

/** ONLY for Builder **/


#pragma once

#include <vector>
#include <windows.h>
#include <oleauto.h>
#include <complex>
#pragma hdrstop

#include "Forevaldll.h"
//#include <complex.h>
//#include <cmath>

using namespace std;


#ifndef TypesForeval_H
#define TypesForeval_H

///**************************************************************************************************************************************



#define EXTENDED_FLOAT   ///  <- x,y,t,...: TFloatType(Extended); z1,z2,z3,...: TComplexE(Extended); z1s,z2s,z3s,...: TSTDComplexE(Extended)
                         ///         vu1,vu2,vu3: TArrayE; STACK&CONST in Foreval : Extended; All variables in functions are Extended **/
                         /// else ... - double;


#define COMPLEX_VAR_ANY_ADDR
/**
  Enable to  define complex var. by setting separately addresses of Re & Im part. flSetVarCx(Name,addrRe,addrIm)
  If alignment address of complex var. is not  a multiple of 16 ,  Im part is lie far from Re ,  address of Im <> address Re+16,
    may occur strong fall of performance.
 **/

//---------------------------------------------------------------------------


/**
#ifdef   EXTENDED_FLOAT
 typedef  Extended  T_FloatType;
  #else
 typedef  double T_FloatType;
#endif // EXTENDED_FLOAT
**/





 /**
typedef   std::vector<double> TArrayD ;
typedef   std::vector<Extended> TArrayE ;
typedef   std::vector<Single> TArrayS ;
typedef   std::vector<int> TArrayI ;
typedef   std::vector<byte> TArrayB ;
typedef   std::vector<Pointer32> TArrayP ;
**/

typedef DynamicArray < Single >    TArrayS;
typedef DynamicArray < double >    TArrayD;
typedef DynamicArray < Extended >  TArrayE;
typedef DynamicArray < Int32 >     TArrayI;
typedef DynamicArray < byte >      TArrayB;
typedef DynamicArray < Pointer32 > TArrayP;




#ifdef   EXTENDED_FLOAT
typedef  TArrayE  TArrayU;
  #else
typedef  TArrayD TArrayU;
#endif

typedef TArrayD*   PArrayD ;
typedef TArrayE*   PArrayE ;
typedef TArrayI*   PArrayI ;
typedef TArrayU*   PArrayU ;


typedef   std::complex<double> TSTDComplexD ;
typedef   std::complex<Extended>  TSTDComplexE ;



#ifdef   EXTENDED_FLOAT
 typedef  TArrayE  TArrayF;
  #else
 typedef  TArrayD  TArrayF;
#endif



//typedef  __float80 Extended;


//#pragma pack( push ,1)


struct TComplexS
			  {
				Single re;
				Single im;
			  } ;

struct TComplexD
			  {
				double re;
				double im;
			  } ;



struct TComplexE
			  {
				Extended re;
				Extended im;
			  } ;


//#pragma pack( pop ,1)






#ifdef   EXTENDED_FLOAT
  typedef  Extended    T_FloatType;
  typedef  TComplexE   TComplex;
  typedef  TSTDComplexE   TComplexSTD;
#else
  typedef  double      T_FloatType;
  typedef  TComplexD   TComplex;
  typedef  TSTDComplexD   TComplexSTD;
#endif // EXTENDED_FLOAT


typedef TComplexD*   PComplexD ;
typedef TComplexE*   PComplexE ;
typedef T_FloatType*  PFloatType ;
typedef TComplex*    PComplex ;



/// *****************************************  GCC Complex Numbers Type ********************

struct   TComplexNum
{
//private:

 public:

  T_FloatType re; //  
  T_FloatType im; //  
  //explicit TComplexNum() {}; //   
  //explicit TComplexNum(long double r, long double i) { re = r, im = i; } // 



  inline friend TComplexNum operator+(const TComplexNum &z1, const TComplexNum &z2)
  {
   TComplexNum rez;
	rez.re=z1.re+z2.re;
	rez.im=z1.im+z2.im;
	return rez;
   //return TComplexNum(z1.re+z2.re,z1.im+z2.im);
  }

  inline friend TComplexNum operator+(const T_FloatType &r1, const TComplexNum &z2)
  {
   TComplexNum rez;
	rez.re=r1+z2.re;
	rez.im=z2.im;
	return rez;
   //return TComplexNum(z1.re+z2.re,z1.im+z2.im);
  }

   inline friend TComplexNum operator+(const TComplexNum &z1, const T_FloatType &r2)
  {
   TComplexNum rez;
	rez.re=z1.re+r2;
	rez.im=z1.im;
	return rez;
   //return TComplexNum(z1.re+z2.re,z1.im+z2.im);
  }

   inline friend TComplexNum operator-(const TComplexNum &z1, const TComplexNum &z2)
  {
	TComplexNum res;
	res.re = z1.re - z2.re;
	res.im = z1.im - z2.im;
	return res ;
  }

   inline friend TComplexNum operator-(const T_FloatType &r1, const TComplexNum &z2)
  {
   TComplexNum rez;
	rez.re=r1-z2.re;
	rez.im=-z2.im;
	return rez;
   //return TComplexNum(z1.re+z2.re,z1.im+z2.im);
  }

   inline friend TComplexNum operator-(const TComplexNum &z1, const T_FloatType &r2)
  {
   TComplexNum rez;
	rez.re=z1.re-r2;
	rez.im=z1.im;
	return rez;
   //return TComplexNum(z1.re+z2.re,z1.im+z2.im);
  }

	inline friend TComplexNum operator-(const TComplexNum &z1)
  {
	TComplexNum res;
	res.re = -z1.re;
	res.im = -z1.im;
	return res ;
  }

  inline friend TComplexNum operator*(const TComplexNum &z1, const TComplexNum &z2)
	{
	TComplexNum res;
	res.re = z1.re * z2.re-z1.im * z2.im;
	res.im = z1.im * z2.re + z1.re * z2.im;
	return res ;
	}

 inline friend TComplexNum operator*(const T_FloatType &r1, const TComplexNum &z2)
	{
	TComplexNum res;
	res.re = r1 * z2.re;
	res.im = r1 * z2.im;
	return res ;
	}

  inline friend TComplexNum operator*(const TComplexNum &z1, const T_FloatType &r2)
	{
	TComplexNum res;
	res.re = r2 * z1.re;
	res.im = r2 * z1.im;
	return res ;
	}


  inline friend TComplexNum operator/(const TComplexNum &z1, const TComplexNum &z2)
	{
	TComplexNum res;
	T_FloatType t;

	t = 1/(z2.re*z2.re+z2.im*z2.im);
	res.re = (z1.re*z2.re+z1.im*z2.im)*t;
	res.im = (z1.im*z2.re-z1.re*z2.im)*t;

	return res ;

	}


	inline friend TComplexNum operator/(const T_FloatType &r1, const TComplexNum &z2)
	{
	TComplexNum res;
	T_FloatType t;

	t = 1/(z2.re*z2.re+z2.im*z2.im);
	res.re = r1*z2.re*t;
	res.im = -r1*z2.im*t;
	return res ;
	}


	inline friend TComplexNum operator/(const TComplexNum &z1, const T_FloatType &r2)
	{
	TComplexNum res;
	T_FloatType t;

	t = 1/r2;
	res.re = z1.re*t;
	res.im = z1.im*t;
	return res ;
	}
};



 T_FloatType Re(  TComplexNum z1)
{
  return z1.re;
};


 T_FloatType Im( TComplexNum z1)
{
  return z1.im;
};


/// ************** WARNING! **********************
/*

 If using proc., with complex  variables  passed  through  addresses, then passed and setted  type of variables  must be appropriate.


 I.e. proc. kind of  proc(TComplex& z1,..., TComplex& zn)  ;

    then complex type in proc. and setted for these variables  by flSet() must be identical!

    For this purpose,  introduced type - TComplexF.
    that ombines the types of variables and transmitted through addresses to procedures in one type.
    Depends from key 'COMPLEX_VAR_ANY_ADDR'

 */

#ifdef   COMPLEX_VAR_ANY_ADDR
 typedef  TComplexNum  TComplexF;
  #else
 typedef  TComplex  TComplexF;
#endif

typedef  TComplexF*   PComplexF;

#endif




