
#pragma once
#include "Forevaldll.h"
#include <vector>

#include <windows.h>
#include <oleauto.h>
#include <complex>
//#include <complex.h>
//#include <cmath>

using namespace std;


///**************************************************************************************************************************************


// for  MSVC - only Double:
//#define EXTENDED_FLOAT   ///  <- x,y,t,...: TFloatType(Extended); z1,z2,z3,...: TComplexE(Extended); z1s,z2s,z3s,...: TSTDComplexE(Extended)
                         ///         vu1,vu2,vu3: TArrayE; STACK&CONST in Foreval : Extended; All variables in functions are Extended **/
                         /// else ... - double;


#define COMPLEX_VAR_ANY_ADDR
/**
  Enable to  define complex var. by setting separately addresses of Re & Im part. flSetVarCx(Name,addrRe,addrIm)
  If alignment address of complex var. is not  a multiple of 16 ,  Im part is lie far from Re ,  address of Im <> address Re+16,
    may occur strong fall of performance.
 **/

//---------------------------------------------------------------------------


 typedef  double TFloatType;






typedef   std::vector<double> TArrayD ;
//typedef   std::vector<Extended> TArrayE ;
typedef   std::vector<double> TArrayE ; //change for MSVC
typedef   std::vector<Single> TArrayS ;
typedef   std::vector<int> TArrayI ;
typedef   std::vector<BYTE> TArrayB ;
typedef   std::vector<Pointer32> TArrayP ;
typedef   std::complex<double>  TSTDComplexD ;
//typedef   std::complex<Extended>  TSTDComplexE ;


 typedef  TArrayD  TArrayF;




//typedef  __float80 Extended;

#pragma pack( push ,1)


struct TComplexS
			  {
				Single re;
				Single im;
			  } ;

struct TComplexD
			  {
				double re;
				double im;
			  } ;




#pragma pack( pop ,1)




  typedef  double      TFloatType;
  typedef  TComplexD   TComplex;
  typedef  TSTDComplexD   TComplexSTD;



typedef TComplexD*   PComplexD ;
//typedef TComplexE*   PComplexE ;
typedef TFloatType*  PFloatType ;
typedef TComplex*    PComplex ;



/// *****************************************  GCC Complex Numbers Type ********************

struct   TComplexNum
{
//private:

 public:

  TFloatType re; //  
  TFloatType im; //  
  //explicit TComplexNum() {}; //   
  //explicit TComplexNum(long double r, long double i) { re = r, im = i; } // 



  inline friend TComplexNum operator+(const TComplexNum &z1, const TComplexNum &z2)
  {
   TComplexNum rez;
	rez.re=z1.re+z2.re;
	rez.im=z1.im+z2.im;
	return rez;
   //return TComplexNum(z1.re+z2.re,z1.im+z2.im);
  }

  inline friend TComplexNum operator+(const TFloatType &r1, const TComplexNum &z2)
  {
   TComplexNum rez;
	rez.re=r1+z2.re;
	rez.im=z2.im;
	return rez;
   //return TComplexNum(z1.re+z2.re,z1.im+z2.im);
  }

   inline friend TComplexNum operator+(const TComplexNum &z1, const TFloatType &r2)
  {
   TComplexNum rez;
	rez.re=z1.re+r2;
	rez.im=z1.im;
	return rez;
   //return TComplexNum(z1.re+z2.re,z1.im+z2.im);
  }

   inline friend TComplexNum operator-(const TComplexNum &z1, const TComplexNum &z2)
  {
	TComplexNum res;
	res.re = z1.re - z2.re;
	res.im = z1.im - z2.im;
	return res ;
  }

   inline friend TComplexNum operator-(const TFloatType &r1, const TComplexNum &z2)
  {
   TComplexNum rez;
	rez.re=r1-z2.re;
	rez.im=-z2.im;
	return rez;
   //return TComplexNum(z1.re+z2.re,z1.im+z2.im);
  }

   inline friend TComplexNum operator-(const TComplexNum &z1, const TFloatType &r2)
  {
   TComplexNum rez;
	rez.re=z1.re-r2;
	rez.im=z1.im;
	return rez;
   //return TComplexNum(z1.re+z2.re,z1.im+z2.im);
  }

	inline friend TComplexNum operator-(const TComplexNum &z1)
  {
	TComplexNum res;
	res.re = -z1.re;
	res.im = -z1.im;
	return res ;
  }

  inline friend TComplexNum operator*(const TComplexNum &z1, const TComplexNum &z2)
	{
	TComplexNum res;
	res.re = z1.re * z2.re-z1.im * z2.im;
	res.im = z1.im * z2.re + z1.re * z2.im;
	return res ;
	}

 inline friend TComplexNum operator*(const TFloatType &r1, const TComplexNum &z2)
	{
	TComplexNum res;
	res.re = r1 * z2.re;
	res.im = r1 * z2.im;
	return res ;
	}

  inline friend TComplexNum operator*(const TComplexNum &z1, const TFloatType &r2)
	{
	TComplexNum res;
	res.re = r2 * z1.re;
	res.im = r2 * z1.im;
	return res ;
	}


  inline friend TComplexNum operator/(const TComplexNum &z1, const TComplexNum &z2)
	{
	TComplexNum res;
	TFloatType t;

	t = 1/(z2.re*z2.re+z2.im*z2.im);
	res.re = (z1.re*z2.re+z1.im*z2.im)*t;
	res.im = (z1.im*z2.re-z1.re*z2.im)*t;

	return res ;

	}


	inline friend TComplexNum operator/(const TFloatType &r1, const TComplexNum &z2)
	{
	TComplexNum res;
	TFloatType t;

	t = 1/(z2.re*z2.re+z2.im*z2.im);
	res.re = r1*z2.re*t;
	res.im = -r1*z2.im*t;
	return res ;
	}


	inline friend TComplexNum operator/(const TComplexNum &z1, const TFloatType &r2)
	{
	TComplexNum res;
	TFloatType t;

	t = 1/r2;
	res.re = z1.re*t;
	res.im = z1.im*t;
	return res ;
	}
};



 TFloatType Re(  TComplexNum z1)
{
  return z1.re;
};


 TFloatType Im( TComplexNum z1)
{
  return z1.im;
};


/// ************** WARNING! **********************
/*

 If using proc., with complex  variables  passed  through  addresses, then passed and setted  type of variables  must be appropriate.


 I.e. proc. kind of  proc(TComplex& z1,..., TComplex& zn)  ;

    then complex type in proc. and setted for these variables  by flSet() must be identical!

    For this purpose,  introduced type - TComplexF.
    that ombines the types of variables and transmitted through addresses to procedures in one type.
    Depends from key 'COMPLEX_VAR_ANY_ADDR'

 */

#ifdef   COMPLEX_VAR_ANY_ADDR
 typedef  TComplexNum  TComplexF;
  #else
 typedef  TComplex  TComplexF;
#endif

typedef  TComplexF*   PComplexF;






