#pragma once

/*
                                           WARNING !!!
										   

                              

        Use only 32bit compiler.
        Foreval does not support multitasking: compiled expression can not be executed simultaneously in multiple threads;
        for each thread needs its own compilation of expression, it also applies to functions such fl_Precompiled (not  thread-safe).


>  All variables and function transfered to Foreaval.dll must be placing in region of "unmanaged code" !!! 
>  Calling calculation functions from .dll work very slowly !!! . Use analogous from Forevaldll.h (without prefix 'fl') 



>  When connecting to MSVC(CLR) , errors are not intercepted when calculating constants while compiling an expression in internal blocks
  "try except" (Foreval.dll) - the cause is unknown. Also, floating-point errors are not catching during the calculation.
   Possible workarounds: see proc. Button1_Click, BSafeCalc_Click

*/

 /*              In Windows10x64 work only with this setting (reason - unknown):
	                flSet(fl_ENABLE,fl_USE_VIRTUAL_ALLOC,0);
          
*/


/*
>  Calculations goes with masking of interruptions.
   It is a slow method. Besides, if in expression there is incorrectly written function,  
   in which there is a reset of FPU masks and/or flags of exceptions, interception of an error will not work.
   It is better to use catch of errors  through  interrupts in the design:

   try
    {
     flResult(Func,resf)
    }
   catch(...)
    {
    //error
    };

  ,if you are able to force it to work! :(
*/


#include "Forevaldll.h"
#include "ExtFunc.h"
#include <vector>
#include <string>
//#include <system>
//#include <vcclr.h>


//#define TESTFASTDYNARRAY  // <- test dynamic array, see: Form1_Load (FDynArray) , Button1_Click

//#define StableTEST   // <- stable test (number of expressions = counts*9)


#pragma unmanaged

 struct TFunc2
		   {
				//TStringType    Expr;
				Pointer32      Addr;
				double  res;
				double  x;
				double  y;

		  };

 struct TFunc3
		   {
				//TStringType    Expr;
				Pointer32      Addr;
				double  res;
				double  x;
				double  y;
				double  z;

		  };

struct TFuncInt3
	  {
	  Pointer32 FAddr;
	  double  x    ;
	  double  y     ;
	  double  z     ;
	  double  a     ;
	  double  b     ;
	  Pointer32 F1Addr;
	  Pointer32 F2Addr ;
	  Pointer32 F3Addr ;
	  Pointer32 F4Addr ;
	  };

struct TFuncInt3Ext
	  {
	  Pointer32 FAddr;
	  Pointer32 adrX;
	  Pointer32 adrY;
	  Pointer32 adrZ;
	  double  a     ;
	  double  b     ;
	  Pointer32 F1Addr;
	  Pointer32 F2Addr;
	  Pointer32 F3Addr;
	  Pointer32 F4Addr;
	  };

//TComplexNum z1,z2,z3,i;
 
double x,y,t,A,B,C,D,resf;


double xd,yd,td;
Pointer32 adrXVD,adrXVE,adrXVI,adrXAD,adr1,adrVECD,adrVD,FDynArray,adrXSPL,adrYSPL, adrVDX, adrVDY, adrVF;

_int32 n,k,j,m,l;
PDouble  px,py;
PInteger pi1;

 typedef   std::vector<double> TArrayD ;
 typedef   std::vector<int> TArrayI ;
 typedef   std::vector<byte> TArrayB ;
 typedef   std::vector<Pointer32> TArrayP ;

 TArrayD  vd,ve,vf,vecd,xspl,yspl;
 TArrayI  vi;

 TFunc3  fnc1,fnc2,fnc3;
 double  an[16],bn[16];
 _int32  P_Integral,N_Integral;
 TFuncInt3     FInt3;
 TFuncInt3Ext  FInt3Ext;
 TAttrib FAtr;
 /*
 std::vector<double> vd; 
 std::vector<double> ve; 
 std::vector<int> vi; 
 std::vector<double> vecd; 
 */

#pragma managed	


 int GLT;
//TFormatSettings  G_FMT;

//TArrayD vd,ad;
//TArrayI vi;
//TFunc4 fnc1,fnc2;
 
 

 typedef   System::String^* PString; 


namespace TestForeval {
	
	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	
	/// <summary>
	///   Form1
	///
	/// !        
	///              ("Resource File Name")     ,
	///                .resx,     .   ,
	///                
	///          ,   .
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(void)
		{
			InitializeComponent();
			//
			//TODO:   
			//
		}
       
	   
	protected:
		/// <summary>
		///    .
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}
	private: System::Windows::Forms::Button^  Button1;
	private: System::Windows::Forms::Label^  LR;
	private: System::Windows::Forms::Label^  label1;
	private: System::Windows::Forms::TextBox^  EF;
	private: System::Windows::Forms::Label^  label2;
	private: System::Windows::Forms::Label^  LPf;

	private: System::Windows::Forms::TextBox^  ENC;
	private: System::Windows::Forms::CheckBox^  CB_OM;
	private: System::Windows::Forms::CheckBox^  CB_DS;

	private: System::Windows::Forms::TextBox^  E_EF;
	private: System::Windows::Forms::Button^  button2;
	private: System::Windows::Forms::TextBox^  E_t;


	private: System::Windows::Forms::TextBox^  E_j;


	private: System::Windows::Forms::TextBox^  E_x;
	private: System::Windows::Forms::TextBox^  E_y;
	private: System::Windows::Forms::TextBox^  E_n;
	private: System::Windows::Forms::TextBox^  E_k;








	private: System::Windows::Forms::Label^  label3;

	private: System::Windows::Forms::Label^  label5;

	private: System::Windows::Forms::Label^  label7;
	private: System::Windows::Forms::Label^  label8;
	private: System::Windows::Forms::Label^  label9;
	private: System::Windows::Forms::Label^  label10;
	private: System::Windows::Forms::TextBox^  E_ad0;
	private: System::Windows::Forms::TextBox^  E_ad1;
	private: System::Windows::Forms::TextBox^  E_ad2;
	private: System::Windows::Forms::Label^  label11;
	private: System::Windows::Forms::Label^  label12;
	private: System::Windows::Forms::Label^  label13;
	private: System::Windows::Forms::Button^  button3;
	private: System::Windows::Forms::Label^  label14;
	private: System::Windows::Forms::Label^  label15;
	private: System::Windows::Forms::Label^  label16;
	private: System::Windows::Forms::Label^  LDR;
	private: System::Windows::Forms::Label^  LDPf;
	private: System::Windows::Forms::GroupBox^  groupBox1;
	private: System::Windows::Forms::RadioButton^  radioButton2;
	private: System::Windows::Forms::RadioButton^  radioButton1;
	private: System::Windows::Forms::GroupBox^  groupBox2;
	private: System::Windows::Forms::RadioButton^  radioButton4;
	private: System::Windows::Forms::RadioButton^  radioButton3;
	private: System::Windows::Forms::Label^  label17;
	private: System::Windows::Forms::TextBox^  E_dx;
	private: System::Windows::Forms::Button^  BSafeCalc;
	private: System::Windows::Forms::CheckBox^  cb_FPUMask;
	private: System::Windows::Forms::CheckBox^  cb_VirtAlloc;
	private: System::Windows::Forms::Label^  label4;






	protected: 

	protected: 

	private:
		/// <summary>
		///   .
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		///      -  
		///       .
		/// </summary>
		void InitializeComponent(void)
		{
			this->Button1 = (gcnew System::Windows::Forms::Button());
			this->LR = (gcnew System::Windows::Forms::Label());
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->EF = (gcnew System::Windows::Forms::TextBox());
			this->label2 = (gcnew System::Windows::Forms::Label());
			this->LPf = (gcnew System::Windows::Forms::Label());
			this->ENC = (gcnew System::Windows::Forms::TextBox());
			this->CB_OM = (gcnew System::Windows::Forms::CheckBox());
			this->CB_DS = (gcnew System::Windows::Forms::CheckBox());
			this->E_EF = (gcnew System::Windows::Forms::TextBox());
			this->button2 = (gcnew System::Windows::Forms::Button());
			this->E_t = (gcnew System::Windows::Forms::TextBox());
			this->E_j = (gcnew System::Windows::Forms::TextBox());
			this->E_x = (gcnew System::Windows::Forms::TextBox());
			this->E_y = (gcnew System::Windows::Forms::TextBox());
			this->E_n = (gcnew System::Windows::Forms::TextBox());
			this->E_k = (gcnew System::Windows::Forms::TextBox());
			this->label3 = (gcnew System::Windows::Forms::Label());
			this->label5 = (gcnew System::Windows::Forms::Label());
			this->label7 = (gcnew System::Windows::Forms::Label());
			this->label8 = (gcnew System::Windows::Forms::Label());
			this->label9 = (gcnew System::Windows::Forms::Label());
			this->label10 = (gcnew System::Windows::Forms::Label());
			this->E_ad0 = (gcnew System::Windows::Forms::TextBox());
			this->E_ad1 = (gcnew System::Windows::Forms::TextBox());
			this->E_ad2 = (gcnew System::Windows::Forms::TextBox());
			this->label11 = (gcnew System::Windows::Forms::Label());
			this->label12 = (gcnew System::Windows::Forms::Label());
			this->label13 = (gcnew System::Windows::Forms::Label());
			this->button3 = (gcnew System::Windows::Forms::Button());
			this->label14 = (gcnew System::Windows::Forms::Label());
			this->label15 = (gcnew System::Windows::Forms::Label());
			this->label16 = (gcnew System::Windows::Forms::Label());
			this->LDR = (gcnew System::Windows::Forms::Label());
			this->LDPf = (gcnew System::Windows::Forms::Label());
			this->groupBox1 = (gcnew System::Windows::Forms::GroupBox());
			this->radioButton2 = (gcnew System::Windows::Forms::RadioButton());
			this->radioButton1 = (gcnew System::Windows::Forms::RadioButton());
			this->groupBox2 = (gcnew System::Windows::Forms::GroupBox());
			this->radioButton4 = (gcnew System::Windows::Forms::RadioButton());
			this->radioButton3 = (gcnew System::Windows::Forms::RadioButton());
			this->label17 = (gcnew System::Windows::Forms::Label());
			this->E_dx = (gcnew System::Windows::Forms::TextBox());
			this->BSafeCalc = (gcnew System::Windows::Forms::Button());
			this->cb_FPUMask = (gcnew System::Windows::Forms::CheckBox());
			this->cb_VirtAlloc = (gcnew System::Windows::Forms::CheckBox());
			this->label4 = (gcnew System::Windows::Forms::Label());
			this->groupBox1->SuspendLayout();
			this->groupBox2->SuspendLayout();
			this->SuspendLayout();
			// 
			// Button1
			// 
			this->Button1->Location = System::Drawing::Point(105, 97);
			this->Button1->Name = L"Button1";
			this->Button1->Size = System::Drawing::Size(75, 23);
			this->Button1->TabIndex = 0;
			this->Button1->Text = L"Calc";
			this->Button1->UseVisualStyleBackColor = true;
			this->Button1->Click += gcnew System::EventHandler(this, &Form1::Button1_Click);
			// 
			// LR
			// 
			this->LR->AutoSize = true;
			this->LR->Location = System::Drawing::Point(102, 160);
			this->LR->Name = L"LR";
			this->LR->Size = System::Drawing::Size(148, 13);
			this->LR->TabIndex = 1;
			this->LR->Text = L"                                               ";
			this->LR->Click += gcnew System::EventHandler(this, &Form1::LR_Click);
			// 
			// label1
			// 
			this->label1->AutoSize = true;
			this->label1->Location = System::Drawing::Point(31, 160);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(40, 13);
			this->label1->TabIndex = 2;
			this->label1->Text = L"Result:";
			// 
			// EF
			// 
			this->EF->Location = System::Drawing::Point(9, 243);
			this->EF->Name = L"EF";
			this->EF->Size = System::Drawing::Size(598, 20);
			this->EF->TabIndex = 3;
			this->EF->Text = L"(sin(x/cos(2*t*x-1))^3-cos(y*sin(2*t*x-1))^3)/(sin(y*sin(2*t*x-1))^3+cos(x/cos(2*" 
				L"t*x-1))^3)+exp(x/exp(x))*(sh(x)+ch(x/exp(x))+th(x/exp(x)))+polynom(ad,y/x)*sum(a" 
				L"d)*sum(ad[n],2,x,sum(x,y))";
			this->EF->TextChanged += gcnew System::EventHandler(this, &Form1::textBox1_TextChanged);
			// 
			// label2
			// 
			this->label2->AutoSize = true;
			this->label2->Location = System::Drawing::Point(6, 207);
			this->label2->Name = L"label2";
			this->label2->Size = System::Drawing::Size(73, 13);
			this->label2->TabIndex = 4;
			this->label2->Text = L"Perf(eval/ms):";
			// 
			// LPf
			// 
			this->LPf->AutoSize = true;
			this->LPf->Location = System::Drawing::Point(98, 207);
			this->LPf->Name = L"LPf";
			this->LPf->Size = System::Drawing::Size(154, 13);
			this->LPf->TabIndex = 5;
			this->LPf->Text = L"                                                 ";
			// 
			// ENC
			// 
			this->ENC->Location = System::Drawing::Point(51, 12);
			this->ENC->Name = L"ENC";
			this->ENC->Size = System::Drawing::Size(74, 20);
			this->ENC->TabIndex = 6;
			this->ENC->Text = L"10000000";
			// 
			// CB_OM
			// 
			this->CB_OM->AutoSize = true;
			this->CB_OM->Location = System::Drawing::Point(131, 15);
			this->CB_OM->Name = L"CB_OM";
			this->CB_OM->Size = System::Drawing::Size(73, 17);
			this->CB_OM->TabIndex = 7;
			this->CB_OM->Text = L"One/Multi";
			this->CB_OM->UseVisualStyleBackColor = true;
			// 
			// CB_DS
			// 
			this->CB_DS->AutoSize = true;
			this->CB_DS->Location = System::Drawing::Point(493, 104);
			this->CB_DS->Name = L"CB_DS";
			this->CB_DS->Size = System::Drawing::Size(15, 14);
			this->CB_DS->TabIndex = 8;
			this->CB_DS->UseVisualStyleBackColor = true;
			// 
			// E_EF
			// 
			this->E_EF->Location = System::Drawing::Point(9, 281);
			this->E_EF->Name = L"E_EF";
			this->E_EF->Size = System::Drawing::Size(598, 20);
			this->E_EF->TabIndex = 9;
			this->E_EF->Text = L"fibn(n: int)= s:dbl=0; x1:dbl=0; x2:dbl=1; j:int=2; ifp(n>2,goto(ckl)); s=iff(n=0" 
				L",0,1); goto(end); ckl>> for(j,2,n,s=x1+x2; x1=x2; x2=s); end>> s;";
			// 
			// button2
			// 
			this->button2->Location = System::Drawing::Point(529, 308);
			this->button2->Name = L"button2";
			this->button2->Size = System::Drawing::Size(75, 23);
			this->button2->TabIndex = 10;
			this->button2->Text = L"SetExtFunc";
			this->button2->UseVisualStyleBackColor = true;
			this->button2->Click += gcnew System::EventHandler(this, &Form1::button2_Click);
			// 
			// E_t
			// 
			this->E_t->Location = System::Drawing::Point(24, 373);
			this->E_t->Name = L"E_t";
			this->E_t->Size = System::Drawing::Size(66, 20);
			this->E_t->TabIndex = 11;
			this->E_t->Text = L"-3.789";
			// 
			// E_j
			// 
			this->E_j->Location = System::Drawing::Point(117, 373);
			this->E_j->Name = L"E_j";
			this->E_j->Size = System::Drawing::Size(65, 20);
			this->E_j->TabIndex = 13;
			this->E_j->Text = L"5";
			// 
			// E_x
			// 
			this->E_x->Location = System::Drawing::Point(24, 321);
			this->E_x->Name = L"E_x";
			this->E_x->Size = System::Drawing::Size(66, 20);
			this->E_x->TabIndex = 15;
			this->E_x->Text = L"2.123";
			// 
			// E_y
			// 
			this->E_y->Location = System::Drawing::Point(24, 347);
			this->E_y->Name = L"E_y";
			this->E_y->Size = System::Drawing::Size(66, 20);
			this->E_y->TabIndex = 16;
			this->E_y->Text = L"5.456";
			// 
			// E_n
			// 
			this->E_n->Location = System::Drawing::Point(117, 318);
			this->E_n->Name = L"E_n";
			this->E_n->Size = System::Drawing::Size(65, 20);
			this->E_n->TabIndex = 17;
			this->E_n->Text = L"1";
			// 
			// E_k
			// 
			this->E_k->Location = System::Drawing::Point(117, 344);
			this->E_k->Name = L"E_k";
			this->E_k->Size = System::Drawing::Size(65, 20);
			this->E_k->TabIndex = 18;
			this->E_k->Text = L"2";
			// 
			// label3
			// 
			this->label3->AutoSize = true;
			this->label3->Location = System::Drawing::Point(8, 377);
			this->label3->Name = L"label3";
			this->label3->Size = System::Drawing::Size(13, 13);
			this->label3->TabIndex = 19;
			this->label3->Text = L"t:";
			// 
			// label5
			// 
			this->label5->AutoSize = true;
			this->label5->Location = System::Drawing::Point(98, 377);
			this->label5->Name = L"label5";
			this->label5->Size = System::Drawing::Size(12, 13);
			this->label5->TabIndex = 21;
			this->label5->Text = L"j:";
			// 
			// label7
			// 
			this->label7->AutoSize = true;
			this->label7->Location = System::Drawing::Point(8, 322);
			this->label7->Name = L"label7";
			this->label7->Size = System::Drawing::Size(15, 13);
			this->label7->TabIndex = 23;
			this->label7->Text = L"x:";
			// 
			// label8
			// 
			this->label8->AutoSize = true;
			this->label8->Location = System::Drawing::Point(8, 351);
			this->label8->Name = L"label8";
			this->label8->Size = System::Drawing::Size(15, 13);
			this->label8->TabIndex = 24;
			this->label8->Text = L"y:";
			// 
			// label9
			// 
			this->label9->AutoSize = true;
			this->label9->Location = System::Drawing::Point(98, 321);
			this->label9->Name = L"label9";
			this->label9->Size = System::Drawing::Size(16, 13);
			this->label9->TabIndex = 25;
			this->label9->Text = L"n:";
			// 
			// label10
			// 
			this->label10->AutoSize = true;
			this->label10->Location = System::Drawing::Point(98, 350);
			this->label10->Name = L"label10";
			this->label10->Size = System::Drawing::Size(16, 13);
			this->label10->TabIndex = 26;
			this->label10->Text = L"k:";
			// 
			// E_ad0
			// 
			this->E_ad0->Location = System::Drawing::Point(250, 323);
			this->E_ad0->Name = L"E_ad0";
			this->E_ad0->Size = System::Drawing::Size(65, 20);
			this->E_ad0->TabIndex = 27;
			this->E_ad0->Text = L"3.5";
			// 
			// E_ad1
			// 
			this->E_ad1->Location = System::Drawing::Point(250, 340);
			this->E_ad1->Name = L"E_ad1";
			this->E_ad1->Size = System::Drawing::Size(65, 20);
			this->E_ad1->TabIndex = 28;
			this->E_ad1->Text = L"-1.4";
			// 
			// E_ad2
			// 
			this->E_ad2->Location = System::Drawing::Point(250, 359);
			this->E_ad2->Name = L"E_ad2";
			this->E_ad2->Size = System::Drawing::Size(65, 20);
			this->E_ad2->TabIndex = 29;
			this->E_ad2->Text = L"7.6";
			// 
			// label11
			// 
			this->label11->AutoSize = true;
			this->label11->Location = System::Drawing::Point(213, 326);
			this->label11->Name = L"label11";
			this->label11->Size = System::Drawing::Size(31, 13);
			this->label11->TabIndex = 30;
			this->label11->Text = L"ad[0]";
			// 
			// label12
			// 
			this->label12->AutoSize = true;
			this->label12->Location = System::Drawing::Point(213, 343);
			this->label12->Name = L"label12";
			this->label12->Size = System::Drawing::Size(31, 13);
			this->label12->TabIndex = 31;
			this->label12->Text = L"ad[1]";
			// 
			// label13
			// 
			this->label13->AutoSize = true;
			this->label13->Location = System::Drawing::Point(213, 362);
			this->label13->Name = L"label13";
			this->label13->Size = System::Drawing::Size(31, 13);
			this->label13->TabIndex = 32;
			this->label13->Text = L"ad[2]";
			// 
			// button3
			// 
			this->button3->Location = System::Drawing::Point(398, 98);
			this->button3->Name = L"button3";
			this->button3->Size = System::Drawing::Size(75, 23);
			this->button3->TabIndex = 33;
			this->button3->Text = L"d/dx";
			this->button3->UseVisualStyleBackColor = true;
			this->button3->Click += gcnew System::EventHandler(this, &Form1::button3_Click);
			// 
			// label14
			// 
			this->label14->AutoSize = true;
			this->label14->Location = System::Drawing::Point(44, 304);
			this->label14->Name = L"label14";
			this->label14->Size = System::Drawing::Size(27, 13);
			this->label14->TabIndex = 34;
			this->label14->Text = L"float";
			// 
			// label15
			// 
			this->label15->AutoSize = true;
			this->label15->Location = System::Drawing::Point(132, 302);
			this->label15->Name = L"label15";
			this->label15->Size = System::Drawing::Size(39, 13);
			this->label15->TabIndex = 35;
			this->label15->Text = L"integer";
			// 
			// label16
			// 
			this->label16->AutoSize = true;
			this->label16->Location = System::Drawing::Point(260, 307);
			this->label16->Name = L"label16";
			this->label16->Size = System::Drawing::Size(33, 13);
			this->label16->TabIndex = 36;
			this->label16->Text = L"array:";
			// 
			// LDR
			// 
			this->LDR->AutoSize = true;
			this->LDR->Location = System::Drawing::Point(365, 161);
			this->LDR->Name = L"LDR";
			this->LDR->Size = System::Drawing::Size(169, 13);
			this->LDR->TabIndex = 37;
			this->LDR->Text = L"                                                      ";
			// 
			// LDPf
			// 
			this->LDPf->AutoSize = true;
			this->LDPf->Location = System::Drawing::Point(365, 198);
			this->LDPf->Name = L"LDPf";
			this->LDPf->Size = System::Drawing::Size(196, 13);
			this->LDPf->TabIndex = 38;
			this->LDPf->Text = L"                                                               ";
			// 
			// groupBox1
			// 
			this->groupBox1->Controls->Add(this->radioButton2);
			this->groupBox1->Controls->Add(this->radioButton1);
			this->groupBox1->Location = System::Drawing::Point(386, 12);
			this->groupBox1->Name = L"groupBox1";
			this->groupBox1->Size = System::Drawing::Size(94, 67);
			this->groupBox1->TabIndex = 39;
			this->groupBox1->TabStop = false;
			this->groupBox1->Text = L"StackType";
			// 
			// radioButton2
			// 
			this->radioButton2->AutoSize = true;
			this->radioButton2->Location = System::Drawing::Point(16, 42);
			this->radioButton2->Name = L"radioButton2";
			this->radioButton2->Size = System::Drawing::Size(70, 17);
			this->radioButton2->TabIndex = 1;
			this->radioButton2->Text = L"Extended";
			this->radioButton2->UseVisualStyleBackColor = true;
			this->radioButton2->CheckedChanged += gcnew System::EventHandler(this, &Form1::radioButton2_CheckedChanged);
			// 
			// radioButton1
			// 
			this->radioButton1->AutoSize = true;
			this->radioButton1->Checked = true;
			this->radioButton1->Location = System::Drawing::Point(16, 19);
			this->radioButton1->Name = L"radioButton1";
			this->radioButton1->Size = System::Drawing::Size(59, 17);
			this->radioButton1->TabIndex = 0;
			this->radioButton1->TabStop = true;
			this->radioButton1->Text = L"Double";
			this->radioButton1->UseVisualStyleBackColor = true;
			this->radioButton1->CheckedChanged += gcnew System::EventHandler(this, &Form1::radioButton1_CheckedChanged);
			// 
			// groupBox2
			// 
			this->groupBox2->Controls->Add(this->radioButton4);
			this->groupBox2->Controls->Add(this->radioButton3);
			this->groupBox2->Location = System::Drawing::Point(508, 12);
			this->groupBox2->Name = L"groupBox2";
			this->groupBox2->Size = System::Drawing::Size(98, 67);
			this->groupBox2->TabIndex = 40;
			this->groupBox2->TabStop = false;
			this->groupBox2->Text = L"ParamType";
			// 
			// radioButton4
			// 
			this->radioButton4->AutoSize = true;
			this->radioButton4->Location = System::Drawing::Point(18, 42);
			this->radioButton4->Name = L"radioButton4";
			this->radioButton4->Size = System::Drawing::Size(70, 17);
			this->radioButton4->TabIndex = 1;
			this->radioButton4->Text = L"Extended";
			this->radioButton4->UseVisualStyleBackColor = true;
			this->radioButton4->CheckedChanged += gcnew System::EventHandler(this, &Form1::radioButton4_CheckedChanged);
			// 
			// radioButton3
			// 
			this->radioButton3->AutoSize = true;
			this->radioButton3->Checked = true;
			this->radioButton3->Location = System::Drawing::Point(18, 19);
			this->radioButton3->Name = L"radioButton3";
			this->radioButton3->Size = System::Drawing::Size(59, 17);
			this->radioButton3->TabIndex = 0;
			this->radioButton3->TabStop = true;
			this->radioButton3->Text = L"Double";
			this->radioButton3->UseVisualStyleBackColor = true;
			this->radioButton3->CheckedChanged += gcnew System::EventHandler(this, &Form1::radioButton3_CheckedChanged);
			// 
			// label17
			// 
			this->label17->AutoSize = true;
			this->label17->Location = System::Drawing::Point(3, 15);
			this->label17->Name = L"label17";
			this->label17->Size = System::Drawing::Size(42, 13);
			this->label17->TabIndex = 41;
			this->label17->Text = L"counts:";
			// 
			// E_dx
			// 
			this->E_dx->Location = System::Drawing::Point(425, 127);
			this->E_dx->Name = L"E_dx";
			this->E_dx->Size = System::Drawing::Size(21, 20);
			this->E_dx->TabIndex = 42;
			this->E_dx->Text = L"1";
			// 
			// BSafeCalc
			// 
			this->BSafeCalc->Location = System::Drawing::Point(105, 68);
			this->BSafeCalc->Name = L"BSafeCalc";
			this->BSafeCalc->Size = System::Drawing::Size(75, 23);
			this->BSafeCalc->TabIndex = 43;
			this->BSafeCalc->Text = L"Safe Calc";
			this->BSafeCalc->UseVisualStyleBackColor = true;
			this->BSafeCalc->Click += gcnew System::EventHandler(this, &Form1::BSafeCalc_Click);
			// 
			// cb_FPUMask
			// 
			this->cb_FPUMask->AutoSize = true;
			this->cb_FPUMask->Checked = true;
			this->cb_FPUMask->CheckState = System::Windows::Forms::CheckState::Checked;
			this->cb_FPUMask->Location = System::Drawing::Point(465, 437);
			this->cb_FPUMask->Name = L"cb_FPUMask";
			this->cb_FPUMask->Size = System::Drawing::Size(125, 17);
			this->cb_FPUMask->TabIndex = 44;
			this->cb_FPUMask->Text = L"Mask FPU at parsing";
			this->cb_FPUMask->UseVisualStyleBackColor = true;
			this->cb_FPUMask->Click += gcnew System::EventHandler(this, &Form1::cb_FPUMask_Click);
			// 
			// cb_VirtAlloc
			// 
			this->cb_VirtAlloc->AutoSize = true;
			this->cb_VirtAlloc->Checked = true;
			this->cb_VirtAlloc->CheckState = System::Windows::Forms::CheckState::Checked;
			this->cb_VirtAlloc->Location = System::Drawing::Point(465, 460);
			this->cb_VirtAlloc->Name = L"cb_VirtAlloc";
			this->cb_VirtAlloc->Size = System::Drawing::Size(149, 17);
			this->cb_VirtAlloc->TabIndex = 45;
			this->cb_VirtAlloc->Text = L"Use VirtualAlloc (SysMem)";
			this->cb_VirtAlloc->UseVisualStyleBackColor = true;
			this->cb_VirtAlloc->Click += gcnew System::EventHandler(this, &Form1::cb_VirtAlloc_Click);
			// 
			// label4
			// 
			this->label4->AutoSize = true;
			this->label4->Location = System::Drawing::Point(271, 460);
			this->label4->Name = L"label4";
			this->label4->Size = System::Drawing::Size(188, 13);
			this->label4->TabIndex = 46;
			this->label4->Text = L"in Windows10x64 works only with this:";
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(618, 486);
			this->Controls->Add(this->label4);
			this->Controls->Add(this->cb_VirtAlloc);
			this->Controls->Add(this->cb_FPUMask);
			this->Controls->Add(this->BSafeCalc);
			this->Controls->Add(this->E_dx);
			this->Controls->Add(this->label17);
			this->Controls->Add(this->groupBox2);
			this->Controls->Add(this->groupBox1);
			this->Controls->Add(this->LDPf);
			this->Controls->Add(this->LDR);
			this->Controls->Add(this->label16);
			this->Controls->Add(this->label15);
			this->Controls->Add(this->label14);
			this->Controls->Add(this->button3);
			this->Controls->Add(this->label13);
			this->Controls->Add(this->label12);
			this->Controls->Add(this->label11);
			this->Controls->Add(this->E_ad2);
			this->Controls->Add(this->E_ad1);
			this->Controls->Add(this->E_ad0);
			this->Controls->Add(this->label10);
			this->Controls->Add(this->label9);
			this->Controls->Add(this->label8);
			this->Controls->Add(this->label7);
			this->Controls->Add(this->label5);
			this->Controls->Add(this->label3);
			this->Controls->Add(this->E_k);
			this->Controls->Add(this->E_n);
			this->Controls->Add(this->E_y);
			this->Controls->Add(this->E_x);
			this->Controls->Add(this->E_j);
			this->Controls->Add(this->E_t);
			this->Controls->Add(this->button2);
			this->Controls->Add(this->E_EF);
			this->Controls->Add(this->CB_DS);
			this->Controls->Add(this->CB_OM);
			this->Controls->Add(this->ENC);
			this->Controls->Add(this->LPf);
			this->Controls->Add(this->label2);
			this->Controls->Add(this->EF);
			this->Controls->Add(this->label1);
			this->Controls->Add(this->LR);
			this->Controls->Add(this->Button1);
			this->Name = L"Form1";
			this->Text = L"Form1";
			this->Load += gcnew System::EventHandler(this, &Form1::Form1_Load);
			this->groupBox1->ResumeLayout(false);
			this->groupBox1->PerformLayout();
			this->groupBox2->ResumeLayout(false);
			this->groupBox2->PerformLayout();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion

double trunc(double d){ return (d>0) ? floor(d) : ceil(d) ; }


double  _cdecl sp1(double x1)
{
 return  x1*x1;
};	


double  _stdcall sp2(double x1, double x2)
{
 return  x1-x2;
};


double  _cdecl sp3(double x1, double x2, double x3)
{
 return  x1+x2-x3;
};




double _cdecl sp8(TArrayD &vx, Int32 nx, double x, TArrayD &vd, Int32 nd, double d,  TArrayI &vi, Int32 ni)  
{


return  (vx[nx]*x-vd[nd]*d)*vi[ni];

}


void ConvStr(Pointer32 PS, String^& St1)
{
TStringType S1;
char* pch;

#ifdef    PCHAR


   S1=(TStringType)PS;   
   St1=gcnew String(S1);
  
#endif

#ifdef    SYSTSTR
    

    pch=(char*)PS;   
    St1=gcnew String(pch);

#endif
}




double  _cdecl ps1(double& x1)
{
 //return  (*x1)*(*x1);
	return x1*x1;
}


void  ShowError(void)
{
//String S,S1;
_int32 CError,addr;
//PC: PChar;
//AnsiString Ans;
TStringType ErStr,S1,S2;
String^ St1;
String^ S;
char* pch;
Pointer32 PS;



flGetErrorCode(CError);

switch ( CError )
 {
   case  fl_SPLAIN_DATA_ERROR:                    S="SPLAIN DATA ERROR";break;
   case  fl_NO_DIFF_EXPRESSION:                   S="NO DIFF EXPRESSION";break;
   case  fl_WRONG_NAME:                           S="WRONG NAME";break;
   case  fl_INCORRECT_ARGUMENT:                   S="INCORRECT ARGUMENT";break;
   case  fl_INVALID_OPERATION:                    S="INVALID OPERATION";break;
   case  fl_OVERFLOW:                             S="OVERFLOW";break;
   case  fl_UNDERFLOW:                            S="UNDERFLOW";break;
   case  fl_INT_OVERFLOW:                         S="INTEGER OVERFLOW";break;
   case  fl_ACCESS_VIOLATION:                     S="INTERNAL ERROR or UNCATCHABLE SYNTAX ERROR";break;
   case  fl_OUT_OF_MEMORY:                        S="OUT OF MEMORY";break;
   case  fl_STACK_OVERFLOW:                       S="STACK OVERFLOW";break;
   case  fl_ZERO_DIVIDE:                          S="DIVIDE ON ZERO";break;
   case  fl_UNKNOWN_SYMBOL:                       S ="UNKNOWN SYMBOL or INCORRECT ARGUMENT or WRONG EXPRESSION"; break;
   case  fl_MISSING_ROUND_BRACKET:                S ="MISSING ROUND BRACKET"; break;
   case  fl_MISSING_OPERATION:                    S="MISSING OPERATION";   break;
   case  fl_WRONG_NUMBER_ARGUMENTS:               S="WRONG NUMBER ARGUMENTS";  break;
   case  fl_MISSING_EXPRESSION:                   S="MISSING EXPRESSION";  break;
   case  fl_UNKNOWN_FUNCTION:                     S="UNKNOWN FUNCTION"; break;
   case  fl_ERROR_AT_ADDITION_FUNCTION:           S="ERROR AT ADDITION FUNCTION";   break;
   case  fl_MISSING_ARGUMENT:                     S="MISSING ARGUMENT";  break;
   case  fl_INTERNAL_ERROR:                       S="INTERNAL ERROR or  UNCATCHABLE SYNTAX ERROR"; break;
   case  fl_INCORRECT_TYPE:                       S="WRONG TYPE" ;   break;
   case  fl_MISSING_SQUARE_BRACKET:               S="MISSING SQUARE BRACKET";  break;
   case  fl_MISSING_CURLY_BRACKET:                S="MISSING CURLY BRACKET";  break;
   case  fl_MISSING_ABS_BRACKET:                  S="MISSING ABS BRACKET";  break;
   case  fl_WRONG_EXPRESSION:                     S="WRONG EXPRESSION";  break;
   case  fl_MISSING_SEPARATOR:                    S="MISSING SEPARATOR";   break;
   case  fl_INCORRECT_SPACE:                      S="INCORRECT SPACE";  break;
   case  fl_VARIABLE_REDECLARED:                  S="VARIABLE REDECLARED";  break;
   default:                                       S="UNKNOWN SYNTAX ERROR"; break;


}


   //fzGetSyntaxErrorString)(TStringType& SError);TStringType = char*
   /*
   fzGetSyntaxErrorString(S1);  
   S5=gcnew String(S1);
   MessageBox::Show(S+"\r\n"+S5, "Foreval Error", MessageBoxButtons::OK, MessageBoxIcon::Error);
   */


#ifdef    PCHAR
   //fzGetSyntaxErrorString(Pointer32& SError); TStringType = char*
   flGetErrorString(PS);
   S1=(TStringType)PS;   
   St1=gcnew String(S1);
   //MessageBox::Show(S+"\r\n"+St1, "Foreval Error", MessageBoxButtons::OK, MessageBoxIcon::Error);   
#endif

#ifdef    SYSTSTR
    //fzGetSyntaxErrorString(Pointer32& SError);TStringType = System^
    flGetErrorString(PS);
    pch=(char*)PS;   
    St1=gcnew String(pch);
    //MessageBox::Show(S+"\r\n"+St1, "Foreval Error", MessageBoxButtons::OK, MessageBoxIcon::Error);
#endif

 MessageBox::Show(S+"\r\n"+St1, "Foreval Error", MessageBoxButtons::OK, MessageBoxIcon::Error);

}






void InitIntegral(void)
{
 P_Integral=10;
 N_Integral=15;

 an[1]=0.03075324199611726835; an[2]=0.07036604748810812471;
 an[3]=0.10715922046717193501; an[4]=0.13957067792615431445;
 an[5]=0.16626920581699393355; an[6]=0.18616100001556221103;
 an[7]=0.19843148532711157646; an[8]=0.20257824192556127288;
 an[9]=an[7];  an[10]=an[6];  an[11]=an[5]; an[12]=an[4];
 an[13]=an[3]; an[14]=an[2];  an[15]=an[1];
 bn[1]=0.98799251802048542849; bn[2]=0.93727339240070590431;
 bn[3]=0.84820658341042721620; bn[4]=0.72441773136017004742;
 bn[5]=0.57097217260853884754; bn[6]=0.39415134707756336990;
 bn[7]=0.20119409399743452230; bn[8]=0;
 bn[9]=-bn[7]; bn[10]=-bn[6]; bn[11]=-bn[5]; bn[12]=-bn[4];
 bn[13]=-bn[3];bn[14]=-bn[2]; bn[15]=-bn[1];
};



double  Integral3FF(Pointer32 Func, Pointer32 PV1 , Pointer32 PV2, Pointer32 PV3, double a, double b , Pointer32 Func1, Pointer32 Func2, Pointer32 Func3, Pointer32 Func4)

{
Int32 R, j1, i1, j2, i2, j3, i3, n1, n2, n3;
double int1, int2, int3, HV1, HV2, HV3, h1, h2, h3, x1, x2, c, d, e, f, h;
double ax1, ax2, ax3, sx1, sx2, sx3;



int3 = 0;


n1 = abs(P_Integral);
if (n1 == 0) {n1 = 1;};
n2 = abs(P_Integral);
if (n2 == 0) {n2 = 1;};
n3 = abs(P_Integral);
if (n3 == 0) {n3 = 1;};
h3 = (b - a) / n3 ;


for(j3 = 0; j3 <= n3-1; j3++)
{
 x1 = a + j3 * h3 ;
 x2 = a + (j3 + 1) * h3 ;
 ax3 = (x1 + x2) * 0.5 ;
 sx3 = (x2 - x1) * 0.5 ;

  for(i3 = 1; i3 <= N_Integral; i3++)
  {
   *PDouble(PV1)= sx3 * bn[i3] + ax3 ;


   int2 = 0;
   d = ResultF(Func2);
   c = ResultF(Func1);
   h2 = (d - c) / n2 ;

   for(j2 = 0; j2 <= n2-1; j2++)
   {
	x1 = c + j2 * h2;
	x2 = c + (j2 + 1) * h2;
	ax2 = (x1 + x2) * 0.5 ;
	sx2 = (x2 - x1) * 0.5 ;

	for(i2 = 1; i2 <= N_Integral; i2++)
	{
	 *PDouble(PV2)= sx2 * bn[i2] + ax2 ;

	 int1 = 0;
	 f = ResultF(Func4);
	 e = ResultF(Func3);
	 h1 = (f - e) / n1  ;

	 for(j1 = 0; j1 <= n1-1; j1++)
	 {
	   x1 = e + j1 * h1 ;
	   x2 = e + (j1 + 1) * h1 ;
	   ax1 = (x1 + x2) * 0.5 ;
	   sx1 = (x2 - x1) * 0.5 ;

	   for(i1 = 1; i1 <= N_Integral; i1++)
	   {
		*PDouble(PV3)= sx1 * bn[i1] + ax1 ;

		int1 = int1 + an[i1] * ResultF(Func) * sx1 ;
	   }

	 }

	 int2 = int2 + an[i2] * int1 * sx2 ;

	}
   }

  int3 = int3 + an[i3] * int2 * sx3;
  }
}


return int3 ;

};







	private: System::Void Form1_Load(System::Object^  sender, System::EventArgs^  e) 
{
				 
	  _int32       flLoad,ic,ECode;
	  TStringType  Expr;
	  String       ^Sid,^Sid1,^Sid2,^Sid3,^Sid4,^Expr1,^Expr2,^SRes;
	  Pointer32    Func1,ve0,FS1;
	  double       ax,bx,hx,sx,fx,dx,dy,res;
	  TAddFuncStruct Func;
	  //_int32       VT[10]; 
	  TArrayI      VT;
      TArrayB      Code;
	  _int32       ni, NR, lv, IDF;
	  _int32       ID,ID1,ID2,ID3,ID4,SZ;
	  PInteger     pint1,P_C;
	  PDouble      pdbl1;

      
     //***********************************************************
	  InitIntegral();

     flLoad=flInit();
     if (flLoad != 0)
     {
         flSet(fl_STRING_TYPE, fl_ANSISTRING,0); //example only for ansi,for other string types see Builder's example
         //flSet(fl_STRING_TYPE, fl_WIDESTRING,0);
		 //flSet(fl_STRING_TYPE, fl_STRING_UTF16,0);

	   //flSet(fl_ENABLE, fl_SHOW_EXCEPTION,0);
	   //flSet(fl_ENABLE,fl_CHECK_INCORRECT_SPACE,0);
       //flSet(fl_DISABLE,fl_LEAD_TO_LOWER_CASE,0);

	   flSet(fl_ENABLE,fl_MASK_FPU_EXCEPTION,0);

	 //in Windows10x64 work only with this setting:
	   flSet(fl_ENABLE,fl_USE_VIRTUAL_ALLOC,0);

      

		//for most speed of calculations: (so as in MSVC)
        flSet(fl_PARAM_TYPE,fl_DOUBLE,0);
		flSet(fl_DATA_TYPE,fl_DOUBLE,0);
	
		//on default: Extended - for most exact  of calculations:
	    /*
		flSet(fl_PARAM_TYPE,fl_EXTENDED,0);
		flSet(fl_DATA_TYPE,fl_EXTTENDED,0);
        */
  flGet(fl_COMPILED_BY,0,ID);
  if (ID >= 100 ) {GLT=2;} else {GLT=1;};

  
 
  flSetDiffVar("x");
  A=2.54321;
  B=-3.98765;
  C=4.12345;
  D=-5.6789;

  flSetParam("a",&A,fl_DOUBLE);
  flSetParam("b",&B,fl_DOUBLE);
  flSetParam("c",&C,fl_DOUBLE);
  flSetParam("d",&D,fl_DOUBLE);


  flSetVar("res",&resf,fl_DOUBLE);
  flSetVar("result",&resf,fl_DOUBLE);

  

  flSetVar("x",&x,fl_DOUBLE);
  flSetVar("y",&y,fl_DOUBLE);
  flSetVar("t",&t,fl_DOUBLE);

  flSetVar("n",&n,fl_INTEGER);
  flSetVar("k",&k,fl_INTEGER);
  flSetVar("j",&j,fl_INTEGER);
  flSetVar("m",&m,fl_INTEGER);


  
  n = 1; k = 2; j = 5; m = -3;
 
  x = 2.123; y = 5.456; t = -3.789;

 
  
  /*
  ad.set_length(3);
  ad[0]=3.5; ad[1]=-1.4;  ad[2]=7.6;
*/
  



  /*
  vd=new double[11];
  vd[0]=1.1; vd[1]=2.2; vd[2]=3.3;
  adr1=&vd[0];
  int adr2 = 0;
  px=&vd[0];
  pi1=(PInteger)px; 
  pi1=pi1-1;
  //px=px-4;
  //pi1=(PInteger)px;  
  n=*pi1;
  
  
  LPF->Text= n.ToString();
  */
  //px=px+1;
  //T=*px;
  //LPF->Text= T.ToString();

  //n=(int)(adr2-4);
  //T= (*double)(n);
 /*
  vecd.push_back(1.1);
  vecd.push_back(2.2);
  vecd.push_back(3.3);
  vecd.push_back(4.4);
  vecd.push_back(5.5);
*/
  //vecd[0]=0;

  


  flSetVarIntrnl("ad",fl_ARRAY_DOUBLE,adrXAD);   flSetLength(adrXAD, fl_ARRAY_DOUBLE, 3);
  flSetVarIntrnl("vd",fl_ARRAY_DOUBLE,adrXVD);   flSetLength(adrXVD, fl_ARRAY_DOUBLE, 100);
  flSetVarIntrnl("ve",fl_ARRAY_DOUBLE,adrXVE);   //flSetLength(adrXVE, fl_ARRAY_DOUBLE, 100);
  flSetVarIntrnl("vi",fl_ARRAY_INTEGER,adrXVI);  flSetLength(adrXVI, fl_ARRAY_INTEGER, 100);
   

   vd.resize(100);
   ve.resize(100);
   vi.resize(100);
   vf.resize(101);  //for fast connect: see below

    for (ni = 0; ni <=99; ni++)
	{
       vd[ni]=ni+1;
       ve[ni]=ni+5;

   

      vd[ni]=pow((double)(-1),(Int32)(ni+1))*vd[ni]*0.5;
      ve[ni]=pow((double)(-1),(Int32)(ni+5))*ve[ni]*0.5;
      vi[ni]=trunc(ve[ni]);
	  vf[ni+1]=vd[ni]; 
	
     
	   flSetArrayValueD(adrXVD,ni,vd[ni]);
       flSetArrayValueI(adrXVI,ni,vi[ni]);
	}	   
	 
	//to set "ve" array through copy to memory from ve[]
	//pint1=(PInteger)adrXVE;
	//ve0=(Pointer32)(*pint1);  //= &ve[0]

	
    flSetLength(adrXVE, fl_ARRAY_DOUBLE, ve.size());
	ve0=(Pointer32)(*((PInteger)adrXVE));  //= &ve[0] in Foreval
    CopyMemory(ve0,&ve[0],8*ve.size());

	
 // if data and length of ve is changed, that need reinstall XVE  without recompiling expression , consisting of 've'	 
	/*
	 ve.resize(1000);
	  for (ni = 0; ni <=999; ni++)
	{
		ve[ni]=ni+1.123;
	  }
     
	 flSetLength(adrXVE, fl_ARRAY_DOUBLE, ve.size());
	 ve0=(Pointer32)(*((PInteger)adrXVE)); 
	 CopyMemory(ve0,&ve[0],8*ve.size());
	*/
	
    


//**************   Other way to adding external dynamic array: more fast (without using   flSetArrayValueD or CopyMemory)  ******************************************************************
               
//                 Array in VisualC++ count from '1', in Foreval count from '0'   !!!      
//                 Zero element is using for saving of length, begin array from '1'
//                 Array and pointer to it (adrVECD) must placing in 'unmanaged memory' !!!


  flSetVar("vecd", &adrVECD ,fl_ARRAY_DOUBLE); 
   
   //     compile  of expression for  test "TESTFASTDYNARRAY": see Button1_Click with key:  

  //flCompile("len(vecd)*(sumq(vecd)/sqr(norm(vecd)))",0, FDynArray);  //always = len(vecd)
  flCompile("k:int=0; len:int=len(vecd); s:dbl=0; for(k,0,len-1,s=s+vecd[k]); s/sum(vecd)", 0,FDynArray);  //always = 1

   //vecd.push_back(0);//reserve for length
  //vecd.push_back(0);//begin of array vecd[1]
  vecd.resize(2); //reserve for length (vecd[0]) + begin of array vecd[1] (for creating pointer to array: adrVECD) 
  //vecd.reserve(2);
  adrVECD=&vecd[1];  //to set a  reference to the array.  adrVECD always: placing in 'unmanaged memory' and pointer only to vecd, so, as address of adrVECD using at compilation !!!

  //to write length:
  pint1 = (PInteger)adrVECD;
  pint1=pint1-1;   //= &vecd[1]-4b; or = &vecd[0]+4b;  sizeof(double) = 8
  if (GLT == 1) {SZ = vecd.size()-1;} else {SZ=vecd.size()-2;};  //GLT=1(Delphi); GLT=2(FPC),  in FPC Length=High
  *pint1 = SZ;  //pint1 = &vecd[1]-4b;  *pint1 <- length

//**************************************************************************************************************************************

  flSetVar("vf", &adrVF,fl_ARRAY_DOUBLE); 

  adrVF=&vf[1];  //to set a  reference to the array.  adrVF always: placing in 'unmanaged memory' and pointer only to vf, so, as address of adrVF using at compilation !!!

  //to write length:
  pint1 = (PInteger)adrVF;
  pint1=pint1-1;   //= &vf[1]-4b; or = &vf[0]+4b;  sizeof(double) = 8
  if (GLT == 1) {SZ = vf.size()-1;} else {SZ=vf.size()-2;};  //GLT=1(Delphi); GLT=2(FPC),  in FPC Length=High
  *pint1 = SZ;  //pint1 = &vf[1]-4b;  *pint1 <- length





 /************************  Addition external functions: **********************/

/*
func1(arg1)=arg1^2; func2(arg1,arg2)=arg1-arg2; func3(arg1,arg2,arg3)=arg1+arg2-arg3;

ki1                fl_KERNEL_I
kfi2               fl_KERNEL_FI
kf1, kf2           fl_KERNEL_FF
in1, in2           fl_KERNEL_FF+inline
fp1, fp2, fp3      fl_STACK_FPU        fp3: inline
ma1, ma2, ma3      fl_MEMORY_EAX
ms1, ms2, ms3      fl_MEMORY_STACK_CPU
sp1, sp2, sp3      fl_STACK_CPU
ps1, ps2, ps3      fl_MEMORY_ADDRESSES
pc1, pc2, pc3      fl_PreCompiled

all with diff templates besides pc1,pc2,pc3 - will be diff. numeric (for comparison)


fdif(x)-with derivative
spl1,spl2 -through splain


infs(infsum)       fl_INFINITE_STACK_CPU;


idsin,idcos with ID  fl_STACK_CPU; 

FillArray(TArrayD vd, double x) = vd[all]=x

krsin,krcos,krdiv with diff templates



func8(TArrayE vx, Int32 nx, Extended x, TArrayD vd, Int32 nd, double d,  TArrayI vi, Int32 ni) = (vx[nx]*x-vd[nd]*d)*vi[ni]

 sp8      fl_STACK_CPU
 ps8      fl_MEMORY_ADDRESSES
 ms8      fl_MEMORY_STACK_CPU
 pc8      fl_PreCompiled


********************************************************************************/


  //SPLAIN:

  

//                        spl1(x) = (sin(3*x)-cos(2*x))*exp(-x/10);    -15<=x<=15

//using internal arrays:

hx=0.1;      //<=1!!!
ax=-15.0; bx=15.0; sx=ax;
lv=trunc(abs(bx-ax)/hx)+1;
flSetVarIntrnl("svdx",fl_ARRAY_DOUBLE,adrVDX);
flSetVarIntrnl("svdy",fl_ARRAY_DOUBLE,adrVDY);
flSetLength(adrVDX,fl_ARRAY_DOUBLE,lv);
flSetLength(adrVDY,fl_ARRAY_DOUBLE,lv);


for(ic=0;ic <= lv-1; ic++)
{
  flSetArrayValueD(adrVDX,ic,sx);
  fx=(sin(3*sx)-cos(2*sx))*exp(-sx/10);
  flSetArrayValueD(adrVDY,ic,fx);
  sx=sx+hx;
};



flSetSplainFunction("spl1",adrVDX,adrVDY,fl_ARRAY_DOUBLE,IDF);
//flGetErrorCode(ECode); if (ECode != 0){ShowError();}





//                         spl2(x) = x*(sin(x)+cos(x));          -10<=x<=10

//using external arrays with fast connection: arrays (xspl,yspl) must placing in 'unmanaged memory' !!!
 

hx=0.1;      //<=1!!!
ax=-10; bx=10; sx=ax;
lv=trunc(abs(bx-ax)/hx)+1;
xspl.resize(lv+2);  //+1: in "0" - length
yspl.resize(lv+2);  //+1: in "0" - length



for (ic = 1; ic <= xspl.size()-1; ic++)
{
  xspl[ic]=sx;
  yspl[ic]=sx*(sin(sx)+cos(sx));
  sx=sx+hx;
}

adrXSPL=&xspl[1];  //to set a  reference to the array.  adrXSPL  always: placing in 'unmanaged memory' 
adrYSPL=&yspl[1];  //to set a  reference to the array.  adrYSPL  always: placing in 'unmanaged memory' 

  //to write length:
  pint1 = (PInteger)adrXSPL;
  pint1=pint1-1; // = &xspl[1]-4b; or = &xspl[0]+4b;  sizeof(double) = 8
  if (GLT == 1) {SZ = xspl.size()-1;} else {SZ=xspl.size()-2;};  //GLT=1(Delphi); GLT=2(FPC),  in FPC Length=High
  *pint1 = SZ;  //pint1 = &xspl[1]-4b;  *pint1 <- length

  pint1 = (PInteger)adrYSPL;
  pint1=pint1-1; // = &yspl[1]-4b; or = &yspl[0]+4b;  sizeof(double) = 8
  if (GLT == 1) {SZ = yspl.size()-1;} else {SZ=yspl.size()-2;};  //GLT=1(Delphi); GLT=2(FPC),  in FPC Length=High
  *pint1 = SZ;  //pint1 = &yspl[1]-4b;  *pint1 <- length

flSetSplainFunction("spl2",&adrXSPL,&adrYSPL,fl_ARRAY_DOUBLE,IDF);
flGetErrorCode(ECode); if (ECode != 0){ShowError();}






//kernel:
InitFuncStruct(Func);                      //ki1(i:integer)=i*i;
Func.addr=&KI1;
Func.CallType=fl_KERNEL_I;
Func.DeepFPU=1;
flSetFunction("ki1",&Func,ID);

InitFuncStruct(Func);                     //kf1(x: float)=x^2;
Func.addr=&KF1;
Func.CallType=fl_KERNEL_F;
Func.DeepFPU=0;
flSetFunction("KF1",&Func,ID);

InitFuncStruct(Func);                      //kf2(x,y:float)=x-y
Func.addr=&KF2;
Func.CallType=fl_KERNEL_FF;
Func.DeepFPU=0;
flSetFunction("KF2",&Func,ID);

InitFuncStruct(Func);                     //kfi2(x:float; i:integer)=x-i
Func.addr=&KFI2;
Func.CallType=fl_KERNEL_FI;
Func.DeepFPU=0;
flSetFunction("kfi2",&Func,ID);
//kf1(x-kf2(y,kf1(x-y-kf2(x*y,y-kf1(t*y)))))
//kf1(x)*kf2(x,y)*ki1(n+j)*kfi2(kf1(x)*kf2(x,y)*ki1(n+j),kf1(y)*kf2(t,y)*ki1(n-j))

//kernel+inline
InitFuncStruct(Func);                            //finl(x1,x2) = (x1-x2)*t;
Code.resize(8);
Code[0]=0xDE; Code[1]=0xE1;                    //fsubrp
Code[2]=0xDC; Code[3]=0x0D;                    //fmul qword ptr
P_C=(PInteger)&Code[4]; *P_C=(_int32)(&td);   //addr(t)
Func.CallType=fl_KERNEL_FF;
Func.DeepFPU=0;
Func.SizeCode=8;
Func.CodeInline=&Code[0];
flSetFunction("finl",&Func,ID);

InitFuncStruct(Func);                            //IN1(x) = x^2;
Func.SizeCode=2;
Code.resize(Func.SizeCode);
Code[0]=0xD8; Code[1]=0xC8;                     //fmul st(0),st(0)
Func.CallType=fl_KERNEL_F;
Func.DeepFPU=0;
Func.CodeInline=&Code[0];
flSetFunction("in1",&Func,ID);


InitFuncStruct(Func);                            //IN2(x1,x2) = x1-x2;
Func.SizeCode=2;
Code.resize(Func.SizeCode);
Code[0]=0xDE; Code[1]=0xE1;                    //fsubrp
Func.CallType=fl_KERNEL_FF;
Func.DeepFPU=0;
Func.CodeInline=&Code[0];
flSetFunction("in2",&Func,ID);
//in1(x-in2(y,in1(x-y-in2(x*y,y-in1(t*y)))))



//fl_Stack_FPU
InitFuncStruct(Func);                            //fp1(x)=x^2
Func.addr=&FP1;
Func.Arg=1;
Func.ArgType=fl_DOUBLE;
Func.CallType=fl_STACK_FPU;
Func.DeepFPU=0;
flSetFunction("FP1",&Func,ID);
flSetDiffTemplate(ID,"2*$arg1*$dfarg1");

InitFuncStruct(Func);                            //fp2(x,y)=x-y
Func.addr=&FP2;
Func.Arg=2;
Func.ArgType=fl_DOUBLE;
Func.CallType=fl_STACK_FPU;
Func.DeepFPU=0;
flSetFunction("FP2",&Func,ID);
flSetDiffTemplate(ID,"$dfarg1-$dfarg2");


InitFuncStruct(Func);                            //fp3(x1,x2,x3)=x1+x2-x3
//Func.addr=&FP3;
Func.Arg=3;
Func.ArgType=fl_DOUBLE;
Func.CallType=fl_STACK_FPU;
Func.DeepFPU=0;
Func.SizeCode=4;
Code.resize(Func.SizeCode);
Code[0]=0xDE; Code[1]=0xE9;                    //fsubp
Code[2]=0xDE; Code[3]=0xC1;                    //faddp 
Func.CodeInline=&Code[0];
Func.SaveReg=0;
flSetFunction("FP3",&Func,ID);
flSetDiffTemplate(ID,"$dfarg1+$dfarg2-$dfarg3");
//fp1(x-fp2(y,fp1(x-y-fp2(x*y,y-fp1(t*y)))))
//fp3(fp3(x,y,fp1(t))*fp2(t*fp1(x),t),fp2(fp1(y),-fp3(y,fp2(x,t),fp1(x*fp1(t)))),-fp2(fp3(-y,t,x-fp2(t,y)),fp3(t,y*fp1(fp2(t,-y)),-fp2(y,x))))


//fl_Memory_
InitFuncStruct(Func);                         //MA1(x1double)=x1^2
Func.addr=&MA1;
Func.Arg=1;
Func.ArgType=fl_DOUBLE;
Func.CallType=fl_MEMORY_EAX;
Func.DeepFPU=1;
flSetFunction("MA1",&Func,ID);
flSetDiffTemplate(ID,"2*$arg1*$dfarg1");

InitFuncStruct(Func);
Func.addr=&MA2;
Func.Arg=2;
Func.ArgType=fl_DOUBLE;
Func.CallType=fl_MEMORY_EAX;
Func.DeepFPU=1;
flSetFunction("MA2",&Func,ID);               //MA2(x1,x2double)=x1-x2
flSetDiffTemplate(ID,"$dfarg1-$dfarg2");

InitFuncStruct(Func);
Func.addr=&MA3;
Func.Arg=3;
Func.ArgType=fl_DOUBLE;
Func.CallType=fl_MEMORY_EAX;
Func.DeepFPU=1;
flSetFunction("MA3",&Func,ID);               //MA3(x1,x2,x3double)=x1+x2-x3
flSetDiffTemplate(ID,"$dfarg1+$dfarg2-$dfarg3");
//ma3(ma3(x,y,ma1(t))*ma2(t*ma1(x),t),ma2(ma1(y),-ma3(y,ma2(x,t),ma1(x*ma1(t)))),-ma2(ma3(-y,t,x-ma2(t,y)),ma3(t,y*ma1(ma2(t,-y)),-ma2(y,x))))





InitFuncStruct(Func);
Func.addr=&SP1;
Func.Arg=1;
Func.ArgType=fl_DOUBLE;
Func.CallType=fl_STACK_CPU;
Func.DeepFPU=1;
Func.ClearStack=fl_ENABLE;     //cdecl
Func.Arrow=fl_RIGHT;           //cdecl
flSetFunction("sp1",&Func,ID);
flSetDiffTemplate(ID,"2*$arg1*$dfarg1");

InitFuncStruct(Func);
Func.addr=&SP2;
Func.Arg=2;
Func.ArgType=fl_DOUBLE;
Func.CallType=fl_STACK_CPU;
Func.DeepFPU=1;
Func.ClearStack=fl_DISABLE;     //stdcall
Func.Arrow=fl_RIGHT;            //stdcall
flSetFunction("sp2",&Func,ID);
flSetDiffTemplate(ID,"$dfarg1-$dfarg2");

InitFuncStruct(Func);
Func.addr=&SP3;
Func.Arg=3;
Func.ArgType=fl_DOUBLE;
Func.CallType=fl_STACK_CPU;
Func.DeepFPU=1;
Func.ClearStack=fl_ENABLE;     //cdecl
Func.Arrow=fl_RIGHT;           //cdecl
flSetFunction("sp3",&Func,ID);
flSetDiffTemplate(ID,"$dfarg1+$dfarg2-$dfarg3");
//sp3(sp3(x,y,sp1(t))*sp2(t*sp1(x),t),sp2(sp1(y),-sp3(y,sp2(x,t),sp1(x*sp1(t)))),-sp2(sp3(-y,t,x-sp2(t,y)),sp3(t,y*sp1(sp2(t,-y)),-sp2(y,x))))
//x*sp3(x*sp3(x,y,x/sp1(t*x))*sp2(x*sp1(x),t),x/sp2(sp1(y),-x/sp3(y,x*sp2(x,t),sp1(x*sp1(t)))),-sp2(-x*sp3(-y,t,x-x/sp2(t,y/x)),x*sp3(t,y*sp1(-x/sp2(t,-y-x/sp1(x*y))),-sp2(y/(x+t),x))))


InitFuncStruct(Func);
Func.addr=&MS1;
Func.Arg=1;
Func.ArgType=fl_DOUBLE;
Func.CallType=fl_MEMORY_STACK_CPU;
Func.DeepFPU=1;
Func.ClearStack=fl_ENABLE;     //cdecl
Func.Arrow=fl_RIGHT;           //cdecl
flSetFunction("MS1",&Func,ID);                     //MS1(x1double)=x1^2
flSetDiffTemplate(ID,"2*$arg1*$dfarg1");


InitFuncStruct(Func);
Func.addr=&MS2;
Func.Arg=2;
Func.ArgType=fl_DOUBLE;
Func.CallType=fl_MEMORY_STACK_CPU;
Func.DeepFPU=1;
Func.ClearStack=fl_ENABLE;     //cdecl
Func.Arrow=fl_RIGHT;           //cdecl
flSetFunction("MS2",&Func,ID);                   //MS2(x1,x2double)=x1-x2
flSetDiffTemplate(ID,"$dfarg1-$dfarg2");


InitFuncStruct(Func);
Func.addr=&MS3;
Func.Arg=3;
Func.ArgType=fl_DOUBLE;
Func.CallType=fl_MEMORY_STACK_CPU;
Func.DeepFPU=1;
Func.ClearStack=fl_ENABLE;     //cdecl
Func.Arrow=fl_RIGHT;           //cdecl
flSetFunction("MS3",&Func,ID);                    //MSP3(x1,x2,x3double)=x1+x2-x3
flSetDiffTemplate(ID,"$dfarg1+$dfarg2-$dfarg3");
//ms3(ms3(x,y,ms1(t))*ms2(t*ms1(x),t),ms2(ms1(y),-ms3(y,ms2(x,t),ms1(x*ms1(t)))),-ms2(ms3(-y,t,x-ms2(t,y)),ms3(t,y*ms1(ms2(t,-y)),-ms2(y,x))))


InitFuncStruct(Func);
Func.addr=&PS1;  //=&PS1
Func.Arg=1;
Func.ArgType=fl_DOUBLE;
Func.CallType=fl_MEMORY_ADDRESSES;
Func.DeepFPU=1;
Func.ClearStack=fl_ENABLE;
Func.Arrow=fl_RIGHT;
flSetFunction("ps1",&Func,ID);
flSetDiffTemplate(ID,"2*$arg1*$dfarg1");



InitFuncStruct(Func);
Func.addr=&PS2;    //=&PS2
Func.Arg=2;
Func.ArgType=fl_DOUBLE;
Func.CallType=fl_MEMORY_ADDRESSES;
Func.DeepFPU=1;
Func.ClearStack=fl_ENABLE;
Func.Arrow=fl_RIGHT;
flSetFunction("ps2",&Func,ID);
flSetDiffTemplate(ID,"$dfarg1-$dfarg2");


InitFuncStruct(Func);
Func.addr=&PS3;    //=&PS3
Func.Arg=3;
Func.ArgType=fl_DOUBLE;
Func.CallType=fl_MEMORY_ADDRESSES;
Func.DeepFPU=1;
Func.ClearStack=fl_DISABLE;     //stdcall
Func.Arrow=fl_RIGHT;            //stdcall
flSetFunction("ps3",&Func,ID);
flSetDiffTemplate(ID,"$dfarg1+$dfarg2-$dfarg3");
//ps3(ps3(x,y,ps1(t))*ps2(t*ps1(x),t),ps2(ps1(y),-ps3(y,ps2(x,t),ps1(x*ps1(t)))),-ps2(ps3(-y,t,x-ps2(t,y)),ps3(t,y*ps1(ps2(t,-y)),-ps2(y,x))))


//func(TArrayE vx, Int32 nx, Extended x, TArrayD vd, Int32 nd, double d,  TArrayI vi, Int32 ni) = (vx[nx]*x-vd[nd]*d)*vi[ni]
InitFuncStruct(Func);
Func.Arg=8;
//VT.set_length(Func.Arg);
VT.resize(Func.Arg);
VT[0]=fl_ARRAY_DOUBLE; VT[1]=fl_INTEGER; VT[2]=fl_DOUBLE; VT[3]=fl_ARRAY_DOUBLE; VT[4]=fl_INTEGER;
VT[5]=fl_DOUBLE; VT[6]=fl_ARRAY_INTEGER; VT[7]=fl_INTEGER;
Func.ArgTypeList=&VT[0];
Func.addr=&SP8;
Func.ArgType=fl_DIFFER;
Func.CallType=fl_STACK_CPU;
Func.ClearStack=fl_ENABLE;     //cdecl
Func.Arrow=fl_RIGHT;           //cdecl
Func.DeepFPU=3;
flSetFunction("sp8",&Func,ID);
//sp8(ve,n+3,x*t,vd,j+k,x-y,vi,n+k+j)


//func(TArrayE *vx, Int32 *nx, Extended *x, TArrayD *vd, Int32 *nd, double *d,  TArrayI *vi, Int32 *ni) = (vx[nx]*x-vd[nd]*d)*vi[ni]
InitFuncStruct(Func);
Func.Arg=8;
VT.resize(Func.Arg);
VT[0]=fl_ARRAY_DOUBLE; VT[1]=fl_INTEGER; VT[2]=fl_DOUBLE; VT[3]=fl_ARRAY_DOUBLE; VT[4]=fl_INTEGER;
VT[5]=fl_DOUBLE; VT[6]=fl_ARRAY_INTEGER; VT[7]=fl_INTEGER;
Func.ArgTypeList=&VT[0];
Func.addr=&PS8;  //ps8
Func.ArgType=fl_DIFFER;
Func.CallType=fl_MEMORY_ADDRESSES;
Func.ClearStack=fl_ENABLE;     //cdecl
Func.Arrow=fl_RIGHT;           //cdecl
Func.DeepFPU=3;
flSetFunction("ps8",&Func,ID);
//ps8(ve,n+3,x*t,vd,j+k,x-y,vi,n+k+j)


//func(TArrayE vx, Int32 nx, Extended x, TArrayD vd, Int32 nd, double d,  TArrayI vi, Int32 ni) = (vx[nx]*x-vd[nd]*d)*vi[ni]
//func(adr) = (vx[nx]*x-vd[nd]*d)*vi[ni]
InitFuncStruct(Func);
Func.Arg=8;
VT.resize(Func.Arg);
VT[0]=fl_ARRAY_DOUBLE; VT[1]=fl_INTEGER; VT[2]=fl_DOUBLE; VT[3]=fl_ARRAY_DOUBLE; VT[4]=fl_INTEGER;
VT[5]=fl_DOUBLE; VT[6]=fl_ARRAY_INTEGER; VT[7]=fl_INTEGER;
Func.ArgTypeList=&VT[0];
Func.addr=&MS8;
Func.ArgType=fl_DIFFER;
Func.CallType=fl_MEMORY_STACK_CPU;
Func.ClearStack=fl_ENABLE;     //cdecl
Func.Arrow=fl_RIGHT;           //cdecl
Func.DeepFPU=3;
flSetFunction("ms8",&Func,ID);
//ms8(ve,n+3,x*t,vd,j+k,x-y,vi,n+k+j)


InitFuncStruct(Func);
Func.addr=&infsum;
Func.ArgType=fl_DOUBLE;
Func.ClearStack=fl_ENABLE;
Func.Arrow=fl_RIGHT;
Func.CallType=fl_INFINITE_STACK_CPU;
Func.DeepFPU=2;
flSetFunction("infsum",&Func,IDF);
flAddNameFunction(IDF,"infs") ;
//infsum(x,y,t,x-y-infsum(x,infsum(x,x*y,-x*y*t),t,x*y),t*x)
//infs(x,y,t,x-y-infs(x,infs(x,x*y,-x*y*t),t,x*y),t*x)


InitFuncStruct(Func);           //fdif(x*fdif(x/fdif(x/y)))/fdif(y/x)
Func.addr=&fp3d;
Func.Arg=1;
Func.ArgType=fl_DOUBLE;
Func.CallType=fl_STACK_CPU;
Func.DeepFPU=2;
Func.ClearStack=fl_DISABLE;
Func.Arrow=fl_RIGHT;
Func.NDeriv=4;
VT.resize(Func.NDeriv);
VT[0]=_int32(&fp3d1);
VT[1]=_int32(&fp3d2);
VT[2]=_int32(&fp3d3);
VT[3]=_int32(&fp3d4);
Func.AdrDeriv=&VT[0];
flSetFunction("fdif",&Func,ID);



InitFuncStruct(Func);                   //idsin(x)^2+idcos(x)^2
Func.addr=&idfunc;
Func.Arg=1;
Func.ArgType=fl_DOUBLE;
Func.CallType=fl_STACK_CPU;
Func.DeepFPU=0;
Func.ClearStack=fl_DISABLE;
Func.Set_ID=fl_ENABLE;
Func.Id_Func=1;
flSetFunction("idsin",&Func,ID);
Func.Id_Func=2;
flSetFunction("idcos",&Func,ID);



//FillArray(TArrayD vd, Double x) = vd[all]=x
InitFuncStruct(Func);
Func.Arg=2;
//VT.set_length(Func.Arg);
VT.resize(Func.Arg);
VT[0]=fl_ARRAY_DOUBLE;  VT[1]=fl_DOUBLE;
Func.ArgTypeList=&VT[0];
Func.addr=&FillArray;
Func.ArgType=fl_DIFFER;
Func.CallType=fl_STACK_CPU;
Func.ClearStack=fl_ENABLE;     //cdecl
Func.Arrow=fl_RIGHT;           //cdecl
Func.DeepFPU=2;
Func.RetNum=fl_NO;
flSetFunction("FillArray",&Func,ID);



InitFuncStruct(Func);
Func.Arg=2;
//VT.set_length(Func.Arg);
VT.resize(Func.Arg);
VT[0]=fl_ARRAY_DOUBLE;  VT[1]=fl_DOUBLE;
Func.ArgTypeList=&VT[0];
Func.addr=&retl;
Func.ArgType=fl_DIFFER;
Func.CallType=fl_STACK_CPU;
Func.ClearStack=fl_ENABLE;     //cdecl
Func.Arrow=fl_RIGHT;           //cdecl
Func.DeepFPU=2;
flSetFunction("retl",&Func,ID);



//krsin(x) = sin(x);
InitFuncStruct(Func);
Code.resize(2);
Code[0]=0xD9; Code[1]=0xFE;     //fsin
Func.CallType=fl_KERNEL_F;
Func.DeepFPU=0;
Func.SizeCode=2;
Func.CodeInline=&Code[0];
flSetFunction("krsin",&Func,ID);
flSetDiffTemplate(ID,"krcos($arg1)*$dfarg1");

//krcos(x) = cos(x);
InitFuncStruct(Func);
Code.resize(2);
Code[0]=0xD9; Code[1]=0xFF;     //fcos
Func.CallType=fl_KERNEL_F;
Func.DeepFPU=0;
Func.SizeCode=2;
Func.CodeInline=&Code[0];
flSetFunction("krcos",&Func,ID);
flSetDiffTemplate(ID,"-krsin($arg1)*$dfarg1");


 //krdiv(x,y) = x/y;
InitFuncStruct(Func);
Code.resize(2);
Code[0]=0xDE; Code[1]=0xF1;    //fdivrp
Func.CallType=fl_KERNEL_FF;
Func.DeepFPU=0;
Func.SizeCode=2;
Func.CodeInline=&Code[0];
flSetFunction("krdiv",&Func,ID);
//flSetDiffTemplate(ID,"($dfarg1*$arg2-$arg1*$dfarg2)/sqr($arg2)");
flSetDiffTemplate(ID,"krdiv(($dfarg1*$arg2-$arg1*$dfarg2),sqr($arg2))");
/*
 sin(x/y)/cos(y/x)
 krdiv(sin(krdiv(x,y)),cos(krdiv(y,x)))
 krdiv(krsin(krdiv(x,y)),krcos(krdiv(y,x)))
*/


  flSetFunction("pc1(x:dbl):real=x^2",0,IDF);     flSetDiffTemplate(IDF,"2*$arg1*$dfarg1");
  flSetFunction("pc2(x,y:dbl):real=x-y",0,IDF);   flSetDiffTemplate(IDF,"$dfarg1-$dfarg2");
  flSetFunction("pc3(x1,x2,x3:ext):real=x1+x2-x3",0,IDF);  flSetDiffTemplate(IDF,"$dfarg1+$dfarg2-$dfarg3");
  
  flSetFunction("pc8(vx: arrayDbl; nx:int; x: dbl; vd: arrayDbl; nd: int; d: dbl; vi: arrayInt; ni: int)=(vx[nx]*x - vd[nd]*d)*vi[ni]",0,IDF);


  flSetFunction("pcdiv(x1,x2:dbl) = x1/x2", 0, IDF);
  flSetDiffTemplate(0, "diff(pcdiv) =pcdiv (($dfarg1*$arg2-$arg1*$dfarg2),sqr($arg2))");

  flSetFunction("pcsin(x:dbl) = sin(x)", 0, IDF);
  flSetDiffTemplate(0, "diff(pcsin) = pccos($arg1)*$dfarg1");

  flSetFunction("pccos(x:dbl) = cos(x)", 0, IDF);
  flSetDiffTemplate(0, "diff(pccos) = -pcsin($arg1)*$dfarg1");

  flSetFunction("pcln(x:dbl) = ln(x)", 0, IDF);
  flSetDiffTemplate(0, "diff(pcln) = $dfarg1/$arg1");

  flSetFunction("pcpow(x1,x2:dbl) = x1^x2", 0, IDF);
  flSetDiffTemplate(0, "diff(pcpow) = pcpow($arg1,$arg2)*(($arg2)*($dfarg1)/($arg1)+($dfarg2)*pcln($arg1))");

  flSetFunction("pcipow(x:dbl; n:int)=x^n", 0, IDF);
  flSetDiffTemplate(0, "diff(pcipow) = pcipow($arg1,$arg2-1)*$arg2*$dfarg1");
  
   // (sin(x/(x+y))^cos(y/(x+y)))^(n+2)
   //  pcipow(pcpow(pcsin(x/(x+y)),pccos(y/(x+y))),n+2)
   //  pcipow(pcpow(pcsin(pcdiv(x,x+y)),pccos(pcdiv(y,x+y))),n+2)
   
  
 




//***************  several expressions: ****************************************

/*
fs3(x,y,z)=x*(y+z)+y*(x+z); fs2(x,y)=x+y; fs1(x)=1-x
sum(x=1..5, dx=0.5; y=1..10; dy=0.2; fs3(f1(x-y),fs2(x+1,y-1),x+y));
*/

flPerform(fl_SAVE, fl_VAR_LIST);//push global var.


// fnc1.Expr= "1-x";
// fnc2.Expr= "x+y";
// fnc3.Expr= "x*(y+z)+y*(x+z)";

flSetVar("x", &fnc1.x, fl_DOUBLE);
flCompile("1-x", 0, fnc1.Addr);

flSetVar("x", &fnc2.x, fl_DOUBLE);
flSetVar("y", &fnc2.y, fl_DOUBLE);
flCompile("x+y", 0, fnc2.Addr);

flSetVar("x", &fnc3.x, fl_DOUBLE);
flSetVar("y", &fnc3.y, fl_DOUBLE);
flSetVar("z", &fnc3.z, fl_DOUBLE);
flCompile("x*(y+z)+y*(x+z)", 0, fnc3.Addr);

flPerform(fl_RESTORE, fl_VAR_LIST);  // pop global var.
//flSet(fl_FPU_CW_DEFAULT,0x1332,0);
//flSet(fl_FPU_CW_DEFAULT,0,0)

	x = 1.0;
	y = 1.0;
	dx = 0.5;
	dy = 0.2;
	res = 0.0;

while (x <= 5)
{
	y = 1.0;
	while (y <= 10.0)    
	{
		fnc1.x = x - y;

		fnc2.x = x + 1;
		fnc2.y = y - 1;

		fnc3.x =  ResultF(fnc1.Addr);
		fnc3.y =  ResultF(fnc2.Addr);
		fnc3.z = x + y;

		res = res +  ResultF(fnc3.Addr);

		y = y + dy;
	};

	x = x + dx;
};

//MessageBox::Show(res.ToString(), "",MessageBoxButtons::OK, MessageBoxIcon::Information);

//************   Triple integral   **************************************************************************

// int3(F(x,y,z)=x*y+2*y*z-z*x, x = -1..2; y = -2*x...x^2+1; z = x-y...x+y
// in wolframalpha representation: Integrate[x*y+2*y*z-z*x, {x,-1,2}, {y,-2*x,x^2+1}, {z, x-y, x+y}]

  flPerform(fl_SAVE, fl_VAR_LIST);

  flSetVar("x", &FInt3.x, fl_DOUBLE);
  flSetVar("y", &FInt3.y, fl_DOUBLE) ;
  flSetVar("z", &FInt3.z, fl_DOUBLE)  ;
  flCompile("x*y+2*y*z-z*x", 0, FInt3.FAddr);
  flCompile("-2*x", 0, FInt3.F1Addr) ;
  flCompile("x^2+1", 0, FInt3.F2Addr) ;
  flCompile("x-y", 0, FInt3.F3Addr);
  flCompile("x+y", 0, FInt3.F4Addr) ;
  FInt3.a = -1;
  FInt3.b = 2 ;

  flPerform(fl_RESTORE, fl_VAR_LIST) ;

  //res = Integral3FF(FInt3.FAddr, &FInt3.x, &FInt3.y, &FInt3.z, FInt3.a, FInt3.b, FInt3.F1Addr, FInt3.F2Addr, FInt3.F3Addr, FInt3.F4Addr);
  //MessageBox::Show(res.ToString(), "",MessageBoxButtons::OK, MessageBoxIcon::Information);


//*****************  Triple integral with internal var. **********************************************************

  flPerform(fl_SAVE, fl_VAR_LIST);

  flSetVarIntrnl("x", fl_DOUBLE, FInt3Ext.adrX);
  flSetVarIntrnl("y", fl_DOUBLE, FInt3Ext.adrY);
  flSetVarIntrnl("z", fl_DOUBLE, FInt3Ext.adrZ);
     
  flCompile("x*y+2*y*z-z*x", 0, FInt3Ext.FAddr);
  flCompile("-2*x", 0, FInt3Ext.F1Addr) ;
  flCompile("x^2+1", 0, FInt3Ext.F2Addr) ;
  flCompile("x-y", 0, FInt3Ext.F3Addr);
  flCompile("x+y", 0, FInt3Ext.F4Addr) ;
  FInt3Ext.a = -1;
  FInt3Ext.b = 2 ;

  flPerform(fl_RESTORE, fl_VAR_LIST) ;

  //res = Integral3FF(FInt3Ext.FAddr, FInt3Ext.adrX, FInt3Ext.adrY, FInt3Ext.adrZ, FInt3Ext.a, FInt3Ext.b, FInt3Ext.F1Addr, FInt3Ext.F2Addr, FInt3Ext.F3Addr, FInt3Ext.F4Addr);
  //MessageBox::Show(res.ToString(), "",MessageBoxButtons::OK, MessageBoxIcon::Information);




//*************************** mixed derivatives******************************
//d5/dy3dx2
flSetDiffVar("y");
flSetDiffExpr("cos(x^2)*sin(y*x)");
flDiffExpr(3);    //d3/dy3
flSetDiffVar("x");
flDiffExpr(2);    //d2/dx2
flCompileDiffExpr(FS1);
x = 2.123; y = 5.456; t = -3.789;
flResultD(FS1,res);
//MessageBox::Show(res.ToString(), "",MessageBoxButtons::OK, MessageBoxIcon::Information);




//**************************Use Attrib (set function)********************************************
    
   //fnc1(x,y)=x+y ; fnc2(x,y,z)=x*y*z ; fnc2(5.5,7.7,fnc1(1.1,2.2))
  
   //fnc1.Expr = "x + y";
   //fnc2.Expr = "x * y * z";
   
   //push global var.
   flPerform(fl_SAVE, fl_VAR_LIST);
   
   flSetVar("x", &fnc1.x, fl_DOUBLE);
   flSetVar("y", &fnc1.y, fl_DOUBLE);
   FAtr.Addr = &fnc1.res;
   FAtr.RType = fl_DOUBLE;
   flCompile("x+y", &FAtr, fnc1.Addr);
   //flCompile(fnc1.Expr, &FAtr, fnc1.Addr);
   
   flSetVar("x", &fnc2.x, fl_DOUBLE);
   flSetVar("y", &fnc2.y, fl_DOUBLE);
   flSetVar("z", &fnc2.z, fl_DOUBLE);
   FAtr.Addr = &fnc2.res;
   FAtr.RType = fl_DOUBLE;
   flCompile("x*y*z", &FAtr, fnc2.Addr);
   //flCompile(fnc2.Expr, &FAtr, fnc2.Addr);
   
    //pop global var.
    flPerform(fl_RESTORE, fl_VAR_LIST);
  
   
   fnc1.x = 1.1;
   fnc1.y = 2.2;
   Result(fnc1.Addr);
   
   fnc2.x = 5.5;
   fnc2.y = 7.7;
   fnc2.z = fnc1.res;
   Result(fnc2.Addr);
   
   //MessageBox::Show(fnc2.res.ToString(), "",MessageBoxButtons::OK, MessageBoxIcon::Information);  //  = 5.5*7.7*(1.1+2.2)
  
//*********************************************************************************************************




flGet(fl_VERSION,fl_MAJOR,ID1);    Sid1=ID1.ToString();
flGet(fl_VERSION,fl_MINOR,ID2);    Sid2=ID2.ToString();
flGet(fl_VERSION,fl_RELEASE,ID3);  Sid3=ID3.ToString();
flGet(fl_VERSION,fl_BUILD,ID4);    Sid4=ID4.ToString();
Sid=Sid1+"."+Sid2+"."+Sid3+"."+Sid4;



this->Text="Test Foreval.dll  (v."+Sid+")";
flGet(fl_COMPILED_BY,0,ID);


if (ID >= 100) {this->Text=this->Text+".  Compiled by FPC v." + ID.ToString(); GLT=2;}
else
{
 GLT=1;	 
 switch  (ID)
 {

  case 7: this->Text=this->Text+".   Compiled by Delphi7"; break;
  case 8: this->Text=this->Text+".   Compiled by Delphi8";   break;
  case 9: this->Text=this->Text+".   Compiled by Delphi2005"; break;
  case 10: this->Text=this->Text+".  Compiled by Delphi2006"; break;
  case 11: this->Text=this->Text+".  Compiled by Delphi2007";  break;
  case 12:  this->Text=this->Text+".   Compiled by Delphi 2009"; break;
  case 13:  this->Text=this->Text+".   Compiled by Delphi 2010"; break;
  case 14:  this->Text=this->Text+".   Compiled by Delphi XE"; break;
  case 15:  this->Text=this->Text+".   Compiled by Delphi XE2";  break;
  case 16:  this->Text=this->Text+".   Compiled by Delphi XE3";  break;
  case 17:  this->Text=this->Text+".   Compiled by Delphi XE4";  break;
  case 18:  this->Text=this->Text+".   Compiled by Delphi XE5"; break;
  case 19:  this->Text=this->Text+".   Compiled by Delphi XE6";  break;
  case 20:   this->Text=this->Text+".   Compiled by Delphi XE7";  break;
  }
}

 
}
 
      
}





double StableTest(void)
{
  const int size = 300;
  int ic,ic1;
 // Pointer32 cf[size],df[size];
  String^ Expr, ^Expr1, ^Expr2, ^Expr3, ^Expr4, ^Expr5, ^Expr6;
  Pointer32 FuncF1,FuncF2,FuncF3,FuncF4,FuncF5,FuncF6;
  Pointer32 FuncDF1,FuncDF2,FuncDF3,FuncDF4,FuncDF5,FuncDF6;
  TArrayP cf,df;
  TArrayI  vi1;
  Pointer32 FuncF,FuncDF;
  int NExpr,nf,nfd, NExprF, NExprD;
  double Resf, Resdf, Rf, Rdf, RFunc, RFuncDF, MR, r1, r2, ResF, ResDF, RDFunc, ResFunc, SRes, SResD, ResFuncD;
 

  //Expr = "(sin(x/(x+y))*sp1(x/(x+y))-sp2(cos(x/(x+y)),cos(y/(x+y))))/(sp3(sin(y/(x+y)),cos(x/y),sin(y/x))*sp2(sp1(x/y),sp1(y/x))-sp1(cos(y/x)))";
  /*
  NExpr:=StrToInt(ETest.Text);
  nf:=6; nfd:=3;
  NExprF:=nf*NExpr;
  NExprD:=nfd*NExpr;
  SetLength(cf,NExprF); SetLength(df,NExprD);
  */

  flSet(fl_ENABLE,fl_SHOW_EXCEPTION,0);

  //NExpr=100;
  NExpr = Convert::ToInt32(ENC->Text);
  nf=6; nfd=3;
  NExprF=nf*NExpr;
  NExprD=nfd*NExpr;
  cf.resize(NExprF);
  df.resize(NExprD);
  // Pointer32 *cf = new Pointer32 [NExprF]; 

  Expr1="(sin(x/(x+y))*sp3(sp1(sin(x/(x-y)))*sin(y/(x+y)),-sp2(cos(y/(y-x)),sin(y/x))/cos(x/(x+y)),cos(y/(x+y))/sp1(cos(x/y)))+cos(y/x)*sp2(-sp1(cos(sin(y/x)))*cos(y/(x-y)),-sp3(cos(y/(y-x)),-sin(x/(x-y)),-cos(sin(y/(x+y))))))/(sp2(-sin(y/(y-x)),cos(x))*cos(y)-sp2(sin(x),cos(y/x))*sin(y))";
  Expr2="x:dbl=1.123; y:ext=3.456; k:int=-5; t:ext=-2.789; n: int=7; x=x*y+n*t*(n-x)/(y/n-x*n*y); y=(x+n+y)*(x*n+k/t)/(y*n-2);n=x+y;  t=x*y*(x*n+y/k*(y/(t-k/(x+y)+(t/x-y/x)/k)+k*x*n/(x-k*n))+x*y*(k*t-n/x*(t/y-k/x*(k-x/y+k*n*(x*(t-n)+y)/(x*y-t*y*(x*(k+2.75)+t*2.75))))))/(2.76*x+7.93*y*k+2.8*n*k*(2.99*y+t*x*k*n)); k=x/y+k*n/t;  x=sin(x)*cos(y)*(n*cos(x)+k*sin(y)-sin(t)*cos(t)*(n+k)); y=sin(y)*(cos(x)*y-x*sin(y)*cos(y)+sin(t)*cos(t)*t);(k*x+n*y)/t";
  Expr3="MinSize:int=10; MaxSize:int=100; vi:arrayInt=0; vd:arrayDbl=0; Sum:ext=0; n:int=0; k:int=0;  itr:int=10; SumVD:Ext=0; for(k,0,itr, SetLen(vd,rnd(MinSize,MaxSize)); L:int=Len(vd); for(n,0,L-1,vd[n]=n; Sum=Sum+n); SumVD=SumVD+sum(vd)); SumVI:Ext=0; for(k,0,itr, SetLen(vi,rnd(MinSize,MaxSize)); L=Len(vi); for(n,0,L-1,vi[n]=n; Sum=Sum+n); SumVI=SumVI+sum(vi)); SetLen(vi,0); SetLen(vd,0); Sum/(SumVD+SumVI)";
  Expr4="-(-x-y/(-y*x/(y-t/(-1.34-x*2.76)))-t/(-2.43*t*x*y/(-x*1.76+1.87*y+t/2.74+2.93)))*(x*(2.76-t*1.75/(2.76/x-2.65)*x)*2.45/t-y*(-x/2.53-y/(-t/x-2.71/(2.43*x-y*2.71-2.76-t)))/(-t/(-y/(2.34-3.52*t/x)))-t/(1.57/y-x/(-t/x-2.12)))/(x/t*y/2.71*(2.76/x-1.65)/(y-t/x))";
  Expr5="min:int=10; max:int=200; limit:ext=max;res:int=0;ifp((min > max)or(max <=1),res=0;goto(end));ifp(max = 3,ifp(min=3,res=1;goto(end),res=2;goto(end)),ifp(max=2,res=1;goto(end))); is_prime:arrayInt=limit+2;jj:ext=0;i:int=0;k:ext=0;x:int=0;y:int=0;n:ext=0;Lsqrt:ext=[sqrt(limit)];for(i,5,limit,is_prime[i]=0); for(x,1,Lsqrt,for(y,1,Lsqrt,n=4*sqr(x)+sqr(y);ifp((n<=limit)and((mod(n,12) = 1)or(mod(n,12) = 5)),is_prime[n]=1-is_prime[n]);n=n-sqr(x);ifp((n<=limit) and (mod(n,12) = 7),is_prime[n]=1-is_prime[n]);n=n-2*sqr(y);ifp((x>y)and(n<=limit)and(mod(n,12)=11),is_prime[n]=1-is_prime[n])));for(i,5,Lsqrt,ifp(is_prime[i]=1,k=sqr(i);n=k; while(n<=limit,is_prime[n]=0; n=n+k)));is_prime[0]=0;is_prime[0]=0;is_prime[1]=0;is_prime[2]=1;is_prime[3]=1;for(i,min,max,ifp(is_prime[i]=1,inc(res)));end>>res";
  Expr6="(y^(x/(x+y))*(-t/x)^(y/(x+y))-x*(x/vd[n+k]^vi[2*n+3]-y*sin(vd[2*k+3]*x)))*((x/y)^((y/x)^((y/(x+y)))^(x/(x+y)))*((y/x)^(y/x)+(x/(x+y))^(y/(x+y))))*((sin(x/y)+x)^cos(y/x)+(cos(x/y)+y)^(sin(x/(x+y))+cos(y/(x+y))))";

   flCompile(Expr1, 0, FuncF1);
   flCompile(Expr2, 0, FuncF2);
   flCompile(Expr3, 0, FuncF3);
   flCompile(Expr4, 0, FuncF4);
   flCompile(Expr5, 0, FuncF5);
   flCompile(Expr6, 0, FuncF6);

   flSetDiffVar("x");
   flSetDiffExpr(Expr1);
   flDiffExpr(1);
   flSetDiffVar("y");
   flDiffExpr(1);
   flCompileDiffExpr(FuncDF1);

   flSetDiffVar("x");
   flSetDiffExpr(Expr4);
   flDiffExpr(1);
   flSetDiffVar("y");
   flDiffExpr(1);
   flCompileDiffExpr(FuncDF4);

   flSetDiffVar("x");
   flSetDiffExpr(Expr6);
   flDiffExpr(1);
   flSetDiffVar("y");
   flDiffExpr(1);
   flCompileDiffExpr(FuncDF6);

   ic=0;
   while (ic < NExpr*nf) 
   {
     flCompile(Expr1, 0, cf[ic]);
     flCompile(Expr2, 0, cf[ic+1]);
     flCompile(Expr3, 0, cf[ic+2]);
     flCompile(Expr4, 0, cf[ic+3]);
     flCompile(Expr5, 0, cf[ic+4]);
     flCompile(Expr6, 0, cf[ic+5]);
     ic=ic+6;
   };

   ic=0;
   while (ic < NExpr*nfd) 
   {
    flSetDiffVar("x");
    flSetDiffExpr(Expr1);
    flDiffExpr(1);
    flSetDiffVar("y");
    flDiffExpr(1);
    flCompileDiffExpr(df[ic]);

    flSetDiffVar("x");
    flSetDiffExpr(Expr4);
    flDiffExpr(1);
    flSetDiffVar("y");
    flDiffExpr(1);
    flCompileDiffExpr(df[ic+1]);

    flSetDiffVar("x");
    flSetDiffExpr(Expr6);
    flDiffExpr(1);
    flSetDiffVar("y");
    flDiffExpr(1);
    flCompileDiffExpr(df[ic+2]);
    ic=ic+3;
  };

   ResF=1;
   flResultD(FuncF1,RFunc);
   ResF=ResF*RFunc;
   flResultD(FuncF2,RFunc);
   ResF=ResF*RFunc;
   flResultD(FuncF3,RFunc);
   ResF=ResF*RFunc;
   flResultD(FuncF4,RFunc);
   ResF=ResF*RFunc;
   flResultD(FuncF5,RFunc);
   ResF=ResF*RFunc;
   flResultD(FuncF6,RFunc);
   ResF=ResF*RFunc;

   ResDF=1;
   flResultD(FuncDF1,RDFunc);
   ResDF=ResDF*RDFunc;
   flResultD(FuncDF4,RDFunc);
   ResDF=ResDF*RDFunc;
   flResultD(FuncDF6,RDFunc);
   ResDF=ResDF*RDFunc;


   SRes=0;
   ic=0;
   while (ic < NExpr*nf) 
   {
      ResFunc=1;

		  RFunc=ResultF(cf[ic]);
      ResFunc=ResFunc*RFunc;

		  RFunc=ResultF(cf[ic+1]);
      ResFunc=ResFunc*RFunc;

		  RFunc=ResultF(cf[ic+2]);
      ResFunc=ResFunc*RFunc;

		  RFunc=ResultF(cf[ic+3]);
      ResFunc=ResFunc*RFunc;

		  RFunc=ResultF(cf[ic+4]);
      ResFunc=ResFunc*RFunc;

		  RFunc=ResultF(cf[ic+5]);
      ResFunc=ResFunc*RFunc;

      SRes=SRes+ResFunc;

       for (ic1 = 0; ic1 < 100; ic1++)
	   {
         RFunc=ResultF(cf[ic]);
         RFunc=ResultF(cf[ic+1]);
         RFunc=ResultF(cf[ic+2]);
         RFunc=ResultF(cf[ic+3]);
         RFunc=ResultF(cf[ic+4]);
         RFunc=ResultF(cf[ic+5]);
	   };
      ic=ic+6;
   };

   
   SResD=0;
   ic=0;
   while (ic < NExpr*nfd) 
   {
      ResFuncD=1;

		  RFunc=ResultF(df[ic]);
      ResFuncD=ResFuncD*RFunc;

		  RFunc=ResultF(df[ic+1]);
      ResFuncD=ResFuncD*RFunc;

		  RFunc=ResultF(df[ic+2]);
      ResFuncD=ResFuncD*RFunc;

      SResD=SResD+ResFuncD;

        for  (ic1 = 0; ic1 < 100; ic1++)
		{
         RFunc=ResultF(df[ic]);
         RFunc=ResultF(df[ic+1]);
         RFunc=ResultF(df[ic+2]);
		};

      ic=ic+3;
   };


   Rf=(SRes/NExpr)/ResF+(SResD/NExpr)/ResDF;  //=2
   MR=Rf;


       
   for  (ic1 = 0; ic1 < cf.size(); ic1++)
   {
	  flPerform(fl_FREE, (DWORD)(cf[ic1]));
   };

   for  (ic1 = 0; ic1 < df.size(); ic1++)
   {
	  flPerform(fl_FREE,  (DWORD)(df[ic1]));
   };

   flSet(fl_DISABLE,fl_SHOW_EXCEPTION,0);

  return MR;

/*

  Expr="(sin(x/(x+y))*sp2(cos(x/y)*sp2(cos(x/(x+y)),sin(y/(x+y))),sin(y/x)*sp1(cos(y/x)-sin(x/y)))-cos(y/(x+y))*sp2(sp1(sin(y/(y-x)))/(x+y),sp1(cos(x/(y-x)))/(x-y)))/(sin(cos(y/(y-x)))*sp2(cos(x/y)^2-sin(y/x)^3,sin(x/(y-x))^2-cos(y/(y-x))^3)-cos(sin(x/(y-x)))*sp1(cos(cos(x/(y-x)))-sin(sin(x/(y-x)))))";
  
  flCompile(Expr, 0, FuncF);
   flResultD(FuncF,RFunc);

   flSetDiffVar("y");
   flSetDiffExpr(Expr);
   flDiffExpr(1);
   flSetDiffVar("x");
   flDiffExpr(1);
   flCompileDiffExpr(FuncDF);
   flResultD(FuncDF,RFuncDF);

  for(ic = 0; ic < size; ic++)
  {

   flCompile(Expr, 0, cf[ic]);

   flSetDiffVar("y");
   flSetDiffExpr(Expr);
   flDiffExpr(1);
   flSetDiffVar("x");
   flDiffExpr(1);
   flCompileDiffExpr(df[ic]);

  }

   Resf = 0; Resdf = 0;
   for(ic = 0; ic < size; ic++)
   {
	 Resf=Resf+ResultF(cf[ic]);
	 Resdf=Resdf+ResultF(df[ic]);
   }

   
	for(ic = 0; ic < size; ic++)
   {
	 flPerform(fl_FREE,(Int32)cf[ic]);
	 flPerform(fl_FREE,(Int32)df[ic]);
   }
   

   MR=Resf/(size*RFunc)+Resdf/(size*RFuncDF);  //=2
 

   return MR;

   */
}







 void SetVarValue(void)
{
	double xt;
	
  x=Convert::ToDouble(this->E_x->Text->Replace(",", "."), System::Globalization::CultureInfo::GetCultureInfo("en-US"));
  y=Convert::ToDouble(this->E_y->Text->Replace(",", "."), System::Globalization::CultureInfo::GetCultureInfo("en-US"));
  t=Convert::ToDouble(this->E_t->Text->Replace(",", "."), System::Globalization::CultureInfo::GetCultureInfo("en-US"));


  xt=Convert::ToDouble(this->E_ad0->Text->Replace(",", "."), System::Globalization::CultureInfo::GetCultureInfo("en-US"));
  flSetArrayValueD(adrXAD,0,xt);
  xt=Convert::ToDouble(this->E_ad1->Text->Replace(",", "."), System::Globalization::CultureInfo::GetCultureInfo("en-US"));
  flSetArrayValueD(adrXAD,1,xt);
  xt=Convert::ToDouble(this->E_ad2->Text->Replace(",", "."), System::Globalization::CultureInfo::GetCultureInfo("en-US"));
  flSetArrayValueD(adrXAD,2,xt);


  n=Convert::ToInt32(this->E_n->Text);
  k=Convert::ToInt32(this->E_k->Text);
  j=Convert::ToInt32(this->E_j->Text);


}


 





	private: System::Void Button1_Click(System::Object^  sender, System::EventArgs^  e) 
{
		 TStringType  Expr;
	     Pointer32    Func1;
		 String^      SExpr;
		 String^      SCE;
		 Pointer32    PExpr;
		 IntPtr       iptr;
		 PString      PStr;   
		 double       r,  res;
		 _int32       ECode,NC,ni,Prf,SZ,ct,rt,ID;
		 unsigned long T1, T2;
		 Pointer32    adri1,vecd0;
		 PInteger     pint1; 
		 System::String^      S1r;
		 System::String^      S2r;
		 _int32       FpuExc;
		 

		 //***************************************************


	
		 SetVarValue() ;
		 

		  #ifdef StableTEST
		   res=StableTest();
	       LR->Text=res.ToString();  goto endp;
          #endif;
		
		 SExpr = EF->Text;
		 
		 
         //Expr = &SExpr;
		 
         //SExpr = SExpr+"12345";
		 //PExpr = &SExpr;
		 //PStr = (PString)PExpr;
		 //iptr = (IntPtr)PStr;
         //PExpr = &SExpr;
		 //EF->Text = *PStr;
		 //PExpr = &SExpr;
		 //SExpr->
		 //PExpr = PtrToStringChars(SExpr);

		  NC = Convert::ToInt32(ENC->Text);
          res=0;

		
 // flGetFuncID("sin",ID);
 // flSet(108,ID,5);

//****************************  test  fast connecting of dynamic array (in VisualC++ count from '1', in foreval count from '0'   !!!)  ****************************
//                              without using   flSetArrayValueD or CopyMemory   
//                      		   Expression FDynArray compiled in Form1_Load 
#ifdef   TESTFASTDYNARRAY 


		  // set randomize size of array (VECD) and fill it 1.0

    NC = rand()+2;
    vecd.clear();


	//******************first way to write array:
	/*
	     vecd.push_back(0);//reserve for length	
         for (ni = 1; ni <= NC; ni++)  //count from 1 !!!
     	 {
         vecd.push_back(1.0);
	     }
	*/
   
	//*******************second way to write array:
    	vecd.resize(NC+1); // NC+1=length(VC++); NC = length(foreval); (>0 !!!); 1 - reserve for length (vecd[0])
       //vecd.reserve(NC+1);
	
       for (ni = 1; ni <= NC; ni++)  //count from 1 !!!
       {
	    vecd[ni]=1.0;
	   }
	

    //set length 
	adrVECD=&vecd[1];//to set a new reference to the array so , as  memory location of  vecd is changed  ; after full load of array!!!	
	pint1 = (PInteger)adrVECD;
	pint1=pint1-1; //= &vecd[1]-4b; or = &vecd[0]+4b;  sizeof(double) = 8
	if (GLT == 1) {SZ = vecd.size()-1;} else {SZ=vecd.size()-2;};  //GLT=1(Delphi); GLT=2(FPC),  in FPC Length=High
	*pint1 = SZ;  //pint1 = &vecd[1]-4b;  *pint1 <- length
	  

	//  len(vecd)*(sum(vecd)/len(vecd))
	//  k:int=0; len:int=len(vecd); s:dbl=0; for(k,0,len-1,s=s+vecd[k]); s/sum(vecd)
	flResultD(FDynArray, res);   //without recompiling expression
    LR->Text=res.ToString();	
	goto endp;

#endif
//************************************************************************************************************************************************

	

  Func1 = NULL;


  flCompile(SExpr, 0, Func1);
 



  if (CB_OM->Checked) { NC=1;} else {NC=Convert::ToInt32(ENC->Text);};

  flGetErrorCode(ECode);


  if (ECode != 0)
  {
	  ShowError();
  }
  else
  {

   flPerform(fl_MASK_FPU_EXCEPTION,0);

   flGet(fl_RETURN_NUMBER,Int32(Func1),rt);

   if (rt == fl_NO)            //no return number: return result in inner 'result' or 'res' variable  ( x1: ext=x+y; x1=x1*x; result=x1  )
   {

	 

	  T1=GetTickCount();

	  for(ni = 0; ni <= NC; ni++)
	  {
		//flResult(Func1);
		Result(Func1);
		
	  };
	 T2=GetTickCount();	

	 res=resf;

   }
   else
   {
	   

	   T1=GetTickCount();
	   for(ni = 0; ni <= NC; ni++)
	   {

//		  res = x*y*t*(t*x*(x*y-t*x)-x*y*(x*t-y*t)+y*x*(y*x-t*y)-(x+y)*(x-y)*(t-y)*(x*y-t*x*(x-y*(t-x*(t-x)*(x-t)*(t-y)-x*y-y))))-(x*t*y*(x*y-x*(y-y*(t-t*(x-x*t*(x*y-t*x-(x*y-t*x)*(x-y)*(y-t)*(t-y)-(x+t*y)*(y-x*t)+(t-y*t)*(y-t*x))))))) ;
//		  res = -x/(x/y-t/(x+t)+x*y*(x*y-y*t+x/(x/(x+y)+y/(t+x))))*(y*(x-y/(x*y-y/(x*y+y*t)*(y*t-x*y)))+x-y*(x-t-t/(x-y)*(y/(y-t*(x+y*t)*(y-x*t)/(x*t-y*(x+t))))))*(x*y-t*y-t*(x*t-y*(t-x)/(x*y*t-x-y-t)));
//		  res = x*y*(2.111*x+1)*(2.211*x*y/t-2.311*x*(3.422*t-1)/(2.511*x-3.611*y-4.22)*(x/(3.711*x-1)-4.111/x+5.111*(2.611*x*y*t-1.23)/(y+1.12)-7.132*(2.812*x*(y+1.123)*(3.832*y+2.121)*(3.112/(x+1.123)-2.133*t))));
//		  res = x*y*(x-t*(2.123*x-3.222*y-5.323)/(t*x*y/(2.234-x*y)+(2.455*x+3.632)*(3.734*y-4.832*t-5.923)-(1.134-x)/(-t-y))+x*(y-(-x-(-y/(-t*x*(x*y*t*(2.745*x-3.345*y-t))-y*(x*y-y*t*3.167+2.965*(x/t-t/(x-y*(2.467-x-y-t)))*(y-t)-2.376*x)*(y-x)-7.154/x)*(-1.943/t+x*y*t*5.334))-3.556*x-5.657)-7.243*y-3.459)/(x-t)+x*(t*y/(x-2.834*t)-y*(x*(t-2.756*y-x-5.676))));
//		  res = (x*y+t*(x*y-y*t*x-x+y-t))*(x+y+t)*(x-y-t)*(t-x*(t-y*(x-y-t)))*x*y*t-x*t*(x*t-y*t+x-t)*(y*x+t*x+t*y-y-x)*(x*t-y*(x-y*t-t-x)*(x-y-t)-y*(y+y*x-t-x)+t*(x*y-x*(t+y*(x*y-t*y*x-y*t*(y+x*(x-t+y*(x-y+t-x*(x*y-t*x)*(x*y-t*(x+y+t)*(x-y-t)-t*(-x-y*(-t*(-x*(y-t))))))))))));
//		  res = x*y-x/(x/y-t/y-(-x-y*(x*y-t*x/(x/y-t/y-(-x-(-y-(-t-(x*y-y*(-x*y-y/(x+y*t)))*x)*y)/(x+y*t)-x*(y/t-(-y*x/(x-y*t)-(-x-(-y/(-x*y*(-x-y))+x/y*(y*x+y*t-x/(x+y*t))-x*y*(x*y+(-x*y-t/y+x-y*x)))))+x*y*t*(x+y*t)))))));
//		  res = x*y*(x-t*(2.154*x-3.253*y-5.353)/(t*x*y/(2.544-x*y)+(2.143*x+3.556)*(3.343*y-4.153*t-5.456)-(1.153-x)/(-t-y))+x*(y-(-x-(-y/(-t*x*(x*y*t*(2.644*x-3.364*y-t))-y*(x*y-y*t*3.164+2.267*(x/t-t/(x-y*(2.533-x-y-t)))*(y-t)-2.453*x)*(y-x)-7.535/x)*(-1.253/t+x*y*t*5.353))-3.433*x-5.455)-7.466*y-3.577)/(x-t)+x*(t*y/(x-2.699*t)-y*(x*(t-2.767*y-x-5.854)-y*(-1.549-x/(-t-y))/(x/y-x/(t/x-y/t)+t*(1/x-5.344/y-x*y*(2.435*x-1.456)*(t*y*3.326-5.347)*(1.943-x*y*t*3.245)*(x+y))))));
//		  res = (x*y+t*(x*y-y*t*x-x+y-t))*(x+y+t)*(x-y-t)*(t-x*(t-y*(x-y-t)))*x*y*t-x*t*(x*t-y*t+x-t)*(y*x+t*x+t*y-y-x)*(x*t-y*(x-y*t-t-x)*(x-y-t)-y*(y+y*x-t-x)+t*(x*y-x*(t+y*(x*y-t*y*x-y*t*(y+x*(x-t+y*(x-y+t-x*(x*y-t*x)*(x*y-t*(x+y+t)*(x-y-t*(x-y*(t-x*y-y*(x*y-t*x)-t*(t*x+y))))-t*(-x-y*(-t*(-x*(y-t*(x*y*t-y*x*t*(-x*(y*x-t*y-x-y-t)))))))))))))));
//        res = (x*y+t/(x*y-y*t/x-x+y-t))*(x+y+t)/(x-y-t)*(t-x*(t-y/(x-y-t)))*x/y*t-x*t*(x*t-y*t+x-t)/(y*x+t*x+t/y-y-x)*(x*t-y*(x-y*t-t-x)*(x-y-t)-y*(y+y*x-t-x)+t*(x*y-x*(t+y/(x*y-t*y*x-y*t*(y+x*(x-t+y*(x-y+t-x*(x*y-t*x)*(x*y-t*(x+y+t)*(x-y-t/(x-y*(t-x*y-y/(x*y-t*x)-t/(t/x+y))))-t*(-x-y*(-t/(-x*(y-t*(x*y/t-y*x*t/(-x*(y*x-t*y-x-y-t)))))))))))))));
//		  res = x*y*(x-t*(2.156*x-3.652*y-5.653)/(t*x*y/(2.664-x*y)+(2.155*x+3.543)*(3.345*y-4.431*t-5.443)-(1.451-x)/(-t-y))+x*(y-(-x-(-y/(-t*x*(x*y*t*(2.453*x-3.353*y-t))-y*(x*y-y*t*3.153+2.253*(x/t-t/(x-y*(2.533-x-y-t)))*(y-t)-2.453*x)*(y-x)-7.553/x)*(-1.253/t+x*y*t*5.533))-3.453*x-5.453)-7.453*y-3.553)/(x-t)+x*(t*y/(x-2.653*t)-y*(x*(t-2.753*y-x-5.853)-y*(-1.539-x/(-t-y))/(x/y-x/(t/x-y/t)+t*(1/x-5.553/y-x*y*(2.535*x-1.53)*(t*y*3.536-5.753)*(1.539-x*y*t*3.665)*(x+y*(t-(-x-y*t/(x*y-2.863*(x*y*(x-y*(x*t+y/t*(2.623*x-1.352-t*y))))))))))))) ;
//		  res = x*y*(2.251*x+1)*(2.243*x*y/t-2.353*x*(3.475*t-1)/(2.575*x-3.675*y-4.766)*(x/(3.767*x-1)-4.176/x+5.186*(2.866*x*y*t-1.766)/(y+1.876)-7.165*(2.874*x*(y+1.641)*(3.864*y+2.162)*(3.171/(x+1.765)-2.173*t/(2.174*x*y*t-1.171)+(4.171*x-1.164)*(5.172*y-7.174)/(x-2.175*y-1.747-2.174*t/(3.618-7.716*x-8.181*y*(4.612*x/(2.189*t+1.165)-7.198*x-8.149/t+9.912*(2.199*x-1.261)*(3.107*x+4.179*y+5.108)*(2.271*x*y*t-7.179)*x*y*t/(x-y*2.282-3.621/(x/(t-1.147)-7.198/(y+2.245)+8.233/(2.288*x*y*t+1.247)-9.174)))))/(x-1.525)))));

		  
//        res=sp8(ve,n+3,x/sp8(ve,n+7,x-t,vd,j+3,-y+sp8(ve,k+3,-t,vd,j+3*k,x-sp8(ve,j+3,t,vd,j+n,t+x,vi,n+2*j),vi,k+j),vi,n+2*k),vd,j+k,x*sp8(ve,n+7,t/sp8(ve,j+6,x-t,vd,j+n-1,x-y,vi,n+3*k+j),vd,j+9,x+sp8(ve,n,t,vd,k,y,vi,j),vi,j+5),vi,n+k+j)/sp8(ve,k+3,t,vd,n+3,x,vi,k+2*j);		
		   // pc8(ve,n+3,x/pc8(ve,n+7,x-t,vd,j+3,-y+pc8(ve,k+3,-t,vd,j+3*k,x-pc8(ve,j+3,t,vd,j+n,t+x,vi,n+2*j),vi,k+j),vi,n+2*k),vd,j+k,x*pc8(ve,n+7,t/pc8(ve,j+6,x-t,vd,j+n-1,x-y,vi,n+3*k+j),vd,j+9,x+pc8(ve,n,t,vd,k,y,vi,j),vi,j+5),vi,n+k+j)/pc8(ve,k+3,t,vd,n+3,x,vi,k+2*j);
		   // ms8(ve,n+3,x/ms8(ve,n+7,x-t,vd,j+3,-y+ms8(ve,k+3,-t,vd,j+3*k,x-ms8(ve,j+3,t,vd,j+n,t+x,vi,n+2*j),vi,k+j),vi,n+2*k),vd,j+k,x*ms8(ve,n+7,t/ms8(ve,j+6,x-t,vd,j+n-1,x-y,vi,n+3*k+j),vd,j+9,x+ms8(ve,n,t,vd,k,y,vi,j),vi,j+5),vi,n+k+j)/ms8(ve,k+3,t,vd,n+3,x,vi,k+2*j);
		   // ps8(ve,n+3,x/ps8(ve,n+7,x-t,vd,j+3,-y+ps8(ve,k+3,-t,vd,j+3*k,x-ps8(ve,j+3,t,vd,j+n,t+x,vi,n+2*j),vi,k+j),vi,n+2*k),vd,j+k,x*ps8(ve,n+7,t/ps8(ve,j+6,x-t,vd,j+n-1,x-y,vi,n+3*k+j),vd,j+9,x+ps8(ve,n,t,vd,k,y,vi,j),vi,j+5),vi,n+k+j)/ps8(ve,k+3,t,vd,n+3,x,vi,k+2*j);
		 
		   //res=sp8(ve,j,t,vd,k,y,vi,j);
		   //res=sp1(x)*sp2(x,y)*sp3(x,y,t);
		  //res=sp1(-x)/(-(-(-1-sp2(-1-x,sp1(x))))-sp1(-sp1(-x)-1)*(2-sp2(-x,-1)*3))/(-sp1(sp1(-x)*2-3)*3-5)/(sp1(-x-1)*3-5)+(-(-sp1(-1-x))*(-(-(-sp1(-x)*2+5)))*(-sp1(x+1)))+sp1(2*sp1(-x-1)-1)-sp1(-1-x)/((sp1(2*sp1(-x-1)-1)*3-5)+(-(-(-sp1(-1+2*sp1(-x-1)))))-(-sp1(-2*sp1(-x-1)+1)-5)*(sp1(1-2*sp1(-x-1))))+(-sp1(2*sp1(-x-1)-1)-5)*(-2*sp1(1-2*sp1(-x-1))-3)/(sp1(-1+2*sp1(-x-1))*3-sp1(2*sp1(-x-1)-1)*5)/sp1(2*sp1(-x-1)-1)-(-sp1(2*sp1(-x-1)-1)/sp1(x+1))+sp2(-x,x)+2*sp2(x,-x)/(-sp2(-x-1,x+1)-5*sp2(x+1,-x-1)*sp1(sp2(x+1,-x-1)))*(sp1(sp2(x+1,-x-1))-sp1(sp2(1-2*sp1(-x-1),-1-x)))-sp2(x+1,2*sp1(-x)-1)/(-(-3*sp2(1-2*sp1(-x-1),-1-x)))*((-2*sp2(sp1(x+1)*2-1,-1-2*sp1(x+1))-(-5*sp2(-sp1(x+1)*2-1,1-sp1(-x-1)*2))))+(-sp2(-x,x)+(7-3*sp2(x,-x)-5)/(-sp2(-x-1,x+1))/sp2(x+1,-x-1))/(-9/sp2(1-2*sp1(-x-1),-1-x)-sp1(-7*sp2(x+1,2*sp1(-x)-1))-3)+(-sp1(-sp2(sp1(x+1)*2-1,-1-2*sp1(x+1))-7)+(3*sp2(-sp1(x+1)*2-1,1-sp1(-x-1)*2)-5));
         
//		  res=sp3(x*sp2(sp1(y-x),sp2(x-sp2(t*x,x-y),sp2(t*x,y+t))),sp1(t-y)+sp2(sp3(sp2(x*t,y*x),t,sp2(t-x,y-x)),sp3(sp3(x-y,y*x,y*t),x*sp2(x-y,y-t),t*sp1(x+y))),sp3(sp1(t+x),sp2(x-y,y*t),sp1(x+y+t)));
			 // ps3(x*ps2(ps1(y-x),ps2(x-ps2(t*x,x-y),ps2(t*x,y+t))),ps1(t-y)+ps2(ps3(ps2(x*t,y*x),t,ps2(t-x,y-x)),ps3(ps3(x-y,y*x,y*t),x*ps2(x-y,y-t),t*ps1(x+y))),ps3(ps1(t+x),ps2(x-y,y*t),ps1(x+y+t)));
			 // ms3(x*ms2(ms1(y-x),ms2(x-ms2(t*x,x-y),ms2(t*x,y+t))),ms1(t-y)+ms2(ms3(ms2(x*t,y*x),t,ms2(t-x,y-x)),ms3(ms3(x-y,y*x,y*t),x*ms2(x-y,y-t),t*ms1(x+y))),ms3(ms1(t+x),ms2(x-y,y*t),ms1(x+y+t)));
			 // pc3(x*pc2(pc1(y-x),pc2(x-pc2(t*x,x-y),pc2(t*x,y+t))),pc1(t-y)+pc2(pc3(pc2(x*t,y*x),t,pc2(t-x,y-x)),pc3(pc3(x-y,y*x,y*t),x*pc2(x-y,y-t),t*pc1(x+y))),pc3(pc1(t+x),pc2(x-y,y*t),pc1(x+y+t)));

//            res = 2.15*pow(x,12)-4.541*pow(x,11)-3.65*pow(x,10)+6.75*pow(x,9)+2.2*pow(x,8)-2.84*pow(x,7)+5.2*pow(x,6)-3.9*pow(x,5)+4.765*pow(x,4)+2.63*pow(x,3)+2.8*pow(x,2)+2.11*x+12.754;     
//            res = (pow(x-1.5,2*n-3*k+1)*0.05-15.1*pow(t*x,n-2*k)-21.1*pow(y*t,k-3*n-7))/(2.1*pow(x+y,2*k+1)-y*pow(x-t,n+5))*(3.2*pow(x-y,n+k)-x*pow(t+x*y,n+k+2)) ;
//            res = sin(cos(x+y))*cos(y*sin(x-y))*(2.15*cos(sin(3.53*cos(t-x)))-tan(x+y)*(tan(t+x)-cos(sin(t+y))*((1.76*asin(x/(x+y))+2.97*acos(y/(x+y)))*(2.12*atan(x-y)*atan2(x-y,x+y)-asin(t/(x+y))*acos(t/(y+x-t))/(atan(x+y)+atan2(t-x-y,x-t))))));

//		      res=pow(x,y);
//            res=sin(x/y)*(sin(y/(x+y))+cos(x/(x+y))+cos(y/x))+cos(x/y)*(sin(y/x)+cos(y/(x+y))+sin(x/(x+y))); 
//			  res=(sin(x/(x+y))-sinh(y/(x+y)))*(cosh(y/(x+y))+cos(x/(x+y)));
//            res=exp(x/(x+y))*(sinh(x/(x+y))+cosh(x/(x+y))+tanh(x/(x+y)));
//		      res=(vd[n+1]*x-ve[k+n]*y)*(vd[n+k+3]*(x-y)+ve[2*n+3*k+4]*t);

		  /*
		  sp8(ve,j,t,vd,k,y,vi,j)
		  ps8(ve,j,t,vd,k,y,vi,j)
		  ms8(ve,j,t,vd,k,y,vi,j)
		  pc8(ve,j,t,vd,k,y,vi,j)
		  */
		   
		 //flResultD(Func1,res);
		res=ResultF(Func1);
		   //res=flResultF(Func1);
		   
		   
	   }
		T2=GetTickCount();		

  }


  LR->Text=res.ToString();

  if ((T2-T1) != 0)
	   { LPf->Text=Convert::ToString((Int32)(NC/(T2-T1))); }
	   else { LPf->Text="no defined" ; };



  flPerform(fl_FREE,(Int32)Func1);

  //flPerform(fl_CLEAR_FPU_EXCEPTION,0);
  flGet(fl_IS_FPU_EXCEPTION,0,FpuExc);
  if(FpuExc == fl_YES)
	 {
		  LR->Text="Invalid operation";		  
	 }

 }

endp:;
}


//  sp8(ve,n+3,x/sp8(ve,n+7,x-t,vd,j+3,-y+sp8(ve,k+3,-t,vd,j+3*k,x-sp8(ve,j+3,t,vd,j+n,t+x,vi,n+2*j),vi,k+j),vi,n+2*k),vd,j+k,x*sp8(ve,n+7,t/sp8(ve,j+6,x-t,vd,j+n-1,x-y,vi,n+3*k+j),vd,j+9,x+sp8(ve,n,t,vd,k,y,vi,j),vi,j+5),vi,n+k+j)/sp8(ve,k+3,t,vd,n+3,x,vi,k+2*j)
//  ps8(ve,n+3,x/ps8(ve,n+7,x-t,vd,j+3,-y+ps8(ve,k+3,-t,vd,j+3*k,x-ps8(ve,j+3,t,vd,j+n,t+x,vi,n+2*j),vi,k+j),vi,n+2*k),vd,j+k,x*ps8(ve,n+7,t/ps8(ve,j+6,x-t,vd,j+n-1,x-y,vi,n+3*k+j),vd,j+9,x+ps8(ve,n,t,vd,k,y,vi,j),vi,j+5),vi,n+k+j)/ps8(ve,k+3,t,vd,n+3,x,vi,k+2*j);
//  ms8(ve,n+3,x/ms8(ve,n+7,x-t,vd,j+3,-y+ms8(ve,k+3,-t,vd,j+3*k,x-ms8(ve,j+3,t,vd,j+n,t+x,vi,n+2*j),vi,k+j),vi,n+2*k),vd,j+k,x*ms8(ve,n+7,t/ms8(ve,j+6,x-t,vd,j+n-1,x-y,vi,n+3*k+j),vd,j+9,x+ms8(ve,n,t,vd,k,y,vi,j),vi,j+5),vi,n+k+j)/ms8(ve,k+3,t,vd,n+3,x,vi,k+2*j);
//  pc8(ve,n+3,x/pc8(ve,n+7,x-t,vd,j+3,-y+pc8(ve,k+3,-t,vd,j+3*k,x-pc8(ve,j+3,t,vd,j+n,t+x,vi,n+2*j),vi,k+j),vi,n+2*k),vd,j+k,x*pc8(ve,n+7,t/pc8(ve,j+6,x-t,vd,j+n-1,x-y,vi,n+3*k+j),vd,j+9,x+pc8(ve,n,t,vd,k,y,vi,j),vi,j+5),vi,n+k+j)/pc8(ve,k+3,t,vd,n+3,x,vi,k+2*j);

//sp2(x*sp1(x-y),y*sp1(y-x))*sp2(x*sp2(x-sp1(x*y),y-sp2(y*x,x*(x+y)))-y*sp1(x*(x-y)),y*sp2(y*(x-y),t*(x+y))-x*sp1(t*(x-y)))/(2.23*sp2(1.51*sp1(t-x*(t-y))-1.73,-3.21*sp1(t-y))-1.24*sp2(1.74*x-1.85*sp1(y-t),y-1.96*sp1(t-x)))
//ps2(x*ps1(x-y),y*ps1(y-x))*ps2(x*ps2(x-ps1(x*y),y-ps2(y*x,x*(x+y)))-y*ps1(x*(x-y)),y*ps2(y*(x-y),t*(x+y))-x*ps1(t*(x-y)))/(2.23*ps2(1.51*ps1(t-x*(t-y))-1.73,-3.21*ps1(t-y))-1.24*ps2(1.74*x-1.85*ps1(y-t),y-1.96*ps1(t-x)))
//ms2(x*ms1(x-y),y*ms1(y-x))*ms2(x*ms2(x-ms1(x*y),y-ms2(y*x,x*(x+y)))-y*ms1(x*(x-y)),y*ms2(y*(x-y),t*(x+y))-x*ms1(t*(x-y)))/(2.23*ms2(1.51*ms1(t-x*(t-y))-1.73,-3.21*ms1(t-y))-1.24*ms2(1.74*x-1.85*ms1(y-t),y-1.96*ms1(t-x)))
//ma2(x*ma1(x-y),y*ma1(y-x))*ma2(x*ma2(x-ma1(x*y),y-ma2(y*x,x*(x+y)))-y*ma1(x*(x-y)),y*ma2(y*(x-y),t*(x+y))-x*ma1(t*(x-y)))/(2.23*ma2(1.51*ma1(t-x*(t-y))-1.73,-3.21*ma1(t-y))-1.24*ma2(1.74*x-1.85*ma1(y-t),y-1.96*ma1(t-x)))
//pc2(x*pc1(x-y),y*pc1(y-x))*pc2(x*pc2(x-pc1(x*y),y-pc2(y*x,x*(x+y)))-y*pc1(x*(x-y)),y*pc2(y*(x-y),t*(x+y))-x*pc1(t*(x-y)))/(2.23*pc2(1.51*pc1(t-x*(t-y))-1.73,-3.21*pc1(t-y))-1.24*pc2(1.74*x-1.85*pc1(y-t),y-1.96*pc1(t-x)))
//kf2(x*kf1(x-y),y*kf1(y-x))*kf2(x*kf2(x-kf1(x*y),y-kf2(y*x,x*(x+y)))-y*kf1(x*(x-y)),y*kf2(y*(x-y),t*(x+y))-x*kf1(t*(x-y)))/(2.23*kf2(1.51*kf1(t-x*(t-y))-1.73,-3.21*kf1(t-y))-1.24*kf2(1.74*x-1.85*kf1(y-t),y-1.96*kf1(t-x)))
//fp2(x*fp1(x-y),y*fp1(y-x))*fp2(x*fp2(x-fp1(x*y),y-fp2(y*x,x*(x+y)))-y*fp1(x*(x-y)),y*fp2(y*(x-y),t*(x+y))-x*fp1(t*(x-y)))/(2.23*fp2(1.51*fp1(t-x*(t-y))-1.73,-3.21*fp1(t-y))-1.24*fp2(1.74*x-1.85*fp1(y-t),y-1.96*fp1(t-x)))
//in2(x*in1(x-y),y*in1(y-x))*in2(x*in2(x-in1(x*y),y-in2(y*x,x*(x+y)))-y*in1(x*(x-y)),y*in2(y*(x-y),t*(x+y))-x*in1(t*(x-y)))/(2.23*in2(1.51*in1(t-x*(t-y))-1.73,-3.21*in1(t-y))-1.24*in2(1.74*x-1.85*in1(y-t),y-1.96*in1(t-x)))


//kf1(x)*kf2(x,y)-(-kf1(-kf2(-kf2(2*kf1(-x),3*kf1(-y)+1),2*kf1(-y))))-(kf2(5*kf1(8*kf1(y)-3),7-kf2(kf1(x)/kf1(y),2*kf1(-x)*kf1(y)))*2-1)*(kf2(4*kf1(-y)-5,4-kf1(-x))*3-4-7*kf1(x)/kf1(y))
//in1(x)*in2(x,y)-(-in1(-in2(-in2(2*in1(-x),3*in1(-y)+1),2*in1(-y))))-(in2(5*in1(8*in1(y)-3),7-in2(in1(x)/in1(y),2*in1(-x)*in1(y)))*2-1)*(in2(4*in1(-y)-5,4-in1(-x))*3-4-7*in1(x)/in1(y))
//fp1(x)*fp2(x,y)-(-fp1(-fp2(-fp2(2*fp1(-x),3*fp1(-y)+1),2*fp1(-y))))-(fp2(5*fp1(8*fp1(y)-3),7-fp2(fp1(x)/fp1(y),2*fp1(-x)*fp1(y)))*2-1)*(fp2(4*fp1(-y)-5,4-fp1(-x))*3-4-7*fp1(x)/fp1(y))
//ma1(x)*ma2(x,y)-(-ma1(-ma2(-ma2(2*ma1(-x),3*ma1(-y)+1),2*ma1(-y))))-(ma2(5*ma1(8*ma1(y)-3),7-ma2(ma1(x)/ma1(y),2*ma1(-x)*ma1(y)))*2-1)*(ma2(4*ma1(-y)-5,4-ma1(-x))*3-4-7*ma1(x)/ma1(y))
//pc1(x)*pc2(x,y)-(-pc1(-pc2(-pc2(2*pc1(-x),3*pc1(-y)+1),2*pc1(-y))))-(pc2(5*pc1(8*pc1(y)-3),7-pc2(pc1(x)/pc1(y),2*pc1(-x)*pc1(y)))*2-1)*(pc2(4*pc1(-y)-5,4-pc1(-x))*3-4-7*pc1(x)/pc1(y))


//in1(2*in1(-x-1)-1)-in1(-1-x)/((in1(2*in1(-x-1)-1)*3-5)+(-(-(-in1(-1+2*in1(-x-1)))))-(-in1(-2*in1(-x-1)+1)-5)*(in1(1-2*in1(-x-1))))+(-in1(2*in1(-x-1)-1)-5)*(-2*in1(1-2*in1(-x-1))-3)/(in1(-1+2*in1(-x-1))*3-in1(2*in1(-x-1)-1)*5)/in1(2*in1(-x-1)-1)-(-in1(2*in1(-x-1)-1)/in1(x+1))
//in1(-x)/(-(-(-1-in2(-1-x,in1(x))))-in1(-in1(-x)-1)*(2-in2(-x,-1)*3))/(-in1(in1(-x)*2-3)*3-5)/(in1(-x-1)*3-5)+(-(-in1(-1-x))*(-(-(-in1(-x)*2+5)))*(-in1(x+1)))
//in2(-x,x)+2*in2(x,-x)/(-in2(-x-1,x+1)-5*in2(x+1,-x-1)*in1(in2(x+1,-x-1)))*(in1(in2(x+1,-x-1))-in1(in2(1-2*in1(-x-1),-1-x)))-in2(x+1,2*in1(-x)-1)/(-(-3*in2(1-2*in1(-x-1),-1-x)))*((-2*in2(in1(x+1)*2-1,-1-2*in1(x+1))-(-5*in2(-in1(x+1)*2-1,1-in1(-x-1)*2))))
//in2(-x,x)+2*in2(x,-x)/(-in2(-x-1,x+1)-5*in2(x+1,-x-1)*in1(in2(x+1,-x-1)))*(in1(in2(x+1,-x-1))-in1(in2(1-2*in1(-x-1),-1-x)))-in2(x+1,2*in1(-x)-1)/(-(-3*in2(1-2*in1(-x-1),-1-x)))*((-2*in2(in1(x+1)*2-1,-1-2*in1(x+1))-(-5*in2(-in1(x+1)*2-1,1-in1(-x-1)*2))))+(-in2(-x,x)+(7-3*in2(x,-x)-5)/(-in2(-x-1,x+1))/in2(x+1,-x-1))/(-9/in2(1-2*in1(-x-1),-1-x)-in1(-7*in2(x+1,2*in1(-x)-1))-3)+(-in1(-in2(in1(x+1)*2-1,-1-2*in1(x+1))-7)+(3*in2(-in1(x+1)*2-1,1-in1(-x-1)*2)-5))

//in1(2*in1(-x-1)-1)-in1(-1-x)/((in1(2*in1(-x-1)-1)*3-5)+(-(-(-in1(-1+2*in1(-x-1)))))-(-in1(-2*in1(-x-1)+1)-5)*(in1(1-2*in1(-x-1))))+(-in1(2*in1(-x-1)-1)-5)*(-2*in1(1-2*in1(-x-1))-3)/(in1(-1+2*in1(-x-1))*3-in1(2*in1(-x-1)-1)*5)/in1(2*in1(-x-1)-1)-(-in1(2*in1(-x-1)-1)/in1(x+1))+in2(-x,x)+2*in2(x,-x)/(-in2(-x-1,x+1)-5*in2(x+1,-x-1)*in1(in2(x+1,-x-1)))*(in1(in2(x+1,-x-1))-in1(in2(1-2*in1(-x-1),-1-x)))-in2(x+1,2*in1(-x)-1)/(-(-3*in2(1-2*in1(-x-1),-1-x)))*((-2*in2(in1(x+1)*2-1,-1-2*in1(x+1))-(-5*in2(-in1(x+1)*2-1,1-in1(-x-1)*2))))+(-in2(-x,x)+(7-3*in2(x,-x)-5)/(-in2(-x-1,x+1))/in2(x+1,-x-1))/(-9/in2(1-2*in1(-x-1),-1-x)-in1(-7*in2(x+1,2*in1(-x)-1))-3)+(-in1(-in2(in1(x+1)*2-1,-1-2*in1(x+1))-7)+(3*in2(-in1(x+1)*2-1,1-in1(-x-1)*2)-5))
//sp1(2*sp1(-x-1)-1)-sp1(-1-x)/((sp1(2*sp1(-x-1)-1)*3-5)+(-(-(-sp1(-1+2*sp1(-x-1)))))-(-sp1(-2*sp1(-x-1)+1)-5)*(sp1(1-2*sp1(-x-1))))+(-sp1(2*sp1(-x-1)-1)-5)*(-2*sp1(1-2*sp1(-x-1))-3)/(sp1(-1+2*sp1(-x-1))*3-sp1(2*sp1(-x-1)-1)*5)/sp1(2*sp1(-x-1)-1)-(-sp1(2*sp1(-x-1)-1)/sp1(x+1))+sp2(-x,x)+2*sp2(x,-x)/(-sp2(-x-1,x+1)-5*sp2(x+1,-x-1)*sp1(sp2(x+1,-x-1)))*(sp1(sp2(x+1,-x-1))-sp1(sp2(1-2*sp1(-x-1),-1-x)))-sp2(x+1,2*sp1(-x)-1)/(-(-3*sp2(1-2*sp1(-x-1),-1-x)))*((-2*sp2(sp1(x+1)*2-1,-1-2*sp1(x+1))-(-5*sp2(-sp1(x+1)*2-1,1-sp1(-x-1)*2))))+(-sp2(-x,x)+(7-3*sp2(x,-x)-5)/(-sp2(-x-1,x+1))/sp2(x+1,-x-1))/(-9/sp2(1-2*sp1(-x-1),-1-x)-sp1(-7*sp2(x+1,2*sp1(-x)-1))-3)+(-sp1(-sp2(sp1(x+1)*2-1,-1-2*sp1(x+1))-7)+(3*sp2(-sp1(x+1)*2-1,1-sp1(-x-1)*2)-5))

//in1(-x)/(-(-(-1-in2(-1-x,in1(x))))-in1(-in1(-x)-1)*(2-in2(-x,-1)*3))/(-in1(in1(-x)*2-3)*3-5)/(in1(-x-1)*3-5)+(-(-in1(-1-x))*(-(-(-in1(-x)*2+5)))*(-in1(x+1)))+in1(2*in1(-x-1)-1)-in1(-1-x)/((in1(2*in1(-x-1)-1)*3-5)+(-(-(-in1(-1+2*in1(-x-1)))))-(-in1(-2*in1(-x-1)+1)-5)*(in1(1-2*in1(-x-1))))+(-in1(2*in1(-x-1)-1)-5)*(-2*in1(1-2*in1(-x-1))-3)/(in1(-1+2*in1(-x-1))*3-in1(2*in1(-x-1)-1)*5)/in1(2*in1(-x-1)-1)-(-in1(2*in1(-x-1)-1)/in1(x+1))+in2(-x,x)+2*in2(x,-x)/(-in2(-x-1,x+1)-5*in2(x+1,-x-1)*in1(in2(x+1,-x-1)))*(in1(in2(x+1,-x-1))-in1(in2(1-2*in1(-x-1),-1-x)))-in2(x+1,2*in1(-x)-1)/(-(-3*in2(1-2*in1(-x-1),-1-x)))*((-2*in2(in1(x+1)*2-1,-1-2*in1(x+1))-(-5*in2(-in1(x+1)*2-1,1-in1(-x-1)*2))))+(-in2(-x,x)+(7-3*in2(x,-x)-5)/(-in2(-x-1,x+1))/in2(x+1,-x-1))/(-9/in2(1-2*in1(-x-1),-1-x)-in1(-7*in2(x+1,2*in1(-x)-1))-3)+(-in1(-in2(in1(x+1)*2-1,-1-2*in1(x+1))-7)+(3*in2(-in1(x+1)*2-1,1-in1(-x-1)*2)-5))
//kf1(-x)/(-(-(-1-kf2(-1-x,kf1(x))))-kf1(-kf1(-x)-1)*(2-kf2(-x,-1)*3))/(-kf1(kf1(-x)*2-3)*3-5)/(kf1(-x-1)*3-5)+(-(-kf1(-1-x))*(-(-(-kf1(-x)*2+5)))*(-kf1(x+1)))+kf1(2*kf1(-x-1)-1)-kf1(-1-x)/((kf1(2*kf1(-x-1)-1)*3-5)+(-(-(-kf1(-1+2*kf1(-x-1)))))-(-kf1(-2*kf1(-x-1)+1)-5)*(kf1(1-2*kf1(-x-1))))+(-kf1(2*kf1(-x-1)-1)-5)*(-2*kf1(1-2*kf1(-x-1))-3)/(kf1(-1+2*kf1(-x-1))*3-kf1(2*kf1(-x-1)-1)*5)/kf1(2*kf1(-x-1)-1)-(-kf1(2*kf1(-x-1)-1)/kf1(x+1))+kf2(-x,x)+2*kf2(x,-x)/(-kf2(-x-1,x+1)-5*kf2(x+1,-x-1)*kf1(kf2(x+1,-x-1)))*(kf1(kf2(x+1,-x-1))-kf1(kf2(1-2*kf1(-x-1),-1-x)))-kf2(x+1,2*kf1(-x)-1)/(-(-3*kf2(1-2*kf1(-x-1),-1-x)))*((-2*kf2(kf1(x+1)*2-1,-1-2*kf1(x+1))-(-5*kf2(-kf1(x+1)*2-1,1-kf1(-x-1)*2))))+(-kf2(-x,x)+(7-3*kf2(x,-x)-5)/(-kf2(-x-1,x+1))/kf2(x+1,-x-1))/(-9/kf2(1-2*kf1(-x-1),-1-x)-kf1(-7*kf2(x+1,2*kf1(-x)-1))-3)+(-kf1(-kf2(kf1(x+1)*2-1,-1-2*kf1(x+1))-7)+(3*kf2(-kf1(x+1)*2-1,1-kf1(-x-1)*2)-5))
//fp1(-x)/(-(-(-1-fp2(-1-x,fp1(x))))-fp1(-fp1(-x)-1)*(2-fp2(-x,-1)*3))/(-fp1(fp1(-x)*2-3)*3-5)/(fp1(-x-1)*3-5)+(-(-fp1(-1-x))*(-(-(-fp1(-x)*2+5)))*(-fp1(x+1)))+fp1(2*fp1(-x-1)-1)-fp1(-1-x)/((fp1(2*fp1(-x-1)-1)*3-5)+(-(-(-fp1(-1+2*fp1(-x-1)))))-(-fp1(-2*fp1(-x-1)+1)-5)*(fp1(1-2*fp1(-x-1))))+(-fp1(2*fp1(-x-1)-1)-5)*(-2*fp1(1-2*fp1(-x-1))-3)/(fp1(-1+2*fp1(-x-1))*3-fp1(2*fp1(-x-1)-1)*5)/fp1(2*fp1(-x-1)-1)-(-fp1(2*fp1(-x-1)-1)/fp1(x+1))+fp2(-x,x)+2*fp2(x,-x)/(-fp2(-x-1,x+1)-5*fp2(x+1,-x-1)*fp1(fp2(x+1,-x-1)))*(fp1(fp2(x+1,-x-1))-fp1(fp2(1-2*fp1(-x-1),-1-x)))-fp2(x+1,2*fp1(-x)-1)/(-(-3*fp2(1-2*fp1(-x-1),-1-x)))*((-2*fp2(fp1(x+1)*2-1,-1-2*fp1(x+1))-(-5*fp2(-fp1(x+1)*2-1,1-fp1(-x-1)*2))))+(-fp2(-x,x)+(7-3*fp2(x,-x)-5)/(-fp2(-x-1,x+1))/fp2(x+1,-x-1))/(-9/fp2(1-2*fp1(-x-1),-1-x)-fp1(-7*fp2(x+1,2*fp1(-x)-1))-3)+(-fp1(-fp2(fp1(x+1)*2-1,-1-2*fp1(x+1))-7)+(3*fp2(-fp1(x+1)*2-1,1-fp1(-x-1)*2)-5))
//ma1(-x)/(-(-(-1-ma2(-1-x,ma1(x))))-ma1(-ma1(-x)-1)*(2-ma2(-x,-1)*3))/(-ma1(ma1(-x)*2-3)*3-5)/(ma1(-x-1)*3-5)+(-(-ma1(-1-x))*(-(-(-ma1(-x)*2+5)))*(-ma1(x+1)))+ma1(2*ma1(-x-1)-1)-ma1(-1-x)/((ma1(2*ma1(-x-1)-1)*3-5)+(-(-(-ma1(-1+2*ma1(-x-1)))))-(-ma1(-2*ma1(-x-1)+1)-5)*(ma1(1-2*ma1(-x-1))))+(-ma1(2*ma1(-x-1)-1)-5)*(-2*ma1(1-2*ma1(-x-1))-3)/(ma1(-1+2*ma1(-x-1))*3-ma1(2*ma1(-x-1)-1)*5)/ma1(2*ma1(-x-1)-1)-(-ma1(2*ma1(-x-1)-1)/ma1(x+1))+ma2(-x,x)+2*ma2(x,-x)/(-ma2(-x-1,x+1)-5*ma2(x+1,-x-1)*ma1(ma2(x+1,-x-1)))*(ma1(ma2(x+1,-x-1))-ma1(ma2(1-2*ma1(-x-1),-1-x)))-ma2(x+1,2*ma1(-x)-1)/(-(-3*ma2(1-2*ma1(-x-1),-1-x)))*((-2*ma2(ma1(x+1)*2-1,-1-2*ma1(x+1))-(-5*ma2(-ma1(x+1)*2-1,1-ma1(-x-1)*2))))+(-ma2(-x,x)+(7-3*ma2(x,-x)-5)/(-ma2(-x-1,x+1))/ma2(x+1,-x-1))/(-9/ma2(1-2*ma1(-x-1),-1-x)-ma1(-7*ma2(x+1,2*ma1(-x)-1))-3)+(-ma1(-ma2(ma1(x+1)*2-1,-1-2*ma1(x+1))-7)+(3*ma2(-ma1(x+1)*2-1,1-ma1(-x-1)*2)-5))
//ms1(-x)/(-(-(-1-ms2(-1-x,ms1(x))))-ms1(-ms1(-x)-1)*(2-ms2(-x,-1)*3))/(-ms1(ms1(-x)*2-3)*3-5)/(ms1(-x-1)*3-5)+(-(-ms1(-1-x))*(-(-(-ms1(-x)*2+5)))*(-ms1(x+1)))+ms1(2*ms1(-x-1)-1)-ms1(-1-x)/((ms1(2*ms1(-x-1)-1)*3-5)+(-(-(-ms1(-1+2*ms1(-x-1)))))-(-ms1(-2*ms1(-x-1)+1)-5)*(ms1(1-2*ms1(-x-1))))+(-ms1(2*ms1(-x-1)-1)-5)*(-2*ms1(1-2*ms1(-x-1))-3)/(ms1(-1+2*ms1(-x-1))*3-ms1(2*ms1(-x-1)-1)*5)/ms1(2*ms1(-x-1)-1)-(-ms1(2*ms1(-x-1)-1)/ms1(x+1))+ms2(-x,x)+2*ms2(x,-x)/(-ms2(-x-1,x+1)-5*ms2(x+1,-x-1)*ms1(ms2(x+1,-x-1)))*(ms1(ms2(x+1,-x-1))-ms1(ms2(1-2*ms1(-x-1),-1-x)))-ms2(x+1,2*ms1(-x)-1)/(-(-3*ms2(1-2*ms1(-x-1),-1-x)))*((-2*ms2(ms1(x+1)*2-1,-1-2*ms1(x+1))-(-5*ms2(-ms1(x+1)*2-1,1-ms1(-x-1)*2))))+(-ms2(-x,x)+(7-3*ms2(x,-x)-5)/(-ms2(-x-1,x+1))/ms2(x+1,-x-1))/(-9/ms2(1-2*ms1(-x-1),-1-x)-ms1(-7*ms2(x+1,2*ms1(-x)-1))-3)+(-ms1(-ms2(ms1(x+1)*2-1,-1-2*ms1(x+1))-7)+(3*ms2(-ms1(x+1)*2-1,1-ms1(-x-1)*2)-5))
//pc1(-x)/(-(-(-1-pc2(-1-x,pc1(x))))-pc1(-pc1(-x)-1)*(2-pc2(-x,-1)*3))/(-pc1(pc1(-x)*2-3)*3-5)/(pc1(-x-1)*3-5)+(-(-pc1(-1-x))*(-(-(-pc1(-x)*2+5)))*(-pc1(x+1)))+pc1(2*pc1(-x-1)-1)-pc1(-1-x)/((pc1(2*pc1(-x-1)-1)*3-5)+(-(-(-pc1(-1+2*pc1(-x-1)))))-(-pc1(-2*pc1(-x-1)+1)-5)*(pc1(1-2*pc1(-x-1))))+(-pc1(2*pc1(-x-1)-1)-5)*(-2*pc1(1-2*pc1(-x-1))-3)/(pc1(-1+2*pc1(-x-1))*3-pc1(2*pc1(-x-1)-1)*5)/pc1(2*pc1(-x-1)-1)-(-pc1(2*pc1(-x-1)-1)/pc1(x+1))+pc2(-x,x)+2*pc2(x,-x)/(-pc2(-x-1,x+1)-5*pc2(x+1,-x-1)*pc1(pc2(x+1,-x-1)))*(pc1(pc2(x+1,-x-1))-pc1(pc2(1-2*pc1(-x-1),-1-x)))-pc2(x+1,2*pc1(-x)-1)/(-(-3*pc2(1-2*pc1(-x-1),-1-x)))*((-2*pc2(pc1(x+1)*2-1,-1-2*pc1(x+1))-(-5*pc2(-pc1(x+1)*2-1,1-pc1(-x-1)*2))))+(-pc2(-x,x)+(7-3*pc2(x,-x)-5)/(-pc2(-x-1,x+1))/pc2(x+1,-x-1))/(-9/pc2(1-2*pc1(-x-1),-1-x)-pc1(-7*pc2(x+1,2*pc1(-x)-1))-3)+(-pc1(-pc2(pc1(x+1)*2-1,-1-2*pc1(x+1))-7)+(3*pc2(-pc1(x+1)*2-1,1-pc1(-x-1)*2)-5))
//sp1(-x)/(-(-(-1-sp2(-1-x,sp1(x))))-sp1(-sp1(-x)-1)*(2-sp2(-x,-1)*3))/(-sp1(sp1(-x)*2-3)*3-5)/(sp1(-x-1)*3-5)+(-(-sp1(-1-x))*(-(-(-sp1(-x)*2+5)))*(-sp1(x+1)))+sp1(2*sp1(-x-1)-1)-sp1(-1-x)/((sp1(2*sp1(-x-1)-1)*3-5)+(-(-(-sp1(-1+2*sp1(-x-1)))))-(-sp1(-2*sp1(-x-1)+1)-5)*(sp1(1-2*sp1(-x-1))))+(-sp1(2*sp1(-x-1)-1)-5)*(-2*sp1(1-2*sp1(-x-1))-3)/(sp1(-1+2*sp1(-x-1))*3-sp1(2*sp1(-x-1)-1)*5)/sp1(2*sp1(-x-1)-1)-(-sp1(2*sp1(-x-1)-1)/sp1(x+1))+sp2(-x,x)+2*sp2(x,-x)/(-sp2(-x-1,x+1)-5*sp2(x+1,-x-1)*sp1(sp2(x+1,-x-1)))*(sp1(sp2(x+1,-x-1))-sp1(sp2(1-2*sp1(-x-1),-1-x)))-sp2(x+1,2*sp1(-x)-1)/(-(-3*sp2(1-2*sp1(-x-1),-1-x)))*((-2*sp2(sp1(x+1)*2-1,-1-2*sp1(x+1))-(-5*sp2(-sp1(x+1)*2-1,1-sp1(-x-1)*2))))+(-sp2(-x,x)+(7-3*sp2(x,-x)-5)/(-sp2(-x-1,x+1))/sp2(x+1,-x-1))/(-9/sp2(1-2*sp1(-x-1),-1-x)-sp1(-7*sp2(x+1,2*sp1(-x)-1))-3)+(-sp1(-sp2(sp1(x+1)*2-1,-1-2*sp1(x+1))-7)+(3*sp2(-sp1(x+1)*2-1,1-sp1(-x-1)*2)-5))
//ps1(-x)/(-(-(-1-ps2(-1-x,ps1(x))))-ps1(-ps1(-x)-1)*(2-ps2(-x,-1)*3))/(-ps1(ps1(-x)*2-3)*3-5)/(ps1(-x-1)*3-5)+(-(-ps1(-1-x))*(-(-(-ps1(-x)*2+5)))*(-ps1(x+1)))+ps1(2*ps1(-x-1)-1)-ps1(-1-x)/((ps1(2*ps1(-x-1)-1)*3-5)+(-(-(-ps1(-1+2*ps1(-x-1)))))-(-ps1(-2*ps1(-x-1)+1)-5)*(ps1(1-2*ps1(-x-1))))+(-ps1(2*ps1(-x-1)-1)-5)*(-2*ps1(1-2*ps1(-x-1))-3)/(ps1(-1+2*ps1(-x-1))*3-ps1(2*ps1(-x-1)-1)*5)/ps1(2*ps1(-x-1)-1)-(-ps1(2*ps1(-x-1)-1)/ps1(x+1))+ps2(-x,x)+2*ps2(x,-x)/(-ps2(-x-1,x+1)-5*ps2(x+1,-x-1)*ps1(ps2(x+1,-x-1)))*(ps1(ps2(x+1,-x-1))-ps1(ps2(1-2*ps1(-x-1),-1-x)))-ps2(x+1,2*ps1(-x)-1)/(-(-3*ps2(1-2*ps1(-x-1),-1-x)))*((-2*ps2(ps1(x+1)*2-1,-1-2*ps1(x+1))-(-5*ps2(-ps1(x+1)*2-1,1-ps1(-x-1)*2))))+(-ps2(-x,x)+(7-3*ps2(x,-x)-5)/(-ps2(-x-1,x+1))/ps2(x+1,-x-1))/(-9/ps2(1-2*ps1(-x-1),-1-x)-ps1(-7*ps2(x+1,2*ps1(-x)-1))-3)+(-ps1(-ps2(ps1(x+1)*2-1,-1-2*ps1(x+1))-7)+(3*ps2(-ps1(x+1)*2-1,1-ps1(-x-1)*2)-5))


//(-sp1(-(-x)/(-t))-(-sp2(-(-sp2(-x,-x-t)-sp2(-sp1(-1.1-x),-(-1.2-sp2(-x-1.3,-y-1.4)*(-1.5)))/sp1(-1.7-x)),-(-1.8-(-x-1.9/(-t-2.1))))))*(-2.2-x*(-2.3-(-y-(-2.4-(-y-x)))/(2.5*x*y*sp2(2.8,-2.9-x)*t/(-2.6-(2.7*x)))))*(sp1(3.1)*sp1(3.2)/sp2(3.3,3.4)-x/(-x*3.5*y*(-3.6)-3.8))+x*(-1.1-y*(2.3*sp2(-1.1,x+y)-sp2(-y,1.1)/2.3)*t)*(-sp2(1.1,x+y)*3.3-sp1(-1.7-x)/(3.5)+sp1(-1.1-x)*(-3.9)-sp2(sp2(1.1,x+y)*7.1,sp2(-y,1.1)/2.5))*((sp2(-sp2(-1.1,x+y)*5.1,-sp2(-1.1,x+y)*3.1-7.9))+sp2(-sp2(-y,1.1)/3.2,-5.7-sp2(-y,1.1)*2.9))
//(-ps1(-(-x)/(-t))-(-ps2(-(-ps2(-x,-x-t)-ps2(-ps1(-1.1-x),-(-1.2-ps2(-x-1.3,-y-1.4)*(-1.5)))/ps1(-1.7-x)),-(-1.8-(-x-1.9/(-t-2.1))))))*(-2.2-x*(-2.3-(-y-(-2.4-(-y-x)))/(2.5*x*y*ps2(2.8,-2.9-x)*t/(-2.6-(2.7*x)))))*(ps1(3.1)*ps1(3.2)/ps2(3.3,3.4)-x/(-x*3.5*y*(-3.6)-3.8))+x*(-1.1-y*(2.3*ps2(-1.1,x+y)-ps2(-y,1.1)/2.3)*t)*(-ps2(1.1,x+y)*3.3-ps1(-1.7-x)/(3.5)+ps1(-1.1-x)*(-3.9)-ps2(ps2(1.1,x+y)*7.1,ps2(-y,1.1)/2.5))*((ps2(-ps2(-1.1,x+y)*5.1,-ps2(-1.1,x+y)*3.1-7.9))+ps2(-ps2(-y,1.1)/3.2,-5.7-ps2(-y,1.1)*2.9))
//(-kf1(-(-x)/(-t))-(-kf2(-(-kf2(-x,-x-t)-kf2(-kf1(-1.1-x),-(-1.2-kf2(-x-1.3,-y-1.4)*(-1.5)))/kf1(-1.7-x)),-(-1.8-(-x-1.9/(-t-2.1))))))*(-2.2-x*(-2.3-(-y-(-2.4-(-y-x)))/(2.5*x*y*kf2(2.8,-2.9-x)*t/(-2.6-(2.7*x)))))*(kf1(3.1)*kf1(3.2)/kf2(3.3,3.4)-x/(-x*3.5*y*(-3.6)-3.8))+x*(-1.1-y*(2.3*kf2(-1.1,x+y)-kf2(-y,1.1)/2.3)*t)*(-kf2(1.1,x+y)*3.3-kf1(-1.7-x)/(3.5)+kf1(-1.1-x)*(-3.9)-kf2(kf2(1.1,x+y)*7.1,kf2(-y,1.1)/2.5))*((kf2(-kf2(-1.1,x+y)*5.1,-kf2(-1.1,x+y)*3.1-7.9))+kf2(-kf2(-y,1.1)/3.2,-5.7-kf2(-y,1.1)*2.9))
//(-in1(-(-x)/(-t))-(-in2(-(-in2(-x,-x-t)-in2(-in1(-1.1-x),-(-1.2-in2(-x-1.3,-y-1.4)*(-1.5)))/in1(-1.7-x)),-(-1.8-(-x-1.9/(-t-2.1))))))*(-2.2-x*(-2.3-(-y-(-2.4-(-y-x)))/(2.5*x*y*in2(2.8,-2.9-x)*t/(-2.6-(2.7*x)))))*(in1(3.1)*in1(3.2)/in2(3.3,3.4)-x/(-x*3.5*y*(-3.6)-3.8))+x*(-1.1-y*(2.3*in2(-1.1,x+y)-in2(-y,1.1)/2.3)*t)*(-in2(1.1,x+y)*3.3-in1(-1.7-x)/(3.5)+in1(-1.1-x)*(-3.9)-in2(in2(1.1,x+y)*7.1,in2(-y,1.1)/2.5))*((in2(-in2(-1.1,x+y)*5.1,-in2(-1.1,x+y)*3.1-7.9))+in2(-in2(-y,1.1)/3.2,-5.7-in2(-y,1.1)*2.9))
//(-fp1(-(-x)/(-t))-(-fp2(-(-fp2(-x,-x-t)-fp2(-fp1(-1.1-x),-(-1.2-fp2(-x-1.3,-y-1.4)*(-1.5)))/fp1(-1.7-x)),-(-1.8-(-x-1.9/(-t-2.1))))))*(-2.2-x*(-2.3-(-y-(-2.4-(-y-x)))/(2.5*x*y*fp2(2.8,-2.9-x)*t/(-2.6-(2.7*x)))))*(fp1(3.1)*fp1(3.2)/fp2(3.3,3.4)-x/(-x*3.5*y*(-3.6)-3.8))+x*(-1.1-y*(2.3*fp2(-1.1,x+y)-fp2(-y,1.1)/2.3)*t)*(-fp2(1.1,x+y)*3.3-fp1(-1.7-x)/(3.5)+fp1(-1.1-x)*(-3.9)-fp2(fp2(1.1,x+y)*7.1,fp2(-y,1.1)/2.5))*((fp2(-fp2(-1.1,x+y)*5.1,-fp2(-1.1,x+y)*3.1-7.9))+fp2(-fp2(-y,1.1)/3.2,-5.7-fp2(-y,1.1)*2.9))
//(-ms1(-(-x)/(-t))-(-ms2(-(-ms2(-x,-x-t)-ms2(-ms1(-1.1-x),-(-1.2-ms2(-x-1.3,-y-1.4)*(-1.5)))/ms1(-1.7-x)),-(-1.8-(-x-1.9/(-t-2.1))))))*(-2.2-x*(-2.3-(-y-(-2.4-(-y-x)))/(2.5*x*y*ms2(2.8,-2.9-x)*t/(-2.6-(2.7*x)))))*(ms1(3.1)*ms1(3.2)/ms2(3.3,3.4)-x/(-x*3.5*y*(-3.6)-3.8))+x*(-1.1-y*(2.3*ms2(-1.1,x+y)-ms2(-y,1.1)/2.3)*t)*(-ms2(1.1,x+y)*3.3-ms1(-1.7-x)/(3.5)+ms1(-1.1-x)*(-3.9)-ms2(ms2(1.1,x+y)*7.1,ms2(-y,1.1)/2.5))*((ms2(-ms2(-1.1,x+y)*5.1,-ms2(-1.1,x+y)*3.1-7.9))+ms2(-ms2(-y,1.1)/3.2,-5.7-ms2(-y,1.1)*2.9))


//((sp3(x/y,-y/x,-sp2(-x/(x+y),y/(x-y))*2.1)-sp2(-sp1(-y/(y-x))/(x-y/(x-y)),-sp2(x/sp1(x/y),-y/sp1(-y/x))/(x/y-y/x)))/(x/(1.5-sp1(x/(x-y)))-sp2(-x/y,-y/(x+y))/sp3(x/(x+y),-y/(x+y),-2.5+3.1*sp1(x/(x-y)))))/(sp3(x/sp2(x/sp1(x/y),-y/sp1(-y/x)),y/sp2(-x/(x+y),y/(x-y)),-2.5/sp1(x/(x-y)))-sp3(sp1(-y/(y-x))*3.1,sp1(1.5-2.1*sp1(x/(x-y))),sp2(x/y,y/(x+y))/sp2(-x/y,-y/(x+y)))+sp2(3.5-1.7*sp3(x/y,-y/x,-sp2(-x/(x+y),y/(x-y))),3.9-sp1(-y/(y-x))/sp1(-y/x))*sp3(sp2(x/sp1(-y/(x-y)),-sp2(-x/y,-y/(x+y))),sp1(x/(x-y))/sp2(-x/y,-y/(x+y)),sp1(-x/(x-y))/sp1(-y/(x-y))))
//((ps3(x/y,-y/x,-ps2(-x/(x+y),y/(x-y))*2.1)-ps2(-ps1(-y/(y-x))/(x-y/(x-y)),-ps2(x/ps1(x/y),-y/ps1(-y/x))/(x/y-y/x)))/(x/(1.5-ps1(x/(x-y)))-ps2(-x/y,-y/(x+y))/ps3(x/(x+y),-y/(x+y),-2.5+3.1*ps1(x/(x-y)))))/(ps3(x/ps2(x/ps1(x/y),-y/ps1(-y/x)),y/ps2(-x/(x+y),y/(x-y)),-2.5/ps1(x/(x-y)))-ps3(ps1(-y/(y-x))*3.1,ps1(1.5-2.1*ps1(x/(x-y))),ps2(x/y,y/(x+y))/ps2(-x/y,-y/(x+y)))+ps2(3.5-1.7*ps3(x/y,-y/x,-ps2(-x/(x+y),y/(x-y))),3.9-ps1(-y/(y-x))/ps1(-y/x))*ps3(ps2(x/ps1(-y/(x-y)),-ps2(-x/y,-y/(x+y))),ps1(x/(x-y))/ps2(-x/y,-y/(x+y)),ps1(-x/(x-y))/ps1(-y/(x-y))))
//((ms3(x/y,-y/x,-ms2(-x/(x+y),y/(x-y))*2.1)-ms2(-ms1(-y/(y-x))/(x-y/(x-y)),-ms2(x/ms1(x/y),-y/ms1(-y/x))/(x/y-y/x)))/(x/(1.5-ms1(x/(x-y)))-ms2(-x/y,-y/(x+y))/ms3(x/(x+y),-y/(x+y),-2.5+3.1*ms1(x/(x-y)))))/(ms3(x/ms2(x/ms1(x/y),-y/ms1(-y/x)),y/ms2(-x/(x+y),y/(x-y)),-2.5/ms1(x/(x-y)))-ms3(ms1(-y/(y-x))*3.1,ms1(1.5-2.1*ms1(x/(x-y))),ms2(x/y,y/(x+y))/ms2(-x/y,-y/(x+y)))+ms2(3.5-1.7*ms3(x/y,-y/x,-ms2(-x/(x+y),y/(x-y))),3.9-ms1(-y/(y-x))/ms1(-y/x))*ms3(ms2(x/ms1(-y/(x-y)),-ms2(-x/y,-y/(x+y))),ms1(x/(x-y))/ms2(-x/y,-y/(x+y)),ms1(-x/(x-y))/ms1(-y/(x-y))))
//((pc3(x/y,-y/x,-pc2(-x/(x+y),y/(x-y))*2.1)-pc2(-pc1(-y/(y-x))/(x-y/(x-y)),-pc2(x/pc1(x/y),-y/pc1(-y/x))/(x/y-y/x)))/(x/(1.5-pc1(x/(x-y)))-pc2(-x/y,-y/(x+y))/pc3(x/(x+y),-y/(x+y),-2.5+3.1*pc1(x/(x-y)))))/(pc3(x/pc2(x/pc1(x/y),-y/pc1(-y/x)),y/pc2(-x/(x+y),y/(x-y)),-2.5/pc1(x/(x-y)))-pc3(pc1(-y/(y-x))*3.1,pc1(1.5-2.1*pc1(x/(x-y))),pc2(x/y,y/(x+y))/pc2(-x/y,-y/(x+y)))+pc2(3.5-1.7*pc3(x/y,-y/x,-pc2(-x/(x+y),y/(x-y))),3.9-pc1(-y/(y-x))/pc1(-y/x))*pc3(pc2(x/pc1(-y/(x-y)),-pc2(-x/y,-y/(x+y))),pc1(x/(x-y))/pc2(-x/y,-y/(x+y)),pc1(-x/(x-y))/pc1(-y/(x-y))))

/*

vd:array double=0; L:int=1000000; setlen(vd,rand(0,L)); for(i,0,len(vd)-1,vd[i]=i); x=sum(vd); setlen(vd,0); x
MinSize:int=1000; MaxSize:int=100000; vd:arrayDbl=0; Sum:ext=0; n:int=0; k:int=0;  itr:int=10; SumVD:Ext=0; for(k,0,itr, SetLen(vd,rnd(MinSize,MaxSize)); L:int=Len(vd); for(n,0,L-1,vd[n]=n; Sum=Sum+n); SumVD=SumVD+sum(vd)); SetLen(vd,0); Sum/SumVD

*/






private: System::Void textBox1_TextChanged(System::Object^  sender, System::EventArgs^  e) {
		 }
private: System::Void textBox4_TextChanged(System::Object^  sender, System::EventArgs^  e) {
		 }
private: System::Void button2_Click(System::Object^  sender, System::EventArgs^  e)
		 {
			 _int32       Error;
             TStringType Expr;
			 _int32 IDF;


	        Expr = E_EF->Text;
           

		    flSetFunction(Expr,0,IDF);
            flGetErrorCode(Error);
            if (Error != 0) { ShowError();}
		 }
private: System::Void LR_Click(System::Object^  sender, System::EventArgs^  e) {
		 }









private: System::Void button3_Click(System::Object^  sender, System::EventArgs^  e) 

{

   Pointer32 Func1;
   Pointer32 PS;
   double res;

   TStringType Expr,ErStr;
   Int32 ECode,ct,rt;
   String  ^DiffStr;
   _int32  ni,NC,T1,T2,nd;
   _int32       FpuExc;
   


//*****************************************************************************

   SetVarValue();

   //NC = 10000000;
    
   res = 0;


   Func1 = NULL;



	Expr = EF->Text;



  nd=Convert::ToInt32(E_dx->Text);
  flCompileDiff(Expr, nd, Func1);

  if (CB_OM->Checked) { NC=1;} else {NC = Convert::ToInt32(ENC->Text);};

  flGetErrorCode(ECode);

   if ((CB_DS->Checked) && (ECode == 0))
   {
	 flGetDiffString(PS);  
	 ConvStr(PS,DiffStr);
	 MessageBox::Show(DiffStr, "derivative (d/dx)", MessageBoxButtons::OK, MessageBoxIcon::Information);
   } ;




  if (ECode != 0)
  {
	  ShowError();
  }
  else
  {
   
	   flPerform(fl_MASK_FPU_EXCEPTION,0);

	   T1=GetTickCount();
	   for(ni = 0; ni <= NC; ni++)
	   {

		 //flResultD(Func1,res);
		 res=ResultF(Func1);
		
       }
	   T2=GetTickCount();


  LDR->Text=res.ToString();

   if ((T2-T1) != 0)
	   { LDPf->Text=Convert::ToString((Int32)(NC/(T2-T1))); }
	   else { LDPf->Text="no defined" ; };




  flPerform(fl_FREE,(Int32)Func1);

  flGet(fl_IS_FPU_EXCEPTION,0,FpuExc);
  if(FpuExc == fl_YES)
	 {
		  LDR->Text="Invalid operation";		  
	 }

 }


endp: ;

}





private: System::Void radioButton1_CheckedChanged(System::Object^  sender, System::EventArgs^  e)
		 {
			 flSet(fl_DATA_TYPE,fl_DOUBLE,0);
		 }
private: System::Void radioButton2_CheckedChanged(System::Object^  sender, System::EventArgs^  e)
		 {
			 flSet(fl_DATA_TYPE,fl_EXTENDED,0);
		 }
private: System::Void radioButton3_CheckedChanged(System::Object^  sender, System::EventArgs^  e) 
		 {
			 flSet(fl_PARAM_TYPE,fl_DOUBLE,0);
		 }
private: System::Void radioButton4_CheckedChanged(System::Object^  sender, System::EventArgs^  e)
		 {
			 flSet(fl_PARAM_TYPE,fl_EXTENDED,0);
		 }




private: System::Void BSafeCalc_Click(System::Object^  sender, System::EventArgs^  e)
{
TStringType  Expr;
	     Pointer32    Func1;
		 String^      SExpr;
		 String^      SCE;
		 Pointer32    PExpr;
		 IntPtr       iptr;
		 PString      PStr;   
		 double       r,  res;
		 _int32       ECode,NC,ni,Prf,SZ,ct,rt;
		 unsigned long T1, T2;
		 Pointer32    adri1,vecd0;
		 PInteger     pint1; 
		 System::String^      S1r;
		 System::String^      S2r;
		 _int32       FpuExc;
		 

		 //***************************************************


	
		 SetVarValue() ;
		 
		
		 SExpr = EF->Text;
	
		  NC = Convert::ToInt32(ENC->Text);
          res=0;

		
  flSet(fl_ADDRESS_EXCEPTION_FLAG , _int32(&FpuExc),0);	//uses in flResultSafe, flResultDSafe

  Func1 = NULL;


  flCompile(SExpr, 0, Func1);
 



  if (CB_OM->Checked) { NC=1;} else {NC=Convert::ToInt32(ENC->Text);};

  flGetErrorCode(ECode);


  if (ECode != 0)
  {
	  ShowError();
  }
  else
  {
   flGet(fl_RETURN_NUMBER,Int32(Func1),rt);

   if (rt == fl_NO)            //no return number: return result in inner 'result' or 'res' variable  ( x1: ext=x+y; x1=x1*x; result=x1  )
   {
	       
	  T1=GetTickCount();

	  for(ni = 0; ni <= NC; ni++)
	  {

          /* 
		      res=sqrt(-x)
              res=x/sin(x-x)
		      x=10000; res=x^x
		   */
		FpuExc=ResultSafe(Func1);  //more fast then:
        //flResultSafe(Func1);
		if (FpuExc != 0) { goto endc;}
		
	  };
	 T2=GetTickCount();	

	 res=resf;

   }
   else
   {
	   	   
	   T1=GetTickCount();
	   for(ni = 0; ni <= NC; ni++)
	   {		
		   /* 
		       sqrt(-x)
               x/sin(x-x)
		       x=10000; x^x
		   */
		   FpuExc=ResultFSafe(Func1,res); //more fast then:
		   //flResultDSafe(Func1,res);
		   if (FpuExc != 0) { goto endc;}
				   
	   }
		T2=GetTickCount();			   		

  }


  LR->Text=res.ToString();

  if ((T2-T1) != 0)
	   { LPf->Text=Convert::ToString((Int32)(NC/(T2-T1))); }
	   else { LPf->Text="no defined" ; };


  endc:
  flPerform(fl_FREE,(Int32)Func1);
  
   if (FpuExc != 0) 
   {
	  LPf->Text=FpuExc.ToString();
	 
	   switch ( FpuExc)
      {
       case  1:    SCE="Invalid operation";break;          //  sqrt(-x)
	   case  4:    SCE="Divizion on Zero";break;           //  x/sin(x-x)
	   case  8:    SCE="Overflow in float point";break;    //  x=10000; x^x
	   default:    SCE="Invalid operation"; 
      }
	  LR->Text=SCE;
   }


  }
  



}





private: System::Void cb_FPUMask_Click(System::Object^  sender, System::EventArgs^  e) 
		 {
              if (cb_FPUMask->Checked) {  flSet(fl_ENABLE,fl_MASK_FPU_EXCEPTION,0);} else { flSet(fl_DISABLE,fl_MASK_FPU_EXCEPTION,0);};

		 }
private: System::Void cb_VirtAlloc_Click(System::Object^  sender, System::EventArgs^  e)
		 {
			  if (cb_VirtAlloc->Checked) {   flSet(fl_ENABLE,fl_USE_VIRTUAL_ALLOC,0);} else {  flSet(fl_DISABLE,fl_USE_VIRTUAL_ALLOC,0);};

		 }
};


}

