unit ForevalZ_Lib;
{******************************************************************************}
{                                                                              }
{                                 ver 1.3.5.231                                }
{----------------------------------------------------------------------------- }
{                ForevalZ_Lib -    ForevalZ.dll +         }
{       : for, while,...;   fz_PreCompiled;...   }
{                    DELPHI 7                 }
{------------------------------------------------------------------------------}
{              ForevalZ_Lib -  constructor of  interface of ForevalZ.dll +     }
{   parser of comand: for, while,...; compile of functions fz_PreCompiled;...  }
{                   Compile only since version DELPHI 7                        }
{------------------------------------------------------------------------------}
{                  SOREL   (C)CopyRight 2000. Russia, S.-Petersburg.           }
{******************************************************************************}

//Note:
{
rus:

      ( "dll")       "USEDLL".    "dll" !!!

   32 -   !!!
}

{
eng:

At direct connection to the program (without "dll") or compilation to package: to disable  key "USEDLL". At compilation in "dll" to set key !!!

Use only 32 bit compiler !!!
}

// {$RangeChecks On}
// {$OverFlowChecks On}
 //{$ZEROBASEDSTRINGS Off}

{$R-}
{$Q-}

{$IFDEF FPC}
   {$MODE DELPHI}
{$ENDIF}


{$DEFINE USEDLL}

{$IFNDEF USEDLL}
   {$DEFINE STRINGINT}
{$ENDIF}

interface

uses
ForevalZ_Main, SysUtils, StrUtils, Math;

const c_pi:extended = 3.1415926535897932384626433832795;

const _VMAJOR: integer   = 1;
const _VMINOR: integer   = 3;
const _VREALISE: integer = 5;
const _VBUILD: integer   = 231;


{$IFDEF FPC}
  const _COMPILED_BY: integer = 300; //4-Delphi4; ...; 7-Delphi7; ...;  12-Delphi2009; 13-Delphi2010; ...; 16-DelphiXE3;...; > 100 - FPC version
{$ELSE}
  const _COMPILED_BY: integer = 12; //4-Delphi4; ...; 7-Delphi7; ...;  12-Delphi2009; 13-Delphi2010; ...; 16-DelphiXE3;...; > 100 - FPC version
{$ENDIF}

const _S_ABOUT: String = 'ForevalZ - compiler of string mathematical expressions with complex numbers in "run-time" mode. (x86-32 CPU/FPU command set).  v.1.3.5.219.  Last compilations: xx.xx.2017. SoReL  -2000- CopyRight .Russia, S.-Petersburg';
const _S_AUTHOR: String = 'SOREL. CopyRight(C) -2000-. Russia, S.-Petersburg';
const _S_COMMENT: String = 'with FastMM4 v. 4.991 - only for delphi';


const
fz_DISABLE              = 0;
fz_ENABLE               = 1;
fz_REAL                 = 2;  //result type
fz_COMPLEX              = 3;  //result type
fz_REAL_DOUBLE          = 4;  //var type
fz_REAL_EXTENDED        = 5;  //var type
fz_REAL_INTEGER         = 6;  //var type
fz_COMPLEX_DOUBLE       = 7;  //var type
fz_COMPLEX_EXTENDED     = 8;  //var type
fz_ARRAY_REAL_DOUBLE    = 9;  //var type
fz_ARRAY_REAL_EXTENDED  = 10; //var type
fz_DIFFER_DOUBLE        = 11; //var type
fz_DIFFER_EXTENDED      = 12; //var type
fz_STACK_VAL            = 13; //call func
fz_STACK_ADR            = 14; //call func
fz_EAX                  = 15; //call func
fz_ESP                  = 16; //call func
fz_CDECL                = 17; //call type
fz_STDCALL              = 18; //call type
fz_PASCAL               = 19; //call type
fz_DOUBLE               = 20; //stack type
fz_EXTENDED             = 21; //stack type
fz_SHOW_EXCEPTION       = 22;
fz_OPTIMIZATION         = 23;
fz_STACK_TYPE           = 24;
fz_STACK_DEEP           = 25;
fz_CALC_TYPE            = 26;
fz_RESULT_TYPE          = 27;
fz_DIFFER               = 28;
fz_INFINITE             = 29;
fz_FREE                 = 30;
fz_CLEAR                = 31;
fz_VAR_LIST             = 32;
fz_CMPL_FUNC_LIST       = 33;
fz_STRING               = 32;
fz_STRING_UTF16         = 32;
fz_PCHAR                = 33;
fz_ANSISTRING           = 34;
fz_STRING_INTERNAL      = 35;
fz_UNKNOWN              = 36;
fz_STRING_TYPE          = 37;
fz_SYNTAX_EXTENSION     = 38;
fz_PRESENT_COMPLEX_NUMBER = 39;
fz_YES                  = 60;
fz_NO                   = 61;
fz_PRECOMPILED          = 62;
fz_COMPILE_STACK_DEEP   = 63;
fz_COMPILE_OVFL         = 64;
fz_DINAMIC_LOAD_NUM     = 65;
fz_PANSICHAR            = 66;
fz_PESENT_VAR           = 67;
fz_NONE                 = 68;  //result type
fz_WIDESTRING           = 69;
fz_ARRAY_LENGTH         = 70;
fz_VERSION                         = 71;
fz_MAJOR                           = 72;
fz_MINOR                           = 73;
fz_RELEASE                         = 74;
fz_ABOUT                           = 75;
fz_BUILD                           = 76;
fz_AUTHOR                          = 77;
fz_EXTENDED_COMMAND                = 78;
fz_STRING_UTF8                     = 79;
fz_ERROR_CODE                      = 80;
fz_ARRAY_REAL_INTEGER              = 81;
fz_SAVE                            = 82;
fz_RESTORE                         = 83;
fz_COMPILED_BY                     = 84;
fz_ENABLE_FUNCTION                 = 85;   {.191}
fz_DISABLE_FUNCTION                = 86;   {.191}
fz_REPLACE_FUNCTIONS               = 87;   {.193}
fz_REPLACE_FUNCTIONS_NUM           = 88;    {.193}
fz_REPLACE_DIV                     = 89;  {.193}
fz_REPLACE_MUL                     = 90;   {.193}
fz_REPLACE_ADDSUB                  = 91;   {.193}
fz_REPLACE_OPERATIONS              = 92;    {.193}
fz_REPLACE_OPERATIONS_NUM          = 93;    {.193}
fz_REPLACE_MULTI_EXPR              = 94;    {.193}
fz_USE_VIRTUAL_ALLOC               = 95;   //only for exe code
fz_LENGTH_CODE                     = 96;   {.193}
fz_SAVE_EAX                        = 97;   {.193}
fz_SAVE_EBX                        = 98;   {.193}
fz_SAVE_ECX                        = 99;   {.193}
fz_SAVE_EDX                        = 100;  {.193}
fz_SAVE_ESP                        = 101;   {.193}
fz_SAVE_EBP                        = 102;  {.193}
fz_SAVE_ESI                        = 103;  {.193}
fz_SAVE_EDI                        = 104;  {.193}
fz_ACCURATE_SPEC_FUNC              = 105;
fz_DINAMIC_LOAD                    = 106;
fz_CHECK_INCORRECT_SPACE           = 107; {.195}
fz_POWER_SYMBOL                    = 108; {.195}
fz_REPLACE_AT_IF                   = 109; {.197}
fz_LOAD_STACK_AFTER_CALC           = 110;  {.197}
fz_ADDRESS_OBJECT                  = 111;  {.197}
fz_FPU_CW                          = 112; {.203}
fz_FPU_CW_DEFAULT                  = 113; {.203} { = $1372 }
fz_FAST_DIV                        = 114; {.205}
fz_COMMENT                         = 115; {.213}
fz_ENABLE_REPLACE_FUNCTION         = 116; {.215}
fz_DISABLE_REPLACE_FUNCTION        = 117; {.215}
fz_ENABLE_CALC_CONST               = 118; {.215}
fz_DISABLE_CALC_CONST              = 119; {.215}
fz_REPLACE_COMPOSITE_FUNCTIONS                 = 120; {.217}
fz_REPLACE_COMPOSITE_FUNCTIONS_COMPLEX         = 121; {.217}
fz_REPLACE_COMPOSITE_FUNCTIONS_REAL            = 122; {.217}
fz_DISABLE_REPLACE_FUNCTION_COMPLEX            = 123; {.217}
fz_DISABLE_REPLACE_FUNCTION_REAL               = 124; {.217}
fz_ENABLE_REPLACE_FUNCTION_COMPLEX             = 125; {.217}
fz_ENABLE_REPLACE_FUNCTION_REAL                = 126; {.217}
fz_OPTIMIZATION_MUL_DIV                        = 127; {.217A}
fz_OPTIMIZATION_A1                             = 128;
fz_OPTIMIZATION_A2                             = 129;
fz_CALC_CONST_EXPRESSION                       = 130;
fz_LEAD_TO_LOWER_CASE                          = 131; {.221}
fz_SKIPPED_IF                                  = 132;  {.221}
fz_CALC_CONST_EXPR_IN_MULTI_EXPR               = 133;   {.221}
fz_PRECISION                                   = 134;
fz_MASK_FPU_EXCEPTION                          = 135;  {.229}
fz_CLEAR_FPU_EXCEPTION                         = 136;  {.229}
fz_IS_FPU_EXCEPTION                            = 137;  {.229}
fz_FREE_CODE_AT_REPLACE                        = 138; {.229}
fz_ADDRESS_EXCEPTION_FLAG                      = 139; {.231}





fz_UNKNOWN_SYMBOL                 = 40;
fz_MISSING_ROUND_BRACKET          = 41;
fz_MISSING_OPERATION              = 43;
fz_WRONG_NUMBER_ARGUMENTS         = 44;
fz_MISSING_EXPRESSION             = 45;
fz_UNKNOWN_FUNCTION               = 46;
fz_ERROR_AT_ADDITION_FUNCTION     = 47;
fz_NOT_DEFINED_OPERATOR           = 48;
fz_NOT_DEFINED_FUNCTION           = 49;
fz_INCORRECT_ARGUMENT             = 50;
fz_MISSING_ARGUMENT               = 51;
fz_INTERNAL_ERROR                 = 52;
fz_INCORRECT_TYPE                 = 53;
fz_MISSING_SEPARATOR              = 54;
fz_WRONG_NAME                     = 55;
fz_CALCULATION_ERROR              = 56;
fz_ABSENT_LOAD_FUNCTION_FOR_TYPE  = 57;
fz_MISSING_SQUARE_BRACKET         = 58;
fz_MISSING_CURLY_BRACKET          = 59;
fz_MISSING_ABS_BRACKET            = 60;
fz_WRONG_EXPRESSION               = 61;
fz_INCORRECT_SPACE                = 62;  {.195}
fz_VARIABLE_REDECLARED            = 63;  {.221}


fz_Power=4;
fz_Log=5;
fz_Abs=7;
fz_Arg=10;
fz_Sin=11;
fz_Cos=12;
fz_Tan=13;
fz_Cotan=14;
fz_ArcCos=15;
fz_ArcSin=16;
fz_ArcTan=17;
fz_ArcCotan=18;
fz_Sinh=19;
fz_Cosh=20;
fz_Tanh=21;
fz_Cotanh=22;
fz_ArcCosh=23;
fz_ArcSinh=24;
fz_ArcTanh=25;
fz_ArcCotanh=26;
fz_Ln=27;
fz_Exp=28;
fz_Sqr=29;
fz_Sqrt=30;
fz_Fact=31;
fz_Log10=32;
fz_Log2=33;
fz_Root=34;
fz_ArcTan2=70;



  //const _Single = 1;
  const _Double = 2;
  const _Extended = 3;
  const _Pointer = 5;


  const _Pascal = 1;
  const _StdCall = 2;
  const _Cdecl = 3;
  const _STACK_ADR = 1;
  const _STACK_VAL = 2;
  const _ESP = 4;
  const _EAX = 5;
  const _EBX = 6;
  const _ECX = 7;
  const _EDX = 8;
  const _Compiled = 9;


  const R_EAX = 1;
  const R_EBX = 2;
  const R_ECX = 3;
  const R_EDX = 4;
  const R_ESP = 5;
  const R_EBP = 6;
  const R_ESI = 7;
  const R_EDI = 8;
  const _CLEAR = 1;
  const _SAVE = 2;


const
S_c1: single = 1;

const S_c2: single = 2;

const S_c05: single = 0.5;

const S_c025: single = 0.25;
const S_cs2: Single = -2;
const NumberFact = 1754;

const E_CPId2: extended = 1.57079632679489662;{Pi/2;}
{const
 D_Real =         11;
 E_Real =         12;
 D_Complex =      13;
 E_Complex =      14;
 D_Any  =         15;
 E_Any =          16;
 D_Array_Real =   17;
 E_Array_Real  =  18;}

const
 _Complex  = 2; //=T_Complex  !!!
 _Real  = 1;    //=T_Real     !!!
 _Array = 3;  //=T_Array   !!!
 _Integer = 4; //=T_Integer

  const  T_Complex = 2;
  const  T_Real  = 1;
  const  T_Array = 3;
  const  T_Integer = 4;



type
TComplexD =  record
               re: double;
               im: double;
              end;

type
TComplexE = record
            re: extended;
            im: extended;
           end;

type
TByte32 = record
            re:  double;
            re2: double;
            im:  double;
            im2: double;
           end;

type
PComplexE = ^TComplexE;

type
PComplexD = ^TComplexD;


type TArrayC = array of Cardinal;
type TArrayI = array of Integer;
type PArrayI = ^TArrayI;
type TArrayD = array of Double;
type TArrayE = array of extended;
type PArrayD = ^TArrayD;
type PArrayE = ^TArrayE;
type TArrayB = array of byte;
type PArrayB = ^TArrayB;



type TFuncS = record
                SV: String;
                SF: String;
              end;

type
TFunctionZ = record
              Func: TFunction;
              R_Type: Integer;
              CmplOverFlow: Integer;
              CmplSDeep: Integer;
              DinLoadNMem: Integer;
              ReplFuncNum:  Integer;
              ReplOpNum: Integer;
              LoadStackAfterCalc: Integer;
             end;


type
TZAddFuncStruct = record
                    addr:  Pointer;
                CallType:  Cardinal;  //stdcall, cdecl, pascal
                     Arg:  Cardinal;
                 ArgType:  Cardinal;  //
             ArgTypeList:  Pointer;   //
                CallFunc:  Cardinal;
              ResultType:  Cardinal;
                 DeepFPU:  Cardinal;
               CalcConst:  Cardinal;
                 SaveReg:  Cardinal;
                ReplFunc:  Cardinal;   {.193}
                  Resrv2:  Cardinal;
                  Resrv3:  Cardinal;
                   end;

type
TArraySt = array of String;

type
   PInternalVar = ^TInternalVar;
   TInternalVar = record
                { TComplexE  TByte32: -   Delphi:    (    )
                  - TComplexE     10+10;
                     z: TComplexE; -    16+16 }
                Variable: TByte32; {.203} {internal complex extended use 16+16 instead 10+10:TComplexE}//TComplexE;  {.203}
                VecE: TArrayD;
                VecD: TArrayE;
                VecI: TArrayI;
                Name:  String;
                Next:  PInternalVar;
               end;



type TForevalZ_Custom = class(TForevalH) end;


        procedure fzCompile(Expr: {$IFDEF STRINGINT}String{$ELSE}Pointer{$ENDIF}; var Func: Pointer);             stdcall;
        procedure fzSetVar(Name: {$IFDEF STRINGINT}String{$ELSE}Pointer{$ENDIF}; Addr: Pointer; TV: Cardinal);    stdcall;
        procedure fzSetFunction(Name: {$IFDEF STRINGINT}String{$ELSE}Pointer{$ENDIF}; FAdr: Pointer);             stdcall;
        procedure fzSet(mode: Cardinal; value: Cardinal);                                                      stdcall;
        procedure fzGet(mode,subj: Cardinal; var value: Cardinal);                                             stdcall;
        procedure fzGetSyntaxErrorCode(var CError: Cardinal);                                                  stdcall;
        procedure fzGetSyntaxErrorString(var SError:{$IFDEF STRINGINT}String{$ELSE}Pointer{$ENDIF});              stdcall;
        procedure fzRenameFunction(Name,NewName: {$IFDEF STRINGINT}String{$ELSE}Pointer{$ENDIF});                 stdcall;
        procedure fzAddNameFunction(IDF: Integer; Name: {$IFDEF STRINGINT}String{$ELSE}Pointer{$ENDIF});          stdcall;    {.191}
        procedure fzPerform(act,subj: Cardinal);                                                               stdcall;
        procedure fzResultCxD(Func: Pointer; var Re,Im: Double);                                                stdcall;
        procedure fzResultCxE(Func: Pointer; var Re,Im: Extended);                                                stdcall;
        procedure fzResultCxDP(Func: Pointer;  Res: Pointer);                                                    stdcall;
        procedure fzResultCxEP(Func: Pointer;  Res: Pointer);                                                    stdcall;
        procedure fzResultD(Addr: Pointer;  var Res: double);                                                  stdcall;
        procedure fzResultE(Addr: Pointer;  var Res: extended);                                                stdcall;
        procedure fzResult(Func: Pointer);                                                                     stdcall;
        procedure fzResultSafe(Func: Pointer);                                                                 stdcall;
        procedure fzResultDSafe(Addr: Pointer;  var Res: double);                                             stdcall;
        procedure fzResultCxDSafe(Addr: Pointer;  var Re,Im: double);                                         stdcall;
        procedure fzResultCxDPSafe(Addr: Pointer;  Res: Pointer);                                              stdcall;
        procedure fzPolarDP(pz: Pointer;   pz1: Pointer);                                                      stdcall;
        procedure fzPolarEP(pz: Pointer;   pz1: Pointer);                                                      stdcall;
        procedure fzDecartDP(pz: Pointer;  pz1: Pointer);                                                      stdcall;
        procedure fzDecartEP(pz: Pointer;  pz1: Pointer);                                                      stdcall;
        procedure fzSetVarIntrnl(Name: {$IFDEF STRINGINT}String{$ELSE}Pointer{$ENDIF};  VType: Cardinal; var ExAddr: Pointer);   stdcall;
        procedure fzSetVarValueD(Addr: Pointer;  Val: Double);       stdcall;
        procedure fzSetVarValueE(Addr: Pointer;  Val: Extended);       stdcall;
        procedure fzSetVarValueI(Addr: Pointer;  Val: Integer);       stdcall;
        procedure fzSetVarValueCxD(Addr: Pointer;  ValRe,ValIm: Double);       stdcall;
        procedure fzSetVarValueCxE(Addr: Pointer;  ValRe,ValIm: Extended);       stdcall;
        procedure fzSetLength(AdrV: Pointer; TypeV: Cardinal; Len: Cardinal);  stdcall;
        procedure fzSetArrayValueI(AdrV: Pointer; indx: Cardinal; Val: integer);  stdcall;
        procedure fzSetArrayValueD(AdrV: Pointer; indx: Cardinal; Val: double);  stdcall;
        procedure fzSetArrayValueE(AdrV: Pointer; indx: Cardinal; Val: extended);  stdcall;
        procedure fzGetVarValueE(Addr: Pointer; var Val: Extended);       stdcall;
        procedure fzGetVarValueI(Addr: Pointer; var Val: Integer);       stdcall;
        procedure fzGetVarValueD(Addr: Pointer; var Val: Double);       stdcall;
        procedure fzGetArrayValueI(AdrV: Pointer; indx: Cardinal; var Val: integer);  stdcall;
        procedure fzGetArrayValueD(AdrV: Pointer; indx: Cardinal; var Val: double);  stdcall;
        procedure fzGetArrayValueE(AdrV: Pointer; indx: Cardinal; var Val: extended);  stdcall;
        procedure fzGetVarValueCxD(Addr: Pointer;  var ValRe,ValIm: Double);       stdcall;
        procedure fzGetVarValueCxE(Addr: Pointer;  var ValRe,ValIm: Extended);       stdcall;

        procedure fzSetNameImUnit(Name: {$IFDEF STRINGINT}String{$ELSE}Pointer{$ENDIF});   stdcall;

        procedure fzLoadFPUD(RE: Double; Im: Double);  stdcall;
        procedure fzLoadFPUE(RE: Extended; Im: Extended);  stdcall;
        procedure fzLoadFPUDP(Adr: Pointer);  stdcall;
        procedure fzLoadFPUEP(Adr: Pointer);  stdcall;

        procedure fzGetFuncID(Name: {$IFDEF STRINGINT}String{$ELSE}Pointer{$ENDIF}; var IDF: Integer);   stdcall; {.191}




procedure _SetIntVar(NS: String; TypeV,MType: Integer; var Adr: Cardinal);
procedure _CompileMultiExpr(Expr: String; var SExpr1: String);
procedure _FindReIm(S: String; var S1:String; var TF: Integer);
procedure _ResultC(Func: cardinal; var Res: TComplexE);
function  _ResultR(Func: Cardinal): extended;
procedure pcSetFunc(VNS: TArraySt; S: String; var SF: String);
procedure pcFreeIntVar;
procedure pcSetIntVar(VNS: TArraySt; ATL: TArrayI);
function  pcPosN(S: String; FS: String; P: Integer): Integer;
procedure pcFindVar(S: String; NV: String; P: Integer;  var Bl: Boolean; var NNV: String);
procedure  pcGetFuncVarName(S: String; var FN: String; var VNS: TArraySt);
procedure FreeFunction(Func: Cardinal);
procedure FreeCmplFuncList;
procedure SetReg(Reg,Mode: Integer);
function PtrToStr(P: Pointer): String;
function StrToPtr(S: String): Pointer;
procedure DeleteSpace(S: String; var S1: String);
procedure pcFindFuncArg(SA: String; var MX: TArraySt; var VT: Integer);
function pcGetFuncName(SF,SFM: String; MX: TArraySt): String;
procedure pcConvertFuncName(S: String;  var FN: String; var LVT: TArrayI; var VN,VT,RT: Integer);
procedure pcCompile(S: String; var FName: String; var FAdr: Pointer);
procedure zInitFuncStruct(var FS: TZAddFuncStruct);
procedure PushVar(S: String);
procedure PopVar;
procedure ExchLabl(S1: String; var S2: String);
procedure _SetVar(Name: String; Addr: Pointer; TV: Cardinal);
procedure _GetStrPCh(var P: Pointer);
procedure _SetStrPCh(P: Pointer);
procedure _Compile(Expr: String; var Func: Pointer);
procedure ResultCxD(Func: Pointer; var Res: TComplexD);
procedure ResultCxE(Func: Pointer; var Res: TComplexE);
procedure _LEN(adr: Cardinal; var len: Cardinal);
procedure _SetFunction(Name: String; FAdr: Pointer);
procedure FindArray(SV,SF: String; var SV1,SF1: String);
procedure SetNameTypes;
function _FindCmplFunc(Addr: Cardinal): Cardinal;
procedure CheckFalseBlank(S: String; var S1: String);
function IsCurrentSet(NS: String): Boolean;    {.221}
procedure WriteCurrentSet(NS: String);    {.221}
procedure _SetVarIntrnl(NS: String; TypeV,MType: Integer; var Adr: Cardinal); {.221}
procedure _SetIntVarMultiExpr(NS: String; TypeV,MType: Integer; var Adr: Cardinal);  {.229}






var

 ForevZ: TForevalZ_Custom;
 CompZ: array of TFunctionZ;
 _STRINGTYPE: Integer;
 VSI,ATL,CVA,pcLVT: TArrayI;
 SaveVar,SaveVarD: TAlgObject;
 F_CurrentIntFunc: Cardinal; // -  fl_PRECOMPILED
 InternalVarList, BInternalVarList: PInternalVar;
 CmplOverFlow,CmplSDeep,DinLoadNMem,ReplFuncNum,ReplOpNum,LoadStackAfterCalc: Integer;
 E_Code: Cardinal;
 VSB: TArrayB;
 Str,Str1,SError: String;
 Sws,Sws1: WideString;
 Sans,Sans1: AnsiString;
 Su8,S1u8: UTF8STRING;
 PSu8: PUTF8STRING;
 G_FMT: TFormatSettings;
 StrE: String;
 FS:TZAddFuncStruct;
 LabCount: Integer;
 _EXTENDED_COMMAND, _REPLACE_MULTI_EXPR: Boolean;
 F_Current_Expression: String;
 G_FS:TZAddFuncStruct;
 SNCmplx,SNInt,SNReal,SNSpace: array of String;
 F_FindWrongSpace: Boolean;
 F_CalcConsExprInMulti: Boolean;  //    (  )     .
 CurrentNameSet:Array of String;
 CWMEM: WORD;
 CalcCW: WORD;
 F_ClearCurrentNameSet: Boolean;
 F_FREE_CODE_AT_REPLACE: Boolean;
 F_CALC_EXCEPTION_IN_SAFE: Cardinal;
 GA_TmpExeptionFlag: Cardinal;
 GA_ExceptionFlagAddr: TAddress;

implementation
var
MEM: Cardinal;


(*
NOTE:
    ForevalZ    (Pointer)    : String(UTF-16),  AnsiString(PAnsiChar), WideString, UTF8
   : PtrToStr, StrToPtr.


String variables in procedures ForevalZ are transferred through pointers (Pointer) and can have types: String(UTF-16),  AnsiString(PAnsiChar), WideString, UTF8
Their conversion is fulfilled by procedures: PtrToStr, StrToPtr.
*)




procedure fzCompile(Expr: {$IFDEF STRINGINT}String{$ELSE}Pointer{$ENDIF}; var Func: Pointer);
var
S: String;
begin
{$IFDEF STRINGINT}
S:=Expr;
{$ELSE}
S:=PtrToStr(Expr);
{$ENDIF}

_Compile(S,Func);

end;









procedure fzSet(mode: Cardinal; value: Cardinal);
begin
if mode = fz_ENABLE then
  begin
   if value = fz_SHOW_EXCEPTION           then  ForevZ.ShowException:=True else
   if value = fz_OPTIMIZATION             then begin
                                                 ForevZ.OperationOptimizatorA1:=True;
                                                 ForevZ.OperationOptimizatorA2:=True;
                                                 ForevZ.CalcConstExpr:=True;
                                                 ForevZ.MulDivOptimization:=True;
                                                   //ForevZ.OperationOptimizator:=True;
                                                end  else
   if value = fz_SYNTAX_EXTENSION         then ForevZ.SyntaxExtension:=True    else
   if value = fz_EXTENDED_COMMAND         then _EXTENDED_COMMAND:=True         else
   if value = fz_REPLACE_FUNCTIONS        then ForevZ.ReplaceFuncs:=True else      {.193}
   if value = fz_REPLACE_OPERATIONS       then ForevZ.ReplaceOps:=True else      {.193}
   if value = fz_REPLACE_DIV              then ForevZ.SetF(3,CM_DIV) else
   if value = fz_REPLACE_MUL              then ForevZ.SetF(3,CM_MUL) else
   if value = fz_REPLACE_ADDSUB           then ForevZ.SetF(3,CM_ADD) else
   if value = fz_REPLACE_MULTI_EXPR       then _REPLACE_MULTI_EXPR:=True else
   if value = fz_USE_VIRTUAL_ALLOC        then ForevZ.UseVirtAlloc:=True else
   if value = fz_SAVE_EAX                 then SetReg(R_EAX,_SAVE)             else     {.193}
   if value = fz_SAVE_EBX                 then SetReg(R_EBX,_SAVE)          else
   if value = fz_SAVE_ECX                 then SetReg(R_ECX,_SAVE)            else
   if value = fz_SAVE_EDX                 then SetReg(R_EDX,_SAVE)            else
   if value = fz_SAVE_ESP                 then SetReg(R_ESP,_SAVE)            else
   if value = fz_SAVE_EBP                 then SetReg(R_EBP,_SAVE)            else
   if value = fz_SAVE_ESI                 then SetReg(R_ESI,_SAVE)           else
   if value = fz_SAVE_EDI                 then SetReg(R_EDI,_SAVE)           else
   if value = fz_ACCURATE_SPEC_FUNC       then ForevZ.FastSpec(False)   else
   if value = fz_DINAMIC_LOAD             then ForevZ.DinamicLoad:=True else
   if value = fz_CHECK_INCORRECT_SPACE    then F_FindWrongSpace:=True else      {.195}
   if value = fz_REPLACE_AT_IF            then ForevZ.DisableReplaceIF:=False else  {.195}
   if value = fz_FAST_DIV                 then ForevZ.FastDivision:=True else  {.205}
   if value = fz_REPLACE_COMPOSITE_FUNCTIONS        then ForevZ.ReplaceFuncsCF:=True else      {.217}
   if value = fz_REPLACE_COMPOSITE_FUNCTIONS_COMPLEX        then ForevZ.SetF(17,0)  else      {.217}
   if value = fz_REPLACE_COMPOSITE_FUNCTIONS_REAL           then ForevZ.SetF(16,0)   else   {.217}
   if value = fz_OPTIMIZATION_MUL_DIV     then ForevZ.MulDivOptimization:=True else {.217A}
   if value = fz_OPTIMIZATION_A1          then ForevZ.OperationOptimizatorA1:=True else
   if value = fz_OPTIMIZATION_A2          then ForevZ.OperationOptimizatorA2:=True else
   if value = fz_CALC_CONST_EXPRESSION    then ForevZ.CalcConstExpr:=True else
   if value = fz_LEAD_TO_LOWER_CASE       then ForevZ.LeadToLowerCase:=True else {.221}
   if value = fz_SKIPPED_IF               then ForevZ.SkippedIF:=True else           {.221}
   if value = fz_CALC_CONST_EXPR_IN_MULTI_EXPR   then F_CalcConsExprInMulti:=True else {.221}
   if value = fz_MASK_FPU_EXCEPTION       then ForevZ.EnableMaskFpuException:=True else {.229}
   if value = fz_FREE_CODE_AT_REPLACE     then    F_FREE_CODE_AT_REPLACE:=True;  {.229}
  end
 else
if mode = fz_DISABLE then
  begin
    if value = fz_SHOW_EXCEPTION          then  ForevZ.ShowException:=False else
    if value = fz_OPTIMIZATION            then begin
                                                 ForevZ.OperationOptimizatorA1:=False;
                                                 ForevZ.OperationOptimizatorA2:=False;
                                                 ForevZ.CalcConstExpr:=False;
                                                 ForevZ.MulDivOptimization:=False;
                                               end   else
    if value = fz_SYNTAX_EXTENSION        then ForevZ.SyntaxExtension:=False  else
    if value = fz_EXTENDED_COMMAND        then _EXTENDED_COMMAND:=False   else
    if value = fz_REPLACE_FUNCTIONS       then ForevZ.ReplaceFuncs:=False else
    if value = fz_REPLACE_OPERATIONS      then ForevZ.ReplaceOps:=False  else    {.193}
    if value = fz_REPLACE_DIV             then ForevZ.SetF(4,CM_DIV) else
    if value = fz_REPLACE_MUL             then ForevZ.SetF(4,CM_MUL) else
    if value = fz_REPLACE_ADDSUB          then ForevZ.SetF(4,CM_ADD) else
    if value = fz_REPLACE_MULTI_EXPR      then _REPLACE_MULTI_EXPR:=False else
    if value = fz_USE_VIRTUAL_ALLOC       then ForevZ.UseVirtAlloc:=False else
    if value = fz_SAVE_EAX                then SetReg(R_EAX,_CLEAR)             else     {.193}
    if value = fz_SAVE_EBX                then SetReg(R_EBX,_CLEAR)          else
    if value = fz_SAVE_ECX                then SetReg(R_ECX,_CLEAR)            else
    if value = fz_SAVE_EDX                then SetReg(R_EDX,_CLEAR)            else
    if value = fz_SAVE_ESP                then SetReg(R_ESP,_CLEAR)            else
    if value = fz_SAVE_EBP                then SetReg(R_EBP,_CLEAR)            else
    if value = fz_SAVE_ESI                then SetReg(R_ESI,_CLEAR)           else
    if value = fz_SAVE_EDI                then SetReg(R_EDI,_CLEAR)           else
    if value = fz_ACCURATE_SPEC_FUNC      then ForevZ.FastSpec(True) else
    if value = fz_DINAMIC_LOAD            then ForevZ.DinamicLoad:=False else
    if value = fz_CHECK_INCORRECT_SPACE   then F_FindWrongSpace:=False else      {.195}
    if value = fz_REPLACE_AT_IF           then ForevZ.DisableReplaceIF:=True else  {.195}
    if value = fz_FAST_DIV                then ForevZ.FastDivision:=False else  {.205}
    if value = fz_REPLACE_COMPOSITE_FUNCTIONS        then ForevZ.ReplaceFuncsCF:=False else      {.217}
    if value = fz_REPLACE_COMPOSITE_FUNCTIONS_COMPLEX        then ForevZ.SetF(15,0)  else      {.217}
    if value = fz_REPLACE_COMPOSITE_FUNCTIONS_REAL           then ForevZ.SetF(14,0) else     {.217}
    if value = fz_OPTIMIZATION_MUL_DIV     then ForevZ.MulDivOptimization:=False else {.217A}
    if value = fz_OPTIMIZATION_A1          then ForevZ.OperationOptimizatorA1:=False else
    if value = fz_OPTIMIZATION_A2          then ForevZ.OperationOptimizatorA2:=False else
    if value = fz_CALC_CONST_EXPRESSION    then ForevZ.CalcConstExpr:=False else
    if value = fz_LEAD_TO_LOWER_CASE       then ForevZ.LeadToLowerCase:=False else {.221}
    if value = fz_SKIPPED_IF               then ForevZ.SkippedIF:=False else           {.221}
    if value = fz_CALC_CONST_EXPR_IN_MULTI_EXPR   then F_CalcConsExprInMulti:=False else {.221}
    if value = fz_MASK_FPU_EXCEPTION       then ForevZ.EnableMaskFpuException:=False  else {.229}
    if value = fz_FREE_CODE_AT_REPLACE     then    F_FREE_CODE_AT_REPLACE:=False;  {.229}
  end
 else
if mode = fz_STACK_TYPE then
  begin
    if value = fz_DOUBLE      then  ForevZ.DataType:=_Double  else
    if value = fz_EXTENDED    then  ForevZ.DataType:=_Extended;
  end
 else
if mode = fz_STACK_DEEP then
  begin
    if (value <= 8) and (value >= 0) then  ForevZ.StackDeep:=value;
    if  value = 0 then ForevZ.DinamicLoad:=False else
    if  value >= 1 then ForevZ.DinamicLoad:=True;
  end
 else
if mode = fz_CALC_TYPE then
  begin
    if value = fz_REAL    then  ForevZ.CalcType:=T_Real else
    if value = fz_COMPLEX then  ForevZ.CalcType:=T_Complex;
  end
  else
if mode = fz_STRING_TYPE then
begin
 case Value of
 fz_STRING:           _STRINGTYPE:=Value;
 fz_ANSISTRING:       _STRINGTYPE:=Value;
 fz_PANSICHAR:        _STRINGTYPE:=Value;
 fz_WIDESTRING:       _STRINGTYPE:=Value;
 fz_STRING_UTF8:      _STRINGTYPE:=Value;
 end;
end
else
if mode = fz_PRECISION then          {.221}
begin
   case Value of
     fz_DOUBLE:          begin CalcCW:=$1272; Set8087CW($1272);   end;    {.229}
     fz_EXTENDED:        begin CalcCW:=$1372; Set8087CW($1372);  end;     {.229}
   end;
end
else    {.191}
if mode = fz_ENABLE_FUNCTION then   ForevZ.SetF(1,value)
else
if mode = fz_DISABLE_FUNCTION then  ForevZ.SetF(2,value)
else
if mode = fz_POWER_SYMBOL then   ForevZ.SetF(5,value)  {.195}
else
if mode = fz_FPU_CW then   Set8087CW(value)           {.203}
else
if mode =  fz_FPU_CW_DEFAULT  then  Set8087CW($1372)  {.203}
else
if mode =  fz_ENABLE_REPLACE_FUNCTION then   ForevZ.SetF(6,value)    {.215}
else
if mode =  fz_DISABLE_REPLACE_FUNCTION then   ForevZ.SetF(7,value)    {.215}
else
if mode =  fz_ENABLE_CALC_CONST   then    ForevZ.SetF(8,value)  {.215}
else
if mode =  fz_DISABLE_CALC_CONST   then    ForevZ.SetF(9,value)   {.215}
else
if mode = fz_DISABLE_REPLACE_FUNCTION_COMPLEX then     ForevZ.SetF(11,value)   {.217}
else
if mode = fz_DISABLE_REPLACE_FUNCTION_REAL then       ForevZ.SetF(10,value)   {.217}
else
if mode = fz_ENABLE_REPLACE_FUNCTION_COMPLEX then     ForevZ.SetF(13,value)   {.217}
else
if mode = fz_ENABLE_REPLACE_FUNCTION_REAL then       ForevZ.SetF(12,value)   {.217}
else
if mode =   fz_ADDRESS_EXCEPTION_FLAG then   GA_ExceptionFlagAddr:=value;   {.231}


end;






procedure fzGet(mode,subj: Cardinal; var value: Cardinal);
var
cd,Num,rt: cardinal;
begin
value:=0;
 if (mode = fz_RESULT_TYPE) and (subj = 0) then
   begin
     if ForevZ.ResultType = T_Real    then value:=fz_REAL else
     if ForevZ.ResultType = T_None    then value:=fz_NONE else
     if ForevZ.ResultType = T_Complex then value:=fz_COMPLEX else
     if ForevZ.ResultType = T_Array   then value:=fz_NONE;   {arraycpu}  {.223}
   end
  else
 if mode = fz_RESULT_TYPE then
 begin
   Num:=_FindCmplFunc(subj);
   if Num <> 0 then
   begin
     rt:=CompZ[Num].R_Type;
     if rt = T_Real    then value:=fz_REAL else
     if rt = T_None    then value:=fz_NONE else
     if rt = T_Complex then value:=fz_COMPLEX else
     if rt = T_Array   then value:=fz_NONE;   {arraycpu}  {.223}
   end;
  end
 else
 if mode = fz_IS_FPU_EXCEPTION then
  begin
   if (ForevZ.IsFPUException(@CWMEM) =  0) and (F_CALC_EXCEPTION_IN_SAFE = 0) then value:=fz_NO else value:=fz_YES; {.229}
  end
 else
 if mode = fz_PRESENT_COMPLEX_NUMBER then
 begin
     if ForevZ.ComplexNumber = True   then value:=fz_YES else value:=fz_NO;
 end
 else
 if mode = fz_COMPILE_STACK_DEEP then  value:=CmplSDeep;
 if mode = fz_COMPILE_OVFL       then
                                  begin
                                    if CmplOverFlow = 1 then value:=fz_YES
                                    else
                                    if CmplOverFlow = 0 then value:=fz_NO;
                                   end;
 if mode = fz_DINAMIC_LOAD_NUM   then  value:=DinLoadNMem
 else
 if mode = fz_LOAD_STACK_AFTER_CALC  then  value:=LoadStackAfterCalc        {.197}
 else
 if mode = fz_REPLACE_FUNCTIONS_NUM  then value:=ReplFuncNum  {.193}
 else
 if mode = fz_REPLACE_OPERATIONS_NUM  then value:=ReplOpNum  {.193}
 else
 if mode = fz_ADDRESS_OBJECT  then  value:=subj {.197}
 else
 if mode = fz_PESENT_VAR then
 begin
   if ForevZ.PresentVar = True   then value:=fz_YES else value:=fz_NO;
 end
 else
 if mode = fz_ARRAY_LENGTH then
 begin
  _LEN(subj,cd);
  value:=cd;
 end
 else
 if mode = fz_LENGTH_CODE   then
 begin
    Num:=_FindCmplFunc(subj);
    if Num <> 0 then
    begin
     value:=CompZ[Num].Func.CodeSize;
    end;
 end
 else
 if mode = fz_VERSION        then
begin
 if subj = fz_MAJOR          then value:=_VMAJOR;
 if subj = fz_MINOR          then value:=_VMINOR;
 if subj = fz_RELEASE        then value:=_VREALISE;
 if subj = fz_BUILD          then value:=_VBUILD;
end
else
if mode = fz_ABOUT        then value:=Cardinal(StrToPtr(_S_ABOUT))
else
if mode = fz_AUTHOR       then value:=Cardinal(StrToPtr(_S_AUTHOR))
else
if mode = fz_COMMENT      then value:=Cardinal(StrToPtr(_S_COMMENT))
else
if mode = fz_STRING_TYPE  then value:=_STRINGTYPE
else
if mode = fz_COMPILED_BY  then value:=_COMPILED_BY


end;


procedure fzGetSyntaxErrorCode(var CError: Cardinal);
begin
CError:=0;
 case ForevZ.SyntaxError of

 E_UNKNOWN_SYMBOL:                              CError:=fz_UNKNOWN_SYMBOL;
 E_MISSING_ROUND_BRACKET:                       CError:=fz_MISSING_ROUND_BRACKET;
 E_MISSING_OPERATION:                           CError:=fz_MISSING_OPERATION;
 E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS:           CError:=fz_WRONG_NUMBER_ARGUMENTS;
 E_MISSING_EXPRESSION:                          CError:=fz_MISSING_EXPRESSION;
 E_UNKNOWN_FUNCTION:                            CError:=fz_UNKNOWN_FUNCTION;
 E_ABSENT_FUNCTION_FOR_LOAD_TYPE:               CError:=fz_ABSENT_LOAD_FUNCTION_FOR_TYPE;
 E_NOT_DEFINED_OPERATION_FOR_TYPE:              CError:=fz_NOT_DEFINED_OPERATOR;
 E_NOT_DEFINED_FUNCTION_FOR_TYPE:               CError:=fz_NOT_DEFINED_FUNCTION;
 E_INTERNAL_ERROR:                              CError:=fz_INTERNAL_ERROR;
 E_ERROR_AT_ADDITION_OF_FUNCTION:               CError:=fz_ERROR_AT_ADDITION_FUNCTION;
 E_WRONG_TYPE:                                  CError:=fz_INCORRECT_TYPE;
 E_WRONG_NAME:                                  CError:=fz_WRONG_NAME;
 E_MISSING_SQUARE_BRACKET:                      CError:=fz_MISSING_SQUARE_BRACKET;
 E_MISSING_CURLY_BRACKET:                       CError:=fz_MISSING_CURLY_BRACKET;
 E_MISSING_ABS_BRACKET:                         CError:=fz_MISSING_ABS_BRACKET;
 E_MISSING_SEPARATOR:                           CError:=fz_MISSING_SEPARATOR;
 E_WRONG_EXPRESSION:                            CError:=fz_WRONG_EXPRESSION;
 E_ERROR_AT_CALCULATION:                        CError:=fz_CALCULATION_ERROR;
 E_INCORRECT_ARGUMENT:                          CError:=fz_INCORRECT_ARGUMENT;
 E_INCORRECT_SPACE:                             CError:=fz_INCORRECT_SPACE;{.195}
 E_VARIABLE_REDECLARED:                         CError:=fz_VARIABLE_REDECLARED; {.221}
 //else       CError:=ForevZ.SyntaxError;
 end;
end;


procedure fzGetSyntaxErrorString(var SError:{$IFDEF STRINGINT}String{$ELSE}Pointer{$ENDIF});
var
S1: String;
begin
S1:=ForevZ.SyntaxErrorString;

StrE:=Copy(S1,1,Length(S1));

SError:={$IFDEF STRINGINT}StrE{$ELSE}StrToPtr(StrE){$ENDIF};
end;



procedure fzRenameFunction(Name,NewName: {$IFDEF STRINGINT}String{$ELSE}Pointer{$ENDIF});
begin
  ForevZ.RenameFunction({$IFDEF STRINGINT}Name,NewName{$ELSE}PtrToStr(Name),PtrToStr(NewName){$ENDIF});
end;


procedure fzAddNameFunction(IDF: Integer; Name: {$IFDEF STRINGINT}String{$ELSE}Pointer{$ENDIF});          stdcall;
var
S: String;
begin
 S:=Copy({$IFDEF STRINGINT}Name{$ELSE}PtrToStr(Name){$ENDIF},1,Length({$IFDEF STRINGINT}Name{$ELSE}PtrToStr(Name){$ENDIF}));
 ForevZ.SetExtNameFunc(IDF,S);
end;


procedure fzPerform(act,subj: Cardinal);
begin
  if act = fz_FREE then
  begin
   case subj of
     fz_VAR_LIST:         ForevZ.FreeVar;
     fz_CMPL_FUNC_LIST:   FreeCmplFuncList;
     else                 FreeFunction(subj);
   end;
  end
  else
  if act = fz_CLEAR then
  begin
   case subj of
    fz_ERROR_CODE:  begin ForevZ.SyntaxError:=0; ForevZ.InternalError:=0; ForevZ.CalcError:=0; end
   end
  end
  else
  if act = fz_SAVE then
  begin
    case subj of
     fz_VAR_LIST:         ForevZ.PushVar;
    end
  end
  else
  if act = fz_RESTORE then
  begin
    case subj of
     fz_VAR_LIST:         ForevZ.PopVar;
    end;
  end
  else
  if act = fz_MASK_FPU_EXCEPTION then ForevZ.MaskFPUException(@CWMEM) //_MaskFpuException;
  else
  if act = fz_CLEAR_FPU_EXCEPTION then   ForevZ.ClearFpuException;   {.229}




end;



procedure fzSetVar(Name: {$IFDEF STRINGINT}String{$ELSE}Pointer{$ENDIF}; Addr: Pointer; TV: Cardinal);
var
TypeV,MType: Integer;
NameS: String;
begin
{$IFDEF STRINGINT}NameS:=Name{$ELSE}NameS:=PtrToStr(Name){$ENDIF};

_SetVar(NameS,Addr,TV);
end;







procedure fzSetVarIntrnl(Name: {$IFDEF STRINGINT}String{$ELSE}Pointer{$ENDIF};  VType: Cardinal; var ExAddr: Pointer);
var
TypeV,MType: Integer;
NameS: String;
begin
{$IFDEF STRINGINT}NameS:=Name{$ELSE}NameS:=PtrToStr(Name){$ENDIF};

 case VType of
  fz_Real_Double:            begin TypeV:=T_Real;    MType:=_Double; end;
  fz_Real_Extended:          begin TypeV:=T_Real;    MType:=_Extended; end;
  fz_Complex_Double:         begin TypeV:=T_Complex; MType:=_Double; end;
  fz_Complex_Extended:       begin TypeV:=T_Complex; MType:=_Extended; end;
  fz_Array_Real_Double:      begin TypeV:=T_Array;   MType:=_Double; end;
  fz_Array_Real_Extended:    begin TypeV:=T_Array;   MType:=_Extended; end;
  fz_Array_Real_Integer:     begin TypeV:=T_Array;   MType:=_Integer; end;
  fz_Real_Integer:           begin TypeV:=T_Real;    MType:=_Integer; end;
 end;

 _SetVarIntrnl(NameS, TypeV, MType, Cardinal(ExAddr));
end;




procedure  fzSetVarValueD(Addr: Pointer;  Val: Double);       stdcall;
{asm
  push eax
  mov eax, [Addr]
  fld qword ptr [Val]
  fstp qword ptr [eax]
  pop eax
end;}
begin
  PDouble(Addr)^:=Val
end;


procedure  fzSetVarValueE(Addr: Pointer;  Val: Extended);       stdcall;
{asm
  push eax
  mov eax, [Addr]
  fld tbyte ptr [Val]
  fstp tbyte ptr [eax]
  pop eax
end; }
begin
  PExtended(Addr)^:=Val
end;


procedure  fzSetVarValueI(Addr: Pointer;  Val: Integer);       stdcall;
{asm
  push eax
  push ebx
  mov eax, [Addr]
  mov ebx, [Val]
  mov [eax], ebx
  pop ebx
  pop eax
end; }
begin
  PInteger(Addr)^:=Val
end;




procedure  fzSetVarValueCxD(Addr: Pointer;  ValRe,ValIm: Double);       stdcall;
{asm
  push eax
  mov eax, [Addr]
  fld qword ptr [ValRe]
  fstp qword ptr [eax]
  fld qword ptr [ValIm]
  fstp qword ptr [eax+8]
  pop eax
end;}
begin
  PDouble(Addr)^:=ValRe;
  PDouble(Cardinal(Addr)+8)^:=ValIm;
end;


procedure  fzGetVarValueCxE(Addr: Pointer;  var ValRe,ValIm: Extended);       stdcall;
begin
  ValRe:=PExtended(Addr)^;
  ValIm:=PEXtended(Cardinal(Addr)+16)^;
end;


procedure  fzGetVarValueCxD(Addr: Pointer;  var ValRe,ValIm: Double);       stdcall;
begin
  ValRe:=PDouble(Addr)^;
  ValIm:=PDouble(Cardinal(Addr)+8)^;
end;


procedure  fzSetVarValueCxE(Addr: Pointer;  ValRe,ValIm: Extended);       stdcall;
{asm
  push eax
  mov eax, [Addr]
  fld tbyte ptr [ValRe]
  fstp tbyte ptr [eax]
  fld tbyte ptr [ValRe]
  fstp tbyte ptr [eax+16]
  pop eax
end;}
begin
  PExtended(Addr)^:=ValRe;
  PEXtended(Cardinal(Addr)+16)^:=ValIm;
end;



procedure  fzResultD(Addr: Pointer;  var Res: double);       stdcall;
asm
  push eax
  call Addr
  mov eax, [res]
  fstp qword ptr [eax]
  pop eax
end;


procedure  fzResultE(Addr: Pointer;  var Res: extended);     stdcall;
asm
  push eax
  call Addr
  mov eax, [res]
  fstp tbyte ptr [eax]
  pop eax
end;



procedure fzResultCxD(Func: Pointer; var Re,Im: double);     stdcall;
var
p:TComplexD;
begin
  asm
   call Func
   push eax
   mov  eax, [re]
   fstp qword ptr [eax]
   mov  eax, [Im]
   fstp qword ptr [eax]
   pop  eax
  end;

{
  asm
   call Func
   fstp p.re
   fstp p.im
  end;

  Res:=p;
  }
end;



procedure fzResultCxE(Func: Pointer; var  Re,Im: extended);   stdcall;
var
p:TComplexE;
begin
 asm
   call Func
   push eax
   mov  eax, [Re]
   fstp tbyte ptr [eax]
   mov  eax, [Im]
   fstp tbyte ptr [eax]
   pop  eax
  end;
{
  asm
   call Func
   fstp p.re
   fstp p.im
  end;

  Res:=p;
 }
end;




procedure fzResultCxDP(Func: Pointer; Res: Pointer);   stdcall;
asm
   push eax
   call Func
   mov eax, [res]
   fstp qword ptr [eax]
   fstp qword ptr [eax+8]
   pop  eax
end;
{var
p:TComplexD;
begin
  asm
   call Func
   fstp p.re
   fstp p.im
  end;

  Res:=PComplexD(@p);
end;
}


procedure fzResultCxEP(Func: Pointer;  Res: Pointer);      stdcall;
asm
   push eax
   call Func
   mov eax, [res]
   fstp tbyte ptr [eax]
   fstp tbyte ptr [eax+16]
   pop  eax
end;
{var
p:TComplexE;
begin
  asm
   call Func
   fstp p.re
   fstp p.im
  end;

  Res:=PComplexE(@p);
end;
}


procedure  fzResult(Func: Pointer); assembler;     stdcall;
asm
   call Func
end;



procedure  fzResultSafe(Func: Pointer);        stdcall;
begin
asm

    push  eax
    push  ecx

    //init error flags
    mov F_CALC_EXCEPTION_IN_SAFE,0
    mov eax,GA_ExceptionFlagAddr
    mov [eax],0

     //Mask
    sub esp,8
    fnstcw word ptr [esp+4];       //->store   CW
    fnstcw word ptr [esp];
    or word ptr [esp], 003Fh;
    fldcw [esp];

    call Func

    //Catch
    xor  eax,eax
    fnstsw ax
    sahf
    //test ax, 001Fh
    and  ax, 001Fh


    jz @@Z         //if no error

    //save error code
    mov F_CALC_EXCEPTION_IN_SAFE, eax   //,1
    mov ecx,GA_ExceptionFlagAddr
    mov [ecx],eax  //,1

    @@Z:

    fnclex
    fldcw  word ptr [esp+4]   //<-load        CW

    add esp, 8
    pop ecx
    pop eax
end;
end;



procedure  fzResultDSafe(Addr: Pointer;  var Res: double);       stdcall;
begin
asm

    push  eax
    push  ecx

    //init error flags
    {mov F_CALC_EXEPTION_IN_SAFE,0
    mov eax,GA_ExeptionFlagAddr
    mov [eax],0 }

    //Mask
    {sub esp,8
    fnstcw word ptr [esp+4];       //->store   CW
    fnstcw word ptr [esp];
    or word ptr [esp], 003Fh;
    fldcw [esp];
    }
    sub esp,8
    fnstcw word ptr [esp];
    or word ptr [esp], 003Fh;
    fnstcw word ptr [esp+4];       //->store   CW
    fldcw [esp];

    call Addr
    mov eax, [res]
    fstp qword ptr [eax]

    //Catch
    xor  eax,eax
    fnstsw ax
    sahf
    //test ax, 001Fh
    and  ax, 001Fh


    //jz @@Z         //if no error

    //save error code
    mov ecx,GA_ExceptionFlagAddr
    mov F_CALC_EXCEPTION_IN_SAFE, eax   //,1
    mov [ecx],eax  //,1

    @@Z:
    fnclex
    fldcw  word ptr [esp+4]   //<-load        CW
    add esp, 8

    pop ecx
    pop eax
end;
end;



procedure  fzResultCxDSafe(Addr: Pointer;  var Re,Im: double);       stdcall;
begin
asm

    push  eax
    push  ecx

    //init error flags
    {mov F_CALC_EXEPTION_IN_SAFE,0
    mov eax,GA_ExeptionFlagAddr
    mov [eax],0 }

    //Mask
    {sub esp,8
    fnstcw word ptr [esp+4];       //->store   CW
    fnstcw word ptr [esp];
    or word ptr [esp], 003Fh;
    fldcw [esp];
    }
    sub esp,8
    fnstcw word ptr [esp];
    or word ptr [esp], 003Fh;
    fnstcw word ptr [esp+4];       //->store   CW
    fldcw [esp];

    call Addr
    mov  eax, [Re]
    fstp qword ptr [eax]
    mov  eax, [Im]
    fstp qword ptr [eax]

    //Catch
    xor  eax,eax
    fnstsw ax
    sahf
    //test ax, 001Fh
    and  ax, 001Fh


    //jz @@Z         //if no error

    //save error code
    mov ecx,GA_ExceptionFlagAddr
    mov F_CALC_EXCEPTION_IN_SAFE, eax   //,1
    mov [ecx],eax  //,1

    @@Z:
    fnclex
    fldcw  word ptr [esp+4]   //<-load        CW
    add esp, 8

    pop ecx
    pop eax
end;
end;




procedure  fzResultCxDPSafe(Addr: Pointer;  Res: Pointer);       stdcall;
begin
asm

    push  eax
    push  ecx

    //init error flags
    {mov F_CALC_EXEPTION_IN_SAFE,0
    mov eax,GA_ExeptionFlagAddr
    mov [eax],0 }

    //Mask
    {sub esp,8
    fnstcw word ptr [esp+4];       //->store   CW
    fnstcw word ptr [esp];
    or word ptr [esp], 003Fh;
    fldcw [esp];
    }
    sub esp,8
    fnstcw word ptr [esp];
    or word ptr [esp], 003Fh;
    fnstcw word ptr [esp+4];       //->store   CW
    fldcw [esp];

    call Addr
    mov eax, [Res]
    fstp qword ptr [eax]
    fstp qword ptr [eax+8]

    //Catch
    xor  eax,eax
    fnstsw ax
    sahf
    //test ax, 001Fh
    and  ax, 001Fh


    //jz @@Z         //if no error

    //save error code
    mov ecx,GA_ExceptionFlagAddr
    mov F_CALC_EXCEPTION_IN_SAFE, eax   //,1
    mov [ecx],eax  //,1

    @@Z:
    fnclex
    fldcw  word ptr [esp+4]   //<-load        CW
    add esp, 8

    pop ecx
    pop eax
end;
end;



procedure fzSetNameImUnit(Name: {$IFDEF STRINGINT}String{$ELSE}Pointer{$ENDIF});   stdcall;
var
S: String;
begin
 S:=Copy({$IFDEF STRINGINT}Name{$ELSE}PtrToStr(Name){$ENDIF},1,Length({$IFDEF STRINGINT}Name{$ELSE}PtrToStr(Name){$ENDIF}));
 ForevZ.SetImUnitName(S);
end;


{.191}
procedure fzGetFuncID(Name: {$IFDEF STRINGINT}String{$ELSE}Pointer{$ENDIF}; var IDF: Integer);   stdcall;
var
S: String;
begin
 S:=Copy({$IFDEF STRINGINT}Name{$ELSE}PtrToStr(Name){$ENDIF},1,Length({$IFDEF STRINGINT}Name{$ELSE}PtrToStr(Name){$ENDIF}));
 ForevZ.FindFuncA(S,IDF);
end;



procedure fzSetFunction(Name: {$IFDEF STRINGINT}String{$ELSE}Pointer{$ENDIF}; FAdr: Pointer);
var
S: String;
begin
S:=Copy({$IFDEF STRINGINT}Name{$ELSE}PtrToStr(Name){$ENDIF},1,Length({$IFDEF STRINGINT}Name{$ELSE}PtrToStr(Name){$ENDIF}));
_SetFunction(S,FAdr);
end;



procedure _SetFunction(Name: String; FAdr: Pointer);
label 1,ler,endp;
var
N,K,i,idf,idn: Integer;
FS:  TIntFunc;
TypeV,MType,CError,CP,P,CT,adr: Cardinal;
TV: PArrayI;
ResT: Cardinal;
CallF,CallT,SDeep,ECode,CT1: Integer;
FuncStruct: TZAddFuncStruct;
PF: ^TZAddFuncStruct;
E: Exception;
SN,SF,NameF,S: String;
VNS: TArraySt;
CAdr: Pointer;
begin
ECode:=0;
E_Code:=0;
NameF:=Copy(Name,1,Length(Name));

CError:=0;
ForevZ.SyntaxError:=0;

if ForevZ.LeadToLowerCase = True then NameF:=LowerCase(NameF); {.221}

SError:=NameF;

if F_FindWrongSpace = True then      {.195}
begin
  CheckFalseBlank(NameF,NameF);
  if E_Code <> 0 then
  begin
    ForevZ.SyntaxErrorString:=SError;
    ForevZ.SyntaxError:=E_Code;
    ForevZ.IntException;
    goto endp;
  end;
end
else
DeleteSpace(NameF,NameF);

if NameF = '' then
begin
 ECode:=E_ERROR_AT_ADDITION_OF_FUNCTION; ForevZ.SyntaxError:=ECode;
 goto ler;
end;

  {
  fnc():real=1.123
  fnc():real=1.123345
  
  }
if FAdr = nil then    //fl_PRECOMPILED: whole string
begin
  pcCompile(NameF,NameF,FAdr);
  if E_Code <> 0 then goto ler;
end;

try

PF:=FAdr;
FuncStruct:=PF^;


ForevZ.InitFuncStruct(FS);
FS.Addr:=Cardinal(FuncStruct.addr);



if FuncStruct.CallFunc = fz_INFINITE then
begin
 FS.N:=-1;

 SetLength(FS.TV,1); SetLength(FS.TM,1);

 case FuncStruct.ArgType of
    fz_Real_Double:               begin TypeV:=T_Real;    MType:=_Double; end;
    fz_Real_Extended:             begin TypeV:=T_Real;    MType:=_Extended; end;
    fz_Complex_Double:            begin TypeV:=T_Complex; MType:=_Double; end;
    fz_Complex_Extended:          begin TypeV:=T_Complex; MType:=_Extended; end;
    fz_Real_Integer:              begin TypeV:=T_Real;    MType:=_Integer; end;
    fz_differ_Double:             begin end;
    fz_differ_Extended:           begin end;
    else                          ECode:=fz_ERROR_AT_ADDITION_FUNCTION
 end;

 FS.TV[0]:=TypeV;
 FS.TM[0]:=MType;

 FS.CallT:=_STACK_INFINITE;

 if FuncStruct.ArgType = fz_differ_Double then begin FS.CallT:=_STACK_INFINITE_A; FS.N:=-2; FS.TM[0]:=_Double; end;
 if FuncStruct.ArgType = fz_differ_Extended then begin FS.CallT:=_STACK_INFINITE_A; FS.N:=-2; FS.TM[0]:=_Extended; end;

 goto 1;
end;



 N:=FuncStruct.Arg;
 FS.N:=N;
 SetLength(FS.TV,N); SetLength(FS.TM,N);




 if (FuncStruct.ArgType = fz_DIFFER) or (FuncStruct.ArgTypeList <> nil) then
 begin
  TV:=@TArrayI(FuncStruct.ArgTypeList);
  for i:=0 to N-1 do
  begin
   case TV^[i] of
    fz_Real_Double:               begin TypeV:=T_Real;    MType:=_Double; end;
    fz_Real_Extended:             begin TypeV:=T_Real;    MType:=_Extended; end;
    fz_Complex_Double:            begin TypeV:=T_Complex; MType:=_Double; end;
    fz_Complex_Extended:          begin TypeV:=T_Complex; MType:=_Extended; end;
    fz_Array_Real_Double:         begin TypeV:=T_Array;   MType:=_Double; end;
    fz_Array_Real_Extended:       begin TypeV:=T_Array;   MType:=_Extended; end;
    fz_Array_Real_Integer:        begin TypeV:=T_Array;   MType:=_Integer; end;
    fz_Real_Integer:              begin TypeV:=T_Real;    MType:=_Integer; end;
    else                          ECode:=fz_ERROR_AT_ADDITION_FUNCTION
   end;
   FS.TV[i]:=TypeV;
   FS.TM[i]:=MType;
   end;
 end
 else
 begin
  for i:=0 to N-1 do
  begin
   case FuncStruct.ArgType of
    fz_Real_Double:               begin TypeV:=T_Real;    MType:=_Double; end;
    fz_Real_Extended:             begin TypeV:=T_Real;    MType:=_Extended; end;
    fz_Complex_Double:            begin TypeV:=T_Complex; MType:=_Double; end;
    fz_Complex_Extended:          begin TypeV:=T_Complex; MType:=_Extended; end;
    fz_Array_Real_Double:         begin TypeV:=T_Array;   MType:=_Double; end;
    fz_Array_Real_Extended:       begin TypeV:=T_Array;   MType:=_Extended; end;
    fz_Array_Real_Integer:        begin TypeV:=T_Array;   MType:=_Integer; end;
    fz_Real_Integer:              begin TypeV:=T_Real;    MType:=_Integer; end;
    else                          ECode:=fz_ERROR_AT_ADDITION_FUNCTION
   end;
   FS.TV[i]:=TypeV;
   FS.TM[i]:=MType;
   end;
 end;

 if (FuncStruct.ArgTypeList <> nil) and (FuncStruct.ArgType <> fz_DIFFER) then ECode:=fz_ERROR_AT_ADDITION_FUNCTION;

 case FuncStruct.CallFunc of
   fz_STACK_VAL:    CallF:=_Stack_Val;
   fz_STACK_ADR:    CallF:=_Stack_Adr;
   fz_EAX:          CallF:=_EAX;
   fz_ESP:          CallF:=_ESP;
   fz_PRECOMPILED:  CallF:=_Compiled;
   else             ECode:=fz_ERROR_AT_ADDITION_FUNCTION;
 end;

 FS.CallT:=CallF;

1:
 case FuncStruct.CallType of
   fz_CDECL:    CallT:=_Cdecl;
   fz_STDCALL:  CallT:=_StdCall;
   fz_PASCAL:   CallT:=_Pascal;
   else  if CallF = _Compiled then CallT:=_Compiled else  ECode:=fz_ERROR_AT_ADDITION_FUNCTION;
 end;

 if FuncStruct.ResultType = fz_REAL then ResT:=T_Real else
   if FuncStruct.ResultType = fz_COMPLEX then ResT:=T_Complex else
     if FuncStruct.ResultType = fz_NONE then ResT:=T_NONE else
     ECode:=fz_ERROR_AT_ADDITION_FUNCTION;

 if FuncStruct.DeepFPU = fz_UNKNOWN then SDeep:=-1 else
   if (FuncStruct.DeepFPU  < 0) or (FuncStruct.DeepFPU > 8) then
     ECode:=fz_ERROR_AT_ADDITION_FUNCTION  else SDeep:=FuncStruct.DeepFPU;


 FS.TypeF:=ResT;
 FS.SDeep:=SDeep;
 FS.SaveReg:=FuncStruct.SaveReg;

 if FuncStruct.CalcConst = fz_YES then FS.CalcConst:=_YES else FS.CalcConst:=_NO;
 if FuncStruct.ReplFunc = fz_YES then FS.ReplFunc:=_YES else FS.ReplFunc:=_NO; {.193}


 if CallT = _Pascal then  FS.Arrow:=_Back else
 if CallT = _StdCall then FS.Arrow:=_Right else
 if CallT = _Cdecl then   FS.Arrow:=_Right;

 if  CallT = _Cdecl then FS.CLST:=1;


if FuncStruct.CallFunc = fz_PRECOMPILED then
begin
  //NameF:=Copy({$IFDEF STRINGINT}Name{$ELSE}PtrToStr(Name){$ENDIF},1,Length({$IFDEF STRINGINT}Name{$ELSE}PtrToStr(Name){$ENDIF}));
  //DeleteSpace(NameF,NameF);
  P:=Pos('=',NameF);
  SN:=Copy(NameF,1,P-1);
  SF:=Copy(NameF,P+1,Length(NameF)-P+1);

  SError:=SN;

  if (SF = '') or (SN = '') then   ECode:=fz_ERROR_AT_ADDITION_FUNCTION;

  pcGetFuncVarName(SN,SN,VNS);
  FS.N:=Length(VNS);
  SetLength(ATL,FS.N);


 N:=FS.N;
 SetLength(FS.TV,N); SetLength(FS.TM,N);
 if (FuncStruct.ArgType = fz_DIFFER) or (FuncStruct.ArgTypeList <> nil) then
 begin
  TV:=@TArrayI(FuncStruct.ArgTypeList);
  for i:=0 to N-1 do
  begin
   case TV^[i] of
    fz_Real_Double:               begin TypeV:=T_Real;    MType:=_Double; end;
    fz_Real_Extended:             begin TypeV:=T_Real;    MType:=_Extended; end;
    fz_Complex_Double:            begin TypeV:=T_Complex; MType:=_Double; end;
    fz_Complex_Extended:          begin TypeV:=T_Complex; MType:=_Extended; end;
    fz_Array_Real_Double:         begin TypeV:=T_Array;   MType:=_Double; end;
    fz_Array_Real_Extended:       begin TypeV:=T_Array;   MType:=_Extended; end;
    fz_Array_Real_Integer:        begin TypeV:=T_Array;   MType:=_Integer; end;
    fz_Real_Integer:              begin TypeV:=T_Real;    MType:=_Integer; end;
    else                          ECode:=fz_ERROR_AT_ADDITION_FUNCTION
   end;
   FS.TV[i]:=TypeV;
   FS.TM[i]:=MType;
   ATL[i]:=TV^[i];
   end;
 end
 else
 begin
  for i:=0 to N-1 do
  begin
   case FuncStruct.ArgType of
    fz_Real_Double:               begin TypeV:=T_Real;    MType:=_Double; end;
    fz_Real_Extended:             begin TypeV:=T_Real;    MType:=_Extended; end;
    fz_Complex_Double:            begin TypeV:=T_Complex; MType:=_Double; end;
    fz_Complex_Extended:          begin TypeV:=T_Complex; MType:=_Extended; end;
    fz_Array_Real_Double:         begin TypeV:=T_Array;   MType:=_Double; end;
    fz_Array_Real_Extended:       begin TypeV:=T_Array;   MType:=_Extended; end;
    fz_Array_Real_Integer:        begin TypeV:=T_Array;   MType:=_Integer; end;
    fz_Real_Integer:              begin TypeV:=T_Real;    MType:=_Integer; end;
    else                          ECode:=fz_ERROR_AT_ADDITION_FUNCTION
   end;
   FS.TV[i]:=TypeV;
   FS.TM[i]:=MType;
   ATL[i]:=FuncStruct.ArgType;
   end;
 end;

 if (FuncStruct.ArgTypeList <> nil) and (FuncStruct.ArgType <> fz_DIFFER) then ECode:=fz_ERROR_AT_ADDITION_FUNCTION;



  pcSetFunc(VNS,SF,SF);
  inc(F_CurrentIntFunc);
  CT:=ForevZ.CalcType;
  if FuncStruct.ResultType = fz_REAL then  ForevZ.CalcType:=T_Real;



  if (ECode = 0) and (E_Code = 0)
  then
  begin
    F_ClearCurrentNameSet:=False;    {.229}
    _Compile(SF,CAdr);
    F_ClearCurrentNameSet:=True;      {.229}
  end
   else
  begin
    PopVar;      {.229}
  end;


  ForevZ.CalcType:=CT;
  fzGetSyntaxErrorCode(CError);
  FS.addr:=Cardinal(CAdr);
  if CError = 0 then
  begin
     fzGet(fz_COMPILE_OVFL,0,CP);
     if CP = fz_YES then  {FS.SDeep:=-1}FS.SDeep:=8 {.209}  //max value
     else
     if CP = fz_NO  then
     begin
      fzGet(fz_COMPILE_STACK_DEEP,0,CP);
      FS.SDeep:=CP;
     end;


     N:=Length(CVA);
     if N <> FS.N then   ECode:=fz_ERROR_AT_ADDITION_FUNCTION;

     SetLength(FS.ArgAdr,N);

     for i:=0 to N-1 do
     begin
       FS.ArgAdr[i]:=CVA[i];
     end;
     //   - ( )
     ForevZ.FindFunc(SN,FS.TV,idn,idf,CT1,adr);
     if CT1 = _Compiled then
     begin
       fzPerform(fz_Free,adr);
       ForevZ.DeleteFunc(idn,idf);
        {
        if F_FREE_CODE_AT_REPLACE = True then
        begin
           fzPerform(fz_Free,adr);
           ForevZ.DeleteFunc(idn,idf);
        end;
        }
     end;
  end;

  NameF:=Copy(SN,1,Length(SN));
  if NameF = ''  then  begin ECode:=11;  end;

end;

except
on E:  EAccessViolation do ECode:=11;
end;

ler:
if (ECode = 0) and (E_Code = 0)   then
begin
 if FS.N = 0  then  FS.CalcConst:=_NO;   {.203} //func1(): real=sin(x)
 ForevZ.SetFunction(NameF,FS)
end
else
begin
  if E_Code <> 0 then  ForevZ.SyntaxError:=E_Code else ForevZ.SyntaxError:=E_ERROR_AT_ADDITION_OF_FUNCTION;
  ForevZ.SyntaxErrorString:=SError;
  ForevZ.IntException;
end;

endp:
end;




procedure fzPolarDP(pz: Pointer;  pz1: Pointer);   stdcall;
asm
  push eax
  mov eax, [pz]
  fld qword ptr [eax+8]
  fld qword ptr [eax]
  fpatan
  fld qword ptr [eax+8]
  fmul st(0),st(0)
  fld qword ptr [eax]
  fmul st(0),st(0)
  faddp
  fsqrt
  mov eax, [pz1]
  fstp qword ptr [eax]
  fstp qword ptr [eax+8]
  pop eax
end;


procedure fzPolarEP(pz: Pointer;  pz1: Pointer);     stdcall;
asm
  push eax
  mov eax, [pz]
  fld tbyte ptr [eax+16]
  fld tbyte ptr [eax]
  fpatan
  fld tbyte ptr [eax+16]
  fmul st(0),st(0)
  fld tbyte ptr [eax]
  fmul st(0),st(0)
  faddp
  fsqrt
  mov eax, [pz1]
  fstp tbyte ptr [eax]
  fstp tbyte ptr [eax+16]
  pop eax
end;


procedure fzDecartDP(pz: Pointer;  pz1: Pointer);  stdcall;
asm
  push eax
  mov eax, [pz]
  fld qword ptr [eax+8]
  fsincos
  fmul qword ptr [eax]
  fxch
  fmul qword ptr [eax]
  fxch
  mov eax, [pz1]
  fstp qword ptr [eax]
  fstp qword ptr [eax+8]
  pop eax
end;



procedure fzDecartEP(pz: Pointer;  pz1: Pointer);    stdcall;
asm
  push eax
  mov eax, [pz]
  fld tbyte ptr [eax+16]
  fsincos
  fld tbyte ptr [eax]
  fmulp
  fxch
  fld tbyte ptr [eax]
  fmulp
  fxch
  mov eax, [pz1]
  fstp tbyte ptr [eax]
  fstp tbyte ptr [eax+16]
  pop eax
end;





procedure fzSetLength(AdrV: Pointer; TypeV: Cardinal; Len: Cardinal);  stdcall;
begin

if TypeV = fz_ARRAY_REAL_DOUBLE then
begin
  SetLength(PArrayD(AdrV)^,Len);
end
else
if TypeV = fz_ARRAY_REAL_EXTENDED then
begin
  SetLength(PArrayE(AdrV)^,Len);
end
else
if TypeV = fz_ARRAY_REAL_INTEGER then
begin
  SetLength(PArrayI(AdrV)^,Len);
end

end;




procedure fzSetArrayValueI(AdrV: Pointer; indx: Cardinal; Val: integer);  stdcall;
begin
 PArrayI(AdrV)^[indx]:=Val;
end;


procedure fzSetArrayValueD(AdrV: Pointer; indx: Cardinal; Val: double);  stdcall;
begin
 PArrayD(AdrV)^[indx]:=Val;
end;


procedure fzSetArrayValueE(AdrV: Pointer; indx: Cardinal; Val: extended);  stdcall;
begin
 PArrayE(AdrV)^[indx]:=Val;
end;




procedure fzGetArrayValueI(AdrV: Pointer; indx: Cardinal; var Val: integer);  stdcall;
begin
 Val:=PArrayI(AdrV)^[indx];
end;


procedure fzGetArrayValueD(AdrV: Pointer; indx: Cardinal; var Val: double);  stdcall;
begin
 Val:=PArrayD(AdrV)^[indx];
end;


procedure fzGetArrayValueE(AdrV: Pointer; indx: Cardinal; var Val: extended);  stdcall;
begin
 Val:=PArrayE(AdrV)^[indx];
end;






function PtrToStr(P: Pointer): String;
var
S: String;
S1,S2: AnsiString;
begin
 if _STRINGTYPE = fz_STRING then
 begin
  Str:=String(P);
  S:=Copy(Str,1,Length(Str));
  Str:='';
 end
 else
 if  _STRINGTYPE = fz_ANSISTRING then
 begin
   _SetStrPCh(P);
   S:=Str;
   //S:=String(PAnsiChar(P))
 end
 else
 if  _STRINGTYPE = fz_WIDESTRING then
 begin
  Sws:=WideString(p);
  Str:=String(Copy(Sws,1,Length(Sws)));
  S:=Str;
  Sws:='';
 end
 else
 if  _STRINGTYPE = fz_STRING_UTF8 then
 begin
   {$IFDEF FPC}
    Su8:=UTF8String(p);
    Str:=String(Su8);
    S:=Copy(Str,1,Length(Str));
    Su8:='';
   {$ELSE}
   //for Delphi:
    Str:=StringOf(P);
    S:=Copy(Str,1,Length(Str));
    Str:='';
   {$ENDIF}

  {Su8:=UTF8String(p);
  S1u8:=Copy(Su8,1,Length(Su8));
  Sws:=Utf8Decode(S1u8);
  Str:=String(Copy(Sws,1,Length(Sws)));
  S:=Str;
  Su8:='0';
  }
  {Su8:=UTF8String(p);
  S1u8:=Copy(Su8,1,Length(Su8));
  Str:=String(S1u8);
  S:=Str;
  Su8:='0'; }
 end
 else
 if  _STRINGTYPE = fz_PANSICHAR then
 begin
  _SetStrPCh(P);
  S:=Str;
  {S1:=PAnsiChar(P);
  S2:=Copy(S1,1,Length(S2));
  S:=S2;}
  //S1:=
  //S:=String(PAnsiChar(P))
  //S:=String(P)
 end;
 {else
 if  _STRINGTYPE = fz_PWIDECHAR then S:=String(PWideChar(P));}


 PtrToStr:=Copy(S,1,Length(S));
end;




function StrToPtr(S: String): Pointer;
var
P: Pointer;
begin
 if _STRINGTYPE = fz_STRING then
 begin
   Str:=S;
   StrToPtr:=Pointer(PChar(Str))
 //StrToPtr:=Pointer(S)
 end
 else
 if _STRINGTYPE = fz_ANSISTRING then
 begin
   {Str:=S;
   _GetStrPCh(P);
   StrToPtr:=Pointer(P); }
   SAns:=AnsiString(Copy(S,1,Length(S)));
   StrToPtr:=Pointer(PAnsiChar(Sans))
 end
 else
 if  _STRINGTYPE = fz_WIDESTRING then
 begin
   Sws:=WideString(Copy(S,1,Length(S)));
   StrToPtr:=PWideString(Sws);
 end
 else
 if  _STRINGTYPE = fz_STRING_UTF8 then
 begin
   Su8:=UTF8String(Copy(S,1,Length(S)));
   StrToPtr:=PUTF8String(Su8);
   {Sws:=WideString(Copy(S,1,Length(S)));
   StrToPtr:=Pointer(Utf8Encode(Sws));
   }
 end
 else
 if  _STRINGTYPE = fz_PANSICHAR then
 begin
  //StrToPtr:=(PAnsiChar(S));
   SAns:=AnsiString(Copy(S,1,Length(S)));
   StrToPtr:=Pointer(PAnsiChar(Sans))
 end;
end;


procedure DeleteSpace(S: String; var S1: String);
label 1,2;
var i,p: Integer;
begin
if Length(S) > 0 then
begin
 {.217}
//S:=StringReplace(S,' ','',[rfReplaceAll, rfIgnoreCase]);
S:=StringReplace(S,#9,'',[rfReplaceAll, rfIgnoreCase]);    //Tab

i:=Length(S);

 while i >= 1 do
 begin
    if S[i] = ' ' then
   begin
    Delete(S,i,1);
   end;
  dec(i);
 end;


1:
if S[Length(S)] = ';' then begin Delete(S,Length(S),1); goto 1; end;

2:
p:=pos(';;',S);
if p > 0 then  begin Delete(S,p,1); goto 2; end;

if S[1] = ';' then Delete(S,1,1);

end;

S1:=Copy(S,1,Length(S));
end;



procedure FreeFunction(Func: Cardinal);
var
i: Integer;
begin
if Func <> 0 then
begin
For i:=0 to High(CompZ) do
 begin
  if Func = CompZ[i].Func.Addr then
  begin
   ForevZ.FreeExtFunc(@CompZ[i].Func);   {.225}
   CompZ[i].Func.Addr:=0;
  end;
 end;
end;
end;


procedure FreeCmplFuncList;
var
i: Integer;
begin
For i:=1 to Length(CompZ)-1 do
 begin
  if CompZ[i].Func.Addr <> 0 then
  ForevZ.FreeExtFunc(@CompZ[i].Func);   {.225}
 end;
end;


procedure SetReg(Reg,Mode: Integer);
var
R,C: Integer;
begin
//R:=Reg-_EAX+1;
C:=Mode-_CLEAR;
ForevZ.SetRegA(Reg,C);
end;



procedure  pcGetFuncVarName(S: String; var FN: String; var VNS: TArraySt);
var                                        //S=Func(x1,x2,...,xn)
  i,N,P,L: Integer;
begin
 VNS:=nil;
 N:=pos('(',S);
 if N <> 0  then
 begin
  FN:=Copy(S,1,N-1);   P:=N+1; L:=Length(S);
  for i := N+1 to L - 1 do
  begin
   if S[i] = ',' then begin  SetLength(VNS,Length(VNS)+1); VNS[High(VNS)]:=Copy(S,P,i-P); P:=i+1; end;
  end;
  SetLength(VNS,Length(VNS)+1); VNS[High(VNS)]:=Copy(S,P,L-P);
  if VNS[High(VNS)] = '' then   SetLength(VNS,0);  {.203} {.xxx}    //fnc():real=1.123
 end
 else
 begin
   E_Code:=14{fz_ERROR_AT_ADDITION_FUNCTION};
 end;

end;


procedure pcFindVar(S: String; NV: String; P: Integer;  var Bl: Boolean; var NNV: String);
var
i,LV,LS: Integer;
begin
LV:=Length(NV);
LS:=Length(S);
Bl:=False;
if (P = 1) and (LV = LS) then Bl:=True
else
if P = 1 then
begin
 if (S[P+LV] = '+') or (S[P+LV] = '-') or (S[P+LV] = '/') or
    (S[P+LV] = '*') or (S[P+LV] = '^') or (S[P+LV] = '!') or (S[P+LV] = '[') or
    (S[P+LV] = ';') or (S[P+LV] = '.') or (S[P+LV] = '_') or (S[P+LV] = '=') then
    begin
      Bl:=True;
    end;
end
else
if P = LS-LV+1  then
begin
  if (S[P-1] = '+') or  (S[P-1] = '-') or (S[P-1] = '*')  or
     (S[P-1] = '/') or  (S[P-1] = '^') or (S[P-1] = ';')  then
   begin
     Bl:=True;
   end;
end
else
if ((S[P-1] = '(')  or  (S[P-1] = '{') or (S[P-1] = '[')  or
    (S[P-1] = '+')  or  (S[P-1] = '-') or (S[P-1] = '*')  or
    (S[P-1] = '/')  or  (S[P-1] = '^') or (S[P-1] = '|')  or
    (S[P-1] = ',')  or  (S[P-1] = '=') or (S[P-1] = '<')  or (S[P-1] = '>') or (S[P-1] = ';'))
    and
   ((S[P+LV] = '+') or (S[P+LV] = '-') or (S[P+LV] = '/') or
    (S[P+LV] = '*') or (S[P+LV] = '^') or (S[P+LV] = '!') or
    (S[P+LV] = ')') or (S[P+LV] = ']') or (S[P+LV] = '}') or
    (S[P+LV] = '|') or (S[P+LV] = '[') or (S[P+LV] = ',') or
    (S[P+LV] = '=') or (S[P+LV] = '<') or (S[P+LV] = '>') or
    (S[P+LV] = ';') or (S[P+LV] = '.') or (S[P+LV] = '_'))
    then
   begin
     Bl:=True;
   end;


if Bl = True then begin {NNV:=NV+'#'+IntToStr(F_CurrentIntFunc);} NNV:=NV; end;       {###}
//F_CurrentIntFunc -  -  fl_PreCompiled

end;


function pcPosN(S: String; FS: String; P: Integer): Integer;
label 1, endp;
var
 N,i,j,L,LFS: Integer;
begin
L:=Length(S);
LFS:=Length(FS);
pcPosN:=0;
for i := P to L-LFS+1 do     {.197}
begin
    for j := 1 to LFS do
    begin
    {
      if ForevZ.VarShift = False then
      begin
       if LowerCase(S[i+j-1]) <> LowerCase(FS[j]) then  goto 1
      end
      else
       if (S[i+j]) <> (FS[j]) then  goto 1;
       }
       if S[i+j-1] <> FS[j] then  goto 1;     {.221}
    end;
    pcPosN:=i; goto endp;
1:
end;

endp:
end;


procedure pcSetIntVar(VNS: TArraySt; ATL: TArrayI);
label endp;
var
FD1,FD2: PInternalVar;
LS,LL,i: Integer;
SN,SV,num: String;
Bl: Boolean;
begin

LS:=Length(VNS); LL:=Length(ATL);
//LS=LL!!!
SetLength(CVA,LS);
SetLength(CurrentNameSet,0);
for i := 0 to LS-1 do
begin
  if IsCurrentSet(VNS[i]) = False then      {.221}
  begin
    new(FD1); FD1^.Next:=nil;

    {FD1^.Name:=Copy(LowerCase(VNS[i]),1,Length(VNS[i]))+'#'+IntToStr(F_CurrentIntFunc);}
    FD1^.Name:=Copy(VNS[i],1,Length(VNS[i]));
    PushVar(FD1^.Name);
    _SetVar(FD1^.Name,@FD1^.Variable,ATL[i]{fl_Extended});
    CVA[i]:=TAddress(@FD1^.Variable);
    InternalVarList^.Next:=FD1;
    InternalVarList:=FD1;
  end
  else
  begin
    E_Code:=E_VARIABLE_REDECLARED;
    PopVar;                   {.229}
    goto endp;
  end;

  WriteCurrentSet(VNS[i]);
end;

endp:
end;



procedure pcFreeIntVar;
var
FD1,FD2: PInternalVar;
begin

FD1:=BInternalVarList;
while FD1 <> nil do
begin
 FD2:=FD1^.Next;
 {SetLength(FD1^.VecD,0);
 SetLength(FD1^.VecE,0);
 SetLength(FD1^.VecI,0); }
 FD1^.VecD:=nil;
 FD1^.VecE:=nil;
 FD1^.VecI:=nil;
 FD1^.Name:='';
 dispose(FD1);
 FD1:=FD2;
end;

end;



procedure pcSetFunc(VNS: TArraySt; S: String; var SF: String);
label 1;
var
 P,i,L,BP: Integer;
 NNV,S1: String;
 Bl: Boolean;
 SN: String;
begin

 pcSetIntVar(VNS,ATL);

 L:=Length(VNS);

 for i:=0 to L-1  do
 begin
  P:=1; BP:=1;
1:
  P:=pcPosN(S,VNS[i],BP);  // G_int1:=i;   : 
  if P <> 0 then
  begin
    pcFindVar(S,VNS[i],P,Bl,NNV);
    if Bl = True then
    begin
      Delete(S,P,Length(VNS[i]));
      Insert(NNV,S,P);
      BP:=P+Length(NNV);
    end
    else
    BP:=BP+1;
    goto 1;
  end;

 end;

 SF:=Copy(S,1,Length(S));
end;




function  _ResultR(Func: Cardinal): extended;
asm
   call Func
end;



procedure _ResultC(Func: cardinal; var Res: TComplexE);
var
p:TComplexE;
begin
 asm
   call Func
   push eax
   mov  eax, [res]
   fstp tbyte ptr [eax]
   fstp tbyte ptr [eax+16]
   pop  eax
  end;
end;




procedure _SetVar(Name: String; Addr: Pointer; TV: Cardinal);
var
TypeV,MType: Integer;
begin

 case TV of
  fz_Real_Double:            begin TypeV:=T_Real;    MType:=_Double; end;
  fz_Real_Extended:          begin TypeV:=T_Real;    MType:=_Extended; end;
  fz_Complex_Double:         begin TypeV:=T_Complex; MType:=_Double; end;
  fz_Complex_Extended:       begin TypeV:=T_Complex; MType:=_Extended; end;
  fz_Array_Real_Double:      begin TypeV:=T_Array;   MType:=_Double; end;
  fz_Array_Real_Extended:    begin TypeV:=T_Array;   MType:=_Extended; end;
  fz_Array_Real_Integer:     begin TypeV:=T_Array;   MType:=_Integer; end;
  fz_Real_Integer:           begin TypeV:=T_Real;    MType:=_Integer; end;
 end;
 ForevZ.SetObject(Name,Cardinal(Addr),TypeV,MType)
end;





procedure _SyntaxExtComReplaceIfName(S1: String; var S2: String);
label 1,2;
const EnName = ['(','{','[','|','*','/','>','<','=','+','^','-',',',';'];
var
p,cp: integer;
SL: String;                            //x+iff(
Bxh: Boolean;                          //x+piff(
begin
cp:=1;
1:
{SL:=LowerCase(S1);} SL:=S1;

p:=posEx('iff(',SL,cp);

if p <> 0 then
begin
 Bxh:=False;
 if (p > 1) then
 begin
   if S1[p-1] in  EnName = true then Bxh:=True
 end
 else Bxh:=True;

 if Bxh = True then Delete(S1,p+1,1); cp:=cp+2;
 goto 1;
end;


cp:=1;
2:
{SL:=LowerCase(S1);} SL:=S1;

p:=posEx('ifp(',SL,cp);

if p <> 0 then
begin
 Bxh:=False;
 if (p > 1) then
 begin
   if S1[p-1] in  EnName = true then Bxh:=True
 end
 else Bxh:=True;

 if Bxh = True then  Delete(S1,p+2,1); cp:=cp+2;
 goto 2;
end;


S2:=S1;
end;


{.191}
function FindNewVar(SA: String; SF: String; VT: Cardinal; MT: Cardinal): Boolean;
label nxtsrchi,nxtsrchf,nxtsrchc,endp;
var
 ST1,ST2,SA1,SF1,S1,S2: String;
 ResF: Boolean;
 P: Cardinal;
 i,rp,ip,TF,pf: Integer;
begin
ResF:=False;

SA1:=SA; SF1:=SF;



if (VT = T_Real) and (MT = _Integer) then
  begin

    for i := 0 to Length(SNInt)-1 do
    begin
      S1:=SA1+':'+SNInt[i];
      //P:=Pos(S1,SF1);

      pf:=1;              {.211}
      nxtsrchi:
      P:=PosEx(S1,SF1,pf);

      if P = 1 then
      begin
        ResF:=True;
        goto endp;
      end
      else
      if P > 1 then
      begin
        if SF1[P-1] = ';' then
        begin
           ResF:=True;
           goto endp;
        end
        else        {.211}  // max:int=0; x:int=0; for(x,...)
        begin
          pf:=pf+Length(S1);
          if pf >= Length(SF1) then goto endp
           else goto nxtsrchi;
        end;
      end;
    end;

  end;


if (VT = T_Real) and ((MT = _Double) or (MT = _Extended))  then
  begin

    for i := 0 to Length(SNReal)-1 do
    begin
      S1:=SA1+':'+SNReal[i];
      //P:=Pos(S1,SF1);
      pf:=1;              {.211}
      nxtsrchf:
      P:=PosEx(S1,SF1,pf);

      if P = 1 then
      begin
        ResF:=True;
        goto endp;
      end
      else
      if P > 1 then
      begin
        if SF1[P-1] = ';' then
        begin
           ResF:=True;
           goto endp;
        end
        else        {.211}  // max:ext=0; x:ext=0; for(x,...)
        begin
          pf:=pf+Length(S1);
          if pf >= Length(SF1) then goto endp
           else goto nxtsrchf;
        end;
      end;
    end;

  end;



if (VT = T_Complex)  then
  begin
     _FindReIm(SA1,SA1,TF);
     if TF = 0  then goto endp;

     {
     rp:=pos('.re',LowerCase(SA1));
     if (rp <> 0) and (rp = Length(SA1)-2) then
     begin
        //SA1:=Copy(SA1,1,Length(SA1)-3);
        Delete(SA1,Length(SA1)-2,3);
     end
     else
     begin
        ip:=pos('.im',LowerCase(SA1));
        if (ip <> 0) and (ip = Length(SA1)-2) then
        begin
          //SA1:=Copy(SA1,1,Length(SA1)-3);
          Delete(SA1,Length(SA1)-2,3);
        end
        else
        begin
          goto endp;
        end;
      end;

     }
    for i := 0 to Length(SNCmplx)-1 do
    begin
      S1:=SA1+':'+SNCmplx[i];
      //P:=Pos(S1,SF1);

      pf:=1;              {.211}
      nxtsrchc:
      P:=PosEx(S1,SF1,pf);

      if P = 1 then
      begin
        ResF:=True;
        goto endp;
      end
      else
      if P > 1 then
      begin
        if SF1[P-1] = ';' then
        begin
           ResF:=True;
           goto endp;
        end
        else        {.211}  // max:extcx=0; x:extcx=0; ...
        begin
          pf:=pf+Length(S1);
          if pf >= Length(SF1) then goto endp
           else goto nxtsrchc;
        end;
      end;
    end;

  end;


endp:
FindNewVar:=ResF;
end;



function _SyntaxExtComSep(SM: String; ps,lens,typef: integer): boolean;
var
str: String[1];             //typef=0: if
begin                       //typef=1: for,fordown,while
_SyntaxExtComSep:=True;

//if typef = 0 then
begin

 if ps+lens < Length(SM) then
 begin
  str:=SM[ps+lens+1];
  if (str <> ';') and (str <> ')') and (str <> ',') then
  begin
    _SyntaxExtComSep:=false;
  end;
 end;

end
(*else
begin
 //after : for();  for(),  for())
 if ps+lens < Length(SM) then
 begin
  str:=SM[ps+lens+1];
  if (str <> ';') and (str <> ')') and (str <> ',') then
  begin
    _SyntaxExtComSep:=false;
  end;
 end;
 //before:  ;for()   ,for()
 if ps > 1 then
 begin
  str:=SM[ps-1];
  if (str <> ';') and (str <> ',') then
  begin
    _SyntaxExtComSep:=false;
  end;
 end;

end;
*)
end;




function _CheckOperatorPlacement(SF: String; bpos,epos: integer): boolean;
label endp;
const EnName = ['(','{','[','|','*','/','>','<','=','+','^','-',',',';'];
var
BH: boolean;
Len: integer;
p: integer;
Bch: Boolean;
s1,s2: string;
begin                  //if(x<y, if(x>t,x=x+1), if(x>=y,x=x-1)); x
                       //-for(i,1,10,if({i/3}=0,x=x+1)); x
BH:=False;
Len:=Length(SF);

if (bpos-1 >= 1) and (epos+1 <= Len)  then
begin
//s1:=SF[bpos-1]; s2:=SF[epos+1];
  if ((SF[bpos-1] = ',') and (SF[epos+1] = ',')) or
     ((SF[bpos-1] = ',') and (SF[epos+1] = ';')) or
     ((SF[bpos-1] = ';') and (SF[epos+1] = ';')) or
     ((SF[bpos-1] = ';') and (SF[epos+1] = ')')) or
     ((SF[bpos-1] = ',') and (SF[epos+1] = ')')) or
     ((SF[bpos-2] = '>') and (SF[bpos-1] = '>') and (SF[epos+1] = ')')) or
     ((SF[bpos-2] = '>') and (SF[bpos-1] = '>') and (SF[epos+1] = ';'))
     then
     BH:=True;
end
else
if (bpos-1 < 2) and (epos+1 <= Len)  then
begin
  if  (SF[epos+1] = ';') then BH:=True;
end
else
if (bpos-1 >= 2) and (epos+1 > Len)  then
begin
  if
     (SF[bpos-1] = ';')  or
     ((SF[bpos-2] = '>') and (SF[bpos-1] = '>'))
     then
     BH:=True;
end
else
if (bpos = 1) and (epos = Len) then   {.195}
 BH:=True;



(*
//       if, iff, ifp (      -   )
//if(x<y, if(x>t,x=x+1), if(x>=y,x=x-1)); x
if BH = True then
begin
  //'if('  'iff(' 'ifp('
  Bch:=False;
  p:=pos('if',LowerCase(SF));
  if p <> 0 then
  begin
    if (p > 1) then
    begin
        if SF[p-1] in  EnName = true then Bch:=True
    end
    else Bch:=True;

    if (Bch = True) and (p < bpos) then
    begin
       BH:=False;   goto endp;
    end;

  end;

  p:=pos(LowerCase(SF),'iff(');
  if p <> 0 then
  begin

  end;

  p:=pos(LowerCase(SF),'ifp(');
  if p <> 0 then
  begin

  end;

end;
*)

endp:
_CheckOperatorPlacement:=BH;
end;




function _CheckSyntaxExtCom(SM: String; pf,lens,typef: integer): boolean;
var
BH: boolean;
begin
BH:=True;

 if _SyntaxExtComSep(SM,pf,lens,typef) = False then
       begin
          E_Code:=E_MISSING_SEPARATOR;
          if lens+1 >= Length(SM)  then lens:=Length(SM)-1;
          if pf > 1 then pf:=pf-1;
          SError:=copy(SM,pf,lens+1);
          BH:=False;
       end
 else
 if _CheckOperatorPlacement(SM,pf,lens+pf) = False then
  begin
     E_Code:=E_WRONG_EXPRESSION;
     if pf-1 = 0 then pf:=1;
     if lens+2 >= Length(SM)  then lens:=Length(SM)-2;
     SError:=copy(SM,pf-1,lens+2);
     BH:=False;
  end;

  _CheckSyntaxExtCom:=BH;
end;






procedure _SyntaxExtCom_CorrectLab(S1: String; var S2: String);
label nxt;
var
i,p: integer;
begin

nxt:
 p:=pos('>>;',S1);

 if p <> 0 then
 begin
   delete(S1,p+2,1);
   goto nxt;
 end;

S2:=S1;
end;


{.191}
procedure _SyntaxExtCom_FindArg(SM,SF: String; cp: integer; var NArg,lensf,pf: Integer; var S1,S2,S3,S4,S5: String);
label endf,endp, endf2;
//const EnName = ['>',',',';'];
const EnName = ['>',',',';','+'];                                      //x+iff(x<y,x=x+1;y=y+1;x+y)+y
var
SF1,SMlc: String;
i,n,p,cna,ls,br,lf,lens: integer;
arp: array of integer;
FA1: Boolean;
begin
{
SF=if, for, ,fordown, while
}


FA1:=False;
SF1:=SF+'(';
ls:=Length(SM);
lf:=Length(SF);
NArg:=0;
SetLength(arp,0);

{SMlc:=LowerCase(SM); } SMlc:=SM;
p:=posEx(SF1,SMlc,cp);

if p <> 0 then
begin

   if p > 1 then
   begin
     if SMlc[p-1] in  EnName = false  then //other function
     begin
       NArg:=0;
       goto endp;
     end;
   end;


   br:=0;
   for i := p+lf+1 to ls do
   begin
    if (SM[i] = '(') or (SM[i] = '{') or (SM[i] = '[') {or (SM[i] = '|')} then dec(br) else
    if (SM[i] = ')') or (SM[i] = '}') or (SM[i] = ']') {or (SM[i] = '|')} then inc(br);

    if (br = 1) then
    begin
      FA1:=True; lens:=i; goto endf;               {.195}
    end;

    if (br = 0) and (SM[i] = ',') then
    begin
      SetLength(arp,Length(arp)+1);
      arp[High(arp)]:=i;
      inc(NArg);
    end;

   end;

end;

endf:
if NArg > 0  then
begin
 inc(NArg);
 SetLength(arp,Length(arp)+1);
 arp[High(arp)]:=lens;
end
else
if (NArg = 0) and (FA1 = True) then   {.195}   //while(n>0)
begin
   NArg:=1;
   S1:=Copy(SM,p+lf+1,lens-(p+lf+1));
   goto endf2;
end;



case NArg of
1: S1:=Copy(SM,p+lf,arp[0]-(p+lf)) ;
2: begin S1:=Copy(SM,p+lf+1,arp[0]-(p+lf+1)) ; S2:=Copy(SM,arp[0]+1,arp[1]-arp[0]-1);  end;
3: begin S1:=Copy(SM,p+lf+1,arp[0]-(p+lf+1)) ; S2:=Copy(SM,arp[0]+1,arp[1]-arp[0]-1); S3:= Copy(SM,arp[1]+1,arp[2]-arp[1]-1);   end;
4: begin S1:=Copy(SM,p+lf+1,arp[0]-(p+lf+1)) ; S2:=Copy(SM,arp[0]+1,arp[1]-arp[0]-1); S3:= Copy(SM,arp[1]+1,arp[2]-arp[1]-1); S4:=Copy(SM,arp[2]+1,arp[3]-arp[2]-1);   end;
5: begin S1:=Copy(SM,p+lf+1,arp[0]-(p+lf+1)) ; S2:=Copy(SM,arp[0]+1,arp[1]-arp[0]-1); S3:= Copy(SM,arp[1]+1,arp[2]-arp[1]-1); S4:=Copy(SM,arp[2]+1,arp[3]-arp[2]-1); S5:=Copy(SM,arp[3]+1,arp[4]-arp[3]-1);   end;
end;


endf2:
lensf:=lens-p;
pf:=p;

endp:
end;



procedure _SyntaxExtCom_FindSubArg(SArg,Ssub: String; var ps: integer);
label endp;
var
i,br: integer;
begin
ps:=0;
br:=0;
for I := 1 to Length(SArg) do
  begin
    if (SArg[i] = '(') (*or (SArg[i] = '{') or (SArg[i] = '[')*) {or (SM[i] = '|')} then dec(br) else
    if (SArg[i] = ')') (*or (SArg[i] = '}') or (SArg[i] = ']')*) {or (SM[i] = '|')} then inc(br);

    if (br = 0) and (SArg[i] = Ssub) then
    begin
      ps:=i;
      goto endp;
    end;

  end;

endp:
end;






procedure _SyntaxExtCom_IF(SFin:String; var SFout: String);

   function FindFirstProc(S: String): boolean;
      var
      Sc: String;
      pp: integer;
      BH: Boolean;
   begin
      BH:=False;
      {Sc:=LowerCase(S);} Sc:=S;
      pp:=pos('ifp(',Sc);
      if pp = 1 then BH:=True
      else
      pp:=pos('for(',S);
      if pp = 1 then BH:=True
      else
      pp:=pos('fordown(',S);
      if pp = 1 then BH:=True
      else
      pp:=pos('while(',S);
      if pp = 1 then BH:=True;

      FindFirstProc:=BH;
   end;

label endp, nxt1;
var
SM,SMlc,SF,S1,S2,S3,S4,S5,SR,S2c: String;
cp,NArg,lens,ps1,ps2,ps3,ps4,pf: Integer;
Bch: Boolean;
str: string[1];
begin
{
if(cond,expA1,expA2;...;expAn) ->
if(cond,goto(lab$1),goto(Lab$2));Lab$1>>expA2;...;expAn; Lab$2>>
//if(x<y,x=sin(y),x=cos(y); y=sin(x))
//if(x<y,proc1(x1),proc2(x,y))
//if(x<y,proc1(x1))
//if(x<y,x=proc1(x1))
//if(x<y,proc1(x1); proc2(x))
//if(x<y,proc1(x1);proc2(x,y),proc3(x))
//if(x<y,proc1(x1),x=proc2(x,y))
//';' / '='      S1,S2

if(cond,expA1, expA2;...; expAn , exprB1; exprB2;...;exprBn) ->
if(cond,goto(lab$1),goto(Lab$2));Lab$1>>expA2;...;expAn; goto(Lab$3); Lab$2>> exprB1; exprB2;...;exprBn; Lab$3>>
}

//k=0;ifp(n>5,inc(k));k   !!!!!!!!!!!

SM:=SFin;
SF:='ifp';


cp:=1;

nxt1:
Bch:=False;

_SyntaxExtCom_FindArg(SM,SF,cp,NArg,lens,pf,S1,S2,S3,S4,S5);

if (NArg = 0) and (SF = 'ifp') then
begin
 SF:='if';
 cp:=1;
 goto nxt1;
end;

if NArg > 0 then
begin
//find in S2 and S3  ';' or '=' or :  'if(' , 'for( , fordown( , 'while(  in first position

//if(x<y, if(x>t,x=x+1)); x  !!!!!!!ERROR if(x<y, if(x>t,x=x+1); y=y); x

  if NArg = 1 then             {.195} //if(n>0)
  begin
    if (S1 = '')  then
    begin
     E_Code:=E_MISSING_EXPRESSION;
     SError:=copy(SM,pf,lens+1);
    end;
     goto endp;
  end;

  if NArg = 2  then
  begin
   if (S1 = '') or (S2 = '') then
   begin
     E_Code:=E_MISSING_EXPRESSION;
     SError:=copy(SM,pf,lens+1);
     goto endp;
   end;

    _SyntaxExtCom_FindSubArg(S2,';',ps1);
    if ps1 = 0 then
    begin
      _SyntaxExtCom_FindSubArg(S2,'=',ps2);
      if ps2 <> 0 then Bch:=True
      else
        if ps2 = 0 then
        begin
          if FindFirstProc(S2) =  True then Bch:=True;
          if (SF = 'ifp') and (Bch = False) then Bch:=True;   //k=0;ifp(n>5,inc(k));k   !!!!!!!!!!!
        end;
    end
    else Bch:=True;
  end

  else


  if NArg = 3  then
  begin

    if (S1 = '') or (S2 = '') or (S3 = '') then
    begin
      E_Code:=E_MISSING_EXPRESSION;
      SError:=copy(SM,pf,lens+1);
      goto endp;
    end;

    _SyntaxExtCom_FindSubArg(S2,';',ps1);
    if ps1 = 0 then
    begin
      _SyntaxExtCom_FindSubArg(S2,'=',ps2);
      if ps2  = 0 then
      begin
        _SyntaxExtCom_FindSubArg(S3,';',ps3);
        if ps3 = 0 then
        begin
         _SyntaxExtCom_FindSubArg(S3,'=',ps4);
          if ps4 <> 0 then Bch:=True;
        end
        else Bch:=True;
      end
      else
      Bch:=True;
    end
    else Bch:=True;
    //if(x<y, if(x>t,x=x+1), if(x>=y,x=x-1)); x       !!!!!!!!!!!!ERROR!!!!!!!!!
    if Bch = False then
    begin
      if FindFirstProc(S2) =  True then Bch:=True else
      if FindFirstProc(S3) =  True then Bch:=True;
      if (SF = 'ifp') and (Bch = False) then Bch:=True;   {.195}   //ifp(n<k,inc(n),inc(k))   !!!!!!!!!!!!ERROR!!!!!!!!!
    end;
  end
  else
  begin
    E_Code:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
    SError:=copy(SM,pf,lens+1);
    goto endp;
  end;

  if Bch = true then
  begin
     //replace
    //if(cond,expA1,expA2;...;expAn) ->
    //if(cond,goto(lab$1),goto(Lab$2));Lab$1>>expA1;...;expAn; Lab$2>>

    //after replaceable if() must be ';' or ')' or end of string!!!!!
    (*if _SyntaxExtComSep(SM,pf+lens) = False then
       begin
          E_Code:=E_MISSING_SEPARATOR;
          SError:=copy(SM,pf,lens+1);
          goto endp;
       end;

    if _CheckOperatorPlacement(SM,pf,lens+pf) = False then
      begin
        E_Code:=E_WRONG_EXPRESSION;
        SError:=copy(SM,pf-1,lens+2);
        goto endp;
      end;
    *)


    if _CheckSyntaxExtCom(SM,pf,lens,0) = false then goto endp;

    if NArg = 2 then
    begin
    //if(x<y,x=sin(y))->                         if(x<y ,goto(lab$1), goto(Lab$2)); Lab$1>> x=sin(y); Lab$2>>
    //if(x<y,proc1(x1);proc2(x,y))->             if(x<y ,goto(lab$1), goto(Lab$2)); Lab$1>> roc1(x1); proc2(x,y); Lab$2>>
    //if(x<y,proc1(x1))           ->             if(x<y,proc1(x1))
    //if(x<y,x=proc1(x1); y=proc2(x2))->         if(x<y ,goto(lab$1), goto(Lab$2)); Lab$1>> x=proc1(x1); y=proc2(x,y); Lab$2>>

     {.195}
     if S2[Length(S2)] = ';'  then  Delete(S2,Length(S2),1);

     SR:='if('+S1+','+'goto(lab$'+IntToStr(LabCount)+'),goto(lab$'+IntToStr(LabCount+1)+'));lab$'+IntToStr(LabCount)+'>>'+S2+';lab$'+IntToStr(LabCount+1)+'>>';
     LabCount:=LabCount+2;

     delete(SM,pf,lens+1);
     insert(SR,SM,pf);
    end
    else
    if NArg = 3 then
    begin
      //replace
     //if(cond, expA1, expA2;...; expAn , exprB1; exprB2;...;exprBn) ->
     //if(cond,goto(lab$1),goto(Lab$2));Lab$1>>expA2;...;expAn; goto(Lab$3); Lab$2>> exprB1; exprB2;...;exprBn; Lab$3>>

     {.195}
     if S2[Length(S2)] = ';'  then  Delete(S2,Length(S2),1);
     if S3[Length(S3)] = ';'  then  Delete(S3,Length(S3),1);



     SR:='if('+S1+','+'goto(lab$'+IntToStr(LabCount)+'),goto(lab$'+IntToStr(LabCount+1)+'));lab$'+IntToStr(LabCount)+'>>'+S2+';goto(lab$'+IntToStr(LabCount+2)+');lab$'+IntToStr(LabCount+1)+'>>'+S3+';lab$'+IntToStr(LabCount+2)+'>>';
     LabCount:=LabCount+3;

     delete(SM,pf,lens+1);
     insert(SR,SM,pf);
    end
    else
    begin
      E_Code:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
      SError:=copy(SM,pf,lens+1);
      goto endp;
    end;

    //if(x<y , x=x+1;t= if(x>y , x=1.1; sin(x),cos(x)))
  end;

  inc(cp);
  goto nxt1;
end;

endp:
SFout:=SM;
end;





procedure _SyntaxExtCom_WHILE(SFin:String; var SFout: String);
label endp, nxt1;
var
SM,SF,S1,S2,S3,S4,S5,SR,SR1,SR2,SR3: String;
cp,NArg,lens,ps1,ps2,ps3,ps4,pf: Integer;
Bch: Boolean;
begin

{
  while(expr, exprA1; exprA2; ...;exprAn) ->
       lab$1>> if(expr,goto(Lab$2),goto(Lab$3)); Lab$2>> exprA1;exprA2;...;exprAn;  goto(lab$1) ;Lab$3>>
}

SM:=SFin;
cp:=1;


nxt1:
Bch:=False;
//SMlc:=LowerCase(SM);
_SyntaxExtCom_FindArg(SM,'while',cp,NArg,lens,pf,S1,S2,S3,S4,S5);



if NArg > 0 then
begin

   if NArg = 1 then   {.195}   //while(n>0)
   begin
    NArg:=2;
    S2:='#nop';
   end
   else
   if NArg <> 2  then
   begin
    E_Code:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
    SError:=copy(SM,pf,lens+1);
    goto endp;
   end;
  {
   if _SyntaxExtComSep(SM,pf+lens) = False then
       begin
          E_Code:=E_MISSING_SEPARATOR;
          SError:=copy(SM,pf,lens+1);
          goto endp;
       end;
  }
   if _CheckSyntaxExtCom(SM,pf,lens,1) = false then goto endp;



    if NArg = 2 then
    begin
       if (S1 = '') or (S2 = '') then
        begin
         E_Code:=E_MISSING_EXPRESSION;
         SError:=copy(SM,pf,lens+1);
         goto endp;
        end;


     {while(expr, exprA1; exprA2; ...;exprAn) ->
       lab$1>> if(expr,goto(Lab$2),goto(Lab$3)); Lab$2>> exprA1;exprA2;...;exprAn;  goto(lab$1) ;Lab$3>>
      }

      //t=0; x=0; y=5;  while(x<y, x=x+1;t=t+2); x+t

     {.195}
     if S2[Length(S2)] = ';'  then  Delete(S2,Length(S2),1);

     SR:= 'lab$'+IntToStr(LabCount)+'>>'+'if('+S1+',goto(lab$'+IntToStr(LabCount+1)+'),goto(lab$'+IntToStr(LabCount+2)+'));lab$'+IntToStr(LabCount+1)+'>>'+S2+';goto(lab$'+IntToStr(LabCount)+');'+'lab$'+IntToStr(LabCount+2)+'>>';
     LabCount:=LabCount+3;

     delete(SM,pf,lens+1);
     insert(SR,SM,pf);
    end;


  inc(cp);
  goto nxt1;
end;

endp:
SFout:=SM;
end;








procedure _SyntaxExtCom_FORDOWN(SFin:String; var SFout: String);
label endp, nxt1;
var
SM,SF,S1,S2,S3,S4,S5,SR,SR1,SR2,SR3: String;
cp,NArg,lens,ps1,ps2,ps3,ps4,pf: Integer;
Bch: Boolean;
adrV: Cardinal;
VT,MT: Cardinal;
begin
{
(var - only integer)

fordown(var,expr1,expr2,exprA1;exprA2;...;exprAn) ->
var=expr1; lab$1>> if(var < expr2,goto(Lab$2)); exprA1;exprA2;...;exprAn; dec(var); goto(lab$1) ;Lab$2>>

}

SM:=SFin;
cp:=1;


nxt1:
Bch:=False;
_SyntaxExtCom_FindArg(SM,'fordown',cp,NArg,lens,pf,S1,S2,S3,S4,S5);


if NArg > 0 then
begin

  if NArg = 3 then   {.195}   //fordown(n,5,0)
  begin
   NArg:=4;
   S4:='#nop';
  end;

  if NArg <> 4 then
  begin
   E_Code:=fz_WRONG_NUMBER_ARGUMENTS;
   SError:=copy(SM,pf,lens+1);
   goto endp;
  end;

  {
  if _SyntaxExtComSep(SM,pf+lens) = False then
       begin
          E_Code:=E_MISSING_SEPARATOR;
          SError:=copy(SM,pf,lens+1);
          goto endp;
       end;
   }

    if _CheckSyntaxExtCom(SM,pf,lens,1) = false then goto endp;

  begin


    if NArg = 4 then
    begin
      if (S1 = '') or (S2 = '') or (S3 = '') or (S4 = '') then
       begin
        E_Code:=fz_MISSING_EXPRESSION;
        SError:=copy(SM,pf,lens+1);
        goto endp;
       end;

      {.191}  //check loop var. for corectness:
      ForevZ.ExistVar(S1,adrV,VT,MT);
      if  (VT <> T_Real) or (MT <> _Integer) then
      begin
        if FindNewVar(S1,SFin,T_Real,_Integer) = False then
        begin
          E_Code:=E_INCORRECT_ARGUMENT;
          SError:=copy(SM,pf,lens+1);
          goto endp;
        end;
      end;

     {fordown(var,expr1,expr2,exprA1;exprA2;...;exprAn) ->
      var=expr1; lab$1>> if(var < expr2,goto(Lab$2)); exprA1;exprA2;...;exprAn; dec(var); goto(lab$1) ;Lab$2>>
     }
     //x=0;  fordown(i,5,1,x=x+1); x


     {.195}
     if S4[Length(S4)] = ';'  then  Delete(S4,Length(S4),1);

     SR:= S1+'='+S2+';'+'lab$'+IntToStr(LabCount)+'>>'+'if('+S1+'<'+S3+',goto(lab$'+IntToStr(LabCount+1)+'));'+S4+';dec('+S1+');'+'goto(lab$'+IntToStr(LabCount)+');'+'lab$'+IntToStr(LabCount+1)+'>>';
     LabCount:=LabCount+2;

     delete(SM,pf,lens+1);
     insert(SR,SM,pf);
    end;
  end;

  inc(cp);
  goto nxt1;
end;

endp:
SFout:=SM;
end;






procedure _SyntaxExtCom_FOR(SFin:String; var SFout: String);
label endp, nxt1;
var
SM,SF,S1,S2,S3,S4,S5,SR,SR1,SR2,SR3: String;
cp,NArg,lens,ps1,ps2,ps3,ps4,pf: Integer;
Bch: Boolean;
adrV: Cardinal;
VT,MT,ImU,CT,P: Cardinal;
begin
{

(var - only integer)
for(var,expr1,expr2,exprA1;exprA2;...;exprAn) ->
var=expr1; lab$1>> if(var > expr2,goto(Lab$2)); exprA1;exprA2;...;exprAn; inc(var); goto(lab$1) ;Lab$2>>

(var - only integer)
fordown(var,expr1,expr2,exprA1;exprA2;...;exprAn) ->
var=expr1; lab$1>> if(var < expr2,goto(Lab$2)); exprA1;exprA2;...;exprAn; dec(var); goto(lab$1) ;Lab$2>>

(var - any)
for(var,expr1,expr2,expr3,exprA1;exprA2;...;exprAn) ->
var=expr1; lab$1>> if(expr2,goto(Lab$2),goto(Lab$3)); Lab$2>> exprA1;exprA2;...;exprAn; var=expr3; goto(lab$1) ;Lab$3>>
//for(x,n+k,(2*x < n*k) or ( x < 100), x=x*2+n, exprA1;exprA2;...;exprAn)
}

SM:=SFin;
cp:=1;


nxt1:
Bch:=False;
_SyntaxExtCom_FindArg(SM,'for',cp,NArg,lens,pf,S1,S2,S3,S4,S5);



if NArg > 0 then
begin


 if NArg = 3 then   {.195}   //for(n,0,5)
  begin
   NArg:=4;
   S4:='#nop';
  end
 (*else
 if (NArg = 3) and (S4 = '') then  {.195}   //for(n,0,5,)
  begin
    S4:='#nop';
  end*)
 else
 if (NArg <> 4) and (NArg <> 5) then
  begin
   E_Code:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
   SError:=copy(SM,pf,lens+1);
   goto endp;
  end;

  if _CheckSyntaxExtCom(SM,pf,lens,1) = false then goto endp;


  begin

    if NArg = 4 then
    begin

       if (S1 = '') or (S2 = '') or (S3 = '') or (S4 = '') then
       begin
        E_Code:=E_MISSING_EXPRESSION;
        SError:=copy(SM,pf,lens+1);
        goto endp;
       end;

      {.191}   //check loop var. for corectness:
      ForevZ.ExistVar(S1,adrV,VT,MT);
      if  (VT <> T_Real) or (MT <> _Integer) then
      begin
        if FindNewVar(S1,SFin,T_Real,_Integer) = False then
        begin
          E_Code:=E_INCORRECT_ARGUMENT;
          SError:=copy(SM,pf,lens+1);
          goto endp;
        end;
      end;

         {for(var,expr1,expr2,exprA1;exprA2;...;exprAn) ->
      var=expr1; lab$1>> if(var > expr2,goto(Lab$2)); exprA1;exprA2;...;exprAn; inc(var); goto(lab$1) ;Lab$2>>
     }
     //x=0; i=1; for(i,1,5,x=x+1); x
     //x=0;  for(i,1,5, if({i*0.5}=0,for(j,1,10,x=x+1))); x
     //x=0;  for(i,1,5, if({i*0.5}=0,  for(j,1,10,x=x+1; if(j>=5,goto(lab1))) lab1>>)); x
     //x=0;  for(i,1,5, if({i*0.5}=0,  for(j,1,10,x=x+1; if(j>=5,goto(lab1)))) lab1>>); x
     //t=0; for(i,1,5,for(j,1,i,t=t+1)); t

     {.195}               //for(n,0,5,y=x;);y
     if S4[Length(S4)] = ';'  then  Delete(S4,Length(S4),1);

        SR:= S1+'='+S2+';'+'lab$'+IntToStr(LabCount)+'>>'+'if('+S1+'>'+S3+',goto(lab$'+IntToStr(LabCount+1)+'));'+S4+';inc('+S1+');'+'goto(lab$'+IntToStr(LabCount)+');'+'lab$'+IntToStr(LabCount+1)+'>>';
     LabCount:=LabCount+2;

     delete(SM,pf,lens+1);
     insert(SR,SM,pf);
    end
    else
    if NArg = 5 then
    begin

      if (S1 = '') or (S2 = '') or (S3 = '') or (S4 = '') or (S5 = '') then
       begin
        E_Code:=E_MISSING_EXPRESSION;
        SError:=copy(SM,pf,lens+1);
        goto endp;
       end;

      {.191}//check loop var. for corectness:
      if FindNewVar(S1,SFin,T_Real,_Integer) = False then
      begin
          if FindNewVar(S1,SFin,T_Real,_Extended) = False then
          begin
             if FindNewVar(S1,SFin,T_Complex,_Extended) = False then
             begin

                     ForevZ.ExistVarEx(S1,adrV,VT,MT,CT,ImU);
                             if  ((VT = T_Complex) and (CT = 0)) or (ImU = Im_Unit) or (VT = 0) then
                             begin
                                E_Code:=E_INCORRECT_ARGUMENT;
                                SError:=copy(SM,pf,lens+1);
                                goto endp;
                             end
                             else
                             if  (VT = T_Complex) and (CT = 0) then
                             begin
                                E_Code:=E_INCORRECT_ARGUMENT;
                                SError:=copy(SM,pf,lens+1);
                                goto endp;
                             end
             end
          end;
      end;


       {
      for(var,expr1,expr2,expr3,exprA1;exprA2;...;exprAn) ->
      var=expr1; lab$1>> if(expr2,goto(Lab$2),goto(Lab$3)); Lab$2>> exprA1;exprA2;...;exprAn; var=expr3; goto(lab$1) ;Lab$3>>
      //for(x,n+k,(2*x < n*k) or ( x < 100), x*2+n, exprA1;exprA2;...;exprAn)
      //for(x,1,x<=10,x+1,y=sin(y))
      //t=0; for(x,1,x<=3,x+1,for(y,1,y<=x,y+1,t=t+1)); t
        }

     {.195}
     if S5[Length(S5)] = ';'  then  Delete(S5,Length(S5),1);

     SR:= S1+'='+S2+';'+'lab$'+IntToStr(LabCount)+'>>'+'if('+S3+',goto(lab$'+IntToStr(LabCount+1)+'),goto(lab$'+IntToStr(LabCount+2)+'));lab$'+IntToStr(LabCount+1)+'>>'+S5+';'+S1+'='+S4+';goto(lab$'+IntToStr(LabCount)+');'+'lab$'+IntToStr(LabCount+2)+'>>';
     LabCount:=LabCount+3;

     delete(SM,pf,lens+1);
     insert(SR,SM,pf);
    end;

    //if(x<y , x=x+1;t= if(x>y , x=1.1; sin(x),cos(x)))
  end;

  inc(cp);
  goto nxt1;
end;

endp:
SFout:=SM;
end;




procedure _SyntaxExtCom(S1: String; var S2: String);
label endp,endp1;
var
SM: String;
b1,b2,i: Integer;
begin
SM:=S1;
b1:=0; b2:=0;
for i:=1 to Length(S1) do
begin
 if S1[i] = '(' then inc(b1);
 if S1[i] = ')' then inc(b2);
end;

if (b2-b1) <> 0 then
begin
 E_Code:=E_MISSING_ROUND_BRACKET;
 SError:=S1;
 goto endp;
end;


LabCount:=1;
try
//_SyntaxExtCom_IF(SM,SM);
_SyntaxExtCom_WHILE(SM,SM);         if E_Code <> 0 then  goto endp1;
_SyntaxExtCom_FORDOWN(SM,SM);       if E_Code <> 0 then  goto endp1;
_SyntaxExtCom_FOR(SM,SM);           if E_Code <> 0 then  goto endp1;
_SyntaxExtCom_IF(SM,SM);            if E_Code <> 0 then  goto endp1;
_SyntaxExtCom_CorrectLab(SM,SM);    if E_Code <> 0 then  goto endp1;
_SyntaxExtComReplaceIfName(SM,SM);

endp1:
except
 on E:  EAccessViolation do E_Code:=E_INTERNAL_ERROR;
end;

//if(x<y, if(x>t,x=x+1), if(x>=y,x=x-1)); x
endp:
S2:=SM;
end;







procedure CheckFalseBlank(S: String; var S1: String);      {.195}
  function FindEnableName(const S: String; p: integer): Boolean;
  var
    S1: String;
    I,L,pb,pe: Integer;
    ENN: Boolean;
  begin
    L:=Length(S);
    ENN:=False;

    pb:=p;
    repeat
     dec(pb);
    until (pb < 1) or (S[pb] =':');

    pe:=p;
    repeat
     inc(pe);
    until (pe >= L) or (S[pe] =';') or (S[pe] = ')') or (S[pe] = '=');

    S1:=Copy(S,pb+1,pe-pb-1);
    DeleteSpace(S1,S1);

    for I := 0 to Length(SNSpace)-1 do
    begin
      if {LowerCase(S1) = SNSpace[i]} S1 = SNSpace[i] then ENN:=True;
    end;

    FindEnableName:=ENN;
  end;


label lab1, lab2;
label endp;
const FalseSymb = ['A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z','1','2','3','4','5','6','7','8','9','0','.'];

var
St1,St2: String;
pb,bs,MaxES,i,j,p1,p2: Integer;
begin

MaxES:=7;//

while S[1] = ' '  do
begin
  Delete(S,1,1);
end;

while S[Length(S)] = ' '  do
begin
  Delete(S,Length(S),1);
end;

pb:=pos('  ',S); //2space
while pb <> 0 do
begin
 Delete(S,pb,1);
 pb:=pos('  ',S); //2space
end;



for i:= 2 to Length(S)-1 do
begin

  if S[i] = ' ' then
  begin
    if (S[i-1] in FalseSymb = True) and (S[i+1] in FalseSymb = True) then
    begin
      {bs:=min(pb,Length(S)-i);
      if bs > MaxES  then  bs:=MaxES;
      SError:=Copy(S,i-MaxES,2*MaxES);}

      for j := i downto 1 do
      begin
        if S[j] <> ' ' then
        begin
          if S[j] in FalseSymb = False then  begin  p1:=j; goto lab1; end;
        end;
      end;
      p1:=1;


      lab1:
      for j := i to Length(S) do
      begin
        if S[j] <> ' ' then
        begin
          if S[j] in FalseSymb = False then  begin p2:=j; goto lab2; end;
        end;
      end;
      p2:=Length(S);

      lab2:
      if FindEnableName(S,i) = False then
      begin
        SError:=Copy(S,p1,p2-p1+1);
        E_Code:=E_INCORRECT_SPACE;
        goto endp;
      end;

      //Delete(S,pb,1);
    end;
  end;

end;



pb:=pos(' ',S); //1space
while pb <> 0 do
begin
 Delete(S,pb,1);
 pb:=pos(' ',S); //1space
end;


pb:=pos(';;',S);
while pb <> 0 do
begin
 Delete(S,pb,1);
 pb:=pos(';;',S);
end;


if S[Length(S)] = ';' then  Delete(S,Length(S),1);
if S[1] = ';' then Delete(S,1,1);

S1:=S;
endp:
end;




procedure _Compile(Expr: String; var Func: Pointer);
label endp;
var
FS: TFunction;
NS: Cardinal;
S,S1: String;
BME,BRF: Boolean;
BRFnc,BROps,BRFncCF: Boolean;
B_CheckMultiExpr: boolean;

     function CheckMultiExpr: Boolean;
     var
       b,i,P1,P2: Integer;
       Res: Boolean;
     begin
       Res:=False;

       if pos(';',S) > 0 then Res:=True
       else
       begin
         P1:=pos('=',S);
         P2:=pos('(',S);

         if (P2 > 0) and (P1 > 0)   then
         begin
           //P1:=pos('=',S);           //x=1
           //P2:=pos('(',S);           //vd[k]=1
                                      //vd[(k+1)*2]=1
                                      //if(x=y,x,y)
           if (P1 < P2)  and (P1 > 0) then Res:=True    //vd[k]=(1+2)*3
           else                                         //vd[(k+1)*2]=(1+2)*3
           if P1 > 0 then
           begin
             b:=0;
             for i :=  P2 to P1 do
             begin
               if S[i] = '(' then inc(b) else
               if S[i] = ')' then dec(b) ;
             end;
             if  b = 0 then Res:=True else Res:=False;
           end
           else
           Res:=False;
         end
         else
         if (P2 = 0) and (P1 > 0) then Res:=True;


       end;

       CheckMultiExpr:=Res;
     end;



begin
E_Code:=0;
S:=Expr;
if S = '' then S:='0';

ForevZ.SyntaxError:=0;

S:=StringReplace(S,#9,'',[rfReplaceAll, rfIgnoreCase]);   {.221}

F_Current_Expression:=Copy(S,1,Length(S));

if ForevZ.LeadToLowerCase = True then S:=LowerCase(S); {.221}

if F_FindWrongSpace = True then      {.195}
begin
  CheckFalseBlank(S,S);
  if E_Code <> 0 then
  begin
    ForevZ.SyntaxErrorString:=SError;
    ForevZ.SyntaxError:=E_Code;
    ForevZ.IntException;
    goto endp;
  end;
end
else
DeleteSpace(S,S);




//S:=Copy(S1,1,Length(S1));                          //x=if(y<x,t,goto(2)); x


if _EXTENDED_COMMAND = True then
begin
  _SyntaxExtCom(S,S);
  if E_Code <> 0 then
  begin
    ForevZ.SyntaxErrorString:=SError;
    ForevZ.SyntaxError:=E_Code;
    ForevZ.IntException;
    goto endp;
  end;
end;


 //BME:=False; {.193}
B_CheckMultiExpr:=CheckMultiExpr; {.231}
if {(pos(';',S) > 0) or (pos('=',S) > 0)} B_CheckMultiExpr = True then    {.213}
begin
 try
  _CompileMultiExpr(S,S);
 except
    on E:  EAccessViolation do E_Code:=E_INTERNAL_ERROR;
 end;
  if E_Code <> 0 then
  begin
    ForevZ.SyntaxErrorString:=SError;
    ForevZ.SyntaxError:=E_Code;
    ForevZ.IntException;
    goto endp;
  end;
  //BME:=True;   {.193}
end;


   if (B_CheckMultiExpr = True) and (_REPLACE_MULTI_EXPR = False)  then   {.231}
   begin
       BRFnc:=ForevZ.ReplaceFuncs;           {.221}
       BROps:=ForevZ.ReplaceOps;
       BRFncCF:=ForevZ.ReplaceFuncsCF;
       //if BME = True then  ForevZ.ReplaceFuncs:=False;    {.193}
       ForevZ.ReplaceFuncs:=False;
       ForevZ.ReplaceOps:=False;
       ForevZ.ReplaceFuncsCF:=False;
     ForevZ.SetExtExpression(S,FS,NS);
       ForevZ.ReplaceFuncs:=BRFnc;
       ForevZ.ReplaceOps:=BROps;
       ForevZ.ReplaceFuncsCF:=BRFncCF;
       //ForevZ.ReplaceFuncs:=BRF;       {.193}
   end
   else
     ForevZ.SetExtExpression(S,FS,NS);


   if ForevZ.SyntaxError = 0 then
   begin
    SetLength(CompZ,Length(CompZ)+1);
    CompZ[High(CompZ)].Func:=FS;
    CompZ[High(CompZ)].R_Type:=ForevZ.ResultType;
    if ForevZ.DinLoadOverFlow = True then
    begin
     CompZ[High(CompZ)].CmplOverFlow:=1;
     CmplOverFlow:=1;
    end
    else
    begin
     CompZ[High(CompZ)].CmplOverFlow:=0;
     CmplOverFlow:=0;
    end;
    CompZ[High(CompZ)].CmplSDeep:=ForevZ.MaxLoadStack;
    CompZ[High(CompZ)].DinLoadNMem:=ForevZ.DinLoadNMem;
    CompZ[High(CompZ)].ReplFuncNum:=ForevZ.ReplFuncNum;
    CompZ[High(CompZ)].ReplOpNum:=ForevZ.ReplOpNum;
    CompZ[High(CompZ)].LoadStackAfterCalc:=ForevZ.LoadStackAfterCalc;

    CmplSDeep:=ForevZ.MaxLoadStack;
    DinLoadNMem:=ForevZ.DinLoadNMem;
    ReplFuncNum:=ForevZ.ReplFuncNum;
    ReplOpNum:=ForevZ.ReplOpNum;
    LoadStackAfterCalc:=ForevZ.LoadStackAfterCalc; {.197}
    //Func:=Pointer(CompZ[High(CompZ)].Func.ICode);  {.193}
    Func:=CompZ[High(CompZ)].Func.PAddr;
   end;

endp:
PopVar;
Set8087CW(CalcCW);//in SetExExpression CW - changed    {.229}
end;



procedure _FindReIm(S: String; var S1:String; var TF: Integer);
var
r,i: Integer;
SR,SI,ST: String;
begin
  r:=pos('.re',S{LowerCase(S)});
  if (r <> 0) and (r = Length(S)-2) then
  begin
   TF:=_RE; S1:=Copy(S,1,Length(S)-3);
  end
  else
  begin
   i:=pos('.im',S{LowerCase(S)});
   if (i <> 0) and (i = Length(S)-2) then
   begin
    TF:=_IM; S1:=Copy(S,1,Length(S)-3);
   end
   else
   begin
    S1:=S; TF:=0;
   end;
  end;
end;







function IsCurrentSet(NS: String): Boolean;
label endp;
var
i: Integer;
begin
IsCurrentSet:=False;

  for i := 0 to Length(CurrentNameSet)-1 do
  begin
   if NS = CurrentNameSet[i] then
   begin
     IsCurrentSet:=True; goto endp;
   end;
  end;

endp:
end;


procedure WriteCurrentSet(NS: String);
var
 i: Integer;
begin
 SetLength(CurrentNameSet,Length(CurrentNameSet)+1);
 CurrentNameSet[High(CurrentNameSet)]:=NS;
end;



procedure _SetVarIntrnl(NS: String; TypeV,MType: Integer; var Adr: Cardinal);
var
FD1,FD2: PInternalVar;
LS,LL,i: Integer;
SN,SV,num: String;
Bl: Boolean;
PAdr: Pointer;
begin


  new(FD1); FD1^.Next:=nil;
  FD1^.Name:=Copy(NS,1,Length(NS));

  {SetLength(FD1^.VecD,0);
  SetLength(FD1^.VecE,0);
  SetLength(FD1^.VecI,0);}

  if (TypeV = T_Real) or (TypeV = T_Complex) then
  begin
     PAdr:=@FD1^.Variable;
  end
  else
  if (TypeV = T_Array) then
  begin
    if (MType =_Double) then     PAdr:=@FD1^.VecD
    else
    if (MType =_Extended) then   PAdr:=@FD1^.VecE
    else
    if (MType =_Integer) then    PAdr:=@FD1^.VecI
  end;



  {ForevZ.SetObject(FD1^.Name,Cardinal(@FD1^.Variable),TypeV,MType);
  Adr:=Cardinal(@FD1^.Variable);}

  ForevZ.SetObject(FD1^.Name,Cardinal(PAdr),TypeV,MType);
  Adr:=Cardinal(PAdr);

  InternalVarList^.Next:=FD1;
  InternalVarList:=FD1;


end;




procedure _SetIntVar(NS: String; TypeV,MType: Integer; var Adr: Cardinal);
var
FD1,FD2: PInternalVar;
LS,LL,i: Integer;
SN,SV,num: String;
Bl: Boolean;
PAdr: Pointer;
begin

if IsCurrentSet(NS) = False then      {.221}
begin
  _SetVarIntrnl(NS,TypeV,MType,Adr);
  WriteCurrentSet(NS);
end
else           {.221}
ForevZ.SyntaxError:=E_VARIABLE_REDECLARED;

end;


{.229}
procedure _SetIntVarMultiExpr(NS: String; TypeV,MType: Integer; var Adr: Cardinal);
var
FD1,FD2: PInternalVar;
LS,LL,i: Integer;
SN,SV,num: String;
Bl: Boolean;
PAdr: Pointer;
begin

if IsCurrentSet(NS) = False then
begin
  PushVar(NS);
  _SetVarIntrnl(NS,TypeV,MType,Adr);
  WriteCurrentSet(NS);
end
else
ForevZ.SyntaxError:=E_VARIABLE_REDECLARED;

end;


procedure CheckEndString(S: String; var S1: String);
label nxt1, nxt2;
var
P: Cardinal;
begin
               // ;  ; x=1;  ;; y=x+1 ;; y ; ;

 nxt1:
 if S[1] = ';' then
 begin
  Delete(S,1,1) ;
  goto nxt1;
 end;


 nxt2:
 if S[Length(S)] = ';' then
 begin
  Delete(S,Length(S),1) ;
  goto nxt2;
 end;

 Insert(';',S,Length(S)+1);

 S1:=S;
end;


procedure _CompileMultiExpr(Expr: String; var SExpr1: String);
label ckl,endp,nxt;
var
FS: TFunction;
P,V,RT,TF,TypeV,MType,ni,{VT,MT,}V1,NE: Integer;
NS,Error,prv,adrv,VT,MT,CT: Cardinal;
S,SV,SF,SV1,SExpr, SFR,ST: String;
ASF: array of TFuncS;
Res: TComplex;
VNS: TArraySt;
ATL: TArrayI;
PF: Pointer;
EC,BH: Boolean;
Siu: String;
begin
if ForevZ.SyntaxExtension = True then Siu:=ForevZ.IM_UNIT_NAME else Siu:='*'+ForevZ.IM_UNIT_NAME;

S:=Copy(Expr,1,Length(Expr));

if F_ClearCurrentNameSet = True then SetLength(CurrentNameSet,0); {.221}

SExpr:='';
NE:=0; //  

if S[Length(S)] = '>' then S:=S+'#nop';// else S:=S+';#nop';


//RT:=0;
ExchLabl(S,S);  if E_Code <> 0 then  goto endp;

//P:=Pos(';',S);


ckl:
RT:=0;     {.227}
 CheckEndString(S,S);        {.195}
 P:=Pos(';',S);              {.195}
 {SV:=Copy(S,1,P-1);
 V:=Pos('=',SV);
 SV:=Copy(S,1,V-1);
 SF:=Copy(S,V+1,P-V-1);}
 VT:=T_None;

 SV:=Copy(S,1,P-1);
 V:=Pos('=',SV);
 SV1:=Copy(S,1,V-1);

 EC:=True;

 if (Pos('(',SV1) > 0) and (Pos('(',SV1) < V) then     //;if(arg1=arg2,,);
 begin
   if (Pos('[',SV1) > 0) and (Pos('[',SV1) < Pos('(',SV1)) then   //vd[len(vd)-1]=x; x
   begin
    SF:=Copy(SV,V+1,Length(SV)-V);
    SV:=Copy(SV,1,V-1);
    FindArray(SV,SF,SV,SF);
   end
   else
   begin
     SF:=SV;
     SV:='';
   end;
 end
 else
 begin
  //V:=Pos('=',SV);
   SV:=Copy(S,1,V-1);
   SF:=Copy(S,V+1,P-V-1);

   V1:=Pos(':',SV);
   if V1 > 0 then                   //xx:ext = sin(x); sqrt(xx^2+cos(x))
   begin
     SV:=Copy(SV,1,V1-1);
     ST:=Copy(S,V1+1,V-V1-1); {ST:=LowerCase(Copy(S,V1+1,V-V1-1));}

     MT:=0; VT:=0;
     if ST = 'real'      then begin MT:=ForevZ.DataType;  VT:=T_Real; end else        {.191}
     if ST = 'float'     then begin MT:=ForevZ.DataType;  VT:=T_Real; end else        {.191}
     if ST = 'double'    then begin MT:=_Double;    VT:=T_Real; end else
     if ST = 'dbl'       then begin MT:=_Double;    VT:=T_Real; end else
     if ST = 'integer'   then begin MT:=_Integer;   VT:=T_Real; end else
     if ST = 'int'       then begin MT:=_Integer;   VT:=T_Real; end else
     if ST = 'ext'       then begin MT:=_Extended;  VT:=T_Real; end else
     if ST = 'extended'  then begin MT:=_Extended;  VT:=T_Real; end else
     if ST = 'complexdouble'    then begin MT:=_Double;    VT:=T_Complex; end else
     if ST = 'complexofdouble'  then begin MT:=_Double;    VT:=T_Complex; end else
     if ST = 'complexofdbl'     then begin MT:=_Double;    VT:=T_Complex; end else
     if ST = 'doublecomplex'    then begin MT:=_Double;    VT:=T_Complex; end else
     if ST = 'cxdbl'            then begin MT:=_Double;    VT:=T_Complex; end else
     if ST = 'complexdbl'       then begin MT:=_Double;    VT:=T_Complex; end else
     if ST = 'dblcomplex'       then begin MT:=_Double;    VT:=T_Complex; end else
     if ST = 'complex'          then begin MT:=ForevZ.DataType; VT:=T_Complex; end else    {.191}
     if ST = 'tcomplexd'        then begin MT:=_Double;    VT:=T_Complex; end else
     if ST = 'dblcx'            then begin MT:=_Double;    VT:=T_Complex; end else
     if ST = 'cxdouble'         then begin MT:=_Double;    VT:=T_Complex; end else
     if ST = 'doublecx'         then begin MT:=_Double;    VT:=T_Complex; end else
     if ST = 'complexextended'  then begin MT:=_Extended;  VT:=T_Complex; end else
     if ST = 'complexofextended'  then begin MT:=_Extended;  VT:=T_Complex; end else
     if ST = 'complexofext'     then begin MT:=_Extended;  VT:=T_Complex; end else
     if ST = 'extendedcomplex'  then begin MT:=_Extended;  VT:=T_Complex; end else
     if ST = 'tcomplexe'        then begin MT:=_Extended;  VT:=T_Complex; end else
     if ST = 'complexext'       then begin MT:=_Extended;  VT:=T_Complex; end else
     if ST = 'extcomplex'       then begin MT:=_Extended;  VT:=T_Complex; end else
     if ST = 'cxextended'       then begin MT:=_Extended;  VT:=T_Complex; end else
     if ST = 'extendedcx'       then begin MT:=_Extended;  VT:=T_Complex; end else
     if ST = 'extcx'            then begin MT:=_Extended;  VT:=T_Complex; end else
     if ST = 'cxext'            then begin MT:=_Extended;  VT:=T_Complex; end else
     if ST = 'arraydouble'              then begin MT:=_Double;  VT:=T_Array; end else
     if ST = 'arrayofdouble'            then begin MT:=_Double;  VT:=T_Array; end else
     if ST = 'arraydbl'                 then begin MT:=_Double;  VT:=T_Array; end else
     if ST = 'arrayofdbl'               then begin MT:=_Double;  VT:=T_Array; end else
     if ST = 'arrayd'                   then begin MT:=_Double;  VT:=T_Array; end else
     if ST = 'arrayextended'            then begin MT:=_Extended;  VT:=T_Array; end else
     if ST = 'arrayofextended'          then begin MT:=_Extended;  VT:=T_Array; end else
     if ST = 'arrayext'                 then begin MT:=_Extended;  VT:=T_Array; end else
     if ST = 'arrayofext'               then begin MT:=_Extended;  VT:=T_Array; end else
     if ST = 'arraye'                   then begin MT:=_Extended;  VT:=T_Array; end else
     if ST = 'arrayinteger'             then begin MT:=_Integer;   VT:=T_Array; end else
     if ST = 'arrayofinteger'           then begin MT:=_Integer;   VT:=T_Array; end else
     if ST = 'arrayint'                 then begin MT:=_Integer;   VT:=T_Array; end else
     if ST = 'arrayi'                   then begin MT:=_Integer;   VT:=T_Array; end else
     if ST = 'array'                    then
                                        begin   {.191}
                                           if ForevZ.DataType = _Double then
                                            begin MT:=_Double;    VT:=T_Array; end
                                            else
                                            begin MT:=_Extended;  VT:=T_Array;  end
                                        end
                                        else



                                  {MT:=ForevZ.DataType;
                                  VT:=T_Real;}
                                   begin
                                     E_Code:=14{fz_INCORRECT_TYPE};
                                     if ST = '' then SError:=SV1 else SError:=ST;
                                     goto endp;
                                   end;
      //newvar:type=<expr>
      {PushVar(SV);
     _SetIntVar(SV,VT,MT,adrv); }
     _SetIntVarMultiExpr(SV,VT,MT,adrv);  {.229}
      if ForevZ.SyntaxError <> 0 then
      begin                                     {.221}
        if ForevZ.SyntaxError = E_VARIABLE_REDECLARED  then E_Code:=E_VARIABLE_REDECLARED else E_Code:=15;
       // E_Code:=15{fz_WRONG_NAME};
        SError:=SV;
        goto endp;
      end;

       if VT = T_Array  then
       begin
        SF:='setlen('+SV+','+SF+')'  ;
       end;

     //ForevZ.SetObject(SV1,adr,VT,MT);
   end
   else
   begin
    FindArray(SV,SF,SV,SF); //array[expr1]=expr2  ->  save(vd,expr1,expr2)
   end;




 end;

  //CalcType=T_Real:
 //z1:extCX=1+2i; x:dbl=3+4;  x=z1.im;  x


 //x=1; x=if(y>x,y,goto(end)); x=3; end>>x;
SFR:=SF;
 //   (  )     .
 if (ForevZ.CalcConstExpr = True) and (F_CalcConsExprInMulti = True) {.221}  then
 begin
     CT:=ForevZ.CalcType;
     ForevZ.CalcType:=T_Complex;
     ForevZ.EnableCalcConsExprInMulti:=True;   {.221}
  ForevZ.SetExtExpression(SF,FS,NS);
     ForevZ.EnableCalcConsExprInMulti:=False;   {.221}
     ForevZ.CalcType:=CT;


  if (ForevZ.SyntaxError = 0)  then
  begin
     //calculated  if expression - const.:
    if (ForevZ.PresentVar = false) and (ForevZ.EnableCalcConstExpression = True) and (ForevZ.ResultType <> T_None) then
    begin
          //_ResultC(FS.Addr,Res);
          //SF:=FloatToStrF(Res.re, ffGeneral, 20, 4, G_FMT)+'+('+FloatToStrF(Res.im, ffGeneral, 20, 4, G_FMT)+')'+Siu;
          //SFR:=FloatToStrF(Res.re, ffGeneral, 20, 4, G_FMT);

          Res:=ForevZ.FResult;  {.229}

         if (ForevZ.ResultType = T_Real) and (ForevZ.CalcType = T_Real) then
           begin
            //Res.re:=_ResultR(FS.ICode);
            //SF:=FloatToStr(Res.re,G_FMT);
            SF:=FloatToStrF(Res.re, ffGeneral, 20, 4, G_FMT);
            SFR:=SF;
           end
           else
           begin
             //_ResultC(FS.ICode,Res);
             //SF:=FloatToStr(Res.re,G_FMT)+'+i*('+FloatToStr(Res.im,G_FMT)+')';
             SF:=FloatToStrF(Res.re, ffGeneral, 20, 4, G_FMT)+'+('+FloatToStrF(Res.im, ffGeneral, 20, 4, G_FMT)+')'+Siu;
             //SFR:=FloatToStr(Res.re,G_FMT);
             SFR:=FloatToStrF(Res.re, ffGeneral, 20, 4, G_FMT);
           end;


    end;

    EC:= ForevZ.PresentVar;
    RT:=ForevZ.ResultType;
    ForevZ.FreeExtFunc(@FS);  {.225}
  end
  else
  begin
   E_Code:=ForevZ.SyntaxError;  SError:=ForevZ.SyntaxErrorString;   goto endp;        {.139}
  end;
 end;
                     //x=if(y>x,t,goto(2));x   !!!!!!!!!!!!!!!!!!!!!!

                     //r1=2*sin(3*cos(pi/2+1))+1;r1
                     //x=2^3; y=x+1;y
                      //x5=2^3; x7=x5+1;x7
                     //z5.re=3^2; z5.im=2^3; z5
                     //z5.re=3^2; z5.im=Im(2^3*i); z5


 _FindReIm(SV,SV1,TF);
  ForevZ.FindVar(SV1,ni);
  if ni = -1 then
  begin
    if RT = 0 then
    begin
      ForevZ.SetExtExpression(SF,FS,NS);
      if ForevZ.SyntaxError <> 0 then
      begin
         E_Code:=ForevZ.SyntaxError;
         SError:=ForevZ.SyntaxErrorString;  {.139};{ForevZ.SyntaxErrorString:=SF;}
         goto endp;
      end;
      RT:=ForevZ.ResultType;
      EC:= ForevZ.PresentVar;
      ForevZ.FreeExtFunc(@FS); {.225}
    end;
    if (TF <> 0) or (RT = T_Complex) then
    begin
     MT:=ForevZ.DataType;
     VT:=T_Complex;
    end
    else
    begin
     MT:=ForevZ.DataType;
     VT:=T_Real;
     //if EC = False then SF:=SFR;
    end;

     if SV1 <> '' then
     begin
       //newvar=<expr>
       {PushVar(SV1);
       _SetIntVar(SV1,VT,MT,adrv); }
       _SetIntVarMultiExpr(SV1,VT,MT,adrv);  {.229}
     end;
     if ForevZ.SyntaxError <> 0 then
      begin
        E_Code:=15{fz_WRONG_NAME};
        SError:=SV;
        //goto endp;
      end;
  end;


   {if (SV = '') then SExpr:=SExpr+SF
             else SExpr:=SExpr+'SAVE('+SV+','+SF+')'; }

  if (SV = '') then SExpr:=SExpr+SF
  else
  begin
      ForevZ.ExistVar(SV1,adrv,VT,MT);
      if VT = T_Array then SExpr:=SExpr+SF
      else
      if VT = T_Real then
       SExpr:=SExpr+'save('+SV+','+SFR+')'    {.191}
      else
      if VT = T_Complex then
       SExpr:=SExpr+'save('+SV+','+SF+')';     {.191}

  end;
  //vd[n]=pi;vd[n]
  //vd:arrayD=10;vd[n+1]




  Delete(S,1,P);
  P:=Pos(';',S);
  if P > 0 then
  begin
   inc(NE);
   SExpr:=SExpr+',';
   goto ckl;
  end
  else
  begin
    //SExpr:=SExpr+','+S;                 //x=1; y=x
    inc(NE);
    if S <> '' then           {.195}    //x=1; y=x;
    SExpr:=SExpr+','+S;                 //x=1; y=x
    //else  SExpr:=SExpr;               //x=1; ; y=x;;  ;x+y; ;
                                        //x=1; ; y=x;;  ;z1=x+y; ;
  end;

  if NE >= 1 then SExpr:='nop('+SExpr+')';    // (NE)
  //SExpr:='nop('+SExpr+')';

endp:
//PopVar;
SExpr1:=Copy(SExpr,1,Length(SExpr));
end;





procedure pcCompile(S: String; var FName: String; var FAdr: Pointer);
label 1,2,3,endp,endp1;
var
i,j: Integer;
//FS:TZAddFuncStruct;
FN: String;
LVT: TArrayI;
VN,VT,RT,PKC,PKF: Integer;
IDF,Er,CC,RF: Cardinal;
begin

try
 CC:=0; RF:=0;

 3:
 PKC:=Pos('{$CC-}',S);
 PKF:=Pos('{$RF-}',S);
 if PKC = 1 then
 begin
   Delete(S,1,6);
   CC:=1;
 end
 else
 if PKF = 1 then
 begin
   Delete(S,1,6);
   RF:=1;
 end;
 if (PKC <> 0) or (PKF <> 0) then goto 3;

  //for i:=0 to FDFN.MA.Lines.Capacity do
  //begin
    ZInitFuncStruct(G_FS);
    G_FS.SaveReg:=0; {.191}
    G_FS.CallFunc:=fz_PRECOMPILED;

    //S:=FDFN.MA.Lines[i];
    {DeleteSpace(S,S);
    if S = '' then goto 1;}


    pcConvertFuncName(S,FN,LVT,VN,VT,RT);
    if  E_Code <> 0 then goto endp1;

    SetLength(pcLVT,Length(LVT));
    if VT = 0 then
    begin
       for j := 0 to  High(LVT) do
       begin
         case LVT[j] of
           //1:  pcLVT[j]:=fl_single;
           2:  pcLVT[j]:=fz_REAL_DOUBLE ;
           3:  pcLVT[j]:=fz_REAL_EXTENDED;
           4:  pcLVT[j]:=fz_REAL_INTEGER ;
           //5:  pcLVT[j]:=fz_ARRAY_SINGLE ;
           6:  pcLVT[j]:=fz_ARRAY_REAL_DOUBLE ;
           7:  pcLVT[j]:=fz_ARRAY_REAL_EXTENDED ;
           8:  pcLVT[j]:=fz_ARRAY_REAL_INTEGER;
           9:  pcLVT[j]:=fz_COMPLEX_DOUBLE;
           10:  pcLVT[j]:=fz_COMPLEX_EXTENDED ;
         end;
       end;
       G_FS.ArgType:=fz_differ;
       G_FS.ArgTypeList:=@pcLVT[0];
    end
    else
    begin
      case VT of
           2:   G_FS.ArgType:=fz_REAL_DOUBLE ;
           3:   G_FS.ArgType:=fz_REAL_EXTENDED;
           4:   G_FS.ArgType:=fz_REAL_INTEGER ;
           //5:  pcLVT[j]:=fz_ARRAY_SINGLE ;
           6:   G_FS.ArgType:=fz_ARRAY_REAL_DOUBLE ;
           7:   G_FS.ArgType:=fz_ARRAY_REAL_EXTENDED ;
           8:   G_FS.ArgType:=fz_ARRAY_REAL_INTEGER;
           9:   G_FS.ArgType:=fz_COMPLEX_DOUBLE;
           10:  G_FS.ArgType:=fz_COMPLEX_EXTENDED ;
      end;
    end;

    case RT of
      1:   G_FS.ResultType:=fz_real;
      2:   G_FS.ResultType:=fz_real;
      3:   G_FS.ResultType:=fz_real;
      4:   G_FS.ResultType:=fz_complex;
      5:   G_FS.ResultType:=fz_none;
    end;

    LVT:=nil;

    1:
  //end;
  if CC = 1 then G_FS.CalcConst:=fz_NO;
  if RF = 1 then G_FS.ReplFunc:=fz_NO;
  FName:=FN;
  FAdr:=@G_FS;

endp1:

except
    on E:  EAccessViolation do E_Code:=E_ERROR_AT_ADDITION_OF_FUNCTION;
end;

endp:
end;




procedure pcConvertFuncName(S: String;  var FN: String; var LVT: TArrayI; var VN,VT,RT: Integer);
label 1, endp;
var                                                               //TV[i]=_float,_integer,_complex,_array
SF,SA,S1,S2,S3,S4,SFM,SR: String;
MA,MAN,MX,MX1: TArraySt;
br1,br2,i,L,p,L1,j: Integer;
BT: Boolean;
begin
//DeleteSpace(S,S);
try
FN:='';
P:=Pos('=',S);

if P = 0 then begin E_Code:=E_ERROR_AT_ADDITION_OF_FUNCTION; SError:=S; goto endp; end;

S1:=Copy(S,1,P-1);
SFM:=Copy(S,P,Length(S)-P+1); //+ '='
RT:=2;
P:=Pos(')',S1);

if P = 0 then begin E_Code:=E_ERROR_AT_ADDITION_OF_FUNCTION; SError:=S; goto endp; end;
if S1 = '' then begin E_Code:=E_ERROR_AT_ADDITION_OF_FUNCTION; SError:=S; goto endp; end;

if S1 = '' then goto endp;

if p+1 < Length(S1) then  {.197}
begin
 if S1[p+1] = ':' then
 begin
  //SR:=LowerCase(Copy(S1,p+2,Length(S1)-p-1));
  SR:=Copy(S1,p+2,Length(S1)-p-1);

  if SR = 'real'    then {RT:=2}begin if ForevZ.DataType = _Double then RT:=2 else RT:=3; end else  {.191}
  if SR = 'float'   then {RT:=2}begin if ForevZ.DataType = _Double then RT:=2 else RT:=3; end  else {.191}
  if SR = 'double'    then RT:=2 else
  if SR = 'dbl'      then RT:=2 else
  if SR = 'complex'    then RT:=4 else
  if SR = 'complexofdouble'    then RT:=4 else
  if SR = 'complexofdbl'    then RT:=4 else
  if SR = 'doublecomplex'      then RT:=4 else
  if SR = 'doubleofcomplex'    then RT:=4 else
  if SR = 'complexdouble'    then RT:=4 else
  if SR = 'cxdbl'        then RT:=4 else
  if SR = 'dblcx'        then RT:=4 else
  if SR = 'cxdouble'    then RT:=4 else
  if SR = 'doublecx'    then RT:=4 else
  if SR = 'complexd'    then RT:=4 else
  if SR = 'tcomplexd'    then RT:=4 else
  if SR = 'complexofextended'    then RT:=4 else
  if SR = 'complexextended'    then RT:=4 else
  if SR = 'complexofext'    then RT:=4 else
  if SR = 'extendedofcomplex'    then RT:=4 else
  if SR = 'extendedcomplex'    then RT:=4 else
  if SR = 'complexext'    then RT:=4 else
  if SR = 'cxextended'    then RT:=4 else
  if SR = 'extendedcx'    then RT:=4 else
  if SR = 'cxext'       then RT:=4 else
  if SR = 'extcx'       then RT:=4 else
  if SR = 'complexe'    then RT:=4 else
  if SR = 'tcomplexe'    then RT:=4 else
  if SR = 'extended'    then RT:=3  else
  if SR = 'ext'         then RT:=3  else
  if SR = 'none'        then RT:=5  else
  if SR = 'nan'         then RT:=5  else
  if SR = 'absent'      then RT:=5  else
  if SR = 'procedure'   then RT:=5  else
  if SR = 'proc'        then RT:=5
  else
  begin
    E_Code:=14{fz_INCORRECT_TYPE};
    if SR = ''  then SError:=S1 else
    SError:=SR;
    goto endp;
  end;
 end
end
else
begin
 if ForevZ.DataType = _Double then RT:=2 else RT:=3;
end;


L:=Length(S1);
br1:=0; br2:=0;
for i := 1 to L do
begin
  if (S1[i] = '(') and (br1 = 0) then begin SF:=Copy(S1,1,i-1); br1:=i; end;
  if (S1[i] = ')') and (br2 = 0) then begin  br2:=i; SA:=Copy(S1,br1+1,br2-br1-1);  goto 1; end;
end;

1:
if SF = '' then begin E_Code:=E_ERROR_AT_ADDITION_OF_FUNCTION; SError:=S; goto endp; end;
//if SA = '' then begin E_Code:=E_ERROR_AT_ADDITION_OF_FUNCTION; SError:=S; goto endp; end;  {.203}{.xxx}  fnc():real=1.123

p:=1;
for i := 1 to Length(SA) do
begin
  if SA[i] = ';' then
  begin
   SetLength(MA,Length(MA)+1);
   MA[High(MA)]:=Copy(SA,p,i-p);
   p:=i+1;
  end;
end;
if p > 1 then
begin
 SetLength(MA,Length(MA)+1);
 MA[High(MA)]:=Copy(SA,p,Length(SA)-p+1);
end;
if Length(MA) = 0 then
begin

//func(x1,..,xn: type)
//func(x1,..xn)
//func(x1)
//func(x1: type)
pcFindFuncArg(SA,MX,VT);
if E_Code <> 0 then goto endp;
VN:=Length(MX);
FN:=pcGetFuncName(SF,SFM,MX);

end
else
//func(x1,..,xn: type1; y1,..,yn: type2,..)
begin
 for i := 0 to High(MA) do
 begin
   pcFindFuncArg(MA[i],MX,VT);
   L:=Length(MX);
   L1:=Length(MX1);
   SetLength(MX1,Length(MX1)+L);
   SetLength(LVT,Length(LVT)+L);
   for j := 0 to L-1 do
   begin
    MX1[L1+j]:=MX[j];
    LVT[L1+j]:=VT;
   end;
   MX:=nil;
 end;

 VN:=Length(MX1);
 FN:=pcGetFuncName(SF,SFM,MX1);

 VT:=LVT[0];
 BT:=True;
 for I := 1 to High(LVT) do
 begin
    if VT <> LVT[i] then BT:=False;
 end;

 if BT = True  then
 begin
   LVT:=nil;
 end
 else
 VT:=0;

end;

endp:
except
    on E:  EAccessViolation do E_Code:=E_ERROR_AT_ADDITION_OF_FUNCTION;
end;
end;




function pcGetFuncName(SF,SFM: String; MX: TArraySt): String;
var
S: String;
i: Integer;
begin
try
S:='';
if Length(MX) = 1 then S:=MX[0]
else
if Length(MX) > 1 then     {.xxx} {.203}   //fnc():real=1.123
begin
  for i := 0 to High(MX) - 1 do
  begin
   S:=S+MX[i]+',';
  end;
  S:=S+MX[High(MX)];
end;

pcGetFuncName:=SF+'('+S+')'+SFM;
except
    on E:  EAccessViolation do E_Code:=E_ERROR_AT_ADDITION_OF_FUNCTION;
end;

end;






procedure pcFindFuncArg(SA: String; var MX: TArraySt; var VT: Integer);
label endp;
var
 i,p: Integer;
 S2,S3: String;
begin
//x1,..,xn: type
//x1,..xn
//x1
//x1: type

try
VT:=0;
 P:=Pos(':',SA);
 if P <> 0 then
 begin
  S2:=Copy(SA,1,P-1);  //x1,..xn
  //S3:=LowerCase(Copy(SA,P+1,Length(SA)-P+1)); //type
  S3:=Copy(SA,P+1,Length(SA)-P+1);

  if S3 = 'float'     then VT:=ForevZ.DataType else    {.191}
  if S3 = 'real'      then VT:=ForevZ.DataType else
  //if S3 = 'single'    then VT:=1 else
  if S3 = 'double'    then VT:=2 else
  if S3 = 'dbl'       then VT:=2 else
  if S3 = 'extended'  then VT:=3 else
  if S3 = 'ext'       then VT:=3 else
  if S3 = 'integer'   then VT:=4 else
  if S3 = 'int'       then VT:=4 else

  if S3 = 'complex'            then begin if ForevZ.DataType = _Double then VT:=9 else VT:=10; end else {.191}
  if S3 = 'complexofdouble'    then VT:=9 else
  if S3 = 'complexofdbl'       then VT:=9 else
  if S3 = 'complexdouble'      then VT:=9 else
  if S3 = 'tcomplexd'          then VT:=9 else
  if S3 = 'doublecomplex'      then VT:=9 else
  if S3 = 'doubleofcomplex'    then VT:=9 else
  if S3 = 'cxdbl'              then VT:=9 else
  if S3 = 'dblcx'              then VT:=9 else
  if S3 = 'cxdouble'           then VT:=9 else
  if S3 = 'doublecx'           then VT:=9 else
  if S3 = 'complexd'           then VT:=9 else
  if S3 = 'complexdbl'         then VT:=9 else
  if S3 = 'dblcomplex'         then VT:=9 else

  if S3 = 'complexofextended'  then VT:=10 else
  if S3 = 'complexofext'       then VT:=10 else
  if S3 = 'complexextended'    then VT:=10 else
  if S3 = 'extendedcomplex'    then VT:=10 else
  if S3 = 'extendedofcomplex'  then VT:=10 else
  if S3 = 'cxext'              then VT:=10 else
  if S3 = 'extcx'              then VT:=10 else
  if S3 = 'cxextended'         then VT:=10 else
  if S3 = 'tcomplexe'          then VT:=10 else
  if S3 = 'extendedcx'         then VT:=10 else
  if S3 = 'complexe'           then VT:=10 else
  if S3 = 'complexext'         then VT:=10 else
  if S3 = 'extcomplex'         then VT:=10 else

  //if S3 = 'arraysingle'       then VT:=5 else
  //if S3 = 'arrays'            then VT:=5 else
  //if S3 = 'arrayofsingle'     then VT:=5 else

  if S3 = 'arraydouble'       then VT:=6 else
  if S3 = 'arrayd'            then VT:=6 else
  if S3 = 'arrayofdouble'     then VT:=6 else
  if S3 = 'arraydbl'          then VT:=6 else
  if S3 = 'arrayofdbl'        then VT:=6 else

  if S3 = 'array'               then  begin if ForevZ.DataType = _Double then VT:=6 else VT:=7; end else {.191}

  if S3 = 'arrayextended'       then VT:=7 else
  if S3 = 'arraye'              then VT:=7 else
  if S3 = 'arrayofextended'     then VT:=7 else
  if S3 = 'arrayext'            then VT:=7 else
  if S3 = 'arrayofext'          then VT:=7 else

  if S3 = 'arrayinteger'        then VT:=8 else
  if S3 = 'arrayi'              then VT:=8 else
  if S3 = 'arrayofinteger'      then VT:=8 else
  if S3 = 'arrayint'            then VT:=8 else
  begin
    E_Code:=14{fz_INCORRECT_TYPE};
    if S3 = ''  then  SError:=SA else
    SError:=S3;
    goto endp;
  end;






 end
 else
 begin
   //VT:=2;              {.191}
   VT:=ForevZ.DataType;
   S2:=SA;
 end;
p:=1;
 for i:=1 to Length(S2) - 1 do
 begin
     if S2[i] = ',' then
     begin
      SetLength(MX,Length(MX)+1);
      MX[High(MX)]:=Copy(S2,p,i-p);
      p:=i+1;
     end;
 end;
 if p <> 1 then
 begin
   SetLength(MX,Length(MX)+1);
   MX[High(MX)]:=Copy(S2,p,Length(S2)-p+1);
 end;
                           {.xxx}
 if (Length(MX) = 0) and (Length(S2) <> 0) {.203} then       //func1(x): real=x
 begin                                                       //func1(): real=1.123
   SetLength(MX,1);
   MX[0]:=Copy(S2,1,Length(S2));
 end;

endp:
except
    on E:  EAccessViolation do E_Code:=E_ERROR_AT_ADDITION_OF_FUNCTION;
end;
end;






procedure PushVar(S: String);
var
Addr,IdType,MType: Cardinal;
begin
ForevZ.ExistVar(S,Addr,IdType,MType);
if Addr <> 0  then
begin
  SetLength(SaveVar,Length(SaveVar)+1);
  SaveVar[Length(SaveVar)-1].Name:=S;
  SaveVar[Length(SaveVar)-1].Addr:=Addr;
  SaveVar[Length(SaveVar)-1].TypeF:=IdType;
  SaveVar[Length(SaveVar)-1].MType:=MType;
end
else
begin
  SetLength(SaveVarD,Length(SaveVarD)+1);
  SaveVarD[Length(SaveVarD)-1].Name:=S;
  SaveVarD[Length(SaveVarD)-1].Addr:=0;
  SaveVarD[Length(SaveVarD)-1].MType:=0;
  SaveVarD[Length(SaveVarD)-1].TypeF:=0;
end;
end;



procedure PopVar;
var
i: integer;
begin
if Length(SaveVar) > 0 then
begin
  for i := 0 to Length(SaveVar) - 1 do
  begin
    ForevZ.SetObject(SaveVar[i].Name,SaveVar[i].Addr,SaveVar[i].TypeF,SaveVar[i].MType);
  end;
  SetLength(SaveVar,0);
end;
if Length(SaveVarD) > 0 then
begin
  for i := 0 to Length(SaveVarD) - 1 do
  begin
    ForevZ.DeleteVar(SaveVarD[i].Name);
  end;
  SetLength(SaveVarD,0);
end;
end;






procedure ExchLabl(S1: String; var S2: String);
label 1,2,3,endp;
var
  i,n,p,ns,pl,pg,lens,br: integer;
  SG,SN,SGN: String;
begin


br:=0;
for I := 1 to Length(S1) do
begin
 if S1[i] = '(' then inc(br);
 if S1[i] = ')' then dec(br);
 if (S1[i] = ';') and (br <> 0 ) then
 begin
     E_Code:=E_WRONG_EXPRESSION;
     SError:=F_Current_Expression;
     goto endp;
 end;
end;

1:
p:=pos('>>',S1);

if P > 0 then
begin
 ns:=0;
 for i := 1 to P do
 begin
  if S1[i]=';' then inc(ns);
 end;

 inc(ns);
 pl:=0;

 for i := p  downto 1  do
 begin
   if S1[i] = ';' then
   begin
     pl:=i;
     goto 2;
   end;
 end;

 2:
  SN:=Copy(S1,pl+1,p-pl-1);
  delete(S1,pl+1,p+1-pl);
  SG:='goto('+SN+')';
  SGN:='goto('+IntToStr(ns)+')';

 3:
   pg:=pos(SG,S1);
   if pg > 0 then
   begin
      lens:=length(SG);
      if _CheckOperatorPlacement(S1,pg,lens+pg-1) = False then
      begin
         E_Code:=E_WRONG_EXPRESSION;
         if pg-1 = 0 then pg:=1;
         if lens+2 >= Length(S1)  then lens:=Length(S1)-2;
         SError:=copy(S1,pg-1,lens+2);
         goto endp;
      end;
      delete(S1,pg,5+p-pl);
      insert(SGN,S1,pg);
      goto 3;
   end;


 goto 1;
end;

endp:
 S2:=S1;
end;





function _FindCmplFunc(Addr: Cardinal): Cardinal;
label endp;
var
i,N: Cardinal;
begin
N:=0;

For i:=0 to High(CompZ) do
 begin
  if Addr = CompZ[i].Func.Addr then
  begin
   N:=i;
   goto endp;
  end;
 end;

endp:
 _FindCmplFunc:=N;
end;




procedure FindArray(SV,SF: String; var SV1,SF1: String); //array[expr1]=expr2  ->  savev(vd,expr1,expr2)
var
SArg,SF2: String;
P,L: Integer;
begin

SF1:=SF;
SV1:=SV;
//P:=Pos(']',SV);
L:=Length(SV);

//if (P = L) and (L > 0) then
if L > 0 then                     {.199}
begin
 if SV[Length(SV)] = ']' then
 begin
   P:=Pos('[',SV);
   SV1:=Copy(SV,1,P-1);
   SArg:=Copy(SV,P+1,Length(SV)-P-1);
   SF1:='save('+SV1+','+SArg+','+SF+')';
 end;
end;

end;



procedure _SetStrPCh(P: Pointer);
label 1,endp;
var
L,es,i: integer;
AI: PArrayB;
S1: AnsiString;
P1: Pointer;
begin

if P = nil then
begin
 S1:='';
 goto endp;
end;


  AI:=@TArrayB(P);
  i:=0;  L:=0;
  es:=Integer(AI^[0]);
  S1:='';

  1:
  if es  > 0 then
  begin
   S1:=S1+AnsiChar(AI^[i]);
   inc(i);
   es:=Integer(AI^[i]);
   goto 1;
  end;



endp:
 //Str:=Sans;
 Str:=String(Copy(S1,1,Length(S1)));
end;





procedure _GetStrPCh(var P: Pointer);
var
L,i: integer;
begin
 Sans:=AnsiString(Str);


  L:=Length(Sans);
  SetLength(VSB,L+1);

  if L > 0 then
  begin
   for i:=1 to L do
   begin
    VSB[i-1]:=byte(AnsiChar(Sans[i]));
   end;
   VSB[L]:=byte(#0);
  end
  else
  begin
   SetLength(VSB,1);
   VSB[0]:=byte(#0);
  end;

  P:=@VSB[0];

end;



procedure SetNameTypes;
begin
 SetLength(SNReal,6);
 SetLength(SNInt,2);
 SetLength(SNCmplx,25);

 SNReal[0]:='dbl';  SNReal[1]:='double'; SNReal[2]:='ext'; SNReal[3]:='extended';  SNReal[4]:='float';  SNReal[5]:='real';

 SNInt[0]:='int';SNInt[1]:='integer';

 SNCmplx[0]:='complex';
 SNCmplx[1]:='complexofdouble';
 SNCmplx[2]:='complexdouble';
 SNCmplx[3]:='doublecomplex';
 SNCmplx[4]:='doubleofcomplex';
 SNCmplx[5]:='cxdbl';
 SNCmplx[6]:='dblcx';
 SNCmplx[7]:='cxdouble';
 SNCmplx[8]:='complexd';
 SNCmplx[19]:='doublecx';
 SNCmplx[20]:='tcomplexd';
 SNCmplx[21]:='dblcomplex';
 SNCmplx[22]:='complexdbl';

 SNCmplx[9]:=  'complexofextended'  ;
 SNCmplx[10]:= 'complexextended'    ;
 SNCmplx[11]:= 'extendedcomplex'    ;
 SNCmplx[12]:= 'extendedofcomplex'  ;
 SNCmplx[13]:= 'cxext'              ;
 SNCmplx[14]:= 'extcx'              ;
 SNCmplx[15]:= 'cxextended'         ;
 SNCmplx[16]:= 'tcomplexe'          ;
 SNCmplx[17]:= 'extendedcx'         ;
 SNCmplx[18]:= 'complexe'           ;
 SNCmplx[23]:= 'complexext';
 SNCmplx[24]:= 'extcomplex';

 SetLength(SNSpace,26);
 SNSpace[0]:='complexdouble';
 SNSpace[1]:='complexofdouble' ;
 SNSpace[2]:='complexofdbl';
 SNSpace[3]:='doublecomplex' ;
 SNSpace[4]:='complexextended' ;
 SNSpace[5]:='complexofextended' ;
 SNSpace[6]:='complexofext' ;
 SNSpace[7]:='extendedcomplex';
 SNSpace[8]:='arraydouble'  ;
 SNSpace[9]:='arrayofdouble' ;
 SNSpace[10]:='arraydbl' ;
 SNSpace[11]:='arrayofdbl' ;
 SNSpace[12]:='arrayextended'  ;
 SNSpace[13]:='arrayofextended'  ;
 SNSpace[14]:='arrayofext'  ;
 SNSpace[15]:='arrayext'    ;
 SNSpace[16]:='arrayinteger'  ;
 SNSpace[17]:='arrayofinteger' ;
 SNSpace[18]:='arrayofint' ;
 SNSpace[19]:='arrayint' ;
 SNSpace[20]:='arrayi' ;
 SNSpace[21]:='arrayd' ;
 SNSpace[22]:='complexext' ;
 SNSpace[23]:='complexdbl' ;
 SNSpace[24]:='extcomplex' ;
 SNSpace[25]:='dblcomplex' ;




end;




procedure ResultCxD(Func: Pointer; var  Res: TComplexD);
var
p:TComplexD;
begin
  asm
   call Func
   push eax
   mov  eax, [res]
   fstp qword ptr [eax]
   fstp qword ptr [eax+8]
   pop  eax
  end;
end;



procedure ResultCxE(Func: Pointer; var Res: TComplexE);
begin
 asm
   call Func
   push eax
   mov  eax, [res]
   fstp tbyte ptr [eax]
   fstp tbyte ptr [eax+16]
   pop  eax
  end;
end;




procedure _LEN(adr: Cardinal; var len: Cardinal);
var
len1: cardinal;
begin
asm
       push eax
       mov  eax, [adr]
       mov  eax, [eax]
       test eax,eax
       jz @@nil
       mov  eax, [eax-4]
       {$IFDEF FPC}
       add eax,1
       {$ENDIF}
       @@nil:
       mov  len1, eax
       pop  eax
end;
len:=len1;
end;




{.193}
procedure zInitFuncStruct(var FS: TZAddFuncStruct);
begin
  FS.addr:=nil;
  FS.CallType:=fz_Stdcall;
  FS.Arg:=0;
  FS.ArgType:=fz_Differ;
  FS.ArgTypeList:=nil;
  FS.CallFunc:=0;
  FS.ResultType:=0;
  FS.DeepFPU:=8;//fz_UNKNOWN;
  FS.CalcConst:=fz_Yes;
  FS.SaveReg:=15;  //save:eax,ebx,ecx,edx
  FS.ReplFunc:=fz_YES;
  FS.Resrv2:=0;
  FS.Resrv3:=0;
end;


procedure fzLoadFPUD(RE: Double; Im: Double);  stdcall;
asm
  fld qword ptr Im
  fld qword ptr Re
end;


procedure fzLoadFPUE(RE: Extended; Im: Extended);   stdcall;
asm
  fld tbyte ptr Im
  fld tbyte ptr Re
end;


procedure fzLoadFPUDP(Adr: Pointer);  stdcall;
asm         //Adr=@TComplexD
  push eax
  mov eax,Adr
  fld qword ptr [eax+8]
  fld qword ptr [eax]
  pop eax
end;


procedure fzLoadFPUEP(Adr: Pointer);  stdcall;   {.191}
asm         //Adr=@TComplexE
  push eax
  mov eax,Adr
  fld tbyte ptr [eax+16]
  fld tbyte ptr [eax]
  pop eax
end;




procedure  fzGetVarValueD(Addr: Pointer; var Val: Double);       stdcall;
begin
  Val:=PDouble(Addr)^
end;


procedure  fzGetVarValueE(Addr: Pointer; var Val: Extended);       stdcall;
begin
  Val:=PExtended(Addr)^
end;


procedure  fzGetVarValueI(Addr: Pointer; var Val: Integer);       stdcall;
begin
  Val:=PInteger(Addr)^
end;





initialization
begin
 ForevZ:=TForevalZ_Custom.Create;
 //CreateClass;
 SetLength(CompZ,1);
 SetLength(SaveVar,0);
 SetLength(SaveVarD,0);
 ForevZ.ShowException:=false;
 ForevZ.DataType:=_Extended;  //_Double;
 F_CalcConsExprInMulti:=True; {.221}
 _STRINGTYPE:=fz_STRING;
 _EXTENDED_COMMAND:=True;
 _REPLACE_MULTI_EXPR:=True;
 F_FREE_CODE_AT_REPLACE := True;


 //        
 {SetReg(_EAX,_SAVE);
 SetReg(_EBX,_SAVE);
 SetReg(_ECX,_SAVE);
 SetReg(_EDX,_SAVE);}
 F_CurrentIntFunc:=0;
 new(InternalVarList);
 InternalVarList^.Next:=nil;
 BInternalVarList:=InternalVarList;
 _SetVar('pi',@c_pi,fz_Real_Extended);
 E_Code:=0;
 SetNameTypes;

 fzSet(fz_Stack_Type,fz_Extended);
 fzSet(fz_Disable,fz_Show_Exception);
 fzSet(fz_Disable,fz_ACCURATE_SPEC_FUNC);
 fzSet(fz_Enable,fz_REPLACE_DIV);
 fzSet(fz_Enable,fz_REPLACE_MUL );
 fzSet(fz_Enable,fz_REPLACE_ADDSUB);
 fzSet(fz_Disable,fz_CHECK_INCORRECT_SPACE);

 F_CALC_EXCEPTION_IN_SAFE:=0;
 F_ClearCurrentNameSet:=True;
 GA_TmpExeptionFlag:=0;
 GA_ExceptionFlagAddr:=TAddress(@GA_TmpExeptionFlag);
 //fzSet(fz_PRECISION,fz_EXTENDED);
 Set8087CW($1372);
 CalcCW:=$1372;
 CWMEM:=$1372;
 GetLocaleFormatSettings(0,G_FMT);
 G_FMT.DecimalSeparator:='.';
end;



finalization
begin

FreeCmplFuncList;
CompZ:=nil;
pcFreeIntVar;
ForevZ.Destroy;

end;

end.
