//---------------------------------------------------------------------------

/*
   Warning: only for 32bits compilers; all expressions not support parallel executions(not thread safety)
*/

#include <vcl.h>
#include <string>
#include <math.h>
#include <cmath.h>
#include <sysdyn.h>
#pragma hdrstop

#include "ForevalZdll.h"
#include "TestFZ.h"


//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

#define EXTENDED_VAR
//#define OVERLOADCOMPLEX  //calc. with overload complex num.: TComplexNum (see Button1)


#ifdef   EXTENDED_VAR
  typedef  Extended    TFloat;
  typedef  TComplexE   TComplex;
#else
  typedef  double TFloat;
  typedef  TComplexD  TComplex;
#endif



typedef TFloat*      PFloat ;
typedef TComplex*    PComplex;

typedef DynamicArray < double >   TArrayD;
typedef DynamicArray < Extended > TArrayE;
typedef DynamicArray < Int32 >    TArrayI;
typedef TArrayD*   PArrayD ;
typedef TArrayE*   PArrayE ;
typedef TArrayI*   PArrayI ;




struct   TComplexNum
{
private:


 public:

  TFloat re; //
  TFloat im; //

  //explicit TComplexNum() {};
  //explicit TComplexNum(TFloat r, TFloat i) { re = r, im = i; }

   //inline friend  TComplexNum ToCx(TFloat cre, TFloat cim) { ToCx.re=cre; ToCx.im=cim; }
/*   explicit inline  friend	TComplexNum (void)
	 {
	 };

  explicit inline friend	TComplexNum (TFloat& r, TFloat& i)
  {
	re = r;
	im = i;
  }
  */



  inline friend TComplexNum operator+(const TComplexNum &z1, const TComplexNum &z2)
  {
   TComplexNum rez;
	rez.re=z1.re+z2.re;
	rez.im=z1.im+z2.im;
	return rez;
	//return this->ToCx(z1.re+z2.re,z1.im+z2.im);
   //return TComplexNum(z1.re+z2.re,z1.im+z2.im);
  }

  inline friend TComplexNum operator+(const TFloat &r1, const TComplexNum &z2)
  {
   TComplexNum rez;
	rez.re=r1+z2.re;
	rez.im=z2.im;
	return rez;
   //return TComplexNum(z1.re+z2.re,z1.im+z2.im);
  }

   inline friend TComplexNum operator+(const TComplexNum &z1, const TFloat &r2)
  {
   TComplexNum rez;
	rez.re=z1.re+r2;
	rez.im=z1.im;
	return rez;
   //return TComplexNum(z1.re+z2.re,z1.im+z2.im);
  }

   inline friend TComplexNum operator-(const TComplexNum &z1, const TComplexNum &z2)
  {
	TComplexNum res;
	res.re = z1.re - z2.re;
	res.im = z1.im - z2.im;
	return res ;
  }

   inline friend TComplexNum operator-(const TFloat &r1, const TComplexNum &z2)
  {
   TComplexNum rez;
	rez.re=r1-z2.re;
	rez.im=-z2.im;
	return rez;
   //return TComplexNum(z1.re+z2.re,z1.im+z2.im);
  }

   inline friend TComplexNum operator-(const TComplexNum &z1, const TFloat &r2)
  {
   TComplexNum rez;
	rez.re=z1.re-r2;
	rez.im=z1.im;
	return rez;
   //return TComplexNum(z1.re+z2.re,z1.im+z2.im);
  }

	inline friend TComplexNum operator-(const TComplexNum &z1)
  {
	TComplexNum res;
	res.re = -z1.re;
	res.im = -z1.im;
	return res ;
  }

  inline friend TComplexNum operator*(const TComplexNum &z1, const TComplexNum &z2)
	{
	TComplexNum res;
	res.re = z1.re * z2.re-z1.im * z2.im;
	res.im = z1.im * z2.re + z1.re * z2.im;
	return res ;
	}

 inline friend TComplexNum operator*(const TFloat &r1, const TComplexNum &z2)
	{
	TComplexNum res;
	res.re = r1 * z2.re;
	res.im = r1 * z2.im;
	return res ;
	}

  inline friend TComplexNum operator*(const TComplexNum &z1, const TFloat &r2)
	{
	TComplexNum res;
	res.re = r2 * z1.re;
	res.im = r2 * z1.im;
	return res ;
	}


  inline friend TComplexNum operator/(const TComplexNum &z1, const TComplexNum &z2)
	{
	TComplexNum res;
	TFloat t;

	t = 1/(z2.re*z2.re+z2.im*z2.im);
	res.re = (z1.re*z2.re+z1.im*z2.im)*t;
	res.im = (z1.im*z2.re-z1.re*z2.im)*t;

	return res ;

	}


	inline friend TComplexNum operator/(const TFloat &r1, const TComplexNum &z2)
	{
	TComplexNum res;
	TFloat t;

	t = 1/(z2.re*z2.re+z2.im*z2.im);
	res.re = r1*z2.re*t;
	res.im = -r1*z2.im*t;
	return res ;
	}


	inline friend TComplexNum operator/(const TComplexNum &z1, const TFloat &r2)
	{
	TComplexNum res;
	TFloat t;

	t = 1/r2;
	res.re = z1.re*t;
	res.im = z1.im*t;
	return res ;
	}


};


typedef   TComplexNum (*PTGccTest)(void);

struct TFunc4
       {
		 TComplexD   z1;
		 TComplexD   z2;
		 double      x;
		 Int32       n;
		 TComplexD   res;
		 Pointer32   addr;
		 TStringType Expr;
       };

TForm1 *Form1;



TFormatSettings  G_FMT;
TComplexNum z1,z2,z3,i,i0;
TComplex z1f,z2f,z3f,resf;
TFloat x,y,t;

TComplexE z1e,z2e,z3e;
TComplexD z1d,z2d,z3d;
Extended xe,ye,te;

Pointer32 adrXVD,adrXVE,adrXVI;
Double xd,yd,td;
Int32 n,k,j,m,l;
TArrayD vd,ad;
TArrayE ve;
TArrayI vi;
TFunc4 fnc1,fnc2;

String 	  SG1r,SG1i;
TComplexNum resG;
TComplex resF;
Int32 GNC;

//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{



}
//---------------------------------------------------------------------------


double trunc(double d){ return (d>0) ? floor(d) : ceil(d) ; }


void  ShowError(void)
{
String S,S1;
Int32 CError,addr;
//PC: PChar;
AnsiString Ans;
TStringType ErStr;
WideString ws;
PWideString pws;
Pointer32 PS;
TByteDynArray utf8b;
//P: Pointer;
PAnsiChar  PAC;
//su8: UTF8String  su8;


fzGetSyntaxErrorCode(CError);

switch ( CError )
 {
   case  fz_UNKNOWN_SYMBOL:                       S ="UNKNOWN SYMBOL or INCORRECT ARGUMENT or WRONG EXPRESSION"; break;
   case  fz_MISSING_ROUND_BRACKET:                S ="MISSING ROUND BRACKET"; break;
   case  fz_MISSING_OPERATION:                    S="MISSING OPERATION";   break;
   case  fz_WRONG_NUMBER_ARGUMENTS:               S="WRONG NUMBER ARGUMENTS";  break;
   case  fz_MISSING_EXPRESSION:                   S="MISSING EXPRESSION";  break;
   case  fz_UNKNOWN_FUNCTION:                     S="UNKNOWN FUNCTION"; break;
   case  fz_ERROR_AT_ADDITION_FUNCTION:           S="ERROR AT ADDITION FUNCTION";   break;
   case  fz_NOT_DEFINED_OPERATOR:                 S="NOT DEFINED OPERATOR"; break;
   case  fz_NOT_DEFINED_FUNCTION:                 S="NOT DEFINED FUNCTION";  break;
   case  fz_INCORRECT_ARGUMENT:                   S="WRONG TYPE OF ARGUMENT";   break;
   case  fz_MISSING_ARGUMENT:                     S="MISSING ARGUMENT";  break;
   case  fz_INTERNAL_ERROR:                       S="INTERNAL ERROR or  UNCATCHABLE SYNTAX ERROR"; break;
   case  fz_CALCULATION_ERROR:                    S="INTERNAL ERROR AT CALCULATION";  break;
   case  fz_INCORRECT_TYPE:                       S="WRONG TYPE" ;   break;
   case  fz_WRONG_NAME:                           S="WRONG NAME";  break;
   case  fz_MISSING_SQUARE_BRACKET:               S="MISSING SQUARE BRACKET";  break;
   case  fz_MISSING_CURLY_BRACKET:                S="MISSING CURLY BRACKET";  break;
   case  fz_MISSING_ABS_BRACKET:                  S="MISSING ABS BRACKET";  break;
   case  fz_WRONG_EXPRESSION:                     S="WRONG EXPRESSION";  break;
   case  fz_ABSENT_LOAD_FUNCTION_FOR_TYPE:        S="ABSENT LOAD FUNCTION FOR TYPE"; break;
   case  fz_MISSING_SEPARATOR:                    S="MISSING SEPARATOR";   break;
   case  fz_INCORRECT_SPACE:                      S="INCORRECT SPACE";  break;
   case  fz_VARIABLE_REDECLARED:                  S="VARIABLE REDECLARED";  break;
   default:                                       S="UNKNOWN SYNTAX ERROR"; break;
}



   MessageBeep(MB_ICONHAND);
  /*
  {$IFDEF STRINGINT}
	fzGetSyntaxErrorString(Str);
	MessageDlg(S+#13#10+'"'+Str+'"',mtError,[mbOk],0);
  {$ELSE}
	fzGetSyntaxErrorString(P);
  {$ENDIF}
  */
/*

*/

 // :      -    ,     (   )
 //it's better: at first,  copying of a string then reset - will help to avoid the possible mistakes connected with transfer of strings  (the conflict of different managers of memory)

  //{$IFDEF ANSISTRING}       Ans:=AnsiString(P);    S1:=Copy(Ans,1,Length(Ans)); Ans:=''; MessageDlg(S+#13#10+'"'+S1+'"',mtError,[mbOk],0); {$ENDIF}
  //{$IFDEF STRING}           Str:=String(P);        S1:=Copy(Str,1,Length(Str)); Str:=''; MessageDlg(S+#13#10+'"'+S1+'"',mtError,[mbOk],0); {$ENDIF}
  //{$IFDEF WIDESTRING}       ws:=WideString(P);     S1:=Copy(ws,1,Length(ws));   ws:=''; MessageDlg(S+#13#10+'"'+S1+'"',mtError,[mbOk],0);{$ENDIF}
  //{$IFDEF UTF8}             su8:=UTF8String(P);    S1:=Copy(Su8,1,Length(Su8)); Su8:=''; MessageDlg(S+#13#10+'"'+S1+'"',mtError,[mbOk],0); {$ENDIF}
  //{$IFDEF PANSICHAR}        PAC:=PAnsiChar(P);     Ans:=AnsiString(PAC); S1:=Copy(Ans,1,Length(Ans)); Ans:=''; MessageDlg(S+#13#10+'"'+S1+'"',mtError,[mbOk],0); {$ENDIF}



	fzGetSyntaxErrorString(PS);



#ifdef    WIDESTRING
	ErStr = PWideChar(PS);
#endif
#ifdef    ANSISTRING
	ErStr = PAnsiChar(PS);
#endif
#ifdef    STRING
	ErStr = PChar(PS);
#endif
#ifdef    UTF8
	_asm         //utf8b=AnyPtrToPtrUtf8(PS)
	{
	 push eax
	 push ebx
	 lea eax,utf8b
	 mov ebx,PS
	 mov [eax],ebx
	 pop ebx
	 pop eax
	}
	ErStr = StringOf(utf8b);
#endif
#ifdef    PANSICHAR
 PAC=PAnsiChar(PS);     Ans=AnsiString(PAC);  S1 = Ans.SubString(1, Ans.Length()); Ans = "";
#endif

#ifndef    PANSICHAR
	S1 = ErStr.SubString(1, ErStr.Length()); ErStr = "";
#endif

	MessageDlg(S+(char)13+(char)10+S1,mtError,TMsgDlgButtons() << mbYes,0);

	//MessageDlg("error",mtError,TMsgDlgButtons() << mbYes,0);
}


	  //z1*z2-cos(z1+z2)





//******************************************************************************
//                Proc&Func adding to ForevalZ
//******************************************************************************



TFloat  _cdecl SP1(TFloat x1)
{
 return  x1*x1;
}


TFloat  _stdcall SP2(TFloat x1, TFloat x2)
{
 return  x1-x2;
}


TFloat  _pascal SP3(TFloat x1, TFloat x2, TFloat x3)
{
 return  x1+x2-x3;
}



void  _pascal SP1Z(TComplex z1)
{
TFloat re,im;
TComplex rez;

 rez.re=z1.re*z1.re-z1.im*z1.im;
 rez.im=2*z1.re*z1.im;

#ifdef   EXTENDED_VAR
  _asm
  {
   fld tbyte ptr [rez+16]
   fld tbyte ptr [rez]
  }
  //fzLoadFPUEP(&rez);
  //fzLoadFPUE(rez.re,rez.im);
#else    //DOUBLE
  _asm
  {
   fld qword ptr [rez+8]
   fld qword ptr [rez]
  }
  //fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif

}



void  _cdecl SP2Z(TComplex z1,TComplex z2)
{
TFloat re,im;
TComplex rez;

 rez.re=z1.re-z2.re;
 rez.im=z1.im-z2.im;

#ifdef   EXTENDED_VAR
  _asm
  {
   fld tbyte ptr [rez+16]
   fld tbyte ptr [rez]
  }
  //fzLoadFPUEP(&rez);
  //fzLoadFPUE(rez.re,rez.im);
#else    //DOUBLE
  _asm
  {
   fld qword ptr [rez+8]
   fld qword ptr [rez]
  }
  //fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif
}




void  _stdcall SP3Z(TComplex z1, TComplex z2, TComplex z3)
{
TFloat re,im;
TComplex rez;

 rez.re=z1.re+z2.re-z3.re;
 rez.im=z1.im+z2.im-z3.im;

#ifdef   EXTENDED_VAR
  _asm
  {
   fld tbyte ptr [rez+16]
   fld tbyte ptr [rez]
  }
  //fzLoadFPUEP(&rez);
  //fzLoadFPUE(rez.re,rez.im);
#else    //DOUBLE
  _asm
  {
   fld qword ptr [rez+8]
   fld qword ptr [rez]
  }
  //fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif
}





void  _cdecl SP2ZR(TComplex z1, TFloat x)
{
//double re,im;
TComplex rez;

 rez.re=z1.re-x;
 rez.im=z1.im;

#ifdef   EXTENDED_VAR
  _asm
  {
   fld tbyte ptr [rez+16]
   fld tbyte ptr [rez]
  }
  //fzLoadFPUEP(&rez);
  //fzLoadFPUE(rez.re,rez.im);
#else    //DOUBLE
  _asm
  {
   fld qword ptr [rez+8]
   fld qword ptr [rez]
  }
  //fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif
}



void  _cdecl SP2RZ(TFloat x,TComplex z2)
{
TFloat re,im;
TComplex rez;

 rez.re=x-z2.re;
 rez.im=-z2.im;

#ifdef   EXTENDED_VAR
  _asm
  {
   fld tbyte ptr [rez+16]
   fld tbyte ptr [rez]
  }
  //fzLoadFPUEP(&rez);
  //fzLoadFPUE(rez.re,rez.im);
#else    //DOUBLE
  _asm
  {
   fld qword ptr [rez+8]
   fld qword ptr [rez]
  }
  //fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif
}



TFloat  _cdecl PS1(TFloat *x1)
{
 return  (*x1)*(*x1);
}


TFloat  _cdecl PS2(TFloat *x1,TFloat *x2)
{
 return  (*x1)-(*x2);
}


TFloat  _stdcall PS3(TFloat *x1, TFloat *x2, TFloat *x3)
{
 return  (*x1)+(*x2)-(*x3);
}




void  _pascal PS1Z(TComplex *z1)
{
TFloat re,im;
TComplex rez;

 rez.re=(*z1).re*(*z1).re-(*z1).im*(*z1).im;
 rez.im=2*(*z1).re*(*z1).im;

#ifdef   EXTENDED_VAR
  _asm
  {
   fld tbyte ptr [rez+16]
   fld tbyte ptr [rez]
  }
  //fzLoadFPUEP(&rez);
  //fzLoadFPUE(rez.re,rez.im);
#else    //DOUBLE
  _asm
  {
   fld qword ptr [rez+8]
   fld qword ptr [rez]
  }
  //fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif
}



void  _cdecl PS2Z(TComplex *z1,TComplex *z2)
{
TFloat re,im;
TComplex rez;

 rez.re=(*z1).re-(*z2).re;
 rez.im=(*z1).im-(*z2).im;

#ifdef   EXTENDED_VAR
  _asm
  {
   fld tbyte ptr [rez+16]
   fld tbyte ptr [rez]
  }
  //fzLoadFPUEP(&rez);
  //fzLoadFPUE(rez.re,rez.im);
#else    //DOUBLE
  _asm
  {
   fld qword ptr [rez+8]
   fld qword ptr [rez]
  }
  //fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif

}



void  _stdcall PS3Z(TComplex *z1, TComplex *z2, TComplex *z3)
{
TFloat re,im;
TComplex rez;

 rez.re=(*z1).re+(*z2).re-(*z3).re;
 rez.im=(*z1).im+(*z2).im-(*z3).im;

#ifdef   EXTENDED_VAR
  _asm
  {
   fld tbyte ptr [rez+16]
   fld tbyte ptr [rez]
  }
  //fzLoadFPUEP(&rez);
  //fzLoadFPUE(rez.re,rez.im);
#else    //DOUBLE
  _asm
  {
   fld qword ptr [rez+8]
   fld qword ptr [rez]
  }
  //fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif
}


void  _cdecl PS2ZR(TComplex *z1, TFloat *x)
{
TFloat re,im;
TComplex rez;

 rez.re=(*z1).re-(*x);
 rez.im=(*z1).im;

#ifdef   EXTENDED_VAR
  _asm
  {
   fld tbyte ptr [rez+16]
   fld tbyte ptr [rez]
  }
  //fzLoadFPUEP(&rez);
  //fzLoadFPUE(rez.re,rez.im);
#else    //DOUBLE
  _asm
  {
   fld qword ptr [rez+8]
   fld qword ptr [rez]
  }
  //fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif

}



void  _cdecl PS2RZ(TFloat *x,TComplex *z2)
{
TFloat re,im;
TComplex rez;

 rez.re=(*x)-(*z2).re;
 rez.im=-(*z2).im;

#ifdef   EXTENDED_VAR
  _asm
  {
   fld tbyte ptr [rez+16]
   fld tbyte ptr [rez]
  }
  //fzLoadFPUEP(&rez);
  //fzLoadFPUE(rez.re,rez.im);
#else    //DOUBLE
  _asm
  {
   fld qword ptr [rez+8]
   fld qword ptr [rez]
  }
  //fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif

}



TFloat  _cdecl MS1(Int32 addr)
{
 return  (*PFloat(addr))*(*PFloat(addr));
}



TFloat  _cdecl MS2(Int32 addr)
{
 return  (*PFloat(addr))-(*PFloat(addr+16));
}



TFloat  _cdecl MS3(Int32 addr)
{
 return  (*PFloat(addr))+(*PFloat(addr+16))-(*PFloat(addr+32));
}





void  _cdecl MS1Z(Int32 addr)
{
TFloat re,im;
TComplex rez;

 rez.re=(*PFloat(addr))*(*PFloat(addr))-(*PFloat(addr+16))*(*PFloat(addr+16));
 rez.im=2*(*PFloat(addr))*(*PFloat(addr+16));

#ifdef   EXTENDED_VAR
  _asm
  {
   fld tbyte ptr [rez+16]
   fld tbyte ptr [rez]
  }
  //fzLoadFPUEP(&rez);
  //fzLoadFPUE(rez.re,rez.im);
#else    //DOUBLE
  _asm
  {
   fld qword ptr [rez+8]
   fld qword ptr [rez]
  }
  //fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif
}



void  _cdecl MS2Z(Int32 addr)
{
TFloat re,im;
TComplex rez;

 rez.re=(*PFloat(addr))-(*PFloat(addr+32));
 rez.im=(*PFloat(addr+16))-(*PFloat(addr+48));

#ifdef   EXTENDED_VAR
  _asm
  {
   fld tbyte ptr [rez+16]
   fld tbyte ptr [rez]
  }
  //fzLoadFPUEP(&rez);
  //fzLoadFPUE(rez.re,rez.im);
#else    //DOUBLE
  _asm
  {
   fld qword ptr [rez+8]
   fld qword ptr [rez]
  }
  //fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif
}


void  _cdecl MS3Z(Int32 addr)
{
TFloat re,im;
TComplex rez;

 rez.re=(*PFloat(addr))+(*PFloat(addr+32))-(*PFloat(addr+64));
 rez.im=(*PFloat(addr+16))+(*PFloat(addr+48))-(*PFloat(addr+80));

#ifdef   EXTENDED_VAR
  _asm
  {
   fld tbyte ptr [rez+16]
   fld tbyte ptr [rez]
  }
  //fzLoadFPUEP(&rez);
  //fzLoadFPUE(rez.re,rez.im);
#else    //DOUBLE
  _asm
  {
   fld qword ptr [rez+8]
   fld qword ptr [rez]
  }
  //fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif
}



void  _cdecl MS2ZR(Int32 addr)
{
TFloat re,im;
TComplex rez;

 rez.re=(*PFloat(addr))-(*PFloat(addr+32));
 rez.im=(*PFloat(addr+16));

#ifdef   EXTENDED_VAR
  _asm
  {
   fld tbyte ptr [rez+16]
   fld tbyte ptr [rez]
  }
  //fzLoadFPUEP(&rez);
  //fzLoadFPUE(rez.re,rez.im);
#else    //DOUBLE
  _asm
  {
   fld qword ptr [rez+8]
   fld qword ptr [rez]
  }
  //fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif
}



void  _cdecl MS2RZ(Int32 addr)
{
TFloat re,im;
TComplex rez;

 rez.re=(*PFloat(addr))-(*PFloat(addr+16));
 rez.im=-(*PFloat(addr+32));

#ifdef   EXTENDED_VAR
  _asm
  {
   fld tbyte ptr [rez+16]
   fld tbyte ptr [rez]
  }
  //fzLoadFPUEP(&rez);
  //fzLoadFPUE(rez.re,rez.im);
#else    //DOUBLE
  _asm
  {
   fld qword ptr [rez+8]
   fld qword ptr [rez]
  }
  //fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif
}


//infsum(z1,z2,z3,z3-z2,z2-z1,z1*z2)
void _cdecl sumz(Int32 addr, Int32 len)
{
 Int32 N,ni;
 TComplex Sz;
 TFloat re,im;


  Sz.re=0; Sz.im=0;
  //re=0; im=0;
  for (ni = 0; ni <= len-1; ni++)
  {
   Sz.re=Sz.re+(*PFloat(addr+32*ni));
   Sz.im=Sz.im+(*PFloat(addr+32*ni+16));
   //re=re+(*PExtended(addr+32*ni));
   //im=im+(*PExtended(addr+32*ni+16));
   }



#ifdef   EXTENDED_VAR
  _asm
  {
   fld tbyte ptr [Sz+16]
   fld tbyte ptr [Sz]
  }
  //fzLoadFPUEP(&Sz);
  //fzLoadFPUE(Sz.re,Sz.im);
#else    //DOUBLE
  _asm
  {
   fld qword ptr [Sz+8]
   fld qword ptr [Sz]
  }
  //fzLoadFPUDP(&Sz);
 //fzLoadFPUD(Sz.re,Sz.im);
#endif

}



//infsum(x,y,t,x-y-infsum(x,y,t,x*y),t*x)
TFloat _cdecl sumr(Int32 addr, Int32 len)
{
 Int32 N,ni;
 TFloat S;

  S=0;
  for (ni = 0; ni <= len-1; ni++)
  {
   S=S+(*PFloat(addr+16*ni));
  }

 return S;
}


void _cdecl SPALL(TArrayE vx, Int32 nx, TComplexE zx, TArrayD vd, Int32 nd, double d, TComplexD zd, Extended x, TArrayI vi, Int32 ni)
{
//rez=(vd[nd]*d*zd - vx[nx]*x*zx)*vi[ni]
//spall(ve,n,z1,vd,k,y,z2,x,vi,j) = (vd[k]*y*z2 - ve[n]*x*z1)*vi[j]
 TComplex rez;

 //spall(ve,n+3,z1,vd,j+k,x,z2+z3,t-y,vi,n+k+j)


 rez.re=(vd[nd]*d*zd.re-vx[nx]*x*zx.re)*vi[ni];
 rez.im=(vd[nd]*d*zd.im-vx[nx]*x*zx.im)*vi[ni];


#ifdef   EXTENDED_VAR
  _asm
  {
   fld tbyte ptr [rez+16]
   fld tbyte ptr [rez]
  }
  //fzLoadFPUEP(&rez);
  //fzLoadFPUE(rez.re,rez.im);
#else    //DOUBLE
  _asm
  {
   fld qword ptr [rez+8]
   fld qword ptr [rez]
  }
  //fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif

}




void _cdecl MSALL(Int32 addr)
{
//msall(vd,nx,zd,vx,nd,d,zx,x,vi,ni) = (vd[nd]*d*zd - vx[nx]*x*zx)*vi[ni]
/*
  vd: array of double;
  vx: array of extended;
  vi: array of integer;
  d:  double;
  x:  extended;
  nd,nx,ni: integer;
*/
 TComplex rez;
  //msall(ve,n+3,z1,vd,j+k,x,z2+z3,t-y,vi,n+k+j)

  //vx[nx] = (*PArrayE(addr))[(*PInteger(addr+16))]       =    (*PExtended(*PInteger(addr)+(*PInteger(addr+16))*10))
  //zx.re =  (*PExtended(addr+32))
  //zx.im =  (*PExtended(addr+48))
  //vd[nd] = (*PArrayD(addr+64))[(*PInteger(addr+80))]    =   (*PDouble(*PInteger(addr+64)+(*PInteger(addr+80))*8))
  //d =      (*PDouble(addr+96))
  //zd.re =  (*PDouble(addr+112))
  //zd.im =  (*PDouble(addr+128))
  //x =      (*PExtended(addr+144))
  //vi[ni] = (*PArrayI(addr+160))[(*PInteger(addr+176))]   = (*PInteger(*PInteger(addr+160)+(*PInteger(addr+176))*4))


 //rez.re=(vd[nd]*d*zd.re-vx[nx]*x*zx.re)*vi[ni];
 //rez.im=(vd[nd]*d*zd.im-vx[nx]*x*zx.im)*vi[ni];
/*
 rez.re  =  ((*PArrayD(addr+64))[(*PInteger(addr+80))]*(*PDouble(addr+96))*(*PDouble(addr+112))-(*PArrayE(addr))[(*PInteger(addr+16))]*(*PExtended(addr+144))*(*PExtended(addr+32)))*(*PArrayI(addr+160))[(*PInteger(addr+176))];
 rez.im  =  ((*PArrayD(addr+64))[(*PInteger(addr+80))]*(*PDouble(addr+96))*(*PDouble(addr+128))-(*PArrayE(addr))[(*PInteger(addr+16))]*(*PExtended(addr+144))*(*PExtended(addr+48)))*(*PArrayI(addr+160))[(*PInteger(addr+176))];
*/

//more fast:
rez.re  =  ((*PDouble(*PInteger(addr+64)+(*PInteger(addr+80))*8))*(*PDouble(addr+96))*(*PDouble(addr+112))-(*PExtended(*PInteger(addr)+(*PInteger(addr+16))*10))*(*PExtended(addr+144))*(*PExtended(addr+32)))*(*PInteger(*PInteger(addr+160)+(*PInteger(addr+176))*4));
rez.im  =  ((*PDouble(*PInteger(addr+64)+(*PInteger(addr+80))*8))*(*PDouble(addr+96))*(*PDouble(addr+128))-(*PExtended(*PInteger(addr)+(*PInteger(addr+16))*10))*(*PExtended(addr+144))*(*PExtended(addr+48)))*(*PInteger(*PInteger(addr+160)+(*PInteger(addr+176))*4));



#ifdef   EXTENDED_VAR
  _asm
  {
   fld tbyte ptr [rez+16]
   fld tbyte ptr [rez]
  }
  //fzLoadFPUEP(&rez);
  //fzLoadFPUE(rez.re,rez.im);
#else    //DOUBLE
  _asm
  {
   fld qword ptr [rez+8]
   fld qword ptr [rez]
  }
  //fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif
}





//void _cdecl PSALL(__int32 *vx, __int32 *nx, TComplexE *zx, __int32 *vd, __int32 *nd, double *d, TComplexD *zd, Extended *x, __int32 *vi, __int32 *ni)
void _cdecl PSALL(TArrayE *vx, __int32 *nx, TComplexE *zx, TArrayD *vd, __int32 *nd, double *d, TComplexD *zd, Extended *x, TArrayI *vi, __int32 *ni)
{
//rez=(vx[nd]*d*zd - vd[nx]*x*zx)*vi[ni]
//spall(ve,n,z1,vd,k,y,z2,x,vi,j) = (ve[k]*y*z2 - vd[n]*x*z1)*vi[j]
/*
  vd: array of double;
  vx: array of Extended;
  vi: array of integer;
  d: double;
  x: Extended;
  nd,nx,ni: integer;
  zd: TComplexD;
  zx: TComplexE;
*/
 TComplex rez;
 //spall(ve,n+3,z1,vd,j+k,x,z2+z3,t-y,vi,n+k+j)

 /*
 Extended fvx;
 double   fvd;
 __int32  fni,fnd,fnx,fvi;


 fvx=*PExtended((*vx)+(*nx)*10);  //vx[nx]
 fvd=*PDouble((*vd)+(*nd)*8);     //vd[nd]
 fvi=*PInteger((*vi)+(*ni)*4);    //vi[ni]

 rez.re=(fvd*(*d)*(*zd).re-fvx*(*x)*(*zx).re)*fvi;
 rez.im=(fvd*(*d)*(*zd).im-fvx*(*x)*(*zx).im)*fvi;
 */


 rez.re=((*vd)[*nd]*(*d)*(*zd).re-(*vx)[*nx]*(*x)*(*zx).re)*(*vi)[*ni];
 rez.im=((*vd)[*nd]*(*d)*(*zd).im-(*vx)[*nx]*(*x)*(*zx).im)*(*vi)[*ni];


#ifdef   EXTENDED_VAR
  _asm
  {
   fld tbyte ptr [rez+16]
   fld tbyte ptr [rez]
  }
  //fzLoadFPUEP(&rez);
  //fzLoadFPUE(rez.re,rez.im);
#else    //DOUBLE
  _asm
  {
   fld qword ptr [rez+8]
   fld qword ptr [rez]
  }
  //fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);
#endif
}



void  _cdecl anyf(Int32 ni, TComplexE z1, double x, TArrayE vx)
{
double re,im;
TComplexE rez;
 //anyf(j+k,z1*z2,x+y,ve)


 rez.re=ni+z1.re+x+vx[ni];
 rez.im=z1.im;
 //rez.re=vx[ni];

 _asm
{
   fld tbyte ptr [rez+16]
   fld tbyte ptr [rez]
 }

 //fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);

}



void  _cdecl anyf1(Int32 ni, TComplexE z1, double x, TArrayI vi)
{
double re,im;
TComplexE rez;
 //anyf1(j+k,z1*z2,x+y,vi)


 rez.re=ni+z1.re+x+vi[ni];
 rez.im=z1.im;
 //rez.re=vx[ni];

 _asm
{
   fld tbyte ptr [rez+16]
   fld tbyte ptr [rez]
 }

 //fzLoadFPUDP(&rez);
 //fzLoadFPUD(rez.re,rez.im);

}


 //vems(ve,70)
//vems(ve,n)= ve[n]
double  _cdecl VEMS(Int32 addr)
{
 //return  (*PArrayE(addr))[(*PInteger(addr+16))];
   return  *PExtended(*PInteger(addr)+(*PInteger(addr+16))*10);
}



//******************************************************************************
//******************************************************************************


TFloat   __fastcall sp1(TFloat x)
{
  return x*x;
}



TFloat  __fastcall sp2(TFloat x1, TFloat x2)
{
 return  x1-x2;
}


TFloat  __fastcall sp3(TFloat x1, TFloat x2, TFloat x3)
{
 return  x1+x2-x3;
}


//********     same  functions for overloading complex: TComplexNum  ***********


TFloat Re(  TComplexNum z1)
{
  return z1.re;
};


TFloat Im( TComplexNum z1)
{
  return z1.im;
};


TComplexNum  __fastcall sp1(TComplexNum z1)
{
  return z1*z1;
}


TComplexNum  __fastcall sp2(TComplexNum z1, TComplexNum z2)
{
  return z1-z2;
}

TComplexNum  __fastcall sp2(TComplexNum z1, TFloat x)
{
  return z1-x;
}


TComplexNum  __fastcall sp2(TFloat x, TComplexNum z1)
{
  return x-z1;
}

TComplexNum  __fastcall sp3(TComplexNum z1, TComplexNum z2, TComplexNum z3)
{
  return z1+z2-z3;
}



TComplexNum  __fastcall spall(TArrayE vx, Int32 nx, TComplexNum z1, TArrayD vd, Int32 nd, double d, TComplexNum z2, Extended x, TArrayI vi, Int32 ni)
{
//spall(vx,nx,z1,vd,nd,d,z2,x,vi,ni) = (vd[nd]*d*z2 - vx[nx]*x*z1)*vi[ni]


return  (vd[nd]*d*z2 - vx[nx]*x*z1)*vi[ni];

}


//******************************************************************************
//******************************************************************************



void __fastcall TForm1::FormCreate(TObject *Sender)
{
  TZAddFuncStruct FS;
  Int32 fzLoad,ic,ID,IDF ;
  TArrayI VT;
  String Sid;
  Int32 ReType, CxType;





GetLocaleFormatSettings(0,G_FMT);
G_FMT.DecimalSeparator='.';

 fzLoad=fzInit();
 if (fzLoad != 0)
 {

#ifdef    ANSISTRING
  fzSet(fz_STRING_TYPE, fz_ANSISTRING);
#endif
#ifdef   WIDESTRING
  fzSet(fz_STRING_TYPE, fz_WIDESTRING);
#endif
#ifdef    STRING
  fzSet(fz_STRING_TYPE, fz_STRING_UTF16);
#endif
#ifdef    UTF8
  fzSet(fz_STRING_TYPE, fz_STRING_UTF8);
#endif
#ifdef    PANSICHAR
  fzSet(fz_STRING_TYPE, fz_PANSICHAR);
#endif



#ifdef   EXTENDED_VAR
   ReType= fz_REAL_EXTENDED; CxType =  fz_COMPLEX_EXTENDED;
 #else    //DOUBLE
   ReType= fz_REAL_DOUBLE; CxType =  fz_COMPLEX_DOUBLE;
#endif




  //fzSet(fz_CALC_TYPE, fz_REAL);
  //fzSet(fz_ENABLE, fz_SHOW_EXCEPTION);



#ifdef   EXTENDED_VAR
	 fzSet(fz_STACK_TYPE,fz_EXTENDED);
#else    //DOUBLE
	 fzSet(fz_STACK_TYPE,fz_DOUBLE);
#endif


#ifdef   EXTENDED_VAR
	 fzSetVar("z1",&z1f,fz_COMPLEX_EXTENDED);
	 fzSetVar("z2",&z2f,fz_COMPLEX_EXTENDED);
	 fzSetVar("z3",&z3f,fz_COMPLEX_EXTENDED);
	 fzSetVar("res",&resf,fz_COMPLEX_EXTENDED);
	 fzSetVar("result",&resf,fz_COMPLEX_EXTENDED);
	 fzSetVar("rez",&resf,fz_COMPLEX_EXTENDED);
	 fzSetVar("rezult",&resf,fz_COMPLEX_EXTENDED);
	 fzSetVar("x",&x,fz_REAL_EXTENDED);
	 fzSetVar("y",&y,fz_REAL_EXTENDED);
	 fzSetVar("t",&t,fz_REAL_EXTENDED);

#else    //DOUBLE
	 fzSetVar("z1",&z1f,fz_COMPLEX_DOUBLE);
	 fzSetVar("z2",&z2f,fz_COMPLEX_DOUBLE);
	 fzSetVar("z3",&z3f,fz_COMPLEX_DOUBLE);
	 fzSetVar("res",&resf,fz_COMPLEX_DOUBLE);
	 fzSetVar("result",&resf,fz_COMPLEX_DOUBLE);
	 fzSetVar("rez",&resf,fz_COMPLEX_DOUBLE);
	 fzSetVar("rezult",&resf,fz_COMPLEX_DOUBLE);
	 fzSetVar("x",&x,fz_REAL_DOUBLE);
	 fzSetVar("y",&y,fz_REAL_DOUBLE);
	 fzSetVar("t",&t,fz_REAL_DOUBLE);
#endif


   //fzSet(fz_STACK_DEEP,0);

  fzSetVar("n",&n,fz_REAL_INTEGER);
  fzSetVar("k",&k,fz_REAL_INTEGER);
  fzSetVar("j",&j,fz_REAL_INTEGER);

  fzSetVar("ad",&ad,fz_ARRAY_REAL_DOUBLE);
  fzSetVar("vd",&vd,fz_ARRAY_REAL_DOUBLE);
  fzSetVar("ve",&ve,fz_ARRAY_REAL_EXTENDED);
  fzSetVar("vi",&vi,fz_ARRAY_REAL_INTEGER);

  fzSetVarIntrnl("xvd",fz_ARRAY_REAL_DOUBLE,adrXVD);   fzSetLength(adrXVD, fz_ARRAY_REAL_DOUBLE, 100);
  fzSetVarIntrnl("xve",fz_ARRAY_REAL_EXTENDED,adrXVE); fzSetLength(adrXVE, fz_ARRAY_REAL_EXTENDED, 100);
  fzSetVarIntrnl("xvi",fz_ARRAY_REAL_INTEGER,adrXVI);  fzSetLength(adrXVI, fz_ARRAY_REAL_INTEGER, 100);


  n = 1; k = 2; j = 5;
  z1e.re=2.123;  z1e.im=-1.456;
  z2e.re=5.456;  z2e.im=2.789;
  z3e.re=-3.789; z3e.im=-3.123;
  z1d.re=2.123;  z1d.im=-1.456;
  z2d.re=5.456;  z2d.im=2.789;
  z3d.re=-3.789; z3d.im=-3.123;
  xe = 2.123; ye = 5.456; te = -3.789;
  xd = 2.123; yd = 5.456; td = -3.789;

  ad.set_length(3);
  ad[0]=3.5; ad[1]=-1.4;  ad[2]=7.6;

  z1.re = z1e.re;  z1.im = z1e.im;
  z2.re = z2e.re;  z2.im = z2e.im;
  z3.re = z3e.re;  z3.im = z3e.im;
  z1f.re = z1e.re;  z1f.im = z1e.im;
  z2f.re = z2e.re;  z2f.im = z2e.im;
  z3f.re = z3e.re;  z3f.im = z3e.im;
  x=xe; y=ye; t=te;
  i.re=0; i.im=1;
  i0.re=0; i0.im=0;

  vd.set_length(100);
  ve.set_length(100);
  vi.set_length(100);
  for (ic = 0; ic <= 99; ic++)
  {

   vd[ic]=ic+1;
   ve[ic]=ic+5;

   //vd1[ic]:=ic+2;
   //vd2[ic]:=ic+3;
   //vd3[ic]:=ic+4;

   //ve1[ic]:=ic+2;
   //ve2[ic]:=ic+3;
   //ve3[ic]:=ic+4;


   vd[ic]=pow((double)(-1),(Int32)(ic+1))*vd[ic]*0.5;
   ve[ic]=pow((Extended)(-1),(Int32)(ic+5))*ve[ic]*0.5;
   vi[ic]=trunc(ve[ic]);

   //vd1[ic]:=power(-1,ic+2)*vd1[ic]*0.7;
   //vd2[ic]:=power(-1,ic+3)*vd2[ic]*0.5;
   //vd3[ic]:=power(-1,ic+4)*vd3[ic]*0.3;

   //ve1[ic]:=power(-1,ic+2)*ve1[ic]*0.7;
   //ve2[ic]:=power(-1,ic+3)*ve2[ic]*0.5;
   //ve3[ic]:=power(-1,ic+4)*ve3[ic]*0.3;

   //vi1[ic]:=Trunc(ve1[ic]);
   //vi2[ic]:=Trunc(ve2[ic]);
   //vi3[ic]:=Trunc(ve3[ic]);

   fzSetArrayValueD(adrXVD,ic,vd[ic]);
   fzSetArrayValueE(adrXVE,ic,ve[ic]);
   fzSetArrayValueI(adrXVI,ic,vi[ic]);
  }



/******************************************************************************


                         Addition external functions:

*******************************************************************************/



/*


func1(arg1)=arg1^2; func2(arg1,arg2)=arg1-arg2; func3(arg1,arg2,arg3)=arg1+arg2-arg3;
arg1,arg2,arg3 - real/complex
arg2 - mixed real/complex

ms1, ms2, ms3      fz_ESP
sp1, sp2, sp3      fz_STACK_VAL
ps1, ps2, ps3      fz_STACK_ADR
pc1, pc2, pc3      fz_PreCompiled


infsum             fz_INFINITE;


with arg. of all types:
func10(TArrayE vx, Int32 nx, TComplexE zx, TArrayD vd, Int32 nd, double d, TComplexD zd, Extended x, TArrayI vi, Int32 ni) = (vd[k]*y*z2 - ve[n]*x*z1)*vi[j]

spall    fz_STACK_VAL
msall    fz_ESP
psall    fz_STACK_ADR
pcall    fz_PreCompiled


********************************************************************************
*/

  InitFuncStructZ(FS);
  FS.addr=&SP1;
  FS.CallType=fz_CDECL;
  FS.Arg=1;
  FS.ArgType=ReType;
  FS.ResultType=fz_REAL;
  FS.CallFunc=fz_STACK_VAL;
  FS.DeepFPU=1;
  fzSetFunction("sp1",&FS);

  InitFuncStructZ(FS);
  FS.addr=&SP2;
  FS.CallType=fz_STDCALL;
  FS.Arg=2;
  FS.ArgType=ReType;
  FS.ResultType=fz_REAL;
  FS.CallFunc=fz_STACK_VAL;
  FS.DeepFPU=1;
  fzSetFunction("sp2",&FS);

  InitFuncStructZ(FS);
  FS.addr=&SP3;
  FS.CallType=fz_PASCAL;
  FS.Arg=3;
  FS.ArgType=ReType;
  FS.ResultType=fz_REAL;
  FS.CallFunc=fz_STACK_VAL;
  FS.DeepFPU=1;
  fzSetFunction("sp3",&FS);

  InitFuncStructZ(FS);
  FS.addr=&SP1Z;
  FS.CallType=fz_PASCAL;
  FS.Arg=1;
  FS.ArgType=CxType;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_VAL;
  FS.DeepFPU=2;
  fzSetFunction("sp1",&FS);


  InitFuncStructZ(FS);
  FS.addr=&SP2Z;
  FS.CallType=fz_CDECL;
  FS.Arg=2;
  FS.ArgType=CxType;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_VAL;
  FS.DeepFPU=2;
  fzSetFunction("sp2",&FS);

  //mixed
  //sp2(z,x)=z-x
  InitFuncStructZ(FS);
  FS.Arg=2;
  VT.set_length(FS.Arg);
  VT[0]=CxType; VT[1]=ReType;
  FS.ArgTypeList=&VT[0];
  FS.addr=&SP2ZR;
  FS.CallType=fz_CDECL;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_VAL;
  FS.DeepFPU=2;
  fzSetFunction("sp2",&FS);

  //sp2(x,z)=x-z
  InitFuncStructZ(FS);
  FS.Arg=2;
  VT.set_length(FS.Arg);
  VT[0]=ReType; VT[1]=CxType;
  FS.ArgTypeList=&VT[0];
  FS.addr=&SP2RZ;
  FS.CallType=fz_CDECL;
  FS.Arg=2;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_VAL;
  FS.DeepFPU=2;
  fzSetFunction("sp2",&FS);

  InitFuncStructZ(FS);
  FS.addr=&SP3Z;
  FS.CallType=fz_STDCALL;
  FS.Arg=3;
  FS.ArgType=CxType;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_VAL;
  FS.DeepFPU=2;
  fzSetFunction("sp3",&FS);





  //ps1(x)
  InitFuncStructZ(FS);
  FS.addr=&PS1;
  FS.CallType=fz_CDECL;
  FS.Arg=1;
  FS.ArgType=ReType;
  FS.ResultType=fz_REAL;
  FS.CallFunc=fz_STACK_ADR;
  FS.DeepFPU=1;
  fzSetFunction("ps1",&FS);

  InitFuncStructZ(FS);
  FS.addr=&PS2;
  FS.CallType=fz_CDECL;
  FS.Arg=2;
  FS.ArgType=ReType;
  FS.ResultType=fz_REAL;
  FS.CallFunc=fz_STACK_ADR;
  FS.DeepFPU=1;
  fzSetFunction("ps2",&FS);

  InitFuncStructZ(FS);
  FS.addr=&PS3;
  FS.CallType=fz_STDCALL;
  FS.Arg=3;
  FS.ArgType=ReType;
  FS.ResultType=fz_REAL;
  FS.CallFunc=fz_STACK_ADR;
  FS.DeepFPU=1;
  fzSetFunction("ps3",&FS);

  InitFuncStructZ(FS);
  FS.addr=&PS1Z;
  FS.CallType=fz_PASCAL;
  FS.Arg=1;
  FS.ArgType=CxType;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_ADR;
  FS.DeepFPU=1;
  fzSetFunction("ps1",&FS);

  InitFuncStructZ(FS);
  FS.addr=&PS2Z;
  FS.CallType=fz_CDECL;
  FS.Arg=2;
  FS.ArgType=CxType;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_ADR;
  FS.DeepFPU=2;
  fzSetFunction("ps2",&FS);

  InitFuncStructZ(FS);
  FS.addr=&PS3Z;
  FS.CallType=fz_STDCALL;
  FS.Arg=3;
  FS.ArgType=CxType;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_ADR;
  FS.DeepFPU=2;
  fzSetFunction("ps3",&FS);

    //mixed
  //ps2(z,x)=z-x
  InitFuncStructZ(FS);
  FS.Arg=2;
  VT.set_length(FS.Arg);
  VT[0]=CxType; VT[1]=ReType;
  FS.ArgTypeList=&VT[0];
  FS.addr=&PS2ZR;
  FS.CallType=fz_CDECL;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_ADR;
  FS.DeepFPU=2;
  fzSetFunction("ps2",&FS);

  //ps2(x,z)=x-z
  InitFuncStructZ(FS);
  FS.Arg=2;
  VT.set_length(FS.Arg);
  VT[0]=ReType; VT[1]=CxType;
  FS.ArgTypeList=&VT[0];
  FS.addr=&PS2RZ;
  FS.CallType=fz_CDECL;
  FS.Arg=2;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_ADR;
  FS.DeepFPU=2;
  fzSetFunction("ps2",&FS);



  //ms1
  InitFuncStructZ(FS);
  FS.addr=&MS1;
  FS.ArgType=ReType;
  FS.Arg=1;
  FS.CallFunc=fz_ESP;
  FS.CallType=fz_CDECL;
  FS.DeepFPU=1;
  FS.ResultType=fz_REAL;
  fzSetFunction("ms1",&FS);

  InitFuncStructZ(FS);
  FS.addr=&MS2;
  FS.ArgType=ReType;
  FS.Arg=2;
  FS.CallFunc=fz_ESP;
  FS.CallType=fz_CDECL;
  FS.DeepFPU=1;
  FS.ResultType=fz_REAL;
  fzSetFunction("ms2",&FS);

  InitFuncStructZ(FS);
  FS.addr=&MS3;
  FS.ArgType=ReType;
  FS.Arg=3;
  FS.CallFunc=fz_ESP;
  FS.CallType=fz_CDECL;
  FS.DeepFPU=1;
  FS.ResultType=fz_REAL;
  fzSetFunction("ms3",&FS);

   //ms2z
  InitFuncStructZ(FS);
  FS.addr=&MS1Z;
  FS.ArgType=CxType;
  FS.Arg=1;
  FS.CallFunc=fz_ESP;
  FS.CallType=fz_CDECL;
  FS.DeepFPU=2;
  FS.ResultType=fz_COMPLEX;
  fzSetFunction("ms1",&FS);

   //ms2z
  InitFuncStructZ(FS);
  FS.addr=&MS2Z;
  FS.ArgType=CxType;
  FS.Arg=2;
  FS.CallFunc=fz_ESP;
  FS.CallType=fz_CDECL;
  FS.DeepFPU=2;
  FS.ResultType=fz_COMPLEX;
  fzSetFunction("ms2",&FS);

   //ms3z
  InitFuncStructZ(FS);
  FS.addr=&MS3Z;
  FS.ArgType=CxType;
  FS.Arg=3;
  FS.CallFunc=fz_ESP;
  FS.CallType=fz_CDECL;
  FS.DeepFPU=2;
  FS.ResultType=fz_COMPLEX;
  fzSetFunction("ms3",&FS);

  //mixed
  //ms2(z,x)=z-x
  InitFuncStructZ(FS);
  FS.Arg=2;
  VT.set_length(FS.Arg);
  VT[0]=CxType; VT[1]=ReType;
  FS.ArgTypeList=&VT[0];
  FS.addr=&MS2ZR;
  FS.CallType=fz_CDECL;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_ESP;
  FS.DeepFPU=2;
  fzSetFunction("ms2",&FS);

  //ms2(x,z)=x-z
  InitFuncStructZ(FS);
  FS.Arg=2;
  VT.set_length(FS.Arg);
  VT[0]=ReType; VT[1]=CxType;
  FS.ArgTypeList=&VT[0];
  FS.addr=&MS2RZ;
  FS.CallType=fz_CDECL;
  FS.Arg=2;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_ESP;
  FS.DeepFPU=2;
  fzSetFunction("ms2",&FS);


  InitFuncStructZ(FS);
  FS.addr=&sumr;
  FS.ArgType=ReType;
  FS.CallFunc=fz_INFINITE;
  FS.CallType=fz_CDECL;
  FS.ResultType=fz_REAL;
  FS.DeepFPU=2;
  fzSetFunction("infsum",&FS);


  InitFuncStructZ(FS);
  FS.addr=&sumz;
  FS.ArgType=CxType;
  FS.CallFunc=fz_INFINITE;
  FS.CallType=fz_CDECL;
  FS.ResultType=fz_COMPLEX;
  FS.DeepFPU=2;
  fzSetFunction("infsum",&FS);

  //infsum(z1,infsum(x,y,t)*z1,infsum(x+0i,z1*z2,z3*t),t+0i,z2)


  InitFuncStructZ(FS);
  FS.Arg=4;
  VT.set_length(FS.Arg);
  FS.addr=&anyf;
  VT[0]=fz_REAL_INTEGER; VT[1]=fz_COMPLEX_EXTENDED; VT[2]=fz_REAL_DOUBLE;  VT[3]=fz_ARRAY_REAL_EXTENDED;
  FS.ArgTypeList=&VT[0];
  FS.CallType=fz_CDECL;
  //FS.ArgType=fz_DIFFER;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_VAL;
  FS.DeepFPU=3;
  fzSetFunction("anyf",&FS);

  InitFuncStructZ(FS);
  FS.Arg=4;
  VT.set_length(FS.Arg);
  FS.addr=&anyf1;
  VT[0]=fz_REAL_INTEGER; VT[1]=fz_COMPLEX_EXTENDED; VT[2]=fz_REAL_DOUBLE;  VT[3]=fz_ARRAY_REAL_INTEGER;
  FS.ArgTypeList=&VT[0];
  FS.CallType=fz_CDECL;
  //FS.ArgType=fz_DIFFER;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_VAL;
  FS.DeepFPU=3;
  fzSetFunction("anyf1",&FS);

  InitFuncStructZ(FS);
  FS.Arg=2;
  VT.set_length(FS.Arg);
  VT[0]=fz_ARRAY_REAL_EXTENDED; VT[1]=fz_REAL_INTEGER;
  FS.ArgTypeList=&VT[0];
  FS.addr=&VEMS;
  FS.CallFunc=fz_ESP;
  FS.CallType=fz_CDECL;
  FS.DeepFPU=2;
  FS.ResultType=fz_REAL;
  fzSetFunction("vems",&FS);

  //TArrayE vx, Int32 nx, TComplexE zx, TArrayD vd, Int32 nd, double d, TComplexD zd, Extended x, TArrayI vi, Int32 ni
  InitFuncStructZ(FS);
  FS.Arg=10;
  VT.set_length(FS.Arg);
  FS.addr=&SPALL;
  VT[0]=fz_ARRAY_REAL_EXTENDED; VT[1]=fz_REAL_INTEGER; VT[2]=fz_COMPLEX_EXTENDED; VT[3]=fz_ARRAY_REAL_DOUBLE;
  VT[4]=fz_REAL_INTEGER; VT[5]=fz_REAL_DOUBLE; VT[6]=fz_COMPLEX_DOUBLE;  VT[7]=fz_REAL_EXTENDED;
  VT[8]=fz_ARRAY_REAL_INTEGER; VT[9]=fz_REAL_INTEGER;
  FS.ArgTypeList=&VT[0];
  FS.CallType=fz_CDECL;
  //FS.ArgType=fz_DIFFER;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_VAL;
  FS.DeepFPU=3;
  fzSetFunction("spall",&FS);

  InitFuncStructZ(FS);
  FS.Arg=10;
  VT.set_length(FS.Arg);
  FS.addr=&MSALL;
  VT[0]=fz_ARRAY_REAL_EXTENDED; VT[1]=fz_REAL_INTEGER; VT[2]=fz_COMPLEX_EXTENDED; VT[3]=fz_ARRAY_REAL_DOUBLE;
  VT[4]=fz_REAL_INTEGER; VT[5]=fz_REAL_DOUBLE; VT[6]=fz_COMPLEX_DOUBLE;  VT[7]=fz_REAL_EXTENDED;
  VT[8]=fz_ARRAY_REAL_INTEGER; VT[9]=fz_REAL_INTEGER;
  FS.ArgTypeList=&VT[0];
  FS.CallType=fz_CDECL;
  //FS.ArgType=fz_DIFFER;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_ESP;
  FS.DeepFPU=3;
  fzSetFunction("msall",&FS);

  InitFuncStructZ(FS);
  FS.Arg=10;
  VT.set_length(FS.Arg);
  FS.addr=&PSALL;
  VT[0]=fz_ARRAY_REAL_EXTENDED; VT[1]=fz_REAL_INTEGER; VT[2]=fz_COMPLEX_EXTENDED; VT[3]=fz_ARRAY_REAL_DOUBLE;
  VT[4]=fz_REAL_INTEGER; VT[5]=fz_REAL_DOUBLE; VT[6]=fz_COMPLEX_DOUBLE;  VT[7]=fz_REAL_EXTENDED;
  VT[8]=fz_ARRAY_REAL_INTEGER; VT[9]=fz_REAL_INTEGER;
  FS.ArgTypeList=&VT[0];
  FS.CallType=fz_CDECL;
  //FS.ArgType=fz_DIFFER;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_ADR;
  FS.DeepFPU=3;
  fzSetFunction("psall",&FS);


  //spall(ve,n+3,z1,vd,j+k,x,z2+z3,t-y,vi,n+k+j)
  //pcall(ve,n+3,pcall(ve,n+1,z1/z2,vd,j+k-1,x,z2/pcall(ve,j+3,z3-pcall(ve,n+9,z1-z3+z1,vd,k*j,x*t,z2*z3,y-t,vi,j+9),vd,k+7,x,z1-z2/pcall(ve,n+3+j,z3/z1,vd,j+k+7,x,z2/z3,-y/t,vi,k+j+5),y/t,vi,j),t-y,vi,n+j),vd,j+k,x,z2-pcall(ve,k+3,z1/pcall(ve,n+3+k,z3*t,vd,j+k+9,x,z1-z3,t-y*x,vi,n+k+j),vd,k+3,x/t,z2*pcall(ve,j+k+7,z1*y,vd,j+3*k,x,z2*y,y-x/y,vi,n+7*k),t/y,vi,k+n+7),t-y/t,vi,n+k+j)
  //spall(ve,n+3,spall(ve,n+1,z1/z2,vd,j+k-1,x,z2/spall(ve,j+3,z3-spall(ve,n+9,z1-z3+z1,vd,k*j,x*t,z2*z3,y-t,vi,j+9),vd,k+7,x,z1-z2/spall(ve,n+3+j,z3/z1,vd,j+k+7,x,z2/z3,-y/t,vi,k+j+5),y/t,vi,j),t-y,vi,n+j),vd,j+k,x,z2-spall(ve,k+3,z1/spall(ve,n+3+k,z3*t,vd,j+k+9,x,z1-z3,t-y*x,vi,n+k+j),vd,k+3,x/t,z2*spall(ve,j+k+7,z1*y,vd,j+3*k,x,z2*y,y-x/y,vi,n+7*k),t/y,vi,k+n+7),t-y/t,vi,n+k+j)

  fzSetFunction("pcall(vx: arrayExt; nx:int; zx: extCx; vd: arrayDbl; nd: int; d: dbl; zd: dblCx; x: ext; vi: arrayInt; ni: int):complex=(vd[nd]*d*zd - vx[nx]*x*zx)*vi[ni]",0);


#ifdef   EXTENDED_VAR
    fzSetFunction("pc1(x:ext):real=x^2",0);
    fzSetFunction("pc2(x,y:ext):real=x-y",0);
    fzSetFunction("pc3(x1,x2,x3:ext):real=x1+x2-x3",0);
    fzSetFunction("pc1(z:extCx):complex=z^2",0);
    fzSetFunction("pc2(x:ext;z:extCx):complex=x-z",0);
    fzSetFunction("pc2(z:extCx; x:ext):complex=z-x",0);
    fzSetFunction("pc2(z1,z2:extCx):complex=z1-z2",0);
    fzSetFunction("pc3(z1,z2,z3:extCx):complex=z1+z2-z3",0);
  #else
    fzSetFunction("pc1(x:dbl):real=x^2",0);
    fzSetFunction("pc2(x,y:dbl):real=x-y",0);
    fzSetFunction("pc3(x1,x2,x3:dbl):real=x1+x2-x3",0);
    fzSetFunction("pc1(z:dblCx):complex=z^2",0);
    fzSetFunction("pc2(x:dbl;z:dblCx):complex=x-z",0);
    fzSetFunction("pc2(z:dblCx; x:dbl):complex=z-x",0);
    fzSetFunction("pc2(z1,z2:dblCx):complex=z1-z2",0);
    fzSetFunction("pc3(z1,z2,z3:dblCx):complex=z1+z2-z3",0);
#endif


 }

//fzSetNameImUnit("ii");
/*
fzGetFuncID("sh",IDF);
fzSet(fz_DISABLE_FUNCTION,IDF);
*/

/*
fzSetFunction("pwr(x,y: ext):complex= if( (x < 0) and ([y] <> y),(x+0i)^y,x^y+0i)",0);
fzSetFunction("pwr(x: ext; z: extcx):complex= x^z",0);
fzSetFunction("pwr(z: extcx; x: ext):complex= z^x",0);
fzSetFunction("pwr(z1,z2: extcx):complex= z1^z2",0);


fzGetFuncID("power",IDF);
fzSet(fz_DISABLE_FUNCTION,IDF);
fzGetFuncID("pwr",IDF);
fzAddNameFunction(IDF,"power");
fzAddNameFunction(IDF,"pow");
fzSet(fz_POWER_SYMBOL,IDF);
*/

//(-x)^2.5
//(-4)^(0.5)


//***************  several expressions: ****************************************
   /*
	  fnc1(z1,z2,n,x) = z1+z2+n*x;
	  fnc2(z1,z2,n,x)=  z1*z2+(i*n+x);

	  fnc2(fnc1(2-i,5+3i,3,1.1),1-i,5,fnc1(2-i,5+3i,3,1.1).re)=
   */


	fzPerform(fz_SAVE, fz_VAR_LIST);

	fnc1.Expr= "z1+z2+n*x";
	fzSetVar("x", &fnc1.x, fz_REAL_DOUBLE);
	fzSetVar("n", &fnc1.n, fz_REAL_INTEGER);
	fzSetVar("z1", &fnc1.z1, fz_COMPLEX_DOUBLE);
	fzSetVar("z2", &fnc1.z2, fz_COMPLEX_DOUBLE);
	fzCompile(fnc1.Expr, fnc1.addr);

	fnc2.Expr= "z1*z2+(i*n+x)";
	fzSetVar("x", &fnc2.x, fz_REAL_DOUBLE);
	fzSetVar("n", &fnc2.n, fz_REAL_INTEGER);
	fzSetVar("z1", &fnc2.z1, fz_COMPLEX_DOUBLE);
	fzSetVar("z2", &fnc2.z2, fz_COMPLEX_DOUBLE);
	fzCompile(fnc2.Expr, fnc2.addr);

	fzPerform(fz_RESTORE, fz_VAR_LIST);

	fnc1.x= 1.1;  fnc1.n= 3; fnc1.z1.re= 2;  fnc1.z1.im= -1;  fnc1.z2.re= 5; fnc1.z2.im= 3;
				  fnc2.n= 5;                                  fnc2.z2.re= 1; fnc2.z2.im= -1;

	fzResultCxDP(fnc1.addr, &fnc1.res) ;    //fnc1.res=fnc1(2-i,5+3i,3,1.1)
	fnc2.z1= fnc1.res; fnc2.x= fnc1.res.re;

	fzResultCxDP(fnc2.addr, &fnc2.res);

	//ShowMessage(FloatToStrF(fnc2.res.re,ffGeneral,19,4,G_FMT)+FloatToStrF(fnc2.res.im,ffGeneral,19,4,G_FMT)+"i");

//******************************************************************************




fzGet(fz_VERSION,fz_MAJOR,ID);    Sid=IntToStr(ID);
fzGet(fz_VERSION,fz_MINOR,ID);    Sid=Sid+'.'+IntToStr(ID);
fzGet(fz_VERSION,fz_RELEASE,ID);  Sid=Sid+'.'+IntToStr(ID);
fzGet(fz_VERSION,fz_BUILD,ID);    Sid=Sid+'.'+IntToStr(ID);



Form1->Caption="Test ForevalZ.dll  (v."+Sid+")";
fzGet(fz_COMPILED_BY,0,ID);


if (ID >= 100) {Form1->Caption=Form1->Caption+".  Compiled by FPC v." + IntToStr(ID);}
else
{
 switch  (ID)
 {

  case 7: Form1->Caption=Form1->Caption+".   Compiled by Delphi7"; break;
  case 8: Form1->Caption=Form1->Caption+".   Compiled by Delphi8";   break;
  case 9: Form1->Caption=Form1->Caption+".   Compiled by Delphi2005"; break;
  case 10: Form1->Caption=Form1->Caption+".  Compiled by Delphi2006"; break;
  case 11: Form1->Caption=Form1->Caption+".  Compiled by Delphi2007";  break;
  case 12:  Form1->Caption=Form1->Caption+".   Compiled by Delphi 2009"; break;
  case 13:  Form1->Caption=Form1->Caption+".   Compiled by Delphi 2010"; break;
  case 14:  Form1->Caption=Form1->Caption+".   Compiled by Delphi XE"; break;
  case 15:  Form1->Caption=Form1->Caption+".   Compiled by Delphi XE2";  break;
  case 16:  Form1->Caption=Form1->Caption+".   Compiled by Delphi XE3";  break;
  case 17:  Form1->Caption=Form1->Caption+".   Compiled by Delphi XE4";  break;
  case 18:  Form1->Caption=Form1->Caption+".   Compiled by Delphi XE5"; break;
  case 19:  Form1->Caption=Form1->Caption+".   Compiled by Delphi XE6";  break;
  case 20:   Form1->Caption=Form1->Caption+".   Compiled by Delphi XE7";  break;
  }
}

}

//---------------------------------------------------------------------------


//******************************************************************************



 void SetVarValue(void)
{
  xd=StrToFloat(Form1->E_x->Text,G_FMT);
  xe=StrToFloat(Form1->E_x->Text,G_FMT);
  yd=StrToFloat(Form1->E_y->Text,G_FMT);
  ye=StrToFloat(Form1->E_y->Text,G_FMT);

  z1d.re=StrToFloat(Form1->E_z1x->Text,G_FMT);
  z1d.im=StrToFloat(Form1->E_z1y->Text,G_FMT);
  z1e.re=StrToFloat(Form1->E_z1x->Text,G_FMT);
  z1e.im=StrToFloat(Form1->E_z1y->Text,G_FMT);

  n=StrToInt(Form1->E_n->Text);
  k=StrToInt(Form1->E_k->Text);

  ad[0]=StrToFloat(Form1->E_ad0->Text,G_FMT);
  ad[1]=StrToFloat(Form1->E_ad1->Text,G_FMT);
  ad[2]=StrToFloat(Form1->E_ad2->Text,G_FMT);

  z1.re = z1e.re;  z1.im = z1e.im;
  z2.re = z2e.re;  z2.im = z2e.im;
  z3.re = z3e.re;  z3.im = z3e.im;

  z1f.re = z1e.re;  z1f.im = z1e.im;
  z2f.re = z2e.re;  z2f.im = z2e.im;
  z3f.re = z3e.re;  z3f.im = z3e.im;

  x=xe; y=ye; t=te;
}




/*
void TestEvalCmpFE(PTGccTest GccFunc, Pointer32 FFunc)
{

	   Extended resGr,resGi,resFr,resFi,h,dh,dx,dy,dt,si;
	   //double dresG_re,dresG_im,dresF_re,dresF_im,si;
	   INT32 t1,t2,i,PerfG,PerfF,dn,dk,dj;
	   //TComplexNum resG;
      // TComplex resF;
	   String SG1r,SG2r,SResG,SResF;


	   //GNC = 10000000;
	   //si =  10000000;
	   SetVarValue();
	   si=log10l((Extended)GNC)/3;
       dn=(INT32)trunc(si+3);
       dk=(INT32)trunc(si+2);
       dj=(INT32)trunc(si+1);

       resG.re=0.0; resG.im=0.0; //h=0.0000001;
       dh=(Extended)1/GNC;
       dx=dh*2; dy=dh*3; dt=dh;


	   t1=GetTickCount();
	   for(i=0; i <= GNC; i++)
	   {
		   x=x+dx; y=y-dy; t=t+dt;
		  //n=n+dn; k=k+dk; j=j+dj;
		  z1.re=z1.re+dx; z2.re=z2.re+dy; z3.re=z3.re+dt; z1.im=z1.im-dx; z2.im=z2.im-dy; z3.im=z3.im-dt;
		resG=resG+GccFunc();
		//resG=GccFunc();
		   z3.im=z3.im+dt; z3.re=z3.re-dt; z1.re=z1.re-dx; z2.re=z2.re-dy; z2.im=z2.im+dy;  z1.im=z1.im+dx;
		  //j=j-dj; k=k-dk;  n=n-dn;
		   t=t-dt;  y=y+dy; x=x-dx;
	   }
	   t2=GetTickCount();

	   if (t1 == t2)
	   {
		 PerfG=0;
	   }
       else
	   {
		PerfG=INT32(GNC/(t2-t1));
	   };

	   SetVarValue();
       resf.re=0.0; resf.im = 0.0;//h=0.0000001;
       //dh=(Extended)1/GNC;
       //dx=dh*2; dy=dh*3; dt=dh;
       t1=GetTickCount();
	   for(i=0; i <= GNC; i++)
       {
		  x=x+dx; y=y-dy; t=t+dt;
		  n=n+dn; k=k+dk; j=j+dj;
	      z1f.re=z1f.re+dx; z2f.re=z2f.re+dy; z3f.re=z3f.re+dt; z1f.im=z1f.im-dx; z2f.im=z2f.im-dy; z3f.im=z3f.im-dt;
	  fzResult(FFunc);
		  z1f.re=z1f.re-dx; z2f.re=z2f.re-dy; z3f.re=z3f.re-dt; z1f.im=z1f.im+dx; z2f.im=z2f.im+dy; z3f.im=z3f.im+dt;
		  //j=j-dj; k=k-dk;  n=n-dn;
          t=t-dt;  y=y+dy; x=x-dx;
       }
       t2=GetTickCount();

       if (t1 == t2)
       {
         PerfF=0;
       }
       else
       {
        PerfF=INT32(GNC/(t2-t1));
       };




	resG.re=resG.re/GNC; resG.im=resG.im/GNC;
	resF.re=resf.re/GNC; resF.im=resf.im/GNC;

	//SG1r=FloatToStrF(resG.re,ffGeneral,20,4,G_FMT);
	//SG1i=FloatToStrF(resG.im,ffGeneral,20,4,G_FMT);



};



                              /// arithmetic expressions:
TComplexNum GccF()
{
  //return sp3(z1,sp2(z1+z3,x-z2)-sp2(sp2(z1+z2,t+y)-z2,sp3(z1,z3,-z2)*sp2(x+y,z1-z2)),z3-z1*sp2(z3*x,-y*z1))*sp2(-sp2(x*t,-y*x),sp1(z2+z3)*sp1(x-t))-sp3(x,y,y-t*x)*sp2(z1-z2*sp2(z2,t+z3),sp1(z3)*x-z2)*sp2(-sp2(z3+y,x+z2),z2);
  return z1-t-z3*z3+y-x-z2;
}
*/


void __fastcall TForm1::Button1Click(TObject *Sender)
{

   //Int32 *Func1;
   Pointer32 Func1,FuncPS;
   //Int32 FuncAddr ;

  // Extended Re,Im;
   TComplexE rezCx;
   TStringType Expr,ErStr,S1,S2;
   Int32 ECode,ct,rt;
   String SRez,S1r,S2r;
   Int32  ni,NC,T1,T2;
   AnsiString ans;
   TComplexNum rez;

//*****************************************************************************
   /*
   Expr = "res=res+z1-t-z3*z3+y-x-z2";
   //Expr = "res=res+ps3(z1,ps2(z1+z3,x-z2)-ps2(ps2(z1+z2,t+y)-z2,ps3(z1,z3,-z2)*ps2(x+y,z1-z2)),z3-z1*ps2(z3*x,-y*z1))*ps2(-ps2(x*t,-y*x),ps1(z2+z3)*ps1(x-t))-ps3(x,y,y-t*x)*ps2(z1-z2*ps2(z2,t+z3),ps1(z3)*x-z2)*ps2(-ps2(z3+y,x+z2),z2)";

   //Expr = "res=res+z1+z2";

   fzCompile(Expr,FuncPS);
   GNC =  StrToInt(ENC->Text);
   TestEvalCmpFE(GccF,FuncPS);
   S1r=FloatToStrF(resG.re,ffGeneral,20,4,G_FMT);
   S2r=FloatToStrF(resG.im,ffGeneral,20,4,G_FMT);
   LR->Caption=S1r+"  "+S2r+"i";
   S1r=FloatToStrF(resF.re,ffGeneral,20,4,G_FMT);
   S2r=FloatToStrF(resF.im,ffGeneral,20,4,G_FMT);
   LPf -> Caption=S1r+"  "+S2r+"i";
   goto endp;
   */

   SetVarValue();

   //NC = 10000000;
   NC = StrToInt(ENC->Text);
   rezCx.re = 0; rezCx.im = 0;



//---------------------------------------- !!!!! WITH  OVERLOAD COMPLEX OPERATIONS  !!!!!-----------------------------------------------------------------

   #ifdef   OVERLOADCOMPLEX
      if (CB_OM->Checked) { NC=1;} else {NC=abs(trunc(StrToFloat(ENC->Text,G_FMT)));};
	  T1=GetTickCount();
	  for (ni = 0; ni < NC; ni++)
	  {
//      rez =  z2*(z1-(z3-z2+z1)*(z3*z2-z2*z1+z1*z3))+z1*z2-z2*(z1+z2-z3)*z2;
//      rez =  z3*(z1*z3-z2*(z1-z2+z3*z1)-z2*z3)-z1*z2;
//      rez =  z1/z2-z3/(z1+z2)+(z1-z3)/z2;
//      rez =  (y*(z1-z2+z3)-t*z3+(x-t)*(z3*z2*y-z1))*(z1*x-y*z2)*(z2-t+z3*(x+y));
//      rez =  z2*(z1-(z3-z2+z1)*(z3*z2-z2*z1+z1*z3))+z1*z2-z2*(z1+z2-z3)*z2-(z1*(z3+z2)*z3-(z3*z1-z3-z1))*z1 ;

//      rez =  z1*z2*z3*(z3*z1*(z1*z2-z3*z1)-z1*z2*(z1*z3-z2*z3)+z2*z1*(z2*z1-z3*z2)-(z1+z2)*(z1-z2)*(z3-z2)*(z1*z2-z3*z1*(z1-z2*(z3-z1*(z3-z1)*(z1-z3)*(z3-z2)-z1*z2-z2))))-(z1*z3*z2*(z1*z2-z1*(z2-z2*(z3-z3*(z1-z1*z3*(z1*z2-z3*z1-(z1*z2-z3*z1)*(z1-z2)*(z2-z3)*(z3-z2)-(z1+z3*z2)*(z2-z1*z3)+(z3-z2*z3)*(z2-z3*z1))))))) ;
//      rez = -z1/(z1/z2-z3/(z1+z3)+z1*z2*(z1*z2-z2*z3+z1/(z1/(z1+z2)+z2/(z3+z1))))*(z2*(z1-z2/(z1*z2-z2/(z1*z2+z2*z3)*(z2*z3-z1*z2)))+z1-z2*(z1-z3-z3/(z1-z2)*(z2/(z2-z3*(z1+z2*z3)*(z2-z1*z3)/(z1*z3-z2*(z1+z3))))))*(z1*z2-z3*z2-z3*(z1*z3-z2*(z3-z1)/(z1*z2*z3-z1-z2-z3)));
//      rez = z1*z2*(2.111*z1+1)*(2.211*z1*z2/z3-2.311*z1*(3.422*z3-1)/(2.511*z1-3.611*z2-4.22)*(z1/(3.711*z1-1)-4.111/z1+5.111*(2.611*z1*z2*z3-1.23)/(z2+1.12)-7.132*(2.812*z1*(z2+1.123)*(3.832*z2+2.121)*(3.112/(z1+1.123)-2.133*z3))));
//      rez = z1*z2*(z1-z3*(2.123*z1-3.222*z2-5.323)/(z3*z1*z2/(2.234-z1*z2)+(2.455*z1+3.632)*(3.734*z2-4.832*z3-5.923)-(1.134-z1)/(-z3-z2))+z1*(z2-(-z1-(-z2/(-z3*z1*(z1*z2*z3*(2.745*z1-3.345*z2-z3))-z2*(z1*z2-z2*z3*3.167+2.965*(z1/z3-z3/(z1-z2*(2.467-z1-z2-z3)))*(z2-z3)-2.376*z1)*(z2-z1)-7.154/z1)*(-1.943/z3+z1*z2*z3*5.334))-3.556*z1-5.657)-7.243*z2-3.459)/(z1-z3)+z1*(z3*z2/(z1-2.834*z3)-z2*(z1*(z3-2.756*z2-z1-5.676))));
//      rez = (z1*z2+z3*(z1*z2-z2*z3*z1-z1+z2-z3))*(z1+z2+z3)*(z1-z2-z3)*(z3-z1*(z3-z2*(z1-z2-z3)))*z1*z2*z3-z1*z3*(z1*z3-z2*z3+z1-z3)*(z2*z1+z3*z1+z3*z2-z2-z1)*(z1*z3-z2*(z1-z2*z3-z3-z1)*(z1-z2-z3)-z2*(z2+z2*z1-z3-z1)+z3*(z1*z2-z1*(z3+z2*(z1*z2-z3*z2*z1-z2*z3*(z2+z1*(z1-z3+z2*(z1-z2+z3-z1*(z1*z2-z3*z1)*(z1*z2-z3*(z1+z2+z3)*(z1-z2-z3)-z3*(-z1-z2*(-z3*(-z1*(z2-z3))))))))))));
//      rez = z1*z2-z1/(z1/z2-z3/z2-(-z1-z2*(z1*z2-z3*z1/(z1/z2-z3/z2-(-z1-(-z2-(-z3-(z1*z2-z2*(-z1*z2-z2/(z1+z2*z3)))*z1)*z2)/(z1+z2*z3)-z1*(z2/z3-(-z2*z1/(z1-z2*z3)-(-z1-(-z2/(-z1*z2*(-z1-z2))+z1/z2*(z2*z1+z2*z3-z1/(z1+z2*z3))-z1*z2*(z1*z2+(-z1*z2-z3/z2+z1-z2*z1)))))+z1*z2*z3*(z1+z2*z3)))))));
//      rez = z1*z2*(z1-z3*(2.154*z1-3.253*z2-5.353)/(z3*z1*z2/(2.544-z1*z2)+(2.143*z1+3.556)*(3.343*z2-4.153*z3-5.456)-(1.153-z1)/(-z3-z2))+z1*(z2-(-z1-(-z2/(-z3*z1*(z1*z2*z3*(2.644*z1-3.364*z2-z3))-z2*(z1*z2-z2*z3*3.164+2.267*(z1/z3-z3/(z1-z2*(2.533-z1-z2-z3)))*(z2-z3)-2.453*z1)*(z2-z1)-7.535/z1)*(-1.253/z3+z1*z2*z3*5.353))-3.433*z1-5.455)-7.466*z2-3.577)/(z1-z3)+z1*(z3*z2/(z1-2.699*z3)-z2*(z1*(z3-2.767*z2-z1-5.854)-z2*(-1.549-z1/(-z3-z2))/(z1/z2-z1/(z3/z1-z2/z3)+z3*(1/z1-5.344/z2-z1*z2*(2.435*z1-1.456)*(z3*z2*3.326-5.347)*(1.943-z1*z2*z3*3.245)*(z1+z2))))));
//      rez = (z1*z2+z3*(z1*z2-z2*z3*z1-z1+z2-z3))*(z1+z2+z3)*(z1-z2-z3)*(z3-z1*(z3-z2*(z1-z2-z3)))*z1*z2*z3-z1*z3*(z1*z3-z2*z3+z1-z3)*(z2*z1+z3*z1+z3*z2-z2-z1)*(z1*z3-z2*(z1-z2*z3-z3-z1)*(z1-z2-z3)-z2*(z2+z2*z1-z3-z1)+z3*(z1*z2-z1*(z3+z2*(z1*z2-z3*z2*z1-z2*z3*(z2+z1*(z1-z3+z2*(z1-z2+z3-z1*(z1*z2-z3*z1)*(z1*z2-z3*(z1+z2+z3)*(z1-z2-z3*(z1-z2*(z3-z1*z2-z2*(z1*z2-z3*z1)-z3*(z3*z1+z2))))-z3*(-z1-z2*(-z3*(-z1*(z2-z3*(z1*z2*z3-z2*z1*z3*(-z1*(z2*z1-z3*z2-z1-z2-z3)))))))))))))));
//      rez = (z1*z2+z3/(z1*z2-z2*z3/z1-z1+z2-z3))*(z1+z2+z3)/(z1-z2-z3)*(z3-z1*(z3-z2/(z1-z2-z3)))*z1/z2*z3-z1*z3*(z1*z3-z2*z3+z1-z3)/(z2*z1+z3*z1+z3/z2-z2-z1)*(z1*z3-z2*(z1-z2*z3-z3-z1)*(z1-z2-z3)-z2*(z2+z2*z1-z3-z1)+z3*(z1*z2-z1*(z3+z2/(z1*z2-z3*z2*z1-z2*z3*(z2+z1*(z1-z3+z2*(z1-z2+z3-z1*(z1*z2-z3*z1)*(z1*z2-z3*(z1+z2+z3)*(z1-z2-z3/(z1-z2*(z3-z1*z2-z2/(z1*z2-z3*z1)-z3/(z3/z1+z2))))-z3*(-z1-z2*(-z3/(-z1*(z2-z3*(z1*z2/z3-z2*z1*z3/(-z1*(z2*z1-z3*z2-z1-z2-z3)))))))))))))));
//      rez = z1*z2*(z1-z3*(2.156*z1-3.652*z2-5.653)/(z3*z1*z2/(2.664-z1*z2)+(2.155*z1+3.543)*(3.345*z2-4.431*z3-5.443)-(1.451-z1)/(-z3-z2))+z1*(z2-(-z1-(-z2/(-z3*z1*(z1*z2*z3*(2.453*z1-3.353*z2-z3))-z2*(z1*z2-z2*z3*3.153+2.253*(z1/z3-z3/(z1-z2*(2.533-z1-z2-z3)))*(z2-z3)-2.453*z1)*(z2-z1)-7.553/z1)*(-1.253/z3+z1*z2*z3*5.533))-3.453*z1-5.453)-7.453*z2-3.553)/(z1-z3)+z1*(z3*z2/(z1-2.653*z3)-z2*(z1*(z3-2.753*z2-z1-5.853)-z2*(-1.539-z1/(-z3-z2))/(z1/z2-z1/(z3/z1-z2/z3)+z3*(1/z1-5.553/z2-z1*z2*(2.535*z1-1.53)*(z3*z2*3.536-5.753)*(1.539-z1*z2*z3*3.665)*(z1+z2*(z3-(-z1-z2*z3/(z1*z2-2.863*(z1*z2*(z1-z2*(z1*z3+z2/z3*(2.623*z1-1.352-z3*z2))))))))))))) ;
	  rez = z1*z2*(2.251*z1+1)*(2.243*z1*z2/z3-2.353*z1*(3.475*z3-1)/(2.575*z1-3.675*z2-4.766)*(z1/(3.767*z1-1)-4.176/z1+5.186*(2.866*z1*z2*z3-1.766)/(z2+1.876)-7.165*(2.874*z1*(z2+1.641)*(3.864*z2+2.162)*(3.171/(z1+1.765)-2.173*z3/(2.174*z1*z2*z3-1.171)+(4.171*z1-1.164)*(5.172*z2-7.174)/(z1-2.175*z2-1.747-2.174*z3/(3.618-7.716*z1-8.181*z2*(4.612*z1/(2.189*z3+1.165)-7.198*z1-8.149/z3+9.912*(2.199*z1-1.261)*(3.107*z1+4.179*z2+5.108)*(2.271*z1*z2*z3-7.179)*z1*z2*z3/(z1-z2*2.282-3.621/(z1/(z3-1.147)-7.198/(z2+2.245)+8.233/(2.288*z1*z2*z3+1.247)-9.174)))))/(z1-1.525)))));



	 // rez = sp3(z1*sp2(sp1(z2-z1),sp2(z1-sp2(z3*z1,z1-z2),sp2(z3*z1,z2+z3))),sp1(z3-z2)+sp2(sp3(sp2(z1*z3,z2*z1),z3,sp2(z3-z1,z2-z1)),sp3(sp3(z1-z2,z2*z1,z2*z3),z1*sp2(z1-z2,z2-z3),z3*sp1(z1+z2))),sp3(sp1(z3+z1),sp2(z1-z2,z2*z3),sp1(z1+z2+z3)));
		 //  ps3(z1*ps2(ps1(z2-z1),ps2(z1-ps2(z3*z1,z1-z2),ps2(z3*z1,z2+z3))),ps1(z3-z2)+ps2(ps3(ps2(z1*z3,z2*z1),z3,ps2(z3-z1,z2-z1)),ps3(ps3(z1-z2,z2*z1,z2*z3),z1*ps2(z1-z2,z2-z3),z3*ps1(z1+z2))),ps3(ps1(z3+z1),ps2(z1-z2,z2*z3),ps1(z1+z2+z3)));
		 //  ms3(z1*ms2(ms1(z2-z1),ms2(z1-ms2(z3*z1,z1-z2),ms2(z3*z1,z2+z3))),ms1(z3-z2)+ms2(ms3(ms2(z1*z3,z2*z1),z3,ms2(z3-z1,z2-z1)),ms3(ms3(z1-z2,z2*z1,z2*z3),z1*ms2(z1-z2,z2-z3),z3*ms1(z1+z2))),ms3(ms1(z3+z1),ms2(z1-z2,z2*z3),ms1(z1+z2+z3)));
		 //  pc3(z1*pc2(pc1(z2-z1),pc2(z1-pc2(z3*z1,z1-z2),pc2(z3*z1,z2+z3))),pc1(z3-z2)+pc2(pc3(pc2(z1*z3,z2*z1),z3,pc2(z3-z1,z2-z1)),pc3(pc3(z1-z2,z2*z1,z2*z3),z1*pc2(z1-z2,z2-z3),z3*pc1(z1+z2))),pc3(pc1(z3+z1),pc2(z1-z2,z2*z3),pc1(z1+z2+z3)));

    // rez = spall(ve,n,z1,vd,n,x,z2,y,vi,k);

	 //rez = spall(ve,n+3,spall(ve,n+1,z1/z2,vd,j+k-1,x,z2/spall(ve,j+3,z3-spall(ve,n+9,z1-z3+z1,vd,k*j,x*t,z2*z3,y-t,vi,j+9),vd,k+7,x,z1-z2/spall(ve,n+3+j,z3/z1,vd,j+k+7,x,z2/z3,-y/t,vi,k+j+5),y/t,vi,j),t-y,vi,n+j),vd,j+k,x,z2-spall(ve,k+3,z1/spall(ve,n+3+k,z3*t,vd,j+k+9,x,z1-z3,t-y*x,vi,n+k+j),vd,k+3,x/t,z2*spall(ve,j+k+7,z1*y,vd,j+3*k,x,z2*y,y-x/y,vi,n+7*k),t/y,vi,k+n+7),t-y/t,vi,n+k+j);
		  // pcall(ve,n+3,pcall(ve,n+1,z1/z2,vd,j+k-1,x,z2/pcall(ve,j+3,z3-pcall(ve,n+9,z1-z3+z1,vd,k*j,x*t,z2*z3,y-t,vi,j+9),vd,k+7,x,z1-z2/pcall(ve,n+3+j,z3/z1,vd,j+k+7,x,z2/z3,-y/t,vi,k+j+5),y/t,vi,j),t-y,vi,n+j),vd,j+k,x,z2-pcall(ve,k+3,z1/pcall(ve,n+3+k,z3*t,vd,j+k+9,x,z1-z3,t-y*x,vi,n+k+j),vd,k+3,x/t,z2*pcall(ve,j+k+7,z1*y,vd,j+3*k,x,z2*y,y-x/y,vi,n+7*k),t/y,vi,k+n+7),t-y/t,vi,n+k+j)
		  // msall(ve,n+3,msall(ve,n+1,z1/z2,vd,j+k-1,x,z2/msall(ve,j+3,z3-msall(ve,n+9,z1-z3+z1,vd,k*j,x*t,z2*z3,y-t,vi,j+9),vd,k+7,x,z1-z2/msall(ve,n+3+j,z3/z1,vd,j+k+7,x,z2/z3,-y/t,vi,k+j+5),y/t,vi,j),t-y,vi,n+j),vd,j+k,x,z2-msall(ve,k+3,z1/msall(ve,n+3+k,z3*t,vd,j+k+9,x,z1-z3,t-y*x,vi,n+k+j),vd,k+3,x/t,z2*msall(ve,j+k+7,z1*y,vd,j+3*k,x,z2*y,y-x/y,vi,n+7*k),t/y,vi,k+n+7),t-y/t,vi,n+k+j)
		  // psall(ve,n+3,psall(ve,n+1,z1/z2,vd,j+k-1,x,z2/psall(ve,j+3,z3-psall(ve,n+9,z1-z3+z1,vd,k*j,x*t,z2*z3,y-t,vi,j+9),vd,k+7,x,z1-z2/psall(ve,n+3+j,z3/z1,vd,j+k+7,x,z2/z3,-y/t,vi,k+j+5),y/t,vi,j),t-y,vi,n+j),vd,j+k,x,z2-psall(ve,k+3,z1/psall(ve,n+3+k,z3*t,vd,j+k+9,x,z1-z3,t-y*x,vi,n+k+j),vd,k+3,x/t,z2*psall(ve,j+k+7,z1*y,vd,j+3*k,x,z2*y,y-x/y,vi,n+7*k),t/y,vi,k+n+7),t-y/t,vi,n+k+j)

   // rez = sp3(sp2(sp3(z1,z2,z3-sp2(sp2(z1,z3),sp2(t,z2))),sp2(z2-z3,x*z1)),sp3(sp2(z2,t),sp2(y,z3),sp3(x,y,t)*sp3(z3,z1,z2)),sp3(z1-sp1(z2),z2-sp2(x*y,-z2),z3-sp2(z2-z1,x*y)));
		 // ps3(ps2(ps3(z1,z2,z3-ps2(ps2(z1,z3),ps2(t,z2))),ps2(z2-z3,x*z1)),ps3(ps2(z2,t),ps2(y,z3),ps3(x,y,t)*ps3(z3,z1,z2)),ps3(z1-ps1(z2),z2-ps2(x*y,-z2),z3-ps2(z2-z1,x*y)))
		 // ms3(ms2(ms3(z1,z2,z3-ms2(ms2(z1,z3),ms2(t,z2))),ms2(z2-z3,x*z1)),ms3(ms2(z2,t),ms2(y,z3),ms3(x,y,t)*ms3(z3,z1,z2)),ms3(z1-ms1(z2),z2-ms2(x*y,-z2),z3-ms2(z2-z1,x*y)))
		 // pc3(pc2(pc3(z1,z2,z3-pc2(pc2(z1,z3),pc2(t,z2))),pc2(z2-z3,x*z1)),pc3(pc2(z2,t),pc2(y,z3),pc3(x,y,t)*pc3(z3,z1,z2)),pc3(z1-pc1(z2),z2-pc2(x*y,-z2),z3-pc2(z2-z1,x*y)))


	// rez = (z1/z2*z3/(z1.re-z2.im*(x-i))*(-z1/(-z2-i/(-x+y*i)))/(y/(z1/x-y/z2)+z2.re/(i-z1.im)))*(-i-3.5-i*x*(-z1-z2.im*(-z1.im*i-t/(-i)*(2.5/z1*i/t-i/(-i+x/z2)))));
	// rez = (z1.re*t-i*x*(z2.im-z1.re/(i-1.5)-i/(-i-3.5/z2-z1*(x*z3.re-t/z2)*(z2.re/z1.im-z3.re/i)+(i*2.5+1.7*z3)*(i*z1+z3/i-z3.re*z1.im*(x-z1-i))+10.5*(i*2.5+5.7))));


		//rez=z1*z2-(-y/x-i-3.6-z1+z2)*7.3;
	   //rez=z1/x;
	  // rez=2*z1*z2-i*x;
	// rez=  z1*z2-z3*(z1-z2-z1*(z2+z3-z1));
		  //rez=x+y+i0;
		  //rez=z1+z2;
	   //rez=-(-(-(-(-(-z1-(-z2-(x-(-2.5-z1-(-(-(-x-z1-(-3.2-i)-i-(-i-4.5))))-i*(-z1-3.7*i-y/i))))-9.5-(-3.5-z2/i)))-i-(-z1/(-i)-(-z2/(-x))))));
	   //rez=sp1(z1*sp2(z2,z1/sp1(z2/x-y/z2)))/sp3(z1-x,sp2(-sp2(-x/i,i/y),-7.5-i/sp3(-z1,-z2/z1,z2*i)),sp1(x*z1-i)/x);
		//rez=Re(z1*sp1(z1)*sp3(z1,z2,z3*sp2(x,z2)-sp2(z3,y)))+i;
		 // rez=sp2(z1,z2)*sp2(x,y);
      //rez=-z1-z2.im*(i*z2.re-z1.im/(z1-i*z2.re*z1.im)-z1/(-1.5-2.7*i-i*(-2.5-x*i)/(x-z1.re-(z2.im*y-i)/i)));
	   //rez=(1.5*i-2.7)*(-3.2-i*(2.7-x-(-z2-i-(-z1.re-3.5-(-x/(z1-z2*i)-i/(x-z2.im-2.3*i)))))/(-i/x*z1-z2*y/i));
	  //rez=(x*z1-z2*y)*(-i-2.1-z1*(x+y*z2.im)+(-z1.re*x-3.2)*z2-z1*(-i-z1*x)-(y-z2*i)*z2*(z1-z2*y*i))/(-z1/(x*y-3.5/(x+y))+(x-y*z2.re*z1.im)/z2);

	  //   rez = sp3(z1,sp2(z1+z3,x-z2)-sp2(sp2(z1+z2,t+y)-z2,sp3(z1,z3,-z2)*sp2(x+y,z1-z2)),z3-z1*sp2(z3*x,-y*z1))*sp2(-sp2(x*t,-y*x),sp1(z2+z3)*sp1(x-t))-sp3(x,y,y-t*x)*sp2(z1-z2*sp2(z2,t+z3),sp1(z3)*x-z2)*sp2(-sp2(z3+y,x+z2),z2);
		//rez=(z1.re-i*(-2.2-z2.im*(-y-3.1*i-i/(x/i-i/z2))-z1*z2*i*x/(-x-2.5*i-z2.im*i)))*(z1*(-i-(y/z1-z2/x*i)/(1.7-i-z2))-z2/(x-i/y))/(-i*(-x/(-z2.im-3.1))+z2*i-4.5/i);
	   //rez=sp3(z1,z2,z3*sp3(z1-x,y-z3,z2-z1*z2))*sp2(sp1(sp2(sp1(z2),sp1(z1))),sp2(z3,z2));
	   //rez=sp3(sp2(z2,sp3(z1,z3,z2)),sp3(z2,sp3(sp3(z3,z2,sp3(z2,z1,z3)),z1,z2),z3),sp1(sp3(z1,sp3(z3,sp3(z2,z3,z1),z1),z3)));
	   //rez=spall(ve,n+3,spall(ve,n+1,z1/z2,vd,j+k-1,x,z2/spall(ve,j+3,z3-spall(ve,n+9,z1-z3+z1,vd,k*j,x*t,z2*z3,y-t,vi,j+9),vd,k+7,x,z1-z2/spall(ve,n+3+j,z3/z1,vd,j+k+7,x,z2/z3,-y/t,vi,k+j+5),y/t,vi,j),t-y,vi,n+j),vd,j+k,x,z2-spall(ve,k+3,z1/spall(ve,n+3+k,z3*t,vd,j+k+9,x,z1-z3,t-y*x,vi,n+k+j),vd,k+3,x/t,z2*spall(ve,j+k+7,z1*y,vd,j+3*k,x,z2*y,y-x/y,vi,n+7*k),t/y,vi,k+n+7),t-y/t,vi,n+k+j);
	   //rez=spall(ve,n,z1,vd,n,x,z2,y,vi,k);
	   //rez=z1*sp2(i,x/i-z2*sp3(-x*sp1(z1-i),-3.796-i,x*(-i-z2-5.875))/5.145+sp2(-i-z2,-t-i/z2)/z1)/sp3(z1*sp1(y*i),-sp2(-z1/x,y/(z1/z2-i))/sp3(x*(z1-z2/i),-z3/z1,x/(-z3)),sp2(2.841-t*i,-z2/(-z3-i/(-x-z1)))*sp3(z1*sp1(t/i),x/i-i/y,2.5*z1-7.5/z2)/sp2(z2/x-y*z3/z2,-4.784/i-i/3.752));

	   //rez=-(-(-z1-(-z2-(-(-x-(-2.5-(-x-z1-(-3.2-i)-i-z2)))))));
		  //rez=sp1(x)*sp3(x,y,t)+i0;

		//rez=z1*z2-z3*(z1-z2-z1*(z2+z3-z1));
		//rez=z1*z2-(-y/x-i-3.6-z1+z2)*7.3;
		//rez=Re(z1*z2)/Im(z1/z2) +i0;
		//rez=Re(z1)+Im(z2)+i0;
	   //rez=z1/x;
	   //rez=z1*z2+i*x;
	   //rez=-(-(-(-(-(-z1-(-z2-(x-(-2.5-z1-(-(-(-x-z1-(-3.2-i)-i-(-i-4.5))))-i*(-z1-3.7*i-y/i))))-9.5-(-3.5-z2/i)))-i-(-z1/(-i)-(-z2/(-x))))));
	   //rez=(z2*sp1(x+t)/sp2(x+y,z1-z2)-sp3(x-1.1,t*2.2,t-x)*sp2(x-t,z1-z2)/sp1(sp2(z1-x,y-z2)-sp2(z2*z1,t*x)));
	   //rez=sp1(z1*sp2(z2,z1/sp1(z2/x-y/z2)))/sp3(z1-x,sp2(-sp2(-x/i,i/y),-7.5-i/sp3(-z1,-z2/z1,z2*i)),sp1(x*z1-i)/x);
	   //rez=sp3(z1,z2,z3*sp3(z1-x,y-z3,z2-z1*z2))*sp2(sp1(sp2(sp1(z2),sp1(z1))),sp2(z3,z2));
	   //rez=sp3(sp2(z2,sp3(z1,z3,z2)),sp3(z2,sp3(sp3(z3,z2,sp3(z2,z1,z3)),z1,z2),z3),sp1(sp3(z1,sp3(z3,sp3(z2,z3,z1),z1),z3)));
	   //rez=spall(ve,n+3,spall(ve,n+1,z1/z2,vd,j+k-1,x,z2/spall(ve,j+3,z3-spall(ve,n+9,z1-z3+z1,vd,k*j,x*t,z2*z3,y-t,vi,j+9),vd,k+7,x,z1-z2/spall(ve,n+3+j,z3/z1,vd,j+k+7,x,z2/z3,-y/t,vi,k+j+5),y/t,vi,j),t-y,vi,n+j),vd,j+k,x,z2-spall(ve,k+3,z1/spall(ve,n+3+k,z3*t,vd,j+k+9,x,z1-z3,t-y*x,vi,n+k+j),vd,k+3,x/t,z2*spall(ve,j+k+7,z1*y,vd,j+3*k,x,z2*y,y-x/y,vi,n+7*k),t/y,vi,k+n+7),t-y/t,vi,n+k+j);
	   //rez=spall(ve,n,z1,vd,n,x,z2,y,vi,k);
	   //rez=z1*sp2(i,x/i-z2*sp3(-x*sp1(z1-i),-3.796-i,x*(-i-z2-5.875))/5.145+sp2(-i-z2,-t-i/z2)/z1)/sp3(z1*sp1(y*i),-sp2(-z1/x,y/(z1/z2-i))/sp3(x*(z1-z2/i),-z3/z1,x/(-z3)),sp2(2.841-t*i,-z2/(-z3-i/(-x-z1)))*sp3(z1*sp1(t/i),x/i-i/y,2.5*z1-7.5/z2)/sp2(z2/x-y*z3/z2,-4.784/i-i/3.752));
		// rez=x+y+i0;
	   //rez=-(-(-z1-(-z2-(-(-x-(-2.5-(-x-z1-(-3.2-i)-i-z2)))))));
	   //rez=-z1-z2.im*(i*z2.re-z1.im/(z1-i*z2.re*z1.im)-z1/(-1.5-2.7*i-i*(-2.5-x*i)/(x-z1.re-(z2.im*y-i)/i)));
	   //rez=(1.5*i-2.7)*(-3.2-i*(2.7-x-(-z2-i-(-z1.re-3.5-(-x/(z1-z2*i)-i/(x-z2.im-2.3*i)))))/(-i/x*z1-z2*y/i));
	   //rez=(z1.re-i*(-2.2-z2.im*(-y-3.1*i-i/(x/i-i/z2))-z1*z2*i*x/(-x-2.5*i-z2.im*i)))*(z1*(-i-(y/z1-z2/x*i)/(1.7-i-z2))-z2/(x-i/y))/(-i*(-x/(-z2.im-3.1))+z2*i-4.5/i);
		//rez=(x*z1-z2*y)*(-i-2.1-z1*(x+y*z2.im)+(-z1.re*x-3.2)*z2-z1*(-i-z1*x)-(y-z2*i)*z2*(z1-z2*y*i))/(-z1/(x*y-3.5/(x+y))+(x-y*z2.re*z1.im)/z2);
	  } ;
	  T2=GetTickCount();

	  S1r=FloatToStrF(rez.re,ffGeneral,20,4,G_FMT);
	  S2r=FloatToStrF(rez.im,ffGeneral,20,4,G_FMT);
	  LR->Caption=S1r+"  "+S2r+"i";
	  if ((T2-T1) != 0) {LPf->Caption=IntToStr((Int32)(NC/(T2-T1))); } else { LPf->Caption="no defined" ; };
	  goto endp;
   #endif
//--------------------------------------------------------------------------------------------------------------------------------------------------------







//pcall(ve,n+3,pcall(ve,n+1,z1/z2,vd,j+k-1,x,z2/pcall(ve,j+3,z3-pcall(ve,n+9,z1-z3+z1,vd,k*j,x*t,z2*z3,y-t,vi,j+9),vd,k+7,x,z1-z2/pcall(ve,n+3+j,z3/z1,vd,j+k+7,x,z2/z3,-y/t,vi,k+j+5),y/t,vi,j),t-y,vi,n+j),vd,j+k,x,z2-pcall(ve,k+3,z1/pcall(ve,n+3+k,z3*t,vd,j+k+9,x,z1-z3,t-y*x,vi,n+k+j),vd,k+3,x/t,z2*pcall(ve,j+k+7,z1*y,vd,j+3*k,x,z2*y,y-x/y,vi,n+7*k),t/y,vi,k+n+7),t-y/t,vi,n+k+j)
//spall(ve,n+3,spall(ve,n+1,z1/z2,vd,j+k-1,x,z2/spall(ve,j+3,z3-spall(ve,n+9,z1-z3+z1,vd,k*j,x*t,z2*z3,y-t,vi,j+9),vd,k+7,x,z1-z2/spall(ve,n+3+j,z3/z1,vd,j+k+7,x,z2/z3,-y/t,vi,k+j+5),y/t,vi,j),t-y,vi,n+j),vd,j+k,x,z2-spall(ve,k+3,z1/spall(ve,n+3+k,z3*t,vd,j+k+9,x,z1-z3,t-y*x,vi,n+k+j),vd,k+3,x/t,z2*spall(ve,j+k+7,z1*y,vd,j+3*k,x,z2*y,y-x/y,vi,n+7*k),t/y,vi,k+n+7),t-y/t,vi,n+k+j)
//msall(ve,n+3,msall(ve,n+1,z1/z2,vd,j+k-1,x,z2/msall(ve,j+3,z3-msall(ve,n+9,z1-z3+z1,vd,k*j,x*t,z2*z3,y-t,vi,j+9),vd,k+7,x,z1-z2/msall(ve,n+3+j,z3/z1,vd,j+k+7,x,z2/z3,-y/t,vi,k+j+5),y/t,vi,j),t-y,vi,n+j),vd,j+k,x,z2-msall(ve,k+3,z1/msall(ve,n+3+k,z3*t,vd,j+k+9,x,z1-z3,t-y*x,vi,n+k+j),vd,k+3,x/t,z2*msall(ve,j+k+7,z1*y,vd,j+3*k,x,z2*y,y-x/y,vi,n+7*k),t/y,vi,k+n+7),t-y/t,vi,n+k+j)

//sp3(z1,z2,z3)/sp2(x,sp2(z2,t))
//ms3(z1,z2,z3)/ms2(x,ms2(z2,t))
//pc3(z1,z2,z3)/pc2(x,pc2(z2,t))

//sp3(sp2(sp3(z1,z2,z3-sp2(sp2(z1,z3),sp2(t,z2))),sp2(z2-z3,x*z1)),sp3(sp2(z2,t),sp2(y,z3),sp3(x,y,t)*sp3(z3,z1,z2)),sp3(z1-sp1(z2),z2-sp2(x*y,-z2),z3-sp2(z2-z1,x*y)))
//ps3(ps2(ps3(z1,z2,z3-ps2(ps2(z1,z3),ps2(t,z2))),ps2(z2-z3,x*z1)),ps3(ps2(z2,t),ps2(y,z3),ps3(x,y,t)*ps3(z3,z1,z2)),ps3(z1-ps1(z2),z2-ps2(x*y,-z2),z3-ps2(z2-z1,x*y)))
//ms3(ms2(ms3(z1,z2,z3-ms2(ms2(z1,z3),ms2(t,z2))),ms2(z2-z3,x*z1)),ms3(ms2(z2,t),ms2(y,z3),ms3(x,y,t)*ms3(z3,z1,z2)),ms3(z1-ms1(z2),z2-ms2(x*y,-z2),z3-ms2(z2-z1,x*y)))
//pc3(pc2(pc3(z1,z2,z3-pc2(pc2(z1,z3),pc2(t,z2))),pc2(z2-z3,x*z1)),pc3(pc2(z2,t),pc2(y,z3),pc3(x,y,t)*pc3(z3,z1,z2)),pc3(z1-pc1(z2),z2-pc2(x*y,-z2),z3-pc2(z2-z1,x*y)))

   Func1 = NULL;

   ct=fz_COMPLEX;
   if (CB_CT->Checked)  {ct=fz_REAL;};
   fzSet(fz_CALC_TYPE, ct);

  #ifdef PANSICHAR
	ans=(AnsiString)(EF->Text);
	Expr = ans.c_str();
  #else
	Expr = EF->Text;
  #endif;

  fzCompile(Expr, Func1);

  if (CB_OM->Checked) { NC=1;} else {NC=abs(trunc(StrToFloat(ENC->Text,G_FMT)));};

  fzGetSyntaxErrorCode(ECode);


  if (ECode != 0)
  {
	  ShowError();
  }
  else
  {
   fzGet(fz_RESULT_TYPE,0,rt);

   if (rt == fz_NONE)            //no return number: return result in inner 'result' or 'res' variable  ( zt: complexDbl=z1+z2; zt=zt*x; result=zt  )
   {
	  T1=GetTickCount();

	  for(ni = 0; ni <= NC; ni++)
	  {
		//fzResult(Func1);
		 _asm
		 {
		  call Func1
		 };
	  };
	 T2=GetTickCount();

	 rezCx.re=resf.re;
	 rezCx.im=resf.im;
   }
   else
   {
	 if (ct == fz_REAL)                                    //return only real result: Re(expr)
	 {

	   T1=GetTickCount();
	   for(ni = 0; ni <= NC; ni++)
	   {
		 //fzResultE(Func1,rezCx.re);
		 _asm
		 {
		  call Func1
		  fstp tbyte ptr [rezCx]//rezCx.re
		 };
		};
		T2=GetTickCount();
	 }
	 else                                                    //full complex result
	 {
		//ct = fz_Complex; rt = fz_Real, fz_Complex
		T1=GetTickCount();

		for(ni = 0; ni <= NC; ni++)
		{

		 //fzResultCxEP(Func1,&rezCx);
		 //fzResultCxE(Func1,rezCx.re,rezCx.im);

		 _asm
		 {
		   call Func1
		   fstp tbyte ptr [rezCx]//rezCx.re
		   fstp tbyte ptr [rezCx+16]//rezCx.im
		  };

		}
		T2=GetTickCount();
     }

   }

  }


  S1r=FloatToStrF(rezCx.re,ffGeneral,20,4,G_FMT);
  S2r=FloatToStrF(rezCx.im,ffGeneral,20,4,G_FMT);
  fzGet(fz_RESULT_TYPE,0, rt);

  if (((ct == fz_COMPLEX) && (rt == fz_COMPLEX)) || (rt == fz_NONE))
   { LR->Caption=S1r+"  "+S2r+"i";}
   else
 { LR->Caption=S1r;};

  if ((T2-T1) != 0)
	   { LPf->Caption=IntToStr((Int32)(NC/(T2-T1))); }
	   else { LPf->Caption="no defined" ; };



  fzPerform(fz_FREE,(Int32)Func1);

endp:
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton1Click(TObject *Sender)
{
   fzSetVar("x",&xd,fz_REAL_DOUBLE);
   fzSetVar("y",&yd,fz_REAL_DOUBLE);
   fzSetVar("t",&td,fz_REAL_DOUBLE);

   fzSetVar("z1",&z1d,fz_COMPLEX_DOUBLE);
   fzSetVar("z2",&z2d,fz_COMPLEX_DOUBLE);
   fzSetVar("z3",&z3d,fz_COMPLEX_DOUBLE);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton2Click(TObject *Sender)
{
   fzSetVar("x",&xe,fz_REAL_EXTENDED);
   fzSetVar("y",&ye,fz_REAL_EXTENDED);
   fzSetVar("t",&te,fz_REAL_EXTENDED);

   fzSetVar("z1",&z1e,fz_COMPLEX_EXTENDED);
   fzSetVar("z2",&z2e,fz_COMPLEX_EXTENDED);
   fzSetVar("z3",&z3e,fz_COMPLEX_EXTENDED);
}
//---------------------------------------------------------------------------


void __fastcall TForm1::RadioButton3Click(TObject *Sender)
{
 fzSet(fz_STACK_TYPE,fz_DOUBLE);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioButton4Click(TObject *Sender)
{
 fzSet(fz_STACK_TYPE,fz_EXTENDED);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
 Int32       Error;
 TStringType Expr;
 AnsiString  ans;

   #ifdef PANSICHAR
	ans =(AnsiString)(E_EF->Text);
	Expr = ans.c_str();
  #else
	Expr = E_EF->Text;
  #endif;

  fzSetFunction(Expr,0);
  fzGetSyntaxErrorCode(Error);
  if (Error != 0) { ShowError();}
}
//---------------------------------------------------------------------------


