unit main;
interface
uses
 Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, math, OpenGL, ExtCtrls, ComCtrls ,

//{$FINITEFLOAT ON}

{$DEFINE USEDLL}


   {$IFDEF USEDLL}
     ForevalZdll;
   {$ELSE}
     ForevalZ_Lib;
   {$ENDIF}



{$IFDEF USEDLL}
   //   dll:        ForevalZdll (  )
   // with dll: to set the same key in ForevalZdll (type of passed strings)

   {.$DEFINE STRING}        //test in dll
   {$DEFINE ANSISTRING}    //test in dll
   {.$DEFINE WIDESTRING}    //test in dll
   {.$DEFINE PANSICHAR}     //test in dll
   {.$DEFINE UTF8}     //test in dll

{$ELSE}
   {$DEFINE STRINGINT}
{$ENDIF}


{$IFDEF STRINGINT}     type TStringType = String;       {$ENDIF}

{$IFDEF STRING}       type TStringType = String;       {$ENDIF}

{$IFDEF ANSISTRING}   type TStringType = AnsiString;   {$ENDIF}

{$IFDEF WIDESTRING}   type TStringType = WideString;    {$ENDIF}

{$IFDEF PANSICHAR}    type TStringType = PAnsiChar;    {$ENDIF}

{$IFDEF UTF8}         type TStringType = UTF8String;       {$ENDIF}

const
_Fractal: cardinal  = 1;
_ComplexDraw : cardinal = 2;
_ComplexDynDraw : cardinal = 3;



  type
   TComplexD =
   record
      re: double;
      im: double;
   end;
   type
   TComplexE =
   record
      re: extended;
      im: extended;
   end;
type
  TForm1 = class(TForm)
    ComboBox1: TComboBox;
    Label1: TLabel;
    ComboBox2: TComboBox;
    Label2: TLabel;
    Edit1: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    PFLD: TPanel;
    Image1: TImage;
    MFRC: TMemo;
    Button1: TButton;
    Label6: TLabel;
    Label7: TLabel;
    Button2: TButton;
    ES: TEdit;
    Label8: TLabel;
    ETF: TEdit;
    Label9: TLabel;
    Button3: TButton;
    OpenFile: TOpenDialog;
    BDraw: TButton;
    L_FPS: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    RadioGroup1: TRadioGroup;
    RB_ComplexGraph: TRadioButton;
    RB_Fractal: TRadioButton;
    RB_ComplexDynamic: TRadioButton;
    UpDown1: TUpDown;
    Label12: TLabel;


    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ComboBox2Change(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ShowError;
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure BDrawClick(Sender: TObject);
    //procedure BFractalClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure RB_FractalClick(Sender: TObject);
    procedure RB_ComplexGraphClick(Sender: TObject);
    procedure RB_ComplexDynamicClick(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);


    private

    public

    procedure ComplexToHSV(z: TComplexE; var h,s,v :extended);
    procedure HsvToRgb(h,s,v: extended; var cr,cg,cb: extended);
    procedure DrawDynComplex;
    procedure DrawComplex;
    procedure DrawFractal;
    procedure SetDCPixelFormat (hdc : HDC);
    procedure Scaling;

      var

       c_real, c_img,tgx, tgy, { x1, X2,Y1,Y2,} Xmax,Xmin, Ymax,Ymin, Sc: {Double;} extended;
       NSc: Integer;
       r4, g4, b4, l, n:integer;
       imagemouse: boolean;
       imageRect: TRect;
       tmr1, tmr2:cardinal;
       NIter, ISize, itr: Cardinal;

       zf,c0: TComplexD;
       FJ,FJ1: Pointer;
       fx,fy: double;

       Gr_Mode: cardinal;

       Ze,zt: TComplexE;
       Zd,FZd: TComplexD;
       FZe: TComplexE;


    end;
var
  Form1: TForm1;
implementation
//uses UQPixels;
var
btm, BitMap: tbitmap;
G_FMT: TFormatSettings;
HGD: HDC;
DC: HDC;
hrc: HGLRC;
hnd: THandle;
ZFunc: Pointer;


{$R *.DFM}


procedure TForm1.Scaling;
begin
NSc:=Trunc(StrToFloat(ES.Text,G_FMT));

if NSc = 0  then NSc:=1;

 if NSc < 0 then
   Sc:=abs(1/NSc)
 else
   Sc:=NSc;

ES.Text:=IntToStr(NSc);
end;



procedure InitFuncStructZ(var FS: TZAddFuncStruct);
begin
  FS.addr:=nil;
  FS.CallType:=fz_StdCall;
  FS.Arg:=0;
  FS.ArgType:=fz_Differ;
  FS.ArgTypeList:=nil;
  FS.CallFunc:=0;
  FS.ResultType:=0;
  FS.CalcConst:=fz_YES;
  FS.DeepFPU:=8;   //fz_UNKNOWN
  FS.SaveReg:=15;            //=15: save eax,ebx,ecx,edx (RECOMMEND.);  =255 save all reg; see .doc if there are any error
  FS.ReplFunc:=fz_YES;
  FS.Resrv2:=0;
  FS.Resrv3:=0;
end;




procedure TForm1.SetDCPixelFormat (hdc : HDC);
var
 pfd : TPixelFormatDescriptor;
 nPixelFormat : Integer;
begin
 FillChar (pfd, SizeOf (pfd), 0);
 pfd.dwFlags  := PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER;
 nPixelFormat := ChoosePixelFormat (hdc, @pfd);
 SetPixelFormat (hdc, nPixelFormat, @pfd);

end;




procedure {TForm1.}SetPixelRGB(Adr: Cardinal);
  stdcall;
var
cc: TColor;
k: Cardinal;
begin
   btm.canvas.Pixels[PInteger(Adr)^,PInteger(Adr+16)^]:=rgb(PCardinal(Adr+32)^, PCardinal(Adr+48)^, PCardinal(Adr+64)^);

    //Windows.SetPixel(HGD,PInteger(Adr)^,PInteger(Adr+16)^,rgb(PCardinal(Adr+32)^, PCardinal(Adr+48)^, PCardinal(Adr+64)^));
   //Form1.image1.Canvas.Pixels[PInteger(Adr)^,PInteger(Adr+16)^]:=rgb(PCardinal(Adr+32)^, PCardinal(Adr+48)^, PCardinal(Adr+64)^);
end;





procedure {TForm1.}SetPixel(Adr: Cardinal);
  stdcall;
var
cc: TColor;
k: Cardinal;
begin
   btm.canvas.Pixels[PInteger(Adr)^,PInteger(Adr+16)^]:=PCardinal(Adr+32)^;

    //Windows.SetPixel(HGD,PInteger(Adr)^,PInteger(Adr+16)^,rgb(PCardinal(Adr+32)^, PCardinal(Adr+48)^, PCardinal(Adr+64)^));
   //Form1.image1.Canvas.Pixels[PInteger(Adr)^,PInteger(Adr+16)^]:=rgb(PCardinal(Adr+32)^, PCardinal(Adr+48)^, PCardinal(Adr+64)^);
end;


procedure {TForm1.}BackGround(Adr: Cardinal);
  stdcall;
var
cc: TColor;
k: Cardinal;
begin
   //btm.canvas.Pixels[PInteger(Adr)^,PInteger(Adr+16)^]:=rgb(PCardinal(Adr+32)^, PCardinal(Adr+48)^, PCardinal(Adr+64)^);

    btm.Canvas.Brush.Color := RGB(PCardinal(Adr)^,PCardinal(Adr+16)^,PCardinal(Adr+32)^);
    btm.Canvas.Rectangle(0,0,  btm.Width, btm.Height);// 
    //Windows.SetPixel(HGD,PInteger(Adr)^,PInteger(Adr+16)^,rgb(PCardinal(Adr+32)^, PCardinal(Adr+48)^, PCardinal(Adr+64)^));
   //Form1.image1.Canvas.Pixels[PInteger(Adr)^,PInteger(Adr+16)^]:=rgb(PCardinal(Adr+32)^, PCardinal(Adr+48)^, PCardinal(Adr+64)^);
end;




procedure {TForm1.}ShowVar(Adr: Cardinal);  stdcall;
var

k: Cardinal;
x,y,r: double;
begin
x:=PDouble(Adr)^; y:=PDouble(adr+16)^;  k:=PInteger(adr+32)^;  r:=PDouble(adr+48)^;

//showMessage(FloatToStr(x)+'   '+floatToStr(y)+'i');
showMessage(FloatToStr(x)+'   '+FloatToStr(y)+'i'+'  k:'+IntToStr(k)+'  r:'+FloatToStr(r));
  {k:=PCardinal(Adr+32)^;
  if k < 290 then
  begin
    showMessage(IntToStr(k));
  end; }





end;



procedure {TForm1.}ShowVar1Ex(Adr: Cardinal);  stdcall;
var

k: Cardinal;
x: Extended;
begin
x:=PExtended(Adr)^;

//showMessage(FloatToStr(x)+'   '+floatToStr(y)+'i');
showMessage(FloatToStr(x));
  {k:=PCardinal(Adr+32)^;
  if k < 290 then
  begin
    showMessage(IntToStr(k));
  end; }





end;



{
procedure ShowImage(adr,len: Cardinal); stdcall;
begin
 Form1.image1.picture.Bitmap.Assign(btm);
end;
}

procedure ShowImage; stdcall;
begin
 Form1.image1.picture.Bitmap.Assign(btm);
end;



procedure SwapBuff; stdcall;
begin
 //Form1.PFLD.picture.Bitmap.Assign(btm);
 SwapBuffers(DC);
end;

//http://docwiki.embarcadero.com/RADStudio/XE7/en/Floating-Point_Number_Control_Routines
procedure MaskException;
var
Mem: Cardinal;
begin

asm
    {
    push ebp;
    fstcw [ebp];
    or word ptr [ebp], 003Fh;
    fldcw [ebp];
    //add esp, 4
    pop ebp
    }
   // push  eax
   // lea eax, M
    //push eax;
    //fclex
   // cli

    sub esp,4
    fnstcw [esp];
    or word ptr [esp], 003Fh;
    fnclex
    fldcw [esp];
    add esp, 4


   //fninit
end;

//SetExceptionMask([exInvalidOp]+[exUnderFlow]+[exDenormalized]+ [exZeroDivide] +[exOverflow]+ [exUnderflow] +[exPrecision]);
end;

procedure IfException;
var
Mem: Cardinal;
begin
asm

    push eax
    xor  eax,eax


    fnstsw ax
    sahf
    test ax, 001Fh
    fldz
    jz @@Z
    fstp st(0)
    fld1
    @@Z:
    pop eax
    fnclex
    //sti
   //finit
end;

end;



procedure TForm1.FormCreate(Sender: TObject);
var
FS:TZAddFuncStruct;
VT: TArrayC;
S1,S2: String;
begin
{$IFDEF STRING}       fzSet(fz_STRING_TYPE,fz_STRING);     {$ENDIF}
{$IFDEF ANSISTRING}   fzSet(fz_STRING_TYPE,fz_ANSISTRING);   {$ENDIF}
{$IFDEF WIDESTRING}   fzSet(fz_STRING_TYPE,fz_WIDESTRING);    {$ENDIF}
{$IFDEF PANSICHAR}    fzSet(fz_STRING_TYPE,fz_ANSISTRING);   {$ENDIF}
{$IFDEF UTF8}         fzSet(fz_String_Type,fz_String_UTF8);   {$ENDIF}

GetLocaleFormatSettings(0,G_FMT);
G_FMT.DecimalSeparator:='.';
NSc:=1;

fzSet(fz_Enable,fz_CHECK_INCORRECT_SPACE);
fzSet(fz_Disable,fz_CALC_CONST_EXPR_IN_MULTI_EXPR);


Set8087CW($1372);


ISize:=strtoint(combobox2.text);

//fzSet(fz_Enable,fz_Show_Exception);
//fzSetVar('zf',@zf,fz_Complex_Double);
//fzSetVar('c0',@c0,fz_Complex_Double);
//fzSetVar('x0',@fx,fz_Real_Double);
//fzSetVar('y0',@fy,fz_Real_Double);
fzSetVar('Iterations',@NIter,fz_Real_Integer);
fzSetVar('ImageSize',@ISize,fz_Real_Integer);
fzSetVar('itr',@itr,fz_Real_Integer);
fzSetVar('fz',@FZd,fz_Complex_Double);

fzSetVar('zt',@zt,fz_Complex_Extended);


fzSetVar('G_Xmin',@Xmin,fz_Real_Extended);
fzSetVar('G_Xmax',@Xmax,fz_Real_Extended);
fzSetVar('G_Ymin',@Ymin,fz_Real_Extended);
fzSetVar('G_Ymax',@Ymax,fz_Real_Extended);

fzSetVar('Xmin',@Xmin,fz_Real_Extended);
fzSetVar('Xmax',@Xmax,fz_Real_Extended);
fzSetVar('Ymin',@Ymin,fz_Real_Extended);
fzSetVar('Ymax',@Ymax,fz_Real_Extended);




{
fzSetVar('Xmin',@x1,fz_Real_Double);
fzSetVar('Xmax',@x2,fz_Real_Double);
fzSetVar('Ymin',@y1,fz_Real_Double);
fzSetVar('Ymax',@y2,fz_Real_Double);
}

InitFuncStructZ(FS);
FS.addr:=@SetPixelRGB;
FS.ArgType:=fz_Real_Integer;
FS.Arg:=5;
FS.CallFunc:=fz_ESP;
FS.CallType:=fz_stdcall;
FS.DeepFPU:=1;
FS.ResultType:=fz_None;
fzSetFunction('SetPixelRGB',@FS);


InitFuncStructZ(FS);
FS.addr:=@SetPixel;
FS.ArgType:=fz_Real_Integer;
FS.Arg:=3;
FS.CallFunc:=fz_ESP;
FS.CallType:=fz_stdcall;
FS.DeepFPU:=1;
FS.ResultType:=fz_None;
fzSetFunction('SetPixel',@FS);

InitFuncStructZ(FS);
FS.addr:=@ShowVar;
SetLength(VT,4);
VT[0]:=fz_real_Double; VT[1]:=fz_real_double; VT[2]:=fz_real_integer; VT[3]:=fz_real_double;
FS.ArgTypeList:=@VT[0];
FS.ArgType:=fz_Differ;
//FS.ArgType:=fz_Real_Double;
FS.Arg:=4;
FS.CallFunc:=fz_ESP;
FS.CallType:=fz_stdcall;
FS.DeepFPU:=1;
FS.ResultType:=fz_None;
fzSetFunction('ShowVar',@FS);

InitFuncStructZ(FS);
FS.addr:=@ShowVar1Ex;
FS.ArgType:=fz_Real_Extended;
FS.Arg:=1;
FS.CallFunc:=fz_ESP;
FS.CallType:=fz_stdcall;
FS.DeepFPU:=1;
FS.ResultType:=fz_None;
fzSetFunction('ShowVar1',@FS);

 {
InitFuncStructZ(FS);
FS.addr:=@ShowImage;
FS.ArgType:=fz_real_integer;
FS.CallFunc:=fz_INFINITE;
FS.CallType:=fz_stdcall;
FS.ResultType:=fz_none;
FS.DeepFPU:=2;
fzSetFunction('ShowImage',@FS);
}
InitFuncStructZ(FS);
FS.addr:=@ShowImage;
FS.Arg:=0;
FS.CallFunc:=fz_STACK_VAL;
FS.CallType:=fz_stdcall;
FS.ResultType:=fz_none;
FS.DeepFPU:=2;
fzSetFunction('ShowImage',@FS);

InitFuncStructZ(FS);
FS.addr:=@BackGround;
FS.ArgType:=fz_Real_Integer;
FS.Arg:=3;
FS.CallFunc:=fz_ESP;
FS.CallType:=fz_stdcall;
FS.DeepFPU:=1;
FS.ResultType:=fz_None;
fzSetFunction('BackGround',@FS);

InitFuncStructZ(FS);
FS.addr:=@SwapBuff;
FS.Arg:=0;
FS.CallFunc:=fz_STACK_VAL;
FS.CallType:=fz_stdcall;
FS.ResultType:=fz_none;
FS.DeepFPU:=0;
fzSetFunction('SwapBuffers',@FS);


InitFuncStructZ(FS);
FS.addr:=@MaskException;
FS.Arg:=0;
FS.CallFunc:=fz_STACK_VAL;
FS.CallType:=fz_stdcall;
FS.ResultType:=fz_none;
FS.DeepFPU:=0;
fzSetFunction('MaskException',@FS);

InitFuncStructZ(FS);
FS.addr:=@IfException;
FS.Arg:=0;
FS.CallFunc:=fz_STACK_VAL;
FS.CallType:=fz_stdcall;
FS.ResultType:=fz_real;
FS.DeepFPU:=1;
fzSetFunction('IfException',@FS);

InitFuncStructZ(FS);
FS.addr:=@glColor3d;
FS.ArgType:=fz_Real_Double;
FS.Arg:=3;
FS.CallFunc:=fz_STACK_VAL;
FS.CallType:=fz_stdcall;
FS.DeepFPU:=1;
FS.ResultType:=fz_None;
fzSetFunction('glColor3d',@FS);

InitFuncStructZ(FS);
FS.addr:=@glVertex2d;
FS.ArgType:=fz_Real_Double;
FS.Arg:=2;
FS.CallFunc:=fz_STACK_VAL;
FS.CallType:=fz_stdcall;
FS.DeepFPU:=1;
FS.ResultType:=fz_None;
fzSetFunction('glVertex2d',@FS);

InitFuncStructZ(FS);
FS.addr:=@glBegin;
FS.ArgType:=fz_Real_Integer;
FS.Arg:=1;
FS.CallFunc:=fz_STACK_VAL;
FS.CallType:=fz_stdcall;
FS.DeepFPU:=1;
FS.ResultType:=fz_None;
fzSetFunction('glBegin',@FS);

InitFuncStructZ(FS);
FS.addr:=@glEnd;
FS.Arg:=0;
FS.CallFunc:=fz_STACK_VAL;
FS.CallType:=fz_stdcall;
FS.DeepFPU:=1;
FS.ResultType:=fz_None;
fzSetFunction('glEnd',@FS);





  Xmin:=-1.5;
  Xmax:=1.5;
  Ymin:=-1.5;
  Ymax:=1.5;

 edit1.Text:=FloatToStrF(Xmin, ffGeneral, 20, 4, G_FMT);
 edit2.Text:=floattostrF(Xmax,ffGeneral, 20, 4, G_FMT);
 edit3.Text:=floattostrF(Ymin,ffGeneral, 20, 4, G_FMT);
 edit4.Text:=floattostrF(Ymax,ffGeneral, 20, 4, G_FMT);

PFLD.Width:=strtoint(combobox2.text);
PFLD.height:=strtoint(combobox2.text);

image1.Width:=strtoint(combobox2.text);
image1.height:=strtoint(combobox2.text);



btm:=Tbitmap.create;

HGD:=Form1.PFLD.Handle;


 hnd:=PFLD.Handle;
 DC := GetDC (hnd);
 SetDCPixelFormat(DC);
 hrc := wglCreateContext(DC);
 wglMakeCurrent(DC, hrc);
 glViewPort (0, 0, PFLD.ClientHeight, PFLD.ClientHeight);

 glDisable(GL_DEPTH_TEST);
 glDisable(GL_LIGHTING);
 glClearColor (0.75, 0.75, 0.75, 1.0);
 glClear (GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
 glPointSize(1);

RB_FractalClick(Self);

end;



procedure TForm1.FormDestroy(Sender: TObject);
begin
 btm.Destroy;
end;


procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
 var
resXxx, resYyy: extended;

begin
if Gr_Mode <> _ComplexDynDraw then
begin
ImageMouse := True;
ImageRect.Left := X;
ImageRect.Top  := Y;
ImageRect.Right := X;
ImageRect.Bottom  := Y;
Image1.Canvas.DrawFocusRect(ImageRect);

Ymin:=StrTofloat(Edit3.text,G_FMT);
Ymax:=StrTofloat(Edit4.text,G_FMT);
Xmin:=StrTofloat(Edit1.text,G_FMT);
Xmax:=StrTofloat(Edit2.text,G_FMT);


if (Xmin<0) and (Xmax>0) then tgx:=abs(Xmin)+abs(Xmax);
if (Xmin<0) and (Xmax<0) then tgx:=abs(Xmin)-abs(Xmax);
if (Xmin>0) and (Xmax>0) then tgx:=Xmax-Xmin;
if (Ymin<0) and (Ymax>0) then tgy:=abs(Ymin)+abs(Ymax);
if (Ymin<0) and (Ymax<0) then tgy:=abs(Ymin)-abs(Ymax);
if (Ymin>0) and (Ymax>0) then tgy:=Ymax-Ymin;


resXxx:=Xmin+(tgx / image1.width)*X;
resYyy:=Ymin+(tgy / image1.height)*Y;
edit1.Text:=FloatToStr(resxxx,G_FMT);
//edit4.Text:=FloatToStr(resYYY,G_FMT);
edit3.Text:=FloatToStr(resYYY,G_FMT);
end;
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);

begin
if Gr_Mode <> _ComplexDynDraw then
begin
if ImageMouse then
If (X > ImageRect.Left) AND (Y > ImageRect.Top) then  begin
{ }
Image1.Canvas.DrawFocusRect(ImageRect);
{ }
ImageRect.Right := X;
ImageRect.Bottom := Y;
{  }
Image1.Canvas.DrawFocusRect(ImageRect);
end;
end;

end;

procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
    var
    resX, resY: extended;

begin

if Gr_Mode <> _ComplexDynDraw then
begin
if ImageMouse then begin
ImageRect.Right := X;
ImageRect.Bottom := Y;
Image1.Canvas.DrawFocusRect(ImageRect);
ImageMouse := False;
Image1.Canvas.CopyRect(Image1.Canvas.ClipRect, Image1.Canvas,ImageRect);


   Ymax:=StrTofloat(Edit4.text,G_FMT);
   Xmax:=StrTofloat(Edit2.text,G_FMT);

if (Xmin<0) and (Xmax>0) then tgx:=abs(Xmin)+abs(Xmax);
if (Xmin<0) and (Xmax<0) then tgx:=abs(Xmin)-abs(Xmax);
if (Xmin>0) and (Xmax>0) then tgx:=Xmax-Xmin;
if (Ymin<0) and (Ymax>0) then tgy:=abs(Ymin)+abs(Ymax);
if (Ymin<0) and (Ymax<0) then tgy:=abs(Ymin)-abs(Ymax);
if (Ymin>0) and (Ymax>0) then tgy:=Ymax-Ymin;
if (Ymin>0) and (Ymax>0) then tgy:=Ymax-Ymin;

resX:=Xmin+(tgx / image1.width)*X;
resY:=Ymin+(tgy / image1.height)*Y;

edit2.Text:=FloatToStr(resx,G_FMT);
edit4.Text:=FloatToStr(resY,G_FMT);
end;

end;
end;



procedure TForm1.RB_ComplexGraphClick(Sender: TObject);
begin
 Gr_Mode := _ComplexDraw;
 ETF.Text:='fz=(z^2-1)*(z-2-i)^2/(z^2+2+2i)';
 fzSet(fz_Stack_Type,fz_Extended);
 fzSetVar('z',@Ze,fz_Complex_Extended);
 fzSetVar('fz',@FZe,fz_Complex_Extended);

 ES.Text:='3';
 NSc:=3; Sc:=3;

 {
 ComboBox1.Text:='300';
 ComboBox2.Text:='500';
 ES.Text:='3';
 }
 //BFractal.Enabled:=False;
 //BDraw.Enabled:=True;
end;

procedure TForm1.RB_ComplexDynamicClick(Sender: TObject);
begin
 Gr_Mode := _ComplexDynDraw;
 ETF.Text:='fz=z^3+2*sin(0.1*itr)';
 fzSet(fz_Stack_Type,fz_Double);
 fzSetVar('z',@Zd,fz_Complex_Double);
 fzSetVar('fz',@FZd,fz_Complex_Double);

 ES.Text:='2';
 NSc:=2; Sc:=2;
 {
 ComboBox1.Text:='200';
 ComboBox2.Text:='500';
 ES.Text:='2';
 }
 //BFractal.Enabled:=False;
 //BDraw.Enabled:=True;
end;

procedure TForm1.RB_FractalClick(Sender: TObject);
begin
 Gr_Mode := _Fractal;
 ETF.Text:='z=z^2-0.55-0.5i';
 fzSet(fz_Stack_Type,fz_Extended);
 fzSetVar('z',@Ze,fz_Complex_Extended);
 fzSetVar('fz',@FZe,fz_Complex_Extended);

 ES.Text:='1';
 NSc:=1; Sc:=1;
 {
 ComboBox1.Text:='300';
 ComboBox2.Text:='500';
 ES.Text:='1';
 }
 //BDraw.Enabled:=False;
 //BFractal.Enabled:=True;

end;

procedure DeleteSpace(S: String; var S1: String);
var i: Integer;
begin
{i:=Length(S);

 while i >= 1 do
 begin
    if S[i] = ' ' then
   begin
    Delete(S,i,1);
   end;
  dec(i);
 end;

S1:=Copy(S,1,Length(S));
}
S1:=StringReplace(S,' ','',[rfReplaceAll, rfIgnoreCase]);
S1:=StringReplace(S1,#9,'',[rfReplaceAll, rfIgnoreCase]);
end;



procedure TForm1.BDrawClick(Sender: TObject);
var
S: TStringType;
S1,S2,Sl: String;
i,nl: integer;
ans: AnsiString;
WS: WideString;
PAC: PAnsiChar;
Error,rt,Prt: Cardinal;
zres: TComplexE;
FZ1: Pointer;
t1,t2: cardinal;
begin


ISize:=strtoint(combobox2.text);
NIter:=strtoint(combobox1.text);

image1.Width:=ISize;
image1.height:=ISize;

PFLD.Width:=ISize;
PFLD.height:=ISize;

btm.Height:=ISize;
btm.Width:=ISize;


//Sc:= StrTofloat(ES.text,G_FMT);
Scaling;
Ymin:=StrTofloat(Edit3.text,G_FMT)*Sc;
Ymax:=StrTofloat(Edit4.text,G_FMT)*Sc;
Xmin:=StrTofloat(Edit1.text,G_FMT)*Sc;
Xmax:=StrTofloat(Edit2.text,G_FMT)*Sc;



btm.Canvas.Brush.Color := RGB(255,255,255);
btm.Canvas.Rectangle(0,0,  btm.Width, btm.Height);



 S:=ETF.Text;



fzSet(fz_Calc_Type, fz_Complex);

    {$IFDEF PANSICHAR}
       ans:=AnsiString(S); pac:=PAnsiChar(ans);   fzCompile(pac,ZFunc);
    {$ELSE}
       fzCompile(S,ZFunc);
    {$ENDIF}
fzGetSyntaxErrorCode(Error);

if Error = 0 then
begin


   if Gr_Mode = _Fractal then
   begin
     t1:=gettickcount;
       DrawFractal ;
     t2:=gettickcount;
   end
   else
    if Gr_Mode = _ComplexDraw then
   begin
      t1:=gettickcount;
        DrawComplex;
      t2:=gettickcount;
   end
   else
   if Gr_Mode = _ComplexDynDraw then
   begin
      t1:=gettickcount;
        DrawDynComplex;
      t2:=gettickcount;
   end;





     Label7.Caption:=InttoStr(t2-t1);
     if Gr_Mode = _ComplexDynDraw then  L_FPS.Caption:=InttoStr(Trunc(NIter*1000/(t2-t1))) else  L_FPS.Caption:='';

//ShowError;

end
else
ShowError;

fzPerform(fz_FREE,Cardinal(ZFunc));


end;


 (*
procedure TForm1.BFractalClick(Sender: TObject);
var
S: TStringType;
S1,S2,Sl: String;
i,nl: integer;
ans: AnsiString;
WS: WideString;
PAC: PAnsiChar;
Error,rt,Prt: Cardinal;
zres: TComplexE;
FZ1: Pointer;
t1,t2: cardinal;
begin

Sc:= StrTofloat(ES.text,G_FMT);
btm.Height:=Image1.Height;
btm.Width:=Image1.Width;



NIter:=strtoint(combobox1.text);
ISize:=strtoint(combobox2.text);
Ymin:=StrTofloat(Edit3.text,G_FMT)*Sc;
Ymax:=StrTofloat(Edit4.text,G_FMT)*Sc;
Xmin:=StrTofloat(Edit1.text,G_FMT)*Sc;
Xmax:=StrTofloat(Edit2.text,G_FMT)*Sc;

 S:=ETF.Text;



fzSet(fz_Calc_Type, fz_Complex);

    {$IFDEF PANSICHAR}
       ans:=AnsiString(S); pac:=PAnsiChar(ans);   fzCompile(pac,ZFunc);
    {$ELSE}
       fzCompile(S,ZFunc);
    {$ENDIF}
fzGetSyntaxErrorCode(Error);

if Error = 0 then
begin


    //btm.canvas.FillRect(clientrect);

     t1:=gettickcount;
      DrawFractal;
     t2:=gettickcount;


     Label7.Caption:=InttoStr(t2-t1);
     L_FPS.Caption:='';

//ShowError;

end
else
ShowError;

fzPerform(fz_FREE,Cardinal(ZFunc));


end;

*)


procedure TForm1.Button1Click(Sender: TObject);
var
S: TStringType;
S1,S2,Sl: String;
i,nl: integer;
ans: AnsiString;
WS: WideString;
PAC: PAnsiChar;
Error,rt,Prt: Cardinal;
zres: TComplexE;
FZ1: Pointer;
t1,t2: cardinal;
begin

//Sc:= StrTofloat(ES.text,G_FMT);
Scaling;
btm.Height:=image1.Height;
btm.Width:=image1.Width;




NIter:=strtoint(combobox1.text);
ISize:=strtoint(combobox2.text);
Ymin:=StrTofloat(Edit3.text,G_FMT)*Sc;
Ymax:=StrTofloat(Edit4.text,G_FMT)*Sc;
Xmin:=StrTofloat(Edit1.text,G_FMT)*Sc;
Xmax:=StrTofloat(Edit2.text,G_FMT)*Sc;


S:='';
for i := 0 to  MFRC.Lines.Capacity-1 do
begin
 Sl:=MFRC.Lines[i];
 DeleteSpace(Sl,Sl);
 if Sl <> '' then
 begin

  Prt:=Pos('//',Sl);
  if Prt <> 0 then    Delete(Sl,Prt,Length(Sl)-Prt+1) ;


  S:=S+Sl;
 end;
end;



fzSet(fz_Calc_Type, fz_Real);

    {$IFDEF PANSICHAR}
       ans:=AnsiString(S); pac:=PAnsiChar(ans);   fzCompile(pac,FJ1);
    {$ELSE}
       fzCompile(S,FJ1);
    {$ENDIF}
fzGetSyntaxErrorCode(Error);

 Set8087CW($1372);

if Error = 0 then
begin


    btm.canvas.FillRect(clientrect);

     t1:=gettickcount;
      fzResult(FJ1);
     t2:=gettickcount;


     Label7.Caption:=InttoStr(t2-t1);
     //L_FPS.Caption:=InttoStr(Trunc(NIter*1000/(t2-t1)));
     if Gr_Mode = _ComplexDynDraw then  L_FPS.Caption:=InttoStr(Trunc(NIter*1000/(t2-t1))) else  L_FPS.Caption:='';

//ShowError;

end
else
ShowError;

fzPerform(fz_FREE,Cardinal(FJ1));
end;





procedure TForm1.Button2Click(Sender: TObject);
begin
  Edit1.text:='-1.5';
  Edit2.text:='1.5';
  Edit3.text:='-1.5';
  Edit4.text:='1.5';

  ES.Text:='1';
  NSc:=1; Sc:=1;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
S,S1,SL: String;
begin
 OpenFile.InitialDir := GetCurrentDir;
 if OpenFile.Execute then
 begin
    MFRC.Lines.LoadFromFile(OpenFile.FileName) ;
    S:=OpenFile.FileName;
    S1:=AnsiStrRScan(PChar(S),'\');
    Delete(S1,1,1);
    SL:=LowerCase(S1);
    if (SL = 'fractal_fern.txt') or (SL = 'fractal_julia.txt') then
      //RB_Fractal.OnClick(self)
      RB_Fractal.Checked:=True
    else
    if SL = 'complex_graph.txt' then
     //RB_ComplexGraph.OnClick(self)
     RB_ComplexGraph.Checked:=True
    else
    if SL = 'complex_dynamic.txt' then
     //RB_ComplexDynamic.OnClick(self);
     RB_ComplexDynamic.Checked:=True;
 end;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
 NIter:=strtoint(combobox1.text);
end;

procedure TForm1.ComboBox2Change(Sender: TObject);
begin
ISize:=strtoint(combobox2.text);

Image1.Picture := NIL;
image1.Width:=strtoint(combobox2.text);
image1.height:=strtoint(combobox2.text);

PFLD.Width:=strtoint(combobox2.text);
PFLD.height:=strtoint(combobox2.text);

btm.Height:=ISize;
btm.Width:=ISize;

glViewPort (0, 0, PFLD.ClientHeight, PFLD.ClientHeight);
end;





procedure TForm1.DrawDynComplex;
const PI2:  double = 3.1415926535897932384626433832795*2;
const Exp1: double = 2.7182818284590452353602874713527;
const PI2i:  double = 1/(3.1415926535897932384626433832795*2);
var
 ix,iy,citr,zi: integer;
 re,im,h,s,v,f,cr,cg,cb,re_min,re_max,im_min,im_max: double;
 //fz: ForevalZdll.TComplexD;
 r,g,b: double;
 t1,t2: Cardinal;
 //fx,fy: GLFloat;
 iw1,ih1,fx,fy: double;

 t,m,r0,r1,p,q,p1,q1: double;
begin
re_min:=Xmin;
re_max:=Xmax;
im_min:=Ymin;
im_max:=Ymax;

 //t1:=gettickcount;


 iw1:=1/PFLD.Width;     ih1:=1/PFLD.Height;

     for citr := 0 to   NIter do
     begin
            Set8087CW($1332);
            itr:=citr;

            for ix := 0 to   PFLD.Width - 1 do
            begin
                //re := re_min + ix * (re_max - re_min) / PFLD.Width;
                 re := re_min + ix * (re_max - re_min) *iw1;

                //fx:=2*(ix/PFLD.Width-0.5);
                 fx:=2*(ix*iw1-0.5);


                for iy := 0 to  PFLD.Height -1   do
                begin

                   try


                         //im := im_min + iy * (im_max - im_min) / PFLD.Height;
                          im := im_min + iy * (im_max - im_min) * ih1;
                          Zd.re:=re; Zd.im:=im;
                           //fzResultCxDP(Zfunc,@fz);
                           //fzResult(ZFunc);
                           asm
                             call ZFunc
                             //fstp qword ptr [fz].re
                             //fstp qword ptr [fz].im
                           end;
                          // fz:=zCalcFunctionZD(ZFunc);

                       {
                        ComplexToHsv(fz,h,s,v);
                        HsvToRgb(h,s,v,cr,cg,cb);
                       }

                     // ComplexToHsv:
                       t:= arctan2(FZd.im,FZd.re);
                       while (t < 0.0) do t := t+PI2;
                       while (t >= PI2) do  t := t-PI2;
                       h:= t * PI2i;
                       m:= sqrt(sqr(FZd.re)+sqr(FZd.im));
                       r0:= 0.0;
                       r1:= 1.0;
                       while (m > r1)  do
                       begin
                          r0 := r1;
                          r1 := r1 * Exp1;
                       end;
                       r:= (m - r0) / (r1 - r0);
                       if (r < 0.5) then p:=2*r else p:=2*(1-r);
                       q:= 1.0 - p;
                       p1:= 1 - q * q * q;
                       q1:= 1 - p * p * p;
                       s:= 0.4 + 0.6 * p1;
                       v:= 0.6 + 0.4 * q1;

                       //HsvToRgb:
                       if (s = 0) then
                       begin
                         r := v;
                         g := v;
                         b := v;
                       end
                       else
                       begin
                         if (h = 1.0) then h := 0.0;
                         zi := Trunc(6 * h);
                         f := h * 6 - zi;
                         p := v * (1 - s);
                         q := v * (1 - s * f);
                         t := v * (1 - s * (1 - f));

                         case zi of
                          0: begin r := v; g := t; b := p;  end;
                          1: begin r := q; g := v; b := p;  end;
                          2: begin r := p; g := v; b := t;  end;
                          3: begin r := p; g := q; b := v;  end;
                          4: begin r := t; g := p; b := v;  end;
                          5: begin r := v; g := p; b := q;  end;
                         end;
                      end;
                    //  cr:=r; cg:=g; cb:=b;
                       glColor3d (r, g, b);



                        //glColor3d (cr, cg, cb);
                        fy:=2*(iy*ih1-0.5);
                         glBegin(GL_POINTS);
                          glVertex2d(fx,fy);
                         glEnd;



                   except

                   end;
                end;
            end;
            SwapBuffers(DC);
     end;

end;





procedure TForm1.ComplexToHSV(z: TComplexE; var h,s,v :extended);
const PI2:extended = 3.1415926535897932384626433832795*2;
const Exp1:extended = 2.7182818284590452353602874713527;
var
 t,m,r0,r1,r,p,q,p1,q1: extended;
 begin
            // extract a phase 0 <= t < 2 pi
            t:= arctan2(z.im,z.re);
            while (t < 0.0) do t := t+PI2;
            while (t >= PI2) do  t := t-PI2;

            // the hue is determined by the phase
            h:= t / PI2;

            // extract a magnitude m >= 0
            m:= sqrt(sqr(z.re)+sqr(z.im));

            // map the magnitude logrithmicly into the repeating interval 0 < r < 1
            // this is essentially where we are between countour lines
            r0:= 0.0;
            r1:= 1.0;
            while (m > r1)  do
            begin
                r0 := r1;
                r1 := r1 * Exp1;
            end;


            r:= (m - r0) / (r1 - r0);
            // this puts contour lines at 0, 1, e, e^2, e^3, ...

            // determine saturation and value based on r
            // p and q are complementary distances from a countour line
            //p:= r < 0.5 ? 2.0 * r : 2.0 * (1.0 - r);
            if (r < 0.5) then p:=2*r else p:=2*(1-r);
            q:= 1.0 - p;
            // only let p and q go to zero very close to zero; otherwise they should stay nearly 1
            // this keep the countour lines from getting thick
            p1:= 1 - q * q * q;
            q1:= 1 - p * p * p;
            // fix s and v from p1 and q1
            s:= 0.4 + 0.6 * p1;
            v:= 0.6 + 0.4 * q1;

           // return (new ColorTriplet() {X = h, Y = s, Z = v} );
 end;


procedure TForm1.HsvToRgb(h,s,v: extended; var cr,cg,cb: extended);
var
f,p,q,t,r,g,b: extended;
zi: integer;
begin

            if (s = 0) then
            begin
                r := v;
                g := v;
                b := v;
            end
            else
             begin
                if (h = 1.0) then h := 0.0;
                zi := Trunc(6 * h);
                f := h * 6 - zi;
                p := v * (1 - s);
                q := v * (1 - s * f);
                t := v * (1 - s * (1 - f));

                case zi of
                    0: begin r := v; g := t; b := p;  end;
                    1: begin r := q; g := v; b := p;  end;
                    2: begin r := p; g := v; b := t;  end;
                    3: begin r := p; g := q; b := v;  end;
                    4: begin r := t; g := p; b := v;  end;
                    5: begin r := v; g := p; b := q;  end;

                end;

             end;

          // cr:=Trunc(r);   cg:=Trunc(g);  cb:=Trunc(b);
          cr:=r; cg:=g; cb:=b;
            //return (new ColorTriplet() { X = r, Y = g, Z = b });



        {
           c = (int)(256*r); if(c>255) c = 255; RGBcolor[0] = c;
           c = (int)(256*g); if(c>255) c = 255; RGBcolor[1] = c;
           c = (int)(256*b); if(c>255) c = 255; RGBcolor[2] = c;
         }


end;



procedure TForm1.DrawComplex;
var
 ix,iy: integer;
 re,im,h,s,v,cr,cg,cb,re_min,re_max,im_min,im_max: extended;
 fzt: TComplexE;
 r,g,b: Cardinal;
 t1,t2: Cardinal;
begin
Set8087CW($1332);

re_min:=Xmin;
re_max:=Xmax;
im_min:=Ymin;
im_max:=Ymax;

 

            for ix := 0 to   image1.Width - 1 do
            begin
                re := re_min + ix * (re_max - re_min) / image1.Width;
                for iy := 0 to  image1.Height -1   do
                begin
                      try

                           im := im_min + iy * (im_max - im_min) / image1.Height;
                           Ze.re:=re; Ze.im:=im;
                           fzResult(Zfunc);

                            ComplexToHsv(FZe,h,s,v);
                            HsvToRgb(h,s,v,cr,cg,cb);
                            r := Trunc(255.0 * cr);
                            g := Trunc(255.0 * cg);
                            b := Trunc(255.0 * cb);
                            btm.canvas.Pixels[ix,iy]:=rgb(r, g, b);
                           {
                           if (IsNaN(FZe.re) = true) or (IsNaN(FZe.im)= true) or
                              (IsInfinite(FZe.re)= true) or (IsInfinite(FZe.im)= true)
                           then
                           begin

                           end
                           else
                           begin
                            ComplexToHsv(FZe,h,s,v);
                            HsvToRgb(h,s,v,cr,cg,cb);
                            r := Trunc(255.0 * cr);
                            g := Trunc(255.0 * cg);
                            b := Trunc(255.0 * cb);
                            btm.canvas.Pixels[ix,iy]:=rgb(r, g, b);
                           end;
                           }

                       except

                       end;
                end;
            end;

Form1.image1.picture.Bitmap.Assign(btm);
end;




procedure TForm1.DrawFractal;
var
 ix,iy,k: integer;
 re,im,x,y,hx,hy,r: extended;
 //fz: TComplexEx;
 cr,cg,cb,cl: Cardinal;

begin

Set8087CW($1332);

hx:=(Xmax-Xmin)/Image1.Width;
hy:=(Ymax-Ymin)/Image1.Height;
im:=Ymin;




 for iy :=  0 to Image1.Height-1 do
 begin
     re:= Xmin;

     for ix := 0 to Image1.Width-1 do
      begin
         r:=1;   k:=NIter;
         Ze.re:=re; Ze.im:=im;

         while (k > 0) and (r < 4) do
         begin

                try
                 //fzResult(ZFunc);
                   asm
                     call ZFunc
                   end;
                except
                end;
                r:=sqr(Ze.re)+sqr(Ze.im);
                dec(k);

         end;

         cl:=Trunc(k*255/NIter);
         cR:=10*cl; cG:=5*cl; cB:=cl;
         btm.canvas.Pixels[ix,iy]:=rgb(cr, cg, cb);

         re:=re+hx;
        end;

     im:=im+hy;
    end;

Form1.Image1.picture.Bitmap.Assign(btm);
end;




procedure TForm1.FormPaint(Sender: TObject);
begin

if Gr_Mode = _ComplexDynDraw then
begin
  PFLD.Update;
  SwapBuffers(DC);

  wglMakeCurrent(0,0);
  wglMakeCurrent(DC, hrc);
end;
end;


procedure TForm1.ShowError;
var
S,S1: String;
Error: Cardinal;
PC: PChar;
Ans: AnsiString;
str:TStringType;
ws: widestring;
P: Pointer;
PAC: PAnsiChar;
su8: UTF8String;
begin
fzGetSyntaxErrorCode(Error);
 case  Error of
   fz_UNKNOWN_SYMBOL:                       S:='UNKNOWN SYMBOL or INCORRECT ARGUMENT or WRONG EXPRESSION';
   fz_MISSING_ROUND_BRACKET:                S:='MISSING ROUND BRACKET';
   fz_MISSING_OPERATION:                    S:='MISSING OPERATION';
   fz_WRONG_NUMBER_ARGUMENTS:               S:='WRONG NUMBER ARGUMENTS';
   fz_MISSING_EXPRESSION:                   S:='MISSING EXPRESSION';
   fz_UNKNOWN_FUNCTION:                     S:='UNKNOWN FUNCTION';
   fz_ERROR_AT_ADDITION_FUNCTION:           S:='ERROR AT ADDITION FUNCTION';
   fz_NOT_DEFINED_OPERATOR:                 S:='NOT DEFINED OPERATOR';
   fz_NOT_DEFINED_FUNCTION:                 S:='NOT DEFINED FUNCTION';
   fz_INCORRECT_ARGUMENT:                   S:='WRONG TYPE OF ARGUMENT';
   fz_MISSING_ARGUMENT:                     S:='MISSING ARGUMENT';
   fz_INTERNAL_ERROR:                       S:='INTERNAL ERROR or  UNCATCHABLE SYNTAX ERROR';
   fz_CALCULATION_ERROR:                    S:='INTERNAL ERROR AT CALCULATION';
   fz_INCORRECT_TYPE:                       S:='WRONG TYPE' ;
   fz_WRONG_NAME:                           S:='WRONG NAME';
   fz_MISSING_SQUARE_BRACKET:               S:='MISSING SQUARE BRACKET';
   fz_MISSING_CURLY_BRACKET:                S:='MISSING CURLY BRACKET';
   fz_MISSING_ABS_BRACKET:                  S:='MISSING ABS BRACKET';
   fz_WRONG_EXPRESSION:                     S:='WRONG EXPRESSION';
   fz_ABSENT_LOAD_FUNCTION_FOR_TYPE:        S:='ABSENT LOAD FUNCTION FOR TYPE';
   fz_MISSING_SEPARATOR:                    S:='MISSING SEPARATOR';
   fz_INCORRECT_SPACE:                      S:='INCORRECT SPACE';
   fz_VARIABLE_REDECLARED:                  S:='VARIABLE REDECLARED';
   else                                     S:='UNKNOWN SYNTAX ERROR';

  end;



   MessageBeep(MB_ICONHAND);

  {$IFDEF STRINGINT}
    fzGetSyntaxErrorString(Str);
    MessageDlg(S+#13#10+'"'+Str+'"',mtError,[mbOk],0);
  {$ELSE}
    fzGetSyntaxErrorString(P);
  {$ENDIF}

(*
   {$IFDEF ANSISTRING}       Ans:=AnsiString(P);    MessageDlg(S+#13#10+'"'+{PAnsiChar(Str)}Ans+'"',mtError,[mbOk],0);      {$ENDIF}
   {$IFDEF STRING}           Str:=String(P);        MessageDlg(S+#13#10+'"'+Str+'"',mtError,[mbOk],0);      {$ENDIF}
   {$IFDEF WIDESTRING}       ws:=WideString(P);     MessageDlg(S+#13#10+'"'+ws+'"',mtError,[mbOk],0);    {$ENDIF}
   {$IFDEF PANSICHAR}        PAC:=PAnsiChar(P);     MessageDlg(S+#13#10+'"'+PAC+'"',mtError,[mbOk],0);      {$ENDIF}
   {$IFDEF UTF8}             su8:=UTF8String(P);    MessageDlg(S+#13#10+'"'+su8+'"',mtError,[mbOk],0);    {$ENDIF}
*)


 // :      -    ,     (   )
 //it's better: at first,  copying of a string then reset - will help to avoid the possible mistakes connected with transfer of strings  (the conflict of different managers of memory)

  {$IFDEF ANSISTRING}       Ans:=AnsiString(P);    S1:=Copy(Ans,1,Length(Ans)); Ans:=''; MessageDlg(S+#13#10+'"'+S1+'"',mtError,[mbOk],0); {$ENDIF}
  {$IFDEF STRING}           Str:=String(P);        S1:=Copy(Str,1,Length(Str)); Str:=''; MessageDlg(S+#13#10+'"'+S1+'"',mtError,[mbOk],0); {$ENDIF}
  {$IFDEF WIDESTRING}       ws:=WideString(P);     S1:=Copy(ws,1,Length(ws));   ws:=''; MessageDlg(S+#13#10+'"'+S1+'"',mtError,[mbOk],0);{$ENDIF}
  {$IFDEF UTF8}             su8:=UTF8String(P);    S1:=Copy(Su8,1,Length(Su8)); Su8:=''; MessageDlg(S+#13#10+'"'+S1+'"',mtError,[mbOk],0); {$ENDIF}
  {$IFDEF PANSICHAR}        PAC:=PAnsiChar(P);     Ans:=AnsiString(PAC); S1:=Copy(Ans,1,Length(Ans)); Ans:=''; MessageDlg(S+#13#10+'"'+S1+'"',mtError,[mbOk],0); {$ENDIF}



end;


procedure TForm1.UpDown1Click(Sender: TObject; Button: TUDBtnType);
var
NS: Integer;
begin


if Button = btNext then
begin
  inc(NSc) ;
  if (NSc = -1) or (NSc = 0)  then NSc:=1;
end
else
if Button = btPrev then
begin
  dec(NSc);
  if NSc = 0  then NSc:=-2;
end;


 if NSc < 0 then
   Sc:=abs(1/NSc)
 else
   Sc:=NSc;

ES.Text:=IntToStr(NSc);


end;

end.



