#pragma once

/*
                                           WARNING !!!

		Use only 32bit compiler.
        ForevalZ does not support multitasking: compiled expression can not be executed simultaneously in multiple threads;
        for each thread needs its own compilation of expression, it also applies to functions such fz_Precompiled (not  thread-safe).

>  All variables and function transfered to ForeavalZ.dll must be placing in region of "unmanaged code" !!! 
>  Calling calculation functions from .dll work very slowly !!! . Use analogous from ForevalZdll.h (without prefix 'fz') 


>  When connecting to MSVC(CLR) , errors are not intercepted when calculating constants while compiling an expression in internal blocks
  "try except" (ForevalZ.dll) - the cause is unknown. Also, floating-point errors are not catching during the calculation.
   Possible workarounds: see proc. Button1_Click, SafeCalc_Click

*/


/*
>  Calculations goes with masking of interruptions.
   It is a slow method. Besides, if in expression there is incorrectly written function,  
   in which there is a reset of FPU masks and/or flags of exceptions, interception of an error will not work.
   It is better to use catch of errors  through  interrupts in the design:

   try
    {
     fzResultCxDP(Func1,&rezCx);
    }
   catch(...)
    {
    //error
    };

  ,if you are able to force it to work! :(
*/


#include "ForevalZdll.h"
#include "stComplexNum.h"
#include "ExtFunc.h"
#include <vector>
#include <string>
//#include <system>  
//#include <vcclr.h>

//#define OVERLOADCOMPLEX   //calc. with overload complex num.: TComplexNum (see Button1)

//#define TESTFASTDYNARRAY  


#pragma unmanaged

 struct TFunc4
       {
		 TComplexD   z1;
		 TComplexD   z2;
		 double      x;
		 _int32       n;
		 TComplexD   res;
		 Pointer32   addr;
		 //TStringType Expr;
		 PCHAR      PchExpr;
       };


//TComplexNum z1,z2,z3,i;
 TComplexD z1d,z2d,z3d,resf;
TComplexNum z1,z2,z3,i,i0;
TFloat x,y,t;
TFunc4 fnc1,fnc2;

double xd,yd,td;
Pointer32 adrXVD,adrXVE,adrXVI,adrXAD,adr1,adrVECD,adrVD,FDynArray;

_int32 n,k,j,m,l;
PDouble  px,py;
PInteger pi1;

 typedef   std::vector<double> TArrayD ;
 typedef   std::vector<int> TArrayI ;
 
 TArrayD  vd,ve,vecd;
 TArrayI  vi;
 /*
 std::vector<double> vd; 
 std::vector<double> ve; 
 std::vector<int> vi; 
 std::vector<double> vecd; 
 */

#pragma managed	


 int GLT;
//TFormatSettings  G_FMT;

//TArrayD vd,ad;
//TArrayI vi;
//TFunc4 fnc1,fnc2;
 
 

 typedef   System::String^* PString; 


namespace TestForevalZ {
	
	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	
	/// <summary>
	///   Form1
	///
	/// !        
	///              ("Resource File Name")     ,
	///                .resx,     .   ,
	///                
	///          ,   .
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(void)
		{
			InitializeComponent();
			//
			//TODO:   
			//
		}
       
	   
	protected:
		/// <summary>
		///    .
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}
	private: System::Windows::Forms::Button^  Button1;
	private: System::Windows::Forms::Label^  LR;
	private: System::Windows::Forms::Label^  label1;
	private: System::Windows::Forms::TextBox^  EF;
	private: System::Windows::Forms::Label^  label2;
	private: System::Windows::Forms::Label^  LPf;

	private: System::Windows::Forms::TextBox^  ENC;
	private: System::Windows::Forms::CheckBox^  CB_OM;
	private: System::Windows::Forms::CheckBox^  CB_CT;
	private: System::Windows::Forms::TextBox^  E_EF;
	private: System::Windows::Forms::Button^  button2;
	private: System::Windows::Forms::TextBox^  E_z1x;
	private: System::Windows::Forms::TextBox^  E_z2x;
	private: System::Windows::Forms::TextBox^  E_z1y;
	private: System::Windows::Forms::TextBox^  E_z2y;
	private: System::Windows::Forms::TextBox^  E_x;
	private: System::Windows::Forms::TextBox^  E_y;
	private: System::Windows::Forms::TextBox^  E_n;
	private: System::Windows::Forms::TextBox^  E_k;








	private: System::Windows::Forms::Label^  label3;
	private: System::Windows::Forms::Label^  label4;
	private: System::Windows::Forms::Label^  label5;
	private: System::Windows::Forms::Label^  label6;
	private: System::Windows::Forms::Label^  label7;
	private: System::Windows::Forms::Label^  label8;
	private: System::Windows::Forms::Label^  label9;
	private: System::Windows::Forms::Label^  label10;
	private: System::Windows::Forms::TextBox^  E_ad0;
	private: System::Windows::Forms::TextBox^  E_ad1;
	private: System::Windows::Forms::TextBox^  E_ad2;
	private: System::Windows::Forms::Label^  label11;
	private: System::Windows::Forms::Label^  label12;
	private: System::Windows::Forms::Label^  label13;
	private: System::Windows::Forms::Button^  SafeCalc;
	private: System::Windows::Forms::CheckBox^  cb_FPUMask;

	private: System::Windows::Forms::CheckBox^  cb_VirtAlloc;
	private: System::Windows::Forms::Label^  label14;







	protected: 

	protected: 

	private:
		/// <summary>
		///   .
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		///      -  
		///       .
		/// </summary>
		void InitializeComponent(void)
		{
			this->Button1 = (gcnew System::Windows::Forms::Button());
			this->LR = (gcnew System::Windows::Forms::Label());
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->EF = (gcnew System::Windows::Forms::TextBox());
			this->label2 = (gcnew System::Windows::Forms::Label());
			this->LPf = (gcnew System::Windows::Forms::Label());
			this->ENC = (gcnew System::Windows::Forms::TextBox());
			this->CB_OM = (gcnew System::Windows::Forms::CheckBox());
			this->CB_CT = (gcnew System::Windows::Forms::CheckBox());
			this->E_EF = (gcnew System::Windows::Forms::TextBox());
			this->button2 = (gcnew System::Windows::Forms::Button());
			this->E_z1x = (gcnew System::Windows::Forms::TextBox());
			this->E_z2x = (gcnew System::Windows::Forms::TextBox());
			this->E_z1y = (gcnew System::Windows::Forms::TextBox());
			this->E_z2y = (gcnew System::Windows::Forms::TextBox());
			this->E_x = (gcnew System::Windows::Forms::TextBox());
			this->E_y = (gcnew System::Windows::Forms::TextBox());
			this->E_n = (gcnew System::Windows::Forms::TextBox());
			this->E_k = (gcnew System::Windows::Forms::TextBox());
			this->label3 = (gcnew System::Windows::Forms::Label());
			this->label4 = (gcnew System::Windows::Forms::Label());
			this->label5 = (gcnew System::Windows::Forms::Label());
			this->label6 = (gcnew System::Windows::Forms::Label());
			this->label7 = (gcnew System::Windows::Forms::Label());
			this->label8 = (gcnew System::Windows::Forms::Label());
			this->label9 = (gcnew System::Windows::Forms::Label());
			this->label10 = (gcnew System::Windows::Forms::Label());
			this->E_ad0 = (gcnew System::Windows::Forms::TextBox());
			this->E_ad1 = (gcnew System::Windows::Forms::TextBox());
			this->E_ad2 = (gcnew System::Windows::Forms::TextBox());
			this->label11 = (gcnew System::Windows::Forms::Label());
			this->label12 = (gcnew System::Windows::Forms::Label());
			this->label13 = (gcnew System::Windows::Forms::Label());
			this->SafeCalc = (gcnew System::Windows::Forms::Button());
			this->cb_FPUMask = (gcnew System::Windows::Forms::CheckBox());
			this->cb_VirtAlloc = (gcnew System::Windows::Forms::CheckBox());
			this->label14 = (gcnew System::Windows::Forms::Label());
			this->SuspendLayout();
			// 
			// Button1
			// 
			this->Button1->Location = System::Drawing::Point(83, 25);
			this->Button1->Name = L"Button1";
			this->Button1->Size = System::Drawing::Size(75, 23);
			this->Button1->TabIndex = 0;
			this->Button1->Text = L"Calc";
			this->Button1->UseVisualStyleBackColor = true;
			this->Button1->Click += gcnew System::EventHandler(this, &Form1::Button1_Click);
			// 
			// LR
			// 
			this->LR->AutoSize = true;
			this->LR->Location = System::Drawing::Point(80, 90);
			this->LR->Name = L"LR";
			this->LR->Size = System::Drawing::Size(256, 13);
			this->LR->TabIndex = 1;
			this->LR->Text = L"                                                                                 " 
				L"  ";
			// 
			// label1
			// 
			this->label1->AutoSize = true;
			this->label1->Location = System::Drawing::Point(34, 90);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(40, 13);
			this->label1->TabIndex = 2;
			this->label1->Text = L"Result:";
			// 
			// EF
			// 
			this->EF->Location = System::Drawing::Point(12, 173);
			this->EF->Name = L"EF";
			this->EF->Size = System::Drawing::Size(598, 20);
			this->EF->TabIndex = 3;
			this->EF->Text = L"sin(z1/z2)^cos(z1/z2)/(sinh(z1/z2)+cosh(z1/z2))+i*max(x,y,max(ad))*polynom(ad,z1/" 
				L"z2)/(z1_.im-i*z2.re)_";
			this->EF->TextChanged += gcnew System::EventHandler(this, &Form1::textBox1_TextChanged);
			// 
			// label2
			// 
			this->label2->AutoSize = true;
			this->label2->Location = System::Drawing::Point(9, 137);
			this->label2->Name = L"label2";
			this->label2->Size = System::Drawing::Size(73, 13);
			this->label2->TabIndex = 4;
			this->label2->Text = L"Perf(eval/ms):";
			// 
			// LPf
			// 
			this->LPf->AutoSize = true;
			this->LPf->Location = System::Drawing::Point(116, 137);
			this->LPf->Name = L"LPf";
			this->LPf->Size = System::Drawing::Size(154, 13);
			this->LPf->TabIndex = 5;
			this->LPf->Text = L"                                                 ";
			// 
			// ENC
			// 
			this->ENC->Location = System::Drawing::Point(83, 54);
			this->ENC->Name = L"ENC";
			this->ENC->Size = System::Drawing::Size(74, 20);
			this->ENC->TabIndex = 6;
			this->ENC->Text = L"10000000";
			// 
			// CB_OM
			// 
			this->CB_OM->AutoSize = true;
			this->CB_OM->Location = System::Drawing::Point(163, 57);
			this->CB_OM->Name = L"CB_OM";
			this->CB_OM->Size = System::Drawing::Size(73, 17);
			this->CB_OM->TabIndex = 7;
			this->CB_OM->Text = L"One/Multi";
			this->CB_OM->UseVisualStyleBackColor = true;
			// 
			// CB_CT
			// 
			this->CB_CT->AutoSize = true;
			this->CB_CT->Location = System::Drawing::Point(175, 31);
			this->CB_CT->Name = L"CB_CT";
			this->CB_CT->Size = System::Drawing::Size(126, 17);
			this->CB_CT->TabIndex = 8;
			this->CB_CT->Text = L"Only real calculations";
			this->CB_CT->UseVisualStyleBackColor = true;
			// 
			// E_EF
			// 
			this->E_EF->Location = System::Drawing::Point(12, 211);
			this->E_EF->Name = L"E_EF";
			this->E_EF->Size = System::Drawing::Size(598, 20);
			this->E_EF->TabIndex = 9;
			this->E_EF->Text = L"func(z:complex double; x: double; np: integer): complex = n:int=0; zf:complex ext" 
				L"ended=0; for(n,0,np, zf=zf+(x+1/z)^n); zf";
			// 
			// button2
			// 
			this->button2->Location = System::Drawing::Point(531, 237);
			this->button2->Name = L"button2";
			this->button2->Size = System::Drawing::Size(75, 23);
			this->button2->TabIndex = 10;
			this->button2->Text = L"SetExtFunc";
			this->button2->UseVisualStyleBackColor = true;
			this->button2->Click += gcnew System::EventHandler(this, &Form1::button2_Click);
			// 
			// E_z1x
			// 
			this->E_z1x->Location = System::Drawing::Point(37, 267);
			this->E_z1x->Name = L"E_z1x";
			this->E_z1x->Size = System::Drawing::Size(66, 20);
			this->E_z1x->TabIndex = 11;
			this->E_z1x->Text = L"2.123";
			// 
			// E_z2x
			// 
			this->E_z2x->Location = System::Drawing::Point(37, 293);
			this->E_z2x->Name = L"E_z2x";
			this->E_z2x->Size = System::Drawing::Size(66, 20);
			this->E_z2x->TabIndex = 12;
			this->E_z2x->Text = L"5.456";
			// 
			// E_z1y
			// 
			this->E_z1y->Location = System::Drawing::Point(146, 267);
			this->E_z1y->Name = L"E_z1y";
			this->E_z1y->Size = System::Drawing::Size(65, 20);
			this->E_z1y->TabIndex = 13;
			this->E_z1y->Text = L"-1.456";
			// 
			// E_z2y
			// 
			this->E_z2y->Location = System::Drawing::Point(146, 293);
			this->E_z2y->Name = L"E_z2y";
			this->E_z2y->Size = System::Drawing::Size(65, 20);
			this->E_z2y->TabIndex = 14;
			this->E_z2y->Text = L"2.789";
			this->E_z2y->TextChanged += gcnew System::EventHandler(this, &Form1::textBox4_TextChanged);
			// 
			// E_x
			// 
			this->E_x->Location = System::Drawing::Point(242, 267);
			this->E_x->Name = L"E_x";
			this->E_x->Size = System::Drawing::Size(66, 20);
			this->E_x->TabIndex = 15;
			this->E_x->Text = L"2.123";
			// 
			// E_y
			// 
			this->E_y->Location = System::Drawing::Point(242, 293);
			this->E_y->Name = L"E_y";
			this->E_y->Size = System::Drawing::Size(66, 20);
			this->E_y->TabIndex = 16;
			this->E_y->Text = L"5.456";
			// 
			// E_n
			// 
			this->E_n->Location = System::Drawing::Point(342, 267);
			this->E_n->Name = L"E_n";
			this->E_n->Size = System::Drawing::Size(65, 20);
			this->E_n->TabIndex = 17;
			this->E_n->Text = L"1";
			// 
			// E_k
			// 
			this->E_k->Location = System::Drawing::Point(342, 293);
			this->E_k->Name = L"E_k";
			this->E_k->Size = System::Drawing::Size(65, 20);
			this->E_k->TabIndex = 18;
			this->E_k->Text = L"2";
			// 
			// label3
			// 
			this->label3->AutoSize = true;
			this->label3->Location = System::Drawing::Point(1, 270);
			this->label3->Name = L"label3";
			this->label3->Size = System::Drawing::Size(30, 13);
			this->label3->TabIndex = 19;
			this->label3->Text = L"z1.re";
			// 
			// label4
			// 
			this->label4->AutoSize = true;
			this->label4->Location = System::Drawing::Point(1, 300);
			this->label4->Name = L"label4";
			this->label4->Size = System::Drawing::Size(30, 13);
			this->label4->TabIndex = 20;
			this->label4->Text = L"z2.re";
			// 
			// label5
			// 
			this->label5->AutoSize = true;
			this->label5->Location = System::Drawing::Point(109, 270);
			this->label5->Name = L"label5";
			this->label5->Size = System::Drawing::Size(31, 13);
			this->label5->TabIndex = 21;
			this->label5->Text = L"z1.im";
			// 
			// label6
			// 
			this->label6->AutoSize = true;
			this->label6->Location = System::Drawing::Point(109, 296);
			this->label6->Name = L"label6";
			this->label6->Size = System::Drawing::Size(31, 13);
			this->label6->TabIndex = 22;
			this->label6->Text = L"z2.im";
			// 
			// label7
			// 
			this->label7->AutoSize = true;
			this->label7->Location = System::Drawing::Point(224, 267);
			this->label7->Name = L"label7";
			this->label7->Size = System::Drawing::Size(12, 13);
			this->label7->TabIndex = 23;
			this->label7->Text = L"x";
			// 
			// label8
			// 
			this->label8->AutoSize = true;
			this->label8->Location = System::Drawing::Point(224, 296);
			this->label8->Name = L"label8";
			this->label8->Size = System::Drawing::Size(12, 13);
			this->label8->TabIndex = 24;
			this->label8->Text = L"y";
			// 
			// label9
			// 
			this->label9->AutoSize = true;
			this->label9->Location = System::Drawing::Point(323, 270);
			this->label9->Name = L"label9";
			this->label9->Size = System::Drawing::Size(13, 13);
			this->label9->TabIndex = 25;
			this->label9->Text = L"n";
			// 
			// label10
			// 
			this->label10->AutoSize = true;
			this->label10->Location = System::Drawing::Point(323, 293);
			this->label10->Name = L"label10";
			this->label10->Size = System::Drawing::Size(13, 13);
			this->label10->TabIndex = 26;
			this->label10->Text = L"k";
			// 
			// E_ad0
			// 
			this->E_ad0->Location = System::Drawing::Point(456, 264);
			this->E_ad0->Name = L"E_ad0";
			this->E_ad0->Size = System::Drawing::Size(65, 20);
			this->E_ad0->TabIndex = 27;
			this->E_ad0->Text = L"3.5";
			// 
			// E_ad1
			// 
			this->E_ad1->Location = System::Drawing::Point(456, 281);
			this->E_ad1->Name = L"E_ad1";
			this->E_ad1->Size = System::Drawing::Size(65, 20);
			this->E_ad1->TabIndex = 28;
			this->E_ad1->Text = L"-1.4";
			// 
			// E_ad2
			// 
			this->E_ad2->Location = System::Drawing::Point(456, 300);
			this->E_ad2->Name = L"E_ad2";
			this->E_ad2->Size = System::Drawing::Size(65, 20);
			this->E_ad2->TabIndex = 29;
			this->E_ad2->Text = L"7.6";
			// 
			// label11
			// 
			this->label11->AutoSize = true;
			this->label11->Location = System::Drawing::Point(419, 267);
			this->label11->Name = L"label11";
			this->label11->Size = System::Drawing::Size(31, 13);
			this->label11->TabIndex = 30;
			this->label11->Text = L"ad[0]";
			// 
			// label12
			// 
			this->label12->AutoSize = true;
			this->label12->Location = System::Drawing::Point(419, 284);
			this->label12->Name = L"label12";
			this->label12->Size = System::Drawing::Size(31, 13);
			this->label12->TabIndex = 31;
			this->label12->Text = L"ad[1]";
			// 
			// label13
			// 
			this->label13->AutoSize = true;
			this->label13->Location = System::Drawing::Point(419, 303);
			this->label13->Name = L"label13";
			this->label13->Size = System::Drawing::Size(31, 13);
			this->label13->TabIndex = 32;
			this->label13->Text = L"ad[2]";
			// 
			// SafeCalc
			// 
			this->SafeCalc->Location = System::Drawing::Point(4, 25);
			this->SafeCalc->Name = L"SafeCalc";
			this->SafeCalc->Size = System::Drawing::Size(75, 23);
			this->SafeCalc->TabIndex = 33;
			this->SafeCalc->Text = L"SafeCalc";
			this->SafeCalc->UseVisualStyleBackColor = true;
			this->SafeCalc->Click += gcnew System::EventHandler(this, &Form1::SafeCalc_Click);
			// 
			// cb_FPUMask
			// 
			this->cb_FPUMask->AutoSize = true;
			this->cb_FPUMask->Checked = true;
			this->cb_FPUMask->CheckState = System::Windows::Forms::CheckState::Checked;
			this->cb_FPUMask->Location = System::Drawing::Point(464, 354);
			this->cb_FPUMask->Name = L"cb_FPUMask";
			this->cb_FPUMask->Size = System::Drawing::Size(125, 17);
			this->cb_FPUMask->TabIndex = 34;
			this->cb_FPUMask->Text = L"Mask FPU at parsing";
			this->cb_FPUMask->UseVisualStyleBackColor = true;
			this->cb_FPUMask->Click += gcnew System::EventHandler(this, &Form1::cb_FpuMask_Click);
			// 
			// cb_VirtAlloc
			// 
			this->cb_VirtAlloc->AutoSize = true;
			this->cb_VirtAlloc->Checked = true;
			this->cb_VirtAlloc->CheckState = System::Windows::Forms::CheckState::Checked;
			this->cb_VirtAlloc->Location = System::Drawing::Point(464, 386);
			this->cb_VirtAlloc->Name = L"cb_VirtAlloc";
			this->cb_VirtAlloc->Size = System::Drawing::Size(146, 17);
			this->cb_VirtAlloc->TabIndex = 35;
			this->cb_VirtAlloc->Text = L"Use Virtual(SysMem)Alloc";
			this->cb_VirtAlloc->UseVisualStyleBackColor = true;
			this->cb_VirtAlloc->Click += gcnew System::EventHandler(this, &Form1::cb_VirtAlloc_Click);
			// 
			// label14
			// 
			this->label14->AutoSize = true;
			this->label14->Location = System::Drawing::Point(275, 386);
			this->label14->Name = L"label14";
			this->label14->Size = System::Drawing::Size(183, 13);
			this->label14->TabIndex = 36;
			this->label14->Text = L"in Windows10x64 work only with this:";
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(618, 415);
			this->Controls->Add(this->label14);
			this->Controls->Add(this->cb_VirtAlloc);
			this->Controls->Add(this->cb_FPUMask);
			this->Controls->Add(this->SafeCalc);
			this->Controls->Add(this->label13);
			this->Controls->Add(this->label12);
			this->Controls->Add(this->label11);
			this->Controls->Add(this->E_ad2);
			this->Controls->Add(this->E_ad1);
			this->Controls->Add(this->E_ad0);
			this->Controls->Add(this->label10);
			this->Controls->Add(this->label9);
			this->Controls->Add(this->label8);
			this->Controls->Add(this->label7);
			this->Controls->Add(this->label6);
			this->Controls->Add(this->label5);
			this->Controls->Add(this->label4);
			this->Controls->Add(this->label3);
			this->Controls->Add(this->E_k);
			this->Controls->Add(this->E_n);
			this->Controls->Add(this->E_y);
			this->Controls->Add(this->E_x);
			this->Controls->Add(this->E_z2y);
			this->Controls->Add(this->E_z1y);
			this->Controls->Add(this->E_z2x);
			this->Controls->Add(this->E_z1x);
			this->Controls->Add(this->button2);
			this->Controls->Add(this->E_EF);
			this->Controls->Add(this->CB_CT);
			this->Controls->Add(this->CB_OM);
			this->Controls->Add(this->ENC);
			this->Controls->Add(this->LPf);
			this->Controls->Add(this->label2);
			this->Controls->Add(this->EF);
			this->Controls->Add(this->label1);
			this->Controls->Add(this->LR);
			this->Controls->Add(this->Button1);
			this->Name = L"Form1";
			this->Text = L"Form1";
			this->Load += gcnew System::EventHandler(this, &Form1::Form1_Load);
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion

double trunc(double d){ return (d>0) ? floor(d) : ceil(d) ; }


double  _cdecl sp1(double x1)
{
 return  x1*x1;
};	


double  _stdcall sp2(double x1, double x2)
{
 return  x1-x2;
};


double  _cdecl sp3(double x1, double x2, double x3)
{
 return  x1+x2-x3;
};



//********     same  functions for overloading complex: TComplexNum  ***********

TComplexNum  __fastcall sp1(TComplexNum z1)
{
  return z1*z1;
}


TComplexNum  __fastcall sp2(TComplexNum z1, TComplexNum z2)
{
  return z1-z2;
}

TComplexNum  __fastcall sp2(TComplexNum z1, TFloat x)
{
  return z1-x;
}


TComplexNum  __fastcall sp2(TFloat x, TComplexNum z1)
{
  return x-z1;
}

TComplexNum  __fastcall sp3(TComplexNum z1, TComplexNum z2, TComplexNum z3)
{
  return z1+z2-z3;
}




TComplexNum _cdecl spall(TArrayD &vx, _int32 nx, TComplexNum zx, TArrayD &vd, _int32 nd, double d, TComplexNum zd, double x, TArrayI &vi, _int32 ni)
{
//rez=(vd[nd]*d*zd - vx[nx]*x*zx)*vi[ni]
//spall(ve,n,z1,vd,k,y,z2,x,vi,j) = (vd[k]*y*z2 - ve[n]*x*z1)*vi[j]
 TComplexNum rez;

 //spall(ve,n+3,z1,vd,j+k,x,z2+z3,t-y,vi,n+k+j)


 rez.re=(vd[nd]*d*zd.re-vx[nx]*x*zx.re)*vi[ni];
 rez.im=(vd[nd]*d*zd.im-vx[nx]*x*zx.im)*vi[ni];


return rez;
 

}


void  ShowError(void)
{
//String S,S1;
_int32 CError,addr;
//PC: PChar;
//AnsiString Ans;
TStringType ErStr,S1,S2;
String^ St1;
String^ S;
char* pch;
Pointer32 PS;



fzGetSyntaxErrorCode(CError);

switch ( CError )
 {
   case  fz_UNKNOWN_SYMBOL:                       S ="UNKNOWN SYMBOL or INCORRECT ARGUMENT or WRONG EXPRESSION"; break;
   case  fz_MISSING_ROUND_BRACKET:                S ="MISSING ROUND BRACKET"; break;
   case  fz_MISSING_OPERATION:                    S="MISSING OPERATION";   break;
   case  fz_WRONG_NUMBER_ARGUMENTS:               S="WRONG NUMBER ARGUMENTS";  break;
   case  fz_MISSING_EXPRESSION:                   S="MISSING EXPRESSION";  break;
   case  fz_UNKNOWN_FUNCTION:                     S="UNKNOWN FUNCTION"; break;
   case  fz_ERROR_AT_ADDITION_FUNCTION:           S="ERROR AT ADDITION FUNCTION";   break;
   case  fz_NOT_DEFINED_OPERATOR:                 S="NOT DEFINED OPERATOR"; break;
   case  fz_NOT_DEFINED_FUNCTION:                 S="NOT DEFINED FUNCTION";  break;
   case  fz_INCORRECT_ARGUMENT:                   S="WRONG TYPE OF ARGUMENT";   break;
   case  fz_MISSING_ARGUMENT:                     S="MISSING ARGUMENT";  break;
   case  fz_INTERNAL_ERROR:                       S="INTERNAL ERROR or  UNCATCHABLE SYNTAX ERROR"; break;
   case  fz_CALCULATION_ERROR:                    S="INTERNAL ERROR AT CALCULATION";  break;
   case  fz_INCORRECT_TYPE:                       S="WRONG TYPE" ;   break;
   case  fz_WRONG_NAME:                           S="WRONG NAME";  break;
   case  fz_MISSING_SQUARE_BRACKET:               S="MISSING SQUARE BRACKET";  break;
   case  fz_MISSING_CURLY_BRACKET:                S="MISSING CURLY BRACKET";  break;
   case  fz_MISSING_ABS_BRACKET:                  S="MISSING ABS BRACKET";  break;
   case  fz_WRONG_EXPRESSION:                     S="WRONG EXPRESSION";  break;
   case  fz_ABSENT_LOAD_FUNCTION_FOR_TYPE:        S="ABSENT LOAD FUNCTION FOR TYPE"; break;
   case  fz_MISSING_SEPARATOR:                    S="MISSING SEPARATOR";   break;
   case  fz_INCORRECT_SPACE:                      S="INCORRECT SPACE";  break;
   case  fz_VARIABLE_REDECLARED:                  S="VARIABLE REDECLARED";  break;
   default:                                       S="UNKNOWN SYNTAX ERROR"; break;
}


   //fzGetSyntaxErrorString)(TStringType& SError);TStringType = char*
   /*
   fzGetSyntaxErrorString(S1);  
   S5=gcnew String(S1);
   MessageBox::Show(S+"\r\n"+S5, "Foreval Error", MessageBoxButtons::OK, MessageBoxIcon::Error);
   */


#ifdef    PCHAR
   //fzGetSyntaxErrorString(Pointer32& SError); TStringType = char*
   fzGetSyntaxErrorString(PS);
   S1=(TStringType)PS;   
   St1=gcnew String(S1);
   //MessageBox::Show(S+"\r\n"+St1, "Foreval Error", MessageBoxButtons::OK, MessageBoxIcon::Error);   
#endif

#ifdef    SYSTSTR
    //fzGetSyntaxErrorString(Pointer32& SError);TStringType = System^
    fzGetSyntaxErrorString(PS);
    pch=(char*)PS;   
    St1=gcnew String(pch);
    //MessageBox::Show(S+"\r\n"+St1, "Foreval Error", MessageBoxButtons::OK, MessageBoxIcon::Error);
#endif

 MessageBox::Show(S+"\r\n"+St1, "Foreval Error", MessageBoxButtons::OK, MessageBoxIcon::Error);

}








	private: System::Void Form1_Load(System::Object^  sender, System::EventArgs^  e) 
{
				 
	  _int32       fzLoad,ic,ECode;
	  TStringType  Expr;
	  String       ^Sid,^Sid1,^Sid2,^Sid3,^Sid4,^Expr1,^Expr2,^SRes;
	  Pointer32    Func1,ve0;
	  TComplexD    rezCx;
	  TZAddFuncStruct FS;
	  _int32       VT[10];  
	  _int32       ni, NR;
	  _int32       ID,ID1,ID2,ID3,ID4,SZ,IDF;
	  PInteger     pint1;
	  PDouble      pdbl1;

      
     //***********************************************************
     fzLoad=fzInit();
     if (fzLoad != 0)
     {
         fzSet(fz_STRING_TYPE, fz_ANSISTRING); //example only for ansi,for other string types see Builder's example
         //fzSet(fz_CALC_TYPE, fz_REAL);
         //fzSet(fz_ENABLE, fz_SHOW_EXCEPTION);
         //fzSet(fz_STACK_TYPE,fz_EXTENDED);
         //fzSet(fz_STRING_TYPE, fz_WIDESTRING);
		 //fzSet(fz_STRING_TYPE, fz_STRING_UTF16);

		  //fzSet(fz_STACK_TYPE,fz_EXTENDED);
         fzSet(fz_STACK_TYPE,fz_DOUBLE);

		 fzSet(fz_ENABLE,fz_MASK_FPU_EXCEPTION);

		 fzSet(fz_ENABLE,fz_USE_VIRTUAL_ALLOC);


		

  
  fzGet(fz_COMPILED_BY,0,ID);
  if (ID >= 100 ) {GLT=2;} else {GLT=1;};

  fzSetVar("res",&resf,fz_COMPLEX_DOUBLE);
  fzSetVar("result",&resf,fz_COMPLEX_DOUBLE);
  fzSetVar("rez",&resf,fz_COMPLEX_DOUBLE);
  fzSetVar("rezult",&resf,fz_COMPLEX_DOUBLE);

  fzSetVar("x",&xd,fz_REAL_DOUBLE);
  fzSetVar("y",&yd,fz_REAL_DOUBLE);
  fzSetVar("t",&td,fz_REAL_DOUBLE);

  fzSetVar("n",&n,fz_REAL_INTEGER);
  fzSetVar("k",&k,fz_REAL_INTEGER);
  fzSetVar("j",&j,fz_REAL_INTEGER);

  fzSetVar("z1",&z1d,fz_COMPLEX_DOUBLE);
  fzSetVar("z2",&z2d,fz_COMPLEX_DOUBLE);
  fzSetVar("z3",&z3d,fz_COMPLEX_DOUBLE);

  
  n = 1; k = 2; j = 5;
  z1d.re=2.123;  z1d.im=-1.456;
  z2d.re=5.456;  z2d.im=2.789;
  z3d.re=-3.789; z3d.im=-3.123;
  xd = 2.123; yd = 5.456; td = -3.789;

  
  /*
  ad.set_length(3);
  ad[0]=3.5; ad[1]=-1.4;  ad[2]=7.6;
*/
  z1.re = z1d.re;  z1.im = z1d.im;
  z2.re = z2d.re;  z2.im = z2d.im;
  z3.re = z3d.re;  z3.im = z3d.im;
  x=xd;
  y=yd; 
  t=td;
  i.re=0; i.im=1;
  i0.re=0; i0.im=0;



  /*
  vd=new double[11];
  vd[0]=1.1; vd[1]=2.2; vd[2]=3.3;
  adr1=&vd[0];
  int adr2 = 0;
  px=&vd[0];
  pi1=(PInteger)px; 
  pi1=pi1-1;
  //px=px-4;
  //pi1=(PInteger)px;  
  n=*pi1;
  
  
  LPF->Text= n.ToString();
  */
  //px=px+1;
  //T=*px;
  //LPF->Text= T.ToString();

  //n=(int)(adr2-4);
  //T= (*double)(n);
 /*
  vecd.push_back(1.1);
  vecd.push_back(2.2);
  vecd.push_back(3.3);
  vecd.push_back(4.4);
  vecd.push_back(5.5);
*/
  //vecd[0]=0;

  


  fzSetVarIntrnl("ad",fz_ARRAY_REAL_DOUBLE,adrXAD);   fzSetLength(adrXAD, fz_ARRAY_REAL_DOUBLE, 3);
  fzSetVarIntrnl("vd",fz_ARRAY_REAL_DOUBLE,adrXVD);   fzSetLength(adrXVD, fz_ARRAY_REAL_DOUBLE, 100);
  fzSetVarIntrnl("ve",fz_ARRAY_REAL_DOUBLE,adrXVE);   //fzSetLength(adrXVE, fz_ARRAY_REAL_DOUBLE, 100);
  fzSetVarIntrnl("vi",fz_ARRAY_REAL_INTEGER,adrXVI);  fzSetLength(adrXVI, fz_ARRAY_REAL_INTEGER, 100);
   

   vd.resize(100);
   ve.resize(100);
   vi.resize(100);

    for (ni = 0; ni <=99; ni++)
	{
       vd[ni]=ni+1;
       ve[ni]=ni+5;

   

      vd[ni]=pow((double)(-1),(Int32)(ni+1))*vd[ni]*0.5;
      ve[ni]=pow((double)(-1),(Int32)(ni+5))*ve[ni]*0.5;
      vi[ni]=trunc(ve[ni]);

	
     
	   fzSetArrayValueD(adrXVD,ni,vd[ni]);
       //fzSetArrayValueE(adrXVE,ni,ve[ni]);
       fzSetArrayValueI(adrXVI,ni,vi[ni]);
	}	   
	

	//to set "ve" array through copy to memory from ve[]
	//pint1=(PInteger)adrXVE;
	//ve0=(Pointer32)(*pint1);  //= &ve[0]

	
    fzSetLength(adrXVE, fz_ARRAY_REAL_DOUBLE, ve.size());
	ve0=(Pointer32)(*((PInteger)adrXVE));  //= &ve[0] in ForevalZ
    CopyMemory(ve0,&ve[0],8*ve.size());

	
 // if data and length of ve is changed, that need reinstall XVE  without recompiling expression , consisting of 've'	 
	/*
	 ve.resize(1000);
	  for (ni = 0; ni <=999; ni++)
	{
		ve[ni]=ni+1.123;
	  }
     
	 fzSetLength(adrXVE, fz_ARRAY_REAL_DOUBLE, ve.size());
	 ve0=(Pointer32)(*((PInteger)adrXVE)); 
	 CopyMemory(ve0,&ve[0],8*ve.size());
	*/




//**************   Other way to adding external dynamic array: more fast (without using   fzSetArrayValueD or CopyMemory)  ******************************************************************
                     	               
//                 Array in VisualC++ count from '1', in ForevalZ count from '0'   !!!      
//                 Zero element is using for saving of length, begin array from '1'
//                 Array and pointer to it (adrVECD) must placing in 'unmanaged memory' !!!


  fzSetVar("vecd", &adrVECD ,fz_ARRAY_REAL_DOUBLE); 
   
    //     compile  of expression for  test "TESTFASTDYNARRAY": see Button1_Click with key:  

  //fzCompile("len(vecd)*(sumq(vecd)/sqr(norm(vecd)))", FDynArray);  //always = len(vecd)
  fzCompile("k:int=0; len:int=len(vecd); s:dbl=0; for(k,0,len-1,s=s+vecd[k]); s/sum(vecd)", FDynArray);  //always = 1

   //vecd.push_back(0);//reserve for length
  //vecd.push_back(0);//begin of array vecd[1]
  vecd.resize(2); //reserve for length (vecd[0]) + begin of array vecd[1] (for creating pointer to array: adrVECD) 
  //vecd.reserve(2);
  vecd[1]=1.23456789;
  adrVECD=&vecd[1];  //to set a  reference to the array.  adrVECD always: placing in 'unmanaged memory' and pointer only to vecd, so, as address of adrVECD using at compilation !!!

  //to write length:
  pint1 = (PInteger)adrVECD;
  pint1=pint1-1;
  if (GLT == 1) {SZ = vecd.size()-1;} else {SZ=vecd.size()-2;};  //GLT=1(Delphi); GLT=2(FPC),  in FPC Length=High
  *pint1 = SZ;  //pint1 = &vecd[1]-4b;  *pint1 <- length

//**************************************************************************************************************************************



/******************************************************************************


                         Addition external functions:

*******************************************************************************/



/*


func1(arg1)=arg1^2; func2(arg1,arg2)=arg1-arg2; func3(arg1,arg2,arg3)=arg1+arg2-arg3;
arg1,arg2,arg3 - real/complex
arg2 - mixed real/complex

ms1, ms2, ms3      fz_ESP
sp1, sp2, sp3      fz_STACK_VAL
ps1, ps2, ps3      fz_STACK_ADR
pc1, pc2, pc3      fz_PreCompiled


infsum             fz_INFINITE;


with arg. of all types:
func10(TArrayE vx, Int32 nx, TComplexE zx, TArrayD vd, Int32 nd, double d, TComplexD zd, Extended x, TArrayI vi, Int32 ni) = (vd[k]*y*z2 - ve[n]*x*z1)*vi[j]

spall    fz_STACK_VAL
msall    fz_ESP
pcall    fz_PreCompiled


********************************************************************************
*/


  //x=vecd[0];

  InitFuncStructZ(FS);
  FS.addr=&SP1;
  FS.CallType=fz_CDECL;
  FS.Arg=1;
  FS.ArgType=fz_REAL_DOUBLE;
  FS.ResultType=fz_REAL;
  FS.CallFunc=fz_STACK_VAL;
  FS.DeepFPU=1;
  fzSetFunction("sp1",&FS);

  InitFuncStructZ(FS);
  FS.addr=&SP2;
  FS.CallType=fz_STDCALL;
  FS.Arg=2;
  FS.ArgType=fz_REAL_DOUBLE;
  FS.ResultType=fz_REAL;
  FS.CallFunc=fz_STACK_VAL;
  FS.DeepFPU=1;
  fzSetFunction("sp2",&FS);

  InitFuncStructZ(FS);
  FS.addr=&SP3;
  FS.CallType=fz_CDECL;
  FS.Arg=3;
  FS.ArgType=fz_REAL_DOUBLE;
  FS.ResultType=fz_REAL;
  FS.CallFunc=fz_STACK_VAL;
  FS.DeepFPU=1;
  fzSetFunction("sp3",&FS);

  InitFuncStructZ(FS);
  FS.addr=&SP1Z;
  FS.CallType=fz_CDECL;
  FS.Arg=1;
  FS.ArgType=fz_COMPLEX_DOUBLE;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_VAL;
  FS.DeepFPU=2;
  fzSetFunction("sp1",&FS);


  InitFuncStructZ(FS);
  FS.addr=&SP2Z;
  FS.CallType=fz_CDECL;
  FS.Arg=2;
  FS.ArgType=fz_COMPLEX_DOUBLE;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_VAL;
  FS.DeepFPU=2;
  fzSetFunction("sp2",&FS);

  //mixed
  //sp2(z,x)=z-x
  InitFuncStructZ(FS);
  FS.Arg=2;
  //VT.set_length(FS.Arg);
  VT[0]=fz_COMPLEX_DOUBLE; VT[1]=fz_REAL_DOUBLE;
  FS.ArgTypeList=&VT[0];
  FS.addr=&SP2ZR;
  FS.CallType=fz_CDECL;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_VAL;
  FS.DeepFPU=2;
  fzSetFunction("sp2",&FS);

  //sp2(x,z)=x-z
  InitFuncStructZ(FS);
  FS.Arg=2;
  //VT.set_length(FS.Arg);
  VT[0]=fz_REAL_DOUBLE; VT[1]=fz_COMPLEX_DOUBLE;
  FS.ArgTypeList=&VT[0];
  FS.addr=&SP2RZ;
  FS.CallType=fz_CDECL;
  FS.Arg=2;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_VAL;
  FS.DeepFPU=2;
  fzSetFunction("sp2",&FS);

  InitFuncStructZ(FS);
  FS.addr=&SP3Z;
  FS.CallType=fz_STDCALL;
  FS.Arg=3;
  FS.ArgType=fz_COMPLEX_DOUBLE;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_VAL;
  FS.DeepFPU=2;
  fzSetFunction("sp3",&FS);

  

  //ps1(x)
  InitFuncStructZ(FS);
  FS.addr=&PS1;
  FS.CallType=fz_CDECL;
  FS.Arg=1;
  FS.ArgType=fz_REAL_DOUBLE;
  FS.ResultType=fz_REAL;
  FS.CallFunc=fz_STACK_ADR;
  FS.DeepFPU=1;
  fzSetFunction("ps1",&FS);

  InitFuncStructZ(FS);
  FS.addr=&PS2;
  FS.CallType=fz_CDECL;
  FS.Arg=2;
  FS.ArgType=fz_REAL_DOUBLE;
  FS.ResultType=fz_REAL;
  FS.CallFunc=fz_STACK_ADR;
  FS.DeepFPU=1;
  fzSetFunction("ps2",&FS);

  InitFuncStructZ(FS);
  FS.addr=&PS3;
  FS.CallType=fz_STDCALL;
  FS.Arg=3;
  FS.ArgType=fz_REAL_DOUBLE;
  FS.ResultType=fz_REAL;
  FS.CallFunc=fz_STACK_ADR;
  FS.DeepFPU=1;
  fzSetFunction("ps3",&FS);

  InitFuncStructZ(FS);
  FS.addr=&PS1Z;
  FS.CallType=fz_CDECL;
  FS.Arg=1;
  FS.ArgType=fz_COMPLEX_DOUBLE;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_ADR;
  FS.DeepFPU=1;
  fzSetFunction("ps1",&FS);

  InitFuncStructZ(FS);
  FS.addr=&PS2Z;
  FS.CallType=fz_CDECL;
  FS.Arg=2;
  FS.ArgType=fz_COMPLEX_DOUBLE;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_ADR;
  FS.DeepFPU=2;
  fzSetFunction("ps2",&FS);

  InitFuncStructZ(FS);
  FS.addr=&PS3Z;
  FS.CallType=fz_STDCALL;
  FS.Arg=3;
  FS.ArgType=fz_COMPLEX_DOUBLE;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_ADR;
  FS.DeepFPU=2;
  fzSetFunction("ps3",&FS);

    //mixed
  //ps2(z,x)=z-x
  InitFuncStructZ(FS);
  FS.Arg=2;
  VT[0]=fz_COMPLEX_DOUBLE; VT[1]=fz_REAL_DOUBLE;
  FS.ArgTypeList=&VT[0];
  FS.addr=&PS2ZR;
  FS.CallType=fz_CDECL;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_ADR;
  FS.DeepFPU=2;
  fzSetFunction("ps2",&FS);

  //ps2(x,z)=x-z
  InitFuncStructZ(FS);
  FS.Arg=2;
  VT[0]=fz_REAL_DOUBLE; VT[1]=fz_COMPLEX_DOUBLE;
  FS.ArgTypeList=&VT[0];
  FS.addr=&PS2RZ;
  FS.CallType=fz_CDECL;
  FS.Arg=2;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_ADR;
  FS.DeepFPU=2;
  fzSetFunction("ps2",&FS);



  //ms1
  InitFuncStructZ(FS);
  FS.addr=&MS1;
  FS.ArgType=fz_REAL_DOUBLE;
  FS.Arg=1;
  FS.CallFunc=fz_ESP;
  FS.CallType=fz_CDECL;
  FS.DeepFPU=1;
  FS.ResultType=fz_REAL;
  fzSetFunction("ms1",&FS);

  InitFuncStructZ(FS);
  FS.addr=&MS2;
  FS.ArgType=fz_REAL_DOUBLE;
  FS.Arg=2;
  FS.CallFunc=fz_ESP;
  FS.CallType=fz_CDECL;
  FS.DeepFPU=1;
  FS.ResultType=fz_REAL;
  fzSetFunction("ms2",&FS);

  InitFuncStructZ(FS);
  FS.addr=&MS3;
  FS.ArgType=fz_REAL_DOUBLE;
  FS.Arg=3;
  FS.CallFunc=fz_ESP;
  FS.CallType=fz_CDECL;
  FS.DeepFPU=1;
  FS.ResultType=fz_REAL;
  fzSetFunction("ms3",&FS);

   //ms2z
  InitFuncStructZ(FS);
  FS.addr=&MS1Z;
  FS.ArgType=fz_COMPLEX_DOUBLE;
  FS.Arg=1;
  FS.CallFunc=fz_ESP;
  FS.CallType=fz_CDECL;
  FS.DeepFPU=2;
  FS.ResultType=fz_COMPLEX;
  fzSetFunction("ms1",&FS);

   //ms2z
  InitFuncStructZ(FS);
  FS.addr=&MS2Z;
  FS.ArgType=fz_COMPLEX_DOUBLE;
  FS.Arg=2;
  FS.CallFunc=fz_ESP;
  FS.CallType=fz_CDECL;
  FS.DeepFPU=2;
  FS.ResultType=fz_COMPLEX;
  fzSetFunction("ms2",&FS);

   //ms3z
  InitFuncStructZ(FS);
  FS.addr=&MS3Z;
  FS.ArgType=fz_COMPLEX_DOUBLE;
  FS.Arg=3;
  FS.CallFunc=fz_ESP;
  FS.CallType=fz_CDECL;
  FS.DeepFPU=2;
  FS.ResultType=fz_COMPLEX;
  fzSetFunction("ms3",&FS);

  //mixed
  //ms2(z,x)=z-x
  InitFuncStructZ(FS);
  FS.Arg=2;
  VT[0]=fz_COMPLEX_DOUBLE; VT[1]=fz_REAL_DOUBLE;
  FS.ArgTypeList=&VT[0];
  FS.addr=&MS2ZR;
  FS.CallType=fz_CDECL;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_ESP;
  FS.DeepFPU=2;
  fzSetFunction("ms2",&FS);

  //ms2(x,z)=x-z
  InitFuncStructZ(FS);
  FS.Arg=2;
  VT[0]=fz_REAL_DOUBLE; VT[1]=fz_COMPLEX_DOUBLE;
  FS.ArgTypeList=&VT[0];
  FS.addr=&MS2RZ;
  FS.CallType=fz_CDECL;
  FS.Arg=2;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_ESP;
  FS.DeepFPU=2;
  fzSetFunction("ms2",&FS);


  InitFuncStructZ(FS);
  FS.addr=&sumr;
  FS.ArgType=fz_REAL_DOUBLE;
  FS.CallFunc=fz_INFINITE;
  FS.CallType=fz_CDECL;
  FS.ResultType=fz_REAL;
  FS.DeepFPU=2;
  fzSetFunction("infsum",&FS);


  InitFuncStructZ(FS);
  FS.addr=&sumz;
  FS.ArgType=fz_COMPLEX_DOUBLE;
  FS.CallFunc=fz_INFINITE;
  FS.CallType=fz_CDECL;
  FS.ResultType=fz_COMPLEX;
  FS.DeepFPU=2;
  fzSetFunction("infsum",&FS);




  InitFuncStructZ(FS);
  FS.Arg=10;
  FS.addr=&SPALL;
  VT[0]=fz_ARRAY_REAL_DOUBLE; VT[1]=fz_REAL_INTEGER; VT[2]=fz_COMPLEX_DOUBLE; VT[3]=fz_ARRAY_REAL_DOUBLE;
  VT[4]=fz_REAL_INTEGER; VT[5]=fz_REAL_DOUBLE; VT[6]=fz_COMPLEX_DOUBLE;  VT[7]=fz_REAL_DOUBLE;
  VT[8]=fz_ARRAY_REAL_INTEGER; VT[9]=fz_REAL_INTEGER;
  FS.ArgTypeList=&VT[0];
  FS.CallType=fz_CDECL;
  //FS.ArgType=fz_DIFFER;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_STACK_VAL;
  FS.DeepFPU=3;
  fzSetFunction("spall",&FS);

  InitFuncStructZ(FS);
  FS.Arg=10;
  FS.addr=&MSALL;
  VT[0]=fz_ARRAY_REAL_DOUBLE; VT[1]=fz_REAL_INTEGER; VT[2]=fz_COMPLEX_DOUBLE; VT[3]=fz_ARRAY_REAL_DOUBLE;
  VT[4]=fz_REAL_INTEGER; VT[5]=fz_REAL_DOUBLE; VT[6]=fz_COMPLEX_DOUBLE;  VT[7]=fz_REAL_DOUBLE;
  VT[8]=fz_ARRAY_REAL_INTEGER; VT[9]=fz_REAL_INTEGER;
  FS.ArgTypeList=&VT[0];
  FS.CallType=fz_CDECL;
  //FS.ArgType=fz_DIFFER;
  FS.ResultType=fz_COMPLEX;
  FS.CallFunc=fz_ESP;
  FS.DeepFPU=3;
  fzSetFunction("msall",&FS);


  


//***************  several expressions: ****************************************
   /*
	  fnc1(z1,z2,n,x) = z1+z2+n*x;
	  fnc2(z1,z2,n,x)=  z1*z2+(i*n+x);

	  fnc2(fnc1(2-i,5+3i,3,1.1),1-i,5,fnc1(2-i,5+3i,3,1.1).re)=
   */


	fzPerform(fz_SAVE, fz_VAR_LIST);

    //fnc1.Expr= "z1+z2+n*x";
	Expr1= "z1+z2+n*x";
	fzSetVar("x", &fnc1.x, fz_REAL_DOUBLE);
	fzSetVar("n", &fnc1.n, fz_REAL_INTEGER);
	fzSetVar("z1", &fnc1.z1, fz_COMPLEX_DOUBLE);
	fzSetVar("z2", &fnc1.z2, fz_COMPLEX_DOUBLE);
	fzCompile(Expr1, fnc1.addr);

	//fnc2.Expr= "z1*z2+(i*n+x)";
	Expr2= "z1*z2+(i*n+x)";
	fzSetVar("x", &fnc2.x, fz_REAL_DOUBLE);
	fzSetVar("n", &fnc2.n, fz_REAL_INTEGER);
	fzSetVar("z1", &fnc2.z1, fz_COMPLEX_DOUBLE);
	fzSetVar("z2", &fnc2.z2, fz_COMPLEX_DOUBLE);
	fzCompile(Expr2, fnc2.addr);

	fzPerform(fz_RESTORE, fz_VAR_LIST);

	fnc1.x= 1.1;  fnc1.n= 3; fnc1.z1.re= 2;  fnc1.z1.im= -1;  fnc1.z2.re= 5; fnc1.z2.im= 3;
				  fnc2.n= 5;                                  fnc2.z2.re= 1; fnc2.z2.im= -1;

	fzResultCxDP(fnc1.addr, &fnc1.res) ;    //fnc1.res=fnc1(2-i,5+3i,3,1.1)
	fnc2.z1= fnc1.res; fnc2.x= fnc1.res.re;

	fzResultCxDP(fnc2.addr, &fnc2.res);
	SRes=fnc2.res.re.ToString()+"   "+fnc2.res.im.ToString()+"i";
	//MessageBox::Show(SRes, "",MessageBoxButtons::OK, MessageBoxIcon::Information);

	

//******************************************************************************



  fzSetFunction("pcall(vx: arrayDbl; nx:int; zx: dblCx; vd: arrayDbl; nd: int; d: dbl; zd: dblCx; x: dbl; vi: arrayInt; ni: int):complex=(vd[nd]*d*zd - vx[nx]*x*zx)*vi[ni]",0);
  fzSetFunction("pc1(x:dbl):real=x^2",0);
  fzSetFunction("pc2(x,y:dbl):real=x-y",0);
  fzSetFunction("pc3(x1,x2,x3:dbl):real=x1+x2-x3",0);
  fzSetFunction("pc1(z:dblCx):complex=z^2",0);
  fzSetFunction("pc2(x:dbl;z:dblCx):complex=x-z",0);
  fzSetFunction("pc2(z:dblCx; x:dbl):complex=z-x",0);
  fzSetFunction("pc2(z1,z2:dblCx):complex=z1-z2",0);
  fzSetFunction("pc3(z1,z2,z3:dblCx):complex=z1+z2-z3",0);
 

//fzSetNameImUnit("ii");  

 /*
fzGetFuncID("sh",IDF);
fzSet(fz_DISABLE_FUNCTION,IDF);
*/

/*
fzSetFunction("pwr(x,y: ext):complex= if( (x < 0) and ([y] <> y),(x+0i)^y,x^y+0i)",0);
fzSetFunction("pwr(x: ext; z: extcx):complex= x^z",0);
fzSetFunction("pwr(z: extcx; x: ext):complex= z^x",0);
fzSetFunction("pwr(z1,z2: extcx):complex= z1^z2",0);


fzGetFuncID("power",IDF);
fzSet(fz_DISABLE_FUNCTION,IDF);
fzGetFuncID("pwr",IDF);
fzAddNameFunction(IDF,"power");
fzAddNameFunction(IDF,"pow");
fzSet(fz_POWER_SYMBOL,IDF);
*/
//(-x)^2.5
//(-4)^(0.5)

fzGet(fz_VERSION,fz_MAJOR,ID1);    Sid1=ID1.ToString();
fzGet(fz_VERSION,fz_MINOR,ID2);    Sid2=ID2.ToString();
fzGet(fz_VERSION,fz_RELEASE,ID3);  Sid3=ID3.ToString();
fzGet(fz_VERSION,fz_BUILD,ID4);    Sid4=ID4.ToString();
Sid=Sid1+"."+Sid2+"."+Sid3+"."+Sid4;



this->Text="Test ForevalZ.dll  (v."+Sid+")";
fzGet(fz_COMPILED_BY,0,ID);


if (ID >= 100) {this->Text=this->Text+".  Compiled by FPC v." + ID.ToString(); GLT=2;}
else
{
 GLT=1;	 
 switch  (ID)
 {

  case 7: this->Text=this->Text+".   Compiled by Delphi7"; break;
  case 8: this->Text=this->Text+".   Compiled by Delphi8";   break;
  case 9: this->Text=this->Text+".   Compiled by Delphi2005"; break;
  case 10: this->Text=this->Text+".  Compiled by Delphi2006"; break;
  case 11: this->Text=this->Text+".  Compiled by Delphi2007";  break;
  case 12:  this->Text=this->Text+".   Compiled by Delphi 2009"; break;
  case 13:  this->Text=this->Text+".   Compiled by Delphi 2010"; break;
  case 14:  this->Text=this->Text+".   Compiled by Delphi XE"; break;
  case 15:  this->Text=this->Text+".   Compiled by Delphi XE2";  break;
  case 16:  this->Text=this->Text+".   Compiled by Delphi XE3";  break;
  case 17:  this->Text=this->Text+".   Compiled by Delphi XE4";  break;
  case 18:  this->Text=this->Text+".   Compiled by Delphi XE5"; break;
  case 19:  this->Text=this->Text+".   Compiled by Delphi XE6";  break;
  case 20:   this->Text=this->Text+".   Compiled by Delphi XE7";  break;
  }
}

  
 
      }
}






 void SetVarValue(void)
{
	double xt;
	
  xd=Convert::ToDouble(this->E_x->Text->Replace(",", "."), System::Globalization::CultureInfo::GetCultureInfo("en-US"));
  yd=Convert::ToDouble(this->E_y->Text->Replace(",", "."), System::Globalization::CultureInfo::GetCultureInfo("en-US"));

  z1d.re=Convert::ToDouble(this->E_z1x->Text->Replace(",", "."), System::Globalization::CultureInfo::GetCultureInfo("en-US"));
  z1d.im=Convert::ToDouble(this->E_z1y->Text->Replace(",", "."), System::Globalization::CultureInfo::GetCultureInfo("en-US"));
  z2d.re=Convert::ToDouble(this->E_z2x->Text->Replace(",", "."), System::Globalization::CultureInfo::GetCultureInfo("en-US"));
  z2d.im=Convert::ToDouble(this->E_z2y->Text->Replace(",", "."), System::Globalization::CultureInfo::GetCultureInfo("en-US"));

  xt=Convert::ToDouble(this->E_ad0->Text->Replace(",", "."), System::Globalization::CultureInfo::GetCultureInfo("en-US"));
  fzSetArrayValueD(adrXAD,0,xt);
  xt=Convert::ToDouble(this->E_ad1->Text->Replace(",", "."), System::Globalization::CultureInfo::GetCultureInfo("en-US"));
  fzSetArrayValueD(adrXAD,1,xt);
  xt=Convert::ToDouble(this->E_ad2->Text->Replace(",", "."), System::Globalization::CultureInfo::GetCultureInfo("en-US"));
  fzSetArrayValueD(adrXAD,2,xt);


  n=Convert::ToInt32(this->E_n->Text);
  k=Convert::ToInt32(this->E_k->Text);


  z1.re = z1d.re;  z1.im = z1d.im;
  z2.re = z2d.re;  z2.im = z2d.im;
  z3.re = z3d.re;  z3.im = z3d.im;
  x=xd; y=yd; t=td;
}


 





	private: System::Void Button1_Click(System::Object^  sender, System::EventArgs^  e) 
{
		 TStringType  Expr;
	     Pointer32    Func1;
	     TComplexD    rezCx;
		 String^      SExpr;
		 Pointer32    PExpr;
		 IntPtr       iptr;
		 PString      PStr;   
		 double       r;
		 _int32       ECode,NC,ni,Prf,SZ,ct,rt;
		 unsigned long T1, T2;
         TComplexNum  rez;
		 Pointer32    adri1;
		 PInteger     pint1; 
		 System::String^      S1r;
		 System::String^      S2r;
		 _int32       FpuExc;
		 

		 //***************************************************


	
		 SetVarValue() ;
		
		 SExpr = EF->Text;
		 
		 
         //Expr = &SExpr;
		 
         //SExpr = SExpr+"12345";
		 //PExpr = &SExpr;
		 //PStr = (PString)PExpr;
		 //iptr = (IntPtr)PStr;
         //PExpr = &SExpr;
		 //EF->Text = *PStr;
		 //PExpr = &SExpr;
		 //SExpr->
		 //PExpr = PtrToStringChars(SExpr);

		  NC = Convert::ToInt32(ENC->Text);
          rezCx.re = 0; rezCx.im = 0;

		 

//---------------------------------------- !!!!! WITH  OVERLOAD COMPLEX OPERATIONS  !!!!!-----------------------------------------------------------------

   #ifdef   OVERLOADCOMPLEX

       if (CB_OM->Checked) { NC=1;} else {NC=Convert::ToInt32(ENC->Text);};
	  T1=GetTickCount();
	  for (ni = 0; ni < NC; ni++)
	  {

      rez =  z2*(z1-(z3-z2+z1)*(z3*z2-z2*z1+z1*z3))+z1*z2-z2*(z1+z2-z3)*z2;
//      rez =  z3*(z1*z3-z2*(z1-z2+z3*z1)-z2*z3)-z1*z2;
//      rez =  z1/z2-z3/(z1+z2)+(z1-z3)/z2;
//      rez =  (y*(z1-z2+z3)-t*z3+(x-t)*(z3*z2*y-z1))*(z1*x-y*z2)*(z2-t+z3*(x+y));
//      rez =  z2*(z1-(z3-z2+z1)*(z3*z2-z2*z1+z1*z3))+z1*z2-z2*(z1+z2-z3)*z2-(z1*(z3+z2)*z3-(z3*z1-z3-z1))*z1;

//      rez =  z1*z2*z3*(z3*z1*(z1*z2-z3*z1)-z1*z2*(z1*z3-z2*z3)+z2*z1*(z2*z1-z3*z2)-(z1+z2)*(z1-z2)*(z3-z2)*(z1*z2-z3*z1*(z1-z2*(z3-z1*(z3-z1)*(z1-z3)*(z3-z2)-z1*z2-z2))))-(z1*z3*z2*(z1*z2-z1*(z2-z2*(z3-z3*(z1-z1*z3*(z1*z2-z3*z1-(z1*z2-z3*z1)*(z1-z2)*(z2-z3)*(z3-z2)-(z1+z3*z2)*(z2-z1*z3)+(z3-z2*z3)*(z2-z3*z1))))))) ;
//      rez = -z1/(z1/z2-z3/(z1+z3)+z1*z2*(z1*z2-z2*z3+z1/(z1/(z1+z2)+z2/(z3+z1))))*(z2*(z1-z2/(z1*z2-z2/(z1*z2+z2*z3)*(z2*z3-z1*z2)))+z1-z2*(z1-z3-z3/(z1-z2)*(z2/(z2-z3*(z1+z2*z3)*(z2-z1*z3)/(z1*z3-z2*(z1+z3))))))*(z1*z2-z3*z2-z3*(z1*z3-z2*(z3-z1)/(z1*z2*z3-z1-z2-z3)));
//      rez = z1*z2*(2.111*z1+1)*(2.211*z1*z2/z3-2.311*z1*(3.422*z3-1)/(2.511*z1-3.611*z2-4.22)*(z1/(3.711*z1-1)-4.111/z1+5.111*(2.611*z1*z2*z3-1.23)/(z2+1.12)-7.132*(2.812*z1*(z2+1.123)*(3.832*z2+2.121)*(3.112/(z1+1.123)-2.133*z3))));
//      rez = z1*z2*(z1-z3*(2.123*z1-3.222*z2-5.323)/(z3*z1*z2/(2.234-z1*z2)+(2.455*z1+3.632)*(3.734*z2-4.832*z3-5.923)-(1.134-z1)/(-z3-z2))+z1*(z2-(-z1-(-z2/(-z3*z1*(z1*z2*z3*(2.745*z1-3.345*z2-z3))-z2*(z1*z2-z2*z3*3.167+2.965*(z1/z3-z3/(z1-z2*(2.467-z1-z2-z3)))*(z2-z3)-2.376*z1)*(z2-z1)-7.154/z1)*(-1.943/z3+z1*z2*z3*5.334))-3.556*z1-5.657)-7.243*z2-3.459)/(z1-z3)+z1*(z3*z2/(z1-2.834*z3)-z2*(z1*(z3-2.756*z2-z1-5.676))));
//      rez = (z1*z2+z3*(z1*z2-z2*z3*z1-z1+z2-z3))*(z1+z2+z3)*(z1-z2-z3)*(z3-z1*(z3-z2*(z1-z2-z3)))*z1*z2*z3-z1*z3*(z1*z3-z2*z3+z1-z3)*(z2*z1+z3*z1+z3*z2-z2-z1)*(z1*z3-z2*(z1-z2*z3-z3-z1)*(z1-z2-z3)-z2*(z2+z2*z1-z3-z1)+z3*(z1*z2-z1*(z3+z2*(z1*z2-z3*z2*z1-z2*z3*(z2+z1*(z1-z3+z2*(z1-z2+z3-z1*(z1*z2-z3*z1)*(z1*z2-z3*(z1+z2+z3)*(z1-z2-z3)-z3*(-z1-z2*(-z3*(-z1*(z2-z3))))))))))));
//      rez = z1*z2-z1/(z1/z2-z3/z2-(-z1-z2*(z1*z2-z3*z1/(z1/z2-z3/z2-(-z1-(-z2-(-z3-(z1*z2-z2*(-z1*z2-z2/(z1+z2*z3)))*z1)*z2)/(z1+z2*z3)-z1*(z2/z3-(-z2*z1/(z1-z2*z3)-(-z1-(-z2/(-z1*z2*(-z1-z2))+z1/z2*(z2*z1+z2*z3-z1/(z1+z2*z3))-z1*z2*(z1*z2+(-z1*z2-z3/z2+z1-z2*z1)))))+z1*z2*z3*(z1+z2*z3)))))));
//      rez = z1*z2*(z1-z3*(2.154*z1-3.253*z2-5.353)/(z3*z1*z2/(2.544-z1*z2)+(2.143*z1+3.556)*(3.343*z2-4.153*z3-5.456)-(1.153-z1)/(-z3-z2))+z1*(z2-(-z1-(-z2/(-z3*z1*(z1*z2*z3*(2.644*z1-3.364*z2-z3))-z2*(z1*z2-z2*z3*3.164+2.267*(z1/z3-z3/(z1-z2*(2.533-z1-z2-z3)))*(z2-z3)-2.453*z1)*(z2-z1)-7.535/z1)*(-1.253/z3+z1*z2*z3*5.353))-3.433*z1-5.455)-7.466*z2-3.577)/(z1-z3)+z1*(z3*z2/(z1-2.699*z3)-z2*(z1*(z3-2.767*z2-z1-5.854)-z2*(-1.549-z1/(-z3-z2))/(z1/z2-z1/(z3/z1-z2/z3)+z3*(1/z1-5.344/z2-z1*z2*(2.435*z1-1.456)*(z3*z2*3.326-5.347)*(1.943-z1*z2*z3*3.245)*(z1+z2))))));
//      rez = (z1*z2+z3*(z1*z2-z2*z3*z1-z1+z2-z3))*(z1+z2+z3)*(z1-z2-z3)*(z3-z1*(z3-z2*(z1-z2-z3)))*z1*z2*z3-z1*z3*(z1*z3-z2*z3+z1-z3)*(z2*z1+z3*z1+z3*z2-z2-z1)*(z1*z3-z2*(z1-z2*z3-z3-z1)*(z1-z2-z3)-z2*(z2+z2*z1-z3-z1)+z3*(z1*z2-z1*(z3+z2*(z1*z2-z3*z2*z1-z2*z3*(z2+z1*(z1-z3+z2*(z1-z2+z3-z1*(z1*z2-z3*z1)*(z1*z2-z3*(z1+z2+z3)*(z1-z2-z3*(z1-z2*(z3-z1*z2-z2*(z1*z2-z3*z1)-z3*(z3*z1+z2))))-z3*(-z1-z2*(-z3*(-z1*(z2-z3*(z1*z2*z3-z2*z1*z3*(-z1*(z2*z1-z3*z2-z1-z2-z3)))))))))))))));
//      rez = (z1*z2+z3/(z1*z2-z2*z3/z1-z1+z2-z3))*(z1+z2+z3)/(z1-z2-z3)*(z3-z1*(z3-z2/(z1-z2-z3)))*z1/z2*z3-z1*z3*(z1*z3-z2*z3+z1-z3)/(z2*z1+z3*z1+z3/z2-z2-z1)*(z1*z3-z2*(z1-z2*z3-z3-z1)*(z1-z2-z3)-z2*(z2+z2*z1-z3-z1)+z3*(z1*z2-z1*(z3+z2/(z1*z2-z3*z2*z1-z2*z3*(z2+z1*(z1-z3+z2*(z1-z2+z3-z1*(z1*z2-z3*z1)*(z1*z2-z3*(z1+z2+z3)*(z1-z2-z3/(z1-z2*(z3-z1*z2-z2/(z1*z2-z3*z1)-z3/(z3/z1+z2))))-z3*(-z1-z2*(-z3/(-z1*(z2-z3*(z1*z2/z3-z2*z1*z3/(-z1*(z2*z1-z3*z2-z1-z2-z3)))))))))))))));
//      rez = z1*z2*(z1-z3*(2.156*z1-3.652*z2-5.653)/(z3*z1*z2/(2.664-z1*z2)+(2.155*z1+3.543)*(3.345*z2-4.431*z3-5.443)-(1.451-z1)/(-z3-z2))+z1*(z2-(-z1-(-z2/(-z3*z1*(z1*z2*z3*(2.453*z1-3.353*z2-z3))-z2*(z1*z2-z2*z3*3.153+2.253*(z1/z3-z3/(z1-z2*(2.533-z1-z2-z3)))*(z2-z3)-2.453*z1)*(z2-z1)-7.553/z1)*(-1.253/z3+z1*z2*z3*5.533))-3.453*z1-5.453)-7.453*z2-3.553)/(z1-z3)+z1*(z3*z2/(z1-2.653*z3)-z2*(z1*(z3-2.753*z2-z1-5.853)-z2*(-1.539-z1/(-z3-z2))/(z1/z2-z1/(z3/z1-z2/z3)+z3*(1/z1-5.553/z2-z1*z2*(2.535*z1-1.53)*(z3*z2*3.536-5.753)*(1.539-z1*z2*z3*3.665)*(z1+z2*(z3-(-z1-z2*z3/(z1*z2-2.863*(z1*z2*(z1-z2*(z1*z3+z2/z3*(2.623*z1-1.352-z3*z2))))))))))))) ;
//      rez = z1*z2*(2.251*z1+1)*(2.243*z1*z2/z3-2.353*z1*(3.475*z3-1)/(2.575*z1-3.675*z2-4.766)*(z1/(3.767*z1-1)-4.176/z1+5.186*(2.866*z1*z2*z3-1.766)/(z2+1.876)-7.165*(2.874*z1*(z2+1.641)*(3.864*z2+2.162)*(3.171/(z1+1.765)-2.173*z3/(2.174*z1*z2*z3-1.171)+(4.171*z1-1.164)*(5.172*z2-7.174)/(z1-2.175*z2-1.747-2.174*z3/(3.618-7.716*z1-8.181*z2*(4.612*z1/(2.189*z3+1.165)-7.198*z1-8.149/z3+9.912*(2.199*z1-1.261)*(3.107*z1+4.179*z2+5.108)*(2.271*z1*z2*z3-7.179)*z1*z2*z3/(z1-z2*2.282-3.621/(z1/(z3-1.147)-7.198/(z2+2.245)+8.233/(2.288*z1*z2*z3+1.247)-9.174)))))/(z1-1.525)))));


//  	rez = sp3(z1*sp2(sp1(z2-z1),sp2(z1-sp2(z3*z1,z1-z2),sp2(z3*z1,z2+z3))),sp1(z3-z2)+sp2(sp3(sp2(z1*z3,z2*z1),z3,sp2(z3-z1,z2-z1)),sp3(sp3(z1-z2,z2*z1,z2*z3),z1*sp2(z1-z2,z2-z3),z3*sp1(z1+z2))),sp3(sp1(z3+z1),sp2(z1-z2,z2*z3),sp1(z1+z2+z3)));
		 //  ps3(z1*ps2(ps1(z2-z1),ps2(z1-ps2(z3*z1,z1-z2),ps2(z3*z1,z2+z3))),ps1(z3-z2)+ps2(ps3(ps2(z1*z3,z2*z1),z3,ps2(z3-z1,z2-z1)),ps3(ps3(z1-z2,z2*z1,z2*z3),z1*ps2(z1-z2,z2-z3),z3*ps1(z1+z2))),ps3(ps1(z3+z1),ps2(z1-z2,z2*z3),ps1(z1+z2+z3)));
		 //  ms3(z1*ms2(ms1(z2-z1),ms2(z1-ms2(z3*z1,z1-z2),ms2(z3*z1,z2+z3))),ms1(z3-z2)+ms2(ms3(ms2(z1*z3,z2*z1),z3,ms2(z3-z1,z2-z1)),ms3(ms3(z1-z2,z2*z1,z2*z3),z1*ms2(z1-z2,z2-z3),z3*ms1(z1+z2))),ms3(ms1(z3+z1),ms2(z1-z2,z2*z3),ms1(z1+z2+z3)));
		 //  pc3(z1*pc2(pc1(z2-z1),pc2(z1-pc2(z3*z1,z1-z2),pc2(z3*z1,z2+z3))),pc1(z3-z2)+pc2(pc3(pc2(z1*z3,z2*z1),z3,pc2(z3-z1,z2-z1)),pc3(pc3(z1-z2,z2*z1,z2*z3),z1*pc2(z1-z2,z2-z3),z3*pc1(z1+z2))),pc3(pc1(z3+z1),pc2(z1-z2,z2*z3),pc1(z1+z2+z3)));

     //rez = spall(ve,n,z1,vd,n,x,z2,y,vi,k); 

	 //rez = spall(ve,n+3,spall(ve,n+1,z1/z2,vd,j+k-1,x,z2/spall(ve,j+3,z3-spall(ve,n+9,z1-z3+z1,vd,k*j,x*t,z2*z3,y-t,vi,j+9),vd,k+7,x,z1-z2/spall(ve,n+3+j,z3/z1,vd,j+k+7,x,z2/z3,-y/t,vi,k+j+5),y/t,vi,j),t-y,vi,n+j),vd,j+k,x,z2-spall(ve,k+3,z1/spall(ve,n+3+k,z3*t,vd,j+k+9,x,z1-z3,t-y*x,vi,n+k+j),vd,k+3,x/t,z2*spall(ve,j+k+7,z1*y,vd,j+3*k,x,z2*y,y-x/y,vi,n+7*k),t/y,vi,k+n+7),t-y/t,vi,n+k+j);
	      // pcall(ve,n+3,pcall(ve,n+1,z1/z2,vd,j+k-1,x,z2/pcall(ve,j+3,z3-pcall(ve,n+9,z1-z3+z1,vd,k*j,x*t,z2*z3,y-t,vi,j+9),vd,k+7,x,z1-z2/pcall(ve,n+3+j,z3/z1,vd,j+k+7,x,z2/z3,-y/t,vi,k+j+5),y/t,vi,j),t-y,vi,n+j),vd,j+k,x,z2-pcall(ve,k+3,z1/pcall(ve,n+3+k,z3*t,vd,j+k+9,x,z1-z3,t-y*x,vi,n+k+j),vd,k+3,x/t,z2*pcall(ve,j+k+7,z1*y,vd,j+3*k,x,z2*y,y-x/y,vi,n+7*k),t/y,vi,k+n+7),t-y/t,vi,n+k+j)
	      // msall(ve,n+3,msall(ve,n+1,z1/z2,vd,j+k-1,x,z2/msall(ve,j+3,z3-msall(ve,n+9,z1-z3+z1,vd,k*j,x*t,z2*z3,y-t,vi,j+9),vd,k+7,x,z1-z2/msall(ve,n+3+j,z3/z1,vd,j+k+7,x,z2/z3,-y/t,vi,k+j+5),y/t,vi,j),t-y,vi,n+j),vd,j+k,x,z2-msall(ve,k+3,z1/msall(ve,n+3+k,z3*t,vd,j+k+9,x,z1-z3,t-y*x,vi,n+k+j),vd,k+3,x/t,z2*msall(ve,j+k+7,z1*y,vd,j+3*k,x,z2*y,y-x/y,vi,n+7*k),t/y,vi,k+n+7),t-y/t,vi,n+k+j)

    //rez = sp3(sp2(sp3(z1,z2,z3-sp2(sp2(z1,z3),sp2(t,z2))),sp2(z2-z3,x*z1)),sp3(sp2(z2,t),sp2(y,z3),sp3(x,y,t)*sp3(z3,z1,z2)),sp3(z1-sp1(z2),z2-sp2(x*y,-z2),z3-sp2(z2-z1,x*y)));
		 // ps3(ps2(ps3(z1,z2,z3-ps2(ps2(z1,z3),ps2(t,z2))),ps2(z2-z3,x*z1)),ps3(ps2(z2,t),ps2(y,z3),ps3(x,y,t)*ps3(z3,z1,z2)),ps3(z1-ps1(z2),z2-ps2(x*y,-z2),z3-ps2(z2-z1,x*y)))
		 // ms3(ms2(ms3(z1,z2,z3-ms2(ms2(z1,z3),ms2(t,z2))),ms2(z2-z3,x*z1)),ms3(ms2(z2,t),ms2(y,z3),ms3(x,y,t)*ms3(z3,z1,z2)),ms3(z1-ms1(z2),z2-ms2(x*y,-z2),z3-ms2(z2-z1,x*y)))
		 // pc3(pc2(pc3(z1,z2,z3-pc2(pc2(z1,z3),pc2(t,z2))),pc2(z2-z3,x*z1)),pc3(pc2(z2,t),pc2(y,z3),pc3(x,y,t)*pc3(z3,z1,z2)),pc3(z1-pc1(z2),z2-pc2(x*y,-z2),z3-pc2(z2-z1,x*y)))
      

	// rez = (z1/z2*z3/(z1.re-z2.im*(x-i))*(-z1/(-z2-i/(-x+y*i)))/(y/(z1/x-y/z2)+z2.re/(i-z1.im)))*(-i-3.5-i*x*(-z1-z2.im*(-z1.im*i-t/(-i)*(2.5/z1*i/t-i/(-i+x/z2)))));
	// rez = (z1.re*t-i*x*(z2.im-z1.re/(i-1.5)-i/(-i-3.5/z2-z1*(x*z3.re-t/z2)*(z2.re/z1.im-z3.re/i)+(i*2.5+1.7*z3)*(i*z1+z3/i-z3.re*z1.im*(x-z1-i))+10.5*(i*2.5+5.7))));


		//rez=z1*z2-(-y/x-i-3.6-z1+z2)*7.3;
	   //rez=z1/x;
	  // rez=2*z1*z2-i*x;
	// rez=  z1*z2-z3*(z1-z2-z1*(z2+z3-z1));
		  //rez=x+y+i0;
		  //rez=z1+z2;
	   //rez=-(-(-(-(-(-z1-(-z2-(x-(-2.5-z1-(-(-(-x-z1-(-3.2-i)-i-(-i-4.5))))-i*(-z1-3.7*i-y/i))))-9.5-(-3.5-z2/i)))-i-(-z1/(-i)-(-z2/(-x))))));
	   //rez=sp1(z1*sp2(z2,z1/sp1(z2/x-y/z2)))/sp3(z1-x,sp2(-sp2(-x/i,i/y),-7.5-i/sp3(-z1,-z2/z1,z2*i)),sp1(x*z1-i)/x);
		//rez=Re(z1*sp1(z1)*sp3(z1,z2,z3*sp2(x,z2)-sp2(z3,y)))+i; 
		 // rez=sp2(z1,z2)*sp2(x,y);
      //rez=-z1-z2.im*(i*z2.re-z1.im/(z1-i*z2.re*z1.im)-z1/(-1.5-2.7*i-i*(-2.5-x*i)/(x-z1.re-(z2.im*y-i)/i)));
	   //rez=(1.5*i-2.7)*(-3.2-i*(2.7-x-(-z2-i-(-z1.re-3.5-(-x/(z1-z2*i)-i/(x-z2.im-2.3*i)))))/(-i/x*z1-z2*y/i));
	  //rez=(x*z1-z2*y)*(-i-2.1-z1*(x+y*z2.im)+(-z1.re*x-3.2)*z2-z1*(-i-z1*x)-(y-z2*i)*z2*(z1-z2*y*i))/(-z1/(x*y-3.5/(x+y))+(x-y*z2.re*z1.im)/z2);
	

		//rez=(z1.re-i*(-2.2-z2.im*(-y-3.1*i-i/(x/i-i/z2))-z1*z2*i*x/(-x-2.5*i-z2.im*i)))*(z1*(-i-(y/z1-z2/x*i)/(1.7-i-z2))-z2/(x-i/y))/(-i*(-x/(-z2.im-3.1))+z2*i-4.5/i);   
	   //rez=sp3(z1,z2,z3*sp3(z1-x,y-z3,z2-z1*z2))*sp2(sp1(sp2(sp1(z2),sp1(z1))),sp2(z3,z2));
	   //rez=sp3(sp2(z2,sp3(z1,z3,z2)),sp3(z2,sp3(sp3(z3,z2,sp3(z2,z1,z3)),z1,z2),z3),sp1(sp3(z1,sp3(z3,sp3(z2,z3,z1),z1),z3)));
	   //rez=spall(ve,n+3,spall(ve,n+1,z1/z2,vd,j+k-1,x,z2/spall(ve,j+3,z3-spall(ve,n+9,z1-z3+z1,vd,k*j,x*t,z2*z3,y-t,vi,j+9),vd,k+7,x,z1-z2/spall(ve,n+3+j,z3/z1,vd,j+k+7,x,z2/z3,-y/t,vi,k+j+5),y/t,vi,j),t-y,vi,n+j),vd,j+k,x,z2-spall(ve,k+3,z1/spall(ve,n+3+k,z3*t,vd,j+k+9,x,z1-z3,t-y*x,vi,n+k+j),vd,k+3,x/t,z2*spall(ve,j+k+7,z1*y,vd,j+3*k,x,z2*y,y-x/y,vi,n+7*k),t/y,vi,k+n+7),t-y/t,vi,n+k+j);
	   //rez=spall(ve,n,z1,vd,n,x,z2,y,vi,k);
	   //rez=z1*sp2(i,x/i-z2*sp3(-x*sp1(z1-i),-3.796-i,x*(-i-z2-5.875))/5.145+sp2(-i-z2,-t-i/z2)/z1)/sp3(z1*sp1(y*i),-sp2(-z1/x,y/(z1/z2-i))/sp3(x*(z1-z2/i),-z3/z1,x/(-z3)),sp2(2.841-t*i,-z2/(-z3-i/(-x-z1)))*sp3(z1*sp1(t/i),x/i-i/y,2.5*z1-7.5/z2)/sp2(z2/x-y*z3/z2,-4.784/i-i/3.752));
	
	   //rez=-(-(-z1-(-z2-(-(-x-(-2.5-(-x-z1-(-3.2-i)-i-z2)))))));
		  //rez=sp1(x)*sp3(x,y,t)+i0;
	  } ;
	  T2=GetTickCount();

	  //S1r=FloatToStrF(rez.re,ffGeneral,20,4,G_FMT);
	  //S2r=FloatToStrF(rez.im,ffGeneral,20,4,G_FMT);
	  //LR->Caption=S1r+"  "+S2r+"i";
	  
	  if ((T2-T1) != 0) {Prf=(_int32)(NC/(T2-T1)); LPf->Text=Prf.ToString(); } else { LPf->Text="no defined" ; };
	  LR->Text=rez.re.ToString()+"   "+rez.im.ToString()+"i";
	  goto endp;
   #endif
//--------------------------------------------------------------------------------------------------------------------------------------------------------
	  
   


//****************************  test  fast connecting of dynamic array (in VisualC++ count from '1', in foreval count from '0'   !!!)  ****************************
//                              without using   fzSetArrayValueD or CopyMemory   
//                                Expression FDynArray compiled in Form1_Load 
#ifdef   TESTFASTDYNARRAY 


  // set randomize size of array (VECD) and fill it 1.0

	NC = rand()+2;
    vecd.clear();


	//******************first way to write array:
	/*
	     vecd.push_back(0);//reserve for length	
         for (ni = 1; ni <= NC; ni++)  //count from 1 !!!
     	 {
         vecd.push_back(1.0);
	     }
	*/
   
	//*******************second way to write array:
    	vecd.resize(NC+1); // NC+1=length(VC++); NC = length(foreval); (>0 !!!); 1 - reserve for length (vecd[0])
       //vecd.reserve(NC+1);
	
       for (ni = 1; ni <= NC; ni++)  //count from 1 !!!
       {
	    vecd[ni]=1.0;
	   }
	
    //set length
	adrVECD=&vecd[1];//to set a new reference to the array so , as  memory location of  vecd is changed  ; after full load of array!!!	
	pint1 = (PInteger)adrVECD;
	pint1=pint1-1;
	if (GLT == 1) {SZ = vecd.size()-1;} else {SZ=vecd.size()-2;};  //GLT=1(Delphi); GLT=2(FPC),  in FPC Length=High
	*pint1 = SZ;  //pint1 = &vecd[1]-4b;  *pint1 <- length
	            
	//  len(vecd)*(sumq(vecd)/sqr(norm(vecd)))
	//  k:int=0; len:int=len(vecd); s:dbl=0; for(k,0,len-1,s=s+vecd[k]); s/sum(vecd)
	fzResultCxDP(FDynArray,&rezCx);   //without recompiling expression
    LR->Text=rezCx.re.ToString();	
	goto endp;

#endif
//************************************************************************************************************************************************

	

	Func1 = NULL;
	 
	


   ct=fz_COMPLEX;
   if (CB_CT->Checked)  {ct=fz_REAL;};
   fzSet(fz_CALC_TYPE, ct);

 
   
  fzCompile(SExpr, Func1);

  if (CB_OM->Checked) { NC=1;} else {NC=Convert::ToInt32(ENC->Text);};

  fzGetSyntaxErrorCode(ECode);


  if (ECode != 0)
  {
	  ShowError();
  }
  else
  {
   fzGet(fz_RESULT_TYPE,0,rt);
   fzPerform(fz_MASK_FPU_EXCEPTION,0);

   if (rt == fz_NONE)           //no return number: return result in inner 'result' or 'res' variable  ( zt: complexDbl=z1+z2; zt=zt*x; result=zt  )
   {
	   

	   T1=GetTickCount();

	  for(ni = 0; ni <= NC; ni++)
	  {
		//fzResult(Func1);
		  Result(Func1);		
	  };
	 T2=GetTickCount();

	

	 rezCx.re=resf.re;
	 rezCx.im=resf.im;
   }
   else
   { 
	 if (ct == fz_REAL)  //return only real result: Re(expr)
	 {
     
	   T1=GetTickCount();
	   for(ni = 0; ni <= NC; ni++)
	   {
		   fzResultD(Func1,rezCx.re);
		   //rezCx.re=ResultD(Func1);


		         //ResultDP(Func1,&rezCx.re);	
		};
		T2=GetTickCount();
		
	 }
	 else                    //full complex result 
	 {
		//ct = fz_Complex; rt = fz_Real, fz_Complex
	   
		T1=GetTickCount();

		for(ni = 0; ni <= NC; ni++)
		{

		 fzResultCxDP(Func1,&rezCx);
		 //fzResultCxD(Func1,rezCx.re,rezCx.im);
         //rezCx=ResultCxD(Func1);
		   

			  //ResultCxDP(Func1,&rezCx);
			  //ResultCxD(Func1,rezCx.re,rezCx.im);
		
		}
		T2=GetTickCount();
	    
     }

   }
  

	 fzPerform(fz_FREE,(Int32)Func1);
  }

  S1r=rezCx.re.ToString();
  S2r=rezCx.im.ToString();
  fzGet(fz_RESULT_TYPE,0, rt);

  if (((ct == fz_COMPLEX) && (rt == fz_COMPLEX)) || (rt == fz_NONE))
   { LR->Text=S1r+"  "+S2r+"i";}
   else
 { LR->Text=S1r;};

  if ((T2-T1) != 0)
	   { LPf->Text=Convert::ToString((Int32)(NC/(T2-T1))); }
	   else { LPf->Text="no defined" ; };

 
 fzGet(fz_IS_FPU_EXCEPTION,0,FpuExc);
	 if(FpuExc == fz_YES)
	 {
		 LR->Text="Invalid operation";
	
	 }
 


endp: ;

}









private: System::Void textBox1_TextChanged(System::Object^  sender, System::EventArgs^  e) {
		 }
private: System::Void textBox4_TextChanged(System::Object^  sender, System::EventArgs^  e) {
		 }
private: System::Void button2_Click(System::Object^  sender, System::EventArgs^  e)
		 {
			 _int32       Error;
             TStringType Expr;


	        Expr = E_EF->Text;
            fzSetFunction(Expr,0);
            fzGetSyntaxErrorCode(Error);
            if (Error != 0) { ShowError();}
		 }






private: System::Void SafeCalc_Click(System::Object^  sender, System::EventArgs^  e) 
		 {
			 TStringType  Expr;
	     Pointer32    Func1;
	     TComplexD    rezCx;
		 String^      SExpr;
		 String^      SCE;
		 Pointer32    PExpr;
		 IntPtr       iptr;
		 PString      PStr;   
		 double       r;
		 _int32       ECode,NC,ni,Prf,SZ,ct,rt;
		 unsigned long T1, T2;
         TComplexNum  rez;
		 Pointer32    adri1;
		 PInteger     pint1; 
		 System::String^      S1r;
		 System::String^      S2r;
		 _int32       FpuExc;
		 

		 //***************************************************


	
		 SetVarValue() ;
		
		 SExpr = EF->Text;
		 
		 
     
		  NC = Convert::ToInt32(ENC->Text);
          rezCx.re = 0; rezCx.im = 0;

		 
   fzSet(fz_ADDRESS_EXCEPTION_FLAG , _int32(&FpuExc));	//uses in fzResultSafe, fzResultDSafe, fzResultCxDSafe,fzResultCxDPSafe

	Func1 = NULL;
	 
	


   ct=fz_COMPLEX;
   if (CB_CT->Checked)  {ct=fz_REAL;};
   fzSet(fz_CALC_TYPE, ct);

 
   
  fzCompile(SExpr, Func1);

  if (CB_OM->Checked) { NC=1;} else {NC=Convert::ToInt32(ENC->Text);};

  fzGetSyntaxErrorCode(ECode);


  if (ECode != 0)
  {
	  ShowError();
  }
  else
  {
   fzGet(fz_RESULT_TYPE,0,rt);
   fzPerform(fz_MASK_FPU_EXCEPTION,0);

   if (rt == fz_NONE)           //no return number: return result in inner 'result' or 'res' variable  ( zt: complexDbl=z1+z2; zt=zt*x; result=zt  )
   {
	   

	  T1=GetTickCount();

	  for(ni = 0; ni <= NC; ni++)
	  {
		   /* 
		      res=sqrt(-x)
              res=x/sin(x-x)
		      x=10000; res=x^x
		   */
		 FpuExc=ResultSafe(Func1);  //more fast then:
         //fzResultSafe(Func1);
		 if (FpuExc != 0) { goto endc;}

	  };
	 T2=GetTickCount();

	

	 rezCx.re=resf.re;
	 rezCx.im=resf.im;
   }
   else
   { 
	 if (ct == fz_REAL)  //return only real result: Re(expr)
	 {
     
	   T1=GetTickCount();
	   for(ni = 0; ni <= NC; ni++)
	   {		  
		    /* 
		       sqrt(-x)
               x/sin(x-x)
		       x=10000; x^x
		   */
		   FpuExc=ResultFSafe(Func1,rezCx.re); //more fast then:
		   //fzResultDSafe(Func1,&rezCx.re);
		   if (FpuExc != 0) { goto endc;}

		};
		T2=GetTickCount();
		
	 }
	 else                    //full complex result 
	 {
		//ct = fz_Complex; rt = fz_Real, fz_Complex
	   
		T1=GetTickCount();

		for(ni = 0; ni <= NC; ni++)
		{

          FpuExc=ResultCxDPSafe(Func1,&rezCx); //more fast then: 
		  //FpuExc=ResultCxDSafe(Func1,rezCx.re,rezCx.im); 
		  //fzResultCxDPSafe(Func1,&rezCx);
		  //fzResultCxDSafe(Func1,rezCx.re,rezCx.im);
		   if (FpuExc != 0) { goto endc;}
		
		}
		T2=GetTickCount();
	    
     }

   }

     endc:
     fzPerform(fz_FREE,(Int32)Func1);
  
	  S1r=rezCx.re.ToString();
      S2r=rezCx.im.ToString();
      fzGet(fz_RESULT_TYPE,0, rt);

      if (((ct == fz_COMPLEX) && (rt == fz_COMPLEX)) || (rt == fz_NONE))
        { LR->Text=S1r+"  "+S2r+"i";}
      else
        { LR->Text=S1r;};

      if ((T2-T1) != 0)
	    { LPf->Text=Convert::ToString((Int32)(NC/(T2-T1))); }
	   else { LPf->Text="no defined" ; };

      if (FpuExc != 0) 
      {
	    LPf->Text=FpuExc.ToString();
	 
	    switch ( FpuExc)
        {
          case  1:    SCE="Invalid operation";break;          //  sqrt(-x)
	      case  4:    SCE="Divizion on Zero";break;           //  x/sin(x-x)
		  case  5:    SCE="Divizion on Zero";break;           //  z1/sin(z1-z1)
	      case  8:    SCE="Overflow in float point";break;    //  x=10000; x^x
		  default:    SCE="Invalid operation";break;
        }
	    LPf->Text=SCE;
		LR->Text="Invalid operation";
      }

  }

 

 

  


 endp: ;
		 }



private: System::Void cb_FpuMask_Click(System::Object^  sender, System::EventArgs^  e) 
		 {
	    if (cb_FPUMask->Checked) {  fzSet(fz_ENABLE,fz_MASK_FPU_EXCEPTION);} else { fzSet(fz_DISABLE,fz_MASK_FPU_EXCEPTION);};
		 }
private: System::Void cb_VirtAlloc_Click(System::Object^  sender, System::EventArgs^  e)
		 {
	   if (cb_VirtAlloc->Checked) {   fzSet(fz_ENABLE,fz_USE_VIRTUAL_ALLOC);} else {  fzSet(fz_DISABLE,fz_USE_VIRTUAL_ALLOC);};
		 }
};


}

