﻿'*************************************************************************************************************************

'rus:
'В .net память под статические объекты выделяется динамически и является перемещаемой.
'По этой причине задание переменных и подключаемых функций через их адреса невозможно: работать будет, но недолго, 
'   пока менеджер памяти не переместит их в другое место (проверено!)
'Поэтому, установка переменных только командой: flSetVarIntrnl
'Задание внешних функций только как тип fl_PRECOMPILED
'больше примеров: см. foreval для .net и VB6

'eng:
'In .net memory for static objects are allocated dynamically and is movable.
'For this reason the define of variables and the external  functions through their addresses is impossible: will work,  but not for long, 
'   until the manager of memory moves them to other place (it is checked!)
'Therefore, the installation of variables only by command: flSetVarIntrnl
'Setting external functions only as a type of flPRECOMPILED
'more examples: see foreval for .net and VB6

'************************************************************************************************************************


Imports System.Math
Imports System.Globalization
Imports System.Runtime.InteropServices.Marshal
Imports System.Runtime.InteropServices



Structure TFuncExt4
    Public Expr As String
    Public Addr As UInteger

    Public res As TComplex
    Public z1 As TComplex
    Public z2 As TComplex
    Public x As Double
    Public n As Integer

    Public adrZ1 As UInteger
    Public adrZ2 As UInteger
    Public adrX As UInteger
    Public adrN As UInteger
    Public adrRes As UInteger
End Structure

Public Class Form1

    Private Declare Function GetTickCount Lib "kernel32" () As UInteger


    Dim x As Double
    Dim y As Double
    Dim t As Double
    Dim a As Double
    Dim b As Double
    Dim c As Double
    Dim d As Double
    Dim res As Double
    Dim n As Integer
    Dim k As Integer
    Dim i As Integer
    Dim j As Integer
    Dim z1 As TComplex
    Dim z2 As TComplex
    Dim z3 As TComplex
    Dim resz As TComplex



    Dim adrVD As UInteger
    Dim AdrVI As UInteger
    Dim AdrVD1 As UInteger
    Dim AdrAD As UInteger
    Dim AdrX, AdrY, AdrT, AdrZ1, AdrZ2, AdrN, AdrK, AdrA, AdrB, AdrC, AdrD, AdrJ, AdrZ3, AdrResZ As UInteger


    Dim VBA1() As Double

    Dim fnc1 As TFuncExt4
    Dim fnc2 As TFuncExt4

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim rd As Double
        Dim lenVD As Integer
        Dim AdrFS As Integer
        Dim ECode As Integer
        Dim fi As Integer
        Dim ri As Integer
        Dim FS As Integer
        Dim Vaddr As Integer
        Dim StrV As String
        Dim Str As String
        Dim ID As Integer
        Dim ArgZ As TComplex
        Dim CXres As TComplex
        Dim FCAddr As Integer

        'First of all need to set type of strings !!!!!!!!!!!!!!!
        'String type  - ANSISTRING
        'To set type of string (ANSISTRING) in forevalZ.dll:
        Call fzSet(fz_STRING_TYPE, fz_ANSISTRING)

        'Call fzSet(fz_ENABLE, fz_SHOW_EXCEPTION)
        ' Call fzSet(fz_ENABLE, fz_CHECK_INCORRECT_SPACE)

        'type all constants and results of intermediate calculations:
        Call fzSet(fz_STACK_TYPE, fz_DOUBLE)  'now - double (Higher speed, lower accuracy)
        'on default:
        'Call fzSet(fz_STACK_TYPE, fz_EXTENDED) 'max accuracy
        
        'to check the correct of transmission strings enable error messages commando fzSet (fz_ENABLE, fz_SHOW_EXCEPTION)
        'and pass the string with the error, such as: fzCompile("1+2+3+",FS);
        'has to be a message with this string without distortions



        'set the same functions with precompiled call
        Call fzSetFunction("pc1(x:  double)=x^2", 0)
        Call fzSetFunction("pc1(z: complex double):complex=z*z", 0)
        Call fzSetFunction("pc2(x,y:  double)=x-y", 0)
        Call fzSetFunction("pc2(z1,z2: complex double):complex=z1-z2", 0)
        Call fzSetFunction("pc2(x:  double; z: complex double):complex=x-z", 0)
        Call fzSetFunction("pc2(z: complex double; x:  double):complex=z-x", 0)
        Call fzSetFunction("pvd4(vd:array double; n:integer; z: complex double; x:double ):complex=vd[n]+x+z", 0)
        Call fzSetFunction("pvd3(vd:array double; n:integer; x:double)=vd[n]*x", 0)
        Call fzSetFunction("{$CC-}pccopy(vs,vd: array double):none = l:int=0; ls:int=len(vs); ld:int=len(vd); l=min(ls,ld); i:int=0; for(i,0,l-1,vd[i]=vs[i])", 0)
        Call fzSetFunction("{$CC-}pcfillarray(vd: array double; x: double):none = l:int=len(vd); i:int=0; for(i,0,l-1,vd[i]=x)", 0)

        'pc2(z1*pc1(x*y),z2+pc2(x,y*x))+pc1(z1*i)/pc1(x*pc2(x,-y))+pc2(x*y,z1*z2)*pc2(z1*i,x+y)
        '(x+y)/(z1+z2+z1*i)-(x+y+x+y+x-y)*(z1-z2+z1+z2+z1*i)
        'pvd3(vd,n+5,x*y)*pvd4(vd,n+k,z1+z2,x+y)




        Call fzSetVarIntrnl("x", fz_REAL_DOUBLE, AdrX)
        Call fzSetVarIntrnl("y", fz_REAL_DOUBLE, AdrY)
        Call fzSetVarIntrnl("t", fz_REAL_DOUBLE, AdrT)
        Call fzSetVarIntrnl("a", fz_REAL_DOUBLE, AdrA)
        Call fzSetVarIntrnl("b", fz_REAL_DOUBLE, AdrB)
        Call fzSetVarIntrnl("c", fz_REAL_DOUBLE, AdrC)
        Call fzSetVarIntrnl("d", fz_REAL_DOUBLE, AdrD)

        Call fzSetVarIntrnl("n", fz_REAL_INTEGER, AdrN)
        Call fzSetVarIntrnl("k", fz_REAL_INTEGER, AdrK)
        Call fzSetVarIntrnl("j", fz_REAL_INTEGER, AdrJ)

        Call fzSetVarIntrnl("z1", fz_COMPLEX_DOUBLE, AdrZ1)
        Call fzSetVarIntrnl("z2", fz_COMPLEX_DOUBLE, AdrZ2)
        Call fzSetVarIntrnl("z3", fz_COMPLEX_DOUBLE, AdrZ3)

        'Error in VB.NET: set only last variable - "result"; in VB6 works correctly
        Call fzSetVarIntrnl("res", fz_COMPLEX_DOUBLE, AdrResZ)
        Call fzSetVarIntrnl("result", fz_COMPLEX_DOUBLE, AdrResZ)

    
        Call fzSetVarIntrnl("vd", fz_ARRAY_REAL_DOUBLE, adrVD)
        Call fzSetVarIntrnl("ad", fz_ARRAY_REAL_DOUBLE, AdrAD)
        Call fzSetVarIntrnl("vi", fz_ARRAY_REAL_INTEGER, AdrVI)

        lenVD = 100
        Call fzSetLength(adrVD, fz_ARRAY_REAL_DOUBLE, lenVD)
        Call fzSetLength(AdrAD, fz_ARRAY_REAL_DOUBLE, 3)
        Call fzSetLength(AdrVI, fz_ARRAY_REAL_INTEGER, lenVD)

        Call fzGet(fz_ARRAY_LENGTH, adrVD, lenVD)


        a = 2.54321
        b = -3.98765
        c = 4.12345
        d = -5.6789

        x = 2.123#
        y = 5.456#
        t = -3.789
        n = 1
        k = 2
        j = 5
        
        z1.re = x
        z1.im = -1.456
        z2.re = y
        z2.im = 2.789
        z3.re = t
        z3.im = -3.123

        Call fzSetVarValueD(AdrX, x)
        Call fzSetVarValueD(AdrY, y)
        Call fzSetVarValueD(AdrT, t)
        Call fzSetVarValueD(AdrA, a)
        Call fzSetVarValueD(AdrB, b)
        Call fzSetVarValueD(AdrC, c)
        Call fzSetVarValueD(AdrD, d)

        Call fzSetVarValueI(AdrN, n)
        Call fzSetVarValueI(AdrK, k)
        Call fzSetVarValueI(AdrJ, j)

        Call fzSetVarValueCxD(AdrZ1, z1.re, z1.im)
        Call fzSetVarValueCxD(AdrZ2, z2.re, z2.im)
        Call fzSetVarValueCxD(AdrZ3, z3.re, z3.im)



        'Vaddr = VarPtr(z1)
        'Call fzGetVarValueCxD(Vaddr, ArgZ.re, ArgZ.im)
        'StrV = CStr(ArgZ.re) + "+" + CStr(ArgZ.im) + "i"
        'MsgBox StrV


        For fi = 0 To lenVD - 1  'array - dinamic count from 0 to length - 1
            rd = ((-1) ^ (fi + 1)) * (fi + 1) * 0.5
            Call fzSetArrayValueD(adrVD, fi, rd)

            ri = Fix((-1) ^ (fi + 5) * (fi + 5) * 0.5)
            Call fzSetArrayValueI(AdrVI, fi, ri)

        Next

        'in the work, you can dynamically change the size of the array without recompiling the function containing it:
        Call fzSetVarIntrnl("vd1", fz_ARRAY_REAL_DOUBLE, AdrVD1)
        Call fzCompile("sum(vd1)*len(vd1)", FCAddr)
        Call fzSetLength(AdrVD1, fz_ARRAY_REAL_DOUBLE, 3)
        Call fzSetArrayValueD(AdrVD1, 0, 1.1)
        Call fzSetArrayValueD(AdrVD1, 1, 2.2)
        Call fzSetArrayValueD(AdrVD1, 2, 3.3)
        Call fzResultCxDP(FCAddr, CXres)

        Str = CStr(CXres.re) + "  + " + CStr(CXres.im) + "*i"
        'MsgBox(Str)  '=(1.1+2.2+3.3)*3=19.8

        Call fzSetLength(AdrVD1, fz_ARRAY_REAL_DOUBLE, 5)
        Call fzSetArrayValueD(AdrVD1, 3, 4.4)
        Call fzSetArrayValueD(AdrVD1, 4, 5.5)
        Call fzResultCxDP(FCAddr, CXres)

        Str = CStr(CXres.re) + "  + " + CStr(CXres.im) + "*i"
        'MsgBox(Str)  '=(1.1+2.2+3.3+4.4+5.5)*5=82.5 

        '************************several expressions*******************************************'
        'save global var.
        Call fzPerform(fz_SAVE, fz_VAR_LIST)
        'fnc1(z1,z2,n,x) = z1+z2+n*x;
        'fnc2(z1,z2,n,x)=  z1*z2+(i*n+x);
        'fnc2(fnc1(2-i,5+3i,3,1.1),1-i,5,fnc1(2-i,5+3i,3,1.1).re)=

        fnc1.Expr = "z1+z2+n*x"
        Call fzSetVarIntrnl("x", fz_REAL_DOUBLE, fnc1.adrX)
        Call fzSetVarIntrnl("n", fz_REAL_INTEGER, fnc1.adrN)
        Call fzSetVarIntrnl("z1", fz_COMPLEX_DOUBLE, fnc1.adrZ1)
        Call fzSetVarIntrnl("z2", fz_COMPLEX_DOUBLE, fnc1.adrZ2)
        Call fzCompile(fnc1.Expr, fnc1.Addr)


        fnc2.Expr = "z1*z2+(i*n+x)"
        Call fzSetVarIntrnl("x", fz_REAL_DOUBLE, fnc2.adrX)
        Call fzSetVarIntrnl("n", fz_REAL_INTEGER, fnc2.adrN)
        Call fzSetVarIntrnl("z1", fz_COMPLEX_DOUBLE, fnc2.adrZ1)
        Call fzSetVarIntrnl("z2", fz_COMPLEX_DOUBLE, fnc2.adrZ2)
        Call fzCompile(fnc2.Expr, fnc2.Addr)

        fnc1.x = 1.1
        fnc1.n = 3
        fnc1.z1.re = 2.0#
        fnc1.z1.im = -1.0#
        fnc1.z2.re = 5.0#
        fnc1.z2.im = 3.0#
        Call fzSetVarValueD(fnc1.adrX, fnc1.x)
        Call fzSetVarValueI(fnc1.adrN, fnc1.n)
        Call fzSetVarValueCxD(fnc1.adrZ1, fnc1.z1.re, fnc1.z1.im)
        Call fzSetVarValueCxD(fnc1.adrZ2, fnc1.z2.re, fnc1.z2.im)



        'fnc2.x = 1.1
        fnc2.n = 5
        'fnc2.z1.re = 2.0#
        'fnc2.z1.im = -1.0#
        fnc2.z2.re = 1.0#
        fnc2.z2.im = -1.0#
        Call fzSetVarValueD(fnc2.adrX, fnc2.x)
        Call fzSetVarValueI(fnc2.adrN, fnc2.n)
        Call fzSetVarValueCxD(fnc2.adrZ1, fnc2.z1.re, fnc2.z1.im)
        Call fzSetVarValueCxD(fnc2.adrZ2, fnc2.z2.re, fnc2.z2.im)

        Call fzResultCxDP(fnc1.Addr, fnc1.res)                       'fnc1.res=fnc1(2-i,5+3i,3,1.1)
        fnc2.z1 = fnc1.res
        fnc2.x = fnc1.res.re
        Call fzSetVarValueCxD(fnc2.adrZ1, fnc1.res.re, fnc1.res.im) 'fnc2.z1=fnc1.res
        Call fzSetVarValueD(fnc2.adrX, fnc1.res.re)                 'fnc2.x=fnc1.res.re

        Call fzResultCxDP(fnc2.Addr, fnc2.res)

        Str = CStr(fnc2.res.re) + "  + " + CStr(fnc2.res.im) + "*i"
        'MsgBox(Str)

        'fnc1.res*fnc2.z2+(i*fnc2.n+Re(fnc1.res))=(10.3+2*i)*(1-i)+(i*5+10.3)=22.6-3.3i




        'restore global var.
        Call fzPerform(fz_RESTORE, fz_VAR_LIST)

        'Call fzSetVar("x", VarPtr(x), fz_REAL_DOUBLE)
        'Call fzSetVar("n", VarPtr(n), fz_REAL_INTEGER)
        'Call fzSetVar("z1", VarPtr(z1), fz_COMPLEX_DOUBLE)
        'Call fzSetVar("z2", VarPtr(z2), fz_COMPLEX_DOUBLE)

        '**************************************************************************

        Call fzGet(fz_VERSION, fz_MAJOR, ID)
        Str = CStr(ID)

        Call fzGet(fz_VERSION, fz_MINOR, ID)
        Str = Str + "." + CStr(ID)

        Call fzGet(fz_VERSION, fz_RELEASE, ID)
        Str = Str + "." + CStr(ID)

        Call fzGet(fz_VERSION, fz_BUILD, ID)
        Str = Str + "." + CStr(ID)


        Str = "ForevalZ.dll v." + Str
        Me.Text = Str

        Call fzGet(fz_COMPILED_BY, 0, ID)

        If ID >= 100 Then
            Me.Text = Me.Text + ".  Compiled by FPC v." + CStr(ID)
        Else
            If ID = 7 Then Me.Text = Me.Text + ".  Compiled by Delphi7" Else 
            If ID = 12 Then Me.Text = Me.Text + ".  Compiled by Delphi 2009" Else 
            If ID = 16 Then Me.Text = Me.Text + ".  Compiled by Delphi XE3"
        End If

        Call fzGetStr(fz_COMMENT, 0, Str)
        'Me.Text = Me.Text + "   " + Str


        Call fzGetStr(fz_ABOUT, 0, Str)
        'MsgBox(Str)

    End Sub

    Private Sub Label2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Label2.Click

    End Sub



    Public Sub ErrorHandle()
        Dim ECode As Integer
        Dim S As String
        Dim ErStr As String
        Dim ErStrTmp As String


        Call fzGetSyntaxErrorCode(ECode)


        Select Case ECode


            Case fz_INTERNAL_ERROR
                S = "INTERNAL ERROR or UNCATCHABLE SYNTAX ERROR"

            Case fz_UNKNOWN_SYMBOL
                S = "UNKNOWN SYMBOL or INCORRECT ARGUMENT or  WRONG EXPRESSION"

            Case fz_WRONG_NUMBER_ARGUMENTS
                S = "INCOINCIDENCE NUMBER OF   ARGUMENTS"

            Case fz_MISSING_OPERATION
                S = "MISSING OPERATION"

            Case fz_MISSING_EXPRESSION
                S = "MISSING EXPRESSION"

            Case fz_UNKNOWN_FUNCTION
                S = "UNKNOWN FUNCTION"

            Case fz_ERROR_AT_ADDITION_FUNCTION
                S = "ERROR AT ADDITION FUNCTION"

            Case fz_INCORRECT_ARGUMENT
                S = "INCORRECT ARGUMENT"

            Case fz_MISSING_ARGUMENT
                S = "MISSING ARGUMENT"

            Case fz_INCORRECT_TYPE
                S = "INCORRECT TYPE"

            Case fz_MISSING_SEPARATOR
                S = "MISSING SEPARATOR "

            Case fz_WRONG_NAME
                S = "WRONG NAME"

            Case fz_MISSING_ABS_BRACKET
                S = "MISSING ABS BRACKET"

            Case fz_MISSING_SQUARE_BRACKET
                S = "MISSING SQUARE BRACKET"

            Case fz_MISSING_CURLY_BRACKET
                S = "MISSING CURLY BRACKET"

            Case fz_MISSING_ROUND_BRACKET
                S = "MISSING ROUND BRACKET"

            Case fz_NOT_DEFINED_OPERATOR
                S = "NOT DEFINED OPERATOR"

            Case fz_NOT_DEFINED_FUNCTION
                S = "NOT DEFINED FUNCTION"

            Case fz_CALCULATION_ERROR
                S = "INTERNAL ERROR AT CALCULATION"

            Case fz_WRONG_EXPRESSION
                S = "WRONG EXPRESSION"

            Case fz_ABSENT_LOAD_FUNCTION_FOR_TYPE
                S = "ABSENT LOAD FUNCTION FOR TYPE"

            Case fz_MISSING_SEPARATOR
                S = "MISSING SEPARATOR"

            Case fz_INCORRECT_SPACE
                S = "INCORRECT SPACE"
  
            Case fz_VARIABLE_REDECLARED
                S = "VARIABLE REDECLARED"

            Case Else : S = "UNKNOWN SYNTAX ERROR"

        End Select


        Call fzGetSyntaxErrorString(ErStrTmp)
        ErStr = ErStrTmp
        ErStrTmp = ""


        '  it's better: at first,  copying of a string then reset - will help to avoid the possible mistakes connected with transfer of strings  (the conflict of different managers of memory)


        MsgBox("ForevalZ:SyntaxError" + Chr(13) + S + Chr(13) + ErStr + Chr(13))

    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim FS As UInteger
        Dim ResR As Double
        Dim ErStr As String
        Dim SPtr As UInteger
        Dim FZ1 As UInteger
        Dim T1 As Single
        Dim T2 As Single
        Dim nc As Integer
        Dim i As Integer
        Dim rt, ct As Integer
        Dim ECode As Integer
        Dim perf As Double
        Dim res As TComplex
        Dim Sre As String
        Dim Sim As String
        Dim SRez As String
        Dim rd As Double



        'examples:
        'root(z1,3)+(z2.re/z1.im)^2
        'zi1:dblCx = |z1|^n*cossin(arg(z1)*n); zi2:dblCx = |z1|*exp(i*arg(z1)); zi1/zi2
        'z1:dblCx = 1+2i; z2:dblCx = 3-5i; result = z1^log(z1,z2)/z2 


     
        x = Convert.ToDouble(ETX.Text.Replace(",", "."), CultureInfo.GetCultureInfo("en-US"))
        y = Convert.ToDouble(ETY.Text.Replace(",", "."), CultureInfo.GetCultureInfo("en-US"))

        z1.re = Convert.ToDouble(ETZ1R.Text.Replace(",", "."), CultureInfo.GetCultureInfo("en-US"))
        z1.im = Convert.ToDouble(ETZ1I.Text.Replace(",", "."), CultureInfo.GetCultureInfo("en-US"))

        z2.re = Convert.ToDouble(ETZ2R.Text.Replace(",", "."), CultureInfo.GetCultureInfo("en-US"))
        z2.im = Convert.ToDouble(ETZ2I.Text.Replace(",", "."), CultureInfo.GetCultureInfo("en-US"))

       
        n = Convert.ToInt32(ETN.Text.Replace(",", "."), CultureInfo.GetCultureInfo("en-US"))
        k = Convert.ToInt32(ETK.Text.Replace(",", "."), CultureInfo.GetCultureInfo("en-US"))
       
        Call fzSetVarValueD(AdrX, x)
        Call fzSetVarValueD(AdrY, y)
        Call fzSetVarValueD(AdrT, t)

        Call fzSetVarValueCxD(AdrZ1, z1.re, z1.im)
        Call fzSetVarValueCxD(AdrZ2, z2.re, z2.im)


        Call fzSetVarValueI(AdrK, k)
        Call fzSetVarValueI(AdrN, n)

        rd = Convert.ToDouble(ETad0.Text.Replace(",", "."), CultureInfo.GetCultureInfo("en-US"))
        Call fzSetArrayValueD(AdrAD, 0, rd)
        rd = Convert.ToDouble(ETad1.Text.Replace(",", "."), CultureInfo.GetCultureInfo("en-US"))
        Call fzSetArrayValueD(AdrAD, 1, rd)
        rd = Convert.ToDouble(ETad2.Text.Replace(",", "."), CultureInfo.GetCultureInfo("en-US"))
        Call fzSetArrayValueD(AdrAD, 2, rd)

        
        resz.re = 0
        resz.im = 0

        nc = ETC.Text

        If Ch1.Checked Then
            nc = 1
        End If
      


        ct = fz_COMPLEX
        If ChRC.Checked Then
            ct = fz_REAL
        End If
        Call fzSet(fz_CALC_TYPE, ct)


        Call fzCompile(ETF.Text, FZ1)
        Call fzGetSyntaxErrorCode(ECode)

        If ECode = 0 Then

         Try

            Call fzGet(fz_RESULT_TYPE, 0, rt)
            If rt = fz_NONE Then             'no return number  
                'z1=1+i; z2= z1*i; result=z1/z2
                'x=1; y=x*2; result=x/y
                T1 = GetTickCount
                For i = 1 To nc
                    fzResult(FZ1)
                Next
                T2 = GetTickCount

                Call fzGetVarValueCxD(AdrResZ, resz.re, resz.im)

            Else  'rt <> fz_none
                If ct = fz_REAL Then   'result - real number

                    T1 = GetTickCount
                    For i = 1 To nc
                        resz.re = fzResultR(FZ1)
                    Next
                    T2 = GetTickCount

                Else                   'result - complex number
                    'ct = fz_Complex; rt = fz_Real,fz_Complex

                    T1 = GetTickCount
                    For i = 0 To nc
                        'Call fzResultCxD(FZ1, ResZ.Re, ResZ.Im)
                        Call fzResultCxDP(FZ1, resz)
                    Next
                    T2 = GetTickCount

                End If
            End If





            If Abs(T2 - T1) = 0 Then
                LP.Text = "no define"
            Else
                LP.Text = Int((nc / (T2 - T1)) / 1)
            End If

            Sre = CStr(resz.re)
            Sim = CStr(resz.im)
            If resz.im < 0 Then
                SRez = Sre + "  " + Sim + "i"
            Else
                SRez = Sre + "     " + Sim + "i"
            End If



            LR.Text = SRez

            Catch ex As Exception
               LR.Text = ex.ToString
            End Try
        

        Else
            Call ErrorHandle()
        End If



endp:

        If ECode = 0 Then Call fzPerform(fz_FREE, FZ1)





    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim ECode As Integer

        Call fzSetFunction(ETEF.Text, 0)
        Call fzGetSyntaxErrorCode(ECode)
        If ECode <> 0 Then Call ErrorHandle()
    End Sub

Private Sub LR_Click( ByVal sender As System.Object,  ByVal e As System.EventArgs) Handles LR.Click

End Sub
End Class
