﻿unit Foreval_Main;

{******************************************************************************}
{                                                                              }
{                                 ver 9.1.1.366                                }
{----------------------------------------------------------------------------- }
{ Cинтаксический анализатор, компилятор выражений.                             }
{ Символьное дифференцирование                                                 }
{------------------------------------------------------------------------------}
{  Parser , compiler of expressions. Symbolic differentiation                  }
{------------------------------------------------------------------------------}
{                  SOREL   (C)CopyRight 2000+. Russia, S.-Petersburg.          }
{******************************************************************************}




//{$RangeChecks On}          //{$R+}
//{$OverFlowChecks On}       //{$Q+}
//{$ZEROBASEDSTRINGS Off}

{$R-}
{$Q-}


{$IFDEF FPC}
  {$MODE DELPHI}
{$ENDIF}



{.$DEFINE DEBUGS}            //db

interface

uses
  Windows,  SysUtils, StrUtils, {Math,}  Foreval_Command, Foreval_SpecFunc {,Classes,  Dialogs, Forms, Controls, StdCtrls};

   const  CWFPU: WORD = $1372;
  const _PI:extended = 3.1415926535897932384626433832795;
  const  PI_2: extended = 3.1415926535897932384626433832795*0.5;

  const rPI: extended = 3.14159265358979323846264/180;
  const dPI: extended = 180/3.14159265358979323846264;

  const  C1: double = 1;
  const C_MaxCardinal: cardinal = 4294967295; //2147483647

  //.NCOP = Alg.Opr[i]
  //Tree.COP
  const  _NOP = 0;      //COP=_NOP : узлы не компилируются
  const  _LDSF = 3;
  const  _LDSC = 4;
  const  _FUNC = 1;
  const  _COP  = 2;
  const  _JMP  = 5; //String Name: #JMP, #JMPE, #JMPEL, #JMPEB, #JMPB, #JMPL, #JMPNE
  const  _FLD  = 6; //FLD1,FLDZ
  const  _LDSCX = 7;
  const  _LDINTFORM = 8;
  const  _LDSA = 9; {.347}

  {.193}
  //const  _LDSV = 5;

  const __VarType  = 7;
  const  T_Real    = 1;
  const  T_Complex = 2;
  const  T_Array   = 3;
  const  T_Integer = 4; //пока не используется. ВВедён для целочисленных функций и выражений, возращающих тип Integer через  EAX
  const  T_None    = 5;
  const  T_Void    = 6;  //как T_None, только для внутренних ф-ий
  const  T_Pointer = 7; {.347}
  const  T_Any  =   -1;   {.324}  //виртуальный тип, подразумевает использование любого вместо себя. В ходе разбора преобразуется в конкретный тип.

  const __MathType = 5;
  const _Single    = 1;
  const _Double    = 2;
  const _Extended  = 3;
  const _Integer   = 4;
  const _Pointer   = 5;


  const _Internal = 1;
  const _External = 2;

  const _None = 0;
  const _Const = 1;     {всегда только Действительная(Real)!! константа. Комплексная - _ConstComplex}
  const _Var = 2;
  const _FloatVar = 3;
  const _IntVar = 4;
  const _IntConst = 5;
  const _IntForm = 6;
  const _FloatArg = 7;
  const _IntArg = 8;
  const _ComplexVar = 9;
  const _Stack  = 10;
  const _IntArray = 11;
  const _FloatArray = 12;
  const _ComplexVarRE = 13;
  const _ComplexVarIM = 14;
  const _ConstComplex = 15; {.361}

  const  Sh_S = 4;
  const  Sh_D = 8;
  const  Sh_E = 16; //сдвиг к полю .im от поля re.; Размерность числа типа Extended в TComplex, TComplexE; Размерность  половины ячейки стека.(TByte32 )

  const _JNZ  = 7;
  const _JNB  = 3;
  const _JZ   = 2;
  const _JBE  = 4;
  const _JB   = 5;
  const _JNBE = 6;


  //const S_IM_UNIT: String = 'i'; //i,I - imaginary unit
  //const S_CON: String = '_'; //z_ =(x,-y)

  const _AddrVar       = 10;
  const _AddrArray     = 11;
  const _AddrFunc      = 12;
  const _PointerVar    = 13;
  const _PointerArray  = 14;
  const _Array         = 15;
  const _AddrArrayElem = 16;
  const _LoadArrayElemFPU  = 17;
  const _LoadArrayElemAddr = 18;
  const _LoadIntArrayElemEAX =19;



  const _STACK_ADDR = 1;
  const _STACK_VAL = 2;
  const _MEMORY_ESP = 4;
  const _MEMORY_EAX = 5;
  const _STACK_INFINITE   = 6;
  const _INTERNAL_INFINITE_ANY = 7; //любое число аргументов с любым типом (исп-ся при оптимизации и #prog)
  const _COMPILED = 9;




  const _Real     = 1;    //=T_Real     !!!
  const _Complex  = 2; //=T_Complex  !!!

  const  _RE = 1;
  const  _IM = 2;
  const _RIGHT = 1;
  const _BACK = 2;
  const _INFINITE = -1;

  const  _YES  = 1;
  const  _NO  = 2;
  const  _ANY  = -1;
  const  _NOT_FOUND = -1;   // = -1 !!!
  const  _ABSENT  = -1;     // = -1 !!!
  const  _POSITIVE = 3;
  const  _NEGATIVE = 4;
  const  _DELETED  = 5; //<> _YES,_NO!!!
  { _ABSENT =  _NOT_FOUND = -1 !!! }

  //const  CM_NOP = -1;


  const  _Enable  = 1;
  const  _Disable = 2;
  const  _Auto    = 3;

  const  _New = 10;
  const  _ReWrite = 20;
  const  _NewOverload = 30;
  //const  _NewIntrnl = 40;
  //const  _NewOverloadIntrnl = 50;

  const  _ADDR = 1;
  const  _CALL_TYPE = 2;
  const  _PRESENT_VAR = 3;

  const C_None = 0;
  const C_Real = 1;      // = T_Real !!!
  const C_Complex = 2;   // = T_Complex !!!
  const C_Image = 3;


  const _First = 1;
  const _Second = 2;
  const _Both = 3;

  const _between = 1;
  const _after   = 2;
  const _before  = 3;

  {.345}
  // M_DIV_MODE =
  const _fast      = 1;
  const _standard  = 2;
  const _accurate  = 3;
  const _extra     = 4;



 // заменить на WriteDataA()
 // const S_10:extended = 10;
  const S_2:extended = 2;
  const S_c2: double = 2;
  const S_c3: double = 3;
  const S_c1: double = 1;
  const S_c1n: double = -1;
  //const S_c1x: extended = 1;
 // const S_C05: double = 0.5;

 const _add = 10;
 const _sub = 20;
 const _mul = 30;
 const _div = 40;
 const _num = 50;

  //1 - EAX; 2 - EBX; 3 - ECX; 4 - EDX; 5 - ESP; 6 - EBP; 7 - ESI; 8 - EDI;
  const R_EAX = 1;
  const R_EBX = 2;
  const R_ECX = 3;
  const R_EDX = 4;
  const R_ESP = 5;
  const R_EBP = 6;
  const R_ESI = 7;
  const R_EDI = 8;

  const R_MEM = 100;

  const rf_FULL_REPLACE = 100; // > than other: !!
  const rf_FULL_REPLACE_XCH = 99;
  const rf_NO_REPLACE =0;
  const rf_EXPR1_REPLACE = 2;
  const rf_EXPR2_REPLACE = 3;
  const rf_INVERSE_REPLACE = 4;
  const rf_COSSINR_REPLACE = 5;
  const rf_EXPZ1_REPLACE = 6;
  const rf_EXPZ2_REPLACE = 7;
  const rf_INVERSEZ_REPLACE = 8;
  const rf_SINR_REPLACE = 9;
  const rf_COSR_REPLACE = 10;
  const rf_ARCCOSR_REPLACE = 11;
  const rf_ARCSINR_REPLACE = 12;
  const rf_ARCTANR_REPLACE = 13;
  const rf_ARCCOTANR_REPLACE = 14;
  const rf_ARCSINZ_REPLACE = 15;
  const rf_ARCCOSZ_REPLACE = 16;
  const rf_ARCTANZ_REPLACE = 17;
  const rf_ARCCOTANZ_REPLACE = 18;
  const rf_ARCSECR_REPLACE = 19;
  const rf_ARCCOSECR_REPLACE = 20;
  const rf_ARCSECZ_REPLACE = 21;
  const rf_ARCCOSECZ_REPLACE = 22;



  const  _MEM = 20;
  const  _FPU = 21;

  const M_Compile: Integer = 10;      {.197}
  const M_DinamicLoad: Integer = 20;   {.197}
  const M_EvalDataCellNum: Integer = 30;
  const M_XchBranch = 40;
  //const M_Diff = 50;
  const M_ParseDiffExpr = 50; {.325}

  //const CmplParamName: String = '@cp';

const
  IM_UNIT =        10;
  D_Real =         11;
  E_Real =         12;
  D_Complex =      13;
  E_Complex =      14;
  D_Any  =         15;
  E_Any =          16;
  D_Array_Real =   17;
  E_Array_Real  =  18;
  I_Array_Real =   19;
  I_Real =         20;
  S_Real =         21;
  S_Complex =      22;
  I_Pointer =      23;
  S_Array_Real =   24;
  Any_Const =      30;
  NO_Const =       40;


const //F_TypeOfNode =
 N_End    = 1;
 N_Parent = 2;

const
  E_UNKNOWN_SYMBOL = 1  ;
  E_MISSING_ROUND_BRACKET = 2 ;
  E_MISSING_OPERATION = 3 ;
  E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS = 4 ;
  E_MISSING_EXPRESSION = 5 ;
  E_UNKNOWN_FUNCTION = 6 ;
  E_ABSENT_FUNCTION_FOR_LOAD_TYPE = 7 ;
  E_NOT_DEFINED_OPERATION_FOR_TYPE = 8 ;
  E_NOT_DEFINED_FUNCTION_FOR_TYPE = 9 ;
  E_UNKNOWN_ARRAY = 10 ;     {.323}
  E_INTERNAL_ERROR = 12;
  E_ERROR_AT_ADDITION_OF_FUNCTION = 11 ;
  E_WRONG_TYPE = 14 ;
  E_WRONG_NAME = 15 ;
  E_MISSING_SQUARE_BRACKET = 16 ;
  E_MISSING_CURLY_BRACKET = 17 ;
  E_MISSING_ABS_BRACKET = 18 ;
  E_MISSING_SEPARATOR = 19;
  E_WRONG_EXPRESSION  = 20;
  E_INTERNAL_ERROR_AT_CALCULATION  = 21;
  E_INCORRECT_ARGUMENT   = 22;
  E_INCORRECT_SPACE = 23;   {.195}
  E_VARIABLE_REDECLARED = 24; {.245}
  E_NO_DIFF_EXPRESSION = 25;
  E_WRONG_PASSED_DATA = 26;
  E_INTERNAL_ERROR_AT_DIFF = 27; {.326}
  E_VOID_EXPRESSION = 28; {.333}
  E_WRONG_SYMBOL    = 29; {.333}
  E_NO_RETURN_NUMBER     = 30; {.347}
  E_PROHIBITED_SYMBOL = 31; {.347} //#,$, |
  E_NO_FUNCTION_ARGUMENT = 32;
  E_NO_APPLICABLE_TO_EXTERNAL_ARRAY = 33;





   {.229}
   E_ZeroDivide = 25;
   E_InvalidOp = 26;
   E_OverFlow = 27;
   E_UnderFlow = 28;
   E_IntOverFlow = 29;
   E_AccessViolation = 30;
   E_OutOfMemory  = 31;
   E_StackOverFlow = 32;



  //номера функций в Alg.ExtFunc[N]
  const  CM_ADD = 0;
  const  CM_SUB = 1;
  const  CM_MUL = 2;
  const  CM_DIV = 3;
  const  CM_POWER = 4;
  const  CM_NEG = 5;
  const  CM_LOGN = 6;
  const  CM_ABS = 7;
  const  CM_RE = 8;
  const  CM_IM = 9;
  const  CM_ARG = 10;
  const  CM_SIN = 11;
  const  CM_COS = 12;
  const  CM_TAN = 13;
  const  CM_COTAN = 14;
  const  CM_ARCCOS = 15;
  const  CM_ARCSIN = 16;
  const  CM_ARCTAN = 17;
  const  CM_ARCCOTAN = 18;
  const  CM_SINH = 19;
  const  CM_COSH = 20;
  const  CM_TANH = 21;
  const  CM_COTANH = 22;
  const  CM_ARCCOSH = 23;
  const  CM_ARCSINH = 24;
  const  CM_ARCTANH = 25;
  const  CM_ARCCOTANH = 26;
  const  CM_LN = 27;
  const  CM_EXP = 28;
  const  CM_SQR = 29;
  const  CM_SQRT = 30;
  const  CM_FACT = 31;
  const  CM_LOG10 = 32;
  const  CM_LOG2 = 33;
  const  CM_ROOT = 34;
  const  CM_IPWR  = 35;
  const  CM_IPWR16 = 36;
  const  CM_TRUNC = 37;
  const  CM_CON = 38;
  const  CM_FRAC  = 39;
  const  CM_NORM = 40;
  const  CM_SUM = 41;
  const  CM_AVR   = 42;
  const  CM_SUMQ   = 43;
  const  CM_LEN   = 44;
  //////////45///////////
  const  CM_MAX   = 46;
  const  CM_MIN   = 47;
  const  CM_PROD   = 48;
  const  CM_MOD  = 49;
  const  CM_F2PWR  = 50 ;
  const  CM_COMPLEX = 51;
  const  CM_SIGN   = 52;
  const  CM_IPWRSGN = 53;
  const  CM_LDSVX  = 54;
  const  CM_IFin   = 55;
  const  CM_IF  = 56;     //#if
  const  CM_FACT2  = 57;
  const  CM_NOP  = 58;
  const  CM_SAVEin = 59;
  const  CM_SAVE = 60; //#save
  const  CM_JMP = 61;
  const  CM_INC = 62;
  const  CM_DEC = 63;
  const  CM_DECART = 64;
  const  CM_DEG = 65;
  const  CM_RAD = 66;
  const  CM_DEV = 67;
  const  CM_DEVS = 68;
  const  CM_SETLENin = 69;
  const  CM_SETLEN = 70;   //#setlen
  const  CM_ARCTAN2 = 71;
  const  CM_COSSIN = 72;
  //const  CM_SINCOS = 73;
  const  CM_SWAPin = 74;
  const  CM_POLYin  = 75;
  const  CM_POLY  = 76;    //#polynom
  const  CM_RANDin  = 77;   {.203}
  const  CM_GCD         = 78;
  const  CM_LCM         = 79;
  //const  CM_ERF         = 80;
  //const  CM_ERFC        = 81;
  const  CM_SEC        = 82;
  const  CM_COSEC        = 83;
  const  CM_SECH        = 84;
  const  CM_COSECH        = 85;
  const  CM_ARCCOSECH  = 86;
  const  CM_ARCSECH    = 87;
  const  CM_ARCCOSEC   = 88;
  const  CM_ARCSEC     = 89;
  const  CM_MAX23     = 90;
  const  CM_MIN23     = 91;
  const  CM_AVR23     = 92;
  const  CM_NORM23     = 93;
  const  CM_TRY      = 94;
  const  CM_EXCEPTION      = 95;
  const  CM_POLYDIFFin   = 96;
  const  CM_POLYDIFF    = 97;
  const  CM_POLYDIFFN    = 98;
  const  CM_VOID          = 99;
  const  CM_PROG          = 100;
  const  CM_IROOT        = 101;
  const  CM_DIFFNUMERIC  = 102;
  const  CM_SUMPin         = 103; {.333}
  const  CM_SUMPSin        = 104; {.333}
  const  CM_SUMP           = 105; {.333}
  const  CM_SUMPS          = 106; {.333}
  const  CM_CALLR          = 107; {.347}
  const  CM_CALLCX         = 108; {.347}
  const  CM_CALL           = 109; {.347}
  const  CM_POLYU          = 110; {.347}
  const  CM_SWAP           = 111; {.347}
  const  CM_ADDR           = 112;
  const  CM_IDIV           = 113;
  const  CM_SWAPIFin       = 114;
  const  CM_SWAPIF         = 115;
  const  CM_SUMI           = 116;
  const  CM_PRODSin        = 117;
  const  CM_PRODS          = 118;
  const  CM_IMUIPWR        = 119;
  const  CM_IMURZPWR       = 120;
  const  CM_CZPWR          = 121;
  const  CM_REUNEGIPWR     = 122;
 // const  CM_REUNEGFPWR     = 123;


  const  CM_LENGTH = 123;     //Lengt of List Command = Last+1


  const BeforeProcEnableSymb = [',',';','>','(','{','[','@'];                                        //{.346}  {.353}
  const BeforeFuncEnableSymb = [',',';','>','(','{','[','|','+','-','*','/','^','=','<','$','@'];       //{.346}{.353}
  const AfterProcEnableSymb =  [',',';',')','}',']'];
  const AfterFuncEnableSymb =  [',',';',')','}',']','|','+','-','*','/','^','=','<','>','!','.'];       //{.346}  '.' = .re .im

  const BeforeProcDisableSymb =  ['+','-','*','/','^','|','=','<','$'];                                        //{.346}
  const AfterProcDisableSymb  =  ['+','-','*','/','^','|','=','<','>','.','!','$'];

  const ProhibitedSymb        =  ['#'];  //используются для внутренних имён

  const OpenBracket     = ['(','{','['];   //нет скобок модуля. "|" - должны быть заменены перед поиском!
  const CloseBracket    = [')','}',']'];   //нет скобок модуля. "|" - должны быть заменены перед поиском!

  const DisableSimbInName = ['(',')','{','}','[',']','|','*','/','>','<','=','+','!','@','^',':','-','.',',','$','#','&','%',';','?',' '];
  const EnableNameSymb = ['A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z','1','2','3','4','5','6','7','8','9','0','_'];

  const Operation2Arg  = ['*','/','+','-','^'];

  const DiffNumFunc = '#diff';  //имя функции численного дифф-я
  const SCdiff1 = '#diff1';
  const SCdiff2 = '#diff2';
  const SCdiff3 = '#diff3';
  const SCdiff4 = '#diff4';
  const SCdiffn = '#diffn';

  const SCsave = '#save';
  const SCprog = '#prog';
  const SCvoid = '#void';
  const SCnop  = '#nop';
  const SCif   = '#if';
  const SChidden = '#hidden';



  //const  C_IPWR = 53;


type TVar = record
              adr: Cardinal;
              TV:  Integer;   //D_Real, E_Real, D_Complex, E_Complex, IM_UNIT
            end;

type
TAddress = Cardinal;

type TFloat = extended; {всегда !! extended} //тип переменных

type PFloat = ^TFloat;

type TArrayF = array of TFloat;

 {
  WARNING!!! SizeOf(TComplexE,TComplex) = 32b! Size of each field (re,im) = 16 b (instead 10b)!!!
  Be shure, that your compiler do correctly set size of TComplexE,TComplex otherwise to be error!
}
type
TComplex =  record
               re: TFloat;
               im: TFloat;
              end;

type
TComplexD =  record
               x: double;
               y: double;
              end;


type
TComplexE =  record
               x: extended;
               y: extended;
              end;
type
TByte32 = record
            re:   double;
            re2:  double;
            im:   double;
            im2:  double;
           end;


type
TStack = array of TByte32;// TComplexE;            {.203}
//sh_E - размерность половины ячейки стека

{
TComplexE (в стеке) заменен на TByte32 из-за непредсказуемой  компяляции Delphi типа TComplexE:
 в одном случае полей  размерность полей 16+16, в другом: 10+10   ?!?!?!?!
}


type TStack16 =  record             //for align on 16
                    r1: Double;
                    r2: Double;
                   end;

type TArray16 =  array of TStack16;

type
TArray4 = array [1..4] of byte;
type TCode = array of Byte;




type TArrayI = array of Integer;
type TArrayC = array of Cardinal;
type PArrayI = ^TArrayI;
type TArrayD = array of Double;
type TArrayE = array of extended;

type TIntType = array of Cardinal;

type TArrayI2 = array of array of Integer;



type TIntVarProd =  record
                      NV: TArrayI;
                      //IC: TArrayI;
                      A: Integer;
                      //B: Integer;
                 end;

type TArrayIntVarProd = array of  TIntVarProd;

{.347}
type TPolyCoeff = record
                     Re:  Extended;
                     Im:  Extended;
                   indx:  Integer;
                     tc:  Integer;
                  end;

type TArrayCP = array of  TPolyCoeff;

{.324}
type
TAttrib = record
            FType:    Integer; //тип сохраняемого результата
                            //RType = _Double,_Integer,_Extended,_Single
            AddrRE:   Cardinal; //адрес сохраняемого результата (непосредственный - Address)
            AddrIM:   Cardinal; //адрес сохраняемого результата (непосредственный - Address)
          end;



type TFIN =      record
                  NV: Integer;
                  A: Integer;
                  B: Integer;
                 end;

type
 TTableRF = record
               WRF_R: integer;
               RRF_R: integer;
               WRF_Z: integer;
               RRF_Z: integer;
               NMEM_R:  integer; //?? число ячеек для сохранения промежуточных результатов
               NMEM_Z:  integer; //?? число ячеек для сохранения промежуточных результатов
               SHFT_R:  integer;
               SHFT_Z:  integer;
            end;


type TIntFunc  = //array of
                  record
                   TypeF:   Integer;          //возвращаемый тип ф-ии  T_Real,T_Complex,T_None, T_Array{.353}
                   TypeM:   Integer;         //возвращаемый математический тип ф-ии (_Extended,_Double,_Integer,_Single,_Pointer) {.353}
                                               // Используется для TypeF = T_Array. Для остальных по умолчанию - _Extended
                   CallT:   Cardinal;          //тип вызова(_ESP,_EAX,_STACK,_STACK_INFINITE,_STACK_INFINITE_A)
                   CLST:    Cardinal;          //очистка стека
                   Arrow:   Cardinal;          //направление передачи параметров _RIGHT,_BACK
                   Addr:    Cardinal;             //адрес ф-ии
                   SDeep:   Integer;           //загрузка стека
                   IntF:    Integer;           //= _Internal(внутренняя ф-ия); = _External(внешняя)
                   ExeF:    Integer;           //=_Yes,_No - исполняемая функция или шаблон(для разбора)
                   XchArg:  Cardinal;          //Запрет на изменение порядка аргументов при оптимизации обмена ветвей: TreeOptimizator. Переставляет аргументы местами
                                               //=_Yes,_No (=_Yes только для CM_ADD, CM_SUB, CM_MUL, CM_DIV)
                   NArg:    Integer;              //число переменных. N=-1,-2 Infinite (-1: аргументы одного типа(_STACK_INFINITE);-2(_STACK_INFINITE_A): аргументы могут быть разного типа)
                   TV:   TArrayI;//array of Cardinal;    //массив типов переменных    (T_Real,T_Complex,T_Array,T_Pointer)  (Size=N)
                   TM:   TArrayI;//array of Cardinal;    //массив машинных типов переменных    (_Double,_Extended,_Integer,_Pointer)   (Size=N)
                   ArgAdr:  TArrayI;           //адреса переменных для ф-ии fl_PRECOMPILED
                   DFTmpl: Integer;             //_YES,_NO:  TemplateDiffFunc = yes,no       {.301}
                   TemplateDiffFunc: String;    //строковой шаблон производной               {.301}
                   CalcConst: Integer;         //_YES -вычислять ф-ию при постоянных аргументах ; _NO - нет
                   ReplFunc: Integer;          //_Yes/_No,0: может замещаться/нет      {.193}
                   SaveReg: Cardinal;          //сохранение используемых регистров: eax,ebx,ecx,edx,esp,ebp,esi,edi, используется 8 бит
                                              //1 - EAX; 2 - EBX; 3 - ECX; 4 - EDX; 5 - ESP; 6 - EBP; 7 - ESI; 8 - EDI;
                   Id_Func:  Integer;  //идентефикатор
                   Set_ID:  Integer;  //разрешение использования идентефикатора :  _Yes, _No
                   Enable: Integer;   //_Yes, _No
                   Place: Integer;  //_New, _ReWrite  {.308}
                   CodeSize: Cardinal;               {.365}
                   IsInline: Integer; //_YES, _NO   {.365}
                  end;

type TIntFuncA = array of TIntFunc;

type TAlgFunction = array of
                      record
                       Name: String;        //имя ф-ии
                       NameEx: array of String; //дополнительные имена функции  {.191}
                       Func: TIntFuncA;      //характеристики ф-ий с данным именем
                       Enable: Integer;   //_Yes, _No
                       XchArg:  Cardinal;          //=_Yes,_No (=_Yes только для CM_ADD, CM_SUB, CM_MUL, CM_DIV)
                       ReplFunc: Integer;          //_Yes/_No,0: может замещаться/нет      {.193}
                       ReplFuncCFZ: Integer;    //_Yes/_No,0: может частично (ReplFuncCF) замещаться/нет  {.217}
                       ReplFuncCFR: Integer;    //_Yes/_No,0: может частично (ReplFuncCF) замещаться/нет      {.217}
                       //только для дифф.:
                       //DFTmpl: Integer;   //_YES,_NO:  TemplateDiffFunc = yes,no       {.301}
                       //TemplateDiffFunc: String; //строковой шаблон производной {.301}
                       //NArg: Integer;     //число переменных вместо Alg.ExFunc[NFunc].Func[0].N   {.301}
                      end;





            {GS -> Pos =  _Before, _After,
            SE убрать
            Настройки F_SyntaxExtension для каждой в отдельности: операции скобки}
type TAlgOperation = array of
                      record
                       PR:  Cardinal;     //приоритет операции  (кроме '0'!)            Operation priority (except ' 0 '!)
                       Name:  String;     //имя символьной операции
                       NFunc: Cardinal;   //номер массива соответствующей ф-ии
                       NArg: Integer;
                       Pos:  Integer;
                       LenOp: Integer; {.340}
                       Enable: Boolean;   {.339}
                       //GS: Integer;  //для одноарг. операций: расположение ((-1)впереди;(-2)сзади) для многоарг. операций: >= 0!  For one-argument operations: place ((-1) before; (-2) behind) for many-argument operations:> = 0!!!
                       //SE:  Integer;     //F_SyntaxExtension(=1)
                      end;


                      //приоритет любой одноарг. операции выше любой многоарг. операции !!!
                      //Priority any one-argument operations above any many-argument operations



type TAlgObject = array of
                   record
                    Name: String;      //имя переменной
                   TypeF: Cardinal;    //тип переменной  (T_Real,T_Complex,T_Array,T_Pointer)
                    Addr: Cardinal;    //её адрес
                  AddrIM: Cardinal;    //адрес мнимой части, если подключение по несвязным адресам   {.343}
                   MType: Cardinal;    //математический тип: _Double,_Extended,_Integer,_Pointer
                  IsUsed: Cardinal;    //_YES,_NO    {.333}
                TypeCnct: Cardinal;    //тип подключения: внутренний, внешний = _Internal, _External {.357}
                   end;

type TListSetVar = array of
                   record
                    //Name: String;

                    MType: Cardinal;         //_Double,_Extended,_Integer,_Pointer
                    Addr: Cardinal;    //
                    //TypeF: Cardinal;          //тип переменной  (T_Real,T_Complex,T_Array,T_Pointer)
                    //AddrIM: Cardinal;    // {.343}

                    //IsUsed: Cardinal;         //_YES,_NO    {.333}
                   end;


 {.311}
type TAlgParam = array of
                   record
                    Name: String;
                    Real: Extended;
                    Imag: Extended;
                   TypeF: Cardinal;          //тип параметра  (T_Real,T_Complex)
                   //MType: Cardinal;         //_Double,_Extended
                   end;


type TAlgLoadFunction = array of
                        record
                         TypeF: Cardinal;    //тип переменной для загрузки
                          Addr: Cardinal;
                          Name: String;     //для ошибок
                         end;




type
 PFunc      = ^TFunc;




 TFunc = record
               NL: Cardinal;               //порядковый номер комманды на уровне
               NM: Cardinal;              //номер (в массиве Interp) главного узла    //В версии 9+ не используется
               S:  Cardinal;               //Stack
               N:  Cardinal;               //Node
           TypeF:  Integer;               //возвращаемый тип
           TypeM:  Integer;              //возвращаемый математический тип ф-ии (_Extended,_Double,_Integer,_Single,_Pointer) {.353}
                                           // Используется для TypeF = T_Array. Для остальных по умолчанию - _Extended
           TypeA:  Cardinal;               //тип аргумента (исп-ся при оптимизации арифм. комманд)
             COP:  Cardinal;
           NFunc:  Cardinal;               //номер массива ф-ий
              NF:  Cardinal;               //номер ф-ии в массиве
            NObj:  Cardinal;               //номер массива переменных
              FD:    TFloat;               //константа
              FD1:   TFloat;               //константа   вспомогательная, исп-ся при оптимизации некоторых команд
              FD2:   TFloat;               //константа   вспомогательная, исп-ся при оптимизации некоторых команд
              FDC:   TComplex;             //константа
              FI:  Integer;
             Arg:  Cardinal;               //числу переменных (для infinite)
             IdN:    Cardinal;     //идентефикатор узла: = порядковому номеру узла (все разные)
             IdL:    Cardinal;     //идентефикатор уровня: Idl всех узлов на одном уровне равны и =  Idn родительского узла
        ArgTypes:  TArrayI;                 //типы переменных для функций с TIntFunc.N=-2(_STACK_INFINITE_A)
           SData:  Integer;                 //нахождение операнда в памяти/FPU  в режиме DinamicLoad
           RData:  TArrayI;                 //нахождение аргументов  в памяти/FPU  в режиме DinamicLoad
          SData1:  Integer;                 //нахождение операнда в памяти/FPU  в любом режиме
           MEM:    Cardinal;
             NC:   Cardinal;   //номер  ICOMP[NC] начала комманды
             CS:   Cardinal;  //размер кода в байтах данного узла + размер кода всех вытекающих узлов
            NCP:   Cardinal;  //размер кода в байтах данного узла
             NV1:    Integer;//TVar;
             NV2:    Integer;//TVar;
             AI:     Integer; //control
             CI:     Integer; //control
            RRF:    Integer;    //=1 замещена и должна считывать рез-т                     {.193}
            WRF:    Integer;    //=1: сохраняет рез-т для замещения других ф-ий              {.193}
            NRF:    Integer;    //=числу функций, считывающих рез-т (если сохраняет рез-т)    {.193}
            MRF:    Integer;    //=номер ячейки в RFStack  с рез-ом                            {.193}

            //RRF1:   Integer;    //= rf_ замещена и должна считывать рез-т                     {.217}
            WRF_CS:   Integer;    //= rf_: сохраняет рез-т для замещения других ф-ий              {.217}
            //NRF1:   Integer;    //=числу функций, считывающих рез-т (если сохраняет рез-т)    {.217}
            MRF_CS:   Integer;    //=номер ячейки в RFStack  с рез-ом                            {.217}
            MWF_CS:   Integer;    //=номер ячейки в RFStack  с рез-ом                            {.217}

             TS:   Integer;  //_RE,IM,0
             TS1:    Integer;     //_RE,_IM,0
             TS2:    Integer;      //_RE,_IM,0
             TC:     Integer; //C_None,C_Real,C_Image,C_Complex
             Inv:  Integer;               //исп-ся при оптимизации в арифметич. ком-ах
             VFP:   TArrayCP; {.347}// TArrayF;   //коэфф. полинома {.207}
          ExtArg:  Integer;   //если команда является аргументом внешней ф-ии, то ExtArg = выталкиваемому типу этого аргумента  (либо нет = 0); исп-ся при компиляции
          ExpressionArg: String;
          Expression: String;
         end;


type
TArrayOfPFunc = array of PFunc;

type
TArrayOfTFunc = array of TFunc;

type
   PFuncData = ^TFuncData;
   TFuncData = record
                FData: Extended;
                Next:  PFuncData;
               end;


type
TFunction = record
                   Code:  TCode;      //exe byte code
                   Data:  PFuncData;  //data of expr. (numeric const. of expr.)
                   Stack: TStack;     //stack of expr. for temp. result(use in DinLoad)  ; for align on 16  //стек выражения для сохранения промежуточных вычислений
                 RFStack:  TArray16;  //stack of expr. for temp. result(use in Replace)  ; for align on 16  //память выражения для сохранения результатов 'Replace'
                   Addr:  TAddress;   //begin addr of exe   {.193}
                   PAddr: Pointer;    //pointer to begin addr of exe {.193}
                CodeSize: Cardinal;   //size of code   (exe code can be moved )  {.193}
                AllocMem: Integer;    //= 1(compile with delphi/fpc memory manager): memory is allocated by SetLength(TFunction.Code,Size) (GetMem) {.193}
                  end;                //= 2(compile with windows (WinXp SP2+)memory manager): memory is allocated by VirtualAlloc  :TFunction.Code=nil
                                      //    setting by fl_USE_VIRTUAL_ALLOC, use this mode with MSVC



type PFunction = ^TFunction;

type TNStack = record
                S: Cardinal; //текущий номер стека
                N: Cardinal; //число вытекающих узлов
              end;


type
PNode = ^TNode;
TNode = record
         Stack: TNStack;
         S:  Cardinal;        //Номер ячейки cтека для сохранения результатов вычисления  узла.   (Stack)
         N:  Cardinal;        //Число вытекающих узлов  (Node)
         SDeep:  Cardinal;    //Глубина FPU для данного узла
         NNode:  Cardinal;    //порядковый номер узла в линейном (последовательном) списке.  Создаётся в InitSequentList; Используется только для отладки.
         IdN:    Cardinal;    //В версии 9+ не используется
         IdL:    Cardinal;    //В версии 9+ не используется
         NL:     Cardinal;    //порядковый (последовательный) номер команды на уровне (составляющая уровня); отсчет с 1 ; Главный узел: NL=0. Создаётся в SetNL.
         NCOP:   Cardinal;           //операция (номер массива) (составляющая узла);
         NFunc:  Cardinal;           //ф-ия (номер массива ф-ий; same names)
         NF:     Cardinal;           //ф-ия (номер массива в массиве ф-ий (same names) (for overload: different arguments))
         NObj:   Cardinal;           //номер массива переменной (исп-ся для массивов)
         NObj2:  Cardinal;           //номер массива переменной (исп-ся для массивов)
         COP:    Integer;            //COP: = 1(ф-ия) в Func номер массива ф-ий;
                                     //2(операция) в NCOP номер массива;
                                     //3(загрузка переменной) в NObj - номер массива;
                                     //4(загрузка константы) в FD - константа;
         FD:     TFloat;             //константа
         FD1:     TFloat;             //константа
         FD2:     TFloat;             //константа
         IC1:    Integer;             //константа
         IC2:    Integer;             //константа
         Expression:    String;//AnsiString;//String;
         ExpressionArg: String;//AnsiString;//String;
         SDiff:  String; {.301}
         TypeF: Integer;       //тип возвращаемого результата  T_Real, T_Complex,T_None, T_Array  {.353}
         TypeM: Integer;       //возвращаемый математический тип  (_Extended,_Double,_Integer,_Single,_Pointer) {.353}
                                    // Используется для TypeF = T_Array. Для остальных по умолчанию - _Extended
         TypeA:  Cardinal;       //тип аргумента :исп-ся при оптимизации в арифметич. ком-ах с одним аргументом т.к в них возвращаемый тип определяется кроме типа аргумента также и типом константного аргумента, встроенного в команду
         Inv: Integer;               //инверсная (обратная) операция:  (исп-ся при оптимизации в арифметич. ком-ах CM_SUB, CM_DIV, )
         XchArg: Boolean;
         NV1:    Integer;//TVar;       (исп-ся для переменных)
         NV2:    Integer;//TVar;       (исп-ся для переменных)
         TA1:    Integer;             //тип аргумента {исп-ся с целочисленными арг.}
         TA2:    Integer;             //тип аргумента {исп-ся с целочисленными арг.}
         AI:     Integer; //control
         BI:     Integer; //control
         CI:     Integer; //control
         DI:     Integer; //control
         TS: Integer;    //_RE,_IM,0
         TS1:    Integer;     //_RE,_IM,0
         TS2:    Integer;      //_RE,_IM,0
         SData:  Integer;      //нахождение(сохранение) операнда (данного узла) в  MEM/FPU  в режиме DinamicLoad
         SData1:  Integer;     //нахождение операнда в MEM/FPU  в любом режиме
         RData: TArrayI;       //нахождение(чтение) аргументов (вытекающих узлов)  в MEM/FPU  в режиме DinamicLoad
         NM: Cardinal;       //В версии 9+ не используется
         FDC:    TComplex;
         TC:     Integer; //C_None,C_Real,C_Image,C_Complex   - constant type C_Real:FD;  C_Complex,C_Image: FDC.re,FDC.im
         VFP:    TArrayCP; {.347}//TArrayF;   //коэфф. полинома {.207}
         Arg:  Cardinal;               //числу переменных (для infinite)
         ArgTypes:  TArrayI;                 //типы переменных для функций с TIntFunc.N=-2(_STACK_INFINITE_A)   _INTERNAL_INFINITE_ANY
         ExtArg:  Integer;   //если команда является аргументом внешней ф-ии, то ExtArg = выталкиваемому типу этого аргумента  (либо нет = 0); исп-ся при компиляции
         ExtFunc: Integer;   {.309}// = NFunc, если является аргументом внешней ф-ии(NFunc) или _NOT_FOUND ; исп-ся для оптимизации IntForm
         NC:   Cardinal;   //номер  ICOMP[NC] начала комманды
         NCP:   Cardinal;  //размер кода в байтах данного узла
         CS:   Cardinal;  //размер кода в байтах данного узла + размер кода всех вытекающих узлов
         RRF:    Integer;    //замещена и должна считывать рез-т    (ранг чтения)                 {.193}
         WRF:    Integer;    // сохраняет рез-т для замещения других ф-ий  (ранг сохранения)            {.193}
         NRF:    Integer;    //=числу функций, считывающих рез-т (если сохраняет рез-т)    {.193}
         MRF:    Integer;    //=номер ячейки в RFStack  с рез-ом (полная замена)                           {.193}
         WRF_CS:   Integer;    //= rf_: сохраняет рез-т для замещения других ф-ий  (ранг)            {.217}
         MRF_CS:   Integer;    //=номер ячейки в RFStack  с рез-ом (частичная замена) (чтение)                          {.217}
         MWF_CS:   Integer;    //=номер ячейки в RFStack  с рез-ом (частичная замена)  (сохранение)                         {.217}

         Addr1:  TAddress; {.347} //call(Addr1)

         cif:    Integer;       {.301}
         tif:    Integer;       {.301}
         AIVP1:  TArrayIntVarProd; {.303}
         AIVP2:  TArrayIntVarProd; {.303}

         Ch:   PNode;   //child       ссылка от родителя всегда только на первого потомка (нижний левый)
         Nb:   PNode;   //neighbor    ссылка на соседа (брата)  из общего родительского узла (Node) - .Pr (потомки .Pr находятся на одном уровне)
         Pr:   PNode;   //parent      ccылка на родительский узел; у всех потомков вышестоящего родительского узла - .Pr она есть.
         Next: PNode;   //следующий  элемент  в последовательном линейном списке  дерева (создаётся в InitSequentList)
         Prev: PNode;   //предыдущий элемент  в последовательном линейном списке  дерева (создаётся в InitSequentList)
       end;

type
TDataNode = record
             N:      Cardinal;
             IdN:    Cardinal;
             NCOP:   Cardinal;
             NFunc:  Cardinal;     // Alg.ExFunc[NFunc].Func[NF]; номер главной ф-ии в массиве Alg.ExFunc. Определяется при разборе
             NObj:   Cardinal;
             NObj2:  Cardinal;
             COP:    Integer;
             FD:     TFloat;
             FD1:     TFloat;
             FD2:     TFloat;
             FDC:    TComplex;
             FX:     Extended;
             NV1:    Integer;//TVar;
             NV2:    Integer;//TVar;
             TA1:    Integer;
             TA2:    Integer;
             IC1:    Integer;             //константа
             IC2:    Integer;             //константа
             AI:     Integer; //control
             BI:     Integer; //control
             CI:     Integer; //control
             DI:     Integer; //control
             TS:     Integer;    //_RE,_IM,0
             TS1:    Integer;     //_RE,_IM,0
             TS2:    Integer;      //_RE,_IM,0
             TC:     Integer; //C_None,C_Real,C_Image,C_Complex
             NF:     Cardinal;  //   Alg.ExFunc[NFunc].Func[NF];  номер "overload" ф-ии  в массиве Alg.ExFunc[NFunc].Func . При разборе = 0; Определяется при связывании типов в LinkTreeData
             //VFP:    TArrayF;   //коэфф. полинома {.207}
             VFP:    TArrayCP;   //коэфф. полинома {.347}
             Addr1:  TAddress; {.347} //call(Addr1)
             cif:    Integer;     {.301}
             tif:    Integer;     {.301}
             AIVP1:  TArrayIntVarProd; {.303}
             AIVP2:  TArrayIntVarProd; {.303}
             ExpressionArg: String;
             Expression: String;
             SDiff:  String; {.301}
             TypeF: Integer;               //если возвращаемый тип определяется при разборе (иначе - LinkTreeData)
             TypeM: Integer;            //возвращаемый математический тип ф-ии (_Extended,_Double,_Integer,_Single,_Pointer) {.353}
                                          // Используется для TypeF = T_Array. Для остальных по умолчанию - _Extended
             Inv:   Integer;             //исп-ся при оптимизации в арифметич. ком-ах (=1: sub->subr; div->divr)
            end;

type
PDataNode = ^TDataNode;

type
TLevel = record
          NL:  Cardinal;               //порядковый номер комманды (составляющая уровня);   отсчет с 1
          IdL: Cardinal;
          COP: Integer; //
          ExtFunc: Integer; {.309}// = NFunc, если является аргументом внешней ф-ии(NFunc) или _NOT_FOUND ; исп-ся для оптимизации IntForm
          Expression: String;
          //ExtArg: Integer;
        end;

type PLevel = array of TLevel;



type TProcTree = procedure(Tree: PNode);
type TProcTreeObj = procedure(Tree: PNode) of object;
type TFuncTreeObj = function(Tree: PNode): Boolean of object;

type
TArrayS = array of String;



type
TAccFastFunc =  record
                   NFuncFast: Integer;
                   NFuncAcc: Integer;
                end;


type
TParamList = record
               Name: String;
               Value: TFloat;
             end;


type
TArrayPN = array of PNode;



{type
TArrayI = array of Integer;
}

type
TString1 = String[1];

type
TSetChar = set of char;


type
TDataArg = record
               Re1:   Extended;
               Im1:   Extended;
               ResT1: Integer;  //T_Real, T_Complex, NO_Const
               Re2:   Extended;
               Im2:   Extended;
               ResT2: Integer;   //T_Real, T_Complex, NO_Const
           end;




type
TAlgebra = record
             Name:  String;
            Types:  TArrayC;
              Obj:  TAlgObject;
            Param:  TAlgParam;
              Opr:  TAlgOperation;
           ExFunc:  TAlgFunction;
           //LdFunc:  TAlgLoadFunction;
          //Bracket:  TAlgBracket;
           end;


type TExternalException = procedure (TypeError: Integer); {of object;} stdcall;


type

  TForevalH = class



  private


    Alg: TAlgebra;
    CurrentExpression: String;              //текущее выражение
    CurrentDiffSubExpression: String;      //текущее дифференцируемое подвыражение
    //LFunc    : Cardinal;          //длина скомпилированного выражения
    LInterp: Cardinal;
    StackSize: Cardinal;          //размер стека памяти Func.Stack выражения  для сохранения результатов вычислений.
    ArgM : TArrayS;              //список аргументов в случае > 2 арг.(отсчёт с '0')
    Func: TFunction;                     //исполняемый код скомпилированного выражения
    //Interp: TArrayOfTFunc;
    FuncData,BFuncData: PFuncData;
    Tree: PNode;                                //дерево разбора выражения
    //F_SyntaxExtension:       Boolean; //вкл./выкл.: имена ф-ий > 1; '{' ; '['; '!'; '^'; .
    BeginTree,LastNode: PNode;   //указатель начала дерева (не обязательно)  (LastNode = BeginTree)
    FirstNode: PNode;          //указатель на первый узел в линейном списке  (нижний левый)
    //F_VarShift:              Boolean;  //распознавание var&param в верхнем/нижнем/обоих регистрах.
    //F_FuncShift:             Boolean;
    F_UseVirtAlloc: Boolean; {.193}
    F_SyntaxErrorCode: Cardinal;    //код ошибки при разборе

    F_SyntaxErrorString: String;   //строка ошибки
    F_SyntaxErrorName: String;     //строка с ошибочным именем  {.323}
    //F_CurrentSubExpr: String;     //теущее подвыражение при разборе
    //F_CurrentEvalSubExpr: String;     //теущее вычисляемое подвыражение при разборе      {.322}
    //F_CalcErrorCode: Integer;    //вычислит. ошибка
    F_InternalError: Integer;
    F_ShowException: Boolean;      //вкл./выкл. показ исключений
    F_ExternalException: Boolean;  //вкл./выкл. внешнего обработчика исключений
    F_CalcType: Integer;          //тип режима вычислений = T_Real; T_Complex(= тип возвращаемого результата),
                                  // T_Any - результат определяется выражением и не приводится к конкретному типу {.324}
    //BeginLinker: Integer; //0,1 - начало/конец трансляции - исп-ся при обработке ошибок
    F_BeginCalc: Integer; //0,1 - начало/конец трансляции - исп-ся при обработке ошибок
    //F_MaxLenArg: Cardinal; //макс. число аргументов в функциях с плавающим числом аргументов
    F_ExtFunc: Boolean;  //внешняя ф-ия в выражении
    F_ComplexNumber, F_PresentVar, F_CallFuncPresent, F_CanRecompile: Boolean; {.347}
    F_EnableCalcConstExpression: Boolean;
    F_RecoverImUnit: Boolean; //=true , если перекрыто имя мнимой переменной(т.е. под этим именем другая переменная)
    //F_ReplaceFunction: Boolean; {.193}
    F_DataType: Integer; //_Double,_Extended;
    F_Mode: Integer;//M_Compile, M_DinamicLoad, M_XchBranch, M_EvalDataCellNum;     {.197}
    F_PolyUReWriteConst, F_PolyReWrite: Boolean;

    NAdr: Cardinal;
    //F_SaveStack: Boolean;
    //Alg:
    F_NumberStack: Cardinal;
    F_Address: Cardinal;
    F_NumberArg: Cardinal;
    F_FConst: TFloat;
    ICOMP:  TCode;
    //GFCode: TCode;
    //GFAddr: Pointer;
    //GFFunc: TFunction;
    F_SyntaxErrorStringA: String;
    F_CurrentString: String;
    F_IdN: Cardinal;
    F_ResultType: Cardinal;
    F_ArgTypes: Cardinal;    //указатель на массив с типами переменных для  функций с плавающим числом аргументов  (TIntFunc.N=-2(_STACK_INFINITE_A))
    //F_ExtNumberArg: Cardinal;
    //NFunc: Cardinal;
    GNode: PNode;
    SAdr: array of Cardinal;
    N_Stack:Integer;     //текущая глубина стека (после вычисления текущей ф-ии)
    N_PrevStack: Integer;    //глубина стека перед вычислением текущей ф-ии
    SMAX:Integer;          //максимально достигнутая глубина стека в текущей ф-ии
    N_DataCellNum: Cardinal;
    N_MaxDataCell: Cardinal; //количество числовых констант в выражении (для сохранения в память при компиляции)
    F_EvalDataCell: Boolean;  // = true: N_MaxDataCell уже найдено
    F_DataInArray: Boolean;  //= true числовые константы выражения при компиляции сохраняются в общий массив RFStack (иначе отдельно для каждого числа через new(Data) при компиляции)
    N_ReplFuncLen: Cardinal; //= RFSize - число ячеек массива Func.RFStack [0..N_ReplFuncLen] для сохранения замещенных команд
    N_CurrentDataCell: Cardinal;  //число  промежуточных результатов вычислений, требующих сохранения в памяти (кроме сохранения замещенных команд)
    F_TreeOptimization: integer;
    F_IntermediateLastNode: Boolean; {.310}
    F_EnableUsePointer,F_EnableUseIntegerPointer: Boolean;
    c_DinArrayLenCorrect: Integer; //= 0 (Delphi), 1 (FPC) Len(DynArray) = Len+c_DinArrayLenCorrect;
    F_CheckArrayTypeConnect: Boolean;

     _MaxStack:Integer;          //максимально достигнутая глубина стека FPU во всём выражении
     F_StackDeep: Integer;
     F_EnableCheckStack: Boolean;
     ES_OverFlow: Boolean;
     //Db_DinLoadOverFlow: Boolean;
     Db_XchBrSDeep: Integer;     //глубина стека до выполнения TreeOpimization (если: _Enable,_Auto)
     Db_XchBrNXch: Integer;      //число перестановок в TreeOpimization
     Db_DinLoadSDeep: Integer;   //глубина стека до выполнения DinamicLoad  (если: _Enable,_Auto)
     Db_DinLoadNMem: Integer;    //число выталкиваний в DinamicLoad
     Db_DinLoadOverFlow: Boolean;//True, если глубину стека в DinamicLoad невозможно сделать меньше заданной
     Db_CmplMaxStack: Integer;   //глубина стека при компилировании
     Db_ReplFuncNum: integer;  //число замен ReplFunc
     Db_ReplOpNum: integer;  //число замен ReplOperations
     Db_LoadStackAfterCalc: integer; //(0,1,2)
     Db_CalcConstFunc: integer;
     Db_CalcConstArg: integer;
     Db_CalcConstMulDiv: integer;
     Db_WriteDataOverFlow: Boolean;
     Db_WriteStackDataOverFlow: Boolean;
     CodeSizeComplExpr: Cardinal; //размер кода в байтах скомпилированного выражения

     F_SaveInFPU: Boolean;
     F_CalcConstExpr: Boolean;       // запрещает/разрешает вычисление и компиляцию выражения без переменных в константу

     F_DinamicLoadOptimization: Boolean;
     F_OperationOptimizator: Boolean;
     F_OperationOptimizatorA1, F_OperationOptimizatorA2: Boolean;
     F_ReplaceFunctions: Boolean;
     F_ReplaceOperations: Boolean;
     F_ReplaceFunctionsCF: Boolean;
     F_ReduceArgOptimizator: Boolean; //оптимизация ф-ий (Power), если один из аргументов (первый) - константа
     F_DisableReplaceIF: Boolean;  {запрещает/разрешает замену ReplaceFunctions/Operations если в выражении есть комманды IF,GOTO
                                   (используется для поиска ошибок)}
     //F_LeadToLowerCase: Boolean; {.221}   //(ускоряет разбор)
                                          { = False если переменные ,параметры, функции и компилируемые выражения регистронезависимы
                                            = True все компилируемые выражения и устанавливаемые функции, переменные ,параметры
                                                   приводятся к LowerCase}
     F_SyntaxExtension : Boolean;   //set all property extended syntax
     F_ExtNameFunction: Boolean;  //use extended (added) name of functions
     F_SubstNumCX: Boolean;       //conv/simplify complex number 1+2i (without "*")
     F_SkippedIF: Boolean; {.221}        //true: non-complete boolean expr; false: complete boolean expr;
     F_CurlyBracketToFrac : Boolean; //    {expr} -> frac(expr)
     F_SquareBracketToTrunc : Boolean; //   [expr] -> trunc(expr)
     F_PipeBracketToAbs   : Boolean;  //    |expr| -> abs(expr)
     F_ReplaceFuncInPart : Boolean;   //    powN(expr),powerN(expr),rootN(expr) -> power(expr,N) ; root(expr,N)     pow7(expr)-> power(expr,7)
     F_PreliminarySyntaxError  : Boolean;


     F_EnableCalcConsExprInMulti: Boolean;  {.221}//режим  компиляции промежуточных выражений (в составном выражении) для проверки их на константу.

     F_EnableMaskFpuException: Boolean; //маскирует прерывания FPU в блоках try except (внешняя: задаётся в dll)     {.223}
     F_CalcConstARG: Boolean;     // запрещает/разрешает вычисление константных подвыражений в  выражении
     F_CalcConstFUNC: Boolean;    // запрещает/разрешает вычисление константных подвыражений и функций в  выражении (имеет смысл только если F_CalcConstARG = True)
     F_CalcConstExtFunc: Boolean;  // запрещает/разрешает вычисление константных внешних функций в  выражении (имеет смысл только если F_CalcConstARG = True)
     F_IntegerOptimization: Boolean; //_IntForm in Array[IntForm], if(IntForm1 cmp IntForm2,...,...), power(Expr,IntForm),...
     F_IntegerOptimizationF: Boolean; ////_IntForm  в целочисленных аргументах внешних функций
     F_FAST_DIV: Boolean; //"быстрое деление" комплексных чисел: r/z, z/r, z1/z2      {.205}
     M_DIV_MODE: Integer; {.345}
     F_FAST_STD_FUNC_REAL,F_FAST_STD_FUNC_COMPLEX,F_FAST_STD_FUNC : Boolean;
     F_MulDivOptimization: Boolean ; {.217A}
     F_CalcConstMulDiv: Boolean; {.312} // запрещает/разрешает вычисление констант при F_MulDivOptimization
     F_SequentList: Boolean;
     F_Enable_All_Replace: Boolean; {.347} {.357} //
     F_DeleteZeroBranch: Boolean; {.363}
     F_EnableInline: Boolean; {.365}

     //F_Opt: Boolean;
     REG,REGA,REGF:  array [1..8] of Integer;
     LInternalFunc: Integer;
     F_JMP: Integer;
     F_SData: Integer;
     F_GotoPresent: boolean;
     F_IF,F_IFtmp: boolean;
     G_SaveVar: TAlgObject;
     G_SaveParam: TAlgParam;
     S_IM_UNIT: String; //i,I - imaginary unit
     // "i" задана ,как переменная, а определяется либо как переменная: i, либо как константа: i, -i, 2i, a+bi,...    !!!

     RFSize: Integer; {.193}
     TableRF: array of array of TTableRF;  {.217}
     //кода операций в массиве Alg.Opr[codeOP]
     COP_ADD, COP_SUB, COP_DIV, COP_MUL , COP_NEG, COP_POW, COP_FACT1, COP_FACT2 ,COP_CONJ, COP_RE, COP_IM, COP_ADDR : integer;
     FV_Result: TComplex;  {.229}
     F_SaveSW: Boolean;  {.229}
     F_UseSaveSW: Boolean;  {.365}    // {.365} Устранение странной ошибки, возникающей в некоторых случаях в CodeBlock16 (В остальных CodeBlock, MSVC ошибки нет)


     F_TypeOfNode: Integer; // N_Parent,N_End;
     M_ParseMode: Integer;  // = M_Compile, M_ParseDiffExpr.  Режимы работы синтаксического анализатора: компиляция, символьное дифференцирование
     S_DiffString,S_DiffVar: String;
     F_DiffVarPresent: Boolean; //присутствие переменной дифференцирования в выражении
     F_ExtFuncD: Boolean; //в выражении - внешняя ф-ия (не дифференцируется)
     G_idName,G_idArg: Integer;
     F_CheckName: Boolean;
     C_CmplParamNumbers: Integer;
     G_NExpr: Integer;  //число выражений в текущей строке при операциях с одинаковым приоритетом (исп-ся при оптимизации MulDiv)
     G_FAttr: TAttrib;
     TableAccFastFunc: array of TAccFastFunc;  {.335}

     CWMEM,SWMEM,CWMEM1,CWMEM2,CWMEM3,CWMEM4,CWMEM5,CWMEM6,CWMEM7,CWMEM8: Cardinal;

    function  FindNumberPR(PR: Cardinal): Cardinal;
    function  FindOperation(S: String): integer;
    function  FindOperationA(S: String; PR: Cardinal; NArg: Integer; Pos: Integer): integer;
    function  FindOperationPS(PS: PString; pos: Integer; NArg: Integer): integer; {.340}
    procedure FindSingleOP(S: String; var NCop: Integer);
    procedure FindSingleOPPS(PS: PString; var NCop: Integer);   {.314}
    function  CompareStingPartPS(PS1: PString; indx: Integer; PS2: PString; Len: Integer): boolean;
    procedure FindCallFunction(Node:PNode; var nf: Integer);
    procedure FindCallFunctionA(Node:PNode; var TypeF: Integer; var nf: Integer; var TypeA: Integer);
    //procedure FindLdFunction(var nf: Integer);
    //procedure FindConstLdFunction(var nf: Integer);
    procedure FindNumberLevel(var ANL: TArrayC);
    function  GetLevelsCS(Node:PNode): Cardinal;
    procedure TranslErrMsg({SubExpr: String}Node: PNode);
    procedure IntToHex(N: TAddress; var AH: TArray4);
    procedure IntToHexNum(N: Integer; var AH: TArray4);
    procedure SaveReg;
    procedure SaveRegF;
    procedure SetReg(R: Integer);
    procedure SaveMainRes;
    procedure AddAddress(Adr: TAddress);
    procedure AddNum(Num: Integer);
    procedure InsertInlineCode(BeginAddr: Cardinal; CodeLength: Cardinal);
    procedure AddCommand(Node:PNode);
    procedure AddByte(B: Byte);
    procedure AddByte2(B1: Byte; B2: Byte);
    procedure AddByte3(B1,B2,B3: Byte);
    procedure AddWord(B1: Byte; B2: Byte);
    procedure Compile;
    procedure CALLA;
    procedure CALLC;
    procedure CALLB;
    procedure RET;
    procedure FSTP(N: TAddress);
    procedure FLD(N: TAddress);       overload;
    procedure MOVAM(N: TAddress);
    procedure MOV_MEM_EAX(N: TAddress);
    procedure MOVMA(N: TAddress);
    procedure MOVMB(N: TAddress);
    procedure MOVMC(N: TAddress);
    procedure MOVMD(N: TAddress);
    procedure MOVAA;
    procedure MOVBB;
    procedure MOVAnum(N: Integer{TAddress});
    procedure MOVBnum(N: Integer{TAddress});
    procedure MOVCnum(N: Integer{TAddress});
    procedure MOVDnum(N: Integer{TAddress});
    procedure MOVAadr(N: TAddress);
    procedure MOVBadr(N: TAddress);
    procedure MOVCadr(N: TAddress);
    procedure INCMEM(N: TAddress);
    procedure DECMEM(N: TAddress);
    procedure MOVESPEAX(N: Integer);
    procedure MOVCREG(Reg,N: Integer); //Const(32)->Reg
    procedure MOVMREG(Reg: Integer; Mem: TAddress); //Mem(32)->Reg
    procedure MOVREGM(Reg: Integer; MEM: TAddress); //Reg->MEM(32)
    procedure IMULCREG(Reg: Integer; C: Integer); //Reg=Reg*C(32)
    procedure IMULMREG(Reg: Integer; MEM: TAddress); //Reg=Reg*MEM(32)
    procedure ADDREG(Reg1,Reg2: Integer); //Reg1=Reg1+Reg2
    procedure SUBREG(Reg1,Reg2: Integer); //Reg1=Reg1-Reg2
    procedure NEGREG(Reg: Integer); //-Reg
    procedure NEGMEM(MEM: Integer);
    procedure MOVREG(Reg1,Reg2: Integer); //Reg1=>Reg2
    procedure ADDMREG(Reg: Integer; MEM: TAddress); //Reg=Reg+[MEM(32)]
    procedure SUBMREG(Reg: Integer; MEM: TAddress); //Reg=Reg-[MEM(32)]
    procedure ADDMEMCONST(MEM: TAddress; IC: Integer); //MEM(32)=MEM(32)+IC
    procedure SHLREG(Reg,Sh: Integer); //shl reg,Sh
    procedure LEAREG(Reg,Sh: Integer); // lea reg,[reg+reg*sh]
    procedure IMULCREG2(Reg: Integer);
    procedure IMULCREG3(Reg: Integer);
    procedure IMULCREG4(Reg: Integer);
    procedure IMULCREG5(Reg: Integer);
    procedure IMULCREG6(Reg: Integer);
    procedure IMULCREG7(Reg: Integer);
    procedure IMULCREG8(Reg: Integer);
    procedure IMULCREG9(Reg: Integer);
    procedure IMULCREG10(Reg: Integer);
    function  IMULREG_CONST(Reg,C: Integer): Boolean;
    procedure CMPR(Reg1,Reg2: Integer);
    procedure CMPRM(Arg1,Arg2: Integer; Addr: TAddress);
    procedure PUSHR(Reg: Integer);
    procedure POPR(Reg: Integer);


    procedure PUSHAD;
    procedure POPAD;
    procedure ADDESP(N: Integer);
    procedure SUBESP(N: Integer);
    procedure FEXP;
    procedure ZEXP;
    procedure FSIN;
    procedure FCOS;
    procedure FSINCOS;
    procedure FPTAN;
    procedure FPATAN;
    procedure FISTP(N: TAddress);
    procedure FSTPESP(VType: Integer);                overload;
    procedure FSTPESP(VType: Integer; N: Integer);    overload;
    procedure FLDCW(N: TAddress);
    procedure PUSHCW;
    procedure POPCW;
    procedure FSTP0;
    procedure FSTP1;
    procedure FLD1;
    procedure FDIVR_C1;
    procedure FMUL_C05;
    procedure FDIV_C3;
    procedure ZDIVR_C1;
    procedure ZMUL_i;
    procedure ZDIV_i;
    procedure ZDIVR_i;
    procedure FDIVRP;
    procedure FDIVRC1;
    procedure FLDLN2;
    procedure FYL2X;
    procedure FLDLG2;
    procedure FABS;
    procedure FRNDINT;
    procedure CDQ;
    procedure IDIV(N: TAddress);
    procedure IDIVB;
    procedure ADD_C;
    procedure SUB_C;
    procedure FDIV(N: TAddress; VType: Integer);
    procedure FDIVR(N: TAddress; VType: Integer);
    procedure FDIVRC(C: Extended; VType: Integer);
    procedure FDIVP;
    procedure FDIV01;
    procedure FDIV02;
    procedure FDIV10;
    procedure FDIVR01;
    procedure FDIVR10;
    procedure FDIVP2;
    procedure FDIVRP2;
    procedure FDIVRP3;
    procedure FDIVP3;
    procedure MUL_C;
    procedure DIV_C;
    procedure FMUL1;
    procedure FDIV2;
    procedure FDIVR2;
    procedure FSUBP01;
    //procedure FDIVR2;
    //procedure FDIVP2;
    procedure FDIVP1;
    procedure FMUL0;
    procedure FMUL02;
    procedure FMUL01;
    procedure FMUL03;
    procedure FMUL04;
    procedure FMUL05;
    procedure FMUL10;
    procedure FSQRT;
    procedure FMUL(N: TAddress; VType: Integer);
    procedure FSUB(N: TAddress; VType: Integer);
    procedure FSUBR(N: TAddress; VType: Integer);
    procedure FSUBP;
    procedure FSUBP1;
    procedure NEG_C;
    procedure RE_C;
    procedure IM_C;
    procedure FADD(N: TAddress; VType: Integer);
    procedure FADDP;
    procedure FADDP1;
    procedure FADDP2;
    procedure FADDP20;
    procedure FADDP30;
    procedure FADDP3;
    procedure FSUBRP;
    procedure FSUBRP2;
    procedure FMULP;
    procedure FMULP1;
    procedure FMULP2;
    procedure FMULP4;
    procedure FMULP20;
    procedure FMUL30;
    procedure FMUL20;
    procedure FSUBP2;
    procedure FSUBP40;
    procedure FLDZ;
    procedure FLD0;
    procedure FCHS;
    procedure PUSHB;
    procedure PUSHF(N: TAddress);
    procedure POPF(N: TAddress);
    procedure FILD(N: TAddress);
    procedure FTRUNC;
    procedure RSQR;
    procedure RIPWR3;
    procedure RIPWR4;
    procedure RIPWR5;
    procedure RIPWR6;
    procedure RIPWR7;
    procedure RIPWR8;
    procedure RIPWR9;
    procedure RIPWR10;
    procedure RIPWR11;
    procedure RIPWR12;
    procedure RIPWR13;
    procedure RIPWR14;
    procedure RIPWR15;
    procedure RIPWR16;
    procedure IPWRC16(P,VType: Integer);
    procedure TRUNCM(N: TAddress);
    procedure TRUNCR(Reg: Integer);
    procedure MOVDM(N: TAddress);
    procedure IDIVM(N: TAddress);
    //procedure FISTPM(N: TAddress);
    procedure POPB;
    procedure FLD(N: TAddress; VType: Integer);    overload;
    procedure FSTPM(N: TAddress; VType: Integer);
    procedure FSTM(N: TAddress; VType: Integer);   {.193}
    procedure FLDREG(Reg,tm: Integer);
    procedure FSTPREG(Reg,tm: Integer);
    procedure LoadArrayAddrCell(REG_load,REG_AddrArray,REG_indx,tm: Integer);
    procedure LoadArrayCellFPU(Addr: TAddress; REG_indx, tm: Integer);
    procedure SaveArrayCellFPU(Addr: TAddress; REG_indx, tm: Integer);
    procedure LoadArrayElem(Act: Integer);
    procedure FCOMPP;
    procedure FCOMIP;
    procedure FCOMIP2;
    procedure FCOMI;
    procedure FSTSW_AX;
    procedure SAHF;
    procedure JMPC(N: TAddress; VType: Integer);
    procedure JMPCI(N: TAddress; VType: Integer);
    procedure JMP(ofst: Integer);
    procedure FXCH1;
    procedure FXCH2;
    procedure FXCH3;
    procedure FXCH4;
    procedure ZMULP;
    procedure ZMUL;
    procedure ZDIV;
    procedure RZDIV;
    procedure MUL_ST(tc,ts: Integer);
    procedure MULP_ST(tc,ts: Integer);
    procedure ADDP_ST(tc,ts: Integer);
    procedure ZSQR;
    procedure ZPUSH;
    procedure ZIPWR3;
    procedure ZIPWR4;
    procedure ZIPWR5;
    procedure ZIPWR6;
    procedure ZIPWR7;
    procedure ZIPWR8;
    procedure ZIPWR9;
    procedure ZIPWR10;
    procedure ZIPWR11;
    procedure ZIPWR12;
    procedure ZIPWR13;
    procedure ZIPWR14;
    procedure ZIPWR15;
    procedure ZIPWR16;
    //procedure AIVP1;  {.303}
    procedure LineForm1;
    procedure LineFormN(AIVP1: TArrayIntVarProd; IC: Integer);

    procedure AddCom(B1,B2: Byte);   overload;
    procedure AddCom(B1,B2,B3: Byte);  overload;
    procedure AddComA(B1: Byte; Adr: TAddress); overload;
    procedure AddComA(B1,B2: Byte; Adr: TAddress);   overload;
    procedure AddComA(B1,B2,B3: Byte; Adr: TAddress);     overload;

    function  WriteData(Node:PNode): TAddress;
    function  WriteDataA(Data: extended; DataType: Integer): TAddress;
    procedure FreeData;
    procedure LoadArgMEM;
    procedure LoadArgMEMInf;
    procedure LoadArgSTACK;
    procedure PushArgSTACK;
    procedure LoadArgMEMInfA;
    procedure LoadArgPC;
    function  GetStackAdr(S,RT: Integer): Cardinal;
    function  CheckIfRet(Node:PNode): Boolean;
    function  CheckNopRet(Node:PNode): Boolean;
    function  CheckSaveRet(Node:PNode): Boolean;
    function  ReadReplFunc(Node:PNode): Boolean;     {.193}
    procedure WriteReplFunc(Node:PNode);             {.193}
    procedure PUSHM(N: Cardinal);
    procedure LoadArg1;
    //procedure LoadArg2;
    procedure LoadArg2(Place: Integer);
    procedure LoadArg2Right;
    procedure LoadArg2Back;
    procedure LoadArg3RL;
    procedure LoadArg2RL;
    procedure FLDV(nv: Integer);
    procedure FLDV_RE(nv: Integer);
    procedure FLDV_IM(nv: Integer);
    procedure FADDV(nv: Integer; st: Integer);
    procedure FSUBV(nv: Integer; st: Integer; inv:Integer = 0);
    procedure FDIVV(nv: Integer; st: Integer; inv:Integer = 0);
    procedure MUL_SV(nv: Integer; st: Integer);
    procedure MUL_VC(nv: Integer; TC: Integer);
    procedure DIV_VC(nv: Integer; TC: Integer);
    procedure FLDS(K: Integer; fm:Integer = _FPU);
    procedure MUL_SC(TS,TC: Integer);
    procedure DIV_SC(TS,TC: Integer);
    procedure LDSF_C(N: Integer);
    procedure LDSA_C;   {.347}
    procedure SAVE_C;
    procedure SWAP_C;
    procedure SWAPIF_C;
    procedure SIN_C;
    procedure COS_C;
    procedure SEC_C;
    procedure COSEC_C;
    procedure TAN_C;
    procedure COTAN_C;
    procedure SINCOS_C;
    procedure COSSIN_C;
    procedure POWER_C;
    procedure LOGN_C;
    procedure ARCTAN2_C;
    procedure FACT_C;
    procedure FACT2_C;
    procedure SQR_C;
    procedure SQRT_C;
    procedure ARCSIN_C;
    procedure ARCCOS_C;
    procedure ARCTAN_C;
    procedure ARCCOTAN_C;
    procedure ARCSEC_C;
    procedure ARCCOSEC_C;
    procedure SINH_C;
    procedure COSH_C;
    procedure COSECH_C;
    procedure SECH_C;
    procedure TANH_C;
    procedure COTANH_C;
    procedure ARCSINH_C;
    procedure ARCCOSH_C;
    procedure ARCTANH_C;
    procedure ARCCOTANH_C;
    procedure ARCCOSECH_C;
    procedure ARCSECH_C;
    procedure LN_C;
    procedure EXP_C;
    procedure LOG10_C;
    procedure LOG2_C;
    procedure DECART_C;
    procedure ABS_C;
    procedure ARG_C;
    procedure ROOT_C;
    procedure IROOT_C;
    procedure COMPLEX_C;
    procedure IPWR16_C;
    procedure PWR3_C;
    procedure PWR4_C;
    procedure PWR5_C;
    procedure PWR6_C;
    procedure PWRN1_C;
    {procedure PWRN2_C;
    procedure PWRN3_C;
    procedure PWRN4_C;
    procedure PWRN5_C;
    procedure PWRN6_C;}
    procedure TRUNC_C;
    procedure CON_C;
    procedure NORM_C;
    procedure Frac_C;
    procedure SUM_C;
    procedure SUMI_C;
    procedure PROD_C;
    procedure AVR_C;
    procedure SUMQ_C;
    procedure LEN_C;
    procedure MAX_C;
    procedure MIN_C;
    procedure DEV_C;
    procedure DEVS_C;
    procedure SGN_C;
    procedure LDSVX_C;
    procedure IPWRSGN_C;
    procedure REUNEGIPWR_C;
    procedure IFNOP_C;
    procedure JMP_C;
    procedure FLD_C(Node:PNode);
    procedure INC_C;
    procedure DEC_C;
    procedure DEG_C;
    procedure RAD_C;
    procedure MOD_C;
    procedure IDIV_C;
    procedure IPWR_C;
    procedure POLY_C;
    procedure GCD_C;
    procedure LCM_C;
    procedure MAX23_C;
    procedure MIN23_C;
    procedure AVR23_C;
    procedure NORM23_C;
    procedure F2PWR_C;
    procedure TRY_C;
    procedure EXCEPTION_C;
    procedure POLYDIFF_C;
    procedure SUMP_C;
    procedure SUMPS_C;
    procedure PRODS_C;
    procedure CALL_C;
    procedure POLYU_C;
    procedure IMUIPWR_C;   {.361}
    procedure IMURZPWR_C;
    procedure CZPWR_C;




    procedure FindNumberLevelA(num: Integer; var ANL: TArrayC);
    //procedure IPWR_C;


    procedure FindExternalBracket(S: String; var SS: String);
    function  DeleteExternalBracketPS(PS: PString): Boolean; {.217A}
    function  DeleteExternalBracketNegPS(PS: PString; var Neg: Integer): Boolean;   {.317}
    //function  CheckToZero(S: String): Boolean; {.217A}
    function  CheckToZeroPS(PS: PString): Boolean; {.219}
    //procedure FindMainOperation(S:String; var NCOP: Integer; var NPos: Cardinal);
    //procedure FindMainOperationA(S:String; var NCOP: Integer; var NPos: Cardinal; var Sret: String);  {.217A}
    procedure FindMainOperationPS(PS: PString;  var NCOP: Integer; var NPos: Cardinal; var NCOP_1: Integer; var NCOP_2: Integer);   {.314}
    //procedure FindMainOperationP(PS: PString; var NCOP: Integer; var NPos: Cardinal);
    procedure StringAnalizatorMEPS(PS:PString; var N: Integer; var COP,COPinv: Integer; var HS:PLevel{; varNeg: Integer});
    //procedure MulDivOpt(S:String; var NCOP: Integer; var NPos: Cardinal; var Sret: String);    {.217A}

    //procedure StringAnalizator(S:String; var ND: TDataNode; var HS:PLevel);
    procedure StringAnalizatorPS(PS: PString; var ND: TDataNode; var HS:PLevel);  {.314}
    procedure WriteCode;
    procedure WriteLevelParam(H: PNode; HS: PLevel; N: Cardinal);
    //procedure SubstParamP(PS: PString;  var C: TFloat; var SB: Boolean);
    procedure SubstParamPS(PS: PString;  var Re,Im: Extended; var TV: Integer);  {.311}
    function  SubstParamPSF(PS: PString;  var Re,Im: Extended): Integer;  {.347}
    function  SubstParamAPSF(PS: PString;  var Re,Im: Extended): Integer;  {.347}
    procedure SubstNumPS(PS: PString;  var Re,Im: Extended; var TV: Integer);
    procedure SubstParam(S1: String;  var C: TFloat; var SB: Integer);        {.330}
    //procedure SubstParamCX(S: String;  var CX: TComplex; var SB: Integer);
    procedure SubstParamCXPS(PS: PString;  var CX: TComplex; var SB: Integer);
    procedure SubstParamACXPS(PS: PString;   var Re,Im: Extended; var TP: Integer);
    function  SubstParamACXPSF(PS: PString; var Re,Im: Extended): Integer;

    function  PointToDec(S: String):String;
    procedure CreateInitData;
    //procedure FindVar(S1: String; var ni: Integer);
    //procedure SyntaxAnalizator(S:String; var ND: TDataNode; var LV:PLevel;  var EOFN: Boolean);
    procedure SyntaxAnalizatorGT( var ND: TDataNode; var LV:PLevel;  var EOFN: Boolean);   {.309}
    procedure OperationalAnalizator2(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
    procedure OperationalAnalizator1(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
    procedure PowerAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
    procedure RootAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
    procedure FactAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
    procedure ReImAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
    procedure AddrAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
    procedure IFAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode);
    procedure SaveAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
    procedure GOTOAnalizator(LV: PLevel; ND: TDataNode; var LV1: PLevel; var ND1: TDataNode);
    procedure IDAMAnalizator(LV: PLevel; ND: TDataNode; var LV1: PLevel; var ND1: TDataNode);
    procedure SetLenAnalizator(LV: PLevel; ND: TDataNode; var LV1: PLevel; var ND1: TDataNode);
    procedure SWAPAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
    procedure SWAPIFAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
    procedure MOD_IDIV_Analizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
    procedure POLYAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
    procedure POLYDIFFAnalizator(LV: PLevel; ND: TDataNode;  var LV1: PLevel; var ND1: TDataNode; var EOFN: boolean);
    procedure RANDAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);  {.203}
    procedure DataFuncAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
    procedure SUMPAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean); {.333}
    procedure SUMPSAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);  {.333}
    procedure PRODSAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);  {.359}
    procedure CALLAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean); {.347}
    function  FindAddrObj(PS: PString;  ND: TDataNode; var ND1: TDataNode): Boolean; {.347}
    function  FindArray(PS: PString; var ND: TDataNode;  var ni, TypeV, TypeIndx: Integer; var Addr: Cardinal;   var Sindx: String): Boolean;
    //procedure SAFECALLAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode);    {.219}
    //procedure NumberAnalizator(S: String; var ND: TDataNode;  var EOFN: Boolean);
    procedure NumberAnalizatorPS(PS: PString;  var ND: TDataNode; var EOFN: Boolean);  {.314}
    //procedure FindConst(S: String; var ND: TDataNode;  var EOFN: Boolean);
    procedure FindConstPS(PS: PString;  var ND: TDataNode; var EOFN: Boolean);     {.314}
    //procedure NumberAnalizatorA(S: String;  var nf: Integer; var FD: extended; var EF: Integer);
    procedure WriteNodeParam(ND: TDataNode);
    procedure InitNode(var ND: TDataNode);
    function  GetReturnedFuncType(Node: PNode): Integer;
    //procedure WriteDataCode;
    //procedure FindFunction(S: String;  var ND: TDataNode; var LV: PLevel;  var BH,EOFN: Boolean);
    procedure FindFunctionPS(PS: PString;  var ND: TDataNode; var LV: PLevel;  var BH,EOFN: Boolean);  {.314}
    //procedure FindFuncBr(S: String; BrS1,BrS2: String; var Sf: String; var Sa: String; var FH: Boolean);
    procedure FindFuncBrPS(PS: PString; BrS1,BrS2: String; var Sf: String; var Sa: String; var FH: Boolean);  {.314}
    procedure PrevTreat(S: String; var S1: String);
    procedure ReplaceAbsBr(S: String; var S1: String);
    procedure ReplaceTruncBr(S: String; var S1: String);
    procedure ReplaceFracBr(S: String; var S1: String);
    procedure FindFactSymb(S1: String; var S2: String);
    procedure FindFact2Symb(S1: String; var S2: String);
    procedure replaceAndOr(S: String;  var S1: String);
    procedure ReplaceAndOrSKIP(S: String;  var S1: String); {.221}
    procedure ReplaceFuncIntPart(S,SF: String; var S1: String);
    procedure ReplaceIff(S1: String; var S2: String);
    procedure insIf(S: String; P,N: Integer; var S1: String);
    function  CheckImUnitAfterBr(const S: String; i: Integer): Boolean;
     procedure FreeTree;
    //procedure FreeFunction;
    procedure FreeFuncData(FuncData: PFuncData);
    procedure TreeBuilder(S:String);
    procedure SetStackSize;
    procedure LinkTreeData;
    procedure LinkTreeData_Tree;    {.325}
    procedure LinkTreeData_SeqList; {.325}
    procedure GetSizeInterp;
    procedure FindManyArg(S: String; var ArgM: TArrayS);
    procedure FindManyArgPS(PS: PString; var ArgM: TArrayS);  {.314}
    procedure SaveResult(Node:PNode);
    procedure CreateFuncList;
    procedure SetNM;
    procedure SetNL;
    procedure SetLoadSource;
    procedure DinamicLoadOptimizator;
    procedure SetLoadMem(Node:PNode);
    function  EnableDL(Node:PNode): Boolean;
    procedure InitCompiler(Mode: Integer);
    function  E_GetMaxLoadDL(Node:PNode): Integer;
    procedure E_SetNodeDL(Node:PNode);
    procedure CheckStack(N: Integer);
    function  E_GetMaxStackEx: Integer;
    procedure InitConstDb;
    procedure InitUsedVar;     {.333}
    procedure DebugDL;
    procedure SetExtArg;
    procedure PUSHArgStackVal;
    procedure PushArgStackAdr;
    procedure GetVar1(N: Integer; var Addr: TAddress; var TV: Integer; var TM: Integer);       {.343}
    procedure GetVar2(N: Integer; var AddrRE,AddrIM: TAddress; var TV: Integer; var TM: Integer);  {.343}
    procedure FindReIm(S: String; var S1:String; var TF: Integer);
    procedure FindReImPS(PS: PString; var TF: Integer);
    procedure FindControlCom(S: String; var code,ni: Integer; var BH: Boolean);
    procedure FindControlComPS(PS: PString; var code,ni: Integer; var BH: Boolean);  {.314}
    procedure FindJMP(S: String; var ni: Integer);
    procedure FindJMPPS(PS: PString; var ni: Integer);     {.314}
    procedure FindFLD(S: String; var ni: Integer);
    procedure FindFLDPS(PS: PString; var ni: Integer);     {.314}
    function  FindIfFunc: Boolean;
    function  CheckName(Name: String): Boolean;
    procedure CheckRecoverImUnit;
    function  CheckImUnit(PSI: PString; var Sgn: Integer): Boolean;
    function  GetFirstNode(num: Integer): Cardinal;   {.193}
    procedure ReplaceOptimizator;                       {.193}
    procedure ReplaceFunc;                             {.193}
    procedure InsertFunc(NodeF,NodeS: PNode{NF,NS: Integer});            {.193}
    procedure FindFuncInExprPS(k: Integer; PSexpr: PString; var BH: Boolean);    {.193}
    procedure FindNonReplFuncPS(PSf: PString; var BH: Boolean);             {.193}
    procedure ReplaceOperations; {.193}
    procedure DelVoidSave;
    procedure DelVoidSaveCF;
    procedure SetNewFuncToOperation(OpName: String; IDF: Cardinal);   {.195}
    function  GetLineStackAdr(NodeM: PNode; NArg: Cardinal{NM,NArg: Cardinal}): TAddress;
    procedure SaveArgMemAdr(Node: PNode);        {.197}
    procedure SaveArgPC(Node: PNode);  {.197}
    procedure SaveArgStackVal(Node: PNode);      {.197}
    procedure SaveArgStackAdr(Node: PNode);
    procedure FreeChld(PrntNode: PNode);
    procedure FreeChldNode(Prnt: PNode; NChld: Integer);
    procedure InitTableRF; {.217}
    procedure InsertFuncRF(NodeF,NodeS: PNode{NF,NS: Integer});  {.217}
    procedure ReplaceFuncComposite;       {.217}
    procedure GetReplaceData({NF,NS,}NodeF,NodeS: PNode; VType: integer; var RangW,RangR,NMem,MShft: Integer);  {.217}
    procedure TryFPUMask{(CWMEM: PCardinal)};
    procedure TryCatchFPUException{(CWMEM: PCardinal)};                           {.229}
    procedure SaveSW;
    function  IsFPUExceptionSW(CWAddr: PCardinal): integer;    stdcall;
    function  SizeArg(VType: Integer): Integer;
    function  GetSizeSh(tm: integer): integer;
    {.300}
    function  GetNextNode(PrntNode: PNode):  PNode;  //inline;
    function  GetLowLevelNode(PrntNode: PNode):  PNode; // inline;
    function  GetLowRightNode(PrntNode: PNode):  PNode; // inline;
    function  GetLastChld(PrntNode: PNode):  PNode;
    procedure GetAllChilds(Node: PNode; var NCHLD: TArrayPN);
    procedure ReadTree(CallProc: TFuncTreeObj{CallProc: TProcTree}{CallProc: Pointer});
    procedure ReadTreeFromNode(NodeTree: PNode; CallProc: TFuncTreeObj{CallProc: TProcTree}{CallProc: Pointer});
    function  SetExtArgInNode(Tree: PNode) : boolean;
    function  FindIfFuncInNode(Tree: PNode): Boolean;
    procedure FindNodeForReplaceROP(Node1: PNode);
    Function  GotoNextNodeROP(Node: PNode):Boolean;
    procedure CompareAndReplace(Node1,Node2: PNode);
    procedure InitSequentList;      //создание последовательного линейного списка чтения дерева и инициализация соответствующих ссылок Next,Prev
    procedure LinkDataNode(Node: PNode);
    procedure ClearNode(Node: PNode);
    procedure FreeChildTree(Prnt: PNode);
    procedure DelAndFreeThisNode(FNode: PNode);
    procedure FreeBranch(BranchPrnt: PNode);
    procedure ReadTreeDBG;
    procedure FreeChildTreeA(Prnt: PNode);
    procedure FreeReplacedNodes(NodeS: PNode);
    procedure FreeNode(Node: PNode);
    procedure EvalDataCellNum;
    procedure TreeOptimizator;
    function  xch_GetFuncLoad(Node: PNode): Integer;
    procedure SetNodeDeep;
    procedure BranchOptimizator;
    function  CheckXchBranch(Lv: PNode): Boolean;
    procedure XchBranch(Pr: PNode);
    procedure RestoreStack;
    procedure SetFunction(Name: String; FS:TIntFunc);
    procedure SetNewFunc(NameF: String; NFunc,NF: Integer; FS:TIntFunc; Com: Integer; var idName,idArg: Integer);

    function _POWER(x,y: extended): extended;
    function _ROOT(x,y: extended): extended;

    {.301}
    procedure DelExternalBracketAP(PS: PString);
    //procedure IsNum(S2: String; var fx: extended; var bnum: boolean);
    procedure ExtDiffFunc(SE: String; var SXD: String; var Bl: Boolean);
    procedure ReplaceDiffTeplate(Tree: PNode; var DiffFunc: String);
    function  CheckForZeroNode(Tree: PNode): boolean;
    function  CheckExp(PS: PString): Boolean;
    procedure PolyDiff(HTree: PNode; var DP: String);
    function  IsArray(Name: String): boolean;
    function  IsFunction(PNE: PNode): Boolean; {.329}
    procedure FindExternalBracketNeg(S: String; var SS: String; var Neg: Integer);
    procedure DiffExtExpression(SExpr: String;  var SDiff: String);
    //procedure SyntaxAnalizatorDiff(S:String; var ND: TDataNode; var LV:PLevel;  var EOFN: Boolean);
    //procedure NumberAnalizatorDiff(S: String;  var ND: TDataNode; var EOFN: Boolean);
    //procedure FindFunctionDiff(S: String;  var ND: TDataNode; var LV: PLevel;  var BH,EOFN: Boolean);
    procedure FindExternalBracketNegPS(PS: PString);
    procedure DelExternalBracketInArgsPS(ArgM: TArrayS; PSa:PString);
    procedure IsNumPS(PS: PString; var fx: extended; var bnum: boolean);
    procedure IsNumLastPS(PS: PString; var fx: extended; var Op: Integer);
    procedure FindAddSubNumInArgPS(PS: PString ;  var fx: extended; var answ: integer);
    procedure FindIntVarProdSPS(PS: PString; var code: Integer; {var FIN: TFin; }var IVP: TIntVarProd);
    procedure FindIntVarProdL(LV: PLevel; COP,COPinv: Integer; var code: Integer; {var FIN: TFin; }var IVP: TIntVarProd);
    procedure FindExtArgIntPS(PS: PString; var code: Integer; {var FIN: TFin;} var AIVP: TArrayIntVarProd;  var NV,IC: Integer);
    procedure CopyAIVP(AIVPs: TArrayIntVarProd; var AIVPd:  TArrayIntVarProd) ;
    procedure WriteFindExtArgInt1PS(PStr1: PString;  place: Integer; ND1: TDataNode; var ND2: TDataNode; var BAnsw: Boolean);
    procedure WriteFindExtArgInt2PS(PStr1,Pstr2: PString; ND1: TDataNode;  var ND2: TDataNode; var BAnsw: Boolean);
    procedure WriteFindExtArgInt2AnyPS(PStr1,Pstr2: PString; ND1: TDataNode;  var ND2: TDataNode; var code: Integer);
    procedure LoadLineFormEAX(place: Integer);
    function  SaveSimpleLineForm: Boolean;
    procedure AddNumToStrPS(PS1: PString; fx: extended; var S1A: String);
    procedure EvalTreeConst;
    procedure EvalCOP1(PNE: PNode; COP,tArg:Integer);
    procedure EvalCOP2(PNE: PNode; COP:Integer);
    procedure EvalConstCOP1(PNE: PNode; COP,tArg: Integer);
    function  EvalConstFunc(PNE: PNode): Boolean;
    function  EvalConstFunc0(PNE: PNode): Boolean;
    function  EvalConstFunc1(PNE: PNode): Boolean;
    function  EvalConstFunc2(PNE: PNode): Boolean;
    function  EvalConstFunc3(PNE: PNode): Boolean;
    function  CheckChildForZero(PNE: PNode;  NumArg: Integer): Boolean;
    procedure GetConstArg1(PNE: PNode; var Re1,Im1: Extended; var ResT1: Integer);
    procedure GetConstArg2(PNE: PNode; var Re1,Im1,Re2,Im2: Extended; var ResT1,ResT2: Integer);
    procedure GetConstArg1U(PNArg: PNode; place: integer; var Re1,Im1: Extended; var ResT1: Integer);
    procedure _ComplexADD(Re1,Im1,Re2,Im2: Extended; var Re,Im: Extended);
    procedure _ComplexSUB(Re1,Im1,Re2,Im2: Extended; var Re,Im: Extended);
    procedure _ComplexMUL(Re1,Im1,Re2,Im2: Extended; var Re,Im: Extended);
    procedure _ComplexDIV(Re1,Im1,Re2,Im2: Extended; var Re,Im: Extended);
    procedure _EvalFunc1({NFunc,NF: Integer;}PNE: PNode; Arg1: TComplex; var Res: TComplex; var ResType: Integer; var IsEval: Boolean);
    procedure _EvalFunc2({NFunc,NF: Integer;}PNE: PNode; Arg1,Arg2: TComplex; var Res: TComplex; var IsEval: Boolean);
    procedure _EvalFunc1Cx(Addr: Pointer;  Arg1: TComplex; var Res: TComplex);
    procedure _EvalFunc2Cx(Addr: Pointer;  Arg1,Arg2: TComplex; TV1,TV2: Integer; var Res: TComplex);
    procedure _EvalFunc1CxInt(Addr: Pointer;  Arg1: TComplex; Arg2: Integer; var Res: TComplex);
    procedure _EvalFunc1CxInt2(Addr: Pointer;  Arg1: TComplex; Arg2,Arg3: Integer; var Res: TComplex);
    procedure _EvalFunc1ReInt(Addr: Pointer;  Arg1: Extended; Arg2: Integer; var Res: Extended);
    procedure FindExtFuncIntArg(var  ND: TDataNode; var EOFN: Boolean);
    procedure CompileNodes(BeginNode: PNode; NNodes: Integer);
    procedure _EvalFunc(AddrF: Pointer; TypeF: Integer; var Res: TComplex);
    procedure _EvalFuncReCx(AddrF: Pointer; Re: TFloat; var Res: TComplex);
    function  EvalConstFuncN(PNE: PNode): Boolean;
    procedure EvalFuncN(PNE: PNode; var Res: TComplex; var IsEval: Boolean);
  //  procedure MulDivOptPS(PS: PString; var NCOP: Integer; var NPos: Cardinal);    {.314}
    function  MulDivAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean): Boolean;
    procedure AddToTableAccFastFunc(NFuncFast, NFuncAcc: Integer);
    procedure PolyUReWrite;
    procedure ReduceArgOptimizator(PNE: PNode; DataArg: TDataArg);


  protected

   procedure  IntException;  virtual;


  public


   constructor Create;
   destructor  Destroy;
   procedure FreeFuncList;
   procedure InitFuncStruct(var FS: TIntFunc);
   procedure SetExtExpression(S: String; Atr: TAttrib;  var E_Func: TFunction; var Stack: Cardinal);
   procedure CheckSyntax(S: String; var Sout: String);       {.327}
   procedure FindVar(S1: String; var ni: Integer);
   procedure FindVarPS(PS1: PString; var ni: Integer);  {.314}
   procedure FindVarExPS(PS: PString; var  ni: Integer; var Addr, AddrIM: TAddress; var TypeF, MType, ReIm,ImU: Integer);
   procedure FindVarP(PS: PString; var ni: Integer);
   procedure FindVarA(S1: String; var ni: Integer; var Adr: TAddress; var TV,TM: Integer);
   procedure FindVarAPS(PS1: PString; var ni: Integer; var Adr: TAddress; var TV,TM: Integer);   {.333}
   procedure ExistVar(S1: String; var Addr,IdType,MType: Cardinal);
   procedure ExistVar2(S1: String; var Addr,AddrIM: TAddress; var IdType,MType,CnctType: Cardinal);
   procedure ExistVarEx(S1: String; var Addr: TAddress; var IdType,MType,ReIm,ImU: Cardinal);
   procedure FindIntVarConstP(PS: PString; var nv,ic,typeVC: Integer);
   function  FindExtractArray(PS: PString; var Sv,Sa: String; var MType,ni: Integer): Boolean;   {.347}


   procedure FindVarConstPS(PS: PString;  var nf: Integer; var FD: extended; var TypeS: Integer);
   procedure FindVarConstCxPS(PS: PString;  var nf: Integer; var Re,Im: extended; var TypeS, TypeC: Integer);  {.361}
   procedure FreeExtFunc(E_Func: PFunction);          {.225}
   //procedure FreeCmplParam;
   function  IsFPUException(CWAddr: PCardinal): integer;     stdcall;
   {.301}
   function  XchNFuncFastAcc(NFunc: integer): integer;  {.335}
   procedure SetDiffVar(NameDV: String);
   procedure SetTemplateDiffFunc(NFunc,NF: integer; TmplDiffFunc: String);
   procedure DiffExpressionN(Expr: String; N: Integer; var SDiff: String);
   procedure DiffTreeP;

   procedure ClearFPUException;
    procedure MaskFPUException(CWAddr: PCardinal);   stdcall;
   //procedure FreeExtFunc(E_Func: TFunction);
   //property  VarShift: Boolean read F_VarShift write F_VarShift default False;
   //property  FuncShift: Boolean read F_FuncShift write F_FuncShift default False;
   property  ShowException: Boolean read F_ShowException write F_ShowException default True;
   property  SyntaxError: Cardinal read  F_SyntaxErrorCode write F_SyntaxErrorCode default 0;
   property  SyntaxErrorString: String read F_SyntaxErrorString write F_SyntaxErrorString;
   //property  CalcError: Integer read F_CalcErrorCode write F_CalcErrorCode default 0;
   property  InternalError: Integer read F_InternalError write F_InternalError default 0;
   property  SyntaxExtension: Boolean read F_SyntaxExtension write F_SyntaxExtension default True;
   procedure SetSyntaxExtension(Val: Boolean); {.341}
   procedure SetSyntaxExtensionForOperations(Val: Boolean); {.341}
   property  ComplexNumber: Boolean  read F_ComplexNumber default False;
   property  PresentVar: Boolean read   F_PresentVar default False;
   property  ExternalException: Boolean read F_ExternalException write F_ExternalException default False;
   property  BeginCalc: Integer read F_BeginCalc write F_BeginCalc default 0;
   procedure RenameFunction(Name,NewName: String);
   property  DataType: Integer read F_DataType write F_DataType default _Extended;
   property  StackDeep: Integer read F_StackDeep write F_StackDeep default 8;
   property  SaveInFPU: boolean read F_SaveInFPU;
   property  DinamicLoad: Boolean read F_DinamicLoadOptimization write F_DinamicLoadOptimization default true;
   //property  OperationOptimizator: Boolean read F_OperationOptimizator write F_OperationOptimizator default true;
   property  ResultType: Cardinal read F_ResultType;
   property  CalcType: Integer read F_CalcType write F_CalcType default T_Complex;
   property  CalcConstExpr: boolean  read  F_CalcConstExpr  write   F_CalcConstExpr default True;
   property  IM_UNIT_NAME: String  read  S_IM_UNIT  write   S_IM_UNIT;
   property  EnableCalcConstExpression: Boolean read F_EnableCalcConstExpression default True;
   procedure SetType(IdType: Cardinal);
   procedure SetObject(Name: String; Addr: Cardinal; IdType: Cardinal; MType: Cardinal; CnctType: Cardinal);
   procedure SetObject2(Name: String; AddrRE,AddrIM: Cardinal; IdType: Cardinal; MType: Cardinal; CnctType: Cardinal);
   procedure SetParam(Name: String; Re,Im: Extended; TypeV: Cardinal);
   procedure SetParamIntrnl(Name: String; Re,Im: Extended; TypeV: Cardinal; IntExt: Cardinal);
   procedure RenameParam(S,SN: String; Re,Im: Extended; TypeF: Integer);
   procedure ExistParam(S: String; var idP: Integer);
   procedure GetParam(idP: Integer; var Re,Im: Extended; var TypeF: Integer);
   procedure DeleteVar(Name: String);
   procedure SetFunctionExt(Name: String; FS:TIntFunc; var idName,idArg: Integer);
   procedure GetFuncAddr(NFunc,NF: Integer; var Addr: Cardinal);
   //procedure SetLoadFunction(IdType: Cardinal; Addr: Cardinal; Name: String);
   procedure SetOperation(OperatorSymb: String; Func: String; PR: Cardinal; NArg: Integer; Pos: Integer);
   procedure SetOperationA(OpName: String; NFunc: Cardinal; PR: Cardinal; NArg: Integer; Pos: Integer; var idOp: Integer);
   procedure GetOperationA(OpName: String; var IdOp: Integer;  var PR: Integer; var Pos: Integer; var NArg: Integer; var NFunc: Integer);
   procedure Operation(IdOp: Integer; act: Boolean);
   function  CheckOperationOnCompound(NameOP: String; PStr: PString; PosOP: Cardinal): Boolean;
   procedure SetRegA(R: Integer; SC: Integer);
   procedure FreeVar;
   procedure FindFunc(Name: String; TV: array of Cardinal; var idn,idf,CallT: integer; var adr: Cardinal);
   procedure DeleteFunc(idn,idf: integer);
   procedure SetExtNameFunc(IDF: Integer; Name: String);     {.191}
   procedure FindFuncA(NameF: String; var NF: Integer);     {.191}
   procedure FindFuncPS(NameF: PString; var NF: Integer);
   procedure FindFuncB(NameF: String; NArg,ResType: Integer; var NFunc,NF: Integer); {.301}
   function  FindExeFunc1V(NFunc,VarType: Integer): Integer;
   procedure FindExprTypePS(PS: PString; var ExprType: Integer);
   procedure SetStdFunc;
   procedure FindZeroArg(NF: Integer; var ni: integer); {.203}
   function  GetIdArgFunc1A(NFunc,NArg,TypeArg: Integer): Integer;
   procedure SetImUnitName(Name: String);
   procedure PushVar;
   procedure PopVar;
   procedure PushParam;
   procedure PopParam;
   property  RecoverImUnit: Boolean read F_RecoverImUnit write F_RecoverImUnit default False;
   procedure SetF(code: Integer; idName,idArg: Integer);
   procedure GetF(code: Integer; idName,idArg: Integer; var Answ: Cardinal);
   procedure FastSpec(Bl: Boolean);
   procedure FastStdFunc(Ft: Integer; Bl: Boolean);
   //procedure FastDiv(Bl: Boolean);
   property  ReplaceFuncs: Boolean read F_ReplaceFunctions write F_ReplaceFunctions default True;    {.193}
   property  ReplaceOps: Boolean read F_ReplaceOperations write F_ReplaceOperations default True;    {.193}
   property  ReplFuncNum:    Integer read Db_ReplFuncNum;
   property  ReplOpNum:    Integer read Db_ReplOpNum;
   property  CalcConstFunc:    Integer read Db_CalcConstFunc;
   property  CalcConstArg:    Integer read Db_CalcConstArg;
   property  CalcConstMulDiv:    Integer read Db_CalcConstMulDiv;
   property  UseVirtAlloc: Boolean   read  F_UseVirtAlloc  write  F_UseVirtAlloc  default False;      {.193}
   procedure SetFunctionInt(Name: String; NFunc: Integer; FS:TIntFunc);
   property  DisableReplaceIF: Boolean read F_DisableReplaceIF  write  F_DisableReplaceIF   default False; {.195}
   procedure FindFuncID(NameF: String; NArg,ResT: Integer; TV,TM: TArrayI; var NFunc,NF: Integer);  {.301}
   function  IsUsedVar(Addr: Cardinal): Integer;     {.333}
   procedure SetDivMode(DivMode: Integer); {.345}
   function  ReplaceAbsBrP(PS: PString): Boolean;
   procedure SetCorrectDynArrayLen(Val: Integer);
   function  FindConst(S: String;  var Re,Im: Extended): Boolean;

   property  FastDivision: Boolean read F_FAST_DIV write F_FAST_DIV default true; {.205}
   property  ReplaceFuncsCF: Boolean read F_ReplaceFunctionsCF write F_ReplaceFunctionsCF default True;    {.217}
   property  MulDivOptimization: Boolean read F_MulDivOptimization write F_MulDivOptimization default True;    {.217A}

   property  DivMode: Integer read M_DIV_MODE write M_DIV_MODE default _fast; {.345}

   property  OperationOptimizatorA1: Boolean read F_OperationOptimizatorA1 write F_OperationOptimizatorA1 default true;
   property  OperationOptimizatorA2: Boolean read F_OperationOptimizatorA2 write F_OperationOptimizatorA2 default true;
   //property  LeadToLowerCase: Boolean read F_LeadToLowerCase write F_LeadToLowerCase default True; {.221}

   property  SkippedIF: Boolean read F_SkippedIF  write  F_SkippedIF   default True; {.221}

   property  PipeBracketToAbs: Boolean read F_PipeBracketToAbs  write  F_PipeBracketToAbs   default True;      {.341}
   property  SquareBracketToTrunc: Boolean read F_SquareBracketToTrunc  write  F_SquareBracketToTrunc   default True;    {.341}
   property  CurlyBracketToFrac: Boolean read F_CurlyBracketToFrac  write  F_CurlyBracketToFrac   default True;  {.341}
   property  ReplaceFuncInPart: Boolean read F_ReplaceFuncInPart  write  F_ReplaceFuncInPart   default True;     {.341}
   property  PreliminarySyntaxError: Boolean read F_PreliminarySyntaxError  write  F_PreliminarySyntaxError   default True;  {.341}
   property  ExtNameFunction: Boolean read F_ExtNameFunction  write  F_ExtNameFunction   default True;  {.341}
   property  SubstNumCX: Boolean read F_SubstNumCX  write  F_SubstNumCX   default True; {.341}

   property  EnableCalcConsExprInMulti: Boolean read F_EnableCalcConsExprInMulti write F_EnableCalcConsExprInMulti default False; {.221}
   property  EnableMaskFpuException: Boolean read F_EnableMaskFpuException write F_EnableMaskFpuException default False; {.229}
   property  FResult: TComplex read FV_Result write FV_Result; {.229}
   property  GetMaxStack: Integer read _MaxStack default 0;
   property  DataInArray: Boolean read F_DataInArray write F_DataInArray  default True;
   property  DiffString: String read S_DiffString write  S_DiffString; {.301}
   property  DiffVar: String read S_DiffVar write  S_DiffVar; {.301}
   property  EnableCheckName: Boolean read F_CheckName  write  F_CheckName   default True;
   property  EnableCalcConstMulDiv: Boolean read F_CalcConstMulDiv write F_CalcConstMulDiv default True;    {.312}
   property  EnableCalcConstARG: boolean  read  F_CalcConstARG  write   F_CalcConstARG default True;
   property  EnableCalcConstFUNC: boolean read  F_CalcConstFUNC  write   F_CalcConstFUNC default True;
   property  IntegerOptimizator:  boolean read F_IntegerOptimization write F_IntegerOptimization default True;
   property  IntegerOptimizatorF: boolean read F_IntegerOptimizationF write F_IntegerOptimizationF default True;
   property  EnableCalcConstExtFunc: boolean read  F_CalcConstExtFunc  write   F_CalcConstExtFunc default True;
   property  EnableAllReplace: boolean read  F_Enable_All_Replace  write   F_Enable_All_Replace default False;    {.347} {.357}
   property  PolyUReWriteConst: boolean read  F_PolyUReWriteConst  write   F_PolyUReWriteConst default True;    {.349}
   property  CanRecompile: Boolean read F_CanRecompile write F_CanRecompile default False; {.347}
   property  UsePointer: Boolean read F_EnableUsePointer write F_EnableUsePointer default True; {.353}
   property  UseIntegerPointer: Boolean read F_EnableUseIntegerPointer write F_EnableUseIntegerPointer default True; {.353}
   property  DinArrayLenCorrect: Integer read c_DinArrayLenCorrect write c_DinArrayLenCorrect default 0; {.357}
   property  CheckArrayTypeConnect: Boolean read F_CheckArrayTypeConnect write F_CheckArrayTypeConnect default False; {.357}
   property  EnableReduceArgOptimizator: Boolean read F_ReduceArgOptimizator write F_ReduceArgOptimizator default True; {.361}
   property  DeleteZeroBranch: Boolean read F_DeleteZeroBranch write F_DeleteZeroBranch default True; {.363}
   property  EnableInline: Boolean read F_EnableInline write F_EnableInline default False; {.365}
   property  UseSaveSW: Boolean read F_UseSaveSW write F_UseSaveSW default True;


   property  TreeOptimization:   Integer  read  F_TreeOptimization write F_TreeOptimization default 3 {_Auto};
   property  DinLoadSDeep:       Integer  read  Db_DinLoadSDeep;
   property  MaxLoadStack:       Integer  read  Db_CmplMaxStack;
   property  DinLoadOverFlow:    Boolean  read  Db_DinLoadOverFlow;
   property  DinLoadNMem:        Integer  read  Db_DinLoadNMem;
   property  LoadStackAfterCalc: Integer  read  Db_LoadStackAfterCalc;
   property  XchBrNXch:          Integer  read  Db_XchBrNXch;
   property  XchBrSDeep:         Integer  read  Db_XchBrSDeep;
   property  CodeSize:           Cardinal read  CodeSizeComplExpr;


  published



  end;

   procedure _SetLenU(AddrV: Pointer; LenV: Integer);  stdcall;
   function _PArrayU(AddrV: Pointer; indx: Integer): Extended; stdcall;
   function _PRealU(AddrV: Pointer): Extended; stdcall;

var



  ForevalH: TForevalH;



implementation

{$IFDEF DEBUGS}
 uses
 testz;
{$ENDIF}

var
MEM,MEM1: Cardinal;
zi: TComplexD;
NameTypeS: array [1..__VarType] of String;
NameMathTypeS: array [1..__MathType] of String;

G_FMT: TFormatSettings;
GotoLab: TArrayPN;//TArrayC;
dbMaxLoadCom, dbFPUBefore,dbFPULoad: Integer;
TE_ADDR: TAddress;
Vdbg: TArrayC;
RZDIV_ADDR, ZDIV_ADDR: Pointer;
AlgVec,AlgVarR: TListSetVar;


//V1: TArrayD;    //test



procedure TForevalH.SetImUnitName(Name: String);
begin
  S_IM_UNIT:=Copy(Name,1,Length(Name));
  Alg.Obj[0].Name:=S_IM_UNIT;
end;




procedure TForevalH.SetType(IdType: Cardinal{; Name: String});
label endp;
var
i: Integer;
begin
{
for i:=0 to High(Alg.Types) do
begin
 if Alg.Types[i] = IdType then goto endp;
end;
}
SetLength(Alg.Types,Length(Alg.Types)+1);
Alg.Types[High(Alg.Types)]:=IdType;

endp:
end;


function TForevalH.CheckName(Name: String): Boolean;
label endp;
var
 //EnName: set of  Char;
 i: integer;
begin

if F_CheckName = True then
begin                                                                             {.221}
 //EnName:=['(',')','{','}','[',']','|','*','/','>','<','=','+','!','@','^',':','-','.',',','$','#','&','%',';','?'];

 if Name <> SChidden then    {.215}
 begin
   for i := 1 to Length(Name) do
   begin
      //if Name[i] in DisableSimbInName then begin CheckName:=False; goto endp; end;
      if not (Name[i] in EnableNameSymb) then begin CheckName:=False; goto endp; end;   {.357}
   end;
    if Name = '' then CheckName:=False else CheckName:=True;
 end
 else
 CheckName:=True;
end
else
CheckName:=True;

 endp:
end;




procedure TForevalH.SetParamIntrnl(Name: String; Re,Im: Extended; TypeV: Cardinal; IntExt: Cardinal);
label endp;
var
i: integer;
Name1: String;
begin

if IntExt = _External then
begin
if CheckName(Name) = false then
 begin
  F_SyntaxErrorCode:=E_WRONG_NAME; F_SyntaxErrorString:=Name; IntException; goto endp;
  end;
end;

//if F_LeadToLowerCase = True then Name:=LowerCase(Name);

 for i := 0 to Length(Alg.Param) - 1 do
   begin
     Name1:=Alg.Param[i].Name;

     if (Name1  = Name) then
     begin
       Alg.Param[i].Real:=Re;
       Alg.Param[i].Imag:=Im;
       Alg.Param[i].TypeF:=TypeV;
       goto endp;
     end;

      if Name1 = SChidden then   //удаленная переменная
      begin
        Alg.Param[i].Real:=Re;
        Alg.Param[i].Imag:=Im;
        Alg.Param[i].TypeF:=TypeV;
        Alg.Param[i].Name:=Copy(Name,1,Length(Name));
       goto endp;
      end;
   end;

 SetLength(Alg.Param,Length(Alg.Param)+1);
 Alg.Param[High(Alg.Param)].TypeF:=TypeV;
 Alg.Param[High(Alg.Param)].Real:=Re;
 Alg.Param[High(Alg.Param)].Imag:=Im;
 Alg.Param[High(Alg.Param)].Name:=Copy(Name,1,Length(Name));

 endp:
end;



procedure TForevalH.SetParam(Name: String; Re,Im: Extended; TypeV: Cardinal);
label endp;
var
i: integer;
Name1: String;
begin

SetParamIntrnl(Name, Re,Im,TypeV,_External);

{
if CheckName(Name) = false then
 begin
  F_SyntaxErrorCode:=E_WRONG_NAME; F_SyntaxErrorString:=Name; IntException; goto endp;
  end;

//if F_LeadToLowerCase = True then Name:=LowerCase(Name);

 for i := 0 to Length(Alg.Param) - 1 do
   begin
     Name1:=Alg.Param[i].Name;

     if (Name1  = Name) then
     begin
       Alg.Param[i].Real:=Re;
       Alg.Param[i].Imag:=Im;
       Alg.Param[i].TypeF:=TypeV;
       goto endp;
     end;

      if Name1 = '@hidden@' then   //удаленная переменная
      begin
        Alg.Param[i].Real:=Re;
        Alg.Param[i].Imag:=Im;
        Alg.Param[i].TypeF:=TypeV;
        Alg.Param[i].Name:=Copy(Name,1,Length(Name));
       goto endp;
      end;
   end;

 SetLength(Alg.Param,Length(Alg.Param)+1);
 Alg.Param[High(Alg.Param)].TypeF:=TypeV;
 Alg.Param[High(Alg.Param)].Real:=Re;
 Alg.Param[High(Alg.Param)].Imag:=Im;
 Alg.Param[High(Alg.Param)].Name:=Copy(Name,1,Length(Name));
 }

 endp:
end;




procedure TForevalH.RenameParam(S,SN: String; Re,Im: Extended; TypeF: Integer);
label endp;
var
i: Integer;
S1: String;
begin
(*
if F_LeadToLowerCase = True then   {.245}
begin
  S:=LowerCase(S);
  SN:=LowerCase(SN);
end;
*)

for i:=0 to High(Alg.Param) do
begin
 S1:= Alg.Param[i].Name;

 if S1 = S then
 begin
   Alg.Param[i].Name:=SN;
   Alg.Param[i].Real:=Re;
   Alg.Param[i].Imag:=Im;
   Alg.Param[i].TypeF:=TypeF;
   goto endp;
 end;
end;

endp:
end;




procedure TForevalH.ExistParam(S: String; var idP: Integer);
label endp;
var
i: Integer;
S1: String;
begin

//if F_LeadToLowerCase = True then S:=LowerCase(S); {.245}

idP:=_NOT_FOUND;

for i:=0 to High(Alg.Param) do
begin
 if Alg.Param[i].Name = S then
 begin
  idP:=i; goto endp;
 end;
end;

endp:
end;





procedure TForevalH.GetParam(idP: Integer; var Re,Im: Extended; var TypeF: Integer);
begin
   Re:=Alg.Param[idP].Real;
   Im:=Alg.Param[idP].Imag;
   TypeF:=Alg.Param[idP].TypeF;
end;




procedure TForevalH.SetObject(Name: String; Addr: Cardinal; IdType: Cardinal; MType: Cardinal; CnctType: Cardinal);
label endp;
var
i,shA: integer;                               //IdType = T_Real, T_Complex, T_Array, T_Pointer
Name1: String;                                //MType =  _Double, _Extended, _Integer, _Pointer, _Single
AddrRE,AddrIM: Cardinal;
begin
 {.343}

 AddrRE:=Addr;
 AddrIM:=0;
 if IdType = T_Complex then
 begin

   if MType =  _Single then    shA:=Sh_S
      else
   if MType =  _Double then    shA:=Sh_D
      else
   if MType =  _Extended then  shA:=Sh_E;


   AddrIM := AddrRE+shA;
 end;

 SetObject2(Name,AddrRE,AddrIM,IdType,MType,CnctType);



(*
if CheckName(Name) = false then
 begin
  F_SyntaxErrorCode:=E_WRONG_NAME; F_SyntaxErrorString:=Name; IntException; goto endp;
  end;

//if F_LeadToLowerCase = True then Name:=LowerCase(Name); {.221}

 for i := 0 to Length(Alg.Obj) - 1 do
   begin
     Name1:=Alg.Obj[i].Name;

     if (Name1  = Name) {and (Alg.Obj[i].TypeF = IdType) and (Alg.Obj[i].MType = MType)} then
     begin
       Alg.Obj[i].Addr:=Addr;
       Alg.Obj[i].TypeF:=IdType;
       Alg.Obj[i].MType:=MType;
       Alg.Obj[i].IsUsed:=_NO;
       goto endp;
     end;

      if Name1 = '@hidden@' then   //удаленная переменная
      begin
       Alg.Obj[i].Addr:=Addr;
       Alg.Obj[i].TypeF:=IdType;
       Alg.Obj[i].MType:=MType;
       Alg.Obj[i].IsUsed:=_NO;
       Alg.Obj[i].Name:=Copy(Name,1,Length(Name));
       goto endp;
      end;
   end;

 SetLength(Alg.Obj,Length(Alg.Obj)+1);
 Alg.Obj[High(Alg.Obj)].TypeF:=IdType;
 Alg.Obj[High(Alg.Obj)].MType:=MType;
 Alg.Obj[High(Alg.Obj)].Addr:=Addr;
 Alg.Obj[High(Alg.Obj)].IsUsed:=_NO;
 Alg.Obj[High(Alg.Obj)].Name:=Copy(Name,1,Length(Name));

 endp:
*)

end;




{.343}
procedure TForevalH.SetObject2(Name: String; AddrRE,AddrIM: Cardinal; IdType: Cardinal; MType: Cardinal; CnctType: Cardinal);
label endp;
var                                         //IdType = T_Real, T_Complex, T_Array, T_Pointer
i: integer;                                 //MType =  _Double, _Extended, _Integer, _Pointer, _Single
Name1: String;
begin


if CheckName(Name) = false then
 begin
     F_SyntaxErrorCode:=E_WRONG_NAME;
     F_SyntaxErrorString:=Name;
     //IntException;
     goto endp;
  end;

//if F_LeadToLowerCase = True then Name:=LowerCase(Name); {.221}

 for i := 0 to Length(Alg.Obj) - 1 do
   begin
     Name1:=Alg.Obj[i].Name;

     //перезаписать новую с таким же именем на место предыдущей
     if (Name1  = Name) {and (Alg.Obj[i].TypeF = IdType) and (Alg.Obj[i].MType = MType)} then
     begin
       Alg.Obj[i].Addr:=AddrRE;
       Alg.Obj[i].AddrIM:=AddrIM;
       Alg.Obj[i].TypeF:=IdType;
       Alg.Obj[i].MType:=MType;
       Alg.Obj[i].IsUsed:=_NO;
       Alg.Obj[i].TypeCnct:=CnctType;
       goto endp;
     end;

      //перезаписать новую  на место удалённой
      if Name1 = SChidden then   //удаленная переменная
      begin
       Alg.Obj[i].Addr:=AddrRE;
       Alg.Obj[i].AddrIM:=AddrIM;
       Alg.Obj[i].TypeF:=IdType;
       Alg.Obj[i].MType:=MType;
       Alg.Obj[i].IsUsed:=_NO;
       Alg.Obj[i].TypeCnct:=CnctType;
       Alg.Obj[i].Name:=Copy(Name,1,Length(Name));
       goto endp;
      end;
   end;

 SetLength(Alg.Obj,Length(Alg.Obj)+1);
 Alg.Obj[High(Alg.Obj)].TypeF:=IdType;
 Alg.Obj[High(Alg.Obj)].MType:=MType;
 Alg.Obj[High(Alg.Obj)].Addr:=AddrRE;
 Alg.Obj[High(Alg.Obj)].AddrIM:=AddrIM;
 Alg.Obj[High(Alg.Obj)].IsUsed:=_NO;
 Alg.Obj[High(Alg.Obj)].TypeCnct:=CnctType;
 Alg.Obj[High(Alg.Obj)].Name:=Copy(Name,1,Length(Name));

 //в AlgVec  записывать все:
endp:
 {.353}
 if idType = T_Array then
 begin
   SetLength(AlgVec,Length(AlgVec)+1);
   //AlgVec[High(AlgVec)].TypeF:=IdType;
   AlgVec[High(AlgVec)].MType:=MType;
   AlgVec[High(AlgVec)].Addr:=AddrRE;
   //AlgVec[High(AlgVec)].AddrIM:=AddrIM;
   //AlgV.Obj[High(AlgV.Obj)].IsUsed:=_NO;
   //AlgV.Obj[High(AlgV.Obj)].Name:=Copy(Name,1,Length(Name));
 end
 else
 if idType = T_Real then
 begin
 //отключена _PRealU
  {
   SetLength(AlgVarR,Length(AlgVarR)+1);

   AlgVarR[High(AlgVarR)].MType:=MType;
   AlgVarR[High(AlgVarR)].Addr:=AddrRE;

   }
 end;


 //endp:
end;




procedure TForevalH.DeleteVar(Name: String);
label endp;
var
Name1: String;
i: integer;
begin

 for i:=0 to Length(Alg.Obj) - 1 do
  begin
   Name1:=Alg.Obj[i].Name;

   if  Name = Name1 then
   begin
     Alg.Obj[i].Addr:=0;
     Alg.Obj[i].TypeF:=0;
     Alg.Obj[i].MType:=0;
     Alg.Obj[i].Name:=SChidden;
    goto endp;
   end;

  end;


endp:
end;




procedure TForevalH.FreeVar;
begin                           //в [0] остаётся мнимая единица
  SetLength(Alg.Obj,0);
  SetObject(S_IM_UNIT,Cardinal(@zi),T_Complex,_Double,_Internal);
  //SetObject('pi',Cardinal(@_PI),T_Real,_Extended);
end;




procedure TForevalH.PushVar;
var
i: Cardinal;
begin

SetLength(G_SaveVar,Length(Alg.Obj));

 for i:=0 to High(Alg.Obj) do
 begin
    G_SaveVar[i].Name:=Alg.Obj[i].Name;
    G_SaveVar[i].Addr:=Alg.Obj[i].Addr;
    G_SaveVar[i].AddrIM:=Alg.Obj[i].AddrIM;
    G_SaveVar[i].TypeF:=Alg.Obj[i].TypeF;
    G_SaveVar[i].MType:=Alg.Obj[i].MType;
    G_SaveVar[i].TypeCnct:=Alg.Obj[i].TypeCnct;
 end;

end;



procedure TForevalH.PopVar;
var
i,Addr,IdType,MType: Cardinal;
begin

if Length(G_SaveVar) > 0 then
begin

 for i:=0 to High(G_SaveVar) do
 begin
  SetObject2(G_SaveVar[i].Name,G_SaveVar[i].Addr,G_SaveVar[i].AddrIM,G_SaveVar[i].TypeF,G_SaveVar[i].MType,G_SaveVar[i].TypeCnct);
 end;

  //SetLength(G_SaveVar,0);
end;
end;




procedure TForevalH.PushParam;
var
i: Cardinal;
begin

SetLength(G_SaveParam,Length(Alg.Param));

 for i:=0 to High(Alg.Param) do
 begin
    G_SaveParam[i].Name:=Alg.Param[i].Name;
    G_SaveParam[i].Real:=Alg.Param[i].Real;
    G_SaveParam[i].Imag:=Alg.Param[i].Imag;
    G_SaveParam[i].TypeF:=Alg.Param[i].TypeF;
 end;

end;



procedure TForevalH.PopParam;
var
i: Cardinal;
begin

if Length(G_SaveParam) > 0 then
begin

 for i:=0 to High(G_SaveParam) do
 begin
  //SetAdditionalParameter(G_SaveParam[i].Name,G_SaveParam[i].Value)
   SetParam(G_SaveParam[i].Name,G_SaveParam[i].Real,G_SaveParam[i].Imag,G_SaveParam[i].TypeF);
 end;

  //SetLength(G_SaveParam,0);
end;
end;



{.191}
procedure TForevalH.FindFuncA(NameF: String; var NF: Integer);
label endp;
var
i,j,LF: Integer;
Sfn: String;
begin
NF:=_NOT_FOUND;

{
 for i:=0 to High(Alg.ExFunc) do
  begin
  LF:=
    for j := 0 to High(Alg.ExFunc[i].NameEx) do
    begin
       Sfn:=Alg.ExFunc[i].NameEx[j];
       if F_FuncShift = False then
       begin
         Sfn:=LowerCase(Sfn);
       end;
       if Sf1 = Sfn then  begin NF:=i;  goto endp; end;
     end;
  end;
 }



 for i:=0 to High(Alg.ExFunc) do
 begin


       if F_ExtNameFunction = True then LF:=High(Alg.ExFunc[i].NameEx)  else
        begin
          if Length(Alg.ExFunc[i].NameEx) <> 0 then  LF:=0 else LF:=-1;
        end;

       for j := 0 to LF do
       begin

          Sfn:=Alg.ExFunc[i].NameEx[j];


          if (NameF = Sfn) and  (Alg.ExFunc[i].Enable = _YES) then
          begin
            NF:=i; goto endp;
          end;

       end;
 end;


endp:
end;



procedure TForevalH.FindFuncPS(NameF: PString; var NF: Integer);
label endp;
var
i,j,LF: Integer;
Sfn: String;
begin
NF:=_NOT_FOUND;


 for i:=0 to High(Alg.ExFunc) do
 begin


       if F_ExtNameFunction = True then LF:=High(Alg.ExFunc[i].NameEx)  else
        begin
          if Length(Alg.ExFunc[i].NameEx) <> 0 then  LF:=0 else LF:=-1;
        end;

       for j := 0 to LF do
       begin

          Sfn:=Alg.ExFunc[i].NameEx[j];


          if (NameF^ = Sfn) and  (Alg.ExFunc[i].Enable = _YES) then
          begin
            NF:=i; goto endp;
          end;

       end;
 end;


endp:
end;





procedure TForevalH.FindFuncB(NameF: String; NArg,ResType: Integer; var NFunc,NF: Integer);
label endp;
var
i,j,k,LF,NFuncFL,TypeFL,NArgFL: Integer;
Sfn: String;
begin
NF:=_NOT_FOUND;
NFunc:=_NOT_FOUND;


 for i:=0 to High(Alg.ExFunc) do
 begin


       if F_ExtNameFunction = True then LF:=High(Alg.ExFunc[i].NameEx)  else
        begin
          if Length(Alg.ExFunc[i].NameEx) <> 0 then  LF:=0 else LF:=-1;
        end;


       for j := 0 to LF do
       begin

          Sfn:=Alg.ExFunc[i].NameEx[j];


          if (NameF = Sfn) and  (Alg.ExFunc[i].Enable = _YES) then
          begin
            NFunc:=i;
            if (NArg = _ANY) and (ResType = _ANY) then   //только по имени
            begin
              goto endp;
            end;


              NFuncFL:=Length(Alg.ExFunc[i].Func);
              for k := 0 to NFuncFL-1 do
              begin
                NArgFL:=Alg.ExFunc[i].Func[k].NArg;
                TypeFL:=Alg.ExFunc[i].Func[k].TypeF;

                if (NArg = _ANY) and (ResType = TypeFL) then   //по имени и возвращаемого типа
                begin
                    NF:=k; goto endp;
                end
                else
                if (NArgFL = NArg) and (ResType = _ANY) then   //по имени и  по числу аргументов
                begin
                    NF:=k; goto endp;
                end
                else
                if (NArgFL = NArg) and (ResType = TypeFL) then    //по имени , числу аргументов   и возвращаемого типа
                begin
                    NF:=k; goto endp;
                end;


              end;



            goto endp;
          end;

       end;
 end;

endp:
end;




function TForevalH.FindExeFunc1V(NFunc,VarType: Integer): Integer;
label endp;
var
k,NF: Integer;
begin
NF:=_NOT_FOUND;

for k := 0 to Length(Alg.ExFunc[NFunc].Func)-1 do
begin
  if   (Alg.ExFunc[NFunc].Func[k].ExeF=_YES) and (Alg.ExFunc[NFunc].Func[k].NArg = 1)   then
  begin
    if Alg.ExFunc[NFunc].Func[k].TV[0] = VarType then
    begin
      NF:=k;
      goto endp;
    end;
  end;

end;


endp:
FindExeFunc1V:=NF;
end;



{.300}
procedure TForevalH.FindFuncID(NameF: String; NArg,ResT: Integer; TV,TM: TArrayI; var NFunc,NF: Integer);
label endp;
var
i,j,k,m,LF: Integer;
Sfn: String;
NFuncFL,NArgFL,TypeFL: Integer;
BH: Boolean;
begin
NF:=_NOT_FOUND;
NFunc:=_NOT_FOUND;


if NArg = _ANY then
begin

end;

 for i:=0 to High(Alg.ExFunc) do
 begin


        if F_ExtNameFunction = True then LF:=High(Alg.ExFunc[i].NameEx)  else
        begin
          if Length(Alg.ExFunc[i].NameEx) <> 0 then  LF:=0 else LF:=-1;
        end;



       for j := 0 to LF do
       begin

          Sfn:=Alg.ExFunc[i].NameEx[j];


          if (NameF = Sfn) and  (Alg.ExFunc[i].Enable = _YES) then
          begin
            NFunc:=i;
            NFuncFL:=Length(Alg.ExFunc[i].Func);

            for k := 0 to NFuncFL-1 do
            begin

              NArgFL:=Alg.ExFunc[i].Func[k].NArg;
              TypeFL:=Alg.ExFunc[i].Func[k].TypeF;

              if ResT = _ANY then
              begin

                BH:=True;
                for m := 0 to NArgFL - 1 do     //сравнение типов аргументов
                begin
                  if (Alg.ExFunc[i].Func[k].TV[m] <> TV[m]) and (TV[m] <> _ANY)  then BH:=False
                  else
                  if (Alg.ExFunc[i].Func[k].TM[m] <> TM[m]) and (TM[m] <> _ANY) then BH:=False;
                end;

                if BH = True then
                begin
                  NF:=k; goto endp;
                end;

              end
              else
              if (NArgFL = NArg) and (ResT = TypeFL) then
              begin

                BH:=True;
                for m := 0 to NArgFL - 1 do     //сравнение типов аргументов
                begin
                  if (Alg.ExFunc[i].Func[k].TV[m] <> TV[m]) and (TV[m] <> _ANY)  then BH:=False
                  else
                  if (Alg.ExFunc[i].Func[k].TM[m] <> TM[m]) and (TM[m] <> _ANY) then BH:=False;
                end;

                if BH = True then
                begin
                  NF:=k; goto endp;
                end;

              end;


            end;

            goto endp;
          end;

       end;
 end;


endp:
end;





procedure TForevalH.GetFuncAddr(NFunc,NF: Integer; var Addr: Cardinal);
begin
Addr:=0;
 if NFunc <= High(Alg.ExFunc) then
   if NF <= High(Alg.ExFunc[NFunc].Func)  then
       Addr:=Alg.ExFunc[NFunc].Func[NF].Addr;
end;





procedure TForevalH.FindZeroArg(NF: Integer; var ni: integer);
label endp;
var
  i: integer;
begin

ni:=-1;

for i := 0 to Length(Alg.ExFunc[NF].Func) - 1 do
begin
  if Alg.ExFunc[NF].Func[i].NArg  = 0 then begin ni:=i; goto endp; end;

end;

endp:
end;





function TForevalH.GetIdArgFunc1A(NFunc,NArg,TypeArg: Integer): Integer;
label endp;
var
  i,idArg: integer;
begin
{возвращает idArg(=NF) для ф- ии с одним аргументом с заданным типом аргумента TypeArg по заданному idFunc(=NFunc) }
// NArg = 1 !!!
idArg:=_NOT_FOUND; //=NF

for i := 0 to Length(Alg.ExFunc[NFunc].Func) - 1 do
begin
  if Alg.ExFunc[NFunc].Func[i].NArg  = NArg then
  begin
    if Alg.ExFunc[NFunc].Func[i].TV[0] = TypeArg then
    begin
      idArg:=i;
      goto endp;
    end;
  end;

end;

endp:
GetIdArgFunc1A:=idArg;
end;




procedure TForevalH.SetFunctionExt(Name: String; FS:TIntFunc; var idName,idArg: Integer);
begin
    SetFunction(Name,FS);                     //idName=NFunc; idArg=NF
    idName:=G_idName;
    idArg:=G_idArg;
end;


procedure TForevalH.SetNewFunc(NameF: String; NFunc,NF: Integer; FS:TIntFunc; Com: Integer; var idName,idArg: Integer);

       function _FindDeletedSubFunction(NFunc: Integer): Integer;
       label endp;
       var
        ni,NF: Integer;
       begin
          NF:=_NOT_FOUND; //=-1 !!!
          for ni := 0 to High(Alg.ExFunc[NFunc].Func) do
          begin
            if Alg.ExFunc[NFunc].Func[ni].Enable = _DELETED then
            begin
               NF:=ni; goto endp;
            end;
          end;

          endp:
          _FindDeletedSubFunction:=NF;
       end;
var
 j,m,NF1: integer;
begin

  if Com = _New then
  begin
    NFunc:=Length(Alg.ExFunc);
    SetLength(Alg.ExFunc,NFunc+1);
    NF:=0;
    SetLength(Alg.ExFunc[NFunc].Func,NF+1);
    Alg.ExFunc[NFunc].Name:=Copy(NameF,1,Length(NameF));
  end
  else
  if Com = _NewOverload then
  begin
  //*******************************************
    {.365}
    NF:=_FindDeletedSubFunction(NFunc);
    if NF =  _NOT_FOUND then
    begin
      NF:=Length(Alg.ExFunc[NFunc].Func);
      SetLength(Alg.ExFunc[NFunc].Func,NF+1);
    end;
    {
    NF:=Length(Alg.ExFunc[NFunc].Func);
    SetLength(Alg.ExFunc[NFunc].Func,NF+1);
    }
  end
  else
  if Com = _Internal then  //NFunc - задан
  begin
    Alg.ExFunc[NFunc].Name:=Copy(NameF,1,Length(NameF));
    NF:=Length(Alg.ExFunc[NFunc].Func);
    SetLength(Alg.ExFunc[NFunc].Func,NF+1);
   // Alg.ExFunc[NFunc].Name:=Copy(NameF,1,Length(NameF));
  end;




  {K:=High(Alg.ExFunc);
  N:=High(Alg.ExFunc[K].Func);
  SetLength(Alg.ExFunc[K].Func,Length(Alg.ExFunc[K].Func)+1);
  N:=N+1; }

  Alg.ExFunc[NFunc].Func[NF].TypeF:=FS.TypeF;
  Alg.ExFunc[NFunc].Func[NF].TypeM:=FS.TypeM;   {.353}
  Alg.ExFunc[NFunc].Func[NF].CallT:=FS.CallT;
  Alg.ExFunc[NFunc].Func[NF].Addr:=FS.Addr;
  Alg.ExFunc[NFunc].Func[NF].Arrow:=FS.Arrow;
  Alg.ExFunc[NFunc].Func[NF].CLST:=FS.CLST;
  Alg.ExFunc[NFunc].Func[NF].SDeep:=FS.SDeep;
  Alg.ExFunc[NFunc].Func[NF].NArg:=FS.NArg;
  //Alg.ExFunc[NFunc].NArg:=FS.N; {.301}
  //Alg.ExFunc[NFunc].DFTmpl:=_NO; {.301}
  Alg.ExFunc[NFunc].Func[NF].DFTmpl:=_NO; {.301}
  Alg.ExFunc[NFunc].Func[NF].CalcConst:=FS.CalcConst;
  Alg.ExFunc[NFunc].Func[NF].IntF:=FS.IntF;
  Alg.ExFunc[NFunc].Func[NF].ExeF:=_YES;//всегда исполняемая: т.к. внешняя
  Alg.ExFunc[NFunc].Func[NF].SaveReg:=FS.SaveReg;
  Alg.ExFunc[NFunc].Func[NF].CodeSize:=FS.CodeSize;   {.365}
  Alg.ExFunc[NFunc].Func[NF].IsInline:=FS.IsInline;    {.365}
  Alg.ExFunc[NFunc].Func[NF].Enable:=_YES;              {.365}


  SetLength(Alg.ExFunc[NFunc].Func[NF].TV,Length(FS.TV));
  SetLength(Alg.ExFunc[NFunc].Func[NF].TM,Length(FS.TM));
  for j:=0 to High(FS.TV) do
  begin
   Alg.ExFunc[NFunc].Func[NF].TV[j]:=FS.TV[j];
   Alg.ExFunc[NFunc].Func[NF].TM[j]:=FS.TM[j];
  end;
  if FS.CallT = _Compiled  then
    begin
     SetLength(Alg.ExFunc[NFunc].Func[NF].ArgAdr,Length(FS.ArgAdr));
     for m:=0 to High(FS.ArgAdr) do
         Alg.ExFunc[NFunc].Func[NF].ArgAdr[m]:=FS.ArgAdr[m];
    end;
    FS.ArgAdr:=nil;
  {.191}
  if Length(Alg.ExFunc[NFunc].NameEx) = 0 then
  begin
    SetLength(Alg.ExFunc[NFunc].NameEx,1);
    Alg.ExFunc[NFunc].NameEx[0]:=Copy(NameF,1,Length(NameF));
  end;

  Alg.ExFunc[NFunc].Enable:=_YES;
  Alg.ExFunc[NFunc].ReplFunc:=FS.ReplFunc;     {.193}
  Alg.ExFunc[NFunc].Func[NF].Set_ID:=FS.Set_ID;
  Alg.ExFunc[NFunc].Func[NF].Id_Func:=FS.ID_Func;
  //Alg.ExFunc[NFunc].XchArg  := FS.XchArg;

  idName:=NFunc;
  idArg:=NF;
end;



procedure TForevalH.SetFunction(Name: String; FS:TIntFunc);
label endp,newf,nxtf;                      //TV - массив с типами переменных (array of types of variables) T_Real,T_Complex,T_Array
var                                         //TypeF - возвращаемый тип функции (returned  type of function) T_Real,T_Complex
                                          //TM - массив с типами переменных (array of types of variables) _Double,_Extended,_Integer
N,K,i,j,m,bf,nf,m1,NFunc,idName,idArg,Place: Integer;
begin

G_idName:=-1;
G_idArg:=-1;

if CheckName(Name) = false then begin F_SyntaxErrorCode:=E_WRONG_NAME; F_SyntaxErrorString:=Name; IntException; goto endp; end;

Place:=FS.Place;

   FindFuncID(Name,FS.NArg,FS.TypeF,FS.TV,FS.TM,NFunc,NF);

   if Place = _ReWrite then
   begin

    if NFunc = _NOT_FOUND then    //установка новой ф-ии с новым именем:
       SetNewFunc(Name,_ANY,_ANY, FS, _New, idName,idArg)
    else
    if NF = _NOT_FOUND then       //установка новой ф-ии с таким же именем: (с другим набором аргументов)
       SetNewFunc(Name,NFunc,_ANY, FS, _NewOverload, idName,idArg)
    else                        //переустановка аналогичной ф-ии:    (с таким-же набором аргументов)
       SetNewFunc(Name,NFunc,NF,FS,_ReWrite,idName,idArg);

   end
   else     {.308}
   if Place = _New then
   begin

    if NFunc = _NOT_FOUND then    //установка новой ф-ии с новым именем:
       SetNewFunc(Name,_ANY,_ANY, FS, _New, idName,idArg)
    else
    if NF = _NOT_FOUND then       //установка новой ф-ии с таким же именем: (с другим набором аргументов)
       SetNewFunc(Name,NFunc,_ANY, FS, _NewOverload, idName,idArg)
    else                        // установка новой ф-ии с таким же именем:    (с таким-же набором аргументов)
       SetNewFunc(Name,_ANY,_ANY, FS, _New, idName,idArg)

   end;





endp:
G_idName:=idName;
G_idArg:=idArg;

end;



procedure TForevalH.SetFunctionInt(Name: String; NFunc: Integer; FS:TIntFunc);
label endp,newf;                                  //TV - массив с типами переменных (array of types of variables) T_Real,T_Complex,T_Array
var                                          //TypeF - возвращаемый тип функции (returned  type of function) T_Real,T_Complex
N,K,i,j,m,bf,nf,m1,id: Integer;                       //TM - массив с типами переменных (array of types of variables) _Double,_Extended,_Integer
idName,idArg: Integer;
begin

SetNewFunc(Name,NFunc,_ANY,FS,_Internal,idName,idArg);

endp:
end;




procedure TForevalH.FindFunc(Name: String; TV: array of Cardinal; var idn,idf,CallT: integer; var adr: Cardinal);
label endp;
var
i,j,N,K,m,bf,LF: Integer;
  nf: Integer;
  Sfn:String;
begin
adr:=0; CallT:=0; idn:=-1; idf:=-1;
{.191}



{for i:=0 to High(Alg.ExFunc) do
  begin
   if Name = Alg.ExFunc[i].Name then
   begin
    K:=i;
    N:=High(Alg.ExFunc[K].Func);
    //проверка существования такой же функции:
    for m := 0 to High(Alg.ExFunc[K].Func) do
    begin
     if Length(TV) = Length(Alg.ExFunc[K].Func[m].TV) then
     begin
       bf:=0;
       for j:=0 to High(TV) do
       begin
        if Alg.ExFunc[K].Func[m].TV[j] = TV[j] then inc(bf);
       end;
       if bf = Length(TV) then
       begin
         CallT:=Alg.ExFunc[K].Func[m].CallT;
         adr:=Alg.ExFunc[K].Func[m].Addr;
         idn:=K;
         idf:=m;
         goto endp;
       end;
     end;
    end;
   end;
  end; }


  {if F_SyntaxExtension = True then
  begin}

     for i:=0 to High(Alg.ExFunc) do
     begin


       if F_ExtNameFunction = True then LF:=High(Alg.ExFunc[i].NameEx)  else
        begin
          if Length(Alg.ExFunc[i].NameEx) <> 0 then  LF:=0 else LF:=-1;
        end;

       for nf := 0 to LF do
       begin

         SFn:=Alg.ExFunc[i].NameEx[nf];



        if Name = Sfn then
        begin
          K:=i;
          N:=High(Alg.ExFunc[K].Func);
         //проверка существования такой же функции:
         for m := 0 to High(Alg.ExFunc[K].Func) do
         begin
           if Length(TV) = Length(Alg.ExFunc[K].Func[m].TV) then
           begin
              bf:=0;
              for j:=0 to High(TV) do
              begin
               if Alg.ExFunc[K].Func[m].TV[j] = TV[j] then inc(bf);
              end;
              if bf = Length(TV) then
              begin
                CallT:=Alg.ExFunc[K].Func[m].CallT;
                adr:=Alg.ExFunc[K].Func[m].Addr;
                idn:=K;
                idf:=m;
                goto endp;
              end;
           end;
         end;
        end;
       end;
     end;

  //end;

endp:
end;




procedure TForevalH.DeleteFunc(idn,idf: integer);
var
arg: integer;
begin
if idf = _ANY then
begin
  SetLength(Alg.ExFunc[idn].Func,0);
  Alg.ExFunc[idn].Enable:=_NO;
  Alg.ExFunc[idn].Name:='@deleted@';
end
else
begin
  arg:=Alg.ExFunc[idn].Func[idf].NArg;
  Alg.ExFunc[idn].Func[idf].TV:=nil;
  Alg.ExFunc[idn].Func[idf].TM:=nil;
  Alg.ExFunc[idn].Func[idf].addr:=0;
  Alg.ExFunc[idn].Func[idf].NArg:=0;  {.365}
  Alg.ExFunc[idn].Func[idf].CallT:=0;
  Alg.ExFunc[idn].Func[idf].TypeF:=0;
  Alg.ExFunc[idn].Func[idf].IntF:=0;
  Alg.ExFunc[idn].Func[idf].Enable:=_DELETED;   {.365}

  if arg = 0 then  SetLength(Alg.ExFunc[idn].Func,0); {.207}  //void()=x

end;
end;



procedure TForevalH.SetF(code: Integer; idName,idArg: Integer);
var
i: integer;
begin
if (idName >= 0) and (idName <=  Length(Alg.ExFunc) - 1) then
begin
  if code = 1 then  Alg.ExFunc[idName].Enable:=_YES else
  if code = 2 then  Alg.ExFunc[idName].Enable:=_NO  else
  if code = 3 then
  begin
     if idName = CM_DIV then     Alg.ExFunc[CM_DIV].ReplFunc:=_Yes    else
     if idName = CM_MUL then     Alg.ExFunc[CM_MUL].ReplFunc:=_Yes    else
     if idName = CM_ADD then     Alg.ExFunc[CM_ADD].ReplFunc:=_Yes    else
     if idName = CM_SUB then     Alg.ExFunc[CM_SUB].ReplFunc:=_Yes    else
     if idName = CM_NEG then     Alg.ExFunc[CM_NEG].ReplFunc:=_Yes    else
     if idName = CM_LDSVX then   Alg.ExFunc[CM_LDSVX].ReplFunc:=_Yes    ;
  end
  else
  if code = 4 then
  begin
     if idName = CM_DIV then     Alg.ExFunc[CM_DIV].ReplFunc:=_No    else
     if idName = CM_MUL then     Alg.ExFunc[CM_MUL].ReplFunc:=_No    else
     if idName = CM_ADD then     Alg.ExFunc[CM_ADD].ReplFunc:=_No    else
     if idName = CM_SUB then     Alg.ExFunc[CM_SUB].ReplFunc:=_No    else
     if idName = CM_NEG then     Alg.ExFunc[CM_NEG].ReplFunc:=_No    else
     if idName = CM_LDSVX then   Alg.ExFunc[CM_LDSVX].ReplFunc:=_No    ;
  end
  else
  if code = 5 then   SetNewFuncToOperation('^',idName)   {.195}
  else
  if code = 6 then
  begin                  {.215}
   Alg.ExFunc[idName].ReplFunc:=_YES;
   for i := 0 to Length(Alg.ExFunc[idName].Func) - 1 do   Alg.ExFunc[idName].Func[i].ReplFunc:=_YES;
  end
  else
  if code = 7 then
  begin                  {.215}
   Alg.ExFunc[idName].ReplFunc:=_NO;
   for i := 0 to Length(Alg.ExFunc[idName].Func) - 1 do   Alg.ExFunc[idName].Func[i].ReplFunc:=_NO;
  end
  else
  if code = 8 then      {.215}
  begin
   for i := 0 to Length(Alg.ExFunc[idName].Func) - 1 do   Alg.ExFunc[idName].Func[i].CalcConst:=_YES;
  end
  else
  if code = 9 then      {.215}
  begin
   for i := 0 to Length(Alg.ExFunc[idName].Func) - 1 do   Alg.ExFunc[idName].Func[i].CalcConst:=_NO;
  end
  else
  if code = 10 then      {.217}
  begin
    Alg.ExFunc[idName].ReplFuncCFR:=_NO;
  end
  else
  if code = 11 then      {.217}
  begin
    Alg.ExFunc[idName].ReplFuncCFZ:=_NO;
  end
  else
  if code = 12 then      {.217}
  begin
    Alg.ExFunc[idName].ReplFuncCFR:=_YES;
  end
  else
  if code = 13 then      {.217}
  begin
    Alg.ExFunc[idName].ReplFuncCFZ:=_YES;
  end
  else
  if code = 14 then
  begin
     for i := 0 to Length(Alg.ExFunc)  - 1 do
       begin
          Alg.ExFunc[i].ReplFuncCFR:=_NO;
       end;
  end
  else
  if code = 15 then
  begin
     for i := 0 to Length(Alg.ExFunc)  - 1 do
       begin
          Alg.ExFunc[i].ReplFuncCFZ:=_NO;
       end;
  end
   else
  if code = 16 then
  begin
     for i := 0 to Length(Alg.ExFunc)  - 1 do
       begin
          Alg.ExFunc[i].ReplFuncCFR:=_YES;
       end;
  end
  else
  if code = 17 then
  begin
     for i := 0 to Length(Alg.ExFunc)  - 1 do
       begin
          Alg.ExFunc[i].ReplFuncCFZ:=_YES;
       end;
  end ;


end;
//ForevalZ_Command.F_FastSpec:=True;
end;




function TForevalH.IsUsedVar(Addr: Cardinal): Integer;     {.333}
label endp;
var
i: integer;
begin

  for i:=0 to High(Alg.Obj) do
  begin
    if Addr = Alg.Obj[i].Addr
    then
    begin
      IsUsedVar:= Alg.Obj[i].IsUsed;
      goto endp;
    end;
  end;

 endp:
end;



procedure TForevalH.GetF(code: Integer; idName,idArg: Integer; var Answ: Cardinal);
var
i: integer;
begin
Answ:=0;

if (idName >= 0) and (idName <=  Length(Alg.ExFunc) - 1) then
begin
 if code = _ADDR then
 begin
   if (idArg >= 0 ) and (idArg <= High( Alg.ExFunc[idName].Func)) then  Answ:=Alg.ExFunc[idName].Func[idArg].Addr;
 end
 else
 if code = _CALL_TYPE then
 begin
    if (idArg >= 0 ) and (idArg <= High( Alg.ExFunc[idName].Func)) then  Answ:=Alg.ExFunc[idName].Func[idArg].CallT;
 end



(*
  if code = 1 then  Alg.ExFunc[IDF].Enable:=_YES else
  if code = 2 then  Alg.ExFunc[IDF].Enable:=_NO  else
  if code = 3 then
  begin
     if IDF = CM_DIV then     Alg.ExFunc[CM_DIV].ReplFunc:=_Yes    else
     if IDF = CM_MUL then     Alg.ExFunc[CM_MUL].ReplFunc:=_Yes    else
     if (IDF = CM_ADD) or (IDF = CM_SUB) then   begin  Alg.ExFunc[CM_ADD].ReplFunc:=_Yes; Alg.ExFunc[CM_SUB].ReplFunc:=_Yes; end
  end
  else
  if code = 4 then
  begin
     if IDF = CM_DIV then     Alg.ExFunc[CM_DIV].ReplFunc:=_No    else
     if IDF = CM_MUL then     Alg.ExFunc[CM_MUL].ReplFunc:=_No    else
     if (IDF = CM_ADD) or (IDF = CM_SUB) then   begin  Alg.ExFunc[CM_ADD].ReplFunc:=_No; Alg.ExFunc[CM_SUB].ReplFunc:=_No; end
  end
  else
  if code = 5 then   SetNewFuncToOperation('^',IDF)   {.195}
  else
  if code = 6 then
  begin                  {.215}
   Alg.ExFunc[IDF].ReplFunc:=_YES;
   for i := 0 to Length(Alg.ExFunc[IDF].Func) - 1 do   Alg.ExFunc[IDF].Func[i].ReplFunc:=_YES;
  end
  else
  if code = 7 then
  begin                  {.215}
   Alg.ExFunc[IDF].ReplFunc:=_NO;
   for i := 0 to Length(Alg.ExFunc[IDF].Func) - 1 do   Alg.ExFunc[IDF].Func[i].ReplFunc:=_NO;
  end
  else
  if code = 8 then      {.215}
  begin
   for i := 0 to Length(Alg.ExFunc[IDF].Func) - 1 do   Alg.ExFunc[IDF].Func[i].CalcConst:=_YES;
  end
  else
  if code = 9 then      {.215}
  begin
   for i := 0 to Length(Alg.ExFunc[IDF].Func) - 1 do   Alg.ExFunc[IDF].Func[i].CalcConst:=_NO;
  end
  else
  if code = 10 then      {.217}
  begin
    Alg.ExFunc[IDF].ReplFuncCFR:=_NO;
  end
  else
  if code = 11 then      {.217}
  begin
    Alg.ExFunc[IDF].ReplFuncCFZ:=_NO;
  end
  else
  if code = 12 then      {.217}
  begin
    Alg.ExFunc[IDF].ReplFuncCFR:=_YES;
  end
  else
  if code = 13 then      {.217}
  begin
    Alg.ExFunc[IDF].ReplFuncCFZ:=_YES;
  end
  else
  if code = 14 then
  begin
     for i := 0 to Length(Alg.ExFunc)  - 1 do
       begin
          Alg.ExFunc[i].ReplFuncCFR:=_NO;
       end;
  end
  else
  if code = 15 then
  begin
     for i := 0 to Length(Alg.ExFunc)  - 1 do
       begin
          Alg.ExFunc[i].ReplFuncCFZ:=_NO;
       end;
  end
   else
  if code = 16 then
  begin
     for i := 0 to Length(Alg.ExFunc)  - 1 do
       begin
          Alg.ExFunc[i].ReplFuncCFR:=_YES;
       end;
  end
  else
  if code = 17 then
  begin
     for i := 0 to Length(Alg.ExFunc)  - 1 do
       begin
          Alg.ExFunc[i].ReplFuncCFZ:=_YES;
       end;
  end ;

 *)
end;
//ForevalZ_Command.F_FastSpec:=True;
end;



procedure TForevalH.FastSpec(Bl: Boolean);
begin
 Foreval_SpecFunc.F_FastSpec:=Bl;
end;


procedure TForevalH.FastStdFunc(Ft: Integer; Bl: Boolean);
begin

 if Ft = _Real then
 begin
    Foreval_Command.F_FastStdFuncReal:=Bl;
    F_FAST_STD_FUNC_REAL:=Bl;
    F_FAST_STD_FUNC:=Bl;
 end
 else
 if Ft = _Complex then
 begin
    Foreval_Command.F_FastStdFuncComplex:=Bl;
    F_FAST_STD_FUNC_COMPLEX:=Bl;
    F_FAST_STD_FUNC:=Bl;
 end;

  //SetStdFunc;

end;





{.345}
procedure TForevalH.SetDivMode(DivMode: Integer);
begin
  M_DIV_MODE:=DivMode;

  if M_DIV_MODE = _fast then
  begin
     F_FAST_DIV:=True;

     {не используется:}
     RZDIV_ADDR:=@Z_RZDIV_FAST;
     ZDIV_ADDR:=@Z_DIV_FAST;
     //Foreval_Command.F_FastDiv:=1;
  end
  else
  if M_DIV_MODE = _standard then
  begin
     F_FAST_DIV:=False;
     RZDIV_ADDR:=@Z_RZDIV_STD;
     ZDIV_ADDR:=@Z_DIV_STD;
    //Foreval_Command.F_FastDiv:=0;
  end
  else
  if M_DIV_MODE = _accurate then
  begin
     F_FAST_DIV:=False;
     RZDIV_ADDR:=@Z_RZDIV_ACC;
     ZDIV_ADDR:=@Z_DIV_ACC;
    //Foreval_Command.F_FastDiv:=0;
  end
  else
  if M_DIV_MODE = _extra then
  begin
     F_FAST_DIV:=False;
     RZDIV_ADDR:=@Z_RZDIV_EXTRA;
     ZDIV_ADDR:=@Z_DIV_EXTRA;
    //Foreval_Command.F_FastDiv:=0;
  end;



  Foreval_Command.SetDivCommand(DivMode);
end;



procedure TForevalH.SetNewFuncToOperation(OpName: String; IDF: Cardinal);  {.195}
label endp;
var
i: Integer;
begin


for i:=0 to High(Alg.Opr) do
begin
    if OpName =  Alg.Opr[i].Name then
    begin
     Alg.Opr[i].NFunc:=IDF;
     goto endp;
    end;
end;


endp:
end;


procedure TForevalH.SetExtNameFunc(IDF: Integer; Name: String);     {.191}
var
L: Integer;                          //IDF = NFunc = idName
begin
if IDF >=0 then
begin
 //if F_LeadToLowerCase = True then Name:=LowerCase(Name); {.221}
 L:=Length(Alg.ExFunc[IDF].NameEx);
 SetLength(Alg.ExFunc[IDF].NameEx,L+1);
 Alg.ExFunc[IDF].NameEx[L]:=Name;
end;
end;

{
procedure TForevalH.SetLoadFunction(IdType: Cardinal; Addr: Cardinal; Name: String);
begin
 SetLength(Alg.LdFunc,Length(Alg.LdFunc)+1);
 Alg.LdFunc[High(Alg.LdFunc)].TypeF:=IdType;
 Alg.LdFunc[High(Alg.LdFunc)].Addr:=Addr;
 Alg.LdFunc[High(Alg.LdFunc)].Name:=Name;
end;
}


procedure TForevalH.SetOperation(OperatorSymb: String; Func: String; PR: Cardinal; NArg: Integer; Pos: Integer);
label 1;
var
i,nf: Integer;                             //Операции взывают только 1,2 - аргументные ф-ии
begin                                      //PR - priority; Pos - place (one arg. op. :_before; _after   two arg. op. _between) ;
nf:=-1;
for i:=0 to High(Alg.ExFunc) do
begin
 if Func = Alg.ExFunc[i].Name then
 begin
  nf:=i; goto 1;
 end;
end;

1:
if nf = -1 then begin {Error} end;
if PR <= 0 then begin {Error} end;

SetLength(Alg.Opr,Length(Alg.Opr)+1);
Alg.Opr[High(Alg.Opr)].Name:=OperatorSymb{[1]};
Alg.Opr[High(Alg.Opr)].NFunc:=nf;
Alg.Opr[High(Alg.Opr)].PR:=PR;
Alg.Opr[High(Alg.Opr)].Pos:=Pos;
Alg.Opr[High(Alg.Opr)].NArg:=NArg;
//Alg.Opr[High(Alg.Opr)].GS:=GS;
//Alg.Opr[High(Alg.Opr)].SE:=SE;
Alg.Opr[High(Alg.Opr)].Enable:=True;
Alg.Opr[High(Alg.Opr)].LenOp:=Length(OperatorSymb);
end;




{.339}
procedure TForevalH.SetOperationA(OpName: String; NFunc: Cardinal; PR: Cardinal; NArg: Integer; Pos: Integer; var idOp: Integer);
label endp;
var
i,nf: Integer;                             //Операции взывают только 1,2 - аргументные ф-ии
begin                                     //PR - priority; Pos - place (one arg. op. :_before; _after   two arg. op. _between) ;

if (NFunc < Length(Alg.ExFunc)) and (PR > 0) then
begin


  for i:=0 to High(Alg.Opr) do
  begin
    if (OpName = Alg.Opr[i].Name) and (Pos = Alg.Opr[i].Pos) and (NArg = Alg.Opr[i].NArg) then
    begin
     Alg.Opr[i].Name:=OpName;
     Alg.Opr[i].NFunc:=NFunc;
     Alg.Opr[i].PR:=PR;
     Alg.Opr[i].Enable:=True;
     //Alg.Opr[i].GS:=GS;
     //Alg.Opr[i].SE:=0;//SE;
     idOp:=i;
     goto endp;
    end;
  end;

  SetLength(Alg.Opr,Length(Alg.Opr)+1);
  Alg.Opr[High(Alg.Opr)].Name:=OpName;
  Alg.Opr[High(Alg.Opr)].NFunc:=NFunc;
  Alg.Opr[High(Alg.Opr)].PR:=PR;
  Alg.Opr[High(Alg.Opr)].Pos:=Pos;
  Alg.Opr[High(Alg.Opr)].NArg:=NArg;
  Alg.Opr[High(Alg.Opr)].Enable:=True;
  Alg.Opr[High(Alg.Opr)].LenOp:=Length(OpName);
  idOp:=High(Alg.Opr);
end;

endp:
end;



{.339}
procedure TForevalH.GetOperationA(OpName: String; var IdOp: Integer;  var PR: Integer; var Pos: Integer; var NArg: Integer; var NFunc: Integer);
label endp;
var
i,nf: Integer;
begin

IdOp:=-1;
NFunc:=-1;
PR:=-1;
Pos:=-1;
NArg:=-1;

  for i:=0 to High(Alg.Opr) do
  begin
    if OpName = Alg.Opr[i].Name then
    begin
     IdOp:=i;
     NFunc:=Alg.Opr[i].NFunc;
     PR:=Alg.Opr[i].PR;
     Pos:=Alg.Opr[i].Pos;
     NArg:=Alg.Opr[i].NArg;
     goto endp;
    end;
  end;


endp:
end;



procedure TForevalH.Operation(IdOp: Integer; act: Boolean);  {.339}
begin
 if (IdOp < Length(Alg.Opr)) then
 begin
   Alg.Opr[IdOp].Enable:=act;
 end;
end;



function TForevalH.CheckOperationOnCompound(NameOP: String; PStr: PString; PosOP: Cardinal): Boolean;
label endp;
var                                       //PNameOP: Имя операции; PStr: Полная строка выражения с операцией; PosOP: позиция этой операции в этой строке
i,nf,Pop1,Pop2,Lop: Integer;
BAnsw: Boolean;
begin
BAnsw:=False;
for i:=0 to High(Alg.Opr) do
begin

 Pop1:=Pos(NameOP,Alg.Opr[i].Name);
 if Pop1 > 0 then
 begin
  Pop2:=Pos(Alg.Opr[i].Name,PStr^);
  if (Pop2 > 0) and (PosOP >= Pop2) and (Length(NameOP)+PosOP <= (Alg.Opr[i].LenOp+Pop2)) then
  begin
    BAnsw:=True;
    goto endp;
  end;

 end;

end;

endp:
CheckOperationOnCompound:=BAnsw;
end;




procedure TForevalH.SetStackSize;
label endp;
begin
if F_SyntaxErrorCode <> 0 then goto endp;
Tree:=BeginTree;   //не обязательно, т.к. чтение дерева - циклически

while Tree^.Ch <> nil do
begin
Tree:=Tree^.Ch;
end;
StackSize:=Tree^.Stack.S;

while Tree^.Pr <> nil do
begin
 while Tree^.Nb <> nil  do
 begin
 Tree:=Tree^.Nb;
  while Tree^.Ch <> nil do
  begin
  Tree:=Tree^.Ch;
  end;
if Tree^.Stack.S > StackSize then StackSize:=Tree^.Stack.S;
 end;
 Tree:=Tree^.Pr;
if Tree^.Stack.S > StackSize then StackSize:=Tree^.Stack.S;
end;


endp:
end;



//главная процедура создания синтаксического  дерева выражения
procedure TForevalH.TreeBuilder(S: String);      //creating of tree of expression
label endp;
var
HS: PLevel;
ND: TDataNode;
H,H1: PNode;
EOFN: Boolean;
i: Cardinal;
begin
if F_SyntaxErrorCode <> 0 then goto endp;
New(Tree);
Tree^.Ch:=nil;
Tree^.Nb:=nil;
Tree^.Pr:=nil;
BeginTree:=Tree;
//вершина дерева:
Tree^.Expression:=Copy(S,1,Length(S));
Tree^.Stack.S:=1;
F_IdN:=0;
Tree^.IdL:=0;
Tree^.ExtFunc:=_NOT_FOUND; {.309}
EOFN:=True;

//SyntaxAnalizator(Tree^.Expression,ND,HS,EOFN);
//разбор текущего подвыражения (узла)
SyntaxAnalizatorGT(ND,HS,EOFN);
//спуск до нижнего левого:
//COP<>NOP:
while EOFN <> True do   //EOFN = End OF Node последний узел текущей ветви
begin
 if F_SyntaxErrorCode <> 0 then goto endp;

 New(H);
 Tree^.Ch:=H;
 inc(F_IdN);
 WriteNodeParam(ND);       //запись параметров найденной команды (узла)
 WriteLevelParam(H,HS,0);  //запись параметров вытекающих узлов из главного узла


 H^.Stack.S:=Tree^.Stack.S;
 H^.Pr:=Tree;
 H1:=H;
 H^.Ch:=nil;
 H^.Nb:=nil;

 for i:=1 to High(HS) do
 begin
  New(H);
  H^.Ch:=nil;
  H^.Nb:=nil;
  WriteLevelParam(H,HS,i);
  H^.Stack.S:=H1^.Stack.S+1;
  H1.Nb:=H;
  H^.Pr:=Tree;
  //HS:=HS^.Next;
  H1:=H;
 end;
 Tree:=H^.Pr^.Ch;
 HS:=nil; //??? (освобождение массива уровня)
 //SyntaxAnalizator(Tree^.Expression,ND,HS,EOFN);
 SyntaxAnalizatorGT(ND,HS,EOFN);
end;
//EOFN=True: последняя команда узла (нижний левый)
inc(F_IdN);
WriteNodeParam(ND);

//подъём:
while Tree^.Pr <> nil do
begin
 while Tree^.Nb <> nil  do
 begin
 Tree:=Tree^.Nb;
 //SyntaxAnalizator(Tree^.Expression,ND,HS,EOFN);
 SyntaxAnalizatorGT(ND,HS,EOFN);
//COP<>NOP:
while EOFN<>True do
 begin
 if F_SyntaxErrorCode <> 0 then goto endp;

 New(H);
 Tree^.Ch:=H;
 inc(F_IdN);
 WriteNodeParam(ND);
 WriteLevelParam(H,HS,0);

 H^.Stack.S:=Tree^.Stack.S;
 H^.Pr:=Tree;
 H1:=H;
 H^.Ch:=nil;
 H^.Nb:=nil;
 for i:=1 to High(HS) do
 begin
  New(H);
  H^.Ch:=nil;
  H^.Nb:=nil;
  WriteLevelParam(H,HS,i);

  H^.Stack.S:=H1^.Stack.S+1;
  H1.Nb:=H;
  H^.Pr:=Tree;
  H1:=H;
 end;
 Tree:=H^.Pr^.Ch;
 HS:=nil; //??? (освобождение массива уровня)
 //SyntaxAnalizator(Tree^.Expression,ND,HS,EOFN);
 SyntaxAnalizatorGT(ND,HS,EOFN);
 end;
//EOFN=True:последняя команда узла
inc(F_IdN);
WriteNodeParam(ND);
end;
Tree:=Tree^.Pr;
end;

Tree:=BeginTree;

endp:
end;





(*
procedure TForevalH.FreeExtFunc(E_Func: TFunction);
var
i: integer;
begin
{.193}
 if E_Func.AllocMem = 2 then
 begin
   VirtualFree(E_Func.PAddr,0,MEM_RELEASE);
 end;

FreeFuncData(E_Func.Data);
E_Func.Code:=nil;
E_Func.Stack:=nil;   //E_Func.AllocMem = 1
E_Func.RFStack:=nil;
E_Func.PAddr:=nil;
E_Func.Addr:=0;
E_Func.Data:=nil;
end;

*)





procedure TForevalH.FreeExtFunc(E_Func: PFunction);    {.225} // on pointer
var
i: integer;
begin
{.193}
 if E_Func^.AllocMem = 2 then
 begin
   VirtualFree(E_Func^.PAddr,0,MEM_RELEASE);
 end;

FreeFuncData(E_Func^.Data);  //E_Func.AllocMem = 1
E_Func^.Code:=nil;
E_Func^.Stack:=nil;
E_Func^.RFStack:=nil;
E_Func^.PAddr:=nil;
E_Func^.Addr:=0;
E_Func^.Data:=nil;
end;



procedure TForevalH.FreeFuncData(FuncData: PFuncData);
var
FD1,FD2: PFuncData;
begin
FD1:=FuncData;
while FD1 <> nil do
begin
 FD2:=FD1^.Next;
 dispose(FD1);
 FD1:=FD2;
end;
end;







(*
procedure TForevalH.FreeCmplParam;
label outf,endp;
var
i,pc: integer;
Name1: String;
begin

 {
 for i := 0 to Length(Alg.Param) - 1 do
 begin
     Name1:=Copy(Alg.Param[i].Name,1,Length(CmplParamName));

     if (Name1  = CmplParamName) then
     begin
       Alg.Param[i].Name:='@hidden@';
       Alg.Param[i].Real:=0;
       Alg.Param[i].Imag:=0;
       Alg.Param[i].TypeF:=0;
     end;
 end;
 }
 pc:=0;
 for i := Length(Alg.Param) - 1 downto 0 do
 begin
     Name1:=Copy(Alg.Param[i].Name,1,Length(CmplParamName));

     if (Name1  = CmplParamName) then
     begin
       {Alg.Param[i].Name:='@hidden@';
       Alg.Param[i].Real:=0;
       Alg.Param[i].Imag:=0;
       Alg.Param[i].TypeF:=0; }
       inc(pc);
     end
     else
     goto outf;

 end;

 outf:
 if pc > 0 then SetLength(Alg.Param,Length(Alg.Param)-pc);


 endp:
end;
 *)


procedure TForevalH.WriteNodeParam(ND: TDataNode);
begin
Tree^.Stack.N:=ND.N;
Tree^.NCOP:=ND.NCOP;
Tree^.FD:=ND.FD;
Tree^.FD1:=ND.FD1;
Tree^.FD2:=ND.FD2;
Tree^.NFunc:=ND.NFunc;
Tree^.COP:=ND.COP;
Tree^.NObj:=ND.NObj;
Tree^.NObj2:=ND.NObj2;
Tree^.IdN:=F_IdN;//ND.IdN;
Tree^.NV1:=ND.NV1;
Tree^.NV2:=ND.NV2;
Tree^.TypeF:=ND.TypeF;    //если возвращаемый тип определяется при разборе (иначе - LinkTreeData)
Tree^.TypeM:=ND.TypeM;    //если возвращаемый математический тип. определяется при разборе (иначе - LinkTreeData)
Tree^.Inv:=ND.Inv;
Tree^.TS:=ND.TS;
Tree^.NF:=ND.NF;
Tree^.AI:=ND.AI;
Tree^.BI:=ND.BI;
Tree^.CI:=ND.CI;
Tree^.DI:=ND.DI;
Tree^.IC1:=ND.IC1;
Tree^.IC2:=ND.IC2;
Tree^.TA1:=ND.TA1;
Tree^.TA2:=ND.TA2;
Tree^.FDC.re:=ND.FDC.re;
Tree^.FDC.im:=ND.FDC.im;
Tree^.TC:=ND.TC;
Tree^.TS1:=ND.TS1;
Tree^.TS2:=ND.TS2;
Tree^.VFP:=ND.VFP;
Tree^.ExpressionArg:=ND.ExpressionArg;
Tree^.XchArg:=False;
Tree^.ExtArg:=0;
//Tree^.ExtFunc:=_NOT_FOUND;

Tree^.Addr1:=ND.Addr1; {.347}
{.301}
Tree^.SDiff:=ND.SDiff;
//Tree^.SFunc:=ND.SFunc; {???}  {.301}
Tree^.cif:=ND.cif;
Tree^.tif:=ND.tif;
Tree^.AIVP1:=ND.AIVP1;
Tree^.AIVP2:=ND.AIVP2;
//CopyAIVP(ND.AIVP1,Tree^.AIVP1);
end;



procedure TForevalH.WriteLevelParam(H: PNode; HS: PLevel; N: Cardinal);
begin
H^.Expression:=Copy(HS[N].Expression,1,Length(HS[N].Expression));
H^.NL:=HS[N].NL;
H^.IdL:=F_IdN;//HS[N].IdL;
H^.ExtFunc:=HS[N].ExtFunc;
end;



procedure TForevalH.FindExternalBracket(S: String; var SS: String);
label 1,endp;
var
b,i,z,a:Integer;
begin
SS:=Copy(S,1,Length(S));



1:
if SS = '' then
begin
goto endp;
end;

if (SS[1] = '(') and (SS[Length(SS)] = ')') then
begin
  b:=-1;
  for i:=2 to Length(SS)-1 do
  begin
   if SS[i] = '(' then b:=b-1;
   if SS[i] = ')' then b:=b+1;
   if b = 0 then goto endp;
  end;

 Delete(SS,Length(SS),1);
 Delete(SS,1,1);
 goto 1;
end;




endp:
end;



function TForevalH.DeleteExternalBracketPS(PS: PString): Boolean;   {.219}
label outf,nxt,endp;
var
b,i,bp,L:Integer;
Answ: Boolean;
begin

(*
bp:=0;  L:=Length(PS^);

nxt:
if PS^ = '' then
begin
 goto outf;
end;


inc(bp);
if (PS^[bp] = '(') and (PS^[L-bp+1] = ')') then
begin

  b:=0;
  for i:=bp to L-bp do
  begin
    if PS^[i] = '(' then dec(b);
    if PS^[i] = ')' then inc(b);
    if b = 0 then  goto outf;
  end;
  goto nxt;

end;

outf:
dec(bp);
if bp > 0 then
begin
 Delete(PS^,L-bp+1,bp);
 Delete(PS^,1,bp);
end;
*)

Answ:=False;
nxt:
if PS^ = '' then
begin
 goto endp;
end;

L:=Length(PS^);

if (PS^[1] = '(') and (PS^[L] = ')') then
begin
  b:=0;
  for i:=1 to L-1 do
  begin
   if PS^[i] = '(' then dec(b)
   else
   if PS^[i] = ')' then inc(b);
   if b = 0 then goto endp;
  end;

 Answ:=True;
 Delete(PS^,L,1);
 Delete(PS^,1,1);
 goto nxt;
end;




endp:
DeleteExternalBracketPS:=Answ;
end;



function TForevalH.DeleteExternalBracketNegPS(PS: PString; var Neg: Integer): Boolean;
label
2,3,endp;
var
b,i,z,a: Integer;
Answ: Boolean;
begin
//SS:=Copy(S,1,Length(S));
z:=1;      Answ:=False;
2:
b:=0; a:=1;

if PS^ = '' then
begin
goto endp;
end;


if PS^[1] = '-' then a:=2;

if  PS^[a] = '(' then
begin

 b:=-1;
 for i:=a+1 to Length(PS^)-1 do
 begin
  if PS^[i] = '(' then b:=b-1;
  if PS^[i] = ')' then b:=b+1;
  if b = 0 then goto 3
 end;


 if PS^[Length(PS^)] = ')' then
 begin
   if a = 2 then
   begin
     Delete(PS^,1,1);
     z:=z*(-1);
   end;

   Answ:=True;
   Delete(PS^,1,1);
   Delete(PS^,Length(PS^),1);
   goto 2;
 end;

end;

3:
if z = -1 then  Neg:=-1 else  Neg:=1;


endp:
DeleteExternalBracketNegPS:=Answ;
end;






function TForevalH.FindNumberPR(PR: Cardinal): Cardinal;
label 1;
var
i: Integer;
N: Cardinal;
begin
for i:=0 to High(Alg.Opr) do
begin
 if PR = Alg.Opr[i].PR then
 begin
  N:=i; goto 1;
 end;
end;

1:
FindNumberPR:=N;
end;






{.340}
function TForevalH.FindOperationPS(PS: PString; pos: Integer; NArg: Integer): integer;
label 1;
var                                               //поиск операции в PS^ , расположенной начиная  с pos; Narg = 1,2 число аргументов в операции
i,NCOP,NCOP1,IDF,LenS,MaxLenOp,Lc: Integer;
begin
NCOP:=-1;
NCOP1:=-1;
LenS:=Length(PS^);
MaxLenOp:=LenS-pos;

for i:=0 to High(Alg.Opr) do
begin

   if (MaxLenOp >= Alg.Opr[i].LenOp) and (Alg.Opr[i].Enable = True) and (Alg.Opr[i].NArg = NArg) then
   begin                                          {.339}
       // if (S = Alg.Opr[i].Name) and (Alg.Opr[i].Enable = True) then
       Lc:=Alg.Opr[i].LenOp;
       if  CompareStingPartPS(PS,pos,@Alg.Opr[i].Name, Lc) = True  {(Copy(PS^,pos, Alg.Opr[i].LenOp) =  Alg.Opr[i].Name)} then
       begin
          //искать самую длинную операцию из подобных x*y x**y x***y ...
          if NCOP1 = -1 then NCOP1:=i
          else
          if Alg.Opr[i].LenOp > Alg.Opr[NCOP1].LenOp then NCOP1:=i;

          {NCOP1:=i;
          goto 1;}
       end;
   end;

end;

1:                                                                            {.339}
//if  ((F_SyntaxExtension = False) and (Alg.Opr[NCOP].SE <> 0)) or (Alg.Opr[NCOP].Enable = False) then NCOP:=-1;

if NCOP1 <> -1 then                    {.195}
begin
 NCOP:=NCOP1;
 IDF:=Alg.Opr[NCOP].NFunc;
 if Alg.ExFunc[IDF].Enable =_NO then NCOP:=-1;
end;

FindOperationPS:=NCOP;
end;





function TForevalH.FindOperation(S: String): integer;
label 1;
var
i,NCOP,IDF: Integer;
begin
NCOP:=-1;
for i:=0 to High(Alg.Opr) do
begin                                      {.339}
    if (S = Alg.Opr[i].Name) and (Alg.Opr[i].Enable = True) then
    begin
     NCOP:=i;
     goto 1;
    end;
end;

1:                                                                            {.339}
//if  ((F_SyntaxExtension = False) and (Alg.Opr[NCOP].SE <> 0)) or (Alg.Opr[NCOP].Enable = False) then NCOP:=-1;

if NCOP <> -1 then                    {.195}
begin
 IDF:=Alg.Opr[NCOP].NFunc;
 if Alg.ExFunc[IDF].Enable =_NO then NCOP:=-1;
end;

FindOperation:=NCOP;
end;




{.357}
function TForevalH.FindOperationA(S: String; PR: Cardinal; NArg: Integer; Pos: Integer): integer;
label 1;
var
i,NCOP,IDF: Integer;
begin
NCOP:=-1;

for i:=0 to High(Alg.Opr) do
begin                                      {.339}
    if (S = Alg.Opr[i].Name) and (Alg.Opr[i].Enable = True) and (Alg.Opr[i].PR = PR) and  (Alg.Opr[i].NArg = NArg) and  (Alg.Opr[i].Pos = Pos)   then
    begin
     NCOP:=i;
     goto 1;
    end;
end;

1:                                                                            {.339}
//if  ((F_SyntaxExtension = False) and (Alg.Opr[NCOP].SE <> 0)) or (Alg.Opr[NCOP].Enable = False) then NCOP:=-1;

if NCOP <> -1 then                    {.195}
begin
 IDF:=Alg.Opr[NCOP].NFunc;
 if Alg.ExFunc[IDF].Enable =_NO then NCOP:=-1;
end;

FindOperationA:=NCOP;
end;




procedure TForevalH.FindSingleOP(S: String; var NCop: Integer);
var
i,j,PR1,PR2: Integer;
NCop1,NCop2,ms,Ls,Lc,IDF: Integer;
BOP: Boolean;
Ss,Sc: String;
begin
BOP:=False;
PR1:=0;
PR2:=0;
NCop1:=-1; NCop2:=-1;  NCop:=-1;

Ss:=Copy(S,1,Length(S));

Ls:=Length(Ss);

for i:=0 to High(Alg.Opr) do
begin

 if Alg.Opr[i].Enable = True then
 begin
   if Alg.Opr[i].NArg = 1 then    //только одноарг. операции
   begin

      if Alg.Opr[i].Pos = _after then
      begin
       Lc:=Length(Alg.Opr[i].Name);
       Sc:=Copy(Ss,Ls-Lc+1,Lc);                {.339}
       if (Sc = Alg.Opr[i].Name) and (Alg.Opr[i].Enable = True) then
       begin
        NCop2:=i;
       end;
      end
      else
      if Alg.Opr[i].pos = _before then
      begin
       Lc:=Length(Alg.Opr[i].Name);
       Sc:=Copy(Ss,1,Lc);                       {.339}
       if (Sc = Alg.Opr[i].Name) and  (Alg.Opr[i].Enable = True) then
       begin
        NCop1:=i;
       end;
      end;

    //for synt. error:
    //if (S[Length(S)] = Alg.Opr[i].Name[1]) or (S[1] = Alg.Opr[i].Name[1]) then BOP:=True;
  end;
 end;
end;



if (NCop1 <> -1) and (NCop2 <> -1) then
begin
 if  Alg.Opr[NCop1].PR < Alg.Opr[NCop2].PR then NCop:=NCop1 else NCop:=NCop2;
end
else
if NCop1 <> -1 then NCop:=NCop1
else
if NCop2 <> -1 then NCop:=NCop2;

//find synt. error
if (NCop = -1) and (BOP = True)  then
begin
  F_SyntaxErrorCode:=5;
  F_SyntaxErrorString:=S;
end;
                                                                              {.339}
//if  ((F_SyntaxExtension = False) and (Alg.Opr[NCOP].SE <> 0)) or (Alg.Opr[NCOP].Enable = False) then NCOP:=-1;

if NCOP <> -1 then                    {.195}
begin
 IDF:=Alg.Opr[NCOP].NFunc;
 if Alg.ExFunc[IDF].Enable =_NO then NCOP:=-1;
end;

end;




function  TForevalH.CompareStingPartPS(PS1: PString; indx: Integer; PS2: PString; Len: Integer): boolean;
label endp;
var
i,k: Integer;
Answ: boolean;
begin

Answ:=True;
k:=indx-1;
for i := 1 to Len do
begin
  if PS1^[k+i] <> PS2^[i] then
  begin
    Answ:=False;
    goto endp;
  end;
end;


endp:
CompareStingPartPS:=Answ;
end;



procedure TForevalH.FindSingleOPPS(PS: PString; var NCop: Integer);
var
i,j,PR1,PR2: Integer;
NCop1,NCop2,ms,Ls,Lc,IDF,indx: Integer;
BOP: Boolean;
Ss,Sc: String;
begin
BOP:=False;
PR1:=0;
PR2:=0;
NCop1:=-1; NCop2:=-1;  NCop:=-1;

//Ss:=Copy(S,1,Length(S));

DeleteExternalBracketPS(PS); {.317}

Ls:=Length(PS^);

for i:=0 to High(Alg.Opr) do
begin

 if Alg.Opr[i].Enable = True then
 begin
   if Alg.Opr[i].NArg = 1 then    //только одноарг. операции
   begin

      if Alg.Opr[i].Pos = _after then
      begin
        //Lc:=Length(Alg.Opr[i].Name);
        //Sc:=Copy(PS^,Ls-Lc+1,Lc);                {.339}
        //if (Sc = Alg.Opr[i].Name) and ( Alg.Opr[i].Enable = True)  then

        {.340}

        Lc:=Alg.Opr[i].LenOp;
        indx:=Ls-Lc+1;
        if Ls - indx + 1 >= Lc then
        begin

          if CompareStingPartPS(PS,indx,@Alg.Opr[i].Name,Lc) = True {(Copy(PS^,indx,Lc) = Alg.Opr[i].Name)} then
          begin
            //NCop2:=i;

            //искать самую длинную операцию из подобных x!, x!!, x!!! ...
            if NCOP2 = -1 then NCOP2:=i
            else
            if Alg.Opr[i].LenOp > Alg.Opr[NCOP2].LenOp then NCOP2:=i;

          end;
        end;

      end
      else
      if Alg.Opr[i].Pos = _before then
      begin
        //Lc:=Length(Alg.Opr[i].Name);
        //Sc:=Copy(PS^,1,Lc);                       {.339}
        //if (Sc = Alg.Opr[i].Name) and  ( Alg.Opr[i].Enable = True) then

        {.340}
        Lc:=Alg.Opr[i].LenOp;
        indx:=1;
        if Ls - indx + 1 >= Lc then
        begin
          
          if  CompareStingPartPS(PS,indx,@Alg.Opr[i].Name,Lc) = True {(Copy(PS^,indx,Lc) = Alg.Opr[i].Name)} then
          begin
             //NCop1:=i;

              //искать самую длинную операцию из подобных !x, !!x, !!!x ...
            if NCOP1 = -1 then NCOP1:=i
            else
            if Alg.Opr[i].LenOp > Alg.Opr[NCOP1].LenOp then NCOP1:=i;

          end;
        end;
      end;


     {.340}
    //for synt. error:
    //if (PS^[Length(PS^)] = Alg.Opr[i].Name[1]) or (PS^[1] = Alg.Opr[i].Name[1]) then BOP:=True;
  end;
 end;

end;



if (NCop1 <> -1) and (NCop2 <> -1) then
begin
 if  Alg.Opr[NCop1].PR < Alg.Opr[NCop2].PR then NCop:=NCop1 else NCop:=NCop2;
end
else
if NCop1 <> -1 then NCop:=NCop1
else
if NCop2 <> -1 then NCop:=NCop2;

{.340}
//find synt. error
 {
if (NCop = -1) and (BOP = True)  then
begin
  F_SyntaxErrorCode:=5;
  F_SyntaxErrorString:=Copy(PS^,1,Length(PS^));
end;
 }
                                                                            {.339}
//if  ((F_SyntaxExtension = False) and (Alg.Opr[NCOP].SE <> 0)) or (Alg.Opr[NCOP].Enable = False) then NCOP:=-1;

if NCOP <> -1 then                    {.195}
begin
 IDF:=Alg.Opr[NCOP].NFunc;
 if Alg.ExFunc[IDF].Enable =_NO then NCOP:=-1;
end;

end;





function TForevalH.CheckToZeroPS(PS: PString): Boolean;
label nxt;
var
b,i,z,a,bp,ep,L: Integer;
BRes: Boolean;
begin

BRes:=False;
L:=Length(PS^); ep:=0; bp:=1;
nxt:
if (PS^[bp] = '(') and (PS^[L-ep] = ')') then
begin
  inc(bp); inc(ep);
  goto nxt;
end
else
if PS^[bp] = '-' then
begin
  inc(bp);
  goto nxt;
end
else
if Copy(PS^,bp,L-bp-ep+1) = '0' then Bres:=True;

CheckToZeroPS:=BRes;
end;





(*
procedure TForevalH.MulDivOptPS(PS: PString; var NCOP: Integer; var NPos: Cardinal);
label endp;
var
Pl,Ml,BZero,BConst,BFrstDiv: Boolean;
i,b,b1,b2: Integer;
NCOP1,NCOP2,NPos1,NPosM,NPosD,CCOP,CUnit: Integer;
SE: Boolean;
NPS: array of integer;
NPO: array of integer;
ndiv,nmul,cpos,lastop,LM,LD,lastpos: integer;
SM,SD,St,Scf,NameP,StrC1: String;
AMUL,ADIV: TArrayS;
CF: TComplex;
ConstT,TP,ConstEval: Integer;

     function _EvalConst(PS: PString; COP: Integer): Boolean;
     var
     Re,Im,Re1,Im1: Extended;
     TP: Integer;
     Answ: Boolean;
     CX: TComplex;
     begin
         Answ:=False;
         //SubstParamP(PS,Re1,Im1,TP);
         SubstParamCXPS(PS,CX,TP);

         if TP <> C_None then
         begin

              if (TP = C_Real) and (CX.re = 1) and (CX.im = 0) then
              begin
                {*1}
                //inc(ConstEval);
                if ConstT = _Absent then  ConstT:=T_Real;
                StrC1:='1';
              end
              else
              if (TP = C_Real) and (CX.re = -1) and (CX.im = 0) then
              begin
                {*-1}
                CF.re:=-CF.re; CF.im:=-CF.im;   inc(ConstEval);
                if ConstT = _Absent then  ConstT:=T_Real;
                StrC1:='(-1)';
              end
              else
              if ((TP = C_Real) and (CX.Re = 0)) or ((TP = C_Complex) and (CX.Re = 0) and (CX.Im = 0)) then
              begin
                if COP = COP_DIV then
                begin
                  {CALCULATION ERROR !!!}
                end
                else
                BZero:=True;
              end
              else
              begin
                  if ConstT = _Absent then
                  begin
                    if TP = C_Real then ConstT:=T_Real else ConstT:=T_Complex
                  end;
                  if (ConstT = T_Real) and (TP <> C_Real) then ConstT:=T_Complex;

                  if COP =   COP_MUL then  _ComplexMul(CF.re,CF.im,CX.Re,CX.Im,Re,Im) else
                  if COP =   COP_DIV then  _ComplexDiv(CF.re,CF.im,CX.Re,CX.Im,Re,Im) else
                  if COP =   _ABSENT then  begin Re:=CX.re; Im:=CX.im; end;

                  CF.re:=Re; CF.im:=Im;
                  //Answ:=True;
                  inc(ConstEval);
                  if ConstEval = 1 then
                  begin
                    StrC1:=PS^;    //x*y/2; x*y/pi
                    if COP = COP_DIV then BFrstDiv:=True;
                  end;

                {
                  if ConstT = _Absent then
                  begin
                    if TP = C_Real then ConstT:=T_Real else ConstT:=T_Complex;
                    CF.Re:=CX.re; CF.Im:=CX.im;  inc(ConstEval);
                    StrC1:=PS^;
                  end
                  else
                  begin
                    if (ConstT = T_Real) and (TP <> C_Real) then ConstT:=T_Complex;

                    if COP =   COP_MUL then  _ComplexMul(CF.re,CF.im,CX.Re,CX.Im,Re,Im) else
                    if COP =   COP_DIV then  _ComplexDiv(CF.re,CF.im,CX.Re,CX.Im,Re,Im) else
                    if COP =   _ABSENT then  begin Re:=CX.re; Im:=CX.im; end;

                    CF.re:=Re; CF.im:=Im;
                    //Answ:=True;
                    inc(ConstEval);
                  end;
                  }
              end;

              Answ:=True;

               {
              if ((ConstT = T_Real) and (Re = 0)) or ((ConstT = T_Complex) and (Re = 0) and (Im = 0)) then
              begin
                if COP = COP_DIV then
                begin
                 // CALCULATION ERROR !!!
                end
                else
                BZero:=True;
              end;
              }
         end;


        _EvalConst:=Answ;
     end;

begin

TryFPUMask; {.229}

//S1opS2opS3...opSn -> Sk1*...*Skn/(Sl1*...*Sln) ;op = '*'  '/'
//S1opS2opS3...opSn -> 0 ,if any Sm = 0 (*Sm) (except: i*0, 0*i)    ;op = '*'  '/'

SE:=False;
BFrstDiv:=False;

//Sret:=S;

NCOP1:=-1; NCOP2:=-1;  NCOP:=-1;     NPos:=0;
b:=0; b1:=0; b2:=0; Pl:=False; Ml:=False;
ndiv:=0; nmul:=0; cpos:=1; lastop:=-1;
SD:=''; SM:='';  BZero:=False;  NPosM:=0; NPosD:=0;
CF.re:=1; CF.im:=0; ConstT:=_Absent;  BConst:=False; ConstEval:=0; CCOP:=_ABSENT;
SetLength(AMUL,0); SetLength(ADIV,0);   lastop := _ABSENT;  lastpos:=0;

//F_CalcConstMulDiv :=False;
for i:=1 to Length(PS^)   do
begin
 if PS^[i] = '(' then {b:=b-1}dec(b)   else
 if PS^[i] = ')' then {b:=b+1}inc(b)   else
 if PS^[i] = '[' then {b1:=b1-1}dec(b1) else
 if PS^[i] = ']' then {b1:=b1+1}inc(b1) else
 if PS^[i] = '{' then {b2:=b2-1}dec(b2) else
 if PS^[i] = '}' then {b2:=b2+1}inc(b2);

 if (b = 0) and (b1 = 0) and (b2 = 0) then
 begin
     if (PS^[i] = Alg.Opr[COP_MUL].Name) or (PS^[i] = Alg.Opr[COP_DIV].Name) then
     begin

          if cpos = 1 then
           begin
              St:=Copy(PS^,1,i-1);
              CCOP:=_ABSENT;
           end
           else
           begin
             St:=Copy(PS^,cpos+1,i-cpos-1);
             CCOP:=lastop;
           end;

           if F_CalcConstMulDiv = True then BConst:=_EvalConst(@St,CCOP) ;

           if BConst = False then
           begin
             if (lastop = _ABSENT) or (lastop = COP_MUL) then
             begin
               SetLength(AMUL,Length(AMUL)+1); AMUL[High(AMUL)]:=St
             end
             else        //COP_DIV
             begin
               SetLength(ADIV,Length(ADIV)+1); ADIV[High(ADIV)]:=St;
             end;
           end;

           cpos:=i;
           lastpos:=i;
           if (PS^[i] = Alg.Opr[COP_MUL].Name) then  lastop:=COP_MUL else   lastop:=COP_DIV;


     end;


 end;
end;





//последнее выражение
if cpos > 1 then
begin
    St:=Copy(PS^,cpos+1,Length(PS^)-cpos);


    if F_CalcConstMulDiv = True then BConst:=_EvalConst(@St,lastop) ;

    if BConst = False then
    begin
        if (lastop = _ABSENT) or (lastop = COP_MUL) then
      begin
        SetLength(AMUL,Length(AMUL)+1); AMUL[High(AMUL)]:=St
      end
      else        //COP_DIV
      begin
        SetLength(ADIV,Length(ADIV)+1); ADIV[High(ADIV)]:=St;
      end;
    end;

end;



if BZero = True then
begin
  //Sret:='0';
  PS^:='0';
  NCOP:=_ABSENT;
end
else
begin

{
  x/y*t*(x+1)/(x+2)/(x+3)/(x+4)*(x+5)*(x+6)/(x+7)
}
  //   (x+1)*(x+2)*(x+3)*(x+4)*(x+5)*(x+6)

  Scf:='';
  LM:=Length(AMUL); LD:=Length(ADIV);

  if ConstT <> _Absent then
  begin
    {
    if (ConstEval = 0) and (LM = 0)  and (LD > 0) then // 1/(S1*...Sn)
    begin

      if ConstT = T_Real     then Scf:=FloatToStrF(CF.re, ffGeneral, 20, 4, G_FMT) else
      if ConstT = T_Complex  then
      begin
       if CF.im < 0 then Scf:=FloatToStrF(CF.re, ffGeneral, 20, 4, G_FMT)+FloatToStrF(CF.im, ffGeneral, 20, 4, G_FMT)+'i' else
                       Scf:=FloatToStrF(CF.re, ffGeneral, 20, 4, G_FMT)+'+'+FloatToStrF(CF.im, ffGeneral, 20, 4, G_FMT)+'i';
      end ;
      Scf:='('+Scf+')'; ConstEval := 1 ;
    end
    else
    }

    {.318}
    if (ConstEval > 1) or ((ConstEval = 1) and (BFrstDiv = True)) then
    begin

    //2.1*x*3.7i*x*y*(2.3-5.9i)*t*(7.3i-2.1)
    {задание внутреннего параметра для сохранения вычисленной константы умножения: выше точность}
       NameP:=CmplParamName+IntToStr(C_CmplParamNumbers);
       SetParamIntrnl(NameP,CF.Re,CF.Im,ConstT,_Internal);
       inc(C_CmplParamNumbers);
       inc(Db_CalcConstMulDiv);
       Scf:=NameP;

       //через сохранение числа в строку: выше скорость разбора, ниже точность >>
      {
      if ConstT = T_Real     then Scf:=FloatToStrF(CF.re, ffGeneral, 20, 4, G_FMT) else
      if ConstT = T_Complex  then
      begin
       if CF.im < 0 then Scf:=FloatToStrF(CF.re, ffGeneral, 20, 4, G_FMT)+FloatToStrF(CF.im, ffGeneral, 20, 4, G_FMT)+'i' else
                       Scf:=FloatToStrF(CF.re, ffGeneral, 20, 4, G_FMT)+'+'+FloatToStrF(CF.im, ffGeneral, 20, 4, G_FMT)+'i';
      end ;
      Scf:='('+Scf+')';
      NameP:=Scf;
      }
    end
    else
    if ConstEval <= 1 then  //ConstEval = 0 for '1'
    begin
      {
      if ConstT = T_Real     then Scf:=FloatToStrF(CF.re, ffGeneral, 20, 4, G_FMT) else
      if ConstT = T_Complex  then
      begin
       if CF.im < 0 then Scf:=FloatToStrF(CF.re, ffGeneral, 20, 4, G_FMT)+FloatToStrF(CF.im, ffGeneral, 20, 4, G_FMT)+'i' else
                       Scf:=FloatToStrF(CF.re, ffGeneral, 20, 4, G_FMT)+'+'+FloatToStrF(CF.im, ffGeneral, 20, 4, G_FMT)+'i';
      end ;
      Scf:='('+Scf+')';
      }
      Scf:=StrC1;
      ConstEval:=1;
    end;

    {
    if ConstEval <= 1 then  //ConstEval = 0 for '1'
    begin
      {
      if ConstT = T_Real     then Scf:=FloatToStrF(CF.re, ffGeneral, 20, 4, G_FMT) else
      if ConstT = T_Complex  then
      begin
       if CF.im < 0 then Scf:=FloatToStrF(CF.re, ffGeneral, 20, 4, G_FMT)+FloatToStrF(CF.im, ffGeneral, 20, 4, G_FMT)+'i' else
                       Scf:=FloatToStrF(CF.re, ffGeneral, 20, 4, G_FMT)+'+'+FloatToStrF(CF.im, ffGeneral, 20, 4, G_FMT)+'i';
      end ;
      Scf:='('+Scf+')';
      }
      Scf:=StrC1;
      ConstEval:=1;
    end
    else
    if ConstEval > 1 then
    begin

    //2.1*x*3.7i*x*y*(2.3-5.9i)*t*(7.3i-2.1)
    {задание внутреннего параметра для сохранения вычисленной константы умножения: выше точность}
       NameP:=CmplParamName+IntToStr(C_CmplParamNumbers);
       SetParamIntrnl(NameP,CF.Re,CF.Im,ConstT,_Internal);
       inc(C_CmplParamNumbers);
       inc(Db_CalcConstMulDiv);

       //через сохранение числа в строку: выше скорость разбора, ниже точность >>
      {
      if ConstT = T_Real     then Scf:=FloatToStrF(CF.re, ffGeneral, 20, 4, G_FMT) else
      if ConstT = T_Complex  then
      begin
       if CF.im < 0 then Scf:=FloatToStrF(CF.re, ffGeneral, 20, 4, G_FMT)+FloatToStrF(CF.im, ffGeneral, 20, 4, G_FMT)+'i' else
                       Scf:=FloatToStrF(CF.re, ffGeneral, 20, 4, G_FMT)+'+'+FloatToStrF(CF.im, ffGeneral, 20, 4, G_FMT)+'i';
      end ;
      Scf:='('+Scf+')';
      NameP:=Scf;
      }
    end;
    }

  end;


  // 2*x/3*4/y/5*6/t/7
  // 2/3/x*4/5/y/7*t*8*9/10/11*y/12
  // 2/3*x*4/5/y/7*t*8*9/10/11*y/12
  // 2/3*x*4/y*8*9/11*y
  // 2/3*x
  // 2/3/x
  // 2/3/x/4
  // 7/y/x/4
  // 7/y/x
  // 2/x/y/3*4.5/(x+1)*(t-1)


 {.317}
CUnit:=0;
if (CF.re = 1.0)  and (CF.im = 0.0)  then  CUnit:=1 else
if (CF.re = -1.0) and (CF.im = 0.0)  then  CUnit:=-1;


 if (LM > 0) {and (LD = 0)} then
 begin
   SM:=AMUL[0];
   for i := 1 to LM - 1 do
   begin
     SM:=SM+'*'+AMUL[i];

     lastpos:=Length(SM)-Length(AMUL[i]);
   end;

 end;

 if   (LD > 0) then
 begin
   SD:=ADIV[0];
   for i := 1 to LD - 1 do
   begin
     SD:=SD+'*'+ADIV[i];

     lastpos:=Length(SD)-Length(ADIV[i]);
   end;
 end;

 if (LM = 0) and (LD = 0) then
 begin
   if ConstEval = 1 then PS^:=Scf
   else                  PS^:=NameP;

   NCOP:=_ABSENT;
 end
 else
 if (LD = 0) then           //S1*...*Sn(*/)C1...Cn
 begin
   {
   if ConstEval = 1 then
   begin
     PS^:=SM+'*'+Scf;
     lastpos:=Length(PS^)-Length(Scf);
   end
   else
   begin
     if ConstT <> _Absent then
     begin
      PS^:=SM+'*'+NameP;
      lastpos:=Length(PS^)-Length(NameP);
     end
     else PS^:=SM;
   end;
   NCOP:=COP_MUL;
   }
   if ConstT = _Absent then
   begin
     PS^:=SM;
     NCOP:=COP_MUL;
   end
   else
   begin
       if CUnit = 1  then
       begin
         PS^:=SM;
         NCOP:=COP_MUL;
       end
       else
       if CUnit =- 1 then     //NCOP = _ABSENT
       begin
          PS^:='-('+SM+')';
          lastpos:=0;
          NCOP:=_ABSENT;
       end
       else
       begin
         PS^:=SM+'*'+Scf;
         lastpos:=Length(PS^)-Length(Scf);
         NCOP:=COP_MUL;
       end
   end;

 end
 else
 if (LM = 0) then      //const/SD
 begin
    {
    if ConstEval = 1 then
    begin
     PS^:=Scf+'/('+SD+')';
     lastpos:=Length(PS^)-Length(SD)-2;
    end
    else
    begin
      PS^:=NameP+'/('+SD+')';
      lastpos:=Length(PS^)-Length(SD)-2;
    end;
    NCOP:=COP_DIV;
    }

     PS^:=Scf+'/('+SD+')';
     lastpos:=Length(PS^)-Length(SD)-2;
     NCOP:=COP_DIV;
 end
 else      //S1...(*/)...Sn(*/)C1...Cn
 begin
    {
    if ConstEval = 1 then
    begin

      if CUnit = 1 then   //Scf=1
      begin
         PS^:=SM+'/('+SD+')';
         lastpos:=Length(PS^)-Length(SD)-2;
         NCOP:=COP_DIV;
      end
      else
      begin
         PS^:=SM+'/('+SD+')*'+Scf;
         lastpos:=Length(PS^)-Length(Scf);
         NCOP:=COP_MUL;
      end;
    end
    else
    begin
     if ConstT <> _Absent then
     begin
      PS^:=SM+'/('+SD+')*'+NameP;
      lastpos:=Length(PS^)-Length(NameP);
      NCOP:=COP_MUL;
     end
     else
     begin
       PS^:=SM+'/('+SD+')';
       lastpos:=Length(PS^)-Length(SD)-2;
       NCOP:=COP_DIV;
     end
    end;
    }

    if ConstT <> _Absent then
     begin

       if CUnit = 1 then
       begin
          PS^:=SM+'/('+SD+')';
          lastpos:=Length(PS^)-Length(SD)-2;
          NCOP:=COP_DIV;
       end
       else
       if CUnit = -1 then         //NCOP = _ABSENT
       begin
          PS^:='-('+SM+'/('+SD+'))';
          lastpos:=0;
          NCOP:=_ABSENT;
       end
       else
       begin
          PS^:=SM+'/('+SD+')*'+Scf;
          lastpos:=Length(PS^)-Length(Scf);
          NCOP:=COP_MUL;
       end;


     end
     else
     begin
        PS^:=SM+'/('+SD+')';
        lastpos:=Length(PS^)-Length(SD)-2;
        NCOP:=COP_DIV;
     end;


 end;


end;


 {искать заново положение NPOS, если было вычисление const.: т.к. размер Sret изменился}
// if NCOP <> _ABSENT then FindMainOperationP(@Sret,NCOP,NPOS);
  NPOS:=lastpos;

endp:
TryCatchFPUException;    {.229}
end;
*)






function TForevalH.MulDivAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean): Boolean;
label endp;
var
Pl,Ml,BZero,BConst,BFrstDiv,FAnsw: Boolean;
i,b,b1,b2: Integer;
NCOP1,NCOP2,NPos1,NPosM,NPosD,CCOP,CUnit,NCOP,NPOS: Integer;
SE: Boolean;
NPS: array of integer;
NPO: array of integer;
ndiv,nmul,cpos,lastop,LM,LD,lastpos,ni: integer;
SM,SD,St,Scf,NameP,StrC1,Sop,S,Str1,Str2, ExprString : String;
AMUL,ADIV: TArrayS;
CF: TComplex;
ConstT,TP,ConstEval: Integer;
PS: PString;

     function _EvalConst(PS: PString; COP: Integer): Boolean;
     var
     Re,Im,Re1,Im1: Extended;
     TP: Integer;
     Answ: Boolean;
     CX: TComplex;
     begin
         Answ:=False;
         //SubstParamP(PS,Re1,Im1,TP);
         SubstParamCXPS(PS,CX,TP);

         if TP <> C_None then
         begin

              if (TP = C_Real) and (CX.re = 1) and (CX.im = 0) then
              begin
                {*1}
                //inc(ConstEval);
                if ConstT = _Absent then  ConstT:=T_Real;
                StrC1:='1';
              end
              else
              if (TP = C_Real) and (CX.re = -1) and (CX.im = 0) then
              begin
                {*-1}
                CF.re:=-CF.re; CF.im:=-CF.im;   inc(ConstEval);
                if ConstT = _Absent then  ConstT:=T_Real;
                StrC1:='(-1)';
              end
              (*
              else         {.329} //i*i, 2i*i, re(ai)*i, i/i
              if (TP = C_Image) and  (ConstT = T_Complex) and (CF.Re = 0)  then
              begin
                  if COP =   COP_MUL then
                  begin
                    CF.re:=-CF.im; CF.im:=0;
                  end
                  else
                  if COP =   COP_DIV then
                  begin
                    CF.re:=CF.im; CF.im:=0;
                  end;

                  ConstT := T_Real;
              end
              *)
              else
              if ((TP = C_Real) and (CX.Re = 0)) or ((TP = C_Complex) and (CX.Re = 0) and (CX.Im = 0)) then
              begin
                if COP = COP_DIV then
                begin
                  {CALCULATION ERROR !!!}
                   F_InternalError:=E_ZeroDivide;
                   F_SyntaxErrorCode:=E_INTERNAL_ERROR_AT_CALCULATION;
                   //F_SyntaxErrorString:=F_CurrentSubExpr;
                   //F_CurrentEvalSubExpr:=F_CurrentSubExpr;
                end
                else
                BZero:=True;
              end
              else
              begin
                  if ConstT = _Absent then
                  begin
                    if TP = C_Real then ConstT:=T_Real else ConstT:=T_Complex
                  end;
                  if (ConstT = T_Real) and (TP <> C_Real) then ConstT:=T_Complex;

                  if COP =   COP_MUL then
                  begin
                      _ComplexMul(CF.re,CF.im,CX.Re,CX.Im,Re,Im)
                  end
                  else
                  if COP =   COP_DIV then
                  begin
                     if( CX.Re = 0) and (CX.Im = 0) then
                     begin
                       F_InternalError:=E_ZeroDivide;
                       F_SyntaxErrorCode:=E_INTERNAL_ERROR_AT_CALCULATION;
                     end
                     else
                      _ComplexDiv(CF.re,CF.im,CX.Re,CX.Im,Re,Im)
                  end
                  else
                  if COP =   _ABSENT then
                  begin
                      Re:=CX.re; Im:=CX.im;
                  end;

                  CF.re:=Re; CF.im:=Im;
                  //Answ:=True;
                  inc(ConstEval);
                  if ConstEval = 1 then
                  begin
                    StrC1:=PS^;    //x*y/2; x*y/pi
                    if COP = COP_DIV then BFrstDiv:=True;
                  end;


              end;

              Answ:=True;
         end;


        _EvalConst:=Answ;
     end;




    procedure _FindVar(PS1,PS2: PString{; var nv1,nv2: Integer});
    var
    nv1,nv2: Integer;
    begin
        DeleteExternalBracketPS(PS1);
        DeleteExternalBracketPS(PS2);
        FindVarPS(PS1,nv1); //{P}
        FindVarPS(PS2,nv2); //{P}
        if (nv1 = _NOT_FOUND) and (nv2 = _NOT_FOUND) then
        begin
           EOFN:=False;
           ND1.N:=2;
           SetLength(LV1,2);
           LV1[0].Expression:=Copy(PS1^,1,Length(PS1^));
           LV1[1].Expression:=Copy(PS2^,1,Length(PS2^));
        end
        else
        if (nv1 = _NOT_FOUND) and (nv2 >= 0)  then
        begin
            ND1.NV1:=nv2;
            EOFN:=False;
            ND1.N:=1;
            SetLength(LV1,1);
            LV1[0].Expression:=Copy(PS1^,1,Length(PS1^));
            //LV1[0].NL:=1;
        end
        else
        if (nv1 >= 0) and (nv2 = _NOT_FOUND)  then
        begin
            ND1.NV1:=nv1;
            EOFN:=False;
            ND1.N:=1;
            SetLength(LV1,1);
            LV1[0].Expression:=Copy(PS2^,1,Length(PS2^));
            ND1.Inv:=1;
            //LV1[0].NL:=1;
        end
        else
        if (nv1 >= 0) and (nv2 >= 0) then
        begin
            EOFN:=True;
            ND1.NV1:=nv1;
            ND1.NV2:=nv2;
            ND1.N:=0;
            SetLength(LV1,0);
        end;
    end;



begin

try
TryFPUMask; {.229}


// 0*i   !!!!! not const _LDSCX re=0; im=0

//S1opS2opS3...opSn -> Sk1*...*Skn/(Sl1*...*Sln) ;op = '*'  '/'
//S1opS2opS3...opSn -> 0 ,if any Sm = 0 (*Sm) (except: i*0, 0*i)    ;op = '*'  '/'
{
 2/y/4/5*6
  (1)*(1)*(3.767*x-1)
  (1)*(3.767*x-1)

  i*0, 0i, 0*i   !!!!!!!!!!!!!!!!
}
//F_CurrentEvalSubExpr:=F_CurrentSubExpr;

ExprString:=F_SyntaxErrorString; {.360}

SE:=False;
BFrstDiv:=False;

{.318}
LV1:=LV;
ND1:=ND;
if ND.NFunc = CM_MUL then Sop:='*' else  if ND.NFunc = CM_DIV then Sop:='/';
//S:=LV[0].Expression+Sop+'('+LV[1].Expression+')';
S:=LV[0].Expression+Sop+LV[1].Expression;
PS:=@S;
FAnsw:=False; EOFN:=False;

//Sret:=S;

NCOP1:=-1; NCOP2:=-1;  NCOP:=-1;     NPos:=0;
b:=0; b1:=0; b2:=0; Pl:=False; Ml:=False;
ndiv:=0; nmul:=0; cpos:=1; lastop:=-1;
SD:=''; SM:='';  BZero:=False;  NPosM:=0; NPosD:=0;
CF.re:=1; CF.im:=0; ConstT:=_Absent;  BConst:=False; ConstEval:=0; CCOP:=_ABSENT;
SetLength(AMUL,0); SetLength(ADIV,0);   lastop := _ABSENT;  lastpos:=0;

//F_CalcConstMulDiv :=False;
for i:=1 to Length(PS^)   do
begin
 if PS^[i] = '(' then dec(b)   else
 if PS^[i] = ')' then inc(b)   else
 if PS^[i] = '[' then dec(b1) else
 if PS^[i] = ']' then inc(b1) else
 if PS^[i] = '{' then dec(b2) else
 if PS^[i] = '}' then inc(b2);

 if (b = 0) and (b1 = 0) and (b2 = 0) then
 begin
     if (PS^[i] = Alg.Opr[COP_MUL].Name) or (PS^[i] = Alg.Opr[COP_DIV].Name) then
     begin

          if cpos = 1 then
           begin
              St:=Copy(PS^,1,i-1);
              CCOP:=_ABSENT;
           end
           else
           begin
             St:=Copy(PS^,cpos+1,i-cpos-1);
             CCOP:=lastop;
           end;

           if F_CalcConstMulDiv = True then
           begin
              BConst:=_EvalConst(@St,CCOP);        {.360} //   +x/y     /x/y
              if (F_InternalError <> 0) or (F_SyntaxErrorCode <> 0) then
              begin
                 if (F_InternalError = 0) and (F_SyntaxErrorCode <> 0) then F_SyntaxErrorString:=ExprString;  {.360}
                 goto endp; {.333}
              end;
           end
           else
           if BZero = False then
           begin
              BZero:=CheckToZeroPS(@St);
              if (BZero = True) and (CCOP = COP_DIV) then
              begin
                  {CALCULATION ERROR !!!}
                  F_InternalError:=E_ZeroDivide;
                  F_SyntaxErrorCode:=E_INTERNAL_ERROR_AT_CALCULATION;
                  goto endp;     {.333}
                  //F_SyntaxErrorString:=F_CurrentSubExpr;
                  //F_CurrentEvalSubExpr:=F_CurrentSubExpr;
              end;
           end;

           if BConst = False then
           begin
             if (lastop = _ABSENT) or (lastop = COP_MUL) then
             begin
               SetLength(AMUL,Length(AMUL)+1); AMUL[High(AMUL)]:=St
             end
             else        //COP_DIV
             begin
               SetLength(ADIV,Length(ADIV)+1); ADIV[High(ADIV)]:=St;
             end;
           end;

           cpos:=i;
           lastpos:=i;
           if (PS^[i] = Alg.Opr[COP_MUL].Name) then  lastop:=COP_MUL else   lastop:=COP_DIV;


     end;


 end;
end;





//последнее выражение
if cpos > 1 then
begin
    St:=Copy(PS^,cpos+1,Length(PS^)-cpos);


    if F_CalcConstMulDiv = True then
    begin
       BConst:=_EvalConst(@St,lastop);
       if F_InternalError <> 0 then goto endp; {.333}
    end
    else
           if BZero = False then
           begin
              BZero:=CheckToZeroPS(@St);
              if (BZero = True) and (lastop = COP_DIV) then
              begin
                  {CALCULATION ERROR !!!}
                  F_InternalError:=E_ZeroDivide;
                  F_SyntaxErrorCode:=E_INTERNAL_ERROR_AT_CALCULATION;
                  goto endp;    {.333}
                  //F_SyntaxErrorString:=F_CurrentSubExpr;
                  //F_CurrentEvalSubExpr:=F_CurrentSubExpr;
              end;
           end;



    if BConst = False then
    begin
        if (lastop = _ABSENT) or (lastop = COP_MUL) then
      begin
        SetLength(AMUL,Length(AMUL)+1); AMUL[High(AMUL)]:=St
      end
      else        //COP_DIV
      begin
        SetLength(ADIV,Length(ADIV)+1); ADIV[High(ADIV)]:=St;
      end;
    end;

end;

LM:=Length(AMUL); LD:=Length(ADIV);

if BZero = True then         //в выражении есть нулевой множитель
begin

   if F_CalcConstMulDiv = True then
   begin
       if (LM = 0) and (LD = 0) and  (CF.re = 0) and  (CF.im = 1) then    //0*i - не оптимизировать
       begin
          ND1.COP:=_LDSCX;
          ND1.TC:=C_Complex;
       end
       else
       begin
          ND1.COP:=_LDSC;
       end;

   end
   else
   begin
       if (LM = 2) and (LD = 0) then    //0*i - не оптимизировать
       begin
         if (AMUL[0] = S_IM_UNIT) or  (AMUL[1] = S_IM_UNIT) then
         begin
           ND1.COP:=_LDSCX;
           ND1.TC:=C_Complex;
         end
       end
       else
       begin
         ND1.COP:=_LDSC;
       end;
   end;

   ND1.FD:=0.0;
   ND1.FDC.re:=0.0;
   ND1.FDC.im:=0.0;
   ND1.NFunc:=0;
   EOFN:=True;
   ND1.N:=0;
   SetLength(LV1,0);
   goto endp;
end
else
begin

{
  x/y*t*(x+1)/(x+2)/(x+3)/(x+4)*(x+5)*(x+6)/(x+7)
}
  //   (x+1)*(x+2)*(x+3)*(x+4)*(x+5)*(x+6)

  Scf:='';
  LM:=Length(AMUL); LD:=Length(ADIV);

  if ConstT <> _Absent then
  begin


    {.318}
    if (ConstEval > 1) or ((ConstEval = 1) and (BFrstDiv = True)) then
    begin

    //2.1*x*3.7i*x*y*(2.3-5.9i)*t*(7.3i-2.1)
    {задание внутреннего параметра для сохранения вычисленной константы умножения: выше точность}
    {
       NameP:=CmplParamName+IntToStr(C_CmplParamNumbers);
       SetParamIntrnl(NameP,CF.Re,CF.Im,ConstT,_Internal);
       inc(C_CmplParamNumbers);
       inc(Db_CalcConstMulDiv);
       Scf:=NameP;
    }
        inc(Db_CalcConstMulDiv);
    end
    else
    if ConstEval <= 1 then  //ConstEval = 0 for '1'
    begin

      Scf:=StrC1;
      ConstEval:=1;
    end;


  end;


  // 2*x/3*4/y/5*6/t/7
  // 2/3/x*4/5/y/7*t*8*9/10/11*y/12
  // 2/3*x*4/5/y/7*t*8*9/10/11*y/12
  // 2/3*x*4/y*8*9/11*y
  // 2/3*x
  // 2/3/x
  // 2/3/x/4
  // 7/y/x/4
  // 7/y/x
  // 2/x/y/3*4.5/(x+1)*(t-1)


 {.317}
CUnit:=0;
if (CF.re = 1.0)  and (CF.im = 0.0)  then  CUnit:=1 else
if (CF.re = -1.0) and (CF.im = 0.0)  then  CUnit:=-1;


 if (LM > 0) {and (LD = 0)} then
 begin
   SM:=AMUL[0];
   for i := 1 to LM - 1 do
   begin
     SM:=SM+'*'+AMUL[i];

     lastpos:=Length(SM)-Length(AMUL[i]);
   end;

 end;


 if   (LD > 0) then
 begin
   SD:=ADIV[0];
   for i := 1 to LD - 1 do
   begin
     SD:=SD+'*'+ADIV[i];

     lastpos:=Length(SD)-Length(ADIV[i]);
   end;
 end;


 if (LM = 0) and (LD = 0) then
 begin

   //Const:
   if ConstT = T_Real then
   begin
       ND1.FD:=CF.re;
       ND1.COP:=_LDSC;
       ND1.TC:=C_Real;
       ND1.NFunc:=0;
       EOFN:=True;
       ND1.N:=0;
       SetLength(LV1,0);
       FAnsw:=True;
   end
   else
   //if ConstT = T_Complex then
   begin
       ND1.FD:=CF.re;
       ND1.COP:=_LDSCX;
       ND1.NFunc:=0;
       EOFN:=True;
       ND1.N:=0;
       SetLength(LV1,0);
       ND1.TC:=C_Complex;
       ND1.FDC.re:=CF.re;
       ND1.FDC.im:=CF.im;
       FAnsw:=True;
       //ND.FD:=CX.re;
   end;

 end
 else
 if (LD = 0) then           //S1*...*Sn(*/)C1...Cn
 begin


   if ConstT = _Absent then
   begin
        {
        SetLength(LV1,2);
        LV1[0].Expression:=Copy(SM,1,lastpos-1);
        LV1[1].Expression:=Copy(SM,lastpos+1,Length(SM)-lastpos);
        ND1.N:=2;
        ND1.NFunc:=CM_MUL;
        //FAnsw:=False;
        }

        Str1:=Copy(SM,1,lastpos-1);
        Str2:=Copy(SM,lastpos+1,Length(SM)-lastpos);
        _FindVar(@Str1,@Str2);
         ND1.NFunc:=CM_MUL;
   end
   else
   begin
       if CUnit = 1  then
       begin
          {
          SetLength(LV1,2);
          LV1[0].Expression:=Copy(SM,1,lastpos-1);
          LV1[1].Expression:=Copy(SM,lastpos+1,Length(SM)-lastpos);
          ND1.N:=2;
          ND1.NFunc:=CM_MUL;
          FAnsw:=False;  }
          if LM = 1 then        //(1)*Expr
          begin
             ND1.FD:=1.0;
             ND1.TC:=C_Real;
             SetLength(LV1,1);
             LV1[0].Expression:=SM ;
             ND1.N:=1;
             ND1.NFunc:=CM_MUL;
          end
          else
          begin
             Str1:=Copy(SM,1,lastpos-1);
             Str2:=Copy(SM,lastpos+1,Length(SM)-lastpos);
            _FindVar(@Str1,@Str2);
             ND1.NFunc:=CM_MUL;
          end;
       end
       else
       if CUnit =- 1 then
       begin
          SetLength(LV1,1);
          LV1[0].Expression:=SM;
          ND1.N:=1;
          ND1.NFunc:=CM_NEG;
          ND1.COP:=_Func;
          //FAnsw:=True;
       end
       else                    //S*Const
       begin


         //FAnsw:=True;
         ND1.NFunc:=CM_MUL;
         if ConstT = T_Real then
         begin
           ND1.FD:=CF.re;
           ND1.TC:=C_Real;
         end
         else
         begin
           ND1.FDC.re:=CF.re;
           ND1.FDC.im:=CF.im;
           ND1.TC:=C_Complex;
         end;

         //DeleteExternalBracketPS(@SM);
         FindVarPS(@SM,ni); //{P}
         if ni >= 0 then      //Var*Const
         begin
            SetLength(LV1,0);
            ND1.N:=0;
            ND1.nv1:=ni;
            EOFN:=True;
         end
         else                    //Expr*Const
         begin
           SetLength(LV1,1);
           LV1[0].Expression:=SM;
           ND1.N:=1;
         end;

       end
   end;

 end
 else
 if (LM = 0) then      //const/SD
 begin

         //FAnsw:=True;
         ND1.NFunc:=CM_DIV;
         if ConstT = T_Real then
         begin
           ND1.FD:=CF.re;
           ND1.TC:=C_Real;
         end
         else
         begin
           ND1.FDC.re:=CF.re;
           ND1.FDC.im:=CF.im;
           ND1.TC:=C_Complex;
         end;

         //DeleteExternalBracketPS(@SD);
         FindVarPS(@SD,ni); //{P}
         if ni >= 0 then      // Const/Var
         begin
            SetLength(LV1,0);
            ND1.N:=0;
            ND1.nv1:=ni;
            EOFN:=True;
         end
         else                    // Const/Expr
         begin
           SetLength(LV1,1);
           LV1[0].Expression:=SD;
           ND1.N:=1;
         end;
         ND1.Inv:=1;
 end
 else      //S1...(*/)...Sn(*/)C1...Cn
 begin

    if ConstT <> _Absent then
     begin

       if CUnit = 1 then
       begin

          SetLength(LV1,2);
          LV1[0].Expression:=SM;
          LV1[1].Expression:=SD;
          ND1.N:=2;
          ND1.NFunc:=CM_DIV;
          FAnsw:=False;
       end
       else
       if CUnit = -1 then         //NCOP = _ABSENT
       begin

          SetLength(LV1,1);
          LV1[0].Expression:=SM+'/('+SD+')';
          ND1.N:=1;
          ND1.NFunc:=CM_NEG;
          ND1.COP:=_Func;
          FAnsw:=True;
       end
       else             // SM/SD*Const
       begin

          SetLength(LV1,1);
          LV1[0].Expression:=SM+'/('+SD+')';
          ND1.N:=1;
          ND1.NFunc:=CM_MUL;
          FAnsw:=True;

          if ConstT = T_Real then
          begin
           ND1.FD:=CF.re;
           ND1.TC:=C_Real;
          end
          else
          begin
           ND1.FDC.re:=CF.re;
           ND1.FDC.im:=CF.im;
           ND1.TC:=C_Complex;
          end;
       end;


     end
     else
     begin
          {
          SetLength(LV1,2);
          LV1[0].Expression:=SM;
          LV1[1].Expression:=SD;
          ND1.N:=2;
          ND1.NFunc:=CM_DIV;
          FAnsw:=False;
          }
         //DeleteExternalBracketPS(@SD);
        _FindVar(@SM,@SD);
         ND1.NFunc:=CM_DIV;
     end;


 end;


end;

if ConstT = T_Real then ND1.TC := C_Real else if ConstT = T_Complex  then ND1.TC := C_Complex;


 {искать заново положение NPOS, если было вычисление const.: т.к. размер Sret изменился}
// if NCOP <> _ABSENT then FindMainOperationP(@Sret,NCOP,NPOS);
  NPOS:=lastpos;

endp:
TryCatchFPUException;    {.229}


except
 on E: EZeroDivide      do F_InternalError:=E_ZeroDivide;
 on E: EInvalidOp       do F_InternalError:=E_InvalidOp;
 on E: EOverFlow        do F_InternalError:=E_OverFlow;
 on E: EUnderFlow       do F_InternalError:=E_UnderFlow;
 on E: EIntOverFlow     do F_InternalError:=E_IntOverFlow;
 on E: EAccessViolation do F_InternalError:=E_AccessViolation;
 on E: EOutOfMemory     do F_InternalError:=E_OutOfMemory;
 on E: EStackOverFlow   do F_InternalError:=E_StackOverFlow;
end;

   if F_InternalError <> 0 then
      F_SyntaxErrorCode:=E_INTERNAL_ERROR_AT_CALCULATION;


MulDivAnalizator:=FAnsw;
end;






procedure TForevalH.FindMainOperationPS(PS: PString; var NCOP: Integer; var NPos: Cardinal; var NCOP_1: Integer; var NCOP_2: Integer);
label endp;
var
Pl,Ml,BZ1,BZ2: Boolean;
i,b,b1,b2: Integer;
NCOP1,NCOP2,NPos1,nexpr,NPos1T,NCOP1T,LenS: Integer;
SE: Boolean;
Sa1,Sa2: String;
begin
//Sret:=S;


if PS^ = '' then
begin
 F_SyntaxErrorCode:=E_MISSING_EXPRESSION;
 F_SyntaxErrorString:=Copy(PS^,1,Length(PS^));
 goto endp;
end;

//if PS^[1] = '+' then Delete(PS^,1,1); {.302} // +Expr -> Expr
nexpr:=1; {.217A}
G_NExpr:=1; {.318}
SE:=False;

NCOP1:=_ABSENT; NCOP2:=_ABSENT;  NCOP:=_ABSENT;    NPos:=0;
NCOP1T:=_ABSENT; NPos1T:=0;
b:=0; b1:=0; b2:=0; Pl:=False; Ml:=False;

if PS^[1] = '(' then b:=-1 else
  if PS^[1] = '[' then b1:=-1 else
    if PS^[1] = '{' then b2:=-1 else
      if (PS^[1] = ')') or (PS^[1] = ']') or (PS^[1] = '}') then
      begin
       F_SyntaxErrorCode:=E_MISSING_ROUND_BRACKET;
       F_SyntaxErrorString:=Copy(PS^,1,Length(PS^));
       goto endp;
      end;


//for i:=2 to Length(PS^)-1 {т.к. 1-ый и последний символы м.б. одноарг. символами}  do
{.340}
LenS:=Length(PS^)-1;
i:=2;
while i <= LenS do
begin
 if PS^[i] = '(' then b:=b-1;
 if PS^[i] = ')' then b:=b+1;
 if PS^[i] = '[' then b1:=b1-1;
 if PS^[i] = ']' then b1:=b1+1;
 if PS^[i] = '{' then b2:=b2-1;
 if PS^[i] = '}' then b2:=b2+1;

 if (b = 0) and (b1 = 0) and (b2 = 0) then
 begin

  //NCOP2:=FindOperation(PS^[i]);
  NCOP2:=FindOperationPS(PS,i,2); {.340}
  if NCOP2 <> _ABSENT then       {.195}
  begin

    if Alg.Opr[NCOP2].NArg = 2 then //вначале только 2 арг. операции
    begin

      if (NCOP2 <> _ABSENT) and (NCOP1 <> _ABSENT) then
      begin
       {обязательно <=, чтобы взять последнее слагаемое !!!}
       if (Alg.Opr[NCOP2].PR <= Alg.Opr[NCOP1].PR)  then
       begin
        NCOP1:=NCOP2;
        NPos1:=i;
       end;
      end
      else
      if (NCOP2 <> _ABSENT) and (NCOP1 = _ABSENT) then
      begin
       NCOP1:=NCOP2;
       NPos1:=i;
      end;

    inc(nexpr);   {.217A}
   end;

    i:=i+Alg.Opr[NCOP2].LenOp-1; {.340}   //корректировка позиции следующего символа на длину операции   x***y
  end;

 end;
 {.300}

 NPos:=NPos1;
 NCOP:=NCOP1;

 inc(i); {.340}

end;

G_NExpr:=nexpr; {.318}

//коррекция выражений на одноарг. оп. типа -x^y, -z1^z2   (neg)
//FindSingleOP(S,NCop,NPos1);
//NCop1:=FindOperation(PS^[1]);   {.197}

NCop1:=FindOperationPS(PS,1,1); {.340}    //искать одноарг. операцию на первой позиции!!

{.357}
NCOP_1:=NCop1; NCOP_2:=NCOP;
{
 Используется в StringAnalizatorMEPS при целочисленной оптимизации
 Для случая, если перед выражением с главной операцией MUL идёт минус (NEG)  -j*k ; -2*k; -2*j*k*n; -k*2*j;
 В этих случаях FindMainOperationPS возвращает  _NOT_FOUND , т.к. главная операция  NEG - одноаргументна
 NCop2 - двуаргументная операция (если есть) NPOS - её позиция; NCop1 - однаргументная операция в начале выражения
 Иначе выражение не распознаётся, как IntForm
}


if (NCOP1 <> _ABSENT) then
begin
 if (NCOP <> _ABSENT) then
 begin
   if  (Alg.Opr[NCOP1].PR < Alg.Opr[NCOP].PR)  then NCOP:=_ABSENT;
 end
 else NCOP:=_ABSENT;
end;


//find synt. error:
if NCop = _ABSENT then
begin
 NCOP1:=FindOperation(PS^[1]); NCOP2:=FindOperation(PS^[Length(PS^)]);
 if NCOP1 <> _ABSENT then
 begin
   if (Alg.Opr[NCOP1].NArg = 2) and (Alg.Opr[NCOP1].Name <> '-') then
   begin
     F_SyntaxErrorCode:=E_MISSING_EXPRESSION;
      F_SyntaxErrorString:=Copy(PS^,1,Length(PS^));
   end
 end
 else
 if NCOP2 <> _ABSENT then
 begin
   if Alg.Opr[NCOP2].NArg = 2 then
   begin
     F_SyntaxErrorCode:=E_MISSING_EXPRESSION;
      F_SyntaxErrorString:=Copy(PS^,1,Length(PS^));
   end
 end;
end;


{.217A}
(*
if M_ParseMode <> M_Diff then      {.301}
begin

  if (NCOP <> _ABSENT) and (F_MulDivOptimization = True) and (BMulDivOpt = True) then
  begin
     if (Alg.Opr[NCOP].NFunc = CM_DIV) or (Alg.Opr[NCOP].NFunc = CM_MUL) then
     begin
        if (nexpr > 2) then MulDivOptPS(PS,NCOP,NPos) //MulDivOpt(S,NCOP,NPos,Sret) {.314}
        else
        begin
          //(nexpr = 2)
          Sa1:=Copy(PS^,1,NPos-1);
          Sa2:=Copy(PS^,NPos+1,Length(PS^)-NPos);
          BZ1:=CheckToZeroPS(@Sa1); BZ2:=CheckToZeroPS(@Sa2);   //CheckToZero(Sa2);

          if (Alg.Opr[NCOP].NFunc = CM_DIV) and (BZ2 = True) then
          begin
            F_InternalError:=E_ZeroDivide ;
            F_SyntaxErrorCode:=E_INTERNAL_ERROR;
            F_SyntaxErrorString:=Copy(PS^,1,Length(PS^));
          end
          else
          begin

            if (BZ1 = True) and (Sa2 <> S_IM_UNIT)  then  begin {Sret:='0';} PS^:='0'; NCOP:=_ABSENT; end {.314}
             else
            if (BZ2 = True) and (Sa1 <> S_IM_UNIT)  then  begin {Sret:='0';} PS^:='0'; NCOP:=_ABSENT; end;  {.314}

          end;



        end;

     end;
  end;

end;
*)


endp:
end;





procedure TForevalH.StringAnalizatorPS(PS: PString; var ND: TDataNode; var HS:PLevel);
label 3,endp;
var
SS,S1,S2: String;
PR,NPR: Cardinal;
BH,IH,IH1: PLevel;
i,p,b: Cardinal;
PR1,N,NCop,NCop1,NCop2: Integer;
ni,SB: Integer;
NPos: Cardinal;
BOP,Lc,Lp: Integer;
px: extended;
cx: TComplex;
begin

//поиск в сложном выражении операции с низшим приоритетом - главная операция узла


if F_SyntaxErrorCode <> 0 then goto endp;
BOP:=0;

//SS:=S;

//{.302} off:
//DeleteExternalBracketP(@SS); {.219}
//FindExternalBracket(S,SS);

InitNode(ND);

//{.302} off:
(*
if M_ParseMode <> M_Diff then      {.301}
begin
//SubstParam(SS,px,SB);     //(-1.12345E-10)
SubstParamCX(SS,cx,SB);     //(-1.12345E-10); 2+3i; 2i-5i; (1E+1)-(2E+1)i;
if SB <> C_None  then
begin
  NCop:=-1;
  goto 3;
end;
end;
*)




PR:=0;
//FindMainOperation(SS,NCop,NPos);
//FindMainOperationA(SS,NCop,NPos,SS);  {.219}

//искать главную операцию в сложном  выражении (двуаргументные операции: + - * / ^ ):
FindMainOperationPS(PS,NCop,NPos,NCop1,NCop2);  {.219}
N:=0;
if NCop <> -1 then
begin
 //inc(F_IdN);
 //ND.IdN:=F_IdN;
 SetLength(HS,2);
 S1:=Copy(PS^,1,NPos-1);
 //DeleteExternalBracketPS(@S1); {.219}
 HS[0].Expression:=S1;//Copy(SS,1,NPos-1);
 HS[0].NL:=1;
 //HS[0].IdL:=F_IdN;

 //S2:=Copy(PS^,NPos+1,Length(PS^)-NPos+1);
 {.340}
 Lc:=Length(PS^)-(NPos+Alg.Opr[NCOP].LenOp)+1;
 Lp:=NPos+Alg.Opr[NCOP].LenOp;
 S2:=Copy(PS^,Lp,Lc);

 //DeleteExternalBracketPS(@S2); {.219}
 HS[1].Expression:=S2;//Copy(SS,NPos+1,Length(SS)-NPos+1);
 HS[1].NL:=2;
 //HS[1].IdL:=F_IdN;
 ND.N:=2;
 ND.COP:=_COP;
 ND.NFunc:=Alg.Opr[NCop].NFunc;
 ND.NCOP:=NCOP;

 //ND.ExpressionArg:=SS;
 {.216}
 //{if NCOP = CM_POWER then }ND.ExpressionArg:=HS[0].Expression+','+HS[1].Expression;    {.319}off

 {.319}//on
 {
   .ExpressionArg исп-ся в ReplaceOptimization . Добавление ко второму аргументу знака операции предотвращает ложную замену
   в ReplaceOperation после MulDivAnalizator: x*a, x/a -> (x,a) COP=CM_MUL в обоих случаях. Во втором константа умножения = 1/a
 }
if M_ParseMode = M_Compile then    // <> M_ParseDiffExpr  {.319}
begin
 DeleteExternalBracketPS(@S1);
 DeleteExternalBracketPS(@S2);
 ND.ExpressionArg:=S1+','+Alg.Opr[NCop].Name+S2;
end;

 BOP:=2;
end
else
//выражение простое, искать одноаргументную операцию: -  ! !! .re .im $ )
begin
 FindSingleOpPS(PS,NCop);
 if NCop <> -1 then
 begin
  ND.COP:=_FUNC;
  ND.N:=1;
  ND.NFunc:=Alg.Opr[NCop].NFunc;
  SetLength(HS,1);


  (*
  if Alg.Opr[NCop].GS = -1 then HS[0].Expression:=Copy(PS^,2,Length(PS^)-1)//Copy(SS,2,Length(SS)-1)
  else
  if Alg.Opr[NCop].GS = -2 then HS[0].Expression:=Copy(PS^,1,Length(PS^)-Length(Alg.Opr[NCop].Name));//Copy(SS,1,Length(SS)-Length(Alg.Opr[NCop].Name){-1});
  *)

  {.340}
  if Alg.Opr[NCop].Pos = _before then HS[0].Expression:=Copy(PS^,Alg.Opr[NCop].LenOp+1,Length(PS^)-Alg.Opr[NCop].LenOp)
  else
  if Alg.Opr[NCop].Pos = _after then HS[0].Expression:=Copy(PS^,1,Length(PS^)-Alg.Opr[NCop].LenOp);

  HS[0].NL:=1;
  ND.NCOP:=NCOP;
  //inc(F_IdN);   {.193}
  ND.ExpressionArg:=Copy(PS^,1,Length(PS^));//HS[0].Expression; //не исп-ся
  //ND.IdN:=F_IdN;
  //HS[0].IdL:=F_IdN;
  //ND.SFunc:=Alg.ExFunc[Alg.Opr[NCop].NFunc].Name;    {.301}
 end
 else
 begin
3:
  ND.COP:=0;
  SetLength(HS,1);
  ND.N:=1;
  HS[0].NL:=1;
  HS[0].Expression:=Copy(PS^,1,Length(PS^));
 end;
end;

for i := 0 to Length(HS) - 1 do   {.309}
begin
 HS[i].ExtFunc:=_NOT_FOUND;
end;

//find synt. error
if (NCop <> -1) and (BOP = 2) then
begin
 FindExternalBracket(HS[0].Expression,S1);
 FindExternalBracket(HS[1].Expression,S2);
 if (S1 = '') or (S2 = '') then
 begin
  F_SyntaxErrorCode:=5;
  F_SyntaxErrorString:=Copy(PS^,1,Length(PS^));
 end;
end
else
if NCop <> -1 then
begin
   if HS[0].Expression = '' then
   begin
     F_SyntaxErrorCode:=5;
     F_SyntaxErrorString:=Copy(PS^,1,Length(PS^));
   end;
end;

endp:
end;




(*
procedure TForevalH.SubstParamP(PS: PString;  var C: TFloat; var SB: Boolean);
label endp;
var
N,i: Cardinal;
S1h,S3: String;
Ct: TFloat;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

SB:=False;
C:=0;
if PS^ = '' then
begin
 F_SyntaxErrorCode:=5;
 goto endp;
end;


SaveSW; {.229} {TryStrToFloat damage SW}
if TryStrToFloat(PS^,Ct,G_FMT) then    {.195}
begin
 //C:=StrToFloat({PointToDec(S1h)}S1,G_FMT);
 C:=Ct;
 SB:=True;
end
else
SB:=False;

endp:
end;
*)



{.311}
procedure TForevalH.SubstParamPS(PS: PString;  var Re,Im: Extended; var TV: Integer);
label endp;                                       //TV = _NOT_FOUND, T_Real, T_Complex
var
Sg,i: Integer;
S1h,S3: String;
Ct: Extended;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

TV:=_NOT_FOUND;
Re:=0;Im:=0;
if PS^ = '' then
begin
 F_SyntaxErrorCode:=5;
 goto endp;
end;

Sg:=1;
if PS^[1] = '-' then
begin
 Sg:=-1;
 Delete(PS^,1,1);
end;




for i:=0 to High(Alg.Param) do
begin
 if PS^ =  Alg.Param[i].Name then
 begin
   Re:=Sg*Alg.Param[i].Real;
   Im:=Sg*Alg.Param[i].Imag;
   TV:=Alg.Param[i].TypeF;
   goto endp;
 end;
end;


SaveSW; {.229} {TryStrToFloat damage SW}
if TryStrToFloat(PS^,Ct,G_FMT) then    {.195}
begin
 Re:=Sg*Ct;
 TV:=T_Real;
end;

endp:
if Sg = -1  then PS^:='-'+PS^;
end;





{.347}
function TForevalH.SubstParamPSF(PS: PString;  var Re,Im: Extended): Integer;
var                                     //TV = _NOT_FOUND, T_Real, T_Complex
 TV: Integer;
begin
 SubstParamPS(PS,Re,Im,TV);
 SubstParamPSF:=TV;
end;




{.347}
function TForevalH.SubstParamAPSF(PS: PString;  var Re,Im: Extended): Integer;
var                                     //TV = _NOT_FOUND, T_Real, T_Complex
 TV: Integer;
begin
 SubstParamPS(PS,Re,Im,TV);
 if (PS^ = S_IM_UNIT) and (F_RecoverImUnit = False) then
 begin
   Re:=0;
   Im:=1;
   TV:=T_Complex;
   F_ComplexNumber:=True;
 end;
 SubstParamAPSF:=TV;
end;



{.330}
procedure TForevalH.SubstNumPS(PS: PString;  var Re,Im: Extended; var TV: Integer);
label endp;                                       //TV = _NOT_FOUND, T_Real, T_Complex
var
Sg,i: Integer;
S1h,S3: String;
Ct: Extended;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

TV:=_NOT_FOUND;
Re:=0;Im:=0;
if PS^ = '' then
begin
 F_SyntaxErrorCode:=5;
 goto endp;
end;

Sg:=1;
if PS^[1] = '-' then
begin
 Sg:=-1;
 Delete(PS^,1,1);
end;



(*
for i:=0 to High(Alg.Param) do
begin
 if PS^ =  Alg.Param[i].Name then
 begin
   Re:=Sg*Alg.Param[i].Real;
   Im:=Sg*Alg.Param[i].Imag;
   TV:=Alg.Param[i].TypeF;
   goto endp;
 end;
end;
*)

SaveSW; {.229} {TryStrToFloat damage SW}
if TryStrToFloat(PS^,Ct,G_FMT) then    {.195}
begin
 Re:=Sg*Ct;
 TV:=T_Real;
end;

endp:
if Sg = -1  then PS^:='-'+PS^;
end;



procedure TForevalH.SubstParam(S1: String;  var C: TFloat; var SB: Integer);
label endp;
var
N,i: Cardinal;
S1h,S3: String;
Ct: TFloat;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

SB:=0;
C:=0;
if S1 = '' then
begin
F_SyntaxErrorCode:=5;
goto endp;
end;

N:=1; {S1h:=Copy(S1,1,Length(S1));}  SB:=C_None;

SaveSW; {.229} {TryStrToFloat damage SW}
if TryStrToFloat(S1,Ct,G_FMT) then    {.195}
begin
 C:=StrToFloat({PointToDec(S1h)}S1,G_FMT);
 SB:=C_Real;
end
else
SB:=C_None;

endp:
end;





procedure TForevalH.SubstParamCXPS(PS: PString;  var CX: TComplex; var SB: Integer);
label endp;
var
BDelBr: Boolean;
C,Cr1,Cr2,Ci1,Ci2,Re,Im: TFloat;
N,i,NPos: Cardinal;
NCop,Li,T1,T2,nz,ni,TV,Neg,NCop1,NCop2: Integer;
S1,S2,Sc,Si,St: String;                              //SB=C_None{no},C_Real(real),C_Image(image),C_Complex(complex)
begin
if F_SyntaxErrorCode <> 0 then goto endp;

//FindExternalBracket(S,S);

//BDelBr:=DeleteExternalBracketPS(PS); {.316}
BDelBr:=DeleteExternalBracketNegPS(PS,Neg); {.317}

C:=0; SB:=C_None; CX.re:=0; CX.im:=0; nz:=1;
//SubstParam(S, C, SB);
SubstParamPS(PS,Re,Im, TV);

if TV = T_Real then
begin
  CX.re:=Re;
  SB:=C_Real;
  goto endp;
end
else
if TV = T_Complex then
begin
  CX.re:=Re;
  CX.im:=Im;
  SB:=C_Complex;
  goto endp;
end;

if F_SubstNumCX = False then
begin
 SB:=C_None;
 goto endp;
end;



St:=PS^;
if (St = S_IM_UNIT) and (F_RecoverImUnit = False) then
begin
   CX.im:=1;
   SB:=C_Image;
   F_ComplexNumber:=True;  {.347}
   goto endp;
end;



C:=0; SB:=C_None;
//FindMainOperationP(PS,NCop,NPos);
FindMainOperationPS(PS,NCop,NPos,NCop1,NCop2); {.315}

if NCop = -1 then        //3i,-3i
begin
 Li:=Length(S_IM_UNIT);
 Sc:=Copy(PS^,1,Length(PS^)-Li);
 Si:=Copy(PS^,Length(PS^)-Li+1,Li);


 if (Si = S_IM_UNIT) and (F_RecoverImUnit = False) then
 begin
   if Sc = '-' then Sc:='-1';    //-i
   //FindExternalBracket(Sc,Sc);
   DeleteExternalBracketPS(@Sc); {.219}
   //SubstParam(Sc, C, SB);
   SubstParamPS(@Sc, Re,Im, TV);
   //if SB = C_Real then
   if TV = T_Real then
   begin
     CX.im:=Re;
     SB:=C_Image;
     F_ComplexNumber:=True;   {.347}
   end;
 end;

 goto endp;
end;

//-2-(-8)
//ai+i    5i+1
if  (NCop = 0) or (NCop = 1) then      {+,-}
begin
 if NCop = 1 then nz:=-1;

 S1:=Copy(PS^,1,NPos-1);
 S2:=Copy(PS^,NPos+1,Length(PS^)-NPos+1);

 Li:=Length(S_IM_UNIT);
 Sc:=Copy(S1,1,Length(S1)-Li);
 Si:=Copy(S1,Length(S1)-Li+1,Li);
 T1:=0;

 if (Si = S_IM_UNIT) and (F_RecoverImUnit = False) then             //i-7i,  i+i, -i-i, -i-(i)
 begin
   //FindExternalBracket(Sc,Sc);
   DeleteExternalBracketPS(@Sc); {.219}
   if Sc = '-' then Sc:='-1';    //-i
   if Sc = '' then Sc:='1';
   //SubstParam(Sc, C, SB);
   //SubstParamPS(@Sc, Re, Im, TV);
   SubstNumPS(@Sc, Re, Im, TV); {.330} // ai+i, ai+1 del ERROR in param end on i  //учитывать только числа при i !!! . не параметры
   //if SB = C_Real then
   if TV = T_Real then
   begin
     Ci1:=Re;
     T1:=_IM;
     SB:=C_Real;
     F_ComplexNumber:=True; {.347}
   end;
 end
 else
 begin
   //FindExternalBracket(S1,S1);
   DeleteExternalBracketPS(@S1); {.219}
   //SubstParam(S1, C, SB);
   //if SB = C_Real then
   SubstParamPS(@S1, Re, Im, TV);
   if TV = T_Real then
   begin
     Cr1:=Re;
     T1:=_RE;
     SB:=C_Real;
   end;
 end;

 if T1 = 0 then begin SB:=C_None; goto endp; end;


 //i+ai     1+5i
 Li:=Length(S_IM_UNIT);
 Sc:=Copy(S2,1,Length(S2)-Li);
 Si:=Copy(S2,Length(S2)-Li+1,Li);
 T2:=0;

 if (Si = S_IM_UNIT) and (F_RecoverImUnit = False) then
 begin
   //FindExternalBracket(Sc,Sc);
   DeleteExternalBracketPS(@Sc); {.219}
   if Sc = '-' then Sc:='-1';    //-i
   if Sc = '' then Sc:='1';
   //SubstParam(Sc, C, SB);
   //if SB = C_Real then
   //SubstParamPS(@Sc, Re, Im, TV);
   SubstNumPS(@Sc, Re, Im, TV); {.330} // i+ai, 1+ai del ERROR in param end on i    //учитывать только числа при i !!! . не параметры
   if TV = T_Real then
   begin
     Ci2:=Re;
     T2:=_IM;
     SB:=C_Real;
     F_ComplexNumber:=True; {.347}
   end;
 end
 else
 begin
   //FindExternalBracket(S2,S2);
   DeleteExternalBracketPS(@S2); {.219}
   //SubstParam(S2, C, SB);
   //if SB = C_Real then
   SubstParamPS(@S2, Re, Im, TV);
   if TV = T_Real then
   begin
     Cr2:=Re;
     T2:=_RE;
     SB:=C_Real;
   end;
 end;

 if T2 = 0 then begin SB:=C_None; goto endp; end;

 if (T1 = _RE) and (T2 = _RE) then
 begin
  CX.re:=Cr1+nz*Cr2; SB:=C_Real;
 end
 else
  if (T1 = _IM) and (T2 = _IM) then
 begin
  CX.im:=Ci1+nz*Ci2; SB:=C_Image;
 end
 else
 if (T1 = _RE) and (T2 = _IM) then
 begin
  CX.re:=Cr1; CX.im:=nz*Ci2; SB:=C_Complex;
 end
 else
 if (T1 = _IM) and (T2 = _RE) then
 begin
  CX.re:=nz*Cr2; CX.im:=Ci1; SB:=C_Complex;
 end;

end;




endp:

//restore PS^ :

//if BDelBr = True then PS^:='('+PS^+')';  {.316}

{.317}

CX.re:=Neg*CX.re;
CX.im:=Neg*CX.im;

if BDelBr = True then
begin
 if Neg = 1 then PS^:='('+PS^+')' else if Neg = -1  then    PS^:='(-('+PS^+'))';    //.317
end;


end;



procedure TForevalH.SubstParamACXPS(PS: PString;   var Re,Im: Extended; var TP: Integer);
var
 CX: TComplex;
 TC: Integer;
begin
  SubstParamCXPS(PS, CX, TC);
  Re:=CX.re;
  Im:=CX.Im;
  If TC = C_None then TP:=_NOT_FOUND;
  If TC = C_Real then TP:=T_Real;
  If TC = C_Complex then TP:=T_Complex;
  If TC = C_Image then TP:=T_Complex;
end;


function TForevalH.SubstParamACXPSF(PS: PString; var Re,Im: Extended): Integer;
var
TP: Integer;
begin
  SubstParamACXPS(PS, Re,Im, TP);
  SubstParamACXPSF:=TP;
end;




procedure TForevalH.NumberAnalizatorPS(PS: PString;  var ND: TDataNode; var EOFN: Boolean);
label endp;
var
S2,S1: String;
ni,SB,code,i,PA: Integer;
C: TFloat;
TF: Integer;
BH: Boolean;
CX: TComplex;
begin
if F_SyntaxErrorCode <> 0 then goto endp;




EOFN:=False;
InitNode(ND);


//поиск переменной
FindVarPS(PS,ni);
if ni >= 0 then
begin
   ND.COP:=_LDSF;
   ND.NObj:=ni;
   ND.TypeF:=Alg.Obj[ni].TypeF; //не обязательно. Перезаписываются в  LinkDataNode
   ND.TypeM:=Alg.Obj[ni].MType; //не обязательно. Перезаписываются в  LinkDataNode
   EOFN:=True;
   //ND.TS:=TF;
   if PS^ = S_DiffVar then
   begin
        ND.SDiff:='1' ; F_DiffVarPresent:=True;   {.301}
   end;

   //загрузка указателя-переменной через команду _LDSA
   if Alg.Obj[ni].TypeF = T_Pointer then
   begin
      ND.COP:=_LDSA;
      ND.TypeF:=T_Pointer;
      ND.TypeM:=_Pointer;
      ND.AI:=_PointerVar;
   end;

   goto endp;
end;



{
Загрузка адреса: @Func; @var; @array=@array[0]
}    {.347}
(*
if F_EnableUsePointer = True then
begin
 if PS^[1] = '@' then
 begin
   BH:=FindAddrObj(PS,ND,ND);
   if BH = True then
   begin
      ND.COP:=_LDSA;
      ND.TypeF:=T_Pointer;//T_Real;//T_Integer//T_Pointer;
      EOFN:=True;
      goto endp;
   end;
 end;
end;
*)


{.301}
 //далее только константы
if M_ParseMode = M_ParseDiffExpr then
begin
 ND.SDiff:='0';
 EOFN:=True;
 //условно:        {.327}
 ND.COP:=_LDSC;
 ND.TC:=C_None;
 ND.FDC.re:=0;
 ND.FDC.im:=0;
 ND.FD:=0;

 goto endp;
end;


//SubstParam(S,C,SB);
//поиск константы
SubstParamCXPS(PS,CX,SB);
if SB <> C_None then
begin
    ND.TC:=SB;
    ND.FDC.re:=CX.re;
    ND.FDC.im:=CX.im;
    ND.FD:=CX.re;
   //inc(F_IdN);
   //ND.IdN:=F_IdN;
    if SB = C_Real  then ND.COP:=_LDSC else  ND.COP:=_LDSCX;
    //ND.SDiff:='0'; //{.301}
    EOFN:=True;
    goto endp;
end;




//поиск служебных (внутренних команд)
FindControlComPS(PS,code,ni,BH);
if BH = True then
begin
 if code = _FLD then
 begin
   ND.COP:=_FLD;
 end
 else
 if code = _JMP then
 begin
   ND.COP:=_FUNC;
   ND.NFunc:=CM_JMP;
 end
 else
 if code = CM_NOP then  {.203}
 begin
   ND.COP:=_FUNC;
   ND.NFunc:=CM_NOP;
   ND.N:=0;
 end
 else
 if code = CM_VOID then  {.303}
 begin
   ND.COP:=_FUNC;
   ND.NFunc:=CM_VOID;
   ND.N:=0;
 end;

 ND.N:=0;
 ND.AI:=ni;
 EOFN:=True;

 goto endp;
end;

{
FindJMP(S,ni);
if ni <> 0 then
begin
 ND.COP:=_JMP;
 ND.AI:=ni;
 EOFN:=True;
 goto endp;
end;
}

F_SyntaxErrorCode:=1;         //неизвестный символ
F_SyntaxErrorString:=Copy(PS^,1,Length(PS^));
EOFN:=False;



endp:
end;




procedure TForevalH.FindConstPS(PS: PString;  var ND: TDataNode; var EOFN: Boolean);
label endp;
var
S2,S1: String;
ni,SB,code: Integer;
C: TFloat;
TF: Integer;
BH: Boolean;
CX: TComplex;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

EOFN:=False;
InitNode(ND);

//BDelBr:=DeleteExternalBracketNegPS(PS,Neg); {.317}

SubstParamCXPS(PS,CX,SB);
if SB <> C_None then
begin
     //.317
   { CX.re:=Neg*CX.re;
    CX.im:=Neg*CX.im; }

    ND.TC:=SB;
    ND.FDC.re:=CX.re;
    ND.FDC.im:=CX.im;
    ND.FD:=CX.re;
    if SB = C_Real  then ND.COP:=_LDSC else  ND.COP:=_LDSCX;
    EOFN:=True;
end ;
{
else   //.317
if BDelBr = True then
begin
 if Neg = 1 then PS^:='('+PS^+')' else if Neg = -1  then    PS^:='(-('+PS^+'))';
end;
 }

endp:
end;




function TForevalH.FindConst(S: String;  var Re,Im: Extended): Boolean;
var
S2,S1: String;
ni,SB,code: Integer;
C: TFloat;
TF: Integer;
Answ: Boolean;
CX: TComplex;

begin

Answ:=False;
Re:=0;
Im:=0;

SubstParamCXPS(@S,CX,SB);
if SB <> C_None then
begin
    Re:=CX.re;
    Im:=CX.im;
    Answ:=True;
end;

FindConst:=Answ;

end;




procedure TForevalH.FindControlCom(S: String; var code,ni: Integer; var BH: Boolean);
begin
BH:=False;
FindJMP(S,ni);
 if ni <> 0 then
 begin
  code:=_JMP;
  BH:=True;
 end
else
begin
FindFLD(S,ni);
if ni <> 0 then
 begin
  code:=_FLD;
  BH:=True;
 end
 else
 begin
  if S = SCnop then
  begin
   code:=CM_NOP;
   BH:=True;
  end
  else
  if S = SCvoid then
  begin
   code:=CM_VOID;
   BH:=True;
  end;
 end
end


end;



procedure TForevalH.FindControlComPS(PS: PString; var code,ni: Integer; var BH: Boolean);
begin
BH:=False;
FindJMPPS(PS,ni);
 if ni <> 0 then
 begin
  code:=_JMP;
  BH:=True;
 end
else
begin
FindFLDPS(PS,ni);
if ni <> 0 then
 begin
  code:=_FLD;
  BH:=True;
 end
 else
 begin
  if PS^ = SCnop then
  begin
   code:=CM_NOP;
   BH:=True;
  end
  else
  if PS^ = SCvoid then
  begin
   code:=CM_VOID;
   BH:=True;
  end;
 end
end


end;




procedure TForevalH.FindJMP(S: String; var ni: Integer);
begin
//ni= 1       2      3       4      5      6     7
//  #JMP, #JMPE, #JMPEL, #JMPEB, #JMPB, #JMPL, #JMPNE

if S = '#jmp'    then ni:=1 else
if S = '#jmpe'   then ni:=2 else
if S = '#jmpel'  then ni:=3 else
if S = '#jmpeb'  then ni:=4 else
if S = '#jmpb'   then ni:=5 else
if S = '#jmpl'   then ni:=6 else
if S = '#jmpne'  then ni:=7 else
ni:=0;

end;



procedure TForevalH.FindJMPPS(PS: PString; var ni: Integer);
begin
//ni= 1       2      3       4      5      6     7
//  #JMP, #JMPE, #JMPEL, #JMPEB, #JMPB, #JMPL, #JMPNE

if PS^ = '#jmp'    then ni:=1 else
if PS^ = '#jmpe'   then ni:=2 else
if PS^ = '#jmpel'  then ni:=3 else
if PS^ = '#jmpeb'  then ni:=4 else
if PS^ = '#jmpb'   then ni:=5 else
if PS^ = '#jmpl'   then ni:=6 else
if PS^ = '#jmpne'  then ni:=7 else
ni:=0;

end;



procedure TForevalH.FindFLD(S: String; var ni: Integer);
begin
//ni= 1     2
//  #FLD1, #FLDZ,
if S = '#fld1'    then ni:=1 else
if S = '#fldz'   then ni:=2 else
ni:=0;
end;



procedure TForevalH.FindFLDPS(PS: PString; var ni: Integer);
begin
//ni= 1     2
//  #FLD1, #FLDZ,
if PS^ = '#fld1'    then ni:=1 else
if PS^ = '#fldz'   then ni:=2 else
ni:=0;
end;

procedure TForevalH.FindReIm(S: String; var S1:String; var TF: Integer);
var
r,i: Integer;
SR,SI,ST: String;
begin
  //r:=pos('.re',LowerCase(S));
  r:=pos('.re',S);
  if (r <> 0) and (r = Length(S)-2) then
  begin
   TF:=_RE; S1:=Copy(S,1,Length(S)-3);
  end
  else
  begin
   //i:=pos('.im',LowerCase(S));
   i:=pos('.im',S);
   if (i <> 0) and (i = Length(S)-2) then
   begin
    TF:=_IM; S1:=Copy(S,1,Length(S)-3);
   end
   else
   begin
    S1:=S; TF:=0;
   end;
  end;



end;



procedure TForevalH.FindReImPS(PS: PString; var TF: Integer);
var
r,i: Integer;
SR,SI,ST: String;
begin
  //r:=pos('.re',LowerCase(S));
  r:=pos('.re',PS^);
  if (r <> 0) and (r = Length(PS^)-2) then
  begin
   TF:=_RE;
   Delete(PS^,Length(PS^)-2,3);
   //S1:=Copy(S,1,Length(PS^)-3);
  end
  else
  begin
   //i:=pos('.im',LowerCase(S));
   i:=pos('.im',PS^);
   if (i <> 0) and (i = Length(PS^)-2) then
   begin
    TF:=_IM;
    Delete(PS^,Length(PS^)-2,3);
    //S1:=Copy(S,1,Length(PS^)-3);
   end
   else
   begin
    //S1:=S;
    TF:=0;
   end;
  end;
end;




procedure TForevalH.FindExprTypePS(PS: PString; var ExprType: Integer);
  //ExprType = _ComplexVar,  _ComplexVarRE, ComplexVarIM, _FloatVar, _IntVar  , _Const, _IntArray, _FloatArray, _IntForm , _NOT_FOUND,
var
  nf,ni: Integer;
  FD: extended;
  TypeS: Integer;
  code: Integer;
  AIVP: TArrayIntVarProd;
  NV,IC,TC: Integer;
  Sv,Sa,Sc: String;
  FH1: Boolean;
begin
ExprType:=_NOT_FOUND;

   FindReIm(PS^,Sc,TC);
   FindVarConstPS(@Sc,nf,FD,TypeS); //TypeS = _ComplexVar, _FloatVar, _IntVar (nf) , _Const(number: FD), _NOT_FOUND
   if TypeS <> _NOT_FOUND then
   begin
     ExprType:=TypeS;
     if (TypeS = _ComplexVar) and (TC = _RE) then   ExprType:=_ComplexVarRE else
     if (TypeS = _ComplexVar) and (TC = _IM) then   ExprType:=_ComplexVarIM;
   end
   else    //find array, IntForm
   begin
      FindFuncBrPS(PS,'[',']',Sv,Sa,FH1);
      if FH1 = True then
      begin
          FindVarPS(@Sv,ni);

          if ni <> -1 then //ni - vector
          begin
             if Alg.Obj[ni].TypeF = T_Array then
             begin
                if (Alg.Obj[ni].MType =  _Double) or (Alg.Obj[ni].MType =  _Extended) then   ExprType:=_FloatArray
                else
                if Alg.Obj[ni].MType =  _Integer   then   ExprType:=_IntArray;
             end;
          end;
      end
      else //find  _IntForm
      begin

           FindExtArgIntPS(PS,code, AIVP, NV,IC);
           {
               code = _IntConst   = IC
               code = _IntVar     = NV
               code = _IntForm    = a1*I1*...Ik+a2*I1*...*In+...+am*I1*...*Im+CI;  AIVP[]=ArrayOf(IVP); IVP.NV=ArrayOf(nv); IVP.A = ai;
               code = _NOT_FOUND;
           }
           ExprType:=code;

      end;
   end;

end;




procedure TForevalH.FindVarConstPS(PS: PString;  var nf: Integer; var FD: extended; var TypeS: Integer);
label endp;
var
S2: String;
ni,TV: Integer;
Re,Im: TFloat;
SB: Boolean;
begin
nf:=_NOT_FOUND;
FD:=0;
TypeS:=_NOT_FOUND;

               //TypeS = _ComplexVar, _FloatVar, _IntVar (nf) , _Const(number: FD), _NOT_FOUND
if F_SyntaxErrorCode <> 0 then goto endp;


FindVarPS(PS,ni); //{P}
if ni >= 0 then
begin
 if  (Alg.Obj[ni].TypeF = T_Complex) then
 begin
  nf:=ni;
  TypeS:=_ComplexVar;
 end
 else
 if (Alg.Obj[ni].TypeF = T_Real) and (Alg.Obj[ni].MType = _Integer) then
 begin
  nf:=ni;
  TypeS:=_IntVar;
 end
 else
 if (Alg.Obj[ni].TypeF = T_Real)  then
 begin
  nf:=ni;
  TypeS:=_FloatVar;
 end
end
else
begin
 SubstParamPS(PS,Re,Im,TV);     {.311}
 if TV = T_Real then
 begin
  FD:=Re;
  TypeS:=_Const;
 end;
end;

endp:
end;



{.361}
procedure TForevalH.FindVarConstCxPS(PS: PString;  var nf: Integer; var Re,Im: extended; var TypeS, TypeC: Integer);
label endp;
var
S2: String;
ni,TV,TC: Integer;
SB: Boolean;
CX: TComplex;
begin
nf:=_NOT_FOUND;
//FD:=0;
TypeS:=_NOT_FOUND;
Re:=0;
Im:=0;
{
 "i" задана ,как переменная, а определяется либо как переменная: i, либо как константа: i, -i, 2i, a+bi,...    !!!
}

               //TypeS = _ComplexVar, _FloatVar, _IntVar (nf) , _Const(real number: Re), _ConstComplex, _NOT_FOUND
if F_SyntaxErrorCode <> 0 then goto endp;


FindVarPS(PS,ni); //{P}
if ni >= 0 then
begin
 if  (Alg.Obj[ni].TypeF = T_Complex) then
 begin
  nf:=ni;
  TypeS:=_ComplexVar;
  //исключение, т.к. "i" задана ,как переменная, а используется, как константа
  if (PS^ = S_IM_UNIT) and (F_RecoverImUnit = False) then
  begin
    Re:=0;
    Im:=1;
    TypeC:=C_Image;
  end;
 end
 else
 if (Alg.Obj[ni].TypeF = T_Real) and (Alg.Obj[ni].MType = _Integer) then
 begin
  nf:=ni;
  TypeS:=_IntVar;
 end
 else
 if (Alg.Obj[ni].TypeF = T_Real)  then
 begin
  nf:=ni;
  TypeS:=_FloatVar;
 end
end
else
begin
 //SubstParamPS(PS,Re,Im,TV);
 SubstParamCXPS(PS,CX, TC);
  //SB=C_None{no},C_Real(real),C_Image(image),C_Complex(complex)
 if TC = C_None then
 begin
   TypeS:=_NOT_FOUND;
   TypeC:=C_None;
 end
 else
 if TC = C_Real then
 begin
  Re:=CX.re;
  Im:=0;
  TypeS:=_Const;      //для совместимости с   FindVarConstPS
  TypeC:=C_Real;
 end
 else
 if TC = C_Image then
 begin
  Re:=0;
  Im:=Cx.im;
  TypeS:=_ConstComplex;
  TypeC:=C_Image;
 end
 else
 if TC = C_Complex then
 begin
  Re:=Cx.re;
  Im:=Cx.im;
  TypeS:=_ConstComplex;
  TypeC:=C_Complex;
 end;

end;

endp:
end;




procedure TForevalH.FindIntVarConstP(PS: PString; var nv,ic,typeVC: Integer);
label outc,endp;
var                                           {finding only integer const,var}
i: Cardinal;
S2,S3: String;
fx: extended;
Neg: Boolean;
begin

nv:=_NOT_FOUND;
typeVC:=_NOT_FOUND;
ic:=1;

if F_SyntaxErrorCode <> 0 then goto endp;


if PS^ = '' then
begin
 F_SyntaxErrorCode:=5;
 goto endp;
end;






SaveSW;  {TryStrToFloat damage SW}
if TryStrToFloat(PS^,fx,G_FMT) then
begin
 if (abs(fx) <= MaxInt) and (Trunc(fx) = fx) then
 begin
   typeVC:=_IntConst;
   ic:=Trunc(fx);
   goto endp;
 end;
end;


Neg:=False;
if PS^[1] = '-' then
begin
   Delete(PS^,1,1);
   Neg:=True;
   ic:=-1;
end;



for i:=0 to High(Alg.Obj) do
begin
S3:=Alg.Obj[i].Name;

 if PS^ = S3 then
  begin
   nv:=i;
   if Alg.Obj[i].TypeF = T_Complex then F_ComplexNumber:=True;   //в выражении присутствует комплексное число

   //if ((LowerCase(S3) <> 'pi') and (LowerCase(S3) <> 'i')) then F_PresentVar:=True;

   //if (S3 = 'pi') then  goto outc;
   if (S3 = S_IM_UNIT) and (Alg.Obj[i].TypeF = T_Complex)  then goto outc;

   F_PresentVar:=True;
   Alg.Obj[i].IsUsed:=_YES;

   goto outc;
  end;
end;

outc:
if nv >=  0 then
begin
 if (Alg.Obj[nv].TypeF = T_Real) and (Alg.Obj[nv].MType = _Integer) then
 begin
    typeVC:=_IntVar;
 end
 else
 begin
    typeVC:=_NOT_FOUND;
    nv:=_NOT_FOUND;
 end;
end;

if Neg = True then PS^:='-'+PS^; //восстановить: т.к. строка передаётся по ссылке !!!

endp:
end;




function  TForevalH.FindExtractArray(PS: PString; var Sv,Sa: String; var MType,ni: Integer): Boolean;
var                                           //Vec[indx]-> Sv='Vec' Sa='indx'; Mtype,ni
  BH: Boolean;
begin
  BH:=False;
  FindFuncBrPS(PS,'[',']',Sv,Sa,BH);
  if BH = True then FindVarPS(@Sv,ni) else ni:=_NOT_FOUND;

  if ni <> _NOT_FOUND then
  begin
     if Alg.Obj[ni].TypeF = T_Array then
     begin
       BH:=True;
       MType:=Alg.Obj[ni].MType;         //_Double,_Extended,_Integer
     end
     else
     ni:=_NOT_FOUND;
  end;


FindExtractArray:=BH;
end;




procedure TForevalH.CheckRecoverImUnit;
label endp;
var
ni: integer;
TV: Integer;
begin
F_RecoverImUnit:=False;

 //FindVar(S_IM_UNIT,ni);
 FindVarPS(@S_IM_UNIT,ni);  {.333}
 if ni <> -1 then
 begin
   TV:=Alg.Obj[ni].TypeF;
   if (TV <> T_Complex)  then begin F_RecoverImUnit:=True; goto endp; end;
 end
 else
 F_RecoverImUnit:=True;

endp:
end;



{.361}
function TForevalH.CheckImUnit(PSI: PString; var Sgn: Integer): Boolean;
label endp;              //i, (i), (-i)  ; Sgn = _NO (+i), _YES (-i)
var
ni: integer;
TV: Integer;
SU: String;
Answ: Boolean;
begin

Sgn:=_POSITIVE;
Answ:=False;

//i
if (PSI^ = S_IM_UNIT) and (F_RecoverImUnit = False) then
begin
  FindVarPS(@S_IM_UNIT,ni);
  if ni <> -1 then
  begin
     Answ:=True;
     goto endp;
  end;
end;

//(i), (-i)
if (PSI^[1] = '(') and (PSI^[Length(PSI^)] = ')') then
begin

  if PSI^[2]='-' then    // (-i)
  begin
    Sgn:=_NEGATIVE;
    SU:=Copy(PSI^,3,Length(PSI^)-3);
  end
  else                //(i)
    SU:=Copy(PSI^,2,Length(PSI^)-2);
end;



if (SU = S_IM_UNIT) and  (F_RecoverImUnit = False) then
begin
  FindVarPS(@S_IM_UNIT,ni);
  if ni <> -1 then
  begin
     Answ:=True;
  end;
end;



endp:
CheckImUnit:=Answ;
end;



procedure TForevalH.FindVarP(PS: PString; var ni: Integer);
label endp;
var
i: Cardinal;
S2,S3: String;
begin
ni:=_NOT_FOUND; //=_ABSENT !!!
                                        //ni - номер массива найденной переменной
if F_SyntaxErrorCode <> 0 then goto endp;      //ni = -1: перем. не найдена


//S2:=Copy(S1,1,Length(S1));



for i:=0 to High(Alg.Obj) do
begin
 S3:=Alg.Obj[i].Name;

 if PS^ = S3 then
  begin
   ni:=i;
   if Alg.Obj[i].TypeF = T_Complex then F_ComplexNumber:=True;   //в выражении присутствует комплексное число

   //if ((LowerCase(S3) <> 'pi') and (LowerCase(S3) <> 'i')) then F_PresentVar:=True;

   //if (S3 = 'pi') then  goto endp;
   if (S3 = S_IM_UNIT) and (Alg.Obj[i].TypeF = T_Complex)  then goto endp;

   F_PresentVar:=True;
   Alg.Obj[i].IsUsed:=_YES;

   goto endp;
  end;
end;



endp:
end;


procedure TForevalH.FindVar(S1: String; var ni: Integer);
label endp;
var
i: Cardinal;
S2,S3: String;
begin
ni:=_ABSENT;
                                        //ni - номер массива найденной переменной
if F_SyntaxErrorCode <> 0 then goto endp;      //ni = _ABSENT = -1: перем. не найдена


//S2:=Copy(S1,1,Length(S1));



for i:=0 to High(Alg.Obj) do
begin
S3:=Alg.Obj[i].Name;

 if S1 = S3 then
  begin
   ni:=i;
   if Alg.Obj[i].TypeF = T_Complex then F_ComplexNumber:=True;   //в выражении присутствует комплексное число

   //if ((LowerCase(S3) <> 'pi') and (LowerCase(S3) <> 'i')) then F_PresentVar:=True;

   //if (S3 = 'pi') then  goto endp;
   if (S3 = S_IM_UNIT) and (Alg.Obj[i].TypeF = T_Complex)  then goto endp;

   F_PresentVar:=True;
   Alg.Obj[i].IsUsed:=_YES;

   goto endp;
  end;
end;



endp:
end;



procedure TForevalH.FindVarPS(PS1: PString; var ni: Integer);
label endp;
var
i: Cardinal;
S2,S3: String;
begin
// "i" imaginary unit set as var (no parameters or const)!!!

ni:=_ABSENT;//= -1!!!!
                                               //ni - номер массива найденной переменной
if F_SyntaxErrorCode <> 0 then goto endp;      //ni = -1!!: перем. не найдена




//S2:=Copy(S1,1,Length(S1));



for i:=0 to High(Alg.Obj) do
begin
S3:=Alg.Obj[i].Name;

 if PS1^ = S3 then
  begin
   ni:=i;
   if Alg.Obj[i].TypeF = T_Complex then F_ComplexNumber:=True;   //в выражении присутствует комплексное число

   //if ((LowerCase(S3) <> 'pi') and (LowerCase(S3) <> 'i')) then F_PresentVar:=True;

   //if (S3 = 'pi') then  goto endp;
   if (S3 = S_IM_UNIT) and (Alg.Obj[i].TypeF = T_Complex)  then goto endp;

   F_PresentVar:=True;
   Alg.Obj[i].IsUsed:=_YES;

   goto endp;
  end;
end;



endp:
end;





{.347}
procedure TForevalH.FindVarExPS(PS: PString; var  ni: Integer; var Addr, AddrIM: TAddress; var TypeF, MType, ReIm,ImU: Integer);
var
S2: String;
TF:Integer;
begin



Addr:=0;
AddrIM:=0;
MType:=0;
ReIm:=0;
ImU:=0;

FindReIm(PS^,S2,TF);
FindVarPS(@S2,ni);


if S2 = S_IM_UNIT then ImU:=Im_Unit;
ReIm:=TF;

Addr:=Alg.Obj[ni].Addr;
AddrIM:=Alg.Obj[ni].AddrIM;
TypeF:=Alg.Obj[ni].TypeF;
MType:=Alg.Obj[ni].MType;


end;




procedure TForevalH.FindVarA(S1: String; var ni: Integer; var Adr: TAddress; var TV,TM: Integer);
label endp;
var
nv: Integer;
begin
ni:=_ABSENT;
                                       //ni - номер массива найденной переменной
if F_SyntaxErrorCode <> 0 then goto endp;      //ni = -1: перем. не найдена

Adr:=0; TV:=0; TM:=0;

FindVar(S1,nv);
if nv >= -1 then
begin
 GetVar1(nv,Adr,TV,TM);
 ni:=nv;
end;

endp:
end;



{.333}
procedure TForevalH.FindVarAPS(PS1: PString; var ni: Integer; var Adr: TAddress; var TV,TM: Integer);
label endp;
var
nv: Integer;
begin
ni:=_ABSENT;
                                        //ni - номер массива найденной переменной
if F_SyntaxErrorCode <> 0 then goto endp;      //ni = -1: перем. не найдена

Adr:=0; TV:=0; TM:=0;

FindVarPS(PS1,nv);
if nv >= -1 then
begin
 GetVar1(nv,Adr,TV,TM);
 ni:=nv;
end;

endp:
end;


procedure TForevalH.ExistVar(S1: String; var Addr: TAddress; var IdType,MType: Cardinal);
label endp;
var
i: Cardinal;
S2,S3: String;
begin


S2:=S1;


Addr:=0;
IdType:=0;
MType:=0;

for i:=0 to High(Alg.Obj) do
begin
S3:=Alg.Obj[i].Name;

 if S2 = S3 then
  begin
    Addr:=Alg.Obj[i].Addr;
    IdType:=Alg.Obj[i].TypeF;
    MType:=Alg.Obj[i].MType;
   goto endp;
  end;
end;



endp:
end;


 {.343}
procedure TForevalH.ExistVar2(S1: String; var Addr,AddrIM: TAddress; var IdType,MType,CnctType: Cardinal);
label endp;
var
i: Cardinal;
S2,S3: String;
begin


S2:=S1;


Addr:=0;
IdType:=0;
MType:=0;

for i:=0 to High(Alg.Obj) do
begin
S3:=Alg.Obj[i].Name;

 if S2 = S3 then
  begin
    Addr:=Alg.Obj[i].Addr;
    AddrIM:=Alg.Obj[i].AddrIM;
    IdType:=Alg.Obj[i].TypeF;
    MType:=Alg.Obj[i].MType;
    CnctType:=Alg.Obj[i].TypeCnct;
   goto endp;
  end;
end;



endp:
end;


{.191}
procedure TForevalH.ExistVarEx(S1: String; var Addr: TAddress; var IdType,MType,ReIm,ImU: Cardinal);
label endp;
var
i: Cardinal;
S2,S3: String;
TF: Integer;
begin


S2:=S1;

FindReIm(S2,S2,TF);


Addr:=0;
IdType:=0;
MType:=0;
ReIm:=TF;
ImU:=0;


if S2 = S_IM_UNIT then ImU:=Im_Unit;


for i:=0 to High(Alg.Obj) do
begin
S3:=Alg.Obj[i].Name;

 if S2 = S3 then
  begin
    Addr:=Alg.Obj[i].Addr;
    IdType:=Alg.Obj[i].TypeF;
    MType:=Alg.Obj[i].MType;
   goto endp;
  end;
end;



endp:
end;




procedure TForevalH.FindFuncBrPS(PS: PString; BrS1,BrS2: String; var Sf: String; var Sa: String; var FH: Boolean);
label 1,endp;
var
bb,b2,b1,i: Integer;                                              //FH=True: func(arg)->Sf(Sa)
begin
                                                                   //BrS=(, [, {
FH:=False;
bb:=0; b1:=0;
for i:=1 to Length(PS^) do
begin
 if PS^[i] = {'('}BrS1 then begin b1:=i; goto 1; end;
end;
if b1 = 0 then begin FH:=False; goto endp; end;

1:
(*
b2:=0; bb:=-1;
for i:=b1+1 to Length(S) do
begin
 if S[i] = '(' then bb:=bb-1;
 if S[i] = ')' then bb:=bb+1;
 if (i <> Length(S)) and (bb = 0) then begin {Internal Error} end;
end;
*)
if b1 = 1 then  FH:=False else FH:=True;
if PS^[Length(PS^)] <> BrS2 then   FH:=False;

Sf:=Copy(PS^,1,b1-1);
Sa:=Copy(PS^,b1+1,Length(PS^)-b1-1);

endp:
end;




procedure TForevalH.CopyAIVP(AIVPs: TArrayIntVarProd; var AIVPd:  TArrayIntVarProd) ;
var
 i,L,LN: Integer;
  j: Integer;
begin
  L:=Length(AIVPs);
  SetLength(AIVPd,L);

  for i := 0 to L - 1 do
  begin
   LN:=Length(AIVPs[i].NV);
   SetLength(AIVPd[i].NV,LN);
   AIVPd[i].A:=AIVPs[i].A;
   for j := 0 to LN - 1 do
   begin
     AIVPd[i].NV[j]:=AIVPs[i].NV[j];
   end;
  end;
end;




procedure TForevalH.DelExternalBracketInArgsPS(ArgM: TArrayS; PSa:PString); {.335}
var
 i: Integer;
begin
   if Length(ArgM) = 1 then
   begin
      FindExternalBracketNegPS(PSa);
   end
   else
   if  Length(ArgM) > 1 then
   begin
      PSa^:='';
      for i := 0 to High(ArgM) do
      begin
        FindExternalBracketNegPS(@ArgM[i]);
        PSa^:=PSa^+ArgM[i]+',';
      end;
      Delete(PSa^,Length(PSa^),1);
   end;
end;


procedure TForevalH.FindFunctionPS(PS: PString;  var ND: TDataNode; var LV: PLevel;  var BH,EOFN: Boolean);
label 1,2,3,4,endp,intf;
var
i,k,l,j,bb,pf,pr,b1,b2,nf,ni,ni1,TV: Integer;       //BH - функция найдена да/нет
S1,Sa,Sa1,Sf,Sf1,Sfn,Sv: String;                     //EOFN - (end of node)-достигнут конец узла: выражение нуждается в дальнейшем разборе да/нет
Neg,SB,TM,code,IC,NV: Integer;
FH,FH1,ExtFunc: Boolean;
C: Extended;
AIVP:  TArrayIntVarProd;
begin

BH:=False;
EOFN:=False;


if F_SyntaxErrorCode <> 0 then goto endp;
F_CurrentString:=PS^;
FH:=False;
FH1:=False;
ExtFunc:=False;


//[-[x-1.5]-[-[x+5.7]]]-[t-[t-[t+7.5]-[t+1.8]]+t]

nf:=0;
{.323} //поиск в PrevTreat
(*
//поиск [arg]->Trunc(arg); {arg}->Frac(arg)
if (PS^[1] = '[') and (PS^[Length(PS^)] = ']') and (F_SyntaxExtension = True) then begin nf:=CM_TRUNC; Sa:=Copy(PS^,2,Length(PS^)-2); end
else
if (PS^[1] = '{') and (PS^[Length(PS^)] = '}') and (F_SyntaxExtension = True) then begin nf:=CM_FRAC; Sa:=Copy(PS^,2,Length(PS^)-2); end
else
*)


//поск функции: func(arg)
begin

  //FindFuncBr(S,'(',')',Sf,Sa,FH);
  FindFuncBrPS(PS,'(',')',Sf,Sa,FH); {.314}
  if FH = False then goto 3;

  Sf1:=Sf;

  nf:=-1;

   //FindFuncA(Sf1,nf);
   FindFuncPS(@Sf1,nf); {.313}
end;


2:
 if nf <> -1 then
 begin
    //SFunc:=Alg.ExFunc[nf].Name; {.301}

    //FindManyArg(Sa,ArgM);
    FindManyArgPS(@Sa,ArgM);{.314}
    DelExternalBracketInArgsPS(ArgM,@Sa); {.335}
    ND.ExpressionArg:=Sa; {.193}   //used in compare at replace func optimization
    if Length(ArgM) = 0  then //поиск INFINITE
    begin

     {ф-ия без аргументов}
     {F_SyntaxErrorCode:=4;
     F_SyntaxErrorString:=Copy(Sf,1,Length(Sf));}

     F_SyntaxErrorCode:=0;
     for i := 0 to High(Alg.ExFunc[nf].Func) do
     begin
           if (Alg.ExFunc[nf].Func[i].CallT = _STACK_INFINITE) or (Alg.ExFunc[nf].Func[i].CallT = _INTERNAL_INFINITE_ANY) then
           begin
              ND.N:=0; ND.COP:=_Func; ND.NFunc:=nf;  ND.NF:=i;  BH:=True; EOFN:=True; SetLength(LV,0);
              //ND.SFunc:=SFunc; {.301}
              goto endp;
           end;
     end;

       {остальные ф-ии без аргументов (.203) вместо (1)}
        FindZeroArg(NF,ni);
        if ni <> -1 then
        begin
           //если внутренняя
           if Alg.ExFunc[NF].Func[ni].IntF = _Internal then
           begin
             SetLength(LV,0); ND.N:=0; ND.COP:=_Func; ND.NF:=ni; ND.NFunc:=nf; BH:=True;  EOFN:=True;
              //ND.SFunc:=SFunc; {.301}
             goto intf;
           end
           else
           //если внешняя:
           ND.N:=0; ND.COP:=_Func; ND.NFunc:=nf;  ND.NF:=ni;  BH:=True; EOFN:=True; SetLength(LV,0);
            //ND.SFunc:=SFunc; {.301}
           goto endp;  {.203}
        end
        else
        begin
          F_SyntaxErrorCode:=4;
          F_SyntaxErrorName:=Copy(Sf,1,Length(Sf));
          F_SyntaxErrorString:=Copy(F_CurrentString,1,Length(F_CurrentString));     {.323}

          F_SyntaxErrorString:=F_SyntaxErrorName+#13#10+F_SyntaxErrorString;


          //F_SyntaxErrorString:=Copy(Sf,1,Length(Sf));
          goto endp;
        end;
     {(1):}
     {F_SyntaxErrorCode:=4;
     F_SyntaxErrorString:=Copy(Sf,1,Length(Sf));
     goto endp;}

    end;

    {inc(F_IdN);
    ND.IdN:=F_IdN;}



    //Func(Array)     только внутренние ф-ии. Для внешних: Array заносится в стек
    //SUM,DEV,DEVS,AVR,PROD,  MAX, MIN, SUMQ, GCD, LCM, SUMI     (array)
    if Length(ArgM) = 1 then
    begin
      //FindVar(ArgM[0],ni);
      FindVarPS(@ArgM[0],ni);
      if ni <> -1 then
      begin
       TV:=Alg.Obj[ni].TypeF;
       TM:=Alg.Obj[ni].MType;
       if TV = T_Array then
       begin
         for i := 0 to High(Alg.ExFunc[nf].Func) do
         begin
           if (Alg.ExFunc[nf].Func[i].NArg = 1) and (Alg.ExFunc[nf].Func[i].TV[0] = T_Array) { and (Alg.ExFunc[nf].Func[i].TM[0] = TM)} then
           begin
             if Alg.ExFunc[nf].Func[i].IntF = _Internal then    //internal
             begin
                ND.N:=0; ND.COP:=_Func; ND.NFunc:=nf;  ND.NF:=i; ND.NV1:=ni; BH:=True; EOFN:=True; SetLength(LV,0);
                //ND.AI:=1;
                goto endp;
             end;
           end;
         end;
       end;
      end;
    end;



    SetLength(LV,1);
    LV[0].Expression:=Copy(ArgM[0],1,Length(ArgM[0]));
    {LV[0].NL:=1;
    LV[0].IdL:=F_IdN;}
    for i:= 1 to High(ArgM) do
    begin
     SetLength(LV,Length(LV)+1);
     LV[i].Expression:=Copy(ArgM[i],1,Length(ArgM[i]));
     {LV[i].NL:=i+1;
     LV[i].IdL:=F_IdN;}
    end;

    ND.N:=Length(ArgM);
    ND.COP:=_Func;
    ND.NFunc:=nf;
    BH:=True;
     //ND.SFunc:=SFunc; {.301}

    intf:

      {.301}
      if M_ParseMode = M_ParseDiffExpr then
      begin
         if ND.NFunc = CM_IFin then
         begin
           IFAnalizator(LV,ND,LV,ND);
          { if F_SyntaxErrorCode <> 0 then
              if PS <> nil  then F_SyntaxErrorString:=Copy(PS^,1,Length(PS^));}
           BH:=True;
           EOFN:=False;
         end;
         goto endp;
      end;

    if (ND.NFunc = CM_POWER) and (F_OperationOptimizatorA2 = True) then
    begin
       PowerAnalizator(LV,ND,LV,ND,EOFN);
       BH:=True;
    end
    else
    if (ND.NFunc = CM_ROOT) and (F_OperationOptimizatorA2 = True) then
    begin
       RootAnalizator(LV,ND,LV,ND,EOFN);
       BH:=True;
    end
    else
    if ((ND.NFunc = CM_FACT) or (ND.NFunc = CM_FACT2)) and (F_OperationOptimizatorA1 = True) then
    begin
       FactAnalizator(LV,ND,LV,ND,EOFN);
       BH:=True;
    end
    else
    if ((ND.NFunc =  CM_RE) or (ND.NFunc = CM_IM)) and (F_OperationOptimizatorA1 = True) then
    begin
       ReImAnalizator(LV, ND, LV, ND, EOFN);
       BH:=True;
    end
    else
    if ND.NFunc = CM_IFin then
    begin
     IFAnalizator(LV,ND,LV,ND);
    { if F_SyntaxErrorCode <> 0 then
       if PS^ <> '' then
                 F_SyntaxErrorString:=Copy(PS^,1,Length(PS^)); }
     BH:=True;
     EOFN:=False;
    end
    else
    if ND.NFunc = CM_SAVEin then
    begin
     SaveAnalizator(LV,ND,LV,ND,EOFN);
     BH:=True;
    end
    else
    if ND.NFunc = CM_JMP then
    begin
     GOTOAnalizator(LV,ND,LV,ND);
     BH:=True;
     EOFN:=True;
    end
    else
    if (ND.NFunc = CM_INC) or (ND.NFunc = CM_DEC) then
    begin
     IDAMAnalizator(LV,ND,LV,ND);
     BH:=True;
     EOFN:=True;
    end
    else
    if ND.NFunc = CM_SETLENin then
    begin
     SetLenAnalizator(LV,ND,LV,ND);
     BH:=True;
     EOFN:=False;
    end
    else
    if ND.NFunc = CM_SWAPin then
    begin
     SwapAnalizator(LV,ND,LV,ND,EOFN);
     BH:=True;
     //EOFN:=True;
    end
    else
    if ND.NFunc = CM_SWAPIFin then
    begin
     SwapIfAnalizator(LV,ND,LV,ND,EOFN);
     BH:=True;
     //EOFN:=True;
    end
    else
    if (ND.NFunc = CM_MOD) or (ND.NFunc = CM_IDIV) then
    begin
     MOD_IDIV_Analizator(LV,ND,LV,ND,EOFN);
     BH:=True;
    end
    else
    if ND.NFunc = CM_POLYin then
    begin
     POLYAnalizator(LV,ND,LV,ND,EOFN);
     BH:=True;
    end
    else
    if ND.NFunc = CM_POLYDIFFin then
    begin
     POLYDIFFAnalizator(LV,ND,LV,ND,EOFN);
     BH:=True;
    end
    else
    if ND.NFunc = CM_RANDin then
    begin
     RANDAnalizator(LV,ND,LV,ND,EOFN);
     BH:=True;
     ExtFunc:=True; {.334}     //т.к. rand при разборе переходит во внешние
    end
    else
    if (ND.NFunc = CM_MAX) or (ND.NFunc = CM_MIN)  or (ND.NFunc = CM_NORM) or (ND.NFunc = CM_AVR) then
    begin
      DataFuncAnalizator(LV,ND,LV,ND,EOFN);
      BH:=True;
    end
    else
    if ND.NFunc = CM_SUMPin then        {.333}
    begin
     SUMPAnalizator(LV,ND,LV,ND,EOFN);
     BH:=True;
    end
    else
    if ND.NFunc = CM_SUMPSin then       {.333}
    begin
     SUMPSAnalizator(LV,ND,LV,ND,EOFN);
     BH:=True;
    end
    else
    if ND.NFunc = CM_PRODSin then       {.359}
    begin
     PRODSAnalizator(LV,ND,LV,ND,EOFN);
     BH:=True;
    end
    else
    if (ND.NFunc = CM_CALLR) or (ND.NFunc = CM_CALLCX) or (ND.NFunc = CM_CALL) then       {.347}
    begin
     CALLAnalizator(LV,ND,LV,ND,EOFN);
     BH:=True;
    end
    else
    if (ND.NFunc = CM_ADDR) then
    begin
       AddrAnalizator(LV,ND,LV,ND,EOFN);
       BH:=True;
    end
    else {.309}  //External Function
    begin
      ExtFunc:=True;
    end;
    (*                {.219}
    else
     if ND.NFunc = CM_SAFECALL then
    begin
     SAFECALLAnalizator(LV,ND,LV,ND,EOFN);
     BH:=True;
    end;
     *)







 end
 else  //nf=-1
 //поиск элементов векторов: AI = (1)Vec[IntConst],(2)Vec[IntVar],(3)Vec[IntForm], (0)Vec[Trunc(Expr)]
 begin
  3:

  FindFuncBrPS(PS,'[',']',Sv,Sa,FH1);
  if FH1 = True then {FindVar(Sv,ni)}FindVarPS(@Sv,ni) else ni:=-1; {.333}

  if ni <> -1 then //ni - vector
  begin
    if Alg.Obj[ni].TypeF = T_Array then
    begin


       {.301}
       if M_ParseMode = M_ParseDiffExpr then
       begin
          //условно:
          ND.NFunc:=CM_LDSVX;
          ND.NObj:=ni;
          ND.COP:=_Func;

          ND.SDiff:='0';
          EOFN:=True;
          goto endp;
       end;

        {F_IntegerOptimization}
       //---------------------------------------------------------

       ND.NFunc:=CM_LDSVX;
       ND.NObj:=ni;
       ND.COP:=_Func;
       BH:=True;

       ND.ExpressionArg:=Sa; {.357}   //used in compare at replace func optimization
       ND.Expression:=PS^; {.357}   //used in compare at replace func optimization



       FindExtArgIntPS(@Sa, code, AIVP, NV, IC);
       if code <> _NOT_FOUND then
       begin
          if code = _IntConst then
          begin
            ND.FD:=IC;
            ND.AI:=1;
          end
          else
          if code = _IntVar then
          begin
            ND.NV1:=NV;
            ND.AI:=2;
          end
          else
          begin
            ND.AIVP1:=Copy(AIVP,0,Length(AIVP));
            //CopyAIVP(AIVP,ND.AIVP1);
            ND.AI:=3;
            ND.FD:=IC;
          end;
          EOFN:=True;
          SetLength(LV,0);
          ND.N:=0;
       end
       else
       begin   //Vec[VecInt[indx]],  Vec[expr]
          ND.AI:=0;
          FH1:=False;

          //Vec[VecInt[indx]]        {.357}
          if F_IntegerOptimization = True then
          FindFuncBrPS(@Sa,'[',']',Sv,Sa1,FH1);
          if FH1 = True then FindVarPS(@Sv,ni1) else ni1:=-1;
          //VecInt[Sa1]
          if ni1 <> -1 then //ni1 - vector
             if Alg.Obj[ni1].TypeF = T_Array then
                if Alg.Obj[ni1].MType = _Integer then
                begin
                    ND.NObj2:=ni1;
                    FindExtArgIntPS(@Sa1, code, AIVP, NV, IC);
                    if code <> _NOT_FOUND then
                    begin
                       if code = _IntConst then
                       begin
                         ND.FD:=IC;
                         ND.DI:=1;
                       end
                       else
                       if code = _IntVar then
                       begin
                        ND.NV2:=NV;
                        ND.DI:=2;
                       end
                       else
                       begin
                        ND.AIVP1:=Copy(AIVP,0,Length(AIVP));
                       //CopyAIVP(AIVP,ND.AIVP1);
                        ND.DI:=3;
                        ND.FD:=IC;
                       end;
                       EOFN:=True;
                       SetLength(LV,0);
                       ND.N:=0;
                    end
                    else
                    begin
                      ND.DI:=0;
                      SetLength(LV,1);
                      LV[0].Expression:=Copy(Sa1,1,Length(Sa1));
                      ND.N:=1;
                      EOFN:=False;
                    end;

                   ND.AI:=4;     //Vec[VecInt[indx]]
                   //goto endp;
                end;


          if ND.AI = 0 then
          begin
             //Vec[expr]
            ND.AI:=0;
            SetLength(LV,1);
            LV[0].Expression:=Copy(Sa,1,Length(Sa));
            ND.N:=1;
            EOFN:=False;
          end;
       end;

       {.353}
       //загрузка элемента массива указателей через команду _LDSA    //vecptr[indx]->eax
       if Alg.Obj[ni].MType = _Pointer then
       begin
           ND.NObj:=ni;
           ND.NFunc:=0;
           ND.COP:=_LDSA;
           ND.TypeF:=T_Pointer;
           ND.CI:=ND.AI;
           ND.AI:=_PointerArray;
       end;



        //---------------------------------------------------------


      (*
      {inc(F_IdN);
      ND.IdN:=F_IdN;}
      ND.NObj:=ni;
      ND.COP:=_Func;
      ND.NFunc:=CM_LDSVX;
      ND.SDiff:='0'; {.301}
      BH:=True;
      if M_ParseMode = M_Diff then goto endp; {.301}

      FindVar(Sa,ni);

      if ni <> -1 then    //ni - vector's arg: Vec[var]
      begin
        if Alg.Obj[ni].TypeF = T_Real then
        begin
         ND.NV1:=ni;
         ND.AI:=2;
         EOFN:=True;
         SetLength(LV,0);
         ND.N:=0;
        end
        else
        begin    //type of arg <> real
          F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
          F_SyntaxErrorString:=Copy(F_CurrentString,1,Length(F_CurrentString));
          F_SyntaxErrorStringA:=Copy(Sa,1,Length(Sa));
          //F_SyntaxErrorString1:=Copy(Sa,1,Length(Sa));
          goto endp;
        end;
      end
      else
      begin
        SubstParam(Sa,C,SB);
        if SB = 1 then    //Vec[num]  must be trunc(num)=num!!!
         begin
          if Trunc(C) = C then
          begin
           ND.FD:=C;
           ND.AI:=1;
           ND.N:=0;
           EOFN:=True;
           SetLength(LV,0);
           goto endp;
          end
          else
          begin      //vec[num]: 'num' must be integer
            F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
            F_SyntaxErrorString:=Copy(F_CurrentString,1,Length(F_CurrentString));
            F_SyntaxErrorStringA:=Copy(Sa,1,Length(Sa));
            //F_SyntaxErrorString1:=Copy(Sa,1,Length(Sa));
          goto endp;
          end;
         end
         else
         begin   //Vec[expr]
           ND.AI:=0;
           SetLength(LV,1);
           LV[0].Expression:=Copy(Sa,1,Length(Sa));
           ND.N:=1;
           {LV[0].NL:=1;
           LV[0].IdL:=F_IdN;}
           EOFN:=False;
         end;
      end
      *)

         //---------------------------------------------------------

    end
    else   //Vec <> T_Array
    begin

      F_SyntaxErrorCode:=E_UNKNOWN_ARRAY; {.323}
      F_SyntaxErrorString:=Copy(F_CurrentString,1,Length(F_CurrentString));     {.323}
      F_SyntaxErrorName:=Copy(Sv,1,Length(Sv));
       //F_SyntaxErrorCode:=6; //UknownFunction
      //F_SyntaxErrorString:=Copy(Sv,1,Length(Sv));
      goto endp;
    end;
  end
  else
  begin  //-2-(-8)
     if (FH = True)  and (CheckName(Sf) = true) then
     begin
       F_SyntaxErrorCode:=E_UNKNOWN_FUNCTION;
       F_SyntaxErrorString:=Copy(F_CurrentString,1,Length(F_CurrentString));     {.323}
       F_SyntaxErrorName:=Copy(Sf,1,Length(Sf));

       F_SyntaxErrorString:='"  '+ F_SyntaxErrorName+'  "'+'  in expression:  '+#13#10+F_SyntaxErrorString;
       //F_SyntaxErrorString:=Copy(Sf,1,Length(Sf));
       goto endp;
     end
     else
     if (FH1 = True) and (CheckName(Sv) = true) then        {.323}
     begin
       F_SyntaxErrorCode:=E_UNKNOWN_ARRAY;
       F_SyntaxErrorString:=Copy(F_CurrentString,1,Length(F_CurrentString));     {.323}
       F_SyntaxErrorName:=Copy(Sv,1,Length(Sv));

        F_SyntaxErrorString:='"  '+ F_SyntaxErrorName+'  "'+'  in expression:  '+#13#10+F_SyntaxErrorString;
       //F_SyntaxErrorString:=Copy(Sv,1,Length(Sv));
       goto endp;
     end
  end;


 end;



endp:
if BH = True then
begin
 {inc(F_IdN);
 ND.IdN:=F_IdN;}
 if {Length(LV) > 0} EOFN = False then
 begin
   for i := 0 to High(LV) do
   begin
     //LV[i].IdL:=F_IdN;
     LV[i].NL:=i+1;
     //if ExtFunc = True then LV[i].ExtFunc:=nf else LV[i].Extfunc:=_NOT_FOUND; {.309}
     if ExtFunc = True then  LV[i].ExtFunc:=ND.NFunc else LV[i].Extfunc:=_NOT_FOUND; {.334}
   end;
 end;
end;
end;





procedure TForevalH.FindManyArg(S: String; var ArgM: TArrayS);
label endp;
var
i,N: Cardinal;
PP: array of Cardinal;
bb: Integer;
begin
if Length(S) = 0 then begin SetLength(ArgM,0); goto endp; end;

bb:=0;
N:=1; SetLength(PP,N+1); PP[1]:=0;

for i:=1 to Length(S) do
begin
 if S[i] = '(' then bb:=bb-1;
 if (bb = 0) and (S[i] = ',') then
 begin
 inc(N);
 SetLength(PP,N+1);
 PP[N]:=i;
 end;
 if S[i] = ')' then bb:=bb+1;
end;

inc(N);  SetLength(PP,N+1); PP[N]:=Length(S)+1;

SetLength(ArgM,{N}N-1);

for i:=1 to N-1 do
begin
ArgM[{i}i-1]:=Copy(S,PP[i]+1,PP[i+1]-PP[i]-1);
if (ArgM[{i}i-1] = '')  then
begin
F_SyntaxErrorCode:=4; F_SyntaxErrorString:=Copy(S,1,Length(S)); goto endp;
end;
end;

endp:
end;




procedure TForevalH.FindManyArgPS(PS: PString; var ArgM: TArrayS);
label endp;
var
i,N: Cardinal;
PP: array of Cardinal;
bb: Integer;
begin
if Length(PS^) = 0 then begin SetLength(ArgM,0); goto endp; end;

bb:=0;
N:=1; SetLength(PP,N+1); PP[1]:=0;

for i:=1 to Length(PS^) do
begin
 if PS^[i] = '(' then bb:=bb-1;
 if (bb = 0) and (PS^[i] = ',') then
 begin
 inc(N);
 SetLength(PP,N+1);
 PP[N]:=i;
 end;
 if PS^[i] = ')' then bb:=bb+1;
end;

inc(N);  SetLength(PP,N+1); PP[N]:=Length(PS^)+1;

SetLength(ArgM,{N}N-1);

for i:=1 to N-1 do
begin
  ArgM[{i}i-1]:=Copy(PS^,PP[i]+1,PP[i+1]-PP[i]-1);
  if (ArgM[{i}i-1] = '')  then
  begin
    F_SyntaxErrorCode:=4;
    F_SyntaxErrorString:=F_CurrentString;
    //F_SyntaxErrorString:=Copy(PS^,1,Length(PS^));
    goto endp;
  end;
end;

endp:
end;





(*
procedure   TForevalH.ReplaceTruncBr(S: String; var S1: String);
label 1,endp;
var
 i,L,p,t: Integer;
begin
L:=Length(S); p:=1;
//[[x-1]+[x+1]]-[x-[x+[x-1]-[x+1]]+y]
//[-[x-1.5]-[-[x+5.7]]]-[t-[t-[t+7.5]-[t+1.8]]+t]
while p < L do
begin
  for i:=p to L do
  begin
   if S[i] = '[' then
   begin
     p:=i; t:=1; goto 1;
   end
   else
   if S[i] = ']' then
   begin
     p:=i; t:=2; goto 1;
   end;
  end;
  goto endp;
1:

  if t = 1 then
  begin
   Delete(S,p,1); Insert('trunc(',S,p); p:=p+5
  end
  else
  if t = 2 then
  begin
    Delete(S,p,1); Insert(')',S,p);
  end;

  L:=Length(S);
end;

endp:
S1:=Copy(S,1,Length(S));
end;
*)


procedure   TForevalH.ReplaceTruncBr(S: String; var S1: String);    {.323}
label 1,endp;

           procedure FindCloseTruncBr(St: String; p: integer; var p1: integer);
           label outp;
           var
            i,L,br: integer;
           begin
              L:=Length(St); br:=1;   p1:=0;

              for i := p to L  do
              begin
                if St[i] = '[' then inc(br)
                 else
                 if St[i] = ']' then dec(br);

                 if br = 0 then
                 begin
                   p1:=i; goto outp;
                 end;
              end;

             outp:
           end;


var
 i,L,p,t,tb,nbr1,nbr2,ep: Integer;
 CF,Exch: Boolean;
begin
L:=Length(S); p:=1; t:=0;  CF:=True; nbr1:=0;  nbr2:=0;  Exch:=False;
//[[x-1]+[x+1]]-[x-[x+[x-1]-[x+1]]+y]
//[[x-1]+[x+1]]-[x-[x+[x-1]-[x+1]+ad[n]]+y]
{while p < L do
begin
  for i:=p to L do
  begin
   if S[i] = '[' then
   begin
     p:=i; t:=1; goto 1;
   end
   else
   if S[i] = ']' then
   begin
     p:=i; t:=2; goto 1;
   end;
  end;
  goto endp;
1:

  if t = 1 then
  begin
   Delete(S,p,1); Insert('trunc(',S,p); p:=p+5
  end
  else
  if t = 2 then
  begin
    Delete(S,p,1); Insert(')',S,p);
  end;

  L:=Length(S);
end; }

while p < L do
begin
  tb:=1;

  for i:=p to L do
  begin
   if (i > 1) and ((S[i-1] = '[') or (S[i-1] = '{') or (S[i-1] = '(') or
                   (S[i-1] = '*') or (S[i-1] = '+') or (S[i-1] = '/') or
                   (S[i-1] = '-') or (S[i-1] = '^') or (S[i-1] = ',') or
                   (S[i-1] = '=') or (S[i-1] = '>') or (S[i-1] = '<') {or(S[i-1] = '&')} )
                   then CF:=True
                   else
                   if (i > 1) then CF:=False;


   if (S[i] = '[') and (CF = True) then
   begin
     p:=i; t:=1; goto 1;
   end;

  (*
   if S[i] = '[' then tb:=tb+1;
   if S[i] = ']' then tb:=tb-1;


   if (S[i] = ']') and (tb = 0) {and (Exch = True)} then
   begin
      p:=i; t:=2; goto 1;
   end;
  *)
  end;
  goto endp;
1:

  if t = 1 then
  begin
   Delete(S,p,1); Insert('trunc(',S,p); p:=p+5; inc(nbr1);  //Exch:=True;
   FindCloseTruncBr(S,p,ep);
   if ep <> 0 then
   begin
     Delete(S,ep,1); Insert(')',S,ep); inc(nbr2);
   end;
  end;
  (*
  else
  if t = 2 then
  begin
    Delete(S,p,1); Insert(')',S,p); inc(nbr2);   //Exch:=False;
  end;
  *)

  L:=Length(S);
end;

endp:

//[x+[x+1]+y
//[[x-1]+[x+1]]-[x-[x+[x-1]-[x+1]+ad[n]]+y]
//ad[[ad[n+1]-6]]


//ad[[ad[n+1]-6]+ad[[ad[n+1]-6]]]
//ad[[[ad[n+1]-6]]+[ad[[ad[n+1]-6]]]]
//ad[[[ad[n+1]-6]+ad[[ad[n+1]-6]]]]


if (nbr1  <>  nbr2) then
begin
   F_SyntaxErrorCode:=E_MISSING_SQUARE_BRACKET;
   //F_SyntaxErrorString:=S;
end;
S1:=Copy(S,1,Length(S));
end;






 (*
procedure   TForevalH.ReplaceFracBr(S: String; var S1: String);
label 1,endp;
var
 i,L,p,t: Integer;
begin
L:=Length(S); p:=1;
//[[x-1]+[x+1]]-[x-[x+[x-1]-[x+1]]+y]
while p < L do
begin
  for i:=p to L do
  begin
   if S[i] = '{' then
   begin
     p:=i; t:=1; goto 1;
   end
   else
   if S[i] = '}' then
   begin
     p:=i; t:=2; goto 1;
   end;
  end;
  goto endp;
1:

  if t = 1 then
  begin
   Delete(S,p,1); Insert('frac(',S,p); p:=p+5
  end
  else
  if t = 2 then
  begin
    Delete(S,p,1); Insert(')',S,p);
  end;

  L:=Length(S);
end;

endp:
S1:=Copy(S,1,Length(S));
end;
*)


procedure   TForevalH.ReplaceFracBr(S: String; var S1: String);    {.323}
label 1,endp;
var
 i,L,p,t,tb,nbr1,nbr2: Integer;
 CF: Boolean;
begin
L:=Length(S); p:=1; t:=0;  CF:=True;   nbr1:=0; nbr2:=0;
//{{x-1}+{x+1}}-{x-{x+{x-1}-{x+1}}+y}
(*
while p < L do
begin
  for i:=p to L do
  begin
   if S[i] = '{' then
   begin
     p:=i; t:=1; goto 1;
   end
   else
   if S[i] = '}' then
   begin
     p:=i; t:=2; goto 1;
   end;
  end;
  goto endp;
1:

  if t = 1 then
  begin
   Delete(S,p,1); Insert('frac(',S,p); p:=p+4
  end
  else
  if t = 2 then
  begin
    Delete(S,p,1); Insert(')',S,p);
  end;

  L:=Length(S);
end;
*)

p:=pos('{',S);
if p = 0  then p:=pos('}',S);


while p <> 0 do
begin

  p:=pos('{',S);
  if p <> 0 then
  begin
   Delete(S,p,1); Insert('frac(',S,p);  inc(nbr1);
  end
  else
  begin
   p:=pos('}',S);
   if p <> 0 then
   begin
    Delete(S,p,1); Insert(')',S,p); inc(nbr2);
   end;
  end;

end;

endp:
if (nbr1  <>  nbr2) then
begin
   F_SyntaxErrorCode:=E_MISSING_CURLY_BRACKET;
   //F_SyntaxErrorString:=S;
end;
S1:=Copy(S,1,Length(S));
end;



procedure   TForevalH.ReplaceAbsBr(S: String; var S1: String);
label 1,endp;

             function GetTypeAbsBr(p: Integer; S: String): Integer;
             begin
              if p = 1 then GetTypeAbsBr:=1
              else
              if p = Length(S) then GetTypeAbsBr:=2
              else
              if (S[p-1] = '+') or (S[p-1] = '-') or (S[p-1] = '*') or
                 (S[p-1] = '/') or (S[p-1] = '^') or (S[p-1] = '(') or
                 (S[p-1] = '[') or (S[p-1] = '{') or (S[p-1] = '=') or      {.353}
                 (S[p-1] = '<') or (S[p-1] = '>') or (S[p-1] = ',') or  (S[p-1] = '$')
                 then GetTypeAbsBr:=1
              else
               GetTypeAbsBr:=2;
             end;


var
 i,L,p,t,nbr: Integer;
begin
L:=Length(S); p:=1; nbr:=0;
//||x-1|+|x+1||-|x-|x+|x-1|-|x+1||+y|
//||x-1|+||x+1|-|x+2|||-||x-1|+||x+1|^||x+2|-x|+|x+1||+|x+1||
while p < L do
begin
  for i:=p to L do
  begin
   if S[i] = '|' then
   begin
     inc(nbr); p:=i; goto 1;
   end;
  end;
  goto endp;
1:
  t:=GetTypeAbsBr(p,S);
  if t = 1 then
  begin
   Delete(S,p,1); Insert('abs(',S,p); p:=p+3
  end
  else
  if t = 2 then
  begin
    Delete(S,p,1); Insert(')',S,p);
  end;

  L:=Length(S);
end;

endp:
S1:=Copy(S,1,Length(S));

if (nbr mod 2 <>  0) then
begin
   F_SyntaxErrorCode:=E_MISSING_ABS_BRACKET;
end;

end;



function TForevalH.ReplaceAbsBrP(PS: PString): Boolean;
var
 BAns: Boolean;
begin

 BAns:=False;
 if pos('|',PS^) <> 0 then
 begin
  ReplaceAbsBr(PS^,PS^);
  BAns:=True;
 end;

 ReplaceAbsBrP:=BAns;
end;


procedure TForevalH.FindFact2Symb(S1: String; var S2: String);
label 1,2,endp;
var
Sa: String;
pb,bb,b,i,pb1,p,sb: TIntegType;
begin
//замена функции fact в виде A!!,(A)!! на fact2(A)

2:
p:=pos('!!',S1);
if p = 0  then goto endp;

b:=0; pb:=0;  sb:=0;
for i:=p downto 1 do
begin
 if (b = 0) and (S1[i] = '(') then begin pb:=i+1; goto 1; end else

 if S1[i] = ')' then b:=b-1 else
 if S1[i] = '(' then b:=b+1 else
 if S1[i] = ']' then sb:=sb-1 else
 if S1[i] = '[' then sb:=sb+1;


 if (b = 0) and  (sb = 0) and  ((S1[i] = '*') or (S1[i] = '/') or (S1[i] = '+') or
    (S1[i] = '-') or (S1[i] = '^') or (S1[i] = ',') {or (S1[i] = '&')})   then  begin pb:=i+1; goto 1; end
    else
    if (S1[i] = '[') and (sb = 1) then   begin pb:=i+1; goto 1; end
end;


1:
if pb = 0 then pb:=1;
delete(S1,p,2);
insert(')',S1,p);
insert('fact2(',s1,pb);
goto 2;

//((n+1)!!-n!!*(n+2)!!)
//((n)!!+sin(x)!!+(cos(x!!)!!))
//vd[x]+[vd[x]!!]+[vd[x!!+1]!!]+[vd[x!!]!!]!!+x
endp:
S2:=Copy(S1,1,Length(S1));
end;




procedure TForevalH.FindFactSymb(S1: String; var S2: String);
label 1,2,endp;
var
Sa: String;
pb,bb,b,i,pb1,p,sb: TIntegType;
begin
//замена функции fact в виде A!,(A)! на fact(A)
//vd[x]+[vd[x]!]+[vd[x!+1]!]+[vd[x!]!]!+x
2:
p:=pos('!',S1);
if p = 0  then goto endp;

b:=0; pb:=0; sb:=0;
for i:=p downto 1 do
begin
 if (b = 0) and (S1[i] = '(') then begin pb:=i+1; goto 1; end else

 if S1[i] = ')' then b:=b-1 else
 if S1[i] = '(' then b:=b+1 else
 if S1[i] = ']' then sb:=sb-1 else
 if S1[i] = '[' then sb:=sb+1;


 if (b = 0) and  (sb = 0) and ((S1[i] = '*') or (S1[i] = '/') or (S1[i] = '+') or
    (S1[i] = '-') or (S1[i] = '^') or (S1[i] = ',') {or (S1[i] = '&')} {or ((S1[i] = '[') and (sb = 1))} )   then  begin pb:=i+1; goto 1; end
    else
    if (S1[i] = '[') and (sb = 1) then   begin pb:=i+1; goto 1; end

end;

//[vd[x!]!]!
1:
if pb = 0 then pb:=1;
delete(S1,p,1);
insert(')',S1,p);
insert('fact(',s1,pb);
goto 2;


endp:
S2:=Copy(S1,1,Length(S1));
end;






procedure TForevalH.insIf(S: String; P,N: Integer; var S1: String);
label endp;
var
i,br: integer;
begin
br:=0;
for I := P downto 1 do
begin
   if (S[i] = '(') or (S[i] = '[') or (S[i] = '{') then  br:=br+1 else
   if (S[i] = ')') or (S[i] = ']') or (S[i] = '}') then  br:=br-1;

   if br = 0 then
   begin
    if (S[i-1] <> 'f') and (S[i-2]<> 'i')then
    begin
      insert('if',S,i);
      Delete(S,P+3,N);
      if N=3 then Insert('*if',S,P+3) else
       if N=2 then Insert('+if',S,P+3);
    end
    else
    begin
     Delete(S,P+1,N);
     if N=3 then Insert('*if',S,P+1) else
      if N=2 then Insert('+if',S,P+1);
    end;
    S1:=S;
    goto endp;
   end;

end;

endp:
end;


procedure TForevalH.replaceAndOr(S: String;  var S1: String);
label 1, endp;
var
PA,PO: Integer;
begin

1:
PA:=pos(')and(',S);  PO:=pos(')or(',S);

if (PA <> 0) or (PO <> 0) then
begin

 if (PA <> 0) and (PO <> 0) then
  begin
    if PA < PO then  InsIf(S,PA,3,S)
    else InsIf(S,PO,2,S);
  end
 else
 if (PA <> 0) then
 begin
   InsIf(S,PA,3,S);
 end
 else
 if PO <> 0 then
 begin
   InsIf(S,PO,2,S);
 end;

 goto 1;
end;

S1:=S;
end;






procedure TForevalH.ReplaceAndOrSKIP(S: String;  var S1: String);
{
конвертация boolean элементов входной строки в 'игнорирующие' IF команды
(arg1)and(arg2)         -> if(arg1,if(arg2))
(arg1)and(arg2)and(arg) ->  if(arg1,if(arg2,if(arg3)))
...
(arg1)or(arg2)          -> if(arg1,1,if(arg2))
(arg1)or(arg2)or(arg)   ->  if(arg1,1,if(arg2,1,if(arg3)))
...
}
        procedure _ReplAndOrSKIP(S1,SC: String; var S2: String);
        label endp,nxtlev,rpl,nxtarg;
        var
         i: integer;
         PA,P,P1,C1,C2,C3: integer;
         S,Sins,FS:String;
         br,Cr,indx,LS: integer;
         SLst: array of  String;
         PLst: array of Integer;
        begin
        S:=S1;

        nxtlev:
        LS:=Length(SC);
        FS:=')'+SC+'(';
        P:=pos(FS,S);
        if P = 0 then goto endp;

        SetLength(PLst,0); SetLength(SLst,0);

           br:=0;
           //поиск первого аргумента на уровне    ()op1()op1()op2()op2()op1()
           for i := P downto 1 do
           begin
             if (S[i] = '(') or (S[i] = '[') or (S[i] = '{') then  br:=br+1 else
             if (S[i] = ')') or (S[i] = ']') or (S[i] = '}') then  br:=br-1;

             if br = 0 then
             begin
              if (i > 2)  and (S[i-1] ='f') and (S[i-2] = 'i') then
              begin
                 P1:=i-2;
              end
              else
                P1:=i;

              SetLength(PLst,Length(PLst)+1);
              PLst[High(PLst)]:=P1;
              goto nxtarg;

             end;
           end;

        nxtarg:
           //поиск остальных элементов на одном уровне
           br:=1;  i:=P;
           while i <= Length(S) do
           begin

             if (S[i] = '(') or (S[i] = '[') or (S[i] = '{') then  br:=br+1 else
             if (S[i] = ')') or (S[i] = ']') or (S[i] = '}') then  br:=br-1;

              if br = 0 then
              begin

                if i = Length(S) then
                begin
                   SetLength(PLst,Length(PLst)+1);
                   PLst[High(PLst)]:=i;
                   goto rpl;
                end
                else
                if  (i < Length(S)) and ((S[i+1] = ')') or (S[i+1] = ',') or (S[i+1] = ';')) then
                begin
                   SetLength(PLst,Length(PLst)+1);
                   PLst[High(PLst)]:=i;
                   goto rpl;
                end
                else
                if (i < Length(S)-LS) and (Copy(S,i+1,LS) = SC)  and  (S[i+LS+1] = '(') then      //if next op also SC
                begin
                  SetLength(PLst,Length(PLst)+1);
                  PLst[High(PLst)]:=i;
                  i:=i+LS;
                end
                else
                if S[i] = ')' then
                begin
                   SetLength(PLst,Length(PLst)+1);
                   PLst[High(PLst)]:=i;
                   goto rpl;
                end

              end;

             inc(i);
           end;


        rpl:
        if Length(PLst) > 0 then
        begin

          SetLength(SLst,Length(PLst)-1);

          SLst[0]:=Copy(S,PLst[0],PLst[1]-PLst[0]+1);
          for i := 1 to High(SLst)-1 do
          begin
           SLst[i]:=Copy(S,PLst[i]+LS+1,PLst[i+1]-PLst[i]-LS);
          end;

          C1:=PLst[High(PLst)] ;C2:=PLst[High(PLst)-1];  C3:= PLst[High(PLst)-1]+LS+1;
          SLst[High(SLst)]:=Copy(S,C3,C1-C3+1);

          Cr:=High(SLst);
          Sins:='if('+SLst[High(SLst)]+')';

          if SC = 'and' then
          begin
            for i := 0 to High(SLst)-1 do
            begin
             dec(Cr) ;
             Sins:='if('+SLst[Cr]+','+Sins+')';
            end;
          end
          else
          if SC = 'or' then
            begin
            for i := 0 to High(SLst)-1 do
            begin
             dec(Cr) ;
             Sins:='if('+SLst[Cr]+',1,'+Sins+')';
            end;
          end;



          Delete(S,PLst[0],PLst[High(PLst)]-PLst[0]+1);
          Sins:='('+Sins+')';
          Insert(Sins,S,Plst[0]);
        end;


        goto nxtlev;

        endp:
        S2:=S;
        end;

begin
  _ReplAndOrSKIP(S,'and',S1);  //приоритет 'and' выше 'or'
  _ReplAndOrSKIP(S1,'or',S1);
end;





procedure TForevalH.ReplaceFuncIntPart(S,SF: String; var S1: String);
label 1,2,3,endp;
var
i,p,k,N,P1,br,m,f,L,LS: Integer;
SP,SL: String;
begin

P:=1;
L:=Length(SF);
1:
//SL:=LowerCase(S);
SL:=S;
P1:=posEx(SF,SL,P);
if P1 = 0 then goto endp;
P:=P1;
LS:=Length(S);

2:
k:=0;   F:=0;
 for I := p+L to Length(S) do
   begin
     if S[i] = '(' then
     begin

       SP:=Copy(S,p+L,k);
       //if SP <> '' then

       {.195}
         if TryStrToInt(SP,N) = true then
         begin
            N:=StrToInt(SP);

            br:=0; m:=i;

           repeat

             if S[m] = '(' then br:=br+1
              else
             if S[m] = ')' then br:=br-1;

             if (br = 1) and (S[m] = ',') then begin   P:=P+L; goto 3;   end;

             inc(m);
             if (m > LS) and (br <> 0)  then begin  F:=2; goto 3; end;

           until br = 0;

           Insert(','+SP,S,m-1);
           Delete(S,P+L,K);

           3:
         end
         else
         F:=1;

         {
         try
           N:=StrToInt(SP);


           br:=0; m:=i;

           repeat

             if S[m] = '(' then br:=br+1
              else
             if S[m] = ')' then br:=br-1;

             if (br = 1) and (S[m] = ',') then begin   P:=P+L; goto 3;   end;

             inc(m);
             if (m > LS) and (br <> 0)  then begin  F:=2; goto 3; end;

           until br = 0;

           Insert(','+SP,S,m-1);
           Delete(S,P+L,K);

          3:
         except
           F:=1;
         end;
         }

         if F=2 then goto endp;

         P:=P+L; goto 1;
     end;
     inc(k);
   end;


endp:
S1:=S;
end;



procedure TForevalH.ReplaceIff(S1: String; var S2: String);
label 1;
var
p,cp: integer;
SL: String;
begin
cp:=1;
1:
//SL:=LowerCase(S1);
SL:=S1;
p:=posEx('iff(',SL,cp);
if p <> 0 then
begin
 Delete(S1,p+1,1); cp:=cp+2;
 goto 1;
end;

S2:=S1;
end;


function TForevalH.CheckImUnitAfterBr(const S: String; i: Integer): Boolean;
var
 EnOp: set of  Char;
 Si: String;
 Li: Cardinal;
 St1: String;
begin
EnOp:=[')','}',']','|','*','/','>','<','+','^','-',',',';'];
  Li:=Length(S_IM_UNIT);

  St1:=S[i];

  if Length(S) > i+Li then
  begin
    {
    Si:=S[i+Li+1];//Copy(S,i,Li);
    if S[i+Li+1] in EnOp then  CheckImUnitAfterBr:=True else CheckImUnitAfterBr:=False;
    }
    {.355}
    Si:=Copy(S,i+1,Li);
    if Si =  S_IM_UNIT then CheckImUnitAfterBr:=True else
       if S[i+1] in EnOp then   CheckImUnitAfterBr:=True  else CheckImUnitAfterBr:=False;

  end
  else
  if Length(S) = i+Li then
  begin
    Si:=Copy(S,i+1,Li);
    if Si =  S_IM_UNIT then CheckImUnitAfterBr:=True else CheckImUnitAfterBr:=False;
  end
  else
  CheckImUnitAfterBr:=False;
end;




procedure TForevalH.PrevTreat(S: String; var S1: String);
(*  предварительная синтаксическая обработка выражения: замена

  |expr|->abs(expr);    Выполняется предварительно также в Foreval_Lib !!!
  [expr]->trunc(expr)  ;
  {expr}->frac(expr);
   expr!!->fact2(expr); expr!->fact(expr);         //замена при разборе, т.к. операторы
   (exp1) and (expr2)-> if(expr1)*if(expr2)
   (exp1) or  (expr2)-> if(expr1)+if(expr2)
   expr1^expr2 -> power(expr1,expr2)
   root2(expr), root3(expr),...,rootN(expr)-> root(expr,N)  N -  integer number
   power2(expr), power3(expr),...,powerN(expr)-> power(expr,N)  N -  integer number
   pow2(expr), pow3(expr),...,powN(expr)-> power(expr,N)  N -  integer number

   поиск ошибки незакрытых скобок
*)

 label endp;
 const
  OpSet: set of char = ['*','/','+','-','^'];
 var
  b1,b2,i,ba,bs,bc,br,LC,p1,p2: Integer;
  E: Exception;

begin


if S = '' then S:='0';

{.341}
//if F_SyntaxExtension = True then
begin      //порядок не менять  (sequnce not to change)

 if F_PipeBracketToAbs = True then
 begin
   if pos('|',S) <> 0 then ReplaceAbsBr(S,S);
   if F_SyntaxErrorCode <> 0 then goto endp;
 end;

 if F_SquareBracketToTrunc = True then
 begin
    if (pos('[',S) <> 0) or (pos(']',S) <> 0)  then ReplaceTruncBr(S,S);
    if F_SyntaxErrorCode <> 0 then goto endp;
 end;

 if F_CurlyBracketToFrac = True then
 begin
    if (pos('{',S) <> 0) or (pos('}',S) <> 0)  then ReplaceFracBr(S,S);
    if F_SyntaxErrorCode <> 0 then goto endp;    {.323}
 end;


 //FindFact2Symb(S,S);
 //FindFactSymb(S,S);

  if F_SkippedIF = True then      {.221}
    ReplaceAndOrSKIP(S,S)    //skipped if
  else
    ReplaceAndOr(S,S);       //complete if

  if F_ReplaceFuncInPart = True then
  begin
    ReplaceFuncIntPart(S,'root',S);
    ReplaceFuncIntPart(S,'power',S);
    ReplaceFuncIntPart(S,'pow',S); {.191}
  end;

end;
 //ReplaceIff(S,S);


if F_PreliminarySyntaxError = True then
begin
   F_SyntaxErrorCode:=0;
   b1:=0; b2:=0; ba:=0;  bs:=0; bc:=0;  br:=0;

   for i:=1 to Length(S)-1 do
   begin
     if (S[i] = ')') and ((S[i+1] <> '*') and  (S[i+1] <> '+') and
        (S[i+1] <> '-') and (S[i+1] <> '/') and (S[i+1] <> '^') and
        (S[i+1] <> '!') and (S[i+1] <> ')') and (S[i+1] <> ',') and
        {(S[i+1] <> '_') and} (S[i+1] <> '}')  and   (S[i+1] <> '.') and
        (S[i+1] <> ']')  and (S[i+1] <> '=') and (S[i+1] <> '<' ) and (S[i+1] <> '>'))  then
      begin
        if CheckImUnitAfterBr(S,i) = False then
        begin
          F_SyntaxErrorCode:=E_MISSING_OPERATION;      //отсутствует операция
          LC:=7; //условно
          if i < LC  then  p1:=i else p1:=LC;
          if Length(S)-i < LC then p2:=Length(S)-i else p2:=LC;

          F_SyntaxErrorString:=Copy(S,i-p1+1,p1+p2);
          goto endp;
        end;
      end;

     {.231}
      if (S[i] in Operation2Arg) and (S[i+1] in Operation2Arg) then
      begin
        F_SyntaxErrorCode:=E_MISSING_EXPRESSION;

        LC:=7; //условно
        if i < LC  then  p1:=i else p1:=LC;
        if Length(S)-i < LC then p2:=Length(S)-i else p2:=LC;
        F_SyntaxErrorString:=Copy(S,i-p1+1,p1+p2);

        goto endp;
      end;

      if S[i] = '(' then inc(br);
      if S[i] = ')' then dec(br);

      if S[i] = '[' then inc(bs);
      if S[i] = ']' then dec(bs);

      if S[i] = '{' then inc(bc);
      if S[i] = '}' then dec(bc);
  end;

  if S[Length(S)] = ')' then dec(br);
  if S[Length(S)] = ']' then dec(bs);
  if S[Length(S)] = '}' then dec(bc);

  if br <> 0 then
  begin
    F_SyntaxErrorCode:=E_MISSING_ROUND_BRACKET;
    F_SyntaxErrorString:=Copy(S,1,Length(S));
    //raise E.Create('');
  end
  else
  if bs <> 0 then
  begin
    F_SyntaxErrorCode:=E_MISSING_SQUARE_BRACKET;
    F_SyntaxErrorString:=Copy(S,1,Length(S));
    //raise E.Create('');
  end
  else
  if bc <> 0 then
  begin
    F_SyntaxErrorCode:=E_MISSING_CURLY_BRACKET;
    F_SyntaxErrorString:=Copy(S,1,Length(S));
    //raise E.Create('');
   end;
end;


(*
if F_SquareBracketToTrunc = False then
begin
    S:=StringReplace(S,'[','(',[rfReplaceAll, rfIgnoreCase]);
    S:=StringReplace(S,']',')',[rfReplaceAll, rfIgnoreCase]);
end;
*)

if F_CurlyBracketToFrac = False then
begin
    S:=StringReplace(S,'{','(',[rfReplaceAll, rfIgnoreCase]);
    S:=StringReplace(S,'}',')',[rfReplaceAll, rfIgnoreCase]);
end;


S1:=Copy(S,1,Length(S));
endp:
end;








procedure TForevalH.SyntaxAnalizatorGT( var ND: TDataNode; var LV:PLevel;  var EOFN: Boolean);
label endp;
var
COP,S: String;
nf: Cardinal;
BH: Boolean;
a,b: TFloat;
Arg: Integer;
begin

//ND - параметры главного родительского узла - текущей идентефицируемой команды - Tree^.Expression
//LV - параметры вытекающих из главного узла ветвей - узлы потомков.
//Число вытекающих потомков = числу аргументов родительской команды = Length(LV)
//LV[].Expression = строковые выражения вытекающих ветвей из главной команды родительского узла


if F_SyntaxErrorCode <> 0 then goto endp;

S:=Tree^.Expression;

//if S[1] = '+' then Delete(S,1,1); {.302} // +Expr -> Expr

//F_CurrentSubExpr:=S; {.195}
F_SyntaxErrorString:=S;


FindExternalBracketNegPS(@S);  {.302} //on

TryFPUMask; {.229}


EOFN:=False;
InitNode(ND);

if M_ParseMode = M_Compile then    // <> M_ParseDiffExpr  {.301}
begin

 //вначале искать составные числа вида : 1.123456789E+-1234
 FindConstPS(@S,ND,EOFN);       //finf const in view 1.123456789E+-1234    {.314}

 {.357A}
 //enable integer optimize for arguments of functions, if it - integer number: fint1(5)
 //перехват сложных целочисленных  аргументов для оптимизации одной исполняемой командой

 if EOFN = True then      //is number
  if ND.COP=_LDSC then      //is real
   if abs(ND.FD) <= C_MaxCardinal then // is <= MaxInt
    if Trunc(ND.FD) = ND.FD then       // is integer
      if  F_IntegerOptimizationF = True then FindExtFuncIntArg(ND,EOFN);


 if EOFN = True then goto endp;

 if  F_IntegerOptimizationF = True then FindExtFuncIntArg(ND,EOFN);  //for other types integer arguments

 if EOFN = True then
 begin

  goto endp;
 end;

end;



//поиск главной операции в текущем выражении:
StringAnalizatorPS(@S,ND,LV);   {.314}
Arg:=Length(LV);
if F_SyntaxErrorCode = 0 then                     {.195}
begin
If (ND.COP = 0)  then      //операция не найдена => выражение - функция, массив ,переменная, константа
 begin

  //искать функцию или массив:
  FindFunctionPS(@LV[0].Expression,ND,LV,BH,EOFN);   {.314}

  if BH = False then //...не найдены, искать переменную или число. Иначе - ошибка: неизвестный символ/выражение
  NumberAnalizatorPS(@LV[0].Expression,ND,EOFN); {.314}
  //NumberAnalizator(LV[0].Expression,ND,EOFN);
 end
 else  {.353}
 //оптимизация некоторых операций
 if (M_ParseMode = M_Compile)  then
 begin
    if (Arg = 1) then  OperationalAnalizator1(LV,ND,LV,ND,EOFN) else
    if (Arg = 2) then  OperationalAnalizator2(LV,ND,LV,ND,EOFN);
 end;

 {
 if (F_SaveInFPU = True) and (Arg = 2) and (F_OperationOptimizatorA2 = True ) and (M_ParseMode = M_Compile) then
    OperationalAnalizator2(LV,ND,LV,ND,EOFN)
 else
 if (F_SaveInFPU = True) and (Arg = 1) and (F_OperationOptimizatorA1 = True ) and (M_ParseMode = M_Compile)  then
    OperationalAnalizator1(LV,ND,LV,ND,EOFN);
 }
end;


endp:
TryCatchFPUException;    {.229}
end;





procedure TForevalH.OperationalAnalizator1(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
label endp;
var
ni: Integer;
Str1: String;
BAnsw: Boolean;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

TryFPUMask; {.229}


LV1:=LV;
ND1:=ND;


EOFN:=False;

//InitNode(ND);
if (F_SaveInFPU = True) and  (F_OperationOptimizatorA1 = True ) then
begin
  if (ND.NFunc = CM_RE) or (ND.NFunc = CM_IM)  then
      ReImAnalizator(LV, ND, LV1, ND1, EOFN)
  else
  if (ND.NFunc = CM_FACT) or (ND.NFunc = CM_FACT2) then
      FactAnalizator(LV, ND, LV1, ND1, EOFN);
end;

if (ND.NFunc = CM_ADDR) then
      AddrAnalizator(LV, ND, LV1, ND1, EOFN); //должен выполняться в любом режиме (F_SaveInFPU ,F_OperationOptimizatorA1)!



endp:
TryCatchFPUException;    {.229}
end;





procedure TForevalH.OperationalAnalizator2(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
label endp;
var
C: TFloat;
BH,BZ1,BZ2,Answ: Boolean;
VC1,VC2: Integer;
S: Integer;
i: Integer;
nv1,nv2,tv1,tv2,tm: Integer;
FD1,FD2: extended;
Str: String;
adr: Cardinal;
begin
if F_SyntaxErrorCode <> 0 then goto endp;
if (F_SaveInFPU = False) or  (F_OperationOptimizatorA2 = False) then goto endp;


TryFPUMask; {.229}

{.195}
if (ND.NFunc <> CM_POWER) and (ND.NFunc <> CM_ROOT) and
   (ND.NFunc <> CM_ADD)   and (ND.NFunc <> CM_SUB ) and  (ND.NFunc <> CM_MUL) and  (ND.NFunc <> CM_DIV) then goto endp;

if ND.NFunc = CM_POWER then begin PowerAnalizator(LV,ND,LV1,ND1,EOFN);   goto endp; end;
if ND.NFunc = CM_ROOT then begin RootAnalizator(LV,ND,LV1,ND1,EOFN);   goto endp; end;

{.318}


(*
LV1:=LV;
ND1:=ND;

if ((ND.NFunc = CM_MUL) or (ND.NFunc = CM_DIV)) and (F_MulDivOptimization = True) then
begin
 if G_NExpr > 2 then
 begin
   Answ:=MulDivAnalizator(LV,ND,LV1,ND1,EOFN);
   if Answ = True then goto endp
   else
   begin
     LV:=LV1;
     ND:=ND1;
   end;
 end
 else
 begin     //(G_NExpr = 2)

          //Sa1:=Copy(PS^,1,NPos-1);
          //Sa2:=Copy(PS^,NPos+1,Length(PS^)-NPos);
          BZ1:=CheckToZeroPS(@LV[0].Expression);
          BZ2:=CheckToZeroPS(@LV[1].Expression);

          if (ND.NFunc = CM_DIV) and (BZ2 = True) then
          begin
            F_InternalError:=E_ZeroDivide ;
            F_SyntaxErrorCode:=E_ERROR_AT_CALCULATION;
            F_SyntaxErrorString:=LV[1].Expression;
            goto endp;
          end
          else
          begin
             //.314
            if (BZ1 = True) and (LV[1].Expression <> S_IM_UNIT)  then
            begin
              ND1.FD:=0;
              ND1.COP:=_LDSC;
              ND1.NFunc:=0;
              EOFN:=True;
              SetLength(LV1,0);
              goto endp;
            end
            else
            if (BZ2 = True) and (LV[0].Expression <> S_IM_UNIT)  then
            begin
              ND1.FD:=0;
              ND1.COP:=_LDSC;
              ND1.NFunc:=0;
              EOFN:=True;
              SetLength(LV1,0);
              goto endp;
            end;

          end;
 end;

end;
*)

if ((ND.NFunc = CM_MUL) or (ND.NFunc = CM_DIV)) and (F_MulDivOptimization = True) then
begin
 MulDivAnalizator(LV,ND,LV1,ND1,EOFN);
 goto endp;
 {
 if G_NExpr > 2 then
 begin
   Answ:=MulDivAnalizator(LV,ND,LV1,ND1,EOFN);
   if Answ = True then goto endp
   else
   begin
     LV:=LV1;
     ND:=ND1;
   end;
 end
 else
 begin     //(G_NExpr = 2)

          //Sa1:=Copy(PS^,1,NPos-1);
          //Sa2:=Copy(PS^,NPos+1,Length(PS^)-NPos);
          BZ1:=CheckToZeroPS(@LV[0].Expression);
          BZ2:=CheckToZeroPS(@LV[1].Expression);

          if (ND.NFunc = CM_DIV) and (BZ2 = True) then
          begin
            F_InternalError:=E_ZeroDivide ;
            F_SyntaxErrorCode:=E_ERROR_AT_CALCULATION;
            F_SyntaxErrorString:=LV[1].Expression;
            goto endp;
          end
          else
          begin
             //.314
            if (BZ1 = True) and (LV[1].Expression <> S_IM_UNIT)  then
            begin
              ND1.FD:=0;
              ND1.COP:=_LDSC;
              ND1.NFunc:=0;
              EOFN:=True;
              SetLength(LV1,0);
              goto endp;
            end
            else
            if (BZ2 = True) and (LV[0].Expression <> S_IM_UNIT)  then
            begin
              ND1.FD:=0;
              ND1.COP:=_LDSC;
              ND1.NFunc:=0;
              EOFN:=True;
              SetLength(LV1,0);
              goto endp;
            end;

          end;
 end;
 }
end
else
begin
  LV1:=LV;
  ND1:=ND;
end;


 //F_IdN не изменилась = ND1.F_IdN!!! (StringAnalizator)

{
NumberAnalizatorA(LV[0].Expression,nv1,FD1,VC1);     //VC = _Const(FD); = _Var(nf); = _None(Stack);
NumberAnalizatorA(LV[1].Expression,nv2,FD2,VC2);                                //op = +  -  *  /
}

// поиск только действительных констант  (комплексные в MulDivAnalizator)
{.305}
FindVarConstPS(@LV[0].Expression,nv1,FD1,VC1);
FindVarConstPS(@LV[1].Expression,nv2,FD2,VC2);

if (VC1 = _ComplexVar) or (VC1 =  _FloatVar) or (VC1 =  _IntVar) then VC1:=_Var
else
if (VC1 = _NOT_FOUND) then VC1:=_None;

if (VC2 = _ComplexVar) or (VC2 =  _FloatVar) or (VC2 =  _IntVar) then VC2:=_Var
else
if (VC2 = _NOT_FOUND) then VC2:=_None;


if (VC1 = _Var)   and (VC2 = _None)   then ND1.NV1:=nv1                         //S op v
else
if (VC1 = _Const) and (VC2 = _None)   then ND1.FD:=FD1                          //S op c
else
if (VC1 = _None)  and (VC2 = _Var)    then ND1.nv1:=nv2                         //S op v
else
if (VC1 = _None)  and (VC2 = _Const)  then ND1.FD:=FD2                          //S op c
else
if (VC1 = _Var)   and (VC2 = _Var)    then begin ND1.nv1:=nv1; ND1.nv2:=nv2; end//v1 op v2
else
if (VC1 = _Var)   and (VC2 = _Const)  then begin ND1.nv1:=nv1; ND1.FD:=FD2; end //v op  c
else
if (VC1 = _Const) and (VC2 = _Var)    then begin ND1.FD:=FD1; ND1.nv1:=nv2; end;//c op v

ND1.TC:=C_Real;




if (VC1 = _None) and (VC2 = _None) then
begin
 EOFN:=False;
 ND1.N:=2;
 goto endp;
end
else
if (VC1 = _None) and (VC2 <> _None) then
begin
  EOFN:=False;
  ND1.N:=1;
  Str:=Copy(LV[0].Expression,1,Length(LV[0].Expression));
  SetLength(LV1,1);
  LV1[0].Expression:=Copy(Str,1,Length(Str));
  LV1[0].NL:=1;
  //LV1[0].IdL:=F_IdN;
end
else
if (VC1 <> _None) and (VC2 = _None) then
begin
  EOFN:=False;
  ND1.N:=1;
  Str:=Copy(LV[1].Expression,1,Length(LV[1].Expression));
  SetLength(LV1,1);
  LV1[0].Expression:=Copy(Str,1,Length(Str));
  LV1[0].NL:=1;
  //LV1[0].IdL:=F_IdN;
end
else
if (VC1 <> _None) and (VC2 <> _None) then
begin
 EOFN:=True;
 ND1.N:=0;
 SetLength(LV1,0);
end;





if ND1.NFunc = CM_ADD then
begin
 if (VC1 = _Const) and (VC2 = _Const) then
 begin
  ND1.FD:=FD1+FD2;
  ND1.COP:=_LDSC;
  ND1.NFunc:=0;
 end
end
else
if ND1.NFunc = CM_SUB then
begin
 if (VC1 = _Const) and (VC2 = _Const) then
 begin
  ND1.FD:=FD1-FD2;
  ND1.COP:=_LDSC;
  ND1.NFunc:=0;
 end
 else
 if (VC1 = _Var) and (VC2 = _None)  then   ND1.Inv:=1  //v-S
 else
 if (VC1 = _Const) and (VC2 = _None) then  ND1.Inv:=1   //c-S
 else
 if (VC1 = _Const) and (VC2 = _Var)  then  ND1.Inv:=1   //c-v
 else
 if (VC1 = _Var) and (VC2 = _Var)  then                 //i-i
 begin
   GetVar1(nv1,adr,tv1,tm);
   GetVar1(nv2,adr,tv2,tm);
   if (tv1 = IM_UNIT) and (tv2 = IM_UNIT) then
   begin
     ND1.FD:=0;
     ND1.COP:=_LDSC;
     ND1.NFunc:=0;
   end;
 end;
end
else
if ND1.NFunc = CM_MUL then
begin
  if (VC1 = _Const) and (VC2 = _Const) then
  begin
   ND1.FD:=FD1*FD2;
   ND1.COP:=_LDSC;
   ND1.NFunc:=0;
  end
  else
 if (VC1 = _Var) and (VC2 = _Var)  then                 //i*i
 begin
   GetVar1(nv1,adr,tv1,tm);
   GetVar1(nv2,adr,tv2,tm);
   if (tv1 = IM_UNIT) and (tv2 = IM_UNIT) then
   begin
     ND1.FD:=-1;
     ND1.COP:=_LDSC;
     ND1.NFunc:=0;
   end;
 end
end
else
if ND1.NFunc = CM_DIV then
begin
  if (VC1 = _Const) and (VC2 = _Const) then
  begin
   ND1.FD:=FD1/FD2;
   ND1.COP:=_LDSC;
   ND1.NFunc:=0;
  end
  else
 if (VC1 = _Var) and (VC2 = _None)  then   ND1.Inv:=1  //v/S
 else
 if (VC1 = _Const) and (VC2 = _None) then  ND1.Inv:=1   //c/S
 else
 if (VC1 = _Const) and (VC2 = _Var)  then  ND1.Inv:=1   //c/v
 else
 if (VC1 = _Var) and (VC2 = _Var)  then                 //i/i
 begin
   GetVar1(nv1,adr,tv1,tm);
   GetVar1(nv2,adr,tv2,tm);
   if (tv1 = IM_UNIT) and (tv2 = IM_UNIT) then
   begin
     ND1.FD:=1;
     ND1.COP:=_LDSC;
     ND1.NFunc:=0;
   end;
 end;
end;


endp:
TryCatchFPUException;    {.229}
end;




procedure TForevalH.FactAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
label endp;
var
C,Im: TFloat;
VC1,VC2: Integer;
S,NA,TV: Integer;
i: Integer;
nv1,nv2,tv1,tv2,tm,P,RP,Len,code2: Integer;
FD1,FD2: extended;
Str,Str1,Str2,Str3: String;
adr: Cardinal;
BH,BAnsw,SB: Boolean;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

TryFPUMask; {.229}

Len:=Length(LV);
if (Len <> 1) then
begin
   {.333}
 {F_SyntaxErrorCode:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
 F_SyntaxErrorString:=F_CurrentString;}
 goto endp;
end;

LV1:=LV;
ND1:=ND;
EOFN:=False;
BH:=False;

Str1:=LV[0].Expression;
 WriteFindExtArgInt1PS(@Str1, _First, ND1,  ND1, BAnsw);
 if Bansw = True then
 begin
    if ND1.TA1 = _IntConst then
    begin
      ND1.COP:=_LDSC;
      ND1.NFunc:=0;
      if ND.NFunc = CM_FACT then ND1.FD:=Factorial[ND1.IC1]
                            else ND1.FD:=Factorial2F[ND1.IC1];
      EOFN:=True;
      LV1:=nil;
      ND1.N:=0;
    end
    else
    begin
     ND1.AI:=1;
     EOFN:=True;
     ND1.N:=0;
     SetLength(LV1,0);
    end;
 end;



endp:
TryCatchFPUException;    {.229}
end;





procedure TForevalH.AddrAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
label endp;
var
C,Im: TFloat;
VC1,VC2: Integer;
S,NA,TV: Integer;
i: Integer;
nv1,nv2,tv1,tv2,tm,P,RP,Len,code2,ni, TypeV, TypeIndx: Integer;
FD1,FD2: extended;
Str,Str1,Str2,Str3,Sindx: String;
adr,Addr: Cardinal;
BH,BAnsw,SB: Boolean;
NDA: TDataNode;
begin
if F_SyntaxErrorCode <> 0 then goto endp;



LV1:=LV;
ND1:=ND;
EOFN:=False;



Len:=Length(LV);
if (Len <> 1)  then
begin
   {.333}
 {F_SyntaxErrorCode:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
 F_SyntaxErrorString:=F_CurrentString;}
 goto endp;
end;


{
Загрузка адреса: @Func; @var; @array
}    {.347}
if F_EnableUsePointer = True then
begin

   BH:=FindAddrObj(@LV[0].Expression,ND1,ND1);     //только адреса func,var,array:     @x, @k, @z1.re,@z1.im, @z1, @vd, @sp2
   if BH = True then
   begin
      ND1.COP:=_LDSA;
      ND1.TypeF:={T_Real;}T_Pointer;//T_Real;//T_Integer//T_Pointer;
      EOFN:=True;
      ND1.NFunc:=0;
      ND1.N:=0;
      SetLength(LV1,0);
      goto endp;
   end
   else
   begin    //поиск  vec[indx] :        @vd[2*k+3]
      //if FindArray(PS,  ND,  ND1,  Sindx) = True then
      //FindArray(PS: PString; var NDA: TDataNode;  var ni, TypeV, TypeIndx: Integer; var Addr: Cardinal;   var Sindx: String): Boolean;
     if FindArray(@LV[0].Expression, NDA, ni, TypeV, TypeIndx, Addr, Sindx) = True then
     begin

         ND1.NObj2:=ni;
         //ND1.Addr1:=Addr;//Alg.Obj[ni].Addr;
         ND1.AI:=_AddrArrayElem;
         ND1.COP:=_LDSA;
         ND1.TypeF:={T_Real;}T_Pointer;//T_Real;//T_Integer//T_Pointer;
         EOFN:=True;
         ND1.NFunc:=0;
         ND1.N:=0;
         SetLength(LV1,0);
         ND1.DI:=NDA.AI; //тип аргумента массива в DI !!
         ND1.AIVP1:=Copy(NDA.AIVP1,0,Length(NDA.AIVP1));
         ND1.FD:=NDA.FD; //константа аргумента массива @vec[IntConst]
         ND1.NV2:=NDA.NV1; //переменная аргумента массива @vec[Intconst]

         if TypeIndx = _Stack then
         begin
           EOFN:=False;
           ND1.N:=1;
           SetLength(LV1,1);
           LV1[0].Expression:=Sindx;
           ND1.DI:=0;
         end;



      end
      else
      begin
          F_SyntaxErrorCode:=E_WRONG_EXPRESSION;
          //F_SyntaxErrorString:=F_CurrentString;
      end;
   end;


end;


endp:
//TryCatchFPUException;    {.229}
end;




procedure TForevalH.ReImAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
label endp;
var
C,Im: TFloat;
VC1,VC2: Integer;
S,NA,TV: Integer;
i: Integer;
nv1,nv2,tv1,tv2,tm,P,RP,Len,code2,ni: Integer;
FD1,FD2: extended;
Str,Str1,Str2,Str3: String;
adr: Cardinal;
BH,BAnsw,SB: Boolean;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

//TryFPUMask; {.229}

Len:=Length(LV);
if (Len <> 1)  then
begin
   {.333}
 {F_SyntaxErrorCode:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
 F_SyntaxErrorString:=F_CurrentString;}
 goto endp;
end;

LV1:=LV;
ND1:=ND;
EOFN:=False;
BH:=False;



  FindVarPS(@LV[0].Expression,ni);
  if ni >= 0 then
  begin
     if ND.NFunc = CM_RE then ND1.TS:=_RE;
     if ND.NFunc = CM_IM then ND1.TS:=_IM;

     ND1.COP:=_LDSF;
     ND1.NObj:=ni;
     EOFN:=True;
     ND1.N:=0;
     ND1.NFunc:=0;
     SetLength(LV1,0);
  end;


endp:
//TryCatchFPUException;    {.229}
end;




procedure TForevalH.PowerAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
label endp;
var
C,Im: TFloat;
VC1,VC2,TC: Integer;
S,NA,TV: Integer;
Sgn:Integer;
i: Integer;
nv1,nv2,tv1,tv2,tm,Len,mt2: Integer;
FD1,FD2,FD1i: extended;
Str,Str1,Str2: String;
adr: Cardinal;
BH,BAnsw,SB: Boolean;
code2,IC1: Integer;
AIVP1: TArrayIntVarProd;
FRes,FArg1,FArg2: TComplex;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

TryFPUMask; {.229}

Len:=Length(LV);
if Len <> 2 then
begin
  {.333}
 {F_SyntaxErrorCode:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
 F_SyntaxErrorString:=F_CurrentString; }
 goto endp;
end;

LV1:=LV;
ND1:=ND;
EOFN:=False;
BH:=False;
//ND1.COP:=_FUNC;
 //F_IdN не изменилась = ND1.F_IdN!!! (StringAnalizator)


//VC = _Const(FD); = _Var(nf); = _None(Stack);
Str2:=LV[1].Expression;
Str1:=LV[0].Expression;

DeleteExternalBracketPS(@Str1); {.219}
DeleteExternalBracketPS(@Str2); {.219}

//FindVarConstPS(@Str1,nv1,FD1,VC1);
FindVarConstCxPS(@Str1, nv1, FD1, FD1i, VC1, TC);

ND1.ExpressionArg:=Str1+','+Str2; {.216}
NA:=2; {.231}

WriteFindExtArgInt1PS(@Str2, _Second, ND1,  ND1, BAnsw);
code2:=ND1.TA2;

VC2:=_none;  TV := _NOT_FOUND; {.346}
if code2 = _IntConst then begin FD2:=ND1.IC2; VC2:=_Const; end
else
if code2 = _NOT_FOUND then SubstParamPS(@Str2,FD2,Im,TV);  //Str2 = FloatConst ?
if TV = T_Real then VC2:=_Const;
//if SB = True then VC2:=_Const;



//FindExtArgInt(@Str2, code2, AIVP1, NV1, IC1);

if  (VC2 = _Var)  then mt2:=Alg.Obj[nv2].MType;


//s1^intvar
//if  (VC2 = _FVar) and (mt2 = _Integer) and (VC1 <> _Const) then

if (VC1 = _Const) and (VC2 = _Const) then       //const^const
begin
     ND1.FD:=_POWER(FD1,FD2);//power(FD1,FD2);
     ND1.COP:=_LDSC;
     ND1.NFunc:=0;
     BH:=True;
     EOFN:=True;
     LV1:=nil;
     ND1.N:=0;
end
else
if  (VC1 <> _Const) and (code2 <> _NOT_FOUND) then    //Expr^IntForm
begin

         //i^IntArg; (-i)^IntArg      {.361}
         if CheckImUnit(@LV1[0].Expression,Sgn) = true then
         begin
           if code2 = _IntConst then //eval const
           begin
               FArg1.re:=0;
               FArg1.im:=1;
               if Sgn = _Negative then FArg1.im:=-1;
               FArg2.re:=FD2;
               FArg2.im:=0;
               _EvalFunc2Cx(@Z_CxReFPWR,FArg1,FArg2,T_Complex,T_Real,FRes);

               ND1.COP:=_LDSCX;
               ND1.NFunc:=0;
               EOFN:=True;
               ND1.N:=0;
               ND1.TC:=C_Complex;
               ND1.FDC.re:=FRes.re;
               ND1.FDC.im:=FRes.im;
               SetLength(LV1,0);
               goto endp;
           end;

           ND1.NFunc:=CM_ImUIPwr;
           ND1.BI:=Sgn;
           EOFN:=True;
           ND1.N:=0;
           ND1.COP:=_FUNC;
           SetLength(LV1,0);
           goto endp;
         end;


         ND1.NFunc:=CM_IPWR;
         ND1.AI:=2;
         EOFN:=False;
         ND1.N:=1;
         ND1.COP:=_FUNC;
         SetLength(LV1,1);
         LV1[0].Expression:=Copy(Str1,1,Length(Str1));
         LV1[0].NL:=1;

         //if VC2 = _Const then
         begin
           if (code2 = _IntConst) and (abs(FD2) <= 16) then
           begin
             ND1.NFunc:=CM_IPWR16;  NA:=0;  BH:=True;
             ND1.AI:=Trunc(FD2);
             if FD2 = 2  then  ND1.NFunc:=CM_SQR;
           end
         end;


end
else
if  (VC1 = _Const) and (code2 <> _NOT_FOUND) then      //const^IntForm
begin

         ND1.AI:=1;
         ND1.FD:=FD1;
         EOFN:=True;
         ND1.N:=0;
         ND1.TypeF:=T_Real;
         ND1.COP:=_FUNC;
         SetLength(LV1,0);

         //if FD1 = -1 then    ND1.NFunc:=CM_IPWRSGN  else     // (-1)^IntForm
         if FD1 = -1 then    ND1.NFunc:=CM_REUNEGIPWR  else      // (-1)^IntForm      {.361}
         if FD1 = 2  then    ND1.NFunc:=CM_F2PWR      else     // 2^IntForm
                             ND1.NFunc:=CM_IPWR;             // num^IntForm


end
else
if  (VC1 <> _Const) and (VC2 = _Const) then  //^floatConst
begin

           if FD2 = 0.5 then
           begin
              ND1.NFunc:=CM_SQRT;
              EOFN:=False;
              ND1.N:=1;
              ND1.COP:=_FUNC;
              SetLength(LV1,1);
              LV1[0].Expression:=Copy(Str1,1,Length(Str1));
              LV1[0].NL:=1;
           end
           else
           if FD2 = 0.25 then             // = sqrt(sqrt(Expr))
           begin
              ND1.NFunc:=CM_SQRT;
              EOFN:=False;
              ND1.N:=1;
              ND1.COP:=_FUNC;
              SetLength(LV1,1);
              LV1[0].NL:=1;
              Str1:='sqrt('+Str1+')';
              LV1[0].Expression:=Copy(Str1,1,Length(Str1));
           end;
end
else
if (VC1 = _Const) and (code2 = _NOT_FOUND)  then      //Const^Expr
begin
  // (-1)^FloatExpr -> (-1)^Trunc(FloatExpr) - close in {.361}
 { if FD1 = -1 then
  begin
         ND1.NFunc:=CM_IPWRSGN;
         ND1.COP:=_FUNC;
         ND1.AI:=0;
         SetLength(LV1,1);
         EOFN:=False;
         ND1.N:=1;
         LV1[0].Expression:=Copy(Str2,1,Length(Str2));
  end
  else  }
  if FD1 = 2 then
  begin
         ND1.NFunc:=CM_F2PWR;
         ND1.COP:=_FUNC;
         ND1.AI:=0;
         SetLength(LV1,1);
         EOFN:=False;
         ND1.N:=1;
         LV1[0].Expression:=Copy(Str2,1,Length(Str2));
  end
  else
  if F_ReduceArgOptimizator = True then
  begin           {.361}
    //const(Re)^Re; const(Re)^Complex
         ND1.NFunc:=CM_CZPWR;
         ND1.COP:=_FUNC;
         ND1.AI:=1; //Const(Re)
         ND1.FD:=FD1;
         //ND1.FD1:=fc_Log2(FD1);
         SetLength(LV1,1);
         EOFN:=False;
         ND1.N:=1;
         LV1[0].Expression:=Copy(Str2,1,Length(Str2));

  end;


end
else   {.361}
if (VC1 = _ConstComplex) and (code2 = _NOT_FOUND)  then      //Const(Complex)^Expr
begin

    if (FD1 = -1) and (FD1i = 0) then
    begin
         ND1.NFunc:=CM_IPWRSGN;
         ND1.COP:=_FUNC;
         ND1.AI:=2;      //(-1+0i)^(arg)
         SetLength(LV1,1);
         EOFN:=False;
         ND1.N:=1;
         LV1[0].Expression:=Copy(Str2,1,Length(Str2));
    end
    else
    if ((FD1 = 0) and (FD1i = 1)) or ((FD1 = 0) and (FD1i = -1)) then
    begin
         ND1.NFunc:=CM_IMURZPWR;       //(+-i)^(Real,Complex)
         ND1.COP:=_FUNC;
         if FD1i = 1 then ND1.AI:=1 else  ND1.AI:=2;
         ND1.FD:=FD1;
         ND1.FDC.re:=FD1;
         ND1.FDC.im:=FD1i;
         SetLength(LV1,1);
         EOFN:=False;
         ND1.N:=1;
         LV1[0].Expression:=Copy(Str2,1,Length(Str2));
    end
    else
    if F_ReduceArgOptimizator = True then
    begin
         ND1.NFunc:=CM_CZPWR;
         ND1.COP:=_FUNC;
         ND1.AI:=2; //Const(Complex)
         ND1.FD:=FD1;
         ND1.FDC.re:=FD1;
         ND1.FDC.im:=FD1i;
         //ND1.FD1:=fc_Log2(FD1);
         SetLength(LV1,1);
         EOFN:=False;
         ND1.N:=1;
         LV1[0].Expression:=Copy(Str2,1,Length(Str2));
    end;

end
else
if (VC1 = _ComplexVar) and (TC = C_Image) and (code2 = _NOT_FOUND)  then      //(i)^Expr
begin
      if  (FD1 = 0) and (FD1i = 1) then
      begin
         ND1.NFunc:=CM_IMURZPWR;     //i^(Real,Complex)
         ND1.COP:=_FUNC;
         ND1.AI:=1 ;
         ND1.FD:=FD1;
         ND1.FDC.re:=FD1;
         ND1.FDC.im:=FD1i;
         SetLength(LV1,1);
         EOFN:=False;
         ND1.N:=1;
         LV1[0].Expression:=Copy(Str2,1,Length(Str2));
      end;
end;




endp:
TryCatchFPUException;    {.229}
end;




function TForevalH._POWER(x,y: extended): extended;
var res: extended;
begin

try

 TryFPUMask;
 asm
   fld  tbyte  ptr [y]
   fld  tbyte  ptr [x]
   call FPWR
   fstp res
 end;


  TryCatchFPUException;
except
 on E: EZeroDivide      do F_InternalError:=E_ZeroDivide;
 on E: EInvalidOp       do F_InternalError:=E_InvalidOp;
 on E: EOverFlow        do F_InternalError:=E_OverFlow;
 on E: EUnderFlow       do F_InternalError:=E_UnderFlow;
 on E: EIntOverFlow     do F_InternalError:=E_IntOverFlow;
 on E: EAccessViolation do F_InternalError:=E_AccessViolation;
 on E: EOutOfMemory     do F_InternalError:=E_OutOfMemory;
 on E: EStackOverFlow   do F_InternalError:=E_StackOverFlow;
end;

   if F_InternalError <> 0 then
      F_SyntaxErrorCode:=E_INTERNAL_ERROR_AT_CALCULATION;



 _POWER:=res;
end;





function TForevalH._ROOT(x,y: extended): extended;
var s,d: double;
res :Extended;
begin


try

 TryFPUMask;
 asm
   fld  tbyte  ptr [y]
   fld  tbyte  ptr [x]
   call R_FROOT
   fstp res
 end;


  TryCatchFPUException;
except
 on E: EZeroDivide      do F_InternalError:=E_ZeroDivide;
 on E: EInvalidOp       do F_InternalError:=E_InvalidOp;
 on E: EOverFlow        do F_InternalError:=E_OverFlow;
 on E: EUnderFlow       do F_InternalError:=E_UnderFlow;
 on E: EIntOverFlow     do F_InternalError:=E_IntOverFlow;
 on E: EAccessViolation do F_InternalError:=E_AccessViolation;
 on E: EOutOfMemory     do F_InternalError:=E_OutOfMemory;
 on E: EStackOverFlow   do F_InternalError:=E_StackOverFlow;
end;

   if F_InternalError <> 0 then
      F_SyntaxErrorCode:=E_INTERNAL_ERROR_AT_CALCULATION;



 _ROOT:=res;

 (*
s:=1;


 if (x = 0) and (y <= 0) then d:=sqrt(-1); {.215}  //call error

if (x < 0) and  (Trunc(y) = y) and (Trunc(y/2) <> y/2) then
  begin
    s:=-1;
    _ROOT:=s*power(abs(x),1/y);

  end
else
_ROOT:=s*power(x,1/y);   {.195}
  *)


end;




procedure TForevalH.RootAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
label endp;
var
C,Im: TFloat;
VC1,VC2: Integer;
S,NA,TV: Integer;
i: Integer;
nv1,nv2,tv1,tv2,tm,P,RP,Len,code2: Integer;
FD1,FD2: extended;
Str,Str1,Str2,Str3: String;
adr: Cardinal;
BH,BAnsw,SB: Boolean;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

TryFPUMask; {.229}

Len:=Length(LV);
if (Len <> 2) and (Len <> 3) then
begin
   {.333}
 {F_SyntaxErrorCode:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
 F_SyntaxErrorString:=F_CurrentString;}
 goto endp;
end;

LV1:=LV;
ND1:=ND;
EOFN:=False;
BH:=False;

{.195}
//if Len = 3 then goto endp;

//ND1.COP:=_FUNC;
 //F_IdN не изменилась = ND1.F_IdN!!! (StringAnalizator)


if Len = 2 then
begin
//VC = _Const(FD); = _Var(nf); = _None(Stack);
Str2:=LV[1].Expression;
Str1:=LV[0].Expression;
//FindExternalBracket(Str1,Str1);
DeleteExternalBracketPS(@Str1); {.219}
//FindExternalBracket(Str2,Str2);
DeleteExternalBracketPS(@Str2); {.219}





FindVarConstPS(@Str1,nv1,FD1,VC1);
ND1.ExpressionArg:=Str1+','+Str2;


WriteFindExtArgInt1PS(@Str2, _Second, ND1,  ND1, BAnsw);
code2:=ND1.TA2;

VC2:=_None; TV:=_NOT_FOUND; {.346}
if code2 = _IntConst then begin FD2:=ND1.IC2; RP:=ND1.IC2; VC2:=_Const; end
else
if code2 = _NOT_FOUND then SubstParamPS(@Str2,FD2,Im,TV);  //Str2 = FloatConst ?
if TV = T_Real then VC2:=_Const;
//if SB = True then VC2:=_Const;




{
NumberAnalizatorA(Str2,nv2,FD2,VC2);
NumberAnalizatorA(Str1,nv1,FD1,VC1);
}

if (VC1 = _Const) and (VC2 = _Const) then       //Root(const,const)
begin
     ND1.FD:=_ROOT(FD1,FD2);//power(FD1,1/FD2);
     ND1.COP:=_LDSC;
     ND1.NFunc:=0;
     BH:=True;
     EOFN:=True;
     LV1:=nil;
     ND1.N:=0;
end
else
if  (VC1 <> _Const) and (code2 <> _NOT_FOUND) then    //IRoot(Expr,IntForm)
begin
         ND1.NFunc:=CM_IROOT;
         ND1.AI:=2;
         EOFN:=False;
         ND1.N:=1;
         ND1.COP:=_FUNC;
         SetLength(LV1,1);
         LV1[0].Expression:=Copy(Str1,1,Length(Str1));
         LV1[0].NL:=1;

         if RP = 2 then
           begin
              ND1.NFunc:=CM_SQRT;
              EOFN:=False;
              ND1.N:=1;
              ND1.COP:=_FUNC;
              SetLength(LV1,1);
              LV1[0].Expression:=Copy(Str1,1,Length(Str1));
              LV1[0].NL:=1;
           end
           else
           if RP = 4 then             // = sqrt(sqrt(Expr))
           begin
              ND1.NFunc:=CM_SQRT;
              EOFN:=False;
              ND1.N:=1;
              ND1.COP:=_FUNC;
              SetLength(LV1,1);
              LV1[0].NL:=1;
              Str1:='sqrt('+Str1+')';
              LV1[0].Expression:=Copy(Str1,1,Length(Str1));
           end
           else
           if RP = 8 then             // = sqrt(sqrt(sqrt(Expr)))
           begin
              ND1.NFunc:=CM_SQRT;
              EOFN:=False;
              ND1.N:=1;
              ND1.COP:=_FUNC;
              SetLength(LV1,1);
              LV1[0].NL:=1;
              Str1:='sqrt(sqrt('+Str1+'))';
              LV1[0].Expression:=Copy(Str1,1,Length(Str1));
           end;
end
else
if  (VC1 = _Const) and (code2 <> _NOT_FOUND) then      // IRoot(const,IntForm)
begin

         ND1.AI:=1;
         ND1.FD:=FD1;
         EOFN:=True;
         ND1.N:=0;
         ND1.TypeF:=T_Real;
         ND1.COP:=_FUNC;
         ND1.NFunc:=CM_IROOT;
         SetLength(LV1,0);
end;
end //of len = 2
else
if Len = 3 then        //root(z1,j+2,n+k)
begin
   Str1:=LV[0].Expression;
   Str2:=LV[1].Expression;
   Str3:=LV[2].Expression;

   DeleteExternalBracketPS(@Str1);
   DeleteExternalBracketPS(@Str2);
   DeleteExternalBracketPS(@Str3);

  WriteFindExtArgInt2PS(@Str2,@Str3,ND1,ND1,BAnsw);
  if BAnsw = True then
  begin
         ND1.AI:=3;
         ND1.NFunc:=CM_IROOT;
         EOFN:=False;
         ND1.N:=1;
         ND1.COP:=_FUNC;
         SetLength(LV1,1);
         LV1[0].Expression:=Copy(Str1,1,Length(Str1));
         LV1[0].NL:=1;
  end;

end;





endp:
TryCatchFPUException;    {.229}
end;






procedure TForevalH.IFAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode);

    function _CheckIFFArg(PS: PString; DisSet: TSetChar): Boolean;
    label endp;
    var
    j,br1,br2: integer;
    BE: boolean;
    begin

       BE:=True;
       br1:=0; br2:=0;
       for j := 1 to Length(PS^) do
       begin
        if PS^[j] in OpenBracket  then inc(br1)
        else
        if PS^[j] in CloseBracket then inc(br2)
        else
        if (br1 = br2)   then
        begin
           if  PS^[j] in DisSet {(PS^[j] = ';') or  (PS^[j] = '=')}   then
           begin
              BE:=False;
              F_SyntaxErrorCode:=E_NO_FUNCTION_ARGUMENT;
              F_SyntaxErrorString:=PS^+'   in:  '+F_CurrentString;
              goto endp;
           end;
        end
       end;

    endp:
    _CheckIFFArg:=BE;
    end;



label 1,endp;
var
C: TFloat;
br,cif,tif: Integer;
i,P,L: Integer;
nf: Integer;
FD1,FD2: extended;
Str,Str1,Str2,Expr: String;
adr: Cardinal;
code1,code2,nv1,nv2,ic1,ic2: Integer;
AIVP1,AIVP2: TArrayIntVarProd;
BAnsw: Boolean;
DisSet: TSetChar;
begin                                                                //tif: 7  4  3   2     5       6
//IF(Arg1 op Arg2, Arg3, Arg4)  => if Arg1 op Arg2 then Arg3 else Arg4  op: =, <, >, <>, <=, =<, >=, =>
//IF При разборе переходит в  IFNOP(Arg1,Arg2,CJMP,Arg3,JMP,ARG4)

//IF(Arg1 op Arg2)  = 1 или 0(если if не выполняется)  op: =, <, >, <=, =<, >=, =>
//IF При разборе переходит в  IFNOP(Arg1,Arg2,CJMP,FLD1,JMP,FLDZ)

//IF(Arg1 op Arg2, Arg3)  = Arg3(если if  выполняется) или 0(если if не выполняется)  op: =, <, >, <=, =<, >=, =>
//IF При разборе переходит в  IFNOP(Arg1,Arg2,CJMP,ARG3,JMP,FLDZ)


if F_SyntaxErrorCode <> 0 then goto endp;

LV1:=LV;
ND1:=ND;
L:=Length(LV);

 {.346}
if L = 1 then
begin
 DisSet := [';'];
  if _CheckIFFArg(@LV[0].Expression,DisSet) = false then goto endp;
end
else
if L = 2 then
begin
   DisSet := [';','='];
   if _CheckIFFArg(@LV[1].Expression,DisSet) = false then goto endp;
end
else
if L = 3 then
begin
   DisSet := [';','='];
   if _CheckIFFArg(@LV[1].Expression,DisSet) = false then goto endp;
   if _CheckIFFArg(@LV[2].Expression,DisSet) = false then goto endp;
end;

  {
if(x>=y,x=x-1)
if(x>=y,cos(x);sin(x))
if(x>=y,cos(x),x=x-1)
Во 2м 3м арг не должно быть ; =
if Len then

  }



if ((L <> 3) and (L <> 1) and (L <> 2)) then
begin
  F_SyntaxErrorCode:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
  F_SyntaxErrorString:=F_CurrentString;
  goto endp;
end;

//nf= 1       2      3       4      5      6     7
//  #JMP, #JMPE, #JMPEL, #JMPEB, #JMPB, #JMPL, #JMPNE

br:=0;  nf:=0;    ND1.BI:=_FloatArg;  ND1.CI:=0; ND1.DI:=0;
Str:=LV[0].Expression;
//FindExternalBracket(Str,Str);
DeleteExternalBracketPS(@Str); {.219}

for i := 1 to Length(Str) do
begin
 if (Str[i] = '(') or (Str[i] = '[') or (Str[i] = '{') then  br:=br+1 else
 if (Str[i] = ')') or (Str[i] = ']') or (Str[i] = '}') then  br:=br-1;

 if br = 0 then
 begin
   //>= , =>
   if ((Str[i] = '>') and (Str[i+1] = '=')) or ((Str[i] = '=') and (Str[i+1] = '>')) then
   begin
     nf:=6;  Str1:=Copy(Str,1,i-1); Str2:=Copy(Str,i+2,Length(Str)-i);
     goto 1;
   end
   else
   //<=, =<
   if ((Str[i] = '<') and (Str[i+1] = '=')) or ((Str[i] = '=') and (Str[i+1] = '<')) then
   begin
     nf:=5; P:=i;  Str1:=Copy(Str,1,i-1); Str2:=Copy(Str,i+2,Length(Str)-i);
     goto 1;
   end
   else
   //<>
   if ((Str[i] = '<') and (Str[i+1] = '>')) then
   begin
     nf:=2; P:=i;  Str1:=Copy(Str,1,i-1); Str2:=Copy(Str,i+2,Length(Str)-i);
     goto 1;
   end
   else
   //><
   if ((Str[i] = '>') and (Str[i+1] = '<')) then
   begin
     nf:=2; P:=i;  Str1:=Copy(Str,1,i-1); Str2:=Copy(Str,i+2,Length(Str)-i);
     goto 1;
   end
   else
   // =
   if (Str[i] = '=') then
   begin
     nf:=7;  P:=i;    Str1:=Copy(Str,1,i-1); Str2:=Copy(Str,i+1,Length(Str)-i);
     goto 1;
   end
   else
   // >
   if (Str[i] = '>') then
   begin
     nf:=3; P:=i;    Str1:=Copy(Str,1,i-1); Str2:=Copy(Str,i+1,Length(Str)-i);
     goto 1;
   end
   else
   // <
   if (Str[i] = '<') then
   begin
     nf:=4; P:=i;   Str1:=Copy(Str,1,i-1); Str2:=Copy(Str,i+1,Length(Str)-i);
     goto 1;
   end
 end;
end;


1:
if (nf = 0) and (L = 3) then
begin
  nf:=3; Str1:=Str; Str2:='0';
end
else
if (nf = 0) and (L = 1) then
begin
  nf:=3; Str1:=Str; Str2:='0';
end
else
if (nf = 0) and (L = 2) then            //if(arg1,arg2) ->  if(arg1 > 0,arg2)
begin
  nf:=3; Str1:=Str; Str2:='0';
end
else
if nf = 0 then
begin
  F_SyntaxErrorCode:=5;
  goto endp;
end;


{
   2: LV1[2].Expression:='#JMPE';
   3: LV1[2].Expression:='#JMPEL';
   4: LV1[2].Expression:='#JMPEB';
   5: LV1[2].Expression:='#JMPB';
   6: LV1[2].Expression:='#JMPL';
   7: LV1[2].Expression:='#JMPNE';
}

{F_IntegerOptimization}
  //---------------------------------------------------------
 WriteFindExtArgInt2PS(@Str1,@Str2,ND1,ND1,BAnsw);
{
FindExtArgInt(@Str1, code1, AIVP1, NV1, IC1);
FindExtArgInt(@Str2, code2, AIVP2, NV2, IC2);
if (code1 <> _NOT_FOUND) and (code2 <> _NOT_FOUND) then
begin
          if code1 = _IntConst then
          begin
            ND1.IC1:=IC1;
          end
          else
          if code1 = _IntVar then
          begin
            ND1.NV1:=NV1;
          end
          else
          if code1 = _IntForm then
          begin
            ND1.AIVP1:=Copy(AIVP1,0,Length(AIVP1));
            ND1.IC1:=IC1;
          end ;

           if code2 = _IntConst then
          begin
            ND1.IC2:=IC2;
          end
          else
          if code2 = _IntVar then
          begin
            ND1.NV2:=NV2;
          end
          else
          if code2 = _IntForm then
          begin
            ND1.AIVP2:=Copy(AIVP2,0,Length(AIVP2));
            ND1.IC2:=IC2;
          end ;

          ND1.TA1:=code1;
          ND1.TA2:=code2;
          ND1.BI:=_IntArg;
end;
}


    //---------------------------------------------------------

if L = 2 then         //IF(Arg1 op Arg2, Arg3) -> IFNOP(Arg1,Arg2,CJMP,ARG3,JMP,FLDZ)
begin
 //P:=Pos('goto(',lowercase(LV[1].Expression));
 P:=Pos('goto(',LV[1].Expression);
  if P > 0 then                  //IF(Arg1 op Arg2,goto(lab))
 begin
  SetLength(LV1,4);
     //IFNOP(Arg1,Arg2,CJMP,JMP)

  LV1[0].Expression:=Copy(Str1,1,Length(Str1));
  LV1[1].Expression:=Copy(Str2,1,Length(Str2));
  case nf of
   2: LV1[2].Expression:='#jmpe';
   3: LV1[2].Expression:='#jmpel';
   4: LV1[2].Expression:='#jmpeb';
   5: LV1[2].Expression:='#jmpb';
   6: LV1[2].Expression:='#jmpl';
   7: LV1[2].Expression:='#jmpne';
 end;
 LV1[3].Expression:=Copy(LV[1].Expression,1,Length(LV[1].Expression));
 //LV1[3].Expression:='#JMP';
 //LV1[5].Expression:='#FLDZ';


   ND1.N:=4;
   ND1.DI:=ND1.N;
   ND1.CI:=_FloatArg;
   ND1.COP:=_FUNC;
   ND1.NFunc:=CM_IF;

   cif:=3;  {.301}
   goto endp;
 end;

end;



SetLength(LV1,6);


if L = 3 then    //IF(Arg1 op Arg2, Arg3, Arg4) -> IFNOP(Arg1,Arg2,CJMP,Arg3,JMP,ARG4)
begin
 LV1[0].Expression:=Copy(Str1,1,Length(Str1));
 LV1[1].Expression:=Copy(Str2,1,Length(Str2));
 case nf of
   2: LV1[2].Expression:='#jmpe';
   3: LV1[2].Expression:='#jmpel';
   4: LV1[2].Expression:='#jmpeb';
   5: LV1[2].Expression:='#jmpb';
   6: LV1[2].Expression:='#jmpl';
   7: LV1[2].Expression:='#jmpne';
 end;
 LV1[3].Expression:=Copy(LV[1].Expression,1,Length(LV[1].Expression));
 LV1[4].Expression:='#jmp';
 LV1[5].Expression:=Copy(LV[2].Expression,1,Length(LV[2].Expression));

 cif:=2;  {.301}
end
else
if L = 1 then     // IF(Arg1 op Arg2) -> IFNOP(Arg1,Arg2,CJMP,FLD1,JMP,FLDZ)
begin
 LV1[0].Expression:=Copy(Str1,1,Length(Str1));
 LV1[1].Expression:=Copy(Str2,1,Length(Str2));
 case nf of
   2: LV1[2].Expression:='#jmpe';
   3: LV1[2].Expression:='#jmpel';
   4: LV1[2].Expression:='#jmpeb';
   5: LV1[2].Expression:='#jmpb';
   6: LV1[2].Expression:='#jmpl';
   7: LV1[2].Expression:='#jmpne';
 end;
 LV1[3].Expression:='#fld1';
 LV1[4].Expression:='#jmp';
 LV1[5].Expression:='#fldz';

 cif:=0;    {.301}
end
else
if L = 2 then      //IFNOP(Arg1,Arg2,CJMP,ARG3,JMP,FLDZ)
begin
  LV1[0].Expression:=Copy(Str1,1,Length(Str1));
  LV1[1].Expression:=Copy(Str2,1,Length(Str2));
  case nf of
   2: LV1[2].Expression:='#jmpe';
   3: LV1[2].Expression:='#jmpel';
   4: LV1[2].Expression:='#jmpeb';
   5: LV1[2].Expression:='#jmpb';
   6: LV1[2].Expression:='#jmpl';
   7: LV1[2].Expression:='#jmpne';
 end;
 LV1[3].Expression:=Copy(LV[1].Expression,1,Length(LV[1].Expression));
 LV1[4].Expression:='#jmp';
 LV1[5].Expression:='#fldz';

 cif:=1;  {.301}
end;


ND1.N:=6;
ND1.DI:=ND1.N;
ND1.CI:=_FloatArg;
ND1.COP:=_FUNC;
ND1.NFunc:=CM_IF;

endp:
//ND1.SFunc:='if'; {.301}
ND1.cif:=cif;
ND1.tif:=nf;
if ND1.BI = _IntArg  then      //BAnsw = True
begin
     LV1[0].Expression:=SCvoid;
     LV1[1].Expression:=SCvoid;
end;
end;





procedure TForevalH.SWAPIFAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);

label 1,endp;
var
C: TFloat;
br,cif,tif: Integer;
i,P,L: Integer;
nf: Integer;
FD1,FD2: extended;
Str,Str1,Str2,Expr: String;
adr: Cardinal;
code1,code2,nv1,nv2,ic1,ic2: Integer;
AIVP1,AIVP2: TArrayIntVarProd;
BAnsw: Boolean;
DisSet: TSetChar;
begin                                                                //tif: 7  4  3   2     5       6
//IF(Arg1 op Arg2, Arg3, Arg4)  => if Arg1 op Arg2 then Arg3 else Arg4  op: =, <, >, <>, <=, =<, >=, =>
//IF При разборе переходит в  IFNOP(Arg1,Arg2,CJMP,Arg3,JMP,ARG4)

//IF(Arg1 op Arg2)  = 1 или 0(если if не выполняется)  op: =, <, >, <=, =<, >=, =>
//IF При разборе переходит в  IFNOP(Arg1,Arg2,CJMP,FLD1,JMP,FLDZ)

//IF(Arg1 op Arg2, Arg3)  = Arg3(если if  выполняется) или 0(если if не выполняется)  op: =, <, >, <=, =<, >=, =>
//IF При разборе переходит в  IFNOP(Arg1,Arg2,CJMP,ARG3,JMP,FLDZ)


if F_SyntaxErrorCode <> 0 then goto endp;

LV1:=LV;
ND1:=ND;
L:=Length(LV);




if (L <> 1)  then
begin
  F_SyntaxErrorCode:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
  F_SyntaxErrorString:=F_CurrentString;
  goto endp;
end;


br:=0;  nf:=0;    ND1.BI:=_FloatArg;  ND1.CI:=0; ND1.DI:=0;
Str:=LV[0].Expression;
//FindExternalBracket(Str,Str);
DeleteExternalBracketPS(@Str); {.219}

//SWAPIF(Arg1 > Arg2);
//SWAPIF(Arg1 <> Arg2) ;

for i := 1 to Length(Str) do
begin
 if (Str[i] = '(') or (Str[i] = '[') or (Str[i] = '{') then  br:=br+1 else
 if (Str[i] = ')') or (Str[i] = ']') or (Str[i] = '}') then  br:=br-1;

 if br = 0 then
 begin
   //>= , =>
   if ((Str[i] = '>') and (Str[i+1] = '=')) or ((Str[i] = '=') and (Str[i+1] = '>')) then
   begin
     Str1:=Copy(Str,1,i-1); Str2:=Copy(Str,i+2,Length(Str)-i);
     //nf:=6;
     nf:=3;
     goto 1;
   end
   else
   //<=, =<
   if ((Str[i] = '<') and (Str[i+1] = '=')) or ((Str[i] = '=') and (Str[i+1] = '<')) then
   begin
     Str1:=Copy(Str,1,i-1); Str2:=Copy(Str,i+2,Length(Str)-i);
     //Str2:=Copy(Str,1,i-1); Str1:=Copy(Str,i+2,Length(Str)-i);
     //nf:=5;
     nf:=4;
     P:=i;
     goto 1;
   end
   else
   //<>
   if ((Str[i] = '<') and (Str[i+1] = '>')) then
   begin
     nf:=2; P:=i;  Str1:=Copy(Str,1,i-1); Str2:=Copy(Str,i+2,Length(Str)-i);
     goto 1;
   end
   else
   //><
   if ((Str[i] = '>') and (Str[i+1] = '<')) then
   begin
     nf:=2; P:=i;  Str1:=Copy(Str,1,i-1); Str2:=Copy(Str,i+2,Length(Str)-i);
     goto 1;
   end
   else
   // =
   if (Str[i] = '=') then
   begin
     nf:=7;  P:=i;    Str1:=Copy(Str,1,i-1); Str2:=Copy(Str,i+1,Length(Str)-i);
     goto 1;
   end
   else
   // >
   if (Str[i] = '>') then
   begin
     nf:=3;
     P:=i;
     Str1:=Copy(Str,1,i-1); Str2:=Copy(Str,i+1,Length(Str)-i);
     goto 1;
   end
   else
   // <
   if (Str[i] = '<') then
   begin
     nf:=4;
     //nf:=3;
     P:=i;
     Str1:=Copy(Str,1,i-1); Str2:=Copy(Str,i+1,Length(Str)-i);
     //Str2:=Copy(Str,1,i-1); Str1:=Copy(Str,i+1,Length(Str)-i);
     goto 1;
   end
 end;
end;


if nf = 0 then
begin
  F_SyntaxErrorCode:=5;
  goto endp;
end;



  1:

 SetLength(LV1,2);
 LV1[0].Expression:=Copy(Str1,1,Length(Str1));
 LV1[1].Expression:=Copy(Str2,1,Length(Str2));
 ND1.N:=2;

 SWAPAnalizator(LV1,ND1,LV1,ND1,EOFN);

 if ND1.AI = 3 then      //swapif(ComplexVar1 <=> ComplexVar2)
 begin
   F_SyntaxErrorCode:=E_WRONG_TYPE;
   goto endp;
 end;

 ND1.NFunc:=CM_SWAPIF;
 ND1.COP:=_FUNC;
 ND1.tif:=nf;

endp:
end;







procedure TForevalH.SAVEAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
label 1,3,endp,endc;
var
C: TFloat;
TF,TF2: Integer;
i,P,L,tv1,tm1,LenV,TV,MType2,ni2,nf2,tv2,tm2,TypeF, MType, ReIm,ImU,TypeAddr: Integer;
nf,ni,SB,NFunc,TypeV, TypeIndx: Integer;
FD1,FD2,Re,Im: extended;
Str,Str1,Str2,Str3,S1,S2,S3,Sv2,Sa2,Sf,Sa,Sindx: String;
adr,adr1,AddrObj,AddrIM,addr2: Cardinal;
BAnsw,BSavePtr,BFH: Boolean;
NDA: TDataNode;
begin



{int=@Func; int=@var; VecInt[]=@Func; VecInt[]=@var}  //  ***** {.347}


  EOFN:=False;
  ND1.AI:=0;

if F_SyntaxErrorCode <> 0 then goto endp;

LenV:=Length(LV);

LV1:=LV;
ND1:=ND;

if (LenV <> 2) and (LenV <> 3) then
begin
      F_SyntaxErrorCode:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
      F_SyntaxErrorString:=F_CurrentString;
      goto endp;
end;

SetLength(LV1,1);
Str1:=LV[0].Expression;
Str2:=LV[1].Expression;
LV1[0].Expression:=Copy(Str2,1,Length(Str2));

FindReIm(Str1,S1,TF);
//FindVar(S1,nf);
FindVarPS(@S1,nf);        {.333}
if nf <> -1 then  GetVar1(nf,adr1,tv1,tm1);




//Save(Var,Expr)
if (nf <> -1) and (tv1 <> IM_UNIT) and (LenV = 2) and (tv1 <> T_Array) then
begin

 BAnsw:=False;
 if (tv1 = T_Real) and (tm1 = _Integer) then WriteFindExtArgInt1PS(@Str2, _First, ND1,ND1,BAnsw);    //save(IntVar,IntForm)
 if BAnsw = True then
 begin
   ND1.AI:=3;
   SetLength(LV1,0);
   ND1.NObj:=nf;
   ND1.N:=0;
   EOFN:=True;
   goto endc;

   //ND2.IC1
 end
 else
 begin


   // <...> = addr() ; ptr = @<...>;  ptr = addr(<...>)  ;

    {
       Save(Addr):
           Save(PointerVar,@<Var,Array,Func>)  PointerVar = @<Var,Array,Func>
           Save(IntVar,@<Var,Array,Func>)      IntVar = @<Var,Array,Func>
    }

    BSavePtr:=False;
    if   (Str2[1] = '@') and (Alg.Opr[COP_ADDR].Enable = True) then    // = @<...>
    begin
         S2:=Str2;
         Delete(S2,1,1);
         BSavePtr:=True;
    end
    else   // = Addr<...>
    begin
        FindFuncBrPS(@Str2,'(',')',Sf,Sa,BFH);
        if BFH = True then
        begin
           if (Alg.ExFunc[CM_ADDR].Name = Sf) and (Alg.ExFunc[CM_ADDR].Enable = _Yes) then
           begin
              S2:=Sa;
              BSavePtr:=True;
           end;
        end;
    end;


    if BSavePtr = True then
    begin

        if (tv1 = T_Pointer) or ((tv1 = T_Real) and (tm1 = _Integer) and (F_EnableUseIntegerPointer = True))  then        {.353}
        begin

           //Find Data Addr

           FindVarExPS(@S2, nf2, AddrObj, AddrIM, TypeF, MType, ReIm,ImU);
           if nf2 <> -1 then
           begin
              if ReIm = _IM then AddrObj:=AddrIM;
              case TypeF of
                 T_Real:       TypeAddr:=_AddrVar;
                 T_Complex:    TypeAddr:=_AddrVar;
                 T_Array:      TypeAddr:=_AddrArray;
                 T_Pointer:    TypeAddr:=_AddrVar;
              end;
           end
           else   //@Function
           begin
              FindFuncPS(@S2,NFunc);
              if NFunc <> _NOT_FOUND then
              begin
                 AddrObj:=Alg.ExFunc[NFunc].Func[0].Addr;
                 TypeAddr:=_AddrFunc;
              end
              else
              if FindArray(@S2, NDA, ni, TypeV, TypeIndx, AddrObj, Sindx) = True then
              begin
                   TypeAddr:=_AddrArrayElem;
                   //ND1.CI:=TypeAddr;
                   //ND1.Addr1:=AddrObj;
                   ND1.NObj2:=ni;

                   {
                   EOFN:=True;
                   ND1.N:=0;
                   SetLength(LV1,0);
                   }
                   ND1.DI:=NDA.AI; //тип аргумента массива в DI !!
                   ND1.AIVP1:=Copy(NDA.AIVP1,0,Length(NDA.AIVP1));
                   ND1.FD:=NDA.FD; //константа аргумента массива @vec[IntConst]
                   ND1.NV2:=NDA.NV1; //переменная аргумента массива @vec[Intconst]

                   if TypeIndx = _Stack then
                   begin
                    EOFN:=False;
                    ND1.N:=1;
                    SetLength(LV1,1);
                    LV1[0].Expression:=Sindx;
                    ND1.DI:=0;
                   end;
              end
              else
              begin
                 F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
                 F_SyntaxErrorString:=Copy(F_CurrentString,1,Length(F_CurrentString));
                 F_SyntaxErrorStringA:=Copy(Str2,1,Length(Str2));
                 goto endp;
              end;
           end;


          ND1.AI:=10;         //Save  Addr
          ND1.NObj:=nf;       //PointerVar, IntVar
          ND1.Addr1:=AddrObj; //Addr
          ND1.BI:=_IntVar;     //Save  Addr -> PointerVar, IntVar
          ND1.CI:=TypeAddr;
          if  (TypeIndx <> _Stack) then   //@var,@vec,@func,@vec[IntForm]
          begin
             ND1.N:=0;
             SetLength(LV1,0);
             EOFN:=True;
          end;

          goto endc;

      end
      else
      begin
          F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
          F_SyntaxErrorString:=Copy(F_CurrentString,1,Length(F_CurrentString));
          F_SyntaxErrorStringA:=Copy(Str2,1,Length(Str2));
          goto endp;
      end;

    end     //BSavePtr = True
    else
    begin           //все остальные присвоения
                    //IntVar,RealVar,ComplexVar =  <IntExpr,RealExpr,ComplexExpr>  в любом сочетании
                    //PointerVar = <PointerVar,IntVar>
                    //IntVar = <PointerVar,IntVar>

          //IntVar = PointerVar
         if (tv1 = T_Real) and (tm1 = _Integer) and (F_EnableUseIntegerPointer = True) then
         begin
            FindVarAPS(@Str2,nf2,Addr2,tv2,tm2);
            if tv2 = T_Pointer then           //j=ptr1
            begin
               ND1.TA1:=_IntVar;
               ND1.AI:=3;
               ND1.NObj:=nf;
               ND1.NV1:=nf2;
               SetLength(LV1,0);
               ND1.N:=0;
               EOFN:=True;
               goto endc;
            end;
         end
         else
         // PointerVar =  <PointerVar, IntVar>
         if (tv1 = T_Pointer) then
         begin
             FindVarAPS(@Str2,nf2,Addr2,tv2,tm2);
             //PointerVar = PointerVar
             if tv2 = T_Pointer then
             begin
                ND1.TA1:=_IntVar;
                ND1.AI:=3;
                ND1.NObj:=nf;
                ND1.NV1:=nf2;
                SetLength(LV1,0);
                ND1.N:=0;
                EOFN:=True;
                goto endc;
             end
             else
              // PointerVar =   IntVar
             if (tv2 = T_Real) and (tm2 = _Integer) and (F_EnableUseIntegerPointer = True) then
             begin
                ND1.TA1:=_IntVar;
                ND1.AI:=3;
                ND1.NObj:=nf;
                ND1.NV1:=nf2;
                SetLength(LV1,0);
                ND1.N:=0;
                EOFN:=True;
                goto endc;
             end;
         end;

         //IntVar,RealVar,ComplexVar =  <IntExpr,RealExpr,ComplexExpr>  в любом сочетании
         ND1.NObj:=nf;
         ND1.TS:=TF;
         ND1.N:=1;
         ND1.AI:=1;
         goto endc;
    end;

    (*
    if   (Str2[1] = '@') then    //Save(Addr)
    begin

      if (tv1 = T_Pointer) or ((tv1 = T_Real) and (tm1 = _Integer) and (F_EnableUseIntegerPointer = True))  then        {.353}
      begin

         //Find Data Addr
         S2:=Str2;
         Delete(S2,1,1);
         //FindReIm(S2,S2,TF2);
         //FindVarPS(@S2,nf2);
         FindVarExPS(@S2, nf2, AddrObj, AddrIM, TypeF, MType, ReIm,ImU);
         if nf2 <> -1 then
         begin
            if ReIm = _IM then AddrObj:=AddrIM;
            case TypeF of
               T_Real:     TypeAddr:=_AddrVar;
               T_Complex:  TypeAddr:=_AddrVar;
               T_Array:    TypeAddr:=_AddrArray;
            end;
         end
         else
         begin
             FindFuncPS(@S2,NFunc);
             if NFunc <> _NOT_FOUND then
             begin
               AddrObj:=Alg.ExFunc[NFunc].Func[0].Addr;
               TypeAddr:=_AddrFunc;
             end
             else
             begin
                 F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
                 F_SyntaxErrorString:=Copy(F_CurrentString,1,Length(F_CurrentString));
                 F_SyntaxErrorStringA:=Copy(Str2,1,Length(Str2));
                 goto endp;
             end;
         end;


        ND1.AI:=10;         //Save  Addr
        SetLength(LV1,0);
        ND1.NObj:=nf;       //PointVar, IntVar
        ND1.N:=0;
        ND1.Addr1:=AddrObj; //Addr
        ND1.BI:=_IntVar;     //Save  Addr -> PointVar, IntVar
        ND1.CI:=TypeAddr;

        EOFN:=True;

        goto endc;

      end
      else
      begin
                 F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
                 F_SyntaxErrorString:=Copy(F_CurrentString,1,Length(F_CurrentString));
                 F_SyntaxErrorStringA:=Copy(Str1,1,Length(Str1));
                 goto endp;
      end;
    end    //Save(Addr)

    else
    begin

      {
       //IntVar = Array
       FindVarAPS(@Str2,nf2,AddrObj,tv2,tm2);
       if (tv1 = T_Real) and (tm1 = _Integer) and (tv2 = T_Array )  then   //IntVar = Array
       begin
          ND1.AI:=10;         //Save  Addr
          SetLength(LV1,0);
          ND1.NObj:=nf;       //IntVar
          ND1.N:=0;
          ND1.Addr1:=AddrObj; //Addr
          ND1.BI:=_IntVar;     //Save  Addr -> IntVar
          ND1.CI:=_Array;

          EOFN:=True;
          if (F_EnableUseIntegerPointer = False) or (F_EnableUsePointer = False) then
          begin
                 F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
                 F_SyntaxErrorString:=Copy(F_CurrentString,1,Length(F_CurrentString));
                 F_SyntaxErrorStringA:=Copy(Str2,1,Length(Str2));
                 goto endp;
          end;
          goto endc;

       end
       else
       }

       begin           //все остальные присвоения IntVar,RealVar,ComplexVar =  <IntExpr,RealExpr,ComplexExpr>  в любом сочетании
         ND1.NObj:=nf;
         ND1.TS:=TF;
         ND1.N:=1;
         ND1.AI:=1;
         goto endc;
       end

    end

    *)




 end;

end
else
begin
 if tv1 =  IM_UNIT then
 begin
    F_SyntaxErrorCode:=14;// else F_SyntaxErrorCode:=1;
    F_SyntaxErrorString:=S1;
    goto endp;
 end;

end;






//array: save(array,index,expr)
if LenV = 3 then  //save(vd,n+1,x+1)
begin


    //vd[i]=vd[k];x
    //vd[i+1]=vd[k];x

    Str3:=LV[2].Expression;

    if Alg.Obj[nf].TypeF = T_Array then
    begin


    // vp[] = @<...>;  vp[] = addr(<...>)


         BSavePtr:=False;
         if   (Str3[1] = '@') and (Alg.Opr[COP_ADDR].Enable = True) then    //PointerArray[indx] = @<...> ,  IntArray[indx]= @<Var,Func,Array>
         begin
           S3:=Str3;
           Delete(S3,1,1);
           BSavePtr:=True;
         end
         else   // = Addr<...>            //PointerArray[indx] = addr<...> ,  IntArray[indx]= addr<Var,Func,Array>
         begin
             FindFuncBrPS(@Str3,'(',')',Sf,Sa,BFH);
             if BFH = True then
             begin
                if (Alg.ExFunc[CM_ADDR].Name = Sf) and (Alg.ExFunc[CM_ADDR].Enable = _Yes) then
                begin
                   S3:=Sa;
                   BSavePtr:=True;
                end;
             end;
         end;


         if BSavePtr = True then
         begin

             tv1:=Alg.Obj[nf].TypeF;
             tm1:=Alg.Obj[nf].MType;

             //Save(PointerArray[],AddrOf <Var,Array,Func>)
             //Save(IntArray[],AddrOf <Var,Array,Func>)
             if ((tv1 = T_Array) and (tm1 = _Pointer)) or ((tv1 = T_Array) and (tm1 = _Integer) and (F_EnableUseIntegerPointer = True))  then
             begin

               //Find Addr Data
                S3:=Str3;
                Delete(S3,1,1);
                FindVarExPS(@S3, nf2, AddrObj, AddrIM, TypeF, MType, ReIm,ImU);
                if nf2 <> -1 then
                begin
                  if ReIm = _IM then AddrObj:=AddrIM;
                  case TypeF of
                     T_Real:     TypeAddr:=_AddrVar;
                     T_Complex:  TypeAddr:=_AddrVar;
                     T_Array:    TypeAddr:=_AddrArray;
                  end;
                end
                else
                begin
                  FindFuncPS(@S3,NFunc);
                  if NFunc <> _NOT_FOUND then
                  begin
                     AddrObj:=Alg.ExFunc[NFunc].Func[0].Addr;
                     TypeAddr:=_AddrFunc;
                  end
                  else
                  begin
                     F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
                     F_SyntaxErrorString:=Copy(F_CurrentString,1,Length(F_CurrentString));
                     F_SyntaxErrorStringA:=Copy(Str3,1,Length(Str3));
                     goto endp;
                  end;
                end;

                //Find PointerArray[] Data
                WriteFindExtArgInt1PS(@Str2, _First, ND1,ND1,BAnsw);
                if BAnsw = True then    //PointerArray[IntForm] = @<  >
                begin
                  SetLength(LV1,0);
                  ND1.N:=0;
                  EOFN:=True;
                end
                else
                begin      //PointerArray[Expr] = @<  >
                  SetLength(LV1,1);
                  ND1.N:=1;
                  EOFN:=False;
                end;


                ND1.AI:=10;         //Save  Addr
                ND1.NObj:=nf;       //PointerArray[]
                ND1.Addr1:=AddrObj; //Addr
                ND1.BI:=_IntArray;  //Save  AddrObj -> PointerArray[]
                ND1.CI:=TypeAddr;

                goto endc;
                {if (F_EnableUseIntegerPointer = False) or (F_EnableUsePointer = False) then
                begin
                   F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
                   F_SyntaxErrorString:=Copy(F_CurrentString,1,Length(F_CurrentString));
                   F_SyntaxErrorStringA:=Copy(Str3,1,Length(Str3));
                   goto endp;
                end;}


             end   //PointerArray[]=@<...> ; IntArray[]=@<...>
             else
             begin
                   F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
                   F_SyntaxErrorString:=Copy(F_CurrentString,1,Length(F_CurrentString));
                   F_SyntaxErrorStringA:=Copy(Str3,1,Length(Str3));
                   goto endp;
             end;

           (*else
           begin


                //IntArray[] = Array
               FindVarAPS(@Str3,nf2,AddrObj,tv2,tm2);
               if (tv2 = T_Array )     then   //IntArray[] = Array
               begin

                   //Find IntArray[] Data
                   WriteFindExtArgInt1PS(@Str2, _First, ND1,ND1,BAnsw);
                   if BAnsw = True then    //IntArray[IntForm] = Array
                   begin
                     SetLength(LV1,0);
                     ND1.N:=0;
                     EOFN:=True;
                   end
                   else
                   begin      //IntArray[Expr] = Array
                      SetLength(LV1,1);
                      ND1.N:=1;
                      EOFN:=False;
                   end;

                   ND1.AI:=10;         //Save  Addr
                   ND1.NObj:=nf;       //IntArray[]
                   ND1.N:=0;
                   ND1.Addr1:=AddrObj; //Addr Array
                   ND1.BI:=_IntArray;  //Save  Addr -> IntArray[]
                   ND1.CI:=_Array;     //Save Array

                   if (F_EnableUseIntegerPointer = False) or (F_EnableUsePointer = False) then
                   begin
                      F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
                      F_SyntaxErrorString:=Copy(F_CurrentString,1,Length(F_CurrentString));
                      F_SyntaxErrorStringA:=Copy(Str3,1,Length(Str3));
                      goto endp;
                  end;
                  goto endc;
               end
               else
               begin
                  //goto arrays;
               end;
               *)

         end;  //BSavePtr = True




      //arrays:
      WriteFindExtArgInt1PS(@Str2, _First, ND1,ND1,BAnsw);
      if BAnsw = True then            //vec[IntForm]=Expr
      begin
          if  Alg.Obj[nf].MType  = _Integer then            //VecI[IntForm1]=IntForm2
          begin
            Str3:=LV[2].Expression;
            WriteFindExtArgInt1PS(@Str3, _Second, ND1,ND1,BAnsw);
            if BAnsw = True then
            begin
              ND1.AI:=4;
              SetLength(LV1,0);
              ND1.NObj:=nf;
              ND1.N:=0;
              EOFN:=True;
            end
            else
            begin
                   //VecInt1[IntForm1]=VecInt2[IntForm2] ;
           {.347} if FindExtractArray(@Str3, Sv2,Sa2, MType2, ni2) = True then
                  begin
                     if  (MType2 = _Integer) then
                     begin //IntArray[]=IntArray[]
                       WriteFindExtArgInt1PS(@Sa2, _second,   ND1,   ND1,  BAnsw);
                       if BAnsw = True then    //IntArray[IntForm1]=IntArray[IntForm2]
                       begin
                          ND1.AI:=5;
                          SetLength(LV1,0);
                          ND1.NObj2:=ni2;
                          ND1.N:=0;
                          ND1.NObj:=nf;
                          EOFN:=True;
                       end
                       else      //IntArray[IntForm1]=IntArray[Expr]
                       begin
                         ND1.AI:=4;
                         SetLength(LV1,1);
                         LV1[0].Expression:=Copy(Str3,1,Length(Str3));
                         ND1.NObj:=nf;
                         ND1.N:=1;
                         EOFN:=False;
                       end;
                     end
                     else     //IntArray[]=FloatArray[]
                     begin
                        ND1.AI:=4;
                        SetLength(LV1,1);
                        LV1[0].Expression:=Copy(Str3,1,Length(Str3));
                        ND1.NObj:=nf;
                        ND1.N:=1;
                        EOFN:=False;
                     end;
                  end
                  else     //IntArray[intform]=Expr
                  begin
                    ND1.AI:=4;
                    SetLength(LV1,1);
                    LV1[0].Expression:=Copy(Str3,1,Length(Str3));
                    ND1.NObj:=nf;
                    ND1.N:=1;
                    EOFN:=False;
                  end;
            end;
          end
          else
          begin
            ND1.AI:=4;
            SetLength(LV1,1);
            LV1[0].Expression:=Copy(Str3,1,Length(Str3));
            ND1.NObj:=nf;
            ND1.N:=1;
            EOFN:=False;
          end;
         // goto 3;
      end
      else
      begin       //vec[Expr1]=Expr2
          3:
          ND1.AI:=2; //vec
          //FindVar(Str2,ni);
          FindVarPS(@Str2,ni); {.333}
          ND1.CI:=0;
          ND1.NObj:=nf;

      if ni <> -1 then    //ni - vector's arg: Vec[var]
      begin
        if (Alg.Obj[ni].TypeF = T_Real) and (Alg.Obj[ni].MType = _Integer) then   //vec[intvar]
        begin
         ND1.NV1:=ni;
         ND1.CI:=1;
         ND1.N:=1;
         SetLength(LV1,1);
         LV1[0].Expression:=Copy(Str3,1,Length(Str3));
        end
        else
        if (Alg.Obj[ni].TypeF = T_Real) then     //vec[realvar]->Vec[expr]
        begin
          SetLength(LV1,2);
          {
          LV1[0].Expression:=Copy(Str2,1,Length(Str2));
          Str3:=LV[2].Expression;
          LV1[1].Expression:=Copy(Str3,1,Length(Str3));
          }
            {.359}
          LV1[1].Expression:=Copy(Str2,1,Length(Str2));
          Str3:=LV[2].Expression;
          LV1[0].Expression:=Copy(Str3,1,Length(Str3));

          //LV1[0].NL:=LV[1].NL;   //LV1[0].idl:=LV[1].idl;
          //LV1[1].NL:=LV[2].NL;   //LV1[1].idl:=LV[2].idl;
          ND1.N:=2;
          ND1.AI:=2;
          ND1.CI:=0;
        end
        else
        begin    //type of arg <> real
          F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
          F_SyntaxErrorString:=Copy(F_CurrentString,1,Length(F_CurrentString));
          F_SyntaxErrorStringA:=Copy(Str2,1,Length(Str2));

          //F_SyntaxErrorCode:=9;
          //F_SyntaxErrorString:=Copy(Str2,1,Length(Str2));
          //F_SyntaxErrorString1:=Copy(Sa,1,Length(Sa));
          goto endp;
        end;
      end
      else
      begin
        //SubstParam(Str2,C,SB);
        //if SB = 1 then
        SubstParamPS(@Str2, Re, Im, TV);      //Vec[num]  must be trunc(num)=num!!!
        if TV = T_Real then
         begin
          if Trunc(Re) = Re then
          begin
           ND1.FD:=Re;
           ND1.CI:=2;
           ND1.N:=1;
           SetLength(LV1,1);
           LV1[0].Expression:=Copy(Str3,1,Length(Str3));
          end
          else
          begin      //vec[num]: 'num' must be integer
            //F_SyntaxErrorCode:=9;
            //F_SyntaxErrorString:=Copy(Str2,1,Length(Str2));
            F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
            F_SyntaxErrorString:=Copy(F_CurrentString,1,Length(F_CurrentString));
            F_SyntaxErrorStringA:=Copy(Str2,1,Length(Str2));
            //F_SyntaxErrorString1:=Copy(Sa,1,Length(Sa));
            goto endp;
          end;
         end
         else
         begin   //Vec[expr]
            SetLength(LV1,2);
           {
            LV1[0].Expression:=Copy(Str2,1,Length(Str2));
            Str3:=LV[2].Expression;
            LV1[1].Expression:=Copy(Str3,1,Length(Str3));
            }
            //LV1[0].NL:=LV[1].NL;   //LV1[0].idl:=LV[1].idl;
            //LV1[1].NL:=LV[2].NL;   //LV1[1].idl:=LV[2].idl;

            {.359}
            LV1[1].Expression:=Copy(Str2,1,Length(Str2));
            Str3:=LV[2].Expression;
            LV1[0].Expression:=Copy(Str3,1,Length(Str3));


            ND1.N:=2;
            ND1.AI:=2;
            ND1.CI:=0;
         end;
      end

      end;



    end
    else   //Vec <> T_Array
    begin                           {.365A}
      F_SyntaxErrorCode:=E_UNKNOWN_ARRAY;
      F_SyntaxErrorString:=Copy(Str1,1,Length(Str1));
      goto endp;
    end;







end;

{
if ((L <> 3) and (L <> 1) and (L <> 2)) then
begin
  F_SyntaxErrorCode:=4;
  goto endp;
end;
}

endc:
//ND1.N:=1;
ND1.COP:=_FUNC;
ND1.NFunc:=CM_SAVE;

endp:
end;













procedure TForevalH.GOTOAnalizator(LV: PLevel; ND: TDataNode; var LV1: PLevel; var ND1: TDataNode);
label endp;
var
ni,VT,nf,L: Integer;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

L:=Length(LV);
if L <> 1 then
begin
 F_SyntaxErrorCode:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
 F_SyntaxErrorString:=F_CurrentString;
 goto endp;
end;

 LV1:=LV;
 ND1:=ND;
 L:=0;
 F_GotoPresent:=True;

 {
 try
   L:=StrToInt(LV[0].Expression);
   ND1.N:=0;
   ND1.AI:=8;
   ND1.CI:=L;
 except
   //F_ErrorCode:=E_INCORRECT_ARGUMENT;
   F_SyntaxErrorCode:=1;
   F_SyntaxErrorString:=F_CurrentString;
   //F_SyntaxErrorString:=Copy(LV[0].Expression,1,Length(LV[0].Expression));
 end;
 }

 {.195}
 if TryStrToInt(LV[0].Expression,L) = true then
 begin
   //L:=StrToInt(LV[0].Expression);
   ND1.N:=0;
   ND1.AI:=8;
   ND1.CI:=L;
 end
 else
 begin
   F_SyntaxErrorCode:=1;
   F_SyntaxErrorString:=F_CurrentString;
 end;


 if L < 0 then
 begin
   //F_ErrorCode:=E_INCORRECT_ARGUMENT;
   F_SyntaxErrorCode:=1;
   F_SyntaxErrorString:=F_CurrentString;
   //F_SyntaxErrorString:=Copy(LV[0].Expression,1,Length(LV[0].Expression));
 end;
 {
 ND1.N:=1;
 ND1.COP:=_JMP;
 }

 ND1.COP:=_FUNC;
 ND1.NFunc:=CM_JMP;

endp:
end;






procedure TForevalH.IDAMAnalizator(LV: PLevel; ND: TDataNode; var LV1: PLevel; var ND1: TDataNode);
label endp;
var
ni,VT,nf,L: Integer;                     //inc,dec,add,mul
begin
if F_SyntaxErrorCode <> 0 then goto endp;

 LV1:=LV;
 ND1:=ND;

L:=Length(LV);
if L <> 1 then
begin
 F_SyntaxErrorCode:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
 F_SyntaxErrorString:=F_CurrentString;
 goto endp;
end;

  //FindVar(LV[0].Expression,ni);
  FindVarPS(@LV[0].Expression,ni); {.333}
  if ni  >= 0 then
  begin
   if Alg.Obj[ni].MType = _Integer then
   begin
    ND1.NV1:=ni;
    ND1.N:=0;
   end
   else
   begin
      //F_ErrorCode:=E_INCORRECT_ARGUMENT;
    F_SyntaxErrorCode:=14;
    F_SyntaxErrorString:=F_CurrentString;//Copy(LV[0].Expression,1,Length(LV[0].Expression));
   end;
  end
  else
  begin
     //F_ErrorCode:=E_INCORRECT_ARGUMENT;
   F_SyntaxErrorCode:=1;
   F_SyntaxErrorString:=F_CurrentString;//Copy(LV[0].Expression,1,Length(LV[0].Expression));
  end;




 ND1.COP:=_FUNC;
 //ND1.NFunc:=C_INC;
 endp:
end;







procedure TForevalH.SetLenAnalizator(LV: PLevel; ND: TDataNode; var LV1: PLevel; var ND1: TDataNode);
label endp;
var
ni,VT,nf,nm,L,nt,CnctType: Integer;
adrV: Cardinal;
SV: String;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

L:=Length(LV);
if L <> 2 then
begin
   F_SyntaxErrorCode:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
   F_SyntaxErrorString:=F_CurrentString;
  goto endp;
end;

 //LV1:=LV;
ND1:=ND;



VT:=0;



 //FindVar(LV[0].Expression,nm);
 FindVarPS(@LV[0].Expression,nm); {.333}

 if nm >= 0 then
 begin
   if (Alg.Obj[nm].TypeF = T_Array)  then
   begin
      VT:=Alg.Obj[nm].MType;
      CnctType:=Alg.Obj[nm].TypeCnct;

      //vd: ArrayExt=15; t=len(vd); setlen(vd,25); len(vd)+t
      //setlen(vd,25); len(vd)
      if (F_CheckArrayTypeConnect = True) and  (CnctType = _External) then
      begin
          F_SyntaxErrorCode:=E_NO_APPLICABLE_TO_EXTERNAL_ARRAY;
          F_SyntaxErrorString:=F_CurrentString;
          goto endp;
      end;
   end;
 end
 else
 begin
  (*
    {.353}
   //setlen(@vec,len)
   if F_EnableUsePointer = True then
   begin
      if LV[0].Expression[1] = '@' then
      begin
        SV:=LV[0].Expression;
        Delete(SV,1,1);
        FindVarPS(@SV,nm); {.333}

        if nm >= 0 then
        begin
         if (Alg.Obj[nm].TypeF = T_Array)  then
         begin
           VT:=Alg.Obj[nm].MType
         end;
        end
      end;
   end;
  *)
 end;

 //для остальных setlen(ptr,len)

       //не работает!   и не будет!
         //setlen(parrayd(@vd),rnd(1,10000)) ; len(vd)
         //ptr1=@vd; setlen(parrayd(ptr1),rnd(1,10000)) ; len(vd)

       //работает: (только через передачу адреса - @vec, а не массива - vec)!!!
         //setlen(arrayd(@vd),rnd(1,10000)); len(vd)
         //ptr1=@vd; setlen(arrayd(ptr1),rnd(1,10000)) ; len(vd)
         //vdt: arrayD=1; ptr1=@vdt; setlen(arrayd(ptr1),rnd(1,10000)); len(vdt)

         //setlen(arrayd(@vd),rnd(1,10000)); len(parrayd(vd))
         //ptr1=@vd; setlen(arrayd(ptr1),rnd(1,10000)); len(parrayd(ptr1))
         //vdt: arrayD=1; ptr1=@vdt; setlen(arrayd(ptr1),rnd(1,10000)); len(parrayd(ptr1))




       //универсальная: { ptr=@vec; setlen(ptr,NewLen) }
         //ptr1=@vd; setlen(ptr1,rnd(1,10000)) ; len(vd)
         //ptr1=@vd; setlen(ptr1,rnd(1,10000)) ; len(parrayp(ptr1))
         //vdt: arrayD=1; ptr1=@vdt; setlen(ptr1,rnd(1,10000)); len(vdt)
         //vdt: arrayD=1; ptr1=@vdt; setlen(ptr1,rnd(1,10000)); len(parrayp(ptr1))

 if VT  = 0  then
 begin
    {F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
    F_SyntaxErrorString:=F_CurrentString;
    F_SyntaxErrorStringA:=Copy(LV[0].Expression,1,Length(LV[0].Expression));
    goto endp;}

    SetLength(LV1,2);
    ND1.N:=2;
    ND1.COP:=_FUNC;
    ND1.NFunc:=CM_SETLEN;
    goto endp;
 end;



 adrV:=Alg.Obj[nm].Addr;



 SetLength(LV1,3);
 //{.357A}
 LV1[0].Expression:='@'+LV[0].Expression;//IntToStr(adrV);{LV[0].Expression;}
 // вместо:     ( чтобы адрес массива передавать через CPU, а не FPU  )
 //LV1[0].Expression:=IntToStr(adrV);   {LV[0].Expression;}

 LV1[1].Expression:=IntToStr(VT);
 LV1[2].Expression:=Copy(LV[1].Expression,1,Length(LV[1].Expression));


  ND1.N:=3;
  ND1.COP:=_FUNC;
  ND1.NFunc:=CM_SETLEN;

 endp:
end;






procedure TForevalH.SWAPAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
label endp;
var
C: TFloat;
VC1,VC2: Integer;
S,NA: Integer;
i: Integer;
nv1,nv2,tv1,tv2,tm1,tm2,nf1,nf2,tf1,tf2: Integer;
FD1,FD2: extended;
Str,Str1,Str2,S1,S2,Sv1,Sa1,Sv2,Sa2: String;
MType1,ni1,MType2,ni2: Integer;
adr1,adr2: Cardinal;
BH, BAnsw1,BAnsw2,BSwap: Boolean;
begin
//При изменении в SWAP  (.AI) внести изменения в SwapIfAnalizator, SwapIf_C  т.к. используется в них

EOFN:=True;
if F_SyntaxErrorCode <> 0 then goto endp;

BSwap:=False;

if Length(LV) <> 2 then
begin
 F_SyntaxErrorCode:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
 F_SyntaxErrorString:=F_CurrentString;
 goto endp;
 //F_SyntaxErrorString:=Copy(Sf,1,Length(Sf));
end;


LV1:=nil;
ND1:=ND;
ND1.N:=0;


//VC = _Const(FD); = _Var(nf); = _None(Stack);
Str2:=LV[1].Expression;
Str1:=LV[0].Expression;
//FindExternalBracket(Str1,Str1);
DeleteExternalBracketPS(@Str1); {.219}
//FindExternalBracket(Str2,Str2);
DeleteExternalBracketPS(@Str2); {.219}


FindReIm(Str1,S1,TF1);
//FindVar(S1,nf1);    {.333}
FindVarPS(@S1,nf1);
FindReIm(Str2,S2,TF2);
FindVarPS(@S2,nf2);
//FindVar(S2,nf2);


{
if (nf1 = -1) or (nf2 = -1) then
begin
  F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
  F_SyntaxErrorString:=F_CurrentString;
  if nf1 = -1  then    F_SyntaxErrorStringA:=Copy(S1,1,Length(S1))
               else    F_SyntaxErrorStringA:=Copy(S2,1,Length(S2));

  goto endp;
end;
}

GetVar1(nf1,adr1,tv1,tm1);
GetVar1(nf2,adr2,tv2,tm2);

if (tv1 = T_Real) and (tv2 = T_Real) and (tm1 <> _Integer) and (tm2 <> _Integer) then
begin
  ND1.NV1:=nf1;
  ND1.NV2:=nf2;
  ND1.AI:=1;       //FloatVar <-> FloatVar
  BSwap:=True;
end
else
if (tv1 = T_Real) and (tv2 = T_Real) and (tm1 = _Integer) and (tm2 = _Integer) then
begin
  ND1.NV1:=nf1;
  ND1.NV2:=nf2;
  ND1.AI:=2;       //IntVar <-> IntVar
  BSwap:=True;
end
else
if (tv1 = T_Complex) and (tv2 = T_Complex) and (tf2 = 0) and (tf1 = 0) then
begin
  ND1.NV1:=nf1;
  ND1.NV2:=nf2;
  ND1.TS1:=TF1;
  ND1.TS1:=TF2;
  ND1.AI:=3;          //ComplexVar <-> ComplexVar
  BSwap:=True;
end
else
if (tv1 = T_Real) and (tv2 = T_Complex) and (tf2 <> 0)  then
begin
  ND1.NV1:=nf1;
  ND1.NV2:=nf2;
  ND1.TS1:=TF1;
  ND1.TS2:=TF2;
  ND1.AI:=4;           //FloatVar <-> ComplexVar(Re,Im)
  BSwap:=True;
end
else
if (tv1 = T_Complex) and (tf1 <> 0) and (tv2 = T_Real)   then
begin
  ND1.NV1:=nf1;
  ND1.NV2:=nf2;
  ND1.TS1:=TF1;
  ND1.TS2:=TF2;
  ND1.AI:=5;                //FloatVar <-> ComplexVar(Re,Im)
  BSwap:=True;
end
else
if (tv1 = T_Complex) and  (tv2 = T_Complex) and (tf2 <> 0) and (tf1 <> 0)    then
begin
  ND1.NV1:=nf1;
  ND1.NV2:=nf2;
  ND1.TS1:=TF1;
  ND1.TS2:=TF2;
  ND1.AI:=6;          //ComplexVar(Re,Im) <-> ComplexVar(Re,Im)
  BSwap:=True;
end
else     //with Array
// IntArray[indx1] <-> IntArray[indx2]; indx1,indx2 = _IntForm, Stack
// IntArray[indx1] <-> IntVar; indx1 = _IntForm, Stack
// FloatArray[indx1](dbl,ext) <-> FloatArray[indx2](dbl,ext); indx1,indx2 = _IntForm, Stack
// FloatArray[indx1](dbl,ext) <-> FloatVar(dbl,ext,Cx.re,CX.im); indx1 = _IntForm, Stack
begin
  if FindExtractArray(@Str1, Sv1,Sa1, MType1,ni1) = True then       //Array1[]<->
  begin
     if FindExtractArray(@Str2, Sv2,Sa2, MType2,ni2) = True then    //Array1[]<->Array2[]
     begin

       if (MType1 = _Integer) and (MType2 = _Integer) then     //IntArray1[]<->IntArray2[]
       begin

            WriteFindExtArgInt1PS(@Sa1, _first,   ND1,   ND1,  BAnsw1);
            WriteFindExtArgInt1PS(@Sa2, _second,  ND1,   ND1,  BAnsw2);
            if (BAnsw1 = True) and (BAnsw2 = True) then   //IntArray1[IntForm1]=IntArray2[IntForm2]
            begin
               ND1.AI:=10;
               SetLength(LV1,0);
               ND1.NObj:=ni1;
               ND1.NObj2:=ni2;
               ND1.N:=0;
               EOFN:=True;
               BSwap:=True;
           end
           else
           if (BAnsw1 = True)and (BAnsw2 = False) then    //IntArray1[IntForm1]=IntArray2[Expr2]
           begin
              ND1.AI:=10;
              SetLength(LV1,1);
              LV1[0].Expression:=Copy(Sa2,1,Length(Sa2));
              ND1.NObj:=ni1;
              ND1.NObj2:=ni2;
              ND1.N:=1;
              EOFN:=False;
              BSwap:=True;
           end
           else
           if (BAnsw1 = False) and (BAnsw2 = True)  then   //IntArray1[Expr1]=IntArray2[IntForm2]
           begin
              ND1.AI:=10;
              SetLength(LV1,1);
              LV1[0].Expression:=Copy(Sa1,1,Length(Sa1));
              ND1.NObj:=ni1;
              ND1.NObj2:=ni2;
              ND1.N:=1;
              EOFN:=False;
              BSwap:=True;
           end
           else          //IntArray1[Expr1]=IntArray2[Expr2]
           begin
              ND1.AI:=10;
              SetLength(LV1,2);
              LV1[0].Expression:=Copy(Sa1,1,Length(Sa1));
              LV1[1].Expression:=Copy(Sa2,1,Length(Sa2));
              ND1.NObj:=ni1;
              ND1.NObj2:=ni2;
              ND1.N:=2;
              EOFN:=False;
              BSwap:=True;
           end;

       end  //of IntArray1[]<->IntArray2[]
       else
       if ((MType1 = _Double) or (MType1 = _Extended) or (MType1 = _Single)) and ((MType2 = _Double) or (MType2 = _Extended) or (MType2 = _Single)) then
       begin            //FloatArray1[]<->FloatArray2[]

            WriteFindExtArgInt1PS(@Sa1, _first,   ND1,   ND1,  BAnsw1);
            WriteFindExtArgInt1PS(@Sa2, _second,  ND1,   ND1,  BAnsw2);
            if (BAnsw1 = True) and (BAnsw2 = True) then   //FloatArray1[IntForm1]=FloatArray2[IntForm2]
            begin
               ND1.AI:=20;
               SetLength(LV1,0);
               ND1.NObj:=ni1;
               ND1.NObj2:=ni2;
               ND1.N:=0;
               EOFN:=True;
               BSwap:=True;
           end
           else
           if (BAnsw1 = True)and (BAnsw2 = False) then    //FloatArray1[IntForm1]=FloatArray2[Expr2]
           begin
              ND1.AI:=20;
              SetLength(LV1,1);
              LV1[0].Expression:=Copy(Sa2,1,Length(Sa2));
              ND1.NObj:=ni1;
              ND1.NObj2:=ni2;
              ND1.N:=1;
              EOFN:=False;
              BSwap:=True;
           end
           else
           if (BAnsw1 = False) and (BAnsw2 = True)  then   //FloatArray1[Expr1]=FloatArray2[IntForm2]
           begin
              ND1.AI:=20;
              SetLength(LV1,1);
              LV1[0].Expression:=Copy(Sa1,1,Length(Sa1));
              ND1.NObj:=ni1;
              ND1.NObj2:=ni2;
              ND1.N:=1;
              EOFN:=False;
              BSwap:=True;
           end
           else          //FloatArray1[Expr1]=FloatArray2[Expr2]
           begin
              ND1.AI:=20;
              SetLength(LV1,2);
              LV1[0].Expression:=Copy(Sa1,1,Length(Sa1));
              LV1[1].Expression:=Copy(Sa2,1,Length(Sa2));
              ND1.NObj:=ni1;
              ND1.NObj2:=ni2;
              ND1.N:=2;
              EOFN:=False;
              BSwap:=True;
           end;
       end;     // of FloatArray1[]<->FloatArray2[]

     end //  of  Array1[]<->Array2[]

     else   //Array1[]<->Var
     begin

        if (MType1 = _Integer) and  (tv2 = T_Real) and  (tm2 = _Integer) then   //IntArray1[]<->IntVar2
        begin
           WriteFindExtArgInt1PS(@Sa1, _first,   ND1,   ND1,  BAnsw1);
           if (BAnsw1 = True)  then   //IntArray1[IntForm1]<->IntVar
           begin
               ND1.AI:=11;
               SetLength(LV1,0);
               ND1.NObj:=ni1;
               ND1.NV2:=nf2;
               ND1.N:=0;
               EOFN:=True;
               BSwap:=True;
               ND1.DI:=_IntArray; //исп-ся в swapif
           end
           else                //IntArray1[Expr1]=IntVar2
           begin
               ND1.AI:=11;
               SetLength(LV1,1);
               LV1[0].Expression:=Copy(Sa1,1,Length(Sa1));
               ND1.NObj:=ni1;
               ND1.NV2:=nf2;
               ND1.N:=1;
               EOFN:=False;
               BSwap:=True;
               ND1.DI:=_IntArray; //исп-ся в swapif
           end;
        end
        else
        if ((MType1 = _Double) or (MType1 = _Extended) or (MType1 = _Single)) and  ( (tv2 = T_Real) or ( (tv2 = T_Complex) and (tf2 <> 0) ) ) then    //FloatArray1[]<->FloatVar2
        begin
           WriteFindExtArgInt1PS(@Sa1, _first,   ND1,   ND1,  BAnsw1);
           if (BAnsw1 = True)  then   //FloatArray1[IntForm1]<->FloatVar
           begin
               ND1.AI:=21;
               SetLength(LV1,0);
               ND1.NObj:=ni1;
               ND1.NV2:=nf2;
               ND1.TS2:=TF2;
               ND1.N:=0;
               EOFN:=True;
               BSwap:=True;
               ND1.DI:=_FloatArray; //исп-ся в swapif
           end
           else                //FloatArray1[Expr1]<->FloatVar2
           begin
               ND1.AI:=21;
               SetLength(LV1,1);
               LV1[0].Expression:=Copy(Sa1,1,Length(Sa1));
               ND1.NObj:=ni1;
               ND1.NV2:=nf2;
               ND1.TS2:=TF2;
               ND1.N:=1;
               EOFN:=False;
               BSwap:=True;
               ND1.DI:=_FloatArray; //исп-ся в swapif
           end;
        end;

     end;

  end    //of  FindExtractArray(@Str1, Sv1,Sa1, MType1,ni1) = True then       //Array1[]<->

  else
  if FindExtractArray(@Str2, Sv2,Sa2, MType2,ni2) = True then      // <-> Array2[]
  begin

     //Var1 <-> Array2[]

     if (MType2 = _Integer) and  (tv1 = T_Real) and  (tm1 = _Integer) then   //IntArray1[]<->IntVar2
        begin
           WriteFindExtArgInt1PS(@Sa2, _first,  ND1,   ND1,  BAnsw1);
           if (BAnsw1 = True)  then   //IntVar1<->IntArray2[IntForm2]
           begin
               ND1.AI:=11;
               SetLength(LV1,0);
               ND1.NObj:=ni2;
               ND1.NV2:=nf1;
               ND1.N:=0;
               EOFN:=True;
               BSwap:=True;
               ND1.DI:=_IntVar; //исп-ся в swapif
           end
           else                //IntVar1<->IntArray2[Expr2]
           begin
               ND1.AI:=11;
               SetLength(LV1,1);
               LV1[0].Expression:=Copy(Sa2,1,Length(Sa2));
               ND1.NObj:=ni2;
               ND1.NV2:=nf1;
               ND1.N:=1;
               EOFN:=False;
               BSwap:=True;
               ND1.DI:=_IntVar; //исп-ся в swapif
           end;
        end
        else
        if ((MType2 = _Double) or (MType2 = _Extended) or (MType2 = _Single)) and  ( (tv1 = T_Real) or ( (tv1 = T_Complex) and (tf1 <> 0) ) ) then    //FloatVar1<->FloatArray2[]
        begin
           WriteFindExtArgInt1PS(@Sa2, _first,   ND1,   ND1,  BAnsw1);
           if (BAnsw1 = True)  then   //FloatVar1<->FloatArray2[IntForm2]
           begin
               ND1.AI:=21;
               SetLength(LV1,0);
               ND1.NObj:=ni2;
               ND1.NV2:=nf1;
               ND1.TS2:=TF1;
               ND1.N:=0;
               EOFN:=True;
               BSwap:=True;
               ND1.DI:=_FloatVar; //исп-ся в swapif
           end
           else                //FloatVar1<->FloatArray2[Expr2]
           begin
               ND1.AI:=21;
               SetLength(LV1,1);
               LV1[0].Expression:=Copy(Sa2,1,Length(Sa2));
               ND1.NObj:=ni2;
               ND1.NV2:=nf1;
               ND1.TS2:=TF1;
               ND1.N:=1;
               EOFN:=False;
               BSwap:=True;
               ND1.DI:=_FloatVar; //исп-ся в swapif
           end;

        end;

  end;

end;

if BSwap = False then
begin
   F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
   F_SyntaxErrorString:=F_CurrentString;
   F_SyntaxErrorStringA:=Copy(S1,1,Length(S1))+'  or  '+Copy(S2,1,Length(S2));
end;


endp:
ND1.COP:=_FUNC;
ND1.NFunc:=CM_SWAP;
end;





procedure TForevalH.MOD_IDIV_Analizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
label endp;
var
C: TFloat;
VC1,VC2: Integer;
S,NA: Integer;
i: Integer;
nv1,nv2,tv1,tv2,tm1,tm2,Len,code1,code2,code,IC2: Integer;
FD1,FD2: extended;
Str,Str1,Str2: String;
adr: Cardinal;
BH,BAnsw: Boolean;
Adr1,Adr2: TAddress;
begin
if F_SyntaxErrorCode <> 0 then goto endp;


//шаблон для разбора: + исполняемые ф-ии. Прописать mod@ !!!

LV1:=LV;
ND1:=ND;  //ND1.NFunc = CM_MOD, CM_IDIV
EOFN:=False;
BH:=False;


Len:=Length(LV);
if Len <> 2 then
begin
  {.333}
 {F_SyntaxErrorCode:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
 F_SyntaxErrorString:=F_CurrentString; }
 goto endp;
end;


Str2:=LV[1].Expression;
Str1:=LV[0].Expression;

DeleteExternalBracketPS(@Str1);
DeleteExternalBracketPS(@Str2);

WriteFindExtArgInt2AnyPS(@Str1,@Str2,ND1,ND1,code);



if (F_OperationOptimizatorA2 = False) or (F_SaveInFPU = False) then     {.231}
begin
    ND1.AI:=0;
    ND1.N:=2;
    ND1.COP:=_COP;   //_COP ?? _FUNC
    //ND1.NFunc:=CM_MOD;
    EOFN:=False;
end
else
if code = _NOT_FOUND then
begin
    ND1.AI:=0;
    ND1.N:=2;
    ND1.COP:=_COP;   //_COP ?? _FUNC
    //ND1.NFunc:=CM_MOD;
    EOFN:=False;
end
else
if code = _Both then
begin
    code2:=ND1.TA2;  code1:=ND1.TA1;  IC2:=ND1.IC2;
    if (code1 = _IntConst) and (code2 = _IntConst)  then
    begin
      if ND1.NFunc = CM_MOD then
         ND1.FD:=ND1.IC1 mod ND1.IC2;

      if ND1.NFunc = CM_IDIV then
         ND1.FD:=ND1.IC1 div ND1.IC2;

      ND1.COP:=_LDSC;
      ND1.NFunc:=0;
      BH:=True;
      EOFN:=True;
      LV1:=nil;
      ND1.N:=0;
    end
    else
    begin
      ND1.AI:=3;
      ND1.N:=0;
      ND1.COP:=_COP;   //_COP ?? _FUNC
      //ND1.NFunc:=CM_MOD;
      EOFN:=True;
      LV1:=nil;
    end;
end
else
if code = _First then
begin
    ND1.AI:=1;
    ND1.COP:=_COP;   //_COP ?? _FUNC
    //ND1.NFunc:=CM_MOD;
    EOFN:=False;
    ND1.N:=1;
    SetLength(LV1,1);
    LV1[0].Expression:=Copy(Str2,1,Length(Str2));
end
else
if code = _Second then
begin
    ND1.AI:=2;
    ND1.COP:=_COP;   //_COP ?? _FUNC
    //ND1.NFunc:=CM_MOD;
    EOFN:=False;
    ND1.N:=1;
    SetLength(LV1,1);
    LV1[0].Expression:=Copy(Str1,1,Length(Str1));
end;

 {
WriteFindExtArgInt1(@Str2, _wSecond, ND1,  ND1, BAnsw);
code2:=ND1.TA2;
 }

(*

//******************************************************************************

Str2:=LV[1].Expression;
Str1:=LV[0].Expression;
//FindExternalBracket(Str1,Str1);
DeleteExternalBracketP(@Str1); {.219}
//FindExternalBracket(Str2,Str2);
DeleteExternalBracketP(@Str2); {.219}
NumberAnalizatorA(Str2,nv2,FD2,VC2);
FindVarA(Str1,nv1,Adr1,tv1,tm1);
FindVarA(Str2,nv2,Adr2,tv2,tm2);


                                                    {.231}
if (F_OperationOptimizatorA2 = False) or (F_SaveInFPU = False) then
begin
    ND1.AI:=0;
    ND1.N:=2;
    ND1.COP:=_COP;   //_COP ?? _FUNC
    ND1.NFunc:=CM_MOD;
    EOFN:=False;
    goto endp;
end
else
//mod(intvar1,intvar2)
if (tv1 = T_Real) and (tv2 = T_Real) and (tm1 = _Integer) and (tm2 = _Integer) then
begin
  ND1.NV1:=nv1;
  ND1.NV2:=nv2;
  ND1.N:=0;
  ND1.AI:=5;
  ND1.COP:=_COP;   //_COP ?? _FUNC
  ND1.NFunc:=CM_MOD;
  EOFN:=True;
end
else
if (VC2 = _Const) and (FD2 = 2) then
begin
   //mod(intvar,2)
   if (tv1 = T_Real)  and (tm1 = _Integer)  then
   begin
     ND1.NV1:=nv1;
     ND1.AI:=1;
     ND1.N:=0;
     ND1.COP:=_COP;   //_COP ?? _FUNC
     ND1.NFunc:=CM_MOD;
     EOFN:=True;
   end
   else
   //mod(S1,2)
   begin
     ND1.AI:=3;
     ND1.N:=1;
     ND1.COP:=_COP;   //_COP ?? _FUNC
     ND1.NFunc:=CM_MOD;
     SetLength(LV1,1);
     LV1[0].Expression:=Copy(Str1,1,Length(Str1));
     LV1[0].NL:=1;
     EOFN:=False;
   end;
end
else
if (VC2 = _Const)  then
begin

  if (Trunc(FD2) <> FD2) {and (abs(FD2) > 2^31) }then
  begin
   F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
   F_SyntaxErrorString:=F_CurrentString;
   F_SyntaxErrorStringA:=Copy(Str2,1,Length(Str2));
   goto endp;
  end

  else
  begin
    //mod(intvar,intconst)
    if (tv1 = T_Real)  and (tm1 = _Integer)  then
    begin
      ND1.NV1:=nv1;
      ND1.FD:=FD2;
      ND1.AI:=2;
      ND1.N:=0;
      ND1.COP:=_COP;   //_COP ?? _FUNC
      ND1.NFunc:=CM_MOD;
      EOFN:=True;
    end
    else
    //mod(S1,intconst)
    begin
      ND1.AI:=4;
      ND1.N:=1;
      ND1.FD:=FD2;
      ND1.COP:=_COP;   //_COP ?? _FUNC
      ND1.NFunc:=CM_MOD;
      SetLength(LV1,1);
      LV1[0].Expression:=Copy(Str1,1,Length(Str1));
      LV1[0].NL:=1;
      EOFN:=False;
    end;
  end;

end
else
//mod(S1,S2)
begin
    ND1.AI:=0;
    ND1.N:=2;
    ND1.COP:=_COP;   //_COP ?? _FUNC
    ND1.NFunc:=CM_MOD;
    EOFN:=False;
end;

 *)

endp:
end;





procedure TForevalH.DataFuncAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
label endp;
var
C: TFloat;
VC1,VC2: Integer;
S,NA: Integer;
i: Integer;
nv1,nv2,tv1,tv2,tm1,tm2,Len: Integer;
FD1,FD2: extended;
Str,Str1,Str2: String;
adr: Cardinal;
BH: Boolean;
Adr1,Adr2: TAddress;
begin
if F_SyntaxErrorCode <> 0 then goto endp;


LV1:=LV;
ND1:=ND;
EOFN:=False;


Len:=Length(LV);
if (Len = 2) or (Len = 3) then
begin
   if ND.NFunc = CM_MAX  then ND1.NFunc := CM_MAX23 else
   if ND.NFunc = CM_MIN  then ND1.NFunc := CM_MIN23 else
   if ND.NFunc = CM_AVR  then ND1.NFunc := CM_AVR23 else
   if ND.NFunc = CM_NORM then ND1.NFunc := CM_NORM23;
end;


endp:
end;





procedure TForevalH.SUMPAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
label endp;
var
C: TFloat;
VC1,VC2: Integer;
S,NA,ni,TV: Integer;
i: Integer;
nv1,nv2,tv1,tv2,tm1,tm2,Len,code1,code2,code,IC2: Integer;
FD1,FD2: extended;
Str,Str1,Str2: String;
adr: Cardinal;
BH,BAnsw: Boolean;
Adr1,Adr2: TAddress;
begin
if F_SyntaxErrorCode <> 0 then goto endp;


LV1:=LV;
ND1:=ND;
EOFN:=False;



Len:=Length(LV);
if Len <> 2 then
begin
 F_SyntaxErrorCode:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
 F_SyntaxErrorString:=F_CurrentString;
 goto endp;
end;



if Len = 2 then
begin


    Str2:=LV[1].Expression;
    Str1:=LV[0].Expression;

    DeleteExternalBracketPS(@Str1);
    DeleteExternalBracketPS(@Str2);


    FindVarPS(@Str1,ni);
    if ni <> -1 then
    begin
       TV:=Alg.Obj[ni].TypeF;
       if TV = T_Array then
       begin
          ND1.NV1:=ni;
       end
       else
       begin
          F_SyntaxErrorCode:= E_WRONG_TYPE;
          F_SyntaxErrorString:=F_CurrentString;
          goto endp;
       end;
    end;

    WriteFindExtArgInt1PS(@Str2, _Second,  ND1, ND1, BAnsw);


    if Bansw = True then       //SUMP(vec,[_IntConst,_IntVar,_IntForm])
    begin
         ND1.AI:=1;
         ND1.N:=0;
         ND1.NFunc:=CM_SUMP;
         EOFN:=True;
    end
    else                     //SUMP(vec,Expr)
    begin
         ND1.AI:=0;
         ND1.N:=1;
         ND1.NFunc:=CM_SUMP;
         SetLength(LV1,1);
         LV1[0].Expression:=Copy(Str2,1,Length(Str2));
         EOFN:=False;
    end;


end;



endp:
end;





procedure TForevalH.SUMPSAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
label endp;
var
C: TFloat;
VC1,VC2: Integer;
S,NA,ni,TV: Integer;
i: Integer;
nv1,nv2,tv1,tv2,tm1,tm2,Len,code1,code2,code,IC2: Integer;
FD1,FD2: extended;
Str,Str1,Str2,Str3: String;
adr: Cardinal;
BH,BAnsw: Boolean;
Adr1,Adr2: TAddress;
begin
if F_SyntaxErrorCode <> 0 then goto endp;


LV1:=LV;
ND1:=ND;
EOFN:=False;



Len:=Length(LV);
if Len <> 3 then
begin
 F_SyntaxErrorCode:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
 F_SyntaxErrorString:=F_CurrentString;
 goto endp;
end;



if Len = 3 then
begin

    //sumps(vec,expr,argi)

    Str3:=LV[2].Expression;
    Str1:=LV[0].Expression;
    Str2:=LV[1].Expression;

    DeleteExternalBracketPS(@Str1);
    DeleteExternalBracketPS(@Str3);


    FindVarPS(@Str1,ni);
    if ni <> -1 then
    begin
       TV:=Alg.Obj[ni].TypeF;
       if TV = T_Array then
       begin
          ND1.NV1:=ni;
       end
       else
       begin
          F_SyntaxErrorCode:= E_WRONG_TYPE;
          F_SyntaxErrorString:=F_CurrentString;
          goto endp;
       end;
    end;

    WriteFindExtArgInt1PS(@Str3, _Second,  ND1, ND1, BAnsw);


    if Bansw = True then       //SUMPS(vec,Expr,[_IntConst,_IntVar,_IntForm])
    begin
         ND1.AI:=1;
         ND1.N:=1;
         ND1.NFunc:=CM_SUMPS;
         SetLength(LV1,ND1.N);
         LV1[0].Expression:=Copy(Str2,1,Length(Str2));
         EOFN:=False;
    end
    else                     //SUMPS(vec,Expr,PwrExpr)
    begin
         ND1.AI:=0;
         ND1.N:=2;
         ND1.NFunc:=CM_SUMPS;
         SetLength(LV1,ND1.N);
         LV1[0].Expression:=Copy(Str2,1,Length(Str2));
         LV1[1].Expression:=Copy(Str3,1,Length(Str3));
         EOFN:=False;
    end;




end;



endp:
end;





procedure TForevalH.PRODSAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
label endp;
var
C: TFloat;
VC1,VC2: Integer;
S,NA,ni,TV: Integer;
i: Integer;
nv1,nv2,tv1,tv2,tm1,tm2,Len,code1,code2,code,IC2: Integer;
FD1,FD2: extended;
Str,Str1,Str2,Str3: String;
adr: Cardinal;
BH,BAnsw: Boolean;
Adr1,Adr2: TAddress;
begin
if F_SyntaxErrorCode <> 0 then goto endp;


LV1:=LV;
ND1:=ND;
EOFN:=False;



Len:=Length(LV);
if Len <> 2 then
begin
 F_SyntaxErrorCode:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
 F_SyntaxErrorString:=F_CurrentString;
 goto endp;
end;



if Len = 2 then
begin

    //prods(vec,expr)

    Str1:=LV[0].Expression;
    Str2:=LV[1].Expression;

    DeleteExternalBracketPS(@Str1);
    DeleteExternalBracketPS(@Str2);


    FindVarPS(@Str1,ni);
    if ni <> -1 then
    begin
       TV:=Alg.Obj[ni].TypeF;
       if TV = T_Array then
       begin
          ND1.NV1:=ni;
          ND1.AI:=1;
          ND1.N:=1;
          ND1.NFunc:=CM_PRODS;
          SetLength(LV1,ND1.N);
          LV1[0].Expression:=Copy(Str2,1,Length(Str2));
          EOFN:=False;
       end
       else
       begin
          F_SyntaxErrorCode:= E_WRONG_TYPE;
          F_SyntaxErrorString:=F_CurrentString;
          goto endp;
       end;
    end;


end;



endp:
end;






procedure TForevalH.POLYAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);

             procedure InitVFP(ND: PDataNode);
             var
                k,L: Integer;
             begin

                for k := 0 to Length(ND^.VFP)-1 do
                begin
                    ND^.VFP[k].indx:=_ABSENT;
                    ND^.VFP[k].tc:=T_Real;
                    ND^.VFP[k].Re:=0;
                    ND^.VFP[k].Im:=0;
                end;

             end;



label endp;
var
C: TFloat;
VC1,VC2: Integer;                              //poly(array,arg)->poly(arg) ; array: ND1.NV1=nv1
S,NA: Integer;
i,nf,ni,tv: Integer;
nv1,nv2,tv1,tv2,tm1,tm2,Len,TC: Integer;
FD1,FD2,f1,f2,Re,Im: extended;
Str,Str1,Str2: String;
adr: Cardinal;
BH,B_PolyU: Boolean;
Adr1,Adr2: TAddress;
begin
if F_SyntaxErrorCode <> 0 then goto endp;


//LV1:=LV;   {.347}
SetLength(LV1,0);
ND1:=ND;
EOFN:=False;
Len:=Length(LV);
B_PolyU:=False;
{
if Len <> 2 then
begin
 F_SyntaxErrorCode:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
 F_SyntaxErrorString:=F_CurrentString;
 goto endp;
end;
}



{.207}

if Len = 2  then
begin

   SaveSW; {.229} {TryStrToFloat damage SW}

   Str2:=LV[1].Expression;
   Str1:=LV[0].Expression;

   //FindVarA(Str1,nv1,Adr1,tv1,tm1);
   //FindVarA(Str2,nv2,Adr2,tv2,tm2);
   FindVarAPS(@Str1,nv1,Adr1,tv1,tm1);   {.333}
   FindVarAPS(@Str2,nv2,Adr2,tv2,tm2);


   if tv1 = T_Array then
   begin
      ND1.N:=1;
      ND1.COP:=_Func;
      ND1.NFunc:=CM_POLY;
      ND1.NV1:=nv1;
      ND1.AI:=T_Array;
      SetLength(LV1,1);
      LV1[0].Expression:=Copy(Str2,1,Length(Str2));
      LV1[0].NL:=1;
      EOFN:=False;
      goto endp;
   end
   else
   if tv2 = T_Array then
   begin
      ND1.N:=1;
      ND1.COP:=_Func;
      ND1.NFunc:=CM_POLY;
      ND1.NV1:=nv2;
      ND1.AI:=T_Array;
      SetLength(LV1,1);
      LV1[0].Expression:=Copy(Str1,1,Length(Str1));
      LV1[0].NL:=1;
      EOFN:=False;
      goto endp;
   end
   else
   begin           // VarExpr - выбрасывыается. Берётся только константа
      //poly
      SubstParamACXPS(@LV[0].Expression, Re,Im, TC);
      //if TryStrToFloat(LV[0].Expression,f1,G_FMT) = true  then    //poly(1.123,x)  poly(1.123,x/y)  poly(x,1.123) poly(x/y,1.123)
      if TC = T_Real then     {.347}
      begin{
      SetLength(LV1,0);
      ND1.EI:=2;
      ND1.N:=0;
      SetLength(ND1.VFP,1);
      ND1.VFP[0]:=f1;
      EOFN:=True;
      goto endp;
      }
         ND1.TC:=C_Real;
         ND1.FDC.re:=Re;
         ND1.FDC.im:=0;
         ND1.FD:=Re;
         ND1.COP:=_LDSC;
         ND1.N:=0;
         SetLength(LV1,0);
         EOFN:=True;
         goto endp;
      end
      else
      if TC = T_Complex then {.347}
      begin
         ND1.TC:=C_Complex;
         ND1.FDC.re:=Re;
         ND1.FDC.im:=Im;
         ND1.COP:=_LDSCX;
         ND1.N:=0;
         SetLength(LV1,0);
         EOFN:=True;
         goto endp;
      end
      (*
      //if TryStrToFloat(LV[1].Expression,f1,G_FMT) = true  then
      if  SubstParamACXPSF(@LV[1].Expression, Re,Im) = T_Real then {.347}
      begin
         ND1.TC:=C_Real;
         ND1.FDC.re:=Re;
         ND1.FDC.im:=0;
         ND1.FD:=Re;
         ND1.COP:=_LDSC;
         ND1.N:=0;
         SetLength(LV1,0);
         EOFN:=True;
         goto endp;
      end
      *)

      else
      {
      begin
        F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
        F_SyntaxErrorString:=F_CurrentString;
        SetLength(LV1,0);
        SetLength(ND1.VFP,0);
        goto endp;
      end;
      }
      begin                            //poly(Expr,Var)
          ND1.NFunc:=CM_POLYU;
          SetLength(ND1.VFP,1);
          InitVFP(@ND1);
          ND1.N:=1;
          ND1.VFP[0].Re:=0;
          ND1.VFP[0].Im:=0;
          ND1.VFP[0].indx:=_ABSENT;
          SetLength(LV1,1);
          LV1[0].Expression:=Copy(LV[0].Expression,1,Length(LV[0].Expression));
          EOFN:=False;
      end;
   end;


end
else
if Len > 2 then
begin

  //poly(3,5,7,9,11,15,17,19,x)-(3*x^7+5*x^6+7*x^5+9*x^4+11*x^3+15*x^2+17*x+19)

   //SaveSW; {.229} {TryStrToFloat damage SW}
   //if TryStrToFloat(LV[0].Expression,f1,G_FMT) = true then


   //Right to Left: Poly(An, An-1, An-2,...,A0, VarExpr)     ;An, An-1, An-2,...,A0 - Real Numbers; VarExpr-Real


  // if SubstParamACXPSF(@LV[0].Expression, Re,Im) = T_Real then
   //begin
       SetLength(ND1.VFP,Length(LV)-1);
       InitVFP(@ND1);

       for i := 0 to Length(LV)-2 do
       begin

          SubstParamACXPS(@LV[i].Expression, Re,Im, TC);

          if TC = T_Real then    {.347}
          begin
            ND1.VFP[i].Re:=Re;
            ND1.VFP[i].indx:=i;
          end
          else
          if TC = T_Complex then
          begin
              ND1.VFP[i].Re:=Re;
              ND1.VFP[i].Im:=Im;
              ND1.VFP[i].indx:=i;
          end
          else
          //PolyU (ExprAn, ExprAn-1, ExprAn-2,...,ExprA0,VarExpr);   ExprAn, ExprAn-1, ExprAn-2,...,ExprA0- Any Type: Real&Complex; VarExpr- Any Type;
          {.347}
          begin

              SetLength(LV1,Length(LV1)+1);
              LV1[High(LV1)].Expression:=LV[i].Expression;
              ND1.VFP[i].indx:=_ABSENT;   //not a number!  = -1!

              B_PolyU:=True;

          end;

       end; //for


       if B_PolyU = True then
       begin
          ND1.NFunc:=CM_POLYU;
          SetLength(LV1,Length(LV1)+1);
          LV1[High(LV1)].Expression:=Copy(LV[High(LV)].Expression,1,Length(LV[High(LV)].Expression));
          EOFN:=False;
          ND1.N:=Length(LV1);
       end
       else
       begin
          ND1.NFunc:=CM_POLY;
          SetLength(LV1,1);
          LV1[0].Expression:=Copy(LV[High(LV)].Expression,1,Length(LV[High(LV)].Expression));
          EOFN:=False;
          ND1.N:=1;
          ND1.AI:=T_Complex;
       end;
       goto endp;

  // end


   (*
   if SubstParamACXPSF(@LV[0].Expression, Re,Im) = T_Real then
   begin
       SetLength(ND1.VFP,Length(LV)-1);
       InitVFP(@ND1);

       for i := 0 to Length(LV)-2 do
       begin

          //if TryStrToFloat(LV[i].Expression,f1,G_FMT) = true then
          //SubstParamPS(@LV[i].Expression, Re,Im, TV);
          TV:=SubstParamACXPSF(@LV[i].Expression, Re,Im);
          if TV = T_Real then    {.347}
          begin
            ND1.VFP[i].Re:=Re;
            ND1.VFP[i].indx:=i;
          end
          else
          if TV = T_Complex then
          begin
              ND1.VFP[i].Re:=Re;
              ND1.VFP[i].Im:=Im;
              ND1.VFP[i].indx:=i;
          end
          else
          //PolyU (ExprAn, ExprAn-1, ExprAn-2,...,ExprA0,VarExpr);   ExprAn, ExprAn-1, ExprAn-2,...,ExprA0- Any Type: Real&Complex; VarExpr- Any Type;
          {
          begin
            F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
            F_SyntaxErrorString:=F_CurrentString;
            SetLength(LV1,0);
            SetLength(ND1.VFP,0);
            goto endp;
          end; }

          {.347}
          begin

            {if TV = T_Complex then
            begin
              ND1.VFP[i].Re:=Re;
              ND1.VFP[i].Im:=Im;
              ND1.VFP[i].indx:=i;
            end
            else }
            //begin
              SetLength(LV1,Length(LV1)+1);
              LV1[High(LV1)].Expression:=LV[i].Expression;
              ND1.VFP[i].indx:=_NOT_FOUND;   //not a number!  = -1!
            //end;

            B_PolyU:=True;

          end;

       end; //for

       if B_PolyU = True then
       begin
          ND1.NFunc:=CM_POLYU;
          SetLength(LV1,Length(LV1)+1);
          LV1[High(LV1)].Expression:=Copy(LV[High(LV)].Expression,1,Length(LV[High(LV)].Expression));
          EOFN:=False;
          ND1.N:=Length(LV1);
       end
       else
       begin
          ND1.NFunc:=CM_POLY;
          SetLength(LV1,1);
          LV1[0].Expression:=Copy(LV[High(LV)].Expression,1,Length(LV[High(LV)].Expression));
          EOFN:=False;
          ND1.N:=1;
          ND1.AI:=T_Real;
       end;
       goto endp;

   end
   else    //poly(x,3,5,7,9,11,15,17,19)
    //Left to Right: Poly(VarExpr, An, An-1, An-2,...,A0)     ;An, An-1, An-2,...,A0 - Real Numbers; VarExpr-Real
    //work only for Poly
   //if TryStrToFloat(LV[High(LV)].Expression,f1,G_FMT) = true then
   if SubstParamACXPSF(@LV[High(LV)].Expression, Re,Im) = T_Real then     {.347}
   begin

       SetLength(ND1.VFP,Length(LV)-1);
       InitVFP(@ND1.VFP);

       for i := 0 to Length(LV)-2 do
       begin
          //if TryStrToFloat(LV[i+1].Expression,f1,G_FMT) = true then
          if SubstParamACXPSF(@LV[i+1].Expression, Re,Im) = T_Real  then
          begin
            ND1.VFP[i].Re:=Re;
          end
          else
          begin
            F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
            F_SyntaxErrorString:=F_CurrentString;
            SetLength(LV1,0);
            SetLength(ND1.VFP,0);
            goto endp;
          end;
       end;

       ND1.NFunc:=CM_POLY;
       SetLength(LV1,1);
       LV1[0].Expression:=Copy(LV[0].Expression,1,Length(LV[0].Expression));
       ND1.N:=1;
       EOFN:=False;
       ND1.AI:=T_Real;
       goto endp;

   end
   else
   {begin
      F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
      F_SyntaxErrorString:=F_CurrentString;
      SetLength(LV1,0);
      SetLength(ND1.VFP,0);
      goto endp;
   end }

   //PolyU {.347}
   begin
       SetLength(ND1.VFP,Length(LV)-1);
       InitVFP(@ND1.VFP);

       for i := 0 to Length(LV)-2 do
       begin

          //SubstParamPS(@LV[i].Expression, Re,Im, TV);
          if {TV <>  _NOT_FOUND} SubstParamACXPSF(@LV[i].Expression, Re,Im) <> _NOT_FOUND then
          begin
            ND1.VFP[i].Re:=Re;
            ND1.VFP[i].Im:=Im;
            ND1.VFP[i].indx:=i;
          end
          else
          begin
              SetLength(LV1,Length(LV1)+1);
              LV1[High(LV1)].Expression:=LV[i].Expression;
              ND1.VFP[i].indx:=_NOT_FOUND;   //not a number!  = -1!
          end;

       end; //for

        SetLength(LV1,Length(LV1)+1);
        LV1[High(LV1)].Expression:=Copy(LV[High(LV)].Expression,1,Length(LV[High(LV)].Expression));
        ND1.NFunc:=CM_POLYU;
        EOFN:=False;
        ND1.N:=Length(LV1);


   end;
   *)
end

else
begin
   F_SyntaxErrorCode:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
   F_SyntaxErrorString:=F_CurrentString;
   SetLength(LV1,0);
   SetLength(ND1.VFP,0);

   {F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
   F_SyntaxErrorString:=F_CurrentString; }
   F_SyntaxErrorStringA:=Copy(Str1,1,Length(Str1));
end;


endp:

  for i := 0 to High(ND1.VFP) do
  begin
    if ND1.VFP[i].Im <> 0  then ND1.VFP[i].tc:=T_Complex else   ND1.VFP[i].tc:=T_Real;
  end;


end;


//polynomdiff(ad,x,n)  ,polynomdiff(ad,expr,n)
procedure TForevalH.POLYDIFFAnalizator(LV: PLevel; ND: TDataNode;  var LV1: PLevel; var ND1: TDataNode; var EOFN: boolean);
label endp;
var
ni,tv1,tv2,tm1,L,P,nv1: Integer;
Adr1: Cardinal;
begin
 //LV1:=LV;
 ND1:=ND;
 L:=Length(LV);

if   (L <> 3)  then
begin
   F_SyntaxErrorCode:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
   F_SyntaxErrorString:=F_CurrentString;
  goto endp;
end;



//FindVarA(LV[0].Expression,nv1,Adr1,tv1,tm1);
FindVarAPS(@LV[0].Expression,nv1,Adr1,tv1,tm1);    {.333}

 if TV1 <> T_Array  then
 begin
   F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
   F_SyntaxErrorString:=F_CurrentString;
   goto endp;
 end;



 {.203}
 if TryStrToInt(LV1[2].Expression,P) = false then
 begin
  P:=-1;
 end;

 if (P = 1) or (P = 2) or (P = 3) then
 begin
   ND1.NFunc:=CM_POLYDIFF;
   ND1.COP:=_Func;
   //ND1.NV1:=nv1;
   ND1.AI:=tm1;
   ND1.CI:=P;
   ND1.N:=1;
   ND1.NObj:=nv1;
   SetLength(LV1,1);
   LV1[0].Expression:=Copy(LV[1].Expression,1,Length(LV[1].Expression));
   LV1[0].NL:=1;
   EOFN:=False;
 end
 else
 begin
   //SetLength(LV1,3);
   LV1:=LV;
   SetLength(LV1,4);
   LV1[3].Expression:=IntToStr(tm1);
   ND1.N:=4;
   ND1.NFunc:=CM_POLYDIFFN;
   EOFN:=False;
 end;

 endp:
end;



procedure TForevalH.PolyUReWrite;
var
 Node: PNode;



       procedure   PolyReWriteConst(PolyNode: PNode);
       label endp;
       var
        PrevNode,NextNode,NbNode,PrNode: PNode;
        NCHLD: TArrayPN;
        LenCh,LenChCnst, LenChExpr,NL,S,k,TC,TV,RetType,NP,PosN: Integer;
        ConstNode,ExprNode,CnstPos,ArgTypesExpr: TArrayI;




       begin

        if PolyNode^.NFunc = CM_POLYU then
        begin

          GetAllChilds(PolyNode,NCHLD);
          LenCh:=Length(NCHLD);
          if LenCh = 0 then goto endp;

          //N:=PolyNode^.NFunc;
          //NF:=PolyNode^.NF;
          TC:=T_Real;
          TV:= PolyNode^.ArgTypes[High(PolyNode^.ArgTypes)];  //тип выражения переменной
          //tv:=Alg.ExFunc[N].Func[NF].TV[0];   //тип выражения переменной

           //проверка на константу
           //-> генерировать команды   _LDSC ,_LDSCX
           //poly(a*b+c*d,x)  poly(ai*b+ci*d,z1) poly(ai*b+c*di,x) poly(a*b+c*d,z1)
          if LenCh = 1 then
          begin

             if NCHLD[0]^.COP = _LDSC then
             begin
                PolyNode^.COP:=_LDSC;
                PolyNode^.N:=0;
                PolyNode^.TC:=T_Real;
                PolyNode^.FD:=NCHLD[0]^.FD;
                PolyNode^.FDC.re:=NCHLD[0]^.FD;
                PolyNode^.FDC.im:=0;
                FreeNode(NCHLD[0]);
                PolyNode^.Ch:=nil;
                F_PolyReWrite := True;
                goto endp;
             end
             else
             if NCHLD[0]^.COP = _LDSCX then
             begin
                PolyNode^.COP:=_LDSCX;
                PolyNode^.N:=0;
                PolyNode^.TC:=T_Complex;
                PolyNode^.FDC.re:=NCHLD[0]^.FDC.re;
                PolyNode^.FDC.im:=NCHLD[0]^.FDC.im;
                FreeNode(NCHLD[0]);
                PolyNode^.Ch:=nil;
                F_PolyReWrite := True;
                goto endp;
             end;

          end;

          PosN:=0;
          //CnstPos - позиции вычисленных конст. аргументов в VPF
          //определение узлов с константами и выражениями
          for k := 0 to LenCh-2 do   //последний эл-т (LenCh-1) - VarExper
          begin

            //просчитывание позиций уже заполненных числами коэфф.:
            if PosN <= High(PolyNode^.VFP)  then    //не обязательно
            begin
               while  PolyNode^.VFP[PosN].indx >= 0 do
               begin
                 inc(PosN);
               end;
            end;

            if (NCHLD[k]^.COP = _LDSC) or (NCHLD[k]^.COP = _LDSCX) then
            begin
              SetLength(ConstNode,Length(ConstNode)+1);
              ConstNode[High(ConstNode)]:=k;
              if NCHLD[k]^.COP = _LDSCX then TC:=T_Complex;

              SetLength(CnstPos,Length(CnstPos)+1);
              CnstPos[High(CnstPos)]:=PosN;
              inc(PosN);
            end
            else
            begin
              SetLength(ExprNode,Length(ExprNode)+1);
              ExprNode[High(ExprNode)]:=k;
              inc(PosN);
              //сохранение типов вытекающих узлов:
              SetLength(ArgTypesExpr,Length(ArgTypesExpr)+1);
              ArgTypesExpr[High(ArgTypesExpr)]:=PolyNode^.ArgTypes[k];
            end;

          end;   //for
          //последний вытекающий узел - VarExpr:
          SetLength(ArgTypesExpr,Length(ArgTypesExpr)+1);
          ArgTypesExpr[High(ArgTypesExpr)]:=PolyNode^.ArgTypes[High(PolyNode^.ArgTypes)];


          LenChExpr:=Length(ExprNode);
          LenChCnst:=Length(ConstNode);

          if  LenChCnst = 0 then goto endp;

          //перезапись выражений с константами
          for k := 0 to LenChCnst-1 do
          begin
              if NCHLD[ConstNode[k]]^.COP = _LDSC then
              begin
                NP:=CnstPos[k];
                PolyNode^.VFP[NP].Re:=NCHLD[ConstNode[k]]^.FD;
                PolyNode^.VFP[NP].indx:=NP;
                PolyNode^.VFP[NP].tc:=T_Real;
               {
                PolyNode^.VFP[ConstNode[k]].Re:=NCHLD[ConstNode[k]]^.FD;
                PolyNode^.VFP[ConstNode[k]].indx:=ConstNode[k];
                PolyNode^.VFP[ConstNode[k]].tc:=T_Real;
                }
              end;

              if NCHLD[ConstNode[k]]^.COP = _LDSCX then
              begin
                NP:=CnstPos[k];
                PolyNode^.VFP[NP].Re:=NCHLD[ConstNode[k]]^.FDC.re;
                PolyNode^.VFP[NP].Im:=NCHLD[ConstNode[k]]^.FDC.im;
                PolyNode^.VFP[NP].indx:=NP;
                PolyNode^.VFP[NP].tc:=T_Complex;
                {
                PolyNode^.VFP[ConstNode[k]].Re:=NCHLD[ConstNode[k]]^.FDC.re;
                PolyNode^.VFP[ConstNode[k]].Re:=NCHLD[ConstNode[k]]^.FDC.im;
                PolyNode^.VFP[ConstNode[k]].indx:=ConstNode[k];
                PolyNode^.VFP[ConstNode[k]].tc:=T_Complex;
                }
              end;

            //удаление
             FreeNode(NCHLD[ConstNode[k]]);
          end;

          //все элементы - константы -> генерировать команду CM_POLY
          if LenChExpr = 0 then
          begin
            PolyNode^.NFunc:=CM_POLY;
            PolyNode^.N:=1;
            PolyNode^.AI:=T_Complex;   //тип полинома по типу аргумента:T_Array ; T_Complex(T_Real or T_Complex)
            if (TV = T_Real) and (TC = T_Real) then RetType:=T_Real else RetType:=T_Complex;
            PolyNode^.TypeF:=RetType;    //возвращаемый тип полинома
            PolyNode^.NF:=FindExeFunc1V(CM_POLY,TV);
            //PolyNode^.Ch:=nil;
            PolyNode^.Ch:=NCHLD[High(NCHLD)]; //указатель  на VarExpr  (только один вытекающий узел)
            F_PolyReWrite:=True;

            goto  endp;
          end;


           //восстановление данных в узлах (для CM_POLYU):
           PolyNode^.N:= PolyNode^.N-LenChCnst;
           S:=PolyNode^.S;
           NL:=1;

           //1-ый
           PolyNode^.Ch:=NCHLD[ExprNode[0]];
           //NCHLD[ExprNode[0]]^.Nb:=NCHLD[High(NCHLD)];  //ссылка первого эл-та на последний с VarExpr(не содержится в ExprNode) Для случая с одним выражением  poly(2,y,2+3*4,x)
           NCHLD[ExprNode[0]]^.S:=S;
           NCHLD[ExprNode[0]]^.NL:=NL;
           inc(S);
           inc(NL);
           //остальные
           for k := 1 to LenChExpr-1 do
           begin
             NCHLD[ExprNode[k]]^.S:=S;
             NCHLD[ExprNode[k]]^.NL:=NL;
             inc(S);
             inc(NL);
             NCHLD[ExprNode[k-1]]^.Nb:=NCHLD[ExprNode[k]];
           end;
           //последний
           NCHLD[ExprNode[High(ExprNode)]]^.Nb:=NCHLD[High(NCHLD)];

           //VarExpr  (в ExprNode не входит VarExpr):
           NCHLD[High(NCHLD)]^.S:=S;
           NCHLD[High(NCHLD)]^.NL:=NL;

           //восстановлеие и перезапись типов оставшихся аргументов (вытекающих узлов)
           SetLength(PolyNode^.ArgTypes,Length(ArgTypesExpr));
           for k := 0 to High(ArgTypesExpr) do
           begin
              PolyNode^.ArgTypes[k]:=ArgTypesExpr[k];
           end;




           F_PolyReWrite:=True;
           //FirstNode:=GetLowLevelNode(BeginTree);  //реинициализация
           //восстановление указателей в линейном списке
           //InitSequentList;
        end;


        endp:
       end;



begin

 F_PolyReWrite:=False;

 Node:=FirstNode;

 while Node <> nil do
 begin
   if Node^.NFunc = CM_POLYU then PolyReWriteConst(Node);
   Node:=Node^.Next;
 end;

 if F_PolyReWrite = True then
 begin
    FirstNode:=GetLowLevelNode(BeginTree);  //реинициализация
    //восстановление указателей в линейном списке
    InitSequentList;
    //восстановление
    //SetExtArg;
 end;
end;





procedure TForevalH.RANDAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
label endp;
var
C: TFloat;                    {.203}
VC1,VC2: Integer;            //random,rand,rnd (),(int),(float1,float2) -> random01mt, intrandommt(int), randommt(float1,float2)
S,NA: Integer;
i,nf,ni,tv: Integer;
nv1,nv2,tv1,tv2,tm1,tm2,Len: Integer;
FD1,FD2: extended;
Str,Str1,Str2: String;
adr: Cardinal;
BH: Boolean;
Adr1,Adr2: TAddress;
begin
if F_SyntaxErrorCode <> 0 then goto endp;


LV1:=LV;
ND1:=ND;
EOFN:=False;


Len:=Length(LV);
if Len = 0  then
begin
   ND1.N:=0;
   ND1.COP:=_Func;
   FindFuncA('random01mt',NF);
   ND1.NFunc:=NF;
   EOFN:=True;
end
else
if Len = 1  then
begin
   ND1.N:=1;
   ND1.COP:=_Func;
   FindFuncA('intrandommt',NF);
   ND1.NFunc:=NF;
   EOFN:=False;
end
else
if Len = 2  then
begin
   ND1.N:=2;
   ND1.COP:=_Func;
   FindFuncA('randommt',NF);
   ND1.NFunc:=NF;
   EOFN:=False;
end
else
begin
 F_SyntaxErrorCode:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
 F_SyntaxErrorString:=F_CurrentString;
 goto endp;
end;

{
Str2:=LV[1].Expression;
Str1:=LV[0].Expression;



FindVarA(Str1,nv1,Adr1,tv1,tm1);
if tv1 = T_Array then
begin
   ND1.N:=1;
   ND1.COP:=_Func;
   ND1.NFunc:=CM_POLY;
   ND1.NV1:=nv1;
   SetLength(LV1,1);
   LV1[0].Expression:=Copy(Str2,1,Length(Str2));
   LV1[0].NL:=1;
   EOFN:=False;
end
else
begin
   F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
   F_SyntaxErrorString:=F_CurrentString;
   F_SyntaxErrorStringA:=Copy(Str1,1,Length(Str1));
end;
}

endp:
end;




procedure TForevalH.CALLAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
label callarray, endp;
var
C: TFloat;
VC1,VC2: Integer;
S,NA,ni,TV,MT,NV,IC,NF: Integer;
i: Integer;
nv1,nv2,tv1,tv2,tm1,tm2,Len,code1,code2,code,IC2: Integer;
FD1,FD2: extended;
Str,Str1,Str2,Str3,Sf,Sa,Sv: String;
//adr: Cardinal;
BH,BAnsw,FH1: Boolean;
Adr1,Adr2,AddrF: TAddress;
AIVP:  TArrayIntVarProd;
begin
if F_SyntaxErrorCode <> 0 then goto endp;


LV1:=LV;
ND1:=ND;
EOFN:=False;



Len:=Length(LV);
if Len <> 1 then
begin
 F_SyntaxErrorCode:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
 F_SyntaxErrorString:=F_CurrentString;
 goto endp;
end;



    //call(<Addr>) Addr = @Func; IntVar; IntArray[indx]


    Str1:=LV[0].Expression;
    //DeleteExternalBracketPS(@Str1);


 //if (F_EnableUseIntegerPointer = True) and (F_EnableUsePointer = True) then
 begin
    // Call (PointerVar) Call(IntVar)

    FindVarPS(@Str1,ni);
    if ni <> -1 then
    begin
       TV:=Alg.Obj[ni].TypeF;
       MT:=Alg.Obj[ni].MType;
       if (TV = T_Pointer) or
          ( (TV = T_Real) and  (MT = _Integer) and (F_EnableUseIntegerPointer = True))
       then
       begin
           ND1.NV1:=ni;
           //ND1.NFunc:=CM_CALLR;
           BH:=True;
           EOFN:=True;
           ND1.N:=0;
           ND1.AI:=1;  //Call (PointerVar) Call(IntVar)
           SetLength(LV1,0);
       end
       else
       begin
          F_SyntaxErrorCode:= E_WRONG_TYPE;
          F_SyntaxErrorString:=F_CurrentString;
          //goto endp;
       end;
       goto endp;
    end;

 end;



    //Call(Func)
    (*
    FindFuncPS(@Str1,NF);
    if NF <> -1 then
    begin
        if Alg.ExFunc[NF].Func[0].NArg = 0 then   //Call(Func): только ф-ии без аргументов!
        begin
           AddrF:=Alg.ExFunc[NF].Func[0].Addr;
           ND1.Addr1:=AddrF;
           BH:=True;
           EOFN:=True;
           ND1.N:=0;
           ND1.AI:=4;  //Call(Func)
           SetLength(LV1,0);
           F_CallFuncPresent:=True;
        end
        else
        begin
           F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
           F_SyntaxErrorString:=Copy(F_CurrentString,1,Length(F_CurrentString));
           //F_SyntaxErrorName:=Copy(Sv,1,Length(Sv));
           F_SyntaxErrorName:=Alg.ExFunc[NF].Name ;
        end;
        goto endp;
    end;
    *)

   //if  (F_EnableUsePointer = True) then
   begin

      //Call(@Func)
    if Str1[1] = '@' then  Str2:=Copy(Str1,2,Length(Str1)-1)
    else   //Call(Addr(func))
    begin
        FindFuncBrPS(@Str1,'(',')',Sf,Sa,FH1);
        if FH1 = True then
        begin
           if Alg.ExFunc[CM_ADDR].Name = Sf then Str2:=Sa
           else
            //вызов сохранённого адреса в стеке. Исп-ся через преобразование типов
               //extf()=sqrt(x)      ptrf:pointer=@extf;  adrI:int=integer(ptrf); callR(pointer(adri))
           begin
               BH:=True;
               EOFN:=False;
               ND1.N:=1;
               ND1.AI:=6;  //Call(Pointer(Addr)) через преобразование типов
               SetLength(LV1,1);
               LV1[0].Expression:=Str1;
               F_CallFuncPresent:=True;
               goto endp;
              {
              F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
              F_SyntaxErrorString:=Copy(F_CurrentString,1,Length(F_CurrentString));
              F_SyntaxErrorName:=Sf;
              }
           end;
        end
        else
        goto callarray;
    end;

    FindFuncPS(@Str2,NF);
    if NF <> -1 then
    begin
        if Alg.ExFunc[NF].Func[0].NArg = 0 then   //Call(Func): только ф-ии без аргументов!
        begin
           AddrF:=Alg.ExFunc[NF].Func[0].Addr;
           ND1.Addr1:=AddrF;
           BH:=True;
           EOFN:=True;
           ND1.N:=0;
           ND1.AI:=4;  //Call(Func)
           SetLength(LV1,0);
           F_CallFuncPresent:=True;
        end
        else
        begin
           F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
           F_SyntaxErrorString:=Copy(F_CurrentString,1,Length(F_CurrentString));
           //F_SyntaxErrorName:=Copy(Sv,1,Length(Sv));
           F_SyntaxErrorName:=Alg.ExFunc[NF].Name ;
        end;
        goto endp;
    end;

   end;



    callarray:
    //if (F_EnableUseIntegerPointer = True) and (F_EnableUsePointer = True) then
    begin

         //CALL(IntArray[indx])
         FindFuncBrPS(@Str1,'[',']',Sv,Sa,FH1);
         if FH1 = True then FindVarPS(@Sv,ni) else ni:=-1; {.333}

         if ni <> -1 then //ni - vector
         begin
           if (Alg.Obj[ni].TypeF = T_Array) and ( (Alg.Obj[ni].MType = _Pointer) or ( (Alg.Obj[ni].MType = _Integer) and (F_EnableUseIntegerPointer = True))) then
           begin

               {F_IntegerOptimization}
               //---------------------------------------------------------

              //ND.NFunc:=CM_LDSVX;
              ND1.NObj:=ni;
              //ND.COP:=_Func;
              BH:=True;



              FindExtArgIntPS(@Sa, code, AIVP, NV, IC);
              if code <> _NOT_FOUND then
              begin
                if code = _IntConst then
                begin
                  ND1.FD:=IC;
                  ND1.AI:=5;    //call(vec[Intconst])
                  ND1.N:=0;
                  EOFN:=True;

                  {
                  F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
                  F_SyntaxErrorString:=Copy(F_CurrentString,1,Length(F_CurrentString));
                  F_SyntaxErrorName:=Copy(Sv,1,Length(Sv));
                  goto endp;
                  }
                end
                else
                if code = _IntVar then
                begin
                   ND1.NV1:=NV;
                   ND1.AI:=2;       //Call(IntArray[IntVar])
                   ND1.N:=0;
                   EOFN:=True;
                end
                else
                begin
                  ND1.AIVP1:=Copy(AIVP,0,Length(AIVP));
                  ND1.AI:=3;     //Call(IntArray[IntForm])
                  ND1.FD:=IC;
                  ND1.N:=0;
                  EOFN:=True;
                end;
                  EOFN:=True;
                  SetLength(LV1,0);
                  ND1.N:=0;
                  EOFN:=True;
              end
              else
              begin
                 ND1.AI:=0;       //Call(IntArray[expr])
                 SetLength(LV,1);
                 LV1[0].Expression:=Copy(Sa,1,Length(Sa));
                 ND1.N:=1;
                 EOFN:=False;
              end;

         //---------------------------------------------------------

           end
           else   //Array <> T_Array Integer
           begin
              F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT; {.323}
              F_SyntaxErrorString:=Copy(F_CurrentString,1,Length(F_CurrentString));     {.323}
              F_SyntaxErrorName:=Copy(Sv,1,Length(Sv));
              goto endp;
           end;

       end
       else  //unknown expr
       begin
              F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT; {.323}
              F_SyntaxErrorString:=Copy(F_CurrentString,1,Length(F_CurrentString));     {.323}
              F_SyntaxErrorName:=Copy(Sv,1,Length(Sv));
              goto endp;
       end;


    end;




   // WriteFindExtArgInt1PS(@Str3, _Second,  ND1, ND1, BAnsw);




endp:
end;




function TForevalH.FindAddrObj(PS: PString;  ND: TDataNode; var ND1: TDataNode): Boolean;
label endp;
var
 NameObj: String;
 NF,ni,TV,TypeF: Integer;
 BH: Boolean;
 Addr,AddrIM: TAddress;
 MType,ReIm,ImU: Integer;
begin
  BH:=False;

    //NameObj:=Copy(PS^,2,Length(PS^)-1);
    ND1:=ND;

    //(@Func)
    FindFuncPS({@NameObj}PS,NF);
    if NF <> -1 then
    begin
        //if Alg.ExFunc[NF].Func[0].NArg = 0 then   //Call(@Func): только ф-ии без аргументов!
        begin
           ND1.Addr1:=Alg.ExFunc[NF].Func[0].Addr;   //первая из списка!!
           ND1.AI:=_AddrFunc; //@Func
           ND1.N:=0;
           BH:=True;
           F_CallFuncPresent:=True;
        end;

        goto endp;
    end;


  (*
    //(@Var)
    FindVarPS({@NameObj}PS,ni);
    if ni <> -1 then
    begin
       TV:=Alg.Obj[ni].TypeF;

       if (TV = T_Array)  then
       begin
          ND1.NV1:=ni;
          ND1.Addr1:=Alg.Obj[ni].Addr;
          ND1.AI:=_AddrArray;
          ND1.N:=0;
          BH:=True;
          goto endp;
       end;

       if (TV = T_Real)  then
       begin
          ND1.NV1:=ni;
          ND1.Addr1:=Alg.Obj[ni].Addr;
          ND1.AI:=_AddrVar;
          ND1.N:=0;
          BH:=True;
          goto endp;
       end;

       if (TV = T_Complex)  then
       begin
          ND1.NV1:=ni;
          ND1.Addr1:=Alg.Obj[ni].Addr;
          ND1.AI:=_AddrVar;
          ND1.N:=0;
          BH:=True;
          goto endp;
       end;

       goto endp;
    end;

    *)

    //(@VarCx.re   @VarCx.im)
    FindVarExPS({@NameObj}PS, ni, Addr, AddrIM, TypeF, MType, ReIm, ImU);    //ReIm = _RE, _IM , 0
    if ni <> _ABSENT then
    begin
      if (TypeF = T_Array)  then
       begin
          ND1.NV1:=ni;
          ND1.Addr1:=Addr;//Alg.Obj[ni].Addr;
          ND1.AI:=_AddrArray;
          ND1.N:=0;
          BH:=True;
          goto endp;
       end;

       if (TypeF = T_Real)  then
       begin
          ND1.NV1:=ni;
          ND1.Addr1:=Addr;//Alg.Obj[ni].Addr;
          ND1.AI:=_AddrVar;
          ND1.N:=0;
          BH:=True;
          goto endp;
       end;

       if (TypeF = T_Complex)  then
       begin
          if ReIm = _IM then ND1.Addr1:=AddrIM else   ND1.Addr1:=Addr;
          ND1.NV1:=ni;
          ND1.TS:=ReIm;
          ND1.AI:=_AddrVar;
          ND1.N:=0;
          BH:=True;
          goto endp;
       end;

       if (TypeF = T_Pointer)  then      {.355}
       begin
          ND1.NV1:=ni;
          ND1.Addr1:=Addr;//Alg.Obj[ni].Addr;
          ND1.AI:=_AddrVar;
          ND1.N:=0;
          BH:=True;
          goto endp;
       end;


    end;



 endp:
 FindAddrObj:=BH;
end;





function TForevalH.FindArray(PS: PString; var ND: TDataNode;  var ni, TypeV, TypeIndx: Integer; var Addr: Cardinal;   var Sindx: String): Boolean;

//поиск элементов векторов:AI = (1)Vec[IntConst],(2)Vec[IntVar],(3)Vec[IntForm], (0)Vec[Sindx]->Vec[Trunc(Sindx)]
//TypeV = _Extended, _Double, _Single, _Integer, _Pointer
//TypeIndx =   _IntVar, _IntConst, _IntForm, _Stack
var
 i,k,l,j,bb,pf,pr,b1,b2,nf,TV: Integer;        //BH - массив найден да/нет
 S1,Sa,Sf,Sf1,Sfn,Sv: String;
 Neg,SB,TM,code,IC,NV: Integer;
 BH,FH1: Boolean;
 AIVP:  TArrayIntVarProd;
begin


  BH:=False;

  FindFuncBrPS(PS,'[',']',Sv,Sa,FH1);
  if FH1 = True then FindVarPS(@Sv,ni) else ni:=-1;

  if ni <> -1 then //ni - vector
  begin
    if Alg.Obj[ni].TypeF = T_Array then
    begin

        {F_IntegerOptimization}
       //---------------------------------------------------------

       Addr:=Alg.Obj[ni].Addr;
       BH:=True;
       ND.NObj:=ni;
       ND.Addr1:=Addr;
       FindExtArgIntPS(@Sa, code, AIVP, NV, IC);

       if code <> _NOT_FOUND then
       begin

          if code = _IntConst then
          begin
            ND.FD:=IC;
            ND.AI:=1;
          end
          else
          if code = _IntVar then
          begin
            ND.NV1:=NV;
            ND.AI:=2;
          end
          else
          begin
            ND.AIVP1:=Copy(AIVP,0,Length(AIVP));
            //CopyAIVP(AIVP,ND.AIVP1);
            ND.AI:=3;
            ND.FD:=IC;
          end;

          TypeIndx := code;
       end
       else
       begin   //Vec[expr]
         Sindx:=Sa;
         TypeIndx := _Stack;
       end;

         //---------------------------------------------------------

    end
  end;


FindArray:=BH;
end;





procedure TForevalH.GetVar1(N: Integer; var Addr: Cardinal; var TV: Integer; var TM: Integer);
var
S3: String;
AddrIm: Cardinal;
begin
 //GetVar2(N,Addr,AddrIm,TV,TM);

TV:=0; TM:=0; Addr:=0;
if (N >=0) and   (N <= High(Alg.Obj))  then
begin
 TV:=Alg.Obj[N].TypeF;      //тип переменной  (T_Real, T_Complex, T_Array,  IM_UNIT)
 TM:=Alg.Obj[N].MType;     //_Double,_Extended,_Integer,_Single

 //if  LowerCase(Alg.Obj[N].Name) = S_IM_UNIT then TV:=IM_UNIT;
 S3:=Alg.Obj[N].Name;
 if (S3 = S_IM_UNIT) and (TV = T_Complex) then TV:=IM_UNIT;

 Addr:=Alg.Obj[N].Addr;
end;

end;




procedure TForevalH.GetVar2(N: Integer; var AddrRE,AddrIM: Cardinal; var TV: Integer; var TM: Integer);
var
S3: String;
begin
 {if (Alg.Obj[N].TypeF = T_Real) and (Alg.Obj[N].MType = _Double) then TV:=D_Real else
 if (Alg.Obj[N].TypeF = T_Real) and (Alg.Obj[N].MType = _Extended) then TV:=E_Real else
 if (Alg.Obj[N].TypeF = T_Complex) and (Alg.Obj[N].MType = _Double) then TV:=D_Complex else
 if (Alg.Obj[N].TypeF = T_Complex) and (Alg.Obj[N].MType = _Extended) then TV:=E_Complex;}

AddrIM:=0;   AddrRE:=0;
TV:=0; TM:=0;
if(N >= 0) and (N <= High(Alg.Obj)) then
begin
 TV:=Alg.Obj[N].TypeF;      //тип переменной  (T_Real, T_Complex, T_Array,  IM_UNIT)
 TM:=Alg.Obj[N].MType;     //_Double,_Extended,_Integer _Single

 //if  LowerCase(Alg.Obj[N].Name) = S_IM_UNIT then TV:=IM_UNIT;
 S3:=Alg.Obj[N].Name;
 if (S3 = S_IM_UNIT) and (TV = T_Complex) then TV:=IM_UNIT;

 AddrRE:=Alg.Obj[N].Addr;
 AddrIM:=Alg.Obj[N].AddrIM;
end;

end;




procedure TForevalH.GetSizeInterp;
label endp;
var
E: Exception;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

LInterp:=1;

Tree:=BeginTree; //не обязательно, т.к. чтение дерева - циклически

while Tree^.Ch <> nil do
begin
  Tree:=Tree^.Ch;
end;
//COP=NOP:
inc(LInterp);

while Tree^.Pr <> nil do
begin

 while Tree^.Nb <> nil  do
 begin
   Tree:=Tree^.Nb;
   while Tree^.Ch <> nil do
   begin
    Tree:=Tree^.Ch;
   end;

   //COP=NOP:
   inc(LInterp);
 end;
  //COP<>NOP:
  Tree:=Tree^.Pr;
  inc(LInterp);
end;

endp:

end;


//найти нижний левый узел
function TForevalH.GetLowLevelNode(PrntNode: PNode):  PNode;
label endp;
var
 Chld: PNode;
begin
//GetLowLevelNode:=FirstNode; {.322}
//if F_InternalError <> 0  then goto endp;  {.322}

 Chld:=PrntNode;

 while Chld^.Ch <> nil do
 begin
  Chld:=Chld^.Ch;
 end;
 F_TypeOfNode:=N_End;
 GetLowLevelNode:=Chld;

endp:
end;


//найти нижний правый узел
function TForevalH.GetLowRightNode(PrntNode: PNode):  PNode;
label endp;
var
 Chld: PNode;
begin

 Chld:=PrntNode;

 while Chld^.Ch <> nil do
 begin
    while Chld^.Nb <> nil do
    begin
       Chld:=Chld^.Nb;
    end;
    Chld:=Chld^.Ch;
 end;


 //F_TypeOfNode:=N_End;
 GetLowRightNode:=Chld;

endp:
end;



function TForevalH.GetLastChld(PrntNode: PNode):  PNode;
var
 Chld: PNode;
begin
 //PrntNode:=PrntNodeIn;
 //GetLastChld:=последний вытекающий узел из PrntNode

 Chld:=PrntNode^.Ch;
 while Chld^.Nb <> nil do
 begin
  Chld:=Chld^.Nb;
 end;
 //F_TypeOfNode:=N_End;
 GetLastChld:=Chld;

end;



//следующий исполняемый узел
function TForevalH.GetNextNode(PrntNode: PNode):  PNode;
label endp;
{var
 PrntNode: PNode;
 S: String;  }
begin

 //PrntNode:=PrntNodeIn;

 while PrntNode^.Pr <> nil do
 begin

   while PrntNode^.Nb <> nil  do
   begin
     PrntNode:=PrntNode^.Nb;

     PrntNode:=GetLowLevelNode(PrntNode);
     {while PrntNode^.Ch <> nil do
     begin
       PrntNode:=PrntNode^.Ch;
     end;}

    //COP=NOP:
    //WriteCode;     //нижний левый
     F_TypeOfNode:=N_End;
     goto endp;
   end;
  //COP<>NOP:
   PrntNode:=PrntNode^.Pr;    // родительский от крайнего правого  на уровне
   F_TypeOfNode:=N_Parent;
   goto endp;
   //WriteCode;
 end;

 endp:
  GetNextNode:=PrntNode;
end;






procedure TForevalH.LinkTreeData_Tree;
label endp;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

Tree:=BeginTree; //не обязательно, т.к. чтение дерева - циклически

while Tree^.Ch <> nil do
begin
Tree:=Tree^.Ch;
end;
//COP=NOP:
LinkDataNode(Tree);      //нижний левый

while Tree^.Pr <> nil do
begin

   while Tree^.Nb <> nil  do
   begin
    Tree:=Tree^.Nb;
    while Tree^.Ch <> nil do
    begin
     Tree:=Tree^.Ch;
    end;
    //COP=NOP:
    LinkDataNode(Tree);     //нижний левый
   end;

 //COP<>NOP:
 Tree:=Tree^.Pr;          // родительский от крайнего правого  на уровне
 LinkDataNode(Tree);

end;
//1-ый элемент в WriteCode выпадает


endp:


end;





procedure TForevalH.LinkTreeData_SeqList;
var
Node: PNode;
begin

Node:=FirstNode;

while Node <> nil do
begin
  LinkDataNode(Node);
  Node:=Node^.Next;
end;

{
LFunc:=1;
SetLength(Interp,LInterp);

   Tree:=BeginTree; //не обязательно, т.к. чтение дерева - циклически
   Tree:=GetLowLevelNode(Tree);
   WriteCode;

   while Tree^.Pr <> nil do
   begin
      Tree:=GetNextNode(Tree);
      WriteCode;
      //if F_TypeOfNode = N_Parent then FreeChld(Tree);
   end;

}

end;




procedure TForevalH.LinkTreeData;
begin

if F_SequentList = True then
   LinkTreeData_SeqList
else
   LinkTreeData_Tree;

end;




//****************************************************************************//
//                        EVAL. CONST. FUNCTIONS  (begin)                     //
//****************************************************************************//


procedure TForevalH._ComplexADD(Re1,Im1,Re2,Im2: Extended; var Re,Im: Extended);
begin
  Re:=Re1+Re2;
  Im:=Im1+Im2;
end;



procedure TForevalH._ComplexSUB(Re1,Im1,Re2,Im2: Extended; var Re,Im: Extended);
begin
  Re:=Re1-Re2;
  Im:=Im1-Im2;
end;


procedure TForevalH._ComplexMUL(Re1,Im1,Re2,Im2: Extended; var Re,Im: Extended);
begin
  Re := Re1*Re2-Im1*Im2;
  Im := Re1*Im2+Im1*Re2;
end;



procedure TForevalH._ComplexDIV(Re1,Im1,Re2,Im2: Extended; var Re,Im: Extended);

     procedure _ZZDIV_acc(_Re1,_Im1,_Re2,_Im2: Extended; var _Re,_Im: Extended); assembler;
     //begin
         asm
           pushad
           fld   tbyte ptr _Im2
           fld   tbyte ptr _Re2
           fld   tbyte ptr _Im1
           fld   tbyte ptr _Re1
           call  Z_DIV_ACC
           fstp  tbyte ptr [_Re]
           fstp  tbyte ptr [_Im]
           popad
         end;
     //end;

begin

try
  TryFPUMask;


 { Re := (Re1*Re2+Im1*Im2)/(sqr(Re2)+sqr(Im2));
  Im := (Im1*Re2-Re1*Im2)/(sqr(Re2)+sqr(Im2)); }
   {.361}
  _ZZDIV_acc(Re1,Im1,Re2,Im2, Re, Im);

  TryCatchFPUException;
except
 on E: EZeroDivide      do F_InternalError:=E_ZeroDivide;
 on E: EInvalidOp       do F_InternalError:=E_InvalidOp;
 on E: EOverFlow        do F_InternalError:=E_OverFlow;
 on E: EUnderFlow       do F_InternalError:=E_UnderFlow;
 on E: EIntOverFlow     do F_InternalError:=E_IntOverFlow;
 on E: EAccessViolation do F_InternalError:=E_AccessViolation;
 on E: EOutOfMemory     do F_InternalError:=E_OutOfMemory;
 on E: EStackOverFlow   do F_InternalError:=E_StackOverFlow;
end;

   if F_InternalError <> 0 then
      F_SyntaxErrorCode:=E_INTERNAL_ERROR_AT_CALCULATION;
end;


procedure TForevalH._EvalFunc1Cx(Addr: Pointer;  Arg1: TComplex;  var Res: TComplex);
var
re,im: Extended;
begin

  asm
    pushad
    fld tbyte ptr [Arg1.im]
    fld tbyte ptr [Arg1.re]
    call Addr
    fstp tbyte ptr [Re]
    fstp tbyte ptr [Im]
    popad
  end;


  Res.re:=Re; Res.im:=Im;
end;




procedure TForevalH._EvalFunc1CxInt(Addr: Pointer;  Arg1: TComplex; Arg2: Integer; var Res: TComplex);
var
re,im: Extended;
begin

  asm
    pushad
    fld tbyte ptr [Arg1.im]
    fld tbyte ptr [Arg1.re]
    mov eax,Arg2
    call Addr
    fstp tbyte ptr [Re]
    fstp tbyte ptr [Im]
    popad
  end;

  Res.re:=Re; Res.im:=Im;
end;



procedure TForevalH._EvalFunc1CxInt2(Addr: Pointer;  Arg1: TComplex; Arg2,Arg3: Integer; var Res: TComplex);
var
re,im: Extended;
begin

   asm
    pushad
    fld tbyte ptr [Arg1.im]
    fld tbyte ptr [Arg1.re]
    mov eax,Arg2
    mov ebx,Arg3
    call Addr
    fstp tbyte ptr [Re]
    fstp tbyte ptr [Im]
    popad
  end;

  Res.re:=Re; Res.im:=Im;
end;


procedure TForevalH._EvalFunc1ReInt(Addr: Pointer;  Arg1: Extended; Arg2: Integer; var Res: Extended);
var
re,im: Extended;
begin

  asm
    pushad
    fld tbyte ptr [Arg1]
    mov eax,Arg2
    call Addr
    fstp tbyte ptr [Re]
    popad
  end;


  Res:=Re; //Res.im:=Im;
end;


procedure TForevalH._EvalFunc2Cx(Addr: Pointer;  Arg1,Arg2: TComplex; TV1,TV2: Integer; var Res: TComplex);
var
re,im: Extended;
begin
if (TV1 = T_Complex) and  (TV2 = T_Complex) then
begin
  asm
    pushad
    fld tbyte ptr [Arg2.im]
    fld tbyte ptr [Arg2.re]
    fld tbyte ptr [Arg1.im]
    fld tbyte ptr [Arg1.re]
    call Addr
    fstp tbyte ptr [Re]
    fstp tbyte ptr [Im]
    popad
  end;
end
else
if (TV1 = T_Real) and  (TV2 = T_Complex) then
begin
  asm
    pushad
    fld tbyte ptr [Arg2.im]
    fld tbyte ptr [Arg2.re]
    fld tbyte ptr [Arg1.re]
    call Addr
    fstp tbyte ptr [Re]
    fstp tbyte ptr [Im]
    popad
  end;
end
else
if (TV1 = T_Complex) and  (TV2 = T_Real) then
begin
   asm
    pushad
    fld tbyte ptr [Arg2.re]
    fld tbyte ptr [Arg1.im]
    fld tbyte ptr [Arg1.re]
    call Addr
    fstp tbyte ptr [Re]
    fstp tbyte ptr [Im]
    popad
  end;
end;

Res.re:=Re; Res.im:=Im;

end;


procedure TForevalH._EvalFuncReCx(AddrF: Pointer; Re: TFloat; var Res: TComplex);
begin
 asm
   fld Re
 end;
 _EvalFunc(AddrF,T_Complex,Res);
end;


procedure TForevalH._EvalFunc(AddrF: Pointer; TypeF: Integer; var Res: TComplex);
var
re,im: Extended;
begin
try

re:=0; im:=0;
  if TypeF = T_Real then
  begin
     asm
       pushad
       call AddrF
       fstp tbyte ptr [Re]
       popad
     end;
  end
  else
  if TypeF = T_Complex then
  begin
     asm
       pushad
       call AddrF
       fstp tbyte ptr [Re]
       fstp tbyte ptr [Im]
       popad
     end;
  end;

  Res.re:=Re; Res.im:=Im;

except {.322}
 on E: EZeroDivide      do F_InternalError:=E_ZeroDivide;
 on E: EInvalidOp       do F_InternalError:=E_InvalidOp;
 on E: EOverFlow        do F_InternalError:=E_OverFlow;
 on E: EUnderFlow       do F_InternalError:=E_UnderFlow;
 on E: EIntOverFlow     do F_InternalError:=E_IntOverFlow;
 on E: EAccessViolation do F_InternalError:=E_AccessViolation;
 on E: EOutOfMemory     do F_InternalError:=E_OutOfMemory;
 on E: EStackOverFlow   do F_InternalError:=E_StackOverFlow
end;

if F_InternalError <> 0 then F_SyntaxErrorCode:=E_INTERNAL_ERROR_AT_CALCULATION;    {.326}


end;



procedure TForevalH._EvalFunc1({NFunc,NF: Integer;}PNE: PNode; Arg1: TComplex; var Res: TComplex; var ResType: Integer;  var IsEval: Boolean);
var
 TV1,TypeF,NFunc,NF,IC,IC1,IC2: Integer;
 Addr: Pointer;
 FName: String;
 ArgR: TComplex;
 ArgW,ResW : Foreval_SpecFunc.complex;
 FD: Extended;
 Arg2: TComplex;
 ArgType1,ArgType2: Integer;
begin


  NFunc:=PNE^.NFunc; NF:=PNE^.NF;
  TypeF:=Alg.ExFunc[NFunc].Func[NF].TypeF;
  ResType:=TypeF; {.361} // иcключение для некоторых нестандартных внутренних функций, возвращающих тип результата через Node^.TypeF
  TV1:=Alg.ExFunc[NFunc].Func[NF].TV[0];

  //IsEval:=True;
  IsEval:=False;   {.329}
  Res.re:=0;   Res.im:=0;   FD:=PNE^.FD;

  {.335}
  // перекодировка NFunc  _acc функций в NFunc обычных (быстрых) для удобства вычисления конст. функ. в режиме AccFunc
  //(не обязательно. Иначе вычисление через промежуточную компиляцию)
  if F_FAST_STD_FUNC = False then
  begin
    NFunc:=XchNFuncFastAcc(NFunc);
  end;


  if TV1 = T_Real then
  begin
     case NFunc of     //  _Internal     {.357}
       CM_SQR:       begin Res.re:=sqr(Arg1.re);   IsEval:=True; end; {.329}
       CM_SQRT:      begin Res.re:=sqrt(Arg1.re);  IsEval:=True; end; {.329}
       CM_EXP:       begin Res.re:=exp(Arg1.re);   IsEval:=True; end; {.329}
       CM_LN:        begin Res.re:=fc_ln(Arg1.re);    IsEval:=True; end; {.329}
       CM_SIN:       begin Res.re:=sin_acc(Arg1.re);   IsEval:=True; end; {.329}
       CM_COS:       begin Res.re:=cos_acc(Arg1.re);   IsEval:=True; end; {.329}
       CM_TAN:       begin Res.re:=fc_tan(Arg1.re);    IsEval:=True; end; {.329}
       CM_COTAN:     begin Res.re:=cot_acc(Arg1.re);  IsEval:=True; end; {.329}
       CM_SINH:      begin  Res.re:=sinh_acc(Arg1.re);   IsEval:=True; end; {.329}
       CM_COSH:      begin  Res.re:=cosh_acc(Arg1.re);   IsEval:=True; end; {.329}
       CM_TANH:      begin  Res.re:=tanh_acc(Arg1.re);   IsEval:=True; end; {.329}
       CM_COTANH:    begin  Res.re:=coth_acc(Arg1.re);    IsEval:=True; end; {.329}
       CM_ARCSIN:    begin    Res.re:=arcsin_acc(Arg1.re);  IsEval:=True; end; {.329}
       CM_ARCCOS:    begin    Res.re:=arccos_acc(Arg1.re);    IsEval:=True; end; {.329}
       CM_ARCTAN:    begin    Res.re:=arctan(Arg1.re);   IsEval:=True; end; {.329}
       CM_ARCCOTAN:  begin                                    {.335}
                          if F_FAST_STD_FUNC = True then
                             Res.re:=PI_2-arctan(Arg1.re)
                          else
                             Res.re:=arccot_acc(Arg1.re);

                          IsEval:=True;
                     end; {.329}
       CM_ARCSINH:   begin     Res.re:=arcsinh_acc(Arg1.re);   IsEval:=True; end; {.329}
       CM_ARCCOSH:   begin     Res.re:=arccosh_acc(Arg1.re);    IsEval:=True; end; {.329}
       CM_ARCTANH:   begin     Res.re:=arctanh_acc(Arg1.re);    IsEval:=True; end; {.329}
       CM_ARCCOTANH: begin     Res.re:=arccoth_acc(Arg1.re);   IsEval:=True; end; {.329}
       CM_SEC:       begin     Res.re:=sec_acc(Arg1.re);       IsEval:=True; end; {.329}
       CM_COSEC:     begin     Res.re:=csc_acc(Arg1.re);      IsEval:=True; end; {.329}
       CM_SECH:      begin     Res.re:=sech_acc(Arg1.re);      IsEval:=True; end; {.329}
       CM_COSECH:    begin     Res.re:=csch_acc(Arg1.re);      IsEval:=True; end; {.329}
       CM_ARCSEC:    begin     Res.re:=arcsec_acc(Arg1.re);    IsEval:=True; end; {.329}
       CM_ARCCOSEC:  begin     Res.re:=arccsc_acc(Arg1.re);    IsEval:=True; end; {.329}
       CM_ARCSECH:   begin     Res.re:=arcsech_acc(Arg1.re);    IsEval:=True; end; {.329}
       CM_ARCCOSECH: begin     Res.re:=arccsch_acc(Arg1.re);    IsEval:=True; end; {.329}
       CM_LOG2:      begin     Res.re:=fc_log2(Arg1.re);         IsEval:=True; end; {.329}
       CM_LOG10:     begin     Res.re:=fc_log10(Arg1.re);       IsEval:=True; end; {.329}
       CM_FACT2:     begin     Res.re:=factorial2F[Trunc(Arg1.re)];    IsEval:=True; end; {.329}
       CM_FACT:      begin     Res.re:=factorial[Trunc(Arg1.re)];   IsEval:=True; end; {.329}
       CM_F2PWR:     begin     Res.re:=power_acc(2,Arg1.re);       IsEval:=True; end; {.329}
       CM_IPWRSGN:   begin
                              if PNE^.AI = 2 then
                              begin
                                 _EvalFuncReCx(@Z_UNeg_ReFPWR,Arg1.re,Res);
                                 ResType:=T_Complex;
                                 IsEval:=True;
                              end
                              else
                              begin
                                Res.re:=power_acc(-1,Arg1.re);
                                ResType:=T_Real;
                                IsEval:=True;
                              end;
                     end;
       CM_IMURZPWR:  begin
                              if PNE^.AI = 1 then
                              begin
                                 _EvalFuncReCx(@Z_ImU_ReFPWR,Arg1.re,Res);
                                 ResType:=T_Complex;
                                 IsEval:=True;
                              end
                              else      //AI=2
                              begin
                                _EvalFuncReCx(@Z_ImUNeg_ReFPWR,Arg1.re,Res);
                                 ResType:=T_Complex;
                                 IsEval:=True;
                              end;
                     end;
       CM_TRUNC:     begin     Res.re:=trunc(Arg1.re);       IsEval:=True; end; {.329}
       CM_FRAC:      begin     Res.re:=frac(Arg1.re);      IsEval:=True; end; {.329}
       CM_ABS:       begin     Res.re:=abs(Arg1.re);      IsEval:=True; end; {.329}
       CM_SIGN:      begin if Arg1.re = 0 then Res.re:=0 else if Arg1.re > 0 then Res.re:=1 else Res.re:=-1;  IsEval:=True; end;
       CM_DEG:       begin     Res.re:=Arg1.re*180/3.14159265358979323846264;   IsEval:=True; end;
       CM_RAD:       begin     Res.re:=Arg1.re*3.14159265358979323846264/180;   IsEval:=True; end;


       CM_IPWR:    begin
                       if (PNE^.AI = 2) and (PNE^.TA2 = _IntConst) then //Expr^IntConst
                       begin
                          IC:=PNE^.IC2;
                          Res.re:=fc_IntPower(Arg1.re,IC);
                          IsEval:=True;
                       end
                       else
                       IsEval:=False;
                   end;

       CM_IPWR16:  begin
                          IC:=PNE^.AI;                  //Expr^(+- 1..16)
                          Res.re:=fc_IntPower(Arg1.re,IC);
                          IsEval:=True;
                   end;

       CM_IROOT:   begin
                       if (PNE^.AI = 2) and (PNE^.TA2 = _IntConst) then //root(Expr,IntConst)
                       begin
                          IC:=PNE^.IC2;
                          _EvalFunc1ReInt(@R_IROOT,Arg1.re,IC,Res.re);
                          IsEval:=True;
                       end
                       else
                       IsEval:=False;
                   end;

       CM_CZPWR:   begin

                       if PNE^.AI = 1 then   ArgType1:=T_Real else
                       if PNE^.AI = 2 then   ArgType1:=T_Complex;
                       ArgType2:=Alg.ExFunc[PNE^.NFunc].Func[PNE^.NF].TV[0];
                       //или ArgType2:=PNE^.TypeA;

                       if (ArgType1 = T_Real) and (ArgType2 = T_Real) then
                       begin
                         Res.re:=power_acc(PNE^.FD,Arg1.re);
                         IsEval:=True;
                         ResType:=T_Real;
                         //исключение, т.к. тип рез-та однозначно не определяется заданием ф-ии в Alg.ExFunc[NFunc].Func[NF].TV[0];
                       end
                      (* else

                       if  (ArgType1 = T_Real) and (ArgType2 = T_Complex) then
                       begin
                             Arg2:=Arg1;
                             Arg1.re:=PNE^.FD; Arg1.im:=0;
                            _EvalFunc2Cx(@Z_ReCxFPWR,Arg1,Arg2,ArgType1,ArgType2,Res);
                             IsEval:=True;
                             ResType:=T_Complex;
                            //исключение, т.к. тип рез-та однозначно не определяется заданием ф-ии в Alg.ExFunc[NFunc].Func[NF].TV[0];
                       end
                       *)
                       else
                       if  (ArgType1 = T_Complex) and (ArgType2 = T_Real) then
                       begin
                              Arg2:=Arg1;
                              Arg2.im:=0;
                              Arg1.re:=PNE^.FDC.re; Arg1.im:=PNE^.FDC.im;
                             _EvalFunc2Cx(@Z_CxReFPWR,Arg1,Arg2,ArgType1,ArgType2,Res);
                              IsEval:=True;
                              ResType:=T_Complex;
                              //исключение, т.к. тип рез-та однозначно не определяется заданием ф-ии в Alg.ExFunc[NFunc].Func[NF].TV[0];
                       end
                       (*
                       else
                       if  (ArgType1 = T_Complex) and (ArgType2 = T_Complex) then
                       begin
                              Arg2:=Arg1;
                              Arg1.re:=PNE^.FDC.re; Arg1.im:=PNE^.FDC.im;
                             _EvalFunc2Cx(@ZPWR,Arg1,Arg2,ArgType1,ArgType2,Res);
                              IsEval:=True;
                              ResType:=T_Complex;
                             //исключение, т.к. тип рез-та однозначно не определяется заданием ф-ии в Alg.ExFunc[NFunc].Func[NF].TV[0];
                       end;
                       *)

                   end;

       else
                  begin     //  _External
                      FName:=Alg.ExFunc[NFunc].Name;
                      if FName = 'gamma'    then  begin Res.re:=sfc_gamma(Arg1.re); IsEval:=True; end else
                      if FName = 'lngamma'  then  begin Res.re:=sfc_lngamma(Arg1.re); IsEval:=True; end else  {.334}
                      if FName = 'besselj0' then  begin Res.re:=sfc_j0(Arg1.re); IsEval:=True; end else
                      if FName = 'besselj1' then  begin Res.re:=sfc_j1(Arg1.re); IsEval:=True; end else
                      if FName = 'bessely0' then  begin Res.re:=sfc_y0(Arg1.re); IsEval:=True; end else
                      if FName = 'bessely1' then  begin Res.re:=sfc_y1(Arg1.re); IsEval:=True; end else
                      if FName = 'erf'      then  begin Res.re:=sfc_erf(Arg1.re); IsEval:=True; end else
                      if FName = 'erfc'     then  begin Res.re:=sfc_erfc(Arg1.re); IsEval:=True; end else
                      if FName = 'zeta'     then  begin Res.re:=sfc_zeta(Arg1.re); IsEval:=True; end else
                      if FName = 'psi'      then  begin Res.re:=sfc_psi(Arg1.re); IsEval:=True; end
                      else
                      if (F_CalcConstExtFunc = True) and
                         (Alg.ExFunc[NFunc].Func[NF].IntF = _External) and
                         (Alg.ExFunc[NFunc].Func[NF].Addr <> 0)
                       then EvalFuncN(PNE,Res,IsEval);
                      //IsEval:=False;
                  end;
     end


  end
  else
  if TV1 = T_Complex then
  begin
     case NFunc of
       CM_SQR:     begin  _EvalFunc1Cx(@Z_SQR,Arg1,Res);  IsEval:=True; end; {.329}
       CM_SQRT:    begin  _EvalFunc1Cx(@Z_SQRT,Arg1,Res);  IsEval:=True; end; {.329}
       CM_EXP:     begin  _EvalFunc1Cx(@Z_EXP,Arg1,Res);   IsEval:=True; end; {.329}
       CM_LN:      begin  _EvalFunc1Cx(@Z_LN,Arg1,Res);   IsEval:=True; end; {.329}
       CM_SIN:     begin  _EvalFunc1Cx(@Z_SIN,Arg1,Res);  IsEval:=True; end; {.329}
       CM_COS:     begin  _EvalFunc1Cx(@Z_COS,Arg1,Res);    IsEval:=True; end; {.329}
       CM_TAN:     begin  _EvalFunc1Cx(@Z_TAN,Arg1,Res);    IsEval:=True; end; {.329}
       CM_COTAN:   begin  _EvalFunc1Cx(@Z_COTAN,Arg1,Res);   IsEval:=True; end; {.329}
       CM_SINH:    begin  _EvalFunc1Cx(@Z_SINH,Arg1,Res);   IsEval:=True; end; {.329}
       CM_COSH:    begin  _EvalFunc1Cx(@Z_COSH,Arg1,Res);    IsEval:=True; end; {.329}
       CM_TANH:    begin  _EvalFunc1Cx(@Z_TANH,Arg1,Res);    IsEval:=True; end; {.329}
       CM_COTANH:  begin  _EvalFunc1Cx(@Z_COTANH,Arg1,Res);   IsEval:=True; end; {.329}
       CM_ARCSIN:  begin

                           if F_FAST_STD_FUNC = True then
                               _EvalFunc1Cx(@Z_ARCSIN,Arg1,Res)
                           else
                           begin
                               ArgW.re:=Arg1.re; ArgW.im:=Arg1.im;
                               carcsin_acc(ArgW,ResW);
                               Res.re:=ResW.re; Res.im:=ResW.im;
                           end;

                           IsEval:=True;
                   end; {.329}
       CM_ARCCOS:  begin
                          if F_FAST_STD_FUNC = True then
                               _EvalFunc1Cx(@Z_ARCCOS,Arg1,Res)
                           else
                           begin
                               ArgW.re:=Arg1.re; ArgW.im:=Arg1.im;
                               carccos_acc(ArgW,ResW);
                               Res.re:=ResW.re; Res.im:=ResW.im;
                           end;

                         IsEval:=True;
                   end; {.329}
       CM_ARCTAN:  begin
                           if F_FAST_STD_FUNC = True then
                               _EvalFunc1Cx(@Z_ARCTAN,Arg1,Res)
                           else
                           begin
                               ArgW.re:=Arg1.re; ArgW.im:=Arg1.im;
                               carctan_acc(ArgW,ResW);
                               Res.re:=ResW.re; Res.im:=ResW.im;
                           end;

                           IsEval:=True;
                     end; {.329}
       CM_ARCCOTAN:  begin
                           if F_FAST_STD_FUNC = True then
                                _EvalFunc1Cx(@Z_ARCCOTAN,Arg1,Res)
                           else
                           begin
                               ArgW.re:=Arg1.re; ArgW.im:=Arg1.im;
                               carccot_acc(ArgW,ResW);
                               Res.re:=ResW.re; Res.im:=ResW.im;
                           end;

                           IsEval:=True;
                     end; {.329}
       CM_ARCSINH:   begin    {.335}
                           if F_FAST_STD_FUNC = True then
                                _EvalFunc1Cx(@Z_ARCSINH,Arg1,Res)
                           else
                           begin
                               ArgW.re:=Arg1.re; ArgW.im:=Arg1.im;
                               carcsinh_acc(ArgW,ResW);
                               Res.re:=ResW.re; Res.im:=ResW.im;
                           end;

                             IsEval:=True;
                     end; {.329}
       CM_ARCCOSH:   begin    {.335}

                           if F_FAST_STD_FUNC = True then
                               _EvalFunc1Cx(@Z_ARCCOSH,Arg1,Res)
                           else
                           begin
                               ArgW.re:=Arg1.re; ArgW.im:=Arg1.im;
                               carccosh_acc(ArgW,ResW);
                               Res.re:=ResW.re; Res.im:=ResW.im;
                           end;

                          IsEval:=True;
                     end; {.329}
       CM_ARCTANH:   begin    {.335}
                           if F_FAST_STD_FUNC = True then
                               _EvalFunc1Cx(@Z_ARCTANH,Arg1,Res)
                           else
                           begin
                               ArgW.re:=Arg1.re; ArgW.im:=Arg1.im;
                               carctanh_acc(ArgW,ResW);
                               Res.re:=ResW.re; Res.im:=ResW.im;
                           end;
                           IsEval:=True;
                     end; {.329}
       CM_ARCCOTANH: begin  {.335}
                          if F_FAST_STD_FUNC = True then
                                _EvalFunc1Cx(@Z_ARCCOTANH,Arg1,Res)
                           else
                           begin
                               ArgW.re:=Arg1.re; ArgW.im:=Arg1.im;
                               carccoth_acc(ArgW,ResW);
                               Res.re:=ResW.re; Res.im:=ResW.im;
                           end;

                            IsEval:=True;
                     end; {.329}
       CM_SEC:       begin  _EvalFunc1Cx(@Z_SEC,Arg1,Res);      IsEval:=True; end; {.329}
       CM_COSEC:     begin  _EvalFunc1Cx(@Z_COSEC,Arg1,Res);   IsEval:=True; end; {.329}
       CM_SECH:      begin  _EvalFunc1Cx(@Z_SECH,Arg1,Res);      IsEval:=True; end; {.329}
       CM_COSECH:    begin  _EvalFunc1Cx(@Z_COSECH,Arg1,Res);    IsEval:=True; end; {.329}
       CM_ARCSEC:    begin
                           if F_FAST_STD_FUNC = True then
                              _EvalFunc1Cx(@Z_ARCSEC,Arg1,Res)
                           else
                           begin
                               ArgW.re:=Arg1.re; ArgW.im:=Arg1.im;
                               carcsec_acc(ArgW,ResW);
                               Res.re:=ResW.re; Res.im:=ResW.im;
                           end;

                           IsEval:=True;

                     end; {.329}
       CM_ARCCOSEC:  begin
                         if F_FAST_STD_FUNC = True then
                               _EvalFunc1Cx(@Z_ARCCOSEC,Arg1,Res)
                           else
                           begin
                               ArgW.re:=Arg1.re; ArgW.im:=Arg1.im;
                               carccsc_acc(ArgW,ResW);
                               Res.re:=ResW.re; Res.im:=ResW.im;
                           end;

                          IsEval:=True;
                     end; {.329}
       CM_ARCSECH:   begin   {.335}
                          if F_FAST_STD_FUNC = True then
                                _EvalFunc1Cx(@Z_ARCSECH,Arg1,Res)
                          else
                          begin
                               ArgW.re:=Arg1.re; ArgW.im:=Arg1.im;
                               carcsech_acc(ArgW,ResW);
                               Res.re:=ResW.re; Res.im:=ResW.im;
                          end;

                           IsEval:=True;
                     end; {.329}
       CM_ARCCOSECH:  begin   {.335}
                          if F_FAST_STD_FUNC = True then
                                _EvalFunc1Cx(@Z_ARCCOSECH,Arg1,Res)
                          else
                          begin
                               ArgW.re:=Arg1.re; ArgW.im:=Arg1.im;
                               carccsch_acc(ArgW,ResW);
                               Res.re:=ResW.re; Res.im:=ResW.im;
                          end;

                            IsEval:=True;
                      end; {.329}
       CM_LOG2:       begin ArgR.re:=2;  _EvalFunc2Cx(@Z_ReCxLOG,ArgR,Arg1,T_Real,T_Complex,Res);   IsEval:=True; end;
       CM_LOG10:      begin ArgR.re:=10; _EvalFunc2Cx(@Z_ReCxLOG,ArgR,Arg1,T_Real,T_Complex,Res);   IsEval:=True; end;
       CM_IPWRSGN:    begin _EvalFunc1Cx(@Z_IPWRSGN,Arg1,Res);   IsEval:=True; end;
       CM_ABS:        begin Res.re:=sqrt(sqr(Arg1.re)+sqr(Arg1.im));   IsEval:=True; end;
       CM_SIGN:       begin        {.334}
                            if Arg1.re > 0 then Res.re:=1
                            else
                            if Arg1.re < 0 then Res.re:=-1
                            else
                            if Arg1.im > 0 then Res.re:=1
                            else
                            if Arg1.im < 0 then Res.re:=-1
                            else Res.re:=0;
                            IsEval:=True;
                      end;

       CM_ARG:        begin Res.re:=arctan2_acc(Arg1.im,Arg1.re);   IsEval:=True; end;  {.361}


       CM_IPWR:   begin
                       if (PNE^.AI = 2) and (PNE^.TA2 = _IntConst) then //Expr^IntConst
                       begin
                          IC:=PNE^.IC2;
                          _EvalFunc1CxInt(@Z_IPWR,Arg1,IC,Res);
                            IsEval:=True;
                       end
                       else
                       IsEval:=False;
                   end;

       CM_IPWR16:  begin                       //Expr^(+- 1..16)
                          IC:=PNE^.AI;
                          _EvalFunc1CxInt(@Z_IPWR,Arg1,IC,Res);
                            IsEval:=True;
                   end;

      CM_IROOT:   begin
                       if (PNE^.AI = 2) and (PNE^.TA2 = _IntConst) then //root(Expr,IntConst)
                       begin
                          IC:=PNE^.IC2;
                          _EvalFunc1CxInt(@Z_CxIROOT,Arg1,IC,Res);
                            IsEval:=True;
                       end
                       else
                       if (PNE^.AI = 3) and (PNE^.TA1 = _IntConst) and (PNE^.TA2 = _IntConst) then //root(Expr,IntConst1,IntConst2)
                       begin
                           IC1:=PNE^.IC1;
                           IC2:=PNE^.IC2;
                          _EvalFunc1CxInt2(@Z_CxIROOT3Int,Arg1,IC1,IC2,Res);
                            IsEval:=True;
                       end
                       else
                       IsEval:=False;
                   end;

       CM_CZPWR:   begin

                       if PNE^.AI = 1 then   ArgType1:=T_Real else
                       if PNE^.AI = 2 then   ArgType1:=T_Complex;
                       ArgType2:=Alg.ExFunc[PNE^.NFunc].Func[PNE^.NF].TV[0];
                       //или ArgType2:=PNE^.TypeA;


                       (*if (ArgType1 = T_Real) and (ArgType2 = T_Real) then
                       begin
                         Res.re:=power_acc(PNE^.FD,Arg1.re);
                         IsEval:=True;
                         ResType:=T_Real;
                         //исключение, т.к. тип рез-та однозначно не определяется заданием ф-ии в Alg.ExFunc[NFunc].Func[NF].TV[0];
                       end
                       else *)
                       if  (ArgType1 = T_Real) and (ArgType2 = T_Complex) then
                       begin
                             Arg2:=Arg1;
                             Arg1.re:=PNE^.FD; Arg1.im:=0;
                            _EvalFunc2Cx(@Z_ReCxFPWR,Arg1,Arg2,ArgType1,ArgType2,Res);
                             IsEval:=True;
                             ResType:=T_Complex;
                            //исключение, т.к. тип рез-та однозначно не определяется заданием ф-ии в Alg.ExFunc[NFunc].Func[NF].TV[0];
                       end
                       else
                       (*
                       if  (ArgType1 = T_Complex) and (ArgType2 = T_Real) then
                       begin
                              Arg2:=Arg1;
                              Arg2.im:=0;
                              Arg1.re:=PNE^.FDC.re; Arg1.im:=PNE^.FDC.im;
                             _EvalFunc2Cx(@Z_CxReFPWR,Arg1,Arg2,ArgType1,ArgType2,Res);
                              IsEval:=True;
                              ResType:=T_Complex;
                              //исключение, т.к. тип рез-та однозначно не определяется заданием ф-ии в Alg.ExFunc[NFunc].Func[NF].TV[0];
                       end
                       else *)
                       if  (ArgType1 = T_Complex) and (ArgType2 = T_Complex) then
                       begin
                              Arg2:=Arg1;
                              Arg1.re:=PNE^.FDC.re; Arg1.im:=PNE^.FDC.im;
                             _EvalFunc2Cx(@ZPWR,Arg1,Arg2,ArgType1,ArgType2,Res);
                              IsEval:=True;
                              ResType:=T_Complex;
                             //исключение, т.к. тип рез-та однозначно не определяется заданием ф-ии в Alg.ExFunc[NFunc].Func[NF].TV[0];
                       end;

                   end;

     CM_IMURZPWR:  begin
                              if PNE^.AI = 1 then
                              begin
                                 _EvalFunc1Cx(@Z_ImU_CxFPWR,Arg1,Res);
                                 ResType:=T_Complex;
                                 IsEval:=True;
                              end
                              else      //AI=2
                              begin
                                _EvalFunc1Cx(@Z_ImUNeg_CxFPWR,Arg1,Res);
                                 ResType:=T_Complex;
                                 IsEval:=True;
                              end;
                    end;


      else         begin     //  _External
                      FName:=Alg.ExFunc[NFunc].Name;
                       if FName = 'gamma'    then  begin _EvalFunc1Cx(@Z_GAMMA,Arg1,Res) ;   IsEval:=True; end
                       else
                       if FName = 'lngamma'    then  begin _EvalFunc1Cx(@Z_LNGAMMA,Arg1,Res) ;   IsEval:=True; end  {.334}
                       else
                       if FName = 'psi'    then  begin _EvalFunc1Cx(@Z_PSI,Arg1,Res) ;   IsEval:=True; end  {.334}
                       else
                       if FName = 'zeta'    then  begin _EvalFunc1Cx(@Z_ZETA,Arg1,Res) ;   IsEval:=True; end  {.334}
                       else
                       if    (F_CalcConstExtFunc = True) and
                             (Alg.ExFunc[NFunc].Func[NF].IntF = _External) and
                             (Alg.ExFunc[NFunc].Func[NF].Addr <> 0)
                       then  begin EvalFuncN(PNE,Res,IsEval);   IsEval:=True; end
                       else
                       IsEval:=False;
                   end;


     end;


  end ;

end;



procedure TForevalH._EvalFunc2({NFunc,NF: Integer;}PNE: PNode; Arg1,Arg2: TComplex; var Res: TComplex; var IsEval: Boolean);
var
 TV1,TV2,TypeF,NFunc,NF: Integer;
 Addr: Pointer;
 FName: String;
begin

  NFunc:=PNE^.NFunc; NF:=PNE^.NF;
  TypeF:=Alg.ExFunc[NFunc].Func[NF].TypeF;
  TV1:=Alg.ExFunc[NFunc].Func[NF].TV[0];
  TV2:=Alg.ExFunc[NFunc].Func[NF].TV[1];

  //IsEval:=True;
  IsEval:=False;   {.329}
  Res.re:=0;   Res.im:=0;

  if (TV1 = T_Real) and (TV2 = T_Real)  then
  begin
     case NFunc of
       CM_POWER:     begin Res.re:=power_acc(Arg1.re,Arg2.re);  IsEval:=True; end; {.329}
       CM_COMPLEX:   begin Res.re:=Arg1.re; Res.im:=Arg2.re;   IsEval:=True; end; {.329}
       CM_ARCTAN2:   begin Res.re:=arctan2_acc(Arg1.re,Arg2.re);   IsEval:=True; end; {.329}
       CM_LOGN:      begin Res.re:=fc_logn(Arg1.re,Arg2.re);    IsEval:=True; end; {.329}
       CM_ROOT:      begin _EvalFunc1ReInt(@R_IROOT,Arg1.re,round(Arg2.re),Res.re);     IsEval:=True; end; {.329}
       CM_DECART:    begin Arg1.im:=Arg2.re; _EvalFunc1Cx(@R_Decart,Arg1,Res);   IsEval:=True; end; {.329}

       else
       begin
         FName:=Alg.ExFunc[NFunc].Name;
         if FName = 'besseljn' then      begin Res.re:=sfc_jn(round(Arg1.re),Arg2.re);   IsEval:=True; end {.329} else
         if FName = 'besselyn' then      begin Res.re:=sfc_yn(round(Arg1.re),Arg2.re);   IsEval:=True; end else
         if FName = 'sphbesseljn' then   begin Res.re:=sfc_sph_jn(round(Arg1.re),Arg2.re); IsEval:=True; end  else
         if FName = 'legendrep' then     begin Res.re:=sfc_legendre_p(round(Arg1.re),Arg2.re);   IsEval:=True; end else
         if FName = 'chebyshevt' then    begin Res.re:=sfc_chebyshev_t(round(Arg1.re),Arg2.re);   IsEval:=True; end else
         if FName = 'chebyshevu' then    begin Res.re:=sfc_chebyshev_u(round(Arg1.re),Arg2.re);   IsEval:=True; end else
         if FName = 'laguerrep' then     begin Res.re:=sfc_laguerre(round(Arg1.re),Arg2.re);   IsEval:=True; end else
         if FName = 'hermitep' then      begin Res.re:=sfc_hermite_h(round(Arg1.re),Arg2.re);   IsEval:=True; end else

         if   (F_CalcConstExtFunc = True) and
              (Alg.ExFunc[NFunc].Func[NF].IntF = _External) and
              (Alg.ExFunc[NFunc].Func[NF].Addr <> 0) then begin EvalFuncN(PNE,Res,IsEval);   IsEval:=True; end
       end;
       //IsEval:=False;
     end;

  end
  else
  if  (TV1 = T_Complex) and (TV2 = T_Complex)  then
  begin
     case NFunc of
       CM_POWER:   begin  _EvalFunc2Cx(@ZPWR,Arg1,Arg2,TV1,TV2,Res);   IsEval:=True; end; {.329}
       CM_LOGN:    begin  _EvalFunc2Cx(@Z_CxCxLOG,Arg1,Arg2,TV1,TV2,Res); IsEval:=True; end; {.329}


       else
       begin
         FName:=Alg.ExFunc[NFunc].Name;

         if    (F_CalcConstExtFunc = True) and
               (Alg.ExFunc[NFunc].Func[NF].IntF = _External) and
               (Alg.ExFunc[NFunc].Func[NF].Addr <> 0) then begin EvalFuncN(PNE,Res,IsEval);  IsEval:=True; end; {.329}
       end;
        //IsEval:=False;
     end;


  end
  else
  if (TV1 = T_Real) and (TV2 = T_Complex)  then
  begin
     case NFunc of
       CM_POWER:    begin _EvalFunc2Cx(@Z_ReCxFPWR,Arg1,Arg2,TV1,TV2,Res);  IsEval:=True; end; {.329}
       CM_LOGN:     begin _EvalFunc2Cx(@Z_ReCxLog,Arg1,Arg2,TV1,TV2,Res); IsEval:=True; end; {.329}

       else
       begin
         FName:=Alg.ExFunc[NFunc].Name;

         if    (F_CalcConstExtFunc = True) and
               (Alg.ExFunc[NFunc].Func[NF].IntF = _External) and
               (Alg.ExFunc[NFunc].Func[NF].Addr <> 0) then begin EvalFuncN(PNE,Res,IsEval);  IsEval:=True; end; {.329}
       end;
       //IsEval:=False;
     end;


  end
  else
  if  (TV1 = T_Complex) and (TV2 = T_Real)  then
  begin
    case NFunc of
       CM_POWER:    begin _EvalFunc2Cx(@Z_CxReFPWR,Arg1,Arg2,TV1,TV2,Res);  IsEval:=True; end; {.329}
       CM_LOGN:     begin _EvalFunc2Cx(@Z_CxReLog,Arg1,Arg2,TV1,TV2,Res);  IsEval:=True; end; {.329}
       CM_ROOT:     begin _EvalFunc1CxInt(@Z_CxIROOT,Arg1,round(Arg2.re),Res); IsEval:=True; end; {.329}


       else
       begin
         FName:=Alg.ExFunc[NFunc].Name;

         if    (F_CalcConstExtFunc = True) and
               (Alg.ExFunc[NFunc].Func[NF].IntF = _External) and
               (Alg.ExFunc[NFunc].Func[NF].Addr <> 0) then begin  EvalFuncN(PNE,Res,IsEval);  IsEval:=True; end; {.329}
       end;
       //IsEval:=False;
     end;
  end

end;




procedure TForevalH.GetConstArg1(PNE: PNode; var Re1,Im1: Extended; var ResT1: Integer);
var
TC1,COP1: Integer;
PN1: PNode;
begin
    {Если арумент функции func1(arg1) не константа , то ResT1 = NO_Const}

  PN1:=PNE^.Ch;
  //ResT1:=PN1^.TypeF;
  TC1:=PN1^.TC;
  COP1:=PN1^.COP;

  ResT1:=NO_Const;

  if (COP1 = _LDSC) then
  begin
   ResT1:=T_Real;
   Re1:=PN1^.FD; Im1:=0.0;
  end
  else
  if (COP1 = _LDINTFORM)  and (PN1^.TA1 = _IntConst) then
  begin
   ResT1:=T_Real;
   Re1:=PN1^.IC1; Im1:=0.0;
  end
  else
  if (COP1 = _LDSCX) then
  begin
    if TC1 = C_Complex then
    begin
       ResT1:=T_Complex;
       Re1:=PN1^.FDC.re; Im1:=PN1^.FDC.im;
    end
    else
    if TC1 = C_Image then
    begin
       ResT1:=T_Complex;
       Re1:=0.0; Im1:=PN1^.FDC.im;
    end
    else
    if TC1 = C_Real then
    begin
       ResT1:=T_Real;
       Re1:=PN1^.FDC.re; Im1:=0.0;
    end
  end ;

end;




procedure TForevalH.GetConstArg2(PNE: PNode; var Re1,Im1,Re2,Im2: Extended; var ResT1,ResT2: Integer);
var
TC1,TC2,COP1,COP2: Integer;
PN1,PN2: PNode;
begin
  {Если арументы функции func2(arg1,arg2) не константы , то ResT1,ResT2 = NO_Const}

  PN1:=PNE^.Ch; PN2:=PN1^.Nb;
  //ResT1:=PN1^.TypeF;     ResT2:=PN2^.TypeF;
  TC1:=PN1^.TC;   TC2:=PN2^.TC;
  COP1:=PN1^.COP;  COP2:=PN2^.COP;

  ResT1:=NO_Const;  ResT2:=NO_Const;

 if (COP1 = _LDSC) then
 begin
   ResT1:=T_Real;
   Re1:=PN1^.FD; Im1:=0.0;
 end
 else
 if (COP1 = _LDINTFORM)  and (PN1^.TA1 = _IntConst) then
 begin
   ResT1:=T_Real;
   Re1:=PN1^.IC1; Im1:=0.0;
 end
 else
 if (COP1 = _LDSCX) then
 begin
    if TC1 = C_Complex then
    begin
       ResT1:=T_Complex;
       Re1:=PN1^.FDC.re; Im1:=PN1^.FDC.im;
    end
    else
    if TC1 = C_Image then
    begin
       ResT1:=T_Complex;
       Re1:=0.0; Im1:=PN1^.FDC.im;
    end
    else
    if TC1 = C_Real then
    begin
       ResT1:=T_Real;
       Re1:=PN1^.FDC.re; Im1:=0.0;
    end
 end ;


 if (COP2 = _LDSC) then
 begin
   ResT2:=T_Real;
   Re2:=PN2^.FD; Im2:=0.0;
 end
 else
 if (COP2 = _LDINTFORM)  and (PN2^.TA1 = _IntConst) then
 begin
   ResT2:=T_Real;
   Re2:=PN2^.IC1; Im1:=0.0;
 end
 else
 if (COP2 = _LDSCX) then
 begin
    if TC2 = C_Complex then
    begin
       ResT2:=T_Complex;
       Re2:=PN2^.FDC.re; Im2:=PN2^.FDC.im;
    end
    else
    if TC2 = C_Image then
    begin
       ResT2:=T_Complex;
       Re2:=0.0; Im2:=PN2^.FDC.im;
    end
    else
    if TC2 = C_Real then
    begin
       ResT2:=T_Real;
       Re2:=PN2^.FDC.re; Im2:=0.0;
    end
 end ;

end;






function TForevalH.EvalConstFunc0(PNE: PNode): Boolean;
label endp;
var
Re1,Im1,Re2,Im2,ResF: Extended;
ResT1,ResT2,NFunc,NF,NArg,TypeF,TV1: Integer;
Answ,IsEval: Boolean;
Arg1,Res: TComplex;
begin
if F_InternalError <> 0  then goto endp;  {.322}

try
TryFPUMask; {.326}
Answ:=False;

//if True then


      NFunc:=PNE^.NFunc; NF:=PNE^.NF;
      //NArg:=Alg.ExFunc[NFunc].Func[NF].NArg;
      //TypeF:=Alg.ExFunc[NFunc].Func[NF].TypeF;
      //TV1:=Alg.ExFunc[NFunc].Func[NF].TV[0];

      if (NFunc = CM_FACT) and  (PNE^.AI = 1) and (PNE^.TA1 = _IntConst) then
          begin Res.re:=factorial[PNE^.IC1]; Answ:=True; end
      else
      if (NFunc = CM_FACT2) and  (PNE^.AI = 1) and (PNE^.TA1 = _IntConst) then
           begin Res.re:=factorial2F[PNE^.IC1];  Answ:=True; end
      else
      if (NFunc = CM_F2PWR) and  (PNE^.AI = 1) and (PNE^.TA2 = _IntConst) then
           begin Res.re:=power_acc(2,PNE^.IC2); Answ:=True; end
      else                   {.361}
       if (NFunc = {CM_IPWRSGN}CM_REUNEGIPWR ) and  (PNE^.AI = 1) and (PNE^.TA2 = _IntConst) then
           begin Res.re:=power_acc(-1,PNE^.IC2); Answ:=True; end;




      if Answ = True then
      begin
              PNE^.FD:=Res.re;
              PNE^.COP := _LDSC;
              PNE^.TypeF:=T_Real;
      end;

EvalConstFunc0:=Answ;

TryCatchFPUException;    {.326}
except {.322}
 on E: EZeroDivide      do F_InternalError:=E_ZeroDivide;
 on E: EInvalidOp       do F_InternalError:=E_InvalidOp;
 on E: EOverFlow        do F_InternalError:=E_OverFlow;
 on E: EUnderFlow       do F_InternalError:=E_UnderFlow;
 on E: EIntOverFlow     do F_InternalError:=E_IntOverFlow;
 on E: EAccessViolation do F_InternalError:=E_AccessViolation;
 on E: EOutOfMemory     do F_InternalError:=E_OutOfMemory;
 on E: EStackOverFlow   do F_InternalError:=E_StackOverFlow
end;

if F_InternalError <> 0 then F_SyntaxErrorCode:=E_INTERNAL_ERROR_AT_CALCULATION;    {.326}

endp:
end;



function TForevalH.EvalConstFunc1(PNE: PNode): Boolean;
label endp;
var
Re1,Im1,Re2,Im2,ResF: Extended;
ResT1,ResT2,NFunc,NF,NArg,TypeF,TV1,ResType: Integer;
Answ,IsEval: Boolean;
Arg1,Res: TComplex;
begin
if F_InternalError <> 0  then goto endp;  {.322}

try
TryFPUMask; {.326}

Answ:=False;

   GetConstArg1(PNE,Re1,Im1,ResT1);

   if (ResT1 <> NO_Const)  then       //if Arg = const
   begin
      NFunc:=PNE^.NFunc; NF:=PNE^.NF;
      NArg:=Alg.ExFunc[NFunc].Func[NF].NArg;
      TypeF:=Alg.ExFunc[NFunc].Func[NF].TypeF;
      TV1:=Alg.ExFunc[NFunc].Func[NF].TV[0];

      if TV1 = ResT1 then
      begin
         Arg1.re:=Re1; Arg1.im:=Im1;
         _EvalFunc1({NFunc,NF,}PNE,Arg1,Res,ResType,IsEval);

         if IsEval = True then
         begin
               {.361}
           if {TypeF}ResType = T_Real then
           begin
              PNE^.FD:=Res.re;
              PNE^.COP := _LDSC;
              PNE^.TypeF:=T_Real;
           end
           else    {.361}
           if {TypeF}ResType = T_Complex then
           begin
              PNE^.FDC.re:=Res.re;
              PNE^.FDC.im:=Res.im;
              PNE^.COP := _LDSCX;
              PNE^.TypeF:=T_Complex;
           end;

           if PNE^.COP = _LDSCX then PNE^.TC := C_Complex;
           Answ:=True;

         end
         else
           Answ:=False;


      end
      else
      begin {Internal ERROR !!!} end;




   end;


EvalConstFunc1:=Answ;

TryCatchFPUException;    {.326}
except {.322}
 on E: EZeroDivide      do F_InternalError:=E_ZeroDivide;
 on E: EInvalidOp       do F_InternalError:=E_InvalidOp;
 on E: EOverFlow        do F_InternalError:=E_OverFlow;
 on E: EUnderFlow       do F_InternalError:=E_UnderFlow;
 on E: EIntOverFlow     do F_InternalError:=E_IntOverFlow;
 on E: EAccessViolation do F_InternalError:=E_AccessViolation;
 on E: EOutOfMemory     do F_InternalError:=E_OutOfMemory;
 on E: EStackOverFlow   do F_InternalError:=E_StackOverFlow
end;

if F_InternalError <> 0 then F_SyntaxErrorCode:=E_INTERNAL_ERROR_AT_CALCULATION;    {.326}

endp:
end;




function TForevalH.EvalConstFunc2(PNE: PNode): Boolean;
label endp;
var
Re1,Im1,Re2,Im2: Extended;
ResT1,ResT2,NFunc,NF,NArg,TypeF,TV1,TV2: Integer;
Answ,IsEval: Boolean;
Arg1,Arg2,Res: TComplex;
NodeT: PNode;
S: String;
DataArg: TDataArg;
begin
if F_InternalError <> 0  then goto endp;  {.322}

try
TryFPUMask; {.326}

Answ:=False;

   GetConstArg2(PNE,Re1,Im1,Re2,Im2,ResT1,ResT2);

   if (ResT1 <> NO_Const) and (ResT2 <> NO_Const) then      //if Arg1&Arg2 = const
   begin
      NFunc:=PNE^.NFunc; NF:=PNE^.NF;
      NArg:=Alg.ExFunc[NFunc].Func[NF].NArg;
      TypeF:=Alg.ExFunc[NFunc].Func[NF].TypeF;
      TV1:=Alg.ExFunc[NFunc].Func[NF].TV[0];
      TV2:=Alg.ExFunc[NFunc].Func[NF].TV[1];

      if (TV1 = ResT1) and (TV2 = ResT2) then
      begin

           Arg1.re:=Re1; Arg1.im:=Im1;
           Arg2.re:=Re2; Arg2.im:=Im2;
          _EvalFunc2({NFunc,NF,}PNE,Arg1,Arg2,Res,IsEval);

         if IsEval = True then
         begin

           if TypeF = T_Real then
           begin
             PNE^.FD:=Res.re;
             PNE^.COP := _LDSC;
             PNE^.TypeF:=T_Real;
           end
           else
           if TypeF = T_Complex then
           begin
              PNE^.FDC.re:=Res.re;
              PNE^.FDC.im:=Res.im;
              PNE^.COP := _LDSCX;
              PNE^.TypeF:=T_Complex;
           end;

          if PNE^.COP = _LDSCX then PNE^.TC := C_Complex;
          Answ:=True;
         end
         else
         Answ:=False;




      end
      else
      begin {Internal ERROR !!!} end;


   end
   else
   if F_ReduceArgOptimizator = True then
   begin
      if (ResT1 <> NO_Const) and (ResT2 = NO_Const) then
      begin
        DataArg.Re1:=Re1; DataArg.Im1:=Im1; DataArg.ResT1:=ResT1;
        DataArg.Re2:=Re2; DataArg.Im2:=Im2; DataArg.ResT2:=ResT2;
        ReduceArgOptimizator(PNE,DataArg);
      end;
   end;




EvalConstFunc2:=Answ;

TryCatchFPUException;    {.326}
except {.322}
 on E: EZeroDivide      do F_InternalError:=E_ZeroDivide;
 on E: EInvalidOp       do F_InternalError:=E_InvalidOp;
 on E: EOverFlow        do F_InternalError:=E_OverFlow;
 on E: EUnderFlow       do F_InternalError:=E_UnderFlow;
 on E: EIntOverFlow     do F_InternalError:=E_IntOverFlow;
 on E: EAccessViolation do F_InternalError:=E_AccessViolation;
 on E: EOutOfMemory     do F_InternalError:=E_OutOfMemory;
 on E: EStackOverFlow   do F_InternalError:=E_StackOverFlow
end;

if F_InternalError <> 0 then F_SyntaxErrorCode:=E_INTERNAL_ERROR_AT_CALCULATION;    {.326}

endp:
end;




procedure TForevalH.ReduceArgOptimizator(PNE: PNode; DataArg: TDataArg);
label endp;
var
Re1,Im1,Re2,Im2: Extended;
ResT1,ResT2,NFunc,NF,NArg,TypeF,TV1,TV2: Integer;
Answ,IsEval: Boolean;
Arg1,Arg2,Res: TComplex;
NodeT: PNode;
S: String;
begin

NFunc:=PNE^.NFunc;

if NFunc = CM_POWER then
begin

   NF:=PNE^.NF;
   TV1:=Alg.ExFunc[NFunc].Func[NF].TV[0];
   TV2:=Alg.ExFunc[NFunc].Func[NF].TV[1];

   if (DataArg.ResT1 = T_Real) and (DataArg.ResT2 = NO_Const) then
   begin


      //NArg:=Alg.ExFunc[NFunc].Func[NF].NArg;
      //TypeF:=Alg.ExFunc[NFunc].Func[NF].TypeF;
      //NF:=PNE^.NF;
      //TV1:=Alg.ExFunc[NFunc].Func[NF].TV[0];
      //TV2:=Alg.ExFunc[NFunc].Func[NF].TV[1];

      if (TV1 = T_Real) and (TV2 = T_Real) then
      begin
         //((1+4*(1+2/50))^x)*((1+3*(1+2/3))^((1+3*(1+2/30))^x))
         //(sin(a-b)*cos(b/c))^(x)
         //sin(x)*((1+(1+2/3))^((1+(1+2/30))^x))
         //sin(x)*((1+2/3)^((1+2/30)^x))

         {if TV1 = T_Real then PNE^.AI:=1 else
         if TV1 = T_Complex then PNE^.AI:=2;}


         FreeChldNode(PNE,1);
         PNE^.AI:=1;
         PNE^.NFunc:=CM_CZPWR;
         //PNE^.NF:=0;     // (=> T_Real) !!! используется в LoadArg1
         PNE^.NF:=GetIdArgFunc1A(PNE^.NFunc,1,TV2);
         PNE^.TypeA:=T_Real; //Тип аргумента, т.к. в определении CM_CZPWR нет однозначного соответствия (зависит ещё и от типа константы - первый аргумент)
         PNE^.FD:=DataArg.Re1;
         //PNE^.FD1:=fc_Log2(DataArg.Re1);
         PNE^.N:=1;

      end
      else
      if (TV1 = T_Real) and (TV2 = T_Complex) then
      begin
         FreeChldNode(PNE,1);
         PNE^.AI:=1;
         PNE^.NFunc:=CM_CZPWR;
         //PNE^.NF:=1;   // (=>  T_Complex) !!! используется в LoadArg1
         PNE^.NF:=GetIdArgFunc1A(PNE^.NFunc,1,TV2);
         PNE^.TypeA:=T_Complex;
         PNE^.FD:=DataArg.Re1;
         //PNE^.FD1:=fc_Log2(DataArg.Re1);
         PNE^.N:=1;
      end;

   end
   else
   if (DataArg.ResT1 = T_Complex) and (DataArg.ResT2 = NO_Const) then
   begin

      if (TV1 = T_Complex) and (TV2 = T_Real) then
      begin
         FreeChldNode(PNE,1);
         if (DataArg.Re1  = -1) and  (DataArg.Im1  = 0) then
         begin
           PNE^.AI:=2;
           PNE^.NFunc:=CM_IPWRSGN;
           //PNE^.NF:=0;     // (=> T_Real) !!! используется в LoadArg1
           PNE^.NF:=GetIdArgFunc1A(PNE^.NFunc,1,T_Real);
           PNE^.TypeA:=T_Real;
           PNE^.N:=1;
         end
         else
         if (DataArg.Re1  = 0) and  (DataArg.Im1  = 1) then
         begin
           PNE^.AI:=1;
           PNE^.NFunc:=CM_IMURZPWR;
           //PNE^.NF:=0;     // (=> T_Real) !!! используется в LoadArg1
           PNE^.NF:=GetIdArgFunc1A(PNE^.NFunc,1,T_Real);
           PNE^.TypeA:=T_Real;
           PNE^.N:=1;
         end
         else
         if (DataArg.Re1  = 0) and  (DataArg.Im1  = -1) then
         begin
           PNE^.AI:=2;
           PNE^.NFunc:=CM_IMURZPWR;
           //PNE^.NF:=0;     // (=> T_Real) !!! используется в LoadArg1
           PNE^.NF:=GetIdArgFunc1A(PNE^.NFunc,1,T_Real);
           PNE^.TypeA:=T_Real;
           PNE^.N:=1;
         end
         else
         begin
           PNE^.AI:=2;
           PNE^.NFunc:=CM_CZPWR;
           //PNE^.NF:=0;     // (=> T_Real) !!! используется в LoadArg1
           PNE^.NF:=GetIdArgFunc1A(PNE^.NFunc,1,TV2);
           PNE^.FDC.re:=DataArg.Re1;
           PNE^.FDC.im:=DataArg.Im1;
           PNE^.TypeA:=T_Real;
           PNE^.N:=1;
         end;
      end
      else
      if (TV1 = T_Complex) and (TV2 = T_Complex) then
      begin

         FreeChldNode(PNE,1);
         if (DataArg.Re1  = -1) and  (DataArg.Im1  = 0) then
         begin
           PNE^.AI:=0;
           PNE^.NFunc:=CM_IPWRSGN;
           //PNE^.NF:=0;     // (=> T_Real) !!! используется в LoadArg1
           PNE^.NF:=GetIdArgFunc1A(PNE^.NFunc,1,T_Complex);
           PNE^.TypeA:=T_Complex;
           PNE^.N:=1;
         end
         else
         if (DataArg.Re1  = 0) and  (DataArg.Im1  = 1) then
         begin
           PNE^.AI:=1;
           PNE^.NFunc:=CM_IMURZPWR;
           //PNE^.NF:=0;     // (=> T_Complex) !!! используется в LoadArg1
           PNE^.NF:=GetIdArgFunc1A(PNE^.NFunc,1,T_Complex);
           PNE^.TypeA:=T_Real;
           PNE^.N:=1;
         end
         else
         if (DataArg.Re1  = 0) and  (DataArg.Im1  = -1) then
         begin
           PNE^.AI:=2;
           PNE^.NFunc:=CM_IMURZPWR;
           //PNE^.NF:=0;     // (=> T_Complex) !!! используется в LoadArg1
           PNE^.NF:=GetIdArgFunc1A(PNE^.NFunc,1,T_Complex);
           PNE^.TypeA:=T_Real;
           PNE^.N:=1;
         end
         else
         begin
           PNE^.AI:=2;
           PNE^.NFunc:=CM_CZPWR;
           //PNE^.NF:=1;   // (=>  T_Complex) !!! используется в LoadArg1
           PNE^.NF:=GetIdArgFunc1A(PNE^.NFunc,1,TV2);
           PNE^.FDC.re:=DataArg.Re1;
           PNE^.FDC.im:=DataArg.Im1;
           PNE^.TypeA:=T_Complex;
           PNE^.N:=1;
         end;
      end;

   end;


    // InitSequentList;
end;


end;





procedure TForevalH.GetConstArg1U(PNArg: PNode; place: integer; var Re1,Im1: Extended; var ResT1: Integer);
var
TC1,COP1: Integer;
//PN1: PNode;
begin
    {Если арумент функции func1(arg1) не константа , то ResT1 = NO_Const}

  //PN1:=PNE^.Ch;

  TC1:=PNArg^.TC;
  COP1:=PNArg^.COP;

  ResT1:=NO_Const;

  if (COP1 = _LDSC) then
  begin
   ResT1:=T_Real;
   Re1:=PNArg^.FD; Im1:=0.0;
  end
  else
  if (COP1 = _LDINTFORM)   then
  begin
    if (place = _First) and  (PNArg^.TA1 = _IntConst) then
    begin
      ResT1:=T_Real;
      Re1:=PNArg^.IC1; Im1:=0.0;
    end
    else
     if (place = _Second) and  (PNArg^.TA2 = _IntConst) then
    begin
      ResT1:=T_Real;
      Re1:=PNArg^.IC2; Im1:=0.0;
    end
  end
  else
  if (COP1 = _LDSCX) then
  begin
    if TC1 = C_Complex then
    begin
       ResT1:=T_Complex;
       Re1:=PNArg^.FDC.re; Im1:=PNArg^.FDC.im;
    end
    else
    if TC1 = C_Image then
    begin
       ResT1:=T_Complex;
       Re1:=0.0; Im1:=PNArg^.FDC.im;
    end
    else
    if TC1 = C_Real then
    begin
       ResT1:=T_Real;
       Re1:=PNArg^.FDC.re; Im1:=0.0;
    end
  end ;

end;



function TForevalH.EvalConstFunc3(PNE: PNode): Boolean;
var
Re1,Im1,Re2,Im2: Extended;
ResT1,ResT2,NFunc,NF,NArg,TypeF,TV1,TV2,TV3: Integer;
Answ,IsEval: Boolean;
Arg1,Arg2,Res: TComplex;
FName: String;
begin
Answ:=False;
{
  NFunc:=PNE^.NFunc;
  FName:=Alg.ExFunc[NFunc].Name;
  if FName = 'root' then
  begin


  end
  else
  Answ:=EvalConstFuncN(PNE);

}

EvalConstFunc3:=Answ;
end;






procedure TForevalH.EvalFuncN(PNE: PNode; var Res: TComplex; var IsEval: Boolean);
label endc, endp;
var
Re1,Im1,Re2,Im2: Extended;
ResT1,ResT2,NFunc,NF,NS,NArg,TypeF,TV1,TV2,COP: Integer;
Answ: Boolean;
Arg1,Arg2: TComplex;
BeginNode,ChNd: PNode;
begin
if F_InternalError <> 0  then goto endp;  {.322}

try
//Answ:=False;
TryFPUMask; {.326}

IsEval:=False;

   NFunc:=PNE^.NFunc; NF:=PNE^.NF;
   NArg:=Alg.ExFunc[NFunc].Func[NF].NArg;
   TypeF:=Alg.ExFunc[NFunc].Func[NF].TypeF;

   NS:=PNE^.Stack.N;
   if Alg.ExFunc[NFunc].Func[NF].CallT = _STACK_INFINITE then NArg:=NS; {.322} //для inf ф-ий текущее число арг. в Stack.N



   ChNd:=PNE^.Ch;
   while ChNd <> nil do
   begin
     COP:=ChNd^.COP;
     if (COP = _LDSC) or  (COP = _LDSCX) or ((COP = _LDINTFORM) and (ChNd^.TA1 = _IntConst))  then
     begin
     end
     else
     begin
        IsEval:=False;
        goto endc;
     end;
     ChNd:=ChNd^.Nb;
   end;

   {
    компиляция func(arg1,arg2,...,argN); arg1,..,argN - константы
    число узлов для компиляции: NArg+1 - arg1,...,argN + функция
    первый узел - первый аргумент: PNE^.Ch, последний - функция
   }
   CompileNodes(PNE^.Ch,NArg+1);


  _EvalFunc(Func.PAddr,TypeF,Res);
  FreeExtFunc(@Func);
  IsEval:=True;

 (*
   if TypeF = T_Real then
   begin
       PNE^.FD:=Res.re;
       PNE^.COP := _LDSC;
       PNE^.TypeF:=T_Real;
   end
   else
   if TypeF = T_Complex then
   begin
       PNE^.FDC.re:=Res.re;
       PNE^.FDC.im:=Res.im;
       PNE^.COP := _LDSCX;
       PNE^.TypeF:=T_Complex;
   end;

  if PNE^.COP = _LDSCX then PNE^.TC := C_Complex;
  Answ:=True;

  *)


endc:
TryCatchFPUException;    {.326}
except {.322}
 on E: EZeroDivide      do F_InternalError:=E_ZeroDivide;
 on E: EInvalidOp       do F_InternalError:=E_InvalidOp;
 on E: EOverFlow        do F_InternalError:=E_OverFlow;
 on E: EUnderFlow       do F_InternalError:=E_UnderFlow;
 on E: EIntOverFlow     do F_InternalError:=E_IntOverFlow;
 on E: EAccessViolation do F_InternalError:=E_AccessViolation;
 on E: EOutOfMemory     do F_InternalError:=E_OutOfMemory;
 on E: EStackOverFlow   do F_InternalError:=E_StackOverFlow
end;

if F_InternalError <> 0 then F_SyntaxErrorCode:=E_INTERNAL_ERROR_AT_CALCULATION;    {.326}

endp:
end;



function TForevalH.EvalConstFuncN(PNE: PNode): Boolean;
label endp;
var
Re1,Im1,Re2,Im2: Extended;
ResT1,ResT2,NFunc,NF,NArg,TypeF,TV1,TV2,COP: Integer;
Answ,IsEval: Boolean;
Arg1,Arg2,Res: TComplex;
BeginNode,ChNd: PNode;
begin
Answ:=False;
if  F_CalcConstExtFunc = False then goto endp;
//IsEval:=True;
  (*
   NFunc:=PNE^.NFunc; NF:=PNE^.NF;
   NArg:=Alg.ExFunc[NFunc].Func[NF].NArg;
   TypeF:=Alg.ExFunc[NFunc].Func[NF].TypeF;

   ChNd:=PNE^.Ch;
   while ChNd <> nil do
   begin
     COP:=ChNd^.COP;
     if (COP = _LDSC) or  (COP = _LDSCX) or ((COP = _LDINTFORM) and (ChNd^.TA1 = _IntConst))  then
     begin
     end
     else
     begin
        Answ:=False;
        goto endp;
     end;
     ChNd:=ChNd^.Nb;
   end;

   CompileNodes(PNE^.Ch,NArg+1);


  _EvalFunc(GFAddr,TypeF,Res);
  *)


   NFunc:=PNE^.NFunc; NF:=PNE^.NF;
   NArg:=Alg.ExFunc[NFunc].Func[NF].NArg;
   if (Alg.ExFunc[NFunc].Func[NF].IntF <> _External) or (Alg.ExFunc[NFunc].Func[NF].Addr = 0) then goto endp;

   TypeF:=Alg.ExFunc[NFunc].Func[NF].TypeF;

   EvalFuncN(PNE,Res,IsEval);

if IsEval = True then
begin

   if TypeF = T_Real then
   begin
       PNE^.FD:=Res.re;
       PNE^.COP := _LDSC;
       PNE^.TypeF:=T_Real;
   end
   else
   if TypeF = T_Complex then
   begin
       PNE^.FDC.re:=Res.re;
       PNE^.FDC.im:=Res.im;
       PNE^.COP := _LDSCX;
       PNE^.TypeF:=T_Complex;
   end;

  if PNE^.COP = _LDSCX then PNE^.TC := C_Complex;
  Answ:=True;

end;



endp:
EvalConstFuncN:=Answ;
end;



procedure TForevalH.CompileNodes(BeginNode: PNode; NNodes: Integer);
label recompile,2,endp;
var
i,j,N,alg,db,db1: Integer;
AH,AB: TArray4;
R: TFloat;
P: Pointer;
X: TFloat;
CS,LCode: Cardinal;
ANL: TArrayC;
S,S1: String;
AdrCmpl,AdrD,AdrS: Pointer;
AdrTst: TAddress;
Node: PNode;
CalcTypeF: Integer;
DataInArrayF: Boolean;
begin
if F_SyntaxErrorCode <> 0 then goto endp;
{
CalcTypeF:=F_CalcType;
F_CalcType:=T_None;
}
DataInArrayF:=F_DataInArray;

//каждый раз инициализация т.к. предыдущее выражение может сбросить F_SaveInFPU:
N_Stack:=0;
_MaxStack:=0;
//F_Opt:=False;
F_ExtFunc:=False;
ES_OverFlow:=False;
F_EnableCheckStack:=True;
F_Mode:=M_Compile;   {.197}



recompile:
new(FuncData); FuncData^.Next:=nil; BFuncData:=FuncData;
SetLength(ICOMP,0);
N_CurrentDataCell:=0;

F_IntermediateLastNode:=False; {.310}
F_DataInArray := False;        {.310}
SetLength(Func.Stack,BeginNode^.S+NNodes+1); {.310}    {.364}

SetLength(GotoLab,0);

CS:=0;
F_JMP:=1;
TE_ADDR:=0;

PUSHAD;

Node:=BeginNode;
//while Node <> nil do
for j := 1 to NNodes do
begin

   Node^.CS:=0;

   if Node^.COP <> _NOP then      //COP=_NOP: только для аргументов замещаемой комманды //for(j,0,1,t=(x^2+x)*(x^2+x) ); t
   begin
      {$IFDEF DEBUGS}
         S:=Node^.Expression;
         db1:=Node^.SData1;
         if db1 = _MEM then S1:='SaveRes:MEM'  else if db1 = _FPU then S1:='SaveRes:FPU';
         dbFPUBefore:=N_Stack; dbFPULoad:=0;
      {$ENDIF}

     S:=Node^.Expression;


      GNode:=Node;

      if j = NNodes then F_IntermediateLastNode:=True;

     // Node^.NC:=Length(ICOMP);

      AddCommand(Node);
     (*
      Node^.NCP:=Length(ICOMP);
      CS:=Length(ICOMP)-CS;
      Node^.CS:=CS+GetLevelsCS(Node{i});
      CS:=Length(ICOMP);
     *)

      {$IFDEF DEBUGS}
        dbMaxLoadCom:=dbFPUBefore+dbFPULoad;
        TestZ.Form1.MT.Lines.Add('"'+S+'"   '+S1+'    loadFPUafter:'+IntToStr(N_Stack)+ '    MaxLoadFPU:'+IntToStr(_MaxStack{dbMaxLoadCom}));
      {$ENDIF}
  end;

  Node:=Node^.Next;
end;

 (*
//расстановка адресов переходов jmp adr
F_JMP:=2;
Node:=BeginNode;
//while Node <> nil do
for j := 1 to NNodes do
begin
  GNode:=Node; //NFunc:=i;
  if Node^.NFunc = CM_JMP then JMP_C;//if Interp[i].NFunc = CM_JMP then JMP_C;
  Node:=Node^.Next;
end;
*)

POPAD;
RET;


//if  (F_SaveInFPU = True) and (_MaxStack > 8) and ({F_Opt = False}F_Mode=M_Compile) then
if  (F_SaveInFPU = True) and (ES_OverFlow = True) and (F_Mode = M_Compile) then    {.300}
begin
//может быть только в случае внутренней ошибки в DinamicLoadOptimizator: неверный расчет Load FPU => защита)
  N_Stack:=0;
  _MaxStack:=0;
  ES_OverFlow:=False;
  FreeData;
  //Db_OverFlow:=True;
  F_SaveInFPU:=False;
  Db_DinLoadOverFlow:=True;
  //S:=CurrentExpression;
  goto recompile;
end;


if F_UseVirtAlloc = False then
begin

  SetLength(Func.Code,Length(ICOMP));
  for i:=0 to High(ICOMP) do
  begin
   Func.Code[i]:=ICOMP[i];
  end;

  Func.Addr:=TAddress(@Func.Code[0]);
  Func.PAddr:=@Func.Code[0];
  Func.CodeSize:=Length(ICOMP);
  Func.AllocMem:=1;

end
else
{
  fzSet(fz_ENABLE, fz_USE_VIRTUAL_ALLOC);
  allows memory for the  code  is allocated  out  by  the system command  instead: command 'SetLength' in a dynamic array.
{
//F_VirtAlloc = True   {.193}
begin     //only for WinXP SP2+;  memory alloc. only for exe code. Use, only if is any errors with standard memory allocating   (SetLength)
  LCode:=Length(ICOMP);
  AdrD:=VirtualAlloc(Nil, LCode, MEM_COMMIT or MEM_RESERVE, PAGE_EXECUTE_READWRITE);
  AdrS:=@ICOMP[0];
  CopyMemory(AdrD,AdrS,LCode);
  Func.Addr:=TAddress(AdrD);
  Func.PAddr:=AdrD;
  Func.CodeSize:=LCode;
  Func.AllocMem:=2;
end;

ICOMP:=nil;
Func.Data:=BFuncData;



ICOMP:=nil;

F_DataInArray := DataInArrayF;
F_IntermediateLastNode:=False;
//F_CalcType:=CalcTypeF;

//PInteger(AdrCmpl)^:=Func.Addr;
{AdrTst:=Func.Addr;
asm
  push eax
  mov eax, AdrTst
  call eax

  pop  eax

end;  }

endp:
end;




function  TForevalH.EvalConstFunc(PNE: PNode): Boolean;
label endp;
var
ResT1,ResT2,ResT,TC1,TC2,COP1,COP2,NFunc,NF,NArg,NS: Integer;
PN1,PN2: PNode;
Re1,Im1,Re2,Im2,RE,IM: Extended;
Answ: Boolean;
begin
if F_InternalError <> 0  then goto endp;  {.322}


  NFunc:=PNE^.NFunc; NF:=PNE^.NF;
  NArg:=Alg.ExFunc[NFunc].Func[NF].NArg;
  NS:=PNE^.Stack.N;
  Answ:=False;

  if NS = NArg then
  begin
     case NArg of
       0:    Answ:=EvalConstFunc0(PNE);
       1:    Answ:=EvalConstFunc1(PNE);
       2:    Answ:=EvalConstFunc2(PNE);
       //3:    Answ:=EvalConstFunc3(PNE);
       else  Answ:=EvalConstFuncN(PNE);
     end;

  end
  else  //вычисление ф-ий с переменным числом арг. sum(1,2,3), sum(1,2-4/5,3*2,4/(5-7/8),5)*x
  if (Alg.ExFunc[NFunc].Func[NF].CallT = _STACK_INFINITE) and  (NS > 0) then     {.322}
  begin
     Answ:=EvalConstFuncN(PNE);
  end;
  //else Internal ERROR !!!

EvalConstFunc:=Answ;

endp:
end;






function TForevalH.CheckChildForZero(PNE: PNode; NumArg: Integer): Boolean;
label endp;
var
ResT1,ResT2,ResT,TC1,TC2,COP1,COP2: Integer;
PN1,PN2: PNode;
Re1,Im1,Re2,Im2,RE,IM: Extended;
ZeroArg: Boolean;
S1,S2: String;
begin
if F_InternalError <> 0  then goto endp;  {.322}

ZeroArg:=False;

 PN1:=PNE^.Ch; PN2:=PN1^.Nb;
 ResT1:=PN1^.TypeF;     ResT2:=PN2^.TypeF;
 TC1:=PN1^.TC;   TC2:=PN2^.TC;
 COP1:=PN1^.COP;  COP2:=PN2^.COP;

 S1:=PN1^.Expression;
 S2:=PN2^.Expression;

 Re1:=1.0; Im1:=1.0; Re2:=1.0; Im2:=1.0; //init for delete garbage

if (NumArg = _First) or  (NumArg = _Both) then
begin
 if (COP1 = _LDSC) then
 begin
   ResT1:=T_Real;
   Re1:=PN1^.FD; Im1:=0.0;
 end
 else
 if (COP1 = _LDSCX) then
 begin
    if TC1 = C_Complex then
    begin
       ResT1:=T_Complex;
       Re1:=PN1^.FDC.re; Im1:=PN1^.FDC.im;
    end
    else
    if TC1 = C_Image then
    begin
       ResT1:=T_Complex;
       Re1:=0.0; Im1:=PN1^.FDC.im;
    end
    else
    if TC1 = C_Real then
    begin
       ResT1:=T_Real;
       Re1:=PN1^.FDC.re; Im1:=0.0;
    end
 end ;
end;



if (NumArg = _Second) or  (NumArg = _Both) then
begin
 if (COP2 = _LDSC) then
 begin
   ResT2:=T_Real;
   Re2:=PN2^.FD; Im2:=0.0;
 end
 else
 if (COP2 = _LDSCX) then
 begin
    if TC2 = C_Complex then
    begin
       ResT2:=T_Complex;
       Re2:=PN2^.FDC.re; Im2:=PN2^.FDC.im;
    end
    else
    if TC2 = C_Image then
    begin
       ResT2:=T_Complex;
       Re2:=0.0; Im2:=PN2^.FDC.im;
    end
    else
    if TC2 = C_Real then
    begin
       ResT2:=T_Real;
       Re2:=PN2^.FDC.re; Im2:=0.0;
    end
 end ;
end;

 if ((Re1 = 0.0) and (Im1 = 0.0)) or ((Re2 = 0.0) and (Im2 = 0.0)) then
    ZEroArg:=True;

if ZeroArg = True then
begin
 PNE^.FDC.re:=0.0;
 PNE^.FDC.im:=0.0;
 PNE^.FD:=0.0;

 if (ResT1 = T_Complex) and (ResT2 = T_Complex) then
 begin
   PNE^.COP:=_LDSCX;
   PNE^.TypeF:=T_Complex;
 end
 else
 if (ResT1 = T_Real) and (ResT2 = T_Real) then
 begin
   PNE^.COP := _LDSC;
   PNE^.TypeF:=T_Real;
 end
 else
 if ((ResT1 = T_Complex) and (ResT2 = T_Real)) or ((ResT1 = T_Real) and (ResT2 = T_Complex)) then
 begin
   PNE^.COP:=_LDSCX;
   PNE^.TypeF:=T_Complex;
 end ;

 if PNE^.COP = _LDSCX then PNE^.TC := C_Complex;
end;


endp:
CheckChildForZero:=ZeroArg;
end;




procedure TForevalH.EvalCOP1(PNE: PNode; COP,tArg:Integer);
label endp;
var
ResT1,ResT,TC1,COP1,Inv: Integer;
PN1: PNode;
Re1,Im1,RE,IM: Extended;

begin
if F_InternalError <> 0  then goto endp;  {.322}

try
TryFPUMask; {.326}

  PN1:=PNE^.Ch;
  ResT1:=PN1^.TypeF;
  TC1:=PN1^.TC;
  COP1:=PN1^.COP;
  Inv:=PNE^.Inv;

  if (COP1 = _LDSC) then
  begin
   ResT1:=T_Real;
   Re1:=PN1^.FD; Im1:=0.0;
  end
  else
  if (COP1 = _LDSCX) then
  begin
    if TC1 = C_Complex then
    begin
       ResT1:=T_Complex;
       Re1:=PN1^.FDC.re; Im1:=PN1^.FDC.im;
    end
    else
    if TC1 = C_Image then
    begin
       ResT1:=T_Complex;
       Re1:=0.0; Im1:=PN1^.FDC.im;
    end
    else
    if TC1 = C_Real then
    begin
       ResT1:=T_Real;
       Re1:=PN1^.FDC.re; Im1:=0.0;
    end
  end ;



 if (ResT1 = T_Complex)  then
 begin
   case COP of

     CM_NEG:  begin
                 PNE^.FDC.re:=-Re1;//PN1^.FDC.re;
                 PNE^.FDC.im:=-Im1;//PN1^.FDC.im;
                 PNE^.COP := _LDSCX;
                 PNE^.TypeF:=T_Complex;
              end;

     CM_RE:   begin
                 PNE^.FD:=Re1;//-PN1^.FDC.re;
                 PNE^.COP := _LDSC;
                 PNE^.TypeF:=T_Real;
              end;

     CM_IM:   begin
                 PNE^.FD:=Im1;//-PN1^.FDC.im;
                 PNE^.COP := _LDSC;
                 PNE^.TypeF:=T_Real;
              end;

     CM_ADD:  begin
                  if tArg = IM_UNIT then   //constCX+i
                  begin
                    PNE^.FDC.re:=Re1;
                    PNE^.FDC.im:=Im1+1;
                    PNE^.COP := _LDSCX;
                    PNE^.TypeF:=T_Complex;
                  end
                  else
                  begin   //tArg = Any_Const       //constCX+const
                    PNE^.FDC.re:=Re1+PNE^.FD;
                    PNE^.FDC.im:=Im1;
                    PNE^.COP := _LDSCX;
                    PNE^.TypeF:=T_Complex;
                  end;
              end;

     CM_MUL:  begin
                 if tArg = IM_UNIT then    //constCX*i
                  begin
                    PNE^.FDC.re:=-Im1;
                    PNE^.FDC.im:=Re1;
                    PNE^.COP := _LDSCX;
                    PNE^.TypeF:=T_Complex;
                  end
                  else
                  begin   //tArg = Any_Const
                    {After MulDivOtimizator: i - recognize as const (not variable)}

                    if PNE^.TC = C_Real then
                    begin
                     PNE^.FDC.re:=Re1*PNE^.FD;
                     PNE^.FDC.im:=Im1*PNE^.FD;
                     PNE^.COP := _LDSCX;
                     PNE^.TypeF:=T_Complex;
                    end
                    else
                    if PNE^.TC = C_Complex then
                    begin
                      _ComplexMUL(PNE^.FDC.re,PNE^.FDC.im,Re1,Im1,RE,IM);
                     PNE^.FDC.re:=RE;
                     PNE^.FDC.im:=IM;
                     PNE^.COP := _LDSCX;
                     PNE^.TypeF:=T_Complex;
                    end

                  end;
              end;

     CM_SUB:  begin
                 if tArg = IM_UNIT then      //ConstCX-i
                 begin
                    if Inv = 1 then        //i-ConstCX
                    begin
                       PNE^.FDC.re:=-Re1;
                       PNE^.FDC.im:=1-Im1;
                    end
                    else                 //ConstCX-i
                    begin
                       PNE^.FDC.re:=Re1;
                       PNE^.FDC.im:=Im1-1;
                    end;
                    PNE^.COP := _LDSCX;
                    PNE^.TypeF:=T_Complex;
                 end
                 else
                 begin   //tArg = Any_Const
                    if Inv = 1 then
                    begin
                       PNE^.FDC.re:=PNE^.FD-Re1;
                       PNE^.FDC.im:=-Im1;
                    end
                    else
                    begin
                       PNE^.FDC.re:=Re1-PNE^.FD;
                       PNE^.FDC.im:=Im1;
                    end;
                    PNE^.COP := _LDSCX;
                    PNE^.TypeF:=T_Complex;
                  end;
              end;

     CM_DIV:  begin
                 if tArg = IM_UNIT then
                  begin
                     if Inv = 1 then      // i/ConstCX
                    begin
                       _ComplexDIV(0,1,Re1,Im1,RE,IM);
                       PNE^.FDC.re:=RE;
                       PNE^.FDC.im:=IM;
                    end
                    else                   //ConstCX/i
                    begin
                       PNE^.FDC.re:=Im1;
                       PNE^.FDC.im:=-Re1;
                    end;

                    PNE^.COP := _LDSCX;
                    PNE^.TypeF:=T_Complex;
                  end
                  else
                  begin   //tArg = Any_Const
                    if Inv = 1 then
                    begin
                         {After MulDivOtimizator: i - recognize as const (not variable)}

                        if PNE^.TC = C_Real then
                        begin
                          _ComplexDIV(PNE^.FD,0,Re1,Im1,RE,IM);
                          PNE^.FDC.re:=RE;
                          PNE^.FDC.im:=IM;
                        end
                        else
                        if PNE^.TC = C_Complex then
                        begin
                          _ComplexDIV(PNE^.FDC.re,PNE^.FDC.im,Re1,Im1,RE,IM);
                          PNE^.FDC.re:=RE;
                          PNE^.FDC.im:=IM;
                        end

                    end
                    else
                    begin
                       PNE^.FDC.re:=Re1/PNE^.FD;
                       PNE^.FDC.im:=Im1/PNE^.FD;
                    end;

                    PNE^.COP := _LDSCX;
                    PNE^.TypeF:=T_Complex;
                  end;
              end;
   end;
 end
 else

 if (ResT1 = T_Real)  then
 begin
   case COP of
      CM_NEG:  begin PNE^.FD:=-Re1;  PNE^.COP := _LDSC; PNE^.TypeF:=T_Real;  end;
      CM_RE:   begin PNE^.FD:=Re1;   PNE^.COP := _LDSC; PNE^.TypeF:=T_Real;  end;
      CM_IM:   begin PNE^.FD:=0.0;   PNE^.COP := _LDSC; PNE^.TypeF:=T_Real;  end;

      CM_ADD:  begin
                 if tArg = IM_UNIT then     //ConstRe+i
                  begin
                    PNE^.FDC.re:=Re1;
                    PNE^.FDC.im:=1.0;
                    PNE^.COP := _LDSCX;
                    PNE^.TypeF:=T_Complex;
                  end
                  else
                  begin   //tArg = Any_Const
                    PNE^.FD:=Re1+PNE^.FD;
                    PNE^.COP := _LDSC;
                    PNE^.TypeF:=T_Real;
                  end;
               end;
      CM_MUL:  begin
               if tArg = IM_UNIT then       //ConstRe*i
                  begin
                    PNE^.FDC.re:=0.0;
                    PNE^.FDC.im:=Re1;
                    PNE^.COP := _LDSCX;
                    PNE^.TypeF:=T_Complex;
                  end
                  else
                  begin   //tArg = Any_Const
                    {After MulDivOtimizator: i - recognize as const (not variable)}
                    if  (PNE^.TC = C_Real) then
                    begin
                      PNE^.FD:=Re1*PNE^.FD;
                      PNE^.COP := _LDSC;
                      PNE^.TypeF:=T_Real;
                    end
                    else
                    if  (PNE^.TC = C_Complex) then
                    begin
                      _ComplexMUL(PNE^.FDC.re,PNE^.FDC.im,Re1,Im1,RE,IM);
                      PNE^.FDC.re:=RE;
                      PNE^.FDC.im:=IM;
                      PNE^.COP := _LDSCX;
                      PNE^.TypeF:=T_Complex;
                    end
                  end;
               end;

      CM_SUB:  begin
                  if tArg = IM_UNIT then
                  begin
                    if Inv = 1 then         //i-ConstRe
                    begin
                       PNE^.FDC.re:=-Re1;
                       PNE^.FDC.im:=1.0;
                    end
                    else                   //ConstRe-i
                    begin
                       PNE^.FDC.re:=Re1;
                       PNE^.FDC.im:=-1.0;
                    end;
                    PNE^.COP := _LDSCX;
                    PNE^.TypeF:=T_Complex;
                  end
                  else
                  begin   //tArg = Any_Const
                    if Inv = 1 then PNE^.FD:=PNE^.FD-Re1 else PNE^.FD:=Re1-PNE^.FD;
                    PNE^.COP := _LDSC;
                    PNE^.TypeF:=T_Real;
                  end;
               end;

      CM_DIV:  begin
                 if tArg = IM_UNIT then
                  begin
                    if Inv = 1 then     // i/ConstRe
                    begin
                       PNE^.FDC.re:=0.0;
                       PNE^.FDC.im:=1.0/Re1;
                    end
                    else               // ConstRe/i
                    begin
                       PNE^.FDC.re:=0.0;
                       PNE^.FDC.im:=-Re1;
                    end;

                    PNE^.COP := _LDSCX;
                    PNE^.TypeF:=T_Complex;
                  end
                  else
                  begin   //tArg = Any_Const

                       if Inv = 1 then
                       begin
                         {After MulDivOtimizator: i - recognize as const (not variable)}

                         if PNE^.TC = C_Real then
                         begin
                           {_ComplexDIV(PNE^.FD,0,Re1,Im1,RE,IM);
                           PNE^.FDC.re:=RE;
                           PNE^.FDC.im:=IM;}
                           PNE^.FD:=PNE^.FD/Re1;
                           PNE^.COP := _LDSC;
                           PNE^.TypeF:=T_Real;
                         end
                         else
                         if PNE^.TC = C_Complex then
                         begin
                           _ComplexDIV(PNE^.FDC.re,PNE^.FDC.im,Re1,Im1,RE,IM);
                           PNE^.FDC.re:=RE;
                           PNE^.FDC.im:=IM;
                           PNE^.COP := _LDSCX;
                           PNE^.TypeF:=T_Complex;
                         end

                       end
                       else
                       begin
                         PNE^.FD:=Re1/PNE^.FD;
                         PNE^.COP := _LDSC;
                         PNE^.TypeF:=T_Real;
                       end;

                    {
                    if Inv = 1 then PNE^.FD:=PNE^.FD/Re1 else PNE^.FD:=Re1/PNE^.FD;
                    PNE^.COP := _LDSC;
                    PNE^.TypeF:=T_Real;  }
                  end;
               end;
   end;


 end ;

 if PNE^.COP = _LDSCX then PNE^.TC := C_Complex;


TryCatchFPUException;    {.326}
except          {.322}
 on E: EZeroDivide      do F_InternalError:=E_ZeroDivide;
 on E: EInvalidOp       do F_InternalError:=E_InvalidOp;
 on E: EOverFlow        do F_InternalError:=E_OverFlow;
 on E: EUnderFlow       do F_InternalError:=E_UnderFlow;
 on E: EIntOverFlow     do F_InternalError:=E_IntOverFlow;
 on E: EAccessViolation do F_InternalError:=E_AccessViolation;
 on E: EOutOfMemory     do F_InternalError:=E_OutOfMemory;
 on E: EStackOverFlow   do F_InternalError:=E_StackOverFlow
end;

if F_InternalError <> 0 then F_SyntaxErrorCode:=E_INTERNAL_ERROR_AT_CALCULATION;    {.326}

endp:
end;





procedure TForevalH.EvalCOP2(PNE: PNode; COP:Integer);
label endp;
var
ResT1,ResT2,ResT,TC1,TC2,COP1,COP2: Integer;
PN1,PN2: PNode;
Re1,Im1,Re2,Im2,RE,IM: Extended;
begin
if F_InternalError <> 0  then goto endp;  {.322}

try
TryFPUMask; {.326}


 PN1:=PNE^.Ch; PN2:=PN1^.Nb;
 ResT1:=PN1^.TypeF;     ResT2:=PN2^.TypeF;
 TC1:=PN1^.TC;   TC2:=PN2^.TC;
 COP1:=PN1^.COP;  COP2:=PN2^.COP;

 if (COP1 = _LDSC) then
 begin
   ResT1:=T_Real;
   Re1:=PN1^.FD; Im1:=0.0;
 end
 else
 if (COP1 = _LDSCX) then
 begin
    if TC1 = C_Complex then
    begin
       ResT1:=T_Complex;
       Re1:=PN1^.FDC.re; Im1:=PN1^.FDC.im;
    end
    else
    if TC1 = C_Image then
    begin
       ResT1:=T_Complex;
       Re1:=0.0; Im1:=PN1^.FDC.im;
    end
    else
    if TC1 = C_Real then
    begin
       ResT1:=T_Real;
       Re1:=PN1^.FDC.re; Im1:=0.0;
    end
 end ;


 if (COP2 = _LDSC) then
 begin
   ResT2:=T_Real;
   Re2:=PN2^.FD; Im2:=0.0;
 end
 else
 if (COP2 = _LDSCX) then
 begin
    if TC2 = C_Complex then
    begin
       ResT2:=T_Complex;
       Re2:=PN2^.FDC.re; Im2:=PN2^.FDC.im;
    end
    else
    if TC2 = C_Image then
    begin
       ResT2:=T_Complex;
       Re2:=0.0; Im2:=PN2^.FDC.im;
    end
    else
    if TC2 = C_Real then
    begin
       ResT2:=T_Real;
       Re2:=PN2^.FDC.re; Im2:=0.0;
    end
 end ;



 if (ResT1 = T_Complex) and (ResT2 = T_Complex) then
 begin
   case COP of
     CM_ADD:  _ComplexADD(Re1,Im1,Re2,Im2,RE,IM);
     CM_SUB:  _ComplexSUB(Re1,Im1,Re2,Im2,RE,IM);
     CM_MUL:  _ComplexMUL(Re1,Im1,Re2,Im2,RE,IM);
     CM_DIV:  _ComplexDIV(Re1,Im1,Re2,Im2,RE,IM);
   end;
   PNE^.FDC.re:=RE;
   PNE^.FDC.im:=IM;
   PNE^.COP:=_LDSCX;
   PNE^.TypeF:=T_Complex;
 end
 else
 if (ResT1 = T_Real) and (ResT2 = T_Real) then
 begin
   case COP of
      CM_ADD:  PNE^.FD:=Re1+Re2;
      CM_SUB:  PNE^.FD:=Re1-Re2;
      CM_MUL:  PNE^.FD:=Re1*Re2;
      CM_DIV:  PNE^.FD:=Re1/Re2;
   end;

   PNE^.COP := _LDSC;
   PNE^.TypeF:=T_Real;
 end
 else
 if ((ResT1 = T_Complex) and (ResT2 = T_Real)) or ((ResT1 = T_Real) and (ResT2 = T_Complex)) then
 begin
   case COP of
     CM_ADD:  _ComplexADD(Re1,Im1,Re2,Im2,RE,IM);
     CM_SUB:  _ComplexSUB(Re1,Im1,Re2,Im2,RE,IM);
     CM_MUL:  _ComplexMUL(Re1,Im1,Re2,Im2,RE,IM);
     CM_DIV:  _ComplexDIV(Re1,Im1,Re2,Im2,RE,IM);
   end;
   PNE^.FDC.re:=RE;
   PNE^.FDC.im:=IM;
   PNE^.COP:=_LDSCX;
   PNE^.TypeF:=T_Complex;
 end ;

 if PNE^.COP = _LDSCX then PNE^.TC := C_Complex;

TryCatchFPUException;    {.326}
except   {.322}
 on E: EZeroDivide      do F_InternalError:=E_ZeroDivide;
 on E: EInvalidOp       do F_InternalError:=E_InvalidOp;
 on E: EOverFlow        do F_InternalError:=E_OverFlow;
 on E: EUnderFlow       do F_InternalError:=E_UnderFlow;
 on E: EIntOverFlow     do F_InternalError:=E_IntOverFlow;
 on E: EAccessViolation do F_InternalError:=E_AccessViolation;
 on E: EOutOfMemory     do F_InternalError:=E_OutOfMemory;
 on E: EStackOverFlow   do F_InternalError:=E_StackOverFlow
end;

if F_InternalError <> 0 then F_SyntaxErrorCode:=E_INTERNAL_ERROR_AT_CALCULATION;    {.326}

endp:
end;




procedure TForevalH.EvalConstCOP1(PNE: PNode; COP,tArg: Integer);
label endp;
var
Inv: Integer;
begin
if F_InternalError <> 0  then goto endp;  {.322}

try
TryFPUMask; {.326}

Inv:=PNE^.Inv;

if tArg = IM_UNIT then //FD COP i
begin
   case COP of

     CM_ADD: begin
                PNE^.FDC.re:=PNE^.FD;
                PNE^.FDC.im:=1.0;
             end;

     CM_SUB: begin
                    if Inv = 1 then         //i-FD
                    begin
                       PNE^.FDC.re:=-PNE^.FD;
                       PNE^.FDC.im:=1.0;
                    end
                    else                   //FD-i
                    begin
                       PNE^.FDC.re:=PNE^.FD;
                       PNE^.FDC.im:=-1.0;
                    end;
               end;

     CM_MUL: begin
                PNE^.FDC.re:=0.0;
                PNE^.FDC.im:=PNE^.FD;
             end;


     CM_DIV:  begin
                    if Inv = 1 then     // i/FD
                    begin
                       PNE^.FDC.re:=0.0;
                       PNE^.FDC.im:=-PNE^.FD;
                    end
                    else               // FD/i
                    begin
                       PNE^.FDC.re:=0.0;
                       PNE^.FDC.im:=1.0/PNE^.FD;
                    end;
              end;
   end;

   PNE^.COP:=_LDSCX;
   PNE^.TypeF:=T_Complex;

TryCatchFPUException;    {.326}
end;

 if PNE^.COP = _LDSCX then PNE^.TC := C_Complex;

except    {.322}
 on E: EZeroDivide      do F_InternalError:=E_ZeroDivide;
 on E: EInvalidOp       do F_InternalError:=E_InvalidOp;
 on E: EOverFlow        do F_InternalError:=E_OverFlow;
 on E: EUnderFlow       do F_InternalError:=E_UnderFlow;
 on E: EIntOverFlow     do F_InternalError:=E_IntOverFlow;
 on E: EAccessViolation do F_InternalError:=E_AccessViolation;
 on E: EOutOfMemory     do F_InternalError:=E_OutOfMemory;
 on E: EStackOverFlow   do F_InternalError:=E_StackOverFlow
end;

if F_InternalError <> 0 then F_SyntaxErrorCode:=E_INTERNAL_ERROR_AT_CALCULATION;    {.326}

endp:
end;




 {.322}
procedure TForevalH.EvalTreeConst;
label endp;

          function EvalNode(PNE: PNode): Boolean;
          label endp;
          var
           Answ: Boolean;
           PN1,PN2: PNode;
           N,COP,ResT1,ResT2,nv1,nv2,tv1,tv2,tm1,tm2,NFunc,NF: Integer;
           adr1,adr2: TAddress;
           S: String;
          begin

            //S:=PNE^.Expression;
            //F_CurrentEvalSubExpr:=PNE^.Expression; {.322}
            F_SyntaxErrorString:=PNE^.Expression; {.326}
            Answ:=False;

            if F_CalcConstARG = True then
            begin

              if (PNE^.COP = _LDSC) or (PNE^.COP = _LDSCX) or ((PNE^.COP = _LDINTFORM) and (PNE^.TA1 = _IntConst)) then answ:=True
              else
              if (PNE^.NFunc = CM_NEG) or (PNE^.NFunc = CM_RE) or (PNE^.NFunc = CM_IM) then
              begin
                 PN1:=PNE^.Ch;
                 if PN1 <> nil then  {else Internal ERROR!!!}
                 begin
                     if ((PN1^.COP = _LDSC) or (PN1^.COP = _LDSCX))  then          //re(2+3i), -(3+5i),
                     begin
                        EvalCOP1(PNE,PNE^.NFunc,Any_Const);
                        FreeChildTree(PNE);
                        answ:=True;
                     end;
                 end;
              end
              else
              if PNE^.COP = _FUNC then
              begin
                COP:=PNE^.NFunc;

                if (COP = CM_ADD) or (COP = CM_SUB) or (COP = CM_MUL) or (COP = CM_DIV) then
                begin

                  N:=PNE^.Stack.N;
                  if N = 2 then      //const1(Stack) COP const2(Stack)             // (1+2)+(4+5),    (1+2i+3)*(4+5i+7)   ,  (2+3i+4)+5i
                  begin

                    PN1:=PNE^.Ch; if PN1 <> nil then PN2:=PN1^.Nb;
                    if (PN1 <> nil) and (PN2 <> nil)  then  {else Internal ERROR!!!}
                    begin

                        if ((PN1^.COP = _LDSC) or (PN1^.COP = _LDSCX)) and ((PN2^.COP = _LDSC) or (PN2^.COP = _LDSCX)) then
                        begin
                            EvalCOP2(PNE,COP);
                            answ:=True;
                            FreeChildTree(PNE);
                        end
                        else
                        //удаление всех ветвей произведения, если среди сомножителей есть нулевой аргумент.
                        if (F_DeleteZeroBranch = True) and  (COP = CM_MUL) then  {.363}        // sin(x)*cos(x+1)*(a*c-a*(3*c-2*c))*sin(x+3)*cos(x+4)
                        //sin(x)*cos(x+1)*(sin(2*x)*(a*c-a*(3*c-2*c))*cos(3*x)+sin(4*x)*(b*c-b*(3*c-2*c))*cos(5*x))*sin(x+3)*cos(x+4)
                        begin
                           if (PN1^.COP = _LDSC) or (PN1^.COP = _LDSCX) or (PN2^.COP = _LDSC) or (PN2^.COP = _LDSCX) then
                           begin
                            if CheckChildForZero(PNE,_Both) = True then
                            begin
                              FreeChildTree(PNE);
                              answ:=True;
                            end;
                           end
                        end
                        else
                        if (F_DeleteZeroBranch = True) and (COP = CM_DIV) then  {.363}
                        begin      //   sin(x)/cos(x+1)*(a*c-a*(3*c-2*c))/sin(x+3)*cos(x+4)
                           if (PN1^.COP = _LDSC) or (PN1^.COP = _LDSCX) then
                           begin
                             if CheckChildForZero(PNE,_First) = True then
                             begin
                               FreeChildTree(PNE);
                               answ:=True;
                            end;
                           end;
                        end;

                    end;

                  end
                  else
                  if N = 1 then //const COP Stack(const)
                  begin

                     PN1:=PNE^.Ch;
                     if (PN1 <> nil)  then  {else Internal ERROR!!!}
                     begin
                         nv1:=PNE^.NV1; nv2:=PNE^.NV2;
                         if ((PN1^.COP = _LDSC) or (PN1^.COP = _LDSCX)) and (nv1 = _NOT_FOUND) and (nv2 = _NOT_FOUND)  then
                         begin
                           EvalCOP1(PNE,COP,Any_Const);            //1+(2+3i) , (2+3i+4)/i , i/(2+3i+4)  ,      5/(-3*2)
                           answ:=True;
                           FreeChildTree(PNE);
                         end
                         else
                         if ((PN1^.COP = _LDSC) or (PN1^.COP = _LDSCX)) and (nv1 >= 0)   then
                         begin
                           GetVar1(nv1,adr1,tv1,tm1);
                           if tv1 = IM_UNIT then
                           begin
                             EvalCOP1(PNE,COP,IM_UNIT);
                             answ:=True;
                             FreeChildTree(PNE);
                           end;
                         end
                     end;

                  end
                  else
                  if N = 0 then //const COP i
                  begin
                     nv1:=PNE^.NV1;   GetVar1(nv1,adr1,tv1,tm1);
                     nv2:=PNE^.NV2;   GetVar1(nv2,adr2,tv2,tm2);

                     if ((tv1 = IM_UNIT) and (nv2 = _ABSENT)) or ((tv2 = IM_UNIT) and (nv1 = _ABSENT)) then
                     begin
                       //FD COP i
                       EvalConstCOP1(PNE,COP,IM_UNIT);
                       answ:=True;
                     end;
                   {
                    nv1:=PNE^.NV1;
                    if nv1 >=0 then
                    begin
                     GetVar(nv1,adr1,tv1,tm1);
                     if tv1 = IM_UNIT then
                     begin
                       //FD COP i
                       EvalConstCOP1(PNE,COP,IM_UNIT);
                       answ:=True;
                     end;
                    end;
                    }
                  end;
                  if Answ = True then inc(db_CalcConstArg);
                end  //end of << if (COP = CM_ADD) or (COP = CM_SUB) or (COP = CM_MUL) or (COP = CM_DIV)  >>

              end   // end of <<if PNE^.COP = _FUNC>>
            end;    //end of  F_CalcConstARG



            if IsFunction(PNE) = False then    goto endp; //calc const only for functions:   {.329}

            if (F_CalcConstFUNC = True) and (F_InternalError = 0 ) and (Answ = False){не найдена в F_CalcConstARG}  then          {.322}
            begin
                   NFunc:=PNE^.NFunc;
                   NF:=PNE^.NF;
                   if (Alg.ExFunc[NFunc].Func[NF].CalcConst = _YES) and
                      (Alg.ExFunc[NFunc].Func[NF].TypeF <> T_None)  and
                      (Alg.ExFunc[NFunc].Func[NF].TypeF <> T_Void)
                   then  Answ:=EvalConstFunc(PNE);

                   if Answ = True then
                   begin
                    FreeChildTree(PNE);
                    inc(db_CalcConstFunc);
                   end;
            end;

          endp:
          end;

var
Node: PNode;
begin
if F_SyntaxErrorCode <> 0 then goto endp;
if F_InternalError <> 0  then goto endp;  {.322}

Node:=FirstNode;

while Node <> nil do
begin
  EvalNode(Node);
     if F_InternalError <> 0 then goto endp;  {.322}
  Node:=Node^.Next;
end;

endp:
FirstNode:=GetLowLevelNode(BeginTree);  //реинициализация

//InitSequentList;
{восстанавливает ссылки в линейном списке.
Включить, если будут ошибки после выполнения EvalTreeConst }



//endp:
end;





//****************************************************************************//
//                        EVAL. CONST. FUNCTIONS  (end)                       //
//****************************************************************************//



procedure TForevalH.ReadTreeDBG;
label endp;
var
Tree: PNode;
NNode: Cardinal;
  i,nc: Integer;
  S: String;
  Vnc: TArrayC;
begin

(*
   Tree:=BeginTree;
   Tree:=GetLowLevelNode(Tree);
        // TProcTree(CallProc)(Tree);
       //if CallProc(Tree) = True then goto endp;

   while Tree^.Pr <> nil do
   begin
      Tree:=GetNextNode(Tree);
      //TProcTree(CallProc)(Tree);
       // if CallProc(Tree) = True then goto endp;
   end;
*)

 nc:=0;      SetLength(Vnc,0);
 Tree:=FirstNode;
 while Tree <> nil do
 begin

   NNode:=Tree^.NNode;
   for i := 0 to Length(Vdbg)-1 do
   begin
     if NNode = Vdbg[i] then
     begin
        S:=Tree^.Expression;
        inc(nc);
        SetLength(Vnc,Length(Vnc)+1);
        Vnc[High(Vnc)]:=NNode;
     end;

   end;
   Tree:=Tree^.Next;
 end;

  if nc <> 0 then
    nc:=Length(Vdbg)-nc;

endp:
end;


procedure TForevalH.ReadTree(CallProc: TFuncTreeObj{CallProc: TProcTree}{CallProc: Pointer});
label endp;
var
Tree: PNode;
begin

   Tree:=BeginTree; //не обязательно, т.к. чтение дерева - циклически
   Tree:=GetLowLevelNode(Tree);
  // TProcTree(CallProc)(Tree);
   if CallProc(Tree) = True then goto endp;

   while Tree^.Pr <> nil do
   begin
      Tree:=GetNextNode(Tree);
      //TProcTree(CallProc)(Tree);
      if CallProc(Tree) = True then goto endp;
   end;

endp:
end;




procedure TForevalH.ReadTreeFromNode(NodeTree: PNode; CallProc: TFuncTreeObj{CallProc: TProcTree}{CallProc: Pointer});
label endp;
var
Tree: PNode;
begin

   Tree:=NodeTree;
   Tree:=GetLowLevelNode(Tree);
  // TProcTree(CallProc)(Tree);
   if CallProc(Tree) = True then goto endp;

   while Tree^.Pr <> nil do
   begin
      Tree:=GetNextNode(Tree);
      //TProcTree(CallProc)(Tree);
      if CallProc(Tree) = True then goto endp;
   end;

endp:
end;




procedure TForevalH.InitSequentList;
label endp;
var
Tree,NFirst,NSecond,H: PNode;
Num: Cardinal;
S: String;
begin
   //создание последовательного линейного списка чтения дерева и инициализация соответствующих ссылок Next,Prev

   Num:=1;
   LastNode:=BeginTree;

   {Last:}
   Tree:=BeginTree;
   Tree^.Next:=nil;


   {1:}
   Tree:=GetLowLevelNode(Tree);
   FirstNode:=Tree;
   Tree^.Prev:=nil;
   Tree^.NNode:=Num; inc(Num);
   NFirst:=Tree;

   while Tree^.Pr <> nil do
   begin
      Tree:=GetNextNode(Tree);
      NSecond:=Tree;
      NSecond^.Prev:=NFirst;
      NFirst^.Next:=NSecond;
      NSecond^.NNode:=Num; inc(Num);
      NFirst:=NSecond;
   end;

   {Last:}
   Tree^.NNode:=Num;

   F_SequentList:=True;



(*
      //L:int=len(vd);L
      //L=len(vd);L

//Tree:=FirstNode;
Tree:=GetLowLevelNode(Tree);
while Tree <> nil do
begin
 H:=Tree^.Next;
 FreeNode(Tree);
 Tree:=H;
end;
FirstNode:=nil;
*)


endp:
end;




 (*
procedure TForevalH.CodeGeneration;
label endp;
var
Prnt: PNode;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

LFunc:=1;
//SetLength(Interp,LFunc);    {.197}
SetLength(Interp,LInterp);

Tree:=BeginTree; //не обязательно, т.к. чтение дерева - циклически

while Tree^.Ch <> nil do
begin
  Tree:=Tree^.Ch;
end;
//COP=NOP:

WriteCode;              //нижний левый


while Tree^.Pr <> nil do
begin

 while Tree^.Nb <> nil  do
 begin
   Tree:=Tree^.Nb;
   while Tree^.Ch <> nil do
   begin
    Tree:=Tree^.Ch;
   end;

   //COP=NOP:
   WriteCode;     //нижний левый
 end;
  //COP<>NOP:
  Tree:=Tree^.Pr;    // родительский от крайнего правого  на уровне

  Prnt:=Tree;
  WriteCode;
  FreeChld(Prnt);
end;
//1-ый элемент в WriteCode выпадает

endp:

if F_SyntaxErrorCode <> 0 then
 begin
  //CalcException;
 end
end;
*)



procedure TForevalH.WriteCode;
label endp;
var
i: Cardinal;
begin
//SetLength(Interp,LFunc+1);    {.197}
//WriteDataCode;


endp:
{---------}
//out:
{$IFDEF DEBUGS}
(*
if TestZ.Form1.CB_Cod.Checked = True then
begin
if Tree^.COP = _LDSC then
begin
 TestZ.Form1.M2.Lines[LFunc-1]:='LDSC:  '+String(StrUpper(PChar(FloatToStr(Tree^.FD))));
end
else
if Tree^.COP = _LDSF then
begin
 TestZ.Form1.M2.Lines[LFunc-1]:='LDSF:  '+String(StrUpper(PChar(Alg.Obj[Tree^.NObj].Name)));
end
else
if (Tree^.COP = _Func) or (Tree^.COP = _COP) then
begin
 TestZ.Form1.M2.Lines[LFunc-1]:=String(StrUpper(PChar(Alg.ExFunc[Tree^.NFunc].Name)));
end;




end;
*)
{$ENDIF}
{---------}
//inc(LFunc);    {.233}

end;



procedure TForevalH.LinkDataNode(Node: PNode);
{
Связывание типов с исполняемыми командами.
Поиск вызываемых команд.
Определение возвращаемого типа команд.
Отлов синтаксических ошибок.
}

label endp;
var
fa,i,L,j,N,N1: Cardinal;
S,Sa: String;
nf,TypeF,TypeA,NF1: Integer;
ANL: TArrayC;
NCHLD: TArrayPN ;
begin
if F_SyntaxErrorCode <> 0 then goto endp;
//goto endp;

S:=Node^.Expression;
Sa:=Node^.ExpressionArg;
//Interp[LFunc].Expression:=Node^.Expression;   //for syntax error

if Node^.COP = _LDSC then
begin
 {Interp[LFunc].FD:=Node^.FD;
 Interp[LFunc].COP:=_LDSC;
 Interp[LFunc].TypeF:=T_Real;}

 Node^.TypeF:=T_Real;
end
else
if Node^.COP = _LDSCX then
begin
 {Interp[LFunc].FDC.re:=Node^.FDC.re;
 Interp[LFunc].FDC.im:=Node^.FDC.im;
 Interp[LFunc].COP:=_LDSCX;
 if Node^.TC = C_Real then Interp[LFunc].TypeF:=T_Real else Interp[LFunc].TypeF:=T_Complex;
 Interp[LFunc].TC:=Node^.TC; }

 if Node^.TC = C_Real then Node^.TypeF:=T_Real else Node^.TypeF:=T_Complex;
end
else
if Node^.COP = _LDSF then
begin
 {Interp[LFunc].NObj:=Node^.NObj;
 if Node^.TS <> 0 then  Interp[LFunc].TypeF:=T_Real
 else Interp[LFunc].TypeF:=Alg.Obj[Node^.NObj].TypeF;
 Interp[LFunc].COP:=_LDSF;
 Interp[LFunc].TS:=Node^.TS; }

  if Node^.TS <> 0 then  Node^.TypeF:=T_Real else  Node^.TypeF:=Alg.Obj[Node^.NObj].TypeF;
  Node^.TypeM:=Alg.Obj[Node^.NObj].MType;  {.353}
end
else
{if Node^.COP = _JMP then
begin
 Interp[LFunc].TypeF:=T_None;
 Interp[LFunc].COP:=_JMP;
 Interp[LFunc].AI:=Node^.AI;
end
else
}
if Node^.COP = _FLD then
begin
 {Interp[LFunc].TypeF:=T_Real;
 Interp[LFunc].COP:=_FLD;
 Interp[LFunc].AI:=Node^.AI;}

 Node^.TypeF:=T_Real;
end
else
if Node^.COP = _LDINTFORM then
begin
  Node^.TypeF:=T_Real;
end
else
if (Node^.COP = _FUNC) or (Node^.COP = _COP) then
begin
  N:=Node^.Stack.N;
 //определение возвращаемого типа комманды:
 if (F_SaveInFPU = True) and (Node^.COP = _COP) then
 begin
   if (N = 0) or (N = 1) then        //в случае оптимизации арифметических комманд  (N - число аргументов)
   begin
     FindCallFunctionA(Node,TypeF,nf,TypeA);
     {Interp[LFunc].TypeF:=TypeF;
     Interp[LFunc].TypeA:=TypeA;
     Interp[LFunc].FD:=Node^.FD; }

     Node^.TypeF:=TypeF;
     Node^.TypeM:=_Extended;   {внутренние арифм. ф-ии всегда возвращают float var}
     Node^.TypeA:=TypeA;
   end
   else
   begin      //S1 op S2
     FindCallFunction(Node,nf);
     if nf >=0 then    {.197}
     begin
       {Interp[LFunc].TypeF:=Alg.ExFunc[Node^.NFunc].Func[nf].TypeF;
       Interp[LFunc].TypeA:=0;  }

       Node^.TypeF:=Alg.ExFunc[Node^.NFunc].Func[nf].TypeF;
       Node^.TypeM:=Alg.ExFunc[Node^.NFunc].Func[nf].TypeM;
       Node^.TypeA:=0;
     end;
   end;

 end
 else
 if (F_SaveInFPU = False) and (Node^.COP = _COP)   then
 begin
   FindCallFunction(Node,nf);
   {Interp[LFunc].TypeF:=Alg.ExFunc[Node^.NFunc].Func[nf].TypeF;
   Interp[LFunc].TypeA:=0;}

   Node^.TypeF:=Alg.ExFunc[Node^.NFunc].Func[nf].TypeF;
   Node^.TypeM:=Alg.ExFunc[Node^.NFunc].Func[nf].TypeM;
   Node^.TypeA:=0;
 end
 else
 if (Node^.COP = _FUNC) and (N >= 1)   then
 begin
   FindCallFunction(Node,nf);
   if nf >=0 then    {.197}
   begin
     {Interp[LFunc].TypeF:=Alg.ExFunc[Node^.NFunc].Func[nf].TypeF;
     Interp[LFunc].TypeA:=0; }

     Node^.TypeF:=Alg.ExFunc[Node^.NFunc].Func[nf].TypeF;
     Node^.TypeM:=Alg.ExFunc[Node^.NFunc].Func[nf].TypeM;
     Node^.TypeA:=0;
   end;

   //для 'nop' тип результата = типу последнего аргумента
        //if Alg.ExFunc[Node^.NFunc].Name = 'nop'     then Interp[LFunc].TypeF:=Interp[LFunc].ArgTypes[high(Interp[LFunc].ArgTypes)];
   //if Node^.NFunc = CM_NOP     then Interp[LFunc].TypeF:=Interp[LFunc].ArgTypes[high(Interp[LFunc].ArgTypes)];    {.197}
   if Node^.NFunc = CM_NOP     then Node^.TypeF:=Node^.ArgTypes[high(Node^.ArgTypes)];
   if Node^.NFunc = CM_PROG    then Node^.TypeF:=Node^.ArgTypes[high(Node^.ArgTypes)];    {.316}
   //if Node^.NFunc = CM_POLYU   then Node^.TypeF:=GetReturnedFuncType(Node); {.347}
 end
 else
 if (Node^.COP = _FUNC) and (N = 0)   then
 {аргумент ф-ии (nf) определён на стадии разбора: func(v) (v-заданная переменная/переменные)
                                      либо ф-ия без аргументов типа _STACK_INFINITE  }
 { Если у ф-ии нет аргумента или он не прописан в   Alg.ExFunc, то её возвращаемый тип определяется на стадии разбора и передаётся через ND.TypeF}


 begin
   nf:=Node^.NF;
      {FindCallFunction(nf);
       if nf = -1 then nf:=Node^.NF;}

   //Interp[LFunc].TypeF:=Alg.ExFunc[Node^.NFunc].Func[nf].TypeF;
   Node^.TypeF:=Alg.ExFunc[Node^.NFunc].Func[nf].TypeF;
   Node^.TypeM:=Alg.ExFunc[Node^.NFunc].Func[nf].TypeM;

   //для 'nop' без аргументов  тип результата = T_None
       //if Alg.ExFunc[Node^.NFunc].Name = 'nop' then Interp[LFunc].TypeF:=T_None;
   //if Node^.NFunc = CM_NOP then Interp[LFunc].TypeF:=T_None;    {.197}
   if Node^.NFunc = CM_NOP then Node^.TypeF:=T_None;    {.197}
   if Node^.NFunc = CM_PROG then Node^.TypeF:=T_None; {.316}
 end;


 if nf = _NOT_FOUND then
 begin {Error: нет ф-ии}
  TranslErrMsg(Node);
  (*
  //для операций
  if Node^.COP = _COP then
  begin
   F_SyntaxErrorCode:=E_NOT_DEFINED_OPERATION_FOR_TYPE;
   F_SyntaxErrorStringA:=Alg.Opr[Node^.NCOP].Name;

     //исключение для MOD:
     if Node^.NFunc = CM_MOD then
     begin
       F_SyntaxErrorCode:=E_NOT_DEFINED_FUNCTION_FOR_TYPE;
       F_SyntaxErrorStringA:=Alg.ExFunc[Node^.NFunc].Name;
     end;
  end
  else
  //для ф-ий
  begin
   F_SyntaxErrorCode:=E_NOT_DEFINED_FUNCTION_FOR_TYPE;
   F_SyntaxErrorStringA:=Alg.ExFunc[Node^.NFunc].Name;
  end;

  F_SyntaxErrorString:='';
  //FindNumberLevel(ANL);
  GetAllChilds(Node,NCHLD);
  for j:=0 to Node^.Stack.N-1 do
  begin
   if j > 0 then  F_SyntaxErrorString:=F_SyntaxErrorString+',';
   //F_SyntaxErrorString:=F_SyntaxErrorString+NameTypes[Interp[ANL[j]].TypeF];
   F_SyntaxErrorString:=F_SyntaxErrorString+NameTypes[NCHLD[j]^.TypeF];

  end;

  //if F_SyntaxErrorCode = E_NOT_DEFINED_FUNCTION_FOR_TYPE  then F_SyntaxErrorString:=F_SyntaxErrorStringA+'('+F_SyntaxErrorString+')';
  TranslErrMsg(Node^.Expression);

  if F_SyntaxErrorCode = E_NOT_DEFINED_OPERATION_FOR_TYPE  then F_SyntaxErrorString:=F_SyntaxErrorStringA+'('+F_SyntaxErrorString+')';
  //if F_SyntaxErrorCode = E_NOT_DEFINED_FUNCTION_FOR_TYPE  then F_SyntaxErrorString:=F_SyntaxErrorStringA+'('+F_SyntaxErrorString+')';
  goto endp;           {.197}
  *)
 end;

 {Interp[LFunc].COP:=_FUNC;
 Interp[LFunc].NFunc:=Node^.NFunc;
 Interp[LFunc].Arg:=Node^.Stack.N;
 Interp[LFunc].NF:=nf; }
 Node^.COP:=_FUNC;
 Node^.Arg:=Node^.Stack.N;
 Node^.NF:=nf;


 //if present function similar 'rand' - disable calc const
 {N1:=Interp[LFunc].NFunc;
 NF1:=Interp[LFunc].NF;}
 N1:=Node^.NFunc;
 NF1:=Node^.NF;
 if Alg.ExFunc[N1].Func[NF1].CalcConst = _NO then  F_EnableCalcConstExpression:=False;

end;

//To Tree
 (*
Interp[LFunc].S:=Node^.Stack.S-1;  //начинается с '0'
Interp[LFunc].N:=Node^.Stack.N;
Interp[LFunc].NL:=Node^.NL;
Interp[LFunc].NM:=Node^.NM;
Interp[LFunc].IdN:=Node^.IdN;
Interp[LFunc].IdL:=Node^.IdL;
Interp[LFunc].Inv:=Node^.Inv;

Interp[LFunc].nv1:=Node^.nv1;
Interp[LFunc].nv2:=Node^.nv2;
Interp[LFunc].NObj:=Node^.NObj;

Interp[LFunc].AI:=Node^.AI;
Interp[LFunc].CI:=Node^.CI;
Interp[LFunc].FD:=Node^.FD;

Interp[LFunc].CS:=0;

Interp[LFunc].TS:=Node^.TS;
Interp[LFunc].TS1:=Node^.TS1;
Interp[LFunc].TS2:=Node^.TS2;


Interp[LFunc].RRF:=rf_NO_REPLACE;
Interp[LFunc].WRF:=rf_NO_REPLACE;
Interp[LFunc].NRF:=0;
Interp[LFunc].MRF:=-1;
Interp[LFunc].WRF_CS:=rf_NO_REPLACE; {.217}
Interp[LFunc].MRF_CS:=-1; {.217}

Interp[LFunc].VFP:=Node^.VFP;          {.207}
*)

if Node^.NFunc = CM_VOID then Node^.COP:=_NOP;{.303}


//{.347}

//x+proc1(...)
{
if (Node^.TypeF = T_None) then
begin
  if Node^.Pr <> nil then
  begin
    if (Node^.NFunc = CM_JMP) and (Node^.Pr^.NFunc = CM_IF) then
    begin

    end
    else
    if Node^.Pr^.NFunc <> CM_PROG then
    begin
      F_SyntaxErrorCode:=E_NO_FUNCTION;
      F_SyntaxErrorString:=Node^.Expression;
    end;
  end;
end;
}


//if Node^.NFunc = CM_PROG then Node^.COP:=_NOP;{.316}

//GetReturnedFuncType - определение возвращаемого типа для остальных, нестандартных команд
{
 нестандартные  те, у которых тип результата зависит от внутренних постоянных аргументов,
 тип которых определяется в ходе разбора,т.е.
 func(const, var) -> func(var), тип которой зависит от const и var
}
if Node^.NFunc = CM_POLYU    then Node^.TypeF:=GetReturnedFuncType(Node); {.347}
if Node^.NFunc = CM_POLY     then Node^.TypeF:=GetReturnedFuncType(Node); {.347}
if Node^.NFunc = CM_CZPWR    then Node^.TypeF:=GetReturnedFuncType(Node); {.361}
if Node^.NFunc = CM_IPWRSGN  then Node^.TypeF:=GetReturnedFuncType(Node); {.361}


Node^.S:=Node^.Stack.S-1;  //начинается с '0'
Node^.N:=Node^.Stack.N;
Node^.CS:=0;
Node^.RRF:=rf_NO_REPLACE;
Node^.WRF:=rf_NO_REPLACE;
Node^.NRF:=0;
Node^.MRF:=-1;
Node^.WRF_CS:=rf_NO_REPLACE; {.217}
Node^.MRF_CS:=-1; {.217}




{
N:=Length(Interp[LFunc].RData);
if N < 2 then N:=2;
//инициализация RData: чтобы не возникала ошибка Access Violation при чтении RData в коммандах с числом арг. < 2
SetLength(Interp[LFunc].RData,N);
Interp[LFunc].RData[0]:=_FPU;  Interp[LFunc].RData[1]:=_FPU;
}

//To Tree
(*
if Length(Node^.RData) <> 0 then
begin
 SetLength(Interp[LFunc].RData,Length(Node^.RData));
 for i:=0 to High(Node^.RData) do
 begin
  Interp[LFunc].RData[i]:=Node^.RData[i];
 end;
end;
*)

{.197}
(*
N:=Length(Interp[LFunc].RData);
if N < 2 then
begin
 N:=2;
 //инициализация RData: чтобы не возникала ошибка Access Violation при чтении RData в коммандах с числом арг. < 2
 SetLength(Interp[LFunc].RData,N);
 Interp[LFunc].RData[0]:=_FPU;  Interp[LFunc].RData[1]:=_FPU;
end;
*)
N:=Length(Node^.RData);
if N < 2 then
begin
 N:=2;
 //инициализация RData: чтобы не возникала ошибка Access Violation при чтении RData в коммандах с числом арг. < 2
 SetLength(Node^.RData,N);
 Node^.RData[0]:=_FPU;  Node^.RData[1]:=_FPU;
end;


//To Tree
(*
Interp[LFunc].SData:=Node^.SData;
Interp[LFunc].ExpressionArg:=Node^.ExpressionArg;
*)

endp:

end;



procedure TForevalH.FindCallFunction(Node:PNode; var nf: Integer);
label 1,2,3,endp;
var
Fnc: TIntFuncA;
i,N,T,j,S: Integer;
//ANL: TArrayC;
NCHLD: TArrayPN;
//HTree: PNode;
begin
nf:=-1;
N:=Node^.Stack.N;
S:=Node^.Stack.S;
Fnc:=Alg.ExFunc[Node^.NFunc].Func;


//FindNumberLevel(ANL);  //число аргументов
GetAllChilds(Node,NCHLD);
//HTree:=Tree;

//вначале искать среди внутренних
for i:=0 to High(Fnc) do
begin
  if Fnc[i].ExeF = _YES then   //если все правильно, должно работать и без этого
  begin

    if N = Fnc[i].NArg then //проверить совпадение типов:
    begin

     for j:=0 to N-1 do
     begin
      //if Interp[ANL[j]].TypeF <> Fnc[i].TV[j] then goto 1;

         {.353}
         if (NCHLD[j]^.TypeF = T_Pointer) and  (Fnc[i].TV[j] = T_Real) and (Fnc[i].TM[j] = _Integer) then
         begin
            if F_EnableUseIntegerPointer = False then  goto 1;   //разрешать передавать в  Integer аргументы - тип Pointer
         end
         else
         if (NCHLD[j]^.TypeF = T_Real) and  (Fnc[i].TV[j] = T_Pointer) and (Fnc[i].TM[j] = _Pointer) then
         begin
            if F_EnableUseIntegerPointer = False then  goto 1;   //разрешать передавать в  Pointer аргументы - тип T_Real (Integer)
         end
         else   //для остальных аргументов: при несовпадении типов переданных аргументов и заданных типов аргументов текущей ф-ии перейти к следующей функции с таким же именем
         if NCHLD[j]^.TypeF <> Fnc[i].TV[j] then goto 1;

         if NCHLD[j]^.TypeF = T_Array then            {.302}
         begin

            {.353}
            if (NCHLD[j]^.TypeM  = _Pointer) and (Fnc[i].TM[j] = _Integer) then
            begin
               if F_EnableUseIntegerPointer = False then  goto 1;
            end
            else
            if NCHLD[j]^.TypeM <> Fnc[i].TM[j]  then goto 1;    //проверить совпадение математических типов , если аргумент -  массив или возвращаемый тип - массив

            {
            if (Alg.Obj[NCHLD[j]^.NObj].MType  = _Pointer) and (Fnc[i].TM[j] = _Integer) then
            begin
               if F_EnableUseIntegerPointer = False then  goto 1;
            end
            else
            if Alg.Obj[NCHLD[j]^.NObj].MType <> Fnc[i].TM[j]  then goto 1;    //проверить совпадение математических типов , если аргумент -  массив
            }
         end;

     end;

     nf:=i;
     goto endp;
    end;

  end;
1:
end;




 for i:=0 to High(Fnc) do
 begin

   if Fnc[i].ExeF = _YES then   //если все правильно, должно работать и без этого
   begin

     if  Fnc[i].CallT = _STACK_INFINITE then //проверить совпадение типов:
     begin

      for j:=0 to High(NCHLD) do
      begin
       //if Interp[ANL[j]].TypeF <> Fnc[i].TV[0] then goto 2;
       if NCHLD[j]^.TypeF <> Fnc[i].TV[0] then goto 2;
      end;

      nf:=i;
      goto endp;
     end;

   end;

 2:
 end;




for i:=0 to High(Fnc) do
 begin
   if Fnc[i].ExeF = _YES then   //если все правильно, должно работать и без этого
   begin

     if  Fnc[i].CallT = _INTERNAL_INFINITE_ANY then
     begin
      //SetLength(Interp[LFunc].ArgTypes,Length(ANL));
      SetLength(Node^.ArgTypes,Length(NCHLD));
      for j:=0 to High(NCHLD) {High(ANL)} do
      begin
       //if (Interp[ANL[j]].TypeF =  T_Integer) or (Interp[ANL[j]].TypeF =  T_Array) then goto 3;
        if (NCHLD[j]^.TypeF =  T_Integer) or (NCHLD[j]^.TypeF =  T_Array) then goto 3;
        //Interp[LFunc].ArgTypes[j]:=Interp[ANL[j]].TypeF;

        //Tree^.ArgTypes[j]:=NCHLD[j]^.TypeF;   {.345}
          Node^.ArgTypes[j]:=NCHLD[j]^.TypeF;   {.346}
      end;

      nf:=i;
      goto endp;
     end;

   end;
 3:
 end;



endp:
end;






procedure TForevalH.FindCallFunctionA(Node:PNode; var TypeF: Integer; var nf: Integer; var TypeA: Integer);
label endp;
var
Fnc: TIntFuncA;
i,N,T,j,S: Integer;
ANL: TArrayC;
NCHLD: TArrayPN;
TypeF1,TypeF2: Integer;
adr: Cardinal;
nv1,nv2,tv1,tv2,tm1,tm2: Integer;
begin

{
 поправка оптимизации для случаев (N=0,1) (N - число аргументов в стеке) арифметической операции
  (напр.: x+sin(x); x+y; x+1; sin(x)+1; mod(Real,IntForm); mod(IntForm1,IntForm2); IntForm1^IntForm2;  )

 Арифм. команды с 2-мя аргументами в некоторых случаях оптимизируются до такой же команды, но с одним аргументом или без аргументов.
 Данные о них скрыты внутри самой команды и не передаются в стек.

 В связи с этим нужно обработать всевозможные типы аргументов команд для каждой.

}


nf:=-1;
TypeA:=0;       //тип аргумента
TypeF2:=0;      //тип аргумента
tv1:=0;
tv2:=0;

N:=Node^.Stack.N;
S:=Node^.Stack.S;
Fnc:=Alg.ExFunc[Node^.NFunc].Func;

//скрытые переменные в командах
nv1:=Node^.NV1; nv2:=Node^.NV2;
if nv1 <> -1 then GetVar1(nv1,adr,tv1,tm1);
if nv2 <> -1 then GetVar1(nv2,adr,tv2,tm2);



//типы скрытых переменных в командах
if (tv1 = T_Complex) or (tv2 = T_Complex) then TypeF1:=T_Complex
 else
 if (tv1 = IM_UNIT) or (tv2 = IM_UNIT) then TypeF1:=T_Complex
  else TypeF1:=T_Real;

if ((Node^.NFunc = CM_MUL) or (Node^.NFunc = CM_DIV)) and (tv1 = IM_UNIT) and (tv2 = IM_UNIT) then  TypeF1:=T_Real; //i*i,i/i


//FindNumberLevel(ANL);  //число аргументов
GetAllChilds(Node,NCHLD);
//if N = 1 then begin TypeF2:=Interp[ANL[0]].TypeF; TypeA:=TypeF2; end;
if N = 1 then begin TypeF2:=NCHLD[0]^.TypeF; TypeA:=TypeF2; end;       // тип аргумента в стеке в случае одного
if (TypeF1 = T_Complex) or (TypeF2 = T_Complex) then TypeF:=T_Complex else TypeF:=T_Real;

{.346}
if (TypeF2 = T_None) {or (TypeF2 = T_Void)} then
begin
  nf:=_NOT_FOUND;
  goto endp;
end;

{.353}   //для отлова ошибок: арифм. команды выполняются только для  T_Real T_Complex
if (N > 0) and ((Node^.NFunc = CM_ADD) or (Node^.NFunc = CM_SUB) or (Node^.NFunc = CM_MUL) or (Node^.NFunc = CM_DIV) or (Node^.NFunc = CM_MOD) or (Node^.NFunc = CM_IDIV) )  then
begin
  if (TypeF2 <> T_Real) and (TypeF2 <> T_Complex) then
  begin
     nf:=_NOT_FOUND;
     goto endp;
  end;

  {.357}
  if ((Node^.NFunc = CM_MOD) or (Node^.NFunc = CM_IDIV)) and (TypeF2 <> T_Real) then
  begin
     nf:=_NOT_FOUND;
     goto endp;
  end;
end;


{.318}
//если есть комплексная константа:
if ((Node^.NFunc = CM_MUL) or (Node^.NFunc = CM_DIV)) and (Node^.TC = C_Complex) then TypeF:=T_Complex; //MulDivAnalizator, 2i*3*(3i-1)*x; (2i-1)/(3i-2)/sin(x)

{
При одном аргументе в арифметических командах, тип аргумента определяется по  TypeA
}

//!!! nf не соответствует реальному (не сущ-ет арифм. комманды  с одним аргументом)
begin
  case Node^.NFunc of
   CM_ADD:  nf:=0;
   CM_SUB:  nf:=0;
   CM_MUL:  nf:=0;
   CM_DIV:  nf:=0;
   CM_MOD:  nf:=0;
   CM_IDIV: nf:=0;
  end;
goto endp;
end;





endp:
end;





procedure TForevalH.FindNumberLevel(var ANL: TArrayC);
var   //определение номеров уровней, вытекающих из данного узла
i,j: Integer;
E: Exception;
begin

  (*
for j:=1 to LFunc-1 do
begin
   if Tree^.IdN = Interp[j].IdL then
   begin
    SetLength(ANL,Length(ANL)+1);
    ANL[High(ANL)]:=j;
   end;
end;

if Tree^.Stack.N <> Length(ANL) then
begin {InternalError}
 F_InternalError:=E_AccessViolation;
 IntException;
end;

*)

end;




procedure TForevalH.GetAllChilds(Node: PNode; var NCHLD: TArrayPN);
var   //определение номеров уровней, вытекающих из данного узла
i,j: Integer;
E: Exception;
NodeCh: PNode;
S: String;
begin

SetLength(NCHLD,0);
NodeCh:=Node^.Ch;

while NodeCh <> nil do
 begin
  //S:=HTree^.ExpressionArg;
  SetLength(NCHLD,Length(NCHLD)+1);
  NCHLD[High(NCHLD)]:=NodeCh;
  NodeCh:=NodeCh^.Nb;
 end;


if Node^.Stack.N <> Length(NCHLD) then
begin {InternalError}
 F_InternalError:=E_AccessViolation;
 F_SyntaxErrorCode:=E_INTERNAL_ERROR;    {.326}
 //IntException;
end;

end;


procedure TForevalH.TranslErrMsg({SubExpr: String}Node: PNode);
var
SA,SF,St,SubExpr,St1: String;
PF: Cardinal;
NCHLD: TArrayPN ;
j: Integer;
SN: TArrayS;
begin
 //if F_SyntaxErrorCode = E_NOT_DEFINED_OPERATION_FOR_TYPE  then F_SyntaxErrorString:=F_SyntaxErrorStringA+'('+F_SyntaxErrorString+')';
 //if F_SyntaxErrorCode = E_NOT_DEFINED_FUNCTION_FOR_TYPE  then F_SyntaxErrorString:=F_SyntaxErrorStringA+'('+F_SyntaxErrorString+')';

 
  //для операций
  if Node^.COP = _COP then
  begin
   F_SyntaxErrorCode:=E_NOT_DEFINED_OPERATION_FOR_TYPE;
   F_SyntaxErrorStringA:=Alg.Opr[Node^.NCOP].Name;

     //исключение для MOD, IDIV:
     if (Node^.NFunc = CM_MOD) or (Node^.NFunc = CM_IDIV) then
     begin
       F_SyntaxErrorCode:=E_NOT_DEFINED_FUNCTION_FOR_TYPE;
       F_SyntaxErrorStringA:=Alg.ExFunc[Node^.NFunc].Name;
     end;
  end
  else
  //для ф-ий
  begin
   F_SyntaxErrorCode:=E_NOT_DEFINED_FUNCTION_FOR_TYPE;
   F_SyntaxErrorStringA:=Alg.ExFunc[Node^.NFunc].Name;
  end;

  F_SyntaxErrorString:='';
  //FindNumberLevel(ANL);
  GetAllChilds(Node,NCHLD);
  for j:=0 to Node^.Stack.N-1 do
  begin
     if j > 0 then  F_SyntaxErrorString:=F_SyntaxErrorString+',';
   //F_SyntaxErrorString:=F_SyntaxErrorString+NameTypes[Interp[ANL[j]].TypeF];

    if NCHLD[j]^.TypeF = T_Array then
    begin
         if Alg.Obj[NCHLD[j]^.NObj].MType = _Integer  then  St1:='Array Integer'  else
         if Alg.Obj[NCHLD[j]^.NObj].MType = _Double   then  St1:='Array Double'   else
         if Alg.Obj[NCHLD[j]^.NObj].MType = _Extended then  St1:='Array Extended' else
         if Alg.Obj[NCHLD[j]^.NObj].MType = _Single   then  St1:='Array Single'   else
         if Alg.Obj[NCHLD[j]^.NObj].MType = _Pointer  then  St1:='Array Pointer';
    end
    else
    St1:=NameTypes[NCHLD[j]^.TypeF];

    F_SyntaxErrorString:=F_SyntaxErrorString+St1;
    SetLength(SN,Length(SN)+1);
    SN[High(SN)]:=St1;
   end;

  //if F_SyntaxErrorCode = E_NOT_DEFINED_FUNCTION_FOR_TYPE  then F_SyntaxErrorString:=F_SyntaxErrorStringA+'('+F_SyntaxErrorString+')';



if F_SyntaxErrorCode = E_NOT_DEFINED_FUNCTION_FOR_TYPE   then
begin

  SubExpr:=Node^.Expression;
  SA:=F_SyntaxErrorString;
  SF:=F_SyntaxErrorStringA;


  //St:=LowerCase(SA);
                           //ifp(z1<z2,x=1;z1=z2);x
                           //iff(z1<z2,x,z1);x
                           //iff(x<y,x,z1);x
  //PF:=Pos('ifnop(',St);
  if  SF = SCif then
  begin
     if Length(SN) = 6 then
     begin
        SA:=SN[0]+','+SN[1]+','+SN[3]+','+SN[5];
     end
     else
     if Length(SN) = 4 then
     begin
        SA:=SN[0]+','+SN[1]+','+SN[3];
     end ;


     Delete(F_SyntaxErrorStringA,1,1);//#
   

     SF:='if'+'('+SA+')';
     F_SyntaxErrorString:=SF+' in '+ '  "'+SubExpr+'"  ';
  end
  else
   if  SF = 'ldsvx' then
  begin
     //vd[z1+1]
     //vd[i+1]
     //St:=F_SyntaxErrorStringA+'('+F_SyntaxErrorString+')';
     //F_SyntaxErrorString:=St+' in '+SubExpr ;
     F_SyntaxErrorString:=SubExpr ;
     F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
  end
  else
  if  SF = SCsave then
  begin
    //vd[i+1]=x;x
     Delete(F_SyntaxErrorStringA,1,1);//#
     St:=F_SyntaxErrorStringA+'('+F_SyntaxErrorString+')';
     F_SyntaxErrorString:=St+' in '+SubExpr ;

     if (Length(NCHLD) = 1) then
     begin
       if NCHLD[0]^.TypeF = T_None then
       begin
          F_SyntaxErrorCode := E_NO_RETURN_NUMBER;
          F_SyntaxErrorString:=NCHLD[0]^.Expression+'  in expsession:   '+SubExpr ;
       end;

     end;



  end
  else
  begin
    F_SyntaxErrorString:=F_SyntaxErrorStringA+'('+F_SyntaxErrorString+')';
    F_SyntaxErrorString:=F_SyntaxErrorString+'  in expsession:   '+#13#10+SubExpr; {.323}
  end;

end
else
//{.346}
if F_SyntaxErrorCode = E_NOT_DEFINED_OPERATION_FOR_TYPE  then
begin
   SubExpr:=Node^.Expression;
   F_SyntaxErrorString:=F_SyntaxErrorStringA+'('+F_SyntaxErrorString+')'+'  in expsession:   '+#13#10+SubExpr;
end
else
F_SyntaxErrorString:=F_SyntaxErrorStringA+'('+F_SyntaxErrorString+')';






  //if F_SyntaxErrorCode = E_NOT_DEFINED_FUNCTION_FOR_TYPE  then F_SyntaxErrorString:=F_SyntaxErrorStringA+'('+F_SyntaxErrorString+')';




end;



function TForevalH.GetLevelsCS(Node: PNode{num: Integer}): Cardinal;
var   //размер кода вытекающих узлов
j,IdN: Integer;
CS: Cardinal;
ANL: TArrayC;
Chld: PNode;
begin

 {
IdN:=Interp[num].IdN;
for j:=1 to LFunc-1 do
begin
   if IdN = Interp[j].IdL then
   begin
    SetLength(ANL,Length(ANL)+1);
    ANL[High(ANL)]:=j;
   end;
end;

CS:=0;
for j:=0 to High(ANL) do
begin
   CS:=CS+Interp[ANL[j]].CS;
end;
}
CS:=0;
Chld:=Node^.Ch;
while Chld <> nil do
begin
 CS:=CS+Chld^.CS;
 Chld:=Chld^.Nb;
end;

GetLevelsCS:=CS;
end;



function TForevalH.GetReturnedFuncType(Node: PNode): Integer;
label outf,outf1,endp;
var
  i,L,N,NF: Integer;
  RetType,t1,t2,TypeArg: Integer;
begin
{
Определение возвращаемого типа нестандартных внутренних команд и
 перекодировка (оптимизация) одних в другие в зависимости от типов аргументов.
}


   if Node^.NFunc = CM_POLYU   then
   {
   Возвращаемый тип определяется типами коэфф-ов и типом выражения переменной.
   Если хотя бы один из них - комплексный, то возвращаемый тип - комплексный. Иначе - действительный
   За исключением случая  poly(RealConst,ComplexExpr)
   Числовые коэфф-ты содержатся в массиве. Коэфф-ты , заданные выражениями - в вытекающих узлах
   }
   begin
     RetType:=T_Real;
     L:=Length(Node^.VFP);
     for i := 0 to L-1 do
     begin
       if (Node^.VFP[i].Im <> 0) and (Node^.VFP[i].indx >= 0) then
       begin
        RetType:=T_Complex;
        goto outf;
       end;

     end; //for

     L:=Length(Node^.ArgTypes);
     for i := 0 to L-1 do
     begin
       if Node^.ArgTypes[i] = T_Complex then
        begin
          RetType:=T_Complex;
          goto outf;
        end;
     end; //for

     outf:
     if (L = 1) then    //poly(2*a+b,z) = 2*a+b   poly(2*ai+bi,z) = 2*ai+bi  poly(2*a+b,x) = 2*a+b   poly(2*ai+bi,x) = 2*ai+bi
     begin
        if Node^.VFP[0].indx >= 0 then  RetType:=Node^.VFP[0].tc
        else                            RetType:=Node^.ArgTypes[0];
     end;


   end
   else
   if Node^.NFunc = CM_POLY   then
   {
   Возвращаемый тип определяется типами коэфф-ов и типом выражения переменной.
   Если хотя бы один из них - комплексный, то возвращаемый тип - комплексный. Иначе - действительный
   За исключением случая poly(RealConst,ComplexExpr)
   Числовые коэфф-ты содержатся в массиве.
   }
   begin
     N:=Node^.NFunc;
     NF:=Node^.NF;

     RetType:=T_Real;
     L:=Length(Node^.VFP);
     for i := 0 to L-1 do
     begin
       if (Node^.VFP[i].Im <> 0) {and (Node^.VFP[i].indx >= 0)} then
       begin
        RetType:=T_Complex;
        goto outf1;
       end;
     end; //for

     outf1:
     if Node^.Ch^.TypeF = T_Complex   then     RetType := T_Complex;
     //if Alg.ExFunc[N].Func[NF].TV[0]= T_Complex   then     RetType := T_Complex;


   end
   else
   if Node^.NFunc = CM_CZPWR   then     {.361}
   begin
     //Const(Real,Complex)^(Real,Complex)
     RetType:=T_Real;
     if Node^.AI = 1 then t1:=T_Real else
     if Node^.AI = 2 then t1:=T_Complex;
     t2:=Node^.Ch^.TypeF;
     Node^.TypeA:=t2;//тип аргумента в TypeA вместо автоопределения, т.к. ф-ия задана неоднозначно
     if (t1 = T_Complex) or (t2 = T_Complex) then  RetType := T_Complex;
   end
   else

   //перекодировка команды (-1+0i)^Arg  в (-1+0i)^Real
   if (Node^.NFunc = CM_IPWRSGN)   then    {.361}
   begin

      RetType := Node^.TypeF;
      if (Node^.AI = 2) then
      begin
         TypeArg:=Node^.Ch^.TypeF; //(-1)^(Stack)    //N > 0 !!!
         if (TypeArg = T_Real) then
         begin
            Node^.NF:=GetIdArgFunc1A(Node^.NFunc,1,T_Real);
            //Node^.AI:=3;
            Node^.TypeA:=T_Real;
            Node^.TypeF:=T_Complex;
            RetType := T_Complex;
          end
          else    //(-1+0i)^Complex
          if TypeArg = T_Complex then
          begin
            Node^.AI:=0;
            Node^.NF:=GetIdArgFunc1A(Node^.NFunc,1,T_Complex);
          end;
     end;

   end;

 endp:
 GetReturnedFuncType:=RetType;
end;
 


procedure TForevalH.InitNode(var ND: TDataNode);
var
i: Integer;
begin
ND.N:=0;
ND.NCOP:=0;
ND.NFunc:=0;
ND.NObj:=0;
ND.COP:=0;
ND.FD:=0;
ND.FDC.re:=0;
ND.FDC.im:=0;
ND.FX:=0;
ND.IdN:=0;
ND.NV1:=_ABSENT;
ND.NV2:=_ABSENT;
ND.TypeF:=0;
ND.TypeM:=_Extended;
ND.Inv:=0;
ND.TS:=0;
ND.AI:=0;
ND.BI:=0;
ND.CI:=0;
ND.DI:=0;
ND.IC1:=0;
ND.IC2:=0;
ND.NF:=0;
ND.TC:=C_Real; {.318}
ND.TS1:=0;
ND.TS2:=0;
ND.TA1:=0;
ND.TA2:=0;
//ND.ExtFunc:=_NOT_FOUND;
{.301}
ND.SDiff:='0';
ND.cif:=0;
ND.tif:=0;
SetLength(ND.AIVP1,0);
SetLength(ND.AIVP2,0);
end;






function TForevalH.PointToDec(S: String):String;
label
1;
var
i:Cardinal;
SS: String;
begin
SS:=Copy(S,1,Length(S));
for i:=1 to Length(S) do
 begin
  if SS[i] = '.' then
  begin
   Delete(SS,i,1);
   Insert(',',SS,i);
   goto 1;
 end
end;

1:
PointToDec:=Copy(SS,1,Length(SS));
end;




procedure TForevalH.CreateInitData;
begin                             //порядок не менять


F_SyntaxErrorCode:=0;
//LFunc:=0;   {.233}

F_ShowException:=False;
F_ExternalException:=False;
//F_LeadToLowerCase := True;    {.221}
F_DataType:=_Extended;{_Double};
F_DinamicLoadOptimization:=True;
F_SaveInFPU:=True;
//F_SaveStack:=True;
F_StackDeep:=8;
//F_Opt:=False;
F_Mode:=M_Compile;
F_CalcType:=T_Complex;
F_OperationOptimizatorA1:=True;
F_OperationOptimizatorA2:=True;
F_CalcConstExpr:=True;
F_ReplaceFunctions:=True;
F_ReplaceOperations:=True;
F_ReplaceFunctionsCF:=True; {.217}
F_UseVirtAlloc:=False;
F_DisableReplaceIF:=False;   {.195}
//F_FAST_DIV:=True; {.205}
//M_DIV_MODE:=_fast;
SetDivMode(_fast);    {.345}
F_MulDivOptimization:=True; {.217A}
F_CalcConstMulDiv:=True;

F_SyntaxExtension:=True;
F_SkippedIf:=True;{.221}
F_PipeBracketToAbs := True;    {.341}
F_SquareBracketToTrunc:= True;   {.341}
F_CurlyBracketToFrac:= True;   {.341}
F_ReplaceFuncInPart:= True;     {.341}
F_ExtNameFunction := True;    {.341}
F_SubstNumCX  := True;    {.341}

F_PreliminarySyntaxError:= True;    {.341}

F_EnableCalcConsExprInMulti:=False;  {.221}
F_EnableMaskFpuException:=False; {.229}
F_DataInArray := True;
F_TreeOptimization:= _Auto;
F_CheckName :=True;
F_CalcConstARG:=True;
F_CalcConstFUNC:=True;
F_IntegerOptimization:=True;
F_IntegerOptimizationF:=True;   {.309}
F_CalcConstExtFunc:=True;  {.310}
F_IntermediateLastNode:=False; {.310}
F_Enable_All_Replace:=False; {.347}
F_PolyUReWriteConst:=True; {349}
F_EnableUsePointer:=True;
F_EnableUseIntegerPointer:=True;
F_CheckArrayTypeConnect:=False; {.357}
F_ReduceArgOptimizator:=True; {.361}
F_DeleteZeroBranch:=True; {.363}
F_EnableInline:=False; {.365}
F_UseSaveSW:=True; {.365}

{.357}
c_DinArrayLenCorrect:=0;
{$IFDEF FPC}
    c_DinArrayLenCorrect:=1;
{$ENDIF}
SetDynArrayLenCorrect(c_DinArrayLenCorrect);



CreateFuncList;
CreateFactMass;
CreateBinomCoeff;

//Application.OnException:=CalcException;

SetType(T_Real);

REGA[1]:=0;
REGA[2]:=0;
REGA[3]:=0;
REGA[4]:=0;
REGA[5]:=0;
REGA[6]:=0;
REGA[7]:=0;
REGA[8]:=0;

NameTypeS[T_Real]:='Real';
NameTypeS[T_Complex]:='Complex';
NameTypeS[T_Array]:='Array';
NameTypeS[T_Integer]:='Integer';
NameTypeS[T_None]:='None';
NameTypeS[T_Void]:='Void';
NameTypeS[T_Pointer]:='Pointer';

NameMathTypeS[_Single]:='Single';
NameMathTypeS[_Double]:='Double';
NameMathTypeS[_Extended]:='Extended';
NameMathTypeS[_Integer]:='Integer';
NameMathTypeS[_Pointer]:='Pointer';


end;


procedure TForevalH.SetCorrectDynArrayLen(Val: Integer);
begin
   DinArrayLenCorrect:=Val;
   SetDynArrayLenCorrect(Val);
end;


procedure TForevalH.SetSyntaxExtension(Val: Boolean); {.341}
begin
   SyntaxExtension:=Val;
   //SkippedIf:=Val;
   PipeBracketToAbs := Val;
   SquareBracketToTrunc:= Val;
   CurlyBracketToFrac:= Val;
   ReplaceFuncInPart:= Val;
   ExtNameFunction := Val;
   SubstNumCX  := Val;
   Alg.Opr[COP_POW].Enable := Val;
   Alg.Opr[COP_FACT1].Enable := Val;
   Alg.Opr[COP_FACT2].Enable := Val;
   Alg.Opr[COP_CONJ].Enable := Val;
   Alg.Opr[COP_RE].Enable := Val;
   Alg.Opr[COP_IM].Enable := Val;

end;



procedure TForevalH.SetSyntaxExtensionForOperations(Val: Boolean); {.341}
begin
   Alg.Opr[COP_POW].Enable := Val;
   Alg.Opr[COP_FACT1].Enable := Val;
   Alg.Opr[COP_FACT2].Enable := Val;
   Alg.Opr[COP_CONJ].Enable := Val;
   Alg.Opr[COP_RE].Enable := Val;
   Alg.Opr[COP_IM].Enable := Val;
end;


function TForevalH.GetLineStackAdr(NodeM: PNode; NArg: Cardinal{NM,NArg: Cardinal}): TAddress;
var
i,NL,N,NF,TV,TM,CallT, NArgF, S, SzArg: Integer;
SAdr: TAddress;
begin
             //"упаковка" в стека в 16-ти байтные ячейки (вместо 32 (TComplexE=ext,ext))

    {N:=Interp[NM].NFunc;
    NF:=Interp[NM].NF;
    NL:=Interp[NM].NL;
    S:=Interp[NM].S;
    }
    S:=NodeM^.S;
    NL:=NodeM^.NL;
    N:=NodeM^.NFunc;
    NF:=NodeM^.NF;

    NArgF:=Alg.ExFunc[N].Func[NF].NArg;

    SzArg:=0;

    //{$OverFlowChecks Off}
    //{$RangeChecks Off}

    //SzArg - размерность предыдущих аргументов
    for I := 0 to NArg - 2 do
      begin
        TV:=Alg.ExFunc[N].Func[NF].TV[i];
        if (TV = T_Real) or (TV = T_Array) then SzArg:=SzArg+16 else
        if (TV = T_Complex) then SzArg:=SzArg+32;
      end;
    //{$OverFlowChecks On}
    //{$RangeChecks On}

    SAdr:=GetStackAdr(S,_RE)+SzArg;    //GetStackAdr(S,_RE) - адрес первой ячейки функции

    GetLineStackAdr:=SAdr;
end;



procedure TForevalH.SaveArgMemAdr(Node: PNode{i: Cardinal});
var
S,N,NM,CallT,NF,dt,sh,Adr,tf,NL: Cardinal;
SAdr: TAddress;
begin                         //NM - номер функции
   {S:=Interp[I].S;            //NL - порядковый номер аргумента в функции
   NM:=Interp[I].NM;
   NL:=Interp[I].NL;
   N:=Interp[NM].NFunc;
   NF:=Interp[NM].NF;
   }
   S:=Node^.S;
   NL:=Node^.NL;
   N:=Node^.Pr^.NFunc;
   NF:=Node^.Pr^.NF;

   SAdr:=GetLineStackAdr({NM}Node^.Pr,NL);    //получить адрес сохранения для текущего аргумента(NL)

     case Node^.ExtArg of
      D_Real:         dt:=_Double;
      D_Complex:      dt:=_Double;
      E_Real:         dt:=_Extended;
      E_Complex:      dt:=_Extended;
      S_Real:         dt:=_Single;
      S_Complex:      dt:=_Single;
      D_Array_Real:   dt:=_Pointer;
      E_Array_Real:   dt:=_Pointer;
      I_Array_Real:   dt:=_Pointer;
      S_Array_Real:   dt:=_Pointer;
      I_Real:         dt:=_Integer;
      I_Pointer:      dt:=_Pointer;
     end;

     if (Node^.TypeF = T_Real) and (Node^.COP = _LDINTFORM) then {.309}  //EAX -> MEM
     begin
      MOVREGM(R_EAX,SAdr);
     end
     else
     if Node^.TypeF = T_Real then
     begin
      FSTPM(SAdr,dt);
     end
     else
     if (Node^.TypeF = T_Complex)  then
     begin
      FSTPM(SAdr,dt);
      FSTPM(SAdr+sh_E,dt);
     end
     else
     if Node^.TypeF = T_Array then
     begin  {arraycpu}
      //FSTPM(SAdr,_Pointer);    {.197}

      //POPF(SAdr);      {.223}

      //PUSHF(GetStackAdr(S,_RE)) ;
      //POPF(SAdr);
        {
        PUSHF(Alg.Obj[GNode^.NObj].Addr);
        POPF(SAdr);
        }

        (*
        MOVMREG(R_EAX,Alg.Obj[GNode^.NObj].Addr);             {.309}
        MOVREGM(R_EAX,SAdr);
        *)
        {.353}   //выгрузка адреса массива из EAX в адрес аргумента ф-ии:
        MOVREGM(R_EAX,SAdr);
     end
     else
     if Node^.TypeF = T_Pointer then
     begin  {arraycpu}
        {.353}   //выгрузка указателя из EAX в адрес аргумента ф-ии:
        MOVREGM(R_EAX,SAdr);
     end;
end;




procedure TForevalH.SaveArgPC(Node: PNode{i: Cardinal});      {.197}
var
S,N,NM,CallT,NF,dt,sh,Adr,tf,NL,TV,TM: Cardinal;
SAdr,AddrArg,Addr: TAddress;

begin

 {S:=Interp[I].S;
 NM:=Interp[I].NM;
 NL:=Interp[I].NL;
 N:=Interp[NM].NFunc;
 NF:=Interp[NM].NF;   }



 S:=Node^.S;
 NL:=Node^.NL;
 N:=Node^.Pr^.NFunc;
 NF:=Node^.Pr^.NF;


 CallT:=Alg.ExFunc[N].Func[NF].CallT;

if Node^.TypeF = T_Array then
begin  {arraycpu}
      //FSTPM(GetStackAdr(S,_RE),_Pointer);      {.197}
      //POPF(GetStackAdr(S,_RE));      {.223}

      {.353}   //выгрузка адреса массива из EAX в стек выражения
      MOVREGM(R_EAX,GetStackAdr(S,_RE));
      Node^.Pr^.RData[NL-1]:=_MEM;
end
else
if Node^.TypeF = T_Pointer then
begin  {arraycpu}

      {.353}   //выгрузка указателя из EAX в стек выражения
      MOVREGM(R_EAX,GetStackAdr(S,_RE));
      Node^.Pr^.RData[NL-1]:=_MEM;
end
else
if (Node^.TypeF = T_Real) and (Node^.COP = _LDINTFORM) then {.309}  //EAX -> MEM
begin
  MOVREGM(R_EAX,GetStackAdr(S,_RE));
  Node^.Pr^.RData[NL-1]:=_MEM;
end
else
//если в целочисленный аргумент ф-ии передаётся плавающее значение   {.357}  //FISTP -> MEM
if (Node^.TypeF = T_Real) and (Node^.ExtArg = I_Real) then
begin
  FSTPM(GetStackAdr(S,_RE),_Integer);
  Node^.Pr^.RData[NL-1]:=_MEM;
end
else
if (Node^.SData = _MEM) then       {.309}//off
begin
     case Node^.ExtArg of
      D_Real:         dt:=_Double;
      D_Complex:      dt:=_Double;
      E_Real:         dt:=_Extended;
      E_Complex:      dt:=_Extended;
      S_Real:         dt:=_Single;
      S_Complex:      dt:=_Single;
      D_Array_Real:   dt:=_Pointer;
      E_Array_Real:   dt:=_Pointer;
      I_Array_Real:   dt:=_Pointer;
      S_Array_Real:   dt:=_Pointer;
      I_Real:         dt:=_Integer;
      I_Pointer:      dt:=_Pointer;
     end;


     if Node^.TypeF = T_Real then
     begin
      FSTPM(GetStackAdr(S,_RE),dt);
     end
     else
     if Node^.TypeF = T_Complex then
     begin       //RE-ST(0); IM-ST(1)
      FSTPM(GetStackAdr(S,_RE),dt);
      FSTPM(GetStackAdr(S,_IM),dt);
     end

end;



{.309}
(*
 S:=Node^.S;
 NL:=Node^.NL;
 N:=Node^.Pr^.NFunc;
 NF:=Node^.Pr^.NF;

 TV:=Alg.ExFunc[N].Func[NF].TV[NL-1];
 TM:=Alg.ExFunc[N].Func[NF].TM[NL-1];
 AddrArg:=Alg.ExFunc[N].Func[NF].ArgAdr[NL-1];


 if Node^.TypeF = T_Array then
 begin    {arraycpu}
     Addr:=Alg.Obj[GNode^.NObj].Addr;
     MOVMREG(R_EAX,Addr);
     MOVREGM(R_EAX,AddrArg);
 end
 else
 if (Node^.TypeF = T_Real) and (Node^.COP = _LDINTFORM) then {.309}  //EAX -> MEM
 begin
     MOVREGM(R_EAX,AddrArg);
 end
 else
 if (Node^.TypeF = T_Real)  then
 begin
     FSTPM(AddrArg,TM);
 end
 else
 if TV  =  T_Complex then
 begin
     FSTPM(AddrArg,TM);

     if TM = _Double   then FSTPM(AddrArg+SH_D,TM)
       else
     if TM = _Extended then FSTPM(AddrArg+SH_E,TM)
 end;

*)

end;





function   TForevalH.GetSizeSh(tm: integer): integer;
begin
    if tm = _Double then GetSizeSh:=sh_D else
       if tm = _Extended then GetSizeSh:=sh_E else
           if tm = _Single then GetSizeSh:=sh_S;
end;



function TForevalH.SizeArg(VType: Integer): Integer;
begin
  case VType of
      S_Real:          SizeArg:=4;
      D_Real:          SizeArg:=8;
      D_Complex:       SizeArg:=16;
      E_Real:          SizeArg:=12;
      E_Complex:       SizeArg:=24;
      S_Complex:       SizeArg:=8;
      D_Array_Real:    SizeArg:=4;
      E_Array_Real:    SizeArg:=4;
      I_Array_Real:    SizeArg:=4;
      S_Array_Real:    SizeArg:=4;
      I_Real:          SizeArg:=4;
      I_Pointer:       SizeArg:=4;
  end;
end;



procedure TForevalH.SaveArgStackVal(Node: PNode{i: Cardinal});      {.197} {.304}
var
S,N,NM,CallT,NF,dt,sh,Adr,tf,NL,TV,TM,Arg: Cardinal;
DS,SZ,Ar: Integer;
SAdr,AddrM,AddrObj: TAddress;

    function  GetCPUStackDeep(Arg1,Arg2: Integer): Integer;     //DS - определение глубины стека для передаваемых аргументов:
    var
      DS,k,CS: Integer;
    begin
     DS:=0;

     for k:=Arg1-1 to  Arg2-1 do
     begin
         CS:=0;
         TV:=Alg.ExFunc[N].Func[NF].TV[k];
         TM:=Alg.ExFunc[N].Func[NF].TM[k];

         if TV = T_Array then   CS:=4
         else
         begin
           case TM of
           _Single:      CS:=4;
           _Integer:     CS:=4;
           _Pointer:     CS:=4;
           _Double:      CS:=8;
           _Extended:    CS:=12;  //12 -  (12 вместо 10) - так компилирует DELPHI
           end;
          case TV of
           T_Real:       CS:=CS;
           T_Complex:    CS:=CS*2;
           end;
         end;



        DS:=DS+CS;
        if (TM = _Extended) and (TV = T_Complex) then DS:=DS+8; //16+16;выравнивание на 16

     end;

     //if Alg.ExFunc[N].Func[NF].Set_Id = _YES then DS:=DS+4;

     GetCPUStackDeep:=DS;
    end;





begin

   {S:=Interp[I].S;
   NM:=Interp[I].NM;
   NL:=Interp[I].NL;
   N:=Interp[NM].NFunc;
   NF:=Interp[NM].NF; }

   S:=Node^.S;
   NL:=Node^.NL;        //порядковый номер аргумента (номер на уровне)
   N:=Node^.Pr^.NFunc;
   NF:=Node^.Pr^.NF;
   Arg:=Alg.ExFunc[N].Func[NF].NArg;
  

   if NL = 1 then
   begin
    DS:=GetCPUStackDeep(1,Arg);   //полная глубина стека для ф-ии (без учета ID)
    if Alg.ExFunc[N].Func[NF].Set_Id = _YES then DS:=DS+4;
    SUBESP(DS);                 //резервирование стека
   end;


   //if _BACK then SZ:=GetCPUStackDeep(NL+1,Arg); //размер последующих аргументов в стеке    (обратный порядок)
   SZ:=GetCPUStackDeep(1,NL-1);   //размер предыдущих аргументов   (прямой порядок)

   case Node^.ExtArg of
      S_Real:          dt:=_Single;
      D_Real:          dt:=_Double;
      D_Complex:       dt:=_Double;
      E_Real:          dt:=_Extended;
      E_Complex:       dt:=_Extended;
      S_Complex:       dt:=_Single;
      D_Array_Real:    dt:=_Pointer;
      S_Array_Real:    dt:=_Pointer;
      E_Array_Real:    dt:=_Pointer;
      I_Array_Real:    dt:=_Pointer;
      I_Real:          dt:=_Integer;
      I_Pointer:       dt:=_Pointer;
   end;


   {
   if Alg.ExFunc[N].Func[NF].Arrow = _RIGHT then Ar:=-1 else
   if Alg.ExFunc[N].Func[NF].Arrow = _BACK then  Ar:=1;
    }

   if (Node^.TypeF = T_Real) and (Node^.COP = _LDINTFORM) then {.309}
   begin
      MOVESPEAX(SZ);
   end
   else
   (*
   if Node^.COP = _LDSA then       {.347}
   begin  //передача адреса объекта

      {
      AddrObj:=Node^.Addr1;

      if (Node^.AI = _AddrVar) then
      begin
         MOVAadr(AddrObj);
         MOVESPEAX(SZ);
      end
      else
      if (Node^.AI = _AddrFunc) then
      begin
         MOVAadr(AddrObj);
         MOVESPEAX(SZ);
      end
      else
      if (Node^.AI = _AddrArray) then
      begin

        //MOVAadr(AddrObj);
        //MOVAA;   //вычисление и передача адреса нулевого элемента массива
        //MOVESPEAX(SZ);


         //MOVMREG(R_EAX,AddrObj);
         MOVCREG(R_EAX,AddrObj);
         MOVESPEAX(SZ);
      end;
      }

      {.353}   //выгрузка указателя из EAX в стек  CPU:
      MOVESPEAX(SZ);
   end
   else
   *)
   if Node^.TypeF = T_Real then
   begin
     FSTPESP(dt,SZ);
   end
   else
   if Node^.TypeF = T_Complex then
   begin       //RE-ST(0); IM-ST(1)
      FSTPESP(dt,SZ);    //re
      case dt  of
        _Single:     SZ:=SZ+Sh_S; //+4
        _Double:     SZ:=SZ+Sh_D; //+8
        _Extended:   SZ:=SZ+Sh_E; //+16
       end;
      FSTPESP(dt,SZ);    //im
   end
   else
   if Node^.TypeF = T_Array then      //_LDSF
   begin    {arraycpu}
     {AddrM:=Alg.Obj[GNode^.NObj].Addr;
     MOVMREG(R_EAX,AddrM);
     MOVESPEAX(SZ);  }

     {.353}   //выгрузка адреса массива из EAX в стек  CPU:
     MOVESPEAX(SZ);
   end
   else
   if Node^.TypeF = T_Pointer then      //_LDSA
   begin    {arraycpu}
     {.353}   //выгрузка указателя из EAX в стек  CPU:
     MOVESPEAX(SZ);
   end;



   (*
   S:=Node^.S;
   NL:=Node^.NL;
   N:=Node^.Pr^.NFunc;
   NF:=Node^.Pr^.NF;

   CallT:=Alg.ExFunc[N].Func[NF].CallT;

  case Node^.ExtArg of
      D_Real:     dt:=_Double;
      D_Complex:  dt:=_Double;
      E_Real:     dt:=_Extended;
      E_Complex:  dt:=_Extended;
      D_Array_Real:   dt:=_Pointer;
      E_Array_Real:   dt:=_Pointer;
      I_Array_Real:    dt:=_Pointer;
       _Integer:       dt:=_Integer;
     end;
     if Node^.TypeF = T_Real then
     begin
      FSTPM(GetStackAdr(S,_RE),dt);
     end
     else
     if Node^.TypeF = T_Complex then
     begin       //RE-ST(0); IM-ST(1)
      FSTPM(GetStackAdr(S,_RE),dt);
      FSTPM(GetStackAdr(S,_IM),dt);
     end
     else
     if Node^.TypeF = T_Array then
     begin    {arraycpu}
      //FSTPM(GetStackAdr(S,_RE),_Pointer);      {.197}

      //POPF(GetStackAdr(S,_RE));       {.223}
     end;

     *)
end;


procedure TForevalH.SaveArgStackAdr(Node: PNode{i: Cardinal});      {.197}
var
S,N,NM,CallT,NF,dt,sh,Adr,tf,NL,TV,TM: Cardinal;
SAdr: TAddress;

begin

   {S:=Interp[I].S;
   NM:=Interp[I].NM;
   NL:=Interp[I].NL;
   N:=Interp[NM].NFunc;
   NF:=Interp[NM].NF; }

   S:=Node^.S;
   NL:=Node^.NL;
   N:=Node^.Pr^.NFunc;
   NF:=Node^.Pr^.NF;
   CallT:=Alg.ExFunc[N].Func[NF].CallT;

   case Node^.ExtArg of
      D_Real:         dt:=_Double;
      D_Complex:      dt:=_Double;
      E_Real:         dt:=_Extended;
      E_Complex:      dt:=_Extended;
      S_Real:         dt:=_Single;
      S_Complex:      dt:=_Single;
      D_Array_Real:   dt:=_Pointer;
      E_Array_Real:   dt:=_Pointer;
      I_Array_Real:   dt:=_Pointer;
      S_Array_Real:   dt:=_Pointer;
      I_Real:         dt:=_Integer;
      I_Pointer:      dt:=_Pointer;
   end;


     if (Node^.TypeF = T_Real) and (Node^.COP = _LDINTFORM) then {.309}  //EAX -> MEM
     begin
      MOVREGM(R_EAX,GetStackAdr(S,_RE));
     end
     else
     if Node^.TypeF = T_Real then
     begin
      FSTPM(GetStackAdr(S,_RE),dt);
     end
     else
     if (Node^.TypeF = T_Complex)  then
     begin
      Adr:=GetStackAdr(S,_RE);
      if  dt = _Double    then  sh:=sh_D else
      if  dt = _Extended  then  sh:=sh_E;
      FSTPM(Adr,dt);
      FSTPM(Adr+sh,dt);
     end
     else
     if Node^.TypeF = T_Array then
     begin    {arraycpu}
      //FSTPM(GetStackAdr(S,_RE),_Pointer);    {.197}

      //POPF(GetStackAdr(S,_RE));           {.223}

      {.353}   //выгрузка адреса массива из EAX в стек выражения:
       MOVREGM(R_EAX,GetStackAdr(GNode^.S,_RE));
     end
     else
     if Node^.TypeF = T_Pointer then
     begin    {arraycpu}
      {.353}   //выгрузка указателя из EAX в стек выражения:
       MOVREGM(R_EAX,GetStackAdr(GNode^.S,_RE));
     end;
end;



 (*
procedure TForevalH.SetExtArg;
label endp;
var
i,NM,NL,N,NF,TV,TM,CallT: Integer;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

  for i:= 1 to  High(Interp)-1 do
  begin

    NM:=Interp[i].NM;
    NL:=Interp[i].NL;

    N:=Interp[NM].NFunc;
    NF:=Interp[NM].NF;

    CallT:=Alg.ExFunc[N].Func[NF].CallT;

    if  CallT = 0 then
       Interp[i].ExtArg:=0
    else
    begin
      if (CallT = _STACK_ADR) or (CallT = _EAX) or (CallT = _ESP) or (CallT = _STACK_VAL) or (CallT = _COMPILED) then
      begin
       TV:=Alg.ExFunc[N].Func[NF].TV[NL-1];
       TM:=Alg.ExFunc[N].Func[NF].TM[NL-1];
      end
      else
      if  CallT = _STACK_INFINITE then
      begin
       TV:=Alg.ExFunc[N].Func[NF].TV[0];
       TM:=Alg.ExFunc[N].Func[NF].TM[0];
      end
      else
      if  CallT = _STACK_INFINITE_A then
      begin
       TV:=Interp[i].TypeF;
       TM:=Alg.ExFunc[N].Func[NF].TM[0];
      end;

       if (TV = T_Real) and (TM = _Double) then Interp[i].ExtArg:=D_Real else
       if (TV = T_Real) and (TM = _Extended) then Interp[i].ExtArg:=E_Real else
       if (TV = T_Complex) and (TM = _Double) then Interp[i].ExtArg:=D_Complex else
       if (TV = T_Complex) and (TM = _Extended) then Interp[i].ExtArg:=E_Complex else
       if (TV = T_Array) and (TM = _Double) then Interp[i].ExtArg:=D_Array_Real else
       if (TV = T_Array) and (TM = _Extended) then Interp[i].ExtArg:=E_Array_Real else
       if (TV = T_Array) and (TM = _Integer)  then Interp[i].ExtArg:=I_Array_Real else
       if (TV = T_Real) and (TM = _Integer) then Interp[i].ExtArg:=_Integer;
    end;

  end;

  Interp[High(Interp)].ExtArg:=0;

endp:
end;
*)



function TForevalH.SetExtArgInNode(Tree: PNode): Boolean;
var
 i,NM,NL,N,NF,TV,TM,CallT: Integer;
 begin

          {
            NM:=Interp[i].NM;
            NL:=Interp[i].NL;

            N:=Interp[NM].NFunc;
            NF:=Interp[NM].NF;
           }

          N:=Tree^.Pr^.NFunc;
          NF:=Tree^.Pr^.NF;

          CallT:=Alg.ExFunc[N].Func[NF].CallT;

         if  CallT = 0 then
          //Interp[i].ExtArg:=0
           Tree^.ExtArg:=0
         else
         begin

           if (CallT = _STACK_ADDR) or (CallT = _MEMORY_EAX) or (CallT = _MEMORY_ESP) or (CallT = _STACK_VAL) or (CallT = _COMPILED) then
           begin
            TV:=Alg.ExFunc[N].Func[NF].TV[NL-1];
            TM:=Alg.ExFunc[N].Func[NF].TM[NL-1];
           end
           else
           if  CallT = _STACK_INFINITE then
           begin
            TV:=Alg.ExFunc[N].Func[NF].TV[0];
            TM:=Alg.ExFunc[N].Func[NF].TM[0];
           end
           else
           if  CallT = _INTERNAL_INFINITE_ANY then
           begin
            //TV:=Interp[i].TypeF;
            TV:=Tree^.TypeF;
            TM:=Alg.ExFunc[N].Func[NF].TM[0];
           end;

           if (TV = T_Real) and (TM = _Double) then Tree^.ExtArg:=D_Real else
           if (TV = T_Real) and (TM = _Extended) then Tree^.ExtArg:=E_Real else
           if (TV = T_Real) and (TM = _Single) then Tree^.ExtArg:=S_Real else
           if (TV = T_Complex) and (TM = _Double) then Tree^.ExtArg:=D_Complex else
           if (TV = T_Complex) and (TM = _Extended) then Tree^.ExtArg:=E_Complex else
           if (TV = T_Complex) and (TM = _Single) then Tree^.ExtArg:=S_Complex else
           if (TV = T_Array) and (TM = _Double) then Tree^.ExtArg:=D_Array_Real else
           if (TV = T_Array) and (TM = _Extended) then Tree^.ExtArg:=E_Array_Real else
           if (TV = T_Array) and (TM = _Integer)  then Tree^.ExtArg:=I_Array_Real else
           if (TV = T_Array) and (TM = _Pointer)  then Tree^.ExtArg:=I_Array_Real else
           if (TV = T_Array) and (TM = _Single) then Tree^.ExtArg:=S_Array_Real else
           if (TV = T_Real) and (TM = _Integer) then Tree^.ExtArg:=I_Real else
           if (TV = T_Pointer) and (TM = _Pointer) then Tree^.ExtArg:=I_Pointer;

   end;
 SetExtArgInNode:=False;
end;



procedure TForevalH.SetExtArg;
label endp;
var
PF: TProcTree;
PFObj: TProcTreeObj;
NL,NM,N,NF: Cardinal;
CallT,TV,TM: Integer;
Node: PNode;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

(*
// PFObj:=ForevalH.SetExtArgInNode;

 ReadTree(SetExtArgInNode);
 //ReadTree(@TForevalH.SetExtArgInNode);
 //ReadTree(TProcTree(TForevalH.SetExtArgInNode));
 Tree^.ExtArg:=0;
*)


Node:=FirstNode;
//Node^.ExtArg:=0;

//if Node^.NM = 0 then goto endp;

while Node^.Pr <> nil do
begin

    N:=Node^.Pr^.NFunc;
    NF:=Node^.Pr^.NF;
    NL:=Node^.NL;


    CallT:=Alg.ExFunc[N].Func[NF].CallT;

    if  CallT = 0 then
       Node^.ExtArg:=0
    else
    begin
      if (CallT = _STACK_ADDR) or (CallT = _MEMORY_EAX) or (CallT = _MEMORY_ESP) or (CallT = _STACK_VAL) or (CallT = _COMPILED) then
      begin
       TV:=Alg.ExFunc[N].Func[NF].TV[NL-1];
       TM:=Alg.ExFunc[N].Func[NF].TM[NL-1];
      end
      else
      if  CallT = _STACK_INFINITE then
      begin
       TV:=Alg.ExFunc[N].Func[NF].TV[0];
       TM:=Alg.ExFunc[N].Func[NF].TM[0];
      end
      else
      if  CallT = _INTERNAL_INFINITE_ANY then
      begin
       TV:=Node^.TypeF;
       TM:=Alg.ExFunc[N].Func[NF].TM[0];
      end;

       if (TV = T_Real) and (TM = _Double) then Node^.ExtArg:=D_Real else
       if (TV = T_Real) and (TM = _Extended) then Node^.ExtArg:=E_Real else
       if (TV = T_Real) and (TM = _Single) then Node^.ExtArg:=S_Real else
       if (TV = T_Complex) and (TM = _Double) then Node^.ExtArg:=D_Complex else
       if (TV = T_Complex) and (TM = _Extended) then Node^.ExtArg:=E_Complex else
       if (TV = T_Complex) and (TM = _Single) then Node^.ExtArg:=S_Complex else
       if (TV = T_Array) and (TM = _Double) then Node^.ExtArg:=D_Array_Real else
       if (TV = T_Array) and (TM = _Extended) then Node^.ExtArg:=E_Array_Real else
       if (TV = T_Array) and (TM = _Integer)  then Node^.ExtArg:=I_Array_Real else
       if (TV = T_Array) and (TM = _Pointer)  then Node^.ExtArg:=I_Array_Real else
       if (TV = T_Array) and (TM = _Single) then Node^.ExtArg:=S_Array_Real else
       if (TV = T_Real) and (TM = _Integer) then Node^.ExtArg:=I_Real else
       if (TV = T_Pointer) and (TM = _Pointer) then Node^.ExtArg:=I_Pointer;
    end;

    Node:=Node^.Next;
end;

  Node^.ExtArg:=0;     //top of tree: last node

 endp:
end;



{
procedure TForevalH.ReplaceArctan;
var

begin
  for i:=1 to LFunc-1 do
  begin
     if (Interp[i].NFunc = CM_ARCTAN) and (i > 1) then
     begin
       if (Interp[i-1].NFunc = CM_DIV) and (Interp[i-1].TypeF = T_Real) then
       begin
          Interp[i].NFunc: = CM_ARCTAN2;
          Interp[i].N:=2;
       end;
     end;
  end;
end;
  }






procedure TForevalH.SetExtExpression(S: String; Atr: TAttrib;  var E_Func: TFunction; var Stack: Cardinal);
label endp, beginp, nocmpl;
var
I_Func: TFunction;
I_LFunc, FAdr,StSize: Cardinal;
E: Exception;
cc: boolean;
V_RE,V_IM: Extended;
Siu,Sre,Sim,S1,S2,S3,S4: String;
T1,T2: Cardinal;
EnableCmpl: Boolean;
ResType: integer;    {.324}
CommonError: Integer; {.326}
begin
cc:=false;

if F_SubstNumCX = True then Siu:=S_IM_UNIT else Siu:='*'+S_IM_UNIT;
CheckRecoverImUnit;

S1:=S;

PrevTreat(S,S);
if F_SyntaxErrorCode <> 0 then          {.231}
begin

   Func.Addr:=0;
   E_Func.Addr:=0;
   Func.Code:=nil;
   Func.Data:=nil;
   Func.PAddr:=nil;
   Func.Addr:=0;
   IntException;
   goto endp;
end;


beginp:

InitConstDb;
InitUsedVar;      {.333}
Set8087CW($1372); {.229}
try
V_RE:=0; V_IM:=0;    {.191}

if F_StackDeep = 0 then F_SaveInFPU:=False else F_SaveInFPU:=True;   {.300} //on
//F_SaveInFPU:=F_DinamicLoadOptimization;  {.300}  //off

//F_CalcConstExpr:=F_OperationOptimizator;  {.195}



//I_LFunc:=LFunc;
//Func:=E_Func;    {.221}
Func.PAddr:=nil;
Func.Addr:=0;
Func.Data:=nil;
Func.Code:=nil;
Tree:=nil;
BeginTree:=nil;
F_SyntaxErrorCode:=0;
//F_CalcErrorCode:=0;
F_InternalError:=0;
CommonError:=0;
F_SyntaxErrorString:=S;
F_Mode:=M_Compile;   {.197}
F_SyntaxErrorStringA:='';
F_GotoPresent:=False;
F_IF:=False;
F_EnableCalcConstExpression:=True;
F_ComplexNumber:=False;
F_PresentVar:=False;
F_CallFuncPresent:=False; {.347}
F_CanRecompile:=False; {.347}     //=F_PresentVar&F_CallFuncPresent
CurrentExpression:=Copy(S,1,Length(S));
F_ResultType:=T_Complex; {.227}
F_SequentList:=False;
N_DataCellNum:=0;
N_MaxDataCell:=0;
F_EvalDataCell:=False;
N_ReplFuncLen:=0;
N_CurrentDataCell:=0;
M_ParseMode:=M_Compile;
C_CmplParamNumbers:=0;
G_FAttr:=Atr;

//F_DataInArray :=False;

//PrevTreat(S,S);
      //TestZ.Form1.MT.Lines.Add('****************************');
      //T1:=GetTickCount;
TryFPUMask; {.229}
TreeBuilder(S);

      //T2:=GetTickCount;
      //TestZ.Form1.MT.Lines.Add('Linker: '+IntToStr(T2-T1));

//запрет компиляции выражения(из составного выражения) для генерации константы , если оно содержит переменную (уже не константа)
//F_EnableCalcConsExprInMulti устанавливает: _CompileMultiExpr
if   (F_EnableCalcConsExprInMulti = True) and (F_PresentVar = True) then  EnableCmpl:= False else EnableCmpl:= True;   {.221}

//Связывание найденных команд с типом аргумента,  оптимизация, компиляция
if (F_SyntaxErrorCode = 0) and (F_InternalError = 0) and  (EnableCmpl = True){.221} {.227}   then
begin
  //FreeFunction;
      //T1:=GetTickCount;
  InitSequentList;  {.233}

  SetNL;
  SetLoadSource;
  //SetNM;

 
  SetStackSize;
  //StSize:=StackSize;

     //T1:=GetTickCount;
  LinkTreeData;

  if (F_CalcConstARG = True) or (F_CalcConstFUNC = True) then
  begin
     SetExtArg;
     EvalTreeConst; {.306}
     if F_InternalError <> 0 then goto nocmpl; {.322}

     if F_PolyUReWriteConst = True then PolyUReWrite; {.353}
  end;

     //T2:=GetTickCount;
     //TestZ.Form1.MT.Lines.Add('CodeGen: '+IntToStr(T2-T1));
   
  //FreeTree; {.233}    {.197}
  SetExtArg;
  if F_TreeOptimization  <> _Disable then
  begin
                //SetExtArg;
    TreeOptimizator;
  end;


  F_IF:=FindIfFunc;
  //SetExtArg;
  //SetNL;

      //T1:=GetTickCount;
  if (F_IF = True) and (F_DisableReplaceIF = True) then begin end else  ReplaceOptimizator;   {.195}
      //T2:=GetTickCount;
      //TestZ.Form1.MT.Lines.Add('Replace: '+IntToStr(T2-T1));
  //SetStackSize;


  // ReadTreeDBG;     //dbg

      //T1:=GetTickCount;
  if (F_DinamicLoadOptimization = True) and (F_SaveInFPU = True) then   DinamicLoadOptimizator;

 //SetNL;
      //T2:=GetTickCount;
      //TestZ.Form1.MT.Lines.Add('DinLoad: '+IntToStr(T2-T1));

  //if Length(Interp) <> 0 then F_ResultType:=Interp[High(Interp)].TypeF;
    if BeginTree <> nil then F_ResultType:=BeginTree^.TypeF;

  //SetStackSize;
  //FreeTree;     {.197}

  SetLength(Func.Stack,StackSize{StSize});
  _MaxStack:=0;

    {DEBUG DL}
     //DebugDL;


  EvalDataCellNum;

  if F_DataInArray = True then
  begin
    N_ReplFuncLen:=Length(Func.RFStack)+1;
    SetLength(Func.RFStack,Length(Func.RFStack)+N_MaxDataCell+2);
  end;
       //T1:=GetTickCount;
      // SetNL;
  Compile;

  {DB}     {.332}
  if Db_WriteDataOverFlow = True then
  begin
      CommonError:=E_AccessViolation;
  end;

  {DB}     {.332}
  if Db_WriteStackDataOverFlow = True then
  begin
      CommonError:=E_AccessViolation;
  end;




      //T2:=GetTickCount;
      //TestZ.Form1.MT.Lines.Add('Compile: '+IntToStr(T2-T1));
      //TestZ.Form1.MT.Lines.Add('SizeInterp: '+IntToStr(Length(Interp)));

//Func.ICode:=TAddress(@Func.Code[NAdr]);   {.193}
  Db_CmplMaxStack:=_MaxStack;
  Db_LoadStackAfterCalc:=N_Stack;         {.197}
//FreeInterp;
//FreeTree;
  Stack:=StackSize;
  E_Func:=Func;
//LFunc:=I_LFunc;
//Func:=I_Func;

  if (F_IF = True) or (F_GotoPresent = True) then F_EnableCalcConstExpression:=False;

  //F_EnableCalcConstExpression:=False;  //db

 nocmpl:
 TryCatchFPUException;    {.229}


end;
{else   //xx=t; xx
if (F_SyntaxErrorCode = 0) and (F_InternalError = 0) and  (EnableCmpl = False)   then
begin
      if BeginTree <> nil then F_ResultType:=BeginTree^.TypeF;
end;  }

 //для случая определения типа переменной по выражению без компиляции   xx=t; xx    xx=z1+z2; xx :
 if BeginTree <> nil then F_ResultType:=BeginTree^.TypeF; {.357}
 {.326}
 FreeTree;
 //FreeCmplParam;

except
 on E: EZeroDivide      do {F_SyntaxErrorCode:=E_INTERNAL_ERROR;}CommonError:=E_ZeroDivide;
 on E: EInvalidOp       do {F_SyntaxErrorCode:=E_INTERNAL_ERROR;}CommonError:=E_InvalidOp;
 on E: EOverFlow        do {F_SyntaxErrorCode:=E_INTERNAL_ERROR;}CommonError:=E_OverFlow;
 on E: EUnderFlow       do {F_SyntaxErrorCode:=E_INTERNAL_ERROR;}CommonError:=E_UnderFlow;
 on E: EIntOverFlow     do {F_SyntaxErrorCode:=E_INTERNAL_ERROR;}CommonError:=E_IntOverFlow;
 on E: EAccessViolation do {F_SyntaxErrorCode:=E_INTERNAL_ERROR;}CommonError:=E_AccessViolation;
 on E: EOutOfMemory     do {F_SyntaxErrorCode:=E_INTERNAL_ERROR;}CommonError:=E_OutOfMemory;
 on E: EStackOverFlow   do {F_SyntaxErrorCode:=E_INTERNAL_ERROR;}CommonError:=E_StackOverFlow;
end;

{.326}
if CommonError <> 0  then
begin
  {.346}
  FreeTree;//Для случаев AV,...  Т.к. FreeTree не выполняется в try except

  F_SyntaxErrorString:=CurrentExpression;
  F_InternalError:=CommonError;
  if (F_InternalError <> 0) and (F_SyntaxErrorCode = 0) then
  begin
   if F_InternalError = E_AccessViolation then
      F_SyntaxErrorCode:=E_INTERNAL_ERROR else
      F_SyntaxErrorCode:=E_INTERNAL_ERROR_AT_CALCULATION;
  end;
end;






{FreeTree;
FreeCmplParam; }


if (F_InternalError <> 0 ) or (F_SyntaxErrorCode <> 0) then
begin
 FreeExtFunc(@Func); {.225}
 ICOMP:=nil;
 IntException;
 goto endp;
end;

if  (F_PresentVar = False)  and (F_CallFuncPresent = False) then F_CanRecompile:=True;


//перекомпиляция, если выражение - константа
if (F_ResultType <> T_None) and (F_CanRecompile = True)  {and (F_PresentVar = False)  and (F_CallFuncPresent = False)}  and
   (F_CalcConstExpr = True)   and (cc = false) and ({F_GotoPresent = False}F_EnableCalcConstExpression = True) then
begin
  FAdr:=Func.Addr;
  if F_CalcType = T_Any then ResType := F_ResultType else ResType := F_CalcType; {.324}

  try
    TryFPUMask; {.229}

    if G_FAttr.FType <>  0 then        {.357}
    begin
       asm
          call  FAdr
       end;
       if G_FAttr.FType = _Extended then     {.366}
       begin
         V_RE:=PExtended(G_FAttr.AddrRE)^;
         V_IM:=PExtended(G_FAttr.AddrIM)^;
       end
       else
       if G_FAttr.FType = _Double then
       begin
         V_RE:=PDouble(G_FAttr.AddrRE)^;
         V_IM:=PDouble(G_FAttr.AddrIM)^;
       end
       else
       if G_FAttr.FType = _Single then
       begin
         V_RE:=PSingle(G_FAttr.AddrRE)^;
         V_IM:=PSingle(G_FAttr.AddrIM)^;
       end;
    end
    else
    begin

       if ResType = T_Real {F_CalcType = T_Real} then     {.324}
       begin
         asm
           call  FAdr
           fstp  tbyte ptr V_RE
         end;
       end
       else
       if ResType = T_Complex {F_CalcType = T_Complex} then  {.324}
       begin
         asm
           call  FAdr
           fstp  tbyte ptr V_RE
           fstp  tbyte ptr V_IM
         end;
       end;

    end;

    TryCatchFPUException;    {.229}

    FV_Result.re:=V_RE;     FV_Result.im:=V_IM;     {.229}

  except                                                         {.155}
   on E: EZeroDivide      do {F_SyntaxErrorCode:=E_ERROR_AT_CALCULATION;}CommonError:=E_ZeroDivide;
   on E: EInvalidOp       do {F_SyntaxErrorCode:=E_ERROR_AT_CALCULATION;}CommonError:=E_InvalidOp;
   on E: EOverFlow        do {F_SyntaxErrorCode:=E_ERROR_AT_CALCULATION;}CommonError:=E_OverFlow;
   on E: EUnderFlow       do {F_SyntaxErrorCode:=E_ERROR_AT_CALCULATION;}CommonError:=E_UnderFlow;
   on E: EIntOverFlow     do {F_SyntaxErrorCode:=E_ERROR_AT_CALCULATION;}CommonError:=E_IntOverFlow;
   on E: EAccessViolation do {F_SyntaxErrorCode:=E_ERROR_AT_CALCULATION;}CommonError:=E_AccessViolation;
   on E: EOutOfMemory     do {F_SyntaxErrorCode:=E_ERROR_AT_CALCULATION;}CommonError:=E_OutOfMemory;
   on E: EStackOverFlow   do {F_SyntaxErrorCode:=E_ERROR_AT_CALCULATION;}CommonError:=E_StackOverFlow;
  end;

  {.191}
  Sre:=FloatToStr(V_RE);   Sim:=FloatToStr(V_IM);
  if   (LowerCase(Sre)= 'nan') or (LowerCase(Sim)  = 'nan')
    or (LowerCase(Sre)  = 'inf') or (LowerCase(Sim)  = 'inf')
    or (LowerCase(Sre)  = '-inf') or (LowerCase(Sim)  = '-inf')
  then
     CommonError:=E_InvalidOp;


  FreeExtFunc(@Func);{.225}

  if CommonError <> 0  then       {.326}
  begin
     F_SyntaxErrorString:=CurrentExpression;
     F_InternalError:=CommonError;
  end;

  if F_InternalError <> 0 then F_SyntaxErrorCode:=E_INTERNAL_ERROR_AT_CALCULATION;    {.326}

  if (F_SyntaxErrorCode <> 0) or (F_InternalError <> 0)  then
  begin
   //F_CurrentSubExpr:=CurrentExpression;
   //F_CurrentEvalSubExpr:=CurrentExpression;  {.322}
   F_SyntaxErrorString:=CurrentExpression;{.326}
   IntException;
   F_SyntaxErrorString:= F_SyntaxErrorString+ F_SyntaxErrorStringA;
   goto endp;
  end;

  if (F_CalcType = T_Real) or (F_ResultType = T_Real)  then S:=FloatToStrF(V_RE, ffGeneral, 20, 4, G_FMT) {S:=FloatToStr(V_RE,G_FMT)}
   else     {.324}
  //if (F_CalcType = T_Complex)  then  S:=FloatToStrF(V_RE,ffGeneral, 20, 4, G_FMT)+'+('+FloatToStrF(V_IM,ffGeneral, 20, 4, G_FMT)+')'+Siu {S:=FloatToStr(V_RE,G_FMT)+'+i*('+FloatToStr(V_IM,G_FMT)+')'}
  if (F_CalcType = T_Complex) or ((F_CalcType = T_Any) and (F_ResultType = T_Complex)) then  S:=FloatToStrF(V_RE,ffGeneral, 20, 4, G_FMT)+'+('+FloatToStrF(V_IM,ffGeneral, 20, 4, G_FMT)+')'+Siu;



  cc:=true;
  goto beginp;
end;

endp:
E_Func:=Func; {.221}
Set8087CW($1372); {.229}
end;



 {.327}
procedure TForevalH.CheckSyntax(S: String; var Sout: String);
label endp, nocmpl;
var
I_Func: TFunction;
I_LFunc, FAdr,StSize: Cardinal;
E: Exception;
cc: boolean;
V_RE,V_IM: Extended;
Siu,Sre,Sim,S1,S2,S3,S4: String;
T1,T2: Cardinal;
EnableCmpl: Boolean;
ResType: integer;
CommonError: Integer; {.326}
bIntegerOptimization,bIntegerOptimizationF,bOperationOptimizatorA1,bOperationOptimizatorA2,bMulDivOptimization: boolean;
begin


if F_SubstNumCX = True then Siu:=S_IM_UNIT else Siu:='*'+S_IM_UNIT;
CheckRecoverImUnit;


PrevTreat(S,S);
if F_SyntaxErrorCode <> 0 then
begin
   //IntException;   {обработчик запускается из вызывающей процедуры}    {.347}
   goto endp;
end;
Sout:=S;



InitConstDb;
Set8087CW($1372); {.229}
try
V_RE:=0; V_IM:=0;    {.191}

//if F_StackDeep = 0 then F_SaveInFPU:=False else F_SaveInFPU:=True;   {.300} //on
//F_SaveInFPU:=F_DinamicLoadOptimization;  {.300}  //off

//F_CalcConstExpr:=F_OperationOptimizator;  {.195}


Tree:=nil;
BeginTree:=nil;
F_SyntaxErrorCode:=0;
//F_CalcErrorCode:=0;
F_InternalError:=0;
CommonError:=0;
F_SyntaxErrorString:=S;
F_Mode:=M_Compile;   {.197}
F_SyntaxErrorStringA:='';
F_GotoPresent:=False;
F_IF:=False;
F_ComplexNumber:=False;
F_PresentVar:=False;
CurrentExpression:=Copy(S,1,Length(S));
F_ResultType:=T_Complex; {.227}
F_SequentList:=False;
N_DataCellNum:=0;
N_MaxDataCell:=0;
F_EvalDataCell:=False;
N_ReplFuncLen:=0;
N_CurrentDataCell:=0;
M_ParseMode:=M_Compile;
C_CmplParamNumbers:=0;

bIntegerOptimization:=F_IntegerOptimization;
bIntegerOptimizationF:=F_IntegerOptimizationF;
bOperationOptimizatorA1:=F_OperationOptimizatorA1;
bOperationOptimizatorA2:=F_OperationOptimizatorA2;
bMulDivOptimization:=F_MulDivOptimization;

F_IntegerOptimization:=False;
F_IntegerOptimizationF:=False;
F_OperationOptimizatorA1:=False;
F_OperationOptimizatorA2:=False;
F_MulDivOptimization:=False;


TryFPUMask; {.229}
//отключить оптимизацию:
TreeBuilder(S);


if (F_SyntaxErrorCode = 0) and (F_InternalError = 0)   then
begin

  InitSequentList;

  {SetNL;
  SetLoadSource;
  SetStackSize;
  StSize:=StackSize;  }


  LinkTreeData;


 nocmpl:
 TryCatchFPUException;


end;
 {.326}
 FreeTree;
//FreeCmplParam;

except
 on E: EZeroDivide      do {F_SyntaxErrorCode:=E_INTERNAL_ERROR;}CommonError:=E_ZeroDivide;
 on E: EInvalidOp       do {F_SyntaxErrorCode:=E_INTERNAL_ERROR;}CommonError:=E_InvalidOp;
 on E: EOverFlow        do {F_SyntaxErrorCode:=E_INTERNAL_ERROR;}CommonError:=E_OverFlow;
 on E: EUnderFlow       do {F_SyntaxErrorCode:=E_INTERNAL_ERROR;}CommonError:=E_UnderFlow;
 on E: EIntOverFlow     do {F_SyntaxErrorCode:=E_INTERNAL_ERROR;}CommonError:=E_IntOverFlow;
 on E: EAccessViolation do {F_SyntaxErrorCode:=E_INTERNAL_ERROR;}CommonError:=E_AccessViolation;
 on E: EOutOfMemory     do {F_SyntaxErrorCode:=E_INTERNAL_ERROR;}CommonError:=E_OutOfMemory;
 on E: EStackOverFlow   do {F_SyntaxErrorCode:=E_INTERNAL_ERROR;}CommonError:=E_StackOverFlow;
end;

{.326}
if CommonError <> 0  then
begin
  F_SyntaxErrorString:=CurrentExpression;
  F_InternalError:=CommonError;
  if (F_InternalError <> 0) and (F_SyntaxErrorCode = 0) then
  begin
   if F_InternalError = E_AccessViolation then
      F_SyntaxErrorCode:=E_INTERNAL_ERROR else
      F_SyntaxErrorCode:=E_INTERNAL_ERROR_AT_CALCULATION;
  end;
end;






{FreeTree;
FreeCmplParam; }


if (F_InternalError <> 0 ) or (F_SyntaxErrorCode <> 0) then
begin
 //IntException;   {обработчик запускается из вызывающей процедуры}    {.347}
end;



F_IntegerOptimization:=bIntegerOptimization;
F_IntegerOptimizationF:=bIntegerOptimizationF;
F_OperationOptimizatorA1:=bOperationOptimizatorA1;
F_OperationOptimizatorA2:=bOperationOptimizatorA2;
F_MulDivOptimization:=bMulDivOptimization;


endp:
Set8087CW($1372); {.229}
end;




//******************************************************************************

//******************************************************************************




procedure TForevalH.TreeOptimizator;
label endp;
//обмен ветвей дерева
begin
if F_InternalError <> 0 then goto endp; {.322}

 F_Mode:=M_XchBranch;
 SetNodeDeep;
 Db_XchBrNXch:=0;


if (F_TreeOptimization = _Enable) or
   ((F_TreeOptimization = _Auto) and (GetMaxStack > F_StackDeep)) then
 begin
  BranchOptimizator;
  //восстановление данных после обмена ветвей: (реинициализация)
  RestoreStack;
  InitSequentList;
  SetNL;

 // SetNL;
  //SetLoadSource;
  //SetNM;
  {

   }
  //SetLoadSource;
 end;

endp:
end;





function TForevalH.xch_GetFuncLoad(Node: PNode): Integer;
var
S: String;
NM: Integer;
begin
{
 SMAX:=N_Stack;
 GNode:=Node;
 AddCommand(Node);
 xch_GetFuncLoad:=SMAX-N_Stack;
 }
 {.300}
 (*
 SMAX:=0;
 N_Stack:=0;
 GNode:=Node;
 AddCommand(Node);
 xch_GetFuncLoad:=SMAX;
 *)

 //S:=Node^.Expression;   //db
 //NM:=_MaxStack;         //db

 SMAX:=N_PrevStack;
 GNode:=Node;
 AddCommand(Node);
 xch_GetFuncLoad:=SMAX-N_PrevStack;
 N_PrevStack:=N_Stack;
end;


procedure TForevalH.SetNodeDeep;
//вычисление загрузки стека FPU каждым узлом  через предварительное компилирование (эмуляция компилирования Cmpl.E_GetFuncLoad(Tree))
label endp;
var
NS,SD,i: Integer;
S: String;
Interp0: TArrayOfTFunc;
begin
  if F_SyntaxErrorCode <> 0 then goto endp;
  Tree:=BeginTree; //не обязательно, т.к. чтение дерева - циклически
  //SetLength(Interp,1);
  //Cmpl.E_Init(Interp0,{InternalFuncList,ExternalFuncList,}FuncList,VarList,F_StackDeep,F_ParamType,F_DataType,C_EmlXchBranch);
  InitCompiler(M_XchBranch);

  Db_XchBrSDeep:=0;
  N_Stack:=0;

  while Tree^.Ch <> nil do
  begin
    Tree:=Tree^.Ch;
  end;
  Tree^.SDeep:=0+xch_GetFuncLoad(Tree);


while Tree^.Pr <> nil do
begin
   while Tree^.Nb <> nil  do
   begin
    Tree:=Tree^.Nb;
    while Tree^.Ch <> nil do
    begin
     Tree:=Tree^.Ch;
    end;
    Tree^.SDeep:=0+xch_GetFuncLoad(Tree);
    end;

 SD:=Tree^.Pr^.Ch^.SDeep; NS:=Tree^.Pr^.Ch^.Stack.S;
 Tree:=Tree^.Pr^.Ch;
 while Tree^.Nb <> nil do
 begin
  Tree:=Tree^.Nb;
  if (Tree^.SDeep+Tree^.Stack.S) > (SD+NS) then
  begin
   SD:=Tree^.SDeep;
   NS:=Tree^.Stack.S;
  end;
 end;

 Tree:=Tree^.Pr;
 Tree^.SDeep:=NS-Tree^.Stack.S+SD+xch_GetFuncLoad(Tree);
end;

Db_XchBrSDeep:=GetMaxStack;

endp:
end;




procedure TForevalH.BranchOptimizator;
label 1,2,3,endp;
var
S: String;
CNI: Integer;
begin
CNI:=0;
if F_SyntaxErrorCode <> 0 then goto endp;

Tree:=BeginTree; //не обязательно, т.к. чтение дерева - циклически

1:
while Tree.Ch <> nil do
begin
 Tree:=Tree^.Ch;
end;


2:
if Tree^.Nb = nil then goto 3
else
begin
 Tree:=Tree^.Nb;
 goto 1;
end;

3:
if Tree^.Pr = nil then  goto endp
else
begin
 //для добавл. ф-ий с FType < 0 аргументы не переставлять {XchArg=_Yes}  {.205}
 S:=Tree^.Pr^.Expression;
 if (Alg.ExFunc[Tree^.Pr^.NFunc].XchArg = _Yes) and (Tree^.Pr^.N = 2) {должно работать и без этого} then
                                           //{ Tree^.Pr^.NFunc = CM_ADD }{ (FuncList[Tree^.Pr^.Code].XchArg = _Yes)} then  {.205}
 begin
  if CheckXchBranch(Tree^.Pr^.Ch) then
  begin
    //S:=Tree^.Pr^.Expression;
    XchBranch(Tree^.Pr);
    inc(Db_XchBrNXch);
  end;
 end;
 Tree:=Tree^.Pr;
 goto 2;
end;

//not error (must be zero):

//(2*x*y+1)*(3*x*t+1)+(2*x*y+1)^(2*x*y+1)-((2*x*y+1)*(3*x*t+1)+(2*x*y+1)^(2*x*y+1))
//after exchange order of execute (not equal zero):
//-((2*x*y+1)*(3*x*t+1)+(2*x*y+1)^(2*x*y+1))+(2*x*y+1)^(2*x*y+1)+(2*x*y+1)*(3*x*t+1)
//so as (2*x*y+1)^(2*x*y+1) many much  than (2*x*y+1)*(3*x*t+1)

endp:
//sin(z1)-sin(z1/z2)
//sin(x)-sin(z1)

//sin(x)-cos(z1)
//sqr(z1)-x^y
//sqr(z1)-z1^z2
(*
Tree:=BeginTree;
Tree^.Ch^.SData:={_FPU}_MEM;
Tree^.Ch^.Nb^.SData:=_FPU{_MEM};
Tree^.RData[0]:=Tree^.Ch^.SData;
Tree^.RData[1]:=Tree^.Ch^.Nb^.SData;
*)
//Tree^.XchArg:=False;


end;



function TForevalH.CheckXchBranch(Lv: PNode): Boolean;
label endp;
var
SD: Integer;
begin
CheckXchBranch:=False;
SD:=LV^.SDeep;
LV:=LV^.Nb;
while Lv <> nil do
begin
 if Lv^.SDeep > SD then
 begin
  CheckXchBranch:=True;
  goto endp;
 end;
 Lv:=Lv^.Nb;
end;

endp:
end;





procedure TForevalH.XchBranch(Pr: PNode);
type
Tmax = record
        N: Integer;
     Tree: PNode;
       end;
var
Mx: array of TMax;
Tr,Ch: PNode;
N,M,i,j,Max,NMax,nif,SS,St: Integer;
S,S1,S2,S3: String;
begin
Ch:=Pr^.Ch;
N:=0;

while Ch <> nil do
begin
 inc(N);
 Ch:=Ch^.Nb;
end;
SetLength(MX,N);

//создание массива узлов:
Ch:=Pr^.Ch;
M:=0;
while Ch <> nil do
begin
  MX[M].Tree:=Ch;
  MX[M].N:=M;
  inc(M);
  Ch:=Ch^.Nb;
end;

Ch:=Pr^.Ch;

//расстановка узлов по убыванию SDeep:
for i:=0 to N-1 do
begin
 Max:=MX[i].Tree^.SDeep; NMax:=i;
 for j:=i+1 to N-1 do
 begin
  if MX[j].Tree^.SDeep > Max then
  begin
   NMax:=j; Max:=MX[j].Tree^.SDeep;
  end;
 end;

 //обмен узлов:
 if NMax <> i then
 begin
  Tr:=MX[i].Tree;
  MX[i].Tree:=MX[NMax].Tree;
  MX[NMax].Tree:=Tr;

  M:=MX[i].N;
  MX[i].N:=MX[NMax].N;
  MX[NMax].N:=M;
 end;
end;

//восстановление ссылок после замены:
MX[N-1].Tree^.Nb:=nil; MX[N-1].Tree^.Pr:=Pr; Pr^.Ch:=MX[0].Tree;
for i:=0 to N-2 do
begin
  MX[i].Tree^.Nb:=MX[i+1].Tree;
end;

Pr^.XchArg:=True;


{
if (Pr^.NFunc = CM_SUB) or (Pr^.NFunc = CM_DIV) then
begin
  if Pr^.Inv = 1 then   Pr^.Inv := 0 else
  if Pr^.Inv = 0 then   Pr^.Inv := 1;
end;
 }

//-(-(1))-(-(-2-(-8)))-((7*x)+((a+9)))

//f1(1)+f2(2)+f3(3)+f4(4)+f5(5)
//x-t/y+t/(x+t)
//((2*x-1)/(3*x-4))/(8/x-9/(2*x*y-1)+1)
{S:=MX[0].Tree^.Expression;
S1:=MX[1].Tree^.Expression;
S2:=MX[2].Tree^.Expression;
S3:=MX[3].Tree^.Expression;}
{$IFDEF DEBUGS}
 //TestG8.Form1.M3.Lines[0]:=S;
 //TestG8.Form1.M4.Lines[0]:=S1;
{$ENDIF}

{
 MX[i].N
 i - текущий номер команды на уровне (после перестановки)
 N - предыдущий  (до перестановки)
}
(*
if Pr^.Code = C_ADD then
begin
 for i:=0 to N-1 do
 begin
  //S1:=MX[i].Tree^.Expression;
  if (i = 0) and (MX[i].N <> 0) then
  begin
   if MX[i].Tree^.I = _ADD then MX[i].Tree^.I:=_NOP;
   if MX[i].Tree^.I = _SUB then
   begin
    MX[i].Tree^.I:=_NOP;
    if MX[i].Tree^.Neg = 1 then MX[i].Tree^.Neg:=0
    else
    MX[i].Tree^.Neg:=1;
   end;
  end;

  if (i > 0) and (MX[i].Tree^.I = _NOP)  then MX[i].Tree^.I:=_ADD;

  if (i > 0) and (MX[i].N = 0) and (MX[i].Tree^.Neg = 1) and (MX[i].Tree^.I = _ADD) then
  begin
   MX[i].Tree^.Neg:=0;
   MX[i].Tree^.I:=_SUB;
  end;

   //ADD-S1+S2; ADD+S1-S2;
   if (i = 0) and (MX[i].Tree^.I = _NOP) then  Pr^.SGN[i]:=_ADD
   else
   if (i > 0) then Pr^.SGN[i]:=MX[i].Tree^.I;

   MX[i].Tree^.NL:=i+1;

 end;
end
else
if Pr^.Code = C_MUL then
begin

 for i:=0 to N-1 do
 begin
  if (i = 0) and (MX[i].N > 0) then
  begin
   if MX[i].Tree^.I = _MUL then MX[i].Tree^.I:=_NOP;
  end;

  if (i > 0) and (MX[i].Tree^.I = _NOP)  then MX[i].Tree^.I:=_MUL;

  if (i > 0)  or  ((i = 0) and (MX[i].Tree^.I <> _NOP)) then
   Pr^.SGN[i]:=MX[i].Tree^.I;

  MX[i].Tree^.NL:=i+1;
 end;

//обработка ситуации (в MUL): если в результате перестановки аргументов первой операцией
//на уровне  становится '/', то отсутствует её делитель =>
//следующей операции на уровне  присваивается: .I:=DIVR (становится её  делителем)
//(в SGN изменения не вносятся!!!)

 if (MX[0].Tree^.I = _DIV) and (MX[0].N > 0) then
 begin
  MX[0].Tree^.I:=_NOP;
  MX[1].Tree^.I:=_DIVR;
 end;

 {
 !!!
   для выражений  типа S1/S2*S3/S4/S5... ->S1*S3/(S2*S4*S5)   обязательно приведение к одному знаменателю
   либо MulDivOptimization либо LeadToDenominator  иначе неверно переставляет

 }

  // sin(x)/cos(y)/sh(x)
 //  sin(x)/cos(y)/sh(x)
 // f2xch(x)/f1xch(x)/f5xch(x)/f3xch(x)/f4xch(x)
 // f1xch(x)/f2xch(x)/f5xch(x)/f3xch(x)/f4xch(x)
 // f5xch(x)/f4xch(x)/f2xch(x)/f3xch(x)/f1xch(x)
 // f5xch(x)/f2xch(x)/f3xch(x)/f4xch(x)/f1xch(x)
 // f1xch(x)/f2xch(x)/f3xch(x)*f4xch(x)/f5xch(x)


end
else
if FuncList[Pr^.Code].FType = 4 then
begin
 Pr^.XCHA:=1;
end
else
begin
  if FuncList[Pr^.Code].NST = -1 then F_OverFlowFunc:=True;
end;
*)

end;




procedure TForevalH.RestoreStack;
label endp;
var
S,SSN: Integer;
SE: String;
begin
if F_SyntaxErrorCode <> 0 then goto endp;
Tree:=BeginTree;   //не обязательно, т.к. чтение дерева - циклически

S:=1;
while Tree^.Ch <> nil do
begin
  Tree:=Tree^.Ch;
  //SE:=Tree^.Expression;
  Tree^.Stack.S:=S;
  Tree^.S:=Tree^.Stack.S-1;
end;

SSN:=Tree^.Stack.S;    {.332}

while Tree^.Pr <> nil do
begin

 while Tree^.Nb <> nil  do
 begin
   S:=Tree^.Stack.S;
   Tree:=Tree^.Nb;
   //SE:=Tree^.Expression;
   Tree^.Stack.S:=S+1;
   Tree^.S:=Tree^.Stack.S-1;
   inc(S);
   while Tree^.Ch <> nil do
   begin
     Tree:=Tree^.Ch;
     //SE:=Tree^.Expression;
     Tree^.Stack.S:=S;
     Tree^.S:=Tree^.Stack.S-1;
   end;

   if Tree^.Stack.S > SSN then SSN:=Tree^.Stack.S;  {.332}

 end;

 Tree:=Tree^.Pr;

 if Tree^.Stack.S > SSN then SSN:=Tree^.Stack.S;       {.332}
end;

if SSN > StackSize  then  StackSize:=SSN;      {.332}

{.332} //SSN пересчёт размера стека после перестановки ветвей дерева.
       //В некоторых случаях он может увеличится (по неизвестной пока причине :))



endp:
end;




//******************************************************************************

//******************************************************************************

procedure TForevalH.ReplaceOptimizator;
label endp;
var
i,j,FType,CODE,t1: Integer;
BH: Boolean;
begin
if F_InternalError <> 0 then goto endp; {.322}

if  F_SyntaxErrorCode  = 0 then
begin
  RFSize:=-1;

  {
  if (F_ReplaceFunctionsCF = True) and (F_ReplaceFunctions = True) then ReplaceFuncComposite
    else
     if F_ReplaceFunctions = True then ReplaceFunc;
  }


  {.347}
    if F_ReplaceFunctions = True then  ReplaceFuncComposite;
    if F_ReplaceOperations = True then ReplaceOperations;
    SetLength(Func.RFStack,RFSize+1);
    if RFSize >= 1 then
    begin
      if F_ReplaceFunctionsCF = True  then DelVoidSaveCF else  DelVoidSave; {.195} {.217}
    end;

  {.345}
  (*
  if F_ReplaceFunctionsCF = True then
  begin
    if F_ReplaceFunctions = True then  ReplaceFuncComposite;
    if F_ReplaceOperations = True then ReplaceOperations;
    SetLength(Func.RFStack,RFSize+1);
    if RFSize >= 1 then
    begin
      if F_ReplaceFunctionsCF = True  then DelVoidSaveCF else  DelVoidSave; {.195} {.217}
    end;
  end
  else    //if F_ReplaceFunctionsCF - off: then return to v.215 (not necessary: must be to work all in v.217)
  begin
    if F_ReplaceFunctions = True then ReplaceFunc;
    if F_ReplaceOperations = True then ReplaceOperations;
    SetLength(Func.RFStack,RFSize+1);
    if RFSize >= 1 then DelVoidSave; {.195}
  end;
  *)

end;

endp:
end;

  
procedure TForevalH.ReplaceFunc;
label 0,1,2,endp;
var
FType1,FType2,Code1,Code2,N1,N2,i,j,k,l,RL,RLB,t1,c1,c2,n,P,ReplF1,ReplF2: Integer;
Sc,Sc1,St1,St2,S: String;
BH: Boolean;
NFunc1,NFunc2,NF1,NF2,ResT1,ResT2: Integer;
Node1,Node2: PNode;
begin

                                  //x=sin(x);x=sin(x);x
//цикл по главной комманде:
//legendrep(i,k,x)+legendrep(i,k,x)
//S:= Interp[LFunc-1].Expression;
Node1:=FirstNode;
while Node1 <> nil do
begin
 //i-главная команда
 //S:= Interp[i].Expression;
 if Node1^.COP <> _FUNC then goto 1;
 if Node1^.RRF = rf_FULL_REPLACE then goto 1;   //если полностью замещена

 NFunc1:=Node1^.NFunc;
 NF1:=Node1^.NF;

 //только для функций:                                                                        {.357}
 if (NFunc1 = CM_DIV) or (NFunc1 = CM_MUL) or (NFunc1 = CM_SUB) or (NFunc1 = CM_ADD) or (NFunc1 = CM_NEG) then goto 1;


 ResT1:=Node1^.TypeF;

 //ReplF1:=Alg.ExFunc[NFunc1].Func[NF1].ReplFunc;
 ReplF1:=Alg.ExFunc[NFunc1].ReplFunc;

 if (ReplF1 = _No)  then goto 1;
 if (ResT1 = T_None)  then goto 1;           {.216}




 Sc:=Node1^.ExpressionArg;
 //цикл по замещаемой комманде:
 Node2:=Node1^.Next;
 while Node2 <> nil do
 begin
    //x=2; y=5; x=sin(x)*cos(y);x=sin(x)*cos(y)-cos(sin(x)); y=cos(y)*sin(x)*cos(y)+sin(x); x=y*sin(y)*cos(x)+cos(x)*sin(y); y=sin(x)/cos(y)+cos(y)/sin(x); x+y
   //для исключения ложной замены при компиляции составных выражений в случаях изменения переменных: x=sin(x);x=sin(x);x
    if (Node2^.NFunc = CM_SAVE) and (F_Enable_All_Replace = False) then goto 1; {.347} // исключение для режима пакетной компиляции:
                                                                                    // f1=r*sin(x)*cos(y); f2=r*sin(x)*sin(y); f3=r*cos(x);
   //if Node2^.NFunc = CM_SAVE  then goto 1;      {.193}                            // pvc#1=r*sin(x)*cos(y); pvc#2=r*sin(x)*sin(y); pvc#3=r*cos(x);

   if (Node2^.NFunc = CM_JMP) then goto 1;  {.195}

   if Node2^.COP <> _FUNC then goto 2;
   if Node2^.RRF = rf_FULL_REPLACE then goto 2;   //если полностью замещена

   NFunc2:=Node2^.NFunc;
   NF2:=Node2^.NF;

   //только для функций:                                                                        {.357}
   if (NFunc2 = CM_DIV) or (NFunc2 = CM_MUL) or (NFunc2 = CM_SUB) or (NFunc2 = CM_ADD) or (NFunc2 = CM_NEG) then goto 2;

   ResT2:=Node2^.TypeF;



   if (NFunc1 <> NFunc2) or (NF1 <> NF2) or (ResT1 <> ResT2)  then goto 2;


   //ReplF2:=Alg.ExFunc[NFunc2].Func[NF2].ReplFunc;
   ReplF2:=Alg.ExFunc[NFunc2].ReplFunc;


   if (ReplF2 = _No)  then goto 2;
   if (ResT2 = T_None)  then goto 2;           {.216}


   //St1:=Interp[i].Expression;
   //St2:=Interp[j].Expression;

   Sc1:=Node2^.ExpressionArg;


   if Sc <> Sc1  then  goto 2;


   FindNonReplFuncPS(@Sc1,BH);  //in Arg       //sin(x+rand(x,y)+x)+sin(x+rand(x,y)+x)
   if BH = True then goto 2;

   InsertFunc(Node1,Node2);  //InsertFunc(i,j);


 2:
  Node2:=Node2^.Next;
 end;

1:
 Node1:=Node1^.Next;
end;

(*
                                  //x=sin(x);x=sin(x);x
//цикл по главной комманде:
//legendrep(i,k,x)+legendrep(i,k,x)
//S:= Interp[LFunc-1].Expression;
for i:=1 to LFunc-1 do
begin
 //i-главная команда
 //S:= Interp[i].Expression;
 if Interp[i].COP <> _FUNC then goto 1;
 if Interp[i].RRF = rf_FULL_REPLACE then goto 1;   //если полностью замещена

 NFunc1:=Interp[i].NFunc;
 NF1:=Interp[i].NF;

 //только для функций:
 if (NFunc1 = CM_DIV) or (NFunc1 = CM_MUL) or (NFunc1 = CM_SUB) or (NFunc1 = CM_ADD) then goto 1;


 ResT1:=Interp[i].TypeF;

 //ReplF1:=Alg.ExFunc[NFunc1].Func[NF1].ReplFunc;
 ReplF1:=Alg.ExFunc[NFunc1].ReplFunc;

 if (ReplF1 = _No)  then goto 1;
 if (ResT1 = T_None)  then goto 1;           {.216}




 Sc:=Interp[i].ExpressionArg;
 //цикл по замещаемой комманде:
 for j:=i+1 to LFunc-1 do
 begin
    //x=2; y=5; x=sin(x)*cos(y);x=sin(x)*cos(y)-cos(sin(x)); y=cos(y)*sin(x)*cos(y)+sin(x); x=y*sin(y)*cos(x)+cos(x)*sin(y); y=sin(x)/cos(y)+cos(y)/sin(x); x+y
   //для исключения ложной замены при компиляции составных выражений в случаях изменения переменных: x=sin(x);x=sin(x);x
   if Interp[j].NFunc = CM_SAVE  then goto 1;      {.193}
   if (Interp[j].NFunc = CM_JMP) then goto 1;  {.195}

   if Interp[j].COP <> _FUNC then goto 2;
   if Interp[j].RRF = rf_FULL_REPLACE then goto 2;   //если полностью замещена

   NFunc2:=Interp[j].NFunc;
   NF2:=Interp[j].NF;

   //только для функций:
   if (NFunc2 = CM_DIV) or (NFunc2 = CM_MUL) or (NFunc2 = CM_SUB) or (NFunc2 = CM_ADD) then goto 2;

   ResT2:=Interp[j].TypeF;



   if (NFunc1 <> NFunc2) or (NF1 <> NF2) or (ResT1 <> ResT2)  then goto 2;


   //ReplF2:=Alg.ExFunc[NFunc2].Func[NF2].ReplFunc;
   ReplF2:=Alg.ExFunc[NFunc2].ReplFunc;


   if (ReplF2 = _No)  then goto 2;
   if (ResT2 = T_None)  then goto 2;           {.216}


   //St1:=Interp[i].Expression;
   //St2:=Interp[j].Expression;

   Sc1:=Interp[j].ExpressionArg;


   if Sc <> Sc1  then  goto 2;


   FindNonReplFunc(Sc1,BH);  //in Arg       //sin(x+rand(x,y)+x)+sin(x+rand(x,y)+x)
   if BH = True then goto 2;

   InsertFunc(i,j);


 2:
 end;

1:
end;
*)


endp:
end;




 //sin(x)-cos(x)+sin(x)+cos(x)
 {.217}
 {.ReplFuncComposite = True/False !!!!!!!!!!!!!!!!!!!! для всех функций}
procedure TForevalH.ReplaceFuncComposite;

      function CompareFunc(Node1,Node2: PNode{N1,N2: Integer}): Boolean;
      label endp;
      var
          NFunc1,NFunc2,NF1,NF2,ResT1,ResT2,NArg1,NArg2,i: Integer;
          Answ: Boolean;
      begin
          {NFunc1:=Interp[N1].NFunc;
          NF1:=Interp[N1].NF;
          NFunc2:=Interp[N2].NFunc;
          NF2:=Interp[N2].NF;
          ResT1:=Interp[N1].TypeF;
          ResT2:=Interp[N2].TypeF;
          }
          NFunc1:=Node1^.NFunc;
          NF1:=Node1^.NF;
          NFunc2:=Node2^.NFunc;
          NF2:=Node2^.NF;
          ResT1:=Node1^.TypeF;
          ResT2:=Node2^.TypeF;

          NArg1:=Length(Alg.ExFunc[NFunc1].Func[NF1].TV);
          NArg2:=Length(Alg.ExFunc[NFunc2].Func[NF2].TV);

          Answ:=True;

          if (F_ReplaceFunctionsCF = True) and (NFunc1 <= High(TableRF)) and (NFunc2 <= High(TableRF)) then      //только составные внутренние
          begin
            //cossin <-> sin,cos,sec,cosec;     {.331}
            if {(ResT1 <> ResT2) or} (NArg1 <> NArg2)  then begin  Answ:=False;  goto endp;  end;

            if ResT2 = T_Real then
               if TableRF[NFunc1,NFunc2].RRF_R = rf_NO_REPLACE then  begin  Answ:=False;  goto endp;  end;

            if ResT2 = T_Complex then
               if TableRF[NFunc1,NFunc2].RRF_Z = rf_NO_REPLACE then  begin  Answ:=False;  goto endp;  end;

             //запрет (composite!) замещения для конкретной ф-ии  соответствующего типа (real/complex):
             if  (ResT1 = T_Complex) and (NFunc1 <> NFunc2) and (Alg.ExFunc[NFunc2].ReplFuncCFZ = _NO) then  begin  Answ:=False;  goto endp;  end;
             if  (ResT1 = T_Real) and (NFunc1 <> NFunc2) and (Alg.ExFunc[NFunc2].ReplFuncCFR = _NO) then  begin  Answ:=False;  goto endp;  end;

             for i := 0 to NArg1 - 1 do
               if Alg.ExFunc[NFunc1].Func[NF1].TV[i] <> Alg.ExFunc[NFunc2].Func[NF2].TV[i] then  begin  Answ:=False;  goto endp;  end;
          end
          else
          begin
              if (NFunc1 <> NFunc2) or (NF1 <> NF2) or (ResT1 <> ResT2)  then Answ:=False;  //только одинаковые функции
          end;

          {.357} //замена массивов vec[expr1] vec[expr2]  ; vd[k+1]+vd[k+1];   vd[k*(n+3)]+vd[k*(n+3)]
          if (NFunc1 = CM_LDSVX) and (NFunc2 = CM_LDSVX) then
          begin
             //Alg.Obj[NObj].MType
             if Node1.NObj <> Node2.NObj then  Answ:=False;
          end;


       endp:
       CompareFunc:=Answ;
      end;


label 0,1,2,endp;
var
FType1,FType2,Code1,Code2,N1,N2,i,j,k,l,RL,RLB,t1,c1,c2,n,P,ReplF1,ReplF2: Integer;
Sc,Sc1,St1,St2,S,Sf1,Sf2: String;
BH: Boolean;
NFunc1,NFunc2,NF1,NF2,ResT1,ResT2: Integer;
Node,Node1,Node2: PNode;
begin


Node1:=FirstNode;


                                  //x=sin(x);x=sin(x);x
//цикл по главной комманде:
//legendrep(i,k,x)+legendrep(i,k,x)
//S:= Interp[LFunc-1].Expression;


while Node1 <> nil do
begin
 //i-главная команда
 Sf1:= Node1^.Expression;
 if Node1^.COP <> _FUNC then goto 1;
 if Node1^.RRF = rf_FULL_REPLACE then goto 1;   //если полностью замещена

 NFunc1:=Node1^.NFunc;
 NF1:=Node1^.NF;

 //только для функций:                                                                        {.357}
 if (NFunc1 = CM_DIV) or (NFunc1 = CM_MUL) or (NFunc1 = CM_SUB) or (NFunc1 = CM_ADD) or (NFunc1 = CM_NEG)  then goto 1;


 ResT1:=Node1^.TypeF;

 //ReplF1:=Alg.ExFunc[NFunc1].Func[NF1].ReplFunc;
 ReplF1:=Alg.ExFunc[NFunc1].ReplFunc;

 if (ReplF1 = _No)  then goto 1;
 if (ResT1 = T_None)  then goto 1;           {.216}




 Sc:=Node1^.ExpressionArg;
 //цикл по замещаемой комманде:
 Node2:=Node1^.Next;
 while Node2 <> nil do
 begin
    Sf2:= Node2^.Expression;
    //x=2; y=5; x=sin(x)*cos(y);x=sin(x)*cos(y)-cos(sin(x)); y=cos(y)*sin(x)*cos(y)+sin(x); x=y*sin(y)*cos(x)+cos(x)*sin(y); y=sin(x)/cos(y)+cos(y)/sin(x); x+y
   //для исключения ложной замены при компиляции составных выражений в случаях изменения переменных: x=sin(x);x=sin(x);x
   if (Node2^.NFunc = CM_SAVE) and (F_Enable_All_Replace = False) then goto 1; {.347} // исключение для режима пакетной компиляции:
                                                                                    // f1=r*sin(x)*cos(y); f2=r*sin(x)*sin(y); f3=r*cos(x);
   //if Node2^.NFunc = CM_SAVE then goto 1;      {.193}
   if (Node2^.NFunc = CM_JMP)  then goto 1;  {.195}

   if Node2^.COP <> _FUNC then goto 2;
   if Node2^.RRF = rf_FULL_REPLACE then goto 2;   //если полностью замещена

   //sh(x)+exp(x)+sh(x)+ch(x)    ;;; sh(x)-> exp(x),sh(x)
   //exp(x)+sh(x)+sh(x)
   //sh(x)+ch(x)+exp(x)


   NFunc2:=Node2^.NFunc;
   NF2:=Node2^.NF;



   //только для функций:                                                                       {.357}
   if (NFunc2 = CM_DIV) or (NFunc2 = CM_MUL) or (NFunc2 = CM_SUB) or (NFunc2 = CM_ADD) or (NFunc2 = CM_NEG)  then goto 2;

   ResT2:=Node2^.TypeF;                   {.320}

   //if (ResT2 = T_None)  then goto 1; {.216} {.320} {вместо goto 2 , если первый сохраняемый аргумент  является аргументом процедуры setlen(vi,len(vi)+1);  len(vi) }
   if (ResT2 = T_None)  then         {.347}   // исключение для режима пакетной компиляции:  CM_SAVE имеет тип  T_None
   begin
       if (NFunc2 = CM_SAVE) and (F_Enable_All_Replace = True) then
       begin
       end
       else   goto 1;
   end;


   ReplF2:=Alg.ExFunc[NFunc2].ReplFunc;
   if (ReplF2 = _No)    then goto 2;



  {
   ResT2:=Interp[j].TypeF;

   if ResT1 <> ResT2   then goto 2;


   if ResT2 = T_Real then
      if TableRF[NFunc1,NFunc2].RRF_R = rf_NO_REPLACE then  goto 2;

   if ResT2 = T_Complex then
      if TableRF[NFunc1,NFunc2].RRF_Z = rf_NO_REPLACE then  goto 2;
      }

   if CompareFunc(Node1,Node2) = False then goto 2;


  // if {(NFunc1 <> NFunc2) or (NF1 <> NF2) or} (ResT1 <> ResT2)  then goto 2;





   //St1:=Interp[i].Expression;
   //St2:=Interp[j].Expression;


   Sc1:=Node2^.ExpressionArg;


   if Sc <> Sc1  then  goto 2;


   FindNonReplFuncPS(@Sc1,BH);  //in Arg       //sin(x+rand(x,y)+x)+sin(x+rand(x,y)+x)
   if BH = True then goto 2;

   //if F_ReplaceFunctionsCF = True then InsertFuncRF(i,j) else   InsertFunc(i,j);  //не обязательно: должно работать только с  InsertFuncRF
   InsertFuncRF(Node1,Node2);//InsertFuncRF(i,j);

 2:
  Node2:=Node2^.Next;
 end;

1:
 Node1:=Node1^.Next;
end;



endp:
end;




(*
 //sin(x)-cos(x)+sin(x)+cos(x)
 {.217}
 {.ReplFuncComposite = True/False !!!!!!!!!!!!!!!!!!!! для всех функций}
procedure TForevalH.ReplaceFuncComposite;

      function CompareFunc(N1,N2: Integer): Boolean;
      label endp;
      var
          NFunc1,NFunc2,NF1,NF2,ResT1,ResT2,NArg1,NArg2,i: Integer;
          Answ: Boolean;
      begin
          NFunc1:=Interp[N1].NFunc;
          NF1:=Interp[N1].NF;
          NFunc2:=Interp[N2].NFunc;
          NF2:=Interp[N2].NF;
          ResT1:=Interp[N1].TypeF;
          ResT2:=Interp[N2].TypeF;
          NArg1:=Length(Alg.ExFunc[NFunc1].Func[NF1].TV);
          NArg2:=Length(Alg.ExFunc[NFunc2].Func[NF2].TV);

          Answ:=True;

          if (F_ReplaceFunctionsCF = True) and (NFunc1 <= High(TableRF)) and (NFunc2 <= High(TableRF)) then      //только составные внутренние
          begin
            //sincos,cossin <-> sin,cos;
            if {(ResT1 <> ResT2) or} (NArg1 <> NArg2)  then begin  Answ:=False;  goto endp;  end;

            if ResT2 = T_Real then
               if TableRF[NFunc1,NFunc2].RRF_R = rf_NO_REPLACE then  begin  Answ:=False;  goto endp;  end;

            if ResT2 = T_Complex then
               if TableRF[NFunc1,NFunc2].RRF_Z = rf_NO_REPLACE then  begin  Answ:=False;  goto endp;  end;

             //запрет (composite!) замещения для конкретной ф-ии  соответствующего типа (real/complex):
             if  (ResT1 = T_Complex) and (NFunc1 <> NFunc2) and (Alg.ExFunc[NFunc2].ReplFuncCFZ = _NO) then  begin  Answ:=False;  goto endp;  end;
             if  (ResT1 = T_Real) and (NFunc1 <> NFunc2) and (Alg.ExFunc[NFunc2].ReplFuncCFR = _NO) then  begin  Answ:=False;  goto endp;  end;

             for i := 0 to NArg1 - 1 do
               if Alg.ExFunc[NFunc1].Func[NF1].TV[i] <> Alg.ExFunc[NFunc2].Func[NF2].TV[i] then  begin  Answ:=False;  goto endp;  end;
          end
          else
          begin
              if (NFunc1 <> NFunc2) or (NF1 <> NF2) or (ResT1 <> ResT2)  then Answ:=False;  //только одинаковые функции
          end;

       endp:
       CompareFunc:=Answ;
      end;


label 0,1,2,endp;
var
FType1,FType2,Code1,Code2,N1,N2,i,j,k,l,RL,RLB,t1,c1,c2,n,P,ReplF1,ReplF2: Integer;
Sc,Sc1,St1,St2,S,Sf1,Sf2: String;
BH: Boolean;
NFunc1,NFunc2,NF1,NF2,ResT1,ResT2: Integer;
begin

                                  //x=sin(x);x=sin(x);x
//цикл по главной комманде:
//legendrep(i,k,x)+legendrep(i,k,x)
//S:= Interp[LFunc-1].Expression;
for i:=1 to LFunc-1 do
begin
 //i-главная команда
 Sf1:= Interp[i].Expression;
 if Interp[i].COP <> _FUNC then goto 1;
 if Interp[i].RRF = rf_FULL_REPLACE then goto 1;   //если полностью замещена

 NFunc1:=Interp[i].NFunc;
 NF1:=Interp[i].NF;

 //только для функций:
 if (NFunc1 = CM_DIV) or (NFunc1 = CM_MUL) or (NFunc1 = CM_SUB) or (NFunc1 = CM_ADD) then goto 1;


 ResT1:=Interp[i].TypeF;

 //ReplF1:=Alg.ExFunc[NFunc1].Func[NF1].ReplFunc;
 ReplF1:=Alg.ExFunc[NFunc1].ReplFunc;

 if (ReplF1 = _No)  then goto 1;
 if (ResT1 = T_None)  then goto 1;           {.216}




 Sc:=Interp[i].ExpressionArg;
 //цикл по замещаемой комманде:
 for j:=i+1 to LFunc-1 do
 begin
    Sf2:= Interp[j].Expression;
    //x=2; y=5; x=sin(x)*cos(y);x=sin(x)*cos(y)-cos(sin(x)); y=cos(y)*sin(x)*cos(y)+sin(x); x=y*sin(y)*cos(x)+cos(x)*sin(y); y=sin(x)/cos(y)+cos(y)/sin(x); x+y
   //для исключения ложной замены при компиляции составных выражений в случаях изменения переменных: x=sin(x);x=sin(x);x
   if Interp[j].NFunc = CM_SAVE then goto 1;      {.193}
   if (Interp[j].NFunc = CM_JMP)  then goto 1;  {.195}

   if Interp[j].COP <> _FUNC then goto 2;
   if Interp[j].RRF = rf_FULL_REPLACE then goto 2;   //если полностью замещена

   //sh(x)+exp(x)+sh(x)+ch(x)    ;;; sh(x)-> exp(x),sh(x)
   //exp(x)+sh(x)+sh(x)
   //sh(x)+ch(x)+exp(x)


   NFunc2:=Interp[j].NFunc;
   NF2:=Interp[j].NF;



   //только для функций:
   if (NFunc2 = CM_DIV) or (NFunc2 = CM_MUL) or (NFunc2 = CM_SUB) or (NFunc2 = CM_ADD) then goto 2;

   ReplF2:=Alg.ExFunc[NFunc2].ReplFunc;

   if (ReplF2 = _No)  then goto 2;
   if (ResT2 = T_None)  then goto 2;           {.216}



  {
   ResT2:=Interp[j].TypeF;

   if ResT1 <> ResT2   then goto 2;


   if ResT2 = T_Real then
      if TableRF[NFunc1,NFunc2].RRF_R = rf_NO_REPLACE then  goto 2;

   if ResT2 = T_Complex then
      if TableRF[NFunc1,NFunc2].RRF_Z = rf_NO_REPLACE then  goto 2;
      }

   if CompareFunc(i,j) = False then goto 2;


  // if {(NFunc1 <> NFunc2) or (NF1 <> NF2) or} (ResT1 <> ResT2)  then goto 2;





   //St1:=Interp[i].Expression;
   //St2:=Interp[j].Expression;


   Sc1:=Interp[j].ExpressionArg;


   if Sc <> Sc1  then  goto 2;


   FindNonReplFunc(Sc1,BH);  //in Arg       //sin(x+rand(x,y)+x)+sin(x+rand(x,y)+x)
   if BH = True then goto 2;

   //if F_ReplaceFunctionsCF = True then InsertFuncRF(i,j) else   InsertFunc(i,j);  //не обязательно: должно работать только с  InsertFuncRF
   InsertFuncRF(i,j);

 2:
 end;

1:
end;



endp:
end;
*)




(*
procedure TForevalH.ReplaceOperations;
label 0,1,2,endp;
var
FType1,FType2,Code1,Code2,N1,N2,i,j,k,l,RL,RLB,t1,c1,c2,n,P,ReplF1,ReplF2: Integer;
Sc,Sc1,St1,St2,S: String;
BH: Boolean;
NFunc1,NFunc2,NF1,NF2,ResT1,ResT2: Integer;
begin

                                  //x=sin(x);x=sin(x);x
//цикл по главной комманде:
//legendrep(i,k,x)+legendrep(i,k,x)
S:= Interp[LFunc-1].Expression;
for i:=1 to LFunc-1 do
begin
 //i-главная команда
 //S:= Interp[i].Expression;
 if Interp[i].COP <> _FUNC then goto 1;
 if Interp[i].RRF = rf_FULL_REPLACE then goto 1;   //если полностью замещена

 NFunc1:=Interp[i].NFunc;
 NF1:=Interp[i].NF;

 //только для операций:
 if (NFunc1 <> CM_DIV) and (NFunc1 <> CM_MUL) and (NFunc1 <> CM_SUB) and (NFunc1 <> CM_ADD) then goto 1;


 ResT1:=Interp[i].TypeF;

 //ReplF1:=Alg.ExFunc[NFunc1].Func[NF1].ReplFunc;
 ReplF1:=Alg.ExFunc[NFunc1].ReplFunc;

 if (ReplF1 = _No)  then goto 1;




 Sc:=Interp[i].ExpressionArg;
 //цикл по замещаемой комманде:
 for j:=i+1 to LFunc-1 do
 begin
  //z1=2-i; z2=5-2i; z1=(z1/z2+z2/z1)/(z1/z2-z2/z1); z2=(z2/z1)*(z1/z2-z2/z1); z2=z1*z2/(z1/z2-z2/z1)+z1/(z1*z2/(z1/z2-z2/z1)); z1=(z1/z2-z2/z1)/(z2/z1+z1/z2)+z1*z2/(z1/z2-z2/z1); z1+z2
  //x=2; y=5; x=(x/y+y/x)/(x/y-y/x); y=(y/x)*(x/y-y/x); y=x*y/(x/y-y/x)+x/(x*y/(x/y-y/x)); x=(x/y-y/x)/(y/x+x/y)+x*y/(x/y-y/x); x+y

   //для исключения ложной замены при компиляции составных выражений в случаях изменения переменных: x=x/y; x=x/y; x
   if Interp[j].NFunc = CM_SAVE then goto 1;      {.193}
   if (Interp[j].NFunc = CM_JMP)  then goto 1;  {.195}

   if Interp[j].COP <> _FUNC then goto 2;
   if Interp[j].RRF = rf_FULL_REPLACE then goto 2;   //если полностью замещена

   NFunc2:=Interp[j].NFunc;
   NF2:=Interp[j].NF;
   ResT2:=Interp[j].TypeF;



   //только для операций:
   if (NFunc2 <> CM_DIV) and (NFunc2 <> CM_MUL) and (NFunc2 <> CM_SUB) and (NFunc2 <> CM_ADD) then goto 2;


   if (NFunc1 <> NFunc2) or (NF1 <> NF2) or (ResT1 <> ResT2)  then goto 2;


   //ReplF2:=Alg.ExFunc[NFunc2].Func[NF2].ReplFunc;
   ReplF2:=Alg.ExFunc[NFunc2].ReplFunc;


   if (ReplF2 = _No)  then goto 2;


   //St1:=Interp[i].Expression;
   //St2:=Interp[j].Expression;

   Sc1:=Interp[j].ExpressionArg;


   if Sc <> Sc1  then  goto 2;


   FindNonReplFunc(Sc1,BH);  //in Arg       //sin(x+rand(x,y)+x)+sin(x+rand(x,y)+x)
   if BH = True then goto 2;

   InsertFunc(i,j);


 2:
 end;

1:
end;



endp:
end;
*)


procedure TForevalH.CompareAndReplace(Node1,Node2: PNode);
label endp;
var
NFunc1,NFunc2,NF1,NF2,ResT1,ResT2: Integer;
S1,S2: String;
BH: Boolean;
begin

  NFunc1:=Node1^.NFunc;
  NF1:=Node1^.NF;
  ResT1:=Node1^.TypeF;
  S1:=Node1^.ExpressionArg;

  NFunc2:=Node2^.NFunc;
  NF2:=Node2^.NF;
  ResT2:=Node2^.TypeF;
  S2:=Node2^.ExpressionArg;


  if (NFunc1 <> NFunc2) or (NF1 <> NF2) or (ResT1 <> ResT2)  then goto endp;
  if S1 <> S2  then  goto endp;

  FindNonReplFuncPS(@S1,BH);  //in Arg       //sin(x+rand(x,y)+x)+sin(x+rand(x,y)+x)
  if BH = True then goto endp;

  InsertFunc(Node1,Node2);

  endp:
end;



Function TForevalH.GotoNextNodeROP(Node: PNode):Boolean;
label endp;
var
 Answ: Boolean;
 NFunc,NF,ReplF: Integer;

begin

  Answ:=False;


  if Node^.COP <> _FUNC          then       goto endp;
  if Node^.RRF = rf_FULL_REPLACE then     goto endp;     //если полностью замещена

  NFunc:=Node^.NFunc;
  NF:=Node^.NF;

  if (NFunc <> CM_DIV) and (NFunc <> CM_MUL) and (NFunc <> CM_SUB) and (NFunc <> CM_ADD) then goto endp;    //только для операций:


   ReplF:=Alg.ExFunc[NFunc].ReplFunc;
   if (ReplF = _No)  then goto endp;    //не подлежит оптимизации замещения

   //ResT1:=Node^.TypeF;


  Answ:=True;

endp:
end;



procedure TForevalH.FindNodeForReplaceROP(Node1: PNode);
var
Node2: PNode;
begin

   Node2:=GetNextNode(Node1);

   if  GotoNextNodeROP(Node2) = False then
   begin
     CompareAndReplace(Node1,Node2);
   end;

   while Node2^.Pr <> nil do
   begin

      Node2:=GetNextNode(Node2);
      if  GotoNextNodeROP(Node2) = False then
      begin
        CompareAndReplace(Node1,Node2);
      end;

   end;
end;



procedure TForevalH.ReplaceOperations;
label 0,1,2,endp;
var
FType1,FType2,Code1,Code2,N1,N2,i,j,k,l,RL,RLB,t1,c1,c2,n,P,ReplF1,ReplF2: Integer;
Sc,Sc1,St1,St2,S: String;
BH: Boolean;
NFunc1,NFunc2,NF1,NF2,ResT1,ResT2: Integer;
Node1,Node2: PNode;
begin
(*
   Node1:=BeginTree;
   Node1:=GetLowLevelNode(Node1);

   if  GotoNextNodeROP(Node1) = False then
   begin
      FindNodeForReplaceROP(Node1);
   end;

   while Node1^.Pr <> nil do
   begin

      Node1:=GetNextNode(Node1);
      if  GotoNextNodeROP(Node1) = False then
      begin
        FindNodeForReplaceROP(Node1);
      end;

   end;

  *)

(*

                                  //x=sin(x);x=sin(x);x
//цикл по главной комманде:
//legendrep(i,k,x)+legendrep(i,k,x)
S:= Interp[LFunc-1].Expression;
for i:=1 to LFunc-1 do
begin
 //i-главная команда
 //S:= Interp[i].Expression;
 if Interp[i].COP <> _FUNC then goto 1;
 if Interp[i].RRF = rf_FULL_REPLACE then goto 1;   //если полностью замещена

 NFunc1:=Interp[i].NFunc;
 NF1:=Interp[i].NF;

 //только для операций:
 if (NFunc1 <> CM_DIV) and (NFunc1 <> CM_MUL) and (NFunc1 <> CM_SUB) and (NFunc1 <> CM_ADD) then goto 1;


 ResT1:=Interp[i].TypeF;

 //ReplF1:=Alg.ExFunc[NFunc1].Func[NF1].ReplFunc;
 ReplF1:=Alg.ExFunc[NFunc1].ReplFunc;

 if (ReplF1 = _No)  then goto 1;




 Sc:=Interp[i].ExpressionArg;
 //цикл по замещаемой комманде:
 for j:=i+1 to LFunc-1 do
 begin
  //z1=2-i; z2=5-2i; z1=(z1/z2+z2/z1)/(z1/z2-z2/z1); z2=(z2/z1)*(z1/z2-z2/z1); z2=z1*z2/(z1/z2-z2/z1)+z1/(z1*z2/(z1/z2-z2/z1)); z1=(z1/z2-z2/z1)/(z2/z1+z1/z2)+z1*z2/(z1/z2-z2/z1); z1+z2
  //x=2; y=5; x=(x/y+y/x)/(x/y-y/x); y=(y/x)*(x/y-y/x); y=x*y/(x/y-y/x)+x/(x*y/(x/y-y/x)); x=(x/y-y/x)/(y/x+x/y)+x*y/(x/y-y/x); x+y

   //для исключения ложной замены при компиляции составных выражений в случаях изменения переменных: x=x/y; x=x/y; x
   if Interp[j].NFunc = CM_SAVE then goto 1;      {.193}
   if (Interp[j].NFunc = CM_JMP)  then goto 1;  {.195}

   if Interp[j].COP <> _FUNC then goto 2;
   if Interp[j].RRF = rf_FULL_REPLACE then goto 2;   //если полностью замещена

   NFunc2:=Interp[j].NFunc;
   NF2:=Interp[j].NF;
   ResT2:=Interp[j].TypeF;



   //только для операций:
   if (NFunc2 <> CM_DIV) and (NFunc2 <> CM_MUL) and (NFunc2 <> CM_SUB) and (NFunc2 <> CM_ADD) then goto 2;


   if (NFunc1 <> NFunc2) or (NF1 <> NF2) or (ResT1 <> ResT2)  then goto 2;


   //ReplF2:=Alg.ExFunc[NFunc2].Func[NF2].ReplFunc;
   ReplF2:=Alg.ExFunc[NFunc2].ReplFunc;


   if (ReplF2 = _No)  then goto 2;


   //St1:=Interp[i].Expression;
   //St2:=Interp[j].Expression;

   Sc1:=Interp[j].ExpressionArg;


   if Sc <> Sc1  then  goto 2;


   FindNonReplFunc(Sc1,BH);  //in Arg       //sin(x+rand(x,y)+x)+sin(x+rand(x,y)+x)
   if BH = True then goto 2;

   InsertFunc(i,j);


 2:
 end;

1:
end;


*)



                                  //x=sin(x);x=sin(x);x
//цикл по главной комманде:
//legendrep(i,k,x)+legendrep(i,k,x)
//S:= Interp[LFunc-1].Expression;

Node1:=FirstNode;

while Node1 <> nil do
begin
 //i-главная команда
 //S:= Interp[i].Expression;
 if Node1^.COP <> _FUNC then goto 1;
 if Node1^.RRF = rf_FULL_REPLACE then goto 1;   //если полностью замещена

 NFunc1:=Node1^.NFunc;
 NF1:=Node1^.NF;

 //только для операций:                                                                                 {.357}
 if (NFunc1 <> CM_DIV) and (NFunc1 <> CM_MUL) and (NFunc1 <> CM_SUB) and (NFunc1 <> CM_ADD) and (NFunc1 <> CM_NEG) then goto 1;


 ResT1:=Node1^.TypeF;

 //ReplF1:=Alg.ExFunc[NFunc1].Func[NF1].ReplFunc;
 ReplF1:=Alg.ExFunc[NFunc1].ReplFunc;

 if (ReplF1 = _No)  then goto 1;




 Sc:=Node1^.ExpressionArg;
 //цикл по замещаемой комманде:
 Node2:=Node1^.Next;
 while Node2 <> nil do
 begin
  //z1=2-i; z2=5-2i; z1=(z1/z2+z2/z1)/(z1/z2-z2/z1); z2=(z2/z1)*(z1/z2-z2/z1); z2=z1*z2/(z1/z2-z2/z1)+z1/(z1*z2/(z1/z2-z2/z1)); z1=(z1/z2-z2/z1)/(z2/z1+z1/z2)+z1*z2/(z1/z2-z2/z1); z1+z2
  //x=2; y=5; x=(x/y+y/x)/(x/y-y/x); y=(y/x)*(x/y-y/x); y=x*y/(x/y-y/x)+x/(x*y/(x/y-y/x)); x=(x/y-y/x)/(y/x+x/y)+x*y/(x/y-y/x); x+y

   {.360}
   NFunc2:=Node2^.NFunc;
   NF2:=Node2^.NF;
   ResT2:=Node2^.TypeF;

   {.360}
   //для исключения ложной замены при компиляции составных выражений в случаях изменения переменных: x=x/y; x=x/y; x
   //if Node2^.NFunc = CM_SAVE then goto 1;      {.193}
   if (NFunc2 = CM_SAVE) and (F_Enable_All_Replace = False) then goto 1; {.347} // исключение для режима пакетной компиляции:
                                                                                    // f1=5*x^3*y^3+2*x^5*y^5-3*x^7*y^7; f2=(x^3+y^3)*(5*x^5-7*y^7+y^4*x^4); f3=x^7*y^5-x^4*y^7+x^5*y^3;

   if (ResT2 = T_None)  then         {.359}   // исключение для режима пакетной компиляции:  CM_SAVE имеет тип  T_None
   begin
       if (NFunc2 = CM_SAVE) and (F_Enable_All_Replace = True) then
       begin
       end
       else   goto 1;
   end;

   if (NFunc2 = CM_JMP)  then goto 1;  {.195} {.360}


   if Node2^.COP <> _FUNC then goto 2;
   if Node2^.RRF = rf_FULL_REPLACE then goto 2;   //если полностью замещена
   {
   NFunc2:=Node2^.NFunc;
   NF2:=Node2^.NF;
   ResT2:=Node2^.TypeF;
   }


   //только для операций:                                                                                {.357}
   if (NFunc2 <> CM_DIV) and (NFunc2 <> CM_MUL) and (NFunc2 <> CM_SUB) and (NFunc2 <> CM_ADD) and (NFunc2 <> CM_NEG)then goto 2;


   if (NFunc1 <> NFunc2) or (NF1 <> NF2) or (ResT1 <> ResT2)  then goto 2;


   //ReplF2:=Alg.ExFunc[NFunc2].Func[NF2].ReplFunc;
   ReplF2:=Alg.ExFunc[NFunc2].ReplFunc;


   if (ReplF2 = _No)  then goto 2;




   //St1:=Interp[i].Expression;
   //St2:=Interp[j].Expression;

   Sc1:=Node2^.ExpressionArg;


   if Sc <> Sc1  then  goto 2;


   FindNonReplFuncPS(@Sc1,BH);  //in Arg       //sin(x+rand(x,y)+x)+sin(x+rand(x,y)+x)
   if BH = True then goto 2;

   InsertFunc(Node1,Node2);//InsertFunc(i,j);


 2:
  Node2:=Node2^.Next;
 end;

1:
 Node1:=Node1^.Next;
end;




endp:
end;




 (*
procedure TForevalH.InsertFunc(NF,NS: Integer);
label 1,endp;
var
i,s,St: Integer;
L,FN: Integer;
NFunc: Cardinal;
begin
//NF -> NS
NFunc:=Interp[NF].NFunc;


if Interp[NF].NRF = 0 then
begin
 if Interp[NF].TypeF = T_Real then
 begin
   RFSize:=RFSize+1;
 end
 else
 if Interp[NF].TypeF = T_Complex then
 begin
   RFSize:=RFSize+2;
 end
end;

Interp[NF].NRF:=Interp[NF].NRF+1;

Interp[NF].WRF:=rf_FULL_REPLACE;
Interp[NS].RRF:=rf_FULL_REPLACE;
Interp[NS].MRF:=RFSize;
Interp[NF].MRF:=RFSize;




//все вытекающие аргументы замещаемой функции=CM_NOP
1:
S:=Interp[NS].S;
FN:=GetFirstNode(NS);  //первый аргумент дерева(замещаемой функции) =  (нижний левый Interp.[FN]); (верхний узел Interp.[NS] - замещаемая функция)
for i:=FN to NS-1 do
begin
  Interp[i].N:=0;
  Interp[i].NFunc:=CM_NOP;
  Interp[i].NF:=0;{.197}
  Interp[i].TypeF:=0;
  Interp[i].COP:=_NOP;   //только для аргументов замещаемой комманды
  Interp[i].RRF:=rf_NO_REPLACE;//???????
  //FuncList[Interp[i].Code].FType:=0;
end;



endp:
 if (NFunc = CM_DIV) or (NFunc = CM_MUL) or (NFunc = CM_SUB) or (NFunc = CM_ADD) then inc(Db_ReplOpNum)
 else inc(Db_ReplFuncNum);
end;
*)


procedure TForevalH.InsertFunc(NodeF,NodeS: PNode);
label 1,endp;
var
i,s,St: Integer;
L,FN: Integer;
NFunc: Cardinal;
NodeS1: PNode;
begin
//NF -> NS
NFunc:=NodeF^.NFunc;


if NodeF^.NRF = 0 then
begin
 if NodeF^.TypeF = T_Real then
 begin
   RFSize:=RFSize+1;
 end
 else
 if NodeF^.TypeF = T_Complex then
 begin
   RFSize:=RFSize+2;
 end
end;

NodeF^.NRF:=NodeF^.NRF+1;

NodeF^.WRF:=rf_FULL_REPLACE;
NodeS^.RRF:=rf_FULL_REPLACE;
NodeS^.MRF:=RFSize;
NodeF^.MRF:=RFSize;




1:
//удалить все вытекающие аргументы замещаемой функции

FreeReplacedNodes(NodeS);



//x*y*t*(t*x*(x*y-t*x)-x*y*(x*t-y*t)-(x+y)*(t-y)*(x*y-t*x*(x-y*(t-x*(x-t)*(t-y)))))
//x*y*t*(t*x*(x*y-t*x)-x*y*(x*t-y*t)-(t-y)*(x*y-t*x*(x-y*(t-x*(t-y)))))
//x*y*t*(t*x-x*y*(x*t-y*t)-(t-y)*(x*y-t*x*(x-y*(t-x*(t-y)))))
//x*y*t*(t*x-x*y-(t-y)*(x*y-t*x*(x-y*(t-x*(t-y)))))

(*
NodeS1:=GetLowLevelNode(NodeS);
while NodeS1 <> NodeS do
begin
  NodeS1^.N:=0;
  NodeS1^.NFunc:=CM_NOP;
  NodeS1^.NF:=0;{.197}
  NodeS1^.TypeF:=0;
  NodeS1^.COP:=_NOP;   //только для аргументов замещаемой комманды
  NodeS1^.RRF:=rf_NO_REPLACE;//???????
  //FuncList[Interp[i].Code].FType:=0;
  NodeS1:=NodeS1^.Next;
end;
*)



(*
//все вытекающие аргументы замещаемой функции=CM_NOP
S:=Interp[NS].S;
FN:=GetFirstNode(NS);  //первый аргумент дерева(замещаемой функции) =  (нижний левый Interp.[FN]); (верхний узел Interp.[NS] - замещаемая функция)
for i:=FN to NS-1 do
begin
  Interp[i].N:=0;
  Interp[i].NFunc:=CM_NOP;
  Interp[i].NF:=0;{.197}
  Interp[i].TypeF:=0;
  Interp[i].COP:=_NOP;   //только для аргументов замещаемой комманды
  Interp[i].RRF:=rf_NO_REPLACE;//???????
  //FuncList[Interp[i].Code].FType:=0;
end;
*)



endp:
 if (NFunc = CM_DIV) or (NFunc = CM_MUL) or (NFunc = CM_SUB) or (NFunc = CM_ADD) or (NFunc = CM_NEG) then inc(Db_ReplOpNum)
 else inc(Db_ReplFuncNum);
end;




//sin(x)-cos(x)+sin(x)+cos(x)
procedure TForevalH.InsertFuncRF(NodeF,NodeS: PNode{NF,NS: Integer});
label 1,endp,fin;
var
i,s,St: Integer;
L,FN: Integer;
NFuncNF,NFuncNS,RangRRF,NFF,NFS,CRFMem: Cardinal;
RangW,RangR,NMem,MShft:integer;
B_RF:Boolean;
NodeS1: PNode;
begin
(*
//NF -> NS
if Interp[NS].RRF = rf_FULL_REPLACE  then goto endp;   // (NS) уже полностью замещена



B_RF:=False;
NFuncNF:=Interp[NF].NFunc;
NFuncNS:=Interp[NS].NFunc;
NFF:=Interp[NF].NF;
NFS:=Interp[NS].NF;



   GetReplaceData(NF,NS,Interp[NF].TypeF,RangW,RangR,NMem,MShft);

   if RangW = rf_FULL_REPLACE  then   //сохраняется вся ф-ия (NF)
   begin
     inc(Interp[NF].NRF);  //для совместимости (выше^)
     if (Interp[NF].WRF = rf_FULL_REPLACE)  then        //уже было сохранение всей ф-ии (NF)
     begin

         if RangR > Interp[NS].RRF then        //ранг замещаемой ф-ии выше предыдущего замещения , то выполнить  замещение
         begin
           //если замещается вся ф-ия (NS), то ячейка памяти - MRF
           //если частичное замещение (NS) - то  , то ячейка памяти - MRF_CS
           if RangR = rf_FULL_REPLACE  then
           begin
              Interp[NS].MRF:=Interp[NF].MRF-MShft;
              Interp[NS].RRF:=rf_FULL_REPLACE;
           end
           else
           begin
             Interp[NS].MRF_CS:=Interp[NF].MRF-MShft;
             Interp[NS].RRF:=RangR;
           end;
           B_RF:=True;
         end;
     end
     else                                        //нет-выделить память
     begin
        if RangR > Interp[NS].RRF then        //если ранг замещаемой ф-ии выше предыдущего замещения, то выполнить  замещение
       begin
          RFSize:=RFSize+NMem;  //кол-во сохраняемых чисел
          Interp[NF].WRF:=rf_FULL_REPLACE;   //если сохраняется вся функция, то ячейка памяти - MRF
          Interp[NF].MRF:=RFSize;

           //если замещается вся ф-ия (NS), то ячейка памяти - MRF
           //если частичное замещение (NS) - то  , то ячейка памяти - MRF_CS
           if RangR = rf_FULL_REPLACE  then
           begin
            Interp[NS].MRF:=Interp[NF].MRF-MShft;
            Interp[NS].RRF:=rf_FULL_REPLACE;
           end
           else
           begin
            Interp[NS].MRF_CS:=Interp[NF].MRF-MShft;
            Interp[NS].RRF:=RangR;
           end;

           B_RF:=True;
       end;
     end;

   end
   else    //сохраняется часть ф-ии (NF): ячейка памяти - MWF_CS
   begin
      if Interp[NF].WRF_CS = RangW then        //уже было сохранение этой части ф-ии  (NF)
      begin
          if RangR > Interp[NS].RRF then        //ранг замещаемой ф-ии выше предыдущего замещения , то выполнить  замещение
          begin
            //если замещается вся ф-ия (NS), то ячейка памяти - MRF
            //если частичное замещение (NS) - то  , то ячейка памяти - MRF_CS
            if RangR = rf_FULL_REPLACE  then
            begin
              Interp[NS].MRF:=Interp[NF].MWF_CS-MShft;
              Interp[NS].RRF:=rf_FULL_REPLACE;
            end
            else
            begin
              Interp[NS].MRF_CS:=Interp[NF].MWF_CS-MShft;
              Interp[NS].RRF:=RangR;
            end;

            B_RF:=True;
          end;
      end
      else             //нет-выделить память
      begin

           if RangR > Interp[NS].RRF then        //ранг замещаемой ф-ии выше предыдущего замещения , то выполнить  замещение
          begin
            RFSize:=RFSize+NMem;      //кол-во сохраняемых чисел
            Interp[NF].WRF_CS:=RangW;   //часть сохраняемой   функции (NF)
            Interp[NF].MWF_CS:=RFSize;

            //если замещается вся ф-ия (NS), то ячейка памяти - MRF
            //если частичное замещение (NS) - то  , то ячейка памяти - MRF_CS
            if RangR = rf_FULL_REPLACE  then
             begin
               Interp[NS].MRF:=Interp[NF].MWF_CS-MShft;
               Interp[NS].RRF:=rf_FULL_REPLACE;
             end
             else
             begin
               Interp[NS].MRF_CS:=Interp[NF].MWF_CS-MShft;
               Interp[NS].RRF:=RangR;
             end;

            B_RF:=True;
          end;
      end;
   end;





fin:
//все вытекающие аргументы замещаемой функции=CM_NOP
if B_RF = True  then
begin
  S:=Interp[NS].S;
  FN:=GetFirstNode(NS);  //первый аргумент дерева(замещаемой функции) =  (нижний левый Interp.[FN]); (верхний узел Interp.[NS] - замещаемая функция)
  for i:=FN to NS-1 do
  begin
    Interp[i].N:=0;
    Interp[i].NFunc:=CM_NOP;
    Interp[i].NF:=0;{.197}
    Interp[i].TypeF:=0;
    Interp[i].COP:=_NOP;   //только для аргументов замещаемой комманды
    Interp[i].RRF:=rf_NO_REPLACE;//???????
    //FuncList[Interp[i].Code].FType:=0;
  end;
  inc(Db_ReplFuncNum);
end;

{
 if (NFuncNF = CM_DIV) or (NFuncNF = CM_MUL) or (NFuncNF = CM_SUB) or (NFuncNF = CM_ADD) then inc(Db_ReplOpNum)
 else inc(Db_ReplFuncNum);  }
 *)



//NF -> NS
if {Interp[NS]}NodeS^.RRF = rf_FULL_REPLACE  then goto endp;   // (NS) уже полностью замещена



B_RF:=False;
NFuncNF:={Interp[NF]}NodeF^.NFunc;
NFuncNS:={Interp[NS]}NodeS^.NFunc;
NFF:={Interp[NF]}NodeF^.NF;
NFS:={Interp[NS]}NodeS^.NF;



   GetReplaceData({NF,NS,}NodeF,NodeS,NodeF^.TypeF,RangW,RangR,NMem,MShft);

   if RangW = rf_FULL_REPLACE  then   //сохраняется вся ф-ия (NF)
   begin
     inc(NodeF^.NRF);  //для совместимости (выше^)
     if (NodeF^.WRF = rf_FULL_REPLACE)  then        //уже было сохранение всей ф-ии (NF)
     begin

         if RangR > NodeS^.RRF then        //ранг замещаемой ф-ии выше предыдущего замещения , то выполнить  замещение
         begin
           //если замещается вся ф-ия (NS), то ячейка памяти - MRF
           //если частичное замещение (NS) - то  , то ячейка памяти - MRF_CS
           if RangR = rf_FULL_REPLACE  then
           begin
              NodeS^.MRF:=NodeF^.MRF-MShft;
              NodeS^.RRF:=rf_FULL_REPLACE;
           end
           else
           begin
             NodeS^.MRF_CS:=NodeF^.MRF-MShft;
             NodeS^.RRF:=RangR;
           end;
           B_RF:=True;
         end;
     end
     else                                        //нет-выделить память
     begin
        if RangR > NodeS^.RRF then        //если ранг замещаемой ф-ии выше предыдущего замещения, то выполнить  замещение
       begin
          RFSize:=RFSize+NMem;  //кол-во сохраняемых чисел
          NodeF^.WRF:=rf_FULL_REPLACE;   //если сохраняется вся функция, то ячейка памяти - MRF
          NodeF^.MRF:=RFSize;

           //если замещается вся ф-ия (NS), то ячейка памяти - MRF
           //если частичное замещение (NS) - то  , то ячейка памяти - MRF_CS
           if RangR = rf_FULL_REPLACE  then
           begin
            NodeS^.MRF:=NodeF^.MRF-MShft;
            NodeS^.RRF:=rf_FULL_REPLACE;
           end
           else
           begin
            NodeS^.MRF_CS:=NodeF^.MRF-MShft;
            NodeS^.RRF:=RangR;
           end;

           B_RF:=True;
       end;
     end;

   end
   else    //сохраняется часть ф-ии (NF): ячейка памяти - MWF_CS
   begin
      if NodeF^.WRF_CS = RangW then        //уже было сохранение этой части ф-ии  (NF)
      begin
          if RangR > NodeS^.RRF then        //ранг замещаемой ф-ии выше предыдущего замещения , то выполнить  замещение
          begin
            //если замещается вся ф-ия (NS), то ячейка памяти - MRF
            //если частичное замещение (NS) - то  , то ячейка памяти - MRF_CS
            if RangR = rf_FULL_REPLACE  then
            begin
              NodeS^.MRF:=NodeF^.MWF_CS-MShft;
              NodeS^.RRF:=rf_FULL_REPLACE;
            end
            else
            begin
              NodeS^.MRF_CS:=NodeF^.MWF_CS-MShft;
              NodeS^.RRF:=RangR;
            end;

            B_RF:=True;
          end;
      end
      else             //нет-выделить память
      begin

           if RangR > NodeS^.RRF then        //ранг замещаемой ф-ии выше предыдущего замещения , то выполнить  замещение
          begin
            RFSize:=RFSize+NMem;      //кол-во сохраняемых чисел
            NodeF^.WRF_CS:=RangW;   //часть сохраняемой   функции (NF)
            NodeF^.MWF_CS:=RFSize;

            //если замещается вся ф-ия (NS), то ячейка памяти - MRF
            //если частичное замещение (NS) - то  , то ячейка памяти - MRF_CS
            if RangR = rf_FULL_REPLACE  then
             begin
               NodeS^.MRF:=NodeF^.MWF_CS-MShft;
               NodeS^.RRF:=rf_FULL_REPLACE;
             end
             else
             begin
               NodeS^.MRF_CS:=NodeF^.MWF_CS-MShft;
               NodeS^.RRF:=RangR;
             end;

            B_RF:=True;
          end;
      end;
   end;






(*
fin:
//все вытекающие аргументы замещаемой функции=CM_NOP
if B_RF = True  then
begin
  S:=Interp[NS].S;
  FN:=GetFirstNode(NS);  //первый аргумент дерева(замещаемой функции) =  (нижний левый Interp.[FN]); (верхний узел Interp.[NS] - замещаемая функция)
  for i:=FN to NS-1 do
  begin
    Interp[i].N:=0;
    Interp[i].NFunc:=CM_NOP;
    Interp[i].NF:=0;{.197}
    Interp[i].TypeF:=0;
    Interp[i].COP:=_NOP;   //только для аргументов замещаемой комманды
    Interp[i].RRF:=rf_NO_REPLACE;//???????
    //FuncList[Interp[i].Code].FType:=0;
  end;
  inc(Db_ReplFuncNum);
end;

*)


fin:
//удалить все вытекающие аргументы замещаемой функции
if B_RF = True  then
begin
  FreeReplacedNodes(NodeS);

(*
  NodeS1:=GetLowLevelNode(NodeS);
  while NodeS1 <> NodeS do
  begin
    NodeS1^.N:=0;
    NodeS1^.NFunc:=CM_NOP;
    NodeS1^.NF:=0;{.197}
    NodeS1^.TypeF:=0;
    NodeS1^.COP:=_NOP;   //только для аргументов замещаемой комманды
    NodeS1^.RRF:=rf_NO_REPLACE;//???????
    //FuncList[Interp[i].Code].FType:=0;
    NodeS1:=NodeS1^.Next;
  end;
*)
   inc(Db_ReplFuncNum);

end;


{
 if (NFuncNF = CM_DIV) or (NFuncNF = CM_MUL) or (NFuncNF = CM_SUB) or (NFuncNF = CM_ADD) then inc(Db_ReplOpNum)
 else inc(Db_ReplFuncNum);  }


endp:
end;





 (*

//sin(x)-cos(x)+sin(x)+cos(x)
procedure TForevalH.InsertFuncRF(NF,NS: Integer);
label 1,endp,fin;
var
i,s,St: Integer;
L,FN: Integer;
NFuncNF,NFuncNS,RangRRF,NFF,NFS,CRFMem: Cardinal;
RangW,RangR,NMem,MShft:integer;
B_RF:Boolean;
begin
//NF -> NS
if Interp[NS].RRF = rf_FULL_REPLACE  then goto endp;   // (NS) уже полностью замещена



B_RF:=False;
NFuncNF:=Interp[NF].NFunc;
NFuncNS:=Interp[NS].NFunc;
NFF:=Interp[NF].NF;
NFS:=Interp[NS].NF;


{
if  ((NFuncNF = NFuncNS) and (NFF = NFS))  then
begin

  if Interp[NF].NRF = 0 then  //=Interp[NF].WRF <> rf_FULL_REPLACE
  begin
   if Interp[NF].TypeF = T_Real then
   begin
     RFSize:=RFSize+1;
     CRFMem:=RFSize;
   end
   else
   if Interp[NF].TypeF = T_Complex then
   begin
     RFSize:=RFSize+2;
     CRFMem:=RFSize;
   end
  end
  else
  CRFMem:=Interp[NF].MRF;       // т.к. может быть промежуточное изменение RFSize в случае CompositeReplace между последовательными полными
                                // заменами  Interp[NF]; (если CompositeReplace нет - то RFSize не изменится)


  Interp[NF].NRF:=Interp[NF].NRF+1;

  Interp[NF].WRF:=rf_FULL_REPLACE;
  Interp[NS].RRF:=rf_FULL_REPLACE;
  Interp[NS].MRF:=CRFMem;//RFSize;
  Interp[NF].MRF:=CRFMem;//RFSize;

  B_RF:=True;
  goto fin;
end
else
if (NFuncNF > High(TableRF)) or (NFuncNS > High(TableRF))  then
begin
  B_RF:=False;
  goto endp;
end;
}


{
if Interp[NF].TypeF = T_Real then
begin

   if TableRF[NFuncNF,NFuncNS].WRF_R = rf_FULL_REPLACE  then   //сохраняется вся ф-ия (NF)
   begin
     if (Interp[NF].WRF = rf_FULL_REPLACE)  then        //уже было сохранение всей ф-ии (NF)
     begin
         RangRRF:=TableRF[NFuncNF,NFuncNS].RRF_R;        //какая часть ф-ии замещается (NS)

         if RangRRF > Interp[NS].RRF then        //ранг замещаемой ф-ии выше предыдущего замещения , то выполнить  замещение
         begin
           //если замещается вся ф-ия (NS), то ячейка памяти - MRF
           //если частичное замещение (NS) - то  , то ячейка памяти - MRF_CS
           if RangRRF = rf_FULL_REPLACE  then   Interp[NS].MRF:=Interp[NF].MRF else   Interp[NS].MRF_CS:=Interp[NF].MRF;
           Interp[NS].RRF:=RangRRF;
           B_RF:=True;
         end;
     end
     else                                        //нет-выделить память
     begin
       RangRRF:=TableRF[NFuncNF,NFuncNS].RRF_R;        //какая часть ф-ии замещается (NS)
       if RangRRF > Interp[NS].RRF then        //если ранг замещаемой ф-ии выше предыдущего замещения, то выполнить  замещение
       begin
          RFSize:=RFSize+TableRF[NFuncNF,NFuncNS].NMEM_R;  //кол-во сохраняемых чисел
          Interp[NF].WRF:=rf_FULL_REPLACE;   //если сохраняется вся функция, то ячейка памяти - MRF
          Interp[NF].MRF:=RFSize;

           //если замещается вся ф-ия (NS), то ячейка памяти - MRF
           //если частичное замещение (NS) - то  , то ячейка памяти - MRF_CS
           if RangRRF = rf_FULL_REPLACE  then   Interp[NS].MRF:=Interp[NF].MRF else   Interp[NS].MRF_CS:=Interp[NF].MRF;
           Interp[NS].RRF:=RangRRF;
           B_RF:=True;
       end;
     end;

   end
   else    //сохраняется часть ф-ии (NF): ячейка памяти - MRF_CS
   begin
      if Interp[NF].WRF_CS = TableRF[NFuncNF,NFuncNS].WRF_R then        //уже было сохранение этой части ф-ии  (NF)
      begin
          RangRRF:=TableRF[NFuncNF,NFuncNS].RRF_R;        //какая часть ф-ии замещается (NS)
          if RangRRF > Interp[NS].RRF then        //ранг замещаемой ф-ии выше предыдущего замещения , то выполнить  замещение
          begin
            //если замещается вся ф-ия (NS), то ячейка памяти - MRF
            //если частичное замещение (NS) - то  , то ячейка памяти - MRF_CS
            if RangRRF = rf_FULL_REPLACE  then   Interp[NS].MRF:=Interp[NF].MRF_CS else   Interp[NS].MRF_CS:=Interp[NF].MRF_CS;
            Interp[NS].RRF:=RangRRF;
            B_RF:=True;
          end;
      end
      else             //нет-выделить память
      begin

          RangRRF:=TableRF[NFuncNF,NFuncNS].RRF_R;        //какая часть ф-ии замещается (NS)
          if RangRRF > Interp[NS].RRF then        //ранг замещаемой ф-ии выше предыдущего замещения , то выполнить  замещение
          begin
            RFSize:=RFSize+TableRF[NFuncNF,NFuncNS].NMEM_R;      //кол-во сохраняемых чисел
            Interp[NF].WRF_CS:=TableRF[NFuncNF,NFuncNS].WRF_R;   //часть сохраняемой   функции (NF)
            Interp[NF].MRF_CS:=RFSize;

            //если замещается вся ф-ия (NS), то ячейка памяти - MRF
            //если частичное замещение (NS) - то  , то ячейка памяти - MRF_CS
            if RangRRF = rf_FULL_REPLACE  then   Interp[NS].MRF:=Interp[NF].MRF_CS else   Interp[NS].MRF_CS:=Interp[NF].MRF_CS;
            Interp[NS].RRF:=RangRRF;
            B_RF:=True;
          end;
      end;
   end;
end ;
}



{
if (Interp[NF].NFunc <= High(TableRF)) and (Interp[NS].NFunc <= High(TableRF))  then   //только для внутренних функций (full+composite)
begin


if Interp[NF].TypeF = T_Real then
begin

   if TableRF[NFuncNF,NFuncNS].WRF_R = rf_FULL_REPLACE  then   //сохраняется вся ф-ия (NF)
   begin
     inc(Interp[NF].NRF);  //для совместимости (выше^)
     if (Interp[NF].WRF = rf_FULL_REPLACE)  then        //уже было сохранение всей ф-ии (NF)
     begin
         RangRRF:=TableRF[NFuncNF,NFuncNS].RRF_R;        //какая часть ф-ии замещается (NS)

         if RangRRF > Interp[NS].RRF then        //ранг замещаемой ф-ии выше предыдущего замещения , то выполнить  замещение
         begin
           //если замещается вся ф-ия (NS), то ячейка памяти - MRF
           //если частичное замещение (NS) - то  , то ячейка памяти - MRF_CS
           if RangRRF = rf_FULL_REPLACE  then
           begin
              Interp[NS].MRF:=Interp[NF].MRF-TableRF[NFuncNF,NFuncNS].SHFT_R;
              Interp[NS].RRF:=rf_FULL_REPLACE;
           end
           else
           begin
             Interp[NS].MRF_CS:=Interp[NF].MRF-TableRF[NFuncNF,NFuncNS].SHFT_R;
             Interp[NS].RRF:=RangRRF;
           end;
           B_RF:=True;
         end;
     end
     else                                        //нет-выделить память
     begin
       RangRRF:=TableRF[NFuncNF,NFuncNS].RRF_R;        //какая часть ф-ии замещается (NS)
       if RangRRF > Interp[NS].RRF then        //если ранг замещаемой ф-ии выше предыдущего замещения, то выполнить  замещение
       begin
          RFSize:=RFSize+TableRF[NFuncNF,NFuncNS].NMEM_R;  //кол-во сохраняемых чисел
          Interp[NF].WRF:=rf_FULL_REPLACE;   //если сохраняется вся функция, то ячейка памяти - MRF
          Interp[NF].MRF:=RFSize;

           //если замещается вся ф-ия (NS), то ячейка памяти - MRF
           //если частичное замещение (NS) - то  , то ячейка памяти - MRF_CS
           if RangRRF = rf_FULL_REPLACE  then
           begin
            Interp[NS].MRF:=Interp[NF].MRF-TableRF[NFuncNF,NFuncNS].SHFT_R;
            Interp[NS].RRF:=rf_FULL_REPLACE;
           end
           else
           begin
            Interp[NS].MRF_CS:=Interp[NF].MRF-TableRF[NFuncNF,NFuncNS].SHFT_R;
            Interp[NS].RRF:=RangRRF;
           end;
           Interp[NS].RRF:=RangRRF;
           B_RF:=True;
       end;
     end;

   end
   else    //сохраняется часть ф-ии (NF): ячейка памяти - MWF_CS
   begin
      if Interp[NF].WRF_CS = TableRF[NFuncNF,NFuncNS].WRF_R then        //уже было сохранение этой части ф-ии  (NF)
      begin
          RangRRF:=TableRF[NFuncNF,NFuncNS].RRF_R;        //какая часть ф-ии замещается (NS)
          if RangRRF > Interp[NS].RRF then        //ранг замещаемой ф-ии выше предыдущего замещения , то выполнить  замещение
          begin
            //если замещается вся ф-ия (NS), то ячейка памяти - MRF
            //если частичное замещение (NS) - то  , то ячейка памяти - MRF_CS
            if RangRRF = rf_FULL_REPLACE  then
            begin
              Interp[NS].MRF:=Interp[NF].MWF_CS-TableRF[NFuncNF,NFuncNS].SHFT_R;
              Interp[NS].RRF:=rf_FULL_REPLACE;
            end
            else
            begin
              Interp[NS].MRF_CS:=Interp[NF].MWF_CS-TableRF[NFuncNF,NFuncNS].SHFT_R;
              Interp[NS].RRF:=RangRRF;
            end;

            B_RF:=True;
          end;
      end
      else             //нет-выделить память
      begin

          RangRRF:=TableRF[NFuncNF,NFuncNS].RRF_R;        //какая часть ф-ии замещается (NS)
          if RangRRF > Interp[NS].RRF then        //ранг замещаемой ф-ии выше предыдущего замещения , то выполнить  замещение
          begin
            RFSize:=RFSize+TableRF[NFuncNF,NFuncNS].NMEM_R;      //кол-во сохраняемых чисел
            Interp[NF].WRF_CS:=TableRF[NFuncNF,NFuncNS].WRF_R;   //часть сохраняемой   функции (NF)
            Interp[NF].MWF_CS:=RFSize;

            //если замещается вся ф-ия (NS), то ячейка памяти - MRF
            //если частичное замещение (NS) - то  , то ячейка памяти - MRF_CS
            if RangRRF = rf_FULL_REPLACE  then
             begin
               Interp[NS].MRF:=Interp[NF].MWF_CS-TableRF[NFuncNF,NFuncNS].SHFT_R;
               Interp[NS].RRF:=rf_FULL_REPLACE;
             end
             else
             begin
               Interp[NS].MRF_CS:=Interp[NF].MWF_CS-TableRF[NFuncNF,NFuncNS].SHFT_R;
               Interp[NS].RRF:=RangRRF;
             end;

            B_RF:=True;
          end;
      end;
   end;
end
else
if Interp[NF].TypeF = T_Complex then
begin

   if TableRF[NFuncNF,NFuncNS].WRF_Z = rf_FULL_REPLACE  then   //сохраняется вся ф-ия (NF)
   begin
     inc(Interp[NF].NRF);  //для совместимости (выше^)
     if (Interp[NF].WRF = rf_FULL_REPLACE)  then        //уже было сохранение всей ф-ии (NF)
     begin
         RangRRF:=TableRF[NFuncNF,NFuncNS].RRF_Z;        //какая часть ф-ии замещается (NS)

         if RangRRF > Interp[NS].RRF then        //ранг замещаемой ф-ии выше предыдущего замещения , то выполнить  замещение
         begin
           //если замещается вся ф-ия (NS), то ячейка памяти - MRF
           //если частичное замещение (NS) - то  , то ячейка памяти - MRF_CS
           if RangRRF = rf_FULL_REPLACE  then
           begin
              Interp[NS].MRF:=Interp[NF].MRF-TableRF[NFuncNF,NFuncNS].SHFT_Z;
              Interp[NS].RRF:=rf_FULL_REPLACE;
           end
           else
           begin
             Interp[NS].MRF_CS:=Interp[NF].MRF-TableRF[NFuncNF,NFuncNS].SHFT_Z;
             Interp[NS].RRF:=RangRRF;
           end;
           B_RF:=True;
         end;
     end
     else                                        //нет-выделить память
     begin
       RangRRF:=TableRF[NFuncNF,NFuncNS].RRF_Z;        //какая часть ф-ии замещается (NS)
       if RangRRF > Interp[NS].RRF then        //если ранг замещаемой ф-ии выше предыдущего замещения, то выполнить  замещение
       begin
          RFSize:=RFSize+TableRF[NFuncNF,NFuncNS].NMEM_Z;  //кол-во сохраняемых чисел
          Interp[NF].WRF:=rf_FULL_REPLACE;   //если сохраняется вся функция, то ячейка памяти - MRF
          Interp[NF].MRF:=RFSize;

           //если замещается вся ф-ия (NS), то ячейка памяти - MRF
           //если частичное замещение (NS) - то  , то ячейка памяти - MRF_CS
           if RangRRF = rf_FULL_REPLACE  then
           begin
            Interp[NS].MRF:=Interp[NF].MRF-TableRF[NFuncNF,NFuncNS].SHFT_Z;
             Interp[NS].RRF:=rf_FULL_REPLACE;
           end
           else
           begin
            Interp[NS].MRF_CS:=Interp[NF].MRF-TableRF[NFuncNF,NFuncNS].SHFT_Z;
            Interp[NS].RRF:=RangRRF;
           end;
           Interp[NS].RRF:=RangRRF;
           B_RF:=True;
       end;
     end;

   end
   else    //сохраняется часть ф-ии (NF): ячейка памяти - MWF_CS
   begin
      if Interp[NF].WRF_CS = TableRF[NFuncNF,NFuncNS].WRF_Z then        //уже было сохранение этой части ф-ии  (NF)
      begin
          RangRRF:=TableRF[NFuncNF,NFuncNS].RRF_Z;        //какая часть ф-ии замещается (NS)
          if RangRRF > Interp[NS].RRF then        //ранг замещаемой ф-ии выше предыдущего замещения , то выполнить  замещение
          begin
            //если замещается вся ф-ия (NS), то ячейка памяти - MRF
            //если частичное замещение (NS) - то  , то ячейка памяти - MRF_CS
            if RangRRF = rf_FULL_REPLACE  then
            begin
              Interp[NS].MRF:=Interp[NF].MWF_CS-TableRF[NFuncNF,NFuncNS].SHFT_Z;
              Interp[NS].RRF:=rf_FULL_REPLACE;
            end
            else
            begin
              Interp[NS].MRF_CS:=Interp[NF].MWF_CS-TableRF[NFuncNF,NFuncNS].SHFT_Z;
              Interp[NS].RRF:=RangRRF;
            end;

            B_RF:=True;
          end;
      end
      else             //нет-выделить память
      begin

          RangRRF:=TableRF[NFuncNF,NFuncNS].RRF_Z;        //какая часть ф-ии замещается (NS)
          if RangRRF > Interp[NS].RRF then        //ранг замещаемой ф-ии выше предыдущего замещения , то выполнить  замещение
          begin
            RFSize:=RFSize+TableRF[NFuncNF,NFuncNS].NMEM_Z;      //кол-во сохраняемых чисел
            Interp[NF].WRF_CS:=TableRF[NFuncNF,NFuncNS].WRF_Z;   //часть сохраняемой   функции (NF)
            Interp[NF].MWF_CS:=RFSize;

            //если замещается вся ф-ия (NS), то ячейка памяти - MRF
            //если частичное замещение (NS) - то  , то ячейка памяти - MRF_CS
            if RangRRF = rf_FULL_REPLACE  then
             begin
               Interp[NS].MRF:=Interp[NF].MWF_CS-TableRF[NFuncNF,NFuncNS].SHFT_Z;
               Interp[NS].RRF:=rf_FULL_REPLACE;
             end
             else
             begin
               Interp[NS].MRF_CS:=Interp[NF].MWF_CS-TableRF[NFuncNF,NFuncNS].SHFT_Z;
               Interp[NS].RRF:=RangRRF;
             end;

            B_RF:=True;
          end;
      end;
   end;
end ;

end
else
begin

 if  ((Interp[NF].NFunc = Interp[NS].NFunc) and (Interp[NF].NF = Interp[NS].NF))  then      //только полное замещение для добавляемых функций
 begin

   //if Interp[NF].NRF = 0
   if Interp[NF].WRF = rf_FULL_REPLACE then
   begin
         //уже было сохранение всей ф-ии (NF)
   end
   else   //нет-выделить память
   begin
    if Interp[NF].TypeF = T_Real then
    begin
      RFSize:=RFSize+1;
      Interp[NF].MRF:=RFSize;
    end
    else
    if Interp[NF].TypeF = T_Complex then
    begin
      RFSize:=RFSize+2;
      Interp[NF].MRF:=RFSize;
    end
   end;

   Interp[NF].NRF:=Interp[NF].NRF+1;

   Interp[NF].WRF:=rf_FULL_REPLACE;
   Interp[NS].RRF:=rf_FULL_REPLACE;
   Interp[NS].MRF:=Interp[NF].MRF;


   B_RF:=True;
 end;

end;

}



//if Interp[NF].TypeF = T_Real then
//begin


   GetReplaceData(NF,NS,Interp[NF].TypeF,RangW,RangR,NMem,MShft);

   if RangW = rf_FULL_REPLACE  then   //сохраняется вся ф-ия (NF)
   begin
     inc(Interp[NF].NRF);  //для совместимости (выше^)
     if (Interp[NF].WRF = rf_FULL_REPLACE)  then        //уже было сохранение всей ф-ии (NF)
     begin

         if RangR > Interp[NS].RRF then        //ранг замещаемой ф-ии выше предыдущего замещения , то выполнить  замещение
         begin
           //если замещается вся ф-ия (NS), то ячейка памяти - MRF
           //если частичное замещение (NS) - то  , то ячейка памяти - MRF_CS
           if RangR = rf_FULL_REPLACE  then
           begin
              Interp[NS].MRF:=Interp[NF].MRF-MShft;
              Interp[NS].RRF:=rf_FULL_REPLACE;
           end
           else
           begin
             Interp[NS].MRF_CS:=Interp[NF].MRF-MShft;
             Interp[NS].RRF:=RangR;
           end;
           B_RF:=True;
         end;
     end
     else                                        //нет-выделить память
     begin
        if RangR > Interp[NS].RRF then        //если ранг замещаемой ф-ии выше предыдущего замещения, то выполнить  замещение
       begin
          RFSize:=RFSize+NMem;  //кол-во сохраняемых чисел
          Interp[NF].WRF:=rf_FULL_REPLACE;   //если сохраняется вся функция, то ячейка памяти - MRF
          Interp[NF].MRF:=RFSize;

           //если замещается вся ф-ия (NS), то ячейка памяти - MRF
           //если частичное замещение (NS) - то  , то ячейка памяти - MRF_CS
           if RangR = rf_FULL_REPLACE  then
           begin
            Interp[NS].MRF:=Interp[NF].MRF-MShft;
            Interp[NS].RRF:=rf_FULL_REPLACE;
           end
           else
           begin
            Interp[NS].MRF_CS:=Interp[NF].MRF-MShft;
            Interp[NS].RRF:=RangR;
           end;

           B_RF:=True;
       end;
     end;

   end
   else    //сохраняется часть ф-ии (NF): ячейка памяти - MWF_CS
   begin
      if Interp[NF].WRF_CS = RangW then        //уже было сохранение этой части ф-ии  (NF)
      begin
          if RangR > Interp[NS].RRF then        //ранг замещаемой ф-ии выше предыдущего замещения , то выполнить  замещение
          begin
            //если замещается вся ф-ия (NS), то ячейка памяти - MRF
            //если частичное замещение (NS) - то  , то ячейка памяти - MRF_CS
            if RangR = rf_FULL_REPLACE  then
            begin
              Interp[NS].MRF:=Interp[NF].MWF_CS-MShft;
              Interp[NS].RRF:=rf_FULL_REPLACE;
            end
            else
            begin
              Interp[NS].MRF_CS:=Interp[NF].MWF_CS-MShft;
              Interp[NS].RRF:=RangR;
            end;

            B_RF:=True;
          end;
      end
      else             //нет-выделить память
      begin

           if RangR > Interp[NS].RRF then        //ранг замещаемой ф-ии выше предыдущего замещения , то выполнить  замещение
          begin
            RFSize:=RFSize+NMem;      //кол-во сохраняемых чисел
            Interp[NF].WRF_CS:=RangW;   //часть сохраняемой   функции (NF)
            Interp[NF].MWF_CS:=RFSize;

            //если замещается вся ф-ия (NS), то ячейка памяти - MRF
            //если частичное замещение (NS) - то  , то ячейка памяти - MRF_CS
            if RangR = rf_FULL_REPLACE  then
             begin
               Interp[NS].MRF:=Interp[NF].MWF_CS-MShft;
               Interp[NS].RRF:=rf_FULL_REPLACE;
             end
             else
             begin
               Interp[NS].MRF_CS:=Interp[NF].MWF_CS-MShft;
               Interp[NS].RRF:=RangR;
             end;

            B_RF:=True;
          end;
      end;
   end;
//end
{
else

if Interp[NF].TypeF = T_Complex then
begin
   GetReplaceData(NF,NS,T_Complex,RangW,RangR,NMem,MShft);

   if TableRF[NFuncNF,NFuncNS].WRF_Z = rf_FULL_REPLACE  then   //сохраняется вся ф-ия (NF)
   begin
     inc(Interp[NF].NRF);  //для совместимости (выше^)
     if (Interp[NF].WRF = rf_FULL_REPLACE)  then        //уже было сохранение всей ф-ии (NF)
     begin
         RangRRF:=TableRF[NFuncNF,NFuncNS].RRF_Z;        //какая часть ф-ии замещается (NS)

         if RangRRF > Interp[NS].RRF then        //ранг замещаемой ф-ии выше предыдущего замещения , то выполнить  замещение
         begin
           //если замещается вся ф-ия (NS), то ячейка памяти - MRF
           //если частичное замещение (NS) - то  , то ячейка памяти - MRF_CS
           if RangRRF = rf_FULL_REPLACE  then
           begin
              Interp[NS].MRF:=Interp[NF].MRF-TableRF[NFuncNF,NFuncNS].SHFT_Z;
              Interp[NS].RRF:=rf_FULL_REPLACE;
           end
           else
           begin
             Interp[NS].MRF_CS:=Interp[NF].MRF-TableRF[NFuncNF,NFuncNS].SHFT_Z;
             Interp[NS].RRF:=RangRRF;
           end;
           B_RF:=True;
         end;
     end
     else                                        //нет-выделить память
     begin
       RangRRF:=TableRF[NFuncNF,NFuncNS].RRF_Z;        //какая часть ф-ии замещается (NS)
       if RangRRF > Interp[NS].RRF then        //если ранг замещаемой ф-ии выше предыдущего замещения, то выполнить  замещение
       begin
          RFSize:=RFSize+TableRF[NFuncNF,NFuncNS].NMEM_Z;  //кол-во сохраняемых чисел
          Interp[NF].WRF:=rf_FULL_REPLACE;   //если сохраняется вся функция, то ячейка памяти - MRF
          Interp[NF].MRF:=RFSize;

           //если замещается вся ф-ия (NS), то ячейка памяти - MRF
           //если частичное замещение (NS) - то  , то ячейка памяти - MRF_CS
           if RangRRF = rf_FULL_REPLACE  then
           begin
            Interp[NS].MRF:=Interp[NF].MRF-TableRF[NFuncNF,NFuncNS].SHFT_Z;
             Interp[NS].RRF:=rf_FULL_REPLACE;
           end
           else
           begin
            Interp[NS].MRF_CS:=Interp[NF].MRF-TableRF[NFuncNF,NFuncNS].SHFT_Z;
            Interp[NS].RRF:=RangRRF;
           end;
           Interp[NS].RRF:=RangRRF;
           B_RF:=True;
       end;
     end;

   end
   else    //сохраняется часть ф-ии (NF): ячейка памяти - MWF_CS
   begin
      if Interp[NF].WRF_CS = TableRF[NFuncNF,NFuncNS].WRF_Z then        //уже было сохранение этой части ф-ии  (NF)
      begin
          RangRRF:=TableRF[NFuncNF,NFuncNS].RRF_Z;        //какая часть ф-ии замещается (NS)
          if RangRRF > Interp[NS].RRF then        //ранг замещаемой ф-ии выше предыдущего замещения , то выполнить  замещение
          begin
            //если замещается вся ф-ия (NS), то ячейка памяти - MRF
            //если частичное замещение (NS) - то  , то ячейка памяти - MRF_CS
            if RangRRF = rf_FULL_REPLACE  then
            begin
              Interp[NS].MRF:=Interp[NF].MWF_CS-TableRF[NFuncNF,NFuncNS].SHFT_Z;
              Interp[NS].RRF:=rf_FULL_REPLACE;
            end
            else
            begin
              Interp[NS].MRF_CS:=Interp[NF].MWF_CS-TableRF[NFuncNF,NFuncNS].SHFT_Z;
              Interp[NS].RRF:=RangRRF;
            end;

            B_RF:=True;
          end;
      end
      else             //нет-выделить память
      begin

          RangRRF:=TableRF[NFuncNF,NFuncNS].RRF_Z;        //какая часть ф-ии замещается (NS)
          if RangRRF > Interp[NS].RRF then        //ранг замещаемой ф-ии выше предыдущего замещения , то выполнить  замещение
          begin
            RFSize:=RFSize+TableRF[NFuncNF,NFuncNS].NMEM_Z;      //кол-во сохраняемых чисел
            Interp[NF].WRF_CS:=TableRF[NFuncNF,NFuncNS].WRF_Z;   //часть сохраняемой   функции (NF)
            Interp[NF].MWF_CS:=RFSize;

            //если замещается вся ф-ия (NS), то ячейка памяти - MRF
            //если частичное замещение (NS) - то  , то ячейка памяти - MRF_CS
            if RangRRF = rf_FULL_REPLACE  then
             begin
               Interp[NS].MRF:=Interp[NF].MWF_CS-TableRF[NFuncNF,NFuncNS].SHFT_Z;
               Interp[NS].RRF:=rf_FULL_REPLACE;
             end
             else
             begin
               Interp[NS].MRF_CS:=Interp[NF].MWF_CS-TableRF[NFuncNF,NFuncNS].SHFT_Z;
               Interp[NS].RRF:=RangRRF;
             end;

            B_RF:=True;
          end;
      end;
   end;

end ;
}





fin:
//все вытекающие аргументы замещаемой функции=CM_NOP
if B_RF = True  then
begin
  S:=Interp[NS].S;
  FN:=GetFirstNode(NS);  //первый аргумент дерева(замещаемой функции) =  (нижний левый Interp.[FN]); (верхний узел Interp.[NS] - замещаемая функция)
  for i:=FN to NS-1 do
  begin
    Interp[i].N:=0;
    Interp[i].NFunc:=CM_NOP;
    Interp[i].NF:=0;{.197}
    Interp[i].TypeF:=0;
    Interp[i].COP:=_NOP;   //только для аргументов замещаемой комманды
    Interp[i].RRF:=rf_NO_REPLACE;//???????
    //FuncList[Interp[i].Code].FType:=0;
  end;
  inc(Db_ReplFuncNum);
end;

{
 if (NFuncNF = CM_DIV) or (NFuncNF = CM_MUL) or (NFuncNF = CM_SUB) or (NFuncNF = CM_ADD) then inc(Db_ReplOpNum)
 else inc(Db_ReplFuncNum);  }


endp:
end;

 *)



procedure TForevalH.GetReplaceData({NF,NS,}NodeF,NodeS: PNode; VType: integer; var RangW,RangR,NMem,MShft: Integer);
var
 NFuncNF,NFuncNS,NFF,NFS: Cardinal;
begin
{
NFuncNF:=Interp[NF].NFunc;
NFuncNS:=Interp[NS].NFunc;
NFF:=Interp[NF].NF;
NFS:=Interp[NS].NF;
 }
NFuncNF:=NodeF^.NFunc;
NFuncNS:=NodeS^.NFunc;
NFF:=NodeF^.NF;
NFS:=NodeS^.NF;

RangW:=rf_NO_REPLACE;
RangR:=rf_NO_REPLACE;
MShft:=0;
NMem:=0;

if (NodeF^.NFunc <= High(TableRF)) and (NodeS^.NFunc <= High(TableRF))  then   //только для внутренних функций (full+composite)
begin



  if VType = T_Real then
  begin
     RangW:=TableRF[NFuncNF,NFuncNS].WRF_R;
     RangR:=TableRF[NFuncNF,NFuncNS].RRF_R;
     MShft:=TableRF[NFuncNF,NFuncNS].SHFT_R;
     NMem:=TableRF[NFuncNF,NFuncNS].NMEM_R;
  end
  else
  if VType = T_Complex then
  begin
     RangW:=TableRF[NFuncNF,NFuncNS].WRF_Z;
     RangR:=TableRF[NFuncNF,NFuncNS].RRF_Z;
     MShft:=TableRF[NFuncNF,NFuncNS].SHFT_Z;
     NMem:=TableRF[NFuncNF,NFuncNS].NMEM_Z;

     //исключение, т.к. комплексная ф-ия cossin замещает действительные cos, sin (несоответствие VType ф-ий)
    (* if (NFuncNF = CM_SINCOS) and ((NFuncNS = CM_COS) or (NFuncNS = CM_SIN)) then    {.331}
     begin
        RangW:=rf_FULL_REPLACE;
        RangR:=rf_FULL_REPLACE;
        if NFuncNS = CM_COS then
        begin
          NMem:=TableRF[CM_SINCOS,CM_COS].NMEM_R;
          MShft:=TableRF[CM_SINCOS,CM_COS].SHFT_R;
        end
        else
         if NFuncNS = CM_SIN then
        begin
          NMem:=TableRF[CM_SINCOS,CM_SIN].NMEM_R;
          MShft:=TableRF[CM_SINCOS,CM_SIN].SHFT_R;
        end;
     end;
     *)


  end;

end
else
if  ((NodeF^.NFunc = NodeS^.NFunc) and (NodeF^.NF = NodeS^.NF))  then      //только полное замещение для добавляемых функций
 begin

  if VType = T_Real then
  begin
     RangW:=rf_FULL_REPLACE;
     RangR:=rf_FULL_REPLACE;
     MShft:=0;
     NMem:=1;
  end
  else
  if VType = T_Complex then
  begin
     RangW:=rf_FULL_REPLACE;
     RangR:=rf_FULL_REPLACE;
     MShft:=0;
     NMem:=2;
  end;
end;

end;






procedure TForevalH.DelVoidSave;
label nxts;

(********************************
    function ConditionForDel(NodeS: PNode): Boolean;
    label endp;
    var
      Answer: Boolean;
      NodeD: PNode;
    begin
         Answer:=False;

         NodeD:=NodeS;
         NodeD:=GetLowLevelNode(NodeD);



         if (NodeD^.RRF = rf_FULL_REPLACE) and (NodeS^.MRF = NodeD^.MRF) and (NodeS^.MRF >= 0)   then
         begin
            Answer:=True; goto endp;
         end;

         while NodeS^.Pr <> nil do
         begin
            NodeS:=GetNextNode(NodeS);

            if (NodeD^.RRF = rf_FULL_REPLACE) and (NodeS^.MRF = NodeD^.MRF) and (NodeS^.MRF >= 0)   then
            begin
               Answer:=True; goto endp;
            end;

         end;

         endp:
         ConditionForDel:=Answer;
    end;
 **************************************)
var
 BRF: Boolean;
 NRF,NS,ND,NV: Cardinal;
 NodeS,NodeD: PNode;
begin



 (***************
   NV:=0;

   NodeS:=BeginTree;
   NodeS:=GetLowLevelNode(NodeS);

   if (NodeS^.NFunc <> CM_NOP) and (NodeS^.WRF = rf_FULL_REPLACE) then
   begin
     if  ConditionForDel(NodeS) = True then
     begin
       NodeS^.WRF:=rf_NO_REPLACE;
       NodeS^.NRF:=0;
       inc(NV);
     end;
   end;


   while NodeS^.Pr <> nil do
   begin
      NodeS:=GetNextNode(NodeS);

      if (NodeS^.NFunc <> CM_NOP) and (NodeS^.WRF = rf_FULL_REPLACE) then
      begin
        if  ConditionForDel(NodeS) = True then
        begin
          NodeS^.WRF:=rf_NO_REPLACE;
          NodeS^.NRF:=0;
          inc(NV);
        end;
      end;
   end;
***************)



(*
//NS->ND
NV:=0;
for NS := 0 to LFunc-1 do
begin
  BRF:=False;

  if (Interp[NS].NFunc <> CM_NOP) and (Interp[NS].WRF = rf_FULL_REPLACE) then
  begin
   for ND := NS to LFunc-1 do
   begin                                                                                           {.219}
     if (Interp[ND].RRF = rf_FULL_REPLACE) and (Interp[NS].MRF = Interp[ND].MRF) and (Interp[NS].MRF >= 0) {and (Interp[ND].NFunc <> CM_NOP)}  then
     begin
       BRF:=True;
     end;
   end;
  end;

  if BRF = False then
  begin
    Interp[NS].WRF:=rf_NO_REPLACE;
    Interp[NS].NRF:=0;
    inc(NV);
  end;

end;
*)



//NS->ND
NV:=0;
NodeS:=FirstNode;

while NodeS <> nil do
begin
  BRF:=False;

  if (NodeS^.NFunc <> CM_NOP) and (NodeS^.WRF = rf_FULL_REPLACE) then
  begin

   NodeD:=NodeS^.Next;
   while NodeD <> nil do
   begin                                                                                           {.219}
     if (NodeD^.RRF = rf_FULL_REPLACE) and (NodeS^.MRF = NodeD^.MRF) and (NodeS^.MRF >= 0) {and (Interp[ND].NFunc <> CM_NOP)}  then
     begin
       BRF:=True;
       goto nxts;    {.233}
     end;
     NodeD:=NodeD^.Next;
   end;

  end;

  if BRF = False then
  begin
    NodeS^.WRF:=rf_NO_REPLACE;
    NodeS^.NRF:=0;
    inc(NV);
  end;

  nxts:
  NodeS:=NodeS^.Next;
end;


end;


(*
procedure TForevalH.DelVoidSave;
var
 BRF: Boolean;
 NRF,NS,ND,NV: Cardinal;
begin

//NS->ND
NV:=0;
for NS := 0 to LFunc-1 do
begin
  BRF:=False;

  if (Interp[NS].NFunc <> CM_NOP) and (Interp[NS].WRF = rf_FULL_REPLACE) then
  begin
   for ND := NS to LFunc-1 do
   begin                                                                                           {.219}
     if (Interp[ND].RRF = rf_FULL_REPLACE) and (Interp[NS].MRF = Interp[ND].MRF) and (Interp[NS].MRF >= 0) {and (Interp[ND].NFunc <> CM_NOP)}  then
     begin
       BRF:=True;
     end;
   end;
  end;

  if BRF = False then
  begin
    Interp[NS].WRF:=rf_NO_REPLACE;
    Interp[NS].NRF:=0;
    inc(NV);
  end;

end;

end;
*)




procedure TForevalH.DelVoidSaveCF;
label nxts;

  (*******************************************
    function ConditionForDel(NodeS: PNode): Boolean;
    label endp;
    var
      Answer: Boolean;
      NodeD: PNode;
    begin
         Answer:=False;

         NodeD:=NodeS;
         NodeD:=GetLowLevelNode(NodeD);

         if (NodeD^.RRF <>  rf_NO_REPLACE) and
         (
          ((NodeS^.MRF = NodeD^.MRF)       and (NodeS^.MRF >=0))     or
          ((NodeS^.MRF = NodeD^.MRF_CS)    and (NodeS^.MRF >= 0))    or
          ((NodeS^.MRF_CS = NodeD^.MRF_CS) and (NodeS^.MRF_CS >= 0)) or
          ((NodeS^.MRF_CS = NodeD^.MRF)    and (NodeS^.MRF_CS >= 0))
         )  then
         begin
           Answer:=True; goto endp;
         end;

         while NodeS^.Pr <> nil do
         begin
            NodeS:=GetNextNode(NodeS);

            if (NodeD^.RRF <>  rf_NO_REPLACE) and
           (
           ((NodeS^.MRF = NodeD^.MRF)       and (NodeS^.MRF >=0))     or
           ((NodeS^.MRF = NodeD^.MRF_CS)    and (NodeS^.MRF >= 0))    or
           ((NodeS^.MRF_CS = NodeD^.MRF_CS) and (NodeS^.MRF_CS >= 0)) or
           ((NodeS^.MRF_CS = NodeD^.MRF)    and (NodeS^.MRF_CS >= 0))
           )  then
           begin
             Answer:=True; goto endp;
           end;

         end;

         endp:
         ConditionForDel:=Answer;
    end;

    ***********************************************)
var
 BRF: Boolean;
 NRF,NS,ND,NV: Cardinal;

 NodeS,NodeD,NodeF: PNode;
begin

//NS->ND



(*******************************************

   NV:=0;

   NodeS:=BeginTree; //не обязательно, т.к. чтение дерева - циклически
   NodeS:=GetLowLevelNode(NodeS);

   if (NodeS^.NFunc <> CM_NOP) and ((NodeS^.WRF <> rf_NO_REPLACE) or (NodeS^.WRF_CS <> rf_NO_REPLACE)) then
   begin
     if  ConditionForDel(NodeS) = True then
     begin
       NodeS^.WRF:=rf_NO_REPLACE;
       NodeS^.NRF:=0;
       inc(NV);
     end;
   end;


   while NodeS^.Pr <> nil do
   begin
      NodeS:=GetNextNode(NodeS);

      if (NodeS^.NFunc <> CM_NOP) and ((NodeS^.WRF <> rf_NO_REPLACE) or (NodeS^.WRF_CS <> rf_NO_REPLACE)) then
      begin
        if  ConditionForDel(NodeS) = True then
        begin
          NodeS^.WRF:=rf_NO_REPLACE;
          NodeS^.NRF:=0;
          inc(NV);
        end;
      end;
   end;

 ***********************************************)



//NS->ND
NV:=0;
NodeS:=FirstNode;
while NodeS <> nil do
begin
  BRF:=False;

  if (NodeS^.NFunc <> CM_NOP) and ((NodeS^.WRF <> rf_NO_REPLACE) or (NodeS^.WRF_CS <> rf_NO_REPLACE)) then
  begin

    NodeD:=NodeS^.Next;
    while NodeD <> nil do
    begin

      if (NodeD^.RRF <>  rf_NO_REPLACE) and
        (
          ((NodeS^.MRF = NodeD^.MRF)       and (NodeS^.MRF >=0))     or
          ((NodeS^.MRF = NodeD^.MRF_CS)    and (NodeS^.MRF >= 0))    or
          ((NodeS^.MRF_CS = NodeD^.MRF_CS) and (NodeS^.MRF_CS >= 0)) or
          ((NodeS^.MRF_CS = NodeD^.MRF)    and (NodeS^.MRF_CS >= 0))
        )  then
      begin
       BRF:=True;
       goto nxts; {.233}
      end;


      {.331}  //исключения для :  cossin -> sin,cos,sec,cosec     несовпадение по  номерам ячеек (полное сохранение и чтение, но для sin читает из +shift(=1))
     if (NodeS^.NFunc = CM_COSSIN) then
     begin
       if (NodeD^.NFunc = CM_COS) or (NodeD^.NFunc = CM_SIN) or (NodeD^.NFunc = CM_SEC) or (NodeD^.NFunc = CM_COSEC) then    //<- необязательно
       begin
         if (NodeS^.WRF = rf_FULL_REPLACE) and (NodeD^.RRF = rf_FULL_REPLACE)  then        //полная замена cossin(x)+cos(x)
         begin
           if (NodeS^.MRF = NodeD^.MRF+TableRF[NodeS^.NFunc,NodeD^.NFunc].SHFT_R) then
           begin
             BRF := True;
             goto nxts;
           end
         end
         else
         if (NodeS^.WRF = rf_FULL_REPLACE) and (NodeD^.RRF <> rf_NO_REPLACE)  then       //частичные замены       cossin(x)+sec(x)
         begin
           if (NodeS^.MRF = NodeD^.MRF_CS+TableRF[NodeS^.NFunc,NodeD^.NFunc].SHFT_R) then
           begin
             BRF := True;
             goto nxts;
           end
         end;
       end;
     end;




      NodeD:=NodeD^.Next;
    end;

  end;


  //удаляются только полные (уже ненужные) сохранения. Частичные остаются(WRF_CS).
  if BRF = False then
  begin
    NodeS^.WRF:=rf_NO_REPLACE;
    NodeS^.NRF:=0;
    inc(NV);
  end;

  nxts:
  NodeS:=NodeS^.Next;
end;


(*
//NS->ND
NV:=0;
for NS := 0 to LFunc-1 do
begin
  BRF:=False;

  if (Interp[NS].NFunc <> CM_NOP) and ((Interp[NS].WRF <> rf_NO_REPLACE) or (Interp[NS].WRF_CS <> rf_NO_REPLACE)) then
  begin
   for ND := NS to LFunc-1 do
   begin
     if (Interp[ND].RRF <>  rf_NO_REPLACE) and
        (
          ((Interp[NS].MRF = Interp[ND].MRF)       and (Interp[NS].MRF >=0))     or
          ((Interp[NS].MRF = Interp[ND].MRF_CS)    and (Interp[NS].MRF >= 0))    or
          ((Interp[NS].MRF_CS = Interp[ND].MRF_CS) and (Interp[NS].MRF_CS >= 0)) or
          ((Interp[NS].MRF_CS = Interp[ND].MRF)    and (Interp[NS].MRF_CS >= 0))
        )  then
     begin
       BRF:=True;
     end;
   end;
  end;

  if BRF = False then
  begin
    Interp[NS].WRF:=rf_NO_REPLACE;
    Interp[NS].NRF:=0;
    inc(NV);
  end;

end;
*)

end;






function TForevalH.GetFirstNode(num: Integer): Cardinal;
label repf,endp;
var
j,IdN: Integer;
CS,FN: Cardinal;
ANL: TArrayC;
begin

 {$IFDEF TEXTOUT}
   if num = LFunc-1 then
     G_Test2:={G_Test2+}Interp[num].IdL;
 {$ENDIF}
                                               //(2^3)*4+(2^3)*4

  (*                                             //(2+3)*4+(2+3)*4
FN:=num;
IdN:=Interp[num].IdN;

repf:
for j:=1 to LFunc-1 do
begin
   if Interp[j].IdL = IdN then
   begin
    if Interp[j].N = 0 then      //N = 0  <=>   Interp[j].COP = _LDSC, LDSCX, _LDSF
    begin
      FN:=j; goto endp;
    end
    else
    begin
      IdN:=Interp[j].IdN;
      goto repf;
    end;
   end;
end;
*)


endp:
GetFirstNode:=FN;

end;





{.358}
procedure TForevalH.FindNonReplFuncPS(PSf: PString; var BH: Boolean);
label endp;
var
k,l: Integer;
//Sf1,Sfn: String;
BH1: Boolean;
begin

BH:=False;

//Sf1:=Sf;

if  F_ExtNameFunction = True then
begin

 for k:=0 to High(Alg.ExFunc) do
 begin

   if (Alg.ExFunc[k].ReplFunc = _No) and (Alg.ExFunc[k].Enable <> _No) then
   begin
      FindFuncInExprPS(k,PSf,BH1);
      if BH1 = True then
      begin
        BH:=True;
        goto endp;
      end;

   end;

 end

end
else
for k:=0 to High(Alg.ExFunc) do
 begin
    if (Alg.ExFunc[k].ReplFunc = _No) and (Alg.ExFunc[k].Enable <> _No) then
    begin
        FindFuncInExprPS(k,PSf,BH1);
        if BH1 = True then
        begin
          BH:=True;
          goto endp;
        end;
    end;
 end;


endp:
end;




{.358}
procedure  TForevalH.FindFuncInExprPS(k: Integer; PSexpr: PString; var BH: Boolean);
label endp;
var
FName: set of  Char;
Sfn: String;
i,P,L,LF: integer;
begin
FName:=['(','{','[','|','*','/','>','<','=','+','^','-',',',';','$'];

BH:=False;

//if F_ExtNameFunction = True then LF:= Length(Alg.ExFunc[k].NameEx)-1 else LF:=1;

if F_ExtNameFunction = True then LF:=High(Alg.ExFunc[k].NameEx)  else
begin
   if Length(Alg.ExFunc[k].NameEx) <> 0 then  LF:=0 else LF:=-1;
end;


  for i:=0 to LF do
     begin
         Sfn:=Alg.ExFunc[k].NameEx[i];

         P:=Pos(Sfn,PSExpr^);
         if P > 0 then
         begin
           L:=Length(Sfn);

           if (PSExpr^[L+P] = '(') then
           begin
               if (P = 1)  then
               begin
                 BH:=True;
                 goto endp;
               end
               else
               begin
                  if PSExpr^[P-1] in FName = True then
                  begin
                    BH:=True;
                    goto endp;
                  end
               end;
           end
           else
           if PSExpr^[P-1] = '@' then     {.358}     //call(@func); AnyCall(..,@func,..) ; AnyCall(..,@func)
           begin
              if (Length(PSExpr^) = L+1) or       //anycall(@func)
                   (PSExpr^[L+P] = ',')    or       //anycall(...,@func,...)  ; anycall(@func,...)
                     (Length(PSExpr^) = L+P-1) then    //anycall(...,@func)
              begin
                 BH:=True;
                 goto endp;
              end;
           end;
         end;
     end;

endp:
end;







function TForevalH.FindIfFuncInNode(Tree: PNode): Boolean;
begin

  if (Tree^.NFunc = CM_IF) or  (Tree^.NFunc = CM_JMP) then
    F_IFtmp:=True
  else
    F_IFtmp:=True;

   FindIfFuncInNode:=F_IFtmp;

end;




function TForevalH.FindIfFunc: Boolean;
label endp;
var
i: Integer;
Node: PNode;
begin
if F_InternalError <> 0 then goto endp; {.322}

(*
 if F_SyntaxErrorCode <> 0 then goto endp;

  F_IFtmp:=False;



// PFObj:=ForevalH.SetExtArgInNode;

 ReadTree(FindIfFuncInNode);
 //ReadTree(@TForevalH.SetExtArgInNode);
 //ReadTree(TProcTree(TForevalH.SetExtArgInNode));
 FindIfFunc:= F_IFtmp;
*)



Node:=FirstNode;

while Node <> nil do
begin
  if (Node^.NFunc = CM_IF) or  (Node^.NFunc = CM_JMP) then
  begin
    FindIfFunc:=True; goto endp;
  end;

  Node:=Node^.Next;
end;
FindIfFunc:=False;

endp:
end;





(*
function TForevalH.FindIfFunc: Boolean;
label endp;
var
i: Integer;
begin


 for i:=1 to Length(Interp)-1 do
 begin
  if (Interp[i].NFunc = CM_IF) or  (Interp[i].NFunc = CM_JMP)
  then  begin FindIfFunc:=True; goto endp; end;
 end;

FindIfFunc:=False;

endp:
end;
*)








{.191}
procedure TForevalH.FreeFuncList;
var
i,j: Integer;
begin

 for i:=0 to High(Alg.ExFunc) do
  begin
    for j := 0 to High(Alg.ExFunc[i].NameEx) do
    begin
       Alg.ExFunc[i].NameEx[j]:='';
     end;
     Alg.ExFunc[i].NameEx:=nil;
  end;


end;



constructor TForevalH.Create;
begin
//inherited Create(AOwner);
GetLocaleFormatSettings(0,G_FMT);
G_FMT.DecimalSeparator:='.';
CreateInitData;
end;


destructor TForevalH.Destroy;
begin
FreeFuncList;
Alg.Obj:=nil;
Alg.Param:=nil;
Alg.Opr:=nil;
Alg.ExFunc:=nil;

AlgVec:=nil;
AlgVarR:=nil;

Factorial:=nil;
inherited Destroy;
end;



procedure TForevalH.FreeTree;
label endp;
var
H: PNode;
begin
if Tree = nil then goto endp;


      //L:int=len(vd);L
      //L=len(vd);L

//освобождение дерева через последовательное чтение списка
if F_SequentList = True then
begin
 Tree:=FirstNode;
 //Tree:=GetLowLevelNode(Tree);
 while Tree <> nil do
 begin
   H:=Tree^.Next;
   FreeNode(Tree);
   Tree:=H;
 end;
 FirstNode:=nil;
 F_SequentList:=False;
 goto endp;
end;



{
освобождение дерева обычным способом: через обход ссылок на Ch,Pr
исп-ся после дифф-я т.к. в нём удаляются промежуточные ветви дерева и
ссыли последовательного списока в дереве не действительны
}

Tree:=BeginTree;

while Tree^.Ch <> nil do
begin
Tree:=Tree^.Ch;
end;
//COP=NOP

while Tree^.Pr <> nil do
begin
 while Tree^.Nb <> nil  do
 begin
  H:=Tree; Tree:=Tree^.Nb;  H^.Nb:=nil;
  {ClearNode(H);//H^.RData:=nil;H^.Expression:='';   H^.ExpressionArg:='';
  dispose(H); }
  FreeNode(H);
  while Tree^.Ch <> nil do
  begin
  Tree:=Tree^.Ch;
  end;
 //COP=NOP
 end;

//COP<>NOP
 H:=Tree; Tree:=Tree^.Pr; H^.Pr:=nil;
 FreeNode(H);
 {ClearNode(H); //H^.RData:=nil;H^.Expression:='';   H^.ExpressionArg:='';
 dispose(H); }
end;
{.193}
FreeNode(Tree);
{ClearNode(Tree); //Tree^.RData:=nil;Tree^.Expression:='';   Tree^.ExpressionArg:='';
dispose(Tree);}



endp:
Tree:=nil;
BeginTree:=nil;
end;






        //sin(x)^cos(x)
procedure TForevalH.FreeChld(PrntNode: PNode);
label endp;
var
H: PNode;
Tree: PNode;
begin
//if F_SyntaxErrorCode <> 0 then goto endp;
if PrntNode = nil  then goto endp;

Tree:=PrntNode^.Ch;

repeat
   H:=Tree;
   Tree:=Tree^.Nb;
   H^.RData:=nil;
   H^.Expression:='';
   H^.ExpressionArg:='';
   H^.SDiff:='';
   //H^.SFunc:='';
   H^.Ch:=nil;
   dispose(H);
until Tree = nil ;


PrntNode^.Ch:=nil;

endp:
end;


procedure TForevalH.FreeChldNode(Prnt: PNode; NChld: Integer);
var
Ch1,Ch2,LLCh,PrevNode,NextNode: PNode;
begin
//    Освобождает вытекающий узел(аргумент ) с номером NChld (и все из него)
//    Определена  только для NChld = 1 и  двуаргументной функции Prnt^.N =2 !!!
if Prnt^.N > 1 then
begin

  //sin(x)*((1+2/3)^((1+2/30)^x))
 { LLCh:=GetLowLevelNode(Prnt);
  PrevNode:=LLCh^.Prev; }


  if NChld = 1 then
  begin
     Ch1:=Prnt^.Ch;
     Ch2:=Ch1^.Nb;

     PrevNode:=Ch1^.Prev;



     NextNode:=Ch1^.Next;
     NextNode^.Prev:=PrevNode;
     if PrevNode <> nil then PrevNode^.Next:=NextNode;


     FreeNode(Ch1);
     Prnt^.Ch:=Ch2;
     Prnt^.Prev:=Ch2;

     Prnt^.N:=1;
  end;
end;



end;




procedure TForevalH.FreeChildTree(Prnt: PNode);
label endp;
var
H,Tree,PrevNode,NextNode,Chld,PrevCH,NextCH,LLCh,Node,HNode: PNode;
S: String;
NNode,db: Integer;
begin
if F_InternalError <> 0  then goto endp;  {.322}

{Prnt остается, удаляются только вытекающие узлы. }

if Prnt = nil then goto endp;
if Prnt^.Ch = nil then goto endp;


LLCh:=GetLowLevelNode(Prnt);
PrevNode:=LLCh^.Prev;
NextNode:=Prnt;

//db:=Prnt^.NNode;

{
Prnt^.Ch:=nil;
PrevNode^.Next:=NextNode;
NextNode^.Prev:=PrevNode;
 }



Node:=LLCh;
while Node <> Prnt do
begin
    HNode:=Node^.Next;
    FreeNode(Node);
    Node:=HNode;
end;

{.306}  //on
Prnt^.Ch:=nil;
if      PrevNode <> nil { = nil - LLCh первый узел в дереве}
  then  PrevNode^.Next:=NextNode
  else  Prnt^.Prev:=nil; {если LLCh первый узел в дереве, то после его удаления Prnt становится первым узлом в дереве}

NextNode^.Prev:=PrevNode;

//{.306} off
{
PrevNode^.Next:=NextNode;
NextNode^.Prev:=PrevNode;
}


(*
if Prnt = nil then goto endp;
if Prnt^.Ch = nil then goto endp;



LLCh:=GetLowLevelNode(Prnt);
PrevNode:=LLCh^.Prev;
NextNode:=Prnt;

//LastCh:=GetLastChld(Prnt);
//NextPrntCh:=LastCh^.Next;


Chld:=Prnt^.Ch;
while Chld <> nil do
begin
 H:=Chld^.Nb;

 //NNode:=Chld^.NNode;



 {if Chld = nil  then
 begin
  NNode:=Chld^.NNode;
  S:=Chld^.Expression;
 end
 else }
 FreeBranch(Chld);

{ PrevCH:=Chld^.Prev;
 NextCH:=Chld^.Next;
 PrevCH^.Next:=NextCH;
 NextCH^.Prev:=PrevCH;}

 {if Chld = nil  then
 begin
  NNode:=Chld^.NNode;
  S:=Chld^.Expression;
 end
 else}


{ ClearNode(Chld);
 dispose(Chld);
 Chld^.Pr:=nil;
 Chld^.Nb:=nil;
 Chld^.Ch:=nil;
 Chld^.Next:=nil;
 Chld^.Prev:=nil;
 Chld:=nil;
 }
 FreeNode(Chld);

 Chld:=H;
end;


Prnt^.Ch:=nil;
PrevNode^.Next:=NextNode;
NextNode^.Prev:=PrevNode;
*)

endp:
end;





procedure TForevalH.DelAndFreeThisNode(FNode: PNode);
var
 PrevNode,NextNode,NbNode,PrNode: PNode;
begin
(*
{
  Удаляет и освобождает узел FNode со всеми вытекающими из него узлами из дерева
  Все указатели и данные узлов на текущем уровне пересчитываются (S,N,)
}
 PrNode:=FNode^.Pr;
 //if PrNode^.Ch = nil  then
 PrevNode:=FNode^.Prev;
 NextNode:=FNode^.Next;
 NbNode:=FNode^.Nb;

 FreeChildTree(FNode); //освободить все  вытекающие из него узлы






 *)
end;


//(z1*(z3+z1)+z2/(z1-z3))/(x*(x-y)+z2*(x+y))+(z1*(z3+z1)+z2/(z1-z3))/(x*(x-y)+z2*(x+y))
// (z1*(z3+z1)+z2/(z1-z3))+(z1*(z3+z1)+z2/(z1-z3))
//(z1*(z3+z1)+z2/z1)+(z1*(z3+z1)+z2/z1)
//(z1*z3+z2/z1)+(z1*z3+z2/z1)

procedure TForevalH.FreeChildTreeA(Prnt: PNode);
label last,endp;
var
H,Prev,Tree,PrevNode,NextNode,Chld,PrevCH,NextCH,LLCh,LastCh,LastFreeNode: PNode;
S: String;
NumCh: Cardinal;
begin
if Tree = nil then goto endp;
if Prnt^.Ch = nil then goto endp;



LLCh:=GetLowLevelNode(Prnt);
PrevNode:=LLCh^.Prev;
NextNode:=Prnt;

Tree:=Prnt;
LastCh:=GetLastChld(Prnt);

if {Prnt^.Ch^.Nb = nil}Prnt^.Ch = LastCh then    {только один исходящий узел}
begin
   ClearNode(Prnt^.Ch);
   dispose(Prnt^.Ch);
   goto last;
end;


while Tree^.Ch <> nil do
begin
 Tree:=Tree^.Ch;
end;
//COP=NOP



LastFreeNode:=Tree;
while LastFreeNode <> LastCh do
begin
 //S:=Tree^.Expression;
 //if (Tree^.Pr = Prnt) and (Tree^.Nb = nil) then  goto last;

 while Tree^.Nb <> nil  do
 begin
  H:=Tree; LastFreeNode:=Tree;
  Tree:=Tree^.Nb;  H^.Nb:=nil;
  //S:=H^.Expression;
  ClearNode(H);//H^.RData:=nil;H^.Expression:='';   H^.ExpressionArg:='';
  dispose(H);
  H:=nil;
  while Tree^.Ch <> nil do
  begin
   Tree:=Tree^.Ch;
  end;
 //COP=NOP
 end;

//COP<>NOP
 H:=Tree;  LastFreeNode:=Tree;
 Tree:=Tree^.Pr; H^.Pr:=nil;
 //S:=H^.Expression;
 ClearNode(H); //H^.RData:=nil;H^.Expression:='';   H^.ExpressionArg:='';
 dispose(H);
 H:=nil;
end;

last: {Prnt node}
{
if Tree <> Prnt then
begin
   ClearNode(Tree);
   dispose(Tree);
end;
 }
{.193}
//S:=Tree^.Expression;
//ClearNode(Tree); //Tree^.RData:=nil;Tree^.Expression:='';   Tree^.ExpressionArg:='';
//dispose(Tree);
//Tree:=nil;

Prnt^.Ch:=nil;
PrevNode^.Next:=NextNode;
NextNode^.Prev:=PrevNode;

//Tree:=nil;
//BeginTree:=nil;
endp:
end;



procedure TForevalH.FreeBranch(BranchPrnt: PNode);
label endp;
var
H,PrevH,NextH,LastCh,LastFreeNode: PNode;
S: String;
NNode: Integer;
begin


if BranchPrnt = nil then goto endp;
if BranchPrnt^.Ch = nil then goto endp;

LastCh:=GetLastChld(BranchPrnt);


if {BranchPrnt^.Ch^.Nb = nil}BranchPrnt^.Ch = LastCh then    {только один исходящий узел}
begin
   {ClearNode(BranchPrnt^.Ch);
   dispose(BranchPrnt^.Ch);  }
   FreeNode(BranchPrnt^.Ch);
   goto endp;
end;


Tree:=BranchPrnt;

while Tree^.Ch <> nil do
begin
  Tree:=Tree^.Ch;
end;
 //z1/(x+z2)+z1/(x+z2)
 //(z1*(z3+z1)+z2/(z1-z3))/(x*(x-y)+z2*(x+y))+(z1*(z3+z1)+z2/(z1-z3))/(x*(x-y)+z2*(x+y))
// (z1*(z3+z1)+z2/(z1-z3))+(z1*(z3+z1)+z2/(z1-z3))

//S:=Tree^.Expression;



LastFreeNode:=Tree;
while LastFreeNode <> LastCh do
begin

  { if Tree = nil then
       S:= Tree^.Expression;    }


 while Tree^.Nb {Tree} <> nil  do
 begin

    H:=Tree; LastFreeNode:=Tree;
    Tree:=Tree^.Nb;
    FreeNode(H);

   while Tree^.Ch <> nil do
   begin
     Tree:=Tree^.Ch;
   end;


 end;



  H:=Tree;   LastFreeNode:=Tree;

  Tree:=Tree^.Pr;
  FreeNode(H);

end;

endp:
end;



procedure TForevalH.FreeReplacedNodes(NodeS: PNode);
var
NodeS1: PNode;
begin

   FreeChildTree(NodeS);

 (*
  NodeS1:=GetLowLevelNode(NodeS);
  while NodeS1 <> NodeS do
  begin
    NodeS1^.N:=0;
    NodeS1^.NFunc:=CM_NOP;
    NodeS1^.NF:=0;{.197}
    NodeS1^.TypeF:=0;
    NodeS1^.COP:=_NOP;   //только для аргументов замещаемой комманды
    NodeS1^.RRF:=rf_NO_REPLACE;//???????
    //FuncList[Interp[i].Code].FType:=0;
    NodeS1:=NodeS1^.Next;
  end;
  *)
end;


procedure TForevalH.ClearNode(Node: PNode);
var
S: String;
begin
if Node <> nil then
begin
   Node^.RData:=nil;
   Node^.Expression:='';
   Node^.ExpressionArg:='';
   Node^.ArgTypes:=nil;
   Node^.VFP:=nil;

  { SetLength(Vdbg,Length(Vdbg)+1);
   Vdbg[High(Vdbg)]:=Node^.NNode;  }
end;
end;



procedure TForevalH.FreeNode(Node: PNode);
var
S: String;
i,db: integer;
begin
if Node <> nil then
begin
   db:=Node^.NNode;
   Node^.RData:=nil;
   Node^.Expression:='';
   Node^.ExpressionArg:='';
   Node^.ArgTypes:=nil;
   Node^.VFP:=nil;
   for i :=0 to Length(Node^.AIVP1)-1  do
   begin
     Node^.AIVP1[i].NV:=nil
   end;
   //Node^.AIVP1:=nil;
   SetLength(Node^.AIVP1,0);
   Node^.Pr:=nil;
   Node^.Ch:=nil;
   Node^.Nb:=nil;
   Node^.Next:=nil;
   Node^.Prev:=nil;
   dispose(Node);
   Node:=nil;

  { SetLength(Vdbg,Length(Vdbg)+1);
   Vdbg[High(Vdbg)]:=Node^.NNode; }
end;
end;




procedure TForevalH.RenameFunction(Name,NewName: String);
label endp;
var
i: Integer;
begin

  for i:=0 to High(Alg.ExFunc) do
  begin
   if Name = Alg.ExFunc[i].Name then
   begin
    Alg.ExFunc[i].Name:=Copy(NewName,1,Length(NewName));
    goto endp;
   end;
  end;

endp:
end;



(*
procedure TForevalH.IntException;
var
S: String;
T: Integer;
begin


if F_BeginCalc = 0 then
begin
 {on E: EZeroDivide      do F_InternalError:=1;
 on E: EInvalidOp       do F_InternalError:=2;
 on E: EOverFlow        do F_InternalError:=3;
 on E: EUnderFlow       do F_InternalError:=4;
 on E: EIntOverFlow     do F_InternalError:=5;
 on E: EAccessViolation do F_InternalError:=6;
 on E: EOutOfMemory     do F_InternalError:=7;
 on E: EStackOverFlow   do F_InternalError:=8;}
 {if E.ClassType  = EZeroDivide       then F_InternalError:=1
 else
 if E.ClassType =  EInvalidOp        then F_InternalError:=2
 else
 if E.ClassType =  EOverFlow         then F_InternalError:=3
 else
 if E.ClassType =  EUnderFlow        then F_InternalError:=4
 else
 if E.ClassType =  EIntOverFlow      then F_InternalError:=5
 else
 if E.ClassType =  EAccessViolation  then F_InternalError:=6
 else
 if E.ClassType =  EOutOfMemory      then F_InternalError:=7
 else
 if E.ClassType =  EStackOverFlow    then F_InternalError:=8;
 }
end

else
if F_SyntaxErrorCode = 0 then
begin
 {if E.ClassType  = EZeroDivide       then F_CalcErrorCode:=1
 else
 if E.ClassType =  EInvalidOp        then F_CalcErrorCode:=2
 else
 if E.ClassType =  EOverFlow         then F_CalcErrorCode:=3
 else
 if E.ClassType =  EUnderFlow        then F_CalcErrorCode:=4
 else
 if E.ClassType =  EIntOverFlow      then F_CalcErrorCode:=5
 else
 if E.ClassType =  EAccessViolation  then F_CalcErrorCode:=6;}

 F_BeginCalc:=0;
end;



if (F_InternalError <> 0) and ((F_SyntaxErrorCode = 0 ) or (F_SyntaxErrorCode = E_INTERNAL_ERROR )) then
 begin

  {.195}
  if (F_InternalError = E_ZeroDivide) or (F_InternalError = E_InvalidOp) or (F_InternalError = E_OverFlow) then
  begin
    //F_SyntaxErrorString:=F_CurrentSubExpr;
    F_SyntaxErrorString:=F_CurrentEvalSubExpr; {.322}
    F_SyntaxErrorCode:= E_ERROR_AT_CALCULATION;  S:='INTERNAL ERROR AT CALCULATION';
  end
  else
  F_SyntaxErrorCode:= E_INTERNAL_ERROR;  S:='INTERNAL ERROR OR UNCATCHABLE SYNTAX ERROR';

 end;


if (F_CalcErrorCode <> 0) and (F_SyntaxErrorCode = 0 ) then
 begin
  F_SyntaxErrorCode:= E_ERROR_AT_CALCULATION;  S:='INTERNAL ERROR AT CALCULATION';
 end;


{
  fzSet(fz_ENABLE,fz_SHOW_EXCEPTION);
  fzSet(fz_DISABLE,fz_SHOW_EXCEPTION);

  allows/forbids to show an exception in case of a error  from '.dll'
}


if F_ShowException then
begin
 MessageBeep(MB_ICONHAND);
 {.155}
 {if F_CalcErrorCode <> 0 then
 begin
  //MessageDlg('Calculation Error',mtError,[mbOk],0)
  MessageBox(0,PChar(S+#13+#10+'"'+'Calculation Error'+'"'),PChar('ForevalZ error'),MB_ICONERROR);
 end
 else}
 if (F_SyntaxErrorCode <> 0) {and (F_SyntaxErrorCode <> 12)} then
 begin
  case F_SyntaxErrorCode of
    E_UNKNOWN_SYMBOL:                          S:='UNKNOWN SYMBOL or INCORRECT ARGUMENT or WRONG EXPRESSION';
    E_MISSING_ROUND_BRACKET:                   S:='MISSING ROUND BRACKET';
    E_MISSING_OPERATION:                       S:='MISSING OPERATION:';
    E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS:       S:='INCOINCIDENCE NUMBER OF ARGUMENTS:';
    E_MISSING_EXPRESSION:                      S:='MISSING EXPRESSION:';
    E_UNKNOWN_FUNCTION:                        S:='UNKNOWN FUNCTION:';
    E_UNKNOWN_ARRAY:                           S:='UNKNOWN ARRAY:';
    E_ABSENT_FUNCTION_FOR_LOAD_TYPE:           S:='ABSENT FUNCTION FOR LOAD TYPE:';
    E_NOT_DEFINED_OPERATION_FOR_TYPE:          S:='NOT DEFINED OPERATION '+'"'+F_SyntaxErrorStringA+'"'+' FOR TYPES:';
    E_NOT_DEFINED_FUNCTION_FOR_TYPE:           S:='NOT DEFINED FUNCTION '+'"'+F_SyntaxErrorStringA+'"'+' FOR TYPES:';
    E_INTERNAL_ERROR:                          S:='INTERNAL ERROR or  UNCATCHABLE SYNTAX ERROR';
    E_ERROR_AT_ADDITION_OF_FUNCTION:           S:='ERROR AT ADDITION OF FUNCTION';
    E_WRONG_TYPE:                              S:='WRONG TYPE';
    E_WRONG_NAME:                              S:='WRONG NAME';
    E_MISSING_SQUARE_BRACKET:                  S:='MISSING SQUARE BRACKET';
    E_MISSING_CURLY_BRACKET:                   S:='MISSING CURLY BRACKET';
    E_MISSING_ABS_BRACKET:                     S:='MISSING ABS BRACKET';
    E_MISSING_SEPARATOR:                       S:='MISSING SEPARATOR';
    E_WRONG_EXPRESSION:                        S:='WRONG EXPRESSION';
    E_ERROR_AT_CALCULATION:                    S:='INTERNAL ERROR AT CALCULATION';
    E_INCORRECT_ARGUMENT:                      S:='WRONG TYPE OF ARGUMENT'+'"'+F_SyntaxErrorStringA+'"';
    E_INCORRECT_SPACE:                         S:='INCORRECT SPACE';
    E_VARIABLE_REDECLARED:                     S:='VARIABLE REDECLARED';
    E_WRONG_PASSED_DATA:                       S:='WRONG PASSED DATA';
    E_NO_DIFF_EXPRESSION:                      S:='NO DIFF EXPRESSION';
  end;




  //MessageDlg(S+#13+#10+'"'+F_SyntaxErrorString+'"',mtError,[mbOk],0)
  MessageBox(0,PChar(S+#13+#10+'"'+F_SyntaxErrorString+'"'),PChar('Foreval error'),MB_ICONERROR);
 end
 {.155}
 {else
 if F_InternalError <> 0  then
 //MessageDlg('Internal Error',mtError,[mbOk],0)
 MessageBox(0,PChar(S+#13+#10+'"'+'Internal Error'+'"'),PChar('ForevalZ error'),MB_ICONERROR);
 }
end;


//if F_SyntaxErrorCode = 8  then F_SyntaxErrorString:=F_SyntaxErrorString1+'('+F_SyntaxErrorString+')';
//if F_SyntaxErrorCode = 9  then F_SyntaxErrorString:=F_SyntaxErrorString1+'('+F_SyntaxErrorString+')';
end;

*)


{.326}
procedure TForevalH.IntException;
var
S: String;
T: Integer;
begin


//if F_SyntaxErrorCode = E_INTERNAL_ERROR then    S:='INTERNAL ERROR OR UNCATCHABLE SYNTAX ERROR';

(*

if (F_InternalError <> 0) and ((F_SyntaxErrorCode = 0 ) or (F_SyntaxErrorCode = E_INTERNAL_ERROR )) then
 begin

  {.195}
  if (F_InternalError = E_ZeroDivide) or (F_InternalError = E_InvalidOp) or (F_InternalError = E_OverFlow) then
  begin
    //F_SyntaxErrorString:=F_CurrentSubExpr;
    F_SyntaxErrorString:=F_CurrentEvalSubExpr; {.322}
    F_SyntaxErrorCode:= E_ERROR_AT_CALCULATION;  S:='INTERNAL ERROR AT CALCULATION';
  end
  else
  F_SyntaxErrorCode:= E_INTERNAL_ERROR;  S:='INTERNAL ERROR OR UNCATCHABLE SYNTAX ERROR';

 end;


if (F_CalcErrorCode <> 0) and (F_SyntaxErrorCode = 0 ) then
 begin
  F_SyntaxErrorCode:= E_ERROR_AT_CALCULATION;  S:='INTERNAL ERROR AT CALCULATION';
 end;

 *)


{
  fzSet(fz_ENABLE,fz_SHOW_EXCEPTION);
  fzSet(fz_DISABLE,fz_SHOW_EXCEPTION);

  allows/forbids to show an exception in case of a error  from '.dll'
}


if F_ShowException then
begin
 MessageBeep(MB_ICONHAND);

 if (F_SyntaxErrorCode <> 0) then
 begin
  case F_SyntaxErrorCode of
    E_UNKNOWN_SYMBOL:                          S:='UNKNOWN SYMBOL or INCORRECT ARGUMENT or WRONG EXPRESSION';
    E_MISSING_ROUND_BRACKET:                   S:='MISSING ROUND BRACKET';
    E_MISSING_OPERATION:                       S:='MISSING OPERATION:';
    E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS:       S:='INCOINCIDENCE NUMBER OF ARGUMENTS:';
    E_MISSING_EXPRESSION:                      S:='MISSING EXPRESSION:';
    E_UNKNOWN_FUNCTION:                        S:='UNKNOWN FUNCTION:';
    E_UNKNOWN_ARRAY:                           S:='UNKNOWN ARRAY:';
    E_ABSENT_FUNCTION_FOR_LOAD_TYPE:           S:='ABSENT FUNCTION FOR LOAD TYPE:';
    E_NOT_DEFINED_OPERATION_FOR_TYPE:          S:='NOT DEFINED OPERATION '+'"'+F_SyntaxErrorStringA+'"'+' FOR TYPES:';
    E_NOT_DEFINED_FUNCTION_FOR_TYPE:           S:='NOT DEFINED FUNCTION '+'"'+F_SyntaxErrorStringA+'"'+' FOR TYPES:';
    E_INTERNAL_ERROR:                          S:='INTERNAL ERROR or  UNCATCHABLE SYNTAX ERROR';
    E_ERROR_AT_ADDITION_OF_FUNCTION:           S:='ERROR AT ADDITION OF FUNCTION';
    E_WRONG_TYPE:                              S:='WRONG TYPE';
    E_WRONG_NAME:                              S:='WRONG NAME';
    E_MISSING_SQUARE_BRACKET:                  S:='MISSING SQUARE BRACKET';
    E_MISSING_CURLY_BRACKET:                   S:='MISSING CURLY BRACKET';
    E_MISSING_ABS_BRACKET:                     S:='MISSING ABS BRACKET';
    E_MISSING_SEPARATOR:                       S:='MISSING SEPARATOR';
    E_WRONG_EXPRESSION:                        S:='WRONG EXPRESSION';
    E_INTERNAL_ERROR_AT_CALCULATION:           S:='INTERNAL ERROR AT CALCULATION';
    E_INCORRECT_ARGUMENT:                      S:='WRONG TYPE OF ARGUMENT'+'"'+F_SyntaxErrorStringA+'"';
    E_INCORRECT_SPACE:                         S:='INCORRECT SPACE';
    E_VARIABLE_REDECLARED:                     S:='VARIABLE REDECLARED';
    E_WRONG_PASSED_DATA:                       S:='WRONG PASSED DATA';
    E_NO_DIFF_EXPRESSION:                      S:='NO DIFF EXPRESSION';
    E_INTERNAL_ERROR_AT_DIFF:                  S:='INTERNAL ERROR AT DIFF or UNCATCHABLE SYNTAX ERROR';
    E_WRONG_SYMBOL:                            S:='WRONG SYMBOL';
    E_VOID_EXPRESSION:                         S:='VOID EXPRESSION';
    E_NO_RETURN_NUMBER:                        S:='NO RETURN NUMBER';
    E_PROHIBITED_SYMBOL:                       S:='PROHIBITED SYMBOL';
    E_NO_FUNCTION_ARGUMENT:                    S:='NO FUNCTION_ARGUMENT';
    E_NO_APPLICABLE_TO_EXTERNAL_ARRAY:         S:='NO APPLICABLE TO EXTERNAL ARRAY';
  end;




  //MessageDlg(S+#13+#10+'"'+F_SyntaxErrorString+'"',mtError,[mbOk],0)
  MessageBox(0,PChar(S+#13+#10+'"'+F_SyntaxErrorString+'"'),PChar('Foreval error'),MB_ICONERROR);
 end
 {.155}
 (*else
 if F_InternalError <> 0  then
 //MessageDlg('Internal Error',mtError,[mbOk],0)
 MessageBox(0,PChar(S+#13+#10+'"'+'Internal Error'+'"'),PChar('ForevalZ error'),MB_ICONERROR);
 *)
end;




//if F_SyntaxErrorCode = 8  then F_SyntaxErrorString:=F_SyntaxErrorString1+'('+F_SyntaxErrorString+')';
//if F_SyntaxErrorCode = 9  then F_SyntaxErrorString:=F_SyntaxErrorString1+'('+F_SyntaxErrorString+')';
end;






procedure TForevalH.SetLoadMem(Node: PNode);
var
NL,NM: Integer;
S,S1: String;
begin
 {
 Interp[I].SData:=_MEM;
 NM:=Interp[I].NM;
 NL:=Interp[I].NL;
 Interp[NM].RData[NL-1]:=_MEM;
 }
 Node^.SData:=_MEM;
 NL:=Node^.NL;
 Node^.Pr^.RData[NL-1]:=_MEM;

 //S:=Interp[i].Expression;        //db
 //S1:=Interp[NM].Expression;      //db
 inc(Db_DinLoadNMem);

end;




function TForevalH.EnableDL({I: Integer}Node: PNode): Boolean;
var
ifn: Integer;
NL,NM,NF,N: Integer;
S: String;
begin
//False - если аргументы выталкивать для данного узла нельзя
//COP = NOP
//для добавляемых ф-ий через FPU
(*if {Internal}FuncList[Interp[Interp[I].NM].Code].FType = -8 then EnableDL:=False
else
if Interp[I].Code = C_NOP then  EnableDL:=False
else
EnableDL:=True;*)

//EnableDL:=True;
//{.213}- для всех функций, не возвращающих число
{
  NM:=Interp[I].NM;
  //NL:=Interp[I].NL;
  N:=Interp[NM].NFunc;
  NF:=Interp[NM].NF;
  if Alg.ExFunc[N].Func[NF].TypeF = T_None then EnableDL:=False else EnableDL:=True;
}
  //NM:=Interp[I].NM;
  //NL:=Interp[I].NL;
  S:=Node^.Expression;
  N:=Node^.Pr^.NFunc; //N:=Interp[NM].NFunc;
  NF:=Node^.Pr^.NF;   //NF:=Interp[NM].NF;
  if Alg.ExFunc[N].Func[NF].TypeF = T_None then EnableDL:=False else EnableDL:=True;
end;


procedure TForevalH.SetNM;
label endp;
var
N: Integer;
HTree: PNode;
S: String;
begin
//инициализирует поле NM: номер массива главного узла, т.е.: Interp[Interp[i].NM]  -
//главный узел, где i - комманды уровня (исп-ся только в MUL,ADD,JMP)


if F_SyntaxErrorCode <> 0 then goto endp;

//new(Interp[0]);
Tree:=BeginTree; //не обязательно, т.к. чтение дерева - циклически


while Tree^.Ch <> nil do
begin
Tree:=Tree^.Ch;
end;
//COP=NOP:
N:=1;

while Tree^.Pr <> nil do
begin
  while Tree^.Nb <> nil  do
  begin
    Tree:=Tree^.Nb;
    while Tree^.Ch <> nil do
    begin
      Tree:=Tree^.Ch;
    end;
    //COP=NOP:
    inc(N);
  end;

 //COP<>NOP:
 S:=Tree^.Expression;
 Tree:=Tree^.Pr;
 inc(N);
 HTree:=Tree^.Ch;
 HTree^.NM:=N;
 HTree:=HTree^.Nb;
 while HTree <> nil do
 begin
  HTree^.NM:=N;
  HTree:=HTree^.Nb;
 end;

end;
Tree^.NM:=0;

endp:
end;






procedure TForevalH.SetNL;
label endp;
var
N: Integer;
HTree: PNode;
S: String;
begin
//инициализирует поле NL: порядковый номер  на уровне;


if F_SyntaxErrorCode <> 0 then goto endp;

Tree:=BeginTree; //не обязательно, т.к. чтение дерева - циклически

N:=0;

while Tree^.Ch <> nil do
begin
Tree:=Tree^.Ch;
end;
//COP=NOP:

while Tree^.Pr <> nil do
begin

  while Tree^.Nb <> nil  do
  begin
   Tree:=Tree^.Nb;
   while Tree^.Ch <> nil do
   begin
     Tree:=Tree^.Ch;
   end;
  //COP=NOP:
  inc(N);
  end;

//COP<>NOP:
  //S:=Tree^.Expression;
  Tree:=Tree^.Pr;
  N:=1;
  HTree:=Tree^.Ch;
  HTree^.NL:=N;
  HTree:=HTree^.Nb;
  while HTree <> nil do
  begin
    inc(N);
    HTree^.NL:=N;
    HTree:=HTree^.Nb;
   end;

end;

//в вершине '0' !!!
Tree^.NL:=0;
endp:
end;





//начальное заполнение: SData,RData[i] = _FPU
procedure TForevalH.SetLoadSource;
label endp;
var
i,LS,N: Integer;
HTree: PNode;
S: String;
begin
//инициализирует поля: SData,RData = _FPU и XCHA=0
LS:=_FPU;
if F_SyntaxErrorCode <> 0 then goto endp;

Tree:=BeginTree; //не обязательно, т.к. чтение дерева - циклически

while Tree^.Ch <> nil do
begin
Tree:=Tree^.Ch;
end;
//COP=NOP:
Tree^.SData:=LS;
Tree^.RData:=nil;
//Tree^.XchArg:=False;

while Tree^.Pr <> nil do
begin
 while Tree^.Nb <> nil  do
 begin
 Tree:=Tree^.Nb;
  while Tree^.Ch <> nil do
  begin
  Tree:=Tree^.Ch;
  end;
 //COP=NOP:
 Tree^.SData:=LS;
 Tree^.RData:=nil;
 //Tree^.XchArg:=False;
 end;

//COP<>NOP:
 Tree:=Tree^.Pr;
 Tree^.SData:=LS;
 //Tree^.XchArg:=False;
 N:=Tree^.Stack.N;
 SetLength(Tree^.RData,N);
 for i:=0 to High(Tree^.RData) do
 begin
  Tree^.RData[i]:=LS;
  //Tree^.XchArg:=False;
 end;

 //S:=Tree^.Expression;
end;

Tree^.SData:=_FPU;

endp:
end;






procedure TForevalH.InitCompiler(Mode: Integer);
begin
 N_Stack:=0;
 N_PrevStack:=0;
 SMAX:=0;
 //StackSize:=8;
 //F_StackDeep:=8;
  _MaxStack:=0;
 ES_Overflow:=False;
 //F_SaveInFPU:=True;
 //F_Mode:=Mode;
 F_EnableCheckStack:=True;
 F_Mode:=Mode;   {.197}
 //Db_DinLoadNMem:=0;
 //LFunc:=Length(Interp); {.213} {.233}
 F_JMP:=1;     {.213}
 N_DataCellNum:=0;
 F_IntermediateLastNode:=False; {.310}
 TE_ADDR:=0; {.357}  //иначе будет ложное срабатывание для try(), except() в  'if Db_WriteDataOverFlow = True then'
end;



procedure TForevalH.DinamicLoadOptimizator;
label 1,beginp,endp;
var
i,Pn,PML,ML,CNT,k,t2: Integer;
S,S1: String;
Node,MNode,MTNode: PNode;
begin
if F_SyntaxErrorCode <> 0 then goto endp;
if F_InternalError <> 0 then goto endp; {.322}

InitCompiler(M_DinamicLoad);
{F_Opt:=True;}
F_Mode:=M_DinamicLoad;
Db_DinLoadNMem:=0;
//if  F_DinamicLoadOptimization = _Enable then goto beginp;
//if  F_DinamicLoadOptimization = _Auto then
begin
 Db_DinLoadSDeep:=E_GetMaxStackEx;
 if Db_DinLoadSDeep > F_StackDeep then goto beginp else goto endp;
end;


//LFunc:=Length(Interp);     {.233}
beginp:
//CNT:=0;
if F_SyntaxErrorCode <> 0 then goto endp;
PML:=0; PN:=0;
1:
InitCompiler(M_DinamicLoad);
Node:=FirstNode;
//for i:=1 to LFunc-1 do
while Node <> nil do
begin
  //S:=Interp[i].Expression;      //db

  {if Node^.NNode = 95 then
  begin
    S:=Node^.Expression;
  end; }

  ML:=E_GetMaxLoadDL(Node);

  {если переполнение стека в рез-те выталкивания предыдущей комманды (I-1) не устранено, то
   продолжить выталкивание предыдущих комманд (I-2,...1) по одной до тех пор, пока есть
   переполнение в данной комманде (I)}
  if {(ML = PML)}(ML > F_StackDeep) and (MNode = Node{PN = I}) then
  begin

    //MTNode:=Node^.Prev^.Prev;

    {.345}
    MTNode := nil;
    if Node <> nil then
      if Node^.Prev <> nil then
        if Node^.Prev^.Prev <> nil then
           MTNode:=Node^.Prev^.Prev;

    //for k:=I-2 downto 1 do
    while MTNode <> nil do
    begin
       //if Interp[k].SData = _FPU then
       if MTNode.SData = _FPU then
       begin
         if EnableDL(MTNode{k}) then
         begin
          SetLoadMem(MTNode{k});
          goto 1;
         end;
       end;
       MTNode:=MTNode^.Prev;
    end;
    Db_DinLoadOverFlow:=True;
    //защита от зацикливания (возникает, если невозможно сделать загрузку стека < F_StackDeep:
    goto endp;
  end;

  {если произошло переполнение стека в текущем узле, то рез-т передыдущей (I-1) комманды
  выталкивается в память: (т.о. уменьшается на 1 загрузка стека)}
  if ML > F_StackDeep then
  begin
   if {I = 1} Node^.Prev = nil {Node^.NNode = 1} then
   begin
    Db_DinLoadOverFlow:=True;
    //защита от зацикливания:
    goto endp;
   end;
   if EnableDL(Node^.Prev{I-1}) then
   begin
    SetLoadMem(Node^.Prev{I-1});
    //PML:=ML;
    MNode:=Node;//PN:=I;
    goto 1;
   end;
  end;


  Node:=Node^.Next;
end;


endp:
if  (F_SaveInFPU = True) and (Db_DinLoadOverFlow = True) then
begin
  N_Stack:=0;
  _MaxStack:=0;
  ES_OverFlow:=False;
  F_SaveInFPU:=False;
  //FreeData;
  //Db_OverFlow:=True;
end;

//F_Opt:=False;
end;


(*
procedure TForevalH.DinamicLoadOptimizator;
label 1,beginp,endp;
var
i,Pn,PML,ML,CNT,k,t2: Integer;
S,S1: String;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

InitCompiler(M_DinamicLoad);
{F_Opt:=True;}
F_Mode:=M_DinamicLoad;
Db_DinLoadNMem:=0;
//if  F_DinamicLoadOptimization = _Enable then goto beginp;
//if  F_DinamicLoadOptimization = _Auto then
begin
 Db_DinLoadSDeep:=E_GetMaxStackEx;
 if Db_DinLoadSDeep > F_StackDeep then goto beginp else goto endp;
end;


LFunc:=Length(Interp);
beginp:
//CNT:=0;
if F_SyntaxErrorCode <> 0 then goto endp;
PML:=0; PN:=0;
1:
InitCompiler(M_DinamicLoad);
for i:=1 to LFunc-1 do
begin
  //S:=Interp[i].Expression;      //db

  ML:=E_GetMaxLoadDL(I);

  {если переполнение стека в рез-те выталкивания предыдущей комманды (I-1) не устранено, то
   продолжить выталкивание предыдущих комманд (I-2,...1) по одной до тех пор, пока есть
   переполнение в данной комманде (I)}
  if {(ML = PML)}(ML > F_StackDeep) and (PN = I) then
  begin
   for k:=I-2 downto 1 do
   begin
     if Interp[k].SData = _FPU then
     begin
      if EnableDL(k) then
      begin
       SetLoadMem(k);
       goto 1;
      end;

     end;
   end;
    Db_DinLoadOverFlow:=True;
    //защита от зацикливания (возникает, если невозможно сделать загрузку стека < F_StackDeep:
   goto endp;
  end;

  {если произошло переполнение стека в текущем узле, то рез-т передыдущей (I-1) комманды
  выталкивается в память: (т.о. уменьшается на 1 загрузка стека)}
  if ML > F_StackDeep then
  begin
   if I = 1 then
   begin
    Db_DinLoadOverFlow:=True;
    //защита от зацикливания:
    goto endp;
   end;
   if EnableDL(I-1) then
   begin
    SetLoadMem(I-1);
    PML:=ML;
    PN:=I;
    goto 1;
   end;
  end;


end;


endp:
if  (F_SaveInFPU = True) and (Db_DinLoadOverFlow = True) then
begin
  N_Stack:=0;
  _MaxStack:=0;
  ES_OverFlow:=False;
  F_SaveInFPU:=False;
  //FreeData;
  //Db_OverFlow:=True;
end;

//F_Opt:=False;
end;
*)




function TForevalH.E_GetMaxLoadDL(Node:PNode{I: Integer}): Integer;
begin
 E_SetNodeDL(Node);
 E_GetMaxLoadDL:=SMAX;
 //SetLength(ICOMP,0);  {.197}
end;




procedure TForevalH.E_SetNodeDL(Node: PNode);
var
Expr: String;
begin

{
      //Expr:=Interp[i].Expression; //db
NFunc:=I; //NFunc
SMAX:=N_Stack;
        //N1_Stack:=N_Stack;
AddCommand(I);
    //AddEndCommand(I);
       //SetLength(ICOMP,0);//.197

}

//Expr:=Interp[i].Expression; //db
GNode:=Node;//NFunc:=I; //NFunc
SMAX:=N_Stack;
AddCommand(Node);

end;




function TForevalH.E_GetMaxStackEx: Integer;
var
i: Integer;
Node: PNode;
begin
{
 for i:=1 to High(Interp) do
 begin
  E_SetNodeDL(i);
 end;
 E_GetMaxStackEx:=_MaxStack;
 }
 //SetLength(ICOMP,0);   {.197}

 Node:=FirstNode;
 while Node <> nil do
 begin
    E_SetNodeDL(Node);
    Node:=Node^.Next;
 end;
 E_GetMaxStackEx:=_MaxStack;

 N_MaxDataCell:=N_DataCellNum;
 F_EvalDataCell:=True;
end;




procedure TForevalH.CheckStack(N: Integer);
begin
 {$IFDEF DEBUGS}
    if N > 0  then dbFPULoad:=N+dbFPULoad;  //db
 {$ENDIF}

if F_EnableCheckStack then
 N_Stack:=N_Stack+N;

if N_Stack > {StackSize} F_StackDeep then {.300}
begin
 ES_OverFlow:=True;
end;


if N_Stack > _MaxStack
  then _MaxStack:=N_Stack;

if N_Stack > SMAX then SMAX:=N_Stack;

end;


procedure TForevalH.EvalDataCellNum;
label endp;
var
Node: PNode;
begin
if F_SyntaxErrorCode <> 0 then goto endp;
if F_InternalError <> 0 then goto endp; {.322}

 //вычисляет размерность массива под числовые константы
if (F_EvalDataCell = False) and (F_DataInArray = True) then
begin


 N_DataCellNum:=0;
 N_MaxDataCell:=0;
 F_EvalDataCell:=False;

 F_Mode:=M_EvalDataCellNum;
 InitCompiler(F_Mode);

 Node:=FirstNode;

 while Node <> nil do
 begin
   AddCommand(Node);
   Node:=Node^.Next;
 end;

 N_MaxDataCell:=N_DataCellNum;
 F_EvalDataCell:=True;

end;

endp:
end;


procedure TForevalH.Compile;
label recompile,2,endp;
var
i,j,N,alg,db,db1: Integer;
AH,AB: TArray4;
R: TFloat;
P: Pointer;
X: TFloat;
CS,LCode: Cardinal;
ANL: TArrayC;
S,S1: String;
AdrCmpl,AdrD,AdrS: Pointer;
AdrTst: TAddress;
Node: PNode;
begin
if F_SyntaxErrorCode <> 0 then goto endp;
if F_InternalError <> 0 then goto endp; {.322}

//каждый раз инициализация т.к. предыдущее выражение может сбросить F_SaveInFPU:
N_Stack:=0;
_MaxStack:=0;
//F_Opt:=False;
F_ExtFunc:=False;
ES_OverFlow:=False;
F_EnableCheckStack:=True;
F_Mode:=M_Compile;   {.197}
F_IntermediateLastNode:=False; {.310}

    {$IFDEF DEBUGS}
       dbMaxLoadCom:=0;
       TestZ.Form1.MT.Lines.Add('***********************************************************');
    {$ENDIF}

recompile:
new(FuncData); FuncData^.Next:=nil; BFuncData:=FuncData;
//LFunc:=Length(Interp);    {.233}
SetLength(ICOMP,0);
N_CurrentDataCell:=0;

for I := 1 to 8 do
begin
 REG[i]:=0;
 REGF[i]:=0;
end;


SetLength(GotoLab,0);

CS:=0;
F_JMP:=1;
TE_ADDR:=0;
//F_SaveInFPU:=False;
//PUSHAD;
Node:=FirstNode;
//while Node <> BeginTree do
while Node <> nil do //for i:=1 to LFunc-1 do               //(sin(z1/z2)+cos(x)^(z1/z2))
begin
   Node^.CS:=0;

   if Node^.COP <> _NOP then //if Interp[i].COP <> _NOP then     //COP=_NOP: только для аргументов замещаемой комманды //for(j,0,1,t=(x^2+x)*(x^2+x) ); t
   begin
      {$IFDEF DEBUGS}
         S:=Node^.Expression;
         db1:=Node^.SData1;
         if db1 = _MEM then S1:='SaveRes:MEM'  else if db1 = _FPU then S1:='SaveRes:FPU';
         dbFPUBefore:=N_Stack; dbFPULoad:=0;
      {$ENDIF}

      S:=Node^.Expression;
      //for(j,0,1,t=(x^2+x)*(x^2+x) ); t

      GNode:=Node;//NFunc:=i;
      Node^.NC:=Length(ICOMP);  //Interp[i].NC:=Length(ICOMP);

      AddCommand(Node{i});
      Node^.NCP:=Length(ICOMP);//Interp[i].NCP:=Length(ICOMP);
      CS:=Length(ICOMP)-CS;
      Node^.CS:=CS+GetLevelsCS(Node{i}); //Interp[i].CS:=CS+GetLevelsCS(i);
      CS:=Length(ICOMP);

      {$IFDEF DEBUGS}
        dbMaxLoadCom:=dbFPUBefore+dbFPULoad;
        TestZ.Form1.MT.Lines.Add('"'+S+'"   '+S1+'    loadFPUafter:'+IntToStr(N_Stack)+ '    MaxLoadFPU:'+IntToStr(_MaxStack{dbMaxLoadCom}));
      {$ENDIF}
  end;

  Node:=Node^.Next;
end;


//расстановка адресов переходов jmp adr
F_JMP:=2;
Node:=FirstNode;
//for i:=1 to LFunc-1 do
while Node <> nil do
begin
  GNode:=Node; //NFunc:=i;
  if Node^.NFunc = CM_JMP then JMP_C;//if Interp[i].NFunc = CM_JMP then JMP_C;
  Node:=Node^.Next;
end;

SaveMainRes; {.324}
SaveReg;
RET;
//POPAD;


//if  (F_SaveInFPU = True) and (_MaxStack > 8) and ({F_Opt = False}F_Mode=M_Compile) then
if  (F_SaveInFPU = True) and (ES_OverFlow = True) and (F_Mode = M_Compile) then    {.300}
begin
//может быть только в случае внутренней ошибки в DinamicLoadOptimizator: неверный расчет Load FPU => защита)
  N_Stack:=0;
  _MaxStack:=0;
  ES_OverFlow:=False;
  FreeData;
  //Db_OverFlow:=True;
  F_SaveInFPU:=False;
  Db_DinLoadOverFlow:=True;
  //S:=CurrentExpression;
  goto recompile;
end;


if F_UseVirtAlloc = False then    {.193}
begin
  //выравнивание кода на alg:
  alg:=16;
  SetLength(Func.Code,Length(ICOMP)+alg+1);
  for i:=0 to alg+1  do
  begin
   if Cardinal(@Func.Code[i]) mod alg = 0 then
   begin
    NAdr:=i;
    goto 2;
   end;
  end;
  2:
  for i:=0 to High(ICOMP) do begin
   Func.Code[i+NAdr]:=ICOMP[i];
  end;

  Func.Addr:=TAddress(@Func.Code[NAdr]);     {.193}
  Func.PAddr:=@Func.Code[NAdr];
  Func.CodeSize:=Length(ICOMP);
  Func.AllocMem:=1;
end
else   
{
  fzSet(fz_ENABLE, fz_USE_VIRTUAL_ALLOC); 
  allows memory for the  code  is allocated  out  by  the system command  instead: command 'SetLength' in a dynamic array.
{
//F_VirtAlloc = True   {.193}
begin     //only for WinXP SP2+;  memory alloc. only for exe code. Use, only if is any errors with standard memory allocating   (SetLength)
  LCode:=Length(ICOMP);
  AdrD:=VirtualAlloc(Nil, LCode, MEM_COMMIT or MEM_RESERVE, PAGE_EXECUTE_READWRITE);
  AdrS:=@ICOMP[0];
  CopyMemory(AdrD,AdrS,LCode);
  Func.Addr:=TAddress(AdrD);
  Func.PAddr:=AdrD;
  Func.CodeSize:=LCode;
  Func.AllocMem:=2;
end;

CodeSizeComplExpr:= Func.CodeSize; {.365}

ICOMP:=nil;
Func.Data:=BFuncData;

//PInteger(AdrCmpl)^:=Func.Addr;
{AdrTst:=Func.Addr;
asm
  push eax
  mov eax, AdrTst
  call eax

  pop  eax

end;  }

endp:
end;


procedure TForevalH.RET;
begin
AddByte($C3);
end;




procedure TForevalH.AddCommand(Node:PNode {I: Integer});
label endp,extf;
var
N,NF,RType,S,R,SDeep,CLS: Integer;
Expr: String;
begin

GNode:=Node;
//Expr:=Interp[i].Expression; //db
{
S:=Interp[I].S;
N:=Interp[NFunc].NFunc;
NF:=Interp[NFunc].NF;
InitMEM(Cardinal(@Interp[NFunc].MEM));
 }
S:=Node^.S;
N:=Node^.NFunc;
NF:=Node^.NF;


if Node^.COP = _LDSC then
begin
 FLD(WriteData(Node),F_DataType);
end
else
if Node^.COP = _LDSCX then
begin
  if Node^.TC = C_Real then
  begin
    FLD(WriteDataA(Node^.FDC.re,F_DataType),F_DataType)
  end
  else
  if Node^.TC = C_Image then
  begin
    FLD(WriteDataA(Node^.FDC.im,F_DataType),F_DataType);
    FLDZ;
  end
  else
  if {Interp[I]}Node^.TC = C_Complex then
  begin
    FLD(WriteDataA(Node^.FDC.im,F_DataType),F_DataType);
    FLD(WriteDataA(Node^.FDC.re,F_DataType),F_DataType);
  end;
end
else
if Node^.COP = _LDSF then
begin
 N:=Node^.NObj;
 LDSF_C(N);
end
else
if Node^.COP = _LDSA then    {.347}
begin
  //загрузка указателя в EAX
  LDSA_C;
end
{else
if Interp[I].COP = _JMP then
begin
 JMP_C(I);
end  }
else
if Node^.COP = _FLD then
begin
 FLD_C(Node);
end
else
if Node^.COP = _LDINTFORM then    {.309}
begin
 LoadLineFormEAX(_First);
end
else
if Node^.COP = _FUNC then
begin

 N:=Node^.NFunc;
 NF:=Node^.NF;

 if ReadReplFunc(Node) = True then   goto endp;       {.193}

 if Alg.ExFunc[N].Func[NF].IntF = _External then goto extf;

 case N of            //порядок следования в Alg.ExtFunc[N]
      CM_ADD:       ADD_C;
      CM_SUB:       SUB_C;
      CM_MUL:       MUL_C;
      CM_DIV:       DIV_C;
      CM_POWER:     POWER_C;
      CM_IPWR:      IPWR_C;
      CM_IPWR16:    IPWR16_C;
      CM_ROOT:      ROOT_C;
      CM_IROOT:     IROOT_C;
      CM_LOGN:      LOGN_C;
      CM_NEG:       NEG_C;
      CM_ABS:       ABS_C;
      CM_RE:        RE_C;
      CM_IM:        IM_C;
      CM_ARG:       ARG_C;
      CM_SIN:       SIN_C;
      CM_COS:       COS_C;
      CM_TAN:       TAN_C;
      CM_COTAN:     COTAN_C;
      CM_SEC:       SEC_C;
      CM_COSEC:     COSEC_C;
      CM_ARCCOS:    ARCCOS_C;
      CM_ARCSIN:    ARCSIN_C;
      CM_ARCTAN:    ARCTAN_C;
      CM_ARCCOTAN:  ARCCOTAN_C;
      CM_ARCSEC:    ARCSEC_C;
      CM_ARCCOSEC:  ARCCOSEC_C;
      CM_SINH:      SINH_C;
      CM_COSH:      COSH_C;
      CM_COSECH:    COSECH_C;
      CM_SECH:      SECH_C;
      CM_ARCSECH:   ARCSECH_C;
      CM_ARCCOSECH: ARCCOSECH_C;
      CM_TANH:      TANH_C;
      CM_COTANH:    COTANH_C;
      CM_ARCCOSH:   ARCCOSH_C;
      CM_ARCSINH:   ARCSINH_C;
      CM_ARCTANH:   ARCTANH_C;
      CM_ARCCOTANH: ARCCOTANH_C;
      CM_LN:        LN_C;
      CM_EXP:       EXP_C;
      CM_SQR:       SQR_C;
      CM_SQRT:      SQRT_C;
      CM_FACT:      FACT_C;
      CM_LOG10:     LOG10_C;
      CM_LOG2:      LOG2_C;
      CM_TRUNC:     TRUNC_C;
      CM_CON:       CON_C;
      CM_FRAC:      FRAC_C;
      CM_NORM:      NORM_C;
      CM_SUM:       SUM_C;
      CM_AVR:       AVR_C;
      CM_SUMQ:      SUMQ_C;
      CM_LEN:       LEN_C;
      CM_MAX:       MAX_C;
      CM_MIN:       MIN_C;
      CM_PROD:      PROD_C;
      CM_SUMI:      SUMI_C;
      CM_SIGN:      SGN_C;
      CM_IPWRSGN:   IPWRSGN_C;
      CM_REUNEGIPWR: REUNEGIPWR_C;
      CM_LDSVX:     LDSVX_C;
      CM_IF:        IFNOP_C;
      CM_FACT2:     FACT2_C;
      CM_SAVE:      SAVE_C;
      CM_JMP:       JMP_C;
      CM_INC:       INC_C;
      CM_DEC:       DEC_C;
      CM_DECART:    DECART_C;
      CM_DEG:       DEG_C;
      CM_RAD:       RAD_C;
      CM_DEV:       DEV_C;
      CM_DEVS:      DEVS_C;
      CM_ARCTAN2:   ARCTAN2_C;
      //CM_SINCOS:    SINCOS_C;
      CM_COSSIN:    COSSIN_C;
      CM_SWAP:      SWAP_C;
      CM_COMPLEX:   COMPLEX_C;
      CM_MOD:       MOD_C;
      CM_POLY:      POLY_C;
      CM_GCD:       GCD_C;
      CM_LCM:       LCM_C;
      CM_MAX23:     MAX23_C;
      CM_MIN23:     MIN23_C;
      CM_NORM23:    NORM23_C;
      CM_AVR23:     AVR23_C;
      CM_F2PWR:     F2PWR_C;
      CM_TRY:       TRY_C;
      CM_EXCEPTION: EXCEPTION_C;
      CM_POLYDIFF:  POLYDIFF_C;
      CM_SUMP:      SUMP_C;        {.333}
      CM_SUMPS:     SUMPS_C;       {.333}
      CM_CALLR:     CALL_C;       {.347}
      CM_CALLCX:    CALL_C;       {.347}
      CM_CALL:      CALL_C;       {.347}
      CM_POLYU:     POLYU_C;      {.347}
      CM_IDIV:      IDIV_C;
      CM_SWAPIF:    SWAP_C; //SWAPIF_C;     //для SWAPIF используется SWAP
      CM_PRODS:     PRODS_C;
      CM_IMUIPWR:   IMUIPWR_C;
      CM_CZPWR:     CZPWR_C;
      CM_IMURZPWR:  IMURZPWR_C;


 else
 //external functions
 begin
extf:
  if Alg.ExFunc[N].Func[NF].CallT = _STACK_ADDR then
  begin

     PushArgStackAdr;
     MOVAadr(Alg.ExFunc[N].Func[NF].Addr);
     CALLA;

     if Alg.ExFunc[N].Func[NF].Set_Id = 1 then CLS:=4 else CLS:=0;
     CLS:=CLS+Node^.Arg*4;
     if Alg.ExFunc[N].Func[NF].CLST = 1 then ADDESP(CLS);
  end
  else
  if Alg.ExFunc[N].Func[NF].CallT = _STACK_VAL then
  begin
     PushArgStackVal;
  end
  else
  if Alg.ExFunc[N].Func[NF].CallT = _MEMORY_ESP then
  begin

     LoadArgMem;

     if (Alg.ExFunc[N].Func[NF].Set_Id = _YES) and (Alg.ExFunc[N].Func[NF].ARROW = _RIGHT)
     then PUSHM(Alg.ExFunc[N].Func[NF].Id_Func);   {.302}

     PUSHM(GetStackAdr(S,_RE));

     if (Alg.ExFunc[N].Func[NF].Set_Id = _YES) and (Alg.ExFunc[N].Func[NF].ARROW = _BACK)
     then PUSHM(Alg.ExFunc[N].Func[NF].Id_Func);   {.302}

     MOVAadr(Alg.ExFunc[N].Func[NF].Addr);
     CALLA;
     if Alg.ExFunc[N].Func[NF].Set_Id = 1 then CLS:=4 else CLS:=0;
     CLS:=CLS+4;
     if Alg.ExFunc[N].Func[NF].CLST = 1 then ADDESP(CLS);   {.197}

  end
  else
  if Alg.ExFunc[N].Func[NF].CallT = _MEMORY_EAX then
  begin

     LoadArgMem;
     if (Alg.ExFunc[N].Func[NF].Set_Id = _YES) then PUSHM(Alg.ExFunc[N].Func[NF].Id_Func);   {.302}
     MOVAadr(GetStackAdr(S,_RE));
     MOVBadr(Alg.ExFunc[N].Func[NF].Addr);
     CALLB;
     if (Alg.ExFunc[N].Func[NF].Set_Id = _YES) then ADDESP(4);

  end
  else
  if Alg.ExFunc[N].Func[NF].CallT = _COMPILED then
    begin
     LoadArgPC;
     if (Alg.ExFunc[N].Func[NF].IsInline = _YES) and (F_EnableInline = True) then
        InsertInlineCode(Alg.ExFunc[N].Func[NF].Addr,Alg.ExFunc[N].Func[NF].CodeSize)
     else
     begin
        MOVAadr(Alg.ExFunc[N].Func[NF].Addr);
        CALLA;
     end;

    end

  else

  if Alg.ExFunc[N].Func[NF].CallT = _STACK_INFINITE then     //FUNC(ADR,LEN)
  begin

    LoadArgMemInf;
    if Alg.ExFunc[N].Func[NF].Arrow = _BACK then
    begin
      PUSHM(GetStackAdr(S,_RE));
      PUSHM(GNode^.Arg);
      if (Alg.ExFunc[N].Func[NF].Set_Id = _YES) then PUSHM(Alg.ExFunc[N].Func[NF].Id_Func);   {.302}
    end
    else
     if Alg.ExFunc[N].Func[NF].Arrow = _RIGHT then
    begin
      if (Alg.ExFunc[N].Func[NF].Set_Id = _YES) then PUSHM(Alg.ExFunc[N].Func[NF].Id_Func);   {.302}
      PUSHM(GNode^.Arg);
      PUSHM(GetStackAdr(S,_RE));
    end;
    MOVAadr(Alg.ExFunc[N].Func[NF].Addr);
    CALLA;
    if Alg.ExFunc[N].Func[NF].Set_Id = 1 then CLS:=4 else CLS:=0;
    CLS:=CLS+8;
    if Alg.ExFunc[N].Func[NF].CLST = 1 then ADDESP(CLS);

  end;
  {.316}//off
  (*
  else
  if (Alg.ExFunc[N].Func[NF].CallT = _STACK_INFINITE_A)  then     //FUNC(ADR,LEN,ADRT)
  begin

   if  {( Alg.ExFunc[N].Name <> 'nop')}(N <> CM_NOP) and (N <> CM_VOID) and (N <> CM_PROG) then       {.197}
   begin
     LoadArgMemInfA;
     if Alg.ExFunc[N].Func[NF].Arrow = _BACK then
     begin
       PUSHM(GetStackAdr(S,_RE));
       PUSHM({Interp[NFunc]}GNode^.Arg);
       //PUSHM(Cardinal(@Interp[I].ArgTypes[0]));  {.233}  //изменить !!!!!!!!!!!!!!!
     end
     else
     if Alg.ExFunc[N].Func[NF].Arrow = _RIGHT then
     begin
       //PUSHM(Cardinal(@Interp[I].ArgTypes[0]));  {.233}    //изменить !!!!!!!!!!!!!!!
       PUSHM({Interp[NFunc]}GNode^.Arg);
       PUSHM(GetStackAdr(S,_RE));
     end;
     MOVAadr(Alg.ExFunc[N].Func[NF].Addr);
     CALLA;
     if Alg.ExFunc[N].Func[NF].CLST = 1 then ADDESP(12);
   end;
  end;*)


   SDeep:=Alg.ExFunc[N].Func[NF].SDeep;
   SaveRegF;

   //fz_UNKNOWN
   if  SDeep = -1 then F_SaveInFPU:=False
   else
   begin
    if Alg.ExFunc[N].Func[NF].TypeF = T_Real then R:=1 else
    if Alg.ExFunc[N].Func[NF].TypeF = T_Complex then R:=2 else
    if Alg.ExFunc[N].Func[NF].TypeF = T_None then R:=0 else
    if Alg.ExFunc[N].Func[NF].TypeF = T_Array then R:=0 else
    if Alg.ExFunc[N].Func[NF].TypeF = T_Pointer then R:=0;


     //исключение для PROG т.к. TypeF меняется при разборе (<>T_None):
     if Node^.NFunc = CM_NOP then R:=0;
     if Node^.NFunc = CM_PROG then R:=0;  {.316}
     //исключение для IF т.к. загрузка стека учитывается в аргументах и команде #JMP :
     if Node^.NFunc = CM_IF then R:=0;   {.211}

    if R > SDeep then SDeep:=R;
    CheckStack(SDeep);

    if (Alg.ExFunc[N].Func[NF].TypeF = T_Real) and (SDeep > 1) then CheckStack(-(SDeep-1)) else
    if (Alg.ExFunc[N].Func[NF].TypeF = T_Complex) and (SDeep > 2) then CheckStack(-(SDeep-2));
    if Alg.ExFunc[N].Func[NF].TypeF = T_None then CheckStack(-SDeep); //для процедур: нет результата (+SDeep,-SDeep) {.211}

    //F_ExtFunc:=True;
     //SetReg(1); SetReg(2); SetReg(3); SetReg(4);
   end;
    F_ExtFunc:=True;





 end;

 end; //of case

  WriteReplFunc(Node);
end;


endp:
SaveResult(Node);
end;




procedure TForevalH.SaveResult(Node:PNode{I: Cardinal});
label endp;
var
S,N,NM,CallT,NF,dt,sh,Adr,tf,NL: Cardinal;
REA,IMA: TAddress;
NodePrnt: PNode;
begin

F_SData:=_FPU;
//аргументы с плавающей точкой этих комманд не выталкиваются в стек: сохраняютс в FPU:
//возвращаемый результат комманды IFNOP остаётся в стеке FPU (иначе IFNOP возвратит NAN)

if CheckIfRet(Node)    then goto endp;
if CheckNopRet(Node)   then goto endp;
//if CheckSaveRet(Node)  then goto endp;

 //{.353}аргументы T_Pointer, T_Array для SAVE сохраняются в стеке выражения (float vars остаются в FPU):
if (CheckSaveRet(Node) = True) and ((Node^.TypeF = T_Real) or (Node^.TypeF = T_Complex))  then goto endp;

if F_IntermediateLastNode = True then goto endp;  {.310}

//эти комманды не возвращают результат: (T_None)    {.197}
if Node^.TypeF = T_None then   goto endp;



if F_SaveInFPU = False then
begin


 //if I < LFunc-1 then
 if Node^.Pr <> nil  {Node <> BeginTree} {Node^.NNode < LFunc - 1}  then
 begin


   dt:=F_DataType;

   {S:=Interp[I].S;
   NM:=Interp[I].NM;
   NL:=Interp[I].NL;
   N:=Interp[NM].NFunc;
   NF:=Interp[NM].NF; }

   S:=Node^.S;
   NL:=Node^.NL;
   N:=Node^.Pr^.NFunc;
   NF:=Node^.Pr^.NF;

   REA:=GetStackAdr(S,_RE);
   IMA:=GetStackAdr(S,_IM);

   CallT:=Alg.ExFunc[N].Func[NF].CallT;

   //Args. push in stack [ESP]
   if  (CallT = _STACK_VAL)  then    {.304}
   begin
     SaveArgStackVal(Node);
     goto endp;
   end;

   if  (CallT = _STACK_ADDR) or (CallT = _COMPILED) or (CallT = _MEMORY_ESP) or (CallT = _MEMORY_EAX) then      {.309}
   begin
     case Node^.ExtArg of
      D_Real:          dt:=_Double;
      D_Complex:       dt:=_Double;
      E_Real:          dt:=_Extended;
      E_Complex:       dt:=_Extended;
      S_Real:          dt:=_Single;
      S_Complex:       dt:=_Single;
      D_Array_Real:    dt:=_Pointer;
      S_Array_Real:    dt:=_Pointer;
      E_Array_Real:    dt:=_Pointer;
      I_Array_Real:    dt:=_Pointer;
      I_Real:          dt:=_Integer;
      I_Pointer:       dt:=_Pointer;
     end;
   end;

   if (Node^.TypeF = T_Real) and (Node^.COP = _LDINTFORM) then {.309}  //EAX -> MEM
   begin
      MOVREGM(R_EAX,REA);
   end
   else
   if Node^.TypeF = T_Real then
   begin
    FSTPM({GetStackAdr(S,_RE)}REA,{F_DataType}dt);
   end
   else
   if Node^.TypeF = T_Complex then
   begin
           //RE-ST(0); IM-ST(1)
      if  (CallT = _STACK_ADDR) then            {.309}
      begin
         if  dt = _Double    then  sh:=sh_D else
         if  dt = _Extended  then  sh:=sh_E;
         FSTPM(REA,dt);
         FSTPM(REA+sh,dt);
      end
      else
      begin
         FSTPM({GetStackAdr(S,_RE)}REA,{F_DataType}dt);
         FSTPM({GetStackAdr(S,_IM)}IMA,{F_DataType}dt);
      end;

   end
   else
   if Node^.TypeF = T_Array then
   begin    {arraycpu}
     //FSTPM({GetStackAdr(S,_RE)}REA,_Pointer);
     //POPF(REA);       {.197}        {.223}

      {.353}   //выгрузка адреса массива из EAX в стек выражения:
      MOVREGM(R_EAX,REA);
   end
   else
   if Node^.TypeF = T_Pointer then
   begin    {arraycpu}

      {.353}   //выгрузка содержимого указателя из EAX в стек выражения:
      MOVREGM(R_EAX,REA);
   end;
 end
 else   //результат последней комманды остаётся в стеке
 begin
  tf:=Node^.TypeF;

  if F_CalcType = T_Complex then
  begin
    case tf of
     T_Real:    begin FLDZ; FXCH1; end;
     //T_Array:  begin FLDZ; FXCH1; end;     {arraycpu}{.223}
    end;
  end
  else
   if F_CalcType = T_Real then
   begin
     if tf = T_Complex then
     begin
      FXCH1;
      FSTP0;
     end;
   end;
 end;


end
else
//////////////////////////////
if F_SaveInFPU = True then
begin

 //if I < LFunc-1 then
 if  Node^.Pr <> nil  {Node <> BeginTree} {Node^.NNode < LFunc - 1}  then
 begin
   {S:=Interp[I].S;
   NM:=Interp[I].NM;
   NL:=Interp[I].NL;
   N:=Interp[NM].NFunc;
   NF:=Interp[NM].NF; }

   S:=Node^.S;
   NL:=Node^.NL;
   N:=Node^.Pr^.NFunc;
   NF:=Node^.Pr^.NF;

   CallT:=Alg.ExFunc[N].Func[NF].CallT;

   //аргументы добавл. ф-ий выталкиваются в память:
  if (Node^.SData = _MEM) or (Node^.ExtArg <> 0) then
  begin

   if  (CallT = _STACK_VAL) {or ((CallT = _COMPILED) and (Interp[I].SData = _MEM))}  {.197} then
   begin
     SaveArgStackVal(Node{i});     {.197}
   end
   else
   if  (CallT = _STACK_ADDR)  then
   begin
     SaveArgStackAdr(Node{i});
   end
   else
   if CallT = _COMPILED then
   begin
      SaveArgPC(Node{i});     {.197}
   end
   else
   if (CallT = _MEMORY_ESP) or (CallT = _MEMORY_EAX)  then
   begin
      SaveArgMemAdr(Node{i})     {.197}
   end
   else
   //остальные 'external functions' (CallT=...) или .SData=_MEM
   begin
     if (Node^.TypeF = T_Real) and (Node^.COP = _LDINTFORM) then {.309}  //EAX -> MEM
     begin
       MOVREGM(R_EAX,GetStackAdr(S,_RE));
     end
     else
     if Node^.TypeF = T_Real then
     begin
       FSTPM(GetStackAdr(S,_RE),F_DataType);
     end
     else
     if Node^.TypeF = T_Complex then
     begin       //RE-ST(0); IM-ST(1)
       FSTPM(GetStackAdr(S,_RE),F_DataType);
       FSTPM(GetStackAdr(S,_IM),F_DataType);
     end
     else {.197}
     if Node^.TypeF = T_Array then    {arraycpu}
     begin
      //FSTPM(GetStackAdr(S,_RE),_Pointer);  {.223}

       {.353}   //выгрузка адреса массива из EAX в стек выражения:
       MOVREGM(R_EAX,GetStackAdr(S,_RE));
     end
     else {.197}
     if Node^.TypeF = T_Pointer then    {arraycpu}
     begin
       {.353}   //выгрузка содержимого указателя из EAX в стек выражения:
       MOVREGM(R_EAX,GetStackAdr(S,_RE));
     end;

   end
  end   //(Node^.SData = _MEM) or (Node^.ExtArg <> 0)


  else  {.353} //для всех остальных: целочисленные аргументы, возращающие результат в EAX сохраняются в стеке выражения всегда!
  begin

     if (Node^.TypeF = T_Real) and (Node^.COP = _LDINTFORM) then {.309}  //EAX -> MEM
     begin
       MOVREGM(R_EAX,GetStackAdr(S,_RE));
     end
     else
     if Node^.TypeF = T_Array then    {arraycpu}
     begin
      //FSTPM(GetStackAdr(S,_RE),_Pointer);  {.223}
      {.353}   //выгрузка адреса массива из EAX в стек выражения:
       MOVREGM(R_EAX,GetStackAdr(S,_RE));
     end
     else {.197}
     if Node^.TypeF = T_Pointer then    {arraycpu}
     begin
       {.353}   //выгрузка содержимого указателя из EAX в стек выражения:
       MOVREGM(R_EAX,GetStackAdr(S,_RE));
     end;

  end;

 end


 else   //результат последней комманды остаётся в стеке
 begin

      tf:=Node^.TypeF;

      if F_CalcType = T_Complex then
      begin
        case tf of
          T_Real:    begin FLDZ; FXCH1; end;
        // T_Array:  begin FLDZ; FXCH1; end;     {arraycpu}{.223}
        end;
      end
      else
      if F_CalcType = T_Real then
      begin
        if tf = T_Complex then
        begin
         FXCH1;
         FSTP0;
        end;
      end;

      //T_Array,T_Pointer,_LDINTFORM - остаются в EAX (если не являются аргументами добавляемых ф-ий)
 end;

end;

endp:
Node^.SData1:=F_SData;
end;



function TForevalH.CheckIfRet(Node: PNode{N: Integer}): Boolean;
begin
 {
  if Interp[Interp[N].NM].NFunc = CM_IF then
     begin
       if (Interp[N].NL = 4) or (Interp[N].NL = 6) then   CheckIfRet:=True
       else
       CheckIfRet:=False;
     end
  else
  CheckIfRet:=False;  }

  if Node^.Pr = nil then
  begin
    CheckIfRet:=False;
  end
  else
  begin
   if Node^.Pr^.NFunc = CM_IF then
     begin
       if (Node^.NL = 4) or (Node^.NL = 6) then   CheckIfRet:=True
       else
       CheckIfRet:=False;
     end
   else
   CheckIfRet:=False;
  end;
end;


function TForevalH.CheckNopRet(Node: PNode{N: Integer}): Boolean;
begin
//является аргументом NOP
//является аргументом PROG  {.316}
 { if Interp[Interp[N].NM].NFunc = CM_NOP then
  begin
    CheckNopRet:=True;
    SetLength(GotoLab,Length(GotoLab)+1);
    GotoLab[High(GotoLab)]:=NFunc;
  end
   else CheckNopRet:=False;   }
  if Node^.Pr = nil then
  begin
    CheckNopRet:=False;
  end
  else
  begin                       {.316}
    if Node^.Pr^.NFunc = {CM_NOP}CM_PROG then
    begin
     CheckNopRet:=True;
     SetLength(GotoLab,Length(GotoLab)+1);
     GotoLab[High(GotoLab)]:=Node;
    end
    else CheckNopRet:=False;
  end;
end;


function TForevalH.CheckSaveRet(Node: PNode{N: Integer}): Boolean;
begin
  {if Interp[Interp[N].NM].NFunc = CM_SAVE then CheckSaveRet:=True
   else CheckSaveRet:=False; }

  if Node^.Pr = nil then
  begin
    CheckSaveRet:=False;
  end
  else
  begin
    if Node^.Pr^.NFunc = CM_SAVE then CheckSaveRet:=True
     else CheckSaveRet:=False;
  end;
end;



function TForevalH.ReadReplFunc(Node: PNode{i: integer}): Boolean;
begin
//полное замещение:
if Node^.RRF = rf_FULL_REPLACE then
  begin
    if Node^.TypeF = T_Real then
    begin
     FLD(TAddress(@Func.RFStack[Node^.MRF]),F_DataType);
    end
    else
    if Node^.TypeF = T_Complex then
    begin
      FLD(TAddress(@Func.RFStack[Node^.MRF]),F_DataType);
      FLD(TAddress(@Func.RFStack[Node^.MRF-1]),F_DataType);
    end;
     ReadReplFunc:=True;
  end
  else
  ReadReplFunc:=False;
end;


procedure TForevalH.WriteReplFunc(Node: PNode{i: integer});
var
L: integer;
Addr: TAddress;
begin
//полное сохранение:
if (Node^.WRF = rf_FULL_REPLACE) then
 begin
  if Node^.TypeF = T_Real then
  begin
   Addr:=TAddress(@Func.RFStack[Node^.MRF]);
   FSTM(Addr,F_DataType);
  end
  else
  if Node^.TypeF = T_Complex then
  begin
   Addr:=TAddress(@Func.RFStack[Node^.MRF-1]);
   FSTM(Addr,F_DataType);
   FXCH1;
   Addr:=TAddress(@Func.RFStack[Node^.MRF]);
   FSTM(Addr,F_DataType);
   FXCH1;
  end
 end;
end;



function TForevalH.GetStackAdr(S,RT: Integer): Cardinal;
var
H: Integer;
begin
if F_Mode = M_Compile then        {.197}
begin
  if RT = _RE then GetStackAdr:=Cardinal(@Func.Stack[S].re)
  else
  if RT = _IM then GetStackAdr:=Cardinal(@Func.Stack[S].im);

    {DB}
    H:=High(Func.Stack);
    if (S < 0) or ( S > H) then
    begin
      Db_WriteStackDataOverFlow:=True;
    end;

end
else
GetStackAdr:=0;
end;





procedure TForevalH.LoadArgSTACK;
var
S,N,NF,j,Adr,Adr1,Adr2,tm,Arg: Cardinal;
sh,i: Integer;
begin
 N:=GNode^.NFunc;//N:=Interp[NFunc].NFunc;
 NF:=GNode^.NF;//NF:=Interp[NFunc].NF;
 S:=GNode^.S;//S:=Interp[NFunc].S;
 Arg:=GNode^.Arg;

 Adr:=GetStackAdr(S,_RE);
 j:=0;
 SetLength(Sadr,0);
 sh:=10;
//перезагрузка аргументов
 for i:=0 to  Arg-1 {Interp[NFunc].Arg-1} do
  begin
   //if Alg.ExFunc[N].Func[NF].TM[i] <> F_DataType then   // если '=', то арг-ты не перегружаются
   begin
    if Alg.ExFunc[N].Func[NF].TV[i]  =  T_Real then
    begin
      tm:=Alg.ExFunc[N].Func[NF].TM[i];
      Adr:=GetStackAdr(S+i,_RE);
       {.309}//off
     { if F_SaveInFPU = False then
      begin
       FLD(Adr,F_DataType);
       FSTPM(Adr,tm);
      end; }
      SetLength(SAdr,Length(SAdr)+1);   SAdr[High(SAdr)]:=Adr;
    end
    else
    if Alg.ExFunc[N].Func[NF].TV[i]  =  T_Complex then
    begin
       tm:=Alg.ExFunc[N].Func[NF].TM[i];
       Adr1:=GetStackAdr(S+i,_RE);  Adr2:=GetStackAdr(S+i,_IM);
        {.309}//off
       {
       if F_SaveInFPU = False then
       begin
        FLD(Adr2,F_DataType);
        FLD(Adr1,F_DataType);
        FSTPM(Adr1,tm);
        sh:=8; if tm = _Extended then sh:=16;
        FSTPM(Adr1+sh,tm);
       end;
       }
        SetLength(SAdr,Length(SAdr)+1);  SAdr[High(SAdr)]:=Adr1;
    end
    else
    if Alg.ExFunc[N].Func[NF].TV[i]  =  T_Array then
    begin
      //tm:=Alg.ExFunc[N].Func[NF].TM[i];
      Adr:=GetStackAdr(S+i,_RE);
       {.309}//off
     { if F_SaveInFPU = False then
      begin
       FILD(Adr);
       FISTP(Adr);
      end;  }
      SetLength(SAdr,Length(SAdr)+1);   SAdr[High(SAdr)]:=Adr;
    end;
   end;
 end;
end;




procedure TForevalH.LoadArgMEM;
var
S,N,NF,j,Adr,vs,Arg: Cardinal;
sh,i: Integer;
begin
if F_SaveInFPU = False then     {.197}
begin

  {
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 Arg:=GNode^.Arg;


 Adr:=GetStackAdr(S,_RE);
 j:=0;
sh:=sh_E;
//перезагрузка (уплоинение) аргументов   (из стека(32) в стек(16))
 for i:=0 to  Arg-1{Interp[NFunc].Arg-1} do
  begin
    if Alg.ExFunc[N].Func[NF].TV[i]  =  T_Real then
    begin
      vs:=Alg.ExFunc[N].Func[NF].TM[i];
      FLD(GetStackAdr(S+i,_RE),{F_DataType}vs);{.309}
      FSTPM(Adr+j*sh,vs);
      inc(j);
    end
    else
    if Alg.ExFunc[N].Func[NF].TV[i]  =  T_Complex then
    begin
      vs:=Alg.ExFunc[N].Func[NF].TM[i];
      FLD(GetStackAdr(S+i,_IM),{F_DataType}vs); {.309}
      FLD(GetStackAdr(S+i,_RE),{F_DataType}vs);  {.309}
      FSTPM(Adr+j*sh,vs);
      inc(j);
      FSTPM(Adr+j*sh,vs);
      inc(j);
    end
    else
    if Alg.ExFunc[N].Func[NF].TV[i]  =  T_Array then    {.197}
    begin      {arraycpu}
      {FLD(GetStackAdr(S+i,_RE),_Pointer);
      FSTPM(Adr+j*sh,_Pointer); }

      {PUSHF(GetStackAdr(S+i,_RE)) ;
      POPF(Adr+j*sh);}

       MOVMREG(R_EAX,GetStackAdr(S+i,_RE));             {.309}
       MOVREGM(R_EAX,Adr+j*sh);

      inc(j);
    end
 end;

end;
end;



procedure TForevalH.LoadArgPC;
var
S,N,NF,j,Adr,TM,TV,NL,Arg: Cardinal;
sh,k,i: Integer;
AddrM,AddrS: TAddress;
begin

  {
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 NL:=Interp[NFunc].NL;
 S:=Interp[NFunc].S;
  }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 NL:=GNode^.NL;
 Arg:=GNode^.Arg;

 Adr:=GetStackAdr(S,_RE);
 (*
  {.309}
  //перезагрузка аргументов
 for i:=0 to  Arg-1 do
  begin
    TV:=Alg.ExFunc[N].Func[NF].TV[i];
    if  (TV =  T_Real) then
    begin
      TM:=Alg.ExFunc[N].Func[NF].TM[i];
      FLD(GetStackAdr(S+i,_RE),TM);
      FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[i],TM);
    end
    else
    if TV  =  T_Complex then
    begin
      TM:=Alg.ExFunc[N].Func[NF].TM[i];
      FLD(GetStackAdr(S+i,_RE),TM);
      FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[i],TM);
      FLD(GetStackAdr(S+i,_IM),TM);
      if TM = _Double   then FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[i]+SH_D,TM) else
         if TM = _Extended then FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[i]+SH_E,TM)
    end
    else
    if   (TV = T_Array) then
    begin   {arraycpu}
      {FLD(GetStackAdr(S+i,_RE),_Pointer);
      FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[i],_Pointer); }
      PUSHF(GetStackAdr(S+i,_RE));                        {.197}
      POPF(Alg.ExFunc[N].Func[NF].ArgAdr[i]);
    end
 end;
 *)


if F_SaveInFPU = True then
begin

  //т.к. в FPU-стеке запись наоборот:
  for k:={Interp[NFunc].Arg}Arg downto 1 do
  begin

      TV:=Alg.ExFunc[N].Func[NF].TV[k-1];
      TM:=Alg.ExFunc[N].Func[NF].TM[k-1];

      if  (TV =  T_Real)  then
      begin

         if (TM = _Integer) or (TM = _Pointer) then  {.357}
         begin
            MOVMREG(R_EAX,GetStackAdr(S+k-1,_RE));
            MOVREGM(R_EAX,Alg.ExFunc[N].Func[NF].ArgAdr[k-1]);
         end
         else
         begin
            if GNode^.RData[k-1] = _MEM then
               FLD(GetStackAdr(S+k-1,_RE),TM);

            FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[k-1],TM);
         end;

      end
      else
      if   TV = T_Array then      {arraycpu}
      begin
         {FLD(GetStackAdr(S+k-1,_RE),_Pointer);
         FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[k-1],_Pointer); }  {.197}

         {PUSHF(GetStackAdr(S+k-1,_RE));
         POPF(Alg.ExFunc[N].Func[NF].ArgAdr[k-1]);}

         MOVMREG(R_EAX,GetStackAdr(S+k-1,_RE));             {.309}
         MOVREGM(R_EAX,Alg.ExFunc[N].Func[NF].ArgAdr[k-1]);
      end
      else
      if  (TV =  T_Pointer)  then     {.357}
      begin
            MOVMREG(R_EAX,GetStackAdr(S+k-1,_RE));
            MOVREGM(R_EAX,Alg.ExFunc[N].Func[NF].ArgAdr[k-1]);
      end
      else
      if TV  =  T_Complex then
      begin
         if GNode^.RData[k-1] = _MEM then//if Interp[NFunc].RData[k-1] = _MEM then
         begin
            FLD(GetStackAdr(S+k-1,_RE),TM);
            FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[k-1],TM);
            FLD(GetStackAdr(S+k-1,_IM),TM);
            if TM = _Double   then FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[k-1]+SH_D,TM) else
               if TM = _Extended then FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[k-1]+SH_E,TM) else
                   if TM = _Single then FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[k-1]+SH_S,TM)
         end
         else  //in _FPU
         begin
            FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[k-1],TM);
            if TM = _Double   then FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[k-1]+SH_D,TM) else
               if TM = _Extended then FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[k-1]+SH_E,TM) else
                  if TM = _Single then FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[k-1]+SH_S,TM)
         end;
      end;

  end;

end
else
if F_SaveInFPU = False then      {.197}

begin

  {
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 NL:=Interp[NFunc].NL;
 S:=Interp[NFunc].S;
 }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 NL:=GNode^.NL;
 Arg:=GNode^.Arg;

 Adr:=GetStackAdr(S,_RE);

//перезагрузка аргументов
 for i:=0 to  Arg-1{Interp[NFunc].Arg-1} do
  begin
    TV:=Alg.ExFunc[N].Func[NF].TV[i];
    if  (TV =  T_Real) then
    begin

      TM:=Alg.ExFunc[N].Func[NF].TM[i];
      FLD(GetStackAdr(S+i,_RE),TM);
      FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[i],TM);

    end
    else
    if TV  =  T_Complex then
    begin
      TM:=Alg.ExFunc[N].Func[NF].TM[i];
      FLD(GetStackAdr(S+i,_RE),TM);
      FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[i],TM);
      FLD(GetStackAdr(S+i,_IM),TM);
      if TM = _Double   then FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[i]+SH_D,TM) else
         if TM = _Extended then FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[i]+SH_E,TM) else
             if TM = _Single then FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[i]+SH_S,TM)
    end
    else
    if   (TV = T_Array) then
    begin   {arraycpu}
      {FLD(GetStackAdr(S+i,_RE),_Pointer);
      FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[i],_Pointer); }

      {PUSHF(GetStackAdr(S+i,_RE));
      POPF(Alg.ExFunc[N].Func[NF].ArgAdr[i]); }

       MOVMREG(R_EAX,GetStackAdr(S+i,_RE));             {.309}
       MOVREGM(R_EAX,Alg.ExFunc[N].Func[NF].ArgAdr[i]);
    end
    else
    if  (TV =  T_Pointer)  then     {.357}
    begin
        MOVMREG(R_EAX,GetStackAdr(S+i,_RE));
        MOVREGM(R_EAX,Alg.ExFunc[N].Func[NF].ArgAdr[i]);
    end
 end;

end;


end;


procedure TForevalH.LoadArgMEMInf;
var
S,N,NF,j,Adr,vs,Arg: Cardinal;
sh,i: Integer;
begin
{
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 Arg:=GNode^.Arg;

 Adr:=GetStackAdr(S,_RE);
 j:=0;
sh:=sh_E;
//перезагрузка (уплотнение) аргументов из стека 32 в стек 16
if {Interp[NFunc].Arg}Arg = 0 then
begin
  {FLDZ;
  FSTPM(Adr,Alg.ExFunc[N].Func[NF].TM[0]);}
end
else
 for i:=0 to Arg-1 {Interp[NFunc].Arg-1} do
  begin
    if Alg.ExFunc[N].Func[NF].TV[0]  =  T_Real then
    begin
      vs:=Alg.ExFunc[N].Func[NF].TM[0];
      FLD(GetStackAdr(S+i,_RE),F_DataType);
      FSTPM(Adr+j*sh,vs);
      inc(j);
    end
    else
    if Alg.ExFunc[N].Func[NF].TV[0]  =  T_Complex then
    begin
      vs:=Alg.ExFunc[N].Func[NF].TM[0];
      FLD(GetStackAdr(S+i,_IM),F_DataType);
      FLD(GetStackAdr(S+i,_RE),F_DataType);
      FSTPM(Adr+j*sh,vs);
      inc(j);
      FSTPM(Adr+j*sh,vs);
      inc(j);
    end;
 end;
end;



procedure TForevalH.LoadArgMEMInfA;
var
S,N,NF,j,Adr,vs,Arg: Cardinal;
sh,i: Integer;
begin
{
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 Arg:=GNode^.Arg;

 Adr:=GetStackAdr(S,_RE);
 j:=0;
sh:=sh_E;
//перезагрузка (уплотнение) аргументов из стека 32 в стек 16
 for i:=0 to  Arg-1{Interp[NFunc].Arg-1} do
  begin
    if GNode^.ArgTypes[i]  =  T_Real then //if Interp[NFunc].ArgTypes[i]  =  T_Real then
    begin
      vs:=Alg.ExFunc[N].Func[NF].TM[0];
      FLD(GetStackAdr(S+i,_RE),F_DataType);
      FSTPM(Adr+j*sh,vs);
      inc(j);
    end
    else
    if GNode.ArgTypes[i]  =  T_Complex then //if Interp[NFunc].ArgTypes[i]  =  T_Complex then
    begin
      vs:=Alg.ExFunc[N].Func[NF].TM[0];
      FLD(GetStackAdr(S+i,_IM),F_DataType);
      FLD(GetStackAdr(S+i,_RE),F_DataType);
      FSTPM(Adr+j*sh,vs);
      inc(j);
      FSTPM(Adr+j*sh,vs);
      inc(j);
    end;
 end;
end;



procedure TForevalH.PUSHArgSTACK;
var
S,N,NF,j,Adr,vs,Arg: Cardinal;
i: integer;
begin
{
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 Arg:=Interp[NFunc].Arg;
 }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 Arg:=GNode^.Arg;

 j:=0;


if Alg.ExFunc[N].Func[NF].Arrow = _BACK then
begin
  for i:=0 to  Arg-1 do
  begin
   PUSHM(Sadr[i]);
  end;
  if (Alg.ExFunc[N].Func[NF].Set_Id = _YES) then PUSHM(Alg.ExFunc[N].Func[NF].Id_Func);   {.302}
end
else
if Alg.ExFunc[N].Func[NF].Arrow = _RIGHT then
begin
  if (Alg.ExFunc[N].Func[NF].Set_Id = _YES) then PUSHM(Alg.ExFunc[N].Func[NF].Id_Func);   {.302}
  for i:=Arg-1 downto  0 do
  begin
    PUSHM(SAdr[i]);
  end;
end;


end;




procedure TForevalH.PushArgStackAdr;
begin
  LoadArgStack;
  PushArgStack;
end;



// by value only for 'STDCALL' or 'CDECL'
procedure TForevalH.PUSHArgStackVal;
var
S,N,NF,i,j,Adr,vs,Arg,TM,TV,DS,CS,cn: Cardinal;
k: integer;

        (*

        procedure PUSHARG(TV,TM,Sh{,arw}: Integer);
        var
        S: Cardinal;
        begin                         //Sh - номер переменой
           S:=GNode^.S; //S:=Interp[NFunc].S;

           if TM = _Double then
           begin

            if TV = T_Complex  then     //для "pascal" не работает, т.к. передается адрес, а не числа
            begin
                {if arw = _RIGHT then
                 begin  }
                  PUSHF(GetStackAdr(S+Sh,_IM)+4);
                  PUSHF(GetStackAdr(S+Sh,_IM));
                  PUSHF(GetStackAdr(S+Sh,_RE)+4);
                  PUSHF(GetStackAdr(S+Sh,_RE));
                 {end
                 else
                 begin
                   PUSHF(GetStackAdr(S+Sh,_RE));
                 end; }
            end
            else
            if TV = T_Real  then
            begin
              PUSHF(GetStackAdr(S+Sh,_RE)+4);
              PUSHF(GetStackAdr(S+Sh,_RE));
            end
            else
            if TV = T_Array  then
            begin
              PUSHF(GetStackAdr(S+Sh,_RE));
            end
           end
           else
           if TM = _Extended then
           begin

            if TV = T_Complex  then               //для "pascal" не работает, т.к. передается адрес, а не числа
            begin

              //так компилирует Delphi (выравнивание на 16)
              PUSHF(GetStackAdr(S+Sh,_IM)+12);
              PUSHF(GetStackAdr(S+Sh,_IM)+8);
              PUSHF(GetStackAdr(S+Sh,_IM)+4);
              PUSHF(GetStackAdr(S+Sh,_IM));


              PUSHF(GetStackAdr(S+Sh,_RE)+12);
              PUSHF(GetStackAdr(S+Sh,_RE)+8);
              PUSHF(GetStackAdr(S+Sh,_RE)+4);
              PUSHF(GetStackAdr(S+Sh,_RE));
            end
            else
            if TV = T_Real then
            begin
              PUSHF(GetStackAdr(S+Sh,_RE)+8);
              PUSHF(GetStackAdr(S+Sh,_RE)+4);
              PUSHF(GetStackAdr(S+Sh,_RE));
            end
            else
            if TV = T_Array  then
            begin
              PUSHF(GetStackAdr(S+Sh,_RE));
            end;

           end
           else
           if TM = _Integer then
           begin
             PUSHF(GetStackAdr(S+Sh,_RE));
           end;
        end;

       *)
begin
  {
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 Arg:=Interp[NFunc].Arg;
 }
 (*
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 Arg:=GNode^.Arg;

 j:=0;


DS:=0;
//DS - определение глубины стека для передаваемых аргументов:
 for k:=0 to  Arg-1 do
 begin
   CS:=0;
   TV:=Alg.ExFunc[N].Func[NF].TV[k];
   TM:=Alg.ExFunc[N].Func[NF].TM[k];

   if TV = T_Array then   CS:=4      {.197}
   else
   begin
     case TM of
     _Integer:     CS:=4;
     _Pointer:     CS:=4;
     _Double:     CS:=8;
     _Extended:   CS:=12;  //12 -  (12 вместо 10) - так компилирует DELPHI
     end;
     case TV of
     T_Real:      CS:=CS;
     T_Complex:   CS:=CS*2;
     end;
   end;



    DS:=DS+CS;
    if (TM = _Extended) and (TV = T_Complex) then DS:=DS+8; //16+16;выравнивание на 16

 end;

    if Alg.ExFunc[N].Func[NF].Set_Id = _YES then DS:=DS+4;


if (Alg.ExFunc[N].Func[NF].Set_Id = _YES) and (Alg.ExFunc[N].Func[NF].ARROW = _RIGHT)
   then PUSHM(Alg.ExFunc[N].Func[NF].Id_Func);   {.302}

//загрузка аргументов в стек:
 for k:= 0 to Arg-1 do
 begin
  if Alg.ExFunc[N].Func[NF].ARROW = _BACK then cn:=k
  else
  if Alg.ExFunc[N].Func[NF].ARROW = _RIGHT then cn:=Arg-1-k;

  TV:=Alg.ExFunc[N].Func[NF].TV[cn];
  TM:=Alg.ExFunc[N].Func[NF].TM[cn];

  PUSHARG(TV,TM,cn{,Alg.ExFunc[N].Func[NF].ARROW});
 end;

if (Alg.ExFunc[N].Func[NF].Set_Id = _YES) and (Alg.ExFunc[N].Func[NF].ARROW = _BACK)
   then PUSHM(Alg.ExFunc[N].Func[NF].Id_Func);   {.302}



MOVAadr(Alg.ExFunc[N].Func[NF].Addr);
CALLA;
if Alg.ExFunc[N].Func[NF].CLST = 1 then ADDESP(DS);

*)


{.304}
//transfer args. by values work only for stdcall & cdecl !!!

N:=GNode^.NFunc;
NF:=GNode^.NF;
S:=GNode^.S;
Arg:=GNode^.Arg;


DS:=0;
//DS - определение глубины стека для передаваемых аргументов:
 for k:=0 to  Arg-1 do
 begin
   CS:=0;
   TV:=Alg.ExFunc[N].Func[NF].TV[k];
   TM:=Alg.ExFunc[N].Func[NF].TM[k];

   if TV = T_Array then   CS:=4      {.197}
   else
   begin
     case TM of
     _Integer:     CS:=4;
     _Single:      CS:=4;
     _Pointer:     CS:=4;
     _Double:      CS:=8;
     _Extended:    CS:=12;  //12 -  (12 вместо 10) - так компилирует DELPHI
     end;
     case TV of
     T_Real:      CS:=CS;
     T_Complex:   CS:=CS*2;
     T_Pointer:   CS:=CS;
     end;
   end;



    DS:=DS+CS;
    if (TM = _Extended) and (TV = T_Complex) then DS:=DS+8; //16+16;выравнивание на 16

 end;

 if Alg.ExFunc[N].Func[NF].Set_Id = _YES then DS:=DS+4;

 {.304}
 //ID передается последним  при вызовах  'stdcall' & 'cdecl' !!! (в 'pascal' не работает)
if (Alg.ExFunc[N].Func[NF].Set_Id = _YES)  {and (Alg.ExFunc[N].Func[NF].ARROW = _BACK)} then
begin
  if Arg >= 1 then
  begin
     MOVCREG(R_EAX,Alg.ExFunc[N].Func[NF].Id_Func);
     MOVESPEAX(DS-4);
  end
  else
  if Arg = 0 then
     PUSHM(Alg.ExFunc[N].Func[NF].Id_Func);
end;




MOVAadr(Alg.ExFunc[N].Func[NF].Addr);
CALLA;
if Alg.ExFunc[N].Func[NF].CLST = 1 then ADDESP(DS);

end;




procedure TForevalH.ADD_C;
var
t1,t2,N,NF,S,st1,st2,Arg,nv1,nv2,xchT: Integer;
XchArg: Boolean;

  procedure ADD_DL;      //S1+S2 (F_SaveInFPU = True)
  begin
    if (t1 = T_Real) and (t2 = T_Real) then        //t2,t1
    begin
        if (st1 = _FPU) and (st2 = _FPU) then
        begin
           FADDP
        end
        else
        if (st1 = _FPU) and (st2 = _MEM) then
        begin
           FADD(GetStackAdr(S+1,_RE),F_DataType)
        end
        else
        if (st1 = _MEM) and (st2 = _FPU) then
        begin
           FADD(GetStackAdr(S,_RE),F_DataType)
        end
        else
        if (st1 = _MEM) and (st2 = _MEM) then
        begin
          FLD(GetStackAdr(S,_RE),F_DataType);
          FADD(GetStackAdr(S+1,_RE),F_DataType);
        end;
    end
    else
    if (t1 = T_Real) and (t2 = T_Complex) then            //x,y,r
    begin
       if (st1 = _FPU) and (st2 = _FPU) then
       begin
          FADDP2;
          FXCH1;
       end
       else
       if (st1 = _FPU) and (st2 = _MEM) then
       begin
         FADD(GetStackAdr(S+1,_RE),F_DataType);
         FLD(GetStackAdr(S+1,_IM),F_DataType);
         FXCH1;
       end
       else
       if (st1 = _MEM) and (st2 = _FPU) then
       begin
         FADD(GetStackAdr(S,_RE),F_DataType)
       end
       else
       if (st1 = _MEM) and (st2 = _MEM) then
       begin
         FLD(GetStackAdr(S+1,_IM),F_DataType);
         FLD(GetStackAdr(S+1,_RE),F_DataType);
         FADD(GetStackAdr(S,_RE),F_DataType);
       end;
    end
    else
    if (t1 = T_Complex) and (t2 = T_Real) then
    begin
       if (st1 = _FPU) and (st2 = _FPU) then
       begin
         FADDP;
       end
       else
       if (st1 = _FPU) and (st2 = _MEM) then
       begin
         FADD(GetStackAdr(S+1,_RE),F_DataType);
       end
       else
       if (st1 = _MEM) and (st2 = _FPU) then
       begin
         FADD(GetStackAdr(S,_RE),F_DataType);
         FLD(GetStackAdr(S,_IM),F_DataType);
         FXCH1;
       end
       else
       if (st1 = _MEM) and (st2 = _MEM) then
       begin
         FLD(GetStackAdr(S,_IM),F_DataType);
         FLD(GetStackAdr(S,_RE),F_DataType);
         FADD(GetStackAdr(S+1,_RE),F_DataType);
       end;
    end
    else
    if (t1 = T_Complex) and (t2 = T_Complex) then
    begin
       if (st1 = _FPU) and (st2 = _FPU) then
       begin
         FADDP2;
         FADDP2;
       end
       else
       if (st1 = _MEM) and (st2 = _MEM) then
       begin
         FLD(GetStackAdr(S,_IM),F_DataType);
         FADD(GetStackAdr(S+1,_IM),F_DataType);
         FLD(GetStackAdr(S,_RE),F_DataType);
         FADD(GetStackAdr(S+1,_RE),F_DataType);
       end
       else
       if (st1 = _FPU) and (st2 = _MEM) then
       begin
         FADD(GetStackAdr(S+1,_RE),F_DataType);
         FXCH1;
         FADD(GetStackAdr(S+1,_IM),F_DataType);
         FXCH1;
       end
       else
       if (st1 = _MEM) and (st2 = _FPU) then
       begin
         FADD(GetStackAdr(S,_RE),F_DataType);
         FXCH1;
         FADD(GetStackAdr(S,_IM),F_DataType);
         FXCH1;
       end;
    end;
  end;

  procedure ADD_ST;       //S1+S2 (F_SaveInFPU = False)
  begin
   if (t1 = T_Real) and (t2 = T_Real) then
   begin
    FLD(GetStackAdr(S,_RE),F_DataType);
    FADD(GetStackAdr(S+1,_RE),F_DataType);
   end
   else
   if (t1 = T_Real) and (t2 = T_Complex) then
   begin
    FLD(GetStackAdr(S+1,_IM),F_DataType);
    FLD(GetStackAdr(S+1,_RE),F_DataType);
    FADD(GetStackAdr(S,_RE),F_DataType);
   end
   else
   if (t1 = T_Complex) and (t2 = T_Real) then
   begin
    FLD(GetStackAdr(S,_IM),F_DataType);
    FLD(GetStackAdr(S,_RE),F_DataType);
    FADD(GetStackAdr(S+1,_RE),F_DataType);
   end
   else
   if (t1 = T_Complex) and (t2 = T_Complex) then
   begin
    FLD(GetStackAdr(S,_IM),F_DataType);
    FADD(GetStackAdr(S+1,_IM),F_DataType);
    FLD(GetStackAdr(S,_RE),F_DataType);
    FADD(GetStackAdr(S+1,_RE),F_DataType);
   end;
  end;


  procedure ADD_VAR;                             //v1+v2
  var
    nv1,nv2,tv1,tv2,tm1,tm2,sh1,sh2: Integer;
    Adr1,Adr2,adr1RE,adr1IM,adr2RE,adr2IM: Cardinal;
  begin
   {nv1:=Interp[NFunc].nv1;
   nv2:=Interp[NFunc].nv2;  }
   nv1:=GNode^.NV1;
   nv2:=GNode^.NV2;

   {
   GetVar(nv1,adr1,tv1,tm1);
   GetVar(nv2,adr2,tv2,tm2);
   if (tm1 = _Extended) then sh1:=SH_E else sh1:=SH_D;
   if (tm2 = _Extended) then sh2:=SH_E else sh2:=SH_D;
   }

   GetVar2(nv1,adr1RE,adr1IM,tv1,tm1);   {.343}
   GetVar2(nv2,adr2RE,adr2IM,tv2,tm2);   {.343}
   Adr1:=Adr1RE; Adr2:=Adr2RE;           {.343}

   if (tv1 = T_Real) and (tv2 = T_Real) then
   begin
     FLD(Adr1,tm1);  //FLDV(nv1);
     FADD(Adr2,tm2); //FADDV(nv2,tv2);
   end
   else
   if (tv1 = T_Real) and (tv2 = IM_UNIT) then
   begin
     FLD1;
     FLD(Adr1,tm1);
   end
   else
   if (tv1 = T_Real) and (tv2 = T_Complex) then
   begin
     FLDV(nv2);
     FADD(Adr1,tm1); //FADDV(nv1);
   end
   else
   if (tv1 = IM_UNIT) and (tv2 = T_Real) then
   begin
     FLD1;
     FLD(Adr2,tm2); //FLDV(nv2);
   end
   else
   if (tv1 = T_Complex) and (tv2 = T_Real) then
   begin
     FLDV(nv1);
     FADD(Adr2,tm2);  //FADDV(nv2);
   end
   else
   if (tv1 = T_Complex) and (tv2 = T_Complex) then
   begin
     {.343}
     {FLD(Adr1+sh1,tm1); FADD(Adr2+sh2,tm2);
     FLD(Adr1,tm1);     FADD(Adr2,tm2); }
     FLD(Adr1IM,tm1);     FADD(Adr2IM,tm2);
     FLD(Adr1RE,tm1);     FADD(Adr2RE,tm2);
   end
   else
   if (tv1 = IM_UNIT) and (tv2 = T_Complex) then
   begin
     FLDV_IM(nv2); FLD1; FADDP;
     FLDV_RE(nv2);
   end
   else
   if (tv1 = T_Complex) and (tv2 = IM_UNIT) then
   begin
     FLDV_IM(nv1); FLD1; FADDP;
     FLDV_RE(nv1);
   end
   else
   if (tv1 = IM_UNIT) and (tv2 = IM_UNIT) then
   begin
     FLD1; FLD1; FADDP;
     FLDZ;
   end

  end;

 /////////////////////////////////MAIN//////////////////////////////////////////
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 Arg:=Interp[NFunc].N; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 Arg:=GNode^.N;

 t1:=Alg.ExFunc[N].Func[NF].TV[0]; t2:=Alg.ExFunc[N].Func[NF].TV[1];

 {
 st1:=Interp[NFunc].RData[0]; st2:=Interp[NFunc].RData[1];
 nv1:=Interp[NFunc].NV1;
 nv2:=Interp[NFunc].NV2;
 }
 st1:=GNode^.RData[0]; st2:=GNode^.RData[1];
 nv1:=GNode^.NV1;
 nv2:=GNode^.NV2;

 //if (Arg = 1) and (Interp[NFunc].TypeA <> 0) then  t1:=Interp[NFunc].TypeA;
 if (Arg = 1) and (GNode^.TypeA <> 0) then  t1:=GNode^.TypeA;

 XchArg:=GNode^.XchArg;
 if XchArg = True then
 begin
   xchT:=t1;
   t1:=t2;
   t2:=xchT;
 end;





 if F_SaveInFPU = False then
 begin
   if (Arg = 2) and (nv1 = -1) and (nv2 = -1) then         //S1+S2
   begin
    ADD_ST;
   end
   else
   if (Arg = 0) and (nv1 >= 0) and (nv2 >= 0) then         //v1+v2
   begin
      ADD_VAR;
   end
   else
   if (Arg = 1) and  (nv1 >= 0)     then                   //S+v1
   begin
    FLDS(0,_MEM);  FADDV(nv1,t1)
   end
   else
   if (Arg = 1) and  (nv1 = -1) and (nv2 = -1)  then       //S1+c
   begin
    FLDS(0,_MEM); FADD(WriteData(GNode{NFunc}),F_DataType);
   end
   else
   if (Arg = 0) and (nv2 = -1)    then                     //v+c
   begin
     FLD(WriteData(GNode{NFunc}),F_DataType);
     FADDV(nv1,T_Real);
   end
 end
 else
 if F_SaveInFPU = True then
 begin
   if (Arg = 2) and (nv1 = -1) and (nv2 = -1) then         //S1+S2
   begin
    ADD_DL;
   end
   else
   if (Arg = 0) and (nv1 >= 0) and (nv2 >= 0) then         //v1+v2
   begin
      ADD_VAR
   end
   else
   if (Arg = 1) and  (nv1 >= 0)     then                   //S+v1
   begin
    FLDS(0);  FADDV(nv1,t1)
   end
   else
   if (Arg = 1) and  (nv1 = -1) and (nv2 = -1)  then       //S1+c
   begin
    FLDS(0); FADD(WriteData(GNode{NFunc}),F_DataType);
   end
   else
   if (Arg = 0) and (nv2 = -1)    then                     //v+c
   begin
     FLD(WriteData(GNode{NFunc}),F_DataType);
     FADDV(nv1,T_Real);
   end;
 end;


end;




procedure TForevalH.FLDV(nv: Integer);
var
 Adr: Cardinal;
 tv,tm: Integer;
begin
 GetVar1(nv,Adr,tv,tm);
 if  tv = T_Real    then FLDV_RE(nv)//FLD(Adr,tm)
 else
 if tv = T_Complex  then
 begin
   FLDV_IM(nv);
   FLDV_RE(nv);
 end
 else
 if tv = IM_UNIT then
 begin
   FLD1;
   FLDZ;
 end;
end;





procedure TForevalH.LDSF_C(N: Integer);
var
NFunc,NF,CallT: Integer;
begin
   //Node^ = Interp[NFunc]

 if Alg.Obj[N].TypeF = T_Real then
 begin
  if (GNode^.TS = 0) or (GNode^.TS = _RE) then
     FLD(Alg.Obj[N].Addr,Alg.Obj[N].MType)
  else
  if GNode^.TS = _IM then
     FLDZ;
 end
 else
 if Alg.Obj[N].TypeF = T_Complex then
 begin
  if GNode^.TS = 0 then
  begin
    {if Alg.Obj[N].MType = _Double then
     FLD(Alg.Obj[N].Addr+sh_D,Alg.Obj[N].MType)        //Sh_D = 8
    else
    if Alg.Obj[N].MType = _Extended then
     FLD(Alg.Obj[N].Addr+sh_E,Alg.Obj[N].MType);     //Sh_E = 16

    FLD(Alg.Obj[N].Addr,Alg.Obj[N].MType);  }

    {.343}
    FLD(Alg.Obj[N].AddrIM,Alg.Obj[N].MType);
    FLD(Alg.Obj[N].Addr,Alg.Obj[N].MType);
  end
  else
  if GNode^.TS = _RE then
  begin
    FLD(Alg.Obj[N].Addr,Alg.Obj[N].MType);
  end
  else
  if GNode^.TS = _IM then
  begin
    {
    if Alg.Obj[N].MType = _Double then
     FLD(Alg.Obj[N].Addr+sh_D,Alg.Obj[N].MType)     //Sh_D = 8
    else
    if Alg.Obj[N].MType = _Extended then
     FLD(Alg.Obj[N].Addr+sh_E,Alg.Obj[N].MType);     //Sh_E = 16
     }
     {.343}
     FLD(Alg.Obj[N].AddrIM,Alg.Obj[N].MType);
  end
 end
 else
 //Pointer: Vector
 if Alg.Obj[N].TypeF = T_Array then
 begin   {arraycpu}
   //FILD(Alg.Obj[N].Addr);

   //PUSHF(Alg.Obj[N].Addr);     {.197}




  (*
  if (GNode^.ExtArg <> 0) then
  begin
      NFunc:=GNode^.Pr^.NFunc;
      NF:=GNode^.Pr^.NF;
      CallT:=Alg.ExFunc[NFunc].Func[NF].CallT;
  end;

   //загрузка адреса массива сразу в стек выражения   {.223}, кроме ф-ий  _STACK_VAL,...
  if  (CallT <> _STACK_VAL)  then
  begin
     if (F_SaveInFPU = True) and  ((CallT = _MEMORY_EAX) or (CallT = _MEMORY_ESP)) then     {.309}
     begin
       {}
     end
     else
     begin
       {
       PUSHF(Alg.Obj[N].Addr);
       POPF(GetStackAdr(GNode^.S,_RE));
       }
       //Addr:=Alg.Obj[GNode^.NObj].Addr;
       MOVMREG(R_EAX,Alg.Obj[N].Addr);
       MOVREGM(R_EAX,GetStackAdr(GNode^.S,_RE));
     end;
  end;
  *)

    //загрузка адреса массива  в EAX   {.353}
     MOVMREG(R_EAX,Alg.Obj[N].Addr);
     //MOVREGM(R_EAX,GetStackAdr(GNode^.S,_RE));

 end
 (*
 else
 if Alg.Obj[N].TypeF = T_Pointer then
   begin   {arraycpu}
    //загрузка содержимого указателя  в EAX   {.353}
     MOVMREG(R_EAX,Alg.Obj[N].Addr);
 end;
 *)

end;





procedure TForevalH.LDSA_C;
var
NFunc,NF,CallT,N: Integer;
Addr: TAddress;

t1,S,nv,TM,TA,NM,NA,TMA,tva: Integer;
AdrM,AdrA,Num: Cardinal;
begin


   {arraycpu}
   //FILD(Alg.Obj[N].Addr);
   //PUSHF(Alg.Obj[N].Addr);     {.197}


   Addr:=GNode^.Addr1;

  (*
  if (GNode^.ExtArg <> 0) then
  begin
      NFunc:=GNode^.Pr^.NFunc;
      NF:=GNode^.Pr^.NF;
      CallT:=Alg.ExFunc[NFunc].Func[NF].CallT;
  end;
   //загрузка адреса массива сразу в стек выражения   {.223}, кроме ф-ий  _STACK_VAL,...
  if  (CallT <> _STACK_VAL)  then
  begin
     if (F_SaveInFPU = True) and  ((CallT = _MEMORY_EAX) or (CallT = _MEMORY_ESP)) then     {.309}
     begin
       {}
     end
     else
     begin
       {
       PUSHF(Alg.Obj[N].Addr);
       POPF(GetStackAdr(GNode^.S,_RE));
       }
       //Addr:=Alg.Obj[GNode^.NObj].Addr;
       MOVMREG(R_EAX,Addr);
       MOVREGM(R_EAX,GetStackAdr(GNode^.S,_RE));
     end;
  end;
 *)


  //загрузка указателя  в EAX   {.353}
   if (GNode^.AI = _AddrVar) then      //@var -> EAX
   begin
         MOVAadr(Addr);
   end
   else
   if (GNode^.AI = _AddrFunc) then     //@Func -> EAX
   begin
         MOVAadr(Addr);
   end
   else
   if (GNode^.AI = _AddrArray) then       //@vec -> EAX
   begin
        {
        MOVAadr(AddrObj);
        //MOVAA;   //вычисление и передача адреса нулевого элемента массива
        MOVESPEAX(SZ);
        }
        //
         //MOVMREG(R_EAX,Addr);
         MOVCREG(R_EAX,Addr);
   end
   else
   if GNode^.AI = _PointerVar then
   begin   {arraycpu}
     //загрузка содержимого указателя  в EAX   {.353}
      N:=GNode^.NObj;
      MOVMREG(R_EAX,Alg.Obj[N].Addr);
   end
   else
   if GNode^.AI = _PointerArray then           //Vec[indx]-> EAX (Vec = array of Pointer)
   begin   {arraycpu}
     //загрузка содержимого указателя  в EAX   {.353}

      //MOVMREG(R_EAX,Alg.Obj[N].Addr);


       N:=GNode^.NObj;
       AdrM:=Alg.Obj[N].Addr;
       //TM:=Alg.Obj[NM].MType;


       if GNode^.CI = 0 then     //Vec[Trunc(Stack)]
       begin
          LoadArg1;
          TRUNCR(R_ECX);
         //trunc
         (*
          PUSHCW;    {.227}
          FLDCW(TAddress(@FCW1));
          MEM:=WriteDataA(0,_Integer);
          FISTP(MEM);
          POPCW;    {.227} //FLDCW(TAddress(@FCW2));
          MOVMC(MEM);
          *)
      end
      else
      if GNode^.CI = 2 then    //Vec[float_var]
      begin
         GetVar1(GNode^.NV1,AdrA,tva,TMA);
         if (TMA = _Double) or (TMA = _Extended) or (TMA = _Single) then
         begin
            FLDV(GNode^.NV1);
            TRUNCR(R_ECX);
            (*
            PUSHCW;    {.227}
            FLDCW(TAddress(@FCW1));
            MEM:=WriteDataA(0,_Integer);
            FISTP(MEM);
            POPCW;    {.227} //FLDCW(TAddress(@FCW2));
            MOVMC(MEM);
            *)

         end
         else
         if TMA = _Integer then
         begin
           MOVMC(AdrA);
         end;
      end
      else
      if GNode^.CI = 1 then  //Vec[num]
      begin
          Num:=Trunc(GNode^.FD);
          MOVCadr(NUM); //Num>=0!!!
      end
      else
      if GNode^.CI = 3 then  //Vec[AIVP]  - vec[IntForm]
      begin
         //AIVP1;
          LineFormN(GNode^.AIVP1,Trunc(GNode^.FD));
          MOVREG(R_EAX,R_ECX);
      end
      else
      if GNode^.CI = 4 then  //Vec[VecInt[indx]]    {.357}
      begin
         LoadArrayElem(_LoadIntArrayElemEAX);//VecInt[indx]->EAX
         MOVREG(R_EAX,R_ECX);
      end;


      MOVBadr(AdrM);
      //mov  ebx, [ebx]:
      AddByte2($8B,$1B);  //вычисление адреса массива: адрес адреса
      //mov  eax, [ebx+4*ecx]:
      AddByte3($8B,$04,$8B);
      SetReg(R_EAX);
      SetReg(R_EBX);
      SetReg(R_ECX);



   end
   else
   if GNode^.AI = _AddrArrayElem then    //загрузка в EAX адреса элемента массива @vec[indx]-> EAX ; @vd[2*k+3*j-1]
   begin
      LoadArrayElem(_LoadArrayElemAddr);
   end;



end;





procedure TForevalH.LoadArrayElem(Act: Integer);
var
t1,N,NF,S,nv,TM,TA,NM,NA,TMA,tva: Integer;
AdrM,AdrA,Num,AddrI: Cardinal;
begin
// 1 загрузка элемента массива в FPU  или его адреса в EAX
// 2 возвращает  адрес элемента массива @vec[indx] -> EAX

 //GNode^.NObj2 номер массива в NObj !!!
 //тип аргумента в DI !!!
 //GNode^.NV2 - целочисленная переменная vec[IntVar]
 //GNode^.FD - целочисленная константа vec[IntConst]

 NM:=GNode^.NObj2;
 AdrM:=Alg.Obj[NM].Addr;
 TM:=Alg.Obj[NM].MType;

 //вычисление индекса (аргумента массива) и загрузка его в ECX:
 if GNode^.DI = 0 then     //Vec[Trunc(Stack)]
 begin
   LoadArg1;
   TRUNCR(R_ECX);
   //trunc
   (*
   PUSHCW;    {.227}
   FLDCW(TAddress(@FCW1));
   MEM:=WriteDataA(0,_Integer);
   FISTP(MEM);
   POPCW;    {.227} //FLDCW(TAddress(@FCW2));
   MOVMC(MEM);
   *)
 end
 else
 if GNode^.DI = 2 then    //Vec[IntVar]
 begin
   AddrI:=Alg.Obj[GNode^.NV2].Addr;
   MOVMC(AddrI);
  (*
  GetVar1({Interp[NFunc]}GNode^.NV1,AdrA,tva,TMA);
  if (TMA = _Double) or (TMA = _Extended) then
  begin
   FLDV(GNode^.NV1);
   PUSHCW;    {.227}
   FLDCW(TAddress(@FCW1));
   MEM:=WriteDataA(0,_Integer);
   FISTP(MEM);
   POPCW;    {.227} //FLDCW(TAddress(@FCW2));
   MOVMC(MEM);
  end
  else
  if TMA = _Integer then
  begin
    MOVMC(AdrA);
  end;
  *)
 end
 else
 if GNode^.DI = 1 then  //Vec[num]
 begin
   Num:=Trunc(GNode^.FD);
   MOVCadr(NUM); //Num>=0!!!
 end
 else
 if GNode^.DI = 3 then  //Vec[AIVP]  - vec[IntForm]
 begin
    //AIVP1;
    LineFormN(GNode^.AIVP1,Trunc(GNode^.FD));
    MOVREG(R_EAX,R_ECX);
 end;


 //AddrArray -> EBX; indxArray -> ECX

  MOVBadr(AdrM);
  //mov  ebx, [ebx]:
  AddByte($8B); AddByte($1B);

 //загрузка элемента массива в FPU  или его адреса в EAX:
 if TM = _Double then
 begin

     if Act = _LoadArrayElemFPU then
     begin
       //fld  qword ptr [ebx+8*ecx]:
       //AddByte($DD); AddByte($04);AddByte($CB);
        LoadArrayCellFPU(R_EBX,R_ECX,TM);
     end
     else
     if Act = _LoadArrayElemAddr then
     begin
       //lea eax,ebx+8*ecx
       //AddByte3($8D,$04,$CB);
       LoadArrayAddrCell(R_EAX,R_EBX,R_ECX,TM);
     end;

 end
 else
 if TM = _Extended then
 begin

     if Act = _LoadArrayElemFPU then
     begin
     {
       //lea   ecx,[ecx+4*ecx]:
        AddByte($8D); AddByte($0C);AddByte($89);
       //fld   tbyte ptr [ebx+2*ecx]:
        AddByte($DB); AddByte($2C);AddByte($4B);
        }
         LoadArrayCellFPU(R_EBX,R_ECX,TM);
     end
     else
     if Act = _LoadArrayElemAddr then
     begin
       {
        //lea   ecx,[ecx+4*ecx]:
        AddByte($8D); AddByte($0C);AddByte($89);
        //lea eax,ebx+2*ecx
        AddByte3($8D,$04,$4B);
        }
         LoadArrayAddrCell(R_EAX,R_EBX,R_ECX,TM);
     end;


 end
 else
 if (TM = _Integer) or (TM = _Pointer) then
 begin

     if Act = _LoadArrayElemFPU then
     begin
        //fild  dword ptr [ebx+4*ecx]:
        //AddByte($DB); AddByte($04);AddByte($8B);
         LoadArrayCellFPU(R_EBX,R_ECX,_Integer);
     end
     else
     if Act = _LoadArrayElemAddr then
     begin
        //lea eax,ebx+4*ecx
       //AddByte3($8D,$04,$8B);
        LoadArrayAddrCell(R_EAX,R_EBX,R_ECX,_Integer);
     end
     else
      if Act = _LoadIntArrayElemEAX then
     begin
         //mov   eax,[ebx+4*ecx]:
         AddByte($8B); AddByte($04);AddByte($8B);
     end


 end
 else
 if (TM = _Single) then
 begin

     if Act = _LoadArrayElemFPU then
     begin
        //fld  dword ptr [ebx+4*ecx]:
        //AddByte($D9); AddByte($04);AddByte($8B);
        LoadArrayCellFPU(R_EBX,R_ECX,TM);
     end
     else
     if Act = _LoadArrayElemAddr then
     begin
        //lea eax,ebx+4*ecx
       //AddByte3($8D,$04,$8B);
        LoadArrayAddrCell(R_EAX,R_EBX,R_ECX,TM);
     end;


 end;

SetReg(R_EAX);
SetReg(R_EBX);
SetReg(R_ECX);

end;




procedure TForevalH.LoadArrayAddrCell(REG_load,REG_AddrArray,REG_indx,tm: Integer);
//in: @VEC -> REG_AddrArray; indx -> REG_indx;  out: REG_load <- @VEC[indx];
begin


 if tm = _Single then
 begin
    if  (REG_AddrArray = R_EBX) and  (REG_indx = R_EAX) then
    begin
       if REG_load = R_EDI  then
       begin
              //lea edi,ebx+4*eax
               AddByte3($8D,$3C,$83);
       end
       else
       if REG_load = R_EBX  then
       begin
              //lea ebx,ebx+4*eax
               AddByte3($8D,$1C,$83);
       end
       else
       if REG_load = R_ESI  then
       begin
              //lea esi,ebx+4*eax
               AddByte3($8D,$34,$83);
       end;
    end
    else
    if  (REG_AddrArray = R_EBX) and  (REG_indx = R_ECX) then
    begin
       if REG_load = R_EAX  then
       begin
            //lea eax,ebx+4*ecx
            AddByte3($8D,$04,$8B);
       end
    end;
 end
 else
 if tm = _Double then
 begin
    if  (REG_AddrArray = R_EBX) and  (REG_indx = R_EAX) then
    begin
       if REG_load = R_EDI  then
       begin
              //lea edi,ebx+8*eax
               AddByte3($8D,$3C,$C3);
       end
       else
       if REG_load = R_EBX  then
       begin
              //lea ebx,ebx+8*eax
               AddByte3($8D,$1C,$C3);
       end
       else
       if REG_load = R_ESI  then
       begin
              //lea esi,ebx+8*eax
               AddByte3($8D,$34,$C3);
       end;
    end
    else
    if  (REG_AddrArray = R_EBX) and  (REG_indx = R_ECX) then
    begin
       if REG_load = R_EAX  then
       begin
           //lea eax,ebx+8*ecx
           AddByte3($8D,$04,$CB);
       end
    end;

 end
 else
 if tm = _Extended   then
 begin
    if (REG_AddrArray = R_EBX) and  (REG_indx = R_EAX) then
    begin
       if REG_load = R_EDI then
       begin
            //lea   eax,[eax+4*eax]:
              AddByte3($8D,$04,$80);
              //add   eax,eax:
              AddByte2($01,$C0);
              //lea edi,ebx+eax
              AddByte3($8D,$3C,$18);
       end
       else
       if REG_load = R_EBX  then
       begin
             //lea   eax,[eax+4*eax]
              AddByte3($8D,$04,$80);
              //add   eax,eax
              AddByte2($01,$C0);
              //lea ebx,ebx+eax
              AddByte3($8D,$1C,$18);
       end
       else
       if REG_load = R_ESI  then
       begin
              //lea   eax,[eax+4*eax]
              AddByte3($8D,$04,$80);
              //add   eax,eax
              AddByte2($01,$C0);
              //lea esi,ebx+eax
              AddByte3($8D,$34,$18);
       end;
    end
    else
    if  (REG_AddrArray = R_EBX) and  (REG_indx = R_ECX) then
    begin
       if REG_load = R_EAX  then
       begin
           //lea   ecx,[ecx+4*ecx]:
           AddByte($8D); AddByte($0C);AddByte($89);
           //lea eax,ebx+2*ecx
           AddByte3($8D,$04,$4B);
       end
    end;
 end
 else
 if tm = _Integer   then
 begin
    if (REG_AddrArray = R_EBX) and  (REG_indx = R_EAX) then
    begin
       if REG_load = R_EDI then
       begin
           //lea edi,ebx+4*eax
           AddByte($8D); AddByte($3C);AddByte($83);
       end
       else
       if REG_load = R_EBX  then
       begin
           //lea ebx,[ebx+4*eax]
          AddByte($8D); AddByte($1C);AddByte($83);
       end
       else
       if REG_load = R_ESI  then
       begin
          //lea esi,ebx+4*eax
           AddByte($8D); AddByte($34);AddByte($83);
       end;
    end
    else
    if  (REG_AddrArray = R_EBX) and  (REG_indx = R_ECX) then
    begin
       if REG_load = R_EAX  then
       begin
          //lea eax,ebx+4*ecx
          AddByte3($8D,$04,$8B);
       end
    end;
 end;

end;


procedure TForevalH.LoadArrayCellFPU(Addr: TAddress; REG_indx, tm: Integer);
begin
//FLD  type ptr Array[indx]

//Addr - AddrArray or REG with AddrArray
//REG_indx- REG with indxArray
//tm - type of float array


if tm = _Integer then
begin
   if Addr = R_EBX then
   begin
      if REG_indx = R_ECX then
      begin
         //fild  dword ptr [ebx+4*ecx]:
        AddByte($DB); AddByte($04);AddByte($8B);
      end;
   end;
end
else
if tm = _Single then
begin
   if Addr = R_EBX then
   begin
      if REG_indx = R_ECX then
      begin
        //fld  dword ptr [ebx+4*ecx]:
        AddByte($D9); AddByte($04);AddByte($8B);
      end;
   end;
end
else
if tm = _Double then
begin
   if Addr = R_EBX then
   begin
      if REG_indx = R_ECX then
      begin
         //fld  qword ptr [ebx+8*ecx]:
         AddByte($DD); AddByte($04);AddByte($CB);
      end;
   end;
end
else
if tm = _Extended then
begin
   if Addr = R_EBX then
   begin
      if REG_indx = R_ECX then
      begin
         //lea   ecx,[ecx+4*ecx]:
         AddByte($8D); AddByte($0C);AddByte($89);
        //fld   tbyte ptr [ebx+2*ecx]:
         AddByte($DB); AddByte($2C);AddByte($4B);
      end;
   end;
end;




CheckStack(1);
end;




procedure TForevalH.SaveArrayCellFPU(Addr: TAddress; REG_indx, tm: Integer);
begin
//FSTP  type ptr Array[indx]

//Addr - AddrArray or REG with AddrArray
//REG_indx- REG with indxArray
//tm - type of float array


if tm = _Integer then
begin
   if Addr = R_EBX then
   begin
      if REG_indx = R_EAX then
      begin
          //fistp  dword ptr [ebx+4*eax]:
          AddByte($DB); AddByte($1C);AddByte($83);
      end
      else
      if REG_indx = R_ECX then
      begin
         //fistp  dword ptr [ebx+4*ecx]:
         AddByte($DB); AddByte($1C);AddByte($8B);
      end;
   end;
end
else
if tm = _Single then
begin
   if Addr = R_EBX then
   begin
      if REG_indx = R_EAX then
      begin
          //fstp  dword ptr [ebx+4*eax]:
          AddByte($D9); AddByte($1C);AddByte($83);
      end
      else
      if REG_indx = R_ECX then
      begin
         //fstp  dword ptr [ebx+4*ecx]:
         AddByte($D9); AddByte($1C);AddByte($8B);
      end;
   end;
end
else
if tm = _Double then
begin
   if Addr = R_EBX then
   begin
      if REG_indx = R_EAX then
      begin
          //fstp  qword ptr [ebx+8*eax]:
         AddByte($DD); AddByte($1C);AddByte($C3);
      end
      else
      if REG_indx = R_ECX then
      begin
          //fstp  qword ptr [ebx+8*ecx]:
           AddByte($DD); AddByte($1C);AddByte($CB);
      end;
   end;
end
else
if tm = _Extended then
begin
   if Addr = R_EBX then
   begin
      if REG_indx = R_EAX then
      begin
         //lea   eax,[eax+4*eax]:
         AddByte($8D); AddByte($04);AddByte($80);
         //fstp   tbyte ptr [ebx+2*eax]:
         AddByte($DB); AddByte($3C);AddByte($43);
      end
      else
      if REG_indx = R_ECX then
      begin
          //lea   ecx,[ecx+4*ecx]:
          AddByte($8D); AddByte($0C);AddByte($89);
         //fstp   tbyte ptr [ebx+2*ecx]:
          AddByte($DB); AddByte($3C);AddByte($4B);
      end;
   end;
end;




CheckStack(-1);
end;



procedure TForevalH.SAVE_C;
label err1,endp;
var
N,N1,NF,tf,tv,ts,sh,TM,TMA,tva,ta1,code2,ArgForm1,ArgForm2,S: Integer;
AdrM,AdrA,Num,AddrA1,AddrA2,AddrObj,AddrI,AddrI1,AddrI2: Cardinal;
IM1,IM2: Integer;
begin
//Аргументы SAVE не выталкиваются в память после вычислений (в SaveResult)( SaveResult: if CheckSaveRet(Node) then goto endp; )
//и в любом режиме остаются в FPU. Иначе - испльзовать LoadArg1, LoadArg2


 N:=GNode^.NObj;
 N1:=GNode^.NFunc;
 NF:=GNode^.NF;
 tf:=Alg.ExFunc[N1].Func[NF].TV[0];
 tv:=Alg.Obj[N].TypeF;
 tm:=Alg.Obj[N].MType;
 TS:=GNode^.TS;
 sh:=GetSizeSh(tm);
 //if Alg.Obj[N].MType = _Double then sh:=sh_D else   if Alg.Obj[N].MType = _Extended  then sh:=sh_E;

 S:=GNode^.S;

if GNode^.AI = 3 then    //save(IntVar,IntForm)
begin
       ta1:=GNode^.TA1;

       if (ta1 = _IntForm)  then  //IntForm->IntVar
       begin

           {.357}    //оптимизация для случаев:
          //IntVar1=IntVar1 +- IntConst
          //IntVar1=IntVar1 +- A*IntVar2

          {иначе, общий вариант: LineFormN(GNode^.AIVP1,GNode^.IC1);}


          if SaveSimpleLineForm = True  then goto endp
            else
          LineFormN(GNode^.AIVP1,GNode^.IC1);

       end
       else
       if (ta1 = _IntVar)  then    //IntVar(NV1)->IntVar(NObj)        IntVar1=IntVar2
       begin
          MOVMREG(R_EAX,Alg.Obj[GNode^.NV1].Addr);
       end
       else
       if (ta1 = _IntConst)  then      //IntConst->IntVar          IntVar1=IntConst
       begin
          MOVCREG(R_EAX,GNode^.IC1);
       end;

       MOVREGM(R_EAX,Alg.Obj[N].Addr);  //Result-> IntVar(Alg.Obj[N].Addr)    сохранение результата  ->  IntVar1

end
else
if GNode^.AI = 4 then  //vec[IntForm]=Expr
begin

     if tf =   T_Complex then
     begin
        //vd[k]=z1; x
        F_SyntaxErrorString:='save(real,complex) in:   '+{Interp[NFunc]}GNode^.Expression;
        F_SyntaxErrorCode:=E_NOT_DEFINED_FUNCTION_FOR_TYPE;
        goto endp;
     end;

       ta1:=GNode^.TA1;
       AdrM:=Alg.Obj[N].Addr;  //addr of Array
       TM:=Alg.Obj[N].MType;   //math type of Array
       code2:=GNode^.TA2;

       //оптимизация для случая: VecI[IntForm1]=IntForm2    ;
       if (TM = _Integer) and ((code2 = _IntConst) or (code2 = _IntVar) or (code2 = _IntForm)) then
       begin

           LoadLineFormEAX(_Second);  //IntForm2
           PUSHR(R_EAX);
           LoadLineFormEAX(_First);  //IntForm1

           MOVMREG(R_EBX,AdrM);       //Addr->EBX
           POPR(R_ECX);

           // mov [ebx+4*eax],ecx
           AddByte($89); AddByte($0C);AddByte($83);
           
           goto endp;
       end;


       //NCell->EAX
       if (ta1 = _IntForm)  then
       begin
          LineFormN(GNode^.AIVP1,GNode^.IC1);
       end
       else
       if (ta1 = _IntVar)  then
       begin
          MOVMREG(R_EAX,Alg.Obj[GNode^.NV1].Addr);
       end
       else
       if (ta1 = _IntConst)  then
       begin
          MOVCREG(R_EAX,GNode^.IC1);
       end;

       MOVMREG(R_EBX,AdrM);       //Addr->EBX
       SaveArrayCellFPU(R_EBX,R_EAX,TM);

       (*
       if TM = _Double then
       begin
         //fstp  qword ptr [ebx+8*eax]:
         AddByte($DD); AddByte($1C);AddByte($C3);
       end
       else
       if TM = _Extended then
       begin
         //lea   eax,[eax+4*eax]:
         AddByte($8D); AddByte($04);AddByte($80);
         //fstp   tbyte ptr [ebx+2*eax]:
         AddByte($DB); AddByte($3C);AddByte($43);
       end
       else
       if TM = _Integer then
       begin
         //fistp  dword ptr [ebx+4*eax]:
         AddByte($DB); AddByte($1C);AddByte($83);
       end
       else
       if TM = _Single then
       begin
         //fstp  dword ptr [ebx+4*eax]:
         AddByte($D9); AddByte($1C);AddByte($83);
       end;

       CheckStack(-1);
       *)

end
else
{.347}
if GNode^.AI = 5 then  //VecInt[IntForm]=VecInt[IntForm]
begin
    AddrA1:=Alg.Obj[GNode^.NObj].Addr;      // vi1[7*j*k+5*k*j*n-3*n-4*k-15]= vi2[7*j*k+5*k*j*n-3*n-4*k-15];  vi1[7*j*k+5*k*j*n-3*n-4*k-15]
    AddrA2:=Alg.Obj[GNode^.NObj2].Addr;     //vi2[5*m+3*k+2*n*k*j*l+2*k-15]=vi1[5*m+3*k+4*n*k*j*l+8*k+10]; vi2[5*m+3*k+2*n*k*j*l+2*k-15]-vi1[5*m+3*k+4*n*k*j*l+8*k+10];
    ArgForm1:=GNode^.TA1;
    ArgForm2:=GNode^.TA2;

    if  ((ArgForm1 = _IntConst) or (ArgForm1 = _IntVar) or (ArgForm1 = _IntForm)) and ((ArgForm2 = _IntConst) or (ArgForm2 = _IntVar) or (ArgForm2 = _IntForm)) then
    begin
           LoadLineFormEAX(_Second);    //ArgForm2
           MOVMREG(R_EBX,AddrA2);       //Addr2->EBX
            // mov edx,[ebx+4*eax]
           AddByte($8B); AddByte($14);AddByte($83);      // VecInt2[ArgForm2] -> EDX

           LoadLineFormEAX(_First);     //ArgForm1
           MOVMREG(R_EBX,AddrA1);       //Addr1->EBX

           // mov [ebx+4*eax],edx
           AddByte($89); AddByte($14);AddByte($83);    //EDX -> VecInt1[ArgForm1]

           SetReg(R_EDX);
           goto endp;
    end;
   { else
    begin

    end};

end
else
if GNode^.AI = 1 then
begin
 if tf =   T_Real then       //var = real expression
 begin
    if tv =   T_Real then                     //real var =  real expression
    begin
      FSTPM(Alg.Obj[N].Addr,Alg.Obj[N].MType)
    end
    else
    {if (tv =   T_Complex) and (ts = _RE) then
    begin
      FSTPM(Alg.Obj[N].Addr,Alg.Obj[N].MType)
    end
    else
    if (tv =   T_Complex) and (ts = _IM ) then
    begin
      FSTPM(Alg.Obj[N].Addr+sh,Alg.Obj[N].MType)
    end
    else
    if (tv =   T_Complex) and  (ts = 0) then
    begin
      FSTPM(Alg.Obj[N].Addr,Alg.Obj[N].MType)
    end }
     {.203}
     if tv =   T_Complex then                  //complex var =  real expression
     begin
       if  ts = _RE then
         FSTPM(Alg.Obj[N].Addr,Alg.Obj[N].MType)
       else
        if  ts = _IM then
         FSTPM(Alg.Obj[N].AddrIM,Alg.Obj[N].MType)        {.343}
         //FSTPM(Alg.Obj[N].Addr+sh,Alg.Obj[N].MType)
       else
        if ts = 0 then
       begin
         FSTPM(Alg.Obj[N].Addr,Alg.Obj[N].MType);      //expr->re
         FLDZ;
         FSTPM(Alg.Obj[N].AddrIM,Alg.Obj[N].MType);   //0->im      {.343}
         //FSTPM(Alg.Obj[N].Addr+sh,Alg.Obj[N].MType);   //0->im
       end;
     end
     else
     begin           //ptr1=j
        F_SyntaxErrorStringA:='save';
        F_SyntaxErrorString:='save('+NameTypeS[tv]+','+NameTypeS[tf]+')  in:  '  +GNode^.Expression;
        F_SyntaxErrorCode:=E_NOT_DEFINED_FUNCTION_FOR_TYPE;
        goto endp;
     end;

 end
 else
 if tf =   T_Complex then
 begin
    if tv =   T_Real then
    begin
      FSTPM(Alg.Obj[N].Addr,Alg.Obj[N].MType);
      FSTP0;
    end
    else
    if (tv =   T_Complex) and (ts = _RE ) then
    begin
      FSTPM(Alg.Obj[N].Addr,Alg.Obj[N].MType);
      FSTP0;
    end
    else
    if (tv =   T_Complex) and (ts = _IM ) then
    begin
      //FSTP0;
      //FSTPM(Alg.Obj[N].Addr+sh,Alg.Obj[N].MType);
      FSTPM(Alg.Obj[N].AddrIM,Alg.Obj[N].MType);  {.343}
      FSTP0;
    end
    else
    if (tv =   T_Complex)  then
    begin
      FSTPM(Alg.Obj[N].Addr,Alg.Obj[N].MType);
      //FSTPM(Alg.Obj[N].Addr+sh,Alg.Obj[N].MType);
      FSTPM(Alg.Obj[N].AddrIM,Alg.Obj[N].MType); {.343}
    end
 end
 else
 if tf = T_Pointer then       // = T_Pointer
 begin
    if tv = T_Pointer then      //PoiterVar=T_Pointer
    begin
        //загрузить T_Pointer из стека выражения в EAX
        MOVMREG(R_EAX,GetStackAdr(S,_RE));
        //-> PointerVar
        MOVREGM(R_EAX,Alg.Obj[N].Addr);
    end
    else
    if (tv = T_Real) and (tm = _Integer) and (F_EnableUseIntegerPointer = True) then     //IntegVar = T_Pointer
    begin
       //загрузить T_Pointer из стека выражения в EAX
        MOVMREG(R_EAX,GetStackAdr(S,_RE));
        //-> PointerVar
        MOVREGM(R_EAX,Alg.Obj[N].Addr);
    end
    else
    goto err1;
 end
 else
 begin
     err1:
                //j=ptr1
     TM:=Alg.Obj[N].MType;
     F_SyntaxErrorStringA:='save';
     F_SyntaxErrorString:='save('+NameMathTypeS[tm]+','+NameTypeS[tf]+')  in:  '  +GNode^.Expression;
     F_SyntaxErrorCode:=E_NOT_DEFINED_FUNCTION_FOR_TYPE;
     goto endp;
 end;
end
else
if GNode^.AI = 2 then   //save(vd,expr,x)      ;vd[y*x]=x+y; vd[y*x]
begin

  if tf =   T_Complex then
  begin
     //vd[x*y]=z1; x
     F_SyntaxErrorString:='save(real,complex) in:   '+{Interp[NFunc]}GNode^.Expression;
     F_SyntaxErrorCode:=E_NOT_DEFINED_FUNCTION_FOR_TYPE;
    goto endp;
  end;

  AdrM:=Alg.Obj[N].Addr;
  TM:=Alg.Obj[N].MType;
   {
   FXCH1;
   FLDCW(TAddress(@FCW1));
   MEM:=WriteDataA(0,_Integer);
   FISTP(MEM);
   FLDCW(TAddress(@FCW2));
   MOVMC(MEM);
   }

   //номер элемента массива -> ECX
   if GNode^.CI = 1 then    //Vec[int_var]
   begin
     GetVar1(GNode^.NV1,AdrA,tva,TMA);
     MOVMC(AdrA);
   end
   else
    if GNode^.CI = 2 then    //Vec[int_num]
   begin
     Num:=Trunc(GNode^.FD);
     MOVCadr(NUM);  //Num>=0!!!
   end
   else                            //vec[stack]
   begin
    //FXCH1;              {.359}
    TRUNCR(R_ECX);
    (*
    PUSHCW;    {.227}
    FLDCW(TAddress(@FCW1));
    MEM:=WriteDataA(0,_Integer);
    FISTP(MEM);
    POPCW;      {.227}   //FLDCW(TAddress(@FCW2));
    MOVMC(MEM);
    *)
   end;



   //адрес массива -> EBX
   MOVBadr(AdrM);
   //mov  ebx, [ebx]:
   AddByte($8B); AddByte($1B);

   SaveArrayCellFPU(R_EBX,R_ECX,TM);

   (*
   if TM = _Double then
   begin
    {MOVB1(AdrM);
    MOVA1(Cardinal(@RD_VECS));
    CALLA;}

     MOVBadr(AdrM);
     //mov  ebx, [ebx]:
     AddByte($8B); AddByte($1B);

     //fstp  qword ptr [ebx+8*ecx]:
     AddByte($DD); AddByte($1C);AddByte($CB);
   end
   else
   if TM = _Extended then
   begin
    {MOVB1(AdrM);
    MOVA1(Cardinal(@RE_VECS));
    CALLA;}

      MOVBadr(AdrM);
     //mov  ebx, [ebx]:
     AddByte($8B); AddByte($1B);
     //lea   ecx,[ecx+4*ecx]:
     AddByte($8D); AddByte($0C);AddByte($89);
     //fstp   tbyte ptr [ebx+2*ecx]:
     AddByte($DB); AddByte($3C);AddByte($4B);
   end
   else
   if TM = _Integer then
   begin
    {MOVB1(AdrM);
    MOVA1(Cardinal(@RI_VECS));
    CALLA;}

     MOVBadr(AdrM);
    //mov  ebx, [ebx]:
     AddByte($8B); AddByte($1B);
    //fistp  dword ptr [ebx+4*ecx]:
     AddByte($DB); AddByte($1C);AddByte($8B);
   end
   else
   if TM = _Single then
   begin
     MOVBadr(AdrM);
    //mov  ebx, [ebx]:
     AddByte($8B); AddByte($1B);
    //fstp  dword ptr [ebx+4*ecx]:
     AddByte($D9); AddByte($1C);AddByte($8B);
   end;

   CheckStack(-1);

   *)

 end
else
if GNode^.AI = 10 then    //save(<IntVar,IntArray>,AddrOf<Var,Array,Func>)
begin

   if (GNode^.BI = _IntVar) then     //save(IntVar,AddrOf<Var,Array,Func,Array[indx]>)
   begin

     if (GNode^.CI = _AddrVar) or (GNode^.CI = _AddrFunc)  then
     begin
        MOVCREG(R_EAX,GNode^.Addr1);
        MOVREGM(R_EAX,Alg.Obj[N].Addr);
     end
     else
     if (GNode^.CI = _AddrArray) then
     begin
        MOVCREG(R_EAX,GNode^.Addr1);
        MOVREGM(R_EAX,Alg.Obj[N].Addr);
     end
     else
     if (GNode^.CI = _Array) then
     begin
        MOVMREG(R_EAX,GNode^.Addr1);           //вычисление адреса от адреса
        MOVREGM(R_EAX,Alg.Obj[N].Addr);
     end
     else
     if (GNode^.CI = _AddrArrayElem) then   //  PtrVar,IntVar=@vec[indx]
     begin
       LoadArrayElem(_LoadArrayElemAddr);
       MOVREGM(R_EAX,Alg.Obj[N].Addr); //EAX->PtrVar
     end;

   end
   else
   if (GNode^.BI = _IntArray) then     //save(IntArray,AddrOf<Var,Array,Func>)
   begin

       AddrA1:=Alg.Obj[GNode^.NObj].Addr;        //Addr of IntArray
       AddrObj:=GNode^.Addr1;                    //Addr of Obj to save
       ArgForm1:=GNode^.TA1;
       //GNode^.CI  - type of Obj

       //ArrayData
       if  ((ArgForm1 = _IntConst) or (ArgForm1 = _IntVar) or (ArgForm1 = _IntForm)) then
       begin
           LoadLineFormEAX(_Second);    //ArgForm2

           LoadLineFormEAX(_First);           //indx(ArgForm1)->EAX
           MOVMREG(R_EBX,AddrA1);             //AddrA1->EBX
           //MOVCREG(R_ECX,AddrObj);           //AddrObj->ECX

           // mov [ebx+4*eax],ecx
          // AddByte3($89,$0C,$83);       //ECX -> VecInt1[ArgForm1]
           //goto endp;
       end
       else    //vec[stack]
       begin
          FXCH1;
          (*
          PUSHCW;
          FLDCW(TAddress(@FCW1));
          MEM:=WriteDataA(0,_Integer);
          FISTP(MEM);
          POPCW;
          MOVMA(MEM);              //indx->EAX
          *)
          TRUNCR(R_EAX);           //indx->EAX
          MOVMREG(R_EBX,AddrA1);   //AddrA1->EBX
       end;


       //ObjData
       if (GNode^.CI = _AddrVar) or (GNode^.CI = _AddrFunc) or (GNode^.CI = _AddrArray) then
       begin
           MOVCREG(R_ECX,AddrObj);           //AddrObj->ECX
       end
       else
       if (GNode^.CI = _Array) then
       begin
           MOVMREG(R_ECX,AddrObj);           //вычисление адреса от адреса    //Addr(AddrObj)->ECX
       end;

       //Save
        // mov [ebx+4*eax],ecx
        AddByte3($89,$0C,$83);       //ECX -> VecInt1[indx]

        SetReg(R_ECX);
      {***************************************}

   end;



end;


{SetLength(GotoLab,Length(GotoLab)+1);
GotoLab[High(GotoLab)]:=NFunc;}
endp:
end;






procedure TForevalH.SWAP_C;
var
N,nv1,nv2,NF,tf,tv1,ts1,tv2,ts2,sh1,sh2,TM1,TM2,tva,ArgForm1,ArgForm2: Integer;
Adr1,Adr2,Adr1IM,Adr2IM, AddrA1, AddrA2: TAddress;
Com,tif: Integer;
begin

//используется сразу для 2 команд: SWAP и SWAPIF

 nv1:=GNode^.NV1;
 nv2:=GNode^.NV2;

 ts1:=GNode^.TS1;
 ts2:=GNode^.TS2;

 Com:=GNode^.NFunc;
 tif:=GNode.tif;

 if (GNode^.AI >= 1) and  (GNode^.AI <= 6) then
 begin
    Adr1:=Alg.Obj[nv1].Addr;
    Adr1IM:=Alg.Obj[nv1].AddrIM;      {.343}
    tv1:=Alg.Obj[nv1].TypeF;
    tm1:=Alg.Obj[nv1].MType;
    sh1:=GetSizeSh(tm1);
    //if tm1 = _Double then sh1:=sh_D else   if Alg.Obj[nv1].MType = _Extended  then sh1:=sh_E;

    Adr2:=Alg.Obj[nv2].Addr;
    Adr2IM:=Alg.Obj[nv2].AddrIM;       {.343}
    tv2:=Alg.Obj[nv2].TypeF;
    tm2:=Alg.Obj[nv2].MType;
    sh2:=GetSizeSh(tm2);
    //if tm2 = _Double then sh2:=sh_D else   if Alg.Obj[nv2].MType = _Extended  then sh2:=sh_E;
 end;


 if (GNode^.AI = 1) {or (GNode^.AI = 2)} then         //SWAP, SWAPIF
 begin
 {
    x=1; y=11; swap(x,y);   x-y;
    x=1; y=11; swapif(x<y); x-y;
 }
 (*
   FLD(Adr1,tm1);
   FLD(Adr2,tm2);
   FSTPM(Adr1,tm1);
   FSTPM(Adr2,tm2);
   //CheckStack(2);
   //CheckStack(-2);
   *)

      FLD(Adr1,tm1);
      FLD(Adr2,tm2);

      if Com = CM_SWAPIF then
      begin
        FCOMI;
        JMPC(17,tif);
      end;

      FSTPM(Adr1,tm1);
      FSTPM(Adr2,tm2);

      if Com = CM_SWAPIF then
      begin
         JMP(4);
         FSTP0;
         FSTP0;
         CheckStack(2);     //коррекция на излишние fstp в swapif
      end;
 end
 else
 if  (GNode^.AI = 2) then      //SWAP, SWAPIF
 begin
 {
    n=1; k=11; swap(n,k);   n-k;
    n=1; k=11; swapif(n<k); n-k;
 }

  (*
   MOVMREG(R_EAX,Adr1);
   MOVMREG(R_EBX,Adr2);
   MOVREGM(R_EAX,Adr2);
   MOVREGM(R_EBX,Adr1);
   *)

    MOVMREG(R_EAX,Adr1);
    MOVMREG(R_EBX,Adr2);

    if Com = CM_SWAPIF then
    begin
       CMPR(R_EBX,R_EAX);
       JMPC(12,tif);
    end;

    MOVREGM(R_EAX,Adr2);
    MOVREGM(R_EBX,Adr1);

 end
 else
 if (GNode^.AI = 3) then          //SWAP
 begin
  {
    z1=1+1i; z2=11+11i; swap(z1,z2);   z1-z2;
  }

   FLD(Adr1,tm1);
   //FLD(Adr1+sh1,tm1);
   FLD(Adr1IM,tm1);        {.343}
   FLD(Adr2,tm2);
   //FLD(Adr2+sh2,tm2);
   FLD(Adr2IM,tm2);       {.343}

   //FSTPM(Adr1+sh1,tm1);
   FSTPM(Adr1IM,tm1);       {.343}
   FSTPM(Adr1,tm1);
   //FSTPM(Adr2+sh2,tm2);
   FSTPM(Adr2IM,tm2);     {.343}
   FSTPM(Adr2,tm2);
   //CheckStack(4);
   //CheckStack(-4);
 end
 else
 if (GNode^.AI = 6) then          //SWAP, SWAPIF
 begin
  {
    z1=1+11i; z2=111+1111i; swap(z1.re,z2.im);     z1.re-z2.im;
    z1=1+11i; z2=111+1111i; swapif(z1.re<z2.im);   z1.re-z2.im;
  }

   (*
   if ts1 = _RE then FLD(Adr1,tm1) else  if ts1 = _IM then FLD(Adr1IM,tm1);//FLD(Adr1+sh1,tm1);   {.343}
   if ts2 = _RE then FLD(Adr2,tm2) else  if ts2 = _IM then FLD(Adr2IM,tm2);//FLD(Adr2+sh2,tm2);   {.343}

   if ts1 = _RE then FSTPM(Adr1,tm1) else  if ts1 = _IM then FSTPM(Adr1IM,tm1);//FSTPM(Adr1+sh1,tm1);  {.343}
   if ts2 = _RE then FSTPM(Adr2,tm2) else  if ts2 = _IM then FSTPM(Adr2IM,tm2);//FSTPM(Adr2+sh2,tm2);   {.343}
   *)

   //load
   if ts1 = _RE then FLD(Adr1,tm1) else  if ts1 = _IM then FLD(Adr1IM,tm1);
   if ts2 = _RE then FLD(Adr2,tm2) else  if ts2 = _IM then FLD(Adr2IM,tm2);

   if Com = CM_SWAPIF then    // z1.re=2; z2.im=12;  swapif(z2.im>z1.re) ; z2.im-z1.re
   begin
      FCOMI;
      JMPC(17,tif);
   end;

   //save
   if ts1 = _RE then FSTPM(Adr1,tm1) else  if ts1 = _IM then FSTPM(Adr1IM,tm1);//FSTPM(Adr1+sh1,tm1);  {.343}
   if ts2 = _RE then FSTPM(Adr2,tm2) else  if ts2 = _IM then FSTPM(Adr2IM,tm2);//FSTPM(Adr2+sh2,tm2);   {.343}

   if Com = CM_SWAPIF then
   begin
      JMP(4);
      FSTP0;
      FSTP0;
      CheckStack(2);     //коррекция на излишние fstp в swapif
   end;

   //CheckStack(2);
   //CheckStack(-2);
 end
 else
 if (GNode^.AI = 4) then          //SWAP, SWAPIF
 begin
  {
    x=1;  z2=11+111i; swap(x,z2.im);     x-z2.im;
    x=1;  z2=11+111i; swapif(x<z2.im);   x-z2.im;
  }

   (*
   FLD(Adr1,tm1);
   if ts2 = _RE then FLD(Adr2,tm2) else  if ts2 = _IM then FLD(Adr2IM,tm2);//FLD(Adr2+sh2,tm2);       {.343}

   FSTPM(Adr1,tm1);
   if ts2 = _RE then FSTPM(Adr2,tm2) else  if ts2 = _IM then FSTPM(Adr2IM,tm2);//FSTPM(Adr2+sh2,tm2);    {.343}
   *)

    //load
   FLD(Adr1,tm1);
   if ts2 = _RE then FLD(Adr2,tm2) else  if ts2 = _IM then FLD(Adr2IM,tm2);

   if Com = CM_SWAPIF then              //x=2; z2.im=12;  swapif(x<z2.im); z2.im-x
   begin
      FCOMI;
      JMPC(17,tif);
   end;

   //save
   FSTPM(Adr1,tm1);
   if ts2 = _RE then FSTPM(Adr2,tm2) else  if ts2 = _IM then FSTPM(Adr2IM,tm2);

   if Com = CM_SWAPIF then
   begin
      JMP(4);
      FSTP0;
      FSTP0;
      CheckStack(2);     //коррекция на излишние fstp  в swapif
   end;


   //CheckStack(-2);

 end
 else
 if GNode^.AI = 5 then    //SWAP, SWAPIF
 begin
  {
    x=1;  z2=11+111i; swap(z2.im,x);     x-z2.im;
    x=1;  z2=11+111i; swapif(z2.im>x);   x-z2.im;
  }
   (*
   FLD(Adr2,tm2);
   if ts1 = _RE then FLD(Adr1,tm1) else  if ts1 = _IM then FLD(Adr1IM,tm1);//FLD(Adr1+sh1,tm1);        {.343}

   FSTPM(Adr2,tm2);
   if ts1 = _RE then FSTPM(Adr1,tm1) else  if ts1 = _IM then FSTPM(Adr1IM,tm1);//FSTPM(Adr1+sh1,tm1);   {.343}

   *)

    //load
   if ts1 = _RE then FLD(Adr1,tm1) else  if ts1 = _IM then FLD(Adr1IM,tm1);//FLD(Adr1+sh1,tm1);        {.343}
   FLD(Adr2,tm2);

   if Com = CM_SWAPIF then         //x=2; z2.im=12;  swapif(z2.im>x); z2.im-x
   begin
      FCOMI;
      JMPC(17,tif);
   end;

   //save
   if ts1 = _RE then FSTPM(Adr1,tm1) else  if ts1 = _IM then FSTPM(Adr1IM,tm1);//FSTPM(Adr1+sh1,tm1);   {.343}
   FSTPM(Adr2,tm2);

   if Com = CM_SWAPIF then
   begin
      JMP(4);
      FSTP0;
      FSTP0;
      CheckStack(2);     //коррекция на излишние fstp  в swapif
   end;

 end
 else
 if GNode^.AI = 10 then    //SWAP, SWAPIF         // IntArray[]<->IntArray[]
 begin
     AddrA1:=Alg.Obj[GNode^.NObj].Addr;
     AddrA2:=Alg.Obj[GNode^.NObj2].Addr;
     ArgForm1:=GNode^.TA1;
     ArgForm2:=GNode^.TA2;

     //swap(IntArray,IntArray)
     if  ((ArgForm1 = _IntConst) or (ArgForm1 = _IntVar) or (ArgForm1 = _IntForm)) and ((ArgForm2 = _IntConst) or (ArgForm2 = _IntVar) or (ArgForm2 = _IntForm)) then
     begin                                //swap(vi1[2*k+4],vi2[j*n+2]); vi1[2*k+4]
     {
       vi1[10]=1; vi2[20]=11; swap(vi1[10],vi2[20]);   vi1[10]-vi2[20]
       vi1[10]=1; vi2[20]=11; swapif(vi1[10]<vi2[20]); vi1[10]-vi2[20]

       vi1[k]=1; vi2[j]=11; swap(vi1[k],vi2[j]);   vi1[k]-vi2[j]
       vi1[k]=1; vi2[j]=11; swapif(vi1[k]<vi2[j]); vi1[k]-vi2[j]

       vi1[2*k+4]=1; vi2[3*j*k-5]=11; swap(vi1[2*k+4],vi2[3*j*k-5]);   vi1[2*k+4]-vi2[3*j*k-5]
       vi1[2*k+4]=1; vi2[3*j*k-5]=11; swapif(vi1[2*k+4]<vi2[3*j*k-5]); vi1[2*k+4]-vi2[3*j*k-5]
     }

           LoadLineFormEAX(_First);     //ArgForm1
           MOVMREG(R_EBX,AddrA1);       //Addr1->EBX

           //lea esi,ebx+4*eax
           AddByte($8D); AddByte($34);AddByte($83);      // @VecInt1[ArgForm1] -> ESI

           LoadLineFormEAX(_Second);    //ArgForm2
           MOVMREG(R_EBX,AddrA2);       //Addr2->EBX

           //lea edi,ebx+4*eax
           AddByte($8D); AddByte($3C);AddByte($83);      // @VecInt2[ArgForm2] -> EDI

           //load
           //mov eax,[esi]
           AddByte($8B); AddByte($06);     // VecInt1[ArgForm1] -> EAX
           //mov ebx,[edi]
           AddByte($8B); AddByte($1F);     // VecInt2[ArgForm2] -> EBX

           if Com = CM_SWAPIF then
           begin
             CMPR(R_EBX,R_EAX);
             JMPC(4,tif);
           end;

           //save
           //mov [edi],eax
           AddByte($89); AddByte($07);     // EAX -> VecInt2[ArgForm2]
           //mov [esi],ebx
           AddByte($89); AddByte($1E);     // EBX -> VecInt1[ArgForm1]

           SetReg(R_ESI);
           SetReg(R_EDI);
           SetReg(R_EAX);
           SetReg(R_EBX);

     end
     else
     if ((ArgForm1 = _IntConst) or (ArgForm1 = _IntVar) or (ArgForm1 = _IntForm)) and (ArgForm2 = _NOT_FOUND) then
     begin
                          //vi1[2*k+4]=2; vi2[j*(n+2)]=12; swap(vi1[2*k+4],vi2[j*(n+2)]); vi2[j*(n+2)]-vi1[2*k+4]
      {
       vi1[10]=1; vi2[j*(n+2)]=11; swap(vi1[10],vi2[j*(n+2)]);   vi1[10]-vi2[j*(n+2)]
       vi1[10]=1; vi2[j*(n+2)]=11; swapif(vi1[10]<vi2[j*(n+2)]); vi1[10]-vi2[j*(n+2)]

       vi1[k]=1; vi2[j*(n+2)]=11; swap(vi1[k],vi2[j*(n+2)]);   vi1[k]-vi2[j*(n+2)]
       vi1[k]=1; vi2[j*(n+2)]=11; swapif(vi1[k]<vi2[j*(n+2)]); vi1[k]-vi2[j*(n+2)]

       vi1[2*k+4]=1; vi2[j*(n+2)]=11; swap(vi1[2*k+4],vi2[j*(n+2)]);   vi1[2*k+4]-vi2[j*(n+2)]
       vi1[2*k+4]=1; vi2[j*(n+2)]=11; swapif(vi1[2*k+4]<vi2[j*(n+2)]); vi1[2*k+4]-vi2[j*(n+2)]
     }

           LoadArg1;

           LoadLineFormEAX(_First);     //ArgForm1
           MOVMREG(R_EBX,AddrA1);       //Addr1->EBX
           //lea esi,ebx+4*eax
           AddByte($8D); AddByte($34);AddByte($83);      // @VecInt1[ArgForm1] -> ESI


           //vec[stack]
           //FXCH1;
           (*
           PUSHCW;   {.227}
           FLDCW(TAddress(@FCW1));
           MEM:=WriteDataA(0,_Integer);
           FISTP(MEM);
           POPCW;      {.227}   //FLDCW(TAddress(@FCW2));
           MOVMA(MEM);    // Expr2->EAX
           *)
           TRUNCR(R_EAX);

           MOVMREG(R_EBX,AddrA2);       //Addr2->EBX
           //lea edi,ebx+4*eax
           AddByte($8D); AddByte($3C);AddByte($83);      // @VecInt2[Expr2] -> EDI

           //load
           //mov eax,[esi]
           AddByte($8B); AddByte($06);     // VecInt1[ArgForm1] -> EAX
           //mov ebx,[edi]
           AddByte($8B); AddByte($1F);     // VecInt2[Expr2] -> EBX

           if Com = CM_SWAPIF then
           begin
             CMPR(R_EBX,R_EAX);
             JMPC(4,tif);
           end;

           //save
           //mov [edi],eax
           AddByte($89); AddByte($07);     // EAX -> VecInt2[Expr2]
           //mov [esi],ebx
           AddByte($89); AddByte($1E);     // EBX -> VecInt1[ArgForm1]


           //CheckStack(-1);
           SetReg(R_ESI);
           SetReg(R_EDI);
           SetReg(R_EAX);
           SetReg(R_EBX);

     end
     else
     if ((ArgForm2 = _IntConst) or (ArgForm2 = _IntVar) or (ArgForm2 = _IntForm)) and (ArgForm1 = _NOT_FOUND) then     //swap(vi2[j*(n+2)],vi1[2*k+4]); vi1[2*k+4]
     begin
      {
       vi1[10]=1; vi2[j*(n+2)]=11; swap(vi2[j*(n+2)],vi1[10]);   vi1[10]-vi2[j*(n+2)]
       vi1[10]=1; vi2[j*(n+2)]=11; swapif(vi2[j*(n+2)]>vi1[10]); vi1[10]-vi2[j*(n+2)]

       vi1[k]=1; vi2[j*(n+2)]=11; swap(vi2[j*(n+2)],vi1[k]);   vi1[k]-vi2[j*(n+2)]
       vi1[k]=1; vi2[j*(n+2)]=11; swapif(vi2[j*(n+2)]>vi1[k]); vi1[k]-vi2[j*(n+2)]

       vi1[2*k+4]=1; vi2[j*(n+2)]=11; swap(vi2[j*(n+2)], vi1[2*k+4]);  vi1[2*k+4]-vi2[j*(n+2)]
       vi1[2*k+4]=1; vi2[j*(n+2)]=11; swapif(vi2[j*(n+2)]>vi1[2*k+4]); vi1[2*k+4]-vi2[j*(n+2)]
     }


           LoadArg1;

           LoadLineFormEAX(_Second);     //ArgForm2
           MOVMREG(R_EBX,AddrA2);       //Addr2->EBX
           //lea esi,ebx+4*eax
           AddByte($8D); AddByte($34);AddByte($83);      // @VecInt2[ArgForm2] -> ESI


           //vec[stack]
           //FXCH1;
           (*
           PUSHCW;   {.227}
           FLDCW(TAddress(@FCW1));
           MEM:=WriteDataA(0,_Integer);
           FISTP(MEM);
           POPCW;      {.227}   //FLDCW(TAddress(@FCW2));
           MOVMA(MEM);    // Expr1->EAX
          *)
           TRUNCR(R_EAX);

           MOVMREG(R_EBX,AddrA1);       //Addr1->EBX
           //lea edi,ebx+4*eax
           AddByte($8D); AddByte($3C);AddByte($83);      // @VecInt1[Expr1] -> EDI

           //load
           //mov eax,[esi]
           AddByte($8B); AddByte($06);     // VecInt2[ArgForm2] -> EAX
           //mov ebx,[edi]
           AddByte($8B); AddByte($1F);     // VecInt1[Expr1] -> EBX

           if Com = CM_SWAPIF then
           begin
             CMPR(R_EAX,R_EBX);
             JMPC(4,tif);
           end;


           //save
           //mov [edi],eax
           AddByte($89); AddByte($07);     // EAX -> VecInt1[Expr1]
           //mov [esi],ebx
           AddByte($89); AddByte($1E);     // EBX -> VecInt2[ArgForm2]


           //CheckStack(-1);
           SetReg(R_ESI);
           SetReg(R_EDI);
           SetReg(R_EAX);
           SetReg(R_EBX);


     end
     else
     if  (ArgForm1 = _NOT_FOUND) and (ArgForm2 = _NOT_FOUND) then    //swap(vi1[x],vi2[y]); vi1[x]
     begin
     {
       vi1[x]=1; vi2[y]=11; swap(vi1[x],vi2[y]);   vi1[x]-vi2[y]
       vi1[x]=1; vi2[y]=11; swapif(vi1[x]<vi2[y]); vi1[x]-vi2[y]
     }
           LoadArg2(_Back);
                  //ST(0)      ST(1)
           //vec2[stack2],vec1[stack1]
           //FXCH1;
           PUSHCW;   {.227}
           FLDCW(TAddress(@FCW1));
           MEM:=WriteDataA(0,_Integer);
           FISTP(MEM);
           MEM1:=WriteDataA(0,_Integer);
           FISTP(MEM1);
           POPCW;      {.227}   //FLDCW(TAddress(@FCW2));

           MOVMA(MEM);    // Expr2->EAX
           MOVMREG(R_EBX,AddrA2);       //Addr2->EBX
           //lea edi,ebx+4*eax
           AddByte($8D); AddByte($3C);AddByte($83);      // @VecInt2[Expr2] -> EDI

           MOVMA(MEM1);    // Expr1->EAX
           MOVMREG(R_EBX,AddrA1);       //Addr1->EBX
           //lea esi,ebx+4*eax
           AddByte($8D); AddByte($34);AddByte($83);      // @VecInt1[Expr1] -> ESI

           //load
           //mov eax,[esi]
           AddByte($8B); AddByte($06);     // VecInt2[Expr2] -> EAX
           //mov ebx,[edi]
           AddByte($8B); AddByte($1F);     // VecInt1[Expr1] -> EBX

           if Com = CM_SWAPIF then
           begin
             CMPR(R_EBX,R_EAX);
             JMPC(4,tif);
           end;

           //save
           //mov [edi],eax
           AddByte($89); AddByte($07);     // EAX -> VecInt1[Expr1]
           //mov [esi],ebx
           AddByte($89); AddByte($1E);     // EBX -> VecInt2[Expr2]


           //CheckStack(-2);
           SetReg(R_ESI);
           SetReg(R_EDI);
           SetReg(R_EAX);
           SetReg(R_EBX);

     end;

 end   // of swap(IntArray,IntArray)
 else
 if GNode^.AI = 11 then    //SWAP, SWAPIF        //swap(IntArray,IntVar)   swap(IntVar,IntArray)
 begin
         //vi[2*k+7]=2; ki:int=12; swap(vi[2*k+7],ki); ki-vi[2*k+7]

     AddrA1:=Alg.Obj[GNode^.NObj].Addr;
     ArgForm1:=GNode^.TA1;
     Adr2:=Alg.Obj[GNode^.NV2].Addr;

     if (ArgForm1 = _IntConst) or (ArgForm1 = _IntVar) or (ArgForm1 = _IntForm) then
     begin

      {
       n=1; vi2[20]=11; swap(n,vi2[20]);   n-vi2[20]
       n=1; vi2[20]=11; swapif(n<vi2[20]); n-vi2[20]

       n=1; vi2[j]=11; swap(n,vi2[j]);   n-vi2[j]
       n=1; vi2[j]=11; swapif(n<vi2[j]); n-vi2[j]

       n=1; vi2[3*j*k-5]=11; swap(n,vi2[3*j*k-5]);   n-vi2[3*j*k-5]
       n=1; vi2[3*j*k-5]=11; swapif(n<vi2[3*j*k-5]); n-vi2[3*j*k-5]

       n=1; vi2[j]=11; swapif(vi2[j]>n); n-vi2[j]
      }

        LoadLineFormEAX(_First);     //ArgForm1
        MOVMREG(R_EBX,AddrA1);       //Addr1->EBX

        //lea ebx,[ebx+4*eax]
        AddByte($8D); AddByte($1C);AddByte($83);      // @VecInt1[ArgForm1] -> EBX

        //load
        MOVMREG(R_EAX,Adr2);        //IntVar -> EAX
         //mov ecx,[ebx]
        AddByte($8B); AddByte($0B);  //VecInt1[ArgForm1]->ECX

         //IntVar->EAX; IntArray[indx]->ECX;  @IntArray[indx]->EBX;

        if Com = CM_SWAPIF then
        begin
           CMPR(R_ECX,R_EAX);
           //swap использует один вид: swap(var,vec[]) для swap(var,vec[]) и swap(vec[],var)
           //поэтому во 2-м случае нужно перевернуть условие сравнения:
           if GNode.DI = _IntArray then
           begin
             if tif = _JNB  then  tif:=_JBE else
             if tif = _JBE  then  tif:=_JNB;
           end;

           JMPC(8,tif);
        end;


        //save
        //mov [ebx],eax
        AddByte($89); AddByte($03);  //EAX -> VecInt1[ArgForm1]
        MOVREGM(R_ECX,Adr2);         //ECX -> IntVar

        SetReg(R_ECX);
        SetReg(R_EAX);
        SetReg(R_EBX);
     end
     else
     if  (ArgForm1 = _NOT_FOUND) then      //IntArray1[Expr1]<->IntVar2
     begin
             //vi[2*x+7]=2; ki:int=12; swap(vi[2*x+7],ki); ki-vi[2*x+7]
     {
       n=1; vi2[y]=11; swap(n,vi2[y]);   n-vi2[y]
       n=1; vi2[y]=11; swapif(n<vi2[y]); n-vi2[y]
       n=1; vi2[y]=11; swapif(vi2[y]>n); n-vi2[y]

      }

           LoadArg1;
           (*
           PUSHCW;   {.227}
           FLDCW(TAddress(@FCW1));
           MEM:=WriteDataA(0,_Integer);
           FISTP(MEM);
           POPCW;      {.227}   //FLDCW(TAddress(@FCW2));
           MOVMA(MEM);    // Expr1->EAX
           *)
           TRUNCR(R_EAX);

           MOVMREG(R_EBX,AddrA1);       //Addr1->EBX
           //lea ebx,[ebx+4*eax]
           AddByte($8D); AddByte($1C);AddByte($83);      // @VecInt1[ArgForm1] -> EBX

           //load
           MOVMREG(R_EAX,Adr2);        //IntVar -> EAX
           //mov ecx,[ebx]
           AddByte($8B); AddByte($0B);  //VecInt1[ArgForm1]->ECX

           //IntVar->EAX; IntArray[indx]->ECX;  @IntArray[indx]->EBX;
           if Com = CM_SWAPIF then
           begin
              CMPR(R_ECX,R_EAX);
              //swap использует один вид: swap(var,vec[]) для swap(var,vec[]) и swap(vec[],var)
              //поэтому во 2-м случае нужно перевернуть условие сравнения:
              if GNode.DI = _IntArray then
              begin
                if tif = _JNB  then  tif:=_JBE else
                if tif = _JBE  then  tif:=_JNB;
              end;
              JMPC(8,tif);
          end;

           //save
           //mov [ebx],eax
           AddByte($89); AddByte($03);  //EAX -> VecInt1[ArgForm1]
           MOVREGM(R_ECX,Adr2);         //ECX -> IntVar

           SetReg(R_ECX);
           SetReg(R_EAX);
           SetReg(R_EBX);
     end;

 end
 else
 if GNode^.AI = 20 then   //SWAP,  SWAPIF          //swap(FloatArray,FloatArray)
 begin
     AddrA1:=Alg.Obj[GNode^.NObj].Addr;
     AddrA2:=Alg.Obj[GNode^.NObj2].Addr;
     ArgForm1:=GNode^.TA1;
     ArgForm2:=GNode^.TA2;
     tm1:=Alg.Obj[GNode^.NObj].MType;
     tm2:=Alg.Obj[GNode^.NObj2].MType;


     //swap(FloatArray,FloatArray)
     if  ((ArgForm1 = _IntConst) or (ArgForm1 = _IntVar) or (ArgForm1 = _IntForm)) and ((ArgForm2 = _IntConst) or (ArgForm2 = _IntVar) or (ArgForm2 = _IntForm)) then
     begin
                    //vs[2*k+7]=2; ve[3*k*j+5]=12; swap(vs[2*k+7],ve[3*k*j+5]); ve[3*k*j+5]-vs[2*k+7]
                    //vd[2*k+7]=2; ve[3*k*j+5]=12; swap(vd[2*k+7],ve[3*k*j+5]); ve[3*k*j+5]-vd[2*k+7]

      {
       vd[10]=1; ve[20]=11; swap(vd[10],ve[20]);   vd[10]-ve[20]
       vd[10]=1; ve[20]=11; swapif(vd[10]<ve[20]); vd[10]-ve[20]

       vd[k]=1; ve[j]=11; swap(vd[k],ve[j]);   vd[k]-ve[j]
       vd[k]=1; ve[j]=11; swapif(vd[k]<ve[j]); vd[k]-ve[j]

       vd[2*k+4]=1; ve[3*j*k-5]=11; swap(vd[2*k+4],ve[3*j*k-5]);   vd[2*k+4]-ve[3*j*k-5]
       vd[2*k+4]=1; ve[3*j*k-5]=11; swapif(vd[2*k+4]<ve[3*j*k-5]); vd[2*k+4]-ve[3*j*k-5]
     }


           LoadLineFormEAX(_First);     //ArgForm1 -> EAX
           MOVMREG(R_EBX,AddrA1);       //Addr1    -> EBX
           (*
           if tm1 = _Double   then
           begin
               //lea esi,ebx+8*eax
               AddByte3($8D,$34,$C3);       // @VecFloat1[ArgForm1] -> ESI
           end
           else
           if tm1 = _Extended   then
           begin
              //lea   eax,[eax+4*eax]
              AddByte3($8D,$04,$80);
              //add   eax,eax
              AddByte2($01,$C0);
              //lea esi,ebx+eax
              AddByte3($8D,$34,$18);  // @VecFloat1[ArgForm1] -> ESI
           end;
           *)
           LoadArrayAddrCell(R_ESI,R_EBX,R_EAX,tm1);   // @VecFloat1[ArgForm1] -> ESI

           LoadLineFormEAX(_Second);    //ArgForm2  -> EAX
           MOVMREG(R_EBX,AddrA2);       //Addr2     -> EBX
           (*
           if tm2 = _Double   then
           begin
               //lea edi,ebx+8*eax
               AddByte3($8D,$3C,$C3);       // @VecFloat2[ArgForm2] -> EDI
           end
           else
           if tm2 = _Extended   then
           begin
              //lea   eax,[eax+4*eax]:
              AddByte3($8D,$04,$80);
              //add   eax,eax:
              AddByte2($01,$C0);
              //lea edi,ebx+eax
              AddByte3($8D,$3C,$18);  // @VecFloat2[ArgForm2] -> EDI
           end;
           *)
           LoadArrayAddrCell(R_EDI,R_EBX,R_EAX,tm2);   // @VecFloat2[ArgForm2] -> EDI


           (*
           //load
           if tm1 = _Double   then     AddByte2($DD,$06) else    //fld qword ptr [esi]
           if tm1 = _Extended then     AddByte2($DB,$2E);        //fld tbyte ptr [esi]

           if tm2 = _Double   then     AddByte2($DD,$07) else    //fld qword ptr [edi]
           if tm2 = _Extended then     AddByte2($DB,$2F);        //fld tbyte ptr [edi]


           //save
           if tm1 = _Double   then     AddByte2($DD,$1E) else    //fstp qword ptr [esi]
           if tm1 = _Extended then     AddByte2($DB,$3E);        //fstp tbyte ptr [esi]

           if tm2 = _Double   then     AddByte2($DD,$1F) else    //fstp qword ptr [edi]
           if tm2 = _Extended then     AddByte2($DB,$3F);        //fstp tbyte ptr [edi]


           CheckStack(2);
           CheckStack(-2);
           *)

           //load
           FLDREG(R_ESI,tm1);
           FLDREG(R_EDI,tm2);

           if Com = CM_SWAPIF then
           begin
             FCOMI;
             JMPC(9,tif);
           end;

           //save
           FSTPREG(R_ESI,tm1);
           FSTPREG(R_EDI,tm2);

           if Com = CM_SWAPIF then
           begin
             JMP(4);
             FSTP0;
             FSTP0;
             CheckStack(2);     //коррекция на излишние fstp
           end;


           SetReg(R_ESI);
           SetReg(R_EDI);
           SetReg(R_EAX);
           SetReg(R_EBX);

     end
     else
     if ((ArgForm1 = _IntConst) or (ArgForm1 = _IntVar) or (ArgForm1 = _IntForm)) and (ArgForm2 = _NOT_FOUND) then
     begin
                    //vs[2*k+7]=2; ve[3*k*y+5]=12; swap(vs[2*k+7],ve[3*k*y+5]); ve[3*k*y+5]-vs[2*k+7]
                    //vd[2*k+7]=2; ve[3*k*y+5]=12; swap(vd[2*k+7],ve[3*k*y+5]); ve[3*k*y+5]-vd[2*k+7]
      {
       vd[10]=1; ve[y]=11; swap(vd[10],ve[y]);   vd[10]-ve[y]
       vd[10]=1; ve[y]=11; swapif(vd[10]<ve[y]); vd[10]-ve[y]

       vd[k]=1; ve[y]=11; swap(vd[k],ve[y]);   vd[k]-ve[y]
       vd[k]=1; ve[y]=11; swapif(vd[k]<ve[y]); vd[k]-ve[y]

       vd[2*k+4]=1; ve[y]=11; swap(vd[2*k+4],ve[y]);   vd[2*k+4]-ve[y]
       vd[2*k+4]=1; ve[y]=11; swapif(vd[2*k+4]<ve[y]); vd[2*k+4]-ve[y]
     }


           LoadArg1;

           LoadLineFormEAX(_First);     //ArgForm1 -> EAX
           MOVMREG(R_EBX,AddrA1);       //Addr1    -> EBX
           (*
           if tm1 = _Double   then
           begin
               //lea esi,ebx+8*eax
               AddByte3($8D,$34,$C3);       // @VecFloat1[ArgForm1] -> ESI
           end
           else
           if tm1 = _Extended   then
           begin
              //lea   eax,[eax+4*eax]
              AddByte3($8D,$04,$80);
              //add   eax,eax
              AddByte2($01,$C0);
              //lea esi,ebx+eax
              AddByte3($8D,$34,$18);  // @VecFloat1[ArgForm1] -> ESI
           end;
           *)
           LoadArrayAddrCell(R_ESI,R_EBX,R_EAX,tm1);   // @VecFloat1[ArgForm1] -> ESI

           //vec[stack]
           //FXCH1;
           (*
           PUSHCW;   {.227}
           FLDCW(TAddress(@FCW1));
           MEM:=WriteDataA(0,_Integer);
           FISTP(MEM);
           POPCW;      {.227}   //FLDCW(TAddress(@FCW2));
           MOVMA(MEM);                  // Expr2 -> EAX
           *)
           TRUNCR(R_EAX);

           MOVMREG(R_EBX,AddrA2);       //Addr2  -> EBX
           (*
           if tm2 = _Double   then
           begin
               //lea edi,ebx+8*eax
               AddByte3($8D,$3C,$C3);       // @VecFloat2[ArgForm2] -> EDI
           end
           else
           if tm2 = _Extended   then
           begin
              //lea   eax,[eax+4*eax]:
              AddByte3($8D,$04,$80);
              //add   eax,eax:
              AddByte2($01,$C0);
              //lea edi,ebx+eax
              AddByte3($8D,$3C,$18);  // @VecFloat2[ArgForm2] -> EDI
           end;
          *)
          LoadArrayAddrCell(R_EDI,R_EBX,R_EAX,tm2);   // @VecFloat2[ArgForm2] -> EDI

          (*
          //load
           if tm1 = _Double   then     AddByte2($DD,$06) else    //fld qword ptr [esi]
           if tm1 = _Extended then     AddByte2($DB,$2E);        //fld tbyte ptr [esi]

           if tm2 = _Double   then     AddByte2($DD,$07) else    //fld qword ptr [edi]
           if tm2 = _Extended then     AddByte2($DB,$2F);        //fld tbyte ptr [edi]


           //save
           if tm1 = _Double   then     AddByte2($DD,$1E) else    //fstp qword ptr [esi]
           if tm1 = _Extended then     AddByte2($DB,$3E);        //fstp tbyte ptr [esi]

           if tm2 = _Double   then     AddByte2($DD,$1F) else    //fstp qword ptr [edi]
           if tm2 = _Extended then     AddByte2($DB,$3F);        //fstp tbyte ptr [edi]

           CheckStack(2);
           CheckStack(-2);
           *)


           //load
           FLDREG(R_ESI,tm1);
           FLDREG(R_EDI,tm2);

           if Com = CM_SWAPIF then
           begin
             FCOMI;
             JMPC(9,tif);
           end;


           //save
           FSTPREG(R_ESI,tm1);
           FSTPREG(R_EDI,tm2);


           if Com = CM_SWAPIF then
           begin
             JMP(4);
             FSTP0;
             FSTP0;
             CheckStack(2);     //коррекция на излишние fstp
           end;

           SetReg(R_ESI);
           SetReg(R_EDI);
           SetReg(R_EAX);
           SetReg(R_EBX);

     end
     else
     if ((ArgForm2 = _IntConst) or (ArgForm2 = _IntVar) or (ArgForm2 = _IntForm)) and (ArgForm1 = _NOT_FOUND) then
     begin

                    //vs[2*x+7]=2; ve[3*k*j+5]=12; swap(vs[2*x+7],ve[3*k*j+5]); ve[3*k*j+5]-vs[2*x+7]
                    //vd[2*x+7]=2; ve[3*k*j+5]=12; swap(vd[2*x+7],ve[3*k*j+5]); ve[3*k*j+5]-vd[2*x+7]
     {
       vd[10]=1; ve[y]=11; swap(ve[y],vd[10]);   vd[10]-ve[y]
       vd[10]=1; ve[y]=11; swapif(ve[y]>vd[10]); vd[10]-ve[y]

       vd[k]=1; ve[y]=11; swap(ve[y],vd[k]);   vd[k]-ve[y]
       vd[k]=1; ve[y]=11; swapif(ve[y]>vd[k]); vd[k]-ve[y]

       vd[2*k+4]=1; ve[y]=11; swap(ve[y],vd[2*k+4]);   vd[2*k+4]-ve[y]
       vd[2*k+4]=1; ve[y]=11; swapif(ve[y]>vd[2*k+4]); vd[2*k+4]-ve[y]
     }



           LoadArg1;
           //vec[stack]
           //FXCH1;
           (*
           PUSHCW;   {.227}
           FLDCW(TAddress(@FCW1));
           MEM:=WriteDataA(0,_Integer);
           FISTP(MEM);
           POPCW;      {.227}   //FLDCW(TAddress(@FCW2));
           MOVMA(MEM);                  // Expr1 -> EAX
           *)
           TRUNCR(R_EAX);
           MOVMREG(R_EBX,AddrA1);        //Addr1  -> EBX
           (*
           if tm1 = _Double   then
           begin
               //lea esi,ebx+8*eax
               AddByte3($8D,$34,$C3);       // @VecFloat1[ArgForm1] -> ESI
           end
           else
           if tm1 = _Extended   then
           begin
              //lea   eax,[eax+4*eax]
              AddByte3($8D,$04,$80);
              //add   eax,eax
              AddByte2($01,$C0);
              //lea esi,ebx+eax
              AddByte3($8D,$34,$18);  // @VecFloat1[ArgForm1] -> ESI
           end;
           *)
           LoadArrayAddrCell(R_ESI,R_EBX,R_EAX,tm1);   // @VecFloat1[ArgForm1] -> ESI

           LoadLineFormEAX(_Second);     //ArgForm2 -> EAX
           MOVMREG(R_EBX,AddrA2);        //Addr2    -> EBX
           (*
           if tm2 = _Double   then
           begin
               //lea edi,ebx+8*eax
               AddByte3($8D,$3C,$C3);       // @VecFloat2[ArgForm2] -> EDI
           end
           else
           if tm2 = _Extended   then
           begin
              //lea   eax,[eax+4*eax]:
              AddByte3($8D,$04,$80);
              //add   eax,eax:
              AddByte2($01,$C0);
              //lea edi,ebx+eax
              AddByte3($8D,$3C,$18);  // @VecFloat2[ArgForm2] -> EDI
           end;
           *)

           LoadArrayAddrCell(R_EDI,R_EBX,R_EAX,tm2);   // @VecFloat2[ArgForm2] -> EDI
           (*
          //load
           if tm1 = _Double   then     AddByte2($DD,$06) else    //fld qword ptr [esi]
           if tm1 = _Extended then     AddByte2($DB,$2E);        //fld tbyte ptr [esi]

           if tm2 = _Double   then     AddByte2($DD,$07) else    //fld qword ptr [edi]
           if tm2 = _Extended then     AddByte2($DB,$2F);        //fld tbyte ptr [edi]


           //save
           if tm1 = _Double   then     AddByte2($DD,$1E) else    //fstp qword ptr [esi]
           if tm1 = _Extended then     AddByte2($DB,$3E);        //fstp tbyte ptr [esi]

           if tm2 = _Double   then     AddByte2($DD,$1F) else    //fstp qword ptr [edi]
           if tm2 = _Extended then     AddByte2($DB,$3F);        //fstp tbyte ptr [edi]

           CheckStack(2);
           CheckStack(-2);
           *)

           //load
           FLDREG(R_ESI,tm1);
           FLDREG(R_EDI,tm2);

           if Com = CM_SWAPIF then
           begin
             FCOMI;
             JMPC(9,tif);
           end;

           //save
           FSTPREG(R_ESI,tm1);
           FSTPREG(R_EDI,tm2);

           if Com = CM_SWAPIF then
           begin
             JMP(4);
             FSTP0;
             FSTP0;
             CheckStack(2);     //коррекция на излишние fstp
           end;

           SetReg(R_ESI);
           SetReg(R_EDI);
           SetReg(R_EAX);
           SetReg(R_EBX);

     end
     else
     if  (ArgForm1 = _NOT_FOUND) and (ArgForm2 = _NOT_FOUND) then
     begin

           //vs[2*x+7]=2; ve[3*k*y+5]=12; swap(vs[2*x+7],ve[3*k*y+5]); ve[3*k*y+5]-vs[2*x+7]
           //vd[2*x+7]=2; ve[3*k*y+5]=12; swap(vd[2*x+7],ve[3*k*y+5]); ve[3*k*y+5]-vd[2*x+7]

    {

       vd[x]=1; ve[y]=11; swap(vd[x],ve[y]);   vd[x]-ve[y]
       vd[x]=1; ve[y]=11; swapif(vd[x]<ve[y]); vd[x]-ve[y]
     }


           LoadArg2(_Back);
                  //ST(0)      ST(1)
           //vec2[stack2],vec1[stack1]
           //FXCH1;
           PUSHCW;   {.227}
           FLDCW(TAddress(@FCW1));
           MEM:=WriteDataA(0,_Integer);
           FISTP(MEM);
           MEM1:=WriteDataA(0,_Integer);
           FISTP(MEM1);
           POPCW;      {.227}   //FLDCW(TAddress(@FCW2));

           MOVMA(MEM);                  // Expr2->EAX
           MOVMREG(R_EBX,AddrA2);       //Addr2->EBX
           (*
           if tm2 = _Double   then
           begin
               //lea edi,ebx+8*eax
               AddByte3($8D,$3C,$C3);       // @VecFloat2[ArgForm2] -> EDI
           end
           else
           if tm2 = _Extended   then
           begin
              //lea   eax,[eax+4*eax]:
              AddByte3($8D,$04,$80);
              //add   eax,eax:
              AddByte2($01,$C0);
              //lea edi,ebx+eax
              AddByte3($8D,$3C,$18);  // @VecFloat2[ArgForm2] -> EDI
           end;
           *)
           LoadArrayAddrCell(R_EDI,R_EBX,R_EAX,tm2);   // @VecFloat2[ArgForm2] -> EDI


           MOVMA(MEM1);                 // Expr1->EAX
           MOVMREG(R_EBX,AddrA1);       //Addr1->EBX
           (*
           if tm1 = _Double   then
           begin
               //lea esi,ebx+8*eax
               AddByte3($8D,$34,$C3);       // @VecFloat1[ArgForm1] -> ESI
           end
           else
           if tm1 = _Extended   then
           begin
              //lea   eax,[eax+4*eax]
              AddByte3($8D,$04,$80);
              //add   eax,eax
              AddByte2($01,$C0);
              //lea esi,ebx+eax
              AddByte3($8D,$34,$18);  // @VecFloat1[ArgForm1] -> ESI
           end;
           *)

           LoadArrayAddrCell(R_ESI,R_EBX,R_EAX,tm1);   // @VecFloat1[ArgForm1] -> ESI

           (*
           //load
           if tm1 = _Double   then     AddByte2($DD,$06) else    //fld qword ptr [esi]
           if tm1 = _Extended then     AddByte2($DB,$2E);        //fld tbyte ptr [esi]

           if tm2 = _Double   then     AddByte2($DD,$07) else    //fld qword ptr [edi]
           if tm2 = _Extended then     AddByte2($DB,$2F);        //fld tbyte ptr [edi]


           //save
           if tm1 = _Double   then     AddByte2($DD,$1E) else    //fstp qword ptr [esi]
           if tm1 = _Extended then     AddByte2($DB,$3E);        //fstp tbyte ptr [esi]

           if tm2 = _Double   then     AddByte2($DD,$1F) else    //fstp qword ptr [edi]
           if tm2 = _Extended then     AddByte2($DB,$3F);        //fstp tbyte ptr [edi]

           CheckStack(2);
           CheckStack(-2);
           *)

           //load
           FLDREG(R_ESI,tm1);
           FLDREG(R_EDI,tm2);

           if Com = CM_SWAPIF then
           begin
             FCOMI;
             JMPC(9,tif);
           end;

           //save
           FSTPREG(R_ESI,tm1);
           FSTPREG(R_EDI,tm2);

           if Com = CM_SWAPIF then
           begin
             JMP(4);
             FSTP0;
             FSTP0;
             CheckStack(2);     //коррекция на излишние fstp
           end;

           SetReg(R_ESI);
           SetReg(R_EDI);
           SetReg(R_EAX);
           SetReg(R_EBX);


     end;


 end  // of swap(FloatArray,FloatArray)
 else
 if GNode^.AI = 21 then            // SWAP,  SWAPIF   swap(FloatArray,FloatVar)   swap(FloatVar,FloatArray)
 begin

     AddrA1:=Alg.Obj[GNode^.NObj].Addr;
     ArgForm1:=GNode^.TA1;
     tm1:=Alg.Obj[GNode^.NObj].MType;
     Adr2:=Alg.Obj[GNode^.NV2].Addr;
     tm2:=Alg.Obj[GNode^.NV2].MType;
     ts2:=GNode^.TS2;
     if ts2 = _IM then Adr2:=Alg.Obj[NV2].AddrIM;


     if (ArgForm1 = _IntConst) or (ArgForm1 = _IntVar) or (ArgForm1 = _IntForm) then
     begin
                                                                               //swap(vd2[k],x); x
                                                                               //swap(ve2[2*k+3*j-1],y); y
                                                                               //swap(vd2[k],z1.re); z1.re
     {
       vd[10]=1; y=11; swap(y,vd[10]);   vd[10]-y
       vd[10]=1; y=11; swapif(y>vd[10]); vd[10]-y
       vd[10]=1; z1.im=11; swap(z1.im,vd[10]);   vd[10]-z1.im
       vd[10]=1; z1.im=11; swapif(z1.im>vd[10]); vd[10]-z1.im

       vd[j]=1; y=11; swap(y,vd[j]);   vd[j]-y
       vd[j]=1; y=11; swapif(y>vd[j]); vd[j]-y
       vd[j]=1; z1.im=11; swap(z1.im,vd[j]);   vd[j]-z1.im
       vd[j]=1; z1.im=11; swapif(z1.im>vd[j]); vd[j]-z1.im

       vd[2*k+3]=1; y=11; swap(y,vd[2*k+3]);   vd[2*k+3]-y
       vd[2*k+3]=1; y=11; swapif(y>vd[2*k+3]); vd[2*k+3]-y
       vd[2*k+3]=1; z1.im=11; swap(z1.im,vd[2*k+3]);   vd[2*k+3]-z1.im
       vd[2*k+3]=1; z1.im=11; swapif(z1.im>vd[2*k+3]); vd[2*k+3]-z1.im

       ve[2*k+3]=1; z1.re=11; swapif(ve[2*k+3]<z1.re); ve[2*k+3]-z1.re


     }

                                                                           //swap(ve2[2*k+3*j-1],z1.im); z1.im


           LoadLineFormEAX(_First);     //ArgForm1 -> EAX
           MOVMREG(R_EBX,AddrA1);       //Addr1    -> EBX
           LoadArrayAddrCell(R_EBX,R_EBX,R_EAX,tm1);   // @VecFloat1[ArgForm1] -> EBX

           //load
            //_FloatArray
           FLDREG(R_EBX,tm1);
           //_FloatVar
           FLD(Adr2,tm2);

           if Com = CM_SWAPIF then
           begin
              //swap использует один вид: swap(vec[],var) для swap(vec[],var) и swap(var,vec[])
              //поэтому во 2-м случае нужно перевернуть условие сравнения:
              if GNode.DI = _FloatVar then
              begin
                if tif = _JNB  then  tif:=_JBE else
                if tif = _JBE  then  tif:=_JNB;
              end;

              FCOMI;
              JMPC(13,tif);
           end;

           //save
           //_FloatArray
           FSTPREG(R_EBX,tm1);
           //_FloatVar
           FSTPM(Adr2,tm2);

           if Com = CM_SWAPIF then
           begin
             JMP(4);
             FSTP0;
             FSTP0;
             CheckStack(2);     //коррекция на излишние fstp
           end;

           {
           if tm1 = _Double   then
           begin
               //lea ebx,ebx+8*eax
               AddByte3($8D,$1C,$C3);       // @VecFloat1[ArgForm1] -> EBX
           end
           else
           if tm1 = _Extended   then
           begin
              //lea   eax,[eax+4*eax]
              AddByte3($8D,$04,$80);
              //add   eax,eax
              AddByte2($01,$C0);
              //lea ebx,ebx+eax
              AddByte3($8D,$1C,$18);  // @VecFloat1[ArgForm1] -> EBX
           end;
           }

            {
            //load
           if tm1 = _Double   then     AddByte2($DD,$03) else    //fld qword ptr [ebx]
           if tm1 = _Extended then     AddByte2($DB,$2B);        //fld tbyte ptr [ebx]
           CheckStack(1);

           FLD(Adr2,tm2);

            //save
           if tm1 = _Double   then     AddByte2($DD,$1B) else    //fstp qword ptr [ebx]
           if tm1 = _Extended then     AddByte2($DB,$3B);        //fstp tbyte ptr [ebx]
           CheckStack(-1);

           FSTPM(Adr2,tm2);
           }

           SetReg(R_ECX);
           SetReg(R_EAX);
           SetReg(R_EBX);
     end
     else
     if  (ArgForm1 = _NOT_FOUND) then      //FloatArray1[Expr1]<->FloatVar2
     begin
                                                                              //swap(vd2[k*y],x); x
                                                                              //swap(ve2[k*x+3*j-1],y); y
                                                                              //swap(vd2[x],z1.re); z1.re
       {
       vd[x]=1; y=11; swap(y,vd[x]);   vd[x]-y
       vd[x]=1; y=11; swapif(y>vd[x]); vd[x]-y
       vd[x]=1; z1.im=11; swap(z1.im,vd[x]);   vd[x]-z1.im
       vd[x]=1; z1.im=11; swapif(z1.im>vd[x]); vd[x]-z1.im

       ve[x]=1; z1.re=11; swapif(ve[x]<z1.re); ve[x]-z1.re


     }
       //swap(ve2[2*x+3*j-1],z1.im); z1.im

           LoadArg1;
           (*
           PUSHCW;   {.227}
           FLDCW(TAddress(@FCW1));
           MEM:=WriteDataA(0,_Integer);
           FISTP(MEM);
           POPCW;      {.227}   //FLDCW(TAddress(@FCW2));
           MOVMA(MEM);                 // Expr1->EAX
           *)
           TRUNCR(R_EAX);

           MOVMREG(R_EBX,AddrA1);       //Addr1->EBX

           LoadArrayAddrCell(R_EBX,R_EBX,R_EAX,tm1);   // @VecFloat1[ArgForm1] -> EBX

           //load
            //_FloatArray
           FLDREG(R_EBX,tm1);
           //_FloatVar
           FLD(Adr2,tm2);

           if Com = CM_SWAPIF then
           begin
               //swap использует один вид: swap(vec[],var) для swap(vec[],var) и swap(var,vec[])
               //поэтому во 2-м случае нужно перевернуть условие сравнения:
              if GNode.DI = _FloatVar then
              begin
                if tif = _JNB  then  tif:=_JBE else
                if tif = _JBE  then  tif:=_JNB;
              end;

              FCOMI;
              JMPC(13,tif);
           end;


           //save
           //_FloatArray
           FSTPREG(R_EBX,tm1);
           //_FloatVar
           FSTPM(Adr2,tm2);

           if Com = CM_SWAPIF then
           begin
             JMP(4);
             FSTP0;
             FSTP0;
             CheckStack(2);     //коррекция на излишние fstp
           end;

           {
           if tm1 = _Double   then
           begin
               //lea ebx,ebx+8*eax
               AddByte3($8D,$1C,$C3);       // @VecFloat1[ArgForm1] -> EBX
           end
           else
           if tm1 = _Extended   then
           begin
              //lea   eax,[eax+4*eax]
              AddByte3($8D,$04,$80);
              //add   eax,eax
              AddByte2($01,$C0);
              //lea ebx,ebx+eax
              AddByte3($8D,$1C,$18);  // @VecFloat1[ArgForm1] -> EBX
           end;
           }
           {
           //load
           if tm1 = _Double   then     AddByte2($DD,$03) else    //fld qword ptr [ebx]
           if tm1 = _Extended then     AddByte2($DB,$2B);        //fld tbyte ptr [ebx]
           CheckStack(1);

           FLD(Adr2,tm2);

            //save
           if tm1 = _Double   then     AddByte2($DD,$1B) else    //fstp qword ptr [ebx]
           if tm1 = _Extended then     AddByte2($DB,$3B);        //fstp tbyte ptr [ebx]
           CheckStack(-1);

           FSTPM(Adr2,tm2);
           }



           SetReg(R_ECX);
           SetReg(R_EAX);
           SetReg(R_EBX);

     end;

 end;




end;




procedure TForevalH.SWAPIF_C;
var
N,nv1,nv2,NF,tf,tv1,ts1,tv2,ts2,sh1,sh2,TM1,TM2,tva,ArgForm1,ArgForm2,tif: Integer;
Adr1,Adr2,Adr1IM,Adr2IM, AddrA1, AddrA2: TAddress;
begin


 nv1:=GNode^.NV1;
 nv2:=GNode^.NV2;

 ts1:=GNode^.TS1;
 ts2:=GNode^.TS2;

 tif:=GNode.tif;

 if (GNode^.AI >= 1) and  (GNode^.AI <= 6) then
 begin
    Adr1:=Alg.Obj[nv1].Addr;
    Adr1IM:=Alg.Obj[nv1].AddrIM;      {.343}
    tv1:=Alg.Obj[nv1].TypeF;
    tm1:=Alg.Obj[nv1].MType;
    sh1:=GetSizeSh(tm1);


    Adr2:=Alg.Obj[nv2].Addr;
    Adr2IM:=Alg.Obj[nv2].AddrIM;       {.343}
    tv2:=Alg.Obj[nv2].TypeF;
    tm2:=Alg.Obj[nv2].MType;
    sh2:=GetSizeSh(tm2);
 end;


 //SWAPIF(FloatVar1 <=> FloatVar2)  ; x=1; y=10; swapif(x<y); x
 if (GNode^.AI = 1) {or (GNode^.AI = 2)} then
 begin
   {FLD(Adr1,tm1);
   FLD(Adr2,tm2);
   FSTPM(Adr1,tm1);
   FSTPM(Adr2,tm2);}

   {
   if tif = _JNB then  //swapif(x>y)
   begin
      FLD(Adr1,tm1);
      FLD(Adr2,tm2);
      FCOMI;
      JMPC(17,_JNB);
      FSTPM(Adr1,tm1);
      FSTPM(Adr2,tm2);
      JMP(4);
      FSTP0;
      FSTP0;
   end
   else
   if tif = _JZ then  //swapif(x<>y)
   begin
      FLD(Adr1,tm1);
      FLD(Adr2,tm2);
      FCOMI;
      JMPC(17,_JZ);
      FSTPM(Adr1,tm1);
      FSTPM(Adr2,tm2);
      JMP(4);
      FSTP0;
      FSTP0;
   end;
   }

      FLD(Adr1,tm1);
      FLD(Adr2,tm2);
      FCOMI;
      JMPC(17,tif);
      FSTPM(Adr1,tm1);
      FSTPM(Adr2,tm2);
      JMP(4);
      FSTP0;
      FSTP0;

  CheckStack(2);     //коррекция на излишние fstp
 end
 else
  //SWAPIF(IntVar1 <=> IntVar2)        ;n=1; k=10; swapif(n<k); n
 if  (GNode^.AI = 2) then
 begin
   {
   MOVMREG(R_EAX,Adr1);
   MOVMREG(R_EBX,Adr2);
   MOVREGM(R_EAX,Adr2);
   MOVREGM(R_EBX,Adr1);
   }
    MOVMREG(R_EAX,Adr1);
    MOVMREG(R_EBX,Adr2);
    CMPR(R_EBX,R_EAX);
    JMPC(12,tif);
    MOVREGM(R_EAX,Adr2);
    MOVREGM(R_EBX,Adr1);

  

 end
 else
 (*
 if (GNode^.AI = 3) then
 begin
   FLD(Adr1,tm1);
   //FLD(Adr1+sh1,tm1);
   FLD(Adr1IM,tm1);        {.343}
   FLD(Adr2,tm2);
   //FLD(Adr2+sh2,tm2);
   FLD(Adr2IM,tm2);       {.343}

   //FSTPM(Adr1+sh1,tm1);
   FSTPM(Adr1IM,tm1);       {.343}
   FSTPM(Adr1,tm1);
   //FSTPM(Adr2+sh2,tm2);
   FSTPM(Adr2IM,tm2);     {.343}
   FSTPM(Adr2,tm2);
   //CheckStack(4);
   //CheckStack(-4);
 end
 else
 *)
 //SWAPIF(CxVar1.re/im <=> CxVar2.re/im)
 if (GNode^.AI = 6) then      //swapif(z1.re>z2.im)
 begin
  (*
   if ts1 = _RE then FLD(Adr1,tm1) else  if ts1 = _IM then FLD(Adr1IM,tm1);//FLD(Adr1+sh1,tm1);   {.343}
   if ts2 = _RE then FLD(Adr2,tm2) else  if ts2 = _IM then FLD(Adr2IM,tm2);//FLD(Adr2+sh2,tm2);   {.343}

   if ts1 = _RE then FSTPM(Adr1,tm1) else  if ts1 = _IM then FSTPM(Adr1IM,tm1);//FSTPM(Adr1+sh1,tm1);  {.343}
   if ts2 = _RE then FSTPM(Adr2,tm2) else  if ts2 = _IM then FSTPM(Adr2IM,tm2);//FSTPM(Adr2+sh2,tm2);   {.343}
   *)

   //load
   if ts1 = _RE then FLD(Adr1,tm1) else  if ts1 = _IM then FLD(Adr1IM,tm1);
   if ts2 = _RE then FLD(Adr2,tm2) else  if ts2 = _IM then FLD(Adr2IM,tm2);

   FCOMI;
   JMPC(17,tif);

   //save
   if ts1 = _RE then FSTPM(Adr1,tm1) else  if ts1 = _IM then FSTPM(Adr1IM,tm1);//FSTPM(Adr1+sh1,tm1);  {.343}
   if ts2 = _RE then FSTPM(Adr2,tm2) else  if ts2 = _IM then FSTPM(Adr2IM,tm2);//FSTPM(Adr2+sh2,tm2);   {.343}

   JMP(4);
   FSTP0;
   FSTP0;

   CheckStack(2);     //коррекция на излишние fstp
   //CheckStack(-2);
 end
 else
 //SWAPIF(FloatVar1 <=> CxVar2.re/im)
 if (GNode^.AI = 4) then       //swapif(x>z1.im)
 begin
   //load
   FLD(Adr1,tm1);
   if ts2 = _RE then FLD(Adr2,tm2) else  if ts2 = _IM then FLD(Adr2IM,tm2);

   FCOMI;
   JMPC(17,tif);

   //save
   FSTPM(Adr1,tm1);
   if ts2 = _RE then FSTPM(Adr2,tm2) else  if ts2 = _IM then FSTPM(Adr2IM,tm2);

   JMP(4);
   FSTP0;
   FSTP0;

   CheckStack(2);     //коррекция на излишние fstp
   //CheckStack(-2);
 end
 else
  //SWAPIF(CxVar1.re/im <=> FloatVar2)
 if GNode^.AI = 5 then       //swapif(z1.im>x)
 begin
   //load
   if ts1 = _RE then FLD(Adr1,tm1) else  if ts1 = _IM then FLD(Adr1IM,tm1);//FLD(Adr1+sh1,tm1);        {.343}
   FLD(Adr2,tm2);

   FCOMI;
   JMPC(17,tif);

   //save
   if ts1 = _RE then FSTPM(Adr1,tm1) else  if ts1 = _IM then FSTPM(Adr1IM,tm1);//FSTPM(Adr1+sh1,tm1);   {.343}
   FSTPM(Adr2,tm2);

   JMP(4);
   FSTP0;
   FSTP0;

   CheckStack(2);     //коррекция на излишние fstp
   //CheckStack(-2);
 end
 else
  //SWAPIF(IntArray1[] <=> IntArray2[])
 if GNode^.AI = 10 then             //swap(IntArray,IntArray)
 begin
     AddrA1:=Alg.Obj[GNode^.NObj].Addr;
     AddrA2:=Alg.Obj[GNode^.NObj2].Addr;
     ArgForm1:=GNode^.TA1;
     ArgForm2:=GNode^.TA2;

     //swap(IntArray,IntArray)
     if  ((ArgForm1 = _IntConst) or (ArgForm1 = _IntVar) or (ArgForm1 = _IntForm)) and ((ArgForm2 = _IntConst) or (ArgForm2 = _IntVar) or (ArgForm2 = _IntForm)) then
     begin
                                                                        //vi1[2*k+4]=1; vi2[j*j+2]=10;  swapif(vi1[2*k+4] < vi2[j*j+2]); vi1[2*k+4]
                                                                        //vi1[2*k+4]=1; vi2[j*j+2]=10;  swapif(vi1[2*k+4] > vi2[j*j+2]); vi1[2*k+4]
           LoadLineFormEAX(_First);     //ArgForm1
           MOVMREG(R_EBX,AddrA1);       //Addr1->EBX

           //lea esi,ebx+4*eax
           AddByte($8D); AddByte($34);AddByte($83);      // @VecInt1[ArgForm1] -> ESI

           LoadLineFormEAX(_Second);    //ArgForm2
           MOVMREG(R_EBX,AddrA2);       //Addr2->EBX

           //lea edi,ebx+4*eax
           AddByte($8D); AddByte($3C);AddByte($83);      // @VecInt2[ArgForm2] -> EDI

           //mov eax,[esi]
           AddByte($8B); AddByte($06);     // VecInt1[ArgForm1] -> EAX
           //mov ebx,[edi]
           AddByte($8B); AddByte($1F);     // VecInt2[ArgForm2] -> EBX


           CMPR(R_EBX,R_EAX);
           JMPC(4,tif);

           //mov [edi],eax
           AddByte($89); AddByte($07);     // EAX -> VecInt2[ArgForm2]
           //mov [esi],ebx
           AddByte($89); AddByte($1E);     // EBX -> VecInt1[ArgForm1]

           SetReg(R_ESI);
           SetReg(R_EDI);
           SetReg(R_EAX);
           SetReg(R_EBX);

     end
     else
     if ((ArgForm1 = _IntConst) or (ArgForm1 = _IntVar) or (ArgForm1 = _IntForm)) and (ArgForm2 = _NOT_FOUND) then     //swap(vi1[2*k+4],vi2[j*(n+2)]); vi1[2*k+4]
     begin
                                                      //vi1[2*k+4]=1; vi2[j^2+2]=10;  swapif(vi1[2*k+4] < vi2[j^2+2]); vi1[2*k+4]
                                                      //vi1[2*k+4]=1; vi2[j^2+2]=10;  swapif(vi1[2*k+4] > vi2[j^2+2]); vi1[2*k+4]
           LoadArg1;

           LoadLineFormEAX(_First);     //ArgForm1
           MOVMREG(R_EBX,AddrA1);       //Addr1->EBX
           //lea esi,ebx+4*eax
           AddByte($8D); AddByte($34);AddByte($83);      // @VecInt1[ArgForm1] -> ESI


           //vec[stack]
           //FXCH1;
           (*
           PUSHCW;   {.227}
           FLDCW(TAddress(@FCW1));
           MEM:=WriteDataA(0,_Integer);
           FISTP(MEM);
           POPCW;      {.227}   //FLDCW(TAddress(@FCW2));
           MOVMA(MEM);    // Expr2->EAX
           *)
           TRUNCR(R_EAX);

           MOVMREG(R_EBX,AddrA2);       //Addr2->EBX
           //lea edi,ebx+4*eax
           AddByte($8D); AddByte($3C);AddByte($83);      // @VecInt2[Expr2] -> EDI

           //mov eax,[esi]
           AddByte($8B); AddByte($06);     // VecInt1[ArgForm1] -> EAX
           //mov ebx,[edi]
           AddByte($8B); AddByte($1F);     // VecInt2[Expr2] -> EBX

           CMPR(R_EBX,R_EAX);
           JMPC(4,tif);

           //mov [edi],eax
           AddByte($89); AddByte($07);     // EAX -> VecInt2[Expr2]
           //mov [esi],ebx
           AddByte($89); AddByte($1E);     // EBX -> VecInt1[ArgForm1]


           //CheckStack(-1);
           SetReg(R_ESI);
           SetReg(R_EDI);
           SetReg(R_EAX);
           SetReg(R_EBX);

     end
     else
     if ((ArgForm2 = _IntConst) or (ArgForm2 = _IntVar) or (ArgForm2 = _IntForm)) and (ArgForm1 = _NOT_FOUND) then     //swap(vi2[j*(n+2)],vi1[2*k+4]); vi1[2*k+4]
     begin
                                            //vi1[2*k+4]=1; vi2[j^2+2]=10;  swapif(vi2[j^2+2] > vi1[2*k+4]); vi1[2*k+4]
                                            //vi1[2*k+4]=1; vi2[j^2+2]=10;  swapif(vi2[j^2+2] < vi1[2*k+4]); vi1[2*k+4]

           LoadArg1;

           LoadLineFormEAX(_Second);     //ArgForm2
           MOVMREG(R_EBX,AddrA2);       //Addr2->EBX
           //lea esi,ebx+4*eax
           AddByte($8D); AddByte($34);AddByte($83);      // @VecInt2[ArgForm2] -> ESI


           //vec[stack]
           //FXCH1;
           (*
           PUSHCW;   {.227}
           FLDCW(TAddress(@FCW1));
           MEM:=WriteDataA(0,_Integer);
           FISTP(MEM);
           POPCW;      {.227}   //FLDCW(TAddress(@FCW2));
           MOVMA(MEM);    // Expr1->EAX
           *)
           TRUNCR(R_EAX);

           MOVMREG(R_EBX,AddrA1);       //Addr1->EBX
           //lea edi,ebx+4*eax
           AddByte($8D); AddByte($3C);AddByte($83);      // @VecInt1[Expr1] -> EDI

           //mov eax,[esi]
           AddByte($8B); AddByte($06);     // VecInt2[ArgForm2] -> EAX
           //mov ebx,[edi]
           AddByte($8B); AddByte($1F);     // VecInt1[Expr1] -> EBX

           CMPR(R_EAX,R_EBX);
           JMPC(4,tif);

           //mov [edi],eax
           AddByte($89); AddByte($07);     // EAX -> VecInt1[Expr1]
           //mov [esi],ebx
           AddByte($89); AddByte($1E);     // EBX -> VecInt2[ArgForm2]


           //CheckStack(-1);
           SetReg(R_ESI);
           SetReg(R_EDI);
           SetReg(R_EAX);
           SetReg(R_EBX);


     end
     else
     if  (ArgForm1 = _NOT_FOUND) and (ArgForm2 = _NOT_FOUND) then    //swap(vi1[x],vi2[y]); vi1[x]
     begin

                                //vi1[2*k^2+4]=1; vi2[j^2+2]=10;  swapif(vi2[j^2+2] > vi1[2*k^2+4]); vi1[2*k^2+4]
                                //vi1[2*k^2+4]=1; vi2[j^2+2]=10;  swapif(vi2[j^2+2] < vi1[2*k^2+4]); vi1[2*k^2+4]

           LoadArg2(_Back);
                  //ST(0)      ST(1)
           //vec2[stack2],vec1[stack1]
           //FXCH1;
           PUSHCW;   {.227}
           FLDCW(TAddress(@FCW1));
           MEM:=WriteDataA(0,_Integer);
           FISTP(MEM);
           MEM1:=WriteDataA(0,_Integer);
           FISTP(MEM1);
           POPCW;      {.227}   //FLDCW(TAddress(@FCW2));

           MOVMA(MEM);    // Expr2->EAX
           MOVMREG(R_EBX,AddrA2);       //Addr2->EBX
           //lea edi,ebx+4*eax
           AddByte($8D); AddByte($3C);AddByte($83);      // @VecInt2[Expr2] -> EDI

           MOVMA(MEM1);    // Expr1->EAX
           MOVMREG(R_EBX,AddrA1);       //Addr1->EBX
           //lea esi,ebx+4*eax
           AddByte($8D); AddByte($34);AddByte($83);      // @VecInt1[Expr1] -> ESI

           //mov eax,[esi]
           AddByte($8B); AddByte($06);     // VecInt2[Expr2] -> EAX
           //mov ebx,[edi]
           AddByte($8B); AddByte($1F);     // VecInt1[Expr1] -> EBX

           CMPR(R_EBX,R_EAX);
           JMPC(4,tif);

           //mov [edi],eax
           AddByte($89); AddByte($07);     // EAX -> VecInt1[Expr1]
           //mov [esi],ebx
           AddByte($89); AddByte($1E);     // EBX -> VecInt2[Expr2]


           //CheckStack(-2);
           SetReg(R_ESI);
           SetReg(R_EDI);
           SetReg(R_EAX);
           SetReg(R_EBX);

     end;

 end   // of swap(IntArray,IntArray)
 else
 //SWAPIF(IntArray[] <=> IntVar)
 if GNode^.AI = 11 then            //swapif(IntArray,IntVar)   swapif(IntVar,IntArray)
 begin                             //n=1; vi[2*k+1]=10; swapif(n < vi[2*k+1]); n
                                   //n=1; vi[2*k+1]=10; swapif(n < vi[2*k+1]); vi[2*k+1]
                                   //n=1; vi[2*k+1]=10; swapif(vi[2*k+1] > n); n
                                   //n=1; vi[2*k+1]=10; swapif(vi[2*k+1] > n); vi[2*k+1]

     AddrA1:=Alg.Obj[GNode^.NObj].Addr;  //IntArray
     ArgForm1:=GNode^.TA1;

     Adr2:=Alg.Obj[GNode^.NV2].Addr;      //IntVar

     if (ArgForm1 = _IntConst) or (ArgForm1 = _IntVar) or (ArgForm1 = _IntForm) then
     begin
        //load
        LoadLineFormEAX(_First);     //ArgForm1
        MOVMREG(R_EBX,AddrA1);       //Addr1->EBX

        //lea ebx,[ebx+4*eax]
        AddByte($8D); AddByte($1C);AddByte($83);      // @VecInt1[ArgForm1] -> EBX
        MOVMREG(R_EAX,Adr2);        //IntVar -> EAX
         //mov ecx,[ebx]
        AddByte($8B); AddByte($0B);  //VecInt1[ArgForm1]->ECX

        //IntVar->EAX; IntArray[indx]->ECX;  @IntArray[indx]->EBX;
        CMPR(R_ECX,R_EAX);
        //swap использует один вид: swap(var,vec[]) для swap(var,vec[]) и swap(vec[],var)
        //поэтому во 2-м случае нужно перевернуть условие сравнения:
        if GNode.DI = _IntArray then
        begin
             if tif = _JNB  then  tif:=_JBE else
             if tif = _JBE  then  tif:=_JNB;
        end;

        JMPC(8,tif);

        //save
        //mov [ebx],eax
        AddByte($89); AddByte($03);  //EAX -> VecInt1[ArgForm1]
        MOVREGM(R_ECX,Adr2);         //ECX -> IntVar

        SetReg(R_ECX);
        SetReg(R_EAX);
        SetReg(R_EBX);
     end
     else
     if  (ArgForm1 = _NOT_FOUND) then      //IntArray1[Expr1]<->IntVar2
     begin
                                           //n=1;  vi[2*k^2+1]=10; swapif(n < vi[2*k^2+1]); n
                                           //n=1;  vi[2*k^2+1]=10; swapif(n < vi[2*k^2+1]); vi[2*k^2+1]
                                           //n=1;  vi[2*k^2+1]=10; swapif(vi[2*k^2+1] > n); n
                                           //n=1;  vi[2*k^2+1]=10; swapif(vi[2*k^2+1] > n); vi[2*k^2+1]
           //load
           LoadArg1;
           (*
           PUSHCW;   {.227}
           FLDCW(TAddress(@FCW1));
           MEM:=WriteDataA(0,_Integer);
           FISTP(MEM);
           POPCW;      {.227}   //FLDCW(TAddress(@FCW2));
           MOVMA(MEM);    // Expr1->EAX
           *)
           TRUNCR(R_EAX);

           MOVMREG(R_EBX,AddrA1);       //Addr1->EBX
           //lea ebx,[ebx+4*eax]
           AddByte($8D); AddByte($1C);AddByte($83);      // @VecInt1[ArgForm1] -> EBX
           MOVMREG(R_EAX,Adr2);        //IntVar -> EAX
           //mov ecx,[ebx]
           AddByte($8B); AddByte($0B);  //VecInt1[ArgForm1]->ECX

           //IntVar->EAX; IntArray[indx]->ECX;  @IntArray[indx]->EBX;
           CMPR(R_ECX,R_EAX);
           //swap использует один вид: swap(var,vec[]) для swap(var,vec[]) и swap(vec[],var)
           //поэтому во 2-м случае нужно перевернуть условие сравнения:
           if GNode.DI = _IntArray then
           begin
             if tif = _JNB  then  tif:=_JBE else
             if tif = _JBE  then  tif:=_JNB;
           end;
           JMPC(8,tif);

           //save
           //mov [ebx],eax
           AddByte($89); AddByte($03);  //EAX -> VecInt1[ArgForm1]
           MOVREGM(R_ECX,Adr2);         //ECX -> IntVar

           SetReg(R_ECX);
           SetReg(R_EAX);
           SetReg(R_EBX);
     end;

 end
 else
 //SWAPIF(FloatArray1[] <=> FloatArray2[])
 if GNode^.AI = 20 then             //swap(FloatArray,FloatArray)
 begin
     AddrA1:=Alg.Obj[GNode^.NObj].Addr;
     AddrA2:=Alg.Obj[GNode^.NObj2].Addr;
     ArgForm1:=GNode^.TA1;
     ArgForm2:=GNode^.TA2;
     tm1:=Alg.Obj[GNode^.NObj].MType;
     tm2:=Alg.Obj[GNode^.NObj2].MType;


    //vd1[2*k+3]=1; vd2[3*k*j+5]=10; swapif(vd1[2*k+3] < vd2[3*k*j+5]); vd1[2*k+3]
     if  ((ArgForm1 = _IntConst) or (ArgForm1 = _IntVar) or (ArgForm1 = _IntForm)) and ((ArgForm2 = _IntConst) or (ArgForm2 = _IntVar) or (ArgForm2 = _IntForm)) then
     begin
                      //vd[2*k+3]=2; ve[3*k*j+5]=12; swapif(ve[3*k*j+5]>vd[2*k+3]); ve[3*k*j+5]-vd[2*k+3]


           LoadLineFormEAX(_First);     //ArgForm1 -> EAX
           MOVMREG(R_EBX,AddrA1);       //Addr1    -> EBX

           (*
           if tm1 = _Double   then
           begin
               //lea esi,ebx+8*eax
               AddByte3($8D,$34,$C3);       // @VecFloat1[ArgForm1] -> ESI
           end
           else
           if tm1 = _Extended   then
           begin
              //lea   eax,[eax+4*eax]
              AddByte3($8D,$04,$80);
              //add   eax,eax
              AddByte2($01,$C0);
              //lea esi,ebx+eax
              AddByte3($8D,$34,$18);  // @VecFloat1[ArgForm1] -> ESI
           end;
           *)
           LoadArrayAddrCell(R_ESI,R_EBX,R_EAX,tm1);   // @VecFloat1[ArgForm1] -> ESI

           LoadLineFormEAX(_Second);    //ArgForm2  -> EAX
           MOVMREG(R_EBX,AddrA2);       //Addr2     -> EBX
           (*
           if tm2 = _Double   then
           begin
               //lea edi,ebx+8*eax
               AddByte3($8D,$3C,$C3);       // @VecFloat2[ArgForm2] -> EDI
           end
           else
           if tm2 = _Extended   then
           begin
              //lea   eax,[eax+4*eax]:
              AddByte3($8D,$04,$80);
              //add   eax,eax:
              AddByte2($01,$C0);
              //lea edi,ebx+eax
              AddByte3($8D,$3C,$18);  // @VecFloat2[ArgForm2] -> EDI
           end;
           *)

           LoadArrayAddrCell(R_EDI,R_EBX,R_EAX,tm2);   // @VecFloat2[ArgForm2] -> EDI

           //load
           FLDREG(R_ESI,tm1);
           FLDREG(R_EDI,tm2);

           FCOMI;
           JMPC(9,tif);

           //save
           FSTPREG(R_ESI,tm1);
           FSTPREG(R_EDI,tm2);
        
           JMP(4);
           FSTP0;
           FSTP0;

      
           CheckStack(2);     //коррекция на излишние fstp

           SetReg(R_ESI);
           SetReg(R_EDI);
           SetReg(R_EAX);
           SetReg(R_EBX);

     end
     else
     //vd1[2*k+3]=1; vd2[3*k^2+1]=10; swapif(vd1[2*k+3] < vd2[3*k^2+1]); vd2[3*k^2+1]
     //ve1[2*k+3]=1; ve2[3*k^2+1]=10; swapif(ve1[2*k+3] < ve2[3*k^2+1]); ve2[3*k^2+1]
     if ((ArgForm1 = _IntConst) or (ArgForm1 = _IntVar) or (ArgForm1 = _IntForm)) and (ArgForm2 = _NOT_FOUND) then
     begin

            //vd[2*x+3]=2; ve[3*k*j+5]=12; swapif(ve[3*k*j+5]>vd[2*x+3]); ve[3*k*j+5]-vd[2*x+3]


           LoadArg1;
           LoadLineFormEAX(_First);     //ArgForm1 -> EAX
           MOVMREG(R_EBX,AddrA1);       //Addr1    -> EBX
           (*
           if tm1 = _Double   then
           begin
               //lea esi,ebx+8*eax
               AddByte3($8D,$34,$C3);       // @VecFloat1[ArgForm1] -> ESI
           end
           else
           if tm1 = _Extended   then
           begin
              //lea   eax,[eax+4*eax]
              AddByte3($8D,$04,$80);
              //add   eax,eax
              AddByte2($01,$C0);
              //lea esi,ebx+eax
              AddByte3($8D,$34,$18);  // @VecFloat1[ArgForm1] -> ESI
           end;
           *)
           LoadArrayAddrCell(R_ESI,R_EBX,R_EAX,tm1);   // @VecFloat1[ArgForm1] -> ESI

           //vec[stack]
           //FXCH1;
           (*
           PUSHCW;   {.227}
           FLDCW(TAddress(@FCW1));
           MEM:=WriteDataA(0,_Integer);
           FISTP(MEM);
           POPCW;      {.227}   //FLDCW(TAddress(@FCW2));
           MOVMA(MEM);                  // Expr2 -> EAX
           *)
           TRUNCR(R_EAX);

           MOVMREG(R_EBX,AddrA2);       //Addr2  -> EBX
           (*
           if tm2 = _Double   then
           begin
               //lea edi,ebx+8*eax
               AddByte3($8D,$3C,$C3);       // @VecFloat2[ArgForm2] -> EDI
           end
           else
           if tm2 = _Extended   then
           begin
              //lea   eax,[eax+4*eax]:
              AddByte3($8D,$04,$80);
              //add   eax,eax:
              AddByte2($01,$C0);
              //lea edi,ebx+eax
              AddByte3($8D,$3C,$18);  // @VecFloat2[ArgForm2] -> EDI
           end;
          *)
           LoadArrayAddrCell(R_EDI,R_EBX,R_EAX,tm2);   // @VecFloat2[ArgForm2] -> EDI

          //load

           FLDREG(R_ESI,tm1);
           FLDREG(R_EDI,tm2);

           FCOMI;
           JMPC(9,tif);

           //save
           FSTPREG(R_ESI,tm1);
           FSTPREG(R_EDI,tm2);


           JMP(4);
           FSTP0;
           FSTP0;


           CheckStack(2);     //коррекция на излишние fstp

           SetReg(R_ESI);
           SetReg(R_EDI);
           SetReg(R_EAX);
           SetReg(R_EBX);

     end
     else
     //vd1[2*k+3]=1; vd2[3*k^2+1]=10; swapif(vd2[3*k^2+1] > vd1[2*k+3]); vd2[3*k^2+1]
     //ve1[2*k+3]=1; ve2[3*k^2+1]=10; swapif(ve2[3*k^2+1] > ve1[2*k+3]); ve2[3*k^2+1]
     if ((ArgForm2 = _IntConst) or (ArgForm2 = _IntVar) or (ArgForm2 = _IntForm)) and (ArgForm1 = _NOT_FOUND) then
     begin
                //vd[2*x+3]=2; ve[3*k*j+5]=12; swapif(vd[2*x+3]<ve[3*k*j+5]); ve[3*k*j+5]-vd[2*x+3]

           LoadArg1;
           //vec[stack]
           //FXCH1;
           (*
           PUSHCW;   {.227}
           FLDCW(TAddress(@FCW1));
           MEM:=WriteDataA(0,_Integer);
           FISTP(MEM);
           POPCW;      {.227}   //FLDCW(TAddress(@FCW2));
           MOVMA(MEM);                  // Expr1 -> EAX
           *)
           TRUNCR(R_EAX);

           MOVMREG(R_EBX,AddrA1);        //Addr1  -> EBX

           (*
           if tm1 = _Double   then
           begin
               //lea esi,ebx+8*eax
               AddByte3($8D,$34,$C3);       // @VecFloat1[ArgForm1] -> ESI
           end
           else
           if tm1 = _Extended   then
           begin
              //lea   eax,[eax+4*eax]
              AddByte3($8D,$04,$80);
              //add   eax,eax
              AddByte2($01,$C0);
              //lea esi,ebx+eax
              AddByte3($8D,$34,$18);  // @VecFloat1[ArgForm1] -> ESI
           end;
           *)
           LoadArrayAddrCell(R_ESI,R_EBX,R_EAX,tm1);   // @VecFloat1[ArgForm1] -> ESI

           LoadLineFormEAX(_Second);     //ArgForm2 -> EAX
           MOVMREG(R_EBX,AddrA2);        //Addr2    -> EBX
           (*
           if tm2 = _Double   then
           begin
               //lea edi,ebx+8*eax
               AddByte3($8D,$3C,$C3);       // @VecFloat2[ArgForm2] -> EDI
           end
           else
           if tm2 = _Extended   then
           begin
              //lea   eax,[eax+4*eax]:
              AddByte3($8D,$04,$80);
              //add   eax,eax:
              AddByte2($01,$C0);
              //lea edi,ebx+eax
              AddByte3($8D,$3C,$18);  // @VecFloat2[ArgForm2] -> EDI
           end;
          *)
          LoadArrayAddrCell(R_EDI,R_EBX,R_EAX,tm2);   // @VecFloat2[ArgForm2] -> EDI

          //load

           FLDREG(R_ESI,tm1);
           FLDREG(R_EDI,tm2);

           FCOMI;
           JMPC(9,tif);

           //save
           FSTPREG(R_ESI,tm1);
           FSTPREG(R_EDI,tm2);

           JMP(4);
           FSTP0;
           FSTP0;

           CheckStack(2); //коррекция на излишние fstp


           SetReg(R_ESI);
           SetReg(R_EDI);
           SetReg(R_EAX);
           SetReg(R_EBX);

     end
     else
      //vd1[2*k^3+3]=1; vd2[3*k^2+1]=10; swapif(vd2[3*k^2+1] > vd1[2*k^3+3]); vd2[3*k^2+1]
      //ve1[2*k^3+3]=1; ve2[3*k^2+1]=10; swapif(ve2[3*k^2+1] > ve1[2*k^3+3]); ve2[3*k^2+1]
     if  (ArgForm1 = _NOT_FOUND) and (ArgForm2 = _NOT_FOUND) then
     begin
                                     //vs[x*y]=2; ve[x+y]=12; swapif(ve[x+y]>vs[x*y]); ve[x+y]-vs[x*y]

           LoadArg2(_Back);
                  //ST(0)      ST(1)
           //vec2[stack2],vec1[stack1]
           //FXCH1;

           PUSHCW;   {.227}
           FLDCW(TAddress(@FCW1));
           MEM:=WriteDataA(0,_Integer);
           FISTP(MEM);
           MEM1:=WriteDataA(0,_Integer);
           FISTP(MEM1);
           POPCW;      {.227}   //FLDCW(TAddress(@FCW2));
           MOVMA(MEM);                  // Expr2->EAX

           MOVMREG(R_EBX,AddrA2);       //Addr2->EBX
           (*
           if tm2 = _Double   then
           begin
               //lea edi,ebx+8*eax
               AddByte3($8D,$3C,$C3);       // @VecFloat2[ArgForm2] -> EDI
           end
           else
           if tm2 = _Extended   then
           begin
              //lea   eax,[eax+4*eax]:
              AddByte3($8D,$04,$80);
              //add   eax,eax:
              AddByte2($01,$C0);
              //lea edi,ebx+eax
              AddByte3($8D,$3C,$18);  // @VecFloat2[ArgForm2] -> EDI
           end;
            *)
           LoadArrayAddrCell(R_EDI,R_EBX,R_EAX,tm2);   // @VecFloat2[ArgForm2] -> EDI


           MOVMA(MEM1);                 // Expr1->EAX
           MOVMREG(R_EBX,AddrA1);       //Addr1->EBX
           (*
           if tm1 = _Double   then
           begin
               //lea esi,ebx+8*eax
               AddByte3($8D,$34,$C3);       // @VecFloat1[ArgForm1] -> ESI
           end
           else
           if tm1 = _Extended   then
           begin
              //lea   eax,[eax+4*eax]
              AddByte3($8D,$04,$80);
              //add   eax,eax
              AddByte2($01,$C0);
              //lea esi,ebx+eax
              AddByte3($8D,$34,$18);  // @VecFloat1[ArgForm1] -> ESI
           end;
           *)
           LoadArrayAddrCell(R_ESI,R_EBX,R_EAX,tm1);   // @VecFloat1[ArgForm1] -> ESI

           //load
           {if tm1 = _Double   then     AddByte2($DD,$06) else    //fld qword ptr [esi]
           if tm1 = _Extended then     AddByte2($DB,$2E);        //fld tbyte ptr [esi]

           if tm2 = _Double   then     AddByte2($DD,$07) else    //fld qword ptr [edi]
           if tm2 = _Extended then     AddByte2($DB,$2F);        //fld tbyte ptr [edi]


           //save
           if tm1 = _Double   then     AddByte2($DD,$1E) else    //fstp qword ptr [esi]
           if tm1 = _Extended then     AddByte2($DB,$3E);        //fstp tbyte ptr [esi]

           if tm2 = _Double   then     AddByte2($DD,$1F) else    //fstp qword ptr [edi]
           if tm2 = _Extended then     AddByte2($DB,$3F);        //fstp tbyte ptr [edi]

           CheckStack(2);
           CheckStack(-2);}

            //load

           FLDREG(R_ESI,tm1);
           FLDREG(R_EDI,tm2);

           FCOMI;
           JMPC(9,tif);

           //save
           FSTPREG(R_ESI,tm1);
           FSTPREG(R_EDI,tm2);

           JMP(4);
           FSTP0;
           FSTP0;

           CheckStack(2); //коррекция на излишние fstp


           SetReg(R_ESI);
           SetReg(R_EDI);
           SetReg(R_EAX);
           SetReg(R_EBX);


     end;


 end  // of swap(FloatArray,FloatArray)
 else
 //SWAPIF(FloatArray[] <=> FloatVar)
 if GNode^.AI = 21 then            //swap(FloatArray,FloatVar)   swap(FloatVar,FloatArray)
 begin
                                                       //FloatArray[] <=> FloatVar
     AddrA1:=Alg.Obj[GNode^.NObj].Addr;
     ArgForm1:=GNode^.TA1;
     tm1:=Alg.Obj[GNode^.NObj].MType;
     Adr2:=Alg.Obj[GNode^.NV2].Addr;
     tm2:=Alg.Obj[GNode^.NV2].MType;
     ts2:=GNode^.TS2;
     if ts2 = _IM then Adr2:=Alg.Obj[NV2].AddrIM;


     if (ArgForm1 = _IntConst) or (ArgForm1 = _IntVar) or (ArgForm1 = _IntForm) then
     begin                                                                     //x=1; vd[k]=10; swapif(vd[k]<x); x
                                                                               //swap(vd2[k],x); x
                                                                               //swap(ve2[2*k+3*j-1],y); y
                                                                               //swap(vd2[k],z1.re); z1.re
                                                                               //swap(ve2[2*k+3*j-1],z1.im); z1.im

           LoadLineFormEAX(_First);     //ArgForm1 -> EAX
           MOVMREG(R_EBX,AddrA1);       //Addr1    -> EBX
           LoadArrayAddrCell(R_EBX,R_EBX,R_EAX,tm1);   // @VecFloat1[ArgForm1] -> EBX
           {
           if tm1 = _Double   then
           begin
               //lea ebx,ebx+8*eax
               AddByte3($8D,$1C,$C3);       // @VecFloat1[ArgForm1] -> EBX
           end
           else
           if tm1 = _Extended   then
           begin
              //lea   eax,[eax+4*eax]
              AddByte3($8D,$04,$80);
              //add   eax,eax
              AddByte2($01,$C0);
              //lea ebx,ebx+eax
              AddByte3($8D,$1C,$18);  // @VecFloat1[ArgForm1] -> EBX
           end;
           }
            //load

            //_FloatArray
           FLDREG(R_EBX,tm1);
           //_FloatVar
           FLD(Adr2,tm2);

           //swap использует один вид: swap(vec[],var) для swap(vec[],var) и swap(var,vec[])
           //поэтому во 2-м случае нужно перевернуть условие сравнения:
           if GNode.DI = _FloatVar then
           begin
             if tif = _JNB  then  tif:=_JBE else
             if tif = _JBE  then  tif:=_JNB;
           end;

           FCOMI;
           JMPC(13,tif);


           //save

            //_FloatArray
           FSTPREG(R_EBX,tm1);
              //_FloatVar
           FSTPM(Adr2,tm2);


           JMP(4);
           FSTP0;
           FSTP0;

           CheckStack(2); //коррекция на излишние fstp

           SetReg(R_ECX);
           SetReg(R_EAX);
           SetReg(R_EBX);
     end
     else
     if  (ArgForm1 = _NOT_FOUND) then      //FloatArray1[Expr1]<->FloatVar2
     begin                                                                   //x=1; vd[k*(k+1)]=10; swapif(vd[k*(k+1)]>x); x
                                                                              //swap(vd2[k*y],x); x
                                                                              //swap(ve2[k*x+3*j-1],y); y
                                                                              //swap(vd2[x],z1.re); z1.re
                                                                              //swap(ve2[2*x+3*j-1],z1.im); z1.im
           LoadArg1;
           (*
           PUSHCW;   {.227}
           FLDCW(TAddress(@FCW1));
           MEM:=WriteDataA(0,_Integer);
           FISTP(MEM);
           POPCW;      {.227}   //FLDCW(TAddress(@FCW2));
           MOVMA(MEM);                 // Expr1->EAX
           *)
           TRUNCR(R_EAX);     // indx->EAX
           MOVMREG(R_EBX,AddrA1);       //Addr1->EBX
           LoadArrayAddrCell(R_EBX,R_EBX,R_EAX,tm1);   // @VecFloat1[ArgForm1] -> EBX
           {
           if tm1 = _Double   then
           begin
               //lea ebx,ebx+8*eax
               AddByte3($8D,$1C,$C3);       // @VecFloat1[ArgForm1] -> EBX
           end
           else
           if tm1 = _Extended   then
           begin
              //lea   eax,[eax+4*eax]
              AddByte3($8D,$04,$80);
              //add   eax,eax
              AddByte2($01,$C0);
              //lea ebx,ebx+eax
              AddByte3($8D,$1C,$18);  // @VecFloat1[ArgForm1] -> EBX
           end;
           }
           //load
            //_FloatArray
            FLDREG(R_EBX,tm1);

            //_FloatVar
           FLD(Adr2,tm2);

            //swap использует один вид: swap(vec[],var) для swap(vec[],var) и swap(var,vec[])
           //поэтому во 2-м случае нужно перевернуть условие сравнения:
           if GNode.DI = _FloatVar then
           begin
             if tif = _JNB  then  tif:=_JBE else
             if tif = _JBE  then  tif:=_JNB;
           end;

           FCOMI;
           JMPC(13,tif);

           //save
           FSTPREG(R_EBX,tm1);
           //_FloatVar
           FSTPM(Adr2,tm2);

           JMP(4);
           FSTP0;
           FSTP0;

           CheckStack(2); //коррекция на излишние fstp


           SetReg(R_ECX);
           SetReg(R_EAX);
           SetReg(R_EBX);

     end;

 end;




end;









procedure TForevalH.FindNumberLevelA(num: Integer; var ANL: TArrayC);
var
j,IdN: Integer;
begin
 {
IdN:=Interp[num].IdN;
for j:=1 to LFunc-1 do
begin
   if IdN = Interp[j].IdL then
   begin
    SetLength(ANL,Length(ANL)+1);
    ANL[High(ANL)]:=j;
   end;
end;
 }
end;






{.213}
procedure TForevalH.JMP_C;
label out1;
                   procedure CorrectStackIF(Node: PNode{N: Integer});
                   begin
                     {.211}
                      //'выталкивание' из стека первого аргумента (перед вторым) в команде IF для корректного определения загрузки стека N_Stack
                      //команда #JMP (AI=1) всегда является аргументом IF
                      if Node^.AI = 1 then
                      begin
                        //по типу предыдущего аргумента
                        if Node^.Prev^.TypeF = T_Real then CheckStack(-1)       //if(x<y), if(x<y,x,y)
                         else
                        if Node^.Prev^.TypeF = T_Complex then CheckStack(-2);   //if(x<y,z1,z2)
                        // else T_None                                          //if(x<y,goto())  if(x<y,goto(),goto())


                          //тоже самое, только через главную команду IF:
                       { if Node^.Pr <> nil then
                        begin
                          if Node^.Pr^.NFunc = CM_IF then
                          begin
                            if Node^.Pr^.TypeF = T_Real then CheckStack(-1) else
                            if Node^.Pr^.TypeF = T_Complex then CheckStack(-2); //else T_None
                          end;
                        end;  }

                        (*
                        //по типу предыдущего аргумента
                        if Interp[N-1].TypeF = T_Real then CheckStack(-1)       //if(x<y), if(x<y,x,y)
                         else
                        if Interp[N-1].TypeF = T_Complex then CheckStack(-2);   //if(x<y,z1,z2)
                        // else T_None


                        {
                        NM:=Interp[N].NM;  //Interp[Interp[N].NM].NFunc = CM_IF !!! всегда
                        if NM > 0 then
                        begin
                          if Interp[NM].NFunc = CM_IF then
                          begin
                            if Interp[NM].TypeF = T_Real then CheckStack(-1) else
                            if Interp[NM].TypeF = T_Complex then CheckStack(-2); //else T_None
                          end;
                        end;
                        }
                         *)
                      end;
                   end;
label endp;
var
P: ^Integer{Cardinal};
NC,CC,N1,N2,SZ,S,NCP,L,NCP1,NM: Cardinal;
NL,NB,CS,Adr1,Adr2,CS1,N: Cardinal;
ANL: TArrayC;
NN,CI,ta1,ta2,tva,tma: Integer;
Node,NodeCh1,NodeCh2,NodeJmp: PNode;
AddrI1,AddrI2: TAddress;

begin
 //AI = 1       2      3       4      5      6     7       8
 //   #JMP, #JMPE, #JMPEL, #JMPEB, #JMPB, #JMPL, #JMPNE, JMP(goto)

Node:=GNode;//N:=NFunc;

   (*
if F_Mode = M_XchBranch{C_Compile} then    {.302}
begin
//режим: DinamicLoad
 if (Node^.AI >= 2) and (Node.AI <= 7) then CheckStack(-2); //FCOMPP      {.new}  {!!!}
 //else CheckStack(-1); //JMP
 //CorrectStackIF(N);  {.235}

 goto endp;
end;
   *)

 //Node^ = Interp[N]

//первый проход
if F_JMP = 1 then
begin
  if (Node^.AI = 1) or (Node^.AI = 8) then     //JMP ,goto
  begin
   SetLength(ICOMP,Length(ICOMP)+5);
   ICOMP[High(ICOMP)-4]:=$E9;         //jmp
   CorrectStackIF(Node);  {.211}
  end
  else    //CJMP
  begin

    // Node^.Pr  <- pointer to IF

    if Node^.Pr^.BI = _IntArg then
    begin
       ta1:=Node^.Pr^.TA1;
       ta2:=Node^.Pr^.TA2;
       if (ta1 = _IntForm) and (ta2 = _IntForm) then
       begin
          LineFormN(Node^.Pr^.AIVP2,Node^.Pr^.IC2);
          PUSHR(R_EAX);
          LineFormN(Node^.Pr^.AIVP1,Node^.Pr^.IC1);
          POPR(R_EBX);
          CMPR(R_EAX,R_EBX);
       end
       else
       if (ta1 = _IntVar) and (ta2 = _IntVar) then      //ok
       begin
          GetVar1(Node^.Pr^.NV1,AddrI1,tva,TMA);
          GetVar1(Node^.Pr^.NV2,AddrI2,tva,TMA);

          MOVMREG(R_EAX,AddrI1);
          CMPRM(R_EAX,R_MEM,AddrI2);
       end
       else
       if (ta1 = _IntVar) and (ta2 = _IntConst) then      //ok
       begin
          GetVar1(Node^.Pr^.NV1,AddrI1,tva,TMA);
          MOVCREG(R_EAX,Node^.Pr^.IC2);
          CMPRM(R_MEM,R_EAX,AddrI1);
       end
       else
       if (ta1 = _IntVar) and (ta2 =  _IntForm) then   //ok
       begin
          LineFormN(Node^.Pr^.AIVP2,Node^.Pr^.IC2);
          //PUSHR(R_EAX);
          GetVar1(Node^.Pr^.NV1,AddrI1,tva,TMA);
          //MOVCREG(R_EAX,Node^.Pr^.IC2);
          CMPRM(R_MEM,R_EAX,AddrI1);
       end
       else
       if (ta1 = _IntForm) and (ta2 = _IntConst) then
       begin
          LineFormN(Node^.Pr^.AIVP1,Node^.Pr^.IC1);
          MOVCREG(R_EBX,Node^.Pr^.IC2);
          CMPR(R_EAX,R_EBX);
       end
       else
       if (ta1 = _IntForm) and (ta2 = _IntVar) then
       begin
          LineFormN(Node^.Pr^.AIVP1,Node^.Pr^.IC1);
          GetVar1(Node^.Pr^.NV2,AddrI2,tva,TMA);
          CMPRM(R_EAX,R_MEM,AddrI2);
       end
       else
       if (ta1 = _IntConst) and (ta2 = _IntVar) then
       begin
          GetVar1(Node^.Pr^.NV2,AddrI2,tva,TMA);
          MOVCREG(R_EAX,Node^.Pr^.IC1);
          CMPRM(R_EAX,R_MEM,AddrI2);
       end
       else
       if (ta1 = _IntConst) and (ta2 = _IntForm) then
       begin
          LineFormN(Node^.Pr^.AIVP2,Node^.Pr^.IC2);
          MOVCREG(R_EBX,Node^.Pr^.IC1);
          CMPR(R_EBX,R_EAX);
       end
       else
       if (ta1 = _IntConst) and (ta2 = _IntConst) then   {.322}
       begin
          MOVCREG(R_EAX,Node^.Pr^.IC1);
          MOVCREG(R_EBX,Node^.Pr^.IC2);
          CMPR(R_EAX,R_EBX);
       end
       else
       begin
          F_SyntaxErrorCode:=E_INTERNAL_ERROR;
          F_SyntaxErrorString:='IF_ERROR';
       end;


       JMPCI(0,Node^.AI);
       goto out1;
    end;


    //A1,A2 - float arg
   //если A1,A2 в памяти
   {FindNumberLevelA(Interp[N].NM,ANL);      //NM - узел: комманда IFNOP
   N1:=ANL[0];    N2:=ANL[1];  }

   NodeCh1:=Node^.Pr^.Ch;
   NodeCh2:=NodeCh1^.Nb;
   if (NodeCh1 = nil) or (NodeCh2 = nil) then begin {InternalError} end;

   S:=Node^.Pr^.S;  //S:=Interp[Interp[N].NM].S;

   Adr1:=GetStackAdr(S,_RE);
   Adr2:=GetStackAdr(S+1,_RE);


   //if (Interp[N1].SData1 = _MEM) and (Interp[N2].SData1 = _MEM) then
   if (NodeCh1^.SData1 = _MEM) and (NodeCh2^.SData1 = _MEM) then
   begin

     //fld A1,fld A2
      FLD(Adr1,F_DataType);
      FLD(Adr2,F_DataType);

   end
   else
   //if (Interp[N1].SData1 = _MEM) and (Interp[N2].SData1 = _FPU) then
   if (NodeCh1^.SData1 = _MEM) and (NodeCh2^.SData1 = _FPU) then
   begin
     //fld A1
     FLD(Adr1,F_DataType);
     FXCH1;

   end
   else
   //if (Interp[N1].SData1 = _FPU) and (Interp[N2].SData1 = _MEM) then
   if (NodeCh1^.SData1 = _FPU) and (NodeCh2^.SData1 = _MEM) then
   begin
     // fld A2
     FLD(Adr2,F_DataType);

   end
   else
   //if (Interp[N1].SData1 = _FPU) and (Interp[N2].SData1 = _FPU) then
   if (NodeCh1^.SData1 = _FPU) and (NodeCh2^.SData1 = _FPU) then
   begin

   end;

   { P:=@ICOMP[0];
   asm
     call  P
   end;
   }

   {.217}
   {
   FCOMPP;
   FSTSW_AX;
   SAHF;
   JMPC(0,Interp[N].AI);
   }
   FCOMIP;
   FSTP0;
   JMPC(0,Node^.AI);


   out1:
  end;

end
else  //расстановка смещений в JMP
if F_JMP =2 then
begin
  if (Node^.AI = 8) {and (Length(GotoLab)>0)} then  //GOTO
  begin
    NCP:=Node^.NCP;
    P:=@ICOMP[NCP-4];
    NN:=Node^.CI-2;
    if (NN = -1) or(Length(GotoLab) = 0) then
    begin
         {Если возникает исключение при  OverFlowChecks,RangeChecks -On - это не ошибка ! }
         {If there is an exception at OverFlowChecks,RangeChecks -On - it is no error !}

      //{$RangeChecks Off}
      //{$OverFlowChecks Off}
      P^:=-NCP;
      //{$RangeChecks On}
      //{$OverFlowChecks On}

    end
    else
    begin
     {L:=GotoLab[NN];
     NCP1:=Interp[L].NCP; }
     NodeJmp:=GotoLab[NN];
     NCP1:=NodeJmp^.NCP;

       //{$RangeChecks Off}
       //{$OverFlowChecks Off}
     P^:=NCP1-NCP;
       //{$RangeChecks On}
       //{$OverFlowChecks On}

    end;
    goto endp;
  end;

  NN:=Node^.Pr^.N; //NN:=Interp[interp[N].NM].N;
  NL:=Node^.NL;    //NL:=Interp[N].NL;      //текущий эл-т на уровне: отсчёт с '1'
  CI:=Node^.Pr^.CI; //CI:=Interp[interp[N].NM].CI;  //CI=2: if(arg1,goto())
  {
  FindNumberLevelA(Interp[N].NM,ANL);      //NM - узел: комманда IFNOP
  NB:=ANL[NL];           //ANL:  отсчёт с '0': ANL[NL] содержит следующий эл-т уровня
  }

  CS:=Node^.Nb^.CS;  //CS:=Interp[NB].CS;     //размер кода следующего эл-та
  NC:=Node^.NC;      //NC:=Interp[N].NC;    //номер начальной ячейки в ICOMP текущей комманды
  CS1:=Node^.CS;     //CS1:=Interp[N].CS;   //размер кода текущей комманды
  //if Interp[N].AI = 1 then  //JMP
  if Node^.AI = 1 then  //JMP
  begin
    //ICOMP[NC]:=$E9;
    P:=@ICOMP[NC{+1}+CS1-4];
    P^:=CS;
  end
  else  //CJMP
  begin
    P:=@ICOMP[NC+CS1-4];
    if NN = 6 then P^:=CS+5 else  //5 - размерность операнда JMP: A1,A2,CJMP,A3,JMP,A4 переход на A4: NL и NB указывают на JMP
       if NN = 4 then P^:=5;      //if(arg,goto())     A1,A2,CJMP,JMP
                            //P^:=CS+5;  //5 - размерность операнда JMP: A1,A2,CJMP,A3,JMP,A4 переход на A4: NL и NB указывают на JMP

  end;

  //CheckStack(-1);            {.211}
end;

endp:
end;



(*

{.213}
procedure TForevalH.JMP_C;
                   procedure CorrectStackIF(Node: PNode{N: Integer});
                   begin
                     {.211}
                      //'выталкивание' из стека первого аргумента (перед вторым) в команде IF для корректного определения загрузки стека N_Stack
                      //команда #JMP (AI=1) всегда является аргументом IF
                      if Node^.AI = 1 then
                      begin
                        //по типу предыдущего аргумента
                        if Node^.Prev^.TypeF = T_Real then CheckStack(-1)       //if(x<y), if(x<y,x,y)
                         else
                        if Node^.Prev^.TypeF = T_Complex then CheckStack(-2);   //if(x<y,z1,z2)
                        // else T_None                                          //if(x<y,goto())  if(x<y,goto(),goto())


                          //тоже самое, только через главную команду IF:
                       { if Node^.Pr <> nil then
                        begin
                          if Node^.Pr^.NFunc = CM_IF then
                          begin
                            if Node^.Pr^.TypeF = T_Real then CheckStack(-1) else
                            if Node^.Pr^.TypeF = T_Complex then CheckStack(-2); //else T_None
                          end;
                        end;  }

                        {
                        //по типу предыдущего аргумента
                        if Interp[N-1].TypeF = T_Real then CheckStack(-1)       //if(x<y), if(x<y,x,y)
                         else
                        if Interp[N-1].TypeF = T_Complex then CheckStack(-2);   //if(x<y,z1,z2)
                        // else T_None


                        {
                        NM:=Interp[N].NM;  //Interp[Interp[N].NM].NFunc = CM_IF !!! всегда
                        if NM > 0 then
                        begin
                          if Interp[NM].NFunc = CM_IF then
                          begin
                            if Interp[NM].TypeF = T_Real then CheckStack(-1) else
                            if Interp[NM].TypeF = T_Complex then CheckStack(-2); //else T_None
                          end;
                        end;
                        }
                         }
                      end;
                   end;
label endp;
var
P: ^Integer{Cardinal};
NC,CC,N1,N2,SZ,S,NCP,L,NCP1,NM: Cardinal;
NL,NB,CS,Adr1,Adr2,CS1,N: Cardinal;
ANL: TArrayC;
NN,CI: Integer;
Node,NodeCh1,NodeCh2,NodeJmp: PNode;
begin
 //AI = 1       2      3       4      5      6     7       8
 //   #JMP, #JMPE, #JMPEL, #JMPEB, #JMPB, #JMPL, #JMPNE, JMP(goto)

Node:=GNode;//N:=NFunc;

if F_Mode = M_XchBranch{C_Compile} then    {.302}
begin
//режим: DinamicLoad
 if (Node^.AI >= 2) and (Node.AI <= 7) then CheckStack(-2); //FCOMPP      {.new}  {!!!}
 //else CheckStack(-1); //JMP
 //CorrectStackIF(N);  {.235}

 goto endp;
end;

 //Node^ = Interp[N]

//первый проход
if F_JMP = 1 then
begin
  if (Node^.AI = 1) or (Node^.AI = 8) then     //JMP ,goto
  begin
   SetLength(ICOMP,Length(ICOMP)+5);
   ICOMP[High(ICOMP)-4]:=$E9;         //jmp
   CorrectStackIF(Node);  {.211}
  end
  else    //CJMP
  begin
   //если A1,A2 в памяти
   {FindNumberLevelA(Interp[N].NM,ANL);      //NM - узел: комманда IFNOP
   N1:=ANL[0];    N2:=ANL[1];  }

   NodeCh1:=Node^.Pr^.Ch;
   NodeCh2:=NodeCh1^.Nb;
   if (NodeCh1 = nil) or (NodeCh2 = nil) then begin {InternalError} end;

   S:=Node^.Pr^.S;  //S:=Interp[Interp[N].NM].S;

   Adr1:=GetStackAdr(S,_RE);
   Adr2:=GetStackAdr(S+1,_RE);


   //if (Interp[N1].SData1 = _MEM) and (Interp[N2].SData1 = _MEM) then
   if (NodeCh1^.SData1 = _MEM) and (NodeCh2^.SData1 = _MEM) then
   begin

     //fld A1,fld A2
      FLD(Adr1,F_DataType);
      FLD(Adr2,F_DataType);

   end
   else
   //if (Interp[N1].SData1 = _MEM) and (Interp[N2].SData1 = _FPU) then
   if (NodeCh1^.SData1 = _MEM) and (NodeCh2^.SData1 = _FPU) then
   begin
     //fld A1
     FLD(Adr1,F_DataType);
     FXCH1;

   end
   else
   //if (Interp[N1].SData1 = _FPU) and (Interp[N2].SData1 = _MEM) then
   if (NodeCh1^.SData1 = _FPU) and (NodeCh2^.SData1 = _MEM) then
   begin
     // fld A2
     FLD(Adr2,F_DataType);

   end
   else
   //if (Interp[N1].SData1 = _FPU) and (Interp[N2].SData1 = _FPU) then
   if (NodeCh1^.SData1 = _FPU) and (NodeCh2^.SData1 = _FPU) then
   begin

   end;

   { P:=@ICOMP[0];
   asm
     call  P
   end;
   }

   {.217}
   {
   FCOMPP;
   FSTSW_AX;
   SAHF;
   JMPC(0,Interp[N].AI);
   }
   FCOMIP;
   FSTP0;
   JMPC(0,Node^.AI);


  end;

end
else  //расстановка смещений в JMP
if F_JMP =2 then
begin
  if (Node^.AI = 8) {and (Length(GotoLab)>0)} then  //GOTO
  begin
    NCP:=Node^.NCP;
    P:=@ICOMP[NCP-4];
    NN:=Node^.CI-2;
    if (NN = -1) or(Length(GotoLab) = 0) then
    begin
         {Если возникает исключение при  OverFlowChecks,RangeChecks -On - это не ошибка ! }
         {If there is an exception at OverFlowChecks,RangeChecks -On - it is no error !}

      //{$RangeChecks Off}
      //{$OverFlowChecks Off}
      P^:=-NCP;
      //{$RangeChecks On}
      //{$OverFlowChecks On}

    end
    else
    begin
     {L:=GotoLab[NN];
     NCP1:=Interp[L].NCP; }
     NodeJmp:=GotoLab[NN];
     NCP1:=NodeJmp^.NCP;

       //{$RangeChecks Off}
       //{$OverFlowChecks Off}
     P^:=NCP1-NCP;
       //{$RangeChecks On}
       //{$OverFlowChecks On}

    end;
    goto endp;
  end;

  NN:=Node^.Pr^.N; //NN:=Interp[interp[N].NM].N;
  NL:=Node^.NL;    //NL:=Interp[N].NL;      //текущий эл-т на уровне: отсчёт с '1'
  CI:=Node^.Pr^.CI; //CI:=Interp[interp[N].NM].CI;  //CI=2: if(arg1,goto())
  {
  FindNumberLevelA(Interp[N].NM,ANL);      //NM - узел: комманда IFNOP
  NB:=ANL[NL];           //ANL:  отсчёт с '0': ANL[NL] содержит следующий эл-т уровня
  }

  CS:=Node^.Nb^.CS;  //CS:=Interp[NB].CS;     //размер кода следующего эл-та                                  c
  NC:=Node^.NC;      //NC:=Interp[N].NC;    //номер начальной ячейки в ICOMP текущей комманды
  CS1:=Node^.CS;     //CS1:=Interp[N].CS;   //размер кода текущей комманды
  //if Interp[N].AI = 1 then  //JMP
  if Node^.AI = 1 then  //JMP
  begin
    //ICOMP[NC]:=$E9;
    P:=@ICOMP[NC{+1}+CS1-4];
    P^:=CS;
  end
  else  //CJMP
  begin
    P:=@ICOMP[NC+CS1-4];
    if NN = 6 then P^:=CS+5 else  //5 - размерность операнда JMP: A1,A2,CJMP,A3,JMP,A4 переход на A4: NL и NB указывают на JMP
       if NN = 4 then P^:=5;      //if(arg,goto())     A1,A2,CJMP,JMP
                            //P^:=CS+5;  //5 - размерность операнда JMP: A1,A2,CJMP,A3,JMP,A4 переход на A4: NL и NB указывают на JMP

  end;

  //CheckStack(-1);            {.211}
end;

endp:
end;
*)





procedure TForevalH.FLD_C(Node: PNode{I: Integer});
begin
//FLD1
if Node^.AI = 1 then
begin
  FLD1;
end
else
//FLDZ
if Node^.AI = 2 then
begin
  FLDZ;
end
end;



procedure TForevalH.FLDV_RE(nv: Integer);
var
 Adr: Cardinal;
 tv,tm: Integer;
begin
 GetVar1(nv,adr,tv,tm);
 if  tv = T_Real    then  FLD(Adr,tm)
 else
 if  tv = T_Complex  then FLD(Adr,tm)
 else
 if  tv = IM_UNIT  then   FLDZ;
end;




procedure TForevalH.FLDV_IM(nv: Integer);
var
 AdrRE,AdrIM: Cardinal;
 tv,tm: Integer;
begin
 GetVar2(nv,adrRE,adrIM,tv,tm);
 if  tv = T_Real    then FLDZ  else
 if  tv = T_Complex  then
 begin
      FLD(AdrIM,tm); {.343}
     {
     if tm = _Double    then   FLD(Adr+Sh_D,tm) else
     if tm = _Extended  then   FLD(Adr+Sh_E,tm)
     }
 end
 else
 if  tv = IM_UNIT  then   FLD1;
end;



procedure TForevalH.FADDV(nv: Integer; st: Integer);
var
 Adr,AdrRE,AdrIM: Cardinal;                //st = T_Real,T_Complex
 tv,tm,sh: Integer;
begin
 //GetVar(nv,adr,tv,tm);
 GetVar2(nv,adrRE,adrIM,tv,tm);        {.343}
 adr:=adrRE;

 if (tm = _Extended) then sh:=SH_E else sh:=SH_D;

 if (tv = T_Real) and (st = T_Real)    then  FADD(adr,tm)
 else
 if (tv = T_Real) and (st = T_Complex) then  FADD(adr,tm)
 else
 if (tv = T_Complex) and (st = T_Real) then
 begin
   FADD(adr,tm);
   //FLD(adr+sh,tm);
   FLD(adrIM,tm);  {.343}
   FXCH1;
 end
 else
  if (tv = T_Complex) and (st = T_Complex) then
 begin
   FADD(adr,tm);
   FXCH1;
   //FADD(adr+sh,tm);
   FADD(adrIM,tm);   {.343}
   FXCH1;
 end
 else
 if (tv = IM_UNIT) and (st = T_Real) then
 begin
   FLD1;
   FXCH1;
 end
 else
 if (tv = IM_UNIT) and (st = T_Complex) then
 begin
   FLD1;
   FADDP2;
 end

end;




procedure TForevalH.FSUBV(nv: Integer; st: Integer; inv:Integer = 0);
var
 Adr,adrRE,adrIM: Cardinal;                //st = T_Real,T_Complex
 tv,tm,sh: Integer;
begin
 {                        //S-v (inv=0); v-S (inv=1);
 GetVar(nv,adr,tv,tm);
 if (tm = _Extended) then sh:=SH_E else sh:=SH_D;
 }

 GetVar2(nv,adrRE,adrIM,tv,tm);        {.343}
 adr:=adrRE;                           {.343}



 if (tv = T_Real) and (st = T_Real)    then
 begin
  if (inv = 0) then  FSUB(adr,tm) else if (inv = 1) then FSUBR(adr,tm);
 end
 else
 if (tv = T_Real) and (st = T_Complex) then
 begin
  if (inv = 0) then  FSUB(adr,tm) else if (inv = 1) then begin FXCH1; FCHS; FXCH1; FSUBR(adr,tm); end
 end
 else
 if (tv = T_Complex) and (st = T_Real) then
 begin
   if (inv = 0) then
   begin
     FSUB(adr,tm);
     //FLD(adr+sh,tm);
     FLD(adrIM,tm); {.343}
     FCHS; FXCH1;
   end
   else
   if (inv = 1) then
   begin
     FSUBR(adr,tm);
     //FLD(adr+sh,tm);
     FLD(adrIM,tm); {.343}
     FXCH1;
   end
 end
 else
  if (tv = T_Complex) and (st = T_Complex) then
 begin
   if (inv = 0) then
   begin
     FSUB(adr,tm); FXCH1;
     //FSUB(adr+sh,tm);
     FSUB(adrIM,tm);  {.343}
     FXCH1;
   end
   else
   if (inv = 1) then
   begin
     FSUBR(adr,tm); FXCH1;
     //FSUBR(adr+sh,tm);
     FSUBR(adrIM,tm);    {.343}
     FXCH1;
   end
 end
 else
 if (tv = IM_UNIT) and (st = T_Real) then
 begin
   if (inv = 0) then
   begin
    FLD1;
    FCHS;
    FXCH1;
   end
   else
   if (inv = 1) then
   begin
    FCHS;
    FLD1;
    FXCH1;
   end
 end
 else
 if (tv = IM_UNIT) and (st = T_Complex) then
 begin
   if (inv = 0) then
   begin
    FLD1;
    FSUBP2;
   end
   else
   if (inv = 1) then
   begin
    FCHS;
    FXCH1;
    FLD1;
    FSUBRP;
    FXCH1;
   end
 end

end;





procedure TForevalH.MUL_SC(TS,TC: Integer);
var
Re,Im: Extended;
CMul: Integer;
AdrC: Cardinal;
begin       {умножение  стека TS=T_Real: ST(0), TS=T_Complex: ST(0),ST(1) на константу TC = C_Real,C_Complex}

Re:=0; Im:=0;
if TC =  C_Real    then Re:=GNode^.FD else
if TC =  C_Complex then
begin
  Re:=GNode^.FDC.re;
  Im:=GNode^.FDC.im;
end;

CMul:=-1;
if (Re = 0)  and  (Im = 0)  then CMul:=0 else  // 0
if (Re = 1)  and  (Im = 0)  then CMul:=1 else  // 1
if (Re = -1) and  (Im = 0)  then CMul:=2 else  // -1
if (Re = 0)  and  (Im = 1)  then CMul:=3 else  // i
if (Re = 0)  and  (Im = -1) then CMul:=4 else  // -i
if (Re = 0)                 then CMul:=5;      // im*i


if TC = C_Real then
begin


          if TS = T_Real then
          begin
            if CMul = 1 then  begin              end else
            if CMul = 2 then  begin FCHS;        end else
            if CMul = 0 then  begin FSTP0; FLDZ; end else
                                    FMUL(WriteData(GNode),F_DataType)
          end
          else
          if TS = T_Complex then
          begin
             if CMul = 1  then  begin       end else
             if CMul = 2  then
             begin
                FCHS;
                FXCH1;
                FCHS;
                FXCH1;
             end
             else
             if CMul = 0 then
             begin
                FSTP0;
                FSTP0;
                FLDZ;
                FLDZ;
             end
             else
             begin
                AdrC:=WriteData(GNode);
                FMUL(AdrC,F_DataType);
                FXCH1;
                FMUL(AdrC,F_DataType);
                FXCH1;
             end;
          end;

end
else //.318    TC = C_Complex
begin

          if TS = T_Real then
          begin
             if CMul = 3 then   // St(0)*i
             begin
                FLDZ;
             end
             else
             if CMul = 4 then  // St(0)*(-i)
             begin
                FCHS;
                FLDZ;
             end
             else
             if CMul = 5 then  // St(0)*[0,im]
             begin
                FMUL(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);
                FLDZ;
             end
             else              //St(0)*[re,im]
             begin
                FLD0;
                FMUL(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);
                FXCH1;
                FMUL(WriteDataA(GNode^.FDC.re,F_DataType),F_DataType);
             end;

          end
          else
          if TS = T_Complex then
          begin
              if CMul = 3 then   // [St(0),St(1)]*i
             begin
                FXCH1;
                FCHS;
             end
             else
             if CMul = 4 then  // [St(0),St(1)]*(-i)
             begin
                FCHS;
                FXCH1;
             end
             else
             if CMul = 5 then     // [St(0),St(1)]*[0,im]
             begin
                FMUL(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);
                FXCH1;
                FMUL(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);
                FCHS;
             end
             else             // [St(0),St(1)]*[re,im]
             begin
               FLD(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);
               FLD(WriteDataA(GNode^.FDC.re,F_DataType),F_DataType);
               ZMULP;
             end;
          end;

end;

end;


procedure TForevalH.MUL_VC(nv: Integer; TC: Integer);
{умножение  переменной nv на константу  (TC = C_Real,C_Complex)}
var
 Adr,Adr_RE,Adr_IM,AdrC: Cardinal;                //st = T_Real,T_Complex
 tv,tm,sh,CMul: Integer;
 Re,Im: Extended;
begin

 {GetVar(nv,adr,tv,tm);
 if (tm = _Extended) then sh:=SH_E else sh:=SH_D;
 Adr_RE:=adr; Adr_IM:=adr+sh;
 }
 GetVar2(nv,adr_RE,adr_IM,tv,tm);       {.343}
 adr:=adr_RE;                            {.343}


Re:=0; Im:=0;
if TC =  C_Real    then Re:=GNode^.FD else
if TC =  C_Complex then
begin
  Re:=GNode^.FDC.re;
  Im:=GNode^.FDC.im;
end;

CMul:=-1;
if (Re = 0)  and  (Im = 0)  then CMul:=0 else  // 0
if (Re = 1)  and  (Im = 0)  then CMul:=1 else  // 1
if (Re = -1) and  (Im = 0)  then CMul:=2 else  // -1
if (Re = 0)  and  (Im = 1)  then CMul:=3 else  // i
if (Re = 0)  and  (Im = -1) then CMul:=4 else  // -i
if (Re = 0)                 then CMul:=5;      // im*i


if TC = C_Real then
begin

          if TV = T_Real then
          begin

            if CMul = 1 then
            begin
               FLD(adr_re,tm);
            end
            else
            if CMul = 2 then
            begin
               FLD(adr_re,tm);
               FCHS;
            end
            else
            if CMul = 0 then
            begin
               FLDZ;
            end
            else
            begin
               FLD(adr_re,tm); FMUL(WriteData(GNode),F_DataType)
            end

          end
          else
          if TV = T_Complex then
          begin

             if CMul = 1  then
             begin
                FLD(adr_im,tm);
                FLD(adr_re,tm);
             end
             else
             if CMul = 2  then
             begin
                FLD(adr_im,tm);
                FCHS;
                FLD(adr_re,tm);
                FCHS;
             end
             else
             if CMul = 0 then
             begin
                FLDZ;
                FLDZ;
             end
             else
             begin
                AdrC:=WriteData(GNode);
                FLD(adr_im,tm);
                FMUL(AdrC,F_DataType);
                FLD(adr_re,tm);
                FMUL(AdrC,F_DataType);
             end;
          end

         {
         FLD(WriteData(GNode),F_DataType);
         MUL_SV(nv,T_Real);
         }
          else
          {del ERROR:  MulDiv,CaclConstOnTree = off     2*i; i*a}
          if TV = IM_UNIT then    {.329}
          begin

              if CMul = 0 then
              begin
                FLDZ;
              end
              else
              if CMul = 1 then
              begin
                FLD1;
                FLDZ;
              end
              else
              if CMul = 2 then
              begin
                FLD1;
                 FCHS;
               FLDZ;
              end
              else
              begin
                FLD(WriteDataA(GNode^.FD,F_DataType),F_DataType);
                FLDZ;
              end

          end;



end
else  //.318 // TC = C_Complex
begin

          if TV = T_Real then
          begin

             if CMul = 3 then   // v(re)*i
             begin
                FLD(adr_re,tm);
                FLDZ;
             end
             else
             if CMul = 4 then  // v(re)*(-i)
             begin
                FLD(adr_re,tm);
                FCHS;
                FLDZ;
             end
             else
             if CMul = 5 then  // v(re)*[0,im]
             begin
                FLD(adr_re,tm);
                FMUL(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);
                FLDZ;
             end
             else              //v(re)*[re,im]
             begin
                FLD(adr_re,tm);
                FMUL(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);
                FLD(adr_re,tm);
                FMUL(WriteDataA(GNode^.FDC.re,F_DataType),F_DataType);
             end;

          end
          else
          if TV = T_Complex then
          begin
             if CMul = 3 then   //v(re,im)*i
             begin
                FLD(adr_re,tm);
                FLD(adr_im,tm);
                FCHS;
             end
             else
             if CMul = 4 then  // v(re,im)*(-i)
             begin
                FLD(adr_re,tm);
                FCHS;
                FLD(adr_im,tm);
             end
             else
             if CMul = 5 then     // v(re,im)*[0,im]
             begin
                FLD(adr_re,tm);
                FMUL(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);
                FLD(adr_im,tm);
                FMUL(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);
                FCHS;
             end
             else             // v(re,im)*[re,im]
             begin
               FLD(adr_im,tm);
               FLD(adr_re,tm);
               FLD(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);
               FLD(WriteDataA(GNode^.FDC.re,F_DataType),F_DataType);
               ZMULP;
             end;
          end
         {
         FLD(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);
         FLD(WriteDataA(GNode^.FDC.re,F_DataType),F_DataType);
         MUL_SV(nv,T_Complex);
         }
          else
          if TV = IM_UNIT then    {.329}
          begin

              if CMul = 3 then
              begin
                FLD1;
                FCHS;
              end
              else
              if CMul = 4 then
              begin
                FLD1;
              end
              else
              if CMul = 5 then
              begin
                FLD(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);
                FCHS;
                FLDZ;
              end
              else
              begin
                FLD(WriteDataA(GNode^.FDC.re,F_DataType),F_DataType);
                FLD(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);
                FCHS;
              end;

          end;




end



end;



procedure TForevalH.MUL_SV(nv: Integer; st: Integer);
{умножение  стека st=T_Real: ST(0), st=T_Complex: ST(0),ST(1) на переменную nv (tv = T_Real,T_Complex)}
var
 Adr,Adr_RE,Adr_IM: Cardinal;                //st = T_Real,T_Complex
 tv,tm,sh: Integer;
begin
 {GetVar(nv,adr,tv,tm);
 if (tm = _Extended) then sh:=SH_E else sh:=SH_D;
 Adr_RE:=adr; Adr_IM:=adr+sh; }

 GetVar2(nv,adr_RE,adr_IM,tv,tm);   {.343}
 adr:=adr_RE;                        {.343}



 if (tv = T_Real) and (st = T_Real)    then  FMUL(adr,tm)
 else
 if (tv = T_Real) and (st = T_Complex) then  begin FMUL(adr,tm); FXCH1; FMUL(adr,tm); FXCH1; end
 else
 if (tv = T_Complex) and (st = T_Real) then
 begin
   FLD0;
   FMUL(adr_im,tm); FXCH1; FMUL(adr_re,tm);
 end
 else
  if (tv = T_Complex) and (st = T_Complex) then
 begin
         FXCH1;
         FLD0;                                     //y1,y1,x1
         FMUL(adr_re,tm);                          //y1*x2,y1,x1
         FXCH2;                                    //x1,y1,y1*x2
         FLD0;                                     //x1,x1,y1,y1*x2
         FMUL(adr_im,tm);                          //x1*y2,x1,y1,y1*x2
         FADDP3;                                   //x1,y1,IM
         FMUL(adr_re,tm);                          //x1*x2,y1,IM
         FXCH1;                                    //y1,x1*x2,IM
         FMUL(adr_im,tm);                          //y1*y2,x1*x2,IM
         FSUBP;                                    //RE,IM
 end
 else
 if (tv = IM_UNIT) and (st = T_Real) then
 begin
   FLDZ;
 end
 else
 if (tv = IM_UNIT) and (st = T_Complex) then
 begin
   FXCH1;
   FCHS;
 end

end;






procedure TForevalH.DIV_SC(TS,TC: Integer);
{деление   стека TS=T_Real: ST(0), TS=T_Complex: ST(0),ST(1) на константу TC = C_Real,C_Complex;  и наоборот inv=0,1 }
var
 Adr,Adr_RE,Adr_IM,AdrC: Cardinal;                //st = T_Real,T_Complex
 tv,tm,sh,CMul,inv: Integer;
 Re,Im: Extended;
begin

 
 inv:=GNode^.Inv;

Re:=0; Im:=0;
if TC =  C_Real    then Re:=GNode^.FD else
if TC =  C_Complex then
begin
  Re:=GNode^.FDC.re;
  Im:=GNode^.FDC.im;
end;

CMul:=-1;
if (Re = 0)  and  (Im = 0)  then CMul:=0 else  // 0
if (Re = 1)  and  (Im = 0)  then CMul:=1 else  // 1
if (Re = -1) and  (Im = 0)  then CMul:=2 else  // -1
if (Re = 0)  and  (Im = 1)  then CMul:=3 else  // i
if (Re = 0)  and  (Im = -1) then CMul:=4 else  // -i
if (Re = 0)                 then CMul:=5;      // im*i


if TC = C_Real then    // S(r)/C(r), c(r)/S(r)
begin


          if TS = T_Real then      //  S(r)/c(r), c(r)/S(r)
          begin
             if (CMul = 0) and (inv = 0) then    // 0/C(r)
             begin
               FLDZ;
             end
             else
             if inv = 0 then FDIV(WriteData(GNode),F_DataType) else
               if inv = 1 then  FDIVR(WriteData(GNode),F_DataType);
          end
          else
          if TS = T_Complex then      //  S(z)/c(r), c(r)/S(z)
          begin

              if inv = 0 then               //xxx                 // (z1*z2+z1*(z1+z2))/50.123;   (DL=3)
              begin
                 if F_FAST_DIV = True then
                 begin
                    AdrC:=WriteData(GNode);
                    FLD(AdrC,F_DataType);
                    FDIVR(TAddress(@S_C1),_Double);
                    FMUL1;
                    FXCH2;
                    FMULP20;
                 end
                 else
                 begin
                    AdrC:=WriteData(GNode);
                    FDIV(AdrC,F_DataType);
                    FXCH1;
                    FDIV(AdrC,F_DataType);
                    FXCH1;
                 end;

              end
              else
              if inv = 1 then
              begin
                 if CMul = 1 then  // 1/S(z)  {.339}
                 begin
                   ZDIVR_C1;
                 end
                 else
                 begin
                   FLD(WriteData(GNode),F_DataType);
                   RZDIV;
                 end;
             end;
          end;

  {
  if inv = 0 then inv:=1 else inv:=0;
  if (CMul = 0) and (inv = 0) then    // 0/C(r)
  begin
    FLDZ;
  end
  else
  begin
   FLD(WriteData(GNode),F_DataType);
   FDIVV(nv,T_Real,inv);
  end;
  }

end
else  //.318 // TC = C_Complex       // v/c(z), c(z)/v
begin

          if TS = T_Real then    //S(r)
          begin

             if inv = 0 then   // S(r)/c(z)
             begin

                 if F_FAST_DIV = True then       //FAST DIV!!!
                 begin

                   FLD(WriteDataA(GNode^.FDC.re,F_DataType),F_DataType);  //x,r
                   FMUL0;                                    //x^2,r
                   FLD(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);  //y,x^2,r
                   FMUL0;                                    //y^2,x^2,r
                   FADDP;
                   FLD1;
                   FDIVRP;                                   //B,r (B=1/(x^2+y^2))

                   FLD(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);   //y,B,r
                   FMUL02;                                   //y*r,B,r
                   FMUL01;                                   //y*B*r,B,r
                   FCHS;                                     //IM,B,r
                   FXCH2;                                    //r,B,IM
                   FMULP;                                    //r*B,IM
                   FMUL(WriteDataA(GNode^.FDC.re,F_DataType),F_DataType); //RE,IM

                 end
                 else
                 begin
                   {.335}
                   FLD(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);     //y,r
                   FXCH1;                                                    //r,y
                   FLD(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);     //x,r,y
                   FXCH1;                                                    //r,x,y
                   //MOVAadr(TAddress(@Z_RZDIV_acc));
                   MOVAadr(TAddress(RZDIV_ADDR)); {.345}
                   CheckStack(2);
                   CheckStack(-3);
                   CALLA;
                   {
                   FLD(WriteDataA(GNode^.FDC.re,F_DataType),F_DataType);                                //x,r
                   FMUL0;                                    //x^2,r
                   FLD(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);                                //y,x^2,r
                   FMUL0;                                    //y^2,x^2,r
                   FADDP;                                    //B,r (B=(x^2+y^2))

                   FLD(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);                                //y,B,r
                   FMUL02;                                   //y*r,B,r
                   FDIV01;                                   //y*r/B,B,r
                   FCHS;                                     //IM,B,r
                   FXCH2;                                    //r,B,IM
                   FDIVRP;                                    //r/B,IM
                   FMUL(WriteDataA(GNode^.FDC.re,F_DataType),F_DataType);                           //RE,IM
                   }
                 end;

             end

             else

             if inv = 1 then    // c(z)/S(r)
             begin

                if (CMul = 3)  then  // i/S(r)
                begin
                   FDIVR(TAddress(@S_C1),_Double);
                   FLDZ;
                end
                else
                if  (CMul = 4) then  //  -i/S(r)
                begin
                   FDIVR(TAddress(@S_C1n),_Double);
                   FLDZ;
                end
                else
                if  (CMul = 5) then  //  [0,im]/S(r)       2i/(x+y)
                begin
                   FDIVR(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);
                   FLDZ;
                end
                else    // c[re,im]/S(r)
                begin

                  if F_FAST_DIV = True then    //FAST DIV!!!
                   begin
                     FDIVR(TAddress(@S_C1),_Double);
                     FLD0;
                     FMUL(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);
                     FXCH1;
                     FMUL(WriteDataA(GNode^.FDC.re,F_DataType),F_DataType);
                   end
                   else
                   begin
                     FLD0;
                     FDIVR(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);
                     FXCH1;
                     FDIVR(WriteDataA(GNode^.FDC.re,F_DataType),F_DataType);
                   end;

                end;

             end; //inv = 1


          end
          else
          if TS = T_Complex then      //S(z)
          begin
             if inv = 0 then     // S(z)/c(z)
             begin

               //else
               begin
                 FLD(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);
                 FXCH2;
                 FLD(WriteDataA(GNode^.FDC.re,F_DataType),F_DataType);
                 FXCH2;

                 ZDIV;
               end;

             end
             else
             if inv = 1 then    // c(z)/S(z)
             begin

                if (CMul = 3) or (CMul = 4) then      // i/S(z) , -i/S(z)
                begin
                  if F_FAST_DIV = True then
                  begin
                    FLD0;
                    FMUL0;
                    FXCH2;
                    FLD0;
                    FMUL0;
                    FADDP30;
                    FLD1;
                    if (CMul = 4) then FCHS;
                    FDIVRP3;

                    FMUL02;
                    FXCH2;
                    FMULP;
                    FXCH1;
                  end
                  else
                  begin
                    FLD0;
                    FMUL0;
                    FXCH2;
                    FLD0;
                    FMUL0;
                    FADDP30;

                    FDIV02;
                    FXCH2;
                    FDIVP;
                    if (CMul = 4) then FCHS;
                    FXCH1;
                    if (CMul = 4) then FCHS;
                  end;

                end
                else
                if CMul = 5 then //[0,im]/S(z)
                begin

                   if F_FAST_DIV = True then
                   begin
                     FLD0;
                     FMUL0;
                     FXCH2;
                     FLD0;
                     FMUL0;
                     FADDP30;
                     FLD(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);
                     FDIVRP3;

                     FMUL02;
                     FXCH2;
                     FMULP;
                     FXCH1;
                   end
                   else
                   begin
                     {.335}
                     FLD(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);   //r(im),x,y
                     //MOVAadr(TAddress(@Z_RZDIV_acc));
                     MOVAadr(TAddress(RZDIV_ADDR));
                     CheckStack(2);
                     CheckStack(-3);
                     CALLA;
                     //res=res*i
                     FXCH1;
                     FCHS;

                     {
                     FLD0;
                     FMUL0;
                     FXCH2;
                     FLD0;
                     FMUL0;
                     FADDP30;

                     FDIV02;
                     FMUL(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);
                     FXCH2;
                     FDIVP;
                     FMUL(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);
                     FXCH1;
                     }
                 end;
             
                end
                else
                begin
                  FLD(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);
                  FLD(WriteDataA(GNode^.FDC.re,F_DataType),F_DataType);
                  ZDIV;
                end;
             end;


          end;

end



end;






procedure TForevalH.DIV_VC(nv: Integer; TC: Integer);
{деление  переменной nv на константу и наоборот inv=0,1 (TC = C_Real,C_Complex)}
var
 Adr,Adr_RE,Adr_IM,AdrC: Cardinal;                //st = T_Real,T_Complex
 tv,tm,sh,CMul,inv: Integer;
 Re,Im: Extended;
begin
 {
 GetVar(nv,adr,tv,tm);
 if (tm = _Extended) then sh:=SH_E else sh:=SH_D;
 Adr_RE:=adr; Adr_IM:=adr+sh;
 }
 GetVar2(nv,adr_RE,adr_IM,tv,tm);        {.343}
 adr:=adr_RE;                            {.343}


 inv:=GNode^.Inv;

Re:=0; Im:=0;
if TC =  C_Real    then Re:=GNode^.FD else
if TC =  C_Complex then
begin
  Re:=GNode^.FDC.re;
  Im:=GNode^.FDC.im;
end;

CMul:=-1;
if (Re = 0)  and  (Im = 0)  then CMul:=0 else  // 0
if (Re = 1)  and  (Im = 0)  then CMul:=1 else  // 1
if (Re = -1) and  (Im = 0)  then CMul:=2 else  // -1
if (Re = 0)  and  (Im = 1)  then CMul:=3 else  // i
if (Re = 0)  and  (Im = -1) then CMul:=4 else  // -i
if (Re = 0)                 then CMul:=5;      // im*i


if TC = C_Real then    // v/c(r), c(r)/v
begin
  if inv = 0 then inv:=1 else inv:=0;

  if (CMul = 0) and (inv = 0) then    // 0/v
  begin
    FLDZ;
  end
  else
  if (CMul = 1) and (inv = 0) and (tv = T_Complex) then // 1/v(complex)
  begin
    FLDV(nv);
    ZDIVR_C1;
  end
  else
  begin
   FLD(WriteData(GNode),F_DataType);
   FDIVV(nv,T_Real,inv);
  end;

end
else  //.318 // TC = C_Complex       // v/c(z), c(z)/v
begin

   if inv = 0 then inv:=1 else inv:=0;

   if TV = T_Real then
   begin

        if CMul = 3 then
        begin
           if inv = 0 then     // i/v(re)
           begin
              FLD(adr,tm);
              FDIVR(TAddress(@S_C1),_Double);
              FLDZ;
           end
           else   //v(re)/i
           begin
              FLD(adr,tm);
              FCHS;
              FLDZ;
           end;
        end
        else
        if CMul = 4 then
        begin
           if inv = 0 then     // -i/v(re)
           begin
              FLD(adr,tm);
              FDIVR(TAddress(@S_C1n),_Double);
              FLDZ;
           end
           else   //v(re)/(-i)
           begin
              FLD(adr,tm);
              FLDZ;
           end;
        end
        else
        if CMul = 5 then
        begin
           if inv = 0 then     // [0,im]/v(re)
           begin
              FLD(adr,tm);
              FDIVR(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);
              FLDZ;
           end
           else   //v(re)/[0,im]
           begin
              FLD(adr,tm);
              FDIV(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);
              FLDZ;
           end;
        end
        else     // v(re)/[re,im] ;  [re,im]/v(re)
        begin
           FLD(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);
           FLD(WriteDataA(GNode^.FDC.re,F_DataType),F_DataType);
           FDIVV(nv,T_Complex,inv);
        end;
   end

   else

   if TV = T_Complex then
   begin
       if (CMul = 3) or (CMul = 4) then
        begin

          if inv = 0 then     // i/v(re,im)
           begin
               if F_FAST_DIV = True then      //FAST DIV!!!
               begin
                 FLD(Adr_re,tm);
                 FMUL0;
                 FLD(Adr_im,tm);
                 FMUL0;
                 FADDP;
                 FLD1;
                 FDIVRP;

                 FLD0;
                 FMUL(Adr_RE,tm);
                 if CMul = 4 then  FCHS;      // -i/v(re,im)
                 FXCH1;
                 FMUL(Adr_IM,tm);
                 if CMul = 4 then  FCHS;      // -i/v(re,im)
               end
               else
               begin
                 FLD(Adr_re,tm);
                 FMUL0;
                 FLD(Adr_im,tm);
                 FMUL0;
                 FADDP;

                 FLD0;
                 FDIVR(Adr_RE,tm);
                 if CMul = 4 then  FCHS;       // -i/v(re,im)
                 FXCH1;
                 FDIVR(Adr_IM,tm);
                 if CMul = 4 then  FCHS;       // -i/v(re,im)
             end;
           end
           else   //v(re,im)/i
           begin
              if CMul = 3 then
              begin
                FLD(Adr_RE,tm);
                FCHS;
                FLD(Adr_IM,tm);
              end
              else   // CMul = 4  : v(re,im)/(-i)
              begin
                FLD(Adr_RE,tm);
                FLD(Adr_IM,tm);
                FCHS;
              end;
           end;

        end
        else
        if CMul = 5 then
        begin
           if inv = 0 then     // [0,im]/v(re,im)
           begin
               if F_FAST_DIV = True then      //FAST DIV!!!
               begin
                 FLD(Adr_re,tm);
                 FMUL0;
                 FLD(Adr_im,tm);
                 FMUL0;
                 FADDP;
                 FLD(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);
                 FDIVRP;


                 FLD0;
                 FMUL(Adr_RE,tm);
                 FXCH1;
                 FMUL(Adr_IM,tm);
               end
               else
               begin
                 {.335}
                 FLD(Adr_im,tm);
                 FLD(Adr_re,tm);
                 FLD(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);
                 //MOVAadr(TAddress(@Z_RZDIV_acc));
                 MOVAadr(TAddress(RZDIV_ADDR));     {.345}
                 CheckStack(2);
                 CheckStack(-3);
                 CALLA;
                 //res=res*i
                 FXCH1;
                 FCHS;
                 {
                 FLD(Adr_re,tm);
                 FMUL0;
                 FLD(Adr_im,tm);
                 FMUL0;
                 FADDP;

                 FLD0;
                 FDIVR(Adr_RE,tm);
                 FMUL(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);
                 FXCH1;
                 FDIVR(Adr_IM,tm);
                 FMUL(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);
                 }
             end;
           end
           else   //v(re,im)/[0,im]
           begin
               if F_FAST_DIV = True then      //FAST DIV!!!
               begin
                  FLD(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);
                  FDIVR(TAddress(@S_C1),_Double);
                  FLD0;

                  FMUL(Adr_RE,tm);
                  FCHS;
                  FXCH1;
                  FMUL(Adr_IM,tm);
               end
               else
               begin
                  FLD(Adr_RE,tm);
                  FDIV(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);
                  FCHS;
                  FLD(Adr_IM,tm);
                  FDIV(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);
               end;
           end;
        end
        else           // v(re,im)/[re,im] ;  [re,im]/v(re,im)
        begin
          FLD(WriteDataA(GNode^.FDC.im,F_DataType),F_DataType);
          FLD(WriteDataA(GNode^.FDC.re,F_DataType),F_DataType);
          FDIVV(nv,T_Complex,inv);
        end;
   end;
end



end;





procedure TForevalH.FDIVV(nv: Integer; st: Integer; inv:Integer = 0);
var
 Adr,Adr_RE,Adr_IM: Cardinal;                //st = T_Real,T_Complex
 tv,tm,sh: Integer;
begin                          //S/v (inv=0); v/S (inv=1);
 {
 GetVar(nv,adr,tv,tm);
 if (tm = _Extended) then sh:=SH_E else sh:=SH_D;
 Adr_RE:=adr; Adr_IM:=adr+sh;
 }

 GetVar2(nv,adr_RE,adr_IM,tv,tm); {.343}
 adr:=adr_RE;                     {.343}

 if (tv = T_Real) and (st = T_Real)    then
 begin
  if (inv = 0) then  FDIV(adr,tm) else if (inv = 1) then FDIVR(adr,tm);
 end
 else
 if (tv = T_Real) and (st = T_Complex) then
 begin
  if (inv = 0) then   // S(z)/r           (z1+z2)/x
  begin

    if F_FAST_DIV = True then
    begin
       //FAST DIV!!!
      FLD(adr,tm);
      FDIVR(TAddress(@S_C1),_Double);
      FMUL20;
      FMULP;
    end
    else
    begin
      FDIV(adr,tm);
      FXCH1;
      FDIV(adr,tm);
      FXCH1;
    end;

  end
  else
  if (inv = 1) then    // r/S(z)          x/(z1+z2)
  begin  //FAST DIV!!!
         FLDV(nv);
         RZDIV;

  end
 end
 else
 if (tv = T_Complex) and (st = T_Real) then
 begin
   if (inv = 0) then   //S(r)(fpu)/z(mem)            // (x*y+x*y)/z1
   begin
       if F_FAST_DIV = True then
       begin
         //FAST DIV!!!
         FLDV_RE(nv);                               //x,r
         FMUL0;                                    //x^2,r
         FLDV_IM(nv);                               //y,x^2,r
         FMUL0;                                    //y^2,x^2,r
         FADDP;
         FLD1;
         FDIVRP;                                   //B,r (B=1/(x^2+y^2))

         FLDV_IM(nv);                               //y,B,r
         FMUL02;                                   //y*r,B,r
         FMUL01;                                   //y*B*r,B,r
         FCHS;                                     //IM,B,r
         FXCH2;                                    //r,B,IM
         FMULP;                                    //r*B,IM
         FMUL(Adr_RE,tm);                          //RE,IM
       end
       else
       begin
         {.335}
         FLDV_IM(nv);                              //y,r
         FXCH1;                                    //r,y
         FLDV_RE(nv);                              //x,r,y
         FXCH1;                                    //r,x,y
         //MOVAadr(TAddress(@Z_RZDIV_acc));
         MOVAadr(TAddress(RZDIV_ADDR));     {.345}
         CheckStack(2);
         CheckStack(-3);
         CALLA;
         {
         FLDV_RE(nv);                               //x,r
         FMUL0;                                    //x^2,r
         FLDV_IM(nv);                               //y,x^2,r
         FMUL0;                                    //y^2,x^2,r
         FADDP;                                    //B,r (B=(x^2+y^2))
        
         FLDV_IM(nv);                               //y,B,r
         FMUL02;                                   //y*r,B,r
         FDIV01;                                   //y*r/B,B,r
         FCHS;                                     //IM,B,r
         FXCH2;                                    //r,B,IM
         FDIVRP;                                    //r/B,IM
         FMUL(Adr_RE,tm);                          //RE,IM
         }
       end;
   end
   else
   if (inv = 1) then       //z(mem)/S(r)(fpu)        // z1/(x*y+x*y)
   begin

         if F_FAST_DIV = True then
         begin //FAST DIV !!!
            FDIVR(TAddress(@S_C1),_Double);
            FLD0;
            FMUL(adr_IM,tm);
            FXCH1;
            FMUL(adr_RE,tm);
         end
         else
         begin
            FLD0;
            FDIVR(adr_IM,tm);
            FXCH1;
            FDIVR(adr_RE,tm);
         end;
   end
 end
 else
  if (tv = T_Complex) and (st = T_Complex) then          // (z1+z2)/z1
 begin
   if (inv = 0) then                                //  S(z)(fpu)/z(mem)
   begin //FAST DIV!!!
         FLDV_IM(nv);
         FXCH2;
         FLDV_RE(nv);
         FXCH2;

         ZDIV;
   end
   else
   if (inv = 1) then                                  //  z(mem)/S(z)(fpu)
   begin //FAST DIV!!!                                   // z1/(z1+z2)
         FLDV_IM(nv);
         FLDV_RE(nv);

         ZDIV;
   end
 end
 else
 if (tv = IM_UNIT) and (st = T_Real) then
 begin
   if (inv = 1) then      // i/S(r)
   begin
    FLD1;
    FDIVRP;
    FLDZ;
   end
   else
   if (inv = 0) then     // S(r)/i
   begin
    FCHS;
    FLDZ;
   end
 end
 else
 if (tv = IM_UNIT) and (st = T_Complex) then
 begin
   if (inv = 1) then          //  i/S(z)         //  i/(z1+z2)
   begin

         if F_FAST_DIV = True then
         begin //FAST DIV !!!
           FLD0;
           FMUL0;                                  //x^2,x,y
           FXCH2;                                  //y,x,x^2
           FLD0;                                   //y,y,x,x^2
           FMUL0;                                  //y^2,y,x,x^2,
           FADDP3;                                 //y,x,y^2+x^2
           FXCH2;                                  //y^2+x^2,y,x
           FLD1;
           FDIVRP;                                 //B,y,x
           FMUL1;                                  //B,IM,x
           FMULP2;
           FXCH1;
         end
         else
         begin
           FLD0;
           FMUL0;                                  //x^2,x,y
           FXCH2;                                  //y,x,x^2
           FLD0;                                   //y,y,x,x^2
           FMUL0;                                  //y^2,y,x,x^2,
           FADDP3;                                 //y,x,y^2+x^2
           FXCH2;                                  //y^2+x^2,y,x
                                                    //B,y,x
           FDIV10;                                 //B,IM,x
           FDIVP2;
           FXCH1;
         end;
   end
   else
   if (inv = 0) then                //   S(z)/i
   begin
    FCHS;
    FXCH1;
   end
 end

end;






procedure TForevalH.FLDS(K: Integer; fm:Integer = _FPU);
var
S,st,t,N,NF: Integer;
begin                           //DL загрузка стека (K - номер аргумента = 0,1) !!!
 S:={Interp[NFunc]}GNode^.S;
 N:={Interp[NFunc]}GNode^.NFunc;
 NF:={Interp[NFunc]}GNode^.NF;

 if {Interp[NFunc]}GNode^.TypeA = 0 then  t:=Alg.ExFunc[N].Func[NF].TV[K] else  t:={Interp[NFunc]}GNode^.TypeA;

st:={Interp[NFunc]}GNode^.RData[K];
if fm = _MEM then st:=_MEM;


if st = _MEM then
begin
  if t = T_Real then   FLD(GetStackAdr(S,_RE),F_DataType)
  else
  if t = T_Complex then
  begin
     FLD(GetStackAdr(S,_IM),F_DataType);
     FLD(GetStackAdr(S,_RE),F_DataType);
  end;
end;
end;





procedure TForevalH.SUB_C;
var
t1,t2,N,NF,S,st1,st2,Arg,nv1,nv2,Inv,xchT: Integer;
XchArg: Boolean ;

  procedure SUB_ST;
  begin
   if (t1 = T_Real) and (t2 = T_Real) then
   begin
     if XchArg = False then
     begin
        FLD(GetStackAdr(S,_RE),F_DataType);
        FSUB(GetStackAdr(S+1,_RE),F_DataType);
     end
     else
     begin
        FLD(GetStackAdr(S,_RE),F_DataType);
        FSUBR(GetStackAdr(S+1,_RE),F_DataType);
     end;
   end
   else
   if (t1 = T_Real) and (t2 = T_Complex) then
   begin
     if XchArg = False then
     begin
        FLD(GetStackAdr(S+1,_IM),F_DataType);
        FCHS;
        FLD(GetStackAdr(S,_RE),F_DataType);
        FSUB(GetStackAdr(S+1,_RE),F_DataType);
     end
     else
     begin
        FLD(GetStackAdr(S+1,_IM),F_DataType);
        FLD(GetStackAdr(S,_RE),F_DataType);
        FSUBR(GetStackAdr(S+1,_RE),F_DataType);
     end;
   end
   else
   if (t1 = T_Complex) and (t2 = T_Real) then
   begin
     if XchArg = False then
     begin
        FLD(GetStackAdr(S,_IM),F_DataType);
        FLD(GetStackAdr(S,_RE),F_DataType);
        FSUB(GetStackAdr(S+1,_RE),F_DataType);
     end
     else
     begin
        FLD(GetStackAdr(S,_IM),F_DataType);
        FCHS;
        FLD(GetStackAdr(S,_RE),F_DataType);
        FSUBR(GetStackAdr(S+1,_RE),F_DataType);
     end;
   end
   else
   if (t1 = T_Complex) and (t2 = T_Complex) then
   begin
     if XchArg = False then
     begin
       FLD(GetStackAdr(S,_IM),F_DataType);
       FSUB(GetStackAdr(S+1,_IM),F_DataType);
       FLD(GetStackAdr(S,_RE),F_DataType);
       FSUB(GetStackAdr(S+1,_RE),F_DataType);
     end
     else
     begin
       FLD(GetStackAdr(S,_IM),F_DataType);
       FSUBR(GetStackAdr(S+1,_IM),F_DataType);
       FLD(GetStackAdr(S,_RE),F_DataType);
       FSUBR(GetStackAdr(S+1,_RE),F_DataType);
     end;

   end;
  end;


  procedure SUB_DL;
  begin
     if (t1 = T_Real) and (t2 = T_Real) then
     begin
        if (st1 = _FPU) and (st2 = _FPU) then
        begin
           if XchArg = False then FSUBP else FSUBRP;
        end
        else
        if (st1 = _FPU) and (st2 = _MEM) then
        begin
           if XchArg = False then FSUB(GetStackAdr(S+1,_RE),F_DataType) else FSUBR(GetStackAdr(S+1,_RE),F_DataType);
        end
        else
        if (st1 = _MEM) and (st2 = _FPU) then
        begin
            if XchArg = False then  FSUBR(GetStackAdr(S,_RE),F_DataType) else FSUB(GetStackAdr(S,_RE),F_DataType)  ;
        end
        else
        if (st1 = _MEM) and (st2 = _MEM) then
        begin
           if XchArg = False then
           begin
              FLD(GetStackAdr(S,_RE),F_DataType);
              FSUB(GetStackAdr(S+1,_RE),F_DataType);
           end
           else
           begin
              FLD(GetStackAdr(S,_RE),F_DataType);
              FSUBR(GetStackAdr(S+1,_RE),F_DataType);
           end;
        end;
     end
    else
    if (t1 = T_Real) and (t2 = T_Complex) then
    begin
       if (st1 = _FPU) and (st2 = _FPU) then
       begin
         if XchArg = False then
         begin
           FSUBP2;
           FCHS;
           FXCH1;
         end
         else
         begin
           FSUBRP2;
           FXCH1;
         end;
       end
       else
       if (st1 = _FPU) and (st2 = _MEM) then
       begin
         if XchArg = False then
         begin
           FSUB(GetStackAdr(S+1,_RE),F_DataType);
           FLD(GetStackAdr(S+1,_IM),F_DataType);
           FXCH1;
         end
         else
         begin
           FSUBR(GetStackAdr(S+1,_RE),F_DataType);
           FLD(GetStackAdr(S+1,_IM),F_DataType);
           FXCH1;
         end;
       end
       else
       if (st1 = _MEM) and (st2 = _FPU) then
       begin
         if XchArg = False then
         begin
           FXCH1;
           FCHS;
           FXCH1;
           FSUBR(GetStackAdr(S,_RE),F_DataType);
         end
         else
         begin
           FSUB(GetStackAdr(S,_RE),F_DataType);
         end;
       end
       else
       if (st1 = _MEM) and (st2 = _MEM) then
       begin
         if XchArg = False then
         begin
           FLD(GetStackAdr(S+1,_IM),F_DataType);
           FCHS;
           FLD(GetStackAdr(S,_RE),F_DataType);
           FSUB(GetStackAdr(S+1,_RE),F_DataType);
         end
         else
         begin
           FLD(GetStackAdr(S+1,_IM),F_DataType);
           FLD(GetStackAdr(S,_RE),F_DataType);
           FSUBR(GetStackAdr(S+1,_RE),F_DataType);
         end;
       end;
    end
    else
    if (t1 = T_Complex) and (t2 = T_Real) then
    begin
       if (st1 = _FPU) and (st2 = _FPU) then
       begin
         if XchArg = False then
         begin
           FSUBP;
         end
         else
         begin
           FSUBRP;
           FXCH1;
           FCHS;
           FXCH1;
         end;
       end
       else
       if (st1 = _FPU) and (st2 = _MEM) then
       begin
         if XchArg = False then
         begin
           FSUB(GetStackAdr(S+1,_RE),F_DataType);
         end
         else
         begin
           FSUBR(GetStackAdr(S+1,_RE),F_DataType);
           FXCH1;
           FCHS;
           FXCH1;
         end;
       end
       else
       if (st1 = _MEM) and (st2 = _FPU) then
       begin
         if XchArg = False then
         begin
           FSUBR(GetStackAdr(S,_RE),F_DataType);
           FLD(GetStackAdr(S,_IM),F_DataType);
           FXCH1;
         end
         else
         begin
           FSUB(GetStackAdr(S,_RE),F_DataType);
           FLD(GetStackAdr(S,_IM),F_DataType);
           FCHS;
           FXCH1;
         end;
       end
       else
       if (st1 = _MEM) and (st2 = _MEM) then
       begin
         if XchArg = False then
         begin
           FLD(GetStackAdr(S,_IM),F_DataType);
           FLD(GetStackAdr(S,_RE),F_DataType);
           FSUB(GetStackAdr(S+1,_RE),F_DataType);
         end
         else
         begin
           FLD(GetStackAdr(S,_IM),F_DataType);
           FCHS;
           FLD(GetStackAdr(S,_RE),F_DataType);
           FSUBR(GetStackAdr(S+1,_RE),F_DataType);
         end;
       end;
    end
    else
    if (t1 = T_Complex) and (t2 = T_Complex) then
    begin
       if (st1 = _FPU) and (st2 = _FPU) then
       begin
         if XchArg = False then
         begin
           FSUBP2;
           FSUBP2;
         end
         else
         begin
           FSUBRP2;
           FSUBRP2;
         end;
       end
       else
       if (st1 = _MEM) and (st2 = _MEM) then
       begin
         if XchArg = False then
         begin
           FLD(GetStackAdr(S,_IM),F_DataType);
           FSUB(GetStackAdr(S+1,_IM),F_DataType);
           FLD(GetStackAdr(S,_RE),F_DataType);
           FSUB(GetStackAdr(S+1,_RE),F_DataType);
         end
         else
         begin
           FLD(GetStackAdr(S,_IM),F_DataType);
           FSUBR(GetStackAdr(S+1,_IM),F_DataType);
           FLD(GetStackAdr(S,_RE),F_DataType);
           FSUBR(GetStackAdr(S+1,_RE),F_DataType);
         end;
       end
       else
       if (st1 = _FPU) and (st2 = _MEM) then
       begin
         if XchArg = False then
         begin
           FSUB(GetStackAdr(S+1,_RE),F_DataType);
           FXCH1;
           FSUB(GetStackAdr(S+1,_IM),F_DataType);
           FXCH1;
         end
         else
         begin
           FSUBR(GetStackAdr(S+1,_RE),F_DataType);
           FXCH1;
           FSUBR(GetStackAdr(S+1,_IM),F_DataType);
           FXCH1;
         end;
       end
       else
       if (st1 = _MEM) and (st2 = _FPU) then
       begin
         if XchArg = False then
         begin
           FSUBR(GetStackAdr(S,_RE),F_DataType);
           FXCH1;
           FSUBR(GetStackAdr(S,_IM),F_DataType);
           FXCH1;
         end
         else
         begin
           FSUB(GetStackAdr(S,_RE),F_DataType);
           FXCH1;
           FSUB(GetStackAdr(S,_IM),F_DataType);
           FXCH1;
         end;

       end;
    end;
  end;



  procedure SUB_VAR;                             //v1-v2
  var
    nv1,nv2,tv1,tv2,tm1,tm2,sh1,sh2: Integer;
    Adr1,Adr2,V1_RE,V1_IM,V2_RE,V2_IM: Cardinal;
  begin
   {nv1:=Interp[NFunc].nv1;
   nv2:=Interp[NFunc].nv2;  }
   nv1:=GNode^.NV1;
   nv2:=GNode^.NV2;
   {
   GetVar(nv1,adr1,tv1,tm1);
   GetVar(nv2,adr2,tv2,tm2);
   if (tm1 = _Extended) then sh1:=SH_E else sh1:=SH_D;
   if (tm2 = _Extended) then sh2:=SH_E else sh2:=SH_D;
   V1_RE:=adr1;
   V1_IM:=adr1+sh1;
   V2_RE:=adr2;
   V2_IM:=adr2+sh2;
   }

   GetVar2(nv1,V1_RE,V1_IM,tv1,tm1);      {.343}
   GetVar2(nv2,V2_RE,V2_IM,tv2,tm2);       {.343}
   adr1:=V1_RE; adr2:=V2_RE;               {.343}

   if (tv1 = T_Real) and (tv2 = T_Real) then         //r1+r2
   begin
     FLD(Adr1,tm1);  //FLDV(nv1);
     FSUB(Adr2,tm2); //FADDV(nv2,tv2);
   end
   else
   if (tv1 = T_Real) and (tv2 = IM_UNIT) then       //r1-i
   begin
     FLD1;
     FCHS;
     FLD(Adr1,tm1);
   end
   else
   if (tv1 = T_Real) and (tv2 = T_Complex) then       //r1-z2
   begin
     FLDV_IM(nv2);
     FCHS;
     FLDV(nv1);
     FSUB(V2_RE,tm2);
   end
   else
   if (tv1 = IM_UNIT) and (tv2 = T_Real) then         //i-r2
   begin
     FLD1;
     FLD(Adr2,tm2);
     FCHS;
   end
   else
   if (tv1 = T_Complex) and (tv2 = T_Real) then      //z1-r1
   begin
     FLDV(nv1);
     FSUB(Adr2,tm2);
   end
   else
   if (tv1 = T_Complex) and (tv2 = T_Complex) then   //z1-z2
   begin
     FLD(V1_IM,tm1);
     FSUB(V2_IM,tm2);
     FLD(V1_RE,tm1);
     FSUB(V2_RE,tm2);
   end
   else
   if (tv1 = IM_UNIT) and (tv2 = T_Complex) then       //i-z1
   begin
     FLD1;
     FSUB(V2_IM,tm2);
     FLDV_RE(nv2);
     FCHS;
   end
   else
   if (tv1 = T_Complex) and (tv2 = IM_UNIT) then        //z1-i
   begin
     FLDV_IM(nv1);
     FLD1;
     FSUBP;
     FLDV_RE(nv1);
   end;

  end;


///////////////////////////////////////MAIN/////////////////////////////////////
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 Arg:=Interp[NFunc].N;
 inv:=Interp[NFunc].Inv;
 t1:=Alg.ExFunc[N].Func[NF].TV[0]; t2:=Alg.ExFunc[N].Func[NF].TV[1];
 st1:=Interp[NFunc].RData[0]; st2:=Interp[NFunc].RData[1];
 nv1:=Interp[NFunc].NV1;
 nv2:=Interp[NFunc].NV2;
 }

 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 Arg:=GNode^.N;
 inv:=GNode^.Inv;
 t1:=Alg.ExFunc[N].Func[NF].TV[0]; t2:=Alg.ExFunc[N].Func[NF].TV[1];
 st1:=GNode^.RData[0]; st2:=GNode^.RData[1];
 nv1:=GNode^.NV1;
 nv2:=GNode^.NV2;

 XchArg:=GNode^.XchArg;

 //if (Arg = 1) and (Interp[NFunc].TypeA <> 0) then  t1:=Interp[NFunc].TypeA;
 if (Arg = 1) and (GNode^.TypeA <> 0) then  t1:=GNode^.TypeA;

 if XchArg = True then
 begin
   xchT:=t1;
   t1:=t2;
   t2:=xchT;
 end;



 if F_SaveInFPU = False then
 begin
   if (Arg = 2) and (nv1 = -1) and (nv2 = -1) then         //S1-S2
   begin
    SUB_ST;
   end
   else
   if (Arg = 0) and (nv1 >= 0) and (nv2 >= 0) then         //v1-v2
   begin
      SUB_VAR;
   end
   else
   if (Arg = 1) and  (nv1 >= 0)     then                   //S-v1
   begin
      FLDS(0,_MEM);  FSUBV(nv1,t1,inv)
   end
   else
   if (Arg = 1) and  (nv1 = -1) and (nv2 = -1)  then       //S1-c
   begin
    FLDS(0,_MEM);
    if inv = 0 then FSUB(WriteData(GNode{NFunc}),F_DataType)
    else
    if inv = 1 then
    begin
     if t1 = T_Real then
      FSUBR(WriteData(GNode{NFunc}),F_DataType)
     else
     if t1 = T_Complex then
     begin
      FXCH1; FCHS; FXCH1; FSUBR(WriteData(GNode{NFunc}),F_DataType);
     end;
    end
   end
   else
   if (Arg = 0) and (nv2 = -1)    then                     //v-c
   begin
     FLD(WriteData(GNode{NFunc}),F_DataType);
     if inv = 0 then FSUBV(nv1,T_Real,1) else if inv = 1 then  FSUBV(nv1,T_Real,0);
   end
 end
 else
 if F_SaveInFPU = True then
 begin
   if (Arg = 2) and (nv1 = -1) and (nv2 = -1) then         //S1-S2
   begin
    SUB_DL;
   end
   else
   if (Arg = 0) and (nv1 >= 0) and (nv2 >= 0) then         //v1-v2
   begin
      SUB_VAR;
   end
   else
   if (Arg = 1) and  (nv1 >= 0)     then                   //S-v1
   begin
      FLDS(0);  FSUBV(nv1,t1,inv)
   end
   else
   if (Arg = 1) and  (nv1 = -1) and (nv2 = -1)  then       //S1-c
   begin
    FLDS(0);
    if inv = 0 then FSUB(WriteData(GNode{NFunc}),F_DataType)
    else
    if inv = 1 then
    begin
     if t1 = T_Real then
      FSUBR(WriteData(GNode{NFunc}),F_DataType)
     else
     if t1 = T_Complex then
     begin
      FXCH1; FCHS; FXCH1; FSUBR(WriteData(GNode{NFunc}),F_DataType);
     end;
    end
   end
   else
   if (Arg = 0) and (nv2 = -1)    then                     //v-c
   begin
     FLD(WriteData(GNode{NFunc}),F_DataType);
     if inv = 0 then FSUBV(nv1,T_Real,1) else if inv = 1 then  FSUBV(nv1,T_Real,0);

   end;
 end;

end;






procedure TForevalH.MUL_C;
var
t1,t2,N,NF,S,st1,st2,Arg,nv1,nv2,AdrC,xchT,TC,TS: Integer;
XchArg: Boolean;

  procedure MUL_ST;
  begin
    if (t1 = T_Real) and (t2 = T_Real) then
  begin
   FLD(GetStackAdr(S,_RE),F_DataType);
   FMUL(GetStackAdr(S+1,_RE),F_DataType);
  end
  else
  if (t1 = T_Real) and (t2 = T_Complex) then
  begin
   FLD(GetStackAdr(S+1,_IM),F_DataType);
   FMUL(GetStackAdr(S,_RE),F_DataType);
   FLD(GetStackAdr(S+1,_RE),F_DataType);
   FMUL(GetStackAdr(S,_RE),F_DataType);
  end
  else
  if (t1 = T_Complex) and (t2 = T_Real) then
  begin
   FLD(GetStackAdr(S,_IM),F_DataType);
   FMUL(GetStackAdr(S+1,_RE),F_DataType);
   FLD(GetStackAdr(S,_RE),F_DataType);
   FMUL(GetStackAdr(S+1,_RE),F_DataType);
  end
  else
  if (t1 = T_Complex) and (t2 = T_Complex) then
  begin
   FLD(GetStackAdr(S+1,_IM),F_DataType);
   FLD(GetStackAdr(S+1,_RE),F_DataType);
   FLD(GetStackAdr(S,_IM),F_DataType);
   FLD(GetStackAdr(S,_RE),F_DataType);
   ZMULP;
   {MOVA1(TAddress(@Z_MUL));
   CALLA;}
  end;
  end;


  procedure MUL_DL;
  begin
    if (t1 = T_Real) and (t2 = T_Real) then
  begin
        if (st1 = _FPU) and (st2 = _FPU) then
        begin
           FMULP;
        end
        else
        if (st1 = _FPU) and (st2 = _MEM) then
        begin
           FMUL(GetStackAdr(S+1,_RE),F_DataType)
        end
        else
        if (st1 = _MEM) and (st2 = _FPU) then
        begin
           FMUL(GetStackAdr(S,_RE),F_DataType)
        end
        else
        if (st1 = _MEM) and (st2 = _MEM) then
        begin
          FLD(GetStackAdr(S,_RE),F_DataType);
          FMUL(GetStackAdr(S+1,_RE),F_DataType);
        end;
  end
  else
  if (t1 = T_Real) and (t2 = T_Complex) then
  begin
       if (st1 = _FPU) and (st2 = _FPU) then
       begin
         FMUL02;
         FXCH1;
         FMULP2;
       end
       else
       if (st1 = _FPU) and (st2 = _MEM) then
       begin
         FLD0;
         FMUL(GetStackAdr(S+1,_IM),F_DataType);
         FXCH1;
         FMUL(GetStackAdr(S+1,_RE),F_DataType);
       end
       else
       if (st1 = _MEM) and (st2 = _FPU) then
       begin
         FMUL(GetStackAdr(S,_RE),F_DataType);
         FXCH1;
         FMUL(GetStackAdr(S,_RE),F_DataType);
         FXCH1;
       end
       else
       if (st1 = _MEM) and (st2 = _MEM) then
       begin
         FLD(GetStackAdr(S+1,_IM),F_DataType);
         FMUL(GetStackAdr(S,_RE),F_DataType);
         FLD(GetStackAdr(S+1,_RE),F_DataType);
         FMUL(GetStackAdr(S,_RE),F_DataType);
       end;
  end
  else
  if (t1 = T_Complex) and (t2 = T_Real) then
  begin
       if (st1 = _FPU) and (st2 = _FPU) then
       begin
         FMUL1;
         FMULP2;
       end
       else
       if (st1 = _FPU) and (st2 = _MEM) then
       begin
         FMUL(GetStackAdr(S+1,_RE),F_DataType);
         FXCH1;
         FMUL(GetStackAdr(S+1,_RE),F_DataType);
         FXCH1;
       end
       else
       if (st1 = _MEM) and (st2 = _FPU) then
       begin
         FLD0;
         FMUL(GetStackAdr(S,_IM),F_DataType);
         FXCH1;
         FMUL(GetStackAdr(S,_RE),F_DataType);
       end
       else
       if (st1 = _MEM) and (st2 = _MEM) then
       begin
         FLD(GetStackAdr(S,_IM),F_DataType);
         FMUL(GetStackAdr(S+1,_RE),F_DataType);
         FLD(GetStackAdr(S,_RE),F_DataType);
         FMUL(GetStackAdr(S+1,_RE),F_DataType);
       end;
  end
  else
  if (t1 = T_Complex) and (t2 = T_Complex) then
  begin
       if (st1 = _FPU) and (st2 = _FPU) then
       begin
         {MOVA1(TAddress(@Z_MUL));
         CALLA;
         CheckStack(1);
         CheckStack(-3);}
         ZMULP;

       end
       else
       if (st1 = _MEM) and (st2 = _MEM) then      //RE:(x1*x2-y1*y2);IM(y1*x2+y2*x1)
       begin
         FLD(GetStackAdr(S,_IM),F_DataType);      //y1
         FMUL(GetStackAdr(S+1,_RE),F_DataType);   //y1*x2
         FLD(GetStackAdr(S+1,_IM),F_DataType);    //y2
         FMUL(GetStackAdr(S,_RE),F_DataType);     //y1*x1
         FADDP;                                   //IM
         FLD(GetStackAdr(S,_RE),F_DataType);      //x1
         FMUL(GetStackAdr(S+1,_RE),F_DataType);   //x1*x2
         FLD(GetStackAdr(S,_IM),F_DataType);      //y1
         FMUL(GetStackAdr(S+1,_IM),F_DataType);   //y1*y2
         FSUBP;                                   //RE
       end
       else
       if (st1 = _FPU) and (st2 = _MEM) then
       begin
         FXCH1;
         FLD0;                                     //y1,y1,x1
         FMUL(GetStackAdr(S+1,_RE),F_DataType);    //y1*x2,y1,x1
         FXCH2;                                    //x1,y1,y1*x2
         FLD0;                                     //x1,x1,y1,y1*x2
         FMUL(GetStackAdr(S+1,_IM),F_DataType);    //x1*y2,x1,y1,y1*x2
         FADDP3;                                   //x1,y1,IM
         FMUL(GetStackAdr(S+1,_RE),F_DataType);    //x1*x2,y1,IM
         FXCH1;                                    //y1,x1*x2,IM
         FMUL(GetStackAdr(S+1,_IM),F_DataType);    //y1*y2,x1*x2,IM
         FSUBP;                                    //RE,IM
       end
       else
       if (st1 = _MEM) and (st2 = _FPU) then
       begin
         FXCH1;
         FLD0;
         FMUL(GetStackAdr(S,_RE),F_DataType);
         FXCH2;
         FLD0;
         FMUL(GetStackAdr(S,_IM),F_DataType);
         FADDP3;
         FMUL(GetStackAdr(S,_RE),F_DataType);
         FXCH1;
         FMUL(GetStackAdr(S,_IM),F_DataType);
         FSUBP;
       end;
  end;

  end;



  procedure MUL_VAR;                             //v1*v2
  var
    nv1,nv2,tv1,tv2,tm1,tm2,sh1,sh2: Integer;
    Adr1,Adr2,V1_RE,V1_IM,V2_RE,V2_IM: Cardinal;
  begin
   {nv1:=Interp[NFunc].nv1;
   nv2:=Interp[NFunc].nv2; }
   nv1:=GNode^.NV1;
   nv2:=GNode^.NV2;
   {
   GetVar(nv1,adr1,tv1,tm1);
   GetVar(nv2,adr2,tv2,tm2);
   if (tm1 = _Extended) then sh1:=SH_E else sh1:=SH_D;
   if (tm2 = _Extended) then sh2:=SH_E else sh2:=SH_D;
   V1_RE:=adr1;
   V1_IM:=adr1+sh1;
   V2_RE:=adr2;
   V2_IM:=adr2+sh2;
   }

   GetVar2(nv1,V1_RE,V1_IM,tv1,tm1);             {.343}
   GetVar2(nv2,V2_RE,V2_IM,tv2,tm2);              {.343}
   adr1:=V1_RE;   adr2:=V2_RE;                     {.343}

   if (tv1 = T_Real) and (tv2 = T_Real) then
   begin
     FLD(Adr1,tm1);  //FLDV(nv1);
     FMUL(Adr2,tm2); //FADDV(nv2,tv2);
   end
   else
   if (tv1 = T_Real) and (tv2 = IM_UNIT) then
   begin
     FLD(Adr1,tm1);
     FLDZ;
   end
   else
   if (tv1 = T_Real) and (tv2 = T_Complex) then
   begin
     FLDV_IM(nv2); FMUL(V1_RE,tm1);
     FLDV_RE(nv2); FMUL(V1_RE,tm1);
   end
   else
   if (tv1 = IM_UNIT) and (tv2 = T_Real) then
   begin
     FLD(Adr2,tm2);
     FLDZ;
   end
   else
   if (tv1 = T_Complex) and (tv2 = T_Real) then
   begin
     FLDV_IM(nv1); FMUL(V2_RE,tm2);
     FLDV_RE(nv1); FMUL(V2_RE,tm2);
   end
   else
   if (tv1 = T_Complex) and (tv2 = T_Complex) then
   begin
     FLDV_IM(nv1);        //y1
     FMUL(V2_RE,tm2);    //y1*x2
     FLDV_IM(nv2);        //y2
     FMUL(V1_RE,tm1);    //y2*x1
     FADDP;              //IM
     FLDV_RE(nv1);        //x1
     FMUL(V2_RE,tm2);    //x1*x2
     FLDV_IM(nv1);        //y1
     FMUL(V2_IM,tm2);    //y1*y2
     FSUBP;              //RE
   end
   else
   if (tv1 = IM_UNIT) and (tv2 = T_Complex) then
   begin
     FLDV_RE(nv2);
     FLDV_IM(nv2);
     FCHS;
   end
   else
   if (tv1 = T_Complex) and (tv2 = IM_UNIT) then
   begin
     FLDV_RE(nv1);
     FLDV_IM(nv1);
     FCHS;
   end
   else    // del ERROR at CalcConstMulDiv = off  i*i   {.329}
   if (tv1 = IM_UNIT) and (tv2 = IM_UNIT) then
   begin
     FLD1;
     FCHS;
   end

  end;

 {.318}
 procedure MUL_CONST(TypeP,TS,TC: Integer);
 var
   nv1: Integer;
   AdrC: Cardinal;
 begin

   nv1:=GNode^.NV1;

   if TypeP = _Stack then     //S*c
   begin
      if F_SaveInFPU = False then FLDS(0,_MEM)  else  FLDS(0,_FPU);
      MUL_SC(TS,TC);
   end

   else

   if TypeP = _Var then       //v*c
   begin
      MUL_VC(nv1,TC);
   end;



 end;

 /////////////////////////////////MAIN//////////////////////////////////////////
begin
 

 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 Arg:=GNode^.N;
 st1:=GNode^.RData[0];
 st2:=GNode^.RData[1];
 nv1:=GNode^.NV1;
 nv2:=GNode^.NV2;
 t1:=Alg.ExFunc[N].Func[NF].TV[0]; t2:=Alg.ExFunc[N].Func[NF].TV[1];
 TC:=GNode^.TC;   //constant type


 //if (Arg = 1) and (Interp[NFunc].TypeA <> 0) then  t1:=Interp[NFunc].TypeA;
 if (Arg = 1) and (GNode^.TypeA <> 0) then  t1:=GNode^.TypeA;

 XchArg:=GNode^.XchArg;
 if XchArg = True then
 begin
   xchT:=t1;
   t1:=t2;
   t2:=xchT;
 end;

 TS:=t1; //stack type for 1 arg

 if F_SaveInFPU = False then
 begin
   if (Arg = 2) and (nv1 = -1) and (nv2 = -1) then         //S1*S2
   begin
       MUL_ST;
   end
   else
   if (Arg = 0) and (nv1 >= 0) and (nv2 >= 0) then         //v1*v2
   begin
       MUL_VAR;
   end
   else
   if (Arg = 1) and  (nv1 >= 0)     then                   //S*v1
   begin
       FLDS(0,_MEM);  MUL_SV(nv1,t1)
   end
   else
   if (Arg = 1) and  (nv1 = -1) and (nv2 = -1)  then       //S1*c
   begin
        MUL_CONST(_Stack,TS,TC);    {.318}
   end
   else
   if (Arg = 0) and (nv2 = -1)    then                     //v*c
   begin
        MUL_CONST(_VAR,TS,TC);    {.318}
   end
 end
 else
 if F_SaveInFPU = True then
 begin
   if (Arg = 2) and (nv1 = -1) and (nv2 = -1) then         //S1*S2
   begin
       MUL_DL;
   end
   else
   if (Arg = 0) and (nv1 >= 0) and (nv2 >= 0) then         //v1*v2
   begin
      MUL_VAR;
   end
   else
   if (Arg = 1) and  (nv1 >= 0)     then                   //S*v1
   begin
       FLDS(0);  MUL_SV(nv1,t1);
   end
   else
   if (Arg = 1) and  (nv1 = -1) and (nv2 = -1)  then       //S1*c
   begin
      MUL_CONST(_Stack,TS,TC);    {.318}
   end
   else
   if (Arg = 0) and (nv2 = -1)    then                     //v*c
   begin
      MUL_CONST(_VAR,TS,TC);    {.318}
   end;
 end;


end;







procedure TForevalH.DIV_C;
var
t1,t2,N,NF,S,st1,st2,Arg,nv1,nv2,AdrC,inv,xchT,TS,TC: Integer;
XchArg: Boolean;

  procedure DIV_ST;            //without optimization  DL
  begin
    if (t1 = T_Real) and (t2 = T_Real) then
   begin
     if XchArg = False then
     begin
        FLD(GetStackAdr(S,_RE),F_DataType);
        FDIV(GetStackAdr(S+1,_RE),F_DataType);
     end
     else
     begin
        FLD(GetStackAdr(S,_RE),F_DataType);
        FDIVR(GetStackAdr(S+1,_RE),F_DataType);
     end;
   end
   else
   if (t1 = T_Real) and (t2 = T_Complex) then
   begin
      if XchArg = False then
      begin
        FLD(GetStackAdr(S+1,_IM),F_DataType);    // (x*y+x*y)/(z1*z2+z1*z2)
        FLD(GetStackAdr(S+1,_RE),F_DataType);
        FLD(GetStackAdr(S,_RE),F_DataType);

        RZDIV;
      end
      else
      begin
        //FLD(GetStackAdr(S+1,_IM),F_DataType);
        //FLD(GetStackAdr(S+1,_RE),F_DataType);

        if F_FAST_DIV = True then
        begin
          FLD(GetStackAdr(S,_RE),F_DataType);
          FDIVR(TAddress(@S_C1),_Double);
          FLD(GetStackAdr(S+1,_RE),F_DataType);
          FMUL01;
          FXCH1;
          FMUL(GetStackAdr(S+1,_IM),F_DataType);
          FXCH1;
        end
        else
        begin
          FLD(GetStackAdr(S+1,_IM),F_DataType);
          FDIV(GetStackAdr(S,_RE),F_DataType);
          FLD(GetStackAdr(S+1,_RE),F_DataType);
          FDIV(GetStackAdr(S,_RE),F_DataType);
        end;
      end;

   end
   else
   if (t1 = T_Complex) and (t2 = T_Real) then    //(z1*z2+z1*z2)/(x*y+x*y)
   begin
    if XchArg = False then
    begin
        if F_FAST_DIV = True then
        begin
          FLD(GetStackAdr(S+1,_RE),F_DataType);
          FDIVR(TAddress(@S_C1),_Double);
          FLD(GetStackAdr(S,_RE),F_DataType);
          FMUL01;
          FXCH1;
          FMUL(GetStackAdr(S,_IM),F_DataType);
          FXCH1;
        end
        else
        begin
          FLD(GetStackAdr(S,_IM),F_DataType);
          FDIV(GetStackAdr(S+1,_RE),F_DataType);     //(z1+z2)/(x+y)     z1/x
          FLD(GetStackAdr(S,_RE),F_DataType);
          FDIV(GetStackAdr(S+1,_RE),F_DataType);
        end;
    end
    else
    begin
           FLD(GetStackAdr(S,_IM),F_DataType);
           FLD(GetStackAdr(S,_RE),F_DataType);
           FLD(GetStackAdr(S+1,_RE),F_DataType);

           RZDIV;
    end;
   end
   else
   if (t1 = T_Complex) and (t2 = T_Complex) then
   begin
     if XchArg = False then
     begin
       FLD(GetStackAdr(S+1,_IM),F_DataType);
       FLD(GetStackAdr(S+1,_RE),F_DataType);
       FLD(GetStackAdr(S,_IM),F_DataType);
       FLD(GetStackAdr(S,_RE),F_DataType);
     end
     else
     begin
       FLD(GetStackAdr(S,_IM),F_DataType);
       FLD(GetStackAdr(S,_RE),F_DataType);
       FLD(GetStackAdr(S+1,_IM),F_DataType);
       FLD(GetStackAdr(S+1,_RE),F_DataType);
     end;

      ZDIV;

   end;
  end;



  procedure DIV_DL;
  begin
     if (t1 = T_Real) and (t2 = T_Real) then
  begin
        if (st1 = _FPU) and (st2 = _FPU) then
        begin
           if XchArg = False then FDIVP else  FDIVRP ;
        end
        else
        if (st1 = _FPU) and (st2 = _MEM) then
        begin
           if XchArg = False then FDIV(GetStackAdr(S+1,_RE),F_DataType)  else FDIVR(GetStackAdr(S+1,_RE),F_DataType)  ;
        end
        else
        if (st1 = _MEM) and (st2 = _FPU) then
        begin
           if XchArg = False then FDIVR(GetStackAdr(S,_RE),F_DataType)  else  FDIV(GetStackAdr(S,_RE),F_DataType) ;
        end
        else
        if (st1 = _MEM) and (st2 = _MEM) then
        begin
           if XchArg = False then
           begin
              FLD(GetStackAdr(S,_RE),F_DataType);
              FDIV(GetStackAdr(S+1,_RE),F_DataType);
           end
           else
           begin
              FLD(GetStackAdr(S,_RE),F_DataType);
              FDIVR(GetStackAdr(S+1,_RE),F_DataType);
           end;
        end;
  end
  else
  if (t1 = T_Real) and (t2 = T_Complex) then
  begin
       if (st1 = _FPU) and (st2 = _FPU) then
       begin
          if XchArg = False then
          begin
             FXCH1;
             FXCH2;

             RZDIV;

          end
          else
          begin
             if F_FAST_DIV = True then
             begin
                FXCH2;
                FDIVR(TAddress(@S_C1),_Double);
                FMUL20;
                FMULP;
                FXCH1;
             end
             else
             begin
                FXCH2;
                FDIV2;
                FDIVP;
                FXCH1;
             end;
          end;

       end
       else
       if (st1 = _FPU) and (st2 = _MEM) then
       begin
         if XchArg = False then
         begin

            if F_FAST_DIV = True then
            begin
              FLD(GetStackAdr(S+1,_RE),F_DataType);     //x,r
              FMUL0;                                    //x^2,r
              FLD(GetStackAdr(S+1,_IM),F_DataType);     //y,x^2,r
              FMUL0;                                    //y^2,x^2,r
              FADDP;
              FLD1;
              FDIVRP;                                   //B,r (B=1/(x^2+y^2))

              FLD(GetStackAdr(S+1,_IM),F_DataType);     //y,B,r
              FMUL02;                                   //y*r,B,r
              FMUL01;                                   //y*B*r,B,r
              FCHS;                                     //IM,B,r
              FXCH2;                                    //r,B,IM
              FMULP;                                    //r*B,IM
              FMUL(GetStackAdr(S+1,_RE),F_DataType);    //RE,IM
            end
            else
            begin
              {.335}
              FLD(GetStackAdr(S+1,_IM),F_DataType);     //y,r
              FXCH1;                                    //r,y
              FLD(GetStackAdr(S+1,_RE),F_DataType);     //x,r,y
              FXCH1;                                    //r,x,y
              //MOVAadr(TAddress(@Z_RZDIV_acc));
              MOVAadr(TAddress(RZDIV_ADDR));     {.345}
              CheckStack(2);
              CheckStack(-3);
              CALLA;

              {
              FLD(GetStackAdr(S+1,_RE),F_DataType);     //x,r
              FMUL0;                                    //x^2,r
              FLD(GetStackAdr(S+1,_IM),F_DataType);     //y,x^2,r
              FMUL0;                                    //y^2,x^2,r
              FADDP;

              FLD(GetStackAdr(S+1,_IM),F_DataType);     //y,B,r
              FMUL02;                                   //y*r,B,r
              FDIV01;                                    //y*r/B,B,r
              FCHS;                                     //IM,B,r
              FXCH2;                                    //r,B,IM
              FDIVRP;                                   //r/B,IM
              FMUL(GetStackAdr(S+1,_RE),F_DataType);    //RE,IM
              }
            end;
         end
         else  //<Test
         begin
              if F_FAST_DIV = True then
              begin
                FDIVR(TAddress(@S_C1),_Double);
                FLD(GetStackAdr(S+1,_IM),F_DataType);
                FXCH1;
                FLD(GetStackAdr(S+1,_RE),F_DataType);
                FXCH1;
                FMUL1;
                FXCH2;
                FMULP20;
              end
              else
              begin
                FLD(GetStackAdr(S+1,_RE),F_DataType);
                FDIV01;
                FLD(GetStackAdr(S+1,_IM),F_DataType);
                FDIVRP2;
              end;
         end;

       end
       else
       if (st1 = _MEM) and (st2 = _FPU) then
       begin
         if XchArg = False then
         begin
            FLD(GetStackAdr(S,_RE),F_DataType);
            RZDIV;
         end
         else
         begin
             if F_FAST_DIV = True then
             begin
                FLD(GetStackAdr(S,_RE),F_DataType);
                FDIVR(TAddress(@S_C1),_Double);
                FMUL1;
                FXCH2;
                FMULP20;
             end
             else
             begin
                FDIV(GetStackAdr(S,_RE),F_DataType);
                FXCH1;
                FDIV(GetStackAdr(S,_RE),F_DataType);
                FXCH1;
             end;
         end;

       end
       else
       if (st1 = _MEM) and (st2 = _MEM) then
       begin

        if XchArg = False then
        begin
            if F_FAST_DIV = True then
            begin

               FLD(GetStackAdr(S+1,_RE),F_DataType);
               FMUL0;
               FLD(GetStackAdr(S+1,_IM),F_DataType);
               FMUL0;
               FADDP;
               FLD1;
               FDIVRP;   //B=1/x^2+y^2

               FLD(GetStackAdr(S+1,_RE),F_DataType);
               FMUL(GetStackAdr(S,_RE),F_DataType);
               FMUL01;   //RE,B

               FLD(GetStackAdr(S+1,_IM),F_DataType);
               FMUL(GetStackAdr(S,_RE),F_DataType);
               FCHS;
               FMULP2;
            end
            else
            begin
               {.335}
               FLD(GetStackAdr(S+1,_IM),F_DataType);
               FLD(GetStackAdr(S+1,_RE),F_DataType);
               FLD(GetStackAdr(S,_RE),F_DataType);

               //MOVAadr(TAddress(@Z_RZDIV_acc));
               MOVAadr(TAddress(RZDIV_ADDR));     {.345}
               CheckStack(2);
               CheckStack(-3);
               CALLA;

               {
               FLD(GetStackAdr(S+1,_RE),F_DataType);
               FMUL0;
               FLD(GetStackAdr(S+1,_IM),F_DataType);
               FMUL0;
               FADDP;

               FLD(GetStackAdr(S+1,_RE),F_DataType);
               FMUL(GetStackAdr(S,_RE),F_DataType);
               FDIV01;

               FLD(GetStackAdr(S+1,_IM),F_DataType);
               FMUL(GetStackAdr(S,_RE),F_DataType);
               FCHS;
               FDIVRP2;
               }
            end;
        end
        else
        begin

            if F_FAST_DIV = True then
            begin
              FLD(GetStackAdr(S,_RE),F_DataType);
              FDIVR(TAddress(@S_C1),_Double);
              FLD0;
              FMUL(GetStackAdr(S+1,_IM),F_DataType);
              FXCH1;
              FMUL(GetStackAdr(S+1,_RE),F_DataType);
           end
           else
           begin
              FLD(GetStackAdr(S+1,_IM),F_DataType);
              FDIV(GetStackAdr(S,_RE),F_DataType);
              FLD(GetStackAdr(S+1,_RE),F_DataType);
              FDIV(GetStackAdr(S,_RE),F_DataType);
           end;

        end;

       end;
  end
  else
  if (t1 = T_Complex) and (t2 = T_Real) then
  begin
       if (st1 = _FPU) and (st2 = _FPU) then    // (z1+z2)/(x+y)
       begin

          if XchArg = False then
          begin
             if F_FAST_DIV = True then
             begin
                FDIVR(TAddress(@S_C1),_Double);
                FMUL20;
                FMULP;
             end
             else
             begin
                FDIV2;
                FDIVP;
             end;
          end
          else
          begin

              RZDIV;
          end;

       end
       else
       if (st1 = _FPU) and (st2 = _MEM) then        //sin(z1*sin(z1)/cos(x)*(sin(z1)/cos(x)))/(sin(z1)/cos(x))
       begin                                        //(z1*(z1)/(x)*((z1)/(x)))/((z1)/(x))
         //FAST DIV!!!                              //(z1)/(x)/(z1)/(x)
                                                   //(z1*z1)/sin(x*y+x*y*(x*y+x))/(z1*z2)/sin(x*y+x*y*(x*y+x))
                                                   //sin(z1)/sin(x)
         if XchArg = False then
         begin
            if F_FAST_DIV = True then
            begin
               FLD(GetStackAdr(S+1,_RE),F_DataType);
               FDIVR(TAddress(@S_C1),_Double);
               FMUL1;
               FXCH2;
               FMULP20;
            end
            else
            begin
               FDIV(GetStackAdr(S+1,_RE),F_DataType);
               FXCH1;
               FDIV(GetStackAdr(S+1,_RE),F_DataType);
               FXCH1;
            end;
         end
         else
         begin
            FLD(GetStackAdr(S+1,_RE),F_DataType);
            RZDIV;
         end;


       end
       else
       if (st1 = _MEM) and (st2 = _FPU) then          //sin(z1)/sin(x)
       begin
         if XchArg = False then
         begin
             if F_FAST_DIV = True then
             begin
                 FDIVR(TAddress(@S_C1),_Double);
                 FLD0;
                 FMUL(GetStackAdr(S,_IM),F_DataType);
                 FXCH1;
                 FMUL(GetStackAdr(S,_RE),F_DataType);
             end
             else
             begin
                 FLD0;
                 FDIVR(GetStackAdr(S,_IM),F_DataType);
                 FXCH1;
                 FDIVR(GetStackAdr(S,_RE),F_DataType);
             end;
         end
         else
         begin
             FLD(GetStackAdr(S,_IM),F_DataType);
             FXCH1;
             FLD(GetStackAdr(S,_RE),F_DataType);
             FXCH1;

             RZDIV;

         end;
       end
       else
       if (st1 = _MEM) and (st2 = _MEM) then         //sin(z1)/cos(x)
       begin

         if XchArg = False then
         begin
            if F_FAST_DIV = True then
            begin
               FLD(GetStackAdr(S+1,_RE),F_DataType);
               FDIVR(TAddress(@S_C1),_Double);
               FLD0;
               FMUL(GetStackAdr(S,_IM),F_DataType);
               FXCH1;
               FMUL(GetStackAdr(S,_RE),F_DataType);
            end
            else
            begin
               FLD(GetStackAdr(S,_IM),F_DataType);
               FDIV(GetStackAdr(S+1,_RE),F_DataType);
               FLD(GetStackAdr(S,_RE),F_DataType);
               FDIV(GetStackAdr(S+1,_RE),F_DataType);
            end;
         end
         else
         begin
             FLD(GetStackAdr(S,_IM),F_DataType);
             FLD(GetStackAdr(S,_RE),F_DataType);
             FLD(GetStackAdr(S+1,_RE),F_DataType);

             RZDIV;
         end;

       end;
  end
  else
  if (t1 = T_Complex) and (t2 = T_Complex) then        //Test
  begin

    if (st1 = _FPU) and (st2 = _FPU) then
    begin

        if XchArg = False then
        begin
              FXCH2;
              FXCH1;
              FXCH3;
              FXCH1;

              ZDIV;
        end
        else
        begin

              ZDIV;
         end;

       end
       else
       if (st1 = _MEM) and (st2 = _MEM) then
       begin

           if XchArg = False then
           begin
             FLD(GetStackAdr(S+1,_IM),F_DataType);
             FLD(GetStackAdr(S+1,_RE),F_DataType);
             FLD(GetStackAdr(S,_IM),F_DataType);
             FLD(GetStackAdr(S,_RE),F_DataType);

             ZDIV;
           end
           else
           begin
              FLD(GetStackAdr(S,_IM),F_DataType);
              FLD(GetStackAdr(S,_RE),F_DataType);
              FLD(GetStackAdr(S+1,_IM),F_DataType);
              FLD(GetStackAdr(S+1,_RE),F_DataType);

              ZDIV;
           end;

       end
       else
       if (st1 = _FPU) and (st2 = _MEM) then
       begin
         if XchArg = False then
         begin
            FLD(GetStackAdr(S+1,_IM),F_DataType);
            FXCH2;
            FLD(GetStackAdr(S+1,_RE),F_DataType);
            FXCH2;

            ZDIV;

         end
         else
         begin
            FLD(GetStackAdr(S+1,_IM),F_DataType);
            FLD(GetStackAdr(S+1,_RE),F_DataType);

            ZDIV;
         end;


       end
       else
       if (st1 = _MEM) and (st2 = _FPU) then
       begin
         if XchArg = False then
         begin
            FLD(GetStackAdr(S,_IM),F_DataType);
            FLD(GetStackAdr(S,_RE),F_DataType);

            ZDIV;
         end
         else
         begin
              FLD(GetStackAdr(S,_IM),F_DataType);
              FXCH2;
              FLD(GetStackAdr(S,_RE),F_DataType);
              FXCH2;

              ZDIV;
         end;
       end;
  end;
  end;





  procedure DIV_VAR;                             // v1/v2
  var
    nv1,nv2,tv1,tv2,tm1,tm2,sh1,sh2: Integer;
    Adr1,Adr2,V1_RE,V1_IM,V2_RE,V2_IM: Cardinal;
  begin
   {nv1:=Interp[NFunc].nv1;
   nv2:=Interp[NFunc].nv2; }
   nv1:=GNode^.NV1;
   nv2:=GNode^.NV2;
   {
   GetVar(nv1,adr1,tv1,tm1);
   GetVar(nv2,adr2,tv2,tm2);
   if (tm1 = _Extended) then sh1:=SH_E else sh1:=SH_D;
   if (tm2 = _Extended) then sh2:=SH_E else sh2:=SH_D;
   V1_RE:=adr1;
   V1_IM:=adr1+sh1;
   V2_RE:=adr2;
   V2_IM:=adr2+sh2;
    }
   GetVar2(nv1,V1_RE,V1_IM,tv1,tm1);             {.343}
   GetVar2(nv2,V2_RE,V2_IM,tv2,tm2);              {.343}
   adr1:=V1_RE;   adr2:=V2_RE;                     {.343}

   if (tv1 = T_Real) and (tv2 = T_Real) then
   begin
     FLD(Adr1,tm1);  //FLDV(nv1);
     FDIV(Adr2,tm2); //FADDV(nv2,tv2);
   end
   else
   if (tv1 = T_Real) and (tv2 = IM_UNIT) then
   begin
     FLD(Adr1,tm1);
     FCHS;
     FLDZ;
   end
   else
   if (tv1 = T_Real) and (tv2 = T_Complex) then
   begin
      if F_FAST_DIV = True then
      begin
         FLDV_RE(nv2);                           //FAST DIV!!!
         FMUL0;
         FLDV_IM(nv2);
         FMUL0;
         FADDP;
         FLD1;
         FDIVRP;   //B=1/x^2+y^2

         FLDV_RE(nv2);
         FMUL(V1_RE,tm1);
         FMUL01;   //RE,B

         FLDV_IM(nv2);
         FMUL(V1_RE,tm1);
         FCHS;
         FMULP2;
      end
      else
      begin
         {.335}
         FLDV_IM(nv2);
         FLDV_RE(nv2);
         FLD(V1_RE,tm1);// FLDV_RE(nv1);
         //MOVAadr(TAddress(@Z_RZDIV_acc));
         MOVAadr(TAddress(RZDIV_ADDR));     {.345}
         CheckStack(2);
         CheckStack(-3);
         CALLA;
         {
         FLDV_RE(nv2);
         FMUL0;
         FLDV_IM(nv2);
         FMUL0;
         FADDP;

         FLDV_RE(nv2);
         FMUL(V1_RE,tm1);
         FDIV01;   //RE,B

         FLDV_IM(nv2);
         FMUL(V1_RE,tm1);
         FCHS;
         FDIVRP2;
         }

      end;

   end
   else
   if (tv1 = IM_UNIT) and (tv2 = T_Real) then
   begin
     FLD(Adr2,tm2);
     FLD1;
     FDIVRP;
     FLDZ;
   end
   else
   if (tv1 = T_Complex) and (tv2 = T_Real) then
   begin
      //FAST DIV!!!
      if F_FAST_DIV = True then
      begin
         FLD(V2_RE,tm2);
         FDIVR(TAddress(@S_C1),_Double);
         FLD0;
         FMUL(V1_IM,tm1);
         FXCH1;
         FMUL(V1_RE,tm1);
       end
       else
       begin
         FLDV_IM(nv1); FDIV(V2_RE,tm2);
         FLDV_RE(nv1); FDIV(V2_RE,tm2);
       end;


   end
   else
   if (tv1 = T_Complex) and (tv2 = T_Complex) then
   begin

         FLDV(nv2);
         FLDV(nv1);

         ZDIV;
   end
   else
   if (tv1 = IM_UNIT) and (tv2 = T_Complex) then    //FAST DIV!!!
   begin
         if F_FAST_DIV = True then
         begin
           FLDV_RE(nv2);
           FMUL0;
           FLDV_IM(nv2);
           FMUL0;
           FADDP;
           FLD1;
           FDIVRP;   //B=1/x^2+y^2

           FLD0;
           FMUL(V2_RE,tm2);
           FXCH1;
           FMUL(V2_IM,tm2);
         end
         else
         begin
           FLDV_RE(nv2);
           FMUL0;
           FLDV_IM(nv2);
           FMUL0;
           FADDP;

           FLD0;
           FDIVR(V2_RE,tm2);
           FXCH1;
           FDIVR(V2_IM,tm2);
         end;

   end
   else
   if (tv1 = T_Complex) and (tv2 = IM_UNIT) then
   begin
     FLDV_RE(nv1);
     FCHS;
     FLDV_IM(nv1);
   end
   else    // del ERROR at CalcConstMulDiv = off  i/i   {.329}
   if (tv1 = IM_UNIT) and (tv2 = IM_UNIT) then
   begin
     FLD1;
   end

  end;

  {.318}

  {
    оптимизация отдельно для каждого случая:
    CF.re=0; CF.im = -1;
    CF.re = 0; CF.im = 1 !!!!!!
    CF.re=+-1; CF.im=0

  }
  procedure DIV_CONST(TypeP,TS,TC: Integer);
  var
   {TS,TC,}nv1,inv: Integer;
    AdrC: Cardinal;
  begin
    //TS:=Alg.ExFunc[N].Func[NF].TV[0];  //stack type
    //TC:=GNode^.TC;   //constant type

    inv:=GNode^.Inv;
    nv1:=GNode^.NV1;

    if TypeP = _Stack then     //  S/c, c/S
    begin

      if F_SaveInFPU = False then FLDS(0,_MEM)  else  FLDS(0,_FPU);

      DIV_SC(TS,TC);

    end

    else

    if TypeP = _Var then       // v/c, c/v
    begin

       DIV_VC(nv1,TC);
    end;



  end;

 /////////////////////////////////MAIN//////////////////////////////////////////
begin


 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 Arg:=GNode^.N;
 inv:=GNode^.Inv;
 t1:=Alg.ExFunc[N].Func[NF].TV[0]; t2:=Alg.ExFunc[N].Func[NF].TV[1];
 st1:=GNode^.RData[0]; st2:=GNode^.RData[1];
 nv1:=GNode^.NV1;
 nv2:=GNode^.NV2;
 TC:=GNode^.TC;
 XchArg:=GNode^.XchArg;

 if (Arg = 1) and (GNode^.TypeA <> 0) then  t1:=GNode^.TypeA;

 if XchArg = True then
 begin
   xchT:=t1;
   t1:=t2;
   t2:=xchT;
 end;

 TS:=t1;

 if F_SaveInFPU = False then
 begin
   if (Arg = 2) and (nv1 = -1) and (nv2 = -1) then         // S1/S2
   begin
    DIV_ST;
   end
   else
   if (Arg = 0) and (nv1 >= 0) and (nv2 >= 0) then         // v1/v2
   begin
    DIV_VAR;
   end
   else
   if (Arg = 1) and  (nv1 >= 0)     then                   // S/v1; v1/S
   begin
    FLDS(0,_MEM);  FDIVV(nv1,t1,inv)
   end
   else
   if (Arg = 1) and  (nv1 = -1) and (nv2 = -1)  then       // S1/c; c/S1
   begin
      DIV_CONST(_Stack,TS,TC);   {.318}
     {
     FLDS(0,_MEM);
     if t1 = T_Real then
     begin
      if inv = 0 then FDIV(WriteData(GNode),F_DataType) else
        if inv = 1 then  FDIVR(WriteData(GNode),F_DataType);
     end
     else
     if t1 = T_Complex then
     begin

      if inv = 0 then               //xxx                 // (z1*z2+z1*(z1+z2))/50.123;   (DL=3)
      begin
         if F_FAST_DIV = True then
         begin
           AdrC:=WriteData(GNode);
           FLD(AdrC,F_DataType);
           FDIVR(TAddress(@S_C1),_Double);
           FMUL1;
           FXCH2;
           FMULP20;
         end
         else
         begin
           AdrC:=WriteData(GNode);
           FDIV(AdrC,F_DataType);
           FXCH1;
           FDIV(AdrC,F_DataType);
           FXCH1;
         end;

      end
      else
      if inv = 1 then
      begin
         FLD(WriteData(GNode),F_DataType);

         if F_FAST_DIV = True then
             MOVAadr(TAddress(@Z_RZDIV_FAST))    //FAST DIV!!!
                               else
             MOVAadr(TAddress(@Z_RZDIV));
         CALLA;
         CheckStack(1);
         CheckStack(-2);
      end;
     end
     }

   end
   else
   if (Arg = 0) and (nv2 = -1)    then                     // v1/c; c/v1
   begin
      DIV_CONST(_VAR,TS,TC);   {.318}
     {
     if inv = 0 then inv:=1 else inv:=0;
     FLD(WriteData(GNode),F_DataType);
     FDIVV(nv1,T_Real,inv);
     }

   end
 end
 else
 if F_SaveInFPU = True then
 begin
   if (Arg = 2) and (nv1 = -1) and (nv2 = -1) then         // S1/S2
   begin
    DIV_DL;
   end
   else
   if (Arg = 0) and (nv1 >= 0) and (nv2 >= 0) then         // v1/v2
   begin
      DIV_VAR;
   end
   else
   if (Arg = 1) and  (nv1 >= 0)     then                   // S/v1;v1/S
   begin
    FLDS(0);  FDIVV(nv1,t1,inv);
   end
   else
   if (Arg = 1) and  (nv1 = -1) and (nv2 = -1)  then       // S1/c; c/S1
   begin
      DIV_CONST(_Stack,TS,TC);   {.318}
     {
     FLDS(0);
     if t1 = T_Real then
     begin
      if inv = 0 then FDIV(WriteData(GNode),F_DataType) else
        if inv = 1 then  FDIVR(WriteData(GNode),F_DataType);
     end
     else
     if t1 = T_Complex then
     begin
      if inv = 0 then
      begin
        if F_FAST_DIV = True then                           // (z1*z2+z1*(z1+z2))/50.123;
         begin
           //FAST DIV!!!
           AdrC:=WriteData(GNode);
           FLD(AdrC,F_DataType);
           FDIVR(TAddress(@S_C1),_Double);
           FMUL1;
           FXCH2;
           FMULP20;
         end
         else
         begin
           AdrC:=WriteData(GNode);
           FDIV(AdrC,F_DataType);
           FXCH1;
           FDIV(AdrC,F_DataType);
           FXCH1;
       end
      end
      else
      if inv = 1 then
      begin
         FLD(WriteData(GNode),F_DataType);
         if F_FAST_DIV = True then
             MOVAadr(TAddress(@Z_RZDIV_FAST))    //FAST DIV!!!
                               else
             MOVAadr(TAddress(@Z_RZDIV));
         CALLA;
         CheckStack(1);
         CheckStack(-2);
      end;
     end
     }

   end
   else
   if (Arg = 0) and (nv2 = -1)    then                     // v1/c; c/v1
   begin
     DIV_CONST(_VAR,TS,TC);    {.318}
     {
     if inv = 0 then inv:=1 else inv:=0;
     FLD(WriteData(GNode),F_DataType);
     FDIVV(nv1,T_Real,inv);
     }
   end;

 end;
end;





procedure TForevalH.FMUL(N: TAddress; VType: Integer);
begin
 if VType = _Extended then
 begin
  FLD(N,_Extended);
  FMULP1;
 end
 else
 if VType = _Double then
 begin
  AddComA($DC,$0D,N);
 end
 else
 if VType = _Single then
 begin
  AddComA($D8,$0D,N);
 end
 else
 if VType = _Integer then
 begin
  AddComA($DA,$0D,N);
 end;
end;



procedure TForevalH.FMUL0;
begin          //fmul st(0),st(0)
 AddWord($D8,$C8);
end;



procedure TForevalH.FMUL1;
begin       //fmul st(1),st(0)
 AddWord($DC,$C9);
end;


procedure TForevalH.FMUL02;
begin      //fmul st(0),st(2)
 AddWord($D8,$CA);
end;

procedure TForevalH.FMUL01;
begin      //fmul st(0),st(1)
 AddWord($D8,$C9);
end;



procedure TForevalH.FMUL03;
begin      //fmul st(0),st(3)
 AddWord($D8,$CB);
end;


procedure TForevalH.FMUL04;
begin      //fmul st(0),st(4)
 AddWord($D8,$CC);
end;

procedure TForevalH.FMUL05;
begin      //fmul st(0),st(5)
 AddWord($D8,$CD);
end;


procedure TForevalH.FMUL10;
begin      //fmul st(1),st(0)
 AddWord($DC,$C9);
end;


procedure TForevalH.FSQRT;
begin
AddWord($D9,$FA);
end;




procedure TForevalH.FDIV(N: TAddress; VType: Integer);
begin
 if VType = _Extended then
 begin
  FLD(N,_Extended);
  FDIVP;
 end
 else
 if VType = _Double  then
 begin
  AddComA($DC,$35,N);
 end
 else
 if VType = _Single then
 begin
   AddComA($D8,$35,N);
 end
 else
 if VType = _Integer then
 begin
   AddComA($DA,$35,N);
 end;
end;


procedure TForevalH.FDIVRC(C: Extended; VType: Integer);
begin
  FDIVR(WriteDataA(C,_Double),_Double);
end;


procedure TForevalH.FDIVR(N: TAddress; VType: Integer);
begin
 if VType = _Extended then
 begin
 FLD(N,_Extended);
 FDIVRP;
 end
 else
 if VType = _Double then
 begin
 AddComA($DC,$3D,N);
 end
 else
 if VType = _Single then
 begin
   AddComA($D8,$3D,N);
 end
 else
 if VType = _Integer then
 begin
   AddComA($DA,$3D,N);
 end;
end;



procedure TForevalH.FDIVP;
begin
 AddWord($DE,$F9);
 CheckStack(-1);
end;



procedure TForevalH.FDIV01;
begin      //fdiv st(0),st(1)
 AddWord($D8,$F1);
end;




procedure TForevalH.FDIV10;
begin      //fdiv st(1),st(0)
 AddWord($DC,$F9);
end;


procedure TForevalH.FDIVP2;
begin     //fdivp st(2),st(0)
 AddWord($DE,$FA);
 CheckStack(-1);
end;


procedure TForevalH.FDIVP3;
begin     //fdivp st(3),st(0)
 AddWord($DE,$FB);
 CheckStack(-1);
end;



procedure TForevalH.FDIVRP2;
begin     //fdivrp st(2),st(0)
 AddWord($DE,$F2);
 CheckStack(-1);
end;




procedure TForevalH.FDIVRP3;
begin     //fdivrp st(3),st(0)
 AddWord($DE,$F3);
 CheckStack(-1);
end;


procedure TForevalH.FDIVR01;
begin      //fdivr st(0),st(1)
 AddWord($D8,$F9);
end;


procedure TForevalH.FDIVR10;
begin      //fdivr st(1),st(0)
 AddWord($DC,$F1);
end;



procedure TForevalH.FDIV02;
begin               //st(0)=st(0)/st(2)
 AddCom($D8,$F2);
end;


procedure TForevalH.FDIVRP;
begin
 AddWord($DE,$F1);
 CheckStack(-1);
end;



procedure TForevalH.FDIVRC1;    //1/st(0)
begin
 AddCom($DC,$3D);
 AddAddress(TAddress(@C1));
end;


procedure TForevalH.FSUB(N: TAddress; VType: Integer);
begin
 if VType = _Extended then
 begin
  FLD(N,_Extended);
  FSUBP;
 end
 else
 if VType = _Double then
 begin
  AddComA($DC,$25,N);
 end
 else
 if VType = _Single then
 begin
   AddComA($D8,$25,N);
 end
 else
 if VType = _Integer then
 begin
   AddComA($DA,$25,N);
 end;
end;


procedure TForevalH.FSUBR(N: TAddress; VType: Integer);
begin
 if VType = _Extended then
 begin
  FLD(N,VType);
  FSUBRP;
 end
 else
 if VType = _Double then
 begin
  AddComA($DC,$2D,N);
 end
 else
 if VType = _Single then
 begin
   AddComA($D8,$2D,N);
 end
 else
 if VType = _Integer then
 begin
   AddComA($DA,$2D,N);
 end;
end;

procedure TForevalH.FSUBP;
begin
 AddWord($DE,$E9);
 CheckStack(-1);
end;

procedure TForevalH.FSUBP1;
begin
 AddWord($DE,$E9);
 CheckStack(-1);
end;





procedure TForevalH.NEG_C;
var
t1,t2,N,NF,S,st1: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;


 //st1:=Interp[NFunc].RData[0];
 st1:=GNode^.RData[0];
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 if F_SaveInFPU = False then
 begin
  if (t1 = T_Real) then
  begin
   FLD(GetStackAdr(S,_RE),F_DataType);
   FCHS;
  end
  else
  if  (t1 = T_Complex) then
  begin
   FLD(GetStackAdr(S,_IM),F_DataType);
   FCHS;
   FLD(GetStackAdr(S,_RE),F_DataType);
   FCHS;
  end
 end
 else
 if F_SaveInFPU = True then
 begin
   if t1 = T_Real then
   begin
     if st1 = _FPU then
     begin
       FCHS;
     end
     else
     if st1 = _MEM then
     begin
      FLD(GetStackAdr(S,_RE),F_DataType);
      FCHS;
     end
   end
   else
   if t1 = T_Complex then
   begin
     if st1 = _FPU then
     begin
       FCHS;
       FXCH1;
       FCHS;
       FXCH1;
     end
     else
     if st1 = _MEM then
     begin
       FLD(GetStackAdr(S,_IM),F_DataType);
       FCHS;
       FLD(GetStackAdr(S,_RE),F_DataType);
       FCHS;
     end
   end;
 end;

end;




procedure TForevalH.RE_C;
var
t1,t2,N,NF,RType,S,st1: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;}
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;

 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 //st1:=Interp[NFunc].RData[0];
  st1:=GNode^.RData[0];

if F_SaveInFPU = False then
 begin
  if (t1 = T_Real) then
  begin
   FLD(GetStackAdr(S,_RE),F_DataType);
  end
  else
  if  (t1 = T_Complex) then
  begin
   FLD(GetStackAdr(S,_RE),F_DataType);
   FLDZ;
   //if NFunc = LFunc-1 then Rtype:=_Extended else RType:=_Double;
   if GNode^.Pr = nil then Rtype:=_Extended else RType:=_Double;
   FSTPM(GetStackAdr(S,_IM),RType);
  end;
 end
 else
if F_SaveInFPU = True then
 begin
   if t1 = T_Real then
   begin
     if st1 = _FPU then
     begin
       //RE
     end
     else
     if st1 = _MEM then
     begin
      FLD(GetStackAdr(S,_RE),F_DataType);
     end
   end
   else
   if t1 = T_Complex then
   begin
     if st1 = _FPU then
     begin
       FXCH1;
       FSTP0;
     end
     else
     if st1 = _MEM then
     begin
       FLD(GetStackAdr(S,_RE),F_DataType);
     end
   end;
 end;

end;




procedure TForevalH.IM_C;
var
t1,t2,N,NF,RType,S,st1: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;

 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 //st1:=Interp[NFunc].RData[0];
 st1:=GNode^.RData[0];

if F_SaveInFPU = False then
 begin
  if (t1 = T_Real) then
  begin
   FLDZ;
  end
  else
  if  (t1 = T_Complex) then
  begin
   FLD(GetStackAdr(S,_IM),F_DataType);
   FLDZ;
   //if NFunc = LFunc-1 then Rtype:=_Extended else RType:=_Double;
   if GNode^.Pr = nil then Rtype:=_Extended else RType:=_Double;
   FSTPM(GetStackAdr(S,_IM),RType);
  end;
 end
 else
if F_SaveInFPU = True then
 begin
   if t1 = T_Real then
   begin
     if st1 = _FPU then
     begin
       FSTP0;
       FLDZ;
     end
     else
     if st1 = _MEM then
     begin
      FLDZ;
     end
   end
   else
   if t1 = T_Complex then
   begin
     if st1 = _FPU then
     begin
       FSTP0;
     end
     else
     if st1 = _MEM then
     begin
       FLD(GetStackAdr(S,_IM),F_DataType);
     end
   end;
 end;

end;




procedure TForevalH.LoadArg1;
var
t1,N,NF,S,st1: Integer;
begin

//if Interp[NFunc].RRF  = rf_NO_REPLACE then
if GNode^.RRF  = rf_NO_REPLACE then
begin

 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;  }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 st1:=GNode^.RData[0];//st1:=Interp[NFunc].RData[0];


if F_SaveInFPU = False then
begin
 if (t1 = T_Real) then
 begin
  FLD(GetStackAdr(S,_RE),F_DataType);
 end
 else
 if  (t1 = T_Complex) then
 begin
  FLD(GetStackAdr(S,_IM),F_DataType);
  FLD(GetStackAdr(S,_RE),F_DataType);
 end;
end
else
if F_SaveInFPU = True then
begin
  if (t1 = T_Real) and (st1 = _MEM) then
 begin
  FLD(GetStackAdr(S,_RE),F_DataType);
 end
 else
 if  (t1 = T_Complex) and (st1 = _MEM) then
 begin
  FLD(GetStackAdr(S,_IM),F_DataType);
  FLD(GetStackAdr(S,_RE),F_DataType);
 end;
end;
end;

end;



procedure TForevalH.LoadArg2Right;
var                                 // load arg1, arg2 for  func(arg1,arg2): Right order : arg1,arg2
t1,t2,N,NF,S,st1,st2: Integer;
begin
if GNode^.RRF  = rf_NO_REPLACE then
begin

  {
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0]; t2:=Alg.ExFunc[N].Func[NF].TV[1];
 st1:=Interp[NFunc].RData[0]; st2:=Interp[NFunc].RData[1];
 }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;

 st1:=GNode^.RData[0]; st2:=GNode^.RData[1];


 t1:=Alg.ExFunc[N].Func[NF].TV[0]; t2:=Alg.ExFunc[N].Func[NF].TV[1];

if F_SaveInFPU = False then
begin
 if (t1 = T_Real) and (t2 = T_Real) then
 begin
  FLD(GetStackAdr(S+1,_RE),F_DataType);
  FLD(GetStackAdr(S,_RE),F_DataType);
 end
 else
 if (t1 = T_Real) and (t2 = T_Complex) then
 begin
  FLD(GetStackAdr(S+1,_IM),F_DataType);
  FLD(GetStackAdr(S+1,_RE),F_DataType);
  FLD(GetStackAdr(S,_RE),F_DataType);
 end
 else
 if (t1 = T_Complex) and (t2 = T_Real) then
 begin
  FLD(GetStackAdr(S+1,_RE),F_DataType);
  FLD(GetStackAdr(S,_IM),F_DataType);
  FLD(GetStackAdr(S,_RE),F_DataType);
 end
 else
 if (t1 = T_Complex) and (t2 = T_Complex) then
 begin
  FLD(GetStackAdr(S+1,_IM),F_DataType);
  FLD(GetStackAdr(S+1,_RE),F_DataType);
  FLD(GetStackAdr(S,_IM),F_DataType);
  FLD(GetStackAdr(S,_RE),F_DataType);
 end;
end
else
if F_SaveInFPU = True then
begin
  if (t1 = T_Real) and (t2 = T_Real) then
 begin
    if (st1 = _FPU) and (st2 = _FPU) then
    begin
     FXCH1;
    end
    else
    if (st1 = _MEM) and (st2 = _MEM) then
    begin
     FLD(GetStackAdr(S+1,_RE),F_DataType);
     FLD(GetStackAdr(S,_RE),F_DataType);
    end
    else
    if (st1 = _FPU) and (st2 = _MEM) then
    begin
     FLD(GetStackAdr(S+1,_RE),F_DataType);
     FXCH1;
    end
    else
    if (st1 = _MEM) and (st2 = _FPU) then
    begin
     FLD(GetStackAdr(S,_RE),F_DataType);
    end
 end
 else
 if (t1 = T_Real) and (t2 = T_Complex) then
 begin

  if (st1 = _FPU) and (st2 = _FPU) then
    begin
     FXCH1;
     FXCH2;
    end
    else
    if (st1 = _MEM) and (st2 = _MEM) then
    begin
     FLD(GetStackAdr(S+1,_IM),F_DataType);
     FLD(GetStackAdr(S+1,_RE),F_DataType);
     FLD(GetStackAdr(S,_RE),F_DataType);
    end
    else
    if (st1 = _FPU) and (st2 = _MEM) then
    begin
     FLD(GetStackAdr(S+1,_IM),F_DataType);
     FXCH1;
     FLD(GetStackAdr(S+1,_RE),F_DataType);
     FXCH1;
    end
    else
    if (st1 = _MEM) and (st2 = _FPU) then
    begin
     FLD(GetStackAdr(S,_RE),F_DataType);
    end
 end
 else
 if (t1 = T_Complex) and (t2 = T_Real) then
 begin
  if (st1 = _FPU) and (st2 = _FPU) then
    begin
     FXCH2;
     FXCH1;
    end
    else
    if (st1 = _MEM) and (st2 = _MEM) then
    begin
     FLD(GetStackAdr(S+1,_RE),F_DataType);
     FLD(GetStackAdr(S,_IM),F_DataType);
     FLD(GetStackAdr(S,_RE),F_DataType);
    end
    else
    if (st1 = _FPU) and (st2 = _MEM) then
    begin
     FXCH1;
     FLD(GetStackAdr(S+1,_RE),F_DataType);
     FXCH2;
    end
    else
    if (st1 = _MEM) and (st2 = _FPU) then
    begin
     FLD(GetStackAdr(S,_IM),F_DataType);
     FLD(GetStackAdr(S,_RE),F_DataType);
    end
 end
 else
 if (t1 = T_Complex) and (t2 = T_Complex) then
 begin
  if (st1 = _FPU) and (st2 = _FPU) then
    begin
     FXCH2;
     FXCH1;
     FXCH3;
     FXCH1;
    end
    else
    if (st1 = _MEM) and (st2 = _MEM) then
    begin
     FLD(GetStackAdr(S+1,_IM),F_DataType);
     FLD(GetStackAdr(S+1,_RE),F_DataType);
     FLD(GetStackAdr(S,_IM),F_DataType);
     FLD(GetStackAdr(S,_RE),F_DataType);
    end
    else
    if (st1 = _FPU) and (st2 = _MEM) then
    begin
     FLD(GetStackAdr(S+1,_IM),F_DataType);
     FXCH2;
     FLD(GetStackAdr(S+1,_RE),F_DataType);
     FXCH2;
    end
    else
    if (st1 = _MEM) and (st2 = _FPU) then
    begin
     FLD(GetStackAdr(S,_IM),F_DataType);
     FLD(GetStackAdr(S,_RE),F_DataType);
    end
 end;
end;
end;
end;



{.305}
procedure TForevalH.LoadArg2Back;
var                                    // load arg1, arg2 for  func(arg1,arg2): Back order : arg2,arg1
t1,t2,N,NF,S,st1,st2: Integer;
begin
if GNode^.RRF  = rf_NO_REPLACE then
begin

  {
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0]; t2:=Alg.ExFunc[N].Func[NF].TV[1];
 st1:=Interp[NFunc].RData[0]; st2:=Interp[NFunc].RData[1];
 }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;

 st1:=GNode^.RData[0]; st2:=GNode^.RData[1];


 t1:=Alg.ExFunc[N].Func[NF].TV[0]; t2:=Alg.ExFunc[N].Func[NF].TV[1];

if F_SaveInFPU = False then
begin
 if (t1 = T_Real) and (t2 = T_Real) then
 begin
  FLD(GetStackAdr(S,_RE),F_DataType);
  FLD(GetStackAdr(S+1,_RE),F_DataType);
  {FLD(GetStackAdr(S+1,_RE),F_DataType);
  FLD(GetStackAdr(S,_RE),F_DataType); }
 end
 else
 if (t1 = T_Real) and (t2 = T_Complex) then
 begin
  FLD(GetStackAdr(S,_RE),F_DataType);
  FLD(GetStackAdr(S+1,_IM),F_DataType);
  FLD(GetStackAdr(S+1,_RE),F_DataType);

  {FLD(GetStackAdr(S+1,_IM),F_DataType);
  FLD(GetStackAdr(S+1,_RE),F_DataType);
  FLD(GetStackAdr(S,_RE),F_DataType);}
 end
 else
 if (t1 = T_Complex) and (t2 = T_Real) then
 begin
  FLD(GetStackAdr(S,_IM),F_DataType);
  FLD(GetStackAdr(S,_RE),F_DataType);
  FLD(GetStackAdr(S+1,_RE),F_DataType);
  {FLD(GetStackAdr(S+1,_RE),F_DataType);
  FLD(GetStackAdr(S,_IM),F_DataType);
  FLD(GetStackAdr(S,_RE),F_DataType); }
 end
 else
 if (t1 = T_Complex) and (t2 = T_Complex) then
 begin
  FLD(GetStackAdr(S,_IM),F_DataType);
  FLD(GetStackAdr(S,_RE),F_DataType);
  FLD(GetStackAdr(S+1,_IM),F_DataType);
  FLD(GetStackAdr(S+1,_RE),F_DataType);
  {FLD(GetStackAdr(S+1,_IM),F_DataType);
  FLD(GetStackAdr(S+1,_RE),F_DataType);
  FLD(GetStackAdr(S,_IM),F_DataType);
  FLD(GetStackAdr(S,_RE),F_DataType); }
 end;
end
else
if F_SaveInFPU = True then
begin
  if (t1 = T_Real) and (t2 = T_Real) then
 begin
    if (st1 = _FPU) and (st2 = _FPU) then
    begin
     //FXCH1;
    end
    else
    if (st1 = _MEM) and (st2 = _MEM) then
    begin
     FLD(GetStackAdr(S,_RE),F_DataType);
     FLD(GetStackAdr(S+1,_RE),F_DataType);
     {FLD(GetStackAdr(S+1,_RE),F_DataType);
     FLD(GetStackAdr(S,_RE),F_DataType);}
    end
    else
    if (st1 = _FPU) and (st2 = _MEM) then
    begin
     FLD(GetStackAdr(S+1,_RE),F_DataType);
     {FLD(GetStackAdr(S+1,_RE),F_DataType);
     FXCH1; }
    end
    else
    if (st1 = _MEM) and (st2 = _FPU) then
    begin
     FLD(GetStackAdr(S,_RE),F_DataType);
     FXCH1;
     //FLD(GetStackAdr(S,_RE),F_DataType);
    end
 end
 else
 if (t1 = T_Real) and (t2 = T_Complex) then
 begin

  if (st1 = _FPU) and (st2 = _FPU) then
    begin
     {FXCH1;
     FXCH2;}
    end
    else
    if (st1 = _MEM) and (st2 = _MEM) then
    begin
     FLD(GetStackAdr(S,_RE),F_DataType);
     FLD(GetStackAdr(S+1,_IM),F_DataType);
     FLD(GetStackAdr(S+1,_RE),F_DataType);

     {FLD(GetStackAdr(S+1,_IM),F_DataType);
     FLD(GetStackAdr(S+1,_RE),F_DataType);
     FLD(GetStackAdr(S,_RE),F_DataType);}
    end
    else
    if (st1 = _FPU) and (st2 = _MEM) then
    begin
     FLD(GetStackAdr(S+1,_IM),F_DataType);
     FLD(GetStackAdr(S+1,_RE),F_DataType);

     {FLD(GetStackAdr(S+1,_IM),F_DataType);
     FXCH1;
     FLD(GetStackAdr(S+1,_RE),F_DataType);
     FXCH1; }
    end
    else
    if (st1 = _MEM) and (st2 = _FPU) then
    begin
     FLD(GetStackAdr(S,_RE),F_DataType);
     FXCH2;
     FXCH1;
     //FLD(GetStackAdr(S,_RE),F_DataType);
    end
 end
 else
 if (t1 = T_Complex) and (t2 = T_Real) then
 begin
  if (st1 = _FPU) and (st2 = _FPU) then
    begin
     {FXCH2;
     FXCH1;}
    end
    else
    if (st1 = _MEM) and (st2 = _MEM) then
    begin
     FLD(GetStackAdr(S,_IM),F_DataType);
     FLD(GetStackAdr(S,_RE),F_DataType);
     FLD(GetStackAdr(S+1,_RE),F_DataType);

     {FLD(GetStackAdr(S+1,_RE),F_DataType);
     FLD(GetStackAdr(S,_IM),F_DataType);
     FLD(GetStackAdr(S,_RE),F_DataType);}
    end
    else
    if (st1 = _FPU) and (st2 = _MEM) then
    begin
     FLD(GetStackAdr(S+1,_RE),F_DataType);
     {FXCH1;
     FLD(GetStackAdr(S+1,_RE),F_DataType);
     FXCH2;}
    end
    else
    if (st1 = _MEM) and (st2 = _FPU) then
    begin
     FLD(GetStackAdr(S,_RE),F_DataType);
     FLD(GetStackAdr(S,_IM),F_DataType);
     FXCH1;
     {FLD(GetStackAdr(S,_IM),F_DataType);
     FLD(GetStackAdr(S,_RE),F_DataType);}
    end
 end
 else
 if (t1 = T_Complex) and (t2 = T_Complex) then
 begin
  if (st1 = _FPU) and (st2 = _FPU) then
    begin
     {FXCH2;
     FXCH1;
     FXCH3;
     FXCH1;}
    end
    else
    if (st1 = _MEM) and (st2 = _MEM) then
    begin
     FLD(GetStackAdr(S,_IM),F_DataType);
     FLD(GetStackAdr(S,_RE),F_DataType);
     FLD(GetStackAdr(S+1,_IM),F_DataType);
     FLD(GetStackAdr(S+1,_RE),F_DataType);
     {FLD(GetStackAdr(S+1,_IM),F_DataType);
     FLD(GetStackAdr(S+1,_RE),F_DataType);
     FLD(GetStackAdr(S,_IM),F_DataType);
     FLD(GetStackAdr(S,_RE),F_DataType);}
    end
    else
    if (st1 = _FPU) and (st2 = _MEM) then
    begin
     FLD(GetStackAdr(S+1,_IM),F_DataType);
     FLD(GetStackAdr(S+1,_RE),F_DataType);

     {FLD(GetStackAdr(S+1,_IM),F_DataType);
     FXCH2;
     FLD(GetStackAdr(S+1,_RE),F_DataType);
     FXCH2;}
    end
    else
    if (st1 = _MEM) and (st2 = _FPU) then
    begin
     FLD(GetStackAdr(S,_IM),F_DataType);
     FXCH2;
     FLD(GetStackAdr(S,_RE),F_DataType);
     FXCH2;
     {FLD(GetStackAdr(S,_IM),F_DataType);
     FLD(GetStackAdr(S,_RE),F_DataType); }
    end
 end;
end;
end;
end;



{.305}
procedure TForevalH.LoadArg2(Place: Integer);
var
t1,t2,N,NF,S,st1,st2: Integer;
begin
if GNode^.RRF  = rf_NO_REPLACE then
begin
 if Place = _Right then LoadArg2Right else
 if Place = _Back then LoadArg2Back;
end;
end;




procedure TForevalH.LoadArg2RL;        //Real,List
var
t1,t2,N,NF,S,st1,st2,st3: Integer;
begin
           //загрузка только действ. арг. без сохранения  порядка аргументов

//if Interp[NFunc].RRF  = rf_NO_REPLACE then
if GNode^.RRF  = rf_NO_REPLACE then
begin

 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;


 //t1:=Alg.ExFunc[N].Func[NF].TV[0]; t2:=Alg.ExFunc[N].Func[NF].TV[1];
 st1:=Interp[NFunc].RData[0]; st2:=Interp[NFunc].RData[1];
  }

 S:=GNode^.S;
 st1:=GNode^.RData[0]; st2:=GNode^.RData[1];  {.366}


 if F_SaveInFPU = False then
 begin
    FLD(GetStackAdr(S+1,_RE),F_DataType);
    FLD(GetStackAdr(S,_RE),F_DataType);
 end
 else

 if F_SaveInFPU = True then
 begin
   if st1 = _MEM then FLD(GetStackAdr(S,_RE),F_DataType);
   if st2 = _MEM then FLD(GetStackAdr(S+1,_RE),F_DataType);
 end;

end;


end;




procedure TForevalH.LoadArg3RL;        //Real,List
var
t1,t2,N,NF,S,st1,st2,st3: Integer;
begin
           //загрузка только действ. арг. без сохранения  порядка аргументов

//if Interp[NFunc].RRF  = rf_NO_REPLACE then
if GNode^.RRF  = rf_NO_REPLACE then
begin
 {
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 //t1:=Alg.ExFunc[N].Func[NF].TV[0]; t2:=Alg.ExFunc[N].Func[NF].TV[1];
 st1:=Interp[NFunc].RData[0]; st2:=Interp[NFunc].RData[1]; st3:=Interp[NFunc].RData[2];
 }
 st1:=GNode^.RData[0]; st2:=GNode^.RData[1]; st3:=GNode^.RData[2];
 S:=GNode^.S;
 if F_SaveInFPU = False then
 begin
    FLD(GetStackAdr(S+2,_RE),F_DataType);
    FLD(GetStackAdr(S+1,_RE),F_DataType);
    FLD(GetStackAdr(S,_RE),F_DataType);
 end
 else

 if F_SaveInFPU = True then
 begin
   if st1 = _MEM then FLD(GetStackAdr(S,_RE),F_DataType);
   if st2 = _MEM then FLD(GetStackAdr(S+1,_RE),F_DataType);
   if st3 = _MEM then FLD(GetStackAdr(S+2,_RE),F_DataType);
 end;

end;


end;





procedure TForevalH.FACT_C;
var
t1,N,NF,S,tv1,tm1: Integer;
adr1: Cardinal;
begin
{
  При изменении функции также соответственно вносить изменения в блоке вычисления констант !!!
}
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;


if GNode^.AI = 0 then
begin
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 LoadArg1;
 if t1 = T_Real then
 begin
  //PUSHCW;    {.227}
  //FLDCW(TAddress(@FCW1));
  MEM:=WriteDataA(0,_Integer);
  FISTP(MEM);
  //POPCW;    {.227} //FLDCW(TAddress(@FCW2));
  MOVMA(MEM);
 end;
end
else
if GNode^.AI = 1 then
begin
  LoadLineFormEAX(_First);

  {
  GetVar(GNode^.NV1,adr1,tv1,tm1);
  MOVMA(adr1);
  }

end;
 //mov   ecx, dword ptr [Factorial]
 MOVMREG(R_ECX,Cardinal(@Factorial));
 //lea   ecx, [ecx+eax*8]
 AddCom($8D,$0C,$C1);
 //lea   eax, [ecx+eax*2]
 AddCom($8D,$04,$41);
 //fld   tbyte ptr [eax]
 AddCom($DB,$28);

 CheckStack(1);
 SetReg(R_EAX);
 SetReg(R_ECX);
 {
 MOVBadr(Cardinal(@R_FACT));
 CALLB;
 CheckStack(1);
 }


end;




procedure TForevalH.FACT2_C;
var
t1,N,NF,S,tv1,tm1: Integer;
adr1: Cardinal;
begin
{
  При изменении функции также соответственно вносить изменения в блоке вычисления констант !!!
}
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;


if {Interp[NFunc]}GNode^.AI = 0 then
begin
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 LoadArg1;
 if t1 = T_Real then
 begin
  //PUSHCW;    {.227}
  //FLDCW(TAddress(@FCW1));
  MEM:=WriteDataA(0,_Integer);
  FISTP(MEM);
  //POPCW;    {.227} //FLDCW(TAddress(@FCW2));
  MOVMA(MEM);
 end;
end
else
if GNode^.AI = 1 then
begin
  LoadLineFormEAX(_First);
{
  GetVar(GNode^.NV1,adr1,tv1,tm1);
  MOVMA(adr1);
  }
end;
  //mov   ecx, dword ptr [Factorial2F]
 MOVMREG(R_ECX,Cardinal(@Factorial2F));
 //lea   ecx, [ecx+eax*8]
 AddCom($8D,$0C,$C1);
 //lea   eax, [ecx+eax*2]
 AddCom($8D,$04,$41);
 //fld   tbyte ptr [eax]
 AddCom($DB,$28);

 CheckStack(1);
 SetReg(R_EAX);
 SetReg(R_ECX);

{
 MOVBadr(Cardinal(@R_FACT2));
 CALLB;
 CheckStack(1);
 }
end;



procedure TForevalH.SQR_C;
var
t1,N,NF,S: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;}
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then FMUL0
 else
 if t1 = T_Complex then
 begin
  {MOVA1(Cardinal(@Z_SQR));
  CALLA;
  CheckStack(1);
  CheckStack(-1);}

  ZSQR;

 end;

end;





procedure TForevalH.SQRT_C;
var
t1,N,NF,S: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then FSQRT
 else
 if t1 = T_Complex then
 begin
  MOVAadr(Cardinal(@Z_SQRT));
  CALLA;
  CheckStack(1);
  CheckStack(-1);
 end;

end;


 (*

fldz                        {.335}
fcomip2
JMPCI(L_RSIN,_JNZ) //jnz @@zsin
FSINCOS   //cos(re), sin(re) ,im(=0)
Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-3]);               //  RE(exp) ->
FSTM(Addr,F_DataType);
Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-1]);               //  RE(exp^-1) ->
FSTM(Addr,F_DataType);
FXCH1; //sin(re), cos(re), 0
Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-2]);               //  IM(exp) ->
FSTM(Addr,F_DataType);
FCHS;
Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS]);                 //  IM(exp^-1) ->
FSTM(Addr,F_DataType);
FCHS;
FXCH1;
FSTP0;  //sin,0
JMP(L_ZSIN)//jmp @@end

@@zsin:
...
@@end:
*)

procedure TForevalH.SIN_C;
var
t1,N,NF,S: Integer;
Addr: TAddress;
L1,L2,L_ZSIN,L_ZSIN_END: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
  if t1 = T_Real then
  begin
    if {Interp[NFunc]}GNode^.WRF_CS = rf_COSSINR_REPLACE    then
    begin
      FSINCOS;
      Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-1]); // -> cos
      FSTPM(Addr,F_DataType);
      Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS]);   // -> sin
      FSTM(Addr,F_DataType);
    end
    else
    FSIN;
  end
  else
  if t1 = T_Complex then
  begin

  if ({Interp[NFunc]}GNode^.RRF = rf_NO_REPLACE) and ({Interp[NFunc]}GNode^.WRF_CS = rf_NO_REPLACE) then
   begin
        MOVAadr(Cardinal(@Z_SIN));
        CALLA;
        CheckStack(2);
        CheckStack(-2);
   end
   else
   begin      //sin(z)=sh(i*z)/i
   if ({Interp[NFunc]}GNode^.RRF = rf_NO_REPLACE) and ({Interp[NFunc]}GNode^.WRF_CS = rf_EXPZ2_REPLACE)    then
   begin                                                                                       //sin(z1)+tan(z1)
      // L1:=Length(ICOMP);
      {.335}

      if F_DataType = _Extended then
        begin
          L_ZSIN:=49;       //size of code
          L_ZSIN_END:=97;   //size of code
        end
        else
         if F_DataType = _Double then
        begin
          L_ZSIN:=41;       //size of code
          L_ZSIN_END:=89;   //size of code
        end;

      //If Z.Im = 0 then: ... else goto @@zsin
      FLDZ;
      FCOMIP2;
      JMPCI(L_ZSIN,_JNZ); //jnz @@zsin
         L1:=Length(IComp);
      //L_ZSIN - size of:
      FSINCOS;   //cos(re), sin(re) ,im(=0)
        Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-3]);               //  RE(exp) ->
      FSTM(Addr,F_DataType);
        Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-1]);               //  RE(exp^-1) ->
      FSTM(Addr,F_DataType);
      FXCH1; //sin(re), cos(re), 0
        Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-2]);               //  IM(exp) ->
      FSTM(Addr,F_DataType);
      FCHS;
        Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS]);                 //  IM(exp^-1) ->
      FSTM(Addr,F_DataType);
      FCHS;
      FXCH1;
      FSTP0;  //sin,0
      JMP(L_ZSIN_END);//jmp @@end
          L2:=Length(IComp);
          L2:=L2-L1;


          L1:=Length(IComp);
        //full complex z
        //L_ZSIN_END - size of:
       { @@zsin: }
       ZMUL_i;
       FEXP;
       FLD0;
       FDIVR_C1;
       FXCH2;
       FSINCOS;
       FLD0;
       FMUL03;   //st(0):RE(exp)
          Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-3]);               //  RE(exp) ->
       FSTM(Addr,F_DataType);
       FXCH1;
       FMUL04;    //st(0):RE(exp^-1)
          Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-1]);               //  RE(exp^-1) ->
       FSTM(Addr,F_DataType);
       FXCH3;
       FMUL02;    //st(0):IM(exp)
          Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-2]);               //  IM(exp) ->
       FSTM(Addr,F_DataType);
       FXCH2;
       FMULP4;       //  RE(exp),IM(exp),RE(exp^-1),IM(exp^-1)
       FSUBRP2;
       FXCH2;       //st(0):IM(exp^-1)
       FCHS;
          Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS]);                 //  IM(exp^-1) ->
       FSTM(Addr,F_DataType);
       FSUBP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;
       ZDIV_i;
      { @@end:  }
          L2:=Length(IComp);
          L2:=L2-L1;


   end
   else
   if (GNode^.RRF = rf_EXPZ2_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE)   then
   begin
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-2]),F_DataType);    // -> IM(exp)
        FSUB(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);      // IM(exp)-IM(exp^-1)
        FMUL_C05; // st(0):IM
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-3]),F_DataType);    // -> RE(exp)
        FSUB(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);      // RE(exp)-RE(exp^-1)
        FMUL_C05; // st(0):RE;  st(1):IM
        ZDIV_i;
   end
   else
   if (GNode^.RRF = rf_EXPZ1_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE)   then        //tan(z1)+sin(z1)
   begin
       FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);   // -> IM(exp)
       FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);     // -> RE(exp)
       ZPUSH;
       ZDIVR_C1;        // ->  RE(exp^-1),IM(exp^-1),RE(exp),IM(exp)
       FSUBP2;
       FXCH2;
       FSUBRP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;
       ZDIV_i;

   end
   else
   if (GNode^.RRF = rf_EXPZ1_REPLACE) and (GNode^.WRF_CS = rf_EXPZ2_REPLACE)    then
   begin                                                                        //tan(z1)+sin(z1)+cos(z1)
      FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);     // -> IM(exp)
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-2]);
         FSTM(Addr,F_DataType);                                          //  IM(exp) ->
      FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);   // -> RE(exp)
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-3]);
         FSTM(Addr,F_DataType);                                          //  RE(exp) ->
      ZPUSH;
      ZDIVR_C1;        // ->  RE(exp^-1),IM(exp^-1),RE(exp),IM(exp)
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-1]);
         FSTM(Addr,F_DataType);                                          //  RE(exp^-1) ->
      FSUBP2;
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);
         FSTM(Addr,F_DataType);                                          //  IM(exp^-1) ->
      FXCH2;
      FSUBRP2;
      FMUL_C05;
      FXCH1;
      FMUL_C05;
      FXCH1;
      ZDIV_i;

   end;


 end;
  end;
end;



procedure TForevalH.COS_C;
var
t1,N,NF,S,L_ZCOS_END,L_ZCOS: Integer;
Addr: TAddress;
L1,L2: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;}
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];


 LoadArg1;
 if t1 = T_Real then
 begin
  if GNode^.WRF_CS = rf_COSSINR_REPLACE    then
    begin
      FSINCOS;
      Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-1]); // -> cos
      FSTM(Addr,F_DataType);
      FXCH1;
      Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);   // -> sin
      FSTPM(Addr,F_DataType);
    end
    else
    FCOS;
 end
 else
 if t1 = T_Complex then
 begin
 if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE) then
   begin
        MOVAadr(Cardinal(@Z_COS));
        CALLA;
        CheckStack(2);
        CheckStack(-2);
   end
   else
   begin           //cos(z)=cosh(i*z)
   if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_EXPZ2_REPLACE)    then
   begin
      {.335}

      if F_DataType = _Extended then
        begin
          L_ZCOS:=47;       //size of code
          L_ZCOS_END:=93;   //size of code
        end
        else
         if F_DataType = _Double then
        begin
          L_ZCOS:=39;       //size of code
          L_ZCOS_END:=85;   //size of code
        end;


      //If Z.Im = 0 then: ... else goto @@zcos
      FLDZ;
      FCOMIP2;
      JMPCI(L_ZCOS,_JNZ); //jnz @@zcos
          L1:=Length(IComp);
      //L_ZCOS - size of:
      FSINCOS;   //cos(re), sin(re) ,im(=0)
        Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-3]);               //  RE(exp) ->
      FSTM(Addr,F_DataType);
        Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-1]);               //  RE(exp^-1) ->
      FSTM(Addr,F_DataType);
      FXCH1; //sin(re), cos(re), 0
        Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-2]);               //  IM(exp) ->
      FSTM(Addr,F_DataType);
      FCHS;
        Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS]);                 //  IM(exp^-1) ->
      FSTM(Addr,F_DataType);
      FCHS;
      //FXCH1;
      FSTP0;  //cos,0
      JMP(L_ZCOS_END);//jmp @@end
           L2:=Length(IComp);
           L2:=L2-L1;

        //full complex z
        //L_ZCOS_END - size of:

       {@@zcos:}
          L1:=Length(IComp);
       ZMUL_i;
       FEXP;
       FLD0;
       FDIVR_C1;
       FXCH2;
       FSINCOS;
       FLD0;
       FMUL03;   //st(0):RE(exp)
          Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-3]);               //  RE(exp) ->
          FSTM(Addr,F_DataType);
       FXCH1;
       FMUL04;    //st(0):RE(exp^-1)
          Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-1]);               //  RE(exp^-1) ->
          FSTM(Addr,F_DataType);
       FXCH3;
       FMUL02;    //st(0):IM(exp)
          Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-2]);               //  IM(exp) ->
          FSTM(Addr,F_DataType);
       FXCH2;
       FMULP4;       //  RE(exp),IM(exp),RE(exp^-1),IM(exp^-1)
       FADDP2;
       FXCH2;       //st(0):IM(exp^-1)
       FCHS;
          Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);                 //  IM(exp^-1) ->
          FSTM(Addr,F_DataType);
       FADDP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;
       {@@end:}
          L2:=Length(IComp);
          L2:=L2-L1;

   end
   else
   if (GNode^.RRF = rf_EXPZ2_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE)   then
   begin
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-2]),F_DataType);    // -> IM(exp)
        FADD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);      // IM(exp)-IM(exp^-1)
        FMUL_C05; // st(0):IM
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-3]),F_DataType);    // -> RE(exp)
        FADD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);      // RE(exp)-RE(exp^-1)
        FMUL_C05; // st(0):RE;  st(1):IM
   end
   else
   if (GNode^.RRF = rf_EXPZ1_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE)   then
   begin
       FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);   // -> IM(exp)
       FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);     // -> RE(exp)
       ZPUSH;
       ZDIVR_C1;        // ->  RE(exp^-1),IM(exp^-1),RE(exp),IM(exp)
       FADDP2;  //FSUBP2;
       FXCH2;
       FADDP2;   //FSUBRP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;
   end
   else
   if (GNode^.RRF = rf_EXPZ1_REPLACE) and (GNode^.WRF_CS = rf_EXPZ2_REPLACE)    then
   begin
      FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);     // -> IM(exp)
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-2]);
         FSTM(Addr,F_DataType);                                          //  IM(exp) ->
      FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);   // -> RE(exp)
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-3]);
         FSTM(Addr,F_DataType);                                          //  RE(exp) ->
      ZPUSH;
      ZDIVR_C1;        // ->  RE(exp^-1),IM(exp^-1),RE(exp),IM(exp)
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-1]);
         FSTM(Addr,F_DataType);                                          //  RE(exp^-1) ->
      FADDP2; //FSUBP2;
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);
         FSTM(Addr,F_DataType);                                          //  IM(exp^-1) ->
      FXCH2;
      FADDP2;  //FSUBRP2;
      FMUL_C05;
      FXCH1;
      FMUL_C05;
      FXCH1;
   end;


 end;
 end;
end;



//   1/cos
procedure TForevalH.SEC_C;
var
t1,N,NF,S,L_ZSEC_END,L_ZSEC: Integer;
Addr: TAddress;
L1,L2: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];


 LoadArg1;
 if t1 = T_Real then
 begin
   if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE) then
   begin
      FCOS;
      FLD1;
      FDIVRP;
   end
   else
   begin

    if (GNode^.RRF = rf_COSR_REPLACE)  then
    begin
      FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);
      FLD1;
      FDIVRP;
    end
    else
    if GNode^.WRF_CS = rf_COSSINR_REPLACE    then
    begin
      FSINCOS;
      Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-1]); // -> cos
      FSTM(Addr,F_DataType);
      FXCH1;
      Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);   // -> sin
      FSTPM(Addr,F_DataType);
      FLD1;
      FDIVRP;
    end


   end;
 end
 else
 if t1 = T_Complex then
 begin
 if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE) then
   begin
        MOVAadr(Cardinal(@Z_SEC));
        CALLA;
        CheckStack(2);
        CheckStack(-2);
   end
   else
   begin           //cos(z)=cosh(i*z)
   if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_EXPZ2_REPLACE)    then
   begin
      {.335}
        if F_DataType = _Extended then
        begin
           L_ZSEC:=51;       //size of code
           L_ZSEC_END:=117;   //size of code
           if F_FAST_DIV = False then  L_ZSEC_END:=102; //Зависит от размера  ZDIVR_C1 !!!
        end
        else
         if F_DataType = _Double then
        begin
           L_ZSEC:=43;       //size of code
           L_ZSEC_END:=109;   //size of code
           if F_FAST_DIV = False then  L_ZSEC_END:=94; //Зависит от размера  ZDIVR_C1 !!!
        end;

      //If Z.Im = 0 then: ... else goto @@zsec
      FLDZ;
      FCOMIP2;
      JMPCI(L_ZSEC,_JNZ); //jnz @@L_ZSEC

      //L_ZSEC - size of:
            L1:=Length(IComp);
      FSINCOS;   //cos(re), sin(re) ,im(=0)
        Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-3]);               //  RE(exp) ->
      FSTM(Addr,F_DataType);
        Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-1]);               //  RE(exp^-1) ->
      FSTM(Addr,F_DataType);
      FXCH1; //sin(re), cos(re), 0
        Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-2]);               //  IM(exp) ->
      FSTM(Addr,F_DataType);
      FCHS;
        Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS]);                 //  IM(exp^-1) ->
      FSTM(Addr,F_DataType);
      FCHS;
      //FXCH1;
      FSTP0;
      FDIVR_C1;  //1/cos,0
      JMP(L_ZSEC_END);//jmp @@L_ZSEC_END
         L2:=Length(IComp);
         L2:=L2-L1;

        {full complex z
         L_ZSEC_END - size of: }

              L1:=Length(IComp);
       {@@L_ZSEC:}
       ZMUL_i;
       FEXP;
       FLD0;
       FDIVR_C1;
       FXCH2;
       FSINCOS;
       FLD0;
       FMUL03;   //st(0):RE(exp)
          Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-3]);               //  RE(exp) ->
       FSTM(Addr,F_DataType);
       FXCH1;
       FMUL04;    //st(0):RE(exp^-1)
          Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-1]);               //  RE(exp^-1) ->
       FSTM(Addr,F_DataType);
       FXCH3;
       FMUL02;    //st(0):IM(exp)
          Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-2]);               //  IM(exp) ->
       FSTM(Addr,F_DataType);
       FXCH2;
       FMULP4;       //  RE(exp),IM(exp),RE(exp^-1),IM(exp^-1)
       FADDP2;
       FXCH2;       //st(0):IM(exp^-1)
       FCHS;
          Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);                 //  IM(exp^-1) ->
       FSTM(Addr,F_DataType);
       FADDP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;
       ZDIVR_C1;
       {@@L_ZSEC_END:}
            L2:=Length(IComp);
            L2:=L2-L1;

   end
   else
   if (GNode^.RRF = rf_EXPZ2_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE)   then
   begin
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-2]),F_DataType);    // -> IM(exp)
        FADD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);      // IM(exp)-IM(exp^-1)
        FMUL_C05; // st(0):IM
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-3]),F_DataType);    // -> RE(exp)
        FADD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);      // RE(exp)-RE(exp^-1)
        FMUL_C05; // st(0):RE;  st(1):IM
        ZDIVR_C1;
   end
   else
   if (GNode^.RRF = rf_EXPZ1_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE)   then
   begin
       FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);   // -> IM(exp)
       FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);     // -> RE(exp)
       ZPUSH;
       ZDIVR_C1;        // ->  RE(exp^-1),IM(exp^-1),RE(exp),IM(exp)
       FADDP2;  //FSUBP2;
       FXCH2;
       FADDP2;   //FSUBRP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;
       ZDIVR_C1;
   end
   else
   if (GNode^.RRF = rf_EXPZ1_REPLACE) and (GNode^.WRF_CS = rf_EXPZ2_REPLACE)    then
   begin
      FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);     // -> IM(exp)
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-2]);
         FSTM(Addr,F_DataType);                                          //  IM(exp) ->
      FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);   // -> RE(exp)
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-3]);
         FSTM(Addr,F_DataType);                                          //  RE(exp) ->
      ZPUSH;
      ZDIVR_C1;        // ->  RE(exp^-1),IM(exp^-1),RE(exp),IM(exp)
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-1]);
         FSTM(Addr,F_DataType);                                          //  RE(exp^-1) ->
      FADDP2; //FSUBP2;
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);
         FSTM(Addr,F_DataType);                                          //  IM(exp^-1) ->
      FXCH2;
      FADDP2;  //FSUBRP2;
      FMUL_C05;
      FXCH1;
      FMUL_C05;
      FXCH1;
      ZDIVR_C1;
   end;


 end;
 end;
end;




//    1/sin
procedure TForevalH.COSEC_C;
var
t1,N,NF,S,L_ZCOSEC_END,L_ZCOSEC: Integer;
Addr: TAddress;
L1,L2: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;  }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;

 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
  if t1 = T_Real then
  begin
  if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE) then
   begin
      FSIN;
      FLD1;
      FDIVRP;
   end
   else
   begin
    if (GNode^.RRF = rf_SINR_REPLACE)  then
    begin
      FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);
      FLD1;
      FDIVRP;
    end
    else
    if GNode^.WRF_CS = rf_COSSINR_REPLACE    then
    begin
      FSINCOS;
      Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-1]); // -> cos
      FSTPM(Addr,F_DataType);
      Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);   // -> sin
      FSTM(Addr,F_DataType);
      FLD1;
      FDIVRP;
    end


   end;
  end
  else
  if t1 = T_Complex then
  begin

  if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE) then
   begin
        MOVAadr(Cardinal(@Z_COSEC));
        CALLA;
        CheckStack(2);
        CheckStack(-2);
   end
   else
   begin      //sin(z)=sh(i*z)/i
   if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_EXPZ2_REPLACE)    then
   begin                                 //cosec(z1)+cos(z1)
        {.335}
      if F_DataType = _Extended then
      begin
          L_ZCOSEC:=53;       //size of code
          L_ZCOSEC_END:=115;   //size of code
          if F_FAST_DIV = False then  L_ZCOSEC_END:=111; //Зависит от размера  ZDIVR_i !!!
      end
      else
      if F_DataType = _Double then
      begin
          L_ZCOSEC:=45;       //size of code
          L_ZCOSEC_END:=107;   //size of code
          if F_FAST_DIV = False then  L_ZCOSEC_END:=103; //Зависит от размера  ZDIVR_i !!!
      end;

      //If Z.Im = 0 then: ... else goto @@zcosec
      FLDZ;
      FCOMIP2;
      JMPCI(L_ZCOSEC,_JNZ); //jnz @@zcosec
      //L_ZCOSEC - size of:
            L1:=Length(IComp);
      FSINCOS;   //cos(re), sin(re) ,im(=0)
        Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-3]);               //  RE(exp) ->
      FSTM(Addr,F_DataType);
        Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-1]);               //  RE(exp^-1) ->
      FSTM(Addr,F_DataType);
      FXCH1; //sin(re), cos(re), 0
        Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-2]);               //  IM(exp) ->
      FSTM(Addr,F_DataType);
      FCHS;
        Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS]);                 //  IM(exp^-1) ->
      FSTM(Addr,F_DataType);
      FCHS;
      FXCH1;
      FSTP0;
      FDIVR_C1;  //1/sin,0
      JMP(L_ZCOSEC_END);//jmp @@end
          L2:=Length(IComp);
          L2:=L2-L1;

        {full complex z
         L_ZCOSEC_END - size of: }

              L1:=Length(IComp);
       {@@zcosec:}
       ZMUL_i;
       FEXP;
       FLD0;
       FDIVR_C1;
       FXCH2;
       FSINCOS;
       FLD0;
       FMUL03;   //st(0):RE(exp)
          Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-3]);               //  RE(exp) ->
       FSTM(Addr,F_DataType);
       FXCH1;
       FMUL04;    //st(0):RE(exp^-1)
          Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-1]);               //  RE(exp^-1) ->
       FSTM(Addr,F_DataType);
       FXCH3;
       FMUL02;    //st(0):IM(exp)
          Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-2]);               //  IM(exp) ->
       FSTM(Addr,F_DataType);
       FXCH2;
       FMULP4;       //  RE(exp),IM(exp),RE(exp^-1),IM(exp^-1)
       FSUBRP2;
       FXCH2;       //st(0):IM(exp^-1)
       FCHS;
          Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);                 //  IM(exp^-1) ->
       FSTM(Addr,F_DataType);
       FSUBP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;
       ZDIVR_i;
       {@@end:}
          L2:=Length(IComp);
          L2:=L2-L1;

   end
   else
   if (GNode^.RRF = rf_EXPZ2_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE)   then
   begin
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-2]),F_DataType);    // -> IM(exp)
        FSUB(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);      // IM(exp)-IM(exp^-1)
        FMUL_C05; // st(0):IM
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-3]),F_DataType);    // -> RE(exp)
        FSUB(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);      // RE(exp)-RE(exp^-1)
        FMUL_C05; // st(0):RE;  st(1):IM
        ZDIVR_i;
   end
   else
   if (GNode^.RRF = rf_EXPZ1_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE)   then
   begin
       FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);   // -> IM(exp)
       FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);     // -> RE(exp)
       ZPUSH;
       ZDIVR_C1;        // ->  RE(exp^-1),IM(exp^-1),RE(exp),IM(exp)
       FSUBP2;
       FXCH2;
       FSUBRP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;
       ZDIVR_i;

   end
   else
   if (GNode^.RRF = rf_EXPZ1_REPLACE) and (GNode^.WRF_CS = rf_EXPZ2_REPLACE)    then
   begin
      FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);     // -> IM(exp)
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-2]);
         FSTM(Addr,F_DataType);                                          //  IM(exp) ->
      FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);   // -> RE(exp)
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-3]);
         FSTM(Addr,F_DataType);                                          //  RE(exp) ->
      ZPUSH;
      ZDIVR_C1;        // ->  RE(exp^-1),IM(exp^-1),RE(exp),IM(exp)
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-1]);
         FSTM(Addr,F_DataType);                                          //  RE(exp^-1) ->
      FSUBP2;
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);
         FSTM(Addr,F_DataType);                                          //  IM(exp^-1) ->
      FXCH2;
      FSUBRP2;
      FMUL_C05;
      FXCH1;
      FMUL_C05;
      FXCH1;
      ZDIVR_i;

   end;


 end;
  end;
end;







procedure TForevalH.TAN_C;
var
t1,N,NF,S,L_ZTAN_END,L_ZTAN: Integer;
Addr: TAddress;
L1,L2: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;  }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
    if GNode^.RRF = rf_INVERSE_REPLACE    then     //tan=1/cotan
    begin
       FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);
       FDIVR(TAddress(@S_C1),_Double);
    end
    else
    begin
       FPTAN; FSTP0;
    end;
 end
 else
 if t1 = T_Complex then
 begin

  if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE) then
   begin
     MOVAadr(Cardinal(@Z_TAN));
     CALLA;
     CheckStack(3);
     CheckStack(-3);
   end
   else
   begin
      if GNode^.RRF = rf_EXPZ1_REPLACE    then
      begin
       FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);       // -> IM(exp)
       FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);     // -> RE(exp)
       ZSQR;
       ZPUSH;
       FLD1;
       FSUBP;
       FXCH2;
       FLD1;
       FADDP;
       FXCH2;

       ZDIV;

       ZDIV_i;
      end
      else
      if GNode^.RRF = rf_INVERSE_REPLACE    then
      begin
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);       // -> IM(exp)
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);     // -> RE(exp)
        ZDIVR_C1;
      end
      else               //tan(z)=th(i*z)/i
      if GNode^.WRF_CS = rf_EXPZ1_REPLACE    then { (GNode^.RRF = rf_NO_REPLACE) }
      begin

         {.335}
         if F_DataType = _Extended then
         begin
            L_ZTAN:=27;       //size of code
            L_ZTAN_END:=82;   //size of code
         end
         else
         if F_DataType = _Double then
         begin
            L_ZTAN:=23;       //size of code
            L_ZTAN_END:=78;   //size of code
         end;

         //If Z.Im = 0 then: ... else goto @@ztan
         FLDZ;
         FCOMIP2;
         JMPCI(L_ZTAN,_JNZ); //jnz @@ztan
         //L_ZTAN - size of:
               L1:=Length(IComp);
         FSINCOS;
           Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-1]);               //  RE(exp) ->
         FSTM(Addr,F_DataType);
         FXCH1;
           Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS]);               //  RE(exp^-1) ->
         FSTM(Addr,F_DataType);
         FDIVRP;
         //tan,0
         JMP(L_ZTAN_END);//jmp @@end
             L2:=Length(IComp);
             L2:=L2-L1;

             L1:=Length(IComp);
           {full complex z
            L_ZTAN_END - size of: }
          {@@ztan:}
          ZMUL_i;
          ZEXP;
             Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-1]);       // -> RE(exp)
          FSTM(Addr,F_DataType);
          FXCH1;
             Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);        // -> IM(exp)
          FSTM(Addr,F_DataType);
          FXCH1;
          ZSQR;
          ZPUSH;
          FLD1;
          FSUBP;
          FXCH2;
          FLD1;
          FADDP;
          FXCH2;
          ZDIV;
          ZDIV_i;

             L2:=Length(IComp);
             L2:=L2-L1;


      end

   end;

 end;

end;




procedure TForevalH.COTAN_C;
var
t1,N,NF,S,L_ZCOTAN_END,L_ZCOTAN: Integer;
Addr: TAddress;
L1,L2: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
    if GNode^.RRF = rf_INVERSE_REPLACE    then     //cotan=1/tan
    begin
       FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);
       //FDIVR(TAddress(@S_C1),_Double);
       FLD1; FDIVRP;
    end
    else
    begin
       FPTAN;
       if GNode^.WRF_CS = rf_INVERSE_REPLACE    then
       begin
         FXCH1;
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);
         FSTM(Addr,F_DataType);
         FXCH1;
       end ;
       FDIVRP;
    end;
 end
 else
 if t1 = T_Complex then
 begin

   if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE) then
   begin
     MOVAadr(Cardinal(@Z_COTAN));
     CALLA;
     CheckStack(3);
     CheckStack(-3);
   end
   else
   begin
      if GNode^.RRF = rf_EXPZ1_REPLACE    then
      begin
       FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);       // -> IM(exp)
       FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);     // -> RE(exp)
       ZSQR;
       ZPUSH;
       FLD1;
       FADDP; //FSUBP;
       FXCH2;
       FLD1;
       FSUBP; //FADDP;
       FXCH2;

       ZDIV;
       ZMUL_i;
      end
      else
      if GNode^.RRF = rf_INVERSE_REPLACE    then
      begin
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);       // -> IM(exp)
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);     // -> RE(exp)
        ZDIVR_C1;
      end
      else                         //ctg(z)=i*cth(i*z)
      if GNode^.WRF_CS = rf_EXPZ1_REPLACE    then     { (GNode^.RRF = rf_NO_REPLACE)}
      begin
         {.335}
         if F_DataType = _Extended then
         begin
            L_ZCOTAN:=27;       //size of code
            L_ZCOTAN_END:=82;   //size of code
         end
         else
         if F_DataType = _Double then
         begin
            L_ZCOTAN:=23;       //size of code
            L_ZCOTAN_END:=78;   //size of code
         end;

         //If Z.Im = 0 then: ... else goto @@zcotan
         FLDZ;
         FCOMIP2;
         JMPCI(L_ZCOTAN,_JNZ); //jnz @@zcotan
         //L_ZCOTAN - size of:
               L1:=Length(IComp);
         FSINCOS;
           Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-1]);               //  RE(exp) ->
         FSTM(Addr,F_DataType);
         FXCH1;
           Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS]);               //  RE(exp^-1) ->
         FSTM(Addr,F_DataType);
         FDIVP;
         //cotan,0
         JMP(L_ZCOTAN_END);//jmp @@end
             L2:=Length(IComp);
             L2:=L2-L1;

           {full complex z
            L_ZCOTAN_END - size of: }

                 L1:=Length(IComp);
          {@@zcotan:}
         ZMUL_i;
         ZEXP;
            Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-1]);       // -> RE(exp)
         FSTM(Addr,F_DataType);
         FXCH1;
            Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);        // -> IM(exp)
         FSTM(Addr,F_DataType);
         FXCH1;
         ZSQR;
         ZPUSH;
         FLD1;
         FADDP;//FSUBP;
         FXCH2;
         FLD1;
         FSUBP;//FADDP;
         FXCH2;
         ZDIV;
         ZMUL_i;
             L2:=Length(IComp);
             L2:=L2-L1;


      end

   end;
 end;

end;






procedure TForevalH.ARCSIN_C;
var
t1,N,NF,S: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE) then
   begin
     MOVAadr(Cardinal(@R_ARCSIN));
     CALLA;
     CheckStack(2);
     CheckStack(-2);
   end
   else
   if (GNode^.RRF = rf_ARCCOSR_REPLACE) then
   begin
     FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);
     FSUBR(TAddress(@PI_2),_Extended);
   end;
 end
 else
 if t1 = T_Complex then
 begin
   if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE) then
   begin
     MOVAadr(Cardinal(@Z_ARCSIN));
     CALLA;
     CheckStack(3);
     CheckStack(-3);
   end
   else
   if (GNode^.RRF = rf_ARCCOSZ_REPLACE) then
   begin
     FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);
     FCHS;
     FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);
     FSUBR(TAddress(@PI_2),_Extended);
   end;

 end;

end;




procedure TForevalH.ARCCOS_C;
var
t1,N,NF,S: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE) then
   begin
     MOVAadr(Cardinal(@R_ARCCOS));
     CALLA;
     CheckStack(2);
     CheckStack(-2);
   end
   else
   if (GNode^.RRF = rf_ARCSINR_REPLACE) then
   begin
     FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);
     FSUBR(TAddress(@PI_2),_Extended);
   end
 end
 else
 if t1 = T_Complex then
 begin
   if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE) then
   begin
     MOVAadr(Cardinal(@Z_ARCCOS));
     CALLA;
     CheckStack(3);
     CheckStack(-3);
   end
   else
   if (GNode^.RRF = rf_ARCSINZ_REPLACE) then
   begin
     FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);
     FCHS;
     FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);
     FSUBR(TAddress(@PI_2),_Extended);
   end;

 end;

end;





procedure TForevalH.ARCCOTAN_C;
var
t1,N,NF,S: Integer;
begin
{ N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE) then
   begin
     MOVAadr(Cardinal(@R_ARCCOTAN));
     CALLA;
     CheckStack(1);
     CheckStack(-1);
   end
   else
   if (GNode^.RRF = rf_ARCTANR_REPLACE) then
   begin
     FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);
     FSUBR(TAddress(@PI_2),_Extended);
   end;
 end
 else
 if t1 = T_Complex then
 begin
  if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE) then
   begin
     MOVAadr(Cardinal(@Z_ARCCOTAN));
     CALLA;
     CheckStack(4);
     CheckStack(-4);
   end
   else
   if (GNode^.RRF = rf_ARCTANZ_REPLACE) then
   begin
     FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);
     FCHS;
     FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);
     FSUBR(TAddress(@PI_2),_Extended);
   end;

 end;

end;




procedure TForevalH.ARCTAN_C;
var
t1,N,NF,S: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;}
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE) then
   begin
     FLD1;
     FPATAN;
   end
   else
   if (GNode^.RRF = rf_ARCCOTANR_REPLACE) then
   begin
     FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);
     FSUBR(TAddress(@PI_2),_Extended);
   end;
 end
 else
 if t1 = T_Complex then
 begin
  if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE) then
   begin
     MOVAadr(Cardinal(@Z_ARCTAN));
     CALLA;
     CheckStack(2);
     CheckStack(-2);
   end
   else
   if (GNode^.RRF = rf_ARCCOTANZ_REPLACE) then
   begin
     FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);
     FCHS;
     FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);
     FSUBR(TAddress(@PI_2),_Extended);
   end;
 end;

end;





//
procedure TForevalH.ARCSEC_C;
var
t1,N,NF,S: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;}
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE) then
   begin
     MOVAadr(Cardinal(@R_ARCSEC));
     CALLA;
     CheckStack(2);
     CheckStack(-2);
   end
   else
   if (GNode^.RRF = rf_ARCCOSECR_REPLACE) then
   begin
     FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);
     FSUBR(TAddress(@PI_2),_Extended);
   end;
 end
 else
 if t1 = T_Complex then
 begin
   if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE) then
   begin
     MOVAadr(Cardinal(@Z_ARCSEC));
     CALLA;
     CheckStack(3);
     CheckStack(-3);
   end
   else
   if (GNode^.RRF = rf_ARCCOSECZ_REPLACE) then
   begin
     FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);
     FCHS;
     FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);
     FSUBR(TAddress(@PI_2),_Extended);
   end;

 end;

end;




//
procedure TForevalH.ARCCOSEC_C;
var
t1,N,NF,S: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;}
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE) then
   begin
     MOVAadr(Cardinal(@R_ARCCOSEC));
     CALLA;
     CheckStack(2);
     CheckStack(-2);
   end
   else
   if (GNode^.RRF = rf_ARCSECR_REPLACE) then
   begin
     FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);
     FSUBR(TAddress(@PI_2),_Extended);
   end;
 end
 else
 if t1 = T_Complex then
 begin
   if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE) then
   begin
     MOVAadr(Cardinal(@Z_ARCCOSEC));
     CALLA;
     CheckStack(3);
     CheckStack(-3);
   end
   else
   if (GNode^.RRF = rf_ARCSECZ_REPLACE) then
   begin
     FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);
     FCHS;
     FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);
     FSUBR(TAddress(@PI_2),_Extended);
   end;

 end;

end;



procedure TForevalH.SINH_C;
var
t1,N,NF,S,L_ZSINH_END,L_ZSINH: Integer;
Addr: TAddress;
L1,L2: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin

   if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE) then
   begin
        MOVAadr(Cardinal(@R_SINH));
        CALLA;
        CheckStack(2);
        CheckStack(-2);
   end

   else

   begin
   if (GNode^.RRF = rf_EXPR2_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE)   then
    begin
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);    // exp   ->
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);      // 1/exp ->
        FSUBP;
        FMUL_C05; {.217} //FMUL(TAddress(@S_C05),_Double);
    end
    else
    if (GNode^.RRF = rf_EXPR1_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE)   then
    begin
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);       //  exp ->
        FLD0;
        FLD1;
        FDIVRP;
        FSUBP;
        FMUL_C05; {.217} // FMUL(TAddress(@S_C05),_Double);
   end
   else
   if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_EXPR2_REPLACE)    then
   begin
        FEXP;
        Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-1]);
        FSTM(Addr,F_DataType);
        FLD0;
        FLD1;
        FDIVRP;
        Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);
        FSTM(Addr,F_DataType);
        FSUBP;
        FMUL_C05; {.217} //FMUL(TAddress(@S_C05),_Double);
   end
   else
    if (GNode^.RRF = rf_EXPR1_REPLACE) and  (GNode^.WRF_CS = rf_EXPR2_REPLACE)  then
    begin
         FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);       //  exp ->
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-1]);
         FSTM(Addr,F_DataType);
         FLD0;
         FLD1;
         FDIVRP;
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);
         FSTM(Addr,F_DataType);
         FSUBP;
         FMUL_C05; {.217} //FMUL(TAddress(@S_C05),_Double);
    end;

   end;
 end
 else
 if t1 = T_Complex then
 begin
   if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE) then
   begin

        MOVAadr(Cardinal(@Z_SINH));
        CALLA;
        CheckStack(2);
        CheckStack(-2);

       {
       FEXP;
       FLD0;
       FDIVR_C1;
       FXCH2;
       FSINCOS;
       FLD0;
       FMUL03;
       FXCH1;
       FMUL04;
       FXCH3;
       FMUL02;
       FXCH2;
       FMULP4;       // -> RE(exp),IM(exp),RE(exp^-1),IM(exp^-1)
       FSUBRP2;
       FXCH2;
       FADDP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;
       }

   end
   else
   begin
   if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_EXPZ2_REPLACE)    then
   begin
                                              //sinh(z1)+cosech(z1)
          {.335}
        if F_DataType = _Extended then
        begin
          L_ZSINH:=62;       //size of code
          L_ZSINH_END:=89;   //size of code
        end
        else
         if F_DataType = _Double then
        begin
          L_ZSINH:=54;       //size of code
          L_ZSINH_END:=81;   //size of code
        end;


        //If Z.Im = 0 then: ... else goto @@zsinh
        FLDZ;
        FCOMIP2;
        JMPCI(L_ZSINH,_JNZ); //jnz @@zsinh
            L1:=Length(IComp);
        //L_ZSINH - size of:
        FEXP;   //exp(re),im(=0)
           Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-3]);               //  RE(exp) ->
        FSTM(Addr,F_DataType);
        FXCH1;
           Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-2]);               //  IM(exp) ->
        FSTM(Addr,F_DataType);
           Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS]);                 //  IM(exp^-1) ->
        FSTM(Addr,F_DataType);
        FXCH1;
        FLD0;
        FDIVR_C1;      //1/e,0,e
           Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-1]);               //  RE(exp^-1) ->
        FSTM(Addr,F_DataType);
        FSUBP;
        FMUL_C05;
        JMP(L_ZSINH_END);//jmp @@end
            L2:=Length(IComp);
            L2:=L2-L1;

        //full complex z
        //L_ZSINH_END - size of:

       {@@zsinh:}
            L1:=Length(IComp);
       FEXP;
       FLD0;
       FDIVR_C1;
       FXCH2;
       FSINCOS;
       FLD0;
       FMUL03;   //st(0):RE(exp)
          Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-3]);               //  RE(exp) ->
          FSTM(Addr,F_DataType);
       FXCH1;
       FMUL04;    //st(0):RE(exp^-1)
          Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-1]);               //  RE(exp^-1) ->
          FSTM(Addr,F_DataType);
       FXCH3;
       FMUL02;    //st(0):IM(exp)
          Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-2]);               //  IM(exp) ->
          FSTM(Addr,F_DataType);
       FXCH2;
       FMULP4;       //  RE(exp),IM(exp),RE(exp^-1),IM(exp^-1)
       FSUBRP2;
       FXCH2;       //st(0):IM(exp^-1)
       FCHS;
          Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);                 //  IM(exp^-1) ->
          FSTM(Addr,F_DataType);
       FSUBP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;
       {@@end:}
            L2:=Length(IComp);
            L2:=L2-L1;

   end
   else
   if (GNode^.RRF = rf_EXPZ2_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE)   then
   begin
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-2]),F_DataType);    // -> IM(exp)
        FSUB(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);      // IM(exp)-IM(exp^-1)
        FMUL_C05; // st(0):IM
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-3]),F_DataType);    // -> RE(exp)
        FSUB(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);      // RE(exp)-RE(exp^-1)
        FMUL_C05; // st(0):RE;  st(1):IM
   end
   else
   if (GNode^.RRF = rf_EXPZ1_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE)   then
   begin
       FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);   // -> IM(exp)
       FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);     // -> RE(exp)
       ZPUSH;
       ZDIVR_C1;        // ->  RE(exp^-1),IM(exp^-1),RE(exp),IM(exp)
       FSUBP2;
       FXCH2;
       FSUBRP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;
   end
   else
   if (GNode^.RRF = rf_EXPZ1_REPLACE) and (GNode^.WRF_CS = rf_EXPZ2_REPLACE)    then
   begin
      FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);     // -> IM(exp)
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-2]);
         FSTM(Addr,F_DataType);                                          //  IM(exp) ->
      FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);   // -> RE(exp)
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-3]);
         FSTM(Addr,F_DataType);                                          //  RE(exp) ->
      ZPUSH;
      ZDIVR_C1;        // ->  RE(exp^-1),IM(exp^-1),RE(exp),IM(exp)
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-1]);
         FSTM(Addr,F_DataType);                                          //  RE(exp^-1) ->
      FSUBP2;
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);
         FSTM(Addr,F_DataType);                                          //  IM(exp^-1) ->
      FXCH2;
      FSUBRP2;
      FMUL_C05;
      FXCH1;
      FMUL_C05;
      FXCH1;
   end;


 end;
 end;

end;




 // 1/sh
procedure TForevalH.COSECH_C;
var
t1,N,NF,S,L_ZCOSECH_END,L_ZCOSECH: Integer;
Addr: TAddress;
L1,L2: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin

   if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE) then
   begin
        MOVAadr(Cardinal(@R_SINH));
        CALLA;
        CheckStack(2);
        CheckStack(-2);
        FLD1;
        FDIVRP;
   end

   else

   begin
   if (GNode^.RRF = rf_EXPR2_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE)   then
    begin
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);    // exp   ->
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);      // 1/exp ->
        FSUBP;
        FMUL_C05;    {.217} //FMUL(TAddress(@S_C05),_Double);
        FLD1;
        FDIVRP;
    end
    else
    if (GNode^.RRF = rf_EXPR1_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE)   then
    begin
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);       //  exp ->
        FLD0;
        FLD1;
        FDIVRP;
        FSUBP;
        FMUL_C05;    {.217} //FMUL(TAddress(@S_C05),_Double);
        FLD1;
        FDIVRP;
   end
   else
   if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_EXPR2_REPLACE)    then
   begin
        FEXP;
        Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-1]);
        FSTM(Addr,F_DataType);
        FLD0;
        FLD1;
        FDIVRP;
        Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);
        FSTM(Addr,F_DataType);
        FSUBP;
        FMUL_C05;    {.217}  //FMUL(TAddress(@S_C05),_Double);
        FLD1;
        FDIVRP;
   end
   else
    if (GNode^.RRF = rf_EXPR1_REPLACE) and  (GNode^.WRF_CS = rf_EXPR2_REPLACE)  then
    begin
         FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);       //  exp ->
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-1]);
         FSTM(Addr,F_DataType);
         FLD0;
         FLD1;
         FDIVRP;
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);
         FSTM(Addr,F_DataType);
         FSUBP;
         FMUL_C05;    {.217};//FMUL(TAddress(@S_C05),_Double);
         FLD1;
         FDIVRP;
    end;

   end;
 end
 else
 if t1 = T_Complex then
 begin
   if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE) then
   begin

        MOVAadr(Cardinal(@Z_COSECH));
        CALLA;
        CheckStack(2);
        CheckStack(-2);

   end
   else
   begin
   if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_EXPZ2_REPLACE)    then
   begin
                                         //cosech(z1)+sinh(z1) cosech(z1)-2/(exp(x)-exp(-x))
        {.335}
        if F_DataType = _Extended then
        begin
          L_ZCOSECH:=62;       //size of code
          L_ZCOSECH_END:=113;   //size of code
          if F_FAST_DIV = False then  L_ZCOSECH_END:=98; //Зависит от размера  ZDIVR_C1 !!!
        end
        else
         if F_DataType = _Double then
        begin
          L_ZCOSECH:=54;       //size of code
          L_ZCOSECH_END:=105;   //size of code
          if F_FAST_DIV = False then  L_ZCOSECH_END:=90; //Зависит от размера  ZDIVR_C1 !!!
        end;

            L1:=Length(IComp);
        //If Z.Im = 0 then: ... else goto @@zcosech
        FLDZ;
        FCOMIP2;
        JMPCI(L_ZCOSECH,_JNZ); //jnz @@zcosech
            L1:=Length(IComp);
        //L_ZCOSECH - size of:
        FEXP;   //exp(re),im(=0)
           Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-3]);               //  RE(exp) ->
        FSTM(Addr,F_DataType);
        FXCH1;
           Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-2]);               //  IM(exp) ->
        FSTM(Addr,F_DataType);
           Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS]);                 //  IM(exp^-1) ->
        FSTM(Addr,F_DataType);
        FXCH1;
        FLD0;
        FDIVR_C1;      //1/e,0,e
           Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-1]);               //  RE(exp^-1) ->
        FSTM(Addr,F_DataType);
        FSUBP;
        FDIVRC(2.0,_Double);
        JMP(L_ZCOSECH_END);//jmp @@end
            L2:=Length(IComp);
            L2:=L2-L1;

        //full complex z
        //L_ZCOSECH_END - size of:

       {@@zcosech:}
            L1:=Length(IComp);

       FEXP;
       FLD0;
       FDIVR_C1;
       FXCH2;
       FSINCOS;
       FLD0;
       FMUL03;   //st(0):RE(exp)
          Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-3]);               //  RE(exp) ->
       FSTM(Addr,F_DataType);
       FXCH1;
       FMUL04;    //st(0):RE(exp^-1)
          Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-1]);               //  RE(exp^-1) ->
       FSTM(Addr,F_DataType);
       FXCH3;
       FMUL02;    //st(0):IM(exp)
          Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-2]);               //  IM(exp) ->
       FSTM(Addr,F_DataType);
       FXCH2;
       FMULP4;       //  RE(exp),IM(exp),RE(exp^-1),IM(exp^-1)
       FSUBRP2;
       FXCH2;       //st(0):IM(exp^-1)
       FCHS;
          Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);                 //  IM(exp^-1) ->
       FSTM(Addr,F_DataType);
       FSUBP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;
       ZDIVR_C1;
       {@@end:}
            L2:=Length(IComp);
            L2:=L2-L1;

   end
   else
   if (GNode^.RRF = rf_EXPZ2_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE)   then
   begin
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-2]),F_DataType);    // -> IM(exp)
        FSUB(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);      // IM(exp)-IM(exp^-1)
        FMUL_C05; // st(0):IM
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-3]),F_DataType);    // -> RE(exp)
        FSUB(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);      // RE(exp)-RE(exp^-1)
        FMUL_C05; // st(0):RE;  st(1):IM
        ZDIVR_C1;
   end
   else
   if (GNode^.RRF = rf_EXPZ1_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE)   then
   begin
       FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);   // -> IM(exp)
       FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);     // -> RE(exp)
       ZPUSH;
       ZDIVR_C1;        // ->  RE(exp^-1),IM(exp^-1),RE(exp),IM(exp)
       FSUBP2;
       FXCH2;
       FSUBRP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;
       ZDIVR_C1;
   end
   else
   if (GNode^.RRF = rf_EXPZ1_REPLACE) and (GNode^.WRF_CS = rf_EXPZ2_REPLACE)    then
   begin
      FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);     // -> IM(exp)
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-2]);
         FSTM(Addr,F_DataType);                                          //  IM(exp) ->
      FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);   // -> RE(exp)
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-3]);
         FSTM(Addr,F_DataType);                                          //  RE(exp) ->
      ZPUSH;
      ZDIVR_C1;        // ->  RE(exp^-1),IM(exp^-1),RE(exp),IM(exp)
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-1]);
         FSTM(Addr,F_DataType);                                          //  RE(exp^-1) ->
      FSUBP2;
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);
         FSTM(Addr,F_DataType);                                          //  IM(exp^-1) ->
      FXCH2;
      FSUBRP2;
      FMUL_C05;
      FXCH1;
      FMUL_C05;
      FXCH1;
      ZDIVR_C1;
   end;


 end;
 end;

end;






procedure TForevalH.COSH_C;
var
t1,N,NF,S,L_ZCOSH_END,L_ZCOSH: Integer;
Addr: TAddress;
L1,L2: integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin

   if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE) then
   begin
        MOVAadr(Cardinal(@R_COSH));
        CALLA;
        CheckStack(2);
        CheckStack(-2);
   end
   else
   if (GNode^.RRF = rf_EXPR2_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE)   then
    begin
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);    // exp   ->
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);      // 1/exp ->
        FADDP;
        FMUL_C05;    {.217}//FMUL(TAddress(@S_C05),_Double);
    end
    else
    if (GNode^.RRF = rf_EXPR1_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE)   then
    begin
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);       //  exp ->
        FLD0;
        FLD1;
        FDIVRP;
        FADDP;
        FMUL_C05;    {.217}//FMUL(TAddress(@S_C05),_Double);
   end
   else
   if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_EXPR2_REPLACE)    then
   begin
        FEXP;
        Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-1]);
        FSTM(Addr,F_DataType);
        FLD0;
        FLD1;
        FDIVRP;
        Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);
        FSTM(Addr,F_DataType);
        FADDP;
        FMUL_C05;    {.217}//FMUL(TAddress(@S_C05),_Double);
   end
   else
    if (GNode^.RRF = rf_EXPR1_REPLACE) and  (GNode^.WRF_CS = rf_EXPR2_REPLACE)  then
    begin
         FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);       //  exp ->
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-1]);
         FSTM(Addr,F_DataType);
         FLD0;
         FLD1;
         FDIVRP;
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);
         FSTM(Addr,F_DataType);
         FADDP;
         FMUL_C05;    {.217}//FMUL(TAddress(@S_C05),_Double);
    end;

 end
 else
 if t1 = T_Complex then
 begin
  if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE) then
   begin
        MOVAadr(Cardinal(@Z_COSH));
        CALLA;
        CheckStack(2);
        CheckStack(-2);
   end
   else
   begin
   if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_EXPZ2_REPLACE)    then
   begin                         //cosh(z1)+sinh(z1)
         {.335}
        if F_DataType = _Extended then
        begin
          L_ZCOSH:=62;       //size of code
          L_ZCOSH_END:=89;   //size of code
        end
        else
         if F_DataType = _Double then
        begin
          L_ZCOSH:=54;       //size of code
          L_ZCOSH_END:=81;   //size of code
        end;


        //If Z.Im = 0 then: ... else goto @@zcosh
        FLDZ;
        FCOMIP2;
        JMPCI(L_ZCOSH,_JNZ); //jnz @@zcosh
            L1:=Length(IComp);
        //L_ZCOSH - size of:
        FEXP;   //exp(re),im(=0)
           Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-3]);               //  RE(exp) ->
        FSTM(Addr,F_DataType);
        FXCH1;
           Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-2]);               //  IM(exp) ->
        FSTM(Addr,F_DataType);
           Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS]);                 //  IM(exp^-1) ->
        FSTM(Addr,F_DataType);
        FXCH1;
        FLD0;
        FDIVR_C1;      //1/e,0,e
           Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-1]);               //  RE(exp^-1) ->
        FSTM(Addr,F_DataType);
        FADDP;
        FMUL_C05;
        JMP(L_ZCOSH_END);//jmp @@end
            L2:=Length(IComp);
            L2:=L2-L1;

        //full complex z
        //L_ZCOSH_END - size of:

       {@@zcosh:}
            L1:=Length(IComp);
       FEXP;
       FLD0;
       FDIVR_C1;
       FXCH2;
       FSINCOS;
       FLD0;
       FMUL03;   //st(0):RE(exp)
          Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-3]);               //  RE(exp) ->
       FSTM(Addr,F_DataType);
       FXCH1;
       FMUL04;    //st(0):RE(exp^-1)
          Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-1]);               //  RE(exp^-1) ->
       FSTM(Addr,F_DataType);
       FXCH3;
       FMUL02;    //st(0):IM(exp)
          Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-2]);               //  IM(exp) ->
       FSTM(Addr,F_DataType);
       FXCH2;
       FMULP4;       //  RE(exp),IM(exp),RE(exp^-1),IM(exp^-1)
       FADDP2;
       FXCH2;       //st(0):IM(exp^-1)
       FCHS;
          Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);                 //  IM(exp^-1) ->
       FSTM(Addr,F_DataType);
       FADDP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;
       {@@end:}
              L2:=Length(IComp);
              L2:=L2-L1;

   end
   else
   if (GNode^.RRF = rf_EXPZ2_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE)   then
   begin
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-2]),F_DataType);    // -> IM(exp)
        FADD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);      // IM(exp)-IM(exp^-1)
        FMUL_C05; // st(0):IM
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-3]),F_DataType);    // -> RE(exp)
        FADD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);      // RE(exp)-RE(exp^-1)
        FMUL_C05; // st(0):RE;  st(1):IM
   end
   else
   if (GNode^.RRF = rf_EXPZ1_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE)   then
   begin
       FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);   // -> IM(exp)
       FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);     // -> RE(exp)
       ZPUSH;
       ZDIVR_C1;        // ->  RE(exp^-1),IM(exp^-1),RE(exp),IM(exp)
       FADDP2;  //FSUBP2;
       FXCH2;
       FADDP2;   //FSUBRP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;
   end
   else
   if (GNode^.RRF = rf_EXPZ1_REPLACE) and (GNode^.WRF_CS = rf_EXPZ2_REPLACE)    then
   begin
      FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);     // -> IM(exp)
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-2]);
         FSTM(Addr,F_DataType);                                          //  IM(exp) ->
      FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);   // -> RE(exp)
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-3]);
         FSTM(Addr,F_DataType);                                          //  RE(exp) ->
      ZPUSH;
      ZDIVR_C1;        // ->  RE(exp^-1),IM(exp^-1),RE(exp),IM(exp)
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-1]);
         FSTM(Addr,F_DataType);                                          //  RE(exp^-1) ->
      FADDP2; //FSUBP2;
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);
         FSTM(Addr,F_DataType);                                          //  IM(exp^-1) ->
      FXCH2;
      FADDP2;  //FSUBRP2;
      FMUL_C05;
      FXCH1;
      FMUL_C05;
      FXCH1;
   end;


 end;
 end;

end;



// 1/ch
procedure TForevalH.SECH_C;
var
t1,N,NF,S,L_ZSECH_END,L_ZSECH: Integer;
Addr: TAddress;
L1,L2: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin

   if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE) then
   begin
        MOVAadr(Cardinal(@R_COSH));
        CALLA;
        CheckStack(2);
        CheckStack(-2);
        FLD1;
        FDIVRP;
   end
   else
   if (GNode^.RRF = rf_EXPR2_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE)   then
    begin
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);    // exp   ->
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);      // 1/exp ->
        FADDP;
        FMUL_C05;    {.217}//FMUL(TAddress(@S_C05),_Double);
        FLD1;
        FDIVRP;
    end
    else
    if (GNode^.RRF = rf_EXPR1_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE)   then
    begin
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);       //  exp ->
        FLD0;
        FLD1;
        FDIVRP;
        FADDP;
        FMUL_C05;    {.217}//FMUL(TAddress(@S_C05),_Double);
        FLD1;
        FDIVRP;
   end
   else
   if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_EXPR2_REPLACE)    then
   begin
        FEXP;
        Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-1]);
        FSTM(Addr,F_DataType);
        FLD0;
        FLD1;
        FDIVRP;
        Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);
        FSTM(Addr,F_DataType);
        FADDP;
        FMUL_C05;    {.217}//FMUL(TAddress(@S_C05),_Double);
        FLD1;
        FDIVRP;
   end
   else
    if (GNode^.RRF = rf_EXPR1_REPLACE) and  (GNode^.WRF_CS = rf_EXPR2_REPLACE)  then
    begin
         FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);       //  exp ->
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-1]);
         FSTM(Addr,F_DataType);
         FLD0;
         FLD1;
         FDIVRP;
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);
         FSTM(Addr,F_DataType);
         FADDP;
         FMUL_C05;    {.217}//FMUL(TAddress(@S_C05),_Double);
         FLD1;
         FDIVRP;
    end;

 end
 else
 if t1 = T_Complex then
 begin
  if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE) then
   begin
        MOVAadr(Cardinal(@Z_SECH));
        CALLA;
        CheckStack(2);
        CheckStack(-2);
   end
   else
   begin
   if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_EXPZ2_REPLACE)    then
   begin                                           // sech(z1)+cosh(z1)
         {.335}                                   //(tanh(sech(z1/z2))/(coth(csch(z2/z1))*tanh(z1)))*sinh(z1/z2)
                                                  // z1.im=0; z2.im=0; FastDiv=False ERROR!!!
        if F_DataType = _Extended then
        begin
          L_ZSECH:=62;       //size of code
          L_ZSECH_END:=113;   //size of code
          if F_FAST_DIV = False then  L_ZSECH_END:=98; //Зависит от размера  ZDIVR_C1 !!!
        end
        else
        if F_DataType = _Double then
        begin
          L_ZSECH:=54;       //size of code
          L_ZSECH_END:=105;   //size of code
          if F_FAST_DIV = False then  L_ZSECH_END:=90; //Зависит от размера  ZDIVR_C1 !!!
        end;

            L1:=Length(IComp);
        //If Z.Im = 0 then: ... else goto @@zsech
        FLDZ;
        FCOMIP2;
        JMPCI(L_ZSECH,_JNZ); //jnz @@zsech
            L1:=Length(IComp);
        //L_ZSECH - size of:
        FEXP;   //exp(re),im(=0)
           Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-3]);               //  RE(exp) ->
        FSTM(Addr,F_DataType);
        FXCH1;
           Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-2]);               //  IM(exp) ->
        FSTM(Addr,F_DataType);
           Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS]);                 //  IM(exp^-1) ->
        FSTM(Addr,F_DataType);
        FXCH1;
        FLD0;
        FDIVR_C1;      //1/e,0,e
           Addr:=TAddress(@Func.RFStack[{Interp[NFunc]}GNode^.MWF_CS-1]);               //  RE(exp^-1) ->
        FSTM(Addr,F_DataType);
        FADDP;
        FDIVRC(2.0,_Double);
        JMP(L_ZSECH_END);//jmp @@end
            L2:=Length(IComp);
            L2:=L2-L1;

        //full complex z
        //L_ZSECH_END - size of:

       {@@zsech:}
            L1:=Length(IComp);
       FEXP;
       FLD0;
       FDIVR_C1;
       FXCH2;
       FSINCOS;
       FLD0;
       FMUL03;   //st(0):RE(exp)
          Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-3]);               //  RE(exp) ->
       FSTM(Addr,F_DataType);
       FXCH1;
       FMUL04;    //st(0):RE(exp^-1)
          Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-1]);               //  RE(exp^-1) ->
       FSTM(Addr,F_DataType);
       FXCH3;
       FMUL02;    //st(0):IM(exp)
          Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-2]);               //  IM(exp) ->
       FSTM(Addr,F_DataType);
       FXCH2;
       FMULP4;       //  RE(exp),IM(exp),RE(exp^-1),IM(exp^-1)
       FADDP2;
       FXCH2;       //st(0):IM(exp^-1)
       FCHS;
          Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);                 //  IM(exp^-1) ->
       FSTM(Addr,F_DataType);
       FADDP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;
       ZDIVR_C1;
       {@@end:}
            L2:=Length(IComp);
            L2:=L2-L1;

   end
   else
   if (GNode^.RRF = rf_EXPZ2_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE)   then
   begin
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-2]),F_DataType);    // -> IM(exp)
        FADD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);      // IM(exp)-IM(exp^-1)
        FMUL_C05; // st(0):IM
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-3]),F_DataType);    // -> RE(exp)
        FADD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);      // RE(exp)-RE(exp^-1)
        FMUL_C05; // st(0):RE;  st(1):IM
        ZDIVR_C1;
   end
   else
   if (GNode^.RRF = rf_EXPZ1_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE)   then
   begin
       FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);   // -> IM(exp)
       FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);     // -> RE(exp)
       ZPUSH;
       ZDIVR_C1;        // ->  RE(exp^-1),IM(exp^-1),RE(exp),IM(exp)
       FADDP2;  //FSUBP2;
       FXCH2;
       FADDP2;   //FSUBRP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;
       ZDIVR_C1;
   end
   else
   if (GNode^.RRF = rf_EXPZ1_REPLACE) and (GNode^.WRF_CS = rf_EXPZ2_REPLACE)    then
   begin
      FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);     // -> IM(exp)
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-2]);
         FSTM(Addr,F_DataType);                                          //  IM(exp) ->
      FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);   // -> RE(exp)
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-3]);
         FSTM(Addr,F_DataType);                                          //  RE(exp) ->
      ZPUSH;
      ZDIVR_C1;        // ->  RE(exp^-1),IM(exp^-1),RE(exp),IM(exp)
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-1]);
         FSTM(Addr,F_DataType);                                          //  RE(exp^-1) ->
      FADDP2; //FSUBP2;
         Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);
         FSTM(Addr,F_DataType);                                          //  IM(exp^-1) ->
      FXCH2;
      FADDP2;  //FSUBRP2;
      FMUL_C05;
      FXCH1;
      FMUL_C05;
      FXCH1;
      ZDIVR_C1;
   end;


 end;
 end;

end;



procedure TForevalH.TANH_C;
var
t1,N,NF,S,L_ZTANH_END,L_ZTANH: Integer;
Addr: TAddress;
L1,L2: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;

 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE) then
   begin
        MOVAadr(Cardinal(@R_TANH));
        CALLA;
        CheckStack(2);
        CheckStack(-2);
   end
   else
   begin

     if GNode^.RRF = rf_EXPR1_REPLACE    then
      begin
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);
        FMUL0;
        FLD0;
        FLD1;
        FSUBP;
        FLD1;
        FADDP20;
        FDIVRP;
      end
      else
      if GNode^.RRF = rf_INVERSE_REPLACE    then
      begin
         FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);
         //FDIVR(TAddress(@S_C1),_Double);
         FLD1; FDIVRP;
      end
      else
      if GNode^.WRF_CS = rf_EXPR1_REPLACE    then
      begin
        FEXP;
        Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);
        FSTM(Addr,F_DataType);
        FMUL0;
        FLD0;
        FLD1;
        FSUBP;
        FLD1;
        FADDP20;
        FDIVRP;
      end


    end

 end
 else
 if t1 = T_Complex then
 begin
   if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE) then
   begin
     MOVAadr(Cardinal(@Z_TANH));
     CALLA;
     CheckStack(3);
     CheckStack(-3);
   end
   else
   begin
      if GNode^.RRF = rf_EXPZ1_REPLACE    then
      begin
       FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);       // -> IM(exp)
       FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);     // -> RE(exp)
       ZSQR;
       ZPUSH;
       FLD1;
       FSUBP;
       FXCH2;
       FLD1;
       FADDP;
       FXCH2;

       ZDIV;
      end
      else
      if GNode^.RRF = rf_INVERSE_REPLACE    then
      begin
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);       // -> IM(exp)
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);     // -> RE(exp)
        ZDIVR_C1;
      end
      else
      if GNode^.WRF_CS = rf_EXPZ1_REPLACE    then      { (GNode^.RRF = rf_NO_REPLACE)}
      begin                       //tanh(z1)+cosh(z1)
           {.335}
        if F_DataType = _Extended then
        begin
          L_ZTANH:=48;       //size of code
          L_ZTANH_END:=74;   //size of code
        end
        else
         if F_DataType = _Double then
        begin
          L_ZTANH:=44;       //size of code
          L_ZTANH_END:=70;   //size of code
        end;

            L1:=Length(IComp);
        //If Z.Im = 0 then: ... else goto @@ztanh
        FLDZ;
        FCOMIP2;
        JMPCI(L_ZTANH,_JNZ); //jnz @@ztanh
            L1:=Length(IComp);
        //L_ZTANH - size of:

        FXCH1;
           Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);        // -> IM(exp)
        FSTM(Addr,F_DataType);
        FXCH1;
        FEXP;   //exp(re),im(=0)
           Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-1]);       // -> RE(exp)
        FSTM(Addr,F_DataType);
        FMUL0;
        FLD0;     //e^2,e^2,im=0
        FLD1;
        FSUBP;
        FXCH1;
        FLD1;
        FADDP;
        FDIVP;
        JMP(L_ZTANH_END);//jmp @@end
            L2:=Length(IComp);
            L2:=L2-L1;

        //full complex z
        //L_ZTANH_END - size of:

       {@@ztanh:}
            L1:=Length(IComp);
        ZEXP;
           Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-1]);       // -> RE(exp)
        FSTM(Addr,F_DataType);
        FXCH1;
           Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);        // -> IM(exp)
        FSTM(Addr,F_DataType);
        FXCH1;
        ZSQR;
        ZPUSH;
        FLD1;
        FSUBP;
        FXCH2;
        FLD1;
        FADDP;
        FXCH2;
        ZDIV;
            {@@end:}
            L2:=Length(IComp);
            L2:=L2-L1;
      end



   end;

 end;

end;







procedure TForevalH.COTANH_C;
var
t1,N,NF,S,L_ZCOTANH_END,L_ZCOTANH: Integer;
Addr: TAddress;
L1,L2: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin

   if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE) then
   begin
        MOVAadr(Cardinal(@R_COTANH));
        CALLA;
        CheckStack(2);
        CheckStack(-2);
   end
   else
   begin

   if GNode^.RRF = rf_EXPR1_REPLACE    then
    begin
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);
        FMUL0;
        FLD0;
        FLD1;
        FSUBP;
        FLD1;
        FADDP20;
        FDIVP;
    end
    else
    if GNode^.RRF = rf_INVERSE_REPLACE    then
    begin
         FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);
         //FDIVR(TAddress(@S_C1),_Double);
         FLD1; FDIVRP;
    end
    else
    if GNode^.WRF_CS = rf_EXPR1_REPLACE    then
      begin
        FEXP;
        Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);
        FSTM(Addr,F_DataType);
        FMUL0;
        FLD0;
        FLD1;
        FSUBP;
        FLD1;
        FADDP20;
        FDIVP;
      end
   end;

 end
 else
 if t1 = T_Complex then
 begin
  if (GNode^.RRF = rf_NO_REPLACE) and (GNode^.WRF_CS = rf_NO_REPLACE) then
   begin
     MOVAadr(Cardinal(@Z_COTANH));
     CALLA;
     CheckStack(3);
     CheckStack(-3);
   end
   else
   begin
      if GNode^.RRF = rf_EXPZ1_REPLACE    then
      begin
       FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);       // -> IM(exp)
       FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);     // -> RE(exp)
       ZSQR;
       ZPUSH;
       FLD1;
       FADDP; //FSUBP;
       FXCH2;
       FLD1;
       FSUBP; //FADDP;
       FXCH2;

       ZDIV;
      end
      else
      if GNode^.RRF = rf_INVERSE_REPLACE    then
      begin
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);       // -> IM(exp)
        FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);     // -> RE(exp)
        ZDIVR_C1;
      end
      else
      if GNode^.WRF_CS = rf_EXPZ1_REPLACE    then     {GNode^.RRF = rf_NO_REPLACE }
      begin                                        //cotanh(z1)+cosh(z1)
        {.335}
        if F_DataType = _Extended then
        begin
          L_ZCOTANH:=48;       //size of code
          L_ZCOTANH_END:=74;   //size of code
        end
        else
        if F_DataType = _Double then
        begin
          L_ZCOTANH:=44;       //size of code
          L_ZCOTANH_END:=70;   //size of code
        end;


            L1:=Length(IComp);
        //If Z.Im = 0 then: ... else goto @@zcotanh
        FLDZ;
        FCOMIP2;
        JMPCI(L_ZCOTANH,_JNZ); //jnz @@zcotanh
            L1:=Length(IComp);
        //L_ZCOTANH - size of:

        FXCH1;
           Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);        // -> IM(exp)
        FSTM(Addr,F_DataType);
        FXCH1;
        FEXP;   //exp(re),im(=0)
           Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-1]);       // -> RE(exp)
        FSTM(Addr,F_DataType);
        FMUL0;
        FLD0;     //e^2,e^2,im=0
        FLD1;
        FSUBP;
        FXCH1;
        FLD1;
        FADDP;
        FDIVRP;
        JMP(L_ZCOTANH_END);//jmp @@end
            L2:=Length(IComp);
            L2:=L2-L1;

        //full complex z
        //L_ZCOTANH_END - size of:

       {@@zcotanh:}
            L1:=Length(IComp);
        ZEXP;
        Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS-1]);       // -> RE(exp)
        FSTM(Addr,F_DataType);
        FXCH1;
        Addr:=TAddress(@Func.RFStack[GNode^.MWF_CS]);        // -> IM(exp)
        FSTM(Addr,F_DataType);
        FXCH1;
        ZSQR;
        ZPUSH;
        FLD1;
        FADDP;//FSUBP;
        FXCH2;
        FLD1;
        FSUBP;//FADDP;
        FXCH2;

        ZDIV;

            L2:=Length(IComp);
            L2:=L2-L1;
      end

   end;

 end;

end;





procedure TForevalH.ARCSINH_C;
var
t1,N,NF,S: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   MOVAadr(Cardinal(@R_ARCSINH));
   CALLA;
   CheckStack(2);
   CheckStack(-2);
 end
 else
 if t1 = T_Complex then
 begin
  MOVAadr(Cardinal(@Z_ARCSINH));
  CALLA;
  CheckStack(3);
  CheckStack(-3);
 end;

end;






procedure TForevalH.ARCCOSH_C;
var
t1,N,NF,S: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   MOVAadr(Cardinal(@R_ARCCOSH));
   CALLA;
   CheckStack(2);
   CheckStack(-2);
 end
 else
 if t1 = T_Complex then
 begin
  MOVAadr(Cardinal(@Z_ARCCOSH));
  CALLA;
  CheckStack(3);
  CheckStack(-3);
 end;

end;







procedure TForevalH.ARCTANH_C;
var
t1,N,NF,S: Integer;
begin
{ N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;}
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   MOVAadr(Cardinal(@R_ARCTANH));
   CALLA;
   CheckStack(2);
   CheckStack(-2);
 end
 else
 if t1 = T_Complex then
 begin
  MOVAadr(Cardinal(@Z_ARCTANH));
  CALLA;
  CheckStack(2);
  CheckStack(-2);
 end;

end;







procedure TForevalH.ARCCOTANH_C;
var
t1,N,NF,S: Integer;
begin
{ N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;  }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   MOVAadr(Cardinal(@R_ARCCOTANH));
   CALLA;
   CheckStack(1);
   CheckStack(-1);
 end
 else
 if t1 = T_Complex then
 begin
  MOVAadr(Cardinal(@Z_ARCCOTANH));
  CALLA;
  CheckStack(2);
  CheckStack(-2);
 end;

end;






procedure TForevalH.ARCSECH_C;
var
t1,N,NF,S: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;   }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   MOVAadr(Cardinal(@R_ARCSECH));
   CALLA;
   CheckStack(2);
   CheckStack(-2);
 end
 else
 if t1 = T_Complex then
 begin
  MOVAadr(Cardinal(@Z_ARCSECH));
  CALLA;
  CheckStack(5);
  CheckStack(-5);
 end;

end;







procedure TForevalH.ARCCOSECH_C;
var
t1,N,NF,S: Integer;
begin
{ N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   MOVAadr(Cardinal(@R_ARCCOSECH));
   CALLA;
   CheckStack(2);
   CheckStack(-2);
 end
 else
 if t1 = T_Complex then
 begin
  MOVAadr(Cardinal(@Z_ARCCOSECH));
  CALLA;
  CheckStack(3);
  CheckStack(-3);
 end;

end;





procedure TForevalH.LN_C;
var
t1,N,NF,S: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;}
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   FLDLN2;
   FXCH1;
   FYL2X;
 end
 else
 if t1 = T_Complex then
 begin
  MOVAadr(Cardinal(@Z_LN));
  CALLA;
  CheckStack(2);
  CheckStack(-2);
 end;

end;






procedure TForevalH.EXP_C;
var
t1,N,NF,S: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   MOVAadr(Cardinal(@R_EXP));
   CALLA;
   CheckStack(2);
   CheckStack(-2);
 end
 else
 if t1 = T_Complex then
 begin
  MOVAadr(Cardinal(@Z_EXP));
  CALLA;
  CheckStack(2);
  CheckStack(-2);
 end;

end;





procedure TForevalH.LOG10_C;
var
t1,N,NF,S: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;  }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   FLDLG2;
   FXCH1;
   FYL2X;
 end
 else
 if t1 = T_Complex then
 begin
  //FLD(Cardinal(@S_10),_Extended);
  FLD(WriteDataA(10,_Double),_Double); //{.217}
  MOVAadr(Cardinal(@Z_ReCxLog));
  CALLA;
  CheckStack(3);
  CheckStack(-4);
 end;

end;





procedure TForevalH.LOG2_C;
var
t1,N,NF,S: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;}
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   FLD1;
   FXCH1;
   FYL2X;
 end
 else
 if t1 = T_Complex then
 begin
  FLD(Cardinal(@S_2),_Extended);
  MOVAadr(Cardinal(@Z_ReCxLog));
  CALLA;
  CheckStack(3);
  CheckStack(-4);
 end;

end;





procedure TForevalH.SINCOS_C;
var
t1,N,NF,S: Integer;
begin            //st(0) sin; st(1) cos;
LoadArg1;
 if GNode^.RRF  = rf_FULL_REPLACE_XCH then
 begin
    FLD(TAddress(@Func.RFStack[GNode^.MRF_CS-1]),F_DataType);
    FLD(TAddress(@Func.RFStack[GNode^.MRF_CS]),F_DataType);
 end
 else
 begin
   FSINCOS;
   FXCH1;
 end;
 //CheckStack(1);
end;



procedure TForevalH.COSSIN_C;
var
t1,N,NF,S: Integer;
begin              //st(0) cos; st(1) sin;
 LoadArg1;
 FSINCOS;
 //CheckStack(1);
end;



procedure TForevalH.POWER_C;
var
t1,t2,N,NF,S,tva,tma: Integer;
AdrA: Cardinal;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
  }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;

 LoadArg2Right;
 t1:=Alg.ExFunc[N].Func[NF].TV[0]; t2:=Alg.ExFunc[N].Func[NF].TV[1];
 if (t1 = T_Real) and (t2 = T_Real) then
 begin
  MOVAadr(Cardinal(@FPWR));
  CALLA;
  CheckStack(2);
  CheckStack(-3);
  //SetReg(3); SetReg(4);
 end
 else
 if (t1 = T_Real) and (t2 = T_Complex) then
 begin
  MOVAadr(Cardinal(@Z_ReCxFPWR));
  CALLA;
  CheckStack(2);     {.195}
  CheckStack(-3);
 end
 else
 if (t1 = T_Complex) and (t2 = T_Real) then
 begin
  MOVAadr(Cardinal(@Z_CxReFPWR));
  CALLA;
  CheckStack(3);
  CheckStack(-4);
 end
 else
 if (t1 = T_Complex) and (t2 = T_Complex) then
 begin
  MOVAadr(Cardinal(@ZPWR));
  CALLA;
  CheckStack(2);
  CheckStack(-4);
 end;

SetReg(1); SetReg(2); SetReg(3); SetReg(4);
end;





procedure TForevalH.IMUIPWR_C;
var
t1,N,NF,S,tma,tva: Integer;
AdrA: Cardinal;
begin
{
  При изменении функции также соответственно вносить изменения в блоке вычисления констант !!!
}
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;}

LoadLineFormEAX(_Second);
if GNode^.BI = _NEGATIVE then
 MOVBnum(1) else  MOVBnum(0);
MOVCadr(Cardinal(@Z_ImU_IPWR));
CALLC;
CheckStack(2);
SetReg(1);  SetReg(2);  SetReg(3);


end;



procedure TForevalH.IPWR_C;
var                              //s1^IntForm
t1,t2,N,NF,S,tv,tm,Num: Integer;
Adr1: TAddress;
begin
{
  При изменении функции также соответственно вносить изменения в блоке вычисления констант !!!
}
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;


  //t2:=Alg.ExFunc[N].Func[NF].TV[1];

if GNode^.AI = 2 then    //s1^IntForm
begin
 LoadArg1;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadLineFormEAX(_Second);

  if t1 = T_Real  then
   begin
     MOVCadr(Cardinal(@R_IPWR));
     CALLC;
     CheckStack(1);
     CheckStack(-1);
     SetReg(1);  SetReg(3);  SetReg(4);
   end
   else
   if t1 = T_Complex  then
   begin
     MOVBadr(Cardinal(@Z_IPWR));
     CALLB;
     CheckStack(4);
     CheckStack(-4);
     SetReg(1); SetReg(3); SetReg(4);
   end;
end
else
if GNode^.AI = 1 then    //RealNum^IntForm
begin
    LoadLineFormEAX(_Second);
    FLD(WriteData(GNode),F_DataType);
    MOVCadr(Cardinal(@R_IPWR));
    CALLC;
    CheckStack(1);
    CheckStack(-1);
    SetReg(1);  SetReg(3);  SetReg(4);
end;


   (*
if {Interp[NFunc]}GNode^.AI = 1 then    //s1^intconst
begin
   if t1 = T_Real  then
   begin
     Num:=Trunc({Interp[NFunc]}GNode^.FD);
     MOVAnum(NUM);
     MOVCadr(Cardinal(@R_IPWR));
     CALLC;
     CheckStack(1);
     CheckStack(-1);
     SetReg(1);  SetReg(3);  SetReg(4);
   end
   else
   if t1 = T_Complex  then
   begin
     Num:=Trunc({Interp[NFunc]}GNode^.FD);
     MOVAnum(NUM);
     MOVBadr(Cardinal(@Z_IPWR));
     CALLB;
     CheckStack(4);
     CheckStack(-4);
     SetReg(1); SetReg(3); SetReg(4);
   end;
end
else
if {Interp[NFunc]}GNode^.AI = 2 then    //s1^intvar
begin
   if t1 = T_Real  then
   begin
     GetVar({Interp[NFunc]}GNode^.NV1,adr1,tv,tm);
     MOVMA(adr1);
     MOVCadr(Cardinal(@R_IPWR));
     CALLC;
     CheckStack(1);
     CheckStack(-1);
     SetReg(1); SetReg(3); SetReg(4);
   end
   else
   if t1 = T_Complex  then
   begin
     GetVar({Interp[NFunc]}GNode^.NV1,adr1,tv,tm);
     MOVMA(adr1);
     MOVBadr(Cardinal(@Z_IPWR));
     CALLB;
     CheckStack(4);
     CheckStack(-4);
     SetReg(1); SetReg(2); SetReg(3);
   end;
end;
*)

end;






procedure TForevalH.IROOT_C;
var
t1,t2,N,NF,S,tv,tm,Num: Integer;
Adr1: TAddress;
begin
{
  При изменении функции также соответственно вносить изменения в блоке вычисления констант !!!
}

 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;


  //t2:=Alg.ExFunc[N].Func[NF].TV[1];

if GNode^.AI = 2 then    //Root(Expr,IntForm)
begin
 LoadArg1;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadLineFormEAX(_Second);

  if t1 = T_Real  then
   begin
     MOVCadr(Cardinal(@R_IROOT));
     CALLC;
     CheckStack(2);
     CheckStack(-2);
   end
   else
   if t1 = T_Complex  then
   begin
     MOVBadr(Cardinal(@Z_CxIROOT));
     CALLB;
     CheckStack(2);
     CheckStack(-2);
   end;
end
else
if GNode^.AI = 1 then    //Root(RealNum,IntForm)
begin
    LoadLineFormEAX(_Second);
    FLD(WriteData(GNode),F_DataType);
    MOVCadr(Cardinal(@R_IROOT));
    CALLC;
    CheckStack(1);
    CheckStack(-1);
end
else
if GNode^.AI = 3 then    //Root(Expr,IntForm1,IntForm2)
begin

    LoadLineFormEAX(_Second);  //IntForm2
    PUSHR(R_EAX);
    LoadLineFormEAX(_First);  //IntForm1
    POPR(R_EBX);


    LoadArg1;
    MOVCadr(Cardinal(@Z_CxIROOT3Int));
    CALLC;
    CheckStack(3);
    CheckStack(-3);
end;

  SetReg(1);  SetReg(2); SetReg(3);  SetReg(4);
end;




procedure TForevalH.LOGN_C;
var
t1,t2,N,NF,S: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;

 t1:=Alg.ExFunc[N].Func[NF].TV[0]; t2:=Alg.ExFunc[N].Func[NF].TV[1];

 LoadArg2Right;

 if (t1 = T_Real) and (t2 = T_Real) then
 begin
  MOVAadr(Cardinal(@R_LOGN));
  CALLA;
  CheckStack(1);
  CheckStack(-2);
 end
 else
 if (t1 = T_Real) and (t2 = T_Complex) then
 begin
  MOVAadr(Cardinal(@Z_ReCxLog));
  CALLA;
  CheckStack(3);
  CheckStack(-4);
 end
 else
 if (t1 = T_Complex) and (t2 = T_Real) then
 begin
  MOVAadr(Cardinal(@Z_CxReLog));
  CALLA;
  CheckStack(3);
  CheckStack(-4);
 end
 else
 if (t1 = T_Complex) and (t2 = T_Complex) then
 begin
  MOVAadr(Cardinal(@Z_CxCxLog));
  CALLA;
  CheckStack(2);
  CheckStack(-4);
 end;
end;





procedure TForevalH.ARCTAN2_C;
var
t1,t2,N,NF,S: Integer;
begin

 LoadArg2Right;
 FXCH1;
 FPATAN;

 CheckStack(0);     {.365B}

end;



procedure TForevalH.COMPLEX_C;
begin
 LoadArg2Right;
end;


procedure TForevalH.ROOT_C;
var
t1,t2,N,NF,S,st1,st2: Integer;

begin
{ N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;  }

 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;

 t1:=Alg.ExFunc[N].Func[NF].TV[0]; t2:=Alg.ExFunc[N].Func[NF].TV[1];
 //st1:=Interp[NFunc].RData[0]; st2:=Interp[NFunc].RData[1];
 st1:=GNode^.RData[0]; st2:=GNode^.RData[1];

 {.305}
 LoadArg2Back;
 if (t1 = T_Real) and (t2 = T_Real) then
 begin
     MEM:=WriteDataA(0,_Integer);
     FISTP(MEM);
     MOVMA(MEM);
     MOVBadr(Cardinal(@R_IROOT));
     CALLB;
     CheckStack(2);
     CheckStack(-2);
 end
 else
 if (t1 = T_Complex) and (t2 = T_Real) then
 begin
     MEM:=WriteDataA(0,_Integer);
     FISTP(MEM);
     MOVMA(MEM);
     MOVBadr(Cardinal(@Z_CxIROOT));  //!!!портит ecx
     CALLB;
     CheckStack(2);
     CheckStack(-2);
 end;



SetReg(1); SetReg(2); SetReg(3); SetReg(4);
end;





procedure TForevalH.DECART_C;
var
t1,t2,N,NF,S,tva,tma: Integer;
AdrA: Cardinal;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;


 LoadArg2Right;
 t1:=Alg.ExFunc[N].Func[NF].TV[0]; t2:=Alg.ExFunc[N].Func[NF].TV[1];
 if (t1 = T_Real) and (t2 = T_Real) then
 begin
  MOVAadr(Cardinal(@R_DECART));
  CALLA;
  CheckStack(1);
  CheckStack(-1);
 end

end;





procedure TForevalH.ABS_C;
var
t1,N,NF,S: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   FABS;
 end
 else
 if t1 = T_Complex then
 begin
  FMUL0;
  FXCH1;
  FMUL0;
  FADDP;
  FSQRT;
 end;

end;






procedure TForevalH.ARG_C;
var
t1,N,NF,S: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   FSTP0;
   FLDZ;
 end
 else
 if t1 = T_Complex then
 begin
  FPATAN;
 end;

end;





procedure TForevalH.IPWR16_C;
var
t1,N,NF,S,P,Pn,Neg: Integer;
begin


 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;

 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 P:=GNode^.AI;

 LoadArg1;
 IPWRC16(P,t1);


end;




procedure TForevalH.PWR3_C;
var
t1,N,NF,S: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;  }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
  if t1 = T_Real then
  begin
    FLD0;
    FMUL0;
    FMULP;
  end
  else
  if t1 = T_Complex then
  begin
   {MOVA1(Cardinal(@Z_IPWR3));
   CALLA;
   CheckStack(3);
   CheckStack(-3); }

   {ZPUSH;
   ZSQR;
   ZMULP;}

   ZIPWR3;

  end;
end;





procedure TForevalH.PWR4_C;
var
t1,N,NF,S: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;}
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
  if t1 = T_Real then
  begin
    FMUL0;
    FMUL0;
  end
  else
  if t1 = T_Complex then
  begin
   {MOVA1(Cardinal(@Z_IPWR4));
   CALLA;
   CheckStack(3);
   CheckStack(-3);}

   ZSQR;
   ZSQR;
  end;
end;




procedure TForevalH.PWR5_C;
var
t1,N,NF,S: Integer;
begin
{ N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;   }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
  if t1 = T_Real then
  begin
    FLD0;
    FMUL0;
    FMUL0;
    FMULP;
  end
  else
  if t1 = T_Complex then
  begin
   ZPUSH;
   ZSQR;
   ZSQR;
   ZMULP;
  end;
end;



procedure TForevalH.PWR6_C;
var
t1,N,NF,S: Integer;
begin
{ N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;   }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
  if t1 = T_Real then
  begin
    FMUL0;
    FLD0;
    FMUL0;
    FMULP;
  end
  else
  if t1 = T_Complex then
  begin
   ZSQR;
   ZPUSH;
   ZSQR;
   ZMULP;
  end;
end;




procedure TForevalH.PWRN1_C;
var
t1,N,NF,S: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;  }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
  if t1 = T_Real then
  begin
    FLD1;
    FDIVRP;
  end
  else
  if t1 = T_Complex then
  begin
   MOVAadr(Cardinal(@Z_IPWRN1));
   CALLA;
   CheckStack(2);
   CheckStack(-2);
  end;
end;





procedure TForevalH.TRUNC_C;
var
t1,N,NF,S: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
  if t1 = T_Real then
  begin
    PUSHCW;    {.227}
    FLDCW(TAddress(@FCW1));
    FRNDINT;
    POPCW;    {.227}// FLDCW(TAddress(@FCW2));
  end;
end;



procedure TForevalH.CON_C;
var
t1,N,NF,S: Integer;
begin
{ N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;

 if t1 = T_Complex then
 begin
  FXCH1;
  FCHS;
  FXCH1;
 end
 else
 if t1 = T_Real then
 begin
 end;

end;



procedure TForevalH.Frac_C;
var
t1,N,NF,S: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;  }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
  if t1 = T_Real then
  begin
    FLD0;
    PUSHCW;    {.227}
    FLDCW(TAddress(@FCW1));
    FRNDINT;
    POPCW;    {.227}//FLDCW(TAddress(@FCW2));
    FSUBP;
  end;
end;



procedure TForevalH.SGN_C;
var
t1,N,NF,S: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
  if t1 = T_Real then
  begin
    MOVAadr(Cardinal(@R_SGN));
    CALLA;
  end
  else
  if t1 = T_Complex then
  begin
    MOVAadr(Cardinal(@Z_SGN));
    CALLA;
  end;

end;




procedure TForevalH.NORM23_C;
var
t1,N,NF,S,nv,TM,NArg: Integer;
Adr: Cardinal;
begin
{ N:=Interp[NFunc].NFunc;
 NArg:=Interp[NFunc].N;  }
 N:=GNode^.NFunc;
 NArg:=GNode^.N;

 // norm(r1,r2)
 if NArg =  2 then
 begin
   LoadArg2RL;
   FMUL0;
   FXCH1;
   FMUL0;
   FADDP;
   FSQRT;
 end
 else
 // norm(r1,r2,r3)
 if NArg =  3 then
 begin
   LoadArg3RL;
   FMUL0;
   FXCH1;
   FMUL0;
   FADDP;
   FXCH1;
   FMUL0;
   FADDP;
   FSQRT;
 end;

end;


procedure TForevalH.NORM_C;
var
t1,N,NF,S,nv,TM: Integer;
Adr: Cardinal;
begin
 
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 nv:=GNode^.NV1;

 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 //nv:=Interp[NFunc].NV1;
 Adr:=Alg.Obj[nv].Addr;
 TM:=Alg.Obj[nv].MType;

 (*
 if TM = _Double then
 begin

   MOVMA(Adr);
   MOVBadr(Cardinal(@RD_NORM));
   CALLB;
 end
 else
 if TM = _Extended then
 begin

   MOVMA(Adr);
   MOVBadr(Cardinal(@RE_NORM));
   CALLB;
 end
 else
 if (TM = _Integer) or ((TM = _Pointer) {and (F_EnableUseIntegerPointer = True)}) then
 begin

   MOVMA(Adr);
   MOVBadr(Cardinal(@RI_NORM));
   CALLB;
 end
 else
 *)

 if (TM = _Extended) or (TM = _Double) or (TM = _Single) or (TM = _Integer){ or ((TM = _Pointer) and (F_EnableUseIntegerPointer = True)) } then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBnum(TM);
   MOVCadr(Cardinal(@RV_NORM));
   CALLC;
 end
 else
 begin
     begin
        F_SyntaxErrorString:=Alg.ExFunc[N].Name+'(Array of  '+NameMathTypeS[TM]+')  in:  '  +GNode^.Expression;
        F_SyntaxErrorCode:=E_NOT_DEFINED_FUNCTION_FOR_TYPE;
     end;
  end;

 CheckStack(2);
 CheckStack(-1);
end;




procedure TForevalH.SUM_C;
var
t1,N,NF,S,nv,TM,TV,NArg: Integer;
Adr: Cardinal;
begin

 NArg:=GNode^.N;

 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;

 nv:=GNode^.NV1;
 Adr:=Alg.Obj[nv].Addr;
 TM:=Alg.Obj[nv].MType;

 (*
 if NArg = 0 then
 begin
   nv:=GNode^.NV1;
   Adr:=Alg.Obj[nv].Addr;
   TM:=Alg.Obj[nv].MType;

   MOVMA(Adr);
 end
 else
 if NArg = 1 then
 begin
  //TV:=Alg.ExFunc[N].Func[NF].TV[0];
  TM:=Alg.ExFunc[N].Func[NF].TM[0];

  MOVMREG(R_EAX,GetStackAdr(S,_RE));
 end;
 *)


 (*
 if TM = _Double then
 begin

   //MOVMA(Adr);
   MOVBadr(Cardinal(@RD_SUM));
   CALLB;
 end
 else
 if TM = _Extended then
 begin

   //MOVMA(Adr);
   MOVBadr(Cardinal(@RE_SUM));
   CALLB;
 end
 else
 if (TM = _Integer) or  ((TM = _Pointer) {and (F_EnableUseIntegerPointer = True)}) then
 begin

   //MOVMA(Adr);
   MOVBadr(Cardinal(@RI_SUM));
   CALLB;
 end
 *)

 if (TM = _Extended) or (TM = _Double) or (TM = _Single) or (TM = _Integer){ or  (TM = _Pointer)}  then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBnum(TM);
   MOVCadr(Cardinal(@RV_SUM));
   CALLC;
 end
 else
 begin
     begin
        //sum(vp1)
        F_SyntaxErrorString:=Alg.ExFunc[N].Name+'(Array of  '+NameMathTypeS[TM]+')  in:  '  +GNode^.Expression;
        F_SyntaxErrorCode:=E_NOT_DEFINED_FUNCTION_FOR_TYPE;
     end;
  end;



 CheckStack(2);
 CheckStack(-1);
end;



procedure TForevalH.PROD_C;
var
t1,N,NF,S,nv,TM: Integer;
Adr: Cardinal;
begin
{ N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;  }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 nv:=GNode^.NV1;

 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 //nv:=Interp[NFunc].NV1;
 Adr:=Alg.Obj[nv].Addr;
 TM:=Alg.Obj[nv].MType;

 (*
 if TM = _Double then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RD_PROD));
   CALLB;
 end
 else
 if TM = _Extended then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RE_PROD));
   CALLB;
 end
 else
 if (TM = _Integer) or  ((TM = _Pointer) and (F_EnableUseIntegerPointer = True)) then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RI_PROD));
   CALLB;
 end
 *)

 if (TM = _Extended) or (TM = _Double) or (TM = _Single) or (TM = _Integer) {or ((TM = _Pointer) and (F_EnableUseIntegerPointer = True))} then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBnum(TM);
   MOVCadr(Cardinal(@RV_PROD));
   CALLC;
 end
 else
 begin
     begin
        F_SyntaxErrorString:=Alg.ExFunc[N].Name+'(Array of  '+NameMathTypeS[TM]+')  in:  '  +GNode^.Expression;
        F_SyntaxErrorCode:=E_NOT_DEFINED_FUNCTION_FOR_TYPE;
     end;
  end;

 CheckStack(2);
 CheckStack(-1);
end;




procedure TForevalH.SUMP_C;
var
t1,N,NF,S,nv,TM: Integer;
Adr: Cardinal;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }

 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 nv:=GNode^.NV1;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 //nv:=Interp[NFunc].NV1;
 Adr:=Alg.Obj[nv].Addr;
 TM:=Alg.Obj[nv].MType;

  //EAX<-adr(vector);  EDX<-intpower
 if GNode^.AI = 1 then
 begin
       LoadLineFormEAX(_Second);
       MOVREG(R_EAX,R_EDX);
 end
 else
 if GNode^.AI = 0 then
 begin
       LoadArg1;
        //trunc
        (*
       PUSHCW;    {.227}
       FLDCW(TAddress(@FCW1));
       MEM:=WriteDataA(0,_Integer);
       FISTP(MEM);
       POPCW;    {.227} //FLDCW(TAddress(@FCW2));
       MOVMB(MEM);
       *)
       TRUNCR(R_EDX);
 end;

  {
 if TM = _Double then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVCadr(Cardinal(@RD_SUMP));
   CALLC;
 end
 else
 if TM = _Extended then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVCadr(Cardinal(@RE_SUMP));
   CALLC;
 end
 else
 if (TM = _Integer) or  ((TM = _Pointer) and (F_EnableUseIntegerPointer = True)) then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVCadr(Cardinal(@RI_SUMP));
   CALLC;
 end
 else
 }

 if (TM = _Extended) or (TM = _Double) or (TM = _Single) or (TM = _Integer) {or ((TM = _Pointer) and (F_EnableUseIntegerPointer = True))} then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBnum(TM);
   MOVCadr(Cardinal(@RV_SUMP));
   CALLC;
 end
 else
 begin
     begin
        F_SyntaxErrorString:=Alg.ExFunc[N].Name+'(Array of  '+NameMathTypeS[TM]+')  in:  '  +GNode^.Expression;
        F_SyntaxErrorCode:=E_NOT_DEFINED_FUNCTION_FOR_TYPE;
     end;
  end;

  CheckStack(3);
  CheckStack(-2);
end;




procedure TForevalH.SUMPS_C;
var
t1,N,NF,S,nv,TM: Integer;
Adr: Cardinal;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }

 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 nv:=GNode^.NV1;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 //nv:=Interp[NFunc].NV1;
 Adr:=Alg.Obj[nv].Addr;
 TM:=Alg.Obj[nv].MType;

  //EAX<-adr(vector);  EDX<-intpower
 if GNode^.AI = 1 then
 begin
       LoadArg1;
       LoadLineFormEAX(_Second);
       MOVREG(R_EAX,R_EDX);
 end
 else
 if GNode^.AI = 0 then
 begin
       LoadArg2Back;
        //trunc
        (*
       PUSHCW;    {.227}
       FLDCW(TAddress(@FCW1));
       MEM:=WriteDataA(0,_Integer);
       FISTP(MEM);
       POPCW;    {.227} //FLDCW(TAddress(@FCW2));
       MOVMB(MEM);
       *)
       TRUNCR(R_EDX);
 end;

 {
 if TM = _Double then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVCadr(Cardinal(@RD_SUMPS));
   CALLC;
 end
 else
 if TM = _Extended then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVCadr(Cardinal(@RE_SUMPS));
   CALLC;
 end
 else
 if (TM = _Integer) or  ((TM = _Pointer) and (F_EnableUseIntegerPointer = True))  then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVCadr(Cardinal(@RI_SUMPS));
   CALLC;
 end
 else
 }

 if (TM = _Extended) or (TM = _Double) or (TM = _Single) or (TM = _Integer) {or ((TM = _Pointer) and (F_EnableUseIntegerPointer = True))} then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBnum(TM);
   MOVCadr(Cardinal(@RV_SUMPS));
   CALLC;
 end
 else
 begin
     begin
        F_SyntaxErrorString:=Alg.ExFunc[N].Name+'(Array of  '+NameMathTypeS[TM]+')  in:  '  +GNode^.Expression;
        F_SyntaxErrorCode:=E_NOT_DEFINED_FUNCTION_FOR_TYPE;
     end;
  end;

  CheckStack(3);
  CheckStack(-3);
end;



procedure TForevalH.PRODS_C;
var
t1,N,NF,S,nv,TM: Integer;
Adr: Cardinal;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }

 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 nv:=GNode^.NV1;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 //nv:=Interp[NFunc].NV1;
 Adr:=Alg.Obj[nv].Addr;
 TM:=Alg.Obj[nv].MType;

  //EAX<-adr(vector);
 if GNode^.AI = 0 then
 begin
       LoadArg1;
 end;


 if (TM = _Extended) or (TM = _Double) or (TM = _Single) or (TM = _Integer) {or ((TM = _Pointer) and (F_EnableUseIntegerPointer = True))} then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBnum(TM);
   MOVCadr(Cardinal(@RV_PRODS));
   CALLC;
 end
 else
 begin
     begin
        F_SyntaxErrorString:=Alg.ExFunc[N].Name+'(Array of  '+NameMathTypeS[TM]+')  in:  '  +GNode^.Expression;
        F_SyntaxErrorCode:=E_NOT_DEFINED_FUNCTION_FOR_TYPE;
     end;
  end;

  CheckStack(3);
  CheckStack(-3);
end;




procedure TForevalH.SUMI_C;
var
t1,N,NF,S,nv,TM,TV,NArg: Integer;
Adr: Cardinal;
begin

 NArg:=GNode^.N;

 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;

 nv:=GNode^.NV1;
 Adr:=Alg.Obj[nv].Addr;
 TM:=Alg.Obj[nv].MType;


 if (TM = _Integer){ or  (TM = _Pointer)}  then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVCadr(Cardinal(@RI_SUMI));
   CALLC;
 end
 else
 begin
     begin
        //sum(vp1)
        F_SyntaxErrorString:=Alg.ExFunc[N].Name+'(Array of  '+NameMathTypeS[TM]+')  in:  '  +GNode^.Expression;
        F_SyntaxErrorCode:=E_NOT_DEFINED_FUNCTION_FOR_TYPE;
     end;
  end;



 CheckStack(1);
end;



procedure TForevalH.CALL_C;
var
t1,N,NF,S,nv,TM,NM: Integer;
Adr,AdrM,AddrF: Cardinal;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }

 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 nv:=GNode^.NV1;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 //nv:=Interp[NFunc].NV1;
 Adr:=Alg.Obj[nv].Addr;  //адрес переменной
 TM:=Alg.Obj[nv].MType;

 AddrF:=GNode^.Addr1; //адрес функции

 NM:=GNode^.NObj;
 AdrM:=Alg.Obj[NM].Addr;  //адрес массива
 TM:=Alg.Obj[NM].MType;


  //CALL(Addr)
 if GNode^.AI = 1 then
 begin
      //CALL addr
      AddWord($FF,$15);
      AddAddress(Adr);

 end
 else  //CALL(Addr)
 if GNode^.AI = 4 then
 begin
      //CALL addr
      //AddWord($FF,$15);
      //AddAddress(AddrF);
      MOVAadr(AddrF);
      CALLA;
 end
 else
  //вызов сохранённого адреса в стеке. Исп-ся через преобразование типов
       //extf()=sqrt(x)      ptrf:pointer=@extf;  adrI:int=integer(ptrf); callR(pointer(adri))
 if GNode^.AI = 6 then
 begin
    MOVMREG(R_EAX,GetStackAdr(S,_RE));
    CALLA;
 end
 else
 begin
   //Call(Vec[IntConst])
   if GNode^.AI = 5 then
   begin
      //IntConst -> EAX;
      MOVCREG(R_EAX,Trunc(GNode^.FD));
   end
   else
   //CALL(VecInt[IntForm])
   if GNode^.AI = 3 then  //Vec[AIVP]  - vec[IntForm]
   begin
      //AIVP1 -> EAX;
      LineFormN(GNode^.AIVP1,Trunc(GNode^.FD));
   end
   else
   //CALL(VecInt[IntVar])
   if GNode^.AI = 2 then
   begin
     MOVMA(Adr);

   (*
   LoadArg1;
   //trunc
   PUSHCW;    {.227}
   FLDCW(TAddress(@FCW1));
   MEM:=WriteDataA(0,_Integer);
   FISTP(MEM);
   POPCW;    {.227} //FLDCW(TAddress(@FCW2));
   MOVMC(MEM);
   *)
   end
   else
   if GNode^.AI = 0 then     //Vec[Trunc(Stack)]
   begin
     LoadArg1;
     //trunc
     (*
     PUSHCW;    {.227}
     FLDCW(TAddress(@FCW1));
     MEM:=WriteDataA(0,_Integer);
     FISTP(MEM);
     POPCW;    {.227} //FLDCW(TAddress(@FCW2));
     //MOVMC(MEM);
     MOVMA(MEM);
     *)
     TRUNCR(R_EAX);
 end;


   //  CALL   EAX



   MOVBadr(AdrM);                    //Addr(Vec) -> EBX
    //mov  ebx, [ebx]:
   AddByte($8B); AddByte($1B);      //Addr(Vec[0]) -> EBX
    //mov eax, [ebx+4*eax]
   AddByte($8B); AddByte($04);AddByte($83);    //Vec[indx]->EAX

   CALLA;
 end;


   CheckStack(8);
   CheckStack(-8);
end;





procedure TForevalH.AVR23_C;
var
t1,N,NF,S,nv,TM,NArg: Integer;
Adr: Cardinal;
begin
 {N:=Interp[NFunc].NFunc;
 NArg:=Interp[NFunc].N; }
 N:=GNode^.NFunc;
 NArg:=GNode^.N;

 // avr(r1,r2)
 if NArg =  2 then
 begin
   LoadArg2RL;
   FADDP;
   FMUL_C05;
 end
 else
 // avr(r1,r2,r3)
 if NArg =  3 then
 begin
   LoadArg3RL;
   FADDP;
   FADDP;
   FDIV_C3;
 end;

end;



procedure TForevalH.AVR_C;
label endp;
var
t1,N,NF,S,nv,TM,NArg: Integer;
Adr: Cardinal;
begin
{ N:=Interp[NFunc].NFunc;
 NArg:=Interp[NFunc].N;
 }
 N:=GNode^.NFunc;
 NArg:=GNode^.N;

 {NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;  }
 NF:=GNode^.NF;
 S:=GNode^.S;
 nv:=GNode^.NV1;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 //nv:=Interp[NFunc].NV1;
 Adr:=Alg.Obj[nv].Addr;
 TM:=Alg.Obj[nv].MType;


 (*
 //for array:
 if TM = _Double then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RD_AVR));
   CALLB;
 end
 else
 if TM = _Extended then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RE_AVR));
   CALLB;
 end
 else
 if (TM = _Integer) or ((TM = _Pointer) and (F_EnableUseIntegerPointer = True)) then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RI_AVR));
   CALLB;
 end
 *)

 if (TM = _Extended) or (TM = _Double) or (TM = _Single) or (TM = _Integer){ or ((TM = _Pointer) and (F_EnableUseIntegerPointer = True)) } then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBnum(TM);
   MOVCadr(Cardinal(@RV_AVR));
   CALLC;
 end
 else
 begin
     begin
        F_SyntaxErrorString:=Alg.ExFunc[N].Name+'(Array of  '+NameMathTypeS[TM]+')  in:  '  +GNode^.Expression;
        F_SyntaxErrorCode:=E_NOT_DEFINED_FUNCTION_FOR_TYPE;
     end;
  end;


 CheckStack(2);
 CheckStack(-1);

endp:
end;





procedure TForevalH.SUMQ_C;
var
t1,N,NF,S,nv,TM: Integer;
Adr: Cardinal;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;}
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 nv:=GNode^.NV1;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 //nv:=Interp[NFunc].NV1;
 Adr:=Alg.Obj[nv].Addr;
 TM:=Alg.Obj[nv].MType;

 (*
 if TM = _Double then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RD_SUMQ));
   CALLB;
 end
 else
 if TM = _Extended then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RE_SUMQ));
   CALLB;
 end
 else
 if (TM = _Integer) or ((TM = _Pointer) and (F_EnableUseIntegerPointer = True))  then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RI_SUMQ));
   CALLB;
 end
 else
 *)

 if (TM = _Extended) or (TM = _Double) or (TM = _Single) or (TM = _Integer){ or ((TM = _Pointer) and (F_EnableUseIntegerPointer = True)) } then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBnum(TM);
   MOVCadr(Cardinal(@RV_SUMQ));
   CALLC;
 end
 else
 begin
     begin
        F_SyntaxErrorString:=Alg.ExFunc[N].Name+'(Array of  '+NameMathTypeS[TM]+')  in:  '  +GNode^.Expression;
        F_SyntaxErrorCode:=E_NOT_DEFINED_FUNCTION_FOR_TYPE;
     end;
 end;


 CheckStack(2);
 CheckStack(-1);
end;





procedure TForevalH.DEV_C;
var
t1,N,NF,S,nv,TM: Integer;
Adr: Cardinal;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 nv:=GNode^.NV1;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 //nv:=Interp[NFunc].NV1;
 Adr:=Alg.Obj[nv].Addr;
 TM:=Alg.Obj[nv].MType;

 (*
 if TM = _Double then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RD_DEV));
   CALLB;
 end
 else
 if TM = _Extended then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RE_DEV));
   CALLB;
 end
 else
 if (TM = _Integer) or ((TM = _Pointer) and (F_EnableUseIntegerPointer = True)) then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RI_DEV));
   CALLB;
 end
 else
 *)

 if (TM = _Extended) or (TM = _Double) or (TM = _Single) or (TM = _Integer){ or ((TM = _Pointer) and (F_EnableUseIntegerPointer = True)) } then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBnum(TM);
   MOVCadr(Cardinal(@RV_DEV));
   CALLC;
 end
 else
 begin
     begin
        F_SyntaxErrorString:=Alg.ExFunc[N].Name+'(Array of  '+NameMathTypeS[TM]+')  in:  '  +GNode^.Expression;
        F_SyntaxErrorCode:=E_NOT_DEFINED_FUNCTION_FOR_TYPE;
     end;
  end;


 CheckStack(2);
 CheckStack(-1);
end;




procedure TForevalH.DEVS_C;
var
t1,N,NF,S,nv,TM: Integer;
Adr: Cardinal;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 nv:=GNode^.NV1;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 //nv:=Interp[NFunc].NV1;
 Adr:=Alg.Obj[nv].Addr;
 TM:=Alg.Obj[nv].MType;

 (*
 if TM = _Double then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RD_DEVS));
   CALLB;
 end
 else
 if TM = _Extended then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RE_DEVS));
   CALLB;
 end
 else
 if (TM = _Integer) or ((TM = _Pointer) and (F_EnableUseIntegerPointer = True))  then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RI_DEVS));
   CALLB;
 end
 else
 *)

 if (TM = _Extended) or (TM = _Double) or (TM = _Single) or (TM = _Integer){ or ((TM = _Pointer) and (F_EnableUseIntegerPointer = True)) } then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBnum(TM);
   MOVCadr(Cardinal(@RV_DEVS));
   CALLC;
 end
 else
 begin
     begin
        F_SyntaxErrorString:=Alg.ExFunc[N].Name+'(Array of  '+NameMathTypeS[TM]+')  in:  '  +GNode^.Expression;
        F_SyntaxErrorCode:=E_NOT_DEFINED_FUNCTION_FOR_TYPE;
     end;
  end;


 CheckStack(2);
 CheckStack(-1);
end;



procedure TForevalH.GCD_C;
var
t1,N,NF,S,nv,TM: Integer;
Adr: Cardinal;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 nv:=GNode^.NV1;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 //nv:=Interp[NFunc].NV1;
 Adr:=Alg.Obj[nv].Addr;
 TM:=Alg.Obj[nv].MType;

 (*
 if TM = _Double then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RD_GCD));
   CALLB;
 end
 else
 if TM = _Extended then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RE_GCD));
   CALLB;
 end
 else
 if (TM = _Integer) or ((TM = _Pointer) and (F_EnableUseIntegerPointer = True)) then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RI_GCD));
   CALLB;
 end
 else
 *)
 if (TM = _Extended) or (TM = _Double) or (TM = _Single) or (TM = _Integer){ or ((TM = _Pointer) and (F_EnableUseIntegerPointer = True)) } then
 begin
   //MOVA1(Adr);

   MOVAnum(TM);
   PUSHR(R_EAX);
   MOVMA(Adr);
   PUSHR(R_EAX);

   MOVAadr(Cardinal(@RV_GCD));
   CALLA;
 end
 else
 begin
     begin
        F_SyntaxErrorString:=Alg.ExFunc[N].Name+'(Array of  '+NameMathTypeS[TM]+')  in:  '  +GNode^.Expression;
        F_SyntaxErrorCode:=E_NOT_DEFINED_FUNCTION_FOR_TYPE;
     end;
  end;


 CheckStack(2);
 CheckStack(-1);
end;



procedure TForevalH.LCM_C;
var
t1,N,NF,S,nv,TM: Integer;
Adr: Cardinal;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 nv:=GNode^.NV1;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 //nv:=Interp[NFunc].NV1;
 Adr:=Alg.Obj[nv].Addr;
 TM:=Alg.Obj[nv].MType;
 (*
 if TM = _Double then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RD_LCM));
   CALLB;
 end
 else
 if TM = _Extended then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RE_LCM));
   CALLB;
 end
 else
 if (TM = _Integer) or ((TM = _Pointer) and (F_EnableUseIntegerPointer = True)) then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RI_LCM));
   CALLB;
 end
 else
 *)
 if (TM = _Extended) or (TM = _Double) or (TM = _Single) or (TM = _Integer){ or ((TM = _Pointer) and (F_EnableUseIntegerPointer = True)) } then
 begin
   //MOVA1(Adr);

   MOVAnum(TM);
   PUSHR(R_EAX);
   MOVMA(Adr);
   PUSHR(R_EAX);

   MOVAadr(Cardinal(@RV_LCM));
   CALLA;
 end
 else
 begin
     begin
        F_SyntaxErrorString:=Alg.ExFunc[N].Name+'(Array of  '+NameMathTypeS[TM]+')  in:  '  +GNode^.Expression;
        F_SyntaxErrorCode:=E_NOT_DEFINED_FUNCTION_FOR_TYPE;
     end;
  end;


 CheckStack(2);
 CheckStack(-1);
end;



procedure TForevalH.LEN_C;
var
t1,N,NF,S,nv,TM,NArg: Integer;
Adr: Cardinal;
begin

 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 //tv:=Alg.ExFunc[N].Func[NF].TV[0];
 //tm:=Alg.ExFunc[N].Func[NF].TM[0];

 NArg:=GNode^.N;

 if NArg =  0 then
 begin
    nv:=GNode^.NV1;
    Adr:=Alg.Obj[nv].Addr;
    //TM:=Alg.Obj[nv].MType;

    MOVMA(Adr);
 end
 else
 if NArg =  1 then MOVMREG(R_EAX,GetStackAdr(S,_RE));

   MOVBadr(Cardinal(@R_LEN));
   CALLB;

   CheckStack(1);
end;







procedure TForevalH.MAX23_C;
label endp;
var
t1,N,NF,S,nv,TM,NArg: Integer;
Adr: Cardinal;
begin
 {N:=Interp[NFunc].NFunc;
 NArg:=Interp[NFunc].N; }
 N:=GNode^.NFunc;
 NArg:=GNode^.N;

 // max(r1,r2)
 if NArg =  2 then
 begin
   //LoadArg2;
   LoadArg2RL;
   AddWord($DB,$F1);    //fcomi   st(0), st(1)
   AddWord($DA,$C1);    //fcmovb  st(0), st(1)
   FSTP1;
 end
 else
 if NArg =  3 then     // max(r1,r2,r3)
 begin
   LoadArg3RL;
   AddWord($DB,$F1);    //fcomi   st(0), st(1)
   AddWord($DA,$C1);    //fcmovb  st(0), st(1)
   FSTP1;
   AddWord($DB,$F1);    //fcomi   st(0), st(1)
   AddWord($DA,$C1);    //fcmovb  st(0), st(1)
   FSTP1;
 end;
end;




procedure TForevalH.MAX_C;
label endp;
var
t1,N,NF,S,nv,TM,NArg: Integer;
Adr: Cardinal;
begin
 {N:=Interp[NFunc].NFunc;
 NArg:=Interp[NFunc].N; }
 N:=GNode^.NFunc;
 NArg:=GNode^.N;




 //for array:
 {NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;}
 NF:=GNode^.NF;
 S:=GNode^.S;
 nv:=GNode^.NV1;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 //nv:=Interp[NFunc].NV1;
 Adr:=Alg.Obj[nv].Addr;
 TM:=Alg.Obj[nv].MType;



 if (TM = _Extended) or (TM = _Double) or (TM = _Single)  then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBnum(TM);
   MOVCadr(Cardinal(@RV_MAX));
   CALLC;
 end
 else
 if (TM = _Integer) or ((TM = _Pointer) and (F_EnableUseIntegerPointer = True)) then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RI_MAX));
   CALLB;
 end
 else
 begin
     begin
        F_SyntaxErrorString:=Alg.ExFunc[N].Name+'(Array of  '+NameMathTypeS[TM]+')  in:  '  +GNode^.Expression;
        F_SyntaxErrorCode:=E_NOT_DEFINED_FUNCTION_FOR_TYPE;
     end;
  end;


 CheckStack(2);
 CheckStack(-1);

 endp:
end;







procedure TForevalH.MIN23_C;
label endp;
var
t1,N,NF,S,nv,TM,NArg: Integer;
Adr: Cardinal;
begin
 {N:=Interp[NFunc].NFunc;
 NArg:=Interp[NFunc].N;}
 N:=GNode^.NFunc;
 NArg:=GNode^.N;

 // min(r1,r2)
 if NArg =  2 then
 begin
   //LoadArg2;
   LoadArg2RL;
   AddWord($DB,$F1);    //fcomi   st(0), st(1)
   AddWord($DB,$C1);    //fcmovnb st(0), st(1)
   FSTP1;
 end
 else
 if NArg =  3 then     // min(r1,r2,r3)
 begin
   LoadArg3RL;
   AddWord($DB,$F1);    //fcomi   st(0), st(1)
   AddWord($DB,$C1);    //fcmovnb st(0), st(1)
   FSTP1;
   AddWord($DB,$F1);    //fcomi   st(0), st(1)
   AddWord($DB,$C1);    //fcmovnb st(0), st(1)
   FSTP1;
 end;
end;



procedure TForevalH.MIN_C;
label endp;
var
t1,N,NF,S,nv,TM,NArg: Integer;
Adr: Cardinal;
begin
 {N:=Interp[NFunc].NFunc;
 NArg:=Interp[NFunc].N; }
 N:=GNode^.NFunc;
 NArg:=GNode^.N;

 //for array:
 NF:=GNode^.NF;
 S:=GNode^.S;
 nv:=GNode^.NV1;
 {NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 //nv:=Interp[NFunc].NV1;
 Adr:=Alg.Obj[nv].Addr;
 TM:=Alg.Obj[nv].MType;



 if (TM = _Extended) or (TM = _Double) or (TM = _Single)  then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBnum(TM);
   MOVCadr(Cardinal(@RV_MIN));
   CALLC;
 end
 else
 if (TM = _Integer) or ((TM = _Pointer) and (F_EnableUseIntegerPointer = True)) then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RI_MIN));
   CALLB;
 end
 else
 begin
     begin
        F_SyntaxErrorString:=Alg.ExFunc[N].Name+'(Array of  '+NameMathTypeS[TM]+')  in:  '  +GNode^.Expression;
        F_SyntaxErrorCode:=E_NOT_DEFINED_FUNCTION_FOR_TYPE;
     end;
  end;


 CheckStack(2);
 CheckStack(-1);

endp:
end;





procedure TForevalH.LDSVX_C;
var
t1,N,NF,S,nv,TM,TA,NM,NA,TMA,tva: Integer;
AdrM,AdrA,Num: Cardinal;
begin

 //NM:=Interp[NFunc].NObj;
 NM:=GNode^.NObj;
 AdrM:=Alg.Obj[NM].Addr;
 TM:=Alg.Obj[NM].MType;


 if GNode^.AI = 0 then     //Vec[Trunc(Stack)]
 begin
   LoadArg1;
   //trunc
   (*
   PUSHCW;    {.227}
   FLDCW(TAddress(@FCW1));
   MEM:=WriteDataA(0,_Integer);
   FISTP(MEM);
   POPCW;    {.227} //FLDCW(TAddress(@FCW2));
   MOVMC(MEM);
   *)
   TRUNCR(R_ECX);
 end
 else
 if GNode^.AI = 2 then    //Vec[float_var]
 begin
  GetVar1(GNode^.NV1,AdrA,tva,TMA);
  if (TMA = _Double) or (TMA = _Extended) or (TMA = _Single) then
  begin
   FLDV(GNode^.NV1);
   (*
   PUSHCW;    {.227}
   FLDCW(TAddress(@FCW1));
   MEM:=WriteDataA(0,_Integer);
   FISTP(MEM);
   POPCW;    {.227} //FLDCW(TAddress(@FCW2));
   MOVMC(MEM);
   *)
   TRUNCR(R_ECX);
  end
  else
  if TMA = _Integer then
  begin
    MOVMC(AdrA);
  end;
 end
 else
 if GNode^.AI = 1 then  //Vec[num]
 begin
   Num:=Trunc(GNode^.FD);
   MOVCadr(NUM); //Num>=0!!!
 end
 else
 if GNode^.AI = 3 then  //Vec[AIVP]  - vec[IntForm]
 begin
    //AIVP1;
    LineFormN(GNode^.AIVP1,Trunc(GNode^.FD));
    MOVREG(R_EAX,R_ECX);
 end
 else
 if GNode^.AI = 4 then  //Vec[VecInt[indx]]    {.357}
 begin
    LoadArrayElem(_LoadIntArrayElemEAX);//VecInt[indx]->EAX
    MOVREG(R_EAX,R_ECX);
 end;



   MOVBadr(AdrM);
   //mov  ebx, [ebx]:
   AddByte($8B); AddByte($1B);   //AddrArray -> EBX

   LoadArrayCellFPU(R_EBX,R_ECX,TM);

  (*
 if TM = _Double then
 begin


   MOVB1(AdrM);
   MOVA1(Cardinal(@RD_VEC));
   CALLA;
   //fld  qword ptr [ebx+8*ecx]:
   AddByte($DD); AddByte($04);AddByte($CB);

 end
 else
 if TM = _Extended then
 begin
   MOVB1(AdrM);
   MOVA1(Cardinal(@RE_VEC));
   CALLA;

    MOVBadr(AdrM);
   //mov  ebx, [ebx]:
   AddByte($8B); AddByte($1B);

   //lea   ecx,[ecx+4*ecx]:
   AddByte($8D); AddByte($0C);AddByte($89);
   //fld   tbyte ptr [ebx+2*ecx]:
   AddByte($DB); AddByte($2C);AddByte($4B);

 end
 else
 if TM = _Integer then
 begin
   MOVB1(AdrM);
   MOVA1(Cardinal(@RI_VEC));
   CALLA;

    MOVBadr(AdrM);
   //mov  ebx, [ebx]:
   AddByte($8B); AddByte($1B);
   //fild  dword ptr [ebx+4*ecx]:
   AddByte($DB); AddByte($04);AddByte($8B);
 end
 else
 if TM = _Single then
 begin
   MOVBadr(AdrM);
   //mov  ebx, [ebx]:
   AddByte($8B); AddByte($1B);
   //fld  dword ptr [ebx+4*ecx]:
   AddByte($D9); AddByte($04);AddByte($8B);
 end;
CheckStack(1);
*)

end;





procedure TForevalH.POLY_C;
var
tf,tv,tc,ts,N,NF,S,nv,TM,t2,ta,LP,k,i: Integer;
Adr: Cardinal;
f1: TFloat;
CAn: TComplex;


    procedure _ADD_Cn(k: Integer);
    var
      B_LoadST:Boolean;

    begin
       B_LoadST:=False;

        //if GNode^.VFP[k].indx >= 0 then
        begin
           CAn.re:=GNode^.VFP[k].Re;
           CAn.im:=GNode^.VFP[k].Im;
           tc:=GNode^.VFP[k].tc;

           if (CAn.re <> 0) or (CAn.im <> 0)  then
           begin

             if tc = T_Complex then
                FLD(WriteDataA(CAn.im,F_DataType),F_DataType);

             FLD(WriteDataA(CAn.re,F_DataType),F_DataType);

             B_LoadST:=True;
           end;

        end;

        if   B_LoadST = True then ADDP_ST(tc,ts);

        if   tc = T_Complex then ts := T_Complex;
    end;


begin

 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 nv:=GNode^.NV1;
 ta:=GNode^.AI;   //тип полинома по типу аргумента:T_Array ; T_Complex(T_Real or T_Complex)

 //tf:=Alg.ExFunc[N].Func[NF].TV[0];
 tf:=GNode^.TypeF;    //возвращаемый тип полинома
 //tv:= GNode^.ArgTypes[High(GNode^.ArgTypes)];  //тип выражения переменной
 tv:=Alg.ExFunc[N].Func[NF].TV[0];   //тип выражения переменной

 Adr:=Alg.Obj[nv].Addr;
 TM:=Alg.Obj[nv].MType;



LoadArg1;

if ta = T_Array then
begin

  if tf = T_Real then
  begin
    (*
    if TM = _Double then
    begin
       //MOVA1(Adr);
       MOVMA(Adr);
       MOVBadr(Cardinal(@RD_POLY));
       CALLB;

       CheckStack(2);
       CheckStack(-2);
    end
    else
    if TM = _Extended then
    begin
      //MOVA1(Adr);
      MOVMA(Adr);
      MOVBadr(Cardinal(@RE_POLY));
      CALLB;

      CheckStack(2);
      CheckStack(-2);
    end
    else
    if TM = _Integer then
    begin
      //MOVA1(Adr);
      MOVMA(Adr);
      MOVBadr(Cardinal(@RI_POLY));
      CALLB;

      CheckStack(2);
      CheckStack(-2);
    end
    else
    *)

    if (TM = _Extended) or (TM = _Double) or (TM = _Single) or (TM = _Integer){ or ((TM = _Pointer) and (F_EnableUseIntegerPointer = True)) } then
    begin
      //MOVA1(Adr);
      MOVMA(Adr);
      MOVBnum(TM);
      MOVCadr(Cardinal(@RV_POLY));
      CALLC;
      CheckStack(2);
      CheckStack(-2);
    end
    else
    begin
      begin
        F_SyntaxErrorString:=Alg.ExFunc[N].Name+'(Array of  '+NameMathTypeS[TM]+')  in:  '  +GNode^.Expression;
        F_SyntaxErrorCode:=E_NOT_DEFINED_FUNCTION_FOR_TYPE;
      end;
    end;

  end
  else
  if tf = T_Complex then
  begin

    (*
   if TM = _Double then
   begin
      //MOVA1(Adr);
      MOVMA(Adr);
      MOVBadr(Cardinal(@CxD_POLY));
      CALLB;

      CheckStack(4);
      CheckStack(-4);
    end
    else
    if TM = _Extended then
    begin
      //MOVA1(Adr);
      MOVMA(Adr);
      MOVBadr(Cardinal(@CxE_POLY));
      CALLB;

      CheckStack(4);
      CheckStack(-4);
    end
    else
    if TM = _Integer then
    begin
      //MOVA1(Adr);
      MOVMA(Adr);
      MOVBadr(Cardinal(@CxI_POLY));
      CALLB;

      CheckStack(4);
      CheckStack(-4);
    end
    else
    *)
     if (TM = _Extended) or (TM = _Double) or (TM = _Single) or (TM = _Integer){ or ((TM = _Pointer) and (F_EnableUseIntegerPointer = True)) } then
    begin
      //MOVA1(Adr);
      MOVMA(Adr);
      MOVBnum(TM);
      MOVCadr(Cardinal(@CxV_POLY));
      CALLC;
      CheckStack(4);
      CheckStack(-4);
    end
    else
    begin
      begin
        F_SyntaxErrorString:=Alg.ExFunc[N].Name+'(Array of  '+NameMathTypeS[TM]+')  in:  '  +GNode^.Expression;
        F_SyntaxErrorCode:=E_NOT_DEFINED_FUNCTION_FOR_TYPE;
      end;
    end;

  end
end  //ta = T_Array
else
//if ta = T_Real then
begin     //ta =  T_Complex (T_Real or T_Complex)
 if tf = T_Real  then   //poly(<ExprReal>,An,..,A0: RealConst)   poly(An,..,A0: RealConst,<ExprReal>)
 begin
  LP:=Length(GNode^.VFP)-1;

  //if F_Mode = M_Compile then F1:={Interp[NFunc]}GNode^.VFP[0].Re else  F1:=1.234;  //1.234 <> +-1 !!!!
  F1:=GNode^.VFP[0].Re; {.347}


                                                  //poly(3,5,x)
     if LP + 1 > 2 then FLD0;  //x,x

     if F1 = -1 then                              {.347}
        FCHS    else
     if F1 <> 1 then
        FMUL(WriteDataA(F1,F_DataType),F_DataType);    //An*x,x

      //FMUL(WriteDataA(F1,F_DataType),F_DataType);    //An*x,x

     for k := 1 to LP-1 do
     begin
       //if F_Mode = M_Compile then F1:=GNode^.VFP[k].Re else  F1:=1.0;  //1.0 <> 0 !!!!
       F1:=GNode^.VFP[k].Re; {.347}
       //FADD(WriteDataA(F1,F_DataType),F_DataType);

       if F1 <> 0 then  FADD(WriteDataA(F1,F_DataType),F_DataType); {.347}

       if k < LP-1 then FMUL01 else FMULP1;
     end;

    //if F_Mode = M_Compile then  F1:=GNode^.VFP[LP].Re else  F1:=1.0;   //1.0 <> 0!!!
    F1:=GNode^.VFP[LP].Re; {.347}
    if F1 <> 0 then FADD(WriteDataA(F1,F_DataType),F_DataType);   //+A0

 // end;

 end     //tf = T_Real
 else
 {
 poly(9,-8,7,-6,5,-4,3,-2,1,-12.34,z1)
 9*z1^9-8*z1^8+7*z1^7-6*z1^6+5*z1^5-4*z1^4+3*z1^3-2*z1^2+z1-12.34
 (((((((((9*z1-8)*z1+7)*z1-6)*z1+5)*z1-4)*z1+3)*z1-2)*z1+1)*z1)-12.34
 }
 if tf = T_Complex  then      //poly(<Expr: Real,Complex>,An,..,A0: Const (Real,Complex))   poly(An,..,A0,<exprCX>)
 begin
        LP:=Length(GNode^.VFP)-1;

         // тип и значение An:
        CAn.re:=GNode^.VFP[0].Re;
        CAn.im:=GNode^.VFP[0].Im;
        tc:=GNode^.VFP[0].tc;


       if LP + 1 > 2 then
       begin
          if tv = T_Real then    FLD0;  //x,x
          if tv = T_Complex then ZPUSH;  //z,z
       end;



       //An*VarExpr:
       if tv = T_Real then      //VarExpr=real
       begin

             if tc = T_Real then       //An.Re*x         poly(a,bi,x)
             begin
             //
                 if CAn.re = -1    then   FCHS          //poly(p2,bi,x)
                 else
                 if CAn.re <> 1    then   FMUL(WriteDataA(CAn.re,F_DataType),F_DataType);    //An*x,x     //poly(a,bi,x)
             end
             else
             if tc = T_Complex then          //CAn*x
             begin

                FLD0;

                if CAn.im = -1 then  FCHS                 //poly(p3i,a,x)      poly(p3i,ai,x)     poly(p5i,a,x)
                else
                if CAn.im <> 1 then  FMUL(WriteDataA(CAn.im,F_DataType),F_DataType);

                FXCH1;

                if CAn.re = -1 then  FCHS
                else
                if CAn.re <> 1 then  FMUL(WriteDataA(CAn.re,F_DataType),F_DataType);       //poly(ai,a,x) poly(ai,bi,x)

             end
       end
       else
       if tv = T_Complex then      //VarExpr=complex
       begin

             if tc = T_Real then       //An.Re*z
             begin

                if CAn.re = -1    then             // poly(p2,bi,z1)
                begin
                   FCHS;
                   FXCH1;
                   FCHS;
                   FXCH1;
                end
                else
                if CAn.re <> 1    then             //     poly(a,bi,z1)
                begin
                   FLD(WriteDataA(CAn.re,F_DataType),F_DataType);
                   FMUL20;
                   FMULP;
                end;

             end   //tc = T_Real
             else
             if tc = T_Complex then          //CAn(VFP)*z
             begin

               if CAn.re = 0 then
               begin
                   if CAn.im = 1 then                     //poly(p4i,b,z1) poly(p4i,bi,z1)
                   begin
                      FXCH1;
                      FCHS;
                   end
                   else
                   if CAn.im = - 1 then                  //poly(p5i,b,z1) poly(p5i,bi,z1)
                   begin
                     FCHS;
                     FXCH1;
                   end
                   else    //Ci*z
                   begin
                     FMUL(WriteDataA(CAn.im,F_DataType),F_DataType);    //poly(p6i,b,z1)    poly(p6i,bi,z1)
                     FXCH1;
                     FMUL(WriteDataA(CAn.im,F_DataType),F_DataType);
                     FCHS;
                   end;

               end   //CAn.re = 0
               else      //CAn(VFP)*z
               begin                                                //poly(ai,bi,z1)
                   FLD(WriteDataA(CAn.im,F_DataType),F_DataType);
                   FLD(WriteDataA(CAn.re,F_DataType),F_DataType);
                   ZMULP;
               end;

             end;  //tc = T_Complex

       end;   //tv = T_Complex

      if (tc = T_Complex) or (tv = T_Complex) then ts := T_Complex else ts:=T_Real; //текущий тип выражения (в стеке)

    //главный цикл вычисления полинома:
     //********************************
   for i :=1 to LP-1 do
    begin


        _ADD_Cn(i);

        if i < LP-1 then
           MUL_ST(ts,tv)
        else
           MULP_ST(ts,tv);



        if tc = T_Complex then   ts := T_Complex;


    end;//for


    _ADD_Cn(LP);


    //OLD {.345}
    (*
    LP:=Length(GNode^.VFP)-1;

    //if F_Mode = M_Compile then F1:={Interp[NFunc]}GNode^.VFP[0].Re else  F1:=1.234;  //1.234 <> +-1 !!!!
    F1:=GNode^.VFP[0].Re; {.347}


     if LP + 1 > 2 then ZPUSH;

     Adr:=WriteDataA(F1,F_DataType);      // An*Zn
     if F1 = -1 then
     begin
       FCHS;
       FXCH1;
       FCHS;
       FXCH1;
     end
     else
     if F1 <> 1 then
     begin
       FMUL(Adr,F_DataType);
       FXCH1;
       FMUL(Adr,F_DataType);
       FXCH1;
     end;


     for k := 1 to LP-1 do
     begin
       //if F_Mode = M_Compile then F1:=GNode^.VFP[k].Re else  F1:=1.0;   //1.0 <> 0!!!
       F1:=GNode^.VFP[k].Re; {.347}
       if F1 <> 0 then FADD(WriteDataA(F1,F_DataType),F_DataType);

       if k < LP-1 then
       begin
         ZMUL;
       end
       else
       begin
         ZMULP;
       end;
     end;

    //if F_Mode = M_Compile then  F1:=GNode^.VFP[LP].Re else  F1:=1.0;  //1.0 <> 0!!!
     F1:=GNode^.VFP[LP].Re; {.347}
    if F1 <> 0 then FADD(WriteDataA(F1,F_DataType),F_DataType);   //+A0

    *)


 end;  //tf = T_Complex


end; //ta =  T_Complex



end;






procedure TForevalH.POLYU_C;
label endp;
var
 NArg,NS,NF,S,nv,TM,tf,tv,LP,k,ts,tc: Integer;
 Addr: Cardinal;
 An,Ai,A0: Extended;
 CAn,CAi,CA0: TComplex;
 i,cs: Integer;
 //B_LoadST:Boolean;

    procedure _ADD_Cn(k: Integer);
    var
      B_LoadST:Boolean;

    begin
       B_LoadST:=False;

        if GNode^.VFP[k].indx >= 0 then
        begin
           CAn.re:=GNode^.VFP[k].Re;
           CAn.im:=GNode^.VFP[k].Im;
           tc:=GNode^.VFP[k].tc;

           if (CAn.re <> 0) or (CAn.im <> 0)  then
           begin

             if tc = T_Complex then
                FLD(WriteDataA(CAn.im,F_DataType),F_DataType);

             FLD(WriteDataA(CAn.re,F_DataType),F_DataType);

             B_LoadST:=True;
           end;

        end
        else
        begin
           tc:=GNode^.ArgTypes[cs];

           if tc = T_Complex then
              FLD(GetStackAdr(S+cs,_IM),F_DataType);

           FLD(GetStackAdr(S+cs,_RE),F_DataType);

           inc(cs);

           B_LoadST:=True;
        end;

        if   B_LoadST = True then ADDP_ST(tc,ts);

        if   tc = T_Complex then ts := T_Complex;
    end;

begin
//poly(2*a,3*a,4*a,x)+1

 //poly(2*a,3*a,4*a,x)
 //poly(2,3*a,4,5*a,6,7*a,x)
 //poly(2*a,3*y,4*a,5*y,6*a,7*y,x)
 //poly(a,3*y,a,5*y,a,7*y,x)
 //poly(2,3*a,4,5*a,6,7*a,x)-(2*x^5+3*a*x^4+4*x^3+5*a*x^2+6*x+7*a)
 //polynom(5*(z1+y),0,3*(2+3),4,5*(2+3+i),x)


 tf:=GNode^.TypeF;                             //возвращаемый тип полинома
 tv:= GNode^.ArgTypes[High(GNode^.ArgTypes)];  //тип выражения переменной
 S:=GNode^.S;
 NArg:=Length(GNode^.VFP)+1; //полное число аргументов, включая ExprArg
 NS:=GNode^.N; //число аргументов, сохранённых в памяти (аргументы-выражения) Все остальные аргументы - числа, содержатся в массиве VFP
 cs:=0; //указатель текущего аргумента  в памяти: cs = 0,..,NS;
 LP:=NArg-2;

 //poly(ExprAn, ExprAn-1, ExprAn-2,...,ExprA0, VarExpr)
 if tf = T_Real then
 begin
    if NArg-1 = 1 then  //poly(2*a,x) = 2*a    poly(2*a,z1)=2*a
    begin
       FLD(GetStackAdr(S,_RE),F_DataType);
       goto endp;
    end;

                  //NS-1: отсчёт стека с '0'
    FLD(GetStackAdr(S+(NS-1),_RE),F_DataType); //загрузка VarExpr

    if LP + 1 > 2 then FLD0;  //x,x


    if GNode^.VFP[0].indx >= 0 then
    begin
      //if F_Mode = M_Compile then An:=GNode^.VFP[0].Re else An:=1.234;   //1.234 <> +-1 !!!!
      An:=GNode^.VFP[0].Re;
      if An = -1 then
         FCHS    else
      if An <> 1 then
         FMUL(WriteDataA(An,F_DataType),F_DataType);    //An*x,x
    end
    else
    begin
      FMUL(GetStackAdr(S,_RE),F_DataType);    //ExprAn*x,x
      inc(cs);
    end;


    for i := 1 to LP-1 do
    begin

        if GNode^.VFP[i].indx >= 0 then
        begin
           //if F_Mode = M_Compile then Ai:=GNode^.VFP[i].Re else Ai:=1.0;     //1.0 <> 0!!!
           Ai:=GNode^.VFP[i].Re;
           if Ai <> 0 then    FADD(WriteDataA(Ai,F_DataType),F_DataType);
        end
        else
        begin
           FADD(GetStackAdr(S+cs,_RE),F_DataType);
           inc(cs);
        end;

        if i < LP-1 then FMUL01 else FMULP1;

    end;//for

    if GNode^.VFP[LP].indx >= 0 then
    begin
      //if F_Mode = M_Compile then An:=GNode^.VFP[LP].Re else A0:=1.0;   //1.0 <> 0!!!
      A0:=GNode^.VFP[LP].Re;
      if A0 <> 0  then FADD(WriteDataA(A0,F_DataType),F_DataType);   //+A0
    end
    else
    begin
      FADD(GetStackAdr(S+cs,_RE),F_DataType);    //+ExprA0
    end;


 end
 else
 if tf = T_Complex then
 begin
    // poly(ai+bi,x)=ai+bi   poly(ai*2,z1)=2*ai
    if NArg-1 = 1 then
    begin
       FLD(GetStackAdr(S,_IM),F_DataType);
       FLD(GetStackAdr(S,_RE),F_DataType);
       goto endp;
    end;



    // тип и значение An:
    if GNode^.VFP[0].indx >= 0 then
    begin
      {
        if F_Mode = M_Compile then
        begin
          CAn.re:=GNode^.VFP[0].Re;
          CAn.im:=GNode^.VFP[0].Im;
        end
        else
        begin
          CAn.re:=1.234;   //1.234 <> +-1 !!!!
          CAn.im:=1.234;   //1.234 <> +-1 !!!!
        end;
        }

        CAn.re:=GNode^.VFP[0].Re;
        CAn.im:=GNode^.VFP[0].Im;
        tc:=GNode^.VFP[0].tc;
    end
    else
    begin
        tc:=GNode^.ArgTypes[0];
    end;

    //загрузка VarExpr
    if tv = T_Real then
    begin
                      //NS-1: отсчёт стека с '0'
         FLD(GetStackAdr(S+(NS-1),_RE),F_DataType); //загрузка VarExpr
         if LP + 1 > 2 then FLD0;  //x,x
    end
    else
    if tv = T_Complex then
    begin                //NS-1: отсчёт стека с '0'
        FLD(GetStackAdr(S+(NS-1),_IM),F_DataType); //загрузка VarExpr.IM
        FLD(GetStackAdr(S+(NS-1),_RE),F_DataType); //загрузка VarExpr.RE
        if LP + 1 > 2 then ZPUSH;  //z,z
    end;


    //An*VarExpr:
    if tv = T_Real then      //VarExpr=real
    begin
       if GNode^.VFP[0].indx >= 0 then
       begin

          if tc = T_Real then       //An.Re*x         poly(a,bi,x)
          begin
             //
              if CAn.re = -1    then   FCHS          //poly(p2,bi,x)
              else
              if CAn.re <> 1    then   FMUL(WriteDataA(CAn.re,F_DataType),F_DataType);    //An*x,x     //poly(a,bi,x)
          end
          else
          if tc = T_Complex then          //CAn*x
          begin

             FLD0;

             if CAn.im = -1 then  FCHS                 //poly(p3i,a,x)      poly(p3i,ai,x)     poly(p5i,a,x)
             else
             if CAn.im <> 1 then  FMUL(WriteDataA(CAn.im,F_DataType),F_DataType);

             FXCH1;

             if CAn.re = -1 then  FCHS
             else
             if CAn.re <> 1 then  FMUL(WriteDataA(CAn.re,F_DataType),F_DataType);       //poly(ai,a,x) poly(ai,bi,x)

          end

       end
       else   //An in stack
       begin

          if tc = T_Real then                        //poly(a+b,bi,x)      poly(a+b,bi+ci,x)  poly(ai+bi,b+c,x)
          begin
             FMUL(GetStackAdr(S,_RE),F_DataType);    //ExprAn*x,x
             inc(cs);
          end
          else
          if tc = T_Complex then                       // poly(ai+bi,bi,x)    poly(ai+bi,bi+ci,x)    poly(ai+bi,b+c,x)
          begin
             FLD0;
             FMUL(GetStackAdr(S,_IM),F_DataType);
             FXCH1;
             FMUL(GetStackAdr(S,_RE),F_DataType);

             inc(cs);
          end

       end;

    end
    else
    if tv = T_Complex then    //VarExpr=complex
    begin

       if GNode^.VFP[0].indx >= 0 then
       begin

          if tc = T_Real then       //An.Re*z
          begin

              if CAn.re = -1    then             // poly(p2,bi,z1)
              begin
                 FCHS;
                 FXCH1;
                 FCHS;
                 FXCH1;
              end
              else
              if CAn.re <> 1    then             //     poly(a,bi,z1)
              begin
                 FLD(WriteDataA(CAn.re,F_DataType),F_DataType);
                 FMUL20;
                 FMULP;
              end;

          end
          else
          if tc = T_Complex then          //CAn(VFP)*z
          begin

             if CAn.re = 0 then
             begin
               if CAn.im = 1 then                     //poly(p4i,b,z1) poly(p4i,bi,z1)
               begin
                  FXCH1;
                  FCHS;
               end
               else
               if CAn.im = - 1 then                  //poly(p5i,b,z1) poly(p5i,bi,z1)
               begin
                 FCHS;
                 FXCH1;
               end
               else    //Ci*z
               begin
                 FMUL(WriteDataA(CAn.im,F_DataType),F_DataType);    //poly(p6i,b,z1)    poly(p6i,bi,z1)
                 FXCH1;
                 FMUL(WriteDataA(CAn.im,F_DataType),F_DataType);
                 FCHS;
               end;
             end
             else      //CAn(VFP)*z
             begin                                                //poly(ai,bi,z1)
               FLD(WriteDataA(CAn.im,F_DataType),F_DataType);
               FLD(WriteDataA(CAn.re,F_DataType),F_DataType);
               ZMULP;
             end;

          end

       end
       else   //An in stack
       begin

          if tc = T_Real then     //An*z                      //poly(a+b,c+d,z1)  poly(a+b,ci+di,z1)
          begin
             FMUL(GetStackAdr(S,_RE),F_DataType);
             FXCH1;
             FMUL(GetStackAdr(S,_RE),F_DataType);
             FXCH1;
             inc(cs);
          end
          else
          if tc = T_Complex then     //CAn(Mem)*z          // poly(ai+bi,ci+di,z1)   poly(ai+bi,c+d,z1)
          begin
             FLD(GetStackAdr(S,_IM),F_DataType);
             FLD(GetStackAdr(S,_RE),F_DataType);
             ZMULP;
             inc(cs);
          end

       end;

    end ;


    if (tc = T_Complex) or (tv = T_Complex) then ts := T_Complex else ts:=T_Real; //текущий тип выражения (в стеке)

    //главный цикл вычисления полинома:

   //********************************
   for i :=1 to LP-1 do
    begin
        {
        B_LoadST:=False;

        if GNode^.VFP[i].indx >= 0 then
        begin
           CAn.re:=GNode^.VFP[i].Re;
           CAn.im:=GNode^.VFP[i].Im;
           tc:=GNode^.VFP[i].tc;

           if (CAn.re <> 0) or (CAn.im <> 0)  then
           begin

             if tc = T_Complex then
                FLD(WriteDataA(CAn.im,F_DataType),F_DataType);

             FLD(WriteDataA(CAn.re,F_DataType),F_DataType);

             B_LoadST:=True;
           end;

        end
        else
        begin
           tc:=GNode^.ArgTypes[S+cs];

           if tc = T_Complex then
              FLD(GetStackAdr(S+cs,_IM),F_DataType);

           FLD(GetStackAdr(S+cs,_RE),F_DataType);

           inc(cs);

           B_LoadST:=True;
        end;

        if   B_LoadST = True then ADD_ST(tc,ts);
        }

        _ADD_Cn(i);

        if i < LP-1 then
           MUL_ST(ts,tv)
        else
           MULP_ST(ts,tv);



        if tc = T_Complex then   ts := T_Complex;
       

    end;//for

    {
      //+A0
    B_LoadST:=False;
    if GNode^.VFP[LP].indx >= 0 then
    begin
      CAn.re:=GNode^.VFP[LP].Re;
      CAn.im:=GNode^.VFP[LP].Im;
      tc:=GNode^.VFP[LP].tc;

      if (CAn.re <> 0) or (CAn.im <> 0)  then
      begin

             if tc = T_Complex then
                FLD(WriteDataA(CAn.im,F_DataType),F_DataType);

             FLD(WriteDataA(CAn.re,F_DataType),F_DataType);

             B_LoadST:=True;
      end

    end
    else
    begin
           tc:=GNode^.ArgTypes[S+cs];

           if tc = T_Complex then
              FLD(GetStackAdr(S+cs,_IM),F_DataType);

           FLD(GetStackAdr(S+cs,_RE),F_DataType);

           inc(cs);

           B_LoadST:=True;
    end;

    if   B_LoadST = True then ADD_ST(tc,ts);
    }

    _ADD_Cn(LP);

 end;

 (*
 {
 poly(9,-8,7,-6,5,-4,3,-2,1,-12.34,z1)
 9*z1^9-8*z1^8+7*z1^7-6*z1^6+5*z1^5-4*z1^4+3*z1^3-2*z1^2+z1-12.34
 (((((((((9*z1-8)*z1+7)*z1-6)*z1+5)*z1-4)*z1+3)*z1-2)*z1+1)*z1)-12.34
 }
 if t1 = T_Complex  then      //poly(<exprCX>,An,..,A0)   poly(An,..,A0,<exprCX>)
 begin
    LP:=Length({Interp[NFunc]}GNode^.VFP)-1;

   if F_Mode = M_Compile then F1:={Interp[NFunc]}GNode^.VFP[0].Re else  F1:=1.5;



     if LP + 1 > 2 then ZPUSH;

     Adr:=WriteDataA(F1,F_DataType);      // An*Zn
     if F1 = -1 then
     begin
       FCHS;
       FXCH1;
       FCHS;
       FXCH1;
     end
     else
     if F1 <> 1 then
     begin
       FMUL(Adr,F_DataType);
       FXCH1;
       FMUL(Adr,F_DataType);
       FXCH1;
     end;


     for k := 1 to LP-1 do
     begin
       if F_Mode = M_Compile then F1:={Interp[NFunc]}GNode^.VFP[k].Re else  F1:=1;

       if F1 <> 0 then FADD(WriteDataA(F1,F_DataType),F_DataType);

       if k < LP-1 then
       begin
         ZMUL;
       end
       else
       begin
         ZMULP;
       end;
     end;

    if F_Mode = M_Compile then  F1:={Interp[NFunc]}GNode^.VFP[LP].Re else  F1:=1;

    if F1 <> 0 then FADD(WriteDataA(F1,F_DataType),F_DataType);   //+A0
 end;

end;

 *)

  endp:
end;







procedure TForevalH.POLYDIFF_C;
var
t1,N,NF,S,nv,TM,t2,ta,LP,k,ND: Integer;
Adr: Cardinal;
f1: TFloat;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;  }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 nv:=GNode^.NObj;

 //tm:=GNode^.AI;
 ND:=GNode^.CI;    //diff power

 t1:=Alg.ExFunc[N].Func[NF].TV[0];

// nv:=Interp[NFunc].NV1;
 Adr:=Alg.Obj[nv].Addr;
 TM:=Alg.Obj[nv].MType;
 //ta:=Interp[NFunc].AI;

LoadArg1;


 //EAX<-addr(array);
MOVMA(Adr);
//FLD(TAddress(Interp[i].AdrF1),TF);  {.213}
if t1 = T_Real then
begin

 if (TM = _Extended) or (TM = _Double) or (TM = _Single) or (TM = _Integer){ or  (TM = _Pointer)}  then
 begin
   //MOVA1(Adr);
   //MOVMA(Adr);

   {if ND = 1 then MOVCadr(Cardinal(@RD_POLYDIFF1)) else
   if ND = 2 then MOVCadr(Cardinal(@RD_POLYDIFF2)) else
   if ND = 3 then MOVCadr(Cardinal(@RD_POLYDIFF3));}

   if ND = 1 then MOVCadr(Cardinal(@RV_POLYDIFF1)) else
   if ND = 2 then MOVCadr(Cardinal(@RV_POLYDIFF2)) else
   if ND = 3 then MOVCadr(Cardinal(@RV_POLYDIFF3));

  // if ND = 2 then MOVCadr(Cardinal(@RE_POLYDIFF2));

   MOVBnum(TM);
   CALLC;
 end;

 (*
 if TM = _Double then
 begin
   //MOVB1(AdrM);
   if ND = 1 then MOVCadr(Cardinal(@RD_POLYDIFF1)) else
   if ND = 2 then MOVCadr(Cardinal(@RD_POLYDIFF2)) else
   if ND = 3 then MOVCadr(Cardinal(@RD_POLYDIFF3));
   CALLC;
 end
 else
 if TM = _Extended then
 begin
   if ND = 1 then MOVCadr(Cardinal(@RE_POLYDIFF1)) else
   if ND = 2 then MOVCadr(Cardinal(@RE_POLYDIFF2)) else
   if ND = 3 then MOVCadr(Cardinal(@RE_POLYDIFF3));
   CALLC;
 end
 else
 if TM = _Single then
 begin
   if ND = 1 then MOVCadr(Cardinal(@RS_POLYDIFF1)) else
   if ND = 2 then MOVCadr(Cardinal(@RS_POLYDIFF2)) else
   if ND = 3 then MOVCadr(Cardinal(@RS_POLYDIFF3));
   CALLC;
 end
 else
 if TM = _Integer then
 begin
   if ND = 1 then MOVCadr(Cardinal(@RI_POLYDIFF1)) else
   if ND = 2 then MOVCadr(Cardinal(@RI_POLYDIFF2)) else
   if ND = 3 then MOVCadr(Cardinal(@RI_POLYDIFF3));
   CALLC;
 end;
 *)
 CheckStack(3);
 CheckStack(-3);
end
else
if t1 = T_Complex then
begin
  if (TM = _Extended) or (TM = _Double) or (TM = _Single) or (TM = _Integer){ or  (TM = _Pointer)}  then
  begin
   //MOVA1(Adr);
   //MOVMA(Adr);

   {if ND = 1 then MOVCadr(Cardinal(@RD_POLYDIFF1)) else
   if ND = 2 then MOVCadr(Cardinal(@RD_POLYDIFF2)) else
   if ND = 3 then MOVCadr(Cardinal(@RD_POLYDIFF3));}

   if ND = 1 then MOVCadr(Cardinal(@CxV_POLYDIFF1)) else
   if ND = 2 then MOVCadr(Cardinal(@CxV_POLYDIFF2)) else
   if ND = 3 then MOVCadr(Cardinal(@CxV_POLYDIFF3));



   MOVBnum(TM);
   CALLC;
  end;

 {
  if TM = _Double then
 begin

   if ND = 1 then MOVCadr(Cardinal(@CxD_POLYDIFF1)) else
   if ND = 2 then MOVCadr(Cardinal(@CxD_POLYDIFF2)) else
   if ND = 3 then MOVCadr(Cardinal(@CxD_POLYDIFF3));
   CALLC;
 end
 else
 if TM = _Extended then
 begin
   if ND = 1 then MOVCadr(Cardinal(@CxE_POLYDIFF1)) else
   if ND = 2 then MOVCadr(Cardinal(@CxE_POLYDIFF2)) else
   if ND = 3 then MOVCadr(Cardinal(@CxE_POLYDIFF3));
   CALLC;
 end
 else
 if TM = _Single then
 begin
   //if ND = 1 then MOVCadr(Cardinal(@CxS_POLYDIFF1)) else
   //if ND = 2 then MOVCadr(Cardinal(@CxS_POLYDIFF2)) else
   //if ND = 3 then MOVCadr(Cardinal(@CxS_POLYDIFF3));
   CALLC;
 end
 else
 if TM = _Integer then
 begin
   if ND = 1 then MOVCadr(Cardinal(@CxI_POLYDIFF1)) else
   if ND = 2 then MOVCadr(Cardinal(@CxI_POLYDIFF2)) else
   if ND = 3 then MOVCadr(Cardinal(@CxI_POLYDIFF3));
   CALLC;
 end;
 }
 CheckStack(4);
 CheckStack(-4);
end;



end;





procedure TForevalH.IPWRSGN_C;
var
t1,N,NF,S,tma,tva: Integer;
AdrA: Cardinal;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S; }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;



if GNode^.AI = 0 then        //(-1)^(Real,Complex)
begin
 LoadArg1;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
  // отключена начиная с {.361}.
  if t1 = T_Real then     // (-1)^Real -> (-1)^Trunc(Real)
  begin
    //PUSHCW;    {.227}
    //FLDCW(TAddress(@FCW1));
    MEM:=WriteDataA(0,_Integer);
    FISTP(MEM);
    //POPCW;    {.227}  //FLDCW(TAddress(@FCW2));
    MOVMA(MEM);
    {.191}
    //fld1
    AddWord($D9,$E8);
   //and eax,1
    AddByte($83);AddByte($E0);AddByte($01);
    //jz +$2
    AddWord($74,$02);
    //fchs
    AddWord($D9,$E0);
    {MOVBadr(Cardinal(@R_IPWRSGN));
    CALLB;}
    CheckStack(1);
    CheckStack(-1);
  end
  else
  if t1 = T_Complex then
  begin
   {FLD1;
   FCHS;
   MOVAadr(Cardinal(@Z_ReCxFPWR));
   CALLA;
   CheckStack(2);
   CheckStack(-2);  }

   MOVAadr(Cardinal(@Z_IPWRSGN));    {189}
   CALLA;
   CheckStack(2);
   CheckStack(-2);
  end;
end
else
if GNode^.AI = 1 then        // (-1)^IntForm
// не работает начиная с {.361}. Перенесено в REUNEGIPWR_C
begin
 {
  GetVar(GNode^.NV1,AdrA,tva,TMA);
  MOVMA(AdrA);
 }
  LoadLineFormEAX(_Second);

  //fld1
  AddWord($D9,$E8);
  //and eax,1
  AddByte($83);AddByte($E0);AddByte($01);
  //jz +$2
  AddWord($74,$02);
  //fchs
  AddWord($D9,$E0);


  CheckStack(1);
end
else
if GNode^.AI = 2 then        // (-1+0i)^Real
begin
 LoadArg1;
 MOVAadr(Cardinal(@Z_UNeg_ReFPWR));
 CALLA;
 CheckStack(2);
 CheckStack(-1);
end;

end;





procedure TForevalH.REUNEGIPWR_C; {.361}
var
t1,N,NF,S,tma,tva: Integer;
AdrA: Cardinal;
begin


if GNode^.AI = 1 then        // (-1)^IntForm
begin
 {
  GetVar(GNode^.NV1,AdrA,tva,TMA);
  MOVMA(AdrA);
 }
  LoadLineFormEAX(_Second);

  //fld1
  AddWord($D9,$E8);
  //and eax,1
  AddByte($83);AddByte($E0);AddByte($01);
  //jz +$2
  AddWord($74,$02);
  //fchs
  AddWord($D9,$E0);


  CheckStack(1);
end;

end;







procedure TForevalH.F2PWR_C;
var
t1,N,NF,S,tma,tva: Integer;
AdrA: Cardinal;
begin
{
  При изменении функции также соответственно вносить изменения в блоке вычисления констант !!!
}
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;}

if GNode^.AI = 1 then        // 2^IntForm
begin
  LoadLineFormEAX(_Second);
  MOVBadr(Cardinal(@R_FPWR2I));
  CALLB;
  CheckStack(2);
  CheckStack(-1);
end
else
begin

 LoadArg1;
 MOVAadr(Cardinal(@R_F2PWR));    {.223}
 CALLA;
 CheckStack(2);
 CheckStack(-2);
end;

end;






procedure TForevalH.CZPWR_C;
var
t1,N,NF,S,tma,tva: Integer;
AdrA: Cardinal;
FD: Extended;
begin
//Const(Real,Complex)^(Real,Complex)

 {
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;   }

 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=GNode^.TypeA; //Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;

 if GNode^.AI = 1 then        //Const(Real)
 begin
   if t1 = T_Real then          //Const(Real)^Real
   begin
     if GNode^.FD > 0  then
     begin
        GNode^.FD1:=fc_Log2(GNode^.FD);

        FLD(WriteDataA(GNode^.FD,_Extended),_Extended);
        FLD(WriteDataA(GNode^.FD1,_Extended),_Extended);

        MOVAadr(Cardinal(@R_CR_FPWR));
        CALLA;

        CheckStack(2);
        CheckStack(-4);
     end
     else
     begin
        FLD(WriteDataA(GNode^.FD,_Extended),_Extended);
        MOVAadr(Cardinal(@FPWR));
        CALLA;
        CheckStack(2);
        CheckStack(-3);
     end;
   end
   else
   if t1 = T_Complex then       //Const(Real)^Complex
   begin
        GNode^.FD1:=fc_Ln(abs(GNode^.FD));

        FLD(WriteDataA(GNode^.FD,_Extended),_Extended);
        FLD(WriteDataA(GNode^.FD1,_Extended),_Extended);

        MOVAadr(Cardinal(@Z_CRe_CxFPWR));
        CALLA;
        CheckStack(-2);
   end;
 end
 else
 if GNode^.AI = 2 then        //Const(Complex)
 begin
    if t1 = T_Real then     //Const(Complex)^Real
    begin
        FLD(WriteDataA(arctan2_acc(GNode^.FDC.im,GNode^.FDC.re),_Extended),_Extended);
        FLD(WriteDataA(fc_ln(sqrt(sqr(GNode^.FDC.im)+sqr(GNode^.FDC.re))),_Extended),_Extended);
        FLD(WriteDataA(GNode^.FDC.im,_Extended),_Extended);
        FLD(WriteDataA(GNode^.FDC.re,_Extended),_Extended);

        MOVAadr(Cardinal(@Z_CCxRe_FPWR));
        CALLA;
        CheckStack(-3);
    end
    else
    if t1 = T_Complex then    //Const(Complex)^Complex
    begin
         FLD(WriteDataA(fc_ln(sqrt(sqr(GNode^.FDC.im)+sqr(GNode^.FDC.re))),_Extended),_Extended);
         FLD(WriteDataA(arctan2_acc(GNode^.FDC.im,GNode^.FDC.re),_Extended),_Extended);
         MOVAadr(Cardinal(@Z_CCx_CxFPWR));
         CALLA;
         CheckStack(1);
         CheckStack(-3);
    end
 end;

 SetReg(1); SetReg(2); SetReg(3); SetReg(4);
end;





procedure TForevalH.IMURZPWR_C;
var
t1,N,NF,S,tma,tva: Integer;
AdrA: Cardinal;
FD: Extended;
begin
//(+-I)^(Real,Complex)

 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];//GNode^.TypeA;

 LoadArg1;
 if t1 = T_Real then
 begin
     if GNode^.AI = 1 then
     begin

         MOVAadr(Cardinal(@Z_ImU_ReFPWR));
         CALLA;

         CheckStack(1);

     end
     else
     if GNode^.AI = 2 then
     begin
         MOVAadr(Cardinal(@Z_ImUNeg_ReFPWR));
         CALLA;

         CheckStack(1);
        //CheckStack(-4);
     end;
 end
 else
 if t1 = T_Complex then
 begin
     if GNode^.AI = 1 then
     begin

         MOVAadr(Cardinal(@Z_ImU_CxFPWR));
         CALLA;

         CheckStack(1);
         CheckStack(-1);

     end
     else
     if GNode^.AI = 2 then
     begin
         MOVAadr(Cardinal(@Z_ImUNeg_CxFPWR));
         CALLA;

         CheckStack(1);
         CheckStack(-1);
     end;
 end;


end;






procedure TForevalH.INC_C;
var
t1,N,NF,S,tv1,tm1: Integer;
adr1: Cardinal;
begin
  GetVar1({Interp[NFunc]}GNode^.NV1,adr1,tv1,tm1);
  AddWord($FF,$05);
  AddAddress(adr1);
end;



procedure TForevalH.DEC_C;
var
t1,N,NF,S,tv1,tm1: Integer;
adr1: Cardinal;
begin
  GetVar1({Interp[NFunc]}GNode^.NV1,adr1,tv1,tm1);
  AddWord($FF,$0D);
  AddAddress(adr1);
end;



procedure TForevalH.DEG_C;
var
t1,N,NF,S: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;  }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;

 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
  //fld tbyte ptr []
 AddWord($DB,$2D);
 //addr(dPI)
 AddAddress(Cardinal(@dPI));
//fmulp
 AddWord($DE,$C9);

   CheckStack(1);
   CheckStack(-1);

end;




procedure TForevalH.RAD_C;
var
t1,N,NF,S: Integer;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;}
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;

 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
  //fld tbyte ptr []
 AddWord($DB,$2D);
 //addr(dPI)
 AddAddress(Cardinal(@rPI));
//fmulp
 AddWord($DE,$C9);

   CheckStack(1);
   CheckStack(-1);

end;




procedure TForevalH.MOD_C;

   procedure MOD_EAX_2;     //EAX mod 2 -> ST(0)
   begin
     //and eax,$80000001
     AddByte($25); AddByte($01); AddByte($00); AddByte($00); AddByte($80);
     //jns +5
     AddByte($79); AddByte($05);
     //dec eax
     AddByte($48);
     //or eax,-$02
     AddByte($83); AddByte($C8); AddByte($FE);
     //inc eax
     AddByte($40);
     MEM:=WriteDataA(0,_Integer);
     MOVAM(MEM);
     FILD(MEM);

     SetReg(1);
   end;

   procedure MOD_EAX_EBX;   //EAX mod EBX -> ST(0)
   begin
     CDQ;
     IDIVB;
     MEM:=WriteDataA(0,_Integer);
     MOVDM(MEM);
     FILD(MEM);
   end;


var
t1,t2,N,NF,S,tv,tm,tv1,tv2,tm1,tm2,Num,code2,IC2: Integer;
adrV,adrV1,adrV2: TAddress;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;  }
 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;

 //Arg:=Interp[NFunc].N;
 //t1:=Alg.ExFunc[N].Func[NF].TV[0]; t2:=Alg.ExFunc[N].Func[NF].TV[1];
 //st1:=Interp[NFunc].RData[0]; st2:=Interp[NFunc].RData[1];
 //nv1:=Interp[NFunc].NV1;
 //nv2:=Interp[NFunc].NV2;

{.191}


if GNode^.AI = 0 then    //mod([S1],[S2])
begin
   {.357}
    LoadArg2Right;
    TRUNCR(R_EAX);
    TRUNCR(R_EBX);
    MOD_EAX_EBX;


   (*
   //y-[y/x]*x

   LoadArg2Right;
   AddByte($D9); AddByte($F8);   //fprem
   AddByte($DF); AddByte($E0);   //fstsw  ax
   AddByte($9E);                 //sahf
   AddByte($7A); AddByte($F9);   //jp     fprem
   AddByte($DD); AddByte($D9);   //fstp   st(1)

   SetReg(1);
   CheckStack(-1);

  *)

end
else
if GNode^.AI = 3 then      //mod(IntForm1,IntForm2)     //ok
begin
    code2:=GNode^.TA2;  IC2:=GNode^.IC2;
    if (code2 = _IntConst) and (IC2 = 2) then       //mod(IntForm1,2)
    begin
       LoadLineFormEAX(_First);
       MOD_EAX_2;
    end
    else
    begin
       LoadLineFormEAX(_Second);
       PUSHR(R_EAX);
       LoadLineFormEAX(_First);
       POPR(R_EBX);
       MOD_EAX_EBX;
    end;
end
else
if GNode^.AI = 2 then      //mod([S1],IntForm2)      //ok
begin
    LoadArg1;
    code2:=GNode^.TA2;  IC2:=GNode^.IC2;
    if (code2 = _IntConst) and (IC2 = 2) then       //mod([S1],2)
    begin
       {MEM:=WriteDataA(0,_Integer);
       FISTP(MEM);
       MOVMA(MEM);
       MOD_EAX_2;}

       {.357}
       TRUNCR(R_EAX);
       MOD_EAX_2;
    end
    else
    begin
        //LineFormN(GNode^.AIVP2,GNode^.IC2);

        {LoadLineFormEAX(_Second);
        PUSHR(R_EAX);
        MEM:=WriteDataA(0,_Integer);
        FISTP(MEM);
        MOVMA(MEM);
        POPR(R_EBX);
        MOD_EAX_EBX;}

        {.357}
        LoadLineFormEAX(_Second);
        PUSHR(R_EAX);
        TRUNCR(R_EAX);
        POPR(R_EBX);
        MOD_EAX_EBX;
    end;
end
else
if GNode^.AI = 1 then      //mod(IntForm1,[S2])    //ok
begin
        {
        //LineFormN(GNode^.AIVP1,GNode^.IC1);
        LoadLineFormEAX(_First);
        //PUSHR(R_EAX);
        MEM:=WriteDataA(0,_Integer);
        FISTP(MEM);
        MOVMB(MEM);
        MOD_EAX_EBX; }

        {.357}
        LoadLineFormEAX(_First);
        TRUNCR(R_EBX);
        MOD_EAX_EBX;
end;


 (*

if {Interp[NFunc]}GNode^.AI = 1 then   //mod(intvar,2)
begin
    GetVar({Interp[NFunc]}GNode^.NV1,adrV,tv,tm);

    MOVMA(adrV);
    //and eax,$80000001
    AddByte($25); AddByte($01); AddByte($00); AddByte($00); AddByte($80);
    //jns +5
    AddByte($79); AddByte($05);
    //dec eax
    AddByte($48);
    //or eax,-$02
    AddByte($83); AddByte($C8); AddByte($FE);
    //inc eax
    AddByte($40);
    MEM:=WriteDataA(0,_Integer);
    MOVAM(MEM);
    FILD(MEM);

    SetReg(1);
end
else
if {Interp[NFunc]}GNode^.AI = 2 then   //mod(intvar,intconst)
begin
   GetVar({Interp[NFunc]}GNode^.NV1,adrV,tv,tm);
   MOVMA(adrV);
   Num:=Trunc({Interp[NFunc]}GNode^.FD);
   MOVBnum(NUM);
   CDQ;
   IDIVB;
   MEM:=WriteDataA(0,_Integer);
   MOVDM(MEM);
   FILD(MEM);
end
else
if {Interp[NFunc]}GNode^.AI = 5 then   //mod(intvar1,intvar2)
begin
   GetVar({Interp[NFunc]}GNode^.NV1,adrV1,tv1,tm1);
   MOVMA(adrV1);
   GetVar({Interp[NFunc]}GNode^.NV2,adrV2,tv2,tm2);
   MOVMB(adrV2);
   CDQ;
   IDIVB;
   MEM:=WriteDataA(0,_Integer);
   MOVDM(MEM);
   FILD(MEM);

   {GetVar(Interp[NFunc].NV1,adrV1,tv1,tm1);
   MOVMA(adrV1);
   GetVar(Interp[NFunc].NV2,adrV2,tv2,tm2);
   CDQ;
   IDIVM(adrV2);
   MEM:=WriteDataA(0,_Integer);
   MOVDM(MEM);
   FILD(MEM);  }
end
else
if {Interp[NFunc]}GNode^.AI = 3 then   //mod(S1,2)
begin
   LoadArg1;
   MEM:=WriteDataA(0,_Integer);
   TRUNCM(MEM);
   MOVMA(MEM);

  //and eax,$80000001
    AddByte($25); AddByte($01); AddByte($00); AddByte($00); AddByte($80);
    //jns +5
    AddByte($79); AddByte($05);
    //dec eax
    AddByte($48);
    //or eax,-$02
    AddByte($83); AddByte($C8); AddByte($FE);
    //inc eax
    AddByte($40);
    MEM:=WriteDataA(0,_Integer);
    MOVAM(MEM);
    FILD(MEM);

    SetReg(1);
end
else
if {Interp[NFunc]}GNode^.AI = 4 then   //mod(stack,intconst)
begin
   LoadArg1;
   MEM:=WriteDataA(0,_Integer);
   TRUNCM(MEM);
   MOVMA(MEM);

   Num:=Trunc({Interp[NFunc]}GNode^.FD);
   MOVBnum(NUM);
   CDQ;
   IDIVB;
   MEM:=WriteDataA(0,_Integer);
   MOVDM(MEM);
   FILD(MEM);
end;

   *)

end;




  {.357}
procedure TForevalH.IDIV_C;

   procedure IDIV_EAX_2;     //EAX idiv 2 -> ST(0)
   begin

     //sar eax,1
     AddByte($D1); AddByte($F8);
     //jns +3
     AddByte($79); AddByte($03);
     //adc $00
     AddByte($83); AddByte($D0); AddByte($00);

     MEM:=WriteDataA(0,_Integer);
     MOVAM(MEM);
     FILD(MEM);
     SetReg(1);

   end;

   procedure IDIV_EAX_EBX;   //EAX div EBX -> ST(0)
   begin
     CDQ;
     IDIVB;
     MEM:=WriteDataA(0,_Integer);
     MOVREGM(R_EAX,MEM);
     FILD(MEM);
   end;


var
t1,t2,N,NF,S,tv,tm,tv1,tv2,tm1,tm2,Num,code2,IC2: Integer;
adrV,adrV1,adrV2: TAddress;
begin

 N:=GNode^.NFunc;
 NF:=GNode^.NF;
 S:=GNode^.S;



{.191}


if GNode^.AI = 0 then    //idiv([S1],[S2])
begin
    LoadArg2Right;

    FDIVRP;
    FTRUNC;

    {TRUNCR(R_EAX);
    TRUNCR(R_EBX);
    IDIV_EAX_EBX;}
end
else
if GNode^.AI = 3 then      //idiv(IntForm1,IntForm2)     //ok
begin
    code2:=GNode^.TA2;  IC2:=GNode^.IC2;
    if (code2 = _IntConst) and (IC2 = 2) then       //idiv(IntForm1,2)
    begin
       LoadLineFormEAX(_First);
       IDIV_EAX_2;
    end
    else
    begin
       LoadLineFormEAX(_Second);
       PUSHR(R_EAX);
       LoadLineFormEAX(_First);
       POPR(R_EBX);
       IDIV_EAX_EBX;
    end;
end
else
if GNode^.AI = 2 then      //idiv([S1],IntForm2)
begin
    LoadArg1;
    code2:=GNode^.TA2;  IC2:=GNode^.IC2;
    if (code2 = _IntConst) and (IC2 = 2) then       //idiv([S1],2)
    begin

       {.357}
       TRUNCR(R_EAX);
       IDIV_EAX_2;
    end
    else
    begin
        LoadLineFormEAX(_Second);
        PUSHR(R_EAX);
        TRUNCR(R_EAX);
        POPR(R_EBX);
        IDIV_EAX_EBX;
    end;
end
else
if GNode^.AI = 1 then      //idiv(IntForm1,[S2])    //ok
begin

        LoadLineFormEAX(_First);
        TRUNCR(R_EBX);
        IDIV_EAX_EBX;
end;



end;





procedure TForevalH.TRY_C;
var
k: Integer;
adr: TAddress;
begin
if TE_ADDR = 0 then
begin
   adr:=WriteDataA(CWFPU,_Integer) ;
   TE_ADDR:=adr;
end
else
   adr:=TE_ADDR;

//ECX<-addr(CWMEM);
MOVCnum(adr);

MOVAnum(Cardinal(@_MaskFPUExceptionA));
CALLA;
end;





procedure TForevalH.EXCEPTION_C;
var
k: Integer;
adr: TAddress;
begin

if TE_ADDR = 0 then
begin
   adr:=WriteDataA(CWFPU,_Integer);
   TE_ADDR:=adr;
end
else
   adr:=TE_ADDR;


//ECX<-addr(CWMEM);
MOVCnum(adr);

MOVAnum(Cardinal(@_IsFPUExceptionA));
CALLA;

CheckStack(1);

end;


procedure TForevalH.CDQ;
begin
 AddByte($99);
end;

procedure TForevalH.IDIV(N: TAddress);
begin
 AddComA($F7,$3D,N);
 SetReg(1);
 SetReg(4);
end;

procedure TForevalH.IDIVB;
begin
 AddWord($F7,$FB);
 SetReg(1);
 SetReg(2);
 SetReg(4);
end;


                           //if(x>y)
                           //if(x>y,z1,z2)
procedure TForevalH.IFNOP_C;
var
arg,N,NF,t1,t2,tf: Integer;
begin
 //IFNOP(Arg1,Arg2,cjmp(Arg4),Arg3,jmp(Arg4+),Arg4)

 //arg:=Interp[NFunc].Arg;
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 tf:=Alg.ExFunc[N].Func[NF].TypeF;
 if tf = T_Real  then CheckStack(-1) else
 if tf = T_Complex  then CheckStack(-2);}

 //t1:=Alg.ExFunc[N].Func[NF].TV[0];
 //t2:=Alg.ExFunc[N].Func[NF].TV[1];
 { = T_Real then R:=1 else
    if Alg.ExFunc[N].Func[NF].TypeF = T_Complex then R:=2; }
end;




(*
procedure TForevalH.IPWR_C;
var
t1,N,NF,S,tva,tma: Integer;
AdrA: Cardinal;
begin
 N:=Interp[NFunc]^.NFunc;
 NF:=Interp[NFunc]^.NF;
 S:=Interp[NFunc]^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];


 LoadArg1;
 if t1 = T_Real then
 begin
   if  Interp[NFunc]^.AI = 1 then
   begin
      Interp[NFunc]^.FI:=Trunc(Interp[NFunc]^.FD);
      MOVMA(Cardinal(@Interp[NFunc]^.FI));
   end
   else
   if  Interp[NFunc]^.AI = 2 then
   begin
      GetVar(Interp[NFunc]^.NV2,AdrA,tva,TMA);
      MOVMA(AdrA);
   end;
   MOVC1(Cardinal(@R_IPWR));
   CALLC;
   SetReg(4);
 end
 else
 if t1 = T_Complex then
 begin
  if  Interp[NFunc]^.AI = 1 then
   begin

   end
   else
   if  Interp[NFunc]^.AI = 2 then
   begin

   end;
 end;

end;
*)




//*****************************************************************************//
//                DIFFERENTIATION PROCEDURES  (begin)                          //
//*****************************************************************************//




procedure  TForevalH.SetDiffVar(NameDV: String);
begin
 S_DiffVar:=Copy(NameDV,1,Length(NameDV));
 //FindVar(NameDV,N_DiffVar);
end;





function TForevalH.XchNFuncFastAcc(NFunc: integer): integer;
label endp;
var
 i,XNFunc: integer;
begin
 XNFunc:=NFunc;
 for i := 0 to High(TableAccFastFunc) do
 begin
   if TableAccFastFunc[i].NFuncAcc = NFunc then
   begin
     XNFunc:=TableAccFastFunc[i].NFuncFast;
     goto endp;
   end;

 end;

 endp:
 XchNFuncFastAcc:=XNFunc;
end;



procedure TForevalH.DiffTreeP;
label endp,extf,extfwd,endf;
var
N,NCOP,nn,tr,ng,ng1,ng2,ngd1,ngd2,NP,NArg,NF,NFunc,Op,DF1,DF2,Len: Integer;
HTree,H1Tree,Chld,Prnt: PNode;
S,SD,SD1,SD2,SD3,S1,S2,S3,Sc,SE,SE1,SD1b,SD2b,S1b,S2b,SFunc,SX,SXD,Sx1,Sexpr,S1A,S2A,SB1,SB2,S1P,S2P: String;
DiffFunc: String;
fx,fx1,fx2: extended;
bnum,bnum1,bnum2,Bl,blx,bl1,bl2: boolean;
Tmp1,Tmp2: Cardinal;
answ,answ1,answ2: Integer;
begin
F_ExtFuncD:=False;


if F_SyntaxErrorCode <> 0 then goto endp;

Tree:=BeginTree; //не обязательно, т.к. чтение дерева - циклически


while Tree^.Ch <> nil do
begin
Tree:=Tree^.Ch;
end;
//COP=NOP:

while Tree^.Pr <> nil do
begin
 while Tree^.Nb <> nil  do
 begin
 Tree:=Tree^.Nb;
  while Tree^.Ch <> nil do
  begin
  Tree:=Tree^.Ch;
  end;
 //COP=NOP:
 inc(N);
end;

//COP<>NOP:
 //S:=Tree^.Expression;
 Tree:=Tree^.Pr;
 //Sexpr:=Tree^.Expression;
 S:='0';
 N:=1;
 NCOP:=Tree^.NCOP;
 CurrentDiffSubExpression:=Tree^.Expression;
 DiffFunc:=Tree^.Expression;

 HTree:=Tree^.Ch;



 Prnt:=Tree;
 NArg:=Tree^.Stack.N;
 NF:=Tree^.NF;
 NFunc:=Tree^.NFunc;

 {.327}
 //приведение в соответствие COP -> NFunc для дифф-я операций (+ - * / ^)
 //т.к. связывание типов LinkTreeData при дифф.  не выполняется
 if (Tree^.COP = _COP) then
 begin
   NCOP:=Tree^.NCOP;
   Tree.NFunc:=Alg.Opr[NCOP].NFunc;
   Tree.COP:=_Func;
   NFunc:=Tree^.NFunc;
 end;

  if F_FAST_STD_FUNC = False then   {.335} // перекодировка NFunc  _acc функций в NFunc обычных (быстрых) для оптимального дифференцирования в режиме AccFunc
  begin
    NFunc:=XchNFuncFastAcc(NFunc);
  end;

 //SFunc:=Tree^.SFunc;
 //SFunc:=Alg.ExFunc[Alg.Opr[NCOP].NFunc].Name;
 SFunc:=Alg.ExFunc[NFunc].Name;

 (*
 {.325}
 if (Tree^.COP = _LDSC) or (Tree^.COP = _LDSCX) or (Tree^.COP = _LDSF) then
 begin
     //константы и переменные продифференцированы при разборе в TreeBuilder
 end
 else {.319}
 *)
 if Tree^.COP = _Func then
 begin


      //двуаргументные операции
      if (NFunc =  CM_ADD) or (NFunc =  CM_SUB) or (NFunc =  CM_MUL) or (NFunc = CM_DIV) or (NFunc =  CM_POWER) then
      begin

        SD1:=HTree^.SDiff;           FindExternalBracketNegPS(@SD1);//FindExternalBracketN(SD1,SD1b,ngd1);
        SD2:=HTree^.Nb^.SDiff;       FindExternalBracketNegPS(@SD2);//FindExternalBracketN(SD2,SD2b,ngd2);
        S1:=HTree^.Expression;       FindExternalBracketNegPS(@S1);//FindExternalBracketN(S1,S1b,ng1);
        S2:=HTree^.Nb^.Expression;   FindExternalBracketNegPS(@S2);//FindExternalBracketN(S2,S2b,ng2);


        if (NFunc =  CM_ADD) then
        begin
           if (SD1 = '0')  and  (SD2 = '0') then  S:='0' else
           if (SD1 <> '0') and  (SD2 <> '0') then   S:=SD1+'+'+'('+SD2+')' else
           if  SD2 = '0'    then  S:=SD1 else
           if  SD1 = '0'    then  S:=SD2;
        end

        else

        if (NFunc =  CM_SUB) then
        begin
           if (SD1 = '0') and (SD2 = '0') then  S:='0' else
           if (SD1 <> '0') and (SD2 <> '0') then  S:=SD1+'-'+'('+SD2+')' else
           if SD2 = '0' then   S:=SD1 else
           if SD1 = '0' then   S:='-('+SD2+')';
        end

        else

        if (NFunc =  CM_MUL) then       //S:=S1*SD2+S2*SD1
        begin

           if (SD1 = '0') and (SD2 = '0') then  S:='0'
           else
           if SD1 = '0'  then      //S:=S1*SD2; SD1=0
           begin

             if (S1 = '0') or (SD2 = '0') then
               S:='0'
             else
             if (S1 = '1')  then
               S:='('+SD2+')'
             else
             if (S1 = '-1')  then
               S:='(-('+SD2+'))'
             else
             if (SD2 = '1')  then
              S:='('+S1+')'
             else
             if (SD2 = '-1')  then
              S:='(-('+S1+'))'
             else
             if (S1 = '1') and (SD2 = '1')  then
              S:='1'
             else
             if (S1 = '1') and (SD2 = '-1')  then
              S:='-1'
             else
             if (S1 = '-1') and (SD2 = '1')  then
              S:='-1'
             else
             if (S1 = '-1') and (SD2 = '-1')  then
              S:='1'
             else
              S:= '('+S1+')*('+SD2+')'

           end   //SD1=0
           else
           if SD2 = '0'  then              //S:=S2*SD1; SD2=0
           begin

             if (S2 = '0') or (SD1 = '0') then
              S:='0'
             else
             if (S2 = '1')  then
              S:='('+SD1+')'
             else
             if (S2 = '-1')  then
              S:='(-('+SD1+'))'
             else
             if (SD1 = '1')  then
              S:='('+S2+')'
             else
             if (SD1 = '-1')  then
              S:='(-('+S2+'))'
             else
             if (S2 = '1') and (SD1 = '1')  then
              S:='1'
             else
             if (S2 = '1') and (SD1 = '-1')  then
              S:='-1'
             else
             if (S2 = '-1') and (SD1 = '1')  then
              S:='-1'
             else
             if (S2 = '-1') and (SD1 = '-1')  then
              S:='1'
             else
              S:= '('+S2+')*('+SD1+')'

           end // SD2=0
           else      //S:=S1*SD2+S2*SD1
           begin

             if (SD1 = '1') and (SD2 = '1')  then
              S:='('+S1+')'+'+('+S2+')'
             else
             if (SD1 = '-1') and (SD2 = '1')  then
              S:='('+S1+')'+'-('+S2+')'
             else
             if (SD1 = '1') and (SD2 = '-1')  then
              S:='('+S2+')'+'-('+S1+')'
             else
             if (SD1 = '-1') and (SD2 = '-1')  then
              S:='(-('+S1+'))'+'+(-('+S2+'))'
             else
             if (SD1 = '1')  then
              S:='('+S1+')'+'*'+'('+SD2+')'+'+('+S2+')'
             else
             if (SD1 = '-1')  then
              S:='('+S1+')'+'*'+'('+SD2+')'+'-('+S2+')'
             else
             if (SD2 = '1')   then
              S:='('+S1+')'+'+('+S2+')'+'*'+'('+SD1+')'
             else
             if (SD2 = '-1')   then
              S:='('+S2+')'+'*'+'('+SD1+')'+'-('+S1+')'
             else
              S:='('+S1+')'+'*'+'('+SD2+')'+'+('+S2+')'+'*'+'('+SD1+')';

           end   //S:=S1*SD2+S2*SD1

        end

        else

        if (NFunc =  CM_DIV) then        //S:='(('+SD1+')*('+S2+')-('+SD2+')*('+S1+'))/sqr('+S2+')';
        begin

           if (SD1 = '0') and (SD2 = '0') then  S:='0'
           else
           if SD1 = '0'  then
           begin

              if (S1 = '0') or (SD2 = '0') then S:='0'
              else  //S:='-('+SD2+')*('+S1+')/sqr('+S2+')'
              begin
                 IsNumPS(@S1,fx1,bnum1);
                 IsNumPS(@SD2,fx2,bnum2);

                 if (bnum1 = true) and (bnum2 = true) then
                 begin
                    fx1:=-fx1*fx2;
                    Sx:=FloatToStr(fx1,G_FMT);
                    //Sx:=FloatToStrF(fx1, ffExponent, 20, 4, G_FMT);
                    S:='('+Sx+')/sqr('+S2+')';
                 end
                 else
                 begin
                   if (bnum2 = true) and (fx2 = 1.0) then
                      S:='-('+S1+')/sqr('+S2+')' //{.347}
                   else
                      S:='-('+SD2+')*('+S1+')/sqr('+S2+')';
                 end;
              end

           end   //SD1=0
           else
           if SD2 = '0'  then
           begin
               if (S2 = '0') or (SD1 = '0') then S:='0'
               else  //S:='('+SD1+')*('+S2+')/sqr('+S2+')'
               begin
                  IsNumPS(@SD1,fx1,bnum1);
                  IsNumPS(@S2,fx2,bnum2);

                if (bnum1 = true) and (bnum2 = true) then
                begin
                  fx1:=fx1*fx2;
                  Sx:=FloatToStr(fx1,G_FMT);
                  //Sx:=FloatToStrF(fx1, ffExponent, 20, 4, G_FMT);
                  S:='('+Sx+')/sqr('+S2+')';
                end
                else
                begin
                  if S1 = DiffVar then   S:='(1/'+'('+S2+'))'         // x/y -> 1/y  //{.209
                  else
                   S:='('+SD1+')*('+S2+')/sqr('+S2+')';
                end;
               end
           end  //SD2=0
           else
           begin
              if (SD1 = '1') then       //{.347}
              begin
                  if (SD2 = '1') then      //{.347}
                  S:='(('+S2+')-('+S1+'))/sqr('+S2+')'
                  else
                  S:='(('+S2+')-('+SD2+')*('+S1+'))/sqr('+S2+')'
              end
              else
              if (SD2 = '1') then                  //{.347}
              begin
                  S:='(('+SD1+')*('+S2+')-('+S1+'))/sqr('+S2+')';
              end
              else
              S:='(('+SD1+')*('+S2+')-('+SD2+')*('+S1+'))/sqr('+S2+')';

           end;

        end //CM_DIV
        else

        if (NFunc =  CM_POWER) then
        begin

           if SD1 = '1' then DF1:=1 else DF1:=0;
           if SD2 = '1' then DF2:=1 else DF2:=0;

           if SD2 = '0' then
           begin

             if (S2 = '0') or (SD1 = '0')  then  S:='0' else
             begin
                IsNumPS(@S2,fx,bnum);
                if bnum = true then
                begin
                   fx:=fx-1;
                   if fx = 0 then S:='('+S2+')*('+SD1+')'
                   else
                   begin
                       IsNumPS(@S2,fx1,bnum1);
                       IsNumPS(@SD1,fx2,bnum2);
                       if fx = 1  then SX:='' else SX:='^('+{FloatToStrF(fx, ffExponent, 20, 4, G_FMT)}FloatToStr(fx,G_FMT)+')';

                       if (bnum1 = true) and (bnum2 = true) then
                        S:='('+S1+')'+SX{'^('+FloatToStr(fx)+')'}+'*('+{FloatToStrF(fx1*fx2, ffExponent, 20, 4, G_FMT)}FloatToStr(fx1*fx2,G_FMT)+')'
                       else
                        S:='('+S1+')'+SX{'^('+FloatToStr(fx)+')'}+'*('+S2+')*('+SD1+')'
                   end;
                end
                else
                begin              //power(x,n-1)->power(x,n-2)

                   S3:=S2;
                  //IsNumLastP(@S3,fx,Op);
                   FindAddSubNumInArgPS(@S3,fx,answ);
                  //if (Op  = _add) or (Op = _sub) then
                   if (answ  = _num) or (answ = _const) then
                   begin

                      fx:=fx-1;
                      if fx > 0 then
                       S3:=S3+'+'+FloatToStr(fx,G_FMT)
                      else
                      if fx < 0  then
                       S3:=S3+FloatToStr(fx,G_FMT);

                      if DF1 = 1 then
                        S:='('+S1+')^('+S3+')'+'*('+S2+')'
                      else
                        S:='('+S1+')^('+S3+')'+'*('+S2+')*('+SD1+')';

                   end
                   else
                   begin

                      if DF1 = 1 then
                        S:='('+S1+')^('+S2+'-1)'+'*('+S2+')'
                      else
                        S:='('+S1+')^('+S2+'-1)'+'*('+S2+')*('+SD1+')';

                   end;

                end;
             end;

           end   //SD2=0
           else
           if SD1 = '0' then
           begin

              if SD2 = '0' then S:='0'
              else
              begin
                 if DF2 = 1 then
                 begin
                   {.356}
                   if CheckExp(@S1) = True then     //exp1^x
                    S:='('+S1+')^('+S2+')'
                   else
                    S:='('+S1+')^('+S2+')'+'*ln('+S1+')';
                 end
                 else
                 begin
                   {.356}
                   if CheckExp(@S1) = True then     //exp1^(-x)
                    S:='('+S1+')^('+S2+')*('+SD2+')'
                   else
                    S:='('+S1+')^('+S2+')*('+SD2+')*'+'ln('+S1+')'
                 end;
              end;

           end
           else
           begin
               //S:='('+S1+')^('+S2+'-1)'+'*('+S2+')*('+SD1+')+('+S1+')^('+S2+')*('+SD2+')*'+'ln('+S1+')';
               //S:='('+S1+')^('+S2+')'+'*(('+S2+')*('+SD1+')/('+S1+')+('+SD2+')*ln('+S1+'))';
              if (DF1 = 1) and (DF2 = 1) then
              begin
                 S:='('+S1+')^('+S2+')'+'*(('+S2+')/('+S1+')+'+'ln('+S1+'))';
              end
              else
                 S:='('+S1+')^('+S2+')'+'*(('+S2+')*('+SD1+')/('+S1+')+('+SD2+')*ln('+S1+'))';


           end;

        end; //CM_POWER


        goto  endf;
      end;


   //одноаргументные операции и функции:

   SD1:=HTree^.SDiff;
   S1:=HTree^.Expression;


  // if {Alg.ExFunc[Tree^.NFunc].Name}SFunc = 'neg' then S:='('+SD1+')'  else   {.301}//off
   if {SFunc = 'neg'}NFunc = CM_NEG then
   begin
     S:='-('+SD1+')' ;
     FindExternalBracketNegPS(@S);
   end
   else {.301}//on
   begin

     tr:=0;

     if  NFunc = CM_SIN    then begin SD:='cos' ; tr:=1; end  else
     if  NFunc = CM_COS    then begin SD:='-sin' ; tr:=1; end else
     if  NFunc = CM_EXP    then begin SD:='exp' ; tr:=1; end else
     if  NFunc = CM_LN     then begin SD:='1/'  ; tr:=1; end else
     if  NFunc = CM_SQR    then begin SD:='2*' ; tr:=1; end else
     if  NFunc = CM_SQRT   then begin SD:='0.5/sqrt' ; tr:=1; end else
     if  NFunc = CM_SINH   then begin SD:='cosh' ; tr:=1; end else
     if  NFunc = CM_COSH   then begin SD:='sinh';  tr:=1; end;
      {.365A} //Wrong diff for RE, IM : нужно выделить отдельно вещественную и мнимую части!
     { else
     if  NFunc = CM_RE     then begin SD:='re';  tr:=1; end else
     if  NFunc = CM_IM     then begin SD:='im';  tr:=1; end; }




     FindExternalBracketNegPS(@SD1);//FindExternalBracketN(SD1,SD1b,ngd1);
     FindExternalBracketNegPS(@S1);//FindExternalBracketN(S1,S1b,ng1);


     if tr = 1 then
     begin

        if (SD1 = '1') then
           S:=SD+'('+S1+')'
        else
        if (SD1 = '-1') then
           S:='-('+SD+'('+S1+'))'
        else
        if SD1 = '0' then
           S:='0'
        else
           S:=SD+'('+S1+')*'+'('+SD1+')';

      {if (SD1 = '1') and (ngd1 = 0) then S:=SD+'('+S1+')' else
         if (SD1 = '1') and (ngd1 = 1) then S:='-('+SD+'('+S1+'))' else
         if SD1 = '0' then  S:='0' else
         S:=SD+'('+S1+')*'+'('+SD1+')';  }

      { if (SD1b = '1') and (ngd1 = 0) then S:=SD+'('+S1+')' else
         if (SD1b = '1') and (ngd1 = 1) then S:='-('+SD+'('+S1+'))' else
         if SD1b = '0' then  S:='0' else
         S:=SD+'('+S1+')*'+'('+SD1+')';  }

     end
     else
     if {SFunc = 'tan'}NFunc = CM_TAN then
     begin
       //S:='(sqr(tan('+S1+'))+1)*'+SD1;
       if SD1 = '0' then  S:='0' else
          S:='('+SD1+')/sqr(cos('+S1+'))';
     end
     else
     if {SFunc = 'cotan'}NFunc = CM_COTAN then
     begin
       //S:='(-(sqr(cotan('+S1+'))+1))*'+SD1;
       if SD1 = '0' then  S:='0' else
          S:='-('+SD1+')/sqr(sin('+S1+'))';
     end
     else
     if {SFunc = 'arcsin'}NFunc = CM_ARCSIN then
     begin
       if SD1 = '0' then  S:='0' else
          S:='('+SD1+')/sqrt(1-sqr('+S1+'))';
     end
     else
     if {SFunc = 'arccos'}NFunc = CM_ARCCOS then
     begin
       if SD1 = '0' then  S:='0' else
          S:='-('+SD1+')/sqrt(1-sqr('+S1+'))';
     end
     else
     if {SFunc = 'arctan'}NFunc = CM_ARCTAN then
     begin
       if SD1 = '0' then  S:='0' else
          S:='('+SD1+')/(1+sqr('+S1+'))';
     end
     else
     if {SFunc = 'arccotan'}NFunc = CM_ARCCOTAN then
     begin
       if SD1 = '0' then  S:='0' else
          S:='-('+SD1+')/(1+sqr('+S1+'))';
     end
     else
     if {SFunc = 'tanh'}NFunc = CM_TANH then
     begin
       //S:='(sqr(tan('+S1+'))+1)*'+SD1;
       if SD1 = '0' then  S:='0' else
          S:='('+SD1+')/sqr(cosh('+S1+'))';
     end
     else
     if {SFunc = 'cotanh'}NFunc = CM_COTANH then
     begin
       //S:='(-(sqr(cotan('+S1+'))+1))*'+SD1;
       if SD1 = '0' then  S:='0' else
          S:='-('+SD1+')/sqr(sinh('+S1+'))';
     end
     else
     if {SFunc = 'arcsinh'}NFunc = CM_ARCSINH then
     begin
       if SD1 = '0' then  S:='0' else
          S:='('+SD1+')/sqrt(1+sqr('+S1+'))';
     end
     else
     if {SFunc = 'arccosh'}NFunc = CM_ARCCOSH then
     begin
       if SD1 = '0' then  S:='0' else
          S:='('+SD1+')/sqrt(sqr('+S1+')-1)';
     end
     else
     if {SFunc = 'arctanh'}NFunc = CM_ARCTANH then
     begin
       if SD1 = '0' then  S:='0' else
          S:='('+SD1+')/(sqr('+S1+')-1)';
     end
     else
     if {SFunc = 'arccotanh'}NFunc = CM_ARCCOTANH then
     begin
       if SD1 = '0' then  S:='0' else
          S:='('+SD1+')/(1-sqr('+S1+'))';
     end
     else
     if {SFunc = 'sec'}NFunc = CM_SEC then
     begin
       if SD1 = '0' then  S:='0' else
          S:='('+SD1+')*(sin('+S1+')/(sqr(cos('+S1+'))))';
     end
     else
     if {SFunc = 'cosec'}NFunc = CM_COSEC then
     begin
       if SD1 = '0' then  S:='0' else
          S:='-('+SD1+')*(cos('+S1+')/(sqr(sin('+S1+'))))';
     end
     else
     if {SFunc = 'arcsec'} NFunc = CM_ARCSEC then
     begin
       if SD1 = '0' then  S:='0' else
          S:='('+SD1+')/((sqr('+S1+')*(sqrt(1-1/sqr('+S1+')))))';
     end
     else
     if {SFunc = 'arccosec'}NFunc = CM_ARCCOSEC then
     begin
       if SD1 = '0' then  S:='0' else
          S:='-('+SD1+')/((sqr('+S1+')*(sqrt(1-1/sqr('+S1+')))))';
     end
     else
     if {SFunc = 'sech'}NFunc = CM_SECH then
     begin
       if SD1 = '0' then  S:='0' else
          S:='-('+SD1+')*(sinh('+S1+')/(sqr(cosh('+S1+'))))';
     end
     else
     if {SFunc = 'cosech'}NFunc = CM_COSECH then
     begin
       if SD1 = '0' then  S:='0' else
          S:='-('+SD1+')*(cosh('+S1+')/(sqr(sinh('+S1+'))))';
     end
     else
     if {SFunc = 'arcsech'}NFunc = CM_ARCSECH then
     begin
       if SD1 = '0' then  S:='0' else
          S:='-('+SD1+')/(('+S1+')*('+S1+'+1)*sqrt((1-('+S1+'))/('+S1+'+1)))';
     end
     else
     if {SFunc = 'arccosech'}NFunc = CM_ARCCOSECH then
     begin
       if SD1 = '0' then  S:='0' else
          S:='-('+SD1+')/((sqr('+S1+')*(sqrt(1+1/sqr('+S1+')))))';
     end
     else
     if {SFunc = 'log2'}NFunc = CM_LOG2 then
     begin
       if SD1 = '0' then  S:='0' else
          S:='('+SD1+')/(('+S1+')*ln2)';
     end
     else
     if {SFunc = 'log10'}NFunc = CM_LOG10 then
     begin
       if SD1 = '0' then  S:='0' else
          S:='('+SD1+')/(('+S1+')*ln10)';
     end
     else
     if  {SFunc = 'abs'}NFunc = CM_ABS then
     begin
       if SD1 = '0' then  S:='0' else
          S:='('+SD1+')*sign('+S1+')'
     end
     else
     if  {SFunc = 'fact'}NFunc = CM_FACT then
         S:='0'
         else
     if  {SFunc = 'fact2'}NFunc = CM_FACT2 then
         S:='0'
     else
      {
     if  NFunc = CM_RAND then      //SFunc = 'rand'
         S:='0'
     else
     }
     if  {SFunc = 'trunc'}NFunc = CM_TRUNC then
         S:='0'
     else
     if  {SFunc = 'frac'}NFunc = CM_FRAC then
         S:='1'
     else
     if  {SFunc = 'sign'}NFunc = CM_SIGN then
         S:='0'
     else
     if NFunc = CM_DEG then      {.365A}
     begin
        if SD1 = '0' then  S:='0'      else
        if SD1 = '1' then  S:='180/pi' else
                           S:='('+SD1+')*(180/pi)';
     end
     else
     if NFunc = CM_RAD then     {.365A}
     begin
        if SD1 = '0' then  S:='0'      else
        if SD1 = '1' then  S:='pi/180' else
                           S:='('+SD1+')*(pi/180)';
     end
     else
     if {SFunc = 'log'}NFunc = CM_LOGN then
     begin

       SD2:=HTree^.Nb^.SDiff;
       S2:=HTree^.Nb^.Expression;

       FindExternalBracketNegPS(@SD2);
        if (SD1 = '0') and (SD2 = '0') then
          S:='0'
        else
        if SD1 = '0' then
          S:='('+SD2+')/(('+S2+')*ln('+S1+'))'
        else
        if SD2 = '0' then
          S:='-(('+SD1+')*'+'ln('+S2+'))/(('+S1+')*sqr(ln('+S1+')))'
        else
          S:='('+SD2+')/(('+S2+')*ln('+S1+'))'+'-(('+SD1+')*'+'ln('+S2+'))/(('+S1+')*sqr(ln('+S1+')))';

     end
     else
     if {SFunc = 'arctan2'}NFunc = CM_ARCTAN2 then               {.209}
     begin
       {S1:=HTree^.Expression;
       SD1:=HTree^.SDiff;}

       S2:=HTree^.Nb^.Expression;
       SD2:=HTree^.Nb^.SDiff;
       FindExternalBracketNegPS(@SD2);

        //arctan2(F1/F2)'=
       // (F1'*F2-F1*F2')/(sqr(F2)*(1+sqr(F1/F2))) = (F1'-F2'*(F1/F2))/(F2*(1+sqr(F1/F2)))

       //S:='(('+SD1+')*('+S2+')-('+S1+')*('+SD2+'))/(sqr('+S2+')*(1+sqr(('+S1+')/('+S2+'))))';
       //S:='(('+SD1+')'+'-(('+SD2+')*(('+S1+')/('+S2+'))))/(('+S2+')*(1+'+'sqr(('+S1+')/('+S2+'))'+'))';


       if (SD1 = '0') and (SD2 = '0') then
         S:='0'
       else
       if SD1 = '0' then  //(-F1*F2')/(sqr(F2)*(1+sqr(F1/F2)))
         S:='(-('+S1+')*('+SD2+'))/(sqr('+S2+')*(1+sqr(('+S1+')/('+S2+'))))'
       else
       if SD2 = '0' then    // (F1'*F2)/(sqr(F2)*(1+sqr(F1/F2)))
         S:='(('+SD1+')*('+S2+'))/(sqr('+S2+')*(1+sqr(('+S1+')/('+S2+'))))'
       else
         S:='(('+SD1+')*('+S2+')-('+S1+')*('+SD2+'))/(sqr('+S2+')*(1+sqr(('+S1+')/('+S2+'))))';
         //S:='(('+SD1+')'+'-(('+SD2+')*(('+S1+')/('+S2+'))))/(('+S2+')*(1+'+'sqr(('+S1+')/('+S2+'))'+'))';

     end
     else
     if SFunc = 'gamma' then   {.211}
     begin
        if SD1 = '0' then S:='0' else
        S:='gamma('+S1+')*psi('+S1+')*('+SD1+')';
     end
     else
      if SFunc = 'lngamma' then   {.334}
     begin
        if SD1 = '0' then S:='0' else
        S:='psi('+S1+')*('+SD1+')';
     end
     else
     if SFunc = 'psi' then     {.211}
     begin
        if SD1 = '0' then S:='0' else
        S:='psid1('+S1+')*('+SD1+')';
     end
     else
     if SFunc = 'psid1' then   {.211}
     begin
        if SD1 = '0' then S:='0' else
        S:='psid2('+S1+')*('+SD1+')';
     end
     else
     if SFunc = 'psid2' then    {.211}
     begin
        if SD1 = '0' then S:='0' else
        S:='psid3('+S1+')*('+SD1+')';
     end
     else
     if SFunc = 'psid3' then    {.344}
     begin
        if SD1 = '0' then S:='0' else
        S:='polygamma('+'4,'+S1+')*('+SD1+')';
     end
     else
     if SFunc = 'besselj0' then   {.211}
     begin
        if SD1 = '0' then S:='0' else
        S:='-besselj1('+S1+')*('+SD1+')';
     end
      else
     if SFunc = 'besselj1' then   {.211}
     begin
        if SD1 = '0' then S:='0' else
        S:='(besselj0('+S1+')-besseljn(2,'+S1+'))*0.5*('+SD1+')';
     end
     else
     if SFunc = 'erf' then   {.211}
     begin
        if SD1 = '0' then S:='0' else
        S:='2*exp(-sqr('+S1+'))/sqrt(pi)';
     end

     else

     if SFunc = 'erfc' then   {.211}
     begin
        if SD1 = '0' then S:='0' else
        S:='-2*exp(-sqr('+S1+'))/sqrt(pi)';
     end

     else
     //(besseljn(k+1,x)*besseljn(k-1,x)-besseljn(k,x)*besseljn(-k,x))*(besseljn(2,x)*besseljn(1,x)-besselj0(x)*besselj1(x))
     if SFunc = 'besseljn' then    {.211}
     begin
        S1:=HTree^.Expression;
        S2:=HTree^.Nb^.Expression;
        SD1:=HTree^.SDiff;
        SD2:=HTree^.Nb^.SDiff;
        if SD2 = '0' then S:='0' else
        begin
           S3:=S1;

           //IsNumLastP(@S3,fx,Op);
           FindAddSubNumInArgPS(@S3,fx,answ);
           //if Op <> 0 then
           if (answ = _num) or (answ = _const) then
           begin

             //if Op = _num then
             if  (answ = _const) then
             begin
                fx1:=fx-1;
                fx2:=fx+1;
                if fx1 = 0 then SB1:='besselj0('+S2+')' else
                if fx1 = 1 then SB1:='besselj1('+S2+')' else
                                SB1:='besseljn('+FloatToStr(fx1)+','+S2+')';

                if fx2 = 0 then SB2:='besselj0('+S2+')' else
                if fx2 = 1 then SB2:='besselj1('+S2+')' else
                                SB2:='besseljn('+FloatToStr(fx2)+','+S2+')';

                S:='('+SB1+'-'+SB2+')*0.5*('+SD2+')';
             end
             else
             begin
               fx1:=fx-1;
               if fx1 > 0 then
                 S1A:=S3+'+'+FloatToStr(fx1,G_FMT)
               else
               if fx1 < 0  then
                 S1A:=S3+FloatToStr(fx1,G_FMT)
               else
                 S1A:=S3;


               fx2:=fx+1;
               if fx2 > 0 then
                 S1B:=S3+'+'+FloatToStr(fx2,G_FMT)
               else
               if fx2 < 0  then
                 S1B:=S3+FloatToStr(fx2,G_FMT)
               else
                 S1B:=S3;


               S:='(besseljn('+S1A+','+S2+')-besseljn('+S1B+','+S2+'))*0.5*('+SD2+')';
             end;
           end
           else
           S:='(besseljn('+S1+'-1,'+S2+')-besseljn('+S1+'+1,'+S2+'))*0.5*('+SD2+')';
        end;
     end

     else

      //(besseljv(k+1,x)*besseljv(k-1,x)-besseljv(k,x)*besseljv(-k,x))*(besseljv(2,x)*besseljv(1,x))
      //(besseljv(t+1,x)*besseljv(t-1,x)-besseljv(t,x)*besseljv(-t,x))*(besseljv(2,x)*besseljv(1.5,x)-besseljv(1,x)*besseljv(0.5,x))
     if SFunc = 'besseljv' then    {.357}
     begin
        S1:=HTree^.Expression;
        S2:=HTree^.Nb^.Expression;
        SD1:=HTree^.SDiff;
        SD2:=HTree^.Nb^.SDiff;

        if SD1 <> '0' then goto   extf; //  d/dx besseljv(F1(x),F2(x))

        if SD2 = '0' then S:='0' else
        begin
           S3:=S1;

           //IsNumLastP(@S3,fx,Op);
           FindAddSubNumInArgPS(@S3,fx,answ);
           //if Op <> 0 then
           if (answ = _num) or (answ = _const) then
           begin

             //if Op = _num then
             if  (answ = _const)   then
             begin
                begin
                   fx1:=fx-1;
                   fx2:=fx+1;
                   if fx1 = 0 then SB1:='besselj0('+S2+')' else
                   if fx1 = 1 then SB1:='besselj1('+S2+')' else
                   if Trunc(fx1)= fx1 then
                                   SB1:='besseljn('+FloatToStr(fx1,G_FMT)+','+S2+')' else
                                   SB1:='besseljv('+FloatToStr(fx1,G_FMT)+','+S2+')';


                   if fx2 = 0 then SB2:='besselj0('+S2+')' else
                   if fx2 = 1 then SB2:='besselj1('+S2+')' else
                   if Trunc(fx2)= fx2 then
                                   SB2:='besseljn('+FloatToStr(fx2,G_FMT)+','+S2+')' else
                                   SB2:='besseljv('+FloatToStr(fx2,G_FMT)+','+S2+')' ;

                   S:='('+SB1+'-'+SB2+')*0.5*('+SD2+')';
                end
             end
             else
             begin
               fx1:=fx-1;
               if fx1 > 0 then
                 S1A:=S3+'+'+FloatToStr(fx1,G_FMT)
               else
               if fx1 < 0  then
                 S1A:=S3+FloatToStr(fx1,G_FMT)
               else
                 S1A:=S3;


               fx2:=fx+1;
               if fx2 > 0 then
                 S1B:=S3+'+'+FloatToStr(fx2,G_FMT)
               else
               if fx2 < 0  then
                 S1B:=S3+FloatToStr(fx2,G_FMT)
               else
                 S1B:=S3;


               S:='(besseljv('+S1A+','+S2+')-besseljv('+S1B+','+S2+'))*0.5*('+SD2+')';
             end;
           end
           else
           S:='(besseljv('+S1+'-1,'+S2+')-besseljv('+S1+'+1,'+S2+'))*0.5*('+SD2+')';
        end;
     end


     else

     if SFunc = 'bessely0' then   {.357}
     begin
        if SD1 = '0' then S:='0' else
        S:='-bessely1('+S1+')*('+SD1+')';
     end

     else

     if SFunc = 'bessely1' then   {.357}
     begin
        if SD1 = '0' then S:='0' else
        S:='(bessely0('+S1+')-besselyn(2,'+S1+'))*0.5*('+SD1+')';
     end

     else

     //(besselyn(k+1,x)*besselyn(k-1,x)-besselyn(k,x)*besselyn(-k,x))*(besselyn(2,x)*besselyn(1,x))
     if SFunc = 'besselyn' then    {.357}
     begin
        S1:=HTree^.Expression;
        S2:=HTree^.Nb^.Expression;
        SD1:=HTree^.SDiff;
        SD2:=HTree^.Nb^.SDiff;
        if SD2 = '0' then S:='0' else
        begin
           S3:=S1;

           FindAddSubNumInArgPS(@S3,fx,answ);
           //if Op <> 0 then
           if (answ = _num) or (answ = _const) then
           begin

             if  (answ = _const) then
             //if Op = _num then
             begin
                fx1:=fx-1;
                fx2:=fx+1;
                if fx1 = 0 then SB1:='bessely0('+S2+')' else
                if fx1 = 1 then SB1:='bessely1('+S2+')' else
                                SB1:='besselyn('+FloatToStr(fx1)+','+S2+')';

                if fx2 = 0 then SB2:='bessely0('+S2+')' else
                if fx2 = 1 then SB2:='bessely1('+S2+')' else
                                SB2:='besselyn('+FloatToStr(fx2)+','+S2+')';

                S:='('+SB1+'-'+SB2+')*0.5*('+SD2+')';
             end
             else
             begin
               fx1:=fx-1;
               if fx1 > 0 then
                 S1A:=S3+'+'+FloatToStr(fx1,G_FMT)
               else
               if fx1 < 0  then
                 S1A:=S3+FloatToStr(fx1,G_FMT)
               else
                 S1A:=S3;


               fx2:=fx+1;
               if fx2 > 0 then
                 S1B:=S3+'+'+FloatToStr(fx2,G_FMT)
               else
               if fx2 < 0  then
                 S1B:=S3+FloatToStr(fx2,G_FMT)
               else
                 S1B:=S3;


               S:='(besselyn('+S1A+','+S2+')-besselyn('+S1B+','+S2+'))*0.5*('+SD2+')';
             end;
           end
           else
           S:='(besselyn('+S1+'-1,'+S2+')-besselyn('+S1+'+1,'+S2+'))*0.5*('+SD2+')';

           //S:='(besselyn('+S1+'-1,'+S2+')-besselyn('+S1+'+1,'+S2+'))*0.5*('+SD2+')';
        end;
     end

     else

       //(besselyv(k+1,x)*besselyv(k-1,x)-besselyv(k,x)*besselyv(-k,x))*(besselyv(2,x)*besselyv(1,x))
       //(besselyv(t+1,x)*besselyv(t-1,x)-besselyv(t,x)*besselyv(-t,x))*(besselyv(2,x)*besselyv(1.5,x)-besselyv(1,x)*besselyv(0.5,x))
     if SFunc = 'besselyv' then    {.357}
     begin
        S1:=HTree^.Expression;
        S2:=HTree^.Nb^.Expression;
        SD1:=HTree^.SDiff;
        SD2:=HTree^.Nb^.SDiff;

        if SD1 <> '0' then goto   extf; //  d/dx besselyv(F1(x),F2(x))

        if SD2 = '0' then S:='0' else
        begin
           S3:=S1;

           //IsNumLastP(@S3,fx,Op);
           FindAddSubNumInArgPS(@S3,fx,answ);
           //if Op <> 0 then
           if (answ = _num) or (answ = _const) then
           begin

             //if Op = _num then
             if  (answ = _const)   then
             begin
                begin
                   fx1:=fx-1;
                   fx2:=fx+1;
                   if fx1 = 0 then SB1:='bessely0('+S2+')' else
                   if fx1 = 1 then SB1:='bessely1('+S2+')' else
                   if Trunc(fx1)= fx1 then
                                   SB1:='besselyn('+FloatToStr(fx1,G_FMT)+','+S2+')' else
                                   SB1:='besselyv('+FloatToStr(fx1,G_FMT)+','+S2+')';


                   if fx2 = 0 then SB2:='bessely0('+S2+')' else
                   if fx2 = 1 then SB2:='bessely1('+S2+')' else
                   if Trunc(fx2)= fx2 then
                                   SB2:='besselyn('+FloatToStr(fx2,G_FMT)+','+S2+')' else
                                   SB2:='besselyv('+FloatToStr(fx2,G_FMT)+','+S2+')' ;

                   S:='('+SB1+'-'+SB2+')*0.5*('+SD2+')';
                end
             end
             else
             begin
               fx1:=fx-1;
               if fx1 > 0 then
                 S1A:=S3+'+'+FloatToStr(fx1,G_FMT)
               else
               if fx1 < 0  then
                 S1A:=S3+FloatToStr(fx1,G_FMT)
               else
                 S1A:=S3;


               fx2:=fx+1;
               if fx2 > 0 then
                 S1B:=S3+'+'+FloatToStr(fx2,G_FMT)
               else
               if fx2 < 0  then
                 S1B:=S3+FloatToStr(fx2,G_FMT)
               else
                 S1B:=S3;


               S:='(besselyv('+S1A+','+S2+')-besselyv('+S1B+','+S2+'))*0.5*('+SD2+')';
             end;
           end
           else
           S:='(besselyv('+S1+'-1,'+S2+')-besselyv('+S1+'+1,'+S2+'))*0.5*('+SD2+')';
        end;
     end

     else

     if SFunc = 'besseli0' then   {.357}
     begin
        if SD1 = '0' then S:='0' else
        S:='besseli1('+S1+')*('+SD1+')';
     end

     else

     if SFunc = 'besseli1' then   {.357}
     begin
        if SD1 = '0' then S:='0' else
        S:='(besseli0('+S1+')+besselin(2,'+S1+'))*0.5*('+SD1+')';
     end

     else

     //(besselin(k+1,x)*besselin(k-1,x)-besselin(k,x)*besselin(-k,x))*(besselin(2,x)*besselin(1,x))
     if SFunc = 'besselin' then    {.357}
     begin
        S1:=HTree^.Expression;
        S2:=HTree^.Nb^.Expression;
        SD1:=HTree^.SDiff;
        SD2:=HTree^.Nb^.SDiff;
        if SD2 = '0' then S:='0' else
        begin
           S3:=S1;

           FindAddSubNumInArgPS(@S3,fx,answ);
           //if Op <> 0 then
           if (answ = _num) or (answ = _const) then
           begin

             if  (answ = _const) then
             //if Op = _num then
             begin
                fx1:=fx-1;
                fx2:=fx+1;
                if fx1 = 0 then SB1:='besseli0('+S2+')' else
                if fx1 = 1 then SB1:='besseli1('+S2+')' else
                                SB1:='besselin('+FloatToStr(fx1)+','+S2+')';

                if fx2 = 0 then SB2:='besseli0('+S2+')' else
                if fx2 = 1 then SB2:='besseli1('+S2+')' else
                                SB2:='besselin('+FloatToStr(fx2)+','+S2+')';

                S:='('+SB1+'+'+SB2+')*0.5*('+SD2+')';
             end
             else
             begin
               fx1:=fx-1;
               if fx1 > 0 then
                 S1A:=S3+'+'+FloatToStr(fx1,G_FMT)
               else
               if fx1 < 0  then
                 S1A:=S3+FloatToStr(fx1,G_FMT)
               else
                 S1A:=S3;


               fx2:=fx+1;
               if fx2 > 0 then
                 S1B:=S3+'+'+FloatToStr(fx2,G_FMT)
               else
               if fx2 < 0  then
                 S1B:=S3+FloatToStr(fx2,G_FMT)
               else
                 S1B:=S3;


               S:='(besselin('+S1A+','+S2+')+besselin('+S1B+','+S2+'))*0.5*('+SD2+')';
             end;
           end
           else
           S:='(besselin('+S1+'-1,'+S2+')+besselin('+S1+'+1,'+S2+'))*0.5*('+SD2+')';


        end;
     end


     else

       //(besseliv(k+1,x)*besseliv(k-1,x)-besseliv(k,x)*besseliv(-k,x))*(besseliv(2,x)*besseliv(1,x))
       //(besseliv(t+1,x)*besseliv(t-1,x)-besseliv(t,x)*besseliv(-t,x))*(besseliv(2,x)*besseliv(1.5,x)-besseliv(1,x)*besseliv(0.5,x))
     if SFunc = 'besseliv' then    {.357}
     begin
        S1:=HTree^.Expression;
        S2:=HTree^.Nb^.Expression;
        SD1:=HTree^.SDiff;
        SD2:=HTree^.Nb^.SDiff;

        if SD1 <> '0' then goto   extf; //  d/dx besseliv(F1(x),F2(x))

        if SD2 = '0' then S:='0' else
        begin
           S3:=S1;

           //IsNumLastP(@S3,fx,Op);
           FindAddSubNumInArgPS(@S3,fx,answ);
           //if Op <> 0 then
           if (answ = _num) or (answ = _const) then
           begin

             //if Op = _num then
             if  (answ = _const)   then
             begin
                begin
                   fx1:=fx-1;
                   fx2:=fx+1;
                   if fx1 = 0 then SB1:='besseli0('+S2+')' else
                   if fx1 = 1 then SB1:='besseli1('+S2+')' else
                   if Trunc(fx1)= fx1 then
                                   SB1:='besselin('+FloatToStr(fx1,G_FMT)+','+S2+')' else
                                   SB1:='besseliv('+FloatToStr(fx1,G_FMT)+','+S2+')';


                   if fx2 = 0 then SB2:='besseli0('+S2+')' else
                   if fx2 = 1 then SB2:='besseli1('+S2+')' else
                   if Trunc(fx2)= fx2 then
                                   SB2:='besselin('+FloatToStr(fx2,G_FMT)+','+S2+')' else
                                   SB2:='besseliv('+FloatToStr(fx2,G_FMT)+','+S2+')' ;

                   S:='('+SB1+'+'+SB2+')*0.5*('+SD2+')';
                end
             end
             else
             begin
               fx1:=fx-1;
               if fx1 > 0 then
                 S1A:=S3+'+'+FloatToStr(fx1,G_FMT)
               else
               if fx1 < 0  then
                 S1A:=S3+FloatToStr(fx1,G_FMT)
               else
                 S1A:=S3;


               fx2:=fx+1;
               if fx2 > 0 then
                 S1B:=S3+'+'+FloatToStr(fx2,G_FMT)
               else
               if fx2 < 0  then
                 S1B:=S3+FloatToStr(fx2,G_FMT)
               else
                 S1B:=S3;


               S:='(besseliv('+S1A+','+S2+')+besseliv('+S1B+','+S2+'))*0.5*('+SD2+')';
             end;
           end
           else
           S:='(besseliv('+S1+'-1,'+S2+')+besseliv('+S1+'+1,'+S2+'))*0.5*('+SD2+')';
        end;
     end

     else


     if SFunc = 'besselk0' then   {.357}
     begin
        if SD1 = '0' then S:='0' else
        S:='-besselk1('+S1+')*('+SD1+')';
     end

     else

     if SFunc = 'besselk1' then   {.357}
     begin
        if SD1 = '0' then S:='0' else
        S:='(-besselk0('+S1+')-besselkn(2,'+S1+'))*0.5*('+SD1+')';
     end

     else

      //(besselkn(k+1,x)*besselkn(k-1,x)-besselkn(k,x)*besselkn(-k,x))*(besselkn(2,x)*besselkn(1,x))
     if SFunc = 'besselkn' then    {.357}
     begin
        S1:=HTree^.Expression;
        S2:=HTree^.Nb^.Expression;
        SD1:=HTree^.SDiff;
        SD2:=HTree^.Nb^.SDiff;
        if SD2 = '0' then S:='0' else
        begin
           S3:=S1;

           FindAddSubNumInArgPS(@S3,fx,answ);
           //if Op <> 0 then
           if (answ = _num) or (answ = _const) then
           begin

             if  (answ = _const) then
             //if Op = _num then
             begin
                fx1:=fx-1;
                fx2:=fx+1;
                if fx1 = 0 then SB1:='besselk0('+S2+')' else
                if fx1 = 1 then SB1:='besselk1('+S2+')' else
                                SB1:='besselkn('+FloatToStr(fx1)+','+S2+')';

                if fx2 = 0 then SB2:='besselk0('+S2+')' else
                if fx2 = 1 then SB2:='besselk1('+S2+')' else
                                SB2:='besselkn('+FloatToStr(fx2)+','+S2+')';

                S:='(-'+SB1+'-'+SB2+')*0.5*('+SD2+')';
             end
             else
             begin
               fx1:=fx-1;
               if fx1 > 0 then
                 S1A:=S3+'+'+FloatToStr(fx1,G_FMT)
               else
               if fx1 < 0  then
                 S1A:=S3+FloatToStr(fx1,G_FMT)
               else
                 S1A:=S3;


               fx2:=fx+1;
               if fx2 > 0 then
                 S1B:=S3+'+'+FloatToStr(fx2,G_FMT)
               else
               if fx2 < 0  then
                 S1B:=S3+FloatToStr(fx2,G_FMT)
               else
                 S1B:=S3;


               S:='(-besselkn('+S1A+','+S2+')-besselkn('+S1B+','+S2+'))*0.5*('+SD2+')';
             end;
           end
           else
           S:='(-besselkn('+S1+'-1,'+S2+')-besselkn('+S1+'+1,'+S2+'))*0.5*('+SD2+')';


        end;
     end


     else


       //(besselkv(k+1,x)*besselkv(k-1,x)-besselkv(k,x)*besselkv(-k,x))*(besselkv(2,x)*besselkv(1,x))
       //(besselkv(t+1,x)*besselkv(t-1,x)-besselkv(t,x)*besselkv(-t,x))*(besselkv(2,x)*besselkv(1.5,x)-besselkv(1,x)*besselkv(0.5,x))
     if SFunc = 'besselkv' then    {.357}
     begin
        S1:=HTree^.Expression;
        S2:=HTree^.Nb^.Expression;
        SD1:=HTree^.SDiff;
        SD2:=HTree^.Nb^.SDiff;

        if SD1 <> '0' then goto   extf; //  d/dx besselkv(F1(x),F2(x))

        if SD2 = '0' then S:='0' else
        begin
           S3:=S1;

           //IsNumLastP(@S3,fx,Op);
           FindAddSubNumInArgPS(@S3,fx,answ);
           //if Op <> 0 then
           if (answ = _num) or (answ = _const) then
           begin

             //if Op = _num then
             if  (answ = _const)   then
             begin
                begin
                   fx1:=fx-1;
                   fx2:=fx+1;
                   if fx1 = 0 then SB1:='besselk0('+S2+')' else
                   if fx1 = 1 then SB1:='besselk1('+S2+')' else
                   if Trunc(fx1)= fx1 then
                                   SB1:='besselkn('+FloatToStr(fx1,G_FMT)+','+S2+')' else
                                   SB1:='besselkv('+FloatToStr(fx1,G_FMT)+','+S2+')';


                   if fx2 = 0 then SB2:='besselk0('+S2+')' else
                   if fx2 = 1 then SB2:='besselk1('+S2+')' else
                   if Trunc(fx2)= fx2 then
                                   SB2:='besselkn('+FloatToStr(fx2,G_FMT)+','+S2+')' else
                                   SB2:='besselkv('+FloatToStr(fx2,G_FMT)+','+S2+')' ;

                   S:='(-'+SB1+'-'+SB2+')*0.5*('+SD2+')';
                end
             end
             else
             begin
               fx1:=fx-1;
               if fx1 > 0 then
                 S1A:=S3+'+'+FloatToStr(fx1,G_FMT)
               else
               if fx1 < 0  then
                 S1A:=S3+FloatToStr(fx1,G_FMT)
               else
                 S1A:=S3;


               fx2:=fx+1;
               if fx2 > 0 then
                 S1B:=S3+'+'+FloatToStr(fx2,G_FMT)
               else
               if fx2 < 0  then
                 S1B:=S3+FloatToStr(fx2,G_FMT)
               else
                 S1B:=S3;


               S:='(-besselkv('+S1A+','+S2+')-besselkv('+S1B+','+S2+'))*0.5*('+SD2+')';
             end;
           end
           else
           S:='(-besselkv('+S1+'-1,'+S2+')-besselkv('+S1+'+1,'+S2+'))*0.5*('+SD2+')';
        end;
     end

     else


     //sphbesseljn(3,x^2)*sphbesseljn(n+2,x^3)-sphbesseljn(1,x^2)*sphbesseljn(2,x^2)
     if SFunc = 'sphbesseljn' then    {.211}
     begin
        S1:=HTree^.Expression;
        S2:=HTree^.Nb^.Expression;
        SD1:=HTree^.SDiff;
        SD2:=HTree^.Nb^.SDiff;

        if SD2 = '0' then S:='0' else
        begin
          S3:=S1;
          FindAddSubNumInArgPS(@S3,fx,answ);
          if answ = _none then
          begin
             S:='(sphbesseljn('+S1+'-1,'+S2+')-sphbesseljn('+S1+','+S2+')*('+S1+'+1)/('+S2+'))*('+SD2+')';
          end
          else
          begin
            if answ = _const then
            begin
               if fx = 0 then         // (x*cos(x)-sin(x))/sqr(x)
                 S:='(('+S2+')*cos('+S2+')-sin('+S2+'))/sqr('+S2+')*('+SD2+')'
                 else
               if fx = 1 then          // ((x^2-2)*sin(x)+2*x*cos(x))/x^3
                S:='((sqr('+S2+')-2)*sin('+S2+')+2*('+S2+')*cos('+S2+'))/power('+S2+',3)*('+SD2+')'
                 else
               if fx = 2 then        //((4*sqr(x)-9)*sin(x)+x*(9-sqr(x))*cos(x))/sqr(sqr(x))
                S:='((4*sqr('+S2+')-9)*sin('+S2+')+('+S2+')*(9-sqr('+S2+'))*cos('+S2+'))/sqr(sqr('+S2+'))*('+SD2+')'
                  else
                S:='(sphbesseljn('+FloatToStr(fx-1)+','+S2+')-sphbesseljn('+S1+','+S2+')*('+FloatToStr(fx+1)+')/('+S2+'))*('+SD2+')';
            end
            else
            if answ = _num then
            begin
               fx:=fx-1;

               if fx > 0 then
                 S1A:=S3+'+'+FloatToStr(fx,G_FMT)
               else
               if fx < 0  then
                 S1A:=S3+FloatToStr(fx,G_FMT)
               else
                 S1A:=S3;

                S:='(sphbesseljn('+S1A+','+S2+')-sphbesseljn('+S1+','+S2+')*('+S1+'+1)/('+S2+'))*('+SD2+')';
            end;

          end;

        end;

        (*
        if SD2 = '0' then S:='0' else
        begin
          if TryStrToInt(S1,NP) = true then
          begin
             if NP = 0 then
               S:='(('+S2+')*cos('+S2+')-sin('+S2+'))/sqr('+S2+')*('+SD2+')'
             else
             if NP = 1 then
               S:='((sqr('+S2+')-2)*sin('+S2+')+2*('+S2+')*cos('+S2+'))/power('+S2+',3)*('+SD2+')'
             else
               S:='(sphbesseljn('+IntToStr(NP-1)+','+S2+')-sphbesseljn('+S1+','+S2+')*('+IntToStr(NP+1)+')/('+S2+'))*('+SD2+')';
          end
          else
          S:='(sphbesseljn('+S1+'-1,'+S2+')-sphbesseljn('+S1+','+S2+')*('+S1+'+1)/('+S2+'))*('+SD2+')';
       end;
       *)


     end

     else

    {.357}
    //sphbesselyn(3,x^2)*sphbesselyn(n+2,x^3)-sphbesselyn(1,x^2)*sphbesselyn(2,x^2)
     if SFunc = 'sphbesselyn' then
     begin
        S1:=HTree^.Expression;
        S2:=HTree^.Nb^.Expression;
        SD1:=HTree^.SDiff;
        SD2:=HTree^.Nb^.SDiff;

        if SD2 = '0' then S:='0' else
        begin
          S3:=S1;
          FindAddSubNumInArgPS(@S3,fx,answ);
          if answ = _none then
          begin
             S:='(sphbesselyn('+S1+'-1,'+S2+')-sphbesselyn('+S1+','+S2+')*('+S1+'+1)/('+S2+'))*('+SD2+')';
          end
          else
          begin
            if answ = _const then
            begin
               if fx = 0 then      //   (x*sin(x)+cos(x))/x^2
                 S:='(('+S2+')*sin('+S2+')+cos('+S2+'))/sqr('+S2+')*('+SD2+')'
                 else
               if fx = 1 then       //  ((2-x^2)*x*cos(x)+2*x^2*sin(x))/sqr(x^2)
                S:='((2-sqr('+S2+'))*('+S2+')*cos('+S2+')+2*sqr('+S2+')*sin('+S2+'))/sqr(sqr('+S2+'))*('+SD2+')'
                 else
               if fx = 2 then      // (x*(9-sqr(x))*sin(x)+(9-4*sqr(x))*cos(x))/sqr(sqr(x))
                S:='(('+S2+')*(9-sqr('+S2+'))*sin('+S2+')+(9-4*sqr('+S2+'))*cos('+S2+'))/sqr(sqr('+S2+'))*('+SD2+')'
                 else
                S:='(sphbesselyn('+FloatToStr(fx-1)+','+S2+')-sphbesselyn('+S1+','+S2+')*('+FloatToStr(fx+1)+')/('+S2+'))*('+SD2+')';
            end
            else
            if answ = _num then
            begin
               fx:=fx-1;

               if fx > 0 then
                 S1A:=S3+'+'+FloatToStr(fx,G_FMT)
               else
               if fx < 0  then
                 S1A:=S3+FloatToStr(fx,G_FMT)
               else
                 S1A:=S3;

                S:='(sphbesselyn('+S1A+','+S2+')-sphbesselyn('+S1+','+S2+')*('+S1+'+1)/('+S2+'))*('+SD2+')';
            end;

          end;

        end;


     end

     else

     //(legendrep(j+1,x^2)-legendrep(j-1,x^2))*(legendrep(-j,x^2)-legendrep(-1-j,x^2))
     //(legendrep(j+1,x^2)-legendrep(j-1,x^2))*(legendrep(-j,x^2)-legendrep(-1-j,x^2))/((legendrep(1,x^2)-legendrep(-1,x^2))*(legendrep(3,x^2)-legendrep(9,x^2)))

     if (SFunc = 'legendrep') and (NArg = 2) then    {.211}
     begin
       S1:=HTree^.Expression;
       S2:=HTree^.Nb^.Expression;
       SD1:=HTree^.SDiff;
       SD2:=HTree^.Nb^.SDiff;

       if SD2 = '0' then S:='0' else
       begin
           S3:=S1;
           FindAddSubNumInArgPS(@S3,fx,answ);
           if answ = _none then
           begin
              S:='('+S1+')/(1-sqr('+S2+'))*(legendrep('+S1+'-1,'+S2+')-('+S2+')*legendrep('+S1+','+S2+'))*('+SD2+')';
             //P'(n,x)=n/(1-x^2)*(P(n-1,x)-x*P(n,x))*SD1
           end
           else
           if answ = _const then
           begin
               if fx = 0 then S:='0' else
               if fx = 1 then S:=SD2 else
               if fx = 2 then S:='3*('+S2+')*('+SD2+')' else
               if fx = 3 then S:='1.5*(5*sqr('+S2+')-1)*('+SD2+')' else
               if fx = 4 then S:='2.5*('+S2+')*(7*sqr('+S2+')-3)*('+SD2+')' else
               if fx = 5 then S:='1.875*(21*power('+S2+',4)-14*sqr('+S2+')+1)*('+SD2+')' else
               if fx = 6 then S:='2.625*('+S2+')*(33*power('+S2+',4)-30*sqr('+S2+')+5)*('+SD2+')' else
               if fx = 7 then S:='0.4375*(429*power('+S2+',6)-495*power('+S2+',4)+135*sqr('+S2+')-5)*('+SD2+')' else
               S:='('+FloatToStr(fx)+')/(1-sqr('+S2+'))*(legendrep('+FloatToStr(fx-1)+','+S2+')-('+S2+')*legendrep('+FloatToStr(fx)+','+S2+'))*('+SD2+')';
               //P'(n,x)=n/(1-x^2)*(P(n-1,x)-x*P(n,x))*SD2
           end
           else
           if answ = _num then
           begin
               AddNumToStrPS(@S3,fx-1,S1A);
               S:='('+S1+')/(1-sqr('+S2+'))*(legendrep('+S1A+','+S2+')-('+S2+')*legendrep('+S1+','+S2+'))*('+SD2+')';
           end


       end;


       (*
       if SD2 = '0' then S:='0' else
        begin
          if TryStrToInt(S1,NP) = true then
          begin
            if NP = 0 then S:='0' else
            if NP = 1 then S:=SD2 else
            if NP = 2 then S:='3*('+S2+')*('+SD2+')' else
            if NP = 3 then S:='1.5*(5*sqr('+S2+')-1)*('+SD2+')' else
            if NP = 4 then S:='2.5*('+S2+')*(7*sqr('+S2+')-3)*('+SD2+')' else
            if NP = 5 then S:='1.875*(21*power('+S2+',4)-14*sqr('+S2+')+1)*('+SD2+')' else
            if NP = 6 then S:='2.625*('+S2+')*(33*power('+S2+',4)-30*sqr('+S2+')+5)*('+SD2+')' else
            if NP = 7 then S:='0.4375*(429*power('+S2+',6)-495*power('+S2+',4)+135*sqr('+S2+')-5)*('+SD2+')' else
            S:='('+IntToStr(NP)+')/(1-sqr('+S2+'))*(legendrep('+IntToStr(NP-1)+','+S2+')-('+S2+')*legendrep('+IntToStr(NP)+','+S2+'))*('+SD2+')';
            //P'(n,x)=n/(1-x^2)*(P(n-1,x)-x*P(n,x))*SD2

          end
          else
          S:='('+S1+')/(1-sqr('+S2+'))*(legendrep('+S1+'-1,'+S2+')-('+S2+')*legendrep('+S1+','+S2+'))*('+SD2+')';
          //P'(n,x)=n/(1-x^2)*(P(n-1,x)-x*P(n,x))*SD1
        end;
        *)

     end

     else
     //legendrep(j-1,k+1,x^2)*legendrep(j,k+1,x^2)-legendrep(5,k+1,x^2)*legendrep(6,k+1,x^2)
     if (SFunc = 'legendrep') and (NArg = 3) then    {.211}
     begin
      //  P'(n,m,x) = ((n-m+1)*P(n+1,m,x)-(n+1)*x*P(n,m,x))/(x^2-1)*SD3

       S1:=HTree^.Expression;
       S2:=HTree^.Nb^.Expression;
       S3:=HTree^.Nb^.Nb^.Expression;
       SD1:=HTree^.SDiff;
       SD2:=HTree^.Nb^.SDiff;
       SD3:=HTree^.Nb^.Nb^.SDiff;
       if SD3 = '0' then S:='0' else
       begin
          S1P:=S1;
          FindAddSubNumInArgPS(@S1P,fx,answ);
          if answ = _none then
          begin
             S:='(('+S1+'-('+S2+')+1)*legendrep('+S1+'+1,'+S2+','+S3+')-('+S1+'+1)*('+S3+')*legendrep('+S1+','+S2+','+S3+'))/(sqr('+S3+')-1)*('+SD3+')';
          end
          else
          if answ = _const then
          begin
            S:='(('+S1+'-('+S2+')+1)*legendrep('+FloatToStr(fx+1)+','+S2+','+S3+')-('+FloatToStr(fx+1)+')*('+S3+')*legendrep('+S1+','+S2+','+S3+'))/(sqr('+S3+')-1)*('+SD3+')';
          end
          else
          if answ = _num then
          begin
             AddNumToStrPS(@S1P,fx+1,S1A);
             S:='(('+S1+'-('+S2+')+1)*legendrep('+S1A+','+S2+','+S3+')-('+S1A+')*('+S3+')*legendrep('+S1+','+S2+','+S3+'))/(sqr('+S3+')-1)*('+SD3+')';
          end;

        end;

     end

     else
    //(chebt(k,x^2)*chebt(j+1,x^2)-chebt(k+1,x^2)*chebt(j,x^2))/chebt(-k,x^2)-chebt(-1-j,x^2)/(chebt(7,x^2)*chebt(9,x^2)-chebt(3,x^2)*chebt(2,x^2))
     if (SFunc = 'chebyshevt')  then    {.211}
     begin
     //T'(n,x)=n*U(n-1,x)*SD2
     // T(n,x):    T'(n=0)=0 ;  T'(n=1)=1*SD2 ; T'(n=2)=4*x*SD2 ;  T'(n=3)=(12*x^2-3)*SD2 ;   U'(n=4)=16*x*(2*x^2-1)*SD2 ;


       S1:=HTree^.Expression;
       S2:=HTree^.Nb^.Expression;
       SD1:=HTree^.SDiff;
       SD2:=HTree^.Nb^.SDiff;

       if SD2 = '0' then S:='0' else
       begin
           S1P:=S1;
           FindAddSubNumInArgPS(@S1P,fx,answ);
           if answ = _none then
           begin
               S:='('+S1+')*chebyshevu('+S1+'-1,'+S2+')*('+SD2+')';
           end
           else
           if answ = _const then
           begin
               if fx = 0 then S:='0' else
               if fx = 1 then S:=SD2 else
               if fx = 2 then S:='4*('+S2+')*('+SD2+')' else
               if fx = 3 then S:='(12*sqr('+S2+')-3)*('+SD2+')' else
               if fx = 4 then S:='16*('+S2+')*(2*sqr('+S2+')-1)*('+SD2+')' else
               if fx = 5 then S:='(80*power('+S2+',4)-60*sqr('+S2+')+5)*('+SD2+')' else
               if fx = 6 then S:='12*('+S2+')*(16*power('+S2+',4)-16*sqr('+S2+')+3)*('+SD2+')' else
               if fx = 7 then S:='7*(64*power('+S2+',6)-80*power('+S2+',4)+24*sqr('+S2+')-1)*('+SD2+')' else
                              S:='('+FloatToStr(fx)+')*chebyshevu('+FloatToStr(fx-1)+','+S2+')*('+SD2+')';
           end
           else
           if answ = _num then
           begin
               AddNumToStrPS(@S1P,fx-1,S1A);
               S:='('+S1+')*chebyshevu('+S1A+','+S2+')*('+SD2+')';
           end;

       end;
      (*
       if SD2 = '0' then S:='0' else
        begin
          if TryStrToInt(S1,NP) = true then
          begin
            if NP = 0 then S:='0' else
            if NP = 1 then S:=SD2 else
            if NP = 2 then S:='4*('+S2+')*('+SD2+')' else
            if NP = 3 then S:='(12*sqr('+S2+')-3)*('+SD2+')' else
            if NP = 4 then S:='16*('+S2+')*(2*sqr('+S2+')-1)*('+SD2+')' else
            if NP = 5 then S:='(80*power('+S2+',4)-60*sqr('+S2+')+5)*('+SD2+')' else
            if NP = 6 then S:='12*('+S2+')*(16*power('+S2+',4)-16*sqr('+S2+')+3)*('+SD2+')' else
            if NP = 7 then S:='7*(64*power('+S2+',6)-80*power('+S2+',4)+24*sqr('+S2+')-1)*('+SD2+')' else
            S:='('+IntToStr(NP)+')*chebyshevu('+IntToStr(NP-1)+','+S2+')*('+SD2+')';
          end
          else
          S:='('+S1+')*chebyshevu('+S1+'-1,'+S2+')*('+SD2+')';
        end;
       *)

     end

     else
     //(chebu(k,x^2)*chebu(j+1,x^2)-chebu(k+1,x^2)*chebu(j,x^2))/chebu(-k,x^2)-chebu(-1-j,x^2)/(chebu(7,x^2)*chebu(9,x^2)-chebu(3,x^2)*chebu(2,x^2))
     if (SFunc = 'chebyshevu')  then    {.211}
     begin

     //U'(n,x)=(n*x*U(n,x)-(n+1)*U(n-1,x))/(x^2-1)*SD2


       S1:=HTree^.Expression;
       S2:=HTree^.Nb^.Expression;
       SD1:=HTree^.SDiff;
       SD2:=HTree^.Nb^.SDiff;

       if SD2 = '0' then S:='0' else
       begin
           S1P:=S1;
           FindAddSubNumInArgPS(@S1P,fx,answ);
           if answ = _none then
           begin
                S:='(('+S1+')*('+S2+')*chebyshevu('+S1+','+S2+')-('+S1+'+1'+')*chebyshevu('+S1+'-1,'+S2+'))/(sqr('+S2+')-1)*('+SD2+')';
           end
           else
           if answ = _const then
           begin
               if fx = 0 then S:='0' else
               if fx = 1 then S:='2*('+SD2+')' else
               if fx = 2 then S:='8*('+S2+')*('+SD2+')' else
               if fx = 3 then S:='(24*sqr('+S2+')-4)*('+SD2+')' else
               if fx = 4 then S:='8*('+S2+')*(8*sqr('+S2+')-3)*('+SD2+')' else
               if fx = 5 then S:='(160*power('+S2+',4)-96*sqr('+S2+')+6)*('+SD2+')' else
               if fx = 6 then S:='16*('+S2+')*(24*power('+S2+',4)-20*sqr('+S2+')+3)*('+SD2+')' else
               if fx = 7 then S:='(896*power('+S2+',6)-960*power('+S2+',4)+240*sqr('+S2+')-8)*('+SD2+')' else
                              S:='(('+FloatToStr(fx)+')*('+S2+')*chebyshevu('+FloatToStr(fx)+','+S2+')-('+FloatToStr(fx+1)+')*chebyshevu('+FloattoStr(fx-1)+','+S2+'))/(sqr('+S2+')-1)*('+SD2+')';
           end
           else
           if answ = _num then
           begin
              AddNumToStrPS(@S1P,fx-1,S1A);
              S:='(('+S1+')*('+S2+')*chebyshevu('+S1+','+S2+')-('+S1+'+1'+')*chebyshevu('+S1A+','+S2+'))/(sqr('+S2+')-1)*('+SD2+')';
           end;
       end;

       (*
       if SD2 = '0' then S:='0' else
        begin
          if TryStrToInt(S1,NP) = true then
          begin
            if NP = 0 then S:='0' else
            if NP = 1 then S:='2*('+SD2+')' else
            if NP = 2 then S:='8*('+S2+')*('+SD2+')' else
            if NP = 3 then S:='(24*sqr('+S2+')-4)*('+SD2+')' else
            if NP = 4 then S:='8*('+S2+')*(8*sqr('+S2+')-3)*('+SD2+')' else
            if NP = 5 then S:='(160*power('+S2+',4)-96*sqr('+S2+')+6)*('+SD2+')' else
            if NP = 6 then S:='16*('+S2+')*(24*power('+S2+',4)-20*sqr('+S2+')+3)*('+SD2+')' else
            if NP = 7 then S:='(896*power('+S2+',6)-960*power('+S2+',4)+240*sqr('+S2+')-8)*('+SD2+')' else
            S:='(('+IntToStr(NP)+')*('+S2+')*chebyshevu('+IntToStr(NP)+','+S2+')-('+IntToStr(NP+1)+')*chebyshevu('+IntToStr(NP-1)+','+S2+'))/(sqr('+S2+')-1)*('+SD2+')';
          end
          else
          S:='(('+S1+')*('+S2+')*chebyshevu('+S1+','+S2+')-('+S1+'+1'+')*chebyshevu('+S1+'-1,'+S2+'))/(sqr('+S2+')-1)*('+SD2+')';
        end;
       *)

     end

     else
      //(herp(k,x^2)*herp(j+1,x^2)-herp(k+1,x^2)*herp(j,x^2))/herp(-k+3,x^2)-herp(-1+j,x^2)/(herp(7,x^2)*herp(9,x^2)-herp(3,x^2)*herp(2,x^2))
     if (SFunc = 'hermitep')  then    {.211}
     begin

     //H'(n,x)=2*n*H(n-1,x)*SD2

       S1:=HTree^.Expression;
       S2:=HTree^.Nb^.Expression;
       SD1:=HTree^.SDiff;
       SD2:=HTree^.Nb^.SDiff;

       if SD2 = '0' then S:='0' else
       begin
           S1P:=S1;
           FindAddSubNumInArgPS(@S1P,fx,answ);
           if answ = _none then
           begin
               S:='2*'+'('+S1+')*hermitep('+S1+'-1,'+S2+')*('+SD2+')';
           end
           else
           if answ = _const then
           begin
               if fx = 0 then S:='0' else
               if fx = 1 then S:='2*('+SD2+')' else
               if fx = 2 then S:='8*('+S2+')*('+SD2+')' else
               if fx = 3 then S:='(24*sqr('+S2+')-12)*('+SD2+')' else
               if fx = 4 then S:='32*('+S2+')*(2*sqr('+S2+')-3)*('+SD2+')' else
               if fx = 5 then S:='(160*power('+S2+',4)-480*sqr('+S2+')+120)*('+SD2+')' else
               if fx = 6 then S:='96*('+S2+')*(4*power('+S2+',4)-20*sqr('+S2+')+15)*('+SD2+')' else
               if fx = 7 then S:='(896*power('+S2+',6)-6720*power('+S2+',4)+10080*sqr('+S2+')-1680)*('+SD2+')' else
                              S:='2*'+'('+FloatToStr(fx)+')*hermitep('+FloatToStr(fx-1)+','+S2+')*('+SD2+')';
           end
           else
           if answ = _num then
           begin
               AddNumToStrPS(@S1P,fx-1,S1A);
               S:='2*'+'('+S1+')*hermitep('+S1A+','+S2+')*('+SD2+')';
           end;

       end;

       (*
       if SD2 = '0' then S:='0' else
        begin
          if TryStrToInt(S1,NP) = true then
          begin
            if NP = 0 then S:='0' else
            if NP = 1 then S:='2*('+SD2+')' else
            if NP = 2 then S:='8*('+S2+')*('+SD2+')' else
            if NP = 3 then S:='(24*sqr('+S2+')-12)*('+SD2+')' else
            if NP = 4 then S:='32*('+S2+')*(2*sqr('+S2+')-3)*('+SD2+')' else
            if NP = 5 then S:='(160*power('+S2+',4)-480*sqr('+S2+')+120)*('+SD2+')' else
            if NP = 6 then S:='96*('+S2+')*(4*power('+S2+',4)-20*sqr('+S2+')+15)*('+SD2+')' else
            if NP = 7 then S:='(896*power('+S2+',6)-6720*power('+S2+',4)+10080*sqr('+S2+')-1680)*('+SD2+')' else
            S:='2*'+'('+IntToStr(NP)+')*hermitep('+IntToStr(NP-1)+','+S2+')*('+SD2+')';
          end
          else
          S:='2*'+'('+S1+')*hermitep('+S1+'-1,'+S2+')*('+SD2+')';
        end;
       *)
     end

      else

     if (SFunc = 'laguerrep') and (NArg = 2) then    {.211}
     begin
     //L(n,x)'=-L(n-1,1,x)*SD2

       S1:=HTree^.Expression;
       S2:=HTree^.Nb^.Expression;
       SD1:=HTree^.SDiff;
       SD2:=HTree^.Nb^.SDiff;

       if SD2 = '0' then S:='0' else
       begin
           S1P:=S1;
           FindAddSubNumInArgPS(@S1P,fx,answ);
           if answ = _none then
           begin
               S:='-laguerrep('+S1+'-1,1,'+S2+')*('+SD2+')';
           end
           else
           if answ = _const then
           begin
               if fx = 0 then S:='0' else
               if fx = 1 then S:='-('+SD2+')' else
               if fx = 2 then S:='('+S2+'-2)*('+SD2+')' else
               if fx = 3 then S:='(-0.5*sqr('+S2+')+3*('+S2+')-3)*('+SD2+')' else
               if fx = 4 then S:='(power('+S2+',3)/6-2*sqr('+S2+')+6*('+S2+')-4)*('+SD2+')' else
               if fx = 5 then S:='(-power('+S2+',4)/24+5*power('+S2+',3)/6-5*sqr('+S2+')+10*('+S2+')-5)*('+SD2+')' else
               if fx = 6 then S:='(power('+S2+',5)/120-0.25*power('+S2+',4)+2.5*power('+S2+',3)-10*sqr('+S2+')+15*('+S2+')-6)*('+SD2+')' else
               if fx = 7 then S:='(-power('+S2+',6)/720+power('+S2+',5)*7/120-power('+S2+',4)*7/8+power('+S2+',3)*35/6-17.5*sqr('+S2+')+21*('+S2+')-7)*('+SD2+')' else
                              S:='-laguerrep('+FloatToStr(fx-1)+',1,'+S2+')*('+SD2+')';

           end
           else
           if answ = _num then
           begin
              AddNumToStrPS(@S1P,fx-1,S1A);
              S:='-laguerrep('+S1A+',1,'+S2+')*('+SD2+')';
           end;

       end;


       (*
       if SD2 = '0' then S:='0' else
        begin

          if TryStrToInt(S1,NP) = true then
          begin
            if NP = 0 then S:='0' else
            if NP = 1 then S:='-('+SD2+')' else
            if NP = 2 then S:='('+S2+'-2)*('+SD2+')' else
            if NP = 3 then S:='(-0.5*sqr('+S2+')+3*('+S2+')-3)*('+SD2+')' else
            if NP = 4 then S:='(power('+S2+',3)/6-2*sqr('+S2+')+6*('+S2+')-4)*('+SD2+')' else
            if NP = 5 then S:='(-power('+S2+',4)/24+5*power('+S2+',3)/6-5*sqr('+S2+')+10*('+S2+')-5)*('+SD2+')' else
            if NP = 6 then S:='(power('+S2+',5)/120-0.25*power('+S2+',4)+2.5*power('+S2+',3)-10*sqr('+S2+')+15*('+S2+')-6)*('+SD2+')' else
            if NP = 7 then S:='(-power('+S2+',6)/720+power('+S2+',5)*7/120-power('+S2+',4)*7/8+power('+S2+',3)*35/6-17.5*sqr('+S2+')+21*('+S2+')-7)*('+SD2+')' else

            S:='-laguerrep('+IntToStr(NP-1)+',1,'+S2+')*('+SD2+')';
          end
          else
           S:='-laguerrep('+S1+'-1,1,'+S2+')*('+SD2+')';
        end;
        *)

     end

     else
     // (lagp(k,n,x^2)*lagp(k+1,n+2,x^2)-lagp(k-1,n+1,x^2)*lagp(k-2,n-1,x^2))*(lagp(3,n,x^2)*lagp(k,2,x^2)-lagp(3,4,x^2)*lagp(4,3,x^2))
      if (SFunc = 'laguerrep') and (NArg = 3) then    {.211}
     begin
      //  L'(n,m,x) = -L(n-1,m+1,x)*SD3

       S1:=HTree^.Expression;
       S2:=HTree^.Nb^.Expression;
       S3:=HTree^.Nb^.Nb^.Expression;
       SD1:=HTree^.SDiff;
       SD2:=HTree^.Nb^.SDiff;
       SD3:=HTree^.Nb^.Nb^.SDiff;

       if SD3 = '0' then S:='0' else
       begin
           S1P:=S1;   S2P:=S2;
           FindAddSubNumInArgPS(@S1P,fx1,answ1);
           FindAddSubNumInArgPS(@S2P,fx2,answ2);

           if answ1 = _none then
           begin
                if answ2 = _none then
                begin
                  S:='(-laguerrep('+S1+'-1,'+S2+'+1,'+S3+'))*('+SD3+')';
                end
                else
                if answ2 = _const then
                begin
                   S:='(-laguerrep('+S1+'-1,'+FloatToStr(fx2+1)+','+S3+'))*('+SD3+')';
                end
                else
                if answ2 = _num then
                begin
                    AddNumToStrPS(@S2P,fx2+1,S2A);
                    S:='(-laguerrep('+S1+'-1,'+S2A+','+S3+'))*('+SD3+')';
                end;

           end
           else
           if answ1 = _const then
           begin
                if answ2 = _none then
                begin
                  S:='(-laguerrep('+FloatToStr(fx1-1)+','+S2+'+1,'+S3+'))*('+SD3+')';
                end
                else
                if answ2 = _const then
                begin
                   S:='(-laguerrep('+FloatToStr(fx1-1)+','+FloatToStr(fx2+1)+','+S3+'))*('+SD3+')';
                end
                else
                if answ2 = _num then
                begin
                    AddNumToStrPS(@S2P,fx2+1,S2A);
                    S:='(-laguerrep('+FloatToStr(fx1-1)+','+S2A+','+S3+'))*('+SD3+')';
                end;
           end
           else
           if answ1 = _num then
           begin
               AddNumToStrPS(@S1P,fx1-1,S1A);
               if answ2 = _none then
                begin
                  S:='(-laguerrep('+S1A+','+S2+'+1,'+S3+'))*('+SD3+')';
                end
                else
                if answ2 = _const then
                begin
                   S:='(-laguerrep('+S1A+','+FloatToStr(fx2+1)+','+S3+'))*('+SD3+')';
                end
                else
                if answ2 = _num then
                begin
                    AddNumToStrPS(@S2P,fx2+1,S2A);
                    S:='(-laguerrep('+S1A+','+S2A+','+S3+'))*('+SD3+')';
                end;
           end;

       end;
       (*
       if SD3 = '0' then S:='0' else
       begin
           S:='(-laguerrep('+S1+'-1,'+S2+'+1,'+S3+'))*('+SD3+')';
       end;
       *)

     end

     else

     if SFunc = 'polygamma' then    {.344}
     begin
        // d/dx polygamma(n,F(x)) -> polygamma(n+1,F(x))*d/dx(F(x))

        S1:=HTree^.Expression;
        S2:=HTree^.Nb^.Expression;
        SD1:=HTree^.SDiff;
        SD2:=HTree^.Nb^.SDiff;
        if SD2 = '0'  then S:='0' else
        if SD1 <> '0' then goto   extf    //{.356} polygamma(F1(x),F2(x)) Must be error! so that polygamma(const, var)
        else
        begin

           S1P:=S1;
           FindAddSubNumInArgPS(@S1P,fx,answ);
           if answ = _none then
           begin
               S:='polygamma('+S1+'+1,'+S2+')*('+SD2+')';
           end
           else
           if answ = _const then
           begin
               S:='polygamma('+FloatToStr(Trunc(fx+1))+','+S2+')*('+SD2+')';
           end
           else
           if answ = _num then
           begin
              AddNumToStrPS(@S1P,Trunc(fx+1),S1A);
              S:='polygamma('+S1A+','+S2+')*('+SD2+')';
           end;

        end;
     end

     else

     if (SFunc = 'gammaincl') or (SFunc = 'gammaincu') then    {.356}
     begin

        {
        d/dx gammaincl(a,F(x))= exp(-F(x))*power(F(x),a-1)*d/dx(F(x))
        d/dx gammaincu(a,F(x))= -exp(-F(x))*power(F(x),a-1)*d/dx(F(x))
        }

        S1:=HTree^.Expression;
        S2:=HTree^.Nb^.Expression;
        SD1:=HTree^.SDiff;
        SD2:=HTree^.Nb^.SDiff;

        if SD2 = '0'  then S:='0' else
        if SD1 <> '0' then goto   extf    //{.356} gammaincu(F1(x),F2(x))   gammaincl(F1(x),F2(x))
        else
        begin

          if SFunc = 'gammaincu' then
            S:='-exp(-('+S2+'))*power('+S2+','+S1+'-1)*'+SD2
          else
          if SFunc = 'gammaincl' then
            S:='exp(-('+S2+'))*power('+S2+','+S1+'-1)*'+SD2

        end;

     end

     else

     if (SFunc = 'gammaincln') or (SFunc = 'gammaincun') then    {.356}
     begin

        {
        d/dx gammaincln(a,F(x))= exp(-F(x))*power(F(x),a-1)/gamma(a)*d/dx(F(x))
        d/dx gammaincun(a,F(x))= -exp(-F(x))*power(F(x),a-1)/gamma(a)*d/dx(F(x))
        }

        S1:=HTree^.Expression;
        S2:=HTree^.Nb^.Expression;
        SD1:=HTree^.SDiff;
        SD2:=HTree^.Nb^.SDiff;

        if SD2 = '0'  then S:='0' else
        if SD1 <> '0' then goto   extf    //{.356} gammaincun(F1(x),F2(x))   gammaincln(F1(x),F2(x))
        else
        begin

          if SFunc = 'gammaincun' then
            S:='-exp(-('+S2+'))*power('+S2+','+S1+'-1)/gamma('+S1+')*'+SD2
          else
          if SFunc = 'gammaincln' then
            S:='exp(-('+S2+'))*power('+S2+','+S1+'-1)/gamma('+S1+')*'+SD2

        end;

     end

     else

     if (SFunc = 'gammaincinvln') or (SFunc = 'gammaincinvun') then    {.356}
     begin
        //d/dx gammainv(a,F(x))=Gamma(a)*(exp(gammainv(a,F(x))))*power(gammainv(a,F(x)),1-a)*dF(x)/dx

        {
        d/dx gammaincinvun(a,F(x))= -Gamma(a)*(exp(gammaincinvun(a,F(x))))*power(gammaincinvun(a,F(x)),1-a)*dF(x)/dx
        d/dx gammaincinvln(a,F(x))= Gamma(a)*(exp(gammaincinvln(a,F(x))))*power(gammaincinvln(a,F(x)),1-a)*dF(x)/dx
        }


        S1:=HTree^.Expression;
        S2:=HTree^.Nb^.Expression;
        SD1:=HTree^.SDiff;
        SD2:=HTree^.Nb^.SDiff;

        if SD2 = '0'  then S:='0' else
        if SD1 <> '0' then goto   extf    //{.356} gammaincinvln(F1(x),F2(x))   gammaincinvun(F1(x),F2(x))
        else
        begin

          if SFunc = 'gammaincinvun' then
            S:='-exp('+DiffFunc+')*power('+DiffFunc+',1-'+S1+')*gamma('+S1+')*'+SD2
          else
          if SFunc = 'gammaincinvln' then
            S:='exp('+DiffFunc+')*power('+DiffFunc+',1-'+S1+')*gamma('+S1+')*'+SD2

        end;

     end

     else


     if SFunc = 'polynom' then             //poly(vd,x); poly(vd,sin(x)/x)
     begin
        {
        S1:=HTree^.Expression;
        S2:=HTree^.Nb^.Expression;
        if S2 <> DiffVar then goto extf;   //poly(vd,y); poly(vd,f(x))
        S:='polynomdiff('+S1+','+S2+','+'1)'
        }
         {.213}
          {
           S1:=HTree^.Expression;
           S2:=HTree^.Nb^.Expression;
           SD2:=HTree^.Nb^.SDiff;
           //if S2 <> DiffVar then goto extf;   //poly(vd,y); poly(vd,f(x))
           if SD2 = '0' then S:='0' else
           begin
             if SD2 = '1' then
               S:='polynomdiff('+S1+','+S2+','+'1)'
             else
               S:='polynomdiff('+S1+','+S2+','+'1)*('+SD2+')';
           end;
         }
         {.223}
          S1:=HTree^.Expression;
          S2:=HTree^.Nb^.Expression;
          bl1:=IsArray(S1);
          bl2:=IsArray(S2);

          if (NArg = 2) and ((bl1=true) or (bl2 = true)) then
          begin
             if bl1 = true then
             begin
                SD2:=HTree^.Nb^.SDiff;
                //if S2 <> DiffVar then goto extf;   //poly(vd,x); poly(vd,f(x))
                if SD2 = '0' then S:='0' else
                begin
                  if SD2 = '1' then
                    S:='polynomdiff('+S1+','+S2+','+'1)'
                  else
                    S:='polynomdiff('+S1+','+S2+','+'1)*('+SD2+')';
                end;
             end
             else           //poly(x,vd); poly(f(x),vd)
             begin
                SD2:=HTree^.SDiff;
                //if S2 <> DiffVar then goto extf;   //poly(vd,x); poly(vd,f(x))
                if SD2 = '0' then S:='0' else
                begin
                  if SD2 = '1' then
                    S:='polynomdiff('+S2+','+S1+','+'1)'
                  else
                    S:='polynomdiff('+S2+','+S1+','+'1)*('+SD2+')';
                end;
             end;

          end
          else     //poly(1,2,3,4,5,6,7,x)     poly(x,1,2,3,4,5,6,7)  poly(1,2,3,4,5,6,7,f(x))  poly(f(x),1,2,3,4,5,6,7)
          begin
            if (NArg = 2) then S:='0' else
            begin
              PolyDiff(HTree,S);
            end;
          end;


     end
     else
      if SFunc = 'polynomdiff' then               //poly(vd,-sin(x)/x)/poly(ad,cos(x)/x)
     begin
        {
        S1:=HTree^.Expression;
        S2:=HTree^.Nb^.Expression;
        S3:=HTree^.Nb^.Nb^.Expression;
        if S2 <> DiffVar then goto extf;
        S3:=IntToStr(StrToInt(S3)+1);
        S:='polynomdiff('+S1+','+S2+','+S3+')';
        }
        {.213}
        S1:=HTree^.Expression;
        S2:=HTree^.Nb^.Expression;
        S3:=HTree^.Nb^.Nb^.Expression;
        SD2:=HTree^.Nb^.SDiff;
        //if S2 <> DiffVar then goto extf;
        if SD2 = '0' then S:='0' else
        begin
          S3:=IntToStr(StrToInt(S3)+1);
          if SD2 = '1' then
           S:='polynomdiff('+S1+','+S2+','+S3+')'
           else
           S:='polynomdiff('+S1+','+S2+','+S3+')*('+SD2+')';
        end;
     end
     else
     if {SFunc = 'root'}NFunc = CM_ROOT then
     begin
       S1:=HTree^.Expression;
       S2:=HTree^.Nb^.Expression;
       SD1:=HTree^.SDiff;
       SD2:=HTree^.Nb^.SDiff;
       FindExternalBracketNegPS(@SD2);

       if (SD2 = '0') and (SD1 = '0') then
       begin
        S:='0';
       end
       else
       if SD2 = '0' then     //root(func,number)
       begin
        //S:='('+S1+')^(1/('+S2+')-1)'+'*('+SD1+')/('+S2+')'

          FindExternalBracketNegPS(@S2);
          blx:=false;

          IsNumPS(@S2,fx,blx);
          {.203}
           (*
          if TryStrToFloat(S2,fx,G_FMT) = true then
          begin
            //fx:=StrToFloat(Sx,G_FMT);
            if ng = 1 then fx:=-fx;
          end
          else
          blx:=true;
          *)

          if blx = false then      //root(func,argi)
          begin
            //S:='('+SD1+')*'+'root(power('+S1+',1-('+S2+')),'+S2+')'+'/('+S2+')';
            //S:='('+SD1+')/(('+S2+')*root(power('+S1+','+S2+'-1),'+S2+'))';
            S:='('+SD1+')/(('+S1+')*('+S2+'))*root('+S1+','+S2+')';            {.209}
          end
          else                    //root(func,num)
          begin
            Sx:=FloatToStr(fx,G_FMT);
            //Sx:=FloatToStrF(fx, ffExponent, 20, 4, G_FMT);
            Sx1:=FloatToStr(fx-1,G_FMT);
            //Sx1:=FloatToStrF(fx-1, ffExponent, 20, 4, G_FMT);
            if fx-1 = 1 then   S:='('+SD1+')/(('+Sx+')*root('+S1+','+Sx+'))'
            else
            //S:='('+SD1+')/(('+Sx+')*root(power('+S1+','+Sx1+'),'+Sx+'))';
            S:='('+SD1+')/(('+S1+')*('+Sx+'))*root('+S1+','+Sx+')';            {.209}


            {Sx1:=FloatToStr(1-fx,G_FMT);
            S:='('+SD1+')*root(power('+S1+','+Sx1+'),'+Sx+')/('+Sx+')'; }
          end;

       end
       else
       if SD1 = '0' then
       begin
         //S:='-(('+S1+')^(1/('+S2+'))*('+SD2+')*'+'ln('+S1+')/sqr('+S2+'))'
         S:='-root('+S1+','+S2+')*('+SD2+')*'+'ln('+S1+')/sqr('+S2+')' ;
       end
       else  //(root(S1,S2)*SD1)/(S1*S2)-root(S1,S2)*SD2*ln(S1)/sqr(S2)
       //S:='('+S1+')^(1/('+S2+')-1)'+'*('+SD1+')/('+S2+')-('+S1+')^(1/('+S2+'))*('+SD2+')*'+'ln('+S1+')/sqr('+S2+')';
       //S:='root(power('+S1+',1-('+S2+')),'+S2+')*('+SD1+')/('+S2+')-root('+S1+','+S2+')*('+SD2+')*ln('+S1+')/sqr('+S2+')';
       S:='(root('+S1+','+S2+'))*(('+SD1+')*('+S2+')-('+S1+')*('+SD2+')*ln('+S1+'))/(('+S1+')*sqr('+S2+'))';  {.209}

       //S:=.....
     end  //sin(x)^((1-cos(x))/cos(x))-root(sin(x),cos(x))/sin(x)
          //root(sin(x),(1-cos(x))/cos(x))-power(sin(x),cos(x)/(1-cos(x)))

     else
     {if (SFunc = 'max') or (SFunc = 'min') or (SFunc = 'sum') or (SFunc = 'avr') or
        (SFunc = 'sumq') or (SFunc = 'prod') or (SFunc = 'len') then }
     if (NFunc = CM_SUM) or (NFunc = CM_AVR)  then
     begin
        if Tree^.Stack.N <= 1  then
        begin
          SD:=SD1;
        end
        else
        //if (NFunc = CM_MAX) or (NFunc = CM_MIN) or (NFunc = CM_SUM) or (NFunc = CM_AVR) then
        begin
         H1Tree:=HTree;
         SD:=H1Tree^.SDiff;
         H1Tree:=H1Tree^.Nb;
         while H1Tree <> nil do
         begin
          SD:=SD+','+H1Tree^.SDiff;
          H1Tree:=H1Tree^.Nb;
         end;
        end
        {else
        goto  extf};

         S:=SFunc+'('+SD+')';
     end
     else
     if (NFunc = CM_MAX) or (NFunc = CM_MIN)  then
     begin

        if Tree^.Stack.N <= 1  then
        begin
          SD:=SD1;
        end
        else
        if Tree^.Stack.N = 2  then
        begin
          S1:=HTree^.Expression;
          S2:=HTree^.Nb^.Expression;

          SD1:=HTree^.SDiff;
          SD2:=HTree^.Nb^.SDiff;
          //SD:=SD1+','+SD2;

          if (NFunc = CM_MAX) then  S:='iff('+S1+'>'+S2+','+SD1+','+SD2+')'
          else
          if (NFunc = CM_MIN) then  S:='iff('+S1+'<'+S2+','+SD1+','+SD2+')';

        end
        else
        goto  extf;

     end
     else
     if {SFunc = 'if'}NFunc = CM_IF then                 //ifnop->if {.243}
     begin
      case Tree^.tif of
       7: Sc:='=';
       6: Sc:='>=';
       5: Sc:='=<';
       4: Sc:='<';
       3: Sc:='>';
       2: Sc:='<>';
      end;

       if Tree^.cif = 0 then  S:='0' else
       if Tree^.cif = 1 then
       begin
         S1:=HTree^.Expression;
         S2:=HTree^.Nb^.Expression;
         SD1:=HTree^.Nb^.Nb^.Nb^.SDiff;
         S:='if('+S1+Sc+S2+','+SD1+')';
       end
       else
       if Tree^.cif = 2 then
       begin
         S1:=HTree^.Expression;
         S2:=HTree^.Nb^.Expression;
         SD1:=HTree^.Nb^.Nb^.Nb^.SDiff;
         SD2:=HTree^.Nb^.Nb^.Nb^.Nb^.Nb^.SDiff;
         S:='if('+S1+Sc+S2+','+SD1+','+SD2+')';
       end;
     end
     else
     {if SFunc = '@@external' then  goto extfwd
     else }
     begin
     extf:       //external functions:

         //if all derivatives of arguments = 0, then derivative of function = 0:
         {.211}
         if CheckForZeroNode(HTree) = True then
         begin
           S:='0';
           goto endf;
         end;

         {.211}
         //with diff template:
         //ограничение версии 9.0-9.1; шаблон дифференцирования задаётся ОДИН на все overload ф-ии и прописывается в первую ф-ию:  {.327}
         if  Alg.ExFunc[NFunc].Func[0].DFTmpl = _YES {Alg.ExFunc[NFunc].Func[NF].DFTmpl = _YES} then
         begin
          //NArg:=Tree^.Stack.N;
          ReplaceDiffTeplate(Tree,S);
          goto endf;
         end;
         {
         if  Alg.ExFunc[Tree^.NFunc].DFTmpl = _YES then
         begin
          //NArg:=Tree^.Stack.N;
          ReplaceDiffTeplate(Tree,S);
          goto endf;
         end;
         }


        //with derivatives as external func(x):
       {
        SE:=Tree^.Expression;
        FindExternalBracket(SE,SE);
        }
        Sexpr:=Tree^.Expression;
        DelExternalBracketAP(@Sexpr);

        ExtDiffFunc(SExpr,SXD,Bl);     //find derivatives

        if Bl = true  then
        begin

          FindExternalBracketNeg(SD1,SD1b,ngd1);

          if SD1b = '0'  then  S:='0' else
           if (SD1b = '1') and (ngd1 = 0) then S:=SXD+'('+HTree^.Expression+')'
            else
             if (SD1b = '1') and (ngd1 = 1) then S:='(-('+SXD+'('+HTree^.Expression+')))'
              else S:=SXD+'('+HTree^.Expression+')*('+SD1+')';


        end
        else


        begin  //without derivatives. All other  functions with unknown names: (numiric diff. only on one var.)
         extfwd:  //@@external:

           {
           SE1:=Copy(SE,1,5);
           if SE1 = '@diff' then
           begin
             S:=HTree^.Expression;
             nn:=StrToInt(HTree^.Nb^.Expression);
             inc(nn);
             S:='@diff('+S+','+IntToStr(nn)+','+DiffVar+')';
           end
           else
           S:='@diff('+Tree^.Expression+',1,'+DiffVar+')';
           }

           {.215}      //make possible numeric diff.of many var.
          { Sexpr:=Tree^.Expression;
           DelExternalBracketAP(@Sexpr);
           SE1:=Copy(Sexpr,1,5);
            }

            {.345}
           (*
           SE1:=Copy(Sexpr,1,5);
           if SE1 = '@diff' then
           begin
             S1:=HTree^.Expression;
             S2:=HTree^.Nb^.Expression;
             S3:=HTree^.Nb^.Nb^.Expression;
             nn:=StrToInt(HTree^.Nb^.Expression);
             inc(nn);
             if S3 = DiffVar then S:='@diff('+S1+','+IntToStr(nn)+','+DiffVar+')'
             else
             begin
                S:='@diff('+Sexpr{Tree^.Expression}+',1,'+DiffVar+')';
             end;
           end
           else
           S:='@diff('+Sexpr{Tree^.Expression}+',1,'+DiffVar+')';
           *)


           {.347}
           Len:=Length(DiffNumFunc);
           SE1:=Copy(Sexpr,1,Len+1);    // #diff(
           if SE1 = DiffNumFunc+'(' then
           begin
             S1:=HTree^.Expression;
             S2:=HTree^.Nb^.Expression;
             S3:=HTree^.Nb^.Nb^.Expression;
             nn:=StrToInt(HTree^.Nb^.Expression);
             inc(nn);
             if S3 = DiffVar then S:=DiffNumFunc+'('+S1+','+IntToStr(nn)+','+DiffVar+')'
             else
             begin
                S:=DiffNumFunc+'('+Sexpr+',1,'+DiffVar+')';
             end;
           end
           else
           S:=DiffNumFunc+'('+Sexpr+',1,'+DiffVar+')';



        end;

        F_ExtFuncD:=True;


      end;



   end;
 end;



endf:

   HTree:=HTree^.Nb;
   while HTree <> nil do
   begin
    HTree:=HTree^.Nb;
   end;





 //Tree^.SDiff:=S;


 //NC:=Tree^.NCOP;

 //if NC = 5 then S:='-('+S+')';  {.301} //off
 //S:='('+S+')';

 //DelExternalBracketAP(@S);     {.301}

 Tree^.SDiff:=S;


 //освобождает память,занимаемую вытекающими узлами (более не нужными)для уменьшения захвата памяти
 FreeChld(Prnt);


end;


S:=Tree^.SDiff;
S_DiffString:=S;


endp:
end;






procedure TForevalH.DiffExpressionN(Expr: String; N: Integer; var SDiff: String);
label endp;
var
NS: Cardinal;
S,SD: String;
i: integer;
begin

S:=Expr;

PrevTreat(S,S);

if F_SyntaxErrorCode = 0 then
begin

  for i := 0 to N-1 do
  begin
   if F_SyntaxErrorCode = 0 then  DiffExtExpression(S,S) else goto endp;
  end;

end;


SDiff:=S;
endp:
end;


procedure TForevalH.DiffExtExpression(SExpr: String;  var SDiff: String);
label endp;
var
 S:String;
 Siu,Sre,Sim: String;
 CommonError : Integer;
begin

//M_ParseMode:=M_Diff;   {.319}
M_ParseMode:=M_ParseDiffExpr; {.325}


if F_SubstNumCX = True then Siu:=S_IM_UNIT else Siu:='*'+S_IM_UNIT;
CheckRecoverImUnit;

S:=SExpr;

Set8087CW($1372); {.229}

//if F_StackDeep = 0 then F_SaveInFPU:=False else F_SaveInFPU:=True;   {.300} //on

Tree:=nil;
BeginTree:=nil;
F_SyntaxErrorCode:=0;
//F_CalcErrorCode:=0;
F_InternalError:=0;
F_SyntaxErrorString:=S;
F_SyntaxErrorStringA:='';
F_GotoPresent:=False;
F_IF:=False;
F_EnableCalcConstExpression:=True;
F_ComplexNumber:=False;
F_PresentVar:=False;
CurrentExpression:=Copy(S,1,Length(S));
F_ResultType:=T_Complex; {.227}
S_DiffString:='0';
F_DiffVarPresent:=False;
F_SequentList:=False;
CommonError:=0;



try

  TryCatchFPUException;    {.229}

  {.319}
  {
  TreeBuilder(S);
  LinkTreeData;        //???
  DiffTreeP;
  }

  {.325}
  TreeBuilder(S);
  if F_SyntaxErrorCode = 0 then
  begin
       //F_SyntaxErrorString:=CurrentExpression; //для ошибок ;восст. после  TreeBuilder
    //InitSequentList;      //необходимо создать лин. список для отлова ошибок при чтении в  LinkTreeData
    //LinkTreeData; {нужно для отлова ошибок и определения исполняемых функций (зависят от типа и числа аргументов): Tree^.NFunc, Tree^.nf}
    if F_SyntaxErrorCode = 0 then
    begin
     DiffTreeP;
    end;
       //F_SyntaxErrorString:=CurrentExpression; //для ошибок ;восст. после  DiffTreeP;
  end;

  //F_SequentList := False; //перед FreeTree: ссылки линейного списка недействительны т.к. части дерева при дифф. удаляются.
  //Чтение дерева только обычним способом
  FreeTree;

except
 on E: EAccessViolation do CommonError:=E_AccessViolation;
 on E: EZeroDivide      do CommonError:=E_ZeroDivide;
 on E: EInvalidOp       do CommonError:=E_InvalidOp;
 on E: EOverFlow        do CommonError:=E_OverFlow;
 on E: EUnderFlow       do CommonError:=E_UnderFlow;
 on E: EIntOverFlow     do CommonError:=E_IntOverFlow;
 on E: EAccessViolation do CommonError:=E_AccessViolation;
 on E: EOutOfMemory     do CommonError:=E_OutOfMemory;
 on E: EStackOverFlow   do CommonError:=E_StackOverFlow;
end;



{.326}
if CommonError <> 0  then
begin
  {.346}
  FreeTree;//Для случаев AV,...  Т.к. FreeTree не выполняется в try except

  F_SyntaxErrorString:=CurrentExpression;
  F_InternalError:=CommonError;
  if (F_InternalError <> 0) and (F_SyntaxErrorCode = 0) then
  begin
   if F_InternalError = E_AccessViolation then
      F_SyntaxErrorCode:=E_INTERNAL_ERROR_AT_DIFF else
      F_SyntaxErrorCode:=E_INTERNAL_ERROR_AT_CALCULATION;
  end;
end;

if F_SyntaxErrorCode <> 0 then
begin
  //IntException;
end;

if F_DiffVarPresent = False then S_DiffString:='0';


endp:
SDiff:=S_DiffString;
end;




procedure TForevalH.FindExternalBracketNeg(S: String; var SS: String; var Neg: Integer);
label
2,3,endp;
var
b,i,z,a: Integer;
begin
SS:=Copy(S,1,Length(S)); z:=1;
2:
b:=0; a:=1;

if SS = '' then
begin
goto endp;
end;


if SS[1] = '-' then a:=2;
if  SS[a] = '(' then
begin
 b:=-1;
 for i:=a+1 to Length(SS)-1 do
 begin
  if SS[i] = '(' then b:=b-1;
  if SS[i] = ')' then b:=b+1;
  if b = 0 then goto 3
 end;


if SS[Length(SS)] = ')' then
begin
if a = 2 then
begin
Delete(SS,1,1);
z:=z*(-1);
end;
Delete(SS,1,1);
Delete(SS,Length(SS),1);
goto 2;
end;
end;
3:
if z = -1 then  Neg:=1
else  Neg:=0;


endp:
end;





procedure TForevalH.FindExternalBracketNegPS(PS: PString);
label
2,3,outckl,endp;
var
b,i,j,z,a,NdelB,NDelE,L,Nbr,Nbrz,LS: Integer;
Fz: Boolean;
begin

//Упрощение выражений, обёрнутыми во множество внешних скобок
//-(((-(-((-(-(Expr)))))))) -> -(Expr)

if PS^ = ''  then goto endp;


NDelB:=0;
NDelE:=0;
NBr:=0;
NBrz:=0;
L:=Length(PS^);
z:=1;
i:=1;
//for i := 1 to Length(S)-1 do
while i <= L-1 do
begin

    if (PS^[i] = '-') and (PS^[i+1] = '(')  then
    begin
       b:=-1;
       LS:=L-NDelE;
       for j := i+2 to LS do
       begin
         if PS^[j] = '(' then b:=b-1 else
         if PS^[j] = ')' then b:=b+1;
         if (j < LS) and (b = 0)  then goto outckl;
       end;
       if b = 0 then
       begin
         NDelB:=NDelB+2;
         inc(NDelE);
         //z:=z*(-1);
         z:=-z;
         inc(NBrz);
       end
       else goto outckl;  {mast be error}
       i:=i+2;
    end
    else
    if (PS^[i] = '(')  then
    begin
       b:=-1;
       LS:=L-NDelE;
       for j := i+1 to LS do
       begin
         if PS^[j] = '(' then b:=b-1 else
         if PS^[j] = ')' then b:=b+1;
         if (j < LS) and (b = 0)  then goto outckl;
       end;
       if b = 0 then
       begin
         NDelB:=NDelB+1;
         inc(NDelE);
         inc(NBr);
       end
       else goto outckl;  {mast be error}
       i:=i+1;
    end
    else
    goto outckl;
    //inc(i);

end;

outckl:
//if (NBr <= 1)  and (NBrz = 0)  then goto endp;//  (Expr) ->  (Expr)
//if (NBrz <= 1) and (NBr = 0)   then goto endp;// -(Expr) -> -(Expr)

if (NBrz >= 1) or (NBr >= 1) then
begin
  Delete(PS^,1,NDelB);
  Delete(PS^,Length(PS^)-NDelE+1,NDelE);


  if PS^ = '' then   {.366}
  begin
    F_SyntaxErrorCode:=E_MISSING_EXPRESSION;
    goto endp;
  end;

  Fz:=False;
  if PS^[1] = '-' then
  begin
    Delete(PS^,1,1);
    //z:=z*(-1);
    Fz:=True;
  end;

  if (PS^ = '0')  then
  begin
    PS^:='0';
    goto endp;
  end
  else
  if (PS^ = '1') then
  begin
    if Fz = True then z:=-z;
    if z = -1 then PS^:='-1';
    goto endp;
  end
  else
  if (PS^ = '-1') then
  begin
    if z = -1 then PS^:='1';
    goto endp;
  end;

  if Fz = True then  PS^:='-'+PS^;
  if z = -1 then PS^:='-('+PS^+')';
  //if z = -1 then PS^:='(-('+PS^+'))';

   {
   if z = -1 then
    PS^:='(-('+PS^+'))';  }
  {
   if z = -1 then
    PS^:='(-('+PS^+'))'
   else
    PS^:='('+PS^+')';
   }

  //PS^:='('+PS^+')';
end
else
begin
  if PS^[1] = '-' then
  begin
    Delete(PS^,1,1);
    z:=z*(-1);
  end;

  if (PS^ = '0')  then
  begin
    PS^:='0';
    goto endp;
  end
  else
  if (PS^ = '1') then
  begin
    if z = -1 then PS^:='-1';
    goto endp;
  end
  else
  if (PS^ = '-1') then
  begin
    if z = -1 then PS^:='1';
    goto endp;
  end;

   //if z = -1 then  PS^:='(-('+PS^+'))';
    if z = -1 then  PS^:='-'+PS^;
end;

//PS^:='('+PS^+')';
endp:
{if (PS^ = '-0') or (PS^ = '(-0)') or (PS^ = '-(-0)') or (PS^ = '(0)') then begin PS^:='0'; z:=1;  end
else
if PS^ = '(1)' then PS^:='1';  }

{if z = -1 then  Neg:=1
else  Neg:=0; }


end;


procedure TForevalH.AddNumToStrPS(PS1: PString; fx: extended; var S1A: String);
begin
  if fx > 0 then
    S1A:=PS1^+'+'+FloatToStr(fx,G_FMT)
  else
  if fx < 0  then
    S1A:=PS1^+FloatToStr(fx,G_FMT)
  else
    S1A:=PS1^;
end;


function TForevalH.IsArray(Name: String): boolean;
var
ft,ni: Integer;
//Rb: boolean
begin
   //FindVar(Name,ni);

   FindVarPS(@Name,ni);  {.333}
   if ni <> _ABSENT then  ft :=Alg.Obj[ni].TypeF
      else  ft:=_ABSENT;


   if ft = T_Array then IsArray:=True else IsArray:=False;
end;



function   TForevalH.IsFunction(PNE: PNode): Boolean; {.329}
begin
            if (PNE^.COP = _LDSC) or (PNE^.COP = _LDSCX)  or (PNE^.COP = _LDSF)   or  (PNE^.COP = _FLD) or (PNE^.COP = _LDSA) or
               (PNE^.COP = _LDINTFORM) or (PNE^.COP = _NOP)  or (PNE^.COP = _JMP) or
               (PNE^.NFunc = CM_NEG) or (PNE^.NFunc = CM_RE)  or (PNE^.NFunc = CM_IM)  or (PNE^.NFunc = CM_LDSVX) or
               (PNE^.NFunc = CM_ADD) or (PNE^.NFunc = CM_SUB) or (PNE^.NFunc = CM_MUL) or (PNE^.NFunc = CM_DIV)
               then IsFunction:=False else IsFunction:=True;

end;





procedure  TForevalH.PolyDiff(HTree: PNode; var DP: String);
label endp;
var
H1Tree,HnTree: PNode;
SD,S1,Sn: String;
NP: integer;
ci: Extended;
fx1,fxn,fx,fxd: Extended;
bl1,bln,bl: boolean;


   function OptimizationMultiCoeff(PS: PString; var ci: Extended; var S1: String): Boolean;
   label endp;
   var
    k,rbr,L: Integer;
    blc: Boolean;
    Sc: String;
   begin

     L:=Length(PS^);
     blc:=False;
     rbr:=0;

     for k := 1 to L-1 do
     begin

        if (PS^[k] = '*') and (PS^[k+1] = '(' ) and (blc = False) then
        begin
          Sc:=Copy(PS^,1,k-1);
          //blc:=TryStrToInt(Sc,ci);
          blc:=TryStrToFloat(Sc,ci,G_FMT);     {.362}
          S1:=Copy(PS^,k+1,L-k);
          if blc = False then goto endp;
          //else  inc(rbr);
        end
        else
        if (PS^[k] = '(') then
        begin
            inc(rbr);
            if (blc = True) and (rbr = 0) then    // 2*(s+1)+(p+3)
            begin
               blc:=False;
               goto endp;
            end;
        end
        else
        if (PS^[k] = ')') then
        begin
            dec(rbr);
            if (blc = True) and (rbr = 0) then    // 2*(s+1)+(p+3)
            begin
               blc:=False;
               goto endp;
            end;
        end;

     end; //for

     if (PS^[L] = ')') and (rbr = 1) and (blc = True) then
     begin
       {OK} //dec(rbr)
     end
     else
     blc:=False;


     endp:
     OptimizationMultiCoeff:=blc;
   end;



begin


{.353}
//ERROR
//sin(x*y*t)*poly(2,a,c*t^2,d,5,e,x*y*t)+cos(x*y*t)
//poly(2,a,c*t^2,d,5,e,x*y*t)
//poly(1,2,t,3,4,5,x*y*t)
//poly(1,t,2,3,x*y*t)

//diff(10)
//poly(s,0,0,0,0,0,0,0,0,0,0,0,0,0,0,x)  !!!


H1Tree:=HTree;


SaveSW; {.229} {TryStrToFloat damage SW}



//SD:=H1Tree^.SDiff;
NP:=0;
H1Tree:=H1Tree^.Nb;
inc(NP);
while H1Tree <> nil do
begin
  //DP:=H1Tree^.Expression+','; inc(np);
  //SD:=SD+','+H1Tree^.SDiff;
  HnTree:=H1Tree;
  H1Tree:=H1Tree^.Nb;
  inc(NP);
end;

NP:=NP-2;   //степень полинома после дифф-ия (-2: dec(степень)+ посл. эл-т - VarExpr)

DP:='';
H1Tree:=HTree;

while H1Tree^.Nb^.Nb <> nil do  //до предпредпоследнего (последний - переменная(выражение VarExpr), (предпоследний - при дифф-ии уходит)
begin
     SD:=H1Tree^.SDiff;

     if SD <> '0' then    //коэфф. полинома не должны содержать переменную дифференцирования
     begin
        F_SyntaxErrorCode:=E_NO_DIFF_EXPRESSION;
        F_SyntaxErrorString:=CurrentDiffSubExpression;
        F_SyntaxErrorStringA:=Copy(H1Tree^.Expression,1,Length(H1Tree^.Expression));

        F_SyntaxErrorString:=F_SyntaxErrorString + ' depends on diff. var.  "'+S_DiffVar+'"  in : '+F_SyntaxErrorStringA;
        //goto endp;
     end;

     bl:=TryStrToFloat(H1Tree^.Expression,fx,G_FMT);
     if bl = True then
     begin
       fxd:=fx*NP;
       DP:=DP+FloatToStr(fxd,G_FMT)+',';          {.362}
     end
     else
     begin
        if NP = 1 then
           DP:=DP+H1Tree^.Expression+','
        else
        begin
           //without    OptimizationMultiCoeff:
           //DP:=DP+IntToStr(NP)+'*('+H1Tree^.Expression+')'+',';

           //with OptimizationMultiCoeff:
           if OptimizationMultiCoeff(@H1Tree^.Expression,ci,S1) = False  then
              DP:=DP+FloatToStr(NP)+'*('+H1Tree^.Expression+')'+','    else
           begin
              DP:=DP+FloatToStr(NP*ci)+'*'+S1+','
           end;


        end;

     end;

     dec(NP);
     H1Tree:=H1Tree^.Nb;
end;

DP:=DP+HnTree^.Expression; //+<VarExpr>
SD:=HnTree^.SDiff;         //diff(<VarExpr>)

if SD = '0' then DP:='0'
  else
  if SD = '1' then DP:='polynom('+DP+')'
    else  DP:='polynom('+DP+')*('+SD+')';








//{.345}
(*
H1Tree:=HTree;
np:=0;
DP:=H1Tree^.Expression+','; inc(np);
SaveSW; {.229} {TryStrToFloat damage SW}

bl1:=TryStrToFloat(H1Tree^.Expression,fx1,G_FMT);


//SD:=H1Tree^.SDiff;
H1Tree:=H1Tree^.Nb;
while H1Tree <> nil do
begin
  //DP:=H1Tree^.Expression+','; inc(np);
  //SD:=SD+','+H1Tree^.SDiff;
  HnTree:=H1Tree;
  H1Tree:=H1Tree^.Nb;
  inc(np);
end;

np:=np-2;

bln:=TryStrToFloat(HnTree^.Expression,fxn,G_FMT);


// //poly(1,2,3,x*y)   diff(x=1,y=2) ERROR!!!!!!!!!!!!
//poly(1,2,3,4,5,x/y)  diff(x=2,y=3) ERROR!!!!!!!!!!!!
if bl1 = True then    //poly(a0,..,an,<expr>) <expr>=<diffvar>, <f(diffvar)>
begin
   H1Tree:=HTree;
   //bl:=TryStrToFloat(H1Tree^.Expression,fx,G_FMT);
   {if bl = false then
   begin
     ERROR;
     goto endp;
   end;}
   fxd:=fx1*np;
   dec(np);
   DP:=FloatToStr(fxd,G_FMT)+',';//H1Tree^.Expression+','; //inc(np);
   H1Tree:=H1Tree^.Nb;
   while H1Tree^.Nb^.Nb <> nil do  //до предпредпоследнего (последний - переменная(выражение), (предпоследний - при дифф-ии уходит)
   begin
     bl:=TryStrToFloat(H1Tree^.Expression,fx,G_FMT);
       if bl = false then
       begin
        F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
        goto endp;
       end;
     fxd:=fx*np;
     dec(np);
     DP:=DP+FloatToStr(fxd,G_FMT)+',';
     H1Tree:=H1Tree^.Nb;
   end;
   DP:=DP+HnTree^.Expression; //+<expr>
   SD:=HnTree^.SDiff;         //diff(<expr>)

   if SD = '0' then DP:='0'
     else
     if SD = '1' then DP:='polynom('+DP+')'
       else  DP:='polynom('+DP+')*('+SD+')';

end
else
//poly(x/y,1,2,3,4,5)
if bln = True then             //poly(<expr>,a0,..,an)   <expr>=<diffvar>, <f(diffvar)>
begin                            //кроме первого - переменная(выражение) и последнего (при дифф-ии уходит)
   H1Tree:=HTree^.Nb;
   bl1:=TryStrToFloat(H1Tree^.Expression,fx,G_FMT);
   if bl1 = false then
       begin
        F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
        goto endp;
       end;
   fxd:=fx*np;
   dec(np);
   DP:=FloatToStr(fxd,G_FMT)+',';
   H1Tree:=H1Tree^.Nb;
   while H1Tree^.Nb <> nil do  //до предпоследнего (последний - при дифф-ии уходит)
   begin
     bl:=TryStrToFloat(H1Tree^.Expression,fx,G_FMT);
       if bl = false then
       begin
        F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
        goto endp;
       end;
     fxd:=fx*np;
     dec(np);
     DP:=DP+FloatToStr(fxd,G_FMT)+',';
     H1Tree:=H1Tree^.Nb;
   end;
   DP:=DP+HTree^.Expression; //+<expr>
   SD:=HTree^.SDiff;         //diff(<expr>)

   if SD = '0' then DP:='0'
     else
     if SD = '1' then DP:='polynom('+DP+')'
       else  DP:='polynom('+DP+')*('+SD+')';

end;
{else
ERROR;}

*)

endp:
end;


function TForevalH.CheckExp(PS: PString): Boolean;
var
Re,Im: Extended;
TV: Integer;
begin
 SubstParamPS(PS,Re,Im,TV);
 if (TV = T_Real) and (Re = exp(1)) then  CheckExp:=True else CheckExp:=False;
end;




         //sin(x)^cos(x)
function TForevalH.CheckForZeroNode(Tree: PNode): boolean;
label endp;
var
H: PNode;
bFZ: boolean;
S: String;
begin
//if F_SyntaxErrorCode <> 0 then goto endp;

bFZ:=False;
//if Tree = nil  then goto endp;

repeat
   H:=Tree;
   S:=H^.SDiff;
   FindExternalBracketNegPS(@S);
   if S <> '0' then goto endp;
   Tree:=Tree^.Nb;
until Tree = nil ;
bFZ:=True;


endp:
CheckForZeroNode:=bFZ;
end;



procedure TForevalH.ReplaceDiffTeplate(Tree: PNode; var DiffFunc: String);
label endp;
var
HTree: PNode;
NFunc,NArg,NFArg,i,NF: Integer;
FArg,DFArg: array of String;
Expr,TemplateDiffFunc,SFunc: String;
begin

if Tree = nil  then
begin
 {ERROR!!!}
 F_InternalError:=9;
 F_SyntaxErrorString:=Tree^.Expression;
 goto endp;
end;

NArg:=Tree^.Stack.N;            //число вытекающих узлов из вершины
NFunc:=Tree^.NFunc;

NF:=Tree^.NF;      {.301}
NFArg:=Alg.ExFunc[NFunc].Func[NF].NArg;   {.301}
//NFArg:=Alg.ExFunc[NFunc].NArg;  //число аргументов ф-ии NFunc   (должно быть равно NArg)

{.365} //закрыто из-за отлова ошибки с повторным заданием шаблона дифф-я: ошибка есть , но ловить не нужно :)
(*
if NFArg <> NArg then
begin
 F_InternalError:=9;
 F_SyntaxErrorString:=Tree^.Expression;
 {ERROR!!!}
 goto endp;
end;
*)

HTree:=Tree^.Ch;
//SFunc:=Tree^.SFunc;
SFunc:=Alg.ExFunc[NFunc].Name;                                    {.301}
//TemplateDiffFunc:=Alg.ExFunc[NFunc].TemplateDiffFunc;
TemplateDiffFunc:=Alg.ExFunc[NFunc].Func[NF].TemplateDiffFunc;    {.301}

SetLength(FArg,NArg);   SetLength(DFArg,NArg);

try
  for i := 0 to NArg - 1 do
  begin
   FArg[i]:=HTree^.Expression;
   DFArg[i]:=HTree^.SDiff;

   FindExternalBracketNegPS(@FArg[i]);      {.335}
   FindExternalBracketNegPS(@DFArg[i]);     {.335}

   HTree:=HTree^.Nb;
  end;
except
  F_InternalError:=9;
  F_SyntaxErrorString:=Tree^.Expression;
  {INTERNAL ERROR !!!}
end;

if F_InternalError <> 0 then goto endp;


DiffFunc:=TemplateDiffFunc;
for i := 0 to Length(FArg) - 1 do
begin
  DiffFunc:=StringReplace( DiffFunc, '$arg'+IntToStr(i+1), '('+FArg[i]+')',  [rfReplaceAll, rfIgnoreCase]);
end;

for i := 0 to Length(DFArg) - 1 do
begin
  DiffFunc:=StringReplace( DiffFunc, '$dfarg'+IntToStr(i+1), '('+DFArg[i]+')',  [rfReplaceAll, rfIgnoreCase]);
end;


{
SD1:=HTree^.SDiff;           FindExternalBracketN(SD1,SD1b,ng);
SD2:=HTree^.Nb^.SDiff;       FindExternalBracketN(SD2,SD2b,ng);
S1:=HTree^.Expression;       FindExternalBracketN(S1,S1b,ng);
S2:=HTree^.Nb^.Expression;   FindExternalBracketN(S2,S2b,ng2);
}
{F_InternalError:=9;
F_SyntaxErrorString:=Tree^.Expression;}

endp:
end;




procedure TForevalH.ExtDiffFunc(SE: String; var SXD: String; var Bl: Boolean);
label endp;
var
i,P,N,P1,k,l,NF: Integer;
S1,SS,Sf1,Sfn: String;
bl1: boolean;
begin

BL:=False;

P1:=Pos('(',SE);
if P1 = 0 then goto endp;
SS:=Copy(SE,1,P1-1);

P:=Pos('$',SS);
if P = 0 then
begin
 SS:=SS+'$1'; //P:=Length(SE)-1; N:=1; NS:=SE;
end
else
begin

 S1:=Copy(SS,P+1,Length(SS)-P);
 bl1:=true;

 {
 try
  N:=StrToInt(S1);
 except
   bl1:=false;
 end;
 }
 {.203}
 if TryStrToInt(S1,N) = false then
 begin
   bl1:=false;
 end;

 if bl1 = false  then goto endp;

 S1:=IntToStr(N+1);
 Delete(SS,P+1,Length(SS)-P);
 Insert(S1,SS,P+1);
end;


FindFuncA(SS,NF);
if NF <> _NOT_FOUND then
begin
  Bl:=True;
  SXD:=SS;
end;

(*
Sf1:=SS;

if F_SyntaxExtension = True then
begin
for k:=0 to High(Alg.ExFunc) do
 begin
  if Alg.ExFunc[k].IntF = _External then
  begin
   for l:=0 to High(Alg.ExFunc[k].NameF) do
    begin
     Sfn:=Alg.ExFunc[k].NameF[l];
                                       {.199}
     if (Sf1 = Sfn) and   (Alg.ExFunc[k].Enable = _YES) then  begin   SXD:=Alg.ExFunc[k].Name; Bl:=True; goto endp; end;
    end;
  end;
 end
end
else

 for i:=0 to High(Alg.ExFunc) do
  begin
    if Alg.ExFunc[k].Ext = 1 then
    begin
     Sfn:=Alg.ExFunc[i].Name;
                                 {.199}
     if (Sf1 = Sfn) and   (Alg.ExFunc[i].Enable = _YES) then  begin  SXD:=Alg.ExFunc[i].Name; Bl:=True; goto endp; end;
    end;
  end;

  *)

 {
 for I := 0 to Length(NameExtFunc)-1 do
 begin
  if SS = NameExtFunc[i] then
  begin
    Bl:=True;
    SXD:=SS;
    goto endp;
  end;
 end;
  }


endp:
end;


 (*
procedure TForevalH.FindExternalBracketAP(PS: PString);
label 1,endp;
var
b,i,z,a:Integer;
begin
//SS:=Copy(S,1,Length(S));



1:
if PS^ = '' then
begin
goto endp;
end;

if (PS^[1] = '(') and (PS^[Length(PS^)] = ')') then
begin
  b:=-1;
  for i:=2 to Length(PS^)-1 do
  begin
   if PS^[i] = '(' then b:=b-1;
   if PS^[i] = ')' then b:=b+1;

   if b = 0 then goto endp;
  end;

 Delete(PS^,Length(PS^),1);
 Delete(PS^,1,1);
 goto 1;
end;

endp:
end;
*)


procedure TForevalH.DelExternalBracketAP(PS: PString);
label 1,endp;
var
ng:Integer;
begin

 FindExternalBracketNegPS(PS);
  {
 if ng = 1 then
 begin
  if PS^[1] = '-' then  Delete(PS^,1,1) else
   PS^:='(-('+PS^+'))';
 end;
  }

//SS:=Copy(S,1,Length(S));


{
1:
if PS^ = '' then
begin
goto endp;
end;

if (PS^[1] = '(') and (PS^[Length(PS^)] = ')') then
begin
  b:=-1;
  for i:=2 to Length(PS^)-1 do
  begin
   if PS^[i] = '(' then b:=b-1;
   if PS^[i] = ')' then b:=b+1;

   if b = 0 then goto endp;
  end;

 Delete(PS^,Length(PS^),1);
 Delete(PS^,1,1);
 goto 1;
end;
}



endp:
end;



 (*
procedure  TForevalH.IsNum(S2: String; var fx: extended; var bnum: boolean);
var
 S3: String;
 Neg: Integer;
begin
bnum:=false;
FindExternalBracketNeg(S2,S3,neg);

{.203}
if TryStrToFloat(S3,fx,G_FMT) = true then
begin
    bnum:=true;
    fx:=StrToFloat(S3,G_FMT);
    if neg = 1 then fx:=-fx
end
else
begin
    bnum:=false;
    fx:=0;
end;

{
try
 fx:=StrToFloat(S3,G_FMT);
 bnum:=true;
 if neg = 1 then fx:=-fx
except
 bnum:=false;
end;
}

end;
*)



procedure  TForevalH.IsNumPS(PS: PString; var fx: extended; var bnum: boolean);
var
 S3: String;
 Neg: Integer;
begin
bnum:=false;
fx:=0;
S3:=PS^;
FindExternalBracketNegPS(@S3);
Neg:=1;
SaveSW; {.229} {TryStrToFloat damage SW}

if Length(S3) > 2 then     //-(num) -> num
begin
 if (S3[1]='-') and (S3[2] ='(') and (S3[Length(S3)] = ')') then
 begin
   Delete(S3,1,2);
   Delete(S3,Length(S3),1);
   Neg:=-1;
 end;
end;


{.203}
if TryStrToFloat(S3,fx,G_FMT) = true then
begin
    bnum:=true;
    fx:=StrToFloat(S3,G_FMT);
    fx:=Neg*fx
end
else
begin
    bnum:=false;
    fx:=0;
end;

{
try
 fx:=StrToFloat(S3,G_FMT);
 bnum:=true;
 if neg = 1 then fx:=-fx
except
 bnum:=false;
end;
}

end;








procedure TForevalH.FindAddSubNumInArgPS(PS: PString ;  var fx: extended; var answ: integer);
label beginp;

var
 L,b,i,p,cop: Integer;
 Sn: String;                               //E1 op N1 op ... En/Nn ... ; op=+,- ;N-number, E- expression ->  S = E1op...opEn; fx=N1op...opNn
 ft: extended;
begin                                    //1-E1+2-4+E2-E3+5 -> S=-E1+E2-E3; fx=4   _num
fx:=0;                                   //1+2-3+4; -> S=''; fx=4; _const
                                         //E1+E2-E3+E4 -> S=E1+E2-E3+E4; fx=0; _none
answ:=_none;
SaveSW; {.229} {TryStrToFloat damage SW}
beginp:

b:=0; L:=Length(PS^); p:=1;

for i:=1 to L  do
begin
 if PS^[i] = '(' then b:=b-1 else
 if PS^[i] = ')' then b:=b+1 else
 if PS^[i] = '[' then b:=b-1 else
 if PS^[i] = ']' then b:=b+1 else
 if PS^[i] = '{' then b:=b-1 else
 if PS^[i] = '}' then b:=b+1;

 if b = 0 then
 begin

    if (PS^[i] = '+') or (PS^[i] = '-') then
    begin
      Sn:=Copy(PS^,p,i-p);
      //SaveSW; {.229} {TryStrToFloat damage SW}
      if TryStrToFloat(Sn,ft,G_FMT) = true then
      begin
         fx:=fx+ft ;
         Delete(PS^,p,i-p);
         p:=i;
         answ:=_num;
         goto beginp;
      end;
    p:=i;
    end;



 end;

end;

//SaveSW; {.229} {TryStrToFloat damage SW}
//last expr:
if TryStrToFloat(PS^,ft,G_FMT) = true then
begin
      fx:=fx+ft;
      PS^:='';
      answ:=_const;
end
else
begin
  Sn:=Copy(PS^,p,L-p+1);
  if TryStrToFloat(Sn,ft,G_FMT) = true then
  begin
      fx:=fx+ft;
      Delete(PS^,p,L-p+1);
      answ:=_num;
  end;
  if PS^[1] = '+' then Delete(PS^,1,1); //+Expr->Expr


end;




end;



procedure  TForevalH.IsNumLastPS(PS: PString; var fx: extended; var Op: Integer);
label fnum,endp;
var                                      //Op=0: none; _add,_sub,_mul,_div,_num
 S3: String;
 Neg,LS,p,i: Integer;
begin


Op:=0;
fx:=0;

SaveSW; {.229} {TryStrToFloat damage SW}
if TryStrToFloat(PS^,fx,G_FMT) = true then
begin
   Op:=_num;
   goto endp;
end ;


LS:=Length(PS^);
for i := LS  downto 1   do
begin
  if (PS^[i] = ')') or  (PS^[i] = ']') then  goto endp
  else
  if (PS^[i] = '-')  then //только Expr-num, Expr+num
  begin
    p:=i; Op:=_sub; goto fnum;
  end
  else
  if  (PS^[i] = '+') then //только Expr-num, Expr+num
  begin
    p:=i; Op:=_add; goto fnum;
  end;


end;

fnum:

S3:=Copy(PS^,p+1,LS-p);


{.203}
if TryStrToFloat(S3,fx,G_FMT) = true then
begin
    //fx:=StrToFloat(S3,G_FMT);
    Delete(PS^,p,LS-p+1);
    if Op = _sub then  fx:=(-1)*fx;
end
else
Op:=0;

endp:
end;



procedure TForevalH.SetTemplateDiffFunc(NFunc,NF: integer; TmplDiffFunc: String);
begin                                                            //idName=NFunc; idArg=NF

  //Alg.ExFunc[NFunc].TemplateDiffFunc:=TmplDiffFunc;
  if (NFunc < Length(Alg.ExFunc)) and (NF < Length(Alg.ExFunc[NFunc].Func)) and (NF >= 0) and (NFunc >= 0) then
  begin
    {
    Alg.ExFunc[NFunc].Func[NF].TemplateDiffFunc:=TmplDiffFunc;
    Alg.ExFunc[NFunc].Func[NF].DFTmpl:=_YES;
    }

    //ограничение версии 9.0; шаблон дифференцирования задаётся ОДИН на все overload ф-ии и прописывается в первую ф-ию:  {.327}
    Alg.ExFunc[NFunc].Func[0].TemplateDiffFunc:=TmplDiffFunc;
    Alg.ExFunc[NFunc].Func[0].DFTmpl:=_YES;
  end
  else
  begin
    F_SyntaxErrorCode :=E_ERROR_AT_ADDITION_OF_FUNCTION;
    F_SyntaxErrorString:=TmplDiffFunc;
    IntException;
  end;
end;




//*****************************************************************************//
//                DIFFERENTIATION PROCEDURES  (end)                            //
//*****************************************************************************//



//*****************************************************************************//
//            FINDING INTEGER ARG. - INTEGER FORMS of VARS. (begin)             //
//*****************************************************************************//


procedure TForevalH.StringAnalizatorMEPS(PS:PString; var N: Integer; var COP,COPinv: Integer; var HS:PLevel{; varNeg: Integer});
label endp;
var
S2,SMOP,SMOP1: String;                                //ME- multi expression (not binary)
BH,IH,IH1: PLevel;
i,p,b,b1,b2,L: Integer;
Neg1,MOP,MOP1,SB,NCop1,NCop2: Integer;
NPOS: Cardinal;
C: extended;

begin
if F_SyntaxErrorCode <> 0 then goto endp;
(*
FindExternalBracket(S,SS,Neg1);
if SS = '' then
begin
 F_ErrorCode:=E_MISSING_EXPRESSION;
 F_SyntaxErrorString:=S;
 goto endp;
end;

//для чисел с экспонентой 1.233454565E+1233
SaveSW; {.249} {TryStrToFloat damage SW}
if TryStrToFloat(SS,C,G_FMT) = true then  MOP:=_NOP else FindMainOperation(SS,MOP);
*)

//FindMainOperationP(PS,MOP,NPOS);
FindMainOperationPS(PS,MOP,NPOS,NCop1,NCop2); {.315}


//k=-j*k
//k=-2*k
//k=-j*k*2*n
//k=-2*j*k*5


{.357}
if (MOP = _NOT_FOUND) and (NCop2 = COP_MUL) and (NCop1 = COP_NEG) and (NPOS > 0) then MOP:=COP_MUL;
{
 Для случая, если перед выражением с главной операцией MUL идёт минус (NEG)  -j*k ; -2*k; -2*j*k*n; -k*2*j;
 В этих случаях FindMainOperationPS возвращает  _NOT_FOUND , т.к. главная операция  NEG - одноаргументна
 NCop2 - двуаргументная операция (если есть) NPOS - её позиция; NCop1 - однаргументная операция в начале выражения
 Иначе выражение не распознаётся, как IntForm
}




if MOP = COP_ADD then  MOP:=_ADD else
if MOP = COP_SUB then  MOP:=_SUB else
if MOP = COP_MUL then  MOP:=_MUL else
if MOP = COP_DIV then  MOP:=_DIV else
if MOP = _NOT_FOUND then MOP:=_NOP;

COPinv:=_NOP;


if MOP = _ADD then begin MOP1:=_SUB; SMOP:='+'; SMOP1:='-'; end
else
if MOP = _SUB then begin MOP:=_ADD;  MOP1:=_SUB; SMOP:='+'; SMOP1:='-'; end
else
if MOP = _MUL then begin MOP1:=_DIV; SMOP:='*'; SMOP1:='/'; end
else
if MOP = _DIV then begin MOP := _MUL;  MOP1:=_DIV; SMOP:='*'; SMOP1:='/'; end;

//Neg:=Neg1;
N:=0;

if MOP <> _NOP then
 begin
 p:=1; b:=0;  b1:=0; b2:=0;  BH:=IH; IH1:=IH;
  {
 if MOP = _ADD then begin MOP1:=_SUB; SMOP1:='-'; end
 else
 if MOP = _MUL then begin MOP1:=_DIV; SMOP1:='/'; end;
   }

if PS^[1] = '(' then b:=-1; {else
  if SS[1] = '[' then b1:=-1 else
    if SS[1] = '{' then b2:=-1;}

L:=Length(PS^);

 for i:=2 to L do
  begin

   if PS^[i] = '(' then b:=b-1;
   if PS^[i] = ')' then b:=b+1;
   if PS^[i] = '[' then b1:=b1-1;
   if PS^[i] = ']' then b1:=b1+1;
   (*if SS[i] = '{' then b2:=b2-1;
   if SS[i] = '}' then b2:=b2+1;*)

   if (b = 0) and (b1 = 0) {and (b2 = 0)} and ((PS^[i] = SMOP) or (PS^[i] = SMOP1)) then
    begin

      if Copy(PS^,p,i-p) = '' then
      begin
       F_SyntaxErrorCode:=E_MISSING_EXPRESSION;
       F_SyntaxErrorString:=Copy(PS^,1,Length(PS^));
       //raise ESyntaxError.Create('');
       goto endp;
      end;

     N:=N+1;
     SetLength(HS,N);
     HS[N-1].Expression:=Copy(PS^,p,i-p);
     HS[N-1].COP:=_NOP;
     //HS[N-1].ExtArg:=_None;
     if (N-1) > 0 then
     begin
      if PS^[p-1] = '-' then  begin HS[N-1].COP:=_SUB; COPinv:=_SUB; end   else
      if PS^[p-1] = '/' then  begin HS[N-1].COP:=_DIV; COPinv:=_DIV; end   else
      if PS^[p-1] = '*' then  HS[N-1].COP:=_MUL   else
      if PS^[p-1] = '+' then  HS[N-1].COP:=_ADD;
     end;
     p:=i+1;
    end;
  end;

 N:=N+1;
 SetLength(HS,N);
 HS[N-1].Expression:=Copy(PS^,p,L-p+1);
 HS[N-1].COP:=_NOP;

 if PS^[p-1] = '-' then  begin HS[N-1].COP:=_SUB; COPinv:=_SUB; end   else
 if PS^[p-1] = '/' then  begin HS[N-1].COP:=_DIV; COPinv:=_DIV; end   else
 if PS^[p-1] = '*' then  HS[N-1].COP:=_MUL   else
 if PS^[p-1] = '+' then  HS[N-1].COP:=_ADD;
 end
else
begin   {  узел без операции - число, переменная, функция}
 L:=Length(PS^);
 N:=1;
 SetLength(HS,N);
 HS[0].Expression:=Copy(PS^,1,L);
 //HS[0].ExtArg:=_None;
 //N:=0; {.221} //N=0 -end of node !!
end;

COP:=MOP;

endp:
end;



procedure TForevalH.FindExtArgIntPS(PS: PString; var code: Integer; {var FIN: TFin;} var AIVP: TArrayIntVarProd; var NV,IC: Integer);
label endp;
{

 code = _IntConst   = IC
 code = _IntVar     = NV
 code = _IntForm    = a1*I1*...Ik+a2*I1*...*In+...+am*I1*...*Im+CI;  AIVP[]=ArrayOf(IVP); IVP.NV=ArrayOf(nv); IVP.A = ai;
 code = _NOT_FOUND;
}
var
  LV:PLevel;
  COP,COPinv,N,i,im: Integer;
  IVP: TIntVarProd;
  BDelBr: Boolean;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

if F_IntegerOptimization = False then
begin
 code:=_NOT_FOUND;
 goto endp;
end;

BDelBr:=DeleteExternalBracketPS(PS);
if PS^ = '' then
begin
 F_SyntaxErrorCode:=5;
 goto endp;
end;

SetLength(AIVP,0);
code := _NOT_FOUND;
IC:=0;

StringAnalizatorMEPS(PS,N,COP,COPinv,LV{,Neg});

if (COP = _MUL) and (COPinv = _DIV) then
begin
 code := _NOT_FOUND;
 goto endp;
end
else
if (COP = _MUL)  then
begin
  SetLength(IVP.NV,0);
  FindIntVarProdL(LV,COP,COPinv,code,IVP);
  if code = _NOT_FOUND then  goto endp;
  if code = _IntConst then    {.335} //func(2*3)
  begin
      code:=_IntConst;
      ic:=IVP.A;
      goto endp;
  end;
  SetLength(AIVP,1);
  AIVP[0]:=IVP;
  code:=_IntForm;
  //goto endp;
end
else
if COP = _ADD then
begin

   for i:=0 to High(LV) do
   begin
     SetLength(IVP.NV,0);

     FindIntVarProdSPS(@LV[i].Expression,code,IVP);

     if code = _NOT_FOUND then  goto endp;

     if LV[i].COP = _SUB then    IVP.A:=-IVP.A;

     if code = _IntConst then    IC:=IC+IVP.A
     else
     begin
       SetLength(AIVP,Length(AIVP)+1);
       AIVP[High(AIVP)]:=IVP;
     end;

   end;

   if Length(AIVP) = 0 then code:=_IntConst else code:=_IntForm;
end
else
if COP = _NOP then
begin
    FindIntVarConstP(PS,nv,im,code);
    if code = _NOT_FOUND then
    begin
      //code:=_NOT_FOUND;
      //goto endp;
    end
    else
    if code = _IntConst then
    begin
      code:=_IntConst;
      ic:=im;
       //убрать:
      //code := _IntForm;
    end
    else
    if code = _IntVar then
    begin
      if im = 1 then
      begin
        code:=_IntVar;
        //убрать:
        {SetLength(IVP.NV,Length(IVP.NV)+1);
        IVP.NV[High(IVP.NV)]:=nv;
        IVP.A:=im;
        SetLength(AIVP,Length(AIVP)+1);
        AIVP[High(AIVP)]:=IVP;
        code := _IntForm; }
      end
      else     //-n
      begin
        SetLength(IVP.NV,Length(IVP.NV)+1);
        IVP.NV[High(IVP.NV)]:=nv;
        IVP.A:=im;
        SetLength(AIVP,Length(AIVP)+1);
        AIVP[High(AIVP)]:=IVP;
        code := _IntForm;
      end
    end
end;


// else  code:=_IntForm;


endp:
if BDelBr = True  then   PS^:='('+PS^+')';

end;




procedure TForevalH.FindIntVarProdSPS(PS: PString; var code: Integer;{ var FIN: TFin;} var IVP: TIntVarProd);
{
{
 code = _IntProd     = a*i1*i2*...*in        ; a,b - int. coeff;         i1,...,in - int.var;  a=>PN.A, i1,...,in=>PN.NV,
 code = _IntVar      = a*i                   ; a,b - int. coeff;                i  - int.var;  i=>FIN.NV, a=>FIN.A,
 code = _IntNum      = a                     ; a - int.num.                                    a=>FIN.A
 code = _NOT_FOUND
}

label endp;
var
LV: PLevel;
i,MC,N,COP,COPinv: Integer;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

if PS^ = '' then
begin
 F_SyntaxErrorCode:=5;
 goto endp;
end;

StringAnalizatorMEPS(PS,N,COP,COPinv,LV{Neg});

FindIntVarProdL(LV,COP,COPinv,code,IVP);
(*

if (COP = _MUL) and (COPinv = _DIV) then
begin
 code := _NOT_FOUND;
 goto endp;
end;
{
FIN.A:=0;
FIN.B:=0;
FIN.NV:=-1;  }

MC:=1;

if (COP = _MUL)  then
begin

  H:=High(LV);
  for i:=0 to High(LV) do
  begin

    FindIntVarConstP(@LV[i].Expression,nv,ic,typeVC);
    if typeVC = _NOT_FOUND then
    begin
      code:=_NOT_FOUND;
      goto endp;
    end
    else
    if typeVC = _IntConst then
    begin
      MC:=MC*ic;
      //code:=_IntConst;
    end
    else
    if typeVC = _IntVar then
    begin
      SetLength(IVP.NV,Length(IVP.NV)+1);
      IVP.NV[High(IVP.NV)]:=nv;
      //code = _IntProd;
      MC:=MC*ic;  //-n
    end
    else
    begin
      code:=_NOT_FOUND;
      goto endp;
    end;

  end;

end
else
if COP = _NOP then
begin

    FindIntVarConstP(PS,nv,ic,typeVC);
    if typeVC = _NOT_FOUND then
    begin
      code:=_NOT_FOUND;
      goto endp;
    end
    else
    if typeVC = _IntConst then
    begin
      MC:=MC*ic;
      //code:=_IntConst;
      //goto endp;
    end
    else
    if typeVC = _IntVar then
    begin
      {code := _IntVar;
      MC:=MC*ic;  //-n
      FIN.NV:=nv;
      FIN.A:=MC; }
      SetLength(IVP.NV,Length(IVP.NV)+1);
      IVP.NV[High(IVP.NV)]:=nv;
      //code = _IntProd;
      MC:=MC*ic;  //-n

      //goto endp;
    end
    else
    begin
      code:=_NOT_FOUND;
      goto endp;
    end;

end;

IVP.A:=MC;
if Length(IVP.NV) = 0 then code := _IntConst else  code := _IntVar;

 {
if  Length(PN.NV) = 0 then
begin
 code := _IntConst;
 FIN.A:=MC;
end
else
if  Length(PN.NV) = 1 then
begin
 code := _IntVar;
 FIN.NV:=PN.NV[0];
 FIN.A:=MC;
end
else
 code := _IntVProd;
}
*)

endp:
end;



procedure TForevalH.FindIntVarProdL(LV: PLevel; COP,COPinv: Integer; var code: Integer;{ var FIN: TFin;} var IVP: TIntVarProd);
{
{
 code = _IntProd       = a*i1*i2*...*in        ; a,b - int. coeff;         i1,...,in - int.var;  a=>PN.A, i1,...,in=>PN.NV,
 code = _IntVar        = a*i                   ; a,b - int. coeff;                i  - int.var;  i=>FIN.NV, a=>FIN.A,
 code = _IntConst      = a                     ; a - int.num.                                    a=>FIN.A
 code = _NOT_FOUND
}

label endp;
var
i,MC,H,nv,ic,typeVC: Integer;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

IVP.A:=0;
SetLength(IVP.NV,0);
//StringAnalizatorME(PS,N,COP,COPinv,LV{Neg});

if (COP = _MUL) and (COPinv = _DIV) then
begin
 code := _NOT_FOUND;
 goto endp;
end
else
if (COP <> _MUL) and (COP <> _NOP) then   // ^,!,!!
begin
 code := _NOT_FOUND;
 goto endp;
end;

{
FIN.A:=0;
FIN.B:=0;
FIN.NV:=-1;  }

MC:=1;

if (COP = _MUL)  then
begin

  H:=High(LV);
  for i:=0 to High(LV) do
  begin

    FindIntVarConstP(@LV[i].Expression,nv,ic,typeVC);
    if typeVC = _NOT_FOUND then
    begin
      code:=_NOT_FOUND;
      goto endp;
    end
    else
    if typeVC = _IntConst then
    begin
      MC:=MC*ic;
      //code:=_IntConst;
    end
    else
    if typeVC = _IntVar then
    begin
      SetLength(IVP.NV,Length(IVP.NV)+1);
      IVP.NV[High(IVP.NV)]:=nv;
      //code = _IntProd;
      MC:=MC*ic;  //-n
    end
    else
    begin
      code:=_NOT_FOUND;
      goto endp;
    end;

  end;

end
else
if COP = _NOP then
begin

    FindIntVarConstP(@LV[0].Expression,nv,ic,typeVC);
    if typeVC = _NOT_FOUND then
    begin
      code:=_NOT_FOUND;
      goto endp;
    end
    else
    if typeVC = _IntConst then
    begin
      MC:=MC*ic;
      code:=_IntConst;
      //goto endp;
    end
    else
    if typeVC = _IntVar then
    begin
      {code := _IntVar;
      MC:=MC*ic;  //-n
      FIN.NV:=nv;
      FIN.A:=MC; }
      SetLength(IVP.NV,Length(IVP.NV)+1);
      IVP.NV[High(IVP.NV)]:=nv;
      //code = _IntProd;
      MC:=MC*ic;  //-n

      //goto endp;
    end
    else
    begin
      code:=_NOT_FOUND;
      goto endp;
    end;

end;

IVP.A:=MC;
if Length(IVP.NV) = 0 then code := _IntConst else  code := _IntVar;

 {
if  Length(PN.NV) = 0 then
begin
 code := _IntConst;
 FIN.A:=MC;
end
else
if  Length(PN.NV) = 1 then
begin
 code := _IntVar;
 FIN.NV:=PN.NV[0];
 FIN.A:=MC;
end
else
 code := _IntVProd;
}


endp:
end;


procedure TForevalH.WriteFindExtArgInt1PS(PStr1: PString; place: Integer;  ND1: TDataNode;  var ND2: TDataNode; var BAnsw: Boolean);
label endp;
var
code1,NV1,IC1: Integer;
AIVP1: TArrayIntVarProd;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

ND2:=ND1;

if F_IntegerOptimization = False then
begin
 ND2.TA1:=_NOT_FOUND;
 ND2.TA2:=_NOT_FOUND;
 BAnsw:=False;
 goto endp;
end;



SetLength(AIVP1,0);

BAnsw:=False;

FindExtArgIntPS(PStr1, code1, AIVP1, NV1, IC1);

if (code1 <> _NOT_FOUND)  then
begin
          if code1 = _IntConst then
          begin

            if place = _First then ND2.IC1:=IC1 else  ND2.IC2:=IC1; {_Second}

          end
          else
          if code1 = _IntVar then
          begin

            if place = _First then ND2.NV1:=NV1 else  ND2.NV2:=NV1; {_Second}

          end
          else
          if code1 = _IntForm then
          begin

            if place = _First then
            begin
              ND2.AIVP1:=Copy(AIVP1,0,Length(AIVP1));
              ND2.IC1:=IC1;
            end
            else    {_Second}
            begin
              ND2.AIVP2:=Copy(AIVP1,0,Length(AIVP1));
              ND2.IC2:=IC1;
            end;

          end ;


          //ND2.TA1:=code1;
          ND2.BI:=_IntArg;

          BAnsw:=True;
end;

    if place = _First then ND2.TA1:=code1 else ND2.TA2:=code1;  {_Second}

endp:
end;




procedure TForevalH.WriteFindExtArgInt2PS(PStr1,Pstr2: PString; ND1: TDataNode;  var ND2: TDataNode; var BAnsw: Boolean);
label endp;
var
code1,code2,NV1,NV2,IC1,IC2: Integer;
AIVP1,AIVP2: TArrayIntVarProd;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

ND2:=ND1;

if F_IntegerOptimization = False then
begin
 ND2.TA1:=_NOT_FOUND;
 ND2.TA2:=_NOT_FOUND;
 BAnsw:=False;
 goto endp;
end;


SetLength(AIVP1,0);
SetLength(AIVP2,0);

BAnsw:=False;

FindExtArgIntPS(PStr1, code1, AIVP1, NV1, IC1);
FindExtArgIntPS(PStr2, code2, AIVP2, NV2, IC2);
if (code1 <> _NOT_FOUND) and (code2 <> _NOT_FOUND) then
begin
          if code1 = _IntConst then
          begin
            ND2.IC1:=IC1;
          end
          else
          if code1 = _IntVar then
          begin
            ND2.NV1:=NV1;
          end
          else
          if code1 = _IntForm then
          begin
            ND2.AIVP1:=Copy(AIVP1,0,Length(AIVP1));
            ND2.IC1:=IC1;
          end ;

           if code2 = _IntConst then
          begin
            ND2.IC2:=IC2;
          end
          else
          if code2 = _IntVar then
          begin
            ND2.NV2:=NV2;
          end
          else
          if code2 = _IntForm then
          begin
            ND2.AIVP2:=Copy(AIVP2,0,Length(AIVP2));
            ND2.IC2:=IC2;
          end ;

          ND2.TA1:=code1;
          ND2.TA2:=code2;
          ND2.BI:=_IntArg;

          BAnsw:=True;
end;

endp:
end;




procedure TForevalH.WriteFindExtArgInt2AnyPS(PStr1,Pstr2: PString; ND1: TDataNode;  var ND2: TDataNode; var code: Integer);
label endp;
var                                                                                        //code = 3 (_Both)
code1,code2,NV1,NV2,IC1,IC2: Integer;                                                      //code = 1 (_First)
AIVP1,AIVP2: TArrayIntVarProd;                                                             //code = 2 (_Second)
begin                                                                                      //code = _NOT_FOUND
if F_SyntaxErrorCode <> 0 then goto endp;

ND2:=ND1;

if F_IntegerOptimization = False then
begin
 ND2.TA1:=_NOT_FOUND;
 ND2.TA2:=_NOT_FOUND;
 code:=_NOT_FOUND;
 goto endp;
end;


SetLength(AIVP1,0);
SetLength(AIVP2,0);

code:=_NOT_FOUND;

FindExtArgIntPS(PStr1, code1, AIVP1, NV1, IC1);
FindExtArgIntPS(PStr2, code2, AIVP2, NV2, IC2);

if (code1 <> _NOT_FOUND)  then
begin
          if code1 = _IntConst then
          begin
            ND2.IC1:=IC1;
          end
          else
          if code1 = _IntVar then
          begin
            ND2.NV1:=NV1;
          end
          else
          if code1 = _IntForm then
          begin
            ND2.AIVP1:=Copy(AIVP1,0,Length(AIVP1));
            ND2.IC1:=IC1;
          end ;

          ND2.TA1:=code1;

          //ND2.BI:=_IntArg;

end ;

if  (code2 <> _NOT_FOUND) then
begin

           if code2 = _IntConst then
          begin
            ND2.IC2:=IC2;
          end
          else
          if code2 = _IntVar then
          begin
            ND2.NV2:=NV2;
          end
          else
          if code2 = _IntForm then
          begin
            ND2.AIVP2:=Copy(AIVP2,0,Length(AIVP2));
            ND2.IC2:=IC2;
          end ;


          ND2.TA2:=code2;
         // ND2.BI:=_IntArg;

end;

if (code1 <> _NOT_FOUND) and (code2 <> _NOT_FOUND) then code:=_Both
else
if (code1 <> _NOT_FOUND)  then code:=_First
else
if (code2 <> _NOT_FOUND) then code:=_Second;



endp:
end;




procedure TForevalH.FindExtFuncIntArg(var  ND: TDataNode; var EOFN: Boolean);
label endp;
var
IntArg: Boolean;
nf,TM,TV,L,NL,ExtFunc,NFunc,IntF: Integer;
S: String;
begin
EOFN:=False;

InitNode(ND);
ExtFunc:=Tree^.ExtFunc;




  //защита AV
  if (ExtFunc >= 0) and (ExtFunc <= High(Alg.ExFunc)) then
  begin
    //IntArg:=True;
    S:=Tree^.Expression;
    NL:=Tree^.NL;                        // ExtFunc(...,NL,...)
    L:=Length(Alg.ExFunc[Extfunc].Func);


    for nf := 0 to L-1 do    //если аргументы всех overload ф-ий (ExtFunc) с порядковым номером NL = _Integer, то поиск IntForm
    begin

         if NL <= Alg.ExFunc[ExtFunc].Func[nf].NArg then
         begin
            TV:=Alg.ExFunc[ExtFunc].Func[nf].TV[NL-1];
            TM:=Alg.ExFunc[ExtFunc].Func[nf].TM[NL-1];
            if (TV = T_Real) and (TM = _Integer) then begin end else begin  goto endp; end;
         end
         else goto endp;

         WriteFindExtArgInt1PS(@S, _First, ND, ND, IntArg);
         if IntArg = True then
         begin
           ND.N:=0;
           ND.COP:=_LDINTFORM;
           ND.NFunc:=0;
           EOFN:=True;
         end;

    end;

  end;


endp:
end;

//*****************************************************************************//
//            FINDING INTEGER ARG. - NTEGER FORMS of VARS. (end)               //
//*****************************************************************************//




procedure TForevalH.InitFuncStruct(var FS: TIntFunc);
begin
  FS.TypeF:=0;
  FS.TypeM:=_Extended;
  FS.CallT:=0;
  FS.CLST:=0;
  FS.Arrow:=0;
  FS.Addr:=0;
  FS.NArg:=0;
  FS.SDeep:=0;//-1;
  FS.IntF:=_External;
  FS.TV:=nil;
  FS.TM:=nil;
  FS.ArgAdr:=nil;
  FS.CalcConst:=_YES;
  FS.SaveReg:=0;
  FS.ReplFunc:=_YES;
  FS.ExeF:=_YES;
  FS.XchArg:=_NO;
  FS.Set_ID:=_NO;
  FS.Id_Func:=0;
  FS.DFTmpl:=_NO;
  FS.Enable:=_YES;
  FS.Place:=_ReWrite;//_New; olny for internal (for external = _New)
  FS.CodeSize:=0;      {.365}
  FS.IsInline:=_NO;    {.365}
end;




procedure TForevalH.CreateFuncList;
var
TF,TM: TArrayC;
FS: TIntFunc;
NFunc,NF: Integer;
begin



//INTERNAL FUNCTION(FS.IntF:=_Internal {1})

SetLength(Alg.ExFunc,CM_LENGTH);

SetType(T_None);
SetType(T_Void);   //внутренний тип, аналогичен T_None (для внешний ф-ий); используется при оптимизации ф-ий с целочисленными аргументами и #prog
SetType(T_Integer);
SetType(T_Complex);
SetType(T_Pointer);

InitFuncStruct(FS);
FS.IntF:=_Internal;//1;
//внутренние функции  ///ПОРЯДОК СЛЕДОВАНИЯ НЕ МЕНЯТЬ!!!!!!!!!!!SEQUENCE NOT TO CHANGE !!!!!!!!!!!!!!!!!!
//{N} - указаны порядковые номера (идентификаторы) функций в массиве  Alg.ExFunc[N]
//{N} - serial numbers are specified (identifiers: IDF) functions in an array Alg.ExFunc[N]
//REAL:
//func(arg1,arg2)
FS.NArg:=2; FS.TypeF:=T_Real;
SetLength(FS.TM,2); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
//SetLoadFunction(T_Real,0,'Real');

FS.ReplFunc:=_YES;//_NO;

{0}SetFunctionInt('add',CM_ADD,FS);
{1}SetFunctionInt('sub',CM_SUB,FS);
{2}SetFunctionInt('mul',CM_MUL,FS);
{3}SetFunctionInt('div',CM_DIV,FS);
{4}SetFunctionInt('power',CM_POWER,FS);
{5}SetFunctionInt('log',CM_LOGN,FS);



//func(arg1)
FS.NArg:=1; FS.TypeF:=T_Real;
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
   FS.ReplFunc:=_NO;
{6}SetFunctionInt('neg',CM_NEG,FS);
   FS.ReplFunc:=_YES;
{7}SetFunctionInt('abs',CM_ABS,FS);
   FS.ReplFunc:=_NO;
{8}SetFunctionInt('re',CM_RE,FS);
{9}SetFunctionInt('im',CM_IM,FS);
   FS.ReplFunc:=_YES;
{10}SetFunctionInt('arg',CM_ARG,FS);

    FS.ReplFunc:=_YES;
{11}SetFunctionInt('sin',CM_SIN,FS);
{12}SetFunctionInt('cos',CM_COS,FS);
{13}SetFunctionInt('tan',CM_TAN,FS);
{14}SetFunctionInt('cotan',CM_COTAN,FS);
    SetFunctionInt('sec',CM_SEC,FS);
    SetFunctionInt('cosec',CM_COSEC,FS);
{15}SetFunctionInt('arccos',CM_ARCCOS,FS);
{16}SetFunctionInt('arcsin',CM_ARCSIN,FS);
{17}SetFunctionInt('arctan',CM_ARCTAN,FS);
{18}SetFunctionInt('arccotan',CM_ARCCOTAN,FS);
    SetFunctionInt('arcsec',CM_ARCSEC,FS);
    SetFunctionInt('arccosec',CM_ARCCOSEC,FS);
    SetFunctionInt('arcsech',CM_ARCSECH,FS);
    SetFunctionInt('arccosech',CM_ARCCOSECH,FS);

{19}SetFunctionInt('sinh',CM_SINH,FS);
{20}SetFunctionInt('cosh',CM_COSH,FS);
    SetFunctionInt('sech',CM_SECH,FS);
    SetFunctionInt('cosech',CM_COSECH,FS);
{21}SetFunctionInt('tanh',CM_TANH,FS);
{22}SetFunctionInt('cotanh',CM_COTANH,FS);
{23}SetFunctionInt('arccosh',CM_ARCCOSH,FS);
{24}SetFunctionInt('arcsinh',CM_ARCSINH,FS);
{25}SetFunctionInt('arctanh',CM_ARCTANH,FS);
{26}SetFunctionInt('arccotanh',CM_ARCCOTANH,FS);


{27}SetFunctionInt('ln',CM_LN,FS);
{28}SetFunctionInt('exp',CM_EXP,FS);
{29}SetFunctionInt('sqr',CM_SQR,FS);
{30}SetFunctionInt('sqrt',CM_SQRT,FS);
{31}SetFunctionInt('fact',CM_FACT,FS);
{32}SetFunctionInt('log10',CM_LOG10,FS);
{33}SetFunctionInt('log2',CM_LOG2,FS);




//COMPLEX:
//func(arg1,arg2)
FS.NArg:=2; FS.TypeF:=T_Complex;
SetLength(FS.TM,2); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex; FS.TV[1]:=T_Complex;
//SetLoadFunction(T_Complex,0,'Complex');
SetFunctionInt('add',CM_ADD,FS);
SetFunctionInt('sub',CM_SUB,FS);
SetFunctionInt('mul',CM_MUL,FS);
SetFunctionInt('div',CM_DIV,FS);
SetFunctionInt('power',CM_POWER,FS);
SetFunctionInt('log',CM_LOGN,FS);



//func(arg1)
FS.NArg:=1; FS.TypeF:=T_Complex;
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Complex;
SetFunctionInt('ln',CM_LN,FS);
SetFunctionInt('sin',CM_SIN,FS);
SetFunctionInt('cos',CM_COS,FS);
SetFunctionInt('sec',CM_SEC,FS);
SetFunctionInt('cosec',CM_COSEC,FS);
SetFunctionInt('exp',CM_EXP,FS);
SetFunctionInt('sqrt',CM_SQRT,FS);
SetFunctionInt('sqr',CM_SQR,FS);
SetFunctionInt('log10',CM_LOG10,FS);
SetFunctionInt('log2',CM_LOG2,FS);


SetFunctionInt('tan',CM_TAN,FS);
SetFunctionInt('cotan',CM_COTAN,FS);
SetFunctionInt('arccos',CM_ARCCOS,FS);
SetFunctionInt('arcsin',CM_ARCSIN,FS);
SetFunctionInt('arctan',CM_ARCTAN,FS);
SetFunctionInt('arccotan',CM_ARCCOTAN,FS);
SetFunctionInt('cosh',CM_COSH,FS);
SetFunctionInt('sinh',CM_SINH,FS);
SetFunctionInt('tanh',CM_TANH,FS);
SetFunctionInt('cotanh',CM_COTANH,FS);
SetFunctionInt('arccosh',CM_ARCCOSH,FS);
SetFunctionInt('arcsinh',CM_ARCSINH,FS);
SetFunctionInt('arctanh',CM_ARCTANH,FS);
SetFunctionInt('arccotanh',CM_ARCCOTANH,FS);
SetFunctionInt('sech',CM_SECH,FS);
SetFunctionInt('cosech',CM_COSECH,FS);
SetFunctionInt('arcsec',CM_ARCSEC,FS);
SetFunctionInt('arccosec',CM_ARCCOSEC,FS);
SetFunctionInt('arcsech',CM_ARCSECH,FS);
SetFunctionInt('arccosech',CM_ARCCOSECH,FS);





FS.NArg:=1; FS.TypeF:=T_Complex;
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Complex;
SetFunctionInt('neg',CM_NEG,FS);
FS.TypeF:=T_Real;
SetFunctionInt('re',CM_RE,FS);
SetFunctionInt('im',CM_IM,FS);
SetFunctionInt('abs',CM_ABS,FS);
SetFunctionInt('arg',CM_ARG,FS);



//MIXED(real,complex):
FS.NArg:=2; FS.TypeF:=T_Complex;
SetLength(FS.TM,2); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Complex;
SetFunctionInt('add',CM_ADD,FS);
SetFunctionInt('sub',CM_SUB,FS);
SetFunctionInt('mul',CM_MUL,FS);
SetFunctionInt('div',CM_DIV,FS);
SetFunctionInt('power',CM_POWER,FS);
SetFunctionInt('log',CM_LOGN,FS);

//MIXED(complex,real):
FS.TV[0]:=T_Complex; FS.TV[1]:=T_Real;
SetFunctionInt('add',CM_ADD,FS);
SetFunctionInt('sub',CM_SUB,FS);
SetFunctionInt('mul',CM_MUL,FS);
SetFunctionInt('div',CM_DIV,FS);
SetFunctionInt('power',CM_POWER,FS);
SetFunctionInt('log',CM_LOGN,FS);






//Imaginary unit:
S_IM_UNIT:='i';
zi.x:=0; zi.y:=1;
SetObject(S_IM_UNIT,Cardinal(@zi),T_Complex,_Double,_Internal);
//SetObject('pi',Cardinal(@_PI),T_Real,_Extended);


//ROOT  real,real
//root(R_arg,x)
FS.NArg:=2; FS.TypeF:=T_Real;  FS.ReplFunc:=_YES;
SetLength(FS.TM,2); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
{34}SetFunctionInt('root',CM_ROOT,FS);
//ROOT MIXED(real,complex):
//root(Z_arg,trunc(x))
FS.NArg:=2; FS.TypeF:=T_Complex;
SetLength(FS.TM,2); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex; FS.TV[1]:=T_Real;
SetFunctionInt('root',CM_ROOT,FS);


//TRUNC:
FS.TypeF:=T_Real; FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;  FS.NArg:=1;
SetFunctionInt('trunc',CM_TRUNC,FS);
//CON:
FS.TypeF:=T_Complex; FS.TV[0]:=T_Complex;
SetFunctionInt('con',CM_CON,FS);
FS.TypeF:=T_Real; FS.TV[0]:=T_Real;
SetFunctionInt('con',CM_CON,FS);
//ADDR:
FS.TypeF:=T_Pointer; FS.TV[0]:=T_Complex;
SetFunctionInt('addr',CM_ADDR,FS);
FS.TypeF:=T_Pointer; FS.TV[0]:=T_Real;
SetFunctionInt('addr',CM_ADDR,FS);
//FRAC:
FS.TypeF:=T_Real; FS.TV[0]:=T_Real;
SetFunctionInt('frac',CM_FRAC,FS);


//ARRAY:
SetType(T_Array);
//SetLoadFunction(T_Array,0,'Vector');
//FS.ReplFunc:=_YES;
{44}//NORM:
FS.TypeF:=T_Real; FS.TV[0]:=T_Array;
SetFunctionInt('norm',CM_NORM,FS);
{45}//SUM:
{FS.TypeF:=T_Real; FS.TV[0]:=T_Array;
SetFunctionInt('sum',CM_SUM,FS); }
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TypeF:=T_Real;
FS.SDeep:=2;
FS.SaveReg:=1;
FS.ReplFunc:=_YES;
FS.TV[0]:=T_Array;  FS.TM[0]:=_Extended;
SetFunctionInt('sum',CM_SUM,FS);
FS.TV[0]:=T_Array;  FS.TM[0]:=_Double;
SetFunctionInt('sum',CM_SUM,FS);
FS.TV[0]:=T_Array;  FS.TM[0]:=_Integer;
SetFunctionInt('sum',CM_SUM,FS);
FS.TV[0]:=T_Array;  FS.TM[0]:=_Pointer;
SetFunctionInt('sum',CM_SUM,FS);

{46}//AVR:
FS.TypeF:=T_Real; FS.TV[0]:=T_Array;
SetFunctionInt('avr',CM_AVR,FS);
{47}//SUMQ:
FS.TypeF:=T_Real; FS.TV[0]:=T_Array;
SetFunctionInt('sumq',CM_SUMQ,FS);
{48}//LEN:
{FS.TypeF:=T_Real; FS.TV[0]:=T_Array;
SetFunctionInt('len',CM_LEN,FS);}
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TypeF:=T_Real;
FS.SDeep:=1;
FS.SaveReg:=1;
FS.ReplFunc:=_YES;
FS.TV[0]:=T_Array;  FS.TM[0]:=_Extended;
SetFunctionInt('len',CM_LEN,FS);
FS.TV[0]:=T_Array;  FS.TM[0]:=_Double;
SetFunctionInt('len',CM_LEN,FS);
FS.TV[0]:=T_Array;  FS.TM[0]:=_Integer;
SetFunctionInt('len',CM_LEN,FS);
FS.TV[0]:=T_Array;  FS.TM[0]:=_Pointer;
SetFunctionInt('len',CM_LEN,FS);


{49}//MAX:
FS.TypeF:=T_Real; FS.TV[0]:=T_Array;
SetFunctionInt('max',CM_MAX,FS);
{50}//MIN:
FS.TypeF:=T_Real; FS.TV[0]:=T_Array;
SetFunctionInt('min',CM_MIN,FS);
{51}//PROD:
FS.TypeF:=T_Real; FS.TV[0]:=T_Array;
SetFunctionInt('prod',CM_PROD,FS);
//GCD:
FS.TypeF:=T_Real; FS.TV[0]:=T_Array;
SetFunctionInt('gcd',CM_GCD,FS);
//LCM:
FS.TypeF:=T_Real; FS.TV[0]:=T_Array;
SetFunctionInt('lcm',CM_LCM,FS);


//SUMI:
FS.NArg:=1;
FS.IntF:=_Internal;
SetLength(FS.TV,FS.NArg); SetLength(FS.TM,FS.NArg);
FS.TV[0]:=T_Array;  FS.TM[0]:=_Integer;
FS.TypeF:=T_Real;
FS.SDeep:=1;
FS.SaveReg:=1;
FS.ReplFunc:=_YES;
FS.TypeF:=T_Real;
SetFunctionInt('sumi',CM_SUMI,FS);


{.333}
//шаблон для разбора

//SUMP:
FS.ExeF:=_NO;  FS.NArg:=2;  FS.TypeF:=T_Real;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Array; FS.TV[1]:=T_Real;
SetFunctionInt('sump',CM_SUMPin,FS);
//SUMPS:
FS.ExeF:=_NO;  FS.NArg:=3;  FS.TypeF:=T_Real;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;  FS.TM[2]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Array; FS.TV[1]:=T_Real;  FS.TV[2]:=T_Real;
SetFunctionInt('sumps',CM_SUMPSin,FS);
//PRODS:
FS.ExeF:=_NO;  FS.NArg:=2;  FS.TypeF:=T_Real;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Array;   FS.TV[1]:=T_Real;
SetFunctionInt('prods',CM_PRODSin,FS);

//исполняемые функции
//SUMP
FS.NArg:=1;  FS.TypeF:=T_Real;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real;
SetFunctionInt('#sump',CM_SUMP,FS);
//SUMPS:
FS.NArg:=1;  FS.TypeF:=T_Real;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real;
SetFunctionInt('#sumps',CM_SUMPS,FS);

FS.NArg:=2;   FS.TypeF:=T_Real;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real;  FS.TV[1]:=T_Real;
SetFunctionInt('#sumps',CM_SUMPS,FS);

//PRODS:
FS.NArg:=1;  FS.TypeF:=T_Real;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real;
SetFunctionInt('#prods',CM_PRODS,FS);




{52}//SGN:
FS.NArg:=1;
SetLength(FS.TM,FS.NArg);
SetLength(FS.TV,FS.NArg);
FS.TypeF:=T_Real; FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
FS.ReplFunc:=_NO;
SetFunctionInt('sign',CM_SIGN,FS);

FS.NArg:=1; FS.TypeF:=T_Real; FS.TV[0]:=T_Complex;     {.334}
FS.ReplFunc:=_NO;
SetFunctionInt('sign',CM_SIGN,FS);

{53}//IPWRSGN    //(-1+0i)^Real; (-1)^Complex
FS.TypeF:=T_Real; FS.TV[0]:=T_Real;
FS.ReplFunc:=_YES;       {.361}
SetFunctionInt('ipwrsgn',CM_IPWRSGN,FS);
FS.TypeF:=T_Complex; FS.TV[0]:=T_Complex;
SetFunctionInt('ipwrsgn',CM_IPWRSGN,FS);


{.361}
// CM_RUNEGIPWR   (-1)^IntArg
InitFuncStruct(FS); FS.IntF:=_Internal;
FS.NArg:=0;  SetLength(FS.TM,FS.NArg); SetLength(FS.TV,FS.NArg);
FS.TypeF:=T_Real;
SetFunctionInt('reunegipwr',CM_REUNEGIPWR ,FS);

(*
{.361}
// CM_RUNEGIPWR   (-1)^Real -> (-1)^Trunc(Real)
InitFuncStruct(FS); FS.IntF:=_Internal;
FS.NArg:=0;  SetLength(FS.TM,FS.NArg); SetLength(FS.TV,FS.NArg);
FS.TypeF:=T_Real;
SetFunctionInt('reunegipwr',CM_REUNEGIPWR ,FS);

 *)

 {.361}
 {
FS.NArg:=1;
SetLength(FS.TM,FS.NArg);
SetLength(FS.TV,FS.NArg);
FS.TV[0]:=T_Real; FS.TM[0]:=_Extended;
FS.TypeF:=T_Complex;
FS.ReplFunc:=_YES;
SetFunctionInt('ipwrzsgnr',CM_IPWRZSGNR,FS);
}


{54}//LDSVX:   загрузочная ф-ия элемента массива vec[expr]
FS.NArg:=1;
SetLength(FS.TM,FS.NArg);
SetLength(FS.TV,FS.NArg);
FS.TypeF:=T_Real; FS.TV[0]:=T_Real;
FS.ReplFunc:=_Yes;   {.357}
FS.CalcConst:=_NO; {.322} // vd[1+(5)]
SetFunctionInt('ldsvx',CM_LDSVX,FS);



(*
{54}//IPWR
FS.TypeF:=T_Real; FS.TV[0]:=T_Real;
SetFunction('ipwr',FS);
FS.TypeF:=T_Complex; FS.TV[0]:=T_Complex;
SetFunction('ipwr',FS);
*)


//SetType(T_None);


//in: IF => out: '#if'
//IF(Arg1 op Arg2, Arg3, Arg4)  => if Arg1 op Arg2 then Arg3 else Arg4  op: =, <, >, <=, =<, >=, =>
//Arg1, Arg2 всегда T_Real;
//При разборе IF переходит в  #if(Arg1,Arg2,CJMP,Arg3,JMP,ARG4)
//Arg3,Arg4 - T_Real:
//шаблон для разбора
InitFuncStruct(FS);
FS.ExeF:=_NO;  FS.NArg:=3; FS.TypeF:=T_Real;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;  FS.TM[2]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;  FS.TV[2]:=T_Real;
FS.ReplFunc:=_NO;
{55}SetFunctionInt('if',CM_IFin,FS);
//IF(Arg1 op Arg2)  => if Arg1 op Arg2 then FLD1 else FLDZ  op: =, <, >, <=, =<, >=, =>
//Arg1, Arg2 всегда T_Real;
//При разборе переходит в  #if(Arg1,Arg2,CJMP,FLD1,JMP,FLDZ)
//Arg3,Arg4 - T_Real:
FS.NArg:=1; FS.TypeF:=T_Real;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real;
{55}SetFunctionInt('if',CM_IFin,FS);

//Arg3,Arg4 - T_Complex:
FS.NArg:=3; FS.TypeF:=T_Complex;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;  FS.TM[2]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real; FS.TV[1]:=T_Complex;  FS.TV[2]:=T_Complex;
{55}SetFunctionInt('if',CM_IFin,FS);


 {#if=IFNOP}
//#if(Arg1,Arg2,CJMP,Arg3,JMP,ARG4) - исполняемая функция (вместо IF)

//Arg3,Arg4 - T_Real:
InitFuncStruct(FS);
FS.NArg:=6; FS.TypeF:=T_Real;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;  FS.TM[2]:=_Extended;  FS.TM[3]:=_Extended; FS.TM[4]:=_Extended; FS.TM[5]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;  FS.TV[2]:=T_None;  FS.TV[3]:=T_Real;  FS.TV[4]:=T_None;  FS.TV[5]:=T_Real;
FS.ReplFunc:=_NO;
{56}SetFunctionInt(SCif,CM_IF,FS);

//Arg3,Arg4 - T_Complex:
FS.NArg:=6; FS.TypeF:=T_Complex;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;  FS.TM[2]:=_Extended;  FS.TM[3]:=_Extended; FS.TM[4]:=_Extended; FS.TM[5]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;  FS.TV[2]:=T_None;  FS.TV[3]:=T_Complex;  FS.TV[4]:=T_None;  FS.TV[5]:=T_Complex;
{56}SetFunctionInt(SCif,CM_IF,FS);

//if(Arg1,Arg2,goto(1),goto(2)) ->#if(Arg1,Arg2,CJMP,GOTO(1),JMP,GOTO(2))
FS.NArg:=6; FS.TypeF:=T_None;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;  FS.TM[2]:=_Extended;  FS.TM[3]:=_Extended; FS.TM[4]:=_Extended; FS.TM[5]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;  FS.TV[2]:=T_None;  FS.TV[3]:=T_None;  FS.TV[4]:=T_None;  FS.TV[5]:=T_None;
{56}SetFunctionInt(SCif,CM_IF,FS);


//if(Arg1,Arg2,goto()) ->#if(Arg1,Arg2,CJMP,GOTO())
FS.NArg:=4; FS.TypeF:=T_None;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;  FS.TM[2]:=_Extended;  FS.TM[3]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;  FS.TV[2]:=T_None;  FS.TV[3]:=T_None;
{56}SetFunctionInt(SCif,CM_IF,FS);


//Arg1,Arg2 - T_Void (IntegArg); Arg3,Arg4 - T_Real:
InitFuncStruct(FS);
FS.NArg:=6; FS.TypeF:=T_Real;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;  FS.TM[2]:=_Extended;  FS.TM[3]:=_Extended; FS.TM[4]:=_Extended; FS.TM[5]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Void; FS.TV[1]:=T_Void;  FS.TV[2]:=T_None;  FS.TV[3]:=T_Real;  FS.TV[4]:=T_None;  FS.TV[5]:=T_Real;
FS.ReplFunc:=_NO;
{56}SetFunctionInt(SCif,CM_IF,FS);


//if(Arg1,Arg2,goto()) ->#if(Arg1,Arg2,CJMP,GOTO()) ;Arg1,Arg2 - T_Void (IntegArg);
FS.NArg:=4; FS.TypeF:=T_None;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;  FS.TM[2]:=_Extended;  FS.TM[3]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Void; FS.TV[1]:=T_Void;  FS.TV[2]:=T_None;  FS.TV[3]:=T_None;
{56}SetFunctionInt(SCif,CM_IF,FS);


//if(Arg1,Arg2,goto(1),goto(2)) ->#if(Arg1,Arg2,CJMP,GOTO(1),JMP,GOTO(2)) ; Arg1,Arg2 - T_Void (IntegArg);
FS.NArg:=6; FS.TypeF:=T_None;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;  FS.TM[2]:=_Extended;  FS.TM[3]:=_Extended; FS.TM[4]:=_Extended; FS.TM[5]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Void; FS.TV[1]:=T_Void;  FS.TV[2]:=T_None;  FS.TV[3]:=T_None;  FS.TV[4]:=T_None;  FS.TV[5]:=T_None;
{56}SetFunctionInt(SCif,CM_IF,FS);


//fact2
InitFuncStruct(FS);
FS.IntF:=_Internal;{1;} FS.NArg:=1; FS.TypeF:=T_Real;
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.ReplFunc:=_NO;
{57}SetFunctionInt('fact2',CM_FACT2,FS);




{MAX}
InitFuncStruct(FS);
FS.Addr:=Cardinal(@R_MAX);
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
FS.TypeF:=T_Real;
FS.SDeep:=2;
FS.Arrow:=_Right;
FS.CallT:=_STACK_INFINITE;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionInt('max',CM_MAX,FS);
{MIN}
InitFuncStruct(FS);
FS.Addr:=Cardinal(@R_MIN);
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
FS.TypeF:=T_Real;
FS.SDeep:=2;
FS.Arrow:=_Right;
FS.CallT:=_STACK_INFINITE;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionInt('min',CM_MIN,FS);
{AVR}
InitFuncStruct(FS);
FS.Addr:=Cardinal(@R_AVR);
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
FS.TypeF:=T_Real;
FS.SDeep:=2;
FS.Arrow:=_Right;
FS.CallT:=_STACK_INFINITE;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionInt('avr',CM_AVR,FS);
{SUMQ}
InitFuncStruct(FS);
FS.Addr:=Cardinal(@R_SUMQ);
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
FS.TypeF:=T_Real;
FS.SDeep:=2;
FS.Arrow:=_Right;
FS.CallT:=_STACK_INFINITE;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionInt('sumq',CM_SUMQ,FS);
{NORM}
InitFuncStruct(FS);
FS.Addr:=Cardinal(@R_NORM);
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
FS.TypeF:=T_Real;
FS.SDeep:=2;
FS.Arrow:=_Right;
FS.CallT:=_STACK_INFINITE;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionInt('norm',CM_NORM,FS);
{SUM}
InitFuncStruct(FS);
FS.Addr:=Cardinal(@R_SUM);
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
FS.TypeF:=T_Real;
FS.SDeep:=2;
FS.Arrow:=_Right;
FS.CallT:=_STACK_INFINITE;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionInt('sum',CM_SUM,FS);
{PROD}
InitFuncStruct(FS);
FS.Addr:=Cardinal(@R_PROD);
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
FS.TypeF:=T_Real;
FS.SDeep:=2;
FS.Arrow:=_Right;
FS.CallT:=_STACK_INFINITE;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionInt('prod',CM_PROD,FS);
{GCD}
InitFuncStruct(FS);
FS.Addr:=Cardinal(@R_GCD);
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
FS.TypeF:=T_Real;
FS.SDeep:=2;
FS.Arrow:=_Right;
FS.CallT:=_STACK_INFINITE;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionInt('gcd',CM_GCD,FS);
{LCM}
InitFuncStruct(FS);
FS.Addr:=Cardinal(@R_LCM);
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
FS.TypeF:=T_Real;
FS.SDeep:=2;
FS.Arrow:=_Right;
FS.CallT:=_STACK_INFINITE;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionInt('lcm',CM_LCM,FS);



//SetType(T_Integer);



//SetLoadFunction(T_Integer,0,'Integer');

//fzSetFunctionInf('max',@R_MAX,E_Real,_Real,_StdCall,2);

//LInternalFunc:=45;
//test:
//SetObject('v1',Cardinal(@V1),T_Array,_Double);



(*
{42}//F2PWR
FS.TypeF:=T_Real; FS.TV[0]:=T_Real;
SetFunction('f2pwr',FS);
FS.TypeF:=T_Complex; FS.TV[0]:=T_Complex;
SetFunction('f2pwr',FS);
*)

{ROOT(Z,N,K)}
InitFuncStruct(FS);
FS.Addr:=Cardinal(@Z_CxIROOT3);
FS.NArg:=3;
SetLength(FS.TV,3); SetLength(FS.TM,3);
FS.TV[0]:=T_Complex;  FS.TM[0]:=_Extended;
FS.TV[1]:=T_Real;     FS.TM[1]:=_Extended;
FS.TV[2]:=T_Real;     FS.TM[2]:=_Extended;
FS.TypeF:=T_Complex;
FS.SDeep:=5;
FS.CallT:=_MEMORY_EAX;
FS.SaveReg:=15;
SetFunctionInt('root',CM_ROOT,FS);


//Для 'nop' TypeF = типу последнего аргумента или если аргументов нет = T_None
{58}
InitFuncStruct(FS);
SetLength(FS.TV,1); SetLength(FS.TM,1);
//FS.NArg:=-2;        //INFINITE_A
FS.TM[0]:=_Extended;
//FS.TypeF:=T_Complex;
FS.TypeF:=T_None;      {.193}
FS.CallT:=_INTERNAL_INFINITE_ANY;
//FS.SDeep:=0;
FS.ReplFunc:=_NO;
SetFunctionInt(SCnop,CM_NOP,FS);     //'nop'->'#nop'



InitFuncStruct(FS);
SetLength(FS.TV,1); SetLength(FS.TM,1);
//FS.NArg:=-2;        //INFINITE_A
FS.TM[0]:=_Extended;
//FS.TypeF:=T_Complex;
FS.TypeF:=T_None;      {.193}
FS.CallT:=_INTERNAL_INFINITE_ANY;
//FS.SDeep:=0;
FS.ReplFunc:=_NO;
SetFunctionInt(SCprog,CM_PROG,FS);


InitFuncStruct(FS);
SetLength(FS.TV,1); SetLength(FS.TM,1);
//FS.NArg:=-2;        //INFINITE_A
FS.TM[0]:=_Extended;
//FS.TypeF:=T_Complex;
FS.TypeF:=T_Void;         //внутренний тип, аналогичен T_None (для внешний ф-ий); используется при оптимизации ф-ий с целочисленными аргументами
FS.CallT:=_INTERNAL_INFINITE_ANY;
//FS.SDeep:=0;
FS.ReplFunc:=_NO;
SetFunctionInt(SCvoid,CM_VOID,FS);



InitFuncStruct(FS);
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TM[0]:=_Extended;
FS.TypeF:=T_Complex;
FS.CallT:=_INTERNAL_INFINITE_ANY;
//FS.SDeep:=0;
FS.ReplFunc:=_NO;
SetFunctionInt(DiffNumFunc,CM_DIFFNUMERIC,FS);



//save=>#save
//шаблон для разбора
{59}
//in:
InitFuncStruct(FS); FS.ExeF:=_NO;  FS.IntF:=_Internal;{1;}
FS.NArg:=2; FS.TypeF:=T_None;
SetLength(FS.TM,2); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;    FS.TV[1]:=T_Complex;
FS.ReplFunc:=_NO;
SetFunctionInt('save',CM_SAVEin,FS);

InitFuncStruct(FS); FS.IntF:=_Internal;
FS.NArg:=3; FS.TypeF:=T_None;
SetLength(FS.TM,3); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended; FS.TM[2]:=_Extended;
SetLength(FS.TV,3); FS.TV[0]:=T_Array;   FS.TV[1]:=T_Real;    FS.TV[2]:=T_Real;
SetFunctionInt('save',CM_SAVEin,FS);

InitFuncStruct(FS); FS.ExeF:=_NO;  FS.IntF:=_Internal;{1;}
FS.NArg:=2; FS.TypeF:=T_None;
SetLength(FS.TM,2); FS.TM[0]:=_Pointer; FS.TM[1]:=_Pointer;
SetLength(FS.TV,2); FS.TV[0]:=T_Pointer;    FS.TV[1]:=T_Pointer;
FS.ReplFunc:=_NO;
SetFunctionInt('save',CM_SAVEin,FS);

 //vd[k]=z1 ;

//out:
//исполняемая
InitFuncStruct(FS); FS.IntF:=_Internal;
FS.NArg:=1; FS.TypeF:=T_None;
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
SetFunctionInt(SCsave,CM_SAVE,FS);

//z=complex
InitFuncStruct(FS);  FS.IntF:=_Internal;
FS.NArg:=1; FS.TypeF:=T_None;
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Complex;
SetFunctionInt(SCsave,CM_SAVE,FS);

//array[real]=real
InitFuncStruct(FS);  FS.IntF:=_Internal;
FS.NArg:=2; FS.TypeF:=T_None;
SetLength(FS.TM,2); FS.TM[0]:=_Extended;  FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;  FS.TV[1]:=T_Real;
SetFunctionInt(SCsave,CM_SAVE,FS);

//=ptr

InitFuncStruct(FS); FS.IntF:=_Internal;
FS.NArg:=1; FS.TypeF:=T_None;
SetLength(FS.TM,1); FS.TM[0]:=_Pointer;
SetLength(FS.TV,1); FS.TV[0]:=T_Pointer;
SetFunctionInt(SCsave,CM_SAVE,FS);


{60}
InitFuncStruct(FS);  FS.IntF:=_Internal;
FS.NArg:=1; FS.TypeF:=T_None;
SetLength(FS.TM,1); FS.TM[0]:=_Integer;
SetLength(FS.TV,1); FS.TV[0]:=T_None;
FS.ReplFunc:=_NO;
SetFunctionInt('goto',CM_JMP,FS);


{61}
InitFuncStruct(FS);  FS.IntF:=_Internal;
FS.NArg:=1; FS.TypeF:=T_None;
SetLength(FS.TM,1); FS.TM[0]:=_Integer;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.ReplFunc:=_NO;
SetFunctionInt('inc',CM_INC,FS);


{62}
InitFuncStruct(FS);  FS.IntF:=_Internal;
FS.NArg:=1; FS.TypeF:=T_None;
SetLength(FS.TM,1); FS.TM[0]:=_Integer;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.ReplFunc:=_NO;
SetFunctionInt('dec',CM_DEC,FS);


{63}
FS.NArg:=2; FS.TypeF:=T_Complex;
SetLength(FS.TM,2); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
FS.ReplFunc:=_YES;
SetFunctionInt('decart',CM_DECART,FS);

{64}
FS.NArg:=1; FS.TypeF:=T_Real;
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.ReplFunc:=_NO;
SetFunctionInt('deg',CM_DEG,FS);

{65}
FS.NArg:=1; FS.TypeF:=T_Real;
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.ReplFunc:=_NO;
SetFunctionInt('rad',CM_RAD,FS);

{66}//DEV:
InitFuncStruct(FS);
FS.IntF:=_Internal;
FS.NArg:=1; FS.TypeF:=T_Real;
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Array;
FS.ReplFunc:=_YES;
SetFunctionInt('dev',CM_DEV,FS);

{67}//DEVS:
InitFuncStruct(FS);
FS.IntF:=_Internal;
FS.NArg:=1; FS.TypeF:=T_Real;
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Array;
FS.ReplFunc:=_YES;
SetFunctionInt('devs',CM_DEVS,FS);

{DEV}
InitFuncStruct(FS);
FS.Addr:=Cardinal(@R_DEV);
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
FS.TypeF:=T_Real;
FS.SDeep:=2;
FS.Arrow:=_Right;
FS.CallT:=_STACK_INFINITE;
FS.SaveReg:=15;
SetFunctionInt('dev',CM_DEV,FS);
{DEVS}
InitFuncStruct(FS);
FS.Addr:=Cardinal(@R_DEVS);
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
FS.TypeF:=T_Real;
FS.SDeep:=2;
FS.Arrow:=_Right;
FS.CallT:=_STACK_INFINITE;
FS.SaveReg:=15;
SetFunctionInt('devs',CM_DEVS,FS);





//шаблон для разбора
//CM_SETLENin
InitFuncStruct(FS); FS.ExeF:=_NO; FS.IntF:=_Internal;
SetLength(FS.TM,2); FS.TM[0]:=_Extended; FS.TM[1]:=_Integer;
SetLength(FS.TV,2); FS.TV[0]:=T_Array; FS.TV[1]:=T_Real;
FS.NArg:=2;
FS.TypeF:=T_None;
FS.ReplFunc:=_NO;
SetFunctionInt('setlen',CM_SETLENin,FS);

//внутренняя исполняемая, но добавлена как внешняя FS.IntF:=0
//CM_SETLEN
InitFuncStruct(FS); FS.IntF:=_External;//0;
FS.addr:=Cardinal(@SetLengthArray);
SetLength(FS.TM,3); FS.TM[0]:=_Pointer; FS.TM[1]:=_Integer; FS.TM[2]:=_Integer;
SetLength(FS.TV,3); FS.TV[0]:=T_Pointer; FS.TV[1]:=T_Real;  FS.TV[2]:=T_Real;
//вместо:   {.357A}  чтобы адрес массива передавать через CPU
//SetLength(FS.TM,3); FS.TM[0]:=_Integer{_Double}; FS.TM[1]:=_Integer; FS.TM[2]:=_Integer;
//SetLength(FS.TV,3); FS.TV[0]:=T_Real{T_Array}; FS.TV[1]:=T_Real;  FS.TV[2]:=T_Real;
FS.NArg:=3;
FS.TypeF:=T_None;
FS.SDeep:=0;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=255;
FS.ReplFunc:=_NO;    {.320}
SetFunctionInt('#setlen',CM_SETLEN,FS);




//внутренняя исполняемая, но добавлена как внешняя FS.IntF:=0
//CM_SETLEN
InitFuncStruct(FS); FS.IntF:=_External;//0;

FS.NArg:=2;
SetLength(FS.TM,FS.NArg);
SetLength(FS.TV,FS.NArg);
FS.TypeF:=T_None;
FS.SDeep:=0;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=255;
FS.ReplFunc:=_NO;    {.320}

FS.TV[0]:=T_Array;   FS.TM[0]:=_Extended;
FS.TV[1]:=T_Real;    FS.TM[1]:=_Integer;
FS.addr:=Cardinal(@SetLengthArrayE);
SetFunctionInt('setlen',CM_SETLEN,FS);
FS.TV[0]:=T_Array;   FS.TM[0]:=_Double;
FS.TV[1]:=T_Real;    FS.TM[1]:=_Integer;
FS.addr:=Cardinal(@SetLengthArrayD);
SetFunctionInt('setlen',CM_SETLEN,FS);
FS.TV[0]:=T_Array;   FS.TM[0]:=_Single;
FS.TV[1]:=T_Real;    FS.TM[1]:=_Integer;
FS.addr:=Cardinal(@SetLengthArrayS);
FS.TV[0]:=T_Array;   FS.TM[0]:=_Integer;
FS.TV[1]:=T_Real;    FS.TM[1]:=_Integer;
FS.addr:=Cardinal(@SetLengthArrayI);
SetFunctionInt('setlen',CM_SETLEN,FS);
FS.TV[0]:=T_Array;   FS.TM[0]:=_Pointer;
FS.TV[1]:=T_Real;    FS.TM[1]:=_Integer;
FS.addr:=Cardinal(@SetLengthArrayI);
SetFunctionInt('setlen',CM_SETLEN,FS);
FS.TV[0]:=T_Pointer;   FS.TM[0]:=_Pointer;
FS.TV[1]:=T_Real;      FS.TM[1]:=_Integer;
FS.addr:=Cardinal(@_SetLenU);
SetFunctionInt('setlen',CM_SETLEN,FS);





//CM_ARCTAN2 = 70
InitFuncStruct(FS); FS.IntF:=_Internal;
SetLength(FS.TM,2); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
FS.SDeep:=0;
FS.NArg:=2;
FS.TypeF:=T_Real;
FS.ReplFunc:=_YES;
SetFunctionInt('arctan2',CM_ARCTAN2,FS);


//CM_cossin = 72
InitFuncStruct(FS); FS.IntF:=_Internal;
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.SDeep:=1;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.ReplFunc:=_YES;
SetFunctionInt('cossin',CM_COSSIN,FS);


//CM_sincos = 73
InitFuncStruct(FS); FS.IntF:=_Internal;
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.SDeep:=1;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.ReplFunc:=_YES;
//SetFunctionInt('sincos',CM_SINCOS,FS);



//CM_SWAPin
InitFuncStruct(FS); FS.IntF:=_Internal;   FS.ExeF:=_NO;
SetLength(FS.TM,2); FS.TM[0]:=_Extended;  FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;     FS.TV[1]:=T_Real;
FS.SDeep:=0;
FS.NArg:=2;
FS.TypeF:=T_None;
FS.ReplFunc:=_NO;
SetFunctionInt('swap',CM_SWAPin,FS);

//CM_SWAPin
InitFuncStruct(FS); FS.IntF:=_Internal;   FS.ExeF:=_NO;
SetLength(FS.TM,2); FS.TM[0]:=_Extended;  FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex;  FS.TV[1]:=T_Complex;
FS.SDeep:=0;
FS.NArg:=2;
FS.TypeF:=T_None;
SetFunctionInt('swap',CM_SWAPin,FS);


//CM_SWAP
InitFuncStruct(FS); FS.IntF:=_Internal;
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.SDeep:=0;
FS.NArg:=1;
FS.TypeF:=T_None;
FS.ReplFunc:=_NO;
SetFunctionInt('#swap',CM_SWAP,FS);

//CM_SWAP
InitFuncStruct(FS); FS.IntF:=_Internal;
SetLength(FS.TM,2); FS.TM[0]:=_Extended;  FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;     FS.TV[1]:=T_Real;
FS.SDeep:=0;
FS.NArg:=2;
FS.TypeF:=T_None;
SetFunctionInt('#swap',CM_SWAP,FS);




//CM_SWAPIFin
InitFuncStruct(FS); FS.IntF:=_Internal;   FS.ExeF:=_NO;
SetLength(FS.TM,2); FS.TM[0]:=_Extended;  FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;     FS.TV[1]:=T_Real;
FS.SDeep:=0;
FS.NArg:=2;
FS.TypeF:=T_None;
FS.ReplFunc:=_NO;
SetFunctionInt('swapif',CM_SWAPIFin,FS);

//CM_SWAPIFin
InitFuncStruct(FS); FS.IntF:=_Internal;   FS.ExeF:=_NO;
SetLength(FS.TM,2); FS.TM[0]:=_Extended;  FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex;  FS.TV[1]:=T_Complex;
FS.SDeep:=0;
FS.NArg:=2;
FS.TypeF:=T_None;
SetFunctionInt('swapif',CM_SWAPIFin,FS);


//CM_SWAPIF
InitFuncStruct(FS); FS.IntF:=_Internal;
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.SDeep:=0;
FS.NArg:=1;
FS.TypeF:=T_None;
FS.ReplFunc:=_NO;
SetFunctionInt('#swapif',CM_SWAPIF,FS);

//CM_SWAPIF
InitFuncStruct(FS); FS.IntF:=_Internal;
SetLength(FS.TM,2); FS.TM[0]:=_Extended;  FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;     FS.TV[1]:=T_Real;
FS.SDeep:=0;
FS.NArg:=2;
FS.TypeF:=T_None;
SetFunctionInt('#swapif',CM_SWAPIF,FS);



//CM_Complex
InitFuncStruct(FS); FS.IntF:=_Internal;
SetLength(FS.TM,2); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;    FS.TV[1]:=T_Real;
FS.SDeep:=0;
FS.NArg:=2;
FS.TypeF:=T_Complex;
FS.ReplFunc:=_NO;
SetFunctionInt('complex',CM_COMPLEX,FS);



//MOD:
InitFuncStruct(FS);
FS.IntF:=_Internal; FS.NArg:=2;  FS.SDeep:=0;  FS.TypeF:=T_Real;
SetLength(FS.TM,2); FS.TM[0]:=_Extended;  FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;  FS.TV[1]:=T_Real;
FS.ReplFunc:=_NO;
SetFunctionInt('mod',CM_MOD,FS);


//IDIV:
InitFuncStruct(FS);
FS.IntF:=_Internal; FS.NArg:=2;  FS.SDeep:=0;  FS.TypeF:=T_Real;
SetLength(FS.TM,2); FS.TM[0]:=_Extended;  FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;  FS.TV[1]:=T_Real;
FS.ReplFunc:=_NO;
SetFunctionInt('idiv',CM_IDIV,FS);

//IPWR:
InitFuncStruct(FS); FS.IntF:=_Internal; FS.NArg:=1;
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TypeF:=T_Real; FS.TV[0]:=T_Real;     FS.TM[0]:=_Extended;
FS.ReplFunc:=_YES;                              {.216}
SetFunctionInt('#ipwr',CM_IPWR,FS);
FS.TypeF:=T_Complex; FS.TV[0]:=T_Complex;     FS.TM[0]:=_Extended;
SetFunctionInt('#ipwr',CM_IPWR,FS);


InitFuncStruct(FS); FS.IntF:=_Internal; FS.NArg:=1;
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TypeF:=T_Real; FS.TV[0]:=T_Real;     FS.TM[0]:=_Extended;
FS.ReplFunc:=_YES;
SetFunctionInt('#ipwr16',CM_IPWR16,FS);
FS.TypeF:=T_Complex; FS.TV[0]:=T_Complex;     FS.TM[0]:=_Extended;
SetFunctionInt('#ipwr16',CM_IPWR16,FS);


//IROOT:
InitFuncStruct(FS); FS.IntF:=_Internal; FS.NArg:=1;
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TypeF:=T_Real; FS.TV[0]:=T_Real;     FS.TM[0]:=_Extended;
FS.ReplFunc:=_YES;
SetFunctionInt('#iroot',CM_IROOT,FS);
FS.TypeF:=T_Complex; FS.TV[0]:=T_Complex;     FS.TM[0]:=_Extended;
SetFunctionInt('#iroot',CM_IROOT,FS);




//POLY: {81}
//шаблон для разбора: poly(array,arg)
InitFuncStruct(FS);
FS.IntF:=_Internal; FS.ExeF:=_NO;
FS.NArg:=2; FS.TypeF:=T_Real;
SetLength(FS.TM,2);
SetLength(FS.TV,2);
FS.TV[0]:=T_Array; FS.TM[0]:=_Extended;
FS.TV[1]:=T_Real;  FS.TM[1]:=_Extended;
FS.ReplFunc:=_YES;
SetFunctionInt('polynom',CM_POLYin,FS);

InitFuncStruct(FS);
FS.IntF:=_Internal;  FS.ExeF:=_NO;
FS.NArg:=2; FS.TypeF:=T_Complex;
SetLength(FS.TM,2);
SetLength(FS.TV,2);
FS.TV[0]:=T_Array;    FS.TM[0]:=_Extended;
FS.TV[1]:=T_Complex;  FS.TM[1]:=_Extended;
SetFunctionInt('polynom',CM_POLYin,FS);



//исполняемые функции :
InitFuncStruct(FS);
FS.IntF:=_Internal;
FS.NArg:=1; FS.TypeF:=T_Real;
SetLength(FS.TM,1); SetLength(FS.TV,1);
FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
SetFunctionInt('#polynom',CM_POLY,FS);

InitFuncStruct(FS);
FS.IntF:=_Internal;
FS.NArg:=1; FS.TypeF:=T_Complex;
SetLength(FS.TM,1); SetLength(FS.TV,1);
FS.TV[0]:=T_Complex;  FS.TM[0]:=_Extended;
SetFunctionInt('#polynom',CM_POLY,FS);


{.353}
InitFuncStruct(FS);
FS.IntF:=_Internal;
SetLength(FS.TM,1); SetLength(FS.TV,1);
FS.TV[0]:=T_Complex;  FS.TM[0]:=_Extended;//условно
FS.TypeF:=T_None;  //определяется при разборе по типу аргументов
FS.CallT:=_INTERNAL_INFINITE_ANY;
SetFunctionInt('#polynomu',CM_POLYU,FS);



//polynomdiff
//шаблон для разбора: polynomdiff(array,arg,Ndiff)
InitFuncStruct(FS);
FS.IntF:=_Internal; FS.ExeF:=_NO;
FS.NArg:=3; FS.TypeF:=T_Real;
SetLength(FS.TM,FS.NArg);
SetLength(FS.TV,FS.NArg);
FS.TV[0]:=T_Array; FS.TM[0]:=_Extended;
FS.TV[1]:=T_Real;  FS.TM[1]:=_Extended;
FS.TV[2]:=T_Real;  FS.TM[2]:=_Integer;
FS.ReplFunc:=_YES;
SetFunctionInt('polynomdiff',CM_POLYDIFFin,FS);

InitFuncStruct(FS);
FS.IntF:=_Internal; FS.ExeF:=_NO;
FS.NArg:=3; FS.TypeF:=T_Complex;
SetLength(FS.TM,FS.NArg);
SetLength(FS.TV,FS.NArg);
FS.TV[0]:=T_Array; FS.TM[0]:=_Extended;
FS.TV[1]:=T_Complex;  FS.TM[1]:=_Extended;
FS.TV[2]:=T_Real;  FS.TM[2]:=_Integer;
FS.ReplFunc:=_YES;
SetFunctionInt('polynomdiff',CM_POLYDIFFin,FS);


//исполняемые функции :
InitFuncStruct(FS);
FS.IntF:=_Internal;
FS.NArg:=1; FS.TypeF:=T_Real;
SetLength(FS.TM,FS.NArg); SetLength(FS.TV,FS.NArg);
FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
SetFunctionInt('#polynomdiff',CM_POLYDIFF,FS);

InitFuncStruct(FS);
FS.IntF:=_Internal;
FS.NArg:=1; FS.TypeF:=T_Complex;
SetLength(FS.TM,FS.NArg); SetLength(FS.TV,FS.NArg);
FS.TV[0]:=T_Complex;  FS.TM[0]:=_Extended;
SetFunctionInt('#polynomdiff',CM_POLYDIFF,FS);



{.223}
InitFuncStruct(FS);
FS.IntF:=_Internal;  FS.TypeF:=T_Real;
FS.NArg:=2; SetLength(FS.TM,FS.NArg); SetLength(FS.TV,FS.NArg);
FS.TV[0]:=T_Real;    FS.TM[0]:=_Extended;
FS.TV[1]:=T_Real;    FS.TM[1]:=_Extended;
SetFunctionInt('max23',CM_MAX23,FS);

FS.NArg:=3; SetLength(FS.TM,FS.NArg); SetLength(FS.TV,FS.NArg);
FS.TV[0]:=T_Real;    FS.TM[0]:=_Extended;
FS.TV[1]:=T_Real;    FS.TM[1]:=_Extended;
FS.TV[2]:=T_Real;    FS.TM[2]:=_Extended;
SetFunctionInt('max23',CM_MAX23,FS);


InitFuncStruct(FS);
FS.IntF:=_Internal;  FS.TypeF:=T_Real;
FS.NArg:=2; SetLength(FS.TM,FS.NArg); SetLength(FS.TV,FS.NArg);
FS.TV[0]:=T_Real;    FS.TM[0]:=_Extended;
FS.TV[1]:=T_Real;    FS.TM[1]:=_Extended;
SetFunctionInt('min23',CM_MIN23,FS);

FS.NArg:=3; SetLength(FS.TM,FS.NArg); SetLength(FS.TV,FS.NArg);
FS.TV[0]:=T_Real;    FS.TM[0]:=_Extended;
FS.TV[1]:=T_Real;    FS.TM[1]:=_Extended;
FS.TV[2]:=T_Real;    FS.TM[2]:=_Extended;
SetFunctionInt('min23',CM_MIN23,FS);

InitFuncStruct(FS);
FS.IntF:=_Internal;  FS.TypeF:=T_Real;
FS.NArg:=2; SetLength(FS.TM,FS.NArg); SetLength(FS.TV,FS.NArg);
FS.TV[0]:=T_Real;    FS.TM[0]:=_Extended;
FS.TV[1]:=T_Real;    FS.TM[1]:=_Extended;
SetFunctionInt('avr23',CM_AVR23,FS);

FS.NArg:=3; SetLength(FS.TM,FS.NArg); SetLength(FS.TV,FS.NArg);
FS.TV[0]:=T_Real;    FS.TM[0]:=_Extended;
FS.TV[1]:=T_Real;    FS.TM[1]:=_Extended;
FS.TV[2]:=T_Real;    FS.TM[2]:=_Extended;
SetFunctionInt('avr23',CM_AVR23,FS);


InitFuncStruct(FS);
FS.IntF:=_Internal;  FS.TypeF:=T_Real;
FS.NArg:=2; SetLength(FS.TM,FS.NArg); SetLength(FS.TV,FS.NArg);
FS.TV[0]:=T_Real;    FS.TM[0]:=_Extended;
FS.TV[1]:=T_Real;    FS.TM[1]:=_Extended;
SetFunctionInt('norm23',CM_NORM23,FS);

FS.NArg:=3; SetLength(FS.TM,FS.NArg); SetLength(FS.TV,FS.NArg);
FS.TV[0]:=T_Real;    FS.TM[0]:=_Extended;
FS.TV[1]:=T_Real;    FS.TM[1]:=_Extended;
FS.TV[2]:=T_Real;    FS.TM[2]:=_Extended;
SetFunctionInt('norm23',CM_NORM23,FS);


//2^real
InitFuncStruct(FS); FS.IntF:=_Internal;
FS.NArg:=1;  SetLength(FS.TM,FS.NArg); SetLength(FS.TV,FS.NArg);
FS.TypeF:=T_Real; FS.TV[0]:=T_Real;   FS.TM[0]:=_Extended;
SetFunctionInt('f2pwr',CM_F2PWR,FS);


{.361}
//i^(IntArg); (-i)^IntArg
InitFuncStruct(FS); FS.IntF:=_Internal;
FS.NArg:=0;  SetLength(FS.TM,FS.NArg); SetLength(FS.TV,FS.NArg);
FS.TypeF:=T_Complex;
SetFunctionInt('imupwr',CM_IMUIPWR,FS);

{.361}
// CM_IMURZPWR { (+-I)^(Real,Complex) }
FS.NArg:=1;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real;
FS.TypeF:=T_Complex;
FS.ReplFunc:=_YES;
SetFunctionInt('imurzpwr',CM_IMURZPWR,FS);
FS.TV[0]:=T_Complex;
SetFunctionInt('imurzpwr',CM_IMURZPWR,FS);


//CM_CZPWR    { Const(Real,Complex)^Complex }
//Первая: аргумент всегда Real!! NF = 0;   NF = 1 (Complex)
FS.NArg:=1;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real;
FS.TypeF:=T_Complex;
SetFunctionInt('czpwr',CM_CZPWR,FS);
FS.NArg:=1;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Complex;
FS.TypeF:=T_Complex;
SetFunctionInt('czpwr',CM_CZPWR,FS);





{.227}
InitFuncStruct(FS); FS.IntF:=_Internal;
FS.NArg:=0;  SetLength(FS.TM,FS.NArg); SetLength(FS.TV,FS.NArg);
FS.TypeF:=T_None;
FS.CalcConst:=_NO;
FS.ReplFunc:=_NO;
SetFunctionInt('try',CM_TRY,FS);

InitFuncStruct(FS); FS.IntF:=_Internal;
FS.NArg:=0; FS.TypeF:=T_Real; SetLength(FS.TM,FS.NArg); SetLength(FS.TV,FS.NArg);
FS.SDeep:=1;
FS.CalcConst:=_NO;
FS.ReplFunc:=_NO;
SetFunctionInt('exception',CM_EXCEPTION,FS);








//шаблон для разбора: random,rand,rnd (),(int),(float1,float2)
InitFuncStruct(FS);
FS.IntF:=_Internal; FS.ExeF:=_NO;
FS.NArg:=0; FS.TypeF:=T_Real;
SetLength(FS.TM,0);
SetLength(FS.TV,0);
FS.ReplFunc:=_NO;
FS.CalcConst:=_NO;
SetFunctionInt('random',CM_RANDin,FS);


InitFuncStruct(FS);
FS.IntF:=_Internal; FS.ExeF:=_NO;
FS.NArg:=1; FS.TypeF:=T_Real;
SetLength(FS.TM,1);
SetLength(FS.TV,1);
FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
FS.ReplFunc:=_NO;
FS.CalcConst:=_NO;
SetFunctionInt('random',CM_RANDin,FS);


InitFuncStruct(FS);
FS.IntF:=_Internal; FS.ExeF:=_NO;
FS.NArg:=2; FS.TypeF:=T_Real;
SetLength(FS.TM,2);
SetLength(FS.TV,2);
FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
FS.TV[1]:=T_Real;  FS.TM[1]:=_Extended;
FS.ReplFunc:=_NO;
FS.CalcConst:=_NO;
SetFunctionInt('random',CM_RANDin,FS);





{.347}
InitFuncStruct(FS); FS.IntF:=_Internal;
FS.NArg:=1;
SetLength(FS.TM,FS.NArg); SetLength(FS.TV,FS.NArg);
//FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
FS.TV[0]:=T_Pointer;  FS.TM[0]:=_Pointer;
FS.TypeF:=T_Real;
FS.SDeep:=8;
SetFunctionInt('callr',CM_CALLR,FS);
FS.TypeF:=T_Complex;
SetFunctionInt('callc',CM_CALLCX,FS);
FS.TypeF:=T_None;
SetFunctionInt('call',CM_CALL,FS);



SetExtNameFunc(CM_POWER,'pow');
SetExtNameFunc(CM_LOGN,'logn');
SetExtNameFunc(CM_TAN,'tg');
SetExtNameFunc(CM_COTAN,'ctg');   SetExtNameFunc(CM_COTAN,'cot');
SetExtNameFunc(CM_ARCCOS,'acos');
SetExtNameFunc(CM_ARCSIN,'asin');
SetExtNameFunc(CM_ARCTAN,'atan'); SetExtNameFunc(CM_ARCTAN,'arctg'); SetExtNameFunc(CM_ARCTAN,'atg');
SetExtNameFunc(CM_ARCCOTAN,'arccotan');SetExtNameFunc(CM_ARCCOTAN,'acot'); SetExtNameFunc(CM_ARCCOTAN,'arccot'); SetExtNameFunc(CM_ARCCOTAN,'arcctg'); SetExtNameFunc(CM_ARCCOTAN,'actg');
SetExtNameFunc(CM_SINH,'sh');
SetExtNameFunc(CM_COSH,'ch');
SetExtNameFunc(CM_TANH,'th');
SetExtNameFunc(CM_COTANH,'cth');  SetExtNameFunc(CM_COTANH,'coth');
SetExtNameFunc(CM_ARCCOSH,'arcch');SetExtNameFunc(CM_ARCCOSH,'acosh');SetExtNameFunc(CM_ARCCOSH,'ach');  SetExtNameFunc(CM_ARCCOSH,'arch'); SetExtNameFunc(CM_ARCCOSH,'arcosh');
SetExtNameFunc(CM_ARCSINH,'arcsh');SetExtNameFunc(CM_ARCSINH,'asinh'); SetExtNameFunc(CM_ARCSINH,'ash');  SetExtNameFunc(CM_ARCSINH,'arsh'); SetExtNameFunc(CM_ARCSINH,'arsinh');
SetExtNameFunc(CM_ARCTANH,'arcth');SetExtNameFunc(CM_ARCTANH,'ath'); SetExtNameFunc(CM_ARCTANH,'atanh'); SetExtNameFunc(CM_ARCTANH,'arth'); SetExtNameFunc(CM_ARCTANH,'artanh');
SetExtNameFunc(CM_ARCCOTANH,'arccth');SetExtNameFunc(CM_ARCCOTANH,'acth'); SetExtNameFunc(CM_ARCCOTANH,'arccoth'); SetExtNameFunc(CM_ARCCOTANH,'acoth'); SetExtNameFunc(CM_ARCCOTANH,'arcoth');
SetExtNameFunc(CM_COSECH,'csch');
SetExtNameFunc(CM_ARCCOSECH,'arccsch');  SetExtNameFunc(CM_ARCCOSECH,'arcosech');  SetExtNameFunc(CM_ARCCOSECH,'acsch');
SetExtNameFunc(CM_ARCSECH,'arsech');   SetExtNameFunc(CM_ARCSECH,'asech');
SetExtNameFunc(CM_COSEC,'csc');
SetExtNameFunc(CM_ARCSEC,'asec');
SetExtNameFunc(CM_ARCCOSEC,'arccsc'); SetExtNameFunc(CM_ARCCOSEC,'acsc'); SetExtNameFunc(CM_ARCCOSEC,'acosec');
SetExtNameFunc(CM_LOG10,'lg');
SetExtNameFunc(CM_LOG2,'lg2');
SetExtNameFunc(CM_AVR,'avg');
SetExtNameFunc(CM_SIGN,'sgn');
SetExtNameFunc(CM_ARCTAN2,'atan2');  SetExtNameFunc(CM_ARCTAN2,'arctg2'); SetExtNameFunc(CM_ARCTAN2,'atg2');
SetExtNameFunc(CM_POLYin,'poly');
SetExtNameFunc(CM_RANDin,'rand');   SetExtNameFunc(CM_RANDin,'rnd');
SetExtNameFunc(CM_CON,'conj');




//внутренняя. подключена, как внешняя
(*
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@PolyDiffN);
FS.NArg:=4;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Array;   FS.TV[1]:=T_Real;     FS.TV[2]:=T_Real;   FS.TV[3]:=T_Real;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;  FS.TM[2]:=_Integer; FS.TM[3]:=_Integer;
FS.TypeF:=T_Real;
FS.SDeep:=3; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Adr;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionInt('PolyDiffN@',CM_POLYDIFFN,FS);
*)

(*
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@PolyDiffE);
FS.NArg:=3;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Array;   FS.TV[1]:=T_Real;     FS.TV[2]:=T_Real;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;  FS.TM[2]:=_Integer;
FS.TypeF:=T_Real;
FS.SDeep:=3; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionInt('#PolyDiffN',CM_POLYDIFFN,FS);
*)


//real
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@PolyDiffVN);
FS.NArg:=4;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Array ;  FS.TV[1]:=T_Real;     FS.TV[2]:=T_Real;   FS.TV[3]:=T_Real;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;  FS.TM[2]:=_Integer; FS.TM[3]:=_Integer;
FS.TypeF:=T_Real;
FS.SDeep:=3; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_STACK_VAL;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionInt('#PolyDiffN',CM_POLYDIFFN,FS);
FS.TV[0]:=T_Array ;  FS.TM[0]:=_Double;
SetFunctionInt('#PolyDiffN',CM_POLYDIFFN,FS);
FS.TV[0]:=T_Array ;  FS.TM[0]:=_Single;
SetFunctionInt('#PolyDiffN',CM_POLYDIFFN,FS);
FS.TV[0]:=T_Array ;  FS.TM[0]:=_Integer;
SetFunctionInt('#PolyDiffN',CM_POLYDIFFN,FS);



//complex:
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@PolyDiffVNcx);
FS.NArg:=4;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Array ;  FS.TV[1]:=T_Complex;    FS.TV[2]:=T_Real;   FS.TV[3]:=T_Real;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;    FS.TM[2]:=_Integer; FS.TM[3]:=_Integer;
FS.TypeF:=T_Complex;
FS.SDeep:=3; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_VAL;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionInt('#PolyDiffN',CM_POLYDIFFN,FS);
FS.TV[0]:=T_Array ;  FS.TM[0]:=_Double;
SetFunctionInt('#PolyDiffN',CM_POLYDIFFN,FS);
FS.TV[0]:=T_Array ;  FS.TM[0]:=_Single;
SetFunctionInt('#PolyDiffN',CM_POLYDIFFN,FS);
FS.TV[0]:=T_Array ;  FS.TM[0]:=_Integer;
SetFunctionInt('#PolyDiffN',CM_POLYDIFFN,FS);


(*
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@PolyDiffEcx);
FS.NArg:=3;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Array;     FS.TV[1]:=T_Complex;     FS.TV[2]:=T_Real;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended;   FS.TM[1]:=_Extended;     FS.TM[2]:=_Integer;
FS.TypeF:=T_Complex;
FS.SDeep:=3; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionInt('#PolyDiffN',CM_POLYDIFFN,FS);


//real:
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@PolyDiffD);
FS.NArg:=3;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Array;   FS.TV[1]:=T_Real;     FS.TV[2]:=T_Real;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Double;   FS.TM[1]:=_Extended;  FS.TM[2]:=_Integer;
FS.TypeF:=T_Real;
FS.SDeep:=3; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionInt('#PolyDiffN',CM_POLYDIFFN,FS);
//complex:
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@PolyDiffDcx);
FS.NArg:=3;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Array;   FS.TV[1]:=T_Complex;     FS.TV[2]:=T_Real;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Double;   FS.TM[1]:=_Extended;     FS.TM[2]:=_Integer;
FS.TypeF:=T_Complex;
FS.SDeep:=3; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionInt('#PolyDiffN',CM_POLYDIFFN,FS);


//real
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@PolyDiffI);
FS.NArg:=3;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Array;   FS.TV[1]:=T_Real;     FS.TV[2]:=T_Real;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Integer;  FS.TM[1]:=_Extended;  FS.TM[2]:=_Integer;
FS.TypeF:=T_Real;
FS.SDeep:=3; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionInt('#PolyDiffN',CM_POLYDIFFN,FS);
//complex:
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@PolyDiffIcx);
FS.NArg:=3;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Array;    FS.TV[1]:=T_Complex;     FS.TV[2]:=T_Real;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Integer;   FS.TM[1]:=_Extended;     FS.TM[2]:=_Integer;
FS.TypeF:=T_Complex;
FS.SDeep:=3; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionInt('#PolyDiffN',CM_POLYDIFFN,FS);


InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@PolyDiffS);
FS.NArg:=3;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Array;   FS.TV[1]:=T_Real;     FS.TV[2]:=T_Real;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Single; FS.TM[1]:=_Extended;  FS.TM[2]:=_Integer;
FS.TypeF:=T_Real;
FS.SDeep:=3; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionInt('#PolyDiffN',CM_POLYDIFFN,FS);
*)






//EXTERNAL FUNCTIONS (FS.IntF:=_External {0})

InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@mt_rand2);
SetLength(FS.TM,2); FS.TM[0]:=_Double; FS.TM[1]:=_Double;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
FS.NArg:=2;
FS.TypeF:=T_Real;
FS.SDeep:=2;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.SaveReg:=15;
FS.CalcConst:=_NO;
FS.ReplFunc:=_NO;
SetFunction('randommt',FS);  FindFuncA('randommt',NF); SetExtNameFunc(NF,'randmt');  SetExtNameFunc(NF,'rndmt');


InitFuncStruct(FS);  FS.IntF:=_External;
FS.addr:=Cardinal(@MT_intrand);
SetLength(FS.TM,1); FS.TM[0]:=_Integer;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.Arrow:=_Right;
//FS.CallT:=_Stack_Addr;
FS.NArg:=1;
FS.TypeF:=T_real;
FS.CallT:=_STACK_VAL;
FS.SDeep:=2;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
FS.CalcConst:=_NO;
SetFunction('intrandommt',FS);  FindFuncA('intrandommt',NF);  SetExtNameFunc(NF,'irandmt'); SetExtNameFunc(NF,'irndmt');


InitFuncStruct(FS);  FS.IntF:=_External;
FS.addr:=Cardinal(@MT_rand01);
SetLength(FS.TM,0);
SetLength(FS.TV,0);
FS.Arrow:=_Right;
//FS.CallT:=_Stack_Adr;
FS.NArg:=0;
FS.TypeF:=T_real;
FS.CallT:=_STACK_VAL;
FS.SDeep:=2;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
FS.CalcConst:=_NO;
SetFunction('random01mt',FS);  FindFuncA('random01mt',NF);  SetExtNameFunc(NF,'rand01mt'); SetExtNameFunc(NF,'rnd01mt');


InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@ple_rand2);
SetLength(FS.TM,2); FS.TM[0]:=_Double; FS.TM[1]:=_Double;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
FS.NArg:=2;
FS.TypeF:=T_Real;
FS.SDeep:=2;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
FS.CalcConst:=_NO;
SetFunction('randomple',FS); FindFuncA('randomple',NF); SetExtNameFunc(NF,'randple');  SetExtNameFunc(NF,'randple');
                                                        SetExtNameFunc(NF,'randf');    SetExtNameFunc(NF,'rndple');


InitFuncStruct(FS);  FS.IntF:=_External;
FS.addr:=Cardinal(@PLE_intrand);
SetLength(FS.TM,1); FS.TM[0]:=_Integer;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.Arrow:=_Right;
//FS.CallT:=_Stack_Adr;
FS.NArg:=1;
FS.TypeF:=T_real;
FS.CallT:=_STACK_VAL;
FS.SDeep:=2;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
FS.CalcConst:=_NO;
SetFunction('intrandomple',FS);  FindFuncA('intrandomple',NF);  SetExtNameFunc(NF,'irandple'); SetExtNameFunc(NF,'irndple');


InitFuncStruct(FS);  FS.IntF:=_External;
FS.addr:=Cardinal(@PLE_rand01);
SetLength(FS.TM,0);
SetLength(FS.TV,0);
FS.Arrow:=_Right;
//FS.CallT:=_Stack_Adr;
FS.NArg:=0;
FS.TypeF:=T_real;
FS.CallT:=_STACK_VAL;
FS.SDeep:=2;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
FS.CalcConst:=_NO;
SetFunction('random01ple',FS);  FindFuncA('random01ple',NF);  SetExtNameFunc(NF,'rand01ple'); SetExtNameFunc(NF,'rnd01ple');



InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@xor_rand2);
SetLength(FS.TM,2); FS.TM[0]:=_Double; FS.TM[1]:=_Double;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
FS.NArg:=2;
FS.TypeF:=T_Real;
FS.SDeep:=2;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.CalcConst:=_NO;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
SetFunction('randomxor',FS);  FindFuncA('randomxor',NF); SetExtNameFunc(NF,'randxor');  SetExtNameFunc(NF,'rndxor');


InitFuncStruct(FS);  FS.IntF:=_External;
FS.addr:=Cardinal(@XOR_intrand);
SetLength(FS.TM,1); FS.TM[0]:=_Integer;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.Arrow:=_Right;
//FS.CallT:=_Stack_Adr;
FS.NArg:=1;
FS.TypeF:=T_real;
FS.CallT:=_STACK_VAL;
FS.SDeep:=2;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
FS.CalcConst:=_NO;
SetFunction('intrandomxor',FS);  FindFuncA('intrandomxor',NF);  SetExtNameFunc(NF,'irandxor'); SetExtNameFunc(NF,'irndxor');


InitFuncStruct(FS);  FS.IntF:=_External;
FS.addr:=Cardinal(@XOR_rand01);
SetLength(FS.TM,0);
SetLength(FS.TV,0);
FS.Arrow:=_Right;
//FS.CallT:=_Stack_Addr;
FS.NArg:=0;
FS.TypeF:=T_real;
FS.CallT:=_STACK_VAL;
FS.SDeep:=2;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
FS.CalcConst:=_NO;
SetFunction('random01xor',FS);  FindFuncA('random01xor',NF);  SetExtNameFunc(NF,'rand01xor'); SetExtNameFunc(NF,'rnd01xor');


InitFuncStruct(FS);  FS.IntF:=_External;
FS.addr:=Cardinal(@_Randomize);
SetLength(FS.TM,0);
SetLength(FS.TV,0);
FS.Arrow:=_Right;
//FS.CallT:=_Stack_Adr;
FS.NArg:=0;
FS.CallT:=_STACK_VAL;
FS.SDeep:=2;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
FS.CalcConst:=_NO;
FS.TypeF:=T_None;
SetFunction('randomize',FS);



InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sphY);
SetLength(FS.TM,4); FS.TM[0]:=_Integer; FS.TM[1]:=_Integer; FS.TM[2]:=_Extended; FS.TM[3]:=_Extended;
SetLength(FS.TV,4); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;  FS.TV[2]:=T_Real; FS.TV[3]:=T_Real;
FS.NArg:=4;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('sphy',FS);   FindFuncA('sphy',NF); SetExtNameFunc(NF,'sphericalharmonics');  SetExtNameFunc(NF,'sphericalharmonicy');



InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_gamma);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('gamma',FS);

FS.addr:=Cardinal({@cgamma}@sfc_gammaCx);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('gamma',FS);



 {.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_lngamma);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('lngamma',FS);
  {.334}
FS.addr:=Cardinal(@sfc_lngammaCx);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('lngamma',FS);



InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_psi);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('psi',FS);
FindFuncA('psi',NF); SetExtNameFunc(NF,'digamma');



{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_psiCx);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('psi',FS);






InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_trigamma);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('psid1',FS);     FindFuncA('psid1',NF); SetExtNameFunc(NF,'trigamma');



InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_tetragamma);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('psid2',FS);  FindFuncA('psid2',NF); SetExtNameFunc(NF,'tetragamma');



InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_pentagamma);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('psid3',FS);   FindFuncA('psid3',NF); SetExtNameFunc(NF,'pentagamma');





{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_polygamma);
FS.NArg:=2;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Integer; FS.TM[1]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real;    FS.TV[1]:=T_Real;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('polygamma',FS);    FindFuncA('polygamma',NF);
SetExtNameFunc(NF,'gammapoly');






{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_igammaq);
FS.NArg:=2;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real;    FS.TV[1]:=T_Real;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('gammaincun',FS);    FindFuncA('gammaincun',NF);
SetExtNameFunc(NF,'gammaq');





{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_igammap);
FS.NArg:=2;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real;    FS.TV[1]:=T_Real;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('gammaincln',FS);    FindFuncA('gammaincln',NF);
SetExtNameFunc(NF,'gammap');





{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_igammal);
FS.NArg:=2;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real;    FS.TV[1]:=T_Real;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('gammaincl',FS);    FindFuncA('gammaincl',NF);
SetExtNameFunc(NF,'gammal');






{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_igamma);
FS.NArg:=2;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real;    FS.TV[1]:=T_Real;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('gammaincu',FS);    FindFuncA('gammaincu',NF);
SetExtNameFunc(NF,'gammau');






{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_igammap_inv);
FS.NArg:=2;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real;    FS.TV[1]:=T_Real;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('gammaincinvln',FS);   FindFuncA('gammaincinvln',NF);
SetExtNameFunc(NF,'gammainvp');





{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_igammaq_inv);
FS.NArg:=2;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real;    FS.TV[1]:=T_Real;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('gammaincinvun',FS);   FindFuncA('gammaincinvun',NF);
SetExtNameFunc(NF,'gammainvq');









InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@bessel_j0);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('besselj0',FS);    FindFuncA('besselj0',NF); SetExtNameFunc(NF,'bj0');


InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@bessel_j1);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('besselj1',FS);    FindFuncA('besselj1',NF); SetExtNameFunc(NF,'bj1');




InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@bessel_jn);
SetLength(FS.TM,2); FS.TM[0]:=_Integer; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
FS.NArg:=2;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('besseljn',FS);    FindFuncA('besseljn',NF); SetExtNameFunc(NF,'bjn');


InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@bessel_jv);
SetLength(FS.TM,2); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
FS.NArg:=2;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('besseljv',FS);    FindFuncA('besseljv',NF); SetExtNameFunc(NF,'bjv');    SetExtNameFunc(NF,'besselj');



InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@bessel_y0);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('bessely0',FS);     FindFuncA('bessely0',NF); SetExtNameFunc(NF,'by0');


InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@bessel_y1);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('bessely1',FS);    FindFuncA('bessely1',NF); SetExtNameFunc(NF,'by1');



InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@bessel_yn);
SetLength(FS.TM,2); FS.TM[0]:=_Integer; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
FS.NArg:=2;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('besselyn',FS);     FindFuncA('besselyn',NF); SetExtNameFunc(NF,'byn');



InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@bessel_yv);
SetLength(FS.TM,2); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
FS.NArg:=2;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('besselyv',FS);    FindFuncA('besselyv',NF); SetExtNameFunc(NF,'byv');  SetExtNameFunc(NF,'bessely');



InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@bessel_i0);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('besseli0',FS);    FindFuncA('besseli0',NF); SetExtNameFunc(NF,'bi0');


InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@bessel_i1);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('besseli1',FS);    FindFuncA('besseli1',NF); SetExtNameFunc(NF,'bi1');



InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@bessel_in);
SetLength(FS.TM,2); FS.TM[0]:=_Integer; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
FS.NArg:=2;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('besselin',FS);    FindFuncA('besselin',NF); SetExtNameFunc(NF,'bin');



InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@bessel_iv);
SetLength(FS.TM,2); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
FS.NArg:=2;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('besseliv',FS);    FindFuncA('besseliv',NF); SetExtNameFunc(NF,'biv');   SetExtNameFunc(NF,'biv');  SetExtNameFunc(NF,'besseli');




InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@bessel_k0);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('besselk0',FS);    FindFuncA('besselk0',NF); SetExtNameFunc(NF,'bk0');


InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@bessel_k1);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('besselk1',FS);    FindFuncA('besselk1',NF); SetExtNameFunc(NF,'bk1');



InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@bessel_kn);
SetLength(FS.TM,2); FS.TM[0]:=_Integer; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
FS.NArg:=2;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('besselkn',FS);    FindFuncA('besselkn',NF); SetExtNameFunc(NF,'bkn');



InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@bessel_kv);
SetLength(FS.TM,2); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
FS.NArg:=2;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('besselkv',FS);    FindFuncA('besselkv',NF); SetExtNameFunc(NF,'bkv');    SetExtNameFunc(NF,'besselk');





InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sph_bessel_jn);
SetLength(FS.TM,2); FS.TM[0]:=_Integer; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
FS.NArg:=2;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('sphbesseljn',FS);     FindFuncA('sphbesseljn',NF);
SetExtNameFunc(NF,'sphbjn'); SetExtNameFunc(NF,'sbjn'); SetExtNameFunc(NF,'sphbesselj');


InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sph_bessel_yn);
SetLength(FS.TM,2); FS.TM[0]:=_Integer; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
FS.NArg:=2;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('sphbesselyn',FS);     FindFuncA('sphbesselyn',NF);
SetExtNameFunc(NF,'sphbyn'); SetExtNameFunc(NF,'sbyn'); SetExtNameFunc(NF,'sphbessely');




InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_legendre_p);
SetLength(FS.TM,2); FS.TM[0]:=_Integer; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
FS.NArg:=2;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('legendrep',FS);    FindFuncA('legendrep',NF); SetExtNameFunc(NF,'legp');   SetExtNameFunc(NF,'legpoly');


InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_legendre_plm);
SetLength(FS.TM,3); FS.TM[0]:=_Integer; FS.TM[1]:=_Integer; FS.TM[2]:=_Extended;
SetLength(FS.TV,3); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;  FS.TV[2]:=T_Real;
FS.NArg:=3;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('legendrep',FS);



InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_zeta);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('zeta',FS);


{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_zetaCx);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('zeta',FS);




InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_chebyshev_t);
SetLength(FS.TM,2); FS.TM[0]:=_Integer; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
FS.NArg:=2;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('chebyshevt',FS);    FindFuncA('chebyshevt',NF);
SetExtNameFunc(NF,'tcheb');   SetExtNameFunc(NF,'chebt');   SetExtNameFunc(NF,'tchebpoly');
SetExtNameFunc(NF,'chebtpoly');  SetExtNameFunc(NF,'polychebt');   SetExtNameFunc(NF,'polytcheb');



InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_chebyshev_u);
SetLength(FS.TM,2); FS.TM[0]:=_Integer; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
FS.NArg:=2;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('chebyshevu',FS);    FindFuncA('chebyshevu',NF);
SetExtNameFunc(NF,'ucheb');   SetExtNameFunc(NF,'chebu');   SetExtNameFunc(NF,'uchebpoly');
SetExtNameFunc(NF,'chebupoly');  SetExtNameFunc(NF,'polychebu');   SetExtNameFunc(NF,'polyucheb');



InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_hermite_h);
SetLength(FS.TM,2); FS.TM[0]:=_Integer; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
FS.NArg:=2;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('hermitep',FS);    FindFuncA('hermitep',NF);
SetExtNameFunc(NF,'polyher');   SetExtNameFunc(NF,'herpoly');   SetExtNameFunc(NF,'herp');


InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_laguerre);
SetLength(FS.TM,2); FS.TM[0]:=_Integer; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
FS.NArg:=2;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('laguerrep',FS);    FindFuncA('laguerrep',NF);
SetExtNameFunc(NF,'lagp');   SetExtNameFunc(NF,'polylag');   SetExtNameFunc(NF,'lagpoly');


InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_laguerre_a);
SetLength(FS.TM,3); FS.TM[0]:=_Integer; FS.TM[1]:=_Extended;  FS.TM[2]:=_Extended;
SetLength(FS.TV,3); FS.TV[0]:=T_Real;   FS.TV[1]:=T_Real;     FS.TV[2]:=T_Real;
FS.NArg:=3;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('laguerrep',FS);   // FindFuncA('laguerrep',NF);
//SetExtNameFunc(NF,'lagp');   SetExtNameFunc(NF,'polylag');   SetExtNameFunc(NF,'lagpoly');




InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_erf);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('erf',FS);


InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_erfc);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('erfc',FS);




{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_erfCx);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('erf',FS);

{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_erfcCx);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('erfc',FS);


{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_erf_inv);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('erfinv',FS);





{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_erfc_inv);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('erfcinv',FS);





InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@_RandG);
SetLength(FS.TM,2); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
FS.NArg:=2;
FS.TypeF:=T_Real;
FS.SDeep:=3; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Addr;
FS.SaveReg:=15;
FS.CalcConst:=_NO;
FS.ReplFunc:=_NO;
SetFunction('randomgausse',FS); FindFuncA('randomgausse',NF);
SetExtNameFunc(NF,'randg'); SetExtNameFunc(NF,'rndg'); SetExtNameFunc(NF,'randgausse');



{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@BinomialC);
FS.NArg:=2;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Integer; FS.TM[1]:=_Integer;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
FS.TypeF:=T_Real;
FS.SDeep:=4; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('binomc',FS);       FindFuncA('binomc',NF);
SetExtNameFunc(NF,'cbinom');   SetExtNameFunc(NF,'cbinomial');   SetExtNameFunc(NF,'binomialc');




{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@DistBinomial);
FS.NArg:=3;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Integer;  FS.TM[1]:=_Integer;  FS.TM[2]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real;    FS.TV[1]:=T_Real;    FS.TV[2]:=T_Real;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('distbinom',FS);      FindFuncA('distbinom',NF);
SetExtNameFunc(NF,'dbinom');      SetExtNameFunc(NF,'binomd');
SetExtNameFunc(NF,'dbinomial');   SetExtNameFunc(NF,'binomiald');





{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@DistPoisson);
FS.NArg:=2;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Integer; FS.TM[1]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real;    FS.TV[1]:=T_Real;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('distpoisson',FS);   FindFuncA('distpoisson',NF);
SetExtNameFunc(NF,'poissond');   SetExtNameFunc(NF,'dpoisson');





{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@DistNormal);
FS.NArg:=3;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;  FS.TM[2]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real;    FS.TV[1]:=T_Real;    FS.TV[2]:=T_Real;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('distnormal',FS);    FindFuncA('distnormal',NF);
SetExtNameFunc(NF,'dnorm');      SetExtNameFunc(NF,'normd');
SetExtNameFunc(NF,'dnormal');    SetExtNameFunc(NF,'normald');     SetExtNameFunc(NF,'distnorm');




{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_normstd_pdf);
FS.NArg:=1;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('distnormalstd',FS);
FindFuncA('distnormalstd',NF);
SetExtNameFunc(NF,'normstddist'); SetExtNameFunc(NF,'dnormstd');
SetExtNameFunc(NF,'dnormalstd');





{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@DistHyperGeom);
FS.NArg:=4;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Integer; FS.TM[1]:=_Integer;  FS.TM[2]:=_Integer;  FS.TM[3]:=_Integer;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real;   FS.TV[1]:=T_Real;    FS.TV[2]:=T_Real;    FS.TV[3]:=T_Real;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('disthypergeom',FS);    FindFuncA('disthypergeom',NF);
SetExtNameFunc(NF,'dhypergeom');    SetExtNameFunc(NF,'hypergeomd');
SetExtNameFunc(NF,'dhypgeom');      SetExtNameFunc(NF,'hypgeomd');
SetExtNameFunc(NF,'disthypgeom');   SetExtNameFunc(NF,'hypgeomdist');





{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_maxwell_pdf);
FS.NArg:=2;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real;    FS.TV[1]:=T_Real;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('distmaxwell',FS);    FindFuncA('distmaxwell',NF);
SetExtNameFunc(NF,'dmaxwell');    SetExtNameFunc(NF,'maxwelld');
SetExtNameFunc(NF,'maxwelldist');






{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_binomial_cdf);
FS.NArg:=3;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Integer;  FS.TM[1]:=_Integer;  FS.TM[2]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real;    FS.TV[1]:=T_Real;    FS.TV[2]:=T_Real;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('probbinom',FS);       FindFuncA('probbinom',NF);
SetExtNameFunc(NF,'binomp');        SetExtNameFunc(NF,'pbinom');
SetExtNameFunc(NF,'pbinomial');     SetExtNameFunc(NF,'binomialp');
SetExtNameFunc(NF,'binomialprob');  SetExtNameFunc(NF,'probbinomial');
SetExtNameFunc(NF,'binomprob');



{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_poisson_cdf);
FS.NArg:=2;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Integer; FS.TM[1]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real;    FS.TV[1]:=T_Real;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('probpoisson',FS);   FindFuncA('probpoisson',NF);
SetExtNameFunc(NF,'poissonp');   SetExtNameFunc(NF,'ppoisson');  SetExtNameFunc(NF,'poissonprob');





{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_normal_cdf);
FS.NArg:=3;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;  FS.TM[2]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real;    FS.TV[1]:=T_Real;    FS.TV[2]:=T_Real;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('probnormal',FS);    FindFuncA('probnormal',NF);
SetExtNameFunc(NF,'pnorm');         SetExtNameFunc(NF,'normp');
SetExtNameFunc(NF,'pnormal');       SetExtNameFunc(NF,'normalp');
SetExtNameFunc(NF,'probnorm');      SetExtNameFunc(NF,'normprob');



{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_maxwell_cdf);
FS.NArg:=2;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real;    FS.TV[1]:=T_Real;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('probmaxwell',FS);    FindFuncA('probmaxwell',NF);
SetExtNameFunc(NF,'pmaxwell');    SetExtNameFunc(NF,'maxwellp');
SetExtNameFunc(NF,'maxwellprob');




{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_maxwell_inv);
FS.NArg:=2;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real;    FS.TV[1]:=T_Real;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
SetFunction('invmaxwell',FS);    FindFuncA('invmaxwell',NF);
SetExtNameFunc(NF,'maxwellinv');






{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_normstd_cdf);
FS.NArg:=1;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('probnormalstd',FS);    FindFuncA('probnormalstd',NF);
SetExtNameFunc(NF,'normstdp'); SetExtNameFunc(NF,'pnormstd');






{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_normstd_inv);
FS.NArg:=1;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
SetFunction('invnormalstd',FS);
FindFuncA('invnormalstd',NF);
SetExtNameFunc(NF,'normstdinv');  SetExtNameFunc(NF,'invnormstd');   SetExtNameFunc(NF,'normalstdinv');









{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@sfc_normal_inv);
FS.NArg:=3;
SetLength(FS.TM,FS.NArg); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;  FS.TM[2]:=_Extended;
SetLength(FS.TV,FS.NArg); FS.TV[0]:=T_Real;    FS.TV[1]:=T_Real;    FS.TV[2]:=T_Real;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('invnormal',FS);    FindFuncA('invnormal',NF);
SetExtNameFunc(NF,'invnorm');   SetExtNameFunc(NF,'norminv');
SetExtNameFunc(NF,'normalinv');







//*********************** ACCURATE FUNCTIONS of WE <BEGIN> *************************************************



{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_SIN_ACC);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('sin_acc',FS);




{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_SIN_ACC);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionExt('sin_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'sin');
SetTemplateDiffFunc(NFunc,NF,'cos_acc($arg1)*$dfarg1');
AddToTableAccFastFunc(CM_SIN,NFunc);




{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_COS_ACC);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('cos_acc',FS);



{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_COS_ACC);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionExt('cos_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'cos');
SetTemplateDiffFunc(NFunc,NF,'-sin_acc($arg1)*$dfarg1');
AddToTableAccFastFunc(CM_COS,NFunc);




{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_COT_ACC);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('cotan_acc',FS);


InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_COT_ACC);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionExt('cotan_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'cotan'); SetExtNameFunc(NFunc,'ctg');   SetExtNameFunc(NFunc,'cot');
SetTemplateDiffFunc(NFunc,NF,'-$dfarg1/sqr(sin_acc($arg1))');
AddToTableAccFastFunc(CM_COTAN,NFunc);



{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_TAN_ACC);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('tan_acc',FS);



{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_TAN_ACC);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionExt('tan_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'tan'); SetExtNameFunc(NFunc,'tg');
SetTemplateDiffFunc(NFunc,NF,'$dfarg1/sqr(cos_acc($arg1))');
AddToTableAccFastFunc(CM_TAN,NFunc);






{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_POWER_ACC);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;  FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex;  FS.TV[1]:=T_Complex;
FS.NArg:=2;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('power_acc',FS);


{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_POWER_ACC);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;  FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;  FS.TV[1]:=T_Real;
FS.NArg:=2;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('power_acc',FS);


{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@ZR_POWER_ACC);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;  FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex;  FS.TV[1]:=T_Real;
FS.NArg:=2;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('power_acc',FS);


{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@RZ_POWER_ACC);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;  FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;  FS.TV[1]:=T_Complex;
FS.NArg:=2;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionExt('power_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'pow'); SetExtNameFunc(NFunc,'power');
SetTemplateDiffFunc(NFunc,NF,'power_acc($arg1,$arg2)*(($arg2)*($dfarg1)/($arg1)+($dfarg2)*ln_acc($arg1))');
AddToTableAccFastFunc(CM_POWER,NFunc);



{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_EXP_ACC);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('exp_acc',FS);


{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_EXP_ACC);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionExt('exp_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'exp');
SetTemplateDiffFunc(NFunc,NF,'$dfarg1*exp_acc($arg1)');
AddToTableAccFastFunc(CM_EXP,NFunc);



{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_ROOT_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;  FS.TM[1]:=_Integer;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex;  FS.TV[1]:=T_Real;
FS.NArg:=2;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('root_acc',FS);



{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_ROOT_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;  FS.TM[1]:=_Integer;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;  FS.TV[1]:=T_Real;
FS.NArg:=2;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionExt('root_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'root');
SetTemplateDiffFunc(NFunc,NF,'(root_acc($arg1,$arg2))*(($dfarg1)*($arg2)-($arg1)*($dfarg2)*ln_acc($arg1))/(($arg1)*sqr($arg2))');
AddToTableAccFastFunc(CM_ROOT,NFunc);






{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_SQRT_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('sqrt_acc',FS);



{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_SQRT_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=2; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionExt('sqrt_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'sqrt');
SetTemplateDiffFunc(NFunc,NF,'$dfarg1*0.5/sqrt_acc($arg1)');
AddToTableAccFastFunc(CM_SQRT,NFunc);




{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_LN_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('ln_acc',FS);



{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_LN_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionExt('ln_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'ln');
SetTemplateDiffFunc(NFunc,NF,'$dfarg1/($arg1)');
AddToTableAccFastFunc(CM_LN,NFunc);





{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_SINH_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('sinh_acc',FS);



{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_SINH_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionExt('sinh_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'sinh'); SetExtNameFunc(NFunc,'sh');
SetTemplateDiffFunc(NFunc,NF,'$dfarg1*cosh_acc($arg1)');
AddToTableAccFastFunc(CM_SINH,NFunc);




{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_COSH_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('cosh_acc',FS);



{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_COSH_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionExt('cosh_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'cosh'); SetExtNameFunc(NFunc,'ch');
SetTemplateDiffFunc(NFunc,NF,'$dfarg1*sinh_acc($arg1)');
AddToTableAccFastFunc(CM_COSH,NFunc);




{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_TANH_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('tanh_acc',FS);



{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_TANH_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionExt('tanh_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'tanh'); SetExtNameFunc(NFunc,'th');
SetTemplateDiffFunc(NFunc,NF,'($dfarg1)/sqr(cosh_acc($arg1))');
AddToTableAccFastFunc(CM_TANH,NFunc);




{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_COTH_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('cotanh_acc',FS);




{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_COTH_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionExt('cotanh_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'cotanh'); SetExtNameFunc(NFunc,'coth');   SetExtNameFunc(NFunc,'cth');
SetTemplateDiffFunc(NFunc,NF,'-($dfarg1)/sqr(sinh_acc($arg1))');
AddToTableAccFastFunc(CM_COTANH,NFunc);







{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_COSEC_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('cosec_acc',FS);





{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_COSEC_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionExt('cosec_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'cosec'); SetExtNameFunc(NFunc,'csc');
SetTemplateDiffFunc(NFunc,NF,'-($dfarg1)*(cos_acc($arg1)/(sqr(sin_acc($arg1))))');
AddToTableAccFastFunc(CM_COSEC,NFunc);



{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_SEC_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('sec_acc',FS);




{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_SEC_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionExt('sec_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'sec');
SetTemplateDiffFunc(NFunc,NF,'($dfarg1)*(sin_acc($arg1)/(sqr(cos_acc($arg1))))');
AddToTableAccFastFunc(CM_SEC,NFunc);






{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_SECH_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('sech_acc',FS);



{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_SECH_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionExt('sech_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'sech');
SetTemplateDiffFunc(NFunc,NF,'-($dfarg1)*(sinh_acc($arg1)/(sqr(cosh_acc($arg1))))');
AddToTableAccFastFunc(CM_SECH,NFunc);






{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_COSECH_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('cosech_acc',FS);




{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_COSECH_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionExt('cosech_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'cosech'); SetExtNameFunc(NFunc,'csch');
SetTemplateDiffFunc(NFunc,NF,'-($dfarg1)*(cosh_acc($arg1)/(sqr(sinh_acc($arg1))))');
AddToTableAccFastFunc(CM_COSECH,NFunc);




{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_ARCSIN_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('arcsin_acc',FS);




{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_ARCSIN_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionExt('arcsin_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'arcsin'); SetExtNameFunc(NFunc,'asin');
SetTemplateDiffFunc(NFunc,NF,'($dfarg1)/sqrt_acc(1-sqr($arg1))');
AddToTableAccFastFunc(CM_ARCSIN,NFunc);






{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_ARCCOS_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('arccos_acc',FS);



{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_ARCCOS_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionExt('arccos_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'arccos'); SetExtNameFunc(NFunc,'acos');
SetTemplateDiffFunc(NFunc,NF,'-($dfarg1)/sqrt_acc(1-sqr($arg1))');
AddToTableAccFastFunc(CM_ARCCOS,NFunc);





{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_ARCTAN_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('arctan_acc',FS);



{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_ARCTAN_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionExt('arctan_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'arctan'); SetExtNameFunc(NFunc,'atan');  SetExtNameFunc(NFunc,'arctg'); SetExtNameFunc(NFunc,'atg');
SetTemplateDiffFunc(NFunc,NF,'($dfarg1)/(1+sqr($arg1))');
AddToTableAccFastFunc(CM_ARCTAN,NFunc);





{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_ARCCOTAN_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('arccotan_acc',FS);




{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_ARCCOTAN_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionExt('arccotan_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'arccotan'); SetExtNameFunc(NFunc,'acot');  SetExtNameFunc(NFunc,'arccot');
SetExtNameFunc(NFunc,'arcctg'); SetExtNameFunc(NFunc,'actg');
SetTemplateDiffFunc(NFunc,NF,'-($dfarg1)/(1+sqr($arg1))');
AddToTableAccFastFunc(CM_ARCCOTAN,NFunc);





{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_ARCSEC_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('arcsec_acc',FS);




{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_ARCSEC_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionExt('arcsec_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'arcsec'); SetExtNameFunc(NFunc,'asec');
SetTemplateDiffFunc(NFunc,NF,'($dfarg1)/((sqr($arg1)*(sqrt_acc(1-1/sqr($arg1)))))');
AddToTableAccFastFunc(CM_ARCSEC,NFunc);








{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_ARCCOSEC_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('arccosec_acc',FS);



{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_ARCCOSEC_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionExt('arccosec_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'arccosec'); SetExtNameFunc(NFunc,'acosec');  SetExtNameFunc(NFunc,'acsc');
SetExtNameFunc(NFunc,'arccsc');
SetTemplateDiffFunc(NFunc,NF,'-($dfarg1)/((sqr($arg1)*(sqrt_acc(1-1/sqr($arg1)))))');
AddToTableAccFastFunc(CM_ARCCOSEC,NFunc);









{--------------------------------------------}


{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_ARCSINH_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('arcsinh_acc',FS);



{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_ARCSINH_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionExt('arcsinh_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'arcsinh'); SetExtNameFunc(NFunc,'asinh');  SetExtNameFunc(NFunc,'ash'); SetExtNameFunc(NFunc,'arcsh');
SetTemplateDiffFunc(NFunc,NF,'($dfarg1)/sqrt_acc(1+sqr($arg1))');
AddToTableAccFastFunc(CM_ARCSINH,NFunc);






{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_ARCCOSH_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('arccosh_acc',FS);



{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_ARCCOSH_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6;   // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionExt('arccosh_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'arccosh'); SetExtNameFunc(NFunc,'acosh');  SetExtNameFunc(NFunc,'ach'); SetExtNameFunc(NFunc,'arcch');
SetTemplateDiffFunc(NFunc,NF,'($dfarg1)/sqrt_acc(sqr($arg1)-1)');
AddToTableAccFastFunc(CM_ARCCOSH,NFunc);




{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_ARCTANH_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('arctanh_acc',FS);




{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_ARCTANH_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionExt('arctanh_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'arctanh'); SetExtNameFunc(NFunc,'atanh');  SetExtNameFunc(NFunc,'ath'); SetExtNameFunc(NFunc,'arcth');
SetTemplateDiffFunc(NFunc,NF,'($dfarg1)/(sqr($arg1)-1)');
AddToTableAccFastFunc(CM_ARCTANH,NFunc);




{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_ARCCOTANH_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('arccotanh_acc',FS);



{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_ARCCOTANH_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionExt('arccotanh_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'arccotanh'); SetExtNameFunc(NFunc,'acotanh');  SetExtNameFunc(NFunc,'acth'); SetExtNameFunc(NFunc,'arccth');
SetExtNameFunc(NFunc,'acoth'); SetExtNameFunc(NFunc,'arccoth');
SetTemplateDiffFunc(NFunc,NF,'($dfarg1)/(1-sqr($arg1))');
AddToTableAccFastFunc(CM_ARCCOTANH,NFunc);




{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_ARCSECH_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('arcsech_acc',FS);



{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_ARCSECH_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionExt('arcsech_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'arcsech'); SetExtNameFunc(NFunc,'asech');
SetTemplateDiffFunc(NFunc,NF,'-($dfarg1)/(($arg1)*($arg1+1)*sqrt_acc((1-($arg1))/($arg1+1)))');
AddToTableAccFastFunc(CM_ARCSECH,NFunc);








{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_ARCCOSECH_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('arccosech_acc',FS);



{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_ARCCOSECH_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionExt('arccosech_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'arccosech'); SetExtNameFunc(NFunc,'acosech'); SetExtNameFunc(NFunc,'acsch');
SetExtNameFunc(NFunc,'arccsch');
SetTemplateDiffFunc(NFunc,NF,'-($dfarg1)/((sqr($arg1)*(sqrt_acc(1+1/sqr($arg1)))))');
AddToTableAccFastFunc(CM_ARCCOSECH,NFunc);






{---------------------------}



{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_LOG_ACC);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;  FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex;  FS.TV[1]:=T_Complex;
FS.NArg:=2;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('log_acc',FS);


{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_LOG_ACC);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;  FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;  FS.TV[1]:=T_Real;
FS.NArg:=2;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('log_acc',FS);


{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@ZR_LOG_ACC);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;  FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex;  FS.TV[1]:=T_Real;
FS.NArg:=2;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('log_acc',FS);


{.334}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@RZ_LOG_ACC);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;  FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;  FS.TV[1]:=T_Complex;
FS.NArg:=2;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionExt('log_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'log');
SetTemplateDiffFunc(NFunc,NF,'($dfarg2)/(($arg2)*ln_acc($arg1))-(($dfarg1)*ln_acc($arg2))/(($arg1)*sqr(ln_acc($arg1)))');
AddToTableAccFastFunc(CM_LOGN,NFunc);






{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_LOG10_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('log10_acc',FS);



{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_LOG10_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
SetFunctionExt('log10_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'log10'); SetExtNameFunc(NFunc,'lg');
SetTemplateDiffFunc(NFunc,NF,'($dfarg1)/(($arg1)*ln10)');
AddToTableAccFastFunc(CM_LOG10,NFunc);




{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_LOG2_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('log2_acc',FS);



{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_LOG2_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
SetFunctionExt('log2_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'log2'); SetExtNameFunc(NFunc,'lg2');
SetTemplateDiffFunc(NFunc,NF,'($dfarg1)/(($arg1)*ln2)');
AddToTableAccFastFunc(CM_LOG2,NFunc);





{.335}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@Z_COSSIN_acc);
SetLength(FS.TM,2); FS.TM[0]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=6; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
SetFunctionExt('cossin_acc',FS,NFunc,NF);
SetExtNameFunc(NFunc,'cossin');
AddToTableAccFastFunc(CM_COSSIN,NFunc);




//*********************** ACCURATE FUNCTIONS of WE <END> *************************************************







//***********************  POINTERS PROCEDURES <BEGIN> *************************************************




{.353}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_PDouble);
SetLength(FS.TM,1); FS.TM[0]:=_Pointer;
SetLength(FS.TV,1); FS.TV[0]:=T_Pointer;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=1;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
SetFunctionExt('pdouble',FS,NFunc,NF);
SetExtNameFunc(NFunc,'pdbl');




InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@RW_PDouble);
FS.NArg:=2;
SetLength(FS.TM,FS.NArg);
SetLength(FS.TV,FS.NArg);
FS.TM[0]:=_Pointer; FS.TV[0]:=T_Pointer;
FS.TM[1]:=_double;  FS.TV[1]:=T_Real;
FS.TypeF:=T_None;
FS.SDeep:=1;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
SetFunctionExt('pdouble',FS,NFunc,NF);
SetExtNameFunc(NFunc,'pdbl');


{.353}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_PExtended);
SetLength(FS.TM,1); FS.TM[0]:=_Pointer;
SetLength(FS.TV,1); FS.TV[0]:=T_Pointer;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=1;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
SetFunctionExt('pextended',FS,NFunc,NF);
SetExtNameFunc(NFunc,'pext');



InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@RW_PExtended);
FS.NArg:=2;
SetLength(FS.TM,FS.NArg);
SetLength(FS.TV,FS.NArg);
FS.TM[0]:=_Pointer; FS.TV[0]:=T_Pointer;
FS.TM[1]:=_Extended;  FS.TV[1]:=T_Real;
FS.TypeF:=T_None;
FS.SDeep:=1;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
SetFunctionExt('pextended',FS,NFunc,NF);
SetExtNameFunc(NFunc,'pext');



{.353}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_PInteger);
SetLength(FS.TM,1); FS.TM[0]:=_Pointer;
SetLength(FS.TV,1); FS.TV[0]:=T_Pointer;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=1;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
SetFunctionExt('pinteger',FS,NFunc,NF);
SetExtNameFunc(NFunc,'pint');


InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@RW_PInteger);
FS.NArg:=2;
SetLength(FS.TM,FS.NArg);
SetLength(FS.TV,FS.NArg);
FS.TM[0]:=_Pointer; FS.TV[0]:=T_Pointer;
FS.TM[1]:=_Integer; FS.TV[1]:=T_Real;
FS.TypeF:=T_None;
FS.SDeep:=1;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
SetFunctionExt('pinteger',FS,NFunc,NF);
SetExtNameFunc(NFunc,'pint');



InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_PSingle);
SetLength(FS.TM,1); FS.TM[0]:=_Pointer;
SetLength(FS.TV,1); FS.TV[0]:=T_Pointer;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=1;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
SetFunctionExt('psingle',FS,NFunc,NF);
SetExtNameFunc(NFunc,'psng');



InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@RW_PSingle);
FS.NArg:=2;
SetLength(FS.TM,FS.NArg);
SetLength(FS.TV,FS.NArg);
FS.TM[0]:=_Pointer; FS.TV[0]:=T_Pointer;
FS.TM[1]:=_Single;  FS.TV[1]:=T_Real;
FS.TypeF:=T_None;
FS.SDeep:=1;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
SetFunctionExt('psingle',FS,NFunc,NF);
SetExtNameFunc(NFunc,'psng');


{.353}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@_PRealU);
SetLength(FS.TM,1); FS.TM[0]:=_Pointer;
SetLength(FS.TV,1); FS.TV[0]:=T_Pointer;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=1;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
SetFunctionExt('preal',FS,NFunc,NF);



{.353}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@I_PPointer);
SetLength(FS.TM,1); FS.TM[0]:=_Pointer;
SetLength(FS.TV,1); FS.TV[0]:=T_Pointer;
FS.NArg:=1;
FS.TypeF:=T_Pointer;
FS.SDeep:=0;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
SetFunctionExt('ppointer',FS,NFunc,NF);
SetExtNameFunc(NFunc,'pptr');



{.353}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_PArrayExtended);
FS.NArg:=2;
SetLength(FS.TM,FS.NArg);   SetLength(FS.TV,FS.NArg);
FS.TV[0]:=T_Pointer; FS.TM[0]:=_Pointer;
FS.TV[1]:=T_Real;    FS.TM[1]:=_Integer;
FS.TypeF:=T_Real;
FS.SDeep:=1;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
SetFunctionExt('parrayextended',FS,NFunc,NF);
SetExtNameFunc(NFunc,'parrayext');
SetExtNameFunc(NFunc,'parraye');



{.353}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_PArrayDouble);
FS.NArg:=2;
SetLength(FS.TM,FS.NArg);   SetLength(FS.TV,FS.NArg);
FS.TV[0]:=T_Pointer; FS.TM[0]:=_Pointer;
FS.TV[1]:=T_Real;    FS.TM[1]:=_Integer;
FS.TypeF:=T_Real;
FS.SDeep:=1;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
SetFunctionExt('parraydouble',FS,NFunc,NF);
SetExtNameFunc(NFunc,'parraydbl');
SetExtNameFunc(NFunc,'parrayd');




{.353}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@R_PArrayInteger);
FS.NArg:=2;
SetLength(FS.TM,FS.NArg);   SetLength(FS.TV,FS.NArg);
FS.TV[0]:=T_Pointer; FS.TM[0]:=_Pointer;
FS.TV[1]:=T_Real;    FS.TM[1]:=_Integer;
FS.TypeF:=T_Real;
FS.SDeep:=1;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
SetFunctionExt('parrayinteger',FS,NFunc,NF);
SetExtNameFunc(NFunc,'parrayint');
SetExtNameFunc(NFunc,'parrayi');



InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@_PArrayU);
FS.NArg:=2;
SetLength(FS.TM,FS.NArg);   SetLength(FS.TV,FS.NArg);
FS.TV[0]:=T_Pointer; FS.TM[0]:=_Pointer;
FS.TV[1]:=T_Real;    FS.TM[1]:=_Integer;
FS.TypeF:=T_Real;
FS.SDeep:=1;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
SetFunctionExt('parrayp',FS,NFunc,NF);





{.353}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@ToPointer);
SetLength(FS.TM,1); FS.TM[0]:=_Integer;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.NArg:=1;
FS.TypeF:=T_Pointer;
FS.SDeep:=0;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
SetFunctionExt('pointer',FS,NFunc,NF);
SetExtNameFunc(NFunc,'ptr');




{.353}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@ToInteger);
SetLength(FS.TM,1); FS.TM[0]:=_Pointer;
SetLength(FS.TV,1); FS.TV[0]:=T_Pointer;
FS.NArg:=1;
FS.TypeF:=T_Real;
FS.SDeep:=0;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
SetFunctionExt('integer',FS,NFunc,NF);
SetExtNameFunc(NFunc,'int');




{.353}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@ToPointer);
SetLength(FS.TM,1); FS.TM[0]:=_Pointer;
SetLength(FS.TV,1); FS.TV[0]:=T_Pointer;
FS.NArg:=1;
FS.TypeF:=T_Array;
FS.TypeM:=_Double;
FS.SDeep:=0;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=1;
FS.ReplFunc:=_NO;
SetFunctionExt('arraydouble',FS,NFunc,NF);
SetExtNameFunc(NFunc,'arrayd');   SetExtNameFunc(NFunc,'arraydbl');




{.353}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@I_PPointer);
SetLength(FS.TM,1); FS.TM[0]:=_Pointer;
SetLength(FS.TV,1); FS.TV[0]:=T_Pointer;
FS.NArg:=1;
FS.TypeF:=T_Array;
FS.TypeM:=_Double;
FS.SDeep:=0;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=1;
FS.ReplFunc:=_NO;
SetFunctionExt('parraydouble',FS,NFunc,NF);
SetExtNameFunc(NFunc,'parrayd');   SetExtNameFunc(NFunc,'parraydbl');






{.353}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@I_PPointer);
SetLength(FS.TM,1); FS.TM[0]:=_Pointer;
SetLength(FS.TV,1); FS.TV[0]:=T_Pointer;
FS.NArg:=1;
FS.TypeF:=T_Array;
FS.TypeM:=_Extended;
FS.SDeep:=0;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=1;
FS.ReplFunc:=_NO;
SetFunctionExt('parrayextended',FS,NFunc,NF);
SetExtNameFunc(NFunc,'parraye');   SetExtNameFunc(NFunc,'parrayext');






{.353}
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@I_PPointer);
SetLength(FS.TM,1); FS.TM[0]:=_Pointer;
SetLength(FS.TV,1); FS.TV[0]:=T_Pointer;
FS.NArg:=1;
FS.TypeF:=T_Array;
FS.TypeM:=_Integer;
FS.SDeep:=0;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=1;
FS.ReplFunc:=_NO;
SetFunctionExt('parrayinteger',FS,NFunc,NF);
SetExtNameFunc(NFunc,'parrayi');   SetExtNameFunc(NFunc,'parrayint');




{.353}
//универсальная процедура преобразования адреса массива в любой массив  ptr1=@vd; len(parrayp(ptr1))
InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@I_PPointer);
SetLength(FS.TM,1); FS.TM[0]:=_Pointer;
SetLength(FS.TV,1); FS.TV[0]:=T_Pointer;
FS.NArg:=1;
FS.TypeF:=T_Array;
FS.TypeM:=_Pointer;
FS.SDeep:=0;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=1;
FS.ReplFunc:=_NO;
SetFunctionExt('parraypointer',FS,NFunc,NF);
SetExtNameFunc(NFunc,'parrayp');   SetExtNameFunc(NFunc,'parrayptr');


InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@I_PPointer);
SetLength(FS.TM,1); FS.TM[0]:=_Pointer;
SetLength(FS.TV,1); FS.TV[0]:=T_Pointer;
FS.NArg:=1;
FS.TypeF:=T_Pointer;
FS.TypeM:=_Pointer;
FS.SDeep:=0;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=1;
FS.ReplFunc:=_NO;
SetFunctionExt('parraypointer1',FS,NFunc,NF);
SetExtNameFunc(NFunc,'parrayp1');   SetExtNameFunc(NFunc,'parrayptr1');





//***********************  POINTERS PROCEDURES <END> *************************************************






InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@CallSafe);
FS.NArg:=2;
SetLength(FS.TM,FS.NArg);
SetLength(FS.TV,FS.NArg);
FS.TM[0]:=_Pointer; FS.TV[0]:=T_Pointer;
FS.TM[1]:=_Pointer; FS.TV[1]:=T_Pointer;
FS.TypeF:=T_None;
FS.SDeep:=8;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
SetFunctionExt('callsafe',FS,NFunc,NF);



InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@CallRSafe);
FS.NArg:=2;
SetLength(FS.TM,FS.NArg);
SetLength(FS.TV,FS.NArg);
FS.TM[0]:=_Pointer; FS.TV[0]:=T_Pointer;
FS.TM[1]:=_Pointer; FS.TV[1]:=T_Pointer;
FS.TypeF:=T_Real;
FS.SDeep:=8;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
SetFunctionExt('callrsafe',FS,NFunc,NF);



InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@CallCxSafe);
FS.NArg:=2;
SetLength(FS.TM,FS.NArg);
SetLength(FS.TV,FS.NArg);
FS.TM[0]:=_Pointer; FS.TV[0]:=T_Pointer;
FS.TM[1]:=_Pointer; FS.TV[1]:=T_Pointer;
FS.TypeF:=T_Complex;
FS.SDeep:=8;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
SetFunctionExt('callcsafe',FS,NFunc,NF);






InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@CallMaskFPU);
FS.NArg:=2;
SetLength(FS.TM,FS.NArg);
SetLength(FS.TV,FS.NArg);
FS.TM[0]:=_Pointer; FS.TV[0]:=T_Pointer;
FS.TM[1]:=_Pointer; FS.TV[1]:=T_Pointer;
FS.TypeF:=T_None;
FS.SDeep:=8;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
SetFunctionExt('callmaskfpu',FS,NFunc,NF);



InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@CallRMaskFPU);
FS.NArg:=2;
SetLength(FS.TM,FS.NArg);
SetLength(FS.TV,FS.NArg);
FS.TM[0]:=_Pointer; FS.TV[0]:=T_Pointer;
FS.TM[1]:=_Pointer; FS.TV[1]:=T_Pointer;
FS.TypeF:=T_Real;
FS.SDeep:=8;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
SetFunctionExt('callrmaskfpu',FS,NFunc,NF);




InitFuncStruct(FS); FS.IntF:=_External;
FS.addr:=Cardinal(@CallCxMaskFPU);
FS.NArg:=2;
SetLength(FS.TM,FS.NArg);
SetLength(FS.TV,FS.NArg);
FS.TM[0]:=_Pointer; FS.TV[0]:=T_Pointer;
FS.TM[1]:=_Pointer; FS.TV[1]:=T_Pointer;
FS.TypeF:=T_Complex;
FS.SDeep:=8;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
SetFunctionExt('callcmaskfpu',FS,NFunc,NF);








(*
{.227}
InitFuncStruct(FS);  FS.IntF:=0;
FS.addr:=Cardinal(@_MaskFPUException);
FS.N:=0;
FS.TypeF:=T_None;
FS.SDeep:=0; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=0;
FS.ReplFunc:=_NO;
SetFunction('try',FS);


{.227}
InitFuncStruct(FS);  FS.IntF:=0;
FS.addr:=Cardinal(@_IsFPUException);
FS.N:=0;
FS.TypeF:=T_Real;
FS.SDeep:=1; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=0;
FS.ReplFunc:=_NO;
SetFunction('exception',FS);
*)






InitTableRF; {.217}


//Добавление операций после добавления соответствующих функций
//При разборе, вначале выбираются операции с наименьшим приоритетом.

//Addition of operations after addition of appropriate functions
//Operation:

SetOperation('+','add',1,2,_between);
SetOperation('-','sub',1,2,_between);
SetOperation('*','mul',2,2,_between);
SetOperation('/','div',2,2,_between);
SetOperation('^','power',3,2,_between);
SetOperation('-','neg',1,1,_before);
SetOperation('!','fact',2,1,_after);
SetOperation('!!','fact2',2,1,_after);
//SetOperation('_','con',2,1,_after);
SetOperation('$','con',2,1,_before);    {.353}
SetOperation('.re','re',2,1,_after);
SetOperation('.im','im',2,1,_after);
SetOperation('@','addr',1,1,_before);   // priority of '@' < '.re', '.im' !!!


//SetOperation('<=>','swap',2,2,_between);

//Для изменении символа см. описание  TAlgOperation
//For character change the description see of TAlgOperation

Alg.ExFunc[CM_ADD].XchArg := _YES;
Alg.ExFunc[CM_MUL].XchArg := _YES;
Alg.ExFunc[CM_SUB].XchArg := _YES;
Alg.ExFunc[CM_DIV].XchArg := _YES;

COP_ADD:=FindOperationA('+',1,2,_between);
COP_SUB:=FindOperationA('-',1,2,_between);
COP_MUL:=FindOperationA('*',2,2,_between);
COP_DIV:=FindOperationA('/',2,2,_between);
COP_NEG:=FindOperationA('-',1,1,_before);
//COP_MUL:=FindOperation('*');
//COP_DIV:=FindOperation('/');
COP_POW:=FindOperation('^');
COP_FACT1:=FindOperation('!');
COP_FACT2:=FindOperation('!!');
COP_CONJ:=FindOperation('$');
COP_RE:=FindOperation('.re');
COP_IM:=FindOperation('.im');
COP_ADDR:=FindOperation('@');


{
F_FAST_STD_FUNC  := False;
SetStdFunc;
}

end;



{.217}
procedure TForevalH.InitTableRF;
var
 i,j,L: integer;
begin
 SetLength(TableRF,Length(Alg.ExFunc),Length(Alg.ExFunc));

 L:=Length(Alg.ExFunc);
 for i := 0 to L - 1 do
 begin
   for j := 0 to L - 1 do
   begin
        TableRF[i,j].WRF_R:=rf_NO_REPLACE;    //=0
        TableRF[i,j].RRF_R:=rf_NO_REPLACE;    //=0
        TableRF[i,j].WRF_Z:=rf_NO_REPLACE;    //=0
        TableRF[i,j].RRF_Z:=rf_NO_REPLACE;    //=0
        TableRF[i,j].NMEM_R:=0;    //=0
        TableRF[i,j].NMEM_Z:=0;    //=0
        TableRF[i,j].SHFT_R:=0;    //=0
        TableRF[i,j].SHFT_Z:=0;    //=0
        if i=j  then
        begin
          TableRF[i,j].WRF_R:=rf_FULL_REPLACE;
          TableRF[i,j].RRF_R:=rf_FULL_REPLACE;
          TableRF[i,j].NMEM_R:=1;
          TableRF[i,j].WRF_Z:=rf_FULL_REPLACE;
          TableRF[i,j].RRF_Z:=rf_FULL_REPLACE;
          TableRF[i,j].NMEM_Z:=2;
        end;
   end;

   //используется только для функций из TableRF[]
   Alg.ExFunc[i].ReplFuncCFZ:=_YES;
   Alg.ExFunc[i].ReplFuncCFR:=_YES;
 end;

{
  WRF_R -> RRF_R
  WRF_R - ранг сохранения функции: либо полное (=rf_FULL_REPLACE) , либо часть (или несколько частей)
  RRF_R - ранг считывания функции: либо полное (=rf_FULL_REPLACE) , либо часть (или несколько частей)
          NMEM_R, NMEM_Z - число сохраняемых чисел для real/complex функции (для complex - минимум = 2)
          частичное сохранение для функции возможно только одного ранга (независимо от: все ли части будут использованы считывающими функциями или нет)
          напр.: sh->ch сохраняются (WRF_R=rf_EXPR2_REPLACE) "exp", "1/exp" и считываются (ch) оба значения (RRF_R=rf_EXPR2_REPLACE)
                 sh->th сохраняются!! (WRF_R=rf_EXPR2_REPLACE) "exp", "1/exp" , но считывается (th) только "exp" (RRF_R=rf_EXPR1_REPLACE)
 SHFT_R - сдвиг к нужному результату (относительно последнего (всех сохраняемых чисел: NMEM_R/NMEM_Z )) для считывающей функции (если сохраняется чисел больше, чем считывается)
          напр.: sin->cos    сохраняются два (NMEM_R=2)(fsincos: [1]cos,[2]sin); cos считывает одно (первое), сдвиг = 1 (SHFT_R)
          напр.: sinh->tanh    сохраняются четыре (NMEM_Z=4)( [1]RE(exp),[2]IM(exp),[3]RE(1/exp),[4]IM(1/exp))); tanh считывает два первых, сдвиг = 2 (SHFT_Z)
                 (сдвиг указывает на последнее нужное число)
 функция может сохранить результат дважды: полное сохранение  (rf_FULL_REPLACE) и частичное (но только одного ранга)
}
                {  SIN    }
 TableRF[CM_SIN,CM_COS].WRF_R:=rf_COSSINR_REPLACE;
 TableRF[CM_SIN,CM_COS].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_SIN,CM_COS].NMEM_R:=2;
 TableRF[CM_SIN,CM_COS].SHFT_R:=1;
 TableRF[CM_SIN,CM_COS].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SIN,CM_COS].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SIN,CM_COS].NMEM_Z:=4;

 TableRF[CM_SIN,CM_COSEC].WRF_R:=rf_COSSINR_REPLACE;
 TableRF[CM_SIN,CM_COSEC].RRF_R:=rf_SINR_REPLACE;
 TableRF[CM_SIN,CM_COSEC].NMEM_R:=2;
 TableRF[CM_SIN,CM_COSEC].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SIN,CM_COSEC].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SIN,CM_COSEC].NMEM_Z:=4;

 TableRF[CM_SIN,CM_SEC].WRF_R:=rf_COSSINR_REPLACE;
 TableRF[CM_SIN,CM_SEC].RRF_R:=rf_COSR_REPLACE;
 TableRF[CM_SIN,CM_SEC].NMEM_R:=2;
 TableRF[CM_SIN,CM_SEC].SHFT_R:=1;
 TableRF[CM_SIN,CM_SEC].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SIN,CM_SEC].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SIN,CM_SEC].NMEM_Z:=4;

 TableRF[CM_SIN,CM_TAN].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SIN,CM_TAN].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_SIN,CM_TAN].NMEM_Z:=4;
 TableRF[CM_SIN,CM_TAN].SHFT_Z:=2;

 TableRF[CM_SIN,CM_COTAN].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SIN,CM_COTAN].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_SIN,CM_COTAN].NMEM_Z:=4;
 TableRF[CM_SIN,CM_COTAN].SHFT_Z:=2;

 {
  COSSIN <-> COS,SIN,SEC,COSEC: исключение, т.к. используются подстановки между функциями с разными выходными типами: Complex vs Real.
  Не предусмотрено в оптимизации Replace...
 }
 {.331}
 TableRF[CM_SIN,CM_COSSIN].WRF_R:=rf_COSSINR_REPLACE;
 TableRF[CM_SIN,CM_COSSIN].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_SIN,CM_COSSIN].NMEM_R:=2;
 //Не используется:. Введено для совместимости с ReplaceFuncComposite -> CompareFunc
 TableRF[CM_SIN,CM_COSSIN].WRF_Z:=rf_COSSINR_REPLACE;
 TableRF[CM_SIN,CM_COSSIN].RRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_SIN,CM_COSSIN].NMEM_Z:=2;


 {.331}
 (*
 TableRF[CM_SIN,CM_SINCOS].WRF_R:=rf_COSSINR_REPLACE;
 TableRF[CM_SIN,CM_SINCOS].RRF_R:=rf_FULL_REPLACE_XCH;
 TableRF[CM_SIN,CM_SINCOS].NMEM_R:=2;
 //Не используется:. Введено для совместимости с ReplaceFuncComposite -> CompareFunc
 TableRF[CM_SIN,CM_SINCOS].WRF_Z:=rf_COSSINR_REPLACE;
 TableRF[CM_SIN,CM_SINCOS].RRF_Z:=rf_FULL_REPLACE_XCH;
 TableRF[CM_SIN,CM_SINCOS].NMEM_Z:=2;
 *)








                { COS   }

 TableRF[CM_COS,CM_SIN].WRF_R:=rf_COSSINR_REPLACE;
 TableRF[CM_COS,CM_SIN].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_COS,CM_SIN].NMEM_R:=2;
 TableRF[CM_COS,CM_SIN].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COS,CM_SIN].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COS,CM_SIN].NMEM_Z:=4;

 TableRF[CM_COS,CM_COSEC].WRF_R:=rf_COSSINR_REPLACE;
 TableRF[CM_COS,CM_COSEC].RRF_R:=rf_SINR_REPLACE;
 TableRF[CM_COS,CM_COSEC].NMEM_R:=2;
 TableRF[CM_COS,CM_COSEC].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COS,CM_COSEC].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COS,CM_COSEC].NMEM_Z:=4;

 TableRF[CM_COS,CM_SEC].WRF_R:=rf_COSSINR_REPLACE;
 TableRF[CM_COS,CM_SEC].RRF_R:=rf_COSR_REPLACE;
 TableRF[CM_COS,CM_SEC].NMEM_R:=2;
 TableRF[CM_COS,CM_SEC].SHFT_R:=1;
 TableRF[CM_COS,CM_SEC].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COS,CM_SEC].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COS,CM_SEC].NMEM_Z:=4;

 TableRF[CM_COS,CM_TAN].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COS,CM_TAN].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COS,CM_TAN].NMEM_Z:=4;
 TableRF[CM_COS,CM_TAN].SHFT_Z:=2;

 TableRF[CM_COS,CM_COTAN].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COS,CM_COTAN].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COS,CM_COTAN].NMEM_Z:=4;
 TableRF[CM_COS,CM_COTAN].SHFT_Z:=2;

  {.331}
 TableRF[CM_COS,CM_COSSIN].WRF_R:=rf_COSSINR_REPLACE;
 TableRF[CM_COS,CM_COSSIN].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_COS,CM_COSSIN].NMEM_R:=2;
 //Не используется:. Введено для совместимости с ReplaceFuncComposite -> CompareFunc
 TableRF[CM_COS,CM_COSSIN].WRF_Z:=rf_COSSINR_REPLACE;
 TableRF[CM_COS,CM_COSSIN].RRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_COS,CM_COSSIN].NMEM_Z:=2;






                {COSSIN}
                // st(0) <- cos; st(1) <- sin;
 {
  COSSIN <-> COS,SIN,SEC,COSEC: исключение, т.к. используются подстановки между функциями с разными выходными типами: Complex vs Real, которые не предусмотрены в оптимизации Replace...
 }

 //cossin {.331}
 //не используется. нужно для совместимости:
 TableRF[CM_COSSIN,CM_COS].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_COSSIN,CM_COS].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_COSSIN,CM_COS].NMEM_R:=2;
 TableRF[CM_COSSIN,CM_COS].SHFT_R:=1;
 //используется вместо Real данных . нужно для совместимости с GetReplaceData:
 TableRF[CM_COSSIN,CM_COS].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_COSSIN,CM_COS].RRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_COSSIN,CM_COS].NMEM_Z:=2;
 TableRF[CM_COSSIN,CM_COS].SHFT_Z:=1;

 //не используется. нужно для совместимости:
 TableRF[CM_COSSIN,CM_SIN].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_COSSIN,CM_SIN].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_COSSIN,CM_SIN].NMEM_R:=2;
 TableRF[CM_COSSIN,CM_SIN].SHFT_R:=0;
 //используется вместо Real данных. нужно для совместимости с GetReplaceData:
 TableRF[CM_COSSIN,CM_SIN].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_COSSIN,CM_SIN].RRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_COSSIN,CM_SIN].NMEM_Z:=2;
 TableRF[CM_COSSIN,CM_SIN].SHFT_Z:=0;


 //не используется. нужно для совместимости:
 TableRF[CM_COSSIN,CM_SEC].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_COSSIN,CM_SEC].RRF_R:=rf_COSR_REPLACE;
 TableRF[CM_COSSIN,CM_SEC].NMEM_R:=2;
 TableRF[CM_COSSIN,CM_SEC].SHFT_R:=1;
 //используется вместо Real данных . нужно для совместимости с GetReplaceData:
 TableRF[CM_COSSIN,CM_SEC].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_COSSIN,CM_SEC].RRF_Z:=rf_COSR_REPLACE;
 TableRF[CM_COSSIN,CM_SEC].NMEM_Z:=2;
 TableRF[CM_COSSIN,CM_SEC].SHFT_Z:=1;
                   //cossin(x)+sec(x)


 //не используется. нужно для совместимости:
 TableRF[CM_COSSIN,CM_COSEC].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_COSSIN,CM_COSEC].RRF_R:=rf_SINR_REPLACE;
 TableRF[CM_COSSIN,CM_COSEC].NMEM_R:=2;
 TableRF[CM_COSSIN,CM_COSEC].SHFT_R:=0;
 //используется вместо Real данных . нужно для совместимости с GetReplaceData:
 TableRF[CM_COSSIN,CM_COSEC].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_COSSIN,CM_COSEC].RRF_Z:=rf_SINR_REPLACE;
 TableRF[CM_COSSIN,CM_COSEC].NMEM_Z:=2;
 TableRF[CM_COSSIN,CM_COSEC].SHFT_Z:=0;
                    //cossin(x)+cosec(x)




              {  TAN  }
 TableRF[CM_TAN,CM_COTAN].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_TAN,CM_COTAN].RRF_R:=rf_INVERSE_REPLACE;
 TableRF[CM_TAN,CM_COTAN].NMEM_R:=1;
 TableRF[CM_TAN,CM_COTAN].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_TAN,CM_COTAN].RRF_Z:=rf_INVERSE_REPLACE;
 TableRF[CM_TAN,CM_COTAN].NMEM_Z:=2;

 TableRF[CM_TAN,CM_SIN].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TAN,CM_SIN].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TAN,CM_SIN].NMEM_Z:=2;

 TableRF[CM_TAN,CM_SEC].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TAN,CM_SEC].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TAN,CM_SEC].NMEM_Z:=2;

 TableRF[CM_TAN,CM_COSEC].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TAN,CM_COSEC].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TAN,CM_COSEC].NMEM_Z:=2;

 TableRF[CM_TAN,CM_COS].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TAN,CM_COS].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TAN,CM_COS].NMEM_Z:=2;





         {    COTAN   }
 TableRF[CM_COTAN,CM_SIN].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTAN,CM_SIN].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTAN,CM_SIN].NMEM_Z:=2;

 TableRF[CM_COTAN,CM_TAN].WRF_R:=rf_INVERSE_REPLACE;
 TableRF[CM_COTAN,CM_TAN].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_COTAN,CM_TAN].NMEM_R:=1;
 TableRF[CM_COTAN,CM_TAN].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_COTAN,CM_TAN].RRF_Z:=rf_INVERSE_REPLACE;
 TableRF[CM_COTAN,CM_TAN].NMEM_Z:=2;

 TableRF[CM_COTAN,CM_SEC].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTAN,CM_SEC].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTAN,CM_SEC].NMEM_Z:=2;

 TableRF[CM_COTAN,CM_COSEC].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTAN,CM_COSEC].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTAN,CM_COSEC].NMEM_Z:=2;

 TableRF[CM_COTAN,CM_COS].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTAN,CM_COS].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTAN,CM_COS].NMEM_Z:=2;






               {  COSEC    }
 TableRF[CM_COSEC,CM_SIN].WRF_R:=rf_COSSINR_REPLACE;
 TableRF[CM_COSEC,CM_SIN].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_COSEC,CM_SIN].NMEM_R:=2;
 TableRF[CM_COSEC,CM_SIN].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSEC,CM_SIN].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSEC,CM_SIN].NMEM_Z:=4;

 TableRF[CM_COSEC,CM_COS].WRF_R:=rf_COSSINR_REPLACE;
 TableRF[CM_COSEC,CM_COS].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_COSEC,CM_COS].NMEM_R:=2;
 TableRF[CM_COSEC,CM_COS].SHFT_R:=1;
 TableRF[CM_COSEC,CM_COS].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSEC,CM_COS].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSEC,CM_COS].NMEM_Z:=4;

 TableRF[CM_COSEC,CM_SEC].WRF_R:=rf_COSSINR_REPLACE;
 TableRF[CM_COSEC,CM_SEC].RRF_R:=rf_COSR_REPLACE;
 TableRF[CM_COSEC,CM_SEC].NMEM_R:=2;
 TableRF[CM_COSEC,CM_SEC].SHFT_R:=1;
 TableRF[CM_COSEC,CM_SEC].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSEC,CM_SEC].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSEC,CM_SEC].NMEM_Z:=4;

 TableRF[CM_COSEC,CM_TAN].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSEC,CM_TAN].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COSEC,CM_TAN].NMEM_Z:=4;
 TableRF[CM_COSEC,CM_TAN].SHFT_Z:=2;

 TableRF[CM_COSEC,CM_COTAN].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSEC,CM_COTAN].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COSEC,CM_COTAN].NMEM_Z:=4;
 TableRF[CM_COSEC,CM_COTAN].SHFT_Z:=2;

 {.331}
 TableRF[CM_COSEC,CM_COSSIN].WRF_R:=rf_COSSINR_REPLACE;
 TableRF[CM_COSEC,CM_COSSIN].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_COSEC,CM_COSSIN].NMEM_R:=2;
 //Не используется:. Введено для совместимости с ReplaceFuncComposite -> CompareFunc
 TableRF[CM_COSEC,CM_COSSIN].WRF_Z:=rf_COSSINR_REPLACE;
 TableRF[CM_COSEC,CM_COSSIN].RRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_COSEC,CM_COSSIN].NMEM_Z:=2;
             //cosec(x)+cossin(x)


            {  SEC   }
 TableRF[CM_SEC,CM_SIN].WRF_R:=rf_COSSINR_REPLACE;
 TableRF[CM_SEC,CM_SIN].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_SEC,CM_SIN].NMEM_R:=2;
 TableRF[CM_SEC,CM_SIN].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SEC,CM_SIN].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SEC,CM_SIN].NMEM_Z:=4;

 TableRF[CM_SEC,CM_COS].WRF_R:=rf_COSSINR_REPLACE;
 TableRF[CM_SEC,CM_COS].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_SEC,CM_COS].NMEM_R:=2;
 TableRF[CM_SEC,CM_COS].SHFT_R:=1;
 TableRF[CM_SEC,CM_COS].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SEC,CM_COS].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SEC,CM_COS].NMEM_Z:=4;

 TableRF[CM_SEC,CM_TAN].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SEC,CM_TAN].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_SEC,CM_TAN].NMEM_Z:=4;
 TableRF[CM_SEC,CM_TAN].SHFT_Z:=2;

 TableRF[CM_SEC,CM_COTAN].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SEC,CM_COTAN].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_SEC,CM_COTAN].NMEM_Z:=4;
 TableRF[CM_SEC,CM_COTAN].SHFT_Z:=2;


 TableRF[CM_SEC,CM_COSEC].WRF_R:=rf_COSSINR_REPLACE;
 TableRF[CM_SEC,CM_COSEC].RRF_R:=rf_SINR_REPLACE;
 TableRF[CM_SEC,CM_COSEC].NMEM_R:=2;
 TableRF[CM_SEC,CM_COSEC].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SEC,CM_COSEC].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SEC,CM_COSEC].NMEM_Z:=4;

 {.331}
 TableRF[CM_SEC,CM_COSSIN].WRF_R:=rf_COSSINR_REPLACE;
 TableRF[CM_SEC,CM_COSSIN].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_SEC,CM_COSSIN].NMEM_R:=2;
 //Не используется:. Введено для совместимости с ReplaceFuncComposite -> CompareFunc
 TableRF[CM_SEC,CM_COSSIN].WRF_Z:=rf_COSSINR_REPLACE;
 TableRF[CM_SEC,CM_COSSIN].RRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_SEC,CM_COSSIN].NMEM_Z:=2;
             //sec(x)+cossin(x)



             {  SINH   }
 TableRF[CM_SINH,CM_EXP].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SINH,CM_EXP].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_SINH,CM_EXP].NMEM_R:=2;
 TableRF[CM_SINH,CM_EXP].SHFT_R:=1;
 TableRF[CM_SINH,CM_EXP].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SINH,CM_EXP].RRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_SINH,CM_EXP].NMEM_Z:=4;
 TableRF[CM_SINH,CM_EXP].SHFT_Z:=2;

 TableRF[CM_SINH,CM_COSH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SINH,CM_COSH].RRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SINH,CM_COSH].NMEM_R:=2;
 TableRF[CM_SINH,CM_COSH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SINH,CM_COSH].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SINH,CM_COSH].NMEM_Z:=4;

 TableRF[CM_SINH,CM_TANH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SINH,CM_TANH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_SINH,CM_TANH].NMEM_R:=2;
 TableRF[CM_SINH,CM_TANH].SHFT_R:=1;
 TableRF[CM_SINH,CM_TANH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SINH,CM_TANH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_SINH,CM_TANH].NMEM_Z:=4;
 TableRF[CM_SINH,CM_TANH].SHFT_Z:=2;

 TableRF[CM_SINH,CM_COTANH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SINH,CM_COTANH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_SINH,CM_COTANH].NMEM_R:=2;
 TableRF[CM_SINH,CM_COTANH].SHFT_R:=1;
 TableRF[CM_SINH,CM_COTANH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SINH,CM_COTANH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_SINH,CM_COTANH].NMEM_Z:=4;
 TableRF[CM_SINH,CM_COTANH].SHFT_Z:=2;

 TableRF[CM_SINH,CM_COSECH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SINH,CM_COSECH].RRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SINH,CM_COSECH].NMEM_R:=2;
 TableRF[CM_SINH,CM_COSECH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SINH,CM_COSECH].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SINH,CM_COSECH].NMEM_Z:=4;

 TableRF[CM_SINH,CM_SECH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SINH,CM_SECH].RRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SINH,CM_SECH].NMEM_R:=2;
 TableRF[CM_SINH,CM_SECH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SINH,CM_SECH].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SINH,CM_SECH].NMEM_Z:=4;



             { COSH }
 TableRF[CM_COSH,CM_EXP].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSH,CM_EXP].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_COSH,CM_EXP].NMEM_R:=2;
 TableRF[CM_COSH,CM_EXP].SHFT_R:=1;
 TableRF[CM_COSH,CM_EXP].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSH,CM_EXP].RRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_COSH,CM_EXP].NMEM_Z:=4;
 TableRF[CM_COSH,CM_EXP].SHFT_Z:=2;

 TableRF[CM_COSH,CM_SINH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSH,CM_SINH].RRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSH,CM_SINH].NMEM_R:=2;
 TableRF[CM_COSH,CM_SINH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSH,CM_SINH].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSH,CM_SINH].NMEM_Z:=4;

 TableRF[CM_COSH,CM_COSECH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSH,CM_COSECH].RRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSH,CM_COSECH].NMEM_R:=2;
 TableRF[CM_COSH,CM_COSECH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSH,CM_COSECH].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSH,CM_COSECH].NMEM_Z:=4;

 TableRF[CM_COSH,CM_SECH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSH,CM_SECH].RRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSH,CM_SECH].NMEM_R:=2;
 TableRF[CM_COSH,CM_SECH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSH,CM_SECH].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSH,CM_SECH].NMEM_Z:=4;

 TableRF[CM_COSH,CM_TANH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSH,CM_TANH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_COSH,CM_TANH].NMEM_R:=2;
 TableRF[CM_COSH,CM_TANH].SHFT_R:=1;
 TableRF[CM_COSH,CM_TANH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSH,CM_TANH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COSH,CM_TANH].NMEM_Z:=4;
 TableRF[CM_COSH,CM_TANH].SHFT_Z:=2;

 TableRF[CM_COSH,CM_COTANH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSH,CM_COTANH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_COSH,CM_COTANH].NMEM_R:=2;
 TableRF[CM_COSH,CM_COTANH].SHFT_R:=1;
 TableRF[CM_COSH,CM_COTANH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSH,CM_COTANH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COSH,CM_COTANH].NMEM_Z:=4;
 TableRF[CM_COSH,CM_COTANH].SHFT_Z:=2;



           { EXP  }
 TableRF[CM_EXP,CM_SINH].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_EXP,CM_SINH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_EXP,CM_SINH].NMEM_R:=1;
 TableRF[CM_EXP,CM_SINH].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_EXP,CM_SINH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_EXP,CM_SINH].NMEM_Z:=2;

 TableRF[CM_EXP,CM_COSH].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_EXP,CM_COSH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_EXP,CM_COSH].NMEM_R:=1;
 TableRF[CM_EXP,CM_COSH].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_EXP,CM_COSH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_EXP,CM_COSH].NMEM_Z:=2;

 TableRF[CM_EXP,CM_COSECH].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_EXP,CM_COSECH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_EXP,CM_COSECH].NMEM_R:=1;
 TableRF[CM_EXP,CM_COSECH].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_EXP,CM_COSECH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_EXP,CM_COSECH].NMEM_Z:=2;

 TableRF[CM_EXP,CM_SECH].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_EXP,CM_SECH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_EXP,CM_SECH].NMEM_R:=1;
 TableRF[CM_EXP,CM_SECH].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_EXP,CM_SECH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_EXP,CM_SECH].NMEM_Z:=2;


 TableRF[CM_EXP,CM_TANH].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_EXP,CM_TANH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_EXP,CM_TANH].NMEM_R:=1;
 TableRF[CM_EXP,CM_TANH].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_EXP,CM_TANH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_EXP,CM_TANH].NMEM_Z:=2;

 TableRF[CM_EXP,CM_COTANH].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_EXP,CM_COTANH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_EXP,CM_COTANH].NMEM_R:=1;
 TableRF[CM_EXP,CM_COTANH].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_EXP,CM_COTANH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_EXP,CM_COTANH].NMEM_Z:=2;


           {TANH }
 TableRF[CM_TANH,CM_COTANH].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_TANH,CM_COTANH].RRF_R:=rf_INVERSE_REPLACE;
 TableRF[CM_TANH,CM_COTANH].NMEM_R:=1;
 TableRF[CM_TANH,CM_COTANH].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_TANH,CM_COTANH].RRF_Z:=rf_INVERSE_REPLACE;
 TableRF[CM_TANH,CM_COTANH].NMEM_Z:=2;

 TableRF[CM_TANH,CM_EXP].WRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_TANH,CM_EXP].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_TANH,CM_EXP].NMEM_R:=1;
 TableRF[CM_TANH,CM_EXP].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TANH,CM_EXP].RRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_TANH,CM_EXP].NMEM_Z:=2;

 TableRF[CM_TANH,CM_SINH].WRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_TANH,CM_SINH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_TANH,CM_SINH].NMEM_R:=1;
 TableRF[CM_TANH,CM_SINH].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TANH,CM_SINH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TANH,CM_SINH].NMEM_Z:=2;

 TableRF[CM_TANH,CM_COSH].WRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_TANH,CM_COSH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_TANH,CM_COSH].NMEM_R:=1;
 TableRF[CM_TANH,CM_COSH].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TANH,CM_COSH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TANH,CM_COSH].NMEM_Z:=2;

 TableRF[CM_TANH,CM_COSECH].WRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_TANH,CM_COSECH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_TANH,CM_COSECH].NMEM_R:=1;
 TableRF[CM_TANH,CM_COSECH].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TANH,CM_COSECH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TANH,CM_COSECH].NMEM_Z:=2;

 TableRF[CM_TANH,CM_SECH].WRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_TANH,CM_SECH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_TANH,CM_SECH].NMEM_R:=1;
 TableRF[CM_TANH,CM_SECH].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TANH,CM_SECH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TANH,CM_SECH].NMEM_Z:=2;


              { COTANH }
 TableRF[CM_COTANH,CM_SINH].WRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_COTANH,CM_SINH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_COTANH,CM_SINH].NMEM_R:=1;
 TableRF[CM_COTANH,CM_SINH].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTANH,CM_SINH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTANH,CM_SINH].NMEM_Z:=2;

 TableRF[CM_COTANH,CM_COSH].WRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_COTANH,CM_COSH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_COTANH,CM_COSH].NMEM_R:=1;
 TableRF[CM_COTANH,CM_COSH].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTANH,CM_COSH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTANH,CM_COSH].NMEM_Z:=2;

 TableRF[CM_COTANH,CM_COSECH].WRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_COTANH,CM_COSECH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_COTANH,CM_COSECH].NMEM_R:=1;
 TableRF[CM_COTANH,CM_COSECH].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTANH,CM_COSECH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTANH,CM_COSECH].NMEM_Z:=2;

 TableRF[CM_COTANH,CM_SECH].WRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_COTANH,CM_SECH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_COTANH,CM_SECH].NMEM_R:=1;
 TableRF[CM_COTANH,CM_SECH].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTANH,CM_SECH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTANH,CM_SECH].NMEM_Z:=2;

 TableRF[CM_COTANH,CM_EXP].WRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_COTANH,CM_EXP].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_COTANH,CM_EXP].NMEM_R:=1;
 TableRF[CM_COTANH,CM_EXP].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTANH,CM_EXP].RRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_COTANH,CM_EXP].NMEM_Z:=2;

 TableRF[CM_COTANH,CM_TANH].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_COTANH,CM_TANH].RRF_R:=rf_INVERSE_REPLACE;
 TableRF[CM_COTANH,CM_TANH].NMEM_R:=1;
 TableRF[CM_COTANH,CM_TANH].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_COTANH,CM_TANH].RRF_Z:=rf_INVERSE_REPLACE;
 TableRF[CM_COTANH,CM_TANH].NMEM_Z:=2;



            {   COSECH   }
 TableRF[CM_COSECH,CM_EXP].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSECH,CM_EXP].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_COSECH,CM_EXP].NMEM_R:=2;
 TableRF[CM_COSECH,CM_EXP].SHFT_R:=1;
 TableRF[CM_COSECH,CM_EXP].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSECH,CM_EXP].RRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_COSECH,CM_EXP].NMEM_Z:=4;
 TableRF[CM_COSECH,CM_EXP].SHFT_Z:=2;

 TableRF[CM_COSECH,CM_SINH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSECH,CM_SINH].RRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSECH,CM_SINH].NMEM_R:=2;
 TableRF[CM_COSECH,CM_SINH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSECH,CM_SINH].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSECH,CM_SINH].NMEM_Z:=4;

 TableRF[CM_COSECH,CM_COSH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSECH,CM_COSH].RRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSECH,CM_COSH].NMEM_R:=2;
 TableRF[CM_COSECH,CM_COSH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSECH,CM_COSH].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSECH,CM_COSH].NMEM_Z:=4;

 TableRF[CM_COSECH,CM_SECH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSECH,CM_SECH].RRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSECH,CM_SECH].NMEM_R:=2;
 TableRF[CM_COSECH,CM_SECH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSECH,CM_SECH].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSECH,CM_SECH].NMEM_Z:=4;

 TableRF[CM_COSECH,CM_TANH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSECH,CM_TANH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_COSECH,CM_TANH].NMEM_R:=2;
 TableRF[CM_COSECH,CM_TANH].SHFT_R:=1;
 TableRF[CM_COSECH,CM_TANH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSECH,CM_TANH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COSECH,CM_TANH].NMEM_Z:=4;
 TableRF[CM_COSECH,CM_TANH].SHFT_Z:=2;

 TableRF[CM_COSECH,CM_COTANH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSECH,CM_COTANH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_COSECH,CM_COTANH].NMEM_R:=2;
 TableRF[CM_COSECH,CM_COTANH].SHFT_R:=1;
 TableRF[CM_COSECH,CM_COTANH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSECH,CM_COTANH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COSECH,CM_COTANH].NMEM_Z:=4;
 TableRF[CM_COSECH,CM_COTANH].SHFT_Z:=2;


             {    SECH    }
 TableRF[CM_SECH,CM_EXP].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SECH,CM_EXP].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_SECH,CM_EXP].NMEM_R:=2;
 TableRF[CM_SECH,CM_EXP].SHFT_R:=1;
 TableRF[CM_SECH,CM_EXP].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SECH,CM_EXP].RRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_SECH,CM_EXP].NMEM_Z:=4;
 TableRF[CM_SECH,CM_EXP].SHFT_Z:=2;

 TableRF[CM_SECH,CM_SINH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SECH,CM_SINH].RRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SECH,CM_SINH].NMEM_R:=2;
 TableRF[CM_SECH,CM_SINH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SECH,CM_SINH].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SECH,CM_SINH].NMEM_Z:=4;

 TableRF[CM_SECH,CM_COSH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SECH,CM_COSH].RRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SECH,CM_COSH].NMEM_R:=2;
 TableRF[CM_SECH,CM_COSH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SECH,CM_COSH].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SECH,CM_COSH].NMEM_Z:=4;

 TableRF[CM_SECH,CM_COSECH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SECH,CM_COSECH].RRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SECH,CM_COSECH].NMEM_R:=2;
 TableRF[CM_SECH,CM_COSECH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SECH,CM_COSECH].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SECH,CM_COSECH].NMEM_Z:=4;

 TableRF[CM_SECH,CM_TANH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SECH,CM_TANH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_SECH,CM_TANH].NMEM_R:=2;
 TableRF[CM_SECH,CM_TANH].SHFT_R:=1;
 TableRF[CM_SECH,CM_TANH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SECH,CM_TANH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_SECH,CM_TANH].NMEM_Z:=4;
 TableRF[CM_SECH,CM_TANH].SHFT_Z:=2;

 TableRF[CM_SECH,CM_COTANH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SECH,CM_COTANH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_SECH,CM_COTANH].NMEM_R:=2;
 TableRF[CM_SECH,CM_COTANH].SHFT_R:=1;
 TableRF[CM_SECH,CM_COTANH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SECH,CM_COTANH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_SECH,CM_COTANH].NMEM_Z:=4;
 TableRF[CM_SECH,CM_COTANH].SHFT_Z:=2;




        {ARCSIN}
 TableRF[CM_ARCSIN,CM_ARCCOS].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_ARCSIN,CM_ARCCOS].RRF_R:=rf_ARCSINR_REPLACE;
 TableRF[CM_ARCSIN,CM_ARCCOS].NMEM_R:=1;
 TableRF[CM_ARCSIN,CM_ARCCOS].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_ARCSIN,CM_ARCCOS].RRF_Z:=rf_ARCSINZ_REPLACE;
 TableRF[CM_ARCSIN,CM_ARCCOS].NMEM_Z:=2;

        {ARCCOS  }
 TableRF[CM_ARCCOS,CM_ARCSIN].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_ARCCOS,CM_ARCSIN].RRF_R:=rf_ARCCOSR_REPLACE;
 TableRF[CM_ARCCOS,CM_ARCSIN].NMEM_R:=1;
 TableRF[CM_ARCCOS,CM_ARCSIN].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_ARCCOS,CM_ARCSIN].RRF_Z:=rf_ARCCOSZ_REPLACE;
 TableRF[CM_ARCCOS,CM_ARCSIN].NMEM_Z:=2;

         {ARCTAN  }
 TableRF[CM_ARCTAN,CM_ARCCOTAN].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_ARCTAN,CM_ARCCOTAN].RRF_R:=rf_ARCTANR_REPLACE;
 TableRF[CM_ARCTAN,CM_ARCCOTAN].NMEM_R:=1;
 TableRF[CM_ARCTAN,CM_ARCCOTAN].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_ARCTAN,CM_ARCCOTAN].RRF_Z:=rf_ARCTANZ_REPLACE;
 TableRF[CM_ARCTAN,CM_ARCCOTAN].NMEM_Z:=2;

         {ARCCOTAN }
 TableRF[CM_ARCCOTAN,CM_ARCTAN].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_ARCCOTAN,CM_ARCTAN].RRF_R:=rf_ARCCOTANR_REPLACE;
 TableRF[CM_ARCCOTAN,CM_ARCTAN].NMEM_R:=1;
 TableRF[CM_ARCCOTAN,CM_ARCTAN].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_ARCCOTAN,CM_ARCTAN].RRF_Z:=rf_ARCCOTANZ_REPLACE;
 TableRF[CM_ARCCOTAN,CM_ARCTAN].NMEM_Z:=2;


        {ARCSEC }
 TableRF[CM_ARCSEC,CM_ARCCOSEC].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_ARCSEC,CM_ARCCOSEC].RRF_R:=rf_ARCSECR_REPLACE;
 TableRF[CM_ARCSEC,CM_ARCCOSEC].NMEM_R:=1;
 TableRF[CM_ARCSEC,CM_ARCCOSEC].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_ARCSEC,CM_ARCCOSEC].RRF_Z:=rf_ARCSECZ_REPLACE;
 TableRF[CM_ARCSEC,CM_ARCCOSEC].NMEM_Z:=2;


       {ARCCOSEC}
 TableRF[CM_ARCCOSEC,CM_ARCSEC].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_ARCCOSEC,CM_ARCSEC].RRF_R:=rf_ARCCOSECR_REPLACE;
 TableRF[CM_ARCCOSEC,CM_ARCSEC].NMEM_R:=1;
 TableRF[CM_ARCCOSEC,CM_ARCSEC].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_ARCCOSEC,CM_ARCSEC].RRF_Z:=rf_ARCCOSECZ_REPLACE;
 TableRF[CM_ARCCOSEC,CM_ARCSEC].NMEM_Z:=2;


end;




procedure TForevalH.AddToTableAccFastFunc(NFuncFast, NFuncAcc: Integer);
begin
 SetLength(TableAccFastFunc,Length(TableAccFastFunc)+1);
 TableAccFastFunc[High(TableAccFastFunc)].NFuncFast:=NFuncFast;
 TableAccFastFunc[High(TableAccFastFunc)].NFuncAcc:=NFuncAcc;
end;



procedure TForevalH.SetStdFunc;

     function _GetFuncMainId(NameF: String): Integer;
     label endp;
     var
       i,j,LF,NF: Integer;
       Sfn: String;
     begin
       NF:=-1;


        for i:=0 to High(Alg.ExFunc) do
        begin

          //if F_SyntaxExtension = True then LF:=High(Alg.ExFunc[i].NameEx) else LF:=0;
           if (NameF = Alg.ExFunc[i].Name) {and  (Alg.ExFunc[i].Enable = _YES)} then
           begin
                NF:=i; goto endp;
           end;
           (*
           for j := 0 to LF do
           begin

              //Sfn:=Alg.ExFunc[i].NameEx[j];

              if (NameF = Alg.ExFunc[i].NameEx[j]) {and  (Alg.ExFunc[i].Enable = _YES)} then
              begin
                NF:=i; goto endp;
              end;

           end;
           *)

        end;


     endp:
     _GetFuncMainId:=NF;
     end;

var
 IdName,i,NFunc: Integer;
begin



 if F_FAST_STD_FUNC  = True then
 begin


    for i := 0 to High(TableAccFastFunc)  do
    begin
       NFunc:=TableAccFastFunc[i].NFuncFast;
       Alg.ExFunc[NFunc].Enable:=_YES;
    end;
    SetNewFuncToOperation('^',CM_POWER);

   (*
   //FindFuncA('tan_acc',idName);

   //idName:=_GetFuncMainId('tan_acc');
   //Alg.ExFunc[idName].Enable:=_NO;
   Alg.ExFunc[CM_TAN].Enable:=_YES;

   //idName:=_GetFuncMainId('cotan_acc');
   //Alg.ExFunc[idName].Enable:=_NO;
   Alg.ExFunc[CM_COTAN].Enable:=_YES;

   //idName:=_GetFuncMainId('cos_acc');
   //Alg.ExFunc[idName].Enable:=_NO;
   Alg.ExFunc[CM_COS].Enable:=_YES;

   //idName:=_GetFuncMainId('sin_acc');
   //Alg.ExFunc[idName].Enable:=_NO;
   Alg.ExFunc[CM_SIN].Enable:=_YES;

   //idName:=_GetFuncMainId('pow_acc');
   //Alg.ExFunc[idName].Enable:=_NO;
   Alg.ExFunc[CM_POWER].Enable:=_YES;
   SetNewFuncToOperation('^',CM_POWER);

   //idName:=_GetFuncMainId('exp_acc');
   //Alg.ExFunc[idName].Enable:=_NO;
   Alg.ExFunc[CM_EXP].Enable:=_YES;

   //idName:=_GetFuncMainId('root_acc');
   //Alg.ExFunc[idName].Enable:=_NO;
   Alg.ExFunc[CM_ROOT].Enable:=_YES;

   //idName:=_GetFuncMainId('sqrt_acc');
   //Alg.ExFunc[idName].Enable:=_NO;
   Alg.ExFunc[CM_SQRT].Enable:=_YES;

   //idName:=_GetFuncMainId('ln_acc');
   //Alg.ExFunc[idName].Enable:=_NO;
   Alg.ExFunc[CM_LN].Enable:=_YES;

   //idName:=_GetFuncMainId('log_acc');
   //Alg.ExFunc[idName].Enable:=_NO;
   Alg.ExFunc[CM_LOGN].Enable:=_YES;

   //idName:=_GetFuncMainId('log10_acc');
   //Alg.ExFunc[idName].Enable:=_NO;
   Alg.ExFunc[CM_LOG10].Enable:=_YES;

   //idName:=_GetFuncMainId('log2_acc');
   //Alg.ExFunc[idName].Enable:=_NO;
   Alg.ExFunc[CM_LOG2].Enable:=_YES;

   //idName:=_GetFuncMainId('sinh_acc');
   //Alg.ExFunc[idName].Enable:=_NO;
   Alg.ExFunc[CM_SINH].Enable:=_YES;

   //idName:=_GetFuncMainId('cosh_acc');
   //Alg.ExFunc[idName].Enable:=_NO;
   Alg.ExFunc[CM_COSH].Enable:=_YES;

   //idName:=_GetFuncMainId('tanh_acc');
  //Alg.ExFunc[idName].Enable:=_NO;
   Alg.ExFunc[CM_TANH].Enable:=_YES;

   //idName:=_GetFuncMainId('cotanh_acc');
   //Alg.ExFunc[idName].Enable:=_NO;
   Alg.ExFunc[CM_COTANH].Enable:=_YES;

   //idName:=_GetFuncMainId('sec_acc');
   //Alg.ExFunc[idName].Enable:=_NO;
   Alg.ExFunc[CM_SEC].Enable:=_YES;

   //idName:=_GetFuncMainId('cosec_acc');
   //Alg.ExFunc[idName].Enable:=_NO;
   Alg.ExFunc[CM_COSEC].Enable:=_YES;

   //idName:=_GetFuncMainId('sech_acc');
   //Alg.ExFunc[idName].Enable:=_NO;
   Alg.ExFunc[CM_SECH].Enable:=_YES;

   //idName:=_GetFuncMainId('cosech_acc');
   //Alg.ExFunc[idName].Enable:=_NO;
   Alg.ExFunc[CM_COSECH].Enable:=_YES;


   //idName:=_GetFuncMainId('arctan_acc');
   //Alg.ExFunc[idName].Enable:=_NO;
   Alg.ExFunc[CM_ARCTAN].Enable:=_YES;

   //idName:=_GetFuncMainId('arccotan_acc');
   //Alg.ExFunc[idName].Enable:=_NO;
   Alg.ExFunc[CM_ARCCOTAN].Enable:=_YES;

   //idName:=_GetFuncMainId('arccos_acc');
   //Alg.ExFunc[idName].Enable:=_NO;
   Alg.ExFunc[CM_ARCCOS].Enable:=_YES;

   //idName:=_GetFuncMainId('arcsin_acc');
   //Alg.ExFunc[idName].Enable:=_NO;
   Alg.ExFunc[CM_ARCSIN].Enable:=_YES;

   //idName:=_GetFuncMainId('arcsec_acc');
   //Alg.ExFunc[idName].Enable:=_NO;
   Alg.ExFunc[CM_ARCSEC].Enable:=_YES;


   //idName:=_GetFuncMainId('arccosec_acc');
   //Alg.ExFunc[idName].Enable:=_NO;
   Alg.ExFunc[CM_ARCCOSEC].Enable:=_YES;



   //idName:=_GetFuncMainId('arctanh_acc');
   //Alg.ExFunc[idName].Enable:=_NO;
   Alg.ExFunc[CM_ARCTANH].Enable:=_YES;

   //idName:=_GetFuncMainId('arccotanh_acc');
   //Alg.ExFunc[idName].Enable:=_NO;
   Alg.ExFunc[CM_ARCCOTANH].Enable:=_YES;

   //idName:=_GetFuncMainId('arccosh_acc');
   //Alg.ExFunc[idName].Enable:=_NO;
   Alg.ExFunc[CM_ARCCOSH].Enable:=_YES;

   //idName:=_GetFuncMainId('arcsinh_acc');
   //Alg.ExFunc[idName].Enable:=_NO;
   Alg.ExFunc[CM_ARCSINH].Enable:=_YES;

   //idName:=_GetFuncMainId('arcsech_acc');
   //Alg.ExFunc[idName].Enable:=_NO;
   Alg.ExFunc[CM_ARCSECH].Enable:=_YES;


   //idName:=_GetFuncMainId('arccosech_acc');
   //Alg.ExFunc[idName].Enable:=_NO;
   Alg.ExFunc[CM_ARCCOSECH].Enable:=_YES;


   Alg.ExFunc[CM_COSSIN].Enable:=_YES;
    *)



 end
 else
 begin


    for i := 0 to High(TableAccFastFunc)  do
    begin
       NFunc:=TableAccFastFunc[i].NFuncFast;
       Alg.ExFunc[NFunc].Enable:=_NO;
    end;

    idName:=_GetFuncMainId('power_acc');
    SetNewFuncToOperation('^',idName);

  (*
   //idName:=_GetFuncMainId('tan_acc');
   //Alg.ExFunc[idName].Enable:=_YES;
   Alg.ExFunc[CM_TAN].Enable:=_NO;

   //FindFuncA('cot_acc',idName);
   //idName:=_GetFuncMainId('cotan_acc');
   //Alg.ExFunc[idName].Enable:=_YES;
   Alg.ExFunc[CM_COTAN].Enable:=_NO;

   //idName:=_GetFuncMainId('cos_acc');
   //Alg.ExFunc[idName].Enable:=_YES;
   Alg.ExFunc[CM_COS].Enable:=_NO;

   //idName:=_GetFuncMainId('sin_acc');
   //Alg.ExFunc[idName].Enable:=_YES;
   Alg.ExFunc[CM_SIN].Enable:=_NO;

   idName:=_GetFuncMainId('power_acc');
   //Alg.ExFunc[idName].Enable:=_YES;
   Alg.ExFunc[CM_POWER].Enable:=_NO;
   SetNewFuncToOperation('^',idName);

   //idName:=_GetFuncMainId('exp_acc');
   //Alg.ExFunc[idName].Enable:=_YES;
   Alg.ExFunc[CM_EXP].Enable:=_NO;

   //idName:=_GetFuncMainId('root_acc');
   //Alg.ExFunc[idName].Enable:=_YES;
   Alg.ExFunc[CM_ROOT].Enable:=_NO;

   //idName:=_GetFuncMainId('sqrt_acc');
   //Alg.ExFunc[idName].Enable:=_YES;
   Alg.ExFunc[CM_SQRT].Enable:=_NO;

   //idName:=_GetFuncMainId('log_acc');
   //Alg.ExFunc[idName].Enable:=_YES;
   Alg.ExFunc[CM_LOGN].Enable:=_NO;

   //idName:=_GetFuncMainId('log10_acc');
   //Alg.ExFunc[idName].Enable:=_YES;
   Alg.ExFunc[CM_LOG10].Enable:=_NO;

   //idName:=_GetFuncMainId('log2_acc');
   //Alg.ExFunc[idName].Enable:=_YES;
   Alg.ExFunc[CM_LOG2].Enable:=_NO;

   //idName:=_GetFuncMainId('tanh_acc');
   //Alg.ExFunc[idName].Enable:=_YES;
   Alg.ExFunc[CM_TANH].Enable:=_NO;

   //FindFuncA('cot_acc',idName);
   //idName:=_GetFuncMainId('cotanh_acc');
   //Alg.ExFunc[idName].Enable:=_YES;
   Alg.ExFunc[CM_COTANH].Enable:=_NO;

   //idName:=_GetFuncMainId('cosh_acc');
   //Alg.ExFunc[idName].Enable:=_YES;
   Alg.ExFunc[CM_COSH].Enable:=_NO;

   //idName:=_GetFuncMainId('sinh_acc');
   //Alg.ExFunc[idName].Enable:=_YES;
   Alg.ExFunc[CM_SINH].Enable:=_NO;

   //idName:=_GetFuncMainId('sec_acc');
   //Alg.ExFunc[idName].Enable:=_YES;
   Alg.ExFunc[CM_SEC].Enable:=_NO;

   //idName:=_GetFuncMainId('cosec_acc');
   //Alg.ExFunc[idName].Enable:=_YES;
   Alg.ExFunc[CM_COSEC].Enable:=_NO;

   //idName:=_GetFuncMainId('sech_acc');
   //Alg.ExFunc[idName].Enable:=_YES;
   Alg.ExFunc[CM_SECH].Enable:=_NO;

   //idName:=_GetFuncMainId('cosech_acc');
   //Alg.ExFunc[idName].Enable:=_YES;
   Alg.ExFunc[CM_COSECH].Enable:=_NO;



   //idName:=_GetFuncMainId('arctan_acc');
   //Alg.ExFunc[idName].Enable:=_YES;
   Alg.ExFunc[CM_ARCTAN].Enable:=_NO;

   //FindFuncA('cot_acc',idName);
   //idName:=_GetFuncMainId('arccotan_acc');
   //Alg.ExFunc[idName].Enable:=_YES;
   Alg.ExFunc[CM_ARCCOTAN].Enable:=_NO;

   //idName:=_GetFuncMainId('arccos_acc');
   //Alg.ExFunc[idName].Enable:=_YES;
   Alg.ExFunc[CM_ARCCOS].Enable:=_NO;

   //idName:=_GetFuncMainId('arcsin_acc');
   //Alg.ExFunc[idName].Enable:=_YES;
   Alg.ExFunc[CM_ARCSIN].Enable:=_NO;

   //idName:=_GetFuncMainId('arcsec_acc');
   //Alg.ExFunc[idName].Enable:=_YES;
   Alg.ExFunc[CM_ARCSEC].Enable:=_NO;

   //idName:=_GetFuncMainId('arccosec_acc');
   //Alg.ExFunc[idName].Enable:=_YES;
   Alg.ExFunc[CM_ARCCOSEC].Enable:=_NO;


   //idName:=_GetFuncMainId('arctanh_acc');
   //Alg.ExFunc[idName].Enable:=_YES;
   Alg.ExFunc[CM_ARCTANH].Enable:=_NO;

   //FindFuncA('cot_acc',idName);
   //idName:=_GetFuncMainId('arccotanh_acc');
   //Alg.ExFunc[idName].Enable:=_YES;
   Alg.ExFunc[CM_ARCCOTANH].Enable:=_NO;

   //idName:=_GetFuncMainId('arccosh_acc');
   //Alg.ExFunc[idName].Enable:=_YES;
   Alg.ExFunc[CM_ARCCOSH].Enable:=_NO;

   //idName:=_GetFuncMainId('arcsinh_acc');
   //Alg.ExFunc[idName].Enable:=_YES;
   Alg.ExFunc[CM_ARCSINH].Enable:=_NO;

   //idName:=_GetFuncMainId('arcsech_acc');
   //Alg.ExFunc[idName].Enable:=_YES;
   Alg.ExFunc[CM_ARCSECH].Enable:=_NO;

   //idName:=_GetFuncMainId('arccosech_acc');
   //Alg.ExFunc[idName].Enable:=_YES;
   Alg.ExFunc[CM_ARCCOSECH].Enable:=_NO;


   Alg.ExFunc[CM_COSSIN].Enable:=_NO;

   *)
 end;


end;



procedure TForevalH.SaveSW;
var
SSW: integer;
begin
 //если есть исключение: сохранить SW, но маски не сбрасывать
SSW:=0;

// {.365} Устранение странной ошибки, возникающей в некоторых случаях в CodeBlock16 (В остальных CodeBlock, MSVC ошибки нет)
if F_UseSaveSW = True then    {.365}
begin

if F_SaveSW = False then
begin
 asm
    push eax
    xor  eax,eax
    fnstsw ax
    sahf
    test ax, 001Fh

    jz @@Z

    push ax
    fnstsw ax
    mov word ptr [SWMEM],ax
    pop  ax
    mov SSW,1

    @@Z:
    pop eax

 end;

  if SSW = 1 then F_SaveSW:=True;
end;

end;

end;





procedure TForevalH.ClearFPUException;    {.229}
begin
 asm
    fnclex
 end;
end;


procedure TForevalH.MaskFPUException(CWAddr: PCardinal);  stdcall;  {.229}
begin
 asm
    push eax
    mov eax,CWAddr
    fnstcw word ptr [eax];       //->store
    pop eax
    sub esp,4
    fnstcw [esp];
    or word ptr [esp], 003Fh;
    fldcw [esp];
    add esp, 4
 end;
end;


 {.229}
function TForevalH.IsFPUException(CWAddr: PCardinal): integer;  stdcall;
begin
 asm
    push eax
    push ecx
    xor  eax,eax
    fnstsw ax
    sahf
    test ax, 001Fh
    mov  ecx,0
    //push $00000000
    jz @@Z
    mov  ecx,1
    //mov [esp],$00000001
    @@Z:
    mov dword ptr Result,ecx
    //pop dword ptr Result //[IsFPUException]
    fnclex
    mov eax,CWAddr
    fldcw  word ptr [eax]   //<-load
    pop ecx
    pop eax
 end;
end;



 {.229}
function TForevalH.IsFPUExceptionSW(CWAddr: PCardinal): integer;  stdcall;
begin
 asm
    push eax
    push ecx
    xor  eax,eax
    //fnstsw ax
    mov ax,word ptr [SWMEM]
    sahf
    test ax, 001Fh
    mov  ecx,0
    //push $00000000
    jz @@Z
    mov  ecx,1
    //mov [esp],$00000001
    @@Z:
    mov dword ptr Result,ecx
    //pop dword ptr Result //[IsFPUException]
    fnclex
    mov eax,CWAddr
    fldcw  word ptr [eax]   //<-load
    pop ecx
    pop eax
 end;
end;


{.229}
procedure TForevalH.TryFPUMask{(CWMEM: PCardinal)};
begin
 F_SaveSW:=False;
 if F_EnableMaskFpuException = True then MaskFPUException(@CWMEM{CWMEM});
end;


{.229}
procedure TForevalH.TryCatchFPUException{(CWMEM: PCardinal)};
begin
{if IsFPUException(@CWMEM) <> 0 then
begin
  F_InternalError:=E_InvalidOp;
  F_ErrorCode:=E_InvalidOp;
end;  }

  if F_EnableMaskFpuException = True then
   begin
     if F_SaveSW = True then
     begin
       if IsFPUExceptionSW(@CWMEM{CWMEM}) <> 0 then
       begin
         F_InternalError:=E_InvalidOp;
         F_SyntaxErrorCode:=E_INTERNAL_ERROR_AT_CALCULATION;
         //F_SyntaxErrorCode:=E_InvalidOp;
       end;
     end
     else
     begin
       if IsFPUException(@CWMEM{CWMEM}) <> 0 then
       begin
         F_InternalError:=E_InvalidOp;
         F_SyntaxErrorCode:=E_INTERNAL_ERROR_AT_CALCULATION;
         //F_SyntaxErrorCode:=E_InvalidOp;
       end;
     end;
   end;

end;




procedure _SetLenU(AddrV: Pointer; LenV: Integer); stdcall;
label endp;
var
i,TypeV: Integer;
Addr: Pointer;
begin

   for i := 0 to High(AlgVec) do
   begin

       //if AlgV.Obj[i].TypeF = T_Array then
       begin
          if AlgVec[i].Addr = Cardinal(AddrV) then
          begin
            TypeV := AlgVec[i].MType;
            SetLengthArray(AddrV,TypeV,LenV);
            goto endp;
          end;
       end;

   end;

endp:
end;



//parrayp(@vd,k+1)
//parrayp(@ve,k+1)
//parrayp(@vi,k+1)
//ptr1=@ve; parrayp(ptr1,k+1)
//ptr1=@vd; parrayp(ptr1,k+1)
//ptr1=@vi; parrayp(ptr1,k+1)
function _PArrayU(AddrV: Pointer; indx: Integer): Extended; stdcall;
label endp;
var
i,TypeV: Integer;
Addr: Pointer;
begin

   for i := 0 to High(AlgVec) do
   begin

       //if AlgV.Obj[i].TypeF = T_Array then
       begin
          if AlgVec[i].Addr = Cardinal(AddrV) then
          begin
            if AlgVec[i].MType = _Extended then _PArrayU:= PArrayE(AddrV)^[indx] else
            if AlgVec[i].MType = _Double   then _PArrayU:= PArrayD(AddrV)^[indx] else
            if AlgVec[i].MType = _Integer  then _PArrayU:= PArrayI(AddrV)^[indx] else
            if AlgVec[i].MType = _Pointer  then _PArrayU:= PArrayI(AddrV)^[indx];
            goto endp;
          end;
       end;

   end;

endp:
end;


//preal(@x)
//preal(@k)
//x:ext=1.2345; ptr1: pointer=@x; preal(ptr1)

//отключена в TForevalH.SetObject2:
function _PRealU(AddrV: Pointer): Extended; stdcall;
label endp;
var
i,TypeV: Integer;
Addr: Pointer;
begin

   for i := 0 to High(AlgVarR) do
   begin

       //if AlgV.Obj[i].TypeF = T_Array then
       begin
          if AlgVarR[i].Addr = Cardinal(AddrV) then
          begin
            if AlgVarR[i].MType = _Extended then _PRealU:= PExtended(AddrV)^ else
            if AlgVarR[i].MType = _Double   then _PRealU:= PDouble(AddrV)^ else
            if AlgVarR[i].MType = _Integer  then _PRealU:= PInteger(AddrV)^ else
            if AlgVarR[i].MType = _Single   then _PRealU:= PSingle(AddrV)^ else
            if AlgVarR[i].MType = _Pointer  then _PRealU:= PInteger(AddrV)^;
            goto endp;
          end;
       end;

   end;

endp:
end;



procedure TForevalH.FADD(N: TAddress; VType: Integer);
begin
 if VType = _Extended then
 begin
  FLD(N,_Extended);
  FADDP;
 end
 else
 if VType = _Double then
 begin
  AddComA($DC,$05,N);
 end
 else
 if VType = _Single then
 begin
   AddComA($D8,$05,N);
 end
 else
 if VType = _Integer then
 begin
   AddComA($DA,$05,N);
 end;
end;


procedure TForevalH.FADDP;
begin
 AddWord($DE,$C1);
 CheckStack(-1);
end;

procedure TForevalH.FADDP1;
begin
 AddWord($DE,$C1);
 CheckStack(-1);
end;

procedure TForevalH.FADDP2;
begin
 AddWord($DE,$C2);
 CheckStack(-1);
end;


procedure TForevalH.FADDP20;
begin
 AddWord($DE,$C2);
 CheckStack(-1);
end;



procedure TForevalH.FADDP30;
begin             //st(3)=st(0)+st(3)   ; fstp(0)
 AddWord($DE,$C3);
 CheckStack(-1);
end;

procedure TForevalH.FSUBRP;
begin                 //st(1)=st(0)-st(1)   ; fstp(0)
 AddWord($DE,$E1);
 CheckStack(-1);
end;

procedure TForevalH.FSUBRP2;
begin                 //st(2)=st(0)-st(2) ; fstp(0)
 AddWord($DE,$E2);
 CheckStack(-1);
end;



procedure TForevalH.FSUBP2;
begin
 AddWord($DE,$EA);
 CheckStack(-1);
end;



procedure TForevalH.FSUBP40;
begin        //fsubp st(4),st(0)
 AddWord($DE,$EC);
 CheckStack(-1);
end;



procedure TForevalH.FMULP;
begin
 AddWord($DE,$C9);
 CheckStack(-1);
end;


procedure TForevalH.FMULP1;
begin           //fmulp st(1),st(0)
 AddWord($DE,$C9);
 CheckStack(-1);
end;



procedure TForevalH.FMULP2;
begin     //fmulp st(2),st(0)
 AddWord($DE,$CA);
 CheckStack(-1);
end;

procedure TForevalH.FMULP4;
begin     //fmulp st(4),st(0)
 AddWord($DE,$CC);
 CheckStack(-1);
end;


procedure TForevalH.FMULP20;
begin     //fmulp st(2),st(0)
 AddWord($DE,$CA);
 CheckStack(-1);
end;



procedure TForevalH.FMUL20;
begin     //fmul st(2),st(0)
 AddWord($DC,$CA);
end;

procedure TForevalH.FMUL30;
begin     //fmul st(3),st(0)
 AddWord($DC,$CB);
end;


procedure TForevalH.FADDP3;
begin
 AddWord($DE,$C3);
 CheckStack(-1);
end;


procedure TForevalH.FDIV2;
begin     //fdiv st(2),st(0)
 AddWord($DC,$FA);
end;

procedure TForevalH.FDIVR2;
begin                    //fdivr st,st(2)
AddWord($D8,$FA);
end;

procedure TForevalH.FSUBP01;
begin                    //fsubp st(1),st(0)
AddWord($DE,$E9);
CheckStack(-1);
end;


procedure TForevalH.FDIVP1;
begin     //fdivp st(0),st(1)
 AddWord($D8,$FA);
 CheckStack(-1);
end;

{procedure TForevalH.FDIVP2;
begin     //fdivp st(2),st(0)
 AddWord($DE,$FA);
 CheckStack(-1);
end;}


procedure TForevalH.FLD0;
begin
 AddWord($D9,$C0);
 CheckStack(1);
end;

procedure TForevalH.FLDZ;
begin
 AddWord($D9,$EE);
 CheckStack(1);
end;



procedure TForevalH.FXCH1;
begin
 AddWord($D9,$C9);
end;

procedure TForevalH.FXCH2;
begin
 AddWord($D9,$CA);
end;


procedure TForevalH.FXCH3;
begin
 AddWord($D9,$CB);
end;


procedure TForevalH.FXCH4;
begin
 AddWord($D9,$CC);
end;


procedure TForevalH.FCHS;
begin
AddWord($D9,$E0);
end;

procedure TForevalH.PUSHB;
begin
AddByte($53);
end;

procedure TForevalH.POPB;
begin
AddByte($5B);
end;



procedure TForevalH.PUSHM(N: Cardinal);
begin
//непосредственная загрузка стека
AddComA($68,N);
end;


procedure TForevalH.FLD(N: TAddress; VType: Integer);
begin
case VType of
_Single:    AddComA($D9,$05,N);
_Double:    AddComA($DD,$05,N);
_Extended:  AddComA($DB,$2D,N);
_Integer:   AddComA($DB,$05,N);
_Pointer:   AddComA($DB,$05,N);
end;
CheckStack(1);
end;


procedure TForevalH.FSTPM(N: TAddress; VType: Integer);
begin
F_SData:=_MEM;
case VType of
_Single:   AddComA($D9,$1D,N);
_Extended: AddComA($DB,$3D,N);
_Double:   AddComA($DD,$1D,N);
_Integer:  AddComA($DB,$1D,N);    //fistp
_Pointer:  AddComA($DB,$1D,N);    //fistp
end;
CheckStack(-1);
end;



procedure TForevalH.FSTM(N: TAddress; VType: Integer);
begin
 if VType = _Extended then
 begin
  FLD0;
  FSTPM(N,_Extended)
 end
 else
 if VType = _Double then
 begin
  AddComA($DD,$15,N);
 end
 else
 if VType = _Single then
 begin
   AddComA($D9,$15,N);
 end;
end;



procedure  TForevalH.FCOMPP;
begin
 AddWord($DE,$D9);
 CheckStack(-2);
end;

procedure  TForevalH.FCOMIP;
begin
 AddWord($DF,$F1);
 CheckStack(-1);
end;


procedure  TForevalH.FCOMIP2;
begin                       //fcomip st,st2
 AddWord($DF,$F2);
 CheckStack(-1);
end;


procedure  TForevalH.FCOMI;
begin                       //fcomi st,st1
 AddWord($DB,$F1);
end;



procedure  TForevalH.FSTSW_AX;
begin
 AddWord($DF,$E0);
 SetReg(1);     {.213}
end;

procedure  TForevalH.SAHF;
begin
 AddByte($9E);
end;


procedure TForevalH.JMPC(N: TAddress; VType: Integer);
begin
case VType of
2:    AddComA($0F,$84,N);        //jz
3:    AddComA($0F,$83,N);        //jnb
4:    AddComA($0F,$86,N);        //jbe
5:    AddComA($0F,$82,N);        //jb
6:    AddComA($0F,$87,N);        //jnbe
7:    AddComA($0F,$85,N);        //jnz
end;
end;


procedure TForevalH.JMPCI(N: TAddress; VType: Integer);
begin
case VType of
2:    AddComA($0F,$84,N);        //jz      =
3:    AddComA($0F,$8E,N);        //jnb    //jle  >=
4:    AddComA($0F,$8D,N);        //jbe    //jnl  <=
5:    AddComA($0F,$8F,N);        //jb     //jnle  <
6:    AddComA($0F,$8C,N);        //jnbe   //jl     >
7:    AddComA($0F,$85,N);        //jnz     <>
end;
end;



procedure TForevalH.JMP(ofst: Integer);
begin
 AddComA($E9,ofst);        //jmp offset 4bytes
end;



procedure TForevalH.FLDREG(Reg,tm: Integer);
//fld type ptr [reg]
begin
if Reg = R_ESI then
begin
   case tm of
     _Double:        AddByte2($DD,$06);       //fld qword ptr [esi]
     _Extended:      AddByte2($DB,$2E);       //fld tbyte ptr [esi]
     _Single:        AddByte2($D9,$06);       //fld dword ptr [esi]
   end;
end
else
if Reg = R_EDI then
begin
   case tm of
     _Double:        AddByte2($DD,$07);        //fld qword ptr [edi]
     _Extended:      AddByte2($DB,$2F);        //fld tbyte ptr [edi]
     _Single:        AddByte2($D9,$07);        //fld dword ptr [edi]
   end;
end
else
if Reg = R_EBX then
begin
   case tm of
     _Double:        AddByte2($DD,$03);       //fld qword ptr [ebx]
     _Extended:      AddByte2($DB,$2B);       //fld tbyte ptr [ebx]
     _Single:        AddByte2($D9,$03);       //fld dword ptr [ebx]
   end;
end;

CheckStack(1);

end;



procedure TForevalH.FSTPREG(Reg,tm: Integer);
//fstp type ptr [reg]
begin
if Reg = R_ESI then
begin
   case tm of
     _Double:        AddByte2($DD,$1E);        //fstp qword ptr [esi]
     _Extended:      AddByte2($DB,$3E);        //fstp tbyte ptr [esi]
     _Single:        AddByte2($D9,$1E);        //fstp dword ptr [esi]
   end;
end
else
if Reg = R_EDI then
begin
   case tm of
     _Double:        AddByte2($DD,$1F);        //fstp qword ptr [edi]
     _Extended:      AddByte2($DB,$3F);        //fstp tbyte ptr [edi]
     _Single:        AddByte2($D9,$1F);        //fstp dword ptr [edi]
   end;
end
else
if Reg = R_EBX then
begin
   case tm of
     _Double:        AddByte2($DD,$1B);        //fstp qword ptr [ebx]
     _Extended:      AddByte2($DB,$3B);        //fstp tbyte ptr [ebx]
     _Single:        AddByte2($D9,$1B);        //fstp dword ptr [ebx]
   end;
end;

CheckStack(-1);


end;



procedure  TForevalH.ZMULP;
begin

   FLD0;
   FMUL03;
   FXCH1;
   FMUL04;
   FXCH4;
   FMUL02;
   FSUBP1;
   FXCH2;
   FMULP1;
   FADDP2;

end;




procedure  TForevalH.ZMUL;
begin
   FLD0;
   FMUL03;
   FXCH1;
   FMUL04;
   FXCH2;
   FLD0;
   FMUL05;
   FXCH1;
   FMUL04;
   FXCH2;
   FSUBRP;
   FXCH1;
   FADDP20;
end;


procedure  TForevalH.ZDIV;
begin
       if F_FAST_DIV = True then
       begin
            MOVAadr(TAddress(@Z_DIV_FAST))     //FAST DIV!!!
       end
       else
       begin
           // MOVAadr(TAddress(@Z_DIV));
           // MOVAadr(TAddress(@Z_DIV_acc));  {.335}
           MOVAadr(TAddress(ZDIV_ADDR));     {.345}
       end;

       CheckStack(2);
       CheckStack(-4);
       CALLA;

end;



procedure  TForevalH.RZDIV;
begin
           if F_FAST_DIV = True then
           begin
             MOVAadr(TAddress(@Z_RZDIV_FAST));        //FAST DIV!!!
             {.335}
             CheckStack(1);
             CheckStack(-2);
           end
           else
           begin
             //MOVAadr(TAddress(@Z_RZDIV));
             {.335}
             //MOVAadr(TAddress(@Z_RZDIV_acc));
             MOVAadr(TAddress(RZDIV_ADDR)); {.345}
             CheckStack(2);
             CheckStack(-3);
           end;
           CALLA;
end;



procedure  TForevalH.MUL_ST(tc,ts: Integer);
{                               //Stack before               //Stack after:
  tc=T_Real; ts=T_Real;         ST(0)*[ST(1)]                -> ST(0);       ST(1)
  tc=T_Real; ts=T_Complex;      ST(0)*[ST(1),ST(2)]          -> ST(0),ST(1); ST(2),ST(3)
  tc=T_Complex; ts=T_Real;      (ST(0),ST(1))*[ST(2)]        -> ST(0),ST(1); ST(2);
  tc=T_Complex; ts=T_Complex;   (ST(0),ST(1))*[ST(2),ST(3)]  -> ST(0),ST(1); ST(2),ST(3);

}
begin

  if (tc = T_Real) and  (ts = T_Real)  then
  begin
     FMUL01;
  end
  else
  if (tc = T_Real) and  (ts = T_Complex)  then
  begin
     FLD0;
     FMUL03;
     FXCH1;
     FMUL02;
  end
  else
  if (tc = T_Complex) and  (ts = T_Real)  then
  begin
     FMUL02;
     FXCH1;
     FMUL02;
     FXCH1;
  end
  else
  if (tc = T_Complex) and  (ts = T_Complex)  then
  begin
     ZMUL;
  end;

end;


procedure  TForevalH.MULP_ST(tc,ts: Integer);
{                               //Stack before               //Stack after:
  tc=T_Real; ts=T_Real;         ST(0)*ST(1)                  -> ST(0);
  tc=T_Real; ts=T_Complex;      ST(0)*(ST(1),ST(2))          -> ST(0),ST(1);
  tc=T_Complex; ts=T_Real;      (ST(0),ST(1))*ST(2)          -> ST(0),ST(1);
  tc=T_Complex; ts=T_Complex;   (ST(0),ST(1))*(ST(2),ST(3))  -> ST(0),ST(1);

}
begin

  if (tc = T_Real) and  (ts = T_Real)  then
  begin
    FMULP;
  end
  else
  if (tc = T_Real) and  (ts = T_Complex)  then
  begin
    FMUL20;
    FMULP;
  end
  else
  if (tc = T_Complex) and  (ts = T_Real)  then
  begin
    FMUL02;
    FXCH1;
    FMULP2;
  end
  else
  if (tc = T_Complex) and  (ts = T_Complex)  then
  begin
    ZMULP;
  end;

end;

procedure  TForevalH.ADDP_ST(tc,ts: Integer);
{                               //Stack before               //Stack after:
  tc=T_Real; ts=T_Real;         ST(0)+ST(1)                  -> ST(0);
  tc=T_Real; ts=T_Complex;      ST(0)+(ST(1),ST(2))          -> ST(0),ST(1);
  tc=T_Complex; ts=T_Real;      (ST(0),ST(1))+ST(2)          -> ST(0),ST(1);
  tc=T_Complex; ts=T_Complex;   (ST(0),ST(1))+(ST(2),ST(3))  -> ST(0),ST(1);

}
begin

  if (tc = T_Real) and  (ts = T_Real)  then
  begin
    FADDP;
  end
  else
  if (tc = T_Real) and  (ts = T_Complex)  then
  begin
    FADDP;
  end
  else
  if (tc = T_Complex) and  (ts = T_Real)  then
  begin
    FADDP2;
    FXCH1;
  end
  else
  if (tc = T_Complex) and  (ts = T_Complex)  then
  begin
    FADDP2;
    FADDP2;
  end;

end;



procedure  TForevalH.ZSQR;
begin
  

   FLD0;
   FMUL0;
   FXCH1;
   FMUL02;
   //FMUL(Cardinal(@S_c2),_Double);
   FMUL(WriteDataA(2,_Double),_Double);      {.217}
   FXCH2;
   FMUL0;
   FSUBP;


end;



procedure TForevalH.ZIPWR3;
begin

  FLD0;
  FMUL0;
  FMUL01;
  FXCH2;
  FLD0;
  FMUL0;
  FMUL01;
  FXCH1;
  FLD0;
  FMUL03;
  //FMUL(Cardinal(@S_c3),_Double);
  FMUL(WriteDataA(3,_Double),_Double);      {.217}
  FXCH1;
  FMUL01;
  FSUBP40;
  FMULP20;
  FSUBP;
  FXCH1;

end;



procedure TForevalH.ZIPWR4;
begin
   ZSQR;
   ZSQR;
end;



procedure TForevalH.ZIPWR5;
begin
   ZPUSH;
   ZSQR;
   ZSQR;
   ZMULP;
end;


procedure TForevalH.ZIPWR6;
begin
   ZSQR;
   ZPUSH;
   ZSQR;
   ZMULP;
end;


procedure TForevalH.ZIPWR7;
begin
   ZPUSH;
   ZSQR;
   ZPUSH;
   ZSQR;
   ZMULP;
   ZMULP;
end;


procedure TForevalH.ZIPWR8;
begin
   ZSQR;
   ZSQR;
   ZSQR;
end;



procedure TForevalH.ZIPWR9;
begin
   ZPUSH;
   ZSQR;
   ZSQR;
   ZSQR;
   ZMULP;
end;




procedure TForevalH.ZIPWR10;
begin
   ZSQR;
   ZPUSH;
   ZSQR;
   ZSQR;
   ZMULP;
end;




procedure TForevalH.ZIPWR11;
begin
   ZPUSH;
   ZSQR;
   ZPUSH;
   ZSQR;
   ZSQR;
   ZMULP;
   ZMULP;
end;




procedure TForevalH.ZIPWR12;
begin
   ZSQR;
   ZSQR;
   ZPUSH;
   ZSQR;
   ZMULP;
end;




procedure TForevalH.ZIPWR13;
begin
ZPUSH;
ZSQR;
ZSQR;
ZPUSH;
ZSQR;
ZMULP;
ZMULP;
end;




procedure TForevalH.ZIPWR14;
begin
ZSQR;
ZPUSH;
ZSQR;
ZPUSH;
ZSQR;
ZMULP;
ZMULP;
end;






procedure TForevalH.ZIPWR15;
begin
{ZPUSH;
ZPUSH;
ZSQR;
ZPUSH;
ZSQR;
ZMULP;
ZMULP;
ZSQR;
ZMULP; }
     MOVCREG(R_EAX,15);
     MOVBadr(Cardinal(@Z_IPWR));
     CALLB;
     CheckStack(4);
     CheckStack(-4);
     SetReg(1); SetReg(3); SetReg(4);
end;





procedure TForevalH.ZIPWR16;
begin
ZSQR;
ZSQR;
ZSQR;
ZSQR;
end;




procedure  TForevalH.ZPUSH;
begin
  FLD0;
  FXCH2;
  FLD0;
  FXCH3;
end;



procedure TForevalH.AddCom(B1,B2: Byte);
begin
if F_Mode=M_Compile then
begin
 SetLength(ICOMP,Length(ICOMP)+2);
 ICOMP[High(ICOMP)-1]:=B1; ICOMP[High(ICOMP)]:=B2;
end;
end;


procedure TForevalH.AddCom(B1,B2,B3: Byte);
begin
if F_Mode = M_Compile then
begin
 SetLength(ICOMP,Length(ICOMP)+3);
 ICOMP[High(ICOMP)-2]:=B1; ICOMP[High(ICOMP)-1]:=B2; ICOMP[High(ICOMP)]:=B3;
end;
end;




procedure TForevalH.AddComA(B1: Byte; Adr: TAddress);
var
P: ^Cardinal;
begin
if F_Mode=M_Compile then
begin
 SetLength(ICOMP,Length(ICOMP)+5);
 ICOMP[High(ICOMP)-4]:=B1;
 P:=@ICOMP[High(ICOMP)-3];
 P^:=Adr;
end;
end;


procedure TForevalH.AddComA(B1,B2: Byte; Adr: TAddress);
var
P: ^Cardinal;
begin
if F_Mode=M_Compile then
begin
 SetLength(ICOMP,Length(ICOMP)+6);
 ICOMP[High(ICOMP)-5]:=B1; ICOMP[High(ICOMP)-4]:=B2;
 P:=@ICOMP[High(ICOMP)-3];
 P^:=Adr;
end;
end;


procedure TForevalH.AddComA(B1,B2,B3: Byte; Adr: TAddress);
var
P: ^Cardinal;
begin
if F_Mode = M_Compile then
begin
 SetLength(ICOMP,Length(ICOMP)+7);
 ICOMP[High(ICOMP)-6]:=B1; ICOMP[High(ICOMP)-5]:=B2; ICOMP[High(ICOMP)-4]:=B3;
 P:=@ICOMP[High(ICOMP)-3];
 P^:=Adr;
end;
end;





(*
function  TForevalH.WriteData(NF: Integer): TAddress;
var
Pm: Pointer;
begin
if F_Opt = False then
begin
  {Pm:=Pointer(@Interp[NF].FD);

  case  F_DataType of
  _Integer:   Integer(Pm^):=Trunc(Interp[NF].FD);
  //_Single:    Single(Pm^):=Interp[NF]^.FD;
  _Double:    Double(Pm^):=Interp[NF].FD;
  _Extended:  Extended(Pm^):=Interp[NF].FD;
  end;

  WriteData:=TAddress(Pm); }

end;
end;
*)


function  TForevalH.WriteData(Node: PNode): TAddress;
var
FD1: PFuncData;
Pm: Pointer;
Data: extended;
begin


if F_Mode=M_Compile then
begin

     if F_DataInArray = True then
     begin
       Pm:=Pointer(@Func.RFStack[N_CurrentDataCell+N_ReplFuncLen]);
       inc(N_CurrentDataCell);

          {DB}
          if N_CurrentDataCell+N_ReplFuncLen > High(Func.RFStack) then
          begin
              Db_WriteDataOverFlow:=True;
          end;

      end
     else
     begin
       new(FD1); FD1^.Next:=nil;
       FuncData^.Next:=FD1;
       FuncData:=FD1;
       Pm:=Pointer(@FD1^.FData);
     end;

    Data:=Node^.FD;

    case  F_DataType of
       _Integer:   Integer(Pm^):=Trunc(Data);
       //_Single:    Single(Pm^):=Data;
       _Double:    Double(Pm^):=Data;
       _Extended:  Extended(Pm^):=Data;
    end;

    WriteData:=TAddress(Pm);

 end
else
begin
 WriteData:=TAddress(nil);
 inc(N_DataCellNum);
end;

end;





 //выделяет память для сохранения промежуточных результатов вычислений - возвращвает адрес ячейки
 //Data - инициализирующее значение
 //DataType - тип данных для сохранения
function  TForevalH.WriteDataA(Data: extended; DataType: Integer): TAddress;
var
FD1: PFuncData;
Pm: Pointer;
begin


if F_Mode=M_Compile then
begin
   //выделение в массиве (размер рассчитывается заранее в EvalDataCellNum) =
   // = число  промежуточных результатов + число замещаемых выражений в оптимизациях Replace
   if F_DataInArray = True then
   begin
     Pm:=Pointer(@Func.RFStack[N_CurrentDataCell+N_ReplFuncLen]);
     inc(N_CurrentDataCell);

        {DB}
         if N_CurrentDataCell+N_ReplFuncLen > High(Func.RFStack) then
         begin
             Db_WriteDataOverFlow:=True;
         end;

   end
   else
   begin

     new(FD1); FD1^.Next:=nil;
     FuncData^.Next:=FD1;
     FuncData:=FD1;
     Pm:=Pointer(@FD1^.FData);

   end;

   case  DataType of
    _Integer:   Integer(Pm^):=Trunc(Data);
    //_Single:    Single(Pm^):=Data;
    _Double:    Double(Pm^):=Data;
    _Extended:  Extended(Pm^):=Data;
    end;

    WriteDataA:=TAddress(Pm);


end
else
begin
  WriteDataA:=TAddress(nil);
  inc(N_DataCellNum);
end;

end;



procedure TForevalH.FreeData;
var
FD1,FD2: PFuncData;
begin

FD1:=BFuncData;
while FD1 <> nil do
begin
 FD2:=FD1^.Next;
 dispose(FD1);
 FD1:=FD2;
end;

end;




procedure TForevalH.SaveMainRes;
begin

 if (G_FAttr.FType <>  0) and (F_ResultType <> T_None) then
 begin

   if F_CalcType = T_Real then
   begin
     FSTPM(G_FAttr.AddrRE,G_FAttr.FType);
   end
   else
   if F_CalcType = T_Complex then
   begin
     FSTPM(G_FAttr.AddrRE,G_FAttr.FType);
     FSTPM(G_FAttr.AddrIM,G_FAttr.FType);
   end
   else
   if F_CalcType = T_Any then
   begin
     if F_ResultType = T_Real then
     begin
       FSTPM(G_FAttr.AddrRE,G_FAttr.FType);
     end
     else
     if F_ResultType = T_Complex then
     begin
       FSTPM(G_FAttr.AddrRE,G_FAttr.FType);
       FSTPM(G_FAttr.AddrIM,G_FAttr.FType);
     end
   end;


 end;

end;




procedure TForevalH.IntToHex(N: TAddress; var AH: TArray4);
var
i,K,j: Integer;
N1: Cardinal;
A8: array [1..8] of Integer;
begin
N1:=N;  j:=1;
for i:=7 downto 1 do
begin
 K:=Trunc(N1/fc_IntPower(2,i*4));
 A8[j]:=(K);
 N1:=N1-Trunc(fc_IntPower(2,i*4))*K;
 inc(j);
end;
A8[j]:=N1;


//в обратном порядке:
j:=1;
for i:=4 downto 1 do
begin
 AH[i]:=A8[j]*16+A8[j+1];
 j:=j+2;
end;
end;


procedure TForevalH.IntToHexNum(N: Integer; var AH: TArray4);
var
i,K,N1,j: Cardinal;
A8: array [1..8] of Integer;
begin
N1:=N;  j:=1;
//if N1 < 0 then N1:=4294967296+N1;

for i:=7 downto 1 do
begin
 K:=Trunc(abs(N1/fc_IntPower(2,i*4)));
 A8[j]:=(K);
 N1:=N1-Trunc(fc_IntPower(2,i*4))*K;
 inc(j);
end;
A8[j]:=N1;


//в обратном порядке:
j:=1;
for i:=4 downto 1 do
begin
 AH[i]:=A8[j]*16+A8[j+1];
 j:=j+2;
end;
end;




procedure TForevalH.SaveReg;
var
PP: array [0..7] of byte;
i,L,j,k: integer;
begin
L:=-1;

for i:=1 to 8 do
begin
 PP[i-1]:=0;
if (REG[i] <> 0) or (REGA[i] <> 0) or ((REGF[i] <> 0) and (F_ExtFunc = True)) then   {.193}
 begin
 inc(L); PP[L]:=i;
 end;
end;

if L > -1 then
begin
 j:=High(ICOMP);
 SetLength(ICOMP,Length(ICOMP)+2*(L+1));

 for i:=j downto 0 do
 begin
 ICOMP[i+(L+1)]:=ICOMP[i];
 end;

 for i:=0 to (L{+1}) do
 begin
  if PP[i] = 1 then ICOMP[i]:=$50 else
  if PP[i] = 2 then ICOMP[i]:=$53 else
  if PP[i] = 3 then ICOMP[i]:=$51 else
  if PP[i] = 4 then ICOMP[i]:=$52 else
  if PP[i] = 5 then ICOMP[i]:=$54 else
  if PP[i] = 6 then ICOMP[i]:=$55 else
  if PP[i] = 7 then ICOMP[i]:=$56 else
  if PP[i] = 8 then ICOMP[i]:=$57;
 end;

 k:=0;
 for i:=(L{+1}) downto 0 do
 begin
  if PP[i] = 1 then
   begin ICOMP[j+(L+1)+k+1]:=$58; inc(k); end else
  if PP[i] = 2 then
   begin ICOMP[j+(L+1)+k+1]:=$5B; inc(k); end else
  if PP[i] = 3 then
   begin ICOMP[j+(L+1)+k+1]:=$59; inc(k); end else
  if PP[i] = 4 then
   begin ICOMP[j+(L+1)+k+1]:=$5A; inc(k); end else
  if PP[i] = 5 then
   begin ICOMP[j+(L+1)+k+1]:=$5C; inc(k); end else
  if PP[i] = 6 then
   begin ICOMP[j+(L+1)+k+1]:=$5D; inc(k); end else
  if PP[i] = 7 then
   begin ICOMP[j+(L+1)+k+1]:=$5E; inc(k); end else
  if PP[i] = 8 then
   begin ICOMP[j+(L+1)+k+1]:=$5F; inc(k); end;


 end;

end;

//RET;
end;



procedure TForevalH.SaveRegF;
var
N,NF,SR,b: Cardinal;
  I: Integer;
begin

 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;}
 N:=GNode^.NFunc;
 NF:=GNode^.NF;

 SR:=Alg.ExFunc[N].Func[NF].SaveReg;
 //n:=0; k:=147;    //10010011
 for i := 0 to 7 do
 begin
   b:=(SR and (1 shl i));
   if b <> 0 then REGF[i+1]:=1;
 end;
 {b:= SR and (1 shl 0);
 b:= SR and (1 shl 1);
 b:= SR and (1 shl 2);
 b:= SR and (1 shl 3);
 b:= SR and (1 shl 4);
 b:= SR and (1 shl 5);
 b:= SR and (1 shl 6);
 b:= SR and (1 shl 7); }
end;


procedure TForevalH.SetReg(R: Integer);
begin
//1 - EAX; 2 - EBX; 3 - ECX; 4 - EDX;
REG[R]:=1;
end;


procedure TForevalH.SetRegA(R: Integer; SC: Integer);
begin //для установки из-вне принудительного сохранения регистров
//1 - EAX; 2 - EBX; 3 - ECX; 4 - EDX; 5 - ESP; 6 - EBP; 7 - ESI; 8 - EDI;
REGA[R]:=SC;
end;



procedure TForevalH.AddByte(B: Byte);
var
j: Integer;
begin
if F_Mode=M_Compile then
begin
 j:=High(ICOMP)+1;
 SetLength(ICOMP,Length(ICOMP)+1);
 ICOMP[j]:=B;
end;
end;


procedure TForevalH.AddByte2(B1: Byte; B2: Byte);
var
j: Integer;
begin
if F_Mode=M_Compile then
begin
 j:=High(ICOMP)+1;
 SetLength(ICOMP,Length(ICOMP)+2);
 ICOMP[j]:=B1; ICOMP[j+1]:=B2;
end;
end;



procedure TForevalH.AddByte3(B1,B2,B3: Byte);
var
j: Integer;
begin
if F_Mode=M_Compile then
begin
 j:=High(ICOMP)+1;
 SetLength(ICOMP,Length(ICOMP)+3);
 ICOMP[j]:=B1; ICOMP[j+1]:=B2;  ICOMP[j+2]:=B3;
end;
end;




procedure TForevalH.AddWord(B1: Byte; B2: Byte);
var
j: Integer;
begin
if F_Mode=M_Compile then
begin
 j:=High(ICOMP)+1;
 SetLength(ICOMP,Length(ICOMP)+2);
 ICOMP[j]:=B1; ICOMP[j+1]:=B2;
end;
end;



{
procedure TForevalH.AddAddress(Adr: TAddress);
var
AB: TArray4;
j: Integer;
begin
IntToHex(Adr,AB);
j:=High(ICOMP)+1;
SetLength(ICOMP,Length(ICOMP)+4);
ICOMP[j]:=AB[1];  ICOMP[j+1]:=AB[2]; ICOMP[j+2]:=AB[3]; ICOMP[j+3]:=AB[4];
end;
}
procedure TForevalH.AddAddress(Adr: TAddress);
var
//AB: TArray4;
j: Cardinal;
P: ^Cardinal;
begin
if F_Mode = M_Compile then     {???}
begin
 j:=High(ICOMP)+1;
 SetLength(ICOMP,Length(ICOMP)+4);
 P:=@ICOMP[j];
 P^:=Adr;
end;
end;


{
procedure TForevalH.AddNum(Num: Integer);
var
AB: TArray4;
j: Integer;
begin
IntToHexNum(Num,AB);
j:=High(ICOMP)+1;
SetLength(ICOMP,Length(ICOMP)+4);
ICOMP[j]:=AB[1];  ICOMP[j+1]:=AB[2]; ICOMP[j+2]:=AB[3]; ICOMP[j+3]:=AB[4];
end;
}

procedure TForevalH.AddNum(Num: Integer);
var
//AB: TArray4;
j: Cardinal;
P: ^Integer;//Pointer;
begin
if F_Mode = M_Compile then     {???}
begin
 j:=High(ICOMP)+1;
 SetLength(ICOMP,Length(ICOMP)+4);
 P:=@ICOMP[j];
 P^:=Num;
end;
end;



procedure TForevalH.InsertInlineCode(BeginAddr: Cardinal; CodeLength: Cardinal);
var
j,k: Integer;
P: ^Byte;
begin
if F_Mode=M_Compile then
begin

 j:=High(ICOMP)+1;
 SetLength(ICOMP,Length(ICOMP)+CodeLength-1); // -1 последняя команда RET !!!
 P:=Pointer(BeginAddr);
 for k := j to j+CodeLength-2 do   // -1 последняя команда RET !!!
 begin
   ICOMP[k]:=P^;
   inc(P);
 end;

end;
end;



procedure TForevalH.CALLA;
begin
AddWord($FF,$D0);
SetReg(1);
end;



procedure TForevalH.CALLC;
begin
AddWord($FF,$D1);
SetReg(3);
end;


procedure TForevalH.MOVAM(N: TAddress);
begin
//EAX->MEM
AddWord($89,$05);
AddAddress(N);
SetReg(1);
end;


procedure TForevalH.MOV_MEM_EAX(N: TAddress);
begin
//[MEM]->EAX
AddByte($A1);
AddAddress(N);
SetReg(1);
end;



procedure TForevalH.MOVMA(N: TAddress);
begin
//[MEM]->EAX
AddWord($8B,$05);
AddAddress(N);
SetReg(1);
end;


procedure TForevalH.MOVMB(N: TAddress);
begin
//[MEM]->EBX
AddWord($8B,$1D);
AddAddress(N);
SetReg(2);
end;




procedure TForevalH.MOVMC(N: TAddress);
begin
//[MEM]->ECX
AddWord($8B,$0D);
AddAddress(N);
SetReg(3);
end;


procedure TForevalH.MOVMD(N: TAddress);
begin
//[MEM]->EDX
AddWord($8B,$15);
AddAddress(N);
SetReg(4);
end;



procedure TForevalH.MOVAA;
begin
//[EAX]->EAX        mov  eax,[eax]
AddWord($8B,$00);
SetReg(1);
end;




procedure TForevalH.MOVBB;
begin
//[EBX]->EBX        mov  ebx,[ebx]
AddWord($8B,$1b);
SetReg(2);
end;



procedure TForevalH.MOVAnum(N: Integer{TAddress});
begin
//N - число
AddByte($B8);
AddNum(N);
SetReg(1);
end;


procedure TForevalH.MOVBnum(N: Integer{TAddress});
begin
AddByte($BB);
AddNum(N);
SetReg(2);
end;



procedure TForevalH.MOVCnum(N: Integer{TAddress});
begin
AddByte($B9);
AddNum(N);
SetReg(3);
end;


procedure TForevalH.MOVDnum(N: Integer{TAddress});
begin
AddByte($BA);
AddNum(N);
SetReg(4);
end;


procedure TForevalH.MOVAadr(N: TAddress);
begin
AddByte($B8);
AddAddress(N);
SetReg(1);
end;


procedure TForevalH.MOVBadr(N: TAddress);
begin
AddByte($BB);
AddAddress(N);
SetReg(2);
end;



procedure TForevalH.MOVCadr(N: TAddress);
begin
AddByte($B9);
AddAddress(N);
SetReg(3);
end;



procedure TForevalH.INCMEM(N: TAddress);
begin
AddWord($FF,$05);
AddAddress(N);
end;




procedure TForevalH.DECMEM(N: TAddress);
begin
AddWord($FF,$0D);
AddAddress(N);
end;



procedure TForevalH.MOVESPEAX(N: Integer);
begin
if N = 0 then AddCom($89,$04,$24)     //mov [esp],eax
else
              AddComA($89,$84,$24,N);  //mov[esp+N],eax

end;


procedure TForevalH.CALLB;
begin
AddWord($FF,$D3);
SetReg(2);
end;


procedure TForevalH.FLD(N: TAddress);
begin
AddWord($DD,$05);
AddAddress(N);
CheckStack(1);
end;



procedure TForevalH.FSTP(N: TAddress);
begin
AddWord($DD,$1D);
AddAddress(N);
CheckStack(-1);
end;


procedure TForevalH.PUSHAD;
begin
AddByte($60);
end;


procedure TForevalH.POPAD;
begin
AddByte($61);
end;

procedure TForevalH.ADDESP(N: Integer);
begin
if N <> 0 then
AddComA($81,$C4,N);
end;


procedure TForevalH.SUBESP(N: Integer);
begin
if N <> 0 then
AddComA($81,$EC,N);
end;

procedure TForevalH.FISTP(N: TAddress);
begin
AddWord($DB,$1D);
AddAddress(N);
CheckStack(-1);
end;



procedure TForevalH.FSTPESP(VType: Integer);
begin
 case VType of
  _Single:   AddCom($D9,$1C,$24);
  _Integer:  AddCom($DB,$1C,$24);  //fistp
  _Pointer:  AddCom($DB,$1C,$24);  //fistp
  _Double:   AddCom($DD,$1C,$24);
  _Extended: AddCom($DB,$3C,$24);
 end;
 CheckStack(-1);
end;


procedure TForevalH.FSTPESP(VType: Integer; N: Integer);
begin
if N = 0 then FSTPESP(VType)
else
begin
 case VType of
  _Single:   AddComA($D9,$9C,$24,N);
  _Integer:  AddComA($DB,$9C,$24,N);  //fistp
  _Pointer:  AddComA($DB,$9C,$24,N);  //fistp
  _Double:   AddComA($DD,$9C,$24,N);
  _Extended: AddComA($DB,$BC,$24,N);
 end;
 CheckStack(-1);
end;
end;



procedure TForevalH.FLDCW(N: TAddress);
begin

//FNFLEX
AddWord($DB,$E2);
//FLDCW
AddWord($D9,$2D);
AddAddress(N);
end;


procedure TForevalH.PUSHCW;
begin
//sub esp,4
AddWord($83,$EC);    AddByte($04);
//fnstcw [esp];
AddWord($D9,$3C);   AddByte($24);
end;



procedure TForevalH.POPCW;
begin
//fldcw [esp];
AddWord($D9,$2C);   AddByte($24);
//add esp, 4
AddWord($83,$C4);    AddByte($04);
end;


procedure  TForevalH.FRNDINT;
begin
AddWord($D9,$FC);
end;


procedure TForevalH.FEXP;
begin
  MOVAadr(Cardinal(@R_EXP));
  CALLA;
  CheckStack(2);
  CheckStack(-2);
end;

procedure TForevalH.ZEXP;
begin
  MOVAadr(Cardinal(@Z_EXP));
  CALLA;
  CheckStack(2);
  CheckStack(-2);
end;

procedure TForevalH.FSIN;
begin
 AddWord($D9,$FE);
end;



procedure TForevalH.FPTAN;
begin
 AddWord($D9,$F2);
 CheckStack(1);
end;



procedure TForevalH.FCOS;
begin
 AddWord($D9,$FF);
end;



procedure TForevalH.FSINCOS;
begin
 AddWord($D9,$FB);
 CheckStack(1);
end;



procedure TForevalH.FPATAN;
begin
 AddWord($D9,$F3);
 CheckStack(-1);
end;



procedure TForevalH.FSTP0;
begin
 AddWord($DD,$D8);
 CheckStack(-1);
end;


procedure TForevalH.FSTP1;
begin
  AddWord($DD,$D9);    //fstp  st(1)
 CheckStack(-1);
end;


procedure TForevalH.FLD1;
begin
 AddWord($D9,$E8);
 CheckStack(1);
end;


procedure TForevalH.FDIVR_C1;
begin   // 1/st(0)
 FLD1;
 FDIVRP;
end;

procedure TForevalH.ZDIVR_C1;
begin   // 1/Z
{
 Not change code!!!
 OR after change, reinstall new 'goto' labels in functions that depend on this ZDIVR_C1:
   SEC_C,COSECH_C,SECH_C, COTANH_C,...
}
if F_FAST_DIV = True then
begin
  {.340}
  FLD0;
  FMUL0;
  FXCH2;
  FLD0;
  FMUL0;
  FADDP30;
  FLD1;
  FDIVRP3;
  FMUL02;
  FCHS;
  FXCH2;
  FMULP;


  {FLD1;
  FXCH2;
  FLD0;
  FMUL0;
  FXCH1;
  FMUL03;
  FCHS;
  FXCH3;
  FMUL02;
  FXCH2;
  FMUL0;
  FADDP;
  FLD1;
  FDIVRP;
  FMUL10;
  FMULP20; }
end
else
begin
  {.340}
  FLD1;
  //MOVAadr(TAddress(@Z_RZDIV_acc));
  MOVAadr(TAddress(RZDIV_ADDR)); {.345}
  CheckStack(2);
  CheckStack(-3);
  CALLA;
 {
  FLD1;
  FXCH2;
  FLD0;
  FMUL0;
  FXCH1;
  FCHS;
  FXCH3;
  FMUL02;
  FXCH2;
  FMUL0;
  FADDP;
  FDIV10;
  FDIVP2;
  }
  {
  fxch st(2)
  fld  st
  fmul st,st
  fxch
  fmul st,st(3)
  fchs
  fxch st(3)
  fmul st,st(2)
  fxch st(2)
  fmul st,st
  faddp

  fdiv  st(1),st
  fdivp st(2),st
  }
end;
end;


procedure TForevalH.ZMUL_i;
begin   // i*Z
 FXCH1;
 FCHS;
end;

procedure TForevalH.ZDIV_i;
begin   // z/i
 FCHS;
 FXCH1;
end;




procedure TForevalH.ZDIVR_i;
begin   // i/z
{
 Not change code!!!
 OR after change, reinstall new 'goto' labels in functions that depend on this ZDIVR_i:
   COSEC_C,...
}
if F_FAST_DIV = True then
begin
 FLD0;
 FMUL0;
 FXCH2;
 FLD0;
 FMUL0;
 FADDP3;
 FLD1;
 FDIVRP3;
 FMUL02;
 FXCH1;
 FMULP20;
end
else       // only ZDIV_STD on all non-fast divisions
begin
 FLD0;
 FMUL0;
 FXCH2;
 FLD0;
 FMUL0;
 FADDP3;
 FDIV02;
 FXCH1;
 FDIVRP2;
end;

end;


procedure TForevalH.FMUL_C05;
begin
 //FMUL(TAddress(@S_C05),_Double);
 FMUL(WriteDataA(0.5,_Double),_Double); //{.217}
end;



procedure TForevalH.FDIV_C3;
begin
 FDIV(WriteDataA(3.0,_Double),_Double); //{.217}
end;




procedure TForevalH.FLDLN2;
begin
AddWord($D9,$ED);
CheckStack(1);
end;


procedure TForevalH.FYL2X;
begin
AddWord($D9,$F1);
CheckStack(-1);
end;


procedure TForevalH.FLDLG2;
begin
AddWord($D9,$EC);
CheckStack(1);
end;




procedure TForevalH.FABS;
begin
AddWord($D9,$E1);
end;



procedure TForevalH.PUSHF(N: TAddress);
begin
//загрузка стека по адресу: dword ptr [N]
AddWord($FF,$35);
AddAddress(N);
end;


procedure TForevalH.POPF(N: TAddress);
begin
//выталкивание стека по адресу: dword ptr [N]
AddWord($8F,$05);
AddAddress(N);
end;


procedure TForevalH.FILD(N: TAddress);
begin
AddWord($DB,$05);
AddAddress(N);
CheckStack(1);
end;

procedure TForevalH.IPWRC16(P,VType: Integer);
begin
if VType = T_Real then
begin
    case abs(P) of
      0: begin FSTP0; FLD1; end;
      1: ;
      2:  RSQR;
      3:  RIPWR3;
      4:  RIPWR4;
      5:  RIPWR5;
      6:  RIPWR6;
      7:  RIPWR7;
      8:  RIPWR8;
      9:  RIPWR9;
      10: RIPWR10;
      11: RIPWR11;
      12: RIPWR12;
      13: RIPWR13;
      14: RIPWR14;
      15: RIPWR15;
      16: RIPWR16;
    end;

    if P < 0 then
    begin
       FLD1;
       FDIVRP;
    end;

end
else
if VType = T_Complex then
begin
     case abs(P) of
      0: begin FSTP0; FSTP0; FLDZ; FLD1; end;
      1: ;
      2:  ZSQR;
      3:  ZIPWR3;
      4:  ZIPWR4;
      5:  ZIPWR5;
      6:  ZIPWR6;
      7:  ZIPWR7;
      8:  ZIPWR8;
      9:  ZIPWR9;
      10: ZIPWR10;
      11: ZIPWR11;
      12: ZIPWR12;
      13: ZIPWR13;
      14: ZIPWR14;
      15: ZIPWR15;
      16: ZIPWR16;
    end;


    if P < 0 then
    begin
       if F_FAST_DIV = True then
       begin
          MOVAadr(Cardinal(@Z_IPWRN1));
       end
       else
       begin
          FLD1;
          //MOVAadr(Cardinal(@Z_RZDIV_acc));
          MOVAadr(Cardinal(RZDIV_ADDR)); {.345}
       end;
      CALLA;
      CheckStack(2);
      CheckStack(-2);
    end;
end;

end;


procedure TForevalH.RSQR;
begin
FMUL0;
end;



procedure TForevalH.RIPWR3;
begin
FLD0;
FMUL0;
FMULP1;
end;



procedure TForevalH.RIPWR4;
begin
FMUL0;
FMUL0;
end;



procedure TForevalH.RIPWR5;
begin
FLD0;
FMUL0;
FMUL0;
FMULP1;
end;



procedure TForevalH.RIPWR6;
begin
FMUL0;
FLD0;
FMUL0;
FMULP1;
end;




procedure TForevalH.RIPWR7;
begin
FLD0;
FMUL0;
FLD0;
FMUL0;
FMULP1;
FMULP1;
end;



procedure TForevalH.RIPWR8;
begin
FMUL0;
FMUL0;
FMUL0;
end;



procedure TForevalH.RIPWR9;
begin
FLD0;
FMUL0;
FMUL0;
FMUL0;
FMULP1;
end;






procedure TForevalH.RIPWR10;
begin
FMUL0;
FLD0;
FMUL0;
FMUL0;
FMULP1;
end;




procedure TForevalH.RIPWR11;
begin
FLD0;
FMUL0;
FLD0;
FMUL0;
FMUL0;
FMULP1;
FMULP1;
end;




procedure TForevalH.RIPWR12;
begin
FMUL0;
FMUL0;
FLD0;
FMUL0;
FMULP1;
end;




procedure TForevalH.RIPWR13;
begin
FLD0;
FMUL0;
FMUL0;
FLD0;
FMUL0;
FMULP1;
FMULP1;
end;




procedure TForevalH.RIPWR14;
begin
FMUL0;
FLD0;
FMUL0;
FLD0;
FMUL0;
FMULP1;
FMULP1;
end;






procedure TForevalH.RIPWR15;
begin
FLD0;
FLD0;
FMUL0;
FLD0;
FMUL0;
FMULP1;
FMULP1;
FMUL0;
FMULP1;
end;





procedure TForevalH.RIPWR16;
begin
FMUL0;
FMUL0;
FMUL0;
FMUL0;
end;





procedure TForevalH.FTRUNC;
begin
PUSHCW;    {.227}
FLDCW(TAddress(@FCW1));
FRNDINT;
POPCW;    {.227}//FLDCW(TAddress(@FCW2));
end;

procedure TForevalH.TRUNCM(N: TAddress);
begin
PUSHCW;    {.227}
FLDCW(TAddress(@FCW1));
FISTP(N);
POPCW;    {.227}//FLDCW(TAddress(@FCW2));
end;


procedure TForevalH.TRUNCR(Reg: Integer);
begin           //Trunc(ST(0)) -> Reg
   PUSHCW;
   FLDCW(TAddress(@FCW1));
   MEM:=WriteDataA(0,_Integer);
   FISTP(MEM);
   POPCW;    {.227} //FLDCW(TAddress(@FCW2));

   if Reg =  R_EAX then    MOVMA(MEM) else
   if Reg =  R_EBX then    MOVMB(MEM) else
   if Reg =  R_ECX then    MOVMC(MEM) else
   if Reg =  R_EDX then    MOVMD(MEM);

end;


procedure TForevalH.MOVDM(N: TAddress);
begin
//EDX->MEM
AddWord($89,$15);
AddAddress(N);
SetReg(4);
end;

procedure TForevalH.IDIVM(N: TAddress);
begin
 AddComA($F7,$3D,N);
 SetReg(1);
 SetReg(4);
end;


procedure TForevalH.LineForm1;    //use: EAX,EBX,ECX
label endp;
var
LT,L,LA,i: Integer;
ICF,IM,LN,IM1,IM2,HM,tva,tma: Integer;
ra,LF1: Boolean;
AddrI,AddrI1,AddrI2: TAddress;
  j: Integer;
begin
//LF1:=True: LineForm(1 order)   a1*i1+a2*i2+...+an*in+ICF;

ICF:=Trunc(GNode^.FD);
L:=Length(GNode^.AIVP1);
ra:=false;

if L = 0 then     //const
begin
   MOVCREG(R_EAX,ICF);
end
else
//if L = 1 then    //a*i+b
begin
 //L = 1:     a*i+b

 IM:=GNode^.AIVP1[0].A;

 GetVar1(GNode^.AIVP1[0].NV[0],AddrI,tva,TMA);


 if ICF <> 0 then
 begin
   MOVCREG(R_EAX,ICF);
   ra:=true;
 end;

 if ra = true then
 begin   //b+a*i
    MOVMREG(R_EBX,AddrI);
    IMULCREG(R_EBX,abs(IM));
    if IM < 0 then SUBREG(R_EAX,R_EBX) else
                   ADDREG(R_EAX,R_EBX);
 end
 else  //a*i
 begin
   MOVMREG(R_EAX,AddrI);
   IMULCREG(R_EAX,IM);
 end;

 if L = 1 then goto endp;

//L > 1: a1*i1+a2*i2+...+ICF
 (*
 for i := 1 to L - 1 do
 begin
    IM:=GNode^.AIVP1[i].A;
    AddrI:=GNode^.AIVP1[i].NV[0];

    MOVMREG(R_EBX,AddrI);
    IMULCREG(R_EBX,abs(IM));
    if IM < 0 then SUBREG(R_EAX,R_EBX) else
                   ADDREG(R_EAX,R_EBX);

 end;
 *)

 HM:=L-1;
 LN:=HM div 2;

   i:=1;
   while i <= 2*LN do
   begin
     IM1:=GNode^.AIVP1[i].A; GetVar1(GNode^.AIVP1[i].NV[0],AddrI1,tva,TMA);//AddrI1:=GNode^.AIVP1[i].NV[0];
     IM2:=GNode^.AIVP1[i+1].A; GetVar1(GNode^.AIVP1[i+1].NV[0],AddrI2,tva,TMA);//AddrI2:=GNode^.AIVP1[i+1].NV[0];




     if IM1 = 1 then
      ADDMREG(R_EAX,AddrI1)
     else
     if IM1 = -1 then
      SUBMREG(R_EAX,AddrI1)
     else
     begin
      MOVMREG(R_EBX,AddrI1);
      IMULCREG(R_EBX,abs(IM1));
     end;



     if IM2 = 1 then
      ADDMREG(R_EAX,AddrI2)
     else
     if IM2 = -1 then
      SUBMREG(R_EAX,AddrI2)
     else
     begin
       MOVMREG(R_ECX,AddrI2);
       IMULCREG(R_ECX,abs(IM2));
     end;



     if abs(IM1) > 1 then
     begin
       if (IM1 < 0) then SUBREG(R_EAX,R_EBX) else
                         ADDREG(R_EAX,R_EBX);
     end;


     if abs(IM2) > 1 then
     begin
       if (IM2 < 0) then SUBREG(R_EAX,R_ECX) else
                         ADDREG(R_EAX,R_ECX);
     end;


     i:=i+2;
   end;

   if HM mod 2 <> 0 then
   begin
      IM:=GNode^.AIVP1[HM].A; GetVar1(GNode^.AIVP1[HM].NV[0],AddrI,tva,TMA);//AddrI:=GNode^.AIVP1[HM].NV[0];

       if IM = 1 then
         ADDMREG(R_EAX,AddrI)
       else
       if IM = -1 then
         SUBMREG(R_EAX,AddrI)
       else
       begin
         MOVMREG(R_EBX,AddrI);
         IMULCREG(R_EBX,abs(IM));
       end;

       if abs(IM) > 1 then
       begin
          if (IM < 0) then SUBREG(R_EAX,R_EBX) else
                           ADDREG(R_EAX,R_EBX);
       end;
   end;

end;




endp:
end;



//vd[-k-j+5-k*j*3*j*2-j*l*n-k-j*3+n*m*4-k*n*j-l*m*k*5-j+l+k*m*2-4*k*j*l-150-j*m+k*n*3-m+l*2-k*3+50*k*j+100]

procedure TForevalH.LineFormN(AIVP1: TArrayIntVarProd; IC: Integer);    //use: EAX,EBX,ECX,EDX

   function MulIntVar(ANV: TArrayI;  Reg,A: Integer): Boolean;
   var
    L,j,tva,tma: Integer;
    AddrI: TAddress;
    Answ: Boolean;
   begin
     Answ:=False;
     L:=Length(ANV);

     if L > 1 then                     //A*I1*...In
     begin
          GetVar1(ANV[0],AddrI,tva,TMA);
          MOVMREG(Reg,AddrI);   //I1->Reg

          for j := 1 to  L-1 do           //I1*...*In
          begin
             GetVar1(ANV[j],AddrI,tva,TMA);
             IMULMREG(Reg,AddrI);
          end;

          (*
          if A = 1 then             //*A
            ADDREG(R_EAX,Reg)
          else
          if A = -1 then
            SUBREG(R_EAX,Reg)
          else
          begin
            IMULCREG(Reg,abs(A));
          end;
          *)

          {.357}
          //if abs(A) <> 1 then   IMULCREG(Reg,abs(A));
          IMULCREG(Reg,A);

          Answ:=True;
     end;

     MulIntVar:=Answ;
   end;


label endp;
var
LT,L,LA,i,Reg: Integer;
ICF,IM,LN,IM1,IM2,HM,tva,tma: Integer;
ra,LF1: Boolean;
AddrI,AddrI1,AddrI2: TAddress;
  j: Integer;
begin
//LF1:=True: LineForm(1 order)   A1*I1*..*Ik+A2*I1*...*In+...+An*I1*...*Ij+ICF;
{
ICF:=Trunc(GNode^.FD);        //ICF=B
L:=Length(GNode^.AIVP1);   }

ICF:=IC;
L:=Length(AIVP1);

ra:=false;

if L = 0 then     //const
begin
   MOVCREG(R_EAX,ICF);
end
else
//if L = 1 then    //a*i+b
begin
 //L = 1:     A*I1+B, A*I1*...*In+B

 IM:={GNode^.}AIVP1[0].A;

 GetVar1({GNode^.}AIVP1[0].NV[0],AddrI,tva,TMA);


 if ICF <> 0 then
 begin
   MOVCREG(R_EAX,ICF);
   ra:=true;
 end;

 if ra = true then
 begin   //b+a*i , b+a*i1*...*in ,
    //MOVMREG(R_EBX,AddrI);
    //IMULCREG(R_EBX,abs(IM));
    if MulIntVar({GNode^.}AIVP1[0].NV,R_EBX,abs(IM)) = False then
    begin

         if IM = 1 then
            ADDMREG(R_EAX,AddrI)
          else
          if IM = -1 then
            SUBMREG(R_EAX,AddrI)
          else
          begin
            MOVMREG(R_EBX,AddrI);
            IMULCREG(R_EBX,abs(IM));
          end;

    end
    else
     begin
          if IM = 1 then             //*A
            ADDREG(R_EAX,R_EBX)
          else
          if IM = -1 then
            SUBREG(R_EAX,R_EBX)
     end;

     if abs(IM) > 1 then
     begin
       if (IM < 0) then  SUBREG(R_EAX,R_EBX) else
                         ADDREG(R_EAX,R_EBX);
     end;
 end
 else  //a*i, a*i1*...*in
 begin
   //MOVMREG(R_EAX,AddrI);                       {.357}  //k=-j*n;k
   if MulIntVar({GNode^.}AIVP1[0].NV,R_EAX,{abs(IM)}IM) = False then
   begin
    MOVMREG(R_EAX,AddrI);
    IMULCREG(R_EAX,IM);
   end;

   //IMULCREG(R_EAX,IM);
 end;

 if L = 1 then goto endp;

//L > 1: A1*I1*..*Ik+A2*I1*...*In+...+An*I1*...*Ij+ICF;


 HM:=L-1;
 LN:=HM div 2;

   i:=1;
   while i <= 2*LN do       //multiplication twice at a time  (EBX,ECX)
   begin

    //Reult -> EAX

     // (1) -> EBX   (i)
     IM1:={GNode^.}AIVP1[i].A; GetVar1({GNode^.}AIVP1[i].NV[0],AddrI1,tva,TMA);//AddrI1:=GNode^.AIVP1[i].NV[0];
     // EBX
     Reg:=R_EBX;
     if MulIntVar({GNode^.}AIVP1[i].NV,Reg,abs(IM1)) = False then  // A*I1*...In,  A*I1;
     begin
     // A*I1

          if IM1 = 1 then
            ADDMREG(R_EAX,AddrI1)
          else
          if IM1 = -1 then
            SUBMREG(R_EAX,AddrI1)
          else
          begin
            MOVMREG(Reg,AddrI1);
            IMULCREG(Reg,abs(IM1));
          end;

     end
     else
     begin

     {if IM1 = 1 then
            ADDMREG(R_EAX,AddrI1)
          else
          if IM1 = -1 then
            SUBMREG(R_EAX,AddrI1)  }

          if IM1 = 1 then             //*A
            ADDREG(R_EAX,Reg)
          else
          if IM1 = -1 then
            SUBREG(R_EAX,Reg)
          {else
          begin
            IMULCREG(Reg,abs(A));
          end; }

     end;





     // (2) -> ECX   (i+1)
     IM2:={GNode^.}AIVP1[i+1].A; GetVar1({GNode^.}AIVP1[i+1].NV[0],AddrI2,tva,TMA);//AddrI2:=GNode^.AIVP1[i+1].NV[0];
     // ECX
     Reg:=R_ECX;
     if MulIntVar({GNode^.}AIVP1[i+1].NV,Reg,abs(IM2)) = False then  // A*I1*...In,  A*I1;
     begin
     // A*I1
            if IM2 = 1 then
            ADDMREG(R_EAX,AddrI2)
          else
          if IM2 = -1 then
            SUBMREG(R_EAX,AddrI2)
          else
          begin
            MOVMREG(R_ECX,AddrI2);
            IMULCREG(R_ECX,abs(IM2));
          end;
     end
     else
     begin
          if IM2 = 1 then
            ADDREG(R_EAX,Reg)
          else
          if IM2 = -1 then
            SUBREG(R_EAX,Reg)
     end;



     if abs(IM1) > 1 then
     begin
       if (IM1 < 0) then SUBREG(R_EAX,R_EBX) else
                         ADDREG(R_EAX,R_EBX);
     end;


     if abs(IM2) > 1 then
     begin
       if (IM2 < 0) then SUBREG(R_EAX,R_ECX) else
                         ADDREG(R_EAX,R_ECX);
     end;



     (*
     {I1***In}
     HMV:=Length(GNode^.AIVP1[i].NV);
     if HMV > 1 then                     //a*I1*...In
     begin

          MOVMREG(R_EBX,AddrI1);
          for j := 1 to  HMV do           //I1*...*In
          begin
             GetVar(GNode^.AIVP1[i].NV[j],AddrI,tva,TMA);
             IMULMREG(R_EBX,AddrI);
          end;

          if IM1 = 1 then             //*A
            ADDMREG(R_EAX,R_EBX)
          else
          if IM1 = -1 then
            SUBMREG(R_EAX,R_EBX)
          else
          begin
            IMULCREG(R_EBX,abs(IM1));
          end;

     end
     else //a*I1
     begin
          if IM1 = 1 then
            ADDMREG(R_EAX,AddrI1)
          else
          if IM1 = -1 then
            SUBMREG(R_EAX,AddrI1)
          else
          begin
            MOVMREG(R_EBX,AddrI1);
            IMULCREG(R_EBX,abs(IM1));
          end;
     end;
     *)
     {*****************************}





     //IM2:=GNode^.AIVP1[i+1].A; GetVar(GNode^.AIVP1[i+1].NV[0],AddrI2,tva,TMA);//AddrI2:=GNode^.AIVP1[i+1].NV[0];

     (*
     {I1***In}
     HMV:=Length(GNode^.AIVP1[i+1].NV);
     if HMV > 1 then                     //a*I1*...In
     begin

          MOVMREG(R_ECX,AddrI2);
          for j := 1 to  HMV do           //I1*...*In
          begin
             GetVar(GNode^.AIVP1[i].NV[j],AddrI,tva,TMA);
             IMULMREG(R_ECX,AddrI);
          end;

          if IM2 = 1 then             //*A
            ADDMREG(R_EAX,R_ECX)
          else
          if IM2 = -1 then
            SUBMREG(R_EAX,R_ECX)
          else
          begin
            IMULCREG(R_ECX,abs(IM2));
          end;

     end
     else //a*I1
     begin
          if IM2 = 1 then
            ADDMREG(R_EAX,AddrI2)
          else
          if IM2 = -1 then
            SUBMREG(R_EAX,AddrI2)
          else
          begin
            MOVMREG(R_ECX,AddrI2);
            IMULCREG(R_ECX,abs(IM2));
          end;
     end;
     *)
     {*****************************}


      {

     if abs(IM1) > 1 then
     begin
       if (IM1 < 0) then SUBREG(R_EAX,R_EBX) else
                         ADDREG(R_EAX,R_EBX);
     end;


     if abs(IM2) > 1 then
     begin
       if (IM2 < 0) then SUBREG(R_EAX,R_ECX) else
                         ADDREG(R_EAX,R_ECX);
     end;
     }

     i:=i+2;
   end;

   if HM mod 2 <> 0 then    //Last elements
   begin
      IM:={GNode^.}AIVP1[HM].A; GetVar1({GNode^.}AIVP1[HM].NV[0],AddrI,tva,TMA);//AddrI:=GNode^.AIVP1[HM].NV[0];
      Reg:=R_EBX;
      if MulIntVar({GNode^.}AIVP1[HM].NV,Reg,abs(IM)) = False then  // A*I1*...In,  A*I1;
      begin
      // A*I1

          if IM = 1 then
            ADDMREG(R_EAX,AddrI)
          else
          if IM = -1 then
            SUBMREG(R_EAX,AddrI)
          else
          begin
            MOVMREG(R_EBX,AddrI);
            IMULCREG(R_EBX,abs(IM));
          end;

      end
      else
      begin
          if IM = 1 then
            ADDREG(R_EAX,Reg)
          else
          if IM = -1 then
            SUBREG(R_EAX,Reg)
      end;

      {
       if IM = 1 then
         ADDMREG(R_EAX,AddrI)
       else
       if IM = -1 then
         SUBMREG(R_EAX,AddrI)
       else
       begin
         MOVMREG(R_EBX,AddrI);
         IMULCREG(R_EBX,abs(IM));
       end; }

       if abs(IM) > 1 then
       begin
          if (IM < 0) then SUBREG(R_EAX,R_EBX) else
                           ADDREG(R_EAX,R_EBX);
       end;
   end;

end;




endp:
end;

(*

 procedure LoadIntFormEAX(Place: Integer);
   var
    code,tva,tma: Integer;
    AddrI: Cardinal;

   begin
      if Place = _First then
      begin
       code:=GNode^.TA1;
       if code = _IntConst then
       begin
          MOVCREG(R_EAX,Node^.IC1);
       end
       else
       if code = _IntVar then
       begin
          GetVar(Node^.NV1,AddrI1,tva,TMA);
          MOVMREG(R_EAX,AddrI1);
       end
       else
        LineFormN(GNode^.AIVP1,GNode^.IC1);
      end
      else
      if Place = _Second then
      begin
       code:=GNode^.TA2;
       if code = _IntConst then
       begin
          MOVCREG(R_EAX,Node^.IC2);
       end
       else
       if code = _IntVar then
       begin
          GetVar(Node^.NV2,AddrI,tva,TMA);
          MOVMREG(R_EAX,AddrI);
       end
       else
        LineFormN(GNode^.AIVP2,GNode^.IC2);
      end ;

   end;

*)

procedure TForevalH.LoadLineFormEAX(place: Integer);
var
ta1,ta2: Integer;
begin
if place = _First  then
begin
       ta1:=GNode^.TA1;

       if (ta1 = _IntForm)  then  //IntForm->IntVar
       begin
          LineFormN(GNode^.AIVP1,GNode^.IC1);
       end
       else
       if (ta1 = _IntVar)  then    //IntVar->IntVar
       begin
          MOVMREG(R_EAX,Alg.Obj[GNode^.NV1].Addr);
       end
       else
       if (ta1 = _IntConst)  then      //IntConst->IntVar
       begin
          MOVCREG(R_EAX,GNode^.IC1);
       end;
end
else
if place = _Second  then
begin
       ta2:=GNode^.TA2;

       if (ta2 = _IntForm)  then  //IntForm->IntVar
       begin
          LineFormN(GNode^.AIVP2,GNode^.IC2);
       end
       else
       if (ta2 = _IntVar)  then    //IntVar->IntVar
       begin
          MOVMREG(R_EAX,Alg.Obj[GNode^.NV2].Addr);
       end
       else
       if (ta2 = _IntConst)  then      //IntConst->IntVar
       begin
          MOVCREG(R_EAX,GNode^.IC2);
       end;
end;

end;





function  TForevalH.SaveSimpleLineForm: Boolean;
var
N,N1,NF,tf,tv,ts,sh,TM,TMA,tva,ta1,code2,ArgForm1,ArgForm2,S: Integer;
AdrM,AdrA,Num,AddrA1,AddrA2,AddrObj,AddrI,AddrI1,AddrI2: Cardinal;
IM1,IM2: Integer;
Answ: Boolean;
begin
Answ:=False;

  {.357}    //оптимизация для случаев:
          //IntVar1=IntVar1 +- IntConst
          //IntVar1=IntVar1 +- IntVar2

          {иначе, общий вариант: LineFormN(GNode^.AIVP1,GNode^.IC1);}
 N:=GNode^.NObj;
{ N1:=GNode^.NFunc;
 NF:=GNode^.NF;
 tf:=Alg.ExFunc[N1].Func[NF].TV[0];
 tv:=Alg.Obj[N].TypeF;
 tm:=Alg.Obj[N].MType;
 TS:=GNode^.TS;
 if Alg.Obj[N].MType = _Double then sh:=sh_D else   if Alg.Obj[N].MType = _Extended  then sh:=sh_E;
 S:=GNode^.S; }


          if (Length(GNode^.AIVP1) = 1)  then      //IntVar1=IntVar1 +- IntConst
          begin

            if Length(GNode^.AIVP1[0].NV) = 1  then   //  IntVar1=IntVar1 (IntVar1 <> IntVar1*IntVar2*IntVar3*...)
            begin

               GetVar1(GNode^.AIVP1[0].NV[0],AddrI,tva,TMA);

               if (AddrI = Alg.Obj[N].Addr){ and (GNode^.AIVP1[0].A = 1) and  (GNode^.IC1 <> 0)}then      //IntVar1=A*IntVar1; A=1; IntConst <> 0
               begin

                  if GNode^.AIVP1[0].A = 1 then           //IntVar1=IntVar1+-IntConst;
                  begin
                       //IntVar1=IntVar1 + IntConst
                      if (GNode^.IC1 > 0) then
                      begin
                        if GNode^.IC1 = 1 then  //inc(IntVar1)
                        begin
                           INCMEM(AddrI);
                        end
                        else
                        begin
                           AddWord($81,$05);
                           AddAddress(AddrI);
                           AddNum(GNode^.IC1);
                        end;
                        Answ:=True;
                      end
                      else
                       //IntVar1=IntVar1 - IntConst
                      if (GNode^.IC1 < 0) then
                      begin
                        if GNode^.IC1 = -1 then  //dec(IntVar1)
                        begin
                           DECMEM(AddrI);
                        end
                        else
                        begin
                           AddWord($81,$2D);
                           AddAddress(AddrI);
                           AddNum(-GNode^.IC1);
                        end;
                        Answ:=True;
                      end
                      else
                      Answ:=True; {IntVar1=IntVar1}  //without generated command
                  end
                  else   //IntVar1=A*IntVar1+-IntConst; A <> 1
                  begin

                     if (GNode^.AIVP1[0].A = -1)  then    //IntVar1=IntConst-IntVar1 ;
                     begin
                        if  (GNode^.IC1 = 0) then     //IntVar1=-IntVar1 ;
                        begin
                           NEGMEM(AddrI);
                           Answ:=True;
                        end
                        else                     //IntVar1=IntConst-IntVar1 ;
                        begin

                           (*
                            NEGMEM(AddrI);
                            if  (GNode^.IC1 = 1) then  INCMEM(AddrI)
                              else
                            if  (GNode^.IC1 = -1) then DECMEM(AddrI)
                              else                     ADDMEMCONST(AddrI,GNode^.IC1);


                            Answ:=True;
                            *)

                        end;

                     end;

                  end;

               end

            end;
          end
          else
          if (Length(GNode^.AIVP1) = 2) and (GNode^.IC1 = 0) then      //IntVar1=A1*IntVar1 +- A2*IntVar2  ; IntConst = 0
          begin

             if (Length(GNode^.AIVP1[0].NV) = 1) and (Length(GNode^.AIVP1[1].NV) = 1)   then
             //  IntVar1=IntVar1 +- IntVar2 (IntVar1 <> A1*IntVar1*IntVar2*IntVar3*... +- A2*IntVar1*IntVar2*IntVar3*...)
             begin


                IM1:= GNode^.AIVP1[0].A; IM2:=GNode^.AIVP1[1].A;
                GetVar1(GNode^.AIVP1[0].NV[0],AddrI1,tva,TMA);
                GetVar1(GNode^.AIVP1[1].NV[0],AddrI2,tva,TMA);

                if (Alg.Obj[N].Addr = AddrI1) and (IM1 = 1) then    //  IntVar1=A1*IntVar1 +- A2*IntVar2   ; A1 = 1
                begin

                   if IM2 = 1 then      // IntVar1=IntVar1 + IntVar2
                   begin
                     //MOVMREG(R_EAX,AddrI2);
                     MOV_MEM_EAX(AddrI2);
                     AddWord($01,$05);
                     AddAddress(AddrI1);
                     Answ:=True;
                   end
                   else
                   if IM2 = -1 then      // IntVar1=IntVar1 - IntVar2
                   begin
                     //MOVMREG(R_EAX,AddrI2);
                     MOV_MEM_EAX(AddrI2);
                     AddWord($29,$05);
                     AddAddress(AddrI1);
                     Answ:=True;
                   end
                   else       // IntVar1=IntVar1 +- A2*IntVar2
                   begin

                       MOV_MEM_EAX(AddrI2);
                       IMULCREG(R_EAX,abs(IM2));
                       if IM2 > 0 then     // IntVar1=IntVar1 + A2*IntVar2
                       begin
                          AddWord($01,$05);
                          AddAddress(AddrI1);
                          Answ:=True;
                       end
                       else                // IntVar1=IntVar1 - A2*IntVar2
                       begin
                          AddWord($29,$05);
                          AddAddress(AddrI1);
                       end;

                       Answ:=True;

                   end;


                end
                else
                if (Alg.Obj[N].Addr = AddrI2) and (IM2 = 1) then     //  IntVar1=A2*IntVar2 + A1*IntVar1   ; A1 = 1
                begin
                   if IM1 = 1 then      // IntVar1=IntVar2 + IntVar1
                   begin
                     //MOVMREG(R_EAX,AddrI1);
                     MOV_MEM_EAX(AddrI1);
                     AddWord($01,$05);
                     AddAddress(AddrI2);
                     Answ:=True;
                   end
                   else
                   if IM1 = -1 then      // IntVar1=-IntVar2 + IntVar1
                   begin
                      //MOVMREG(R_EAX,AddrI1);
                      MOV_MEM_EAX(AddrI1);
                      AddWord($29,$05);
                      AddAddress(AddrI2);
                      Answ:=True;
                   end
                   else           //  IntVar1=A2*IntVar2 + IntVar1
                   begin

                       MOV_MEM_EAX(AddrI1);
                       IMULCREG(R_EAX,abs(IM1));
                       if IM1 > 0 then     //  IntVar1=A2*IntVar2 + IntVar1
                       begin
                          AddWord($01,$05);
                          AddAddress(AddrI2);
                          Answ:=True;
                       end
                       else                //  IntVar1=-A2*IntVar2 + IntVar1
                       begin
                          AddWord($29,$05);
                          AddAddress(AddrI2);
                       end;

                       Answ:=True;

                   end;
                end
             end;

          end;


 SaveSimpleLineForm:=Answ;
end;




(*
procedure TForevalH.AIVP1(AIVP:TArrayIntVarProd; IC: Integer);    //use: EAX,EBX,ECX,EDX
label nxt1;
var
LT,L,LA,i: Integer;
ICF,IC: Integer;
ra,LF1: Boolean;
begin
ICF:=Trunc(GNode^.FD);
L:=Length(GNode^.AIVP1);
ra:=false;
LF1:=True;

//Is No LineForm1:
{
for i := 0 to L-1 do
begin
  if Length(GNode^.AIVP1[i].NV) > 1 then
  begin
   LF1:=False; goto nxt1;
  end;
end;
}

//LF1:=True: LineForm(1 order)   a1*i1+a2*i2+...+an*in+ICF;
//LineForm1;

nxt1:
LineFormN;
{if ICF <> 0 then
begin
  MOVCREG(R_EAX,ICF);
  ra:=true;
end;}



end;

*)



procedure TForevalH.MOVCREG(Reg,N: Integer); //Const(32)->Reg
begin
 if Reg = R_EAX then   MOVAnum(N) else
 if Reg = R_EBX then   MOVBnum(N) else
 if Reg = R_ECX then   MOVCnum(N) else
 if Reg = R_EDX then   MOVDnum(N);

 SetReg(Reg);
end;


procedure TForevalH.MOVMREG(Reg: Integer; MEM: TAddress); //MEM(32)->Reg
begin
 if Reg = R_EAX then   MOVMA(MEM) else
 if Reg = R_EBX then   MOVMB(MEM) else
 if Reg = R_ECX then   MOVMC(MEM) else
 if Reg = R_EDX then   MOVMD(MEM);

 SetReg(Reg);
end;




procedure TForevalH.MOVREGM(Reg: Integer; MEM: TAddress); //Reg->MEM
begin
 if Reg = R_EAX then   begin AddWord($89,$05); AddAddress(MEM); end else
 if Reg = R_EBX then   begin AddWord($89,$1D); AddAddress(MEM); end else
 if Reg = R_ECX then   begin AddWord($89,$0D); AddAddress(MEM); end else
 if Reg = R_EDX then   begin AddWord($89,$15); AddAddress(MEM); end ;//else

 SetReg(Reg);
end;



procedure TForevalH.NEGREG(Reg: Integer); //-Reg
begin
 if Reg = R_EAX then   AddWord($F7,$D8) else
 if Reg = R_EBX then   AddWord($F7,$DB) else
 if Reg = R_ECX then   AddWord($F7,$D9) else
 if Reg = R_EDX then   AddWord($F7,$DA);// else

 SetReg(Reg);
end;




procedure TForevalH.NEGMEM(MEM: Integer); //MEM=-MEM
begin
  AddWord($F7,$1D);
  AddAddress(MEM);
end;


procedure TForevalH.ADDREG(Reg1,Reg2: Integer); //Reg1=Reg1+Reg2
begin
 if (Reg1 = R_EAX) and (Reg2 = R_EAX) then   AddWord($01,$C1) else
 if (Reg1 = R_EAX) and (Reg2 = R_EBX) then   AddWord($01,$D8) else
 if (Reg1 = R_EAX) and (Reg2 = R_ECX) then   AddWord($01,$C8) else
 if (Reg1 = R_EBX) and (Reg2 = R_EBX) then   AddWord($01,$DB) else
 if (Reg1 = R_EBX) and (Reg2 = R_ECX) then   AddWord($01,$CB) else
 if (Reg1 = R_ECX) and (Reg2 = R_ECX) then   AddWord($01,$C9) else
 if (Reg1 = R_ECX) and (Reg2 = R_EDX) then   AddWord($01,$D1) else
 if (Reg1 = R_EDX) and (Reg2 = R_EDX) then   AddWord($01,$D3);// else

 SetReg(Reg1);
 SetReg(Reg2);
end;


procedure TForevalH.ADDMREG(Reg: Integer; MEM: TAddress); //Reg=Reg+[MEM(32)]
begin
 if Reg = R_EAX then    begin AddWord($03,$05); AddAddress(MEM); end  else
 if Reg = R_EBX then    begin AddWord($03,$1D); AddAddress(MEM); end else
 if Reg = R_ECX then    begin AddWord($03,$0D); AddAddress(MEM); end else
 if Reg = R_EDX then    begin AddWord($03,$15); AddAddress(MEM); end;// else

 SetReg(Reg);
end;



procedure TForevalH.SUBMREG(Reg: Integer; MEM: TAddress); //Reg=Reg-[MEM(32)]
begin
 if Reg = R_EAX then    begin AddWord($2B,$05); AddAddress(MEM); end else
 if Reg = R_EBX then    begin AddWord($2B,$1D); AddAddress(MEM); end else
 if Reg = R_ECX then    begin AddWord($2B,$0D); AddAddress(MEM); end else
 if Reg = R_EDX then    begin AddWord($2B,$15); AddAddress(MEM); end;// else

 SetReg(Reg);
end;



procedure TForevalH.SUBREG(Reg1,Reg2: Integer); //Reg1=Reg1-Reg2
begin
 if (Reg1 = R_EAX) and (Reg2 = R_EAX) then   AddWord($29,$C1) else
 if (Reg1 = R_EAX) and (Reg2 = R_EBX) then   AddWord($29,$D8) else
 if (Reg1 = R_EAX) and (Reg2 = R_ECX) then   AddWord($29,$C8) else
 if (Reg1 = R_EBX) and (Reg2 = R_EBX) then   AddWord($29,$DB) else
 if (Reg1 = R_EBX) and (Reg2 = R_ECX) then   AddWord($29,$CB) else
 if (Reg1 = R_ECX) and (Reg2 = R_ECX) then   AddWord($29,$C9) else
 if (Reg1 = R_ECX) and (Reg2 = R_EDX) then   AddWord($29,$D1) else
 if (Reg1 = R_EDX) and (Reg2 = R_EDX) then   AddWord($29,$D3);// else

 SetReg(Reg1);
 SetReg(Reg2);
end;



procedure TForevalH.MOVREG(Reg1,Reg2: Integer); //Reg1=>Reg2
begin
 if (Reg1 = R_EAX) and (Reg2 = R_ECX) then   AddWord($89,$C1) else
 if (Reg1 = R_EAX) and (Reg2 = R_EBX) then   AddWord($89,$C3) else
 if (Reg1 = R_EAX) and (Reg2 = R_EDX) then   AddWord($89,$C2) else
 if (Reg1 = R_EBX) and (Reg2 = R_ECX) then   AddWord($89,$D9) else
 if (Reg1 = R_ECX) and (Reg2 = R_EDX) then   AddWord($89,$CA);//else

 SetReg(Reg1);
 SetReg(Reg2);
end;



procedure TForevalH.ADDMEMCONST(MEM: TAddress; IC: Integer); //MEM=MEM+IC
begin
   AddWord($81,$05);
   AddAddress(MEM);
   AddNum(IC);
end;


procedure TForevalH.IMULCREG(Reg: Integer; C: Integer); //Reg=Reg*C(32)
begin

if C = -1 then NEGREG(Reg)
else

if C <> 1 then
begin

 //if (C > 1) and (C <= 10) then IMULREG_CONST(Reg,C) else
 if IMULREG_CONST(Reg,C) = False then
 begin


 if Reg = R_EAX then
 begin
   begin
     AddWord($69,$C0);  AddNum(C);
   end;
 end
 else
 if Reg = R_EBX then
 begin

   begin
     AddWord($69,$DB);  AddNum(C);
   end;
 end
 else
 if Reg = R_ECX then
 begin

   begin
     AddWord($69,$C9);  AddNum(C);
   end;
 end
 else
 if Reg = R_EDX then
 begin

   begin
     AddWord($69,$D2);  AddNum(C);
   end;
 end;



 end;


end;

SetReg(Reg);

end;



function TForevalH.IMULREG_CONST(Reg,C: Integer): Boolean;

  {.357}
  procedure _NegReg;
  begin
   if C < 0  then NEGREG(Reg);
  end ;

var
 Answ,BNeg: Boolean;

begin
 Answ:=False;

 case abs(C)  of
  2:  begin IMULCREG2(Reg); _NegReg; Answ:=True; end;
  3:  begin IMULCREG3(Reg); _NegReg; Answ:=True; end;
  4:  begin IMULCREG4(Reg); _NegReg; Answ:=True; end;
  5:  begin IMULCREG5(Reg); _NegReg; Answ:=True; end;
  6:  begin IMULCREG6(Reg); _NegReg; Answ:=True; end;
  //7:  begin IMULCREG7(Reg); _NegReg; Answ:=True; end;
  8:  begin IMULCREG8(Reg); _NegReg; Answ:=True; end;
  9:  begin IMULCREG9(Reg); _NegReg; Answ:=True; end;
  10: begin IMULCREG10(Reg);_NegReg; Answ:=True; end;
 end;

 IMULREG_CONST:=Answ;
end;




procedure TForevalH.IMULMREG(Reg: Integer; MEM: TAddress); //Reg=Reg*MEM(32)
begin

 if Reg = R_EAX then
 begin
     AddWord($0F,$AF); AddByte($05);  AddAddress(MEM);
 end
 else
 if Reg = R_EBX then
 begin
     AddWord($0F,$AF); AddByte($1D);  AddAddress(MEM);
 end
 else
 if Reg = R_ECX then
 begin
     AddWord($0F,$AF); AddByte($0D);  AddAddress(MEM);
 end
 else
 if Reg = R_EDX then
 begin
     AddWord($0F,$AF); AddByte($15);  AddAddress(MEM);
 end;


 SetReg(Reg);
end;





procedure TForevalH.IMULCREG2(Reg: Integer); //Reg=2*Reg
begin
 SHLREG(Reg,1);
 SetReg(Reg);
end;



procedure TForevalH.IMULCREG3(Reg: Integer); //Reg=3*Reg
begin
  LEAREG(Reg,2);
  SetReg(Reg);
end;


procedure TForevalH.IMULCREG4(Reg: Integer); //Reg=4*Reg
begin
  SHLREG(Reg,2);
  SetReg(Reg);
end;


procedure TForevalH.IMULCREG5(Reg: Integer); //Reg=5*Reg
begin
  LEAREG(Reg,4);
  SetReg(Reg);
end;





procedure TForevalH.IMULCREG6(Reg: Integer); //Reg=6*Reg
begin
  LEAREG(Reg,2);
  SHLREG(Reg,1);
  SetReg(Reg);
end;



procedure TForevalH.IMULCREG7(Reg: Integer); //Reg=7*Reg
begin
  MOVREG(Reg,Reg+1);
  SHLREG(Reg,3);
  SUBREG(Reg,Reg+1);

  SetReg(Reg);
  SetReg(Reg+1);
end;


procedure TForevalH.IMULCREG8(Reg: Integer); //Reg=8*Reg
begin
  SHLREG(Reg,3);
  SetReg(Reg);
end;



procedure TForevalH.IMULCREG9(Reg: Integer); //Reg=9*Reg
begin
  LEAREG(Reg,8);
  SetReg(Reg);
end;



procedure TForevalH.IMULCREG10(Reg: Integer); //Reg=10*Reg
begin
  LEAREG(Reg,4);
  SHLREG(Reg,1);
  SetReg(Reg);
end;


procedure TForevalH.SHLREG(Reg,Sh: Integer); //shl reg,Sh
begin
  if Sh = 1 then
  begin
       if Reg = R_EAX then AddWord($D1,$E0) else
       if Reg = R_EBX then AddWord($D1,$E3) else
       if Reg = R_ECX then AddWord($D1,$E1) else
       if Reg = R_EDX then AddWord($D1,$E2);

  end
  else
   if Sh = 2 then
  begin
       if Reg = R_EAX then begin AddWord($C1,$E0); AddByte($02); end else
       if Reg = R_EBX then begin AddWord($C1,$E3); AddByte($02); end else
       if Reg = R_ECX then begin AddWord($C1,$E1); AddByte($02); end else
       if Reg = R_EDX then begin AddWord($C1,$E2); AddByte($02); end
  end
  else
   if Sh = 3 then
  begin
       if Reg = R_EAX then begin AddWord($C1,$E0); AddByte($03); end else
       if Reg = R_EBX then begin AddWord($C1,$E3); AddByte($03); end else
       if Reg = R_ECX then begin AddWord($C1,$E1); AddByte($03); end else
       if Reg = R_EDX then begin AddWord($C1,$E2); AddByte($03); end
  end
  else
   if Sh = 4 then
  begin

  end;

  SetReg(Reg);
end;



procedure TForevalH.LEAREG(Reg,Sh: Integer); // lea reg,[reg+reg*sh]
begin
  if Sh = 2 then
  begin
       if Reg = R_EAX then begin AddWord($8D,$04); AddByte($40); end else
       if Reg = R_EBX then begin AddWord($8D,$1C); AddByte($5B); end else
       if Reg = R_ECX then begin AddWord($8D,$0C); AddByte($49); end else
       if Reg = R_EDX then begin AddWord($8D,$14); AddByte($52); end

  end
  else
  if Sh = 4 then
  begin
       if Reg = R_EAX then begin AddWord($8D,$04); AddByte($80); end else
       if Reg = R_EBX then begin AddWord($8D,$1C); AddByte($9B); end else
       if Reg = R_ECX then begin AddWord($8D,$0C); AddByte($89); end else
       if Reg = R_EDX then begin AddWord($8D,$14); AddByte($92); end
  end
  else
  if Sh = 8 then
  begin
       if Reg = R_EAX then begin AddWord($8D,$04); AddByte($C0); end else
       if Reg = R_EBX then begin AddWord($8D,$1C); AddByte($DB); end else
       if Reg = R_ECX then begin AddWord($8D,$0C); AddByte($C9); end else
       if Reg = R_EDX then begin AddWord($8D,$14); AddByte($D2); end
  end;

end;


procedure TForevalH.PUSHR(Reg: Integer);
begin

       if Reg = R_EAX then begin AddByte($50); end else
       if Reg = R_EBX then begin AddByte($53); end else
       if Reg = R_ECX then begin AddByte($51); end else
       if Reg = R_EDX then begin AddByte($52); end;

       SetReg(Reg);
end;


procedure TForevalH.POPR(Reg: Integer);
begin

       if Reg = R_EAX then begin AddByte($58); end else
       if Reg = R_EBX then begin AddByte($5b); end else
       if Reg = R_ECX then begin AddByte($59); end else
       if Reg = R_EDX then begin AddByte($5a); end  ;
      SetReg(Reg);
end;


procedure TForevalH.CMPR(Reg1,Reg2: Integer);
begin
  if (Reg1 = R_EAX) and (Reg2 = R_EBX) then begin AddWord($39,$D8); end else
  if (Reg1 = R_EBX) and (Reg2 = R_EAX) then begin AddWord($39,$C3); end else
  if (Reg1 = R_EAX) and (Reg2 = R_ESP) then begin AddWord($39,$E0); end else
  if (Reg1 = R_ESP) and (Reg2 = R_EAX) then begin AddWord($39,$C4); end else
  if (Reg1 = R_EAX) and (Reg2 = R_ECX) then begin AddWord($39,$C8); end else
  if (Reg1 = R_ECX) and (Reg2 = R_EAX) then begin AddWord($39,$C1); end;// else

  SetReg(Reg1); SetReg(Reg2);
end;


procedure TForevalH.CMPRM(Arg1,Arg2: Integer; Addr: TAddress);
begin
  if (Arg1 = R_EAX) and (Arg2 = R_MEM) then begin AddWord($3B,$05); AddAddress(Addr); SetReg(Arg1); end else
  if (Arg1 = R_MEM) and (Arg2 = R_EAX) then begin AddWord($39,$05); AddAddress(Addr); SetReg(Arg2); end else
  if (Arg1 = R_EBX) and (Arg2 = R_MEM) then begin AddWord($3B,$1D); AddAddress(Addr); SetReg(Arg1); end else
  if (Arg1 = R_MEM) and (Arg2 = R_EBX) then begin AddWord($39,$1D); AddAddress(Addr); SetReg(Arg2); end //else
end;


procedure TForevalH.InitConstDb;
begin
 Db_XchBrSDeep:=0;
 Db_XchBrNXch:=0;
 Db_DinLoadSDeep:=0;
 Db_DinLoadNMem:=0;
 Db_DinLoadOverFlow:=False;
 Db_CmplMaxStack:=0;
 Db_ReplFuncNum:=0;
 Db_ReplOpNum:=0;
 Db_LoadStackAfterCalc:=0;
 Db_CalcConstFunc:=0;
 Db_CalcConstArg:=0;
 Db_CalcConstMulDiv:=0;
 Db_WriteDataOverFlow:=False;
 Db_WriteStackDataOverFlow:=False;
end;



procedure TForevalH.InitUsedVar;     {.333}
var
i: integer;
begin
  for i:=0 to High(Alg.Obj) do
  begin
      Alg.Obj[i].IsUsed:=_NO;
  end;
end;



procedure TForevalH.DebugDL;
begin
{
sin(z1)/cos(x)
sin(x)/cos(z1)
sin(z1)/cos(z2)

sin(z1)*cos(x)
sin(x)*cos(z1)
sin(z1)*cos(z2)

sin(z1)+cos(x)
sin(x)+cos(z1)
sin(z1)+cos(z2)

sin(z1)-cos(x)
sin(x)-cos(z1)
sin(z1)-cos(z2)

sin(z1)^cos(x)
sin(x)^cos(z1)
sin(z1)^cos(z2)
}

{                     //sin() -> fpu; cos() -> mem
Interp[4].SData:=_MEM;
SetLength(Interp[5].RData,2);  Interp[5].RData[0]:=_FPU; Interp[5].RData[1]:=_MEM;
}

{                      //sin()->mem; cos()->fpu
Interp[2].SData:=_MEM;
SetLength(Interp[5].RData,2);  Interp[5].RData[0]:=_MEM; Interp[5].RData[1]:=_FPU;
}

                     //sin()->mem; cos()->mem
{
Interp[2].SData:=_MEM;   Interp[4].SData:=_MEM;
SetLength(Interp[5].RData,2);  Interp[5].RData[0]:=_MEM; Interp[5].RData[1]:=_MEM;
}

//*******************************************************************************

{
sin(z1)/z2
sin(z1)*z2
sin(z1)+z2
sin(z1)-z2
z2+sin(z1)
z2-sin(z1)
z2*sin(z1)
z2/sin(z1)
}
{
sin(z1)/x
sin(z1)*x
sin(z1)+x
sin(z1)-x
x+sin(z1)
x-sin(z1)
x*sin(z1)
x/sin(z1)
}
{
sin(z1)/k
sin(z1)*k
sin(z1)+k
sin(z1)-k
k+sin(z1)
k-sin(z1)
k*sin(z1)
k/sin(z1)
}
{

sin(x)/y
sin(x)*y
sin(x)+y
sin(x)-y
y+sin(x)
y-sin(x)
y*sin(x)
y/sin(x)
}
{
sin(x)/x
sin(x)*x
sin(x)+x
sin(x)-x
x+sin(x)
x-sin(x)
x*sin(x)
x/sin(x)
}
{
sin(x)/k
sin(x)*k
sin(x)+k
sin(x)-k
k+sin(x)
k-sin(x)
k*sin(x)
k/sin(x)
}

                     //sin()->mem;
{
Interp[2].SData:=_MEM;
SetLength(Interp[3].RData,1);  Interp[3].RData[0]:=_MEM; //Interp[3].RData[1]:=_MEM;
}
//*******************************************************************************




end;



end.
