unit Foreval_Compilator;


{******************************************************************************}
{                                                                              }
{                          ver. 8.4.17.249                                     }
{------------------------------------------------------------------------------}
{                               }
{                 (Interp[]  Foreval_Main)                                   }        
{------------------------------------------------------------------------------}
{      The compiler and the emulator of the interpreted expression             }
{                       (Interp[] from Foreval_Main)                           }
{------------------------------------------------------------------------------}
{                       min: Pentium Pro(FCOMIP,FCMOV)                         }   
{------------------------------------------------------------------------------}
{           SOREL (C)CopyRight 2000. Russia, S.-Petersburg.                    }
{******************************************************************************}

//{$RangeChecks On}
//{$OverFlowChecks On}
//{$ZEROBASEDSTRINGS Off}

{$R-}
{$Q-}

{$IFDEF FPC}
  {$MODE DELPHI}
{$ENDIF}


{.$DEFINE DEBUGS}

//  - (   ):
//FType =
//       -3 - EAX              
//       -4 - EBX              
//       -5 - ECX              
//       -6 - EDX              
//       -7 - ESP              
//       -8 - FPU               ( FPU max:8)
//       -10 - Stack (CPU)     
//       -11 - Infinite         - EAX;  - EBX
//       -12 - Infinite         - EBX;  - ECX
//       -13 - Infinite         - ECX;  - EDX
//       -14 - Infinite       Stack (CPU);  , ; (Addr,Length: Cardinal)
//       -15 - Stack (CPU)     
//       -16 - Compiled        
//       -17 - :      ,       FindFunction
                        {IF,IFNOP  (  :    )
                        IF(Arg1 op Arg2, Arg3, Arg4)  => if Arg1 op Arg2 then Arg3 else Arg4  op: =, <, >, <=, =<, >=, =>
                        IF      IFNOP(Arg1,Arg2,CJMP,Arg3,JMP,ARG4)
                        IF(Arg1 op Arg2, Arg3)  =>  IFNOP(Arg1,Arg2,CJMP,Arg3,JMP,FLDZ)
                        IF(Arg1 op Arg2)        =>  IFNOP(Arg1,Arg2,CJMP,FLD1,JMP,FLDZ)}
//      -18 - :      ,       FindFunction
                             {    : SUM, SUMQ, AVR, NORM, LEN, NORM, MIN, MAX, PROD:
                                 FType = 1: func(Array); FType = -14: func(data1,data2,...)}

interface

uses
{Math, }SysUtils, Foreval_Main, {Command,} Foreval_Command, Windows
{$IFDEF DEBUGS}
,TestG8
{$ENDIF}
;

const
CWFPU: WORD = $1372;

C05: double = 0.5;
C1: double = 1;

E_CPId2: extended = 3.141592653589793238462643/2; //1.57079632679489662;{_Pi/2;}

D_CPId2: double = 3.141592653589793238462643/2; //1.57079632679489662;{_Pi/2;}

D_Zero: double = 0;

const SizeS = 16;

const _Single = 1;
const _Double = 2;
const _Extended = 3;
const _Integer = 4;
const _Differ =  5;
const _None = 0;
const _Float = 6;
const _Load = 7;
const _AddSub = 8;
const _MulDiv = 9;
const _Address = 10;

type
TArrayC = array of Cardinal;


type
  TCompiler = class

 private
  E_Overflow: Boolean;
  Db_OverFlow: Boolean;
  F_SaveStack: Boolean;
  F_EnableCheckStack: Boolean;
  F_VirtAlloc: Boolean; {.199}
  F_Attrib: TAttrib;
  N_Stack: Integer;     //   (   -)
  N1_Stack: Integer;    //     -
  StackSize: Integer;   //    (<= 8)
  _MaxStack: Integer;   //      
   F_CorrectIPWR: Integer;
  F_ParamType, F_DataType: Integer; //     (_Double/_Extended/_Single)
  SMAX: Integer;        //      -
  F_CloseArg: Boolean;
  Func: TFunction;
  Interp: TArrayOfTFunc;
  Factorial: TArrayF;
  FuncData,BFuncData: PFuncData;

  FuncList: TArrayFuncList;
  VarList: TVarList;
  LFunc: Integer;
  F_Mode: Integer;   //  : C_Compile, (:)C_EmlXchBranch, C_EmlDinamicLoad;
  REG:  array [1..8] of Integer;
  REGA: array [1..8] of Integer;
  ICOMP: TCode;   //TBCode;
  AL_ICOMP: TCode;
  CNI: Cardinal; //   
  F_SData: Integer;
  F_JMP: Integer;
  F_RetNum: Integer;
  F_SaveNum: Boolean;     //  
  F_EnableSave: Boolean;


  //procedure IntToHex(N: TAddress; var AH: TArray4);
  procedure AddAddress(Adr: TAddress);
  procedure AddInteger(Int: Integer);
  procedure AddCommand(I: Integer);
  procedure AddEndCommand(I: Integer);
  procedure AddByte(B: Byte);
  procedure AddWord(B1: Byte; B2: Byte);

  procedure AddCom(B1: Byte);                           overload;
  procedure AddCom(B1,B2: Byte);                        overload;
  procedure AddCom(B1,B2,B3: Byte);                     overload;
  procedure AddCom(B1: Byte; Adr: TAddress);            overload;
  procedure AddCom(B1,B2: Byte; Adr: TAddress);         overload;
  procedure AddCom(B1,B2,B3: Byte; Adr: TAddress);      overload;
  procedure AddCom(B1,B2,B3: Byte; N: Integer);         overload;
  procedure AddCom(B1: Byte; N: Integer);               overload;
  procedure AddCom(B1,B2: Byte; N: Integer);            overload;

  procedure FLD(N: TAddress; VType: Integer);     overload;
  procedure FSTPM(N: TAddress; VType: Integer);
  procedure FAVB(I: Integer);
  procedure FAVBM(I,k: Integer);
  procedure FAVBM1(I: Integer);
  function  FAVB1(I: Integer): Boolean;
  procedure FAVBF(I: Integer);
  procedure FAVBF1(I: Integer);
  procedure ASB(I: Integer);
  procedure FMUL(X: TFloatType; N: TAddress; VType: Integer); overload;
  procedure FADD(X: TfloatType; N: TAddress; VType: Integer); overload;
  procedure FADD(N: TAddress; VType: Integer); overload;
  procedure FMUL(N: TAddress; VType: Integer); overload;
  procedure FADD; overload;
  procedure FADD2;
  procedure FSUB;     overload;
  procedure FSUBRP;
  procedure FSUBP;
  procedure FSUBR(N: TAddress; VType: Integer);
  procedure FSUB(N: TAddress; VType: Integer); overload;
  procedure FMULP1; overload;
  procedure MAF(I: Integer);
  procedure AAF(I:Integer);
  procedure AAI(I: Integer);
  procedure AAI1(I: Integer);
  procedure AFI(I: Integer);
  procedure FIDIV(N: TAddress);
  procedure FDIVR1;
  procedure FDIVP;   overload;
  procedure FDIVRP;  overload;
  procedure FDIV(N:TAddress; VType: Integer);  overload;
  procedure FDIVR(N:TAddress; VType: Integer); overload;
  procedure FDIV2;
  procedure FDIVR2;
  procedure FMULP02;
  procedure FMUL01;
  procedure FSUBP02;
  procedure FSUBP01;
  procedure FILD(N: TAddress);
  procedure FIMUL(N: TAddress);
  procedure FIADD(N: TAddress);
  procedure IAVB(I: Integer);
  procedure INC_C(N: TAddress);
  procedure DEC_C(N: TAddress);
  procedure IAVBF(I: Integer);
  procedure IAVBF1(I: Integer);
  procedure IAVBF2(I: Integer);
  procedure AIFB(I: Integer);
  procedure AIFB1(I: Integer);
  procedure MOVB(N: TAddress);
  procedure MOVAM(N: TAddress);
  procedure MOVMA(N: TAddress);
  procedure MOVAX(N: TAddress);
  procedure MOVCM(N: TAddress);
  procedure MOVCA;
  procedure MOVAB;
  procedure MOVBA;
  procedure MOVD1(N: TAddress);
  procedure MOVMB(N: TAddress);
  procedure MOVMC(N: TAddress);
  procedure SUBAB;
  procedure SUBA(N: TAddress);
  procedure FSTPESP(VType: Integer);                overload;
  procedure FSTPESP(VType: Integer; N: Integer);    overload;
  procedure NEGA;
  procedure NEGB;
  procedure IMULA(X: Integer; N: TAddress);
  procedure IMULB(X: Integer;N: TAddress);
  procedure IMULBA_B(B: Byte);
  procedure IMULDA_B(B: Byte);
  procedure IMULBA;
  procedure IMULBB;
  procedure IMULAA;
  procedure IMULAB;
  procedure LEA_CC8A;
  procedure LEA_CD8A;
  procedure LEA_AC2A;
  procedure ADDA(X: Integer; N: TAddress);  overload;
  procedure ADDB(X: Integer; N: TAddress);  overload;
  procedure ADDA(N: TAddress);    overload;
  procedure ADDCB;
  procedure ADDCD;
  procedure ADDAB;
  procedure CMPAB;
  procedure ADDESP(N: Integer);
  procedure SUBESP(N: Integer);
  procedure PUSHAX;
  procedure PUSHA;
  procedure PUSHB;
  procedure PUSHC;
  procedure PUSHD;
  procedure XCHGAB;
  procedure PUSHESP;
  procedure POPESP;
  procedure PUSHEBP;
  procedure POPEBP;
  procedure PUSHESI;
  procedure POPESI;
  procedure PUSHEDI;
  procedure POPEDI;
  procedure PUSHM(N: Integer);
  procedure PUSHF(N: TAddress);
  procedure POPF(N: TAddress);
  procedure POPA;
  procedure POPB;
  procedure POPC;
  procedure POPD;
  procedure CALLA;
  procedure CALLB;
  procedure CALLC;
  procedure CALLD;
  procedure MOVB1(N: TAddress);
  procedure MOVA1(N: TAddress);
  procedure MOVC1(N: TAddress);
  procedure SUBA_B(B: Byte);
  procedure FCHS;
  procedure EndFuncCom(I: Integer);
  procedure InsertFunc1(I: Integer);
  procedure InsertFunc2(I: Integer);
  procedure InsertFunc3(I: Integer);
  procedure InsertFunc4(I: Integer);
  procedure FPWR; overload;
  procedure FXCH1;
  procedure CDQ;
  procedure IDIVB;
  procedure IDIV(N: TAddress);
  procedure MOVDM(N: TAddress);

  procedure FLDLN2;
  procedure FLDLG2;
  procedure FYL2X;
  procedure FLDCW(N: TAddress);
  procedure FISTP(N: TAddress);
  procedure FNCLEX; {.248}
  //procedure FSTP(VType: Integer; Adr: TAddress);
  procedure FSTPA(VType: Integer; Shift: Cardinal);
  procedure FSTPB(VType: Integer; Shift: Cardinal);
  procedure FSTPC(VType: Integer; Shift: Cardinal);
  procedure FSTPD(VType: Integer; Shift: Cardinal);
  procedure FSINCOS;
  procedure SQR;
  procedure IPWR3;
  procedure IPWR4;
  procedure IPWR5;
  procedure IPWR6;
  procedure IPWR7;
  procedure IPWR8;
  procedure IPWR9;
  procedure IPWR10;
  procedure IPWR11;
  procedure IPWR12;
  procedure IPWR13;
  procedure IPWR14;
  procedure IPWR15;
  procedure IPWR16;
  procedure IPWR_B;
  procedure FMUL0;
  procedure FMULZ;


  procedure FSCALE;
  procedure FSIN;
  procedure FCOS;
  procedure FPTAN;
  procedure FPATAN;
  procedure FLD1;
  procedure FLDZ;
  procedure FLD0;
  procedure FSTP0;
  procedure FSTP1;
  procedure FLDA_E;
  procedure FCOMPP;
  procedure FCOMIP;
  procedure FSTSW_AX;
  procedure SAHF;
  procedure JMPC(N: TAddress; VType: Integer);
  procedure FTAN;
  procedure FATAN;
  procedure SINH;
  procedure COTAN;
  procedure ARCSIN;
  procedure ARCCOS;
  procedure ARCCOTAN;
  procedure EXP;
  procedure LN;
  procedure LOG10;
  procedure LOG2;
  procedure COSH;
  procedure TANH;
  procedure COTANH;
  procedure ARCSINH;
  procedure ARCCOSH;
  procedure ARCTANH;
  procedure ARCCOTANH;
  procedure SIN;
  procedure COS;
  procedure FABS;
  procedure ADD(I: Integer);
  procedure MUL(I: Integer);
  procedure MUL_AFB(I,OP: Integer);
  procedure MUL_AAF(I: Integer);
  procedure MUL_MAF(I: Integer);

  procedure FUNC1(I: Integer);
  procedure FUNC2(I: Integer);
  procedure FUNC3(I: Integer);
  procedure FUNC4(I: Integer);
  procedure FUNC5(I: Integer);
  procedure FSTM(N: TAddress; VType: Integer);
  //procedure CopyStack(I: Integer);
  procedure FAB12(I: Integer);
  procedure FSQRT;
  function  GetStackAddr(N: Cardinal): TAddress;     {.241}



  //procedure FACTSTACK;
  procedure FRNDINT;
  procedure FTRUNC; overload;
  procedure TRUNCM(N: TAddress);
  procedure PUSHCW;{.248}
  procedure POPCW; {.248}
  procedure LOGN;              overload;
  //procedure ALS;
  procedure SetReg(R: Integer);
  procedure RET;
  procedure SaveReg;
  procedure SaveRes(Adr,RType,Shift: Cardinal);
  procedure SaveFuncReg(I: Integer);
  function  SizeArg(VType: Integer): Integer;
  procedure AddFuncMEM(I: Integer);
  procedure AddFuncCPU(I: Integer);
  procedure AddFuncFPU(I: Integer);
  procedure AddFuncINF(I: Integer);
  procedure AddFuncMEMADR(I: Integer);
  procedure PKGCMPL(I: Integer);
  procedure MOVREGESP(R: Integer; Sh: Byte);
  procedure POPREG(reg: Cardinal);
  procedure PUSHREG(reg: Cardinal);
  procedure LDSV(I: Integer);
  procedure LDSVA(I: Integer);
  procedure SAVEV(I: Integer);
  procedure SUMP(I: Integer);
  procedure SUMPS(I: Integer);
  procedure POLY_C(I: Integer);
  procedure POLYDIFF_C(I: Integer);
  procedure AddFuncPC(I: Integer);
  function  CheckIfRet(N: Integer): Boolean;
  function  GetLevelsCS(num: Integer): Cardinal;
  procedure FindNumberLevelA(num: Integer; var ANL: TArrayC);
  procedure JMP_C(N: Integer);
  procedure FLD_C(I: Integer);
  procedure LDA_C(I: Integer);
  procedure MOD_C(I: Integer);
  procedure TRY_C(I: Integer);     {.249}
  procedure EXCEPTION_C(I: Integer);   {.249}
  function  GetBeginCom(N: Cardinal): Cardinal;
  procedure COMPILE_C(I: Integer);

  function ReadReplFunc(i: integer): Boolean;
  procedure WriteReplFunc(i: integer);

  function  IgnoreCom(I: Integer): Boolean;

  procedure LoadArg1(I: Integer);
  procedure LoadArg2(I: Integer);
  procedure CheckStack(N: Integer);
  function  WriteData(Data: TFloatType; DataType: Integer; ComType: Integer): TAddress;
  procedure FreeData;
  function  IsLevelLoad(I: Integer): Boolean;
  function  IsLevelLoadA(I: Integer): Integer;

  procedure POPFPU;
  procedure PUSHFPU;



  procedure E_TreeToInterp(Tree: PNode);
  procedure E_SetNode(Tree: PNode);
  procedure E_SetNodeDL(I: Integer);



 public
  constructor Create(FL: TArrayFuncList);
  procedure Compile(PFunc: PFunction; EInterp: TArrayOfTFunc;  var NAdr: Cardinal);
   procedure SetRegA(R: Integer; SC: Integer);
  function  GetReg(R: Integer): Integer;
  function  GetVarType(Addr: TAddress): Integer;
  procedure Init(FL: TArrayFuncList; VList: TVarList; S,Param,Data: Integer; SaveStack,CloseArg: Boolean; Atr: TAttrib; VirtAlloc: Boolean);
  procedure E_Init( EInterp: TArrayOfTFunc; FL: TArrayFuncList; VList: TVarList; S,Param,Data,Mode: Integer);
  function  E_GetMaxLoadDL(I: Integer): Integer;
  function  E_GetFuncLoad(Tree: PNode): Integer;
  function  E_GetMaxStackEx: Integer;
  property  GetMaxStack: Integer read _MaxStack default 0;
  property  OverFlow: Boolean read Db_OverFlow default False;
  property  LoadStackAfterCalc: Integer read N_Stack default 0;
  property  RetNum: Integer read  F_RetNum;




end;


implementation
const
FCW1: Word = $1f32;
FCW2: Word = $1332;
FCW3: Word = $1232;
var
MEM,MEM1: Integer; //     
DMEM,DMEM1,DMEM2,DMEM3,DMEM4,DMEM5,DMEM6,DMEM7,DMEM8,DMEM9: double;
EMEM,EMEM1,EMEM2,EMEM3,EMEM4,EMEM5,EMEM6,EMEM7,EMEM8,EMEM9: extended;
SFPU: array [1..8] of Extended;
GotoLab: TArrayC;
G_Test1,G_Test2,G_Test3: Integer;
TE_ADDR: TAddress;


constructor TCompiler.Create(FL: TArrayFuncList);
begin
 FuncList:=FL;
 inherited Create;
end;




procedure TCompiler.Init(FL: TArrayFuncList;  VList: TVarList; S,Param,Data: Integer; SaveStack,CloseArg: Boolean; Atr: TAttrib; VirtAlloc: Boolean);
begin
FuncList:=FL;
VarList:=VList;
StackSize:=S;
F_Attrib:=Atr;
F_SaveStack:=SaveStack;
F_ParamType:=Param;
F_DataType:=Data;
F_Mode:=C_Compile;
F_CloseArg:=CloseArg;
F_EnableCheckStack:=True;
F_VirtAlloc:=VirtAlloc;
end;


procedure TCompiler.E_Init(EInterp: TArrayOfTFunc; FL: TArrayFuncList; VList: TVarList; S,Param,Data,Mode: Integer);
begin
N_Stack:=0;
SMAX:=0;
Interp:=EInterp;
FuncList:=FL;
VarList:=VList;
StackSize:=S;
F_ParamType:=Param;
F_DataType:=Data;
N_Stack:=0;
E_Overflow:=False;
F_SaveStack:=True;
_MaxStack:=0;
F_Mode:=Mode;
F_EnableCheckStack:=True;
F_RetNum:=_Yes; {.203}
F_EnableSave:=True; {.205}
LFunc:=Length(EInterp); {.239}
end;





procedure TCompiler.E_SetNode(Tree: PNode);
label 1,2;
var
i,j,k,N: Integer;
AH,AB: TArray4;
R: TFloatType;
P: Pointer;
X: TFloatType;
Sh,S: String;
Cm,alg: Cardinal;
Bt1: Byte;
AdrS,AdrD,AdrH,TAdr: Cardinal;
begin
//F_JMP:=1;
CNI:=0;
E_TreeToInterp(Tree);

SMAX:=N_Stack;
N1_Stack:=N_Stack;
AddCommand(0);
AddEndCommand(0);

//ICOMP:=nil;//???
end;




procedure TCompiler.E_SetNodeDL(I: Integer);
label 1,2;
var
j,k,N: Integer;
AH,AB: TArray4;
R: TFloatType;
P: Pointer;
X: TFloatType;
Sh,S: String;
Cm,alg: Cardinal;
Bt1: Byte;
AdrS,AdrD,AdrH,TAdr: Cardinal;
begin
F_JMP:=1;     {.239}
CNI:=I;

SMAX:=N_Stack;
N1_Stack:=N_Stack;
AddCommand(I);
AddEndCommand(I);

//???
//ICOMP:=nil;
end;



procedure TCompiler.E_TreeToInterp(Tree: PNode);
label endp;
var
fa,i,L,j: TIntegType;
S: String;
begin


Interp[0].Expression:=Copy(Tree^.Expression,1,Length(Tree^.Expression));
for i:=0 to High(VarList) do
begin
 if Tree^.FV1 = i then Interp[0].FV1:=VarList[i].Addr;
 if Tree^.FV2 = i then Interp[0].FV2:=VarList[i].Addr;
 if Tree^.IV1 = i then Interp[0].IV1:=VarList[i].Addr;
 if Tree^.IV2 = i then Interp[0].IV2:=VarList[i].Addr;
end;


Interp[0].S:=Tree^.Stack.S;
Interp[0].N:=Tree^.Stack.N;
Interp[0].RCS:=0;
Interp[0].ExtArg:=Tree^.ExtArg;
Interp[0].SExtArg:=Tree^.SExtArg;
Interp[0].PkAdr:=Tree^.PkAdr;
Interp[0].PkShift:=Tree^.PkShift;
Interp[0].PkRType:=Tree^.PkRType;
SetLength(Interp[0].AWCS,0);
SetLength(Interp[0].AFB,0);
SetLength(Interp[0].PN,0);
SetLength(Interp[0].PM,0);
SetLength(Interp[0].PI,0);
SetLength(Interp[0].PC,0);
SetLength(Interp[0].RData,0);



SetLength(Interp[0].SGN,Length(Tree^.SGN));
for i:=0 to High(Tree^.SGN) do
begin
 Interp[0].SGN[i]:=Tree^.SGN[i];
end;

Interp[0].EI:=Tree^.EI;
Interp[0].DI:=Tree^.DI;
Interp[0].AI:=Tree^.AI;
Interp[0].BI:=Tree^.BI;
Interp[0].CI:=Tree^.CI;
Interp[0].FI:=Tree^.FI;

Interp[0].F1:=Tree^.F1;
Interp[0].F2:=Tree^.F2;



Interp[0].V1:=Tree^.V1;
Interp[0].V2:=Tree^.V2;

Interp[0].V3:=Tree^.V3;
Interp[0].V4:=Tree^.V4;


Interp[0].VI1:=Tree^.VI1;
Interp[0].VI2:=Tree^.VI2;
Interp[0].VI3:=Tree^.VI3;
Interp[0].VI4:=Tree^.VI4;



Interp[0].I:=0;

//AAF:
if Tree^.DI = _AAF then
begin
fa:=0;
for i:=0 to High(VarList) do
begin

if Tree^.PN.FM[i] <> 0 then
begin
inc(fa);
end;
end;
  begin
   SetLength(Interp[0].PM,fa+1);   SetLength(Interp[0].PN,fa+2);
   j:=0;
   for i:=0 to High(VarList) do
    begin
     if Tree^.PN.FM[i] <> 0 then
      begin
       inc(j);
       Interp[0].PM[j]:=VarList[i].Addr;
       Interp[0].PN[j]:=Tree^.PN.FM[i];
      end;
    end;
   Interp[0].PN[j+1]:=Tree^.PN.FC;

   //Interp[0].AM:=1;
  end;

end;




//MAF:
if Tree^.DI = _MAF then
begin
fa:=0;
for i:=0 to High(VarList) do
begin
if Tree^.PN.FM[i] <> 0 then
begin
inc(fa);
end;
end;
  Interp[0].V1:=Tree^.PN.FC;
  begin
   SetLength(Interp[0].PM,fa+1);
   j:=0;
   for i:=0 to High(VarList) do
    begin
     if Tree^.PN.FM[i] <> 0 then
      begin
       inc(j); Interp[0].PM[j]:=VarList[i].Addr;
      end;
    end;
  end;
end;




if Tree^.CI = _AAI then
begin
fa:=0;
for i:=0 to High(VarList) do
begin
if Tree^.PN1.IM[i] <> 0 then
begin
inc(fa);
end;
end;
  begin
   SetLength(Interp[0].PI,fa+1);   SetLength(Interp[0].PC,fa+2);
   j:=0;
   for i:=0 to High(VarList) do
    begin
     if Tree^.PN1.IM[i] <> 0 then
      begin
       inc(j); Interp[0].PI[j]:=VarList[i].Addr;
       Interp[0].PC[j]:=Trunc(Tree^.PN1.IM[i]);
      end;
    end;
   Interp[0].PC[j+1]:=Trunc(Tree^.PN1.FC);
  end;

end;




if Tree^.DI = _AFI then
begin

fa:=0;
for i:=0 to High(VarList) do
begin
if Tree^.PN.IM[i] <> 0 then
begin
inc(fa);
end;
end;

SetLength(Interp[0].PI,fa+1);
SetLength(Interp[0].PN,fa+2);
j:=0;
 for i:=0 to High(VarList) do
 begin
  if Tree^.PN.IM[i] <> 0 then
  begin
   inc(j); Interp[0].PI[j]:=VarList[i].Addr;
   Interp[0].PN[j]:=Tree^.PN.IM[i];
  end;
 end;
Interp[0].PN[j+1]:=Tree^.PN.FC;


end;



if Length(Tree^.AFB) > 0 then
begin
 SetLength(Interp[0].AFB,Length(Tree^.AFB));
 for i:=0 to  High(Tree^.AFB) do
 begin
  Interp[0].AFB[i].PF:=VarList[Tree^.AFB[i].nf].Addr;
  Interp[0].AFB[i].A:=Tree^.AFB[i].A;
  Interp[0].AFB[i].B:=Tree^.AFB[i].B;
 end;
end;



if Length(Tree^.RData) <> 0 then SetLength(Interp[0].RData,Length(Tree^.RData));
for i:=0 to High(Tree^.RData) do
begin
 Interp[0].RData[i]:=Tree^.RData[i];
end;

if Length(Tree^.SNExtArg) <> 0 then SetLength(Interp[0].SNExtArg,Length(Tree^.SNExtArg));
for i:=0 to High(Tree^.SNExtArg) do
begin
 Interp[0].SNExtArg[i]:=Tree^.SNExtArg[i];
end;



Interp[0].SData:=Tree^.SData;
Interp[0].Neg:=Tree^.Neg;
Interp[0].I:=Tree^.I;
Interp[0].NL:=Tree^.NL;
Interp[0].XCHA:=Tree^.XCHA;
Interp[0].NM:=Tree^.NM;
Interp[0].Code:=Tree^.Code;
Interp[0].IdN:=Tree^.IdN;
Interp[0].IdL:=Tree^.IdL;
Interp[0].Adr:=Tree^.Adr;   //lda

endp:
end;



function TCompiler.E_GetMaxLoadDL(I: Integer): Integer;
begin
 E_SetNodeDL(I);
 E_GetMaxLoadDL:=SMAX;
end;



function TCompiler.E_GetFuncLoad(Tree: PNode): Integer;
begin
 E_SetNode(Tree);
 E_GetFuncLoad:=SMAX-N1_Stack;
end;



function TCompiler.E_GetMaxStackEx: Integer;
var
i: Integer;
begin
 for i:=1 to High(Interp) do
 begin
  E_SetNodeDL(i);
 end;
 E_GetMaxStackEx:=_MaxStack;
end;




function  TCompiler.GetVarType(Addr: TAddress): Integer;
label endp;
var
 i: Integer;
begin
 for i:=0 to High(VarList) do
 begin
   if  Addr = VarList[i].Addr then
   begin
    GetVarType:=VarList[i].VType;
    goto endp;
   end;
 end;

endp:
end;



{
procedure TCompiler.IntToHex(N: TAddress; var AH: TArray4);
var
i,K,N1,j: Integer;
A8: array [1..8] of Integer;
begin
N1:=N;  j:=1;
for i:=7 downto 1 do
begin
 K:=Trunc(N1/IntPower(2,i*4));
 A8[j]:=(K);
 N1:=N1-Trunc(IntPower(2,i*4))*K;
 inc(j);
end;
A8[j]:=N1;


//  :
j:=1;
for i:=4 downto 1 do
begin
 AH[i]:=A8[j]*16+A8[j+1];
 j:=j+2;
end;
end;
}






function  TCompiler.WriteData(Data: TFloatType;  DataType,ComType: Integer): TAddress;
var
FD1: PFuncData;
BH: Boolean;
Pm: Pointer;
ConstType: Integer;
begin


if F_Mode = C_Compile then
begin

 BH:=False;
 if ComType = _LOAD then
  begin
   BH:=True;
   if DataType = _Integer then ConstType:=_Integer
   else
   ConstType:=F_ParamType;
  end
 else
 begin
  if ComType = _ADDSUB then
  begin
   if Data <> 0 then BH:=True;
  end
  else
  if ComType = _MULDIV then
  begin
   if (Data <> 1) and (Data <> -1) then BH:=True;
  end;

  if BH then
  begin
   if DataType = _Integer then ConstType:=_Integer
   else
   ConstType:=F_ParamType;
  end;
 end;





 if BH = True then
 begin
  new(FD1); FD1^.Next:=nil;
  FuncData^.Next:=FD1;
  FuncData:=FD1;
  Pm:=Pointer(@FD1^.FData);


  case  ConstType of
  _Integer:   Integer(Pm^):=Trunc(Data);
  _Single:    Single(Pm^):=Data;
  _Double:    Double(Pm^):=Data;
              {asm
               fld tbyte ptr [data]
               fstp qword ptr pm
              end; }
  _Extended:  Extended(Pm^):=Data;
  end;

  WriteData:=TAddress(Pm);

 end
 else
 WriteData:=TAddress(nil);

end
else
WriteData:=TAddress(nil);
end;



procedure TCompiler.FreeData;
var
FD1,FD2: PFuncData;
begin

FD1:=BFuncData;
while FD1 <> nil do
begin
 FD2:=FD1^.Next;
 dispose(FD1);
 FD1:=FD2;
end;

end;


function TCompiler.IgnoreCom(I: Integer): Boolean;
var
IC: Boolean;
begin

IC:=False;

if Interp[i].Code = C_NOP then IC:=True else
if Interp[i].Code = C_PACKAGE then
begin
 if (Interp[i].PkAdr = 0) and (Interp[i].PkRType = 0) then IC:=True
end;

IgnoreCom:=IC;
end;



procedure TCompiler.Compile(PFunc: PFunction; EInterp: TArrayOfTFunc;  var NAdr: Cardinal);
label 1,2;
var
i,j,k,N,t1,db1,db2: Integer;
AH,AB: TArray4;
R: TFloatType;
P: Pointer;
X: TFloatType;
Sh,S,Expr,ExprArg,S1: String;
Cm,alg,CS: Cardinal;
Bt1: Byte;
AdrH,TAdr,LCode: Cardinal;
AdrS,AdrD:Pointer;
begin
{$IFDEF DEBUGS}
G_Test1:=0;
G_Test2:=0;
G_Test3:=0;
{$ENDIF}


_MaxStack:=0;
//   ..     F_SaveStack:
//if StackSize = 0 then F_SaveStack:=False else F_SaveStack:=True;


N_Stack:=0;
CNI:=0;
E_Overflow:=False;
Db_OverFlow:=False;
F_EnableCheckStack:=True;
F_RetNum:=_Yes; {.203}
F_EnableSave:=True; {.205}

 Func:=PFunc^;
 Interp:=EInterp;
 LFunc:=Length(Interp);

1:
new(FuncData); FuncData^.Next:=nil; BFuncData:=FuncData;
SetLength(ICOMP,0);
REG[1]:=0;
REG[2]:=0;
REG[3]:=0;
REG[4]:=0;
REG[5]:=0;
REG[6]:=0;
REG[7]:=0;
REG[8]:=0;

{$IFDEF DEBUGS}
      G_Test3:=0;
{$ENDIF}

SetLength(GotoLab,0);
CS:=0;
F_JMP:=1;
TE_ADDR:=0;


   {$IFDEF DEBUGS}
       //for i:=0 to TestG8.Form1.MT.Lines.Count-1 do  TestG8.Form1.MT.Lines[i]:='';
       //dbMaxLoadCom:=0;
       TestG8.Form1.MT.Lines.Add('***********************************************************');
   {$ENDIF}

for i:=1 to LFunc-1 do
begin
  Expr:=Interp[i].Expression;       //db
  //ExprArg:=Interp[i].ExpressionArg; //db

//NOP  
 if Interp[i].Code <> C_NOP {IgnoreCom(I) = False} then  {.203}
 begin
   F_SaveNum:=False; {.203}

   CNI:=i;
   Interp[i].NC:=Length(ICOMP);

   //db1:=N_Stack;  //db

    {$IFDEF DEBUGS}
       db1:=Interp[i].SData1;
       if db1 = _MEM then S1:='SaveRes:MEM'  else if db1 = _FPU then S1:='SaveRes:FPU';
       //dbFPUBefore:=N_Stack; dbFPULoad:=0;
     {$ENDIF}

   AddCommand(i);
   AddEndCommand(i);

   //db2:=N_Stack;    //db

   Interp[i].NCP:=Length(ICOMP);

   CS:=Length(ICOMP)-CS;
   Interp[i].CS:=CS+GetLevelsCS(i);
   CS:=Length(ICOMP);

   if {Interp[i].Code <> C_PACKAGE}IgnoreCom(i) = False then F_RetNum:=FuncList[Interp[i].Code].RetNum; {.203}

   {$IFDEF DEBUGS}
      //G_Test1:=G_Test1+GetLevelsCS(i);
      //G_Test3:=G_Test3+Interp[i].CS;
      {if i <= LFunc-1 then} //G_Test3:=G_Test3+CS;
       //if i < LFunc-4 then G_Test1:=G_Test1+Interp[i].CS;
       //if i > LFunc-3 then G_Test1:=G_Test1+GetLevelsCS(i);
      //TestG8.Form1.MT.Lines[i]:=Expr+':  '+'Max:  '+IntToStr(_MaxStack)+';   Load:  '+IntToStr(N_Stack);
      //dbMaxLoadCom:=dbFPUBefore+dbFPULoad;
      TestG8.Form1.MT.Lines.Add('"'+Expr+'"'+'   '+S1+'    loadFPUafter:'+IntToStr(N_Stack)+ '    MaxLoadFPU:'+IntToStr(_MaxStack{dbMaxLoadCom}));
   {$ENDIF}
 end;
end;



//   jmp adr
F_JMP:=2;
for i:=1 to LFunc-1 do
begin
  CNI:=i;
  if Interp[i].Code = C_JMP then JMP_C(i);
end;


SaveReg;
SaveRes(F_Attrib.Adr,F_Attrib.RType,F_Attrib.Shift);
RET;



if  (F_SaveStack = True) and (E_OverFlow = True) then
begin
  N_Stack:=0;
  _MaxStack:=0;
  E_OverFlow:=False;
  F_SaveStack:=False;
  FreeData;
  Db_OverFlow:=True;
  goto 1;
end;


{$IFDEF DEBUGS}
  //TestG8.Form1.STL.Caption:=IntToStr(N_Stack);

  //TestG8.Form1.LTest1.Caption:=IntToStr(G_Test1);
  //TestG8.Form1.LTest2.Caption:=IntToStr(G_Test2);
  //TestG8.Form1.LTest3.Caption:=IntToStr(G_Test3);
{$ENDIF}

//F_RetNum:=FuncList[Interp[I].Code].RetNum; {.203}
if (F_SaveNum = True) or (F_RetNum = _No) then F_RetNum:=_No else  F_RetNum:=_Yes;  {.203}



if F_VirtAlloc = False then    {.199}
begin
//   alg:
  alg:=16;
  SetLength(Func.Code,0);
  SetLength(PFunc^.Code,Length(ICOMP)+alg+1);
  for i:=0 to alg+1  do
  begin
   if Cardinal(@PFunc^.Code[i]) mod alg = 0 then
   begin
    NAdr:=i;
    goto 2;
   end;
  end;
  2:
  for i:=0 to High(ICOMP) do begin
   PFunc^.Code[i+NAdr]:=ICOMP[i];
  end;
  PFunc^.Addr:=TAddress(@PFunc^.Code[NAdr]);    {.199}
  PFunc^.PAddr:=@PFunc^.Code[NAdr];          {.199}
  PFunc^.CodeSize:=Length(ICOMP);            {.199}
  PFunc^.AllocMem:=1;                      {.199}
end
else   
{
  flSet(fl_ENABLE, fl_USE_VIRTUAL_ALLOC,0); 
  allows memory for the  code  is allocated  out  by  the system command  instead: command 'SetLength' in a dynamic array.
{
//F_VirtAlloc = True   {.199}
begin      //only for WinXP SP2+;  memory alloc. only for exe code. Use, only if is any errors with standard memory allocating   (SetLength)
  LCode:=Length(ICOMP);
  AdrD:=VirtualAlloc(Nil, LCode, MEM_COMMIT or MEM_RESERVE, PAGE_EXECUTE_READWRITE);
  AdrS:=@ICOMP[0];
  CopyMemory(AdrD,AdrS,LCode);
  PFunc^.Addr:=TAddress(AdrD);    {.199}
  PFunc^.PAddr:=AdrD;          {.199}
  PFunc^.CodeSize:=LCode;            {.199}
  PFunc^.AllocMem:=2;                      {.199}
end;

{TAdr:=TAddress(@PFunc^.Code[NAdr]);
P:=@PFunc^.Code[NAdr];
asm
  push  eax
  mov   eax,[TAdr]
  call eax
  pop   eax
end;  }

PFunc^.Data:=BFuncData;
ICOMP:=nil;
end;




{
if( ((sin(x+y)*cos(x-y) > sin(cos(y)*x)) and (sin(cos(x)) >= cos(y*sin(x*cos(x))))) or ((sin(x) <= cos(y+x)) and ( cos(x-y)*cos(x+y) <= sin(cos(x)+sin(y)))) and (sin(x*sin(x)) > cos(y*cos(y))) ,if( ((sin(x+y)*cos(x-y) > sin(cos(y)*x)) and (sin(cos(x)) >= cos(y*sin(x*cos(x))))) or
((sin(x) <= cos(y+x)) and ( cos(x-y)*cos(x+y) <= sin(cos(x)+sin(y)))) and (sin(x*sin(x)) > cos(y*cos(y))) ,sin(x),cos(x)),if( ((sin(x+y)*cos(x-y) > sin(cos(y)*x)*sin(x+y)) or (sin(cos(x)+sin(y)) >= cos(y*sin(x*cos(x*y))))) and ((sin(x*y) <= cos(y+x)) or ( cos(x-y)*cos(x+y) <=
cos(x*sin(y)+y*sin(x))*sin(cos(x)+sin(y)))) or (sin(x) > cos(x*y)) ,if( ((sin(x+y)*cos(x-y) > sin(cos(y)*x)*sin(x+y)) or (sin(cos(x)+sin(y)) >= cos(y*sin(x*cos(x*y))))) and ((sin(x*y) <= cos(y+x)) or ( cos(x-y)*cos(x+y) <= cos(x*sin(y)+y*sin(x))*sin(cos(x)+sin(y)))) ,sin(x),cos(x)),
if( ((sin(x+y)*cos(x-y) > sin(cos(y)*x)) and (sin(cos(x)) >= cos(y*sin(x*cos(x))))) or ((sin(x) <= cos(y+x)) and ( cos(x-y)*cos(x+y) <= sin(cos(x)+sin(y)))) ,sin(x),cos(x))))+if((sin(x*y)*cos(x+y) > sin(cos(y)*x))  or ( cos(x-y)*cos(x+y) <= sin(cos(x)+sin(y))) ,if( ((sin(x+y)*cos(x-y) >
sin(cos(y)*x)*sin(x+y)) or (sin(cos(x)+sin(y)) >= cos(y*sin(x*cos(x*y))))) and ((sin(x*y) <= cos(y+x)) or ( cos(x-y)*cos(x+y) <= cos(x*sin(y)+y*sin(x))*sin(cos(x)+sin(y)))) ,sin(x),cos(x)),if( ((sin(x+y)*cos(x-y) > sin(cos(y)*x)) and (sin(cos(x)) >= cos(y*sin(x*cos(x))))) or ((sin(x) <= cos(y+x)) and
( cos(x-y)*cos(x+y) <= sin(cos(x)+sin(y)))) ,sin(x),cos(x)))*if( ((sin(x+y)*cos(x-y) > sin(cos(y)*x)*sin(x+y)) or (sin(cos(x)+sin(y)) >= cos(y*sin(x*cos(x*y))))) and ((sin(x*y) <= cos(y+x)) or ( cos(x-y)*cos(x+y) <= cos(x*sin(y)+y*sin(x))*sin(cos(x)+sin(y)))) or (sin(x) > cos(x*y)) ,if( ((sin(x+y)*cos(x-y) >
sin(cos(y)*x)) and (sin(cos(x)) >= cos(y*sin(x*cos(x))))) or ((sin(x) <= cos(y+x)) and ( cos(x-y)*cos(x+y) <= sin(cos(x)+sin(y)))) and (sin(x*sin(x)) > cos(y*cos(y))) ,sin(x),cos(x)),if( ((sin(x+y)*cos(x-y) > sin(cos(y)*x)) and (sin(cos(x)) >= cos(y*sin(x*cos(x))))) or ((sin(x) <= cos(y+x)) and ( cos(x-y)*cos(x+y) <= sin(cos(x)+sin(y)))) ,sin(x),cos(x)))
}


//x*y+x*y*(x*y+x*y*(x*y+x*y*(x*y+x*y*(x*y+x*y*(x*y+x*y*(x*y+x*y))))))

procedure TCompiler.CheckStack(N: Integer);
begin
if F_EnableCheckStack then
N_Stack:=N_Stack+N;

if N_Stack > StackSize then
begin
E_OverFlow:=True;
end;


if N_Stack > _MaxStack
  then _MaxStack:=N_Stack;
if N_Stack > SMAX then SMAX:=N_Stack;

end;


procedure TCompiler.SetReg(R: Integer);
begin
//1 - EAX; 2 - EBX; 3 - ECX; 4 - EDX;
REG[R]:=1;
end;


procedure TCompiler.SetRegA(R: Integer; SC: Integer);
begin //  -   
//1 - EAX; 2 - EBX; 3 - ECX; 4 - EDX; 5 - ESP; 6 - EBP; 7 - ESI; 8 - EDI;
REGA[R]:=SC;
end;

function  TCompiler.GetReg(R: Integer): Integer;
begin
 if (REG[R] = 1) or (REGA[R] = 1) then GetReg:=1 else GetReg:=0;
end;

procedure TCompiler.SaveFuncReg(I: Integer);
var
N,k,E: Integer;
begin
  N:=FuncList[Interp[I].Code].SaveReg;
  for k:=0 to 7 do
  begin
    E:=0;
    asm
     push eax
     push ebx

     mov  eax,N
     mov  ebx,k
     bt   eax,ebx
     jnc  @@1
     mov  E,1
     @@1:
     pop  ebx
     pop  eax
    end;

    if E = 1 then SetReg(k+1);
  end;
end;



procedure TCompiler.SaveReg;
var
PP: array [0..7] of byte;
i,L,j,k: integer;
begin
L:=-1;

for i:=1 to 8 do
begin
 PP[i-1]:=0;
if (REG[i] <> 0) or (REGA[i] <> 0) then
 begin
 inc(L); PP[L]:=i;
 end;
end;

if L > -1 then
begin
 j:=High(ICOMP);
 SetLength(ICOMP,Length(ICOMP)+2*(L+1));

 for i:=j downto 0 do
 begin
 ICOMP[i+(L+1)]:=ICOMP[i];
 end;

 for i:=0 to (L{+1}) do
 begin
  if PP[i] = 1 then ICOMP[i]:=$50 else
  if PP[i] = 2 then ICOMP[i]:=$53 else
  if PP[i] = 3 then ICOMP[i]:=$51 else
  if PP[i] = 4 then ICOMP[i]:=$52 else
  if PP[i] = 5 then ICOMP[i]:=$54 else
  if PP[i] = 6 then ICOMP[i]:=$55 else
  if PP[i] = 7 then ICOMP[i]:=$56 else
  if PP[i] = 8 then ICOMP[i]:=$57;
 end;

 k:=0;
 for i:=(L{+1}) downto 0 do
 begin
  if PP[i] = 1 then
   begin ICOMP[j+(L+1)+k+1]:=$58; inc(k); end else
  if PP[i] = 2 then
   begin ICOMP[j+(L+1)+k+1]:=$5B; inc(k); end else
  if PP[i] = 3 then
   begin ICOMP[j+(L+1)+k+1]:=$59; inc(k); end else
  if PP[i] = 4 then
   begin ICOMP[j+(L+1)+k+1]:=$5A; inc(k); end else
  if PP[i] = 5 then
   begin ICOMP[j+(L+1)+k+1]:=$5C; inc(k); end else
  if PP[i] = 6 then
   begin ICOMP[j+(L+1)+k+1]:=$5D; inc(k); end else
  if PP[i] = 7 then
   begin ICOMP[j+(L+1)+k+1]:=$5E; inc(k); end else
  if PP[i] = 8 then
   begin ICOMP[j+(L+1)+k+1]:=$5F; inc(k); end;


 end;

end;

//RET;
end;



procedure TCompiler.SaveRes(Adr,RType,Shift: Cardinal);
var
PP: array [0..7] of byte;
i,L,j,k: integer;
begin

if (Adr <> 0) and (RType <> 0) then
begin
 case Adr of
 1:   FSTPA(RType,Shift);
 2:   FSTPB(RType,Shift);
 3:   FSTPC(RType,Shift);
 4:   FSTPD(RType,Shift);
 5:   FSTPESP(RType,Shift)   //non-doc
 else
      FSTPM(Adr,RType);
end;
 F_SaveNum:=True;     {.203}
end;

//RET;

end;



function TCompiler.IsLevelLoad(I: Integer): Boolean;
label endp;
var
NM,NL,k: Integer;
begin
if F_Mode = C_EmlXchBranch then
begin
 if Interp[I].NL = 1 then IsLevelLoad:=False
 else
 IsLevelLoad:=True;
end
else
begin
 NM:=Interp[I].NM;
 NL:=Interp[I].NL;

 for k:=0 to NL-2 do
 begin
  if Interp[NM].RData[k] = _FPU then
  begin
   IsLevelLoad:=True; goto endp;
  end;
 end;

 IsLevelLoad:=False;
end;
endp:
end;



function TCompiler.IsLevelLoadA(I: Integer): Integer;
var
n,k,l: Integer;
begin
n:=-1;
l:=0;
 for k:=0 to High(Interp[I].RData) do
 begin
  if Interp[I].RData[k] = _FPU then
  begin
   inc(l);
   n:=k;
  end;
 end;

 if n = -1 then IsLevelLoadA:=0
 else
 begin
  k:=Interp[i].SGN[n];
  if (l = 1) and (k = _DIV) then IsLevelLoadA:=_DIV
  else
  IsLevelLoadA:=_MUL;
  // l > 0,    
 end;
end;


function TCompiler.SizeArg(VType: Integer): Integer;
begin
  case VType of
    _Single:     SizeArg:=4;
    _Integer:    SizeArg:=4;
    _Address:    SizeArg:=4;
    _ArrayD:     SizeArg:=4;  {.245}
    _ArrayE:     SizeArg:=4;
    _ArrayS:     SizeArg:=4;
    _ArrayI:     SizeArg:=4;
    _Double:     SizeArg:=8;
    _Extended:   SizeArg:=12;
  end;
end;


function TCompiler.GetLevelsCS(num: Integer): Cardinal;
var   //   
j,IdN: Integer;
CS: Cardinal;
ANL: TArrayC;
begin

 {$IFDEF DEBUGS}
   if num = LFunc-1 then
     G_Test2:={G_Test2+}Interp[num].IdL;
 {$ENDIF}

IdN:=Interp[num].IdN;
for j:=1 to LFunc-1 do
begin
   if IdN = Interp[j].IdL then
   begin
    SetLength(ANL,Length(ANL)+1);
    ANL[High(ANL)]:=j;
   end;
end;

CS:=0;
for j:=0 to High(ANL) do
begin
   CS:=CS+Interp[ANL[j]].CS;
end;

GetLevelsCS:=CS;


end;




procedure TCompiler.FindNumberLevelA(num: Integer; var ANL: TArrayC);
var
j,IdN: Integer;
begin

IdN:=Interp[num].IdN;
for j:=1 to LFunc-1 do
begin
   if IdN = Interp[j].IdL then
   begin
    SetLength(ANL,Length(ANL)+1);
    ANL[High(ANL)]:=j;
   end;
end;

end;







{.239}
procedure TCompiler.JMP_C(N: Integer);
         procedure CorrectStackIF(N: Integer);
         begin
            {.235}
           //''   3-  ( 4-)   IF      N_Stack
           //#JMP (EI = 1)     IF
           {
             IF(Arg1 op Arg2, Arg3, Arg4)  => IFNOP(Arg1,Arg2,CJMP,Arg3,JMP,ARG4)
             IF(Arg1 op Arg2)              => IFNOP(Arg1,Arg2,CJMP,FLD1,JMP,FLDZ)
             IF(Arg1 op Arg2, Arg3)        => IFNOP(Arg1,Arg2,CJMP,Arg3,JMP,FLDZ)
           }

          //  
          //xxx
          if Interp[N].EI = 1 then
          begin
            if Interp[N-1].EI <> 8 then CheckStack(-1);   //if(x<y), if(x<y,x,y);   EI=8(N-1 = goto): if(x<y,goto()), if(x<y,goto(),goto())
          end;


          // ,     IF:
         {
          NM:=Interp[N].NM;  //Interp[Interp[N].NM].code = C_IFNOP !!! 
         if NM > 0 then
         begin
           if (Interp[NM].CODE = C_IFNOP) and (Interp[NM].DI = 0) then CheckStack(-1); //DI=0:  IF  goto (if(x<y,goto()), if(x<y,goto(),goto()))
         end;
         }
       end;
label endp;
var
P: ^Integer;{^Cardinal;} {.203}
NC,CC,N1,N2,SZ,S,L,NCP,NCP1: Cardinal;
NL,NB,CS,Adr1,Adr2,CS1: Cardinal;
NN,FI,iTmp,NM: Integer;
ANL: TArrayC;
Str: String;
begin
 //EI = 1       2      3       4      5      6     7         8
 //   #JMP, #JMPE, #JMPEL, #JMPEB, #JMPB, #JMPL, #JMPNE,  JMP(goto)

if F_Mode = C_EmlXchBranch{C_Compile} then    {.239}
begin
//: DinamicLoad
 if (Interp[N].EI >= 2) and (Interp[N].EI <= 7) then CheckStack(-2); //FCOMPP      {.new}  {!!!}
 //else CheckStack(-1); //JMP
 //CorrectStackIF(N);  {.235}

 goto endp;
end;

// 
if F_JMP = 1 then
begin
  if (Interp[N].EI = 1) or (Interp[N].EI = 8) then     //JMP, GOTO
  begin
   SetLength(ICOMP,Length(ICOMP)+5);
   ICOMP[High(ICOMP)-4]:=$E9;         //jmp

   CorrectStackIF(N);   {.235}

  //''     ( )   IF      N_Stack
   //#JMP (EI = 1)     IF

   //  
   //xxx
   {
   if Interp[N].EI = 1 then
   begin
     if Interp[N-1].EI <> 8 then CheckStack(-1);   //if(x<y), if(x<y,x,y);   EI=8(N-1=goto): if(x<y,goto()), if(x<y,goto(),goto())
   end;
   }

   // ,     IF:
   {
   NM:=Interp[N].NM;  //Interp[Interp[N].NM].code = C_IFNOP !!! 
   if NM > 0 then
   begin
     if (Interp[NM].CODE = C_IFNOP) and (Interp[NM].DI = 0) then CheckStack(-1); //DI=0:  IF  goto (if(x<y,goto()), if(x<y,goto(),goto()))
   end;
   }

  end
  else   //CJMP   {condition jump}
  begin

   // A1,A2  
   FindNumberLevelA(Interp[N].NM,ANL);      //NM - :  IFNOP
   N1:=ANL[0];    N2:=ANL[1];
   S:=Interp[Interp[N].NM].S;
   Adr1:=GetStackAddr(S);     {.241}
   Adr2:=GetStackAddr(S+1);   {.241}
   {
   Adr1:=0; Adr2:=0;
   if F_Mode = C_Compile then
   begin
      Adr1:=TAddress(@Func.Stack[S]);
      Adr2:=TAddress(@Func.Stack[S+1]);
   end;
   }
   if (Interp[N1].SData1 = _MEM) and (Interp[N2].SData1 = _MEM) then
   begin
      //fld A1,fld A2
      FLD(Adr1,F_DataType);
      FLD(Adr2,F_DataType);

     //12: fld A1,fld A2

     {
     SetLength(ICOMP,Length(ICOMP)+12);
     CheckStack(2);
     if F_DataType = _Double then
     begin
       //fld qword ptr [Adr1]
       ICOMP[Length(ICOMP)-12]:=$DD; ICOMP[Length(ICOMP)-11]:=$05;
       P:=@ICOMP[Length(ICOMP)-10];
       P^:=Adr1;
       //fld qword ptr [Adr2]
       ICOMP[Length(ICOMP)-6]:=$DD; ICOMP[Length(ICOMP)-5]:=$05;
       P:=@ICOMP[Length(ICOMP)-4];
       P^:=Adr2;
     end
     else
     if F_DataType = _Extended then
     begin
       //fld tbyte ptr [Adr1]
       ICOMP[Length(ICOMP)-12]:=$DB; ICOMP[Length(ICOMP)-11]:=$2D;
       P:=@ICOMP[Length(ICOMP)-10];
       P^:=Adr1;
       //fld tbyte ptr [Adr2]
       ICOMP[Length(ICOMP)-6]:=$DB; ICOMP[Length(ICOMP)-5]:=$2D;
       P:=@ICOMP[Length(ICOMP)-4];
       P^:=Adr2;
     end;
     }
   end
   else
   if (Interp[N1].SData1 = _MEM) and (Interp[N2].SData1 = _FPU) then
   begin
     //fld A1
     FLD(Adr1,F_DataType);
     FXCH1;
     {
     //8: fld A1; fxch
     SetLength(ICOMP,Length(ICOMP)+8);
     CheckStack(1);
     if F_DataType = _Double then
     begin
       //fld qword ptr [Adr1]
       ICOMP[Length(ICOMP)-8]:=$DD; ICOMP[Length(ICOMP)-7]:=$05;
       P:=@ICOMP[Length(ICOMP)-6];
       P^:=Adr1;
     end
     else
     if F_DataType = _Extended then
     begin
       //fld tbyte ptr [Adr1]
       ICOMP[Length(ICOMP)-8]:=$DB; ICOMP[Length(ICOMP)-7]:=$2D;
       P:=@ICOMP[Length(ICOMP)-6];
       P^:=Adr1;
     end;
     //fxch
     ICOMP[Length(ICOMP)-2]:=$D9; ICOMP[Length(ICOMP)-1]:=$C9;
     }
   end
   else
   if (Interp[N1].SData1 = _FPU) and (Interp[N2].SData1 = _MEM) then
   begin
     // fld A2
     FLD(Adr2,F_DataType);

     {
     //6: fld A2
     SetLength(ICOMP,Length(ICOMP)+6);
     CheckStack(1);
     if F_DataType = _Double then
     begin
       //fld qword ptr [Adr2]
       ICOMP[Length(ICOMP)-6]:=$DD; ICOMP[Length(ICOMP)-5]:=$05;
       P:=@ICOMP[Length(ICOMP)-4];
       P^:=Adr2;
     end
     else
     if F_DataType = _Extended then
     begin
       //fld qword ptr [Adr2]
       ICOMP[Length(ICOMP)-6]:=$DB; ICOMP[Length(ICOMP)-5]:=$2D;
       P:=@ICOMP[Length(ICOMP)-4];
       P^:=Adr2;
     end;
      }
   end
   else
   if (Interp[N1].SData1 = _FPU) and (Interp[N2].SData1 = _FPU) then
   begin

   end;

   { P:=@ICOMP[0];
   asm
     call  P
   end;
   }

   {
   SetLength(ICOMP,Length(ICOMP)+10);   //8: fucomip, fstp st(0)
   //fucomip:
   ICOMP[High(ICOMP)-9]:=$DF;  ICOMP[High(ICOMP)-8]:=$E9;
   //fstp st(0)
   ICOMP[High(ICOMP)-7]:=$DD;  ICOMP[High(ICOMP)-6]:=$D8;
   }



   {
    SetLength(ICOMP,Length(ICOMP)+11);   //11: fcompp, fstsw ax, sahf
   //fcompp:
   ICOMP[High(ICOMP)-10]:=$DE;  ICOMP[High(ICOMP)-9]:=$D9;
   //fstsw ax:
   ICOMP[High(ICOMP)-8]:=$DF;  ICOMP[High(ICOMP)-7]:=$E0;
   //sahf
   ICOMP[High(ICOMP)-6]:=$9E;

   case Interp[N].EI of
   2:   begin ICOMP[High(ICOMP)-5]:=$0F; ICOMP[High(ICOMP)-4]:=$84; end; //jz
   3:   begin ICOMP[High(ICOMP)-5]:=$0F; ICOMP[High(ICOMP)-4]:=$83; end; //jnb
   4:   begin ICOMP[High(ICOMP)-5]:=$0F; ICOMP[High(ICOMP)-4]:=$86; end; //jbe
   5:   begin ICOMP[High(ICOMP)-5]:=$0F; ICOMP[High(ICOMP)-4]:=$82; end; //jb
   6:   begin ICOMP[High(ICOMP)-5]:=$0F; ICOMP[High(ICOMP)-4]:=$87; end; //jnbe
   7:   begin ICOMP[High(ICOMP)-5]:=$0F; ICOMP[High(ICOMP)-4]:=$85; end; //jnz
   end;
   }
     {FLDCW(TAddress(@FCW3));
     FLDZ;
     FADD;
     FXCH1;
     FLDZ;
     FADD;
     FXCH1;}

     {.243}
   {
   FCOMPP;
   FSTSW_AX;
   SAHF;
   JMPC(0,Interp[N].EI);
   }
   FCOMIP;
   FSTP0;
   JMPC(0,Interp[N].EI);



   //if(x<y,sin(x),cos(x))
   { P:=@ICOMP[0];
   asm
     call  P
   end; }

   //CheckStack(-2);  //fcompp
   SetReg(1);       //eax

  end;

end
else  //   JMP
if F_JMP =2 then
begin
 {P:=@ICOMP[0];
   asm
     call  P
   end;   }

  //GOTO():
  if (Interp[N].EI = 8) {and (Length(GotoLab)>0)} then
  begin
    NCP:=Interp[N].NCP;
    P:=@ICOMP[NCP-4];
    NN:=Interp[N].CI-2;
    if (NN = -1) or(Length(GotoLab) = 0) then
    begin
     P^:=-NCP;
    end
    else
    begin
     L:=GotoLab[NN];
     NCP1:=Interp[L].NCP;


     {     OverFlowChecks,RangeChecks -On -    ! }
     {If there is an exception at OverFlowChecks,RangeChecks -On - it is no error !}
     //{$RangeChecks Off}
     //{$OverFlowChecks Off}
      P^:=NCP1-NCP;
      //{$RangeChecks On}
      //{$OverFlowChecks On}


     ///iTmp:=integer(NCP1-NCP);
     //P^:=iTmp{NCP1-NCP};
    end;

    {$IFDEF DEBUGS}
      //inc(G_Test3);
    {$ENDIF}

    goto endp;
  end;

  //CJMP:
  //Str:=Interp[interp[N].nm].Ers;
  L:=Interp[interp[N].NM].N;
  FI:=Interp[interp[N].NM].FI;  //FI=2: if(arg1,arg2,goto())
  NL:=Interp[N].NL;      // -  :   '1'
  FindNumberLevelA(Interp[N].NM,ANL);      //NM - :  IFNOP
  NB:=ANL[NL];           //ANL:    '0': ANL[NL]   - 
  CS:=Interp[NB].CS;     //   -
  NC:=Interp[N].NC;      //    ICOMP  
  CS1:=Interp[N].CS;     //   

  {$IFDEF DEBUGS}
      //if NL >= Length(ANL) then G_Test1:={G_Test1+NL}1;
       //G_Test1:=G_Test1+CS;
  {$ENDIF}

  if Interp[N].EI = 1 then  //JMP:
  begin
    P:=@ICOMP[NC{+1}+CS1-4];
    P^:=CS;

    {$IFDEF DEBUGS}
     //inc(G_Test1);
    {$ENDIF}
  end
  else                      //CJMP:
  begin
     {     OverFlowChecks,RangeChecks -On -    ! }
     {If there is an exception at OverFlowChecks,RangeChecks -On - it is no error !}
      //{$RangeChecks Off}
      //{$OverFlowChecks Off}
    P:=@ICOMP[NC+CS1-4];
      //{$RangeChecks On}
      //{$OverFlowChecks On}
    {if L = 6 then P^:=CS+5 else  //5 -   JMP: A1,A2,CJMP,A3,JMP,A4   A4: NL  NB   JMP
       if L = 4 then P^:=5;}      //if(arg,goto())     A1,A2,CJMP,JMP
     if FI = 0 then P^:=CS+5 else
       if FI = 2 then P^:=5;        //      if(arg,goto())

     {$IFDEF DEBUGS}
       //inc(G_Test2);
     {$ENDIF}
  end;

  //CheckStack(-1);      {.235}
end;

endp:
end;






 (*
//if(x<y,x^2,x^3)
procedure TCompiler.JMP_C(N: Integer);
         procedure CorrectStackIF(N: Integer);
         begin
            {.235}
           //''     ( )   IF      N_Stack
           //#JMP (EI = 1)     IF

          //  
          //xxx
          if Interp[N].EI = 1 then
          begin
            if Interp[N-1].EI <> 8 then CheckStack(-1);   //if(x<y), if(x<y,x,y);   EI=8(N-1=goto): if(x<y,goto()), if(x<y,goto(),goto())
          end;


          // ,     IF:
         {
          NM:=Interp[N].NM;  //Interp[Interp[N].NM].code = C_IFNOP !!! 
         if NM > 0 then
         begin
           if (Interp[NM].CODE = C_IFNOP) and (Interp[NM].DI = 0) then CheckStack(-1); //DI=0:  IF  goto (if(x<y,goto()), if(x<y,goto(),goto()))
         end;
         }
       end;
label endp;
var
P: ^Integer;{^Cardinal;} {.203}
NC,CC,N1,N2,SZ,S,L,NCP,NCP1: Cardinal;
NL,NB,CS,Adr1,Adr2,CS1: Cardinal;
NN,FI,iTmp,NM: Integer;
ANL: TArrayC;
Str: String;
begin
 //AI = 1       2      3       4      5      6     7         8
 //   #JMP, #JMPE, #JMPEL, #JMPEB, #JMPB, #JMPL, #JMPNE,  JMP(goto)

if F_Mode <> C_Compile then
begin
//: DinamicLoad
 if (Interp[N].EI >= 2) and (Interp[N].EI <= 7) then CheckStack(-2); //FCOMPP      {.new}  {!!!}
 //else CheckStack(-1); //JMP
 CorrectStackIF(N);  {.235}

 goto endp;
end;

// 
if F_JMP = 1 then
begin
  if (Interp[N].EI = 1) or (Interp[N].EI = 8) then     //JMP, GOTO
  begin
   SetLength(ICOMP,Length(ICOMP)+5);
   ICOMP[High(ICOMP)-4]:=$E9;         //jmp

   CorrectStackIF(N);   {.235}

  //''     ( )   IF      N_Stack
   //#JMP (EI = 1)     IF

   //  
   //xxx
   {
   if Interp[N].EI = 1 then
   begin
     if Interp[N-1].EI <> 8 then CheckStack(-1);   //if(x<y), if(x<y,x,y);   EI=8(N-1=goto): if(x<y,goto()), if(x<y,goto(),goto())
   end;
   }

   // ,     IF:
   {
   NM:=Interp[N].NM;  //Interp[Interp[N].NM].code = C_IFNOP !!! 
   if NM > 0 then
   begin
     if (Interp[NM].CODE = C_IFNOP) and (Interp[NM].DI = 0) then CheckStack(-1); //DI=0:  IF  goto (if(x<y,goto()), if(x<y,goto(),goto()))
   end;
   }

  end
  else   //CJMP   {condition jump}
  begin

   // A1,A2  
   FindNumberLevelA(Interp[N].NM,ANL);      //NM - :  IFNOP
   N1:=ANL[0];    N2:=ANL[1];
   S:=Interp[Interp[N].NM].S;
   Adr1:=TAddress(@Func.Stack[S]);
   Adr2:=TAddress(@Func.Stack[S+1]);
   if (Interp[N1].SData1 = _MEM) and (Interp[N2].SData1 = _MEM) then
   begin
      //FLD(Adr1,F_DataType);
      //FLD(Adr2,F_DataType);

     //12: fld A1,fld A2
     SetLength(ICOMP,Length(ICOMP)+12);
     CheckStack(2);
     if F_DataType = _Double then
     begin
       //fld qword ptr [Adr1]
       ICOMP[Length(ICOMP)-12]:=$DD; ICOMP[Length(ICOMP)-11]:=$05;
       P:=@ICOMP[Length(ICOMP)-10];
       P^:=Adr1;
       //fld qword ptr [Adr2]
       ICOMP[Length(ICOMP)-6]:=$DD; ICOMP[Length(ICOMP)-5]:=$05;
       P:=@ICOMP[Length(ICOMP)-4];
       P^:=Adr2;
     end
     else
     if F_DataType = _Extended then
     begin
       //fld tbyte ptr [Adr1]
       ICOMP[Length(ICOMP)-12]:=$DB; ICOMP[Length(ICOMP)-11]:=$2D;
       P:=@ICOMP[Length(ICOMP)-10];
       P^:=Adr1;
       //fld tbyte ptr [Adr2]
       ICOMP[Length(ICOMP)-6]:=$DB; ICOMP[Length(ICOMP)-5]:=$2D;
       P:=@ICOMP[Length(ICOMP)-4];
       P^:=Adr2;
     end;

   end
   else
   if (Interp[N1].SData1 = _MEM) and (Interp[N2].SData1 = _FPU) then
   begin
     //FLD(Adr1,F_DataType);
     //FXCH1;

     //8: fld A1; fxch
     SetLength(ICOMP,Length(ICOMP)+8);
     CheckStack(1);
     if F_DataType = _Double then
     begin
       //fld qword ptr [Adr1]
       ICOMP[Length(ICOMP)-8]:=$DD; ICOMP[Length(ICOMP)-7]:=$05;
       P:=@ICOMP[Length(ICOMP)-6];
       P^:=Adr1;
     end
     else
     if F_DataType = _Extended then
     begin
       //fld tbyte ptr [Adr1]
       ICOMP[Length(ICOMP)-8]:=$DB; ICOMP[Length(ICOMP)-7]:=$2D;
       P:=@ICOMP[Length(ICOMP)-6];
       P^:=Adr1;
     end;
     //fxch
     ICOMP[Length(ICOMP)-2]:=$D9; ICOMP[Length(ICOMP)-1]:=$C9;

   end
   else
   if (Interp[N1].SData1 = _FPU) and (Interp[N2].SData1 = _MEM) then
   begin
     //FLD(Adr1,F_DataType);


     //6: fld A1
     SetLength(ICOMP,Length(ICOMP)+6);
     CheckStack(1);
     if F_DataType = _Double then
     begin
       //fld qword ptr [Adr2]
       ICOMP[Length(ICOMP)-6]:=$DD; ICOMP[Length(ICOMP)-5]:=$05;
       P:=@ICOMP[Length(ICOMP)-4];
       P^:=Adr2;
     end
     else
     if F_DataType = _Extended then
     begin
       //fld qword ptr [Adr2]
       ICOMP[Length(ICOMP)-6]:=$DB; ICOMP[Length(ICOMP)-5]:=$2D;
       P:=@ICOMP[Length(ICOMP)-4];
       P^:=Adr2;
     end;

   end
   else
   if (Interp[N1].SData1 = _FPU) and (Interp[N2].SData1 = _FPU) then
   begin

   end;

   { P:=@ICOMP[0];
   asm
     call  P
   end;
   }

   {
   SetLength(ICOMP,Length(ICOMP)+10);   //8: fucomip, fstp st(0)
   //fucomip:
   ICOMP[High(ICOMP)-9]:=$DF;  ICOMP[High(ICOMP)-8]:=$E9;
   //fstp st(0)
   ICOMP[High(ICOMP)-7]:=$DD;  ICOMP[High(ICOMP)-6]:=$D8;
   }



   {
    SetLength(ICOMP,Length(ICOMP)+11);   //11: fcompp, fstsw ax, sahf
   //fcompp:
   ICOMP[High(ICOMP)-10]:=$DE;  ICOMP[High(ICOMP)-9]:=$D9;
   //fstsw ax:
   ICOMP[High(ICOMP)-8]:=$DF;  ICOMP[High(ICOMP)-7]:=$E0;
   //sahf
   ICOMP[High(ICOMP)-6]:=$9E;

   case Interp[N].EI of
   2:   begin ICOMP[High(ICOMP)-5]:=$0F; ICOMP[High(ICOMP)-4]:=$84; end; //jz
   3:   begin ICOMP[High(ICOMP)-5]:=$0F; ICOMP[High(ICOMP)-4]:=$83; end; //jnb
   4:   begin ICOMP[High(ICOMP)-5]:=$0F; ICOMP[High(ICOMP)-4]:=$86; end; //jbe
   5:   begin ICOMP[High(ICOMP)-5]:=$0F; ICOMP[High(ICOMP)-4]:=$82; end; //jb
   6:   begin ICOMP[High(ICOMP)-5]:=$0F; ICOMP[High(ICOMP)-4]:=$87; end; //jnbe
   7:   begin ICOMP[High(ICOMP)-5]:=$0F; ICOMP[High(ICOMP)-4]:=$85; end; //jnz
   end;
   }
     {FLDCW(TAddress(@FCW3));
     FLDZ;
     FADD;
     FXCH1;
     FLDZ;
     FADD;
     FXCH1;}
   FCOMPP;
     //FLDCW(TAddress(@FCW2));
   FSTSW_AX;
   SAHF;
   JMPC(0,Interp[N].EI);




   //if(x<y,sin(x),cos(x))
   { P:=@ICOMP[0];
   asm
     call  P
   end; }

   //CheckStack(-2);  //fcompp
   SetReg(1);       //eax

  end;

end
else  //   JMP
if F_JMP =2 then
begin
 {P:=@ICOMP[0];
   asm
     call  P
   end;   }

  //GOTO():
  if (Interp[N].EI = 8) {and (Length(GotoLab)>0)} then
  begin
    NCP:=Interp[N].NCP;
    P:=@ICOMP[NCP-4];
    NN:=Interp[N].CI-2;
    if (NN = -1) or(Length(GotoLab) = 0) then
    begin
     P^:=-NCP;
    end
    else
    begin
     L:=GotoLab[NN];
     NCP1:=Interp[L].NCP;


     {     OverFlowChecks,RangeChecks -On -    ! }
     {If there is an exception at OverFlowChecks,RangeChecks -On - it is no error !}
     //{$RangeChecks Off}
     //{$OverFlowChecks Off}
      P^:=NCP1-NCP;
      //{$RangeChecks On}
      //{$OverFlowChecks On}


     ///iTmp:=integer(NCP1-NCP);
     //P^:=iTmp{NCP1-NCP};
    end;

    {$IFDEF DEBUGS}
      //inc(G_Test3);
    {$ENDIF}

    goto endp;
  end;

  //CJMP:
  //Str:=Interp[interp[N].nm].Ers;
  L:=Interp[interp[N].NM].N;
  FI:=Interp[interp[N].NM].FI;  //FI=2: if(arg1,arg2,goto())
  NL:=Interp[N].NL;      // -  :   '1'
  FindNumberLevelA(Interp[N].NM,ANL);      //NM - :  IFNOP
  NB:=ANL[NL];           //ANL:    '0': ANL[NL]   - 
  CS:=Interp[NB].CS;     //   -
  NC:=Interp[N].NC;      //    ICOMP  
  CS1:=Interp[N].CS;     //   

  {$IFDEF DEBUGS}
      //if NL >= Length(ANL) then G_Test1:={G_Test1+NL}1;
       //G_Test1:=G_Test1+CS;
  {$ENDIF}

  if Interp[N].EI = 1 then  //JMP:
  begin
    P:=@ICOMP[NC{+1}+CS1-4];
    P^:=CS;

    {$IFDEF DEBUGS}
     //inc(G_Test1);
    {$ENDIF}
  end
  else                      //CJMP:
  begin
    P:=@ICOMP[NC+CS1-4];
    {if L = 6 then P^:=CS+5 else  //5 -   JMP: A1,A2,CJMP,A3,JMP,A4   A4: NL  NB   JMP
       if L = 4 then P^:=5;}      //if(arg,goto())     A1,A2,CJMP,JMP
     if FI = 0 then P^:=CS+5 else
       if FI = 2 then P^:=5;        //      if(arg,goto())

     {$IFDEF DEBUGS}
       //inc(G_Test2);
     {$ENDIF}
  end;

  //CheckStack(-1);      {.235}
end;

endp:
end;
*)








procedure TCompiler.FLD_C(I: Integer);
begin
//FLD1
if Interp[i].EI = 1 then
begin
  FLD1;
   //if F_Mode = C_Compile then if Interp[Interp[i].NM].CODE = C_IFNOP then CheckStack(-1);

end
else
//FLDZ
if Interp[i].EI = 2 then
begin
  FLDZ;
    //if F_Mode = C_Compile then if Interp[Interp[i].NM].CODE = C_IFNOP then CheckStack(-1);
end
end;




procedure TCompiler.LDA_C(I: Integer);
var
adr: TAddress;
begin
adr:=TAddress(Interp[i].FV1);
FLD(WriteData(adr,_Integer,_Load),_Integer);
end;



function TCompiler.GetBeginCom(N: Cardinal): Cardinal;
//    (N)   
label 1;
var
i,S,BC: Integer;
begin
S:=Interp[N].S;
i:=N;

1:
if i = 1 then BC:=i else
  if Interp[i].S >= S  then
  begin
   dec(i);
   goto 1;
  end
  else
  BC:=i;

GetBeginCom:=BC;
end;


procedure TCompiler.COMPILE_C(I: Integer);
var
adr: TAddress;
N,BC: Cardinal;
begin
BC:=GetBeginCom(I);
N:=Interp[BC].NC; //@ICOMP[N]   Compile(Arg)
//adr:=TAddress(Interp[i].FV1);
//FLD(WriteData(adr,_Integer,_Load),_Integer);
RET;
end;


procedure TCompiler.AddCommand(I: Integer);
var
N,k,j,NS,OVF,SR: Integer;
begin

//    :
//(1)  ( ) 
//(2)  
//  -   


{if Interp[I].Code = C_CopyStack then
begin
CopyStack(I);
end
else }
if Interp[I].Code = C_NOP then
begin
//EndFuncCom(I);
end
else
if Interp[I].Code = C_IFNOP then
begin          //xxx
 //if Interp[I].DI = 0 then CheckStack(-1);        {.235}
 {
 ''      (  :3  4)   IF      N_Stack
       C_EmlXchBranch
     - CorrectStackIF
 }
 if  (F_Mode = C_EmlXchBranch) and (Interp[I].DI = 0) then CheckStack(-1); {.239}
 FAB12(i);
end
else
if Interp[I].Code = C_PACKAGE then
begin
 PKGCMPL(I);
end
else
if Interp[I].Code = C_JMP then
begin
 JMP_C(I);
end
else
if Interp[I].Code = C_FLD then
begin
 FLD_C(I);
end
else
if Interp[I].Code = C_LDA then
begin
 LDA_C(I);
end
else
if Interp[I].Code = C_COMPILED then
begin
 //off
 COMPILE_C(I);
end
else
if Interp[I].Code = C_LDSC then
begin
 FLD(WriteData(Interp[i].V2,_Float,_Load),F_ParamType);
end
else
if Interp[i].Code = C_LDSF then
begin
 FLD(TAddress(Interp[i].FV1),GetVarType(Interp[i].FV1));
end
else
if Interp[i].Code = C_LDSI then
begin
 FILD(TAddress(Interp[i].IV1));
end
else
if Interp[i].Code = C_LDSV then
begin
  LDSV(I);
end
else
if Interp[i].Code = C_LDSVA then
begin
  LDSVA(I);      {arraycpu} {.245}
end
else
if Interp[i].Code = C_SAVEV then
begin
  SAVEV(I);
end
else
if Interp[i].Code = C_SUMP then
begin
  SUMP(I);
end
else
if Interp[i].Code = C_SUMPS then
begin
  SUMPS(I);
end
else
if Interp[i].Code = C_FAVB then
begin
 FAVB(I);
end
else
if Interp[i].Code = C_IAVB then
begin
 IAVB(I);
end
else
if Interp[i].Code = C_AIFB then
begin
 AIFB(I);
end
else
if Interp[i].Code = C_MUL then
begin
 MUL(I);
end
else
if Interp[i].Code = C_AAI then
begin
 AAI(I);
end
else
if Interp[i].Code = C_AFI then
begin
 AFI(I);
end
else
if Interp[i].Code = C_MAF then
begin
 MAF(I);
end
else
if Interp[i].Code = C_AAF then
begin
 AAF(I);
end
else
if Interp[i].Code = C_ADD  then
begin
  ADD(I);
end
else
if Interp[i].Code = C_INC then
begin
 INC_C(TAddress(Interp[i].IV1));
end
else
if Interp[i].Code = C_DEC then
begin
 DEC_C(TAddress(Interp[i].IV1));
end
else
if Interp[i].Code = C_MOD then    {!!!}
begin
 MOD_C(i);
end
else
if Interp[i].Code = C_POLY then    {!!!}
begin
 POLY_C(i);
end
else
if Interp[i].Code = C_POLYDIFF then    {!!!}
begin
 POLYDIFF_C(i);
end
else
if Interp[i].Code = C_TRY then    {.249}
begin
  TRY_C(i);
end
else
if Interp[i].Code = C_EXCEPTION then    {.249}
begin
  EXCEPTION_C(i);
end
else
if FuncList[Interp[i].Code].FType = 1 then
begin
 FUNC1(I);
end
else
if FuncList[Interp[i].Code].FType = 2 then
begin
 FUNC2(I);
end
else
if FuncList[Interp[i].Code].FType = 3 then
begin
 FUNC3(I);
end
else
if FuncList[Interp[i].Code].FType = 4 then
begin
 FUNC4(I);
end
else
if FuncList[Interp[i].Code].FType = 5 then
begin
 FUNC5(I);
end
else
//EXTERNAL FUNCTION
if {Interp[i].Code > LInternalFuncList}FuncList[Interp[i].Code].FType < 0 then
begin
{if E_OverFlow = True then OVF:=1 else OVF:=0; //  (FType = -5, NST <> -1)
// -    F_SaveStack = False: (  FType = -5,NST <> -1)
E_OverFlow:=True;
}
  //SR:=1;
  //     (EAX,EBX,ECX,EDX,ESP):
  if (FuncList[Interp[i].Code].FType <= -3) and   (FuncList[Interp[i].Code].FType >= -7) then
  begin
   AddFuncMEM(I);
  end
  else
  if (FuncList[Interp[i].Code].FType = -15)  then
  begin
   AddFuncMEMADR(I);
  end
  else
  //   Stack (FPU):
  if (FuncList[Interp[i].Code].FType = -8) then
  begin
   AddFuncFPU(I);
  end
  else
  //    Stack (CPU):
  if FuncList[Interp[i].Code].FType = -10 then
  begin
   AddFuncCPU(I);
  end
  else
  //    :
  if (FuncList[Interp[i].Code].FType <= -11) and   (FuncList[Interp[i].Code].FType >= -14) then
  begin
   AddFuncINF(I);
  end
  else
  //fl_PRECOMPILED:      
  if (FuncList[Interp[i].Code].FType = -16) then
  begin
   AddFuncPC(I);  SR:=0;
  end
  else
  if (FuncList[Interp[i].Code].FType = -17) then
  begin
   //IFNOP
   FAB12(I);   SR:=0;
  end
  else
  begin
   //ERROR
   //Wrong type additional function
  end;
   SaveFuncReg(I);{!!!}
   //if SR = 1 then begin SetReg(1); SetReg(2); SetReg(3); SetReg(4); end;
end;


end;



procedure TCompiler.AddFuncMEM(I: Integer);
label fin;
var
k,T,N,S,IdS: Integer;
Adr: TAddress;
begin
if ReadReplFunc(i) = True then   goto fin;

IdS:=0;
 if FuncList[Interp[i].Code].Arg  > 0 then
 begin
  //Adr:=0; {.203}
  //if F_Mode = C_Compile then Adr:=TAddress(@Func.Stack[Interp[i].S]);
  Adr:=GetStackAddr(Interp[i].S);   {.241}

  if FuncList[Interp[i].Code].FType = -3 then
  MOVA1(Adr)
  else
  if FuncList[Interp[i].Code].FType = -4 then
  MOVB1(Adr)
  else
  if FuncList[Interp[i].Code].FType = -5 then
  MOVC1(Adr)
  else
  if FuncList[Interp[i].Code].FType = -6 then
  MOVD1(Adr)
  else
  if (FuncList[Interp[i].Code].FType = -7) and (FuncList[Interp[i].Code].Set_Id = 1) then
  begin
    if FuncList[Interp[i].Code].Arrow = 1 then
    begin
      PUSHM(Adr);
      PUSHM(FuncList[Interp[i].Code].Id_Func);
    end
    else
    if FuncList[Interp[i].Code].Arrow = 0 then
    begin
      PUSHM(FuncList[Interp[i].Code].Id_Func);
      PUSHM(Adr);
    end;
    IdS:=1;
  end
  else
  if (FuncList[Interp[i].Code].FType = -7) then
  PUSHM(Adr);


  if (FuncList[Interp[i].Code].FType = -3) then
  MOVB1(TAddress(FuncList[Interp[i].Code].Addr))
  else
  MOVA1(TAddress(FuncList[Interp[i].Code].Addr));
 end;

 //    ( : _FPU)
 if F_SaveStack = True then
 begin
  //..  FPU-  :
  for k:=FuncList[Interp[i].Code].Arg downto 1 do
  begin
   //Adr:=0; {.203}
   //if F_Mode = C_Compile then Adr:=TAddress(@Func.Stack[Interp[I].S+k-1]);
   Adr:=GetStackAddr(Interp[I].S+k-1);    {.241}

   if Interp[I].RData[k-1] = _FPU then
   begin

    if FuncList[Interp[I].Code].ArgType = _Differ then
        T:=FuncList[Interp[I].Code].ArgTypeList[k-1]
    else
        T:=FuncList[Interp[I].Code].ArgType;

    if (F_Mode = C_Compile) and (F_CloseArg = True) then  S:=Interp[I].SNExtArg[k-1]
    else S:=0;

    FSTPM(Adr-S,T);
   end;
  end;
 end;


 if (FuncList[Interp[i].Code].Set_Id = 1) and (IdS = 0) then
 begin
  PUSHM(FuncList[Interp[i].Code].Id_Func);
 end;

 if (FuncList[Interp[i].Code].FType = -3) then CALLB else CALLA;


 if FuncList[Interp[i].Code].Set_Id = 1 then N:=4 else N:=0;
 if FuncList[Interp[i].Code].FType = -7  then N:=N+4;
 if FuncList[Interp[i].Code].CLST = 1 then ADDESP(N);


 //FAB12(I);

 if (FuncList[Interp[i].Code].NST <> -1)  and (F_SaveStack = True) then
 begin
  CheckStack(FuncList[Interp[i].Code].NST);
  CheckStack(-FuncList[Interp[i].Code].NST+1);                  // : (-NST+1)  
  if FuncList[Interp[i].Code].RetNum = _No then CheckStack(-1); // :   (+NST,-NST) {.237}
 end
 else
 E_OverFlow:=True;

 WriteReplFunc(i);

fin:
FAB12(I);
end;






procedure TCompiler.AddFuncMEMADR(I: Integer);
label fin;
var
k,T,N,S,IdS,NArg,Sn,j: Integer;
SAdr: array of Cardinal;
Adr: TAddress;
begin
if ReadReplFunc(i) = True then   goto fin;
IdS:=0;



 if FuncList[Interp[i].Code].Arg  > 0 then
 begin


   NArg:=FuncList[Interp[i].Code].Arg;
   Sn:=Interp[i].S;
   SetLength(Sadr,NArg);
   for j:=0 to NArg-1  do
   begin
    //Adr:=0;
    //if (F_Mode = C_Compile) then Adr:=TAddress(@Func.Stack[Sn+j]);  {.203}
    Adr:=GetStackAddr(Sn+j);      {.241}
    Sadr[j]:=Adr;
   end;


   if FuncList[Interp[i].Code].Arrow = {_BACK}1 then
   begin
     for j:=0 to  NArg-1 do
     begin
      PUSHM(Sadr[j]);
     end;
     if (FuncList[Interp[i].Code].Set_Id = 1) then PUSHM(FuncList[Interp[i].Code].Id_Func);
   end
   else
   if FuncList[Interp[i].Code].Arrow = {_RIGHT}0 then
   begin
     if (FuncList[Interp[i].Code].Set_Id = 1) then PUSHM(FuncList[Interp[i].Code].Id_Func);
     for j:=NArg-1 downto  0 do
     begin
      PUSHM(SAdr[j]);
     end;
   end;

   if FuncList[Interp[i].Code].Set_Id = 1 then IdS:=1;
 end;


 //    ( : _FPU)
 if F_SaveStack = True then
 begin
  //..  FPU-  :
  for k:=FuncList[Interp[i].Code].Arg downto 1 do
  begin
   if Interp[I].RData[k-1] = _FPU then
   begin

    if FuncList[Interp[I].Code].ArgType = _Differ then
        T:=FuncList[Interp[I].Code].ArgTypeList[k-1]
    else
        T:=FuncList[Interp[I].Code].ArgType;

    if (F_Mode = C_Compile) and (F_CloseArg = True) then  S:=Interp[I].SNExtArg[k-1]
    else S:=0;

    //Adr:=0;
    //if (F_Mode = C_Compile) then Adr:=TAddress(@Func.Stack[Interp[I].S+k-1]);  {.203}
    Adr:=GetStackAddr(Interp[I].S+k-1);  {.241}
    FSTPM(Adr-S,T);
   end;
  end;
 end;


 if (FuncList[Interp[i].Code].Set_Id = 1) and (IdS = 0) then
 begin
  PUSHM(FuncList[Interp[i].Code].Id_Func);
 end;

 MOVA1(TAddress(FuncList[Interp[i].Code].Addr));
 CALLA;

 if FuncList[Interp[i].Code].Set_Id = 1 then N:=4 else N:=0;
 N:=N+4*NArg;
 if FuncList[Interp[i].Code].CLST = 1 then ADDESP(N);


 //FAB12(I);

 if (FuncList[Interp[i].Code].NST <> -1)  and (F_SaveStack = True) then
 begin
  CheckStack(FuncList[Interp[i].Code].NST);
  CheckStack(-FuncList[Interp[i].Code].NST+1);                  // : (-NST+1)  
  if FuncList[Interp[i].Code].RetNum = _No then CheckStack(-1); // :   (+NST,-NST) {.237}
 end
 else
 E_OverFlow:=True;

 WriteReplFunc(i);

fin:
FAB12(I);
end;




procedure TCompiler.AddFuncCPU(I: Integer);
label fin;
var
k,SS,T,N,XCH,NS,VType,DS,Sz,F1,M1,Reg: Integer;

        procedure PUSHARG(VType,S: Integer);
        var
        Adr: TAddress;
        begin
           //Adr:=0; {.203}
           //if F_Mode = C_Compile then Adr:=TAddress(@Func.Stack[Interp[i].S+S]);
           Adr:=GetStackAddr(Interp[i].S+S); {.241}

           {.245}     {arraycpu}
           if (VType = _Integer) or (VType = _Address) or (VType = _ArrayD) or (VType = _ArrayE) or (VType = _ArrayS) or (VType = _ArrayI) then
            PUSHF(Adr)
           else
           if (VType = _Single)  then
            PUSHF(Adr)
           else
           if VType = _Double then
           begin
            PUSHF(Adr+4);
            PUSHF(Adr);
           end
           else
           if VType = _Extended then
           begin
            PUSHF(Adr+8);
            PUSHF(Adr+4);
            PUSHF(Adr);
           end
        end;




  procedure ArgInMEM_FPU(I,DS,Reg: Integer);
    var
      k,VType1,VType2,cn,SS,Sz,N,PS,f,ID: Integer;
    begin
      //Reg=_MEM - F_SaveStack=False

      PS:=0;

      if (FuncList[Interp[i].Code].ARROW = 1)  and
         (FuncList[Interp[i].Code].Set_Id = 1) then
      begin
         DS:=DS-4;
      end
      else
      if (FuncList[Interp[i].Code].ARROW = 0)  then
      begin
       DS:=0;
       if (FuncList[Interp[i].Code].Set_Id = 1) then
        PUSHM(FuncList[Interp[i].Code].Id_Func);
      end;


         N:=FuncList[Interp[i].Code].Arg-1;


         //  FPU-.:
       for k:=N downto 0 do
       begin
          if FuncList[Interp[i].Code].ArgType = _Differ then
             VType:=FuncList[Interp[i].Code].ArgTypeList[k] else
             VType:=FuncList[Interp[i].Code].ArgType;

          Sz:=SizeArg(VType);

          if  (Interp[I].RData[k] = _FPU) and (Reg <> _MEM) then
          begin
            if FuncList[Interp[i].Code].ARROW = 1 then
            begin
             FSTPESP(VType,-DS);
             DS:=DS-Sz;
            end
            else
            if FuncList[Interp[i].Code].ARROW = 0 then
            begin
             DS:=DS+Sz;
             FSTPESP(VType,-DS);
            end
          end
          else
          //if  Interp[I].RData[k] = _MEM then
          begin
             if FuncList[Interp[i].Code].ARROW = 1 then
                DS:=DS-SizeArg(VType)
             else
             if FuncList[Interp[i].Code].ARROW = 0 then
                DS:=DS+SizeArg(VType);
          end;
       end;


         for k:= 0 to N do
         begin
           if FuncList[Interp[i].Code].ARROW = 1 then cn:=k
           else
           if FuncList[Interp[i].Code].ARROW = 0 then cn:=N-k;

           if FuncList[Interp[i].Code].ArgType = _Differ then
              VType:=FuncList[Interp[i].Code].ArgTypeList[cn] else
              VType:=FuncList[Interp[i].Code].ArgType;


           if  (Interp[I].RData[cn] = _FPU) and (Reg <> _MEM) then
           begin
             PS:=PS+SizeArg(VType);
           end
           else
           //if  Interp[I].RData[cn] = _MEM then
           begin
             SUBESP(PS);
             PUSHARG(VType,cn);
             PS:=0;
           end;

         end;


      if (FuncList[Interp[i].Code].Set_Id = 1) then
      begin
        SUBESP(PS);
        if (FuncList[Interp[i].Code].ARROW = 1) then
         PUSHM(FuncList[Interp[i].Code].Id_Func);
      end
      else
      if (FuncList[Interp[i].Code].Set_Id = 0) then
         SUBESP(PS);

    end;


begin
if ReadReplFunc(i) = True then   goto fin;

//Id_Func -  : func(x1,...,xn,Id_Func);
NS:=0;
DS:=0;
//DS -      :
if FuncList[Interp[i].Code].ArgType = _Differ then
begin
 for k:=0 to  High(Interp[I].RData) do
 begin
   VType:=FuncList[Interp[i].Code].ArgTypeList[k];
     case VType of
     _Single:     DS:=DS+4;
     _Integer:    DS:=DS+4;
     _ArrayD:     DS:=DS+4;{.245}      {arraycpu}
     _ArrayE:     DS:=DS+4;
     _ArrayS:     DS:=DS+4;
     _ArrayI:     DS:=DS+4;
     _Address:    DS:=DS+4;
     _Double:     DS:=DS+8;
     _Extended:   DS:=DS+12;  //12 - .. PUSH EAX  PUSH AX (12  10) -   DELPHI
     end;
 end
end
else
begin
 VType:=FuncList[Interp[i].Code].ArgType;
 case VType of
  _Single:     Sz:=4;
  _Integer:    Sz:=4;
  _Address:    Sz:=4;
  _ArrayD:     Sz:=4; {.245}      {arraycpu}
  _ArrayE:     Sz:=4; {.245}
  _ArrayS:     Sz:=4; {.245}
  _ArrayI:     Sz:=4; {.245}
  _Double:     Sz:=8;
  _Extended:   Sz:=12;
 end;
 DS:=FuncList[Interp[i].Code].Arg*Sz;
end;

if FuncList[Interp[i].Code].Set_Id = 1 then DS:=DS+4;


//Reg=1(   FPU) ,Reg=2(   MEM), Reg=3(FPU&MEM)
M1:=0;F1:=0;
for k:=0 to  High(Interp[I].RData) do
begin
 if Interp[I].RData[k] = _MEM then M1:=1
 else
 if  Interp[I].RData[k] = _FPU then F1:=1
end;

if (F1 = 1) and (M1 = 0) then Reg:=1
else
if (F1 = 0) and (M1 = 1) then Reg:=2
else Reg:=3;

if (F_SaveStack = False) or (FuncList[Interp[i].Code].NST = -1) then Reg:=2;


ArgInMEM_FPU(I,DS,Reg);



 MOVA1(TAddress(FuncList[Interp[i].Code].Addr));
 CALLA;

 if FuncList[Interp[i].Code].CLST = 1 then
 begin
  ADDESP(DS);
 end;



 if (FuncList[Interp[i].Code].NST <> -1)  and (F_SaveStack = True) then
 begin
  CheckStack(FuncList[Interp[i].Code].NST);
  CheckStack(-FuncList[Interp[i].Code].NST+1);                  // : (-NST+1)  
  if FuncList[Interp[i].Code].RetNum = _No then CheckStack(-1); // :   (+NST,-NST) {.237}
 end
 else
 E_OverFlow:=True;

 WriteReplFunc(i);

fin:
FAB12(I);
end;




procedure TCompiler.AddFuncFPU(I: Integer);
label fin;
var
N,k: Integer;
Adr: TAddress;
begin
if ReadReplFunc(i) = True then   goto fin;

if (FuncList[Interp[i].Code].NST = -1) or (F_SaveStack = False) then
begin
    for k:= 0 to FuncList[Interp[i].Code].Arg-1 do
    begin
      //Adr:=0; {.203}
      //if F_Mode = C_Compile then Adr:=TAddress(@Func.Stack[Interp[i].S+k]);
      Adr:=GetStackAddr(Interp[i].S+k); {.241}

      if FuncList[Interp[i].Code].ArgType = _Differ then
       FLD(Adr,FuncList[Interp[i].Code].ArgTypeList[k])
      else
       FLD(Adr,FuncList[Interp[i].Code].ArgType);
    end;
end;
//      DL  

 if FuncList[Interp[i].Code].Set_Id = 1 then
 begin
  PUSHM(FuncList[Interp[i].Code].Id_Func);
 end;


 {
 MOVA1(TAddress(FuncList[Interp[i].Code].Addr));
 CALLA;
 }
 {.243} // inline
  if FuncList[Interp[I].Code].inl = 1 then
  begin
     for k:=0 to High(FuncList[Interp[I].Code].inlCode) do
     begin
       AddByte(FuncList[Interp[I].Code].inlCode[k]);
     end
   end
   else
   begin
      MOVA1(TAddress(FuncList[Interp[i].Code].Addr));
      CALLA;
   end;


 if FuncList[Interp[i].Code].Set_Id = 1 then N:=4 else N:=0;
 if FuncList[Interp[i].Code].CLST = 1 then ADDESP(N);


 //FAB12(I);


 if (FuncList[Interp[i].Code].NST <> -1)  and (F_SaveStack = True) then
 begin
  CheckStack(FuncList[Interp[i].Code].NST);
  CheckStack(-(FuncList[Interp[i].Code].NST+FuncList[Interp[i].Code].Arg)+1);  // : (-(NST+ARG)+1)  
  if FuncList[Interp[i].Code].RetNum = _No then CheckStack(-1);                // :   (+NST+ARG,-NST-ARG) {.237}
 end
 else
 E_OverFlow:=True;

  WriteReplFunc(i);

fin:
FAB12(I);
end;





procedure TCompiler.AddFuncINF(I: Integer);
label fin;
var
CT,k,T,N,DS: Integer;
S: Cardinal;
Adr: TAddress;
begin
if ReadReplFunc(i) = True then   goto fin;

//    ( : _FPU)
 if F_SaveStack = True then
 begin
  //..  FPU-  :
  for k:=Interp[i].N downto 1 do
  begin
   if Interp[I].RData[k-1] = _FPU then
   begin

    if (F_Mode = C_Compile) and (F_CloseArg = True) then  S:=Interp[I].SNExtArg[k-1]
    else S:=0;

    //Adr:=0;                                                                  {.203}
    //if (F_Mode = C_Compile) then Adr:=TAddress(@Func.Stack[Interp[I].S+k-1]);
    Adr:=GetStackAddr(Interp[I].S+k-1); {.241}
    T:=FuncList[Interp[I].Code].ArgType;
    FSTPM(Adr-S,T);

   end;
  end;
 end;


DS:=0;
//Infinite EAX,EBX
if -FuncList[Interp[i].Code].FType = 11 then
begin
 //Adr:=0; {.203}
 //if F_Mode = C_Compile then Adr:=TAddress(@Func.Stack[Interp[i].S]);
 Adr:=GetStackAddr(Interp[i].S); {.241}
 MOVA1(Adr);
 MOVB1(Interp[i].N);
 MOVC1(TAddress(FuncList[Interp[i].Code].Addr));
 CT:=1;
end
else
//Infinite EBX,ECX
if -FuncList[Interp[i].Code].FType = 12 then
begin
 //Adr:=0; {.203}
 //if F_Mode = C_Compile then Adr:=TAddress(@Func.Stack[Interp[i].S]);
 Adr:=GetStackAddr(Interp[i].S); {.241}
 MOVB1(Adr);
 MOVC1(Interp[i].N);
 MOVA1(TAddress(FuncList[Interp[i].Code].Addr));
 CT:=0;
end
else
//Infinite ECX,EDX
if -FuncList[Interp[i].Code].FType = 13 then
begin
 //Adr:=0; {.203}
 //if F_Mode = C_Compile then Adr:=TAddress(@Func.Stack[Interp[i].S]);
 Adr:=GetStackAddr(Interp[i].S); {.241}
 MOVC1(Adr);
 MOVD1(Interp[i].N);
 MOVA1(TAddress(FuncList[Interp[i].Code].Addr));
 CT:=0;
end
else
//Infinite Stack (Adr,Length,[ID])
if -FuncList[Interp[i].Code].FType = 14 then
begin

 if  FuncList[Interp[i].Code].ARROW = 0  then
 begin
  if FuncList[Interp[i].Code].Set_Id = 1 then
  begin
   PUSHM(FuncList[Interp[i].Code].Id_Func);
  end;
  PUSHM(Interp[i].N);
  //Adr:=0;
  //if (F_Mode = C_Compile) then Adr:=TAddress(@Func.Stack[Interp[i].S]); {.203}
  Adr:=GetStackAddr(Interp[i].S); {.241}
  PUSHM(Adr);
 end
 else
 if  FuncList[Interp[i].Code].ARROW = 1  then
 begin
  //Adr:=0; {.203}
  //if F_Mode = C_Compile then Adr:=TAddress(@Func.Stack[Interp[i].S]);
  Adr:=GetStackAddr(Interp[i].S); {.241}

  PUSHM(Adr);
  PUSHM(Interp[i].N);
  if FuncList[Interp[i].Code].Set_Id = 1 then
  begin
   PUSHM(FuncList[Interp[i].Code].Id_Func);
  end;
 end;

 MOVA1(TAddress(FuncList[Interp[i].Code].Addr));
 DS:=8;
 CT:=0;
end;



//: arg=-1(INFINITE), ..   - arg=  .  -
//ExternalFuncList[Interp[i].FI].arg:=-1;

if (FuncList[Interp[i].Code].Set_Id = 1) and (DS = 0) then
   PUSHM(FuncList[Interp[i].Code].Id_Func);

if CT = 1 then CALLC else CALLA;

if FuncList[Interp[i].Code].Set_Id = 1 then DS:=DS+4;

if FuncList[Interp[i].Code].CLST = 1 then ADDESP(DS);



//FAB12(I);

if (FuncList[Interp[i].Code].NST <> -1)  and (F_SaveStack = True) then
begin
  CheckStack(FuncList[Interp[i].Code].NST);
  CheckStack(-FuncList[Interp[i].Code].NST+1);                  // : (-NST+1)  
  if FuncList[Interp[i].Code].RetNum = _No then CheckStack(-1); // :   (+NST,-NST) {.237}
end
else
E_OverFlow:=True;

WriteReplFunc(i);

fin:
FAB12(I);
end;




procedure TCompiler.AddFuncPC(I: Integer);
label fin;
var
k,T,N,S,IdS: Integer;
Adr: TAddress;
begin
if ReadReplFunc(i) = True then   goto fin;

 //    ( : _FPU)
if F_SaveStack = True then
begin

  //..  FPU-  :
  for k:=FuncList[Interp[i].Code].Arg downto 1 do
  begin

    if Interp[I].RData[k-1] = _FPU then
    begin

      if FuncList[Interp[I].Code].ArgType = _Differ then
         T:=FuncList[Interp[I].Code].ArgTypeList[k-1]
      else
         T:=FuncList[Interp[I].Code].ArgType;

      {if (F_Mode = C_Compile) and (F_CloseArg = True) then  S:=Interp[I].SNExtArg[k-1]
      else S:=0; }

      //FSTPM(TAddress(@Func.Stack[Interp[I].S+k-1])-S,T);
      FSTPM(FuncList[Interp[I].Code].ArgAdr[k-1],T);
   end;

  end;
  //      
  for k:=FuncList[Interp[i].Code].Arg downto 1 do
  begin

    if Interp[I].RData[k-1] = _MEM then
    begin

      if FuncList[Interp[I].Code].ArgType = _Differ then
         T:=FuncList[Interp[I].Code].ArgTypeList[k-1]
      else
         T:=FuncList[Interp[I].Code].ArgType;

      if (F_Mode = C_Compile) and (F_CloseArg = True) then  S:=Interp[I].SNExtArg[k-1]
      else S:=0;

      //Adr:=0; {.203}
      //if F_Mode = C_Compile then Adr:=TAddress(@Func.Stack[Interp[I].S+k-1]);
      Adr:=GetStackAddr(Interp[I].S+k-1); {.241}

      if (T = _ArrayD) or (T = _ArrayE) or (T = _ArrayS) or (T = _ArrayI)  then   {arraycpu}    {.245}
      begin
         PUSHF(Adr);
         POPF(FuncList[Interp[I].Code].ArgAdr[k-1]);
      end
      else
      begin
        FLD(Adr-S,T);
        FSTPM(FuncList[Interp[I].Code].ArgAdr[k-1],T);
      end;

   end;

  end;

end
else
if F_SaveStack = False then //      
begin
   for k:=FuncList[Interp[i].Code].Arg downto 1 do
  begin

    //if Interp[I].RData[k-1] = _FPU then
    begin

      if FuncList[Interp[I].Code].ArgType = _Differ then
         T:=FuncList[Interp[I].Code].ArgTypeList[k-1]
      else
         T:=FuncList[Interp[I].Code].ArgType;

      if (F_Mode = C_Compile) and (F_CloseArg = True) then  S:=Interp[I].SNExtArg[k-1]
      else S:=0;

      //Adr:=0; {.203}
      //if F_Mode = C_Compile then Adr:=TAddress(@Func.Stack[Interp[I].S+k-1]);
      Adr:=GetStackAddr(Interp[I].S+k-1); {.241}

      if (T = _ArrayD) or (T = _ArrayE) or (T = _ArrayS) or (T = _ArrayI)  then    {arraycpu}    {.245}
      begin
         PUSHF(Adr);
         POPF(FuncList[Interp[I].Code].ArgAdr[k-1]);
      end
      else
      begin
        FLD(Adr-S,T);
        FSTPM(FuncList[Interp[I].Code].ArgAdr[k-1],T);
      end;

   end;

  end;
end;




 MOVA1(TAddress(FuncList[Interp[I].Code].Addr));
 CALLA;




 //FAB12(I);

 if (FuncList[Interp[i].Code].NST <> -1)  and (F_SaveStack = True) then
 begin
   CheckStack(FuncList[Interp[i].Code].NST);
   CheckStack(-FuncList[Interp[i].Code].NST+1);                  // : (-NST+1)  
   if FuncList[Interp[i].Code].RetNum = _No then CheckStack(-1); // :   (+NST,-NST) {.237}
 end
 else
 E_OverFlow:=True;


 WriteReplFunc(i);

fin:
FAB12(I);
end;



function TCompiler.ReadReplFunc(i: integer): Boolean;
var
Adr: TAddress;
begin
// :
if Interp[i].RCS = 1 then
  begin
   Adr:=0;
   if F_Mode = C_Compile then Adr:=TAddress(@Func.CpSt[Interp[i].MRCS]);{.203}

   FLD(Adr,F_DataType);
   ReadReplFunc:=True;
  end
  else
  ReadReplFunc:=False;
end;


procedure TCompiler.WriteReplFunc(i: integer);
var
L: integer;
N: TAddress;
begin
// .        .  : FUNC1,FUNC2,FUNC3,FUNC4
if F_EnableSave = True  then  {.205}  //sin(x)+sin(x); sin(argf)+sin(argf)
begin
 N:=0;
 // :
   L:=Length(Interp[i].AWCS);
   if (L = 1)   then
   begin
    if (Interp[i].AWCS[0].WCS = 1) then
    begin
     if F_Mode = C_Compile {.203} then  N:=TAddress(@Func.CpSt[Interp[i].AWCS[0].MWCS]);
     FSTM(N,F_DataType);
    end;
   end;
end;
end;




procedure TCompiler.POPFPU;
var
i,adr: Cardinal;
begin
adr:=Cardinal(@SFPU[1]);
 for i:=0 to N_Stack do
 begin
  FSTPM(adr+i*SizeS,F_DataType);
 end;
end;


procedure TCompiler.PUSHFPU;
var
i,adr: Cardinal;
begin
adr:=Cardinal(@SFPU[1]);
 for i:=0 to N_Stack do
 begin
  FLD(adr+i*SizeS,F_DataType);
 end;
end;



procedure TCompiler.AddByte(B: Byte);
var
j: Integer;
begin
if F_Mode = C_Compile then
begin
 j:=High(ICOMP)+1;
 SetLength(ICOMP,Length(ICOMP)+1);
 ICOMP[j]:=B;
end;
end;



procedure TCompiler.AddWord(B1: Byte; B2: Byte);
var
j: Integer;
begin
if F_Mode = C_Compile then
begin
 j:=High(ICOMP)+1;
 SetLength(ICOMP,Length(ICOMP)+2);
 ICOMP[j]:=B1; ICOMP[j+1]:=B2;
end;
end;



procedure TCompiler.AddCom(B1: Byte);
begin
if F_Mode = C_Compile then
begin
 SetLength(ICOMP,Length(ICOMP)+1);
 ICOMP[High(ICOMP)]:=B1;
end;
end;

procedure TCompiler.AddCom(B1,B2: Byte);
begin
if F_Mode = C_Compile then
begin
 SetLength(ICOMP,Length(ICOMP)+2);
 ICOMP[High(ICOMP)-1]:=B1; ICOMP[High(ICOMP)]:=B2;
end;
end;

procedure TCompiler.AddCom(B1,B2,B3: Byte);
begin
if F_Mode = C_Compile then
begin
 SetLength(ICOMP,Length(ICOMP)+3);
 ICOMP[High(ICOMP)-2]:=B1; ICOMP[High(ICOMP)-1]:=B2; ICOMP[High(ICOMP)]:=B3;
end;
end;

procedure TCompiler.AddCom(B1: Byte; Adr: TAddress);
var
P: ^Cardinal;
begin
if F_Mode = C_Compile then
begin
 SetLength(ICOMP,Length(ICOMP)+5);
 ICOMP[High(ICOMP)-4]:=B1;
 P:=@ICOMP[High(ICOMP)-3];
 P^:=Adr;
end;
end;


procedure TCompiler.AddCom(B1,B2: Byte; Adr: TAddress);
var
P: ^Cardinal;
begin
if F_Mode = C_Compile then
begin
 SetLength(ICOMP,Length(ICOMP)+6);
 ICOMP[High(ICOMP)-5]:=B1; ICOMP[High(ICOMP)-4]:=B2;
 P:=@ICOMP[High(ICOMP)-3];
 P^:=Adr;
end;
end;

procedure TCompiler.AddCom(B1,B2,B3: Byte; Adr: TAddress);
var
P: ^Cardinal;
begin
if F_Mode = C_Compile then
begin
 SetLength(ICOMP,Length(ICOMP)+7);
 ICOMP[High(ICOMP)-6]:=B1; ICOMP[High(ICOMP)-5]:=B2; ICOMP[High(ICOMP)-4]:=B3;
 P:=@ICOMP[High(ICOMP)-3];
 P^:=Adr;
end;
end;


procedure TCompiler.AddCom(B1,B2,B3: Byte; N: Integer);
var
P: ^Integer;
begin
if F_Mode = C_Compile then
begin
 SetLength(ICOMP,Length(ICOMP)+7);
 ICOMP[High(ICOMP)-6]:=B1; ICOMP[High(ICOMP)-5]:=B2; ICOMP[High(ICOMP)-4]:=B3;
 P:=@ICOMP[High(ICOMP)-3];
 P^:=N;
end;
end;


procedure TCompiler.AddCom(B1: Byte; N: Integer);
var
P: ^Integer;
begin
if F_Mode = C_Compile then
begin
 SetLength(ICOMP,Length(ICOMP)+5);
 ICOMP[High(ICOMP)-4]:=B1;
 P:=@ICOMP[High(ICOMP)-3];
 P^:=N;
end;
end;


procedure TCompiler.AddCom(B1,B2: Byte; N: Integer);
var
P: ^Integer;
begin
if F_Mode = C_Compile then
begin
 SetLength(ICOMP,Length(ICOMP)+6);
 ICOMP[High(ICOMP)-5]:=B1; ICOMP[High(ICOMP)-4]:=B2;
 P:=@ICOMP[High(ICOMP)-3];
 P^:=N;
end;
end;


procedure TCompiler.FLD(N: TAddress; VType: Integer);
begin
case VType of
_Single:    AddCom($D9,$05,N);
_Double:    AddCom($DD,$05,N);
_Extended:  AddCom($DB,$2D,N);
_Integer:   AddCom($DB,$05,N);
_Address:   AddCom($DB,$05,N);
end;

if (VType <> _ArrayD) and (VType <> _ArrayE) and (VType <> _ArrayS) and (VType <> _ArrayI)
   then CheckStack(1);
end;


procedure TCompiler.FSTPM(N: TAddress; VType: Integer);
begin
F_SData:=_MEM;

case VType of
_Single:   AddCom($D9,$1D,N);
_Extended: AddCom($DB,$3D,N);
_Double:   AddCom($DD,$1D,N);
_Integer:  AddCom($DB,$1D,N);
_Address:  AddCom($DB,$1D,N);
end;

if (VType <> _ArrayD) and (VType <> _ArrayE) and (VType <> _ArrayS) and (VType <> _ArrayI)
   then  CheckStack(-1);
end;



procedure TCompiler.AddEndCommand(I: Integer);
label endp;
var
N,J,S,SS,ArgT: Integer;
AdrN: TAddress;    {.203}
begin

F_SData:=_FPU;
//   IFNOP    FPU ( IFNOP  NAN)
if CheckIfRet(I) then goto endp;
if Interp[i].CODE = C_JMP then goto endp;
if FuncList[Interp[i].CODE].RetNum = _NO then goto endp;

//if Interp[i].ExtArg = _Compiled then begin RET; goto endp; end;


 if F_SaveStack = False then
 begin
  if Interp[i].CODE = C_PACKAGE then goto endp;
  if Interp[i].Neg = 1  then FCHS;

  //    :
  //(1)  ( )
  //(2) 
  //(3)  - : Func[I]^.FType < 0
  //  :
  //  - (Func[LFunc-1])
  //  NOP,JMP,PACKAGE

  if  (I < LFunc-1)   then
  begin
   if ((Interp[I+1].S <> Interp[i].S) or (Interp[I+1].N > 1) or
      (FuncList[Interp[I+1].Code].FType < 0 )) and
      (Interp[i].Code <> C_NOP) then
   begin
    //AdrN:=TAddress(@Func.Stack[Interp[i].S]);
    AdrN:=GetStackAddr(Interp[i].S); {.241}
    //  :
    if Interp[I].ExtArg = _None  then
       FSTPM(AdrN,F_DataType)
    else
    // -:
    begin
        ArgT:=Interp[i].ExtArg;   {arraycpu} {.245}
        if (ArgT <> _ArrayD) and (ArgT <> _ArrayE) and (ArgT <> _ArrayS) and (ArgT <> _ArrayI)  then
        begin
          S:=Interp[I].S;
         //AdrN:=TAddress(@Func.Stack[S])-Interp[i].SExtArg;
          AdrN:=GetStackAddr(S)-Interp[i].SExtArg; {.241}
          FSTPM(AdrN,Interp[i].ExtArg);
        end;
    end;
   end
  end
 end

 else

 if F_SaveStack = True then
 begin
  if Interp[I].SData = _FPU then
  begin
   if {Interp[i].NL > 1} IsLevelLoad(I)  then
   begin  //ADD,SUB
    if (Interp[i].I = _SUB) and (Interp[i].Neg = 0)  then FSUB
    else
    if (Interp[i].I = _SUB) and (Interp[i].Neg = 1)  then FADD
    else
    if (Interp[i].I = _NOP) and (Interp[i].Neg = 1)   then FCHS
    else
    if (Interp[i].I = _ADD) and (Interp[i].Neg = 1)   then FSUB
    else
    if Interp[i].I = _ADD  then FADD
    else
    begin  //MUL,DIV
     if Interp[i].Neg = 1   then FCHS;

     if Interp[i].I = _MUL then FMULP1
     else
     if Interp[i].I = _DIV then FDIVP
     else
     if Interp[i].I = _DIVR then FDIVRP;
    end;
   end
   else
   //    
   begin
    if (Interp[i].I = _SUB)  and (Interp[i].Neg = 0)  then FCHS
    else
    if (Interp[i].I <> _SUB) and (Interp[i].Neg = 1)  then FCHS;
  end;
  end
  //SData = _MEM
  else
  if Interp[I].SData = _MEM then
  begin
    if Interp[I].Neg = 1   then FCHS;
    //AdrN:=0;
    //if F_Mode = C_Compile then  AdrN:=TAddress(@Func.Stack[Interp[I].S]);   {.203}
    AdrN:=GetStackAddr(Interp[I].S); {.241}
    //  :
    if Interp[I].ExtArg = _None  then
    FSTPM(AdrN,F_DataType)
    else
    //   -:
    begin
        ArgT:=Interp[i].ExtArg;   {arraycpu} {.245}
        if (ArgT <> _ArrayD) and (ArgT <> _ArrayE) and (ArgT <> _ArrayS) and (ArgT <> _ArrayI)  then
        begin
          S:=Interp[i].S;
           //AdrN:=0;
          //if F_Mode = C_Compile then  AdrN:=TAddress(@Func.Stack[S])-Interp[i].SExtArg;  {.203}
          AdrN:=GetStackAddr(S)-Interp[i].SExtArg; {.241}
          FSTPM(AdrN,Interp[i].ExtArg);
        end;
    end;
  end;
 end;

endp:
Interp[I].SData1:=F_SData;
end;




function TCompiler.CheckIfRet(N: Integer): Boolean;
begin
if F_Mode = C_Compile then
begin
{if Interp[N].NM > Length(Interp) then !!!ERROR
begin
 Interp[0].NM:=0;
end; }

  if Interp[Interp[N].NM].code = C_IFNOP then
     begin
       if (Interp[N].NL = 4) or (Interp[N].NL = 6) then   CheckIfRet:=True
       else
       CheckIfRet:=False;
     end
  else
  CheckIfRet:=False;
end
else
CheckIfRet:=False;
end;



procedure TCompiler.AddAddress(Adr: TAddress);
var
AB: TArray4;
j: Integer;
P: ^Cardinal;
begin
if F_Mode = C_Compile then
begin
 j:=High(ICOMP)+1;
 SetLength(ICOMP,Length(ICOMP)+4);
 P:=@ICOMP[j];
 P^:=Adr;
end;
end;




procedure TCompiler.AddInteger(Int: Integer);
var
AB: TArray4;
j: Integer;
P: ^Integer;//Pointer;
begin
if F_Mode = C_Compile then
begin
 j:=High(ICOMP)+1;
 SetLength(ICOMP,Length(ICOMP)+4);
 P:=@ICOMP[j];
 P^:=Int;
end;
end;



procedure TCompiler.FAVB(I: Integer);
label endp;
begin
if ReadReplFunc(i) = True then   goto endp;     {.201}


if Interp[i].V1 <> 0 then
begin
 FLD(TAddress(Interp[i].FV1),GetVarType(Interp[i].FV1));
 if  (Interp[i].V1 <> 1) and (Interp[i].V1 <> -1) then
 FMUL(Interp[i].V1,WriteData(Interp[i].V1,_Float,_MulDiv),F_ParamType);
 if Interp[i].V2 <> 0 then
 begin
  if Interp[i].V1 = -1 then
  FSUBR(WriteData(Interp[i].V2,_Float,_AddSub),F_ParamType)
  else
  FADD(Interp[i].V2,WriteData(Interp[i].V2,_Float,_AddSub),F_ParamType);
 end
 else
 if (Interp[i].V1 = -1) then FCHS;
end
else
FLD(WriteData(Interp[i].V2,_Float,_Load),F_ParamType);


WriteReplFunc(i);   {.201}

endp:
end;



procedure TCompiler.FAVBM(I,k: Integer);
//  MUL
begin
FLD(TAddress(Interp[i].AFB[k].PF),GetVarType(Interp[i].AFB[k].PF));

if Interp[i].AFB[k].A = -1 then
   FSUBR(WriteData(Interp[i].AFB[k].B,_Float,_AddSub),F_ParamType)
else
  begin
    FMUL(Interp[i].AFB[k].A,WriteData(Interp[i].AFB[k].A,_Float,_MulDiv),F_ParamType);
    FADD(Interp[i].AFB[k].B,WriteData(Interp[i].AFB[k].B,_Float,_AddSub),F_ParamType);
  end;
end;




procedure TCompiler.FAVBM1(I: Integer);
//  MUL
begin
FLD(TAddress(Interp[i].PM[1]),GetVarType(Interp[i].PM[1]));

if Interp[i].PN[1] = -1 then
begin
   if Interp[i].PN[2] = 0 then FCHS
   else
   FSUBR(WriteData(Interp[i].PN[2],_Float,_AddSub),F_ParamType);
end
else
  begin
    FMUL(Interp[i].PN[1],WriteData(Interp[i].PN[1],_Float,_MulDiv),F_ParamType);
    FADD(Interp[i].PN[2],WriteData(Interp[i].PN[2],_Float,_AddSub),F_ParamType);
  end;
end;


function TCompiler.FAVB1(I: Integer): Boolean;
begin
FAVB1:=False;
if Interp[i].F1 <> 0 then
begin
 if Interp[i].F1 = 1 then
 begin
  FADD(TAddress(Interp[i].FV1),GetVarType(Interp[i].FV1));
  FADD(Interp[i].F2,WriteData(Interp[i].F2,_Float,_AddSub),F_ParamType);
 end
 else
 if  Interp[i].F1 = -1 then
 begin
  FSUB(TAddress(Interp[i].FV1),GetVarType(Interp[i].FV1));
  FADD(Interp[i].F2,WriteData(Interp[i].F2,_Float,_AddSub),F_ParamType);
 end
 else
 begin
  FLD(TAddress(Interp[i].FV1),GetVarType(Interp[i].FV1));
   FMUL(Interp[i].F1,WriteData(Interp[i].F1,_Float,_MulDiv),F_ParamType);
  FADD(Interp[i].F2,WriteData(Interp[i].F2,_Float,_AddSub),F_ParamType);
  FADD;
 end;

FAVB1:=True;
end
else
if Interp[i].F2 <> 0 then
begin
FADD(WriteData(Interp[i].F2,_Float,_AddSub),F_ParamType);
FAVB1:=True;
end;
end;



procedure TCompiler.FCHS;
begin
AddWord($D9,$E0);
end;







procedure TCompiler.FAVBF(I: Integer);
begin
FAVB(I);
end;



procedure TCompiler.FAVBF1(I: Integer);
begin
if Interp[i].V3 <> 0 then
begin
 FLD(TAddress(Interp[i].FV2),GetVarType(Interp[i].FV2));
 if  (Interp[i].V3 <> 1) and (Interp[i].V3 <> -1) then
 FMUL(Interp[i].V3,WriteData(Interp[i].V3,_Float,_MulDiv),F_ParamType);
 if Interp[i].V4 <> 0 then
 begin
  if Interp[i].V3 = -1 then
  FSUBR(WriteData(Interp[i].V4,_Float,_AddSub),F_ParamType)
  else
  FADD(Interp[i].V4,WriteData(Interp[i].V4,_Float,_AddSub),F_ParamType);
 end
 else
 if (Interp[i].V3 = -1) then FCHS;
end
else
FLD(WriteData(Interp[i].V4,_Float,_Load),F_ParamType);
end;





procedure TCompiler.FAB12(I: Integer);
begin
FMUL(Interp[i].F1,WriteData(Interp[i].F1,_Float,_MulDiv),F_ParamType);
FADD(Interp[i].F2,WriteData(Interp[i].F2,_Float,_AddSub),F_ParamType);
end;




procedure TCompiler.ASB(I: Integer);
begin
if Interp[i].F1 = -1 then AddWord($D9,$E0) else
if Interp[i].F1 <> 1 then
begin
 FADD(Interp[i].F1,WriteData(Interp[i].F1,_Float,_AddSub),F_ParamType);
end;

FADD(Interp[i].F2,WriteData(Interp[i].F2,_Float,_AddSub),F_ParamType);
end;




procedure TCompiler.FMUL(X: TFloatType; N: TAddress; VType: Integer);
begin
if X = -1 then FCHS else
if (X <> 1) {and (X <> 0)} then
begin
 FMUL(N,VType);
end;
end;


procedure TCompiler.FADD(X: TFloatType; N: TAddress; VType: Integer);
begin
if X <> 0 then
begin
 FADD(N,VType);
end;
end;


procedure TCompiler.FADD;
begin
 AddCom($DE,$C1);
 CheckStack(-1);
end;


procedure TCompiler.FADD2;
begin
 AddCom($D8,$C2);
end;


procedure TCompiler.FSUB;
begin
 AddCom($DE,$E9);
 CheckStack(-1);
end;


procedure TCompiler.FSUB(N: TAddress; VType: Integer);
begin
 if VType = _Extended then
 begin
  FLD(N,_Extended);
  FSUBP;
 end
 else
 if VType = _Double then
 begin
  AddCom($DC,$25,N);
 end
 else
 if VType = _Single then
 begin
   AddCom($D8,$25,N);
 end;
end;






procedure TCompiler.FSUBRP;
begin
 AddWord($DE,$E1);
 CheckStack(-1);
end;


procedure TCompiler.FSUBP;
begin
 AddWord($DE,$E9);
 CheckStack(-1);
end;


procedure TCompiler.FSUBR(N: TAddress; VType: Integer);
begin
 if VType = _Extended then
 begin
  FLD(N,VType);
  FSUBRP;
 end
 else
 if VType = _Double then
 begin
  AddCom($DC,$2D,N);
 end
 else
 if VType = _Single then
 begin
   AddCom($D8,$2D,N);
 end;
end;



procedure TCompiler.FMULP1;
begin
 AddWord($DE,$C9);
 CheckStack(-1);
end;

procedure TCompiler.FDIVP;
begin
 AddCom($DE,$F9);
 CheckStack(-1);
end;

procedure TCompiler.FDIVRP;
begin
 AddCom($DE,$F1);
 CheckStack(-1);
end;


procedure TCompiler.FDIVR1;
begin
 AddCom($DC,$3D);
 AddAddress(TAddress(@C1));
end;


procedure TCompiler.FDIV(N: TAddress; VType: Integer);
begin
 if VType = _Extended then
 begin
  FLD(N,_Extended);
  FDIVP;
 end
 else
 if VType = _Double  then
 begin
  AddCom($DC,$35,N);
 end
 else
 if VType = _Single then
 begin
   AddCom($D8,$35,N);
 end;
end;

procedure TCompiler.FDIVR(N: TAddress; VType: Integer);
begin
 if VType = _Extended then
 begin
 FLD(N,_Extended);
 FDIVRP;
 end
 else
 if VType = _Double then
 begin
 AddCom($DC,$3D,N);
 end
 else
 if VType = _Single then
 begin
   AddCom($D8,$3D,N);
 end;
end;



procedure TCompiler.FMUL(N: TAddress; VType: Integer);
begin
 if VType = _Extended then
 begin
  FLD(N,_Extended);
  FMULP1;
 end
 else
 if VType = _Double then
 begin
  AddCom($DC,$0D,N);
 end
 else
 if VType = _Single then
 begin
  AddCom($D8,$0D,N);
 end;
end;




procedure TCompiler.FADD(N: TAddress; VType: Integer);
begin
 if VType = _Extended then
 begin
  FLD(N,_Extended);
  FADD;
 end
 else
 if VType = _Double then
 begin
  AddCom($DC,$05,N);
 end
 else
 if VType = _Single then
 begin
   AddCom($D8,$05,N);
 end;
end;




procedure TCompiler.FMUL0;
begin
 AddWord($D8,$C8);
end;




procedure TCompiler.FMULZ;
begin
  FMUL(Cardinal(@D_Zero),_Double);
end;



procedure TCompiler.MAF(I: Integer);
label endp;
var
k: Integer;
begin
if ReadReplFunc(i) = True then   goto endp;      {.201}

FLD(TAddress(Interp[i].PM[1]),GetVarType(Interp[i].PM[1]));
for k:=2 to High(Interp[i].PM) do
begin
 FMUL(TAddress(Interp[i].PM[k]),GetVarType(Interp[i].PM[k]));
end;

FMUL(Interp[i].V1,WriteData(Interp[i].V1,_Float,_MulDiv),F_ParamType);
FADD(Interp[i].V2,WriteData(Interp[i].V2,_Float,_AddSub),F_ParamType);

WriteReplFunc(i);         {.201}
endp:
end;



procedure TCompiler.AAF(I: Integer);
label endp;
var
k,H: Integer;
begin
if ReadReplFunc(i) = True then   goto endp;   {.201}


FLD(TAddress(Interp[i].PM[1]),GetVarType(Interp[i].PM[1]));
H:=High(Interp[i].PN);


if Interp[i].PN[H] <> 0 then
begin
 if Interp[i].PN[1] = -1 then
 FSUBR(WriteData(Interp[i].PN[H],_Float,_AddSub),F_ParamType)
 else
 begin
  FMUL(Interp[i].PN[1],WriteData(Interp[i].PN[1],_Float,_MulDiv),F_ParamType);
  FADD(Interp[i].PN[H],WriteData(Interp[i].PN[H],_Float,_AddSub),F_ParamType);
 end;
end
else
begin
 if Interp[i].PN[1] = -1 then FCHS else
 if Interp[i].PN[1] <> 1 then
  FMUL(Interp[i].PN[1],WriteData(Interp[i].PN[1],_Float,_MulDiv),F_ParamType);
end;


for k:=2 to High(Interp[i].PM) do
begin
 if Interp[i].PN[k] = -1 then
  FSUB(TAddress(Interp[i].PM[k]),GetVarType(Interp[i].PM[k]))
 else
 if Interp[i].PN[k] = 1  then
  FADD(TAddress(Interp[i].PM[k]),GetVarType(Interp[i].PM[k]))
 else
 begin
  FLD(TAddress(Interp[i].PM[k]),GetVarType(Interp[i].PM[k]));
  FMUL(Interp[i].PN[k],WriteData(Interp[i].PN[k],_Float,_MulDiv),F_ParamType);
  FADD;
 end;
end;


 WriteReplFunc(i);    {.201}
endp:
end;




procedure TCompiler.ADD(I: Integer);
label endp;

var
k,j,LL,s: Integer;
BF: Boolean;
Adr:TAddress;
begin
if ReadReplFunc(i) = True then   goto endp;

  if F_SaveStack = False then
  begin

   //    -  ST(0),  :
   j:=Interp[i].S;
   if Interp[i].N > 1 then
   begin
     //Adr:=0;
     //if F_Mode = C_Compile then Adr:=TAddress(@Func.Stack[j]);      {.203}
     Adr:=GetStackAddr(j); {.241}
     FLD(Adr,F_DataType);
   end;

   if  Interp[i].SGN[0] = _SUB   then FCHS;

   j:=1;
   for k:=Interp[i].S+1 to Interp[i].S+Interp[i].N-1 do
   begin
    //Adr:=0;
    //if F_Mode = C_Compile then Adr:=TAddress(@Func.Stack[k]);         {.203}
    Adr:=GetStackAddr(k); {.241}

    if  Interp[i].SGN[j] = _ADD then FADD(Adr,F_DataType)
    else
    if  Interp[i].SGN[j] = _SUB then FSUB(Adr,F_DataType);
    inc(j);
   end;

  end
  else
  //   ,    (SData = _MEM):
  if F_SaveStack = True then
  begin
   LL:=0; S:=Interp[I].S;
   for j:=0 to High(Interp[I].RData) do
   begin
    if Interp[I].RData[j] = _FPU then LL:=1;
   end;


   for j:=0 to High(Interp[I].RData) do
   begin
     //Adr:=0; {.203}
     //if F_Mode = C_Compile then  Adr:=TAddress(@Func.Stack[S]);
     Adr:=GetStackAddr(S); {.241}

     if Interp[I].RData[j] = _MEM then
     begin
      if LL = 1  then
      begin
       if (Interp[i].SGN[j] = _SUB)   then FSUB(Adr,F_DataType)
       else
       if (Interp[i].SGN[j] = _ADD)   then FADD(Adr,F_DataType);
      end
      else
      if LL = 0 then
      begin
       if (Interp[i].SGN[j] = _SUB)   then
       begin
        FLD(Adr,F_DataType);
        FCHS;
       end
       else
       if (Interp[i].SGN[j] = _ADD)   then FLD(Adr,F_DataType);
       LL:=1;
      end;
     end;

    inc(S);
   end;

  end;



//  F_SaveStack = True/False:
  if {Interp[i].AM = 0}Interp[i].DI = 0 then FAVB1(I)
  else
  if {Interp[i].AM = 1}Interp[i].DI = _AAF then
  begin
   AAF(I);
   FADD;
  end;

  WriteReplFunc(i);
endp:
end;



procedure TCompiler.MUL(I: Integer);
label endp;
var
k,j,l,f,f1,s,h,n,op,FD: Integer;
S1: String;
Adr:TAddress;
begin
if ReadReplFunc(i) = True then   goto endp;

//S1:=Interp[i].Expression;


//f=1    -   (FP)   
//f=0    -    (FP) 
//OP     -    ( - ,   FPU)
//f1=1   -    F1

f1:=0;

if F_SaveStack = True then
begin
 Op:=IsLevelLoadA(I);
 if Op <> 0 then f:=1 else f:=0;
end
else
//F_SaveStack=False:
begin
// -   
 N:=Interp[i].N;
 if N = 0 then
 begin
  f:=0;
  OP:=0;
 end
 else
 if N = 1 then
 begin
  f:=1;
  OP:=Interp[I].SGN[0];
 end
 else
 if N > 1 then
 begin
  //Adr:=0; {.203}
  //if F_Mode = C_Compile then  Adr:=TAddress(@Func.Stack[Interp[I].S]);
  Adr:=GetStackAddr(Interp[I].S); {.241}
  FLD(Adr,F_DataType);
  f:=1;
  OP:=Interp[I].SGN[0];
 end
 else
 begin
  f:=0;
  OP:=0;
 end;
end;


//  F_SaveStack = True/False:
//(a1*x1+b1)*...*(ak*xk+bk):
 if Length(Interp[i].AFB) > 0 then
 begin
  MUL_AFB(I,OP);
  OP:=0; f:=1;
 end;

//MUL/ARGF:  (ARGF = a1*x1+...+an*xn+b)(AAF)
 if {Interp[i].AM = 1}Interp[i].DI = _AAF then
 begin
  //..   ,    F1:
  if (OP = 0) and (f = 0) then
  begin
    FLD(WriteData(Interp[i].F1,_Float,_Load),F_ParamType);
    f1:=1;
  end;
  MUL_AAF(I);
  OP:=0; f:=1;
 end
 else
//MUL/ARGF:  (ARGF = (a*x1*...*xn+b)(MAF)
 if {Interp[i].AM = 2}Interp[i].DI = _MAF then
 begin
  //..   ,    F1:
  if (OP = 0) and (f = 0) then
  begin
    FLD(WriteData(Interp[i].F1,_Float,_Load),F_ParamType);
    f1:=1;
  end;
  MUL_MAF(I);
  OP:=0; f:=1;
 end;




if F_SaveStack = True then
begin
//  3 :
//(1)f=0; (2)f=1&OP=0; (3)f=1&OP<>0;
   S:=Interp[I].S;


   for j:=0 to High(Interp[I].RData) do
   begin
     //Adr:=0; {.203}
     //if F_Mode = C_Compile then Adr:=TAddress(@Func.Stack[S]);
     Adr:=GetStackAddr(S); {.241}

    if Interp[I].RData[j] = _MEM then
    begin
     if F = 1  then
     begin
      if OP <> 0 then
      begin
       if OP = _DIV then  FDIVR(Adr,F_DataType)
       else
       if (OP = _MUL) and (Interp[I].SGN[j] = _DIV) then  FDIV(Adr,F_DataType)
       else
       FMUL(Adr,F_DataType);
       OP:=0;
      end
      else
      if (Interp[i].SGN[j] = _MUL) then FMUL(Adr,F_DataType)
      else
      if (Interp[i].SGN[j] = _DIV)   then FDIV(Adr,F_DataType);
     end
     else
     if F = 0 then
     begin
      if (Interp[i].SGN[j] = _DIV)   then
      begin
       FLD(Adr,F_DataType);
       OP:=_DIV;
      end
      else
      if (Interp[i].SGN[j] = _MUL)   then FLD(Adr,F_DataType);
      F:=1;
     end;
    end;
    inc(S);
   end;

 end
 else
 //F_SaveStack = False:
 begin

    if N > 1 then
    begin
      S:=Interp[I].S+1;

      for k:=1 to N-1 do
      begin
        //Adr:=0; {.203}
        //if F_Mode = C_Compile then  Adr:=TAddress(@Func.Stack[S]);
        Adr:=GetStackAddr(S); {.241}

        if OP = _DIV then
        begin
         FDIVR(Adr,F_DataType);
         OP:=0;
        end
        else
        if  Interp[i].SGN[k] = _MUL then  FMUL(Adr,F_DataType)
        else
        if  Interp[i].SGN[k] = _DIV then  FDIV(Adr,F_DataType);
        inc(S);
      end;
      OP:=0;
    end;

 end;



//  Const/S:
if OP = _DIV then FDIVR(WriteData(Interp[i].F1,_Float,_Load{.}),F_ParamType)
else
if F1 = 0 then FMUL(Interp[i].F1,WriteData(Interp[i].F1,_Float,_MulDiv),F_ParamType);

FADD(Interp[i].F2,WriteData(Interp[i].F2,_Float,_AddSub),F_ParamType);

WriteReplFunc(i);    {tst}

endp:
end;


(*
procedure TCompiler.MUL(I: Integer);
label endp;
var
k,j,l,f,f1,s,h,n,op,FD: Integer;
S1: String;
begin
if ReadReplFunc(i) = True then   goto endp;

//S1:=Interp[i].Expression;


//f=1    -   (FP)   
//f=0    -    (FP) 
//OP     -    ( - ,   FPU)
//f1=1   -    F1

f1:=0;

if F_SaveStack = True then
begin
 Op:=IsLevelLoadA(I);
 if Op <> 0 then f:=1 else f:=0;
end
else
//F_SaveStack=False:
begin
// -   
 N:=Interp[i].N;
 if N = 0 then
 begin
  f:=0;
  OP:=0;
 end
 else
 if N = 1 then
 begin
  f:=1;
  OP:=Interp[I].SGN[0];
 end
 else
 if N > 1 then
 begin
  FLD(TAddress(@Func.Stack[Interp[I].S]),F_DataType);
  f:=1;
  OP:=Interp[I].SGN[0];
 end
 else
 begin
  f:=0;
  OP:=0;
 end;
end;


//  F_SaveStack = True/False:
//(a1*x1+b1)*...*(ak*xk+bk):
 if Length(Interp[i].AFB) > 0 then
 begin
  MUL_AFB(I,OP);
  OP:=0; f:=1;
 end;

//MUL/ARGF:  (ARGF = a1*x1+...+an*xn+b)(AAF)
 if {Interp[i].AM = 1}Interp[i].DI = _AAF then
 begin
  //..   ,    F1:
  if (OP = 0) and (f = 0) then
  begin
    FLD(WriteData(Interp[i].F1,_Float,_Load),F_ParamType);
    f1:=1;
  end;
  MUL_AAF(I);
  OP:=0; f:=1;
 end
 else
//MUL/ARGF:  (ARGF = (a*x1*...*xn+b)(MAF)
 if {Interp[i].AM = 2}Interp[i].DI = _MAF then
 begin
  //..   ,    F1:
  if (OP = 0) and (f = 0) then
  begin
    FLD(WriteData(Interp[i].F1,_Float,_Load),F_ParamType);
    f1:=1;
  end;
  MUL_MAF(I);
  OP:=0; f:=1;
 end;




if F_SaveStack = True then
begin
//  3 :
//(1)f=0; (2)f=1&OP=0; (3)f=1&OP<>0;
   S:=Interp[I].S;

   for j:=0 to High(Interp[I].RData) do
   begin
    if Interp[I].RData[j] = _MEM then
    begin
     if F = 1  then
     begin
      if OP <> 0 then
      begin
       if OP = _DIV then  FDIVR(TAddress(@Func.Stack[S]),F_DataType)
       else
       if (OP = _MUL) and (Interp[I].SGN[j] = _DIV) then  FDIV(TAddress(@Func.Stack[S]),F_DataType)
       else
       FMUL(TAddress(@Func.Stack[S]),F_DataType);
       OP:=0;
      end
      else
      if (Interp[i].SGN[j] = _MUL) then FMUL(TAddress(@Func.Stack[S]),F_DataType)
      else
      if (Interp[i].SGN[j] = _DIV)   then FDIV(TAddress(@Func.Stack[S]),F_DataType);
     end
     else
     if F = 0 then
     begin
      if (Interp[i].SGN[j] = _DIV)   then
      begin
       FLD(TAddress(@Func.Stack[S]),F_DataType);
       OP:=_DIV;
      end
      else
      if (Interp[i].SGN[j] = _MUL)   then FLD(TAddress(@Func.Stack[S]),F_DataType);
      F:=1;
     end;
    end;
    inc(S);
   end;

 end
 else
 //F_SaveStack = False:
 begin

    if N > 1 then
    begin
      S:=Interp[I].S+1;


      for k:=1 to N-1 do
      begin

       if OP = _DIV then
       begin
        FDIVR(TAddress(@Func.Stack[S]),F_DataType);
        OP:=0;
       end
       else
       if  Interp[i].SGN[k] = _MUL then  FMUL(TAddress(@Func.Stack[S]),F_DataType)
       else
       if  Interp[i].SGN[k] = _DIV then  FDIV(TAddress(@Func.Stack[S]),F_DataType);
       inc(S);
      end;
      OP:=0;
    end;

 end;



//  Const/S:
if OP = _DIV then FDIVR(WriteData(Interp[i].F1,_Float,_Load{.}),F_ParamType)
else
if F1 = 0 then FMUL(Interp[i].F1,WriteData(Interp[i].F1,_Float,_MulDiv),F_ParamType);

FADD(Interp[i].F2,WriteData(Interp[i].F2,_Float,_AddSub),F_ParamType);

WriteReplFunc(i);    {tst}

endp:
end;

*)

procedure TCompiler.MUL_AFB(I,OP: Integer);
var
f,k: Integer;
begin
//(a1*x1+b1)*...*(ak*xk+bk):
if OP <> 0 then f:=1 else f:=0;

      for k:=0 to High(Interp[i].AFB) do
      begin
        //A*X:
        if Interp[i].AFB[k].B = 0 then
        begin
          // :
          if f = 0 then
          begin
           FLD(TAddress(Interp[i].AFB[k].PF),GetVarType(Interp[i].AFB[k].PF));
           FMUL(Interp[i].AFB[k].A,WriteData(Interp[i].AFB[k].A,_Float,_MulDiv),F_ParamType);
          end
          else
          //   (f = 1):
          begin
           if OP = _MUL then
            FMUL(TAddress(Interp[i].AFB[k].PF),GetVarType(Interp[i].AFB[k].PF))
           else
           if OP = _DIV then
            FDIVR(TAddress(Interp[i].AFB[k].PF),GetVarType(Interp[i].AFB[k].PF))
           else
            FMUL(TAddress(Interp[i].AFB[k].PF),GetVarType(Interp[i].AFB[k].PF));
           OP:=0;

           FMUL(Interp[i].AFB[k].A,WriteData(Interp[i].AFB[k].A,_Float,_MulDiv),F_ParamType);
          end;

          f:=1;
        end
        //A*X+B:
        else
        begin
         FAVBM(I,k);
         if OP = _MUL then FMULP1
         else
         if OP = _DIV then FDIVRP;
         OP:=0;
         if k > 0 then FMULP1;
         f:=1;
        end;
      end;

end;



procedure TCompiler.MUL_AAF(I: Integer);
begin
//      
      {(a*x+b),(x+b),x:}
      if  Length(Interp[i].PM) = 2 then
      begin
       {/x}
       if (Interp[i].PN[1] = 1) and  (Interp[i].PN[2] = 0) then
       begin
        FDIV(TAddress(Interp[i].PM[1]),GetVarType(Interp[i].PM[1]));
       end
       else
       {/(x+b),/(a*x+b)}
       begin
        FAVBM1(I);
        FDIVP;
       end;
      end
      else
      begin
       AAF(I);
       FDIVP;
      end;
end;




procedure TCompiler.MUL_MAF(I: Integer);
begin
//      
 MAF(I);
 FDIVP;
end;




procedure TCompiler.FILD(N: TAddress);
begin
AddWord($DB,$05);
AddAddress(N);
CheckStack(1);
end;

procedure TCompiler.FIMUL(N: TAddress);
begin
AddWord($DA,$0D);
AddAddress(N);
end;

procedure TCompiler.FIADD(N: TAddress);
begin
AddWord($DA,$05);
AddAddress(N);
end;


procedure TCompiler.INC_C(N: TAddress);
begin
AddWord($FF,$05);
AddAddress(N);
end;



procedure TCompiler.DEC_C(N: TAddress);
begin
AddWord($FF,$0D);
AddAddress(N);
end;




procedure TCompiler.IAVB(I: Integer);
begin
MOVMA(TAddress(Interp[i].IV1));
IMULA(Interp[i].VI1,WriteData(Interp[i].VI1,_Integer,_MulDiv));
ADDA(Interp[i].VI2,WriteData(Interp[i].VI2,_Integer,_AddSub));
MEM:=WriteData(1,_Integer,_Load);
MOVAM(MEM);
FILD(MEM);
end;


procedure TCompiler.IAVBF(I: Integer);
begin
if Interp[i].VI1 <> 0 then
begin
MOVMA(TAddress(Interp[i].IV1));
IMULA(Interp[i].VI1,WriteData(Interp[i].VI1,_Integer,_MulDiv));
ADDA(Interp[i].VI2,WriteData(Interp[i].VI2,_Integer,_AddSub))
end
else
MOVMA(WriteData(Interp[i].VI2,_Integer,_Load));
end;



procedure TCompiler.IAVBF1(I: Integer);
begin
if Interp[i].VI1 <> 0 then
begin
MOVMA(TAddress(Interp[i].IV1));
IMULA(Interp[i].VI1,WriteData(Interp[i].VI1,_Integer,_MulDiv));
ADDA(Interp[i].VI2,WriteData(Interp[i].VI2,_Integer,_AddSub))
end
else
MOVMA(WriteData(Interp[i].VI2,_Integer,_Load));
end;



procedure TCompiler.IAVBF2(I: Integer);
begin
if Interp[i].VI3 <> 0 then
begin
MOVMB(TAddress(Interp[i].IV2));
IMULB(Interp[i].VI3,WriteData(Interp[i].VI3,_Integer,_MulDiv));
ADDB(Interp[i].VI4,WriteData(Interp[i].VI4,_Integer,_AddSub))
end
else
MOVMB(WriteData(Interp[i].VI4,_Integer,_Load));
end;




procedure TCompiler.AIFB(I: Integer);
begin
FILD(TAddress(Interp[i].IV1));
FMUL(TAddress(Interp[i].FV1),GetVarType(Interp[i].FV1));

if Interp[i].V1 = -1 then AddWord($D9,$E0) else
if Interp[i].V1 <> 1 then
begin
 FMUL(Interp[i].V1,WriteData(Interp[i].V1,_Float,_MulDiv),F_ParamType);
end;

FADD(Interp[i].V2,WriteData(Interp[i].V2,_Float,_AddSub),F_ParamType);
end;




procedure TCompiler.AIFB1(I: Integer);
begin
FLD(TAddress(Interp[i].FV1),GetVarType(Interp[i].FV1));
FIMUL(TAddress(Interp[i].IV2));

if Interp[i].V1 = -1 then AddWord($D9,$E0) else
if Interp[i].V1 <> 1 then
begin
 FMUL(Interp[i].V1,WriteData(Interp[i].V1,_Float,_MulDiv),F_ParamType);
end;

FADD(Interp[i].V2,WriteData(Interp[i].V2,_Float,_AddSub),F_ParamType);
end;



procedure TCompiler.AAI(I: Integer);
var
k: Integer;
begin

MOVMA(TAddress(Interp[i].PI[1]));
IMULA(Interp[i].PC[1],WriteData(Interp[i].PC[1],_Integer,_MulDiv));
for k:=2 to High(Interp[i].PI) do
begin
 if Interp[i].PC[k] = 1 then
 ADDA(TAddress(Interp[i].PI[k]))
 else
 if Interp[i].PC[k] = -1 then
 SUBA(TAddress(Interp[i].PI[k]))
 else
 begin
 MOVB(TAddress(Interp[i].PI[k]));
 IMULB(Interp[i].PC[k],WriteData(Interp[i].PC[k],_Integer,_MulDiv));
 ADDAB;
 end;
end;

ADDA(Interp[i].PC[High(Interp[i].PC)],WriteData(Interp[i].PC[High(Interp[i].PC)],_Integer,_AddSub));
MEM:=WriteData(1,_Integer,_Load);
MOVAM(MEM);
FILD(MEM);

end;



procedure TCompiler.AAI1(I: Integer);
var
k: Integer;
begin


MOVMA(TAddress(Interp[i].PI[1]));
IMULA(Interp[i].PC[1],WriteData(Interp[i].PC[1],_Integer,_MulDiv));
for k:=2 to High(Interp[i].PI) do
begin
 if Interp[i].PC[k] = 1 then
 ADDA(TAddress(Interp[i].PI[k]))
 else
 if Interp[i].PC[k] = -1 then
 SUBA(TAddress(Interp[i].PI[k]))
 else
 begin
 MOVB(TAddress(Interp[i].PI[k]));
 IMULB(Interp[i].PC[k],WriteData(Interp[i].PC[k],_Integer,_MulDiv));
 ADDAB;
 end;
end;
ADDA(Interp[i].PC[High(Interp[i].PC)],WriteData(Interp[i].PC[High(Interp[i].PC)],_Integer,_AddSub));
end;





procedure TCompiler.AFI(I: Integer);
var
k: Integer;
begin
FILD(TAddress(Interp[i].PI[1]));
FMUL(Interp[i].PN[1],WriteData(Interp[i].PN[1],_Float,_MulDiv),F_ParamType);
for k:=2 to High(Interp[i].PI) do
begin
 FILD(TAddress(Interp[i].PI[k]));
 FMUL(Interp[i].PN[k],WriteData(Interp[i].PN[k],_Float,_MulDiv),F_ParamType);
 FADD;
end;

FADD(Interp[i].PN[High(Interp[i].PN)],WriteData(Interp[i].PN[High(Interp[i].PN)],_Float,_AddSub),F_ParamType);
end;




procedure TCompiler.LDSV(I: Integer);
var
k,TM: Integer;
AdrM: TAddress;
begin
AdrM:=TAddress(Interp[i].IV2);
TM:=GetVarType(Interp[i].IV2);


//Vec[num]
if Interp[i].EI = 1 then
begin
  MOVA1(Interp[i].VI2);     {!!!}
end
else
//Vec[int]
if Interp[i].EI = 2 then
begin
  MOVMA(TAddress(Interp[i].IV1));
end
else
//Vec[A*I+B]
if Interp[i].EI = 3 then
begin
  IAVBF(I);
end
//Vec[AAI]
else
if Interp[i].EI = 4 then
begin
  AAI1(I);
end
else
//Vec[Trunc(S)]
if Interp[i].EI = 0 then
begin
   if  (F_SaveStack = True) and (Interp[I].RData[0] = _MEM) then
   {Stack}
   begin
     //FLD(TAddress(@Func.Stack[Interp[i].S]),F_DataType);
      FLD(GetStackAddr(Interp[i].S),F_DataType);    {.241}
   end;
   MEM:=WriteData(1,_Integer,_Load);
   TRUNCM(MEM);
   MOVMA(MEM);
end;
(*
else
//addr(Vec)->st(0)
if Interp[i].EI = 5 then      {arraycpu}
begin
      //FLD(WriteData(adrM,_Integer,_Load),_Integer);

  //FILD(AdrM);   {.245}

  //      
   PUSHF(AdrM);
   POPF(GetStackAddr(Interp[i].S));

end;
*)

if Interp[i].EI <> 5 then
begin
 //array[count]:
 //EBX<-addr(array); EAX<-count;
 if TM = _ArrayD then
 begin
   MOVB1(AdrM);
   {MOVC1(Cardinal(@RD_VEC));
   CALLC;
   SetReg(3);}
   AddByte($8B); AddByte($1B);               //  mov  ebx, [ebx]
   AddByte($DD); AddByte($04); AddByte($C3); //  fld  qword ptr [ebx+8*eax];
   SetReg(1);  SetReg(2);
 end
 else
 if TM = _ArrayE then
 begin
   MOVB1(AdrM);
   {MOVC1(Cardinal(@RE_VEC));
   CALLC;SetReg(3);}
   AddByte($8B); AddByte($1B);                //mov  ebx, [ebx]
   AddByte($8D); AddByte($04); AddByte($80);  //lea   eax,[eax+4*eax]
   AddByte($DB); AddByte($2C); AddByte($43);  //fld   tbyte ptr [ebx+2*eax]
   SetReg(1);  SetReg(2);
 end
 else
 if TM = _ArrayS then
 begin
   MOVB1(AdrM);
   {MOVC1(Cardinal(@RS_VEC));
   CALLC;SetReg(3);}
   AddByte($8B); AddByte($1B);                //mov  ebx, [ebx]
   AddByte($D9); AddByte($04); AddByte($83); //  fld  dword ptr [ebx+4*eax];
   SetReg(1);  SetReg(2);
 end
 else
 if TM = _ArrayI then
 begin
    MOVB1(AdrM);
   {MOVC1(Cardinal(@RI_VEC));
   CALLC;SetReg(3); }
   AddByte($8B); AddByte($1B);                //mov  ebx, [ebx]
   AddByte($DB); AddByte($04); AddByte($83);  //  fild  dword ptr [ebx+4*eax];
   SetReg(1);  SetReg(2);
 end;

CheckStack(1);
end;


end;


{arraycpu} {.245}
procedure TCompiler.LDSVA(I: Integer);
var
k,TM: Integer;
AdrM: TAddress;
begin
AdrM:=TAddress(Interp[i].IV2);
TM:=GetVarType(Interp[i].IV2);


//FLD(WriteData(adrM,_Integer,_Load),_Integer);
//FILD(AdrM);   {.245}

  //      
   PUSHF(AdrM);
   POPF(GetStackAddr(Interp[i].S));

end;









procedure TCompiler.SAVEV(I: Integer);
var
k,TM: Integer;
AdrM: TAddress;
begin
AdrM:=TAddress(Interp[i].IV2);
TM:=GetVarType(Interp[i].IV2);


//Vec[num]
if Interp[i].EI = 1 then
begin
  MOVA1(Interp[i].VI2);      {!!!}
end
else
//Vec[int]
if Interp[i].EI = 2 then
begin
  MOVMA(TAddress(Interp[i].IV1));
end
else
//Vec[A*I+B]
if Interp[i].EI = 3 then
begin
  IAVBF(I);
end
//Vec[AAI]
else
if Interp[i].EI = 4 then
begin
  AAI1(I);
end
else
//Vec[Trunc(S)]
if Interp[i].EI = 0 then
begin
   if  ((F_SaveStack = True) and (Interp[I].RData[1] = _MEM)) or (F_SaveStack = False) then
   {Stack}
   begin
     //FLD(TAddress(@Func.Stack[Interp[i].S+1]),F_DataType);
     FLD(GetStackAddr(Interp[i].S+1),F_DataType);      {.241}
   end;
   MEM:=WriteData(1,_Integer,_Load);
   TRUNCM(MEM);
   MOVMA(MEM);
end;
//vd[x^2+x^3]=x^4;vd[12]
//vd[x*y-x*y*(x*y-x*y*(x*y-x*y*(x*y-x*y)-x*y)-x*y)]=x*y-x*y*(x*y-x*y*(x*y-x*y*(x*y+x))); vd[x*y-x*y*(x*y-x*y*(x*y-x*y*(x*y-x*y)-x*y)-x*y)]

if  ((F_SaveStack = True) and (Interp[I].RData[0] = _MEM)) or  (F_SaveStack = False) then
   begin
     //FLD(TAddress(@Func.Stack[Interp[i].S]),F_DataType);
     FLD(GetStackAddr(Interp[i].S),F_DataType);   {.241}
   end;

 //array[count]:
 //EBX<-addr(array); EAX<-count;
 if TM = _ArrayD then
 begin
   MOVB1(AdrM);
   {MOVC1(Cardinal(@RD_VEC));
   CALLC;
   SetReg(3);}
   AddByte($8B); AddByte($1B);               //  mov  ebx, [ebx]
   AddByte($DD); AddByte($1C); AddByte($C3); //  fstp  qword ptr [ebx+8*eax];
   SetReg(1);  SetReg(2);
 end
 else
 if TM = _ArrayE then
 begin
   MOVB1(AdrM);
   {MOVC1(Cardinal(@RE_VEC));
   CALLC;SetReg(3);}
   AddByte($8B); AddByte($1B);                //mov  ebx, [ebx]
   AddByte($8D); AddByte($04); AddByte($80);  //lea   eax,[eax+4*eax]
   AddByte($DB); AddByte($3C); AddByte($43);  //fstp   tbyte ptr [ebx+2*eax]
   SetReg(1);  SetReg(2);
 end
 else
 if TM = _ArrayS then
 begin
   MOVB1(AdrM);
   {MOVC1(Cardinal(@RS_VEC));
   CALLC;SetReg(3);}
   AddByte($8B); AddByte($1B);                //mov  ebx, [ebx]
   AddByte($D9); AddByte($1C); AddByte($83); //  fstp  dword ptr [ebx+4*eax];
   SetReg(1);  SetReg(2);
 end
 else
 if TM = _ArrayI then
 begin
    MOVB1(AdrM);
   {MOVC1(Cardinal(@RI_VEC));
   CALLC;SetReg(3); }
   AddByte($8B); AddByte($1B);                //mov  ebx, [ebx]
   AddByte($DB); AddByte($1C); AddByte($83);  //  fistp  dword ptr [ebx+4*eax];
   SetReg(1);  SetReg(2);
 end;

CheckStack(-1);
F_SaveNum:=True;  {.203}
end;






procedure TCompiler.SUMPS(I: Integer);
label fin;
var
k,TM: Integer;
AdrM: TAddress;
begin
if ReadReplFunc(i) = True then   goto fin;

AdrM:=TAddress(Interp[i].IV2);
TM:=GetVarType(Interp[i].IV2);


//Vec^[num]
if Interp[i].EI = 1 then
begin
  MOVA1(Interp[i].VI2);     {!!!}
end
else
//Vec^[intvar]
if Interp[i].EI = 2 then
begin
  MOVMA(TAddress(Interp[i].IV1));
end
else
//Vec^[A*I+B]
if Interp[i].EI = 3 then
begin
  IAVBF(I);
end
//Vec^[AAI]
else
if Interp[i].EI = 4 then
begin
  AAI1(I);
end
else
//Vec^[Trunc(S)]
if Interp[i].EI = 0 then
begin

   if  ((F_SaveStack = True) and (Interp[I].RData[1] = _MEM)) or (F_SaveStack = False) then
   {Stack}
   begin
     //FLD(TAddress(@Func.Stack[Interp[i].S+1]),F_DataType);
     FLD(GetStackAddr(Interp[i].S+1),F_DataType);    {.241}
   end;


   MEM:=WriteData(1,_Integer,_Load);
   TRUNCM(MEM);
   MOVMA(MEM);
end;

if  ((F_SaveStack = True) and (Interp[I].RData[0] = _MEM)) or  (F_SaveStack = False) then
   begin
     //FLD(TAddress(@Func.Stack[Interp[i].S]),F_DataType);
     FLD(GetStackAddr(Interp[i].S),F_DataType);  {.241}
   end;

 //array^[count]:
 //EBX<-addr(array); EAX<-power;
 //(Xi-S)^[EAX]
MOVMB(TAddress(Interp[i].IV2));
XCHGAB;
 if TM = _ArrayD then
 begin
   //MOVB1(AdrM);
   MOVC1(Cardinal(@RD_SUMPS));
   CALLC;
 end
 else
 if TM = _ArrayE then
 begin
   //MOVB1(AdrM);
   MOVC1(Cardinal(@RE_SUMPS));
   CALLC;
 end
 else
 if TM = _ArrayS then
 begin
   //MOVB1(AdrM);
   MOVC1(Cardinal(@RS_SUMPS));
   CALLC;
 end
 else
 if TM = _ArrayI then
 begin
    //MOVB1(AdrM);
    MOVC1(Cardinal(@RI_SUMPS));
    CALLC;
 end;

WriteReplFunc(i);

fin:
FAB12(I);
end;







procedure TCompiler.SUMP(I: Integer);
label fin;
var
k,TM: Integer;
AdrM: TAddress;
begin
if ReadReplFunc(i) = True then   goto fin;

AdrM:=TAddress(Interp[i].IV2);
TM:=GetVarType(Interp[i].IV2);


//Vec^[num]
if Interp[i].EI = 1 then
begin
  MOVA1(Interp[i].VI2);         {!!!}
end
else
//Vec^[intvar]
if Interp[i].EI = 2 then
begin
  MOVMA(TAddress(Interp[i].IV1));
end
else
//Vec^[A*I+B]
if Interp[i].EI = 3 then
begin
  IAVBF(I);
end
//Vec^[AAI]
else
if Interp[i].EI = 4 then
begin
  AAI1(I);
end
else
//Vec^[Trunc(S)]
if Interp[i].EI = 0 then
begin
   if  ((F_SaveStack = True) and (Interp[I].RData[0] = _MEM)) or (F_SaveStack = False) then
   {Stack}
   begin
     //FLD(TAddress(@Func.Stack[Interp[i].S]),F_DataType);
     FLD(GetStackAddr(Interp[i].S),F_DataType);  {.241}
   end;
   //LoadArg1(I);
   MEM:=WriteData(1,_Integer,_Load);
   TRUNCM(MEM);
   MOVMA(MEM);
end;



 //array^[count]:
 //EBX<-addr(array); EAX<-power;
MOVMB(TAddress(Interp[i].IV2));
XCHGAB;
 if TM = _ArrayD then
 begin
   //MOVB1(AdrM);
   MOVC1(Cardinal(@RD_SUMP));
   CALLC;
 end
 else
 if TM = _ArrayE then
 begin
   //MOVB1(AdrM);
   MOVC1(Cardinal(@RE_SUMP));
   CALLC;
 end
 else
 if TM = _ArrayS then
 begin
   //MOVB1(AdrM);
   MOVC1(Cardinal(@RS_SUMP));
   CALLC;
 end
 else
 if TM = _ArrayI then
 begin
    //MOVB1(AdrM);
    MOVC1(Cardinal(@RI_SUMP));
    CALLC;
 end;

CheckStack(3);
CheckStack(-2);

WriteReplFunc(i);

fin:
FAB12(I);
end;







procedure TCompiler.POLY_C(I: Integer);
label fin;
var
k,TM,LP: Integer;
AdrM: TAddress;
f1: TFloatType;

begin
if ReadReplFunc(i) = True then   goto fin;







(*
if  ((F_SaveStack = True) and (Interp[I].RData[0] = _MEM)) or (F_SaveStack = False) then
   {Stack}
   begin
     FLD(TAddress(@Func.Stack[Interp[i].S]),F_DataType);
   end;
*)
 //EAX<-addr(array);

if (Interp[i].EI = 1)  then   {EI=1}  //poly(vec,expr) poly(expr,vec)
begin
 LoadArg1(I);  {.213}

 AdrM:=TAddress(Interp[i].IV2);
 TM:=GetVarType(Interp[i].IV2);

 MOVMA(TAddress(Interp[i].IV2));

 if TM = _ArrayD then
 begin
   //MOVB1(AdrM);
   MOVC1(Cardinal(@RD_POLY));
   CALLC;
 end
 else
 if TM = _ArrayE then
 begin
   MOVC1(Cardinal(@RE_POLY));
   CALLC;
 end
 else
 if TM = _ArrayS then
 begin
   MOVC1(Cardinal(@RS_POLY));
   CALLC;
 end
 else
 if TM = _ArrayI then
 begin
    MOVC1(Cardinal(@RI_POLY));
    CALLC;
 end;

 CheckStack(2);
 CheckStack(-2);

end

//poly(2,x*y)*x+poly(2,x*y)*x        ERROR!!!
//poly(2,3,x*y)*x+poly(2,3,x*y)*x    NO ERROR!!!
else        {.223}
begin          //poly(3,5,7,9,11,15,17,19,x)-(3*x^7+5*x^6+7*x^5+9*x^4+11*x^3+15*x^2+17*x+19)

  LP:=Length(Interp[i].VFP)-1;

  if F_Mode = C_Compile then f1:=Interp[i].VFP[0] else  f1:=1;

  if (Interp[i].EI = 2) then   {EI=2}  //poly(x,1)  poly(1,x)
  begin
     FLD(WriteData(F1,_Float,_Load),F_ParamType);
  end
  else
  begin    {EI=3}
     LoadArg1(I);
                                                  //poly(3,5,x)
     if LP + 1 > 2 then FLD0;  //x,x
     FMUL(F1,WriteData(F1,_Float,_MulDiv),F_ParamType);    //a0*x,x


     for k := 1 to LP-1 do
     begin
       if F_Mode = C_Compile then f1:=Interp[i].VFP[k] else  f1:=1;

       FADD(F1,WriteData(F1,_Float,_AddSub),F_ParamType);

       if k < LP-1 then FMUL01 else FMULP1;
     end;

    if F_Mode = C_Compile then  f1:=Interp[i].VFP[LP] else  f1:=1;
    FADD(F1,WriteData(F1,_Float,_AddSub),F_ParamType);   //+an

  end;
end;

WriteReplFunc(i);

fin:
FAB12(I);
end;





procedure TCompiler.POLYDIFF_C(I: Integer);
label fin;                    //diff only for 1,2,3
var
k,TM,ND,TF: Integer;
AdrM: TAddress;
begin
if ReadReplFunc(i) = True then   goto fin;

//AdrM:=TAddress(Interp[i].IV2);
//TM:=GetVarType(Interp[i].IV2);

ND:=Interp[i].DI;
TM:=Interp[i].BI;
TF:=Interp[i].CI;


LoadArg1(I);  {.213}
(*if  ((F_SaveStack = True) and (Interp[I].RData[0] = _MEM)) or (F_SaveStack = False) then
   {Stack}
   begin
     FLD(TAddress(@Func.Stack[Interp[i].S]),F_DataType);
   end;
*)

 //EAX<-addr(array);
MOVMA(TAddress(Interp[i].AdrV1));
//FLD(TAddress(Interp[i].AdrF1),TF);  {.213}

 if TM = _ArrayD then
 begin
   //MOVB1(AdrM);
   if ND = 1 then MOVC1(Cardinal(@RD_POLYDIFF1)) else
   if ND = 2 then MOVC1(Cardinal(@RD_POLYDIFF2)) else
   if ND = 3 then MOVC1(Cardinal(@RD_POLYDIFF3));
   CALLC;
 end
 else
 if TM = _ArrayE then
 begin
   if ND = 1 then MOVC1(Cardinal(@RE_POLYDIFF1)) else
   if ND = 2 then MOVC1(Cardinal(@RE_POLYDIFF2)) else
   if ND = 3 then MOVC1(Cardinal(@RE_POLYDIFF3));
   CALLC;
 end
 else
 if TM = _ArrayS then
 begin
   if ND = 1 then MOVC1(Cardinal(@RS_POLYDIFF1)) else
   if ND = 2 then MOVC1(Cardinal(@RS_POLYDIFF2)) else
   if ND = 3 then MOVC1(Cardinal(@RS_POLYDIFF3));
   CALLC;
 end
 else
 if TM = _ArrayI then
 begin
   if ND = 1 then MOVC1(Cardinal(@RI_POLYDIFF1)) else
   if ND = 2 then MOVC1(Cardinal(@RI_POLYDIFF2)) else
   if ND = 3 then MOVC1(Cardinal(@RI_POLYDIFF3));
   CALLC;
 end;

 CheckStack(3);
 CheckStack(-3);

WriteReplFunc(i);

fin:
FAB12(I);
end;






procedure TCompiler.TRY_C(I: Integer);
var
k: Integer;
adr: TAddress;
begin
if TE_ADDR = 0 then
begin
   adr:=WriteData(CWFPU,_Integer,_Load);
   TE_ADDR:=adr;
end
else
   adr:=TE_ADDR;

//ECX<-addr(CWMEM);
MOVC1(adr);

MOVA1(Cardinal(@MaskFPUExceptionA));
CALLA;
end;





procedure TCompiler.EXCEPTION_C(I: Integer);
var
k: Integer;
adr: TAddress;
begin

if TE_ADDR = 0 then
begin
   adr:=WriteData(CWFPU,_Integer,_Load) ;
   TE_ADDR:=adr;
end
else
   adr:=TE_ADDR;


//ECX<-addr(CWMEM);
MOVC1(adr);

MOVA1(Cardinal(@IsFPUExceptionA));
CALLA;

CheckStack(1);

end;




procedure TCompiler.PKGCMPL(I: Integer);
var
R,N,K,m: Integer;
NL,NB: Integer;
ANL: TArrayC;
begin
 //     (reg)   
 //(.. push reg   ),   mov reg,[esp+S]  
 //; S - ' '    
 // S:
 case Interp[I].PkAdr of
    1,2,3,4:
    begin
     R:=Interp[I].PkAdr;
     N:=0; K:=0;
     if (REG[R] = 1) or (REGA[R] = 1) then
     begin

      for m:=1 to 8 do
      begin
       if (REG[m] = 1) or (REGA[m] = 1) then
       begin
        inc(N);
        if R = m then K:=N;
       end;
      end;

      MOVREGESP(R,(N-K)*4);
     end;
    end;
 end;

SaveRes(Interp[I].PkAdr,Interp[I].PkRType,Interp[I].PkShift);

//if (Interp[I].PkAdr <> 0) and (Interp[I].PkRType <> 0) then F_SaveNum:=True;  {.203}

//NL:=Interp[I].NL;      // -  :   '1'
//FindNumberLevelA(Interp[I-1].NM,ANL);      //NM - :  @@PACKAGE

//NB:=ANL[0];           //ANL:    '0': ANL[NL]   - 
SetLength(GotoLab,Length(GotoLab)+1);
GotoLab[High(GotoLab)]:=I;

{CS:=Interp[NB].CS;     //   -
NC:=Interp[N].NC;      //    ICOMP  
CS1:=Interp[N].CS;     //    }

end;



procedure TCompiler.MOVREGESP(R: Integer; Sh: Byte);
begin  //mov reg,[esp+Sh]
   case R of
   1:  begin AddCom($8B,$44,$24); AddByte(Sh); end;
   2:  begin AddCom($8B,$5C,$24); AddByte(Sh); end;
   3:  begin AddCom($8B,$4C,$24); AddByte(Sh); end;
   4:  begin AddCom($8B,$54,$24); AddByte(Sh); end;
   end;
end;



procedure TCompiler.POPREG(reg: Cardinal);
begin
  case reg of
   1:  POPA;
   2:  POPB;
   3:  POPC;
   4:  POPD;
  end;
end;


procedure TCompiler.PUSHREG(reg: Cardinal);
begin
  case reg of
   1:  PUSHA;
   2:  PUSHB;
   3:  PUSHC;
   4:  PUSHD;
  end;
end;

procedure TCompiler.MOVB(N: TAddress);
begin
AddWord($8B,$1D);
AddAddress(N);
SetReg(2);
end;


procedure TCompiler.MOVA1(N: TAddress);
begin
//N - 
AddByte($B8);
AddAddress(N);
SetReg(1);
end;



procedure TCompiler.MOVB1(N: TAddress);
begin
AddByte($BB);
AddAddress(N);
SetReg(2);
end;


procedure TCompiler.MOVC1(N: TAddress);
begin
AddByte($B9);
AddAddress(N);
SetReg(3);
end;


procedure TCompiler.MOVD1(N: TAddress);
begin
AddByte($BA);
AddAddress(N);
SetReg(4);
end;


procedure TCompiler.MOVCA;
begin
AddWord($89,$C1);
SetReg(1);
SetReg(3);
end;


procedure TCompiler.MOVAB;
begin
//EAX -> EBX
AddWord($89,$C3);
SetReg(1);
SetReg(2);
end;


procedure TCompiler.MOVBA;
begin
//EBX -> EAX
AddWord($89,$D8);
SetReg(1);
SetReg(2);
end;


procedure TCompiler.NEGA;
begin
AddWord($F7,$D8);
end;


procedure TCompiler.NEGB;
begin
AddWord($F7,$DB);
end;


procedure TCompiler.SUBA(N: TAddress);
begin
AddWord($2B,$05);
AddAddress(N);
SetReg(1);
end;

procedure TCompiler.SUBAB;
begin
//EAX = EAX - EBX
AddWord($29,$D8);
SetReg(1);
SetReg(2);
end;



procedure TCompiler.SUBA_B(B: Byte);
begin
//EAX = EAX - B
AddWord($83,$E8);
AddByte(B);
SetReg(1);
end;



procedure TCompiler.FSTPESP(VType: Integer);
begin
 case VType of
  _Single:   AddCom($D9,$1C,$24);
  _Integer:  AddCom($DB,$1C,$24);  //fistp
  _Address:  AddCom($DB,$1C,$24);  //fistp
  _Double:   AddCom($DD,$1C,$24);
  _Extended: AddCom($DB,$3C,$24);
 end;
 CheckStack(-1);
end;


procedure TCompiler.FSTPESP(VType: Integer; N: Integer);
begin
if N = 0 then FSTPESP(VType)
else
begin
 case VType of
  _Single:   AddCom($D9,$9C,$24,N);
  _Integer:  AddCom($DB,$9C,$24,N);  //fistp
  _Address:  AddCom($DB,$9C,$24,N);  //fistp
  _Double:   AddCom($DD,$9C,$24,N);
  _Extended: AddCom($DB,$BC,$24,N);
 end;
 CheckStack(-1);
end;
end;


procedure TCompiler.MOVAM(N: TAddress);
begin
//EAX->MEM
AddWord($89,$05);
AddAddress(N);
SetReg(1);
end;


procedure TCompiler.MOVMA(N: TAddress);
begin
//MEM->EAX
AddWord($8B,$05);
AddAddress(N);
SetReg(1);
end;


procedure TCompiler.MOVAX(N: TAddress);
begin
//word ptr [N] -> AX
AddByte($66);  AddByte($8B); AddByte($05);
AddAddress(N);
SetReg(1);
end;



procedure TCompiler.MOVMB(N: TAddress);
begin
//MEM->EBX
AddWord($8B,$1D);
AddAddress(N);
SetReg(2);
end;



procedure TCompiler.MOVMC(N: TAddress);
begin
//MEM->ECX
AddWord($8B,$0D);
AddAddress(N);
SetReg(3);
end;



procedure TCompiler.MOVCM(N: TAddress);
begin
AddWord($8B,$0D);
AddAddress(N);
SetReg(3);
end;


procedure TCompiler.IMULA(X: Integer; N: TAddress);
begin
if X = -1 then NEGA
else
if X <> 1 then
begin
//AddWord($F7,$2D);
AddByte($0F); AddByte($AF); AddByte($05);
AddAddress(N);
SetReg(1);
end;
end;


procedure TCompiler.IMULBA;
begin
AddByte($0F); AddByte($AF); AddByte($D8);
SetReg(1);
SetReg(2);
end;


procedure TCompiler.IMULBB;
begin
AddByte($0F); AddByte($AF); AddByte($DB);
SetReg(1);
SetReg(2);
end;


procedure TCompiler.IMULAA;
begin
AddByte($0F); AddByte($AF); AddByte($C0);
SetReg(1);
end;


procedure TCompiler.IMULAB;
begin
AddByte($0F); AddByte($AF); AddByte($C3);
SetReg(1);
SetReg(2);
end;



procedure TCompiler.IMULB(X: Integer; N: TAddress);
begin
if X = -1 then NEGB
else
if X <> 1 then
begin
AddByte($0F); AddByte($AF); AddByte($1D);
AddAddress(N);
SetReg(2);
end;
end;


procedure TCompiler.IMULBA_B(B: Byte);
begin
//EAX*B -> EBX
AddWord($6B,$D8);
AddByte(B); //B - 
SetReg(1);
SetReg(2);
end;


procedure TCompiler.IMULDA_B(B: Byte);
begin
//EAX*B -> EDX
AddWord($6B,$D0);
AddByte(B); //B - 
SetReg(1);
SetReg(4);
end;


procedure TCompiler.ADDA(X: Integer; N: TAddress);
begin
if X <> 0 then
begin
AddWord($03,$05);
AddAddress(N);
SetReg(1);
end;
end;


procedure TCompiler.ADDB(X: Integer; N: TAddress);
begin
if X <> 0 then
begin
AddWord($03,$1D);
AddAddress(N);
SetReg(2);
end;
end;


procedure TCompiler.ADDA(N: TAddress);
begin
AddWord($03,$05);
AddAddress(N);
SetReg(1);
end;


procedure TCompiler.ADDAB;
begin
AddWord($01,$D8);
SetReg(1);
SetReg(2);
end;


procedure TCompiler.ADDCB;
begin
AddWord($01,$D9);
SetReg(2);
SetReg(3);
end;


procedure TCompiler.ADDCD;
begin
AddWord($01,$D1);
SetReg(3);
SetReg(4);
end;


procedure TCompiler.ADDESP(N: Integer);
begin
if N <> 0 then
AddCom($81,$C4,N);
end;

procedure TCompiler.SUBESP(N: Integer);
begin
if N <> 0 then
AddCom($81,$EC,N);
end;

procedure TCompiler.PUSHAX;
begin
//PUSH AX
AddWord($66,$50);
end;


procedure TCompiler.PUSHA;
begin
AddByte($50);
end;

procedure TCompiler.PUSHB;
begin
AddByte($53);
end;


procedure TCompiler.PUSHC;
begin
AddByte($51);
end;

procedure TCompiler.POPA;
begin
AddByte($58);
end;

procedure TCompiler.POPB;
begin
AddByte($5B);
end;


procedure TCompiler.POPC;
begin
AddByte($59);
end;


procedure TCompiler.CALLA;
begin
AddWord($FF,$D0);
SetReg(1);
end;


procedure TCompiler.CALLB;
begin
AddWord($FF,$D3);
SetReg(2);
end;


procedure TCompiler.CALLC;
begin
AddWord($FF,$D1);
SetReg(3);
end;

procedure TCompiler.CALLD;
begin
AddWord($FF,$D2);
SetReg(4);
end;


procedure TCompiler.FLDCW(N: TAddress);
begin
AddWord($D9,$2D);
AddAddress(N);
end;



procedure TCompiler.FNCLEX;
begin
AddWord($DB,$E2);
end;

procedure TCompiler.FISTP(N: TAddress);
begin
AddWord($DB,$1D);
AddAddress(N);
CheckStack(-1);
end;



procedure TCompiler.FSTPA(VType: Integer; Shift: Cardinal);
begin
if Shift = 0 then
begin
 case VType of
  _Single:   AddCom($D9,$18);
  _Integer:  AddCom($DB,$18);  //fistp
  _Address:  AddCom($DB,$18);  //fistp
  _Double:   AddCom($DD,$18);
  _Extended: AddCom($DB,$38);
 end;
end
else
begin
  case VType of
  _Single:   AddCom($D9,$98,Shift);
  _Integer:  AddCom($DB,$98,Shift);  //fistp
  _Address:  AddCom($DB,$98,Shift);  //fistp
  _Double:   AddCom($DD,$98,Shift);
  _Extended: AddCom($DB,$B8,Shift);
 end;
end;
CheckStack(-1);
end;

procedure TCompiler.FSTPB(VType: Integer; Shift: Cardinal);
begin
if Shift = 0 then
begin
 case VType of
  _Integer:  AddCom($DB,$1B);  //fistp
  _Address:  AddCom($DB,$1B);  //fistp
  _Double:   AddCom($DD,$1B);
  _Single:   AddCom($D9,$1B);
  _Extended: AddCom($DB,$3B);
 end;
end
else
begin
  case VType of
  _Integer:  AddCom($DB,$9B,Shift);  //fistp
  _Address:  AddCom($DB,$9B,Shift);  //fistp
  _Double:   AddCom($DD,$9B,Shift);
  _Single:   AddCom($D9,$9B,Shift);
  _Extended: AddCom($DB,$BB,Shift);
 end;
end;
CheckStack(-1);
end;



procedure TCompiler.FSTPC(VType: Integer; Shift: Cardinal);
begin
if Shift = 0 then
begin
 case VType of
  _Integer:  AddCom($DB,$19);  //fistp
  _Address:  AddCom($DB,$19);  //fistp
  _Double:   AddCom($DD,$19);
  _Single:   AddCom($D9,$19);
  _Extended: AddCom($DB,$39);
 end;
end
else
begin
  case VType of
  _Integer:  AddCom($DB,$99,Shift);  //fistp
  _Address:  AddCom($DB,$99,Shift);  //fistp
  _Double:   AddCom($DD,$99,Shift);
  _Single:   AddCom($D9,$99,Shift);
  _Extended: AddCom($DB,$B9,Shift);
 end;
end;
CheckStack(-1);
end;


procedure TCompiler.FSTPD(VType: Integer; Shift: Cardinal);
begin
if Shift = 0 then
begin
 case VType of
  _Integer:  AddCom($DB,$1A);  //fistp
  _Address:  AddCom($DB,$1A);  //fistp
  _Double:   AddCom($DD,$1A);
  _Single:   AddCom($D9,$1A);
  _Extended: AddCom($DB,$3A);
 end;
end
else
begin
  case VType of
  _Integer:  AddCom($DB,$9A,Shift);  //fistp
  _Address:  AddCom($DB,$9A,Shift);  //fistp
  _Double:   AddCom($DD,$9A,Shift);
  _Single:   AddCom($D9,$9A,Shift);
  _Extended: AddCom($DB,$BA,Shift);
 end;
end;

CheckStack(-1);
end;


procedure TCompiler.FXCH1;
begin
AddWord($D9,$C9);
end;



procedure TCompiler.FLDLN2;
begin
AddWord($D9,$ED);
CheckStack(1);
end;


procedure TCompiler.FYL2X;
begin
AddWord($D9,$F1);
CheckStack(-1);
end;


procedure TCompiler.FLDLG2;
begin
AddWord($D9,$EC);
CheckStack(1);
end;


procedure TCompiler.FSINCOS;
begin
AddWord($D9,$FB);
CheckStack(1);
end;



procedure TCompiler.LoadArg1(I: Integer);
var
Adr: TAddress;
begin
(*
Adr:=0;
if F_Mode = C_Compile then        {.203}
begin
 Adr:=TAddress(@Func.Stack[Interp[i].S]);
end;
*)
Adr:=GetStackAddr(Interp[i].S); {.241}

if (F_SaveStack = True) and (Interp[i].RData[0] = _MEM) then
 {Stack}
 begin
   FLD(Adr,F_DataType);
 end
 else
 if  (F_SaveStack = False) {and (Interp[i].N = 1) } then
begin
   FLD(Adr,F_DataType);
end;

end;




procedure TCompiler.LoadArg2(I: Integer);
var
Adr,Adr1: TAddress;
begin



(*
Adr:=0; Adr1:=0;{.203}
if F_Mode = C_Compile then
begin
 if Interp[i].N > 0 then
  begin
   Adr:=TAddress(@Func.Stack[Interp[i].S]);
    if Interp[i].N = 2 then
     Adr1:=TAddress(@Func.Stack[Interp[i].S+1]);
  end;
end;
*)

{.241}
if Interp[i].N > 0 then
  begin
   Adr:=GetStackAddr(Interp[i].S);
    if Interp[i].N = 2 then
     Adr1:=GetStackAddr(Interp[i].S+1);
  end;



if (F_SaveStack = True) and (Interp[i].N > 0) then
begin
 if (Interp[i].N = 1) and (Interp[i].RData[0] = _MEM) then
    FLD(Adr,F_DataType)
 else
 if (Interp[i].N = 2) and (Interp[i].RData[0] = _MEM) and (Interp[i].RData[1] = _MEM) then
 begin
    FLD(Adr,F_DataType);
    FLD(Adr1,F_DataType)
 end
 else
 if (Interp[i].N = 2) and (Interp[i].RData[0] = _MEM) and (Interp[i].RData[1] = _FPU) then
 begin
    FLD(Adr,F_DataType);
    FXCH1;
 end
 else
 if (Interp[i].N = 2) and (Interp[i].RData[0] = _FPU) and (Interp[i].RData[1] = _MEM) then
 begin
    FLD(Adr1,F_DataType)
 end
end
 else
if  (F_SaveStack = False) {and (Interp[i].N = 2)} then
begin
   FLD(Adr,F_DataType);
   FLD(Adr1,F_DataType)
end;

//if Interp[i].XCHA = 1 then FXCH1;
end;






procedure TCompiler.EndFuncCom(I: Integer);
var
N,L: Cardinal;
begin
//   ( -   -)
L:=Length(Interp[i].AWCS);
N:=0;

if (L = 1)  {and  (Interp[i].Code <> 510)}  then
begin
 if (Interp[i].AWCS[0].WCS = 1) then
 begin
  if F_Mode = C_Compile {.203} then  N:=TAddress(@Func.CpSt[Interp[i].AWCS[0].MWCS]);
  FSTM(N,F_DataType);
 end;
end;

if Interp[i].AI = 1 then
begin
FAB12(I);
end;
end;




procedure TCompiler.FUNC3(I: Integer);
var
Adr,Adr1: TAddress;
begin


if Interp[i].RCS = 0 then
begin
  // .        .
 F_EnableSave:=False;   {.205}  //sin(x)+sin(x); sin(argf)+sin(argf)
(*
 Adr:=0; Adr1:=0;{.203}
 if F_Mode = C_Compile then
 begin

  if Interp[i].N > 0 then
  begin
   Adr:=TAddress(@Func.Stack[Interp[i].S]);
    if Interp[i].N = 2 then
     Adr1:=TAddress(@Func.Stack[Interp[i].S+1]);
  end;
 end;
*)

{.241}
if Interp[i].N > 0 then
  begin
   Adr:=GetStackAddr(Interp[i].S);
    if Interp[i].N = 2 then
     Adr1:=GetStackAddr(Interp[i].S+1);
  end;



 if (F_SaveStack = True) and (Interp[i].N > 0) then
 begin
   if (Interp[i].N = 1) and (Interp[i].RData[0] = _MEM) then
      FLD(Adr,F_DataType)
   else
   if (Interp[i].N = 2) and (Interp[i].RData[0] = _MEM) and (Interp[i].RData[1] = _MEM) then
   begin
     FLD(Adr,F_DataType);
     FLD(Adr1,F_DataType)
   end
   else
   if (Interp[i].N = 2) and (Interp[i].RData[0] = _MEM) and (Interp[i].RData[1] = _FPU) then
   begin
     FLD(Adr,F_DataType);
     FXCH1;
   end
   else
   if (Interp[i].N = 2) and (Interp[i].RData[0] = _FPU) and (Interp[i].RData[1] = _MEM) then
   begin
     FLD(Adr1,F_DataType)
   end
 end
 else
 if  (F_SaveStack = False) and (Interp[i].N = 2) then
 begin
   FLD(Adr,F_DataType);
   FLD(Adr1,F_DataType)
 end;

 if Interp[i].XCHA = 1 then FXCH1;


 //Arg1->ST(0); Arg2->EAX
 if Interp[i].EI = 1 then
 begin
  IAVBF(I);
 end
 else
 if Interp[i].EI = 2 then
 begin
  IAVBF(I);
  FAVBF(I);
 end
 else
 if Interp[i].EI = 3 then
 begin
  IAVBF(I);
  AAF(I);
 end
 else
 if Interp[i].EI = 4 then
 begin
  IAVBF(I);
  MAF(I);
 end
 else
 if Interp[i].EI = 5 then
 begin
  AAI1(I);
 end
 else
 if Interp[i].EI = 6 then
 begin
  FAVBF(I);
  AAI1(I);
 end
 else
 if Interp[i].EI = 7 then
 begin
  AAI1(I);
  AAF(I);
 end
 else
 if Interp[i].EI = 8 then
 begin
  MAF(I);
  AAI1(I);
 end
 else
 if Interp[i].EI = 9 then
 begin
  MEM:=WriteData(1,_Integer,_Load);
  TRUNCM(MEM);
  MOVMA(MEM);
 end
 else
 if Interp[i].EI = 10 then
 begin
  MEM:=WriteData(1,_Integer,_Load);
  TRUNCM(MEM);
  MOVMA(MEM);
  FAVBF(I);
 end
 else
 if Interp[i].EI = 11 then
 begin
  MEM:=WriteData(1,_Integer,_Load);
  TRUNCM(MEM);
  MOVMA(MEM);
  AAF(I);
 end
 else
 if Interp[i].EI = 12 then
 begin
  MEM:=WriteData(1,_Integer,_Load);
  TRUNCM(MEM);
  MOVMA(MEM);
  MAF(I);
 end;


 F_EnableSave:=True;   {.205}

end;




InsertFunc3(I);
EndFuncCom(I);
end;




procedure TCompiler.InsertFunc3(I: Integer);
var
S: String;
Adr: TAddress;
                procedure AddFunc(I,C: Integer);
                label endp;
                var
                 k: Integer;
                  begin
                  //  - = 0  inl = 1,  -    ,
                  // .  <> 0,  - : mov eax,Addr; call EAX
                  //    -   (=1)
                  //(    -  FType=3)
                  // (  )    - 
                  //    FuncList[C_FUNC].Addr=NewFuncAddr  
                  // ( )     FuncList[C_FUNC].NST=NewFuncNST
                   if C = 1 then
                   begin
                     if FuncList[Interp[I].Code].inl = 1 then
                     begin
                      for k:=0 to High(FuncList[Interp[I].Code].inlCode) do
                      begin
                       AddByte(FuncList[Interp[I].Code].inlCode[k]);
                      end;
                     end
                     else
                     if FuncList[Interp[I].Code].Addr <> nil then
                     begin
                      MOVB1(TAddress(FuncList[Interp[I].Code].Addr));
                      CALLB;
                     end;

                     SaveFuncReg(I);
                     
                     goto endp;
                   end;

                   //   C=0:
                   {case  Interp[I].Code of
                    C_IPWR:           IPWR;
                    C_IROOT:          IROOT;
                   end; }

                  endp:
                  end;

begin



//   ( -   -)
if Interp[i].RCS = 1 then
begin
 Adr:=0;
 if F_Mode = C_Compile then Adr:=TAddress(@Func.CpSt[Interp[i].MRCS]);{.203}
 FLD(Adr,F_DataType);
 {$IFDEF DEBUGS}
  {if (TestG8.Form1.CB_Cod.Checked = True)  then
  TestG8.Form1.M2.Lines[I-1]:='COPYSTACK';}
 {$ENDIF}
end
else
begin
 //           ( ):
 //(    - FType = 3)
 if (Interp[i].RCS = 0) and
   ((Length(Interp[i].AWCS) = 0) or ((Length(Interp[i].AWCS) = 1) and (Interp[i].AWCS[0].WCS = 1))) then
 begin
 //    NST
  CheckStack(FuncList[Interp[i].Code].NST);
  CheckStack(-FuncList[Interp[i].Code].NST);
  F_EnableCheckStack:=False;
  AddFunc(I,1);
  F_EnableCheckStack:=True;
 end
 else
 //      :
 //( -  FType = 3   (  ))
 begin
  AddFunc(I,0);
 end;


end;



end;



procedure TCompiler.IPWR_B;
begin
MOVB1(TAddress(@R_IPWR));
CALLB;
SetReg(1);
SetReg(3);
SetReg(4);
end;




procedure TCompiler.FUNC4(I: Integer);
var
S: String;
Adr,Adr1: TAddress;
begin



if Interp[i].RCS = 0 then
begin
  // .        .
 F_EnableSave:=False;   {.205}  //sin(x)+sin(x); sin(argf)+sin(argf)

 (*
 Adr:=0; Adr1:=0;{.203}
 if F_Mode = C_Compile then
 begin
  if Interp[i].N > 0 then
   begin
    Adr:=TAddress(@Func.Stack[Interp[i].S]);
     if Interp[i].N = 2 then
      Adr1:=TAddress(@Func.Stack[Interp[i].S+1]);
   end;
 end;
 *)
 {.241}
if Interp[i].N > 0 then
  begin
   Adr:=GetStackAddr(Interp[i].S);
    if Interp[i].N = 2 then
     Adr1:=GetStackAddr(Interp[i].S+1);
  end;

if (F_SaveStack = True) and (Interp[i].N > 0) then
begin
 if (Interp[i].N = 1) and (Interp[i].RData[0] = _MEM) then
    FLD(Adr,F_DataType)
 else
 if (Interp[i].N = 2) and (Interp[i].RData[0] = _MEM) and (Interp[i].RData[1] = _MEM) then
 begin
    FLD(Adr,F_DataType);
    FLD(Adr1,F_DataType)
 end
 else
 if (Interp[i].N = 2) and (Interp[i].RData[0] = _MEM) and (Interp[i].RData[1] = _FPU) then
 begin
    FLD(Adr,F_DataType);
    FXCH1;
 end
 else
 if (Interp[i].N = 2) and (Interp[i].RData[0] = _FPU) and (Interp[i].RData[1] = _MEM) then
 begin
    FLD(Adr1,F_DataType)
 end
end
 else
if  (F_SaveStack = False) and (Interp[i].N = 2) then
begin
   FLD(Adr,F_DataType);
   FLD(Adr1,F_DataType)
end;

if Interp[i].XCHA = 1 then FXCH1;

//Arg1->ST(0); Arg2->ST(1)
 if Interp[i].EI = 1 then
 begin
  {}
 end
 else
 if Interp[i].EI = 2 then
 begin
  FAVBF(I);
 end
 else
 if Interp[i].EI = 3  then
 begin
  AAF(I);
 end
 else
 if Interp[i].EI = 4 then
 begin
  MAF(I);
 end
 else
 if Interp[i].EI = 5 then
 begin
  FAVBF1(I);
  FXCH1;
 end
 else
 if Interp[i].EI = 6  then
 begin
  FAVBF1(I);
  FAVBF(I);
 end
 else
 if Interp[i].EI = 7  then
 begin
  FAVBF1(I);
  AAF(I);
 end
 else
 if Interp[i].EI = 8  then
 begin
  FAVBF1(I);
  MAF(I);
 end
 else
 if Interp[i].EI = 10 then
 begin
  AAF(I);
  FAVBF1(I);
 end
 else
 if Interp[i].EI = 12 then
 begin
  MAF(I);
  FAVBF1(I);
 end
 else
 if Interp[i].EI = 9 then
 begin
  AAF(I);
  FXCH1;
 end
 else
 if Interp[i].EI = 11 then
 begin
  MAF(I);
  FXCH1;
 end;


 F_EnableSave:=True;   {.205}

end;

InsertFunc4(I);
EndFuncCom(I);
end;





procedure TCompiler.InsertFunc4(I: Integer);
var
S: String;
Adr: TAddress;
                procedure AddFunc(I,C: Integer);
                label endp;
                var
                 k: Integer;
                  begin
                  //  - = 0  inl = 1,  -    ,
                  // .  <> 0,  - : mov eax,Addr; call EAX
                  //    -   (=1)
                  //(    -  FType=4)
                  // (  )    - 
                  //    FuncList[C_FUNC].Addr=NewFuncAddr  
                  // ( )     FuncList[C_FUNC].NST=NewFuncNST
                   if C = 1 then
                   begin
                     if FuncList[Interp[I].Code].inl = 1 then
                     begin
                      for k:=0 to High(FuncList[Interp[I].Code].inlCode) do
                      begin
                       AddByte(FuncList[Interp[I].Code].inlCode[k]);
                      end
                     end
                     else
                     if FuncList[Interp[I].Code].Addr <> nil then
                     begin
                      MOVA1(TAddress(FuncList[Interp[I].Code].Addr));
                      CALLA;
                     end;

                     SaveFuncReg(I);

                     goto endp;
                   end;

                   //   C=0:
                   {case  Interp[I].Code of
                    C_FPWR:           FPWR;
                    C_FROOT:          FROOT;
                   end;}

                  endp:
                  end;

begin



//   ( -   -)
if Interp[i].RCS = 1 then
begin
 Adr:=0;
 if F_Mode = C_Compile then Adr:=TAddress(@Func.CpSt[Interp[i].MRCS]);{.203}
 FLD(Adr,F_DataType);
 {$IFDEF DEBUGS}
  {if (TestG8.Form1.CB_Cod.Checked = True)  then
  TestG8.Form1.M2.Lines[I-1]:='COPYSTACK';}
 {$ENDIF}
end
else
begin
 //           ( ):
 //(    - FType = 4)
 if (Interp[i].RCS = 0) and
   ((Length(Interp[i].AWCS) = 0) or ((Length(Interp[i].AWCS) = 1) and (Interp[i].AWCS[0].WCS = 1))) then
 begin
 //    NST
  CheckStack(FuncList[Interp[i].Code].NST);
  CheckStack(-FuncList[Interp[i].Code].NST-1); //..  
  F_EnableCheckStack:=False;
  AddFunc(I,1);
  F_EnableCheckStack:=True;
 end
 else
 //      :
 //( -  FType = 4   (  ))
 begin
  AddFunc(I,0);
 end;


end;



end;






procedure TCompiler.SQR;
begin
FMUL0;
end;



procedure TCompiler.IPWR3;
begin
FLD0;
FMUL0;
FMULP1;
end;



procedure TCompiler.IPWR4;
begin
FMUL0;
FMUL0;
end;



procedure TCompiler.IPWR5;
begin
FLD0;
FMUL0;
FMUL0;
FMULP1;
end;



procedure TCompiler.IPWR6;
begin
FMUL0;
FLD0;
FMUL0;
FMULP1;
end;




procedure TCompiler.IPWR7;
begin
FLD0;
FMUL0;
FLD0;
FMUL0;
FMULP1;
FMULP1;
end;



procedure TCompiler.IPWR8;
begin
FMUL0;
FMUL0;
FMUL0;
end;



procedure TCompiler.IPWR9;
begin
FLD0;
FMUL0;
FMUL0;
FMUL0;
FMULP1;
end;






procedure TCompiler.IPWR10;
begin
FMUL0;
FLD0;
FMUL0;
FMUL0;
FMULP1;
end;




procedure TCompiler.IPWR11;
begin
FLD0;
FMUL0;
FLD0;
FMUL0;
FMUL0;
FMULP1;
FMULP1;
end;




procedure TCompiler.IPWR12;
begin
FMUL0;
FMUL0;
FLD0;
FMUL0;
FMULP1;
end;




procedure TCompiler.IPWR13;
begin
FLD0;
FMUL0;
FMUL0;
FLD0;
FMUL0;
FMULP1;
FMULP1;
end;




procedure TCompiler.IPWR14;
begin
FMUL0;
FLD0;
FMUL0;
FLD0;
FMUL0;
FMULP1;
FMULP1;
end;






procedure TCompiler.IPWR15;
begin
FLD0;
FLD0;
FMUL0;
FLD0;
FMUL0;
FMULP1;
FMULP1;
FMUL0;
FMULP1;
end;





procedure TCompiler.IPWR16;
begin
FMUL0;
FMUL0;
FMUL0;
FMUL0;
end;






procedure TCompiler.FSIN;
begin
 AddWord($D9,$FE);
end;


procedure TCompiler.FSTM(N: TAddress; VType: Integer);
begin
 if VType = _Extended then
 begin
  FLD0;
  FSTPM(N,_Extended)
 end
 else
 if VType = _Double then
 begin
  AddCom($DD,$15,N);
 end
 else
 if VType = _Single then
 begin
   AddCom($D9,$15,N);
 end;
end;


procedure TCompiler.FSQRT;
begin
AddWord($D9,$FA);
end;



procedure TCompiler.FPWR;
begin
MOVA1(TAddress(@R_FPWR));
CALLA;
CheckStack(1);
CheckStack(-2);
end;



procedure TCompiler.LOGN;
begin
MOVA1(TAddress(@R_LOGN));
CALLA;
CheckStack(1);
CheckStack(-2);
SetReg(1);
end;







procedure TCompiler.InsertFunc2(I: Integer);
var
S: String;
Adr: TAddress;
                procedure AddFunc(I,C: Integer);
                label endp;
                var
                 k: Integer;
                  begin
                  //  - = 0  inl = 1,  -    ,
                  // .  <> 0,  - : mov eax,Addr; call EAX
                  //    -   (=1)
                  //(    -  FType=2)
                  // (  )    - 
                  //    FuncList[C_FUNC].Addr=NewFuncAddr  
                  // ( )     FuncList[C_FUNC].NST=NewFuncNST
                   if C = 1 then
                   begin
                     if FuncList[Interp[I].Code].inl = 1 then
                     begin
                      for k:=0 to High(FuncList[Interp[I].Code].inlCode) do
                      begin
                       AddByte(FuncList[Interp[I].Code].inlCode[k]);
                      end;
                     end
                     else
                     if FuncList[Interp[I].Code].Addr <> nil then
                     begin
                      MOVA1(TAddress(FuncList[Interp[I].Code].Addr));
                      CALLA;
                     end;

                     SaveFuncReg(I);
                     goto endp;
                   end;

                   //   C=0:
                   case  Interp[I].Code of
                    C_SIN:             SIN;
                    C_COS:             COS;
                    C_TAN:             FTAN;
                    C_SQR:             SQR;
                    C_SINH:            SINH;
                    C_SQRT:            FSQRT;
                    C_ARCTAN:          FATAN;
                    C_ARCSIN:          ARCSIN;
                    C_ARCCOS:          ARCCOS;
                    C_COTAN:           COTAN;
                    C_ARCCOTAN:        ARCCOTAN;
                    C_EXP:             EXP;
                    C_LN:              LN;
                    C_LOG10:           LOG10;
                    C_LOG2:            LOG2;
                    C_COSH:            COSH;
                    C_TANH:            TANH;
                    C_COTANH:          COTANH;
                    C_ARCSINH:         ARCSINH;
                    C_ARCCOSH:         ARCCOSH;
                    C_ARCTANH:         ARCTANH;
                    C_ARCCOTANH:       ARCCOTANH;
                    C_ABS:             FABS;
                    C_TRUNC:           FTRUNC;
                    C_IPWR3:           IPWR3;
                    C_IPWR4:           IPWR4;
                    C_IPWR5:           IPWR5;
                    C_IPWR6:           IPWR6;
                    C_IPWR7:           IPWR7;
                    C_IPWR8:           IPWR8;
                    C_IPWR9:           IPWR9;
                    C_IPWR10:          IPWR10;
                    C_IPWR11:          IPWR11;
                    C_IPWR12:          IPWR12;
                    C_IPWR13:          IPWR13;
                    C_IPWR14:          IPWR14;
                    C_IPWR15:          IPWR15;
                    C_IPWR16:          IPWR16;
                   end;

                  endp:
                  end;

begin



//   ( -   -)
if Interp[i].RCS = 1 then
begin
 //FLD(TAddress(@Func.CpSt[Interp[i].MRCS]));
 Adr:=0;
 if F_Mode = C_Compile then  Adr:=TAddress(@Func.CpSt[Interp[i].MRCS]);   {.203}
 FLD(Adr,F_DataType);

 {$IFDEF DEBUGS}
  {if (TestG8.Form1.CB_Cod.Checked = True)  then
  TestG8.Form1.M2.Lines[I-1]:='COPYSTACK';}
 {$ENDIF}
end
else
begin
 //           ( ):
 //(    -  FType=2)
 if (Interp[i].RCS = 0) and
   ((Length(Interp[i].AWCS) = 0) or ((Length(Interp[i].AWCS) = 1) and (Interp[i].AWCS[0].WCS = 1))) then
 begin
 //    NST
  CheckStack(FuncList[Interp[i].Code].NST);
  CheckStack(-FuncList[Interp[i].Code].NST);
  F_EnableCheckStack:=False;
  AddFunc(I,1);
  F_EnableCheckStack:=True;
 end
 else
 //      :
 begin
  AddFunc(I,0);
 end;


end;



end;







procedure TCompiler.FUNC2(I: Integer);
var
S: String;
Adr: TAddress;
begin
if Interp[i].RCS  = 0 then
begin
 // .        .
 F_EnableSave:=False;   {.205}  //sin(x)+sin(x); sin(argf)+sin(argf)

 if Interp[i].EI = 2 then FAVBF(I)
 else
 if Interp[i].EI = 3 then AAF(I)
 else
 if Interp[i].EI = 4 then MAF(I)
 else
 if Interp[i].EI = 5 then AIFB(I)
 else
 if (Interp[i].EI = 1) and (F_SaveStack = True) and (Interp[i].RData[0] = _MEM) then
 {Stack}
 begin
   //Adr:=0; {.203}
   //if F_Mode = C_Compile then Adr:=TAddress(@Func.Stack[Interp[i].S]);
   Adr:=GetStackAddr(Interp[i].S); {.241}
   FLD(Adr,F_DataType);
 end;

 F_EnableSave:=True;
end;

InsertFunc2(I);
EndFuncCom(I);
end;


procedure TCompiler.FCOS;
begin
 AddCom($D9,$FF);
end;

procedure TCompiler.FPTAN;
begin
 AddCom($D9,$F2);
 CheckStack(1);
end;

procedure TCompiler.FPATAN;
begin
 AddCom($D9,$F3);
end;


procedure TCompiler.FSCALE;
begin
 AddCom($D9,$FD);
 CheckStack(-1);
end;

procedure TCompiler.FLD1;
begin
 AddWord($D9,$E8);
 CheckStack(1);
end;

procedure TCompiler.FLDZ;
begin
 AddWord($D9,$EE);
 CheckStack(1);
end;

procedure TCompiler.FLD0;
begin
 AddWord($D9,$C0);
 CheckStack(1);
end;

procedure TCompiler.FSTP0;
begin
 AddWord($DD,$D8);
 CheckStack(-1);
end;

procedure TCompiler.FSTP1;
begin
 AddWord($DD,$D9);
 CheckStack(-1);
end;

procedure TCompiler.FTAN;
begin
 FPTAN;
 FSTP0;
end;

procedure TCompiler.FATAN;
begin
 FLD1;
 FPATAN;
 CheckStack(-1);
end;


procedure TCompiler.SINH;
label endp;
var
L,N: Cardinal;
N1,N2,N3,P: Integer;
Adr: TAddress;
begin


P:=Interp[CNI].RCS;  //  (1-sh;2-exp,1/exp;3-exp)
L:=Length(Interp[CNI].AWCS);
N1:=-1; N2:=-1; N3:=-1; //  (   . ) (1-sh;2-exp,1/exp;3-exp)
if L = 1 then
begin
 if Interp[CNI].AWCS[0].WCS = 1 then N1:=0
 else
 if Interp[CNI].AWCS[0].WCS = 2 then N2:=0
 else
 if Interp[CNI].AWCS[0].WCS = 3 then N3:=0
end
else
if L = 2 then
begin
 if Interp[CNI].AWCS[0].WCS = 1 then N1:=0
 else
 if Interp[CNI].AWCS[0].WCS = 2 then N2:=0
 else
 if Interp[CNI].AWCS[0].WCS = 3 then N3:=0;
 if Interp[CNI].AWCS[1].WCS = 1 then N1:=1
 else
 if Interp[CNI].AWCS[1].WCS = 2 then N2:=1
 else
 if Interp[CNI].AWCS[1].WCS = 3 then N3:=1
end
else
if L = 3 then
begin
 if Interp[CNI].AWCS[0].WCS = 1 then N1:=0
 else
 if Interp[CNI].AWCS[0].WCS = 2 then N2:=0
 else
 if Interp[CNI].AWCS[0].WCS = 3 then N3:=0;
 if Interp[CNI].AWCS[1].WCS = 1 then N1:=1
 else
 if Interp[CNI].AWCS[1].WCS = 2 then N2:=1
 else
 if Interp[CNI].AWCS[1].WCS = 3 then N3:=1;
 if Interp[CNI].AWCS[2].WCS = 1 then N1:=1
 else
 if Interp[CNI].AWCS[2].WCS = 2 then N2:=1
 else
 if Interp[CNI].AWCS[2].WCS = 3 then N3:=1;

end;


//       :
if P > 1 then
begin

 //exp->
 if P = 3 then
 begin

  Adr:=0;
  if F_Mode = C_Compile then  Adr:=TAddress(@Func.CpSt[Interp[CNI].MRCS]); {.203}

  FLD(Adr,F_DataType);

  //->exp
  if N2 <> -1 then
  begin
   Adr:=0;
   if F_Mode = C_Compile then Adr:=TAddress(@Func.CpSt[Interp[CNI].AWCS[N2].MWCS-1]);   {.203}
   FSTM(Adr,F_DataType);
  end;

  {1/EXP:}
  FLD0;
  //FDIVR1;
  FDIVR(TAddress(@C1),_Double); //instead fdivr1; only for FPC (unknown error in FPC)

  //1/exp:
  if N2 <> -1 then
  begin
   Adr:=0;
   if F_Mode = C_Compile then Adr:=TAddress(@Func.CpSt[Interp[CNI].AWCS[N2].MWCS]);   {.203}
   FSTM(Adr,F_DataType);
  end;

  //sinh:
  FSUB;
  FMUL(TAddress(@C05),_Double);

  if (L > 1) and (N1 <> -1) then //   L=1  EndFuncCom
  begin
   Adr:=0;
   if F_Mode = C_Compile then Adr:=TAddress(@Func.CpSt[Interp[CNI].AWCS[N1].MWCS-1]);   {.203}
   FSTM(Adr,F_DataType);
  end
 end
 else
 if P = 2 then
 begin
   //EXP
   Adr:=0;
   if F_Mode = C_Compile then Adr:=TAddress(@Func.CpSt[Interp[CNI].MRCS-1]);    {.203}
   FLD(Adr,F_DataType);
   //EXP-1/EXP
   Adr:=0;
   if F_Mode = C_Compile then Adr:=TAddress(@Func.CpSt[Interp[CNI].MRCS]);   {.203}
   FSUB(Adr,F_DataType);
   FMUL(TAddress(@C05),_Double);
  {  ,    : (L = 1;N1 <> -1) -   EndFuncCom)}
 end;

 {$IFDEF DEBUGS}
   {if (TestG8.Form1.CB_Cod.Checked = True)  then
   TestG8.Form1.M2.Lines[CNI-1]:='COPYSTACK'; }
 {$ENDIF}

 goto endp;
end;






//        ( ):
if (L = 0) or ((L = 1) and (Interp[CNI].AWCS[0].WCS = 1)) then
begin
 MOVA1(TAddress(@R_SINH));
 CALLA;
 CheckStack(2);
 CheckStack(-2);
 goto endp;
end;



//       :
if (P = 0) and (L >= 1) then
begin
 {EXP:}
 EXP;


 //->exp:
 if N3 <> -1 then
 begin
  N:=0;
  if F_Mode = C_Compile then N:=TAddress(@Func.CpSt[Interp[CNI].AWCS[N3].MWCS]); {.203}
  FSTM(N,F_DataType);
 end;

  //->exp
 if N2 <> -1 then
 begin
  Adr:=0;
  if F_Mode = C_Compile then Adr:=TAddress(@Func.CpSt[Interp[CNI].AWCS[N2].MWCS-1]);    {.203}
  FSTM(Adr,F_DataType);
 end;

 {1/EXP:}
 FLD0;
 //FDIVR1;
 FDIVR(TAddress(@C1),_Double); //instead fdivr1; only for FPC (unknown error in FPC)


 //1/exp:
 if N2 <> -1 then
 begin
  Adr:=0;
  if F_Mode = C_Compile then Adr:=TAddress(@Func.CpSt[Interp[CNI].AWCS[N2].MWCS]);    {.203}
  FSTM(Adr,F_DataType);
 end;

 //sinh:
 FSUB;
 FMUL(TAddress(@C05),_Double);

 if (L > 1) and (N1 <> -1) then
 begin
  N:=0;
  if F_Mode = C_Compile then N:=TAddress(@Func.CpSt[Interp[CNI].AWCS[N1].MWCS]); {.203}
  FSTM(N,F_DataType);
 end;

end;


endp:
end;



procedure TCompiler.COTAN;
label endp;
var
L,N: Cardinal;
N1,N2,P: Integer;
Adr: TAddress;
begin


P:=Interp[CNI].RCS; //  (1-cotan,tan)
L:=Length(Interp[CNI].AWCS);
//  (   . ) (N1-cotan,N2-tan)
N1:=-1; N2:=-1;
if L = 1 then
begin
 if Interp[CNI].AWCS[0].WCS = 1 then N1:=0
 else
 if Interp[CNI].AWCS[0].WCS = 2 then N2:=0;
end
else
if L = 2 then
begin
 if Interp[CNI].AWCS[0].WCS = 1 then N1:=0
 else
 if Interp[CNI].AWCS[0].WCS = 2 then N2:=0;
 if Interp[CNI].AWCS[1].WCS = 1 then N1:=1
 else
 if Interp[CNI].AWCS[1].WCS = 2 then N2:=1;
end;

//       :
if P <> 0 then
begin

 //tan->
 if P = 2 then
 begin
  FLD1;

  Adr:=0;
  if F_Mode = C_Compile then Adr:=TAddress(@Func.CpSt[Interp[CNI].MRCS]);  {.203}

  FDIV(Adr,F_DataType);
 end;

 {$IFDEF DEBUGS}
   {if (TestG8.Form1.CB_Cod.Checked = True)  then
   TestG8.Form1.M2.Lines[CNI-1]:='COPYSTACK'; }
 {$ENDIF}

 goto endp;
end;


//        ( ):
if (L = 0) or ((L = 1) and (Interp[CNI].AWCS[0].WCS = 1)) then
begin
 FPTAN;
 FDIVRP;
 goto endp;
end;




//       :
if (P = 0) and (L >= 1) then
begin
 FPTAN;
 FXCH1;

 //->tan:
 if N2 <> -1 then
 begin
  Adr:=0;
  if F_Mode = C_Compile then Adr:=TAddress(@Func.CpSt[Interp[CNI].AWCS[N2].MWCS]);  {.203}

  FSTM(Adr,F_DataType);
 end;

 FXCH1;
 FDIVRP;

 if (L > 1) and (N1 <> -1) then
 begin
  Adr:=0;
  if F_Mode = C_Compile then Adr:=TAddress(@Func.CpSt[Interp[CNI].AWCS[N1].MWCS]);  {.203}

  FSTM(Adr,F_DataType);
 end;

end;

endp:
end;




procedure TCompiler.ARCSIN;
label endp;
var
L,N: Cardinal;
N1,P: Integer;
Adr: TAddress;
begin


P:=Interp[CNI].RCS; //  (1-asin,2-acos)
L:=Length(Interp[CNI].AWCS);
N1:=-1;   //  (   . ) (N1-asin)

//       :
if P <> 0 then
begin

 //acos->
 if P = 2 then
 begin
  if (F_DataType = _Double) or (F_DataType = _Single) then
  FLD(TAddress(@D_CPid2),_Double)
  else
  FLD(TAddress(@E_CPid2),_Extended);

  Adr:=0;
  if F_Mode = C_Compile then Adr:=TAddress(@Func.CpSt[Interp[CNI].MRCS]);  {.203}

  FSUB(Adr,F_DataType);
 end;

 {$IFDEF DEBUGS}
   {if (TestG8.Form1.CB_Cod.Checked = True)  then
   TestG8.Form1.M2.Lines[CNI-1]:='COPYSTACK';}
 {$ENDIF}

 goto endp;
end;


//        ( ):
if P = 0 then
begin
 MOVA1(TAddress(@R_ARCSIN));
 CALLA;
 CheckStack(1);
 CheckStack(-1);
 goto endp;
end;

endp:
end;




procedure TCompiler.ARCCOS;
label endp;
var
L,N: Cardinal;
N1,P: Integer;
Adr: TAddress;
begin


P:=Interp[CNI].RCS; //  (1-acos,2-asin)
L:=Length(Interp[CNI].AWCS);

//       :
if P <> 0 then
begin

 //asin->
 if P = 2 then
 begin
  if (F_DataType = _Double) or (F_DataType = _Single) then
  FLD(TAddress(@D_CPid2),_Double)
  else
  FLD(TAddress(@E_CPid2),_Extended);

  Adr:=0;
  if F_Mode = C_Compile then Adr:=TAddress(@Func.CpSt[Interp[CNI].MRCS]);  {.203}

  FSUB(Adr,F_DataType);
 end;

 {$IFDEF DEBUGS}
 {if (TestG8.Form1.CB_Cod.Checked = True)  then
 TestG8.Form1.M2.Lines[CNI-1]:='COPYSTACK'; }
 {$ENDIF}

 goto endp;
end;






//        ( ):
if P = 0 then
begin
 MOVA1(TAddress(@R_ARCCOS));
 CALLA;
 CheckStack(1);
 CheckStack(-1);
 goto endp;
end;


endp:
end;




procedure TCompiler.ARCCOTAN;
label endp;
var
L,N: Cardinal;
N1,N2,P: Integer;
Adr: TAddress;
begin


P:=Interp[CNI].RCS; //  (1-acotan,atan)
L:=Length(Interp[CNI].AWCS);
//  (   . ) (N1-acotan,N2-atan)
N1:=-1; N2:=-1;
if L = 1 then
begin
 if Interp[CNI].AWCS[0].WCS = 1 then N1:=0
 else
 if Interp[CNI].AWCS[0].WCS = 2 then N2:=0;
end
else
if L = 2 then
begin
 if Interp[CNI].AWCS[0].WCS = 1 then N1:=0
 else
 if Interp[CNI].AWCS[0].WCS = 2 then N2:=0;
 if Interp[CNI].AWCS[1].WCS = 1 then N1:=1
 else
 if Interp[CNI].AWCS[1].WCS = 2 then N2:=1;
end;

//       :
if P <> 0 then
begin

 //->atan
 if P = 2 then
 begin
  if (F_DataType = _Double) or (F_DataType = _Single) then
  FLD(TAddress(@D_CPid2),_Double)
  else
  FLD(TAddress(@E_CPid2),_Extended);

  Adr:=0;
  if F_Mode = C_Compile then Adr:=TAddress(@Func.CpSt[Interp[CNI].MRCS]);  {.203}
  FSUB(Adr,F_DataType);
 end;

 {$IFDEF DEBUGS}
 {if (TestG8.Form1.CB_Cod.Checked = True)  then
 TestG8.Form1.M2.Lines[CNI-1]:='COPYSTACK';}
 {$ENDIF}

 goto endp;
end;


//        ( ):
if (L = 0) or ((L = 1) and (Interp[CNI].AWCS[0].WCS = 1)) then
begin
 FLD1;
 FPATAN;
 if (F_DataType = _Double) or (F_DataType = _Single) then
 FSUBR(TAddress(@D_CPid2),_Double)
 else
 FSUBR(TAddress(@E_CPid2),_Extended);
 goto endp;
end;






//       :
if (P = 0) and (L >= 1) then
begin
 FLD1;
 FPATAN;

 //->atan:
 if N2 <> -1 then
 begin
  Adr:=0;
  if F_Mode = C_Compile then Adr:=TAddress(@Func.CpSt[Interp[CNI].AWCS[N2].MWCS]);   {.203}
  FSTM(Adr,F_DataType);
 end;

 if (F_DataType = _Double) or (F_DataType = _Single) then
 FSUBR(TAddress(@D_CPid2),_Double)
 else
 FSUBR(TAddress(@E_CPid2),_Extended);

 if (L > 1) and (N1 <> -1) then
 begin
  Adr:=0;
  if F_Mode = C_Compile then Adr:=TAddress(@Func.CpSt[Interp[CNI].AWCS[N1].MWCS]);  {.203}
  FSTM(Adr,F_DataType);
 end;

end;



endp:
end;




procedure TCompiler.SIN;
label endp;
var
L,N: Cardinal;
N1,N2,P: Integer;
Adr: TAddress;
begin


P:=Interp[CNI].RCS;
L:=Length(Interp[CNI].AWCS);
//  (   . ) (N1-sin,N2-cos)
N1:=-1; N2:=-1;
if L = 1 then
begin
 if Interp[CNI].AWCS[0].WCS = 1 then N1:=0
 else
 if Interp[CNI].AWCS[0].WCS = 2 then N2:=0;
end
else
if L = 2 then
begin
 if Interp[CNI].AWCS[0].WCS = 1 then N1:=0
 else
 if Interp[CNI].AWCS[0].WCS = 2 then N2:=0;

 if Interp[CNI].AWCS[1].WCS = 1 then N1:=1
 else
 if Interp[CNI].AWCS[1].WCS = 2 then N2:=1;
end;



//        ( ):
if (L = 0) or ((L = 1) and (Interp[CNI].AWCS[0].WCS = 1)) then
begin
 FSIN;
 goto endp;
end;



//       :
//sin->cos  sin->sin,cos
if (P = 0) and (((L = 1) and (Interp[CNI].AWCS[0].WCS = 2)) or (L = 2)) then
begin
 FSINCOS;


 //->cos:
 if N2 <> -1 then
 begin
  N:=0;
  if F_Mode = C_Compile then N:=TAddress(@Func.CpSt[Interp[CNI].AWCS[N2].MWCS]);  {.203}
  FSTPM(N,F_DataType);
 end;


 //->sin
 if {(L > 1) and} (N1 <> -1) then
 begin
  N:=0;
  if F_Mode = C_Compile then N:=TAddress(@Func.CpSt[Interp[CNI].AWCS[N1].MWCS]);  {.203}
  FSTM(N,F_DataType);
 end;

end;



endp:
end;






procedure TCompiler.COS;
label endp;
var
L,N: Cardinal;
N1,N2,P: Integer;
Adr: TAddress;
begin


P:=Interp[CNI].RCS;
L:=Length(Interp[CNI].AWCS);
//  (   . ) (N1-sin,N2-cos)
N1:=-1; N2:=-1;
if L = 1 then
begin
 if Interp[CNI].AWCS[0].WCS = 1 then N1:=0
 else
 if Interp[CNI].AWCS[0].WCS = 2 then N2:=0;
end
else
if L = 2 then
begin
 if Interp[CNI].AWCS[0].WCS = 1 then N1:=0
 else
 if Interp[CNI].AWCS[0].WCS = 2 then N2:=0;

 if Interp[CNI].AWCS[1].WCS = 1 then N1:=1
 else
 if Interp[CNI].AWCS[1].WCS = 2 then N2:=1;
end;



//        ( ):
if (L = 0) or ((L = 1) and (Interp[CNI].AWCS[0].WCS = 1)) then
begin
 FCOS;
 goto endp;
end;



//       :
//cos->sin  cos->cos,sin
if (P = 0) and (((L = 1) and (Interp[CNI].AWCS[0].WCS = 2)) or (L = 2)) then
begin
 FSINCOS;
 FXCH1;


 //->sin:
 if N2 <> -1 then
 begin
  N:=0;
  if F_Mode = C_Compile then  N:=TAddress(@Func.CpSt[Interp[CNI].AWCS[N2].MWCS]);   {.203}
  FSTPM(N,F_DataType);
 end;


 //->cos
 if {(L > 1) and} (N1 <> -1) then
 begin
  N:=0;
  if F_Mode = C_Compile then  N:=TAddress(@Func.CpSt[Interp[CNI].AWCS[N1].MWCS]); {.203}
  FSTM(N,F_DataType);
 end;

end;



endp:
end;



procedure TCompiler.EXP;
begin
 MOVA1(TAddress(@R_EXP));
 CALLA;
 CheckStack(2);
 CheckStack(-2);
end;




procedure TCompiler.LN;
begin
 FLDLN2;
 FXCH1;
 FYL2X;
end;


procedure TCompiler.LOG10;
begin
 FLDLG2;
 FXCH1;
 FYL2X;
end;


procedure TCompiler.LOG2;
begin
 FLD1;
 FXCH1;
 FYL2X;
end;




procedure TCompiler.COSH;
label endp;
var
L,N: Cardinal;
N1,N2,N3,P: Integer;
Adr: TAddress;
begin


P:=Interp[CNI].RCS;
L:=Length(Interp[CNI].AWCS);
N1:=-1; N2:=-1; N3:=-1;
if L = 1 then
begin
 if Interp[CNI].AWCS[0].WCS = 1 then N1:=0
 else
 if Interp[CNI].AWCS[0].WCS = 2 then N2:=0
 else
 if Interp[CNI].AWCS[0].WCS = 3 then N3:=0
end
else
if L = 2 then
begin
 if Interp[CNI].AWCS[0].WCS = 1 then N1:=0
 else
 if Interp[CNI].AWCS[0].WCS = 2 then N2:=0
 else
 if Interp[CNI].AWCS[0].WCS = 3 then N3:=0;
 if Interp[CNI].AWCS[1].WCS = 1 then N1:=1
 else
 if Interp[CNI].AWCS[1].WCS = 2 then N2:=1
 else
 if Interp[CNI].AWCS[1].WCS = 3 then N3:=1
end
else
if L = 3 then
begin
 if Interp[CNI].AWCS[0].WCS = 1 then N1:=0
 else
 if Interp[CNI].AWCS[0].WCS = 2 then N2:=0
 else
 if Interp[CNI].AWCS[0].WCS = 3 then N3:=0;
 if Interp[CNI].AWCS[1].WCS = 1 then N1:=1
 else
 if Interp[CNI].AWCS[1].WCS = 2 then N2:=1
 else
 if Interp[CNI].AWCS[1].WCS = 3 then N3:=1;
 if Interp[CNI].AWCS[2].WCS = 1 then N1:=1
 else
 if Interp[CNI].AWCS[2].WCS = 2 then N2:=1
 else
 if Interp[CNI].AWCS[2].WCS = 3 then N3:=1;

end;


//       :
if P > 1 then
begin

 //exp->
 if P = 3 then
 begin
  //FLD(TAddress(@Func.CpSt[Interp[CNI].MRCS]));
  Adr:=0;

 if F_Mode = C_Compile then   Adr:=TAddress(@Func.CpSt[Interp[CNI].MRCS]); {.203}

 FLD(Adr,F_DataType);

  //->exp
  if N2 <> -1 then
  begin
   Adr:=0;
   if F_Mode = C_Compile then   Adr:=TAddress(@Func.CpSt[Interp[CNI].AWCS[N2].MWCS-1]); {.203}
   FSTM(Adr,F_DataType);
  end;

  {1/EXP:}
  FLD0;
  //FDIVR1;
  FDIVR(TAddress(@C1),_Double); //instead fdivr1; only for FPC (unknown error in FPC)



  //1/exp:
  if N2 <> -1 then
  begin
   Adr:=0;
   if F_Mode = C_Compile then   Adr:=TAddress(@Func.CpSt[Interp[CNI].AWCS[N2].MWCS]); {.203}
   FSTM(Adr,F_DataType);
  end;

  //cosh:
  FADD;
  FMUL(TAddress(@C05),_Double);

  if (L > 1) and (N1 <> -1) then //   L=1  EndFuncCom
  begin
   Adr:=0;
   if F_Mode = C_Compile then   Adr:=TAddress(@Func.CpSt[Interp[CNI].AWCS[N1].MWCS]); {.203}
   FSTM(Adr,F_DataType);
  end
 end
 else
 if P = 2 then
 begin
   //EXP
   //FLD(TAddress(@Func.CpSt[Interp[CNI].MRCS-1]));
   Adr:=0;
   if F_Mode = C_Compile then   Adr:=TAddress(@Func.CpSt[Interp[CNI].MRCS-1]);  {.203}
   FLD(Adr,F_DataType);

   //EXP+1/EXP
   Adr:=0;
   if F_Mode = C_Compile then   Adr:=TAddress(@Func.CpSt[Interp[CNI].MRCS]);   {.203}
   FADD(Adr,F_DataType);
   FMUL(TAddress(@C05),_Double);
  {  ,    : (L = 1;N1 <> -1) -   EndFuncCom)}
 end;

 {$IFDEF DEBUGS}
 {if (TestG8.Form1.CB_Cod.Checked = True)  then
 TestG8.Form1.M2.Lines[CNI-1]:='COPYSTACK'; }
 {$ENDIF}

 goto endp;
end;






//        ( ):
if (L = 0) or ((L = 1) and (Interp[CNI].AWCS[0].WCS = 1)) then
begin
 MOVA1(TAddress(@R_COSH));
 CALLA;
 CheckStack(2);
 CheckStack(-2);
 goto endp;
end;



//       :
if (P = 0) and (L >= 1) then
begin
 {EXP:}
 EXP;

 //->exp:
 if N3 <> -1 then
 begin
  Adr:=0;
  if F_Mode = C_Compile then   Adr:=TAddress(@Func.CpSt[Interp[CNI].AWCS[N3].MWCS]);   {.203}
  FSTM(Adr,F_DataType);
 end;

  //->exp
 if N2 <> -1 then
 begin
  Adr:=0;
  if F_Mode = C_Compile then   Adr:=TAddress(@Func.CpSt[Interp[CNI].AWCS[N2].MWCS-1]); {.203}
  FSTM(Adr,F_DataType);
 end;

 {1/EXP:}
 FLD0;
 //FDIVR1;
 FDIVR(TAddress(@C1),_Double); //instead fdivr1; only for FPC (unknown error in FPC)


 //1/exp:
 if N2 <> -1 then
 begin
  Adr:=0;
  if F_Mode = C_Compile then   Adr:=TAddress(@Func.CpSt[Interp[CNI].AWCS[N2].MWCS]);  {.203}
  FSTM(Adr,F_DataType);
 end;

 //cosh:
 FADD;
 FMUL(TAddress(@C05),_Double);

 if (L > 1) and (N1 <> -1) then
 begin
  Adr:=0;
  if F_Mode = C_Compile then   Adr:=TAddress(@Func.CpSt[Interp[CNI].AWCS[N1].MWCS]);  {.203}
  FSTM(Adr,F_DataType);
 end;

end;


endp:
end;





procedure TCompiler.TANH;
label endp;
var
L,N: Cardinal;
N1,N2,P: Integer;
Adr: TAddress;
begin


P:=Interp[CNI].RCS; //  (1-th,2-cth,3-exp)
L:=Length(Interp[CNI].AWCS);
N1:=-1; N2:=-1;  //  (   . ) (N1-th;N2-exp)
if L = 1 then
begin
 if Interp[CNI].AWCS[0].WCS = 1 then N1:=0
 else
 if Interp[CNI].AWCS[0].WCS = 2 then N2:=0;
end
else
if L = 2 then
begin
 if Interp[CNI].AWCS[0].WCS = 1 then N1:=0
 else
 if Interp[CNI].AWCS[0].WCS = 2 then N2:=0;
 if Interp[CNI].AWCS[1].WCS = 1 then N1:=1
 else
 if Interp[CNI].AWCS[1].WCS = 2 then N2:=1;
end;

//       :
if P > 1 then
begin

 //exp->
 if P = 3 then
 begin

  Adr:=0;

  if F_Mode = C_Compile then  Adr:=TAddress(@Func.CpSt[Interp[CNI].MRCS]); {.203}

  FLD(Adr,F_DataType);

  {(EXP^2-1)/(EXP^2+1):}
  FMUL0;
  FLD0;
  FLD1;
  FSUBP;
  FLD1;
  FADD2;
  FDIVP;
  FSTP1;

  //  ,    (th)  EndFuncCom

 end
 else
 if P = 2 then
 begin
   //cth->
   Adr:=0;
   if F_Mode = C_Compile then  Adr:=TAddress(@Func.CpSt[Interp[CNI].MRCS]); {.203}
   FLD(Adr,F_DataType);
   //FDIVR1;
   FDIVR(TAddress(@C1),_Double); //instead fdivr1; only for FPC (unknown error in FPC)
 end;

 {$IFDEF DEBUGS}
 {if (TestG8.Form1.CB_Cod.Checked = True)  then
 TestG8.Form1.M2.Lines[CNI-1]:='COPYSTACK'; }
 {$ENDIF}

 goto endp;
end;






//        ( ):
if (L = 0) or ((L = 1) and (Interp[CNI].AWCS[0].WCS = 1)) then
begin
 MOVA1(TAddress(@R_TANH));
 CALLA;
 CheckStack(2);
 CheckStack(-2);
 goto endp;
end;



//       :
if (P = 0) and (L >= 1) then
begin
 {EXP:}
 EXP;

 //->exp:
 if N2 <> -1 then
 begin
  Adr:=0;
  if F_Mode = C_Compile then  Adr:=TAddress(@Func.CpSt[Interp[CNI].AWCS[N2].MWCS]); {.203}
  FSTM(Adr,F_DataType);
 end;

 {(EXP^2-1)/(EXP^2+1):}
  FMUL0;
  FLD0;
  FLD1;
  FSUBP;
  FLD1;
  FADD2;
  FDIVP;
  FSTP1;


 if (L > 1) and (N1 <> -1) then
 begin
  Adr:=0;
  if F_Mode = C_Compile then  Adr:=TAddress(@Func.CpSt[Interp[CNI].AWCS[N1].MWCS]); {.203}
  FSTM(Adr,F_DataType);
 end;

end;


endp:
end;



procedure TCompiler.COTANH;
label endp;
var
L,N: Cardinal;
N1,N2,P: Integer;
Adr: TAddress;
begin


P:=Interp[CNI].RCS; //  (1-th,2-cth,3-exp)
L:=Length(Interp[CNI].AWCS);
N1:=-1; N2:=-1;  //  (   . ) (N1-th;N2-exp)
if L = 1 then
begin
 if Interp[CNI].AWCS[0].WCS = 1 then N1:=0
 else
 if Interp[CNI].AWCS[0].WCS = 2 then N2:=0;
end
else
if L = 2 then
begin
 if Interp[CNI].AWCS[0].WCS = 1 then N1:=0
 else
 if Interp[CNI].AWCS[0].WCS = 2 then N2:=0;
 if Interp[CNI].AWCS[1].WCS = 1 then N1:=1
 else
 if Interp[CNI].AWCS[1].WCS = 2 then N2:=1;
end;

//       :
if P > 1 then
begin

 //exp->
 if P = 3 then
 begin
  Adr:=0;
  if F_Mode = C_Compile then  Adr:=TAddress(@Func.CpSt[Interp[CNI].MRCS]); {.203}
  FLD(Adr,F_DataType);

  {(EXP^2-1)/(EXP^2+1):}
  FMUL0;
  FLD0;
  FLD1;
  FSUBP;
  FLD1;
  FADD2;
  FDIVRP;
  FSTP1;

  //  ,    (th)  EndFuncCom

 end
 else
 if P = 2 then
 begin
   //cth->
   Adr:=0;
   if F_Mode = C_Compile then  Adr:=TAddress(@Func.CpSt[Interp[CNI].MRCS]);  {.203}
   FLD(Adr,F_DataType);
   //FDIVR1;
   FDIVR(TAddress(@C1),_Double); //instead fdivr1; only for FPC (unknown error in FPC)
 end;

 {$IFDEF DEBUGS}
 {if (TestG8.Form1.CB_Cod.Checked = True)  then
 TestG8.Form1.M2.Lines[CNI-1]:='COPYSTACK'; }
 {$ENDIF}

 goto endp;
end;






//        ( ):
if (L = 0) or ((L = 1) and (Interp[CNI].AWCS[0].WCS = 1)) then
begin
 MOVA1(TAddress(@R_COTANH));
 CALLA;
 CheckStack(2);
 CheckStack(-2);
 goto endp;
end;



//       :
if (P = 0) and (L >= 1) then
begin
 {EXP:}
 EXP;

 //->exp:
 if N2 <> -1 then
 begin
  Adr:=0;
  if F_Mode = C_Compile then  Adr:=TAddress(@Func.CpSt[Interp[CNI].AWCS[N2].MWCS]);  {.203}
  FSTM(Adr,F_DataType);
 end;

 {(EXP^2-1)/(EXP^2+1):}
  FMUL0;
  FLD0;
  FLD1;
  FSUBP;
  FLD1;
  FADD2;
  FDIVRP;
  FSTP1;



 if (L > 1) and (N1 <> -1) then
 begin
  Adr:=0;
  if F_Mode = C_Compile then  Adr:=TAddress(@Func.CpSt[Interp[CNI].AWCS[N1].MWCS]); {.203}
  FSTM(Adr,F_DataType);
 end;

end;


endp:
end;


procedure TCompiler.MOD_C(I: Integer);      {!!!}
label fin;
begin
if ReadReplFunc(i) = True then   goto fin;

//y-[y/x]*x
if Interp[i].EI = 0 then      //mod(S1,S2)
begin
   LoadArg2(i);
   {.199}
   fxch1;
   AddByte($D9); AddByte($F8);   //fprem
   AddByte($DF); AddByte($E0);   //fstsw  ax
   AddByte($9E);                 //sahf
   AddByte($7A); AddByte($F9);   //jp     fprem
   AddByte($DD); AddByte($D9);   //fstp   st(1)

   SetReg(1);


   {
   FLD0;
   FDIVR2;
   FTRUNC;
   FMULP1;
   FSUBP01;
   }



   {MEM:=WriteData(0,_Integer,_Load);
   TRUNCM(MEM);
   MOVMB(MEM);
   //MEM:=WriteDataA(0,_Integer);
   TRUNCM(MEM);
   MOVMA(MEM);
   CDQ;
   IDIVB;
   //MEM:=WriteDataA(0,_Integer);
   MOVDM(MEM);
   FILD(MEM); }
end
else
if Interp[i].EI = 2 then     //mod(iavb1,(const)(iavb2))
begin
  IAVBF1(I);
  IAVBF2(I);
  CDQ;
  IDIVB;
  MEM:=WriteData(0,_Integer,_Load);
  MOVDM(MEM);
  FILD(MEM);
end
else
if Interp[i].EI = 6 then     //mod(aai,(const)(iavb2))
begin
  AAI1(I);
  IAVBF2(I);
  CDQ;
  IDIVB;
  MEM:=WriteData(0,_Integer,_Load);
  MOVDM(MEM);
  FILD(MEM);
end
else
if (Interp[i].EI = 1) or (Interp[i].EI = 3) or (Interp[i].EI = 5) then
begin
   if Interp[i].EI = 1 then   //mod(iavb1,2)
   begin
     IAVBF1(I);
   end
   else
   if Interp[i].EI = 5 then   //mod(aai,2)
   begin
     AAI1(I);
   end
   else                      //mod(S1,2)
   begin
     LoadArg1(i);
     MEM:=WriteData(0,_Integer,_Load);
     TRUNCM(MEM);
     MOVMA(MEM);
   end;

    //and eax,$80000001
    AddByte($25); AddByte($01); AddByte($00); AddByte($00); AddByte($80);
    //jns +5
    AddByte($79); AddByte($05);
    //dec eax
    AddByte($48);
    //or eax,-$02
    AddByte($83); AddByte($C8); AddByte($FE);
    //inc eax
    AddByte($40);
    MEM:=WriteData(0,_Integer,_Load);
    MOVAM(MEM);
    FILD(MEM);

    SetReg(1);
 end
else
if Interp[i].EI = 4 then    //mod(S1,(const)(iavb))
begin
  LoadArg1(i);
  MEM:=WriteData(0,_Integer,_Load);
  TRUNCM(MEM);
  MOVMA(MEM);
  IAVBF2(I);
  CDQ;
  IDIVB;
  //MEM:=WriteData(0,_Integer,_Load);
  MOVDM(MEM);
  FILD(MEM);
end;

WriteReplFunc(i);

fin:
FAB12(I);
end;








procedure TCompiler.CDQ;
begin
 AddByte($99);
end;

procedure TCompiler.IDIV(N: TAddress);
begin
 AddCom($F7,$3D,N);
 SetReg(1);
 SetReg(4);
end;

procedure TCompiler.IDIVB;
begin
 AddWord($F7,$FB);
 SetReg(1);
 SetReg(2);
 SetReg(4);
end;


procedure TCompiler.MOVDM(N: TAddress);
begin
//EDX->MEM
AddWord($89,$15);
AddAddress(N);
SetReg(4);
end;


procedure TCompiler.ARCSINH;
begin
 MOVA1(TAddress(@R_ARCSINH));
 CALLA;
 CheckStack(1);
 CheckStack(-1);
end;



procedure TCompiler.ARCCOSH;
begin
 MOVA1(TAddress(@R_ARCCOSH));
 CALLA;
 CheckStack(2);
 CheckStack(-2);
end;


procedure TCompiler.ARCTANH;
begin
 MOVA1(TAddress(@R_ARCTANH));
 CALLA;
 CheckStack(2);
 CheckStack(-2);
end;



procedure TCompiler.ARCCOTANH;
begin
 MOVA1(TAddress(@R_ARCCOTANH));
 CALLA;
 CheckStack(2);
 CheckStack(-2);
end;


procedure TCompiler.FABS;
begin
AddWord($D9,$E1);
end;



procedure  TCompiler.FRNDINT;
begin
AddWord($D9,$FC);
end;



procedure TCompiler.TRUNCM(N: TAddress);
begin
PUSHCW;    {.248}
FNCLEX;     {.248}
FLDCW(TAddress(@FCW1));
FISTP(N);
POPCW;    {.248}//FLDCW(TAddress(@FCW2));
end;



procedure TCompiler.FTRUNC;
begin
PUSHCW;    {.248}
FNCLEX;     {.248}
FLDCW(TAddress(@FCW1));
FRNDINT;
POPCW;    {.248}//FLDCW(TAddress(@FCW2));
end;



procedure TCompiler.PUSHCW;
begin
//sub esp,4
AddWord($83,$EC);    AddByte($04);
//fnstcw [esp];
AddWord($D9,$3C);   AddByte($24);
end;



procedure TCompiler.POPCW;
begin
//fldcw [esp];
AddWord($D9,$2C);   AddByte($24);
//add esp, 4
AddWord($83,$C4);    AddByte($04);
end;


procedure TCompiler.LEA_CC8A;
begin
//LEA ECX, ECX+8*EAX
 AddByte($8D);
 AddByte($0C);
 AddByte($C1);
end;

procedure TCompiler.LEA_AC2A;
begin
//LEA EAX, ECX+2*EAX
 AddByte($8D);
 AddByte($04);
 AddByte($41);
end;


procedure TCompiler.LEA_CD8A;
begin
//LEA ECX, EDX+8*EAX
 AddByte($8D);
 AddByte($0C);
 AddByte($C2);
end;

procedure  TCompiler.FLDA_E;
begin
//fld tbyte ptr [EAX]
AddWord($DB,$28);
CheckStack(1);
end;


procedure  TCompiler.FCOMPP;
begin
AddWord($DE,$D9);
CheckStack(-2);
end;

procedure  TCompiler.FCOMIP;
begin
 AddWord($DF,$F1);
 CheckStack(-1);
end;


procedure  TCompiler.FSTSW_AX;
begin
 AddWord($DF,$E0);
 SetReg(1);     {.239}
end;

procedure  TCompiler.SAHF;
begin
 AddByte($9E);
 //SetReg(1);
end;


procedure TCompiler.JMPC(N: TAddress; VType: Integer);
begin
case VType of
2:    AddCom($0F,$84,N);        //jz
3:    AddCom($0F,$83,N);        //jnb
4:    AddCom($0F,$86,N);        //jbe
5:    AddCom($0F,$82,N);        //jb
6:    AddCom($0F,$87,N);        //jnbe
7:    AddCom($0F,$85,N);        //jnz
end;
end;


{
   case Interp[N].EI of
   2:   begin ICOMP[High(ICOMP)-5]:=$0F; ICOMP[High(ICOMP)-4]:=$84; end; //jz
   3:   begin ICOMP[High(ICOMP)-5]:=$0F; ICOMP[High(ICOMP)-4]:=$83; end; //jnb
   4:   begin ICOMP[High(ICOMP)-5]:=$0F; ICOMP[High(ICOMP)-4]:=$86; end; //jbe
   5:   begin ICOMP[High(ICOMP)-5]:=$0F; ICOMP[High(ICOMP)-4]:=$82; end; //jb
   6:   begin ICOMP[High(ICOMP)-5]:=$0F; ICOMP[High(ICOMP)-4]:=$87; end; //jnbe
   7:   begin ICOMP[High(ICOMP)-5]:=$0F; ICOMP[High(ICOMP)-4]:=$85; end; //jnz
   end;
}


{
procedure TCompiler.FACTSTACK;
begin
FLDCW(TAddress(@FCW1));
FISTP(TAddress(@Interp[i].MEM));
FLDCW(TAddress(@FCW2));
MOVMA(TAddress(@Interp[i].MEM));
end;
}



procedure TCompiler.FUNC1(I: Integer);
var
S: String;
Adr: TAddress;
begin
if Interp[i].RCS  = 0 then
begin
 // .        .
 F_EnableSave:=False;   {.205}  //sin(x)+sin(x); sin(argf)+sin(argf)

 if (Interp[i].EI = 1) and (F_SaveStack = True) and (Interp[i].RData[0] = _MEM) then
 {Stack}
 begin
   //Adr:=0; {.203}
   //if F_Mode = C_Compile then Adr:=TAddress(@Func.Stack[Interp[i].S]);
   Adr:=GetStackAddr(Interp[i].S); {.241}
   FLD(Adr,F_DataType);
 end;

 if Interp[i].EI = 1 then
 begin
  MEM:=WriteData(1,_Integer,_Load);
  TRUNCM(MEM);
  MOVMA(MEM);
 end
 else
 if Interp[i].EI = 2 then IAVBF(I)
 else
 if Interp[i].EI = 3 then AAI1(I);


 F_EnableSave:=True;   {.205}

end;

InsertFunc1(I);
EndFuncCom(I);
end;






procedure TCompiler.InsertFunc1(I: Integer);
var
S: String;
Adr: TAddress;
                procedure AddFunc(I,C: Integer);
                label endp;
                var
                 k: Integer;
                  begin
                  //  - = 0  inl = 1,  -    ,
                  // .  <> 0,  - : mov eax,Addr; call EAX
                  //    -   (=1)
                  //(    -  FType=1)
                  // (  )    - 
                  //    FuncList[C_FUNC].Addr=NewFuncAddr  
                  // ( )     FuncList[C_FUNC].NST=NewFuncNST
                   if C = 1 then
                   begin
                     if FuncList[Interp[I].Code].inl = 1 then
                     begin
                      for k:=0 to High(FuncList[Interp[I].Code].inlCode) do
                      begin
                       AddByte(FuncList[Interp[I].Code].inlCode[k]);
                      end;
                     end
                     else
                     if FuncList[Interp[I].Code].Addr <> nil then
                     begin
                      MOVB1(TAddress(FuncList[Interp[I].Code].Addr));
                      CALLB;
                     end;

                     SaveFuncReg(I);

                     goto endp;
                   end;

                   //   C=0:
                   {case  Interp[I].Code of
                    C_FACT:             FACT;
                    C_I2PWR:            I2PWR;
                    C_IPWRSGN:          IPWRSGN;
                   end;}

                  endp:
                  end;

begin



//   ( -   -)
if Interp[i].RCS = 1 then
begin
 Adr:=0;
 if F_Mode = C_Compile then Adr:=TAddress(@Func.CpSt[Interp[i].MRCS]);   {.203}
 FLD(Adr,F_DataType);
 {$IFDEF DEBUGS}
 {if (TestG8.Form1.CB_Cod.Checked = True)  then
 TestG8.Form1.M2.Lines[I-1]:='COPYSTACK';  }
 {$ENDIF}
end
else
begin
 //           ( ):
 //(    -  FType=1)
 if (Interp[i].RCS = 0) and
   ((Length(Interp[i].AWCS) = 0) or ((Length(Interp[i].AWCS) = 1) and (Interp[i].AWCS[0].WCS = 1))) then
 begin
 //    NST
  CheckStack(FuncList[Interp[i].Code].NST);
  CheckStack(-FuncList[Interp[i].Code].NST+1);//..    EAX,
  F_EnableCheckStack:=False;                  //   ST(0)
  AddFunc(I,1);
  F_EnableCheckStack:=True;
 end
 else
 //      :
 //( -  FType = 1   (  ))
 begin
  AddFunc(I,0);
 end;


end;
end;






procedure TCompiler.FUNC5(I: Integer);
var
AdrF: TAddress;
TM: Integer;
begin
if Interp[i].RCS  = 0 then
begin

 TM:=GetVarType(Interp[i].IV1);

 if  TM = _ArrayD  then
 begin
   case Interp[i].CODE of
    C_SUMV:  begin AdrF:=TAddress(@RD_SUM);        end;
    C_PRODV: begin AdrF:=TAddress(@RD_PROD);       end;
    C_SUMQV: begin AdrF:=TAddress(@RD_SUMQ);       end;
    C_AVRV:  begin AdrF:=TAddress(@RD_AVR);        end;
    C_NORMV: begin AdrF:=TAddress(@RD_NORM);       end;
    C_MAXV:  begin AdrF:=TAddress(@RD_MAX);        end;
    C_MINV:  begin AdrF:=TAddress(@RD_MIN);        end;
    C_LENV:  begin AdrF:=TAddress(@R_LEN);         end;
    C_DEVV:  begin AdrF:=TAddress(@RD_DEV);        end;
    C_DEVSV: begin AdrF:=TAddress(@RD_DEVS);       end;
    C_GCDV:  begin AdrF:=TAddress(@RD_GCD);        end;
    C_LCMV:  begin AdrF:=TAddress(@RD_LCM);        end;
   end;
 end
 else
  if  TM = _ArrayE  then
 begin
   case Interp[i].CODE of
    C_SUMV:  begin AdrF:=TAddress(@RE_SUM);        end;
    C_PRODV: begin AdrF:=TAddress(@RE_PROD);       end;
    C_SUMQV: begin AdrF:=TAddress(@RE_SUMQ);       end;
    C_AVRV:  begin AdrF:=TAddress(@RE_AVR);        end;
    C_NORMV: begin AdrF:=TAddress(@RE_NORM);       end;
    C_MAXV:  begin AdrF:=TAddress(@RE_MAX);        end;
    C_MINV:  begin AdrF:=TAddress(@RE_MIN);        end;
    C_LENV:  begin AdrF:=TAddress(@R_LEN);         end;
    C_DEVV:  begin AdrF:=TAddress(@RE_DEV);        end;
    C_DEVSV: begin AdrF:=TAddress(@RE_DEVS);       end;
    C_GCDV:  begin AdrF:=TAddress(@RE_GCD);        end;
    C_LCMV:  begin AdrF:=TAddress(@RE_LCM);        end;
   end;
 end
 else
  if  TM = _ArrayS  then
 begin
   case Interp[i].CODE of
    C_SUMV:  begin AdrF:=TAddress(@RS_SUM);        end;
    C_PRODV: begin AdrF:=TAddress(@RS_PROD);       end;
    C_SUMQV: begin AdrF:=TAddress(@RS_SUMQ);       end;
    C_AVRV:  begin AdrF:=TAddress(@RS_AVR);        end;
    C_NORMV: begin AdrF:=TAddress(@RS_NORM);       end;
    C_MAXV:  begin AdrF:=TAddress(@RS_MAX);        end;
    C_MINV:  begin AdrF:=TAddress(@RS_MIN);        end;
    C_LENV:  begin AdrF:=TAddress(@R_LEN);         end;
    C_DEVV:  begin AdrF:=TAddress(@RS_DEV);        end;
    C_DEVSV: begin AdrF:=TAddress(@RS_DEVS);       end;
    C_GCDV:  begin AdrF:=TAddress(@RS_GCD);        end;
    C_LCMV:  begin AdrF:=TAddress(@RS_LCM);        end;
   end;
 end
 else
  if  TM = _ArrayI  then
 begin
   case Interp[i].CODE of
    C_SUMV:  begin AdrF:=TAddress(@RI_SUM);        end;
    C_PRODV: begin AdrF:=TAddress(@RI_PROD);       end;
    C_SUMQV: begin AdrF:=TAddress(@RI_SUMQ);       end;
    C_AVRV:  begin AdrF:=TAddress(@RI_AVR);        end;
    C_NORMV: begin AdrF:=TAddress(@RI_NORM);       end;
    C_MAXV:  begin AdrF:=TAddress(@RI_MAX);        end;
    C_MINV:  begin AdrF:=TAddress(@RI_MIN);        end;
    C_LENV:  begin AdrF:=TAddress(@R_LEN);         end;
    C_DEVV:  begin AdrF:=TAddress(@RI_DEV);        end;
    C_DEVSV: begin AdrF:=TAddress(@RI_DEVS);       end;
    C_GCDV:  begin AdrF:=TAddress(@RI_GCD);        end;
    C_LCMV:  begin AdrF:=TAddress(@RI_LCM);        end;
   end;
 end;


 MOVMA(TAddress(Interp[i].IV1));
 //MOVA1(TAddress(Interp[i].IV1));
 MOVC1(AdrF);
 CALLC;


end;

InsertFunc1(I);
EndFuncCom(I);
end;


{.241}
function TCompiler.GetStackAddr(N: Cardinal): TAddress;
begin
  if F_Mode = C_Compile then GetStackAddr:=TAddress(@Func.Stack[N]) else GetStackAddr:=0;
end;


procedure TCompiler.FIDIV(N: TAddress);
begin
AddWord($DA,$35);
AddAddress(N);
end;


procedure TCompiler.FDIV2;
begin                    //fdiv st,st(2)
AddWord($D8,$F2);
end;

procedure TCompiler.FDIVR2;
begin                    //fdivr st,st(2)
AddWord($D8,$FA);
end;

procedure TCompiler.FMULP02;
begin                    //fmulp st(2),st(0)
AddWord($DE,$CA);
CheckStack(-1);
end;

procedure TCompiler.FMUL01;
begin                    //fmulp st(0),st(1)
AddWord($D8,$C9);
end;

procedure TCompiler.FSUBP02;
begin                    //fsubp st(2),st(0)
AddWord($DE,$EA);
CheckStack(-1);
end;

procedure TCompiler.FSUBP01;
begin                    //fsubp st(1),st(0)
AddWord($DE,$E9);
CheckStack(-1);
end;


procedure TCompiler.CMPAB;
begin
//CMP EAX,EBX
AddWord($39,$D8);
SetReg(1);
SetReg(2);
end;


{
procedure TCompiler.ALS;
begin
//EAX -> ST(0)
MOVAM(TAddress(@Interp[i].MEM));
FILD(TAddress(@Interp[i].MEM));
end;
}


procedure TCompiler.PUSHM(N: Integer);
begin
//  
AddCom($68,N);
end;


procedure TCompiler.PUSHF(N: TAddress);
begin
//   : dword ptr [N]
AddWord($FF,$35);
AddAddress(N);
end;

procedure TCompiler.POPF(N: TAddress);
begin
//   : dword ptr [N]
AddWord($8F,$05);
AddAddress(N);
end;


procedure TCompiler.XCHGAB;
//xchg eax,ebx
begin
AddByte($93);
end;


procedure TCompiler.PUSHD;
begin
AddByte($52);
end;

procedure TCompiler.PUSHESP;
begin
AddByte($54);
end;


procedure TCompiler.POPESP;
begin
AddByte($5C);
end;

procedure TCompiler.PUSHEBP;
begin
AddByte($55);
end;


procedure TCompiler.POPEBP;
begin
AddByte($5D);
end;


procedure TCompiler.PUSHESI;
begin
AddByte($56);
end;


procedure TCompiler.POPESI;
begin
AddByte($5E);
end;

procedure TCompiler.PUSHEDI;
begin
AddByte($57);
end;


procedure TCompiler.POPEDI;
begin
AddByte($5F);
end;

procedure TCompiler.POPD;
begin
AddByte($5A);
end;


procedure TCompiler.RET;
begin
AddByte($C3);
end;



end.
