unit Foreval_Main;

{******************************************************************************}
{                                                                              }
{                                ver. 8.4.17.250                               }
{----------------------------------------------------------------------------- }
{       .           }
{------------------------------------------------------------------------------}
{ The module contains the parser and optimizer of expressions.                 }
{------------------------------------------------------------------------------}
{               SOREL   (C)CopyRight 2000. Russia, S.-Petersburg.              }
{******************************************************************************}

             

{.$DEFINE DEBUGS}

//{$RangeChecks On}
//{$OverFlowChecks On}
//{$ZEROBASEDSTRINGS Off}

{$R-}
{$Q-}

{$IFDEF FPC}
  {$MODE DELPHI}
{$ENDIF}

interface

uses

  SysUtils,StrUtils,Math,Windows   {,Dialogs{DEBUG};

  const _PI: extended = 3.141592653589793238462643;
  const NumberFact = 1754;
  const NumberFact2 = 1604;

  const
   E_ZeroDivide = 20;
   E_InvalidOp = 21;
   E_OverFlow = 22;
   E_UnderFlow = 23;
   E_IntOverFlow = 24;
   E_AccessViolation = 25;
   E_OutOfMemory  = 26;
   E_StackOverFlow = 27;
   E_ERROR_AT_ADDITION_FUNCTION = 28;
   E_NONEXISTENT_FUNCTION = 29;
   E_UNKNOWN_SYMBOL  = 1;
   //E_MISSING_BRACKET_LEFT  = 2;
   //E_MISSING_BRACKET_RIGHT  = 3;
   E_MISSING_OPERATION = 4;
   E_INCOINCIDENCE_NUMBER_ARGUMENTS = 5;
   E_MISSING_EXPRESSION  = 6;
   E_UNKNOWN_FUNCTION = 7;
   E_INCORRECT_ARGUMENT = 30;
   E_MISSING_ARGUMENT = 31;
   E_INCORRECT_TYPE = 32;
   E_MISSING_SEPARATOR = 18;
   E_WRONG_NAME =        15;
   E_MISSING_ABS_BRACKET = 16;
   E_MISSING_ROUND_BRACKET = 2;
   E_MISSING_SQUARE_BRACKET = 17;
   E_MISSING_CURLY_BRACKET = 19;
   E_WRONG_EXPRESSION = 34;
   E_INCORRECT_SPACE = 35;
   E_VARIABLE_REDECLARED = 36;


  const SizeS = 16;
  const _Single = 1;
  const _Double = 2;
  const _Extended = 3;
  const _Integer = 4;
  const _Differ =  5;
  const _None = 0;
  const _ArrayS = 6;
  const _ArrayD = 7;
  const _ArrayE = 8;
  const _ArrayI = 9;
  const _Address = 10;
  const _Compiled = 11;
  const _Real = 12;

  const  _ADD:  Integer = 2;
  const  _MUL:  Integer = -2;
  const  _DIV:  Integer = -1;
  const  _SUB:  Integer = 1;
  const  _SUBR: Integer = 3; // TreeOptimizator -
  const  _DIVR: Integer = -3;// TreeOptimizator -
  const  _NOP:  Integer = 0;

  const  _FAVB: Integer = 1;
  const  _AIFB: Integer = 2;
  const  _AAF:  Integer = 3;
  const  _MAF:  Integer = 4;
  const  _IAVB: Integer = 5;
  const  _AAI:  Integer = 6;
  const  _AFI:  Integer = 7;



  const  _FPU:  Integer = 1;
  const  _MEM:  Integer = 2;

  const  _Disable: Integer = 0;
  const  _Enable:  Integer = 1;
  const  _Auto:    Integer = 2;

  const  _Yes: Integer = 1;
  const  _No: Integer = 2;

  const  C_Compile: Integer = 1;
  const  C_EmlXchBranch: Integer = 2;  //TreeOptimizator
  const  C_EmlDinamicLoad: Integer = 3;

type
TAddress = Cardinal;



type TFloatType = extended;          //   
type TIntegType = Integer;
type PFloatType = TAddress;//Pointer;

type
TAmvab  = record
            A: TFloatType;
            B: TFloatType;
           nf: Cardinal;
          end;

type
PAmvab  = record
            A: TFloatType;
            B: TFloatType;
           PF: PFloatType;
          end;

type TDAmvab = array of TAmvab;
type PDAmvab = array of PAmvab;

type TStackType =  record             //for align on 16
                    r1: Double;
                    r2: Double;
                   end;

type
   PFuncData = ^TFuncData;
   TFuncData = record
                FData: TStackType;//Extended;  //for align on 16
                //IData: TIntegType;
                Next:  PFuncData;
               end;




type TMass2 =  record
              FM: array of TFloatType;
              IM: array of TFloatType;
              FC: TFloatType;
               end;



type
TArray4 = array [1..4] of byte;
type TCode = array of byte;    //=DWORD    32
type TArrayFS = array of TStackType;
type TArrayF = array of TFloatType;
type PArrayF = ^TArrayF;
type TAddFunc = function(N: Integer; SF: TArrayF): TFloatType;


type PIntegType = TAddress;//Pointer;

type TArrayI = array of Integer;
type PArrayI = ^TArrayI;

type TPrt =    record
                WCS: Integer; //   (   )
                RCS: Integer; //  (   )
                NC: Integer;  //    
               end;

type TWCS =    record
                WCS: Integer;  //   (   )
                MWCS: Integer; //   CopyStack ( WCS)
               end;            //    

type TAWCS = array of TWCS; //     

type TArray2I = array of array of  TPrt;



type

 TFunc = record
               S: TIntegType;              //Stack
               N: TIntegType;              //Node  (   )  , = 0 ,    
               I: TIntegType;              //Inv; 1:'-';-1:'/'; 2:'+'; -2:'*'; 0: NOP;
             Neg: TIntegType;
               NL: Cardinal;      //    
               NM: Cardinal;      //; Interp[NM] -  (Tree^.Pr)  - 
              IdN: Cardinal;     //    
              IdL: Cardinal;     // IdN (Tree^.Pr) 
              BC: Cardinal;
               CODE: TIntegType;    //   FuncList
            ExtArg: Integer;   //=_Double,_Extended,_Integer,_Single,_Address,_None -      - .  (  - _None) -  
            SExtArg: Integer; //   . - (  -  ,   = 0!!!)
              SGN: TArrayI;   //SGN[i] = _MUL,_ADD,_SUB,_DIV (i=0,..N); -      
            RData: TArrayI;   //RData[i] = _FPU,_MEM; (i=0..N); -   -   
            SNExtArg: TArrayI;//   - ( . -  )
             SData: Integer;    //=_FPU,_MEM;   -      DL
            SData1: Integer;    //=_FPU,_MEM    -       
               PkAdr: Cardinal;
               PkShift: Cardinal;
               PkRType: Cardinal;
               Expression:  String;
               ExpressionArg: String;
             XCHA: Integer;   //   2-. .(FType = 4) -  TreeOptimizator(  ) - 
               AI: TIntegType;             //inf  for Func
               BI: TIntegType;             //inf  for Ipwr
               CI: TIntegType;             //TIntegType const.; inf for type ARGI
               DI: TIntegType;             //inf for Type of ARGF
               EI: TIntegType;             //manage for function
               FI: TIntegType;             //manage, only for FPwr

               F1:  TFloatType;            //help var. for func. opt.
               F2:  TFloatType;

               V1: TFloatType;           //help var. for float var. opt.
               V2: TFloatType;          //   ax+b :
                      //a - V1(VI1), b - V2(VI2)
                         // . . const. - V12, VI6, V6;

               V3: TFloatType;          //.  .
               V4: TFloatType;         //.  .

               VI1:   TIntegType;         //help var. for int. var. opt.
               VI2:   TIntegType;
               VI3:   TIntegType;   //.  .
               VI4:   TIntegType;   //.  .


               FV1:  PFloatType;   //  
               FV2:  PFloatType;     //-     fl. .

               Adr: Cardinal;     //lda
               AdrV1: Cardinal;  //adr of array
               AdrV2: Cardinal;  //adr of array
               AdrF1: Cardinal;  //adr of float
               NC:   Cardinal;   //  ICOMP[NC]  
               NCP:  Cardinal;   //  ICOMP[NCP]  
               CS:   Cardinal;   //CodeSize:       +     

               IV1:   Cardinal; //PIntegType;
               IV2:   Cardinal;//PIntegType; //-     int. .
               MEM:   Cardinal;
               AWCS: TAWCS;
               RCS: Integer;
               MRCS: Integer; {   CopyStack    }
                              {   ,  -   }

                PM:  array of PFloatType;  //   AAI,AAF,
                PN:  array of TFloatType;  //. 
                PI:  array of PIntegType;
                PC:  array of TIntegType;

                VFP: TArrayF;   //.  {.223}

               AFB:  PDAmvab;
               RetNum: Integer;

                end;


type
TArrayOfTFunc = array of TFunc;

type
TFunction = record
                   Code:  TCode;      //exe byte code
                   Data:  PFuncData;  //data of expr. (numeric const. of expr.)
                   Stack: TArrayFS;   //stack of expr. for temp. result(use in DinLoad)       //TArrayF;   //for align on 16
                   CpSt:  TArrayFS;   //stack of expr. for temp. result(use in Replace)      //TArrayF;   //for align on 16
                   Addr:  TAddress;   //begin addr of exe   {.199}
                   PAddr: Pointer;    //pointer to begin addr of exe {.199}
                CodeSize: Cardinal;   //size of code   (exe code can be moved )  {.199}
                AllocMem: Integer;    //= 1(compile with delphi/fpc memory manager): memory is allocated by SetLength(TFunction.Code,Size) (GetMem) {.199}
                  end;                //= 2(compile with windows (WinXp SP2+)memory manager): memory is allocated by VirtualAlloc  :TFunction.Code=nil
                                      {setting by fl_USE_VIRTUAL_ALLOC}
type PFunction = ^TFunction;

type TNStack = record
                S: TIntegType; //  
                N: TIntegType; //  
              end;


type
PNode = ^TNode;
TNode = record
        Code:  Integer;
        SGN: TArrayI;
        RData: TArrayI;
        SNExtArg: TArrayI;
        PkAdr: Cardinal;
        PkShift: Cardinal;
        PkRType: Cardinal;
        Expression: String;
        ExpressionArg: String;
        NL: Cardinal;
        NM: Cardinal;
        IdN: Cardinal;
        IdL: Cardinal;
        BC:  Cardinal;
        SData: Integer;
        ExtArg: Integer;
        SExtArg: Integer;
        Stack: TNStack;
        SDeep: Integer;
        Neg: Integer;   //1-neg
        XCHA: Integer;
        I: Integer;   //1:'-';-1:'/'; 2:'+'; -2:'*'; 0: NOP;
        Ch: PNode;         //child
        Nb: PNode;         //neighbor
        Pr: PNode;         //parent
        AI: TIntegType;
        BI: TIntegType;
        CI: TIntegType;
        DI: TIntegType;
        EI: TIntegType;
        FI: TIntegType;
        FV1: Cardinal;    //adr fl.      
        FV2: Cardinal;    //adr fl.       
        IV1: Cardinal;    //adr int.      
        IV2: Cardinal;    //adr int.       
        Adr: Cardinal;     //lda
        AdrV1: Cardinal;  //adr of array
        AdrV2: Cardinal;  //adr of array
        AdrF1: Cardinal;  //adr of float
        F1:  TFloatType;
        F2:  TFloatType;
        V1: TFloatType;
        V2: TFloatType;
        V3: TFloatType;
        V4: TFloatType;
        VI1: TIntegType;
        VI2: TIntegType;
        VI3: TIntegType;
        VI4:  TIntegType;
        AFB: TDAmvab;
        PN:  TMass2;         //-  -: ARGF
        PN1: TMass2;         //-  -: ARGI
        VFP: TArrayF;   //.  {.223}
       end;

type
TDataNode = record                //data of node
              Code: Integer;
              N: TIntegType;
              Expression: String;
              ExpressionArg: String;
              SGN: TArrayI;
              SNExtArg: TArrayI;
              SS: Integer;      // : -  . -
              ExtArg: Integer;
              XCHA: Integer;
              Neg: Integer;   //1-neg;
              AI: TIntegType;
              BI: TIntegType;
              CI: TIntegType;
              DI: TIntegType;
              EI: TIntegType;
              FI: TIntegType;
              FV1: Cardinal;    //adr fl.      
              FV2: Cardinal;    //adr fl.       
              IV1: Cardinal;    //adr int.      
              IV2: Cardinal;    //adr int.       
              Adr: Cardinal;     //lda
              AdrV1: Cardinal;  //adr of array
              AdrV2: Cardinal;  //adr of array
              AdrF1: Cardinal;  //adr of float
              F1:  TFloatType;
              F2:  TFloatType;
              V1: TFloatType;
              V2: TFloatType;
              V3: TFloatType;
              V4: TFloatType;
              VI1: TIntegType;
              VI2: TIntegType;
              VI3: TIntegType;
              VI4: TIntegType;
              PN:  TMass2;
              PN1: TMass2;
              VFP: TArrayF;   //.  {.223}
              AFB: TDAmvab;
            end;

type
TLevel = record                  //data of level
          Expression: String;
          NL: Cardinal;
          I: Integer;   //1:'-';-1:'/'; 2:'+'; -2:'*';
          ExtArg: Integer;
          SExtArg: Integer;
          PkAdr: Cardinal;
          PkShift: Cardinal;
          PkRType: Cardinal;
         end;


type PLevel = array of TLevel;



type
TArrayS = array of String;


type
TAdditionalFunc = record
                   Name: String;
                   Arg:  Integer;  // 
                  addr:  Pointer;  //
                 FType:  Integer;
               SaveReg:  Integer;
                   inl:  Integer;
               Id_Func:  Integer;  //
                  CLST:  Integer;  // 
                 Arrow:  Integer;  //  
                Set_ID:  Integer;  //  
                   NST:  Integer;  //   . -   ,
                                   //  NST=  -,  NST = -1.
               ArgType:  Integer;  //_Integer,_Double,_Extended,_Differ
           ArgTypeList:  TArrayI;  // ArgType = _Differ,   ArgTypeList -
                                   //  
               inlCode:  TCode;
                ArgAdr:  TArrayI;  //   - fl_PRECOMPILED
             CalcConst:  Integer;  //_Yes,_No
                RetNum:  Integer;  //_Yes,_No   return number, if set '_No' then - 'procedure'
              ReplFunc:  Integer;  //_Yes,_No
               //Enabled:  Integer;  //_Yes,_No
                  end;



type
TFuncList =     record
                 Name: TArrayS;
                 Addr: Pointer;
                 inl: Integer;  //0,1 - -   (Addr),  
                                //   (inline)
                 inlCode: TCode;//  -   inl=1
                 NST: Integer;  // 
                                //   . -   ,
                                //  NST=  -,  NST = -1.
                 Id_Func:  Integer; //   - (   ESP)
                 Set_Id:  Integer; //1 -  Id_Func; 0 - 
                 Arg: Integer;    //  (-1  Infinite)
                 ARROW: Integer; //   : 0 - (LR); 1 - (RL);
                 CLST: Integer;  //   : 0 - ; 1 - ;
                 ArgType:  Integer;  //  (  )
                 ArgTypeList:  TArrayI; //  ( - )
                 SaveReg: Integer; //   (PUSH/POP),
                                   //  (EAX,...)  , = 1,0 (./)
                                   //: 1 - EAX; 2 - EBX; 3 - ECX; 4 - EDX; 5 - ESP; 6 - EBP; 7 - ESI; 8 - EDI;
                                   //  
                 ArgAdr:  TArrayI;  //   - fl_PRECOMPILED
              CalcConst:  Integer;  //_Yes,_No
                Enabled:  Integer;  //_Yes,_No
                RetNum:   Integer;  //_Yes,_No
                 FType: Integer; //< 0 -  -
                             // = 0 -  (AAF,MAF,ADD,MUL,LDSC,...)
                                 // = 1 -    -  func(n)
                                 // = 2 -    -  func(x)
                                 // = 3 -    -  func(x,n)
                                 // = 4 -    -  func(x1,x2)
                  ReplFunc: Integer; //_Yes,_No
                  XchArg: Integer; //_Yes,_No
                 end;
type
TArrayFuncList = array of TFuncList;


type
TParamList = record
               Name: String;
               Value: TFloatType;
             end;



type
TVariable = record
              Name:  String;
              Addr:  TAddress;
             VType:  Integer; //_Single,_Double, _Extended, _Integer,_ArrayS,_ArrayD,_ArrayE,_ArrayI;
            IsUsed:  Boolean; //True, if this var used in current expression {.225}
            end;

type
TVarList = array of TVariable;




type
TString1 = String[1];

type
TFin = record
        F: Integer;
        I: Integer;
       end;

type
TAttrib = record
           Adr:   Cardinal; //   ( - Address)
                            //  ( )
                            //Adr = Address,EAX(1),EBX(2),ECX(3),EDX(4),ESP(5);
           RType: Cardinal; //  
                            //RType = _Double,_Integer,_Extended,_Single
           Shift: Cardinal; //    ([EAX+shift],...)                 
          end;

type
TArrayPkg = array of TAttrib;
type
PArrayPkg = ^TArrayPkg;

type TExternalException = procedure; //  


{type
ESyntaxError = class(Exception);

type
EInternalError = class(Exception);}





type

  TForevalH = class



  private



    Interp: TArrayOfTFunc;
    LInterp: Cardinal;
    CurrentExpression: String;      // 
    LFunc    : TIntegType;          //  
    StackSize: TIntegType;          // 
    ParamList: array  of TParamList;                     // (,)
    VarList: TVarList;
    ArgM : array of String;              //    > 2 .(  '1')
    Func: TFunction;                     //   
    Tree: PNode;                                //  
    FuncList: TArrayFuncList;
    F_Optimization: Boolean; //. .  ,  
    F_FuncArgOpt: Boolean; {.249} //  . .    
    F_SyntaxExtension:       Boolean; //./.:  - > 1; '{' ; '['; '!'; '^'; .
    F_ConvertAtanToAtan2: Boolean;   {.209}
    BeginTree: PNode;                 //   ( )
    //F_VarShift:              Boolean;  // var&param  // .
    //F_FuncShift:             Boolean;
    DMI: array of Integer;   //  PostCodeOptimization;
    LSRes: TIntegType;
    F_PostCodeOptimizator:   Boolean;
    F_StackDeep:             Integer;
    F_SyntaxErrorString, F_SyntaxE: String;   // 
    F_SaveInStack: Boolean;
    F_ErrorCode,F_InternalError: Integer;
    F_ShowException: Boolean;      //./.  
    F_ExternalException: Boolean;  //./.   
    F_LevelReplace: Cardinal;
    F_ErNum: Integer;  // Interp     CalcConst;
    F_Arrow: Integer;
    F_CLST:  Integer;
    F_Set_Id: Integer;
    F_TreeOptimization: Integer;
    F_DinamicLoadOptimization: Integer;
    F_ParamType, F_DataType: Integer; //     (_Double/_Extended)
    F_OverFlowFunc: Boolean;  //=True      -  .NST=-1(..   )
    F_CloseArg: Boolean;
    F_PackageCompile: Boolean;
    F_XchTableTrig: Boolean;
    F_XchTableHYP: Boolean;
    F_ReplaceFunction: Boolean;
    F_ReplaceOperation: Boolean;  {.199}
    F_UseVirtAlloc: Boolean; {.199}
    XchTable: TArray2I;
    XchCode:  TArrayI;
    PkgData:  TArrayPkg;
    F_IdN: Integer; // : IdN   IdL     (  ) 
    F_Attrib: TAttrib;
    F_CurrentString: String;
    Db_XchBrSDeep: Integer;     //    TreeOpimization (: _Enable,_Auto)
    Db_XchBrNXch: Integer;      //   TreeOpimization
    Db_DinLoadSDeep: Integer;   //    DinamicLoad  (: _Enable,_Auto)
    Db_DinLoadNMem: Integer;    //   DinamicLoad
    Db_DinLoadOverFlow: Boolean;//True,     DinamicLoad    
    Db_CmplMaxStack: Integer;   //   
    Db_CmplOverFlow: Boolean;   //     F_SaveStack = True  , : True, : False
    Db_CopyStackXch: Integer;   //   CopyStack
    Db_CopyStackXchG: Integer;  //  ()  CopyStack (untyped)
    Db_CopyStackOpXch: Integer;  //  ()  CopyStack (untyped)
    Db_CalcConst: Integer;      //    CalcConst
    Db_MaxReplaceLevel: Integer;//.    CopyStack
    Db_LoadStackAfterCalc: Integer; //    = 0,1!!!
    F_VarPresent: Boolean;       //   
    F_CalcConstExpr: Boolean;    ///    ( ) (:   dll)
    F_CalcConstantFunc: Boolean; ///        (:   dll)
    F_EnableCalcConstExpression: Boolean;  {   ,      ,
                                                 (goto(), if(), random(), ...)}
                                            //(:   )
    F_EnableCalcConsExprInMulti: Boolean; //     (  )     .
                                             //(:   )
    F_GotoPresent: Boolean;
    F_NopPresent: Boolean;
    G_SaveVar: TVarList;
    G_SaveParam: array  of TParamList;
    F_Replace_ARGF: Boolean;
    F_RetNum: Integer;
    F_EnableReplaceInPackage: Boolean;
    F_AddSubOptimization: Boolean;  {.243}
    F_MulDivOptimization: Boolean;   {.243}
    F_SkippedIF: Boolean; {.243}        //true: non-complete boolean expr; false: complete boolean expr;
    F_LeadToLowerCase: Boolean; {.245}   //( )
                                          { = False   ,,     
                                            = True      ,  ,
                                                     LowerCase}
    F_DisableReplaceIF: Boolean;  {/  ReplaceFunctions/Operations      IF,GOTO
                                   (   )}
                                     {.245}
    F_EnableMaskFpuException: Boolean; //  FPU   try except (:   dll)

    FV_Result: TFloatType;

    F_SaveSW: Boolean;

    F_MulOptLight: Boolean;

    procedure FindExternalBracket(S: String; var SS: String; var Neg: Integer);
    procedure FindMainOperation(S:String; var MOP: Integer);
    procedure StringAnalizator(S:String; var N: TIntegType; var COP: Integer; var HS:PLevel; var{Neg: Boolean} Neg: Integer);
    procedure WriteCode;
    procedure WriteLevelParam(H: PNode; HS: PLevel; N: Cardinal);
    function  PointToDec(S: String):String;
    procedure CreateFuncList;
    procedure CreateInitData;
    procedure AddExtFunc;
    procedure CreateFactMass;
    procedure FindVar(S1: String; ND: TDataNode; var ni: TIntegType; var FIN:TFin; var {Neg: Boolean} Neg: Integer);
    procedure FindVarA(S1: String; var FIN:TFin; var VType: Integer);
    procedure SyntaxAnalizator(S:String; var ND: TDataNode; var LV:PLevel;  var EOFN: Boolean);
    procedure NumberAnalizator(LV: PLevel; ND: TDataNode; var LV1: PLevel; var ND1: TDataNode; var EOFN: Boolean);
    procedure FindArray(S: String; Neg: Integer; var ND1: TDataNode; var SArg: String; var BH1,EOFN1: Boolean);
    procedure FindJMP(S: String; var ni: Integer);
    procedure FindFLD(S: String; var ni: Integer);
    procedure FindIDAM(S: String; var code,ni: Integer);
    procedure FindControlCom(S: String; var code,ni: Integer; var BH: Boolean);
    procedure FindFuncBr(S: String; BrS1,BrS2: String; var Sf: String; var Sa: String; var FH: Boolean);
    procedure OperationalAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
    procedure AddOptimizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
    procedure MulOptimizator(LV:PLevel; ND: TDataNode; C: TFloatType; Neg: Integer; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
    procedure FunctionalAnalizator(nf: TIntegType; A: TFloatType; B: TFloatType; Arg1: String; Arg2: String; var ND: TDataNode; var LV: PLevel; var EOFN: Boolean);
    procedure SubstParam(S1: String; var S2: String; var C: TFloatType; var SB: TIntegType);
    procedure PredSyntax(S: String; var ND: TDataNode; var LV: PLevel; var BH: Boolean; var EOFN: Boolean);
    procedure WriteNodeParam(ND: TDataNode);
    procedure FindAV(S: String; ND: TDataNode; var A: TFloatType; var FIN: TFin; var ni: TIntegType);
    procedure FindAMVAB(S: String; var ni: TIntegType; var FIN: TFin; var PN: TMass2);
    procedure InitNode(var ND: TDataNode);
    procedure FindMV(S: String; var PN: TMass2; var ni: TIntegType);
    procedure FindMAF(S: String; var PN: TMass2; var B: TFloatType; var BH: Boolean);
    procedure FindAMVAB_FI(S: String; var A: TFloatType; var B: TFloatType; var nf: TIntegType; var ni: TIntegType; var BH: Boolean);
    procedure WriteDataCode;
    procedure FindAFB(S: String; var A: TFloatType; var B: TFloatType; var BH: Boolean);
    procedure FindArgType(S: String; var nt: TIntegType; var A: TFloatType; var B: TFloatType; var nf: TIntegType; var ni: TIntegType; var PN: TMass2);
    procedure WriteArgData(nt: TIntegType; A: TFloatType; B: TFloatType; ni: TIntegType; nf: TIntegType; PN: TMass2; var ND: TDataNode);
    procedure FindFuncArgData(S: String; var ND: TDataNode; var nt: TIntegType{; var BH: Boolean});
    procedure FindFunction(S: String; var A: TFloatType; var B: TFloatType; var Arg1: String; var Arg2: String; var nf: TIntegType; var BH: Boolean);
    procedure FindFuncSymb(S1: String; var S2: String);
    procedure FindFactSymb(S1: String; var S2: String);
    procedure FindFact2Symb(S1: String; var S2: String);
    procedure ReplacePowerSymb(S1: String; var S2: String);
    procedure FindPowerSymb(S1: String; var S2: String);
    procedure ReplaceAbsBr(S: String; var S1: String);
    procedure ReplaceTruncBr(S: String; var S1: String);
    procedure ReplaceFracBr(S: String; var S1: String);
    //procedure ReplaceIff(S1: String; var S2: String);
    procedure replaceAndOr(S: String;  var S1: String);
    //procedure insIf(S: String; P,N: Integer; var S1: String);
    procedure XchangeAddingBracket(S: String; var S1: String);
    procedure PrevTreat(S: String; var S1: String);
    procedure SetAdditionalParameter(S: String; V: TFloatType);
    procedure FreeTree;
    procedure FreeFunction;
    function  GetParameter2(S: String): TFloatType;
    procedure SetParameter(Number: TIntegType; V: TFloatType);
    function  GetParameter1(Number: TIntegType): TFloatType;
    procedure Linker(S:String);
    procedure SetStackSize;
    procedure CodeGeneration;
    procedure SetArrayLoadSource;
    procedure FindSA(S: String; var LV: PLevel; var A: TFloatType; var N: TIntegType; var BH: Boolean);
    procedure FindFIAV(S1: String; var ni: TIntegType; var FIN: TFin; var A,B: TFloatType; var PN: TMass2);
    procedure FindManyArg(S: String; nf: Integer);
    procedure ExtFunc(nf: TIntegType;  ND: TDataNode; var LV: PLevel; var ND1: TDataNode; var EOFN: Boolean);
    procedure SetExtArgType(nf: Integer; LV: PLevel; var LV1: PLevel); {.227}
    procedure MODAnalizator(LV: PLevel; ND: TDataNode;  var LV1: PLevel; var ND1: TDataNode; var EOFN: boolean);
    procedure POLYAnalizator(LV: PLevel; ND: TDataNode;  var LV1: PLevel; var ND1: TDataNode; var EOFN: boolean);
    procedure POLYDIFFAnalizator(LV: PLevel; ND: TDataNode;  var LV1: PLevel; var ND1: TDataNode; var EOFN: boolean);
    procedure IFAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode);
    procedure DtaAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
    procedure FuncFType1(nf: TIntegType; Arg1: String; var LV: PLevel; var ND: TDataNode; var EOFN: Boolean);
    procedure FuncFType2(nf: TIntegType; Arg1: String; var LV: PLevel; var ND: TDataNode; var EOFN: Boolean);
    procedure FuncFType3(nf: TIntegType; Arg1,Arg2: String; var LV: PLevel; var ND: TDataNode; var EOFN: Boolean);
    procedure FuncFType4(nf: TIntegType; Arg1,Arg2: String; var LV: PLevel; var ND: TDataNode; var EOFN: Boolean);
    procedure FuncFType5(nf: TIntegType; Arg1: String; var LV: PLevel; var ND: TDataNode; var EOFN: Boolean);
    procedure FuncFType17M(nf: TIntegType;  var LV: PLevel; var ND1: TDataNode; var EOFN: Boolean);
    function  CmpAAF(NS,NF: Integer): Boolean;
    function  CmpMAF(NS,NF: Integer): Boolean;
    function  CmpFAVB(NS,NF: Integer): Boolean;
    function  CmpIAVB(NS,NF: Integer): Boolean;
    function  CmpAIFB(NS,NF: Integer): Boolean;
    function  CmpAAI(NS,NF: Integer): Boolean;
    function  CmpFAVB1(NS,NF: Integer): Boolean;
    function  CmpFunc1(NS,NF: Integer): Boolean;
    function  CmpFunc2(NS,NF: Integer): Boolean;
    function  CmpFunc3(NS,NF: Integer): Boolean;
    function  CmpFunc4(NS,NF: Integer): Boolean;
    procedure FindCMPArg(S1,S2: String; ND: TDataNode; var ND1: TDataNode; var BH: Boolean);
    procedure SUMPAnalizator(LV: PLevel; ND: TDataNode; var LV1: PLevel; var ND1: TDataNode; var EOFN: boolean);
    procedure LeadToDenominator(LV:PLevel;  var LV1:PLevel); {.249}
    procedure FindMulArg(S: String; var nt: TIntegType; var A: TFloatType; var B: TFloatType; var nf: TIntegType; var ni: TIntegType; var PN: TMass2);



    procedure FindConstItem(LM: PLevel; {Neg: Boolean;}Neg: Integer; T: Integer;  var LM1: PLevel; var A,B: TFloatType; var BH: Boolean);
    procedure PostCodeOptimization;
    procedure CalcConstExpr(S: String; var A: TFloatType; var BH: Boolean);
    procedure CalcConstExpr_MUL(LVA: PLevel; var A: TFloatType; var BH: Boolean);
    procedure SubstParamC(S1: String; var S2: String; var C: TFloatType; var SB: TIntegType);
    procedure CalcConstFunc;
    function  GetNumberXchTable(Code: Integer): Integer;
    function  GetPriorityXch(Code1,Code2: Integer): TPrt;
    function  Calc: TFloatType;
    //procedure AddNameFunction(FName,NName: String);
    procedure AddNameFunction(Code: Integer; Name: String);
    procedure ClearNameFunction(Code: Integer);
    procedure DeleteFunction(Code: Integer);
    procedure SetNodeDeep;
    procedure GetSizeInterp;
    procedure TreeOptimizator;
    procedure BranchOptimizator;
    function  CheckXchBranch(Lv: PNode): Boolean;
    procedure XchBranch(Pr: PNode);
    procedure RestoreStack;
    procedure InitConstDb;
    procedure InitVarUsed; {.225}
    function  EnableDL(I: Integer): Boolean;
    function  IsSameFunctions(NF,NS: Integer): Boolean;
    procedure ReplaceFunctionsT;
    procedure ReplaceFunctionsUT;
    procedure ReplaceOperations;
    procedure FindNonReplFunc(Sf: String; var BH: Boolean);
    procedure FindFuncInExpr(k: Integer; Sexpr: String; var BH: Boolean);
    procedure InsertCopyStack(NF,NS,N: Integer);
    procedure InsertCopyStackA(NF,NS,N: Integer);
    function  GetFirstNode(num: Integer): Cardinal;
    procedure FreeInterp;
    procedure FreeFuncData(FuncData: PFuncData);
    procedure SetNL;
    procedure SetLoadSource;
    procedure SetNM;
    procedure SetLoadMem(I: Integer);
    procedure DinamicLoadOptimizator;
    procedure SetDIVR;
    procedure PackageAnalizator(LV: PLevel; ND: TDataNode; var LV1: PLevel; var ND1: TDataNode; var BH,EOFN: Boolean);
    procedure PkSyntax(S:String; var ND: TDataNode; var LV:PLevel;  var EOFN: Boolean);
    procedure SetExchTableTrig(k: Integer);
    procedure SetExchTableHYP(k: Integer);
    function  FindIfFunc: Boolean;
    procedure FindVarB(S: String; var ni,VType: Integer);
    function  FuncArgType(nf,i: Integer): Integer;
    procedure LDAAnalizator(LV: PLevel; ND: TDataNode; var LV1: PLevel; var ND1: TDataNode);
    procedure GOTOAnalizator(LV: PLevel; ND: TDataNode; var LV1: PLevel; var ND1: TDataNode);
    procedure SAVEAnalizator(LV: PLevel; ND: TDataNode; var LV1: PLevel; var ND1: TDataNode);
    procedure IDAMAnalizator(LV: PLevel; ND: TDataNode; var LV1: PLevel; var ND1: TDataNode);
    procedure SetLenAnalizator(LV: PLevel; ND: TDataNode; var LV1: PLevel; var ND1: TDataNode);
    procedure ReWriteArg(nf: Integer; LV: PLevel; var LV1: PLevel);
    procedure ReplaceFuncIntPart(S,SF: String; var S1: String);
    procedure ReplaceSecCosec(S,SF,SFR: String; var S1: String);
    procedure ConvToAtn2(S1: String; var S2: String);     {.209}
    procedure FindExternalBracketA(S: String; var SS: String);
    procedure FindExternalBracketAP(PS: PString);     {.209}
    function  CheckToZero(S: String): Boolean;    {.217}
    function  CheckName(Name: String): Boolean;
    procedure DelVoidSave;
    procedure ReplaceAndOrSKIP(S: String;  var S1: String);
    procedure EnDisDerivNames(Code,Value:Integer);


  protected
   ExtException: {Pointer}TExternalException;  //  
   procedure  IntException;  virtual;



  public

   constructor Create;
   destructor  Destroy;    overload;

    procedure SetF(C,Code,Value: Integer);
    function  GetF(C,Code: Integer): Integer;
    function  GetFuncName(id: cardinal): String;


   procedure SetExtExpression(S: String;  Atr: TAttrib; var E_Func: TFunction);
   procedure CheckSyntax(S: String;  var S1: String);
   procedure SetNewVar(Name: String; Addr: Cardinal; VType: Integer);
   procedure DeleteVar(Name: String);
   procedure FreeExtFunc(E_Func: PFunction);
   procedure AddNewFunction(Func: TAdditionalFunc; var ID: Cardinal);
   procedure SetStackDeep(S: Integer);
   procedure SetLevelReplace(L: Integer);
   function  GetLevelReplace: Integer;
   procedure FindFunc(Name: String; var id,ftype: Integer; var adr: Cardinal);
   procedure GetVarAdr(Name: String; var Addr: Cardinal; var VType: Integer);
   procedure FindFuncName(Sf: String; var nf: Integer);
   procedure ExistVar(S1: String; var VType: Integer; var AdrV: Cardinal);
   function  ExistParameter(S: String): Boolean;
   procedure RenameParameter(S,SN: String; v: TFloatType);
   procedure SafeCalcResult(NAdr: TAddress; var FRes: TFloatType);
   procedure MaskFPUException(CWAddr: PCardinal);    {.248}   stdcall;
   function  IsFPUException(CWAddr: PCardinal): integer;  {.248}   stdcall;
   function  IsFPUExceptionSW(CWAddr: PCardinal): integer;     stdcall;
   procedure ClearFPUException;         {.249}
   procedure TryFPUMask{(CWMEM: PCardinal)};        {.249}
   procedure TryCatchFPUException{(CWMEM: PCardinal)};  {.249}
   procedure SaveSW;

   procedure ClearVar;
   procedure ClearParam;
   procedure FreeVar;
   procedure FreeParam;
   procedure FreeAddFunction;
   function  GetReg(R: Integer): Integer;       //  [R]   -
   procedure SetReg(Reg: Integer; SC: Integer); //   [R]   -
   procedure SetPkgData(PD: TArrayPkg);
   procedure PushVar;
   procedure PopVar;
   procedure PushParam;
   procedure PopParam;

   function  GetVarList: TVarList; {.223}

   property  Parameter[Name: string]: TFloatType read GetParameter2 write SetAdditionalParameter;
   property  AddNewFuncName[Code: Integer]: String write AddNameFunction;
   property  ClearNameFunc: Integer write ClearNameFunction;
   property  DeleteFunc: Integer write DeleteFunction;
   property  SyntaxExtension: Boolean read F_SyntaxExtension write F_SyntaxExtension default True;
   //property  VarShift: Boolean read F_VarShift write F_VarShift default False;
   //property  FuncShift: Boolean read F_FuncShift write F_FuncShift default False;
   property  VarPresent: Boolean read F_VarPresent write F_VarPresent default False;
   property  CalcConstantFunc: Boolean read F_CalcConstantFunc write F_CalcConstantFunc default True;
   property  CalcConstExpression: Boolean read F_CalcConstExpr write F_CalcConstExpr default True;
   property  EnableCalcConstExpression: Boolean read F_EnableCalcConstExpression default True;
   property  EnableCalcConsExprInMulti: Boolean read F_EnableCalcConsExprInMulti write F_EnableCalcConsExprInMulti default False; {.245}
   property  ShowException: Boolean read F_ShowException write F_ShowException default True;
   property  ErrorCode: TIntegType read  F_ErrorCode write F_ErrorCode default 0;
   property  SyntaxErrorString: String read F_SyntaxErrorString write F_SyntaxErrorString;
   property  ExternalException: Boolean read F_ExternalException write F_ExternalException default False;
   property  ParamType: Integer read F_ParamType write F_ParamType default _Extended;
   property  DataType: Integer read F_DataType  write F_DataType default _Extended;
   property  TreeOptimization: Integer read F_TreeOptimization write F_TreeOptimization default 2;
   property  DinamicLoadOptimization: Integer read F_DinamicLoadOptimization write F_DinamicLoadOptimization default 2;
   property  SaveInStack: Boolean read F_SaveInStack write F_SaveInStack default True;
   property  GlobalOptimization: Boolean read F_Optimization write F_Optimization default True;
   property  UseReg[R: Integer]: Integer read GetReg;
   property  CloseArg: Boolean read F_CloseArg write F_CloseArg default False;
   property  PackageCompile: Boolean read F_PackageCompile write F_PackageCompile default False;
   property  SpecTrigOptim: Integer write SetExchTableTrig;
   property  SpecHYPOptim:  Integer write SetExchTableHYP;
   property  ReplaceFunction: Boolean   read  F_ReplaceFunction  write  F_ReplaceFunction  default True;
   property  ReplaceOperation: Boolean   read  F_ReplaceOperation  write  F_ReplaceOperation  default True;   {.199}
   property  UseVirtAlloc: Boolean   read  F_UseVirtAlloc  write  F_UseVirtAlloc  default False;      {.199}
   property  RetNum: Integer read  F_RetNum;
   property  EnableReplaceInPackage: Boolean read F_EnableReplaceInPackage write F_EnableReplaceInPackage  default False; {.205}
   property  DisableReplaceIF: Boolean read F_DisableReplaceIF  write  F_DisableReplaceIF   default False; {.205}
   property  ConvertAtanToAtan2: Boolean read F_ConvertAtanToAtan2  write  F_ConvertAtanToAtan2   default True; {.209}
   property  MulDivOptimization: Boolean read F_MulDivOptimization  write  F_MulDivOptimization   default True; {.243}
   property  AddSubOptimization: Boolean read F_AddSubOptimization  write  F_AddSubOptimization   default True; {.243}
   property  SkippedIF: Boolean read F_SkippedIF  write  F_SkippedIF   default True; {.243}
   property  LeadToLowerCase: Boolean read F_LeadToLowerCase write F_LeadToLowerCase default True; {.245}
   property  EnableMaskFpuException: Boolean read F_EnableMaskFpuException write F_EnableMaskFpuException default False; {.248}
   property  FResult: TFloatType read FV_Result write FV_Result; {.248}
   property  FuncArgOptimization: Boolean read F_FuncArgOpt write F_FuncArgOpt default True;  {.249}


   property  XchBrSDeep:      Integer read Db_XchBrSDeep;
   property  XchBrNXch:       Integer read Db_XchBrNXch;
   property  DinLoadSDeep:    Integer read Db_DinLoadSDeep;
   property  DinLoadNMem:     Integer read Db_DinLoadNMem;
   property  DinLoadOverFlow: Boolean read Db_DinLoadOverFlow;
   property  CmplMaxStack:    Integer read Db_CmplMaxStack;
   property  CmplOverFlow:    Boolean read Db_CmplOverFlow;
   property  CopyStackXch:    Integer read Db_CopyStackXch;
   property  CopyStackXchG:   Integer read Db_CopyStackXchG;
   property  CopyStackOpXch:  Integer read Db_CopyStackOpXch;
   property  CalcConst:       Integer read Db_CalcConst;
   property  MaxReplaceLevel: Integer read Db_MaxReplaceLevel;
   property  LoadStackAfterCalc: Integer read Db_LoadStackAfterCalc default 0;





  published



  end;

  //procedure _StrToFloatEx(S: String; var Vex: extended; var SB: integer);

var

  C_2dqrPi: extended;
  Factorial,Factorial1,Factorial2,Factorial2F: TArrayF;          // 
  G_FMT: TFormatSettings;
  V_FVar: extended;

  ForevalH: TForevalH;
  CWMEM,SWMEM,CWMEM1,CWMEM2,CWMEM3,CWMEM4,CWMEM5,CWMEM6,CWMEM7,CWMEM8: Cardinal;



implementation
uses
{$IFDEF DEBUGS}
TestG8,
{$ENDIF}
Foreval_Compilator, Foreval_Command;
var
Cmpl: TCompiler;
G_Test1,G_Test2,G_Test3: integer;
codeArray: array [0..10] of byte;






procedure TForevalH.SetStackSize;
label endp;
begin
if F_ErrorCode <> 0 then goto endp;
Tree:=BeginTree;   // , ..   - 

while Tree^.Ch <> nil do
begin
Tree:=Tree^.Ch;
end;
StackSize:=Tree^.Stack.S;

while Tree^.Pr <> nil do
begin
 while Tree^.Nb <> nil  do
 begin
 Tree:=Tree^.Nb;
  while Tree^.Ch <> nil do
  begin
  Tree:=Tree^.Ch;
  end;
if Tree^.Stack.S > StackSize then StackSize:=Tree^.Stack.S;
 end;
 Tree:=Tree^.Pr;
if Tree^.Stack.S > StackSize then StackSize:=Tree^.Stack.S;
end;

//SetLength(Func.Stack,StackSize+1);
endp:
end;

{
         |
         |
         ND
 (A*B+C/D*E-F*G/H/I)  <-current node ; current subexpression = Tree^.Expression -> SyntaxAnalizator
       / | \
     /   |   \
   /     |     \
  ND     ND     ND
(A*B)  (C/D*E)  (F*G/H/I)   LV (array)  <- current level: is taken all outgoing nodes at the same level(in operations with equal priority) (+,-) or (*,/)
| |     | | |     | | | |
A B     C D E     F G H I

  Tree^.Ch (child)    parent pointer  on first child (Of all childs at the same level)
  Tree^.Nb (neighbor) pointer to neighbor node on the same level
  Tree^.Pr  (parent)  all childes nodes has pointer to their parent
}

procedure TForevalH.Linker(S: String);   //creating of tree of expression
label endp;
var
HS: PLevel;
ND: TDataNode;
H,H1: PNode;
EOFN: Boolean;
i: Cardinal;
begin
if F_ErrorCode <> 0 then goto endp;
New(Tree);
Tree^.Ch:=nil;
Tree^.Nb:=nil;
Tree^.Pr:=nil;
BeginTree:=Tree;
// :
Tree^.Expression:=S;
Tree^.Stack.S:=1;
Tree^.I:=0;
//Tree^.NL:=0;
Tree^.IdL:=0;
F_IdN:=0;
EOFN:=True;
if F_PackageCompile then PkSyntax(Tree^.Expression,ND,HS,EOFN)
else
SyntaxAnalizator(Tree^.Expression,ND,HS,EOFN);
//:
//COP<>NOP:
while EOFN <> True do         //EOFN= end of node
begin
if F_ErrorCode <> 0 then goto endp;

New(H);
Tree^.Ch:=H;
inc(F_IdN);               // 
WriteNodeParam(ND);
WriteLevelParam(H,HS,0);


H^.Stack.S:=Tree^.Stack.S;
H^.Pr:=Tree;
H1:=H;
H^.Ch:=nil;
H^.Nb:=nil;

for i:=1 to High(HS) do
begin
 New(H);
 H^.Ch:=nil;
 H^.Nb:=nil;
 WriteLevelParam(H,HS,i);
 H^.Stack.S:=H1^.Stack.S+1;
 H1.Nb:=H;
 H^.Pr:=Tree;
 //HS:=HS^.Next;
 H1:=H;
end;
Tree:=H^.Pr^.Ch;
HS:=nil; //??? (  )
SyntaxAnalizator(Tree^.Expression,ND,HS,EOFN);
end;
//EOFN=True:    ( )
inc(F_IdN);
WriteNodeParam(ND);


//:
while Tree^.Pr <> nil do
begin
 while Tree^.Nb <> nil  do
 begin
 Tree:=Tree^.Nb;
 SyntaxAnalizator(Tree^.Expression,ND,HS,EOFN);
//COP<>NOP:
while EOFN<>True do
 begin
 if F_ErrorCode <> 0 then goto endp;

 New(H);
 Tree^.Ch:=H;
 inc(F_IdN);  // 
 WriteNodeParam(ND);
 WriteLevelParam(H,HS,0);

 H^.Stack.S:=Tree^.Stack.S;
 H^.Pr:=Tree;
 H1:=H;
 H^.Ch:=nil;
 H^.Nb:=nil;
 for i:=1 to High(HS) do
 begin
  New(H);
  H^.Ch:=nil;
  H^.Nb:=nil;
  WriteLevelParam(H,HS,i);

  H^.Stack.S:=H1^.Stack.S+1;
  H1.Nb:=H;
  H^.Pr:=Tree;
  H1:=H;
 end;
 Tree:=H^.Pr^.Ch;
 HS:=nil; //??? (  )
 SyntaxAnalizator(Tree^.Expression,ND,HS,EOFN);
 end;
//EOFN=True:  
inc(F_IdN);
WriteNodeParam(ND);
end;
Tree:=Tree^.Pr;
end;

Tree:=BeginTree;


endp:
end;



procedure TForevalH.FreeFunction;
var
i: Integer;
begin
Func.Code:=nil;
Func.Stack:=nil;
Func.CpSt:=nil;
FreeFuncData(Func.Data);
end;



procedure TForevalH.WriteNodeParam(ND: TDataNode);
begin
Tree^.IdN:=F_IdN;

Tree^.Stack.N:=ND.N;
Tree^.Neg:=ND.Neg;
Tree^.XCHA:=ND.XCHA;
Tree^.AI:=ND.AI;
Tree^.BI:=ND.BI;
Tree^.CI:=ND.CI;
Tree^.DI:=ND.DI;
Tree^.EI:=ND.EI;
Tree^.FI:=ND.FI;
Tree^.FV1:=ND.FV1;
Tree^.FV2:=ND.FV2;
Tree^.IV1:=ND.IV1;
Tree^.IV2:=ND.IV2;
Tree^.F1:=ND.F1;
Tree^.F2:=ND.F2;


Tree^.V1:=ND.V1;
Tree^.V2:=ND.V2;
Tree^.V3:=ND.V3;
Tree^.V4:=ND.V4;
Tree^.V4:=ND.V4;
Tree^.VI1:=ND.VI1;
Tree^.VI2:=ND.VI2;
Tree^.VI3:=ND.VI3;
Tree^.VI4:=ND.VI4;


Tree^.SGN:=ND.SGN;
Tree^.SNExtArg:=ND.SNExtArg;
Tree^.PN:=ND.PN;
Tree^.PN1:=ND.PN1;
Tree^.VFP:=ND.VFP; {.223}
Tree^.Code:=ND.Code;
Tree^.AFB:=ND.AFB;
Tree^.Adr:=ND.Adr;
Tree^.AdrV1:=ND.AdrV1;
Tree^.AdrV2:=ND.AdrV2;
Tree^.AdrF1:=ND.AdrF1;

Tree^.ExpressionArg:=ND.ExpressionArg;
end;



procedure TForevalH.WriteLevelParam(H: PNode; HS: PLevel; N: Cardinal);
begin
H^.IdL:=F_IdN;
H^.Expression:=HS[N].Expression;
H^.I:=HS[N].I;
H^.ExtArg:=HS[N].ExtArg;
H^.SExtArg:=HS[N].SExtArg;
H^.PkAdr:=HS[N].PkAdr;
H^.PkShift:=HS[N].PkShift;
H^.PkRType:=HS[N].PkRType;
end;


procedure TForevalH.FindExternalBracket(S: String; var SS: String; {var Neg: Boolean} var Neg: Integer);
// (-(((-((-(expr))))))) -> SS = expr;  Neg=1 if  sum of all external  minuses is odd; else Neg = 0
label
2,3,endp;
var
b,i,z,a:TIntegType;
begin
SS:=Copy(S,1,Length(S));
z:=1;

2:
b:=0; a:=1;

if SS = '' then
begin
goto endp;
end;


if SS[1] = '-' then a:=2;

if  SS[a] = '(' then
begin
 b:=-1;
 for i:=a+1 to Length(SS)-1 do
 begin
  if SS[i] = '(' then b:=b-1;
  if SS[i] = ')' then b:=b+1;
  if b = 0 then goto 3
 end;


 if SS[Length(SS)] = ')' then
 begin
  if a = 2 then
  begin
   Delete(SS,1,1);
   z:=z*(-1);
  end;
  Delete(SS,1,1);
  Delete(SS,Length(SS),1);
  goto 2;
 end;
end;

3:
if z = -1 then  Neg:=1
else  Neg:=0;


endp:
end;



procedure TForevalH.FindMainOperation(S:String; var MOP: Integer);
label endp;
var
Pl,Ml: Boolean;
i,b,b1,b2: TIntegType;
E: Exception;
begin
if F_ErrorCode <> 0 then goto endp;

if S = '' then
begin
F_ErrorCode:=E_MISSING_EXPRESSION;
//raise ESyntaxError.Create('');
goto endp;
end;

MOP:=_NOP;
b:=0; b1:=0; b2:=0; Pl:=False; Ml:=False;



if S[1] = '(' then b:=-1 else
  (*if S[1] = '[' then b1:=-1 else
    if S[1] = '{' then b2:=-1 else*)
      if (S[1] = ')') (*or (S[1] = ']') or (S[1] = '}')*) then
      begin
       F_ErrorCode:=E_MISSING_EXPRESSION;
       F_SyntaxErrorString:=Copy(S,1,Length(S));
       //raise ESyntaxError.Create('');
       goto endp;
      end;


if (S[Length(S)] = '*') or (S[Length(S)] = '/') or (S[Length(S)] = '+') or (S[Length(S)] = '-')
then
begin
 F_ErrorCode:=E_MISSING_EXPRESSION;
 F_SyntaxErrorString:=Copy(S,1,Length(S));
 //raise ESyntaxError.Create('');
 goto endp;
end;
for i:=2 to Length(S) do
begin
 if S[i] = '(' then b:=b-1;
 if S[i] = ')' then b:=b+1;
 if S[i] = '[' then b1:=b1-1;
 if S[i] = ']' then b1:=b1+1;

 (*if S[i] = '{' then b2:=b2-1;
 if S[i] = '}' then b2:=b2+1;*)

 if (b = 0) and (b1 = 0) {and (b2 = 0)} and ((S[i] = '+') or (S[i] = '-')) then Pl:= True;
 if (b = 0) and (b1 = 0) {and (b2 = 0)} and ((S[i] = '*') or (S[i] = '/')) then Ml:= True;
end;
if Ml = True then MOP:=_MUL;
if Pl = True then MOP:=_ADD;


endp:
end;





procedure TForevalH.StringAnalizator(S:String; var N: TIntegType; var COP: Integer; var HS:PLevel; var{Neg: Boolean} Neg: Integer);
label endp;
var
SS,S2,SMOP,SMOP1: String;
BH,IH,IH1: PLevel;
i,p,b,b1,b2: TIntegType;
Neg1,MOP,MOP1,SB: Integer;
C: extended;
E: Exception;
begin
if F_ErrorCode <> 0 then goto endp;

FindExternalBracket(S,SS,Neg1);
if SS = '' then
begin
 F_ErrorCode:=E_MISSING_EXPRESSION;
 F_SyntaxErrorString:=S;
 goto endp;
end;

//    1.233454565E+1233
SaveSW; {.249} {TryStrToFloat damage SW}
if TryStrToFloat(SS,C,G_FMT) = true then  MOP:=_NOP else FindMainOperation(SS,MOP);



if MOP = _ADD then begin MOP1:=_SUB; SMOP:='+'; end
else
if MOP = _MUL then begin MOP1:=_DIV; SMOP:='*'; end;
Neg:=Neg1;
N:=0;

if MOP <> _NOP then
 begin
 p:=1; b:=0;  b1:=0; b2:=0;  BH:=IH; IH1:=IH;

 if MOP = _ADD then begin MOP1:=_SUB; SMOP1:='-'; end
 else
 if MOP = _MUL then begin MOP1:=_DIV; SMOP1:='/'; end;


if SS[1] = '(' then b:=-1; {else
  if SS[1] = '[' then b1:=-1 else
    if SS[1] = '{' then b2:=-1;}

 for i:=2 to Length(SS)do
  begin

   if SS[i] = '(' then b:=b-1;
   if SS[i] = ')' then b:=b+1;
   if SS[i] = '[' then b1:=b1-1;
   if SS[i] = ']' then b1:=b1+1;
   (*if SS[i] = '{' then b2:=b2-1;
   if SS[i] = '}' then b2:=b2+1;*)

   if (b = 0) and (b1 = 0) {and (b2 = 0)} and ((SS[i] = SMOP) or (SS[i] = SMOP1)) then
    begin

      if Copy(SS,p,i-p) = '' then
      begin
       F_ErrorCode:=E_MISSING_EXPRESSION;
       F_SyntaxErrorString:=Copy(S,1,Length(S));
       //raise ESyntaxError.Create('');
       goto endp;
      end;

     N:=N+1;
     SetLength(HS,N);
     HS[N-1].Expression:=Copy(SS,p,i-p);
     HS[N-1].I:=_NOP;
     HS[N-1].ExtArg:=_None;
     if (N-1) > 0 then
     begin
      if SS[p-1] = '-' then  HS[N-1].I:=_SUB   else
      if SS[p-1] = '/' then  HS[N-1].I:=_DIV   else
      if SS[p-1] = '*' then  HS[N-1].I:=_MUL   else
      if SS[p-1] = '+' then  HS[N-1].I:=_ADD;
     end;
     p:=i+1;
    end;
  end;

 N:=N+1;
 SetLength(HS,N);
 HS[N-1].Expression:=Copy(SS,p,Length(SS)-p+1);
 HS[N-1].I:=_NOP;

 if SS[p-1] = '-' then  HS[N-1].I:=_SUB   else
 if SS[p-1] = '/' then  HS[N-1].I:=_DIV   else
 if SS[p-1] = '*' then  HS[N-1].I:=_MUL   else
 if SS[p-1] = '+' then  HS[N-1].I:=_ADD;
 end
else
begin   {     - , , }
 N:=1;
 SetLength(HS,N);
 HS[0].Expression:=Copy(SS,1,Length(SS));
 HS[0].ExtArg:=_None;
 //N:=0; {.221} //N=0 -end of node !!
end;

COP:=MOP;

endp:
end;




procedure TForevalH.NumberAnalizator(LV: PLevel; ND: TDataNode; var LV1: PLevel; var ND1: TDataNode; var EOFN: Boolean);
label 1,endp;
var
S2,SArg: String;
ni,SB: TIntegType;
//Neg: Boolean;
Neg,VType,code: Integer;
C: TFloatType;
FIN: TFin;
E: Exception;
BH,BH1,EOFN1: Boolean;
begin
PackageAnalizator(LV,ND,LV1,ND1,BH,EOFN);
if BH then goto endp;

EOFN:=False;  Neg:=0;

SubstParam(LV[0].Expression,S2,C,SB);
if SB = 1 then
begin
ND.V2:=C;
ND.Code:=C_LDSC;
EOFN:=True;
ND.N:=0; {.221}    //N=0 -end of node !!
goto 1;
end;


FindVar(LV[0].Expression,ND,ni,FIN,Neg);
if ni <> 0 then
 begin
  if (ni = 1) or (ni = 20) then
  ND.Code:=C_LDSF
  else
  if ni = -1 then
  ND.Code:=C_LDSI;
  ND.FV1:=FIN.F;
  ND.IV1:=FIN.I;
  ND.Neg:=Neg;
  EOFN:=True;
  ND.N:=0; {.221}     //N=0 -end of node !!
  goto 1;
 end;



//Array:   Vec[Num],Vec[IVar],Vec[FVar],Vec[ARGI],Vec[Trunc(Expr)]
FindArray(LV[0].Expression,ND.Neg,ND,SArg,BH1,EOFN1);
if F_ErrorCode <> 0 then goto endp;
if  BH1 = True  then
begin
 ND.N:=0; {.221}     //N=0 -end of node !!

 if EOFN1 = False then
 begin
   LV[0].Expression:=Copy(SArg,1,Length(SArg));
   ND.N:=1;
 end;
 EOFN:=EOFN1;
 F_VarPresent:=True;
 goto 1;
end;

//array:
FindVarA(LV[0].Expression,FIN,VType);
if (VType = _ArrayD) or (VType = _ArrayE) or (VType = _ArrayS) or (VType = _ArrayI) then
begin
   {ND.Code:=C_LDSV;
   ND.EI:=5;
   ND.IV2:=FIN.I;  }
   ND.Code:=C_LDSVA; {arraycpu}{.245}     // 
   ND.IV2:=FIN.I;
   EOFN:=True;
   F_VarPresent:=True;
   ND.N:=0; {.221}     //N=0 -end of node !!
   goto 1;
end;

{
// :
FindJMP(LV[0].Expression,ni);
if ni <> 0 then
begin
 ND.code:=C_JMP;
 ND.EI:=ni;
 EOFN:=True;
 goto 1;
end;
}

FindControlCom(LV[0].Expression,code,ni,BH);
if BH = True then
begin
 ND.code:=code;
 ND.EI:=ni;
 ND.IV1:=ni;    //inc,dec,add,mul
 EOFN:=True;
 ND.N:=0; {.221}     //N=0 -end of node !!
 goto 1;
end;


F_ErrorCode:=E_UNKNOWN_SYMBOL;
F_SyntaxErrorString:=Copy(LV[0].Expression,1,Length(LV[0].Expression));
//raise ESyntaxError.Create('');

ND.Code:=C_LDSC; EOFN:=True;
ND.N:=0; {.221}     //N=0 -end of node !!

1:
ND1:=ND; LV1:=LV;
endp:
end;



procedure TForevalH.FindControlCom(S: String; var code,ni: Integer; var BH: Boolean);
label endp;
begin
FindJMP(S,ni);
 if ni <> 0 then
 begin
  code:=C_JMP;
  BH:=True;
  goto endp;
 end;

FindFLD(S,ni);
if ni <> 0 then
 begin
  code:=C_FLD;
  BH:=True;
  goto endp;
 end;

//FNOP:
if S = '#nop' then
begin
  code:=C_NOP;
  BH:=True;
  goto endp;
end;

{FindIDAM(S,code,ni);
 if ni <> 0 then
 begin
  BH:=True;
  goto endp;
 end;
}

endp:
end;



procedure TForevalH.FindJMP(S: String; var ni: Integer);
begin
//nf= 1       2      3       4      5      6     7
//  #JMP, #JMPE, #JMPEL, #JMPEB, #JMPB, #JMPL, #JMPNE
if S = '#jmp'    then ni:=1 else
if S = '#jmpe'   then ni:=2 else
if S = '#jmpel'  then ni:=3 else
if S = '#jmpeb'  then ni:=4 else
if S = '#jmpb'   then ni:=5 else
if S = '#jmpl'   then ni:=6 else
if S = '#jmpne'  then ni:=7 else
ni:=0;
end;


procedure TForevalH.FindFLD(S: String; var ni: Integer);
begin
//nf= 1     2
//  #FLD1, #FLDZ,
if S = '#fld1'    then ni:=1 else
if S = '#fldz'   then ni:=2 else
ni:=0;
end;





procedure TForevalH.FindIDAM(S: String; var code,ni: Integer);
label endp;
var
FIN: TFIN;
VType,p,p1: integer;
SV: String;
begin
//  inc(Varint), dec(Varint), add(Varint,int), mul(Varint,int),
code:=0; ni:=0;
P:=pos('inc(',S);

if p = 1 then
begin
  P1:=PosEx(')',S,4);
  if P1 <> 0 then
  begin
    SV:=Copy(S,5,P1-5);
    FindVarA(SV,FIN,VType);
    if VType = _Integer then
    begin
      ni:=FIN.I;
      code:=C_INC;
      goto endp;
    end;
  end;
end
else
begin
 P:=pos('dec(',S);
 if p = 1 then
 begin
  P1:=PosEx(')',S,4);
  if P1 <> 0 then
  begin
    SV:=Copy(S,5,P1-5);
    FindVarA(SV,FIN,VType);
    if VType = _Integer then
    begin
      ni:=FIN.I;
      code:=C_DEC;
      goto endp;
    end;
  end;
 end
end;


endp:
end;




procedure TForevalH.FindArray(S: String; Neg: Integer; var ND1: TDataNode; var SArg: String; var BH1,EOFN1: Boolean);
label endp;
var
FH: Boolean;
C,A,B: TFloatType;
SB,VType,nt,ni,nf,nm,Neg1: Integer;
Sf,Sa,S2: String;
FIN: TFIN;
PN: TMass2;
begin
if F_ErrorCode <> 0 then goto endp;

InitNode(ND1);
Neg1:=0;
if S[1] = '-' then
begin
 Neg1:=1;
 Delete(S,1,1);
end;

FindFuncBr(S,'[',']',Sf,Sa,FH);
if (FH = True) and (Sa = '') then
begin
     F_ErrorCode:=E_MISSING_ARGUMENT;
     F_SyntaxErrorString:=Copy(S,1,Length(S));
     goto endp;
     //raise ESyntaxError.Create('');
end;

if FH = True  then
begin
 FindVarA(Sf,FIN,VType);
 if (VType = _ArrayD) or (VType = _ArrayE)  or (VType = _ArrayS) or (VType = _ArrayI) then
 begin
  nm:=FIN.I;                                                     //const:   EI:=1  ND.VI2=C
  SubstParamC(Sa,S2,C,SB);
  if SB = 1 then
  begin
   if Trunc(C) = C then
   begin
     ND1.EI:=1;
     ND1.VI2:=Trunc(C);
     //ND.Code:=C_LDSV;
     BH1:=True;
     EOFN1:=True;
   end
   else
   begin
     F_ErrorCode:=E_INCORRECT_ARGUMENT;
     F_SyntaxErrorString:=Copy(Sa,1,Length(Sa));
     //raise ESyntaxError.Create('');
   end;
  end
  else
  begin
   FindArgType(Sa,nt,A,B,nf,ni,PN);
   if (nt = _IAVB)  then                                //EI:=3; (a*i+b, i,a,b - integer) ND.VI1:=Trunc(A); ND.VI2:=Trunc(B); ND.IV1:=ni;
   begin                                                //EI:=2; (i - integ. var) ND.IV1:=ni;
    WriteArgData(nt,A,B,ni,nf,PN,ND1);
    if (A = 1) and (B = 0) then  ND1.EI:=2 else ND1.EI:=3;
    //ND.Code:=C_LDSV;
    BH1:=True;
    EOFN1:=True;
   end
   else
   if nt = _AAI then
   begin
    WriteArgData(nt,A,B,ni,nf,PN,ND1);                    //EI:=4; ND.PN1
    //ND.Code:=C_LDSV;
    ND1.EI:=4;
    BH1:=True;
    EOFN1:=True;
   end
   else
   begin
     ND1.EI:=0;
     BH1:=True;
     EOFN1:=False;
     SArg:=Copy(Sa,1,Length(Sa));
   end;
  end;
  ND1.IV2:=nm;
  ND1.Code:=C_LDSV;
 end
 else
 BH1:=False;
end
else
BH1:=False;

if (Neg = 1) and  (Neg1 = 1) then ND1.Neg:= 0
   else
   if (Neg = 1) and  (Neg1 = 0) then ND1.Neg:= 1
   else
   if (Neg = 0) and  (Neg1 = 1) then ND1.Neg:= 1
   else
   if (Neg = 0) and  (Neg1 = 0) then ND1.Neg:= 0;


endp:
end;





procedure TForevalH.FindFuncBr(S: String; BrS1,BrS2: String; var Sf: String; var Sa: String; var FH: Boolean);
label 1,endp;
var
bb,b2,b1,i: Integer;                                              //FH=True: func(arg)->Sf(Sa)
begin
                                                                   //BrS=(, [, {
FH:=False;
bb:=0; b1:=0;
for i:=1 to Length(S) do
begin
 if S[i] = {'('}BrS1 then begin b1:=i; goto 1; end;
end;
if b1 = 0 then begin FH:=False; goto endp; end;

1:
(*
b2:=0; bb:=-1;
for i:=b1+1 to Length(S) do
begin
 if S[i] = '(' then bb:=bb-1;
 if S[i] = ')' then bb:=bb+1;
 if (i <> Length(S)) and (bb = 0) then begin {Internal Error} end;
end;
*)
if b1 = 1 then  FH:=False else FH:=True;
if S[Length(S)] <> BrS2 then   FH:=False;

Sf:=Copy(S,1,b1-1);
Sa:=Copy(S,b1+1,Length(S)-b1-1);

endp:
end;



procedure TForevalH.FindVarA(S1: String; var FIN:TFin; var VType: Integer);
label endp;
var
i,ni: TIntegType;
S2,S3: String;
begin
if F_ErrorCode <> 0 then goto endp;
//S2:=Copy(S1,1,length(S1));

                                             //FIN.F -  fl. .
                                             //FIN.I -  int.,array .
ni:=0; FIN.F:=0; FIN.I:=0;                   //
VType:=0;




for i:=0 to High(VarList) do
begin

 S3:=VarList[i].Name;



 if S1 = S3 then
  begin

   if VarList[i].VType = _Integer then
   begin
    ni:=-1;
    FIN.I:=i;
    VType:=VarList[i].VType;
    F_VarPresent:=True;
    VarList[i].IsUsed:=True; {.225}
    goto endp;
   end
   else
   if (VarList[i].VType = _Single) or (VarList[i].VType = _Double) or (VarList[i].VType = _Extended)  then
   begin
    ni:=1;
    FIN.F:=i;
    VType:=VarList[i].VType;
    F_VarPresent:=True;
    VarList[i].IsUsed:=True; {.225}
    goto endp;
   end
   else
   if (VarList[i].VType = _ArrayS) or  (VarList[i].VType = _ArrayD) or (VarList[i].VType = _ArrayE) or (VarList[i].VType = _ArrayI) then
   begin
    FIN.I:=i;
    VType:=VarList[i].VType;
    F_VarPresent:=True;
    VarList[i].IsUsed:=True; {.225}
    goto endp;
   end;
  end;
end;


endp:
end;




procedure TForevalH.ExistVar(S1: String; var VType: Integer; var AdrV: Cardinal);
var
FIN:TFin;
//VType: Integer;
begin
 FindVarA(S1,FIN,VType);
 if VType > 0 then
 begin
  if FIN.F <> 0 then AdrV:=VarList[FIN.F].Addr
  else
  if FIN.I <> 0 then AdrV:=VarList[FIN.I].Addr
 end
 else  AdrV:=0;
end;





procedure TForevalH.PushVar;
var
i: Cardinal;
begin

SetLength(G_SaveVar,Length(VarList));

 for i:=0 to High(VarList) do
 begin
    G_SaveVar[i].Name:=VarList[i].Name;
    G_SaveVar[i].Addr:=VarList[i].Addr;
    G_SaveVar[i].VType:=VarList[i].VType;
 end;

end;



procedure TForevalH.PopVar;
var
i,Addr,IdType,MType: Cardinal;
begin

if Length(G_SaveVar) > 0 then
begin

 for i:=0 to High(G_SaveVar) do
 begin
  SetNewVar(G_SaveVar[i].Name,G_SaveVar[i].Addr,G_SaveVar[i].VType);
 end;

  //SetLength(G_SaveVar,0);
end;
end;





procedure TForevalH.PushParam;
var
i: Cardinal;
begin

SetLength(G_SaveParam,Length(ParamList));

 for i:=0 to High(ParamList) do
 begin
    G_SaveParam[i].Name:=ParamList[i].Name;
    G_SaveParam[i].Value:=ParamList[i].Value;
 end;

end;



procedure TForevalH.PopParam;
var
i: Cardinal;
begin

if Length(G_SaveParam) > 0 then
begin

 for i:=0 to High(G_SaveParam) do
 begin
  SetAdditionalParameter(G_SaveParam[i].Name,G_SaveParam[i].Value)
 end;

  //SetLength(G_SaveParam,0);
end;
end;




procedure TForevalH.PackageAnalizator(LV: PLevel; ND: TDataNode; var LV1: PLevel; var ND1: TDataNode; var BH,EOFN: Boolean);
begin
 EOFN:=False;
 if Copy(LV[0].Expression,1,9) = '@@PACKAGE' then
 begin
  ND1:=ND;
  LV1:=LV;
  ND1.Code:=C_PACKAGE;
  ND1.N:=1;
  Delete(LV1[0].Expression,1,9);
  BH:=True;
 end
 else
 BH:=False;
end;



function TForevalH.CheckName(Name: String): Boolean;
label endp;
var
 EnName: set of  Char;
 i: integer;
begin
 //EnName:=['(',')','{','}','[',']','|','*','/','>','<','=','+','!','@','^',':','-','.',',','&','%','#',':',';','\','~'];
 EnName:=['(',')','{','}','[',']','|','*','/','>','<','=','+','!','^',':','-','.',',',';','&'];

 for i := 1 to Length(Name) do
 begin
  if Name[i] in EnName then
  begin
    CheckName:=False; goto endp;
  end;
 end;
 if Name = '' then CheckName:=False else CheckName:=True;

 endp:
end;



procedure TForevalH.DeleteVar(Name: String);
label endp;
var
Name1: String;
i: integer;
begin
 for i:=0 to High(VarList) do
  begin

   Name1:=VarList[i].Name;

   if  Name = Name1 then
   begin
    VarList[i].Addr:=0;
    VarList[i].VType:=0;
    VarList[i].Name:='@hidden@';
    goto endp;
   end;

  end;

endp:
end;




procedure TForevalH.SetNewVar(Name: String; Addr: Cardinal; VType: Integer);
label endp,endp1;
var
i: TIntegType;
Name2,Name1: String;
E: Exception;
begin

if CheckName(Name) = false then begin F_ErrorCode:=E_WRONG_NAME; F_SyntaxErrorString:=Name; IntException; goto endp1; end;

if F_LeadToLowerCase = True then Name:=LowerCase(Name); {.245}

try
for i:=0 to High(VarList) do
begin
 Name1:=VarList[i].Name;

if  Name = Name1 then
 begin
  VarList[i].Addr:=Addr;
  VarList[i].VType:=VType;
  VarList[i].IsUsed:=False; {.225}
  goto endp;
 end;
 if Name1 = '@hidden@' then   // 
 begin
  VarList[i].Addr:=Addr;
  VarList[i].VType:=VType;
  VarList[i].Name:=Copy(Name,1,Length(Name));
  VarList[i].IsUsed:=False; {.225}
  goto endp;
 end;
end;

if (VType <> _Double) and  (VType <> _Extended)
   and (VType <> _Integer) and  (VType <> _Single)
   and (VType <> _ArrayD)  and  (VType <> _ArrayE)
   and (VType <> _ArrayS)  and  (VType <> _ArrayI)
then
begin
 //F_ErrorCode:={  }
 goto endp;
end;

SetLength(VarList,Length(VarList)+1);
VarList[High(VarList)].Name:=Copy(Name,1,Length(Name));
VarList[High(VarList)].Addr:=Addr;
VarList[High(VarList)].VType:=VType;
VarList[High(VarList)].IsUsed:=False; {.225}


endp:
except
 on E: EOutOfMemory     do F_ErrorCode:=E_OutOfMemory;
end;
//if F_ErrorCode <> 0 then raise EInternalError.Create('');

endp1:
end;





procedure TForevalH.FuncFType2(nf: TIntegType; Arg1: String; var LV: PLevel; var ND: TDataNode; var EOFN: Boolean);
label 1,endp;
var
nt,nt1,nt2,nf1,nif: Integer;
S1,S2,Sa: String;
B1: Boolean;
a,b: TFloatType;
ND1,ND2: TDataNode;
begin
if  F_ErrorCode <> 0 then goto endp;
EOFN:=False;    InitNode(ND);
Sa:=Copy(Arg1,1,Length(Arg1));



SetLength(LV,1); LV[0].I:=_NOP; LV[0].ExtArg:=_None;
if (F_Optimization  = False) or (F_FuncArgOpt = False) then goto 1;   {.249}
//    . ,  :
FindFuncArgData(Sa,ND,nt);
if (nt <> 0) and (nt < 5) then
begin
if nt = _FAVB then ND.EI:=2
else
if nt = _AAF then ND.EI:=3
else
if nt = _MAF then ND.EI:=4
else
if nt = _AIFB then ND.EI:=5;


 EOFN:=True;
end
else
begin
 //func(Stack):
1: 
 LV[0].Expression:=Copy(Sa,1,Length(Sa));
 ND.EI:=1;  ND.N:=1;
 EOFN:=False;
end;

ND.Code:=nf;
ND.ExpressionArg:=Arg1;

endp:
end;



procedure TForevalH.FuncFType1(nf: TIntegType; Arg1: String; var LV: PLevel; var ND: TDataNode; var EOFN: Boolean);
label 1,endp;
var
nt,nt1,nt2,nf1,nif: Integer;
S1,S2,Sa: String;
B1: Boolean;
a,b: TFloatType;
ND1,ND2: TDataNode;
begin
if  F_ErrorCode <> 0 then goto endp;
EOFN:=False;    InitNode(ND);
Sa:=Copy(Arg1,1,Length(Arg1));



SetLength(LV,1); LV[0].I:=_NOP; LV[0].ExtArg:=_None;
if (F_Optimization = False) or (F_FuncArgOpt = False) then goto 1;
//    . ,  :
FindFuncArgData(Sa,ND,nt);
if nt = _IAVB then begin ND.EI:=2; EOFN:=True; end
else
if nt = _AAI then begin ND.EI:=3; EOFN:=True; end
else
if (nt = _FAVB) and (ND.V1 = 0) and (Trunc(ND.V2) = ND.V2) then
begin
ND.EI:=2; ND.VI1:=0; ND.VI2:=Trunc(ND.V2); ND.IV1:=1; EOFN:=True;
end
else
//[Stack]
begin
1:
 LV[0].Expression:=Copy(Sa,1,Length(Sa));
 ND.EI:=1;  ND.N:=1;
 EOFN:=False;
end;

ND.Code:=nf;
ND.ExpressionArg:=Arg1;
endp:
end;






procedure TForevalH.FuncFType4(nf: TIntegType; Arg1: String; Arg2: String; var LV: PLevel; var ND: TDataNode; var EOFN: Boolean);
label 1,endp;
var
S1,S2: String;
LVH: PLevel;
nif: Integer;
nt1,nt2: TIntegType;
ND2,ND1: TDataNode;
B: Integer;
begin
if  F_ErrorCode <> 0 then goto endp;

{EI:
1:  S1,S2
2:  FAVB,S2
3:  AAF,S2
4:  MAF,S2
5:  S1,FAVB
6:  FAVB,FAVB
7:  AAF,FAVB
8:  MAF,FAVB
9:  S1,AAF
10:  FAVB,AAF
11: S1,MAF
12: FAVB,MAF
}
nt1:=0; nt2:=0;
S1:=Copy(Arg1,1,Length(Arg1));  S2:=Copy(Arg2,1,Length(Arg2));
SetLength(LV,1); LV[0].I:=_NOP;
InitNode(ND1); InitNode(ND2);
if (F_Optimization = False) or (F_FuncArgOpt = False) then goto 1;
FindFuncArgData(S1,ND1,nt1); FindFuncArgData(S2,ND2,nt2);



//^AF+B


if nt2 = _FAVB then
 begin
  ND1.V3:=ND2.V1; ND1.V4:=ND2.V2; ND1.FV2:=ND2.FV1;
  if nt1 = _FAVB then begin ND1.EI:=6; EOFN:=True;  end
  else
  if nt1 = _AAF then begin ND1.EI:=7; EOFN:=True; end
  else
  if nt1 = _MAF then begin ND1.EI:=8; EOFN:=True; end
  else
  begin
   ND1.EI:=5; EOFN:=False;
   ND1.N:=1;
   LV[0].Expression:=Copy(S1,1,Length(S1));
  end
 end
else

//^ARGF ; AF+B, Stack
if (nt2 = _AAF) or (nt2 = _MAF) then
begin
 ND1.PN:=ND2.PN;  ND1.DI:=ND2.DI;
 if nt1 = _FAVB then
  begin
   ND1.V3:=ND1.V1; ND1.V4:=ND1.V2; ND1.FV2:=ND1.FV1; ND1.V1:=0; ND1.FV1:=0;
   if nt2 = _AAF then begin ND1.V2:= 0;  ND1.EI:=10; end
   else
   if nt2 = _MAF then begin ND1.V2:=ND2.V2;   ND1.EI:=12;  end;
   EOFN:=True;
  end
 else
  begin
   EOFN:=False;
   ND1.N:=1;
   if nt2 = _MAF then begin ND1.V2:=ND2.V2; ND1.EI:=11; end
   else
   if nt2 = _AAF then  ND1.EI:=9;
   LV[0].Expression:=Copy(S1,1,Length(S1));
  end
end
else
//^Stack
 begin
  if nt1 = _FAVB then
  begin
   ND1.EI:=2; EOFN:=False;
   ND1.N:=1;
   LV[0].Expression:=Copy(S2,1,Length(S2));
  end
  else
  if nt1 = _AAF  then
  begin
   ND1.EI:=3; EOFN:=False;
   ND1.N:=1;
   LV[0].Expression:=Copy(S2,1,Length(S2));
  end
  else
  if  nt1 = _MAF then
  begin
   ND1.EI:=4; EOFN:=False;
   ND1.N:=1;
   LV[0].Expression:=Copy(S2,1,Length(S2));
  end
  else
  begin
1:
   ND1.EI:=1; EOFN:=False; ND1.N:=2;
   SetLength(LV,2);
   LV[1].Expression:=Copy(S1,1,Length(S1));
   LV[0].Expression:=Copy(S2,1,Length(S2));
  end
end;

ND:=ND1;
ND.Code:=nf;


if nf = C_POWER then
begin
  //(-1)^FLOAT  {.219}
 if  (nt1 = _FAVB) and (ND1.V1 = 0) and (ND1.V2 = -1) and (nt2 <> _IAVB) and  (nt2 <> _AAI) then
 begin
   EOFN:=False; ND.EI:=0;    ND.N:=1;
   SetLength(LV,1);
   LV[0].Expression:=Copy(S2,1,Length(S2));
   ND.Code:=C_IPWRSGNF; //(-1)^float
 end
 else
 if (nt2 = _FAVB) and (ND2.V1 = 0) and  (ND2.V2 = 2) then
 begin
  ND.Code:=C_SQR;
  ND.EI:=ND.EI-4; // FuncFTYpe2(0,S1,LV,ND,EOFN);
 end
 else
 if (nt2 = _FAVB) and (ND2.V1 = 0) and  (ND2.V2 = -2) then
 begin
  ND.Code:=C_SQRN;
  ND.EI:=ND.EI-4; // FuncFTYpe2(0,S1,LV,ND,EOFN);
 end
 else
 if (nt2 = _FAVB) and (ND2.V1 = 0) and  (ND2.V2 = 0.5) then
 begin
  ND.Code:=C_SQRT;
  ND.EI:=ND.EI-4; // FuncFType2(0,S1,LV,ND,EOFN);
 end
 else
 if (nt2 = _FAVB) and (ND2.V1 = 0) and  (ND2.V2 = -1) then
 begin
  ND.Code:=C_FPWRDVR;
  ND.EI:=ND.EI-4; // FuncFType2(0,S1,LV,ND,EOFN);
 end
 else  //2^Expr       {.243}
 if (nt1 = _FAVB) and (ND1.V1 = 0) and  (ND1.V2 = 2) then
 begin
      //2^Int
     if ((nt2 = _IAVB) or (nt2 = _AAI)) or ((nt2 = _FAVB) and (ND2.V1 = 0) and (Trunc(ND2.V2) = ND2.V2)) then
     begin
       nf:=C_IPWR;
       FuncFType3(nf,S1,S2,LV,ND,EOFN);
       ND.Code:=C_I2PWR;
     end
     else
     begin
       ND.Code:=C_F2PWR;  //2^Float
       EOFN:=False; ND.EI:=1;    ND.N:=1;
       SetLength(LV,1);
       LV[0].Expression:=Copy(S2,1,Length(S2));
     end;
 end
 else
 if ((nt2 = _IAVB) or (nt2 = _AAI)) or ((nt2 = _FAVB) and (ND2.V1 = 0) and (Trunc(ND2.V2) = ND2.V2)) then
 begin
  nf:=C_IPWR;
  FuncFType3(nf,S1,S2,LV,ND,EOFN);
 end
 else
 begin
  ND.Code:=C_FPWR;
 end;

end
else
if nf = C_ROOT then
begin
 if (nt2 = _FAVB) and (ND2.V1 = 0) and  (ND2.V2 = 2) then
 begin
  ND.Code:=C_SQRT;
  ND.EI:=ND.EI-4; // FuncFType2(0,S1,LV,ND,EOFN);
 end
 else
 if (nt2 = _FAVB) and (ND2.V1 = 0) and  (ND2.V2 = 4) then
 begin
  ND.Code:=C_SQRT2;
  ND.EI:=ND.EI-4; // FuncFType2(0,S1,LV,ND,EOFN);
 end
 else
 if ((nt2 = _IAVB) or (nt2 = _AAI)) or ((nt2 = _FAVB) and (ND2.V1 = 0) and (Trunc(ND2.V2) = ND2.V2)) then
 begin
  nf:=C_IROOT;
  FuncFType3(nf,S1,S2,LV,ND,EOFN);
 end
 else
 begin
  ND.Code:=C_FROOT;
 end;
end;




endp:
ND.ExpressionArg:=Arg1+','+Arg2;
end;






procedure TForevalH.FuncFType5(nf: TIntegType; Arg1: String; var LV: PLevel; var ND: TDataNode; var EOFN: Boolean);
label 1,endp;
var
nt,nt1,nt2,nf1,nif,VType: Integer;
S1,S2,Sa: String;
B1: Boolean;
a,b: TFloatType;
ND1,ND2: TDataNode;                            //func(array)
FIN: TFIN;
begin
if F_ErrorCode <> 0 then goto endp;

if  F_ErrorCode <> 0 then goto endp;
EOFN:=False;    InitNode(ND);
Sa:=Copy(Arg1,1,Length(Arg1));



SetLength(LV,0);

FindVarA(Sa,FIN,VType);
 if (VType = _ArrayD) or (VType = _ArrayE) or (VType = _ArrayS) or (VType = _ArrayI)  then
 begin
  ND.IV1:=FIN.I;
  EOFN:=True;
  ND.Code:=nf;
 end
 else
 begin
   F_ErrorCode:=E_INCORRECT_ARGUMENT;
   F_SyntaxErrorString:=Copy(Sa,1,Length(Sa));
  // raise ESyntaxError.Create('');
 end;



endp:
end;





procedure TForevalH.SubstParam(S1: String; var S2: String; var C: TFloatType; var SB: TIntegType);
label endp;
var
N,i: TIntegType;
S1h,S3: String;
E: Exception;
Ct: TFloatType;
begin
if F_ErrorCode <> 0 then goto endp;
C:=0;
SB:=0;

if S1 = '' then
begin
F_ErrorCode:=E_MISSING_EXPRESSION;
//raise ESyntaxError.Create('');
goto endp;
end;

N:=1; S1h:=Copy(S1,1,Length(S1));  SB:=0;

if S1h[1] = '-' then
begin
N:=-1;
Delete(S1h,1,1);
end;


for i:=1 to High(ParamList) do
begin
 S3:=ParamList[i].Name;


 if S1h = S3 then
 begin
   C:=N*ParamList[i].Value;
   //S2:=FloatToStr(N*ParamList[i].Value,G_FMT);
   S2:=FloatToStrF(N*ParamList[i].Value, ffGeneral, 20, 4, G_FMT);
   SB:=1;
   goto endp;
 end;

end;

//_StrToFloatEx(S1h,C,SB); C:=N*C;

SaveSW; {.249} {TryStrToFloat damage SW}
if TryStrToFloat(S1h,Ct,G_FMT) = true then     {.203}
begin
  //C:=N*StrToFloat({PointToDec(S1h)}S1h,G_FMT);
  C:=N*Ct;
  //S2:=FloatToStr(C,G_FMT);
  S2:=FloatToStrF(C, ffGeneral, 20, 4, G_FMT);
  SB:=1;
end
else SB:=0;


S2:=S1;

endp:
end;





procedure TForevalH.SubstParamC(S1: String; var S2: String; var C: TFloatType; var SB: TIntegType);
label endp;
var
N,i: TIntegType;
S1h,S3: String;
BH: Boolean;
E: Exception;
Ct: TFloatType;
begin
C:=0;
SB:=0;
if F_ErrorCode <> 0 then goto endp;

if S1 = '' then
begin
F_ErrorCode:=E_MISSING_EXPRESSION;
//raise ESyntaxError.Create('');
goto endp;
end;

N:=1; S1h:=Copy(S1,1,Length(S1));  SB:=0;

if S1h[1] = '-' then
begin
N:=-1;
Delete(S1h,1,1);
end;




for i:=1 to High(ParamList) do
begin
 S3:=ParamList[i].Name;


 if S1h = S3 then
 begin
 C:=N*ParamList[i].Value;
 //S2:=FloatToStr(N*ParamList[i].Value,G_FMT);
 S2:=FloatToStrF(N*ParamList[i].Value, ffGeneral, 20, 4, G_FMT);
 SB:=1;
 goto endp;
 end;

end;


//_StrToFloatEx(S1h,C,SB); C:=N*C;
SaveSW; {.249} {TryStrToFloat damage SW}
if TryStrToFloat(S1h,Ct,G_FMT) = true then     {.203}
begin
   C:=N*Ct;
   //C:=N*StrToFloat({PointToDec(S1h)}S1h,G_FMT);
   SB:=1;
end
else
SB:=0;



if SB = 0 then
 begin
  CalcConstExpr(S1{S1h},C,BH);
  if BH = True then
  begin
   SB:=1;
   //S2:=FloatToStr(C,G_FMT);
   S2:=FloatToStrF(C, ffGeneral, 20, 4, G_FMT);
   goto endp;
  end
  else SB:=0;
 end;

S2:=S1;

endp:
end;




procedure TForevalH.SetParameter(Number: TIntegType; V: TFloatType);
begin
ParamList[Number].Value:=V;
end;


function TForevalH.GetParameter1(Number: TIntegType): TFloatType;
begin
GetParameter1:=ParamList[Number].Value;
end;


function TForevalH.GetParameter2(S: String): TFloatType;
label endp;
var
i: Integer;
S1: String;
begin

if F_LeadToLowerCase = True then S:=LowerCase(S); {.245}

for i:=1 to High(ParamList) do
begin
 S1:=ParamList[i].Name;

 if S1 = S then
 begin
  GetParameter2:=ParamList[i].Value; goto endp;
 end;
end;

endp:
end;





function TForevalH.ExistParameter(S: String): Boolean;
label endp;
var
i: Integer;
S1: String;
BH: Boolean;
begin

BH:=False;

if F_LeadToLowerCase = True then S:=LowerCase(S); {.245}

for i:=1 to High(ParamList) do
begin
 S1:=ParamList[i].Name;

 if S1 = S then
 begin
  BH:=True; goto endp;
 end;
end;

endp:
ExistParameter:=BH;
end;




procedure TForevalH.RenameParameter(S,SN: String; v: TFloatType);
label endp;
var
i: Integer;
S1: String;
begin

if F_LeadToLowerCase = True then   {.245}
begin
  S:=LowerCase(S);
  SN:=LowerCase(SN);
end;


for i:=1 to High(ParamList) do
begin
 S1:=ParamList[i].Name;

 if S1 = S then
 begin
   ParamList[i].Name:=SN;
   ParamList[i].Value:=V;
   goto endp;
 end;
end;

endp:
end;





procedure TForevalH.SetAdditionalParameter(S: String; V: TFloatType);
label endp;
var
i: Integer;
S1,S2: String;
E: Exception;
begin
if F_LeadToLowerCase = True then S:=LowerCase(S); {.245}
try

 for i:=1 to High(ParamList) do
 begin
  S1:=ParamList[i].Name;
  if S1 = S then
  begin
   ParamList[i].Value:=V; goto endp;
  end;
 end;

 //    :
 SetLength(ParamList,Length(ParamList)+1);
 ParamList[High(ParamList)].Name:=Copy(S,1,Length(S));
 ParamList[High(ParamList)].Value:=V;

endp:
except
 on E: EOutOfMemory     do F_ErrorCode:=E_OutOfMemory;
end;
//if F_ErrorCode <> 0 then EInternalError.Create('');
end;



procedure TForevalH.FuncFType3(nf: TIntegType; Arg1: String; Arg2: String; var LV: PLevel; var ND: TDataNode; var EOFN: Boolean);
label 1,endp;
var
S1,S2: String;
LVH: PLevel;
nif,N: Integer;
nt1,nt2: TIntegType;
ND2,ND1: TDataNode;
B: Integer;
begin
if  F_ErrorCode <> 0 then goto endp;
{EI:
1:  S1,IAVB
2:  FAVB,IAVB
3:  AAF,IAVB
4:  MAF,IAVB
5:  S1,AAI
6:  FAVB,AAI
7: AAF,AAI
8: MAF,AAI
9: S1,[S2]
10: FAVB,[S2]
11: AAF,[S2]
12: MAF,[S2]
}
nt1:=0; nt2:=0;
S1:=Copy(Arg1,1,Length(Arg1));  S2:=Copy(Arg2,1,Length(Arg2));
SetLength(LV,1); LV[0].I:=_NOP;
InitNode(ND1); InitNode(ND2);
if (F_Optimization = False) or (F_FuncArgOpt = False) then goto 1;
FindFuncArgData(S1,ND1,nt1); FindFuncArgData(S2,ND2,nt2);


//^Const
if (nt2 = _FAVB) and (ND2.V2 = Trunc(ND2.V2)) and (ND2.V1 = 0) then
 begin
  ND1.VI1:=0; ND1.VI2:=Trunc(ND2.V2); ND1.IV1:=1;
  if nt1 = _FAVB then begin ND1.EI:=2; EOFN:=True;  end
  else
  if nt1 = _AAF then begin ND1.EI:=3; EOFN:=True; end
  else
  if nt1 = _MAF then begin ND1.EI:=4; EOFN:=True; end
  else
  begin
   ND1.EI:=1; EOFN:=False;
   ND1.N:=1;
   LV[0].Expression:=Copy(S1,1,Length(S1));
  end
 end
else
//^(an+b)
if nt2 = _IAVB then
 begin
  ND1.VI1:=ND2.VI1; ND1.VI2:=ND2.VI2; ND1.IV1:=ND2.IV1;
  if nt1 = _FAVB then begin ND1.EI:=2; EOFN:=True;  end
  else
  if nt1 = _AAF  then begin ND1.EI:=3; EOFN:=True; end
  else
  if nt1 = _MAF  then begin ND1.EI:=4; EOFN:=True; end
  else
  begin
   ND1.EI:=1; EOFN:=False;
   ND1.N:=1;
   LV[0].Expression:=Copy(S1,1,Length(S1));
  end
 end
else
//^ARGI
if nt2 = _AAI then
 begin
  ND1.PN1:=ND2.PN1;  ND1.CI:=ND2.CI;
  if nt1 = _FAVB then begin ND1.EI:=6; EOFN:=True;  end
  else
  if nt1 = _AAF then begin ND1.EI:=7; EOFN:=True; end
  else
  if nt1 = _MAF then begin ND1.EI:=8; EOFN:=True; end
  else
  begin
   ND1.EI:=5; EOFN:=False;
   ND1.N:=1;
   LV[0].Expression:=Copy(S1,1,Length(S1));
  end
 end
else
//^Stack
 begin
  if nt1 = _FAVB then
  begin
   ND1.EI:=10; EOFN:=False;
   ND1.N:=1;
   LV[0].Expression:=Copy(S2,1,Length(S2));
  end
  else
  if nt1 = _AAF then
  begin
   ND1.EI:=11; EOFN:=False;
   ND1.N:=1;
   LV[0].Expression:=Copy(S2,1,Length(S2));
  end
  else
  if nt1 = _MAF then
  begin
   ND1.EI:=12; EOFN:=False;
   ND1.N:=1;
   LV[0].Expression:=Copy(S2,1,Length(S2));
  end
  else
  begin
1:  
   ND1.EI:=9; EOFN:=False; ND1.N:=2;
   SetLength(LV,2);
   LV[0].Expression:=Copy(S1,1,Length(S1));
   LV[1].Expression:=Copy(S2,1,Length(S2));
  end
end;

ND:=ND1;
ND.Code:=nf;






if nf = C_IPWR then
begin
 //IPWR3-IPWR16; IPWR3N-IPWR16N   {ND.EI = 1,2,3,4}
 if (nt2 = _FAVB) and  (ND2.V1 = 0) and   (ND2.V2 = Trunc(ND2.V2)) and
    (abs(ND2.V2) >= 3) and (abs(ND2.V2) <= 16) then
 begin
  //EI - 
  N:=abs(Trunc(ND2.V2))-3;
  if ND2.V2 > 0 then ND.Code:=C_IPWR3+N else ND.Code:=C_IPWR3N+N;
 end
 else
 //(-1)^IAVB,AAI
 if ((ND.EI = 2)  or (ND.EI = 6)) and  (ND.V1 = 0) and (ND.V2 = -1) then
 begin
  if ND.EI = 6 then ND.EI:=3;
  ND.Code:=C_IPWRSGN;
  //ND.COP:='IPWRSGN';
 end
 else
 //2^IAVB,AAI
 if ((ND.EI = 2)  or (ND.EI = 6)) and  (ND.V1 = 0) and (ND.V2 = 2)  then
 begin
  if ND.EI = 6 then ND.EI:=3;
  ND.Code:=C_I2PWR;
  //ND.COP:='I2PWR';
 end;
end;

ND.ExpressionArg:=Arg1+','+Arg2;

endp:
end;





procedure TForevalH.LDAAnalizator(LV: PLevel; ND: TDataNode; var LV1: PLevel; var ND1: TDataNode);
var
ni,VT,nf: Integer;
begin
 LV1:=LV;
 ND1:=ND;

 FindVarB(LV[0].Expression,ni,VT);
 if ni <> -1 then
 begin
   ND1.FV1:=ni;
   ND1.Adr:=VarList[ni].Addr;
   ND1.N:=0;
   ND1.EI:=1;  //lda(@var)
 end
 else
 begin
   FindFuncName(LV[0].Expression,nf);
   if nf <> -1 then
   begin
     ND1.Adr:=Cardinal(FuncList[nf].Addr);
     ND1.N:=0;
     ND1.EI:=2;  //lda(@var)
   end
   else
   begin
      F_ErrorCode:=E_INCORRECT_ARGUMENT;
      F_SyntaxErrorString:=Copy(LV[0].Expression,1,Length(LV[0].Expression));
   end;


 end;
 //LV1:=nil;

 //ND1.COP:=_FUNC;
 ND1.code:=C_LDA;
end;







procedure TForevalH.GOTOAnalizator(LV: PLevel; ND: TDataNode; var LV1: PLevel; var ND1: TDataNode);
var
ni,VT,nf,L: Integer;
begin
 LV1:=LV;
 ND1:=ND;
 L:=0;
 F_GotoPresent:=True;
 {
 try
   L:=StrToInt(LV[0].Expression);
   ND1.N:=0;
   ND1.EI:=8;
   ND1.CI:=L;
 except
   F_ErrorCode:=E_INCORRECT_ARGUMENT;
   F_SyntaxErrorString:=Copy(LV[0].Expression,1,Length(LV[0].Expression));
 end;
 }
 {.203}
 if TryStrToInt(LV[0].Expression,L) = true then
 begin
   //L:=StrToInt(LV[0].Expression);
   ND1.N:=0;
   ND1.EI:=8;
   ND1.CI:=L;
 end
 else
 begin
   F_ErrorCode:=E_INCORRECT_ARGUMENT;
   F_SyntaxErrorString:=Copy(LV[0].Expression,1,Length(LV[0].Expression));
 end;


 if L < 0 then
 begin
   F_ErrorCode:=E_INCORRECT_ARGUMENT;
   F_SyntaxErrorString:=Copy(LV[0].Expression,1,Length(LV[0].Expression));
 end;
 ND1.code:=C_JMP;
end;






procedure TForevalH.SAVEAnalizator(LV: PLevel; ND: TDataNode; var LV1: PLevel; var ND1: TDataNode);
label endp;
var
ni,VT,nf,nm,L,nt: Integer;
A,B: TFloatType;
PN: TMass2;
begin
 //LV1:=LV;
 ND1:=ND;

 L:=Length(LV);

if L <> 3 then
begin
  F_ErrorCode:=E_INCOINCIDENCE_NUMBER_ARGUMENTS;
   F_SyntaxErrorString:=F_CurrentString;
  goto endp;
end;

 FindVarB(LV[0].Expression,nm,VT);

 if (VT  <> _ArrayS) and (VT  <> _ArrayE) and (VT  <> _ArrayD) and (VT  <> _ArrayI)  then
 begin
   F_ErrorCode:=E_INCORRECT_ARGUMENT;
   F_SyntaxErrorString:=F_CurrentString;
   goto endp;
 end;



 FindArgType(LV[1].Expression,nt,A,B,nf,ni,PN);

 //const
 if (nt = _FAVB) and (A = 0)  then
 begin
   if Trunc(B) = B then
   begin
     ND1.EI:=1;
     ND1.VI2:=Trunc(B);
   end
   else
   begin
     F_ErrorCode:=E_INCORRECT_ARGUMENT;
     F_SyntaxErrorString:=F_CurrentString;
     goto endp;
   end
 end
 else
 if (nt = _IAVB)  then                                //EI:=3; (a*i+b, i,a,b - integer) ND.VI1:=Trunc(A); ND.VI2:=Trunc(B); ND.IV1:=ni;
   begin                                              //EI:=2; (i - integ. var) ND.IV1:=ni;
    WriteArgData(nt,A,B,ni,nf,PN,ND1);
    if (A = 1) and (B = 0) then  ND1.EI:=2 else ND1.EI:=3;
   end
 else
 if nt = _AAI then
 begin
    WriteArgData(nt,A,B,ni,nf,PN,ND1);                    //EI:=4; ND.PN1
    //ND.Code:=C_LDSV;
    ND1.EI:=4;
 end
 else
 begin
    ND1.EI:=0;
 end;

 ND1.N:=1;

 if ND1.EI = 0 then ND1.N:=2;

 if ND1.N = 1 then
 begin
   SetLength(LV1,1);
   LV1[0].Expression:=Copy(LV[2].Expression,1,Length(LV[2].Expression))
 end
 else
 begin
   SetLength(LV1,2);
   LV1[0].Expression:=Copy(LV[2].Expression,1,Length(LV[2].Expression));
   LV1[1].Expression:=Copy(LV[1].Expression,1,Length(LV[1].Expression))
 end;


  ND1.IV2:=nm;
  ND1.Code:=C_SAVEV;

 endp:
end;








procedure TForevalH.SetLenAnalizator(LV: PLevel; ND: TDataNode; var LV1: PLevel; var ND1: TDataNode);
label endp;
var
ni,VT,nf,nm,L,nt: Integer;
A,B: TFloatType;
PN: TMass2;
adrV: Cardinal;
begin
 //LV1:=LV;
 ND1:=ND;

 L:=Length(LV);

if L <> 2 then
begin
  F_ErrorCode:=E_INCOINCIDENCE_NUMBER_ARGUMENTS;
   F_SyntaxErrorString:=F_CurrentString;
  goto endp;
end;

 FindVarB(LV[0].Expression,nm,VT);

 if (VT  <> _ArrayS) and (VT  <> _ArrayE) and (VT  <> _ArrayD) and (VT  <> _ArrayI)  then
 begin
   F_ErrorCode:=E_INCORRECT_ARGUMENT;
   F_SyntaxErrorString:=F_CurrentString;
   goto endp;
 end;



 adrV:=VarList[nm].Addr;



 SetLength(LV1,3);

 LV1[0].Expression:=IntToStr(adrV);
 LV1[1].Expression:=IntToStr(VT);
 LV1[2].Expression:=Copy(LV[1].Expression,1,Length(LV[1].Expression));


  ND1.N:=3;
  ND1.Code:=C_SETLEN;

 endp:
end;







procedure TForevalH.IDAMAnalizator(LV: PLevel; ND: TDataNode; var LV1: PLevel; var ND1: TDataNode);
label endp;
var
FIN: TFIN;
VType,p,p1: integer;
SV: String;
begin
//  inc(Varint), dec(Varint), add(Varint,int), mul(Varint,int),

ND1:=ND;
SetLength(LV1,0);


FindVarA(LV[0].Expression,FIN,VType);
if VType = _Integer then
    begin
      ND1.IV1:=FIN.I;
      goto endp;
    end
else
begin
  F_ErrorCode:=E_INCORRECT_ARGUMENT;
  F_SyntaxErrorString:=F_CurrentString;
end;


endp:
end;




procedure TForevalH.FunctionalAnalizator(nf: TIntegType; A: TFloatType; B: TFloatType; Arg1: String; Arg2: String; var ND: TDataNode; var LV: PLevel; var EOFN: Boolean);
label 1,2,3,endp;
var
ND1: TDataNode;
LV1: PLevel;
EOFN1,BH: Boolean;
begin
if F_ErrorCode <> 0 then goto endp;

TryFPUMask{(@CWMEM1)}; {.249}

EOFN:=False; InitNode(ND);

if nf = C_NOP then EOFN:=True;


case    FuncList[nf].FType of
1:      FuncFType1(nf,Arg1,LV,ND,EOFN);
2:      FuncFType2(nf,Arg1,LV,ND,EOFN);
3:      FuncFType3(nf,Arg1,Arg2,LV,ND,EOFN);
4:      FuncFType4(nf,Arg1,Arg2,LV,ND,EOFN);
-17:    FuncFType17M(nf,LV,ND,EOFN);
else
// :
if FuncList[nf].FType < 0 then
begin
 ExtFunc(nf,ND,LV,ND,EOFN);
end;
end;



if  (A <> 1) or (B <> 0) then
 begin
  ND.F1:=A;
  ND.F2:=B;
  ND.AI:=1;
 end
else
begin
 ND.F1:=1;
 ND.F2:=0;
 ND.AI:=0;
end;


//ND.ExpressionArg:=Arg1+','+Arg2;
endp:
TryCatchFPUException{(@CWMEM1)};  {.249}
end;







procedure TForevalH.AddOptimizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
label endp;
var
LH,LH1: PLevel;
h,SB,ni,i,nf,vf,st,cf:TIntegType;
z,CA,A,cx,js,C1,nv:TFloatType;
S2: String;
CH: TMass2;
CV: TMass2;
FIN: TFin;
begin
//ADD = AS(Si) + ARGF(ADD)   ;AS-add/sub


if F_ErrorCode <> 0 then goto endp;
SetLength(LV1,0);
st:=0;  //  
cf:=0;  //  .
vf:=0;  // 
nv:=0;  // 
h:=0;   //help var
//    AMVAB: cx*nf+CA
cx:=0;
nf:=0;


SetLength(CV.FM,Length(VarList)); SetLength(CH.FM,Length(VarList));

for i:=0 to High(VarList) do
begin
CH.FM[i]:=0;
CV.FM[i]:=0;
end;

InitNode(ND1);
CA:=0;


// :
for i:=0 to High(LV) do
begin
 FindAV(LV[i].Expression,ND1,A,FIN,ni);

 //var
 if ni = 1  then
 begin
  if LV[i].I = _SUB then A:=-A;
  CV.FM[FIN.F]:=CV.FM[FIN.F]+A;
  CH.FM[FIN.F]:=1;
  vf:=1;
 end
 else
 //const
 if ni = 20 then
 begin
  if LV[i].I = _SUB then CA:=CA-A else CA:=CA+A;
  nf:=1;
 end
 else
 //Stack
 begin
   if h = 0 then SetLength(LV1,1) else SetLength(LV1,Length(LV1)+1);
   LV1[High(LV1)].Expression:=Copy(LV[i].Expression,1,Length(LV[i].Expression));
   LV1[High(LV1)].I:=LV[i].I;
   h:=1; inc(st);
 end;
end;



//:
if vf <> 0 then
for i:=0 to High(VarList) do
begin
nv:=nv+CH.FM[i];
//   AMVAB:
if CH.FM[i] = 1 then begin nf:=i; cx:=CV.FM[i]; end;
end;


if (st = 0) and (vf = 0)  then
begin
 ND1.V2:=CA;
 ND1.Code:=C_LDSC;
end
else
begin
 if (st = 0) and (nv >= 1) then
 begin
   if nv = 1 then
   begin
     if (CA = 0) and (cx = 1) then
     begin
       ND1.Code:=C_LDSF;
       ND1.FV1:=nf;
     end
     else
     begin
       ND1.Code:=C_FAVB;
       ND1.FV1:=nf;
       ND1.V1:=cx;
       ND1.V2:=CA;
     end;
   end
   else //nv > 1 : _AAF       {.243}
   begin
     ND1.Code:=C_AAF;
     ND1.DI:=_AAF;
     ND1.PN:=CV;
     ND1.PN.FC:=CA;
   end;

 end
 else
 if (st <> 0) then
 begin

   ND1.Code:=C_ADD;
   if nv <= 1 then
   begin
     ND1.F2:=CA;
     ND1.F1:=cx;
     ND1.FV1:=nf;
   end
   else
   begin
     ND1.DI:=_AAF;
     ND1.PN:=CV;
     ND1.PN.FC:=CA;
   end

 end
end;


if st = 0 then EOFN:=True else EOFN:=False;


endp:
end;


procedure TForevalH.FindVar(S1: String; ND: TDataNode; var ni: TIntegType; var FIN:TFin; var {Neg: Boolean} Neg: Integer);
label endp;
var
i: TIntegType;
S2,S3: String;                                //ni = 1 - fl. .
begin                                        //ni = -1 - int. .
if F_ErrorCode <> 0 then goto endp;  //ni = 0 - .  
                                             //FIN.F -  fl. .
S2:=Copy(S1,1,length(S1));                 //FIN.I -  int. .
Neg:=0;
ni:=0; FIN.F:=0; FIN.I:=0;

if S2[1] = '-' then
begin
 Neg:=1;
 Delete(S2,1,1);
end;



for i:=0 to High(VarList) do
begin
  S3:=VarList[i].Name;

 if S2 = S3 then
  begin

   if VarList[i].VType = _Integer then
   begin
    ni:=-1;
    FIN.I:=i;
    F_VarPresent:=True;
    VarList[i].IsUsed:=True; {.225}
   end
   else
   if (VarList[i].VType = _Single) or (VarList[i].VType = _Double) or (VarList[i].VType = _Extended)  then
   begin
    ni:=1;
    FIN.F:=i;
    F_VarPresent:=True;
    VarList[i].IsUsed:=True; {.225}
   end;

   if (Neg = 1) and  (ND.Neg = 1) then Neg:= 0
   else
   if (Neg = 1) and  (ND.Neg = 0) then Neg:= 1
   else
   if (Neg = 0) and  (ND.Neg = 1) then Neg:= 1
   else
   if (Neg = 0) and  (ND.Neg = 0) then Neg:= 0;
   goto endp;
  end;
end;

//  -:
if S2 = '@@func' then
  begin
   ni:=1;
   FIN.F:=0;
   if (Neg = 1) and  (ND.Neg = 1) then Neg:= 0
   else
   if (Neg = 1) and  (ND.Neg = 0) then Neg:= 1
   else
   if (Neg = 0) and  (ND.Neg = 1) then Neg:= 1
   else
   if (Neg = 0) and  (ND.Neg = 0) then Neg:= 0;
   ni:=1;
   goto endp;
  end;

endp:
end;







procedure TForevalH.MulOptimizator(LV:PLevel; ND: TDataNode;  C: TFloatType; Neg: Integer; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
label 2,3,4,endp,endp1;
var
PN,PN1: TMass2;
AFB: TDAmvab;
df,ds,ms,mf,mm,dd,h,daf,sz,sms,sds: Integer;
CM,V1,V2,V3,V4,A,B: TFloatType;
nf1,nf2,i,nt,nf,ni,di: Integer;
SD: String;
nds,nx,nxb: Integer;
LV2: PLevel;
begin

//MUL = F1*M(Ai*Xi+Bi)*MD(Si)/ARGF+F2; M - ; D - ;

if F_ErrorCode <> 0 then goto endp1;
SetLength(LV1,0);
ds:=0;  //   
df:=0;  //   FAVB
ms:=0;  //   
dd:=0;  // 
mm:=0;  // 
mf:=0;  //   (AMVAB)
daf:=0; // ARGF  
sz:=0;  //  
sds:=0; //          {.217}
sms:=0; //        {.217}
di:=0;  //_AAF,_MAF
CM:=1;  //const 
V1:=0; V2:=0; nf2:=0;//(V1*nf1+V2) - AMVAB(df)
h:=0; nx:=0; nxb:=0;  //help var


SetLength(PN.FM,Length(VarList)); // 
for i:=0 to High(PN.FM) do
begin
 PN.FM[i]:=0;
end;
PN.FC:=1;


ND.Neg:=0;    {'-'    .}
InitNode(ND1);

if Neg = 1 then CM:=-1;


//(x*2)*y
//(x*2)*5

// :
for i:=0 to High(LV) do
begin
 (*
 if F_MulOptLight = False then
    FindArgType(LV[i].Expression,nt,A,B,nf,ni,PN1{?})
 else
    FindMulArg(LV[i].Expression,nt,A,B,nf,ni,PN1{?});

 *)

 FindArgType(LV[i].Expression,nt,A,B,nf,ni,PN1{?});
 //FindMulArg(LV[i].Expression,nt,A,B,nf,ni,PN1{?});

 TryFPUMask{(@CWMEM2)}; {.249}

 //const
 if (nt = 1) and  (A = 0) then
 begin
  //TryFPUMask;
  if LV[i].I = _DIV then CM:=CM/B else CM:=CM*B;         {DIV}
  //TryCatchFPUException;
 end
 else
 //AMVAB (mf)
 //if (nt = 1) and {(B = 0) and} ((LV[i].I = _MUL) or (LV[i].I = _NOP)) {.201} and  ((F_Replace_ARGF = False) or (B = 0)) then
 if (nt = 1) and (B = 0) and ((LV[i].I = _MUL) or (LV[i].I = _NOP))   then    {.243}
 begin
  SetLength(AFB,Length(AFB)+1);
  AFB[High(AFB)].nf:=nf;
  AFB[High(AFB)].A:=A;
  AFB[High(AFB)].B:=B;

  if (B = 0) and (A = -1) then
  begin
   CM:=-CM;
   AFB[High(AFB)].A:=-AFB[High(AFB)].A;  //    CM
  end;

  inc(mf);
  mm:=1;
  if (nx = 0) and (B = 0) then nx:=mf;
  if (nxb = 0) and (B <> 0) then nxb:=mf;
 end
 else
 {}
 //FAVB (df)
 //if (nt = 1) and  (daf = 0) and (df = 0) and (LV[i].I = _DIV) {.201} and  ((F_Replace_ARGF = False) or (B = 0)) then
 if (nt = 1) and  (daf = 0) and (df = 0) and (LV[i].I = _DIV)  then      {.243}
 begin
  nf1:=nf; V1:=A; V2:=B;
  df:=1;
  dd:=1;
  SD:=LV[i].Expression+'*';
 end
 else
 //ARGF(+) (daf)
 //if (nt = 3) and (daf = 0) and  (df = 0) and (LV[i].I = _DIV) {.201} and (F_Replace_ARGF = False) then
 if (nt = 3) and (daf = 0) and  (df = 0) and (LV[i].I = _DIV)  then   {.243}
 begin
  PN:=PN1;
  daf:=1;
  dd:=1;
  di:=_AAF;
  SD:=LV[i].Expression+'*';
 end
 else
 //ARGF(*) (daf)
 //if (nt = 4) and (daf = 0) and  (df = 0) and (LV[i].I = _DIV)  {.201} and (F_Replace_ARGF = False) then
 if (nt = 4) and (daf = 0) and  (df = 0) and (LV[i].I = _DIV)   then   {.243}
 begin
  PN:=PN1;
  daf:=1;
  df:=1;
  dd:=1;
  di:=_MAF;
  V3:=A; V4:=B;
  SD:=LV[i].Expression+'*';
 end
 else
 {}
 //Stack
 begin
  if h = 0 then SetLength(LV1,1) else SetLength(LV1,Length(LV1)+1);
  h:=1;
  if LV[i].I = _DIV then inc(ds) else inc(ms);
  LV1[High(LV1)].Expression:=Copy(LV[i].Expression,1,Length(LV[i].Expression));
  LV1[High(LV1)].I:=LV[i].I;
  if CheckToZero(LV[i].Expression) = True then       {.217}
  begin
    inc(sz);
    if LV[i].I = _DIV then inc(sds) else inc(sms);
  end;

 end;

 TryCatchFPUException{(@CWMEM2)}; {.249}
end;


//  AFB: (: x*(x+1)->(x+1)*x)
if Length(AFB) <> 0 then
begin
 if (nx = 1) and (nxb <> 0) then
 begin
  nf:=AFB[nx-1].nf;
  A:=AFB[nx-1].A;
  B:=AFB[nx-1].B;
  AFB[nx-1].nf:=AFB[nxb-1].nf;
  AFB[nx-1].A:=AFB[nxb-1].A;
  AFB[nx-1].B:=AFB[nxb-1].B;
  AFB[nxb-1].nf:=nf;
  AFB[nxb-1].A:=A;
  AFB[nxb-1].B:=B;
 end;
end;


//:
if (ds = 0) and (ms = 0) and (daf = 0) and (df = 0) and (mf = 0) then
begin
 ND1.V2:=CM+C;
 ND1.Code:=C_LDSC;
end
else
begin
 if (daf = 0) and (df = 1) then
 begin
  SetLength(PN.FM,Length(VarList));
  for i:=0 to High(PN.FM) do
  begin
   PN.FM[i]:=0;
  end;
  PN.FM[nf1]:=V1;
  PN.FC:=V2;
  di:=_AAF;
 end;
 if (daf = 1) or (df = 1) then
 begin
  ND1.PN:=PN;
  ND1.V1:=V3;
  ND1.V2:=V4;
 end;

 ND1.DI:=di;
 ND1.AFB:=AFB;
 ND1.F2:=C;
 ND1.F1:=CM;
 ND1.Code:=C_MUL;
end;

if (ds+ms) = 0 then EOFN:=True else EOFN:=False;



//  MUL (  AddEndCommand -> FLD1; FDIVRP):
//   (        
//  ):
//MUL/S1*S2/S3*S4... -> MUL*S1*S2/(S1*S3)
//MUL/S1/S2/S3... -> MUL/(S1*S2*S3)  ..


if (ds >= 2) or ((ds+ms >= 2) and (LV1[0].I = _DIV)) or ((ds >= 1) and ((daf =1) or (df = 1))) then
begin
 if (daf = 0) and (df = 0) then SD:='';
 for i:=0 to High(LV1) do
 begin
  if LV1[i].I = _DIV then SD:=SD+LV1[i].Expression+'*'
  else
  begin
   SetLength(LV2,Length(LV2)+1);
   LV2[High(LV2)].Expression:=Copy(LV1[i].Expression,1,Length(LV1[i].Expression));
   LV2[High(LV2)].I:=LV1[i].I;
  end;
 end;

 SetLength(SD,Length(SD)-1);
 SetLength(LV1,Length(LV2)+1);
 for i:=0 to High(LV1)-1 do
 begin
  LV1[i].I:=LV2[i].I;
  LV1[i].Expression:=Copy(LV2[i].Expression,1,Length(LV2[i].Expression));
 end;

 LV1[High(LV1)].I:=_DIV;
 LV1[High(LV1)].Expression:=Copy(SD,1,Length(SD));

 if (df = 1) or (daf = 1) then  ND1.DI:=0;
end;

{.217}
//   : Si='0'        1-(-7-sin(x)*(-(-(0)))*cos(x))
if (sz <> 0) or (CM = 0) then
begin
  SetLength(LV1,0);
  ND1.V2:=0;
  ND1.V1:=0;
  ND1.DI:=0;
  SetLength(ND1.PN.FM,0);
  SetLength(ND1.PN.IM,0);
  //ND1.F2:=C;
  ND1.Code:=C_LDSC;
  EOFN:=True;
end;

endp1:
end;




procedure TForevalH.LeadToDenominator(LV:PLevel;  var LV1:PLevel);
var
i,dv: Integer;
SD: String;
LV2: PLevel;
begin

SD:='';
dv:=0;
for i:=0 to High(LV) do
 begin
  if LV[i].I = _DIV then begin SD:=SD+LV[i].Expression+'*'; inc(dv); end
  else
  begin
   SetLength(LV2,Length(LV2)+1);
   LV2[High(LV2)].Expression:=Copy(LV[i].Expression,1,Length(LV[i].Expression));
   LV2[High(LV2)].I:=LV[i].I;
  end;
 end;

 SetLength(SD,Length(SD)-1);
 SetLength(LV1,Length(LV2)+1);
 for i:=0 to High(LV1)-1 do
 begin
  LV1[i].I:=LV2[i].I;
  LV1[i].Expression:=Copy(LV2[i].Expression,1,Length(LV2[i].Expression));
 end;

 LV1[High(LV1)].I:=_DIV;
 LV1[High(LV1)].Expression:=Copy(SD,1,Length(SD));

 if dv = 0 then  LV1:=LV;  // 

end;





procedure TForevalH.OperationalAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
var
C: TFloatType;
BH{,Neg,Neg1}: Boolean;
Neg,Neg1: Integer;
LH,LH1: PLevel;
i: Integer;
SA: String;
begin
LV1:=LV;
ND1:=ND; Neg1:=ND.Neg;  BH:=False;

TryFPUMask{(@CWMEM3)}; {.249}

if F_Optimization = True then
begin
// :
 if ND.Code = _ADD then
 begin
    if  F_AddSubOptimization = True then    {.243}
    begin
      AddOptimizator(LV, ND, LV1, ND1, EOFN);
      ND1.Neg:=Neg1;
    end
    else
    ND1.Code:=C_ADD
 end
 else
 if ND.Code = _MUL then
 begin
   if  F_MulDivOptimization = True then    {.243}
   begin
     MulOptimizator(LV, ND, 0, Neg1, LV1, ND1, EOFN);
     if Neg1 = 1 then ND1.F2:=-ND1.F2;
     ND1.Neg:=0;        //       
   end
   else
   if  F_TreeOptimization = _Enable    then    // {.249}
   begin                                       //        S1/S2*S3/S4/S5... ->S1*S3/(S2*S4*S5)
    LeadToDenominator(LV,LV1);                 //  ,   F_MulDivOptimization    F_TreeOptimization
    ND1.Code:=C_MUL; ND1.F1:=1; ND1.F2:=0;     // TreeOptimization          
   end
   else
   begin ND1.Code:=C_MUL; ND1.F1:=1; ND1.F2:=0; end;
 end;
end
else
// :
begin
 if  ND.Code = _ADD  then ND1.Code:=C_ADD
 else
 if  ND.Code = _MUL  then begin ND1.Code:=C_MUL; ND1.F1:=1; ND1.F2:=0; end;
end;


//  :
SetLength(ND1.SGN,Length(LV1));
for i:=0 to High(LV1) do
begin
 ND1.SGN[i]:=LV1[i].I;
 //SGN   .I  [0]:
 if (i = 0) and (LV1[i].I = _NOP) then
 begin
  if ND1.Code  = C_MUL then ND1.SGN[0]:=_MUL
  else
  if ND1.Code = C_ADD then ND1.SGN[0]:=_ADD;
 end;
end;
ND1.N:=Length(LV1);

TryCatchFPUException{(@CWMEM3)}; {.249}

end;


(*
procedure TForevalH.OperationalAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
var
C: TFloatType;
BH{,Neg,Neg1}: Boolean;
Neg,Neg1: Integer;
LH,LH1: PLevel;
i: Integer;
SA: String;
begin
LV1:=LV;
ND1:=ND; Neg1:=ND.Neg;  BH:=False;

{.199}
{SA:='';
for i := 0 to Length(LV) - 1 do
  begin
    SA:=SA+LV[i].Expression+','
  end;
ND.ExpressionArg:=SA;
}

if F_Optimization = True then
begin
// :
 if ND.Code = _ADD then
 begin
  //MulOptH(LV,LV1,C,Neg,BH);          (ver. 8.4.15.113)  - : 1+(-(x*y))+5
  if BH = True then
  begin
   if  Neg1 = 1 then C:=-C;

   if (Neg1 = 1) and (Neg = 1) then Neg:=0
   else
   if (Neg1 = 1) and (Neg = 0) then Neg:=1
   else
   if (Neg1 = 0) and (Neg = 1) then Neg:=1
   else
   if (Neg1 = 0) and (Neg = 0) then Neg:=0;

   MulOptimizator(LV1, ND, C, Neg, LV1, ND1, EOFN);


   ND1.Neg:=0;  //       


  end
  else
  begin
   if BH = False then
   begin
    AddOptimizator(LV, ND, LV1, ND1, EOFN);
    ND1.Neg:=Neg1;
   end
  end
 end
 else
 begin
 //'*'
 MulOptimizator(LV, ND, 0, Neg1, LV1, ND1, EOFN);
 if Neg1 = 1 then ND1.F2:=-ND1.F2;

 ND1.Neg:=0;        //       

 end;
end
else
// :
begin
 if  ND.Code = _ADD  then ND1.Code:=C_ADD
 else
 if  ND.Code = _MUL  then begin ND1.Code:=C_MUL; ND1.F1:=1; ND1.F2:=0; end;
end;


//  :
SetLength(ND1.SGN,Length(LV1));
for i:=0 to High(LV1) do
begin
 ND1.SGN[i]:=LV1[i].I;
 //SGN   .I  [0]:
 if (i = 0) and (LV1[i].I = _NOP) then
 begin
  if ND1.Code  = C_MUL then ND1.SGN[0]:=_MUL
  else
  if ND1.Code = C_ADD then ND1.SGN[0]:=_ADD;
 end;
end;
ND1.N:=Length(LV1);


end;
*)


procedure TForevalH.FindSA(S: String; var LV: PLevel; var A: TFloatType; var N: TIntegType; var BH: Boolean);
label 1;
var
LH,LV1,BL,BL1: PLevel;
CN1,CN2,h,SB,ni,i,ds,COP: Integer;
Neg1,Neg2,Neg: Integer;
C1: TFloatType;
ND: TDataNode;
FIN: TFin;
PN: TMass2;
begin
A:=1;  SetLength(LV,1); LV[0].I:=_NOP;
h:=0;    CN1:=1; CN2:=1;  BH:=False;  BL:=LV; ds:=0;
Neg2:=0;
StringAnalizator(S,N{?},COP,LV1,Neg1);
if COP = _ADD then begin BH:=False; goto 1; end;


if  Neg1 = 1 then CN1:=-1;



 for i:=0 to High(LV1) do
 begin

 SubstParam(LV1[i].Expression,LV1[i].Expression,C1{?},SB);
 if SB = 1 then
  begin
   if  LV1[i].I = _DIV then C1:=1/C1;
   A:=A*C1;
  end
  else
  begin
   FindAMVAB(LV1[i].Expression,ni,FIN{?},PN{?});
   if ni = 1 then begin BH:=False; goto 1; end;
   if h = 0 then
    begin
     if LV1[i].Expression[1] = '-' then
     begin
     CN2:=-1; Delete(LV1[i].Expression,1,1);
     end;
     LV[0].Expression:=Copy(LV1[i].Expression,1,Length(LV1[i].Expression));
     LV[0].I:=LV1[i].I;
     if LV[0].I = _DIV then inc(ds);
    end
    else
    begin
    SetLength(LV,Length(LV)+1);
     LV[High(LV)].Expression:=Copy(LV1[i].Expression,1,Length(LV1[i].Expression));
     LV[High(LV)].I:=LV1[i].I;
     if  LV[High(LV)].I = _DIV then inc(ds);
    end;
   h:=h+1;                                  //2*sin(x)*cos(x)*tan(x)
  end;
 end;


 begin
  LV:=BL;
  N:=h;
  A:=CN1*CN2*A;
 end;



BH:=True;

1:
end;






procedure TForevalH.FindAV(S: String; ND :TDataNode; var A: TFloatType; var FIN: TFin; var ni: TIntegType);
label endp;
var
LV: PLevel;
FIN1:TFIN;
//LVA: PLevel;
{Neg,Neg1,Neg2,}BH: Boolean;
Neg,Neg1,Neg2,COP: Integer;
S1,S2: String;                                       //ni = 0 - 
N,SB,nv,ni1,NZ: TIntegType;                          //ni = -1 - int. FIN.I
ND1: TDataNode;                                      //ni = 1 - fl.   FIN.F
C1,C,M: TFloatType;                                  //ni = 20 - const;
i: Integer;
begin
ni:=0; nv:=0;  NZ:=1;
StringAnalizator(S,N,COP,LV,Neg);

if F_ErrorCode = E_MISSING_EXPRESSION then     //sin(x+())
begin
 F_SyntaxErrorString:=S;
 goto endp;
end;

if  Neg = 1 then NZ:=-1;
ND1.Neg:=0;


if COP = _MUL then
begin

 M:=1;  C:=0; A:=0;

 for i:=0 to High(LV) do
 begin
  SubstParam(LV[i].Expression,S1{?},C,SB);
  if SB = 1 then
  begin
   if  LV[i].I = _DIV then M:=M/C else M:=M*C;    {DIV}
  end
  else
  begin
   FindVar(LV[i].Expression,ND1,ni1,FIN1,Neg2);
   if (ni1 <> 0) and (nv = 0) and ((LV[i].I = _MUL) or (LV[i].I = _NOP)) then
   begin
    inc(nv);
    Neg1:=Neg2; FIN:=FIN1;  ni:=ni1;
    if Neg2 = 1 then NZ:=-NZ;
   end
   else
   begin
    ni:=0;
    goto endp;
   end;
  end;
 end;

end
else
if COP = _NOP then      //const,var
begin
 CalcConstExpr(LV[0].Expression,M,BH);
 if BH = True then  ni:=20
 else
 begin

  FindVar(LV[0].Expression,ND1,ni,FIN,Neg2);
  if ni <> 0 then
  begin
   if Neg2 = 1 then NZ:=-NZ; nv:=1; M:=1;
  end
  else

  begin
   {CalcConstExpr(LV[0].Expression,M,BH);
   if BH = True then  ni:=20
   else}
   begin
     ni:=0;
     goto endp;
   end;
  end;

 end;

end
else
begin
 ni:=0;
 goto endp;
end;

if nv = 0 then ni:=20;
A:=NZ*M;


if ND.Neg = 1 then A:=-A;

endp:
end;



procedure TForevalH.FindMV(S: String; var PN: TMass2; var ni: TIntegType);
label 1,endp;
var
S2: String;
N,i,SB,r,SF,SI: TIntegType;
Neg,Neg1,Neg3,COP: Integer;        //ni:
BH: Boolean;                       //A*x*y*...*w*n*k*...j     23
LV: PLevel;                        //A*n*k*...*j              22
ND: TDataNode;                     //A*x*y*...*w              21
A,A1,C1: TFloatType;               //A - PN[Last]
FIN: TFin;
begin

ND.Neg:=0;
BH:=True; SF:=0; SI:=0;  A:=1;
Neg1:=0;  Neg3:=0; Neg:=0;
r:=0;

for i:=0 to High(VarList) do
begin
 PN.FM[i]:=0;
end;


for i:=0 to High(VarList) do
begin
 PN.IM[i]:=0;
end;

StringAnalizator(S,N,COP,LV,Neg);

if COP = _MUL then
begin

 for i:=0 to High(LV) do
 begin
  if LV[i].I = _DIV then goto 1;
  FindVar(LV[i].Expression,ND{?},ni,FIN,Neg1);
  if ni = 0 then
  begin
1:
    (*
   try
    SubstParam(LV[i].Expression,S2,C1{?},SB);
    A1:=StrToFloat({PointToDec(S2)}S2,G_FMT);
    if LV[i].I = _DIV  then A1:=1/A1;
    A:=A*A1;
   except
    BH:=False;
   end;
     *)
    {.203}
    SubstParam(LV[i].Expression,S2,C1,SB);
    if SB = 1  then
    begin
     A1:=C1;
     if LV[i].I = _DIV  then A1:=1/A1;         {DIV}
     A:=A*A1;
    end
    else BH:=False;


  end
  else
  if ni = 1 then
  begin
   PN.FM[FIN.F]:=PN.FM[FIN.F]+1;
   if Neg1 = 1 then Neg3:=1;
   inc(r);
  end
  else
  if ni = -1 then
  begin
   PN.IM[FIN.I]:=PN.IM[FIN.I]+1;
   if Neg1 = 1 then Neg3:=1;
   inc(r);
  end;
   if BH = False then begin ni:=0; goto endp; end;

 end;
end
else BH:=False;

if (BH = False) or (r = 1) then begin ni:=0; goto endp; end;

 for i:=0 to High(VarList) do
  begin
   if PN.FM[i] = 1 then inc(SF);
   if PN.FM[i] > 1 then  begin BH:=False; ni:=0; goto endp; end;
  end;

 for i:=0 to High(VarList) do
  begin
   if PN.IM[i] = 1 then inc(SI);
   if PN.IM[i] > 1 then  begin BH:=False; ni:=0; goto endp; end;
  end;

 ni:=0;


 if (SF > 0) and (SI > 0) then  ni:=23
 else
 if (SF = 0) and (SI > 0) then  ni:=22
 else
 if (SF > 0) and (SI = 0) then  ni:=21
 else ni:=20;


  if ((Neg = 1) and (Neg3 = 0)) or ((Neg = 0) and (Neg3 = 1))
 then A:=-A;

 PN.FC:=A;

if BH = False then ni:=0;
if r = 1 then ni:=0;


endp:
end;

{old:}
(*
procedure TForevalH.FindMAF(S: String; var PN: TMass2; var B: TFloatType; var BH: Boolean);
var
LV: PLevel;
S2: String;               //A*x*...*w+B;
N,SB,ni: TIntegType;
//Neg: Boolean;
Neg,COP: Integer;
C1: TFloatType;
begin
BH:=True;

StringAnalizator(S,N,COP,LV,Neg);
if (COP = _ADD) and (N = 2) then
begin

try
 SubstParam(LV[0].Expression,S2,C1{?},SB{?});
 B:=StrToFloat({PointToDec(S2)}S2,G_FMT);
 FindMV(LV[1].Expression,PN,ni);
 if ni = 21 then
  begin
   if LV[1].I = _SUB then PN.FC:=-PN.FC;
  end
 else BH:=False;
except
 try
  SubstParam(LV[1].Expression,S2,C1{?},SB{?});
  B:=StrToFloat({PointToDec(S2)}S2,G_FMT);
  FindMV(LV[0].Expression,PN,ni);
  if ni = 21 then
   begin
    if LV[1].I = _SUB then B:=-B;
   end
  else BH:=False;
 except
  BH:=False;
 end;
end;
end
else
 if COP = _MUL then
 begin
  FindMV(S,PN,ni);
  if ni = 21 then B:=0
  else BH:=False;
  Neg:=0;  //   FindMV
 end
else
BH:=False;

if BH <> False then
 begin
  if {Neg = True}Neg = 1 then
    begin
     PN.FC:=-PN.FC;
     B:=-B;
    end;
 end;


end;
*)


{.203}
procedure TForevalH.FindMAF(S: String; var PN: TMass2; var B: TFloatType; var BH: Boolean);
var
LV: PLevel;
S2: String;               //A*x*...*w+B;
N,SB,ni: TIntegType;
//Neg: Boolean;
Neg,COP: Integer;
C1: TFloatType;
begin
BH:=True;

StringAnalizator(S,N,COP,LV,Neg);
if (COP = _ADD) and (N = 2) then
begin
  //_StrToFloatEx(S: String; var Vex: extended; var SB: integer);

 SubstParam(LV[0].Expression,S2,B,SB);
 if SB = 1 then
 begin
   FindMV(LV[1].Expression,PN,ni);
   if ni = 21 then
   begin
    if LV[1].I = _SUB then PN.FC:=-PN.FC;
   end
   else BH:=False;
 end
 else
 begin
  SubstParam(LV[1].Expression,S2,B,SB);
  if SB = 1 then
  begin
    FindMV(LV[0].Expression,PN,ni);
    if ni = 21 then
    begin
     if LV[1].I = _SUB then B:=-B;
    end
    else BH:=False;
  end
  else BH:=False;
 end;
end
else
 if COP = _MUL then
 begin
  FindMV(S,PN,ni);
  if ni = 21 then B:=0
  else BH:=False;
  Neg:=0;  //   FindMV
 end
else
BH:=False;


if BH <> False then
 begin
  if {Neg = True}Neg = 1 then
    begin
     PN.FC:=-PN.FC;
     B:=-B;
    end;
 end;


end;

{old:}
(*
procedure TForevalH.FindAMVAB_FI(S: String; var A: TFloatType; var B: TFloatType; var nf: TIntegType; var ni: TIntegType; var BH: Boolean);
label endp;
var
LV: PLevel;
PN: TMass2;
S2: String;                         //A*i*f+B;
N,SB,vf,vi,i,COP: Integer;          //i - IntegVar; nf - 
//Neg: Boolean;                     //f - FloatVar; ni - 
Neg: Integer;
C1: TFloatType;
begin
BH:=True; vf:=0; vi:=0;
SetLength(PN.FM,Length(VarList)); SetLength(PN.IM,Length(VarList));

for i:=0 to High(VarList) do
begin
 PN.FM[i]:=0;
 PN.IM[i]:=0;
end;



StringAnalizator(S,N,COP,LV,Neg);
if (COP = _ADD) and (N = 2) then
begin

try
 SubstParam(LV[0].Expression,S2,C1{?},SB{?});
 B:=StrToFloat({PointToDec(S2)}S2,G_FMT);
 FindMV(LV[1].Expression,PN,ni);
 if ni = 23 then
  begin
   if LV[1].I = 1 then PN.FC:=-PN.FC;
  end
 else BH:=False;
except
 try
  SubstParam(LV[1].Expression,S2,C1{?},SB{?});
  B:=StrToFloat({PointToDec(S2)}S2,G_FMT);
  FindMV(LV[0].Expression,PN,ni);
  if ni = 23 then
   begin
    if LV[1].I = 1 then B:=-B;
   end
  else BH:=False;
 except
  BH:=False;
 end;
end;
end
else
 if COP = _MUL then
 begin
  FindMV(S,PN,ni);
  if ni = 23 then B:=0
  else BH:=False;
  Neg:=0;  //   FindMV
 end
else
BH:=False;

A:=PN.FC;

for i:=0 to High(VarList) do
begin
 if PN.FM[i] = 1 then begin inc(vf); nf:=i; end;
 if vf > 1 then begin BH:=False; goto endp; end;
end;

for i:=0 to High(VarList) do
begin
 if PN.IM[i] = 1 then begin inc(vi); ni:=i; end;
 if vi > 1 then begin BH:=False; goto endp; end;
end;


if BH <> False then
 begin
  if Neg = 1 then
    begin
     A:=-A;
     B:=-B;
    end;
 end;

endp:
end;
*)



{.203}
procedure TForevalH.FindAMVAB_FI(S: String; var A: TFloatType; var B: TFloatType; var nf: TIntegType; var ni: TIntegType; var BH: Boolean);
label endp;
var
LV: PLevel;
PN: TMass2;
S2: String;                         //A*i*f+B;
N,SB,vf,vi,i,COP: Integer;          //i - IntegVar; nf - 
//Neg: Boolean;                     //f - FloatVar; ni - 
Neg: Integer;
C1: TFloatType;
begin
BH:=True; vf:=0; vi:=0;
SetLength(PN.FM,Length(VarList)); SetLength(PN.IM,Length(VarList));

for i:=0 to High(VarList) do
begin
 PN.FM[i]:=0;
 PN.IM[i]:=0;
end;



StringAnalizator(S,N,COP,LV,Neg);
if (COP = _ADD) and (N = 2) then
begin

  SubstParam(LV[0].Expression,S2,B,SB);
  if SB = 1  then
  begin
     FindMV(LV[1].Expression,PN,ni);
     if ni = 23 then
     begin
       if LV[1].I = 1 then PN.FC:=-PN.FC;
     end
     else BH:=False;
  end
  else
  begin
    SubstParam(LV[1].Expression,S2,B,SB);
    if SB = 1  then
    begin
      FindMV(LV[0].Expression,PN,ni);
      if ni = 23 then
      begin
       if LV[1].I = 1 then B:=-B;
      end
      else BH:=False;
    end
    else
    BH:=False;
  end;


end
else
begin
  if COP = _MUL then
  begin
    FindMV(S,PN,ni);
    if ni = 23 then B:=0
    else BH:=False;
    Neg:=0;  //   FindMV
  end
  else
  BH:=False;
end;




A:=PN.FC;

for i:=0 to High(VarList) do
begin
 if PN.FM[i] = 1 then begin inc(vf); nf:=i; end;
 if vf > 1 then begin BH:=False; goto endp; end;
end;

for i:=0 to High(VarList) do
begin
 if PN.IM[i] = 1 then begin inc(vi); ni:=i; end;
 if vi > 1 then begin BH:=False; goto endp; end;
end;


if BH <> False then
 begin
  if Neg = 1 then
    begin
     A:=-A;
     B:=-B;
    end;
 end;

endp:
end;





procedure TForevalH.FindAMVAB(S: String; var ni: TIntegType; var FIN: TFin; var PN: TMass2);
label endp;
var                           //ni = 20, - const; - PN.FC
LV: PLevel;                   //ni = 21, - a1*x1+a2*x2+...an*xn+b;   b - PN.FC
ND: TDataNode;                //ni = 22, - a1*i1+a2*i2+...+an*in+b;  b - PN.FC  (ai,b - )
i,SF,SI,nv,N,COP: Integer;    //ni = 23, - a1*x1+...+an*in+b;        b - PN.FC ( -)
A: TFloatType;                //  ni:
                              //a*var+b, ni = 0,1,-1: a - PN.FM/IM[FIN.F/FIN.I]; b - PN.FC
//Neg: Boolean;               //  .   PN  . 
PH: TMass2;
Neg: Integer;

begin
if F_ErrorCode <> 0 then goto endp;

SF:=0; SI:=0;  ND.Neg:=0;
PN.FC:=0;
SetLength(PN.FM,Length(VarList)); SetLength(PN.IM,Length(VarList));
SetLength(PH.FM,Length(VarList)); SetLength(PH.IM,Length(VarList));

for i:=0 to High(VarList) do
begin
PN.FM[i]:=0;
PH.FM[i]:=0;
end;

for i:=0 to High(VarList) do
begin
PN.IM[i]:=0;
PH.IM[i]:=0;
end;

StringAnalizator({copy(S,1,Length(S))}S{.225},N{?},COP,LV,Neg);
if COP = _ADD then
begin
for i:=0 to High(LV) do
 begin
  ND.Neg:=LV[i].I;
  FindAV(LV[i].Expression,ND{?},A,FIN,ni);
  if ni = 1 then
  begin
   PN.FM[FIN.F]:=PN.FM[FIN.F]+A;
   PH.FM[FIN.F]:=1;
  end
  else
  if ni = -1 then
  begin
   PN.IM[FIN.I]:=PN.IM[FIN.I]+A;
   PH.IM[FIN.I]:=1;
  end
  else
  if ni = 20 then
   PN.FC:=PN.FC+A
  else
  begin
   ni:=0; goto endp;
  end;
 end;

if Neg = 1 then
begin
 for i:=0 to High(VarList) do
 begin
 PN.FM[i]:=-PN.FM[i];
 end;

 for i:=0 to High(VarList) do
 begin
 PN.IM[i]:=-PN.IM[i];
 end;

 PN.FC:=-PN.FC;
end;

end
else
begin
FindAV({Copy(S,1,Length(S))}S{.225},ND{?},A,FIN,ni);
if ni = 1   then PN.FM[FIN.F]:=A else
if ni = -1  then PN.IM[FIN.I]:=A else
if ni = 20  then PN.FC:=A;
goto endp;
end;



for i:=0 to High(VarList) do
begin
if PH.FM[i] <> 0 then begin inc(SF); nv:=i; FIN.F:=i; end;
end;

for i:=0 to High(VarList) do
begin
if PH.IM[i] <> 0 then begin inc(SI); nv:=i; FIN.I:=i; end;
end;

ni:=0;

if (SF >= 1) and (SI >= 1) then ni:=23
else
if (SF = 1) and (SI = 0)  then  ni:=1
else
if (SF = 0) and (SI = 1)  then ni:=-1
else
if (SF > 1) and (SI = 0)  then ni:=21
else
if (SF = 0) and (SI > 1)  then ni:=22
else
if (SF = 0) and (SI = 0)  then ni:=20;


endp:
end;







procedure TForevalH.FindArgType(S: String; var nt: TIntegType; var A: TFloatType; var B: TFloatType; var nf: TIntegType; var ni: TIntegType; var PN: TMass2);
label 1;
var                             //nt:
S1,S2: String;                  //0: type is absent
IB: Boolean;                    //1: a*f+b, const.          i - IntegVar
i,SB: TIntegType;               //2: a*i*f+b                f - FloatVar
{Neg,}BH: Boolean;              //3: a1*x+a2*y+...+a12      (AAF)
C: TFloatType;                  //4: a*x*y*...*w+b          (MAF)
ND: TDataNode;                  //5: a*i+b     ;a,b - Integ.
FIN: TFin;
Neg: Integer;
begin                           //6: a1*n+a2*k+...+a5*j+a6  (all const. - Integ)
nt:=0;   {ND.Neg:=False;}       //7: a1*n+a2*k+...+a5*j+a6  (any const. - Float)
S1:=Copy(S,1,Length(S));
S2:=Copy(S,1,Length(S));
nf:=0; ni:=0;
ND.Neg:=0;


//const:
FindExternalBracket(S1,S2,Neg);

if S2 = '' then                            //x^2+5*()
begin
  F_ErrorCode:=E_MISSING_EXPRESSION;
  F_SyntaxErrorString:=S;
  goto 1;
end;

SubstParamC(S2,S2,C,SB);
//FindVarA(S2,FIN,VType);
if (SB = 1) {and (VType = 0)} then
begin
 nt:=1; //  const. - a*x+b; (a = 0)
 A:=0;
 B:=C;
 ni:=0;
 nf:=1; //  const.   X;
 if Neg = 1 then B:=-B;
 goto 1;
end;

TryFpuMask{(@CWMEM4)}; {.249}

FindFIAV(S1,ni,FIN,A,B,PN);
//a*x+b:
if ni = 1 then
begin
 nf:=FIN.F;
 nt:=1;
 goto 1;
end
else
//a*n+b:
if (ni = -1) then
begin
 if A = 0 then       // const. -    a*x+b
  begin
   nt:=1; A:=0; nf:=1;  goto 1;
  end;
 ni:=FIN.I;
 if (Trunc(A) = A) and (Trunc(B) = B)  then
 begin
  nt:=5;
 end
 else
 begin
  nt:=7;
  for i:=0 to High(VarList) do
  begin
   PN.IM[i]:=0;
  end;
  PN.FC:=B;
  PN.IM[ni]:=A;
 end;

 goto 1;
end
else
//a1*x+a2*y+...+a12:
if ni = 21 then
begin
 nt:=3;
 goto 1;
end
else
//a1*n+a2*k+...+a5*j+a6:
if ni = 22 then
begin
 IB:=True;
 for i:=0 to High(VarList) do
 begin
  if Trunc(PN.IM[i]) <> PN.IM[i] then IB:=False;
 end;
 if Trunc(PN.FC) <> PN.FC then IB:=False;

 if IB = True then nt:=6
 else nt:=7;

 goto 1;
end;



//a*x*y*...*w+b:
FindMAF(S1,PN,B,BH);
if BH = True then
begin
 nt:=4;
 goto 1;
end;



//a*x*n+b:
FindAMVAB_FI(S1,A,B,nf,ni,BH);
if BH = True then
begin
 nt:=2;
 goto 1;
end;


(*
//const:
FindExternalBracket(S1,S2,Neg);
SubstParamC(S2,S2,C,SB);
if (SB = 1)  then
begin
 nt:=1; //  const. - a*x+b; (a = 0)
 A:=0;
 B:=C;
 ni:=0;
 nf:=1; //  const.   X;
 if Neg = 1 then B:=-B;
 goto 1;
end;
*)




1:
TryCatchFpuException{(@CWMEM4)}; {.249}
end;



procedure TForevalH.FindMulArg(S: String; var nt: TIntegType; var A: TFloatType; var B: TFloatType; var nf: TIntegType; var ni: TIntegType; var PN: TMass2);
label endp;
var                             //nt:
S1,S2: String;                  //0: type is absent
IB: Boolean;                    //1: a*f+b, const.          i - IntegVar
i,SB: TIntegType;               //2: a*i*f+b                f - FloatVar
{Neg,}BH: Boolean;              //3: a1*x+a2*y+...+a12      (AAF)
C: TFloatType;                  //4: a*x*y*...*w+b          (MAF)
ND: TDataNode;                  //5: a*i+b     ;a,b - Integ.
FIN: TFin;
Neg: Integer;
VType: Integer;
begin                           //6: a1*n+a2*k+...+a5*j+a6  (all const. - Integ)
nt:=0;   {ND.Neg:=False;}       //7: a1*n+a2*k+...+a5*j+a6  (any const. - Float)
S1:=Copy(S,1,Length(S));
S2:=Copy(S,1,Length(S));
nf:=0; ni:=0;
ND.Neg:=0;


//const:
FindExternalBracket(S1,S2,Neg);

if S2 = '' then                            //x^2+5*()
begin
  F_ErrorCode:=E_MISSING_EXPRESSION;
  F_SyntaxErrorString:=S;
  goto endp;
end;

SubstParamC(S2,S2,C,SB);
//FindVarA(S2,FIN,VType);
if (SB = 1) {and (VType = 0)} then
begin
 nt:=1; //  const. - a*x+b; (a = 0)
 A:=0;
 B:=C;
 ni:=0;
 nf:=1; //  const.   X;
 if Neg = 1 then B:=-B;
 goto endp;
end
else
begin
 FindVarA(S2,FIN,VType);
 if (VType = _Single) or (VType = _Double) or (VType = _Extended) then
 begin
    nf:=FIN.F;
    nt:=1;
    ni:=1;
    A:=1;
    B:=0;
    if Neg = 1 then A:=-A;
 end;

end;

//TryFpuMask{(@CWMEM4)}; {.249}


//TryCatchFpuException{(@CWMEM4)}; {.249}
endp:
end;



procedure TForevalH.FindFIAV(S1: String; var ni: TIntegType; var FIN: TFin; var A,B: TFloatType; var PN: TMass2);
label endp;
begin
if F_ErrorCode <> 0 then goto endp;
A:=0; B:=0;
FindAMVAB(S1,ni,FIN,PN);

if ni = 1 then
begin
 a:=PN.FM[FIN.F];
 b:=PN.FC;
end
else
if ni = -1 then
begin
 a:=PN.IM[FIN.I];
 b:=PN.FC;
end;

endp:
end;


procedure TForevalH.WriteArgData(nt: TIntegType; A: TFloatType; B: TFloatType; ni: TIntegType; nf: TIntegType; PN: TMass2; var ND: TDataNode);
begin
InitNode(ND);
if (nt <> 0) then
begin
if nt = _FAVB then
begin
ND.V1:=A; ND.V2:=B;  ND.FV1:=nf;
end
else
if nt = _AIFB then
begin
ND.V1:=A; ND.V2:=B;  ND.FV1:=nf; ND.IV1:=ni;
end
else
if nt = _AAF then
begin
ND.PN:=PN; ND.DI:=_AAF;
end
else
if nt = _MAF then
begin
ND.DI:=_MAF; ND.V2:=B;  ND.PN:=PN;
end
else
if nt = _IAVB then
begin
ND.VI1:=Trunc(A); ND.VI2:=Trunc(B); ND.IV1:=ni;
end
else
if nt = _AAI then
begin
ND.PN1:=PN; ND.CI:=_AAI;
end
else
if nt = _AFI then
begin
ND.PN:=PN; ND.DI:=_AFI;
end;
end;
end;





procedure TForevalH.FindFuncArgData(S: String;  var ND: TDataNode; var nt: TIntegType);
var
ni,nf: TIntegType;
A,B: TFloatType;
PN: TMass2;
begin
FindArgType(S,nt,A,B,nf,ni,PN);
if (nt <> 0)  then
begin
WriteArgData(nt,A,B,ni,nf,PN,ND);
end;
end;




procedure TForevalH.FindAFB(S: String; var A: TFloatType; var B: TFloatType; var BH: Boolean);
label endp;
var
N,SB,ni,nv,COP: Integer;
{Neg: Boolean;}                  //a*x+b;    
Neg: Integer;
S1: String;
LV: PLevel;
ND: TDataNode;
FIN: TFin;
PN: TMass2;
A1: TFloatType;
i: Cardinal;
begin
if F_ErrorCode <> 0 then goto endp;

A:=0; B:=0; BH:=False; nv:=0;   Neg:=0;
ni:=0;   ND.Neg:=0;
StringAnalizator(S,N{?},COP,LV,Neg);
if COP = _ADD then
begin

 for i:=0 to High(LV) do
 begin
  ND.Neg:=LV[i].I;
  FindAV(LV[i].Expression,ND{?},A1,FIN,ni);

  if (ni = 1) and (nv = 0) and (FIN.F = 0) then
  begin
   nv:=1;  A:=A1;
  end
  else
  if ni = 20 then
  B:=B+A1
  else
  begin
   BH:=False; goto endp;
  end;

 end;

  if Neg = 1 then
  begin
   A:=-A; B:=-B;
  end;

  if nv = 0 then BH:=False else BH:=True;
  goto endp;

end
else
//COP = _MUL,_NOP
begin
 FindAV(S,ND{?},A1,FIN,ni);
 if (ni = 1) and (FIN.F = 0) and (A1 <> 0) then
 begin
  B:=0; A:=A1; BH:=True;
 end
 else
 BH:=False;
end;


endp:
end;





procedure TForevalH.CalcConstExpr_MUL(LVA: PLevel;  var A: TFloatType; var BH: Boolean);
label endp;
var
COP,S1: String;
N,SB,i: Integer;
Neg: Boolean;
LV: PLevel;
LVA1: PLevel;
C,S,M: TFloatType;
begin
M:=1; BH:=True; C:=0; A:=0;

 for i:=0 to High(LVA) do
 begin
  SubstParam(LVA[i].Expression,S1{?},C,SB);
  if SB = 1 then
  begin
   if {LVA[i].Inv = True}LVA[i].I = _DIV then M:=M/C else M:=M*C;      {DIV}
   BH:=True;
  end
  else
  begin
   BH:=False;
   goto endp;
  end;
 end;


A:=M;

endp:
end;



procedure TForevalH.CalcConstExpr(S: String; var A: TFloatType; var BH: Boolean);
label endp;
var
S1,S2: String;
N,SB,i: Integer;
Neg,Neg1,COP: Integer;
LV,LV1: PLevel;
C: TFloatType;
begin

S2:=Copy(S,1,Length(S));
StringAnalizator(S2,N,COP,LV,Neg);
A:=0;  C:=0;
if COP = _MUL then
begin
 CalcConstExpr_MUL(LV,C,BH);
 if BH = True then begin A:=C; goto endp; end else begin BH:=False; goto endp; end;
end
else
if COP = _ADD then
begin

 for i:=0 to High(LV) do
 begin
   StringAnalizator(LV[i].Expression,N,COP,LV1,Neg1);

   if COP = _NOP then
   begin
    SubstParam(LV[i].Expression,S1{?},C,SB);
    if SB = 1 then
    begin
     if LV[i].I = 1 then C:=-C;
    end
    else
    begin
     BH:=False; goto endp;
    end;
   end
   else
   if COP = _MUL then
   begin
    CalcConstExpr_MUL(LV1,C,BH);
    if BH = False then  goto endp;
    if  LV[i].I = _SUB then C:=-C;
   end
   else
   begin BH:=False; goto endp; end;

   if Neg1 = 1 then C:=-C;
   A:=A+C;
 end; //end for
BH:=True;
end
else
if COP = _NOP then
begin
 SubstParam(S,S1{?},C,SB);
  if SB = 1 then
  begin
   if {Neg = True}Neg = 1 then C:=-C;
   A:=C;
   BH:= True;
   goto endp;
  end;
 BH:=False; goto endp;
end;




endp:
if Neg = 1 then A:=-A;
end;






procedure TForevalH.FindConstItem(LM: PLevel; {Neg: Boolean;}Neg: Integer;  T: Integer; var LM1: PLevel; var A,B: TFloatType; var BH: Boolean);
label 1,endp;
var
i,N,N1,N2,SB,Inv,Ng,h: Integer;
S,S1: String;
LM2: PLevel;
//Neg1: Boolean;                        //* = '*','/'
LV1: PLevel;                            //A*S1*..*Sn+B
C: TFloatType;                          //A,B -  const.
Neg1,COP: Integer;
begin
SetLength(LM1,1);
if T = 1 then
begin
 LM2:=LM; A:=1;
 if LM[1].Expression[1] = '-' then begin A:=-1; Delete(LM[1].Expression,1,1);  end;
 goto 1;
end;

B:=0; h:=0; BH:=False;
for i:=1 to  High(LM) do
begin
 SubstParam(LM[i].Expression,S1{},C,SB);
 if SB = 1 then
 begin
  if LM[i].I = _SUB then C:=-C;
  B:=B+C;
 end
 else
 begin
  h:=h+1;
  S:=LM[i].Expression;
  if LM[i].I = _SUB then N:=-1 else N:=1;
 end;
end;


if h = 1 then
begin
 StringAnalizator(S,N2{?},COP,LV1,Neg1);
 if COP = _MUL then
 begin
  if Neg1 = 1 then N1:=-N1 else N1:=1;
  A:=N*N1;
1:
  for i:=1 to High(LM2) do
  begin
   if LM2[i].I = _DIV then Inv:=1 else Inv:=0;
   SubstParam(LM2[i].Expression,S1,C,SB);
   if SB = 1 then
   begin
    if Inv = 1 then C:=1/C;
    A:=A*C;
   end
   else
   begin
    SetLength(LM1,Length(LM1)+1);
    LM1[High(LM1)].Expression:=Copy(LM2[i].Expression,1,Length(LM2[i].Expression));
    LM1[High(LM1)].I:=LM2[i].I;
   end;
  end;
  BH:=True;
  if Neg = 1 then begin A:=-A; B:=-B;  end;
 end
 else
 BH:=False;
end
else
BH:=False;

endp:
end;




(*
procedure TForevalH.FindFactSymb(S1: String; var S2: String);
label 1,2,endp;
var
Sa: String;
pb,bb,b,i,pb1: TIntegType;
begin
Sa:=Copy(S1,1,Length(S1));        //  fact   A!,(A)!  fact(A)

2:
b:=0; pb:=0;
for i:=1 to Length(Sa) do
begin
 if Sa[i] = ')' then b:=b-1;
 if Sa[i] = '(' then b:=b+1;
 if (Sa[i] = '!') and (b = 0) then pb:=i;
end;

if pb = 0 then goto endp;

bb:=0;  pb1:=0;  i:=pb-1;
while  i > 0 do
begin
 if Sa[i] = ')' then bb:=bb-1;
 if Sa[i] = '(' then bb:=bb+1;
 if ((Sa[i] = '*') or (Sa[i] = '/') or (Sa[i] = '+') or
 (Sa[i] = '-') or (Sa[i] = '^'))  and (bb = 0) then
  begin pb1:=i+1; goto 1; end;
  i:=i-1;
end;
1: if   pb1 = 0 then begin pb1:=1; S1:=Copy(Sa,1,pb-1); end
   else
    S1:=Copy(Sa,pb1,pb-pb1);

if (S1[1] = '(') and (S1[Length(S1)] = ')') then  begin Delete(S1,1,1); Delete(S1,Length(S1),1); end;
Delete(Sa,pb1,pb-pb1+1);
Insert('fact'+'('+S1+')',Sa,pb1);
goto 2;

endp:
S2:=Copy(Sa,1,Length(Sa));
end;
*)


procedure TForevalH.FindPowerSymb(S1: String; var S2: String);
label 1,2,3,endp;
var
Sa: String;
pb,bb,i,pb1,pb2,bb1,bb2,PP: TIntegType;
E: Exception;
begin                                   //   A^B,(A)^(B)  power(A,B)
if F_ErrorCode <> 0 then goto endp;


Sa:=Copy(S1,1,Length(S1));

3:
PP:=Pos('^',Sa);
if PP = 0 then goto endp;

pb:=0; bb:=0;  bb1:=0; bb2:=0;
for i:=1 to Length(Sa) do
begin
 if Sa[i] = ')' then bb:=bb-1;
 if Sa[i] = '(' then bb:=bb+1;
 if Sa[i] = '}' then bb1:=bb1-1;
 if Sa[i] = '{' then bb1:=bb1+1;
 if Sa[i] = ']' then bb2:=bb2-1;
 if Sa[i] = '[' then bb2:=bb2+1;
 if (Sa[i] = '^') and (bb = 0) and (pb = 0) and (bb1 = 0)  and (bb2 = 0) then pb:=i;
end;

if pb = 0 then goto endp;


bb:=0;  pb1:=0;  i:=pb-1;  bb1:=0; bb2:=0;
while  i > 0 do
 begin
 if Sa[i] = ')' then bb:=bb-1;
 if Sa[i] = '(' then bb:=bb+1;
 if Sa[i] = '}' then bb1:=bb1-1;
 if Sa[i] = '{' then bb1:=bb1+1;
 if Sa[i] = ']' then bb2:=bb2-1;
 if Sa[i] = '[' then bb2:=bb2+1;
 if ((Sa[i] = '*') or (Sa[i] = '/') or (Sa[i] = '+') or
    (Sa[i] = '-') or (Sa[i] = '^') or (Sa[i] = '&'))  and (bb = 0) and (bb1 = 0) and (bb2 = 0) then
    begin pb1:=i+1; goto 1; end;
     i:=i-1;
 end;

1: if   pb1 = 0 then begin pb1:=1; S1:=Copy(Sa,1,pb-1); end
   else
    S1:=Copy(Sa,pb1,pb-pb1);


bb:=0; i:=pb+1; pb2:=0;  bb1:=0; bb2:=0;
while i <= Length(Sa)  do
 begin
 if Sa[i] = ')' then bb:=bb-1;
 if Sa[i] = '(' then bb:=bb+1;
 if Sa[i] = '}' then bb1:=bb1-1;
 if Sa[i] = '{' then bb1:=bb1+1;
 if Sa[i] = ']' then bb2:=bb2-1;
 if Sa[i] = '[' then bb2:=bb2+1;
 if ((Sa[i] = '*') or (Sa[i] = '/') or (Sa[i] = '+') or
    (Sa[i] = '-') or (Sa[i] = '^')or (Sa[i] = '&')) and (i <> pb+1) and (bb = 0) and (bb1 = 0) and (bb2 = 0) then
    begin pb2:=i-1; goto 2; end;
 if (Sa[i] = '|') and (bb = 0) and (i <> pb+1) then begin pb2:=i; goto 2; end;
 i:=i+1;
 end;
 if pb2 = 0 then pb2:=Length(Sa);
2:
 S2:=Copy(Sa,pb+1,pb2-pb);
 if (S1 = '') or (S2 = '') then        // 
 begin
 F_ErrorCode:=E_MISSING_ARGUMENT;//E_INCOINCIDENCE_NUMBER_ARGUMENTS;
 F_SyntaxErrorString:=Copy(Sa,1,Length(Sa));
 //raise ESyntaxError.Create('');
 goto endp;
 end;
 if (S1[1] = '(') and (S1[Length(S1)] = ')') then  begin Delete(S1,1,1); Delete(S1,Length(S1),1); end;
 if (S2[1] = '(') and (S2[Length(S2)] = ')') then  begin Delete(S2,1,1); Delete(S2,Length(S2),1); end;
 Delete(Sa,pb1,pb2-pb1+1);
 Insert('power('+S1+','+S2+')',Sa,pb1);
 goto 3;


endp:
S2:=Copy(Sa,1,Length(Sa));
end;






procedure TForevalH.FindFuncSymb(S1: String; var S2: String);
begin                  //  
//FindFactSymb(S1,S1);
FindPowerSymb(S1,S2);
end;




procedure   TForevalH.ReplaceAbsBr(S: String; var S1: String);
label 1,endp;

             function GetTypeAbsBr(p: Integer; S: String): Integer;
             begin
              if p = 1 then GetTypeAbsBr:=1
              else
              if p = Length(S) then GetTypeAbsBr:=2
              else
              if (S[p-1] = '+') or (S[p-1] = '-') or (S[p-1] = '*') or
                 (S[p-1] = '/') or (S[p-1] = '^') or (S[p-1] = '(') or
                 (S[p-1] = '[') or (S[p-1] = '{') or (S[p-1] = ',') or
                 (S[p-1] = '=') or (S[p-1] = '>') or (S[p-1] = '<') or
                 (S[p-1] = '&')
                 then GetTypeAbsBr:=1
              else
               GetTypeAbsBr:=2;
             end;


var
 i,L,p,t,nbr: Integer;
begin
L:=Length(S); p:=1; nbr:=0;
//||x-1|+|x+1||-|x-|x+|x-1|-|x+1||+y|
while p < L do
begin
  for i:=p to L do
  begin
   if S[i] = '|' then
   begin
     inc(nbr); p:=i; goto 1;
   end;
  end;
  goto endp;
1:
  t:=GetTypeAbsBr(p,S);
  if t = 1 then
  begin
   Delete(S,p,1); Insert('abs(',S,p); p:=p+3
  end
  else
  if t = 2 then
  begin
    Delete(S,p,1); Insert(')',S,p);
  end;

  L:=Length(S);
end;

endp:
S1:=Copy(S,1,Length(S));

if (nbr mod 2 <>  0) then
begin
   F_ErrorCode:=E_MISSING_ABS_BRACKET;
   //F_SyntaxErrorString:=S;
end;

end;




procedure   TForevalH.ReplaceTruncBr(S: String; var S1: String);
label 1,endp;

           procedure FindCloseTruncBr(St: String; p: integer; var p1: integer);
           label outp;
           var
            i,L,br: integer;
           begin
              L:=Length(St); br:=1;   p1:=0;

              for i := p to L  do
              begin
                if St[i] = '[' then inc(br)
                 else
                 if St[i] = ']' then dec(br);

                 if br = 0 then
                 begin
                   p1:=i; goto outp;
                 end;
              end;

             outp:
           end;


var
 i,L,p,t,tb,nbr1,nbr2,ep: Integer;
 CF,Exch: Boolean;
begin
L:=Length(S); p:=1; t:=0;  CF:=True; nbr1:=0;  nbr2:=0;  Exch:=False;
//[[x-1]+[x+1]]-[x-[x+[x-1]-[x+1]]+y]
//[[x-1]+[x+1]]-[x-[x+[x-1]-[x+1]+ad[n]]+y]
{while p < L do
begin
  for i:=p to L do
  begin
   if S[i] = '[' then
   begin
     p:=i; t:=1; goto 1;
   end
   else
   if S[i] = ']' then
   begin
     p:=i; t:=2; goto 1;
   end;
  end;
  goto endp;
1:

  if t = 1 then
  begin
   Delete(S,p,1); Insert('trunc(',S,p); p:=p+5
  end
  else
  if t = 2 then
  begin
    Delete(S,p,1); Insert(')',S,p);
  end;

  L:=Length(S);
end; }

while p < L do
begin
  tb:=1;

  for i:=p to L do
  begin
   if (i > 1) and ((S[i-1] = '[') or (S[i-1] = '{') or (S[i-1] = '(') or
                   (S[i-1] = '*') or (S[i-1] = '+') or (S[i-1] = '/') or
                   (S[i-1] = '-') or (S[i-1] = '^') or (S[i-1] = ',') or
                   (S[i-1] = '=') or (S[i-1] = '>') or (S[i-1] = '<') or
                   (S[i-1] = '&'))
                   then CF:=True
                   else
                   if (i > 1) then CF:=False;


   if (S[i] = '[') and (CF = True) then
   begin
     p:=i; t:=1; goto 1;
   end;

  (*
   if S[i] = '[' then tb:=tb+1;
   if S[i] = ']' then tb:=tb-1;


   if (S[i] = ']') and (tb = 0) {and (Exch = True)} then
   begin
      p:=i; t:=2; goto 1;
   end;
  *)
  end;
  goto endp;
1:

  if t = 1 then
  begin
   Delete(S,p,1); Insert('trunc(',S,p); p:=p+5; inc(nbr1);  //Exch:=True;
   FindCloseTruncBr(S,p,ep);
   if ep <> 0 then
   begin
     Delete(S,ep,1); Insert(')',S,ep); inc(nbr2);
   end;
  end;
  (*
  else
  if t = 2 then
  begin
    Delete(S,p,1); Insert(')',S,p); inc(nbr2);   //Exch:=False;
  end;
  *)

  L:=Length(S);
end;

endp:

//[x+[x+1]+y
//[[x-1]+[x+1]]-[x-[x+[x-1]-[x+1]+ad[n]]+y]
//ad[[ad[n+1]-6]]


//ad[[ad[n+1]-6]+ad[[ad[n+1]-6]]]
//ad[[[ad[n+1]-6]]+[ad[[ad[n+1]-6]]]]
//ad[[[ad[n+1]-6]+ad[[ad[n+1]-6]]]]


if (nbr1  <>  nbr2) then
begin
   F_ErrorCode:=E_MISSING_SQUARE_BRACKET;
   //F_SyntaxErrorString:=S;
end;
S1:=Copy(S,1,Length(S));
end;






procedure   TForevalH.ReplaceFracBr(S: String; var S1: String);
label 1,endp;
var
 i,L,p,t,tb,nbr1,nbr2: Integer;
 CF: Boolean;
begin
L:=Length(S); p:=1; t:=0;  CF:=True;   nbr1:=0; nbr2:=0;
//{{x-1}+{x+1}}-{x-{x+{x-1}-{x+1}}+y}
(*
while p < L do
begin
  for i:=p to L do
  begin
   if S[i] = '{' then
   begin
     p:=i; t:=1; goto 1;
   end
   else
   if S[i] = '}' then
   begin
     p:=i; t:=2; goto 1;
   end;
  end;
  goto endp;
1:

  if t = 1 then
  begin
   Delete(S,p,1); Insert('frac(',S,p); p:=p+4
  end
  else
  if t = 2 then
  begin
    Delete(S,p,1); Insert(')',S,p);
  end;

  L:=Length(S);
end;
*)

p:=pos('{',S);
if p = 0  then p:=pos('}',S);


while p <> 0 do
begin

  p:=pos('{',S);
  if p <> 0 then
  begin
   Delete(S,p,1); Insert('frac(',S,p);  inc(nbr1);
  end
  else
  begin
   p:=pos('}',S);
   if p <> 0 then
   begin
    Delete(S,p,1); Insert(')',S,p); inc(nbr2);
   end;
  end;

end;

endp:
if (nbr1  <>  nbr2) then
begin
   F_ErrorCode:=E_MISSING_CURLY_BRACKET;
   //F_SyntaxErrorString:=S;
end;
S1:=Copy(S,1,Length(S));
end;




procedure TForevalH.FindFuncName(Sf: String; var nf: Integer);
label outf;                 {.199}
var
k,l: Integer;
Sf1,Sfn: String;
begin

nf:=-1;


Sf1:=Sf;


if F_SyntaxExtension = True then
begin
for k:=1 to Length(FuncList)-1 do
 begin
  for l:=1 to Length(FuncList[k].Name)-1 do
   begin

    Sfn:=FuncList[k].Name[l];

    if (Sf1 = Sfn) and (FuncList[k].Enabled = _Yes) then  begin nf:=k; goto outf;   end;  {.199}

   end;
 end
end
else
for k:=1 to Length(FuncList)-1 do
 begin
  for l:=1 to 1 do
   begin

    Sfn:=FuncList[k].Name[l];

    if (Sf1 = Sfn) and (FuncList[k].Enabled = _Yes) then  begin nf:=k; goto outf;   end;     {.199}

   end;
 end;

outf:                 {.199}
 {if (nf <> -1)   then
  begin
    if FuncList[nf].Enabled = _No then nf:=-1;
  end;   }

end;




procedure TForevalH.FindFunc(Name: String; var id,ftype: Integer; var adr: Cardinal);
begin
 adr:=0;
 FindFuncName(Name,id);
 if id <> -1 then
 begin
  ftype:=FuncList[id].FType;
  adr:=Cardinal(FuncList[id].addr);
 end; 
end;



procedure TForevalH.FindFunction(S: String; var A: TFloatType; var B: TFloatType; var Arg1: String; var Arg2: String; var nf: TIntegType; var BH: Boolean);
label 1,2,3,4,endp;
var
i,k,l,bb,pf,pr,b1,b2,FType,INF,nif,ni,VType: Integer;
S1,Sa,Sf,Sf1,Sfn: String;
//Neg: Boolean;
Neg: Integer;
E: Exception;
FIN: TFIN;
begin
A:=0; B:=0;
if F_ErrorCode <> 0 then goto endp;
BH:=False;            // A*func(Arg1{,Arg2})+B, nf- -, (nf=0: BH=False)

FindExternalBracket(S,S,Neg);

F_CurrentString:=S;

S1:=Copy(S,1,Length(S));

// :
nf:=0; bb:=0;  pf:=0; b1:=0;
for i:=1 to Length(S1) do
begin
 if S1[i] = '(' then begin b1:=i; goto 1; end;

 if (S1[i] = '[') {or (S1[i] = '{') } then begin BH:=False; goto endp; end;   //vec[(arg)]       {.160}
end;
if b1 = 0 then goto endp;

1:
b2:=0; bb:=-1;
for i:=b1+1 to Length(S1) do
begin
 if S1[i] = '(' then bb:=bb-1;
 if S1[i] = ')' then bb:=bb+1;
 if (S1[i] = ')') and (bb = 0) then begin b2:=i; goto 2; end;
end;
2:
i:=b1-1;  pf:=1;
while i <> 0 do
begin
 if (S1[i] = '*') or (S1[i] = '+') or (S1[i] = '/') or (S1[i] = '-') or (S1[i] = '^')
   then begin pf:=i+1; goto 3; end;
 i:=i-1;
end;
3:
nf:=0;
Sf:=Copy(S1,pf,b1-pf);
Sa:=Copy(S1,b1+1,b2-b1-1);
if Sf = '' then goto endp;



FindFuncName(Sf,nf);
if nf <> -1 then goto 4;



{.160}
(*
//  : vec[arg]
 FindVarA(Sf,FIN,VType);
 if (VType = _ArrayD) or (VType = _ArrayE) or (VType = _ArrayS) or (VType = _ArrayI) then
 begin
   BH:=False; goto endp;
 end;
*)

//     : inc,dec
{if (LowerCase(Sf) = 'inc') or (LowerCase(Sf) = 'dec') then
begin
  BH:=False; goto endp;
end;}


  FindVarB(Sf,ni,VType);       {.203}    // x(x+1) ; vd(n+1); sinx(x+1)
  if (ni >=0) and ((VType = _Single) or (VType = _Double)  or (VType = _Extended) or (VType = _Integer)) then
  begin
   F_SyntaxErrorString:=Copy(Sf,1,Length(Sf))+'(';
   F_ErrorCode:=E_MISSING_OPERATION;
  end
  else
  if ExistParameter(Sf) = true then
  begin
    F_SyntaxErrorString:=Copy(Sf,1,Length(Sf))+'(';
    F_ErrorCode:=E_MISSING_OPERATION;
  end
  else
  begin
   F_SyntaxErrorString:=Copy(Sf,1,Length(Sf));
   F_ErrorCode:=E_UNKNOWN_FUNCTION; //UknownFunction
  end;
//raise ESyntaxError.Create('');
  goto endp;

4:
 if nf <> 0 then
 begin
  FType:=FuncList[nf].FType;

  if nf = C_NOP then begin BH:=True; F_NopPresent:=True; goto endp; end;


  if FType = 0 then begin BH:=False; goto endp; end; //   @@PACKAGE:   NOP


  // FType  FindInternalNum    - !!!
  if  {ExternalFuncList[nf].FType < 0} FType < 0 then
  begin
   //-     :
   if (FType <= -11) and (FType >= -14) then INF:=1 else INF:=0;
  end;

  Delete(S1,pf,b2-pf+1);
  Insert('@@func',S1,pf);

  FindAFB(S1,A,B,BH);          //BH = True    a*func+b

  if BH = True then
  begin                // :                  //   :
    if  (Sa = '') and ({External}FuncList[nf].arg <> 0) and (INF = 0)
    then
    begin
     F_ErrorCode:=E_INCOINCIDENCE_NUMBER_ARGUMENTS;
     F_SyntaxErrorString:=Copy(S,1,Length(S));
     //raise ESyntaxError.Create('');
     goto endp;
    end;


    FindManyArg(Sa,nf);
    if INF = 1 then
    begin
     FuncList[nf].arg:=High(ArgM);
    end;

    if (FuncList[nf].arg <> High(ArgM)) and (FType <> -17)  then
    begin
     F_ErrorCode:=E_INCOINCIDENCE_NUMBER_ARGUMENTS;
     F_SyntaxErrorString:=Copy(S,1,Length(S));
     //raise ESyntaxError.Create('');
     goto endp;
    end;

    if FuncList[nf].arg = High(ArgM) then   {.203}  //poly(vd)
    begin
     if (FuncList[nf].arg = 2)   then
     begin
      Arg1:=Copy(ArgM[1],1,Length(ArgM[1]));
      Arg2:=Copy(ArgM[2],1,Length(ArgM[2]));
     end
     else
     if FuncList[nf].arg = 1 then
     begin
      Arg1:=Copy(ArgM[1],1,Length(ArgM[1]));
     end;
    end;



   if Neg = 1 then
   begin
    A:=-A; B:=-B;
   end
  end
  else
  nf:=0;
 end;



endp:
end;




procedure TForevalH.FindManyArg(S: String; nf: Integer);
label endp;
var
i,N,bb,nif,FType,INF: Integer;
PP: TArrayI;
E: Exception;
begin
if F_ErrorCode <> 0 then goto endp;

F_SyntaxE:=S;

bb:=0;
N:=1; SetLength(PP,N+1); PP[1]:=0;
FType:=FuncList[nf].FType;
if  FType < 0 then
begin
 //-     :
 if (FType <= -11) and (FType >= -14) then INF:=1 else INF:=0;
end;

//  :
if (S = '') and  (({External}FuncList[nf].arg = 0) or (INF = 1))  then
begin
SetLength(ArgM,1);
goto endp;
end;

for i:=1 to Length(S) do
begin
 if S[i] = '(' then bb:=bb-1;
 if (bb = 0) and (S[i] = ',') then begin inc(N); SetLength(PP,N+1); PP[N]:=i; end;
 if S[i] = ')' then bb:=bb+1;
end;

inc(N);  SetLength(PP,N+1); PP[N]:=Length(S)+1;

SetLength(ArgM,N);

for i:=1 to N-1 do
begin
ArgM[i]:=Copy(S,PP[i]+1,PP[i+1]-PP[i]-1);
if (ArgM[i] = '')  then
begin
 if (N-1 = 1) or (N-1 = 2) then
 begin
  F_ErrorCode:=E_MISSING_ARGUMENT;
  F_SyntaxErrorString:=Copy(F_CurrentString,1,Length(F_CurrentString));
 end
 else
 begin
  F_ErrorCode:=E_INCOINCIDENCE_NUMBER_ARGUMENTS;
  F_SyntaxErrorString:=Copy(S,1,Length(S));
 end;

 //raise ESyntaxError.Create('');
 goto endp;
end;
end;

endp:
end;



procedure TForevalH.FindVarB(S: String; var ni,VType: Integer);
label endp;
var
i: Integer;
S2,S3: String;
begin

//S2:=Copy(S,1,Length(S));
ni:=-1;
VType:=0;


for i:=0 to High(VarList) do
begin

 S3:=VarList[i].Name;

 if S = S3 then
  begin
   ni:=i;
   VType:=VarList[i].VType;
   F_VarPresent:=True;
   VarList[i].IsUsed:=True; {.225}
   goto endp;
  end;

end;

endp:
end;




procedure TForevalH.GetVarAdr(Name: String; var Addr: Cardinal; var VType: Integer);
label endp;
var
i: Integer;
S2,S3: String;
begin

//S2:=Copy(Name,1,Length(Name));

Addr:=0;

for i:=0 to High(VarList) do
begin

 S3:=VarList[i].Name;


 if Name = S3 then
  begin
   Addr:=VarList[i].Addr;
   VType:=VarList[i].VType;
   goto endp;
  end;

end;

endp:
end;





function TForevalH.FuncArgType(nf,i: Integer): Integer;
begin
 if FuncList[nf].ArgType = _Differ then FuncArgType:=FuncList[nf].ArgTypeList[i]
 else FuncArgType:=FuncList[nf].ArgType;
end;





procedure TForevalH.ReWriteArg(nf: Integer; LV: PLevel; var LV1: PLevel);
label endp;
var
i,ni,VT: Integer;
S1: String;
begin

//   ArgM  LV
//func(..,Arg:_Address,...)
//     - _Address,    (:Arg - !!!)
//     func(..,Arg,..)->func(..,lda(Arg),..)
LV1:=LV;

if FuncArgType(nf,0) = _Address then
begin
  FindVarB(ArgM[1],ni,VT);
  if ni = -1 then
  begin
    F_ErrorCode:=E_INCORRECT_ARGUMENT;
    F_SyntaxErrorString:=Copy(ArgM[1],1,Length(ArgM[1]));
    goto endp;
  end
  else
  begin
    S1:='lda('+ArgM[1]+')';
    LV1[0].Expression:=Copy(S1,1,Length(S1));
  end;
end
else
LV1[0].Expression:=Copy(ArgM[1],1,Length(ArgM[1]));

for i:= 2 to High(ArgM) do
begin
 S1:=ArgM[i];
 if FuncArgType(nf,i-1) = _Address then
 begin
   FindVarB(ArgM[i],ni,VT);
   if ni = -1 then
   begin
    F_ErrorCode:=E_INCORRECT_ARGUMENT;
    F_SyntaxErrorString:=Copy(ArgM[i],1,Length(ArgM[i]));
    goto endp;
   end
   else
   begin
    S1:='lda('+ArgM[i]+')';
   end;
 end;

  SetLength(LV1,Length(LV1)+1);
  LV1[i-1].Expression:=Copy(S1,1,Length(S1));
  LV1[i-1].I:=_NOP;

end;


//func(..,Arg:_Compile,...)
//     - _Compiled,     
//     func(..,Arg,..)->func(..,compile(Arg),..)

(*
if FuncArgType(nf,0) = _Compiled then
begin
    S1:='compile('+ArgM[1]+')';
    LV1[0].Expression:=Copy(S1,1,Length(S1));
end
else
LV1[0].Expression:=Copy(ArgM[1],1,Length(ArgM[1]));

for i:= 2 to High(ArgM) do
begin
 S1:=ArgM[i];
 if FuncArgType(nf,i-1) = _Compiled then
 begin
    S1:='compiled('+ArgM[i]+')';
    SetLength(LV1,Length(LV1)+1);
    LV1[i-1].Expression:=Copy(S1,1,Length(S1));
    LV1[i-1].I:=_NOP;
 end;


end;
*)

endp:
end;




procedure TForevalH.SetExtArgType(nf: Integer; LV: PLevel; var LV1: PLevel); {.227}
var
i: Integer;
begin
{
  ,      
( z  =     )
}
LV1:=LV;
for i:=0 to High(LV1) do
begin
 if (FuncList[nf].FType < 0) then        //  
 begin
  if FuncList[nf].ArgType = _Differ then         // 
     LV1[i].ExtArg:=FuncList[nf].ArgTypeList[i]  //      
  else
     LV1[i].ExtArg:=FuncList[nf].ArgType;       //  
 end
end;

end;


procedure TForevalH.ExtFunc(nf: TIntegType; ND: TDataNode; var LV: PLevel; var ND1: TDataNode; var EOFN: Boolean);
label 1;
var
LH,BL: PLevel;
i,nif,S: Integer;
SArg: String;
begin
ND1:=ND;
LV:=nil;
EOFN:=False;
ND1.N:=High(ArgM);         // ArgM  1

//SetLength(LV,1); LV[0].I:=_NOP; LV[0].ExtArg:=_None;
//   :
if {FuncList[nf].arg = 0}ND1.N = 0 then
begin
//ND1.N:=0;
EOFN:=True;
goto 1;
end;

{
LV[0].Expression:=Copy(ArgM[1],1,Length(ArgM[1]));
for i:= 2 to High(ArgM) do
begin
SetLength(LV,Length(LV)+1);
LV[i-1].Expression:=Copy(ArgM[i],1,Length(ArgM[i]));
LV[i-1].I:=_NOP;
end;
}
SetLength(LV,1); LV[0].I:=_NOP; LV[0].ExtArg:=_None;
ReWriteArg(nf,LV,LV);

//ND1.N:=High(ArgM);


//1:
//ND1.Code:=nf;

SetExtArgType(nf,LV,LV); {.227}
//:
{
for i:=0 to High(LV) do
begin
 if (FuncList[nf].FType < 0) then
 begin
  if FuncList[nf].ArgType = _Differ then
     LV[i].ExtArg:=FuncList[nf].ArgTypeList[i]
  else
     LV[i].ExtArg:=FuncList[nf].ArgType;
 end
end;
}

// . -  :
//         .
//..    = SizeS=16(TStackType{double x 2})     , 
//      (,   !!!) 
//    Extended: Single,Double,Integer  
//     ( )
//      :
//@1 = @1; @2 = @1+S1; @3 = @1+S1+S2; @4 = @1+S1+S2+S3;...;
//@1 -   ; Si -  .(i-)   ;
// ( ): @1 = @1; @2 = @1+SizeS; @3 = @2+SizeS; ...; SizeS=16 -   .
//(  -    = 0!!!)


LV[0].SExtArg:=0;  S:=0;
if F_CloseArg then
begin
 case FuncList[nf].FType of
      -3,  -4, -5, -6, -7, -11, -12, -13, -14, -15, -16:
  begin
    SetLength(ND1.SNExtArg,Length(LV));
    ND1.SNExtArg[0]:=0;
  end;
 end;
end;


for i:=1 to High(LV) do
begin
 LV[i].SExtArg:=0;

 if F_CloseArg then
 begin
  case FuncList[nf].FType of
        -3 , -4 , -5 , -6 , -7 , -11 , -12 , -13 , -14, -15, -16:
   begin
    case LV[i-1].ExtArg of
      _Integer:  S:=S+4;
      _ArrayD:   S:=S+4;
      _ArrayE:   S:=S+4;
      _ArrayS:   S:=S+4;
      _ArrayI:   S:=S+4;
      _Single:   S:=S+4;
      _Double:   S:=S+8;
     _Extended: S:=S+10;
    end;

   LV[i].SExtArg:=i*SizeS-S; //SizeS -    (TStackType) {double x 2}
   ND1.SNExtArg[i]:=LV[i].SExtArg;
   end;
  end;

 end;

end;

1:
ND1.Code:=nf;
if FuncList[nf].NST = -1 then F_OverFlowFunc:=True;
if ND1.N = 0  then LV:=nil;



//  -: LegendreP->LegendreP(n,x),LegendreP(n,m,x)
if nf = C_LEGENDRE then
begin
 if ND1.N = 2 then ND1.Code:=C_LEGENDREP else
 if ND1.N = 3 then ND1.Code:=C_LEGENDREPA else
 begin
   F_ErrorCode:=E_INCORRECT_ARGUMENT;
   F_SyntaxErrorString:=F_CurrentString;
 end;
 SetExtArgType(ND1.Code,LV,LV); {.227}    //   ..  
end
else
//  -: LaguerreP->LaguerreP(n,x),LaguerreP(n,m,x)
if nf = C_LAGUERRE then
begin
 if ND1.N = 2 then ND1.Code:=C_LAGUERREP else
 if ND1.N = 3 then ND1.Code:=C_LAGUERREPA else
 begin
   F_ErrorCode:=E_INCORRECT_ARGUMENT;
   F_SyntaxErrorString:=F_CurrentString;
 end;
 SetExtArgType(ND1.Code,LV,LV); {.227}    //   ..  
end
else
//  -: Random->random(),Random(n),Random(x,y)
if nf = C_RAND then                {.209}
begin
 if ND1.N = 0 then ND1.Code:=C_RAND01MT else
 if ND1.N = 1 then ND1.Code:=C_INTRANDMT else
 if ND1.N = 2 then ND1.Code:=C_RANDMT else
 begin
   F_ErrorCode:=E_INCORRECT_ARGUMENT;
   F_SyntaxErrorString:=F_CurrentString;
 end;
 SetExtArgType(ND1.Code,LV,LV); {.227}    //   ..  
end;



SArg:='';
for i := 1 to High(ArgM) do
  begin
    Sarg:=SArg+ArgM[i]+',';
  end;
if SArg <> '' then Delete(SArg,Length(SArg),1);
ND1.ExpressionArg:=SArg;


end;









procedure TForevalH.FuncFType17M(nf: TIntegType;  var LV: PLevel; var ND1: TDataNode; var EOFN: Boolean);
label 1,endp;
var
LH,BL: PLevel;
i,nif,ni,VT,S,LA: Integer;
S1,SArg: String;
begin
InitNode(ND1);
ND1.Code:=nf;
EOFN:=False;
LV:=nil;
LA:=High(ArgM);    // ArgM  1
ND1.N:=LA;

//   ArgM  LV:
if LA <> 0 then
begin
 SetLength(LV,1); LV[0].I:=_NOP; LV[0].ExtArg:=_None;
 ReWriteArg(nf,LV,LV);
end;


//  (FType = -17):
if nf = C_IF then
begin
    IFAnalizator(LV,ND1,LV,ND1);
    if F_ErrorCode <> 0 then F_SyntaxErrorString:='if('+F_SyntaxE+')';
    EOFN:=False;
    nf:=C_IFNOP;
    //ND1.N:=6;
end
else
if nf = C_LDA then
begin
    LDAAnalizator(LV,ND1,LV,ND1);
    EOFN:=True;
end
else
if nf = C_GOTO then
begin
    GOTOAnalizator(LV,ND1,LV,ND1);
    EOFN:=True;
end
else
if nf = C_SAVEVX then
begin
    SAVEAnalizator(LV,ND1,LV,ND1);
    EOFN:=False;
end
else
if (nf = C_INC) or (nf = C_DEC) then
begin
    IDAMAnalizator(LV,ND1,LV,ND1);
    ND1.code:=nf;
    EOFN:=True;
end
else
if nf = C_SETLENX then
begin
    SetLenAnalizator(LV,ND1,LV,ND1);
    ND1.code:=C_SETLEN;
    EOFN:=False;
end
else
if (nf = C_SUMPX) or (nf = C_SUMPSX)then
begin
    //ND1.Code:=nf;
    SUMPAnalizator(LV,ND1,LV,ND1,EOFN);
end
else
if (nf = C_MOD) {or (nf = C_DIV) or (nf = C_BINC)}then      
begin
    MODAnalizator(LV,ND1,LV,ND1,EOFN);       //   FuncFType17M (..    )
end
else
if (nf = C_POLY) then      
begin
    POLYAnalizator(LV,ND1,LV,ND1,EOFN);       //   FuncFType17M (..    )
end
else
if (nf = C_POLYDIFF) then
begin
    POLYDIFFAnalizator(LV,ND1,LV,ND1,EOFN);       //   FuncFType17M (..    )
end
else
DtaAnalizator(LV,ND1,LV,ND1,EOFN);


//nf 
nf:=ND1.Code;
for i:=0 to High(LV) do
begin
 if (FuncList[nf].FType < 0) then
 begin
  if FuncList[nf].ArgType = _Differ then
     LV[i].ExtArg:=FuncList[nf].ArgTypeList[i]
  else
     LV[i].ExtArg:=FuncList[nf].ArgType;
 end
end;

for i:=0 to High(LV) do
begin
 LV[i].SExtArg:=0;
end;

SArg:='';
for i := 1 to High(ArgM) do
  begin
    Sarg:=SArg+ArgM[i]+',';
  end;
if SArg <> '' then Delete(SArg,Length(SArg),1);
ND1.ExpressionArg:=SArg;


1:
if FuncList[nf].NST = -1 then F_OverFlowFunc:=True;
if ND1.N = 0  then LV:=nil;
endp:
end;






procedure TForevalH.SUMPAnalizator(LV: PLevel; ND: TDataNode;  var LV1: PLevel; var ND1: TDataNode; var EOFN: boolean);
label endp;
var
ni,VT,nm,L,nt,nfc,nf: Integer;
A,B: TFloatType;
PN: TMass2;
Sp: String;
begin
 //LV1:=LV;
 ND1:=ND;
 EOFN:=True;
 nfc:=ND.Code;
 L:=Length(LV);

if  ((nfc = C_SUMPX) and (L <> 2)) or ((nfc = C_SUMPSX) and (L <> 3)) then
begin
  F_ErrorCode:=E_INCOINCIDENCE_NUMBER_ARGUMENTS;
   F_SyntaxErrorString:=F_CurrentString;
  goto endp;
end;

 FindVarB(LV[0].Expression,nm,VT);

 if (VT  <> _ArrayS) and (VT  <> _ArrayE) and (VT  <> _ArrayD) and (VT  <> _ArrayI)  then
 begin
   F_ErrorCode:=E_INCORRECT_ARGUMENT;
   F_SyntaxErrorString:=F_CurrentString;
   goto endp;
 end;


 if nfc = C_SUMPX  then Sp:=LV[1].Expression else
 if nfc = C_SUMPSX then Sp:=LV[2].Expression;

 FindArgType(Sp,nt,A,B,nf,ni,PN);

 //const
 if (nt = _FAVB) and (A = 0)  then
 begin
   if Trunc(B) = B then
   begin
     ND1.EI:=1;
     ND1.VI2:=Trunc(B);
   end
   else
   begin
     F_ErrorCode:=E_INCORRECT_ARGUMENT;
     F_SyntaxErrorString:=F_CurrentString;
     goto endp;
   end
 end
 else
 if (nt = _IAVB)  then                                //EI:=3; (a*i+b, i,a,b - integer) ND.VI1:=Trunc(A); ND.VI2:=Trunc(B); ND.IV1:=ni;
   begin                                              //EI:=2; (i - integ. var) ND.IV1:=ni;
    WriteArgData(nt,A,B,ni,nf,PN,ND1);
    if (A = 1) and (B = 0) then  ND1.EI:=2 else ND1.EI:=3;
   end
 else
 if nt = _AAI then
 begin
    WriteArgData(nt,A,B,ni,nf,PN,ND1);                    //EI:=4; ND.PN1
    //ND.Code:=C_LDSV;
    ND1.EI:=4;
 end
 else
 begin
    ND1.EI:=0;
 end;

 //ND1.N:=1;
 if nfc = C_SUMPX then
 begin
  if ND1.EI = 0 then ND1.N:=1 else  ND1.N:=0;
  ND1.Code:=C_SUMP;
 end
 else
 if nfc = C_SUMPSX then
 begin
   if ND1.EI = 0 then ND1.N:=2 else  ND1.N:=1;
   ND1.Code:=C_SUMPS;
 end;



 if ND1.N = 1 then
 begin
   SetLength(LV1,1);
   LV1[0].Expression:=Copy(LV[1].Expression,1,Length(LV[1].Expression));
   EOFN:=False;
 end
 else
 if ND1.N = 2 then
 begin
   SetLength(LV1,2);
   LV1[0].Expression:=Copy(LV[1].Expression,1,Length(LV[1].Expression));
   LV1[1].Expression:=Copy(LV[2].Expression,1,Length(LV[2].Expression));
   EOFN:=False;
 end;


  ND1.IV2:=nm;


 endp:
end;







procedure TForevalH.DtaAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
label 1,endp;
var
br,Neg,VType: Integer;
i,P,L: Integer;
nf: Integer;
FD1,FD2: extended;
Str,Str1,Str2: String;
adr: Cardinal;
FIN: TFIN;
begin


if F_ErrorCode <> 0 then goto endp;

LV1:=LV;
ND1:=ND;
L:=Length(LV);
EOFN:=False;

//func(array)
if  L = 1 then
begin
//array:
  FindVarA(LV[0].Expression,FIN,VType);
  if (VType = _ArrayD) or (VType = _ArrayE) or (VType = _ArrayS) or (VType = _ArrayI)  then
  begin
    ND1.IV1:=FIN.I;
    ND1.VI1:=0; ND1.VI2:=0;
    ND1.EI:=1;
    ND1.N:=0;
    EOFN:=True;
    case ND1.Code of
      C_SUM:   ND1.Code:=C_SUMV;
      C_SUMQ:  ND1.Code:=C_SUMQV;
      C_AVR:   ND1.Code:=C_AVRV;
      C_NORM:  ND1.Code:=C_NORMV;
      C_MAX:   ND1.Code:=C_MAXV;
      C_MIN:   ND1.Code:=C_MINV;
      C_LEN:   ND1.Code:=C_LENV;
      C_PROD:  ND1.Code:=C_PRODV;
      C_DEV:   ND1.Code:=C_DEVV;
      C_DEVS:  ND1.Code:=C_DEVSV;
      C_GCD:   ND1.Code:=C_GCDV;
      C_LCM:   ND1.Code:=C_LCMV;
    end;
    LV1:=nil;
  end
  else
  //func(data)
  begin
   case ND1.Code of
      C_SUM:   ND1.Code:=C_SUMD;
      C_SUMQ:  ND1.Code:=C_SUMQD;
      C_AVR:   ND1.Code:=C_AVRD;
      C_NORM:  ND1.Code:=C_NORMD;
      C_MAX:   ND1.Code:=C_MAXD;
      C_MIN:   ND1.Code:=C_MIND;
      C_LEN:   ND1.Code:=C_LEND;
      C_PROD:  ND1.Code:=C_PRODD;
      C_DEV:   ND1.Code:=C_DEVD;
      C_DEVS:  ND1.Code:=C_DEVSD;
      C_GCD:   ND1.Code:=C_GCDD;
      C_LCM:   ND1.Code:=C_LCMD;
    end;
   EOFN:=False;
  end;
end
else
  //func(data1,data2,...)
begin
   case ND1.Code of
      C_SUM:   ND1.Code:=C_SUMD;
      C_SUMQ:  ND1.Code:=C_SUMQD;
      C_AVR:   ND1.Code:=C_AVRD;
      C_NORM:  ND1.Code:=C_NORMD;
      C_MAX:   ND1.Code:=C_MAXD;
      C_MIN:   ND1.Code:=C_MIND;
      C_LEN:   ND1.Code:=C_LEND;
      C_PROD:  ND1.Code:=C_PRODD;
      C_DEV:   ND1.Code:=C_DEVD;
      C_DEVS:  ND1.Code:=C_DEVSD;
      C_GCD:   ND1.Code:=C_GCDD;
      C_LCM:   ND1.Code:=C_LCMD;
    end;

   if L = 0 then EOFN:=True else EOFN:=False;
end;

   if L = 2 then
   begin
     if ND1.Code = C_MAXD  then ND1.Code:=C_MAX2;
     if ND1.Code = C_MIND  then ND1.Code:=C_MIN2;
     if ND1.Code = C_AVRD  then ND1.Code:=C_AVR2;
     if ND1.Code = C_NORMD then ND1.Code:=C_NORM2;   {.243}
   end;

   {.243}
   if L = 3 then
   begin
     if ND1.Code = C_MAXD  then ND1.Code:=C_MAX3;
     if ND1.Code = C_MIND  then ND1.Code:=C_MIN3;
     if ND1.Code = C_NORMD then ND1.Code:=C_NORM3;
     if ND1.Code = C_AVRD  then ND1.Code:=C_AVR3;
   end;

endp:
end;




procedure TForevalH.MODAnalizator(LV: PLevel; ND: TDataNode;  var LV1: PLevel; var ND1: TDataNode; var EOFN: boolean);
label endp;
var
ni,VT,nm,L,nt,nfc,nf,ni1,ni2,nt1,nt2,nf1,nf2: Integer;
A1,B1,A2,B2: TFloatType;
PN1,PN2: TMass2;
begin
 EOFN:=False;
 LV1:=LV;
 ND1:=ND;
 //EOFN:=True;
 //nfc:=ND.Code;
 L:=Length(LV);

if  (L <> 2) then
begin
  F_ErrorCode:=E_INCOINCIDENCE_NUMBER_ARGUMENTS;
   F_SyntaxErrorString:=F_CurrentString;
  goto endp;
end;





 FindArgType(LV[0].Expression,nt1,A1,B1,nf1,ni1,PN1);
 FindArgType(LV[1].Expression,nt2,A2,B2,nf2,ni2,PN2);

  if  (nt2 = _FAVB) and (A2 = 0) and  (Trunc(B2) = B2) and (B2 = 2)   then   //mod(...,2)
  begin
    if (nt1 = _IAVB) then      //mod(iavb,2)
    begin
        ND1.VI1:=Trunc(A1); ND1.VI2:=Trunc(B1); ND1.IV1:=ni1;
        ND1.EI:=1;
        ND1.N:=0;
        EOFN:=True;
        LV1:=nil;
    end
    else
    if (nt1 = _AAI) then      //mod(aai,2)
    begin
      ND1.PN1:=PN1; ND1.CI:=_AAI;
      ND1.EI:=5;
      ND1.N:=0;
      EOFN:=True;
      LV1:=nil;
    end
    else                       //mod(S1,2)
    begin
      ND1.EI:=3;
      ND1.N:=1;
      SetLength(LV1,1);
      LV1[0].Expression:=Copy(LV[0].Expression,1,Length(LV[0].Expression));
      LV1[0].NL:=1;
      EOFN:=False;
    end;
  end
  else
  if   (nt2 = _FAVB) and (A2 = 0) and  (Trunc(B2) = B2)   then    //mod(...,const)
  begin
     if (nt1 = _IAVB) then      //mod(iavb,const)
     begin
       ND1.VI1:=Trunc(A1); ND1.VI2:=Trunc(B1); ND1.IV1:=ni1;
       ND1.VI3:=0; ND1.VI4:=Trunc(B2); ND1.IV2:=0;
       ND1.EI:=2;
       ND1.N:=0;
       EOFN:=True;
       LV1:=nil;
     end
     else
     if (nt1 = _AAI) then      //mod(aai,const)
     begin
       ND1.PN1:=PN1; ND1.CI:=_AAI;
       ND1.VI3:=0; ND1.VI4:=Trunc(B2); ND1.IV2:=0;
       ND1.EI:=6;
       ND1.N:=0;
       EOFN:=True;
       LV1:=nil;
     end
     else                       //mod(S1,const)
     begin
       ND1.VI3:=0; ND1.VI4:=Trunc(B2); ND1.IV2:=0;
       ND1.EI:=4;
       ND1.N:=1;
       SetLength(LV1,1);
       LV1[0].Expression:=Copy(LV[0].Expression,1,Length(LV[0].Expression));
       LV1[0].NL:=1;
       EOFN:=False;
     end;

  end
  else
  if  (nt2 = _IAVB) then       //mod(...,IAVB)
  begin
      if (nt1 = _IAVB) then      //mod(iavb,IAVB)
     begin
       ND1.VI1:=Trunc(A1); ND1.VI2:=Trunc(B1); ND1.IV1:=ni1;
       ND1.VI3:=Trunc(A2); ND1.VI4:=Trunc(B2); ND1.IV2:=ni2;
       ND1.EI:=2;
       ND1.N:=0;
       EOFN:=True;
       LV1:=nil;
     end
     else
     if (nt1 = _AAI) then      //mod(aai,IAVB)
     begin
       ND1.PN1:=PN1; ND1.CI:=_AAI;
       ND1.VI3:=Trunc(A2); ND1.VI4:=Trunc(B2); ND1.IV2:=ni2;
       ND1.EI:=6;
       ND1.N:=0;
       EOFN:=True;
       LV1:=nil;
     end
     else                       //mod(S1,IAVB)
     begin
       ND1.VI3:=Trunc(A2); ND1.VI4:=Trunc(B2); ND1.IV2:=ni2;
       ND1.EI:=4;
       ND1.N:=1;
       SetLength(LV1,1);
       LV1[0].Expression:=Copy(LV[0].Expression,1,Length(LV[0].Expression));
       LV1[0].NL:=1;
       EOFN:=False;
     end;
  end
  else
  begin                  //mod(S1,S2)
    ND1.N:=2;
    ND1.EI:=0;
    EOFN:=False;
  end;

  (*
 if (nt1 = _IAVB) and (nt2 = _IAVB)    then      //mod(int1,int2)
 begin
   ND1.VI1:=Trunc(A1); ND1.VI2:=Trunc(B1); ND1.IV1:=ni1;
   ND1.VI3:=Trunc(A2); ND1.VI4:=Trunc(B2); ND1.IV2:=ni2;

   ND1.N:=0;
   ND1.EI:=2;
   EOFN:=True;
   LV1:=nil;
 end
 else
 if (nt1 = _IAVB) and (nt2 = _FAVB) and (A2 = 0) and  (Trunc(B2) = B2)   then   //mod(int1,const)
 begin
   if B2 = 2 then    //mod(int1,2)
   begin
     ND1.VI1:=Trunc(A1); ND1.VI2:=Trunc(B1); ND1.IV1:=ni1;
     ND1.EI:=1;
   end
   else
   begin       //mod(int1,const)
     ND1.VI1:=Trunc(A1); ND1.VI2:=Trunc(B1); ND1.IV1:=ni1;
     ND1.VI3:=Trunc(A2); ND1.VI4:=Trunc(B2); ND1.IV2:=0;
     ND1.EI:=2;
   end;
   ND1.N:=0;
   EOFN:=True;
   LV1:=nil;
 end
 else
 if (nt2 = _FAVB) and (A2 = 0) and  (Trunc(B2) = B2)   then   //mod(S1,const)
 begin
    if B2 = 2 then    //mod(S1,2)
    begin
      ND1.EI:=3;
    end
    else
    begin
      ND1.VI1:=0; ND1.VI2:=Trunc(B2); ND1.IV1:=0;   //mod(S1,const)
      ND1.EI:=4;
    end;
    ND1.N:=1;
    SetLength(LV1,1);
    LV1[0].Expression:=Copy(LV[0].Expression,1,Length(LV[0].Expression));
    LV1[0].NL:=1;
    EOFN:=False;
 end
 else
 begin
  ND1.N:=2;
  ND1.EI:=0;
  EOFN:=False;
 end;
   *)

 endp:
end;




procedure TForevalH.POLYAnalizator(LV: PLevel; ND: TDataNode;  var LV1: PLevel; var ND1: TDataNode; var EOFN: boolean);
label endp;
var
ni,VT,nm,L,nt,nfc,nf: Integer;
f1: TFloatType;
PN: TMass2;
Sp: String;
  I: Integer;
begin
 //LV1:=LV;
 ND1:=ND;
 L:=Length(LV);
{
if   (L <> 2) then
begin
   F_ErrorCode:=E_INCOINCIDENCE_NUMBER_ARGUMENTS;
   F_SyntaxErrorString:=F_CurrentString;
  goto endp;
end;
}

{.223}

if L = 2 then
begin
   FindVarB(LV[0].Expression,nm,VT);          //poly(vd,x)  poly(vd,x/y)
   if (VT  = _ArrayS) or (VT  = _ArrayE) or (VT  = _ArrayD) or (VT  = _ArrayI)  then
   begin
      SetLength(LV1,1);
      LV1[0].Expression:=Copy(LV[1].Expression,1,Length(LV[1].Expression));
      EOFN:=False;
      ND1.N:=1;         {.223}
      ND1.IV2:=nm;
      ND1.EI:=1;
     goto endp;
   end;

   FindVarB(LV[1].Expression,nm,VT);           //poly(x,vd)  poly(x/y,vd)
   if (VT  = _ArrayS) or (VT  = _ArrayE) or (VT  = _ArrayD) or (VT  = _ArrayI)  then
   begin
      SetLength(LV1,1);
      LV1[0].Expression:=Copy(LV[0].Expression,1,Length(LV[0].Expression));
      EOFN:=False;
      ND1.IV2:=nm;
      ND1.N:=1;        {.223}
      ND1.EI:=1;
     goto endp;
   end;


   //SubstParam
   SaveSW; {.249} {TryStrToFloat damage SW}
   if TryStrToFloat(LV[0].Expression,f1,G_FMT) = true      //poly(1.123,x)  poly(1.123,x/y)  poly(x,1.123) poly(x/y,1.123)
   then
   begin
      //SetLength(LV1,1);
      //LV1[0].Expression:=Copy(LV[1].Expression,1,Length(LV[1].Expression));
      //EOFN:=False;
      SetLength(LV1,0);
      ND1.EI:=2;
      ND1.N:=0;           {.223}
      SetLength(ND1.VFP,1);
      ND1.VFP[0]:=f1;
      EOFN:=True;
      goto endp;
   end
   else //SubstParam
   if TryStrToFloat(LV[1].Expression,f1,G_FMT) = true
   then
   begin
      {SetLength(LV1,1);
      LV1[0].Expression:=Copy(LV[0].Expression,1,Length(LV[0].Expression));
      EOFN:=False;}
      SetLength(LV1,0);
      EOFN:=True;
      ND1.EI:=2;
      ND1.N:=0;       {.223}
      SetLength(ND1.VFP,1);
      ND1.VFP[0]:=f1;
      goto endp;
   end
   else
   begin
     F_ErrorCode:=E_INCORRECT_ARGUMENT;
     F_SyntaxErrorString:=F_CurrentString;
     goto endp;
   end;

   {
   if (VT  <> _ArrayS) and (VT  <> _ArrayE) and (VT  <> _ArrayD) and (VT  <> _ArrayI)  then
   begin
     F_ErrorCode:=E_INCORRECT_ARGUMENT;
     F_SyntaxErrorString:=F_CurrentString;
     goto endp;
   end;
   }

end
else
if L > 2 then
begin
   //poly(3,5,7,9,11,15,17,19,x)-(3*x^7+5*x^6+7*x^5+9*x^4+11*x^3+15*x^2+17*x+19)
   SaveSW; {.249} {TryStrToFloat damage SW}
   if TryStrToFloat(LV[0].Expression,f1,G_FMT) = true then      //SubstParam
   begin
       SetLength(ND1.VFP,Length(LV)-1);
       for i := 0 to Length(LV)-2 do
       begin
          if TryStrToFloat(LV[i].Expression,f1,G_FMT) = true then     //SubstParam
          begin
            ND1.VFP[i]:=f1;
          end
          else
          begin
            F_ErrorCode:=E_INCORRECT_ARGUMENT;
            F_SyntaxErrorString:=F_CurrentString;
            SetLength(LV1,0);
            SetLength(ND1.VFP,0);
            goto endp;
          end;
       end;

       SetLength(LV1,1);
       LV1[0].Expression:=Copy(LV[High(LV)].Expression,1,Length(LV[High(LV)].Expression));
       EOFN:=False;
       ND1.N:=1;       {.223}
       ND1.EI:=3;
      goto endp;
   end
   else    //poly(x,3,5,7,9,11,15,17,19)
   if TryStrToFloat(LV[High(LV)].Expression,f1,G_FMT) = true then     //SubstParam
   begin

       SetLength(ND1.VFP,Length(LV)-1);
       for i := 0 to Length(LV)-2 do
       begin
          if TryStrToFloat(LV[i+1].Expression,f1,G_FMT) = true then      //SubstParam
          begin
            ND1.VFP[i]:=f1;
          end
          else
          begin
            F_ErrorCode:=E_INCORRECT_ARGUMENT;
            F_SyntaxErrorString:=F_CurrentString;
            SetLength(LV1,0);
            SetLength(ND1.VFP,0);
            goto endp;
          end;
       end;

       SetLength(LV1,1);
       LV1[0].Expression:=Copy(LV[0].Expression,1,Length(LV[0].Expression));
       ND1.N:=1;        {.223}
       EOFN:=False;
       ND1.EI:=3;
      goto endp;

   end
   else
   begin
      F_ErrorCode:=E_INCORRECT_ARGUMENT;
      F_SyntaxErrorString:=F_CurrentString;
      goto endp;
   end;

end
else
begin
   F_ErrorCode:=E_INCORRECT_ARGUMENT;
   F_SyntaxErrorString:=F_CurrentString;
  goto endp;
end;

 endp:
end;



procedure TForevalH.POLYDIFFAnalizator(LV: PLevel; ND: TDataNode;  var LV1: PLevel; var ND1: TDataNode; var EOFN: boolean);
label endp;
var
ni,VT1,VT2,nm1,nm2,L,nt,nfc,nf,P: Integer;
A,B: TFloatType;
PN: TMass2;
Sp: String;
adrV1,adrV2: TAddress;                   //polynomdiff(ad,x,n)  ,polynomdiff(ad,expr,n)
begin
 //LV1:=LV;
 ND1:=ND;
 L:=Length(LV);

if   (L <> 3) then
begin
   F_ErrorCode:=E_INCOINCIDENCE_NUMBER_ARGUMENTS;
   F_SyntaxErrorString:=F_CurrentString;
  goto endp;
end;

 FindVarB(LV[0].Expression,nm1,VT1);

 if (VT1  <> _ArrayS) and (VT1  <> _ArrayE) and (VT1  <> _ArrayD) and (VT1  <> _ArrayI)  then
 begin
   F_ErrorCode:=E_INCORRECT_ARGUMENT;
   F_SyntaxErrorString:=F_CurrentString;
   goto endp;
 end;

 adrV1:=VarList[nm1].Addr;

 {.213}
{
 FindVarB(LV[1].Expression,nm2,VT2);  //expr,var

 if (VT2  <> _Single) and (VT2  <> _Extended) and (VT2  <> _Double) and (VT2  <> _Integer)  then
 begin
   F_ErrorCode:=E_INCORRECT_ARGUMENT;
   F_SyntaxErrorString:=F_CurrentString;
   goto endp;
 end;

 adrV2:=VarList[nm2].Addr;
}



 {.203}
 if TryStrToInt(LV1[2].Expression,P) = false then
 begin
  P:=-1;
 end;

 if (P = 1) or (P = 2) or (P = 3) then
 begin
   ND1.Code:=C_POLYDIFF;
   ND1.AdrV1:=AdrV1;
   //ND1.AdrF1:=AdrV2;      {.213}
   ND1.DI:=P;
   ND1.BI:=VT1;
   ND1.N:=1;
   //ND1.CI:=VT2;        {.213}
   SetLength(LV1,1);
   LV1[0].Expression:=Copy(LV[1].Expression,1,Length(LV[1].Expression));
   EOFN:=False;
   (* {.213}
   EOFN:=True;
   LV1:=nil;
   *)
 end
 else
 begin
   //SetLength(LV1,3);
   LV1:=LV;
   SetLength(LV1,4);
   LV1[3].Expression:=IntToStr(VT1);
   ND1.N:=4;
   ND1.Code:=C_POLYDIFFN;
   EOFN:=False;
 end;

 endp:
end;


//xxx
procedure TForevalH.IFAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode);
label 1,endp;
var
br,Neg: Integer;
i,P,L,P1,P2: Integer;
nf: Integer;
FD1,FD2: extended;
Str,Str1,Str2: String;
adr: Cardinal;
argt1,ni1,AI1,BI1,argt2,ni2,AI2,BI2: Integer;
BH: Boolean;
begin
//IF(Arg1 op Arg2, Arg3, Arg4)  => if Arg1 op Arg2 then Arg3 else Arg4  op: =, <, >, <=, =<, >=, =>
//IF      IFNOP(Arg1,Arg2,CJMP,Arg3,JMP,ARG4)

//IF(Arg1 op Arg2)  = 1  0( if  )  op: =, <, >, <=, =<, >=, =>
//IF      IFNOP(Arg1,Arg2,CJMP,FLD1,JMP,FLDZ)

//IF(Arg1 op Arg2, Arg3)  = Arg3( if  )  0( if  )  op: =, <, >, <=, =<, >=, =>
//IF      IFNOP(Arg1,Arg2,CJMP,ARG3,JMP,FLDZ)

if F_ErrorCode <> 0 then goto endp;

LV1:=LV;
ND1:=ND;
L:=Length(LV);
ND1.FI:=0;   ND1.DI:=0;  ND1.BI:=0;

if ((L <> 3) and (L <> 1) and (L <> 2)) then
begin
  F_ErrorCode:=E_INCOINCIDENCE_NUMBER_ARGUMENTS;
  goto endp;
end;

//nf= 1       2      3       4      5      6     7
//  #JMP, #JMPE, #JMPEL, #JMPEB, #JMPB, #JMPL, #JMPNE

br:=0;  nf:=0;
Str:=LV[0].Expression;
FindExternalBracket(Str,Str,Neg);
if Neg <> 0  then
begin
  F_ErrorCode:=E_INCOINCIDENCE_NUMBER_ARGUMENTS;
  goto endp;
end;


for i := 1 to Length(Str) do
begin
 if (Str[i] = '(') or (Str[i] = '[') or (Str[i] = '{') then  br:=br+1 else
 if (Str[i] = ')') or (Str[i] = ']') or (Str[i] = '}') then  br:=br-1;

 if br = 0 then
 begin
   //>= , =>
   if ((Str[i] = '>') and (Str[i+1] = '=')) or ((Str[i] = '=') and (Str[i+1] = '>')) then
   begin
     nf:=6;  Str1:=Copy(Str,1,i-1); Str2:=Copy(Str,i+2,Length(Str)-i);
     goto 1;
   end
   else
   //<=, =<
   if ((Str[i] = '<') and (Str[i+1] = '=')) or ((Str[i] = '=') and (Str[i+1] = '<')) then
   begin
     nf:=5; P:=i;  Str1:=Copy(Str,1,i-1); Str2:=Copy(Str,i+2,Length(Str)-i);
     goto 1;
   end
   else
   //<>
   if ((Str[i] = '<') and (Str[i+1] = '>')) then
   begin
     nf:=2; P:=i;  Str1:=Copy(Str,1,i-1); Str2:=Copy(Str,i+2,Length(Str)-i);
     goto 1;
   end
   else
   // =
   if (Str[i] = '=') then
   begin
     nf:=7;  P:=i;    Str1:=Copy(Str,1,i-1); Str2:=Copy(Str,i+1,Length(Str)-i);
     goto 1;
   end
   else
   // >
   if (Str[i] = '>') then
   begin
     nf:=3; P:=i;    Str1:=Copy(Str,1,i-1); Str2:=Copy(Str,i+1,Length(Str)-i);
     goto 1;
   end
   else
   // <
   if (Str[i] = '<') then
   begin
     nf:=4; P:=i;   Str1:=Copy(Str,1,i-1); Str2:=Copy(Str,i+1,Length(Str)-i);
     goto 1;
   end
 end;
end;


1:
if (nf = 0) and (L = 3) then             //if(arg1,agr2,arg3) ->  if(arg1 > 0,agr2,arg3)
begin
  nf:=3; Str1:=Str; Str2:='0';
end
else
if (nf = 0) and (L = 1) then            //if(arg1) ->  if(arg1 > 0)
begin
  nf:=3; Str1:=Str; Str2:='0';
end
else
if (nf = 0) and (L = 2) then            //if(arg1,arg2) ->  if(arg1 > 0,arg2)
begin
  nf:=3; Str1:=Str; Str2:='0';
end
else
if nf = 0 then
begin
  F_ErrorCode:=E_MISSING_EXPRESSION;
  goto endp;
end;

if L = 2 then
begin
 P:=Pos('goto(',LV[1].Expression);

 if {P > 0} P = 1 then  {.235}
 begin
     SetLength(LV1,4);
     //IFNOP(Arg1,Arg2,CJMP,JMP)

     LV1[0].Expression:=Copy(Str1,1,Length(Str1));
     LV1[1].Expression:=Copy(Str2,1,Length(Str2));
     case nf of
      2: LV1[2].Expression:='#jmpe';
      3: LV1[2].Expression:='#jmpel';
      4: LV1[2].Expression:='#jmpeb';
      5: LV1[2].Expression:='#jmpb';
      6: LV1[2].Expression:='#jmpl';
      7: LV1[2].Expression:='#jmpne';
     end;
     LV1[3].Expression:=Copy(LV[1].Expression,1,Length(LV[1].Expression));
   //LV1[3].Expression:='#JMP';
   //LV1[5].Expression:='#FLDZ';

     ND1.FI:=2;                     //if(arg,goto())
     ND1.DI:=1;                     //if(arg,goto())    {.235}
     ND1.N:=4;
     ND1.code:=C_IFNOP;
     goto endp;
   end;

end;


SetLength(LV1,6);

if L = 3 then    //IFNOP(Arg1,Arg2,CJMP,Arg3,JMP,ARG4)
begin
 LV1[0].Expression:=Copy(Str1,1,Length(Str1));
 LV1[1].Expression:=Copy(Str2,1,Length(Str2));
 case nf of
   2: LV1[2].Expression:='#jmpe';
   3: LV1[2].Expression:='#jmpel';
   4: LV1[2].Expression:='#jmpeb';
   5: LV1[2].Expression:='#jmpb';
   6: LV1[2].Expression:='#jmpl';
   7: LV1[2].Expression:='#jmpne';
 end;
 LV1[3].Expression:=Copy(LV[1].Expression,1,Length(LV[1].Expression));
 LV1[4].Expression:='#jmp';
 LV1[5].Expression:=Copy(LV[2].Expression,1,Length(LV[2].Expression));

 {.235}
 P1:=Pos('goto(',LV[1].Expression);
 P2:=Pos('goto(',LV[2].Expression);

 if ((P1 = 1) and (P2 = 0)) or ((P1 = 0) and (P2 = 1)) then
 begin
   //if(<cond>,goto(),<expr>)
   //if(<cond>,<expr>,goto())
   F_ErrorCode:=E_INCORRECT_ARGUMENT;
   goto endp;
 end;

 if (P1 = 1) or (P2 = 1) then ND1.DI:=2;                     //if(arg,goto(),goto())    {.235}

end
else
if L = 1 then      //IFNOP(Arg1,Arg2,CJMP,FLD1,JMP,FLDZ)
begin
 LV1[0].Expression:=Copy(Str1,1,Length(Str1));
 LV1[1].Expression:=Copy(Str2,1,Length(Str2));
 case nf of
   2: LV1[2].Expression:='#jmpe';
   3: LV1[2].Expression:='#jmpel';
   4: LV1[2].Expression:='#jmpeb';
   5: LV1[2].Expression:='#jmpb';
   6: LV1[2].Expression:='#jmpl';
   7: LV1[2].Expression:='#jmpne';
 end;
 LV1[3].Expression:='#fld1';
 LV1[4].Expression:='#jmp';
 LV1[5].Expression:='#fldz';
end
else
if L = 2 then      //IFNOP(Arg1,Arg2,CJMP,ARG3,JMP,FLDZ)
begin
  LV1[0].Expression:=Copy(Str1,1,Length(Str1));
  LV1[1].Expression:=Copy(Str2,1,Length(Str2));
  case nf of
   2: LV1[2].Expression:='#jmpe';
   3: LV1[2].Expression:='#jmpel';
   4: LV1[2].Expression:='#jmpeb';
   5: LV1[2].Expression:='#jmpb';
   6: LV1[2].Expression:='#jmpl';
   7: LV1[2].Expression:='#jmpne';
 end;
 LV1[3].Expression:=Copy(LV[1].Expression,1,Length(LV[1].Expression));
 LV1[4].Expression:='#jmp';
 LV1[5].Expression:='#fldz';
end;


ND1.N:=6;
//ND1.COP:=_FUNC;
ND1.code:=C_IFNOP;

endp:
end;

procedure   TForevalH.FindCMPArg(S1,S2: String; ND: TDataNode; var ND1: TDataNode; var BH: Boolean);
label endp;
var
PN1,PN2: TMass2;
FIN1,FIN2: TFIN;
A1,B1,A2,B2: TFloatType;
ni1,ni2: integer;
begin

ND1:=ND;
FindFIAV(S1,ni1,FIN1,A1,B1,PN1);
FindFIAV(S2,ni2,FIN2,A2,B2,PN2);
//a*x+b:
{if ni = 1 then
begin
 nf:=FIN.F;
 nt:=1;
 goto endp;
end
else}
//a*n+b:
if (ni1 = -1) and (ni2 = -1) then
begin

 if (Trunc(A1) = A1) and (Trunc(B1) = B1) and (Trunc(A2) = A2) and (Trunc(B2) = B2)  then
 begin

   ND1.IV1:= FIN1.I;   ND1.VI1:=Trunc(A1);   ND1.VI2:=Trunc(B1);
   ND1.IV2:= FIN2.I;   ND1.VI3:=Trunc(A2);   ND1.VI4:=Trunc(B2);
   ND1.DI:=1;   //cmp(a1*n1+b1,a2*n2+b2)
   BH:=True;
 end;

 goto endp;
end
else
if (ni1 = -1) and (ni2 = 20) then
begin
  if (Trunc(A1) = A1) and (Trunc(B1) = B1) and (Trunc(PN2.FC) = PN2.FC)   then
 begin

   ND1.IV1:= FIN1.I;   ND1.VI1:=Trunc(A1);   ND1.VI2:=Trunc(B1);
   ND1.IV2:=0;   ND1.VI3:=0;   ND1.VI4:=Trunc(PN2.FC);
   ND1.DI:=2; //cmp(a*n+b,c)
   BH:=True;
 end;
 goto endp;
end;
{else
//a1*x+a2*y+...+a12:
if ni = 21 then
begin
 nt:=3;
 goto endp;
end
else   }
//a1*n+a2*k+...+a5*j+a6:
(*
if ni = 22 then
begin
 IB:=True;
 for i:=0 to High(VarList) do
 begin
  if Trunc(PN.IM[i]) <> PN.IM[i] then IB:=False;
 end;
 if Trunc(PN.FC) <> PN.FC then IB:=False;

 if IB = True then nt:=6
 else nt:=7;

 goto endp;
end;
*)

endp:
end;






procedure TForevalH.FindFact2Symb(S1: String; var S2: String);
label 1,2,endp;
var
Sa: String;
pb,bb,b,i,pb1,p,sb: TIntegType;
begin
//  fact   A!!,(A)!!  fact2(A)

2:
p:=pos('!!',S1);
if p = 0  then goto endp;

b:=0; pb:=0;  sb:=0;
for i:=p downto 1 do
begin
 if (b = 0) and (S1[i] = '(') then begin pb:=i+1; goto 1; end else

 if S1[i] = ')' then b:=b-1 else
 if S1[i] = '(' then b:=b+1 else
 if S1[i] = ']' then sb:=sb-1 else
 if S1[i] = '[' then sb:=sb+1;


 if (b = 0) and  (sb = 0) and  ((S1[i] = '*') or (S1[i] = '/') or (S1[i] = '+') or
    (S1[i] = '-') or (S1[i] = '^') or (S1[i] = ',') or (S1[i] = '&'))   then  begin pb:=i+1; goto 1; end
    else
    if (S1[i] = '[') and (sb = 1) then   begin pb:=i+1; goto 1; end
end;


1:
if pb = 0 then pb:=1;
delete(S1,p,2);
insert(')',S1,p);
insert('fact2(',s1,pb);
goto 2;

//((n+1)!!-n!!*(n+2)!!)
//((n)!!+sin(x)!!+(cos(x!!)!!))
//vd[x]+[vd[x]!!]+[vd[x!!+1]!!]+[vd[x!!]!!]!!+x
endp:
S2:=Copy(S1,1,Length(S1));
end;




procedure TForevalH.FindFactSymb(S1: String; var S2: String);
label 1,2,endp;
var
Sa: String;
pb,bb,b,i,pb1,p,sb: TIntegType;
begin
//  fact   A!,(A)!  fact(A)
//vd[x]+[vd[x]!]+[vd[x!+1]!]+[vd[x!]!]!+x
2:
p:=pos('!',S1);
if p = 0  then goto endp;

b:=0; pb:=0; sb:=0;
for i:=p downto 1 do
begin
 if (b = 0) and (S1[i] = '(') then begin pb:=i+1; goto 1; end else

 if S1[i] = ')' then b:=b-1 else
 if S1[i] = '(' then b:=b+1 else
 if S1[i] = ']' then sb:=sb-1 else
 if S1[i] = '[' then sb:=sb+1;


 if (b = 0) and  (sb = 0) and ((S1[i] = '*') or (S1[i] = '/') or (S1[i] = '+') or
    (S1[i] = '-') or (S1[i] = '^') or (S1[i] = ',') or (S1[i] = '&') {or ((S1[i] = '[') and (sb = 1))} )   then  begin pb:=i+1; goto 1; end
    else
    if (S1[i] = '[') and (sb = 1) then   begin pb:=i+1; goto 1; end

end;

//[vd[x!]!]!
1:
if pb = 0 then pb:=1;
delete(S1,p,1);
insert(')',S1,p);
insert('fact(',s1,pb);
goto 2;


endp:
S2:=Copy(S1,1,Length(S1));
end;



procedure TForevalH.ReplacePowerSymb(S1: String; var S2: String);
{
      "|"   "!"
}
label lArg2,lRepl,lFind,lEndp;      //replace: expr1^expr2 -> power(expr1,expr2)
const
 cRound: integer =  1;
 cSquare: integer = 2;
 cCurly: integer  = 3;
 FrontList: set of  Char = ['(','{','[','*','/','>','<','=','+','^','-',',',';','&'];
 BackList:  set of  Char = [')','}',']','*','/','>','<','=','+','^','-',',',';','&'];
 FrontBr: set of  Char = ['(','{','['];
 BackBr:  set of  Char = [')','}',']'];
 OpList:    set of  Char = ['*','/','>','<','=','+','^','-',',',';','&'];
var
 i,LS,PP,PP1,PP2: integer;
 brR,brC,brS,brFr,brBk: integer;
 St,Sa1,Sa2: String;
begin


St:=S1;

lFind:
PP:=Pos('^',St);
if PP = 0 then goto lEndp;

brR:=0; brC:=0; brS:=0;   brFr:=0; brBk:=0;

LS:=Length(St);  PP1:=1; PP2:=LS;

if St[PP-1] = ')' then  brFr:=cRound else
if St[PP-1] = ']' then  brFr:=cSquare else
if St[PP-1] = '}' then  brFr:=cCurly ;
if St[PP+1] = '(' then  brBk:=cRound else
if St[PP+1] = '[' then  brBk:=cSquare else
if St[PP+1] = '{' then  brBk:=cCurly ;

//find arg1
for i := PP-1 downto  1 do
begin
  if St[i] = '(' then inc(brR) else
  if St[i] = ')' then dec(brR) else
  if St[i] = '[' then inc(brS) else
  if St[i] = ']' then dec(brS) else
  if St[i] = '{' then inc(brC) else
  if St[i] = '}' then dec(brC) ;

  if (brR = 0) and (brS = 0) and (brC = 0) then
  begin

    if (St[i] in FrontBr) and (brFr <> 0) then
    begin
      if (i >=2) and (St[i-1] in FrontList) then     // op (...)^  ; br (...)^;
      begin
        PP1:=i;  goto lArg2;
      end;
      //else op Func(...)^
      //PP1:=i; goto lArg2;
    end
    else
    if (St[i] in FrontList)  then     // op Var,Num ^  ;
    begin
      PP1:=i+1; goto lArg2;
    end
    else
    if (i >=2) and (St[i-1] in FrontBr) then      // br Var,Num ^  ;
    begin
       PP1:=i; goto lArg2;
    end;

  end;

end;

//find arg2
lArg2:
brR:=0; brC:=0; brS:=0;
for i := PP+1 to  LS do
begin
  if St[i] = '(' then inc(brR) else
  if St[i] = ')' then dec(brR) else
  if St[i] = '[' then inc(brS) else
  if St[i] = ']' then dec(brS) else
  if St[i] = '{' then inc(brC) else
  if St[i] = '}' then dec(brC) ;

  if (brR = 0) and (brS = 0) and (brC = 0) then
  begin

     if (St[i] in BackBr)  and (brBk <> 0) then
     begin
       PP2:=i; goto lRepl;
     end
     else
     if (St[i] in OpList)  then
     begin
       PP2:=i-1; goto lRepl;
     end
     else
     if (i < LS) and (St[i+1] in BackBr) then
     begin
        PP2:=i; goto lRepl;
     end;

  end;

end;

lRepl:
Sa1:=Copy(St,PP1,PP-PP1);
Sa2:=Copy(St,PP+1,PP2-PP);

Delete(St,PP1,PP2-PP1+1);
Insert('power('+Sa1+','+Sa2+')',St,PP1);
goto lFind;



St:=S1;

lEndp:
S2:=St;
end;




procedure TForevalH.XchangeAddingBracket(S: String; var S1: String);
var
i: TIntegType;
begin
S1:=Copy(S,1,Length(S));
for i:=1 to Length(S1) do
 begin
  if   (S1[i] = '{') or (S1[i] = '[') then
   begin Delete(S1,i,1); Insert('(',S1,i); end;
  if   (S1[i] = '}') or (S1[i] = ']') then
   begin Delete(S1,i,1); Insert(')',S1,i); end;
 end;
end;








procedure TForevalH.replaceAndOr(S: String;  var S1: String);
{
 boolean     boolean IF  (   ,   )
(exp1) and (expr2) and (expr3)-> if(expr1)*if(expr2)*if(expr2)
(exp1) or  (expr2) or  (expr3)-> if(expr1)+if(expr2)+if(expr3)
}

      procedure insIf(S: String; P,N: Integer; var S1: String);
      label endp;
      var
      i,br: integer;
      begin
            br:=0;
            for i := P downto 1 do
            begin
               if (S[i] = '(') or (S[i] = '[') or (S[i] = '{') then  br:=br+1 else
               if (S[i] = ')') or (S[i] = ']') or (S[i] = '}') then  br:=br-1;

               if br = 0 then
               begin
                if (i > 2) {.243} and (S[i-1] <> 'f') and (S[i-2]<> 'i') then
                begin
                  insert('if',S,i);
                  Delete(S,P+3,N);
                  if N=3 then Insert('*if',S,P+3) else
                   if N=2 then Insert('+if',S,P+3);
                end
                else
                begin
                 Delete(S,P+1,N);
                 if N=3 then Insert('*if',S,P+1) else
                  if N=2 then Insert('+if',S,P+1);
                end;
                S1:=S;
                goto endp;
               end;

            end;

      endp:
      end;


label 1, endp;
var
PA,PO: Integer;
begin

1:
PA:=pos(')and(',S);  PO:=pos(')or(',S);

if (PA <> 0) or (PO <> 0) then
begin

 if (PA <> 0) and (PO <> 0) then
  begin
    if PA < PO then  InsIf(S,PA,3,S)
    else InsIf(S,PO,2,S);
  end
 else
 if (PA <> 0) then
 begin
   InsIf(S,PA,3,S);
 end
 else
 if PO <> 0 then
 begin
   InsIf(S,PO,2,S);
 end;

 goto 1;
end;

S1:=S;
end;



procedure TForevalH.replaceAndOrSKIP(S: String;  var S1: String);
{
 boolean     '' IF 
(arg1)and(arg2)         -> if(arg1,if(arg2))
(arg1)and(arg2)and(arg) ->  if(arg1,if(arg2,if(arg3)))
...
(arg1)or(arg2)          -> if(arg1,1,if(arg2))
(arg1)or(arg2)or(arg)   ->  if(arg1,1,if(arg2,1,if(arg3)))
...
}
        procedure _ReplAndOrSKIP(S1,SC: String; var S2: String);
        label endp,nxtlev,rpl,nxtarg;
        var
         i: integer;
         PA,P,P1,C1,C2,C3: integer;
         S,Sins,FS:String;
         br,Cr,indx,LS: integer;
         SLst: array of  String;
         PLst: array of Integer;
        begin
        S:=S1;

        nxtlev:
        LS:=Length(SC);
        FS:=')'+SC+'(';
        P:=pos(FS,S);
        if P = 0 then goto endp;

        SetLength(PLst,0); SetLength(SLst,0);

           br:=0;
           //        ()op1()op1()op2()op2()op1()
           for i := P downto 1 do
           begin
             if (S[i] = '(') or (S[i] = '[') or (S[i] = '{') then  br:=br+1 else
             if (S[i] = ')') or (S[i] = ']') or (S[i] = '}') then  br:=br-1;

             if br = 0 then
             begin
              if (i > 2)  and (S[i-1] ='f') and (S[i-2] = 'i') then
              begin
                 P1:=i-2;
              end
              else
                P1:=i;

              SetLength(PLst,Length(PLst)+1);
              PLst[High(PLst)]:=P1;
              goto nxtarg;

             end;
           end;

        nxtarg:
           //     
           br:=1;  i:=P;
           while i <= Length(S) do
           begin

             if (S[i] = '(') or (S[i] = '[') or (S[i] = '{') then  br:=br+1 else
             if (S[i] = ')') or (S[i] = ']') or (S[i] = '}') then  br:=br-1;

              if br = 0 then
              begin

                if i = Length(S) then
                begin
                   SetLength(PLst,Length(PLst)+1);
                   PLst[High(PLst)]:=i;
                   goto rpl;
                end
                else
                if  (i < Length(S)) and ((S[i+1] = ')') or (S[i+1] = ',') or (S[i+1] = ';')) then
                begin
                   SetLength(PLst,Length(PLst)+1);
                   PLst[High(PLst)]:=i;
                   goto rpl;
                end
                else
                if (i < Length(S)-LS) and (Copy(S,i+1,LS) = SC)  and  (S[i+LS+1] = '(') then      //if next op also SC
                begin
                  SetLength(PLst,Length(PLst)+1);
                  PLst[High(PLst)]:=i;
                  i:=i+LS;
                end
                else
                if S[i] = ')' then
                begin
                   SetLength(PLst,Length(PLst)+1);
                   PLst[High(PLst)]:=i;
                   goto rpl;
                end

              end;

             inc(i);
           end;


        rpl:
        if Length(PLst) > 0 then
        begin

          SetLength(SLst,Length(PLst)-1);

          SLst[0]:=Copy(S,PLst[0],PLst[1]-PLst[0]+1);
          for i := 1 to High(SLst)-1 do
          begin
           SLst[i]:=Copy(S,PLst[i]+LS+1,PLst[i+1]-PLst[i]-LS);
          end;

          C1:=PLst[High(PLst)] ;C2:=PLst[High(PLst)-1];  C3:= PLst[High(PLst)-1]+LS+1;
          SLst[High(SLst)]:=Copy(S,C3,C1-C3+1);

          Cr:=High(SLst);
          Sins:='if('+SLst[High(SLst)]+')';

          if SC = 'and' then
          begin
            for i := 0 to High(SLst)-1 do
            begin
             dec(Cr) ;
             Sins:='if('+SLst[Cr]+','+Sins+')';
            end;
          end
          else
          if SC = 'or' then
            begin
            for i := 0 to High(SLst)-1 do
            begin
             dec(Cr) ;
             Sins:='if('+SLst[Cr]+',1,'+Sins+')';
            end;
          end;



          Delete(S,PLst[0],PLst[High(PLst)]-PLst[0]+1);
          Sins:='('+Sins+')';
          Insert(Sins,S,Plst[0]);
        end;


        goto nxtlev;

        endp:
        S2:=S;
        end;

begin
  _ReplAndOrSKIP(S,'and',S1);  // 'and'  'or'
  _ReplAndOrSKIP(S1,'or',S1);
end;





procedure TForevalH.ReplaceFuncIntPart(S,SF: String; var S1: String);
label 1,2,3,endp;
var
EnName: set of  Char;
i,p,k,N,P1,br,m,f,L,LS: Integer;
SP,SL: String;
begin
EnName:=['(','{','[','|','*','/','>','<','=','+','^','-',',',';'];

P:=1;
L:=Length(SF);
1:
SL:=S;
P1:=posEx(SF,SL,P);
if P1 = 0 then goto endp;
if P1 > 1 then if (S[P1-1] in  EnName = False)  then begin P:=P+L; goto 1; end;
P:=P1;
LS:=Length(S);

2:
k:=0;   F:=0;
 for I := p+L to Length(S) do
   begin
     if S[i] = '(' then
     begin

       SP:=Copy(S,p+L,k);
       //if SP <> '' then

         {.203}
         if TryStrToInt(SP,N) = true then
         begin
            N:=StrToInt(SP);

            br:=0; m:=i;

           repeat

             if S[m] = '(' then br:=br+1
              else
             if S[m] = ')' then br:=br-1;

             if (br = 1) and (S[m] = ',') then begin   P:=P+L; goto 3;   end;

             inc(m);
             if (m > LS) and (br <> 0)  then begin  F:=2; goto 3; end;

           until br = 0;

           Insert(','+SP,S,m-1);
           Delete(S,P+L,K);

           3:
         end
         else
         F:=1;

         {
         try
           N:=StrToInt(SP);


           br:=0; m:=i;

           repeat

             if S[m] = '(' then br:=br+1
              else
             if S[m] = ')' then br:=br-1;

             if (br = 1) and (S[m] = ',') then begin   P:=P+L; goto 3;   end;

             inc(m);
             if (m > LS) and (br <> 0)  then begin  F:=2; goto 3; end;

           until br = 0;

           Insert(','+SP,S,m-1);
           Delete(S,P+L,K);

          3:
         except
           F:=1;
         end;
         }

         if F=2 then goto endp;

         P:=P+L; goto 1;
     end;
     inc(k);
   end;


endp:
S1:=S;
end;




procedure TForevalH.ReplaceSecCosec(S,SF,SFR: String; var S1: String);
label 1,2,3,endp;
var
EnName: set of  Char;
i,p,k,N,P1,br,m,f,L,LS: Integer;
SP,SL: String;
begin                      //SF(arg)->(1/SFR(arg))
EnName:=['(','{','[','|','*','/','>','<','=','+','^','-',',',';'];
//SF:='sec';
//SFR1:='1/'+SFR;
P:=1;
L:=Length(SF)-1;     //func(

1:
SL:=S;
P1:=posEx(SF,SL,P);
if P1 = 0 then goto endp;

if P1 > 1 then if (S[P1-1] in  EnName = False)  then begin P:=P+L; goto 1; end;
P:=P1;
LS:=Length(S);
k:=p+L;

2:
br:=0;
for i := k to LS do
   begin

   if S[i] = '(' then br:=br+1 else
   if S[i] = ')' then br:=br-1;

   if br = 0 then
   begin
    Insert(')',S,i+1);
    Insert('(',S,P);
    Delete(S,P+1,L);
    Insert(SFR,S,P+1);

    P:=P+L; goto 1;
   end;

end;




endp:
S1:=S;
end;

(*
procedure TForevalH.ReplaceIff(S1: String; var S2: String);
label 1,2;
var
p,cp: integer;
SL: String;
begin
cp:=1;
1:
SL:=LowerCase(S1);
p:=posEx('iff(',SL,cp);

if p <> 0 then
begin
 Delete(S1,p+1,1); cp:=cp+2;
 goto 1;
end;


cp:=1;
2:
SL:=LowerCase(S1);
p:=posEx('ifp(',SL,cp);

if p <> 0 then
begin
 Delete(S1,p+2,1); cp:=cp+2;
 goto 1;
end;


S2:=S1;
end;
*)




procedure TForevalH.FindExternalBracketA(S: String; var SS: String);
label 1,endp;
var
b,i,z,a:Integer;
begin
SS:=Copy(S,1,Length(S));



1:
if SS = '' then
begin
goto endp;
end;

if (SS[1] = '(') and (SS[Length(SS)] = ')') then
begin
  b:=-1;
  for i:=2 to Length(SS)-1 do
  begin
   if SS[i] = '(' then b:=b-1;
   if SS[i] = ')' then b:=b+1;

   if b = 0 then goto endp;
  end;

 Delete(SS,Length(SS),1);
 Delete(SS,1,1);
 goto 1;
end;




endp:
end;





procedure TForevalH.FindExternalBracketAP(PS: PString);
label 1,endp;
var
b,i,z,a:Integer;
begin
//SS:=Copy(S,1,Length(S));



1:
if PS^ = '' then
begin
goto endp;
end;

if (PS^[1] = '(') and (PS^[Length(PS^)] = ')') then
begin
  b:=-1;
  for i:=2 to Length(PS^)-1 do
  begin
   if PS^[i] = '(' then b:=b-1;
   if PS^[i] = ')' then b:=b+1;

   if b = 0 then goto endp;
  end;

 Delete(PS^,Length(PS^),1);
 Delete(PS^,1,1);
 goto 1;
end;




endp:
end;




function TForevalH.CheckToZero(S: String): Boolean;
label
2,3,endp;
var
b,i,z,a:TIntegType;
BRes: Boolean;
begin
//SS:=Copy(S,1,Length(S));

BRes:=False;

z:=1;
2:
b:=0; a:=1;

if S = '' then
begin
goto endp;
end;


if S[1] = '-' then a:=2;

if  S[a] = '(' then
begin
 b:=-1;
 for i:=a+1 to Length(S)-1 do
 begin
  if S[i] = '(' then b:=b-1;
  if S[i] = ')' then b:=b+1;
  if b = 0 then goto 3
 end;


 if S[Length(S)] = ')' then
 begin
  if a = 2 then
  begin
   Delete(S,1,1);
   z:=z*(-1);
  end;
  Delete(S,1,1);
  Delete(S,Length(S),1);
  goto 2;
 end;
end;

3:
{if z = -1 then  Neg:=1
else  Neg:=0; }
if S = '0' then BRes:=True;

CheckToZero:=BRes;

endp:
end;



procedure  TForevalH.ConvToAtn2(S1: String; var S2: String);
label endp,nxt;

  procedure   FindAtn2Arg(Sa: String;  var Sa1,Sa2: String; var BH: Boolean);
  label rep,endp;
  var
     i,bp,pd,cp: integer;
     pps,ppd: Boolean;
  begin


     FindExternalBracketA(Sa,Sa);
     //FindExternalBracketAP(@Sa);

     BH:=False;
     bp:=0; pd:=0;   pps:=false; {+,-,*}  ;ppd:=false; {/}
     for i := 1 to Length(Sa)  do
     begin
        if (Sa[i] = '(') or  (Sa[i] = '[') or (Sa[i] = '{') then inc(bp)
        else
        if (Sa[i] = ')') or  (Sa[i] = ']') or (Sa[i] = '}') then dec(bp)
        else
        if (bp = 0) and ((Sa[i] = '+') or  ((Sa[i] = '-') and (i > 1)) or (Sa[i] = '*'))  then    //arctan(-x/y)
        begin
          pps:=true; goto endp;
        end
        else
        if (bp = 0) and  (Sa[i] = '/') and (ppd = false) then
        begin  ppd:=true; pd:=i; {Sa1:=Copy(Sa,1,i); Sa2:=Copy(Sa,i,Length(Sa)-i); BH:=True; goto endp;} end;
     end;

     if ppd = true then
     begin
       Sa1:=Copy(Sa,1,pd-1); Sa2:=Copy(Sa,pd+1,Length(Sa)-pd); BH:=True;
     end;

  endp:
  end;


var

  Sn,Sa1,Sa2: String;
  Ps,Pa,cp,bp: Integer;
  i,j,Lf,LFL,k: Integer;
  BH: Boolean;
begin


LFL:=Length(FuncList[C_ARCTAN].Name);

if F_SyntaxExtension = False then LFL:=2;

for k := 1 to LFL - 1 do
begin
 Ps:=Pos(FuncList[C_ARCTAN].Name[k]+'(',S1);
 if Ps <> 0 then  goto nxt;
end;
goto endp;

//work very slowly ?!?!:
nxt:
for k := 1 to LFL - 1 do
begin

  //Sn:='arctan'+'('; //

  Sn:= FuncList[C_ARCTAN].Name[k];
  Sn:=Sn+'(';
  Lf:=Length(Sn)-1;
  Ps:=1;

  //S1:='arctan(((((x)/y)/(t))))';
  //S1:='arctan((x/y/t))';
  //S1:='x+arctan(x/y)+y';
  //S1:='arctan([x/y])';
  //S1:='x*arctan(x/y)+y*arctan(y/x)*y';
  //S1:='x+arctan(x/arctan(y/arctan(arctan(x+y)/arctan(x-y))))+y';
  //arctan(arctan(x+y)/arctan(x-y))
  //arctan(sin(x+y)/cos(x-y))
  //atan2(-0.98,0.96)
  //arctan2(-0.98173747282675,0.962430184703893)

  //arctan2((x+y),(x-y))

  {
  arctan2((x+y),(x-y))
  vs
  arctan((x+y)/(x-y))
  }

  for i := 1 to Length(S1)  do
  begin
     Ps:=PosEx(Sn,S1,Ps);
     //Ps:=Pos(Sn,S1);

     if Ps <> 0 then
     begin
       cp:=Ps+Lf+1;
       bp:=-1;
       while (bp <> 0) and (cp <= Length(S1)) do
       begin
        if (S1[cp] = '(') or  (S1[cp] = '[') or (S1[cp] = '{') then dec(bp)
        else
        if (S1[cp] = ')') or  (S1[cp] = ']') or (S1[cp] = '}') then inc(bp);

        inc(cp);
       end;

       FindAtn2Arg(Copy(S1,Ps+Lf+1,cp-Ps-Lf-2),Sa1,Sa2,BH);    //arctan((x+y)/(x-y))
       if BH = True then
       begin
         Delete(S1,Ps,cp-Ps);
         Insert('arctan2('+Sa1+','+Sa2+')',S1,Ps);
       end;
     end;

     Ps:=Ps+Length(Sn);
  end;

end;

  S2:=S1;

 endp:
end;




//ffroot5(x)+root5(x,y)+root5(ffroot5(x))+ffroot5(root5(x))
procedure TForevalH.PrevTreat(S: String; var S1: String);
(*     : 

  |expr|->abs(expr);  [expr]->trunc(expr)  ; {expr}->frac(expr);
   expr!!->fact2(expr); expr!->fact(expr);
   (exp1) and (expr2)-> if(expr1)*if(expr2)
   (exp1) or  (expr2)-> if(expr1)+if(expr2)
   expr1^expr2 -> power(expr1,expr2)
   root2(expr), root3(expr),...,rootN(expr)-> root(expr,N)  N -  integer number
   power2(expr), power3(expr),...,powerN(expr)-> power(expr,N)  N -  integer number
   pow2(expr), pow3(expr),...,powN(expr)-> power(expr,N)  N -  integer number

      
*)
label endp;
const
OpSet: set of char = ['*','/','+','-'];
var
b1,b2,i,ba,bs,bc,br,LC,p1,p2: TIntegType;
E: Exception;
begin
F_SyntaxErrorString:=S;
if S = '' then S:='0';

if F_SyntaxExtension = True then
begin                     //    (sequnce not to change)
 ReplaceAbsBr(S,S);   if F_ErrorCode <> 0 then goto endp;
 ReplaceTruncBr(S,S); if F_ErrorCode <> 0 then goto endp;
 ReplaceFracBr(S,S);  if F_ErrorCode <> 0 then goto endp;
 //XchangeAddingBracket(S,S);    {.160}
 FindFact2Symb(S,S);
 FindFactSymb(S,S);
 if F_SkippedIF = True then      {.243}
  ReplaceAndOrSKIP(S,S)    //skipped if
  else
  ReplaceAndOr(S,S);       //complete if
 ReplacePowerSymb(S,S);           {.243}
 ReplaceFuncIntPart(S,'root',S);
 ReplaceFuncIntPart(S,'power',S);
 ReplaceFuncIntPart(S,'pow',S); {.199}
 {ReplaceSecCosec(S,'cosec(','1/sin',S);
 ReplaceSecCosec(S,'sec(','1/cos',S);}
end;

//if F_ConvertAtanToAtan2 = True then  ConvToAtn2(S,S); {.209}


(*else                             {.160}
 XchangeAddingBracket(S,S);}
*)
 //ReplaceIff(S,S);
//[[x-1]+[x+1]]-[x-[x+[x-1]-[x+1]]+y]+ad[(x+1)]
//F_ErrorCode:=0;
b1:=0; b2:=0; ba:=0;  bs:=0; bc:=0;  br:=0;

for i:=1 to Length(S)-1 do
begin

  if ((S[i] = ')') or (S[i] = ']')) and    {.250} // vec[]
     ((S[i+1] <> '*') and  (S[i+1] <> '+') and
     (S[i+1] <> '-') and (S[i+1] <> '/') and (S[i+1] <> '^') and
     (S[i+1] <> '!')  and (S[i+1] <> ',') and (S[i+1] <> ']') and  (S[i+1] <> ')') and
     (S[i+1] <> '&') and (S[i+1] <> '=') and (S[i+1] <> '<' ) and (S[i+1] <> '>'))  then
  begin
    F_ErrorCode:=E_MISSING_OPERATION;      // 

    LC:=7; //
    if i < LC  then  p1:=i else p1:=LC;
    if Length(S)-i < LC then p2:=Length(S)-i else p2:=LC;
    F_SyntaxErrorString:=Copy(S,i-p1+1,p1+p2);

    goto endp;
  end;

  {.250}
  if (S[i] in OpSet) and (S[i+1] in OpSet) then
  begin
    F_ErrorCode:=E_MISSING_EXPRESSION;

    LC:=7; //
    if i < LC  then  p1:=i else p1:=LC;
    if Length(S)-i < LC then p2:=Length(S)-i else p2:=LC;
    F_SyntaxErrorString:=Copy(S,i-p1+1,p1+p2);

    goto endp;
  end;


  if S[i] = '(' then inc(br);
  if S[i] = ')' then dec(br);

  if S[i] = '[' then inc(bs);
  if S[i] = ']' then dec(bs);

  if S[i] = '{' then inc(bc);
  if S[i] = '}' then dec(bc);
end;



if S[Length(S)] = ')' then dec(br);
if S[Length(S)] = ']' then dec(bs);
if S[Length(S)] = '}' then dec(bc);


if br <> 0 then
begin
F_ErrorCode:=E_MISSING_ROUND_BRACKET;
//F_SyntaxErrorString:=Copy(S,1,Length(S));
//raise ESyntaxError.Create('');
end
else
if bs <> 0 then
begin
 F_ErrorCode:=E_MISSING_SQUARE_BRACKET;
end
else
if bc <> 0 then
begin
 F_ErrorCode:=E_MISSING_CURLY_BRACKET;
end;



S1:=Copy(S,1,Length(S));
endp:
end;




procedure TForevalH.PredSyntax(S: String; var ND: TDataNode; var LV: PLevel; var BH: Boolean; var EOFN: Boolean);
label endp;
var
Sh,Arg1,Arg2: String;
a,b: TFloatType;
ni,nt,nf: TIntegType;
PN: TMass2;
begin
//BH = True -  
if F_ErrorCode <> 0 then goto endp;
EOFN:=False;  BH:=False;
InitNode(ND);



Sh:=Copy(S,1,Length(S));
FindArgType(Sh,nt,A,B,nf,ni,PN);
if (nt <> 0) then
begin
EOFN:=True;  BH:=True;
WriteArgData(nt,A,B,ni,nf,PN,ND);
if nt = _FAVB then
begin
if ND.V1 = 0 then
begin
 ND.Code:=C_LDSC;
end
else
if (abs(ND.V1) = 1) and (ND.V2 = 0) then
 begin
  ND.Code:=C_LDSF;
  if ND.V1 = -1 then ND.Neg:=1;
 end
else
begin
 ND.Code:=C_FAVB;
end
end
else
if nt = _AIFB then
begin
ND.Code:=C_AIFB;
end
else
if nt = _AAF then
begin
ND.Code:=C_AAF;
end
else
if nt = _MAF then
begin
ND.Code:=C_MAF;
end
else
if nt = _IAVB then
begin
if (abs(ND.VI1) = 1) and (ND.VI2 = 0) then
 begin
  ND.Code:=C_LDSI;
  if ND.VI1 = -1 then ND.Neg:=1;
 end
else
begin
ND.Code:=C_IAVB;
end
end
else
if nt = _AAI then
begin
ND.Code:=C_AAI;
end
else
if nt = _AFI then
begin
ND.Code:=C_AFI;
end;


goto endp;
end;




//a*func+b:
//if (F_FunctionalOptimizator = True) and (F_PowerOptimizator = True) then
begin
FindFunction(Sh,A,B,Arg1,Arg2,nf,BH);
if BH = True then
begin
 FunctionalAnalizator(nf,A,B,Arg1,Arg2,ND,LV,EOFN);
 goto endp;
end;
end;




endp:
end;




procedure TForevalH.SyntaxAnalizator(S:String; var ND: TDataNode; var LV:PLevel;  var EOFN: Boolean);
//  finding of main comand in subexpression "S" ;  Out: ND - data of main node;  LV: data of all outgoing nodes (all nodes on the same level)
label endp;                                                                    //EOFN=EndOfNode
var
Arg1,Arg2: String;
nf,COP: Integer;
BH: Boolean;
a,b: TFloatType;
begin
if F_ErrorCode <> 0 then goto endp;
//F_CurrentString:=copy(S,1,Length(S));
F_SyntaxErrorString:=S;

TryFPUMask{(@CWMEM5)}; {.249}

EOFN:=False;   BH:=False; InitNode(ND);
 {
if F_Optimization = True then
PredSyntax(S, ND, LV, BH, EOFN);    //fast finding extended arguments ARGF,ARGI or numbers
}

if  BH = False then
begin

 StringAnalizator(S, ND.N, COP, LV, ND.Neg);     //finding main  arifmetic operation (with the same priority)
 ND.Code:=COP;
 if F_ErrorCode = 0  then   {.203}
 begin

   If ND.Code = _NOP then    //if in expression absent arifmetic operations => function or variable or number
   begin
     FindFunction(S,A,B,Arg1,Arg2,nf,BH);
     if BH = True then   FunctionalAnalizator(nf,A,B,Arg1,Arg2,ND,LV,EOFN)
     else                    // if in expression absent function =>  or variable or number
     begin
      NumberAnalizator(LV,ND, LV, ND,EOFN); //package & variables & numbers
     end;
   end
   else   //arifmetic operations
   begin
    OperationalAnalizator(LV,ND,LV,ND,EOFN); //   
   end;

 end;

end;



endp:
TryCatchFPUException{(@CWMEM5)}; {.249}
end;




procedure TForevalH.PkSyntax(S:String; var ND: TDataNode; var LV:PLevel;  var EOFN: Boolean);
label endp;
var
i,k,HL: Integer;
begin
if F_ErrorCode <> 0 then goto endp;
EOFN:=False;
InitNode(ND);

k:=1;
for i:=1 to Length(S) do
begin
 if S[i] = '&' then
 begin
   SetLength(LV,Length(LV)+1);
   HL:=High(LV);
   LV[HL].Expression:=Copy(S,k,i-k);
   Insert('@@PACKAGE(',LV[HL].Expression,1);
   Insert(')',LV[HL].Expression,Length(LV[HL].Expression)+1);
   LV[HL].PkAdr:=PkgData[HL].Adr;
   LV[HL].PkShift:=PkgData[HL].Shift;
   LV[HL].PkRType:=PkgData[HL].RType;
   LV[HL].I:=_NOP;
   k:=i+1;
 end;
end;
 SetLength(LV,Length(LV)+1);
 HL:=High(LV);
 LV[HL].Expression:=Copy(S,k,Length(S));
 Insert('@@PACKAGE(',LV[HL].Expression,1);
 Insert(')',LV[HL].Expression,Length(LV[HL].Expression)+1);
 LV[HL].PkAdr:=PkgData[HL].Adr;
 LV[HL].PkShift:=PkgData[HL].Shift;
 LV[HL].PkRType:=PkgData[HL].RType;
 LV[HL].I:=_NOP;



ND.N:=Length(LV);
ND.Code:=C_NOP;
F_PackageCompile:=False;

endp:
end;



procedure TForevalH.CodeGeneration;
//     - Interp[]
label endp;
var
E: Exception;
begin
if F_ErrorCode <> 0 then goto endp;

LFunc:=1;
//SetLength(Interp,LFunc);   {.207}
SetLength(Interp,LInterp);   {.207}
Tree:=BeginTree; // , ..   - 

while Tree^.Ch <> nil do
begin
Tree:=Tree^.Ch;
end;
//COP=NOP:
WriteCode;

while Tree^.Pr <> nil do
begin

   while Tree^.Nb <> nil  do
   begin
    Tree:=Tree^.Nb;
    while Tree^.Ch <> nil do
    begin
     Tree:=Tree^.Ch;
    end;
    //COP=NOP:
    WriteCode;
   end;

 //COP<>NOP:
 Tree:=Tree^.Pr;
 WriteCode;

end;
//1-   WriteCode 

//SetArrayLoadSource; //{arraycpu} {.245}

endp:


{$IFDEF DEBUGS}
   //dec(LFunc);
   //if (LFunc - 1) <= High(Interp) then  //G_Test1:=Interp[LFunc-1].IdL;//High(Interp);{LFunc-1;}//Interp[LFunc-1].IdL;
   G_Test3:=Interp[LFunc-1].IdL;
   //Interp[LFunc-1].IdL:=0;  //   Length(Interp)  Size(Tree)
{$ENDIF}

end;



procedure TForevalH.SetArrayLoadSource;
var
  i,NM,NL,ArgT: Integer;
begin
{arraycpu} {.245}
//      ,        ( ) ,     FPU
// SetArrayLoadSource

for i := 1 to LFunc - 1 do
begin
  ArgT:=Interp[i].ExtArg;
  if (ArgT = _ArrayD) or (ArgT = _ArrayE) or (ArgT = _ArrayS) or (ArgT = _ArrayI)  then
  begin
    Interp[i].SData:=_MEM;   //    
    NM:=Interp[i].NM;
    NL:=Interp[i].NL;
    Interp[NM].RData[NL-1]:=_MEM;   //        
  end;
end;


end;


function TForevalH.Calc: TFloatType; assembler;
asm
 call [eax+Func.Addr];
end;


procedure TForevalH.WriteCode;
label endp;
var
i: TIntegType;
S: String;
begin
//SetLength(Interp,LFunc+1);    {.207}
WriteDataCode;
{$IFDEF DEBUGS}
   //G_Test1:=G_Test1+Interp[LFunc-1].IdL;
 {$ENDIF}
inc(LFunc);
end;



procedure TForevalH.WriteDataCode;
//write data for current macrocomand
var
fa,i,L,j,TV,ArgT: TIntegType;
S: String;
NM,NL: Integer;
begin



for i:=0 to High(VarList) do
begin
 if Tree^.FV1 = i then Interp[LFunc].FV1:=VarList[i].Addr;
 if Tree^.FV2 = i then Interp[LFunc].FV2:=VarList[i].Addr;
 if Tree^.IV1 = i then Interp[LFunc].IV1:=VarList[i].Addr;
 if Tree^.IV2 = i then Interp[LFunc].IV2:=VarList[i].Addr;
end;




Interp[LFunc].S:=Tree^.Stack.S;
Interp[LFunc].N:=Tree^.Stack.N;
Interp[LFunc].RCS:=0;
Interp[LFunc].Code:=Tree^.Code;

Interp[LFunc].ExtArg:=Tree^.ExtArg;
Interp[LFunc].SExtArg:=Tree^.SExtArg;
Interp[LFunc].PkAdr:=Tree^.PkAdr;
Interp[LFunc].PkShift:=Tree^.PkShift;
Interp[LFunc].PkRType:=Tree^.PkRType;

SetLength(Interp[LFunc].AWCS,0);
SetLength(Interp[LFunc].AFB,0);
SetLength(Interp[LFunc].PN,0);
SetLength(Interp[LFunc].PM,0);
SetLength(Interp[LFunc].PI,0);
SetLength(Interp[LFunc].PC,0);
SetLength(Interp[LFunc].RData,0);


SetLength(Interp[LFunc].SGN,Length(Tree^.SGN));
for i:=0 to High(Tree^.SGN) do
begin
 Interp[LFunc].SGN[i]:=Tree^.SGN[i];
end;

if Length(Tree^.RData) <> 0 then SetLength(Interp[LFunc].RData,Length(Tree^.RData));
for i:=0 to High(Tree^.RData) do
begin
 Interp[LFunc].RData[i]:=Tree^.RData[i];
end;


if Length(Tree^.SNExtArg) <> 0 then SetLength(Interp[LFunc].SNExtArg,Length(Tree^.SNExtArg));
for i:=0 to High(Tree^.SNExtArg) do
begin
 Interp[LFunc].SNExtArg[i]:=Tree^.SNExtArg[i];
end;




Interp[LFunc].EI:=Tree^.EI;
Interp[LFunc].DI:=Tree^.DI;
Interp[LFunc].AI:=Tree^.AI;
Interp[LFunc].BI:=Tree^.BI;
Interp[LFunc].CI:=Tree^.CI;
Interp[LFunc].FI:=Tree^.FI;

Interp[LFunc].F1:=Tree^.F1;
Interp[LFunc].F2:=Tree^.F2;


Interp[LFunc].V1:=Tree^.V1;
Interp[LFunc].V2:=Tree^.V2;

Interp[LFunc].V3:=Tree^.V3;
Interp[LFunc].V4:=Tree^.V4;

Interp[LFunc].VI1:=Tree^.VI1;
Interp[LFunc].VI2:=Tree^.VI2;
Interp[LFunc].VI3:=Tree^.VI3;       
Interp[LFunc].VI4:=Tree^.VI4;

Interp[LFunc].VFP:=Tree^.VFP;          {.223}

Interp[LFunc].I:=0;

// AAF :
if Tree^.DI = _AAF then
begin
fa:=0;
for i:=0 to High(VarList) do
begin

if Tree^.PN.FM[i] <> 0 then
begin
inc(fa);
end;
end;
  begin
   SetLength(Interp[LFunc].PM,fa+1);   SetLength(Interp[LFunc].PN,fa+2);
   j:=0;
   for i:=0 to High(VarList) do
    begin
     if Tree^.PN.FM[i] <> 0 then
      begin
       inc(j);
       Interp[LFunc].PM[j]:=VarList[i].Addr;
       Interp[LFunc].PN[j]:=Tree^.PN.FM[i];
      end;
    end;
   Interp[LFunc].PN[j+1]:=Tree^.PN.FC;

  end;

end;



// MAF :
if Tree^.DI = _MAF then
begin
fa:=0;
for i:=0 to High(VarList) do
begin
if Tree^.PN.FM[i] <> 0 then
begin
inc(fa);
end;
end;
  Interp[LFunc].V1:=Tree^.PN.FC;
  begin
   SetLength(Interp[LFunc].PM,fa+1);
   j:=0;
   for i:=0 to High(VarList) do
    begin
     if Tree^.PN.FM[i] <> 0 then
      begin
       inc(j); Interp[LFunc].PM[j]:=VarList[i].Addr;
      end;
    end;
  end;
end;

//AAF  MAF    


// AAI:
if Tree^.CI = _AAI then
begin
fa:=0;
for i:=0 to High(VarList) do
begin
if Tree^.PN1.IM[i] <> 0 then
begin
inc(fa);
end;
end;
  begin
   SetLength(Interp[LFunc].PI,fa+1);   SetLength(Interp[LFunc].PC,fa+2);
   j:=0;
   for i:=0 to High(VarList) do
    begin
     if Tree^.PN1.IM[i] <> 0 then
      begin
       inc(j); Interp[LFunc].PI[j]:=VarList[i].Addr;
       Interp[LFunc].PC[j]:=Trunc(Tree^.PN1.IM[i]);
      end;
    end;
   Interp[LFunc].PC[j+1]:=Trunc(Tree^.PN1.FC);
  end;

end;


// AFI: (   -  )
if Tree^.DI = _AFI then
begin

fa:=0;
for i:=0 to High(VarList) do
begin
if Tree^.PN.IM[i] <> 0 then
begin
inc(fa);
end;
end;

SetLength(Interp[LFunc].PI,fa+1);
SetLength(Interp[LFunc].PN,fa+2);
j:=0;
 for i:=0 to High(VarList) do
 begin
  if Tree^.PN.IM[i] <> 0 then
  begin
   inc(j); Interp[LFunc].PI[j]:=VarList[i].Addr;
   Interp[LFunc].PN[j]:=Tree^.PN.IM[i];
  end;
 end;
Interp[LFunc].PN[j+1]:=Tree^.PN.FC;


end;


//  MUL:
if Length(Tree^.AFB) > 0 then
begin
 SetLength(Interp[LFunc].AFB,Length(Tree^.AFB));
 for i:=0 to  High(Tree^.AFB) do
 begin
  Interp[LFunc].AFB[i].PF:=VarList[Tree^.AFB[i].nf].Addr;
  Interp[LFunc].AFB[i].A:=Tree^.AFB[i].A;
  Interp[LFunc].AFB[i].B:=Tree^.AFB[i].B;
 end;
end;


if FuncList[Interp[LFunc].Code].CalcConst = _No then F_EnableCalcConstExpression:=False;
if FuncList[Interp[LFunc].Code].RetNum = _No then F_EnableCalcConstExpression:=False;

//S:=Interp[LFunc].Expression;
//S:=Tree^.Expression;


Interp[LFunc].Neg:=Tree^.Neg;
Interp[LFunc].I:=Tree^.I;
Interp[LFunc].NL:=Tree^.NL;
Interp[LFunc].XCHA:=Tree^.XCHA;
Interp[LFunc].SData:=Tree^.SData;
Interp[LFunc].NM:=Tree^.NM;
Interp[LFunc].IdN:=Tree^.IdN;
Interp[LFunc].IdL:=Tree^.IdL;
Interp[LFunc].Code:=Tree^.Code;
Interp[LFunc].Adr:=Tree^.Adr; //lda
Interp[LFunc].AdrV1:=Tree^.AdrV1;
Interp[LFunc].AdrV2:=Tree^.AdrV2;
Interp[LFunc].AdrF1:=Tree^.AdrF1;



Interp[LFunc].Expression:=Tree^.Expression;//Copy(Tree^.Expression,1,Length(Tree^.Expression));
FindExternalBracketAP(@Interp[LFunc].Expression);    {.209} //   :   ReplaceOperation: (x/y)+x/y

Interp[LFunc].ExpressionArg:=Tree^.ExpressionArg;                                                                       //sin((x/y))+cos(x/y)
FindExternalBracketAP(@Interp[LFunc].ExpressionArg);    {.209}


{$IFDEF DEBUGS}
   //G_Test1:=G_Test1+Interp[LFunc].IdL;
{$ENDIF}


end;





procedure TForevalH.SetNL;
label endp;
var
N: Integer;
HTree: PNode;
S: String;
begin
//  NL:     ;


if F_ErrorCode <> 0 then goto endp;

Tree:=BeginTree; // , ..   - 


while Tree^.Ch <> nil do
begin
Tree:=Tree^.Ch;
end;
//COP=NOP:

while Tree^.Pr <> nil do
begin

  while Tree^.Nb <> nil  do
  begin
   Tree:=Tree^.Nb;
    while Tree^.Ch <> nil do
    begin
     Tree:=Tree^.Ch;
    end;
   //COP=NOP:
   inc(N);
  end;

 //COP<>NOP:
 //S:=Tree^.Expression;
 Tree:=Tree^.Pr;
 N:=1;
 HTree:=Tree^.Ch;
 HTree^.NL:=N;
 HTree:=HTree^.Nb;
 {$IFDEF DEBUGS}
   //G_Test1:=G_Test1+N;
 {$ENDIF}
 while HTree <> nil do
 begin
  inc(N);
  HTree^.NL:=N;
  HTree:=HTree^.Nb;
 {$IFDEF DEBUGS}
   //G_Test1:=G_Test1+N;
 {$ENDIF}
 end;

end;

//  '0' !!!
Tree^.NL:=0;
endp:
end;



procedure TForevalH.SetNM;
label endp;
var
N: Integer;
HTree: PNode;
S: String;
begin
//  NM:    , ..: Interp[Interp[i].NM]  -
// ,  i -   (-   MUL,ADD)


if F_ErrorCode <> 0 then goto endp;

//new(Interp[0]);
Tree:=BeginTree; // , ..   - 


while Tree^.Ch <> nil do
begin
Tree:=Tree^.Ch;
end;
//COP=NOP:
N:=1;

while Tree^.Pr <> nil do
begin
 while Tree^.Nb <> nil  do
 begin
 Tree:=Tree^.Nb;
  while Tree^.Ch <> nil do
  begin
  Tree:=Tree^.Ch;
  end;
 //COP=NOP:
 inc(N);
end;

//COP<>NOP:
 //S:=Tree^.Expression;
 Tree:=Tree^.Pr;
 inc(N);
 HTree:=Tree^.Ch;
 HTree^.NM:=N;
 HTree:=HTree^.Nb;
 while HTree <> nil do
 begin
  HTree^.NM:=N;
  HTree:=HTree^.Nb;
 end;

end;
Tree^.NM:=0;

endp:
end;





// : SData,RData[i] = _FPU
procedure TForevalH.SetLoadSource;

        {arraycpu} {.245}
        //      ,        ( ) ,     FPU
        procedure SetLoadSourceForArray;
        label endp;
        var
          i,LS,NL,ArgT: Integer;
          Tree,pParent: PNode;
          S: String;
        begin

           Tree:=BeginTree; // , ..   - 

           while Tree^.Ch <> nil do
           begin
             Tree:=Tree^.Ch;
           end;
                 ArgT:=Tree^.ExtArg;
                 if (ArgT = _ArrayD) or (ArgT = _ArrayE) or (ArgT = _ArrayS) or (ArgT = _ArrayI)  then
                 begin
                    pParent:=Tree^.Pr;
                    Tree^.SData:=_MEM;             //     
                    NL:=Tree^.NL;
                    pParent^.RData[NL-1]:=_MEM;    //        

                    //if NL - 1 > High(pParent^.RData) then   InternalError !
                 end;


           while Tree^.Pr <> nil do
           begin

              while Tree^.Nb <> nil  do
              begin
                Tree:=Tree^.Nb;

                while Tree^.Ch <> nil do
                begin
                  Tree:=Tree^.Ch;
                end;

                 ArgT:=Tree^.ExtArg;
                 if (ArgT = _ArrayD) or (ArgT = _ArrayE) or (ArgT = _ArrayS) or (ArgT = _ArrayI)  then
                 begin
                    pParent:=Tree^.Pr;
                    Tree^.SData:=_MEM;             //    
                    NL:=Tree^.NL;
                    pParent^.RData[NL-1]:=_MEM;    //        
                 end;

              end;

             Tree:=Tree^.Pr;

             //S:=Tree^.Expression;

           end;

        endp:
        end;




label endp;
var
i,LS: Integer;
HTree: PNode;
S: String;
begin
// : SData,RData = _FPU  XCHA=0
LS:=_FPU;
if F_ErrorCode <> 0 then goto endp;

//new(Interp[0]);
Tree:=BeginTree; // , ..   - 

while Tree^.Ch <> nil do
begin
Tree:=Tree^.Ch;
end;
//COP=NOP:
Tree^.SData:=LS; Tree^.RData:=nil;
Tree^.XCHA:=0;

while Tree^.Pr <> nil do
begin

   while Tree^.Nb <> nil  do
   begin
    Tree:=Tree^.Nb;
    while Tree^.Ch <> nil do
    begin
     Tree:=Tree^.Ch;
    end;
    //COP=NOP:
    Tree^.SData:=LS; Tree^.RData:=nil;
    Tree^.XCHA:=0;
   end;

  //COP<>NOP:
  Tree:=Tree^.Pr;
  Tree^.SData:=LS;
  SetLength(Tree^.RData,Tree^.Stack.N);
  for i:=0 to High(Tree^.RData) do
  begin
   Tree^.RData[i]:=LS;
  end;


 Tree^.XCHA:=0;
 S:=Tree^.Expression;

end;


Tree^.SData:=_FPU;
Tree^.XCHA:=0;

//:
{Tree^.RData[0]:=_MEM;  Tree^.RData[1]:=_FPU; Tree^.RData[2]:=_FPU; Tree^.RData[3]:=_MEM;
HTree:=Tree^.Ch;
HTree^.SData:=_MEM;
HTree^.Nb^.SData:=_FPU;
HTree^.Nb^.Nb^.SData:=_FPU;
HTree^.Nb^.Nb^.Nb^.SData:=_MEM;
}
SetLoadSourceForArray;    {arraycpu} {.245}
endp:
end;



procedure TForevalH.SetNodeDeep;
//   FPU       (  Cmpl.E_GetFuncLoad(Tree))
label endp;
var
NS,SD,i: Integer;
S: String;
Interp0: TArrayOfTFunc;
begin
if F_ErrorCode <> 0 then goto endp;
Tree:=BeginTree; // , ..   - 
SetLength(Interp0,1);
Cmpl.E_Init(Interp0,{InternalFuncList,ExternalFuncList,}FuncList,VarList,F_StackDeep,F_ParamType,F_DataType,C_EmlXchBranch);



while Tree^.Ch <> nil do
begin
Tree:=Tree^.Ch;
end;
Tree^.SDeep:=0+Cmpl.E_GetFuncLoad(Tree);


while Tree^.Pr <> nil do
begin
 while Tree^.Nb <> nil  do
 begin
 Tree:=Tree^.Nb;
  while Tree^.Ch <> nil do
  begin
  Tree:=Tree^.Ch;
  end;
  Tree^.SDeep:=0+Cmpl.E_GetFuncLoad(Tree);
 end;

 SD:=Tree^.Pr^.Ch^.SDeep; NS:=Tree^.Pr^.Ch^.Stack.S;
 Tree:=Tree^.Pr^.Ch;
 while Tree^.Nb <> nil do
 begin
  Tree:=Tree^.Nb;
  if (Tree^.SDeep+Tree^.Stack.S) > (SD+NS) then
  begin
   SD:=Tree^.SDeep;
   NS:=Tree^.Stack.S;
  end;
 end;

 Tree:=Tree^.Pr;
 Tree^.SDeep:=NS-Tree^.Stack.S+SD+Cmpl.E_GetFuncLoad(Tree);
end;

Db_XchBrSDeep:=Cmpl.GetMaxStack;


//???
{Interp0[0].PN:=nil;
Interp0[0].PM:=nil;
Interp0[0].PI:=nil;
Interp0[0].PC:=nil;
Interp0[0].SGN:=nil;
Interp0[0].AFB:=nil;
Interp0[0].RData:=nil;
Interp0[0].SNExtArg:=nil;
Interp0:=nil; }
endp:
end;




procedure TForevalH.GetSizeInterp;
label endp;
begin
if F_ErrorCode <> 0 then goto endp;

LInterp:=1;

Tree:=BeginTree; // , ..   - 

while Tree^.Ch <> nil do
begin
  Tree:=Tree^.Ch;
end;
//COP=NOP:
inc(LInterp);

while Tree^.Pr <> nil do
begin

 while Tree^.Nb <> nil  do
 begin
   Tree:=Tree^.Nb;
   while Tree^.Ch <> nil do
   begin
    Tree:=Tree^.Ch;
   end;

   //COP=NOP:
   inc(LInterp);
 end;
  //COP<>NOP:
  Tree:=Tree^.Pr;
  inc(LInterp);
end;

endp:

end;




procedure TForevalH.TreeOptimizator;
//  
begin
SetNodeDeep;


if (F_TreeOptimization = _Enable) or
   ((F_TreeOptimization = _Auto) and (Cmpl.GetMaxStack > F_StackDeep))
then
 begin
  BranchOptimizator;
  RestoreStack;
 end;

end;





procedure TForevalH.BranchOptimizator;
label 1,2,3,endp;
var
S: String;
CNI: Integer;
begin
CNI:=0;
if F_ErrorCode <> 0 then goto endp;

Tree:=BeginTree; // , ..   - 

1:
while Tree.Ch <> nil do
begin
 Tree:=Tree^.Ch;
end;


2:
if Tree^.Nb = nil then goto 3
else
begin
 Tree:=Tree^.Nb;
 goto 1;
end;

3:
if Tree^.Pr = nil then  goto endp
else
begin
 // . -  FType < 0    {XchArg=_Yes}  {.205}
 if   {(FuncList[Tree^.Pr^.Code].FType >= 0)} (FuncList[Tree^.Pr^.Code].XchArg = _Yes) then  {.205}
 begin
  if CheckXchBranch(Tree^.Pr^.Ch) then
  begin
    S:=Tree^.Pr^.Expression;
    XchBranch(Tree^.Pr);
    inc(Db_XchBrNXch);
  end;
 end;
 Tree:=Tree^.Pr;
 goto 2;
end;

//not error (must be zero):

//(2*x*y+1)*(3*x*t+1)+(2*x*y+1)^(2*x*y+1)-((2*x*y+1)*(3*x*t+1)+(2*x*y+1)^(2*x*y+1))
//after exchange order of execute (not equal zero):
//-((2*x*y+1)*(3*x*t+1)+(2*x*y+1)^(2*x*y+1))+(2*x*y+1)^(2*x*y+1)+(2*x*y+1)*(3*x*t+1)
//so as (2*x*y+1)^(2*x*y+1) many much  than (2*x*y+1)*(3*x*t+1)
endp:
end;



function TForevalH.CheckXchBranch(Lv: PNode): Boolean;
label endp;
var
SD: Integer;
begin
CheckXchBranch:=False;
SD:=LV^.SDeep;
LV:=LV^.Nb;
while Lv <> nil do
begin
 if Lv^.SDeep > SD then
 begin
  CheckXchBranch:=True;
  goto endp;
 end;
 Lv:=Lv^.Nb;
end;

endp:
end;





procedure TForevalH.XchBranch(Pr: PNode);
type
Tmax = record
        N: Integer;
     Tree: PNode;
       end;
var
Mx: array of TMax;
Tr,Ch: PNode;
N,M,i,j,Max,NMax,nif,SS,St: Integer;
S,S1,S2,S3: String;
begin
Ch:=Pr^.Ch;
N:=0;

while Ch <> nil do
begin
 inc(N);
 Ch:=Ch^.Nb;
end;
SetLength(MX,N);

//  :
Ch:=Pr^.Ch;
M:=0;
while Ch <> nil do
begin
  MX[M].Tree:=Ch;
  MX[M].N:=M;
  inc(M);
  Ch:=Ch^.Nb;
end;

Ch:=Pr^.Ch;

//    SDeep:
for i:=0 to N-1 do
begin
 Max:=MX[i].Tree^.SDeep; NMax:=i;
 for j:=i+1 to N-1 do
 begin
  if MX[j].Tree^.SDeep > Max then
  begin
   NMax:=j; Max:=MX[j].Tree^.SDeep;
  end;
 end;

 // :
 if NMax <> i then
 begin
  Tr:=MX[i].Tree;
  MX[i].Tree:=MX[NMax].Tree;
  MX[NMax].Tree:=Tr;

  M:=MX[i].N;
  MX[i].N:=MX[NMax].N;
  MX[NMax].N:=M;
 end;
end;

//   :
MX[N-1].Tree^.Nb:=nil; MX[N-1].Tree^.Pr:=Pr; Pr^.Ch:=MX[0].Tree;
for i:=0 to N-2 do
begin
  MX[i].Tree^.Nb:=MX[i+1].Tree;
end;


//-(-(1))-(-(-2-(-8)))-((7*x)+((a+9)))

//f1(1)+f2(2)+f3(3)+f4(4)+f5(5)
//x-t/y+t/(x+t)
//((2*x-1)/(3*x-4))/(8/x-9/(2*x*y-1)+1)
{S:=MX[0].Tree^.Expression;
S1:=MX[1].Tree^.Expression;
S2:=MX[2].Tree^.Expression;
S3:=MX[3].Tree^.Expression;}
{$IFDEF DEBUGS}
 //TestG8.Form1.M3.Lines[0]:=S;
 //TestG8.Form1.M4.Lines[0]:=S1;
{$ENDIF}

{
 MX[i].N
 i -      ( )
 N -   ( )
}
if Pr^.Code = C_ADD then
begin
 for i:=0 to N-1 do
 begin
  //S1:=MX[i].Tree^.Expression;
  if (i = 0) and (MX[i].N <> 0) then
  begin
   if MX[i].Tree^.I = _ADD then MX[i].Tree^.I:=_NOP;
   if MX[i].Tree^.I = _SUB then
   begin
    MX[i].Tree^.I:=_NOP;
    if MX[i].Tree^.Neg = 1 then MX[i].Tree^.Neg:=0
    else
    MX[i].Tree^.Neg:=1;
   end;
  end;

  if (i > 0) and (MX[i].Tree^.I = _NOP)  then MX[i].Tree^.I:=_ADD;

  if (i > 0) and (MX[i].N = 0) and (MX[i].Tree^.Neg = 1) and (MX[i].Tree^.I = _ADD) then
  begin
   MX[i].Tree^.Neg:=0;
   MX[i].Tree^.I:=_SUB;
  end;

   //ADD-S1+S2; ADD+S1-S2;
   if (i = 0) and (MX[i].Tree^.I = _NOP) then  Pr^.SGN[i]:=_ADD
   else
   if (i > 0) then Pr^.SGN[i]:=MX[i].Tree^.I;

   MX[i].Tree^.NL:=i+1;

 end;
end
else
if Pr^.Code = C_MUL then
begin

 for i:=0 to N-1 do
 begin
  if (i = 0) and (MX[i].N > 0) then
  begin
   if MX[i].Tree^.I = _MUL then MX[i].Tree^.I:=_NOP;
  end;

  if (i > 0) and (MX[i].Tree^.I = _NOP)  then MX[i].Tree^.I:=_MUL;

  if (i > 0)  or  ((i = 0) and (MX[i].Tree^.I <> _NOP)) then
   Pr^.SGN[i]:=MX[i].Tree^.I;

  MX[i].Tree^.NL:=i+1;
 end;

//  ( MUL):       
//    '/',     =>
//     : .I:=DIVR (   )
//( SGN   !!!)

 if (MX[0].Tree^.I = _DIV) and (MX[0].N > 0) then
 begin
  MX[0].Tree^.I:=_NOP;
  MX[1].Tree^.I:=_DIVR;
 end;

 {
 !!!
       S1/S2*S3/S4/S5... ->S1*S3/(S2*S4*S5)       
    MulDivOptimization  LeadToDenominator    

 }

  // sin(x)/cos(y)/sh(x)
 //  sin(x)/cos(y)/sh(x)
 // f2xch(x)/f1xch(x)/f5xch(x)/f3xch(x)/f4xch(x)
 // f1xch(x)/f2xch(x)/f5xch(x)/f3xch(x)/f4xch(x)
 // f5xch(x)/f4xch(x)/f2xch(x)/f3xch(x)/f1xch(x)
 // f5xch(x)/f2xch(x)/f3xch(x)/f4xch(x)/f1xch(x)
 // f1xch(x)/f2xch(x)/f3xch(x)*f4xch(x)/f5xch(x)


end
else
if FuncList[Pr^.Code].FType = 4 then
begin
 Pr^.XCHA:=1;
end
else
begin
  if FuncList[Pr^.Code].NST = -1 then F_OverFlowFunc:=True;
end;


end;






procedure TForevalH.RestoreStack;
label endp;
var
S: Integer;
begin
if F_ErrorCode <> 0 then goto endp;
Tree:=BeginTree;   // , ..   - 

S:=1;
while Tree^.Ch <> nil do
begin
Tree:=Tree^.Ch;
Tree^.Stack.S:=S;
end;


while Tree^.Pr <> nil do
begin
 while Tree^.Nb <> nil  do
 begin
 S:=Tree^.Stack.S;
 Tree:=Tree^.Nb;
 Tree^.Stack.S:=S+1;
 inc(S);
  while Tree^.Ch <> nil do
  begin
  Tree:=Tree^.Ch;
  Tree^.Stack.S:=S;
  end;
 end;
 Tree:=Tree^.Pr;
end;


endp:
end;



procedure TForevalH.DinamicLoadOptimizator;
label 1,beginp,endp;
var
i,Pn,PML,ML,CNT,k,t2: Integer;
S,S1: String;
begin

if  F_DinamicLoadOptimization = _Enable then goto beginp;
if  F_DinamicLoadOptimization = _Auto then
begin
 Cmpl.E_Init(Interp,FuncList,VarList,F_StackDeep,F_ParamType,F_DataType,C_EmlDinamicLoad);
 Db_DinLoadSDeep:=Cmpl.E_GetMaxStackEx;
 if Db_DinLoadSDeep > F_StackDeep then goto beginp else goto endp;
end;


beginp:
CNT:=0;
if F_ErrorCode <> 0 then goto endp;
PML:=0; PN:=0;
1:
SetDIVR;
Cmpl.E_Init(Interp,FuncList,VarList,F_StackDeep,F_ParamType,F_DataType,C_EmlDinamicLoad);

for i:=1 to LFunc-1 do
begin
  {$IFDEF DEBUGS}
   //TestG8.Form1.M3.Lines[i-1]:=IntToStr(Interp[i].Code);
  {$ENDIF}
  S:=Interp[i].Expression;                  //db
  S1:=Interp[i-1].Expression;      ;               //db

  ML:=Cmpl.E_GetMaxLoadDL(I);

  {    -    (I-1)  , 
       (I-2,...1)     ,  
       (I)}
  if {(ML = PML)}(ML > F_StackDeep) and (PN = I) then
  begin
   for k:=I-2 downto 1 do
   begin
     if Interp[k].SData = _FPU then
     begin
      if EnableDL(k) then
      begin
       SetLoadMem(k);
       {$IFDEF DEBUGS}
        //TestG8.Form1.M1.Lines[CNT]:=Interp[k].Ers;
        //inc(CNT);
       {$ENDIF}
       goto 1;
      end;

     end;
   end;
    Db_DinLoadOverFlow:=True;
    //   (,      < F_StackDeep:
   goto endp;
  end;

  {      ,  -  (I-1) 
    : (..   1  )}
  if ML > F_StackDeep then
  begin
   if I = 1 then
   begin
    Db_DinLoadOverFlow:=True;
    //  :
    goto endp;
   end;
   if {Interp[I-1].Code <> 305}EnableDL(I-1) then
   begin
    SetLoadMem(I-1);
    PML:=ML;
    PN:=I;   //    -: _MEM
    {$IFDEF DEBUGS}
     //TestG8.Form1.M1.Lines[CNT]:=Interp[i-1].Ers;
     //inc(CNT);
    {$ENDIF}
    goto 1;
   end;
  end;

end;

//((2*x-1)/(3*x-4))/(8/x-9/(2*x*y-1)+1)
endp:
{$IFDEF DEBUGS}
  TestG8.Form1.LDLSD.Caption:=IntToStr(Db_DinLoadSDeep);
  if Db_DinLoadOverFlow  then
   TestG8.Form1.LDLNM.Caption:='OutOfStack'
  else
   TestG8.Form1.LDLNM.Caption:=IntToStr(Db_DinLoadNMem);
{$ENDIF}
//sinh(x)^cosh(y)
//test:
//m_eax5(f1(1),f2(2),f3(3),f4(4),f5(5))
{Interp[2].SData:=_MEM;
Interp[4].SData:=_MEM;
Interp[6].SData:=_MEM;
Interp[8].SData:=_MEM;
Interp[10].SData:=_MEM;
Interp[11].RData[0]:=_MEM;
Interp[11].RData[1]:=_MEM;
Interp[11].RData[2]:=_MEM;
Interp[11].RData[3]:=_MEM;
Interp[11].RData[4]:=_MEM;}
end;


function TForevalH.EnableDL(I: Integer): Boolean;
var
ifn: Integer;
begin
//False -       
//COP = NOP,JMP,PACKAGE {.239}
//  -  FPU
//{.239}  -   ,   
//{.239}  -     PACKAGE (..    :    : _MEM  PACKAGE)
if {Internal}FuncList[Interp[Interp[I].NM].Code].FType = -8 then EnableDL:=False  //    -  FPU
else
{
if Interp[I].Code = C_NOP then  EnableDL:=False
else
if Interp[I].Code = C_JMP then  EnableDL:=False
else
if Interp[I].Code = C_PACKAGE then  EnableDL:=False
}
if FuncList[Interp[I].Code].RetNum = _NO then  EnableDL:=False   {.239}
else
{.239}
if Interp[Interp[I].NM].Code = C_PACKAGE then EnableDL:=False
else
EnableDL:=True;
end;



procedure TForevalH.SetDIVR;
label 1;
var
NL: TArrayI;
l,i,j,k: Integer;
begin
//  ( MUL):       
//  (c SData = _FPU)  '/',     =>
//    ( SData = _FPU) : .I:=DIVR
//(   ),   ,     MUL
//(     ,   TreeOptimizator   '*'  '/'
//.. '/'( )      )
//( SGN   !!!)

 for i:=1 to LFunc-1 do
 begin
  if Interp[i].Code = C_MUL then
  begin

   if Interp[i].N > 1 then
   begin

    SetLength(NL,Interp[i].N); l:=0;
    for j:=1 to i do
    begin
     if Interp[j].NM = i then
     begin
      NL[l]:=j; inc(l);
     end;
    end;

    //Lengh(SGN) = Length(RData) = Length(NL)
    for k:=0 to High(Interp[i].SGN) do
    begin
     //     SData = _FPU
     if Interp[i].RData[k] = _FPU then
     begin
      //    ( SData  =_FPU) = '/',    
      // ( SData = _FPU)     (.I = _DIVR)
      //  ,        (MUL)
      // SGN    !!!
      if Interp[i].SGN[k] = _DIV then
      begin
       //  -   SData =_FPU  '/'    .I = _DIVR
       for l:=k+1 to High(Interp[i].SGN) do
       begin
        if Interp[i].RData[l] = _FPU then
        begin
         Interp[NL[l]].I:=_DIVR;
         goto 1;
        end;
       end;

      end
      else
      // '/'       SData = _FPU,     
      //(   SData = _FPU)
      goto 1;

     end
    end;

   end;

  end;

 1:
 end;

end;




procedure TForevalH.SetLoadMem(I: Integer);
var
NL,NM: Integer;
S,S1: String;
begin
 Interp[I].SData:=_MEM;
 NM:=Interp[I].NM;
 NL:=Interp[I].NL;
 Interp[NM].RData[NL-1]:=_MEM;

 //S:=Interp[i].Expression;
 //S1:=Interp[NM].ErS;
 inc(Db_DinLoadNMem);

 {$IFDEF DEBUGS}
{if TestG8.Form1.CB_Cod.Checked = True then
 begin
  S:=Copy(TestG8.Form1.M2.Lines[I-1],1,Length(TestG8.Form1.M2.Lines[I-1]));
  S1:=Copy(TestG8.Form1.M2.Lines[NM-1],1,Length(TestG8.Form1.M2.Lines[NM-1]));
  S:=S+'  WM';
  S1:=S1+'  RM';
  TestG8.Form1.M2.Lines[I-1]:=String(StrUpper(PChar(S)));
  TestG8.Form1.M2.Lines[NM-1]:=String(StrUpper(PChar(S1)));
 end; }
{$ENDIF}
end;



procedure TForevalH.CalcConstFunc;
label 1,endp;
var
X,X1,X2,F: TFloatType;
i,il,N,k,HL: Integer;
Addr: Pointer;
FuncCode: array of byte;
begin
if F_ErrorCode <> 0 then goto endp;

F_ErNum:=0;

 for i:=1 to LFunc-1 do
 begin
  if FuncList[Interp[i].Code].FType <= 0 then goto 1;
  if FuncList[Interp[i].Code].CalcConst = _No then goto 1;
  if FuncList[Interp[i].Code].RetNum = _No then goto 1;

  F_ErNum:=i;
  il:=0;

  //  - . :
  if FuncList[Interp[i].Code].FType = 2 then
  begin
   if Interp[i].EI = 2 then
     if Interp[i].V1 = 0 then
     begin
      X:=Interp[i].V2; il:=1;
     end
  end
  else
  if FuncList[Interp[i].Code].FType = 4 then
  begin
   if Interp[i].EI = 6 then
     if (Interp[i].V1 = 0) and  (Interp[i].V3 = 0) then
     begin
      X1:=Interp[i].V2;
      X2:=Interp[i].V4;
      il:=1;
     end
  end
  else
  if FuncList[Interp[i].Code].FType = 1 then
  begin
   if Interp[i].EI = 2 then
     if (Interp[i].VI1 = 0)  then
     begin
      N:=Interp[i].VI2;
      il:=1;
     end
  end
  else
  if FuncList[Interp[i].Code].FType = 3 then
  begin
   if Interp[i].EI = 2 then
     if (Interp[i].V1 = 0) and (Interp[i].VI1 = 0)  then
     begin
      X:=Interp[i].V2;
      N:=Interp[i].VI2;
      il:=1;
     end
  end;




  // -:
  if il = 1 then
  begin
   Addr:=nil;

   if FuncList[Interp[i].Code].Addr <> nil then
   begin
    Addr:=FuncList[Interp[i].Code].Addr;
   end
   else
   if FuncList[Interp[i].Code].inl = 1 then
   begin

     if F_UseVirtAlloc = False then
     begin
       SetLength(FuncCode,Length(FuncList[Interp[i].Code].inlCode)+1);
       for k:=0 to High(FuncList[Interp[i].Code].inlCode) do
       begin
         FuncCode[k]:=FuncList[Interp[i].Code].inlCode[k];
       end;
       FuncCode[High(FuncCode)]:=$C3; //RET
       Addr:=@FuncCode[0];
     end
     else
     begin
       HL:=High(FuncList[Interp[i].Code].inlCode);
       Addr:=VirtualAlloc(Nil, HL+2, MEM_COMMIT or MEM_RESERVE, PAGE_EXECUTE_READWRITE);

       for k:=0 to HL  do
       begin
         PCardinal(Cardinal(Addr)+k)^:=FuncList[Interp[i].Code].inlCode[k];
       end;
       PCardinal(Cardinal(Addr)+HL+1)^:=$C3;
     end;

   end;


 //try

  TryFPUMask{(@CWMEM6)}; {.249}
   if FuncList[Interp[i].Code].FType = 2 then
   begin
     asm
       fld  X
       pushad
       call Addr
       popad
       fstp F
     end
    end
    else
    if FuncList[Interp[i].Code].FType = 4 then
    begin
     asm
       fld  X2
       fld  X1
       pushad
       call Addr
       popad
       fstp F
     end
    end
    else
    if FuncList[Interp[i].Code].FType = 1 then
    begin
     asm
       mov  eax,N
       pushad
       call Addr
       popad
       fstp F
     end
    end
    else
    if FuncList[Interp[i].Code].FType = 3 then
    begin
     asm
       fld  X
       mov  eax,N
       pushad
       call Addr
       popad
       fstp F
     end;
   end;

   TryCatchFPUException{(@CWMEM6)};    {.249}
{
except
 //on E: ESyntaxError     do ;
 on E: EZeroDivide      do F_ErrorCode:=E_ZeroDivide;
 on E: EInvalidOp       do F_ErrorCode:=E_InvalidOp;
 on E: EOverFlow        do F_ErrorCode:=E_OverFlow;
 on E: EUnderFlow       do F_ErrorCode:=E_UnderFlow;
 on E: EIntOverFlow     do F_ErrorCode:=E_IntOverFlow;
 on E: EAccessViolation do F_ErrorCode:=E_AccessViolation;
 on E: EOutOfMemory     do F_ErrorCode:=E_OutOfMemory;
 on E: EStackOverFlow   do F_ErrorCode:=E_StackOverFlow
end;
 }
   if (Addr <> nil) and (F_UseVirtAlloc = True) then VirtualFree(Addr,0,MEM_RELEASE);

   {if  (Interp[i].CODE >= C_IPWR3) and (Interp[i].CODE <= C_IPWR16) then
    if  Interp[i].BI = 1 then X:=1/X;}

//F:=1.12345;
    // - -> LDSC:
    if Interp[i].AI = 1 then F:=Interp[i].F1*F+Interp[i].F2;
    Interp[i].V2:=F;
    Interp[i].CODE:=C_LDSC;
    FuncList[Interp[i].Code].FType:=0;

    inc(Db_CalcConst);



   {----------------------}
    //out:
   {$IFDEF DEBUGS}
    {if (TestG8.Form1.CB_Cod.Checked = True) then
    TestG8.Form1.M2.Lines[i-1]:='LDSC';}
    {$ENDIF}
   {----------------------}



  end;



 1:
 end;

FuncCode:=nil; 
endp:
end;


procedure TForevalH.PostCodeOptimization;
label endp;
var
i,j,FType,CODE,t1: Integer;
BH,FIF: Boolean;
begin
if F_ErrorCode = 0 then
begin
  LSRes:=-1;
  //  !!!
  if F_CalcConstantFunc then CalcConstFunc;
  if F_ErrorCode <> 0 then goto endp; {.249}

  FIF:=FindIfFunc;
  if (FIF = True) and (F_DisableReplaceIF = True) then begin end     {.205}
  else
  begin
    ReplaceFunctionsT;
    if F_ReplaceFunction = True then ReplaceFunctionsUT;
    if F_ReplaceOperation = True then ReplaceOperations;
    SetLength(Func.CpSt,LSRes+1);
    if LSRes >= 0 then DelVoidSave;   {.203}
  end;

end;

endp:
end;



procedure TForevalH.ReplaceFunctionsT;
label 0,1,2,endp;
var
FType1,FType2,Code1,Code2,N1,N2,i,j,k,l,RL,RLB,t1,c1,c2,n,P: Integer;
Sc,Sc1: String;
begin
RL:=F_LevelReplace;

0:
if RL = 0 then goto endp;
//   :
for i:=RL to LFunc-1-RL do
begin
 //i- 
 FType1:=FuncList[Interp[i].Code].FType;
 Code1:=Interp[i].CODE;
 //  . :
 if Interp[i].N > 1 then goto 1;
 // :
 N1:=Interp[i-RL+1].N;
 if N1 <> 0 then goto 1;

 if Interp[i].RCS = 1 then goto 1;   //  

 //    (FType >= 1)
 if (FType1 <= 0) or (FuncList[Code1].ReplFunc = _No) then goto 1;    {.199}


 //Sc:=Interp[i].ErS;
 Sc:=Interp[i].ExpressionArg;
 //   :
 for j:=i+RL to LFunc-1 do
 begin
  //Sc1:=Interp[j].ErS;
  Sc1:=Interp[j].ExpressionArg;

  Code2:=Interp[j].Code;
   //       : x=sin(x); x=sin(x); x
    //      fl_PACKAGE_COMPILE (F_EnableReplaceInPackage = True)
   if (Code2 = C_PACKAGE) and  (F_EnableReplaceInPackage = False) then goto 1;       {.199}  {.205}
   if (Code2 = C_JMP) or (Code2 = C_IFNOP) or (Code2 = C_GOTO) then    goto 1;       {.205}

  FType2:=FuncList[Interp[j].Code].FType;
  if Interp[j].RCS = 1 then goto 2;   //  
  N2:=Interp[j-RL+1].N;
  if N2 <> 0 then goto 2;
  if Interp[j].N > 1 then goto 2;
  if (FType2 <= 0) or (FuncList[Code2].ReplFunc = _No) then goto 2;    {.199}

  if IsSameFunctions(i,j) = False then goto 2;


  c1:=i; c2:=j;
  // :
  P:=GetPriorityXch(Code1,Code2).RCS;
  if ((P <> 0) and (Interp[j].RCS = 0)) or
     ((P <> 0) and (Interp[j].RCS <> 0) and (P < Interp[j].RCS))
  then
  begin
   // :
   if RL = 1  then
   begin
    InsertCopyStack(i,j,1);
    t1:=1;
    goto 2;
   end
   else
   //  :
   for n:=1 to RL-1 do
   begin
    dec(c1); dec(c2);
    if Interp[c2].Code <> Interp[c1].Code then goto 2;
    if Interp[c1].F1 <> Interp[c2].F1 then goto 2;
    if Interp[c1].F2 <> Interp[c2].F2 then goto 2;
    if Interp[c1].N > 1 then goto 1;
    if Interp[c2].N > 1 then goto 2;
    if FuncList[Interp[c1].Code].FType <= 0 then goto 1;
    if FuncList[Interp[c2].Code].FType <= 0 then goto 2;
    if Interp[c1].RCS = 1 then goto 1;
    if Interp[c2].RCS = 1 then goto 2;



    if (Interp[c1].N = 0) and (n < RL-1)  then goto 2;
    if (Interp[c2].N = 0) and (n < RL-1)  then goto 2;
    //   :
    if Interp[c1].S <> Interp[i].S then goto 1;
    //   :
    if Interp[c2].S <> Interp[j].S then goto 2;


    if IsSameFunctions(c1,c2) = False then goto 2;
   end;



  InsertCopyStack(i,j,RL);
  end;

 2:
 end;

1:
end;
dec(RL);
goto 0;


endp:
end;





procedure TForevalH.ReplaceFunctionsUT;
label 0,1,2,endp;
var
FType1,FType2,Code1,Code2,N1,N2,i,j,k,l,RL,RLB,t1,c1,c2,n,P,ReplF1,ReplF2: Integer;
Sc,Sc1,S: String;
BH: Boolean;
begin


//   :
//legendrep(i,k,x)+legendrep(i,k,x)
//x=sin(x); x=sin(x);x
S:=Interp[LFunc-1].Expression;
for i:=1 to LFunc-1 do
begin
 //i- 
 Code1:=Interp[i].CODE;
 FType1:=FuncList[Code1].FType;
 ReplF1:=FuncList[Code1].ReplFunc;
 if (ReplF1 = _No)  then goto 1;

 //  :
 if (Code1 = C_MUL) or (Code1 = C_ADD) or (Code1 = C_MAF) or (Code1 = C_AAF)  or (Code1 = C_FAVB)  then   goto 1;   {.201}



 // :
 if Interp[i].RCS = 1 then goto 1;   //  

 //    (FType >= 1)
 //if (FType1 <= 0)  then goto 1;

 //sin((x/y))+sqr(x/y)

 Sc:=Interp[i].ExpressionArg;
 //   :
 for j:=i+1 to LFunc-1 do
 begin
  //x=2; y=5; x=sin(x)/cos(y)-sin(y)/cos(x); x=sin(x)*sin(y)-2*cos(x)*cos(y); y=sin(y)*sin(x)-cos(y)*cos(x); x=sin(x)-cos(y*sin(x)); y=sin(x/cos(y)-y/sin(y))*sin(x); x+y

   //if Interp[j].N > 2 then goto 2;
   Code2:=Interp[j].Code;
   //           : x=sin(x); x=sin(x); x
   //      fl_PACKAGE_COMPILE (F_EnableReplaceInPackage = True)
   if (Code2 = C_PACKAGE) and  (F_EnableReplaceInPackage = False)  then goto 1;       {.199}  {.205}
   if (Code2 = C_JMP) or (Code2 = C_IFNOP) or (Code2 = C_GOTO) then    goto 1;       {.205}


   ReplF2:=FuncList[Code2].ReplFunc;
   FType2:=FuncList[Code2].FType;

   //  :
   if (Code2 = C_MUL) or (Code2 = C_ADD) or (Code2 = C_MAF) or (Code2 = C_AAF)  or (Code2 = C_FAVB)  then   goto 2;   {.201}

   if (ReplF2 = _No)  then goto 2;

   //if (FType2 <= 0)  then goto 2;

   if Interp[j].RCS = 1 then goto 2;   //  



   Sc1:=Interp[j].ExpressionArg;

   {if ((Code1 = C_MUL) and (Code2 = C_MUL)) or ((Code1 = C_ADD) and (Code2 = C_ADD))  then
   begin
      Sc:=Interp[i].Expression;    Sc1:=Interp[j].Expression;
   end; }{.201}


   if Sc <> Sc1  then  goto 2;


   FindNonReplFunc(Sc1,BH);  //in Arg       //sin(x+rand(x,y)+x)+sin(x+rand(x,y)+x)
   if BH = True then goto 2;

  c1:=i; c2:=j;
  // :
  P:=GetPriorityXch(Code1,Code2).RCS;
  if ((P <> 0) and (Interp[j].RCS = 0)) or
     ((P <> 0) and (Interp[j].RCS <> 0) and (P < Interp[j].RCS))
  then
  begin
    InsertCopyStackA(i,j,0);
  end;

 2:
 end;

1:
end;



endp:
end;




procedure TForevalH.ReplaceOperations;
label 0,1,2,endp;
var
FType1,FType2,Code1,Code2,N1,N2,i,j,k,l,RL,RLB,t1,c1,c2,n,P,ReplF1,ReplF2: Integer;
Sc,Sc1: String;
BH: Boolean;
begin


//   :
//legendrep(i,k,x)+legendrep(i,k,x)
for i:=1 to LFunc-1 do
begin
 //i- 
 Code1:=Interp[i].CODE;
 FType1:=FuncList[Code1].FType;
 ReplF1:=FuncList[Code1].ReplFunc;
 if (ReplF1 = _No)  then goto 1;

 //  :
 if (Code1 <> C_MUL) and (Code1 <> C_ADD) and (Code1 <> C_MAF)  and (Code1 <> C_AAF) and  (Code1 <> C_FAVB) then   goto 1;     {.201}

  //(x/y)+x/y

 // :
 if Interp[i].RCS = 1 then goto 1;   //  

 //    (FType >= 1)
 //if (FType1 <= 0)  then goto 1;



  Sc:=Interp[i].Expression;
  //Sc:=Interp[i].ExpressionArg;

 //   :
 for j:=i+1 to LFunc-1 do
 begin
//x=2; y=5; x=(x/y+y/x)/(x/y-y/x); y=(y/x)*(x/y-y/x); y=x*y/(x/y-y/x)+x/(x*y/(x/y-y/x)); x=(x/y-y/x)/(y/x+x/y)+x*y/(x/y-y/x); x+y
   //if Interp[j].N > 2 then goto 2;
   Code2:=Interp[j].Code;
   //           : x=x/y; x=x/y;x
   //      fl_PACKAGE_COMPILE (F_EnableReplaceInPackage = True)
   if (Code2 = C_PACKAGE) and  (F_EnableReplaceInPackage = False)  then goto 1;       {.199}  {.205}
   if (Code2 = C_JMP) or (Code2 = C_IFNOP) or (Code2 = C_GOTO) then    goto 1;       {.205}

   ReplF2:=FuncList[Code2].ReplFunc;
   FType2:=FuncList[Code2].FType;

   //  :
   if (Code2 <> C_MUL) and (Code2 <> C_ADD) and (Code2 <> C_MAF) and (Code2 <> C_AAF)  and (Code2 <> C_FAVB)  then   goto 2;   {.201}

   if (ReplF2 = _No)  then goto 2;

   //if (FType2 <= 0)  then goto 2;

   if Interp[j].RCS = 1 then goto 2;   //  

   Sc1:=Interp[j].Expression;
   //Sc1:=Interp[i].ExpressionArg;




   if Sc <> Sc1  then  goto 2;


   FindNonReplFunc(Sc1,BH);  //in Arg       //sin(x+rand(x,y)+x)+sin(x+rand(x,y)+x)
   if BH = True then goto 2;

  c1:=i; c2:=j;
  // :
  P:=GetPriorityXch(Code1,Code2).RCS;
  if ((P <> 0) and (Interp[j].RCS = 0)) or
     ((P <> 0) and (Interp[j].RCS <> 0) and (P < Interp[j].RCS))
  then
  begin
    InsertCopyStackA(i,j,0);
  end;

 2:
 end;

1:
end;



endp:
end;




procedure TForevalH.FindNonReplFunc(Sf: String; var BH: Boolean);
label endp;
var
k,l: Integer;
Sf1,Sfn: String;
BH1: Boolean;
begin

BH:=False;

Sf1:=Sf;

if F_SyntaxExtension = True then
begin

 for k:=1 to Length(FuncList)-1 do
 begin

   if (FuncList[k].ReplFunc = _No) and (FuncList[k].Enabled <> _No) then
   begin
      FindFuncInExpr(k,Sf1,BH1);
      if BH1 = True then
      begin
        BH:=True;
        goto endp;
      end;

   end;

 end

end
else
for k:=1 to Length({External}FuncList)-1 do
 begin
    if (FuncList[k].ReplFunc = _No) and (FuncList[k].Enabled <> _No) then
    begin
        FindFuncInExpr(k,Sf1,BH1);
        if BH1 = True then
        begin
          BH:=True;
          goto endp;
        end;
    end;
 end;


endp:
end;





procedure  TForevalH.FindFuncInExpr(k: Integer; Sexpr: String; var BH: Boolean);
label endp;
var
FName: set of  Char;
Sfn: String;
i,P,L,LF: integer;
begin
FName:=['(','{','[','|','*','/','>','<','=','+','^','-',',',';'];

BH:=False;

if F_SyntaxExtension = True then LF:= Length(FuncList[k].Name)-1 else LF:=1;

  for i:=1 to LF do
     begin
         Sfn:=FuncList[k].Name[i];

         P:=Pos(Sfn,SExpr);
         if P > 0 then
         begin
           L:=Length(Sfn);

           if (SExpr[L+P] = '(') then
           begin
               if (P = 1)  then
               begin
                 BH:=True;
                 goto endp;
               end
               else
               begin
                  if SExpr[P-1] in FName = True then
                  begin
                    BH:=True;
                    goto endp;
                  end
               end;
           end;

         end;
     end;

endp:
end;




function TForevalH.CmpFunc2(NS,NF: Integer): Boolean;
begin
if Interp[NS].EI = 1 then CmpFunc2:=True
else
if Interp[NS].EI = 2 then CmpFunc2:=CmpFAVB(NS,NF)
else
if Interp[NS].EI = 3 then CmpFunc2:=CmpAAF(NS,NF)
else
if Interp[NS].EI = 4 then CmpFunc2:=CmpMAF(NS,NF)
else
if Interp[NS].EI = 5 then CmpFunc2:=CmpAIFB(NS,NF);
end;


function TForevalH.CmpFunc4(NS,NF: Integer): Boolean;
var
BH1,BH2: Boolean;
begin
if Interp[NS].EI = 1 then CmpFunc4:=False
else
if Interp[NS].EI = 2 then CmpFunc4:=CmpFAVB(NS,NF)
else
if Interp[NS].EI = 3 then CmpFunc4:=CmpAAF(NS,NF)
else
if Interp[NS].EI = 4 then CmpFunc4:=CmpMAF(NS,NF)
else
if Interp[NS].EI = 5 then CmpFunc4:=CmpFAVB1(NS,NF)
else
if Interp[NS].EI = 6 then
 begin
  BH1:=CmpFAVB(NS,NF);  BH2:=CmpFAVB1(NS,NF);
  if (BH1 = True) and (BH2 = True) then CmpFunc4:=True
  else CmpFunc4:=False;
 end
else
if Interp[NS].EI = 7 then
 begin
  BH1:=CmpAAF(NS,NF);  BH2:=CmpFAVB1(NS,NF);
  if (BH1 = True) and (BH2 = True) then CmpFunc4:=True
  else CmpFunc4:=False;
 end
else
if Interp[NS].EI = 8 then
 begin
  BH1:=CmpMAF(NS,NF);  BH2:=CmpFAVB1(NS,NF);
  if (BH1 = True) and (BH2 = True) then CmpFunc4:=True
  else CmpFunc4:=False;
 end
else
if Interp[NS].EI = 9 then CmpFunc4:=CmpAAF(NS,NF)
else
if Interp[NS].EI = 10 then
 begin
  BH1:=CmpFAVB1(NS,NF);  BH2:=CmpAAF(NS,NF);
  if (BH1 = True) and (BH2 = True) then CmpFunc4:=True
  else CmpFunc4:=False;
 end
else
if Interp[NS].EI = 11 then CmpFunc4:=CmpMAF(NS,NF)
else
if Interp[NS].EI = 12 then
 begin
  BH1:=CmpFAVB1(NS,NF);  BH2:=CmpMAF(NS,NF);
  if (BH1 = True) and (BH2 = True) then CmpFunc4:=True
  else CmpFunc4:=False;
 end;

end;




function TForevalH.CmpFunc3(NS,NF: Integer): Boolean;
var
BH1,BH2: Boolean;
begin

if Interp[NS].EI = 1 then CmpFunc3:=CmpIAVB(NS,NF)
else
if Interp[NS].EI = 2 then
 begin
  BH1:=CmpFAVB(NS,NF);  BH2:=CmpIAVB(NS,NF);
  if (BH1 = True) and (BH2 = True) then CmpFunc3:=True
  else CmpFunc3:=False;
 end
else
if Interp[NS].EI = 3 then
 begin
  BH1:=CmpAAF(NS,NF);  BH2:=CmpIAVB(NS,NF);
  if (BH1 = True) and (BH2 = True) then CmpFunc3:=True
  else CmpFunc3:=False;
 end
else
if Interp[NS].EI = 4 then
 begin
  BH1:=CmpMAF(NS,NF);  BH2:=CmpIAVB(NS,NF);
  if (BH1 = True) and (BH2 = True) then CmpFunc3:=True
  else CmpFunc3:=False;
 end
else
if Interp[NS].EI = 5 then CmpFunc3:=CmpAAI(NS,NF)
else
if Interp[NS].EI = 6 then
 begin
  BH1:=CmpFAVB(NS,NF);  BH2:=CmpAAI(NS,NF);
  if (BH1 = True) and (BH2 = True) then CmpFunc3:=True
  else CmpFunc3:=False;
 end
else
if Interp[NS].EI = 7 then
 begin
  BH1:=CmpAAF(NS,NF);  BH2:=CmpAAI(NS,NF);
  if (BH1 = True) and (BH2 = True) then CmpFunc3:=True
  else CmpFunc3:=False;
 end
else
if Interp[NS].EI = 8 then
 begin
  BH1:=CmpMAF(NS,NF);  BH2:=CmpAAI(NS,NF);
  if (BH1 = True) and (BH2 = True) then CmpFunc3:=True
  else CmpFunc3:=False;
 end
else
if Interp[NS].EI = 9 then CmpFunc3:=False
else
if Interp[NS].EI = 10 then CmpFunc3:=CmpFAVB(NS,NF)
else
if Interp[NS].EI = 11 then CmpFunc3:=CmpAAF(NS,NF)
else
if Interp[NS].EI = 12 then CmpFunc3:=CmpMAF(NS,NF);
end;




function TForevalH.CmpFunc1(NS,NF: Integer): Boolean;
begin
if Interp[NS].EI = 1 then CmpFunc1:=True
else
if Interp[NS].EI = 2 then CmpFunc1:=CmpIAVB(NS,NF)
else
if Interp[NS].EI = 3 then CmpFunc1:=CmpAAI(NS,NF)
end;


function  TForevalH.CmpFAVB(NS,NF: Integer): Boolean;
begin
CmpFAVB:=False;
 if (Interp[NS].V1 = Interp[NF].V1) and  (Interp[NS].V2 = Interp[NF].V2) and
    (Interp[NS].FV1 = Interp[NF].FV1)
   then  CmpFAVB:=True;
end;


function  TForevalH.CmpFAVB1(NS,NF: Integer): Boolean;
begin
CmpFAVB1:=False;
 if (Interp[NS].FV2 = Interp[NF].FV2) and
    (Interp[NS].V3 = Interp[NF].V3)   and
    (Interp[NS].V4 = Interp[NF].V4)
    then  CmpFAVB1:=True;
end;


function  TForevalH.CmpIAVB(NS,NF: Integer): Boolean;
begin
CmpIAVB:=False;
 if (Interp[NS].IV1 = Interp[NF].IV1) and
    (Interp[NS].VI1 = Interp[NF].VI1) and
    (Interp[NS].VI2 = Interp[NF].VI2)
    then CmpIAVB:=TRue;
end;


function  TForevalH.CmpAIFB(NS,NF: Integer): Boolean;
begin
CmpAIFB:=False;
 if (Interp[NS].V1 = Interp[NF].V1) and  (Interp[NS].V2 = Interp[NF].V2) and
    (Interp[NS].FV1 = Interp[NF].FV1) and (Interp[NS].IV1 = Interp[NF].IV1)
   then  CmpAIFB:=True;
end;


function TForevalH.CmpAAF(NS,NF: Integer): Boolean;
label endp;
var
i,L: Integer;
begin
CmpAAF:=False;


if Interp[NS].DI = Interp[NF].DI  then
begin
 if Interp[NS].DI = _AAF  then
 begin
  if (Length(Interp[NS].PM) =  Length(Interp[NF].PM)) and
     (Length(Interp[NS].PN) =  Length(Interp[NF].PN)) then
  begin
   L:=High(Interp[NS].PM);
   for i:=1 to L do
   begin
    if Interp[NS].PM[i] <> Interp[NF].PM[i] then goto endp;
    if Interp[NS].PN[i] <> Interp[NF].PN[i] then goto endp;
   end;

   if Interp[NS].PN[L+1] <> Interp[NF].PN[L+1] then goto endp;
   CmpAAF:=True;
  end;
 end;
end;

endp:
end;



function TForevalH.CmpMAF(NS,NF: Integer): Boolean;
label endp;
var
i,L: Integer;
begin
CmpMAF:=False;


if Interp[NS].DI = Interp[NF].DI  then
begin
 if Interp[NS].DI = _MAF  then
 begin
  if Length(Interp[NS].PM) =  Length(Interp[NF].PM) then
  begin
   L:=High(Interp[NS].PM);
   for i:=1 to L do
   begin
    if Interp[NS].PM[i] <> Interp[NF].PM[i] then goto endp;
   end;

   if Interp[NS].V1 <> Interp[NF].V1 then goto endp;
   if Interp[NS].V2 <> Interp[NF].V2 then goto endp;

   CmpMAF:=True;
  end;
 end;
end;


endp:
end;




function TForevalH.CmpAAI(NS,NF: Integer): Boolean;
label endp;
var
i,L: Integer;
begin
CmpAAI:=False;


if Interp[NS].CI = Interp[NF].CI  then
begin
 if Interp[NS].CI = _AAI  then
 begin
   if (Length(Interp[NS].PI) =  Length(Interp[NF].PI)) and
      (Length(Interp[NS].PC) =  Length(Interp[NF].PC)) then
   begin
    L:=High(Interp[NS].PI);
    for i:=1 to L do
    begin
     if Interp[NS].PI[i] <> Interp[NF].PI[i] then goto endp;
     if Interp[NS].PC[i] <> Interp[NF].PC[i] then goto endp;
    end;

    if Interp[NS].PC[L+1] <> Interp[NF].PC[L+1] then goto endp;
    CmpAAI:=True;
   end;
 end;
end;


endp:
end;






procedure TForevalH.InsertCopyStack(NF,NS,N: Integer);
label 1;
var
i,s: Integer;
Pt: TPrt;
L: Integer;
begin
//NF -> NS
Pt:= GetPriorityXch(Interp[NF].Code,Interp[NS].Code);


L:=Length(Interp[NF].AWCS);
if L = 0 then
begin
 LSRes:=LSRes+Pt.NC;
 SetLength(Interp[NF].AWCS,1);
 Interp[NF].AWCS[0].WCS:=Pt.WCS;
 Interp[NF].AWCS[0].MWCS:=LSRes;
 Interp[NS].MRCS:=LSRes;
 Interp[NS].RCS:=Pt.RCS;
end
else
begin
 for i:=0 to L-1 do
 begin
  if Interp[NF].AWCS[i].WCS = Pt.WCS then
  begin
   Interp[NS].MRCS:=Interp[NF].AWCS[i].MWCS;
   Interp[NS].RCS:=Pt.RCS;
   goto 1;
  end;
 end;

 LSRes:=LSRes+Pt.NC;
 SetLength(Interp[NF].AWCS,L+1);
 Interp[NF].AWCS[L].WCS:=Pt.WCS;
 Interp[NF].AWCS[L].MWCS:=LSRes;
 Interp[NS].MRCS:=LSRes;
 Interp[NS].RCS:=Pt.RCS;
end;



1:
for i:=NS-N+1 to NS-1 do
begin
  Interp[i].N:=0;
  Interp[i].F1:=1;
  Interp[i].F2:=0;
  Interp[i].RCS:=0;   {.199}
  Interp[i].code:=C_NOP;
  //FuncList[Interp[i].Code].FType:=0;    {.199}
end;

inc(Db_CopyStackXch);
if N > Db_MaxReplaceLevel then Db_MaxReplaceLevel:=N;
end;






procedure TForevalH.InsertCopyStackA(NF,NS,N: Integer);
label 1,endp;
var
i,s,St: Integer;
Pt: TPrt;
L,FN,CodeF: Integer;
begin
//NF -> NS
Pt:= GetPriorityXch(Interp[NF].Code,Interp[NS].Code);
CodeF:=Interp[NF].Code;

L:=Length(Interp[NF].AWCS);
if L = 0 then
begin
 LSRes:=LSRes+Pt.NC;
 SetLength(Interp[NF].AWCS,1);
 Interp[NF].AWCS[0].WCS:=Pt.WCS;
 Interp[NF].AWCS[0].MWCS:=LSRes;
 Interp[NS].MRCS:=LSRes;
 Interp[NS].RCS:=Pt.RCS;
end
else
begin
 for i:=0 to L-1 do
 begin
  if Interp[NF].AWCS[i].WCS = Pt.WCS then
  begin
   Interp[NS].MRCS:=Interp[NF].AWCS[i].MWCS;
   Interp[NS].RCS:=Pt.RCS;
   goto 1;
  end;
 end;

 LSRes:=LSRes+Pt.NC;
 SetLength(Interp[NF].AWCS,L+1);
 Interp[NF].AWCS[L].WCS:=Pt.WCS;
 Interp[NF].AWCS[L].MWCS:=LSRes;
 Interp[NS].MRCS:=LSRes;
 Interp[NS].RCS:=Pt.RCS;
end;


//    =C_NOP
1:
S:=Interp[NS].S;
FN:=GetFirstNode(NS);  //  ( ) =  (  Interp.[FN]); (  Interp.[NS] -  )
for i:=FN to NS-1 do
begin
  Interp[i].N:=0;
  Interp[i].F1:=1;
  Interp[i].F2:=0;
  Interp[i].RCS:=0;   {.199}
  Interp[i].code:=C_NOP;
  //FuncList[Interp[i].Code].FType:=0;    {.199}
end;

(*for i:={NS-N+1}NS+1 to {NS-1}Lfunc-1 do
begin
 if Interp[i].S <> S then  goto endp
 else
 begin
  Interp[i].N:=0;
  Interp[i].F1:=1;
  Interp[i].F2:=0;
  Interp[i].code:=C_NOP;
  FuncList[Interp[i].Code].FType:=0;
 end;
end;
*)

endp:
if (CodeF = C_MUL) or (CodeF = C_ADD) or (CodeF = C_MAF) or (CodeF = C_AAF)  or (CodeF = C_FAVB) then     {.201}
 inc(Db_CopyStackOpXch)
else
  inc(Db_CopyStackXchG);
end;



//x/(x/y+y/x)+x/(x/y+y/x)
//sin(cos(sin(x)))+1/sin(cos(sin(x)))
procedure TForevalH.DelVoidSave;
var
 BRF: Boolean;
 NRF,NS,ND,NV,L,i,NMD,NMS: Cardinal;
 S,S1: String;
begin

NV:=0;
for NS := 1 to LFunc-1 do
begin
  BRF:=False;
  L:=Length(Interp[NS].AWCS);
  S:=Interp[NS].Expression;

  if (Interp[NS].code <> C_NOP) and (L > 0) then
  begin
   for ND := NS+1 to LFunc-1 do
   begin
      S1:=Interp[ND].Expression;
      if Interp[ND].RCS >= 1 then
      begin
        NMD:=Interp[ND].MRCS;
        for i := 0 to L-1 do
        begin
          NMS:=Interp[NS].AWCS[i].MWCS;
          if  NMD = NMS {and (Interp[ND].code <> C_NOP)}  then
          begin
            BRF:=True;
          end;
        end;
      end;

   end;
  end;

  if BRF = False then
  begin
    SetLength(Interp[NS].AWCS,0);
    inc(NV);
  end;

end;

end;




function TForevalH.GetFirstNode(num: Integer): Cardinal;
label repf,endp;
var
j,IdN: Integer;
CS,FN: Cardinal;
ANL: TArrayC;
begin

 {$IFDEF DEBUGS}
   if num = LFunc-1 then
     G_Test2:={G_Test2+}Interp[num].IdL;
 {$ENDIF}

FN:=num;
IdN:=Interp[num].IdN;

repf:
for j:=1 to LFunc-1 do
begin
   {if IdN = Interp[j].IdL then
   begin
    SetLength(ANL,Length(ANL)+1);
    ANL[High(ANL)]:=j;
   end;}
   if Interp[j].IdL = IdN then
   begin
    if Interp[j].N = 0 then
    begin
      FN:=j; goto endp;
    end
    else
    begin
      IdN:=Interp[j].IdN;
      goto repf;
    end;
   end;
end;


endp:
GetFirstNode:=FN;

end;










function TForevalH.IsSameFunctions(NF,NS: Integer): Boolean;
label endp;
var
EI1,EI2,I1,I2,AI1,AI2,FI1,FI2,N1,N2,FType: Integer;
A,B: TFloatType;
BH: Boolean;
i,CODE,N,P,FType1,FType2: Integer;
F1,F2: TFloatType;
begin
IsSameFunctions:=False;

EI1:=Interp[NF].EI;
N1:=Interp[NF].N;
FType1:=FuncList[Interp[NF].Code].FType;
FType2:=FuncList[Interp[NS].Code].FType;
EI2:=Interp[NS].EI;
N2:=Interp[NS].N;
if (N1 <> N2)  or  (EI1 <> EI2) or (FType1 <> FType2) then goto endp;


if (FType1 = 2)   then
begin
 IsSameFunctions:=CmpFunc2(NS,NF);
end
else
if (FType1 = 4)   then
begin
 IsSameFunctions:=CmpFunc4(NS,NF);
end
else
if (FType1 = 3)   then
begin
 IsSameFunctions:=CmpFunc3(NS,NF);
 if (Interp[NF].Code >= C_IPWR3) and (Interp[NF].Code <= C_IPWR16) then
  if Interp[NF].BI <> Interp[NS].BI then IsSameFunctions:=False;
end
else
if (FType1 = 1)   then
begin
 IsSameFunctions:=CmpFunc1(NS,NF);
end
else
if (FType1 = 5)   then
begin
 if Interp[NS].IV1 = Interp[NF].IV1 then IsSameFunctions:=True else IsSameFunctions:=False;
end;

endp:
end;






function  TForevalH.GetNumberXchTable(Code: Integer): Integer;
label endp;
var
i: Integer;
begin

 for i:=0 to High(XchCode) do
 begin
  if XchCode[i] = Code then
  begin
   GetNumberXchTable:=i; goto endp;
  end
 end;

GetNumberXchTable:=-1;
endp:
end;


function  TForevalH.GetPriorityXch(Code1,Code2: Integer): TPrt;
var
N1,N2: Integer;
begin
GetPriorityXch:=XchTable[Code1,Code2];
end;





procedure TForevalH.CreateFuncList;
begin
 Foreval_Command.CreateFuncList(FuncList);
end;




procedure TForevalH.AddNameFunction(Code: Integer; Name: String);
begin
if (Code >= 0) and (Code <= High(FuncList)) then
begin
 SetLength(FuncList[Code].Name,Length(FuncList[Code].Name)+1);
 FuncList[Code].Name[High(FuncList[Code].Name)]:=Copy(Name,1,Length(Name));
end; 
end;


procedure TForevalH.ClearNameFunction(Code: Integer);
begin
if (Code >= 0) and (Code <= High(FuncList)) then
 FuncList[Code].Name:=nil;
end;


procedure TForevalH.DeleteFunction(Code: Integer);
var
i: Integer;
begin
 if (Code >= 0) and (Code <= High(FuncList)) then
 begin
  FuncList[Code].FType:=0;
  for i:=1 to High(FuncList[Code].Name) do
  begin
    FuncList[Code].Name[i]:='@@'+FuncList[Code].Name[i];
  end;
 end
 else
 begin
  F_ErrorCode:=E_NONEXISTENT_FUNCTION;
  F_SyntaxErrorString:=IntToStr(Code);
  IntException;
 end;
end;


procedure TForevalH.InitNode(var ND: TDataNode);
var
i: Integer;
begin
SetLength(ND.PN.FM,Length(VarList));   SetLength(ND.PN1.FM,Length(VarList));
SetLength(ND.PN.IM,Length(VarList));   SetLength(ND.PN1.IM,Length(VarList));

SetLength(ND.VFP,0);{.223}

for i:=0 to High(VarList) do
begin
ND.PN.FM[i]:=0;
ND.PN1.FM[i]:=0;
ND.PN.IM[i]:=0;
ND.PN1.IM[i]:=0;
end;
ND.PN.FC:=0;
ND.PN1.FC:=0;

ND.N:=0;
ND.AI:=0;
ND.BI:=0;
ND.CI:=0;
ND.DI:=0;
ND.EI:=0;
ND.FI:=0;
ND.V1:=0;
ND.V2:=0;
ND.V3:=0;
ND.V4:=0;
{ND.V13:=0;
ND.V14:=0;}
ND.VI1:=0;
ND.VI2:=0;
ND.VI3:=0;
ND.VI4:=0;
ND.F1:=0;
ND.F2:=0;


ND.FV1:=0;
ND.IV1:=0;
ND.FV2:=0;
ND.IV2:=0;
ND.ExtArg:=_None;
ND.Neg:=0;
ND.XCHA:=0;
ND.SS:=0;
ND.Code:=0;
end;






procedure TForevalH.CreateFactMass;
var
i,j,k1,k2: TIntegType;
S: TFloatType;
begin                   //  

//{$OverFlowChecks On}
//{$RangeChecks On}
SetLength(Factorial,NumberFact+1);

S:=1;
for j:=1 to NumberFact do
begin
 S:=S*j;
 Factorial[j]:=S;
end;
 Factorial[0]:=1;


k1:=1; k2:=1;
SetLength(Factorial1,NumberFact2+1);  SetLength(Factorial2,NumberFact2+1);
Factorial1[0]:=1; Factorial2[0]:=1;
 for i := 1 to NumberFact2*2 do
 begin
  if i mod 2 = 0 then  begin Factorial2[k2]:=Factorial2[k2-1]*i; inc(k2);  end
  else
    begin Factorial1[k1]:=Factorial1[k1-1]*i;  inc(k1); end;
 end;

 k1:=1; k2:=1;
 SetLength(Factorial2F,NumberFact2*2+1);   Factorial2F[0]:=1;
 for i := 1 to NumberFact2*2 do
 begin
  if i mod 2 = 0 then  begin Factorial2F[i]:=Factorial2[k2-1]*i; inc(k2);  end
  else
    begin Factorial2F[i]:=Factorial1[k1-1]*i;  inc(k1); end;
 end;

end;





function TForevalH.PointToDec(S: String):String;
label
1;
var
i:TIntegType;
SS: String;
begin
SS:=Copy(S,1,Length(S));
{for i:=1 to Length(S) do
 begin
  if SS[i] = '.' then
  begin
   Delete(SS,i,1);
   Insert(',',SS,i);
   goto 1;
 end
end;}

1:
PointToDec:=Copy(SS,1,Length(SS));
end;



procedure TForevalH.InitConstDb;
begin
 Db_XchBrSDeep:=0;
 Db_XchBrNXch:=0;
 Db_DinLoadSDeep:=0;
 Db_DinLoadNMem:=0;
 Db_DinLoadOverFlow:=False;
 Db_CmplMaxStack:=0;
 Db_CmplOverFlow:=False;
 Db_CopyStackXch:=0;
 Db_CopyStackXchG:=0;
 Db_CopyStackOpXch:=0;
 Db_CalcConst:=0;
 Db_MaxReplaceLevel:=0;
end;


procedure TForevalH.InitVarUsed; {.225}
var
 i: Integer;
begin

  for i := 0 to Length(VarList) - 1 do
  begin
    VarList[i].IsUsed:=False;
  end;

end;


procedure TForevalH.CreateInitData;
begin                             //  


//new(Func.Data);
SetLength(Func.Stack,2); //..   1
CreateFactMass;
CreateFuncList;


SetLength(ParamList,1);
F_SaveInStack:=True;
F_StackDeep:=8;
Cmpl:=TCompiler.Create(FuncList);
SetReg(1,0);SetReg(2,0); SetReg(3,0); SetReg(4,0);
SetReg(5,0); SetReg(6,0); SetReg(7,0); SetReg(8,0);
F_ErrorCode:=0;
LFunc:=0;
F_Optimization:=True;
F_DinamicLoadOptimization:=_Auto;
F_PostCodeOptimizator:=True;
F_CalcConstExpr:=True;
F_SyntaxExtension:=True;
F_ShowException:=False;
F_ExternalException:=False;

F_LeadToLowerCase:=True; {.245}
F_SkippedIF:=True; {.245}

F_TreeOptimization:=_Auto;
F_CalcConstantFunc:=True;
F_LevelReplace:=3;
F_CloseArg:=False;
F_PackageCompile:=False;
F_ParamType:=_Double;
F_DataType:=_Double;
F_ReplaceFunction:=True;
F_ReplaceOperation:=True;
F_UseVirtAlloc:=False;
C_2dqrPi:=2/sqrt(_Pi);
CreateExchTable(FuncList,XchTable);
F_XchTableTrig:=True;
F_XchTableHYP:=True;
SetExchTableTrig(1);
SetExchTableHYP(1);
ExtException:=nil;
F_Replace_ARGF:=False;
F_EnableReplaceInPackage:=False; {.205}
F_DisableReplaceIF:=False;   {.205}
F_ConvertAtanToAtan2:=True; {.209}

F_AddSubOptimization:=True;  {.243}
F_MulDivOptimization:=True;  {.243}
F_EnableCalcConsExprInMulti:=False;  {.245}

F_EnableMaskFpuException:=False; {.248}
F_FuncArgOpt:=True; {.249}

CWMEM:=$1372;

SetNewVar('##fvar',Cardinal(@V_FVar),_EXTENDED);
AddExtFunc;
end;



procedure TForevalH.AddExtFunc;
var
Func: TAdditionalFunc;
ID: Cardinal;
begin
 /////////////////////////EXTERNAL FUNCTIONS////////////////////////////////////


(*
   Func.Arg:=0;
   Func.addr:=0;
   Func.FType:=0;
   Func.SaveReg:=0;
   Func.inl:=0;
   Func.Id_Func:=0;
   Func.CLST:=0;
   Func.Arrow:=0;
   Func.Set_ID:=0;
   Func.NST:=0;
   Func.ArgType:=0;
   SetLength(Func.ArgTypeList,0);
   SetLength(Func.inlCode,0);


Func.addr:=@R_AVR;
Func.ArgType:=_Extended;
Func.FType:=-14;//fl_INFINITE_STACK_CPU;
Func.NST:=2;
Func.Name:='avrd';
AddNewFunction(Func,ID);

Func.addr:=@R_MIN;
Func.ArgType:=_Extended;
Func.FType:=-14;//fl_INFINITE_STACK_CPU;
Func.NST:=2;
Func.Name:='mind';
AddNewFunction(Func,ID);


Func.addr:=@R_MAX;
Func.ArgType:=_Extended;
Func.FType:=-14;//fl_INFINITE_STACK_CPU;
Func.NST:=2;
Func.Name:='maxd';
AddNewFunction(Func,ID);


Func.addr:=@R_SUM;
Func.ArgType:=_Extended;
Func.FType:=-14;//fl_INFINITE_STACK_CPU;
Func.NST:=2;
Func.Name:='sumd';
AddNewFunction(Func,ID);

Func.addr:=@R_SUMQ;
Func.ArgType:=_Extended;
Func.FType:=-14;//fl_INFINITE_STACK_CPU;
Func.NST:=2;
Func.Name:='sumqd';
AddNewFunction(Func,ID);


Func.addr:=@R_NORM;
Func.ArgType:=_Extended;
Func.FType:=-14;//fl_INFINITE_STACK_CPU;
Func.NST:=2;
Func.Name:='normd';
AddNewFunction(Func,ID);

*)
end;




procedure TForevalH.SetExchTableTrig(k: Integer);
begin

if k = 1 then F_XchTableTrig:= True else  F_XchTableTrig:= False;

 //enable
if F_XchTableTrig = True then
 begin
   //arcsin->arccos
 XchTable[C_ARCSIN,C_ARCCOS].RCS:=2;   XchTable[C_ARCSIN,C_ARCCOS].WCS:=1;   XchTable[C_ARCSIN,C_ARCCOS].NC:=1;
 //arccos->arcsin
 XchTable[C_ARCCOS,C_ARCSIN].RCS:=2;   XchTable[C_ARCCOS,C_ARCSIN].WCS:=1;   XchTable[C_ARCCOS,C_ARCSIN].NC:=1;


 //arctg->arcctg
 XchTable[C_ARCTAN,C_ARCCOTAN].RCS:=2;   XchTable[C_ARCTAN,C_ARCCOTAN].WCS:=1;   XchTable[C_ARCTAN,C_ARCCOTAN].NC:=1;
 //arcctg->arctg
 XchTable[C_ARCCOTAN,C_ARCTAN].RCS:=1;   XchTable[C_ARCCOTAN,C_ARCTAN].WCS:=2;   XchTable[C_ARCCOTAN,C_ARCTAN].NC:=1;

//tg->ctg
 XchTable[C_TAN,C_COTAN].RCS:=2;   XchTable[C_TAN,C_COTAN].WCS:=1;   XchTable[C_TAN,C_COTAN].NC:=1;
 //ctg->tg
 XchTable[C_COTAN,C_TAN].RCS:=1;   XchTable[C_COTAN,C_TAN].WCS:=2;   XchTable[C_COTAN,C_TAN].NC:=1;

 //sin->cos  ( fsincos)
 XchTable[C_SIN,C_COS].RCS:=1;  XchTable[C_SIN,C_COS].WCS:=2;  XchTable[C_SIN,C_COS].NC:=1;
 //cos->sin ( fsincos)
 XchTable[C_COS,C_SIN].RCS:=1;  XchTable[C_COS,C_SIN].WCS:=2;  XchTable[C_COS,C_SIN].NC:=1;
end
else
//disable
if F_XchTableTrig = False then
begin
   //arcsin->arccos
 XchTable[C_ARCSIN,C_ARCCOS].RCS:=0;   XchTable[C_ARCSIN,C_ARCCOS].WCS:=0;   XchTable[C_ARCSIN,C_ARCCOS].NC:=0;
 //arccos->arcsin
 XchTable[C_ARCCOS,C_ARCSIN].RCS:=0;   XchTable[C_ARCCOS,C_ARCSIN].WCS:=0;   XchTable[C_ARCCOS,C_ARCSIN].NC:=0;


 //arctg->arcctg
 XchTable[C_ARCTAN,C_ARCCOTAN].RCS:=0;   XchTable[C_ARCTAN,C_ARCCOTAN].WCS:=0;   XchTable[C_ARCTAN,C_ARCCOTAN].NC:=0;
 //arcctg->arctg
 XchTable[C_ARCCOTAN,C_ARCTAN].RCS:=0;   XchTable[C_ARCCOTAN,C_ARCTAN].WCS:=0;   XchTable[C_ARCCOTAN,C_ARCTAN].NC:=0;

//tg->ctg
 XchTable[C_TAN,C_COTAN].RCS:=0;   XchTable[C_TAN,C_COTAN].WCS:=0;   XchTable[C_TAN,C_COTAN].NC:=0;
 //ctg->tg
 XchTable[C_COTAN,C_TAN].RCS:=0;   XchTable[C_COTAN,C_TAN].WCS:=0;   XchTable[C_COTAN,C_TAN].NC:=0;

 //sin->cos  ( fsincos)
 XchTable[C_SIN,C_COS].RCS:=0;  XchTable[C_SIN,C_COS].WCS:=0;  XchTable[C_SIN,C_COS].NC:=0;
 //cos->sin ( fsincos)
 XchTable[C_COS,C_SIN].RCS:=0;  XchTable[C_COS,C_SIN].WCS:=0;  XchTable[C_COS,C_SIN].NC:=0;
end;

end;



procedure TForevalH.SetExchTableHYP(k: Integer);
begin

if k = 1 then F_XchTableHYP:= True else  F_XchTableHYP:= False;

 //enable
if F_XchTableHYP = True then
 begin
 //sh->ch (S; 1/S)
 //XchTable[C_SINH,C_COSH].RCS:=2;  XchTable[C_SINH,C_COSH].WCS:=2;  XchTable[C_SINH,C_COSH].NC:=2;
 //sh->ch (S)
 XchTable[C_SINH,C_COSH].RCS:=3;  XchTable[C_SINH,C_COSH].WCS:=3;  XchTable[C_SINH,C_COSH].NC:=1;
 //sh->th (S)
 XchTable[C_SINH,C_TANH].RCS:=3;  XchTable[C_SINH,C_TANH].WCS:=3;  XchTable[C_SINH,C_TANH].NC:=1;
 //sh->cth (S)
 XchTable[C_SINH,C_COTANH].RCS:=3;  XchTable[C_SINH,C_COTANH].WCS:=3;  XchTable[C_SINH,C_COTANH].NC:=1;
 //sh->exp (S)
 XchTable[C_SINH,C_EXP].RCS:=1;  XchTable[C_SINH,C_EXP].WCS:=3;  XchTable[C_SINH,C_EXP].NC:=1;
 //exp->sh (S)
 XchTable[C_EXP,C_SINH].RCS:=3;  XchTable[C_EXP,C_SINH].WCS:=1;  XchTable[C_EXP,C_SINH].NC:=1;
 //exp->ch (S)
 XchTable[C_EXP,C_COSH].RCS:=3;  XchTable[C_EXP,C_COSH].WCS:=1;  XchTable[C_EXP,C_COSH].NC:=1;
 //exp->th (S)
 XchTable[C_EXP,C_TANH].RCS:=3;  XchTable[C_EXP,C_TANH].WCS:=1;  XchTable[C_EXP,C_TANH].NC:=1;
 //exp->cth (S)
 XchTable[C_EXP,C_COTANH].RCS:=3;  XchTable[C_EXP,C_COTANH].WCS:=1;  XchTable[C_EXP,C_COTANH].NC:=1;
 //ch->sh (S; 1/S)
 //XchTable[C_COSH,C_SINH].RCS:=2;  XchTable[C_COSH,C_SINH].WCS:=2;  XchTable[C_COSH,C_SINH].NC:=2;
 //ch->sh (S)
 XchTable[C_COSH,C_SINH].RCS:=3;  XchTable[C_COSH,C_SINH].WCS:=3;  XchTable[C_COSH,C_SINH].NC:=1;
 //ch->th (S)
 XchTable[C_COSH,C_TANH].RCS:=3;  XchTable[C_COSH,C_TANH].WCS:=3;  XchTable[C_COSH,C_TANH].NC:=1;
 //ch->cth (S)
 XchTable[C_COSH,C_COTANH].RCS:=3;  XchTable[C_COSH,C_COTANH].WCS:=3;  XchTable[C_COSH,C_COTANH].NC:=1;
 //ch->exp (S)
 XchTable[C_COSH,C_EXP].RCS:=1;  XchTable[C_COSH,C_EXP].WCS:=3;  XchTable[C_COSH,C_EXP].NC:=1;
 //th->ch (S)
 XchTable[C_TANH,C_COSH].RCS:=3;  XchTable[C_TANH,C_COSH].WCS:=2;  XchTable[C_TANH,C_COSH].NC:=1;
 //th->sh (S)
 XchTable[C_TANH,C_SINH].RCS:=3;  XchTable[C_TANH,C_SINH].WCS:=2;  XchTable[C_TANH,C_SINH].NC:=1;
 //th->cth (th)
 XchTable[C_TANH,C_COTANH].RCS:=2;  XchTable[C_TANH,C_COTANH].WCS:=1;  XchTable[C_TANH,C_COTANH].NC:=1;
 //th->exp (S)
 XchTable[C_TANH,C_EXP].RCS:=1;  XchTable[C_TANH,C_EXP].WCS:=2;  XchTable[C_TANH,C_EXP].NC:=1;
 //cth->ch (S)
 XchTable[C_COTANH,C_COSH].RCS:=3;  XchTable[C_COTANH,C_COSH].WCS:=2;  XchTable[C_COTANH,C_COSH].NC:=1;
 //cth->sh (S)
 XchTable[C_COTANH,C_SINH].RCS:=3;  XchTable[C_COTANH,C_SINH].WCS:=2;  XchTable[C_COTANH,C_SINH].NC:=1;
 //cth->th  (cth)
 XchTable[C_COTANH,C_TANH].RCS:=2;  XchTable[C_COTANH,C_TANH].WCS:=1;  XchTable[C_COTANH,C_TANH].NC:=1;
 //cth->exp (S)
 XchTable[C_COTANH,C_EXP].RCS:=1;  XchTable[C_COTANH,C_EXP].WCS:=2;  XchTable[C_COTANH,C_EXP].NC:=1;
end
else
//disable
if F_XchTableHYP = False then
begin
 //sh->ch (S; 1/S)
 //XchTable[C_SINH,C_COSH].RCS:=2;  XchTable[C_SINH,C_COSH].WCS:=2;  XchTable[C_SINH,C_COSH].NC:=2;
 //sh->ch (S)
 XchTable[C_SINH,C_COSH].RCS:=0;  XchTable[C_SINH,C_COSH].WCS:=0;  XchTable[C_SINH,C_COSH].NC:=0;
 //sh->th (S)
 XchTable[C_SINH,C_TANH].RCS:=0;  XchTable[C_SINH,C_TANH].WCS:=0;  XchTable[C_SINH,C_TANH].NC:=0;
 //sh->cth (S)
 XchTable[C_SINH,C_COTANH].RCS:=0;  XchTable[C_SINH,C_COTANH].WCS:=0;  XchTable[C_SINH,C_COTANH].NC:=0;
 //sh->exp (S)
 XchTable[C_SINH,C_EXP].RCS:=0;  XchTable[C_SINH,C_EXP].WCS:=0;  XchTable[C_SINH,C_EXP].NC:=0;
 //exp->sh (S)
 XchTable[C_EXP,C_SINH].RCS:=0;  XchTable[C_EXP,C_SINH].WCS:=0;  XchTable[C_EXP,C_SINH].NC:=0;
 //exp->ch (S)
 XchTable[C_EXP,C_COSH].RCS:=0;  XchTable[C_EXP,C_COSH].WCS:=0;  XchTable[C_EXP,C_COSH].NC:=0;
 //exp->th (S)
 XchTable[C_EXP,C_TANH].RCS:=0;  XchTable[C_EXP,C_TANH].WCS:=0;  XchTable[C_EXP,C_TANH].NC:=0;
 //exp->cth (S)
 XchTable[C_EXP,C_COTANH].RCS:=0;  XchTable[C_EXP,C_COTANH].WCS:=0;  XchTable[C_EXP,C_COTANH].NC:=0;
 //ch->sh (S; 1/S)
 //XchTable[C_COSH,C_SINH].RCS:=2;  XchTable[C_COSH,C_SINH].WCS:=2;  XchTable[C_COSH,C_SINH].NC:=2;
 //ch->sh (S)
 XchTable[C_COSH,C_SINH].RCS:=0;  XchTable[C_COSH,C_SINH].WCS:=0;  XchTable[C_COSH,C_SINH].NC:=0;
 //ch->th (S)
 XchTable[C_COSH,C_TANH].RCS:=0;  XchTable[C_COSH,C_TANH].WCS:=0;  XchTable[C_COSH,C_TANH].NC:=0;
 //ch->cth (S)
 XchTable[C_COSH,C_COTANH].RCS:=0;  XchTable[C_COSH,C_COTANH].WCS:=0;  XchTable[C_COSH,C_COTANH].NC:=0;
 //ch->exp (S)
 XchTable[C_COSH,C_EXP].RCS:=0;  XchTable[C_COSH,C_EXP].WCS:=0;  XchTable[C_COSH,C_EXP].NC:=0;
 //th->ch (S)
 XchTable[C_TANH,C_COSH].RCS:=0;  XchTable[C_TANH,C_COSH].WCS:=0;  XchTable[C_TANH,C_COSH].NC:=0;
 //th->sh (S)
 XchTable[C_TANH,C_SINH].RCS:=0;  XchTable[C_TANH,C_SINH].WCS:=0;  XchTable[C_TANH,C_SINH].NC:=0;
 //th->cth (th)
 XchTable[C_TANH,C_COTANH].RCS:=0;  XchTable[C_TANH,C_COTANH].WCS:=0;  XchTable[C_TANH,C_COTANH].NC:=0;
 //th->exp (S)
 XchTable[C_TANH,C_EXP].RCS:=0;  XchTable[C_TANH,C_EXP].WCS:=0;  XchTable[C_TANH,C_EXP].NC:=0;
 //cth->ch (S)
 XchTable[C_COTANH,C_COSH].RCS:=0;  XchTable[C_COTANH,C_COSH].WCS:=0;  XchTable[C_COTANH,C_COSH].NC:=0;
 //cth->sh (S)
 XchTable[C_COTANH,C_SINH].RCS:=0;  XchTable[C_COTANH,C_SINH].WCS:=0;  XchTable[C_COTANH,C_SINH].NC:=0;
 //cth->th  (cth)
 XchTable[C_COTANH,C_TANH].RCS:=0;  XchTable[C_COTANH,C_TANH].WCS:=0;  XchTable[C_COTANH,C_TANH].NC:=0;
 //cth->exp (S)
 XchTable[C_COTANH,C_EXP].RCS:=0;  XchTable[C_COTANH,C_EXP].WCS:=0;  XchTable[C_COTANH,C_EXP].NC:=0;
end;

end;




procedure TForevalH.SetStackDeep(S: Integer);
begin
F_StackDeep:=S;
if F_StackDeep > 8 then F_StackDeep:=8
else
if F_StackDeep < 0 then F_StackDeep:=0;
end;







procedure TForevalH.SetLevelReplace(L: Integer);
begin
F_LevelReplace:=L;
end;


function TForevalH.GetLevelReplace: Integer;
begin
GetLevelReplace:=F_LevelReplace;
end;



procedure TForevalH.SetReg(Reg: Integer; SC: Integer);
begin
Cmpl.SetRegA(Reg,SC);
end;


function  TForevalH.GetReg(R: Integer): Integer;
begin
  GetReg:=Cmpl.GetReg(R);
end;


procedure TForevalH.SetPkgData(PD: TArrayPkg);
begin
 //SetLength(PkgData,Length(PD^));
 PkgData:=PD;
end;



procedure TForevalH.SaveSW;
var
SSW: integer;
begin
 //  :  SW,    
SSW:=0;
if F_SaveSW = False then
begin
 asm
    push eax
    xor  eax,eax
    fnstsw ax
    sahf
    test ax, 001Fh

    jz @@Z

    push ax
    fnstsw ax
    mov word ptr [SWMEM],ax
    pop  ax
    mov SSW,1

    @@Z:
    pop eax

 end;

  if SSW = 1 then F_SaveSW:=True;
end;

end;



procedure TForevalH.ClearFPUException;    {.248}
begin
 asm
    fnclex
 end;
end;


procedure TForevalH.MaskFPUException(CWAddr: PCardinal);    {.248}  stdcall;
begin
 asm
    push eax
    mov eax,CWAddr
    fnstcw word ptr [eax];       //->store
    pop eax
    sub esp,4
    fnstcw [esp];
    or word ptr [esp], 003Fh;
    fldcw [esp];
    add esp, 4
 end;
end;


 {.248}
function TForevalH.IsFPUException(CWAddr: PCardinal): integer;   stdcall;
begin
asm
    push eax
    push ecx
    xor  eax,eax
    fnstsw ax
    sahf
    test ax, 001Fh
    mov  ecx,0
    //push $00000000
    jz @@Z
    mov  ecx,1
    //mov [esp],$00000001
    @@Z:
    mov dword ptr Result,ecx
    //pop dword ptr Result //[IsFPUException]
    fnclex
    mov eax,CWAddr
    fldcw  word ptr [eax]   //<-load
    pop ecx
    pop eax
end;
end;



 {.249}
function TForevalH.IsFPUExceptionSW(CWAddr: PCardinal): integer;   stdcall;
begin
asm
    push eax
    push ecx
    xor  eax,eax
    //fnstsw ax
    mov ax,word ptr [SWMEM]
    sahf
    test ax, 001Fh
    mov  ecx,0
    //push $00000000
    jz @@Z
    mov  ecx,1
    //mov [esp],$00000001
    @@Z:
    mov dword ptr Result,ecx
    //pop dword ptr Result //[IsFPUException]
    fnclex
    mov eax,CWAddr
    fldcw  word ptr [eax]   //<-load
    pop ecx
    pop eax
end;
end;


procedure TForevalH.TryFPUMask{(CWMEM: PCardinal)};
begin
 F_SaveSW:=False;
 if F_EnableMaskFpuException = True then MaskFPUException(@CWMEM{CWMEM}); {.249}
end;



procedure TForevalH.TryCatchFPUException{(CWMEM: PCardinal)};
begin
{if IsFPUException(@CWMEM) <> 0 then
begin
  F_InternalError:=E_InvalidOp;
  F_ErrorCode:=E_InvalidOp;
end;  }

  if F_EnableMaskFpuException = True then    {.249}
   begin
     if F_SaveSW = True then
     begin
       if IsFPUExceptionSW(@CWMEM{CWMEM}) <> 0 then
       begin
         F_InternalError:=E_InvalidOp;
         F_ErrorCode:=E_InvalidOp;
       end;
     end
     else
     begin
       if IsFPUException(@CWMEM{CWMEM}) <> 0 then
       begin
         F_InternalError:=E_InvalidOp;
         F_ErrorCode:=E_InvalidOp;
       end;
     end;
   end;

end;

//old: build 201
(*
procedure TForevalH.SetExtExpression(S: String;  Atr: TAttrib; var E_Func: TFunction);
label beginp,endp;
var
//I_PointToData: PStack;
I_Func: TFunction;
I_LFunc: TIntegType;
//E: Exception;
NAdr: Cardinal;
LS: Integer;
cc,FIF: boolean;
begin
{$IFDEF DEBUGS}
   G_Test1:=0;
   G_Test2:=0;
   G_Test3:=0;
{$ENDIF}

cc:=false;
beginp:

V_FVar:=0; {.199}
InitConstDb;
F_Attrib:= Atr;
try
Tree:=nil;
BeginTree:=nil;

Func:=E_Func;
Func.Data:=nil;
F_OverFlowFunc:=False;
F_ErNum:=0;
F_ErrorCode:=0;
F_InternalError:=0;
F_VarPresent:=False;
F_SyntaxErrorString:='';
F_GotoPresent:=False;
F_NopPresent:=False;
F_EnableCalcConstExpression:=True;
CurrentExpression:=Copy(S,1,Length(S));
PrevTreat(S,S);
Linker(S);
SetNL;
SetNM;
SetLoadSource;
if (F_TreeOptimization <> _Disable) and (F_OverFlowFunc = False) and (F_Optimization = True)
   then TreeOptimizator;
SetNM; // TreeOptimizator !!!, ..   
CodeGeneration;

// CopyStack  lda, compile
FIF:=FindIfFunc;
if  FIF = False then   //     IF,  CopyStack  .
   if (F_PostCodeOptimizator = True) and (F_Optimization = True) then PostCodeOptimization;

if (F_DinamicLoadOptimization <> _Disable) and (F_OverFlowFunc = False) and (F_Optimization = True)
   then  DinamicLoadOptimizator;

SetStackSize;
Cmpl.Init(FuncList,VarList,F_StackDeep,F_ParamType,F_DataType,F_SaveInStack,F_CloseArg,F_Attrib,F_UseVirtAlloc);
Cmpl.Compile(@Func,Interp,NAdr);
//Func.Addr:=TAddress(@Func.Code[NAdr]);  {.199}

Db_CmplMaxStack:=Cmpl.GetMaxStack;
Db_CmplOverFlow:=Cmpl.OverFlow;

if (FIF = True) or (F_GotoPresent = True) or (F_NopPresent = True) then F_EnableCalcConstExpression:=False;


except
 //on E: ESyntaxError     do ;
 on E: EZeroDivide      do F_InternalError:=E_ZeroDivide;
 on E: EInvalidOp       do F_InternalError:=E_InvalidOp;
 on E: EOverFlow        do F_InternalError:=E_OverFlow;
 on E: EUnderFlow       do F_InternalError:=E_UnderFlow;
 on E: EIntOverFlow     do F_InternalError:=E_IntOverFlow;
 on E: EAccessViolation do F_InternalError:=E_AccessViolation;
 on E: EOutOfMemory     do F_InternalError:=E_OutOfMemory;
 on E: EStackOverFlow   do F_InternalError:=E_StackOverFlow
end;

if (F_ErrorCode = E_ZeroDivide) and (F_ErNum > 0) then F_SyntaxErrorString:=Copy(Interp[F_ErNum].Expression,1,Length(Interp[F_ErNum].Expression))
else
if (F_ErrorCode = E_InvalidOp) and (F_ErNum > 0) then F_SyntaxErrorString:=Copy(Interp[F_ErNum].Expression,1,Length(Interp[F_ErNum].Expression))
else
if F_ErrorCode = E_ZeroDivide then F_SyntaxErrorString:=Copy(Tree^.Expression,1,Length(Tree.Expression));

FreeInterp;
FreeTree;
E_Func:=Func;
if (F_ErrorCode <> 0) or (F_InternalError <> 0) then
begin
 FreeExtFunc(Func);
 Func.Addr:=0;
 E_Func.Addr:=0;
 CalcException;
 goto endp;
end;


//,   - 
if (F_VarPresent = False) and (F_CalcConstant = True) and (F_CalcConstExpr = True) and (cc = false) and (F_EnableCalcConstExpression = True{F_GotoPresent = False}) then
begin
  NAdr:=Func.Addr;
  try
   asm
    call  NAdr
    fstp  tbyte ptr V_FVar
   end;
  except
   //on E: ESyntaxError     do F_InternalError:=E_AccessViolation;
   on E: EZeroDivide      do F_InternalError:=E_ZeroDivide;
   on E: EInvalidOp       do F_InternalError:=E_InvalidOp;
   on E: EOverFlow        do F_InternalError:=E_OverFlow;
   on E: EUnderFlow       do F_InternalError:=E_UnderFlow;
   on E: EIntOverFlow     do F_InternalError:=E_IntOverFlow;
   on E: EAccessViolation do F_InternalError:=E_AccessViolation;
   on E: EOutOfMemory     do F_InternalError:=E_OutOfMemory;
   on E: EStackOverFlow   do F_InternalError:=E_StackOverFlow
  end;

  {.199}
  S:=FloatToStr(V_FVar);
  if (LowerCase(S)= 'nan') or (LowerCase(S)  = 'inf')  then  F_InternalError:=E_InvalidOp;


  FreeExtFunc(Func);

  if (F_InternalError <> 0) then
  begin
   Func.Addr:=0;
   E_Func.Addr:=0;
   CalcException;
   goto endp;
  end;

  //S:=FloatToStr(V_FVar,G_FMT);
  S:=FloatToStrF(V_FVar, ffGeneral, 20, 4, G_FMT);
  cc:=true;
  goto beginp;
end;

endp:

{$IFDEF DEBUGS}
  //TestG8.Form1.STL.Caption:=IntToStr(N_Stack);
  //TestG8.Form1.LTest1.Caption:=IntToStr(G_Test1);
  //TestG8.Form1.LTest2.Caption:=IntToStr(G_Test2);
  TestG8.Form1.LTest3.Caption:=IntToStr(G_Test3);
{$ENDIF}
end;

*)



procedure TForevalH.SetExtExpression(S: String;  Atr: TAttrib; var E_Func: TFunction);
label beginp,endp,endc;
var
//I_PointToData: PStack;
I_Func: TFunction;
I_LFunc: TIntegType;
//E: Exception;
NAdr: Cardinal;
LS: Integer;
cc,FIF: boolean;
rt,rt1,StSize: Cardinal;
EnableCmpl: Boolean;
begin
{$IFDEF DEBUGS}
   G_Test1:=0;
   G_Test2:=0;
   G_Test3:=0;
{$ENDIF}

cc:=false;
PrevTreat(S,S);
if  F_ErrorCode <> 0 then          {.250}
begin

   Func.Addr:=0;
   E_Func.Addr:=0;
   Func.Code:=nil;
   Func.Data:=nil;
   Func.PAddr:=nil;
   Func.Addr:=0;
   IntException;
   goto endp;

end;


//if S = '#nop' then MessageDlg(S,mtError,[mbOk],0);

beginp:

V_FVar:=0; {.199}
InitConstDb;
InitVarUsed; {.225}
F_Attrib:= Atr;
F_ErNum:=0;
CurrentExpression:=Copy(S,1,Length(S));
F_SyntaxErrorString:=CurrentExpression;

{
 x+power(-1.1,1.1)

x=x+1;y=x+x/(1-1)+y*x; x+y

x=x+1;y=2/(1-1); x+y

x=x+1;y=1/(1-cos(0)); x+y
}
Set8087CW($1372);        {.249}

try
Tree:=nil;
BeginTree:=nil;

//Func:=E_Func;
Func.Code:=nil;
Func.Data:=nil;
Func.PAddr:=nil;
Func.Addr:=0;
F_OverFlowFunc:=False;
F_ErNum:=0;
F_ErrorCode:=0;
F_InternalError:=0;
F_VarPresent:=False;
F_GotoPresent:=False;
F_NopPresent:=False;
F_EnableCalcConstExpression:=True;

(*
{arraycpu} {.245}                //fvd1(vd)
ArgT:=Interp[LFunc].ExtArg;
if (ArgT = _ArrayD) or (ArgT = _ArrayE) or (ArgT = _ArrayS) or (ArgT = _ArrayI)  then
begin
 Interp[LFunc].SData:=_MEM;
 NM:=Interp[LFunc].NM;
 NL:=Interp[LFunc].NL;
 //Interp[NM].RData[NL]:=_MEM;
end;
*)

TryFPUMask{(@CWMEM7)}; {.249}
//CurrentExpression:=Copy(S,1,Length(S));
                    //T1:=GetTickCount;
//PrevTreat(S,S);
                       //Db_TimeExtSyntax:=GetTickCount-T1;
                       //T1:=GetTickCount;
Linker(S);    // <- create tree of expression and check syntax
                       //Db_TimeTreeBuild:=GetTickCount-T1;
//goto endc;
//  (  )    ,     (  )
//F_EnableCalcConsExprInMulti : _CompileMultiExpr
if   (F_EnableCalcConsExprInMulti = True) and (F_VarPresent = True) then  EnableCmpl:= False else EnableCmpl:= True;   {.245}

if (F_ErrorCode = 0) and (EnableCmpl = True)  then   // if no errors - compile
begin
                    //T1:=GetTickCount;
  //  : !
  SetNL;
  SetNM;
  SetLoadSource;
  if (F_TreeOptimization <> _Disable) and (F_OverFlowFunc = False) and (F_Optimization = True)
     then
     begin
      TreeOptimizator;
      SetNM; // TreeOptimizator !!!, ..   
     end;

  GetSizeInterp;    {.207}
  CodeGeneration;     // <- create list of macrocommand: Interp[]

  SetStackSize;
  StSize:=StackSize;
  FreeTree;   {.207}
  // CopyStack  lda, compile
  FIF:=FindIfFunc;


  {if  FIF = False then   //     IF,  CopyStack  .
     if (F_PostCodeOptimizator = True) and (F_Optimization = True) then PostCodeOptimization; }

  {.205}       // - IF    PostCodeOptimization (C_JMP,C_IFNOP,C_GOTO)
                    //Db_TimeCreateComList:=GetTickCount-T1;
                    //T1:=GetTickCount;
   if (F_Optimization = True) then PostCodeOptimization;
   if F_ErrorCode <> 0 then goto endc;     {.249}

                    //Db_TimeAllReplace:=GetTickCount-T1;
                    //T1:=GetTickCount;
  if (F_DinamicLoadOptimization <> _Disable) and (F_OverFlowFunc = False) and (F_Optimization = True)
     then  DinamicLoadOptimizator;
                    //Db_TimeDinLoad:=GetTickCount-T1;
                    //T1:=GetTickCount;
  //SetStackSize;
  SetLength(Func.Stack,StSize+1);
  Cmpl.Init(FuncList,VarList,F_StackDeep,F_ParamType,F_DataType,F_SaveInStack,F_CloseArg,F_Attrib,F_UseVirtAlloc);
  Cmpl.Compile(@Func,Interp,NAdr);
                    //Db_TimeCompile:=GetTickCount-T1;
                    //T1:=GetTickCount;
  //Func.Addr:=TAddress(@Func.Code[NAdr]);  {.199}

  Db_CmplMaxStack:=Cmpl.GetMaxStack;
  Db_CmplOverFlow:=Cmpl.OverFlow;

  if (FIF = True) or (F_GotoPresent = True) or (F_NopPresent = True) then F_EnableCalcConstExpression:=False;

  //F_RetNum:=FuncList[Interp[High(Interp)].Code].RetNum;

  F_RetNum:=Cmpl.RetNum; {.203}
  Db_LoadStackAfterCalc:=Cmpl.LoadStackAfterCalc; {.207}          //=0,1!!!
end;

endc:
TryCatchFPUException{(@CWMEM7)}; {.249}
except
 //on E: ESyntaxError     do ;
 on E: EZeroDivide      do F_InternalError:=E_ZeroDivide;
 on E: EInvalidOp       do F_InternalError:=E_InvalidOp;
 on E: EOverFlow        do F_InternalError:=E_OverFlow;
 on E: EUnderFlow       do F_InternalError:=E_UnderFlow;
 on E: EIntOverFlow     do F_InternalError:=E_IntOverFlow;
 on E: EAccessViolation do F_InternalError:=E_AccessViolation;
 on E: EOutOfMemory     do F_InternalError:=E_OutOfMemory;
 on E: EStackOverFlow   do F_InternalError:=E_StackOverFlow
end;

if (F_InternalError = E_ZeroDivide) and (F_ErNum > 0) then F_SyntaxErrorString:=Copy(Interp[F_ErNum].Expression,1,Length(Interp[F_ErNum].Expression))
else
if (F_InternalError = E_InvalidOp) and (F_ErNum > 0) then F_SyntaxErrorString:=Copy(Interp[F_ErNum].Expression,1,Length(Interp[F_ErNum].Expression)) ;



FreeInterp;
FreeTree;

if (F_ErrorCode <> 0) or (F_InternalError <> 0) then
begin
 FreeExtFunc(@Func);
 IntException;
 goto endp;
end;


//,   - 
if (F_VarPresent = False) {and (F_CalcConstantFunc = True)} and (F_CalcConstExpr = True) and (cc = false) and (F_EnableCalcConstExpression = True{F_GotoPresent = False}) then
begin
    //TryFPUMask(@CWMEM8); {.249}
     TryFPUMask; {.249}

     NAdr:=Func.Addr;
     try
        asm
          call  NAdr
          fstp  tbyte ptr V_FVar
        end;
     FV_Result:=V_FVar;

     TryCatchFPUException;    {.249}
   //TryCatchFPUException(@CWMEM8);    {.249}


    except
     //on E: ESyntaxError     do F_InternalError:=E_AccessViolation;
     on E: EZeroDivide      do F_InternalError:=E_ZeroDivide;
     on E: EInvalidOp       do F_InternalError:=E_InvalidOp;
     on E: EOverFlow        do F_InternalError:=E_OverFlow;
     on E: EUnderFlow       do F_InternalError:=E_UnderFlow;
     on E: EIntOverFlow     do F_InternalError:=E_IntOverFlow;
     on E: EAccessViolation do F_InternalError:=E_AccessViolation;
     on E: EOutOfMemory     do F_InternalError:=E_OutOfMemory;
     on E: EStackOverFlow   do F_InternalError:=E_StackOverFlow
  end;

  {.199}
  S:=FloatToStr(V_FVar);
  if (LowerCase(S)= 'nan') or (LowerCase(S)  = 'inf') or (LowerCase(S)  = '-inf') then  F_InternalError:=E_InvalidOp;


  FreeExtFunc(@Func);

  if (F_InternalError <> 0) then
  begin
   Func.Addr:=0;
   E_Func.Addr:=0;
   F_SyntaxErrorString:=CurrentExpression; {.245}
   IntException;
   goto endp;
  end;

  //S:=FloatToStr(V_FVar,G_FMT);
  S:=FloatToStrF(V_FVar, ffGeneral, 20, 4, G_FMT);
  cc:=true;     //  V_FVar  fdl const
  goto beginp;
end;

endp:
E_Func:=Func; {.245}

Set8087CW($1372);    {.249}
                    //Db_FreeMem:=GetTickCount-T1;

{$IFDEF DEBUGS}
  //TestG8.Form1.STL.Caption:=IntToStr(N_Stack);
  //TestG8.Form1.LTest1.Caption:=IntToStr(G_Test1);
  //TestG8.Form1.LTest2.Caption:=IntToStr(G_Test2);
  //TestG8.Form1.LTest3.Caption:=IntToStr(G_Test3);
{$ENDIF}
end;



 {.245}
procedure TForevalH.SafeCalcResult(NAdr: TAddress; var FRes: TFloatType);
var
S: String;
begin

FRes:=0;
 try
   asm
    call  NAdr
    fstp  tbyte ptr V_FVar
   end;
  except
   //on E: ESyntaxError     do F_InternalError:=E_AccessViolation;
   on E: EZeroDivide      do F_InternalError:=E_ZeroDivide;
   on E: EInvalidOp       do F_InternalError:=E_InvalidOp;
   on E: EOverFlow        do F_InternalError:=E_OverFlow;
   on E: EUnderFlow       do F_InternalError:=E_UnderFlow;
   on E: EIntOverFlow     do F_InternalError:=E_IntOverFlow;
   on E: EAccessViolation do F_InternalError:=E_AccessViolation;
   on E: EOutOfMemory     do F_InternalError:=E_OutOfMemory;
   on E: EStackOverFlow   do F_InternalError:=E_StackOverFlow
  end;


  S:=FloatToStr(V_FVar);
  if (LowerCase(S)= 'nan') or (LowerCase(S)  = 'inf') or (LowerCase(S)  = '-inf') then  F_InternalError:=E_InvalidOp;


  if (F_InternalError <> 0) then
  begin
   IntException;
  end
  else
  FRes:=V_FVAR;


end;



procedure TForevalH.CheckSyntax(S: String; var S1: String);
label beginp,endp;
var
//I_PointToData: PStack;
I_Func: TFunction;
I_LFunc: TIntegType;
//E: Exception;
NAdr: Cardinal;
LS: Integer;
cc,FIF: boolean;
begin


cc:=false;
beginp:

InitConstDb;
//F_Attrib:= Atr;

try
Tree:=nil;
BeginTree:=nil;

//Func:=E_Func;
//Func.Data:=nil;
F_OverFlowFunc:=False;
F_ErNum:=0;
F_ErrorCode:=0;
F_InternalError:=0;
F_VarPresent:=False;
F_SyntaxErrorString:='';
F_GotoPresent:=False;
F_NopPresent:=False;
F_EnableCalcConstExpression:=True;
CurrentExpression:=Copy(S,1,Length(S));
PrevTreat(S,S);
Linker(S);


except
 //on E: ESyntaxError     do ;
 on E: EZeroDivide      do F_InternalError:=E_ZeroDivide;
 on E: EInvalidOp       do F_InternalError:=E_InvalidOp;
 on E: EOverFlow        do F_InternalError:=E_OverFlow;
 on E: EUnderFlow       do F_InternalError:=E_UnderFlow;
 on E: EIntOverFlow     do F_InternalError:=E_IntOverFlow;
 on E: EAccessViolation do F_InternalError:=E_AccessViolation;
 on E: EOutOfMemory     do F_InternalError:=E_OutOfMemory;
 on E: EStackOverFlow   do F_InternalError:=E_StackOverFlow
end;


//FreeInterp;
FreeTree;

if (F_ErrorCode <> 0) or (F_InternalError <> 0) then
begin
 //may occur errors in FPC  -> disable this:
 IntException;
end;


S1:=Copy(S,1,Length(S));
endp:
end;




function TForevalH.GetVarList:TVarList;
begin
 GetVarList:=VarList;
end;




function TForevalH.FindIfFunc: Boolean;
label endp;
var
i: Integer;
begin
 for i:=1 to Length(Interp)-1 do
 begin
  if (Interp[i].Code = C_IFNOP) or (Interp[i].Code = C_LDA)  or (Interp[i].Code = C_COMPILED)
  or (Interp[i].Code = C_JMP) or  (Interp[i].Code = C_GOTO)
  then  begin FindIfFunc:=True; goto endp; end;
 end;

FindIfFunc:=False;

endp:
end;


procedure TForevalH.FreeInterp;
var
i: Integer;
begin
for i:=0 to Length(Interp)-1 do
begin
Interp[i].PN:=nil;
Interp[i].PM:=nil;
Interp[i].PI:=nil;
Interp[i].PC:=nil;
Interp[i].SGN:=nil;
Interp[i].AFB:=nil;
Interp[i].RData:=nil;
Interp[i].SNExtArg:=nil;
Interp[i].Expression:='';
Interp[i].ExpressionArg:='';   
end;
Interp:=nil;
end;





 (*
procedure TForevalH.FreeExtFunc(E_Func: TFunction);
var
i: TIntegType;
begin
{.199}
 if E_Func.AllocMem = 2 then
 begin
   VirtualFree(E_Func.PAddr,0,MEM_RELEASE);
 end;


FreeFuncData(E_Func.Data);
E_Func.Code:=nil;             //E_Func.AllocMem = 1
E_Func.Stack:=nil;
E_Func.CpSt:=nil;
E_Func.PAddr:=nil;
E_Func.Data:=nil;
E_Func.Addr:=0;
end;
  *)



procedure TForevalH.FreeExtFunc(E_Func: PFunction);    {.247}   //on pointer
var
i: TIntegType;
begin
{.199}
 if E_Func.AllocMem = 2 then
 begin
   VirtualFree(E_Func^.PAddr,0,MEM_RELEASE);
 end;


FreeFuncData(E_Func^.Data);
E_Func^.Code:=nil;             //E_Func.AllocMem = 1
E_Func^.Stack:=nil;
E_Func^.CpSt:=nil;
E_Func^.PAddr:=nil;
E_Func^.Data:=nil;
E_Func^.Addr:=0;
end;


procedure TForevalH.FreeFuncData(FuncData: PFuncData);
var
FD1,FD2: PFuncData;
begin

FD1:=FuncData;
while FD1 <> nil do
begin
 FD2:=FD1^.Next;
 dispose(FD1);
 FD1:=FD2;
end;

end;







procedure TForevalH.AddNewFunction(Func: TAdditionalFunc; var ID: Cardinal);
label endp;
var
i,j,HF,XA: Integer;
begin
//     :
//if (Func.FType >= 11) and (Func.FType <= 14) then Func.Arg:=-1;
{
for i := 0 to High(FuncList) do
  begin
    for j := 0 to High(FuncList[i].Name) do
    begin
     if (Func.Name = FuncList[i].Name[j]) then goto endp;
    end;
  end;
}
if CheckName(Func.Name) = false then begin F_ErrorCode:=E_WRONG_NAME; F_SyntaxErrorString:=Func.Name; IntException; goto endp; end;

if (Func.FType < 0)  then XA:=_No else XA:=_Yes; {.205}

SetLength(FuncList,Length(FuncList)+1);
HF:=High(FuncList);
SetLength(FuncList[HF].Name,2);
FuncList[HF].Addr:=Func.addr;
FuncList[HF].inl:=Func.inl;
FuncList[HF].Arg:=Func.Arg;
FuncList[HF].FType:=Func.FType;
FuncList[HF].ArgType:=Func.ArgType;
FuncList[HF].Arrow:=Func.Arrow;
FuncList[HF].CLST:=Func.CLST;
FuncList[HF].Set_Id:=Func.Set_Id;
FuncList[HF].Id_Func:=Func.Id_Func;
FuncList[HF].ArgType:=Func.ArgType;
FuncList[HF].NST:=Func.NST;
FuncList[HF].SaveReg:=Func.SaveReg;
FuncList[HF].Enabled:=_Yes;
FuncList[HF].CalcConst:=Func.CalcConst;
FuncList[HF].RetNum:=Func.RetNum;
FuncList[HF].ReplFunc:=Func.ReplFunc;
FuncList[HF].XchArg:=XA;

FuncList[HF].Name[1]:=Copy(Func.Name,1,Length(Func.Name));
if Func.ArgType = _Differ then
begin
 SetLength(FuncList[HF].ArgTypeList,Length(Func.ArgTypeList));
 for i:=0 to High(Func.ArgTypeList) do
 FuncList[HF].ArgTypeList[i]:=Func.ArgTypeList[i];
end;
Func.ArgTypeList:=nil;
if Func.inl = 1 then
begin
 SetLength(FuncList[HF].inlCode,Length(Func.inlCode));
 for i:=0 to High(Func.inlCode) do
 FuncList[HF].inlCode[i]:=Func.inlCode[i];
end;
if Func.FType = -16 then
begin
 SetLength(FuncList[HF].ArgAdr,Length(Func.ArgAdr));
 for i:=0 to High(Func.ArgAdr) do
 FuncList[HF].ArgAdr[i]:=Func.ArgAdr[i];
end;
Func.ArgAdr:=nil;

//LX:=Length(XchTable);
SetLength(XchTable,HF+1,HF+1);

for i:=1 to HF do
begin
  XchTable[HF,i].RCS:=0;
  XchTable[HF,i].WCS:=0;
  XchTable[HF,i].NC:=0;

  XchTable[i,HF].RCS:=0;
  XchTable[i,HF].WCS:=0;
  XchTable[i,HF].NC:=0;
end;

if (Func.FType > 0) or  (Func.ReplFunc = _Yes)    then i:=1 else  i:=0;

XchTable[HF,HF].RCS:=i;
XchTable[HF,HF].WCS:=i;
XchTable[HF,HF].NC:=i;

ID:=HF;
Func.inlCode:=nil;

endp:
end;



procedure TForevalH.FreeAddFunction;
begin
 SetLength(FuncList,LFuncList);
 SetLength(XchTable,LFuncList+1,LFuncList+1);
end;


procedure TForevalH.FreeVar;
begin
 VarList:=nil;
 SetNewVar('##fvar',Cardinal(@V_FVar),_EXTENDED);
end;


procedure TForevalH.FreeParam;
begin
 ParamList:=nil;
end;




procedure TForevalH.ClearVar;
var
i: TIntegType;
Pm: Pointer;
begin


for i:=0 to High(VarList) do
begin
 Pm:=Pointer(VarList[i].Addr);
 if VarList[i].VType = _Integer then Integer(Pm^):=0
 else
 if VarList[i].VType = _Double then Double(Pm^):=0
 else
 if VarList[i].VType = _Extended then Extended(Pm^):=0
 else
 if VarList[i].VType = _Single then Single(Pm^):=0;
end;

end;


procedure TForevalH.ClearParam;
var
i: TIntegType;
begin
for i:=1 to High(ParamList) do
begin
ParamList[i].Value:=0;
end;
end;

constructor TForevalH.Create;
begin
GetLocaleFormatSettings(0,G_FMT);
G_FMT.DecimalSeparator:='.';
CreateInitData;
end;


destructor TForevalH.Destroy;
var
  I,J: Integer;
begin
Cmpl.Destroy;

//if Func.Data <> nil then dispose(Func.Data);

for I := 0 to High(ParamList) do
begin
  ParamList[i].Name:='';
end;
ParamList:=nil;

for I := 0 to High(VarList) do
begin
  VarList[i].Name:='';
end;
VarList:=nil;

for I := 0 to High(FuncList) do
begin
  for j := 0 to High(FuncList[i].Name) do
  begin
    FuncList[i].Name[j]:='';
  end;
  FuncList[i].Name:=nil;

  FuncList[i].ArgTypeList:=nil;
  FuncList[i].inlCode:=nil;
  FuncList[i].ArgTypeList:=nil;
  FuncList[i].ArgAdr:=nil;
end;
FuncList:=nil;

Factorial:=nil;
Factorial1:=nil;
Factorial2:=nil;
Factorial2F:=nil;
inherited Destroy;
end;



procedure TForevalH.FreeTree;
label endp;
var
H: PNode;
S,S1: String;
begin
//if F_ErrorCode <> 0 then goto endp;
if BeginTree = nil then goto endp;

Tree:=BeginTree;

while Tree^.Ch <> nil do
begin
Tree:=Tree^.Ch;
end;
//COP=NOP

while Tree^.Pr <> nil do
begin
 while Tree^.Nb <> nil  do
 begin
  H:=Tree; Tree:=Tree^.Nb;  H^.Nb:=nil;
  H^.SGN:=nil;    H^.PN.FM:=nil;
  H^.PN1.FM:=nil; H^.PN.IM:=nil;
  H^.PN1.IM:=nil; H^.AFB:=nil;
  H^.RData:=nil;  H^.SNExtArg:=nil;
  H^.Expression:=''; H^.ExpressionArg:='';  
  dispose(H);

  while Tree^.Ch <> nil do
  begin
  Tree:=Tree^.Ch;
  end;
 //COP=NOP
 end;

//COP<>NOP
H:=Tree; Tree:=Tree^.Pr; H^.Pr:=nil;
H^.SGN:=nil;    H^.PN.FM:=nil;
H^.PN1.FM:=nil; H^.PN.IM:=nil;
H^.PN1.IM:=nil; H^.AFB:=nil;
H^.RData:=nil;  H^.SNExtArg:=nil;
H^.Expression:=''; H^.ExpressionArg:='';   
//S:=H^.Expression;
//S1:=H^.COP;
dispose(H);
end;
{.199}
Tree^.SGN:=nil;    Tree^.PN.FM:=nil;
Tree^.PN1.FM:=nil; Tree^.PN.IM:=nil;
Tree^.PN1.IM:=nil; Tree^.AFB:=nil;
Tree^.RData:=nil;  Tree^.SNExtArg:=nil;
Tree^.Expression:='';   Tree^.ExpressionArg:='';
dispose(Tree);

Tree:=nil; BeginTree:=nil;
endp:
end;




procedure TForevalH.IntException;
label endp;
var
S: String;
T: Integer;
begin
{
  flSet(fl_ENABLE,fl_SHOW_EXCEPTION,0);
  flSet(fl_DISABLE,fl_SHOW_EXCEPTION,0);

  allows/forbids to show an exception in case of a error  from '.dll'
}

//goto endp;
if F_InternalError <> 0 then
 begin
 case F_InternalError of
  E_AccessViolation:                    S:='ACCESS VIOLATION';
  E_OutOfMemory:                        S:='OUT OF MEMORY';
  E_StackOverFlow:                      S:='STACK OVERFLOW';
  E_IntOverFlow:                        S:='INTEGER OVERFLOW';
  E_UnderFlow:                          S:='UNDERFLOW';
  E_OverFlow:                           S:='OVERFLOW';
  E_InvalidOp:                          S:='INVALID OPERATION';
  E_ZeroDivide:                         S:='DIVIDE ON ZERO';
 end;

 //F_SyntaxErrorString:=Copy(CurrentExpression,1,Length(CurrentExpression));
 F_ErrorCode:=F_InternalError;
 if F_ShowException then
 MessageBox(0,PChar('Foreval Internal Error'+#13+#10+'"'+S+'"'+#13+#10+F_SyntaxErrorString),PChar('Foreval error'),MB_ICONERROR);
 goto endp;
end;



if F_ShowException then
begin
 if F_ErrorCode <> 0 then
 begin
 case F_ErrorCode of
  {E_AccessViolation:                    S:='ACCESS VIOLATION';
  E_OutOfMemory:                        S:='OUT OF MEMORY';
  E_StackOverFlow:                      S:='STACK OVERFLOW';
  E_IntOverFlow:                        S:='INTEGER OVERFLOW';
  E_UnderFlow:                          S:='UNDERFLOW';
  E_OverFlow:                           S:='OVERFLOW';
  E_InvalidOp:                          S:='INVALID OPERATION';
  E_ZeroDivide:                         S:='DIVIDE ON ZERO'; }
  E_UNKNOWN_SYMBOL :                    S:='UNKNOWN SYMBOL or INCORRECT ARGUMENT or WRONG EXPRESSION';
  //E_MISSING_BRACKET_LEFT :              S:='MISSING "(" BRACKET';
  //E_MISSING_BRACKET_RIGHT :             S:='MISSING ")" BRACKET';
  E_MISSING_OPERATION :                 S:='MISSING OPERATION';
  E_INCOINCIDENCE_NUMBER_ARGUMENTS :    S:='INCOINCIDENCE NUMBER OF ARGUMENTS';
  E_MISSING_EXPRESSION :                S:='MISSING EXPRESSION';
  E_UNKNOWN_FUNCTION :                  S:='UNKNOWN FUNCTION';  {.203}
  E_ERROR_AT_ADDITION_FUNCTION:         S:='ERROR AT ADDITION FUNCTION';
  E_NONEXISTENT_FUNCTION:               S:='NONEXISTENT FUNCTION';
  E_INCORRECT_ARGUMENT:                 S:='INCORRECT ARGUMENT';
  E_MISSING_ARGUMENT:                   S:='MISSING ARGUMENT';
  E_INCORRECT_TYPE:                     S:='INCORRECT TYPE';
  E_MISSING_SEPARATOR:                  S:='MISSING SEPARATOR ;';
  E_WRONG_NAME:                         S:='WRONG NAME;';
  E_MISSING_ROUND_BRACKET :             S:='MISSING ROUND BRACKET';
  E_MISSING_CURLY_BRACKET :             S:='MISSING CURLY BRACKET';
  E_MISSING_SQUARE_BRACKET :            S:='MISSING SQUARE BRACKET';
  E_MISSING_ABS_BRACKET :               S:='MISSING ABS BRACKET';
  E_WRONG_EXPRESSION:                   S:='WRONG EXPRESSION';
  E_INCORRECT_SPACE:                    S:='INCORRECT SPACE';
  E_VARIABLE_REDECLARED :               S:='VARIABLE REDECLARED';
 end;
  MessageBox(0,PChar(S+#13+#10+'"'+F_SyntaxErrorString+'"'),PChar('Foreval error'),MB_ICONERROR);
 end;
end;



endp:
 if Assigned(ExtException) then ExtException;
//Abort;
end;



function TForevalH.GetF(C,Code: Integer): Integer;
label endp;
var
  i: Integer;
begin
{if (Code >= 0) and (Code <= High(FuncList)) then
begin
  F_ErrorCode:=E_NONEXISTENT_FUNCTION;
  F_SyntaxErrorString:=IntToStr(Code);
  CalcException;
goto endp;
end; }
//:
  if C = 2 then
  begin
   //  RET
   {if  (FuncList[Code].Addr <> nil) and (FuncList[Code].inl = 1)
       then GetF:=Cardinal(@FuncList[Code].inlCode[0])
   else }
   //  - RET
   if  (FuncList[Code].Addr <> nil) {and (FuncList[Code].inl = 0)}
       then GetF:=Cardinal(FuncList[Code].Addr)
   else
   begin
     F_ErrorCode:=E_NONEXISTENT_FUNCTION;
     F_SyntaxErrorString:=IntToStr(Code);
     IntException;
     goto endp;
   end;
  end
  else
//inl:
  if C = 3 then  GetF:=FuncList[Code].inl
  else
//NST:
  if C = 5 then  GetF:=FuncList[Code].NST
  else
//id_FUNC:
  if C = 6 then  GetF:=FuncList[Code].id_Func
  else
//Set_ID:
  if C = 7 then  GetF:=FuncList[Code].Set_ID
  else
//Arg:
  if C = 8 then  GetF:=FuncList[Code].Arg
  else
//ARROW:
  if C = 9 then  GetF:=FuncList[Code].ARROW
  else
//CLST:
  if C = 10 then  GetF:=FuncList[Code].CLST
  else
//ArgType:
  if C = 11 then  GetF:=FuncList[Code].ArgType
  else
//SaveReg:
  if C = 13 then  GetF:=FuncList[Code].SaveReg
  else
//FType:
  if C = 14 then  GetF:=FuncList[Code].FType
  else
//is var (Func=@var) used?:
  if C = 15 then                         {.225}
  begin
    for i := 0 to Length(VarList) - 1 do
    begin
      if Cardinal(Code) = VarList[i].Addr then
      begin
         if VarList[i].IsUsed = True then GetF:=1 else GetF:=0;
         goto endp;
      end;
    end;

   GetF:=FuncList[Code].ArgType
  end
  else  GetF:=0;

endp:
end;





function TForevalH.GetFuncName(id: cardinal): String;
begin
if (id > 0) and (id < Length(FuncList)) then
  GetFuncName:=FuncList[id].Name[1];
end;


 {.250}
procedure TForevalH.EnDisDerivNames(Code,Value:Integer);
var
LN,cd,id: Integer;
SF,SD: String;
begin
LN:=Length(FuncList[Code].Name);
 if LN > 1 then
 begin
        SF:=FuncList[Code].Name[1];   //  
        cd:=1;
        SD:=SF+'$'+IntToStr(cd);
        FindFuncName(SD,id);
        while  id > 0 do     //   
        begin
           FuncList[id].Enabled:=Value;
           inc(cd);
           SD:=SF+'$'+IntToStr(cd);
           FindFuncName(SD,id);
        end;
 end;
end;



procedure TForevalH.SetF(C,Code,Value: Integer);
label endp;
var
PIC: ^TCode;
PII: ^TArrayI;
RF,RC,k,HL,LN,cd,id: Integer;
FuncCode: array of byte;
f: extended;
Addr:Pointer;
SD,SF: String;
begin
 (*
if C = 108 then
  begin
  //try
     //SetLength(FuncCode,Length(FuncList[Code].inlCode)+1);
   {  for k:=0 to High(FuncList[Code].inlCode) do
     begin
      CodeArray[k]:=FuncList[Code].inlCode[k];
     end;
     CodeArray[High(FuncList[Code].inlCode)+1]:=$C3; //RET
     Addr:=@CodeArray[0];
    }
     Addr:=VirtualAlloc(Nil, 10, MEM_COMMIT or MEM_RESERVE, PAGE_EXECUTE_READWRITE);

     HL:=High(FuncList[Code].inlCode);
     for k:=0 to HL  do
     begin
      PCardinal(Cardinal(Addr)+k)^:=FuncList[Code].inlCode[k];
     end;
      PCardinal(Cardinal(Addr)+HL+1)^:=$C3;

      asm
       fild  value
       pushad
       call Addr
       popad
       fstp F
     end;

     VirtualFree(Addr,0,MEM_RELEASE);
 // except

  //end;

  end;
 *)
if  (Code >= High(FuncList)) then
begin
  F_ErrorCode:=E_NONEXISTENT_FUNCTION;
  F_SyntaxErrorString:=IntToStr(Code);
  IntException;
goto endp;
end;
//:
  if C = 2 then
  begin
   if Value = 0 then FuncList[Code].Addr:=nil
   else
   FuncList[Code].Addr:=Pointer(Value);
   end
  else
//inl:
  if C = 3 then  FuncList[Code].inl:=Value
  else
//inlCode
  if C = 4 then
  begin
   PIC:=Pointer(Value);
   FuncList[Code].inlCode:=PIC^;
  end
  else
//NST:
  if C = 5 then  FuncList[Code].NST:=Value
  else
//id_FUNC:
  if C = 6 then  FuncList[Code].id_Func:=Value
  else
//Set_ID:
  if C = 7 then  FuncList[Code].Set_ID:=Value
  else
//Arg:
  if C = 8 then  FuncList[Code].Arg:=Value
  else
//ARROW:
  if C = 9 then  FuncList[Code].ARROW:=Value
  else
//CLST:
  if C = 10 then  FuncList[Code].CLST:=Value
  else
//ArgType:
  if C = 11 then  FuncList[Code].ArgType:=Value
  else
//ArgTypeList
  if C = 12 then
  begin
   PII:=Pointer(Value);
   FuncList[Code].ArgTypeList:=PII^;
  end
else
//SaveReg:
  if C = 13 then  FuncList[Code].SaveReg:=Value
  else
//FType:
  if C = 14 then  FuncList[Code].FType:=Value
  else
//Enabled
  if C = 15 then
  begin
     FuncList[Code].Enabled:=Value;

     {.250}     //   ,      ( )
     EnDisDerivNames(Code,Value);
     (*
     LN:=Length(FuncList[Code].Name);
     if LN > 1 then
     begin
        SF:=FuncList[Code].Name[1];   //  
        cd:=1;
        SD:=SF+'$'+IntToStr(cd);
        FindFuncName(SD,id);
        while  id > 0 do     //   
        begin
           FuncList[id].Enabled:=Value;
           inc(cd);
           SD:=SF+'$'+IntToStr(cd);
           FindFuncName(SD,id);
        end;

        {
        for k := 0 to LN-1 do   //    -
        begin
           SF:=FuncList[Code].Name[k];
           cd:=1;
           SD:=SF+'$'+IntToStr(cd);
           FindFuncName(SD,id);
           while  id > 0 do     //   
           begin
              FuncList[id].Enabled:=Value;
              inc(cd);
              SD:=SF+'$'+IntToStr(cd);
              FindFuncName(SD,id);
           end;
        end;
        }
     end;
     *)

  end
  else
//replace
  if C = 16 then      {.199}
  begin
    if Value = _Yes then RF:=1 else if Value = _NO then  RF:=0;

      FuncList[Code].ReplFunc:=Value;

      XchTable[code,code].RCS:=RF;
      XchTable[code,code].WCS:=RF;
      XchTable[code,code].NC:=RF;

      if (code = C_AAF) or (code = C_MAF) or (code = C_FAVB) then {.201}
      begin
        if Value = _Yes then  F_Replace_ARGF:=True else  F_Replace_ARGF:=False
      end;

  end
  else
  //calcconst
  if C = 17 then      {.203}
  begin
    FuncList[Code].CalcConst:=Value;
  end;





endp:
end;

 (*
function TForevalH.StrToFloatEx(S: String; var Vex: extended): boolean;     {.203}
var
ex: extended;
begin
SB:=0;
  if TryStrToFloat(S,ex,G_FMT) = true then
  begin
    SB:=1;
    Vex:=StrToFloat(S,G_FMT);
  end
  else
  begin
    SB:=0;
    Vex:=0;
  end;
end;
*)

end.
