unit ForevalZ_Main;

{******************************************************************************}
{                                                                              }
{                                 ver 1.3.5.229                                }
{----------------------------------------------------------------------------- }
{       .            }
{------------------------------------------------------------------------------}
{ The module contains the parser and compiler of expressions.                  }
{------------------------------------------------------------------------------}
{                  SOREL   (C)CopyRight 2000. Russia, S.-Petersburg.           }
{******************************************************************************}


//{$RangeChecks On}          //{$R+}
//{$OverFlowChecks On}       //{$Q+}
//{$ZEROBASEDSTRINGS Off}

{$R-}
{$Q-}


{$IFDEF FPC}
  {$MODE DELPHI}
{$ENDIF}



{.$DEFINE DEBUGS}            //db

interface

uses
  Windows,  SysUtils, StrUtils, Math,  ForevalZ_Command, ForevalZ_SpecFunc{,Classes,  Dialogs, Forms, Controls, StdCtrls};

  const  CWFPU: WORD = $1372;
  const _PI:extended = 3.1415926535897932384626433832795;
  const  PI_2: extended = 3.1415926535897932384626433832795/2;

  const rPI: extended = 3.14159265358979323846264/180;
  const dPI: extended = 180/3.14159265358979323846264;

  const  _LDSF = 3;
  const  _LDSC = 4;
  const  _FUNC = 1;
  const  _COP  = 2;
  const  _JMP  = 5; //String Name: #JMP, #JMPE, #JMPEL, #JMPEB, #JMPB, #JMPL, #JMPNE
  const  _FLD  = 6; //FLD1,FLDZ
  const  _LDSCX = 7;
  const  _NOP = 0; {.193}
  //const  _LDSV = 5;

  const _Single = 1;
  const _Double = 2;
  const _Extended = 3;
  const _Pointer = 5;
  const _Integer = 4;

  const _None = 0;
  const _Const = 1;
  const _Var = 2;
  const _FVar = 3;
  const  Sh_D = 8;
  const  Sh_E = 16;

  //const S_IM_UNIT: String = 'i'; //i,I - imaginary unit
  //const S_CON: String = '_'; //z_ =(x,-y)


  const _STACK_ADR = 1;
  const _STACK_VAL = 2;
  const _ESP = 4;
  const _EAX = 5;
  const _STACK_INFINITE   = 6;
  const _STACK_INFINITE_A = 7;
  const _COMPILED = 9;

  const  T_Complex = 2;
  const  T_Real  = 1;
  const  T_Array = 3;
  const  T_Integer = 4;
  const  T_None = 5;
  const  _RE = 1;
  const  _IM = 2;
  const _RIGHT = 1;
  const _BACK = 2;
  const _INFINITE = -1;
  const  _YES = 1;
  const  _NO = 2;

  const C_None = 0;
  const C_Real = 1;
  const C_Image = 2;
  const C_Complex = 3;

 //   WriteDataA()
 // const S_10:extended = 10;
  const S_2:extended = 2;
  const S_c2: double = 2;
  const S_c3: double = 3;
  const S_c1: double = 1;
  //const S_c1x: extended = 1;
 // const S_C05: double = 0.5;


  const rf_FULL_REPLACE = 100; // > than other: !!
  const rf_NO_REPLACE =0;
  const rf_EXPR1_REPLACE = 2;
  const rf_EXPR2_REPLACE = 3;
  const rf_INVERSE_REPLACE = 4;
  const rf_SINCOSR_REPLACE = 5;
  const rf_EXPZ1_REPLACE = 6;
  const rf_EXPZ2_REPLACE = 7;
  const rf_INVERSEZ_REPLACE = 8;
  const rf_SINR_REPLACE = 9;
  const rf_COSR_REPLACE = 10;
  const rf_ARCCOSR_REPLACE = 11;
  const rf_ARCSINR_REPLACE = 12;
  const rf_ARCTANR_REPLACE = 13;
  const rf_ARCCOTANR_REPLACE = 14;
  const rf_ARCSINZ_REPLACE = 15;
  const rf_ARCCOSZ_REPLACE = 16;
  const rf_ARCTANZ_REPLACE = 17;
  const rf_ARCCOTANZ_REPLACE = 18;
  const rf_ARCSECR_REPLACE = 19;
  const rf_ARCCOSECR_REPLACE = 20;
  const rf_ARCSECZ_REPLACE = 21;
  const rf_ARCCOSECZ_REPLACE = 22;



  const  _MEM = 20;
  const  _FPU = 21;

  const M_Compile: Integer = 10;      {.197}
  const M_DinamicLoad: Integer = 20;   {.197}

const
  IM_UNIT =        10;
  D_Real =         11;
  E_Real =         12;
  D_Complex =      13;
  E_Complex =      14;
  D_Any  =         15;
  E_Any =          16;
  D_Array_Real =   17;
  E_Array_Real  =  18;
  I_Array_Real =   19;


const
  E_UNKNOWN_SYMBOL = 1  ;
  E_MISSING_ROUND_BRACKET = 2 ;
  E_MISSING_OPERATION = 3 ;
  E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS = 4 ;
  E_MISSING_EXPRESSION = 5 ;
  E_UNKNOWN_FUNCTION = 6 ;
  E_ABSENT_FUNCTION_FOR_LOAD_TYPE = 7 ;
  E_NOT_DEFINED_OPERATION_FOR_TYPE = 8 ;
  E_NOT_DEFINED_FUNCTION_FOR_TYPE = 9 ;
  E_INTERNAL_ERROR = 12;
  E_ERROR_AT_ADDITION_OF_FUNCTION = 11 ;
  E_WRONG_TYPE = 14 ;
  E_WRONG_NAME = 15 ;
  E_MISSING_SQUARE_BRACKET = 16 ;
  E_MISSING_CURLY_BRACKET = 17 ;
  E_MISSING_ABS_BRACKET = 18 ;
  E_MISSING_SEPARATOR = 19;
  E_WRONG_EXPRESSION  = 20;
  E_ERROR_AT_CALCULATION  = 21;
  E_INCORRECT_ARGUMENT   = 22;
  E_INCORRECT_SPACE = 23;   {.195}
  E_VARIABLE_REDECLARED = 24; {.245}


   {.229}
   E_ZeroDivide = 25;
   E_InvalidOp = 26;
   E_OverFlow = 27;
   E_UnderFlow = 28;
   E_IntOverFlow = 29;
   E_AccessViolation = 30;
   E_OutOfMemory  = 31;
   E_StackOverFlow = 32;


  //   Alg.ExtFunc[N]
  const  CM_ADD = 0;
  const  CM_SUB = 1;
  const  CM_MUL = 2;
  const  CM_DIV = 3;
  const  CM_POWER = 4;
  const  CM_LOGN = 5;
  const  CM_NEG = 6;
  const  CM_ABS = 7;
  const  CM_RE = 8;
  const  CM_IM = 9;
  const  CM_ARG = 10;
  const  CM_SIN = 11;
  const  CM_COS = 12;
  const  CM_TAN = 13;
  const  CM_COTAN = 14;
  const  CM_ARCCOS = 15;
  const  CM_ARCSIN = 16;
  const  CM_ARCTAN = 17;
  const  CM_ARCCOTAN = 18;
  const  CM_SINH = 19;
  const  CM_COSH = 20;
  const  CM_TANH = 21;
  const  CM_COTANH = 22;
  const  CM_ARCCOSH = 23;
  const  CM_ARCSINH = 24;
  const  CM_ARCTANH = 25;
  const  CM_ARCCOTANH = 26;
  const  CM_LN = 27;
  const  CM_EXP = 28;
  const  CM_SQR = 29;
  const  CM_SQRT = 30;
  const  CM_FACT = 31;
  const  CM_LOG10 = 32;
  const  CM_LOG2 = 33;
  const  CM_ROOT = 34;
  const  CM_PWR3 = 35;
  const  CM_PWR4  = 36;
  const  CM_PWRN1 = 37;
  const  CM_PWRN2 = 38;
  const  CM_PWRN3 = 39;
  const  CM_PWRN4 = 40;
  const  CM_TRUNC = 41;
  const  CM_CON = 42;
  const  CM_FRAC  = 43;
  const  CM_NORM = 44;
  const  CM_SUM = 45;
  const  CM_AVR   = 46;
  const  CM_SUMQ   = 47;
  const  CM_LEN   = 48;
  const  CM_MAX   = 49;
  const  CM_MIN   = 50;
  const  CM_PROD   = 51;
  const  CM_SIGN   = 52;
  const  CM_IPWRSGN = 53;
  const  CM_LDSVX  = 54;
  const  CM_IFin   = 55;
  const  CM_IF  = 56;     //IF@
  const  CM_FACT2  = 57;
  const  CM_NOP  = 58;
  const  CM_SAVEin = 59;
  const  CM_SAVE = 60; //save@
  const  CM_JMP = 61;
  const  CM_INC = 62;
  const  CM_DEC = 63;
  const  CM_DECART = 64;
  const  CM_DEG = 65;
  const  CM_RAD = 66;
  const  CM_DEV = 67;
  const  CM_DEVS = 68;
  const  CM_SETLENin = 69;
  const  CM_SETLEN = 70;   //setlen@
  const  CM_ARCTAN2 = 71;
  const  CM_SINCOS = 72;
  const  CM_COSSIN = 73;
  const  CM_SWAP = 74;
  const  CM_COMPLEX = 75;
  const  CM_PWR5  = 76;
  const  CM_PWRN5  = 77;
  const  CM_PWR6  = 78;
  const  CM_PWRN6  = 79;
  const  CM_MOD  = 80;
  const  CM_IPWR  = 81;
  const  CM_POLYin  = 82;
  const  CM_POLY  = 83;    //polynom@
  const  CM_RANDin  = 84;   {.203}
  const  CM_GCD         = 85;
  const  CM_LCM         = 86;
  const  CM_ERF         = 87;
  const  CM_ERFC        = 88;
  const  CM_SEC        = 89;
  const  CM_COSEC        = 90;
  const  CM_SECH        = 91;
  const  CM_COSECH        = 92;
  const  CM_ARCCOSECH  = 93;
  const  CM_ARCSECH    = 94;
  const  CM_ARCCOSEC   = 95;
  const  CM_ARCSEC     = 96;
  const  CM_MAX23     = 97;
  const  CM_MIN23     = 98;
  const  CM_AVR23     = 99;
  const  CM_NORM23     = 100;
  const  CM_F2PWR      = 101;
  const  CM_TRY      = 102;
  const  CM_EXCEPTION      = 103;



  const  CM_LENGTH = 104;

  //const  C_IPWR = 53;


type TVar = record
              adr: Cardinal;
              TV:  Integer;   //D_Real, E_Real, D_Complex, E_Complex, IM_UNIT
            end;

type
TAddress = Cardinal;

type TFloat = extended; {extended} // 

type PFloat = ^TFloat;

type TArrayF = array of TFloat;

type
TComplex =  record
               re: TFloat;
               im: TFloat;
              end;

type
TComplexD =  record
               x: double;
               y: double;
              end;


type
TComplexE =  record
               x: extended;
               y: extended;
              end;
type
TByte32 = record
            re:   double;
            re2:  double;
            im:   double;
            im2:  double;
           end;


type
TStack = array of TByte32;// TComplexE;            {.203}

{
TComplexE ( )   TByte32 -    Delphi  TComplexE: 
        16+16,  : 10+10   ?!?!?!?!
}


type TStack16 =  record             //for align on 16
                    r1: Double;
                    r2: Double;
                   end;

type TArray16 =  array of TStack16;

type
TArray4 = array [1..4] of byte;
type TCode = array of Byte;




type TArrayI = array of Integer;
type TArrayC = array of Cardinal;
type PArrayI = ^TArrayI;
type TArrayD = array of Double;
type TArrayE = array of extended;

type TIntType = array of Cardinal;

type TArrayI2 = array of array of Integer;

type
 TTableRF = record
               WRF_R: integer;
               RRF_R: integer;
               WRF_Z: integer;
               RRF_Z: integer;
               NMEM_R:  integer; //??      
               NMEM_Z:  integer; //??      
               SHFT_R:  integer;
               SHFT_Z:  integer;
            end;


type TIntFunc  = //array of
                  record
                   TypeF:   Cardinal;          //  -  T_Real,T_Complex,T_None
                   CallT:   Cardinal;          // (_ESP,_EAX,_STACK,_STACK_INFINITE,_STACK_INFINITE_A)
                   CLST:    Cardinal;          // 
                   Arrow:   Cardinal;          //   _RIGHT,_BACK
                   Addr:    Cardinal;             // -
                   SDeep:   Integer;           // 
                   IntF:    Integer;           //= 1( -); =0()
                   ExeF:    Integer;           //=_Yes,_No -    ( )
                   N:    Integer;              // . N=-1,-2 Infinite (-1:   (_STACK_INFINITE);-2(_STACK_INFINITE_A):     )
                   TV:   array of Cardinal;    //      (T_Real,T_Complex)  (Size=N)
                   TM:   array of Cardinal;    //      (_Double,_Extended)   (Size=N)
                   ArgAdr:  TArrayI;           //   - fl_PRECOMPILED
                   CalcConst: Integer;         //1- -    ; 2- 
                   ReplFunc: Integer;          //_Yes/_No,0:  /      {.193}
                   SaveReg: Cardinal;          //  : eax,ebx,ecx,edx,esp,ebp,esi,edi,  8 
                  end;                         //1 - EAX; 2 - EBX; 3 - ECX; 4 - EDX; 5 - ESP; 6 - EBP; 7 - ESI; 8 - EDI;

type TIntFuncA = array of TIntFunc;

type TAlgFunction = array of
                      record
                       Name: String;        // -
                       NameEx: array of String; //    {.191}
                       Func: TIntFuncA;      // -   
                       Enable: Integer;   //_Yes, _No
                       ReplFunc: Integer;          //_Yes/_No,0:  /      {.193}
                       ReplFuncCFZ: Integer;    //_Yes/_No,0:   (ReplFuncCF) /  {.217}
                       ReplFuncCFR: Integer;    //_Yes/_No,0:   (ReplFuncCF) /      {.217}
                      end;






type TAlgOperation = array of
                      record
                       PR:  Cardinal;     //   ( '0'!)            Operation priority (except ' 0 '!)
                       Name:  String;     //  
                       NFunc: Cardinal;   //   -
                       GS:  Integer;     // . :  ((-1);(-2))  . : >= 0!  For one-argument operations: place ((-1) before; (-2) behind) for many-argument operations:> = 0!!!
                       SE:  Integer;     //F_SyntaxExtension(=1)
                      end;


                      //  .    .  !!!
                      //Priority any one-argument operations above any many-argument operations



type TAlgObject = array of
                   record
                    Name: String;
                   TypeF: Cardinal;          //   (T_Real,T_Complex,T_Array,T_Integer)
                    Addr: Cardinal;
                   MType: Cardinal;         //_Double,_Extended,_Integer
                   end;

type TAlgLoadFunction = array of
                        record
                         TypeF: Cardinal;    //   
                          Addr: Cardinal;
                          Name: String;     // 
                         end;




type
 PFunc      = ^TFunc;




 TFunc = record
               NL: Cardinal;               //    
               NM: Cardinal;              // (  Interp)  
               S:  Cardinal;               //Stack
               N:  Cardinal;               //Node
           TypeF:  Cardinal;               // 
           TypeA:  Cardinal;               //  (-   . )
             COP:  Cardinal;
           NFunc:  Cardinal;               //  -
              NF:  Cardinal;               // -  
            NObj:  Cardinal;               //  
              FD:    TFloat;               //
              FDC:   TComplex;             //
              FI:  Integer;
             Arg:  Cardinal;               //  ( infinite)
             IdN:    Cardinal;     // : =    ( )
             IdL:    Cardinal;     // : Idl        =  Idn  
        ArgTypes:  TArrayI;                 //     TIntFunc.N=-2(_STACK_INFINITE_A)
           SData:  Integer;                 //   /FPU    DinamicLoad
           RData:  TArrayI;                 //    /FPU    DinamicLoad
          SData1:  Integer;                 //   /FPU    
           MEM:    Cardinal;
             NC:   Cardinal;   //  ICOMP[NC]  
             CS:   Cardinal;  //      +     
            NCP:   Cardinal;  //     
             NV1:    Integer;//TVar;
             NV2:    Integer;//TVar;
             AI:     Integer; //control
             CI:     Integer; //control
            RRF:    Integer;    //=1     -                     {.193}
            WRF:    Integer;    //=1:  -    -              {.193}
            NRF:    Integer;    //= ,  - (  -)    {.193}
            MRF:    Integer;    //=   RFStack   -                            {.193}

            //RRF1:   Integer;    //= rf_     -                     {.217}
            WRF_CS:   Integer;    //= rf_:  -    -              {.217}
            //NRF1:   Integer;    //= ,  - (  -)    {.217}
            MRF_CS:   Integer;    //=   RFStack   -                            {.217}
            MWF_CS:   Integer;    //=   RFStack   -                            {.217}

             TS:   Integer;  //_RE,IM,0
             TS1:    Integer;     //_RE,_IM,0
             TS2:    Integer;      //_RE,_IM,0
             TC:     Integer; //C_None,C_Real,C_Image,C_Complex
             Inv:  Integer;               //-    . -
          VFP:    TArrayF;   //.  {.207}
          ExtArg:  Integer;   //     -,  ExtArg =      (  = 0); -  
          ExpressionArg: String;
          Expression: String;
         end;


type
TArrayOfPFunc = array of PFunc;

type
TArrayOfTFunc = array of TFunc;

type
   PFuncData = ^TFuncData;
   TFuncData = record
                FData: Extended;
                Next:  PFuncData;
               end;


type
TFunction = record
                   Code:  TCode;      //exe byte code
                   Data:  PFuncData;  //data of expr. (numeric const. of expr.)
                   Stack: TStack;     //stack of expr. for temp. result(use in DinLoad)  ; for align on 16  //     
                 RFStack:  TArray16;  //stack of expr. for temp. result(use in Replace)  ; for align on 16  //     'Replace'
                   Addr:  TAddress;   //begin addr of exe   {.193}
                   PAddr: Pointer;    //pointer to begin addr of exe {.193}
                CodeSize: Cardinal;   //size of code   (exe code can be moved )  {.193}
                AllocMem: Integer;    //= 1(compile with delphi/fpc memory manager): memory is allocated by SetLength(TFunction.Code,Size) (GetMem) {.193}
                  end;                //= 2(compile with windows (WinXp SP2+)memory manager): memory is allocated by VirtualAlloc  :TFunction.Code=nil
                                      {setting by fl_USE_VIRTUAL_ALLOC}


type PFunction = ^TFunction;

type TNStack = record
                S: Cardinal; //  
                N: Cardinal; //  
              end;


type
PNode = ^TNode;
TNode = record
         Stack: TNStack;
         IdN:    Cardinal;
         IdL:    Cardinal;
         NL:     Cardinal;           //   ( );   1
         NCOP:   Cardinal;           // ( ) ( );
         NFunc:  Cardinal;           //- (  -)
         NObj:   Cardinal;           //  
         COP:    Integer;            //COP: = 1(-)  Func   -;
                                     //2()  NCOP  ;
                                     //3( )  NObj -  ;
                                     //4( )  FD - ;
         FD:     TFloat;             //
         Expression: String;
         ExpressionArg: String;
         TypeF: Integer;             //-    . -
         Inv: Integer;               //-    . -
         NV1:    Integer;//TVar;
         NV2:    Integer;//TVar;
         AI:     Integer; //control
         CI:     Integer; //control
         TS: Integer;    //_RE,_IM,0
         TS1:    Integer;     //_RE,_IM,0
         TS2:    Integer;      //_RE,_IM,0
         SData:  Integer;
         RData: TArrayI;
         NM: Cardinal;
         NF: Cardinal;
         FDC:    TComplex;
         TC:     Integer; //C_None,C_Real,C_Image,C_Complex
         VFP:    TArrayF;   //.  {.207}
         Ch: PNode;
         Nb: PNode;
         Pr: PNode;
       end;

type
TDataNode = record
             N:      Cardinal;
             IdN:    Cardinal;
             NCOP:   Cardinal;
             NFunc:  Cardinal;
             NObj:   Cardinal;
             COP:    Integer;
             FD:     TFloat;
             FDC:    TComplex;
             FX:     Extended;
             NV1:    Integer;//TVar;
             NV2:    Integer;//TVar;
             AI:     Integer; //control
             CI:     Integer; //control
             TS:     Integer;    //_RE,_IM,0
             TS1:    Integer;     //_RE,_IM,0
             TS2:    Integer;      //_RE,_IM,0
             TC:     Integer; //C_None,C_Real,C_Image,C_Complex
             NF:     Cardinal;
             VFP:    TArrayF;   //.  {.207}
             ExpressionArg: String;
             Expression: String;
             TypeF: Integer;             //-    . -
             Inv:   Integer;             //-    . - (=1: sub->subr; div->divr)
            end;

type
TLevel = record
          NL:  Cardinal;               //   ( );     1
          IdL: Cardinal;
          Expression: String;
          //ExtArg: Integer;
        end;

type PLevel = array of TLevel;




type
TArrayS = array of String;





type
TParamList = record
               Name: String;
               Value: TFloat;
             end;






{type
TArrayI = array of Integer;
}

type
TString1 = String[1];





type
TAlgebra = record
             Name:  String;
            Types:  TArrayC;
              Obj:  TAlgObject;
              Opr:  TAlgOperation;
           ExFunc:  TAlgFunction;
           //LdFunc:  TAlgLoadFunction;
          //Bracket:  TAlgBracket;
           end;


type TExternalException = procedure (TypeError: Integer); {of object;} stdcall;


type

  TForevalH = class



  private


    Alg: TAlgebra;
    CurrentExpression: String;      // 
    LFunc    : Cardinal;          //  
    LInterp: Cardinal;
    StackSize: Cardinal;          // 
    ArgM : TArrayS;              //    > 2 .(  '0')
    Func: TFunction;                     //   
    Interp: TArrayOfTFunc;
    FuncData,BFuncData: PFuncData;
    Tree: PNode;                                //  
    //F_SyntaxExtension:       Boolean; //./.:  - > 1; '{' ; '['; '!'; '^'; .
    BeginTree: PNode;                 //   ( )
    //F_VarShift:              Boolean;  // var&param  // .
    //F_FuncShift:             Boolean;
    F_UseVirtAlloc: Boolean; {.193}
    F_SyntaxErrorCode: Cardinal;    //   
    F_SyntaxExtension : Boolean;    //|Expr|->abs(expr); [expr]->trunc(expr); {expr}->frac(expr)
    F_SyntaxErrorString: String;   // 
    F_CurrentSubExpr: String;     //   
    F_CalcErrorCode: Integer;    //. 
    F_InternalError: Integer;
    F_ShowException: Boolean;      //./.  
    F_ExternalException: Boolean;  //./.   
    F_CalcType: Integer;          //   = T_Real; T_Complex(=   )
    //BeginLinker: Integer; //0,1 - /  - -   
    F_BeginCalc: Integer; //0,1 - /  - -   
    //F_MaxLenArg: Cardinal; //.        
    F_ExtFunc: Boolean;  // -  
    F_ComplexNumber, F_PresentVar: Boolean;
    F_EnableCalcConstExpression: Boolean;
    F_RecoverImUnit: Boolean; //=true ,     (..     )
    //F_ReplaceFunction: Boolean; {.193}
    F_DataType: Integer; //_Double,_Extended;
    F_Mode: Integer;//M_Compile, M_DinamicLoad;     {.197}

    NAdr: Cardinal;
    //F_SaveStack: Boolean;
    //Alg:
    F_NumberStack: Cardinal;
    F_Address: Cardinal;
    F_NumberArg: Cardinal;
    F_FConst: TFloat;
    ICOMP: TCode;
    F_SyntaxErrorStringA: String;
    F_CurrentString: String;
    F_IdN: Cardinal;
    F_ResultType: Cardinal;
    F_ArgTypes: Cardinal;    //              (TIntFunc.N=-2(_STACK_INFINITE_A))
    //F_ExtNumberArg: Cardinal;
    NFunc: Cardinal;
    SAdr: array of Cardinal;
    N_Stack:Integer;
    SMAX:Integer;
     _MaxStack:Integer;
     F_StackDeep: Integer;
     F_EnableCheckStack: Boolean;
     ES_OverFlow: Boolean;
     //Db_DinLoadOverFlow: Boolean;
     Db_XchBrSDeep: Integer;     //    TreeOpimization (: _Enable,_Auto)
     Db_XchBrNXch: Integer;      //   TreeOpimization
     Db_DinLoadSDeep: Integer;   //    DinamicLoad  (: _Enable,_Auto)
     Db_DinLoadNMem: Integer;    //   DinamicLoad
     Db_DinLoadOverFlow: Boolean;//True,     DinamicLoad    
     Db_CmplMaxStack: Integer;   //   
     Db_ReplFuncNum: integer;  //  ReplFunc
     Db_ReplOpNum: integer;  //  ReplOperations
     Db_LoadStackAfterCalc: integer; //(0,1,2)

     F_SaveInFPU: Boolean;
     F_CalcConstExpr: Boolean;
     F_DinamicLoadOptimization: Boolean;
     F_OperationOptimizator: Boolean;
     F_OperationOptimizatorA1, F_OperationOptimizatorA2: Boolean;
     F_ReplaceFunctions: Boolean;
     F_ReplaceOperations: Boolean;
     F_ReplaceFunctionsCF: Boolean;
     F_DisableReplaceIF: Boolean;  {/  ReplaceFunctions/Operations      IF,GOTO
                                   (   )}
     F_LeadToLowerCase: Boolean; {.221}   //( )
                                          { = False   ,,     
                                            = True      ,  ,
                                                     LowerCase}
     F_SkippedIF: Boolean; {.221}        //true: non-complete boolean expr; false: complete boolean expr;

     F_EnableCalcConsExprInMulti: Boolean;  {.221}//     (  )     .

     F_EnableMaskFpuException: Boolean; //  FPU   try except (:   dll)     {.223}

     F_FAST_DIV: Boolean; //" "  : r/z, z/r, z1/z2      {.205}
     F_MulDivOptimization: Boolean ; {.217A}
     //F_Opt: Boolean;
     REG,REGA,REGF:  array [1..8] of Integer;
     LInternalFunc: Integer;
     F_JMP: Integer;
     F_SData: Integer;
     F_GotoPresent: boolean;
     F_IF: boolean;
     G_SaveVar: TAlgObject;
     S_IM_UNIT: String; //i,I - imaginary unit
     RFSize: Integer; {.193}
     TableRF: array of array of TTableRF;  {.217}
     COP_DIV, COP_MUL: integer;

     FV_Result: TComplex;  {.229}
     F_SaveSW: Boolean;  {.229}

     CWMEM,SWMEM,CWMEM1,CWMEM2,CWMEM3,CWMEM4,CWMEM5,CWMEM6,CWMEM7,CWMEM8: Cardinal;

    function  FindNumberPR(PR: Cardinal): Cardinal;
    function  FindOperation(S: String): integer;
    procedure FindSingleOP(S: String; var NCop: Integer);
    procedure FindCallFunction(var nf: Integer);
    procedure FindCallFunctionA(var TypeF: Integer; var nf: Integer; var TypeA: Integer);
    //procedure FindLdFunction(var nf: Integer);
    //procedure FindConstLdFunction(var nf: Integer);
    procedure FindNumberLevel(var ANL: TArrayC);
    function  GetLevelsCS(num: Integer): Cardinal;
    procedure TranslErrMsg(SubExpr: String);
    procedure IntToHex(N: TAddress; var AH: TArray4);
    procedure IntToHexNum(N: Integer; var AH: TArray4);
    procedure SaveReg;
    procedure SaveRegF;
    procedure SetReg(R: Integer);
    procedure AddAddress(Adr: TAddress);
    procedure AddNum(Num: Integer);
    procedure AddCommand(I: Integer);
    procedure AddByte(B: Byte);
    procedure AddWord(B1: Byte; B2: Byte);
    procedure Compile;
    procedure CALLA;
    procedure CALLC;
    procedure CALLB;
    procedure RET;
    procedure FSTP(N: TAddress);
    procedure FLD(N: TAddress);       overload;
    procedure MOVAM(N: TAddress);
    procedure MOVMA(N: TAddress);
    procedure MOVMB(N: TAddress);
    procedure MOVMC(N: TAddress);
    procedure MOVAnum(N: Integer{TAddress});
    procedure MOVBnum(N: Integer{TAddress});
    procedure MOVCnum(N: Integer{TAddress});
    procedure MOVAadr(N: TAddress);
    procedure MOVBadr(N: TAddress);
    procedure MOVCadr(N: TAddress);
    procedure PUSHAD;
    procedure POPAD;
    procedure ADDESP(N: Integer);
    procedure FEXP;
    procedure ZEXP;
    procedure FSIN;
    procedure FCOS;
    procedure FSINCOS;
    procedure FPTAN;
    procedure FPATAN;
    procedure FISTP(N: TAddress);
    procedure FLDCW(N: TAddress);
    procedure PUSHCW;
    procedure POPCW;
    procedure FSTP0;
    procedure FSTP1;
    procedure FLD1;
    procedure FDIVR_C1;
    procedure FMUL_C05;
    procedure FDIV_C3;
    procedure ZDIVR_C1;
    procedure ZMUL_i;
    procedure ZDIV_i;
    procedure ZDIVR_i;
    procedure FDIVRP;
    procedure FLDLN2;
    procedure FYL2X;
    procedure FLDLG2;
    procedure FABS;
    procedure FRNDINT;
    procedure CDQ;
    procedure IDIV(N: TAddress);
    procedure IDIVB;
    procedure ADD_C;
    procedure SUB_C;
    procedure FDIV(N: TAddress; VType: Integer);
    procedure FDIVR(N: TAddress; VType: Integer);
    procedure FDIVP;
    procedure FDIV01;
    procedure FDIV02;
    procedure FDIV10;
    procedure FDIVR01;
    procedure FDIVR10;
    procedure FDIVP2;
    procedure FDIVRP2;
    procedure FDIVRP3;
    procedure FDIVP3;
    procedure MUL_C;
    procedure DIV_C;
    procedure FMUL1;
    procedure FDIV2;
    procedure FDIVR2;
    procedure FSUBP01;
    //procedure FDIVR2;
    //procedure FDIVP2;
    procedure FDIVP1;
    procedure FMUL0;
    procedure FMUL02;
    procedure FMUL01;
    procedure FMUL03;
    procedure FMUL04;
    procedure FMUL05;
    procedure FMUL10;
    procedure FSQRT;
    procedure FMUL(N: TAddress; VType: Integer);
    procedure FSUB(N: TAddress; VType: Integer);
    procedure FSUBR(N: TAddress; VType: Integer);
    procedure FSUBP;
    procedure FSUBP1;
    procedure NEG_C;
    procedure RE_C;
    procedure IM_C;
    procedure FADD(N: TAddress; VType: Integer);
    procedure FADDP;
    procedure FADDP1;
    procedure FADDP2;
    procedure FADDP20;
    procedure FADDP3;
    procedure FSUBRP;
    procedure FSUBRP2;
    procedure FMULP;
    procedure FMULP1;
    procedure FMULP2;
    procedure FMULP4;
    procedure FMULP20;
    procedure FMUL30;
    procedure FMUL20;
    procedure FSUBP2;
    procedure FSUBP40;
    procedure FLDZ;
    procedure FLD0;
    procedure FCHS;
    procedure PUSHB;
    procedure PUSHF(N: TAddress);
    procedure POPF(N: TAddress);
    procedure FILD(N: TAddress);
    procedure FTRUNC;
    procedure TRUNCM(N: TAddress);
    procedure MOVDM(N: TAddress);
    procedure IDIVM(N: TAddress);
    //procedure FISTPM(N: TAddress);
    procedure POPB;
    procedure FLD(N: TAddress; VType: Integer);    overload;
    procedure FSTPM(N: TAddress; VType: Integer);
    procedure FSTM(N: TAddress; VType: Integer);   {.193}
    procedure FCOMPP;
    procedure FCOMIP;
    procedure FSTSW_AX;
    procedure SAHF;
    procedure JMPC(N: TAddress; VType: Integer);
    procedure FXCH1;
    procedure FXCH2;
    procedure FXCH3;
    procedure FXCH4;
    procedure ZMULP;
    procedure ZMUL;
    procedure ZSQR;
    procedure ZIPWR3;
    procedure ZPUSH;
    procedure AddCom(B1,B2: Byte; Adr: TAddress);   overload;
    procedure AddCom(B1: Byte; Adr: TAddress); overload;
    procedure AddCom(B1,B2: Byte);   overload;
    function  WriteData(NF: Integer): TAddress;
    function  WriteDataA(Data: extended; DataType: Integer): TAddress;
    procedure FreeData;
    procedure LoadArgMEM;
    procedure LoadArgMEMInf;
    procedure LoadArgSTACK;
    procedure PushArgSTACK;
    procedure LoadArgMEMInfA;
    procedure LoadArgPC;
    function  GetStackAdr(S,RT: Integer): Cardinal;
    function  CheckIfRet(N: Integer): Boolean;
    function  CheckNopRet(N: Integer): Boolean;
    function  CheckSaveRet(N: Integer): Boolean;
    function  ReadReplFunc(i: integer): Boolean;     {.193}
    procedure WriteReplFunc(i: integer);             {.193}
    procedure PUSHM(N: Cardinal);
    procedure LoadArg1;
    procedure LoadArg2;
    procedure LoadArg3RL;
    procedure LoadArg2RL;
    procedure FLDV(nv: Integer);
    procedure FLDV_RE(nv: Integer);
    procedure FLDV_IM(nv: Integer);
    procedure FADDV(nv: Integer; st: Integer);
    procedure FSUBV(nv: Integer; st: Integer; inv:Integer = 0);
    procedure FDIVV(nv: Integer; st: Integer; inv:Integer = 0);
    procedure FMULV(nv: Integer; st: Integer);
    procedure FLDS(K: Integer; fm:Integer = _FPU);
    procedure LDSF_C(N: Integer);
    procedure SAVE_C;
    procedure SWAP_C;
    procedure SIN_C;
    procedure COS_C;
    procedure SEC_C;
    procedure COSEC_C;
    procedure TAN_C;
    procedure COTAN_C;
    procedure SINCOS_C;
    procedure COSSIN_C;
    procedure POWER_C;
    procedure LOGN_C;
    procedure ARCTAN2_C;
    procedure FACT_C;
    procedure FACT2_C;
    procedure SQR_C;
    procedure SQRT_C;
    procedure ARCSIN_C;
    procedure ARCCOS_C;
    procedure ARCTAN_C;
    procedure ARCCOTAN_C;
    procedure ARCSEC_C;
    procedure ARCCOSEC_C;
    procedure SINH_C;
    procedure COSH_C;
    procedure COSECH_C;
    procedure SECH_C;
    procedure TANH_C;
    procedure COTANH_C;
    procedure ARCSINH_C;
    procedure ARCCOSH_C;
    procedure ARCTANH_C;
    procedure ARCCOTANH_C;
    procedure ARCCOSECH_C;
    procedure ARCSECH_C;
    procedure LN_C;
    procedure EXP_C;
    procedure LOG10_C;
    procedure LOG2_C;
    procedure DECART_C;
    procedure ABS_C;
    procedure ARG_C;
    procedure ROOT_C;
    procedure COMPLEX_C;
    procedure PWR3_C;
    procedure PWR4_C;
    procedure PWR5_C;
    procedure PWR6_C;
    procedure PWRN1_C;
    procedure PWRN2_C;
    procedure PWRN3_C;
    procedure PWRN4_C;
    procedure PWRN5_C;
    procedure PWRN6_C;
    procedure TRUNC_C;
    procedure CON_C;
    procedure NORM_C;
    procedure Frac_C;
    procedure SUM_C;
    procedure PROD_C;
    procedure AVR_C;
    procedure SUMQ_C;
    procedure LEN_C;
    procedure MAX_C;
    procedure MIN_C;
    procedure DEV_C;
    procedure DEVS_C;
    procedure SGN_C;
    procedure LDSVX_C;
    procedure IPWRSGN_C;
    procedure IFNOP_C;
    procedure JMP_C;
    procedure FLD_C(I: Integer);
    procedure INC_C;
    procedure DEC_C;
    procedure DEG_C;
    procedure RAD_C;
    procedure MOD_C;
    procedure IPWR_C;
    procedure POLY_C;
    procedure GCD_C;
    procedure LCM_C;
    procedure MAX23_C;
    procedure MIN23_C;
    procedure AVR23_C;
    procedure NORM23_C;
    procedure F2PWR_C;
    procedure TRY_C;
    procedure EXCEPTION_C;


   

    procedure FindNumberLevelA(num: Integer; var ANL: TArrayC);
    //procedure IPWR_C;


    procedure FindExternalBracket(S: String; var SS: String);
    procedure DeleteExternalBracketP(PS: PString); {.217A}
    function  CheckToZero(S: String): Boolean; {.217A}
    function  CheckToZeroP(PS: PString): Boolean; {.219}
    procedure FindMainOperation(S:String; var NCOP: Integer; var NPos: Cardinal);
    procedure FindMainOperationA(S:String; var NCOP: Integer; var NPos: Cardinal; var Sret: String);  {.217A}
    procedure MulDivOpt(S:String; var NCOP: Integer; var NPos: Cardinal; var Sret: String);    {.217A}
    procedure StringAnalizator(S:String; var ND: TDataNode; var HS:PLevel);
    procedure WriteCode;
    procedure WriteLevelParam(H: PNode; HS: PLevel; N: Cardinal);
    procedure SubstParam(S1: String;  var C: TFloat; var SB: Integer);
    procedure SubstParamCX(S: String;  var CX: TComplex; var SB: Integer);
    function  PointToDec(S: String):String;
    procedure CreateInitData;
    //procedure FindVar(S1: String; var ni: Integer);
    procedure SyntaxAnalizator(S:String; var ND: TDataNode; var LV:PLevel;  var EOFN: Boolean);
    procedure OperationalAnalizator2(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
    procedure OperationalAnalizator1(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
    procedure PowerAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
    procedure RootAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
    procedure IFAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode);
    procedure SaveAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode);
    procedure GOTOAnalizator(LV: PLevel; ND: TDataNode; var LV1: PLevel; var ND1: TDataNode);
    procedure IDAMAnalizator(LV: PLevel; ND: TDataNode; var LV1: PLevel; var ND1: TDataNode);
    procedure SetLenAnalizator(LV: PLevel; ND: TDataNode; var LV1: PLevel; var ND1: TDataNode);
    procedure SWAPAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode);
    procedure MODAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
    procedure POLYAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
    procedure RANDAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);  {.203}
    procedure DataFuncAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
    //procedure SAFECALLAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode);    {.219}
    procedure NumberAnalizator(S: String; var ND: TDataNode;  var EOFN: Boolean);
    procedure FindConst(S: String; var ND: TDataNode;  var EOFN: Boolean);
    procedure NumberAnalizatorA(S: String;  var nf: Integer; var FD: extended; var EF: Integer);
    procedure WriteNodeParam(ND: TDataNode);
    procedure InitNode(var ND: TDataNode);
    procedure WriteDataCode;
    procedure FindFunction(S: String;  var ND: TDataNode; var LV: PLevel;  var BH,EOFN: Boolean);
    procedure FindFuncBr(S: String; BrS1,BrS2: String; var Sf: String; var Sa: String; var FH: Boolean);
    procedure PrevTreat(S: String; var S1: String);
    procedure ReplaceAbsBr(S: String; var S1: String);
    procedure ReplaceTruncBr(S: String; var S1: String);
    procedure ReplaceFracBr(S: String; var S1: String);
    procedure replaceAndOr(S: String;  var S1: String);
    procedure ReplaceAndOrSKIP(S: String;  var S1: String); {.221}
    procedure ReplaceFuncIntPart(S,SF: String; var S1: String);
    procedure ReplaceIff(S1: String; var S2: String);
    procedure insIf(S: String; P,N: Integer; var S1: String);
    function  CheckImUnitAfterBr(S: String; i: Integer): Boolean;
     procedure FreeTree;
    //procedure FreeFunction;
    procedure FreeInterp;
    procedure FreeFuncData(FuncData: PFuncData);
    procedure Linker(S:String);
    procedure SetStackSize;
    procedure CodeGeneration;
    procedure GetSizeInterp;
     procedure FindManyArg(S: String; var ArgM: TArrayS);
    procedure SaveResult(I: Cardinal);
    procedure CreateFuncList;
    procedure SetNM;
    procedure SetNL;
    procedure SetLoadSource;
    procedure DinamicLoadOptimizator;
    procedure SetLoadMem(I: Integer);
    function  EnableDL(I: Integer): Boolean;
    procedure InitDL;
    function  E_GetMaxLoadDL(I: Integer): Integer;
    procedure E_SetNodeDL(I: Integer);
    procedure CheckStack(N: Integer);
    function  E_GetMaxStackEx: Integer;
    procedure InitConstDb;
    procedure DebugDL;
    procedure SetExtArg;
    procedure PUSHArgStackVal;
    procedure PushArgStackAdr;
    procedure GetVar(N: Integer; var Adr: TAddress; var TV: Integer; var TM: Integer);
    procedure FindReIm(S: String; var S1:String; var TF: Integer);
    procedure FindControlCom(S: String; var code,ni: Integer; var BH: Boolean);
    procedure FindJMP(S: String; var ni: Integer);
    procedure FindFLD(S: String; var ni: Integer);
    function  FindIfFunc: Boolean;
    function  CheckName(Name: String): Boolean;
    procedure CheckRecoverImUnit;
    function  GetFirstNode(num: Integer): Cardinal;   {.193}
    procedure ReplaceOptimizator;                       {.193}
    procedure ReplaceFunc;                             {.193}
    procedure InsertFunc(NF,NS: Integer);            {.193}
    procedure FindFuncInExpr(k: Integer; Sexpr: String; var BH: Boolean);    {.193}
    procedure FindNonReplFunc(Sf: String; var BH: Boolean);             {.193}
    procedure ReplaceOperations; {.193}
    procedure DelVoidSave;
    procedure DelVoidSaveCF;
    procedure SetNewFuncToOperation(OpName: String; IDF: Cardinal);   {.195}
    function  GetLineStackAdr(NM,NArg: Cardinal): TAddress;
    procedure SaveArgMemAdr(i: Cardinal);        {.197}
    procedure SaveArgPC(i: Cardinal);  {.197}
    procedure SaveArgStackVal(i: Cardinal);      {.197}
    procedure SaveArgStackAdr(i: Cardinal);
    procedure FreeChld(PrntNode: PNode);
    procedure InitTableRF; {.217}
    procedure InsertFuncRF(NF,NS: Integer);  {.217}
    procedure ReplaceFuncComposite;       {.217}
    procedure GetReplaceData(NF,NS,VType: integer; var RangW,RangR,NMem,MShft: Integer);  {.217}
    procedure TryFPUMask{(CWMEM: PCardinal)};
    procedure TryCatchFPUException{(CWMEM: PCardinal)};                           {.229}
    procedure SaveSW;
    function  IsFPUExceptionSW(CWAddr: PCardinal): integer;    stdcall;




  protected

   procedure  IntException;  virtual;


  public


   constructor Create;
   destructor  Destroy;
   procedure FreeFuncList;
   procedure InitFuncStruct(var FS: TIntFunc);
   procedure SetExtExpression(S: String;  var E_Func: TFunction; var Stack: Cardinal);
   procedure FindVar(S1: String; var ni: Integer);
   procedure FindVarA(S1: String; var ni: Integer; var Adr: TAddress; var TV,TM: Integer);
   procedure ExistVar(S1: String; var Addr,IdType,MType: Cardinal);
   procedure ExistVarEx(S1: String; var Addr: TAddress; var IdType,MType,ReIm,ImU: Cardinal);
   procedure FreeExtFunc(E_Func: PFunction);          {.225}
   function  IsFPUException(CWAddr: PCardinal): integer;     stdcall;

   procedure ClearFPUException;
    procedure MaskFPUException(CWAddr: PCardinal);   stdcall;
   //procedure FreeExtFunc(E_Func: TFunction);
   //property  VarShift: Boolean read F_VarShift write F_VarShift default False;
   //property  FuncShift: Boolean read F_FuncShift write F_FuncShift default False;
   property  ShowException: Boolean read F_ShowException write F_ShowException default True;
   property  SyntaxError: Cardinal read  F_SyntaxErrorCode write F_SyntaxErrorCode default 0;
   property  SyntaxErrorString: String read F_SyntaxErrorString write F_SyntaxErrorString;
   property  CalcError: Integer read F_CalcErrorCode write F_CalcErrorCode default 0;
   property  InternalError: Integer read F_InternalError write F_InternalError default 0;
   property  SyntaxExtension: Boolean read F_SyntaxExtension write F_SyntaxExtension default True;
   property  ComplexNumber: Boolean  read F_ComplexNumber default False;
   property  PresentVar: Boolean read   F_PresentVar default False;
   property  ExternalException: Boolean read F_ExternalException write F_ExternalException default False;
   property  BeginCalc: Integer read F_BeginCalc write F_BeginCalc default 0;
   procedure RenameFunction(Name,NewName: String);
   property  DataType: Integer read F_DataType write F_DataType default _Extended;
   property  StackDeep: Integer read F_StackDeep write F_StackDeep default 8;
   property  SaveInFPU: boolean read F_SaveInFPU;
   property  DinamicLoad: Boolean read F_DinamicLoadOptimization write F_DinamicLoadOptimization default true;
   //property  OperationOptimizator: Boolean read F_OperationOptimizator write F_OperationOptimizator default true;
   property  ResultType: Cardinal read F_ResultType;
   property  CalcType: Integer read F_CalcType write F_CalcType default T_Complex;
   property  CalcConstExpr: boolean  read  F_CalcConstExpr  write   F_CalcConstExpr default True;
   property  IM_UNIT_NAME: String  read  S_IM_UNIT  write   S_IM_UNIT;
   property  DinLoadSDeep:    Integer read Db_DinLoadSDeep;
   property  MaxLoadStack: Integer read  Db_CmplMaxStack;
   property  DinLoadOverFlow: Boolean read Db_DinLoadOverFlow;
   property  DinLoadNMem: Integer read Db_DinLoadNMem;
   property  LoadStackAfterCalc: Integer read Db_LoadStackAfterCalc;
   property  EnableCalcConstExpression: Boolean read F_EnableCalcConstExpression default True;
   procedure SetType(IdType: Cardinal);
   procedure SetObject(Name: String; Addr: Cardinal; IdType: Cardinal; MType: Cardinal);
   procedure DeleteVar(Name: String);
   procedure SetFunction(Name: String; FS:TIntFunc);
   //procedure SetLoadFunction(IdType: Cardinal; Addr: Cardinal; Name: String);
   procedure SetOperation(Name: String; Func: String; PR: Cardinal; GS: Integer; SE: Integer);
   procedure SetRegA(R: Integer; SC: Integer);
   procedure FreeVar;
   procedure FindFunc(Name: String; TV: array of Cardinal; var idn,idf,CallT: integer; var adr: Cardinal);
   procedure DeleteFunc(idn,idf: integer);
   procedure SetExtNameFunc(IDF: Integer; Name: String);     {.191}
   procedure FindFuncA(NameF: String; var NF: Integer);     {.191}
   procedure FindZeroArg(NF: Integer; var ni: integer); {.203}
   procedure SetImUnitName(Name: String);
   procedure PushVar;
   procedure PopVar;
   property  RecoverImUnit: Boolean read F_RecoverImUnit write F_RecoverImUnit default False;
   procedure SetF(code: Integer; IDF: Integer);
   procedure FastSpec(Bl: Boolean);
   property  ReplaceFuncs: Boolean read F_ReplaceFunctions write F_ReplaceFunctions default True;    {.193}
   property  ReplaceOps: Boolean read F_ReplaceOperations write F_ReplaceOperations default True;    {.193}
   property  ReplFuncNum:    Integer read Db_ReplFuncNum;
   property  ReplOpNum:    Integer read Db_ReplOpNum;
   property  UseVirtAlloc: Boolean   read  F_UseVirtAlloc  write  F_UseVirtAlloc  default False;      {.193}
   procedure SetFunctionInt(Name: String; IDF: Cardinal; FS:TIntFunc);
   property  DisableReplaceIF: Boolean read F_DisableReplaceIF  write  F_DisableReplaceIF   default False; {.195}
   property  FastDivision: Boolean read F_FAST_DIV write F_FAST_DIV default true; {.205}
   property  ReplaceFuncsCF: Boolean read F_ReplaceFunctionsCF write F_ReplaceFunctionsCF default True;    {.217}
   property  MulDivOptimization: Boolean read F_MulDivOptimization write F_MulDivOptimization default True;    {.217A}
   property  OperationOptimizatorA1: Boolean read F_OperationOptimizatorA1 write F_OperationOptimizatorA1 default true;
   property  OperationOptimizatorA2: Boolean read F_OperationOptimizatorA2 write F_OperationOptimizatorA2 default true;
   property  LeadToLowerCase: Boolean read F_LeadToLowerCase write F_LeadToLowerCase default True; {.221}
   property  SkippedIF: Boolean read F_SkippedIF  write  F_SkippedIF   default True; {.221}
   property  EnableCalcConsExprInMulti: Boolean read F_EnableCalcConsExprInMulti write F_EnableCalcConsExprInMulti default False; {.221}
   property  EnableMaskFpuException: Boolean read F_EnableMaskFpuException write F_EnableMaskFpuException default False; {.229}
   property  FResult: TComplex read FV_Result write FV_Result; {.229}

  published



  end;



var



  ForevalH: TForevalH;



implementation

{$IFDEF DEBUGS}
 uses
 testz;
{$ENDIF}

var
MEM: Cardinal;
zi: TComplexD;
NameTypeS: array [1..5] of String;
G_FMT: TFormatSettings;
GotoLab: TArrayC;
dbMaxLoadCom, dbFPUBefore,dbFPULoad: Integer;
TE_ADDR: TAddress;


//V1: TArrayD;    //test



procedure TForevalH.SetImUnitName(Name: String);
begin
  S_IM_UNIT:=Copy(Name,1,Length(Name));
  Alg.Obj[0].Name:=S_IM_UNIT;
end;




procedure TForevalH.SetType(IdType: Cardinal{; Name: String});
label endp;
var
i: Integer;
begin
{
for i:=0 to High(Alg.Types) do
begin
 if Alg.Types[i] = IdType then goto endp;
end;
}
SetLength(Alg.Types,Length(Alg.Types)+1);
Alg.Types[High(Alg.Types)]:=IdType;

endp:
end;


function TForevalH.CheckName(Name: String): Boolean;
label endp;
var
 EnName: set of  Char;
 i: integer;
begin                                                                                    {.221}
 EnName:=['(',')','{','}','[',']','|','*','/','>','<','=','+','!','@','^',':','-','.',',','$','#','&','%',';','?'];

 if Name <> '@hidden@' then    {.215}
 begin
   for i := 1 to Length(Name) do
   begin
    if Name[i] in EnName then begin CheckName:=False; goto endp; end;
   end;
    if Name = '' then CheckName:=False else CheckName:=True;
 end
 else
 CheckName:=True;
 endp:
end;



procedure TForevalH.SetObject(Name: String; Addr: Cardinal; IdType: Cardinal; MType: Cardinal);
label endp;
var
i: integer;
Name1: String;
begin


if CheckName(Name) = false then
 begin
  F_SyntaxErrorCode:=E_WRONG_NAME; F_SyntaxErrorString:=Name; IntException; goto endp;
  end;

if F_LeadToLowerCase = True then Name:=LowerCase(Name); {.221}

 for i := 0 to Length(Alg.Obj) - 1 do
   begin
     Name1:=Alg.Obj[i].Name;

     if (Name1  = Name) {and (Alg.Obj[i].TypeF = IdType) and (Alg.Obj[i].MType = MType)} then
     begin
       Alg.Obj[i].Addr:=Addr;
       Alg.Obj[i].TypeF:=IdType;
       Alg.Obj[i].MType:=MType;
       goto endp;
     end;

      if Name1 = '@hidden@' then   // 
      begin
       Alg.Obj[i].Addr:=Addr;
       Alg.Obj[i].TypeF:=IdType;
       Alg.Obj[i].MType:=MType;
       Alg.Obj[i].Name:=Copy(Name,1,Length(Name));
       goto endp;
      end;
   end;

 SetLength(Alg.Obj,Length(Alg.Obj)+1);
 Alg.Obj[High(Alg.Obj)].TypeF:=IdType;
 Alg.Obj[High(Alg.Obj)].MType:=MType;
 Alg.Obj[High(Alg.Obj)].Addr:=Addr;
 Alg.Obj[High(Alg.Obj)].Name:=Copy(Name,1,Length(Name));

 endp:
end;




procedure TForevalH.DeleteVar(Name: String);
label endp;
var
Name1: String;
i: integer;
begin

 for i:=0 to Length(Alg.Obj) - 1 do
  begin
   Name1:=Alg.Obj[i].Name;

   if  Name = Name1 then
   begin
     Alg.Obj[i].Addr:=0;
     Alg.Obj[i].TypeF:=0;
     Alg.Obj[i].MType:=0;
     Alg.Obj[i].Name:='@hidden@';
    goto endp;
   end;

  end;


endp:
end;




procedure TForevalH.FreeVar;
begin                           // [0]   
  SetLength(Alg.Obj,0);
  SetObject(S_IM_UNIT,Cardinal(@zi),T_Complex,_Double);
  SetObject('pi',Cardinal(@_PI),T_Real,_Extended);
end;




procedure TForevalH.PushVar;
var
i: Cardinal;
begin

SetLength(G_SaveVar,Length(Alg.Obj));

 for i:=0 to High(Alg.Obj) do
 begin
    G_SaveVar[i].Name:=Alg.Obj[i].Name;
    G_SaveVar[i].Addr:=Alg.Obj[i].Addr;
    G_SaveVar[i].TypeF:=Alg.Obj[i].TypeF;
    G_SaveVar[i].MType:=Alg.Obj[i].MType;
 end;

end;



procedure TForevalH.PopVar;
var
i,Addr,IdType,MType: Cardinal;
begin

if Length(G_SaveVar) > 0 then
begin

 for i:=0 to High(G_SaveVar) do
 begin
  SetObject(G_SaveVar[i].Name,G_SaveVar[i].Addr,G_SaveVar[i].TypeF,G_SaveVar[i].MType);
 end;

  //SetLength(G_SaveVar,0);
end;
end;


{.191}
procedure TForevalH.FindFuncA(NameF: String; var NF: Integer);
label endp;
var
i,j,LF: Integer;
Sfn: String;
begin
NF:=-1;
{
 for i:=0 to High(Alg.ExFunc) do
  begin
  LF:=
    for j := 0 to High(Alg.ExFunc[i].NameEx) do
    begin
       Sfn:=Alg.ExFunc[i].NameEx[j];
       if F_FuncShift = False then
       begin
         Sfn:=LowerCase(Sfn);
       end;
       if Sf1 = Sfn then  begin NF:=i;  goto endp; end;
     end;
  end;
 }



 for i:=0 to High(Alg.ExFunc) do
 begin

       if F_SyntaxExtension = True then LF:=High(Alg.ExFunc[i].NameEx) else LF:=0;

       for j := 0 to LF do
       begin

          Sfn:=Alg.ExFunc[i].NameEx[j];


          if (NameF = Sfn) and  (Alg.ExFunc[i].Enable = _YES) then
          begin
            NF:=i; goto endp;
          end;

       end;
 end;


endp:
end;



procedure TForevalH.FindZeroArg(NF: Integer; var ni: integer);
label endp;
var
  i: integer;
begin

ni:=-1;

for i := 0 to Length(Alg.ExFunc[NF].Func) - 1 do
begin
  if Alg.ExFunc[NF].Func[i].N  = 0 then begin ni:=i; goto endp; end;

end;

endp:
end;



procedure TForevalH.SetFunction(Name: String; FS:TIntFunc);
label endp,newf,nxtf;                                  //TV -     (array of types of variables) T_Real,T_Complex,T_Array
var                                          //TypeF -    (returned  type of function) T_Real,T_Complex
N,K,i,j,m,bf,nf,m1: Integer;                       //TM -     (array of types of variables) _Double,_Extended,_Integer
begin

if CheckName(Name) = false then begin F_SyntaxErrorCode:=E_WRONG_NAME; F_SyntaxErrorString:=Name; IntException; goto endp; end;

  {.191}
  {for i:=0 to High(Alg.ExFunc) do
  begin
   if Name = Alg.ExFunc[i].Name then
   begin }

    FindFuncA(Name,i);           {.191}
    if i = -1 then  goto newf;    {.191}

    K:=i;
    N:=High(Alg.ExFunc[K].Func);
    //    :
    for m := 0 to High(Alg.ExFunc[K].Func) do
    begin
     if Length(FS.TV) = Length(Alg.ExFunc[K].Func[m].TV) then
     begin
       bf:=0;
       for j:=0 to High(FS.TV) do
       begin
        if Alg.ExFunc[K].Func[m].TV[j] = FS.TV[j] then inc(bf);
       end;
       if bf = Length(FS.TV) then
       begin
         //  -:
         {
            fnc(x): real=sin(x)
            fnc(): real = 1.12345
          }
        //void()=x
        //if Length(FS.TV) = 0 then  goto  nxtf;   //{.207}

         {????????}
         {
         Alg.ExFunc[K].Func[N].TypeF:=FS.TypeF;
         Alg.ExFunc[K].Func[N].CallT:=FS.CallT;
         Alg.ExFunc[K].Func[N].Addr:=FS.Addr;
         Alg.ExFunc[K].Func[N].Arrow:=FS.Arrow;
         Alg.ExFunc[K].Func[N].CLST:=FS.CLST;
         Alg.ExFunc[K].Func[N].SDeep:=FS.SDeep;
         Alg.ExFunc[K].Func[N].N:=FS.N;
         Alg.ExFunc[K].Func[N].IntF:=FS.IntF;
         SetLength(Alg.ExFunc[K].Func[N].TV,Length(FS.TV));
         SetLength(Alg.ExFunc[K].Func[N].TM,Length(FS.TM));
         for j:=0 to High(FS.TV) do
         begin
          Alg.ExFunc[K].Func[N].TV[j]:=FS.TV[j];
          Alg.ExFunc[K].Func[N].TM[j]:=FS.TM[j];
         end;
        if FS.CallT = _Compiled  then
        begin
         SetLength(Alg.ExFunc[K].Func[N].ArgAdr,Length(FS.ArgAdr));
        for m1:=0 to High(FS.ArgAdr) do
         Alg.ExFunc[K].Func[N].ArgAdr[m1]:=FS.ArgAdr[m1];
        end;
         FS.ArgAdr:=nil;
         }

        {???????????}

        goto endp;
       end;

     end;
    end;


    nxtf:
    //  -    :
    SetLength(Alg.ExFunc[K].Func,Length(Alg.ExFunc[K].Func)+1);
    N:=N+1;
    Alg.ExFunc[K].Func[N].TypeF:=FS.TypeF;
    Alg.ExFunc[K].Func[N].CallT:=FS.CallT;
    Alg.ExFunc[K].Func[N].Addr:=FS.Addr;
    Alg.ExFunc[K].Func[N].Arrow:=FS.Arrow;
    Alg.ExFunc[K].Func[N].CLST:=FS.CLST;
    Alg.ExFunc[K].Func[N].SDeep:=FS.SDeep;
    Alg.ExFunc[K].Func[N].N:=FS.N;
    Alg.ExFunc[K].Func[N].SaveReg:=FS.SaveReg;
    Alg.ExFunc[K].Func[N].CalcConst:=FS.CalcConst;
    Alg.ExFunc[K].Func[N].IntF:=FS.IntF;
    Alg.ExFunc[K].Func[N].ExeF:=_YES;// : .. 

    SetLength(Alg.ExFunc[K].Func[N].TV,Length(FS.TV));
    SetLength(Alg.ExFunc[K].Func[N].TM,Length(FS.TM));
    for j:=0 to High(FS.TV) do
    begin
     Alg.ExFunc[K].Func[N].TV[j]:=FS.TV[j];
     Alg.ExFunc[K].Func[N].TM[j]:=FS.TM[j];
    end;

    if FS.CallT = _Compiled  then
    begin
     SetLength(Alg.ExFunc[K].Func[N].ArgAdr,Length(FS.ArgAdr));
     for m:=0 to High(FS.ArgAdr) do
         Alg.ExFunc[K].Func[N].ArgAdr[m]:=FS.ArgAdr[m];
    end;
    FS.ArgAdr:=nil;

    goto endp;

 {.191}
  { end;
  end;  }


newf:
  //  -   :
  SetLength(Alg.ExFunc,Length(Alg.ExFunc)+1);
  Alg.ExFunc[High(Alg.ExFunc)].Name:=Copy(Name,1,Length(Name));

  K:=High(Alg.ExFunc);
  N:=High(Alg.ExFunc[K].Func);
  SetLength(Alg.ExFunc[K].Func,Length(Alg.ExFunc[K].Func)+1);
  N:=N+1;
  Alg.ExFunc[K].Func[N].TypeF:=FS.TypeF;
  Alg.ExFunc[K].Func[N].CallT:=FS.CallT;
  Alg.ExFunc[K].Func[N].Addr:=FS.Addr;
  Alg.ExFunc[K].Func[N].Arrow:=FS.Arrow;
  Alg.ExFunc[K].Func[N].CLST:=FS.CLST;
  Alg.ExFunc[K].Func[N].SDeep:=FS.SDeep;
  Alg.ExFunc[K].Func[N].N:=FS.N;
  Alg.ExFunc[K].Func[N].CalcConst:=FS.CalcConst;
  Alg.ExFunc[K].Func[N].IntF:=FS.IntF;
  Alg.ExFunc[K].Func[N].ExeF:=_YES;// : .. 
  Alg.ExFunc[K].Func[N].SaveReg:=FS.SaveReg;
  SetLength(Alg.ExFunc[K].Func[N].TV,Length(FS.TV));
  SetLength(Alg.ExFunc[K].Func[N].TM,Length(FS.TM));
  for j:=0 to High(FS.TV) do
  begin
   Alg.ExFunc[K].Func[N].TV[j]:=FS.TV[j];
   Alg.ExFunc[K].Func[N].TM[j]:=FS.TM[j];
  end;
  if FS.CallT = _Compiled  then
    begin
     SetLength(Alg.ExFunc[K].Func[N].ArgAdr,Length(FS.ArgAdr));
     for m:=0 to High(FS.ArgAdr) do
         Alg.ExFunc[K].Func[N].ArgAdr[m]:=FS.ArgAdr[m];
    end;
    FS.ArgAdr:=nil;
  {.191}
  SetLength(Alg.ExFunc[K].NameEx,1);
  Alg.ExFunc[K].NameEx[0]:=Copy(Name,1,Length(Name));
  Alg.ExFunc[K].Enable:=_YES;
  Alg.ExFunc[K].ReplFunc:=FS.ReplFunc;     {.193}

endp:
end;



procedure TForevalH.SetFunctionInt(Name: String; IDF: Cardinal; FS:TIntFunc);
label endp,newf;                                  //TV -     (array of types of variables) T_Real,T_Complex,T_Array
var                                          //TypeF -    (returned  type of function) T_Real,T_Complex
N,K,i,j,m,bf,nf,m1,id: Integer;                       //TM -     (array of types of variables) _Double,_Extended,_Integer
begin

//if CheckName(Name) = false then begin F_SyntaxErrorCode:=15; F_SyntaxErrorString:=Name; CalcException; goto endp; end;

  {.191}
  {for i:=0 to High(Alg.ExFunc) do
  begin
   if Name = Alg.ExFunc[i].Name then
   begin }

    FindFuncA(Name,id);           {.191}
    if id = -1 then  goto newf;    {.191}

    K:=IDF;
    N:=High(Alg.ExFunc[K].Func);

    //  -    :
    SetLength(Alg.ExFunc[K].Func,Length(Alg.ExFunc[K].Func)+1);
    N:=N+1;
    Alg.ExFunc[K].Func[N].TypeF:=FS.TypeF;
    Alg.ExFunc[K].Func[N].CallT:=FS.CallT;
    Alg.ExFunc[K].Func[N].Addr:=FS.Addr;
    Alg.ExFunc[K].Func[N].Arrow:=FS.Arrow;
    Alg.ExFunc[K].Func[N].CLST:=FS.CLST;
    Alg.ExFunc[K].Func[N].SDeep:=FS.SDeep;
    Alg.ExFunc[K].Func[N].N:=FS.N;
    Alg.ExFunc[K].Func[N].SaveReg:=FS.SaveReg;
    Alg.ExFunc[K].Func[N].CalcConst:=FS.CalcConst;
    Alg.ExFunc[K].Func[N].IntF:=FS.IntF;
    Alg.ExFunc[K].Func[N].ExeF:=FS.ExeF;

    SetLength(Alg.ExFunc[K].Func[N].TV,Length(FS.TV));
    SetLength(Alg.ExFunc[K].Func[N].TM,Length(FS.TM));
    for j:=0 to High(FS.TV) do
    begin
     Alg.ExFunc[K].Func[N].TV[j]:=FS.TV[j];
     Alg.ExFunc[K].Func[N].TM[j]:=FS.TM[j];
    end;

    if FS.CallT = _Compiled  then
    begin
     SetLength(Alg.ExFunc[K].Func[N].ArgAdr,Length(FS.ArgAdr));
     for m:=0 to High(FS.ArgAdr) do
         Alg.ExFunc[K].Func[N].ArgAdr[m]:=FS.ArgAdr[m];
    end;
    FS.ArgAdr:=nil;

    goto endp;

 {.191}
  { end;
  end;  }


newf:
  //  -   :
  //SetLength(Alg.ExFunc,Length(Alg.ExFunc)+1);

  Alg.ExFunc[{High(Alg.ExFunc)}IDF].Name:=Copy(Name,1,Length(Name));

  K:=IDF{High(Alg.ExFunc)};
  N:=High(Alg.ExFunc[K].Func);
  SetLength(Alg.ExFunc[K].Func,Length(Alg.ExFunc[K].Func)+1);
  N:=N+1;
  Alg.ExFunc[K].Func[N].TypeF:=FS.TypeF;
  Alg.ExFunc[K].Func[N].CallT:=FS.CallT;
  Alg.ExFunc[K].Func[N].Addr:=FS.Addr;
  Alg.ExFunc[K].Func[N].Arrow:=FS.Arrow;
  Alg.ExFunc[K].Func[N].CLST:=FS.CLST;
  Alg.ExFunc[K].Func[N].SDeep:=FS.SDeep;
  Alg.ExFunc[K].Func[N].N:=FS.N;
  Alg.ExFunc[K].Func[N].CalcConst:=FS.CalcConst;
  Alg.ExFunc[K].Func[N].IntF:=FS.IntF;
  Alg.ExFunc[K].Func[N].ExeF:=FS.ExeF;
  Alg.ExFunc[K].Func[N].SaveReg:=FS.SaveReg;
  SetLength(Alg.ExFunc[K].Func[N].TV,Length(FS.TV));
  SetLength(Alg.ExFunc[K].Func[N].TM,Length(FS.TM));
  for j:=0 to High(FS.TV) do
  begin
   Alg.ExFunc[K].Func[N].TV[j]:=FS.TV[j];
   Alg.ExFunc[K].Func[N].TM[j]:=FS.TM[j];
  end;
  if FS.CallT = _Compiled  then
    begin
     SetLength(Alg.ExFunc[K].Func[N].ArgAdr,Length(FS.ArgAdr));
     for m:=0 to High(FS.ArgAdr) do
         Alg.ExFunc[K].Func[N].ArgAdr[m]:=FS.ArgAdr[m];
    end;
    FS.ArgAdr:=nil;
  {.191}
  SetLength(Alg.ExFunc[K].NameEx,1);
  Alg.ExFunc[K].NameEx[0]:=Copy(Name,1,Length(Name));
  Alg.ExFunc[K].Enable:=_YES;
  Alg.ExFunc[K].ReplFunc:=FS.ReplFunc;     {.193}

endp:
end;




procedure TForevalH.FindFunc(Name: String; TV: array of Cardinal; var idn,idf,CallT: integer; var adr: Cardinal);
label endp;
var
i,j,N,K,m,bf,LF: Integer;
  nf: Integer;
  Sfn:String;
begin
adr:=0; CallT:=0; idn:=-1; idf:=-1;
{.191}



{for i:=0 to High(Alg.ExFunc) do
  begin
   if Name = Alg.ExFunc[i].Name then
   begin
    K:=i;
    N:=High(Alg.ExFunc[K].Func);
    //    :
    for m := 0 to High(Alg.ExFunc[K].Func) do
    begin
     if Length(TV) = Length(Alg.ExFunc[K].Func[m].TV) then
     begin
       bf:=0;
       for j:=0 to High(TV) do
       begin
        if Alg.ExFunc[K].Func[m].TV[j] = TV[j] then inc(bf);
       end;
       if bf = Length(TV) then
       begin
         CallT:=Alg.ExFunc[K].Func[m].CallT;
         adr:=Alg.ExFunc[K].Func[m].Addr;
         idn:=K;
         idf:=m;
         goto endp;
       end;
     end;
    end;
   end;
  end; }


  {if F_SyntaxExtension = True then
  begin}

     for i:=0 to High(Alg.ExFunc) do
     begin

       if F_SyntaxExtension = True then LF:=High(Alg.ExFunc[i].NameEx) else LF:=0;

       for nf := 0 to LF do
       begin

         SFn:=Alg.ExFunc[i].NameEx[nf];



        if Name = Sfn then
        begin
          K:=i;
          N:=High(Alg.ExFunc[K].Func);
         //    :
         for m := 0 to High(Alg.ExFunc[K].Func) do
         begin
           if Length(TV) = Length(Alg.ExFunc[K].Func[m].TV) then
           begin
              bf:=0;
              for j:=0 to High(TV) do
              begin
               if Alg.ExFunc[K].Func[m].TV[j] = TV[j] then inc(bf);
              end;
              if bf = Length(TV) then
              begin
                CallT:=Alg.ExFunc[K].Func[m].CallT;
                adr:=Alg.ExFunc[K].Func[m].Addr;
                idn:=K;
                idf:=m;
                goto endp;
              end;
           end;
         end;
        end;
       end;
     end;

  //end;

endp:
end;




procedure TForevalH.DeleteFunc(idn,idf: integer);
var
arg: integer;
begin
  arg:=Alg.ExFunc[idn].Func[idf].N;
  Alg.ExFunc[idn].Func[idf].TV:=nil;
  Alg.ExFunc[idn].Func[idf].TM:=nil;
  Alg.ExFunc[idn].Func[idf].addr:=0;
  Alg.ExFunc[idn].Func[idf].N:=-1;
  Alg.ExFunc[idn].Func[idf].CallT:=0;
  Alg.ExFunc[idn].Func[idf].TypeF:=0;
  Alg.ExFunc[idn].Func[idf].IntF:=0;

  if arg = 0 then  SetLength(Alg.ExFunc[idn].Func,0); {.207}  //void()=x

end;



procedure TForevalH.SetF(code: Integer; IDF: Integer);
var
i: integer;
begin
if (IDF >= 0) and (IDF <=  Length(Alg.ExFunc) - 1) then
begin
  if code = 1 then  Alg.ExFunc[IDF].Enable:=_YES else
  if code = 2 then  Alg.ExFunc[IDF].Enable:=_NO  else
  if code = 3 then
  begin
     if IDF = CM_DIV then     Alg.ExFunc[CM_DIV].ReplFunc:=_Yes    else
     if IDF = CM_MUL then     Alg.ExFunc[CM_MUL].ReplFunc:=_Yes    else
     if (IDF = CM_ADD) or (IDF = CM_SUB) then   begin  Alg.ExFunc[CM_ADD].ReplFunc:=_Yes; Alg.ExFunc[CM_SUB].ReplFunc:=_Yes; end
  end
  else
  if code = 4 then
  begin
     if IDF = CM_DIV then     Alg.ExFunc[CM_DIV].ReplFunc:=_No    else
     if IDF = CM_MUL then     Alg.ExFunc[CM_MUL].ReplFunc:=_No    else
     if (IDF = CM_ADD) or (IDF = CM_SUB) then   begin  Alg.ExFunc[CM_ADD].ReplFunc:=_No; Alg.ExFunc[CM_SUB].ReplFunc:=_No; end
  end
  else
  if code = 5 then   SetNewFuncToOperation('^',IDF)   {.195}
  else
  if code = 6 then
  begin                  {.215}
   Alg.ExFunc[IDF].ReplFunc:=_YES;
   for i := 0 to Length(Alg.ExFunc[IDF].Func) - 1 do   Alg.ExFunc[IDF].Func[i].ReplFunc:=_YES;
  end
  else
  if code = 7 then
  begin                  {.215}
   Alg.ExFunc[IDF].ReplFunc:=_NO;
   for i := 0 to Length(Alg.ExFunc[IDF].Func) - 1 do   Alg.ExFunc[IDF].Func[i].ReplFunc:=_NO;
  end
  else
  if code = 8 then      {.215}
  begin
   for i := 0 to Length(Alg.ExFunc[IDF].Func) - 1 do   Alg.ExFunc[IDF].Func[i].CalcConst:=_YES;
  end
  else
  if code = 9 then      {.215}
  begin
   for i := 0 to Length(Alg.ExFunc[IDF].Func) - 1 do   Alg.ExFunc[IDF].Func[i].CalcConst:=_NO;
  end
  else
  if code = 10 then      {.217}
  begin
    Alg.ExFunc[IDF].ReplFuncCFR:=_NO;
  end
  else
  if code = 11 then      {.217}
  begin
    Alg.ExFunc[IDF].ReplFuncCFZ:=_NO;
  end
  else
  if code = 12 then      {.217}
  begin
    Alg.ExFunc[IDF].ReplFuncCFR:=_YES;
  end
  else
  if code = 13 then      {.217}
  begin
    Alg.ExFunc[IDF].ReplFuncCFZ:=_YES;
  end
  else
  if code = 14 then
  begin
     for i := 0 to Length(Alg.ExFunc)  - 1 do
       begin
          Alg.ExFunc[i].ReplFuncCFR:=_NO;
       end;
  end
  else
  if code = 15 then
  begin
     for i := 0 to Length(Alg.ExFunc)  - 1 do
       begin
          Alg.ExFunc[i].ReplFuncCFZ:=_NO;
       end;
  end
   else
  if code = 16 then
  begin
     for i := 0 to Length(Alg.ExFunc)  - 1 do
       begin
          Alg.ExFunc[i].ReplFuncCFR:=_YES;
       end;
  end
  else
  if code = 17 then
  begin
     for i := 0 to Length(Alg.ExFunc)  - 1 do
       begin
          Alg.ExFunc[i].ReplFuncCFZ:=_YES;
       end;
  end ;


end;
//ForevalZ_Command.F_FastSpec:=True;
end;


procedure TForevalH.FastSpec(Bl: Boolean);
begin
 ForevalZ_Command.F_FastSpec:=Bl;
end;


procedure TForevalH.SetNewFuncToOperation(OpName: String; IDF: Cardinal);  {.195}
label endp;
var
i: Integer;
begin


for i:=0 to High(Alg.Opr) do
begin
    if OpName =  Alg.Opr[i].Name then
    begin
     Alg.Opr[i].NFunc:=IDF;
     goto endp;
    end;
end;


endp:
end;


procedure TForevalH.SetExtNameFunc(IDF: Integer; Name: String);     {.191}
var
L: Integer;
begin
if IDF >=0 then
begin
 if F_LeadToLowerCase = True then Name:=LowerCase(Name); {.221}
 L:=Length(Alg.ExFunc[IDF].NameEx);
 SetLength(Alg.ExFunc[IDF].NameEx,L+1);
 Alg.ExFunc[IDF].NameEx[L]:=Name;
end;
end;

{
procedure TForevalH.SetLoadFunction(IdType: Cardinal; Addr: Cardinal; Name: String);
begin
 SetLength(Alg.LdFunc,Length(Alg.LdFunc)+1);
 Alg.LdFunc[High(Alg.LdFunc)].TypeF:=IdType;
 Alg.LdFunc[High(Alg.LdFunc)].Addr:=Addr;
 Alg.LdFunc[High(Alg.LdFunc)].Name:=Name;
end;
}


procedure TForevalH.SetOperation(Name: String; Func: String; PR: Cardinal; GS: Integer; SE: Integer);
label 1;
var
i,nf: Integer;                             //   1,2 -  -
begin                                      //PR - priority; GS - place ((-1) before; (-2) behind) ; SE - F_SyntaxExtension
nf:=-1;
for i:=0 to High(Alg.ExFunc) do
begin
 if Func = Alg.ExFunc[i].Name then
 begin
  nf:=i; goto 1;
 end;
end;

1:
if nf = -1 then begin {Error} end;
if PR <= 0 then begin {Error} end;

SetLength(Alg.Opr,Length(Alg.Opr)+1);
Alg.Opr[High(Alg.Opr)].Name:=Name{[1]};
Alg.Opr[High(Alg.Opr)].NFunc:=nf;
Alg.Opr[High(Alg.Opr)].PR:=PR;
Alg.Opr[High(Alg.Opr)].GS:=GS;
Alg.Opr[High(Alg.Opr)].SE:=SE;
end;





procedure TForevalH.SetStackSize;
label endp;
begin
if F_SyntaxErrorCode <> 0 then goto endp;
Tree:=BeginTree;   // , ..   - 

while Tree^.Ch <> nil do
begin
Tree:=Tree^.Ch;
end;
StackSize:=Tree^.Stack.S;

while Tree^.Pr <> nil do
begin
 while Tree^.Nb <> nil  do
 begin
 Tree:=Tree^.Nb;
  while Tree^.Ch <> nil do
  begin
  Tree:=Tree^.Ch;
  end;
if Tree^.Stack.S > StackSize then StackSize:=Tree^.Stack.S;
 end;
 Tree:=Tree^.Pr;
if Tree^.Stack.S > StackSize then StackSize:=Tree^.Stack.S;
end;


endp:
end;



procedure TForevalH.Linker(S: String);      //creating of tree of expression
label endp;
var
HS: PLevel;
ND: TDataNode;
H,H1: PNode;
EOFN: Boolean;
i: Cardinal;
begin
if F_SyntaxErrorCode <> 0 then goto endp;
New(Tree);
Tree^.Ch:=nil;
Tree^.Nb:=nil;
Tree^.Pr:=nil;
BeginTree:=Tree;
// :
Tree^.Expression:=Copy(S,1,Length(S));
Tree^.Stack.S:=1;
F_IdN:=0;
Tree^.IdL:=0;
EOFN:=True;

SyntaxAnalizator(Tree^.Expression,ND,HS,EOFN);
//:
//COP<>NOP:
while EOFN <> True do
begin
if F_SyntaxErrorCode <> 0 then goto endp;

New(H);
Tree^.Ch:=H;
inc(F_IdN);
WriteNodeParam(ND);
WriteLevelParam(H,HS,0);


H^.Stack.S:=Tree^.Stack.S;
H^.Pr:=Tree;
H1:=H;
H^.Ch:=nil;
H^.Nb:=nil;

for i:=1 to High(HS) do
begin
 New(H);
 H^.Ch:=nil;
 H^.Nb:=nil;
 WriteLevelParam(H,HS,i);
 H^.Stack.S:=H1^.Stack.S+1;
 H1.Nb:=H;
 H^.Pr:=Tree;
 //HS:=HS^.Next;
 H1:=H;
end;
Tree:=H^.Pr^.Ch;
HS:=nil; //??? (  )
SyntaxAnalizator(Tree^.Expression,ND,HS,EOFN);
end;
//EOFN=True:    ( )
inc(F_IdN);
WriteNodeParam(ND);

//:
while Tree^.Pr <> nil do
begin
 while Tree^.Nb <> nil  do
 begin
 Tree:=Tree^.Nb;
 SyntaxAnalizator(Tree^.Expression,ND,HS,EOFN);
//COP<>NOP:
while EOFN<>True do
 begin
 if F_SyntaxErrorCode <> 0 then goto endp;

 New(H);
 Tree^.Ch:=H;
 inc(F_IdN);
 WriteNodeParam(ND);
 WriteLevelParam(H,HS,0);

 H^.Stack.S:=Tree^.Stack.S;
 H^.Pr:=Tree;
 H1:=H;
 H^.Ch:=nil;
 H^.Nb:=nil;
 for i:=1 to High(HS) do
 begin
  New(H);
  H^.Ch:=nil;
  H^.Nb:=nil;
  WriteLevelParam(H,HS,i);

  H^.Stack.S:=H1^.Stack.S+1;
  H1.Nb:=H;
  H^.Pr:=Tree;
  H1:=H;
 end;
 Tree:=H^.Pr^.Ch;
 HS:=nil; //??? (  )
 SyntaxAnalizator(Tree^.Expression,ND,HS,EOFN);
 end;
//EOFN=True:  
inc(F_IdN);
WriteNodeParam(ND);
end;
Tree:=Tree^.Pr;
end;

Tree:=BeginTree;

endp:
end;





(*
procedure TForevalH.FreeExtFunc(E_Func: TFunction);
var
i: integer;
begin
{.193}
 if E_Func.AllocMem = 2 then
 begin
   VirtualFree(E_Func.PAddr,0,MEM_RELEASE);
 end;

FreeFuncData(E_Func.Data);
E_Func.Code:=nil;
E_Func.Stack:=nil;   //E_Func.AllocMem = 1
E_Func.RFStack:=nil;
E_Func.PAddr:=nil;
E_Func.Addr:=0;
E_Func.Data:=nil;
end;

*)





procedure TForevalH.FreeExtFunc(E_Func: PFunction);    {.225} // on pointer
var
i: integer;
begin
{.193}
 if E_Func^.AllocMem = 2 then
 begin
   VirtualFree(E_Func^.PAddr,0,MEM_RELEASE);
 end;

FreeFuncData(E_Func^.Data);
E_Func^.Code:=nil;
E_Func^.Stack:=nil;   //E_Func.AllocMem = 1
E_Func^.RFStack:=nil;
E_Func^.PAddr:=nil;
E_Func^.Addr:=0;
E_Func^.Data:=nil;
end;



procedure TForevalH.FreeFuncData(FuncData: PFuncData);
var
FD1,FD2: PFuncData;
begin
FD1:=FuncData;
while FD1 <> nil do
begin
 FD2:=FD1^.Next;
 dispose(FD1);
 FD1:=FD2;
end;
end;





procedure TForevalH.FreeInterp;
var
i: Integer;
begin
//if F_SyntaxErrorCode = 0 then       {!!!}
begin
for i:=0 to Length(Interp)-1 do
begin
Interp[i].RData:=nil;
Interp[i].ArgTypes:=nil;
Interp[i].Expression:='';
Interp[i].ExpressionArg:='';
end;
Interp:=nil;
end;
end;



procedure TForevalH.WriteNodeParam(ND: TDataNode);
begin
Tree^.Stack.N:=ND.N;
Tree^.NCOP:=ND.NCOP;
Tree^.FD:=ND.FD;
Tree^.NFunc:=ND.NFunc;
Tree^.COP:=ND.COP;
Tree^.NObj:=ND.NObj;
Tree^.IdN:=F_IdN;//ND.IdN;
Tree^.NV1:=ND.NV1;
Tree^.NV2:=ND.NV2;
Tree^.TypeF:=ND.TypeF;
Tree^.Inv:=ND.Inv;
Tree^.TS:=ND.TS;
Tree^.NF:=ND.NF;
Tree^.AI:=ND.AI;
Tree^.CI:=ND.CI;
Tree^.FDC.re:=ND.FDC.re;
Tree^.FDC.im:=ND.FDC.im;
Tree^.TC:=ND.TC;
Tree^.TS1:=ND.TS1;
Tree^.TS2:=ND.TS2;
Tree^.VFP:=ND.VFP;
Tree^.ExpressionArg:=ND.ExpressionArg;
end;



procedure TForevalH.WriteLevelParam(H: PNode; HS: PLevel; N: Cardinal);
begin
H^.Expression:=Copy(HS[N].Expression,1,Length(HS[N].Expression));
H^.NL:=HS[N].NL;
H^.IdL:=F_IdN;//HS[N].IdL;
end;



procedure TForevalH.FindExternalBracket(S: String; var SS: String);
label 1,endp;
var
b,i,z,a:Integer;
begin
SS:=Copy(S,1,Length(S));



1:
if SS = '' then
begin
goto endp;
end;

if (SS[1] = '(') and (SS[Length(SS)] = ')') then
begin
  b:=-1;
  for i:=2 to Length(SS)-1 do
  begin
   if SS[i] = '(' then b:=b-1;
   if SS[i] = ')' then b:=b+1;
   if b = 0 then goto endp;
  end;

 Delete(SS,Length(SS),1);
 Delete(SS,1,1);
 goto 1;
end;




endp:
end;



procedure TForevalH.DeleteExternalBracketP(PS: PString);   {.219}
label outf,nxt,endp;
var
b,i,bp,L:Integer;
begin

(*
bp:=0;  L:=Length(PS^);

nxt:
if PS^ = '' then
begin
 goto outf;
end;


inc(bp);
if (PS^[bp] = '(') and (PS^[L-bp+1] = ')') then
begin

  b:=0;
  for i:=bp to L-bp do
  begin
    if PS^[i] = '(' then dec(b);
    if PS^[i] = ')' then inc(b);
    if b = 0 then  goto outf;
  end;
  goto nxt;

end;

outf:
dec(bp);
if bp > 0 then
begin
 Delete(PS^,L-bp+1,bp);
 Delete(PS^,1,bp);
end;
*)


nxt:
if PS^ = '' then
begin
 goto endp;
end;

L:=Length(PS^);

if (PS^[1] = '(') and (PS^[L] = ')') then
begin
  b:=0;
  for i:=1 to L-1 do
  begin
   if PS^[i] = '(' then dec(b)
   else
   if PS^[i] = ')' then inc(b);
   if b = 0 then goto endp;
  end;

 Delete(PS^,L,1);
 Delete(PS^,1,1);
 goto nxt;
end;




endp:
end;





function TForevalH.FindNumberPR(PR: Cardinal): Cardinal;
label 1;
var
i: Integer;
N: Cardinal;
begin
for i:=0 to High(Alg.Opr) do
begin
 if PR = Alg.Opr[i].PR then
 begin
  N:=i; goto 1;
 end;
end;

1:
FindNumberPR:=N;
end;






function TForevalH.FindOperation(S: String): integer;
label 1;
var
i,NCOP,IDF: Integer;
begin
NCOP:=-1;
for i:=0 to High(Alg.Opr) do
begin
    if S = Alg.Opr[i].Name then
    begin
     NCOP:=i;
     goto 1;
    end;
end;

1:
if  ((F_SyntaxExtension = False) and (Alg.Opr[NCOP].SE <> 0)) then NCOP:=-1;

if NCOP <> -1 then                    {.195}
begin
 IDF:=Alg.Opr[NCOP].NFunc;
 if Alg.ExFunc[IDF].Enable =_NO then NCOP:=-1;
end;

FindOperation:=NCOP;
end;




procedure TForevalH.FindSingleOP(S: String; var NCop: Integer);
var
i,j,PR1,PR2: Integer;
NCop1,NCop2,ms,Ls,Lc,IDF: Integer;
BOP: Boolean;
Ss,Sc: String;
begin
BOP:=False;
PR1:=0;
PR2:=0;
NCop1:=-1; NCop2:=-1;  NCop:=-1;

Ss:=Copy(S,1,Length(S));

Ls:=Length(Ss);

for i:=0 to High(Alg.Opr) do
begin
 if Alg.Opr[i].GS < 0 then    // . 
 begin

    if Alg.Opr[i].GS = -2 then
    begin
     Lc:=Length(Alg.Opr[i].Name);
     Sc:=Copy(Ss,Ls-Lc+1,Lc);
     if Sc = Alg.Opr[i].Name then
     begin
      NCop2:=i;
     end;
    end
    else
    if Alg.Opr[i].GS = -1 then
    begin
     Lc:=Length(Alg.Opr[i].Name);
     Sc:=Copy(Ss,1,Lc);
     if Sc = Alg.Opr[i].Name then
     begin
      NCop1:=i;
     end;
    end;



    //for synt. error:
    if (S[Length(S)] = Alg.Opr[i].Name[1]) or (S[1] = Alg.Opr[i].Name[1]) then BOP:=True;
  end;  
end;



if (NCop1 <> -1) and (NCop2 <> -1) then
begin
 if  Alg.Opr[NCop1].PR < Alg.Opr[NCop2].PR then NCop:=NCop1 else NCop:=NCop2;
end
else
if NCop1 <> -1 then NCop:=NCop1
else
if NCop2 <> -1 then NCop:=NCop2;

//find synt. error
if (NCop = -1) and (BOP = True)  then
begin
  F_SyntaxErrorCode:=5;
  F_SyntaxErrorString:=S;
end;

if  ((F_SyntaxExtension = False) and (Alg.Opr[NCOP].SE <> 0)) then NCOP:=-1;

if NCOP <> -1 then                    {.195}
begin
 IDF:=Alg.Opr[NCOP].NFunc;
 if Alg.ExFunc[IDF].Enable =_NO then NCOP:=-1;
end;

end;





function TForevalH.CheckToZeroP(PS: PString): Boolean;
label nxt;
var
b,i,z,a,bp,ep,L: Integer;
BRes: Boolean;
begin

BRes:=False;
L:=Length(PS^); ep:=0; bp:=1;
nxt:
if (PS^[bp] = '(') and (PS^[L-ep] = ')') then
begin
  inc(bp); inc(ep);
  goto nxt;
end
else
if PS^[bp] = '-' then
begin
  inc(bp);
  goto nxt;
end
else
if Copy(PS^,bp,L-bp-ep+1) = '0' then Bres:=True;

CheckToZeroP:=BRes;
end;





function TForevalH.CheckToZero(S: String): Boolean;
label
2,3,endp;
var
b,i,z,a: Integer;
BRes: Boolean;
begin
//SS:=Copy(S,1,Length(S));

BRes:=False;

z:=1;
2:
b:=0; a:=1;

if S = '' then
begin
goto endp;
end;


if S[1] = '-' then a:=2;

if  S[a] = '(' then
begin
 b:=-1;
 for i:=a+1 to Length(S)-1 do
 begin
  if S[i] = '(' then b:=b-1;
  if S[i] = ')' then b:=b+1;
  if b = 0 then goto 3
 end;


 if S[Length(S)] = ')' then
 begin
  if a = 2 then
  begin
   Delete(S,1,1);
   z:=z*(-1);
  end;
  Delete(S,1,1);
  Delete(S,Length(S),1);
  goto 2;
 end;
end;

3:
{if z = -1 then  Neg:=1
else  Neg:=0; }
if S = '0' then BRes:=True;

CheckToZero:=BRes;

endp:
end;



procedure TForevalH.MulDivOpt(S:String; var NCOP: Integer; var NPos: Cardinal; var Sret: String);
label endp;
var
Pl,Ml,BZero: Boolean;
i,b,b1,b2: Integer;
NCOP1,NCOP2,NPos1,NPosM,NPosD: Integer;
SE: Boolean;
NPS: array of integer;
NPO: array of integer;
ndiv,nmul,cpos,lastop: integer;
SM,SD,St: String;
begin

TryFPUMask; {.229}

//S1opS2opS3...opSn -> Sk1*...*Skn/(Sl1*...*Sln) ;op = '*'  '/'
//S1opS2opS3...opSn -> 0 ,if any Sm = 0 (*Sm) (except: i*0, 0*i)    ;op = '*'  '/'

SE:=False;

NCOP1:=-1; NCOP2:=-1;  NCOP:=-1;     NPos:=0;
b:=0; b1:=0; b2:=0; Pl:=False; Ml:=False;
ndiv:=0; nmul:=0; cpos:=1; lastop:=-1;
SD:=''; SM:='';  BZero:=False;  NPosM:=0; NPosD:=0;




for i:=1 to Length(S)   do
begin
 if S[i] = '(' then {b:=b-1}dec(b)   else
 if S[i] = ')' then {b:=b+1}inc(b)   else
 if S[i] = '[' then {b1:=b1-1}dec(b1) else
 if S[i] = ']' then {b1:=b1+1}inc(b1) else
 if S[i] = '{' then {b2:=b2-1}dec(b2) else
 if S[i] = '}' then {b2:=b2+1}inc(b2);

 if (b = 0) and (b1 = 0) and (b2 = 0) then
 begin

      if (S[i] = Alg.Opr[COP_MUL].Name) then
      begin

          if lastop = COP_DIV then
          begin
            if ndiv <= 1 then SD:=Copy(S,cpos+1,i-cpos-1) else SD:=SD+'*'+Copy(S,cpos+1,i-cpos-1);
          end
          else
          begin
            if cpos = 1 then
            begin
              St:=Copy(S,1,i-1) ; {NPos:=i;}  SM:=St;
            end
            else
            begin
              St:=Copy(S,cpos+1,i-cpos-1);
              if nmul = 0 then SM:=St else SM:=SM+'*'+St;
            end;
            if BZero = False then BZero:=CheckToZeroP(@St); //CheckToZeroP(St);
          end;

          NPos:=i;
          inc(nmul);
          cpos:=i;
          if NPosM = 0 then NPosM:=i;
          lastop:=COP_MUL;
      end

      else

      if (S[i] = Alg.Opr[COP_DIV].Name) then
      begin
          //NPO[High(NPO)]:=COP_DIV;
          if lastop = COP_MUL then
          begin
            St:=Copy(S,cpos+1,i-cpos-1);
            if nmul = 0 then SM:=St else SM:=SM+'*'+St;
            if BZero = False then BZero:=CheckToZeroP(@St); //CheckToZero(St);
          end
          else
          begin
            if cpos = 1 then
            begin
             St:=Copy(S,1,i-1) ; {NPos:=i;}  SM:=St;
             if BZero = False then BZero:=CheckToZeroP(@St);
            end
            else
            begin
             if ndiv <= 1 then SD:=Copy(S,cpos+1,i-cpos-1) else SD:=SD+'*'+Copy(S,cpos+1,i-cpos-1);
            end;
          end;

          NPos:=i;    //   S1,S2: NPos =   ('*'  '/')
          inc(ndiv);
          cpos:=i;
          if NPosD = 0 then NPosD:=i;
          lastop:=COP_DIV;
      end;

 end;
end;

// 
if cpos > 1 then
begin
  St:=Copy(S,cpos+1,Length(S)-cpos);
  if  lastop = COP_MUL then
  begin
    SM:=SM+'*'+St;
    if BZero = False then BZero:=CheckToZeroP(@St);
  end
  else
  if  lastop = COP_DIV then
  begin
    if ndiv > 1 then SD:=SD+'*'+St else SD:=St;
  end
end;


if BZero = True then
begin
  Sret:='0';
  NCOP:=-1;
end
else
begin
{
  x/y*t*(x+1)/(x+2)/(x+3)/(x+4)*(x+5)*(x+6)/(x+7)
}
  //   (x+1)*(x+2)*(x+3)*(x+4)*(x+5)*(x+6)

  if (ndiv > 0) then
  begin
   //FindExternalBracketP(@SD);
   Sret:=SM+'/('+SD+')' ;
   NPos:=Length(SM)+1;
   NCOP:=COP_DIV;
  end
  else
  begin
   //FindExternalBracketP(@SM);
   Sret:=SM;
   NCOP:=COP_MUL;
  end;




(*
  if (ndiv > 0) then
  begin
   FindExternalBracketP(@SD);
   Sret:=SM+'/('+SD+')';
  end
  else Sret:=SM;

  b:=0; b1:=0; b2:=0;
  for i:=1 to Length(Sret)   do
  begin
   if Sret[i] = '(' then b:=b-1;
   if Sret[i] = ')' then b:=b+1;
   if Sret[i] = '[' then b1:=b1-1;
   if Sret[i] = ']' then b1:=b1+1;
   if Sret[i] = '{' then b2:=b2-1;
   if Sret[i] = '}' then b2:=b2+1;

   if (b = 0) and (b1 = 0) and (b2 = 0) then
   begin
      if (Sret[i] = Alg.Opr[COP_MUL].Name) then
      begin
        NPos:=i;
        NCOP:=COP_MUL;
        //goto endp;
      end
      else
      if (Sret[i] = Alg.Opr[COP_DIV].Name) then
       begin
        NPos:=i;
        NCOP:=COP_DIV;
        //goto endp;
      end
   end;
  end;

*)

 end;



endp:
TryCatchFPUException;    {.229}
end;






procedure TForevalH.FindMainOperation(S:String; var NCOP: Integer; var NPos: Cardinal);
label endp;
var
Pl,Ml: Boolean;
i,b,b1,b2: Integer;
NCOP1,NCOP2,NPos1: Integer;
SE: Boolean;
begin
if S = '' then
begin
F_SyntaxErrorCode:=5;
goto endp;
end;

SE:=False;

NCOP1:=-1; NCOP2:=-1;  NCOP:=-1;   NPos:=0;
b:=0; b1:=0; b2:=0; Pl:=False; Ml:=False;

if S[1] = '(' then b:=-1 else
  if S[1] = '[' then b1:=-1 else
    if S[1] = '{' then b2:=-1 else
      if (S[1] = ')') or (S[1] = ']') or (S[1] = '}') then
      begin
       F_SyntaxErrorCode:=2;
       goto endp;
      end;


for i:=2 to Length(S)-1 {.. 1-    .. . }  do
begin
 if S[i] = '(' then b:=b-1;
 if S[i] = ')' then b:=b+1;
 if S[i] = '[' then b1:=b1-1;
 if S[i] = ']' then b1:=b1+1;
 if S[i] = '{' then b2:=b2-1;
 if S[i] = '}' then b2:=b2+1;

 if (b = 0) and (b1 = 0) and (b2 = 0) then
 begin

  NCOP2:=FindOperation(S[i]);
  if NCOP2 <> -1 then       {.195}
  begin

   if Alg.Opr[NCOP2].GS >= 0 then // . 
   begin

    if (NCOP2 <> -1) and (NCOP1 <> -1) then
    begin
     { <=,     !!!}
     if (Alg.Opr[NCOP2].PR <= Alg.Opr[NCOP1].PR)  then
     begin
      NCOP1:=NCOP2;
      NPos1:=i;
     end;
    end
    else
    if (NCOP2 <> -1) and (NCOP1 = -1) then
    begin
     NCOP1:=NCOP2;
     NPos1:=i;
    end;


   end;

  end;

 end;

NPos:=NPos1;
NCOP:=NCOP1;
end;


//   . .  -x^y, -z1^z2   (neg)
//FindSingleOP(S,NCop,NPos1);
NCop1:=FindOperation(S[1]);   {.197}
if (NCOP1 <> -1) then
begin
 if (NCOP <> -1) then
 begin
   if  (Alg.Opr[NCOP1].PR < Alg.Opr[NCOP].PR)  then NCOP:=-1;
 end
 else NCOP:=-1;
end;


//find synt. error:
if NCop = -1 then
begin
 NCOP1:=FindOperation(S[1]); NCOP2:=FindOperation(S[Length(S)]);
 if NCOP1 <> -1 then
 begin
   if (Alg.Opr[NCOP1].GS >= 0) and (Alg.Opr[NCOP1].Name <> '-') then
   begin
     F_SyntaxErrorCode:=5;
     F_SyntaxErrorString:=S;
   end
 end
 else
 if NCOP2 <> -1 then
 begin
   if Alg.Opr[NCOP2].GS >= 0 then
   begin
     F_SyntaxErrorCode:=5;
     F_SyntaxErrorString:=S;
   end
 end;
end;



endp:
end;






procedure TForevalH.FindMainOperationA(S:String; var NCOP: Integer; var NPos: Cardinal; var Sret: String);
label endp;
var
Pl,Ml,BZ1,BZ2: Boolean;
i,b,b1,b2: Integer;
NCOP1,NCOP2,NPos1,nexpr: Integer;
SE: Boolean;
Sa1,Sa2: String;
begin
Sret:=S;
F_SyntaxErrorString:=S;
if S = '' then
begin
F_SyntaxErrorCode:=E_MISSING_EXPRESSION;
goto endp;
end;
nexpr:=1; {.217A}
SE:=False;

NCOP1:=-1; NCOP2:=-1;  NCOP:=-1;    NPos:=0;
b:=0; b1:=0; b2:=0; Pl:=False; Ml:=False;

if S[1] = '(' then b:=-1 else
  if S[1] = '[' then b1:=-1 else
    if S[1] = '{' then b2:=-1 else
      if (S[1] = ')') or (S[1] = ']') or (S[1] = '}') then
      begin
       F_SyntaxErrorCode:=E_MISSING_ROUND_BRACKET;
       goto endp;
      end;


for i:=2 to Length(S)-1 {.. 1-    .. . }  do
begin
 if S[i] = '(' then b:=b-1;
 if S[i] = ')' then b:=b+1;
 if S[i] = '[' then b1:=b1-1;
 if S[i] = ']' then b1:=b1+1;
 if S[i] = '{' then b2:=b2-1;
 if S[i] = '}' then b2:=b2+1;

 if (b = 0) and (b1 = 0) and (b2 = 0) then
 begin

  NCOP2:=FindOperation(S[i]);
  if NCOP2 <> -1 then       {.195}
  begin

   if Alg.Opr[NCOP2].GS >= 0 then // . 
   begin

    if (NCOP2 <> -1) and (NCOP1 <> -1) then
    begin
     { <=,     !!!}
     if (Alg.Opr[NCOP2].PR <= Alg.Opr[NCOP1].PR)  then
     begin
      NCOP1:=NCOP2;
      NPos1:=i;
     end;
    end
    else
    if (NCOP2 <> -1) and (NCOP1 = -1) then
    begin
     NCOP1:=NCOP2;
     NPos1:=i;
    end;

    inc(nexpr);   {.217A}
   end;

  end;

 end;

NPos:=NPos1;
NCOP:=NCOP1;
end;


//   . .  -x^y, -z1^z2   (neg)
//FindSingleOP(S,NCop,NPos1);
NCop1:=FindOperation(S[1]);   {.197}
if (NCOP1 <> -1) then
begin
 if (NCOP <> -1) then
 begin
   if  (Alg.Opr[NCOP1].PR < Alg.Opr[NCOP].PR)  then NCOP:=-1;
 end
 else NCOP:=-1;
end;


//find synt. error:
if NCop = -1 then
begin
 NCOP1:=FindOperation(S[1]); NCOP2:=FindOperation(S[Length(S)]);
 if NCOP1 <> -1 then
 begin
   if (Alg.Opr[NCOP1].GS >= 0) and (Alg.Opr[NCOP1].Name <> '-') then
   begin
     F_SyntaxErrorCode:=E_MISSING_EXPRESSION;
     F_SyntaxErrorString:=S;
   end
 end
 else
 if NCOP2 <> -1 then
 begin
   if Alg.Opr[NCOP2].GS >= 0 then
   begin
     F_SyntaxErrorCode:=E_MISSING_EXPRESSION;
     F_SyntaxErrorString:=S;
   end
 end;
end;


{.217A}

if (NCOP <> -1) and (F_MulDivOptimization = True)  then
begin
   if (Alg.Opr[NCOP].NFunc = CM_DIV) or (Alg.Opr[NCOP].NFunc = CM_MUL) then
   begin
      if (nexpr > 2) then MulDivOpt(S,NCOP,NPos,Sret)
      else
      begin
        //(nexpr = 2)
        Sa1:=Copy(S,1,NPos-1);
        Sa2:=Copy(S,NPos+1,Length(S)-NPos);
        BZ1:=CheckToZeroP(@Sa1); BZ2:=CheckToZeroP(@Sa2);   //CheckToZero(Sa2);

        if (Alg.Opr[NCOP].NFunc = CM_DIV) and (BZ2 = True) then
        begin
          F_InternalError:=E_ZeroDivide ;
          F_SyntaxErrorCode:=E_INTERNAL_ERROR;
        end
        else
        begin

          if (BZ1 = True) and (Sa2 <> S_IM_UNIT)  then  begin Sret:='0'; NCOP:=-1; end
           else
          if (BZ2 = True) and (Sa1 <> S_IM_UNIT)  then  begin Sret:='0'; NCOP:=-1; end;

        end;



      end;

   end;
end;


endp:
end;




procedure TForevalH.StringAnalizator(S:String; var ND: TDataNode; var HS:PLevel);
label 3,endp;
var
SS,S1,S2: String;
PR,NPR: Cardinal;
BH,IH,IH1: PLevel;
i,p,b: Cardinal;
PR1,N,NCop: Integer;
ni,SB: Integer;
NPos: Cardinal;
BOP: Integer;
px: extended;
cx: TComplex;
begin
if F_SyntaxErrorCode <> 0 then goto endp;
BOP:=0;

SS:=S;

DeleteExternalBracketP(@SS); {.219}
//FindExternalBracket(S,SS);

InitNode(ND);

//SubstParam(SS,px,SB);     //(-1.12345E-10)
SubstParamCX(SS,cx,SB);     //(-1.12345E-10); 2+3i; 2i-5i; (1E+1)-(2E+1)i;
if SB <> C_None  then
begin
  NCop:=-1;
  goto 3;
end;




PR:=0;
//FindMainOperation(SS,NCop,NPos);
FindMainOperationA(SS,NCop,NPos,SS);  {.219}
N:=0;
if NCop <> -1 then
begin
 //inc(F_IdN);
 //ND.IdN:=F_IdN;
 SetLength(HS,2);
 S1:=Copy(SS,1,NPos-1);
 DeleteExternalBracketP(@S1); {.219}
 HS[0].Expression:=S1;//Copy(SS,1,NPos-1);
 HS[0].NL:=1;
 //HS[0].IdL:=F_IdN;
 S2:=Copy(SS,NPos+1,Length(SS)-NPos+1);
 DeleteExternalBracketP(@S2); {.219}
 HS[1].Expression:=S2;//Copy(SS,NPos+1,Length(SS)-NPos+1);
 HS[1].NL:=2;
 //HS[1].IdL:=F_IdN;
 ND.N:=2;
 ND.COP:=_COP;
 ND.NFunc:=Alg.Opr[NCop].NFunc;
 ND.NCOP:=NCOP;  // 

 //ND.ExpressionArg:=SS;
 {.216}
 {if NCOP = CM_POWER then }ND.ExpressionArg:=HS[0].Expression+','+HS[1].Expression;
 BOP:=2;
end
else
begin
 FindSingleOp(SS,NCop);
 if NCop <> -1 then
 begin
  ND.COP:=_FUNC;
  ND.N:=1;
  ND.NFunc:=Alg.Opr[NCop].NFunc;
  SetLength(HS,1);
  if Alg.Opr[NCop].GS = -1 then HS[0].Expression:=Copy(SS,2,Length(SS)-1)
  else
  if Alg.Opr[NCop].GS = -2 then HS[0].Expression:=Copy(SS,1,Length(SS)-Length(Alg.Opr[NCop].Name){-1});
  HS[0].NL:=1;
  ND.NCOP:=NCOP;  // 
  //inc(F_IdN);   {.193}
  ND.ExpressionArg:=SS;//HS[0].Expression; // -
  //ND.IdN:=F_IdN;
  //HS[0].IdL:=F_IdN;
 end
 else
 begin
3:
  ND.COP:=0;
  SetLength(HS,1);
  ND.N:=1;
  HS[0].NL:=1;
  HS[0].Expression:=Copy(SS,1,Length(SS));
 end;
end;

//find synt. error
if (NCop <> -1) and (BOP = 2) then
begin
 FindExternalBracket(HS[0].Expression,S1);
 FindExternalBracket(HS[1].Expression,S2);
 if (S1 = '') or (S2 = '') then
 begin
  F_SyntaxErrorCode:=5;
  F_SyntaxErrorString:=S;
 end;
end
else
if NCop <> -1 then
begin
   if HS[0].Expression = '' then
   begin
     F_SyntaxErrorCode:=5;
     F_SyntaxErrorString:=S;
   end;
end;

endp:
end;




procedure TForevalH.SubstParam(S1: String;  var C: TFloat; var SB: Integer);
label endp;
var
N,i: Cardinal;
S1h,S3: String;
Ct: TFloat;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

SB:=0;
C:=0;
if S1 = '' then
begin
F_SyntaxErrorCode:=5;
goto endp;
end;

N:=1; {S1h:=Copy(S1,1,Length(S1));}  SB:=0;

SaveSW; {.229} {TryStrToFloat damage SW}
if TryStrToFloat(S1,Ct,G_FMT) then    {.195}
begin
 C:=StrToFloat({PointToDec(S1h)}S1,G_FMT);
 SB:=1;
end
else
SB:=0;

endp:
end;





procedure TForevalH.SubstParamCX(S: String;  var CX: TComplex; var SB: Integer);
label endp;
var
C,Cr1,Cr2,Ci1,Ci2: TFloat;
N,i,NPos: Cardinal;
NCop,Li,T1,T2,nz,ni: Integer;
S1,S2,Sc,Si,St: String;                              //SB=0{no},1(real),2(image),3(complex)
begin
if F_SyntaxErrorCode <> 0 then goto endp;

//FindExternalBracket(S,S);
DeleteExternalBracketP(@S); {.219}

C:=0; SB:=0; CX.re:=0; CX.im:=0; nz:=1;
SubstParam(S, C, SB);

if SB = C_Real then
begin
  CX.re:=C; goto endp;
end;

if F_SyntaxExtension = False then
begin
 SB:=C_None;
 goto endp;
end;



St:=S;
if (St = S_IM_UNIT) and (F_RecoverImUnit = False) then
begin
   CX.im:=1;
   SB:=C_Image;
   goto endp;
end;



C:=0; SB:=C_None;
FindMainOperation(S,NCop,NPos);

if NCop = -1 then        //3i
begin
 Li:=Length(S_IM_UNIT);
 Sc:=Copy(S,1,Length(S)-Li);
 Si:=Copy(S,Length(S)-Li+1,Li);


 if (Si = S_IM_UNIT) and (F_RecoverImUnit = False) then
 begin
   if Sc = '-' then Sc:='-1';    //-i
   //FindExternalBracket(Sc,Sc);
   DeleteExternalBracketP(@Sc); {.219}
   SubstParam(Sc, C, SB);
   if SB = C_Real then
   begin
     CX.im:=C;
     SB:=C_Image;
   end;
 end;

 goto endp;
end;

//-2-(-8)
if  (NCop = 0) or (NCop = 1) then      {+,-}
begin
 if NCop = 1 then nz:=-1;

 S1:=Copy(S,1,NPos-1);
 S2:=Copy(S,NPos+1,Length(S)-NPos+1);

 Li:=Length(S_IM_UNIT);
 Sc:=Copy(S1,1,Length(S1)-Li);
 Si:=Copy(S1,Length(S1)-Li+1,Li);
 T1:=0;

 if (Si = S_IM_UNIT) and (F_RecoverImUnit = False) then             //i-7i,  i+i, -i-i, -i-(i)
 begin
   //FindExternalBracket(Sc,Sc);
   DeleteExternalBracketP(@Sc); {.219}
   if Sc = '-' then Sc:='-1';    //-i
   if Sc = '' then Sc:='1';
   SubstParam(Sc, C, SB);
   if SB = C_Real then
   begin
     Ci1:=C;
     T1:=_IM;
   end;
 end
 else
 begin
   //FindExternalBracket(S1,S1);
   DeleteExternalBracketP(@S1); {.219}
   SubstParam(S1, C, SB);
   if SB = C_Real then
   begin
     Cr1:=C;
     T1:=_RE;
   end;
 end;

 if T1 = 0 then begin SB:=C_None; goto endp; end;



 Li:=Length(S_IM_UNIT);
 Sc:=Copy(S2,1,Length(S2)-Li);
 Si:=Copy(S2,Length(S2)-Li+1,Li);
 T2:=0;

 if (Si = S_IM_UNIT) and (F_RecoverImUnit = False) then
 begin
   //FindExternalBracket(Sc,Sc);
   DeleteExternalBracketP(@Sc); {.219}
   if Sc = '-' then Sc:='-1';    //-i
   if Sc = '' then Sc:='1';
   SubstParam(Sc, C, SB);
   if SB = C_Real then
   begin
     Ci2:=C;
     T2:=_IM;
   end;
 end
 else
 begin
   //FindExternalBracket(S2,S2);
   DeleteExternalBracketP(@S2); {.219}
   SubstParam(S2, C, SB);
   if SB = C_Real then
   begin
     Cr2:=C;
     T2:=_RE;
   end;
 end;

 if T2 = 0 then begin SB:=C_None; goto endp; end;

 if (T1 = _RE) and (T2 = _RE) then
 begin
  CX.re:=Cr1+nz*Cr2; SB:=C_Real;
 end
 else
  if (T1 = _IM) and (T2 = _IM) then
 begin
  CX.im:=Ci1+nz*Ci2; SB:=C_Image;
 end
 else
 if (T1 = _RE) and (T2 = _IM) then
 begin
  CX.re:=Cr1; CX.im:=nz*Ci2; SB:=C_Complex;
 end
 else
 if (T1 = _IM) and (T2 = _RE) then
 begin
  CX.re:=nz*Cr2; CX.im:=Ci1; SB:=C_Complex;
 end;

end;




endp:
end;




procedure TForevalH.NumberAnalizator(S: String;  var ND: TDataNode; var EOFN: Boolean);
label endp;
var
S2,S1: String;
ni,SB,code: Integer;
C: TFloat;
TF: Integer;
BH: Boolean;
CX: TComplex;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

EOFN:=False;
InitNode(ND);



FindVar(S,ni);
 if ni >= 0 then
  begin
   ND.COP:=_LDSF;
   ND.NObj:=ni;
   EOFN:=True;
   //ND.TS:=TF;
   goto endp;
  end;


//SubstParam(S,C,SB);
SubstParamCX(S,CX,SB);
if SB <> C_None then
  begin
    ND.TC:=SB;
    ND.FDC.re:=CX.re;
    ND.FDC.im:=CX.im;
    ND.FD:=CX.re;
   //inc(F_IdN);
   //ND.IdN:=F_IdN;
    if SB = C_Real  then ND.COP:=_LDSC else  ND.COP:=_LDSCX;
    EOFN:=True;
    goto endp;
  end;





FindControlCom(S,code,ni,BH);
if BH = True then
begin
 if code = _FLD then
 begin
   ND.COP:=_FLD;
 end
 else
 if code = _JMP then
 begin
   ND.COP:=_FUNC;
   ND.NFunc:=CM_JMP;
 end
 else
 if code = CM_NOP then  {.203}
 begin
   ND.COP:=_FUNC;
   ND.NFunc:=CM_NOP;
   ND.N:=0;
 end;


 ND.N:=0;
 ND.AI:=ni;
 EOFN:=True;
 goto endp;
end;

{
FindJMP(S,ni);
if ni <> 0 then
begin
 ND.COP:=_JMP;
 ND.AI:=ni;
 EOFN:=True;
 goto endp;
end;
}

F_SyntaxErrorCode:=1;         // 
F_SyntaxErrorString:=Copy(S,1,Length(S));
EOFN:=False;

endp:
end;



procedure TForevalH.FindConst(S: String;  var ND: TDataNode; var EOFN: Boolean);
label endp;
var
S2,S1: String;
ni,SB,code: Integer;
C: TFloat;
TF: Integer;
BH: Boolean;
CX: TComplex;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

EOFN:=False;
InitNode(ND);

SubstParamCX(S,CX,SB);
if SB <> C_None then
  begin
    ND.TC:=SB;
    ND.FDC.re:=CX.re;
    ND.FDC.im:=CX.im;
    ND.FD:=CX.re;
   //inc(F_IdN);
   //ND.IdN:=F_IdN;
    if SB = C_Real  then ND.COP:=_LDSC else  ND.COP:=_LDSCX;
    EOFN:=True;
  end;

endp:
end;



procedure TForevalH.FindControlCom(S: String; var code,ni: Integer; var BH: Boolean);
begin
BH:=False;
FindJMP(S,ni);
 if ni <> 0 then
 begin
  code:=_JMP;
  BH:=True;
 end
else
begin
FindFLD(S,ni);
if ni <> 0 then
 begin
  code:=_FLD;
  BH:=True;
 end
 else
 begin
  if S = '#nop' then
  begin
   code:=CM_NOP;
   BH:=True;
  end;
 end
end


end;




procedure TForevalH.FindJMP(S: String; var ni: Integer);
begin
//ni= 1       2      3       4      5      6     7
//  #JMP, #JMPE, #JMPEL, #JMPEB, #JMPB, #JMPL, #JMPNE

if S = '#jmp'    then ni:=1 else
if S = '#jmpe'   then ni:=2 else
if S = '#jmpel'  then ni:=3 else
if S = '#jmpeb'  then ni:=4 else
if S = '#jmpb'   then ni:=5 else
if S = '#jmpl'   then ni:=6 else
if S = '#jmpne'  then ni:=7 else
ni:=0;

end;



procedure TForevalH.FindFLD(S: String; var ni: Integer);
begin
//ni= 1     2
//  #FLD1, #FLDZ,
if S = '#fld1'    then ni:=1 else
if S = '#fldz'   then ni:=2 else
ni:=0;
end;



procedure TForevalH.FindReIm(S: String; var S1:String; var TF: Integer);
var
r,i: Integer;
SR,SI,ST: String;
begin
  //r:=pos('.re',LowerCase(S));
  r:=pos('.re',S);
  if (r <> 0) and (r = Length(S)-2) then
  begin
   TF:=_RE; S1:=Copy(S,1,Length(S)-3);
  end
  else
  begin
   //i:=pos('.im',LowerCase(S));
   i:=pos('.im',S);
   if (i <> 0) and (i = Length(S)-2) then
   begin
    TF:=_IM; S1:=Copy(S,1,Length(S)-3);
   end
   else
   begin
    S1:=S; TF:=0;
   end;
  end;



end;






procedure TForevalH.NumberAnalizatorA(S: String;  var nf: Integer; var FD: extended; var EF: Integer);
label endp;
var
S2: String;
ni,SB: Integer;
C: TFloat;
begin                   //EF = 1(number: FD); =2(var: nf); =0(other)
if F_SyntaxErrorCode <> 0 then goto endp;

nf:=-1;
FD:=0;
EF:=0;
FindVar(S,ni);
if ni >= 0 then
begin
 if (Alg.Obj[ni].TypeF = T_Real) or (Alg.Obj[ni].TypeF = T_Complex) then
 begin
  nf:=ni;
  EF:=_FVar;
 end;
end
else
begin
 SubstParam(S,C,SB);
 if SB = 1 then
 begin
 FD:=C;
 EF:=_Const;
 end;
end;

endp:
end;



procedure TForevalH.CheckRecoverImUnit;
label endp;
var
ni: integer;
TV: Integer;
begin
F_RecoverImUnit:=False;

 FindVar(S_IM_UNIT,ni);
 if ni <> -1 then
 begin
   TV:=Alg.Obj[ni].TypeF;
   if (TV <> T_Complex)  then begin F_RecoverImUnit:=True; goto endp; end;
 end
 else
 F_RecoverImUnit:=True;

endp:
end;


procedure TForevalH.FindVar(S1: String; var ni: Integer);
label endp;
var
i: Cardinal;
S2,S3: String;
begin                                          //ni -    
if F_SyntaxErrorCode <> 0 then goto endp;      //ni = -1: .  
ni:=-1;

//S2:=Copy(S1,1,Length(S1));



for i:=0 to High(Alg.Obj) do
begin
S3:=Alg.Obj[i].Name;

 if S1 = S3 then
  begin
   ni:=i;
   if Alg.Obj[i].TypeF = T_Complex then F_ComplexNumber:=True;   //    

   //if ((LowerCase(S3) <> 'pi') and (LowerCase(S3) <> 'i')) then F_PresentVar:=True;

   if (S3 = 'pi') then  goto endp;
   if (S3 = S_IM_UNIT) and (Alg.Obj[i].TypeF = T_Complex)  then goto endp;

   F_PresentVar:=True;

   goto endp;
  end;
end;



endp:
end;



procedure TForevalH.FindVarA(S1: String; var ni: Integer; var Adr: TAddress; var TV,TM: Integer);
label endp;
var
nv: Integer;
begin                                          //ni -    
if F_SyntaxErrorCode <> 0 then goto endp;      //ni = -1: .  
ni:=-1;
Adr:=0; TV:=0; TM:=0;

FindVar(S1,nv);
if nv >= -1 then
begin
 GetVar(nv,Adr,TV,TM);
 ni:=nv;
end;

endp:
end;



procedure TForevalH.ExistVar(S1: String; var Addr: TAddress; var IdType,MType: Cardinal);
label endp;
var
i: Cardinal;
S2,S3: String;
begin


S2:=S1;


Addr:=0;
IdType:=0;
MType:=0;

for i:=0 to High(Alg.Obj) do
begin
S3:=Alg.Obj[i].Name;

 if S2 = S3 then
  begin
    Addr:=Alg.Obj[i].Addr;
    IdType:=Alg.Obj[i].TypeF;
    MType:=Alg.Obj[i].MType;
   goto endp;
  end;
end;



endp:
end;



{.191}
procedure TForevalH.ExistVarEx(S1: String; var Addr: TAddress; var IdType,MType,ReIm,ImU: Cardinal);
label endp;
var
i: Cardinal;
S2,S3: String;
TF: Integer;
begin


S2:=S1;

FindReIm(S2,S2,TF);


Addr:=0;
IdType:=0;
MType:=0;
ReIm:=TF;
ImU:=0;


if S2 = S_IM_UNIT then ImU:=Im_Unit;


for i:=0 to High(Alg.Obj) do
begin
S3:=Alg.Obj[i].Name;

 if S2 = S3 then
  begin
    Addr:=Alg.Obj[i].Addr;
    IdType:=Alg.Obj[i].TypeF;
    MType:=Alg.Obj[i].MType;
   goto endp;
  end;
end;



endp:
end;



procedure TForevalH.FindFuncBr(S: String; BrS1,BrS2: String; var Sf: String; var Sa: String; var FH: Boolean);
label 1,endp;
var
bb,b2,b1,i: Integer;                                              //FH=True: func(arg)->Sf(Sa)
begin
                                                                   //BrS=(, [, {
FH:=False;
bb:=0; b1:=0;
for i:=1 to Length(S) do
begin
 if S[i] = {'('}BrS1 then begin b1:=i; goto 1; end;
end;
if b1 = 0 then begin FH:=False; goto endp; end;

1:
(*
b2:=0; bb:=-1;
for i:=b1+1 to Length(S) do
begin
 if S[i] = '(' then bb:=bb-1;
 if S[i] = ')' then bb:=bb+1;
 if (i <> Length(S)) and (bb = 0) then begin {Internal Error} end;
end;
*)
if b1 = 1 then  FH:=False else FH:=True;
if S[Length(S)] <> BrS2 then   FH:=False;

Sf:=Copy(S,1,b1-1);
Sa:=Copy(S,b1+1,Length(S)-b1-1);

endp:
end;


procedure TForevalH.FindFunction(S: String;  var ND: TDataNode; var LV: PLevel;  var BH,EOFN: Boolean);
label 1,2,3,4,endp,intf;
var
i,k,l,j,bb,pf,pr,b1,b2,nf,ni,TV: Integer;       //BH -   /
S1,Sa,Sf,Sf1,Sfn: String;                     //EOFN - (end of node)-  :      /
Neg,SB,TM: Integer;
ExFunc,FH,FH1: Boolean;
C: Extended;
begin
if F_SyntaxErrorCode <> 0 then goto endp;
F_CurrentString:=S;

BH:=False;
EOFN:=False;
FH:=False;
FH1:=False;


//[-[x-1.5]-[-[x+5.7]]]-[t-[t-[t+7.5]-[t+1.8]]+t]

nf:=0;
// [arg]->Trunc(arg); {arg}->Frac(arg)
if (S[1] = '[') and (S[Length(S)] = ']') and (F_SyntaxExtension = True) then begin nf:=CM_TRUNC; Sa:=Copy(S,2,Length(S)-2); end
else
if (S[1] = '{') and (S[Length(S)] = '}') and (F_SyntaxExtension = True) then begin nf:=CM_FRAC; Sa:=Copy(S,2,Length(S)-2); end
else
// : func(arg)
begin

  FindFuncBr(S,'(',')',Sf,Sa,FH);
  if FH = False then goto 3;

  (*
  bb:=0; pf:=0; b1:=0;
  for i:=1 to Length(S) do
  begin
   if S[i] = '(' then begin b1:=i; goto 1; end;
  end;
  if b1 = 0 then goto 3;

1:
  b2:=0; bb:=-1;
  for i:=b1+1 to Length(S) do
  begin
   if S[i] = '(' then bb:=bb-1;
   if S[i] = ')' then bb:=bb+1;
   if (i <> Length(S)) and (bb = 0) then begin {Internal Error} end;
  end;


  Sf:=Copy(S,1,b1-1);
  Sa:=Copy(S,b1+1,Length(S)-b1-1);
  *)

  Sf1:=Sf;

  nf:=-1;
  {.191}
  {
  for i:=0 to High(Alg.ExFunc) do
  begin
    Sfn:=Alg.ExFunc[i].Name;
    if F_FuncShift = False then
    begin
     Sfn:=LowerCase(Sfn);
    end;
    if Sf1 = Sfn then  begin nf:=i;  goto 2; end;
  end;
   }
   {
  for i:=0 to High(Alg.ExFunc) do
  begin
    for j := 0 to High(Alg.ExFunc[i].NameEx) do
    begin
       Sfn:=Alg.ExFunc[i].NameEx[j];
       if F_FuncShift = False then
       begin
         Sfn:=LowerCase(Sfn);
       end;
       if (Sf1 = Sfn) and (Alg.ExFunc[i].Enable = _YES) then  begin nf:=i;  goto 2; end;
     end;
  end;
   }
   FindFuncA(Sf1,nf);
end;


2:
 if nf <> -1 then
 begin

    FindManyArg(Sa,ArgM);
    ND.ExpressionArg:=Sa; {.193}
    if Length(ArgM) = 0  then // INFINITE
    begin

     {-  }
     {F_SyntaxErrorCode:=4;
     F_SyntaxErrorString:=Copy(Sf,1,Length(Sf));}

     F_SyntaxErrorCode:=0;
     for i := 0 to High(Alg.ExFunc[nf].Func) do
     begin
           if (Alg.ExFunc[nf].Func[i].CallT = _STACK_INFINITE) or (Alg.ExFunc[nf].Func[i].CallT = _STACK_INFINITE_A) then
           begin
              ND.N:=0; ND.COP:=_Func; ND.NFunc:=nf;  ND.NF:=i;  BH:=True; EOFN:=True; SetLength(LV,0);
              goto endp;
           end;
     end;

       { -   (.203)  (1)}
        FindZeroArg(NF,ni);
        if ni <> -1 then
        begin
           // 
           if Alg.ExFunc[NF].Func[ni].IntF = 1 then
           begin
             SetLength(LV,0); ND.N:=0; ND.COP:=_Func; ND.NF:=ni; ND.NFunc:=nf; BH:=True;  EOFN:=True;  goto intf;
           end
           else
           // :
           ND.N:=0; ND.COP:=_Func; ND.NFunc:=nf;  ND.NF:=ni;  BH:=True; EOFN:=True; SetLength(LV,0);  goto endp;  {.203}
        end
        else
        begin
          F_SyntaxErrorCode:=4;
          F_SyntaxErrorString:=Copy(Sf,1,Length(Sf));
          goto endp;
        end;
     {(1):}
     {F_SyntaxErrorCode:=4;
     F_SyntaxErrorString:=Copy(Sf,1,Length(Sf));
     goto endp;}

    end;

    {inc(F_IdN);
    ND.IdN:=F_IdN;}



    //Func(Vec)       -.  : Vec   
    if Length(ArgM) = 1 then
    begin
      FindVar(ArgM[0],ni);
      if ni <> -1 then
      begin
       TV:=Alg.Obj[ni].TypeF;
       if TV = T_Array then
       begin
         for i := 0 to High(Alg.ExFunc[nf].Func) do
         begin
           if (Alg.ExFunc[nf].Func[i].N = 1) and (Alg.ExFunc[nf].Func[i].TV[0] = T_Array) then
           begin
             if Alg.ExFunc[nf].Func[i].IntF = 1 then    //internal
             begin
              ND.N:=0; ND.COP:=_Func; ND.NFunc:=nf;  ND.NF:=i; ND.NV1:=ni; BH:=True; EOFN:=True; SetLength(LV,0);  goto endp;
             end;
           end;
         end;
       end;
      end;
    end;



    SetLength(LV,1);
    LV[0].Expression:=Copy(ArgM[0],1,Length(ArgM[0]));
    {LV[0].NL:=1;
    LV[0].IdL:=F_IdN;}
    for i:= 1 to High(ArgM) do
    begin
     SetLength(LV,Length(LV)+1);
     LV[i].Expression:=Copy(ArgM[i],1,Length(ArgM[i]));
     {LV[i].NL:=i+1;
     LV[i].IdL:=F_IdN;}
    end;

    ND.N:=Length(ArgM);
    ND.COP:=_Func;
    ND.NFunc:=nf;
    BH:=True;

    intf:
    if (ND.NFunc = CM_POWER) and (F_OperationOptimizatorA2 = True) then
    begin
     PowerAnalizator(LV,ND,LV,ND,EOFN);
     BH:=True;
    end
    else
    if (ND.NFunc = CM_ROOT) and (F_OperationOptimizatorA2 = True) then
    begin
     RootAnalizator(LV,ND,LV,ND,EOFN);
     BH:=True;
    end
    else
    if ND.NFunc = CM_IFin then
    begin
     IFAnalizator(LV,ND,LV,ND);
     if F_SyntaxErrorCode <> 0 then F_SyntaxErrorString:=Copy(S,1,Length(S));
     BH:=True;
     EOFN:=False;
    end
    else
    if ND.NFunc = CM_SAVEin then
    begin
     SaveAnalizator(LV,ND,LV,ND);
     BH:=True;
     EOFN:=False;
    end
    else
    if ND.NFunc = CM_JMP then
    begin
     GOTOAnalizator(LV,ND,LV,ND);
     BH:=True;
     EOFN:=True;
    end
    else
    if (ND.NFunc = CM_INC) or (ND.NFunc = CM_DEC) then
    begin
     IDAMAnalizator(LV,ND,LV,ND);
     BH:=True;
     EOFN:=True;
    end
    else
    if ND.NFunc = CM_SETLENin then
    begin
     SetLenAnalizator(LV,ND,LV,ND);
     BH:=True;
     EOFN:=False;
    end
    else
    if ND.NFunc = CM_SWAP then
    begin
     SwapAnalizator(LV,ND,LV,ND);
     BH:=True;
     EOFN:=True;
    end
    else
    if ND.NFunc = CM_MOD then
    begin
     MODAnalizator(LV,ND,LV,ND,EOFN);
     BH:=True;
    end
    else
    if ND.NFunc = CM_POLYin then
    begin
     POLYAnalizator(LV,ND,LV,ND,EOFN);
     BH:=True;
    end
    else
    if ND.NFunc = CM_RANDin then
    begin
     RANDAnalizator(LV,ND,LV,ND,EOFN);
     BH:=True;
    end
    else
    if (ND.NFunc = CM_MAX) or (ND.NFunc = CM_MIN)  or (ND.NFunc = CM_NORM) or (ND.NFunc = CM_AVR) then
    begin
      DataFuncAnalizator(LV,ND,LV,ND,EOFN);
      BH:=True;
    end;
    (*                {.219}
    else
     if ND.NFunc = CM_SAFECALL then
    begin
     SAFECALLAnalizator(LV,ND,LV,ND,EOFN);
     BH:=True;
    end;
     *)







 end
 else  //nf=-1
 //  :AI = (1)Vec[num],(2)Vec[Trunc(Var)],(0)Vec[Trunc(Expr)]
 begin
  3:
  FindFuncBr(S,'[',']',Sf,Sa,FH1);
  if FH1 = True then FindVar(Sf,ni) else ni:=-1;

  if ni <> -1 then //ni - vector
  begin
    if Alg.Obj[ni].TypeF = T_Array then
    begin
      {inc(F_IdN);
      ND.IdN:=F_IdN;}
      ND.NObj:=ni;
      ND.COP:=_Func;
      ND.NFunc:=CM_LDSVX;
      BH:=True;
      FindVar(Sa,ni);

      if ni <> -1 then    //ni - vector's arg: Vec[var]
      begin
        if Alg.Obj[ni].TypeF = T_Real then
        begin
         ND.NV1:=ni;
         ND.AI:=2;
         EOFN:=True;
         SetLength(LV,0);
         ND.N:=0;
        end
        else
        begin    //type of arg <> real
          F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
          F_SyntaxErrorString:=Copy(F_CurrentString,1,Length(F_CurrentString));
          F_SyntaxErrorStringA:=Copy(Sa,1,Length(Sa));
          //F_SyntaxErrorString1:=Copy(Sa,1,Length(Sa));
          goto endp;
        end;
      end
      else
      begin
        SubstParam(Sa,C,SB);
        if SB = 1 then    //Vec[num]  must be trunc(num)=num!!!
         begin
          if Trunc(C) = C then
          begin
           ND.FD:=C;
           ND.AI:=1;
           ND.N:=0;
           EOFN:=True;
           SetLength(LV,0);
           goto endp;
          end
          else
          begin      //vec[num]: 'num' must be integer
            F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
            F_SyntaxErrorString:=Copy(F_CurrentString,1,Length(F_CurrentString));
            F_SyntaxErrorStringA:=Copy(Sa,1,Length(Sa));
            //F_SyntaxErrorString1:=Copy(Sa,1,Length(Sa));
          goto endp;
          end;
         end
         else
         begin   //Vec[expr]
           ND.AI:=0;
           SetLength(LV,1);
           LV[0].Expression:=Copy(Sa,1,Length(Sa));
           ND.N:=1;
           {LV[0].NL:=1;
           LV[0].IdL:=F_IdN;}
           EOFN:=False;
         end;
      end

    end
    else   //Vec <> T_Array
    begin
      F_SyntaxErrorCode:=6; //UknownFunction
      F_SyntaxErrorString:=Copy(Sf,1,Length(Sf));
      goto endp;
    end;
  end
  else
  begin  //-2-(-8)
    if ((FH = True) or (FH1 = True)) and (CheckName(Sf) = true) then
    begin
     F_SyntaxErrorCode:=6; //UknownFunction
     F_SyntaxErrorString:=Copy(Sf,1,Length(Sf));
     goto endp;
    end;
  end;

 end;



endp:
if BH = True then
begin
 {inc(F_IdN);
 ND.IdN:=F_IdN;}
 if {Length(LV) > 0} EOFN = False then
 begin
   for i := 0 to High(LV) do
   begin
     //LV[i].IdL:=F_IdN;
     LV[i].NL:=i+1;
   end;
 end;
end;
end;






procedure TForevalH.FindManyArg(S: String; var ArgM: TArrayS);
label endp;
var
i,N: Cardinal;
PP: array of Cardinal;
bb: Integer;
begin
if Length(S) = 0 then begin SetLength(ArgM,0); goto endp; end;

bb:=0;
N:=1; SetLength(PP,N+1); PP[1]:=0;

for i:=1 to Length(S) do
begin
 if S[i] = '(' then bb:=bb-1;
 if (bb = 0) and (S[i] = ',') then
 begin
 inc(N);
 SetLength(PP,N+1);
 PP[N]:=i;
 end;
 if S[i] = ')' then bb:=bb+1;
end;

inc(N);  SetLength(PP,N+1); PP[N]:=Length(S)+1;

SetLength(ArgM,{N}N-1);

for i:=1 to N-1 do
begin
ArgM[{i}i-1]:=Copy(S,PP[i]+1,PP[i+1]-PP[i]-1);
if (ArgM[{i}i-1] = '')  then
begin
F_SyntaxErrorCode:=4; F_SyntaxErrorString:=Copy(S,1,Length(S)); goto endp;
end;
end;

endp:
end;





procedure   TForevalH.ReplaceTruncBr(S: String; var S1: String);
label 1,endp;
var
 i,L,p,t: Integer;
begin
L:=Length(S); p:=1;
//[[x-1]+[x+1]]-[x-[x+[x-1]-[x+1]]+y]
//[-[x-1.5]-[-[x+5.7]]]-[t-[t-[t+7.5]-[t+1.8]]+t]
while p < L do
begin
  for i:=p to L do
  begin
   if S[i] = '[' then
   begin
     p:=i; t:=1; goto 1;
   end
   else
   if S[i] = ']' then
   begin
     p:=i; t:=2; goto 1;
   end;
  end;
  goto endp;
1:

  if t = 1 then
  begin
   Delete(S,p,1); Insert('trunc(',S,p); p:=p+5
  end
  else
  if t = 2 then
  begin
    Delete(S,p,1); Insert(')',S,p);
  end;

  L:=Length(S);
end;

endp:
S1:=Copy(S,1,Length(S));
end;





procedure   TForevalH.ReplaceFracBr(S: String; var S1: String);
label 1,endp;
var
 i,L,p,t: Integer;
begin
L:=Length(S); p:=1;
//[[x-1]+[x+1]]-[x-[x+[x-1]-[x+1]]+y]
while p < L do
begin
  for i:=p to L do
  begin
   if S[i] = '{' then
   begin
     p:=i; t:=1; goto 1;
   end
   else
   if S[i] = '}' then
   begin
     p:=i; t:=2; goto 1;
   end;
  end;
  goto endp;
1:

  if t = 1 then
  begin
   Delete(S,p,1); Insert('frac(',S,p); p:=p+5
  end
  else
  if t = 2 then
  begin
    Delete(S,p,1); Insert(')',S,p);
  end;

  L:=Length(S);
end;

endp:
S1:=Copy(S,1,Length(S));
end;



procedure   TForevalH.ReplaceAbsBr(S: String; var S1: String);
label 1,endp;

             function GetTypeAbsBr(p: Integer; S: String): Integer;
             begin
              if p = 1 then GetTypeAbsBr:=1
              else
              if p = Length(S) then GetTypeAbsBr:=2
              else
              if (S[p-1] = '+') or (S[p-1] = '-') or (S[p-1] = '*') or
                 (S[p-1] = '/') or (S[p-1] = '^') or (S[p-1] = '(') or
                 (S[p-1] = '[') or (S[p-1] = '{') or (S[p-1] = ',') or
                 (S[p-1] = '=') or (S[p-1] = '<') or (S[p-1] = '>')
                 then GetTypeAbsBr:=1
              else
               GetTypeAbsBr:=2;
             end;


var
 i,L,p,t,nbr: Integer;
begin
L:=Length(S); p:=1; nbr:=0;
//||x-1|+|x+1||-|x-|x+|x-1|-|x+1||+y|
//||x-1|+||x+1|-|x+2|||-||x-1|+||x+1|^||x+2|-x|+|x+1||+|x+1||
while p < L do
begin
  for i:=p to L do
  begin
   if S[i] = '|' then
   begin
     inc(nbr); p:=i; goto 1;
   end;
  end;
  goto endp;
1:
  t:=GetTypeAbsBr(p,S);
  if t = 1 then
  begin
   Delete(S,p,1); Insert('abs(',S,p); p:=p+3
  end
  else
  if t = 2 then
  begin
    Delete(S,p,1); Insert(')',S,p);
  end;

  L:=Length(S);
end;

endp:
S1:=Copy(S,1,Length(S));

if (nbr mod 2 <>  0) then
begin
   F_SyntaxErrorCode:=E_MISSING_ABS_BRACKET;
end;

end;




procedure TForevalH.insIf(S: String; P,N: Integer; var S1: String);
label endp;
var
i,br: integer;
begin
br:=0;
for I := P downto 1 do
begin
   if (S[i] = '(') or (S[i] = '[') or (S[i] = '{') then  br:=br+1 else
   if (S[i] = ')') or (S[i] = ']') or (S[i] = '}') then  br:=br-1;

   if br = 0 then
   begin
    if (S[i-1] <> 'f') and (S[i-2]<> 'i')then
    begin
      insert('if',S,i);
      Delete(S,P+3,N);
      if N=3 then Insert('*if',S,P+3) else
       if N=2 then Insert('+if',S,P+3);
    end
    else
    begin
     Delete(S,P+1,N);
     if N=3 then Insert('*if',S,P+1) else
      if N=2 then Insert('+if',S,P+1);
    end;
    S1:=S;
    goto endp;
   end;

end;

endp:
end;


procedure TForevalH.replaceAndOr(S: String;  var S1: String);
label 1, endp;
var
PA,PO: Integer;
begin

1:
PA:=pos(')and(',S);  PO:=pos(')or(',S);

if (PA <> 0) or (PO <> 0) then
begin

 if (PA <> 0) and (PO <> 0) then
  begin
    if PA < PO then  InsIf(S,PA,3,S)
    else InsIf(S,PO,2,S);
  end
 else
 if (PA <> 0) then
 begin
   InsIf(S,PA,3,S);
 end
 else
 if PO <> 0 then
 begin
   InsIf(S,PO,2,S);
 end;

 goto 1;
end;

S1:=S;
end;






procedure TForevalH.ReplaceAndOrSKIP(S: String;  var S1: String);
{
 boolean     '' IF 
(arg1)and(arg2)         -> if(arg1,if(arg2))
(arg1)and(arg2)and(arg) ->  if(arg1,if(arg2,if(arg3)))
...
(arg1)or(arg2)          -> if(arg1,1,if(arg2))
(arg1)or(arg2)or(arg)   ->  if(arg1,1,if(arg2,1,if(arg3)))
...
}
        procedure _ReplAndOrSKIP(S1,SC: String; var S2: String);
        label endp,nxtlev,rpl,nxtarg;
        var
         i: integer;
         PA,P,P1,C1,C2,C3: integer;
         S,Sins,FS:String;
         br,Cr,indx,LS: integer;
         SLst: array of  String;
         PLst: array of Integer;
        begin
        S:=S1;

        nxtlev:
        LS:=Length(SC);
        FS:=')'+SC+'(';
        P:=pos(FS,S);
        if P = 0 then goto endp;

        SetLength(PLst,0); SetLength(SLst,0);

           br:=0;
           //        ()op1()op1()op2()op2()op1()
           for i := P downto 1 do
           begin
             if (S[i] = '(') or (S[i] = '[') or (S[i] = '{') then  br:=br+1 else
             if (S[i] = ')') or (S[i] = ']') or (S[i] = '}') then  br:=br-1;

             if br = 0 then
             begin
              if (i > 2)  and (S[i-1] ='f') and (S[i-2] = 'i') then
              begin
                 P1:=i-2;
              end
              else
                P1:=i;

              SetLength(PLst,Length(PLst)+1);
              PLst[High(PLst)]:=P1;
              goto nxtarg;

             end;
           end;

        nxtarg:
           //     
           br:=1;  i:=P;
           while i <= Length(S) do
           begin

             if (S[i] = '(') or (S[i] = '[') or (S[i] = '{') then  br:=br+1 else
             if (S[i] = ')') or (S[i] = ']') or (S[i] = '}') then  br:=br-1;

              if br = 0 then
              begin

                if i = Length(S) then
                begin
                   SetLength(PLst,Length(PLst)+1);
                   PLst[High(PLst)]:=i;
                   goto rpl;
                end
                else
                if  (i < Length(S)) and ((S[i+1] = ')') or (S[i+1] = ',') or (S[i+1] = ';')) then
                begin
                   SetLength(PLst,Length(PLst)+1);
                   PLst[High(PLst)]:=i;
                   goto rpl;
                end
                else
                if (i < Length(S)-LS) and (Copy(S,i+1,LS) = SC)  and  (S[i+LS+1] = '(') then      //if next op also SC
                begin
                  SetLength(PLst,Length(PLst)+1);
                  PLst[High(PLst)]:=i;
                  i:=i+LS;
                end
                else
                if S[i] = ')' then
                begin
                   SetLength(PLst,Length(PLst)+1);
                   PLst[High(PLst)]:=i;
                   goto rpl;
                end

              end;

             inc(i);
           end;


        rpl:
        if Length(PLst) > 0 then
        begin

          SetLength(SLst,Length(PLst)-1);

          SLst[0]:=Copy(S,PLst[0],PLst[1]-PLst[0]+1);
          for i := 1 to High(SLst)-1 do
          begin
           SLst[i]:=Copy(S,PLst[i]+LS+1,PLst[i+1]-PLst[i]-LS);
          end;

          C1:=PLst[High(PLst)] ;C2:=PLst[High(PLst)-1];  C3:= PLst[High(PLst)-1]+LS+1;
          SLst[High(SLst)]:=Copy(S,C3,C1-C3+1);

          Cr:=High(SLst);
          Sins:='if('+SLst[High(SLst)]+')';

          if SC = 'and' then
          begin
            for i := 0 to High(SLst)-1 do
            begin
             dec(Cr) ;
             Sins:='if('+SLst[Cr]+','+Sins+')';
            end;
          end
          else
          if SC = 'or' then
            begin
            for i := 0 to High(SLst)-1 do
            begin
             dec(Cr) ;
             Sins:='if('+SLst[Cr]+',1,'+Sins+')';
            end;
          end;



          Delete(S,PLst[0],PLst[High(PLst)]-PLst[0]+1);
          Sins:='('+Sins+')';
          Insert(Sins,S,Plst[0]);
        end;


        goto nxtlev;

        endp:
        S2:=S;
        end;

begin
  _ReplAndOrSKIP(S,'and',S1);  // 'and'  'or'
  _ReplAndOrSKIP(S1,'or',S1);
end;





procedure TForevalH.ReplaceFuncIntPart(S,SF: String; var S1: String);
label 1,2,3,endp;
var
i,p,k,N,P1,br,m,f,L,LS: Integer;
SP,SL: String;
begin

P:=1;
L:=Length(SF);
1:
//SL:=LowerCase(S);
SL:=S;
P1:=posEx(SF,SL,P);
if P1 = 0 then goto endp;
P:=P1;
LS:=Length(S);

2:
k:=0;   F:=0;
 for I := p+L to Length(S) do
   begin
     if S[i] = '(' then
     begin

       SP:=Copy(S,p+L,k);
       //if SP <> '' then

       {.195}
         if TryStrToInt(SP,N) = true then
         begin
            N:=StrToInt(SP);

            br:=0; m:=i;

           repeat

             if S[m] = '(' then br:=br+1
              else
             if S[m] = ')' then br:=br-1;

             if (br = 1) and (S[m] = ',') then begin   P:=P+L; goto 3;   end;

             inc(m);
             if (m > LS) and (br <> 0)  then begin  F:=2; goto 3; end;

           until br = 0;

           Insert(','+SP,S,m-1);
           Delete(S,P+L,K);

           3:
         end
         else
         F:=1;

         {
         try
           N:=StrToInt(SP);


           br:=0; m:=i;

           repeat

             if S[m] = '(' then br:=br+1
              else
             if S[m] = ')' then br:=br-1;

             if (br = 1) and (S[m] = ',') then begin   P:=P+L; goto 3;   end;

             inc(m);
             if (m > LS) and (br <> 0)  then begin  F:=2; goto 3; end;

           until br = 0;

           Insert(','+SP,S,m-1);
           Delete(S,P+L,K);

          3:
         except
           F:=1;
         end;
         }

         if F=2 then goto endp;

         P:=P+L; goto 1;
     end;
     inc(k);
   end;


endp:
S1:=S;
end;



procedure TForevalH.ReplaceIff(S1: String; var S2: String);
label 1;
var
p,cp: integer;
SL: String;
begin
cp:=1;
1:
//SL:=LowerCase(S1);
SL:=S1;
p:=posEx('iff(',SL,cp);
if p <> 0 then
begin
 Delete(S1,p+1,1); cp:=cp+2;
 goto 1;
end;

S2:=S1;
end;


function TForevalH.CheckImUnitAfterBr(S: String; i: Integer): Boolean;
var
 EnOp: set of  Char;
 Si: String;
 Li: Cardinal;
begin
EnOp:=[')','}',']','|','*','/','>','<','+','^','-',',',';'];
  Li:=Length(S_IM_UNIT);

  if Length(S) > i+Li then
  begin
    Si:=S[i+Li+1];//Copy(S,i,Li);
    if S[i+Li+1] in EnOp then  CheckImUnitAfterBr:=True else CheckImUnitAfterBr:=False;
  end
  else
  if Length(S) = i+Li then
  begin
    Si:=Copy(S,i+1,Li);
    if Si =  S_IM_UNIT then CheckImUnitAfterBr:=True else CheckImUnitAfterBr:=False;
  end
  else
  CheckImUnitAfterBr:=False;
end;




procedure TForevalH.PrevTreat(S: String; var S1: String);
 label endp;
 const
  OpSet: set of char = ['*','/','+','-'];
 var
  b1,b2,i,ba,bs,bc,br,LC,p1,p2: Integer;
  E: Exception;

begin
if S = '' then S:='0';
if F_SyntaxExtension = True then
begin
 ReplaceAbsBr(S,S);  if F_SyntaxErrorCode <> 0 then goto endp;
 if F_SkippedIF = True then      {.221}
  ReplaceAndOrSKIP(S,S)    //skipped if
  else
  ReplaceAndOr(S,S);       //complete if
 ReplaceFuncIntPart(S,'root',S);
 ReplaceFuncIntPart(S,'power',S);
 ReplaceFuncIntPart(S,'pow',S); {.191}
 //ReplaceTruncBr(S,S);
 //ReplaceFracBr(S,S);
end;
 //ReplaceIff(S,S);

F_SyntaxErrorCode:=0;
b1:=0; b2:=0; ba:=0;  bs:=0; bc:=0;  br:=0;

for i:=1 to Length(S)-1 do
begin
if (S[i] = ')') and ((S[i+1] <> '*') and  (S[i+1] <> '+') and
   (S[i+1] <> '-') and (S[i+1] <> '/') and (S[i+1] <> '^') and
   (S[i+1] <> '!') and (S[i+1] <> ')') and (S[i+1] <> ',') and
   (S[i+1] <> '_') and (S[i+1] <> '}')  and   (S[i+1] <> '.') and
   (S[i+1] <> ']')  and (S[i+1] <> '=') and (S[i+1] <> '<' ) and (S[i+1] <> '>'))  then
  begin
   if CheckImUnitAfterBr(S,i) = False then
   begin
    F_SyntaxErrorCode:=E_MISSING_OPERATION;      // 
    LC:=7; //
    if i < LC  then  p1:=i else p1:=LC;
    if Length(S)-i < LC then p2:=Length(S)-i else p2:=LC;

    F_SyntaxErrorString:=Copy(S,i-p1+1,p1+p2);
    goto endp;
   end;
  end;

   {.231}
  if (S[i] in OpSet) and (S[i+1] in OpSet) then
  begin
    F_SyntaxErrorCode:=E_MISSING_EXPRESSION;

    LC:=7; //
    if i < LC  then  p1:=i else p1:=LC;
    if Length(S)-i < LC then p2:=Length(S)-i else p2:=LC;
    F_SyntaxErrorString:=Copy(S,i-p1+1,p1+p2);

    goto endp;
  end;

  if S[i] = '(' then inc(br);
  if S[i] = ')' then dec(br);

  if S[i] = '[' then inc(bs);
  if S[i] = ']' then dec(bs);

  if S[i] = '{' then inc(bc);
  if S[i] = '}' then dec(bc);
end;

if S[Length(S)] = ')' then dec(br);
if S[Length(S)] = ']' then dec(bs);
if S[Length(S)] = '}' then dec(bc);

if br <> 0 then
begin
 F_SyntaxErrorCode:=E_MISSING_ROUND_BRACKET;
 F_SyntaxErrorString:=Copy(S,1,Length(S));
 //raise E.Create('');
end
else
if bs <> 0 then
begin
 F_SyntaxErrorCode:=E_MISSING_SQUARE_BRACKET;
 F_SyntaxErrorString:=Copy(S,1,Length(S));
 //raise E.Create('');
end
else
if bc <> 0 then
begin
 F_SyntaxErrorCode:=E_MISSING_CURLY_BRACKET;
 F_SyntaxErrorString:=Copy(S,1,Length(S));
 //raise E.Create('');
end;



S1:=Copy(S,1,Length(S));
endp:
end;







procedure TForevalH.SyntaxAnalizator(S:String; var ND: TDataNode; var LV:PLevel;  var EOFN: Boolean);
label endp;
var
COP: String;
nf: Cardinal;
BH: Boolean;
a,b: TFloat;
Arg: Integer;
begin
if F_SyntaxErrorCode <> 0 then goto endp;
F_CurrentSubExpr:=S; {.195}

TryFPUMask; {.229}

EOFN:=False;
InitNode(ND);

FindConst(S,ND,EOFN);
if EOFN = True then goto endp;



StringAnalizator(S,ND,LV);
Arg:=Length(LV);
if F_SyntaxErrorCode = 0 then                     {.195}
begin
If (ND.COP = 0)  then
 begin
  FindFunction(LV[0].Expression,ND,LV,BH,EOFN);
  if BH = False then
  NumberAnalizator(LV[0].Expression,ND,EOFN);
 end
 else
 if (F_SaveInFPU = True) and (Arg = 2) and (F_OperationOptimizatorA2 = True )then
    OperationalAnalizator2(LV,ND,LV,ND,EOFN)
 else
 if (F_SaveInFPU = True) and (Arg = 1) and (F_OperationOptimizatorA1 = True ) then OperationalAnalizator1(LV,ND,LV,ND,EOFN);
end;


endp:
TryCatchFPUException;    {.229}
end;







procedure TForevalH.OperationalAnalizator1(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
label endp;
var
ni: Integer;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

TryFPUMask; {.229}


LV1:=LV;
ND1:=ND;


EOFN:=False;
//InitNode(ND);
if (ND.NFunc = CM_RE) or (ND.NFunc = CM_IM)  then
begin
FindVar(LV[0].Expression,ni);
 if ni >= 0 then
  begin
   if ND.NFunc = CM_RE then ND1.TS:=_RE;
   if ND.NFunc = CM_IM then ND1.TS:=_IM;

   ND1.COP:=_LDSF;
   ND1.NObj:=ni;
   EOFN:=True;
   ND1.N:=0;
   ND1.NFunc:=0;
   SetLength(LV1,0);
   goto endp;
  end;
end
else
if (ND.NFunc = CM_FACT) then
begin
  FindVar(LV[0].Expression,ni);
  if ni  > 0 then
  begin
   if Alg.Obj[ni].MType = _Integer then
   begin
    ND1.AI:=1;
    ND1.NV1:=ni;
    EOFN:=True;
    ND1.N:=0;
    SetLength(LV1,0);
    goto endp;
   end;
  end;

end;



endp:
TryCatchFPUException;    {.229}
end;





procedure TForevalH.OperationalAnalizator2(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
label endp;
var
C: TFloat;
BH: Boolean;
VC1,VC2: Integer;
S: Integer;
i: Integer;
nv1,nv2,tv1,tv2,tm: Integer;
FD1,FD2: extended;
Str: String;
adr: Cardinal;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

TryFPUMask; {.229}

{.195}
if (ND.NFunc <> CM_POWER) and (ND.NFunc <> CM_ROOT) and
   (ND.NFunc <> CM_ADD)   and (ND.NFunc <> CM_SUB ) and  (ND.NFunc <> CM_MUL) and  (ND.NFunc <> CM_DIV) then goto endp;

if ND.NFunc = CM_POWER then begin PowerAnalizator(LV,ND,LV1,ND1,EOFN);   goto endp; end;
if ND.NFunc = CM_ROOT then begin RootAnalizator(LV,ND,LV1,ND1,EOFN);   goto endp; end;


LV1:=LV;
ND1:=ND;
 //F_IdN   = ND1.F_IdN!!! (StringAnalizator)


NumberAnalizatorA(LV[0].Expression,nv1,FD1,VC1);     //VC = _Const(FD); = _FVar(nf); = _None(Stack);
NumberAnalizatorA(LV[1].Expression,nv2,FD2,VC2);                                //op = +  -  *  /


if (VC1 = _FVar)   and (VC2 = _None)   then ND1.NV1:=nv1                         //S op v
else
if (VC1 = _Const) and (VC2 = _None)   then ND1.FD:=FD1                          //S op c
else
if (VC1 = _None)  and (VC2 = _FVar)    then ND1.nv1:=nv2                         //S op v
else
if (VC1 = _None)  and (VC2 = _Const)  then ND1.FD:=FD2                          //S op c
else
if (VC1 = _FVar)   and (VC2 = _FVar)    then begin ND1.nv1:=nv1; ND1.nv2:=nv2; end//v1 op v2
else
if (VC1 = _FVar)   and (VC2 = _Const)  then begin ND1.nv1:=nv1; ND1.FD:=FD2; end //v op  c
else
if (VC1 = _Const) and (VC2 = _FVar)    then begin ND1.FD:=FD1; ND1.nv1:=nv2; end;//v op c






if (VC1 = _None) and (VC2 = _None) then
begin
 EOFN:=False;
 ND1.N:=2;
 goto endp;
end
else
if (VC1 = _None) and (VC2 <> _None) then
begin
  EOFN:=False;
  ND1.N:=1;
  Str:=Copy(LV[0].Expression,1,Length(LV[0].Expression));
  SetLength(LV1,1);
  LV1[0].Expression:=Copy(Str,1,Length(Str));
  LV1[0].NL:=1;
  //LV1[0].IdL:=F_IdN;
end
else
if (VC1 <> _None) and (VC2 = _None) then
begin
  EOFN:=False;
  ND1.N:=1;
  Str:=Copy(LV[1].Expression,1,Length(LV[1].Expression));
  SetLength(LV1,1);
  LV1[0].Expression:=Copy(Str,1,Length(Str));
  LV1[0].NL:=1;
  //LV1[0].IdL:=F_IdN;
end
else
if (VC1 <> _None) and (VC2 <> _None) then
begin
 EOFN:=True;
 ND1.N:=0;
 SetLength(LV1,0);
end;





if ND1.NFunc = CM_ADD then
begin
 if (VC1 = _Const) and (VC2 = _Const) then
 begin
  ND1.FD:=FD1+FD2;
  ND1.COP:=_LDSC;
  ND1.NFunc:=0;
 end
end
else
if ND1.NFunc = CM_SUB then
begin
 if (VC1 = _Const) and (VC2 = _Const) then
 begin
  ND1.FD:=FD1-FD2;
  ND1.COP:=_LDSC;
  ND1.NFunc:=0;
 end
 else
 if (VC1 = _FVar) and (VC2 = _None)  then   ND1.Inv:=1  //v-S
 else
 if (VC1 = _Const) and (VC2 = _None) then  ND1.Inv:=1   //c-S
 else
 if (VC1 = _Const) and (VC2 = _FVar)  then  ND1.Inv:=1   //c-v
 else
 if (VC1 = _FVar) and (VC2 = _FVar)  then                 //i-i
 begin
   GetVar(nv1,adr,tv1,tm);
   GetVar(nv2,adr,tv2,tm);
   if (tv1 = IM_UNIT) and (tv2 = IM_UNIT) then
   begin
     ND1.FD:=0;
     ND1.COP:=_LDSC;
     ND1.NFunc:=0;
   end;
 end;
end
else
if ND1.NFunc = CM_MUL then
begin
  if (VC1 = _Const) and (VC2 = _Const) then
  begin
   ND1.FD:=FD1*FD2;
   ND1.COP:=_LDSC;
   ND1.NFunc:=0;
  end
  else
 if (VC1 = _FVar) and (VC2 = _FVar)  then                 //i*i
 begin
   GetVar(nv1,adr,tv1,tm);
   GetVar(nv2,adr,tv2,tm);
   if (tv1 = IM_UNIT) and (tv2 = IM_UNIT) then
   begin
     ND1.FD:=-1;
     ND1.COP:=_LDSC;
     ND1.NFunc:=0;
   end;
 end
end
else
if ND1.NFunc = CM_DIV then
begin
  if (VC1 = _Const) and (VC2 = _Const) then
  begin
   ND1.FD:=FD1/FD2;
   ND1.COP:=_LDSC;
   ND1.NFunc:=0;
  end
  else
 if (VC1 = _FVar) and (VC2 = _None)  then   ND1.Inv:=1  //v/S
 else
 if (VC1 = _Const) and (VC2 = _None) then  ND1.Inv:=1   //c/S
 else
 if (VC1 = _Const) and (VC2 = _FVar)  then  ND1.Inv:=1   //c/v
 else
 if (VC1 = _FVar) and (VC2 = _FVar)  then                 //i/i
 begin
   GetVar(nv1,adr,tv1,tm);
   GetVar(nv2,adr,tv2,tm);
   if (tv1 = IM_UNIT) and (tv2 = IM_UNIT) then
   begin
     ND1.FD:=1;
     ND1.COP:=_LDSC;
     ND1.NFunc:=0;
   end;
 end;
end;


endp:
TryCatchFPUException;    {.229}
end;





procedure TForevalH.PowerAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
label endp;
var
C: TFloat;
VC1,VC2: Integer;
S,NA: Integer;
i: Integer;
nv1,nv2,tv1,tv2,tm,Len,mt2: Integer;
FD1,FD2: extended;
Str,Str1,Str2: String;
adr: Cardinal;
BH: Boolean;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

TryFPUMask; {.229}

Len:=Length(LV);
if Len <> 2 then
begin
 F_SyntaxErrorCode:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
 F_SyntaxErrorString:=F_CurrentString;
 goto endp;
end;

LV1:=LV;
ND1:=ND;
EOFN:=False;
BH:=False;
//ND1.COP:=_FUNC;
 //F_IdN   = ND1.F_IdN!!! (StringAnalizator)


//VC = _Const(FD); = _Var(nf); = _None(Stack);
Str2:=LV[1].Expression;
Str1:=LV[0].Expression;
//FindExternalBracket(Str1,Str1);
DeleteExternalBracketP(@Str1); {.219}
//FindExternalBracket(Str2,Str2);
DeleteExternalBracketP(@Str2); {.219}
NumberAnalizatorA(Str2,nv2,FD2,VC2);
NumberAnalizatorA(Str1,nv1,FD1,VC1);
ND1.ExpressionArg:=Str1+','+Str2; {.216}
NA:=2; {.231}

if  (VC2 = _FVar)  then mt2:=Alg.Obj[nv2].MType;


//s1^intvar
if  (VC2 = _FVar) and (mt2 = _Integer) and (VC1 <> _Const) then
begin
         ND1.NFunc:=CM_IPWR;
         ND1.NV1:=nv2;
         ND1.AI:=2;
         EOFN:=False;
         ND1.N:=1;
         ND1.COP:=_FUNC;
         SetLength(LV1,1);
         LV1[0].Expression:=Copy(Str1,1,Length(Str1));
         LV1[0].NL:=1;
         {LV1[0].IdL:=F_IdN;
         BH:=True;}
end
(*else
//s1^intconst
if (VC1 <> _Const) and (VC2 = _Const) and (Trunc(FD2) = FD2) then
begin
         ND1.NFunc:=C_IPWR;
         ND1.FD:=FD2;
         ND1.AI:=1;
         EOFN:=False;
         ND1.N:=1;
         ND1.COP:=_FUNC;
         SetLength(LV1,1);
         LV1[0].Expression:=Copy(Str1,1,Length(Str1));
         LV1[0].NL:=1;
         {LV1[0].IdL:=F_IdN;
         BH:=True; }
end
*)
else

if (VC2 = _Const) or (VC1 = _Const) then
begin

  if (VC2 = _Const) and (VC1 = _Const) then
  begin
     ND1.FD:=power(FD1,FD2);
     ND1.COP:=_LDSC;
     ND1.NFunc:=0;
     BH:=True;
     EOFN:=True;
     LV1:=nil;
     ND1.N:=0;
  end
  else
  begin

    if FD2 = 2  then   begin ND1.NFunc:=CM_SQR;  NA:=0;  BH:=True end   else
    if FD2 = 3  then   begin ND1.NFunc:=CM_PWR3; NA:=0;  BH:=True end   else
    if FD2 = 4  then   begin ND1.NFunc:=CM_PWR4; NA:=0;  BH:=True end   else
    if FD2 = 5  then   begin ND1.NFunc:=CM_PWR5; NA:=0;  BH:=True end   else
    if FD2 = 6  then   begin ND1.NFunc:=CM_PWR6; NA:=0;  BH:=True end   else
    if FD2 = 0.5 then  begin ND1.NFunc:=CM_SQRT; NA:=0;  BH:=True end   else
    if FD2 = -2 then   begin ND1.NFunc:=CM_PWRN2; NA:=0; BH:=True end   else
    if FD2 = -3 then   begin ND1.NFunc:=CM_PWRN3; NA:=0; BH:=True end   else
    if FD2 = -4 then   begin ND1.NFunc:=CM_PWRN4; NA:=0; BH:=True end   else
    if FD2 = -5 then   begin ND1.NFunc:=CM_PWRN5; NA:=0; BH:=True end   else
    if FD2 = -6 then   begin ND1.NFunc:=CM_PWRN6; NA:=0; BH:=True end   else
    if FD2 = -1 then   begin ND1.NFunc:=CM_PWRN1; NA:=0; BH:=True end   else
    if FD1 = -1 then   begin ND1.NFunc:=CM_IPWRSGN; NA:=1; BH:=True end   else
    if FD1 = 2  then   begin ND1.NFunc:=CM_F2PWR; NA:=1; BH:=True end;    {.231}

    if NA = 0 then ND1.ExpressionArg:=Str1     {.231}
    else
    if NA = 1 then   ND1.ExpressionArg:=Str2;  //    (-1)^arg  2^arg     (.231)


    if BH = True then
    begin

       EOFN:=False;
       ND1.N:=1;
       ND1.COP:=_FUNC;
       Str:=Copy(LV[NA].Expression,1,Length(LV[NA].Expression));
       SetLength(LV1,1);
       LV1[0].Expression:=Copy(Str,1,Length(Str));
       LV1[0].NL:=1;
       //LV1[0].IdL:=F_IdN;
       ND1.AI:=0;

       if (ND1.NFunc = CM_IPWRSGN) then
       begin
         if (VC2 = _FVar) and (Alg.Obj[nv2].MType = _Integer) then
         begin
           ND1.NV1:=nv2;
           ND1.N:=0;
           SetLength(LV1,0);
           ND1.AI:=1;
           EOFN:=True;
           goto endp;
         end
         {else
         begin
           LV1:=LV;
           ND1:=ND;
           EOFN:=False;
         end; }
       end;

    end
    else
    //s1^intconst
    if (VC1 <> _Const) and (VC2 = _Const) and (Trunc(FD2) = FD2) then
    begin
         ND1.NFunc:=CM_IPWR;
         ND1.FD:=FD2;
         ND1.AI:=1;
         EOFN:=False;
         ND1.N:=1;
         ND1.COP:=_FUNC;
         SetLength(LV1,1);
         LV1[0].Expression:=Copy(Str1,1,Length(Str1));
         LV1[0].NL:=1;
         ND1.ExpressionArg:=Str1+','+Str2; {.231}
         {LV1[0].IdL:=F_IdN;
         BH:=True; }
    end;
  

  (*
   if (ND1.NFunc = C_POWER)  then
   begin
    if  (VC2 = _FVar)  then
    begin
      if  Alg.Obj[nv2].MType = _Integer then
      begin
         ND1.NFunc:=C_IPWR;
         ND1.NV2:=nv2;
         ND1.AI:=2;
         EOFN:=False;
         ND1.N:=1;
         ND1.COP:=_FUNC;
         SetLength(LV1,1);
         LV1[0].Expression:=Copy(Str1,1,Length(Str1));
         LV1[0].NL:=1;
         LV1[0].IdL:=F_IdN;
         BH:=True;
      end
    end
    else
    if VC2 = _Const then
    begin
      if FD2 = Trunc(FD2) then
      begin
         ND1.NFunc:=C_IPWR;
         ND1.FD:=FD2;
         ND1.AI:=1;
         EOFN:=False;
         ND1.N:=1;
         ND1.COP:=_FUNC;
         SetLength(LV1,1);
         LV1[0].Expression:=Copy(Str1,1,Length(Str1));
         LV1[0].NL:=1;
         LV1[0].IdL:=F_IdN;
         BH:=True;
      end;
    end;
   end;
  *)


  end;
end;




endp:
TryCatchFPUException;    {.229}
end;




function _ROOT(x,y: extended): extended;
var s,d: double;
begin
s:=1;


 if (x = 0) and (y <= 0) then d:=sqrt(-1); {.215}  //call error

if (x < 0) and  (Trunc(y) = y) and (Trunc(y/2) <> y/2) then
  begin
    s:=-1;
    _ROOT:=s*power(abs(x),1/y);

  end
else
_ROOT:=s*power(x,1/y);   {.195}


end;




procedure TForevalH.RootAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
label endp;
var
C: TFloat;
VC1,VC2: Integer;
S,NA: Integer;
i: Integer;
nv1,nv2,tv1,tv2,tm,P,Len: Integer;
FD1,FD2: extended;
Str,Str1,Str2: String;
adr: Cardinal;
BH: Boolean;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

TryFPUMask; {.229}

Len:=Length(LV);
if (Len <> 2) and (Len <> 3) then
begin
 F_SyntaxErrorCode:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
 F_SyntaxErrorString:=F_CurrentString;
 goto endp;
end;

LV1:=LV;
ND1:=ND;
EOFN:=False;
BH:=False;

{.195}
if Len = 3 then goto endp;

//ND1.COP:=_FUNC;
 //F_IdN   = ND1.F_IdN!!! (StringAnalizator)


//VC = _Const(FD); = _Var(nf); = _None(Stack);
Str2:=LV[1].Expression;
Str1:=LV[0].Expression;
//FindExternalBracket(Str1,Str1);
DeleteExternalBracketP(@Str1); {.219}
//FindExternalBracket(Str2,Str2);
DeleteExternalBracketP(@Str2); {.219}
NumberAnalizatorA(Str2,nv2,FD2,VC2);
NumberAnalizatorA(Str1,nv1,FD1,VC1);

if (VC2 = _Const) or (VC1 = _Const) then
begin

  if (VC2 = _Const) and (VC1 = _Const) then
  begin
     ND1.FD:=_ROOT(FD1,FD2);//power(FD1,1/FD2);
     ND1.COP:=_LDSC;
     ND1.NFunc:=0;
     BH:=True;
     EOFN:=True;
     LV1:=nil;
     ND1.N:=0;
  end
  else
  begin

   P:=0;
   if FD2 = 2  then   begin ND1.NFunc:=CM_SQRT;  NA:=0; P:=2; BH:=True end   else
   if FD2 = 4  then   begin ND1.NFunc:=CM_SQRT; NA:=0;  P:=4; BH:=True end{   else
   if FD2 = 8  then   begin ND1.NFunc:=C_SQRT; NA:=0;  P:=8; BH:=True end};


   if BH = True then
   begin
    EOFN:=False;
    ND1.N:=1;
    ND1.COP:=_FUNC;
    Str:=Copy(LV[NA].Expression,1,Length(LV[NA].Expression));
    if P = 4 then
    begin
     Str:='sqrt('+Str+')' ;
     ND1.ExpressionArg:=Str; {.216}
    end
    else
    if P = 8 then Str:='sqrt(sqrt('+Str+'))';

    SetLength(LV1,1);
    LV1[0].Expression:=Copy(Str,1,Length(Str));
    LV1[0].NL:=1;
    //LV1[0].IdL:=F_IdN;
    ND1.AI:=0;
   end;
  end;
end;




endp:
TryCatchFPUException;    {.229}
end;






procedure TForevalH.IFAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode);
label 1,endp;
var
C: TFloat;
br: Integer;
i,P,L: Integer;
nf: Integer;
FD1,FD2: extended;
Str,Str1,Str2: String;
adr: Cardinal;
begin
//IF(Arg1 op Arg2, Arg3, Arg4)  => if Arg1 op Arg2 then Arg3 else Arg4  op: =, <, >, <=, =<, >=, =>
//IF      IFNOP(Arg1,Arg2,CJMP,Arg3,JMP,ARG4)

//IF(Arg1 op Arg2)  = 1  0( if  )  op: =, <, >, <=, =<, >=, =>
//IF      IFNOP(Arg1,Arg2,CJMP,FLD1,JMP,FLDZ)

//IF(Arg1 op Arg2, Arg3)  = Arg3( if  )  0( if  )  op: =, <, >, <=, =<, >=, =>
//IF      IFNOP(Arg1,Arg2,CJMP,ARG3,JMP,FLDZ)


if F_SyntaxErrorCode <> 0 then goto endp;

LV1:=LV;
ND1:=ND;
L:=Length(LV);



if ((L <> 3) and (L <> 1) and (L <> 2)) then
begin
  F_SyntaxErrorCode:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
  F_SyntaxErrorString:=F_CurrentString;
  goto endp;
end;

//nf= 1       2      3       4      5      6     7
//  #JMP, #JMPE, #JMPEL, #JMPEB, #JMPB, #JMPL, #JMPNE

br:=0;  nf:=0;
Str:=LV[0].Expression;
//FindExternalBracket(Str,Str);
DeleteExternalBracketP(@Str); {.219}

for i := 1 to Length(Str) do
begin
 if (Str[i] = '(') or (Str[i] = '[') or (Str[i] = '{') then  br:=br+1 else
 if (Str[i] = ')') or (Str[i] = ']') or (Str[i] = '}') then  br:=br-1;

 if br = 0 then
 begin
   //>= , =>
   if ((Str[i] = '>') and (Str[i+1] = '=')) or ((Str[i] = '=') and (Str[i+1] = '>')) then
   begin
     nf:=6;  Str1:=Copy(Str,1,i-1); Str2:=Copy(Str,i+2,Length(Str)-i);
     goto 1;
   end
   else
   //<=, =<
   if ((Str[i] = '<') and (Str[i+1] = '=')) or ((Str[i] = '=') and (Str[i+1] = '<')) then
   begin
     nf:=5; P:=i;  Str1:=Copy(Str,1,i-1); Str2:=Copy(Str,i+2,Length(Str)-i);
     goto 1;
   end
   else
   //<>
   if ((Str[i] = '<') and (Str[i+1] = '>')) then
   begin
     nf:=2; P:=i;  Str1:=Copy(Str,1,i-1); Str2:=Copy(Str,i+2,Length(Str)-i);
     goto 1;
   end
   else
   // =
   if (Str[i] = '=') then
   begin
     nf:=7;  P:=i;    Str1:=Copy(Str,1,i-1); Str2:=Copy(Str,i+1,Length(Str)-i);
     goto 1;
   end
   else
   // >
   if (Str[i] = '>') then
   begin
     nf:=3; P:=i;    Str1:=Copy(Str,1,i-1); Str2:=Copy(Str,i+1,Length(Str)-i);
     goto 1;
   end
   else
   // <
   if (Str[i] = '<') then
   begin
     nf:=4; P:=i;   Str1:=Copy(Str,1,i-1); Str2:=Copy(Str,i+1,Length(Str)-i);
     goto 1;
   end
 end;
end;


1:
if (nf = 0) and (L = 3) then
begin
  nf:=3; Str1:=Str; Str2:='0';
end
else
if (nf = 0) and (L = 1) then
begin
  nf:=3; Str1:=Str; Str2:='0';
end
else
if (nf = 0) and (L = 2) then            //if(arg1,arg2) ->  if(arg1 > 0,arg2)
begin
  nf:=3; Str1:=Str; Str2:='0';
end
else
if nf = 0 then
begin
  F_SyntaxErrorCode:=5;
  goto endp;
end;


{
   2: LV1[2].Expression:='#JMPE';
   3: LV1[2].Expression:='#JMPEL';
   4: LV1[2].Expression:='#JMPEB';
   5: LV1[2].Expression:='#JMPB';
   6: LV1[2].Expression:='#JMPL';
   7: LV1[2].Expression:='#JMPNE';
}

if L = 2 then
begin
 //P:=Pos('goto(',lowercase(LV[1].Expression));
 P:=Pos('goto(',LV[1].Expression);
  if P > 0 then
 begin
  SetLength(LV1,4);
     //IFNOP(Arg1,Arg2,CJMP,JMP)

  LV1[0].Expression:=Copy(Str1,1,Length(Str1));
  LV1[1].Expression:=Copy(Str2,1,Length(Str2));
  case nf of
   2: LV1[2].Expression:='#jmpe';
   3: LV1[2].Expression:='#jmpel';
   4: LV1[2].Expression:='#jmpeb';
   5: LV1[2].Expression:='#jmpb';
   6: LV1[2].Expression:='#jmpl';
   7: LV1[2].Expression:='#jmpne';
 end;
 LV1[3].Expression:=Copy(LV[1].Expression,1,Length(LV[1].Expression));
 //LV1[3].Expression:='#JMP';
 //LV1[5].Expression:='#FLDZ';


   ND1.N:=4;
   ND1.COP:=_FUNC;
   ND1.NFunc:=CM_IF;
  goto endp;
 end;

end;



SetLength(LV1,6);


if L = 3 then    //IFNOP(Arg1,Arg2,CJMP,Arg3,JMP,ARG4)
begin
 LV1[0].Expression:=Copy(Str1,1,Length(Str1));
 LV1[1].Expression:=Copy(Str2,1,Length(Str2));
 case nf of
   2: LV1[2].Expression:='#jmpe';
   3: LV1[2].Expression:='#jmpel';
   4: LV1[2].Expression:='#jmpeb';
   5: LV1[2].Expression:='#jmpb';
   6: LV1[2].Expression:='#jmpl';
   7: LV1[2].Expression:='#jmpne';
 end;
 LV1[3].Expression:=Copy(LV[1].Expression,1,Length(LV[1].Expression));
 LV1[4].Expression:='#jmp';
 LV1[5].Expression:=Copy(LV[2].Expression,1,Length(LV[2].Expression));
end
else
if L = 1 then      //IFNOP(Arg1,Arg2,CJMP,FLD1,JMP,FLDZ)
begin
 LV1[0].Expression:=Copy(Str1,1,Length(Str1));
 LV1[1].Expression:=Copy(Str2,1,Length(Str2));
 case nf of
   2: LV1[2].Expression:='#jmpe';
   3: LV1[2].Expression:='#jmpel';
   4: LV1[2].Expression:='#jmpeb';
   5: LV1[2].Expression:='#jmpb';
   6: LV1[2].Expression:='#jmpl';
   7: LV1[2].Expression:='#jmpne';
 end;
 LV1[3].Expression:='#fld1';
 LV1[4].Expression:='#jmp';
 LV1[5].Expression:='#fldz';
end
else
if L = 2 then      //IFNOP(Arg1,Arg2,CJMP,ARG3,JMP,FLDZ)
begin
  LV1[0].Expression:=Copy(Str1,1,Length(Str1));
  LV1[1].Expression:=Copy(Str2,1,Length(Str2));
  case nf of
   2: LV1[2].Expression:='#jmpe';
   3: LV1[2].Expression:='#jmpel';
   4: LV1[2].Expression:='#jmpeb';
   5: LV1[2].Expression:='#jmpb';
   6: LV1[2].Expression:='#jmpl';
   7: LV1[2].Expression:='#jmpne';
 end;
 LV1[3].Expression:=Copy(LV[1].Expression,1,Length(LV[1].Expression));
 LV1[4].Expression:='#jmp';
 LV1[5].Expression:='#fldz';
end;


ND1.N:=6;
ND1.COP:=_FUNC;
ND1.NFunc:=CM_IF;

endp:
end;





procedure TForevalH.SAVEAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode);
label 1,endp;
var
C: TFloat;
TF: Integer;
i,P,L,tv1,tm1,LenV: Integer;
nf,ni,SB: Integer;
FD1,FD2: extended;
Str,Str1,Str2,S1,Str3: String;
adr,adr1: Cardinal;
begin



if F_SyntaxErrorCode <> 0 then goto endp;

LenV:=Length(LV);

LV1:=LV;
ND1:=ND;

SetLength(LV1,1);
Str1:=LV[0].Expression;
Str2:=LV[1].Expression;
LV1[0].Expression:=Copy(Str2,1,Length(Str2));

FindReIm(Str1,S1,TF);
FindVar(S1,nf);
if nf <> -1 then  GetVar(nf,adr1,tv1,tm1);

if (nf <> -1) and (tv1 <> IM_UNIT) then
begin
 ND1.NObj:=nf;
 ND1.TS:=TF;
 ND1.N:=1;
 ND1.AI:=1;
end
else
begin
 if tv1 =  IM_UNIT then F_SyntaxErrorCode:=14 else F_SyntaxErrorCode:=1;
 F_SyntaxErrorString:=S1;
 goto endp;
end;

//array: save(array,index,value)
if LenV = 3 then  //save(vd,n+1,x+1)
begin
  {SetLength(LV1,2);
  LV1[0].Expression:=Copy(Str2,1,Length(Str2));
  Str3:=LV[2].Expression;
  LV1[1].Expression:=Copy(Str3,1,Length(Str3));
  LV1[0].NL:=LV[1].NL;   LV1[0].idl:=LV[1].idl;
  LV1[1].NL:=LV[2].NL;   LV1[1].idl:=LV[2].idl;
  ND1.N:=2;
  ND1.AI:=2;}



    //vd[i]=vd[k];x
    //vd[i+1]=vd[k];x

    Str3:=LV[2].Expression;
    if Alg.Obj[nf].TypeF = T_Array then
    begin
      ND1.AI:=2; //vec
      FindVar(Str2,ni);
      ND1.CI:=0;

      if ni <> -1 then    //ni - vector's arg: Vec[var]
      begin
        if (Alg.Obj[ni].TypeF = T_Real) and (Alg.Obj[ni].MType = _Integer) then   //vec[intvar]
        begin
         ND1.NV1:=ni;
         ND1.CI:=1;
         ND1.N:=1;
         SetLength(LV1,1);
         LV1[0].Expression:=Copy(Str3,1,Length(Str3));
        end
        else
        if (Alg.Obj[ni].TypeF = T_Real) then     //vec[realvar]->Vec[expr]
        begin
          SetLength(LV1,2);
          LV1[0].Expression:=Copy(Str2,1,Length(Str2));
          Str3:=LV[2].Expression;
          LV1[1].Expression:=Copy(Str3,1,Length(Str3));
          LV1[0].NL:=LV[1].NL;   LV1[0].idl:=LV[1].idl;
          LV1[1].NL:=LV[2].NL;   LV1[1].idl:=LV[2].idl;
          ND1.N:=2;
          ND1.AI:=2;
          ND1.CI:=0;
        end
        else
        begin    //type of arg <> real
          F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
          F_SyntaxErrorString:=Copy(F_CurrentString,1,Length(F_CurrentString));
          F_SyntaxErrorStringA:=Copy(Str2,1,Length(Str2));

          //F_SyntaxErrorCode:=9;
          //F_SyntaxErrorString:=Copy(Str2,1,Length(Str2));
          //F_SyntaxErrorString1:=Copy(Sa,1,Length(Sa));
          goto endp;
        end;
      end
      else
      begin
        SubstParam(Str2,C,SB);
        if SB = 1 then    //Vec[num]  must be trunc(num)=num!!!
         begin
          if Trunc(C) = C then
          begin
           ND1.FD:=C;
           ND1.CI:=2;
           ND1.N:=1;
           SetLength(LV1,1);
           LV1[0].Expression:=Copy(Str3,1,Length(Str3));
          end
          else
          begin      //vec[num]: 'num' must be integer
            //F_SyntaxErrorCode:=9;
            //F_SyntaxErrorString:=Copy(Str2,1,Length(Str2));
            F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
            F_SyntaxErrorString:=Copy(F_CurrentString,1,Length(F_CurrentString));
            F_SyntaxErrorStringA:=Copy(Str2,1,Length(Str2));
            //F_SyntaxErrorString1:=Copy(Sa,1,Length(Sa));
            goto endp;
          end;
         end
         else
         begin   //Vec[expr]
            SetLength(LV1,2);
            LV1[0].Expression:=Copy(Str2,1,Length(Str2));
            Str3:=LV[2].Expression;
            LV1[1].Expression:=Copy(Str3,1,Length(Str3));
            LV1[0].NL:=LV[1].NL;   LV1[0].idl:=LV[1].idl;
            LV1[1].NL:=LV[2].NL;   LV1[1].idl:=LV[2].idl;
            ND1.N:=2;
            ND1.AI:=2;
            ND1.CI:=0;
         end;
      end

    end
    else   //Vec <> T_Array
    begin
      F_SyntaxErrorCode:=6; //UknownFunction
      F_SyntaxErrorString:=Copy(Str2,1,Length(Str2));
      goto endp;
    end;







end;

{
if ((L <> 3) and (L <> 1) and (L <> 2)) then
begin
  F_SyntaxErrorCode:=4;
  goto endp;
end;
}

//ND1.N:=1;
ND1.COP:=_FUNC;
ND1.NFunc:=CM_SAVE;

endp:
end;






procedure TForevalH.GOTOAnalizator(LV: PLevel; ND: TDataNode; var LV1: PLevel; var ND1: TDataNode);
label endp;
var
ni,VT,nf,L: Integer;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

L:=Length(LV);
if L <> 1 then
begin
 F_SyntaxErrorCode:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
 F_SyntaxErrorString:=F_CurrentString;
 goto endp;
end;

 LV1:=LV;
 ND1:=ND;
 L:=0;
 F_GotoPresent:=True;

 {
 try
   L:=StrToInt(LV[0].Expression);
   ND1.N:=0;
   ND1.AI:=8;
   ND1.CI:=L;
 except
   //F_ErrorCode:=E_INCORRECT_ARGUMENT;
   F_SyntaxErrorCode:=1;
   F_SyntaxErrorString:=F_CurrentString;
   //F_SyntaxErrorString:=Copy(LV[0].Expression,1,Length(LV[0].Expression));
 end;
 }

 {.195}
 if TryStrToInt(LV[0].Expression,L) = true then
 begin
   //L:=StrToInt(LV[0].Expression);
   ND1.N:=0;
   ND1.AI:=8;
   ND1.CI:=L;
 end
 else
 begin
   F_SyntaxErrorCode:=1;
   F_SyntaxErrorString:=F_CurrentString;
 end;


 if L < 0 then
 begin
   //F_ErrorCode:=E_INCORRECT_ARGUMENT;
   F_SyntaxErrorCode:=1;
   F_SyntaxErrorString:=F_CurrentString;
   //F_SyntaxErrorString:=Copy(LV[0].Expression,1,Length(LV[0].Expression));
 end;
 {
 ND1.N:=1;
 ND1.COP:=_JMP;
 }

 ND1.COP:=_FUNC;
 ND1.NFunc:=CM_JMP;

endp:
end;






procedure TForevalH.IDAMAnalizator(LV: PLevel; ND: TDataNode; var LV1: PLevel; var ND1: TDataNode);
label endp;
var
ni,VT,nf,L: Integer;                     //inc,dec,add,mul
begin
if F_SyntaxErrorCode <> 0 then goto endp;

 LV1:=LV;
 ND1:=ND;

L:=Length(LV);
if L <> 1 then
begin
 F_SyntaxErrorCode:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
 F_SyntaxErrorString:=F_CurrentString;
 goto endp;
end;

 FindVar(LV[0].Expression,ni);
  if ni  >= 0 then
  begin
   if Alg.Obj[ni].MType = _Integer then
   begin
    ND1.NV1:=ni;
    ND1.N:=0;
   end
   else
   begin
      //F_ErrorCode:=E_INCORRECT_ARGUMENT;
    F_SyntaxErrorCode:=14;
    F_SyntaxErrorString:=F_CurrentString;//Copy(LV[0].Expression,1,Length(LV[0].Expression));
   end;
  end
  else
  begin
     //F_ErrorCode:=E_INCORRECT_ARGUMENT;
   F_SyntaxErrorCode:=1;
   F_SyntaxErrorString:=F_CurrentString;//Copy(LV[0].Expression,1,Length(LV[0].Expression));
  end;




 ND1.COP:=_FUNC;
 //ND1.NFunc:=C_INC;
 endp:
end;







procedure TForevalH.SetLenAnalizator(LV: PLevel; ND: TDataNode; var LV1: PLevel; var ND1: TDataNode);
label endp;
var
ni,VT,nf,nm,L,nt: Integer;
adrV: Cardinal;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

L:=Length(LV);
if L <> 2 then
begin
  F_SyntaxErrorCode:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
   F_SyntaxErrorString:=F_CurrentString;
  goto endp;
end;

 //LV1:=LV;
ND1:=ND;



VT:=0;

 FindVar(LV[0].Expression,nm);

 if nm >= 0 then
 begin
  if (Alg.Obj[nm].TypeF = T_Array)  then
  begin
   VT:=Alg.Obj[nm].MType
  end;
 end;


 if VT  = 0  then
 begin
   F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
   F_SyntaxErrorString:=F_CurrentString;
   F_SyntaxErrorStringA:=Copy(LV[0].Expression,1,Length(LV[0].Expression));
   goto endp;
 end;



 adrV:=Alg.Obj[nm].Addr;



 SetLength(LV1,3);

 LV1[0].Expression:=IntToStr(adrV);
 LV1[1].Expression:=IntToStr(VT);
 LV1[2].Expression:=Copy(LV[1].Expression,1,Length(LV[1].Expression));


  ND1.N:=3;
  ND1.COP:=_FUNC;
  ND1.NFunc:=CM_SETLEN;

 endp:
end;






procedure TForevalH.SWAPAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode);
label endp;
var
C: TFloat;
VC1,VC2: Integer;
S,NA: Integer;
i: Integer;
nv1,nv2,tv1,tv2,tm1,tm2,nf1,nf2,tf1,tf2: Integer;
FD1,FD2: extended;
Str,Str1,Str2,S1,S2: String;
adr1,adr2: Cardinal;
BH: Boolean;
begin
if F_SyntaxErrorCode <> 0 then goto endp;


if Length(LV) <> 2 then
begin
 F_SyntaxErrorCode:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
 F_SyntaxErrorString:=F_CurrentString;
 goto endp;
 //F_SyntaxErrorString:=Copy(Sf,1,Length(Sf));
end;


LV1:=nil;
ND1:=ND;
ND1.N:=0;


//VC = _Const(FD); = _Var(nf); = _None(Stack);
Str2:=LV[1].Expression;
Str1:=LV[0].Expression;
//FindExternalBracket(Str1,Str1);
DeleteExternalBracketP(@Str1); {.219}
//FindExternalBracket(Str2,Str2);
DeleteExternalBracketP(@Str2); {.219}


FindReIm(Str1,S1,TF1);
FindVar(S1,nf1);
FindReIm(Str2,S2,TF2);
FindVar(S2,nf2);

if (nf1 = -1) or (nf2 = -1) then
begin
  F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
  F_SyntaxErrorString:=F_CurrentString;
  if nf1 = -1  then    F_SyntaxErrorStringA:=Copy(S1,1,Length(S1))
               else    F_SyntaxErrorStringA:=Copy(S2,1,Length(S2));

  goto endp;
end;

GetVar(nf1,adr1,tv1,tm1);
GetVar(nf2,adr2,tv2,tm2);

if (tv1 = T_Real) and (tv2 = T_Real) and (tm1 <> _Integer) and (tm2 <> _Integer) then
begin
  ND1.NV1:=nf1;
  ND1.NV2:=nf2;
  ND1.AI:=1;
end
else
if (tv1 = T_Real) and (tv2 = T_Real) and (tm1 = _Integer) and (tm2 = _Integer) then
begin
  ND1.NV1:=nf1;
  ND1.NV2:=nf2;
  ND1.AI:=2;
end
else
if (tv1 = T_Complex) and (tv2 = T_Complex) and (tf2 = 0) and (tf1 = 0) then
begin
  ND1.NV1:=nf1;
  ND1.NV2:=nf2;
  ND1.TS1:=TF1;
  ND1.TS1:=TF2;
  ND1.AI:=3;
end
else
if (tv1 = T_Real) and (tv2 = T_Complex) and (tf2 <> 0)  then
begin
  ND1.NV1:=nf1;
  ND1.NV2:=nf2;
  ND1.TS1:=TF1;
  ND1.TS2:=TF2;
  ND1.AI:=4;
end
else
if (tv1 = T_Complex) and (tf1 <> 0) and (tv2 = T_Real)   then
begin
  ND1.NV1:=nf1;
  ND1.NV2:=nf2;
  ND1.TS1:=TF1;
  ND1.TS2:=TF2;
  ND1.AI:=5;
end
else
if (tv1 = T_Complex) and  (tv2 = T_Complex) and (tf2 <> 0) and (tf1 <> 0)    then
begin
  ND1.NV1:=nf1;
  ND1.NV2:=nf2;
  ND1.TS1:=TF1;
  ND1.TS2:=TF2;
  ND1.AI:=6;
end
else
begin
   F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
   F_SyntaxErrorString:=F_CurrentString;
   F_SyntaxErrorStringA:=Copy(S1,1,Length(S1))+'  or  '+Copy(S2,1,Length(S2));
end;



endp:
end;





procedure TForevalH.MODAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
label endp;
var
C: TFloat;
VC1,VC2: Integer;
S,NA: Integer;
i: Integer;
nv1,nv2,tv1,tv2,tm1,tm2,Len: Integer;
FD1,FD2: extended;
Str,Str1,Str2: String;
adr: Cardinal;
BH: Boolean;
Adr1,Adr2: TAddress;
begin
if F_SyntaxErrorCode <> 0 then goto endp;


//  : +  -.  mod@ !!!

LV1:=LV;
ND1:=ND;
EOFN:=False;
BH:=False;


Len:=Length(LV);
if Len <> 2 then
begin
 F_SyntaxErrorCode:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
 F_SyntaxErrorString:=F_CurrentString;
 goto endp;
end;

Str2:=LV[1].Expression;
Str1:=LV[0].Expression;
//FindExternalBracket(Str1,Str1);
DeleteExternalBracketP(@Str1); {.219}
//FindExternalBracket(Str2,Str2);
DeleteExternalBracketP(@Str2); {.219}
NumberAnalizatorA(Str2,nv2,FD2,VC2);
FindVarA(Str1,nv1,Adr1,tv1,tm1);
FindVarA(Str2,nv2,Adr2,tv2,tm2);


                                                    {.231}
if (F_OperationOptimizatorA2 = False) or (F_SaveInFPU = False) then
begin
    ND1.AI:=0;
    ND1.N:=2;
    ND1.COP:=_COP;   //_COP ?? _FUNC
    ND1.NFunc:=CM_MOD;
    EOFN:=False;
    goto endp;
end
else
//mod(intvar1,intvar2)
if (tv1 = T_Real) and (tv2 = T_Real) and (tm1 = _Integer) and (tm2 = _Integer) then
begin
  ND1.NV1:=nv1;
  ND1.NV2:=nv2;
  ND1.N:=0;
  ND1.AI:=5;
  ND1.COP:=_COP;   //_COP ?? _FUNC
  ND1.NFunc:=CM_MOD;
  EOFN:=True;
end
else
if (VC2 = _Const) and (FD2 = 2) then
begin
   //mod(intvar,2)
   if (tv1 = T_Real)  and (tm1 = _Integer)  then
   begin
     ND1.NV1:=nv1;
     ND1.AI:=1;
     ND1.N:=0;
     ND1.COP:=_COP;   //_COP ?? _FUNC
     ND1.NFunc:=CM_MOD;
     EOFN:=True;
   end
   else
   //mod(S1,2)
   begin
     ND1.AI:=3;
     ND1.N:=1;
     ND1.COP:=_COP;   //_COP ?? _FUNC
     ND1.NFunc:=CM_MOD;
     SetLength(LV1,1);
     LV1[0].Expression:=Copy(Str1,1,Length(Str1));
     LV1[0].NL:=1;
     EOFN:=False;
   end;
end
else
if (VC2 = _Const)  then
begin

  if (Trunc(FD2) <> FD2) {and (abs(FD2) > 2^31) }then
  begin
   F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
   F_SyntaxErrorString:=F_CurrentString;
   F_SyntaxErrorStringA:=Copy(Str2,1,Length(Str2));
   goto endp;
  end

  else
  begin
    //mod(intvar,intconst)
    if (tv1 = T_Real)  and (tm1 = _Integer)  then
    begin
      ND1.NV1:=nv1;
      ND1.FD:=FD2;
      ND1.AI:=2;
      ND1.N:=0;
      ND1.COP:=_COP;   //_COP ?? _FUNC
      ND1.NFunc:=CM_MOD;
      EOFN:=True;
    end
    else
    //mod(S1,intconst)
    begin
      ND1.AI:=4;
      ND1.N:=1;
      ND1.FD:=FD2;
      ND1.COP:=_COP;   //_COP ?? _FUNC
      ND1.NFunc:=CM_MOD;
      SetLength(LV1,1);
      LV1[0].Expression:=Copy(Str1,1,Length(Str1));
      LV1[0].NL:=1;
      EOFN:=False;
    end;
  end;

end
else
//mod(S1,S2)
begin
    ND1.AI:=0;
    ND1.N:=2;
    ND1.COP:=_COP;   //_COP ?? _FUNC
    ND1.NFunc:=CM_MOD;
    EOFN:=False;
end;



endp:
end;





procedure TForevalH.DataFuncAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
label endp;
var
C: TFloat;
VC1,VC2: Integer;
S,NA: Integer;
i: Integer;
nv1,nv2,tv1,tv2,tm1,tm2,Len: Integer;
FD1,FD2: extended;
Str,Str1,Str2: String;
adr: Cardinal;
BH: Boolean;
Adr1,Adr2: TAddress;
begin
if F_SyntaxErrorCode <> 0 then goto endp;


LV1:=LV;
ND1:=ND;
EOFN:=False;


Len:=Length(LV);
if (Len = 2) or (Len = 3) then
begin
   if ND.NFunc = CM_MAX  then ND1.NFunc := CM_MAX23 else
   if ND.NFunc = CM_MIN  then ND1.NFunc := CM_MIN23 else
   if ND.NFunc = CM_AVR  then ND1.NFunc := CM_AVR23 else
   if ND.NFunc = CM_NORM then ND1.NFunc := CM_NORM23;
end;


endp:
end;




procedure TForevalH.POLYAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
label endp;
var
C: TFloat;
VC1,VC2: Integer;                              //poly(array,arg)->poly(arg) ; array: ND1.NV1=nv1
S,NA: Integer;
i,nf,ni,tv: Integer;
nv1,nv2,tv1,tv2,tm1,tm2,Len: Integer;
FD1,FD2,f1,f2: extended;
Str,Str1,Str2: String;
adr: Cardinal;
BH: Boolean;
Adr1,Adr2: TAddress;
begin
if F_SyntaxErrorCode <> 0 then goto endp;


LV1:=LV;
ND1:=ND;
EOFN:=False;


Len:=Length(LV);
{
if Len <> 2 then
begin
 F_SyntaxErrorCode:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
 F_SyntaxErrorString:=F_CurrentString;
 goto endp;
end;
}



{.207}

if Len = 2  then
begin

   SaveSW; {.229} {TryStrToFloat damage SW}

   Str2:=LV[1].Expression;
   Str1:=LV[0].Expression;

   FindVarA(Str1,nv1,Adr1,tv1,tm1);
   FindVarA(Str2,nv2,Adr2,tv2,tm2);

   if tv1 = T_Array then
   begin
      ND1.N:=1;
      ND1.COP:=_Func;
      ND1.NFunc:=CM_POLY;
      ND1.NV1:=nv1;
      ND1.AI:=T_Array;
      SetLength(LV1,1);
      LV1[0].Expression:=Copy(Str2,1,Length(Str2));
      LV1[0].NL:=1;
      EOFN:=False;
      goto endp;
   end
   else
   if tv2 = T_Array then
   begin
      ND1.N:=1;
      ND1.COP:=_Func;
      ND1.NFunc:=CM_POLY;
      ND1.NV1:=nv2;
      ND1.AI:=T_Array;
      SetLength(LV1,1);
      LV1[0].Expression:=Copy(Str1,1,Length(Str1));
      LV1[0].NL:=1;
      EOFN:=False;
      goto endp;
   end
   else
   //poly
   if TryStrToFloat(LV[0].Expression,f1,G_FMT) = true      //poly(1.123,x)  poly(1.123,x/y)  poly(x,1.123) poly(x/y,1.123)
   then
   begin{
      SetLength(LV1,0);
      ND1.EI:=2;
      ND1.N:=0;
      SetLength(ND1.VFP,1);
      ND1.VFP[0]:=f1;
      EOFN:=True;
      goto endp;
      }
      ND1.TC:=C_Real;
      ND1.FDC.re:=f1;
      ND1.FDC.im:=0;
      ND1.FD:=f1;
      ND1.COP:=_LDSC;
      ND1.N:=0;
      SetLength(LV1,0);
      EOFN:=True;
      goto endp;
   end
   else //SubstParam
   if TryStrToFloat(LV[1].Expression,f1,G_FMT) = true
   then
   begin
      {
      SetLength(LV1,0);
      EOFN:=True;
      ND1.EI:=2;
      ND1.N:=0;
      SetLength(ND1.VFP,1);
      ND1.VFP[0]:=f1;
      goto endp;
      }
      ND1.TC:=C_Real;
      ND1.FDC.re:=f1;
      ND1.FDC.im:=0;
      ND1.FD:=f1;
      ND1.COP:=_LDSC;
      ND1.N:=0;
      SetLength(LV1,0);
      EOFN:=True;
      goto endp;
   end
   else
   begin
     F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
     F_SyntaxErrorString:=F_CurrentString;
     SetLength(LV1,0);
     SetLength(ND1.VFP,0);
     goto endp;
   end;

end
else
if Len > 2 then
begin
  //poly(3,5,7,9,11,15,17,19,x)-(3*x^7+5*x^6+7*x^5+9*x^4+11*x^3+15*x^2+17*x+19)
   SaveSW; {.229} {TryStrToFloat damage SW}

   if TryStrToFloat(LV[0].Expression,f1,G_FMT) = true then      //SubstParam
   begin
       SetLength(ND1.VFP,Length(LV)-1);
       for i := 0 to Length(LV)-2 do
       begin
          if TryStrToFloat(LV[i].Expression,f1,G_FMT) = true then     //SubstParam
          begin
            ND1.VFP[i]:=f1;
          end
          else
          begin
            F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
            F_SyntaxErrorString:=F_CurrentString;
            SetLength(LV1,0);
            SetLength(ND1.VFP,0);
            goto endp;
          end;
       end;

       ND1.NFunc:=CM_POLY;
       SetLength(LV1,1);
       LV1[0].Expression:=Copy(LV[High(LV)].Expression,1,Length(LV[High(LV)].Expression));
       EOFN:=False;
       ND1.N:=1;
       ND1.AI:=T_Real;
       goto endp;
   end
   else    //poly(x,3,5,7,9,11,15,17,19)
   if TryStrToFloat(LV[High(LV)].Expression,f1,G_FMT) = true then     //SubstParam
   begin

       SetLength(ND1.VFP,Length(LV)-1);
       for i := 0 to Length(LV)-2 do
       begin
          if TryStrToFloat(LV[i+1].Expression,f1,G_FMT) = true then      //SubstParam
          begin
            ND1.VFP[i]:=f1;
          end
          else
          begin
            F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
            F_SyntaxErrorString:=F_CurrentString;
            SetLength(LV1,0);
            SetLength(ND1.VFP,0);
            goto endp;
          end;
       end;

       ND1.NFunc:=CM_POLY;
       SetLength(LV1,1);
       LV1[0].Expression:=Copy(LV[0].Expression,1,Length(LV[0].Expression));
       ND1.N:=1;
       EOFN:=False;
       ND1.AI:=T_Real;
       goto endp;

   end
   else
   begin
      F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
      F_SyntaxErrorString:=F_CurrentString;
      SetLength(LV1,0);
      SetLength(ND1.VFP,0);
      goto endp;
   end
end

else
begin
   F_SyntaxErrorCode:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
   F_SyntaxErrorString:=F_CurrentString;
   SetLength(LV1,0);
   SetLength(ND1.VFP,0);

   {F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
   F_SyntaxErrorString:=F_CurrentString; }
   F_SyntaxErrorStringA:=Copy(Str1,1,Length(Str1));
end;


endp:
end;





procedure TForevalH.RANDAnalizator(LV:PLevel; ND: TDataNode; var LV1:PLevel; var ND1: TDataNode; var EOFN: Boolean);
label endp;
var
C: TFloat;                    {.203}
VC1,VC2: Integer;            //random,rand,rnd (),(int),(float1,float2) -> random01mt, intrandommt(int), randommt(float1,float2)
S,NA: Integer;
i,nf,ni,tv: Integer;
nv1,nv2,tv1,tv2,tm1,tm2,Len: Integer;
FD1,FD2: extended;
Str,Str1,Str2: String;
adr: Cardinal;
BH: Boolean;
Adr1,Adr2: TAddress;
begin
if F_SyntaxErrorCode <> 0 then goto endp;


LV1:=LV;
ND1:=ND;
EOFN:=False;


Len:=Length(LV);
if Len = 0  then
begin
   ND1.N:=0;
   ND1.COP:=_Func;
   FindFuncA('random01mt',NF);
   ND1.NFunc:=NF;
   EOFN:=True;
end
else
if Len = 1  then
begin
   ND1.N:=1;
   ND1.COP:=_Func;
   FindFuncA('intrandommt',NF);
   ND1.NFunc:=NF;
   EOFN:=False;
end
else
if Len = 2  then
begin
   ND1.N:=2;
   ND1.COP:=_Func;
   FindFuncA('randommt',NF);
   ND1.NFunc:=NF;
   EOFN:=False;
end
else
begin
 F_SyntaxErrorCode:=E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS;
 F_SyntaxErrorString:=F_CurrentString;
 goto endp;
end;

{
Str2:=LV[1].Expression;
Str1:=LV[0].Expression;



FindVarA(Str1,nv1,Adr1,tv1,tm1);
if tv1 = T_Array then
begin
   ND1.N:=1;
   ND1.COP:=_Func;
   ND1.NFunc:=CM_POLY;
   ND1.NV1:=nv1;
   SetLength(LV1,1);
   LV1[0].Expression:=Copy(Str2,1,Length(Str2));
   LV1[0].NL:=1;
   EOFN:=False;
end
else
begin
   F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
   F_SyntaxErrorString:=F_CurrentString;
   F_SyntaxErrorStringA:=Copy(Str1,1,Length(Str1));
end;
}

endp:
end;




procedure TForevalH.GetVar(N: Integer; var Adr: Cardinal; var TV: Integer; var TM: Integer);
var
S3: String;
begin
 {if (Alg.Obj[N].TypeF = T_Real) and (Alg.Obj[N].MType = _Double) then TV:=D_Real else
 if (Alg.Obj[N].TypeF = T_Real) and (Alg.Obj[N].MType = _Extended) then TV:=E_Real else
 if (Alg.Obj[N].TypeF = T_Complex) and (Alg.Obj[N].MType = _Double) then TV:=D_Complex else
 if (Alg.Obj[N].TypeF = T_Complex) and (Alg.Obj[N].MType = _Extended) then TV:=E_Complex;}

TV:=0; TM:=0; Adr:=0;
if N >=0 then
begin
 TV:=Alg.Obj[N].TypeF;      //   (T_Real, T_Complex, T_Array,  IM_UNIT)
 TM:=Alg.Obj[N].MType;     //_Double,_Extended,_Integer

 //if  LowerCase(Alg.Obj[N].Name) = S_IM_UNIT then TV:=IM_UNIT;
 S3:=Alg.Obj[N].Name;
 if (S3 = S_IM_UNIT) and (TV = T_Complex) then TV:=IM_UNIT;

 Adr:=Alg.Obj[N].Addr;
end;

end;



procedure TForevalH.GetSizeInterp;
label endp;
var
E: Exception;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

LInterp:=1;

Tree:=BeginTree; // , ..   - 

while Tree^.Ch <> nil do
begin
  Tree:=Tree^.Ch;
end;
//COP=NOP:
inc(LInterp);

while Tree^.Pr <> nil do
begin

 while Tree^.Nb <> nil  do
 begin
   Tree:=Tree^.Nb;
   while Tree^.Ch <> nil do
   begin
    Tree:=Tree^.Ch;
   end;

   //COP=NOP:
   inc(LInterp);
 end;
  //COP<>NOP:
  Tree:=Tree^.Pr;
  inc(LInterp);
end;

endp:

end;


 (*
procedure TForevalH.CodeGeneration;
label endp;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

LFunc:=1;
//SetLength(Interp,LFunc);    {.197}
SetLength(Interp,LInterp);

Tree:=BeginTree; // , ..   - 

while Tree^.Ch <> nil do
begin
  Tree:=Tree^.Ch;
end;
//COP=NOP:

WriteCode;


while Tree^.Pr <> nil do
begin

 while Tree^.Nb <> nil  do
 begin
   Tree:=Tree^.Nb;
   while Tree^.Ch <> nil do
   begin
    Tree:=Tree^.Ch;
   end;

   //COP=NOP:
   WriteCode;
 end;
  //COP<>NOP:
  Tree:=Tree^.Pr;
  WriteCode;
end;
//1-   WriteCode 

endp:

if F_SyntaxErrorCode <> 0 then
 begin
  //CalcException;
 end
end;
*)


procedure TForevalH.CodeGeneration;
label endp;
var
Prnt: PNode;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

LFunc:=1;
//SetLength(Interp,LFunc);    {.197}
SetLength(Interp,LInterp);

Tree:=BeginTree; // , ..   - 

while Tree^.Ch <> nil do
begin
  Tree:=Tree^.Ch;
end;
//COP=NOP:

WriteCode;


while Tree^.Pr <> nil do
begin

 while Tree^.Nb <> nil  do
 begin
   Tree:=Tree^.Nb;
   while Tree^.Ch <> nil do
   begin
    Tree:=Tree^.Ch;
   end;

   //COP=NOP:
   WriteCode;
 end;
  //COP<>NOP:
  Tree:=Tree^.Pr;

  Prnt:=Tree;
  WriteCode;
  FreeChld(Prnt);
end;
//1-   WriteCode 

endp:

if F_SyntaxErrorCode <> 0 then
 begin
  //CalcException;
 end
end;


         //sin(x)^cos(x)
procedure TForevalH.FreeChld(PrntNode: PNode);
label endp;
var
H: PNode;
Tree: PNode;
begin
//if F_SyntaxErrorCode <> 0 then goto endp;
if PrntNode = nil  then goto endp;

Tree:=PrntNode^.Ch;

repeat
   H:=Tree;
   Tree:=Tree^.Nb;
   H^.RData:=nil;
   H^.Expression:='';
   H^.ExpressionArg:='';
   H^.Ch:=nil;
   dispose(H);
until Tree = nil ;


PrntNode^.Ch:=nil;

endp:
end;



procedure TForevalH.WriteCode;
label endp;
var
i: Cardinal;
begin
//SetLength(Interp,LFunc+1);    {.197}
WriteDataCode;


endp:
{---------}
//out:
{$IFDEF DEBUGS}
(*
if TestZ.Form1.CB_Cod.Checked = True then
begin
if Tree^.COP = _LDSC then
begin
 TestZ.Form1.M2.Lines[LFunc-1]:='LDSC:  '+String(StrUpper(PChar(FloatToStr(Tree^.FD))));
end
else
if Tree^.COP = _LDSF then
begin
 TestZ.Form1.M2.Lines[LFunc-1]:='LDSF:  '+String(StrUpper(PChar(Alg.Obj[Tree^.NObj].Name)));
end
else
if (Tree^.COP = _Func) or (Tree^.COP = _COP) then
begin
 TestZ.Form1.M2.Lines[LFunc-1]:=String(StrUpper(PChar(Alg.ExFunc[Tree^.NFunc].Name)));
end;




end;
*)
{$ENDIF}
{---------}
inc(LFunc);

end;



procedure TForevalH.WriteDataCode;
label endp;
var
fa,i,L,j,N,N1: Cardinal;
S: String;
nf,TypeF,TypeA,NF1: Integer;
ANL: TArrayC;
begin
if F_SyntaxErrorCode <> 0 then goto endp;
//goto endp;

S:=Tree^.Expression;
Interp[LFunc].Expression:=Tree^.Expression;   //for syntax error

if Tree^.COP = _LDSC then
begin
 Interp[LFunc].FD:=Tree^.FD;
 Interp[LFunc].COP:=_LDSC;
 Interp[LFunc].TypeF:=T_Real;
end
else
if Tree^.COP = _LDSCX then
begin
 Interp[LFunc].FDC.re:=Tree^.FDC.re;
 Interp[LFunc].FDC.im:=Tree^.FDC.im;
 Interp[LFunc].COP:=_LDSCX;
 if Tree^.TC = C_Real then Interp[LFunc].TypeF:=T_Real else Interp[LFunc].TypeF:=T_Complex;
 Interp[LFunc].TC:=Tree^.TC;
end
else
if Tree^.COP = _LDSF then
begin
 Interp[LFunc].NObj:=Tree^.NObj;
 if Tree^.TS <> 0 then  Interp[LFunc].TypeF:=T_Real
 else Interp[LFunc].TypeF:=Alg.Obj[Tree^.NObj].TypeF;
 Interp[LFunc].COP:=_LDSF;
 Interp[LFunc].TS:=Tree^.TS;
end
else
{if Tree^.COP = _JMP then
begin
 Interp[LFunc].TypeF:=T_None;
 Interp[LFunc].COP:=_JMP;
 Interp[LFunc].AI:=Tree^.AI;
end
else
}
if Tree^.COP = _FLD then
begin
 Interp[LFunc].TypeF:=T_Real;
 Interp[LFunc].COP:=_FLD;
 Interp[LFunc].AI:=Tree^.AI;
end
else
if (Tree^.COP = _FUNC) or (Tree^.COP = _COP) then
begin
  N:=Tree^.Stack.N;
 //   :
 if (F_SaveInFPU = True) and (Tree^.COP = _COP) then
 begin
   if (N = 0) or (N = 1) then        //      (N -  )
   begin
     FindCallFunctionA(TypeF,nf,TypeA);
     Interp[LFunc].TypeF:=TypeF;
     Interp[LFunc].TypeA:=TypeA;
     Interp[LFunc].FD:=Tree^.FD;
   end
   else
   begin      //S1 op S2
     FindCallFunction(nf);
     if nf >=0 then    {.197}
     begin
       Interp[LFunc].TypeF:=Alg.ExFunc[Tree^.NFunc].Func[nf].TypeF;
       Interp[LFunc].TypeA:=0;
     end;
   end;

 end
 else
 if (F_SaveInFPU = False) and (Tree^.COP = _COP)   then
 begin
   FindCallFunction(nf);
   Interp[LFunc].TypeF:=Alg.ExFunc[Tree^.NFunc].Func[nf].TypeF;
   Interp[LFunc].TypeA:=0;
 end
 else
 if (Tree^.COP = _FUNC) and (N >= 1)   then
 begin
   FindCallFunction(nf);
   if nf >=0 then    {.197}
   begin
     Interp[LFunc].TypeF:=Alg.ExFunc[Tree^.NFunc].Func[nf].TypeF;
     Interp[LFunc].TypeA:=0;
   end;

   // 'nop'   =   
   //if Alg.ExFunc[Tree^.NFunc].Name = 'nop'     then Interp[LFunc].TypeF:=Interp[LFunc].ArgTypes[high(Interp[LFunc].ArgTypes)];
     if Tree^.NFunc = CM_NOP     then Interp[LFunc].TypeF:=Interp[LFunc].ArgTypes[high(Interp[LFunc].ArgTypes)];    {.197}
 end
 else
 if (Tree^.COP = _FUNC) and (N = 0)   then // - (nf)    : func(v) (v- /)
 begin                                     // -    _STACK_INFINITE
   nf:=Tree^.NF;
   {FindCallFunction(nf);
   if nf = -1 then nf:=Tree^.NF;}

   Interp[LFunc].TypeF:=Alg.ExFunc[Tree^.NFunc].Func[nf].TypeF;

   // 'nop'      = T_None
   //if Alg.ExFunc[Tree^.NFunc].Name = 'nop' then Interp[LFunc].TypeF:=T_None;
   if Tree^.NFunc = CM_NOP then Interp[LFunc].TypeF:=T_None;    {.197}
 end;



 if nf = -1 then
 begin {Error:  -}
  // 
  if Tree^.COP = _COP then
  begin
   F_SyntaxErrorCode:=E_NOT_DEFINED_OPERATION_FOR_TYPE;
   F_SyntaxErrorStringA:=Alg.Opr[Tree^.NCOP].Name;

     //  MOD:
     if Tree^.NFunc = CM_MOD then
     begin
       F_SyntaxErrorCode:=E_NOT_DEFINED_FUNCTION_FOR_TYPE;
       F_SyntaxErrorStringA:=Alg.ExFunc[Tree^.NFunc].Name;
     end;
  end
  else
  // -
  begin
   F_SyntaxErrorCode:=E_NOT_DEFINED_FUNCTION_FOR_TYPE;
   F_SyntaxErrorStringA:=Alg.ExFunc[Tree^.NFunc].Name;
  end;

  F_SyntaxErrorString:='';
  FindNumberLevel(ANL);
  for j:=0 to Tree^.Stack.N-1 do
  begin
   if j > 0 then  F_SyntaxErrorString:=F_SyntaxErrorString+',';
   F_SyntaxErrorString:=F_SyntaxErrorString+NameTypes[Interp[ANL[j]].TypeF];
  end;

  //if F_SyntaxErrorCode = E_NOT_DEFINED_FUNCTION_FOR_TYPE  then F_SyntaxErrorString:=F_SyntaxErrorStringA+'('+F_SyntaxErrorString+')';
  TranslErrMsg(Tree^.Expression);

  if F_SyntaxErrorCode = E_NOT_DEFINED_OPERATION_FOR_TYPE  then F_SyntaxErrorString:=F_SyntaxErrorStringA+'('+F_SyntaxErrorString+')';
  //if F_SyntaxErrorCode = E_NOT_DEFINED_FUNCTION_FOR_TYPE  then F_SyntaxErrorString:=F_SyntaxErrorStringA+'('+F_SyntaxErrorString+')';
  goto endp;           {.197}
 end;

 Interp[LFunc].COP:=_FUNC;
 Interp[LFunc].NFunc:=Tree^.NFunc;
 Interp[LFunc].Arg:=Tree^.Stack.N;
 Interp[LFunc].NF:=nf;


 //if present function similar 'rand' - disable calc const
 N1:=Interp[LFunc].NFunc;
 NF1:=Interp[LFunc].NF;
 if Alg.ExFunc[N1].Func[NF1].CalcConst = _NO then  F_EnableCalcConstExpression:=False;

end;



Interp[LFunc].S:=Tree^.Stack.S-1;  //  '0'
Interp[LFunc].N:=Tree^.Stack.N;
Interp[LFunc].NL:=Tree^.NL;
Interp[LFunc].NM:=Tree^.NM;
Interp[LFunc].IdN:=Tree^.IdN;
Interp[LFunc].IdL:=Tree^.IdL;
Interp[LFunc].Inv:=Tree^.Inv;

Interp[LFunc].nv1:=Tree^.nv1;
Interp[LFunc].nv2:=Tree^.nv2;
Interp[LFunc].NObj:=Tree^.NObj;

Interp[LFunc].AI:=Tree^.AI;
Interp[LFunc].CI:=Tree^.CI;
Interp[LFunc].FD:=Tree^.FD;

Interp[LFunc].CS:=0;

Interp[LFunc].TS:=Tree^.TS;
Interp[LFunc].TS1:=Tree^.TS1;
Interp[LFunc].TS2:=Tree^.TS2;


Interp[LFunc].RRF:=rf_NO_REPLACE;
Interp[LFunc].WRF:=rf_NO_REPLACE;
Interp[LFunc].NRF:=0;
Interp[LFunc].MRF:=-1;
Interp[LFunc].WRF_CS:=rf_NO_REPLACE; {.217}
Interp[LFunc].MRF_CS:=-1; {.217}

Interp[LFunc].VFP:=Tree^.VFP;          {.207}

{
N:=Length(Interp[LFunc].RData);
if N < 2 then N:=2;
// RData:     Access Violation   RData     . < 2
SetLength(Interp[LFunc].RData,N);
Interp[LFunc].RData[0]:=_FPU;  Interp[LFunc].RData[1]:=_FPU;
}

if Length(Tree^.RData) <> 0 then
begin
 SetLength(Interp[LFunc].RData,Length(Tree^.RData));
 for i:=0 to High(Tree^.RData) do
 begin
  Interp[LFunc].RData[i]:=Tree^.RData[i];
 end;
end;

{.197}
N:=Length(Interp[LFunc].RData);
if N < 2 then
begin
 N:=2;
 // RData:     Access Violation   RData     . < 2
 SetLength(Interp[LFunc].RData,N);
 Interp[LFunc].RData[0]:=_FPU;  Interp[LFunc].RData[1]:=_FPU;
end;


Interp[LFunc].SData:=Tree^.SData;
Interp[LFunc].ExpressionArg:=Tree^.ExpressionArg;

endp:

end;



procedure TForevalH.FindCallFunction(var nf: Integer);
label 1,2,3,endp;
var
Fnc: TIntFuncA;
i,N,T,j,S: Integer;
ANL: TArrayC;
begin
nf:=-1;
N:=Tree^.Stack.N;
S:=Tree^.Stack.S;
Fnc:=Alg.ExFunc[Tree^.NFunc].Func;


FindNumberLevel(ANL);  // 


//   
for i:=0 to High(Fnc) do
begin
  if Fnc[i].ExeF = _YES then   //  ,     
  begin

    if N = Fnc[i].N then //  :
    begin

     for j:=0 to N-1 do
     begin
      if Interp[ANL[j]].TypeF <> Fnc[i].TV[j] then goto 1;
     end;

     nf:=i;
     goto endp;
    end;

  end;
1:
end;




 for i:=0 to High(Fnc) do
 begin

   if Fnc[i].ExeF = _YES then   //  ,     
   begin

     if  Fnc[i].CallT = _STACK_INFINITE then //  :
     begin

      for j:=0 to High(ANL) do
      begin
       if Interp[ANL[j]].TypeF <> Fnc[i].TV[0] then goto 2;
      end;

      nf:=i;
      goto endp;
     end;

   end;

 2:
 end;




for i:=0 to High(Fnc) do
 begin
   if Fnc[i].ExeF = _YES then   //  ,     
   begin

     if  Fnc[i].CallT = _STACK_INFINITE_A then
     begin
      SetLength(Interp[LFunc].ArgTypes,Length(ANL));
      for j:=0 to High(ANL) do
      begin
       if (Interp[ANL[j]].TypeF =  T_Integer) or (Interp[ANL[j]].TypeF =  T_Array) then goto 3;

       Interp[LFunc].ArgTypes[j]:=Interp[ANL[j]].TypeF;
      end;

      nf:=i;
      goto endp;
     end;

   end;
 3:
 end;



endp:
end;






procedure TForevalH.FindCallFunctionA(var TypeF: Integer; var nf: Integer; var TypeA: Integer);
label endp;
var
Fnc: TIntFuncA;
i,N,T,j,S: Integer;
ANL: TArrayC;
TypeF1,TypeF2: Integer;
adr: Cardinal;
nv1,nv2,tv1,tv2,tm1,tm2: Integer;
begin
//    (N=0,1) (N -    )   (.: x+sin(x); x+y; x+1; sin(x)+1):

nf:=-1;
TypeA:=0;       // 
TypeF2:=0;      // 
tv1:=0;
tv2:=0;

N:=Tree^.Stack.N;
S:=Tree^.Stack.S;
Fnc:=Alg.ExFunc[Tree^.NFunc].Func;

nv1:=Tree^.NV1; nv2:=Tree^.NV2;
if nv1 <> -1 then GetVar(nv1,adr,tv1,tm1);
if nv2 <> -1 then GetVar(nv2,adr,tv2,tm2);

if (tv1 = T_Complex) or (tv2 = T_Complex) then TypeF1:=T_Complex
 else
 if (tv1 = IM_UNIT) or (tv2 = IM_UNIT) then TypeF1:=T_Complex
  else TypeF1:=T_Real;

if ((Tree^.NFunc = CM_MUL) or (Tree^.NFunc = CM_DIV)) and (tv1 = IM_UNIT) and (tv2 = IM_UNIT) then  TypeF1:=T_Real; //i*i,i/i


FindNumberLevel(ANL);  // 
if N = 1 then begin TypeF2:=Interp[ANL[0]].TypeF; TypeA:=TypeF2; end;

if (TypeF1 = T_Complex) or (TypeF2 = T_Complex) then TypeF:=T_Complex else TypeF:=T_Real;





//!!! nf    ( - .     )
begin
  case Tree^.NFunc of
   CM_ADD:  nf:=0{C_ADD};
   CM_SUB:  nf:=0{C_SUB};
   CM_MUL:  nf:=0{C_MUL};
   CM_DIV:  nf:=0{C_DIV};
   CM_MOD:  nf:=0{C_DIV};
  end;
goto endp;
end;





endp:
end;





procedure TForevalH.FindNumberLevel(var ANL: TArrayC);
var   //  ,    
i,j: Integer;
E: Exception;
begin


for j:=1 to LFunc-1 do
begin
   if Tree^.IdN = Interp[j].IdL then
   begin
    SetLength(ANL,Length(ANL)+1);
    ANL[High(ANL)]:=j;
   end;
end;

if Tree^.Stack.N <> Length(ANL) then
begin {InternalError}
 F_InternalError:=E_AccessViolation;
 IntException;
end;

end;



procedure TForevalH.TranslErrMsg(SubExpr: String);
var
SA,SF,St: String;
PF: Cardinal;
begin
 //if F_SyntaxErrorCode = E_NOT_DEFINED_OPERATION_FOR_TYPE  then F_SyntaxErrorString:=F_SyntaxErrorStringA+'('+F_SyntaxErrorString+')';
 //if F_SyntaxErrorCode = E_NOT_DEFINED_FUNCTION_FOR_TYPE  then F_SyntaxErrorString:=F_SyntaxErrorStringA+'('+F_SyntaxErrorString+')';

if F_SyntaxErrorCode = E_NOT_DEFINED_FUNCTION_FOR_TYPE   then
begin

  SA:=F_SyntaxErrorString;
  SF:=F_SyntaxErrorStringA;


  //St:=LowerCase(SA);
                           //ifp(z1<z2,x=1;z1=z2);x
                           //iff(z1<z2,x,z1);x
                           //iff(x<y,x,z1);x
  //PF:=Pos('ifnop(',St);
  if  SF = 'if@' then
  begin
     Delete(F_SyntaxErrorStringA,3,1);//@

     PF:=Pos('NoType',SA);
     while PF <> 0 do
     begin
        Delete(SA,PF,6);
        PF:=Pos('NoType',SA);
     end;

     PF:=Pos(',,',SA);
     while PF <> 0 do
     begin
        Delete(SA,PF,1);
        PF:=Pos(',,',SA);
     end;

     PF:=Pos(',,',SA);
     if PF = Length(SA)-1 then  Delete(SA,PF,2);

     PF:=Length(SA);
     if SA[PF] = ',' then  Delete(SA,PF,1);

     SF:='if'+'('+SA+')';
     F_SyntaxErrorString:=SF{+' in '+ SubExpr};
  end
  else
   if  SF = 'ldsvx' then
  begin
     //vd[z1+1]
     //vd[i+1]
     //St:=F_SyntaxErrorStringA+'('+F_SyntaxErrorString+')';
     //F_SyntaxErrorString:=St+' in '+SubExpr ;
     F_SyntaxErrorString:=SubExpr ;
     F_SyntaxErrorCode:=E_INCORRECT_ARGUMENT;
  end
  else
  if  SF = 'save@' then
  begin
    //vd[i+1]=x;x
     Delete(F_SyntaxErrorStringA,5,1);//@
     St:=F_SyntaxErrorStringA+'('+F_SyntaxErrorString+')';
     F_SyntaxErrorString:=St+' in '+SubExpr ;

  end
  else
  F_SyntaxErrorString:=F_SyntaxErrorStringA+'('+F_SyntaxErrorString+')';

end
else
F_SyntaxErrorString:=F_SyntaxErrorStringA+'('+F_SyntaxErrorString+')';





end;



function TForevalH.GetLevelsCS(num: Integer): Cardinal;
var   //   
j,IdN: Integer;
CS: Cardinal;
ANL: TArrayC;
begin


IdN:=Interp[num].IdN;
for j:=1 to LFunc-1 do
begin
   if IdN = Interp[j].IdL then
   begin
    SetLength(ANL,Length(ANL)+1);
    ANL[High(ANL)]:=j;
   end;
end;

CS:=0;
for j:=0 to High(ANL) do
begin
   CS:=CS+Interp[ANL[j]].CS;
end;

GetLevelsCS:=CS;
end;




procedure TForevalH.InitNode(var ND: TDataNode);
var
i: Integer;
begin
ND.N:=0;
ND.NCOP:=0;
ND.NFunc:=0;
ND.NObj:=0;
ND.COP:=0;
ND.FD:=0;
ND.FX:=0;
ND.IdN:=0;
ND.NV1:=-1;
ND.NV2:=-1;
ND.TypeF:=0;
ND.Inv:=0;
ND.TS:=0;
ND.AI:=0;
ND.NF:=0;
ND.TC:=0;
ND.TS1:=0;
ND.TS2:=0;
end;






function TForevalH.PointToDec(S: String):String;
label
1;
var
i:Cardinal;
SS: String;
begin
SS:=Copy(S,1,Length(S));
for i:=1 to Length(S) do
 begin
  if SS[i] = '.' then
  begin
   Delete(SS,i,1);
   Insert(',',SS,i);
   goto 1;
 end
end;

1:
PointToDec:=Copy(SS,1,Length(SS));
end;




procedure TForevalH.CreateInitData;
begin                             //  


F_SyntaxErrorCode:=0;
LFunc:=0;

F_ShowException:=False;
F_ExternalException:=False;
F_LeadToLowerCase := True;    {.221}
F_DataType:=_Extended;{_Double};
F_DinamicLoadOptimization:=True;
F_SaveInFPU:=True;
//F_SaveStack:=True;
F_StackDeep:=8;
//F_Opt:=False;
F_Mode:=M_Compile;
F_SyntaxExtension:=True;
F_CalcType:=T_Complex;
F_OperationOptimizatorA1:=True;
F_OperationOptimizatorA2:=True;
F_CalcConstExpr:=True;
F_ReplaceFunctions:=True;
F_ReplaceOperations:=True;
F_ReplaceFunctionsCF:=True; {.217}
F_UseVirtAlloc:=False;
F_DisableReplaceIF:=False;   {.195}
F_FAST_DIV:=True; {.205}
F_MulDivOptimization:=True; {.217A}
F_SkippedIf:=True;{.221}
F_EnableCalcConsExprInMulti:=False;  {.221}
F_EnableMaskFpuException:=False; {.229}

CreateFuncList;
CreateFactMass;

//Application.OnException:=CalcException;

SetType(1);

REGA[1]:=0;
REGA[2]:=0;
REGA[3]:=0;
REGA[4]:=0;
REGA[5]:=0;
REGA[6]:=0;
REGA[7]:=0;
REGA[8]:=0;

NameTypeS[T_Real]:='Real';
NameTypeS[T_Complex]:='Complex';
NameTypeS[T_Array]:='Array';
NameTypeS[T_Integer]:='Integer';
NameTypeS[T_None]:='NoType';
end;



function TForevalH.GetLineStackAdr(NM,NArg: Cardinal): TAddress;
var
i,NL,N,NF,TV,TM,CallT, NArgF, S, SzArg: Integer;
SAdr: TAddress;
begin
             //""    16-   ( 32 (TComplexE=ext,ext))

    N:=Interp[NM].NFunc;
    NF:=Interp[NM].NF;
    NL:=Interp[NM].NL;
    S:=Interp[NM].S;

    NArgF:=Alg.ExFunc[N].Func[NF].N;

    SzArg:=0;

    //{$OverFlowChecks Off}
    //{$RangeChecks Off}

    //SzArg -   
    for I := 0 to NArg - 2 do
      begin
        TV:=Alg.ExFunc[N].Func[NF].TV[i];
        if (TV = T_Real) or (TV = T_Array) then SzArg:=SzArg+16 else
        if (TV = T_Complex) then SzArg:=SzArg+32;
      end;
    //{$OverFlowChecks On}
    //{$RangeChecks On}

    SAdr:=GetStackAdr(S,_RE)+SzArg;    //GetStackAdr(S,_RE) -    

    GetLineStackAdr:=SAdr;
end;



procedure TForevalH.SaveArgMemAdr(i: Cardinal);
var
S,N,NM,CallT,NF,dt,sh,Adr,tf,NL: Cardinal;
SAdr: TAddress;
begin                         //NM -  
   S:=Interp[I].S;            //NL -     
   NM:=Interp[I].NM;
   NL:=Interp[I].NL;
   N:=Interp[NM].NFunc;
   NF:=Interp[NM].NF;

   SAdr:=GetLineStackAdr(NM,NL);    //     (NL)

     case Interp[I].ExtArg of
      D_Real:     dt:=_Double;
      D_Complex:  dt:=_Double;
      E_Real:     dt:=_Extended;
      E_Complex:  dt:=_Extended;
      D_Array_Real:   dt:=_Pointer;
      E_Array_Real:   dt:=_Pointer;
      I_Array_Real:    dt:=_Pointer;
       _Integer:       dt:=_Integer;
     end;
     if Interp[I].TypeF = T_Real then
     begin
      FSTPM(SAdr,dt);
     end
     else
     if (Interp[I].TypeF = T_Complex)  then
     begin
      FSTPM(SAdr,dt);
      FSTPM(SAdr+16,dt);
     end
     else
     if Interp[I].TypeF = T_Array then
     begin  {arraycpu}
      //FSTPM(SAdr,_Pointer);    {.197}

      //POPF(SAdr);      {.223}

      PUSHF(GetStackAdr(S,_RE)) ;
      POPF(SAdr);
     end;
end;




procedure TForevalH.SaveArgPC(i: Cardinal);      {.197}
var
S,N,NM,CallT,NF,dt,sh,Adr,tf,NL,TV,TM: Cardinal;
SAdr: TAddress;

begin

 S:=Interp[I].S;
 NM:=Interp[I].NM;
 NL:=Interp[I].NL;
 N:=Interp[NM].NFunc;
 NF:=Interp[NM].NF;
 CallT:=Alg.ExFunc[N].Func[NF].CallT;

if Interp[I].TypeF = T_Array then
     begin  {arraycpu}
      //FSTPM(GetStackAdr(S,_RE),_Pointer);      {.197}

      //POPF(GetStackAdr(S,_RE));      {.223}
     end
else
if (Interp[I].SData = _MEM) then
begin
     case Interp[I].ExtArg of
      D_Real:     dt:=_Double;
      D_Complex:  dt:=_Double;
      E_Real:     dt:=_Extended;
      E_Complex:  dt:=_Extended;
      D_Array_Real:   dt:=_Pointer;
      E_Array_Real:   dt:=_Pointer;
      I_Array_Real:    dt:=_Pointer;
       _Integer:       dt:=_Integer;
     end;
     if Interp[I].TypeF = T_Real then
     begin
      FSTPM(GetStackAdr(S,_RE),dt);
     end
     else
     if Interp[I].TypeF = T_Complex then
     begin       //RE-ST(0); IM-ST(1)
      FSTPM(GetStackAdr(S,_RE),dt);
      FSTPM(GetStackAdr(S,_IM),dt);
     end

end;


end;

procedure TForevalH.SaveArgStackVal(i: Cardinal);      {.197}
var
S,N,NM,CallT,NF,dt,sh,Adr,tf,NL,TV,TM: Cardinal;
SAdr: TAddress;

begin

 S:=Interp[I].S;
   NM:=Interp[I].NM;
   NL:=Interp[I].NL;
   N:=Interp[NM].NFunc;
   NF:=Interp[NM].NF;
   CallT:=Alg.ExFunc[N].Func[NF].CallT;

  case Interp[I].ExtArg of
      D_Real:     dt:=_Double;
      D_Complex:  dt:=_Double;
      E_Real:     dt:=_Extended;
      E_Complex:  dt:=_Extended;
      D_Array_Real:   dt:=_Pointer;
      E_Array_Real:   dt:=_Pointer;
      I_Array_Real:    dt:=_Pointer;
       _Integer:       dt:=_Integer;
     end;
     if Interp[I].TypeF = T_Real then
     begin
      FSTPM(GetStackAdr(S,_RE),dt);
     end
     else
     if Interp[I].TypeF = T_Complex then
     begin       //RE-ST(0); IM-ST(1)
      FSTPM(GetStackAdr(S,_RE),dt);
      FSTPM(GetStackAdr(S,_IM),dt);
     end
     else
     if Interp[I].TypeF = T_Array then
     begin    {arraycpu}
      //FSTPM(GetStackAdr(S,_RE),_Pointer);      {.197}

      //POPF(GetStackAdr(S,_RE));       {.223}
     end;
end;


procedure TForevalH.SaveArgStackAdr(i: Cardinal);      {.197}
var
S,N,NM,CallT,NF,dt,sh,Adr,tf,NL,TV,TM: Cardinal;
SAdr: TAddress;

begin

 S:=Interp[I].S;
   NM:=Interp[I].NM;
   NL:=Interp[I].NL;
   N:=Interp[NM].NFunc;
   NF:=Interp[NM].NF;
   CallT:=Alg.ExFunc[N].Func[NF].CallT;
 case Interp[I].ExtArg of
      D_Real:     dt:=_Double;
      D_Complex:  dt:=_Double;
      E_Real:     dt:=_Extended;
      E_Complex:  dt:=_Extended;
      D_Array_Real:   dt:=_Pointer;
      E_Array_Real:   dt:=_Pointer;
      I_Array_Real:    dt:=_Pointer;
       _Integer:       dt:=_Integer;
     end;
     if Interp[I].TypeF = T_Real then
     begin
      FSTPM(GetStackAdr(S,_RE),dt);
     end
     else
     if (Interp[I].TypeF = T_Complex)  then
     begin
      Adr:=GetStackAdr(S,_RE);
      if  dt = _Double    then  sh:=8 else
      if  dt = _Extended  then  sh:=16;
      FSTPM(Adr,dt);
      FSTPM(Adr+sh,dt);
     end
     else
     if Interp[I].TypeF = T_Array then
     begin    {arraycpu}
      //FSTPM(GetStackAdr(S,_RE),_Pointer);    {.197}

      //POPF(GetStackAdr(S,_RE));           {.223}
     end;
end;




procedure TForevalH.SetExtArg;
label endp;
var
i,NM,NL,N,NF,TV,TM,CallT: Integer;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

  for i:= 1 to  High(Interp)-1 do
  begin

    NM:=Interp[i].NM;
    NL:=Interp[i].NL;

    N:=Interp[NM].NFunc;
    NF:=Interp[NM].NF;

    CallT:=Alg.ExFunc[N].Func[NF].CallT;

    if  CallT = 0 then
       Interp[i].ExtArg:=0
    else
    begin
      if (CallT = _STACK_ADR) or (CallT = _EAX) or (CallT = _ESP) or (CallT = _STACK_VAL) or (CallT = _COMPILED) then
      begin
       TV:=Alg.ExFunc[N].Func[NF].TV[NL-1];
       TM:=Alg.ExFunc[N].Func[NF].TM[NL-1];
      end
      else
      if  CallT = _STACK_INFINITE then
      begin
       TV:=Alg.ExFunc[N].Func[NF].TV[0];
       TM:=Alg.ExFunc[N].Func[NF].TM[0];
      end
      else
      if  CallT = _STACK_INFINITE_A then
      begin
       TV:=Interp[i].TypeF;
       TM:=Alg.ExFunc[N].Func[NF].TM[0];
      end;

       if (TV = T_Real) and (TM = _Double) then Interp[i].ExtArg:=D_Real else
       if (TV = T_Real) and (TM = _Extended) then Interp[i].ExtArg:=E_Real else
       if (TV = T_Complex) and (TM = _Double) then Interp[i].ExtArg:=D_Complex else
       if (TV = T_Complex) and (TM = _Extended) then Interp[i].ExtArg:=E_Complex else
       if (TV = T_Array) and (TM = _Double) then Interp[i].ExtArg:=D_Array_Real else
       if (TV = T_Array) and (TM = _Extended) then Interp[i].ExtArg:=E_Array_Real else
       if (TV = T_Array) and (TM = _Integer)  then Interp[i].ExtArg:=I_Array_Real else
       if (TV = T_Real) and (TM = _Integer) then Interp[i].ExtArg:=_Integer;
    end;

  end;

  Interp[High(Interp)].ExtArg:=0;

endp:
end;


{
procedure TForevalH.ReplaceArctan;
var

begin
  for i:=1 to LFunc-1 do
  begin
     if (Interp[i].NFunc = CM_ARCTAN) and (i > 1) then
     begin
       if (Interp[i-1].NFunc = CM_DIV) and (Interp[i-1].TypeF = T_Real) then
       begin
          Interp[i].NFunc: = CM_ARCTAN2;
          Interp[i].N:=2;
       end;
     end;
  end;
end;
  }

procedure TForevalH.SetExtExpression(S: String;  var E_Func: TFunction; var Stack: Cardinal);
label endp, beginp, nocmpl;
var
I_Func: TFunction;
I_LFunc, FAdr,StSize: Cardinal;
E: Exception;
cc: boolean;
V_RE,V_IM: Extended;
Siu,Sre,Sim,S1,S2,S3,S4: String;
T1,T2: Cardinal;
EnableCmpl: Boolean;
begin
cc:=false;

if F_SyntaxExtension = True then Siu:=S_IM_UNIT else Siu:='*'+S_IM_UNIT;
CheckRecoverImUnit;

PrevTreat(S,S);
if F_SyntaxErrorCode <> 0 then          {.231}
begin

   Func.Addr:=0;
   E_Func.Addr:=0;
   Func.Code:=nil;
   Func.Data:=nil;
   Func.PAddr:=nil;
   Func.Addr:=0;
   IntException;
   goto endp;
end;


beginp:

InitConstDb;
Set8087CW($1372); {.229}
try
V_RE:=0; V_IM:=0;    {.191}
F_SaveInFPU:=F_DinamicLoadOptimization;
//F_CalcConstExpr:=F_OperationOptimizator;  {.195}



//I_LFunc:=LFunc;
//Func:=E_Func;    {.221}
Func.PAddr:=nil;
Func.Addr:=0;
Func.Data:=nil;
Func.Code:=nil;
Tree:=nil;
BeginTree:=nil;
F_SyntaxErrorCode:=0;
F_CalcErrorCode:=0;
F_InternalError:=0;
F_SyntaxErrorString:=S;
F_Mode:=M_Compile;   {.197}
F_SyntaxErrorStringA:='';
F_GotoPresent:=False;
F_IF:=False;
F_EnableCalcConstExpression:=True;
F_ComplexNumber:=False;
F_PresentVar:=False;
CurrentExpression:=Copy(S,1,Length(S));
F_ResultType:=T_Complex; {.227}
//PrevTreat(S,S);
      //TestZ.Form1.MT.Lines.Add('****************************');
      //T1:=GetTickCount;
TryFPUMask; {.229}
Linker(S);
      //T2:=GetTickCount;
      //TestZ.Form1.MT.Lines.Add('Linker: '+IntToStr(T2-T1));

//  (  )    ,     (  )
//F_EnableCalcConsExprInMulti : _CompileMultiExpr
if   (F_EnableCalcConsExprInMulti = True) and (F_PresentVar = True) then  EnableCmpl:= False else EnableCmpl:= True;   {.221}

if (F_SyntaxErrorCode = 0) and (F_InternalError = 0) and  (EnableCmpl = True){.221} {.227}   then
begin
  //FreeFunction;
      //T1:=GetTickCount;
  SetNL;
  SetLoadSource;
  SetNM;

  GetSizeInterp;    {.197}
     //T2:=GetTickCount;
     //TestZ.Form1.MT.Lines.Add('Init: '+IntToStr(T2-T1));

  SetStackSize;
  StSize:=StackSize;

     //T1:=GetTickCount;
  CodeGeneration;
     //T2:=GetTickCount;
     //TestZ.Form1.MT.Lines.Add('CodeGen: '+IntToStr(T2-T1));
     (*
     //      (      (  ) ...;z=expr; ..)
     if EnableCmpl = False then      {.227}
     begin
        if Length(Interp) <> 0 then F_ResultType:=Interp[High(Interp)].TypeF;
        goto nocmpl;
      end;
     *)

  FreeTree;     {.197}



  F_IF:=FindIfFunc;
  SetExtArg;

      //T1:=GetTickCount;
  if (F_IF = True) and (F_DisableReplaceIF = True) then begin end else  ReplaceOptimizator;   {.195}
      //T2:=GetTickCount;
      //TestZ.Form1.MT.Lines.Add('Replace: '+IntToStr(T2-T1));
  //SetStackSize;
      //T1:=GetTickCount;
  if F_DinamicLoadOptimization = True then   DinamicLoadOptimizator;
      //T2:=GetTickCount;
      //TestZ.Form1.MT.Lines.Add('DinLoad: '+IntToStr(T2-T1));

  if Length(Interp) <> 0 then F_ResultType:=Interp[High(Interp)].TypeF;
  //SetStackSize;
  //FreeTree;     {.197}

  SetLength(Func.Stack,{StackSize}StSize);
  _MaxStack:=0;

    {DEBUG DL}
    DebugDL;



      //T1:=GetTickCount;
  Compile;
      //T2:=GetTickCount;
      //TestZ.Form1.MT.Lines.Add('Compile: '+IntToStr(T2-T1));
      //TestZ.Form1.MT.Lines.Add('SizeInterp: '+IntToStr(Length(Interp)));

//Func.ICode:=TAddress(@Func.Code[NAdr]);   {.193}
  Db_CmplMaxStack:=_MaxStack;
  Db_LoadStackAfterCalc:=N_Stack;         {.197}
//FreeInterp;
//FreeTree;
  Stack:=StackSize;
  E_Func:=Func;
//LFunc:=I_LFunc;
//Func:=I_Func;

  if (F_IF = True) or (F_GotoPresent = True) then F_EnableCalcConstExpression:=False;

 nocmpl:
 TryCatchFPUException;    {.229}
end;

except
 on E: EZeroDivide      do F_InternalError:=E_ZeroDivide;
 on E: EInvalidOp       do F_InternalError:=E_InvalidOp;
 on E: EOverFlow        do F_InternalError:=E_OverFlow;
 on E: EUnderFlow       do F_InternalError:=E_UnderFlow;
 on E: EIntOverFlow     do F_InternalError:=E_IntOverFlow;
 on E: EAccessViolation do F_InternalError:=E_AccessViolation;
 on E: EOutOfMemory     do F_InternalError:=E_OutOfMemory;
 on E: EStackOverFlow   do F_InternalError:=E_StackOverFlow
end;

FreeInterp;
FreeTree;

if (F_InternalError <> 0 ) or (F_SyntaxErrorCode <> 0) then
begin
 //setlength(ICOMP,0);
 FreeExtFunc(@Func); {.225}
 ICOMP:=nil;
 //F_SyntaxErrorString:=S;
 IntException;
 //F_SyntaxErrorString:= F_SyntaxErrorString+ F_SyntaxErrorString1;
 goto endp;
end;
//BeginLinker:=1;


//,   - 
if (F_ResultType <> T_None)   and (F_PresentVar = False) and (F_CalcConstExpr = True)  and (cc = false) and ({F_GotoPresent = False}F_EnableCalcConstExpression = True) then
begin
  FAdr:=Func.Addr;
  try
    TryFPUMask; {.229}

   if F_CalcType = T_Real then
    begin
     asm
      call  FAdr
      fstp  tbyte ptr V_RE
     end;
    end
    else
    if F_CalcType = T_Complex then
    begin
     asm
      call  FAdr
      fstp  tbyte ptr V_RE
      fstp  tbyte ptr V_IM
     end;
    end;

    TryCatchFPUException;    {.229}

    FV_Result.re:=V_RE;     FV_Result.im:=V_IM;     {.229}

  except                                                         {.155}
   on E: EZeroDivide      do F_CalcErrorCode{F_InternalError}:=E_ZeroDivide;
   on E: EInvalidOp       do F_CalcErrorCode{F_InternalError}:=E_InvalidOp;
   on E: EOverFlow        do F_CalcErrorCode{F_InternalError}:=E_OverFlow;
   on E: EUnderFlow       do F_CalcErrorCode{F_InternalError}:=E_UnderFlow;
   on E: EIntOverFlow     do F_CalcErrorCode{F_InternalError}:=E_IntOverFlow;
   on E: EAccessViolation do F_CalcErrorCode{F_InternalError}:=E_AccessViolation;
   on E: EOutOfMemory     do F_CalcErrorCode{F_InternalError}:=E_OutOfMemory;
   on E: EStackOverFlow   do F_CalcErrorCode{F_InternalError}:=E_StackOverFlow;
  end;

  {.191}
  Sre:=FloatToStr(V_RE);   Sim:=FloatToStr(V_IM);
  if   (LowerCase(Sre)= 'nan') or (LowerCase(Sim)  = 'nan')
    or (LowerCase(Sre)  = 'inf') or (LowerCase(Sim)  = 'inf')
    or (LowerCase(Sre)  = '-inf') or (LowerCase(Sim)  = '-inf')
  then
  F_CalcErrorCode:=E_InvalidOp;


  FreeExtFunc(@Func);{.225}

  if (F_InternalError <> 0) or (F_CalcErrorCode <> 0) then
  begin
   F_CurrentSubExpr:=CurrentExpression;
   IntException;
   F_SyntaxErrorString:= F_SyntaxErrorString+ F_SyntaxErrorStringA;
   goto endp;
  end;

  if (F_CalcType = T_Real) or ({F_ComplexNumber = False}F_ResultType = T_Real)  then S:=FloatToStrF(V_RE, ffGeneral, 20, 4, G_FMT) {S:=FloatToStr(V_RE,G_FMT)}
   else
  if F_CalcType = T_Complex then  S:=FloatToStrF(V_RE,ffGeneral, 20, 4, G_FMT)+'+('+FloatToStrF(V_IM,ffGeneral, 20, 4, G_FMT)+')'+Siu; {S:=FloatToStr(V_RE,G_FMT)+'+i*('+FloatToStr(V_IM,G_FMT)+')'};
  cc:=true;
  goto beginp;
end;

endp:
E_Func:=Func; {.221}
Set8087CW($1372); {.229}
end;


procedure TForevalH.ReplaceOptimizator;
var
i,j,FType,CODE,t1: Integer;
BH: Boolean;
begin
if  F_SyntaxErrorCode  = 0 then
begin
  RFSize:=-1;

  {
  if (F_ReplaceFunctionsCF = True) and (F_ReplaceFunctions = True) then ReplaceFuncComposite
    else
     if F_ReplaceFunctions = True then ReplaceFunc;
  }

if F_ReplaceFunctionsCF = True then
begin
  if F_ReplaceFunctions = True then ReplaceFuncComposite;
  if F_ReplaceOperations = True then ReplaceOperations;
  SetLength(Func.RFStack,RFSize+1);
  if RFSize >= 1 then
  begin
    if F_ReplaceFunctionsCF = True  then DelVoidSaveCF else  DelVoidSave; {.195} {.217}
  end;
end
else    //if F_ReplaceFunctionsCF - off: then return to v.215 (not necessary: must be to work all in v.217)
begin
  if F_ReplaceFunctions = True then ReplaceFunc;
  if F_ReplaceOperations = True then ReplaceOperations;
  SetLength(Func.RFStack,RFSize+1);
  if RFSize >= 1 then DelVoidSave; {.195}
end;

end;
end;

  
procedure TForevalH.ReplaceFunc;
label 0,1,2,endp;
var
FType1,FType2,Code1,Code2,N1,N2,i,j,k,l,RL,RLB,t1,c1,c2,n,P,ReplF1,ReplF2: Integer;
Sc,Sc1,St1,St2,S: String;
BH: Boolean;
NFunc1,NFunc2,NF1,NF2,ResT1,ResT2: Integer;
begin

                                  //x=sin(x);x=sin(x);x
//   :
//legendrep(i,k,x)+legendrep(i,k,x)
//S:= Interp[LFunc-1].Expression;
for i:=1 to LFunc-1 do
begin
 //i- 
 //S:= Interp[i].Expression;
 if Interp[i].COP <> _FUNC then goto 1;
 if Interp[i].RRF = rf_FULL_REPLACE then goto 1;   //  

 NFunc1:=Interp[i].NFunc;
 NF1:=Interp[i].NF;

 //  :
 if (NFunc1 = CM_DIV) or (NFunc1 = CM_MUL) or (NFunc1 = CM_SUB) or (NFunc1 = CM_ADD) then goto 1;


 ResT1:=Interp[i].TypeF;

 //ReplF1:=Alg.ExFunc[NFunc1].Func[NF1].ReplFunc;
 ReplF1:=Alg.ExFunc[NFunc1].ReplFunc;

 if (ReplF1 = _No)  then goto 1;
 if (ResT1 = T_None)  then goto 1;           {.216}




 Sc:=Interp[i].ExpressionArg;
 //   :
 for j:=i+1 to LFunc-1 do
 begin
    //x=2; y=5; x=sin(x)*cos(y);x=sin(x)*cos(y)-cos(sin(x)); y=cos(y)*sin(x)*cos(y)+sin(x); x=y*sin(y)*cos(x)+cos(x)*sin(y); y=sin(x)/cos(y)+cos(y)/sin(x); x+y
   //           : x=sin(x);x=sin(x);x
   if Interp[j].NFunc = CM_SAVE  then goto 1;      {.193}
   if (Interp[j].NFunc = CM_JMP) then goto 1;  {.195}

   if Interp[j].COP <> _FUNC then goto 2;
   if Interp[j].RRF = rf_FULL_REPLACE then goto 2;   //  

   NFunc2:=Interp[j].NFunc;
   NF2:=Interp[j].NF;

   //  :
   if (NFunc2 = CM_DIV) or (NFunc2 = CM_MUL) or (NFunc2 = CM_SUB) or (NFunc2 = CM_ADD) then goto 2;

   ResT2:=Interp[j].TypeF;



   if (NFunc1 <> NFunc2) or (NF1 <> NF2) or (ResT1 <> ResT2)  then goto 2;


   //ReplF2:=Alg.ExFunc[NFunc2].Func[NF2].ReplFunc;
   ReplF2:=Alg.ExFunc[NFunc2].ReplFunc;


   if (ReplF2 = _No)  then goto 2;
   if (ResT2 = T_None)  then goto 2;           {.216}


   //St1:=Interp[i].Expression;
   //St2:=Interp[j].Expression;

   Sc1:=Interp[j].ExpressionArg;


   if Sc <> Sc1  then  goto 2;


   FindNonReplFunc(Sc1,BH);  //in Arg       //sin(x+rand(x,y)+x)+sin(x+rand(x,y)+x)
   if BH = True then goto 2;

   InsertFunc(i,j);


 2:
 end;

1:
end;



endp:
end;



 //sin(x)-cos(x)+sin(x)+cos(x)
 {.217}
 {.ReplFuncComposite = True/False !!!!!!!!!!!!!!!!!!!!   }
procedure TForevalH.ReplaceFuncComposite;

      function CompareFunc(N1,N2: Integer): Boolean;
      label endp;
      var
          NFunc1,NFunc2,NF1,NF2,ResT1,ResT2,NArg1,NArg2,i: Integer;
          Answ: Boolean;
      begin
          NFunc1:=Interp[N1].NFunc;
          NF1:=Interp[N1].NF;
          NFunc2:=Interp[N2].NFunc;
          NF2:=Interp[N2].NF;
          ResT1:=Interp[N1].TypeF;
          ResT2:=Interp[N2].TypeF;
          NArg1:=Length(Alg.ExFunc[NFunc1].Func[NF1].TV);
          NArg2:=Length(Alg.ExFunc[NFunc2].Func[NF2].TV);

          Answ:=True;

          if (F_ReplaceFunctionsCF = True) and (NFunc1 <= High(TableRF)) and (NFunc2 <= High(TableRF)) then      //  
          begin
            //sincos,cossin <-> sin,cos;
            if {(ResT1 <> ResT2) or} (NArg1 <> NArg2)  then begin  Answ:=False;  goto endp;  end;

            if ResT2 = T_Real then
               if TableRF[NFunc1,NFunc2].RRF_R = rf_NO_REPLACE then  begin  Answ:=False;  goto endp;  end;

            if ResT2 = T_Complex then
               if TableRF[NFunc1,NFunc2].RRF_Z = rf_NO_REPLACE then  begin  Answ:=False;  goto endp;  end;

             // (composite!)    -    (real/complex):
             if  (ResT1 = T_Complex) and (NFunc1 <> NFunc2) and (Alg.ExFunc[NFunc2].ReplFuncCFZ = _NO) then  begin  Answ:=False;  goto endp;  end;
             if  (ResT1 = T_Real) and (NFunc1 <> NFunc2) and (Alg.ExFunc[NFunc2].ReplFuncCFR = _NO) then  begin  Answ:=False;  goto endp;  end;

             for i := 0 to NArg1 - 1 do
               if Alg.ExFunc[NFunc1].Func[NF1].TV[i] <> Alg.ExFunc[NFunc2].Func[NF2].TV[i] then  begin  Answ:=False;  goto endp;  end;
          end
          else
          begin
              if (NFunc1 <> NFunc2) or (NF1 <> NF2) or (ResT1 <> ResT2)  then Answ:=False;  //  
          end;

       endp:
       CompareFunc:=Answ;
      end;


label 0,1,2,endp;
var
FType1,FType2,Code1,Code2,N1,N2,i,j,k,l,RL,RLB,t1,c1,c2,n,P,ReplF1,ReplF2: Integer;
Sc,Sc1,St1,St2,S,Sf1,Sf2: String;
BH: Boolean;
NFunc1,NFunc2,NF1,NF2,ResT1,ResT2: Integer;
begin

                                  //x=sin(x);x=sin(x);x
//   :
//legendrep(i,k,x)+legendrep(i,k,x)
//S:= Interp[LFunc-1].Expression;
for i:=1 to LFunc-1 do
begin
 //i- 
 Sf1:= Interp[i].Expression;
 if Interp[i].COP <> _FUNC then goto 1;
 if Interp[i].RRF = rf_FULL_REPLACE then goto 1;   //  

 NFunc1:=Interp[i].NFunc;
 NF1:=Interp[i].NF;

 //  :
 if (NFunc1 = CM_DIV) or (NFunc1 = CM_MUL) or (NFunc1 = CM_SUB) or (NFunc1 = CM_ADD) then goto 1;


 ResT1:=Interp[i].TypeF;

 //ReplF1:=Alg.ExFunc[NFunc1].Func[NF1].ReplFunc;
 ReplF1:=Alg.ExFunc[NFunc1].ReplFunc;

 if (ReplF1 = _No)  then goto 1;
 if (ResT1 = T_None)  then goto 1;           {.216}




 Sc:=Interp[i].ExpressionArg;
 //   :
 for j:=i+1 to LFunc-1 do
 begin
    Sf2:= Interp[j].Expression;
    //x=2; y=5; x=sin(x)*cos(y);x=sin(x)*cos(y)-cos(sin(x)); y=cos(y)*sin(x)*cos(y)+sin(x); x=y*sin(y)*cos(x)+cos(x)*sin(y); y=sin(x)/cos(y)+cos(y)/sin(x); x+y
   //           : x=sin(x);x=sin(x);x
   if Interp[j].NFunc = CM_SAVE then goto 1;      {.193}
   if (Interp[j].NFunc = CM_JMP)  then goto 1;  {.195}

   if Interp[j].COP <> _FUNC then goto 2;
   if Interp[j].RRF = rf_FULL_REPLACE then goto 2;   //  

   //sh(x)+exp(x)+sh(x)+ch(x)    ;;; sh(x)-> exp(x),sh(x)
   //exp(x)+sh(x)+sh(x)
   //sh(x)+ch(x)+exp(x)


   NFunc2:=Interp[j].NFunc;
   NF2:=Interp[j].NF;



   //  :
   if (NFunc2 = CM_DIV) or (NFunc2 = CM_MUL) or (NFunc2 = CM_SUB) or (NFunc2 = CM_ADD) then goto 2;

   ReplF2:=Alg.ExFunc[NFunc2].ReplFunc;

   if (ReplF2 = _No)  then goto 2;
   if (ResT2 = T_None)  then goto 2;           {.216}



  {
   ResT2:=Interp[j].TypeF;

   if ResT1 <> ResT2   then goto 2;


   if ResT2 = T_Real then
      if TableRF[NFunc1,NFunc2].RRF_R = rf_NO_REPLACE then  goto 2;

   if ResT2 = T_Complex then
      if TableRF[NFunc1,NFunc2].RRF_Z = rf_NO_REPLACE then  goto 2;
      }

   if CompareFunc(i,j) = False then goto 2;


  // if {(NFunc1 <> NFunc2) or (NF1 <> NF2) or} (ResT1 <> ResT2)  then goto 2;





   //St1:=Interp[i].Expression;
   //St2:=Interp[j].Expression;


   Sc1:=Interp[j].ExpressionArg;


   if Sc <> Sc1  then  goto 2;


   FindNonReplFunc(Sc1,BH);  //in Arg       //sin(x+rand(x,y)+x)+sin(x+rand(x,y)+x)
   if BH = True then goto 2;

   //if F_ReplaceFunctionsCF = True then InsertFuncRF(i,j) else   InsertFunc(i,j);  // :      InsertFuncRF
   InsertFuncRF(i,j);

 2:
 end;

1:
end;



endp:
end;





procedure TForevalH.ReplaceOperations;
label 0,1,2,endp;
var
FType1,FType2,Code1,Code2,N1,N2,i,j,k,l,RL,RLB,t1,c1,c2,n,P,ReplF1,ReplF2: Integer;
Sc,Sc1,St1,St2,S: String;
BH: Boolean;
NFunc1,NFunc2,NF1,NF2,ResT1,ResT2: Integer;
begin

                                  //x=sin(x);x=sin(x);x
//   :
//legendrep(i,k,x)+legendrep(i,k,x)
S:= Interp[LFunc-1].Expression;
for i:=1 to LFunc-1 do
begin
 //i- 
 //S:= Interp[i].Expression;
 if Interp[i].COP <> _FUNC then goto 1;
 if Interp[i].RRF = rf_FULL_REPLACE then goto 1;   //  

 NFunc1:=Interp[i].NFunc;
 NF1:=Interp[i].NF;

 //  :
 if (NFunc1 <> CM_DIV) and (NFunc1 <> CM_MUL) and (NFunc1 <> CM_SUB) and (NFunc1 <> CM_ADD) then goto 1;


 ResT1:=Interp[i].TypeF;

 //ReplF1:=Alg.ExFunc[NFunc1].Func[NF1].ReplFunc;
 ReplF1:=Alg.ExFunc[NFunc1].ReplFunc;

 if (ReplF1 = _No)  then goto 1;




 Sc:=Interp[i].ExpressionArg;
 //   :
 for j:=i+1 to LFunc-1 do
 begin
  //z1=2-i; z2=5-2i; z1=(z1/z2+z2/z1)/(z1/z2-z2/z1); z2=(z2/z1)*(z1/z2-z2/z1); z2=z1*z2/(z1/z2-z2/z1)+z1/(z1*z2/(z1/z2-z2/z1)); z1=(z1/z2-z2/z1)/(z2/z1+z1/z2)+z1*z2/(z1/z2-z2/z1); z1+z2
  //x=2; y=5; x=(x/y+y/x)/(x/y-y/x); y=(y/x)*(x/y-y/x); y=x*y/(x/y-y/x)+x/(x*y/(x/y-y/x)); x=(x/y-y/x)/(y/x+x/y)+x*y/(x/y-y/x); x+y

   //           : x=x/y; x=x/y; x
   if Interp[j].NFunc = CM_SAVE then goto 1;      {.193}
   if (Interp[j].NFunc = CM_JMP)  then goto 1;  {.195}

   if Interp[j].COP <> _FUNC then goto 2;
   if Interp[j].RRF = rf_FULL_REPLACE then goto 2;   //  

   NFunc2:=Interp[j].NFunc;
   NF2:=Interp[j].NF;
   ResT2:=Interp[j].TypeF;



   //  :
   if (NFunc2 <> CM_DIV) and (NFunc2 <> CM_MUL) and (NFunc2 <> CM_SUB) and (NFunc2 <> CM_ADD) then goto 2;


   if (NFunc1 <> NFunc2) or (NF1 <> NF2) or (ResT1 <> ResT2)  then goto 2;


   //ReplF2:=Alg.ExFunc[NFunc2].Func[NF2].ReplFunc;
   ReplF2:=Alg.ExFunc[NFunc2].ReplFunc;


   if (ReplF2 = _No)  then goto 2;


   //St1:=Interp[i].Expression;
   //St2:=Interp[j].Expression;

   Sc1:=Interp[j].ExpressionArg;


   if Sc <> Sc1  then  goto 2;


   FindNonReplFunc(Sc1,BH);  //in Arg       //sin(x+rand(x,y)+x)+sin(x+rand(x,y)+x)
   if BH = True then goto 2;

   InsertFunc(i,j);


 2:
 end;

1:
end;



endp:
end;





procedure TForevalH.InsertFunc(NF,NS: Integer);
label 1,endp;
var
i,s,St: Integer;
L,FN: Integer;
NFunc: Cardinal;
begin
//NF -> NS
NFunc:=Interp[NF].NFunc;


if Interp[NF].NRF = 0 then
begin
 if Interp[NF].TypeF = T_Real then
 begin
   RFSize:=RFSize+1;
 end
 else
 if Interp[NF].TypeF = T_Complex then
 begin
   RFSize:=RFSize+2;
 end
end;

Interp[NF].NRF:=Interp[NF].NRF+1;

Interp[NF].WRF:=rf_FULL_REPLACE;
Interp[NS].RRF:=rf_FULL_REPLACE;
Interp[NS].MRF:=RFSize;
Interp[NF].MRF:=RFSize;




//    =CM_NOP
1:
S:=Interp[NS].S;
FN:=GetFirstNode(NS);  //  ( ) =  (  Interp.[FN]); (  Interp.[NS] -  )
for i:=FN to NS-1 do
begin
  Interp[i].N:=0;
  Interp[i].NFunc:=CM_NOP;
  Interp[i].NF:=0;{.197}
  Interp[i].TypeF:=0;
  Interp[i].COP:=_NOP;   //    
  Interp[i].RRF:=rf_NO_REPLACE;//???????
  //FuncList[Interp[i].Code].FType:=0;
end;



endp:
 if (NFunc = CM_DIV) or (NFunc = CM_MUL) or (NFunc = CM_SUB) or (NFunc = CM_ADD) then inc(Db_ReplOpNum)
 else inc(Db_ReplFuncNum);
end;



//sin(x)-cos(x)+sin(x)+cos(x)
procedure TForevalH.InsertFuncRF(NF,NS: Integer);
label 1,endp,fin;
var
i,s,St: Integer;
L,FN: Integer;
NFuncNF,NFuncNS,RangRRF,NFF,NFS,CRFMem: Cardinal;
RangW,RangR,NMem,MShft:integer;
B_RF:Boolean;
begin
//NF -> NS
if Interp[NS].RRF = rf_FULL_REPLACE  then goto endp;   // (NS)   



B_RF:=False;
NFuncNF:=Interp[NF].NFunc;
NFuncNS:=Interp[NS].NFunc;
NFF:=Interp[NF].NF;
NFS:=Interp[NS].NF;

(*
if  ((NFuncNF = NFuncNS) and (NFF = NFS))  then
begin

  if Interp[NF].NRF = 0  {=Interp[NF].WRF <> rf_FULL_REPLACE} then
  begin
   if Interp[NF].TypeF = T_Real then
   begin
     RFSize:=RFSize+1;
     CRFMem:=RFSize;
   end
   else
   if Interp[NF].TypeF = T_Complex then
   begin
     RFSize:=RFSize+2;
     CRFMem:=RFSize;
   end
  end
  else
  CRFMem:=Interp[NF].MRF;       { ..     RFSize   CompositeReplace   
                                   Interp[NF]; ( CompositeReplace  -  RFSize  )
                                 }

  Interp[NF].NRF:=Interp[NF].NRF+1;

  Interp[NF].WRF:=rf_FULL_REPLACE;
  Interp[NS].RRF:=rf_FULL_REPLACE;
  Interp[NS].MRF:=CRFMem;//RFSize;
  Interp[NF].MRF:=CRFMem;//RFSize;

  B_RF:=True;
  goto fin;
end
else
if (NFuncNF > High(TableRF)) or (NFuncNS > High(TableRF))  then
begin
  B_RF:=False;
  goto endp;
end;
*)


{
if Interp[NF].TypeF = T_Real then
begin

   if TableRF[NFuncNF,NFuncNS].WRF_R = rf_FULL_REPLACE  then   //  - (NF)
   begin
     if (Interp[NF].WRF = rf_FULL_REPLACE)  then        //    - (NF)
     begin
         RangRRF:=TableRF[NFuncNF,NFuncNS].RRF_R;        //  -  (NS)

         if RangRRF > Interp[NS].RRF then        //  -    ,    
         begin
           //   - (NS),    - MRF
           //   (NS) -   ,    - MRF_CS
           if RangRRF = rf_FULL_REPLACE  then   Interp[NS].MRF:=Interp[NF].MRF else   Interp[NS].MRF_CS:=Interp[NF].MRF;
           Interp[NS].RRF:=RangRRF;
           B_RF:=True;
         end;
     end
     else                                        //- 
     begin
       RangRRF:=TableRF[NFuncNF,NFuncNS].RRF_R;        //  -  (NS)
       if RangRRF > Interp[NS].RRF then        //   -   ,    
       begin
          RFSize:=RFSize+TableRF[NFuncNF,NFuncNS].NMEM_R;  //-  
          Interp[NF].WRF:=rf_FULL_REPLACE;   //   ,    - MRF
          Interp[NF].MRF:=RFSize;

           //   - (NS),    - MRF
           //   (NS) -   ,    - MRF_CS
           if RangRRF = rf_FULL_REPLACE  then   Interp[NS].MRF:=Interp[NF].MRF else   Interp[NS].MRF_CS:=Interp[NF].MRF;
           Interp[NS].RRF:=RangRRF;
           B_RF:=True;
       end;
     end;

   end
   else    //  - (NF):   - MRF_CS
   begin
      if Interp[NF].WRF_CS = TableRF[NFuncNF,NFuncNS].WRF_R then        //     -  (NF)
      begin
          RangRRF:=TableRF[NFuncNF,NFuncNS].RRF_R;        //  -  (NS)
          if RangRRF > Interp[NS].RRF then        //  -    ,    
          begin
            //   - (NS),    - MRF
            //   (NS) -   ,    - MRF_CS
            if RangRRF = rf_FULL_REPLACE  then   Interp[NS].MRF:=Interp[NF].MRF_CS else   Interp[NS].MRF_CS:=Interp[NF].MRF_CS;
            Interp[NS].RRF:=RangRRF;
            B_RF:=True;
          end;
      end
      else             //- 
      begin

          RangRRF:=TableRF[NFuncNF,NFuncNS].RRF_R;        //  -  (NS)
          if RangRRF > Interp[NS].RRF then        //  -    ,    
          begin
            RFSize:=RFSize+TableRF[NFuncNF,NFuncNS].NMEM_R;      //-  
            Interp[NF].WRF_CS:=TableRF[NFuncNF,NFuncNS].WRF_R;   //     (NF)
            Interp[NF].MRF_CS:=RFSize;

            //   - (NS),    - MRF
            //   (NS) -   ,    - MRF_CS
            if RangRRF = rf_FULL_REPLACE  then   Interp[NS].MRF:=Interp[NF].MRF_CS else   Interp[NS].MRF_CS:=Interp[NF].MRF_CS;
            Interp[NS].RRF:=RangRRF;
            B_RF:=True;
          end;
      end;
   end;
end ;
}



(*
if (Interp[NF].NFunc <= High(TableRF)) and (Interp[NS].NFunc <= High(TableRF))  then   //    (full+composite)
begin


if Interp[NF].TypeF = T_Real then
begin

   if TableRF[NFuncNF,NFuncNS].WRF_R = rf_FULL_REPLACE  then   //  - (NF)
   begin
     inc(Interp[NF].NRF);  //  (^)
     if (Interp[NF].WRF = rf_FULL_REPLACE)  then        //    - (NF)
     begin
         RangRRF:=TableRF[NFuncNF,NFuncNS].RRF_R;        //  -  (NS)

         if RangRRF > Interp[NS].RRF then        //  -    ,    
         begin
           //   - (NS),    - MRF
           //   (NS) -   ,    - MRF_CS
           if RangRRF = rf_FULL_REPLACE  then
           begin
              Interp[NS].MRF:=Interp[NF].MRF-TableRF[NFuncNF,NFuncNS].SHFT_R;
              Interp[NS].RRF:=rf_FULL_REPLACE;
           end
           else
           begin
             Interp[NS].MRF_CS:=Interp[NF].MRF-TableRF[NFuncNF,NFuncNS].SHFT_R;
             Interp[NS].RRF:=RangRRF;
           end;
           B_RF:=True;
         end;
     end
     else                                        //- 
     begin
       RangRRF:=TableRF[NFuncNF,NFuncNS].RRF_R;        //  -  (NS)
       if RangRRF > Interp[NS].RRF then        //   -   ,    
       begin
          RFSize:=RFSize+TableRF[NFuncNF,NFuncNS].NMEM_R;  //-  
          Interp[NF].WRF:=rf_FULL_REPLACE;   //   ,    - MRF
          Interp[NF].MRF:=RFSize;

           //   - (NS),    - MRF
           //   (NS) -   ,    - MRF_CS
           if RangRRF = rf_FULL_REPLACE  then
           begin
            Interp[NS].MRF:=Interp[NF].MRF-TableRF[NFuncNF,NFuncNS].SHFT_R;
            Interp[NS].RRF:=rf_FULL_REPLACE;
           end
           else
           begin
            Interp[NS].MRF_CS:=Interp[NF].MRF-TableRF[NFuncNF,NFuncNS].SHFT_R;
            Interp[NS].RRF:=RangRRF;
           end;
           Interp[NS].RRF:=RangRRF;
           B_RF:=True;
       end;
     end;

   end
   else    //  - (NF):   - MWF_CS
   begin
      if Interp[NF].WRF_CS = TableRF[NFuncNF,NFuncNS].WRF_R then        //     -  (NF)
      begin
          RangRRF:=TableRF[NFuncNF,NFuncNS].RRF_R;        //  -  (NS)
          if RangRRF > Interp[NS].RRF then        //  -    ,    
          begin
            //   - (NS),    - MRF
            //   (NS) -   ,    - MRF_CS
            if RangRRF = rf_FULL_REPLACE  then
            begin
              Interp[NS].MRF:=Interp[NF].MWF_CS-TableRF[NFuncNF,NFuncNS].SHFT_R;
              Interp[NS].RRF:=rf_FULL_REPLACE;
            end
            else
            begin
              Interp[NS].MRF_CS:=Interp[NF].MWF_CS-TableRF[NFuncNF,NFuncNS].SHFT_R;
              Interp[NS].RRF:=RangRRF;
            end;

            B_RF:=True;
          end;
      end
      else             //- 
      begin

          RangRRF:=TableRF[NFuncNF,NFuncNS].RRF_R;        //  -  (NS)
          if RangRRF > Interp[NS].RRF then        //  -    ,    
          begin
            RFSize:=RFSize+TableRF[NFuncNF,NFuncNS].NMEM_R;      //-  
            Interp[NF].WRF_CS:=TableRF[NFuncNF,NFuncNS].WRF_R;   //     (NF)
            Interp[NF].MWF_CS:=RFSize;

            //   - (NS),    - MRF
            //   (NS) -   ,    - MRF_CS
            if RangRRF = rf_FULL_REPLACE  then
             begin
               Interp[NS].MRF:=Interp[NF].MWF_CS-TableRF[NFuncNF,NFuncNS].SHFT_R;
               Interp[NS].RRF:=rf_FULL_REPLACE;
             end
             else
             begin
               Interp[NS].MRF_CS:=Interp[NF].MWF_CS-TableRF[NFuncNF,NFuncNS].SHFT_R;
               Interp[NS].RRF:=RangRRF;
             end;

            B_RF:=True;
          end;
      end;
   end;
end
else
if Interp[NF].TypeF = T_Complex then
begin

   if TableRF[NFuncNF,NFuncNS].WRF_Z = rf_FULL_REPLACE  then   //  - (NF)
   begin
     inc(Interp[NF].NRF);  //  (^)
     if (Interp[NF].WRF = rf_FULL_REPLACE)  then        //    - (NF)
     begin
         RangRRF:=TableRF[NFuncNF,NFuncNS].RRF_Z;        //  -  (NS)

         if RangRRF > Interp[NS].RRF then        //  -    ,    
         begin
           //   - (NS),    - MRF
           //   (NS) -   ,    - MRF_CS
           if RangRRF = rf_FULL_REPLACE  then
           begin
              Interp[NS].MRF:=Interp[NF].MRF-TableRF[NFuncNF,NFuncNS].SHFT_Z;
              Interp[NS].RRF:=rf_FULL_REPLACE;
           end
           else
           begin
             Interp[NS].MRF_CS:=Interp[NF].MRF-TableRF[NFuncNF,NFuncNS].SHFT_Z;
             Interp[NS].RRF:=RangRRF;
           end;
           B_RF:=True;
         end;
     end
     else                                        //- 
     begin
       RangRRF:=TableRF[NFuncNF,NFuncNS].RRF_Z;        //  -  (NS)
       if RangRRF > Interp[NS].RRF then        //   -   ,    
       begin
          RFSize:=RFSize+TableRF[NFuncNF,NFuncNS].NMEM_Z;  //-  
          Interp[NF].WRF:=rf_FULL_REPLACE;   //   ,    - MRF
          Interp[NF].MRF:=RFSize;

           //   - (NS),    - MRF
           //   (NS) -   ,    - MRF_CS
           if RangRRF = rf_FULL_REPLACE  then
           begin
            Interp[NS].MRF:=Interp[NF].MRF-TableRF[NFuncNF,NFuncNS].SHFT_Z;
             Interp[NS].RRF:=rf_FULL_REPLACE;
           end
           else
           begin
            Interp[NS].MRF_CS:=Interp[NF].MRF-TableRF[NFuncNF,NFuncNS].SHFT_Z;
            Interp[NS].RRF:=RangRRF;
           end;
           Interp[NS].RRF:=RangRRF;
           B_RF:=True;
       end;
     end;

   end
   else    //  - (NF):   - MWF_CS
   begin
      if Interp[NF].WRF_CS = TableRF[NFuncNF,NFuncNS].WRF_Z then        //     -  (NF)
      begin
          RangRRF:=TableRF[NFuncNF,NFuncNS].RRF_Z;        //  -  (NS)
          if RangRRF > Interp[NS].RRF then        //  -    ,    
          begin
            //   - (NS),    - MRF
            //   (NS) -   ,    - MRF_CS
            if RangRRF = rf_FULL_REPLACE  then
            begin
              Interp[NS].MRF:=Interp[NF].MWF_CS-TableRF[NFuncNF,NFuncNS].SHFT_Z;
              Interp[NS].RRF:=rf_FULL_REPLACE;
            end
            else
            begin
              Interp[NS].MRF_CS:=Interp[NF].MWF_CS-TableRF[NFuncNF,NFuncNS].SHFT_Z;
              Interp[NS].RRF:=RangRRF;
            end;

            B_RF:=True;
          end;
      end
      else             //- 
      begin

          RangRRF:=TableRF[NFuncNF,NFuncNS].RRF_Z;        //  -  (NS)
          if RangRRF > Interp[NS].RRF then        //  -    ,    
          begin
            RFSize:=RFSize+TableRF[NFuncNF,NFuncNS].NMEM_Z;      //-  
            Interp[NF].WRF_CS:=TableRF[NFuncNF,NFuncNS].WRF_Z;   //     (NF)
            Interp[NF].MWF_CS:=RFSize;

            //   - (NS),    - MRF
            //   (NS) -   ,    - MRF_CS
            if RangRRF = rf_FULL_REPLACE  then
             begin
               Interp[NS].MRF:=Interp[NF].MWF_CS-TableRF[NFuncNF,NFuncNS].SHFT_Z;
               Interp[NS].RRF:=rf_FULL_REPLACE;
             end
             else
             begin
               Interp[NS].MRF_CS:=Interp[NF].MWF_CS-TableRF[NFuncNF,NFuncNS].SHFT_Z;
               Interp[NS].RRF:=RangRRF;
             end;

            B_RF:=True;
          end;
      end;
   end;
end ;

end
else
begin

 if  ((Interp[NF].NFunc = Interp[NS].NFunc) and (Interp[NF].NF = Interp[NS].NF))  then      //     
 begin

   if {Interp[NF].NRF = 0 } Interp[NF].WRF = rf_FULL_REPLACE then
   begin
         //    - (NF)
   end
   else   //- 
   begin
    if Interp[NF].TypeF = T_Real then
    begin
      RFSize:=RFSize+1;
      Interp[NF].MRF:=RFSize;
    end
    else
    if Interp[NF].TypeF = T_Complex then
    begin
      RFSize:=RFSize+2;
      Interp[NF].MRF:=RFSize;
    end
   end;

   Interp[NF].NRF:=Interp[NF].NRF+1;

   Interp[NF].WRF:=rf_FULL_REPLACE;
   Interp[NS].RRF:=rf_FULL_REPLACE;
   Interp[NS].MRF:=Interp[NF].MRF;


   B_RF:=True;
 end;

end;

*)



//if Interp[NF].TypeF = T_Real then
//begin

   GetReplaceData(NF,NS,Interp[NF].TypeF,RangW,RangR,NMem,MShft);

   if RangW = rf_FULL_REPLACE  then   //  - (NF)
   begin
     inc(Interp[NF].NRF);  //  (^)
     if (Interp[NF].WRF = rf_FULL_REPLACE)  then        //    - (NF)
     begin

         if RangR > Interp[NS].RRF then        //  -    ,    
         begin
           //   - (NS),    - MRF
           //   (NS) -   ,    - MRF_CS
           if RangR = rf_FULL_REPLACE  then
           begin
              Interp[NS].MRF:=Interp[NF].MRF-MShft;
              Interp[NS].RRF:=rf_FULL_REPLACE;
           end
           else
           begin
             Interp[NS].MRF_CS:=Interp[NF].MRF-MShft;
             Interp[NS].RRF:=RangR;
           end;
           B_RF:=True;
         end;
     end
     else                                        //- 
     begin
        if RangR > Interp[NS].RRF then        //   -   ,    
       begin
          RFSize:=RFSize+NMem;  //-  
          Interp[NF].WRF:=rf_FULL_REPLACE;   //   ,    - MRF
          Interp[NF].MRF:=RFSize;

           //   - (NS),    - MRF
           //   (NS) -   ,    - MRF_CS
           if RangR = rf_FULL_REPLACE  then
           begin
            Interp[NS].MRF:=Interp[NF].MRF-MShft;
            Interp[NS].RRF:=rf_FULL_REPLACE;
           end
           else
           begin
            Interp[NS].MRF_CS:=Interp[NF].MRF-MShft;
            Interp[NS].RRF:=RangR;
           end;

           B_RF:=True;
       end;
     end;

   end
   else    //  - (NF):   - MWF_CS
   begin
      if Interp[NF].WRF_CS = RangW then        //     -  (NF)
      begin
          if RangR > Interp[NS].RRF then        //  -    ,    
          begin
            //   - (NS),    - MRF
            //   (NS) -   ,    - MRF_CS
            if RangR = rf_FULL_REPLACE  then
            begin
              Interp[NS].MRF:=Interp[NF].MWF_CS-MShft;
              Interp[NS].RRF:=rf_FULL_REPLACE;
            end
            else
            begin
              Interp[NS].MRF_CS:=Interp[NF].MWF_CS-MShft;
              Interp[NS].RRF:=RangR;
            end;

            B_RF:=True;
          end;
      end
      else             //- 
      begin

           if RangR > Interp[NS].RRF then        //  -    ,    
          begin
            RFSize:=RFSize+NMem;      //-  
            Interp[NF].WRF_CS:=RangW;   //     (NF)
            Interp[NF].MWF_CS:=RFSize;

            //   - (NS),    - MRF
            //   (NS) -   ,    - MRF_CS
            if RangR = rf_FULL_REPLACE  then
             begin
               Interp[NS].MRF:=Interp[NF].MWF_CS-MShft;
               Interp[NS].RRF:=rf_FULL_REPLACE;
             end
             else
             begin
               Interp[NS].MRF_CS:=Interp[NF].MWF_CS-MShft;
               Interp[NS].RRF:=RangR;
             end;

            B_RF:=True;
          end;
      end;
   end;
//end
(*
else

if Interp[NF].TypeF = T_Complex then
begin
   GetReplaceData(NF,NS,T_Complex,RangW,RangR,NMem,MShft);

   if TableRF[NFuncNF,NFuncNS].WRF_Z = rf_FULL_REPLACE  then   //  - (NF)
   begin
     inc(Interp[NF].NRF);  //  (^)
     if (Interp[NF].WRF = rf_FULL_REPLACE)  then        //    - (NF)
     begin
         RangRRF:=TableRF[NFuncNF,NFuncNS].RRF_Z;        //  -  (NS)

         if RangRRF > Interp[NS].RRF then        //  -    ,    
         begin
           //   - (NS),    - MRF
           //   (NS) -   ,    - MRF_CS
           if RangRRF = rf_FULL_REPLACE  then
           begin
              Interp[NS].MRF:=Interp[NF].MRF-TableRF[NFuncNF,NFuncNS].SHFT_Z;
              Interp[NS].RRF:=rf_FULL_REPLACE;
           end
           else
           begin
             Interp[NS].MRF_CS:=Interp[NF].MRF-TableRF[NFuncNF,NFuncNS].SHFT_Z;
             Interp[NS].RRF:=RangRRF;
           end;
           B_RF:=True;
         end;
     end
     else                                        //- 
     begin
       RangRRF:=TableRF[NFuncNF,NFuncNS].RRF_Z;        //  -  (NS)
       if RangRRF > Interp[NS].RRF then        //   -   ,    
       begin
          RFSize:=RFSize+TableRF[NFuncNF,NFuncNS].NMEM_Z;  //-  
          Interp[NF].WRF:=rf_FULL_REPLACE;   //   ,    - MRF
          Interp[NF].MRF:=RFSize;

           //   - (NS),    - MRF
           //   (NS) -   ,    - MRF_CS
           if RangRRF = rf_FULL_REPLACE  then
           begin
            Interp[NS].MRF:=Interp[NF].MRF-TableRF[NFuncNF,NFuncNS].SHFT_Z;
             Interp[NS].RRF:=rf_FULL_REPLACE;
           end
           else
           begin
            Interp[NS].MRF_CS:=Interp[NF].MRF-TableRF[NFuncNF,NFuncNS].SHFT_Z;
            Interp[NS].RRF:=RangRRF;
           end;
           Interp[NS].RRF:=RangRRF;
           B_RF:=True;
       end;
     end;

   end
   else    //  - (NF):   - MWF_CS
   begin
      if Interp[NF].WRF_CS = TableRF[NFuncNF,NFuncNS].WRF_Z then        //     -  (NF)
      begin
          RangRRF:=TableRF[NFuncNF,NFuncNS].RRF_Z;        //  -  (NS)
          if RangRRF > Interp[NS].RRF then        //  -    ,    
          begin
            //   - (NS),    - MRF
            //   (NS) -   ,    - MRF_CS
            if RangRRF = rf_FULL_REPLACE  then
            begin
              Interp[NS].MRF:=Interp[NF].MWF_CS-TableRF[NFuncNF,NFuncNS].SHFT_Z;
              Interp[NS].RRF:=rf_FULL_REPLACE;
            end
            else
            begin
              Interp[NS].MRF_CS:=Interp[NF].MWF_CS-TableRF[NFuncNF,NFuncNS].SHFT_Z;
              Interp[NS].RRF:=RangRRF;
            end;

            B_RF:=True;
          end;
      end
      else             //- 
      begin

          RangRRF:=TableRF[NFuncNF,NFuncNS].RRF_Z;        //  -  (NS)
          if RangRRF > Interp[NS].RRF then        //  -    ,    
          begin
            RFSize:=RFSize+TableRF[NFuncNF,NFuncNS].NMEM_Z;      //-  
            Interp[NF].WRF_CS:=TableRF[NFuncNF,NFuncNS].WRF_Z;   //     (NF)
            Interp[NF].MWF_CS:=RFSize;

            //   - (NS),    - MRF
            //   (NS) -   ,    - MRF_CS
            if RangRRF = rf_FULL_REPLACE  then
             begin
               Interp[NS].MRF:=Interp[NF].MWF_CS-TableRF[NFuncNF,NFuncNS].SHFT_Z;
               Interp[NS].RRF:=rf_FULL_REPLACE;
             end
             else
             begin
               Interp[NS].MRF_CS:=Interp[NF].MWF_CS-TableRF[NFuncNF,NFuncNS].SHFT_Z;
               Interp[NS].RRF:=RangRRF;
             end;

            B_RF:=True;
          end;
      end;
   end;

end ;
*)





fin:
//    =CM_NOP
if B_RF = True  then
begin
  S:=Interp[NS].S;
  FN:=GetFirstNode(NS);  //  ( ) =  (  Interp.[FN]); (  Interp.[NS] -  )
  for i:=FN to NS-1 do
  begin
    Interp[i].N:=0;
    Interp[i].NFunc:=CM_NOP;
    Interp[i].NF:=0;{.197}
    Interp[i].TypeF:=0;
    Interp[i].COP:=_NOP;   //    
    Interp[i].RRF:=rf_NO_REPLACE;//???????
    //FuncList[Interp[i].Code].FType:=0;
  end;
  inc(Db_ReplFuncNum);
end;

{
 if (NFuncNF = CM_DIV) or (NFuncNF = CM_MUL) or (NFuncNF = CM_SUB) or (NFuncNF = CM_ADD) then inc(Db_ReplOpNum)
 else inc(Db_ReplFuncNum);  }


endp:
end;





procedure TForevalH.GetReplaceData(NF,NS,VType: integer; var RangW,RangR,NMem,MShft: Integer);
var
 NFuncNF,NFuncNS,NFF,NFS: Cardinal;
begin

NFuncNF:=Interp[NF].NFunc;
NFuncNS:=Interp[NS].NFunc;
NFF:=Interp[NF].NF;
NFS:=Interp[NS].NF;

RangW:=rf_NO_REPLACE;
RangR:=rf_NO_REPLACE;
MShft:=0;
NMem:=0;

if (Interp[NF].NFunc <= High(TableRF)) and (Interp[NS].NFunc <= High(TableRF))  then   //    (full+composite)
begin
  if VType = T_Real then
  begin
     RangW:=TableRF[NFuncNF,NFuncNS].WRF_R;
     RangR:=TableRF[NFuncNF,NFuncNS].RRF_R;
     MShft:=TableRF[NFuncNF,NFuncNS].SHFT_R;
     NMem:=TableRF[NFuncNF,NFuncNS].NMEM_R;
  end
  else
  if VType = T_Complex then
  begin
     RangW:=TableRF[NFuncNF,NFuncNS].WRF_Z;
     RangR:=TableRF[NFuncNF,NFuncNS].RRF_Z;
     MShft:=TableRF[NFuncNF,NFuncNS].SHFT_Z;
     NMem:=TableRF[NFuncNF,NFuncNS].NMEM_Z;
  end;

end
else
if  ((Interp[NF].NFunc = Interp[NS].NFunc) and (Interp[NF].NF = Interp[NS].NF))  then      //     
 begin

  if VType = T_Real then
  begin
     RangW:=rf_FULL_REPLACE;
     RangR:=rf_FULL_REPLACE;
     MShft:=0;
     NMem:=1;
  end
  else
  if VType = T_Complex then
  begin
     RangW:=rf_FULL_REPLACE;
     RangR:=rf_FULL_REPLACE;
     MShft:=0;
     NMem:=2;
  end;
end;

end;




procedure TForevalH.DelVoidSave;
var
 BRF: Boolean;
 NRF,NS,ND,NV: Cardinal;
begin

//NS->ND
NV:=0;
for NS := 0 to LFunc-1 do
begin
  BRF:=False;

  if (Interp[NS].NFunc <> CM_NOP) and (Interp[NS].WRF = rf_FULL_REPLACE) then
  begin
   for ND := NS to LFunc-1 do
   begin                                                                                           {.219}
     if (Interp[ND].RRF = rf_FULL_REPLACE) and (Interp[NS].MRF = Interp[ND].MRF) and (Interp[NS].MRF >= 0) {and (Interp[ND].NFunc <> CM_NOP)}  then
     begin
       BRF:=True;
     end;
   end;
  end;

  if BRF = False then
  begin
    Interp[NS].WRF:=rf_NO_REPLACE;
    Interp[NS].NRF:=0;
    inc(NV);
  end;

end;

end;





procedure TForevalH.DelVoidSaveCF;
var
 BRF: Boolean;
 NRF,NS,ND,NV: Cardinal;
begin

//NS->ND
NV:=0;
for NS := 0 to LFunc-1 do
begin
  BRF:=False;

  if (Interp[NS].NFunc <> CM_NOP) and ((Interp[NS].WRF <> rf_NO_REPLACE) or (Interp[NS].WRF_CS <> rf_NO_REPLACE)) then
  begin
   for ND := NS to LFunc-1 do
   begin
     if (Interp[ND].RRF <>  rf_NO_REPLACE) and
        (
          ((Interp[NS].MRF = Interp[ND].MRF)       and (Interp[NS].MRF >=0))     or
          ((Interp[NS].MRF = Interp[ND].MRF_CS)    and (Interp[NS].MRF >= 0))    or
          ((Interp[NS].MRF_CS = Interp[ND].MRF_CS) and (Interp[NS].MRF_CS >= 0)) or
          ((Interp[NS].MRF_CS = Interp[ND].MRF)    and (Interp[NS].MRF_CS >= 0))
        )  then
     begin
       BRF:=True;
     end;
   end;
  end;

  if BRF = False then
  begin
    Interp[NS].WRF:=rf_NO_REPLACE;
    Interp[NS].NRF:=0;
    inc(NV);
  end;

end;
end;




function TForevalH.GetFirstNode(num: Integer): Cardinal;
label repf,endp;
var
j,IdN: Integer;
CS,FN: Cardinal;
ANL: TArrayC;
begin

 {$IFDEF TEXTOUT}
   if num = LFunc-1 then
     G_Test2:={G_Test2+}Interp[num].IdL;
 {$ENDIF}
                                               //(2^3)*4+(2^3)*4
                                               //(2+3)*4+(2+3)*4
FN:=num;
IdN:=Interp[num].IdN;

repf:
for j:=1 to LFunc-1 do
begin
   if Interp[j].IdL = IdN then
   begin
    if Interp[j].N = 0 then      //N = 0  <=>   Interp[j].COP = _LDSC, LDSCX, _LDSF
    begin
      FN:=j; goto endp;
    end
    else
    begin
      IdN:=Interp[j].IdN;
      goto repf;
    end;
   end;
end;


endp:
GetFirstNode:=FN;

end;






procedure TForevalH.FindNonReplFunc(Sf: String; var BH: Boolean);
label endp;
var
k,l: Integer;
Sf1,Sfn: String;
BH1: Boolean;
begin

BH:=False;

Sf1:=Sf;

if F_SyntaxExtension = True then
begin

 for k:=0 to High(Alg.ExFunc) do
 begin

   if (Alg.ExFunc[k].ReplFunc = _No) and (Alg.ExFunc[k].Enable <> _No) then
   begin
      FindFuncInExpr(k,Sf1,BH1);
      if BH1 = True then
      begin
        BH:=True;
        goto endp;
      end;

   end;

 end

end
else
for k:=0 to High(Alg.ExFunc) do
 begin
    if (Alg.ExFunc[k].ReplFunc = _No) and (Alg.ExFunc[k].Enable <> _No) then
    begin
        FindFuncInExpr(k,Sf1,BH1);
        if BH1 = True then
        begin
          BH:=True;
          goto endp;
        end;
    end;
 end;


endp:
end;




procedure  TForevalH.FindFuncInExpr(k: Integer; Sexpr: String; var BH: Boolean);
label endp;
var
FName: set of  Char;
Sfn: String;
i,P,L,LF: integer;
begin
FName:=['(','{','[','|','*','/','>','<','=','+','^','-',',',';'];

BH:=False;

if F_SyntaxExtension = True then LF:= Length(Alg.ExFunc[k].NameEx)-1 else LF:=1;

  for i:=0 to LF do
     begin
         Sfn:=Alg.ExFunc[k].NameEx[i];

         P:=Pos(Sfn,SExpr);
         if P > 0 then
         begin
           L:=Length(Sfn);

           if (SExpr[L+P] = '(') then
           begin
               if (P = 1)  then
               begin
                 BH:=True;
                 goto endp;
               end
               else
               begin
                  if SExpr[P-1] in FName = True then
                  begin
                    BH:=True;
                    goto endp;
                  end
               end;
           end;

         end;
     end;

endp:
end;






function TForevalH.FindIfFunc: Boolean;
label endp;
var
i: Integer;
begin
 for i:=1 to Length(Interp)-1 do
 begin
  if (Interp[i].NFunc = CM_IF) or  (Interp[i].NFunc = CM_JMP)
  then  begin FindIfFunc:=True; goto endp; end;
 end;

FindIfFunc:=False;

endp:
end;








{.191}
procedure TForevalH.FreeFuncList;
var
i,j: Integer;
begin

 for i:=0 to High(Alg.ExFunc) do
  begin
    for j := 0 to High(Alg.ExFunc[i].NameEx) do
    begin
       Alg.ExFunc[i].NameEx[j]:='';
     end;
     Alg.ExFunc[i].NameEx:=nil;
  end;


end;



constructor TForevalH.Create;
begin
//inherited Create(AOwner);
GetLocaleFormatSettings(0,G_FMT);
G_FMT.DecimalSeparator:='.';
CreateInitData;
end;


destructor TForevalH.Destroy;
begin
FreeFuncList;
Alg.Obj:=nil;
Alg.Opr:=nil;
Alg.ExFunc:=nil;

Factorial:=nil;
inherited Destroy;
end;



procedure TForevalH.FreeTree;
label endp;
var
H: PNode;
begin
if Tree = nil then goto endp;
Tree:=BeginTree;

while Tree^.Ch <> nil do
begin
Tree:=Tree^.Ch;
end;
//COP=NOP

while Tree^.Pr <> nil do
begin
 while Tree^.Nb <> nil  do
 begin
  H:=Tree; Tree:=Tree^.Nb;  H^.Nb:=nil;
  H^.RData:=nil;
  H^.Expression:='';   H^.ExpressionArg:='';
  dispose(H);
  while Tree^.Ch <> nil do
  begin
  Tree:=Tree^.Ch;
  end;
 //COP=NOP
 end;

//COP<>NOP
H:=Tree; Tree:=Tree^.Pr; H^.Pr:=nil;
H^.RData:=nil;
H^.Expression:='';   H^.ExpressionArg:='';
dispose(H);
end;
{.193}
Tree^.RData:=nil;
Tree^.Expression:='';   Tree^.ExpressionArg:='';
dispose(Tree);


Tree:=nil;
BeginTree:=nil;
endp:
end;



procedure TForevalH.RenameFunction(Name,NewName: String);
label endp;
var
i: Integer;
begin

  for i:=0 to High(Alg.ExFunc) do
  begin
   if Name = Alg.ExFunc[i].Name then
   begin
    Alg.ExFunc[i].Name:=Copy(NewName,1,Length(NewName));
    goto endp;
   end;
  end;

endp:
end;



procedure TForevalH.IntException;
var
S: String;
T: Integer;
begin


if F_BeginCalc = 0 then
begin
 {on E: EZeroDivide      do F_InternalError:=1;
 on E: EInvalidOp       do F_InternalError:=2;
 on E: EOverFlow        do F_InternalError:=3;
 on E: EUnderFlow       do F_InternalError:=4;
 on E: EIntOverFlow     do F_InternalError:=5;
 on E: EAccessViolation do F_InternalError:=6;
 on E: EOutOfMemory     do F_InternalError:=7;
 on E: EStackOverFlow   do F_InternalError:=8;}
 {if E.ClassType  = EZeroDivide       then F_InternalError:=1
 else
 if E.ClassType =  EInvalidOp        then F_InternalError:=2
 else
 if E.ClassType =  EOverFlow         then F_InternalError:=3
 else
 if E.ClassType =  EUnderFlow        then F_InternalError:=4
 else
 if E.ClassType =  EIntOverFlow      then F_InternalError:=5
 else
 if E.ClassType =  EAccessViolation  then F_InternalError:=6
 else
 if E.ClassType =  EOutOfMemory      then F_InternalError:=7
 else
 if E.ClassType =  EStackOverFlow    then F_InternalError:=8;
 }
end

else
if F_SyntaxErrorCode = 0 then
begin
 {if E.ClassType  = EZeroDivide       then F_CalcErrorCode:=1
 else
 if E.ClassType =  EInvalidOp        then F_CalcErrorCode:=2
 else
 if E.ClassType =  EOverFlow         then F_CalcErrorCode:=3
 else
 if E.ClassType =  EUnderFlow        then F_CalcErrorCode:=4
 else
 if E.ClassType =  EIntOverFlow      then F_CalcErrorCode:=5
 else
 if E.ClassType =  EAccessViolation  then F_CalcErrorCode:=6;}

 F_BeginCalc:=0;
end;



if (F_InternalError <> 0) and ((F_SyntaxErrorCode = 0 ) or (F_SyntaxErrorCode = E_INTERNAL_ERROR )) then
 begin

  {.195}
  if (F_InternalError = E_ZeroDivide) or (F_InternalError = E_InvalidOp) or (F_InternalError = E_OverFlow) then
  begin
    F_SyntaxErrorString:=F_CurrentSubExpr;
    F_SyntaxErrorCode:= E_ERROR_AT_CALCULATION;  S:='INTERNAL ERROR AT CALCULATION';
  end
  else
  F_SyntaxErrorCode:= E_INTERNAL_ERROR;  S:='INTERNAL ERROR OR UNCATCHABLE SYNTAX ERROR';

 end;


if (F_CalcErrorCode <> 0) and (F_SyntaxErrorCode = 0 ) then
 begin
  F_SyntaxErrorCode:= E_ERROR_AT_CALCULATION;  S:='INTERNAL ERROR AT CALCULATION';
 end;


{
  fzSet(fz_ENABLE,fz_SHOW_EXCEPTION);
  fzSet(fz_DISABLE,fz_SHOW_EXCEPTION);

  allows/forbids to show an exception in case of a error  from '.dll'
}


if F_ShowException then
begin
 MessageBeep(MB_ICONHAND);
 {.155}
 (*if F_CalcErrorCode <> 0 then
 begin
  //MessageDlg('Calculation Error',mtError,[mbOk],0)
  MessageBox(0,PChar(S+#13+#10+'"'+'Calculation Error'+'"'),PChar('ForevalZ error'),MB_ICONERROR);
 end
 else*)
 if (F_SyntaxErrorCode <> 0) {and (F_SyntaxErrorCode <> 12)} then
 begin
  case F_SyntaxErrorCode of
    E_UNKNOWN_SYMBOL:                          S:='UNKNOWN SYMBOL or INCORRECT ARGUMENT or WRONG EXPRESSION';
    E_MISSING_ROUND_BRACKET:                   S:='MISSING ROUND BRACKET';
    E_MISSING_OPERATION:                       S:='MISSING OPERATION:';
    E_INCOINCIDENCE_NUMBER_OF_ARGUMENTS:       S:='INCOINCIDENCE NUMBER OF ARGUMENTS:';
    E_MISSING_EXPRESSION:                      S:='MISSING EXPRESSION:';
    E_UNKNOWN_FUNCTION:                        S:='UNKNOWN FUNCTION:';
    E_ABSENT_FUNCTION_FOR_LOAD_TYPE:           S:='ABSENT FUNCTION FOR LOAD TYPE:';
    E_NOT_DEFINED_OPERATION_FOR_TYPE:          S:='NOT DEFINED OPERATION '+'"'+F_SyntaxErrorStringA+'"'+' FOR TYPES:';
    E_NOT_DEFINED_FUNCTION_FOR_TYPE:           S:='NOT DEFINED FUNCTION '+'"'+F_SyntaxErrorStringA+'"'+' FOR TYPES:';
    E_INTERNAL_ERROR:                          S:='INTERNAL ERROR or  UNCATCHABLE SYNTAX ERROR';
    E_ERROR_AT_ADDITION_OF_FUNCTION:           S:='ERROR AT ADDITION OF FUNCTION';
    E_WRONG_TYPE:                              S:='WRONG TYPE';
    E_WRONG_NAME:                              S:='WRONG NAME';
    E_MISSING_SQUARE_BRACKET:                  S:='MISSING SQUARE BRACKET';
    E_MISSING_CURLY_BRACKET:                   S:='MISSING CURLY BRACKET';
    E_MISSING_ABS_BRACKET:                     S:='MISSING ABS BRACKET';
    E_MISSING_SEPARATOR:                       S:='MISSING SEPARATOR';
    E_WRONG_EXPRESSION:                        S:='WRONG EXPRESSION';
    E_ERROR_AT_CALCULATION:                    S:='INTERNAL ERROR AT CALCULATION';
    E_INCORRECT_ARGUMENT:                      S:='WRONG TYPE OF ARGUMENT'+'"'+F_SyntaxErrorStringA+'"';
    E_INCORRECT_SPACE:                         S:='INCORRECT SPACE';
    E_VARIABLE_REDECLARED:                     S:='VARIABLE REDECLARED';
  end;




  //MessageDlg(S+#13+#10+'"'+F_SyntaxErrorString+'"',mtError,[mbOk],0)
  MessageBox(0,PChar(S+#13+#10+'"'+F_SyntaxErrorString+'"'),PChar('ForevalZ error'),MB_ICONERROR);
 end
 {.155}
 (*else
 if F_InternalError <> 0  then
 //MessageDlg('Internal Error',mtError,[mbOk],0)
 MessageBox(0,PChar(S+#13+#10+'"'+'Internal Error'+'"'),PChar('ForevalZ error'),MB_ICONERROR);
 *)
end;




//if F_SyntaxErrorCode = 8  then F_SyntaxErrorString:=F_SyntaxErrorString1+'('+F_SyntaxErrorString+')';
//if F_SyntaxErrorCode = 9  then F_SyntaxErrorString:=F_SyntaxErrorString1+'('+F_SyntaxErrorString+')';
end;




procedure TForevalH.SetLoadMem(I: Integer);
var
NL,NM: Integer;
S,S1: String;
begin
 Interp[I].SData:=_MEM;
 NM:=Interp[I].NM;
 NL:=Interp[I].NL;
 Interp[NM].RData[NL-1]:=_MEM;

 //S:=Interp[i].Expression;        //db
 //S1:=Interp[NM].Expression;      //db
 inc(Db_DinLoadNMem);

end;




function TForevalH.EnableDL(I: Integer): Boolean;
var
ifn: Integer;
NL,NM,NF,N: Integer;
begin
//False -       
//COP = NOP
//  -  FPU
(*if {Internal}FuncList[Interp[Interp[I].NM].Code].FType = -8 then EnableDL:=False
else
if Interp[I].Code = C_NOP then  EnableDL:=False
else
EnableDL:=True;*)

//EnableDL:=True;
//{.213}-   ,   
NM:=Interp[I].NM;
//NL:=Interp[I].NL;
N:=Interp[NM].NFunc;
NF:=Interp[NM].NF;
if Alg.ExFunc[N].Func[NF].TypeF = T_None then EnableDL:=False else EnableDL:=True;
end;


procedure TForevalH.SetNM;
label endp;
var
N: Integer;
HTree: PNode;
S: String;
begin
//  NM:    , ..: Interp[Interp[i].NM]  -
// ,  i -   (-   MUL,ADD,JMP)


if F_SyntaxErrorCode <> 0 then goto endp;

//new(Interp[0]);
Tree:=BeginTree; // , ..   - 


while Tree^.Ch <> nil do
begin
Tree:=Tree^.Ch;
end;
//COP=NOP:
N:=1;

while Tree^.Pr <> nil do
begin
  while Tree^.Nb <> nil  do
  begin
    Tree:=Tree^.Nb;
    while Tree^.Ch <> nil do
    begin
      Tree:=Tree^.Ch;
    end;
    //COP=NOP:
    inc(N);
  end;

 //COP<>NOP:
 S:=Tree^.Expression;
 Tree:=Tree^.Pr;
 inc(N);
 HTree:=Tree^.Ch;
 HTree^.NM:=N;
 HTree:=HTree^.Nb;
 while HTree <> nil do
 begin
  HTree^.NM:=N;
  HTree:=HTree^.Nb;
 end;

end;
Tree^.NM:=0;

endp:
end;






procedure TForevalH.SetNL;
label endp;
var
N: Integer;
HTree: PNode;
S: String;
begin
//  NL:     ;


if F_SyntaxErrorCode <> 0 then goto endp;

Tree:=BeginTree; // , ..   - 


while Tree^.Ch <> nil do
begin
Tree:=Tree^.Ch;
end;
//COP=NOP:

while Tree^.Pr <> nil do
begin
 while Tree^.Nb <> nil  do
 begin
 Tree:=Tree^.Nb;
  while Tree^.Ch <> nil do
  begin
  Tree:=Tree^.Ch;
  end;
 //COP=NOP:
 inc(N);
end;

//COP<>NOP:
 S:=Tree^.Expression;
 Tree:=Tree^.Pr;
 N:=1;
 HTree:=Tree^.Ch;
 HTree^.NL:=N;
 HTree:=HTree^.Nb;
 while HTree <> nil do
 begin
  inc(N);
  HTree^.NL:=N;
  HTree:=HTree^.Nb;
 end;

end;

//  '0' !!!
Tree^.NL:=0;
endp:
end;





// : SData,RData[i] = _FPU
procedure TForevalH.SetLoadSource;
label endp;
var
i,LS,N: Integer;
HTree: PNode;
S: String;
begin
// : SData,RData = _FPU  XCHA=0
LS:=_FPU;
if F_SyntaxErrorCode <> 0 then goto endp;

Tree:=BeginTree; // , ..   - 

while Tree^.Ch <> nil do
begin
Tree:=Tree^.Ch;
end;
//COP=NOP:
Tree^.SData:=LS;
Tree^.RData:=nil;

while Tree^.Pr <> nil do
begin
 while Tree^.Nb <> nil  do
 begin
 Tree:=Tree^.Nb;
  while Tree^.Ch <> nil do
  begin
  Tree:=Tree^.Ch;
  end;
 //COP=NOP:
 Tree^.SData:=LS;
 Tree^.RData:=nil;
end;

//COP<>NOP:
 Tree:=Tree^.Pr;
 Tree^.SData:=LS;
 N:=Tree^.Stack.N;
 SetLength(Tree^.RData,N);
 for i:=0 to High(Tree^.RData) do
 begin
  Tree^.RData[i]:=LS;
 end;

 //S:=Tree^.Expression;
end;

Tree^.SData:=_FPU;

endp:
end;






procedure TForevalH.InitDL;
begin
 N_Stack:=0;
 SMAX:=0;
 StackSize:=8;
  _MaxStack:=0;
 ES_Overflow:=False;
 //F_SaveInFPU:=True;
 //F_Mode:=Mode;
 F_EnableCheckStack:=True;
 F_Mode:=M_DinamicLoad;   {.197}
 //Db_DinLoadNMem:=0;
 LFunc:=Length(Interp); {.213}
 F_JMP:=1;     {.213}
end;


procedure TForevalH.DinamicLoadOptimizator;
label 1,beginp,endp;
var
i,Pn,PML,ML,CNT,k,t2: Integer;
S,S1: String;
begin
if F_SyntaxErrorCode <> 0 then goto endp;

InitDL;
{F_Opt:=True;}
F_Mode:=M_DinamicLoad;
Db_DinLoadNMem:=0;
//if  F_DinamicLoadOptimization = _Enable then goto beginp;
//if  F_DinamicLoadOptimization = _Auto then
begin
 Db_DinLoadSDeep:=E_GetMaxStackEx;
 if Db_DinLoadSDeep > F_StackDeep then goto beginp else goto endp;
end;


LFunc:=Length(Interp);
beginp:
//CNT:=0;
if F_SyntaxErrorCode <> 0 then goto endp;
PML:=0; PN:=0;
1:
InitDL;
for i:=1 to LFunc-1 do
begin
  //S:=Interp[i].Expression;      //db

  ML:=E_GetMaxLoadDL(I);

  {    -    (I-1)  , 
       (I-2,...1)     ,  
       (I)}
  if {(ML = PML)}(ML > F_StackDeep) and (PN = I) then
  begin
   for k:=I-2 downto 1 do
   begin
     if Interp[k].SData = _FPU then
     begin
      if EnableDL(k) then
      begin
       SetLoadMem(k);
       goto 1;
      end;

     end;
   end;
    Db_DinLoadOverFlow:=True;
    //   (,      < F_StackDeep:
   goto endp;
  end;

  {      ,  -  (I-1) 
    : (..   1  )}
  if ML > F_StackDeep then
  begin
   if I = 1 then
   begin
    Db_DinLoadOverFlow:=True;
    //  :
    goto endp;
   end;
   if EnableDL(I-1) then
   begin
    SetLoadMem(I-1);
    PML:=ML;
    PN:=I;
    goto 1;
   end;
  end;


end;


endp:
if  (F_SaveInFPU = True) and (Db_DinLoadOverFlow = True) then
begin
  N_Stack:=0;
  _MaxStack:=0;
  ES_OverFlow:=False;
  F_SaveInFPU:=False;
  //FreeData;
  //Db_OverFlow:=True;
end;

//F_Opt:=False;
end;




function TForevalH.E_GetMaxLoadDL(I: Integer): Integer;
begin
 E_SetNodeDL(I);
 E_GetMaxLoadDL:=SMAX;
 //SetLength(ICOMP,0);  {.197}
end;




procedure TForevalH.E_SetNodeDL(I: Integer);
var
Expr: String;
begin
//Expr:=Interp[i].Expression; //db

NFunc:=I; //NFunc

SMAX:=N_Stack;
//N1_Stack:=N_Stack;
AddCommand(I);
//AddEndCommand(I);
//SetLength(ICOMP,0);{.197}
end;




function TForevalH.E_GetMaxStackEx: Integer;
var
i: Integer;
begin
 for i:=1 to High(Interp) do
 begin
  E_SetNodeDL(i);
 end;
 E_GetMaxStackEx:=_MaxStack;
 //SetLength(ICOMP,0);   {.197}
end;


procedure TForevalH.CheckStack(N: Integer);
begin
 {$IFDEF DEBUGS}
    if N > 0  then dbFPULoad:=N+dbFPULoad;  //db
 {$ENDIF}

if F_EnableCheckStack then
 N_Stack:=N_Stack+N;

if N_Stack > StackSize then
begin
ES_OverFlow:=True;
end;


if N_Stack > _MaxStack
  then _MaxStack:=N_Stack;

if N_Stack > SMAX then SMAX:=N_Stack;

end;



procedure TForevalH.Compile;
label 1,2,endp;
var
i,j,N,alg,db,db1: Integer;
AH,AB: TArray4;
R: TFloat;
P: Pointer;
X: TFloat;
CS,LCode: Cardinal;
ANL: TArrayC;
S,S1: String;
AdrCmpl,AdrD,AdrS: Pointer;
AdrTst: TAddress;
begin
if F_SyntaxErrorCode <> 0 then goto endp;
//   ..     F_SaveInFPU:
N_Stack:=0;
_MaxStack:=0;
//F_Opt:=False;
F_ExtFunc:=False;
ES_OverFlow:=False;
F_Mode:=M_Compile;   {.197}

    {$IFDEF DEBUGS}
       dbMaxLoadCom:=0;
       TestZ.Form1.MT.Lines.Add('***********************************************************');
    {$ENDIF}

1:
new(FuncData); FuncData^.Next:=nil; BFuncData:=FuncData;
LFunc:=Length(Interp);
SetLength(ICOMP,0);

for I := 1 to 8 do
begin
 REG[i]:=0;
 REGF[i]:=0;
end;


SetLength(GotoLab,0);

CS:=0;
F_JMP:=1;
TE_ADDR:=0;

//PUSHAD;
for i:=1 to LFunc-1 do               //(sin(z1/z2)+cos(x)^(z1/z2))
begin
  if Interp[i].COP <> _NOP then     //COP=_NOP:      //for(j,0,1,t=(x^2+x)*(x^2+x) ); t

   begin
     {$IFDEF DEBUGS}
       S:=Interp[i].Expression;
       db1:=Interp[i].SData1;
       if db1 = _MEM then S1:='SaveRes:MEM'  else if db1 = _FPU then S1:='SaveRes:FPU';
       dbFPUBefore:=N_Stack; dbFPULoad:=0;
     {$ENDIF}
  S:=Interp[i].Expression;
  //for(j,0,1,t=(x^2+x)*(x^2+x) ); t

  NFunc:=i;
  Interp[i].NC:=Length(ICOMP);

  AddCommand(i);
  Interp[i].NCP:=Length(ICOMP);
  CS:=Length(ICOMP)-CS;
  Interp[i].CS:=CS+GetLevelsCS(i);
  CS:=Length(ICOMP);

    {$IFDEF DEBUGS}
      dbMaxLoadCom:=dbFPUBefore+dbFPULoad;
      TestZ.Form1.MT.Lines.Add('"'+S+'"   '+S1+'    loadFPUafter:'+IntToStr(N_Stack)+ '    MaxLoadFPU:'+IntToStr(_MaxStack{dbMaxLoadCom}));
    {$ENDIF}
  end;
end;


//   jmp adr
F_JMP:=2;
for i:=1 to LFunc-1 do
begin
  NFunc:=i;
  //if Interp[i].COP = _JMP then JMP_C(i);
  if Interp[i].NFunc = CM_JMP then JMP_C;
end;

SaveReg;
RET;
//POPAD;


if  (F_SaveInFPU = True) and (_MaxStack > 8) and ({F_Opt = False}F_Mode=M_Compile) then
begin
//        DinamicLoadOptimizator:   Load FPU => )
  N_Stack:=0;
  _MaxStack:=0;
  ES_OverFlow:=False;
  FreeData;
  //Db_OverFlow:=True;
  F_SaveInFPU:=False;
  Db_DinLoadOverFlow:=True;
  //S:=CurrentExpression;
  goto 1;
end;



if F_UseVirtAlloc = False then    {.193}
begin
  //   alg:
  alg:=16;
  SetLength(Func.Code,Length(ICOMP)+alg+1);
  for i:=0 to alg+1  do
  begin
   if Cardinal(@Func.Code[i]) mod alg = 0 then
   begin
    NAdr:=i;
    goto 2;
   end;
  end;
  2:
  for i:=0 to High(ICOMP) do begin
   Func.Code[i+NAdr]:=ICOMP[i];
  end;

  Func.Addr:=TAddress(@Func.Code[NAdr]);     {.193}
  Func.PAddr:=@Func.Code[NAdr];
  Func.CodeSize:=Length(ICOMP);
  Func.AllocMem:=1;
end
else   
{
  fzSet(fz_ENABLE, fz_USE_VIRTUAL_ALLOC); 
  allows memory for the  code  is allocated  out  by  the system command  instead: command 'SetLength' in a dynamic array.
{
//F_VirtAlloc = True   {.193}
begin     //only for WinXP SP2+;  memory alloc. only for exe code. Use, only if is any errors with standard memory allocating   (SetLength)
  LCode:=Length(ICOMP);
  AdrD:=VirtualAlloc(Nil, LCode, MEM_COMMIT or MEM_RESERVE, PAGE_EXECUTE_READWRITE);
  AdrS:=@ICOMP[0];
  CopyMemory(AdrD,AdrS,LCode);
  Func.Addr:=TAddress(AdrD);
  Func.PAddr:=AdrD;
  Func.CodeSize:=LCode;
  Func.AllocMem:=2;
end;

ICOMP:=nil;
Func.Data:=BFuncData;

//PInteger(AdrCmpl)^:=Func.Addr;
{AdrTst:=Func.Addr;
asm
  push eax
  mov eax, AdrTst
  call eax

  pop  eax

end;  }

endp:
end;


procedure TForevalH.RET;
begin
AddByte($C3);
end;




procedure TForevalH.AddCommand(I: Integer);
label endp,extf;
var
N,NF,RType,S,R,SDeep: Integer;
Expr: String;
begin

//Expr:=Interp[i].Expression; //db

S:=Interp[I].S;
N:=Interp[NFunc].NFunc;
NF:=Interp[NFunc].NF;
InitMEM(Cardinal(@Interp[NFunc].MEM));

if Interp[I].COP = _LDSC then
begin
 FLD(WriteData(I),F_DataType);
end
else
if Interp[I].COP = _LDSCX then
begin
  if Interp[I].TC = C_Real then
  begin
    FLD(WriteDataA(Interp[I].FDC.re,F_DataType),F_DataType)
  end
  else
  if Interp[I].TC = C_Image then
  begin
    FLD(WriteDataA(Interp[I].FDC.im,F_DataType),F_DataType);
    FLDZ;
  end
  else
  if Interp[I].TC = C_Complex then
  begin
    FLD(WriteDataA(Interp[I].FDC.im,F_DataType),F_DataType);
    FLD(WriteDataA(Interp[I].FDC.re,F_DataType),F_DataType);
  end;
end
else
if Interp[I].COP = _LDSF then
begin
 N:=Interp[I].NObj;
 LDSF_C(N);
end
{else
if Interp[I].COP = _JMP then
begin
 JMP_C(I);
end  }
else
if Interp[I].COP = _FLD then
begin
 FLD_C(I);
end
else
if Interp[I].COP = _FUNC then
begin

 N:=Interp[I].NFunc;
 NF:=Interp[I].NF;

 if ReadReplFunc(I) = True then   goto endp;       {.193}

 if Alg.ExFunc[N].Func[NF].IntF = 0 then goto extf;

 case N of            //   Alg.ExtFunc[N]
      CM_ADD:       ADD_C;
      CM_SUB:       SUB_C;
      CM_MUL:       MUL_C;
      CM_DIV:       DIV_C;
      CM_POWER:     POWER_C;
      CM_LOGN:      LOGN_C;
      CM_NEG:       NEG_C;
      CM_ABS:       ABS_C;
      CM_RE:        RE_C;
      CM_IM:        IM_C;
      CM_ARG:       ARG_C;
      CM_SIN:       SIN_C;
      CM_COS:       COS_C;
      CM_TAN:       TAN_C;
      CM_COTAN:     COTAN_C;
      CM_SEC:       SEC_C;
      CM_COSEC:     COSEC_C;
      CM_ARCCOS:    ARCCOS_C;
      CM_ARCSIN:    ARCSIN_C;
      CM_ARCTAN:    ARCTAN_C;
      CM_ARCCOTAN:  ARCCOTAN_C;
      CM_ARCSEC:    ARCSEC_C;
      CM_ARCCOSEC:  ARCCOSEC_C;
      CM_SINH:      SINH_C;
      CM_COSH:      COSH_C;
      CM_COSECH:    COSECH_C;
      CM_SECH:      SECH_C;
      CM_ARCSECH:   ARCSECH_C;
      CM_ARCCOSECH: ARCCOSECH_C;
      CM_TANH:      TANH_C;
      CM_COTANH:    COTANH_C;
      CM_ARCCOSH:   ARCCOSH_C;
      CM_ARCSINH:   ARCSINH_C;
      CM_ARCTANH:   ARCTANH_C;
      CM_ARCCOTANH: ARCCOTANH_C;
      CM_LN:        LN_C;
      CM_EXP:       EXP_C;
      CM_SQR:       SQR_C;
      CM_SQRT:      SQRT_C;
      CM_FACT:      FACT_C;
      CM_LOG10:     LOG10_C;
      CM_LOG2:      LOG2_C;
      CM_ROOT:      ROOT_C;
      CM_PWR3:      PWR3_C;
      CM_PWR4:      PWR4_C;
      CM_PWRN1:     PWRN1_C;
      CM_PWRN2:     PWRN2_C;
      CM_PWRN3:     PWRN3_C;
      CM_PWRN4:     PWRN4_C;
      CM_TRUNC:     TRUNC_C;
      CM_CON:       CON_C;
      CM_FRAC:      FRAC_C;
      CM_NORM:      NORM_C;
      CM_SUM:       SUM_C;
      CM_AVR:       AVR_C;
      CM_SUMQ:      SUMQ_C;
      CM_LEN:       LEN_C;
      CM_MAX:       MAX_C;
      CM_MIN:       MIN_C;
      CM_PROD:      PROD_C;
      CM_SIGN:      SGN_C;
      CM_IPWRSGN:   IPWRSGN_C;
      CM_LDSVX:     LDSVX_C;
      CM_IF:        IFNOP_C;
      CM_FACT2:     FACT2_C;
      CM_SAVE:      SAVE_C;
      CM_JMP:       JMP_C;
      CM_INC:       INC_C;
      CM_DEC:       DEC_C;
      CM_DECART:    DECART_C;
      CM_DEG:       DEG_C;
      CM_RAD:       RAD_C;
      CM_DEV:       DEV_C;
      CM_DEVS:      DEVS_C;
      CM_ARCTAN2:   ARCTAN2_C;
      CM_SINCOS:    SINCOS_C;
      CM_COSSIN:    COSSIN_C;
      CM_SWAP:      SWAP_C;
      CM_COMPLEX:   COMPLEX_C;
      CM_PWR5:      PWR5_C;
      CM_PWRN5:     PWRN5_C;
      CM_PWR6:      PWR6_C;
      CM_PWRN6:     PWRN6_C;
      CM_MOD:       MOD_C;
      CM_IPWR:      IPWR_C;
      CM_POLY:      POLY_C;
      CM_GCD:       GCD_C;
      CM_LCM:       LCM_C;
      CM_MAX23:     MAX23_C;
      CM_MIN23:     MIN23_C;
      CM_NORM23:    NORM23_C;
      CM_AVR23:     AVR23_C;
      CM_F2PWR:     F2PWR_C;
      CM_TRY:       TRY_C;
      CM_EXCEPTION: EXCEPTION_C;

 else
 //external functions
 begin
extf:
  if Alg.ExFunc[N].Func[NF].CallT = _STACK_ADR then
  begin
   PushArgStackAdr;
   MOVAadr(Alg.ExFunc[N].Func[NF].Addr);
   CALLA;
   if Alg.ExFunc[N].Func[NF].CLST = 1 then ADDESP(Interp[NFunc].Arg*4);
  end
  else
  if Alg.ExFunc[N].Func[NF].CallT = _STACK_VAL then
  begin
   PushArgStackVal;
  end
  else
  if Alg.ExFunc[N].Func[NF].CallT = _ESP then
  begin
   LoadArgMem;
   PUSHM(GetStackAdr(S,_RE));
   MOVAadr(Alg.ExFunc[N].Func[NF].Addr);
   CALLA;
   if Alg.ExFunc[N].Func[NF].CLST = 1 then ADDESP(4);   {.197}
  end
  else
  if Alg.ExFunc[N].Func[NF].CallT = _EAX then
  begin
   LoadArgMem;
   MOVAadr(GetStackAdr(S,_RE));
   MOVBadr(Alg.ExFunc[N].Func[NF].Addr);
   CALLB;
  end
  else
  if Alg.ExFunc[N].Func[NF].CallT = _COMPILED then
  begin
   LoadArgPC;
   MOVAadr(Alg.ExFunc[N].Func[NF].Addr);
   CALLA;
  end
  else
  if Alg.ExFunc[N].Func[NF].CallT = _STACK_INFINITE then     //FUNC(ADR,LEN)
  begin

   LoadArgMemInf;
   if Alg.ExFunc[N].Func[NF].Arrow = _BACK then
   begin
     PUSHM(GetStackAdr(S,_RE));
     PUSHM(Interp[NFunc].Arg);
   end
   else
    if Alg.ExFunc[N].Func[NF].Arrow = _RIGHT then
   begin
     PUSHM(Interp[NFunc].Arg);
     PUSHM(GetStackAdr(S,_RE));
   end;
   MOVAadr(Alg.ExFunc[N].Func[NF].Addr);
   CALLA;
   if Alg.ExFunc[N].Func[NF].CLST = 1 then ADDESP(8);
  end
  else
  if (Alg.ExFunc[N].Func[NF].CallT = _STACK_INFINITE_A)  then     //FUNC(ADR,LEN,ADRT)
  begin
   if  {( Alg.ExFunc[N].Name <> 'nop')}N <> CM_NOP then       {.197}
   begin
     LoadArgMemInfA;
     if Alg.ExFunc[N].Func[NF].Arrow = _BACK then
     begin
       PUSHM(GetStackAdr(S,_RE));
       PUSHM(Interp[NFunc].Arg);
       PUSHM(Cardinal(@Interp[I].ArgTypes[0]));
     end
     else
     if Alg.ExFunc[N].Func[NF].Arrow = _RIGHT then
     begin
       PUSHM(Cardinal(@Interp[I].ArgTypes[0]));
       PUSHM(Interp[NFunc].Arg);
       PUSHM(GetStackAdr(S,_RE));
     end;
     MOVAadr(Alg.ExFunc[N].Func[NF].Addr);
     CALLA;
     if Alg.ExFunc[N].Func[NF].CLST = 1 then ADDESP(12);
   end;
  end;


   SDeep:=Alg.ExFunc[N].Func[NF].SDeep;
   SaveRegF;

   //fz_UNKNOWN
   if  SDeep = -1 then F_SaveInFPU:=False
   else
   begin
    if Alg.ExFunc[N].Func[NF].TypeF = T_Real then R:=1 else
    if Alg.ExFunc[N].Func[NF].TypeF = T_Complex then R:=2 else
    if Alg.ExFunc[N].Func[NF].TypeF = T_None then R:=0;

     //  NOP .. TypeF    (<>T_None):
     if Interp[I].NFunc = CM_NOP then R:=0;
     //  IF ..        #JMP :
     if Interp[I].NFunc = CM_IF then R:=0;   {.211}

    if R > SDeep then SDeep:=R;
    CheckStack(SDeep);

    if (Alg.ExFunc[N].Func[NF].TypeF = T_Real) and (SDeep > 1) then CheckStack(-(SDeep-1)) else
    if (Alg.ExFunc[N].Func[NF].TypeF = T_Complex) and (SDeep > 2) then CheckStack(-(SDeep-2));
    if Alg.ExFunc[N].Func[NF].TypeF = T_None then CheckStack(-SDeep); // :   (+SDeep,-SDeep) {.211}

    //F_ExtFunc:=True;
     //SetReg(1); SetReg(2); SetReg(3); SetReg(4);
   end;
    F_ExtFunc:=True;





 end;

 end; //of case

  WriteReplFunc(I);
end;


endp:
SaveResult(I);
end;




procedure TForevalH.SaveResult(I: Cardinal);
label endp;
var
S,N,NM,CallT,NF,dt,sh,Adr,tf,NL: Cardinal;
REA,IMA: TAddress;
begin

F_SData:=_FPU;
//      :   FPU:
//   IFNOP    FPU ( IFNOP  NAN)

if CheckIfRet(I) then goto endp;
if CheckNopRet(I) then goto endp;
if CheckSaveRet(I) then goto endp;

//    : (T_None)    {.197}
if Interp[I].TypeF = T_None then   goto endp;

//if Interp[I].NFunc = CM_JMP  then goto endp;
//if Interp[I].NFunc = CM_INC  then goto endp;
//if Interp[I].NFunc = CM_DEC  then goto endp;
{
N:=Interp[I].NFunc; NF:=Interp[I].NF;
if Alg.ExFunc[N].Func[NF].TypeF = T_None then   goto endp;
}


if F_SaveInFPU = False then
begin


 if I < LFunc-1 then
 begin
   dt:=F_DataType;
   S:=Interp[I].S;
   NM:=Interp[I].NM;
   NL:=Interp[I].NL;
   N:=Interp[NM].NFunc;
   NF:=Interp[NM].NF;
   REA:=GetStackAdr(S,_RE);
   IMA:=GetStackAdr(S,_IM);

   CallT:=Alg.ExFunc[N].Func[NF].CallT;

   if  (CallT = _STACK_VAL) or (CallT = _COMPILED)  then
   begin
     case Interp[I].ExtArg of
      D_Real:          dt:=_Double;
      D_Complex:       dt:=_Double;
      E_Real:          dt:=_Extended;
      E_Complex:       dt:=_Extended;
      D_Array_Real:    dt:=_Pointer;
      E_Array_Real:    dt:=_Pointer;
      I_Array_Real:    dt:=_Pointer;
      _Integer:        dt:=_Integer;
     end;
   end;

   if Interp[I].TypeF = T_Real then
   begin
    FSTPM({GetStackAdr(S,_RE)}REA,{F_DataType}dt);
   end
   else
   if Interp[I].TypeF = T_Complex then
   begin       //RE-ST(0); IM-ST(1)
    FSTPM({GetStackAdr(S,_RE)}REA,{F_DataType}dt);
    FSTPM({GetStackAdr(S,_IM)}IMA,{F_DataType}dt);
   end
   else
   if Interp[I].TypeF = T_Array then
   begin    {arraycpu}
     //FSTPM({GetStackAdr(S,_RE)}REA,_Pointer);
     //POPF(REA);       {.197}        {.223}
   end;

 end
 else   //     
 begin
  tf:=Interp[I].TypeF;
  if F_CalcType = T_Complex then
  begin
    case tf of
     T_Real:    begin FLDZ; FXCH1; end;
     //T_Array:  begin FLDZ; FXCH1; end;     {arraycpu}{.223}
    end;
  end
  else
   if F_CalcType = T_Real then
   begin
     if tf = T_Complex then
     begin
      FXCH1;
      FSTP0;
     end;
   end;
 end;

end
else
//////////////////////////////
if F_SaveInFPU = True then
begin

 if I < LFunc-1 then
 begin
   S:=Interp[I].S;
   NM:=Interp[I].NM;
   NL:=Interp[I].NL;
   N:=Interp[NM].NFunc;
   NF:=Interp[NM].NF;
   CallT:=Alg.ExFunc[N].Func[NF].CallT;
                                       // . -   
  if (Interp[I].SData = _MEM) or (Interp[I].ExtArg <> 0) then
  begin

   if  (CallT = _STACK_VAL) {or ((CallT = _COMPILED) and (Interp[I].SData = _MEM))}  {.197} then
   begin
     SaveArgStackVal(i);     {.197}
   end
   else
   if  (CallT = _STACK_ADR)  then
   begin
     SaveArgStackAdr(i);
   end
   else
   if CallT = _COMPILED then
   begin
      SaveArgPC(i);     {.197}
   end
   else
   if (CallT = _ESP) or (CallT = _EAX)  then
   begin
      SaveArgMemAdr(i)     {.197}
   end
   else
   // 'external functions' (CallT=...)  .SData=_MEM
   begin
     if Interp[I].TypeF = T_Real then
     begin
      FSTPM(GetStackAdr(S,_RE),F_DataType);
     end
     else
     if Interp[I].TypeF = T_Complex then
     begin       //RE-ST(0); IM-ST(1)
      FSTPM(GetStackAdr(S,_RE),F_DataType);
      FSTPM(GetStackAdr(S,_IM),F_DataType);
     end
     else {.197}
     if Interp[I].TypeF = T_Array then    {arraycpu}
     begin
      //FSTPM(GetStackAdr(S,_RE),_Pointer);  {.223}
     end;
   end
  end
 end


 else   //     
 begin

   tf:=Interp[I].TypeF;
   if F_CalcType = T_Complex then
   begin
    case tf of
     T_Real:    begin FLDZ; FXCH1; end;
    // T_Array:  begin FLDZ; FXCH1; end;     {arraycpu}{.223}
    end;
   end
   else
   if F_CalcType = T_Real then
   begin
     if tf = T_Complex then
     begin
      FXCH1;
      FSTP0;
     end;
   end;
 end;

end;

endp:
Interp[I].SData1:=F_SData;
end;



function TForevalH.CheckIfRet(N: Integer): Boolean;
begin
  if Interp[Interp[N].NM].NFunc = CM_IF then
     begin
       if (Interp[N].NL = 4) or (Interp[N].NL = 6) then   CheckIfRet:=True
       else
       CheckIfRet:=False;
     end
  else
  CheckIfRet:=False;
end;


function TForevalH.CheckNopRet(N: Integer): Boolean;
begin
//  NOP
  if Interp[Interp[N].NM].NFunc = CM_NOP then
  begin
    CheckNopRet:=True;
    SetLength(GotoLab,Length(GotoLab)+1);
    GotoLab[High(GotoLab)]:=NFunc;
  end
   else CheckNopRet:=False;
end;


function TForevalH.CheckSaveRet(N: Integer): Boolean;
begin
  if Interp[Interp[N].NM].NFunc = CM_SAVE then CheckSaveRet:=True
   else CheckSaveRet:=False;
end;



function TForevalH.ReadReplFunc(i: integer): Boolean;
begin
// :
if Interp[i].RRF = rf_FULL_REPLACE then
  begin
    if Interp[i].TypeF = T_Real then
    begin
     FLD(TAddress(@Func.RFStack[Interp[i].MRF]),F_DataType);
    end
    else
    if Interp[i].TypeF = T_Complex then
    begin
      FLD(TAddress(@Func.RFStack[Interp[i].MRF]),F_DataType);
      FLD(TAddress(@Func.RFStack[Interp[i].MRF-1]),F_DataType);
    end;
     ReadReplFunc:=True;
  end
  else
  ReadReplFunc:=False;
end;


procedure TForevalH.WriteReplFunc(i: integer);
var
L: integer;
Addr: TAddress;
begin
// :
if (Interp[i].WRF = rf_FULL_REPLACE) then
 begin
  if Interp[i].TypeF = T_Real then
  begin
   Addr:=TAddress(@Func.RFStack[Interp[i].MRF]);
   FSTM(Addr,F_DataType);
  end
  else
  if Interp[i].TypeF = T_Complex then
  begin
   Addr:=TAddress(@Func.RFStack[Interp[i].MRF-1]);
   FSTM(Addr,F_DataType);
   FXCH1;
   Addr:=TAddress(@Func.RFStack[Interp[i].MRF]);
   FSTM(Addr,F_DataType);
   FXCH1;
  end
 end;
end;



function TForevalH.GetStackAdr(S,RT: Integer): Cardinal;
begin
if F_Mode = M_Compile then        {.197}
begin
  if RT = _RE then GetStackAdr:=Cardinal(@Func.Stack[S].re)
  else
  if RT = _IM then GetStackAdr:=Cardinal(@Func.Stack[S].im);
end
else
GetStackAdr:=0;
end;





procedure TForevalH.LoadArgSTACK;
var
S,N,NF,j,Adr,Adr1,Adr2,tm: Cardinal;
sh,i: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 Adr:=GetStackAdr(S,_RE);
 j:=0;
 SetLength(Sadr,0);
 sh:=10;
// 
 for i:=0 to  Interp[NFunc].Arg-1 do
  begin
   //if Alg.ExFunc[N].Func[NF].TM[i] <> F_DataType then   //  '=',  -  
   begin
    if Alg.ExFunc[N].Func[NF].TV[i]  =  T_Real then
    begin
      tm:=Alg.ExFunc[N].Func[NF].TM[i];
      Adr:=GetStackAdr(S+i,_RE);
      if F_SaveInFPU = False then
      begin
       FLD(Adr,F_DataType);
       FSTPM(Adr,tm);
      end;
      SetLength(SAdr,Length(SAdr)+1);   SAdr[High(SAdr)]:=Adr;
    end
    else
    if Alg.ExFunc[N].Func[NF].TV[i]  =  T_Complex then
    begin
       tm:=Alg.ExFunc[N].Func[NF].TM[i];
       Adr1:=GetStackAdr(S+i,_RE);  Adr2:=GetStackAdr(S+i,_IM);
       if F_SaveInFPU = False then
       begin
        FLD(Adr2,F_DataType);
        FLD(Adr1,F_DataType);
        FSTPM(Adr1,tm);
        sh:=8; if tm = _Extended then sh:=16;
        FSTPM(Adr1+sh,tm);
       end;
        SetLength(SAdr,Length(SAdr)+1);  SAdr[High(SAdr)]:=Adr1;
    end
    else
    if Alg.ExFunc[N].Func[NF].TV[i]  =  T_Array then
    begin
      //tm:=Alg.ExFunc[N].Func[NF].TM[i];
      Adr:=GetStackAdr(S+i,_RE);
      if F_SaveInFPU = False then
      begin
       FILD(Adr);
       FISTP(Adr);
      end;
      SetLength(SAdr,Length(SAdr)+1);   SAdr[High(SAdr)]:=Adr;
    end;
   end;
 end;
end;




procedure TForevalH.LoadArgMEM;
var
S,N,NF,j,Adr,vs: Cardinal;
sh,i: Integer;
begin
if F_SaveInFPU = False then     {.197}
begin


 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 Adr:=GetStackAdr(S,_RE);
 j:=0;
sh:=16;
//    ( (32)  (16))
 for i:=0 to  Interp[NFunc].Arg-1 do
  begin
    if Alg.ExFunc[N].Func[NF].TV[i]  =  T_Real then
    begin
      vs:=Alg.ExFunc[N].Func[NF].TM[i];
      FLD(GetStackAdr(S+i,_RE),F_DataType);
      FSTPM(Adr+j*sh,vs);
      inc(j);
    end
    else
    if Alg.ExFunc[N].Func[NF].TV[i]  =  T_Complex then
    begin
      vs:=Alg.ExFunc[N].Func[NF].TM[i];
      FLD(GetStackAdr(S+i,_IM),F_DataType);
      FLD(GetStackAdr(S+i,_RE),F_DataType);
      FSTPM(Adr+j*sh,vs);
      inc(j);
      FSTPM(Adr+j*sh,vs);
      inc(j);
    end
    else
    if Alg.ExFunc[N].Func[NF].TV[i]  =  T_Array then    {.197}
    begin      {arraycpu}
      {FLD(GetStackAdr(S+i,_RE),_Pointer);
      FSTPM(Adr+j*sh,_Pointer); }

      PUSHF(GetStackAdr(S+i,_RE)) ;
      POPF(Adr+j*sh);

      inc(j);
    end
 end;

end;
end;



procedure TForevalH.LoadArgPC;
var
S,N,NF,j,Adr,TM,TV,NL: Cardinal;
sh,k,i: Integer;
begin


 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 NL:=Interp[NFunc].NL;
 S:=Interp[NFunc].S;
 Adr:=GetStackAdr(S,_RE);

if F_SaveInFPU = True then
begin

  //..  FPU-  :
  for k:=Interp[NFunc].Arg downto 1 do
  begin

      TV:=Alg.ExFunc[N].Func[NF].TV[k-1];
      TM:=Alg.ExFunc[N].Func[NF].TM[k-1];
      if  (TV =  T_Real)  then
      begin
         if Interp[NFunc].RData[k-1] = _MEM then
            FLD(GetStackAdr(S+k-1,_RE),TM);

         FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[k-1],TM);
      end
      else
      if   TV = T_Array then      {arraycpu}
      begin
         {FLD(GetStackAdr(S+k-1,_RE),_Pointer);
         FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[k-1],_Pointer); }  {.197}
         PUSHF(GetStackAdr(S+k-1,_RE));
         POPF(Alg.ExFunc[N].Func[NF].ArgAdr[k-1]);
      end
      else
      if TV  =  T_Complex then
      begin
         if Interp[NFunc].RData[k-1] = _MEM then
         begin
            FLD(GetStackAdr(S+k-1,_RE),TM);
            FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[k-1],TM);
            FLD(GetStackAdr(S+k-1,_IM),TM);
            if TM = _Double   then FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[k-1]+SH_D,TM) else
               if TM = _Extended then FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[k-1]+SH_E,TM)
         end
         else  //in _FPU
         begin
            FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[k-1],TM);
            if TM = _Double   then FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[k-1]+SH_D,TM) else
               if TM = _Extended then FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[k-1]+SH_E,TM)
         end;
      end;

  end;

end
else
if F_SaveInFPU = False then      {.197}

begin


 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 NL:=Interp[NFunc].NL;
 S:=Interp[NFunc].S;
 Adr:=GetStackAdr(S,_RE);

// 
 for i:=0 to  Interp[NFunc].Arg-1 do
  begin
    TV:=Alg.ExFunc[N].Func[NF].TV[i];
    if  (TV =  T_Real) then
    begin
      TM:=Alg.ExFunc[N].Func[NF].TM[i];
      FLD(GetStackAdr(S+i,_RE),TM);
      FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[i],TM);
    end
    else
    if TV  =  T_Complex then
    begin
      TM:=Alg.ExFunc[N].Func[NF].TM[i];
      FLD(GetStackAdr(S+i,_RE),TM);
      FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[i],TM);
      FLD(GetStackAdr(S+i,_IM),TM);
      if TM = _Double   then FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[i]+SH_D,TM) else
         if TM = _Extended then FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[i]+SH_E,TM)
    end
    else
    if   (TV = T_Array) then
    begin   {arraycpu}
      {FLD(GetStackAdr(S+i,_RE),_Pointer);
      FSTPM(Alg.ExFunc[N].Func[NF].ArgAdr[i],_Pointer); }
      PUSHF(GetStackAdr(S+i,_RE));                        {.197}
      POPF(Alg.ExFunc[N].Func[NF].ArgAdr[i]);
    end
 end;

end;

end;


procedure TForevalH.LoadArgMEMInf;
var
S,N,NF,j,Adr,vs: Cardinal;
sh,i: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 Adr:=GetStackAdr(S,_RE);
 j:=0;
sh:=16;
// 
if Interp[NFunc].Arg = 0 then
begin
  {FLDZ;
  FSTPM(Adr,Alg.ExFunc[N].Func[NF].TM[0]);}
end
else
 for i:=0 to  Interp[NFunc].Arg-1 do
  begin
    if Alg.ExFunc[N].Func[NF].TV[0]  =  T_Real then
    begin
      vs:=Alg.ExFunc[N].Func[NF].TM[0];
      FLD(GetStackAdr(S+i,_RE),F_DataType);
      FSTPM(Adr+j*sh,vs);
      inc(j);
    end
    else
    if Alg.ExFunc[N].Func[NF].TV[0]  =  T_Complex then
    begin
      vs:=Alg.ExFunc[N].Func[NF].TM[0];
      FLD(GetStackAdr(S+i,_IM),F_DataType);
      FLD(GetStackAdr(S+i,_RE),F_DataType);
      FSTPM(Adr+j*sh,vs);
      inc(j);
      FSTPM(Adr+j*sh,vs);
      inc(j);
    end;
 end;
end;



procedure TForevalH.LoadArgMEMInfA;
var
S,N,NF,j,Adr,vs: Cardinal;
sh,i: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 Adr:=GetStackAdr(S,_RE);
 j:=0;
sh:=16;
// 
 for i:=0 to  Interp[NFunc].Arg-1 do
  begin
    if Interp[NFunc].ArgTypes[i]  =  T_Real then
    begin
      vs:=Alg.ExFunc[N].Func[NF].TM[0];
      FLD(GetStackAdr(S+i,_RE),F_DataType);
      FSTPM(Adr+j*sh,vs);
      inc(j);
    end
    else
    if Interp[NFunc].ArgTypes[i]  =  T_Complex then
    begin
      vs:=Alg.ExFunc[N].Func[NF].TM[0];
      FLD(GetStackAdr(S+i,_IM),F_DataType);
      FLD(GetStackAdr(S+i,_RE),F_DataType);
      FSTPM(Adr+j*sh,vs);
      inc(j);
      FSTPM(Adr+j*sh,vs);
      inc(j);
    end;
 end;
end;



procedure TForevalH.PUSHArgSTACK;
var
S,N,NF,j,Adr,vs,Arg: Cardinal;
i: integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 Arg:=Interp[NFunc].Arg;
 j:=0;


if Alg.ExFunc[N].Func[NF].Arrow = _BACK then
begin
  for i:=0 to  Arg-1 do
  begin
   PUSHM(Sadr[i]);
  end;

end
else
if Alg.ExFunc[N].Func[NF].Arrow = _RIGHT then
begin
  for i:=Arg-1 downto  0 do
  begin
    PUSHM(SAdr[i]);
  end;
end;

end;




procedure TForevalH.PushArgStackAdr;
begin
  LoadArgStack;
  PushArgStack;
end;




procedure TForevalH.PUSHArgStackVal;
var
S,N,NF,i,j,Adr,vs,Arg,TM,TV,DS,CS,cn: Cardinal;
k: integer;



        procedure PUSHARG(TV,TM,Sh{,arw}: Integer);
        var
        S: Cardinal;
        begin                         //Sh -  
           S:=Interp[NFunc].S;

           if TM = _Double then
           begin

            if TV = T_Complex  then     // "pascal"  , ..  ,   
            begin
                {if arw = _RIGHT then
                 begin  }
                  PUSHF(GetStackAdr(S+Sh,_IM)+4);
                  PUSHF(GetStackAdr(S+Sh,_IM));
                  PUSHF(GetStackAdr(S+Sh,_RE)+4);
                  PUSHF(GetStackAdr(S+Sh,_RE));
                 {end
                 else
                 begin
                   PUSHF(GetStackAdr(S+Sh,_RE));
                 end; }
            end
            else
            if TV = T_Real  then
            begin
              PUSHF(GetStackAdr(S+Sh,_RE)+4);
              PUSHF(GetStackAdr(S+Sh,_RE));
            end
            else
            if TV = T_Array  then
            begin
              PUSHF(GetStackAdr(S+Sh,_RE));
            end
           end
           else
           if TM = _Extended then
           begin

            if TV = T_Complex  then               // "pascal"  , ..  ,   
            begin

              //  Delphi (  16)
              PUSHF(GetStackAdr(S+Sh,_IM)+12);
              PUSHF(GetStackAdr(S+Sh,_IM)+8);
              PUSHF(GetStackAdr(S+Sh,_IM)+4);
              PUSHF(GetStackAdr(S+Sh,_IM));


              PUSHF(GetStackAdr(S+Sh,_RE)+12);
              PUSHF(GetStackAdr(S+Sh,_RE)+8);
              PUSHF(GetStackAdr(S+Sh,_RE)+4);
              PUSHF(GetStackAdr(S+Sh,_RE));
            end
            else
            if TV = T_Real then
            begin
              PUSHF(GetStackAdr(S+Sh,_RE)+8);
              PUSHF(GetStackAdr(S+Sh,_RE)+4);
              PUSHF(GetStackAdr(S+Sh,_RE));
            end
            else
            if TV = T_Array  then
            begin
              PUSHF(GetStackAdr(S+Sh,_RE));
            end;

           end
           else
           if TM = _Integer then
           begin
             PUSHF(GetStackAdr(S+Sh,_RE));
           end;
        end;


begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 Arg:=Interp[NFunc].Arg;
 j:=0;


DS:=0;
//DS -      :
 for k:=0 to  Arg-1 do
 begin
   CS:=0;
   TV:=Alg.ExFunc[N].Func[NF].TV[k];
   TM:=Alg.ExFunc[N].Func[NF].TM[k];

   if TV = T_Array then   CS:=4      {.197}
   else
   begin
     case TM of
     _Integer:     CS:=4;
     _Pointer:     CS:=4;
     _Double:     CS:=8;
     _Extended:   CS:=12;  //12 -  (12  10) -   DELPHI
     end;
     case TV of
     T_Real:      CS:=CS;
     T_Complex:   CS:=CS*2;
     end;
   end;



    DS:=DS+CS;
    if (TM = _Extended) and (TV = T_Complex) then DS:=DS+8; //16+16;  16

 end;

//   :
 for k:= 0 to Arg-1 do
 begin
  if Alg.ExFunc[N].Func[NF].ARROW = _BACK then cn:=k
  else
  if Alg.ExFunc[N].Func[NF].ARROW = _RIGHT then cn:=Arg-1-k;

  TV:=Alg.ExFunc[N].Func[NF].TV[cn];
  TM:=Alg.ExFunc[N].Func[NF].TM[cn];

  PUSHARG(TV,TM,cn{,Alg.ExFunc[N].Func[NF].ARROW});
 end;

MOVAadr(Alg.ExFunc[N].Func[NF].Addr);
CALLA;
if Alg.ExFunc[N].Func[NF].CLST = 1 then ADDESP(DS);

end;




procedure TForevalH.ADD_C;
var
t1,t2,N,NF,S,st1,st2,Arg,nv1,nv2: Integer;

  procedure ADD_DL;      //S1+S2 (F_SaveInFPU = True)
  begin
    if (t1 = T_Real) and (t2 = T_Real) then        //t2,t1
    begin
        if (st1 = _FPU) and (st2 = _FPU) then
        begin
           FADDP
        end
        else
        if (st1 = _FPU) and (st2 = _MEM) then
        begin
           FADD(GetStackAdr(S+1,_RE),F_DataType)
        end
        else
        if (st1 = _MEM) and (st2 = _FPU) then
        begin
           FADD(GetStackAdr(S,_RE),F_DataType)
        end
        else
        if (st1 = _MEM) and (st2 = _MEM) then
        begin
          FLD(GetStackAdr(S,_RE),F_DataType);
          FADD(GetStackAdr(S+1,_RE),F_DataType);
        end;
    end
    else
    if (t1 = T_Real) and (t2 = T_Complex) then            //x,y,r
    begin
       if (st1 = _FPU) and (st2 = _FPU) then
       begin
          FADDP2;
          FXCH1;
       end
       else
       if (st1 = _FPU) and (st2 = _MEM) then
       begin
         FADD(GetStackAdr(S+1,_RE),F_DataType);
         FLD(GetStackAdr(S+1,_IM),F_DataType);
         FXCH1;
       end
       else
       if (st1 = _MEM) and (st2 = _FPU) then
       begin
         FADD(GetStackAdr(S,_RE),F_DataType)
       end
       else
       if (st1 = _MEM) and (st2 = _MEM) then
       begin
         FLD(GetStackAdr(S+1,_IM),F_DataType);
         FLD(GetStackAdr(S+1,_RE),F_DataType);
         FADD(GetStackAdr(S,_RE),F_DataType);
       end;
    end
    else
    if (t1 = T_Complex) and (t2 = T_Real) then
    begin
       if (st1 = _FPU) and (st2 = _FPU) then
       begin
         FADDP;
       end
       else
       if (st1 = _FPU) and (st2 = _MEM) then
       begin
         FADD(GetStackAdr(S+1,_RE),F_DataType);
       end
       else
       if (st1 = _MEM) and (st2 = _FPU) then
       begin
         FADD(GetStackAdr(S,_RE),F_DataType);
         FLD(GetStackAdr(S,_IM),F_DataType);
         FXCH1;
       end
       else
       if (st1 = _MEM) and (st2 = _MEM) then
       begin
         FLD(GetStackAdr(S,_IM),F_DataType);
         FLD(GetStackAdr(S,_RE),F_DataType);
         FADD(GetStackAdr(S+1,_RE),F_DataType);
       end;
    end
    else
    if (t1 = T_Complex) and (t2 = T_Complex) then
    begin
       if (st1 = _FPU) and (st2 = _FPU) then
       begin
         FADDP2;
         FADDP2;
       end
       else
       if (st1 = _MEM) and (st2 = _MEM) then
       begin
         FLD(GetStackAdr(S,_IM),F_DataType);
         FADD(GetStackAdr(S+1,_IM),F_DataType);
         FLD(GetStackAdr(S,_RE),F_DataType);
         FADD(GetStackAdr(S+1,_RE),F_DataType);
       end
       else
       if (st1 = _FPU) and (st2 = _MEM) then
       begin
         FADD(GetStackAdr(S+1,_RE),F_DataType);
         FXCH1;
         FADD(GetStackAdr(S+1,_IM),F_DataType);
         FXCH1;
       end
       else
       if (st1 = _MEM) and (st2 = _FPU) then
       begin
         FADD(GetStackAdr(S,_RE),F_DataType);
         FXCH1;
         FADD(GetStackAdr(S,_IM),F_DataType);
         FXCH1;
       end;
    end;
  end;

  procedure ADD_ST;       //S1+S2 (F_SaveInFPU = False)
  begin
   if (t1 = T_Real) and (t2 = T_Real) then
   begin
    FLD(GetStackAdr(S,_RE),F_DataType);
    FADD(GetStackAdr(S+1,_RE),F_DataType);
   end
   else
   if (t1 = T_Real) and (t2 = T_Complex) then
   begin
    FLD(GetStackAdr(S+1,_IM),F_DataType);
    FLD(GetStackAdr(S+1,_RE),F_DataType);
    FADD(GetStackAdr(S,_RE),F_DataType);
   end
   else
   if (t1 = T_Complex) and (t2 = T_Real) then
   begin
    FLD(GetStackAdr(S,_IM),F_DataType);
    FLD(GetStackAdr(S,_RE),F_DataType);
    FADD(GetStackAdr(S+1,_RE),F_DataType);
   end
   else
   if (t1 = T_Complex) and (t2 = T_Complex) then
   begin
    FLD(GetStackAdr(S,_IM),F_DataType);
    FADD(GetStackAdr(S+1,_IM),F_DataType);
    FLD(GetStackAdr(S,_RE),F_DataType);
    FADD(GetStackAdr(S+1,_RE),F_DataType);
   end;
  end;


  procedure ADD_VAR;                             //v1+v2
  var
    nv1,nv2,tv1,tv2,tm1,tm2,sh1,sh2: Integer;
    Adr1,Adr2: Cardinal;
  begin
   nv1:=Interp[NFunc].nv1;
   nv2:=Interp[NFunc].nv2;
   GetVar(nv1,adr1,tv1,tm1);
   GetVar(nv2,adr2,tv2,tm2);
   if (tm1 = _Extended) then sh1:=SH_E else sh1:=SH_D;
   if (tm2 = _Extended) then sh2:=SH_E else sh2:=SH_D;

   if (tv1 = T_Real) and (tv2 = T_Real) then
   begin
     FLD(Adr1,tm1);  //FLDV(nv1);
     FADD(Adr2,tm2); //FADDV(nv2,tv2);
   end
   else
   if (tv1 = T_Real) and (tv2 = IM_UNIT) then
   begin
     FLD1;
     FLD(Adr1,tm1);
   end
   else
   if (tv1 = T_Real) and (tv2 = T_Complex) then
   begin
     FLDV(nv2);
     FADD(Adr1,tm1); //FADDV(nv1);
   end
   else
   if (tv1 = IM_UNIT) and (tv2 = T_Real) then
   begin
     FLD1;
     FLD(Adr2,tm2); //FLDV(nv2);
   end
   else
   if (tv1 = T_Complex) and (tv2 = T_Real) then
   begin
     FLDV(nv1);
     FADD(Adr2,tm2);  //FADDV(nv2);
   end
   else
   if (tv1 = T_Complex) and (tv2 = T_Complex) then
   begin
     FLD(Adr1+sh1,tm1); FADD(Adr2+sh2,tm2);
     FLD(Adr1,tm1);     FADD(Adr2,tm2);
   end
   else
   if (tv1 = IM_UNIT) and (tv2 = T_Complex) then
   begin
     FLDV_IM(nv2); FLD1; FADDP;
     FLDV_RE(nv2);
   end
   else
   if (tv1 = T_Complex) and (tv2 = IM_UNIT) then
   begin
     FLDV_IM(nv1); FLD1; FADDP;
     FLDV_RE(nv1);
   end
   else
   if (tv1 = IM_UNIT) and (tv2 = IM_UNIT) then
   begin
     FLD1; FLD1; FADDP;
     FLDZ;
   end

  end;

 /////////////////////////////////MAIN//////////////////////////////////////////
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 Arg:=Interp[NFunc].N;
 t1:=Alg.ExFunc[N].Func[NF].TV[0]; t2:=Alg.ExFunc[N].Func[NF].TV[1];
 st1:=Interp[NFunc].RData[0]; st2:=Interp[NFunc].RData[1];
 nv1:=Interp[NFunc].NV1;
 nv2:=Interp[NFunc].NV2;

 if (Arg = 1) and (Interp[NFunc].TypeA <> 0) then  t1:=Interp[NFunc].TypeA;



 if F_SaveInFPU = False then
 begin
   if (Arg = 2) and (nv1 = -1) and (nv2 = -1) then         //S1+S2
   begin
    ADD_ST;
   end
   else
   if (Arg = 0) and (nv1 >= 0) and (nv2 >= 0) then         //v1+v2
   begin
      ADD_VAR;
   end
   else
   if (Arg = 1) and  (nv1 >= 0)     then                   //S+v1
   begin
    FLDS(0,_MEM);  FADDV(nv1,t1)
   end
   else
   if (Arg = 1) and  (nv1 = -1) and (nv2 = -1)  then       //S1+c
   begin
    FLDS(0,_MEM); FADD(WriteData(NFunc),F_DataType);
   end
   else
   if (Arg = 0) and (nv2 = -1)    then                     //v+c
   begin
     FLD(WriteData(NFunc),F_DataType);
     FADDV(nv1,T_Real);
   end
 end
 else
 if F_SaveInFPU = True then
 begin
   if (Arg = 2) and (nv1 = -1) and (nv2 = -1) then         //S1+S2
   begin
    ADD_DL;
   end
   else
   if (Arg = 0) and (nv1 >= 0) and (nv2 >= 0) then         //v1+v2
   begin
      ADD_VAR
   end
   else
   if (Arg = 1) and  (nv1 >= 0)     then                   //S+v1
   begin
    FLDS(0);  FADDV(nv1,t1)
   end
   else
   if (Arg = 1) and  (nv1 = -1) and (nv2 = -1)  then       //S1+c
   begin
    FLDS(0); FADD(WriteData(NFunc),F_DataType);
   end
   else
   if (Arg = 0) and (nv2 = -1)    then                     //v+c
   begin
     FLD(WriteData(NFunc),F_DataType);
     FADDV(nv1,T_Real);
   end;
 end;


end;




procedure TForevalH.FLDV(nv: Integer);
var
 Adr: Cardinal;
 tv,tm: Integer;
begin
 GetVar(nv,adr,tv,tm);
 if  tv = T_Real    then FLDV_RE(nv)//FLD(Adr,tm)
 else
 if tv = T_Complex  then
 begin
   FLDV_IM(nv);
   FLDV_RE(nv);
 end
 else
 if tv = IM_UNIT then
 begin
   FLD1;
   FLDZ;
 end;
end;




procedure TForevalH.LDSF_C(N: Integer);
begin

 if Alg.Obj[N].TypeF = T_Real then
 begin
  if (Interp[NFunc].TS = 0) or (Interp[NFunc].TS = _RE) then
     FLD(Alg.Obj[N].Addr,Alg.Obj[N].MType)
  else
  if Interp[NFunc].TS = _IM then
     FLDZ;
 end
 else
 if Alg.Obj[N].TypeF = T_Complex then
 begin
  if Interp[NFunc].TS = 0 then
  begin
    if Alg.Obj[N].MType = _Double then
     FLD(Alg.Obj[N].Addr+8,Alg.Obj[N].MType)
    else
    if Alg.Obj[N].MType = _Extended then
     FLD(Alg.Obj[N].Addr+16,Alg.Obj[N].MType);

    FLD(Alg.Obj[N].Addr,Alg.Obj[N].MType);
  end
  else
  if Interp[NFunc].TS = _RE then
  begin
    FLD(Alg.Obj[N].Addr,Alg.Obj[N].MType);
  end
  else
  if Interp[NFunc].TS = _IM then
  begin
    if Alg.Obj[N].MType = _Double then
     FLD(Alg.Obj[N].Addr+8,Alg.Obj[N].MType)
    else
    if Alg.Obj[N].MType = _Extended then
     FLD(Alg.Obj[N].Addr+16,Alg.Obj[N].MType);
  end
 end
 else
 //Pointer: Vector
 if Alg.Obj[N].TypeF = T_Array then
 begin   {arraycpu}
   //FILD(Alg.Obj[N].Addr);

   //PUSHF(Alg.Obj[N].Addr);     {.197}

   //         {.223}
   PUSHF(Alg.Obj[N].Addr);
   POPF(GetStackAdr(Interp[NFunc].S,_RE));
 end;

end;




procedure TForevalH.SAVE_C;
label endp;
var
N,N1,NF,tf,tv,ts,sh,TM,TMA,tva: Integer;
AdrM,AdrA,Num: Cardinal;
begin



 N:=Interp[NFunc].NObj;
 N1:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 tf:=Alg.ExFunc[N1].Func[NF].TV[0];
 tv:=Alg.Obj[N].TypeF;
 TS:=Interp[NFunc].TS;
 if Alg.Obj[N].MType = _Double then sh:=8 else   if Alg.Obj[N].MType = _Extended  then sh:=16;

if Interp[NFunc].AI = 1 then
begin
 if tf =   T_Real then       //var = real expression
 begin
    if tv =   T_Real then                     //real var =  real expression
    begin
      FSTPM(Alg.Obj[N].Addr,Alg.Obj[N].MType)
    end
    else
    {if (tv =   T_Complex) and (ts = _RE) then
    begin
      FSTPM(Alg.Obj[N].Addr,Alg.Obj[N].MType)
    end
    else
    if (tv =   T_Complex) and (ts = _IM ) then
    begin
      FSTPM(Alg.Obj[N].Addr+sh,Alg.Obj[N].MType)
    end
    else
    if (tv =   T_Complex) and  (ts = 0) then
    begin
      FSTPM(Alg.Obj[N].Addr,Alg.Obj[N].MType)
    end }
     {.203}
     if tv =   T_Complex then                  //complex var =  real expression
     begin
       if  ts = _RE then
         FSTPM(Alg.Obj[N].Addr,Alg.Obj[N].MType)
       else
        if  ts = _IM then
         FSTPM(Alg.Obj[N].Addr+sh,Alg.Obj[N].MType)
       else
        if ts = 0 then
       begin
         FSTPM(Alg.Obj[N].Addr,Alg.Obj[N].MType);      //expr->re
         FLDZ;
         FSTPM(Alg.Obj[N].Addr+sh,Alg.Obj[N].MType);   //0->im
       end;
     end;

 end
 else
 if tf =   T_Complex then
 begin
    if tv =   T_Real then
    begin
      FSTPM(Alg.Obj[N].Addr,Alg.Obj[N].MType);
      FSTP0;
    end
    else
    if (tv =   T_Complex) and (ts = _RE ) then
    begin
      FSTPM(Alg.Obj[N].Addr,Alg.Obj[N].MType);
      FSTP0;
    end
    else
    if (tv =   T_Complex) and (ts = _IM ) then
    begin
      //FSTP0;
      FSTPM(Alg.Obj[N].Addr+sh,Alg.Obj[N].MType);
      FSTP0;
    end
    else
    if (tv =   T_Complex)  then
    begin
      FSTPM(Alg.Obj[N].Addr,Alg.Obj[N].MType);
      FSTPM(Alg.Obj[N].Addr+sh,Alg.Obj[N].MType);
    end
 end
end
else
if Interp[NFunc].AI = 2 then   //save(vd,n,x)
begin

  if tf =   T_Complex then
  begin
     //vd[k]=z1; x
     F_SyntaxErrorString:='save(real,complex) in:   '+Interp[NFunc].Expression;
     F_SyntaxErrorCode:=E_NOT_DEFINED_FUNCTION_FOR_TYPE;
    goto endp;
  end;

  AdrM:=Alg.Obj[N].Addr;
  TM:=Alg.Obj[N].MType;
   {
   FXCH1;
   FLDCW(TAddress(@FCW1));
   MEM:=WriteDataA(0,_Integer);
   FISTP(MEM);
   FLDCW(TAddress(@FCW2));
   MOVMC(MEM);
   }

   if Interp[NFunc].CI = 1 then    //Vec[int_var]
   begin
     GetVar(Interp[NFunc].NV1,AdrA,tva,TMA);
     MOVMC(AdrA);
   end
   else
    if Interp[NFunc].CI = 2 then    //Vec[int_num]
   begin
     Num:=Trunc(Interp[NFunc].FD);
     MOVCadr(NUM);  //Num>=0!!!
   end
   else                            //vec[stack]
   begin
    FXCH1;
    PUSHCW;    {.227}
    FLDCW(TAddress(@FCW1));
    MEM:=WriteDataA(0,_Integer);
    FISTP(MEM);
    POPCW;      {.227}   //FLDCW(TAddress(@FCW2));
    MOVMC(MEM);
   end;




   if TM = _Double then
   begin
    {MOVB1(AdrM);
    MOVA1(Cardinal(@RD_VECS));
    CALLA;}

     MOVBadr(AdrM);
     //mov  ebx, [ebx]:
     AddByte($8B); AddByte($1B);
     //fstp  qword ptr [ebx+8*ecx]:
     AddByte($DD); AddByte($1C);AddByte($CB);
   end
   else
   if TM = _Extended then
   begin
    {MOVB1(AdrM);
    MOVA1(Cardinal(@RE_VECS));
    CALLA;}

      MOVBadr(AdrM);
     //mov  ebx, [ebx]:
     AddByte($8B); AddByte($1B);
     //lea   ecx,[ecx+4*ecx]:
     AddByte($8D); AddByte($0C);AddByte($89);
     //fstp   tbyte ptr [ebx+2*ecx]:
     AddByte($DB); AddByte($3C);AddByte($4B);
   end
   else
   if TM = _Integer then
   begin
    {MOVB1(AdrM);
    MOVA1(Cardinal(@RI_VECS));
    CALLA;}

     MOVBadr(AdrM);
    //mov  ebx, [ebx]:
     AddByte($8B); AddByte($1B);
    //fistp  dword ptr [ebx+4*ecx]:
     AddByte($DB); AddByte($1C);AddByte($8B);
   end;

   CheckStack(-1);
 end;


{SetLength(GotoLab,Length(GotoLab)+1);
GotoLab[High(GotoLab)]:=NFunc;}
  endp:
end;






procedure TForevalH.SWAP_C;
var
N,nv1,nv2,NF,tf,tv1,ts1,tv2,ts2,sh1,sh2,TM1,TM2,tva: Integer;
Adr1,Adr2: TAddress;
begin

 nv1:=Interp[NFunc].NV1;
 nv2:=Interp[NFunc].NV2;
 Adr1:=Alg.Obj[nv1].Addr;
 Adr2:=Alg.Obj[nv2].Addr;
 tv1:=Alg.Obj[nv1].TypeF;
 tv2:=Alg.Obj[nv2].TypeF;
 tm1:=Alg.Obj[nv1].MType;
 tm2:=Alg.Obj[nv2].MType;
 ts1:=Interp[NFunc].TS1;
 ts2:=Interp[NFunc].TS2;

 if tm1 = _Double then sh1:=8 else   if Alg.Obj[nv1].MType = _Extended  then sh1:=16;
 if tm2 = _Double then sh2:=8 else   if Alg.Obj[nv2].MType = _Extended  then sh2:=16;

 if (Interp[NFunc].AI = 1) or (Interp[NFunc].AI = 2) then
 begin
   FLD(Adr1,tm1);
   FLD(Adr2,tm2);
   FSTPM(Adr1,tm1);
   FSTPM(Adr2,tm2);
   CheckStack(2);
   CheckStack(-2);
 end
 else
 if (Interp[NFunc].AI = 3) then
 begin
   FLD(Adr1,tm1);
   FLD(Adr1+sh1,tm1);
   FLD(Adr2,tm2);
   FLD(Adr2+sh2,tm2);

   FSTPM(Adr1+sh1,tm1);
   FSTPM(Adr1,tm1);
   FSTPM(Adr2+sh2,tm2);
   FSTPM(Adr2,tm2);
   CheckStack(4);
   CheckStack(-4);
 end
 else
 if (Interp[NFunc].AI = 6) then
 begin
   if ts1 = _RE then FLD(Adr1,tm1) else  if ts1 = _IM then FLD(Adr1+sh1,tm1);
   if ts2 = _RE then FLD(Adr2,tm2) else  if ts2 = _IM then FLD(Adr2+sh2,tm2);

   if ts1 = _RE then FSTPM(Adr1,tm1) else  if ts1 = _IM then FSTPM(Adr1+sh1,tm1);
   if ts2 = _RE then FSTPM(Adr2,tm2) else  if ts2 = _IM then FSTPM(Adr2+sh2,tm2);

   CheckStack(2);
   CheckStack(-2);
 end
 else
 if (Interp[NFunc].AI = 4) then
 begin
   FLD(Adr1,tm1);
   if ts2 = _RE then FLD(Adr2,tm2) else  if ts2 = _IM then FLD(Adr2+sh2,tm2);

   FSTPM(Adr1,tm1);
   if ts2 = _RE then FSTPM(Adr2,tm2) else  if ts2 = _IM then FSTPM(Adr2+sh2,tm2);


   CheckStack(2);
   CheckStack(-2);
 end
 else
 if (Interp[NFunc].AI = 5) then
 begin
   FLD(Adr2,tm2);
   if ts1 = _RE then FLD(Adr1,tm1) else  if ts1 = _IM then FLD(Adr1+sh1,tm1);

   FSTPM(Adr2,tm2);
   if ts1 = _RE then FSTPM(Adr1,tm1) else  if ts1 = _IM then FSTPM(Adr1+sh1,tm1);


   CheckStack(2);
   CheckStack(-2);
 end;

end;






procedure TForevalH.FindNumberLevelA(num: Integer; var ANL: TArrayC);
var
j,IdN: Integer;
begin

IdN:=Interp[num].IdN;
for j:=1 to LFunc-1 do
begin
   if IdN = Interp[j].IdL then
   begin
    SetLength(ANL,Length(ANL)+1);
    ANL[High(ANL)]:=j;
   end;
end;

end;



{.213}
procedure TForevalH.JMP_C;
                   procedure CorrectStackIF(N: Integer);
                   begin
                     {.211}
                      //''     ( )   IF      N_Stack
                      // #JMP (AI=1)    IF
                      if Interp[N].AI = 1 then
                      begin
                        //   
                        if Interp[N-1].TypeF = T_Real then CheckStack(-1)       //if(x<y), if(x<y,x,y)
                         else
                        if Interp[N-1].TypeF = T_Complex then CheckStack(-2);   //if(x<y,z1,z2)
                        // else T_None                                          //if(x<y,goto())  if(x<y,goto(),goto())

                        // ,     IF:
                        {
                        NM:=Interp[N].NM;  //Interp[Interp[N].NM].NFunc = CM_IF !!! 
                        if NM > 0 then
                        begin
                          if Interp[NM].NFunc = CM_IF then
                          begin
                            if Interp[NM].TypeF = T_Real then CheckStack(-1) else
                            if Interp[NM].TypeF = T_Complex then CheckStack(-2); //else T_None
                          end;
                        end;
                        }
                      end;
                   end;
label endp;
var
P: ^Integer{Cardinal};
NC,CC,N1,N2,SZ,S,NCP,L,NCP1,NM: Cardinal;
NL,NB,CS,Adr1,Adr2,CS1,N: Cardinal;
ANL: TArrayC;
NN,CI: Integer;
begin
 //AI = 1       2      3       4      5      6     7       8
 //   #JMP, #JMPE, #JMPEL, #JMPEB, #JMPB, #JMPL, #JMPNE, JMP(goto)

N:=NFunc;

(*
if {F_Opt = True}F_Mode=M_DinamicLoad then
begin
//: DinamicLoad
 if (Interp[N].AI >= 2) and (Interp[N].AI <= 7) then CheckStack(-2); //FCOMPP
 //else CheckStack(-1);
 CorrectStackIF(N); {.211}
 goto endp;
end;
*)

// 
if F_JMP = 1 then
begin
  if (Interp[N].AI = 1) or (Interp[N].AI = 8) then     //JMP ,goto
  begin
   SetLength(ICOMP,Length(ICOMP)+5);
   ICOMP[High(ICOMP)-4]:=$E9;         //jmp
   CorrectStackIF(N);  {.211}
  end
  else    //CJMP
  begin
   // A1,A2  
   FindNumberLevelA(Interp[N].NM,ANL);      //NM - :  IFNOP
   N1:=ANL[0];    N2:=ANL[1];
   S:=Interp[Interp[N].NM].S;

   Adr1:=GetStackAdr(S,_RE);
   Adr2:=GetStackAdr(S+1,_RE);


   if (Interp[N1].SData1 = _MEM) and (Interp[N2].SData1 = _MEM) then
   begin

     //fld A1,fld A2
      FLD(Adr1,F_DataType);
      FLD(Adr2,F_DataType);
     {
     //12: fld A1,fld A2
     SetLength(ICOMP,Length(ICOMP)+12);
     CheckStack(2);
     if F_DataType = _Double then
     begin
       Adr1:=GetStackAdr(S,_RE);
       Adr2:=GetStackAdr(S+1,_RE);
       //fld qword ptr [Adr1]
       ICOMP[Length(ICOMP)-12]:=$DD; ICOMP[Length(ICOMP)-11]:=$05;
       P:=@ICOMP[Length(ICOMP)-10];
       P^:=Adr1;
       //fld qword ptr [Adr2]
       ICOMP[Length(ICOMP)-6]:=$DD; ICOMP[Length(ICOMP)-5]:=$05;
       P:=@ICOMP[Length(ICOMP)-4];
       P^:=Adr2;
     end
     else
     if F_DataType = _Extended then
     begin
       Adr1:=GetStackAdr(S,_RE);
       Adr2:=GetStackAdr(S+1,_RE);
       //fld tbyte ptr [Adr1]
       ICOMP[Length(ICOMP)-12]:=$DB; ICOMP[Length(ICOMP)-11]:=$2D;
       P:=@ICOMP[Length(ICOMP)-10];
       P^:=Adr1;
       //fld tbyte ptr [Adr2]
       ICOMP[Length(ICOMP)-6]:=$DB; ICOMP[Length(ICOMP)-5]:=$2D;
       P:=@ICOMP[Length(ICOMP)-4];
       P^:=Adr2;
     end;
     }
   end
   else
   if (Interp[N1].SData1 = _MEM) and (Interp[N2].SData1 = _FPU) then
   begin
     //fld A1
     FLD(Adr1,F_DataType);
     FXCH1;
     {
     //8: fld A1; fxch
     SetLength(ICOMP,Length(ICOMP)+8);
     CheckStack(1);
     if F_DataType = _Double then
     begin
       Adr1:=GetStackAdr(S,_RE);
       //fld qword ptr [Adr1]
       ICOMP[Length(ICOMP)-8]:=$DD; ICOMP[Length(ICOMP)-7]:=$05;
       P:=@ICOMP[Length(ICOMP)-6];
       P^:=Adr1;
     end
     else
     if F_DataType = _Extended then
     begin
       Adr1:=GetStackAdr(S,_RE);
       //fld tbyte ptr [Adr1]
       ICOMP[Length(ICOMP)-8]:=$DB; ICOMP[Length(ICOMP)-7]:=$2D;
       P:=@ICOMP[Length(ICOMP)-6];
       P^:=Adr1;
     end;
     //fxch
     ICOMP[Length(ICOMP)-2]:=$D9; ICOMP[Length(ICOMP)-1]:=$C9;
     SZ:=SZ-CC;
     }
   end
   else
   if (Interp[N1].SData1 = _FPU) and (Interp[N2].SData1 = _MEM) then
   begin
     // fld A2
     FLD(Adr2,F_DataType);
     {
     //6: fld A1
     SetLength(ICOMP,Length(ICOMP)+6);
     CheckStack(1);
     if F_DataType = _Double then
     begin
       Adr2:=GetStackAdr(S+1,_RE);
       //fld qword ptr [Adr2]
       ICOMP[Length(ICOMP)-6]:=$DD; ICOMP[Length(ICOMP)-5]:=$05;
       P:=@ICOMP[Length(ICOMP)-4];
       P^:=Adr2;
     end
     else
     if F_DataType = _Extended then
     begin
       Adr2:=GetStackAdr(S+1,_RE);
       //fld qword ptr [Adr2]
       ICOMP[Length(ICOMP)-6]:=$DB; ICOMP[Length(ICOMP)-5]:=$2D;
       P:=@ICOMP[Length(ICOMP)-4];
       P^:=Adr2;
     end;
     }
   end
   else
   if (Interp[N1].SData1 = _FPU) and (Interp[N2].SData1 = _FPU) then
   begin

   end;

   { P:=@ICOMP[0];
   asm
     call  P
   end;
   }

   {.217}
   {
   FCOMPP;
   FSTSW_AX;
   SAHF;
   JMPC(0,Interp[N].AI);
   }
   FCOMIP;
   FSTP0;
   JMPC(0,Interp[N].AI);

  {
   SetLength(ICOMP,Length(ICOMP)+11);   //11: fcompp, fstsw ax, sahf
   //fcompp:
   ICOMP[High(ICOMP)-10]:=$DE;  ICOMP[High(ICOMP)-9]:=$D9;
   //fstsw ax:
   ICOMP[High(ICOMP)-8]:=$DF;  ICOMP[High(ICOMP)-7]:=$E0;
   //sahf
   ICOMP[High(ICOMP)-6]:=$9E;


   case Interp[N].AI of
   2:   begin ICOMP[High(ICOMP)-5]:=$0F; ICOMP[High(ICOMP)-4]:=$84; end; //jz
   3:   begin ICOMP[High(ICOMP)-5]:=$0F; ICOMP[High(ICOMP)-4]:=$83; end; //jnb
   4:   begin ICOMP[High(ICOMP)-5]:=$0F; ICOMP[High(ICOMP)-4]:=$86; end; //jbe
   5:   begin ICOMP[High(ICOMP)-5]:=$0F; ICOMP[High(ICOMP)-4]:=$82; end; //jb
   6:   begin ICOMP[High(ICOMP)-5]:=$0F; ICOMP[High(ICOMP)-4]:=$87; end; //jnbe
   7:   begin ICOMP[High(ICOMP)-5]:=$0F; ICOMP[High(ICOMP)-4]:=$85; end; //jnz
   end;

   //if(x<y,sin(x),cos(x))

   CheckStack(-2);  //fcompp
   SetReg(1);       //eax
   }

  end;

end
else  //   JMP
if F_JMP =2 then
begin
  if (Interp[N].AI = 8) {and (Length(GotoLab)>0)} then  //GOTO
  begin
    NCP:=Interp[N].NCP;
    P:=@ICOMP[NCP-4];
    NN:=Interp[N].CI-2;
    if (NN = -1) or(Length(GotoLab) = 0) then
    begin
         {     OverFlowChecks,RangeChecks -On -    ! }
         {If there is an exception at OverFlowChecks,RangeChecks -On - it is no error !}

      //{$RangeChecks Off}
      //{$OverFlowChecks Off}
      P^:=-NCP;
      //{$RangeChecks On}
      //{$OverFlowChecks On}
    end
    else
    begin
     L:=GotoLab[NN];
     NCP1:=Interp[L].NCP;
       //{$RangeChecks Off}
       //{$OverFlowChecks Off}
     P^:=NCP1-NCP;
       //{$RangeChecks On}
       //{$OverFlowChecks On}
    end;
    goto endp;
  end;

  NN:=Interp[interp[N].NM].N;
  NL:=Interp[N].NL;      // -  :   '1'
  CI:=Interp[interp[N].NM].CI;  //CI=2: if(arg1,goto())
  FindNumberLevelA(Interp[N].NM,ANL);      //NM - :  IFNOP
  NB:=ANL[NL];           //ANL:    '0': ANL[NL]   - 
  CS:=Interp[NB].CS;     //   -
  NC:=Interp[N].NC;      //    ICOMP  
  CS1:=Interp[N].CS;     //   
  if Interp[N].AI = 1 then  //JMP
  begin
    //ICOMP[NC]:=$E9;
    P:=@ICOMP[NC{+1}+CS1-4];
    P^:=CS;
  end
  else  //CJMP
  begin
    P:=@ICOMP[NC+CS1-4];
    if NN = 6 then P^:=CS+5 else  //5 -   JMP: A1,A2,CJMP,A3,JMP,A4   A4: NL  NB   JMP
       if NN = 4 then P^:=5;      //if(arg,goto())     A1,A2,CJMP,JMP
                            //P^:=CS+5;  //5 -   JMP: A1,A2,CJMP,A3,JMP,A4   A4: NL  NB   JMP
    { if CI = 0 then P^:=CS+5 else
       if CI = 2 then P^:=5;  }      //      if(arg,goto())

  end;

  //CheckStack(-1);            {.211}
end;

endp:
end;



(*

procedure TForevalH.JMP_C;
                   procedure CorrectStackIF(N: Integer);
                   begin
                     {.211}
                      //''     ( )   IF      N_Stack
                      // #JMP (AI=1)    IF
                      if Interp[N].AI = 1 then
                      begin
                        //   
                        if Interp[N-1].TypeF = T_Real then CheckStack(-1)       //if(x<y), if(x<y,x,y)
                         else
                        if Interp[N-1].TypeF = T_Complex then CheckStack(-2);   //if(x<y,z1,z2)
                        // else T_None                                          //if(x<y,goto())  if(x<y,goto(),goto())

                        // ,     IF:
                        {
                        NM:=Interp[N].NM;  //Interp[Interp[N].NM].NFunc = CM_IF !!! 
                        if NM > 0 then
                        begin
                          if Interp[NM].NFunc = CM_IF then
                          begin
                            if Interp[NM].TypeF = T_Real then CheckStack(-1) else
                            if Interp[NM].TypeF = T_Complex then CheckStack(-2); //else T_None
                          end;
                        end;
                        }
                      end;
                   end;
label endp;
var
P: ^Integer{Cardinal};
NC,CC,N1,N2,SZ,S,NCP,L,NCP1,NM: Cardinal;
NL,NB,CS,Adr1,Adr2,CS1,N: Cardinal;
ANL: TArrayC;
NN,CI: Integer;
begin
 //AI = 1       2      3       4      5      6     7       8
 //   #JMP, #JMPE, #JMPEL, #JMPEB, #JMPB, #JMPL, #JMPNE, JMP(goto)

N:=NFunc;

if {F_Opt = True}F_Mode=M_DinamicLoad then
begin
//: DinamicLoad
 if (Interp[N].AI >= 2) and (Interp[N].AI <= 7) then CheckStack(-2); //FCOMPP
 //else CheckStack(-1);
 CorrectStackIF(N); {.211}
 goto endp;
end;

// 
if F_JMP = 1 then
begin
  if (Interp[N].AI = 1) or (Interp[N].AI = 8) then     //JMP ,goto
  begin
   SetLength(ICOMP,Length(ICOMP)+5);
   ICOMP[High(ICOMP)-4]:=$E9;         //jmp
   CorrectStackIF(N);  {.211}
  end
  else    //CJMP
  begin
   // A1,A2  
   FindNumberLevelA(Interp[N].NM,ANL);      //NM - :  IFNOP
   N1:=ANL[0];    N2:=ANL[1];
   S:=Interp[Interp[N].NM].S;
   if (Interp[N1].SData1 = _MEM) and (Interp[N2].SData1 = _MEM) then
   begin
     //12: fld A1,fld A2
     SetLength(ICOMP,Length(ICOMP)+12);
     CheckStack(2);
     if F_DataType = _Double then
     begin
       Adr1:=GetStackAdr(S,_RE);
       Adr2:=GetStackAdr(S+1,_RE);
       //fld qword ptr [Adr1]
       ICOMP[Length(ICOMP)-12]:=$DD; ICOMP[Length(ICOMP)-11]:=$05;
       P:=@ICOMP[Length(ICOMP)-10];
       P^:=Adr1;
       //fld qword ptr [Adr2]
       ICOMP[Length(ICOMP)-6]:=$DD; ICOMP[Length(ICOMP)-5]:=$05;
       P:=@ICOMP[Length(ICOMP)-4];
       P^:=Adr2;
     end
     else
     if F_DataType = _Extended then
     begin
       Adr1:=GetStackAdr(S,_RE);
       Adr2:=GetStackAdr(S+1,_RE);
       //fld tbyte ptr [Adr1]
       ICOMP[Length(ICOMP)-12]:=$DB; ICOMP[Length(ICOMP)-11]:=$2D;
       P:=@ICOMP[Length(ICOMP)-10];
       P^:=Adr1;
       //fld tbyte ptr [Adr2]
       ICOMP[Length(ICOMP)-6]:=$DB; ICOMP[Length(ICOMP)-5]:=$2D;
       P:=@ICOMP[Length(ICOMP)-4];
       P^:=Adr2;
     end;
   end
   else
   if (Interp[N1].SData1 = _MEM) and (Interp[N2].SData1 = _FPU) then
   begin
     //8: fld A1; fxch
     SetLength(ICOMP,Length(ICOMP)+8);
     CheckStack(1);
     if F_DataType = _Double then
     begin
       Adr1:=GetStackAdr(S,_RE);
       //fld qword ptr [Adr1]
       ICOMP[Length(ICOMP)-8]:=$DD; ICOMP[Length(ICOMP)-7]:=$05;
       P:=@ICOMP[Length(ICOMP)-6];
       P^:=Adr1;
     end
     else
     if F_DataType = _Extended then
     begin
       Adr1:=GetStackAdr(S,_RE);
       //fld tbyte ptr [Adr1]
       ICOMP[Length(ICOMP)-8]:=$DB; ICOMP[Length(ICOMP)-7]:=$2D;
       P:=@ICOMP[Length(ICOMP)-6];
       P^:=Adr1;
     end;
     //fxch
     ICOMP[Length(ICOMP)-2]:=$D9; ICOMP[Length(ICOMP)-1]:=$C9;
     SZ:=SZ-CC;
   end
   else
   if (Interp[N1].SData1 = _FPU) and (Interp[N2].SData1 = _MEM) then
   begin
     //6: fld A1
     SetLength(ICOMP,Length(ICOMP)+6);
     CheckStack(1);
     if F_DataType = _Double then
     begin
       Adr2:=GetStackAdr(S+1,_RE);
       //fld qword ptr [Adr2]
       ICOMP[Length(ICOMP)-6]:=$DD; ICOMP[Length(ICOMP)-5]:=$05;
       P:=@ICOMP[Length(ICOMP)-4];
       P^:=Adr2;
     end
     else
     if F_DataType = _Extended then
     begin
       Adr2:=GetStackAdr(S+1,_RE);
       //fld qword ptr [Adr2]
       ICOMP[Length(ICOMP)-6]:=$DB; ICOMP[Length(ICOMP)-5]:=$2D;
       P:=@ICOMP[Length(ICOMP)-4];
       P^:=Adr2;
     end;
   end
   else
   if (Interp[N1].SData1 = _FPU) and (Interp[N2].SData1 = _FPU) then
   begin

   end;

   { P:=@ICOMP[0];
   asm
     call  P
   end;
   }

   SetLength(ICOMP,Length(ICOMP)+11);   //11: fcompp, fstsw ax, sahf
   //fcompp:
   ICOMP[High(ICOMP)-10]:=$DE;  ICOMP[High(ICOMP)-9]:=$D9;
   //fstsw ax:
   ICOMP[High(ICOMP)-8]:=$DF;  ICOMP[High(ICOMP)-7]:=$E0;
   //sahf
   ICOMP[High(ICOMP)-6]:=$9E;


   case Interp[N].AI of
   2:   begin ICOMP[High(ICOMP)-5]:=$0F; ICOMP[High(ICOMP)-4]:=$84; end; //jz
   3:   begin ICOMP[High(ICOMP)-5]:=$0F; ICOMP[High(ICOMP)-4]:=$83; end; //jnb
   4:   begin ICOMP[High(ICOMP)-5]:=$0F; ICOMP[High(ICOMP)-4]:=$86; end; //jbe
   5:   begin ICOMP[High(ICOMP)-5]:=$0F; ICOMP[High(ICOMP)-4]:=$82; end; //jb
   6:   begin ICOMP[High(ICOMP)-5]:=$0F; ICOMP[High(ICOMP)-4]:=$87; end; //jnbe
   7:   begin ICOMP[High(ICOMP)-5]:=$0F; ICOMP[High(ICOMP)-4]:=$85; end; //jnz
   end;

   //if(x<y,sin(x),cos(x))
   { P:=@ICOMP[0];
   asm
     call  P
   end; }

   CheckStack(-2);  //fcompp
   SetReg(1);       //eax
  end;

end
else  //   JMP
if F_JMP =2 then
begin
  if (Interp[N].AI = 8) {and (Length(GotoLab)>0)} then  //GOTO
  begin
    NCP:=Interp[N].NCP;
    P:=@ICOMP[NCP-4];
    NN:=Interp[N].CI-2;
    if (NN = -1) or(Length(GotoLab) = 0) then
    begin
         {     OverFlowChecks,RangeChecks -On -    ! }
         {If there is an exception at OverFlowChecks,RangeChecks -On - it is no error !}

      //{$RangeChecks Off}
      //{$OverFlowChecks Off}
      P^:=-NCP;
      //{$RangeChecks On}
      //{$OverFlowChecks On}
    end
    else
    begin
     L:=GotoLab[NN];
     NCP1:=Interp[L].NCP;
       //{$RangeChecks Off}
       //{$OverFlowChecks Off}
     P^:=NCP1-NCP;
       //{$RangeChecks On}
       //{$OverFlowChecks On}
    end;
    goto endp;
  end;

  NN:=Interp[interp[N].NM].N;
  NL:=Interp[N].NL;      // -  :   '1'
  CI:=Interp[interp[N].NM].CI;  //CI=2: if(arg1,goto())
  FindNumberLevelA(Interp[N].NM,ANL);      //NM - :  IFNOP
  NB:=ANL[NL];           //ANL:    '0': ANL[NL]   - 
  CS:=Interp[NB].CS;     //   -
  NC:=Interp[N].NC;      //    ICOMP  
  CS1:=Interp[N].CS;     //   
  if Interp[N].AI = 1 then  //JMP
  begin
    //ICOMP[NC]:=$E9;
    P:=@ICOMP[NC{+1}+CS1-4];
    P^:=CS;
  end
  else  //CJMP
  begin
    P:=@ICOMP[NC+CS1-4];
    if NN = 6 then P^:=CS+5 else  //5 -   JMP: A1,A2,CJMP,A3,JMP,A4   A4: NL  NB   JMP
       if NN = 4 then P^:=5;      //if(arg,goto())     A1,A2,CJMP,JMP
                            //P^:=CS+5;  //5 -   JMP: A1,A2,CJMP,A3,JMP,A4   A4: NL  NB   JMP
    { if CI = 0 then P^:=CS+5 else
       if CI = 2 then P^:=5;  }      //      if(arg,goto())

  end;

  //CheckStack(-1);            {.211}
end;

endp:
end;
*)





procedure TForevalH.FLD_C(I: Integer);
begin
//FLD1
if Interp[i].AI = 1 then
begin
  FLD1;
end
else
//FLDZ
if Interp[i].AI = 2 then
begin
  FLDZ;
end
end;



procedure TForevalH.FLDV_RE(nv: Integer);
var
 Adr: Cardinal;
 tv,tm: Integer;
begin
 GetVar(nv,adr,tv,tm);
 if  tv = T_Real    then  FLD(Adr,tm)
 else
 if  tv = T_Complex  then FLD(Adr,tm)
 else
 if  tv = IM_UNIT  then   FLDZ;
end;




procedure TForevalH.FLDV_IM(nv: Integer);
var
 Adr: Cardinal;
 tv,tm: Integer;
begin
 GetVar(nv,adr,tv,tm);
 if  tv = T_Real    then FLDZ  else
 if  tv = T_Complex  then
 begin
     if tm = _Double    then   FLD(Adr+Sh_D,tm) else
     if tm = _Extended  then   FLD(Adr+Sh_E,tm)
 end
 else
 if  tv = IM_UNIT  then   FLD1;
end;



procedure TForevalH.FADDV(nv: Integer; st: Integer);
var
 Adr: Cardinal;                //st = T_Real,T_Complex
 tv,tm,sh: Integer;
begin
 GetVar(nv,adr,tv,tm);
 if (tm = _Extended) then sh:=SH_E else sh:=SH_D;

 if (tv = T_Real) and (st = T_Real)    then  FADD(adr,tm)
 else
 if (tv = T_Real) and (st = T_Complex) then  FADD(adr,tm)
 else
 if (tv = T_Complex) and (st = T_Real) then
 begin
   FADD(adr,tm); FLD(adr+sh,tm); FXCH1;
 end
 else
  if (tv = T_Complex) and (st = T_Complex) then
 begin
   FADD(adr,tm); FXCH1; FADD(adr+sh,tm); FXCH1;
 end
 else
 if (tv = IM_UNIT) and (st = T_Real) then
 begin
   FLD1;
   FXCH1;
 end
 else
 if (tv = IM_UNIT) and (st = T_Complex) then
 begin
   FLD1;
   FADDP2;
 end

end;




procedure TForevalH.FSUBV(nv: Integer; st: Integer; inv:Integer = 0);
var
 Adr: Cardinal;                //st = T_Real,T_Complex
 tv,tm,sh: Integer;
begin                          //S-v (inv=0); v-S (inv=1);
 GetVar(nv,adr,tv,tm);
 if (tm = _Extended) then sh:=SH_E else sh:=SH_D;

 if (tv = T_Real) and (st = T_Real)    then
 begin
  if (inv = 0) then  FSUB(adr,tm) else if (inv = 1) then FSUBR(adr,tm);
 end
 else
 if (tv = T_Real) and (st = T_Complex) then
 begin
  if (inv = 0) then  FSUB(adr,tm) else if (inv = 1) then begin FXCH1; FCHS; FXCH1; FSUBR(adr,tm); end
 end
 else
 if (tv = T_Complex) and (st = T_Real) then
 begin
   if (inv = 0) then
   begin
    FSUB(adr,tm); FLD(adr+sh,tm); FCHS; FXCH1;
   end
   else
   if (inv = 1) then
   begin
    FSUBR(adr,tm); FLD(adr+sh,tm); FXCH1;
   end
 end
 else
  if (tv = T_Complex) and (st = T_Complex) then
 begin
   if (inv = 0) then
   begin
    FSUB(adr,tm); FXCH1; FSUB(adr+sh,tm); FXCH1;
   end
   else
   if (inv = 1) then
   begin
    FSUBR(adr,tm); FXCH1; FSUBR(adr+sh,tm); FXCH1;
   end
 end
 else
 if (tv = IM_UNIT) and (st = T_Real) then
 begin
   if (inv = 0) then
   begin
    FLD1;
    FCHS;
    FXCH1;
   end
   else
   if (inv = 1) then
   begin
    FCHS;
    FLD1;
    FXCH1;
   end
 end
 else
 if (tv = IM_UNIT) and (st = T_Complex) then
 begin
   if (inv = 0) then
   begin
    FLD1;
    FSUBP2;
   end
   else
   if (inv = 1) then
   begin
    FCHS;
    FXCH1;
    FLD1;
    FSUBRP;
    FXCH1;
   end
 end

end;






procedure TForevalH.FMULV(nv: Integer; st: Integer);
var
 Adr,Adr_RE,Adr_IM: Cardinal;                //st = T_Real,T_Complex
 tv,tm,sh: Integer;
begin
 GetVar(nv,adr,tv,tm);
 if (tm = _Extended) then sh:=SH_E else sh:=SH_D;
 Adr_RE:=adr; Adr_IM:=adr+sh;

 if (tv = T_Real) and (st = T_Real)    then  FMUL(adr,tm)
 else
 if (tv = T_Real) and (st = T_Complex) then  begin FMUL(adr,tm); FXCH1; FMUL(adr,tm); FXCH1; end
 else
 if (tv = T_Complex) and (st = T_Real) then
 begin
   FLD0;
   FMUL(adr_im,tm); FXCH1; FMUL(adr_re,tm);
 end
 else
  if (tv = T_Complex) and (st = T_Complex) then
 begin
         FXCH1;
         FLD0;                                     //y1,y1,x1
         FMUL(adr_re,tm);                          //y1*x2,y1,x1
         FXCH2;                                    //x1,y1,y1*x2
         FLD0;                                     //x1,x1,y1,y1*x2
         FMUL(adr_im,tm);                          //x1*y2,x1,y1,y1*x2
         FADDP3;                                   //x1,y1,IM
         FMUL(adr_re,tm);                          //x1*x2,y1,IM
         FXCH1;                                    //y1,x1*x2,IM
         FMUL(adr_im,tm);                          //y1*y2,x1*x2,IM
         FSUBP;                                    //RE,IM
 end
 else
 if (tv = IM_UNIT) and (st = T_Real) then
 begin
   FLDZ;
 end
 else
 if (tv = IM_UNIT) and (st = T_Complex) then
 begin
   FXCH1;
   FCHS;
 end

end;





procedure TForevalH.FDIVV(nv: Integer; st: Integer; inv:Integer = 0);
var
 Adr,Adr_RE,Adr_IM: Cardinal;                //st = T_Real,T_Complex
 tv,tm,sh: Integer;
begin                          //S/v (inv=0); v/S (inv=1);
 GetVar(nv,adr,tv,tm);
 if (tm = _Extended) then sh:=SH_E else sh:=SH_D;
 Adr_RE:=adr; Adr_IM:=adr+sh;

 if (tv = T_Real) and (st = T_Real)    then
 begin
  if (inv = 0) then  FDIV(adr,tm) else if (inv = 1) then FDIVR(adr,tm);
 end
 else
 if (tv = T_Real) and (st = T_Complex) then
 begin
  if (inv = 0) then   // S(z)/r           (z1+z2)/x
  begin

    if F_FAST_DIV = True then
    begin
       //FAST DIV!!!
      FLD(adr,tm);
      FDIVR(TAddress(@S_C1),_Double);
      FMUL20;
      FMULP;
    end
    else
    begin
      FDIV(adr,tm);
      FXCH1;
      FDIV(adr,tm);
      FXCH1;
    end;

  end
  else
  if (inv = 1) then    // r/S(z)          x/(z1+z2)
  begin  //FAST DIV!!!
         FLDV(nv);
         //MOVAadr(TAddress(@Z_RZDIV));
         if F_FAST_DIV = True then
             MOVAadr(TAddress(@Z_RZDIV_FAST))    //FAST DIV!!!
                               else
             MOVAadr(TAddress(@Z_RZDIV));
         CALLA;
         CheckStack(1);
         CheckStack(-2);
  end
 end
 else
 if (tv = T_Complex) and (st = T_Real) then
 begin
   if (inv = 0) then   //S(r)(fpu)/z(mem)            // (x*y+x*y)/z1
   begin
       if F_FAST_DIV = True then
       begin
         //FAST DIV!!!
         FLDV_RE(nv);                               //x,r
         FMUL0;                                    //x^2,r
         FLDV_IM(nv);                               //y,x^2,r
         FMUL0;                                    //y^2,x^2,r
         FADDP;
         FLD1;
         FDIVRP;                                   //B,r (B=1/(x^2+y^2))

         FLDV_IM(nv);                               //y,B,r
         FMUL02;                                   //y*r,B,r
         FMUL01;                                   //y*B*r,B,r
         FCHS;                                     //IM,B,r
         FXCH2;                                    //r,B,IM
         FMULP;                                    //r*B,IM
         FMUL(Adr_RE,tm);                          //RE,IM
       end
       else
       begin
         FLDV_RE(nv);                               //x,r
         FMUL0;                                    //x^2,r
         FLDV_IM(nv);                               //y,x^2,r
         FMUL0;                                    //y^2,x^2,r
         FADDP;                                    //B,r (B=(x^2+y^2))
        
         FLDV_IM(nv);                               //y,B,r
         FMUL02;                                   //y*r,B,r
         FDIV01;                                   //y*r/B,B,r
         FCHS;                                     //IM,B,r
         FXCH2;                                    //r,B,IM
         FDIVRP;                                    //r/B,IM
         FMUL(Adr_RE,tm);                          //RE,IM
       end;
   end
   else
   if (inv = 1) then       //z(mem)/S(r)(fpu)        // z1/(x*y+x*y)
   begin

         if F_FAST_DIV = True then
         begin //FAST DIV !!!
            FDIVR(TAddress(@S_C1),_Double);
            FLD0;
            FMUL(adr_IM,tm);
            FXCH1;
            FMUL(adr_RE,tm);
         end
         else
         begin
            FLD0;
            FDIVR(adr_IM,tm);
            FXCH1;
            FDIVR(adr_RE,tm);
         end;
   end
 end
 else
  if (tv = T_Complex) and (st = T_Complex) then          // (z1+z2)/z1
 begin
   if (inv = 0) then                                //  S(z)(fpu)/z(mem)
   begin //FAST DIV!!!
         FLDV_IM(nv);
         FXCH2;
         FLDV_RE(nv);
         FXCH2;
         //MOVAadr(TAddress(@Z_DIV));
          if F_FAST_DIV = True then
          MOVAadr(TAddress(@Z_DIV_FAST))     //FAST DIV!!!
          else
          MOVAadr(TAddress(@Z_DIV));
         CALLA;
         CheckStack(2);
         CheckStack(-4);
   end
   else
   if (inv = 1) then                                  //  z(mem)/S(z)(fpu)
   begin //FAST DIV!!!                                   // z1/(z1+z2)
         FLDV_IM(nv);
         FLDV_RE(nv);
         //MOVAadr(TAddress(@Z_DIV));
          if F_FAST_DIV = True then
          MOVAadr(TAddress(@Z_DIV_FAST))     //FAST DIV!!!
          else
          MOVAadr(TAddress(@Z_DIV));
         CALLA;
         CheckStack(2);
         CheckStack(-4);
   end
 end
 else
 if (tv = IM_UNIT) and (st = T_Real) then
 begin
   if (inv = 1) then      // i/S(r)
   begin
    FLD1;
    FDIVRP;
    FLDZ;
   end
   else
   if (inv = 0) then     // S(r)/i
   begin
    FCHS;
    FLDZ;
   end
 end
 else
 if (tv = IM_UNIT) and (st = T_Complex) then
 begin
   if (inv = 1) then          //  i/S(z)         //  i/(z1+z2)
   begin

         if F_FAST_DIV = True then
         begin //FAST DIV !!!
           FLD0;
           FMUL0;                                  //x^2,x,y
           FXCH2;                                  //y,x,x^2
           FLD0;                                   //y,y,x,x^2
           FMUL0;                                  //y^2,y,x,x^2,
           FADDP3;                                 //y,x,y^2+x^2
           FXCH2;                                  //y^2+x^2,y,x
           FLD1;
           FDIVRP;                                 //B,y,x
           FMUL1;                                  //B,IM,x
           FMULP2;
           FXCH1;
         end
         else
         begin
           FLD0;
           FMUL0;                                  //x^2,x,y
           FXCH2;                                  //y,x,x^2
           FLD0;                                   //y,y,x,x^2
           FMUL0;                                  //y^2,y,x,x^2,
           FADDP3;                                 //y,x,y^2+x^2
           FXCH2;                                  //y^2+x^2,y,x
                                                    //B,y,x
           FDIV10;                                 //B,IM,x
           FDIVP2;
           FXCH1;
         end;
   end
   else
   if (inv = 0) then                //   S(z)/i
   begin
    FCHS;
    FXCH1;
   end
 end

end;






procedure TForevalH.FLDS(K: Integer; fm:Integer = _FPU);
var
S,st,t,N,NF: Integer;
begin                           //DL   (K -   = 0,1) !!!
 S:=Interp[NFunc].S;
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;

 if Interp[NFunc].TypeA = 0 then  t:=Alg.ExFunc[N].Func[NF].TV[K] else  t:=Interp[NFunc].TypeA;

st:=Interp[NFunc].RData[K];
if fm = _MEM then st:=_MEM;


if st = _MEM then
begin
  if t = T_Real then   FLD(GetStackAdr(S,_RE),F_DataType)
  else
  if t = T_Complex then
  begin
     FLD(GetStackAdr(S,_IM),F_DataType);
     FLD(GetStackAdr(S,_RE),F_DataType);
  end;
end;
end;





procedure TForevalH.SUB_C;
var
t1,t2,N,NF,S,st1,st2,Arg,nv1,nv2,Inv: Integer;

  procedure SUB_ST;
  begin
   if (t1 = T_Real) and (t2 = T_Real) then
   begin
    FLD(GetStackAdr(S,_RE),F_DataType);
    FSUB(GetStackAdr(S+1,_RE),F_DataType);
   end
   else
   if (t1 = T_Real) and (t2 = T_Complex) then
   begin
    FLD(GetStackAdr(S+1,_IM),F_DataType);
    FCHS;
    FLD(GetStackAdr(S,_RE),F_DataType);
    FSUB(GetStackAdr(S+1,_RE),F_DataType);
   end
   else
   if (t1 = T_Complex) and (t2 = T_Real) then
   begin
    FLD(GetStackAdr(S,_IM),F_DataType);
    FLD(GetStackAdr(S,_RE),F_DataType);
    FSUB(GetStackAdr(S+1,_RE),F_DataType);
   end
   else
   if (t1 = T_Complex) and (t2 = T_Complex) then
   begin
    FLD(GetStackAdr(S,_IM),F_DataType);
    FSUB(GetStackAdr(S+1,_IM),F_DataType);
    FLD(GetStackAdr(S,_RE),F_DataType);
    FSUB(GetStackAdr(S+1,_RE),F_DataType);
   end;
  end;


  procedure SUB_DL;
  begin
     if (t1 = T_Real) and (t2 = T_Real) then
     begin
        if (st1 = _FPU) and (st2 = _FPU) then
        begin
           FSUBP
        end
        else
        if (st1 = _FPU) and (st2 = _MEM) then
        begin
           FSUB(GetStackAdr(S+1,_RE),F_DataType)
        end
        else
        if (st1 = _MEM) and (st2 = _FPU) then
        begin
           FSUBR(GetStackAdr(S,_RE),F_DataType)
        end
        else
        if (st1 = _MEM) and (st2 = _MEM) then
        begin
          FLD(GetStackAdr(S,_RE),F_DataType);
          FSUB(GetStackAdr(S+1,_RE),F_DataType);
        end;
     end
    else
    if (t1 = T_Real) and (t2 = T_Complex) then
    begin
       if (st1 = _FPU) and (st2 = _FPU) then
       begin
         FSUBP2;
         FCHS;
         FXCH1;
       end
       else
       if (st1 = _FPU) and (st2 = _MEM) then
       begin
         FSUB(GetStackAdr(S+1,_RE),F_DataType);
         FLD(GetStackAdr(S+1,_IM),F_DataType);
         FXCH1;
       end
       else
       if (st1 = _MEM) and (st2 = _FPU) then
       begin
         FXCH1;
         FCHS;
         FXCH1;
         FSUBR(GetStackAdr(S,_RE),F_DataType);
       end
       else
       if (st1 = _MEM) and (st2 = _MEM) then
       begin
         FLD(GetStackAdr(S+1,_IM),F_DataType);
         FCHS;
         FLD(GetStackAdr(S,_RE),F_DataType);
         FSUB(GetStackAdr(S+1,_RE),F_DataType);
       end;
    end
    else
    if (t1 = T_Complex) and (t2 = T_Real) then
    begin
       if (st1 = _FPU) and (st2 = _FPU) then
       begin
         FSUBP;
       end
       else
       if (st1 = _FPU) and (st2 = _MEM) then
       begin
         FSUB(GetStackAdr(S+1,_RE),F_DataType);
       end
       else
       if (st1 = _MEM) and (st2 = _FPU) then
       begin
         FSUBR(GetStackAdr(S,_RE),F_DataType);
         FLD(GetStackAdr(S,_IM),F_DataType);
         FXCH1;
       end
       else
       if (st1 = _MEM) and (st2 = _MEM) then
       begin
         FLD(GetStackAdr(S,_IM),F_DataType);
         FLD(GetStackAdr(S,_RE),F_DataType);
         FSUB(GetStackAdr(S+1,_RE),F_DataType);
       end;
    end
    else
    if (t1 = T_Complex) and (t2 = T_Complex) then
    begin
       if (st1 = _FPU) and (st2 = _FPU) then
       begin
         FSUBP2;
         FSUBP2;
       end
       else
       if (st1 = _MEM) and (st2 = _MEM) then
       begin
         FLD(GetStackAdr(S,_IM),F_DataType);
         FSUB(GetStackAdr(S+1,_IM),F_DataType);
         FLD(GetStackAdr(S,_RE),F_DataType);
         FSUB(GetStackAdr(S+1,_RE),F_DataType);
       end
       else
       if (st1 = _FPU) and (st2 = _MEM) then
       begin
         FSUB(GetStackAdr(S+1,_RE),F_DataType);
         FXCH1;
         FSUB(GetStackAdr(S+1,_IM),F_DataType);
         FXCH1;
       end
       else
       if (st1 = _MEM) and (st2 = _FPU) then
       begin
         FSUBR(GetStackAdr(S,_RE),F_DataType);
         FXCH1;
         FSUBR(GetStackAdr(S,_IM),F_DataType);
         FXCH1;
       end;
    end;
  end;



  procedure SUB_VAR;                             //v1-v2
  var
    nv1,nv2,tv1,tv2,tm1,tm2,sh1,sh2: Integer;
    Adr1,Adr2,V1_RE,V1_IM,V2_RE,V2_IM: Cardinal;
  begin
   nv1:=Interp[NFunc].nv1;
   nv2:=Interp[NFunc].nv2;
   GetVar(nv1,adr1,tv1,tm1);
   GetVar(nv2,adr2,tv2,tm2);
   if (tm1 = _Extended) then sh1:=SH_E else sh1:=SH_D;
   if (tm2 = _Extended) then sh2:=SH_E else sh2:=SH_D;
   V1_RE:=adr1;
   V1_IM:=adr1+sh1;
   V2_RE:=adr2;
   V2_IM:=adr2+sh2;

   if (tv1 = T_Real) and (tv2 = T_Real) then         //r1+r2
   begin
     FLD(Adr1,tm1);  //FLDV(nv1);
     FSUB(Adr2,tm2); //FADDV(nv2,tv2);
   end
   else
   if (tv1 = T_Real) and (tv2 = IM_UNIT) then       //r1-i
   begin
     FLD1;
     FCHS;
     FLD(Adr1,tm1);
   end
   else
   if (tv1 = T_Real) and (tv2 = T_Complex) then       //r1-z2
   begin
     FLDV_IM(nv2);
     FCHS;
     FLDV(nv1);
     FSUB(V2_RE,tm2);
   end
   else
   if (tv1 = IM_UNIT) and (tv2 = T_Real) then         //i-r2
   begin
     FLD1;
     FLD(Adr2,tm2);
     FCHS;
   end
   else
   if (tv1 = T_Complex) and (tv2 = T_Real) then      //z1-r1
   begin
     FLDV(nv1);
     FSUB(Adr2,tm2);
   end
   else
   if (tv1 = T_Complex) and (tv2 = T_Complex) then   //z1-z2
   begin
     FLD(V1_IM,tm1);
     FSUB(V2_IM,tm2);
     FLD(V1_RE,tm1);
     FSUB(V2_RE,tm2);
   end
   else
   if (tv1 = IM_UNIT) and (tv2 = T_Complex) then       //i-z1
   begin
     FLD1;
     FSUB(V2_IM,tm2);
     FLDV_RE(nv2);
     FCHS;
   end
   else
   if (tv1 = T_Complex) and (tv2 = IM_UNIT) then        //z1-i
   begin
     FLDV_IM(nv1);
     FLD1;
     FSUBP;
     FLDV_RE(nv1);
   end;

  end;


///////////////////////////////////////MAIN/////////////////////////////////////
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 Arg:=Interp[NFunc].N;
 inv:=Interp[NFunc].Inv;
 t1:=Alg.ExFunc[N].Func[NF].TV[0]; t2:=Alg.ExFunc[N].Func[NF].TV[1];
 st1:=Interp[NFunc].RData[0]; st2:=Interp[NFunc].RData[1];
 nv1:=Interp[NFunc].NV1;
 nv2:=Interp[NFunc].NV2;

 if (Arg = 1) and (Interp[NFunc].TypeA <> 0) then  t1:=Interp[NFunc].TypeA;



 if F_SaveInFPU = False then
 begin
   if (Arg = 2) and (nv1 = -1) and (nv2 = -1) then         //S1-S2
   begin
    SUB_ST;
   end
   else
   if (Arg = 0) and (nv1 >= 0) and (nv2 >= 0) then         //v1-v2
   begin
      SUB_VAR;
   end
   else
   if (Arg = 1) and  (nv1 >= 0)     then                   //S-v1
   begin
      FLDS(0,_MEM);  FSUBV(nv1,t1,inv)
   end
   else
   if (Arg = 1) and  (nv1 = -1) and (nv2 = -1)  then       //S1-c
   begin
    FLDS(0,_MEM);
    if inv = 0 then FSUB(WriteData(NFunc),F_DataType)
    else
    if inv = 1 then
    begin
     if t1 = T_Real then
      FSUBR(WriteData(NFunc),F_DataType)
     else
     if t1 = T_Complex then
     begin
      FXCH1; FCHS; FXCH1; FSUBR(WriteData(NFunc),F_DataType);
     end;
    end
   end
   else
   if (Arg = 0) and (nv2 = -1)    then                     //v-c
   begin
     FLD(WriteData(NFunc),F_DataType);
     if inv = 0 then FSUBV(nv1,T_Real,1) else if inv = 1 then  FSUBV(nv1,T_Real,0);
   end
 end
 else
 if F_SaveInFPU = True then
 begin
   if (Arg = 2) and (nv1 = -1) and (nv2 = -1) then         //S1-S2
   begin
    SUB_DL;
   end
   else
   if (Arg = 0) and (nv1 >= 0) and (nv2 >= 0) then         //v1-v2
   begin
      SUB_VAR;
   end
   else
   if (Arg = 1) and  (nv1 >= 0)     then                   //S-v1
   begin
      FLDS(0);  FSUBV(nv1,t1,inv)
   end
   else
   if (Arg = 1) and  (nv1 = -1) and (nv2 = -1)  then       //S1-c
   begin
    FLDS(0);
    if inv = 0 then FSUB(WriteData(NFunc),F_DataType)
    else
    if inv = 1 then
    begin
     if t1 = T_Real then
      FSUBR(WriteData(NFunc),F_DataType)
     else
     if t1 = T_Complex then
     begin
      FXCH1; FCHS; FXCH1; FSUBR(WriteData(NFunc),F_DataType);
     end;
    end
   end
   else
   if (Arg = 0) and (nv2 = -1)    then                     //v-c
   begin
     FLD(WriteData(NFunc),F_DataType);
     if inv = 0 then FSUBV(nv1,T_Real,1) else if inv = 1 then  FSUBV(nv1,T_Real,0);

   end;
 end;

end;






procedure TForevalH.MUL_C;
var
t1,t2,N,NF,S,st1,st2,Arg,nv1,nv2,AdrC: Integer;

  procedure MUL_ST;
  begin
    if (t1 = T_Real) and (t2 = T_Real) then
  begin
   FLD(GetStackAdr(S,_RE),F_DataType);
   FMUL(GetStackAdr(S+1,_RE),F_DataType);
  end
  else
  if (t1 = T_Real) and (t2 = T_Complex) then
  begin
   FLD(GetStackAdr(S+1,_IM),F_DataType);
   FMUL(GetStackAdr(S,_RE),F_DataType);
   FLD(GetStackAdr(S+1,_RE),F_DataType);
   FMUL(GetStackAdr(S,_RE),F_DataType);
  end
  else
  if (t1 = T_Complex) and (t2 = T_Real) then
  begin
   FLD(GetStackAdr(S,_IM),F_DataType);
   FMUL(GetStackAdr(S+1,_RE),F_DataType);
   FLD(GetStackAdr(S,_RE),F_DataType);
   FMUL(GetStackAdr(S+1,_RE),F_DataType);
  end
  else
  if (t1 = T_Complex) and (t2 = T_Complex) then
  begin
   FLD(GetStackAdr(S+1,_IM),F_DataType);
   FLD(GetStackAdr(S+1,_RE),F_DataType);
   FLD(GetStackAdr(S,_IM),F_DataType);
   FLD(GetStackAdr(S,_RE),F_DataType);
   ZMULP;
   {MOVA1(TAddress(@Z_MUL));
   CALLA;}
  end;
  end;


  procedure MUL_DL;
  begin
    if (t1 = T_Real) and (t2 = T_Real) then
  begin
        if (st1 = _FPU) and (st2 = _FPU) then
        begin
           FMULP;
        end
        else
        if (st1 = _FPU) and (st2 = _MEM) then
        begin
           FMUL(GetStackAdr(S+1,_RE),F_DataType)
        end
        else
        if (st1 = _MEM) and (st2 = _FPU) then
        begin
           FMUL(GetStackAdr(S,_RE),F_DataType)
        end
        else
        if (st1 = _MEM) and (st2 = _MEM) then
        begin
          FLD(GetStackAdr(S,_RE),F_DataType);
          FMUL(GetStackAdr(S+1,_RE),F_DataType);
        end;
  end
  else
  if (t1 = T_Real) and (t2 = T_Complex) then
  begin
       if (st1 = _FPU) and (st2 = _FPU) then
       begin
         FMUL02;
         FXCH1;
         FMULP2;
       end
       else
       if (st1 = _FPU) and (st2 = _MEM) then
       begin
         FLD0;
         FMUL(GetStackAdr(S+1,_IM),F_DataType);
         FXCH1;
         FMUL(GetStackAdr(S+1,_RE),F_DataType);
       end
       else
       if (st1 = _MEM) and (st2 = _FPU) then
       begin
         FMUL(GetStackAdr(S,_RE),F_DataType);
         FXCH1;
         FMUL(GetStackAdr(S,_RE),F_DataType);
         FXCH1;
       end
       else
       if (st1 = _MEM) and (st2 = _MEM) then
       begin
         FLD(GetStackAdr(S+1,_IM),F_DataType);
         FMUL(GetStackAdr(S,_RE),F_DataType);
         FLD(GetStackAdr(S+1,_RE),F_DataType);
         FMUL(GetStackAdr(S,_RE),F_DataType);
       end;
  end
  else
  if (t1 = T_Complex) and (t2 = T_Real) then
  begin
       if (st1 = _FPU) and (st2 = _FPU) then
       begin
         FMUL1;
         FMULP2;
       end
       else
       if (st1 = _FPU) and (st2 = _MEM) then
       begin
         FMUL(GetStackAdr(S+1,_RE),F_DataType);
         FXCH1;
         FMUL(GetStackAdr(S+1,_RE),F_DataType);
         FXCH1;
       end
       else
       if (st1 = _MEM) and (st2 = _FPU) then
       begin
         FLD0;
         FMUL(GetStackAdr(S,_IM),F_DataType);
         FXCH1;
         FMUL(GetStackAdr(S,_RE),F_DataType);
       end
       else
       if (st1 = _MEM) and (st2 = _MEM) then
       begin
         FLD(GetStackAdr(S,_IM),F_DataType);
         FMUL(GetStackAdr(S+1,_RE),F_DataType);
         FLD(GetStackAdr(S,_RE),F_DataType);
         FMUL(GetStackAdr(S+1,_RE),F_DataType);
       end;
  end
  else
  if (t1 = T_Complex) and (t2 = T_Complex) then
  begin
       if (st1 = _FPU) and (st2 = _FPU) then
       begin
         {MOVA1(TAddress(@Z_MUL));
         CALLA;
         CheckStack(1);
         CheckStack(-3);}
         ZMULP;

       end
       else
       if (st1 = _MEM) and (st2 = _MEM) then      //RE:(x1*x2-y1*y2);IM(y1*x2+y2*x1)
       begin
         FLD(GetStackAdr(S,_IM),F_DataType);      //y1
         FMUL(GetStackAdr(S+1,_RE),F_DataType);   //y1*x2
         FLD(GetStackAdr(S+1,_IM),F_DataType);    //y2
         FMUL(GetStackAdr(S,_RE),F_DataType);     //y1*x1
         FADDP;                                   //IM
         FLD(GetStackAdr(S,_RE),F_DataType);      //x1
         FMUL(GetStackAdr(S+1,_RE),F_DataType);   //x1*x2
         FLD(GetStackAdr(S,_IM),F_DataType);      //y1
         FMUL(GetStackAdr(S+1,_IM),F_DataType);   //y1*y2
         FSUBP;                                   //RE
       end
       else
       if (st1 = _FPU) and (st2 = _MEM) then
       begin
         FXCH1;
         FLD0;                                     //y1,y1,x1
         FMUL(GetStackAdr(S+1,_RE),F_DataType);    //y1*x2,y1,x1
         FXCH2;                                    //x1,y1,y1*x2
         FLD0;                                     //x1,x1,y1,y1*x2
         FMUL(GetStackAdr(S+1,_IM),F_DataType);    //x1*y2,x1,y1,y1*x2
         FADDP3;                                   //x1,y1,IM
         FMUL(GetStackAdr(S+1,_RE),F_DataType);    //x1*x2,y1,IM
         FXCH1;                                    //y1,x1*x2,IM
         FMUL(GetStackAdr(S+1,_IM),F_DataType);    //y1*y2,x1*x2,IM
         FSUBP;                                    //RE,IM
       end
       else
       if (st1 = _MEM) and (st2 = _FPU) then
       begin
         FXCH1;
         FLD0;
         FMUL(GetStackAdr(S,_RE),F_DataType);
         FXCH2;
         FLD0;
         FMUL(GetStackAdr(S,_IM),F_DataType);
         FADDP3;
         FMUL(GetStackAdr(S,_RE),F_DataType);
         FXCH1;
         FMUL(GetStackAdr(S,_IM),F_DataType);
         FSUBP;
       end;
  end;

  end;



  procedure MUL_VAR;                             //v1*v2
  var
    nv1,nv2,tv1,tv2,tm1,tm2,sh1,sh2: Integer;
    Adr1,Adr2,V1_RE,V1_IM,V2_RE,V2_IM: Cardinal;
  begin
   nv1:=Interp[NFunc].nv1;
   nv2:=Interp[NFunc].nv2;
   GetVar(nv1,adr1,tv1,tm1);
   GetVar(nv2,adr2,tv2,tm2);
   if (tm1 = _Extended) then sh1:=SH_E else sh1:=SH_D;
   if (tm2 = _Extended) then sh2:=SH_E else sh2:=SH_D;
   V1_RE:=adr1;
   V1_IM:=adr1+sh1;
   V2_RE:=adr2;
   V2_IM:=adr2+sh2;

   if (tv1 = T_Real) and (tv2 = T_Real) then
   begin
     FLD(Adr1,tm1);  //FLDV(nv1);
     FMUL(Adr2,tm2); //FADDV(nv2,tv2);
   end
   else
   if (tv1 = T_Real) and (tv2 = IM_UNIT) then
   begin
     FLD(Adr1,tm1);
     FLDZ;
   end
   else
   if (tv1 = T_Real) and (tv2 = T_Complex) then
   begin
     FLDV_IM(nv2); FMUL(V1_RE,tm1);
     FLDV_RE(nv2); FMUL(V1_RE,tm1);
   end
   else
   if (tv1 = IM_UNIT) and (tv2 = T_Real) then
   begin
     FLD(Adr2,tm2);
     FLDZ;
   end
   else
   if (tv1 = T_Complex) and (tv2 = T_Real) then
   begin
     FLDV_IM(nv1); FMUL(V2_RE,tm2);
     FLDV_RE(nv1); FMUL(V2_RE,tm2);
   end
   else
   if (tv1 = T_Complex) and (tv2 = T_Complex) then
   begin
     FLDV_IM(nv1);        //y1
     FMUL(V2_RE,tm2);    //y1*x2
     FLDV_IM(nv2);        //y2
     FMUL(V1_RE,tm1);    //y2*x1
     FADDP;              //IM
     FLDV_RE(nv1);        //x1
     FMUL(V2_RE,tm2);    //x1*x2
     FLDV_IM(nv1);        //y1
     FMUL(V2_IM,tm2);    //y1*y2
     FSUBP;              //RE
   end
   else
   if (tv1 = IM_UNIT) and (tv2 = T_Complex) then
   begin
     FLDV_RE(nv2);
     FLDV_IM(nv2);
     FCHS;
   end
   else
   if (tv1 = T_Complex) and (tv2 = IM_UNIT) then
   begin
     FLDV_RE(nv1);
     FLDV_IM(nv1);
     FCHS;
   end

  end;

 /////////////////////////////////MAIN//////////////////////////////////////////
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 Arg:=Interp[NFunc].N;
 t1:=Alg.ExFunc[N].Func[NF].TV[0]; t2:=Alg.ExFunc[N].Func[NF].TV[1];
 st1:=Interp[NFunc].RData[0];
 st2:=Interp[NFunc].RData[1];
 nv1:=Interp[NFunc].NV1;
 nv2:=Interp[NFunc].NV2;

 if (Arg = 1) and (Interp[NFunc].TypeA <> 0) then  t1:=Interp[NFunc].TypeA;



 if F_SaveInFPU = False then
 begin
   if (Arg = 2) and (nv1 = -1) and (nv2 = -1) then         //S1*S2
   begin
    MUL_ST;
   end
   else
   if (Arg = 0) and (nv1 >= 0) and (nv2 >= 0) then         //v1*v2
   begin
    MUL_VAR;
   end
   else
   if (Arg = 1) and  (nv1 >= 0)     then                   //S*v1
   begin
    FLDS(0,_MEM);  FMULV(nv1,t1)
   end
   else
   if (Arg = 1) and  (nv1 = -1) and (nv2 = -1)  then       //S1*c
   begin
    FLDS(0,_MEM);
    if t1 = T_Real then FMUL(WriteData(NFunc),F_DataType)
    else
    if t1 = T_Complex then
    begin
     AdrC:=WriteData(NFunc);
     FMUL(AdrC,F_DataType);
     FXCH1;
     FMUL(AdrC,F_DataType);
     FXCH1;
    end;
   end
   else
   if (Arg = 0) and (nv2 = -1)    then                     //v*c
   begin
     FLD(WriteData(NFunc),F_DataType);
     FMULV(nv1,T_Real);
   end
 end
 else
 if F_SaveInFPU = True then
 begin
   if (Arg = 2) and (nv1 = -1) and (nv2 = -1) then         //S1*S2
   begin
    MUL_DL;
   end
   else
   if (Arg = 0) and (nv1 >= 0) and (nv2 >= 0) then         //v1*v2
   begin
      MUL_VAR;
   end
   else
   if (Arg = 1) and  (nv1 >= 0)     then                   //S*v1
   begin
    FLDS(0);  FMULV(nv1,t1);
   end
   else
   if (Arg = 1) and  (nv1 = -1) and (nv2 = -1)  then       //S1*c
   begin
    FLDS(0);
    if t1 = T_Real then FMUL(WriteData(NFunc),F_DataType)
    else
    if t1 = T_Complex then
    begin
     AdrC:=WriteData(NFunc);
     FMUL(AdrC,F_DataType);
     FXCH1;
     FMUL(AdrC,F_DataType);
     FXCH1;
    end;
   end
   else
   if (Arg = 0) and (nv2 = -1)    then                     //v*c
   begin
     FLD(WriteData(NFunc),F_DataType);
     FMULV(nv1,T_Real);
   end;
 end;


end;







procedure TForevalH.DIV_C;
var
t1,t2,N,NF,S,st1,st2,Arg,nv1,nv2,AdrC,inv: Integer;

  procedure DIV_ST;            //without optimization  DL
  begin
    if (t1 = T_Real) and (t2 = T_Real) then
   begin
    FLD(GetStackAdr(S,_RE),F_DataType);
    FDIV(GetStackAdr(S+1,_RE),F_DataType);
   end
   else
   if (t1 = T_Real) and (t2 = T_Complex) then
   begin
    FLD(GetStackAdr(S+1,_IM),F_DataType);    // (x*y+x*y)/(z1*z2+z1*z2)
    FLD(GetStackAdr(S+1,_RE),F_DataType);
    FLD(GetStackAdr(S,_RE),F_DataType);

    if F_FAST_DIV = True then
          MOVAadr(TAddress(@Z_RZDIV_FAST))    //FAST DIV!!!
    else
          MOVAadr(TAddress(@Z_RZDIV));
    CALLA;

   end
   else
   if (t1 = T_Complex) and (t2 = T_Real) then    //(z1*z2+z1*z2)/(x*y+x*y)
   begin
    //FAST DIV!!!
    if F_FAST_DIV = True then
    begin
      FLD(GetStackAdr(S+1,_RE),F_DataType);
      FDIVR(TAddress(@S_C1),_Double);
      FLD(GetStackAdr(S,_RE),F_DataType);
      FMUL01;
      FXCH1;
      FMUL(GetStackAdr(S,_IM),F_DataType);
      FXCH1;
    end
    else
    begin
      FLD(GetStackAdr(S,_IM),F_DataType);
      FDIV(GetStackAdr(S+1,_RE),F_DataType);     //(z1+z2)/(x+y)     z1/x
      FLD(GetStackAdr(S,_RE),F_DataType);
      FDIV(GetStackAdr(S+1,_RE),F_DataType);
    end;
   end
   else
   if (t1 = T_Complex) and (t2 = T_Complex) then
   begin
    FLD(GetStackAdr(S+1,_IM),F_DataType);
    FLD(GetStackAdr(S+1,_RE),F_DataType);
    FLD(GetStackAdr(S,_IM),F_DataType);
    FLD(GetStackAdr(S,_RE),F_DataType);
     if F_FAST_DIV = True then
          MOVAadr(TAddress(@Z_DIV_FAST))     //FAST DIV!!!
     else
          MOVAadr(TAddress(@Z_DIV));
    CALLA;
   end;
  end;



  procedure DIV_DL;
  begin
     if (t1 = T_Real) and (t2 = T_Real) then
  begin
        if (st1 = _FPU) and (st2 = _FPU) then
        begin
           FDIVP;
        end
        else
        if (st1 = _FPU) and (st2 = _MEM) then
        begin
           FDIV(GetStackAdr(S+1,_RE),F_DataType)
        end
        else
        if (st1 = _MEM) and (st2 = _FPU) then
        begin
           FDIVR(GetStackAdr(S,_RE),F_DataType)
        end
        else
        if (st1 = _MEM) and (st2 = _MEM) then
        begin
          FLD(GetStackAdr(S,_RE),F_DataType);
          FDIV(GetStackAdr(S+1,_RE),F_DataType);
        end;
  end
  else
  if (t1 = T_Real) and (t2 = T_Complex) then
  begin
       if (st1 = _FPU) and (st2 = _FPU) then
       begin
          FXCH1;
          FXCH2;

          if F_FAST_DIV = True then
                MOVAadr(TAddress(@Z_RZDIV_FAST))    //FAST DIV!!!
                               else
                MOVAadr(TAddress(@Z_RZDIV));

          CALLA;
          CheckStack(1);
          CheckStack(-2);
       end
       else
       if (st1 = _FPU) and (st2 = _MEM) then       //FAST DIV!!!
       begin

          //FAST DIV!!!
          if F_FAST_DIV = True then
          begin
            FLD(GetStackAdr(S+1,_RE),F_DataType);     //x,r
            FMUL0;                                    //x^2,r
            FLD(GetStackAdr(S+1,_IM),F_DataType);     //y,x^2,r
            FMUL0;                                    //y^2,x^2,r
            FADDP;
            FLD1;
            FDIVRP;                                   //B,r (B=1/(x^2+y^2))

            FLD(GetStackAdr(S+1,_IM),F_DataType);     //y,B,r
            FMUL02;                                   //y*r,B,r
            FMUL01;                                   //y*B*r,B,r
            FCHS;                                     //IM,B,r
            FXCH2;                                    //r,B,IM
            FMULP;                                    //r*B,IM
            FMUL(GetStackAdr(S+1,_RE),F_DataType);    //RE,IM
          end
          else
          begin
            FLD(GetStackAdr(S+1,_RE),F_DataType);     //x,r
            FMUL0;                                    //x^2,r
            FLD(GetStackAdr(S+1,_IM),F_DataType);     //y,x^2,r
            FMUL0;                                    //y^2,x^2,r
            FADDP;

            FLD(GetStackAdr(S+1,_IM),F_DataType);     //y,B,r
            FMUL02;                                   //y*r,B,r
            FDIV01;                                    //y*r/B,B,r
            FCHS;                                     //IM,B,r
            FXCH2;                                    //r,B,IM
            FDIVRP;                                   //r/B,IM
            FMUL(GetStackAdr(S+1,_RE),F_DataType);    //RE,IM
          end;

       end
       else
       if (st1 = _MEM) and (st2 = _FPU) then
       begin
         FLD(GetStackAdr(S,_RE),F_DataType);

         if F_FAST_DIV = True then
             MOVAadr(TAddress(@Z_RZDIV_FAST))    //FAST DIV!!!
                               else
             MOVAadr(TAddress(@Z_RZDIV));

         CALLA;
         CheckStack(1);
         CheckStack(-2);
       end
       else
       if (st1 = _MEM) and (st2 = _MEM) then
       begin                                     //FAST DIV!!!
         //FAST DIV!!!
          if F_FAST_DIV = True then
          begin

            FLD(GetStackAdr(S+1,_RE),F_DataType);
            FMUL0;
            FLD(GetStackAdr(S+1,_IM),F_DataType);
            FMUL0;
            FADDP;
            FLD1;
            FDIVRP;   //B=1/x^2+y^2

            FLD(GetStackAdr(S+1,_RE),F_DataType);
            FMUL(GetStackAdr(S,_RE),F_DataType);
            FMUL01;   //RE,B

            FLD(GetStackAdr(S+1,_IM),F_DataType);
            FMUL(GetStackAdr(S,_RE),F_DataType);
            FCHS;
            FMULP2;
          end
          else
          begin
            FLD(GetStackAdr(S+1,_RE),F_DataType);
            FMUL0;
            FLD(GetStackAdr(S+1,_IM),F_DataType);
            FMUL0;
            FADDP;


            FLD(GetStackAdr(S+1,_RE),F_DataType);
            FMUL(GetStackAdr(S,_RE),F_DataType);
            FDIV01;

            FLD(GetStackAdr(S+1,_IM),F_DataType);
            FMUL(GetStackAdr(S,_RE),F_DataType);
            FCHS;
            FDIVRP2;
          end;
       end;
  end
  else
  if (t1 = T_Complex) and (t2 = T_Real) then
  begin
       if (st1 = _FPU) and (st2 = _FPU) then    // (z1+z2)/(x+y)
       begin

          if F_FAST_DIV = True then
          begin
              //FAST DIV!!!
             FDIVR(TAddress(@S_C1),_Double);
             FMUL20;
             FMULP;
          end
          else
          begin
             FDIV2;
             FDIVP;
          end;

       end
       else
       if (st1 = _FPU) and (st2 = _MEM) then        //sin(z1*sin(z1)/cos(x)*(sin(z1)/cos(x)))/(sin(z1)/cos(x))
       begin                                        //(z1*(z1)/(x)*((z1)/(x)))/((z1)/(x))
         //FAST DIV!!!                              //(z1)/(x)/(z1)/(x)
                                                   //(z1*z1)/sin(x*y+x*y*(x*y+x))/(z1*z2)/sin(x*y+x*y*(x*y+x))
                                                   //sin(z1)/sin(x)
         if F_FAST_DIV = True then
         begin
           FLD(GetStackAdr(S+1,_RE),F_DataType);
           FDIVR(TAddress(@S_C1),_Double);
           FMUL1;
           FXCH2;
           FMULP20;
         end
         else
         begin
           FDIV(GetStackAdr(S+1,_RE),F_DataType);
           FXCH1;
           FDIV(GetStackAdr(S+1,_RE),F_DataType);
           FXCH1;
         end;

       end
       else
       if (st1 = _MEM) and (st2 = _FPU) then           //sin(z1)/sin(x)
       begin
         //FAST DIV!!!
         if F_FAST_DIV = True then
         begin
           FDIVR(TAddress(@S_C1),_Double);
           FLD0;
           FMUL(GetStackAdr(S,_IM),F_DataType);
           FXCH1;
           FMUL(GetStackAdr(S,_RE),F_DataType);
         end
         else
         begin
           FLD0;
           FDIVR(GetStackAdr(S,_IM),F_DataType);
           FXCH1;
           FDIVR(GetStackAdr(S,_RE),F_DataType);
         end;
       end
       else
       if (st1 = _MEM) and (st2 = _MEM) then           //sin(z1)/cos(x)
       begin
         //FAST DIV!!!
         if F_FAST_DIV = True then
         begin
           FLD(GetStackAdr(S+1,_RE),F_DataType);
           FDIVR(TAddress(@S_C1),_Double);
           FLD0;
           FMUL(GetStackAdr(S,_IM),F_DataType);
           FXCH1;
           FMUL(GetStackAdr(S,_RE),F_DataType);
         end
         else
         begin
           FLD(GetStackAdr(S,_IM),F_DataType);
           FDIV(GetStackAdr(S+1,_RE),F_DataType);
           FLD(GetStackAdr(S,_RE),F_DataType);
           FDIV(GetStackAdr(S+1,_RE),F_DataType);
         end;
       end;
  end
  else
  if (t1 = T_Complex) and (t2 = T_Complex) then
  begin
       if (st1 = _FPU) and (st2 = _FPU) then
       begin
         FXCH2;
         FXCH1;
         FXCH3;
         FXCH1;
         //MOVAadr(TAddress(@Z_DIV));         //FAST DIV!!!

          if F_FAST_DIV = True then
             MOVAadr(TAddress(@Z_DIV_FAST))    //FAST DIV!!!
                               else
             MOVAadr(TAddress(@Z_DIV));
         CALLA;
         CheckStack(2);
         CheckStack(-4);
       end
       else
       if (st1 = _MEM) and (st2 = _MEM) then
       begin
         FLD(GetStackAdr(S+1,_IM),F_DataType);
         FLD(GetStackAdr(S+1,_RE),F_DataType);
         FLD(GetStackAdr(S,_IM),F_DataType);
         FLD(GetStackAdr(S,_RE),F_DataType);
         //MOVAadr(TAddress(@Z_DIV));               //FAST DIV!!!
         if F_FAST_DIV = True then
             MOVAadr(TAddress(@Z_DIV_FAST))    //FAST DIV!!!
                               else
             MOVAadr(TAddress(@Z_DIV));
         CALLA;
         CheckStack(2);
         CheckStack(-4);
       end
       else
       if (st1 = _FPU) and (st2 = _MEM) then
       begin
         FLD(GetStackAdr(S+1,_IM),F_DataType);
         FXCH2;
         FLD(GetStackAdr(S+1,_RE),F_DataType);
         FXCH2;
         //MOVAadr(TAddress(@Z_DIV));               //FAST DIV!!!
         if F_FAST_DIV = True then
             MOVAadr(TAddress(@Z_DIV_FAST))    //FAST DIV!!!
                               else
             MOVAadr(TAddress(@Z_DIV));
         CALLA;
         CheckStack(2);
         CheckStack(-4);
       end
       else
       if (st1 = _MEM) and (st2 = _FPU) then
       begin
         FLD(GetStackAdr(S,_IM),F_DataType);
         FLD(GetStackAdr(S,_RE),F_DataType);
         //MOVAadr(TAddress(@Z_DIV));               //FAST DIV!!!
         if F_FAST_DIV = True then
             MOVAadr(TAddress(@Z_DIV_FAST))    //FAST DIV!!!
                               else
             MOVAadr(TAddress(@Z_DIV));
         CALLA;
         CheckStack(2);
         CheckStack(-4);
       end;
  end;
  end;





  procedure DIV_VAR;                             // v1/v2
  var
    nv1,nv2,tv1,tv2,tm1,tm2,sh1,sh2: Integer;
    Adr1,Adr2,V1_RE,V1_IM,V2_RE,V2_IM: Cardinal;
  begin
   nv1:=Interp[NFunc].nv1;
   nv2:=Interp[NFunc].nv2;
   GetVar(nv1,adr1,tv1,tm1);
   GetVar(nv2,adr2,tv2,tm2);
   if (tm1 = _Extended) then sh1:=SH_E else sh1:=SH_D;
   if (tm2 = _Extended) then sh2:=SH_E else sh2:=SH_D;
   V1_RE:=adr1;
   V1_IM:=adr1+sh1;
   V2_RE:=adr2;
   V2_IM:=adr2+sh2;

   if (tv1 = T_Real) and (tv2 = T_Real) then
   begin
     FLD(Adr1,tm1);  //FLDV(nv1);
     FDIV(Adr2,tm2); //FADDV(nv2,tv2);
   end
   else
   if (tv1 = T_Real) and (tv2 = IM_UNIT) then
   begin
     FLD(Adr1,tm1);
     FCHS;
     FLDZ;
   end
   else
   if (tv1 = T_Real) and (tv2 = T_Complex) then
   begin
      if F_FAST_DIV = True then
      begin
         FLDV_RE(nv2);                           //FAST DIV!!!
         FMUL0;
         FLDV_IM(nv2);
         FMUL0;
         FADDP;
         FLD1;
         FDIVRP;   //B=1/x^2+y^2

         FLDV_RE(nv2);
         FMUL(V1_RE,tm1);
         FMUL01;   //RE,B

         FLDV_IM(nv2);
         FMUL(V1_RE,tm1);
         FCHS;
         FMULP2;
      end
      else
      begin
         FLDV_RE(nv2);
         FMUL0;
         FLDV_IM(nv2);
         FMUL0;
         FADDP;
        
         FLDV_RE(nv2);
         FMUL(V1_RE,tm1);
         FDIV01;   //RE,B

         FLDV_IM(nv2);
         FMUL(V1_RE,tm1);
         FCHS;
         FDIVRP2;
      end;

   end
   else
   if (tv1 = IM_UNIT) and (tv2 = T_Real) then
   begin
     FLD(Adr2,tm2);
     FLD1;
     FDIVRP;
     FLDZ;
   end
   else
   if (tv1 = T_Complex) and (tv2 = T_Real) then
   begin
      //FAST DIV!!!
      if F_FAST_DIV = True then
      begin
         FLD(V2_RE,tm2);
         FDIVR(TAddress(@S_C1),_Double);
         FLD0;
         FMUL(V1_IM,tm1);
         FXCH1;
         FMUL(V1_RE,tm1);
       end
       else
       begin
         FLDV_IM(nv1); FDIV(V2_RE,tm2);
         FLDV_RE(nv1); FDIV(V2_RE,tm2);
       end;


   end
   else
   if (tv1 = T_Complex) and (tv2 = T_Complex) then
   begin

         FLDV(nv2);
         FLDV(nv1);

         if F_FAST_DIV = True then
             MOVAadr(TAddress(@Z_DIV_FAST))    //FAST DIV!!!
                               else
             MOVAadr(TAddress(@Z_DIV));

         CALLA;
         CheckStack(2);
         CheckStack(-4);
   end
   else
   if (tv1 = IM_UNIT) and (tv2 = T_Complex) then    //FAST DIV!!!
   begin
         if F_FAST_DIV = True then
         begin
           FLDV_RE(nv2);
           FMUL0;
           FLDV_IM(nv2);
           FMUL0;
           FADDP;
           FLD1;
           FDIVRP;   //B=1/x^2+y^2

           FLD0;
           FMUL(V2_RE,tm2);
           FXCH1;
           FMUL(V2_IM,tm2);
         end
         else
         begin
           FLDV_RE(nv2);
           FMUL0;
           FLDV_IM(nv2);
           FMUL0;
           FADDP;
      
           FLD0;
           FDIVR(V2_RE,tm2);
           FXCH1;
           FDIVR(V2_IM,tm2);
         end;

   end
   else
   if (tv1 = T_Complex) and (tv2 = IM_UNIT) then
   begin
     FLDV_RE(nv1);
     FCHS;
     FLDV_IM(nv1);
   end

  end;



 /////////////////////////////////MAIN//////////////////////////////////////////
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 Arg:=Interp[NFunc].N;
 t1:=Alg.ExFunc[N].Func[NF].TV[0]; t2:=Alg.ExFunc[N].Func[NF].TV[1];
 st1:=Interp[NFunc].RData[0]; st2:=Interp[NFunc].RData[1];
 nv1:=Interp[NFunc].NV1;
 nv2:=Interp[NFunc].NV2;
 inv:=Interp[NFunc].Inv;

 if (Arg = 1) and (Interp[NFunc].TypeA <> 0) then  t1:=Interp[NFunc].TypeA;



 if F_SaveInFPU = False then
 begin
   if (Arg = 2) and (nv1 = -1) and (nv2 = -1) then         // S1/S2
   begin
    DIV_ST;
   end
   else
   if (Arg = 0) and (nv1 >= 0) and (nv2 >= 0) then         // v1/v2
   begin
    DIV_VAR;
   end
   else
   if (Arg = 1) and  (nv1 >= 0)     then                   // S/v1; v1/S
   begin
    FLDS(0,_MEM);  FDIVV(nv1,t1,inv)
   end
   else
   if (Arg = 1) and  (nv1 = -1) and (nv2 = -1)  then       // S1/c; c/S1
   begin
     FLDS(0,_MEM);
     if t1 = T_Real then
     begin
      if inv = 0 then FDIV(WriteData(NFunc),F_DataType) else
        if inv = 1 then  FDIVR(WriteData(NFunc),F_DataType);
     end
     else
     if t1 = T_Complex then
     begin

      if inv = 0 then               //xxx                 // (z1*z2+z1*(z1+z2))/50.123;   (DL=3)
      begin
         if F_FAST_DIV = True then
         begin
           AdrC:=WriteData(NFunc);
           FLD(AdrC,F_DataType);
           FDIVR(TAddress(@S_C1),_Double);
           FMUL1;
           FXCH2;
           FMULP20;
         end
         else
         begin
           AdrC:=WriteData(NFunc);
           FDIV(AdrC,F_DataType);
           FXCH1;
           FDIV(AdrC,F_DataType);
           FXCH1;
         end;

      end
      else
      if inv = 1 then
      begin
         FLD(WriteData(NFunc),F_DataType);
         //MOVAadr(TAddress(@Z_RZDIV));
         if F_FAST_DIV = True then
             MOVAadr(TAddress(@Z_RZDIV_FAST))    //FAST DIV!!!
                               else
             MOVAadr(TAddress(@Z_RZDIV));
         CALLA;
         CheckStack(1);
         CheckStack(-2);
      end;
     end
   end
   else
   if (Arg = 0) and (nv2 = -1)    then                     // v1/c; c/v1
   begin
     if inv = 0 then inv:=1 else inv:=0;

     FLD(WriteData(NFunc),F_DataType);
     FDIVV(nv1,T_Real,inv);
   end
 end
 else
 if F_SaveInFPU = True then
 begin
   if (Arg = 2) and (nv1 = -1) and (nv2 = -1) then         // S1/S2
   begin
    DIV_DL;
   end
   else
   if (Arg = 0) and (nv1 >= 0) and (nv2 >= 0) then         // v1/v2
   begin
      DIV_VAR;
   end
   else
   if (Arg = 1) and  (nv1 >= 0)     then                   // S/v1;v1/S
   begin
    FLDS(0);  FDIVV(nv1,t1,inv);
   end
   else
   if (Arg = 1) and  (nv1 = -1) and (nv2 = -1)  then       // S1/c; c/S1
   begin
     FLDS(0);
     if t1 = T_Real then
     begin
      if inv = 0 then FDIV(WriteData(NFunc),F_DataType) else
        if inv = 1 then  FDIVR(WriteData(NFunc),F_DataType);
     end
     else
     if t1 = T_Complex then
     begin
      if inv = 0 then
      begin
        if F_FAST_DIV = True then                           // (z1*z2+z1*(z1+z2))/50.123;
         begin
           //FAST DIV!!!
           AdrC:=WriteData(NFunc);
           FLD(AdrC,F_DataType);
           FDIVR(TAddress(@S_C1),_Double);
           FMUL1;
           FXCH2;
           FMULP20;
         end
         else
         begin
           AdrC:=WriteData(NFunc);
           FDIV(AdrC,F_DataType);
           FXCH1;
           FDIV(AdrC,F_DataType);
           FXCH1;
       end
      end
      else
      if inv = 1 then
      begin
         FLD(WriteData(NFunc),F_DataType);
         //MOVAadr(TAddress(@Z_RZDIV));               //FAST DIV!!!
         if F_FAST_DIV = True then
             MOVAadr(TAddress(@Z_RZDIV_FAST))    //FAST DIV!!!
                               else
             MOVAadr(TAddress(@Z_RZDIV));
         CALLA;
         CheckStack(1);
         CheckStack(-2);
      end;
     end
   end
   else
   if (Arg = 0) and (nv2 = -1)    then                     // v1/c; c/v1
   begin
     if inv = 0 then inv:=1 else inv:=0;

     FLD(WriteData(NFunc),F_DataType);
     FDIVV(nv1,T_Real,inv);
   end;

 end;
end;




procedure TForevalH.FMUL(N: TAddress; VType: Integer);
begin
 if VType = _Extended then
 begin
  FLD(N,_Extended);
  FMULP1;
 end
 else
 if VType = _Double then
 begin
  AddCom($DC,$0D,N);
 end
 else
 if VType = _Single then
 begin
  AddCom($D8,$0D,N);
 end
 else
 if VType = _Integer then
 begin
  AddCom($DA,$0D,N);
 end;
end;



procedure TForevalH.FMUL0;
begin          //fmul st(0),st(0)
 AddWord($D8,$C8);
end;



procedure TForevalH.FMUL1;
begin       //fmul st(1),st(0)
 AddWord($DC,$C9);
end;


procedure TForevalH.FMUL02;
begin      //fmul st(0),st(2)
 AddWord($D8,$CA);
end;

procedure TForevalH.FMUL01;
begin      //fmul st(0),st(1)
 AddWord($D8,$C9);
end;



procedure TForevalH.FMUL03;
begin      //fmul st(0),st(3)
 AddWord($D8,$CB);
end;


procedure TForevalH.FMUL04;
begin      //fmul st(0),st(4)
 AddWord($D8,$CC);
end;

procedure TForevalH.FMUL05;
begin      //fmul st(0),st(5)
 AddWord($D8,$CD);
end;


procedure TForevalH.FMUL10;
begin      //fmul st(1),st(0)
 AddWord($DC,$C9);
end;


procedure TForevalH.FSQRT;
begin
AddWord($D9,$FA);
end;




procedure TForevalH.FDIV(N: TAddress; VType: Integer);
begin
 if VType = _Extended then
 begin
  FLD(N,_Extended);
  FDIVP;
 end
 else
 if VType = _Double  then
 begin
  AddCom($DC,$35,N);
 end
 else
 if VType = _Single then
 begin
   AddCom($D8,$35,N);
 end
 else
 if VType = _Integer then
 begin
   AddCom($DA,$35,N);
 end;
end;




procedure TForevalH.FDIVR(N: TAddress; VType: Integer);
begin
 if VType = _Extended then
 begin
 FLD(N,_Extended);
 FDIVRP;
 end
 else
 if VType = _Double then
 begin
 AddCom($DC,$3D,N);
 end
 else
 if VType = _Single then
 begin
   AddCom($D8,$3D,N);
 end
 else
 if VType = _Integer then
 begin
   AddCom($DA,$3D,N);
 end;
end;



procedure TForevalH.FDIVP;
begin
 AddWord($DE,$F9);
 CheckStack(-1);
end;



procedure TForevalH.FDIV01;
begin      //fdiv st(0),st(1)
 AddWord($D8,$F1);
end;




procedure TForevalH.FDIV10;
begin      //fdiv st(1),st(0)
 AddWord($DC,$F9);
end;


procedure TForevalH.FDIVP2;
begin     //fdivp st(2),st(0)
 AddWord($DE,$FA);
 CheckStack(-1);
end;


procedure TForevalH.FDIVP3;
begin     //fdivp st(3),st(0)
 AddWord($DE,$FB);
 CheckStack(-1);
end;



procedure TForevalH.FDIVRP2;
begin     //fdivrp st(2),st(0)
 AddWord($DE,$F2);
 CheckStack(-1);
end;




procedure TForevalH.FDIVRP3;
begin     //fdivrp st(3),st(0)
 AddWord($DE,$F3);
 CheckStack(-1);
end;


procedure TForevalH.FDIVR01;
begin      //fdivr st(0),st(1)
 AddWord($D8,$F9);
end;


procedure TForevalH.FDIVR10;
begin      //fdivr st(1),st(0)
 AddWord($DC,$F1);
end;



procedure TForevalH.FDIV02;
begin               //st(0)=st(0)/st(2)
 AddCom($D8,$F2);
end;


procedure TForevalH.FDIVRP;
begin
 AddWord($DE,$F1);
 CheckStack(-1);
end;


procedure TForevalH.FSUB(N: TAddress; VType: Integer);
begin
 if VType = _Extended then
 begin
  FLD(N,_Extended);
  FSUBP;
 end
 else
 if VType = _Double then
 begin
  AddCom($DC,$25,N);
 end
 else
 if VType = _Single then
 begin
   AddCom($D8,$25,N);
 end
 else
 if VType = _Integer then
 begin
   AddCom($DA,$25,N);
 end;
end;


procedure TForevalH.FSUBR(N: TAddress; VType: Integer);
begin
 if VType = _Extended then
 begin
  FLD(N,VType);
  FSUBRP;
 end
 else
 if VType = _Double then
 begin
  AddCom($DC,$2D,N);
 end
 else
 if VType = _Single then
 begin
   AddCom($D8,$2D,N);
 end
 else
 if VType = _Integer then
 begin
   AddCom($DA,$2D,N);
 end;
end;

procedure TForevalH.FSUBP;
begin
 AddWord($DE,$E9);
 CheckStack(-1);
end;

procedure TForevalH.FSUBP1;
begin
 AddWord($DE,$E9);
 CheckStack(-1);
end;





procedure TForevalH.NEG_C;
var
t1,t2,N,NF,S,st1: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;

 st1:=Interp[NFunc].RData[0];
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 if F_SaveInFPU = False then
 begin
  if (t1 = T_Real) then
  begin
   FLD(GetStackAdr(S,_RE),F_DataType);
   FCHS;
  end
  else
  if  (t1 = T_Complex) then
  begin
   FLD(GetStackAdr(S,_IM),F_DataType);
   FCHS;
   FLD(GetStackAdr(S,_RE),F_DataType);
   FCHS;
  end
 end
 else
 if F_SaveInFPU = True then
 begin
   if t1 = T_Real then
   begin
     if st1 = _FPU then
     begin
       FCHS;
     end
     else
     if st1 = _MEM then
     begin
      FLD(GetStackAdr(S,_RE),F_DataType);
      FCHS;
     end
   end
   else
   if t1 = T_Complex then
   begin
     if st1 = _FPU then
     begin
       FCHS;
       FXCH1;
       FCHS;
       FXCH1;
     end
     else
     if st1 = _MEM then
     begin
       FLD(GetStackAdr(S,_IM),F_DataType);
       FCHS;
       FLD(GetStackAdr(S,_RE),F_DataType);
       FCHS;
     end
   end;
 end;

end;




procedure TForevalH.RE_C;
var
t1,t2,N,NF,RType,S,st1: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 st1:=Interp[NFunc].RData[0];


if F_SaveInFPU = False then
 begin
  if (t1 = T_Real) then
  begin
   FLD(GetStackAdr(S,_RE),F_DataType);
  end
  else
  if  (t1 = T_Complex) then
  begin
   FLD(GetStackAdr(S,_RE),F_DataType);
   FLDZ;
   if NFunc = LFunc-1 then Rtype:=_Extended else RType:=_Double;
   FSTPM(GetStackAdr(S,_IM),RType);
  end;
 end
 else
if F_SaveInFPU = True then
 begin
   if t1 = T_Real then
   begin
     if st1 = _FPU then
     begin
       //RE
     end
     else
     if st1 = _MEM then
     begin
      FLD(GetStackAdr(S,_RE),F_DataType);
     end
   end
   else
   if t1 = T_Complex then
   begin
     if st1 = _FPU then
     begin
       FXCH1;
       FSTP0;
     end
     else
     if st1 = _MEM then
     begin
       FLD(GetStackAdr(S,_RE),F_DataType);
     end
   end;
 end;

end;




procedure TForevalH.IM_C;
var
t1,t2,N,NF,RType,S,st1: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 st1:=Interp[NFunc].RData[0];


if F_SaveInFPU = False then
 begin
  if (t1 = T_Real) then
  begin
   FLDZ;
  end
  else
  if  (t1 = T_Complex) then
  begin
   FLD(GetStackAdr(S,_IM),F_DataType);
   FLDZ;
   if NFunc = LFunc-1 then Rtype:=_Extended else RType:=_Double;
   FSTPM(GetStackAdr(S,_IM),RType);
  end;
 end
 else
if F_SaveInFPU = True then
 begin
   if t1 = T_Real then
   begin
     if st1 = _FPU then
     begin
       FSTP0;
       FLDZ;
     end
     else
     if st1 = _MEM then
     begin
      FLDZ;
     end
   end
   else
   if t1 = T_Complex then
   begin
     if st1 = _FPU then
     begin
       FSTP0;
     end
     else
     if st1 = _MEM then
     begin
       FLD(GetStackAdr(S,_IM),F_DataType);
     end
   end;
 end;

end;




procedure TForevalH.LoadArg1;
var
t1,N,NF,S,st1: Integer;
begin

if Interp[NFunc].RRF  = rf_NO_REPLACE then
begin

 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 st1:=Interp[NFunc].RData[0];


if F_SaveInFPU = False then
begin
 if (t1 = T_Real) then
 begin
  FLD(GetStackAdr(S,_RE),F_DataType);
 end
 else
 if  (t1 = T_Complex) then
 begin
  FLD(GetStackAdr(S,_IM),F_DataType);
  FLD(GetStackAdr(S,_RE),F_DataType);
 end;
end
else
if F_SaveInFPU = True then
begin
  if (t1 = T_Real) and (st1 = _MEM) then
 begin
  FLD(GetStackAdr(S,_RE),F_DataType);
 end
 else
 if  (t1 = T_Complex) and (st1 = _MEM) then
 begin
  FLD(GetStackAdr(S,_IM),F_DataType);
  FLD(GetStackAdr(S,_RE),F_DataType);
 end;
end;
end;

end;


procedure TForevalH.LoadArg2;
var
t1,t2,N,NF,S,st1,st2: Integer;
begin
if Interp[NFunc].RRF  = rf_NO_REPLACE then
begin


 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0]; t2:=Alg.ExFunc[N].Func[NF].TV[1];
 st1:=Interp[NFunc].RData[0]; st2:=Interp[NFunc].RData[1];

if F_SaveInFPU = False then
begin
 if (t1 = T_Real) and (t2 = T_Real) then
 begin
  FLD(GetStackAdr(S+1,_RE),F_DataType);
  FLD(GetStackAdr(S,_RE),F_DataType);
 end
 else
 if (t1 = T_Real) and (t2 = T_Complex) then
 begin
  FLD(GetStackAdr(S+1,_IM),F_DataType);
  FLD(GetStackAdr(S+1,_RE),F_DataType);
  FLD(GetStackAdr(S,_RE),F_DataType);
 end
 else
 if (t1 = T_Complex) and (t2 = T_Real) then
 begin
  FLD(GetStackAdr(S+1,_RE),F_DataType);
  FLD(GetStackAdr(S,_IM),F_DataType);
  FLD(GetStackAdr(S,_RE),F_DataType);
 end
 else
 if (t1 = T_Complex) and (t2 = T_Complex) then
 begin
  FLD(GetStackAdr(S+1,_IM),F_DataType);
  FLD(GetStackAdr(S+1,_RE),F_DataType);
  FLD(GetStackAdr(S,_IM),F_DataType);
  FLD(GetStackAdr(S,_RE),F_DataType);
 end;
end
else
if F_SaveInFPU = True then
begin
  if (t1 = T_Real) and (t2 = T_Real) then
 begin
    if (st1 = _FPU) and (st2 = _FPU) then
    begin
     FXCH1;
    end
    else
    if (st1 = _MEM) and (st2 = _MEM) then
    begin
     FLD(GetStackAdr(S+1,_RE),F_DataType);
     FLD(GetStackAdr(S,_RE),F_DataType);
    end
    else
    if (st1 = _FPU) and (st2 = _MEM) then
    begin
     FLD(GetStackAdr(S+1,_RE),F_DataType);
     FXCH1;
    end
    else
    if (st1 = _MEM) and (st2 = _FPU) then
    begin
     FLD(GetStackAdr(S,_RE),F_DataType);
    end
 end
 else
 if (t1 = T_Real) and (t2 = T_Complex) then
 begin

  if (st1 = _FPU) and (st2 = _FPU) then
    begin
     FXCH1;
     FXCH2;
    end
    else
    if (st1 = _MEM) and (st2 = _MEM) then
    begin
     FLD(GetStackAdr(S+1,_IM),F_DataType);
     FLD(GetStackAdr(S+1,_RE),F_DataType);
     FLD(GetStackAdr(S,_RE),F_DataType);
    end
    else
    if (st1 = _FPU) and (st2 = _MEM) then
    begin
     FLD(GetStackAdr(S+1,_IM),F_DataType);
     FXCH1;
     FLD(GetStackAdr(S+1,_RE),F_DataType);
     FXCH1;
    end
    else
    if (st1 = _MEM) and (st2 = _FPU) then
    begin
     FLD(GetStackAdr(S,_RE),F_DataType);
    end
 end
 else
 if (t1 = T_Complex) and (t2 = T_Real) then
 begin
  if (st1 = _FPU) and (st2 = _FPU) then
    begin
     FXCH2;
     FXCH1;
    end
    else
    if (st1 = _MEM) and (st2 = _MEM) then
    begin
     FLD(GetStackAdr(S+1,_RE),F_DataType);
     FLD(GetStackAdr(S,_IM),F_DataType);
     FLD(GetStackAdr(S,_RE),F_DataType);
    end
    else
    if (st1 = _FPU) and (st2 = _MEM) then
    begin
     FXCH1;
     FLD(GetStackAdr(S+1,_RE),F_DataType);
     FXCH2;
    end
    else
    if (st1 = _MEM) and (st2 = _FPU) then
    begin
     FLD(GetStackAdr(S,_IM),F_DataType);
     FLD(GetStackAdr(S,_RE),F_DataType);
    end
 end
 else
 if (t1 = T_Complex) and (t2 = T_Complex) then
 begin
  if (st1 = _FPU) and (st2 = _FPU) then
    begin
     FXCH2;
     FXCH1;
     FXCH3;
     FXCH1;
    end
    else
    if (st1 = _MEM) and (st2 = _MEM) then
    begin
     FLD(GetStackAdr(S+1,_IM),F_DataType);
     FLD(GetStackAdr(S+1,_RE),F_DataType);
     FLD(GetStackAdr(S,_IM),F_DataType);
     FLD(GetStackAdr(S,_RE),F_DataType);
    end
    else
    if (st1 = _FPU) and (st2 = _MEM) then
    begin
     FLD(GetStackAdr(S+1,_IM),F_DataType);
     FXCH2;
     FLD(GetStackAdr(S+1,_RE),F_DataType);
     FXCH2;
    end
    else
    if (st1 = _MEM) and (st2 = _FPU) then
    begin
     FLD(GetStackAdr(S,_IM),F_DataType);
     FLD(GetStackAdr(S,_RE),F_DataType);
    end
 end;
end;
end;
end;




procedure TForevalH.LoadArg2RL;        //Real,List
var
t1,t2,N,NF,S,st1,st2,st3: Integer;
begin
           //  . .     

if Interp[NFunc].RRF  = rf_NO_REPLACE then
begin

 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 //t1:=Alg.ExFunc[N].Func[NF].TV[0]; t2:=Alg.ExFunc[N].Func[NF].TV[1];
 st1:=Interp[NFunc].RData[0]; st2:=Interp[NFunc].RData[1];

 if F_SaveInFPU = False then
 begin
    FLD(GetStackAdr(S+1,_RE),F_DataType);
    FLD(GetStackAdr(S,_RE),F_DataType);
 end
 else

 if F_SaveInFPU = True then
 begin
   if st1 = _MEM then FLD(GetStackAdr(S,_RE),F_DataType);
   if st2 = _MEM then FLD(GetStackAdr(S+1,_RE),F_DataType);
 end;

end;


end;




procedure TForevalH.LoadArg3RL;        //Real,List
var
t1,t2,N,NF,S,st1,st2,st3: Integer;
begin
           //  . .     

if Interp[NFunc].RRF  = rf_NO_REPLACE then
begin

 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 //t1:=Alg.ExFunc[N].Func[NF].TV[0]; t2:=Alg.ExFunc[N].Func[NF].TV[1];
 st1:=Interp[NFunc].RData[0]; st2:=Interp[NFunc].RData[1]; st3:=Interp[NFunc].RData[2];

 if F_SaveInFPU = False then
 begin
    FLD(GetStackAdr(S+2,_RE),F_DataType);
    FLD(GetStackAdr(S+1,_RE),F_DataType);
    FLD(GetStackAdr(S,_RE),F_DataType);
 end
 else

 if F_SaveInFPU = True then
 begin
   if st1 = _MEM then FLD(GetStackAdr(S,_RE),F_DataType);
   if st2 = _MEM then FLD(GetStackAdr(S+1,_RE),F_DataType);
   if st3 = _MEM then FLD(GetStackAdr(S+2,_RE),F_DataType);
 end;

end;


end;





procedure TForevalH.FACT_C;
var
t1,N,NF,S,tv1,tm1: Integer;
adr1: Cardinal;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;


if Interp[NFunc].AI = 0 then
begin
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 LoadArg1;
 if t1 = T_Real then
 begin
  PUSHCW;    {.227}
  FLDCW(TAddress(@FCW1));
  MEM:=WriteDataA(0,_Integer);
  FISTP(MEM);
  POPCW;    {.227} //FLDCW(TAddress(@FCW2));
  MOVMA(MEM);
 end;
end
else
if Interp[NFunc].AI = 1 then
begin
  GetVar(Interp[NFunc].NV1,adr1,tv1,tm1);
  MOVMA(adr1);
end;

 MOVBadr(Cardinal(@R_FACT));
 CALLB;
 CheckStack(1);
end;




procedure TForevalH.FACT2_C;
var
t1,N,NF,S,tv1,tm1: Integer;
adr1: Cardinal;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;


if Interp[NFunc].AI = 0 then
begin
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 LoadArg1;
 if t1 = T_Real then
 begin
  PUSHCW;    {.227}
  FLDCW(TAddress(@FCW1));
  MEM:=WriteDataA(0,_Integer);
  FISTP(MEM);
  POPCW;    {.227} //FLDCW(TAddress(@FCW2));
  MOVMA(MEM);
 end;
end
else
if Interp[NFunc].AI = 1 then
begin
  GetVar(Interp[NFunc].NV1,adr1,tv1,tm1);
  MOVMA(adr1);
end;

 MOVBadr(Cardinal(@R_FACT2));
 CALLB;
end;



procedure TForevalH.SQR_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then FMUL0
 else
 if t1 = T_Complex then
 begin
  {MOVA1(Cardinal(@Z_SQR));
  CALLA;
  CheckStack(1);
  CheckStack(-1);}

  ZSQR;

 end;

end;





procedure TForevalH.SQRT_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then FSQRT
 else
 if t1 = T_Complex then
 begin
  MOVAadr(Cardinal(@Z_SQRT));
  CALLA;
  CheckStack(1);
  CheckStack(-1);
 end;

end;




procedure TForevalH.SIN_C;
var
t1,N,NF,S: Integer;
Addr: TAddress;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
  if t1 = T_Real then
  begin
    if Interp[NFunc].WRF_CS = rf_SINCOSR_REPLACE    then
    begin
      FSINCOS;
      Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-1]); // -> cos
      FSTPM(Addr,F_DataType);
      Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);   // -> sin
      FSTM(Addr,F_DataType);
    end
    else
    FSIN;
  end
  else
  if t1 = T_Complex then
  begin

  if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE) then
   begin
        MOVAadr(Cardinal(@Z_SIN));
        CALLA;
        CheckStack(2);
        CheckStack(-2);
   end
   else
   begin      //sin(z)=sh(i*z)/i
   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_EXPZ2_REPLACE)    then
   begin
       ZMUL_i;
       FEXP;
       FLD0;
       FDIVR_C1;
       FXCH2;
       FSINCOS;
       FLD0;
       FMUL03;   //st(0):RE(exp)
          Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-3]);               //  RE(exp) ->
          FSTM(Addr,F_DataType);
       FXCH1;
       FMUL04;    //st(0):RE(exp^-1)
          Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-1]);               //  RE(exp^-1) ->
          FSTM(Addr,F_DataType);
       FXCH3;
       FMUL02;    //st(0):IM(exp)
          Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-2]);               //  IM(exp) ->
          FSTM(Addr,F_DataType);
       FXCH2;
       FMULP4;       //  RE(exp),IM(exp),RE(exp^-1),IM(exp^-1)
       FSUBRP2;
       FXCH2;       //st(0):IM(exp^-1)
       FCHS;
          Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);                 //  IM(exp^-1) ->
          FSTM(Addr,F_DataType);
       FSUBP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;
       ZDIV_i;

   end
   else
   if (Interp[NFunc].RRF = rf_EXPZ2_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE)   then
   begin
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-2]),F_DataType);    // -> IM(exp)
        FSUB(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);      // IM(exp)-IM(exp^-1)
        FMUL_C05; // st(0):IM
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-3]),F_DataType);    // -> RE(exp)
        FSUB(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);      // RE(exp)-RE(exp^-1)
        FMUL_C05; // st(0):RE;  st(1):IM
        ZDIV_i;
   end
   else
   if (Interp[NFunc].RRF = rf_EXPZ1_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE)   then
   begin
       FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);   // -> IM(exp)
       FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);     // -> RE(exp)
       ZPUSH;
       ZDIVR_C1;        // ->  RE(exp^-1),IM(exp^-1),RE(exp),IM(exp)
       FSUBP2;
       FXCH2;
       FSUBRP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;
       ZDIV_i;

   end
   else
   if (Interp[NFunc].RRF = rf_EXPZ1_REPLACE) and (Interp[NFunc].WRF_CS = rf_EXPZ2_REPLACE)    then
   begin
      FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);     // -> IM(exp)
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-2]);
         FSTM(Addr,F_DataType);                                          //  IM(exp) ->
      FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);   // -> RE(exp)
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-3]);
         FSTM(Addr,F_DataType);                                          //  RE(exp) ->
      ZPUSH;
      ZDIVR_C1;        // ->  RE(exp^-1),IM(exp^-1),RE(exp),IM(exp)
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-1]);
         FSTM(Addr,F_DataType);                                          //  RE(exp^-1) ->
      FSUBP2;
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);
         FSTM(Addr,F_DataType);                                          //  IM(exp^-1) ->
      FXCH2;
      FSUBRP2;
      FMUL_C05;
      FXCH1;
      FMUL_C05;
      FXCH1;
      ZDIV_i;

   end;


 end;
  end;
end;


//    1/sin
procedure TForevalH.COSEC_C;
var
t1,N,NF,S: Integer;
Addr: TAddress;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
  if t1 = T_Real then
  begin
  if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE) then
   begin
      FSIN;
      FLD1;
      FDIVRP;
   end
   else
   begin
    if (Interp[NFunc].RRF = rf_SINR_REPLACE)  then
    begin
      FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);
      FLD1;
      FDIVRP;
    end
    else
    if Interp[NFunc].WRF_CS = rf_SINCOSR_REPLACE    then
    begin
      FSINCOS;
      Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-1]); // -> cos
      FSTPM(Addr,F_DataType);
      Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);   // -> sin
      FSTM(Addr,F_DataType);
      FLD1;
      FDIVRP;
    end


   end;
  end
  else
  if t1 = T_Complex then
  begin

  if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE) then
   begin
        MOVAadr(Cardinal(@Z_COSEC));
        CALLA;
        CheckStack(2);
        CheckStack(-2);
   end
   else
   begin      //sin(z)=sh(i*z)/i
   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_EXPZ2_REPLACE)    then
   begin
       ZMUL_i;
       FEXP;
       FLD0;
       FDIVR_C1;
       FXCH2;
       FSINCOS;
       FLD0;
       FMUL03;   //st(0):RE(exp)
          Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-3]);               //  RE(exp) ->
          FSTM(Addr,F_DataType);
       FXCH1;
       FMUL04;    //st(0):RE(exp^-1)
          Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-1]);               //  RE(exp^-1) ->
          FSTM(Addr,F_DataType);
       FXCH3;
       FMUL02;    //st(0):IM(exp)
          Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-2]);               //  IM(exp) ->
          FSTM(Addr,F_DataType);
       FXCH2;
       FMULP4;       //  RE(exp),IM(exp),RE(exp^-1),IM(exp^-1)
       FSUBRP2;
       FXCH2;       //st(0):IM(exp^-1)
       FCHS;
          Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);                 //  IM(exp^-1) ->
          FSTM(Addr,F_DataType);
       FSUBP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;
       ZDIVR_i;

   end
   else
   if (Interp[NFunc].RRF = rf_EXPZ2_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE)   then
   begin
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-2]),F_DataType);    // -> IM(exp)
        FSUB(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);      // IM(exp)-IM(exp^-1)
        FMUL_C05; // st(0):IM
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-3]),F_DataType);    // -> RE(exp)
        FSUB(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);      // RE(exp)-RE(exp^-1)
        FMUL_C05; // st(0):RE;  st(1):IM
        ZDIVR_i;
   end
   else
   if (Interp[NFunc].RRF = rf_EXPZ1_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE)   then
   begin
       FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);   // -> IM(exp)
       FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);     // -> RE(exp)
       ZPUSH;
       ZDIVR_C1;        // ->  RE(exp^-1),IM(exp^-1),RE(exp),IM(exp)
       FSUBP2;
       FXCH2;
       FSUBRP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;
       ZDIVR_i;

   end
   else
   if (Interp[NFunc].RRF = rf_EXPZ1_REPLACE) and (Interp[NFunc].WRF_CS = rf_EXPZ2_REPLACE)    then
   begin
      FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);     // -> IM(exp)
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-2]);
         FSTM(Addr,F_DataType);                                          //  IM(exp) ->
      FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);   // -> RE(exp)
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-3]);
         FSTM(Addr,F_DataType);                                          //  RE(exp) ->
      ZPUSH;
      ZDIVR_C1;        // ->  RE(exp^-1),IM(exp^-1),RE(exp),IM(exp)
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-1]);
         FSTM(Addr,F_DataType);                                          //  RE(exp^-1) ->
      FSUBP2;
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);
         FSTM(Addr,F_DataType);                                          //  IM(exp^-1) ->
      FXCH2;
      FSUBRP2;
      FMUL_C05;
      FXCH1;
      FMUL_C05;
      FXCH1;
      ZDIVR_i;

   end;


 end;
  end;
end;





procedure TForevalH.COS_C;
var
t1,N,NF,S: Integer;
Addr: TAddress;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];


 LoadArg1;
 if t1 = T_Real then
 begin
  if Interp[NFunc].WRF_CS = rf_SINCOSR_REPLACE    then
    begin
      FSINCOS;
      Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-1]); // -> cos
      FSTM(Addr,F_DataType);
      FXCH1;
      Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);   // -> sin
      FSTPM(Addr,F_DataType);
    end
    else
    FCOS;
 end
 else
 if t1 = T_Complex then
 begin
 if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE) then
   begin
        MOVAadr(Cardinal(@Z_COS));
        CALLA;
        CheckStack(2);
        CheckStack(-2);
   end
   else
   begin           //cos(z)=cosh(i*z)
   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_EXPZ2_REPLACE)    then
   begin
       ZMUL_i;
       FEXP;
       FLD0;
       FDIVR_C1;
       FXCH2;
       FSINCOS;
       FLD0;
       FMUL03;   //st(0):RE(exp)
          Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-3]);               //  RE(exp) ->
          FSTM(Addr,F_DataType);
       FXCH1;
       FMUL04;    //st(0):RE(exp^-1)
          Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-1]);               //  RE(exp^-1) ->
          FSTM(Addr,F_DataType);
       FXCH3;
       FMUL02;    //st(0):IM(exp)
          Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-2]);               //  IM(exp) ->
          FSTM(Addr,F_DataType);
       FXCH2;
       FMULP4;       //  RE(exp),IM(exp),RE(exp^-1),IM(exp^-1)
       FADDP2;
       FXCH2;       //st(0):IM(exp^-1)
       FCHS;
          Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);                 //  IM(exp^-1) ->
          FSTM(Addr,F_DataType);
       FADDP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;

   end
   else
   if (Interp[NFunc].RRF = rf_EXPZ2_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE)   then
   begin
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-2]),F_DataType);    // -> IM(exp)
        FADD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);      // IM(exp)-IM(exp^-1)
        FMUL_C05; // st(0):IM
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-3]),F_DataType);    // -> RE(exp)
        FADD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);      // RE(exp)-RE(exp^-1)
        FMUL_C05; // st(0):RE;  st(1):IM
   end
   else
   if (Interp[NFunc].RRF = rf_EXPZ1_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE)   then
   begin
       FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);   // -> IM(exp)
       FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);     // -> RE(exp)
       ZPUSH;
       ZDIVR_C1;        // ->  RE(exp^-1),IM(exp^-1),RE(exp),IM(exp)
       FADDP2;  //FSUBP2;
       FXCH2;
       FADDP2;   //FSUBRP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;
   end
   else
   if (Interp[NFunc].RRF = rf_EXPZ1_REPLACE) and (Interp[NFunc].WRF_CS = rf_EXPZ2_REPLACE)    then
   begin
      FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);     // -> IM(exp)
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-2]);
         FSTM(Addr,F_DataType);                                          //  IM(exp) ->
      FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);   // -> RE(exp)
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-3]);
         FSTM(Addr,F_DataType);                                          //  RE(exp) ->
      ZPUSH;
      ZDIVR_C1;        // ->  RE(exp^-1),IM(exp^-1),RE(exp),IM(exp)
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-1]);
         FSTM(Addr,F_DataType);                                          //  RE(exp^-1) ->
      FADDP2; //FSUBP2;
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);
         FSTM(Addr,F_DataType);                                          //  IM(exp^-1) ->
      FXCH2;
      FADDP2;  //FSUBRP2;
      FMUL_C05;
      FXCH1;
      FMUL_C05;
      FXCH1;
   end;


 end;
 end;
end;



//   1/cos
procedure TForevalH.SEC_C;
var
t1,N,NF,S: Integer;
Addr: TAddress;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];


 LoadArg1;
 if t1 = T_Real then
 begin
   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE) then
   begin
      FCOS;
      FLD1;
      FDIVRP;
   end
   else
   begin

    if (Interp[NFunc].RRF = rf_COSR_REPLACE)  then
    begin
      FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);
      FLD1;
      FDIVRP;
    end
    else
    if Interp[NFunc].WRF_CS = rf_SINCOSR_REPLACE    then
    begin
      FSINCOS;
      Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-1]); // -> cos
      FSTM(Addr,F_DataType);
      FXCH1;
      Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);   // -> sin
      FSTPM(Addr,F_DataType);
      FLD1;
      FDIVRP;
    end


   end;
 end
 else
 if t1 = T_Complex then
 begin
 if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE) then
   begin
        MOVAadr(Cardinal(@Z_SEC));
        CALLA;
        CheckStack(2);
        CheckStack(-2);
   end
   else
   begin           //cos(z)=cosh(i*z)
   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_EXPZ2_REPLACE)    then
   begin
       ZMUL_i;
       FEXP;
       FLD0;
       FDIVR_C1;
       FXCH2;
       FSINCOS;
       FLD0;
       FMUL03;   //st(0):RE(exp)
          Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-3]);               //  RE(exp) ->
          FSTM(Addr,F_DataType);
       FXCH1;
       FMUL04;    //st(0):RE(exp^-1)
          Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-1]);               //  RE(exp^-1) ->
          FSTM(Addr,F_DataType);
       FXCH3;
       FMUL02;    //st(0):IM(exp)
          Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-2]);               //  IM(exp) ->
          FSTM(Addr,F_DataType);
       FXCH2;
       FMULP4;       //  RE(exp),IM(exp),RE(exp^-1),IM(exp^-1)
       FADDP2;
       FXCH2;       //st(0):IM(exp^-1)
       FCHS;
          Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);                 //  IM(exp^-1) ->
          FSTM(Addr,F_DataType);
       FADDP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;
       ZDIVR_C1;
   end
   else
   if (Interp[NFunc].RRF = rf_EXPZ2_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE)   then
   begin
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-2]),F_DataType);    // -> IM(exp)
        FADD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);      // IM(exp)-IM(exp^-1)
        FMUL_C05; // st(0):IM
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-3]),F_DataType);    // -> RE(exp)
        FADD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);      // RE(exp)-RE(exp^-1)
        FMUL_C05; // st(0):RE;  st(1):IM
        ZDIVR_C1;
   end
   else
   if (Interp[NFunc].RRF = rf_EXPZ1_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE)   then
   begin
       FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);   // -> IM(exp)
       FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);     // -> RE(exp)
       ZPUSH;
       ZDIVR_C1;        // ->  RE(exp^-1),IM(exp^-1),RE(exp),IM(exp)
       FADDP2;  //FSUBP2;
       FXCH2;
       FADDP2;   //FSUBRP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;
       ZDIVR_C1;
   end
   else
   if (Interp[NFunc].RRF = rf_EXPZ1_REPLACE) and (Interp[NFunc].WRF_CS = rf_EXPZ2_REPLACE)    then
   begin
      FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);     // -> IM(exp)
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-2]);
         FSTM(Addr,F_DataType);                                          //  IM(exp) ->
      FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);   // -> RE(exp)
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-3]);
         FSTM(Addr,F_DataType);                                          //  RE(exp) ->
      ZPUSH;
      ZDIVR_C1;        // ->  RE(exp^-1),IM(exp^-1),RE(exp),IM(exp)
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-1]);
         FSTM(Addr,F_DataType);                                          //  RE(exp^-1) ->
      FADDP2; //FSUBP2;
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);
         FSTM(Addr,F_DataType);                                          //  IM(exp^-1) ->
      FXCH2;
      FADDP2;  //FSUBRP2;
      FMUL_C05;
      FXCH1;
      FMUL_C05;
      FXCH1;
      ZDIVR_C1;
   end;


 end;
 end;
end;



procedure TForevalH.TAN_C;
var
t1,N,NF,S: Integer;
Addr: TAddress;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
    if Interp[NFunc].RRF = rf_INVERSE_REPLACE    then     //tan=1/cotan
    begin
       FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);
       FDIVR(TAddress(@S_C1),_Double);
    end
    else
    begin
       FPTAN; FSTP0;
    end;
 end
 else
 if t1 = T_Complex then
 begin

  if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE) then
   begin
     MOVAadr(Cardinal(@Z_TAN));
     CALLA;
     CheckStack(3);
     CheckStack(-3);
   end
   else
   begin
      if Interp[NFunc].RRF = rf_EXPZ1_REPLACE    then
      begin
       FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);       // -> IM(exp)
       FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);     // -> RE(exp)
       ZSQR;
       ZPUSH;
       FLD1;
       FSUBP;
       FXCH2;
       FLD1;
       FADDP;
       FXCH2;
       if F_FAST_DIV = True then
       MOVAadr(TAddress(@Z_DIV_FAST))     //FAST DIV!!!
       else
       MOVAadr(TAddress(@Z_DIV));
       //MOVAadr(TAddress(@Z_DIV_FAST));
       CALLA;
       CheckStack(2);
       CheckStack(-4);
       ZDIV_i;
      end
      else
      if Interp[NFunc].RRF = rf_INVERSE_REPLACE    then
      begin
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);       // -> IM(exp)
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);     // -> RE(exp)
        ZDIVR_C1;
      end
      else               //tan(z)=th(i*z)/i
      if Interp[NFunc].WRF_CS = rf_EXPZ1_REPLACE    then
      begin
        ZMUL_i;
        ZEXP;
        Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-1]);       // -> RE(exp)
        FSTM(Addr,F_DataType);
        FXCH1;
        Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);        // -> IM(exp)
        FSTM(Addr,F_DataType);
        FXCH1;
        ZSQR;
        ZPUSH;
        FLD1;
        FSUBP;
        FXCH2;
        FLD1;
        FADDP;
        FXCH2;
        if F_FAST_DIV = True then
        MOVAadr(TAddress(@Z_DIV_FAST))     //FAST DIV!!!
        else
        MOVAadr(TAddress(@Z_DIV));
        //MOVAadr(TAddress(@Z_DIV_FAST));
        CALLA;
        CheckStack(2);
        CheckStack(-4);
        ZDIV_i;
      end

   end;

 end;

end;




procedure TForevalH.COTAN_C;
var
t1,N,NF,S: Integer;
Addr: TAddress;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
    if Interp[NFunc].RRF = rf_INVERSE_REPLACE    then     //cotan=1/tan
    begin
       FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);
       //FDIVR(TAddress(@S_C1),_Double);
       FLD1; FDIVRP;
    end
    else
    begin
       FPTAN;
       if Interp[NFunc].WRF_CS = rf_INVERSE_REPLACE    then
       begin
         FXCH1;
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);
         FSTM(Addr,F_DataType);
         FXCH1;
       end ;
       FDIVRP;
    end;
 end
 else
 if t1 = T_Complex then
 begin

   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE) then
   begin
     MOVAadr(Cardinal(@Z_COTAN));
     CALLA;
     CheckStack(3);
     CheckStack(-3);
   end
   else
   begin
      if Interp[NFunc].RRF = rf_EXPZ1_REPLACE    then
      begin
       FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);       // -> IM(exp)
       FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);     // -> RE(exp)
       ZSQR;
       ZPUSH;
       FLD1;
       FADDP; //FSUBP;
       FXCH2;
       FLD1;
       FSUBP; //FADDP;
       FXCH2;
       if F_FAST_DIV = True then
       MOVAadr(TAddress(@Z_DIV_FAST))     //FAST DIV!!!
       else
       MOVAadr(TAddress(@Z_DIV));
       //MOVAadr(TAddress(@Z_DIV_FAST));
       CALLA;
       CheckStack(2);
       CheckStack(-4);
       ZMUL_i;
      end
      else
      if Interp[NFunc].RRF = rf_INVERSE_REPLACE    then
      begin
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);       // -> IM(exp)
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);     // -> RE(exp)
        ZDIVR_C1;
      end
      else                         //ctg(z)=i*cth(i*z)
      if Interp[NFunc].WRF_CS = rf_EXPZ1_REPLACE    then
      begin
        ZMUL_i;
        ZEXP;
        Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-1]);       // -> RE(exp)
        FSTM(Addr,F_DataType);
        FXCH1;
        Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);        // -> IM(exp)
        FSTM(Addr,F_DataType);
        FXCH1;
        ZSQR;
        ZPUSH;
        FLD1;
        FADDP;//FSUBP;
        FXCH2;
        FLD1;
        FSUBP;//FADDP;
        FXCH2;
        MOVAadr(TAddress(@Z_DIV_FAST));
        CALLA;
        CheckStack(2);
        CheckStack(-4);
        ZMUL_i;
      end

   end;
 end;

end;






procedure TForevalH.ARCSIN_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE) then
   begin
     MOVAadr(Cardinal(@R_ARCSIN));
     CALLA;
     CheckStack(2);
     CheckStack(-2);
   end
   else
   if (Interp[NFunc].RRF = rf_ARCCOSR_REPLACE) then
   begin
     FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);
     FSUBR(TAddress(@PI_2),_Extended);
   end;
 end
 else
 if t1 = T_Complex then
 begin
   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE) then
   begin
     MOVAadr(Cardinal(@Z_ARCSIN));
     CALLA;
     CheckStack(3);
     CheckStack(-3);
   end
   else
   if (Interp[NFunc].RRF = rf_ARCCOSZ_REPLACE) then
   begin
     FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);
     FCHS;
     FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);
     FSUBR(TAddress(@PI_2),_Extended);
   end;

 end;

end;




procedure TForevalH.ARCCOS_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE) then
   begin
     MOVAadr(Cardinal(@R_ARCCOS));
     CALLA;
     CheckStack(2);
     CheckStack(-2);
   end
   else
   if (Interp[NFunc].RRF = rf_ARCSINR_REPLACE) then
   begin
     FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);
     FSUBR(TAddress(@PI_2),_Extended);
   end
 end
 else
 if t1 = T_Complex then
 begin
   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE) then
   begin
     MOVAadr(Cardinal(@Z_ARCCOS));
     CALLA;
     CheckStack(3);
     CheckStack(-3);
   end
   else
   if (Interp[NFunc].RRF = rf_ARCSINZ_REPLACE) then
   begin
     FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);
     FCHS;
     FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);
     FSUBR(TAddress(@PI_2),_Extended);
   end;

 end;

end;





procedure TForevalH.ARCCOTAN_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE) then
   begin
     MOVAadr(Cardinal(@R_ARCCOTAN));
     CALLA;
     CheckStack(1);
     CheckStack(-1);
   end
   else
   if (Interp[NFunc].RRF = rf_ARCTANR_REPLACE) then
   begin
     FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);
     FSUBR(TAddress(@PI_2),_Extended);
   end;
 end
 else
 if t1 = T_Complex then
 begin
  if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE) then
   begin
     MOVAadr(Cardinal(@Z_ARCCOTAN));
     CALLA;
     CheckStack(2);
     CheckStack(-2);
   end
   else
   if (Interp[NFunc].RRF = rf_ARCTANZ_REPLACE) then
   begin
     FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);
     FCHS;
     FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);
     FSUBR(TAddress(@PI_2),_Extended);
   end;

 end;

end;




procedure TForevalH.ARCTAN_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE) then
   begin
     FLD1;
     FPATAN;
   end
   else
   if (Interp[NFunc].RRF = rf_ARCCOTANR_REPLACE) then
   begin
     FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);
     FSUBR(TAddress(@PI_2),_Extended);
   end;
 end
 else
 if t1 = T_Complex then
 begin
  if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE) then
   begin
     MOVAadr(Cardinal(@Z_ARCTAN));
     CALLA;
     CheckStack(2);
     CheckStack(-2);
   end
   else
   if (Interp[NFunc].RRF = rf_ARCCOTANZ_REPLACE) then
   begin
     FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);
     FCHS;
     FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);
     FSUBR(TAddress(@PI_2),_Extended);
   end;
 end;

end;





//
procedure TForevalH.ARCSEC_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE) then
   begin
     MOVAadr(Cardinal(@R_ARCSEC));
     CALLA;
     CheckStack(2);
     CheckStack(-2);
   end
   else
   if (Interp[NFunc].RRF = rf_ARCCOSECR_REPLACE) then
   begin
     FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);
     FSUBR(TAddress(@PI_2),_Extended);
   end;
 end
 else
 if t1 = T_Complex then
 begin
   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE) then
   begin
     MOVAadr(Cardinal(@Z_ARCSEC));
     CALLA;
     CheckStack(3);
     CheckStack(-3);
   end
   else
   if (Interp[NFunc].RRF = rf_ARCCOSECZ_REPLACE) then
   begin
     FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);
     FCHS;
     FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);
     FSUBR(TAddress(@PI_2),_Extended);
   end;

 end;

end;




//
procedure TForevalH.ARCCOSEC_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE) then
   begin
     MOVAadr(Cardinal(@R_ARCCOSEC));
     CALLA;
     CheckStack(2);
     CheckStack(-2);
   end
   else
   if (Interp[NFunc].RRF = rf_ARCSECR_REPLACE) then
   begin
     FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);
     FSUBR(TAddress(@PI_2),_Extended);
   end;
 end
 else
 if t1 = T_Complex then
 begin
   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE) then
   begin
     MOVAadr(Cardinal(@Z_ARCCOSEC));
     CALLA;
     CheckStack(3);
     CheckStack(-3);
   end
   else
   if (Interp[NFunc].RRF = rf_ARCSECZ_REPLACE) then
   begin
     FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);
     FCHS;
     FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);
     FSUBR(TAddress(@PI_2),_Extended);
   end;

 end;

end;



procedure TForevalH.SINH_C;
var
t1,N,NF,S: Integer;
Addr: TAddress;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin

   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE) then
   begin
        MOVAadr(Cardinal(@R_SINH));
        CALLA;
        CheckStack(2);
        CheckStack(-2);
   end

   else

   begin
   if (Interp[NFunc].RRF = rf_EXPR2_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE)   then
    begin
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);    // exp   ->
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);      // 1/exp ->
        FSUBP;
        FMUL_C05; {.217} //FMUL(TAddress(@S_C05),_Double);
    end
    else
    if (Interp[NFunc].RRF = rf_EXPR1_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE)   then
    begin
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);       //  exp ->
        FLD0;
        FLD1;
        FDIVRP;
        FSUBP;
        FMUL_C05; {.217} // FMUL(TAddress(@S_C05),_Double);
   end
   else
   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_EXPR2_REPLACE)    then
   begin
        FEXP;
        Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-1]);
        FSTM(Addr,F_DataType);
        FLD0;
        FLD1;
        FDIVRP;
        Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);
        FSTM(Addr,F_DataType);
        FSUBP;
        FMUL_C05; {.217} //FMUL(TAddress(@S_C05),_Double);
   end
   else
    if (Interp[NFunc].RRF = rf_EXPR1_REPLACE) and  (Interp[NFunc].WRF_CS = rf_EXPR2_REPLACE)  then
    begin
         FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);       //  exp ->
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-1]);
         FSTM(Addr,F_DataType);
         FLD0;
         FLD1;
         FDIVRP;
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);
         FSTM(Addr,F_DataType);
         FSUBP;
         FMUL_C05; {.217} //FMUL(TAddress(@S_C05),_Double);
    end;

   end;
 end
 else
 if t1 = T_Complex then
 begin
   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE) then
   begin

        MOVAadr(Cardinal(@Z_SINH));
        CALLA;
        CheckStack(2);
        CheckStack(-2);

       {
       FEXP;
       FLD0;
       FDIVR_C1;
       FXCH2;
       FSINCOS;
       FLD0;
       FMUL03;
       FXCH1;
       FMUL04;
       FXCH3;
       FMUL02;
       FXCH2;
       FMULP4;       // -> RE(exp),IM(exp),RE(exp^-1),IM(exp^-1)
       FSUBRP2;
       FXCH2;
       FADDP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;
       }

   end
   else
   begin
   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_EXPZ2_REPLACE)    then
   begin
       FEXP;
       FLD0;
       FDIVR_C1;
       FXCH2;
       FSINCOS;
       FLD0;
       FMUL03;   //st(0):RE(exp)
          Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-3]);               //  RE(exp) ->
          FSTM(Addr,F_DataType);
       FXCH1;
       FMUL04;    //st(0):RE(exp^-1)
          Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-1]);               //  RE(exp^-1) ->
          FSTM(Addr,F_DataType);
       FXCH3;
       FMUL02;    //st(0):IM(exp)
          Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-2]);               //  IM(exp) ->
          FSTM(Addr,F_DataType);
       FXCH2;
       FMULP4;       //  RE(exp),IM(exp),RE(exp^-1),IM(exp^-1)
       FSUBRP2;
       FXCH2;       //st(0):IM(exp^-1)
       FCHS;
          Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);                 //  IM(exp^-1) ->
          FSTM(Addr,F_DataType);
       FSUBP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;

   end
   else
   if (Interp[NFunc].RRF = rf_EXPZ2_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE)   then
   begin
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-2]),F_DataType);    // -> IM(exp)
        FSUB(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);      // IM(exp)-IM(exp^-1)
        FMUL_C05; // st(0):IM
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-3]),F_DataType);    // -> RE(exp)
        FSUB(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);      // RE(exp)-RE(exp^-1)
        FMUL_C05; // st(0):RE;  st(1):IM
   end
   else
   if (Interp[NFunc].RRF = rf_EXPZ1_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE)   then
   begin
       FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);   // -> IM(exp)
       FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);     // -> RE(exp)
       ZPUSH;
       ZDIVR_C1;        // ->  RE(exp^-1),IM(exp^-1),RE(exp),IM(exp)
       FSUBP2;
       FXCH2;
       FSUBRP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;
   end
   else
   if (Interp[NFunc].RRF = rf_EXPZ1_REPLACE) and (Interp[NFunc].WRF_CS = rf_EXPZ2_REPLACE)    then
   begin
      FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);     // -> IM(exp)
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-2]);
         FSTM(Addr,F_DataType);                                          //  IM(exp) ->
      FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);   // -> RE(exp)
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-3]);
         FSTM(Addr,F_DataType);                                          //  RE(exp) ->
      ZPUSH;
      ZDIVR_C1;        // ->  RE(exp^-1),IM(exp^-1),RE(exp),IM(exp)
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-1]);
         FSTM(Addr,F_DataType);                                          //  RE(exp^-1) ->
      FSUBP2;
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);
         FSTM(Addr,F_DataType);                                          //  IM(exp^-1) ->
      FXCH2;
      FSUBRP2;
      FMUL_C05;
      FXCH1;
      FMUL_C05;
      FXCH1;
   end;


 end;
 end;

end;




 // 1/sh
procedure TForevalH.COSECH_C;
var
t1,N,NF,S: Integer;
Addr: TAddress;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin

   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE) then
   begin
        MOVAadr(Cardinal(@R_SINH));
        CALLA;
        CheckStack(2);
        CheckStack(-2);
        FLD1;
        FDIVRP;
   end

   else

   begin
   if (Interp[NFunc].RRF = rf_EXPR2_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE)   then
    begin
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);    // exp   ->
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);      // 1/exp ->
        FSUBP;
        FMUL_C05;    {.217} //FMUL(TAddress(@S_C05),_Double);
        FLD1;
        FDIVRP;
    end
    else
    if (Interp[NFunc].RRF = rf_EXPR1_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE)   then
    begin
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);       //  exp ->
        FLD0;
        FLD1;
        FDIVRP;
        FSUBP;
        FMUL_C05;    {.217} //FMUL(TAddress(@S_C05),_Double);
        FLD1;
        FDIVRP;
   end
   else
   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_EXPR2_REPLACE)    then
   begin
        FEXP;
        Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-1]);
        FSTM(Addr,F_DataType);
        FLD0;
        FLD1;
        FDIVRP;
        Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);
        FSTM(Addr,F_DataType);
        FSUBP;
        FMUL_C05;    {.217}  //FMUL(TAddress(@S_C05),_Double);
        FLD1;
        FDIVRP;
   end
   else
    if (Interp[NFunc].RRF = rf_EXPR1_REPLACE) and  (Interp[NFunc].WRF_CS = rf_EXPR2_REPLACE)  then
    begin
         FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);       //  exp ->
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-1]);
         FSTM(Addr,F_DataType);
         FLD0;
         FLD1;
         FDIVRP;
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);
         FSTM(Addr,F_DataType);
         FSUBP;
         FMUL_C05;    {.217};//FMUL(TAddress(@S_C05),_Double);
         FLD1;
         FDIVRP;
    end;

   end;
 end
 else
 if t1 = T_Complex then
 begin
   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE) then
   begin

        MOVAadr(Cardinal(@Z_COSECH));
        CALLA;
        CheckStack(2);
        CheckStack(-2);

   end
   else
   begin
   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_EXPZ2_REPLACE)    then
   begin
       FEXP;
       FLD0;
       FDIVR_C1;
       FXCH2;
       FSINCOS;
       FLD0;
       FMUL03;   //st(0):RE(exp)
          Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-3]);               //  RE(exp) ->
          FSTM(Addr,F_DataType);
       FXCH1;
       FMUL04;    //st(0):RE(exp^-1)
          Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-1]);               //  RE(exp^-1) ->
          FSTM(Addr,F_DataType);
       FXCH3;
       FMUL02;    //st(0):IM(exp)
          Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-2]);               //  IM(exp) ->
          FSTM(Addr,F_DataType);
       FXCH2;
       FMULP4;       //  RE(exp),IM(exp),RE(exp^-1),IM(exp^-1)
       FSUBRP2;
       FXCH2;       //st(0):IM(exp^-1)
       FCHS;
          Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);                 //  IM(exp^-1) ->
          FSTM(Addr,F_DataType);
       FSUBP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;
       ZDIVR_C1;

   end
   else
   if (Interp[NFunc].RRF = rf_EXPZ2_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE)   then
   begin
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-2]),F_DataType);    // -> IM(exp)
        FSUB(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);      // IM(exp)-IM(exp^-1)
        FMUL_C05; // st(0):IM
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-3]),F_DataType);    // -> RE(exp)
        FSUB(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);      // RE(exp)-RE(exp^-1)
        FMUL_C05; // st(0):RE;  st(1):IM
        ZDIVR_C1;
   end
   else
   if (Interp[NFunc].RRF = rf_EXPZ1_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE)   then
   begin
       FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);   // -> IM(exp)
       FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);     // -> RE(exp)
       ZPUSH;
       ZDIVR_C1;        // ->  RE(exp^-1),IM(exp^-1),RE(exp),IM(exp)
       FSUBP2;
       FXCH2;
       FSUBRP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;
       ZDIVR_C1;
   end
   else
   if (Interp[NFunc].RRF = rf_EXPZ1_REPLACE) and (Interp[NFunc].WRF_CS = rf_EXPZ2_REPLACE)    then
   begin
      FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);     // -> IM(exp)
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-2]);
         FSTM(Addr,F_DataType);                                          //  IM(exp) ->
      FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);   // -> RE(exp)
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-3]);
         FSTM(Addr,F_DataType);                                          //  RE(exp) ->
      ZPUSH;
      ZDIVR_C1;        // ->  RE(exp^-1),IM(exp^-1),RE(exp),IM(exp)
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-1]);
         FSTM(Addr,F_DataType);                                          //  RE(exp^-1) ->
      FSUBP2;
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);
         FSTM(Addr,F_DataType);                                          //  IM(exp^-1) ->
      FXCH2;
      FSUBRP2;
      FMUL_C05;
      FXCH1;
      FMUL_C05;
      FXCH1;
      ZDIVR_C1;
   end;


 end;
 end;

end;






procedure TForevalH.COSH_C;
var
t1,N,NF,S: Integer;
Addr: TAddress;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin

   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE) then
   begin
        MOVAadr(Cardinal(@R_COSH));
        CALLA;
        CheckStack(2);
        CheckStack(-2);
   end
   else
   if (Interp[NFunc].RRF = rf_EXPR2_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE)   then
    begin
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);    // exp   ->
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);      // 1/exp ->
        FADDP;
        FMUL_C05;    {.217}//FMUL(TAddress(@S_C05),_Double);
    end
    else
    if (Interp[NFunc].RRF = rf_EXPR1_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE)   then
    begin
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);       //  exp ->
        FLD0;
        FLD1;
        FDIVRP;
        FADDP;
        FMUL_C05;    {.217}//FMUL(TAddress(@S_C05),_Double);
   end
   else
   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_EXPR2_REPLACE)    then
   begin
        FEXP;
        Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-1]);
        FSTM(Addr,F_DataType);
        FLD0;
        FLD1;
        FDIVRP;
        Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);
        FSTM(Addr,F_DataType);
        FADDP;
        FMUL_C05;    {.217}//FMUL(TAddress(@S_C05),_Double);
   end
   else
    if (Interp[NFunc].RRF = rf_EXPR1_REPLACE) and  (Interp[NFunc].WRF_CS = rf_EXPR2_REPLACE)  then
    begin
         FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);       //  exp ->
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-1]);
         FSTM(Addr,F_DataType);
         FLD0;
         FLD1;
         FDIVRP;
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);
         FSTM(Addr,F_DataType);
         FADDP;
         FMUL_C05;    {.217}//FMUL(TAddress(@S_C05),_Double);
    end;

 end
 else
 if t1 = T_Complex then
 begin
  if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE) then
   begin
        MOVAadr(Cardinal(@Z_COSH));
        CALLA;
        CheckStack(2);
        CheckStack(-2);
   end
   else
   begin
   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_EXPZ2_REPLACE)    then
   begin
       FEXP;
       FLD0;
       FDIVR_C1;
       FXCH2;
       FSINCOS;
       FLD0;
       FMUL03;   //st(0):RE(exp)
          Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-3]);               //  RE(exp) ->
          FSTM(Addr,F_DataType);
       FXCH1;
       FMUL04;    //st(0):RE(exp^-1)
          Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-1]);               //  RE(exp^-1) ->
          FSTM(Addr,F_DataType);
       FXCH3;
       FMUL02;    //st(0):IM(exp)
          Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-2]);               //  IM(exp) ->
          FSTM(Addr,F_DataType);
       FXCH2;
       FMULP4;       //  RE(exp),IM(exp),RE(exp^-1),IM(exp^-1)
       FADDP2;
       FXCH2;       //st(0):IM(exp^-1)
       FCHS;
          Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);                 //  IM(exp^-1) ->
          FSTM(Addr,F_DataType);
       FADDP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;

   end
   else
   if (Interp[NFunc].RRF = rf_EXPZ2_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE)   then
   begin
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-2]),F_DataType);    // -> IM(exp)
        FADD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);      // IM(exp)-IM(exp^-1)
        FMUL_C05; // st(0):IM
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-3]),F_DataType);    // -> RE(exp)
        FADD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);      // RE(exp)-RE(exp^-1)
        FMUL_C05; // st(0):RE;  st(1):IM
   end
   else
   if (Interp[NFunc].RRF = rf_EXPZ1_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE)   then
   begin
       FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);   // -> IM(exp)
       FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);     // -> RE(exp)
       ZPUSH;
       ZDIVR_C1;        // ->  RE(exp^-1),IM(exp^-1),RE(exp),IM(exp)
       FADDP2;  //FSUBP2;
       FXCH2;
       FADDP2;   //FSUBRP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;
   end
   else
   if (Interp[NFunc].RRF = rf_EXPZ1_REPLACE) and (Interp[NFunc].WRF_CS = rf_EXPZ2_REPLACE)    then
   begin
      FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);     // -> IM(exp)
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-2]);
         FSTM(Addr,F_DataType);                                          //  IM(exp) ->
      FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);   // -> RE(exp)
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-3]);
         FSTM(Addr,F_DataType);                                          //  RE(exp) ->
      ZPUSH;
      ZDIVR_C1;        // ->  RE(exp^-1),IM(exp^-1),RE(exp),IM(exp)
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-1]);
         FSTM(Addr,F_DataType);                                          //  RE(exp^-1) ->
      FADDP2; //FSUBP2;
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);
         FSTM(Addr,F_DataType);                                          //  IM(exp^-1) ->
      FXCH2;
      FADDP2;  //FSUBRP2;
      FMUL_C05;
      FXCH1;
      FMUL_C05;
      FXCH1;
   end;


 end;
 end;

end;



// 1/ch
procedure TForevalH.SECH_C;
var
t1,N,NF,S: Integer;
Addr: TAddress;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin

   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE) then
   begin
        MOVAadr(Cardinal(@R_COSH));
        CALLA;
        CheckStack(2);
        CheckStack(-2);
        FLD1;
        FDIVRP;
   end
   else
   if (Interp[NFunc].RRF = rf_EXPR2_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE)   then
    begin
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);    // exp   ->
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);      // 1/exp ->
        FADDP;
        FMUL_C05;    {.217}//FMUL(TAddress(@S_C05),_Double);
        FLD1;
        FDIVRP;
    end
    else
    if (Interp[NFunc].RRF = rf_EXPR1_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE)   then
    begin
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);       //  exp ->
        FLD0;
        FLD1;
        FDIVRP;
        FADDP;
        FMUL_C05;    {.217}//FMUL(TAddress(@S_C05),_Double);
        FLD1;
        FDIVRP;
   end
   else
   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_EXPR2_REPLACE)    then
   begin
        FEXP;
        Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-1]);
        FSTM(Addr,F_DataType);
        FLD0;
        FLD1;
        FDIVRP;
        Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);
        FSTM(Addr,F_DataType);
        FADDP;
        FMUL_C05;    {.217}//FMUL(TAddress(@S_C05),_Double);
        FLD1;
        FDIVRP;
   end
   else
    if (Interp[NFunc].RRF = rf_EXPR1_REPLACE) and  (Interp[NFunc].WRF_CS = rf_EXPR2_REPLACE)  then
    begin
         FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);       //  exp ->
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-1]);
         FSTM(Addr,F_DataType);
         FLD0;
         FLD1;
         FDIVRP;
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);
         FSTM(Addr,F_DataType);
         FADDP;
         FMUL_C05;    {.217}//FMUL(TAddress(@S_C05),_Double);
         FLD1;
         FDIVRP;
    end;

 end
 else
 if t1 = T_Complex then
 begin
  if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE) then
   begin
        MOVAadr(Cardinal(@Z_SECH));
        CALLA;
        CheckStack(2);
        CheckStack(-2);
   end
   else
   begin
   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_EXPZ2_REPLACE)    then
   begin
       FEXP;
       FLD0;
       FDIVR_C1;
       FXCH2;
       FSINCOS;
       FLD0;
       FMUL03;   //st(0):RE(exp)
          Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-3]);               //  RE(exp) ->
          FSTM(Addr,F_DataType);
       FXCH1;
       FMUL04;    //st(0):RE(exp^-1)
          Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-1]);               //  RE(exp^-1) ->
          FSTM(Addr,F_DataType);
       FXCH3;
       FMUL02;    //st(0):IM(exp)
          Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-2]);               //  IM(exp) ->
          FSTM(Addr,F_DataType);
       FXCH2;
       FMULP4;       //  RE(exp),IM(exp),RE(exp^-1),IM(exp^-1)
       FADDP2;
       FXCH2;       //st(0):IM(exp^-1)
       FCHS;
          Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);                 //  IM(exp^-1) ->
          FSTM(Addr,F_DataType);
       FADDP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;
       ZDIVR_C1;

   end
   else
   if (Interp[NFunc].RRF = rf_EXPZ2_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE)   then
   begin
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-2]),F_DataType);    // -> IM(exp)
        FADD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);      // IM(exp)-IM(exp^-1)
        FMUL_C05; // st(0):IM
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-3]),F_DataType);    // -> RE(exp)
        FADD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);      // RE(exp)-RE(exp^-1)
        FMUL_C05; // st(0):RE;  st(1):IM
        ZDIVR_C1;
   end
   else
   if (Interp[NFunc].RRF = rf_EXPZ1_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE)   then
   begin
       FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);   // -> IM(exp)
       FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);     // -> RE(exp)
       ZPUSH;
       ZDIVR_C1;        // ->  RE(exp^-1),IM(exp^-1),RE(exp),IM(exp)
       FADDP2;  //FSUBP2;
       FXCH2;
       FADDP2;   //FSUBRP2;
       FMUL_C05;
       FXCH1;
       FMUL_C05;
       FXCH1;
       ZDIVR_C1;
   end
   else
   if (Interp[NFunc].RRF = rf_EXPZ1_REPLACE) and (Interp[NFunc].WRF_CS = rf_EXPZ2_REPLACE)    then
   begin
      FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);     // -> IM(exp)
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-2]);
         FSTM(Addr,F_DataType);                                          //  IM(exp) ->
      FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);   // -> RE(exp)
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-3]);
         FSTM(Addr,F_DataType);                                          //  RE(exp) ->
      ZPUSH;
      ZDIVR_C1;        // ->  RE(exp^-1),IM(exp^-1),RE(exp),IM(exp)
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-1]);
         FSTM(Addr,F_DataType);                                          //  RE(exp^-1) ->
      FADDP2; //FSUBP2;
         Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);
         FSTM(Addr,F_DataType);                                          //  IM(exp^-1) ->
      FXCH2;
      FADDP2;  //FSUBRP2;
      FMUL_C05;
      FXCH1;
      FMUL_C05;
      FXCH1;
      ZDIVR_C1;
   end;


 end;
 end;

end;



procedure TForevalH.TANH_C;
var
t1,N,NF,S: Integer;
Addr: TAddress;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE) then
   begin
        MOVAadr(Cardinal(@R_TANH));
        CALLA;
        CheckStack(2);
        CheckStack(-2);
   end
   else
   begin

     if Interp[NFunc].RRF = rf_EXPR1_REPLACE    then
      begin
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);
        FMUL0;
        FLD0;
        FLD1;
        FSUBP;
        FLD1;
        FADDP20;
        FDIVRP;
      end
      else
      if Interp[NFunc].RRF = rf_INVERSE_REPLACE    then
      begin
         FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);
         //FDIVR(TAddress(@S_C1),_Double);
         FLD1; FDIVRP;
      end
      else
      if Interp[NFunc].WRF_CS = rf_EXPR1_REPLACE    then
      begin
        FEXP;
        Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);
        FSTM(Addr,F_DataType);
        FMUL0;
        FLD0;
        FLD1;
        FSUBP;
        FLD1;
        FADDP20;
        FDIVRP;
      end


    end

 end
 else
 if t1 = T_Complex then
 begin
   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE) then
   begin
     MOVAadr(Cardinal(@Z_TANH));
     CALLA;
     CheckStack(3);
     CheckStack(-2);
   end
   else
   begin
      if Interp[NFunc].RRF = rf_EXPZ1_REPLACE    then
      begin
       FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);       // -> IM(exp)
       FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);     // -> RE(exp)
       ZSQR;
       ZPUSH;
       FLD1;
       FSUBP;
       FXCH2;
       FLD1;
       FADDP;
       FXCH2;
       if F_FAST_DIV = True then
       MOVAadr(TAddress(@Z_DIV_FAST))     //FAST DIV!!!
       else
       MOVAadr(TAddress(@Z_DIV));
       //MOVAadr(TAddress(@Z_DIV_FAST));
       CALLA;
       CheckStack(2);
       CheckStack(-4);
      end
      else
      if Interp[NFunc].RRF = rf_INVERSE_REPLACE    then
      begin
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);       // -> IM(exp)
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);     // -> RE(exp)
        ZDIVR_C1;
      end
      else
      if Interp[NFunc].WRF_CS = rf_EXPZ1_REPLACE    then
      begin
        ZEXP;
        Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-1]);       // -> RE(exp)
        FSTM(Addr,F_DataType);
        FXCH1;
        Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);        // -> IM(exp)
        FSTM(Addr,F_DataType);
        FXCH1;
        ZSQR;
        ZPUSH;
        FLD1;
        FSUBP;
        FXCH2;
        FLD1;
        FADDP;
        FXCH2;
        if F_FAST_DIV = True then
        MOVAadr(TAddress(@Z_DIV_FAST))     //FAST DIV!!!
        else
        MOVAadr(TAddress(@Z_DIV));
        //MOVAadr(TAddress(@Z_DIV_FAST));
        CALLA;
        CheckStack(2);
        CheckStack(-4);
      end



   end;

 end;

end;







procedure TForevalH.COTANH_C;
var
t1,N,NF,S: Integer;
Addr: TAddress;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin

   if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE) then
   begin
        MOVAadr(Cardinal(@R_COTANH));
        CALLA;
        CheckStack(2);
        CheckStack(-2);
   end
   else
   begin

   if Interp[NFunc].RRF = rf_EXPR1_REPLACE    then
    begin
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);
        FMUL0;
        FLD0;
        FLD1;
        FSUBP;
        FLD1;
        FADDP20;
        FDIVP;
    end
    else
    if Interp[NFunc].RRF = rf_INVERSE_REPLACE    then
    begin
         FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);
         //FDIVR(TAddress(@S_C1),_Double);
         FLD1; FDIVRP;
    end
    else
    if Interp[NFunc].WRF_CS = rf_EXPR1_REPLACE    then
      begin
        FEXP;
        Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);
        FSTM(Addr,F_DataType);
        FMUL0;
        FLD0;
        FLD1;
        FSUBP;
        FLD1;
        FADDP20;
        FDIVP;
      end
   end;

 end
 else
 if t1 = T_Complex then
 begin
  if (Interp[NFunc].RRF = rf_NO_REPLACE) and (Interp[NFunc].WRF_CS = rf_NO_REPLACE) then
   begin
     MOVAadr(Cardinal(@Z_COTANH));
     CALLA;
     CheckStack(3);
     CheckStack(-2);
   end
   else
   begin
      if Interp[NFunc].RRF = rf_EXPZ1_REPLACE    then
      begin
       FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);       // -> IM(exp)
       FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);     // -> RE(exp)
       ZSQR;
       ZPUSH;
       FLD1;
       FADDP; //FSUBP;
       FXCH2;
       FLD1;
       FSUBP; //FADDP;
       FXCH2;
       if F_FAST_DIV = True then
       MOVAadr(TAddress(@Z_DIV_FAST))     //FAST DIV!!!
       else
       MOVAadr(TAddress(@Z_DIV));
       //MOVAadr(TAddress(@Z_DIV_FAST));
       CALLA;
       CheckStack(2);
       CheckStack(-4);
      end
      else
      if Interp[NFunc].RRF = rf_INVERSE_REPLACE    then
      begin
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS]),F_DataType);       // -> IM(exp)
        FLD(TAddress(@Func.RFStack[Interp[NFunc].MRF_CS-1]),F_DataType);     // -> RE(exp)
        ZDIVR_C1;
      end
      else
      if Interp[NFunc].WRF_CS = rf_EXPZ1_REPLACE    then
      begin
        ZEXP;
        Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS-1]);       // -> RE(exp)
        FSTM(Addr,F_DataType);
        FXCH1;
        Addr:=TAddress(@Func.RFStack[Interp[NFunc].MWF_CS]);        // -> IM(exp)
        FSTM(Addr,F_DataType);
        FXCH1;
        ZSQR;
        ZPUSH;
        FLD1;
        FADDP;//FSUBP;
        FXCH2;
        FLD1;
        FSUBP;//FADDP;
        FXCH2;
        if F_FAST_DIV = True then
        MOVAadr(TAddress(@Z_DIV_FAST))     //FAST DIV!!!
        else
        MOVAadr(TAddress(@Z_DIV));
        //MOVAadr(TAddress(@Z_DIV_FAST));
        CALLA;
        CheckStack(2);
        CheckStack(-4);
      end

   end;

 end;

end;





procedure TForevalH.ARCSINH_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   MOVAadr(Cardinal(@R_ARCSINH));
   CALLA;
   CheckStack(2);
   CheckStack(-2);
 end
 else
 if t1 = T_Complex then
 begin
  MOVAadr(Cardinal(@Z_ARCSINH));
  CALLA;
  CheckStack(3);
  CheckStack(-2);
 end;

end;






procedure TForevalH.ARCCOSH_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   MOVAadr(Cardinal(@R_ARCCOSH));
   CALLA;
   CheckStack(2);
   CheckStack(-2);
 end
 else
 if t1 = T_Complex then
 begin
  MOVAadr(Cardinal(@Z_ARCCOSH));
  CALLA;
  CheckStack(3);
   CheckStack(-2);
 end;

end;







procedure TForevalH.ARCTANH_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   MOVAadr(Cardinal(@R_ARCTANH));
   CALLA;
   CheckStack(2);
   CheckStack(-2);
 end
 else
 if t1 = T_Complex then
 begin
  MOVAadr(Cardinal(@Z_ARCTANH));
  CALLA;
  CheckStack(2);
  CheckStack(-2);
 end;

end;







procedure TForevalH.ARCCOTANH_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   MOVAadr(Cardinal(@R_ARCCOTANH));
   CALLA;
   CheckStack(1);
   CheckStack(-1);
 end
 else
 if t1 = T_Complex then
 begin
  MOVAadr(Cardinal(@Z_ARCCOTANH));
  CALLA;
  CheckStack(2);
  CheckStack(-2);
 end;

end;






procedure TForevalH.ARCSECH_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   MOVAadr(Cardinal(@R_ARCSECH));
   CALLA;
   CheckStack(2);
   CheckStack(-2);
 end
 else
 if t1 = T_Complex then
 begin
  MOVAadr(Cardinal(@Z_ARCSECH));
  CALLA;
  CheckStack(3);
  CheckStack(-3);
 end;

end;







procedure TForevalH.ARCCOSECH_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   MOVAadr(Cardinal(@R_ARCCOSECH));
   CALLA;
   CheckStack(2);
   CheckStack(-2);
 end
 else
 if t1 = T_Complex then
 begin
  MOVAadr(Cardinal(@Z_ARCCOSECH));
  CALLA;
  CheckStack(3);
  CheckStack(-3);
 end;

end;





procedure TForevalH.LN_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   FLDLN2;
   FXCH1;
   FYL2X;
 end
 else
 if t1 = T_Complex then
 begin
  MOVAadr(Cardinal(@Z_LN));
  CALLA;
  CheckStack(2);
  CheckStack(-2);
 end;

end;






procedure TForevalH.EXP_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   MOVAadr(Cardinal(@R_EXP));
   CALLA;
   CheckStack(2);
   CheckStack(-2);
 end
 else
 if t1 = T_Complex then
 begin
  MOVAadr(Cardinal(@Z_EXP));
  CALLA;
  CheckStack(2);
  CheckStack(-2);
 end;

end;





procedure TForevalH.LOG10_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   FLDLG2;
   FXCH1;
   FYL2X;
 end
 else
 if t1 = T_Complex then
 begin
  //FLD(Cardinal(@S_10),_Extended);
  FLD(WriteDataA(10,_Double),_Double); //{.217}
  MOVAadr(Cardinal(@Z_ReCxLog));
  CALLA;
  CheckStack(3);
  CheckStack(-4);
 end;

end;





procedure TForevalH.LOG2_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   FLD1;
   FXCH1;
   FYL2X;
 end
 else
 if t1 = T_Complex then
 begin
  FLD(Cardinal(@S_2),_Extended);
  MOVAadr(Cardinal(@Z_ReCxLog));
  CALLA;
  CheckStack(3);
  CheckStack(-4);
 end;

end;





procedure TForevalH.SINCOS_C;
var
t1,N,NF,S: Integer;
begin
 LoadArg1;
 FSINCOS;
 FXCH1;
 CheckStack(1);
end;



procedure TForevalH.COSSIN_C;
var
t1,N,NF,S: Integer;
begin
 LoadArg1;
 FSINCOS;
 CheckStack(1);
end;



procedure TForevalH.POWER_C;
var
t1,t2,N,NF,S,tva,tma: Integer;
AdrA: Cardinal;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;


 LoadArg2;
 t1:=Alg.ExFunc[N].Func[NF].TV[0]; t2:=Alg.ExFunc[N].Func[NF].TV[1];
 if (t1 = T_Real) and (t2 = T_Real) then
 begin
  MOVAadr(Cardinal(@FPWR));
  CALLA;
  CheckStack(2);
  CheckStack(-3);
  //SetReg(3); SetReg(4);
 end
 else
 if (t1 = T_Real) and (t2 = T_Complex) then
 begin
  MOVAadr(Cardinal(@Z_ReCxFPWR));
  CALLA;
  CheckStack(2);     {.195}
  CheckStack(-3);
 end
 else
 if (t1 = T_Complex) and (t2 = T_Real) then
 begin
  MOVAadr(Cardinal(@Z_CxReFPWR));
  CALLA;
  CheckStack(3);
  CheckStack(-4);
 end
 else
 if (t1 = T_Complex) and (t2 = T_Complex) then
 begin
  MOVAadr(Cardinal(@ZPWR));
  CALLA;
  CheckStack(2);
  CheckStack(-4);
 end;

SetReg(1); SetReg(2); SetReg(3); SetReg(4);
end;




procedure TForevalH.IPWR_C;
var
t1,t2,N,NF,S,tv,tm,Num: Integer;
Adr1: TAddress;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;


 LoadArg1;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 //t2:=Alg.ExFunc[N].Func[NF].TV[1];

if Interp[NFunc].AI = 1 then    //s1^intconst
begin
   if t1 = T_Real  then
   begin
     Num:=Trunc(Interp[NFunc].FD);
     MOVAnum(NUM);
     MOVCadr(Cardinal(@R_IPWR));
     CALLC;
     CheckStack(1);
     CheckStack(-1);
     SetReg(1);  SetReg(3);  SetReg(4);
   end
   else
   if t1 = T_Complex  then
   begin
     Num:=Trunc(Interp[NFunc].FD);
     MOVAnum(NUM);
     MOVBadr(Cardinal(@Z_IPWR));
     CALLB;
     CheckStack(4);
     CheckStack(-4);
     SetReg(1); SetReg(3); SetReg(4);
   end;
end
else
if Interp[NFunc].AI = 2 then    //s1^intvar
begin
   if t1 = T_Real  then
   begin
     GetVar(Interp[NFunc].NV1,adr1,tv,tm);
     MOVMA(adr1);
     MOVCadr(Cardinal(@R_IPWR));
     CALLC;
     CheckStack(1);
     CheckStack(-1);
     SetReg(1); SetReg(3); SetReg(4);
   end
   else
   if t1 = T_Complex  then
   begin
     GetVar(Interp[NFunc].NV1,adr1,tv,tm);
     MOVMA(adr1);
     MOVBadr(Cardinal(@Z_IPWR));
     CALLB;
     CheckStack(4);
     CheckStack(-4);
     SetReg(1); SetReg(2); SetReg(3);
   end;
end;


end;








procedure TForevalH.LOGN_C;
var
t1,t2,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0]; t2:=Alg.ExFunc[N].Func[NF].TV[1];

 LoadArg2;

 if (t1 = T_Real) and (t2 = T_Real) then
 begin
  MOVAadr(Cardinal(@R_LOGN));
  CALLA;
  CheckStack(1);
  CheckStack(-2);
 end
 else
 if (t1 = T_Real) and (t2 = T_Complex) then
 begin
  MOVAadr(Cardinal(@Z_ReCxLog));
  CALLA;
  CheckStack(3);
  CheckStack(-4);
 end
 else
 if (t1 = T_Complex) and (t2 = T_Real) then
 begin
  MOVAadr(Cardinal(@Z_CxReLog));
  CALLA;
  CheckStack(3);
  CheckStack(-4);
 end
 else
 if (t1 = T_Complex) and (t2 = T_Complex) then
 begin
  MOVAadr(Cardinal(@Z_CxCxLog));
  CALLA;
  CheckStack(2);
  CheckStack(-4);
 end;
end;





procedure TForevalH.ARCTAN2_C;
var
t1,t2,N,NF,S: Integer;
begin

 LoadArg2;
 FXCH1;
 FPATAN;

 CheckStack(-1);

end;



procedure TForevalH.COMPLEX_C;
begin
 LoadArg2;
end;


procedure TForevalH.ROOT_C;
var
t1,t2,N,NF,S,st1,st2: Integer;

begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0]; t2:=Alg.ExFunc[N].Func[NF].TV[1];
 st1:=Interp[NFunc].RData[0]; st2:=Interp[NFunc].RData[1];

if F_SaveInFPU = False then
begin
 if (t1 = T_Real) and (t2 = T_Real) then
 begin
   FLD(GetStackAdr(S+1,_RE),F_DataType);
   FLD(GetStackAdr(S,_RE),F_DataType);


   MOVBadr(Cardinal(@R_FROOT));
   CALLB;

   CheckStack(1);
   CheckStack(-2);

 end
 else
 if (t1 = T_Complex) and (t2 = T_Real) then
 begin
   FLD(GetStackAdr(S+1,_RE),F_DataType);
   MEM:=WriteDataA(0,_Integer);
   FISTP(MEM);
   MOVMA(MEM);
   FLD(GetStackAdr(S,_IM),F_DataType);
   FLD(GetStackAdr(S,_RE),F_DataType);


   MOVBadr(Cardinal(@Z_CxIROOT));
   CALLB;

   CheckStack(2);
   CheckStack(-2);
 end;
end
else

if F_SaveInFPU = True then
begin
if (t1 = T_Real) and (t2 = T_Real) then
 begin
   if (st1 = _FPU) and (st2 = _FPU) then
    begin
     FXCH1;
    end
    else
    if (st1 = _MEM) and (st2 = _MEM) then
    begin
     FLD(GetStackAdr(S+1,_RE),F_DataType);
     FLD(GetStackAdr(S,_RE),F_DataType);
    end
    else
    if (st1 = _FPU) and (st2 = _MEM) then
    begin
     FLD(GetStackAdr(S+1,_RE),F_DataType);
     FXCH1;
    end
    else
    if (st1 = _MEM) and (st2 = _FPU) then
    begin
     FLD(GetStackAdr(S,_RE),F_DataType);
    end;

   //PUSHB;
   MOVBadr(Cardinal(@R_FROOT));
   CALLB;
   //POPB;
   CheckStack(1);
   CheckStack(-2);
 end
 else
 if (t1 = T_Complex) and (t2 = T_Real) then
 begin
   if (st1 = _FPU) and (st2 = _FPU) then
    begin
     //FXCH1;
     //FXCH2;
     MEM:=WriteDataA(0,_Integer);
     FISTP(MEM);
     MOVMA(MEM);
    end
    else
    if (st1 = _MEM) and (st2 = _MEM) then
    begin
     FLD(GetStackAdr(S+1,_RE),F_DataType);
     MEM:=WriteDataA(0,_Integer);
     FISTP(MEM);
     MOVMA(MEM);
     FLD(GetStackAdr(S,_IM),F_DataType);
     FLD(GetStackAdr(S,_RE),F_DataType);
    end
    else
    if (st1 = _FPU) and (st2 = _MEM) then
    begin
     MEM:=WriteDataA(0,_Integer);
     FISTP(MEM);
     MOVMA(MEM);
     FLD(GetStackAdr(S,_IM),F_DataType);
     FLD(GetStackAdr(S,_RE),F_DataType);
    end
    else
    if (st1 = _MEM) and (st2 = _FPU) then
    begin
     FLD(GetStackAdr(S+1,_RE),F_DataType);
     MEM:=WriteDataA(0,_Integer);
     FISTP(MEM);
     MOVMA(MEM);
    end;

   //PUSHB;
   MOVBadr(Cardinal(@Z_CxIROOT));  //!!! ecx
   CALLB;
   SetReg(3);    {195}
   //POPB;
   CheckStack(2);
   CheckStack(-2);
 end;
end;

SetReg(1); SetReg(2); SetReg(3); SetReg(4);
end;





procedure TForevalH.DECART_C;
var
t1,t2,N,NF,S,tva,tma: Integer;
AdrA: Cardinal;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;


 LoadArg2;
 t1:=Alg.ExFunc[N].Func[NF].TV[0]; t2:=Alg.ExFunc[N].Func[NF].TV[1];
 if (t1 = T_Real) and (t2 = T_Real) then
 begin
  MOVAadr(Cardinal(@R_DECART));
  CALLA;
  CheckStack(1);
  CheckStack(-1);
 end

end;





procedure TForevalH.ABS_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   FABS;
 end
 else
 if t1 = T_Complex then
 begin
  FMUL0;
  FXCH1;
  FMUL0;
  FADDP;
  FSQRT;
 end;

end;






procedure TForevalH.ARG_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
 if t1 = T_Real then
 begin
   FSTP0;
   FLDZ;
 end
 else
 if t1 = T_Complex then
 begin
  FPATAN;
 end;

end;





procedure TForevalH.PWR3_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
  if t1 = T_Real then
  begin
    FLD0;
    FMUL0;
    FMULP;
  end
  else
  if t1 = T_Complex then
  begin
   {MOVA1(Cardinal(@Z_IPWR3));
   CALLA;
   CheckStack(3);
   CheckStack(-3); }

   {ZPUSH;
   ZSQR;
   ZMULP;}

   ZIPWR3;

  end;
end;





procedure TForevalH.PWR4_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
  if t1 = T_Real then
  begin
    FMUL0;
    FMUL0;
  end
  else
  if t1 = T_Complex then
  begin
   {MOVA1(Cardinal(@Z_IPWR4));
   CALLA;
   CheckStack(3);
   CheckStack(-3);}

   ZSQR;
   ZSQR;
  end;
end;




procedure TForevalH.PWR5_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
  if t1 = T_Real then
  begin
    FLD0;
    FMUL0;
    FMUL0;
    FMULP;
  end
  else
  if t1 = T_Complex then
  begin
   ZPUSH;
   ZSQR;
   ZSQR;
   ZMULP;
  end;
end;



procedure TForevalH.PWR6_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
  if t1 = T_Real then
  begin
    FMUL0;
    FLD0;
    FMUL0;
    FMULP;
  end
  else
  if t1 = T_Complex then
  begin
   ZSQR;
   ZPUSH;
   ZSQR;
   ZMULP;
  end;
end;




procedure TForevalH.PWRN1_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
  if t1 = T_Real then
  begin
    FLD1;
    FDIVRP;
  end
  else
  if t1 = T_Complex then
  begin
   MOVAadr(Cardinal(@Z_IPWRN1));
   CALLA;
   CheckStack(2);
   CheckStack(-2);
  end;
end;




procedure TForevalH.PWRN2_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
  if t1 = T_Real then
  begin
    FMUL0;
    FLD1;
    FDIVRP;
  end
  else
  if t1 = T_Complex then
  begin
   MOVAadr(Cardinal(@Z_IPWRN2));
   CALLA;
   CheckStack(2);
   CheckStack(-2);
  end;
end;





procedure TForevalH.PWRN3_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
  if t1 = T_Real then
  begin
    FLD0;
    FMUL0;
    FMULP;
    FLD1;
    FDIVRP;
  end
  else
  if t1 = T_Complex then
  begin
   MOVAadr(Cardinal(@Z_IPWRN3));
   CALLA;
   CheckStack(3);
   CheckStack(-3);
  end;
end;




procedure TForevalH.PWRN4_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
  if t1 = T_Real then
  begin
    FMUL0;
    FMUL0;
    FLD1;
    FDIVRP;
  end
  else
  if t1 = T_Complex then
  begin
   MOVAadr(Cardinal(@Z_IPWRN4));
   CALLA;
   CheckStack(2);
   CheckStack(-2);
  end;
end;



procedure TForevalH.PWRN5_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
  if t1 = T_Real then
  begin
    FLD0;
    FMUL0;
    FMUL0;
    FMULP;
    FLD1;
    FDIVRP;
  end
  else
  if t1 = T_Complex then
  begin
   MOVAadr(Cardinal(@Z_IPWRN5));
   CALLA;
   CheckStack(3);
   CheckStack(-3);
  end;
end;



procedure TForevalH.PWRN6_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
  if t1 = T_Real then
  begin
    FMUL0;
    FLD0;
    FMUL0;
    FMULP;
    FLD1;
    FDIVRP;
  end
  else
  if t1 = T_Complex then
  begin
   MOVAadr(Cardinal(@Z_IPWRN6));
   CALLA;
   CheckStack(3);
   CheckStack(-3);
  end;
end;




procedure TForevalH.TRUNC_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
  if t1 = T_Real then
  begin
    PUSHCW;    {.227}
    FLDCW(TAddress(@FCW1));
    FRNDINT;
    POPCW;    {.227}// FLDCW(TAddress(@FCW2));
  end;
end;



procedure TForevalH.CON_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;

 if t1 = T_Complex then
 begin
  FXCH1;
  FCHS;
  FXCH1;
 end
 else
 if t1 = T_Real then
 begin
 end;

end;



procedure TForevalH.Frac_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
  if t1 = T_Real then
  begin
    FLD0;
    PUSHCW;    {.227}
    FLDCW(TAddress(@FCW1));
    FRNDINT;
    POPCW;    {.227}//FLDCW(TAddress(@FCW2));
    FSUBP;
  end;
end;



procedure TForevalH.SGN_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
  if t1 = T_Real then
  begin
    MOVAadr(Cardinal(@R_SGN));
    CALLA;
  end;

end;




procedure TForevalH.NORM23_C;
var
t1,N,NF,S,nv,TM,NArg: Integer;
Adr: Cardinal;
begin
 N:=Interp[NFunc].NFunc;
 NArg:=Interp[NFunc].N;

 // norm(r1,r2)
 if NArg =  2 then
 begin
   LoadArg2RL;
   FMUL0;
   FXCH1;
   FMUL0;
   FADDP;
   FSQRT;
 end
 else
 // norm(r1,r2,r3)
 if NArg =  3 then
 begin
   LoadArg3RL;
   FMUL0;
   FXCH1;
   FMUL0;
   FADDP;
   FXCH1;
   FMUL0;
   FADDP;
   FSQRT;
 end;

end;


procedure TForevalH.NORM_C;
var
t1,N,NF,S,nv,TM: Integer;
Adr: Cardinal;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 nv:=Interp[NFunc].NV1;
 Adr:=Alg.Obj[nv].Addr;
 TM:=Alg.Obj[nv].MType;

 if TM = _Double then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RD_NORM));
   CALLB;
 end
 else
 if TM = _Extended then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RE_NORM));
   CALLB;
 end
 else
 if TM = _Integer then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RI_NORM));
   CALLB;
 end;

 CheckStack(2);
 CheckStack(-1);
end;




procedure TForevalH.SUM_C;
var
t1,N,NF,S,nv,TM: Integer;
Adr: Cardinal;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 nv:=Interp[NFunc].NV1;
 Adr:=Alg.Obj[nv].Addr;
 TM:=Alg.Obj[nv].MType;

 if TM = _Double then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RD_SUM));
   CALLB;
 end
 else
 if TM = _Extended then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RE_SUM));
   CALLB;
 end
 else
 if TM = _Integer then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RI_SUM));
   CALLB;
 end;

 CheckStack(2);
 CheckStack(-1);
end;



procedure TForevalH.PROD_C;
var
t1,N,NF,S,nv,TM: Integer;
Adr: Cardinal;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 nv:=Interp[NFunc].NV1;
 Adr:=Alg.Obj[nv].Addr;
 TM:=Alg.Obj[nv].MType;

 if TM = _Double then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RD_PROD));
   CALLB;
 end
 else
 if TM = _Extended then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RE_PROD));
   CALLB;
 end
 else
 if TM = _Integer then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RI_PROD));
   CALLB;
 end;

 CheckStack(2);
 CheckStack(-1);
end;




procedure TForevalH.AVR23_C;
var
t1,N,NF,S,nv,TM,NArg: Integer;
Adr: Cardinal;
begin
 N:=Interp[NFunc].NFunc;
 NArg:=Interp[NFunc].N;

 // avr(r1,r2)
 if NArg =  2 then
 begin
   LoadArg2RL;
   FADDP;
   FMUL_C05;
 end
 else
 // avr(r1,r2,r3)
 if NArg =  3 then
 begin
   LoadArg3RL;
   FADDP;
   FADDP;
   FDIV_C3;
 end;

end;



procedure TForevalH.AVR_C;
label endp;
var
t1,N,NF,S,nv,TM,NArg: Integer;
Adr: Cardinal;
begin
 N:=Interp[NFunc].NFunc;
 NArg:=Interp[NFunc].N;


 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 nv:=Interp[NFunc].NV1;
 Adr:=Alg.Obj[nv].Addr;
 TM:=Alg.Obj[nv].MType;



 //for array:
 if TM = _Double then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RD_AVR));
   CALLB;
 end
 else
 if TM = _Extended then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RE_AVR));
   CALLB;
 end
 else
 if TM = _Integer then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RI_AVR));
   CALLB;
 end;

 CheckStack(2);
 CheckStack(-1);

endp:
end;





procedure TForevalH.SUMQ_C;
var
t1,N,NF,S,nv,TM: Integer;
Adr: Cardinal;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 nv:=Interp[NFunc].NV1;
 Adr:=Alg.Obj[nv].Addr;
 TM:=Alg.Obj[nv].MType;

 if TM = _Double then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RD_SUMQ));
   CALLB;
 end
 else
 if TM = _Extended then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RE_SUMQ));
   CALLB;
 end
 else
 if TM = _Integer then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RI_SUMQ));
   CALLB;
 end;

 CheckStack(2);
 CheckStack(-1);
end;





procedure TForevalH.DEV_C;
var
t1,N,NF,S,nv,TM: Integer;
Adr: Cardinal;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 nv:=Interp[NFunc].NV1;
 Adr:=Alg.Obj[nv].Addr;
 TM:=Alg.Obj[nv].MType;

 if TM = _Double then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RD_DEV));
   CALLB;
 end
 else
 if TM = _Extended then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RE_DEV));
   CALLB;
 end
 else
 if TM = _Integer then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RI_DEV));
   CALLB;
 end;

 CheckStack(2);
 CheckStack(-1);
end;




procedure TForevalH.DEVS_C;
var
t1,N,NF,S,nv,TM: Integer;
Adr: Cardinal;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 nv:=Interp[NFunc].NV1;
 Adr:=Alg.Obj[nv].Addr;
 TM:=Alg.Obj[nv].MType;

 if TM = _Double then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RD_DEVS));
   CALLB;
 end
 else
 if TM = _Extended then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RE_DEVS));
   CALLB;
 end
 else
 if TM = _Integer then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RI_DEVS));
   CALLB;
 end;

 CheckStack(2);
 CheckStack(-1);
end;



procedure TForevalH.GCD_C;
var
t1,N,NF,S,nv,TM: Integer;
Adr: Cardinal;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 nv:=Interp[NFunc].NV1;
 Adr:=Alg.Obj[nv].Addr;
 TM:=Alg.Obj[nv].MType;

 if TM = _Double then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RD_GCD));
   CALLB;
 end
 else
 if TM = _Extended then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RE_GCD));
   CALLB;
 end
 else
 if TM = _Integer then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RI_GCD));
   CALLB;
 end;

 CheckStack(2);
 CheckStack(-1);
end;



procedure TForevalH.LCM_C;
var
t1,N,NF,S,nv,TM: Integer;
Adr: Cardinal;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 nv:=Interp[NFunc].NV1;
 Adr:=Alg.Obj[nv].Addr;
 TM:=Alg.Obj[nv].MType;

 if TM = _Double then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RD_LCM));
   CALLB;
 end
 else
 if TM = _Extended then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RE_LCM));
   CALLB;
 end
 else
 if TM = _Integer then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RI_LCM));
   CALLB;
 end;

 CheckStack(2);
 CheckStack(-1);
end;



procedure TForevalH.LEN_C;
var
t1,N,NF,S,nv,TM: Integer;
Adr: Cardinal;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 nv:=Interp[NFunc].NV1;
 Adr:=Alg.Obj[nv].Addr;
 TM:=Alg.Obj[nv].MType;

   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@R_LEN));
   CALLB;

   CheckStack(1);
end;







procedure TForevalH.MAX23_C;
label endp;
var
t1,N,NF,S,nv,TM,NArg: Integer;
Adr: Cardinal;
begin
 N:=Interp[NFunc].NFunc;
 NArg:=Interp[NFunc].N;

 // max(r1,r2)
 if NArg =  2 then
 begin
   //LoadArg2;
   LoadArg2RL;
   AddWord($DB,$F1);    //fcomi   st(0), st(1)
   AddWord($DA,$C1);    //fcmovb  st(0), st(1)
   FSTP1;
 end
 else
 if NArg =  3 then     // max(r1,r2,r3)
 begin
   LoadArg3RL;
   AddWord($DB,$F1);    //fcomi   st(0), st(1)
   AddWord($DA,$C1);    //fcmovb  st(0), st(1)
   FSTP1;
   AddWord($DB,$F1);    //fcomi   st(0), st(1)
   AddWord($DA,$C1);    //fcmovb  st(0), st(1)
   FSTP1;
 end;
end;




procedure TForevalH.MAX_C;
label endp;
var
t1,N,NF,S,nv,TM,NArg: Integer;
Adr: Cardinal;
begin
 N:=Interp[NFunc].NFunc;
 NArg:=Interp[NFunc].N;



 //for array:
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 nv:=Interp[NFunc].NV1;
 Adr:=Alg.Obj[nv].Addr;
 TM:=Alg.Obj[nv].MType;



 if TM = _Double then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RD_MAX));
   CALLB;
 end
 else
 if TM = _Extended then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RE_MAX));
   CALLB;
 end
 else
 if TM = _Integer then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RI_MAX));
   CALLB;
 end;

 CheckStack(2);
 CheckStack(-1);

 endp:
end;







procedure TForevalH.MIN23_C;
label endp;
var
t1,N,NF,S,nv,TM,NArg: Integer;
Adr: Cardinal;
begin
 N:=Interp[NFunc].NFunc;
 NArg:=Interp[NFunc].N;

 // min(r1,r2)
 if NArg =  2 then
 begin
   //LoadArg2;
   LoadArg2RL;
   AddWord($DB,$F1);    //fcomi   st(0), st(1)
   AddWord($DB,$C1);    //fcmovnb st(0), st(1)
   FSTP1;
 end
 else
 if NArg =  3 then     // min(r1,r2,r3)
 begin
   LoadArg3RL;
   AddWord($DB,$F1);    //fcomi   st(0), st(1)
   AddWord($DB,$C1);    //fcmovnb st(0), st(1)
   FSTP1;
   AddWord($DB,$F1);    //fcomi   st(0), st(1)
   AddWord($DB,$C1);    //fcmovnb st(0), st(1)
   FSTP1;
 end;
end;



procedure TForevalH.MIN_C;
label endp;
var
t1,N,NF,S,nv,TM,NArg: Integer;
Adr: Cardinal;
begin
 N:=Interp[NFunc].NFunc;
 NArg:=Interp[NFunc].N;

 //for array:
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
 nv:=Interp[NFunc].NV1;
 Adr:=Alg.Obj[nv].Addr;
 TM:=Alg.Obj[nv].MType;





 if TM = _Double then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RD_MIN));
   CALLB;
 end
 else
 if TM = _Extended then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RE_MIN));
   CALLB;
 end
 else
 if TM = _Integer then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RI_MIN));
   CALLB;
 end;

 CheckStack(2);
 CheckStack(-1);

endp:
end;





procedure TForevalH.LDSVX_C;
var
t1,N,NF,S,nv,TM,TA,NM,NA,TMA,tva: Integer;
AdrM,AdrA,Num: Cardinal;
begin

 NM:=Interp[NFunc].NObj;
 AdrM:=Alg.Obj[NM].Addr;
 TM:=Alg.Obj[NM].MType;


 if Interp[NFunc].AI = 0 then     //Vec[Trunc(Stack)]
 begin
   LoadArg1;
   //trunc
   PUSHCW;    {.227}
   FLDCW(TAddress(@FCW1));
   MEM:=WriteDataA(0,_Integer);
   FISTP(MEM);
   POPCW;    {.227} //FLDCW(TAddress(@FCW2));
   MOVMC(MEM);
 end
 else
 if Interp[NFunc].AI = 2 then    //Vec[float_var]
 begin
  GetVar(Interp[NFunc].NV1,AdrA,tva,TMA);
  if (TMA = _Double) or (TMA = _Extended) then
  begin
   FLDV(Interp[NFunc].NV1);
   PUSHCW;    {.227}
   FLDCW(TAddress(@FCW1));
   MEM:=WriteDataA(0,_Integer);
   FISTP(MEM);
   POPCW;    {.227} //FLDCW(TAddress(@FCW2));
   MOVMC(MEM);
  end
  else
  if TMA = _Integer then
  begin
    MOVMC(AdrA);
  end;
 end
 else
 if Interp[NFunc].AI = 1 then  //Vec[num]
 begin
   Num:=Trunc(Interp[NFunc].FD);
   MOVCadr(NUM); //Num>=0!!!
 end ;


 if TM = _Double then
 begin
   {MOVB1(AdrM);
   MOVA1(Cardinal(@RD_VEC));
   CALLA;}

   MOVBadr(AdrM);
   //mov  ebx, [ebx]:
   AddByte($8B); AddByte($1B);
   //fld  qword ptr [ebx+8*ecx]:
   AddByte($DD); AddByte($04);AddByte($CB);
 end
 else
 if TM = _Extended then
 begin
   {MOVB1(AdrM);
   MOVA1(Cardinal(@RE_VEC));
   CALLA;}

    MOVBadr(AdrM);
   //mov  ebx, [ebx]:
   AddByte($8B); AddByte($1B);
   //lea   ecx,[ecx+4*ecx]:
   AddByte($8D); AddByte($0C);AddByte($89);
   //fld   tbyte ptr [ebx+2*ecx]:
   AddByte($DB); AddByte($2C);AddByte($4B);
 end
 else
 if TM = _Integer then
 begin
   {MOVB1(AdrM);
   MOVA1(Cardinal(@RI_VEC));
   CALLA;}

    MOVBadr(AdrM);
   //mov  ebx, [ebx]:
   AddByte($8B); AddByte($1B);
   //fild  dword ptr [ebx+4*ecx]:
   AddByte($DB); AddByte($04);AddByte($8B);
 end;



CheckStack(1);
end;





procedure TForevalH.POLY_C;
var
t1,N,NF,S,nv,TM,t2,ta,LP,k: Integer;
Adr: Cardinal;
f1: TFloat;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 nv:=Interp[NFunc].NV1;
 Adr:=Alg.Obj[nv].Addr;
 TM:=Alg.Obj[nv].MType;
 ta:=Interp[NFunc].AI;

LoadArg1;

if ta = T_Array then
begin
if t1 = T_Real then
begin
 if TM = _Double then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RD_POLY));
   CALLB;

   CheckStack(2);
   CheckStack(-2);
 end
 else
 if TM = _Extended then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RE_POLY));
   CALLB;

   CheckStack(2);
   CheckStack(-2);
 end
 else
 if TM = _Integer then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@RI_POLY));
   CALLB;

   CheckStack(2);
   CheckStack(-2);
 end;


end
else
if t1 = T_Complex then
begin
 if TM = _Double then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@CxD_POLY));
   CALLB;

   CheckStack(4);
   CheckStack(-4);
 end
 else
 if TM = _Extended then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@CxE_POLY));
   CALLB;

   CheckStack(4);
   CheckStack(-4);
 end
 else
 if TM = _Integer then
 begin
   //MOVA1(Adr);
   MOVMA(Adr);
   MOVBadr(Cardinal(@CxI_POLY));
   CALLB;

   CheckStack(4);
   CheckStack(-4);
 end;


end;
end
else
if ta = T_Real then  //poly(<exprReal>,An,..,A0)   poly(An,..,A0,<exprReal>)
begin
 if t1 = T_Real  then
 begin
  LP:=Length(Interp[NFunc].VFP)-1;

  if F_Mode = M_Compile then f1:=Interp[NFunc].VFP[0] else  f1:=1;

  {if (Interp[i].EI = 2) then     //poly(x,1)  poly(1,x)
  begin
     FLD(WriteData(F1,_Float,_Load),F_ParamType);
  end
  else
  begin }
     //LoadArg1(I);
                                                  //poly(3,5,x)
     if LP + 1 > 2 then FLD0;  //x,x
     FMUL(WriteDataA(F1,F_DataType),F_DataType);    //An*x,x


     for k := 1 to LP-1 do
     begin
       if F_Mode = M_Compile then f1:=Interp[NFunc].VFP[k] else  f1:=1;

       FADD(WriteDataA(F1,F_DataType),F_DataType);

       if k < LP-1 then FMUL01 else FMULP1;
     end;

    if F_Mode = M_Compile then  f1:=Interp[NFunc].VFP[LP] else  f1:=1;
    FADD(WriteDataA(F1,F_DataType),F_DataType);   //+A0

 // end;

 end
 else
 {
 poly(9,-8,7,-6,5,-4,3,-2,1,-12.34,z1)
 9*z1^9-8*z1^8+7*z1^7-6*z1^6+5*z1^5-4*z1^4+3*z1^3-2*z1^2+z1-12.34
 (((((((((9*z1-8)*z1+7)*z1-6)*z1+5)*z1-4)*z1+3)*z1-2)*z1+1)*z1)-12.34
 }
 if t1 = T_Complex  then      //poly(<exprCX>,An,..,A0)   poly(An,..,A0,<exprCX>)
 begin
    LP:=Length(Interp[NFunc].VFP)-1;

   if F_Mode = M_Compile then F1:=Interp[NFunc].VFP[0] else  F1:=1.5;



     if LP + 1 > 2 then ZPUSH;

     Adr:=WriteDataA(F1,F_DataType);      // An*Zn
     if F1 = -1 then
     begin
       FCHS;
       FXCH1;
       FCHS;
       FXCH1;
     end
     else
     if F1 <> 1 then
     begin
       FMUL(Adr,F_DataType);
       FXCH1;
       FMUL(Adr,F_DataType);
       FXCH1;
     end;


     for k := 1 to LP-1 do
     begin
       if F_Mode = M_Compile then F1:=Interp[NFunc].VFP[k] else  F1:=1;

       if F1 <> 0 then FADD(WriteDataA(F1,F_DataType),F_DataType);

       if k < LP-1 then
       begin
         ZMUL;
       end
       else
       begin
         ZMULP;
       end;
     end;

    if F_Mode = M_Compile then  F1:=Interp[NFunc].VFP[LP] else  F1:=1;

    if F1 <> 0 then FADD(WriteDataA(F1,F_DataType),F_DataType);   //+A0
 end;

end;



end;




procedure TForevalH.IPWRSGN_C;
var
t1,N,NF,S,tma,tva: Integer;
AdrA: Cardinal;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;


if Interp[NFunc].AI = 0 then
begin
 LoadArg1;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];
  if t1 = T_Real then
  begin
    PUSHCW;    {.227}
    FLDCW(TAddress(@FCW1));
    MEM:=WriteDataA(0,_Integer);
    FISTP(MEM);
    POPCW;    {.227}  //FLDCW(TAddress(@FCW2));
    MOVMA(MEM);
    {.191}
    //fld1
    AddWord($D9,$E8);
   //and eax,1
    AddByte($83);AddByte($E0);AddByte($01);
    //jz +$2
    AddWord($74,$02);
    //fchs
    AddWord($D9,$E0);
    {MOVBadr(Cardinal(@R_IPWRSGN));
    CALLB;}
    CheckStack(1);
    CheckStack(-1);
  end
  else
  if t1 = T_Complex then
  begin
   {FLD1;
   FCHS;
   MOVAadr(Cardinal(@Z_ReCxFPWR));
   CALLA;
   CheckStack(2);
   CheckStack(-2);  }

   MOVAadr(Cardinal(@Z_IPWRSGN));    {189}
   CALLA;
   CheckStack(2);
   CheckStack(-2);
  end;
end
else
if Interp[NFunc].AI = 1 then
begin
  GetVar(Interp[NFunc].NV1,AdrA,tva,TMA);
  MOVMA(AdrA);
  {MOVBadr(Cardinal(@R_IPWRSGN));
  CALLB;  }

  //fld1
  AddWord($D9,$E8);
  //and eax,1
  AddByte($83);AddByte($E0);AddByte($01);
  //jz +$2
  AddWord($74,$02);
  //fchs
  AddWord($D9,$E0);


  CheckStack(1);
end;

end;




procedure TForevalH.F2PWR_C;
var
t1,N,NF,S,tma,tva: Integer;
AdrA: Cardinal;
begin
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;}


 LoadArg1;
 MOVAadr(Cardinal(@R_F2PWR));    {.223}
 CALLA;
 CheckStack(2);
 CheckStack(-2);

end;



procedure TForevalH.INC_C;
var
t1,N,NF,S,tv1,tm1: Integer;
adr1: Cardinal;
begin
  GetVar(Interp[NFunc].NV1,adr1,tv1,tm1);
  AddWord($FF,$05);
  AddAddress(adr1);
end;



procedure TForevalH.DEC_C;
var
t1,N,NF,S,tv1,tm1: Integer;
adr1: Cardinal;
begin
  GetVar(Interp[NFunc].NV1,adr1,tv1,tm1);
  AddWord($FF,$0D);
  AddAddress(adr1);
end;



procedure TForevalH.DEG_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
  //fld tbyte ptr []
 AddWord($DB,$2D);
 //addr(dPI)
 AddAddress(Cardinal(@dPI));
//fmulp
 AddWord($DE,$C9);

   CheckStack(1);
   CheckStack(-1);

end;




procedure TForevalH.RAD_C;
var
t1,N,NF,S: Integer;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];

 LoadArg1;
  //fld tbyte ptr []
 AddWord($DB,$2D);
 //addr(dPI)
 AddAddress(Cardinal(@rPI));
//fmulp
 AddWord($DE,$C9);

   CheckStack(1);
   CheckStack(-1);

end;


procedure TForevalH.MOD_C;
var
t1,t2,N,NF,S,tv,tm,tv1,tv2,tm1,tm2,Num: Integer;
adrV,adrV1,adrV2: TAddress;
begin
 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 S:=Interp[NFunc].S;
 //Arg:=Interp[NFunc].N;
 //t1:=Alg.ExFunc[N].Func[NF].TV[0]; t2:=Alg.ExFunc[N].Func[NF].TV[1];
 //st1:=Interp[NFunc].RData[0]; st2:=Interp[NFunc].RData[1];
 //nv1:=Interp[NFunc].NV1;
 //nv2:=Interp[NFunc].NV2;

{.191}
if Interp[NFunc].AI = 0 then    //mod(S1,S2)
begin
   LoadArg2;


   AddByte($D9); AddByte($F8);   //fprem
   AddByte($DF); AddByte($E0);   //fstsw  ax
   AddByte($9E);                 //sahf
   AddByte($7A); AddByte($F9);   //jp     fprem
   AddByte($DD); AddByte($D9);   //fstp   st(1)

   SetReg(1);

   {
   FXCH1;
   FLD0;
   FDIVR2;
   FTRUNC;
   FMULP1;
   FSUBP01;
   }
   {
   LoadArg2;
   MEM:=WriteDataA(0,_Integer);
   TRUNCM(MEM);
   MOVMB(MEM);
   MEM:=WriteDataA(0,_Integer);
   TRUNCM(MEM);
   MOVMA(MEM);
   CDQ;
   IDIVB;
   MEM:=WriteDataA(0,_Integer);
   MOVDM(MEM);
   FILD(MEM);
   }
end
else
if Interp[NFunc].AI = 1 then   //mod(intvar,2)
begin
    GetVar(Interp[NFunc].NV1,adrV,tv,tm);

    MOVMA(adrV);
    //and eax,$80000001
    AddByte($25); AddByte($01); AddByte($00); AddByte($00); AddByte($80);
    //jns +5
    AddByte($79); AddByte($05);
    //dec eax
    AddByte($48);
    //or eax,-$02
    AddByte($83); AddByte($C8); AddByte($FE);
    //inc eax
    AddByte($40);
    MEM:=WriteDataA(0,_Integer);
    MOVAM(MEM);
    FILD(MEM);

    SetReg(1);
end
else
if Interp[NFunc].AI = 2 then   //mod(intvar,intconst)
begin
   GetVar(Interp[NFunc].NV1,adrV,tv,tm);
   MOVMA(adrV);
   Num:=Trunc(Interp[NFunc].FD);
   MOVBnum(NUM);
   CDQ;
   IDIVB;
   MEM:=WriteDataA(0,_Integer);
   MOVDM(MEM);
   FILD(MEM);
end
else
if Interp[NFunc].AI = 5 then   //mod(intvar1,intvar2)
begin
   GetVar(Interp[NFunc].NV1,adrV1,tv1,tm1);
   MOVMA(adrV1);
   GetVar(Interp[NFunc].NV2,adrV2,tv2,tm2);
   MOVMB(adrV2);
   CDQ;
   IDIVB;
   MEM:=WriteDataA(0,_Integer);
   MOVDM(MEM);
   FILD(MEM);

   {GetVar(Interp[NFunc].NV1,adrV1,tv1,tm1);
   MOVMA(adrV1);
   GetVar(Interp[NFunc].NV2,adrV2,tv2,tm2);
   CDQ;
   IDIVM(adrV2);
   MEM:=WriteDataA(0,_Integer);
   MOVDM(MEM);
   FILD(MEM);  }
end
else
if Interp[NFunc].AI = 3 then   //mod(S1,2)
begin
   LoadArg1;
   MEM:=WriteDataA(0,_Integer);
   TRUNCM(MEM);
   MOVMA(MEM);

  //and eax,$80000001
    AddByte($25); AddByte($01); AddByte($00); AddByte($00); AddByte($80);
    //jns +5
    AddByte($79); AddByte($05);
    //dec eax
    AddByte($48);
    //or eax,-$02
    AddByte($83); AddByte($C8); AddByte($FE);
    //inc eax
    AddByte($40);
    MEM:=WriteDataA(0,_Integer);
    MOVAM(MEM);
    FILD(MEM);

    SetReg(1);
end
else
if Interp[NFunc].AI = 4 then   //mod(stack,intconst)
begin
   LoadArg1;
   MEM:=WriteDataA(0,_Integer);
   TRUNCM(MEM);
   MOVMA(MEM);

   Num:=Trunc(Interp[NFunc].FD);
   MOVBnum(NUM);
   CDQ;
   IDIVB;
   MEM:=WriteDataA(0,_Integer);
   MOVDM(MEM);
   FILD(MEM);
end;


end;





procedure TForevalH.TRY_C;
var
k: Integer;
adr: TAddress;
begin
if TE_ADDR = 0 then
begin
   adr:=WriteDataA(CWFPU,_Integer) ;
   TE_ADDR:=adr;
end
else
   adr:=TE_ADDR;

//ECX<-addr(CWMEM);
MOVCnum(adr);

MOVAnum(Cardinal(@_MaskFPUExceptionA));
CALLA;
end;





procedure TForevalH.EXCEPTION_C;
var
k: Integer;
adr: TAddress;
begin

if TE_ADDR = 0 then
begin
   adr:=WriteDataA(CWFPU,_Integer);
   TE_ADDR:=adr;
end
else
   adr:=TE_ADDR;


//ECX<-addr(CWMEM);
MOVCnum(adr);

MOVAnum(Cardinal(@_IsFPUExceptionA));
CALLA;

CheckStack(1);

end;


procedure TForevalH.CDQ;
begin
 AddByte($99);
end;

procedure TForevalH.IDIV(N: TAddress);
begin
 AddCom($F7,$3D,N);
 SetReg(1);
 SetReg(4);
end;

procedure TForevalH.IDIVB;
begin
 AddWord($F7,$FB);
 SetReg(1);
 SetReg(2);
 SetReg(4);
end;


                           //if(x>y)
                           //if(x>y,z1,z2)
procedure TForevalH.IFNOP_C;
var
arg,N,NF,t1,t2,tf: Integer;
begin
 //IFNOP(Arg1,Arg2,cjmp(Arg4),Arg3,jmp(Arg4+),Arg4)

 //arg:=Interp[NFunc].Arg;
 {N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 tf:=Alg.ExFunc[N].Func[NF].TypeF;
 if tf = T_Real  then CheckStack(-1) else
 if tf = T_Complex  then CheckStack(-2);}

 //t1:=Alg.ExFunc[N].Func[NF].TV[0];
 //t2:=Alg.ExFunc[N].Func[NF].TV[1];
 { = T_Real then R:=1 else
    if Alg.ExFunc[N].Func[NF].TypeF = T_Complex then R:=2; }
end;




(*
procedure TForevalH.IPWR_C;
var
t1,N,NF,S,tva,tma: Integer;
AdrA: Cardinal;
begin
 N:=Interp[NFunc]^.NFunc;
 NF:=Interp[NFunc]^.NF;
 S:=Interp[NFunc]^.S;
 t1:=Alg.ExFunc[N].Func[NF].TV[0];


 LoadArg1;
 if t1 = T_Real then
 begin
   if  Interp[NFunc]^.AI = 1 then
   begin
      Interp[NFunc]^.FI:=Trunc(Interp[NFunc]^.FD);
      MOVMA(Cardinal(@Interp[NFunc]^.FI));
   end
   else
   if  Interp[NFunc]^.AI = 2 then
   begin
      GetVar(Interp[NFunc]^.NV2,AdrA,tva,TMA);
      MOVMA(AdrA);
   end;
   MOVC1(Cardinal(@R_IPWR));
   CALLC;
   SetReg(4);
 end
 else
 if t1 = T_Complex then
 begin
  if  Interp[NFunc]^.AI = 1 then
   begin

   end
   else
   if  Interp[NFunc]^.AI = 2 then
   begin

   end;
 end;

end;
*)



procedure TForevalH.InitFuncStruct(var FS: TIntFunc);
begin
  FS.TypeF:=0;
  FS.CallT:=0;
  FS.CLST:=0;
  FS.Arrow:=0;
  FS.Addr:=0;
  FS.N:=0;
  FS.SDeep:=0;//-1;
  FS.IntF:=0;
  FS.TV:=nil;
  FS.TM:=nil;
  FS.CalcConst:=_YES;
  FS.SaveReg:=0;
  FS.ReplFunc:=_YES;
  FS.ExeF:=_YES;
end;




procedure TForevalH.CreateFuncList;
var
TF,TM: TArrayC;
FS: TIntFunc;
NF: Integer;
begin



//INTERNAL FUNCTION(FS.IntF:=1)

SetLength(Alg.ExFunc,CM_LENGTH);

SetType(T_None);
SetType(T_Integer);

InitFuncStruct(FS);
FS.IntF:=1;
//   ///   !!!!!!!!!!!SEQUENCE NOT TO CHANGE !!!!!!!!!!!!!!!!!!
//{N} -    ()     Alg.ExFunc[N]
//{N} - serial numbers are specified (identifiers: IDF) functions in an array Alg.ExFunc[N]
//REAL:
//func(arg1,arg2)
FS.N:=2; FS.TypeF:=T_Real;
SetLength(FS.TM,2); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
//SetLoadFunction(T_Real,0,'Real');

   FS.ReplFunc:=_YES;//_NO;
   //FS.ReplFunc:=_YES;
{0}SetFunctionInt('add',CM_ADD,FS);
{1}SetFunctionInt('sub',CM_SUB,FS);
{2}SetFunctionInt('mul',CM_MUL,FS);
{3}SetFunctionInt('div',CM_DIV,FS);
{4}SetFunctionInt('power',CM_POWER,FS);
{5}SetFunctionInt('log',CM_LOGN,FS);



//func(arg1)
FS.N:=1; FS.TypeF:=T_Real;
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
   FS.ReplFunc:=_NO;
{6}SetFunctionInt('neg',CM_NEG,FS);
   FS.ReplFunc:=_YES;
{7}SetFunctionInt('abs',CM_ABS,FS);
   FS.ReplFunc:=_NO;
{8}SetFunctionInt('re',CM_RE,FS);
{9}SetFunctionInt('im',CM_IM,FS);
   FS.ReplFunc:=_YES;
{10}SetFunctionInt('arg',CM_ARG,FS);

    FS.ReplFunc:=_YES;
{11}SetFunctionInt('sin',CM_SIN,FS);
{12}SetFunctionInt('cos',CM_COS,FS);
{13}SetFunctionInt('tan',CM_TAN,FS);
{14}SetFunctionInt('cotan',CM_COTAN,FS);
    SetFunctionInt('sec',CM_SEC,FS);
    SetFunctionInt('cosec',CM_COSEC,FS);
{15}SetFunctionInt('arccos',CM_ARCCOS,FS);
{16}SetFunctionInt('arcsin',CM_ARCSIN,FS);
{17}SetFunctionInt('arctan',CM_ARCTAN,FS);
{18}SetFunctionInt('arccotan',CM_ARCCOTAN,FS);
    SetFunctionInt('arcsec',CM_ARCSEC,FS);
    SetFunctionInt('arccosec',CM_ARCCOSEC,FS);
    SetFunctionInt('arcsech',CM_ARCSECH,FS);
    SetFunctionInt('arccosech',CM_ARCCOSECH,FS);

{19}SetFunctionInt('sinh',CM_SINH,FS);
{20}SetFunctionInt('cosh',CM_COSH,FS);
    SetFunctionInt('sech',CM_SECH,FS);
    SetFunctionInt('cosech',CM_COSECH,FS);
{21}SetFunctionInt('tanh',CM_TANH,FS);
{22}SetFunctionInt('cotanh',CM_COTANH,FS);
{23}SetFunctionInt('arccosh',CM_ARCCOSH,FS);
{24}SetFunctionInt('arcsinh',CM_ARCSINH,FS);
{25}SetFunctionInt('arctanh',CM_ARCTANH,FS);
{26}SetFunctionInt('arccotanh',CM_ARCCOTANH,FS);


{27}SetFunctionInt('ln',CM_LN,FS);
{28}SetFunctionInt('exp',CM_EXP,FS);
{29}SetFunctionInt('sqr',CM_SQR,FS);
{30}SetFunctionInt('sqrt',CM_SQRT,FS);
{31}SetFunctionInt('fact',CM_FACT,FS);
{32}SetFunctionInt('log10',CM_LOG10,FS);
{33}SetFunctionInt('log2',CM_LOG2,FS);




//COMPLEX:
//func(arg1,arg2)
FS.N:=2; FS.TypeF:=T_Complex;
SetLength(FS.TM,2); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex; FS.TV[1]:=T_Complex;
//SetLoadFunction(T_Complex,0,'Complex');
SetFunctionInt('add',CM_ADD,FS);
SetFunctionInt('sub',CM_SUB,FS);
SetFunctionInt('mul',CM_MUL,FS);
SetFunctionInt('div',CM_DIV,FS);
SetFunctionInt('power',CM_POWER,FS);
SetFunctionInt('log',CM_LOGN,FS);



//func(arg1)
FS.N:=1; FS.TypeF:=T_Complex;
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Complex;
SetFunctionInt('ln',CM_LN,FS);
SetFunctionInt('sin',CM_SIN,FS);
SetFunctionInt('cos',CM_COS,FS);
SetFunctionInt('sec',CM_SEC,FS);
SetFunctionInt('cosec',CM_COSEC,FS);
SetFunctionInt('exp',CM_EXP,FS);
SetFunctionInt('sqrt',CM_SQRT,FS);
SetFunctionInt('sqr',CM_SQR,FS);
SetFunctionInt('log10',CM_LOG10,FS);
SetFunctionInt('log2',CM_LOG2,FS);


SetFunctionInt('tan',CM_TAN,FS);
SetFunctionInt('cotan',CM_COTAN,FS);
SetFunctionInt('arccos',CM_ARCCOS,FS);
SetFunctionInt('arcsin',CM_ARCSIN,FS);
SetFunctionInt('arctan',CM_ARCTAN,FS);
SetFunctionInt('arccotan',CM_ARCCOTAN,FS);
SetFunctionInt('cosh',CM_COSH,FS);
SetFunctionInt('sinh',CM_SINH,FS);
SetFunctionInt('tanh',CM_TANH,FS);
SetFunctionInt('cotanh',CM_COTANH,FS);
SetFunctionInt('arccosh',CM_ARCCOSH,FS);
SetFunctionInt('arcsinh',CM_ARCSINH,FS);
SetFunctionInt('arctanh',CM_ARCTANH,FS);
SetFunctionInt('arccotanh',CM_ARCCOTANH,FS);
SetFunctionInt('sech',CM_SECH,FS);
SetFunctionInt('cosech',CM_COSECH,FS);
SetFunctionInt('arcsec',CM_ARCSEC,FS);
SetFunctionInt('arccosec',CM_ARCCOSEC,FS);
SetFunctionInt('arcsech',CM_ARCSECH,FS);
SetFunctionInt('arccosech',CM_ARCCOSECH,FS);





FS.N:=1; FS.TypeF:=T_Complex;
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Complex;
SetFunctionInt('neg',CM_NEG,FS);
FS.TypeF:=T_Real;
SetFunctionInt('re',CM_RE,FS);
SetFunctionInt('im',CM_IM,FS);
SetFunctionInt('abs',CM_ABS,FS);
SetFunctionInt('arg',CM_ARG,FS);



//MIXED(real,complex):
FS.N:=2; FS.TypeF:=T_Complex;
SetLength(FS.TM,2); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Complex;
SetFunctionInt('add',CM_ADD,FS);
SetFunctionInt('sub',CM_SUB,FS);
SetFunctionInt('mul',CM_MUL,FS);
SetFunctionInt('div',CM_DIV,FS);
SetFunctionInt('power',CM_POWER,FS);
SetFunctionInt('log',CM_LOGN,FS);

//MIXED(complex,real):
FS.TV[0]:=T_Complex; FS.TV[1]:=T_Real;
SetFunctionInt('add',CM_ADD,FS);
SetFunctionInt('sub',CM_SUB,FS);
SetFunctionInt('mul',CM_MUL,FS);
SetFunctionInt('div',CM_DIV,FS);
SetFunctionInt('power',CM_POWER,FS);
SetFunctionInt('log',CM_LOGN,FS);






//Imaginary unit:
S_IM_UNIT:='i';
zi.x:=0; zi.y:=1;
SetObject(S_IM_UNIT,Cardinal(@zi),T_Complex,_Double);
SetObject('pi',Cardinal(@_PI),T_Real,_Extended);


//ROOT  real,real
//root(R_arg,x)
FS.N:=2; FS.TypeF:=T_Real;  FS.ReplFunc:=_YES;
SetLength(FS.TM,2); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
{34}SetFunctionInt('root',CM_ROOT,FS);
//ROOT MIXED(real,complex):
//root(Z_arg,trunc(x))
FS.N:=2; FS.TypeF:=T_Complex;
SetLength(FS.TM,2); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex; FS.TV[1]:=T_Real;
SetFunctionInt('root',CM_ROOT,FS);


//PWR3:
FS.N:=1; FS.TypeF:=T_Real;   FS.ReplFunc:=_YES;
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
{35}SetFunctionInt('pwr3',CM_PWR3,FS);
FS.TypeF:=T_Complex; FS.TV[0]:=T_Complex;
SetFunctionInt('pwr3',CM_PWR3,FS);
//PWR4:
FS.TypeF:=T_Real; FS.TV[0]:=T_Real;
{36}SetFunctionInt('pwr4',CM_PWR4,FS);
FS.TypeF:=T_Complex; FS.TV[0]:=T_Complex;
SetFunctionInt('pwr4',CM_PWR4,FS);
//PWRN1:
FS.TypeF:=T_Real; FS.TV[0]:=T_Real;
{37}SetFunctionInt('pwrn1',CM_PWRN1,FS);
FS.TypeF:=T_Complex; FS.TV[0]:=T_Complex;
SetFunctionInt('pwrn1',CM_PWRN1,FS);
//PWRN2:
FS.TypeF:=T_Real; FS.TV[0]:=T_Real;
{38}SetFunctionInt('pwrn2',CM_PWRN2,FS);
FS.TypeF:=T_Complex; FS.TV[0]:=T_Complex;
SetFunctionInt('pwrn2',CM_PWRN2,FS);
//PWRN3:
FS.TypeF:=T_Real; FS.TV[0]:=T_Real;
{39}SetFunctionInt('pwrn3',CM_PWRN3,FS);
FS.TypeF:=T_Complex; FS.TV[0]:=T_Complex;
SetFunctionInt('pwrn3',CM_PWRN3,FS);
//PWRN4:
FS.TypeF:=T_Real; FS.TV[0]:=T_Real;
{40}SetFunctionInt('pwrn4',CM_PWRN4,FS);
FS.TypeF:=T_Complex; FS.TV[0]:=T_Complex;
SetFunctionInt('pwrn4',CM_PWRN4,FS);
FS.TypeF:=T_Complex; FS.TV[0]:=T_Complex;
{41}//TRUNC:
FS.TypeF:=T_Real; FS.TV[0]:=T_Real;
SetFunctionInt('trunc',CM_TRUNC,FS);
{42}//CON:
FS.TypeF:=T_Complex; FS.TV[0]:=T_Complex;
SetFunctionInt('con',CM_CON,FS);
FS.TypeF:=T_Real; FS.TV[0]:=T_Real;
SetFunctionInt('con',CM_CON,FS);
{43}//FRAC:
FS.TypeF:=T_Real; FS.TV[0]:=T_Real;
SetFunctionInt('frac',CM_FRAC,FS);

//ARRAY:
SetType(T_Array);
//SetLoadFunction(T_Array,0,'Vector');
 FS.ReplFunc:=_YES;
{44}//NORM:
FS.TypeF:=T_Real; FS.TV[0]:=T_Array;
SetFunctionInt('norm',CM_NORM,FS);
{45}//SUM:
FS.TypeF:=T_Real; FS.TV[0]:=T_Array;
SetFunctionInt('sum',CM_SUM,FS);
{46}//AVR:
FS.TypeF:=T_Real; FS.TV[0]:=T_Array;
SetFunctionInt('avr',CM_AVR,FS);
{47}//SUMQ:
FS.TypeF:=T_Real; FS.TV[0]:=T_Array;
SetFunctionInt('sumq',CM_SUMQ,FS);
{48}//LEN:
FS.TypeF:=T_Real; FS.TV[0]:=T_Array;
SetFunctionInt('len',CM_LEN,FS);
{49}//MAX:
FS.TypeF:=T_Real; FS.TV[0]:=T_Array;
SetFunctionInt('max',CM_MAX,FS);
{50}//MIN:
FS.TypeF:=T_Real; FS.TV[0]:=T_Array;
SetFunctionInt('min',CM_MIN,FS);
{51}//PROD:
FS.TypeF:=T_Real; FS.TV[0]:=T_Array;
SetFunctionInt('prod',CM_PROD,FS);
//GCD:
FS.TypeF:=T_Real; FS.TV[0]:=T_Array;
SetFunctionInt('gcd',CM_GCD,FS);
//LCM:
FS.TypeF:=T_Real; FS.TV[0]:=T_Array;
SetFunctionInt('lcm',CM_LCM,FS);

{52}//SGN:
FS.TypeF:=T_Real; FS.TV[0]:=T_Real;
FS.ReplFunc:=_NO;
SetFunctionInt('sign',CM_SIGN,FS);
{53}//IPWRSGN
FS.TypeF:=T_Real; FS.TV[0]:=T_Real;
FS.ReplFunc:=_NO;
SetFunctionInt('ipwrsgn',CM_IPWRSGN,FS);
FS.TypeF:=T_Complex; FS.TV[0]:=T_Complex;
SetFunctionInt('ipwrsgn',CM_IPWRSGN,FS);
{54}//LDSVX:    -   vec[expr]
FS.TypeF:=T_Real; FS.TV[0]:=T_Real;
FS.ReplFunc:=_NO;
SetFunctionInt('ldsvx',CM_LDSVX,FS);
(*
{54}//IPWR
FS.TypeF:=T_Real; FS.TV[0]:=T_Real;
SetFunction('ipwr',FS);
FS.TypeF:=T_Complex; FS.TV[0]:=T_Complex;
SetFunction('ipwr',FS);
*)


//SetType(T_None);


//in: IF => out: IF@
//IF(Arg1 op Arg2, Arg3, Arg4)  => if Arg1 op Arg2 then Arg3 else Arg4  op: =, <, >, <=, =<, >=, =>
//Arg1, Arg2  T_Real;
//  IF    IF@(Arg1,Arg2,CJMP,Arg3,JMP,ARG4)
//Arg3,Arg4 - T_Real:
//  
InitFuncStruct(FS);
FS.ExeF:=_NO;  FS.N:=3; FS.TypeF:=T_Real;
SetLength(FS.TM,FS.N); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;  FS.TM[2]:=_Extended;
SetLength(FS.TV,FS.N); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;  FS.TV[2]:=T_Real;
FS.ReplFunc:=_NO;
{55}SetFunctionInt('if',CM_IFin,FS);
//IF(Arg1 op Arg2)  => if Arg1 op Arg2 then FLD1 else FLDZ  op: =, <, >, <=, =<, >=, =>
//Arg1, Arg2  T_Real;
//     IF@(Arg1,Arg2,CJMP,FLD1,JMP,FLDZ)
//Arg3,Arg4 - T_Real:
FS.N:=1; FS.TypeF:=T_Real;
SetLength(FS.TM,FS.N); FS.TM[0]:=_Extended;
SetLength(FS.TV,FS.N); FS.TV[0]:=T_Real;
{55}SetFunctionInt('if',CM_IFin,FS);

//Arg3,Arg4 - T_Complex:
FS.N:=3; FS.TypeF:=T_Complex;
SetLength(FS.TM,FS.N); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;  FS.TM[2]:=_Extended;
SetLength(FS.TV,FS.N); FS.TV[0]:=T_Real; FS.TV[1]:=T_Complex;  FS.TV[2]:=T_Complex;
{55}SetFunctionInt('if',CM_IFin,FS);


 {IF@=IFNOP}
//IF@(Arg1,Arg2,CJMP,Arg3,JMP,ARG4) -   ( IF)

//Arg3,Arg4 - T_Real:
InitFuncStruct(FS);
FS.N:=6; FS.TypeF:=T_Real;
SetLength(FS.TM,FS.N); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;  FS.TM[2]:=_Extended;  FS.TM[3]:=_Extended; FS.TM[4]:=_Extended; FS.TM[5]:=_Extended;
SetLength(FS.TV,FS.N); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;  FS.TV[2]:=T_None;  FS.TV[3]:=T_Real;  FS.TV[4]:=T_None;  FS.TV[5]:=T_Real;
FS.ReplFunc:=_NO;
{56}SetFunctionInt('if@',CM_IF,FS);

//Arg3,Arg4 - T_Complex:
FS.N:=6; FS.TypeF:=T_Complex;
SetLength(FS.TM,FS.N); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;  FS.TM[2]:=_Extended;  FS.TM[3]:=_Extended; FS.TM[4]:=_Extended; FS.TM[5]:=_Extended;
SetLength(FS.TV,FS.N); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;  FS.TV[2]:=T_None;  FS.TV[3]:=T_Complex;  FS.TV[4]:=T_None;  FS.TV[5]:=T_Complex;
{56}SetFunctionInt('if@',CM_IF,FS);

//if(Arg1,Arg2,goto(1),goto(2)) ->IF@(Arg1,Arg2,CJMP,GOTO(1),JMP,GOTO(2))
FS.N:=6; FS.TypeF:=T_None;
SetLength(FS.TM,FS.N); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;  FS.TM[2]:=_Extended;  FS.TM[3]:=_Extended; FS.TM[4]:=_Extended; FS.TM[5]:=_Extended;
SetLength(FS.TV,FS.N); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;  FS.TV[2]:=T_None;  FS.TV[3]:=T_None;  FS.TV[4]:=T_None;  FS.TV[5]:=T_None;
{56}SetFunctionInt('if@',CM_IF,FS);

//if(Arg1,Arg2,goto()) ->IF@(Arg1,Arg2,CJMP,GOTO())
FS.N:=4; FS.TypeF:=T_None;
SetLength(FS.TM,FS.N); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;  FS.TM[2]:=_Extended;  FS.TM[3]:=_Extended;
SetLength(FS.TV,FS.N); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;  FS.TV[2]:=T_None;  FS.TV[3]:=T_None;
{56}SetFunctionInt('if@',CM_IF,FS);




//fact2
InitFuncStruct(FS);
FS.IntF:=1; FS.N:=1; FS.TypeF:=T_Real;
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.ReplFunc:=_NO;
{57}SetFunctionInt('fact2',CM_FACT2,FS);




{MAX}
InitFuncStruct(FS);
FS.Addr:=Cardinal(@R_MAX);
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
FS.TypeF:=T_Real;
FS.SDeep:=2;
FS.Arrow:=_Right;
FS.CallT:=_STACK_INFINITE;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionInt('max',CM_MAX,FS);
{MIN}
InitFuncStruct(FS);
FS.Addr:=Cardinal(@R_MIN);
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
FS.TypeF:=T_Real;
FS.SDeep:=2;
FS.Arrow:=_Right;
FS.CallT:=_STACK_INFINITE;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionInt('min',CM_MIN,FS);
{AVR}
InitFuncStruct(FS);
FS.Addr:=Cardinal(@R_AVR);
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
FS.TypeF:=T_Real;
FS.SDeep:=2;
FS.Arrow:=_Right;
FS.CallT:=_STACK_INFINITE;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionInt('avr',CM_AVR,FS);
{SUMQ}
InitFuncStruct(FS);
FS.Addr:=Cardinal(@R_SUMQ);
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
FS.TypeF:=T_Real;
FS.SDeep:=2;
FS.Arrow:=_Right;
FS.CallT:=_STACK_INFINITE;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionInt('sumq',CM_SUMQ,FS);
{NORM}
InitFuncStruct(FS);
FS.Addr:=Cardinal(@R_NORM);
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
FS.TypeF:=T_Real;
FS.SDeep:=2;
FS.Arrow:=_Right;
FS.CallT:=_STACK_INFINITE;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionInt('norm',CM_NORM,FS);
{SUM}
InitFuncStruct(FS);
FS.Addr:=Cardinal(@R_SUM);
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
FS.TypeF:=T_Real;
FS.SDeep:=2;
FS.Arrow:=_Right;
FS.CallT:=_STACK_INFINITE;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionInt('sum',CM_SUM,FS);
{PROD}
InitFuncStruct(FS);
FS.Addr:=Cardinal(@R_PROD);
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
FS.TypeF:=T_Real;
FS.SDeep:=2;
FS.Arrow:=_Right;
FS.CallT:=_STACK_INFINITE;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionInt('prod',CM_PROD,FS);
{GCD}
InitFuncStruct(FS);
FS.Addr:=Cardinal(@R_GCD);
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
FS.TypeF:=T_Real;
FS.SDeep:=2;
FS.Arrow:=_Right;
FS.CallT:=_STACK_INFINITE;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionInt('gcd',CM_GCD,FS);
{LCM}
InitFuncStruct(FS);
FS.Addr:=Cardinal(@R_LCM);
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
FS.TypeF:=T_Real;
FS.SDeep:=2;
FS.Arrow:=_Right;
FS.CallT:=_STACK_INFINITE;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunctionInt('lcm',CM_LCM,FS);



//SetType(T_Integer);



//SetLoadFunction(T_Integer,0,'Integer');

//fzSetFunctionInf('max',@R_MAX,E_Real,_Real,_StdCall,2);

//LInternalFunc:=45;
//test:
//SetObject('v1',Cardinal(@V1),T_Array,_Double);



(*
{42}//F2PWR
FS.TypeF:=T_Real; FS.TV[0]:=T_Real;
SetFunction('f2pwr',FS);
FS.TypeF:=T_Complex; FS.TV[0]:=T_Complex;
SetFunction('f2pwr',FS);
*)

{ROOT(Z,N,K)}
InitFuncStruct(FS);
FS.Addr:=Cardinal(@Z_CxIROOTA);
FS.N:=3;
SetLength(FS.TV,3); SetLength(FS.TM,3);
FS.TV[0]:=T_Complex;  FS.TM[0]:=_Extended;
FS.TV[1]:=T_Real;     FS.TM[1]:=_Extended;
FS.TV[2]:=T_Real;     FS.TM[2]:=_Extended;
FS.TypeF:=T_Complex;
FS.SDeep:=5;
FS.CallT:=_EAX;
FS.SaveReg:=15;
SetFunctionInt('root',CM_ROOT,FS);


// 'nop' TypeF =        = T_None
{58}
InitFuncStruct(FS);
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.N:=-2;        //INFINITE_A
FS.TM[0]:=_Extended;
//FS.TypeF:=T_Complex;
FS.TypeF:=T_None;      {.193}
FS.CallT:=_STACK_INFINITE_A;
//FS.SDeep:=0;
FS.ReplFunc:=_NO;
SetFunctionInt('nop',CM_NOP,FS);



//save=>save@
//  
{59}
//in:
InitFuncStruct(FS); FS.ExeF:=_NO;  FS.IntF:=1;
FS.N:=2; FS.TypeF:=T_None;
SetLength(FS.TM,2); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;    FS.TV[1]:=T_Complex;
FS.ReplFunc:=_NO;
SetFunctionInt('save',CM_SAVEin,FS);

InitFuncStruct(FS); FS.IntF:=1;
FS.N:=3; FS.TypeF:=T_None;
SetLength(FS.TM,3); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended; FS.TM[2]:=_Extended;
SetLength(FS.TV,3); FS.TV[0]:=T_Array;   FS.TV[1]:=T_Real;    FS.TV[2]:=T_Real;
SetFunctionInt('save',CM_SAVEin,FS);

 //vd[k]=z1 ;

//out:
//
InitFuncStruct(FS); FS.IntF:=1;
FS.N:=1; FS.TypeF:=T_None;
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
SetFunctionInt('save@',CM_SAVE,FS);

//z=complex
InitFuncStruct(FS);  FS.IntF:=1;
FS.N:=1; FS.TypeF:=T_None;
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Complex;
SetFunctionInt('save@',CM_SAVE,FS);

//array[real]=real
InitFuncStruct(FS);  FS.IntF:=1;
FS.N:=2; FS.TypeF:=T_None;
SetLength(FS.TM,2); FS.TM[0]:=_Extended;  FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;  FS.TV[1]:=T_Real;
SetFunctionInt('save@',CM_SAVE,FS);



{60}
InitFuncStruct(FS);  FS.IntF:=1;
FS.N:=1; FS.TypeF:=T_None;
SetLength(FS.TM,1); FS.TM[0]:=_Integer;
SetLength(FS.TV,1); FS.TV[0]:=T_None;
FS.ReplFunc:=_NO;
SetFunctionInt('goto',CM_JMP,FS);


{61}
InitFuncStruct(FS);  FS.IntF:=1;
FS.N:=1; FS.TypeF:=T_None;
SetLength(FS.TM,1); FS.TM[0]:=_Integer;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.ReplFunc:=_NO;
SetFunctionInt('inc',CM_INC,FS);


{62}
InitFuncStruct(FS);  FS.IntF:=1;
FS.N:=1; FS.TypeF:=T_None;
SetLength(FS.TM,1); FS.TM[0]:=_Integer;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.ReplFunc:=_NO;
SetFunctionInt('dec',CM_DEC,FS);


{63}
FS.N:=2; FS.TypeF:=T_Complex;
SetLength(FS.TM,2); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
FS.ReplFunc:=_YES;
SetFunctionInt('decart',CM_DECART,FS);

{64}
FS.N:=1; FS.TypeF:=T_Real;
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.ReplFunc:=_NO;
SetFunctionInt('deg',CM_DEG,FS);

{65}
FS.N:=1; FS.TypeF:=T_Real;
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.ReplFunc:=_NO;
SetFunctionInt('rad',CM_RAD,FS);

{66}//DEV:
InitFuncStruct(FS);
FS.IntF:=1;
FS.N:=1; FS.TypeF:=T_Real;
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Array;
FS.ReplFunc:=_YES;
SetFunctionInt('dev',CM_DEV,FS);

{67}//DEVS:
InitFuncStruct(FS);
FS.IntF:=1;
FS.N:=1; FS.TypeF:=T_Real;
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Array;
FS.ReplFunc:=_YES;
SetFunctionInt('devs',CM_DEVS,FS);

{DEV}
InitFuncStruct(FS);
FS.Addr:=Cardinal(@R_DEV);
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
FS.TypeF:=T_Real;
FS.SDeep:=2;
FS.Arrow:=_Right;
FS.CallT:=_STACK_INFINITE;
FS.SaveReg:=15;
SetFunctionInt('dev',CM_DEV,FS);
{DEVS}
InitFuncStruct(FS);
FS.Addr:=Cardinal(@R_DEVS);
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
FS.TypeF:=T_Real;
FS.SDeep:=2;
FS.Arrow:=_Right;
FS.CallT:=_STACK_INFINITE;
FS.SaveReg:=15;
SetFunctionInt('devs',CM_DEVS,FS);





//  
//CM_SETLENin
InitFuncStruct(FS); FS.ExeF:=_NO; FS.IntF:=1;
SetLength(FS.TM,2); FS.TM[0]:=_Extended; FS.TM[1]:=_Integer;
SetLength(FS.TV,2); FS.TV[0]:=T_Array; FS.TV[1]:=T_Real;
FS.N:=2;
FS.TypeF:=T_None;
FS.ReplFunc:=_NO;
SetFunctionInt('setlen',CM_SETLENin,FS);

// ,     FS.IntF:=0
//CM_SETLEN
InitFuncStruct(FS); FS.IntF:=0;
FS.addr:=Cardinal(@SetLengthArray);
SetLength(FS.TM,3); FS.TM[0]:=_Integer; FS.TM[1]:=_Integer; FS.TM[2]:=_Integer;
SetLength(FS.TV,3); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;  FS.TV[2]:=T_Real;
FS.N:=3;
FS.TypeF:=T_None;
FS.SDeep:=0;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=255;
SetFunctionInt('setlen@',CM_SETLEN,FS);


//CM_ARCTAN2 = 70
InitFuncStruct(FS); FS.IntF:=1;
SetLength(FS.TM,2); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
FS.SDeep:=0;
FS.N:=2;
FS.TypeF:=T_Real;
FS.ReplFunc:=_YES;
SetFunctionInt('arctan2',CM_ARCTAN2,FS);

//CM_sincos = 71
InitFuncStruct(FS); FS.IntF:=1;
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.SDeep:=1;
FS.N:=1;
FS.TypeF:=T_Complex;
FS.ReplFunc:=_YES;
SetFunctionInt('sincos',CM_SINCOS,FS);

//CM_cossin = 72
InitFuncStruct(FS); FS.IntF:=1;
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.SDeep:=1;
FS.N:=1;
FS.TypeF:=T_Complex;
FS.ReplFunc:=_YES;
SetFunctionInt('cossin',CM_COSSIN,FS);


//CM_SWAP = 73
InitFuncStruct(FS); FS.IntF:=1;
SetLength(FS.TM,2); FS.TM[0]:=_Extended;  FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;     FS.TV[1]:=T_Real;
FS.SDeep:=0;
FS.N:=2;
FS.TypeF:=T_None;
FS.ReplFunc:=_NO;
SetFunctionInt('swap',CM_SWAP,FS);

//CM_SWAP = 73
InitFuncStruct(FS); FS.IntF:=1;
SetLength(FS.TM,2); FS.TM[0]:=_Extended;  FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Complex;  FS.TV[1]:=T_Complex;
FS.SDeep:=0;
FS.N:=2;
FS.TypeF:=T_None;
SetFunctionInt('swap',CM_SWAP,FS);

//CM_Complex = 74
InitFuncStruct(FS); FS.IntF:=1;
SetLength(FS.TM,2); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;    FS.TV[1]:=T_Real;
FS.SDeep:=0;
FS.N:=2;
FS.TypeF:=T_Complex;
FS.ReplFunc:=_NO;
SetFunctionInt('complex',CM_COMPLEX,FS);

//PWR5: {75}
InitFuncStruct(FS); FS.IntF:=1; FS.N:=1;
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TypeF:=T_Real; FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
FS.ReplFunc:=_YES;
SetFunctionInt('pwr5',CM_PWR5,FS);
FS.TypeF:=T_Complex; FS.TV[0]:=T_Complex;
SetFunctionInt('pwr5',CM_PWR5,FS);

//PWRN5: {76}
InitFuncStruct(FS); FS.IntF:=1; FS.N:=1;
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TypeF:=T_Real; FS.TV[0]:=T_Real;     FS.TM[0]:=_Extended;
FS.ReplFunc:=_YES;
SetFunctionInt('pwrn5',CM_PWRN5,FS);
FS.TypeF:=T_Complex; FS.TV[0]:=T_Complex;
SetFunctionInt('pwrn5',CM_PWRN5,FS);



//PWR6: {77}
InitFuncStruct(FS); FS.IntF:=1; FS.N:=1;
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TypeF:=T_Real; FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
FS.ReplFunc:=_YES;
SetFunctionInt('pwr6',CM_PWR6,FS);
FS.TypeF:=T_Complex; FS.TV[0]:=T_Complex;
SetFunctionInt('pwr6',CM_PWR6,FS);

//PWRN6: {78}
InitFuncStruct(FS); FS.IntF:=1; FS.N:=1;
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TypeF:=T_Real; FS.TV[0]:=T_Real;     FS.TM[0]:=_Extended;
FS.ReplFunc:=_YES;
SetFunctionInt('pwrn6',CM_PWRN6,FS);
FS.TypeF:=T_Complex; FS.TV[0]:=T_Complex;
SetFunctionInt('pwrn6',CM_PWRN6,FS);


//MOD: {79}
InitFuncStruct(FS);
FS.IntF:=1; FS.N:=2;  FS.SDeep:=0;  FS.TypeF:=T_Real;
SetLength(FS.TM,2); FS.TM[0]:=_Extended;  FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real;  FS.TV[1]:=T_Real;
FS.ReplFunc:=_NO;
SetFunctionInt('mod',CM_MOD,FS);

//IPWR: {80}
InitFuncStruct(FS); FS.IntF:=1; FS.N:=1;
SetLength(FS.TV,1); SetLength(FS.TM,1);
FS.TypeF:=T_Real; FS.TV[0]:=T_Real;     FS.TM[0]:=_Extended;
FS.ReplFunc:=_YES;                              {.216}
SetFunctionInt('ipwr',CM_IPWR,FS);
FS.TypeF:=T_Complex; FS.TV[0]:=T_Complex;     FS.TM[0]:=_Extended;
SetFunctionInt('ipwr',CM_IPWR,FS);




//POLY: {81}
//  : poly(array,arg)
InitFuncStruct(FS);
FS.IntF:=1; FS.ExeF:=_NO;
FS.N:=2; FS.TypeF:=T_Real;
SetLength(FS.TM,2);
SetLength(FS.TV,2);
FS.TV[0]:=T_Array; FS.TM[0]:=_Extended;
FS.TV[1]:=T_Real;  FS.TM[1]:=_Extended;
FS.ReplFunc:=_YES;
SetFunctionInt('polynom',CM_POLYin,FS);

InitFuncStruct(FS);
FS.IntF:=1;
FS.N:=2; FS.TypeF:=T_Complex;
SetLength(FS.TM,2);
SetLength(FS.TV,2);
FS.TV[0]:=T_Array;    FS.TM[0]:=_Extended;
FS.TV[1]:=T_Complex;  FS.TM[1]:=_Extended;
SetFunctionInt('polynom',CM_POLYin,FS);



//  :
InitFuncStruct(FS);
FS.IntF:=1;
FS.N:=1; FS.TypeF:=T_Real;
SetLength(FS.TM,1); SetLength(FS.TV,1);
FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
SetFunctionInt('polynom@',CM_POLY,FS);

InitFuncStruct(FS);
FS.IntF:=1;
FS.N:=1; FS.TypeF:=T_Complex;
SetLength(FS.TM,1); SetLength(FS.TV,1);
FS.TV[0]:=T_Complex;  FS.TM[0]:=_Extended;
SetFunctionInt('polynom@',CM_POLY,FS);




{.223}
InitFuncStruct(FS);
FS.IntF:=1;  FS.TypeF:=T_Real;
FS.N:=2; SetLength(FS.TM,FS.N); SetLength(FS.TV,FS.N);
FS.TV[0]:=T_Real;    FS.TM[0]:=_Extended;
FS.TV[1]:=T_Real;    FS.TM[1]:=_Extended;
SetFunctionInt('max23',CM_MAX23,FS);

FS.N:=3; SetLength(FS.TM,FS.N); SetLength(FS.TV,FS.N);
FS.TV[0]:=T_Real;    FS.TM[0]:=_Extended;
FS.TV[1]:=T_Real;    FS.TM[1]:=_Extended;
FS.TV[2]:=T_Real;    FS.TM[2]:=_Extended;
SetFunctionInt('max23',CM_MAX23,FS);


InitFuncStruct(FS);
FS.IntF:=1;  FS.TypeF:=T_Real;
FS.N:=2; SetLength(FS.TM,FS.N); SetLength(FS.TV,FS.N);
FS.TV[0]:=T_Real;    FS.TM[0]:=_Extended;
FS.TV[1]:=T_Real;    FS.TM[1]:=_Extended;
SetFunctionInt('min23',CM_MIN23,FS);

FS.N:=3; SetLength(FS.TM,FS.N); SetLength(FS.TV,FS.N);
FS.TV[0]:=T_Real;    FS.TM[0]:=_Extended;
FS.TV[1]:=T_Real;    FS.TM[1]:=_Extended;
FS.TV[2]:=T_Real;    FS.TM[2]:=_Extended;
SetFunctionInt('min23',CM_MIN23,FS);

InitFuncStruct(FS);
FS.IntF:=1;  FS.TypeF:=T_Real;
FS.N:=2; SetLength(FS.TM,FS.N); SetLength(FS.TV,FS.N);
FS.TV[0]:=T_Real;    FS.TM[0]:=_Extended;
FS.TV[1]:=T_Real;    FS.TM[1]:=_Extended;
SetFunctionInt('avr23',CM_AVR23,FS);

FS.N:=3; SetLength(FS.TM,FS.N); SetLength(FS.TV,FS.N);
FS.TV[0]:=T_Real;    FS.TM[0]:=_Extended;
FS.TV[1]:=T_Real;    FS.TM[1]:=_Extended;
FS.TV[2]:=T_Real;    FS.TM[2]:=_Extended;
SetFunctionInt('avr23',CM_AVR23,FS);


InitFuncStruct(FS);
FS.IntF:=1;  FS.TypeF:=T_Real;
FS.N:=2; SetLength(FS.TM,FS.N); SetLength(FS.TV,FS.N);
FS.TV[0]:=T_Real;    FS.TM[0]:=_Extended;
FS.TV[1]:=T_Real;    FS.TM[1]:=_Extended;
SetFunctionInt('norm23',CM_NORM23,FS);

FS.N:=3; SetLength(FS.TM,FS.N); SetLength(FS.TV,FS.N);
FS.TV[0]:=T_Real;    FS.TM[0]:=_Extended;
FS.TV[1]:=T_Real;    FS.TM[1]:=_Extended;
FS.TV[2]:=T_Real;    FS.TM[2]:=_Extended;
SetFunctionInt('norm23',CM_NORM23,FS);


//2^real
InitFuncStruct(FS); FS.IntF:=1;
FS.N:=1;  SetLength(FS.TM,FS.N); SetLength(FS.TV,FS.N);
FS.TypeF:=T_Real; FS.TV[0]:=T_Real;   FS.TM[0]:=_Extended;
SetFunctionInt('f2pwr',CM_F2PWR,FS);


{.227}
InitFuncStruct(FS); FS.IntF:=1;
FS.N:=0;  SetLength(FS.TM,FS.N); SetLength(FS.TV,FS.N);
FS.TypeF:=T_None;
FS.CalcConst:=_NO;
SetFunctionInt('try',CM_TRY,FS);

InitFuncStruct(FS); FS.IntF:=1;
FS.N:=0; FS.TypeF:=T_Real; SetLength(FS.TM,FS.N); SetLength(FS.TV,FS.N);
FS.CalcConst:=_NO;
SetFunctionInt('exception',CM_EXCEPTION,FS);








//  : random,rand,rnd (),(int),(float1,float2)
InitFuncStruct(FS);
FS.IntF:=1; FS.ExeF:=_NO;
FS.N:=0; FS.TypeF:=T_Real;
SetLength(FS.TM,0);
SetLength(FS.TV,0);
FS.ReplFunc:=_NO;
FS.CalcConst:=_NO;
SetFunctionInt('random',CM_RANDin,FS);


InitFuncStruct(FS);
FS.IntF:=1; FS.ExeF:=_NO;
FS.N:=1; FS.TypeF:=T_Real;
SetLength(FS.TM,1);
SetLength(FS.TV,1);
FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
FS.ReplFunc:=_NO;
FS.CalcConst:=_NO;
SetFunctionInt('random',CM_RANDin,FS);


InitFuncStruct(FS);
FS.IntF:=1; FS.ExeF:=_NO;
FS.N:=2; FS.TypeF:=T_Real;
SetLength(FS.TM,2);
SetLength(FS.TV,2);
FS.TV[0]:=T_Real;  FS.TM[0]:=_Extended;
FS.TV[1]:=T_Real;  FS.TM[1]:=_Extended;
FS.ReplFunc:=_NO;
FS.CalcConst:=_NO;
SetFunctionInt('random',CM_RANDin,FS);


SetExtNameFunc(CM_POWER,'pow');
SetExtNameFunc(CM_LOGN,'logn');
SetExtNameFunc(CM_TAN,'tg');
SetExtNameFunc(CM_COTAN,'ctg');   SetExtNameFunc(CM_COTAN,'cot');
SetExtNameFunc(CM_ARCCOS,'acos');
SetExtNameFunc(CM_ARCSIN,'asin');
SetExtNameFunc(CM_ARCTAN,'atan'); SetExtNameFunc(CM_ARCTAN,'arctg'); SetExtNameFunc(CM_ARCTAN,'atg');
SetExtNameFunc(CM_ARCCOTAN,'arccotan');SetExtNameFunc(CM_ARCCOTAN,'acot'); SetExtNameFunc(CM_ARCCOTAN,'arccot'); SetExtNameFunc(CM_ARCCOTAN,'arcctg'); SetExtNameFunc(CM_ARCCOTAN,'actg');
SetExtNameFunc(CM_SINH,'sh');
SetExtNameFunc(CM_COSH,'ch');
SetExtNameFunc(CM_TANH,'th');
SetExtNameFunc(CM_COTANH,'cth');  SetExtNameFunc(CM_COTANH,'coth');
SetExtNameFunc(CM_ARCCOSH,'arcch');SetExtNameFunc(CM_ARCCOSH,'acosh');SetExtNameFunc(CM_ARCCOSH,'ach');  SetExtNameFunc(CM_ARCCOSH,'arch'); SetExtNameFunc(CM_ARCCOSH,'arcosh');
SetExtNameFunc(CM_ARCSINH,'arcsh');SetExtNameFunc(CM_ARCSINH,'asinh'); SetExtNameFunc(CM_ARCSINH,'ash');  SetExtNameFunc(CM_ARCSINH,'arsh'); SetExtNameFunc(CM_ARCSINH,'arsinh');
SetExtNameFunc(CM_ARCTANH,'arcth');SetExtNameFunc(CM_ARCTANH,'ath'); SetExtNameFunc(CM_ARCTANH,'atanh'); SetExtNameFunc(CM_ARCTANH,'arth'); SetExtNameFunc(CM_ARCTANH,'artanh');
SetExtNameFunc(CM_ARCCOTANH,'arccth');SetExtNameFunc(CM_ARCCOTANH,'acth'); SetExtNameFunc(CM_ARCCOTANH,'arccoth'); SetExtNameFunc(CM_ARCCOTANH,'acoth'); SetExtNameFunc(CM_ARCCOTANH,'arcoth');
SetExtNameFunc(CM_COSECH,'csch');
SetExtNameFunc(CM_ARCCOSECH,'arccsch');  SetExtNameFunc(CM_ARCCOSECH,'arcosech');  SetExtNameFunc(CM_ARCCOSECH,'acsch');
SetExtNameFunc(CM_ARCSECH,'arsech');   SetExtNameFunc(CM_ARCSECH,'asech');
SetExtNameFunc(CM_COSEC,'csc');
SetExtNameFunc(CM_ARCSEC,'asec');
SetExtNameFunc(CM_ARCCOSEC,'arccsc'); SetExtNameFunc(CM_ARCCOSEC,'acsc'); SetExtNameFunc(CM_ARCCOSEC,'acosec');
SetExtNameFunc(CM_LOG10,'lg');
SetExtNameFunc(CM_LOG2,'lg2');
SetExtNameFunc(CM_AVR,'avg');
SetExtNameFunc(CM_SIGN,'sgn');
SetExtNameFunc(CM_ARCTAN2,'atan2');  SetExtNameFunc(CM_ARCTAN2,'arctg2'); SetExtNameFunc(CM_ARCTAN2,'atg2');
SetExtNameFunc(CM_POLYin,'poly');
SetExtNameFunc(CM_RANDin,'rand');   SetExtNameFunc(CM_RANDin,'rnd');
SetExtNameFunc(CM_CON,'conj');



//EXTERNAL FUNCTIONS (FS.IntF:=0)

InitFuncStruct(FS); FS.IntF:=0;
FS.addr:=Cardinal(@mt_rand2);
SetLength(FS.TM,2); FS.TM[0]:=_Double; FS.TM[1]:=_Double;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
FS.N:=2;
FS.TypeF:=T_Real;
FS.SDeep:=2;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Adr;
FS.SaveReg:=15;
FS.CalcConst:=_NO;
FS.ReplFunc:=_NO;
SetFunction('randommt',FS);  FindFuncA('randommt',NF); SetExtNameFunc(NF,'randmt');  SetExtNameFunc(NF,'rndmt');


InitFuncStruct(FS);  FS.IntF:=0;
FS.addr:=Cardinal(@MT_intrand);
SetLength(FS.TM,1); FS.TM[0]:=_Integer;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Adr;
FS.N:=1;
FS.TypeF:=T_real;
FS.CallT:=_STACK_VAL;
FS.SDeep:=2;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
FS.CalcConst:=_NO;
SetFunction('intrandommt',FS);  FindFuncA('intrandommt',NF);  SetExtNameFunc(NF,'irandmt'); SetExtNameFunc(NF,'irndmt');


InitFuncStruct(FS);  FS.IntF:=0;
FS.addr:=Cardinal(@MT_rand01);
SetLength(FS.TM,0);
SetLength(FS.TV,0);
FS.Arrow:=_Right;
FS.CallT:=_Stack_Adr;
FS.N:=0;
FS.TypeF:=T_real;
FS.CallT:=_STACK_VAL;
FS.SDeep:=2;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
FS.CalcConst:=_NO;
SetFunction('random01mt',FS);  FindFuncA('random01mt',NF);  SetExtNameFunc(NF,'rand01mt'); SetExtNameFunc(NF,'rnd01mt');


InitFuncStruct(FS); FS.IntF:=0;
FS.addr:=Cardinal(@ple_rand2);
SetLength(FS.TM,2); FS.TM[0]:=_Double; FS.TM[1]:=_Double;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
FS.N:=2;
FS.TypeF:=T_Real;
FS.SDeep:=2;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Adr;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
FS.CalcConst:=_NO;
SetFunction('randomple',FS); FindFuncA('randomple',NF); SetExtNameFunc(NF,'randple');  SetExtNameFunc(NF,'randple');
                                                        SetExtNameFunc(NF,'randf');    SetExtNameFunc(NF,'rndple');


InitFuncStruct(FS);  FS.IntF:=0;
FS.addr:=Cardinal(@PLE_intrand);
SetLength(FS.TM,1); FS.TM[0]:=_Integer;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Adr;
FS.N:=1;
FS.TypeF:=T_real;
FS.CallT:=_STACK_VAL;
FS.SDeep:=2;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
FS.CalcConst:=_NO;
SetFunction('intrandomple',FS);  FindFuncA('intrandomple',NF);  SetExtNameFunc(NF,'irandple'); SetExtNameFunc(NF,'irndple');


InitFuncStruct(FS);  FS.IntF:=0;
FS.addr:=Cardinal(@PLE_rand01);
SetLength(FS.TM,0);
SetLength(FS.TV,0);
FS.Arrow:=_Right;
FS.CallT:=_Stack_Adr;
FS.N:=0;
FS.TypeF:=T_real;
FS.CallT:=_STACK_VAL;
FS.SDeep:=2;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
FS.CalcConst:=_NO;
SetFunction('random01ple',FS);  FindFuncA('random01ple',NF);  SetExtNameFunc(NF,'rand01ple'); SetExtNameFunc(NF,'rnd01ple');



InitFuncStruct(FS); FS.IntF:=0;
FS.addr:=Cardinal(@xor_rand2);
SetLength(FS.TM,2); FS.TM[0]:=_Double; FS.TM[1]:=_Double;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
FS.N:=2;
FS.TypeF:=T_Real;
FS.SDeep:=2;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Adr;
FS.CalcConst:=_NO;
FS.CalcConst:=_NO;
FS.SaveReg:=15;
SetFunction('randomxor',FS);  FindFuncA('randomxor',NF); SetExtNameFunc(NF,'randxor');  SetExtNameFunc(NF,'rndxor');


InitFuncStruct(FS);  FS.IntF:=0;
FS.addr:=Cardinal(@XOR_intrand);
SetLength(FS.TM,1); FS.TM[0]:=_Integer;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.Arrow:=_Right;
FS.CallT:=_Stack_Adr;
FS.N:=1;
FS.TypeF:=T_real;
FS.CallT:=_STACK_VAL;
FS.SDeep:=2;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
FS.CalcConst:=_NO;
SetFunction('intrandomxor',FS);  FindFuncA('intrandomxor',NF);  SetExtNameFunc(NF,'irandxor'); SetExtNameFunc(NF,'irndxor');


InitFuncStruct(FS);  FS.IntF:=0;
FS.addr:=Cardinal(@XOR_rand01);
SetLength(FS.TM,0);
SetLength(FS.TV,0);
FS.Arrow:=_Right;
FS.CallT:=_Stack_Adr;
FS.N:=0;
FS.TypeF:=T_real;
FS.CallT:=_STACK_VAL;
FS.SDeep:=2;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
FS.CalcConst:=_NO;
SetFunction('random01xor',FS);  FindFuncA('random01xor',NF);  SetExtNameFunc(NF,'rand01xor'); SetExtNameFunc(NF,'rnd01xor');



InitFuncStruct(FS); FS.IntF:=0;
FS.addr:=Cardinal(@_RandG);
SetLength(FS.TM,2); FS.TM[0]:=_Extended; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
FS.N:=2;
FS.TypeF:=T_Real;
FS.SDeep:=2; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Adr;
FS.SaveReg:=15;
FS.CalcConst:=_NO;
FS.ReplFunc:=_NO;
SetFunction('randomgausse',FS); FindFuncA('randomgausse',NF); SetExtNameFunc(NF,'randG'); SetExtNameFunc(NF,'rndG'); SetExtNameFunc(NF,'randgausse');


InitFuncStruct(FS);  FS.IntF:=0;
FS.addr:=Cardinal(@_Randomize);
SetLength(FS.TM,0);
SetLength(FS.TV,0);
FS.Arrow:=_Right;
FS.CallT:=_Stack_Adr;
FS.N:=0;
FS.CallT:=_STACK_VAL;
FS.SDeep:=2;
FS.SaveReg:=15;
FS.ReplFunc:=_NO;
FS.CalcConst:=_NO;
FS.TypeF:=T_None;
SetFunction('randomize',FS);



InitFuncStruct(FS); FS.IntF:=0;
FS.addr:=Cardinal(@sphY);
SetLength(FS.TM,4); FS.TM[0]:=_Integer; FS.TM[1]:=_Integer; FS.TM[2]:=_Extended; FS.TM[3]:=_Extended;
SetLength(FS.TV,4); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;  FS.TV[2]:=T_Real; FS.TV[3]:=T_Real;
FS.N:=4;
FS.TypeF:=T_Complex;
FS.SDeep:=3; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Adr;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('sphy',FS);   FindFuncA('sphy',NF); SetExtNameFunc(NF,'sphericalharmonics');  SetExtNameFunc(NF,'sphericalharmonicy');



InitFuncStruct(FS); FS.IntF:=0;
FS.addr:=Cardinal(@sfc_gamma);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.N:=1;
FS.TypeF:=T_Real;
FS.SDeep:=4; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('gamma',FS);

FS.addr:=Cardinal({@cgamma}@sfc_gammaCx);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Complex;
FS.N:=1;
FS.TypeF:=T_Complex;
FS.SDeep:=4; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Adr;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('gamma',FS);




InitFuncStruct(FS); FS.IntF:=0;
FS.addr:=Cardinal(@bessel_jn);
SetLength(FS.TM,2); FS.TM[0]:=_Integer; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
FS.N:=2;
FS.TypeF:=T_Real;
FS.SDeep:=4; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Adr;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('besseljn',FS);    FindFuncA('besseljn',NF); SetExtNameFunc(NF,'bjn');    SetExtNameFunc(NF,'besselj');


InitFuncStruct(FS); FS.IntF:=0;
FS.addr:=Cardinal(@bessel_j0);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.N:=1;
FS.TypeF:=T_Real;
FS.SDeep:=4; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Adr;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('besselj0',FS);    FindFuncA('besselj0',NF); SetExtNameFunc(NF,'bj0');


InitFuncStruct(FS); FS.IntF:=0;
FS.addr:=Cardinal(@bessel_j1);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.N:=1;
FS.TypeF:=T_Real;
FS.SDeep:=4; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Adr;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('besselj1',FS);    FindFuncA('besselj1',NF); SetExtNameFunc(NF,'bj1');


InitFuncStruct(FS); FS.IntF:=0;
FS.addr:=Cardinal(@bessel_yn);
SetLength(FS.TM,2); FS.TM[0]:=_Integer; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
FS.N:=2;
FS.TypeF:=T_Real;
FS.SDeep:=4; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Adr;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('besselyn',FS);     FindFuncA('besselyn',NF); SetExtNameFunc(NF,'byn');   SetExtNameFunc(NF,'bessely');


InitFuncStruct(FS); FS.IntF:=0;
FS.addr:=Cardinal(@bessel_y0);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.N:=1;
FS.TypeF:=T_Real;
FS.SDeep:=4; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Adr;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('bessely0',FS);     FindFuncA('bessely0',NF); SetExtNameFunc(NF,'by0');


InitFuncStruct(FS); FS.IntF:=0;
FS.addr:=Cardinal(@bessel_y1);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.N:=1;
FS.TypeF:=T_Real;
FS.SDeep:=4; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Adr;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('bessely1',FS);    FindFuncA('bessely1',NF); SetExtNameFunc(NF,'by1');


InitFuncStruct(FS); FS.IntF:=0;
FS.addr:=Cardinal(@sfc_legendre_p);
SetLength(FS.TM,2); FS.TM[0]:=_Integer; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
FS.N:=2;
FS.TypeF:=T_Real;
FS.SDeep:=3; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('legendrep',FS);    FindFuncA('legendrep',NF); SetExtNameFunc(NF,'legp');   SetExtNameFunc(NF,'legpoly');


InitFuncStruct(FS); FS.IntF:=0;
FS.addr:=Cardinal(@sfc_legendre_plm);
SetLength(FS.TM,3); FS.TM[0]:=_Integer; FS.TM[1]:=_Integer; FS.TM[2]:=_Extended;
SetLength(FS.TV,3); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;  FS.TV[2]:=T_Real;
FS.N:=3;
FS.TypeF:=T_Real;
FS.SDeep:=3; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('legendrep',FS);

InitFuncStruct(FS); FS.IntF:=0;
FS.addr:=Cardinal(@sph_bessel_jn);
SetLength(FS.TM,2); FS.TM[0]:=_Integer; FS.TM[1]:=_Extended;
SetLength(FS.TV,2); FS.TV[0]:=T_Real; FS.TV[1]:=T_Real;
FS.N:=2;
FS.TypeF:=T_Real;
FS.SDeep:=4; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Adr;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('sphbesseljn',FS);     FindFuncA('sphbesseljn',NF); SetExtNameFunc(NF,'sphbjn'); SetExtNameFunc(NF,'sbjn');
                                                                SetExtNameFunc(NF,'sphbesselj');


InitFuncStruct(FS); FS.IntF:=0;
FS.addr:=Cardinal(@sfc_erf);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.N:=1;
FS.TypeF:=T_Real;
FS.SDeep:=4; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('erf',FS);


InitFuncStruct(FS); FS.IntF:=0;
FS.addr:=Cardinal(@sfc_erfc);
SetLength(FS.TM,1); FS.TM[0]:=_Extended;
SetLength(FS.TV,1); FS.TV[0]:=T_Real;
FS.N:=1;
FS.TypeF:=T_Real;
FS.SDeep:=4; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_YES;
FS.SaveReg:=15;
FS.ReplFunc:=_YES;
SetFunction('erfc',FS);


(*
{.227}
InitFuncStruct(FS);  FS.IntF:=0;
FS.addr:=Cardinal(@_MaskFPUException);
FS.N:=0;
FS.TypeF:=T_None;
FS.SDeep:=0; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=0;
FS.ReplFunc:=_NO;
SetFunction('try',FS);


{.227}
InitFuncStruct(FS);  FS.IntF:=0;
FS.addr:=Cardinal(@_IsFPUException);
FS.N:=0;
FS.TypeF:=T_Real;
FS.SDeep:=1; // need to check!!!
FS.Arrow:=_Right;
FS.CallT:=_Stack_Val;
FS.CalcConst:=_NO;
FS.SaveReg:=0;
FS.ReplFunc:=_NO;
SetFunction('exception',FS);
*)






InitTableRF; {.217}

//     
//Addition of operations after addition of appropriate functions
//Operation:
SetOperation('+','add',1,0,0);
SetOperation('-','sub',1,0,0);
SetOperation('*','mul',2,0,0);
SetOperation('/','div',2,0,0);
SetOperation('^','power',3,0,1);
SetOperation('-','neg',1,-1,0);
SetOperation('!','fact',2,-2,1);
SetOperation('!!','fact2',2,-2,1);
SetOperation('_','con',2,-2,1);
SetOperation('.re','re',2,-2,1);
SetOperation('.im','im',2,-2,1);
//   .   TAlgOperation
//For character change the description see of TAlgOperation

COP_MUL:=FindOperation('*');
COP_DIV:=FindOperation('/');
end;



{.217}
procedure TForevalH.InitTableRF;
var
 i,j,L: integer;
begin
 SetLength(TableRF,Length(Alg.ExFunc),Length(Alg.ExFunc));

 L:=Length(Alg.ExFunc);
 for i := 0 to L - 1 do
 begin
   for j := 0 to L - 1 do
   begin
        TableRF[i,j].WRF_R:=rf_NO_REPLACE;    //=0
        TableRF[i,j].RRF_R:=rf_NO_REPLACE;    //=0
        TableRF[i,j].WRF_Z:=rf_NO_REPLACE;    //=0
        TableRF[i,j].RRF_Z:=rf_NO_REPLACE;    //=0
        TableRF[i,j].NMEM_R:=0;    //=0
        TableRF[i,j].NMEM_Z:=0;    //=0
        TableRF[i,j].SHFT_R:=0;    //=0
        TableRF[i,j].SHFT_Z:=0;    //=0
        if i=j  then
        begin
          TableRF[i,j].WRF_R:=rf_FULL_REPLACE;
          TableRF[i,j].RRF_R:=rf_FULL_REPLACE;
          TableRF[i,j].NMEM_R:=1;
          TableRF[i,j].WRF_Z:=rf_FULL_REPLACE;
          TableRF[i,j].RRF_Z:=rf_FULL_REPLACE;
          TableRF[i,j].NMEM_Z:=2;
        end;
   end;

   //     TableRF[]
   Alg.ExFunc[i].ReplFuncCFZ:=_YES;
   Alg.ExFunc[i].ReplFuncCFR:=_YES;
 end;

{
  WRF_R -> RRF_R
  WRF_R -   :   (=rf_FULL_REPLACE) ,   (  )
  RRF_R -   :   (=rf_FULL_REPLACE) ,   (  )
          NMEM_R, NMEM_Z -     real/complex  ( complex -  = 2)
                  ( :         )
          .: sh->ch  (WRF_R=rf_EXPR2_REPLACE) "exp", "1/exp"   (ch) (RRF_R=rf_EXPR2_REPLACE)
                 sh->th !! (WRF_R=rf_EXPR2_REPLACE) "exp", "1/exp" ,   (th)  "exp" (RRF_R=rf_EXPR1_REPLACE)
 SHFT_R -     (  (  : NMEM_R/NMEM_Z ))    (   ,  )
          .: sin->cos      (NMEM_R=2)(fsincos: [1]cos,[2]sin); cos   (),  = 1 (SHFT_R)
          .: sin->tanh      (NMEM_Z=4)( [1]RE(exp),[2]IM(exp),[3]RE(1/exp),[4]IM(1/exp))); tanh   ,  = 2 (SHFT_Z)
                 (     )
     :    (rf_FULL_REPLACE)   (   )
}
                //  SIN
 TableRF[CM_SIN,CM_COS].WRF_R:=rf_SINCOSR_REPLACE;
 TableRF[CM_SIN,CM_COS].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_SIN,CM_COS].NMEM_R:=2;
 TableRF[CM_SIN,CM_COS].SHFT_R:=1;
 TableRF[CM_SIN,CM_COS].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SIN,CM_COS].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SIN,CM_COS].NMEM_Z:=4;

 TableRF[CM_SIN,CM_COSEC].WRF_R:=rf_SINCOSR_REPLACE;
 TableRF[CM_SIN,CM_COSEC].RRF_R:=rf_SINR_REPLACE;
 TableRF[CM_SIN,CM_COSEC].NMEM_R:=2;
 TableRF[CM_SIN,CM_COSEC].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SIN,CM_COSEC].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SIN,CM_COSEC].NMEM_Z:=4;

 TableRF[CM_SIN,CM_SEC].WRF_R:=rf_SINCOSR_REPLACE;
 TableRF[CM_SIN,CM_SEC].RRF_R:=rf_COSR_REPLACE;
 TableRF[CM_SIN,CM_SEC].NMEM_R:=2;
 TableRF[CM_SIN,CM_SEC].SHFT_R:=1;
 TableRF[CM_SIN,CM_SEC].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SIN,CM_SEC].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SIN,CM_SEC].NMEM_Z:=4;

 TableRF[CM_SIN,CM_TAN].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SIN,CM_TAN].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_SIN,CM_TAN].NMEM_Z:=4;
 TableRF[CM_SIN,CM_TAN].SHFT_Z:=2;

 TableRF[CM_SIN,CM_COTAN].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SIN,CM_COTAN].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_SIN,CM_COTAN].NMEM_Z:=4;
 TableRF[CM_SIN,CM_COTAN].SHFT_Z:=2;



                //  COS

 TableRF[CM_COS,CM_SIN].WRF_R:=rf_SINCOSR_REPLACE;
 TableRF[CM_COS,CM_SIN].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_COS,CM_SIN].NMEM_R:=2;
 TableRF[CM_COS,CM_SIN].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COS,CM_SIN].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COS,CM_SIN].NMEM_Z:=4;

 TableRF[CM_COS,CM_COSEC].WRF_R:=rf_SINCOSR_REPLACE;
 TableRF[CM_COS,CM_COSEC].RRF_R:=rf_SINR_REPLACE;
 TableRF[CM_COS,CM_COSEC].NMEM_R:=2;
 TableRF[CM_COS,CM_COSEC].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COS,CM_COSEC].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COS,CM_COSEC].NMEM_Z:=4;

 TableRF[CM_COS,CM_SEC].WRF_R:=rf_SINCOSR_REPLACE;
 TableRF[CM_COS,CM_SEC].RRF_R:=rf_COSR_REPLACE;
 TableRF[CM_COS,CM_SEC].NMEM_R:=2;
 TableRF[CM_COS,CM_SEC].SHFT_R:=1;
 TableRF[CM_COS,CM_SEC].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COS,CM_SEC].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COS,CM_SEC].NMEM_Z:=4;

 TableRF[CM_COS,CM_TAN].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COS,CM_TAN].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COS,CM_TAN].NMEM_Z:=4;
 TableRF[CM_COS,CM_TAN].SHFT_Z:=2;

 TableRF[CM_COS,CM_COTAN].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COS,CM_COTAN].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COS,CM_COTAN].NMEM_Z:=4;
 TableRF[CM_COS,CM_COTAN].SHFT_Z:=2;








 TableRF[CM_SINCOS,CM_COS].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_SINCOS,CM_COS].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_SINCOS,CM_COS].NMEM_R:=2;
 TableRF[CM_SINCOS,CM_COS].SHFT_R:=1;
 TableRF[CM_SINCOS,CM_COS].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SINCOS,CM_COS].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SINCOS,CM_COS].NMEM_Z:=2;

 TableRF[CM_COSSIN,CM_COS].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_COSSIN,CM_COS].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_COSSIN,CM_COS].NMEM_R:=2;
 //TableRF[CM_COSSIN,CM_COS].SHFT_R:=1;
 TableRF[CM_COSSIN,CM_COS].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSSIN,CM_COS].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSSIN,CM_COS].NMEM_Z:=2;




              //  TAN
 TableRF[CM_TAN,CM_COTAN].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_TAN,CM_COTAN].RRF_R:=rf_INVERSE_REPLACE;
 TableRF[CM_TAN,CM_COTAN].NMEM_R:=1;
 TableRF[CM_TAN,CM_COTAN].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_TAN,CM_COTAN].RRF_Z:=rf_INVERSE_REPLACE;
 TableRF[CM_TAN,CM_COTAN].NMEM_Z:=2;

 TableRF[CM_TAN,CM_SIN].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TAN,CM_SIN].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TAN,CM_SIN].NMEM_Z:=2;

 TableRF[CM_TAN,CM_SEC].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TAN,CM_SEC].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TAN,CM_SEC].NMEM_Z:=2;

 TableRF[CM_TAN,CM_COSEC].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TAN,CM_COSEC].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TAN,CM_COSEC].NMEM_Z:=2;

 TableRF[CM_TAN,CM_COS].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TAN,CM_COS].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TAN,CM_COS].NMEM_Z:=2;





          //    COTAN
 TableRF[CM_COTAN,CM_SIN].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTAN,CM_SIN].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTAN,CM_SIN].NMEM_Z:=2;

 TableRF[CM_COTAN,CM_TAN].WRF_R:=rf_INVERSE_REPLACE;
 TableRF[CM_COTAN,CM_TAN].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_COTAN,CM_TAN].NMEM_R:=1;
 TableRF[CM_COTAN,CM_TAN].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_COTAN,CM_TAN].RRF_Z:=rf_INVERSE_REPLACE;
 TableRF[CM_COTAN,CM_TAN].NMEM_Z:=2;

 TableRF[CM_COTAN,CM_SEC].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTAN,CM_SEC].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTAN,CM_SEC].NMEM_Z:=2;

 TableRF[CM_COTAN,CM_COSEC].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTAN,CM_COSEC].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTAN,CM_COSEC].NMEM_Z:=2;

 TableRF[CM_COTAN,CM_COS].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTAN,CM_COS].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTAN,CM_COS].NMEM_Z:=2;






               //  COSEC
 TableRF[CM_COSEC,CM_SIN].WRF_R:=rf_SINCOSR_REPLACE;
 TableRF[CM_COSEC,CM_SIN].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_COSEC,CM_SIN].NMEM_R:=2;
 TableRF[CM_COSEC,CM_SIN].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSEC,CM_SIN].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSEC,CM_SIN].NMEM_Z:=4;

 TableRF[CM_COSEC,CM_COS].WRF_R:=rf_SINCOSR_REPLACE;
 TableRF[CM_COSEC,CM_COS].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_COSEC,CM_COS].NMEM_R:=2;
 TableRF[CM_COSEC,CM_COS].SHFT_R:=1;
 TableRF[CM_COSEC,CM_COS].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSEC,CM_COS].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSEC,CM_COS].NMEM_Z:=4;

 TableRF[CM_COSEC,CM_SEC].WRF_R:=rf_SINCOSR_REPLACE;
 TableRF[CM_COSEC,CM_SEC].RRF_R:=rf_COSR_REPLACE;
 TableRF[CM_COSEC,CM_SEC].NMEM_R:=2;
 TableRF[CM_COSEC,CM_SEC].SHFT_R:=1;
 TableRF[CM_COSEC,CM_SEC].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSEC,CM_SEC].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSEC,CM_SEC].NMEM_Z:=4;

 TableRF[CM_COSEC,CM_TAN].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSEC,CM_TAN].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COSEC,CM_TAN].NMEM_Z:=4;
 TableRF[CM_COSEC,CM_TAN].SHFT_Z:=2;

 TableRF[CM_COSEC,CM_COTAN].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSEC,CM_COTAN].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COSEC,CM_COTAN].NMEM_Z:=4;
 TableRF[CM_COSEC,CM_COTAN].SHFT_Z:=2;



            //  SEC
 TableRF[CM_SEC,CM_SIN].WRF_R:=rf_SINCOSR_REPLACE;
 TableRF[CM_SEC,CM_SIN].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_SEC,CM_SIN].NMEM_R:=2;
 TableRF[CM_SEC,CM_SIN].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SEC,CM_SIN].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SEC,CM_SIN].NMEM_Z:=4;

 TableRF[CM_SEC,CM_COS].WRF_R:=rf_SINCOSR_REPLACE;
 TableRF[CM_SEC,CM_COS].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_SEC,CM_COS].NMEM_R:=2;
 TableRF[CM_SEC,CM_COS].SHFT_R:=1;
 TableRF[CM_SEC,CM_COS].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SEC,CM_COS].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SEC,CM_COS].NMEM_Z:=4;

 TableRF[CM_SEC,CM_TAN].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SEC,CM_TAN].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_SEC,CM_TAN].NMEM_Z:=4;
 TableRF[CM_SEC,CM_TAN].SHFT_Z:=2;

 TableRF[CM_SEC,CM_COTAN].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SEC,CM_COTAN].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_SEC,CM_COTAN].NMEM_Z:=4;
 TableRF[CM_SEC,CM_COTAN].SHFT_Z:=2;


 TableRF[CM_SEC,CM_COSEC].WRF_R:=rf_SINCOSR_REPLACE;
 TableRF[CM_SEC,CM_COSEC].RRF_R:=rf_SINR_REPLACE;
 TableRF[CM_SEC,CM_COSEC].NMEM_R:=2;
 TableRF[CM_SEC,CM_COSEC].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SEC,CM_COSEC].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SEC,CM_COSEC].NMEM_Z:=4;





             // SINH
 TableRF[CM_SINH,CM_EXP].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SINH,CM_EXP].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_SINH,CM_EXP].NMEM_R:=2;
 TableRF[CM_SINH,CM_EXP].SHFT_R:=1;
 TableRF[CM_SINH,CM_EXP].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SINH,CM_EXP].RRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_SINH,CM_EXP].NMEM_Z:=4;
 TableRF[CM_SINH,CM_EXP].SHFT_Z:=2;

 TableRF[CM_SINH,CM_COSH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SINH,CM_COSH].RRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SINH,CM_COSH].NMEM_R:=2;
 TableRF[CM_SINH,CM_COSH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SINH,CM_COSH].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SINH,CM_COSH].NMEM_Z:=4;

 TableRF[CM_SINH,CM_TANH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SINH,CM_TANH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_SINH,CM_TANH].NMEM_R:=2;
 TableRF[CM_SINH,CM_TANH].SHFT_R:=1;
 TableRF[CM_SINH,CM_TANH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SINH,CM_TANH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_SINH,CM_TANH].NMEM_Z:=4;
 TableRF[CM_SINH,CM_TANH].SHFT_Z:=2;

 TableRF[CM_SINH,CM_COTANH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SINH,CM_COTANH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_SINH,CM_COTANH].NMEM_R:=2;
 TableRF[CM_SINH,CM_COTANH].SHFT_R:=1;
 TableRF[CM_SINH,CM_COTANH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SINH,CM_COTANH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_SINH,CM_COTANH].NMEM_Z:=4;
 TableRF[CM_SINH,CM_COTANH].SHFT_Z:=2;

 TableRF[CM_SINH,CM_COSECH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SINH,CM_COSECH].RRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SINH,CM_COSECH].NMEM_R:=2;
 TableRF[CM_SINH,CM_COSECH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SINH,CM_COSECH].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SINH,CM_COSECH].NMEM_Z:=4;

 TableRF[CM_SINH,CM_SECH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SINH,CM_SECH].RRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SINH,CM_SECH].NMEM_R:=2;
 TableRF[CM_SINH,CM_SECH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SINH,CM_SECH].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SINH,CM_SECH].NMEM_Z:=4;



             // COSH
 TableRF[CM_COSH,CM_EXP].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSH,CM_EXP].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_COSH,CM_EXP].NMEM_R:=2;
 TableRF[CM_COSH,CM_EXP].SHFT_R:=1;
 TableRF[CM_COSH,CM_EXP].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSH,CM_EXP].RRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_COSH,CM_EXP].NMEM_Z:=4;
 TableRF[CM_COSH,CM_EXP].SHFT_Z:=2;

 TableRF[CM_COSH,CM_SINH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSH,CM_SINH].RRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSH,CM_SINH].NMEM_R:=2;
 TableRF[CM_COSH,CM_SINH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSH,CM_SINH].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSH,CM_SINH].NMEM_Z:=4;

 TableRF[CM_COSH,CM_COSECH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSH,CM_COSECH].RRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSH,CM_COSECH].NMEM_R:=2;
 TableRF[CM_COSH,CM_COSECH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSH,CM_COSECH].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSH,CM_COSECH].NMEM_Z:=4;

 TableRF[CM_COSH,CM_SECH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSH,CM_SECH].RRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSH,CM_SECH].NMEM_R:=2;
 TableRF[CM_COSH,CM_SECH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSH,CM_SECH].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSH,CM_SECH].NMEM_Z:=4;

 TableRF[CM_COSH,CM_TANH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSH,CM_TANH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_COSH,CM_TANH].NMEM_R:=2;
 TableRF[CM_COSH,CM_TANH].SHFT_R:=1;
 TableRF[CM_COSH,CM_TANH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSH,CM_TANH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COSH,CM_TANH].NMEM_Z:=4;
 TableRF[CM_COSH,CM_TANH].SHFT_Z:=2;

 TableRF[CM_COSH,CM_COTANH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSH,CM_COTANH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_COSH,CM_COTANH].NMEM_R:=2;
 TableRF[CM_COSH,CM_COTANH].SHFT_R:=1;
 TableRF[CM_COSH,CM_COTANH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSH,CM_COTANH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COSH,CM_COTANH].NMEM_Z:=4;
 TableRF[CM_COSH,CM_COTANH].SHFT_Z:=2;



           // EXP
 TableRF[CM_EXP,CM_SINH].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_EXP,CM_SINH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_EXP,CM_SINH].NMEM_R:=1;
 TableRF[CM_EXP,CM_SINH].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_EXP,CM_SINH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_EXP,CM_SINH].NMEM_Z:=2;

 TableRF[CM_EXP,CM_COSH].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_EXP,CM_COSH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_EXP,CM_COSH].NMEM_R:=1;
 TableRF[CM_EXP,CM_COSH].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_EXP,CM_COSH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_EXP,CM_COSH].NMEM_Z:=2;

 TableRF[CM_EXP,CM_COSECH].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_EXP,CM_COSECH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_EXP,CM_COSECH].NMEM_R:=1;
 TableRF[CM_EXP,CM_COSECH].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_EXP,CM_COSECH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_EXP,CM_COSECH].NMEM_Z:=2;

 TableRF[CM_EXP,CM_SECH].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_EXP,CM_SECH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_EXP,CM_SECH].NMEM_R:=1;
 TableRF[CM_EXP,CM_SECH].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_EXP,CM_SECH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_EXP,CM_SECH].NMEM_Z:=2;


 TableRF[CM_EXP,CM_TANH].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_EXP,CM_TANH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_EXP,CM_TANH].NMEM_R:=1;
 TableRF[CM_EXP,CM_TANH].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_EXP,CM_TANH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_EXP,CM_TANH].NMEM_Z:=2;

 TableRF[CM_EXP,CM_COTANH].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_EXP,CM_COTANH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_EXP,CM_COTANH].NMEM_R:=1;
 TableRF[CM_EXP,CM_COTANH].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_EXP,CM_COTANH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_EXP,CM_COTANH].NMEM_Z:=2;


           // TANH
 TableRF[CM_TANH,CM_COTANH].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_TANH,CM_COTANH].RRF_R:=rf_INVERSE_REPLACE;
 TableRF[CM_TANH,CM_COTANH].NMEM_R:=1;
 TableRF[CM_TANH,CM_COTANH].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_TANH,CM_COTANH].RRF_Z:=rf_INVERSE_REPLACE;
 TableRF[CM_TANH,CM_COTANH].NMEM_Z:=2;

 TableRF[CM_TANH,CM_EXP].WRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_TANH,CM_EXP].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_TANH,CM_EXP].NMEM_R:=1;
 TableRF[CM_TANH,CM_EXP].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TANH,CM_EXP].RRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_TANH,CM_EXP].NMEM_Z:=2;

 TableRF[CM_TANH,CM_SINH].WRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_TANH,CM_SINH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_TANH,CM_SINH].NMEM_R:=1;
 TableRF[CM_TANH,CM_SINH].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TANH,CM_SINH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TANH,CM_SINH].NMEM_Z:=2;

 TableRF[CM_TANH,CM_COSH].WRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_TANH,CM_COSH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_TANH,CM_COSH].NMEM_R:=1;
 TableRF[CM_TANH,CM_COSH].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TANH,CM_COSH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TANH,CM_COSH].NMEM_Z:=2;

 TableRF[CM_TANH,CM_COSECH].WRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_TANH,CM_COSECH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_TANH,CM_COSECH].NMEM_R:=1;
 TableRF[CM_TANH,CM_COSECH].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TANH,CM_COSECH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TANH,CM_COSECH].NMEM_Z:=2;

 TableRF[CM_TANH,CM_SECH].WRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_TANH,CM_SECH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_TANH,CM_SECH].NMEM_R:=1;
 TableRF[CM_TANH,CM_SECH].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TANH,CM_SECH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_TANH,CM_SECH].NMEM_Z:=2;


              // COTANH
 TableRF[CM_COTANH,CM_SINH].WRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_COTANH,CM_SINH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_COTANH,CM_SINH].NMEM_R:=1;
 TableRF[CM_COTANH,CM_SINH].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTANH,CM_SINH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTANH,CM_SINH].NMEM_Z:=2;

 TableRF[CM_COTANH,CM_COSH].WRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_COTANH,CM_COSH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_COTANH,CM_COSH].NMEM_R:=1;
 TableRF[CM_COTANH,CM_COSH].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTANH,CM_COSH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTANH,CM_COSH].NMEM_Z:=2;

 TableRF[CM_COTANH,CM_COSECH].WRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_COTANH,CM_COSECH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_COTANH,CM_COSECH].NMEM_R:=1;
 TableRF[CM_COTANH,CM_COSECH].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTANH,CM_COSECH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTANH,CM_COSECH].NMEM_Z:=2;

 TableRF[CM_COTANH,CM_SECH].WRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_COTANH,CM_SECH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_COTANH,CM_SECH].NMEM_R:=1;
 TableRF[CM_COTANH,CM_SECH].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTANH,CM_SECH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTANH,CM_SECH].NMEM_Z:=2;

 TableRF[CM_COTANH,CM_EXP].WRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_COTANH,CM_EXP].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_COTANH,CM_EXP].NMEM_R:=1;
 TableRF[CM_COTANH,CM_EXP].WRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COTANH,CM_EXP].RRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_COTANH,CM_EXP].NMEM_Z:=2;

 TableRF[CM_COTANH,CM_TANH].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_COTANH,CM_TANH].RRF_R:=rf_INVERSE_REPLACE;
 TableRF[CM_COTANH,CM_TANH].NMEM_R:=1;
 TableRF[CM_COTANH,CM_TANH].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_COTANH,CM_TANH].RRF_Z:=rf_INVERSE_REPLACE;
 TableRF[CM_COTANH,CM_TANH].NMEM_Z:=2;



             //    COSECH
 TableRF[CM_COSECH,CM_EXP].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSECH,CM_EXP].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_COSECH,CM_EXP].NMEM_R:=2;
 TableRF[CM_COSECH,CM_EXP].SHFT_R:=1;
 TableRF[CM_COSECH,CM_EXP].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSECH,CM_EXP].RRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_COSECH,CM_EXP].NMEM_Z:=4;
 TableRF[CM_COSECH,CM_EXP].SHFT_Z:=2;

 TableRF[CM_COSECH,CM_SINH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSECH,CM_SINH].RRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSECH,CM_SINH].NMEM_R:=2;
 TableRF[CM_COSECH,CM_SINH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSECH,CM_SINH].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSECH,CM_SINH].NMEM_Z:=4;

 TableRF[CM_COSECH,CM_COSH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSECH,CM_COSH].RRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSECH,CM_COSH].NMEM_R:=2;
 TableRF[CM_COSECH,CM_COSH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSECH,CM_COSH].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSECH,CM_COSH].NMEM_Z:=4;

 TableRF[CM_COSECH,CM_SECH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSECH,CM_SECH].RRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSECH,CM_SECH].NMEM_R:=2;
 TableRF[CM_COSECH,CM_SECH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSECH,CM_SECH].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSECH,CM_SECH].NMEM_Z:=4;

 TableRF[CM_COSECH,CM_TANH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSECH,CM_TANH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_COSECH,CM_TANH].NMEM_R:=2;
 TableRF[CM_COSECH,CM_TANH].SHFT_R:=1;
 TableRF[CM_COSECH,CM_TANH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSECH,CM_TANH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COSECH,CM_TANH].NMEM_Z:=4;
 TableRF[CM_COSECH,CM_TANH].SHFT_Z:=2;

 TableRF[CM_COSECH,CM_COTANH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_COSECH,CM_COTANH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_COSECH,CM_COTANH].NMEM_R:=2;
 TableRF[CM_COSECH,CM_COTANH].SHFT_R:=1;
 TableRF[CM_COSECH,CM_COTANH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_COSECH,CM_COTANH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_COSECH,CM_COTANH].NMEM_Z:=4;
 TableRF[CM_COSECH,CM_COTANH].SHFT_Z:=2;


              //    SECH
 TableRF[CM_SECH,CM_EXP].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SECH,CM_EXP].RRF_R:=rf_FULL_REPLACE;
 TableRF[CM_SECH,CM_EXP].NMEM_R:=2;
 TableRF[CM_SECH,CM_EXP].SHFT_R:=1;
 TableRF[CM_SECH,CM_EXP].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SECH,CM_EXP].RRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_SECH,CM_EXP].NMEM_Z:=4;
 TableRF[CM_SECH,CM_EXP].SHFT_Z:=2;

 TableRF[CM_SECH,CM_SINH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SECH,CM_SINH].RRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SECH,CM_SINH].NMEM_R:=2;
 TableRF[CM_SECH,CM_SINH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SECH,CM_SINH].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SECH,CM_SINH].NMEM_Z:=4;

 TableRF[CM_SECH,CM_COSH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SECH,CM_COSH].RRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SECH,CM_COSH].NMEM_R:=2;
 TableRF[CM_SECH,CM_COSH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SECH,CM_COSH].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SECH,CM_COSH].NMEM_Z:=4;

 TableRF[CM_SECH,CM_COSECH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SECH,CM_COSECH].RRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SECH,CM_COSECH].NMEM_R:=2;
 TableRF[CM_SECH,CM_COSECH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SECH,CM_COSECH].RRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SECH,CM_COSECH].NMEM_Z:=4;

 TableRF[CM_SECH,CM_TANH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SECH,CM_TANH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_SECH,CM_TANH].NMEM_R:=2;
 TableRF[CM_SECH,CM_TANH].SHFT_R:=1;
 TableRF[CM_SECH,CM_TANH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SECH,CM_TANH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_SECH,CM_TANH].NMEM_Z:=4;
 TableRF[CM_SECH,CM_TANH].SHFT_Z:=2;

 TableRF[CM_SECH,CM_COTANH].WRF_R:=rf_EXPR2_REPLACE;
 TableRF[CM_SECH,CM_COTANH].RRF_R:=rf_EXPR1_REPLACE;
 TableRF[CM_SECH,CM_COTANH].NMEM_R:=2;
 TableRF[CM_SECH,CM_COTANH].SHFT_R:=1;
 TableRF[CM_SECH,CM_COTANH].WRF_Z:=rf_EXPZ2_REPLACE;
 TableRF[CM_SECH,CM_COTANH].RRF_Z:=rf_EXPZ1_REPLACE;
 TableRF[CM_SECH,CM_COTANH].NMEM_Z:=4;
 TableRF[CM_SECH,CM_COTANH].SHFT_Z:=2;




        //ARCSIN
 TableRF[CM_ARCSIN,CM_ARCCOS].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_ARCSIN,CM_ARCCOS].RRF_R:=rf_ARCSINR_REPLACE;
 TableRF[CM_ARCSIN,CM_ARCCOS].NMEM_R:=1;
 TableRF[CM_ARCSIN,CM_ARCCOS].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_ARCSIN,CM_ARCCOS].RRF_Z:=rf_ARCSINZ_REPLACE;
 TableRF[CM_ARCSIN,CM_ARCCOS].NMEM_Z:=2;

        //ARCCOS
 TableRF[CM_ARCCOS,CM_ARCSIN].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_ARCCOS,CM_ARCSIN].RRF_R:=rf_ARCCOSR_REPLACE;
 TableRF[CM_ARCCOS,CM_ARCSIN].NMEM_R:=1;
 TableRF[CM_ARCCOS,CM_ARCSIN].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_ARCCOS,CM_ARCSIN].RRF_Z:=rf_ARCCOSZ_REPLACE;
 TableRF[CM_ARCCOS,CM_ARCSIN].NMEM_Z:=2;

         //ARCTAN
 TableRF[CM_ARCTAN,CM_ARCCOTAN].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_ARCTAN,CM_ARCCOTAN].RRF_R:=rf_ARCTANR_REPLACE;
 TableRF[CM_ARCTAN,CM_ARCCOTAN].NMEM_R:=1;
 TableRF[CM_ARCTAN,CM_ARCCOTAN].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_ARCTAN,CM_ARCCOTAN].RRF_Z:=rf_ARCTANZ_REPLACE;
 TableRF[CM_ARCTAN,CM_ARCCOTAN].NMEM_Z:=2;

         //ARCCOTAN
 TableRF[CM_ARCCOTAN,CM_ARCTAN].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_ARCCOTAN,CM_ARCTAN].RRF_R:=rf_ARCCOTANR_REPLACE;
 TableRF[CM_ARCCOTAN,CM_ARCTAN].NMEM_R:=1;
 TableRF[CM_ARCCOTAN,CM_ARCTAN].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_ARCCOTAN,CM_ARCTAN].RRF_Z:=rf_ARCCOTANZ_REPLACE;
 TableRF[CM_ARCCOTAN,CM_ARCTAN].NMEM_Z:=2;


        //ARCSEC
 TableRF[CM_ARCSEC,CM_ARCCOSEC].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_ARCSEC,CM_ARCCOSEC].RRF_R:=rf_ARCSECR_REPLACE;
 TableRF[CM_ARCSEC,CM_ARCCOSEC].NMEM_R:=1;
 TableRF[CM_ARCSEC,CM_ARCCOSEC].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_ARCSEC,CM_ARCCOSEC].RRF_Z:=rf_ARCSECZ_REPLACE;
 TableRF[CM_ARCSEC,CM_ARCCOSEC].NMEM_Z:=2;


       //ARCCOSEC
 TableRF[CM_ARCCOSEC,CM_ARCSEC].WRF_R:=rf_FULL_REPLACE;
 TableRF[CM_ARCCOSEC,CM_ARCSEC].RRF_R:=rf_ARCCOSECR_REPLACE;
 TableRF[CM_ARCCOSEC,CM_ARCSEC].NMEM_R:=1;
 TableRF[CM_ARCCOSEC,CM_ARCSEC].WRF_Z:=rf_FULL_REPLACE;
 TableRF[CM_ARCCOSEC,CM_ARCSEC].RRF_Z:=rf_ARCCOSECZ_REPLACE;
 TableRF[CM_ARCCOSEC,CM_ARCSEC].NMEM_Z:=2;


end;





procedure TForevalH.SaveSW;
var
SSW: integer;
begin
 //  :  SW,    
SSW:=0;
if F_SaveSW = False then
begin
 asm
    push eax
    xor  eax,eax
    fnstsw ax
    sahf
    test ax, 001Fh

    jz @@Z

    push ax
    fnstsw ax
    mov word ptr [SWMEM],ax
    pop  ax
    mov SSW,1

    @@Z:
    pop eax

 end;

  if SSW = 1 then F_SaveSW:=True;
end;

end;



procedure TForevalH.ClearFPUException;    {.229}
begin
 asm
    fnclex
 end;
end;


procedure TForevalH.MaskFPUException(CWAddr: PCardinal);  stdcall;  {.229}
begin
 asm
    push eax
    mov eax,CWAddr
    fnstcw word ptr [eax];       //->store
    pop eax
    sub esp,4
    fnstcw [esp];
    or word ptr [esp], 003Fh;
    fldcw [esp];
    add esp, 4
 end;
end;


 {.229}
function TForevalH.IsFPUException(CWAddr: PCardinal): integer;  stdcall;
begin
 asm
    push eax
    push ecx
    xor  eax,eax
    fnstsw ax
    sahf
    test ax, 001Fh
    mov  ecx,0
    //push $00000000
    jz @@Z
    mov  ecx,1
    //mov [esp],$00000001
    @@Z:
    mov dword ptr Result,ecx
    //pop dword ptr Result //[IsFPUException]
    fnclex
    mov eax,CWAddr
    fldcw  word ptr [eax]   //<-load
    pop ecx
    pop eax
 end;
end;



 {.229}
function TForevalH.IsFPUExceptionSW(CWAddr: PCardinal): integer;  stdcall;
begin
 asm
    push eax
    push ecx
    xor  eax,eax
    //fnstsw ax
    mov ax,word ptr [SWMEM]
    sahf
    test ax, 001Fh
    mov  ecx,0
    //push $00000000
    jz @@Z
    mov  ecx,1
    //mov [esp],$00000001
    @@Z:
    mov dword ptr Result,ecx
    //pop dword ptr Result //[IsFPUException]
    fnclex
    mov eax,CWAddr
    fldcw  word ptr [eax]   //<-load
    pop ecx
    pop eax
 end;
end;


{.229}
procedure TForevalH.TryFPUMask{(CWMEM: PCardinal)};
begin
 F_SaveSW:=False;
 if F_EnableMaskFpuException = True then MaskFPUException(@CWMEM{CWMEM});
end;


{.229}
procedure TForevalH.TryCatchFPUException{(CWMEM: PCardinal)};
begin
{if IsFPUException(@CWMEM) <> 0 then
begin
  F_InternalError:=E_InvalidOp;
  F_ErrorCode:=E_InvalidOp;
end;  }

  if F_EnableMaskFpuException = True then
   begin
     if F_SaveSW = True then
     begin
       if IsFPUExceptionSW(@CWMEM{CWMEM}) <> 0 then
       begin
         F_InternalError:=E_InvalidOp;
         //F_SyntaxErrorCode:=E_InvalidOp;
       end;
     end
     else
     begin
       if IsFPUException(@CWMEM{CWMEM}) <> 0 then
       begin
         F_InternalError:=E_InvalidOp;
         //F_SyntaxErrorCode:=E_InvalidOp;
       end;
     end;
   end;

end;




procedure TForevalH.FADD(N: TAddress; VType: Integer);
begin
 if VType = _Extended then
 begin
  FLD(N,_Extended);
  FADDP;
 end
 else
 if VType = _Double then
 begin
  AddCom($DC,$05,N);
 end
 else
 if VType = _Single then
 begin
   AddCom($D8,$05,N);
 end
 else
 if VType = _Integer then
 begin
   AddCom($DA,$05,N);
 end;
end;


procedure TForevalH.FADDP;
begin
 AddWord($DE,$C1);
 CheckStack(-1);
end;

procedure TForevalH.FADDP1;
begin
 AddWord($DE,$C1);
 CheckStack(-1);
end;

procedure TForevalH.FADDP2;
begin
 AddWord($DE,$C2);
 CheckStack(-1);
end;


procedure TForevalH.FADDP20;
begin
 AddWord($DE,$C2);
 CheckStack(-1);
end;


procedure TForevalH.FSUBRP;
begin                 //st(1)=st(0)-st(1)   ; fstp(0)
 AddWord($DE,$E1);
 CheckStack(-1);
end;

procedure TForevalH.FSUBRP2;
begin                 //st(2)=st(0)-st(2) ; fstp(0)
 AddWord($DE,$E2);
 CheckStack(-1);
end;



procedure TForevalH.FSUBP2;
begin
 AddWord($DE,$EA);
 CheckStack(-1);
end;



procedure TForevalH.FSUBP40;
begin        //fsubp st(4),st(0)
 AddWord($DE,$EC);
 CheckStack(-1);
end;



procedure TForevalH.FMULP;
begin
 AddWord($DE,$C9);
 CheckStack(-1);
end;


procedure TForevalH.FMULP1;
begin           //fmulp st(1),st(0)
 AddWord($DE,$C9);
 CheckStack(-1);
end;



procedure TForevalH.FMULP2;
begin     //fmulp st(2),st(0)
 AddWord($DE,$CA);
 CheckStack(-1);
end;

procedure TForevalH.FMULP4;
begin     //fmulp st(4),st(0)
 AddWord($DE,$CC);
 CheckStack(-1);
end;


procedure TForevalH.FMULP20;
begin     //fmulp st(2),st(0)
 AddWord($DE,$CA);
 CheckStack(-1);
end;



procedure TForevalH.FMUL20;
begin     //fmul st(2),st(0)
 AddWord($DC,$CA);
end;

procedure TForevalH.FMUL30;
begin     //fmul st(3),st(0)
 AddWord($DC,$CB);
end;


procedure TForevalH.FADDP3;
begin
 AddWord($DE,$C3);
 CheckStack(-1);
end;


procedure TForevalH.FDIV2;
begin     //fdiv st(2),st(0)
 AddWord($DC,$FA);
end;

procedure TForevalH.FDIVR2;
begin                    //fdivr st,st(2)
AddWord($D8,$FA);
end;

procedure TForevalH.FSUBP01;
begin                    //fsubp st(1),st(0)
AddWord($DE,$E9);
CheckStack(-1);
end;


procedure TForevalH.FDIVP1;
begin     //fdivp st(0),st(1)
 AddWord($D8,$FA);
 CheckStack(-1);
end;

{procedure TForevalH.FDIVP2;
begin     //fdivp st(2),st(0)
 AddWord($DE,$FA);
 CheckStack(-1);
end;}


procedure TForevalH.FLD0;
begin
 AddWord($D9,$C0);
 CheckStack(1);
end;

procedure TForevalH.FLDZ;
begin
 AddWord($D9,$EE);
 CheckStack(1);
end;



procedure TForevalH.FXCH1;
begin
 AddWord($D9,$C9);
end;

procedure TForevalH.FXCH2;
begin
 AddWord($D9,$CA);
end;


procedure TForevalH.FXCH3;
begin
 AddWord($D9,$CB);
end;


procedure TForevalH.FXCH4;
begin
 AddWord($D9,$CC);
end;


procedure TForevalH.FCHS;
begin
AddWord($D9,$E0);
end;

procedure TForevalH.PUSHB;
begin
AddByte($53);
end;

procedure TForevalH.POPB;
begin
AddByte($5B);
end;



procedure TForevalH.PUSHM(N: Cardinal);
begin
//  
AddCom($68,N);
end;


procedure TForevalH.FLD(N: TAddress; VType: Integer);
begin
case VType of
//_Single:    AddCom($D9,$05,N);
_Double:    AddCom($DD,$05,N);
_Extended:  AddCom($DB,$2D,N);
_Integer:   AddCom($DB,$05,N);
_Pointer:   AddCom($DB,$05,N);
end;
CheckStack(1);
end;


procedure TForevalH.FSTPM(N: TAddress; VType: Integer);
begin
F_SData:=_MEM;
case VType of
//_Single:   AddCom($D9,$1D,N);
_Extended: AddCom($DB,$3D,N);
_Double:   AddCom($DD,$1D,N);
_Integer:  AddCom($DB,$1D,N);    //fistp
_Pointer:  AddCom($DB,$1D,N);    //fistp
end;
CheckStack(-1);
end;



procedure TForevalH.FSTM(N: TAddress; VType: Integer);
begin
 if VType = _Extended then
 begin
  FLD0;
  FSTPM(N,_Extended)
 end
 else
 if VType = _Double then
 begin
  AddCom($DD,$15,N);
 end
 {else
 if VType = _Single then
 begin
   AddCom($D9,$15,N);
 end; }
end;



procedure  TForevalH.FCOMPP;
begin
 AddWord($DE,$D9);
 CheckStack(-2);
end;

procedure  TForevalH.FCOMIP;
begin
 AddWord($DF,$F1);
 CheckStack(-1);
end;


procedure  TForevalH.FSTSW_AX;
begin
 AddWord($DF,$E0);
 SetReg(1);     {.213}
end;

procedure  TForevalH.SAHF;
begin
 AddByte($9E);
end;


procedure TForevalH.JMPC(N: TAddress; VType: Integer);
begin
case VType of
2:    AddCom($0F,$84,N);        //jz
3:    AddCom($0F,$83,N);        //jnb
4:    AddCom($0F,$86,N);        //jbe
5:    AddCom($0F,$82,N);        //jb
6:    AddCom($0F,$87,N);        //jnbe
7:    AddCom($0F,$85,N);        //jnz
end;
end;


procedure  TForevalH.ZMULP;
begin

   FLD0;
   FMUL03;
   FXCH1;
   FMUL04;
   FXCH4;
   FMUL02;
   FSUBP1;
   FXCH2;
   FMULP1;
   FADDP2;

end;




procedure  TForevalH.ZMUL;
begin
   FLD0;
   FMUL03;
   FXCH1;
   FMUL04;
   FXCH2;
   FLD0;
   FMUL05;
   FXCH1;
   FMUL04;
   FXCH2;
   FSUBRP;
   FXCH1;
   FADDP20;
end;


procedure  TForevalH.ZSQR;
begin
  

   FLD0;
   FMUL0;
   FXCH1;
   FMUL02;
   //FMUL(Cardinal(@S_c2),_Double);
   FMUL(WriteDataA(2,_Double),_Double);      {.217}
   FXCH2;
   FMUL0;
   FSUBP;


end;



procedure TForevalH.ZIPWR3;
begin

  FLD0;
  FMUL0;
  FMUL01;
  FXCH2;
  FLD0;
  FMUL0;
  FMUL01;
  FXCH1;
  FLD0;
  FMUL03;
  //FMUL(Cardinal(@S_c3),_Double);
  FMUL(WriteDataA(3,_Double),_Double);      {.217}
  FXCH1;
  FMUL01;
  FSUBP40;
  FMULP20;
  FSUBP;
  FXCH1;

end;



procedure  TForevalH.ZPUSH;
begin
  FLD0;
  FXCH2;
  FLD0;
  FXCH3;
end;


procedure TForevalH.AddCom(B1,B2: Byte; Adr: TAddress);
var
P: ^Cardinal;
begin
if F_Mode=M_Compile then
begin
 SetLength(ICOMP,Length(ICOMP)+6);
 ICOMP[High(ICOMP)-5]:=B1; ICOMP[High(ICOMP)-4]:=B2;
 P:=@ICOMP[High(ICOMP)-3];
 P^:=Adr;
end;
end;


procedure TForevalH.AddCom(B1: Byte; Adr: TAddress);
var
P: ^Cardinal;
begin
if F_Mode=M_Compile then
begin
 SetLength(ICOMP,Length(ICOMP)+5);
 ICOMP[High(ICOMP)-4]:=B1;
 P:=@ICOMP[High(ICOMP)-3];
 P^:=Adr;
end;
end;


procedure TForevalH.AddCom(B1,B2: Byte);
begin
if F_Mode=M_Compile then
begin
 SetLength(ICOMP,Length(ICOMP)+2);
 ICOMP[High(ICOMP)-1]:=B1; ICOMP[High(ICOMP)]:=B2;
end;
end;



(*
function  TForevalH.WriteData(NF: Integer): TAddress;
var
Pm: Pointer;
begin
if F_Opt = False then
begin
  {Pm:=Pointer(@Interp[NF].FD);

  case  F_DataType of
  _Integer:   Integer(Pm^):=Trunc(Interp[NF].FD);
  //_Single:    Single(Pm^):=Interp[NF]^.FD;
  _Double:    Double(Pm^):=Interp[NF].FD;
  _Extended:  Extended(Pm^):=Interp[NF].FD;
  end;

  WriteData:=TAddress(Pm); }

end;
end;
*)


function  TForevalH.WriteData(NF: Integer): TAddress;
var
FD1: PFuncData;
Pm: Pointer;
Data: extended;
begin


if {F_Opt = False}F_Mode=M_Compile then
begin


  Data:=Interp[NF].FD;

  new(FD1); FD1^.Next:=nil;
  FuncData^.Next:=FD1;
  FuncData:=FD1;
  Pm:=Pointer(@FD1^.FData);


  case  F_DataType of
  _Integer:   Integer(Pm^):=Trunc(Data);
  //_Single:    Single(Pm^):=Data;
  _Double:    Double(Pm^):=Data;
  _Extended:  Extended(Pm^):=Data;
  end;

  WriteData:=TAddress(Pm);

 end
else
WriteData:=TAddress(nil);

end;




function  TForevalH.WriteDataA(Data: extended; DataType: Integer): TAddress;
var
FD1: PFuncData;
Pm: Pointer;
begin


if {F_Opt = False}F_Mode=M_Compile then
begin


  new(FD1); FD1^.Next:=nil;
  FuncData^.Next:=FD1;
  FuncData:=FD1;
  Pm:=Pointer(@FD1^.FData);


  case  DataType of
  _Integer:   Integer(Pm^):=Trunc(Data);
  //_Single:    Single(Pm^):=Data;
  _Double:    Double(Pm^):=Data;
  _Extended:  Extended(Pm^):=Data;
  end;

  WriteDataA:=TAddress(Pm);

 end
else
WriteDataA:=TAddress(nil);

end;



procedure TForevalH.FreeData;
var
FD1,FD2: PFuncData;
begin

FD1:=BFuncData;
while FD1 <> nil do
begin
 FD2:=FD1^.Next;
 dispose(FD1);
 FD1:=FD2;
end;

end;




procedure TForevalH.IntToHex(N: TAddress; var AH: TArray4);
var
i,K,j: Integer;
N1: Cardinal;
A8: array [1..8] of Integer;
begin
N1:=N;  j:=1;
for i:=7 downto 1 do
begin
 K:=Trunc(N1/IntPower(2,i*4));
 A8[j]:=(K);
 N1:=N1-Trunc(IntPower(2,i*4))*K;
 inc(j);
end;
A8[j]:=N1;


//  :
j:=1;
for i:=4 downto 1 do
begin
 AH[i]:=A8[j]*16+A8[j+1];
 j:=j+2;
end;
end;


procedure TForevalH.IntToHexNum(N: Integer; var AH: TArray4);
var
i,K,N1,j: Cardinal;
A8: array [1..8] of Integer;
begin
N1:=N;  j:=1;
//if N1 < 0 then N1:=4294967296+N1;

for i:=7 downto 1 do
begin
 K:=Trunc(abs(N1/IntPower(2,i*4)));
 A8[j]:=(K);
 N1:=N1-Trunc(IntPower(2,i*4))*K;
 inc(j);
end;
A8[j]:=N1;


//  :
j:=1;
for i:=4 downto 1 do
begin
 AH[i]:=A8[j]*16+A8[j+1];
 j:=j+2;
end;
end;




procedure TForevalH.SaveReg;
var
PP: array [0..7] of byte;
i,L,j,k: integer;
begin
L:=-1;

for i:=1 to 8 do
begin
 PP[i-1]:=0;
if (REG[i] <> 0) or (REGA[i] <> 0) or ((REGF[i] <> 0) and (F_ExtFunc = True)) then   {.193}
 begin
 inc(L); PP[L]:=i;
 end;
end;

if L > -1 then
begin
 j:=High(ICOMP);
 SetLength(ICOMP,Length(ICOMP)+2*(L+1));

 for i:=j downto 0 do
 begin
 ICOMP[i+(L+1)]:=ICOMP[i];
 end;

 for i:=0 to (L{+1}) do
 begin
  if PP[i] = 1 then ICOMP[i]:=$50 else
  if PP[i] = 2 then ICOMP[i]:=$53 else
  if PP[i] = 3 then ICOMP[i]:=$51 else
  if PP[i] = 4 then ICOMP[i]:=$52 else
  if PP[i] = 5 then ICOMP[i]:=$54 else
  if PP[i] = 6 then ICOMP[i]:=$55 else
  if PP[i] = 7 then ICOMP[i]:=$56 else
  if PP[i] = 8 then ICOMP[i]:=$57;
 end;

 k:=0;
 for i:=(L{+1}) downto 0 do
 begin
  if PP[i] = 1 then
   begin ICOMP[j+(L+1)+k+1]:=$58; inc(k); end else
  if PP[i] = 2 then
   begin ICOMP[j+(L+1)+k+1]:=$5B; inc(k); end else
  if PP[i] = 3 then
   begin ICOMP[j+(L+1)+k+1]:=$59; inc(k); end else
  if PP[i] = 4 then
   begin ICOMP[j+(L+1)+k+1]:=$5A; inc(k); end else
  if PP[i] = 5 then
   begin ICOMP[j+(L+1)+k+1]:=$5C; inc(k); end else
  if PP[i] = 6 then
   begin ICOMP[j+(L+1)+k+1]:=$5D; inc(k); end else
  if PP[i] = 7 then
   begin ICOMP[j+(L+1)+k+1]:=$5E; inc(k); end else
  if PP[i] = 8 then
   begin ICOMP[j+(L+1)+k+1]:=$5F; inc(k); end;


 end;

end;

//RET;
end;



procedure TForevalH.SaveRegF;
var
N,NF,SR,b: Cardinal;
  I: Integer;
begin

 N:=Interp[NFunc].NFunc;
 NF:=Interp[NFunc].NF;
 SR:=Alg.ExFunc[N].Func[NF].SaveReg;
 //n:=0; k:=147;    //10010011
 for i := 0 to 7 do
 begin
   b:=(SR and (1 shl i));
   if b <> 0 then REGF[i+1]:=1;
 end;
 {b:= SR and (1 shl 0);
 b:= SR and (1 shl 1);
 b:= SR and (1 shl 2);
 b:= SR and (1 shl 3);
 b:= SR and (1 shl 4);
 b:= SR and (1 shl 5);
 b:= SR and (1 shl 6);
 b:= SR and (1 shl 7); }
end;


procedure TForevalH.SetReg(R: Integer);
begin
//1 - EAX; 2 - EBX; 3 - ECX; 4 - EDX;
REG[R]:=1;
end;


procedure TForevalH.SetRegA(R: Integer; SC: Integer);
begin //  -   
//1 - EAX; 2 - EBX; 3 - ECX; 4 - EDX; 5 - ESP; 6 - EBP; 7 - ESI; 8 - EDI;
REGA[R]:=SC;
end;



procedure TForevalH.AddByte(B: Byte);
var
j: Integer;
begin
if F_Mode=M_Compile then
begin
 j:=High(ICOMP)+1;
 SetLength(ICOMP,Length(ICOMP)+1);
 ICOMP[j]:=B;
end;
end;



procedure TForevalH.AddWord(B1: Byte; B2: Byte);
var
j: Integer;
begin
if F_Mode=M_Compile then
begin
 j:=High(ICOMP)+1;
 SetLength(ICOMP,Length(ICOMP)+2);
 ICOMP[j]:=B1; ICOMP[j+1]:=B2;
end;
end;


{
procedure TForevalH.AddAddress(Adr: TAddress);
var
AB: TArray4;
j: Integer;
begin
IntToHex(Adr,AB);
j:=High(ICOMP)+1;
SetLength(ICOMP,Length(ICOMP)+4);
ICOMP[j]:=AB[1];  ICOMP[j+1]:=AB[2]; ICOMP[j+2]:=AB[3]; ICOMP[j+3]:=AB[4];
end;
}
procedure TForevalH.AddAddress(Adr: TAddress);
var
//AB: TArray4;
j: Cardinal;
P: ^Cardinal;
begin
if F_Mode = M_Compile then     {???}
begin
 j:=High(ICOMP)+1;
 SetLength(ICOMP,Length(ICOMP)+4);
 P:=@ICOMP[j];
 P^:=Adr;
end;
end;


{
procedure TForevalH.AddNum(Num: Integer);
var
AB: TArray4;
j: Integer;
begin
IntToHexNum(Num,AB);
j:=High(ICOMP)+1;
SetLength(ICOMP,Length(ICOMP)+4);
ICOMP[j]:=AB[1];  ICOMP[j+1]:=AB[2]; ICOMP[j+2]:=AB[3]; ICOMP[j+3]:=AB[4];
end;
}

procedure TForevalH.AddNum(Num: Integer);
var
//AB: TArray4;
j: Cardinal;
P: ^Integer;//Pointer;
begin
if F_Mode = M_Compile then     {???}
begin
 j:=High(ICOMP)+1;
 SetLength(ICOMP,Length(ICOMP)+4);
 P:=@ICOMP[j];
 P^:=Num;
end;
end;


procedure TForevalH.CALLA;
begin
AddWord($FF,$D0);
SetReg(1);
end;



procedure TForevalH.CALLC;
begin
AddWord($FF,$D1);
SetReg(3);
end;


procedure TForevalH.MOVAM(N: TAddress);
begin
//EAX->MEM
AddWord($89,$05);
AddAddress(N);
SetReg(1);
end;


procedure TForevalH.MOVMA(N: TAddress);
begin
//MEM->EAX
AddWord($8B,$05);
AddAddress(N);
SetReg(1);
end;


procedure TForevalH.MOVMB(N: TAddress);
begin
//MEM->EBX
AddWord($8B,$1D);
AddAddress(N);
SetReg(2);
end;




procedure TForevalH.MOVMC(N: TAddress);
begin
//MEM->ECX
AddWord($8B,$0D);
AddAddress(N);
SetReg(3);
end;



procedure TForevalH.MOVAnum(N: Integer{TAddress});
begin
//N - 
AddByte($B8);
AddNum(N);
SetReg(1);
end;


procedure TForevalH.MOVBnum(N: Integer{TAddress});
begin
AddByte($BB);
AddNum(N);
SetReg(2);
end;



procedure TForevalH.MOVCnum(N: Integer{TAddress});
begin
AddByte($B9);
AddNum(N);
SetReg(3);
end;


procedure TForevalH.MOVAadr(N: TAddress);
begin
AddByte($B8);
AddAddress(N);
SetReg(1);
end;


procedure TForevalH.MOVBadr(N: TAddress);
begin
AddByte($BB);
AddAddress(N);
SetReg(2);
end;



procedure TForevalH.MOVCadr(N: TAddress);
begin
AddByte($B9);
AddAddress(N);
SetReg(3);
end;


procedure TForevalH.CALLB;
begin
AddWord($FF,$D3);
SetReg(2);
end;


procedure TForevalH.FLD(N: TAddress);
begin
AddWord($DD,$05);
AddAddress(N);
CheckStack(1);
end;



procedure TForevalH.FSTP(N: TAddress);
begin
AddWord($DD,$1D);
AddAddress(N);
CheckStack(-1);
end;


procedure TForevalH.PUSHAD;
begin
AddByte($60);
end;


procedure TForevalH.POPAD;
begin
AddByte($61);
end;

procedure TForevalH.ADDESP(N: Integer);
begin
if N <> 0 then
AddCom($81,$C4,N);
end;


procedure TForevalH.FISTP(N: TAddress);
begin
AddWord($DB,$1D);
AddAddress(N);
CheckStack(-1);
end;


procedure TForevalH.FLDCW(N: TAddress);
begin

//FNFLEX
AddWord($DB,$E2);
//FLDCW
AddWord($D9,$2D);
AddAddress(N);
end;


procedure TForevalH.PUSHCW;
begin
//sub esp,4
AddWord($83,$EC);    AddByte($04);
//fnstcw [esp];
AddWord($D9,$3C);   AddByte($24);
end;



procedure TForevalH.POPCW;
begin
//fldcw [esp];
AddWord($D9,$2C);   AddByte($24);
//add esp, 4
AddWord($83,$C4);    AddByte($04);
end;


procedure  TForevalH.FRNDINT;
begin
AddWord($D9,$FC);
end;


procedure TForevalH.FEXP;
begin
  MOVAadr(Cardinal(@R_EXP));
  CALLA;
  CheckStack(2);
  CheckStack(-2);
end;

procedure TForevalH.ZEXP;
begin
  MOVAadr(Cardinal(@Z_EXP));
  CALLA;
  CheckStack(2);
  CheckStack(-2);
end;

procedure TForevalH.FSIN;
begin
 AddWord($D9,$FE);
end;



procedure TForevalH.FPTAN;
begin
 AddWord($D9,$F2);
 CheckStack(1);
end;



procedure TForevalH.FCOS;
begin
 AddWord($D9,$FF);
end;



procedure TForevalH.FSINCOS;
begin
 AddWord($D9,$FB);
 CheckStack(1);
end;



procedure TForevalH.FPATAN;
begin
 AddWord($D9,$F3);
 CheckStack(-1);
end;



procedure TForevalH.FSTP0;
begin
 AddWord($DD,$D8);
 CheckStack(-1);
end;


procedure TForevalH.FSTP1;
begin
  AddWord($DD,$D9);    //fstp  st(1)
 CheckStack(-1);
end;


procedure TForevalH.FLD1;
begin
 AddWord($D9,$E8);
 CheckStack(1);
end;


procedure TForevalH.FDIVR_C1;
begin   // 1/st(0)
 FLD1;
 FDIVRP;
end;

procedure TForevalH.ZDIVR_C1;
begin   // 1/Z
if F_FAST_DIV = True then
begin
  FLD1;
  FXCH2;
  FLD0;
  FMUL0;
  FXCH1;
  FMUL03;
  FCHS;
  FXCH3;
  FMUL02;
  FXCH2;
  FMUL0;
  FADDP;
  FLD1;
  FDIVRP;
  FMUL10;
  FMULP20;
end
else
begin
  FLD1;
  FXCH2;
  FLD0;
  FMUL0;
  FXCH1;
  FCHS;
  FXCH3;
  FMUL02;
  FXCH2;
  FMUL0;
  FADDP;
  FDIV10;
  FDIVP2;
  {
  fxch st(2)
  fld  st
  fmul st,st
  fxch
  fmul st,st(3)
  fchs
  fxch st(3)
  fmul st,st(2)
  fxch st(2)
  fmul st,st
  faddp

  fdiv  st(1),st
  fdivp st(2),st
  }
end;
end;


procedure TForevalH.ZMUL_i;
begin   // i*Z
 FXCH1;
 FCHS;
end;

procedure TForevalH.ZDIV_i;
begin   // z/i
 FCHS;
 FXCH1;
end;

procedure TForevalH.ZDIVR_i;
begin   // i/z
if F_FAST_DIV = True then
begin
 FLD0;
 FMUL0;
 FXCH2;
 FLD0;
 FMUL0;
 FADDP3;
 FLD1;
 FDIVRP3;
 FMUL02;
 FXCH1;
 FMULP20;
end
else
begin
 FLD0;
 FMUL0;
 FXCH2;
 FLD0;
 FMUL0;
 FADDP3;
 FDIV02;
 FXCH1;
 FDIVRP2;
end;

end;


procedure TForevalH.FMUL_C05;
begin
 //FMUL(TAddress(@S_C05),_Double);
 FMUL(WriteDataA(0.5,_Double),_Double); //{.217}
end;



procedure TForevalH.FDIV_C3;
begin
 FDIV(WriteDataA(3.0,_Double),_Double); //{.217}
end;




procedure TForevalH.FLDLN2;
begin
AddWord($D9,$ED);
CheckStack(1);
end;


procedure TForevalH.FYL2X;
begin
AddWord($D9,$F1);
CheckStack(-1);
end;


procedure TForevalH.FLDLG2;
begin
AddWord($D9,$EC);
CheckStack(1);
end;




procedure TForevalH.FABS;
begin
AddWord($D9,$E1);
end;



procedure TForevalH.PUSHF(N: TAddress);
begin
//   : dword ptr [N]
AddWord($FF,$35);
AddAddress(N);
end;


procedure TForevalH.POPF(N: TAddress);
begin
//   : dword ptr [N]
AddWord($8F,$05);
AddAddress(N);
end;


procedure TForevalH.FILD(N: TAddress);
begin
AddWord($DB,$05);
AddAddress(N);
CheckStack(1);
end;



procedure TForevalH.FTRUNC;
begin
PUSHCW;    {.227}
FLDCW(TAddress(@FCW1));
FRNDINT;
POPCW;    {.227}//FLDCW(TAddress(@FCW2));
end;

procedure TForevalH.TRUNCM(N: TAddress);
begin
PUSHCW;    {.227}
FLDCW(TAddress(@FCW1));
FISTP(N);
POPCW;    {.227}//FLDCW(TAddress(@FCW2));
end;


procedure TForevalH.MOVDM(N: TAddress);
begin
//EDX->MEM
AddWord($89,$15);
AddAddress(N);
SetReg(4);
end;

procedure TForevalH.IDIVM(N: TAddress);
begin
 AddCom($F7,$3D,N);
 SetReg(1);
 SetReg(4);
end;


procedure TForevalH.InitConstDb;
begin
 Db_XchBrSDeep:=0;
 Db_XchBrNXch:=0;
 Db_DinLoadSDeep:=0;
 Db_DinLoadNMem:=0;
 Db_DinLoadOverFlow:=False;
 Db_CmplMaxStack:=0;
 Db_ReplFuncNum:=0;
 Db_ReplOpNum:=0;
 Db_LoadStackAfterCalc:=0;
end;


procedure TForevalH.DebugDL;
begin
{
sin(z1)/cos(x)
sin(x)/cos(z1)
sin(z1)/cos(z2)

sin(z1)*cos(x)
sin(x)*cos(z1)
sin(z1)*cos(z2)

sin(z1)+cos(x)
sin(x)+cos(z1)
sin(z1)+cos(z2)

sin(z1)-cos(x)
sin(x)-cos(z1)
sin(z1)-cos(z2)

sin(z1)^cos(x)
sin(x)^cos(z1)
sin(z1)^cos(z2)
}

{                     //sin() -> fpu; cos() -> mem
Interp[4].SData:=_MEM;
SetLength(Interp[5].RData,2);  Interp[5].RData[0]:=_FPU; Interp[5].RData[1]:=_MEM;
}

{                      //sin()->mem; cos()->fpu
Interp[2].SData:=_MEM;
SetLength(Interp[5].RData,2);  Interp[5].RData[0]:=_MEM; Interp[5].RData[1]:=_FPU;
}

                     //sin()->mem; cos()->mem
{
Interp[2].SData:=_MEM;   Interp[4].SData:=_MEM;
SetLength(Interp[5].RData,2);  Interp[5].RData[0]:=_MEM; Interp[5].RData[1]:=_MEM;
}

//*******************************************************************************

{
sin(z1)/z2
sin(z1)*z2
sin(z1)+z2
sin(z1)-z2
z2+sin(z1)
z2-sin(z1)
z2*sin(z1)
z2/sin(z1)
}
{
sin(z1)/x
sin(z1)*x
sin(z1)+x
sin(z1)-x
x+sin(z1)
x-sin(z1)
x*sin(z1)
x/sin(z1)
}
{
sin(z1)/k
sin(z1)*k
sin(z1)+k
sin(z1)-k
k+sin(z1)
k-sin(z1)
k*sin(z1)
k/sin(z1)
}
{

sin(x)/y
sin(x)*y
sin(x)+y
sin(x)-y
y+sin(x)
y-sin(x)
y*sin(x)
y/sin(x)
}
{
sin(x)/x
sin(x)*x
sin(x)+x
sin(x)-x
x+sin(x)
x-sin(x)
x*sin(x)
x/sin(x)
}
{
sin(x)/k
sin(x)*k
sin(x)+k
sin(x)-k
k+sin(x)
k-sin(x)
k*sin(x)
k/sin(x)
}

                     //sin()->mem;
{
Interp[2].SData:=_MEM;
SetLength(Interp[3].RData,1);  Interp[3].RData[0]:=_MEM; //Interp[3].RData[1]:=_MEM;
}
//*******************************************************************************




end;



end.
